/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/



































#include "../P2VectorElementwiseEpsilonRotationP1ViscosityAnnulusMap.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2VectorElementwiseEpsilonRotationP1ViscosityAnnulusMap::apply_P2VectorElementwiseEpsilonRotationP1ViscosityAnnulusMap_macro_2D( real_t * RESTRICT  _data_dst_edge_0, real_t * RESTRICT  _data_dst_edge_1, real_t * RESTRICT  _data_dst_vertex_0, real_t * RESTRICT  _data_dst_vertex_1, real_t * RESTRICT  _data_mu, real_t * RESTRICT  _data_nx_rotationEdge, real_t * RESTRICT  _data_nx_rotationVertex, real_t * RESTRICT  _data_ny_rotationEdge, real_t * RESTRICT  _data_ny_rotationVertex, real_t * RESTRICT  _data_src_edge_0, real_t * RESTRICT  _data_src_edge_1, real_t * RESTRICT  _data_src_vertex_0, real_t * RESTRICT  _data_src_vertex_1, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float, real_t radRayVertex, real_t radRefVertex, real_t rayVertex_0, real_t rayVertex_1, real_t refVertex_0, real_t refVertex_1, real_t thrVertex_0, real_t thrVertex_1 ) const
{
    {
       const real_t _data_q_w [] = {0.16666666666666666, 0.16666666666666666, 0.16666666666666666};
   
       const real_t _data_q_p_0 [] = {0.16666666666666666, 0.66666666666666663, 0.16666666666666666};
   
       const real_t _data_q_p_1 [] = {0.66666666666666663, 0.16666666666666666, 0.16666666666666666};
   
       const real_t tmp_coords_jac_0_GRAY = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_GRAY = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_GRAY = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_1_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_2_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t jac_affine_0_0_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_1_0_GRAY;
       const real_t jac_affine_0_1_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_2_0_GRAY;
       const real_t jac_affine_1_0_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_1_1_GRAY;
       const real_t jac_affine_1_1_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_2_1_GRAY;
       const real_t tmp_coords_jac_1_GRAY = jac_affine_0_0_GRAY*jac_affine_1_1_GRAY - jac_affine_0_1_GRAY*jac_affine_1_0_GRAY;
       const real_t tmp_coords_jac_2_GRAY = 1.0 / (tmp_coords_jac_1_GRAY);
       const real_t jac_affine_inv_0_0_GRAY = jac_affine_1_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_0_1_GRAY = -jac_affine_0_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_0_GRAY = -jac_affine_1_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_1_GRAY = jac_affine_0_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t abs_det_jac_affine_GRAY = abs(tmp_coords_jac_1_GRAY);
       const real_t tmp_qloop_1 = -rayVertex_1 + thrVertex_1;
       const real_t tmp_qloop_7 = rayVertex_0 - thrVertex_0;
       const real_t tmp_qloop_8 = -tmp_qloop_7;
       const real_t tmp_qloop_9 = 1.0 / (tmp_qloop_1*(-rayVertex_0 + refVertex_0) - tmp_qloop_8*(-rayVertex_1 + refVertex_1));
       const real_t tmp_qloop_10 = -radRayVertex + radRefVertex;
       const real_t tmp_qloop_11 = tmp_qloop_10*tmp_qloop_9;
       const real_t tmp_qloop_12 = tmp_qloop_11*1.0;
       {
          /* FaceType.GRAY */
          const real_t _data_phi_0_0_GRAY [] = {0.16666666666666674, 0.16666666666666666, 0.66666666666666663, 0.16666666666666671, 0.66666666666666663, 0.16666666666666666, 0.66666666666666674, 0.16666666666666666, 0.16666666666666666};
      
          const real_t _data_tabulated_and_untitled_0_0_GRAY [] = {((real_t)(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)), ((real_t)(abs_det_jac_affine_GRAY)), ((real_t)(jac_affine_inv_0_0_GRAY*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GRAY*1.6666666666666665)), ((real_t)(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)), ((real_t)(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)), ((real_t)(abs_det_jac_affine_GRAY)), ((real_t)(jac_affine_inv_0_0_GRAY*1.6666666666666665)), ((real_t)(jac_affine_inv_1_0_GRAY*-0.33333333333333337)), ((real_t)(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)), ((real_t)(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)), ((real_t)(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)), 0.0, ((real_t)(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)), ((real_t)(abs_det_jac_affine_GRAY)), ((real_t)(jac_affine_inv_0_0_GRAY*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GRAY*-0.33333333333333337)), ((real_t)(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)), ((real_t)(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_0_1_GRAY [] = {0.0, ((real_t)(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_GRAY*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GRAY*1.6666666666666665)), ((real_t)(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)), ((real_t)(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_GRAY*1.6666666666666665)), ((real_t)(jac_affine_inv_1_0_GRAY*-0.33333333333333337)), ((real_t)(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)), ((real_t)(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)), ((real_t)(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)), 0.0, ((real_t)(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)), ((real_t)(jac_affine_inv_0_0_GRAY*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GRAY*-0.33333333333333337)), ((real_t)(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)), ((real_t)(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_0_GRAY [] = {((real_t)(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GRAY*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GRAY*1.6666666666666665)), ((real_t)(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)), ((real_t)(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GRAY*1.6666666666666665)), ((real_t)(jac_affine_inv_1_1_GRAY*-0.33333333333333337)), ((real_t)(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)), ((real_t)(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)), ((real_t)(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)), 0.0, ((real_t)(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)), ((real_t)(jac_affine_inv_0_1_GRAY*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GRAY*-0.33333333333333337)), ((real_t)(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_GRAY [] = {0.0, ((real_t)(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GRAY*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GRAY*1.6666666666666665)), ((real_t)(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)), ((real_t)(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GRAY*1.6666666666666665)), ((real_t)(jac_affine_inv_1_1_GRAY*-0.33333333333333337)), ((real_t)(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)), ((real_t)(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)), ((real_t)(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)), 0.0, ((real_t)(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)), ((real_t)(jac_affine_inv_0_1_GRAY*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GRAY*-0.33333333333333337)), ((real_t)(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663))};
      
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1));
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1));
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1));
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1));
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1));
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1));
             const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t src_dof_3 = _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t src_dof_6 = _data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t src_dof_7 = _data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t src_dof_8 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t src_dof_9 = _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t src_dof_10 = _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t src_dof_11 = _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t mu_dof_1 = _data_mu[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t mu_dof_2 = _data_mu[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t nx_rotation_dof_0 = _data_nx_rotationVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t nx_rotation_dof_1 = _data_nx_rotationVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t nx_rotation_dof_2 = _data_nx_rotationVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t nx_rotation_dof_3 = _data_nx_rotationEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t nx_rotation_dof_4 = _data_nx_rotationEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t nx_rotation_dof_5 = _data_nx_rotationEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t ny_rotation_dof_0 = _data_ny_rotationVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             const real_t ny_rotation_dof_1 = _data_ny_rotationVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t ny_rotation_dof_2 = _data_ny_rotationVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t ny_rotation_dof_3 = _data_ny_rotationEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t ny_rotation_dof_4 = _data_ny_rotationEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t ny_rotation_dof_5 = _data_ny_rotationEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_4_10 = 0.0;
             real_t q_acc_4_11 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_5_10 = 0.0;
             real_t q_acc_5_11 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_6_10 = 0.0;
             real_t q_acc_6_11 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_7_10 = 0.0;
             real_t q_acc_7_11 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_8_10 = 0.0;
             real_t q_acc_8_11 = 0.0;
             real_t q_acc_9_9 = 0.0;
             real_t q_acc_9_10 = 0.0;
             real_t q_acc_9_11 = 0.0;
             real_t q_acc_10_10 = 0.0;
             real_t q_acc_10_11 = 0.0;
             real_t q_acc_11_11 = 0.0;
             const bool tmp_qloop_37 = pow((nx_rotation_dof_0*nx_rotation_dof_0) + (ny_rotation_dof_0*ny_rotation_dof_0), 0.50000000000000000) > 0.5;
             const real_t tmp_qloop_38 = ((tmp_qloop_37) ? (nx_rotation_dof_0): (0.0));
             const real_t tmp_qloop_72 = ((tmp_qloop_37) ? (-ny_rotation_dof_0): (1.0));
             const bool tmp_qloop_80 = pow((nx_rotation_dof_1*nx_rotation_dof_1) + (ny_rotation_dof_1*ny_rotation_dof_1), 0.50000000000000000) > 0.5;
             const real_t tmp_qloop_81 = ((tmp_qloop_80) ? (nx_rotation_dof_1): (0.0));
             const real_t tmp_qloop_92 = ((tmp_qloop_80) ? (-ny_rotation_dof_1): (1.0));
             const bool tmp_qloop_102 = pow((nx_rotation_dof_2*nx_rotation_dof_2) + (ny_rotation_dof_2*ny_rotation_dof_2), 0.50000000000000000) > 0.5;
             const real_t tmp_qloop_103 = ((tmp_qloop_102) ? (nx_rotation_dof_2): (0.0));
             const real_t tmp_qloop_112 = ((tmp_qloop_102) ? (-ny_rotation_dof_2): (1.0));
             const bool tmp_qloop_121 = pow((nx_rotation_dof_3*nx_rotation_dof_3) + (ny_rotation_dof_3*ny_rotation_dof_3), 0.50000000000000000) > 0.5;
             const real_t tmp_qloop_122 = ((tmp_qloop_121) ? (nx_rotation_dof_3): (0.0));
             const real_t tmp_qloop_131 = ((tmp_qloop_121) ? (-ny_rotation_dof_3): (1.0));
             const bool tmp_qloop_140 = pow((nx_rotation_dof_4*nx_rotation_dof_4) + (ny_rotation_dof_4*ny_rotation_dof_4), 0.50000000000000000) > 0.5;
             const real_t tmp_qloop_141 = ((tmp_qloop_140) ? (nx_rotation_dof_4): (0.0));
             const real_t tmp_qloop_150 = ((tmp_qloop_140) ? (-ny_rotation_dof_4): (1.0));
             const bool tmp_qloop_159 = pow((nx_rotation_dof_5*nx_rotation_dof_5) + (ny_rotation_dof_5*ny_rotation_dof_5), 0.50000000000000000) > 0.5;
             const real_t tmp_qloop_160 = ((tmp_qloop_159) ? (nx_rotation_dof_5): (0.0));
             const real_t tmp_qloop_169 = ((tmp_qloop_159) ? (-ny_rotation_dof_5): (1.0));
             const real_t tmp_qloop_178 = ((tmp_qloop_37) ? (ny_rotation_dof_0): (1.0));
             const real_t tmp_qloop_179 = ((tmp_qloop_80) ? (ny_rotation_dof_1): (1.0));
             const real_t tmp_qloop_180 = ((tmp_qloop_102) ? (ny_rotation_dof_2): (1.0));
             const real_t tmp_qloop_181 = ((tmp_qloop_121) ? (ny_rotation_dof_3): (1.0));
             const real_t tmp_qloop_182 = ((tmp_qloop_140) ? (ny_rotation_dof_4): (1.0));
             const real_t tmp_qloop_183 = ((tmp_qloop_159) ? (ny_rotation_dof_5): (1.0));
             for (int64_t q = 0; q < 3; q += 1)
             {
                const real_t tmp_qloop_0 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q];
                const real_t tmp_qloop_2 = (tmp_qloop_0*tmp_qloop_0);
                const real_t tmp_qloop_3 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q];
                const real_t tmp_qloop_4 = (tmp_qloop_3*tmp_qloop_3);
                const real_t tmp_qloop_5 = tmp_qloop_2 + tmp_qloop_4;
                const real_t tmp_qloop_6 = pow(tmp_qloop_5, -0.50000000000000000);
                const real_t tmp_qloop_13 = tmp_qloop_12*tmp_qloop_6;
                const real_t tmp_qloop_14 = tmp_qloop_1*tmp_qloop_13;
                const real_t tmp_qloop_15 = pow(tmp_qloop_5, -1.5000000000000000);
                const real_t tmp_qloop_16 = radRayVertex + tmp_qloop_11*(tmp_qloop_1*(-rayVertex_0 + tmp_qloop_0) - tmp_qloop_8*(-rayVertex_1 + tmp_qloop_3));
                const real_t tmp_qloop_17 = tmp_qloop_15*tmp_qloop_16;
                const real_t tmp_qloop_18 = tmp_qloop_17*1.0;
                const real_t tmp_qloop_19 = tmp_qloop_13*tmp_qloop_8;
                const real_t tmp_qloop_20 = tmp_qloop_0*tmp_qloop_18;
                const real_t tmp_qloop_23 = tmp_qloop_12*tmp_qloop_15;
                const real_t tmp_qloop_24 = tmp_qloop_1*tmp_qloop_23;
                const real_t tmp_qloop_25 = tmp_qloop_2*tmp_qloop_24;
                const real_t tmp_qloop_26 = tmp_qloop_16*pow(tmp_qloop_5, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_27 = tmp_qloop_0*tmp_qloop_26*tmp_qloop_4;
                const real_t tmp_qloop_28 = tmp_qloop_24*tmp_qloop_4 - tmp_qloop_27;
                const real_t tmp_qloop_29 = tmp_qloop_23*tmp_qloop_7;
                const real_t tmp_qloop_30 = tmp_qloop_0*tmp_qloop_3;
                const real_t tmp_qloop_31 = tmp_qloop_24*tmp_qloop_30;
                const real_t tmp_qloop_32 = tmp_qloop_17*2.0;
                const real_t tmp_qloop_33 = tmp_qloop_2*tmp_qloop_26*tmp_qloop_3;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_3 - tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_29*tmp_qloop_30;
                const real_t tmp_qloop_36 = tmp_qloop_23*tmp_qloop_30*tmp_qloop_8;
                const real_t tmp_qloop_42 = mu_dof_0*2.0*_data_phi_0_0_GRAY[3*q] + mu_dof_1*2.0*_data_phi_0_0_GRAY[3*q + 1] + mu_dof_2*2.0*_data_phi_0_0_GRAY[3*q + 2];
                const real_t tmp_qloop_52 = tmp_qloop_42*0.5;
                const real_t tmp_qloop_69 = tmp_qloop_42*2.0;
                const real_t jac_blending_0_0 = tmp_qloop_0*tmp_qloop_14 + tmp_qloop_18*tmp_qloop_4;
                const real_t jac_blending_0_1 = tmp_qloop_0*tmp_qloop_15*tmp_qloop_16*tmp_qloop_3*-1.0 - tmp_qloop_0*tmp_qloop_19;
                const real_t jac_blending_1_0 = tmp_qloop_14*tmp_qloop_3 - tmp_qloop_20*tmp_qloop_3;
                const real_t jac_blending_1_1 = tmp_qloop_15*tmp_qloop_16*tmp_qloop_2*1.0 - tmp_qloop_19*tmp_qloop_3;
                const real_t tmp_qloop_21 = jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0;
                const real_t tmp_qloop_22 = 1.0 / (tmp_qloop_21);
                const real_t abs_det_jac_blending = tmp_qloop_21;
                const real_t tmp_qloop_54 = abs_det_jac_blending*_data_tabulated_and_untitled_0_0_GRAY[8*q + 1];
                const real_t tmp_qloop_55 = tmp_qloop_38*tmp_qloop_54;
                const real_t tmp_qloop_73 = tmp_qloop_54*tmp_qloop_72;
                const real_t tmp_qloop_185 = tmp_qloop_54*tmp_qloop_81;
                const real_t tmp_qloop_188 = tmp_qloop_54*tmp_qloop_92;
                const real_t tmp_qloop_221 = tmp_qloop_103*tmp_qloop_54;
                const real_t tmp_qloop_224 = tmp_qloop_112*tmp_qloop_54;
                const real_t tmp_qloop_251 = tmp_qloop_122*tmp_qloop_54;
                const real_t tmp_qloop_254 = tmp_qloop_131*tmp_qloop_54;
                const real_t tmp_qloop_275 = tmp_qloop_141*tmp_qloop_54;
                const real_t tmp_qloop_278 = tmp_qloop_150*tmp_qloop_54;
                const real_t tmp_qloop_291 = tmp_qloop_160*tmp_qloop_54;
                const real_t tmp_qloop_293 = tmp_qloop_169*tmp_qloop_54;
                const real_t tmp_qloop_298 = tmp_qloop_178*tmp_qloop_54;
                const real_t tmp_qloop_299 = tmp_qloop_179*tmp_qloop_54;
                const real_t tmp_qloop_300 = tmp_qloop_180*tmp_qloop_54;
                const real_t tmp_qloop_301 = tmp_qloop_181*tmp_qloop_54;
                const real_t tmp_qloop_302 = tmp_qloop_182*tmp_qloop_54;
                const real_t tmp_qloop_303 = tmp_qloop_183*tmp_qloop_54;
                const real_t jac_blending_inv_0_0 = jac_blending_1_1*tmp_qloop_22;
                const real_t tmp_qloop_39 = jac_blending_inv_0_0*1.0;
                const real_t tmp_qloop_47 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GRAY[7*q + 1];
                const real_t tmp_qloop_64 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GRAY[7*q];
                const real_t tmp_qloop_83 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GRAY[7*q + 2];
                const real_t tmp_qloop_105 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GRAY[7*q + 3];
                const real_t tmp_qloop_124 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GRAY[7*q + 4];
                const real_t tmp_qloop_143 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GRAY[7*q + 5];
                const real_t tmp_qloop_162 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GRAY[7*q + 6];
                const real_t jac_blending_inv_0_1 = -jac_blending_0_1*tmp_qloop_22;
                const real_t tmp_qloop_44 = jac_blending_inv_0_1*1.0;
                const real_t tmp_qloop_49 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GRAY[8*q + 7];
                const real_t tmp_qloop_62 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GRAY[8*q];
                const real_t tmp_qloop_94 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GRAY[8*q + 2];
                const real_t tmp_qloop_114 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GRAY[8*q + 3];
                const real_t tmp_qloop_133 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GRAY[8*q + 4];
                const real_t tmp_qloop_152 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GRAY[8*q + 5];
                const real_t tmp_qloop_171 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GRAY[8*q + 6];
                const real_t jac_blending_inv_1_0 = -jac_blending_1_0*tmp_qloop_22;
                const real_t tmp_qloop_40 = jac_blending_inv_1_0*1.0;
                const real_t tmp_qloop_41 = tmp_qloop_39*_data_tabulated_and_untitled_0_0_GRAY[8*q + 7] + tmp_qloop_40*_data_tabulated_and_untitled_1_0_GRAY[7*q + 6];
                const real_t tmp_qloop_43 = (tmp_qloop_41*tmp_qloop_41)*tmp_qloop_42;
                const real_t tmp_qloop_48 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GRAY[7*q + 1];
                const real_t tmp_qloop_56 = tmp_qloop_39*_data_tabulated_and_untitled_0_0_GRAY[8*q] + tmp_qloop_40*_data_tabulated_and_untitled_1_0_GRAY[7*q];
                const real_t tmp_qloop_57 = tmp_qloop_42*tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_41*tmp_qloop_57;
                const real_t tmp_qloop_65 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GRAY[7*q];
                const real_t tmp_qloop_66 = tmp_qloop_64*0.5 + tmp_qloop_65*0.5;
                const real_t tmp_qloop_76 = tmp_qloop_64 + tmp_qloop_65;
                const real_t tmp_qloop_84 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GRAY[7*q + 2];
                const real_t tmp_qloop_93 = tmp_qloop_39*_data_tabulated_and_untitled_0_0_GRAY[8*q + 2] + tmp_qloop_40*_data_tabulated_and_untitled_1_0_GRAY[7*q + 1];
                const real_t tmp_qloop_98 = tmp_qloop_41*tmp_qloop_42;
                const real_t tmp_qloop_99 = tmp_qloop_93*tmp_qloop_98;
                const real_t tmp_qloop_106 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GRAY[7*q + 3];
                const real_t tmp_qloop_113 = tmp_qloop_39*_data_tabulated_and_untitled_0_0_GRAY[8*q + 3] + tmp_qloop_40*_data_tabulated_and_untitled_1_0_GRAY[7*q + 2];
                const real_t tmp_qloop_118 = tmp_qloop_113*tmp_qloop_98;
                const real_t tmp_qloop_125 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GRAY[7*q + 4];
                const real_t tmp_qloop_132 = tmp_qloop_39*_data_tabulated_and_untitled_0_0_GRAY[8*q + 4] + tmp_qloop_40*_data_tabulated_and_untitled_1_0_GRAY[7*q + 3];
                const real_t tmp_qloop_137 = tmp_qloop_132*tmp_qloop_98;
                const real_t tmp_qloop_144 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GRAY[7*q + 5];
                const real_t tmp_qloop_151 = tmp_qloop_39*_data_tabulated_and_untitled_0_0_GRAY[8*q + 5] + tmp_qloop_40*_data_tabulated_and_untitled_1_0_GRAY[7*q + 4];
                const real_t tmp_qloop_156 = tmp_qloop_151*tmp_qloop_98;
                const real_t tmp_qloop_163 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GRAY[7*q + 6];
                const real_t tmp_qloop_170 = tmp_qloop_39*_data_tabulated_and_untitled_0_0_GRAY[8*q + 6] + tmp_qloop_40*_data_tabulated_and_untitled_1_0_GRAY[7*q + 5];
                const real_t tmp_qloop_175 = tmp_qloop_170*tmp_qloop_98;
                const real_t tmp_qloop_198 = tmp_qloop_42*tmp_qloop_93;
                const real_t tmp_qloop_234 = tmp_qloop_113*tmp_qloop_42;
                const real_t tmp_qloop_264 = tmp_qloop_132*tmp_qloop_42;
                const real_t jac_blending_inv_1_1 = jac_blending_0_0*tmp_qloop_22;
                const real_t tmp_qloop_45 = jac_blending_inv_1_1*1.0;
                const real_t tmp_qloop_46 = tmp_qloop_44*_data_tabulated_and_untitled_0_1_GRAY[7*q + 1] + tmp_qloop_45*_data_tabulated_and_untitled_1_1_GRAY[7*q + 1];
                const real_t tmp_qloop_50 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GRAY[7*q + 6];
                const real_t tmp_qloop_51 = tmp_qloop_49 + tmp_qloop_50;
                const real_t tmp_qloop_53 = tmp_qloop_42*(tmp_qloop_46*tmp_qloop_46) + tmp_qloop_43 + tmp_qloop_52*((tmp_qloop_47 + tmp_qloop_48 + tmp_qloop_51)*(tmp_qloop_47 + tmp_qloop_48 + tmp_qloop_51));
                const real_t tmp_qloop_59 = tmp_qloop_44*_data_tabulated_and_untitled_0_1_GRAY[7*q] + tmp_qloop_45*_data_tabulated_and_untitled_1_1_GRAY[7*q];
                const real_t tmp_qloop_60 = tmp_qloop_42*tmp_qloop_46;
                const real_t tmp_qloop_61 = tmp_qloop_59*tmp_qloop_60;
                const real_t tmp_qloop_63 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GRAY[7*q];
                const real_t tmp_qloop_67 = tmp_qloop_62*0.5 + tmp_qloop_63*0.5 + tmp_qloop_66;
                const real_t tmp_qloop_68 = tmp_qloop_49*0.5 + tmp_qloop_50*0.5;
                const real_t tmp_qloop_70 = tmp_qloop_69*(tmp_qloop_47*0.5 + tmp_qloop_48*0.5 + tmp_qloop_68);
                const real_t tmp_qloop_71 = tmp_qloop_58 + tmp_qloop_61 + tmp_qloop_67*tmp_qloop_70;
                const real_t tmp_qloop_74 = tmp_qloop_53*tmp_qloop_55 + tmp_qloop_71*tmp_qloop_73;
                const real_t tmp_qloop_75 = tmp_qloop_42*(tmp_qloop_59*tmp_qloop_59);
                const real_t tmp_qloop_77 = tmp_qloop_42*(tmp_qloop_56*tmp_qloop_56) + tmp_qloop_52*((tmp_qloop_62 + tmp_qloop_63 + tmp_qloop_76)*(tmp_qloop_62 + tmp_qloop_63 + tmp_qloop_76)) + tmp_qloop_75;
                const real_t tmp_qloop_78 = tmp_qloop_55*tmp_qloop_71;
                const real_t tmp_qloop_79 = tmp_qloop_73*tmp_qloop_77 + tmp_qloop_78;
                const real_t tmp_qloop_82 = tmp_qloop_44*_data_tabulated_and_untitled_0_1_GRAY[7*q + 2] + tmp_qloop_45*_data_tabulated_and_untitled_1_1_GRAY[7*q + 2];
                const real_t tmp_qloop_85 = tmp_qloop_68 + tmp_qloop_83*0.5 + tmp_qloop_84*0.5;
                const real_t tmp_qloop_86 = tmp_qloop_43 + tmp_qloop_60*tmp_qloop_82 + tmp_qloop_70*tmp_qloop_85;
                const real_t tmp_qloop_87 = tmp_qloop_42*tmp_qloop_59;
                const real_t tmp_qloop_88 = tmp_qloop_82*tmp_qloop_87;
                const real_t tmp_qloop_89 = tmp_qloop_67*tmp_qloop_69;
                const real_t tmp_qloop_90 = tmp_qloop_58 + tmp_qloop_85*tmp_qloop_89 + tmp_qloop_88;
                const real_t tmp_qloop_91 = tmp_qloop_55*tmp_qloop_86 + tmp_qloop_73*tmp_qloop_90;
                const real_t tmp_qloop_95 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GRAY[7*q + 1];
                const real_t tmp_qloop_96 = tmp_qloop_66 + tmp_qloop_94*0.5 + tmp_qloop_95*0.5;
                const real_t tmp_qloop_97 = tmp_qloop_57*tmp_qloop_93 + tmp_qloop_75 + tmp_qloop_89*tmp_qloop_96;
                const real_t tmp_qloop_100 = tmp_qloop_61 + tmp_qloop_70*tmp_qloop_96 + tmp_qloop_99;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_55 + tmp_qloop_73*tmp_qloop_97;
                const real_t tmp_qloop_104 = tmp_qloop_44*_data_tabulated_and_untitled_0_1_GRAY[7*q + 3] + tmp_qloop_45*_data_tabulated_and_untitled_1_1_GRAY[7*q + 3];
                const real_t tmp_qloop_107 = tmp_qloop_105*0.5 + tmp_qloop_106*0.5 + tmp_qloop_68;
                const real_t tmp_qloop_108 = tmp_qloop_104*tmp_qloop_60 + tmp_qloop_107*tmp_qloop_70 + tmp_qloop_43;
                const real_t tmp_qloop_109 = tmp_qloop_104*tmp_qloop_87;
                const real_t tmp_qloop_110 = tmp_qloop_107*tmp_qloop_89 + tmp_qloop_109 + tmp_qloop_58;
                const real_t tmp_qloop_111 = tmp_qloop_108*tmp_qloop_55 + tmp_qloop_110*tmp_qloop_73;
                const real_t tmp_qloop_115 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GRAY[7*q + 2];
                const real_t tmp_qloop_116 = tmp_qloop_114*0.5 + tmp_qloop_115*0.5 + tmp_qloop_66;
                const real_t tmp_qloop_117 = tmp_qloop_113*tmp_qloop_57 + tmp_qloop_116*tmp_qloop_89 + tmp_qloop_75;
                const real_t tmp_qloop_119 = tmp_qloop_116*tmp_qloop_70 + tmp_qloop_118 + tmp_qloop_61;
                const real_t tmp_qloop_120 = tmp_qloop_117*tmp_qloop_73 + tmp_qloop_119*tmp_qloop_55;
                const real_t tmp_qloop_123 = tmp_qloop_44*_data_tabulated_and_untitled_0_1_GRAY[7*q + 4] + tmp_qloop_45*_data_tabulated_and_untitled_1_1_GRAY[7*q + 4];
                const real_t tmp_qloop_126 = tmp_qloop_124*0.5 + tmp_qloop_125*0.5 + tmp_qloop_68;
                const real_t tmp_qloop_127 = tmp_qloop_123*tmp_qloop_60 + tmp_qloop_126*tmp_qloop_70 + tmp_qloop_43;
                const real_t tmp_qloop_128 = tmp_qloop_123*tmp_qloop_87;
                const real_t tmp_qloop_129 = tmp_qloop_126*tmp_qloop_89 + tmp_qloop_128 + tmp_qloop_58;
                const real_t tmp_qloop_130 = tmp_qloop_127*tmp_qloop_55 + tmp_qloop_129*tmp_qloop_73;
                const real_t tmp_qloop_134 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GRAY[7*q + 3];
                const real_t tmp_qloop_135 = tmp_qloop_133*0.5 + tmp_qloop_134*0.5 + tmp_qloop_66;
                const real_t tmp_qloop_136 = tmp_qloop_132*tmp_qloop_57 + tmp_qloop_135*tmp_qloop_89 + tmp_qloop_75;
                const real_t tmp_qloop_138 = tmp_qloop_135*tmp_qloop_70 + tmp_qloop_137 + tmp_qloop_61;
                const real_t tmp_qloop_139 = tmp_qloop_136*tmp_qloop_73 + tmp_qloop_138*tmp_qloop_55;
                const real_t tmp_qloop_142 = tmp_qloop_44*_data_tabulated_and_untitled_0_1_GRAY[7*q + 5] + tmp_qloop_45*_data_tabulated_and_untitled_1_1_GRAY[7*q + 5];
                const real_t tmp_qloop_145 = tmp_qloop_143*0.5 + tmp_qloop_144*0.5 + tmp_qloop_68;
                const real_t tmp_qloop_146 = tmp_qloop_142*tmp_qloop_60 + tmp_qloop_145*tmp_qloop_70 + tmp_qloop_43;
                const real_t tmp_qloop_147 = tmp_qloop_142*tmp_qloop_87;
                const real_t tmp_qloop_148 = tmp_qloop_145*tmp_qloop_89 + tmp_qloop_147 + tmp_qloop_58;
                const real_t tmp_qloop_149 = tmp_qloop_146*tmp_qloop_55 + tmp_qloop_148*tmp_qloop_73;
                const real_t tmp_qloop_153 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GRAY[7*q + 4];
                const real_t tmp_qloop_154 = tmp_qloop_152*0.5 + tmp_qloop_153*0.5 + tmp_qloop_66;
                const real_t tmp_qloop_155 = tmp_qloop_151*tmp_qloop_57 + tmp_qloop_154*tmp_qloop_89 + tmp_qloop_75;
                const real_t tmp_qloop_157 = tmp_qloop_154*tmp_qloop_70 + tmp_qloop_156 + tmp_qloop_61;
                const real_t tmp_qloop_158 = tmp_qloop_155*tmp_qloop_73 + tmp_qloop_157*tmp_qloop_55;
                const real_t tmp_qloop_161 = tmp_qloop_44*_data_tabulated_and_untitled_0_1_GRAY[7*q + 6] + tmp_qloop_45*_data_tabulated_and_untitled_1_1_GRAY[7*q + 6];
                const real_t tmp_qloop_164 = tmp_qloop_162*0.5 + tmp_qloop_163*0.5 + tmp_qloop_68;
                const real_t tmp_qloop_165 = tmp_qloop_161*tmp_qloop_60 + tmp_qloop_164*tmp_qloop_70 + tmp_qloop_43;
                const real_t tmp_qloop_166 = tmp_qloop_161*tmp_qloop_87;
                const real_t tmp_qloop_167 = tmp_qloop_164*tmp_qloop_89 + tmp_qloop_166 + tmp_qloop_58;
                const real_t tmp_qloop_168 = tmp_qloop_165*tmp_qloop_55 + tmp_qloop_167*tmp_qloop_73;
                const real_t tmp_qloop_172 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GRAY[7*q + 5];
                const real_t tmp_qloop_173 = tmp_qloop_171*0.5 + tmp_qloop_172*0.5 + tmp_qloop_66;
                const real_t tmp_qloop_174 = tmp_qloop_170*tmp_qloop_57 + tmp_qloop_173*tmp_qloop_89 + tmp_qloop_75;
                const real_t tmp_qloop_176 = tmp_qloop_173*tmp_qloop_70 + tmp_qloop_175 + tmp_qloop_61;
                const real_t tmp_qloop_177 = tmp_qloop_174*tmp_qloop_73 + tmp_qloop_176*tmp_qloop_55;
                const real_t tmp_qloop_184 = tmp_qloop_42*(tmp_qloop_82*tmp_qloop_82) + tmp_qloop_43 + tmp_qloop_52*((tmp_qloop_51 + tmp_qloop_83 + tmp_qloop_84)*(tmp_qloop_51 + tmp_qloop_83 + tmp_qloop_84));
                const real_t tmp_qloop_186 = tmp_qloop_69*tmp_qloop_85;
                const real_t tmp_qloop_187 = tmp_qloop_186*tmp_qloop_96 + tmp_qloop_88 + tmp_qloop_99;
                const real_t tmp_qloop_189 = tmp_qloop_184*tmp_qloop_185 + tmp_qloop_187*tmp_qloop_188;
                const real_t tmp_qloop_190 = tmp_qloop_42*(tmp_qloop_93*tmp_qloop_93) + tmp_qloop_52*((tmp_qloop_76 + tmp_qloop_94 + tmp_qloop_95)*(tmp_qloop_76 + tmp_qloop_94 + tmp_qloop_95)) + tmp_qloop_75;
                const real_t tmp_qloop_191 = tmp_qloop_185*tmp_qloop_187;
                const real_t tmp_qloop_192 = tmp_qloop_188*tmp_qloop_190 + tmp_qloop_191;
                const real_t tmp_qloop_193 = tmp_qloop_42*tmp_qloop_82;
                const real_t tmp_qloop_194 = tmp_qloop_104*tmp_qloop_193 + tmp_qloop_107*tmp_qloop_186 + tmp_qloop_43;
                const real_t tmp_qloop_195 = tmp_qloop_69*tmp_qloop_96;
                const real_t tmp_qloop_196 = tmp_qloop_107*tmp_qloop_195 + tmp_qloop_109 + tmp_qloop_99;
                const real_t tmp_qloop_197 = tmp_qloop_185*tmp_qloop_194 + tmp_qloop_188*tmp_qloop_196;
                const real_t tmp_qloop_199 = tmp_qloop_113*tmp_qloop_198 + tmp_qloop_116*tmp_qloop_195 + tmp_qloop_75;
                const real_t tmp_qloop_200 = tmp_qloop_116*tmp_qloop_186 + tmp_qloop_118 + tmp_qloop_88;
                const real_t tmp_qloop_201 = tmp_qloop_185*tmp_qloop_200 + tmp_qloop_188*tmp_qloop_199;
                const real_t tmp_qloop_202 = tmp_qloop_123*tmp_qloop_193 + tmp_qloop_126*tmp_qloop_186 + tmp_qloop_43;
                const real_t tmp_qloop_203 = tmp_qloop_126*tmp_qloop_195 + tmp_qloop_128 + tmp_qloop_99;
                const real_t tmp_qloop_204 = tmp_qloop_185*tmp_qloop_202 + tmp_qloop_188*tmp_qloop_203;
                const real_t tmp_qloop_205 = tmp_qloop_132*tmp_qloop_198 + tmp_qloop_135*tmp_qloop_195 + tmp_qloop_75;
                const real_t tmp_qloop_206 = tmp_qloop_135*tmp_qloop_186 + tmp_qloop_137 + tmp_qloop_88;
                const real_t tmp_qloop_207 = tmp_qloop_185*tmp_qloop_206 + tmp_qloop_188*tmp_qloop_205;
                const real_t tmp_qloop_208 = tmp_qloop_142*tmp_qloop_193 + tmp_qloop_145*tmp_qloop_186 + tmp_qloop_43;
                const real_t tmp_qloop_209 = tmp_qloop_145*tmp_qloop_195 + tmp_qloop_147 + tmp_qloop_99;
                const real_t tmp_qloop_210 = tmp_qloop_185*tmp_qloop_208 + tmp_qloop_188*tmp_qloop_209;
                const real_t tmp_qloop_211 = tmp_qloop_151*tmp_qloop_198 + tmp_qloop_154*tmp_qloop_195 + tmp_qloop_75;
                const real_t tmp_qloop_212 = tmp_qloop_154*tmp_qloop_186 + tmp_qloop_156 + tmp_qloop_88;
                const real_t tmp_qloop_213 = tmp_qloop_185*tmp_qloop_212 + tmp_qloop_188*tmp_qloop_211;
                const real_t tmp_qloop_214 = tmp_qloop_161*tmp_qloop_193 + tmp_qloop_164*tmp_qloop_186 + tmp_qloop_43;
                const real_t tmp_qloop_215 = tmp_qloop_164*tmp_qloop_195 + tmp_qloop_166 + tmp_qloop_99;
                const real_t tmp_qloop_216 = tmp_qloop_185*tmp_qloop_214 + tmp_qloop_188*tmp_qloop_215;
                const real_t tmp_qloop_217 = tmp_qloop_170*tmp_qloop_198 + tmp_qloop_173*tmp_qloop_195 + tmp_qloop_75;
                const real_t tmp_qloop_218 = tmp_qloop_173*tmp_qloop_186 + tmp_qloop_175 + tmp_qloop_88;
                const real_t tmp_qloop_219 = tmp_qloop_185*tmp_qloop_218 + tmp_qloop_188*tmp_qloop_217;
                const real_t tmp_qloop_220 = (tmp_qloop_104*tmp_qloop_104)*tmp_qloop_42 + tmp_qloop_43 + tmp_qloop_52*((tmp_qloop_105 + tmp_qloop_106 + tmp_qloop_51)*(tmp_qloop_105 + tmp_qloop_106 + tmp_qloop_51));
                const real_t tmp_qloop_222 = tmp_qloop_107*tmp_qloop_69;
                const real_t tmp_qloop_223 = tmp_qloop_109 + tmp_qloop_116*tmp_qloop_222 + tmp_qloop_118;
                const real_t tmp_qloop_225 = tmp_qloop_220*tmp_qloop_221 + tmp_qloop_223*tmp_qloop_224;
                const real_t tmp_qloop_226 = (tmp_qloop_113*tmp_qloop_113)*tmp_qloop_42 + tmp_qloop_52*((tmp_qloop_114 + tmp_qloop_115 + tmp_qloop_76)*(tmp_qloop_114 + tmp_qloop_115 + tmp_qloop_76)) + tmp_qloop_75;
                const real_t tmp_qloop_227 = tmp_qloop_221*tmp_qloop_223;
                const real_t tmp_qloop_228 = tmp_qloop_224*tmp_qloop_226 + tmp_qloop_227;
                const real_t tmp_qloop_229 = tmp_qloop_104*tmp_qloop_42;
                const real_t tmp_qloop_230 = tmp_qloop_123*tmp_qloop_229 + tmp_qloop_126*tmp_qloop_222 + tmp_qloop_43;
                const real_t tmp_qloop_231 = tmp_qloop_116*tmp_qloop_69;
                const real_t tmp_qloop_232 = tmp_qloop_118 + tmp_qloop_126*tmp_qloop_231 + tmp_qloop_128;
                const real_t tmp_qloop_233 = tmp_qloop_221*tmp_qloop_230 + tmp_qloop_224*tmp_qloop_232;
                const real_t tmp_qloop_235 = tmp_qloop_132*tmp_qloop_234 + tmp_qloop_135*tmp_qloop_231 + tmp_qloop_75;
                const real_t tmp_qloop_236 = tmp_qloop_109 + tmp_qloop_135*tmp_qloop_222 + tmp_qloop_137;
                const real_t tmp_qloop_237 = tmp_qloop_221*tmp_qloop_236 + tmp_qloop_224*tmp_qloop_235;
                const real_t tmp_qloop_238 = tmp_qloop_142*tmp_qloop_229 + tmp_qloop_145*tmp_qloop_222 + tmp_qloop_43;
                const real_t tmp_qloop_239 = tmp_qloop_118 + tmp_qloop_145*tmp_qloop_231 + tmp_qloop_147;
                const real_t tmp_qloop_240 = tmp_qloop_221*tmp_qloop_238 + tmp_qloop_224*tmp_qloop_239;
                const real_t tmp_qloop_241 = tmp_qloop_151*tmp_qloop_234 + tmp_qloop_154*tmp_qloop_231 + tmp_qloop_75;
                const real_t tmp_qloop_242 = tmp_qloop_109 + tmp_qloop_154*tmp_qloop_222 + tmp_qloop_156;
                const real_t tmp_qloop_243 = tmp_qloop_221*tmp_qloop_242 + tmp_qloop_224*tmp_qloop_241;
                const real_t tmp_qloop_244 = tmp_qloop_161*tmp_qloop_229 + tmp_qloop_164*tmp_qloop_222 + tmp_qloop_43;
                const real_t tmp_qloop_245 = tmp_qloop_118 + tmp_qloop_164*tmp_qloop_231 + tmp_qloop_166;
                const real_t tmp_qloop_246 = tmp_qloop_221*tmp_qloop_244 + tmp_qloop_224*tmp_qloop_245;
                const real_t tmp_qloop_247 = tmp_qloop_170*tmp_qloop_234 + tmp_qloop_173*tmp_qloop_231 + tmp_qloop_75;
                const real_t tmp_qloop_248 = tmp_qloop_109 + tmp_qloop_173*tmp_qloop_222 + tmp_qloop_175;
                const real_t tmp_qloop_249 = tmp_qloop_221*tmp_qloop_248 + tmp_qloop_224*tmp_qloop_247;
                const real_t tmp_qloop_250 = (tmp_qloop_123*tmp_qloop_123)*tmp_qloop_42 + tmp_qloop_43 + tmp_qloop_52*((tmp_qloop_124 + tmp_qloop_125 + tmp_qloop_51)*(tmp_qloop_124 + tmp_qloop_125 + tmp_qloop_51));
                const real_t tmp_qloop_252 = tmp_qloop_126*tmp_qloop_69;
                const real_t tmp_qloop_253 = tmp_qloop_128 + tmp_qloop_135*tmp_qloop_252 + tmp_qloop_137;
                const real_t tmp_qloop_255 = tmp_qloop_250*tmp_qloop_251 + tmp_qloop_253*tmp_qloop_254;
                const real_t tmp_qloop_256 = (tmp_qloop_132*tmp_qloop_132)*tmp_qloop_42 + tmp_qloop_52*((tmp_qloop_133 + tmp_qloop_134 + tmp_qloop_76)*(tmp_qloop_133 + tmp_qloop_134 + tmp_qloop_76)) + tmp_qloop_75;
                const real_t tmp_qloop_257 = tmp_qloop_251*tmp_qloop_253;
                const real_t tmp_qloop_258 = tmp_qloop_254*tmp_qloop_256 + tmp_qloop_257;
                const real_t tmp_qloop_259 = tmp_qloop_123*tmp_qloop_42;
                const real_t tmp_qloop_260 = tmp_qloop_142*tmp_qloop_259 + tmp_qloop_145*tmp_qloop_252 + tmp_qloop_43;
                const real_t tmp_qloop_261 = tmp_qloop_135*tmp_qloop_69;
                const real_t tmp_qloop_262 = tmp_qloop_137 + tmp_qloop_145*tmp_qloop_261 + tmp_qloop_147;
                const real_t tmp_qloop_263 = tmp_qloop_251*tmp_qloop_260 + tmp_qloop_254*tmp_qloop_262;
                const real_t tmp_qloop_265 = tmp_qloop_151*tmp_qloop_264 + tmp_qloop_154*tmp_qloop_261 + tmp_qloop_75;
                const real_t tmp_qloop_266 = tmp_qloop_128 + tmp_qloop_154*tmp_qloop_252 + tmp_qloop_156;
                const real_t tmp_qloop_267 = tmp_qloop_251*tmp_qloop_266 + tmp_qloop_254*tmp_qloop_265;
                const real_t tmp_qloop_268 = tmp_qloop_161*tmp_qloop_259 + tmp_qloop_164*tmp_qloop_252 + tmp_qloop_43;
                const real_t tmp_qloop_269 = tmp_qloop_137 + tmp_qloop_164*tmp_qloop_261 + tmp_qloop_166;
                const real_t tmp_qloop_270 = tmp_qloop_251*tmp_qloop_268 + tmp_qloop_254*tmp_qloop_269;
                const real_t tmp_qloop_271 = tmp_qloop_170*tmp_qloop_264 + tmp_qloop_173*tmp_qloop_261 + tmp_qloop_75;
                const real_t tmp_qloop_272 = tmp_qloop_128 + tmp_qloop_173*tmp_qloop_252 + tmp_qloop_175;
                const real_t tmp_qloop_273 = tmp_qloop_251*tmp_qloop_272 + tmp_qloop_254*tmp_qloop_271;
                const real_t tmp_qloop_274 = (tmp_qloop_142*tmp_qloop_142)*tmp_qloop_42 + tmp_qloop_43 + tmp_qloop_52*((tmp_qloop_143 + tmp_qloop_144 + tmp_qloop_51)*(tmp_qloop_143 + tmp_qloop_144 + tmp_qloop_51));
                const real_t tmp_qloop_276 = tmp_qloop_145*tmp_qloop_69;
                const real_t tmp_qloop_277 = tmp_qloop_147 + tmp_qloop_154*tmp_qloop_276 + tmp_qloop_156;
                const real_t tmp_qloop_279 = tmp_qloop_274*tmp_qloop_275 + tmp_qloop_277*tmp_qloop_278;
                const real_t tmp_qloop_280 = (tmp_qloop_151*tmp_qloop_151)*tmp_qloop_42 + tmp_qloop_52*((tmp_qloop_152 + tmp_qloop_153 + tmp_qloop_76)*(tmp_qloop_152 + tmp_qloop_153 + tmp_qloop_76)) + tmp_qloop_75;
                const real_t tmp_qloop_281 = tmp_qloop_275*tmp_qloop_277;
                const real_t tmp_qloop_282 = tmp_qloop_278*tmp_qloop_280 + tmp_qloop_281;
                const real_t tmp_qloop_283 = tmp_qloop_142*tmp_qloop_161*tmp_qloop_42 + tmp_qloop_164*tmp_qloop_276 + tmp_qloop_43;
                const real_t tmp_qloop_284 = tmp_qloop_154*tmp_qloop_69;
                const real_t tmp_qloop_285 = tmp_qloop_156 + tmp_qloop_164*tmp_qloop_284 + tmp_qloop_166;
                const real_t tmp_qloop_286 = tmp_qloop_275*tmp_qloop_283 + tmp_qloop_278*tmp_qloop_285;
                const real_t tmp_qloop_287 = tmp_qloop_151*tmp_qloop_170*tmp_qloop_42 + tmp_qloop_173*tmp_qloop_284 + tmp_qloop_75;
                const real_t tmp_qloop_288 = tmp_qloop_147 + tmp_qloop_173*tmp_qloop_276 + tmp_qloop_175;
                const real_t tmp_qloop_289 = tmp_qloop_275*tmp_qloop_288 + tmp_qloop_278*tmp_qloop_287;
                const real_t tmp_qloop_290 = (tmp_qloop_161*tmp_qloop_161)*tmp_qloop_42 + tmp_qloop_43 + tmp_qloop_52*((tmp_qloop_162 + tmp_qloop_163 + tmp_qloop_51)*(tmp_qloop_162 + tmp_qloop_163 + tmp_qloop_51));
                const real_t tmp_qloop_292 = tmp_qloop_164*tmp_qloop_173*tmp_qloop_69 + tmp_qloop_166 + tmp_qloop_175;
                const real_t tmp_qloop_294 = tmp_qloop_290*tmp_qloop_291 + tmp_qloop_292*tmp_qloop_293;
                const real_t tmp_qloop_295 = (tmp_qloop_170*tmp_qloop_170)*tmp_qloop_42 + tmp_qloop_52*((tmp_qloop_171 + tmp_qloop_172 + tmp_qloop_76)*(tmp_qloop_171 + tmp_qloop_172 + tmp_qloop_76)) + tmp_qloop_75;
                const real_t tmp_qloop_296 = tmp_qloop_291*tmp_qloop_292;
                const real_t tmp_qloop_297 = tmp_qloop_293*tmp_qloop_295 + tmp_qloop_296;
                const real_t hessian_blending_0_0_0 = tmp_qloop_14 - tmp_qloop_25 + tmp_qloop_28;
                const real_t hessian_blending_1_0_0 = -tmp_qloop_26*(tmp_qloop_3*tmp_qloop_3*tmp_qloop_3) + tmp_qloop_29*tmp_qloop_4 + tmp_qloop_3*tmp_qloop_32 - tmp_qloop_31;
                const real_t hessian_blending_0_0_1 = tmp_qloop_1*tmp_qloop_11*tmp_qloop_15*tmp_qloop_30*-2.0 - tmp_qloop_34;
                const real_t hessian_blending_1_0_1 = tmp_qloop_1*tmp_qloop_10*tmp_qloop_6*tmp_qloop_9*1.0 - tmp_qloop_20 - tmp_qloop_28 - tmp_qloop_35;
                const real_t hessian_blending_0_1_0 = tmp_qloop_10*tmp_qloop_15*tmp_qloop_2*tmp_qloop_8*tmp_qloop_9*1.0 - tmp_qloop_19 - tmp_qloop_31 - tmp_qloop_34;
                const real_t hessian_blending_1_1_0 = -tmp_qloop_20 + tmp_qloop_27 - tmp_qloop_35 + tmp_qloop_36;
                const real_t hessian_blending_0_1_1 = tmp_qloop_0*tmp_qloop_32 - (tmp_qloop_0*tmp_qloop_0*tmp_qloop_0)*tmp_qloop_26 + tmp_qloop_25 + tmp_qloop_36;
                const real_t hessian_blending_1_1_1 = tmp_qloop_10*tmp_qloop_15*tmp_qloop_2*tmp_qloop_7*tmp_qloop_9*1.0 + tmp_qloop_10*tmp_qloop_15*tmp_qloop_4*tmp_qloop_8*tmp_qloop_9*1.0 - tmp_qloop_19 - tmp_qloop_33;
                const real_t q_tmp_0_0 = (tmp_qloop_38*tmp_qloop_74 + tmp_qloop_72*tmp_qloop_79)*_data_q_w[q];
                const real_t q_tmp_0_1 = (tmp_qloop_101*tmp_qloop_92 + tmp_qloop_81*tmp_qloop_91)*_data_q_w[q];
                const real_t q_tmp_0_2 = (tmp_qloop_103*tmp_qloop_111 + tmp_qloop_112*tmp_qloop_120)*_data_q_w[q];
                const real_t q_tmp_0_3 = (tmp_qloop_122*tmp_qloop_130 + tmp_qloop_131*tmp_qloop_139)*_data_q_w[q];
                const real_t q_tmp_0_4 = (tmp_qloop_141*tmp_qloop_149 + tmp_qloop_150*tmp_qloop_158)*_data_q_w[q];
                const real_t q_tmp_0_5 = (tmp_qloop_160*tmp_qloop_168 + tmp_qloop_169*tmp_qloop_177)*_data_q_w[q];
                const real_t q_tmp_0_6 = (tmp_qloop_178*tmp_qloop_74 + tmp_qloop_38*tmp_qloop_79)*_data_q_w[q];
                const real_t q_tmp_0_7 = (tmp_qloop_101*tmp_qloop_81 + tmp_qloop_179*tmp_qloop_91)*_data_q_w[q];
                const real_t q_tmp_0_8 = (tmp_qloop_103*tmp_qloop_120 + tmp_qloop_111*tmp_qloop_180)*_data_q_w[q];
                const real_t q_tmp_0_9 = (tmp_qloop_122*tmp_qloop_139 + tmp_qloop_130*tmp_qloop_181)*_data_q_w[q];
                const real_t q_tmp_0_10 = (tmp_qloop_141*tmp_qloop_158 + tmp_qloop_149*tmp_qloop_182)*_data_q_w[q];
                const real_t q_tmp_0_11 = (tmp_qloop_160*tmp_qloop_177 + tmp_qloop_168*tmp_qloop_183)*_data_q_w[q];
                const real_t q_tmp_1_1 = (tmp_qloop_189*tmp_qloop_81 + tmp_qloop_192*tmp_qloop_92)*_data_q_w[q];
                const real_t q_tmp_1_2 = (tmp_qloop_103*tmp_qloop_197 + tmp_qloop_112*tmp_qloop_201)*_data_q_w[q];
                const real_t q_tmp_1_3 = (tmp_qloop_122*tmp_qloop_204 + tmp_qloop_131*tmp_qloop_207)*_data_q_w[q];
                const real_t q_tmp_1_4 = (tmp_qloop_141*tmp_qloop_210 + tmp_qloop_150*tmp_qloop_213)*_data_q_w[q];
                const real_t q_tmp_1_5 = (tmp_qloop_160*tmp_qloop_216 + tmp_qloop_169*tmp_qloop_219)*_data_q_w[q];
                const real_t q_tmp_1_6 = (tmp_qloop_178*(tmp_qloop_100*tmp_qloop_188 + tmp_qloop_185*tmp_qloop_86) + tmp_qloop_38*(tmp_qloop_185*tmp_qloop_90 + tmp_qloop_188*tmp_qloop_97))*_data_q_w[q];
                const real_t q_tmp_1_7 = (tmp_qloop_179*tmp_qloop_189 + tmp_qloop_192*tmp_qloop_81)*_data_q_w[q];
                const real_t q_tmp_1_8 = (tmp_qloop_103*tmp_qloop_201 + tmp_qloop_180*tmp_qloop_197)*_data_q_w[q];
                const real_t q_tmp_1_9 = (tmp_qloop_122*tmp_qloop_207 + tmp_qloop_181*tmp_qloop_204)*_data_q_w[q];
                const real_t q_tmp_1_10 = (tmp_qloop_141*tmp_qloop_213 + tmp_qloop_182*tmp_qloop_210)*_data_q_w[q];
                const real_t q_tmp_1_11 = (tmp_qloop_160*tmp_qloop_219 + tmp_qloop_183*tmp_qloop_216)*_data_q_w[q];
                const real_t q_tmp_2_2 = (tmp_qloop_103*tmp_qloop_225 + tmp_qloop_112*tmp_qloop_228)*_data_q_w[q];
                const real_t q_tmp_2_3 = (tmp_qloop_122*tmp_qloop_233 + tmp_qloop_131*tmp_qloop_237)*_data_q_w[q];
                const real_t q_tmp_2_4 = (tmp_qloop_141*tmp_qloop_240 + tmp_qloop_150*tmp_qloop_243)*_data_q_w[q];
                const real_t q_tmp_2_5 = (tmp_qloop_160*tmp_qloop_246 + tmp_qloop_169*tmp_qloop_249)*_data_q_w[q];
                const real_t q_tmp_2_6 = (tmp_qloop_178*(tmp_qloop_108*tmp_qloop_221 + tmp_qloop_119*tmp_qloop_224) + tmp_qloop_38*(tmp_qloop_110*tmp_qloop_221 + tmp_qloop_117*tmp_qloop_224))*_data_q_w[q];
                const real_t q_tmp_2_7 = (tmp_qloop_179*(tmp_qloop_194*tmp_qloop_221 + tmp_qloop_200*tmp_qloop_224) + tmp_qloop_81*(tmp_qloop_196*tmp_qloop_221 + tmp_qloop_199*tmp_qloop_224))*_data_q_w[q];
                const real_t q_tmp_2_8 = (tmp_qloop_103*tmp_qloop_228 + tmp_qloop_180*tmp_qloop_225)*_data_q_w[q];
                const real_t q_tmp_2_9 = (tmp_qloop_122*tmp_qloop_237 + tmp_qloop_181*tmp_qloop_233)*_data_q_w[q];
                const real_t q_tmp_2_10 = (tmp_qloop_141*tmp_qloop_243 + tmp_qloop_182*tmp_qloop_240)*_data_q_w[q];
                const real_t q_tmp_2_11 = (tmp_qloop_160*tmp_qloop_249 + tmp_qloop_183*tmp_qloop_246)*_data_q_w[q];
                const real_t q_tmp_3_3 = (tmp_qloop_122*tmp_qloop_255 + tmp_qloop_131*tmp_qloop_258)*_data_q_w[q];
                const real_t q_tmp_3_4 = (tmp_qloop_141*tmp_qloop_263 + tmp_qloop_150*tmp_qloop_267)*_data_q_w[q];
                const real_t q_tmp_3_5 = (tmp_qloop_160*tmp_qloop_270 + tmp_qloop_169*tmp_qloop_273)*_data_q_w[q];
                const real_t q_tmp_3_6 = (tmp_qloop_178*(tmp_qloop_127*tmp_qloop_251 + tmp_qloop_138*tmp_qloop_254) + tmp_qloop_38*(tmp_qloop_129*tmp_qloop_251 + tmp_qloop_136*tmp_qloop_254))*_data_q_w[q];
                const real_t q_tmp_3_7 = (tmp_qloop_179*(tmp_qloop_202*tmp_qloop_251 + tmp_qloop_206*tmp_qloop_254) + tmp_qloop_81*(tmp_qloop_203*tmp_qloop_251 + tmp_qloop_205*tmp_qloop_254))*_data_q_w[q];
                const real_t q_tmp_3_8 = (tmp_qloop_103*(tmp_qloop_232*tmp_qloop_251 + tmp_qloop_235*tmp_qloop_254) + tmp_qloop_180*(tmp_qloop_230*tmp_qloop_251 + tmp_qloop_236*tmp_qloop_254))*_data_q_w[q];
                const real_t q_tmp_3_9 = (tmp_qloop_122*tmp_qloop_258 + tmp_qloop_181*tmp_qloop_255)*_data_q_w[q];
                const real_t q_tmp_3_10 = (tmp_qloop_141*tmp_qloop_267 + tmp_qloop_182*tmp_qloop_263)*_data_q_w[q];
                const real_t q_tmp_3_11 = (tmp_qloop_160*tmp_qloop_273 + tmp_qloop_183*tmp_qloop_270)*_data_q_w[q];
                const real_t q_tmp_4_4 = (tmp_qloop_141*tmp_qloop_279 + tmp_qloop_150*tmp_qloop_282)*_data_q_w[q];
                const real_t q_tmp_4_5 = (tmp_qloop_160*tmp_qloop_286 + tmp_qloop_169*tmp_qloop_289)*_data_q_w[q];
                const real_t q_tmp_4_6 = (tmp_qloop_178*(tmp_qloop_146*tmp_qloop_275 + tmp_qloop_157*tmp_qloop_278) + tmp_qloop_38*(tmp_qloop_148*tmp_qloop_275 + tmp_qloop_155*tmp_qloop_278))*_data_q_w[q];
                const real_t q_tmp_4_7 = (tmp_qloop_179*(tmp_qloop_208*tmp_qloop_275 + tmp_qloop_212*tmp_qloop_278) + tmp_qloop_81*(tmp_qloop_209*tmp_qloop_275 + tmp_qloop_211*tmp_qloop_278))*_data_q_w[q];
                const real_t q_tmp_4_8 = (tmp_qloop_103*(tmp_qloop_239*tmp_qloop_275 + tmp_qloop_241*tmp_qloop_278) + tmp_qloop_180*(tmp_qloop_238*tmp_qloop_275 + tmp_qloop_242*tmp_qloop_278))*_data_q_w[q];
                const real_t q_tmp_4_9 = (tmp_qloop_122*(tmp_qloop_262*tmp_qloop_275 + tmp_qloop_265*tmp_qloop_278) + tmp_qloop_181*(tmp_qloop_260*tmp_qloop_275 + tmp_qloop_266*tmp_qloop_278))*_data_q_w[q];
                const real_t q_tmp_4_10 = (tmp_qloop_141*tmp_qloop_282 + tmp_qloop_182*tmp_qloop_279)*_data_q_w[q];
                const real_t q_tmp_4_11 = (tmp_qloop_160*tmp_qloop_289 + tmp_qloop_183*tmp_qloop_286)*_data_q_w[q];
                const real_t q_tmp_5_5 = (tmp_qloop_160*tmp_qloop_294 + tmp_qloop_169*tmp_qloop_297)*_data_q_w[q];
                const real_t q_tmp_5_6 = (tmp_qloop_178*(tmp_qloop_165*tmp_qloop_291 + tmp_qloop_176*tmp_qloop_293) + tmp_qloop_38*(tmp_qloop_167*tmp_qloop_291 + tmp_qloop_174*tmp_qloop_293))*_data_q_w[q];
                const real_t q_tmp_5_7 = (tmp_qloop_179*(tmp_qloop_214*tmp_qloop_291 + tmp_qloop_218*tmp_qloop_293) + tmp_qloop_81*(tmp_qloop_215*tmp_qloop_291 + tmp_qloop_217*tmp_qloop_293))*_data_q_w[q];
                const real_t q_tmp_5_8 = (tmp_qloop_103*(tmp_qloop_245*tmp_qloop_291 + tmp_qloop_247*tmp_qloop_293) + tmp_qloop_180*(tmp_qloop_244*tmp_qloop_291 + tmp_qloop_248*tmp_qloop_293))*_data_q_w[q];
                const real_t q_tmp_5_9 = (tmp_qloop_122*(tmp_qloop_269*tmp_qloop_291 + tmp_qloop_271*tmp_qloop_293) + tmp_qloop_181*(tmp_qloop_268*tmp_qloop_291 + tmp_qloop_272*tmp_qloop_293))*_data_q_w[q];
                const real_t q_tmp_5_10 = (tmp_qloop_141*(tmp_qloop_285*tmp_qloop_291 + tmp_qloop_287*tmp_qloop_293) + tmp_qloop_182*(tmp_qloop_283*tmp_qloop_291 + tmp_qloop_288*tmp_qloop_293))*_data_q_w[q];
                const real_t q_tmp_5_11 = (tmp_qloop_160*tmp_qloop_297 + tmp_qloop_183*tmp_qloop_294)*_data_q_w[q];
                const real_t q_tmp_6_6 = (tmp_qloop_178*(tmp_qloop_298*tmp_qloop_53 + tmp_qloop_78) + tmp_qloop_38*(tmp_qloop_298*tmp_qloop_71 + tmp_qloop_55*tmp_qloop_77))*_data_q_w[q];
                const real_t q_tmp_6_7 = (tmp_qloop_179*(tmp_qloop_298*tmp_qloop_86 + tmp_qloop_55*tmp_qloop_90) + tmp_qloop_81*(tmp_qloop_100*tmp_qloop_298 + tmp_qloop_55*tmp_qloop_97))*_data_q_w[q];
                const real_t q_tmp_6_8 = (tmp_qloop_103*(tmp_qloop_117*tmp_qloop_55 + tmp_qloop_119*tmp_qloop_298) + tmp_qloop_180*(tmp_qloop_108*tmp_qloop_298 + tmp_qloop_110*tmp_qloop_55))*_data_q_w[q];
                const real_t q_tmp_6_9 = (tmp_qloop_122*(tmp_qloop_136*tmp_qloop_55 + tmp_qloop_138*tmp_qloop_298) + tmp_qloop_181*(tmp_qloop_127*tmp_qloop_298 + tmp_qloop_129*tmp_qloop_55))*_data_q_w[q];
                const real_t q_tmp_6_10 = (tmp_qloop_141*(tmp_qloop_155*tmp_qloop_55 + tmp_qloop_157*tmp_qloop_298) + tmp_qloop_182*(tmp_qloop_146*tmp_qloop_298 + tmp_qloop_148*tmp_qloop_55))*_data_q_w[q];
                const real_t q_tmp_6_11 = (tmp_qloop_160*(tmp_qloop_174*tmp_qloop_55 + tmp_qloop_176*tmp_qloop_298) + tmp_qloop_183*(tmp_qloop_165*tmp_qloop_298 + tmp_qloop_167*tmp_qloop_55))*_data_q_w[q];
                const real_t q_tmp_7_7 = (tmp_qloop_179*(tmp_qloop_184*tmp_qloop_299 + tmp_qloop_191) + tmp_qloop_81*(tmp_qloop_185*tmp_qloop_190 + tmp_qloop_187*tmp_qloop_299))*_data_q_w[q];
                const real_t q_tmp_7_8 = (tmp_qloop_103*(tmp_qloop_185*tmp_qloop_199 + tmp_qloop_200*tmp_qloop_299) + tmp_qloop_180*(tmp_qloop_185*tmp_qloop_196 + tmp_qloop_194*tmp_qloop_299))*_data_q_w[q];
                const real_t q_tmp_7_9 = (tmp_qloop_122*(tmp_qloop_185*tmp_qloop_205 + tmp_qloop_206*tmp_qloop_299) + tmp_qloop_181*(tmp_qloop_185*tmp_qloop_203 + tmp_qloop_202*tmp_qloop_299))*_data_q_w[q];
                const real_t q_tmp_7_10 = (tmp_qloop_141*(tmp_qloop_185*tmp_qloop_211 + tmp_qloop_212*tmp_qloop_299) + tmp_qloop_182*(tmp_qloop_185*tmp_qloop_209 + tmp_qloop_208*tmp_qloop_299))*_data_q_w[q];
                const real_t q_tmp_7_11 = (tmp_qloop_160*(tmp_qloop_185*tmp_qloop_217 + tmp_qloop_218*tmp_qloop_299) + tmp_qloop_183*(tmp_qloop_185*tmp_qloop_215 + tmp_qloop_214*tmp_qloop_299))*_data_q_w[q];
                const real_t q_tmp_8_8 = (tmp_qloop_103*(tmp_qloop_221*tmp_qloop_226 + tmp_qloop_223*tmp_qloop_300) + tmp_qloop_180*(tmp_qloop_220*tmp_qloop_300 + tmp_qloop_227))*_data_q_w[q];
                const real_t q_tmp_8_9 = (tmp_qloop_122*(tmp_qloop_221*tmp_qloop_235 + tmp_qloop_236*tmp_qloop_300) + tmp_qloop_181*(tmp_qloop_221*tmp_qloop_232 + tmp_qloop_230*tmp_qloop_300))*_data_q_w[q];
                const real_t q_tmp_8_10 = (tmp_qloop_141*(tmp_qloop_221*tmp_qloop_241 + tmp_qloop_242*tmp_qloop_300) + tmp_qloop_182*(tmp_qloop_221*tmp_qloop_239 + tmp_qloop_238*tmp_qloop_300))*_data_q_w[q];
                const real_t q_tmp_8_11 = (tmp_qloop_160*(tmp_qloop_221*tmp_qloop_247 + tmp_qloop_248*tmp_qloop_300) + tmp_qloop_183*(tmp_qloop_221*tmp_qloop_245 + tmp_qloop_244*tmp_qloop_300))*_data_q_w[q];
                const real_t q_tmp_9_9 = (tmp_qloop_122*(tmp_qloop_251*tmp_qloop_256 + tmp_qloop_253*tmp_qloop_301) + tmp_qloop_181*(tmp_qloop_250*tmp_qloop_301 + tmp_qloop_257))*_data_q_w[q];
                const real_t q_tmp_9_10 = (tmp_qloop_141*(tmp_qloop_251*tmp_qloop_265 + tmp_qloop_266*tmp_qloop_301) + tmp_qloop_182*(tmp_qloop_251*tmp_qloop_262 + tmp_qloop_260*tmp_qloop_301))*_data_q_w[q];
                const real_t q_tmp_9_11 = (tmp_qloop_160*(tmp_qloop_251*tmp_qloop_271 + tmp_qloop_272*tmp_qloop_301) + tmp_qloop_183*(tmp_qloop_251*tmp_qloop_269 + tmp_qloop_268*tmp_qloop_301))*_data_q_w[q];
                const real_t q_tmp_10_10 = (tmp_qloop_141*(tmp_qloop_275*tmp_qloop_280 + tmp_qloop_277*tmp_qloop_302) + tmp_qloop_182*(tmp_qloop_274*tmp_qloop_302 + tmp_qloop_281))*_data_q_w[q];
                const real_t q_tmp_10_11 = (tmp_qloop_160*(tmp_qloop_275*tmp_qloop_287 + tmp_qloop_288*tmp_qloop_302) + tmp_qloop_183*(tmp_qloop_275*tmp_qloop_285 + tmp_qloop_283*tmp_qloop_302))*_data_q_w[q];
                const real_t q_tmp_11_11 = (tmp_qloop_160*(tmp_qloop_291*tmp_qloop_295 + tmp_qloop_292*tmp_qloop_303) + tmp_qloop_183*(tmp_qloop_290*tmp_qloop_303 + tmp_qloop_296))*_data_q_w[q];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_10*src_dof_10 + q_acc_0_11*src_dof_11 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_10*src_dof_10 + q_acc_1_11*src_dof_11 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_10*src_dof_10 + q_acc_2_11*src_dof_11 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_10*src_dof_10 + q_acc_3_11*src_dof_11 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_10*src_dof_10 + q_acc_4_11*src_dof_11 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
             const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_10*src_dof_10 + q_acc_5_11*src_dof_11 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
             const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_10*src_dof_10 + q_acc_6_11*src_dof_11 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
             const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_10*src_dof_10 + q_acc_7_11*src_dof_11 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
             const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_10*src_dof_10 + q_acc_8_11*src_dof_11 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
             const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_10*src_dof_10 + q_acc_9_11*src_dof_11 + q_acc_9_9*src_dof_9;
             const real_t elMatVec_10 = q_acc_0_10*src_dof_0 + q_acc_10_10*src_dof_10 + q_acc_10_11*src_dof_11 + q_acc_1_10*src_dof_1 + q_acc_2_10*src_dof_2 + q_acc_3_10*src_dof_3 + q_acc_4_10*src_dof_4 + q_acc_5_10*src_dof_5 + q_acc_6_10*src_dof_6 + q_acc_7_10*src_dof_7 + q_acc_8_10*src_dof_8 + q_acc_9_10*src_dof_9;
             const real_t elMatVec_11 = q_acc_0_11*src_dof_0 + q_acc_10_11*src_dof_10 + q_acc_11_11*src_dof_11 + q_acc_1_11*src_dof_1 + q_acc_2_11*src_dof_2 + q_acc_3_11*src_dof_3 + q_acc_4_11*src_dof_4 + q_acc_5_11*src_dof_5 + q_acc_6_11*src_dof_6 + q_acc_7_11*src_dof_7 + q_acc_8_11*src_dof_8 + q_acc_9_11*src_dof_9;
             _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatVec_0 + _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatVec_1 + _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_2 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_3 + _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_4 + _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatVec_5 + _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatVec_6 + _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatVec_7 + _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_8 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_9 + _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_10 + _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatVec_11 + _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
          }
       }
       const real_t tmp_coords_jac_0_BLUE = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_4_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_0_0_BLUE = tmp_coords_jac_1_BLUE;
       const real_t p_affine_const_0_1_BLUE = tmp_coords_jac_2_BLUE;
       const real_t p_affine_const_1_0_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_1_1_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_4_BLUE;
       const real_t p_affine_const_2_0_BLUE = tmp_coords_jac_1_BLUE + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_2_1_BLUE = tmp_coords_jac_2_BLUE + tmp_coords_jac_4_BLUE;
       const real_t jac_affine_0_0_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_1_0_BLUE;
       const real_t jac_affine_0_1_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_2_0_BLUE;
       const real_t jac_affine_1_0_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_1_1_BLUE;
       const real_t jac_affine_1_1_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_2_1_BLUE;
       const real_t tmp_coords_jac_5_BLUE = jac_affine_0_0_BLUE*jac_affine_1_1_BLUE - jac_affine_0_1_BLUE*jac_affine_1_0_BLUE;
       const real_t tmp_coords_jac_6_BLUE = 1.0 / (tmp_coords_jac_5_BLUE);
       const real_t jac_affine_inv_0_0_BLUE = jac_affine_1_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_0_1_BLUE = -jac_affine_0_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_0_BLUE = -jac_affine_1_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_1_BLUE = jac_affine_0_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t abs_det_jac_affine_BLUE = abs(tmp_coords_jac_5_BLUE);
       {
          /* FaceType.BLUE */
          const real_t _data_phi_0_0_BLUE [] = {0.16666666666666674, 0.16666666666666666, 0.66666666666666663, 0.16666666666666671, 0.66666666666666663, 0.16666666666666666, 0.66666666666666674, 0.16666666666666666, 0.16666666666666666};
      
          const real_t _data_tabulated_and_untitled_0_0_BLUE [] = {((real_t)(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)), ((real_t)(abs_det_jac_affine_BLUE)), ((real_t)(jac_affine_inv_0_0_BLUE*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE*1.6666666666666665)), ((real_t)(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)), ((real_t)(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)), ((real_t)(abs_det_jac_affine_BLUE)), ((real_t)(jac_affine_inv_0_0_BLUE*1.6666666666666665)), ((real_t)(jac_affine_inv_1_0_BLUE*-0.33333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)), ((real_t)(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)), ((real_t)(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)), ((real_t)(abs_det_jac_affine_BLUE)), ((real_t)(jac_affine_inv_0_0_BLUE*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE*-0.33333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_0_1_BLUE [] = {0.0, ((real_t)(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_BLUE*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE*1.6666666666666665)), ((real_t)(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)), ((real_t)(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_BLUE*1.6666666666666665)), ((real_t)(jac_affine_inv_1_0_BLUE*-0.33333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)), ((real_t)(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)), ((real_t)(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)), ((real_t)(jac_affine_inv_0_0_BLUE*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE*-0.33333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_0_BLUE [] = {((real_t)(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE*1.6666666666666665)), ((real_t)(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)), ((real_t)(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE*1.6666666666666665)), ((real_t)(jac_affine_inv_1_1_BLUE*-0.33333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)), ((real_t)(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)), ((real_t)(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)), ((real_t)(jac_affine_inv_0_1_BLUE*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE*-0.33333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_BLUE [] = {0.0, ((real_t)(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE*1.6666666666666665)), ((real_t)(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)), ((real_t)(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE*1.6666666666666665)), ((real_t)(jac_affine_inv_1_1_BLUE*-0.33333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)), ((real_t)(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)), ((real_t)(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)), ((real_t)(jac_affine_inv_0_1_BLUE*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE*-0.33333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663))};
      
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1));
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1));
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1));
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1));
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*((real_t)(ctr_1 + 1));
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*((real_t)(ctr_0 + 1)) + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*((real_t)(ctr_1 + 1));
             const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t src_dof_3 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t src_dof_6 = _data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t src_dof_7 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t src_dof_8 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t src_dof_9 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t src_dof_10 = _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t src_dof_11 = _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t mu_dof_1 = _data_mu[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t mu_dof_2 = _data_mu[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t nx_rotation_dof_0 = _data_nx_rotationVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t nx_rotation_dof_1 = _data_nx_rotationVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t nx_rotation_dof_2 = _data_nx_rotationVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t nx_rotation_dof_3 = _data_nx_rotationEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t nx_rotation_dof_4 = _data_nx_rotationEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t nx_rotation_dof_5 = _data_nx_rotationEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             const real_t ny_rotation_dof_0 = _data_ny_rotationVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             const real_t ny_rotation_dof_1 = _data_ny_rotationVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t ny_rotation_dof_2 = _data_ny_rotationVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             const real_t ny_rotation_dof_3 = _data_ny_rotationEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             const real_t ny_rotation_dof_4 = _data_ny_rotationEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             const real_t ny_rotation_dof_5 = _data_ny_rotationEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_4_10 = 0.0;
             real_t q_acc_4_11 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_5_10 = 0.0;
             real_t q_acc_5_11 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_6_10 = 0.0;
             real_t q_acc_6_11 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_7_10 = 0.0;
             real_t q_acc_7_11 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_8_10 = 0.0;
             real_t q_acc_8_11 = 0.0;
             real_t q_acc_9_9 = 0.0;
             real_t q_acc_9_10 = 0.0;
             real_t q_acc_9_11 = 0.0;
             real_t q_acc_10_10 = 0.0;
             real_t q_acc_10_11 = 0.0;
             real_t q_acc_11_11 = 0.0;
             const bool tmp_qloop_37 = pow((nx_rotation_dof_0*nx_rotation_dof_0) + (ny_rotation_dof_0*ny_rotation_dof_0), 0.50000000000000000) > 0.5;
             const real_t tmp_qloop_38 = ((tmp_qloop_37) ? (nx_rotation_dof_0): (0.0));
             const real_t tmp_qloop_72 = ((tmp_qloop_37) ? (-ny_rotation_dof_0): (1.0));
             const bool tmp_qloop_80 = pow((nx_rotation_dof_1*nx_rotation_dof_1) + (ny_rotation_dof_1*ny_rotation_dof_1), 0.50000000000000000) > 0.5;
             const real_t tmp_qloop_81 = ((tmp_qloop_80) ? (nx_rotation_dof_1): (0.0));
             const real_t tmp_qloop_92 = ((tmp_qloop_80) ? (-ny_rotation_dof_1): (1.0));
             const bool tmp_qloop_102 = pow((nx_rotation_dof_2*nx_rotation_dof_2) + (ny_rotation_dof_2*ny_rotation_dof_2), 0.50000000000000000) > 0.5;
             const real_t tmp_qloop_103 = ((tmp_qloop_102) ? (nx_rotation_dof_2): (0.0));
             const real_t tmp_qloop_112 = ((tmp_qloop_102) ? (-ny_rotation_dof_2): (1.0));
             const bool tmp_qloop_121 = pow((nx_rotation_dof_3*nx_rotation_dof_3) + (ny_rotation_dof_3*ny_rotation_dof_3), 0.50000000000000000) > 0.5;
             const real_t tmp_qloop_122 = ((tmp_qloop_121) ? (nx_rotation_dof_3): (0.0));
             const real_t tmp_qloop_131 = ((tmp_qloop_121) ? (-ny_rotation_dof_3): (1.0));
             const bool tmp_qloop_140 = pow((nx_rotation_dof_4*nx_rotation_dof_4) + (ny_rotation_dof_4*ny_rotation_dof_4), 0.50000000000000000) > 0.5;
             const real_t tmp_qloop_141 = ((tmp_qloop_140) ? (nx_rotation_dof_4): (0.0));
             const real_t tmp_qloop_150 = ((tmp_qloop_140) ? (-ny_rotation_dof_4): (1.0));
             const bool tmp_qloop_159 = pow((nx_rotation_dof_5*nx_rotation_dof_5) + (ny_rotation_dof_5*ny_rotation_dof_5), 0.50000000000000000) > 0.5;
             const real_t tmp_qloop_160 = ((tmp_qloop_159) ? (nx_rotation_dof_5): (0.0));
             const real_t tmp_qloop_169 = ((tmp_qloop_159) ? (-ny_rotation_dof_5): (1.0));
             const real_t tmp_qloop_178 = ((tmp_qloop_37) ? (ny_rotation_dof_0): (1.0));
             const real_t tmp_qloop_179 = ((tmp_qloop_80) ? (ny_rotation_dof_1): (1.0));
             const real_t tmp_qloop_180 = ((tmp_qloop_102) ? (ny_rotation_dof_2): (1.0));
             const real_t tmp_qloop_181 = ((tmp_qloop_121) ? (ny_rotation_dof_3): (1.0));
             const real_t tmp_qloop_182 = ((tmp_qloop_140) ? (ny_rotation_dof_4): (1.0));
             const real_t tmp_qloop_183 = ((tmp_qloop_159) ? (ny_rotation_dof_5): (1.0));
             for (int64_t q = 0; q < 3; q += 1)
             {
                const real_t tmp_qloop_0 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q];
                const real_t tmp_qloop_2 = (tmp_qloop_0*tmp_qloop_0);
                const real_t tmp_qloop_3 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q];
                const real_t tmp_qloop_4 = (tmp_qloop_3*tmp_qloop_3);
                const real_t tmp_qloop_5 = tmp_qloop_2 + tmp_qloop_4;
                const real_t tmp_qloop_6 = pow(tmp_qloop_5, -0.50000000000000000);
                const real_t tmp_qloop_13 = tmp_qloop_12*tmp_qloop_6;
                const real_t tmp_qloop_14 = tmp_qloop_1*tmp_qloop_13;
                const real_t tmp_qloop_15 = pow(tmp_qloop_5, -1.5000000000000000);
                const real_t tmp_qloop_16 = radRayVertex + tmp_qloop_11*(tmp_qloop_1*(-rayVertex_0 + tmp_qloop_0) - tmp_qloop_8*(-rayVertex_1 + tmp_qloop_3));
                const real_t tmp_qloop_17 = tmp_qloop_15*tmp_qloop_16;
                const real_t tmp_qloop_18 = tmp_qloop_17*1.0;
                const real_t tmp_qloop_19 = tmp_qloop_13*tmp_qloop_8;
                const real_t tmp_qloop_20 = tmp_qloop_0*tmp_qloop_18;
                const real_t tmp_qloop_23 = tmp_qloop_12*tmp_qloop_15;
                const real_t tmp_qloop_24 = tmp_qloop_1*tmp_qloop_23;
                const real_t tmp_qloop_25 = tmp_qloop_2*tmp_qloop_24;
                const real_t tmp_qloop_26 = tmp_qloop_16*pow(tmp_qloop_5, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_27 = tmp_qloop_0*tmp_qloop_26*tmp_qloop_4;
                const real_t tmp_qloop_28 = tmp_qloop_24*tmp_qloop_4 - tmp_qloop_27;
                const real_t tmp_qloop_29 = tmp_qloop_23*tmp_qloop_7;
                const real_t tmp_qloop_30 = tmp_qloop_0*tmp_qloop_3;
                const real_t tmp_qloop_31 = tmp_qloop_24*tmp_qloop_30;
                const real_t tmp_qloop_32 = tmp_qloop_17*2.0;
                const real_t tmp_qloop_33 = tmp_qloop_2*tmp_qloop_26*tmp_qloop_3;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_3 - tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_29*tmp_qloop_30;
                const real_t tmp_qloop_36 = tmp_qloop_23*tmp_qloop_30*tmp_qloop_8;
                const real_t tmp_qloop_42 = mu_dof_0*2.0*_data_phi_0_0_BLUE[3*q] + mu_dof_1*2.0*_data_phi_0_0_BLUE[3*q + 1] + mu_dof_2*2.0*_data_phi_0_0_BLUE[3*q + 2];
                const real_t tmp_qloop_52 = tmp_qloop_42*0.5;
                const real_t tmp_qloop_69 = tmp_qloop_42*2.0;
                const real_t jac_blending_0_0 = tmp_qloop_0*tmp_qloop_14 + tmp_qloop_18*tmp_qloop_4;
                const real_t jac_blending_0_1 = tmp_qloop_0*tmp_qloop_15*tmp_qloop_16*tmp_qloop_3*-1.0 - tmp_qloop_0*tmp_qloop_19;
                const real_t jac_blending_1_0 = tmp_qloop_14*tmp_qloop_3 - tmp_qloop_20*tmp_qloop_3;
                const real_t jac_blending_1_1 = tmp_qloop_15*tmp_qloop_16*tmp_qloop_2*1.0 - tmp_qloop_19*tmp_qloop_3;
                const real_t tmp_qloop_21 = jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0;
                const real_t tmp_qloop_22 = 1.0 / (tmp_qloop_21);
                const real_t abs_det_jac_blending = tmp_qloop_21;
                const real_t tmp_qloop_54 = abs_det_jac_blending*_data_tabulated_and_untitled_0_0_BLUE[8*q + 1];
                const real_t tmp_qloop_55 = tmp_qloop_38*tmp_qloop_54;
                const real_t tmp_qloop_73 = tmp_qloop_54*tmp_qloop_72;
                const real_t tmp_qloop_185 = tmp_qloop_54*tmp_qloop_81;
                const real_t tmp_qloop_188 = tmp_qloop_54*tmp_qloop_92;
                const real_t tmp_qloop_221 = tmp_qloop_103*tmp_qloop_54;
                const real_t tmp_qloop_224 = tmp_qloop_112*tmp_qloop_54;
                const real_t tmp_qloop_251 = tmp_qloop_122*tmp_qloop_54;
                const real_t tmp_qloop_254 = tmp_qloop_131*tmp_qloop_54;
                const real_t tmp_qloop_275 = tmp_qloop_141*tmp_qloop_54;
                const real_t tmp_qloop_278 = tmp_qloop_150*tmp_qloop_54;
                const real_t tmp_qloop_291 = tmp_qloop_160*tmp_qloop_54;
                const real_t tmp_qloop_293 = tmp_qloop_169*tmp_qloop_54;
                const real_t tmp_qloop_298 = tmp_qloop_178*tmp_qloop_54;
                const real_t tmp_qloop_299 = tmp_qloop_179*tmp_qloop_54;
                const real_t tmp_qloop_300 = tmp_qloop_180*tmp_qloop_54;
                const real_t tmp_qloop_301 = tmp_qloop_181*tmp_qloop_54;
                const real_t tmp_qloop_302 = tmp_qloop_182*tmp_qloop_54;
                const real_t tmp_qloop_303 = tmp_qloop_183*tmp_qloop_54;
                const real_t jac_blending_inv_0_0 = jac_blending_1_1*tmp_qloop_22;
                const real_t tmp_qloop_39 = jac_blending_inv_0_0*1.0;
                const real_t tmp_qloop_47 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE[7*q + 1];
                const real_t tmp_qloop_64 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE[7*q];
                const real_t tmp_qloop_83 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE[7*q + 2];
                const real_t tmp_qloop_105 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE[7*q + 3];
                const real_t tmp_qloop_124 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE[7*q + 4];
                const real_t tmp_qloop_143 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE[7*q + 5];
                const real_t tmp_qloop_162 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE[7*q + 6];
                const real_t jac_blending_inv_0_1 = -jac_blending_0_1*tmp_qloop_22;
                const real_t tmp_qloop_44 = jac_blending_inv_0_1*1.0;
                const real_t tmp_qloop_49 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE[8*q + 7];
                const real_t tmp_qloop_62 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE[8*q];
                const real_t tmp_qloop_94 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE[8*q + 2];
                const real_t tmp_qloop_114 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE[8*q + 3];
                const real_t tmp_qloop_133 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE[8*q + 4];
                const real_t tmp_qloop_152 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE[8*q + 5];
                const real_t tmp_qloop_171 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE[8*q + 6];
                const real_t jac_blending_inv_1_0 = -jac_blending_1_0*tmp_qloop_22;
                const real_t tmp_qloop_40 = jac_blending_inv_1_0*1.0;
                const real_t tmp_qloop_41 = tmp_qloop_39*_data_tabulated_and_untitled_0_0_BLUE[8*q + 7] + tmp_qloop_40*_data_tabulated_and_untitled_1_0_BLUE[7*q + 6];
                const real_t tmp_qloop_43 = (tmp_qloop_41*tmp_qloop_41)*tmp_qloop_42;
                const real_t tmp_qloop_48 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE[7*q + 1];
                const real_t tmp_qloop_56 = tmp_qloop_39*_data_tabulated_and_untitled_0_0_BLUE[8*q] + tmp_qloop_40*_data_tabulated_and_untitled_1_0_BLUE[7*q];
                const real_t tmp_qloop_57 = tmp_qloop_42*tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_41*tmp_qloop_57;
                const real_t tmp_qloop_65 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE[7*q];
                const real_t tmp_qloop_66 = tmp_qloop_64*0.5 + tmp_qloop_65*0.5;
                const real_t tmp_qloop_76 = tmp_qloop_64 + tmp_qloop_65;
                const real_t tmp_qloop_84 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE[7*q + 2];
                const real_t tmp_qloop_93 = tmp_qloop_39*_data_tabulated_and_untitled_0_0_BLUE[8*q + 2] + tmp_qloop_40*_data_tabulated_and_untitled_1_0_BLUE[7*q + 1];
                const real_t tmp_qloop_98 = tmp_qloop_41*tmp_qloop_42;
                const real_t tmp_qloop_99 = tmp_qloop_93*tmp_qloop_98;
                const real_t tmp_qloop_106 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE[7*q + 3];
                const real_t tmp_qloop_113 = tmp_qloop_39*_data_tabulated_and_untitled_0_0_BLUE[8*q + 3] + tmp_qloop_40*_data_tabulated_and_untitled_1_0_BLUE[7*q + 2];
                const real_t tmp_qloop_118 = tmp_qloop_113*tmp_qloop_98;
                const real_t tmp_qloop_125 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE[7*q + 4];
                const real_t tmp_qloop_132 = tmp_qloop_39*_data_tabulated_and_untitled_0_0_BLUE[8*q + 4] + tmp_qloop_40*_data_tabulated_and_untitled_1_0_BLUE[7*q + 3];
                const real_t tmp_qloop_137 = tmp_qloop_132*tmp_qloop_98;
                const real_t tmp_qloop_144 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE[7*q + 5];
                const real_t tmp_qloop_151 = tmp_qloop_39*_data_tabulated_and_untitled_0_0_BLUE[8*q + 5] + tmp_qloop_40*_data_tabulated_and_untitled_1_0_BLUE[7*q + 4];
                const real_t tmp_qloop_156 = tmp_qloop_151*tmp_qloop_98;
                const real_t tmp_qloop_163 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE[7*q + 6];
                const real_t tmp_qloop_170 = tmp_qloop_39*_data_tabulated_and_untitled_0_0_BLUE[8*q + 6] + tmp_qloop_40*_data_tabulated_and_untitled_1_0_BLUE[7*q + 5];
                const real_t tmp_qloop_175 = tmp_qloop_170*tmp_qloop_98;
                const real_t tmp_qloop_198 = tmp_qloop_42*tmp_qloop_93;
                const real_t tmp_qloop_234 = tmp_qloop_113*tmp_qloop_42;
                const real_t tmp_qloop_264 = tmp_qloop_132*tmp_qloop_42;
                const real_t jac_blending_inv_1_1 = jac_blending_0_0*tmp_qloop_22;
                const real_t tmp_qloop_45 = jac_blending_inv_1_1*1.0;
                const real_t tmp_qloop_46 = tmp_qloop_44*_data_tabulated_and_untitled_0_1_BLUE[7*q + 1] + tmp_qloop_45*_data_tabulated_and_untitled_1_1_BLUE[7*q + 1];
                const real_t tmp_qloop_50 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE[7*q + 6];
                const real_t tmp_qloop_51 = tmp_qloop_49 + tmp_qloop_50;
                const real_t tmp_qloop_53 = tmp_qloop_42*(tmp_qloop_46*tmp_qloop_46) + tmp_qloop_43 + tmp_qloop_52*((tmp_qloop_47 + tmp_qloop_48 + tmp_qloop_51)*(tmp_qloop_47 + tmp_qloop_48 + tmp_qloop_51));
                const real_t tmp_qloop_59 = tmp_qloop_44*_data_tabulated_and_untitled_0_1_BLUE[7*q] + tmp_qloop_45*_data_tabulated_and_untitled_1_1_BLUE[7*q];
                const real_t tmp_qloop_60 = tmp_qloop_42*tmp_qloop_46;
                const real_t tmp_qloop_61 = tmp_qloop_59*tmp_qloop_60;
                const real_t tmp_qloop_63 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE[7*q];
                const real_t tmp_qloop_67 = tmp_qloop_62*0.5 + tmp_qloop_63*0.5 + tmp_qloop_66;
                const real_t tmp_qloop_68 = tmp_qloop_49*0.5 + tmp_qloop_50*0.5;
                const real_t tmp_qloop_70 = tmp_qloop_69*(tmp_qloop_47*0.5 + tmp_qloop_48*0.5 + tmp_qloop_68);
                const real_t tmp_qloop_71 = tmp_qloop_58 + tmp_qloop_61 + tmp_qloop_67*tmp_qloop_70;
                const real_t tmp_qloop_74 = tmp_qloop_53*tmp_qloop_55 + tmp_qloop_71*tmp_qloop_73;
                const real_t tmp_qloop_75 = tmp_qloop_42*(tmp_qloop_59*tmp_qloop_59);
                const real_t tmp_qloop_77 = tmp_qloop_42*(tmp_qloop_56*tmp_qloop_56) + tmp_qloop_52*((tmp_qloop_62 + tmp_qloop_63 + tmp_qloop_76)*(tmp_qloop_62 + tmp_qloop_63 + tmp_qloop_76)) + tmp_qloop_75;
                const real_t tmp_qloop_78 = tmp_qloop_55*tmp_qloop_71;
                const real_t tmp_qloop_79 = tmp_qloop_73*tmp_qloop_77 + tmp_qloop_78;
                const real_t tmp_qloop_82 = tmp_qloop_44*_data_tabulated_and_untitled_0_1_BLUE[7*q + 2] + tmp_qloop_45*_data_tabulated_and_untitled_1_1_BLUE[7*q + 2];
                const real_t tmp_qloop_85 = tmp_qloop_68 + tmp_qloop_83*0.5 + tmp_qloop_84*0.5;
                const real_t tmp_qloop_86 = tmp_qloop_43 + tmp_qloop_60*tmp_qloop_82 + tmp_qloop_70*tmp_qloop_85;
                const real_t tmp_qloop_87 = tmp_qloop_42*tmp_qloop_59;
                const real_t tmp_qloop_88 = tmp_qloop_82*tmp_qloop_87;
                const real_t tmp_qloop_89 = tmp_qloop_67*tmp_qloop_69;
                const real_t tmp_qloop_90 = tmp_qloop_58 + tmp_qloop_85*tmp_qloop_89 + tmp_qloop_88;
                const real_t tmp_qloop_91 = tmp_qloop_55*tmp_qloop_86 + tmp_qloop_73*tmp_qloop_90;
                const real_t tmp_qloop_95 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE[7*q + 1];
                const real_t tmp_qloop_96 = tmp_qloop_66 + tmp_qloop_94*0.5 + tmp_qloop_95*0.5;
                const real_t tmp_qloop_97 = tmp_qloop_57*tmp_qloop_93 + tmp_qloop_75 + tmp_qloop_89*tmp_qloop_96;
                const real_t tmp_qloop_100 = tmp_qloop_61 + tmp_qloop_70*tmp_qloop_96 + tmp_qloop_99;
                const real_t tmp_qloop_101 = tmp_qloop_100*tmp_qloop_55 + tmp_qloop_73*tmp_qloop_97;
                const real_t tmp_qloop_104 = tmp_qloop_44*_data_tabulated_and_untitled_0_1_BLUE[7*q + 3] + tmp_qloop_45*_data_tabulated_and_untitled_1_1_BLUE[7*q + 3];
                const real_t tmp_qloop_107 = tmp_qloop_105*0.5 + tmp_qloop_106*0.5 + tmp_qloop_68;
                const real_t tmp_qloop_108 = tmp_qloop_104*tmp_qloop_60 + tmp_qloop_107*tmp_qloop_70 + tmp_qloop_43;
                const real_t tmp_qloop_109 = tmp_qloop_104*tmp_qloop_87;
                const real_t tmp_qloop_110 = tmp_qloop_107*tmp_qloop_89 + tmp_qloop_109 + tmp_qloop_58;
                const real_t tmp_qloop_111 = tmp_qloop_108*tmp_qloop_55 + tmp_qloop_110*tmp_qloop_73;
                const real_t tmp_qloop_115 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE[7*q + 2];
                const real_t tmp_qloop_116 = tmp_qloop_114*0.5 + tmp_qloop_115*0.5 + tmp_qloop_66;
                const real_t tmp_qloop_117 = tmp_qloop_113*tmp_qloop_57 + tmp_qloop_116*tmp_qloop_89 + tmp_qloop_75;
                const real_t tmp_qloop_119 = tmp_qloop_116*tmp_qloop_70 + tmp_qloop_118 + tmp_qloop_61;
                const real_t tmp_qloop_120 = tmp_qloop_117*tmp_qloop_73 + tmp_qloop_119*tmp_qloop_55;
                const real_t tmp_qloop_123 = tmp_qloop_44*_data_tabulated_and_untitled_0_1_BLUE[7*q + 4] + tmp_qloop_45*_data_tabulated_and_untitled_1_1_BLUE[7*q + 4];
                const real_t tmp_qloop_126 = tmp_qloop_124*0.5 + tmp_qloop_125*0.5 + tmp_qloop_68;
                const real_t tmp_qloop_127 = tmp_qloop_123*tmp_qloop_60 + tmp_qloop_126*tmp_qloop_70 + tmp_qloop_43;
                const real_t tmp_qloop_128 = tmp_qloop_123*tmp_qloop_87;
                const real_t tmp_qloop_129 = tmp_qloop_126*tmp_qloop_89 + tmp_qloop_128 + tmp_qloop_58;
                const real_t tmp_qloop_130 = tmp_qloop_127*tmp_qloop_55 + tmp_qloop_129*tmp_qloop_73;
                const real_t tmp_qloop_134 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE[7*q + 3];
                const real_t tmp_qloop_135 = tmp_qloop_133*0.5 + tmp_qloop_134*0.5 + tmp_qloop_66;
                const real_t tmp_qloop_136 = tmp_qloop_132*tmp_qloop_57 + tmp_qloop_135*tmp_qloop_89 + tmp_qloop_75;
                const real_t tmp_qloop_138 = tmp_qloop_135*tmp_qloop_70 + tmp_qloop_137 + tmp_qloop_61;
                const real_t tmp_qloop_139 = tmp_qloop_136*tmp_qloop_73 + tmp_qloop_138*tmp_qloop_55;
                const real_t tmp_qloop_142 = tmp_qloop_44*_data_tabulated_and_untitled_0_1_BLUE[7*q + 5] + tmp_qloop_45*_data_tabulated_and_untitled_1_1_BLUE[7*q + 5];
                const real_t tmp_qloop_145 = tmp_qloop_143*0.5 + tmp_qloop_144*0.5 + tmp_qloop_68;
                const real_t tmp_qloop_146 = tmp_qloop_142*tmp_qloop_60 + tmp_qloop_145*tmp_qloop_70 + tmp_qloop_43;
                const real_t tmp_qloop_147 = tmp_qloop_142*tmp_qloop_87;
                const real_t tmp_qloop_148 = tmp_qloop_145*tmp_qloop_89 + tmp_qloop_147 + tmp_qloop_58;
                const real_t tmp_qloop_149 = tmp_qloop_146*tmp_qloop_55 + tmp_qloop_148*tmp_qloop_73;
                const real_t tmp_qloop_153 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE[7*q + 4];
                const real_t tmp_qloop_154 = tmp_qloop_152*0.5 + tmp_qloop_153*0.5 + tmp_qloop_66;
                const real_t tmp_qloop_155 = tmp_qloop_151*tmp_qloop_57 + tmp_qloop_154*tmp_qloop_89 + tmp_qloop_75;
                const real_t tmp_qloop_157 = tmp_qloop_154*tmp_qloop_70 + tmp_qloop_156 + tmp_qloop_61;
                const real_t tmp_qloop_158 = tmp_qloop_155*tmp_qloop_73 + tmp_qloop_157*tmp_qloop_55;
                const real_t tmp_qloop_161 = tmp_qloop_44*_data_tabulated_and_untitled_0_1_BLUE[7*q + 6] + tmp_qloop_45*_data_tabulated_and_untitled_1_1_BLUE[7*q + 6];
                const real_t tmp_qloop_164 = tmp_qloop_162*0.5 + tmp_qloop_163*0.5 + tmp_qloop_68;
                const real_t tmp_qloop_165 = tmp_qloop_161*tmp_qloop_60 + tmp_qloop_164*tmp_qloop_70 + tmp_qloop_43;
                const real_t tmp_qloop_166 = tmp_qloop_161*tmp_qloop_87;
                const real_t tmp_qloop_167 = tmp_qloop_164*tmp_qloop_89 + tmp_qloop_166 + tmp_qloop_58;
                const real_t tmp_qloop_168 = tmp_qloop_165*tmp_qloop_55 + tmp_qloop_167*tmp_qloop_73;
                const real_t tmp_qloop_172 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE[7*q + 5];
                const real_t tmp_qloop_173 = tmp_qloop_171*0.5 + tmp_qloop_172*0.5 + tmp_qloop_66;
                const real_t tmp_qloop_174 = tmp_qloop_170*tmp_qloop_57 + tmp_qloop_173*tmp_qloop_89 + tmp_qloop_75;
                const real_t tmp_qloop_176 = tmp_qloop_173*tmp_qloop_70 + tmp_qloop_175 + tmp_qloop_61;
                const real_t tmp_qloop_177 = tmp_qloop_174*tmp_qloop_73 + tmp_qloop_176*tmp_qloop_55;
                const real_t tmp_qloop_184 = tmp_qloop_42*(tmp_qloop_82*tmp_qloop_82) + tmp_qloop_43 + tmp_qloop_52*((tmp_qloop_51 + tmp_qloop_83 + tmp_qloop_84)*(tmp_qloop_51 + tmp_qloop_83 + tmp_qloop_84));
                const real_t tmp_qloop_186 = tmp_qloop_69*tmp_qloop_85;
                const real_t tmp_qloop_187 = tmp_qloop_186*tmp_qloop_96 + tmp_qloop_88 + tmp_qloop_99;
                const real_t tmp_qloop_189 = tmp_qloop_184*tmp_qloop_185 + tmp_qloop_187*tmp_qloop_188;
                const real_t tmp_qloop_190 = tmp_qloop_42*(tmp_qloop_93*tmp_qloop_93) + tmp_qloop_52*((tmp_qloop_76 + tmp_qloop_94 + tmp_qloop_95)*(tmp_qloop_76 + tmp_qloop_94 + tmp_qloop_95)) + tmp_qloop_75;
                const real_t tmp_qloop_191 = tmp_qloop_185*tmp_qloop_187;
                const real_t tmp_qloop_192 = tmp_qloop_188*tmp_qloop_190 + tmp_qloop_191;
                const real_t tmp_qloop_193 = tmp_qloop_42*tmp_qloop_82;
                const real_t tmp_qloop_194 = tmp_qloop_104*tmp_qloop_193 + tmp_qloop_107*tmp_qloop_186 + tmp_qloop_43;
                const real_t tmp_qloop_195 = tmp_qloop_69*tmp_qloop_96;
                const real_t tmp_qloop_196 = tmp_qloop_107*tmp_qloop_195 + tmp_qloop_109 + tmp_qloop_99;
                const real_t tmp_qloop_197 = tmp_qloop_185*tmp_qloop_194 + tmp_qloop_188*tmp_qloop_196;
                const real_t tmp_qloop_199 = tmp_qloop_113*tmp_qloop_198 + tmp_qloop_116*tmp_qloop_195 + tmp_qloop_75;
                const real_t tmp_qloop_200 = tmp_qloop_116*tmp_qloop_186 + tmp_qloop_118 + tmp_qloop_88;
                const real_t tmp_qloop_201 = tmp_qloop_185*tmp_qloop_200 + tmp_qloop_188*tmp_qloop_199;
                const real_t tmp_qloop_202 = tmp_qloop_123*tmp_qloop_193 + tmp_qloop_126*tmp_qloop_186 + tmp_qloop_43;
                const real_t tmp_qloop_203 = tmp_qloop_126*tmp_qloop_195 + tmp_qloop_128 + tmp_qloop_99;
                const real_t tmp_qloop_204 = tmp_qloop_185*tmp_qloop_202 + tmp_qloop_188*tmp_qloop_203;
                const real_t tmp_qloop_205 = tmp_qloop_132*tmp_qloop_198 + tmp_qloop_135*tmp_qloop_195 + tmp_qloop_75;
                const real_t tmp_qloop_206 = tmp_qloop_135*tmp_qloop_186 + tmp_qloop_137 + tmp_qloop_88;
                const real_t tmp_qloop_207 = tmp_qloop_185*tmp_qloop_206 + tmp_qloop_188*tmp_qloop_205;
                const real_t tmp_qloop_208 = tmp_qloop_142*tmp_qloop_193 + tmp_qloop_145*tmp_qloop_186 + tmp_qloop_43;
                const real_t tmp_qloop_209 = tmp_qloop_145*tmp_qloop_195 + tmp_qloop_147 + tmp_qloop_99;
                const real_t tmp_qloop_210 = tmp_qloop_185*tmp_qloop_208 + tmp_qloop_188*tmp_qloop_209;
                const real_t tmp_qloop_211 = tmp_qloop_151*tmp_qloop_198 + tmp_qloop_154*tmp_qloop_195 + tmp_qloop_75;
                const real_t tmp_qloop_212 = tmp_qloop_154*tmp_qloop_186 + tmp_qloop_156 + tmp_qloop_88;
                const real_t tmp_qloop_213 = tmp_qloop_185*tmp_qloop_212 + tmp_qloop_188*tmp_qloop_211;
                const real_t tmp_qloop_214 = tmp_qloop_161*tmp_qloop_193 + tmp_qloop_164*tmp_qloop_186 + tmp_qloop_43;
                const real_t tmp_qloop_215 = tmp_qloop_164*tmp_qloop_195 + tmp_qloop_166 + tmp_qloop_99;
                const real_t tmp_qloop_216 = tmp_qloop_185*tmp_qloop_214 + tmp_qloop_188*tmp_qloop_215;
                const real_t tmp_qloop_217 = tmp_qloop_170*tmp_qloop_198 + tmp_qloop_173*tmp_qloop_195 + tmp_qloop_75;
                const real_t tmp_qloop_218 = tmp_qloop_173*tmp_qloop_186 + tmp_qloop_175 + tmp_qloop_88;
                const real_t tmp_qloop_219 = tmp_qloop_185*tmp_qloop_218 + tmp_qloop_188*tmp_qloop_217;
                const real_t tmp_qloop_220 = (tmp_qloop_104*tmp_qloop_104)*tmp_qloop_42 + tmp_qloop_43 + tmp_qloop_52*((tmp_qloop_105 + tmp_qloop_106 + tmp_qloop_51)*(tmp_qloop_105 + tmp_qloop_106 + tmp_qloop_51));
                const real_t tmp_qloop_222 = tmp_qloop_107*tmp_qloop_69;
                const real_t tmp_qloop_223 = tmp_qloop_109 + tmp_qloop_116*tmp_qloop_222 + tmp_qloop_118;
                const real_t tmp_qloop_225 = tmp_qloop_220*tmp_qloop_221 + tmp_qloop_223*tmp_qloop_224;
                const real_t tmp_qloop_226 = (tmp_qloop_113*tmp_qloop_113)*tmp_qloop_42 + tmp_qloop_52*((tmp_qloop_114 + tmp_qloop_115 + tmp_qloop_76)*(tmp_qloop_114 + tmp_qloop_115 + tmp_qloop_76)) + tmp_qloop_75;
                const real_t tmp_qloop_227 = tmp_qloop_221*tmp_qloop_223;
                const real_t tmp_qloop_228 = tmp_qloop_224*tmp_qloop_226 + tmp_qloop_227;
                const real_t tmp_qloop_229 = tmp_qloop_104*tmp_qloop_42;
                const real_t tmp_qloop_230 = tmp_qloop_123*tmp_qloop_229 + tmp_qloop_126*tmp_qloop_222 + tmp_qloop_43;
                const real_t tmp_qloop_231 = tmp_qloop_116*tmp_qloop_69;
                const real_t tmp_qloop_232 = tmp_qloop_118 + tmp_qloop_126*tmp_qloop_231 + tmp_qloop_128;
                const real_t tmp_qloop_233 = tmp_qloop_221*tmp_qloop_230 + tmp_qloop_224*tmp_qloop_232;
                const real_t tmp_qloop_235 = tmp_qloop_132*tmp_qloop_234 + tmp_qloop_135*tmp_qloop_231 + tmp_qloop_75;
                const real_t tmp_qloop_236 = tmp_qloop_109 + tmp_qloop_135*tmp_qloop_222 + tmp_qloop_137;
                const real_t tmp_qloop_237 = tmp_qloop_221*tmp_qloop_236 + tmp_qloop_224*tmp_qloop_235;
                const real_t tmp_qloop_238 = tmp_qloop_142*tmp_qloop_229 + tmp_qloop_145*tmp_qloop_222 + tmp_qloop_43;
                const real_t tmp_qloop_239 = tmp_qloop_118 + tmp_qloop_145*tmp_qloop_231 + tmp_qloop_147;
                const real_t tmp_qloop_240 = tmp_qloop_221*tmp_qloop_238 + tmp_qloop_224*tmp_qloop_239;
                const real_t tmp_qloop_241 = tmp_qloop_151*tmp_qloop_234 + tmp_qloop_154*tmp_qloop_231 + tmp_qloop_75;
                const real_t tmp_qloop_242 = tmp_qloop_109 + tmp_qloop_154*tmp_qloop_222 + tmp_qloop_156;
                const real_t tmp_qloop_243 = tmp_qloop_221*tmp_qloop_242 + tmp_qloop_224*tmp_qloop_241;
                const real_t tmp_qloop_244 = tmp_qloop_161*tmp_qloop_229 + tmp_qloop_164*tmp_qloop_222 + tmp_qloop_43;
                const real_t tmp_qloop_245 = tmp_qloop_118 + tmp_qloop_164*tmp_qloop_231 + tmp_qloop_166;
                const real_t tmp_qloop_246 = tmp_qloop_221*tmp_qloop_244 + tmp_qloop_224*tmp_qloop_245;
                const real_t tmp_qloop_247 = tmp_qloop_170*tmp_qloop_234 + tmp_qloop_173*tmp_qloop_231 + tmp_qloop_75;
                const real_t tmp_qloop_248 = tmp_qloop_109 + tmp_qloop_173*tmp_qloop_222 + tmp_qloop_175;
                const real_t tmp_qloop_249 = tmp_qloop_221*tmp_qloop_248 + tmp_qloop_224*tmp_qloop_247;
                const real_t tmp_qloop_250 = (tmp_qloop_123*tmp_qloop_123)*tmp_qloop_42 + tmp_qloop_43 + tmp_qloop_52*((tmp_qloop_124 + tmp_qloop_125 + tmp_qloop_51)*(tmp_qloop_124 + tmp_qloop_125 + tmp_qloop_51));
                const real_t tmp_qloop_252 = tmp_qloop_126*tmp_qloop_69;
                const real_t tmp_qloop_253 = tmp_qloop_128 + tmp_qloop_135*tmp_qloop_252 + tmp_qloop_137;
                const real_t tmp_qloop_255 = tmp_qloop_250*tmp_qloop_251 + tmp_qloop_253*tmp_qloop_254;
                const real_t tmp_qloop_256 = (tmp_qloop_132*tmp_qloop_132)*tmp_qloop_42 + tmp_qloop_52*((tmp_qloop_133 + tmp_qloop_134 + tmp_qloop_76)*(tmp_qloop_133 + tmp_qloop_134 + tmp_qloop_76)) + tmp_qloop_75;
                const real_t tmp_qloop_257 = tmp_qloop_251*tmp_qloop_253;
                const real_t tmp_qloop_258 = tmp_qloop_254*tmp_qloop_256 + tmp_qloop_257;
                const real_t tmp_qloop_259 = tmp_qloop_123*tmp_qloop_42;
                const real_t tmp_qloop_260 = tmp_qloop_142*tmp_qloop_259 + tmp_qloop_145*tmp_qloop_252 + tmp_qloop_43;
                const real_t tmp_qloop_261 = tmp_qloop_135*tmp_qloop_69;
                const real_t tmp_qloop_262 = tmp_qloop_137 + tmp_qloop_145*tmp_qloop_261 + tmp_qloop_147;
                const real_t tmp_qloop_263 = tmp_qloop_251*tmp_qloop_260 + tmp_qloop_254*tmp_qloop_262;
                const real_t tmp_qloop_265 = tmp_qloop_151*tmp_qloop_264 + tmp_qloop_154*tmp_qloop_261 + tmp_qloop_75;
                const real_t tmp_qloop_266 = tmp_qloop_128 + tmp_qloop_154*tmp_qloop_252 + tmp_qloop_156;
                const real_t tmp_qloop_267 = tmp_qloop_251*tmp_qloop_266 + tmp_qloop_254*tmp_qloop_265;
                const real_t tmp_qloop_268 = tmp_qloop_161*tmp_qloop_259 + tmp_qloop_164*tmp_qloop_252 + tmp_qloop_43;
                const real_t tmp_qloop_269 = tmp_qloop_137 + tmp_qloop_164*tmp_qloop_261 + tmp_qloop_166;
                const real_t tmp_qloop_270 = tmp_qloop_251*tmp_qloop_268 + tmp_qloop_254*tmp_qloop_269;
                const real_t tmp_qloop_271 = tmp_qloop_170*tmp_qloop_264 + tmp_qloop_173*tmp_qloop_261 + tmp_qloop_75;
                const real_t tmp_qloop_272 = tmp_qloop_128 + tmp_qloop_173*tmp_qloop_252 + tmp_qloop_175;
                const real_t tmp_qloop_273 = tmp_qloop_251*tmp_qloop_272 + tmp_qloop_254*tmp_qloop_271;
                const real_t tmp_qloop_274 = (tmp_qloop_142*tmp_qloop_142)*tmp_qloop_42 + tmp_qloop_43 + tmp_qloop_52*((tmp_qloop_143 + tmp_qloop_144 + tmp_qloop_51)*(tmp_qloop_143 + tmp_qloop_144 + tmp_qloop_51));
                const real_t tmp_qloop_276 = tmp_qloop_145*tmp_qloop_69;
                const real_t tmp_qloop_277 = tmp_qloop_147 + tmp_qloop_154*tmp_qloop_276 + tmp_qloop_156;
                const real_t tmp_qloop_279 = tmp_qloop_274*tmp_qloop_275 + tmp_qloop_277*tmp_qloop_278;
                const real_t tmp_qloop_280 = (tmp_qloop_151*tmp_qloop_151)*tmp_qloop_42 + tmp_qloop_52*((tmp_qloop_152 + tmp_qloop_153 + tmp_qloop_76)*(tmp_qloop_152 + tmp_qloop_153 + tmp_qloop_76)) + tmp_qloop_75;
                const real_t tmp_qloop_281 = tmp_qloop_275*tmp_qloop_277;
                const real_t tmp_qloop_282 = tmp_qloop_278*tmp_qloop_280 + tmp_qloop_281;
                const real_t tmp_qloop_283 = tmp_qloop_142*tmp_qloop_161*tmp_qloop_42 + tmp_qloop_164*tmp_qloop_276 + tmp_qloop_43;
                const real_t tmp_qloop_284 = tmp_qloop_154*tmp_qloop_69;
                const real_t tmp_qloop_285 = tmp_qloop_156 + tmp_qloop_164*tmp_qloop_284 + tmp_qloop_166;
                const real_t tmp_qloop_286 = tmp_qloop_275*tmp_qloop_283 + tmp_qloop_278*tmp_qloop_285;
                const real_t tmp_qloop_287 = tmp_qloop_151*tmp_qloop_170*tmp_qloop_42 + tmp_qloop_173*tmp_qloop_284 + tmp_qloop_75;
                const real_t tmp_qloop_288 = tmp_qloop_147 + tmp_qloop_173*tmp_qloop_276 + tmp_qloop_175;
                const real_t tmp_qloop_289 = tmp_qloop_275*tmp_qloop_288 + tmp_qloop_278*tmp_qloop_287;
                const real_t tmp_qloop_290 = (tmp_qloop_161*tmp_qloop_161)*tmp_qloop_42 + tmp_qloop_43 + tmp_qloop_52*((tmp_qloop_162 + tmp_qloop_163 + tmp_qloop_51)*(tmp_qloop_162 + tmp_qloop_163 + tmp_qloop_51));
                const real_t tmp_qloop_292 = tmp_qloop_164*tmp_qloop_173*tmp_qloop_69 + tmp_qloop_166 + tmp_qloop_175;
                const real_t tmp_qloop_294 = tmp_qloop_290*tmp_qloop_291 + tmp_qloop_292*tmp_qloop_293;
                const real_t tmp_qloop_295 = (tmp_qloop_170*tmp_qloop_170)*tmp_qloop_42 + tmp_qloop_52*((tmp_qloop_171 + tmp_qloop_172 + tmp_qloop_76)*(tmp_qloop_171 + tmp_qloop_172 + tmp_qloop_76)) + tmp_qloop_75;
                const real_t tmp_qloop_296 = tmp_qloop_291*tmp_qloop_292;
                const real_t tmp_qloop_297 = tmp_qloop_293*tmp_qloop_295 + tmp_qloop_296;
                const real_t hessian_blending_0_0_0 = tmp_qloop_14 - tmp_qloop_25 + tmp_qloop_28;
                const real_t hessian_blending_1_0_0 = -tmp_qloop_26*(tmp_qloop_3*tmp_qloop_3*tmp_qloop_3) + tmp_qloop_29*tmp_qloop_4 + tmp_qloop_3*tmp_qloop_32 - tmp_qloop_31;
                const real_t hessian_blending_0_0_1 = tmp_qloop_1*tmp_qloop_11*tmp_qloop_15*tmp_qloop_30*-2.0 - tmp_qloop_34;
                const real_t hessian_blending_1_0_1 = tmp_qloop_1*tmp_qloop_10*tmp_qloop_6*tmp_qloop_9*1.0 - tmp_qloop_20 - tmp_qloop_28 - tmp_qloop_35;
                const real_t hessian_blending_0_1_0 = tmp_qloop_10*tmp_qloop_15*tmp_qloop_2*tmp_qloop_8*tmp_qloop_9*1.0 - tmp_qloop_19 - tmp_qloop_31 - tmp_qloop_34;
                const real_t hessian_blending_1_1_0 = -tmp_qloop_20 + tmp_qloop_27 - tmp_qloop_35 + tmp_qloop_36;
                const real_t hessian_blending_0_1_1 = tmp_qloop_0*tmp_qloop_32 - (tmp_qloop_0*tmp_qloop_0*tmp_qloop_0)*tmp_qloop_26 + tmp_qloop_25 + tmp_qloop_36;
                const real_t hessian_blending_1_1_1 = tmp_qloop_10*tmp_qloop_15*tmp_qloop_2*tmp_qloop_7*tmp_qloop_9*1.0 + tmp_qloop_10*tmp_qloop_15*tmp_qloop_4*tmp_qloop_8*tmp_qloop_9*1.0 - tmp_qloop_19 - tmp_qloop_33;
                const real_t q_tmp_0_0 = (tmp_qloop_38*tmp_qloop_74 + tmp_qloop_72*tmp_qloop_79)*_data_q_w[q];
                const real_t q_tmp_0_1 = (tmp_qloop_101*tmp_qloop_92 + tmp_qloop_81*tmp_qloop_91)*_data_q_w[q];
                const real_t q_tmp_0_2 = (tmp_qloop_103*tmp_qloop_111 + tmp_qloop_112*tmp_qloop_120)*_data_q_w[q];
                const real_t q_tmp_0_3 = (tmp_qloop_122*tmp_qloop_130 + tmp_qloop_131*tmp_qloop_139)*_data_q_w[q];
                const real_t q_tmp_0_4 = (tmp_qloop_141*tmp_qloop_149 + tmp_qloop_150*tmp_qloop_158)*_data_q_w[q];
                const real_t q_tmp_0_5 = (tmp_qloop_160*tmp_qloop_168 + tmp_qloop_169*tmp_qloop_177)*_data_q_w[q];
                const real_t q_tmp_0_6 = (tmp_qloop_178*tmp_qloop_74 + tmp_qloop_38*tmp_qloop_79)*_data_q_w[q];
                const real_t q_tmp_0_7 = (tmp_qloop_101*tmp_qloop_81 + tmp_qloop_179*tmp_qloop_91)*_data_q_w[q];
                const real_t q_tmp_0_8 = (tmp_qloop_103*tmp_qloop_120 + tmp_qloop_111*tmp_qloop_180)*_data_q_w[q];
                const real_t q_tmp_0_9 = (tmp_qloop_122*tmp_qloop_139 + tmp_qloop_130*tmp_qloop_181)*_data_q_w[q];
                const real_t q_tmp_0_10 = (tmp_qloop_141*tmp_qloop_158 + tmp_qloop_149*tmp_qloop_182)*_data_q_w[q];
                const real_t q_tmp_0_11 = (tmp_qloop_160*tmp_qloop_177 + tmp_qloop_168*tmp_qloop_183)*_data_q_w[q];
                const real_t q_tmp_1_1 = (tmp_qloop_189*tmp_qloop_81 + tmp_qloop_192*tmp_qloop_92)*_data_q_w[q];
                const real_t q_tmp_1_2 = (tmp_qloop_103*tmp_qloop_197 + tmp_qloop_112*tmp_qloop_201)*_data_q_w[q];
                const real_t q_tmp_1_3 = (tmp_qloop_122*tmp_qloop_204 + tmp_qloop_131*tmp_qloop_207)*_data_q_w[q];
                const real_t q_tmp_1_4 = (tmp_qloop_141*tmp_qloop_210 + tmp_qloop_150*tmp_qloop_213)*_data_q_w[q];
                const real_t q_tmp_1_5 = (tmp_qloop_160*tmp_qloop_216 + tmp_qloop_169*tmp_qloop_219)*_data_q_w[q];
                const real_t q_tmp_1_6 = (tmp_qloop_178*(tmp_qloop_100*tmp_qloop_188 + tmp_qloop_185*tmp_qloop_86) + tmp_qloop_38*(tmp_qloop_185*tmp_qloop_90 + tmp_qloop_188*tmp_qloop_97))*_data_q_w[q];
                const real_t q_tmp_1_7 = (tmp_qloop_179*tmp_qloop_189 + tmp_qloop_192*tmp_qloop_81)*_data_q_w[q];
                const real_t q_tmp_1_8 = (tmp_qloop_103*tmp_qloop_201 + tmp_qloop_180*tmp_qloop_197)*_data_q_w[q];
                const real_t q_tmp_1_9 = (tmp_qloop_122*tmp_qloop_207 + tmp_qloop_181*tmp_qloop_204)*_data_q_w[q];
                const real_t q_tmp_1_10 = (tmp_qloop_141*tmp_qloop_213 + tmp_qloop_182*tmp_qloop_210)*_data_q_w[q];
                const real_t q_tmp_1_11 = (tmp_qloop_160*tmp_qloop_219 + tmp_qloop_183*tmp_qloop_216)*_data_q_w[q];
                const real_t q_tmp_2_2 = (tmp_qloop_103*tmp_qloop_225 + tmp_qloop_112*tmp_qloop_228)*_data_q_w[q];
                const real_t q_tmp_2_3 = (tmp_qloop_122*tmp_qloop_233 + tmp_qloop_131*tmp_qloop_237)*_data_q_w[q];
                const real_t q_tmp_2_4 = (tmp_qloop_141*tmp_qloop_240 + tmp_qloop_150*tmp_qloop_243)*_data_q_w[q];
                const real_t q_tmp_2_5 = (tmp_qloop_160*tmp_qloop_246 + tmp_qloop_169*tmp_qloop_249)*_data_q_w[q];
                const real_t q_tmp_2_6 = (tmp_qloop_178*(tmp_qloop_108*tmp_qloop_221 + tmp_qloop_119*tmp_qloop_224) + tmp_qloop_38*(tmp_qloop_110*tmp_qloop_221 + tmp_qloop_117*tmp_qloop_224))*_data_q_w[q];
                const real_t q_tmp_2_7 = (tmp_qloop_179*(tmp_qloop_194*tmp_qloop_221 + tmp_qloop_200*tmp_qloop_224) + tmp_qloop_81*(tmp_qloop_196*tmp_qloop_221 + tmp_qloop_199*tmp_qloop_224))*_data_q_w[q];
                const real_t q_tmp_2_8 = (tmp_qloop_103*tmp_qloop_228 + tmp_qloop_180*tmp_qloop_225)*_data_q_w[q];
                const real_t q_tmp_2_9 = (tmp_qloop_122*tmp_qloop_237 + tmp_qloop_181*tmp_qloop_233)*_data_q_w[q];
                const real_t q_tmp_2_10 = (tmp_qloop_141*tmp_qloop_243 + tmp_qloop_182*tmp_qloop_240)*_data_q_w[q];
                const real_t q_tmp_2_11 = (tmp_qloop_160*tmp_qloop_249 + tmp_qloop_183*tmp_qloop_246)*_data_q_w[q];
                const real_t q_tmp_3_3 = (tmp_qloop_122*tmp_qloop_255 + tmp_qloop_131*tmp_qloop_258)*_data_q_w[q];
                const real_t q_tmp_3_4 = (tmp_qloop_141*tmp_qloop_263 + tmp_qloop_150*tmp_qloop_267)*_data_q_w[q];
                const real_t q_tmp_3_5 = (tmp_qloop_160*tmp_qloop_270 + tmp_qloop_169*tmp_qloop_273)*_data_q_w[q];
                const real_t q_tmp_3_6 = (tmp_qloop_178*(tmp_qloop_127*tmp_qloop_251 + tmp_qloop_138*tmp_qloop_254) + tmp_qloop_38*(tmp_qloop_129*tmp_qloop_251 + tmp_qloop_136*tmp_qloop_254))*_data_q_w[q];
                const real_t q_tmp_3_7 = (tmp_qloop_179*(tmp_qloop_202*tmp_qloop_251 + tmp_qloop_206*tmp_qloop_254) + tmp_qloop_81*(tmp_qloop_203*tmp_qloop_251 + tmp_qloop_205*tmp_qloop_254))*_data_q_w[q];
                const real_t q_tmp_3_8 = (tmp_qloop_103*(tmp_qloop_232*tmp_qloop_251 + tmp_qloop_235*tmp_qloop_254) + tmp_qloop_180*(tmp_qloop_230*tmp_qloop_251 + tmp_qloop_236*tmp_qloop_254))*_data_q_w[q];
                const real_t q_tmp_3_9 = (tmp_qloop_122*tmp_qloop_258 + tmp_qloop_181*tmp_qloop_255)*_data_q_w[q];
                const real_t q_tmp_3_10 = (tmp_qloop_141*tmp_qloop_267 + tmp_qloop_182*tmp_qloop_263)*_data_q_w[q];
                const real_t q_tmp_3_11 = (tmp_qloop_160*tmp_qloop_273 + tmp_qloop_183*tmp_qloop_270)*_data_q_w[q];
                const real_t q_tmp_4_4 = (tmp_qloop_141*tmp_qloop_279 + tmp_qloop_150*tmp_qloop_282)*_data_q_w[q];
                const real_t q_tmp_4_5 = (tmp_qloop_160*tmp_qloop_286 + tmp_qloop_169*tmp_qloop_289)*_data_q_w[q];
                const real_t q_tmp_4_6 = (tmp_qloop_178*(tmp_qloop_146*tmp_qloop_275 + tmp_qloop_157*tmp_qloop_278) + tmp_qloop_38*(tmp_qloop_148*tmp_qloop_275 + tmp_qloop_155*tmp_qloop_278))*_data_q_w[q];
                const real_t q_tmp_4_7 = (tmp_qloop_179*(tmp_qloop_208*tmp_qloop_275 + tmp_qloop_212*tmp_qloop_278) + tmp_qloop_81*(tmp_qloop_209*tmp_qloop_275 + tmp_qloop_211*tmp_qloop_278))*_data_q_w[q];
                const real_t q_tmp_4_8 = (tmp_qloop_103*(tmp_qloop_239*tmp_qloop_275 + tmp_qloop_241*tmp_qloop_278) + tmp_qloop_180*(tmp_qloop_238*tmp_qloop_275 + tmp_qloop_242*tmp_qloop_278))*_data_q_w[q];
                const real_t q_tmp_4_9 = (tmp_qloop_122*(tmp_qloop_262*tmp_qloop_275 + tmp_qloop_265*tmp_qloop_278) + tmp_qloop_181*(tmp_qloop_260*tmp_qloop_275 + tmp_qloop_266*tmp_qloop_278))*_data_q_w[q];
                const real_t q_tmp_4_10 = (tmp_qloop_141*tmp_qloop_282 + tmp_qloop_182*tmp_qloop_279)*_data_q_w[q];
                const real_t q_tmp_4_11 = (tmp_qloop_160*tmp_qloop_289 + tmp_qloop_183*tmp_qloop_286)*_data_q_w[q];
                const real_t q_tmp_5_5 = (tmp_qloop_160*tmp_qloop_294 + tmp_qloop_169*tmp_qloop_297)*_data_q_w[q];
                const real_t q_tmp_5_6 = (tmp_qloop_178*(tmp_qloop_165*tmp_qloop_291 + tmp_qloop_176*tmp_qloop_293) + tmp_qloop_38*(tmp_qloop_167*tmp_qloop_291 + tmp_qloop_174*tmp_qloop_293))*_data_q_w[q];
                const real_t q_tmp_5_7 = (tmp_qloop_179*(tmp_qloop_214*tmp_qloop_291 + tmp_qloop_218*tmp_qloop_293) + tmp_qloop_81*(tmp_qloop_215*tmp_qloop_291 + tmp_qloop_217*tmp_qloop_293))*_data_q_w[q];
                const real_t q_tmp_5_8 = (tmp_qloop_103*(tmp_qloop_245*tmp_qloop_291 + tmp_qloop_247*tmp_qloop_293) + tmp_qloop_180*(tmp_qloop_244*tmp_qloop_291 + tmp_qloop_248*tmp_qloop_293))*_data_q_w[q];
                const real_t q_tmp_5_9 = (tmp_qloop_122*(tmp_qloop_269*tmp_qloop_291 + tmp_qloop_271*tmp_qloop_293) + tmp_qloop_181*(tmp_qloop_268*tmp_qloop_291 + tmp_qloop_272*tmp_qloop_293))*_data_q_w[q];
                const real_t q_tmp_5_10 = (tmp_qloop_141*(tmp_qloop_285*tmp_qloop_291 + tmp_qloop_287*tmp_qloop_293) + tmp_qloop_182*(tmp_qloop_283*tmp_qloop_291 + tmp_qloop_288*tmp_qloop_293))*_data_q_w[q];
                const real_t q_tmp_5_11 = (tmp_qloop_160*tmp_qloop_297 + tmp_qloop_183*tmp_qloop_294)*_data_q_w[q];
                const real_t q_tmp_6_6 = (tmp_qloop_178*(tmp_qloop_298*tmp_qloop_53 + tmp_qloop_78) + tmp_qloop_38*(tmp_qloop_298*tmp_qloop_71 + tmp_qloop_55*tmp_qloop_77))*_data_q_w[q];
                const real_t q_tmp_6_7 = (tmp_qloop_179*(tmp_qloop_298*tmp_qloop_86 + tmp_qloop_55*tmp_qloop_90) + tmp_qloop_81*(tmp_qloop_100*tmp_qloop_298 + tmp_qloop_55*tmp_qloop_97))*_data_q_w[q];
                const real_t q_tmp_6_8 = (tmp_qloop_103*(tmp_qloop_117*tmp_qloop_55 + tmp_qloop_119*tmp_qloop_298) + tmp_qloop_180*(tmp_qloop_108*tmp_qloop_298 + tmp_qloop_110*tmp_qloop_55))*_data_q_w[q];
                const real_t q_tmp_6_9 = (tmp_qloop_122*(tmp_qloop_136*tmp_qloop_55 + tmp_qloop_138*tmp_qloop_298) + tmp_qloop_181*(tmp_qloop_127*tmp_qloop_298 + tmp_qloop_129*tmp_qloop_55))*_data_q_w[q];
                const real_t q_tmp_6_10 = (tmp_qloop_141*(tmp_qloop_155*tmp_qloop_55 + tmp_qloop_157*tmp_qloop_298) + tmp_qloop_182*(tmp_qloop_146*tmp_qloop_298 + tmp_qloop_148*tmp_qloop_55))*_data_q_w[q];
                const real_t q_tmp_6_11 = (tmp_qloop_160*(tmp_qloop_174*tmp_qloop_55 + tmp_qloop_176*tmp_qloop_298) + tmp_qloop_183*(tmp_qloop_165*tmp_qloop_298 + tmp_qloop_167*tmp_qloop_55))*_data_q_w[q];
                const real_t q_tmp_7_7 = (tmp_qloop_179*(tmp_qloop_184*tmp_qloop_299 + tmp_qloop_191) + tmp_qloop_81*(tmp_qloop_185*tmp_qloop_190 + tmp_qloop_187*tmp_qloop_299))*_data_q_w[q];
                const real_t q_tmp_7_8 = (tmp_qloop_103*(tmp_qloop_185*tmp_qloop_199 + tmp_qloop_200*tmp_qloop_299) + tmp_qloop_180*(tmp_qloop_185*tmp_qloop_196 + tmp_qloop_194*tmp_qloop_299))*_data_q_w[q];
                const real_t q_tmp_7_9 = (tmp_qloop_122*(tmp_qloop_185*tmp_qloop_205 + tmp_qloop_206*tmp_qloop_299) + tmp_qloop_181*(tmp_qloop_185*tmp_qloop_203 + tmp_qloop_202*tmp_qloop_299))*_data_q_w[q];
                const real_t q_tmp_7_10 = (tmp_qloop_141*(tmp_qloop_185*tmp_qloop_211 + tmp_qloop_212*tmp_qloop_299) + tmp_qloop_182*(tmp_qloop_185*tmp_qloop_209 + tmp_qloop_208*tmp_qloop_299))*_data_q_w[q];
                const real_t q_tmp_7_11 = (tmp_qloop_160*(tmp_qloop_185*tmp_qloop_217 + tmp_qloop_218*tmp_qloop_299) + tmp_qloop_183*(tmp_qloop_185*tmp_qloop_215 + tmp_qloop_214*tmp_qloop_299))*_data_q_w[q];
                const real_t q_tmp_8_8 = (tmp_qloop_103*(tmp_qloop_221*tmp_qloop_226 + tmp_qloop_223*tmp_qloop_300) + tmp_qloop_180*(tmp_qloop_220*tmp_qloop_300 + tmp_qloop_227))*_data_q_w[q];
                const real_t q_tmp_8_9 = (tmp_qloop_122*(tmp_qloop_221*tmp_qloop_235 + tmp_qloop_236*tmp_qloop_300) + tmp_qloop_181*(tmp_qloop_221*tmp_qloop_232 + tmp_qloop_230*tmp_qloop_300))*_data_q_w[q];
                const real_t q_tmp_8_10 = (tmp_qloop_141*(tmp_qloop_221*tmp_qloop_241 + tmp_qloop_242*tmp_qloop_300) + tmp_qloop_182*(tmp_qloop_221*tmp_qloop_239 + tmp_qloop_238*tmp_qloop_300))*_data_q_w[q];
                const real_t q_tmp_8_11 = (tmp_qloop_160*(tmp_qloop_221*tmp_qloop_247 + tmp_qloop_248*tmp_qloop_300) + tmp_qloop_183*(tmp_qloop_221*tmp_qloop_245 + tmp_qloop_244*tmp_qloop_300))*_data_q_w[q];
                const real_t q_tmp_9_9 = (tmp_qloop_122*(tmp_qloop_251*tmp_qloop_256 + tmp_qloop_253*tmp_qloop_301) + tmp_qloop_181*(tmp_qloop_250*tmp_qloop_301 + tmp_qloop_257))*_data_q_w[q];
                const real_t q_tmp_9_10 = (tmp_qloop_141*(tmp_qloop_251*tmp_qloop_265 + tmp_qloop_266*tmp_qloop_301) + tmp_qloop_182*(tmp_qloop_251*tmp_qloop_262 + tmp_qloop_260*tmp_qloop_301))*_data_q_w[q];
                const real_t q_tmp_9_11 = (tmp_qloop_160*(tmp_qloop_251*tmp_qloop_271 + tmp_qloop_272*tmp_qloop_301) + tmp_qloop_183*(tmp_qloop_251*tmp_qloop_269 + tmp_qloop_268*tmp_qloop_301))*_data_q_w[q];
                const real_t q_tmp_10_10 = (tmp_qloop_141*(tmp_qloop_275*tmp_qloop_280 + tmp_qloop_277*tmp_qloop_302) + tmp_qloop_182*(tmp_qloop_274*tmp_qloop_302 + tmp_qloop_281))*_data_q_w[q];
                const real_t q_tmp_10_11 = (tmp_qloop_160*(tmp_qloop_275*tmp_qloop_287 + tmp_qloop_288*tmp_qloop_302) + tmp_qloop_183*(tmp_qloop_275*tmp_qloop_285 + tmp_qloop_283*tmp_qloop_302))*_data_q_w[q];
                const real_t q_tmp_11_11 = (tmp_qloop_160*(tmp_qloop_291*tmp_qloop_295 + tmp_qloop_292*tmp_qloop_303) + tmp_qloop_183*(tmp_qloop_290*tmp_qloop_303 + tmp_qloop_296))*_data_q_w[q];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_10*src_dof_10 + q_acc_0_11*src_dof_11 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_10*src_dof_10 + q_acc_1_11*src_dof_11 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_10*src_dof_10 + q_acc_2_11*src_dof_11 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_10*src_dof_10 + q_acc_3_11*src_dof_11 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_10*src_dof_10 + q_acc_4_11*src_dof_11 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
             const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_10*src_dof_10 + q_acc_5_11*src_dof_11 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
             const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_10*src_dof_10 + q_acc_6_11*src_dof_11 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
             const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_10*src_dof_10 + q_acc_7_11*src_dof_11 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
             const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_10*src_dof_10 + q_acc_8_11*src_dof_11 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
             const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_10*src_dof_10 + q_acc_9_11*src_dof_11 + q_acc_9_9*src_dof_9;
             const real_t elMatVec_10 = q_acc_0_10*src_dof_0 + q_acc_10_10*src_dof_10 + q_acc_10_11*src_dof_11 + q_acc_1_10*src_dof_1 + q_acc_2_10*src_dof_2 + q_acc_3_10*src_dof_3 + q_acc_4_10*src_dof_4 + q_acc_5_10*src_dof_5 + q_acc_6_10*src_dof_6 + q_acc_7_10*src_dof_7 + q_acc_8_10*src_dof_8 + q_acc_9_10*src_dof_9;
             const real_t elMatVec_11 = q_acc_0_11*src_dof_0 + q_acc_10_11*src_dof_10 + q_acc_11_11*src_dof_11 + q_acc_1_11*src_dof_1 + q_acc_2_11*src_dof_2 + q_acc_3_11*src_dof_3 + q_acc_4_11*src_dof_4 + q_acc_5_11*src_dof_5 + q_acc_6_11*src_dof_6 + q_acc_7_11*src_dof_7 + q_acc_8_11*src_dof_8 + q_acc_9_11*src_dof_9;
             _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatVec_0 + _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_1 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1] = elMatVec_2 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_3 + _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1] = elMatVec_4 + _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_5 + _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatVec_6 + _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_7 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1] = elMatVec_8 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_9 + _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1] = elMatVec_10 + _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_11 + _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
