/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/



































#include "../P2VectorElementwiseFullStokesP1ViscosityAnnulusMap.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2VectorElementwiseFullStokesP1ViscosityAnnulusMap::apply_P2VectorElementwiseFullStokesP1ViscosityAnnulusMap_macro_2D( real_t * RESTRICT  _data_dst_edge_0, real_t * RESTRICT  _data_dst_edge_1, real_t * RESTRICT  _data_dst_vertex_0, real_t * RESTRICT  _data_dst_vertex_1, real_t * RESTRICT  _data_mu, real_t * RESTRICT  _data_src_edge_0, real_t * RESTRICT  _data_src_edge_1, real_t * RESTRICT  _data_src_vertex_0, real_t * RESTRICT  _data_src_vertex_1, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float, real_t radRayVertex, real_t radRefVertex, real_t rayVertex_0, real_t rayVertex_1, real_t refVertex_0, real_t refVertex_1, real_t thrVertex_0, real_t thrVertex_1 ) const
{
    {
       const real_t _data_q_w [] = {-0.28125, 0.26041666666666669, 0.26041666666666669, 0.26041666666666669};
   
       const real_t _data_q_p_0 [] = {0.33333333333333331, 0.20000000000000001, 0.59999999999999998, 0.20000000000000001};
   
       const real_t _data_q_p_1 [] = {0.33333333333333331, 0.59999999999999998, 0.20000000000000001, 0.20000000000000001};
   
       const real_t tmp_coords_jac_0_GRAY = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_GRAY = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_GRAY = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_1_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_2_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t jac_affine_0_0_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_1_0_GRAY;
       const real_t jac_affine_0_1_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_2_0_GRAY;
       const real_t jac_affine_1_0_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_1_1_GRAY;
       const real_t jac_affine_1_1_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_2_1_GRAY;
       const real_t tmp_coords_jac_1_GRAY = jac_affine_0_0_GRAY*jac_affine_1_1_GRAY - jac_affine_0_1_GRAY*jac_affine_1_0_GRAY;
       const real_t tmp_coords_jac_2_GRAY = 1.0 / (tmp_coords_jac_1_GRAY);
       const real_t jac_affine_inv_0_0_GRAY = jac_affine_1_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_0_1_GRAY = -jac_affine_0_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_0_GRAY = -jac_affine_1_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_1_GRAY = jac_affine_0_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t abs_det_jac_affine_GRAY = abs(tmp_coords_jac_1_GRAY);
       const real_t tmp_qloop_1 = -rayVertex_1 + thrVertex_1;
       const real_t tmp_qloop_7 = rayVertex_0 - thrVertex_0;
       const real_t tmp_qloop_8 = -tmp_qloop_7;
       const real_t tmp_qloop_9 = 1.0 / (tmp_qloop_1*(-rayVertex_0 + refVertex_0) - tmp_qloop_8*(-rayVertex_1 + refVertex_1));
       const real_t tmp_qloop_10 = -radRayVertex + radRefVertex;
       const real_t tmp_qloop_11 = tmp_qloop_10*tmp_qloop_9;
       const real_t tmp_qloop_12 = tmp_qloop_11*1.0;
       {
          /* FaceType.GRAY */
          const real_t _data_phi_0_0_GRAY [] = {0.33333333333333343, 0.33333333333333331, 0.33333333333333331, 0.20000000000000007, 0.20000000000000001, 0.59999999999999998, 0.20000000000000001, 0.59999999999999998, 0.20000000000000001, 0.60000000000000009, 0.20000000000000001, 0.20000000000000001};
      
          const real_t _data_tabulated_and_untitled_0_0_GRAY [] = {((real_t)(jac_affine_inv_0_0_GRAY*-0.33333333333333348 + jac_affine_inv_1_0_GRAY*-0.33333333333333348)), ((real_t)(abs_det_jac_affine_GRAY)), ((real_t)(jac_affine_inv_0_0_GRAY*0.33333333333333326)), ((real_t)(jac_affine_inv_1_0_GRAY*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333)), ((real_t)(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)), 0.0, ((real_t)(jac_affine_inv_0_0_GRAY*0.19999999999999973 + jac_affine_inv_1_0_GRAY*0.19999999999999973)), ((real_t)(abs_det_jac_affine_GRAY)), ((real_t)(jac_affine_inv_0_0_GRAY*-0.19999999999999996)), ((real_t)(jac_affine_inv_1_0_GRAY*1.3999999999999999)), ((real_t)(jac_affine_inv_0_0_GRAY*2.3999999999999999 + jac_affine_inv_1_0_GRAY*0.80000000000000004)), ((real_t)(jac_affine_inv_0_0_GRAY*-2.3999999999999999 + jac_affine_inv_1_0_GRAY*-1.5999999999999999)), ((real_t)(jac_affine_inv_1_0_GRAY*-0.80000000000000004)), 0.0, ((real_t)(jac_affine_inv_0_0_GRAY*0.19999999999999996 + jac_affine_inv_1_0_GRAY*0.19999999999999996)), ((real_t)(abs_det_jac_affine_GRAY)), ((real_t)(jac_affine_inv_0_0_GRAY*1.3999999999999999)), ((real_t)(jac_affine_inv_1_0_GRAY*-0.19999999999999996)), ((real_t)(jac_affine_inv_0_0_GRAY*0.80000000000000004 + jac_affine_inv_1_0_GRAY*2.3999999999999999)), ((real_t)(jac_affine_inv_0_0_GRAY*-0.80000000000000004)), ((real_t)(jac_affine_inv_0_0_GRAY*-1.5999999999999999 + jac_affine_inv_1_0_GRAY*-2.3999999999999999)), 0.0, ((real_t)(jac_affine_inv_0_0_GRAY*-1.4000000000000001 + jac_affine_inv_1_0_GRAY*-1.4000000000000001)), ((real_t)(abs_det_jac_affine_GRAY)), ((real_t)(jac_affine_inv_0_0_GRAY*-0.19999999999999996)), ((real_t)(jac_affine_inv_1_0_GRAY*-0.19999999999999996)), ((real_t)(jac_affine_inv_0_0_GRAY*0.80000000000000004 + jac_affine_inv_1_0_GRAY*0.80000000000000004)), ((real_t)(jac_affine_inv_0_0_GRAY*-0.80000000000000004 + jac_affine_inv_1_0_GRAY*1.5999999999999999)), ((real_t)(jac_affine_inv_0_0_GRAY*1.5999999999999999 + jac_affine_inv_1_0_GRAY*-0.80000000000000004)), 0.0};
      
          const real_t _data_tabulated_and_untitled_0_1_GRAY [] = {0.0, ((real_t)(jac_affine_inv_0_0_GRAY*-0.33333333333333348 + jac_affine_inv_1_0_GRAY*-0.33333333333333348)), ((real_t)(jac_affine_inv_0_0_GRAY*0.33333333333333326)), ((real_t)(jac_affine_inv_1_0_GRAY*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333)), ((real_t)(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)), 0.0, ((real_t)(jac_affine_inv_0_0_GRAY*0.19999999999999973 + jac_affine_inv_1_0_GRAY*0.19999999999999973)), ((real_t)(jac_affine_inv_0_0_GRAY*-0.19999999999999996)), ((real_t)(jac_affine_inv_1_0_GRAY*1.3999999999999999)), ((real_t)(jac_affine_inv_0_0_GRAY*2.3999999999999999 + jac_affine_inv_1_0_GRAY*0.80000000000000004)), ((real_t)(jac_affine_inv_0_0_GRAY*-2.3999999999999999 + jac_affine_inv_1_0_GRAY*-1.5999999999999999)), ((real_t)(jac_affine_inv_1_0_GRAY*-0.80000000000000004)), 0.0, ((real_t)(jac_affine_inv_0_0_GRAY*0.19999999999999996 + jac_affine_inv_1_0_GRAY*0.19999999999999996)), ((real_t)(jac_affine_inv_0_0_GRAY*1.3999999999999999)), ((real_t)(jac_affine_inv_1_0_GRAY*-0.19999999999999996)), ((real_t)(jac_affine_inv_0_0_GRAY*0.80000000000000004 + jac_affine_inv_1_0_GRAY*2.3999999999999999)), ((real_t)(jac_affine_inv_0_0_GRAY*-0.80000000000000004)), ((real_t)(jac_affine_inv_0_0_GRAY*-1.5999999999999999 + jac_affine_inv_1_0_GRAY*-2.3999999999999999)), 0.0, ((real_t)(jac_affine_inv_0_0_GRAY*-1.4000000000000001 + jac_affine_inv_1_0_GRAY*-1.4000000000000001)), ((real_t)(jac_affine_inv_0_0_GRAY*-0.19999999999999996)), ((real_t)(jac_affine_inv_1_0_GRAY*-0.19999999999999996)), ((real_t)(jac_affine_inv_0_0_GRAY*0.80000000000000004 + jac_affine_inv_1_0_GRAY*0.80000000000000004)), ((real_t)(jac_affine_inv_0_0_GRAY*-0.80000000000000004 + jac_affine_inv_1_0_GRAY*1.5999999999999999)), ((real_t)(jac_affine_inv_0_0_GRAY*1.5999999999999999 + jac_affine_inv_1_0_GRAY*-0.80000000000000004))};
      
          const real_t _data_tabulated_and_untitled_1_0_GRAY [] = {((real_t)(jac_affine_inv_0_1_GRAY*-0.33333333333333348 + jac_affine_inv_1_1_GRAY*-0.33333333333333348)), ((real_t)(jac_affine_inv_0_1_GRAY*0.33333333333333326)), ((real_t)(jac_affine_inv_1_1_GRAY*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)), ((real_t)(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)), 0.0, ((real_t)(jac_affine_inv_0_1_GRAY*0.19999999999999973 + jac_affine_inv_1_1_GRAY*0.19999999999999973)), ((real_t)(jac_affine_inv_0_1_GRAY*-0.19999999999999996)), ((real_t)(jac_affine_inv_1_1_GRAY*1.3999999999999999)), ((real_t)(jac_affine_inv_0_1_GRAY*2.3999999999999999 + jac_affine_inv_1_1_GRAY*0.80000000000000004)), ((real_t)(jac_affine_inv_0_1_GRAY*-2.3999999999999999 + jac_affine_inv_1_1_GRAY*-1.5999999999999999)), ((real_t)(jac_affine_inv_1_1_GRAY*-0.80000000000000004)), 0.0, ((real_t)(jac_affine_inv_0_1_GRAY*0.19999999999999996 + jac_affine_inv_1_1_GRAY*0.19999999999999996)), ((real_t)(jac_affine_inv_0_1_GRAY*1.3999999999999999)), ((real_t)(jac_affine_inv_1_1_GRAY*-0.19999999999999996)), ((real_t)(jac_affine_inv_0_1_GRAY*0.80000000000000004 + jac_affine_inv_1_1_GRAY*2.3999999999999999)), ((real_t)(jac_affine_inv_0_1_GRAY*-0.80000000000000004)), ((real_t)(jac_affine_inv_0_1_GRAY*-1.5999999999999999 + jac_affine_inv_1_1_GRAY*-2.3999999999999999)), 0.0, ((real_t)(jac_affine_inv_0_1_GRAY*-1.4000000000000001 + jac_affine_inv_1_1_GRAY*-1.4000000000000001)), ((real_t)(jac_affine_inv_0_1_GRAY*-0.19999999999999996)), ((real_t)(jac_affine_inv_1_1_GRAY*-0.19999999999999996)), ((real_t)(jac_affine_inv_0_1_GRAY*0.80000000000000004 + jac_affine_inv_1_1_GRAY*0.80000000000000004)), ((real_t)(jac_affine_inv_0_1_GRAY*-0.80000000000000004 + jac_affine_inv_1_1_GRAY*1.5999999999999999)), ((real_t)(jac_affine_inv_0_1_GRAY*1.5999999999999999 + jac_affine_inv_1_1_GRAY*-0.80000000000000004)), 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_GRAY [] = {0.0, ((real_t)(jac_affine_inv_0_1_GRAY*-0.33333333333333348 + jac_affine_inv_1_1_GRAY*-0.33333333333333348)), ((real_t)(jac_affine_inv_0_1_GRAY*0.33333333333333326)), ((real_t)(jac_affine_inv_1_1_GRAY*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)), ((real_t)(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)), 0.0, ((real_t)(jac_affine_inv_0_1_GRAY*0.19999999999999973 + jac_affine_inv_1_1_GRAY*0.19999999999999973)), ((real_t)(jac_affine_inv_0_1_GRAY*-0.19999999999999996)), ((real_t)(jac_affine_inv_1_1_GRAY*1.3999999999999999)), ((real_t)(jac_affine_inv_0_1_GRAY*2.3999999999999999 + jac_affine_inv_1_1_GRAY*0.80000000000000004)), ((real_t)(jac_affine_inv_0_1_GRAY*-2.3999999999999999 + jac_affine_inv_1_1_GRAY*-1.5999999999999999)), ((real_t)(jac_affine_inv_1_1_GRAY*-0.80000000000000004)), 0.0, ((real_t)(jac_affine_inv_0_1_GRAY*0.19999999999999996 + jac_affine_inv_1_1_GRAY*0.19999999999999996)), ((real_t)(jac_affine_inv_0_1_GRAY*1.3999999999999999)), ((real_t)(jac_affine_inv_1_1_GRAY*-0.19999999999999996)), ((real_t)(jac_affine_inv_0_1_GRAY*0.80000000000000004 + jac_affine_inv_1_1_GRAY*2.3999999999999999)), ((real_t)(jac_affine_inv_0_1_GRAY*-0.80000000000000004)), ((real_t)(jac_affine_inv_0_1_GRAY*-1.5999999999999999 + jac_affine_inv_1_1_GRAY*-2.3999999999999999)), 0.0, ((real_t)(jac_affine_inv_0_1_GRAY*-1.4000000000000001 + jac_affine_inv_1_1_GRAY*-1.4000000000000001)), ((real_t)(jac_affine_inv_0_1_GRAY*-0.19999999999999996)), ((real_t)(jac_affine_inv_1_1_GRAY*-0.19999999999999996)), ((real_t)(jac_affine_inv_0_1_GRAY*0.80000000000000004 + jac_affine_inv_1_1_GRAY*0.80000000000000004)), ((real_t)(jac_affine_inv_0_1_GRAY*-0.80000000000000004 + jac_affine_inv_1_1_GRAY*1.5999999999999999)), ((real_t)(jac_affine_inv_0_1_GRAY*1.5999999999999999 + jac_affine_inv_1_1_GRAY*-0.80000000000000004))};
      
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d src_dof_10 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d src_dof_11 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_mu[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_mu[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_mu[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const __m256d tmp_qloop_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),p_affine_0_0);
                   const __m256d tmp_qloop_2 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_0);
                   const __m256d tmp_qloop_3 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),p_affine_0_1);
                   const __m256d tmp_qloop_4 = _mm256_mul_pd(tmp_qloop_3,tmp_qloop_3);
                   const __m256d tmp_qloop_5 = _mm256_add_pd(tmp_qloop_2,tmp_qloop_4);
                   const __m256d tmp_qloop_6 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_sqrt_pd(tmp_qloop_5));
                   const __m256d tmp_qloop_13 = _mm256_mul_pd(tmp_qloop_6,_mm256_set_pd(tmp_qloop_12,tmp_qloop_12,tmp_qloop_12,tmp_qloop_12));
                   const __m256d tmp_qloop_14 = _mm256_mul_pd(tmp_qloop_13,_mm256_set_pd(tmp_qloop_1,tmp_qloop_1,tmp_qloop_1,tmp_qloop_1));
                   const __m256d tmp_qloop_15 = _mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_5),_mm256_mul_pd(tmp_qloop_5,tmp_qloop_5));
                   const __m256d tmp_qloop_16 = _mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(rayVertex_0,rayVertex_0,rayVertex_0,rayVertex_0)),tmp_qloop_0),_mm256_set_pd(tmp_qloop_1,tmp_qloop_1,tmp_qloop_1,tmp_qloop_1)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(rayVertex_1,rayVertex_1,rayVertex_1,rayVertex_1)),tmp_qloop_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8))),_mm256_set_pd(tmp_qloop_11,tmp_qloop_11,tmp_qloop_11,tmp_qloop_11)),_mm256_set_pd(radRayVertex,radRayVertex,radRayVertex,radRayVertex));
                   const __m256d tmp_qloop_17 = _mm256_mul_pd(tmp_qloop_15,tmp_qloop_16);
                   const __m256d tmp_qloop_18 = _mm256_mul_pd(tmp_qloop_17,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_19 = _mm256_mul_pd(tmp_qloop_13,_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8));
                   const __m256d tmp_qloop_20 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_18);
                   const __m256d tmp_qloop_23 = _mm256_mul_pd(tmp_qloop_15,_mm256_set_pd(tmp_qloop_12,tmp_qloop_12,tmp_qloop_12,tmp_qloop_12));
                   const __m256d tmp_qloop_24 = _mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(tmp_qloop_1,tmp_qloop_1,tmp_qloop_1,tmp_qloop_1));
                   const __m256d tmp_qloop_25 = _mm256_mul_pd(tmp_qloop_2,tmp_qloop_24);
                   const __m256d tmp_qloop_26 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_16,_mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_5),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_5,tmp_qloop_5),tmp_qloop_5))),_mm256_set_pd(3.0,3.0,3.0,3.0));
                   const __m256d tmp_qloop_27 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_26),tmp_qloop_4);
                   const __m256d tmp_qloop_28 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_24,tmp_qloop_4));
                   const __m256d tmp_qloop_29 = _mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(tmp_qloop_7,tmp_qloop_7,tmp_qloop_7,tmp_qloop_7));
                   const __m256d tmp_qloop_30 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_3);
                   const __m256d tmp_qloop_31 = _mm256_mul_pd(tmp_qloop_24,tmp_qloop_30);
                   const __m256d tmp_qloop_32 = _mm256_mul_pd(tmp_qloop_17,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_33 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_2,tmp_qloop_26),tmp_qloop_3);
                   const __m256d tmp_qloop_34 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_33,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_18,tmp_qloop_3));
                   const __m256d tmp_qloop_35 = _mm256_mul_pd(tmp_qloop_29,tmp_qloop_30);
                   const __m256d tmp_qloop_36 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,tmp_qloop_30),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8));
                   const __m256d tmp_qloop_55 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(_data_phi_0_0_GRAY[3*q],_data_phi_0_0_GRAY[3*q],_data_phi_0_0_GRAY[3*q],_data_phi_0_0_GRAY[3*q])),_mm256_mul_pd(mu_dof_1,_mm256_set_pd(_data_phi_0_0_GRAY[3*q + 1],_data_phi_0_0_GRAY[3*q + 1],_data_phi_0_0_GRAY[3*q + 1],_data_phi_0_0_GRAY[3*q + 1]))),_mm256_mul_pd(mu_dof_2,_mm256_set_pd(_data_phi_0_0_GRAY[3*q + 2],_data_phi_0_0_GRAY[3*q + 2],_data_phi_0_0_GRAY[3*q + 2],_data_phi_0_0_GRAY[3*q + 2]))),_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]));
                   const __m256d jac_blending_0_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_14),_mm256_mul_pd(tmp_qloop_18,tmp_qloop_4));
                   const __m256d jac_blending_0_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_19),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_15),tmp_qloop_16),tmp_qloop_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d jac_blending_1_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_14,tmp_qloop_3),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,tmp_qloop_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d jac_blending_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_15,tmp_qloop_16),tmp_qloop_2),_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_21 = _mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_1_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_22 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_21);
                   const __m256d abs_det_jac_blending = tmp_qloop_21;
                   const __m256d tmp_qloop_43 = _mm256_mul_pd(abs_det_jac_blending,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[8*q + 1],_data_tabulated_and_untitled_0_0_GRAY[8*q + 1],_data_tabulated_and_untitled_0_0_GRAY[8*q + 1],_data_tabulated_and_untitled_0_0_GRAY[8*q + 1]));
                   const __m256d jac_blending_inv_0_0 = _mm256_mul_pd(jac_blending_1_1,tmp_qloop_22);
                   const __m256d tmp_qloop_37 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[8*q],_data_tabulated_and_untitled_0_0_GRAY[8*q],_data_tabulated_and_untitled_0_0_GRAY[8*q],_data_tabulated_and_untitled_0_0_GRAY[8*q]));
                   const __m256d tmp_qloop_50 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GRAY[7*q],_data_tabulated_and_untitled_0_1_GRAY[7*q],_data_tabulated_and_untitled_0_1_GRAY[7*q],_data_tabulated_and_untitled_0_1_GRAY[7*q]));
                   const __m256d tmp_qloop_56 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[8*q + 2],_data_tabulated_and_untitled_0_0_GRAY[8*q + 2],_data_tabulated_and_untitled_0_0_GRAY[8*q + 2],_data_tabulated_and_untitled_0_0_GRAY[8*q + 2]));
                   const __m256d tmp_qloop_63 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[8*q + 3],_data_tabulated_and_untitled_0_0_GRAY[8*q + 3],_data_tabulated_and_untitled_0_0_GRAY[8*q + 3],_data_tabulated_and_untitled_0_0_GRAY[8*q + 3]));
                   const __m256d tmp_qloop_70 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[8*q + 4],_data_tabulated_and_untitled_0_0_GRAY[8*q + 4],_data_tabulated_and_untitled_0_0_GRAY[8*q + 4],_data_tabulated_and_untitled_0_0_GRAY[8*q + 4]));
                   const __m256d tmp_qloop_77 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[8*q + 5],_data_tabulated_and_untitled_0_0_GRAY[8*q + 5],_data_tabulated_and_untitled_0_0_GRAY[8*q + 5],_data_tabulated_and_untitled_0_0_GRAY[8*q + 5]));
                   const __m256d tmp_qloop_84 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[8*q + 6],_data_tabulated_and_untitled_0_0_GRAY[8*q + 6],_data_tabulated_and_untitled_0_0_GRAY[8*q + 6],_data_tabulated_and_untitled_0_0_GRAY[8*q + 6]));
                   const __m256d tmp_qloop_93 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[8*q + 7],_data_tabulated_and_untitled_0_0_GRAY[8*q + 7],_data_tabulated_and_untitled_0_0_GRAY[8*q + 7],_data_tabulated_and_untitled_0_0_GRAY[8*q + 7]));
                   const __m256d tmp_qloop_101 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GRAY[7*q + 1],_data_tabulated_and_untitled_0_1_GRAY[7*q + 1],_data_tabulated_and_untitled_0_1_GRAY[7*q + 1],_data_tabulated_and_untitled_0_1_GRAY[7*q + 1]));
                   const __m256d tmp_qloop_112 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GRAY[7*q + 2],_data_tabulated_and_untitled_0_1_GRAY[7*q + 2],_data_tabulated_and_untitled_0_1_GRAY[7*q + 2],_data_tabulated_and_untitled_0_1_GRAY[7*q + 2]));
                   const __m256d tmp_qloop_120 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GRAY[7*q + 3],_data_tabulated_and_untitled_0_1_GRAY[7*q + 3],_data_tabulated_and_untitled_0_1_GRAY[7*q + 3],_data_tabulated_and_untitled_0_1_GRAY[7*q + 3]));
                   const __m256d tmp_qloop_128 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GRAY[7*q + 4],_data_tabulated_and_untitled_0_1_GRAY[7*q + 4],_data_tabulated_and_untitled_0_1_GRAY[7*q + 4],_data_tabulated_and_untitled_0_1_GRAY[7*q + 4]));
                   const __m256d tmp_qloop_136 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GRAY[7*q + 5],_data_tabulated_and_untitled_0_1_GRAY[7*q + 5],_data_tabulated_and_untitled_0_1_GRAY[7*q + 5],_data_tabulated_and_untitled_0_1_GRAY[7*q + 5]));
                   const __m256d tmp_qloop_144 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GRAY[7*q + 6],_data_tabulated_and_untitled_0_1_GRAY[7*q + 6],_data_tabulated_and_untitled_0_1_GRAY[7*q + 6],_data_tabulated_and_untitled_0_1_GRAY[7*q + 6]));
                   const __m256d jac_blending_inv_0_1 = _mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1,tmp_qloop_22),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_39 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GRAY[7*q],_data_tabulated_and_untitled_0_1_GRAY[7*q],_data_tabulated_and_untitled_0_1_GRAY[7*q],_data_tabulated_and_untitled_0_1_GRAY[7*q]));
                   const __m256d tmp_qloop_48 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[8*q],_data_tabulated_and_untitled_0_0_GRAY[8*q],_data_tabulated_and_untitled_0_0_GRAY[8*q],_data_tabulated_and_untitled_0_0_GRAY[8*q]));
                   const __m256d tmp_qloop_60 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[8*q + 2],_data_tabulated_and_untitled_0_0_GRAY[8*q + 2],_data_tabulated_and_untitled_0_0_GRAY[8*q + 2],_data_tabulated_and_untitled_0_0_GRAY[8*q + 2]));
                   const __m256d tmp_qloop_67 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[8*q + 3],_data_tabulated_and_untitled_0_0_GRAY[8*q + 3],_data_tabulated_and_untitled_0_0_GRAY[8*q + 3],_data_tabulated_and_untitled_0_0_GRAY[8*q + 3]));
                   const __m256d tmp_qloop_74 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[8*q + 4],_data_tabulated_and_untitled_0_0_GRAY[8*q + 4],_data_tabulated_and_untitled_0_0_GRAY[8*q + 4],_data_tabulated_and_untitled_0_0_GRAY[8*q + 4]));
                   const __m256d tmp_qloop_81 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[8*q + 5],_data_tabulated_and_untitled_0_0_GRAY[8*q + 5],_data_tabulated_and_untitled_0_0_GRAY[8*q + 5],_data_tabulated_and_untitled_0_0_GRAY[8*q + 5]));
                   const __m256d tmp_qloop_88 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[8*q + 6],_data_tabulated_and_untitled_0_0_GRAY[8*q + 6],_data_tabulated_and_untitled_0_0_GRAY[8*q + 6],_data_tabulated_and_untitled_0_0_GRAY[8*q + 6]));
                   const __m256d tmp_qloop_91 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GRAY[7*q + 1],_data_tabulated_and_untitled_0_1_GRAY[7*q + 1],_data_tabulated_and_untitled_0_1_GRAY[7*q + 1],_data_tabulated_and_untitled_0_1_GRAY[7*q + 1]));
                   const __m256d tmp_qloop_103 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GRAY[8*q + 7],_data_tabulated_and_untitled_0_0_GRAY[8*q + 7],_data_tabulated_and_untitled_0_0_GRAY[8*q + 7],_data_tabulated_and_untitled_0_0_GRAY[8*q + 7]));
                   const __m256d tmp_qloop_107 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GRAY[7*q + 2],_data_tabulated_and_untitled_0_1_GRAY[7*q + 2],_data_tabulated_and_untitled_0_1_GRAY[7*q + 2],_data_tabulated_and_untitled_0_1_GRAY[7*q + 2]));
                   const __m256d tmp_qloop_115 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GRAY[7*q + 3],_data_tabulated_and_untitled_0_1_GRAY[7*q + 3],_data_tabulated_and_untitled_0_1_GRAY[7*q + 3],_data_tabulated_and_untitled_0_1_GRAY[7*q + 3]));
                   const __m256d tmp_qloop_123 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GRAY[7*q + 4],_data_tabulated_and_untitled_0_1_GRAY[7*q + 4],_data_tabulated_and_untitled_0_1_GRAY[7*q + 4],_data_tabulated_and_untitled_0_1_GRAY[7*q + 4]));
                   const __m256d tmp_qloop_131 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GRAY[7*q + 5],_data_tabulated_and_untitled_0_1_GRAY[7*q + 5],_data_tabulated_and_untitled_0_1_GRAY[7*q + 5],_data_tabulated_and_untitled_0_1_GRAY[7*q + 5]));
                   const __m256d tmp_qloop_139 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GRAY[7*q + 6],_data_tabulated_and_untitled_0_1_GRAY[7*q + 6],_data_tabulated_and_untitled_0_1_GRAY[7*q + 6],_data_tabulated_and_untitled_0_1_GRAY[7*q + 6]));
                   const __m256d jac_blending_inv_1_0 = _mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,tmp_qloop_22),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_38 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GRAY[7*q],_data_tabulated_and_untitled_1_0_GRAY[7*q],_data_tabulated_and_untitled_1_0_GRAY[7*q],_data_tabulated_and_untitled_1_0_GRAY[7*q]));
                   const __m256d tmp_qloop_45 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_38,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_51 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GRAY[7*q],_data_tabulated_and_untitled_1_1_GRAY[7*q],_data_tabulated_and_untitled_1_1_GRAY[7*q],_data_tabulated_and_untitled_1_1_GRAY[7*q]));
                   const __m256d tmp_qloop_52 = _mm256_add_pd(tmp_qloop_50,tmp_qloop_51);
                   const __m256d tmp_qloop_53 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_50,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_51,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_57 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GRAY[7*q + 1],_data_tabulated_and_untitled_1_0_GRAY[7*q + 1],_data_tabulated_and_untitled_1_0_GRAY[7*q + 1],_data_tabulated_and_untitled_1_0_GRAY[7*q + 1]));
                   const __m256d tmp_qloop_59 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_56,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_57,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_64 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GRAY[7*q + 2],_data_tabulated_and_untitled_1_0_GRAY[7*q + 2],_data_tabulated_and_untitled_1_0_GRAY[7*q + 2],_data_tabulated_and_untitled_1_0_GRAY[7*q + 2]));
                   const __m256d tmp_qloop_66 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_63,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_64,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_71 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GRAY[7*q + 3],_data_tabulated_and_untitled_1_0_GRAY[7*q + 3],_data_tabulated_and_untitled_1_0_GRAY[7*q + 3],_data_tabulated_and_untitled_1_0_GRAY[7*q + 3]));
                   const __m256d tmp_qloop_73 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_70,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_71,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_78 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GRAY[7*q + 4],_data_tabulated_and_untitled_1_0_GRAY[7*q + 4],_data_tabulated_and_untitled_1_0_GRAY[7*q + 4],_data_tabulated_and_untitled_1_0_GRAY[7*q + 4]));
                   const __m256d tmp_qloop_80 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_78,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_85 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GRAY[7*q + 5],_data_tabulated_and_untitled_1_0_GRAY[7*q + 5],_data_tabulated_and_untitled_1_0_GRAY[7*q + 5],_data_tabulated_and_untitled_1_0_GRAY[7*q + 5]));
                   const __m256d tmp_qloop_87 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_84,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_94 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GRAY[7*q + 6],_data_tabulated_and_untitled_1_0_GRAY[7*q + 6],_data_tabulated_and_untitled_1_0_GRAY[7*q + 6],_data_tabulated_and_untitled_1_0_GRAY[7*q + 6]));
                   const __m256d tmp_qloop_95 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_94,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_97 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_94,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_98 = _mm256_mul_pd(tmp_qloop_45,tmp_qloop_97);
                   const __m256d tmp_qloop_102 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GRAY[7*q + 1],_data_tabulated_and_untitled_1_1_GRAY[7*q + 1],_data_tabulated_and_untitled_1_1_GRAY[7*q + 1],_data_tabulated_and_untitled_1_1_GRAY[7*q + 1]));
                   const __m256d tmp_qloop_113 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GRAY[7*q + 2],_data_tabulated_and_untitled_1_1_GRAY[7*q + 2],_data_tabulated_and_untitled_1_1_GRAY[7*q + 2],_data_tabulated_and_untitled_1_1_GRAY[7*q + 2]));
                   const __m256d tmp_qloop_121 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GRAY[7*q + 3],_data_tabulated_and_untitled_1_1_GRAY[7*q + 3],_data_tabulated_and_untitled_1_1_GRAY[7*q + 3],_data_tabulated_and_untitled_1_1_GRAY[7*q + 3]));
                   const __m256d tmp_qloop_129 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GRAY[7*q + 4],_data_tabulated_and_untitled_1_1_GRAY[7*q + 4],_data_tabulated_and_untitled_1_1_GRAY[7*q + 4],_data_tabulated_and_untitled_1_1_GRAY[7*q + 4]));
                   const __m256d tmp_qloop_137 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GRAY[7*q + 5],_data_tabulated_and_untitled_1_1_GRAY[7*q + 5],_data_tabulated_and_untitled_1_1_GRAY[7*q + 5],_data_tabulated_and_untitled_1_1_GRAY[7*q + 5]));
                   const __m256d tmp_qloop_145 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GRAY[7*q + 6],_data_tabulated_and_untitled_1_1_GRAY[7*q + 6],_data_tabulated_and_untitled_1_1_GRAY[7*q + 6],_data_tabulated_and_untitled_1_1_GRAY[7*q + 6]));
                   const __m256d tmp_qloop_148 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_56,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_57,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_150 = _mm256_mul_pd(tmp_qloop_148,tmp_qloop_97);
                   const __m256d tmp_qloop_152 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_63,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_64,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_154 = _mm256_mul_pd(tmp_qloop_152,tmp_qloop_97);
                   const __m256d tmp_qloop_156 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_70,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_71,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_158 = _mm256_mul_pd(tmp_qloop_156,tmp_qloop_97);
                   const __m256d tmp_qloop_160 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_78,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_162 = _mm256_mul_pd(tmp_qloop_160,tmp_qloop_97);
                   const __m256d tmp_qloop_164 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_84,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_166 = _mm256_mul_pd(tmp_qloop_164,tmp_qloop_97);
                   const __m256d tmp_qloop_167 = _mm256_add_pd(tmp_qloop_93,tmp_qloop_94);
                   const __m256d tmp_qloop_169 = _mm256_mul_pd(tmp_qloop_97,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_94,_mm256_set_pd(1.0,1.0,1.0,1.0))));
                   const __m256d jac_blending_inv_1_1 = _mm256_mul_pd(jac_blending_0_0,tmp_qloop_22);
                   const __m256d tmp_qloop_40 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GRAY[7*q],_data_tabulated_and_untitled_1_1_GRAY[7*q],_data_tabulated_and_untitled_1_1_GRAY[7*q],_data_tabulated_and_untitled_1_1_GRAY[7*q]));
                   const __m256d tmp_qloop_41 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_39,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_40,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_42 = _mm256_add_pd(tmp_qloop_39,tmp_qloop_40);
                   const __m256d tmp_qloop_44 = _mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(tmp_qloop_37,tmp_qloop_38),tmp_qloop_42));
                   const __m256d tmp_qloop_46 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_39,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_40,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_47 = _mm256_mul_pd(tmp_qloop_46,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_39,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_40,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_49 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GRAY[7*q],_data_tabulated_and_untitled_1_0_GRAY[7*q],_data_tabulated_and_untitled_1_0_GRAY[7*q],_data_tabulated_and_untitled_1_0_GRAY[7*q]));
                   const __m256d tmp_qloop_54 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_53,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_48),tmp_qloop_49);
                   const __m256d tmp_qloop_58 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_56,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_57,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_41);
                   const __m256d tmp_qloop_61 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GRAY[7*q + 1],_data_tabulated_and_untitled_1_0_GRAY[7*q + 1],_data_tabulated_and_untitled_1_0_GRAY[7*q + 1],_data_tabulated_and_untitled_1_0_GRAY[7*q + 1]));
                   const __m256d tmp_qloop_62 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_52,tmp_qloop_60),tmp_qloop_61);
                   const __m256d tmp_qloop_65 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_63,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_64,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_41);
                   const __m256d tmp_qloop_68 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GRAY[7*q + 2],_data_tabulated_and_untitled_1_0_GRAY[7*q + 2],_data_tabulated_and_untitled_1_0_GRAY[7*q + 2],_data_tabulated_and_untitled_1_0_GRAY[7*q + 2]));
                   const __m256d tmp_qloop_69 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_52,tmp_qloop_67),tmp_qloop_68);
                   const __m256d tmp_qloop_72 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_70,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_71,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_41);
                   const __m256d tmp_qloop_75 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GRAY[7*q + 3],_data_tabulated_and_untitled_1_0_GRAY[7*q + 3],_data_tabulated_and_untitled_1_0_GRAY[7*q + 3],_data_tabulated_and_untitled_1_0_GRAY[7*q + 3]));
                   const __m256d tmp_qloop_76 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_52,tmp_qloop_74),tmp_qloop_75);
                   const __m256d tmp_qloop_79 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_78,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_41);
                   const __m256d tmp_qloop_82 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GRAY[7*q + 4],_data_tabulated_and_untitled_1_0_GRAY[7*q + 4],_data_tabulated_and_untitled_1_0_GRAY[7*q + 4],_data_tabulated_and_untitled_1_0_GRAY[7*q + 4]));
                   const __m256d tmp_qloop_83 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_52,tmp_qloop_81),tmp_qloop_82);
                   const __m256d tmp_qloop_86 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_84,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_41);
                   const __m256d tmp_qloop_89 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GRAY[7*q + 5],_data_tabulated_and_untitled_1_0_GRAY[7*q + 5],_data_tabulated_and_untitled_1_0_GRAY[7*q + 5],_data_tabulated_and_untitled_1_0_GRAY[7*q + 5]));
                   const __m256d tmp_qloop_90 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_52,tmp_qloop_88),tmp_qloop_89);
                   const __m256d tmp_qloop_92 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GRAY[7*q + 1],_data_tabulated_and_untitled_1_1_GRAY[7*q + 1],_data_tabulated_and_untitled_1_1_GRAY[7*q + 1],_data_tabulated_and_untitled_1_1_GRAY[7*q + 1]));
                   const __m256d tmp_qloop_96 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_91,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_92,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_95);
                   const __m256d tmp_qloop_99 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_91,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_92,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_100 = _mm256_mul_pd(tmp_qloop_46,tmp_qloop_99);
                   const __m256d tmp_qloop_104 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GRAY[7*q + 6],_data_tabulated_and_untitled_1_0_GRAY[7*q + 6],_data_tabulated_and_untitled_1_0_GRAY[7*q + 6],_data_tabulated_and_untitled_1_0_GRAY[7*q + 6]));
                   const __m256d tmp_qloop_105 = _mm256_add_pd(tmp_qloop_103,tmp_qloop_104);
                   const __m256d tmp_qloop_106 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_101,tmp_qloop_102),tmp_qloop_105);
                   const __m256d tmp_qloop_108 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GRAY[7*q + 2],_data_tabulated_and_untitled_1_1_GRAY[7*q + 2],_data_tabulated_and_untitled_1_1_GRAY[7*q + 2],_data_tabulated_and_untitled_1_1_GRAY[7*q + 2]));
                   const __m256d tmp_qloop_109 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_95);
                   const __m256d tmp_qloop_110 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_111 = _mm256_mul_pd(tmp_qloop_110,tmp_qloop_46);
                   const __m256d tmp_qloop_114 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_105,tmp_qloop_112),tmp_qloop_113);
                   const __m256d tmp_qloop_116 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GRAY[7*q + 3],_data_tabulated_and_untitled_1_1_GRAY[7*q + 3],_data_tabulated_and_untitled_1_1_GRAY[7*q + 3],_data_tabulated_and_untitled_1_1_GRAY[7*q + 3]));
                   const __m256d tmp_qloop_117 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_115,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_116,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_95);
                   const __m256d tmp_qloop_118 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_115,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_116,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_119 = _mm256_mul_pd(tmp_qloop_118,tmp_qloop_46);
                   const __m256d tmp_qloop_122 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_105,tmp_qloop_120),tmp_qloop_121);
                   const __m256d tmp_qloop_124 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GRAY[7*q + 4],_data_tabulated_and_untitled_1_1_GRAY[7*q + 4],_data_tabulated_and_untitled_1_1_GRAY[7*q + 4],_data_tabulated_and_untitled_1_1_GRAY[7*q + 4]));
                   const __m256d tmp_qloop_125 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_123,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_124,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_95);
                   const __m256d tmp_qloop_126 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_123,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_124,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_127 = _mm256_mul_pd(tmp_qloop_126,tmp_qloop_46);
                   const __m256d tmp_qloop_130 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_105,tmp_qloop_128),tmp_qloop_129);
                   const __m256d tmp_qloop_132 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GRAY[7*q + 5],_data_tabulated_and_untitled_1_1_GRAY[7*q + 5],_data_tabulated_and_untitled_1_1_GRAY[7*q + 5],_data_tabulated_and_untitled_1_1_GRAY[7*q + 5]));
                   const __m256d tmp_qloop_133 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_131,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_132,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_95);
                   const __m256d tmp_qloop_134 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_131,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_132,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_135 = _mm256_mul_pd(tmp_qloop_134,tmp_qloop_46);
                   const __m256d tmp_qloop_138 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_105,tmp_qloop_136),tmp_qloop_137);
                   const __m256d tmp_qloop_140 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GRAY[7*q + 6],_data_tabulated_and_untitled_1_1_GRAY[7*q + 6],_data_tabulated_and_untitled_1_1_GRAY[7*q + 6],_data_tabulated_and_untitled_1_1_GRAY[7*q + 6]));
                   const __m256d tmp_qloop_141 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_140,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_95);
                   const __m256d tmp_qloop_142 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_140,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_143 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_46);
                   const __m256d tmp_qloop_146 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_105,tmp_qloop_144),tmp_qloop_145);
                   const __m256d tmp_qloop_147 = _mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(tmp_qloop_42,tmp_qloop_56),tmp_qloop_57));
                   const __m256d tmp_qloop_149 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_53,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_60),tmp_qloop_61);
                   const __m256d tmp_qloop_151 = _mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(tmp_qloop_42,tmp_qloop_63),tmp_qloop_64));
                   const __m256d tmp_qloop_153 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_53,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_67),tmp_qloop_68);
                   const __m256d tmp_qloop_155 = _mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(tmp_qloop_42,tmp_qloop_70),tmp_qloop_71));
                   const __m256d tmp_qloop_157 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_53,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_74),tmp_qloop_75);
                   const __m256d tmp_qloop_159 = _mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(tmp_qloop_42,tmp_qloop_77),tmp_qloop_78));
                   const __m256d tmp_qloop_161 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_53,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_81),tmp_qloop_82);
                   const __m256d tmp_qloop_163 = _mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(tmp_qloop_42,tmp_qloop_84),tmp_qloop_85));
                   const __m256d tmp_qloop_165 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_53,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_88),tmp_qloop_89);
                   const __m256d tmp_qloop_168 = _mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(tmp_qloop_167,tmp_qloop_91),tmp_qloop_92));
                   const __m256d tmp_qloop_170 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_91,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_92,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_171 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_172 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_101),tmp_qloop_102);
                   const __m256d tmp_qloop_173 = _mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(tmp_qloop_107,tmp_qloop_108),tmp_qloop_167));
                   const __m256d tmp_qloop_174 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_175 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_112),tmp_qloop_113);
                   const __m256d tmp_qloop_176 = _mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(tmp_qloop_115,tmp_qloop_116),tmp_qloop_167));
                   const __m256d tmp_qloop_177 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_115,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_116,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_178 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_120),tmp_qloop_121);
                   const __m256d tmp_qloop_179 = _mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(tmp_qloop_123,tmp_qloop_124),tmp_qloop_167));
                   const __m256d tmp_qloop_180 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_123,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_124,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_181 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_128),tmp_qloop_129);
                   const __m256d tmp_qloop_182 = _mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(tmp_qloop_131,tmp_qloop_132),tmp_qloop_167));
                   const __m256d tmp_qloop_183 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_131,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_132,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_184 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_136),tmp_qloop_137);
                   const __m256d hessian_blending_0_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_14),tmp_qloop_28);
                   const __m256d hessian_blending_1_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_29,tmp_qloop_4)),_mm256_mul_pd(tmp_qloop_3,tmp_qloop_32)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_3,tmp_qloop_3),tmp_qloop_3)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d hessian_blending_0_0_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_15,tmp_qloop_30),_mm256_set_pd(-2.0,-2.0,-2.0,-2.0)),_mm256_set_pd(tmp_qloop_1,tmp_qloop_1,tmp_qloop_1,tmp_qloop_1)),_mm256_set_pd(tmp_qloop_11,tmp_qloop_11,tmp_qloop_11,tmp_qloop_11)));
                   const __m256d hessian_blending_1_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_20,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(tmp_qloop_35,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_6,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_1,tmp_qloop_1,tmp_qloop_1,tmp_qloop_1)),_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9)));
                   const __m256d hessian_blending_0_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_15,tmp_qloop_2),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9)));
                   const __m256d hessian_blending_1_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_20,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_35,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_27),tmp_qloop_36);
                   const __m256d hessian_blending_0_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_32),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_0),tmp_qloop_0),tmp_qloop_26),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_25),tmp_qloop_36);
                   const __m256d hessian_blending_1_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_33,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_15,tmp_qloop_2),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_set_pd(tmp_qloop_7,tmp_qloop_7,tmp_qloop_7,tmp_qloop_7)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_15,tmp_qloop_4),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9)));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_45,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_38,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(tmp_qloop_54,_mm256_add_pd(_mm256_add_pd(tmp_qloop_48,tmp_qloop_49),tmp_qloop_52))),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_38,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_41)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_1 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_45,tmp_qloop_59),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_62)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_44,tmp_qloop_58),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_2 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_45,tmp_qloop_66),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_69)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_44,tmp_qloop_65),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_3 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_45,tmp_qloop_73),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_76)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_44,tmp_qloop_72),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_4 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_45,tmp_qloop_80),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_83)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_44,tmp_qloop_79),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_5 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_45,tmp_qloop_87),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_90)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_44,tmp_qloop_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_6 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,tmp_qloop_54),tmp_qloop_100),tmp_qloop_98)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_44,tmp_qloop_96),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_7 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_114,tmp_qloop_54),tmp_qloop_111),tmp_qloop_98)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_109,tmp_qloop_44),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_8 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_122,tmp_qloop_54),tmp_qloop_119),tmp_qloop_98)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_117,tmp_qloop_44),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_9 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_54),tmp_qloop_127),tmp_qloop_98)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_125,tmp_qloop_44),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_10 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_54),tmp_qloop_135),tmp_qloop_98)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_44),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_146,tmp_qloop_54),tmp_qloop_143),tmp_qloop_98)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_44),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_148,tmp_qloop_59),_mm256_mul_pd(tmp_qloop_149,tmp_qloop_62)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_147,tmp_qloop_58),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_2 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_148,tmp_qloop_66),_mm256_mul_pd(tmp_qloop_149,tmp_qloop_69)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_147,tmp_qloop_65),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_3 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_148,tmp_qloop_73),_mm256_mul_pd(tmp_qloop_149,tmp_qloop_76)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_147,tmp_qloop_72),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_4 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_148,tmp_qloop_80),_mm256_mul_pd(tmp_qloop_149,tmp_qloop_83)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_147,tmp_qloop_79),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_5 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_148,tmp_qloop_87),_mm256_mul_pd(tmp_qloop_149,tmp_qloop_90)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_147,tmp_qloop_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_6 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,tmp_qloop_149),tmp_qloop_100),tmp_qloop_150)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_147,tmp_qloop_96),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_7 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_114,tmp_qloop_149),tmp_qloop_111),tmp_qloop_150)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_109,tmp_qloop_147),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_8 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_122,tmp_qloop_149),tmp_qloop_119),tmp_qloop_150)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_117,tmp_qloop_147),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_9 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_149),tmp_qloop_127),tmp_qloop_150)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_125,tmp_qloop_147),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_10 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_149),tmp_qloop_135),tmp_qloop_150)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_147),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_146,tmp_qloop_149),tmp_qloop_143),tmp_qloop_150)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_147),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,tmp_qloop_66),_mm256_mul_pd(tmp_qloop_153,tmp_qloop_69)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_151,tmp_qloop_65),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_3 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,tmp_qloop_73),_mm256_mul_pd(tmp_qloop_153,tmp_qloop_76)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_151,tmp_qloop_72),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_4 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,tmp_qloop_80),_mm256_mul_pd(tmp_qloop_153,tmp_qloop_83)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_151,tmp_qloop_79),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_5 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,tmp_qloop_87),_mm256_mul_pd(tmp_qloop_153,tmp_qloop_90)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_151,tmp_qloop_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_6 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,tmp_qloop_153),tmp_qloop_100),tmp_qloop_154)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_151,tmp_qloop_96),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_7 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_114,tmp_qloop_153),tmp_qloop_111),tmp_qloop_154)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_109,tmp_qloop_151),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_8 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_122,tmp_qloop_153),tmp_qloop_119),tmp_qloop_154)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_117,tmp_qloop_151),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_9 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_153),tmp_qloop_127),tmp_qloop_154)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_125,tmp_qloop_151),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_10 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_153),tmp_qloop_135),tmp_qloop_154)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_151),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_146,tmp_qloop_153),tmp_qloop_143),tmp_qloop_154)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_151),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_156,tmp_qloop_73),_mm256_mul_pd(tmp_qloop_157,tmp_qloop_76)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_155,tmp_qloop_72),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_4 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_156,tmp_qloop_80),_mm256_mul_pd(tmp_qloop_157,tmp_qloop_83)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_155,tmp_qloop_79),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_5 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_156,tmp_qloop_87),_mm256_mul_pd(tmp_qloop_157,tmp_qloop_90)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_155,tmp_qloop_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_6 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,tmp_qloop_157),tmp_qloop_100),tmp_qloop_158)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_155,tmp_qloop_96),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_7 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_114,tmp_qloop_157),tmp_qloop_111),tmp_qloop_158)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_109,tmp_qloop_155),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_8 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_122,tmp_qloop_157),tmp_qloop_119),tmp_qloop_158)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_117,tmp_qloop_155),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_9 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_157),tmp_qloop_127),tmp_qloop_158)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_125,tmp_qloop_155),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_10 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_157),tmp_qloop_135),tmp_qloop_158)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_155),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_146,tmp_qloop_157),tmp_qloop_143),tmp_qloop_158)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_155),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_160,tmp_qloop_80),_mm256_mul_pd(tmp_qloop_161,tmp_qloop_83)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_159,tmp_qloop_79),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_5 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_160,tmp_qloop_87),_mm256_mul_pd(tmp_qloop_161,tmp_qloop_90)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_159,tmp_qloop_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_6 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,tmp_qloop_161),tmp_qloop_100),tmp_qloop_162)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_159,tmp_qloop_96),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_7 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_114,tmp_qloop_161),tmp_qloop_111),tmp_qloop_162)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_109,tmp_qloop_159),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_8 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_122,tmp_qloop_161),tmp_qloop_119),tmp_qloop_162)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_117,tmp_qloop_159),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_9 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_161),tmp_qloop_127),tmp_qloop_162)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_125,tmp_qloop_159),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_10 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_161),tmp_qloop_135),tmp_qloop_162)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_159),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_146,tmp_qloop_161),tmp_qloop_143),tmp_qloop_162)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_159),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_164,tmp_qloop_87),_mm256_mul_pd(tmp_qloop_165,tmp_qloop_90)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_163,tmp_qloop_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_6 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,tmp_qloop_165),tmp_qloop_100),tmp_qloop_166)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_163,tmp_qloop_96),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_7 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_114,tmp_qloop_165),tmp_qloop_111),tmp_qloop_166)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_109,tmp_qloop_163),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_8 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_122,tmp_qloop_165),tmp_qloop_119),tmp_qloop_166)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_117,tmp_qloop_163),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_9 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_165),tmp_qloop_127),tmp_qloop_166)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_125,tmp_qloop_163),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_10 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_165),tmp_qloop_135),tmp_qloop_166)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_163),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_146,tmp_qloop_165),tmp_qloop_143),tmp_qloop_166)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_163),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,tmp_qloop_172),_mm256_mul_pd(tmp_qloop_170,tmp_qloop_99)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_168,tmp_qloop_96),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_7 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,tmp_qloop_170),_mm256_mul_pd(tmp_qloop_114,tmp_qloop_172)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_109,tmp_qloop_168),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_8 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_170),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_172)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_117,tmp_qloop_168),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_9 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_126,tmp_qloop_170),_mm256_mul_pd(tmp_qloop_130,tmp_qloop_172)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_125,tmp_qloop_168),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_10 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_134,tmp_qloop_170),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_172)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_168),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_142,tmp_qloop_170),_mm256_mul_pd(tmp_qloop_146,tmp_qloop_172)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_168),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,tmp_qloop_174),_mm256_mul_pd(tmp_qloop_114,tmp_qloop_175)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_109,tmp_qloop_173),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_8 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_174),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_175)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_117,tmp_qloop_173),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_9 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_126,tmp_qloop_174),_mm256_mul_pd(tmp_qloop_130,tmp_qloop_175)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_125,tmp_qloop_173),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_10 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_134,tmp_qloop_174),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_175)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_173),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_142,tmp_qloop_174),_mm256_mul_pd(tmp_qloop_146,tmp_qloop_175)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_173),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_177),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_178)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_117,tmp_qloop_176),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_9 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_126,tmp_qloop_177),_mm256_mul_pd(tmp_qloop_130,tmp_qloop_178)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_125,tmp_qloop_176),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_10 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_134,tmp_qloop_177),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_178)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_176),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_142,tmp_qloop_177),_mm256_mul_pd(tmp_qloop_146,tmp_qloop_178)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_176),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_126,tmp_qloop_180),_mm256_mul_pd(tmp_qloop_130,tmp_qloop_181)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_125,tmp_qloop_179),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_10 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_134,tmp_qloop_180),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_181)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_179),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_142,tmp_qloop_180),_mm256_mul_pd(tmp_qloop_146,tmp_qloop_181)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_179),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_10 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_134,tmp_qloop_183),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_184)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_182),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_142,tmp_qloop_183),_mm256_mul_pd(tmp_qloop_146,tmp_qloop_184)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_182),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_142,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_140,_mm256_set_pd(1.0,1.0,1.0,1.0)))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_146,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_144,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_145,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_171)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_43),_mm256_add_pd(_mm256_add_pd(tmp_qloop_139,tmp_qloop_140),tmp_qloop_167)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_0_1 = _mm256_add_pd(q_acc_0_1,q_tmp_0_1);
                   q_acc_0_2 = _mm256_add_pd(q_acc_0_2,q_tmp_0_2);
                   q_acc_0_3 = _mm256_add_pd(q_acc_0_3,q_tmp_0_3);
                   q_acc_0_4 = _mm256_add_pd(q_acc_0_4,q_tmp_0_4);
                   q_acc_0_5 = _mm256_add_pd(q_acc_0_5,q_tmp_0_5);
                   q_acc_0_6 = _mm256_add_pd(q_acc_0_6,q_tmp_0_6);
                   q_acc_0_7 = _mm256_add_pd(q_acc_0_7,q_tmp_0_7);
                   q_acc_0_8 = _mm256_add_pd(q_acc_0_8,q_tmp_0_8);
                   q_acc_0_9 = _mm256_add_pd(q_acc_0_9,q_tmp_0_9);
                   q_acc_0_10 = _mm256_add_pd(q_acc_0_10,q_tmp_0_10);
                   q_acc_0_11 = _mm256_add_pd(q_acc_0_11,q_tmp_0_11);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_1_2 = _mm256_add_pd(q_acc_1_2,q_tmp_1_2);
                   q_acc_1_3 = _mm256_add_pd(q_acc_1_3,q_tmp_1_3);
                   q_acc_1_4 = _mm256_add_pd(q_acc_1_4,q_tmp_1_4);
                   q_acc_1_5 = _mm256_add_pd(q_acc_1_5,q_tmp_1_5);
                   q_acc_1_6 = _mm256_add_pd(q_acc_1_6,q_tmp_1_6);
                   q_acc_1_7 = _mm256_add_pd(q_acc_1_7,q_tmp_1_7);
                   q_acc_1_8 = _mm256_add_pd(q_acc_1_8,q_tmp_1_8);
                   q_acc_1_9 = _mm256_add_pd(q_acc_1_9,q_tmp_1_9);
                   q_acc_1_10 = _mm256_add_pd(q_acc_1_10,q_tmp_1_10);
                   q_acc_1_11 = _mm256_add_pd(q_acc_1_11,q_tmp_1_11);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_2_3 = _mm256_add_pd(q_acc_2_3,q_tmp_2_3);
                   q_acc_2_4 = _mm256_add_pd(q_acc_2_4,q_tmp_2_4);
                   q_acc_2_5 = _mm256_add_pd(q_acc_2_5,q_tmp_2_5);
                   q_acc_2_6 = _mm256_add_pd(q_acc_2_6,q_tmp_2_6);
                   q_acc_2_7 = _mm256_add_pd(q_acc_2_7,q_tmp_2_7);
                   q_acc_2_8 = _mm256_add_pd(q_acc_2_8,q_tmp_2_8);
                   q_acc_2_9 = _mm256_add_pd(q_acc_2_9,q_tmp_2_9);
                   q_acc_2_10 = _mm256_add_pd(q_acc_2_10,q_tmp_2_10);
                   q_acc_2_11 = _mm256_add_pd(q_acc_2_11,q_tmp_2_11);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_3_4 = _mm256_add_pd(q_acc_3_4,q_tmp_3_4);
                   q_acc_3_5 = _mm256_add_pd(q_acc_3_5,q_tmp_3_5);
                   q_acc_3_6 = _mm256_add_pd(q_acc_3_6,q_tmp_3_6);
                   q_acc_3_7 = _mm256_add_pd(q_acc_3_7,q_tmp_3_7);
                   q_acc_3_8 = _mm256_add_pd(q_acc_3_8,q_tmp_3_8);
                   q_acc_3_9 = _mm256_add_pd(q_acc_3_9,q_tmp_3_9);
                   q_acc_3_10 = _mm256_add_pd(q_acc_3_10,q_tmp_3_10);
                   q_acc_3_11 = _mm256_add_pd(q_acc_3_11,q_tmp_3_11);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_4_5 = _mm256_add_pd(q_acc_4_5,q_tmp_4_5);
                   q_acc_4_6 = _mm256_add_pd(q_acc_4_6,q_tmp_4_6);
                   q_acc_4_7 = _mm256_add_pd(q_acc_4_7,q_tmp_4_7);
                   q_acc_4_8 = _mm256_add_pd(q_acc_4_8,q_tmp_4_8);
                   q_acc_4_9 = _mm256_add_pd(q_acc_4_9,q_tmp_4_9);
                   q_acc_4_10 = _mm256_add_pd(q_acc_4_10,q_tmp_4_10);
                   q_acc_4_11 = _mm256_add_pd(q_acc_4_11,q_tmp_4_11);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_5_6 = _mm256_add_pd(q_acc_5_6,q_tmp_5_6);
                   q_acc_5_7 = _mm256_add_pd(q_acc_5_7,q_tmp_5_7);
                   q_acc_5_8 = _mm256_add_pd(q_acc_5_8,q_tmp_5_8);
                   q_acc_5_9 = _mm256_add_pd(q_acc_5_9,q_tmp_5_9);
                   q_acc_5_10 = _mm256_add_pd(q_acc_5_10,q_tmp_5_10);
                   q_acc_5_11 = _mm256_add_pd(q_acc_5_11,q_tmp_5_11);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_6_7 = _mm256_add_pd(q_acc_6_7,q_tmp_6_7);
                   q_acc_6_8 = _mm256_add_pd(q_acc_6_8,q_tmp_6_8);
                   q_acc_6_9 = _mm256_add_pd(q_acc_6_9,q_tmp_6_9);
                   q_acc_6_10 = _mm256_add_pd(q_acc_6_10,q_tmp_6_10);
                   q_acc_6_11 = _mm256_add_pd(q_acc_6_11,q_tmp_6_11);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_7_8 = _mm256_add_pd(q_acc_7_8,q_tmp_7_8);
                   q_acc_7_9 = _mm256_add_pd(q_acc_7_9,q_tmp_7_9);
                   q_acc_7_10 = _mm256_add_pd(q_acc_7_10,q_tmp_7_10);
                   q_acc_7_11 = _mm256_add_pd(q_acc_7_11,q_tmp_7_11);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_8_9 = _mm256_add_pd(q_acc_8_9,q_tmp_8_9);
                   q_acc_8_10 = _mm256_add_pd(q_acc_8_10,q_tmp_8_10);
                   q_acc_8_11 = _mm256_add_pd(q_acc_8_11,q_tmp_8_11);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                   q_acc_9_10 = _mm256_add_pd(q_acc_9_10,q_tmp_9_10);
                   q_acc_9_11 = _mm256_add_pd(q_acc_9_11,q_tmp_9_11);
                   q_acc_10_10 = _mm256_add_pd(q_acc_10_10,q_tmp_10_10);
                   q_acc_10_11 = _mm256_add_pd(q_acc_10_11,q_tmp_10_11);
                   q_acc_11_11 = _mm256_add_pd(q_acc_11_11,q_tmp_11_11);
                }
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_0,src_dof_0),_mm256_mul_pd(q_acc_0_1,src_dof_1)),_mm256_mul_pd(q_acc_0_10,src_dof_10)),_mm256_mul_pd(q_acc_0_11,src_dof_11)),_mm256_mul_pd(q_acc_0_2,src_dof_2)),_mm256_mul_pd(q_acc_0_3,src_dof_3)),_mm256_mul_pd(q_acc_0_4,src_dof_4)),_mm256_mul_pd(q_acc_0_5,src_dof_5)),_mm256_mul_pd(q_acc_0_6,src_dof_6)),_mm256_mul_pd(q_acc_0_7,src_dof_7)),_mm256_mul_pd(q_acc_0_8,src_dof_8)),_mm256_mul_pd(q_acc_0_9,src_dof_9));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_1,src_dof_0),_mm256_mul_pd(q_acc_1_1,src_dof_1)),_mm256_mul_pd(q_acc_1_10,src_dof_10)),_mm256_mul_pd(q_acc_1_11,src_dof_11)),_mm256_mul_pd(q_acc_1_2,src_dof_2)),_mm256_mul_pd(q_acc_1_3,src_dof_3)),_mm256_mul_pd(q_acc_1_4,src_dof_4)),_mm256_mul_pd(q_acc_1_5,src_dof_5)),_mm256_mul_pd(q_acc_1_6,src_dof_6)),_mm256_mul_pd(q_acc_1_7,src_dof_7)),_mm256_mul_pd(q_acc_1_8,src_dof_8)),_mm256_mul_pd(q_acc_1_9,src_dof_9));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_2,src_dof_0),_mm256_mul_pd(q_acc_1_2,src_dof_1)),_mm256_mul_pd(q_acc_2_10,src_dof_10)),_mm256_mul_pd(q_acc_2_11,src_dof_11)),_mm256_mul_pd(q_acc_2_2,src_dof_2)),_mm256_mul_pd(q_acc_2_3,src_dof_3)),_mm256_mul_pd(q_acc_2_4,src_dof_4)),_mm256_mul_pd(q_acc_2_5,src_dof_5)),_mm256_mul_pd(q_acc_2_6,src_dof_6)),_mm256_mul_pd(q_acc_2_7,src_dof_7)),_mm256_mul_pd(q_acc_2_8,src_dof_8)),_mm256_mul_pd(q_acc_2_9,src_dof_9));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_3,src_dof_0),_mm256_mul_pd(q_acc_1_3,src_dof_1)),_mm256_mul_pd(q_acc_2_3,src_dof_2)),_mm256_mul_pd(q_acc_3_10,src_dof_10)),_mm256_mul_pd(q_acc_3_11,src_dof_11)),_mm256_mul_pd(q_acc_3_3,src_dof_3)),_mm256_mul_pd(q_acc_3_4,src_dof_4)),_mm256_mul_pd(q_acc_3_5,src_dof_5)),_mm256_mul_pd(q_acc_3_6,src_dof_6)),_mm256_mul_pd(q_acc_3_7,src_dof_7)),_mm256_mul_pd(q_acc_3_8,src_dof_8)),_mm256_mul_pd(q_acc_3_9,src_dof_9));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_4,src_dof_0),_mm256_mul_pd(q_acc_1_4,src_dof_1)),_mm256_mul_pd(q_acc_2_4,src_dof_2)),_mm256_mul_pd(q_acc_3_4,src_dof_3)),_mm256_mul_pd(q_acc_4_10,src_dof_10)),_mm256_mul_pd(q_acc_4_11,src_dof_11)),_mm256_mul_pd(q_acc_4_4,src_dof_4)),_mm256_mul_pd(q_acc_4_5,src_dof_5)),_mm256_mul_pd(q_acc_4_6,src_dof_6)),_mm256_mul_pd(q_acc_4_7,src_dof_7)),_mm256_mul_pd(q_acc_4_8,src_dof_8)),_mm256_mul_pd(q_acc_4_9,src_dof_9));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_5,src_dof_0),_mm256_mul_pd(q_acc_1_5,src_dof_1)),_mm256_mul_pd(q_acc_2_5,src_dof_2)),_mm256_mul_pd(q_acc_3_5,src_dof_3)),_mm256_mul_pd(q_acc_4_5,src_dof_4)),_mm256_mul_pd(q_acc_5_10,src_dof_10)),_mm256_mul_pd(q_acc_5_11,src_dof_11)),_mm256_mul_pd(q_acc_5_5,src_dof_5)),_mm256_mul_pd(q_acc_5_6,src_dof_6)),_mm256_mul_pd(q_acc_5_7,src_dof_7)),_mm256_mul_pd(q_acc_5_8,src_dof_8)),_mm256_mul_pd(q_acc_5_9,src_dof_9));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_6,src_dof_0),_mm256_mul_pd(q_acc_1_6,src_dof_1)),_mm256_mul_pd(q_acc_2_6,src_dof_2)),_mm256_mul_pd(q_acc_3_6,src_dof_3)),_mm256_mul_pd(q_acc_4_6,src_dof_4)),_mm256_mul_pd(q_acc_5_6,src_dof_5)),_mm256_mul_pd(q_acc_6_10,src_dof_10)),_mm256_mul_pd(q_acc_6_11,src_dof_11)),_mm256_mul_pd(q_acc_6_6,src_dof_6)),_mm256_mul_pd(q_acc_6_7,src_dof_7)),_mm256_mul_pd(q_acc_6_8,src_dof_8)),_mm256_mul_pd(q_acc_6_9,src_dof_9));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_7,src_dof_0),_mm256_mul_pd(q_acc_1_7,src_dof_1)),_mm256_mul_pd(q_acc_2_7,src_dof_2)),_mm256_mul_pd(q_acc_3_7,src_dof_3)),_mm256_mul_pd(q_acc_4_7,src_dof_4)),_mm256_mul_pd(q_acc_5_7,src_dof_5)),_mm256_mul_pd(q_acc_6_7,src_dof_6)),_mm256_mul_pd(q_acc_7_10,src_dof_10)),_mm256_mul_pd(q_acc_7_11,src_dof_11)),_mm256_mul_pd(q_acc_7_7,src_dof_7)),_mm256_mul_pd(q_acc_7_8,src_dof_8)),_mm256_mul_pd(q_acc_7_9,src_dof_9));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_8,src_dof_0),_mm256_mul_pd(q_acc_1_8,src_dof_1)),_mm256_mul_pd(q_acc_2_8,src_dof_2)),_mm256_mul_pd(q_acc_3_8,src_dof_3)),_mm256_mul_pd(q_acc_4_8,src_dof_4)),_mm256_mul_pd(q_acc_5_8,src_dof_5)),_mm256_mul_pd(q_acc_6_8,src_dof_6)),_mm256_mul_pd(q_acc_7_8,src_dof_7)),_mm256_mul_pd(q_acc_8_10,src_dof_10)),_mm256_mul_pd(q_acc_8_11,src_dof_11)),_mm256_mul_pd(q_acc_8_8,src_dof_8)),_mm256_mul_pd(q_acc_8_9,src_dof_9));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_9,src_dof_0),_mm256_mul_pd(q_acc_1_9,src_dof_1)),_mm256_mul_pd(q_acc_2_9,src_dof_2)),_mm256_mul_pd(q_acc_3_9,src_dof_3)),_mm256_mul_pd(q_acc_4_9,src_dof_4)),_mm256_mul_pd(q_acc_5_9,src_dof_5)),_mm256_mul_pd(q_acc_6_9,src_dof_6)),_mm256_mul_pd(q_acc_7_9,src_dof_7)),_mm256_mul_pd(q_acc_8_9,src_dof_8)),_mm256_mul_pd(q_acc_9_10,src_dof_10)),_mm256_mul_pd(q_acc_9_11,src_dof_11)),_mm256_mul_pd(q_acc_9_9,src_dof_9));
                const __m256d elMatVec_10 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_10,src_dof_0),_mm256_mul_pd(q_acc_10_10,src_dof_10)),_mm256_mul_pd(q_acc_10_11,src_dof_11)),_mm256_mul_pd(q_acc_1_10,src_dof_1)),_mm256_mul_pd(q_acc_2_10,src_dof_2)),_mm256_mul_pd(q_acc_3_10,src_dof_3)),_mm256_mul_pd(q_acc_4_10,src_dof_4)),_mm256_mul_pd(q_acc_5_10,src_dof_5)),_mm256_mul_pd(q_acc_6_10,src_dof_6)),_mm256_mul_pd(q_acc_7_10,src_dof_7)),_mm256_mul_pd(q_acc_8_10,src_dof_8)),_mm256_mul_pd(q_acc_9_10,src_dof_9));
                const __m256d elMatVec_11 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_11,src_dof_0),_mm256_mul_pd(q_acc_10_11,src_dof_10)),_mm256_mul_pd(q_acc_11_11,src_dof_11)),_mm256_mul_pd(q_acc_1_11,src_dof_1)),_mm256_mul_pd(q_acc_2_11,src_dof_2)),_mm256_mul_pd(q_acc_3_11,src_dof_3)),_mm256_mul_pd(q_acc_4_11,src_dof_4)),_mm256_mul_pd(q_acc_5_11,src_dof_5)),_mm256_mul_pd(q_acc_6_11,src_dof_6)),_mm256_mul_pd(q_acc_7_11,src_dof_7)),_mm256_mul_pd(q_acc_8_11,src_dof_8)),_mm256_mul_pd(q_acc_9_11,src_dof_9));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))],_mm256_add_pd(elMatVec_10,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))],_mm256_add_pd(elMatVec_11,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 < -ctr_1 + micro_edges_per_macro_edge; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t src_dof_3 = _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t src_dof_6 = _data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t src_dof_7 = _data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t src_dof_8 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t src_dof_9 = _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t src_dof_10 = _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t src_dof_11 = _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t mu_dof_1 = _data_mu[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t mu_dof_2 = _data_mu[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_0_1 = 0.0;
                real_t q_acc_0_2 = 0.0;
                real_t q_acc_0_3 = 0.0;
                real_t q_acc_0_4 = 0.0;
                real_t q_acc_0_5 = 0.0;
                real_t q_acc_0_6 = 0.0;
                real_t q_acc_0_7 = 0.0;
                real_t q_acc_0_8 = 0.0;
                real_t q_acc_0_9 = 0.0;
                real_t q_acc_0_10 = 0.0;
                real_t q_acc_0_11 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_1_2 = 0.0;
                real_t q_acc_1_3 = 0.0;
                real_t q_acc_1_4 = 0.0;
                real_t q_acc_1_5 = 0.0;
                real_t q_acc_1_6 = 0.0;
                real_t q_acc_1_7 = 0.0;
                real_t q_acc_1_8 = 0.0;
                real_t q_acc_1_9 = 0.0;
                real_t q_acc_1_10 = 0.0;
                real_t q_acc_1_11 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_2_3 = 0.0;
                real_t q_acc_2_4 = 0.0;
                real_t q_acc_2_5 = 0.0;
                real_t q_acc_2_6 = 0.0;
                real_t q_acc_2_7 = 0.0;
                real_t q_acc_2_8 = 0.0;
                real_t q_acc_2_9 = 0.0;
                real_t q_acc_2_10 = 0.0;
                real_t q_acc_2_11 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_3_4 = 0.0;
                real_t q_acc_3_5 = 0.0;
                real_t q_acc_3_6 = 0.0;
                real_t q_acc_3_7 = 0.0;
                real_t q_acc_3_8 = 0.0;
                real_t q_acc_3_9 = 0.0;
                real_t q_acc_3_10 = 0.0;
                real_t q_acc_3_11 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_4_5 = 0.0;
                real_t q_acc_4_6 = 0.0;
                real_t q_acc_4_7 = 0.0;
                real_t q_acc_4_8 = 0.0;
                real_t q_acc_4_9 = 0.0;
                real_t q_acc_4_10 = 0.0;
                real_t q_acc_4_11 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_5_6 = 0.0;
                real_t q_acc_5_7 = 0.0;
                real_t q_acc_5_8 = 0.0;
                real_t q_acc_5_9 = 0.0;
                real_t q_acc_5_10 = 0.0;
                real_t q_acc_5_11 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_6_7 = 0.0;
                real_t q_acc_6_8 = 0.0;
                real_t q_acc_6_9 = 0.0;
                real_t q_acc_6_10 = 0.0;
                real_t q_acc_6_11 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_7_8 = 0.0;
                real_t q_acc_7_9 = 0.0;
                real_t q_acc_7_10 = 0.0;
                real_t q_acc_7_11 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_8_9 = 0.0;
                real_t q_acc_8_10 = 0.0;
                real_t q_acc_8_11 = 0.0;
                real_t q_acc_9_9 = 0.0;
                real_t q_acc_9_10 = 0.0;
                real_t q_acc_9_11 = 0.0;
                real_t q_acc_10_10 = 0.0;
                real_t q_acc_10_11 = 0.0;
                real_t q_acc_11_11 = 0.0;
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const real_t tmp_qloop_0 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q];
                   const real_t tmp_qloop_2 = (tmp_qloop_0*tmp_qloop_0);
                   const real_t tmp_qloop_3 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q];
                   const real_t tmp_qloop_4 = (tmp_qloop_3*tmp_qloop_3);
                   const real_t tmp_qloop_5 = tmp_qloop_2 + tmp_qloop_4;
                   const real_t tmp_qloop_6 = pow(tmp_qloop_5, -0.50000000000000000);
                   const real_t tmp_qloop_13 = tmp_qloop_12*tmp_qloop_6;
                   const real_t tmp_qloop_14 = tmp_qloop_1*tmp_qloop_13;
                   const real_t tmp_qloop_15 = pow(tmp_qloop_5, -1.5000000000000000);
                   const real_t tmp_qloop_16 = radRayVertex + tmp_qloop_11*(tmp_qloop_1*(-rayVertex_0 + tmp_qloop_0) - tmp_qloop_8*(-rayVertex_1 + tmp_qloop_3));
                   const real_t tmp_qloop_17 = tmp_qloop_15*tmp_qloop_16;
                   const real_t tmp_qloop_18 = tmp_qloop_17*1.0;
                   const real_t tmp_qloop_19 = tmp_qloop_13*tmp_qloop_8;
                   const real_t tmp_qloop_20 = tmp_qloop_0*tmp_qloop_18;
                   const real_t tmp_qloop_23 = tmp_qloop_12*tmp_qloop_15;
                   const real_t tmp_qloop_24 = tmp_qloop_1*tmp_qloop_23;
                   const real_t tmp_qloop_25 = tmp_qloop_2*tmp_qloop_24;
                   const real_t tmp_qloop_26 = tmp_qloop_16*pow(tmp_qloop_5, -2.5000000000000000)*3.0;
                   const real_t tmp_qloop_27 = tmp_qloop_0*tmp_qloop_26*tmp_qloop_4;
                   const real_t tmp_qloop_28 = tmp_qloop_24*tmp_qloop_4 - tmp_qloop_27;
                   const real_t tmp_qloop_29 = tmp_qloop_23*tmp_qloop_7;
                   const real_t tmp_qloop_30 = tmp_qloop_0*tmp_qloop_3;
                   const real_t tmp_qloop_31 = tmp_qloop_24*tmp_qloop_30;
                   const real_t tmp_qloop_32 = tmp_qloop_17*2.0;
                   const real_t tmp_qloop_33 = tmp_qloop_2*tmp_qloop_26*tmp_qloop_3;
                   const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_3 - tmp_qloop_33;
                   const real_t tmp_qloop_35 = tmp_qloop_29*tmp_qloop_30;
                   const real_t tmp_qloop_36 = tmp_qloop_23*tmp_qloop_30*tmp_qloop_8;
                   const real_t tmp_qloop_55 = (mu_dof_0*_data_phi_0_0_GRAY[3*q] + mu_dof_1*_data_phi_0_0_GRAY[3*q + 1] + mu_dof_2*_data_phi_0_0_GRAY[3*q + 2])*_data_q_w[q];
                   const real_t jac_blending_0_0 = tmp_qloop_0*tmp_qloop_14 + tmp_qloop_18*tmp_qloop_4;
                   const real_t jac_blending_0_1 = -tmp_qloop_0*tmp_qloop_15*tmp_qloop_16*tmp_qloop_3 - tmp_qloop_0*tmp_qloop_19;
                   const real_t jac_blending_1_0 = tmp_qloop_14*tmp_qloop_3 - tmp_qloop_20*tmp_qloop_3;
                   const real_t jac_blending_1_1 = tmp_qloop_15*tmp_qloop_16*tmp_qloop_2*1.0 - tmp_qloop_19*tmp_qloop_3;
                   const real_t tmp_qloop_21 = jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0;
                   const real_t tmp_qloop_22 = 1.0 / (tmp_qloop_21);
                   const real_t abs_det_jac_blending = tmp_qloop_21;
                   const real_t tmp_qloop_43 = abs_det_jac_blending*_data_tabulated_and_untitled_0_0_GRAY[8*q + 1];
                   const real_t jac_blending_inv_0_0 = jac_blending_1_1*tmp_qloop_22;
                   const real_t tmp_qloop_37 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GRAY[8*q];
                   const real_t tmp_qloop_50 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GRAY[7*q];
                   const real_t tmp_qloop_56 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GRAY[8*q + 2];
                   const real_t tmp_qloop_63 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GRAY[8*q + 3];
                   const real_t tmp_qloop_70 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GRAY[8*q + 4];
                   const real_t tmp_qloop_77 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GRAY[8*q + 5];
                   const real_t tmp_qloop_84 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GRAY[8*q + 6];
                   const real_t tmp_qloop_93 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GRAY[8*q + 7];
                   const real_t tmp_qloop_101 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GRAY[7*q + 1];
                   const real_t tmp_qloop_112 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GRAY[7*q + 2];
                   const real_t tmp_qloop_120 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GRAY[7*q + 3];
                   const real_t tmp_qloop_128 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GRAY[7*q + 4];
                   const real_t tmp_qloop_136 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GRAY[7*q + 5];
                   const real_t tmp_qloop_144 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GRAY[7*q + 6];
                   const real_t jac_blending_inv_0_1 = -jac_blending_0_1*tmp_qloop_22;
                   const real_t tmp_qloop_39 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GRAY[7*q];
                   const real_t tmp_qloop_48 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GRAY[8*q];
                   const real_t tmp_qloop_60 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GRAY[8*q + 2];
                   const real_t tmp_qloop_67 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GRAY[8*q + 3];
                   const real_t tmp_qloop_74 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GRAY[8*q + 4];
                   const real_t tmp_qloop_81 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GRAY[8*q + 5];
                   const real_t tmp_qloop_88 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GRAY[8*q + 6];
                   const real_t tmp_qloop_91 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GRAY[7*q + 1];
                   const real_t tmp_qloop_103 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GRAY[8*q + 7];
                   const real_t tmp_qloop_107 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GRAY[7*q + 2];
                   const real_t tmp_qloop_115 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GRAY[7*q + 3];
                   const real_t tmp_qloop_123 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GRAY[7*q + 4];
                   const real_t tmp_qloop_131 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GRAY[7*q + 5];
                   const real_t tmp_qloop_139 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GRAY[7*q + 6];
                   const real_t jac_blending_inv_1_0 = -jac_blending_1_0*tmp_qloop_22;
                   const real_t tmp_qloop_38 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GRAY[7*q];
                   const real_t tmp_qloop_45 = tmp_qloop_37*1.0 + tmp_qloop_38*1.0;
                   const real_t tmp_qloop_51 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GRAY[7*q];
                   const real_t tmp_qloop_52 = tmp_qloop_50 + tmp_qloop_51;
                   const real_t tmp_qloop_53 = tmp_qloop_50*0.5 + tmp_qloop_51*0.5;
                   const real_t tmp_qloop_57 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GRAY[7*q + 1];
                   const real_t tmp_qloop_59 = tmp_qloop_56*2.0 + tmp_qloop_57*2.0;
                   const real_t tmp_qloop_64 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GRAY[7*q + 2];
                   const real_t tmp_qloop_66 = tmp_qloop_63*2.0 + tmp_qloop_64*2.0;
                   const real_t tmp_qloop_71 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GRAY[7*q + 3];
                   const real_t tmp_qloop_73 = tmp_qloop_70*2.0 + tmp_qloop_71*2.0;
                   const real_t tmp_qloop_78 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GRAY[7*q + 4];
                   const real_t tmp_qloop_80 = tmp_qloop_77*2.0 + tmp_qloop_78*2.0;
                   const real_t tmp_qloop_85 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GRAY[7*q + 5];
                   const real_t tmp_qloop_87 = tmp_qloop_84*2.0 + tmp_qloop_85*2.0;
                   const real_t tmp_qloop_94 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GRAY[7*q + 6];
                   const real_t tmp_qloop_95 = tmp_qloop_93*0.66666666666666663 + tmp_qloop_94*0.66666666666666663;
                   const real_t tmp_qloop_97 = tmp_qloop_93*2.0 + tmp_qloop_94*2.0;
                   const real_t tmp_qloop_98 = tmp_qloop_45*tmp_qloop_97;
                   const real_t tmp_qloop_102 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GRAY[7*q + 1];
                   const real_t tmp_qloop_113 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GRAY[7*q + 2];
                   const real_t tmp_qloop_121 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GRAY[7*q + 3];
                   const real_t tmp_qloop_129 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GRAY[7*q + 4];
                   const real_t tmp_qloop_137 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GRAY[7*q + 5];
                   const real_t tmp_qloop_145 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GRAY[7*q + 6];
                   const real_t tmp_qloop_148 = tmp_qloop_56*1.0 + tmp_qloop_57*1.0;
                   const real_t tmp_qloop_150 = tmp_qloop_148*tmp_qloop_97;
                   const real_t tmp_qloop_152 = tmp_qloop_63*1.0 + tmp_qloop_64*1.0;
                   const real_t tmp_qloop_154 = tmp_qloop_152*tmp_qloop_97;
                   const real_t tmp_qloop_156 = tmp_qloop_70*1.0 + tmp_qloop_71*1.0;
                   const real_t tmp_qloop_158 = tmp_qloop_156*tmp_qloop_97;
                   const real_t tmp_qloop_160 = tmp_qloop_77*1.0 + tmp_qloop_78*1.0;
                   const real_t tmp_qloop_162 = tmp_qloop_160*tmp_qloop_97;
                   const real_t tmp_qloop_164 = tmp_qloop_84*1.0 + tmp_qloop_85*1.0;
                   const real_t tmp_qloop_166 = tmp_qloop_164*tmp_qloop_97;
                   const real_t tmp_qloop_167 = tmp_qloop_93 + tmp_qloop_94;
                   const real_t tmp_qloop_169 = tmp_qloop_97*(tmp_qloop_93*1.0 + tmp_qloop_94*1.0);
                   const real_t jac_blending_inv_1_1 = jac_blending_0_0*tmp_qloop_22;
                   const real_t tmp_qloop_40 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GRAY[7*q];
                   const real_t tmp_qloop_41 = tmp_qloop_39*0.66666666666666663 + tmp_qloop_40*0.66666666666666663;
                   const real_t tmp_qloop_42 = tmp_qloop_39 + tmp_qloop_40;
                   const real_t tmp_qloop_44 = tmp_qloop_43*(tmp_qloop_37 + tmp_qloop_38 + tmp_qloop_42);
                   const real_t tmp_qloop_46 = tmp_qloop_39*1.0 + tmp_qloop_40*1.0;
                   const real_t tmp_qloop_47 = tmp_qloop_46*(tmp_qloop_39*2.0 + tmp_qloop_40*2.0);
                   const real_t tmp_qloop_49 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GRAY[7*q];
                   const real_t tmp_qloop_54 = tmp_qloop_48 + tmp_qloop_49 + tmp_qloop_53*2.0;
                   const real_t tmp_qloop_58 = tmp_qloop_41 + tmp_qloop_56*0.66666666666666663 + tmp_qloop_57*0.66666666666666663;
                   const real_t tmp_qloop_61 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GRAY[7*q + 1];
                   const real_t tmp_qloop_62 = tmp_qloop_52 + tmp_qloop_60 + tmp_qloop_61;
                   const real_t tmp_qloop_65 = tmp_qloop_41 + tmp_qloop_63*0.66666666666666663 + tmp_qloop_64*0.66666666666666663;
                   const real_t tmp_qloop_68 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GRAY[7*q + 2];
                   const real_t tmp_qloop_69 = tmp_qloop_52 + tmp_qloop_67 + tmp_qloop_68;
                   const real_t tmp_qloop_72 = tmp_qloop_41 + tmp_qloop_70*0.66666666666666663 + tmp_qloop_71*0.66666666666666663;
                   const real_t tmp_qloop_75 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GRAY[7*q + 3];
                   const real_t tmp_qloop_76 = tmp_qloop_52 + tmp_qloop_74 + tmp_qloop_75;
                   const real_t tmp_qloop_79 = tmp_qloop_41 + tmp_qloop_77*0.66666666666666663 + tmp_qloop_78*0.66666666666666663;
                   const real_t tmp_qloop_82 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GRAY[7*q + 4];
                   const real_t tmp_qloop_83 = tmp_qloop_52 + tmp_qloop_81 + tmp_qloop_82;
                   const real_t tmp_qloop_86 = tmp_qloop_41 + tmp_qloop_84*0.66666666666666663 + tmp_qloop_85*0.66666666666666663;
                   const real_t tmp_qloop_89 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GRAY[7*q + 5];
                   const real_t tmp_qloop_90 = tmp_qloop_52 + tmp_qloop_88 + tmp_qloop_89;
                   const real_t tmp_qloop_92 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GRAY[7*q + 1];
                   const real_t tmp_qloop_96 = tmp_qloop_91*0.66666666666666663 + tmp_qloop_92*0.66666666666666663 + tmp_qloop_95;
                   const real_t tmp_qloop_99 = tmp_qloop_91*2.0 + tmp_qloop_92*2.0;
                   const real_t tmp_qloop_100 = tmp_qloop_46*tmp_qloop_99;
                   const real_t tmp_qloop_104 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GRAY[7*q + 6];
                   const real_t tmp_qloop_105 = tmp_qloop_103 + tmp_qloop_104;
                   const real_t tmp_qloop_106 = tmp_qloop_101 + tmp_qloop_102 + tmp_qloop_105;
                   const real_t tmp_qloop_108 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GRAY[7*q + 2];
                   const real_t tmp_qloop_109 = tmp_qloop_107*0.66666666666666663 + tmp_qloop_108*0.66666666666666663 + tmp_qloop_95;
                   const real_t tmp_qloop_110 = tmp_qloop_107*2.0 + tmp_qloop_108*2.0;
                   const real_t tmp_qloop_111 = tmp_qloop_110*tmp_qloop_46;
                   const real_t tmp_qloop_114 = tmp_qloop_105 + tmp_qloop_112 + tmp_qloop_113;
                   const real_t tmp_qloop_116 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GRAY[7*q + 3];
                   const real_t tmp_qloop_117 = tmp_qloop_115*0.66666666666666663 + tmp_qloop_116*0.66666666666666663 + tmp_qloop_95;
                   const real_t tmp_qloop_118 = tmp_qloop_115*2.0 + tmp_qloop_116*2.0;
                   const real_t tmp_qloop_119 = tmp_qloop_118*tmp_qloop_46;
                   const real_t tmp_qloop_122 = tmp_qloop_105 + tmp_qloop_120 + tmp_qloop_121;
                   const real_t tmp_qloop_124 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GRAY[7*q + 4];
                   const real_t tmp_qloop_125 = tmp_qloop_123*0.66666666666666663 + tmp_qloop_124*0.66666666666666663 + tmp_qloop_95;
                   const real_t tmp_qloop_126 = tmp_qloop_123*2.0 + tmp_qloop_124*2.0;
                   const real_t tmp_qloop_127 = tmp_qloop_126*tmp_qloop_46;
                   const real_t tmp_qloop_130 = tmp_qloop_105 + tmp_qloop_128 + tmp_qloop_129;
                   const real_t tmp_qloop_132 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GRAY[7*q + 5];
                   const real_t tmp_qloop_133 = tmp_qloop_131*0.66666666666666663 + tmp_qloop_132*0.66666666666666663 + tmp_qloop_95;
                   const real_t tmp_qloop_134 = tmp_qloop_131*2.0 + tmp_qloop_132*2.0;
                   const real_t tmp_qloop_135 = tmp_qloop_134*tmp_qloop_46;
                   const real_t tmp_qloop_138 = tmp_qloop_105 + tmp_qloop_136 + tmp_qloop_137;
                   const real_t tmp_qloop_140 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GRAY[7*q + 6];
                   const real_t tmp_qloop_141 = tmp_qloop_139*0.66666666666666663 + tmp_qloop_140*0.66666666666666663 + tmp_qloop_95;
                   const real_t tmp_qloop_142 = tmp_qloop_139*2.0 + tmp_qloop_140*2.0;
                   const real_t tmp_qloop_143 = tmp_qloop_142*tmp_qloop_46;
                   const real_t tmp_qloop_146 = tmp_qloop_105 + tmp_qloop_144 + tmp_qloop_145;
                   const real_t tmp_qloop_147 = tmp_qloop_43*(tmp_qloop_42 + tmp_qloop_56 + tmp_qloop_57);
                   const real_t tmp_qloop_149 = tmp_qloop_53*2.0 + tmp_qloop_60 + tmp_qloop_61;
                   const real_t tmp_qloop_151 = tmp_qloop_43*(tmp_qloop_42 + tmp_qloop_63 + tmp_qloop_64);
                   const real_t tmp_qloop_153 = tmp_qloop_53*2.0 + tmp_qloop_67 + tmp_qloop_68;
                   const real_t tmp_qloop_155 = tmp_qloop_43*(tmp_qloop_42 + tmp_qloop_70 + tmp_qloop_71);
                   const real_t tmp_qloop_157 = tmp_qloop_53*2.0 + tmp_qloop_74 + tmp_qloop_75;
                   const real_t tmp_qloop_159 = tmp_qloop_43*(tmp_qloop_42 + tmp_qloop_77 + tmp_qloop_78);
                   const real_t tmp_qloop_161 = tmp_qloop_53*2.0 + tmp_qloop_81 + tmp_qloop_82;
                   const real_t tmp_qloop_163 = tmp_qloop_43*(tmp_qloop_42 + tmp_qloop_84 + tmp_qloop_85);
                   const real_t tmp_qloop_165 = tmp_qloop_53*2.0 + tmp_qloop_88 + tmp_qloop_89;
                   const real_t tmp_qloop_168 = tmp_qloop_43*(tmp_qloop_167 + tmp_qloop_91 + tmp_qloop_92);
                   const real_t tmp_qloop_170 = tmp_qloop_91*1.0 + tmp_qloop_92*1.0;
                   const real_t tmp_qloop_171 = tmp_qloop_103*0.5 + tmp_qloop_104*0.5;
                   const real_t tmp_qloop_172 = tmp_qloop_101 + tmp_qloop_102 + tmp_qloop_171*2.0;
                   const real_t tmp_qloop_173 = tmp_qloop_43*(tmp_qloop_107 + tmp_qloop_108 + tmp_qloop_167);
                   const real_t tmp_qloop_174 = tmp_qloop_107*1.0 + tmp_qloop_108*1.0;
                   const real_t tmp_qloop_175 = tmp_qloop_112 + tmp_qloop_113 + tmp_qloop_171*2.0;
                   const real_t tmp_qloop_176 = tmp_qloop_43*(tmp_qloop_115 + tmp_qloop_116 + tmp_qloop_167);
                   const real_t tmp_qloop_177 = tmp_qloop_115*1.0 + tmp_qloop_116*1.0;
                   const real_t tmp_qloop_178 = tmp_qloop_120 + tmp_qloop_121 + tmp_qloop_171*2.0;
                   const real_t tmp_qloop_179 = tmp_qloop_43*(tmp_qloop_123 + tmp_qloop_124 + tmp_qloop_167);
                   const real_t tmp_qloop_180 = tmp_qloop_123*1.0 + tmp_qloop_124*1.0;
                   const real_t tmp_qloop_181 = tmp_qloop_128 + tmp_qloop_129 + tmp_qloop_171*2.0;
                   const real_t tmp_qloop_182 = tmp_qloop_43*(tmp_qloop_131 + tmp_qloop_132 + tmp_qloop_167);
                   const real_t tmp_qloop_183 = tmp_qloop_131*1.0 + tmp_qloop_132*1.0;
                   const real_t tmp_qloop_184 = tmp_qloop_136 + tmp_qloop_137 + tmp_qloop_171*2.0;
                   const real_t hessian_blending_0_0_0 = tmp_qloop_14 - tmp_qloop_25 + tmp_qloop_28;
                   const real_t hessian_blending_1_0_0 = -tmp_qloop_26*(tmp_qloop_3*tmp_qloop_3*tmp_qloop_3) + tmp_qloop_29*tmp_qloop_4 + tmp_qloop_3*tmp_qloop_32 - tmp_qloop_31;
                   const real_t hessian_blending_0_0_1 = tmp_qloop_1*tmp_qloop_11*tmp_qloop_15*tmp_qloop_30*-2.0 - tmp_qloop_34;
                   const real_t hessian_blending_1_0_1 = tmp_qloop_1*tmp_qloop_10*tmp_qloop_6*tmp_qloop_9*1.0 - tmp_qloop_20 - tmp_qloop_28 - tmp_qloop_35;
                   const real_t hessian_blending_0_1_0 = tmp_qloop_10*tmp_qloop_15*tmp_qloop_2*tmp_qloop_8*tmp_qloop_9*1.0 - tmp_qloop_19 - tmp_qloop_31 - tmp_qloop_34;
                   const real_t hessian_blending_1_1_0 = -tmp_qloop_20 + tmp_qloop_27 - tmp_qloop_35 + tmp_qloop_36;
                   const real_t hessian_blending_0_1_1 = tmp_qloop_0*tmp_qloop_32 - (tmp_qloop_0*tmp_qloop_0*tmp_qloop_0)*tmp_qloop_26 + tmp_qloop_25 + tmp_qloop_36;
                   const real_t hessian_blending_1_1_1 = tmp_qloop_10*tmp_qloop_15*tmp_qloop_2*tmp_qloop_7*tmp_qloop_9*1.0 + tmp_qloop_10*tmp_qloop_15*tmp_qloop_4*tmp_qloop_8*tmp_qloop_9*1.0 - tmp_qloop_19 - tmp_qloop_33;
                   const real_t q_tmp_0_0 = tmp_qloop_55*(tmp_qloop_43*(tmp_qloop_45*(tmp_qloop_37*2.0 + tmp_qloop_38*2.0) + tmp_qloop_47 + tmp_qloop_54*(tmp_qloop_48 + tmp_qloop_49 + tmp_qloop_52)) - tmp_qloop_44*(tmp_qloop_37*0.66666666666666663 + tmp_qloop_38*0.66666666666666663 + tmp_qloop_41));
                   const real_t q_tmp_0_1 = tmp_qloop_55*(tmp_qloop_43*(tmp_qloop_45*tmp_qloop_59 + tmp_qloop_47 + tmp_qloop_54*tmp_qloop_62) - tmp_qloop_44*tmp_qloop_58);
                   const real_t q_tmp_0_2 = tmp_qloop_55*(tmp_qloop_43*(tmp_qloop_45*tmp_qloop_66 + tmp_qloop_47 + tmp_qloop_54*tmp_qloop_69) - tmp_qloop_44*tmp_qloop_65);
                   const real_t q_tmp_0_3 = tmp_qloop_55*(tmp_qloop_43*(tmp_qloop_45*tmp_qloop_73 + tmp_qloop_47 + tmp_qloop_54*tmp_qloop_76) - tmp_qloop_44*tmp_qloop_72);
                   const real_t q_tmp_0_4 = tmp_qloop_55*(tmp_qloop_43*(tmp_qloop_45*tmp_qloop_80 + tmp_qloop_47 + tmp_qloop_54*tmp_qloop_83) - tmp_qloop_44*tmp_qloop_79);
                   const real_t q_tmp_0_5 = tmp_qloop_55*(tmp_qloop_43*(tmp_qloop_45*tmp_qloop_87 + tmp_qloop_47 + tmp_qloop_54*tmp_qloop_90) - tmp_qloop_44*tmp_qloop_86);
                   const real_t q_tmp_0_6 = tmp_qloop_55*(tmp_qloop_43*(tmp_qloop_100 + tmp_qloop_106*tmp_qloop_54 + tmp_qloop_98) - tmp_qloop_44*tmp_qloop_96);
                   const real_t q_tmp_0_7 = tmp_qloop_55*(-tmp_qloop_109*tmp_qloop_44 + tmp_qloop_43*(tmp_qloop_111 + tmp_qloop_114*tmp_qloop_54 + tmp_qloop_98));
                   const real_t q_tmp_0_8 = tmp_qloop_55*(-tmp_qloop_117*tmp_qloop_44 + tmp_qloop_43*(tmp_qloop_119 + tmp_qloop_122*tmp_qloop_54 + tmp_qloop_98));
                   const real_t q_tmp_0_9 = tmp_qloop_55*(-tmp_qloop_125*tmp_qloop_44 + tmp_qloop_43*(tmp_qloop_127 + tmp_qloop_130*tmp_qloop_54 + tmp_qloop_98));
                   const real_t q_tmp_0_10 = tmp_qloop_55*(-tmp_qloop_133*tmp_qloop_44 + tmp_qloop_43*(tmp_qloop_135 + tmp_qloop_138*tmp_qloop_54 + tmp_qloop_98));
                   const real_t q_tmp_0_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_44 + tmp_qloop_43*(tmp_qloop_143 + tmp_qloop_146*tmp_qloop_54 + tmp_qloop_98));
                   const real_t q_tmp_1_1 = tmp_qloop_55*(-tmp_qloop_147*tmp_qloop_58 + tmp_qloop_43*(tmp_qloop_148*tmp_qloop_59 + tmp_qloop_149*tmp_qloop_62 + tmp_qloop_47));
                   const real_t q_tmp_1_2 = tmp_qloop_55*(-tmp_qloop_147*tmp_qloop_65 + tmp_qloop_43*(tmp_qloop_148*tmp_qloop_66 + tmp_qloop_149*tmp_qloop_69 + tmp_qloop_47));
                   const real_t q_tmp_1_3 = tmp_qloop_55*(-tmp_qloop_147*tmp_qloop_72 + tmp_qloop_43*(tmp_qloop_148*tmp_qloop_73 + tmp_qloop_149*tmp_qloop_76 + tmp_qloop_47));
                   const real_t q_tmp_1_4 = tmp_qloop_55*(-tmp_qloop_147*tmp_qloop_79 + tmp_qloop_43*(tmp_qloop_148*tmp_qloop_80 + tmp_qloop_149*tmp_qloop_83 + tmp_qloop_47));
                   const real_t q_tmp_1_5 = tmp_qloop_55*(-tmp_qloop_147*tmp_qloop_86 + tmp_qloop_43*(tmp_qloop_148*tmp_qloop_87 + tmp_qloop_149*tmp_qloop_90 + tmp_qloop_47));
                   const real_t q_tmp_1_6 = tmp_qloop_55*(-tmp_qloop_147*tmp_qloop_96 + tmp_qloop_43*(tmp_qloop_100 + tmp_qloop_106*tmp_qloop_149 + tmp_qloop_150));
                   const real_t q_tmp_1_7 = tmp_qloop_55*(-tmp_qloop_109*tmp_qloop_147 + tmp_qloop_43*(tmp_qloop_111 + tmp_qloop_114*tmp_qloop_149 + tmp_qloop_150));
                   const real_t q_tmp_1_8 = tmp_qloop_55*(-tmp_qloop_117*tmp_qloop_147 + tmp_qloop_43*(tmp_qloop_119 + tmp_qloop_122*tmp_qloop_149 + tmp_qloop_150));
                   const real_t q_tmp_1_9 = tmp_qloop_55*(-tmp_qloop_125*tmp_qloop_147 + tmp_qloop_43*(tmp_qloop_127 + tmp_qloop_130*tmp_qloop_149 + tmp_qloop_150));
                   const real_t q_tmp_1_10 = tmp_qloop_55*(-tmp_qloop_133*tmp_qloop_147 + tmp_qloop_43*(tmp_qloop_135 + tmp_qloop_138*tmp_qloop_149 + tmp_qloop_150));
                   const real_t q_tmp_1_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_147 + tmp_qloop_43*(tmp_qloop_143 + tmp_qloop_146*tmp_qloop_149 + tmp_qloop_150));
                   const real_t q_tmp_2_2 = tmp_qloop_55*(-tmp_qloop_151*tmp_qloop_65 + tmp_qloop_43*(tmp_qloop_152*tmp_qloop_66 + tmp_qloop_153*tmp_qloop_69 + tmp_qloop_47));
                   const real_t q_tmp_2_3 = tmp_qloop_55*(-tmp_qloop_151*tmp_qloop_72 + tmp_qloop_43*(tmp_qloop_152*tmp_qloop_73 + tmp_qloop_153*tmp_qloop_76 + tmp_qloop_47));
                   const real_t q_tmp_2_4 = tmp_qloop_55*(-tmp_qloop_151*tmp_qloop_79 + tmp_qloop_43*(tmp_qloop_152*tmp_qloop_80 + tmp_qloop_153*tmp_qloop_83 + tmp_qloop_47));
                   const real_t q_tmp_2_5 = tmp_qloop_55*(-tmp_qloop_151*tmp_qloop_86 + tmp_qloop_43*(tmp_qloop_152*tmp_qloop_87 + tmp_qloop_153*tmp_qloop_90 + tmp_qloop_47));
                   const real_t q_tmp_2_6 = tmp_qloop_55*(-tmp_qloop_151*tmp_qloop_96 + tmp_qloop_43*(tmp_qloop_100 + tmp_qloop_106*tmp_qloop_153 + tmp_qloop_154));
                   const real_t q_tmp_2_7 = tmp_qloop_55*(-tmp_qloop_109*tmp_qloop_151 + tmp_qloop_43*(tmp_qloop_111 + tmp_qloop_114*tmp_qloop_153 + tmp_qloop_154));
                   const real_t q_tmp_2_8 = tmp_qloop_55*(-tmp_qloop_117*tmp_qloop_151 + tmp_qloop_43*(tmp_qloop_119 + tmp_qloop_122*tmp_qloop_153 + tmp_qloop_154));
                   const real_t q_tmp_2_9 = tmp_qloop_55*(-tmp_qloop_125*tmp_qloop_151 + tmp_qloop_43*(tmp_qloop_127 + tmp_qloop_130*tmp_qloop_153 + tmp_qloop_154));
                   const real_t q_tmp_2_10 = tmp_qloop_55*(-tmp_qloop_133*tmp_qloop_151 + tmp_qloop_43*(tmp_qloop_135 + tmp_qloop_138*tmp_qloop_153 + tmp_qloop_154));
                   const real_t q_tmp_2_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_151 + tmp_qloop_43*(tmp_qloop_143 + tmp_qloop_146*tmp_qloop_153 + tmp_qloop_154));
                   const real_t q_tmp_3_3 = tmp_qloop_55*(-tmp_qloop_155*tmp_qloop_72 + tmp_qloop_43*(tmp_qloop_156*tmp_qloop_73 + tmp_qloop_157*tmp_qloop_76 + tmp_qloop_47));
                   const real_t q_tmp_3_4 = tmp_qloop_55*(-tmp_qloop_155*tmp_qloop_79 + tmp_qloop_43*(tmp_qloop_156*tmp_qloop_80 + tmp_qloop_157*tmp_qloop_83 + tmp_qloop_47));
                   const real_t q_tmp_3_5 = tmp_qloop_55*(-tmp_qloop_155*tmp_qloop_86 + tmp_qloop_43*(tmp_qloop_156*tmp_qloop_87 + tmp_qloop_157*tmp_qloop_90 + tmp_qloop_47));
                   const real_t q_tmp_3_6 = tmp_qloop_55*(-tmp_qloop_155*tmp_qloop_96 + tmp_qloop_43*(tmp_qloop_100 + tmp_qloop_106*tmp_qloop_157 + tmp_qloop_158));
                   const real_t q_tmp_3_7 = tmp_qloop_55*(-tmp_qloop_109*tmp_qloop_155 + tmp_qloop_43*(tmp_qloop_111 + tmp_qloop_114*tmp_qloop_157 + tmp_qloop_158));
                   const real_t q_tmp_3_8 = tmp_qloop_55*(-tmp_qloop_117*tmp_qloop_155 + tmp_qloop_43*(tmp_qloop_119 + tmp_qloop_122*tmp_qloop_157 + tmp_qloop_158));
                   const real_t q_tmp_3_9 = tmp_qloop_55*(-tmp_qloop_125*tmp_qloop_155 + tmp_qloop_43*(tmp_qloop_127 + tmp_qloop_130*tmp_qloop_157 + tmp_qloop_158));
                   const real_t q_tmp_3_10 = tmp_qloop_55*(-tmp_qloop_133*tmp_qloop_155 + tmp_qloop_43*(tmp_qloop_135 + tmp_qloop_138*tmp_qloop_157 + tmp_qloop_158));
                   const real_t q_tmp_3_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_155 + tmp_qloop_43*(tmp_qloop_143 + tmp_qloop_146*tmp_qloop_157 + tmp_qloop_158));
                   const real_t q_tmp_4_4 = tmp_qloop_55*(-tmp_qloop_159*tmp_qloop_79 + tmp_qloop_43*(tmp_qloop_160*tmp_qloop_80 + tmp_qloop_161*tmp_qloop_83 + tmp_qloop_47));
                   const real_t q_tmp_4_5 = tmp_qloop_55*(-tmp_qloop_159*tmp_qloop_86 + tmp_qloop_43*(tmp_qloop_160*tmp_qloop_87 + tmp_qloop_161*tmp_qloop_90 + tmp_qloop_47));
                   const real_t q_tmp_4_6 = tmp_qloop_55*(-tmp_qloop_159*tmp_qloop_96 + tmp_qloop_43*(tmp_qloop_100 + tmp_qloop_106*tmp_qloop_161 + tmp_qloop_162));
                   const real_t q_tmp_4_7 = tmp_qloop_55*(-tmp_qloop_109*tmp_qloop_159 + tmp_qloop_43*(tmp_qloop_111 + tmp_qloop_114*tmp_qloop_161 + tmp_qloop_162));
                   const real_t q_tmp_4_8 = tmp_qloop_55*(-tmp_qloop_117*tmp_qloop_159 + tmp_qloop_43*(tmp_qloop_119 + tmp_qloop_122*tmp_qloop_161 + tmp_qloop_162));
                   const real_t q_tmp_4_9 = tmp_qloop_55*(-tmp_qloop_125*tmp_qloop_159 + tmp_qloop_43*(tmp_qloop_127 + tmp_qloop_130*tmp_qloop_161 + tmp_qloop_162));
                   const real_t q_tmp_4_10 = tmp_qloop_55*(-tmp_qloop_133*tmp_qloop_159 + tmp_qloop_43*(tmp_qloop_135 + tmp_qloop_138*tmp_qloop_161 + tmp_qloop_162));
                   const real_t q_tmp_4_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_159 + tmp_qloop_43*(tmp_qloop_143 + tmp_qloop_146*tmp_qloop_161 + tmp_qloop_162));
                   const real_t q_tmp_5_5 = tmp_qloop_55*(-tmp_qloop_163*tmp_qloop_86 + tmp_qloop_43*(tmp_qloop_164*tmp_qloop_87 + tmp_qloop_165*tmp_qloop_90 + tmp_qloop_47));
                   const real_t q_tmp_5_6 = tmp_qloop_55*(-tmp_qloop_163*tmp_qloop_96 + tmp_qloop_43*(tmp_qloop_100 + tmp_qloop_106*tmp_qloop_165 + tmp_qloop_166));
                   const real_t q_tmp_5_7 = tmp_qloop_55*(-tmp_qloop_109*tmp_qloop_163 + tmp_qloop_43*(tmp_qloop_111 + tmp_qloop_114*tmp_qloop_165 + tmp_qloop_166));
                   const real_t q_tmp_5_8 = tmp_qloop_55*(-tmp_qloop_117*tmp_qloop_163 + tmp_qloop_43*(tmp_qloop_119 + tmp_qloop_122*tmp_qloop_165 + tmp_qloop_166));
                   const real_t q_tmp_5_9 = tmp_qloop_55*(-tmp_qloop_125*tmp_qloop_163 + tmp_qloop_43*(tmp_qloop_127 + tmp_qloop_130*tmp_qloop_165 + tmp_qloop_166));
                   const real_t q_tmp_5_10 = tmp_qloop_55*(-tmp_qloop_133*tmp_qloop_163 + tmp_qloop_43*(tmp_qloop_135 + tmp_qloop_138*tmp_qloop_165 + tmp_qloop_166));
                   const real_t q_tmp_5_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_163 + tmp_qloop_43*(tmp_qloop_143 + tmp_qloop_146*tmp_qloop_165 + tmp_qloop_166));
                   const real_t q_tmp_6_6 = tmp_qloop_55*(-tmp_qloop_168*tmp_qloop_96 + tmp_qloop_43*(tmp_qloop_106*tmp_qloop_172 + tmp_qloop_169 + tmp_qloop_170*tmp_qloop_99));
                   const real_t q_tmp_6_7 = tmp_qloop_55*(-tmp_qloop_109*tmp_qloop_168 + tmp_qloop_43*(tmp_qloop_110*tmp_qloop_170 + tmp_qloop_114*tmp_qloop_172 + tmp_qloop_169));
                   const real_t q_tmp_6_8 = tmp_qloop_55*(-tmp_qloop_117*tmp_qloop_168 + tmp_qloop_43*(tmp_qloop_118*tmp_qloop_170 + tmp_qloop_122*tmp_qloop_172 + tmp_qloop_169));
                   const real_t q_tmp_6_9 = tmp_qloop_55*(-tmp_qloop_125*tmp_qloop_168 + tmp_qloop_43*(tmp_qloop_126*tmp_qloop_170 + tmp_qloop_130*tmp_qloop_172 + tmp_qloop_169));
                   const real_t q_tmp_6_10 = tmp_qloop_55*(-tmp_qloop_133*tmp_qloop_168 + tmp_qloop_43*(tmp_qloop_134*tmp_qloop_170 + tmp_qloop_138*tmp_qloop_172 + tmp_qloop_169));
                   const real_t q_tmp_6_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_168 + tmp_qloop_43*(tmp_qloop_142*tmp_qloop_170 + tmp_qloop_146*tmp_qloop_172 + tmp_qloop_169));
                   const real_t q_tmp_7_7 = tmp_qloop_55*(-tmp_qloop_109*tmp_qloop_173 + tmp_qloop_43*(tmp_qloop_110*tmp_qloop_174 + tmp_qloop_114*tmp_qloop_175 + tmp_qloop_169));
                   const real_t q_tmp_7_8 = tmp_qloop_55*(-tmp_qloop_117*tmp_qloop_173 + tmp_qloop_43*(tmp_qloop_118*tmp_qloop_174 + tmp_qloop_122*tmp_qloop_175 + tmp_qloop_169));
                   const real_t q_tmp_7_9 = tmp_qloop_55*(-tmp_qloop_125*tmp_qloop_173 + tmp_qloop_43*(tmp_qloop_126*tmp_qloop_174 + tmp_qloop_130*tmp_qloop_175 + tmp_qloop_169));
                   const real_t q_tmp_7_10 = tmp_qloop_55*(-tmp_qloop_133*tmp_qloop_173 + tmp_qloop_43*(tmp_qloop_134*tmp_qloop_174 + tmp_qloop_138*tmp_qloop_175 + tmp_qloop_169));
                   const real_t q_tmp_7_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_173 + tmp_qloop_43*(tmp_qloop_142*tmp_qloop_174 + tmp_qloop_146*tmp_qloop_175 + tmp_qloop_169));
                   const real_t q_tmp_8_8 = tmp_qloop_55*(-tmp_qloop_117*tmp_qloop_176 + tmp_qloop_43*(tmp_qloop_118*tmp_qloop_177 + tmp_qloop_122*tmp_qloop_178 + tmp_qloop_169));
                   const real_t q_tmp_8_9 = tmp_qloop_55*(-tmp_qloop_125*tmp_qloop_176 + tmp_qloop_43*(tmp_qloop_126*tmp_qloop_177 + tmp_qloop_130*tmp_qloop_178 + tmp_qloop_169));
                   const real_t q_tmp_8_10 = tmp_qloop_55*(-tmp_qloop_133*tmp_qloop_176 + tmp_qloop_43*(tmp_qloop_134*tmp_qloop_177 + tmp_qloop_138*tmp_qloop_178 + tmp_qloop_169));
                   const real_t q_tmp_8_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_176 + tmp_qloop_43*(tmp_qloop_142*tmp_qloop_177 + tmp_qloop_146*tmp_qloop_178 + tmp_qloop_169));
                   const real_t q_tmp_9_9 = tmp_qloop_55*(-tmp_qloop_125*tmp_qloop_179 + tmp_qloop_43*(tmp_qloop_126*tmp_qloop_180 + tmp_qloop_130*tmp_qloop_181 + tmp_qloop_169));
                   const real_t q_tmp_9_10 = tmp_qloop_55*(-tmp_qloop_133*tmp_qloop_179 + tmp_qloop_43*(tmp_qloop_134*tmp_qloop_180 + tmp_qloop_138*tmp_qloop_181 + tmp_qloop_169));
                   const real_t q_tmp_9_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_179 + tmp_qloop_43*(tmp_qloop_142*tmp_qloop_180 + tmp_qloop_146*tmp_qloop_181 + tmp_qloop_169));
                   const real_t q_tmp_10_10 = tmp_qloop_55*(-tmp_qloop_133*tmp_qloop_182 + tmp_qloop_43*(tmp_qloop_134*tmp_qloop_183 + tmp_qloop_138*tmp_qloop_184 + tmp_qloop_169));
                   const real_t q_tmp_10_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_182 + tmp_qloop_43*(tmp_qloop_142*tmp_qloop_183 + tmp_qloop_146*tmp_qloop_184 + tmp_qloop_169));
                   const real_t q_tmp_11_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_43*(tmp_qloop_139 + tmp_qloop_140 + tmp_qloop_167) + tmp_qloop_43*(tmp_qloop_142*(tmp_qloop_139*1.0 + tmp_qloop_140*1.0) + tmp_qloop_146*(tmp_qloop_144*0.5 + tmp_qloop_145*0.5 + tmp_qloop_171)*2.0 + tmp_qloop_169));
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                   q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                   q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                   q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                   q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                   q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                   q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                   q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                   q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                   q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                   q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                   q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                   q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                   q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                   q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                   q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                   q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                   q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                   q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                   q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                   q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                   q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                   q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                   q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                   q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                   q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                   q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                   q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                   q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                   q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                   q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                   q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                   q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                   q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                   q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                   q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                   q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                   q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                   q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                   q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                   q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                   q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                   q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                   q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                   q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                   q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                   q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                   q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                   q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                   q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                   q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                   q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                   q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                   q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                   q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                   q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                   q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                   q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                   q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                   q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                }
                const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_10*src_dof_10 + q_acc_0_11*src_dof_11 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
                const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_10*src_dof_10 + q_acc_1_11*src_dof_11 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
                const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_10*src_dof_10 + q_acc_2_11*src_dof_11 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
                const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_10*src_dof_10 + q_acc_3_11*src_dof_11 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
                const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_10*src_dof_10 + q_acc_4_11*src_dof_11 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
                const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_10*src_dof_10 + q_acc_5_11*src_dof_11 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
                const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_10*src_dof_10 + q_acc_6_11*src_dof_11 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
                const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_10*src_dof_10 + q_acc_7_11*src_dof_11 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
                const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_10*src_dof_10 + q_acc_8_11*src_dof_11 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
                const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_10*src_dof_10 + q_acc_9_11*src_dof_11 + q_acc_9_9*src_dof_9;
                const real_t elMatVec_10 = q_acc_0_10*src_dof_0 + q_acc_10_10*src_dof_10 + q_acc_10_11*src_dof_11 + q_acc_1_10*src_dof_1 + q_acc_2_10*src_dof_2 + q_acc_3_10*src_dof_3 + q_acc_4_10*src_dof_4 + q_acc_5_10*src_dof_5 + q_acc_6_10*src_dof_6 + q_acc_7_10*src_dof_7 + q_acc_8_10*src_dof_8 + q_acc_9_10*src_dof_9;
                const real_t elMatVec_11 = q_acc_0_11*src_dof_0 + q_acc_10_11*src_dof_10 + q_acc_11_11*src_dof_11 + q_acc_1_11*src_dof_1 + q_acc_2_11*src_dof_2 + q_acc_3_11*src_dof_3 + q_acc_4_11*src_dof_4 + q_acc_5_11*src_dof_5 + q_acc_6_11*src_dof_6 + q_acc_7_11*src_dof_7 + q_acc_8_11*src_dof_8 + q_acc_9_11*src_dof_9;
                _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatVec_0 + _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
                _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatVec_1 + _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_2 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_3 + _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_4 + _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatVec_5 + _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
                _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatVec_6 + _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
                _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatVec_7 + _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_8 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_9 + _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_10 + _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatVec_11 + _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             }
          }
       }
       const real_t tmp_coords_jac_0_BLUE = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_4_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_0_0_BLUE = tmp_coords_jac_1_BLUE;
       const real_t p_affine_const_0_1_BLUE = tmp_coords_jac_2_BLUE;
       const real_t p_affine_const_1_0_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_1_1_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_4_BLUE;
       const real_t p_affine_const_2_0_BLUE = tmp_coords_jac_1_BLUE + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_2_1_BLUE = tmp_coords_jac_2_BLUE + tmp_coords_jac_4_BLUE;
       const real_t jac_affine_0_0_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_1_0_BLUE;
       const real_t jac_affine_0_1_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_2_0_BLUE;
       const real_t jac_affine_1_0_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_1_1_BLUE;
       const real_t jac_affine_1_1_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_2_1_BLUE;
       const real_t tmp_coords_jac_5_BLUE = jac_affine_0_0_BLUE*jac_affine_1_1_BLUE - jac_affine_0_1_BLUE*jac_affine_1_0_BLUE;
       const real_t tmp_coords_jac_6_BLUE = 1.0 / (tmp_coords_jac_5_BLUE);
       const real_t jac_affine_inv_0_0_BLUE = jac_affine_1_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_0_1_BLUE = -jac_affine_0_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_0_BLUE = -jac_affine_1_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_1_BLUE = jac_affine_0_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t abs_det_jac_affine_BLUE = abs(tmp_coords_jac_5_BLUE);
       {
          /* FaceType.BLUE */
          const real_t _data_phi_0_0_BLUE [] = {0.33333333333333343, 0.33333333333333331, 0.33333333333333331, 0.20000000000000007, 0.20000000000000001, 0.59999999999999998, 0.20000000000000001, 0.59999999999999998, 0.20000000000000001, 0.60000000000000009, 0.20000000000000001, 0.20000000000000001};
      
          const real_t _data_tabulated_and_untitled_0_0_BLUE [] = {((real_t)(jac_affine_inv_0_0_BLUE*-0.33333333333333348 + jac_affine_inv_1_0_BLUE*-0.33333333333333348)), ((real_t)(abs_det_jac_affine_BLUE)), ((real_t)(jac_affine_inv_0_0_BLUE*0.33333333333333326)), ((real_t)(jac_affine_inv_1_0_BLUE*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE*0.19999999999999973 + jac_affine_inv_1_0_BLUE*0.19999999999999973)), ((real_t)(abs_det_jac_affine_BLUE)), ((real_t)(jac_affine_inv_0_0_BLUE*-0.19999999999999996)), ((real_t)(jac_affine_inv_1_0_BLUE*1.3999999999999999)), ((real_t)(jac_affine_inv_0_0_BLUE*2.3999999999999999 + jac_affine_inv_1_0_BLUE*0.80000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE*-2.3999999999999999 + jac_affine_inv_1_0_BLUE*-1.5999999999999999)), ((real_t)(jac_affine_inv_1_0_BLUE*-0.80000000000000004)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE*0.19999999999999996 + jac_affine_inv_1_0_BLUE*0.19999999999999996)), ((real_t)(abs_det_jac_affine_BLUE)), ((real_t)(jac_affine_inv_0_0_BLUE*1.3999999999999999)), ((real_t)(jac_affine_inv_1_0_BLUE*-0.19999999999999996)), ((real_t)(jac_affine_inv_0_0_BLUE*0.80000000000000004 + jac_affine_inv_1_0_BLUE*2.3999999999999999)), ((real_t)(jac_affine_inv_0_0_BLUE*-0.80000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE*-1.5999999999999999 + jac_affine_inv_1_0_BLUE*-2.3999999999999999)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE*-1.4000000000000001 + jac_affine_inv_1_0_BLUE*-1.4000000000000001)), ((real_t)(abs_det_jac_affine_BLUE)), ((real_t)(jac_affine_inv_0_0_BLUE*-0.19999999999999996)), ((real_t)(jac_affine_inv_1_0_BLUE*-0.19999999999999996)), ((real_t)(jac_affine_inv_0_0_BLUE*0.80000000000000004 + jac_affine_inv_1_0_BLUE*0.80000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE*-0.80000000000000004 + jac_affine_inv_1_0_BLUE*1.5999999999999999)), ((real_t)(jac_affine_inv_0_0_BLUE*1.5999999999999999 + jac_affine_inv_1_0_BLUE*-0.80000000000000004)), 0.0};
      
          const real_t _data_tabulated_and_untitled_0_1_BLUE [] = {0.0, ((real_t)(jac_affine_inv_0_0_BLUE*-0.33333333333333348 + jac_affine_inv_1_0_BLUE*-0.33333333333333348)), ((real_t)(jac_affine_inv_0_0_BLUE*0.33333333333333326)), ((real_t)(jac_affine_inv_1_0_BLUE*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE*0.19999999999999973 + jac_affine_inv_1_0_BLUE*0.19999999999999973)), ((real_t)(jac_affine_inv_0_0_BLUE*-0.19999999999999996)), ((real_t)(jac_affine_inv_1_0_BLUE*1.3999999999999999)), ((real_t)(jac_affine_inv_0_0_BLUE*2.3999999999999999 + jac_affine_inv_1_0_BLUE*0.80000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE*-2.3999999999999999 + jac_affine_inv_1_0_BLUE*-1.5999999999999999)), ((real_t)(jac_affine_inv_1_0_BLUE*-0.80000000000000004)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE*0.19999999999999996 + jac_affine_inv_1_0_BLUE*0.19999999999999996)), ((real_t)(jac_affine_inv_0_0_BLUE*1.3999999999999999)), ((real_t)(jac_affine_inv_1_0_BLUE*-0.19999999999999996)), ((real_t)(jac_affine_inv_0_0_BLUE*0.80000000000000004 + jac_affine_inv_1_0_BLUE*2.3999999999999999)), ((real_t)(jac_affine_inv_0_0_BLUE*-0.80000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE*-1.5999999999999999 + jac_affine_inv_1_0_BLUE*-2.3999999999999999)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE*-1.4000000000000001 + jac_affine_inv_1_0_BLUE*-1.4000000000000001)), ((real_t)(jac_affine_inv_0_0_BLUE*-0.19999999999999996)), ((real_t)(jac_affine_inv_1_0_BLUE*-0.19999999999999996)), ((real_t)(jac_affine_inv_0_0_BLUE*0.80000000000000004 + jac_affine_inv_1_0_BLUE*0.80000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE*-0.80000000000000004 + jac_affine_inv_1_0_BLUE*1.5999999999999999)), ((real_t)(jac_affine_inv_0_0_BLUE*1.5999999999999999 + jac_affine_inv_1_0_BLUE*-0.80000000000000004))};
      
          const real_t _data_tabulated_and_untitled_1_0_BLUE [] = {((real_t)(jac_affine_inv_0_1_BLUE*-0.33333333333333348 + jac_affine_inv_1_1_BLUE*-0.33333333333333348)), ((real_t)(jac_affine_inv_0_1_BLUE*0.33333333333333326)), ((real_t)(jac_affine_inv_1_1_BLUE*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE*0.19999999999999973 + jac_affine_inv_1_1_BLUE*0.19999999999999973)), ((real_t)(jac_affine_inv_0_1_BLUE*-0.19999999999999996)), ((real_t)(jac_affine_inv_1_1_BLUE*1.3999999999999999)), ((real_t)(jac_affine_inv_0_1_BLUE*2.3999999999999999 + jac_affine_inv_1_1_BLUE*0.80000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE*-2.3999999999999999 + jac_affine_inv_1_1_BLUE*-1.5999999999999999)), ((real_t)(jac_affine_inv_1_1_BLUE*-0.80000000000000004)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE*0.19999999999999996 + jac_affine_inv_1_1_BLUE*0.19999999999999996)), ((real_t)(jac_affine_inv_0_1_BLUE*1.3999999999999999)), ((real_t)(jac_affine_inv_1_1_BLUE*-0.19999999999999996)), ((real_t)(jac_affine_inv_0_1_BLUE*0.80000000000000004 + jac_affine_inv_1_1_BLUE*2.3999999999999999)), ((real_t)(jac_affine_inv_0_1_BLUE*-0.80000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE*-1.5999999999999999 + jac_affine_inv_1_1_BLUE*-2.3999999999999999)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE*-1.4000000000000001 + jac_affine_inv_1_1_BLUE*-1.4000000000000001)), ((real_t)(jac_affine_inv_0_1_BLUE*-0.19999999999999996)), ((real_t)(jac_affine_inv_1_1_BLUE*-0.19999999999999996)), ((real_t)(jac_affine_inv_0_1_BLUE*0.80000000000000004 + jac_affine_inv_1_1_BLUE*0.80000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE*-0.80000000000000004 + jac_affine_inv_1_1_BLUE*1.5999999999999999)), ((real_t)(jac_affine_inv_0_1_BLUE*1.5999999999999999 + jac_affine_inv_1_1_BLUE*-0.80000000000000004)), 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_BLUE [] = {0.0, ((real_t)(jac_affine_inv_0_1_BLUE*-0.33333333333333348 + jac_affine_inv_1_1_BLUE*-0.33333333333333348)), ((real_t)(jac_affine_inv_0_1_BLUE*0.33333333333333326)), ((real_t)(jac_affine_inv_1_1_BLUE*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE*0.19999999999999973 + jac_affine_inv_1_1_BLUE*0.19999999999999973)), ((real_t)(jac_affine_inv_0_1_BLUE*-0.19999999999999996)), ((real_t)(jac_affine_inv_1_1_BLUE*1.3999999999999999)), ((real_t)(jac_affine_inv_0_1_BLUE*2.3999999999999999 + jac_affine_inv_1_1_BLUE*0.80000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE*-2.3999999999999999 + jac_affine_inv_1_1_BLUE*-1.5999999999999999)), ((real_t)(jac_affine_inv_1_1_BLUE*-0.80000000000000004)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE*0.19999999999999996 + jac_affine_inv_1_1_BLUE*0.19999999999999996)), ((real_t)(jac_affine_inv_0_1_BLUE*1.3999999999999999)), ((real_t)(jac_affine_inv_1_1_BLUE*-0.19999999999999996)), ((real_t)(jac_affine_inv_0_1_BLUE*0.80000000000000004 + jac_affine_inv_1_1_BLUE*2.3999999999999999)), ((real_t)(jac_affine_inv_0_1_BLUE*-0.80000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE*-1.5999999999999999 + jac_affine_inv_1_1_BLUE*-2.3999999999999999)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE*-1.4000000000000001 + jac_affine_inv_1_1_BLUE*-1.4000000000000001)), ((real_t)(jac_affine_inv_0_1_BLUE*-0.19999999999999996)), ((real_t)(jac_affine_inv_1_1_BLUE*-0.19999999999999996)), ((real_t)(jac_affine_inv_0_1_BLUE*0.80000000000000004 + jac_affine_inv_1_1_BLUE*0.80000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE*-0.80000000000000004 + jac_affine_inv_1_1_BLUE*1.5999999999999999)), ((real_t)(jac_affine_inv_0_1_BLUE*1.5999999999999999 + jac_affine_inv_1_1_BLUE*-0.80000000000000004))};
      
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d src_dof_10 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]);
                const __m256d src_dof_11 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_mu[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_mu[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_mu[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const __m256d tmp_qloop_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),p_affine_0_0);
                   const __m256d tmp_qloop_2 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_0);
                   const __m256d tmp_qloop_3 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),p_affine_0_1);
                   const __m256d tmp_qloop_4 = _mm256_mul_pd(tmp_qloop_3,tmp_qloop_3);
                   const __m256d tmp_qloop_5 = _mm256_add_pd(tmp_qloop_2,tmp_qloop_4);
                   const __m256d tmp_qloop_6 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_sqrt_pd(tmp_qloop_5));
                   const __m256d tmp_qloop_13 = _mm256_mul_pd(tmp_qloop_6,_mm256_set_pd(tmp_qloop_12,tmp_qloop_12,tmp_qloop_12,tmp_qloop_12));
                   const __m256d tmp_qloop_14 = _mm256_mul_pd(tmp_qloop_13,_mm256_set_pd(tmp_qloop_1,tmp_qloop_1,tmp_qloop_1,tmp_qloop_1));
                   const __m256d tmp_qloop_15 = _mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_5),_mm256_mul_pd(tmp_qloop_5,tmp_qloop_5));
                   const __m256d tmp_qloop_16 = _mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(rayVertex_0,rayVertex_0,rayVertex_0,rayVertex_0)),tmp_qloop_0),_mm256_set_pd(tmp_qloop_1,tmp_qloop_1,tmp_qloop_1,tmp_qloop_1)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(rayVertex_1,rayVertex_1,rayVertex_1,rayVertex_1)),tmp_qloop_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8))),_mm256_set_pd(tmp_qloop_11,tmp_qloop_11,tmp_qloop_11,tmp_qloop_11)),_mm256_set_pd(radRayVertex,radRayVertex,radRayVertex,radRayVertex));
                   const __m256d tmp_qloop_17 = _mm256_mul_pd(tmp_qloop_15,tmp_qloop_16);
                   const __m256d tmp_qloop_18 = _mm256_mul_pd(tmp_qloop_17,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_19 = _mm256_mul_pd(tmp_qloop_13,_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8));
                   const __m256d tmp_qloop_20 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_18);
                   const __m256d tmp_qloop_23 = _mm256_mul_pd(tmp_qloop_15,_mm256_set_pd(tmp_qloop_12,tmp_qloop_12,tmp_qloop_12,tmp_qloop_12));
                   const __m256d tmp_qloop_24 = _mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(tmp_qloop_1,tmp_qloop_1,tmp_qloop_1,tmp_qloop_1));
                   const __m256d tmp_qloop_25 = _mm256_mul_pd(tmp_qloop_2,tmp_qloop_24);
                   const __m256d tmp_qloop_26 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_16,_mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_5),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_5,tmp_qloop_5),tmp_qloop_5))),_mm256_set_pd(3.0,3.0,3.0,3.0));
                   const __m256d tmp_qloop_27 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_26),tmp_qloop_4);
                   const __m256d tmp_qloop_28 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_24,tmp_qloop_4));
                   const __m256d tmp_qloop_29 = _mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(tmp_qloop_7,tmp_qloop_7,tmp_qloop_7,tmp_qloop_7));
                   const __m256d tmp_qloop_30 = _mm256_mul_pd(tmp_qloop_0,tmp_qloop_3);
                   const __m256d tmp_qloop_31 = _mm256_mul_pd(tmp_qloop_24,tmp_qloop_30);
                   const __m256d tmp_qloop_32 = _mm256_mul_pd(tmp_qloop_17,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_33 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_2,tmp_qloop_26),tmp_qloop_3);
                   const __m256d tmp_qloop_34 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_33,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_18,tmp_qloop_3));
                   const __m256d tmp_qloop_35 = _mm256_mul_pd(tmp_qloop_29,tmp_qloop_30);
                   const __m256d tmp_qloop_36 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,tmp_qloop_30),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8));
                   const __m256d tmp_qloop_55 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(_data_phi_0_0_BLUE[3*q],_data_phi_0_0_BLUE[3*q],_data_phi_0_0_BLUE[3*q],_data_phi_0_0_BLUE[3*q])),_mm256_mul_pd(mu_dof_1,_mm256_set_pd(_data_phi_0_0_BLUE[3*q + 1],_data_phi_0_0_BLUE[3*q + 1],_data_phi_0_0_BLUE[3*q + 1],_data_phi_0_0_BLUE[3*q + 1]))),_mm256_mul_pd(mu_dof_2,_mm256_set_pd(_data_phi_0_0_BLUE[3*q + 2],_data_phi_0_0_BLUE[3*q + 2],_data_phi_0_0_BLUE[3*q + 2],_data_phi_0_0_BLUE[3*q + 2]))),_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]));
                   const __m256d jac_blending_0_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_14),_mm256_mul_pd(tmp_qloop_18,tmp_qloop_4));
                   const __m256d jac_blending_0_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_19),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_15),tmp_qloop_16),tmp_qloop_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d jac_blending_1_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_14,tmp_qloop_3),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_20,tmp_qloop_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d jac_blending_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_15,tmp_qloop_16),tmp_qloop_2),_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_21 = _mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_1_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_22 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_21);
                   const __m256d abs_det_jac_blending = tmp_qloop_21;
                   const __m256d tmp_qloop_43 = _mm256_mul_pd(abs_det_jac_blending,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[8*q + 1],_data_tabulated_and_untitled_0_0_BLUE[8*q + 1],_data_tabulated_and_untitled_0_0_BLUE[8*q + 1],_data_tabulated_and_untitled_0_0_BLUE[8*q + 1]));
                   const __m256d jac_blending_inv_0_0 = _mm256_mul_pd(jac_blending_1_1,tmp_qloop_22);
                   const __m256d tmp_qloop_37 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[8*q],_data_tabulated_and_untitled_0_0_BLUE[8*q],_data_tabulated_and_untitled_0_0_BLUE[8*q],_data_tabulated_and_untitled_0_0_BLUE[8*q]));
                   const __m256d tmp_qloop_50 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE[7*q],_data_tabulated_and_untitled_0_1_BLUE[7*q],_data_tabulated_and_untitled_0_1_BLUE[7*q],_data_tabulated_and_untitled_0_1_BLUE[7*q]));
                   const __m256d tmp_qloop_56 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[8*q + 2],_data_tabulated_and_untitled_0_0_BLUE[8*q + 2],_data_tabulated_and_untitled_0_0_BLUE[8*q + 2],_data_tabulated_and_untitled_0_0_BLUE[8*q + 2]));
                   const __m256d tmp_qloop_63 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[8*q + 3],_data_tabulated_and_untitled_0_0_BLUE[8*q + 3],_data_tabulated_and_untitled_0_0_BLUE[8*q + 3],_data_tabulated_and_untitled_0_0_BLUE[8*q + 3]));
                   const __m256d tmp_qloop_70 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[8*q + 4],_data_tabulated_and_untitled_0_0_BLUE[8*q + 4],_data_tabulated_and_untitled_0_0_BLUE[8*q + 4],_data_tabulated_and_untitled_0_0_BLUE[8*q + 4]));
                   const __m256d tmp_qloop_77 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[8*q + 5],_data_tabulated_and_untitled_0_0_BLUE[8*q + 5],_data_tabulated_and_untitled_0_0_BLUE[8*q + 5],_data_tabulated_and_untitled_0_0_BLUE[8*q + 5]));
                   const __m256d tmp_qloop_84 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[8*q + 6],_data_tabulated_and_untitled_0_0_BLUE[8*q + 6],_data_tabulated_and_untitled_0_0_BLUE[8*q + 6],_data_tabulated_and_untitled_0_0_BLUE[8*q + 6]));
                   const __m256d tmp_qloop_93 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[8*q + 7],_data_tabulated_and_untitled_0_0_BLUE[8*q + 7],_data_tabulated_and_untitled_0_0_BLUE[8*q + 7],_data_tabulated_and_untitled_0_0_BLUE[8*q + 7]));
                   const __m256d tmp_qloop_101 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE[7*q + 1],_data_tabulated_and_untitled_0_1_BLUE[7*q + 1],_data_tabulated_and_untitled_0_1_BLUE[7*q + 1],_data_tabulated_and_untitled_0_1_BLUE[7*q + 1]));
                   const __m256d tmp_qloop_112 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE[7*q + 2],_data_tabulated_and_untitled_0_1_BLUE[7*q + 2],_data_tabulated_and_untitled_0_1_BLUE[7*q + 2],_data_tabulated_and_untitled_0_1_BLUE[7*q + 2]));
                   const __m256d tmp_qloop_120 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE[7*q + 3],_data_tabulated_and_untitled_0_1_BLUE[7*q + 3],_data_tabulated_and_untitled_0_1_BLUE[7*q + 3],_data_tabulated_and_untitled_0_1_BLUE[7*q + 3]));
                   const __m256d tmp_qloop_128 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE[7*q + 4],_data_tabulated_and_untitled_0_1_BLUE[7*q + 4],_data_tabulated_and_untitled_0_1_BLUE[7*q + 4],_data_tabulated_and_untitled_0_1_BLUE[7*q + 4]));
                   const __m256d tmp_qloop_136 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE[7*q + 5],_data_tabulated_and_untitled_0_1_BLUE[7*q + 5],_data_tabulated_and_untitled_0_1_BLUE[7*q + 5],_data_tabulated_and_untitled_0_1_BLUE[7*q + 5]));
                   const __m256d tmp_qloop_144 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE[7*q + 6],_data_tabulated_and_untitled_0_1_BLUE[7*q + 6],_data_tabulated_and_untitled_0_1_BLUE[7*q + 6],_data_tabulated_and_untitled_0_1_BLUE[7*q + 6]));
                   const __m256d jac_blending_inv_0_1 = _mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1,tmp_qloop_22),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_39 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE[7*q],_data_tabulated_and_untitled_0_1_BLUE[7*q],_data_tabulated_and_untitled_0_1_BLUE[7*q],_data_tabulated_and_untitled_0_1_BLUE[7*q]));
                   const __m256d tmp_qloop_48 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[8*q],_data_tabulated_and_untitled_0_0_BLUE[8*q],_data_tabulated_and_untitled_0_0_BLUE[8*q],_data_tabulated_and_untitled_0_0_BLUE[8*q]));
                   const __m256d tmp_qloop_60 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[8*q + 2],_data_tabulated_and_untitled_0_0_BLUE[8*q + 2],_data_tabulated_and_untitled_0_0_BLUE[8*q + 2],_data_tabulated_and_untitled_0_0_BLUE[8*q + 2]));
                   const __m256d tmp_qloop_67 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[8*q + 3],_data_tabulated_and_untitled_0_0_BLUE[8*q + 3],_data_tabulated_and_untitled_0_0_BLUE[8*q + 3],_data_tabulated_and_untitled_0_0_BLUE[8*q + 3]));
                   const __m256d tmp_qloop_74 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[8*q + 4],_data_tabulated_and_untitled_0_0_BLUE[8*q + 4],_data_tabulated_and_untitled_0_0_BLUE[8*q + 4],_data_tabulated_and_untitled_0_0_BLUE[8*q + 4]));
                   const __m256d tmp_qloop_81 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[8*q + 5],_data_tabulated_and_untitled_0_0_BLUE[8*q + 5],_data_tabulated_and_untitled_0_0_BLUE[8*q + 5],_data_tabulated_and_untitled_0_0_BLUE[8*q + 5]));
                   const __m256d tmp_qloop_88 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[8*q + 6],_data_tabulated_and_untitled_0_0_BLUE[8*q + 6],_data_tabulated_and_untitled_0_0_BLUE[8*q + 6],_data_tabulated_and_untitled_0_0_BLUE[8*q + 6]));
                   const __m256d tmp_qloop_91 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE[7*q + 1],_data_tabulated_and_untitled_0_1_BLUE[7*q + 1],_data_tabulated_and_untitled_0_1_BLUE[7*q + 1],_data_tabulated_and_untitled_0_1_BLUE[7*q + 1]));
                   const __m256d tmp_qloop_103 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE[8*q + 7],_data_tabulated_and_untitled_0_0_BLUE[8*q + 7],_data_tabulated_and_untitled_0_0_BLUE[8*q + 7],_data_tabulated_and_untitled_0_0_BLUE[8*q + 7]));
                   const __m256d tmp_qloop_107 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE[7*q + 2],_data_tabulated_and_untitled_0_1_BLUE[7*q + 2],_data_tabulated_and_untitled_0_1_BLUE[7*q + 2],_data_tabulated_and_untitled_0_1_BLUE[7*q + 2]));
                   const __m256d tmp_qloop_115 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE[7*q + 3],_data_tabulated_and_untitled_0_1_BLUE[7*q + 3],_data_tabulated_and_untitled_0_1_BLUE[7*q + 3],_data_tabulated_and_untitled_0_1_BLUE[7*q + 3]));
                   const __m256d tmp_qloop_123 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE[7*q + 4],_data_tabulated_and_untitled_0_1_BLUE[7*q + 4],_data_tabulated_and_untitled_0_1_BLUE[7*q + 4],_data_tabulated_and_untitled_0_1_BLUE[7*q + 4]));
                   const __m256d tmp_qloop_131 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE[7*q + 5],_data_tabulated_and_untitled_0_1_BLUE[7*q + 5],_data_tabulated_and_untitled_0_1_BLUE[7*q + 5],_data_tabulated_and_untitled_0_1_BLUE[7*q + 5]));
                   const __m256d tmp_qloop_139 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE[7*q + 6],_data_tabulated_and_untitled_0_1_BLUE[7*q + 6],_data_tabulated_and_untitled_0_1_BLUE[7*q + 6],_data_tabulated_and_untitled_0_1_BLUE[7*q + 6]));
                   const __m256d jac_blending_inv_1_0 = _mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,tmp_qloop_22),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_38 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE[7*q],_data_tabulated_and_untitled_1_0_BLUE[7*q],_data_tabulated_and_untitled_1_0_BLUE[7*q],_data_tabulated_and_untitled_1_0_BLUE[7*q]));
                   const __m256d tmp_qloop_45 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_38,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_51 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE[7*q],_data_tabulated_and_untitled_1_1_BLUE[7*q],_data_tabulated_and_untitled_1_1_BLUE[7*q],_data_tabulated_and_untitled_1_1_BLUE[7*q]));
                   const __m256d tmp_qloop_52 = _mm256_add_pd(tmp_qloop_50,tmp_qloop_51);
                   const __m256d tmp_qloop_53 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_50,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_51,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_57 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE[7*q + 1],_data_tabulated_and_untitled_1_0_BLUE[7*q + 1],_data_tabulated_and_untitled_1_0_BLUE[7*q + 1],_data_tabulated_and_untitled_1_0_BLUE[7*q + 1]));
                   const __m256d tmp_qloop_59 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_56,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_57,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_64 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE[7*q + 2],_data_tabulated_and_untitled_1_0_BLUE[7*q + 2],_data_tabulated_and_untitled_1_0_BLUE[7*q + 2],_data_tabulated_and_untitled_1_0_BLUE[7*q + 2]));
                   const __m256d tmp_qloop_66 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_63,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_64,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_71 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE[7*q + 3],_data_tabulated_and_untitled_1_0_BLUE[7*q + 3],_data_tabulated_and_untitled_1_0_BLUE[7*q + 3],_data_tabulated_and_untitled_1_0_BLUE[7*q + 3]));
                   const __m256d tmp_qloop_73 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_70,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_71,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_78 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE[7*q + 4],_data_tabulated_and_untitled_1_0_BLUE[7*q + 4],_data_tabulated_and_untitled_1_0_BLUE[7*q + 4],_data_tabulated_and_untitled_1_0_BLUE[7*q + 4]));
                   const __m256d tmp_qloop_80 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_78,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_85 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE[7*q + 5],_data_tabulated_and_untitled_1_0_BLUE[7*q + 5],_data_tabulated_and_untitled_1_0_BLUE[7*q + 5],_data_tabulated_and_untitled_1_0_BLUE[7*q + 5]));
                   const __m256d tmp_qloop_87 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_84,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_94 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE[7*q + 6],_data_tabulated_and_untitled_1_0_BLUE[7*q + 6],_data_tabulated_and_untitled_1_0_BLUE[7*q + 6],_data_tabulated_and_untitled_1_0_BLUE[7*q + 6]));
                   const __m256d tmp_qloop_95 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_94,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_97 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_94,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_98 = _mm256_mul_pd(tmp_qloop_45,tmp_qloop_97);
                   const __m256d tmp_qloop_102 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE[7*q + 1],_data_tabulated_and_untitled_1_1_BLUE[7*q + 1],_data_tabulated_and_untitled_1_1_BLUE[7*q + 1],_data_tabulated_and_untitled_1_1_BLUE[7*q + 1]));
                   const __m256d tmp_qloop_113 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE[7*q + 2],_data_tabulated_and_untitled_1_1_BLUE[7*q + 2],_data_tabulated_and_untitled_1_1_BLUE[7*q + 2],_data_tabulated_and_untitled_1_1_BLUE[7*q + 2]));
                   const __m256d tmp_qloop_121 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE[7*q + 3],_data_tabulated_and_untitled_1_1_BLUE[7*q + 3],_data_tabulated_and_untitled_1_1_BLUE[7*q + 3],_data_tabulated_and_untitled_1_1_BLUE[7*q + 3]));
                   const __m256d tmp_qloop_129 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE[7*q + 4],_data_tabulated_and_untitled_1_1_BLUE[7*q + 4],_data_tabulated_and_untitled_1_1_BLUE[7*q + 4],_data_tabulated_and_untitled_1_1_BLUE[7*q + 4]));
                   const __m256d tmp_qloop_137 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE[7*q + 5],_data_tabulated_and_untitled_1_1_BLUE[7*q + 5],_data_tabulated_and_untitled_1_1_BLUE[7*q + 5],_data_tabulated_and_untitled_1_1_BLUE[7*q + 5]));
                   const __m256d tmp_qloop_145 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE[7*q + 6],_data_tabulated_and_untitled_1_1_BLUE[7*q + 6],_data_tabulated_and_untitled_1_1_BLUE[7*q + 6],_data_tabulated_and_untitled_1_1_BLUE[7*q + 6]));
                   const __m256d tmp_qloop_148 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_56,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_57,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_150 = _mm256_mul_pd(tmp_qloop_148,tmp_qloop_97);
                   const __m256d tmp_qloop_152 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_63,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_64,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_154 = _mm256_mul_pd(tmp_qloop_152,tmp_qloop_97);
                   const __m256d tmp_qloop_156 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_70,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_71,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_158 = _mm256_mul_pd(tmp_qloop_156,tmp_qloop_97);
                   const __m256d tmp_qloop_160 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_78,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_162 = _mm256_mul_pd(tmp_qloop_160,tmp_qloop_97);
                   const __m256d tmp_qloop_164 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_84,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_166 = _mm256_mul_pd(tmp_qloop_164,tmp_qloop_97);
                   const __m256d tmp_qloop_167 = _mm256_add_pd(tmp_qloop_93,tmp_qloop_94);
                   const __m256d tmp_qloop_169 = _mm256_mul_pd(tmp_qloop_97,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_94,_mm256_set_pd(1.0,1.0,1.0,1.0))));
                   const __m256d jac_blending_inv_1_1 = _mm256_mul_pd(jac_blending_0_0,tmp_qloop_22);
                   const __m256d tmp_qloop_40 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE[7*q],_data_tabulated_and_untitled_1_1_BLUE[7*q],_data_tabulated_and_untitled_1_1_BLUE[7*q],_data_tabulated_and_untitled_1_1_BLUE[7*q]));
                   const __m256d tmp_qloop_41 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_39,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_40,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_42 = _mm256_add_pd(tmp_qloop_39,tmp_qloop_40);
                   const __m256d tmp_qloop_44 = _mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(tmp_qloop_37,tmp_qloop_38),tmp_qloop_42));
                   const __m256d tmp_qloop_46 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_39,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_40,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_47 = _mm256_mul_pd(tmp_qloop_46,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_39,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_40,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_49 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE[7*q],_data_tabulated_and_untitled_1_0_BLUE[7*q],_data_tabulated_and_untitled_1_0_BLUE[7*q],_data_tabulated_and_untitled_1_0_BLUE[7*q]));
                   const __m256d tmp_qloop_54 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_53,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_48),tmp_qloop_49);
                   const __m256d tmp_qloop_58 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_56,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_57,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_41);
                   const __m256d tmp_qloop_61 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE[7*q + 1],_data_tabulated_and_untitled_1_0_BLUE[7*q + 1],_data_tabulated_and_untitled_1_0_BLUE[7*q + 1],_data_tabulated_and_untitled_1_0_BLUE[7*q + 1]));
                   const __m256d tmp_qloop_62 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_52,tmp_qloop_60),tmp_qloop_61);
                   const __m256d tmp_qloop_65 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_63,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_64,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_41);
                   const __m256d tmp_qloop_68 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE[7*q + 2],_data_tabulated_and_untitled_1_0_BLUE[7*q + 2],_data_tabulated_and_untitled_1_0_BLUE[7*q + 2],_data_tabulated_and_untitled_1_0_BLUE[7*q + 2]));
                   const __m256d tmp_qloop_69 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_52,tmp_qloop_67),tmp_qloop_68);
                   const __m256d tmp_qloop_72 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_70,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_71,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_41);
                   const __m256d tmp_qloop_75 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE[7*q + 3],_data_tabulated_and_untitled_1_0_BLUE[7*q + 3],_data_tabulated_and_untitled_1_0_BLUE[7*q + 3],_data_tabulated_and_untitled_1_0_BLUE[7*q + 3]));
                   const __m256d tmp_qloop_76 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_52,tmp_qloop_74),tmp_qloop_75);
                   const __m256d tmp_qloop_79 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_77,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_78,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_41);
                   const __m256d tmp_qloop_82 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE[7*q + 4],_data_tabulated_and_untitled_1_0_BLUE[7*q + 4],_data_tabulated_and_untitled_1_0_BLUE[7*q + 4],_data_tabulated_and_untitled_1_0_BLUE[7*q + 4]));
                   const __m256d tmp_qloop_83 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_52,tmp_qloop_81),tmp_qloop_82);
                   const __m256d tmp_qloop_86 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_84,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_85,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_41);
                   const __m256d tmp_qloop_89 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE[7*q + 5],_data_tabulated_and_untitled_1_0_BLUE[7*q + 5],_data_tabulated_and_untitled_1_0_BLUE[7*q + 5],_data_tabulated_and_untitled_1_0_BLUE[7*q + 5]));
                   const __m256d tmp_qloop_90 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_52,tmp_qloop_88),tmp_qloop_89);
                   const __m256d tmp_qloop_92 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE[7*q + 1],_data_tabulated_and_untitled_1_1_BLUE[7*q + 1],_data_tabulated_and_untitled_1_1_BLUE[7*q + 1],_data_tabulated_and_untitled_1_1_BLUE[7*q + 1]));
                   const __m256d tmp_qloop_96 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_91,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_92,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_95);
                   const __m256d tmp_qloop_99 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_91,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_92,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_100 = _mm256_mul_pd(tmp_qloop_46,tmp_qloop_99);
                   const __m256d tmp_qloop_104 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE[7*q + 6],_data_tabulated_and_untitled_1_0_BLUE[7*q + 6],_data_tabulated_and_untitled_1_0_BLUE[7*q + 6],_data_tabulated_and_untitled_1_0_BLUE[7*q + 6]));
                   const __m256d tmp_qloop_105 = _mm256_add_pd(tmp_qloop_103,tmp_qloop_104);
                   const __m256d tmp_qloop_106 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_101,tmp_qloop_102),tmp_qloop_105);
                   const __m256d tmp_qloop_108 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE[7*q + 2],_data_tabulated_and_untitled_1_1_BLUE[7*q + 2],_data_tabulated_and_untitled_1_1_BLUE[7*q + 2],_data_tabulated_and_untitled_1_1_BLUE[7*q + 2]));
                   const __m256d tmp_qloop_109 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_95);
                   const __m256d tmp_qloop_110 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_111 = _mm256_mul_pd(tmp_qloop_110,tmp_qloop_46);
                   const __m256d tmp_qloop_114 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_105,tmp_qloop_112),tmp_qloop_113);
                   const __m256d tmp_qloop_116 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE[7*q + 3],_data_tabulated_and_untitled_1_1_BLUE[7*q + 3],_data_tabulated_and_untitled_1_1_BLUE[7*q + 3],_data_tabulated_and_untitled_1_1_BLUE[7*q + 3]));
                   const __m256d tmp_qloop_117 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_115,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_116,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_95);
                   const __m256d tmp_qloop_118 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_115,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_116,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_119 = _mm256_mul_pd(tmp_qloop_118,tmp_qloop_46);
                   const __m256d tmp_qloop_122 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_105,tmp_qloop_120),tmp_qloop_121);
                   const __m256d tmp_qloop_124 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE[7*q + 4],_data_tabulated_and_untitled_1_1_BLUE[7*q + 4],_data_tabulated_and_untitled_1_1_BLUE[7*q + 4],_data_tabulated_and_untitled_1_1_BLUE[7*q + 4]));
                   const __m256d tmp_qloop_125 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_123,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_124,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_95);
                   const __m256d tmp_qloop_126 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_123,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_124,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_127 = _mm256_mul_pd(tmp_qloop_126,tmp_qloop_46);
                   const __m256d tmp_qloop_130 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_105,tmp_qloop_128),tmp_qloop_129);
                   const __m256d tmp_qloop_132 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE[7*q + 5],_data_tabulated_and_untitled_1_1_BLUE[7*q + 5],_data_tabulated_and_untitled_1_1_BLUE[7*q + 5],_data_tabulated_and_untitled_1_1_BLUE[7*q + 5]));
                   const __m256d tmp_qloop_133 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_131,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_132,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_95);
                   const __m256d tmp_qloop_134 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_131,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_132,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_135 = _mm256_mul_pd(tmp_qloop_134,tmp_qloop_46);
                   const __m256d tmp_qloop_138 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_105,tmp_qloop_136),tmp_qloop_137);
                   const __m256d tmp_qloop_140 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE[7*q + 6],_data_tabulated_and_untitled_1_1_BLUE[7*q + 6],_data_tabulated_and_untitled_1_1_BLUE[7*q + 6],_data_tabulated_and_untitled_1_1_BLUE[7*q + 6]));
                   const __m256d tmp_qloop_141 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_140,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_95);
                   const __m256d tmp_qloop_142 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_140,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_143 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_46);
                   const __m256d tmp_qloop_146 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_105,tmp_qloop_144),tmp_qloop_145);
                   const __m256d tmp_qloop_147 = _mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(tmp_qloop_42,tmp_qloop_56),tmp_qloop_57));
                   const __m256d tmp_qloop_149 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_53,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_60),tmp_qloop_61);
                   const __m256d tmp_qloop_151 = _mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(tmp_qloop_42,tmp_qloop_63),tmp_qloop_64));
                   const __m256d tmp_qloop_153 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_53,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_67),tmp_qloop_68);
                   const __m256d tmp_qloop_155 = _mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(tmp_qloop_42,tmp_qloop_70),tmp_qloop_71));
                   const __m256d tmp_qloop_157 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_53,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_74),tmp_qloop_75);
                   const __m256d tmp_qloop_159 = _mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(tmp_qloop_42,tmp_qloop_77),tmp_qloop_78));
                   const __m256d tmp_qloop_161 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_53,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_81),tmp_qloop_82);
                   const __m256d tmp_qloop_163 = _mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(tmp_qloop_42,tmp_qloop_84),tmp_qloop_85));
                   const __m256d tmp_qloop_165 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_53,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_88),tmp_qloop_89);
                   const __m256d tmp_qloop_168 = _mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(tmp_qloop_167,tmp_qloop_91),tmp_qloop_92));
                   const __m256d tmp_qloop_170 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_91,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_92,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_171 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_172 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_101),tmp_qloop_102);
                   const __m256d tmp_qloop_173 = _mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(tmp_qloop_107,tmp_qloop_108),tmp_qloop_167));
                   const __m256d tmp_qloop_174 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_175 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_112),tmp_qloop_113);
                   const __m256d tmp_qloop_176 = _mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(tmp_qloop_115,tmp_qloop_116),tmp_qloop_167));
                   const __m256d tmp_qloop_177 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_115,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_116,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_178 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_120),tmp_qloop_121);
                   const __m256d tmp_qloop_179 = _mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(tmp_qloop_123,tmp_qloop_124),tmp_qloop_167));
                   const __m256d tmp_qloop_180 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_123,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_124,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_181 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_128),tmp_qloop_129);
                   const __m256d tmp_qloop_182 = _mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(tmp_qloop_131,tmp_qloop_132),tmp_qloop_167));
                   const __m256d tmp_qloop_183 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_131,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_132,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_184 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_136),tmp_qloop_137);
                   const __m256d hessian_blending_0_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_14),tmp_qloop_28);
                   const __m256d hessian_blending_1_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_29,tmp_qloop_4)),_mm256_mul_pd(tmp_qloop_3,tmp_qloop_32)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_3,tmp_qloop_3),tmp_qloop_3)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d hessian_blending_0_0_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_15,tmp_qloop_30),_mm256_set_pd(-2.0,-2.0,-2.0,-2.0)),_mm256_set_pd(tmp_qloop_1,tmp_qloop_1,tmp_qloop_1,tmp_qloop_1)),_mm256_set_pd(tmp_qloop_11,tmp_qloop_11,tmp_qloop_11,tmp_qloop_11)));
                   const __m256d hessian_blending_1_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_20,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(tmp_qloop_35,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_6,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_1,tmp_qloop_1,tmp_qloop_1,tmp_qloop_1)),_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9)));
                   const __m256d hessian_blending_0_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_15,tmp_qloop_2),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9)));
                   const __m256d hessian_blending_1_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_20,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_35,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_27),tmp_qloop_36);
                   const __m256d hessian_blending_0_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_32),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_0,tmp_qloop_0),tmp_qloop_0),tmp_qloop_26),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_25),tmp_qloop_36);
                   const __m256d hessian_blending_1_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_33,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_15,tmp_qloop_2),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_set_pd(tmp_qloop_7,tmp_qloop_7,tmp_qloop_7,tmp_qloop_7)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_15,tmp_qloop_4),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9)));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_45,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_38,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(tmp_qloop_54,_mm256_add_pd(_mm256_add_pd(tmp_qloop_48,tmp_qloop_49),tmp_qloop_52))),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_38,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_41)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_1 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_45,tmp_qloop_59),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_62)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_44,tmp_qloop_58),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_2 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_45,tmp_qloop_66),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_69)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_44,tmp_qloop_65),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_3 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_45,tmp_qloop_73),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_76)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_44,tmp_qloop_72),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_4 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_45,tmp_qloop_80),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_83)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_44,tmp_qloop_79),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_5 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_45,tmp_qloop_87),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_90)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_44,tmp_qloop_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_6 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,tmp_qloop_54),tmp_qloop_100),tmp_qloop_98)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_44,tmp_qloop_96),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_7 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_114,tmp_qloop_54),tmp_qloop_111),tmp_qloop_98)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_109,tmp_qloop_44),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_8 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_122,tmp_qloop_54),tmp_qloop_119),tmp_qloop_98)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_117,tmp_qloop_44),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_9 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_54),tmp_qloop_127),tmp_qloop_98)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_125,tmp_qloop_44),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_10 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_54),tmp_qloop_135),tmp_qloop_98)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_44),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_146,tmp_qloop_54),tmp_qloop_143),tmp_qloop_98)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_44),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_148,tmp_qloop_59),_mm256_mul_pd(tmp_qloop_149,tmp_qloop_62)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_147,tmp_qloop_58),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_2 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_148,tmp_qloop_66),_mm256_mul_pd(tmp_qloop_149,tmp_qloop_69)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_147,tmp_qloop_65),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_3 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_148,tmp_qloop_73),_mm256_mul_pd(tmp_qloop_149,tmp_qloop_76)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_147,tmp_qloop_72),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_4 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_148,tmp_qloop_80),_mm256_mul_pd(tmp_qloop_149,tmp_qloop_83)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_147,tmp_qloop_79),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_5 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_148,tmp_qloop_87),_mm256_mul_pd(tmp_qloop_149,tmp_qloop_90)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_147,tmp_qloop_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_6 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,tmp_qloop_149),tmp_qloop_100),tmp_qloop_150)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_147,tmp_qloop_96),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_7 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_114,tmp_qloop_149),tmp_qloop_111),tmp_qloop_150)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_109,tmp_qloop_147),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_8 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_122,tmp_qloop_149),tmp_qloop_119),tmp_qloop_150)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_117,tmp_qloop_147),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_9 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_149),tmp_qloop_127),tmp_qloop_150)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_125,tmp_qloop_147),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_10 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_149),tmp_qloop_135),tmp_qloop_150)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_147),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_146,tmp_qloop_149),tmp_qloop_143),tmp_qloop_150)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_147),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,tmp_qloop_66),_mm256_mul_pd(tmp_qloop_153,tmp_qloop_69)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_151,tmp_qloop_65),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_3 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,tmp_qloop_73),_mm256_mul_pd(tmp_qloop_153,tmp_qloop_76)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_151,tmp_qloop_72),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_4 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,tmp_qloop_80),_mm256_mul_pd(tmp_qloop_153,tmp_qloop_83)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_151,tmp_qloop_79),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_5 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,tmp_qloop_87),_mm256_mul_pd(tmp_qloop_153,tmp_qloop_90)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_151,tmp_qloop_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_6 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,tmp_qloop_153),tmp_qloop_100),tmp_qloop_154)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_151,tmp_qloop_96),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_7 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_114,tmp_qloop_153),tmp_qloop_111),tmp_qloop_154)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_109,tmp_qloop_151),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_8 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_122,tmp_qloop_153),tmp_qloop_119),tmp_qloop_154)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_117,tmp_qloop_151),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_9 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_153),tmp_qloop_127),tmp_qloop_154)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_125,tmp_qloop_151),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_10 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_153),tmp_qloop_135),tmp_qloop_154)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_151),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_146,tmp_qloop_153),tmp_qloop_143),tmp_qloop_154)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_151),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_156,tmp_qloop_73),_mm256_mul_pd(tmp_qloop_157,tmp_qloop_76)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_155,tmp_qloop_72),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_4 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_156,tmp_qloop_80),_mm256_mul_pd(tmp_qloop_157,tmp_qloop_83)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_155,tmp_qloop_79),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_5 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_156,tmp_qloop_87),_mm256_mul_pd(tmp_qloop_157,tmp_qloop_90)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_155,tmp_qloop_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_6 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,tmp_qloop_157),tmp_qloop_100),tmp_qloop_158)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_155,tmp_qloop_96),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_7 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_114,tmp_qloop_157),tmp_qloop_111),tmp_qloop_158)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_109,tmp_qloop_155),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_8 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_122,tmp_qloop_157),tmp_qloop_119),tmp_qloop_158)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_117,tmp_qloop_155),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_9 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_157),tmp_qloop_127),tmp_qloop_158)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_125,tmp_qloop_155),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_10 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_157),tmp_qloop_135),tmp_qloop_158)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_155),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_146,tmp_qloop_157),tmp_qloop_143),tmp_qloop_158)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_155),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_160,tmp_qloop_80),_mm256_mul_pd(tmp_qloop_161,tmp_qloop_83)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_159,tmp_qloop_79),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_5 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_160,tmp_qloop_87),_mm256_mul_pd(tmp_qloop_161,tmp_qloop_90)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_159,tmp_qloop_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_6 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,tmp_qloop_161),tmp_qloop_100),tmp_qloop_162)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_159,tmp_qloop_96),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_7 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_114,tmp_qloop_161),tmp_qloop_111),tmp_qloop_162)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_109,tmp_qloop_159),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_8 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_122,tmp_qloop_161),tmp_qloop_119),tmp_qloop_162)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_117,tmp_qloop_159),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_9 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_161),tmp_qloop_127),tmp_qloop_162)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_125,tmp_qloop_159),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_10 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_161),tmp_qloop_135),tmp_qloop_162)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_159),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_146,tmp_qloop_161),tmp_qloop_143),tmp_qloop_162)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_159),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_164,tmp_qloop_87),_mm256_mul_pd(tmp_qloop_165,tmp_qloop_90)),tmp_qloop_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_163,tmp_qloop_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_6 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,tmp_qloop_165),tmp_qloop_100),tmp_qloop_166)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_163,tmp_qloop_96),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_7 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_114,tmp_qloop_165),tmp_qloop_111),tmp_qloop_166)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_109,tmp_qloop_163),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_8 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_122,tmp_qloop_165),tmp_qloop_119),tmp_qloop_166)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_117,tmp_qloop_163),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_9 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_130,tmp_qloop_165),tmp_qloop_127),tmp_qloop_166)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_125,tmp_qloop_163),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_10 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_165),tmp_qloop_135),tmp_qloop_166)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_163),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_146,tmp_qloop_165),tmp_qloop_143),tmp_qloop_166)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_163),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,tmp_qloop_172),_mm256_mul_pd(tmp_qloop_170,tmp_qloop_99)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_168,tmp_qloop_96),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_7 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,tmp_qloop_170),_mm256_mul_pd(tmp_qloop_114,tmp_qloop_172)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_109,tmp_qloop_168),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_8 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_170),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_172)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_117,tmp_qloop_168),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_9 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_126,tmp_qloop_170),_mm256_mul_pd(tmp_qloop_130,tmp_qloop_172)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_125,tmp_qloop_168),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_10 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_134,tmp_qloop_170),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_172)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_168),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_142,tmp_qloop_170),_mm256_mul_pd(tmp_qloop_146,tmp_qloop_172)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_168),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,tmp_qloop_174),_mm256_mul_pd(tmp_qloop_114,tmp_qloop_175)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_109,tmp_qloop_173),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_8 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_174),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_175)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_117,tmp_qloop_173),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_9 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_126,tmp_qloop_174),_mm256_mul_pd(tmp_qloop_130,tmp_qloop_175)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_125,tmp_qloop_173),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_10 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_134,tmp_qloop_174),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_175)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_173),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_142,tmp_qloop_174),_mm256_mul_pd(tmp_qloop_146,tmp_qloop_175)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_173),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_177),_mm256_mul_pd(tmp_qloop_122,tmp_qloop_178)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_117,tmp_qloop_176),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_9 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_126,tmp_qloop_177),_mm256_mul_pd(tmp_qloop_130,tmp_qloop_178)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_125,tmp_qloop_176),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_10 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_134,tmp_qloop_177),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_178)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_176),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_142,tmp_qloop_177),_mm256_mul_pd(tmp_qloop_146,tmp_qloop_178)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_176),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_126,tmp_qloop_180),_mm256_mul_pd(tmp_qloop_130,tmp_qloop_181)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_125,tmp_qloop_179),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_10 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_134,tmp_qloop_180),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_181)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_179),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_142,tmp_qloop_180),_mm256_mul_pd(tmp_qloop_146,tmp_qloop_181)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_179),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_10 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_134,tmp_qloop_183),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_184)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_133,tmp_qloop_182),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_142,tmp_qloop_183),_mm256_mul_pd(tmp_qloop_146,tmp_qloop_184)),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_182),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_11 = _mm256_mul_pd(tmp_qloop_55,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_43,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_142,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_140,_mm256_set_pd(1.0,1.0,1.0,1.0)))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_146,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_144,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_145,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_171)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_169)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_141,tmp_qloop_43),_mm256_add_pd(_mm256_add_pd(tmp_qloop_139,tmp_qloop_140),tmp_qloop_167)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_0_1 = _mm256_add_pd(q_acc_0_1,q_tmp_0_1);
                   q_acc_0_2 = _mm256_add_pd(q_acc_0_2,q_tmp_0_2);
                   q_acc_0_3 = _mm256_add_pd(q_acc_0_3,q_tmp_0_3);
                   q_acc_0_4 = _mm256_add_pd(q_acc_0_4,q_tmp_0_4);
                   q_acc_0_5 = _mm256_add_pd(q_acc_0_5,q_tmp_0_5);
                   q_acc_0_6 = _mm256_add_pd(q_acc_0_6,q_tmp_0_6);
                   q_acc_0_7 = _mm256_add_pd(q_acc_0_7,q_tmp_0_7);
                   q_acc_0_8 = _mm256_add_pd(q_acc_0_8,q_tmp_0_8);
                   q_acc_0_9 = _mm256_add_pd(q_acc_0_9,q_tmp_0_9);
                   q_acc_0_10 = _mm256_add_pd(q_acc_0_10,q_tmp_0_10);
                   q_acc_0_11 = _mm256_add_pd(q_acc_0_11,q_tmp_0_11);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_1_2 = _mm256_add_pd(q_acc_1_2,q_tmp_1_2);
                   q_acc_1_3 = _mm256_add_pd(q_acc_1_3,q_tmp_1_3);
                   q_acc_1_4 = _mm256_add_pd(q_acc_1_4,q_tmp_1_4);
                   q_acc_1_5 = _mm256_add_pd(q_acc_1_5,q_tmp_1_5);
                   q_acc_1_6 = _mm256_add_pd(q_acc_1_6,q_tmp_1_6);
                   q_acc_1_7 = _mm256_add_pd(q_acc_1_7,q_tmp_1_7);
                   q_acc_1_8 = _mm256_add_pd(q_acc_1_8,q_tmp_1_8);
                   q_acc_1_9 = _mm256_add_pd(q_acc_1_9,q_tmp_1_9);
                   q_acc_1_10 = _mm256_add_pd(q_acc_1_10,q_tmp_1_10);
                   q_acc_1_11 = _mm256_add_pd(q_acc_1_11,q_tmp_1_11);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_2_3 = _mm256_add_pd(q_acc_2_3,q_tmp_2_3);
                   q_acc_2_4 = _mm256_add_pd(q_acc_2_4,q_tmp_2_4);
                   q_acc_2_5 = _mm256_add_pd(q_acc_2_5,q_tmp_2_5);
                   q_acc_2_6 = _mm256_add_pd(q_acc_2_6,q_tmp_2_6);
                   q_acc_2_7 = _mm256_add_pd(q_acc_2_7,q_tmp_2_7);
                   q_acc_2_8 = _mm256_add_pd(q_acc_2_8,q_tmp_2_8);
                   q_acc_2_9 = _mm256_add_pd(q_acc_2_9,q_tmp_2_9);
                   q_acc_2_10 = _mm256_add_pd(q_acc_2_10,q_tmp_2_10);
                   q_acc_2_11 = _mm256_add_pd(q_acc_2_11,q_tmp_2_11);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_3_4 = _mm256_add_pd(q_acc_3_4,q_tmp_3_4);
                   q_acc_3_5 = _mm256_add_pd(q_acc_3_5,q_tmp_3_5);
                   q_acc_3_6 = _mm256_add_pd(q_acc_3_6,q_tmp_3_6);
                   q_acc_3_7 = _mm256_add_pd(q_acc_3_7,q_tmp_3_7);
                   q_acc_3_8 = _mm256_add_pd(q_acc_3_8,q_tmp_3_8);
                   q_acc_3_9 = _mm256_add_pd(q_acc_3_9,q_tmp_3_9);
                   q_acc_3_10 = _mm256_add_pd(q_acc_3_10,q_tmp_3_10);
                   q_acc_3_11 = _mm256_add_pd(q_acc_3_11,q_tmp_3_11);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_4_5 = _mm256_add_pd(q_acc_4_5,q_tmp_4_5);
                   q_acc_4_6 = _mm256_add_pd(q_acc_4_6,q_tmp_4_6);
                   q_acc_4_7 = _mm256_add_pd(q_acc_4_7,q_tmp_4_7);
                   q_acc_4_8 = _mm256_add_pd(q_acc_4_8,q_tmp_4_8);
                   q_acc_4_9 = _mm256_add_pd(q_acc_4_9,q_tmp_4_9);
                   q_acc_4_10 = _mm256_add_pd(q_acc_4_10,q_tmp_4_10);
                   q_acc_4_11 = _mm256_add_pd(q_acc_4_11,q_tmp_4_11);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_5_6 = _mm256_add_pd(q_acc_5_6,q_tmp_5_6);
                   q_acc_5_7 = _mm256_add_pd(q_acc_5_7,q_tmp_5_7);
                   q_acc_5_8 = _mm256_add_pd(q_acc_5_8,q_tmp_5_8);
                   q_acc_5_9 = _mm256_add_pd(q_acc_5_9,q_tmp_5_9);
                   q_acc_5_10 = _mm256_add_pd(q_acc_5_10,q_tmp_5_10);
                   q_acc_5_11 = _mm256_add_pd(q_acc_5_11,q_tmp_5_11);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_6_7 = _mm256_add_pd(q_acc_6_7,q_tmp_6_7);
                   q_acc_6_8 = _mm256_add_pd(q_acc_6_8,q_tmp_6_8);
                   q_acc_6_9 = _mm256_add_pd(q_acc_6_9,q_tmp_6_9);
                   q_acc_6_10 = _mm256_add_pd(q_acc_6_10,q_tmp_6_10);
                   q_acc_6_11 = _mm256_add_pd(q_acc_6_11,q_tmp_6_11);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_7_8 = _mm256_add_pd(q_acc_7_8,q_tmp_7_8);
                   q_acc_7_9 = _mm256_add_pd(q_acc_7_9,q_tmp_7_9);
                   q_acc_7_10 = _mm256_add_pd(q_acc_7_10,q_tmp_7_10);
                   q_acc_7_11 = _mm256_add_pd(q_acc_7_11,q_tmp_7_11);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_8_9 = _mm256_add_pd(q_acc_8_9,q_tmp_8_9);
                   q_acc_8_10 = _mm256_add_pd(q_acc_8_10,q_tmp_8_10);
                   q_acc_8_11 = _mm256_add_pd(q_acc_8_11,q_tmp_8_11);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                   q_acc_9_10 = _mm256_add_pd(q_acc_9_10,q_tmp_9_10);
                   q_acc_9_11 = _mm256_add_pd(q_acc_9_11,q_tmp_9_11);
                   q_acc_10_10 = _mm256_add_pd(q_acc_10_10,q_tmp_10_10);
                   q_acc_10_11 = _mm256_add_pd(q_acc_10_11,q_tmp_10_11);
                   q_acc_11_11 = _mm256_add_pd(q_acc_11_11,q_tmp_11_11);
                }
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_0,src_dof_0),_mm256_mul_pd(q_acc_0_1,src_dof_1)),_mm256_mul_pd(q_acc_0_10,src_dof_10)),_mm256_mul_pd(q_acc_0_11,src_dof_11)),_mm256_mul_pd(q_acc_0_2,src_dof_2)),_mm256_mul_pd(q_acc_0_3,src_dof_3)),_mm256_mul_pd(q_acc_0_4,src_dof_4)),_mm256_mul_pd(q_acc_0_5,src_dof_5)),_mm256_mul_pd(q_acc_0_6,src_dof_6)),_mm256_mul_pd(q_acc_0_7,src_dof_7)),_mm256_mul_pd(q_acc_0_8,src_dof_8)),_mm256_mul_pd(q_acc_0_9,src_dof_9));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_1,src_dof_0),_mm256_mul_pd(q_acc_1_1,src_dof_1)),_mm256_mul_pd(q_acc_1_10,src_dof_10)),_mm256_mul_pd(q_acc_1_11,src_dof_11)),_mm256_mul_pd(q_acc_1_2,src_dof_2)),_mm256_mul_pd(q_acc_1_3,src_dof_3)),_mm256_mul_pd(q_acc_1_4,src_dof_4)),_mm256_mul_pd(q_acc_1_5,src_dof_5)),_mm256_mul_pd(q_acc_1_6,src_dof_6)),_mm256_mul_pd(q_acc_1_7,src_dof_7)),_mm256_mul_pd(q_acc_1_8,src_dof_8)),_mm256_mul_pd(q_acc_1_9,src_dof_9));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_2,src_dof_0),_mm256_mul_pd(q_acc_1_2,src_dof_1)),_mm256_mul_pd(q_acc_2_10,src_dof_10)),_mm256_mul_pd(q_acc_2_11,src_dof_11)),_mm256_mul_pd(q_acc_2_2,src_dof_2)),_mm256_mul_pd(q_acc_2_3,src_dof_3)),_mm256_mul_pd(q_acc_2_4,src_dof_4)),_mm256_mul_pd(q_acc_2_5,src_dof_5)),_mm256_mul_pd(q_acc_2_6,src_dof_6)),_mm256_mul_pd(q_acc_2_7,src_dof_7)),_mm256_mul_pd(q_acc_2_8,src_dof_8)),_mm256_mul_pd(q_acc_2_9,src_dof_9));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_3,src_dof_0),_mm256_mul_pd(q_acc_1_3,src_dof_1)),_mm256_mul_pd(q_acc_2_3,src_dof_2)),_mm256_mul_pd(q_acc_3_10,src_dof_10)),_mm256_mul_pd(q_acc_3_11,src_dof_11)),_mm256_mul_pd(q_acc_3_3,src_dof_3)),_mm256_mul_pd(q_acc_3_4,src_dof_4)),_mm256_mul_pd(q_acc_3_5,src_dof_5)),_mm256_mul_pd(q_acc_3_6,src_dof_6)),_mm256_mul_pd(q_acc_3_7,src_dof_7)),_mm256_mul_pd(q_acc_3_8,src_dof_8)),_mm256_mul_pd(q_acc_3_9,src_dof_9));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_4,src_dof_0),_mm256_mul_pd(q_acc_1_4,src_dof_1)),_mm256_mul_pd(q_acc_2_4,src_dof_2)),_mm256_mul_pd(q_acc_3_4,src_dof_3)),_mm256_mul_pd(q_acc_4_10,src_dof_10)),_mm256_mul_pd(q_acc_4_11,src_dof_11)),_mm256_mul_pd(q_acc_4_4,src_dof_4)),_mm256_mul_pd(q_acc_4_5,src_dof_5)),_mm256_mul_pd(q_acc_4_6,src_dof_6)),_mm256_mul_pd(q_acc_4_7,src_dof_7)),_mm256_mul_pd(q_acc_4_8,src_dof_8)),_mm256_mul_pd(q_acc_4_9,src_dof_9));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_5,src_dof_0),_mm256_mul_pd(q_acc_1_5,src_dof_1)),_mm256_mul_pd(q_acc_2_5,src_dof_2)),_mm256_mul_pd(q_acc_3_5,src_dof_3)),_mm256_mul_pd(q_acc_4_5,src_dof_4)),_mm256_mul_pd(q_acc_5_10,src_dof_10)),_mm256_mul_pd(q_acc_5_11,src_dof_11)),_mm256_mul_pd(q_acc_5_5,src_dof_5)),_mm256_mul_pd(q_acc_5_6,src_dof_6)),_mm256_mul_pd(q_acc_5_7,src_dof_7)),_mm256_mul_pd(q_acc_5_8,src_dof_8)),_mm256_mul_pd(q_acc_5_9,src_dof_9));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_6,src_dof_0),_mm256_mul_pd(q_acc_1_6,src_dof_1)),_mm256_mul_pd(q_acc_2_6,src_dof_2)),_mm256_mul_pd(q_acc_3_6,src_dof_3)),_mm256_mul_pd(q_acc_4_6,src_dof_4)),_mm256_mul_pd(q_acc_5_6,src_dof_5)),_mm256_mul_pd(q_acc_6_10,src_dof_10)),_mm256_mul_pd(q_acc_6_11,src_dof_11)),_mm256_mul_pd(q_acc_6_6,src_dof_6)),_mm256_mul_pd(q_acc_6_7,src_dof_7)),_mm256_mul_pd(q_acc_6_8,src_dof_8)),_mm256_mul_pd(q_acc_6_9,src_dof_9));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_7,src_dof_0),_mm256_mul_pd(q_acc_1_7,src_dof_1)),_mm256_mul_pd(q_acc_2_7,src_dof_2)),_mm256_mul_pd(q_acc_3_7,src_dof_3)),_mm256_mul_pd(q_acc_4_7,src_dof_4)),_mm256_mul_pd(q_acc_5_7,src_dof_5)),_mm256_mul_pd(q_acc_6_7,src_dof_6)),_mm256_mul_pd(q_acc_7_10,src_dof_10)),_mm256_mul_pd(q_acc_7_11,src_dof_11)),_mm256_mul_pd(q_acc_7_7,src_dof_7)),_mm256_mul_pd(q_acc_7_8,src_dof_8)),_mm256_mul_pd(q_acc_7_9,src_dof_9));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_8,src_dof_0),_mm256_mul_pd(q_acc_1_8,src_dof_1)),_mm256_mul_pd(q_acc_2_8,src_dof_2)),_mm256_mul_pd(q_acc_3_8,src_dof_3)),_mm256_mul_pd(q_acc_4_8,src_dof_4)),_mm256_mul_pd(q_acc_5_8,src_dof_5)),_mm256_mul_pd(q_acc_6_8,src_dof_6)),_mm256_mul_pd(q_acc_7_8,src_dof_7)),_mm256_mul_pd(q_acc_8_10,src_dof_10)),_mm256_mul_pd(q_acc_8_11,src_dof_11)),_mm256_mul_pd(q_acc_8_8,src_dof_8)),_mm256_mul_pd(q_acc_8_9,src_dof_9));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_9,src_dof_0),_mm256_mul_pd(q_acc_1_9,src_dof_1)),_mm256_mul_pd(q_acc_2_9,src_dof_2)),_mm256_mul_pd(q_acc_3_9,src_dof_3)),_mm256_mul_pd(q_acc_4_9,src_dof_4)),_mm256_mul_pd(q_acc_5_9,src_dof_5)),_mm256_mul_pd(q_acc_6_9,src_dof_6)),_mm256_mul_pd(q_acc_7_9,src_dof_7)),_mm256_mul_pd(q_acc_8_9,src_dof_8)),_mm256_mul_pd(q_acc_9_10,src_dof_10)),_mm256_mul_pd(q_acc_9_11,src_dof_11)),_mm256_mul_pd(q_acc_9_9,src_dof_9));
                const __m256d elMatVec_10 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_10,src_dof_0),_mm256_mul_pd(q_acc_10_10,src_dof_10)),_mm256_mul_pd(q_acc_10_11,src_dof_11)),_mm256_mul_pd(q_acc_1_10,src_dof_1)),_mm256_mul_pd(q_acc_2_10,src_dof_2)),_mm256_mul_pd(q_acc_3_10,src_dof_3)),_mm256_mul_pd(q_acc_4_10,src_dof_4)),_mm256_mul_pd(q_acc_5_10,src_dof_5)),_mm256_mul_pd(q_acc_6_10,src_dof_6)),_mm256_mul_pd(q_acc_7_10,src_dof_7)),_mm256_mul_pd(q_acc_8_10,src_dof_8)),_mm256_mul_pd(q_acc_9_10,src_dof_9));
                const __m256d elMatVec_11 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_11,src_dof_0),_mm256_mul_pd(q_acc_10_11,src_dof_10)),_mm256_mul_pd(q_acc_11_11,src_dof_11)),_mm256_mul_pd(q_acc_1_11,src_dof_1)),_mm256_mul_pd(q_acc_2_11,src_dof_2)),_mm256_mul_pd(q_acc_3_11,src_dof_3)),_mm256_mul_pd(q_acc_4_11,src_dof_4)),_mm256_mul_pd(q_acc_5_11,src_dof_5)),_mm256_mul_pd(q_acc_6_11,src_dof_6)),_mm256_mul_pd(q_acc_7_11,src_dof_7)),_mm256_mul_pd(q_acc_8_11,src_dof_8)),_mm256_mul_pd(q_acc_9_11,src_dof_9));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1],_mm256_add_pd(elMatVec_10,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))],_mm256_add_pd(elMatVec_11,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
                const real_t src_dof_3 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
                const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t src_dof_6 = _data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t src_dof_7 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t src_dof_8 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
                const real_t src_dof_9 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t src_dof_10 = _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
                const real_t src_dof_11 = _data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t mu_dof_1 = _data_mu[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t mu_dof_2 = _data_mu[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_0_1 = 0.0;
                real_t q_acc_0_2 = 0.0;
                real_t q_acc_0_3 = 0.0;
                real_t q_acc_0_4 = 0.0;
                real_t q_acc_0_5 = 0.0;
                real_t q_acc_0_6 = 0.0;
                real_t q_acc_0_7 = 0.0;
                real_t q_acc_0_8 = 0.0;
                real_t q_acc_0_9 = 0.0;
                real_t q_acc_0_10 = 0.0;
                real_t q_acc_0_11 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_1_2 = 0.0;
                real_t q_acc_1_3 = 0.0;
                real_t q_acc_1_4 = 0.0;
                real_t q_acc_1_5 = 0.0;
                real_t q_acc_1_6 = 0.0;
                real_t q_acc_1_7 = 0.0;
                real_t q_acc_1_8 = 0.0;
                real_t q_acc_1_9 = 0.0;
                real_t q_acc_1_10 = 0.0;
                real_t q_acc_1_11 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_2_3 = 0.0;
                real_t q_acc_2_4 = 0.0;
                real_t q_acc_2_5 = 0.0;
                real_t q_acc_2_6 = 0.0;
                real_t q_acc_2_7 = 0.0;
                real_t q_acc_2_8 = 0.0;
                real_t q_acc_2_9 = 0.0;
                real_t q_acc_2_10 = 0.0;
                real_t q_acc_2_11 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_3_4 = 0.0;
                real_t q_acc_3_5 = 0.0;
                real_t q_acc_3_6 = 0.0;
                real_t q_acc_3_7 = 0.0;
                real_t q_acc_3_8 = 0.0;
                real_t q_acc_3_9 = 0.0;
                real_t q_acc_3_10 = 0.0;
                real_t q_acc_3_11 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_4_5 = 0.0;
                real_t q_acc_4_6 = 0.0;
                real_t q_acc_4_7 = 0.0;
                real_t q_acc_4_8 = 0.0;
                real_t q_acc_4_9 = 0.0;
                real_t q_acc_4_10 = 0.0;
                real_t q_acc_4_11 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_5_6 = 0.0;
                real_t q_acc_5_7 = 0.0;
                real_t q_acc_5_8 = 0.0;
                real_t q_acc_5_9 = 0.0;
                real_t q_acc_5_10 = 0.0;
                real_t q_acc_5_11 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_6_7 = 0.0;
                real_t q_acc_6_8 = 0.0;
                real_t q_acc_6_9 = 0.0;
                real_t q_acc_6_10 = 0.0;
                real_t q_acc_6_11 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_7_8 = 0.0;
                real_t q_acc_7_9 = 0.0;
                real_t q_acc_7_10 = 0.0;
                real_t q_acc_7_11 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_8_9 = 0.0;
                real_t q_acc_8_10 = 0.0;
                real_t q_acc_8_11 = 0.0;
                real_t q_acc_9_9 = 0.0;
                real_t q_acc_9_10 = 0.0;
                real_t q_acc_9_11 = 0.0;
                real_t q_acc_10_10 = 0.0;
                real_t q_acc_10_11 = 0.0;
                real_t q_acc_11_11 = 0.0;
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const real_t tmp_qloop_0 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q];
                   const real_t tmp_qloop_2 = (tmp_qloop_0*tmp_qloop_0);
                   const real_t tmp_qloop_3 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q];
                   const real_t tmp_qloop_4 = (tmp_qloop_3*tmp_qloop_3);
                   const real_t tmp_qloop_5 = tmp_qloop_2 + tmp_qloop_4;
                   const real_t tmp_qloop_6 = pow(tmp_qloop_5, -0.50000000000000000);
                   const real_t tmp_qloop_13 = tmp_qloop_12*tmp_qloop_6;
                   const real_t tmp_qloop_14 = tmp_qloop_1*tmp_qloop_13;
                   const real_t tmp_qloop_15 = pow(tmp_qloop_5, -1.5000000000000000);
                   const real_t tmp_qloop_16 = radRayVertex + tmp_qloop_11*(tmp_qloop_1*(-rayVertex_0 + tmp_qloop_0) - tmp_qloop_8*(-rayVertex_1 + tmp_qloop_3));
                   const real_t tmp_qloop_17 = tmp_qloop_15*tmp_qloop_16;
                   const real_t tmp_qloop_18 = tmp_qloop_17*1.0;
                   const real_t tmp_qloop_19 = tmp_qloop_13*tmp_qloop_8;
                   const real_t tmp_qloop_20 = tmp_qloop_0*tmp_qloop_18;
                   const real_t tmp_qloop_23 = tmp_qloop_12*tmp_qloop_15;
                   const real_t tmp_qloop_24 = tmp_qloop_1*tmp_qloop_23;
                   const real_t tmp_qloop_25 = tmp_qloop_2*tmp_qloop_24;
                   const real_t tmp_qloop_26 = tmp_qloop_16*pow(tmp_qloop_5, -2.5000000000000000)*3.0;
                   const real_t tmp_qloop_27 = tmp_qloop_0*tmp_qloop_26*tmp_qloop_4;
                   const real_t tmp_qloop_28 = tmp_qloop_24*tmp_qloop_4 - tmp_qloop_27;
                   const real_t tmp_qloop_29 = tmp_qloop_23*tmp_qloop_7;
                   const real_t tmp_qloop_30 = tmp_qloop_0*tmp_qloop_3;
                   const real_t tmp_qloop_31 = tmp_qloop_24*tmp_qloop_30;
                   const real_t tmp_qloop_32 = tmp_qloop_17*2.0;
                   const real_t tmp_qloop_33 = tmp_qloop_2*tmp_qloop_26*tmp_qloop_3;
                   const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_3 - tmp_qloop_33;
                   const real_t tmp_qloop_35 = tmp_qloop_29*tmp_qloop_30;
                   const real_t tmp_qloop_36 = tmp_qloop_23*tmp_qloop_30*tmp_qloop_8;
                   const real_t tmp_qloop_55 = (mu_dof_0*_data_phi_0_0_BLUE[3*q] + mu_dof_1*_data_phi_0_0_BLUE[3*q + 1] + mu_dof_2*_data_phi_0_0_BLUE[3*q + 2])*_data_q_w[q];
                   const real_t jac_blending_0_0 = tmp_qloop_0*tmp_qloop_14 + tmp_qloop_18*tmp_qloop_4;
                   const real_t jac_blending_0_1 = -tmp_qloop_0*tmp_qloop_15*tmp_qloop_16*tmp_qloop_3 - tmp_qloop_0*tmp_qloop_19;
                   const real_t jac_blending_1_0 = tmp_qloop_14*tmp_qloop_3 - tmp_qloop_20*tmp_qloop_3;
                   const real_t jac_blending_1_1 = tmp_qloop_15*tmp_qloop_16*tmp_qloop_2*1.0 - tmp_qloop_19*tmp_qloop_3;
                   const real_t tmp_qloop_21 = jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0;
                   const real_t tmp_qloop_22 = 1.0 / (tmp_qloop_21);
                   const real_t abs_det_jac_blending = tmp_qloop_21;
                   const real_t tmp_qloop_43 = abs_det_jac_blending*_data_tabulated_and_untitled_0_0_BLUE[8*q + 1];
                   const real_t jac_blending_inv_0_0 = jac_blending_1_1*tmp_qloop_22;
                   const real_t tmp_qloop_37 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE[8*q];
                   const real_t tmp_qloop_50 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE[7*q];
                   const real_t tmp_qloop_56 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE[8*q + 2];
                   const real_t tmp_qloop_63 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE[8*q + 3];
                   const real_t tmp_qloop_70 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE[8*q + 4];
                   const real_t tmp_qloop_77 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE[8*q + 5];
                   const real_t tmp_qloop_84 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE[8*q + 6];
                   const real_t tmp_qloop_93 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE[8*q + 7];
                   const real_t tmp_qloop_101 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE[7*q + 1];
                   const real_t tmp_qloop_112 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE[7*q + 2];
                   const real_t tmp_qloop_120 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE[7*q + 3];
                   const real_t tmp_qloop_128 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE[7*q + 4];
                   const real_t tmp_qloop_136 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE[7*q + 5];
                   const real_t tmp_qloop_144 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE[7*q + 6];
                   const real_t jac_blending_inv_0_1 = -jac_blending_0_1*tmp_qloop_22;
                   const real_t tmp_qloop_39 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE[7*q];
                   const real_t tmp_qloop_48 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE[8*q];
                   const real_t tmp_qloop_60 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE[8*q + 2];
                   const real_t tmp_qloop_67 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE[8*q + 3];
                   const real_t tmp_qloop_74 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE[8*q + 4];
                   const real_t tmp_qloop_81 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE[8*q + 5];
                   const real_t tmp_qloop_88 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE[8*q + 6];
                   const real_t tmp_qloop_91 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE[7*q + 1];
                   const real_t tmp_qloop_103 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE[8*q + 7];
                   const real_t tmp_qloop_107 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE[7*q + 2];
                   const real_t tmp_qloop_115 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE[7*q + 3];
                   const real_t tmp_qloop_123 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE[7*q + 4];
                   const real_t tmp_qloop_131 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE[7*q + 5];
                   const real_t tmp_qloop_139 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE[7*q + 6];
                   const real_t jac_blending_inv_1_0 = -jac_blending_1_0*tmp_qloop_22;
                   const real_t tmp_qloop_38 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE[7*q];
                   const real_t tmp_qloop_45 = tmp_qloop_37*1.0 + tmp_qloop_38*1.0;
                   const real_t tmp_qloop_51 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE[7*q];
                   const real_t tmp_qloop_52 = tmp_qloop_50 + tmp_qloop_51;
                   const real_t tmp_qloop_53 = tmp_qloop_50*0.5 + tmp_qloop_51*0.5;
                   const real_t tmp_qloop_57 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE[7*q + 1];
                   const real_t tmp_qloop_59 = tmp_qloop_56*2.0 + tmp_qloop_57*2.0;
                   const real_t tmp_qloop_64 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE[7*q + 2];
                   const real_t tmp_qloop_66 = tmp_qloop_63*2.0 + tmp_qloop_64*2.0;
                   const real_t tmp_qloop_71 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE[7*q + 3];
                   const real_t tmp_qloop_73 = tmp_qloop_70*2.0 + tmp_qloop_71*2.0;
                   const real_t tmp_qloop_78 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE[7*q + 4];
                   const real_t tmp_qloop_80 = tmp_qloop_77*2.0 + tmp_qloop_78*2.0;
                   const real_t tmp_qloop_85 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE[7*q + 5];
                   const real_t tmp_qloop_87 = tmp_qloop_84*2.0 + tmp_qloop_85*2.0;
                   const real_t tmp_qloop_94 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE[7*q + 6];
                   const real_t tmp_qloop_95 = tmp_qloop_93*0.66666666666666663 + tmp_qloop_94*0.66666666666666663;
                   const real_t tmp_qloop_97 = tmp_qloop_93*2.0 + tmp_qloop_94*2.0;
                   const real_t tmp_qloop_98 = tmp_qloop_45*tmp_qloop_97;
                   const real_t tmp_qloop_102 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE[7*q + 1];
                   const real_t tmp_qloop_113 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE[7*q + 2];
                   const real_t tmp_qloop_121 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE[7*q + 3];
                   const real_t tmp_qloop_129 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE[7*q + 4];
                   const real_t tmp_qloop_137 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE[7*q + 5];
                   const real_t tmp_qloop_145 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE[7*q + 6];
                   const real_t tmp_qloop_148 = tmp_qloop_56*1.0 + tmp_qloop_57*1.0;
                   const real_t tmp_qloop_150 = tmp_qloop_148*tmp_qloop_97;
                   const real_t tmp_qloop_152 = tmp_qloop_63*1.0 + tmp_qloop_64*1.0;
                   const real_t tmp_qloop_154 = tmp_qloop_152*tmp_qloop_97;
                   const real_t tmp_qloop_156 = tmp_qloop_70*1.0 + tmp_qloop_71*1.0;
                   const real_t tmp_qloop_158 = tmp_qloop_156*tmp_qloop_97;
                   const real_t tmp_qloop_160 = tmp_qloop_77*1.0 + tmp_qloop_78*1.0;
                   const real_t tmp_qloop_162 = tmp_qloop_160*tmp_qloop_97;
                   const real_t tmp_qloop_164 = tmp_qloop_84*1.0 + tmp_qloop_85*1.0;
                   const real_t tmp_qloop_166 = tmp_qloop_164*tmp_qloop_97;
                   const real_t tmp_qloop_167 = tmp_qloop_93 + tmp_qloop_94;
                   const real_t tmp_qloop_169 = tmp_qloop_97*(tmp_qloop_93*1.0 + tmp_qloop_94*1.0);
                   const real_t jac_blending_inv_1_1 = jac_blending_0_0*tmp_qloop_22;
                   const real_t tmp_qloop_40 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE[7*q];
                   const real_t tmp_qloop_41 = tmp_qloop_39*0.66666666666666663 + tmp_qloop_40*0.66666666666666663;
                   const real_t tmp_qloop_42 = tmp_qloop_39 + tmp_qloop_40;
                   const real_t tmp_qloop_44 = tmp_qloop_43*(tmp_qloop_37 + tmp_qloop_38 + tmp_qloop_42);
                   const real_t tmp_qloop_46 = tmp_qloop_39*1.0 + tmp_qloop_40*1.0;
                   const real_t tmp_qloop_47 = tmp_qloop_46*(tmp_qloop_39*2.0 + tmp_qloop_40*2.0);
                   const real_t tmp_qloop_49 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE[7*q];
                   const real_t tmp_qloop_54 = tmp_qloop_48 + tmp_qloop_49 + tmp_qloop_53*2.0;
                   const real_t tmp_qloop_58 = tmp_qloop_41 + tmp_qloop_56*0.66666666666666663 + tmp_qloop_57*0.66666666666666663;
                   const real_t tmp_qloop_61 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE[7*q + 1];
                   const real_t tmp_qloop_62 = tmp_qloop_52 + tmp_qloop_60 + tmp_qloop_61;
                   const real_t tmp_qloop_65 = tmp_qloop_41 + tmp_qloop_63*0.66666666666666663 + tmp_qloop_64*0.66666666666666663;
                   const real_t tmp_qloop_68 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE[7*q + 2];
                   const real_t tmp_qloop_69 = tmp_qloop_52 + tmp_qloop_67 + tmp_qloop_68;
                   const real_t tmp_qloop_72 = tmp_qloop_41 + tmp_qloop_70*0.66666666666666663 + tmp_qloop_71*0.66666666666666663;
                   const real_t tmp_qloop_75 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE[7*q + 3];
                   const real_t tmp_qloop_76 = tmp_qloop_52 + tmp_qloop_74 + tmp_qloop_75;
                   const real_t tmp_qloop_79 = tmp_qloop_41 + tmp_qloop_77*0.66666666666666663 + tmp_qloop_78*0.66666666666666663;
                   const real_t tmp_qloop_82 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE[7*q + 4];
                   const real_t tmp_qloop_83 = tmp_qloop_52 + tmp_qloop_81 + tmp_qloop_82;
                   const real_t tmp_qloop_86 = tmp_qloop_41 + tmp_qloop_84*0.66666666666666663 + tmp_qloop_85*0.66666666666666663;
                   const real_t tmp_qloop_89 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE[7*q + 5];
                   const real_t tmp_qloop_90 = tmp_qloop_52 + tmp_qloop_88 + tmp_qloop_89;
                   const real_t tmp_qloop_92 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE[7*q + 1];
                   const real_t tmp_qloop_96 = tmp_qloop_91*0.66666666666666663 + tmp_qloop_92*0.66666666666666663 + tmp_qloop_95;
                   const real_t tmp_qloop_99 = tmp_qloop_91*2.0 + tmp_qloop_92*2.0;
                   const real_t tmp_qloop_100 = tmp_qloop_46*tmp_qloop_99;
                   const real_t tmp_qloop_104 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE[7*q + 6];
                   const real_t tmp_qloop_105 = tmp_qloop_103 + tmp_qloop_104;
                   const real_t tmp_qloop_106 = tmp_qloop_101 + tmp_qloop_102 + tmp_qloop_105;
                   const real_t tmp_qloop_108 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE[7*q + 2];
                   const real_t tmp_qloop_109 = tmp_qloop_107*0.66666666666666663 + tmp_qloop_108*0.66666666666666663 + tmp_qloop_95;
                   const real_t tmp_qloop_110 = tmp_qloop_107*2.0 + tmp_qloop_108*2.0;
                   const real_t tmp_qloop_111 = tmp_qloop_110*tmp_qloop_46;
                   const real_t tmp_qloop_114 = tmp_qloop_105 + tmp_qloop_112 + tmp_qloop_113;
                   const real_t tmp_qloop_116 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE[7*q + 3];
                   const real_t tmp_qloop_117 = tmp_qloop_115*0.66666666666666663 + tmp_qloop_116*0.66666666666666663 + tmp_qloop_95;
                   const real_t tmp_qloop_118 = tmp_qloop_115*2.0 + tmp_qloop_116*2.0;
                   const real_t tmp_qloop_119 = tmp_qloop_118*tmp_qloop_46;
                   const real_t tmp_qloop_122 = tmp_qloop_105 + tmp_qloop_120 + tmp_qloop_121;
                   const real_t tmp_qloop_124 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE[7*q + 4];
                   const real_t tmp_qloop_125 = tmp_qloop_123*0.66666666666666663 + tmp_qloop_124*0.66666666666666663 + tmp_qloop_95;
                   const real_t tmp_qloop_126 = tmp_qloop_123*2.0 + tmp_qloop_124*2.0;
                   const real_t tmp_qloop_127 = tmp_qloop_126*tmp_qloop_46;
                   const real_t tmp_qloop_130 = tmp_qloop_105 + tmp_qloop_128 + tmp_qloop_129;
                   const real_t tmp_qloop_132 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE[7*q + 5];
                   const real_t tmp_qloop_133 = tmp_qloop_131*0.66666666666666663 + tmp_qloop_132*0.66666666666666663 + tmp_qloop_95;
                   const real_t tmp_qloop_134 = tmp_qloop_131*2.0 + tmp_qloop_132*2.0;
                   const real_t tmp_qloop_135 = tmp_qloop_134*tmp_qloop_46;
                   const real_t tmp_qloop_138 = tmp_qloop_105 + tmp_qloop_136 + tmp_qloop_137;
                   const real_t tmp_qloop_140 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE[7*q + 6];
                   const real_t tmp_qloop_141 = tmp_qloop_139*0.66666666666666663 + tmp_qloop_140*0.66666666666666663 + tmp_qloop_95;
                   const real_t tmp_qloop_142 = tmp_qloop_139*2.0 + tmp_qloop_140*2.0;
                   const real_t tmp_qloop_143 = tmp_qloop_142*tmp_qloop_46;
                   const real_t tmp_qloop_146 = tmp_qloop_105 + tmp_qloop_144 + tmp_qloop_145;
                   const real_t tmp_qloop_147 = tmp_qloop_43*(tmp_qloop_42 + tmp_qloop_56 + tmp_qloop_57);
                   const real_t tmp_qloop_149 = tmp_qloop_53*2.0 + tmp_qloop_60 + tmp_qloop_61;
                   const real_t tmp_qloop_151 = tmp_qloop_43*(tmp_qloop_42 + tmp_qloop_63 + tmp_qloop_64);
                   const real_t tmp_qloop_153 = tmp_qloop_53*2.0 + tmp_qloop_67 + tmp_qloop_68;
                   const real_t tmp_qloop_155 = tmp_qloop_43*(tmp_qloop_42 + tmp_qloop_70 + tmp_qloop_71);
                   const real_t tmp_qloop_157 = tmp_qloop_53*2.0 + tmp_qloop_74 + tmp_qloop_75;
                   const real_t tmp_qloop_159 = tmp_qloop_43*(tmp_qloop_42 + tmp_qloop_77 + tmp_qloop_78);
                   const real_t tmp_qloop_161 = tmp_qloop_53*2.0 + tmp_qloop_81 + tmp_qloop_82;
                   const real_t tmp_qloop_163 = tmp_qloop_43*(tmp_qloop_42 + tmp_qloop_84 + tmp_qloop_85);
                   const real_t tmp_qloop_165 = tmp_qloop_53*2.0 + tmp_qloop_88 + tmp_qloop_89;
                   const real_t tmp_qloop_168 = tmp_qloop_43*(tmp_qloop_167 + tmp_qloop_91 + tmp_qloop_92);
                   const real_t tmp_qloop_170 = tmp_qloop_91*1.0 + tmp_qloop_92*1.0;
                   const real_t tmp_qloop_171 = tmp_qloop_103*0.5 + tmp_qloop_104*0.5;
                   const real_t tmp_qloop_172 = tmp_qloop_101 + tmp_qloop_102 + tmp_qloop_171*2.0;
                   const real_t tmp_qloop_173 = tmp_qloop_43*(tmp_qloop_107 + tmp_qloop_108 + tmp_qloop_167);
                   const real_t tmp_qloop_174 = tmp_qloop_107*1.0 + tmp_qloop_108*1.0;
                   const real_t tmp_qloop_175 = tmp_qloop_112 + tmp_qloop_113 + tmp_qloop_171*2.0;
                   const real_t tmp_qloop_176 = tmp_qloop_43*(tmp_qloop_115 + tmp_qloop_116 + tmp_qloop_167);
                   const real_t tmp_qloop_177 = tmp_qloop_115*1.0 + tmp_qloop_116*1.0;
                   const real_t tmp_qloop_178 = tmp_qloop_120 + tmp_qloop_121 + tmp_qloop_171*2.0;
                   const real_t tmp_qloop_179 = tmp_qloop_43*(tmp_qloop_123 + tmp_qloop_124 + tmp_qloop_167);
                   const real_t tmp_qloop_180 = tmp_qloop_123*1.0 + tmp_qloop_124*1.0;
                   const real_t tmp_qloop_181 = tmp_qloop_128 + tmp_qloop_129 + tmp_qloop_171*2.0;
                   const real_t tmp_qloop_182 = tmp_qloop_43*(tmp_qloop_131 + tmp_qloop_132 + tmp_qloop_167);
                   const real_t tmp_qloop_183 = tmp_qloop_131*1.0 + tmp_qloop_132*1.0;
                   const real_t tmp_qloop_184 = tmp_qloop_136 + tmp_qloop_137 + tmp_qloop_171*2.0;
                   const real_t hessian_blending_0_0_0 = tmp_qloop_14 - tmp_qloop_25 + tmp_qloop_28;
                   const real_t hessian_blending_1_0_0 = -tmp_qloop_26*(tmp_qloop_3*tmp_qloop_3*tmp_qloop_3) + tmp_qloop_29*tmp_qloop_4 + tmp_qloop_3*tmp_qloop_32 - tmp_qloop_31;
                   const real_t hessian_blending_0_0_1 = tmp_qloop_1*tmp_qloop_11*tmp_qloop_15*tmp_qloop_30*-2.0 - tmp_qloop_34;
                   const real_t hessian_blending_1_0_1 = tmp_qloop_1*tmp_qloop_10*tmp_qloop_6*tmp_qloop_9*1.0 - tmp_qloop_20 - tmp_qloop_28 - tmp_qloop_35;
                   const real_t hessian_blending_0_1_0 = tmp_qloop_10*tmp_qloop_15*tmp_qloop_2*tmp_qloop_8*tmp_qloop_9*1.0 - tmp_qloop_19 - tmp_qloop_31 - tmp_qloop_34;
                   const real_t hessian_blending_1_1_0 = -tmp_qloop_20 + tmp_qloop_27 - tmp_qloop_35 + tmp_qloop_36;
                   const real_t hessian_blending_0_1_1 = tmp_qloop_0*tmp_qloop_32 - (tmp_qloop_0*tmp_qloop_0*tmp_qloop_0)*tmp_qloop_26 + tmp_qloop_25 + tmp_qloop_36;
                   const real_t hessian_blending_1_1_1 = tmp_qloop_10*tmp_qloop_15*tmp_qloop_2*tmp_qloop_7*tmp_qloop_9*1.0 + tmp_qloop_10*tmp_qloop_15*tmp_qloop_4*tmp_qloop_8*tmp_qloop_9*1.0 - tmp_qloop_19 - tmp_qloop_33;
                   const real_t q_tmp_0_0 = tmp_qloop_55*(tmp_qloop_43*(tmp_qloop_45*(tmp_qloop_37*2.0 + tmp_qloop_38*2.0) + tmp_qloop_47 + tmp_qloop_54*(tmp_qloop_48 + tmp_qloop_49 + tmp_qloop_52)) - tmp_qloop_44*(tmp_qloop_37*0.66666666666666663 + tmp_qloop_38*0.66666666666666663 + tmp_qloop_41));
                   const real_t q_tmp_0_1 = tmp_qloop_55*(tmp_qloop_43*(tmp_qloop_45*tmp_qloop_59 + tmp_qloop_47 + tmp_qloop_54*tmp_qloop_62) - tmp_qloop_44*tmp_qloop_58);
                   const real_t q_tmp_0_2 = tmp_qloop_55*(tmp_qloop_43*(tmp_qloop_45*tmp_qloop_66 + tmp_qloop_47 + tmp_qloop_54*tmp_qloop_69) - tmp_qloop_44*tmp_qloop_65);
                   const real_t q_tmp_0_3 = tmp_qloop_55*(tmp_qloop_43*(tmp_qloop_45*tmp_qloop_73 + tmp_qloop_47 + tmp_qloop_54*tmp_qloop_76) - tmp_qloop_44*tmp_qloop_72);
                   const real_t q_tmp_0_4 = tmp_qloop_55*(tmp_qloop_43*(tmp_qloop_45*tmp_qloop_80 + tmp_qloop_47 + tmp_qloop_54*tmp_qloop_83) - tmp_qloop_44*tmp_qloop_79);
                   const real_t q_tmp_0_5 = tmp_qloop_55*(tmp_qloop_43*(tmp_qloop_45*tmp_qloop_87 + tmp_qloop_47 + tmp_qloop_54*tmp_qloop_90) - tmp_qloop_44*tmp_qloop_86);
                   const real_t q_tmp_0_6 = tmp_qloop_55*(tmp_qloop_43*(tmp_qloop_100 + tmp_qloop_106*tmp_qloop_54 + tmp_qloop_98) - tmp_qloop_44*tmp_qloop_96);
                   const real_t q_tmp_0_7 = tmp_qloop_55*(-tmp_qloop_109*tmp_qloop_44 + tmp_qloop_43*(tmp_qloop_111 + tmp_qloop_114*tmp_qloop_54 + tmp_qloop_98));
                   const real_t q_tmp_0_8 = tmp_qloop_55*(-tmp_qloop_117*tmp_qloop_44 + tmp_qloop_43*(tmp_qloop_119 + tmp_qloop_122*tmp_qloop_54 + tmp_qloop_98));
                   const real_t q_tmp_0_9 = tmp_qloop_55*(-tmp_qloop_125*tmp_qloop_44 + tmp_qloop_43*(tmp_qloop_127 + tmp_qloop_130*tmp_qloop_54 + tmp_qloop_98));
                   const real_t q_tmp_0_10 = tmp_qloop_55*(-tmp_qloop_133*tmp_qloop_44 + tmp_qloop_43*(tmp_qloop_135 + tmp_qloop_138*tmp_qloop_54 + tmp_qloop_98));
                   const real_t q_tmp_0_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_44 + tmp_qloop_43*(tmp_qloop_143 + tmp_qloop_146*tmp_qloop_54 + tmp_qloop_98));
                   const real_t q_tmp_1_1 = tmp_qloop_55*(-tmp_qloop_147*tmp_qloop_58 + tmp_qloop_43*(tmp_qloop_148*tmp_qloop_59 + tmp_qloop_149*tmp_qloop_62 + tmp_qloop_47));
                   const real_t q_tmp_1_2 = tmp_qloop_55*(-tmp_qloop_147*tmp_qloop_65 + tmp_qloop_43*(tmp_qloop_148*tmp_qloop_66 + tmp_qloop_149*tmp_qloop_69 + tmp_qloop_47));
                   const real_t q_tmp_1_3 = tmp_qloop_55*(-tmp_qloop_147*tmp_qloop_72 + tmp_qloop_43*(tmp_qloop_148*tmp_qloop_73 + tmp_qloop_149*tmp_qloop_76 + tmp_qloop_47));
                   const real_t q_tmp_1_4 = tmp_qloop_55*(-tmp_qloop_147*tmp_qloop_79 + tmp_qloop_43*(tmp_qloop_148*tmp_qloop_80 + tmp_qloop_149*tmp_qloop_83 + tmp_qloop_47));
                   const real_t q_tmp_1_5 = tmp_qloop_55*(-tmp_qloop_147*tmp_qloop_86 + tmp_qloop_43*(tmp_qloop_148*tmp_qloop_87 + tmp_qloop_149*tmp_qloop_90 + tmp_qloop_47));
                   const real_t q_tmp_1_6 = tmp_qloop_55*(-tmp_qloop_147*tmp_qloop_96 + tmp_qloop_43*(tmp_qloop_100 + tmp_qloop_106*tmp_qloop_149 + tmp_qloop_150));
                   const real_t q_tmp_1_7 = tmp_qloop_55*(-tmp_qloop_109*tmp_qloop_147 + tmp_qloop_43*(tmp_qloop_111 + tmp_qloop_114*tmp_qloop_149 + tmp_qloop_150));
                   const real_t q_tmp_1_8 = tmp_qloop_55*(-tmp_qloop_117*tmp_qloop_147 + tmp_qloop_43*(tmp_qloop_119 + tmp_qloop_122*tmp_qloop_149 + tmp_qloop_150));
                   const real_t q_tmp_1_9 = tmp_qloop_55*(-tmp_qloop_125*tmp_qloop_147 + tmp_qloop_43*(tmp_qloop_127 + tmp_qloop_130*tmp_qloop_149 + tmp_qloop_150));
                   const real_t q_tmp_1_10 = tmp_qloop_55*(-tmp_qloop_133*tmp_qloop_147 + tmp_qloop_43*(tmp_qloop_135 + tmp_qloop_138*tmp_qloop_149 + tmp_qloop_150));
                   const real_t q_tmp_1_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_147 + tmp_qloop_43*(tmp_qloop_143 + tmp_qloop_146*tmp_qloop_149 + tmp_qloop_150));
                   const real_t q_tmp_2_2 = tmp_qloop_55*(-tmp_qloop_151*tmp_qloop_65 + tmp_qloop_43*(tmp_qloop_152*tmp_qloop_66 + tmp_qloop_153*tmp_qloop_69 + tmp_qloop_47));
                   const real_t q_tmp_2_3 = tmp_qloop_55*(-tmp_qloop_151*tmp_qloop_72 + tmp_qloop_43*(tmp_qloop_152*tmp_qloop_73 + tmp_qloop_153*tmp_qloop_76 + tmp_qloop_47));
                   const real_t q_tmp_2_4 = tmp_qloop_55*(-tmp_qloop_151*tmp_qloop_79 + tmp_qloop_43*(tmp_qloop_152*tmp_qloop_80 + tmp_qloop_153*tmp_qloop_83 + tmp_qloop_47));
                   const real_t q_tmp_2_5 = tmp_qloop_55*(-tmp_qloop_151*tmp_qloop_86 + tmp_qloop_43*(tmp_qloop_152*tmp_qloop_87 + tmp_qloop_153*tmp_qloop_90 + tmp_qloop_47));
                   const real_t q_tmp_2_6 = tmp_qloop_55*(-tmp_qloop_151*tmp_qloop_96 + tmp_qloop_43*(tmp_qloop_100 + tmp_qloop_106*tmp_qloop_153 + tmp_qloop_154));
                   const real_t q_tmp_2_7 = tmp_qloop_55*(-tmp_qloop_109*tmp_qloop_151 + tmp_qloop_43*(tmp_qloop_111 + tmp_qloop_114*tmp_qloop_153 + tmp_qloop_154));
                   const real_t q_tmp_2_8 = tmp_qloop_55*(-tmp_qloop_117*tmp_qloop_151 + tmp_qloop_43*(tmp_qloop_119 + tmp_qloop_122*tmp_qloop_153 + tmp_qloop_154));
                   const real_t q_tmp_2_9 = tmp_qloop_55*(-tmp_qloop_125*tmp_qloop_151 + tmp_qloop_43*(tmp_qloop_127 + tmp_qloop_130*tmp_qloop_153 + tmp_qloop_154));
                   const real_t q_tmp_2_10 = tmp_qloop_55*(-tmp_qloop_133*tmp_qloop_151 + tmp_qloop_43*(tmp_qloop_135 + tmp_qloop_138*tmp_qloop_153 + tmp_qloop_154));
                   const real_t q_tmp_2_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_151 + tmp_qloop_43*(tmp_qloop_143 + tmp_qloop_146*tmp_qloop_153 + tmp_qloop_154));
                   const real_t q_tmp_3_3 = tmp_qloop_55*(-tmp_qloop_155*tmp_qloop_72 + tmp_qloop_43*(tmp_qloop_156*tmp_qloop_73 + tmp_qloop_157*tmp_qloop_76 + tmp_qloop_47));
                   const real_t q_tmp_3_4 = tmp_qloop_55*(-tmp_qloop_155*tmp_qloop_79 + tmp_qloop_43*(tmp_qloop_156*tmp_qloop_80 + tmp_qloop_157*tmp_qloop_83 + tmp_qloop_47));
                   const real_t q_tmp_3_5 = tmp_qloop_55*(-tmp_qloop_155*tmp_qloop_86 + tmp_qloop_43*(tmp_qloop_156*tmp_qloop_87 + tmp_qloop_157*tmp_qloop_90 + tmp_qloop_47));
                   const real_t q_tmp_3_6 = tmp_qloop_55*(-tmp_qloop_155*tmp_qloop_96 + tmp_qloop_43*(tmp_qloop_100 + tmp_qloop_106*tmp_qloop_157 + tmp_qloop_158));
                   const real_t q_tmp_3_7 = tmp_qloop_55*(-tmp_qloop_109*tmp_qloop_155 + tmp_qloop_43*(tmp_qloop_111 + tmp_qloop_114*tmp_qloop_157 + tmp_qloop_158));
                   const real_t q_tmp_3_8 = tmp_qloop_55*(-tmp_qloop_117*tmp_qloop_155 + tmp_qloop_43*(tmp_qloop_119 + tmp_qloop_122*tmp_qloop_157 + tmp_qloop_158));
                   const real_t q_tmp_3_9 = tmp_qloop_55*(-tmp_qloop_125*tmp_qloop_155 + tmp_qloop_43*(tmp_qloop_127 + tmp_qloop_130*tmp_qloop_157 + tmp_qloop_158));
                   const real_t q_tmp_3_10 = tmp_qloop_55*(-tmp_qloop_133*tmp_qloop_155 + tmp_qloop_43*(tmp_qloop_135 + tmp_qloop_138*tmp_qloop_157 + tmp_qloop_158));
                   const real_t q_tmp_3_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_155 + tmp_qloop_43*(tmp_qloop_143 + tmp_qloop_146*tmp_qloop_157 + tmp_qloop_158));
                   const real_t q_tmp_4_4 = tmp_qloop_55*(-tmp_qloop_159*tmp_qloop_79 + tmp_qloop_43*(tmp_qloop_160*tmp_qloop_80 + tmp_qloop_161*tmp_qloop_83 + tmp_qloop_47));
                   const real_t q_tmp_4_5 = tmp_qloop_55*(-tmp_qloop_159*tmp_qloop_86 + tmp_qloop_43*(tmp_qloop_160*tmp_qloop_87 + tmp_qloop_161*tmp_qloop_90 + tmp_qloop_47));
                   const real_t q_tmp_4_6 = tmp_qloop_55*(-tmp_qloop_159*tmp_qloop_96 + tmp_qloop_43*(tmp_qloop_100 + tmp_qloop_106*tmp_qloop_161 + tmp_qloop_162));
                   const real_t q_tmp_4_7 = tmp_qloop_55*(-tmp_qloop_109*tmp_qloop_159 + tmp_qloop_43*(tmp_qloop_111 + tmp_qloop_114*tmp_qloop_161 + tmp_qloop_162));
                   const real_t q_tmp_4_8 = tmp_qloop_55*(-tmp_qloop_117*tmp_qloop_159 + tmp_qloop_43*(tmp_qloop_119 + tmp_qloop_122*tmp_qloop_161 + tmp_qloop_162));
                   const real_t q_tmp_4_9 = tmp_qloop_55*(-tmp_qloop_125*tmp_qloop_159 + tmp_qloop_43*(tmp_qloop_127 + tmp_qloop_130*tmp_qloop_161 + tmp_qloop_162));
                   const real_t q_tmp_4_10 = tmp_qloop_55*(-tmp_qloop_133*tmp_qloop_159 + tmp_qloop_43*(tmp_qloop_135 + tmp_qloop_138*tmp_qloop_161 + tmp_qloop_162));
                   const real_t q_tmp_4_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_159 + tmp_qloop_43*(tmp_qloop_143 + tmp_qloop_146*tmp_qloop_161 + tmp_qloop_162));
                   const real_t q_tmp_5_5 = tmp_qloop_55*(-tmp_qloop_163*tmp_qloop_86 + tmp_qloop_43*(tmp_qloop_164*tmp_qloop_87 + tmp_qloop_165*tmp_qloop_90 + tmp_qloop_47));
                   const real_t q_tmp_5_6 = tmp_qloop_55*(-tmp_qloop_163*tmp_qloop_96 + tmp_qloop_43*(tmp_qloop_100 + tmp_qloop_106*tmp_qloop_165 + tmp_qloop_166));
                   const real_t q_tmp_5_7 = tmp_qloop_55*(-tmp_qloop_109*tmp_qloop_163 + tmp_qloop_43*(tmp_qloop_111 + tmp_qloop_114*tmp_qloop_165 + tmp_qloop_166));
                   const real_t q_tmp_5_8 = tmp_qloop_55*(-tmp_qloop_117*tmp_qloop_163 + tmp_qloop_43*(tmp_qloop_119 + tmp_qloop_122*tmp_qloop_165 + tmp_qloop_166));
                   const real_t q_tmp_5_9 = tmp_qloop_55*(-tmp_qloop_125*tmp_qloop_163 + tmp_qloop_43*(tmp_qloop_127 + tmp_qloop_130*tmp_qloop_165 + tmp_qloop_166));
                   const real_t q_tmp_5_10 = tmp_qloop_55*(-tmp_qloop_133*tmp_qloop_163 + tmp_qloop_43*(tmp_qloop_135 + tmp_qloop_138*tmp_qloop_165 + tmp_qloop_166));
                   const real_t q_tmp_5_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_163 + tmp_qloop_43*(tmp_qloop_143 + tmp_qloop_146*tmp_qloop_165 + tmp_qloop_166));
                   const real_t q_tmp_6_6 = tmp_qloop_55*(-tmp_qloop_168*tmp_qloop_96 + tmp_qloop_43*(tmp_qloop_106*tmp_qloop_172 + tmp_qloop_169 + tmp_qloop_170*tmp_qloop_99));
                   const real_t q_tmp_6_7 = tmp_qloop_55*(-tmp_qloop_109*tmp_qloop_168 + tmp_qloop_43*(tmp_qloop_110*tmp_qloop_170 + tmp_qloop_114*tmp_qloop_172 + tmp_qloop_169));
                   const real_t q_tmp_6_8 = tmp_qloop_55*(-tmp_qloop_117*tmp_qloop_168 + tmp_qloop_43*(tmp_qloop_118*tmp_qloop_170 + tmp_qloop_122*tmp_qloop_172 + tmp_qloop_169));
                   const real_t q_tmp_6_9 = tmp_qloop_55*(-tmp_qloop_125*tmp_qloop_168 + tmp_qloop_43*(tmp_qloop_126*tmp_qloop_170 + tmp_qloop_130*tmp_qloop_172 + tmp_qloop_169));
                   const real_t q_tmp_6_10 = tmp_qloop_55*(-tmp_qloop_133*tmp_qloop_168 + tmp_qloop_43*(tmp_qloop_134*tmp_qloop_170 + tmp_qloop_138*tmp_qloop_172 + tmp_qloop_169));
                   const real_t q_tmp_6_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_168 + tmp_qloop_43*(tmp_qloop_142*tmp_qloop_170 + tmp_qloop_146*tmp_qloop_172 + tmp_qloop_169));
                   const real_t q_tmp_7_7 = tmp_qloop_55*(-tmp_qloop_109*tmp_qloop_173 + tmp_qloop_43*(tmp_qloop_110*tmp_qloop_174 + tmp_qloop_114*tmp_qloop_175 + tmp_qloop_169));
                   const real_t q_tmp_7_8 = tmp_qloop_55*(-tmp_qloop_117*tmp_qloop_173 + tmp_qloop_43*(tmp_qloop_118*tmp_qloop_174 + tmp_qloop_122*tmp_qloop_175 + tmp_qloop_169));
                   const real_t q_tmp_7_9 = tmp_qloop_55*(-tmp_qloop_125*tmp_qloop_173 + tmp_qloop_43*(tmp_qloop_126*tmp_qloop_174 + tmp_qloop_130*tmp_qloop_175 + tmp_qloop_169));
                   const real_t q_tmp_7_10 = tmp_qloop_55*(-tmp_qloop_133*tmp_qloop_173 + tmp_qloop_43*(tmp_qloop_134*tmp_qloop_174 + tmp_qloop_138*tmp_qloop_175 + tmp_qloop_169));
                   const real_t q_tmp_7_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_173 + tmp_qloop_43*(tmp_qloop_142*tmp_qloop_174 + tmp_qloop_146*tmp_qloop_175 + tmp_qloop_169));
                   const real_t q_tmp_8_8 = tmp_qloop_55*(-tmp_qloop_117*tmp_qloop_176 + tmp_qloop_43*(tmp_qloop_118*tmp_qloop_177 + tmp_qloop_122*tmp_qloop_178 + tmp_qloop_169));
                   const real_t q_tmp_8_9 = tmp_qloop_55*(-tmp_qloop_125*tmp_qloop_176 + tmp_qloop_43*(tmp_qloop_126*tmp_qloop_177 + tmp_qloop_130*tmp_qloop_178 + tmp_qloop_169));
                   const real_t q_tmp_8_10 = tmp_qloop_55*(-tmp_qloop_133*tmp_qloop_176 + tmp_qloop_43*(tmp_qloop_134*tmp_qloop_177 + tmp_qloop_138*tmp_qloop_178 + tmp_qloop_169));
                   const real_t q_tmp_8_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_176 + tmp_qloop_43*(tmp_qloop_142*tmp_qloop_177 + tmp_qloop_146*tmp_qloop_178 + tmp_qloop_169));
                   const real_t q_tmp_9_9 = tmp_qloop_55*(-tmp_qloop_125*tmp_qloop_179 + tmp_qloop_43*(tmp_qloop_126*tmp_qloop_180 + tmp_qloop_130*tmp_qloop_181 + tmp_qloop_169));
                   const real_t q_tmp_9_10 = tmp_qloop_55*(-tmp_qloop_133*tmp_qloop_179 + tmp_qloop_43*(tmp_qloop_134*tmp_qloop_180 + tmp_qloop_138*tmp_qloop_181 + tmp_qloop_169));
                   const real_t q_tmp_9_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_179 + tmp_qloop_43*(tmp_qloop_142*tmp_qloop_180 + tmp_qloop_146*tmp_qloop_181 + tmp_qloop_169));
                   const real_t q_tmp_10_10 = tmp_qloop_55*(-tmp_qloop_133*tmp_qloop_182 + tmp_qloop_43*(tmp_qloop_134*tmp_qloop_183 + tmp_qloop_138*tmp_qloop_184 + tmp_qloop_169));
                   const real_t q_tmp_10_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_182 + tmp_qloop_43*(tmp_qloop_142*tmp_qloop_183 + tmp_qloop_146*tmp_qloop_184 + tmp_qloop_169));
                   const real_t q_tmp_11_11 = tmp_qloop_55*(-tmp_qloop_141*tmp_qloop_43*(tmp_qloop_139 + tmp_qloop_140 + tmp_qloop_167) + tmp_qloop_43*(tmp_qloop_142*(tmp_qloop_139*1.0 + tmp_qloop_140*1.0) + tmp_qloop_146*(tmp_qloop_144*0.5 + tmp_qloop_145*0.5 + tmp_qloop_171)*2.0 + tmp_qloop_169));
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                   q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                   q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                   q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                   q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                   q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                   q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                   q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                   q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                   q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                   q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                   q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                   q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                   q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                   q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                   q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                   q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                   q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                   q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                   q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                   q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                   q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                   q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                   q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                   q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                   q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                   q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                   q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                   q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                   q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                   q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                   q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                   q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                   q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                   q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                   q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                   q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                   q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                   q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                   q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                   q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                   q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                   q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                   q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                   q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                   q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                   q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                   q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                   q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                   q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                   q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                   q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                   q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                   q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                   q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                   q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                   q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                   q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                   q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                   q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                }
                const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_10*src_dof_10 + q_acc_0_11*src_dof_11 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
                const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_10*src_dof_10 + q_acc_1_11*src_dof_11 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
                const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_10*src_dof_10 + q_acc_2_11*src_dof_11 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
                const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_10*src_dof_10 + q_acc_3_11*src_dof_11 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
                const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_10*src_dof_10 + q_acc_4_11*src_dof_11 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
                const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_10*src_dof_10 + q_acc_5_11*src_dof_11 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
                const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_10*src_dof_10 + q_acc_6_11*src_dof_11 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
                const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_10*src_dof_10 + q_acc_7_11*src_dof_11 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
                const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_10*src_dof_10 + q_acc_8_11*src_dof_11 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
                const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_10*src_dof_10 + q_acc_9_11*src_dof_11 + q_acc_9_9*src_dof_9;
                const real_t elMatVec_10 = q_acc_0_10*src_dof_0 + q_acc_10_10*src_dof_10 + q_acc_10_11*src_dof_11 + q_acc_1_10*src_dof_1 + q_acc_2_10*src_dof_2 + q_acc_3_10*src_dof_3 + q_acc_4_10*src_dof_4 + q_acc_5_10*src_dof_5 + q_acc_6_10*src_dof_6 + q_acc_7_10*src_dof_7 + q_acc_8_10*src_dof_8 + q_acc_9_10*src_dof_9;
                const real_t elMatVec_11 = q_acc_0_11*src_dof_0 + q_acc_10_11*src_dof_10 + q_acc_11_11*src_dof_11 + q_acc_1_11*src_dof_1 + q_acc_2_11*src_dof_2 + q_acc_3_11*src_dof_3 + q_acc_4_11*src_dof_4 + q_acc_5_11*src_dof_5 + q_acc_6_11*src_dof_6 + q_acc_7_11*src_dof_7 + q_acc_8_11*src_dof_8 + q_acc_9_11*src_dof_9;
                _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatVec_0 + _data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_1 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1] = elMatVec_2 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
                _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_3 + _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1] = elMatVec_4 + _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
                _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_5 + _data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatVec_6 + _data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_7 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1] = elMatVec_8 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
                _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_9 + _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1] = elMatVec_10 + _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
                _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_11 + _data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             }
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
