/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/































#include "../P2ElementwiseSupgAdvectionIcosahedralShellMap.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ElementwiseSupgAdvectionIcosahedralShellMap::computeInverseDiagonalOperatorValues_P2ElementwiseSupgAdvectionIcosahedralShellMap_macro_3D( real_t * RESTRICT  _data_cp_times_deltaEdge, real_t * RESTRICT  _data_cp_times_deltaVertex, real_t * RESTRICT  _data_invDiag_Edge, real_t * RESTRICT  _data_invDiag_Vertex, real_t * RESTRICT  _data_uxEdge, real_t * RESTRICT  _data_uxVertex, real_t * RESTRICT  _data_uyEdge, real_t * RESTRICT  _data_uyVertex, real_t * RESTRICT  _data_uzEdge, real_t * RESTRICT  _data_uzVertex, real_t forVertex_0, real_t forVertex_1, real_t forVertex_2, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float, real_t radRayVertex, real_t radRefVertex, real_t rayVertex_0, real_t rayVertex_1, real_t rayVertex_2, real_t refVertex_0, real_t refVertex_1, real_t refVertex_2, real_t thrVertex_0, real_t thrVertex_1, real_t thrVertex_2 ) const
{
    {
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const real_t tmp_coords_jac_5_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const real_t tmp_coords_jac_3_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const real_t tmp_coords_jac_2_WHITE_UP = jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP;
       const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const real_t tmp_coords_jac_1_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_4_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_6_WHITE_UP = jac_affine_0_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_0_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_0_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
       const real_t tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const real_t jac_affine_inv_0_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
       const real_t jac_affine_inv_0_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_2_1_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const real_t jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const real_t jac_affine_inv_1_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t jac_affine_inv_2_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       const real_t tmp_blending_op_5 = rayVertex_1 - refVertex_1;
       const real_t tmp_blending_op_6 = -rayVertex_0;
       const real_t tmp_blending_op_7 = -forVertex_0 - tmp_blending_op_6;
       const real_t tmp_blending_op_8 = rayVertex_2 - thrVertex_2;
       const real_t tmp_blending_op_9 = tmp_blending_op_7*tmp_blending_op_8;
       const real_t tmp_blending_op_10 = rayVertex_2 - refVertex_2;
       const real_t tmp_blending_op_11 = rayVertex_1 - thrVertex_1;
       const real_t tmp_blending_op_12 = tmp_blending_op_11*tmp_blending_op_7;
       const real_t tmp_blending_op_13 = -rayVertex_1;
       const real_t tmp_blending_op_14 = -forVertex_1 - tmp_blending_op_13;
       const real_t tmp_blending_op_15 = rayVertex_0 - thrVertex_0;
       const real_t tmp_blending_op_16 = rayVertex_0 - refVertex_0;
       const real_t tmp_blending_op_17 = -rayVertex_2;
       const real_t tmp_blending_op_18 = -forVertex_2 - tmp_blending_op_17;
       const real_t tmp_blending_op_19 = tmp_blending_op_14*tmp_blending_op_8;
       const real_t tmp_blending_op_20 = tmp_blending_op_15*tmp_blending_op_18;
       const real_t tmp_blending_op_21 = -tmp_blending_op_10*tmp_blending_op_12 + tmp_blending_op_10*tmp_blending_op_14*tmp_blending_op_15 + tmp_blending_op_11*tmp_blending_op_16*tmp_blending_op_18 - tmp_blending_op_16*tmp_blending_op_19 - tmp_blending_op_20*tmp_blending_op_5 + tmp_blending_op_5*tmp_blending_op_9;
       const real_t tmp_blending_op_22 = radRayVertex*tmp_blending_op_21;
       const real_t tmp_blending_op_23 = radRayVertex - radRefVertex;
       const real_t tmp_blending_op_40 = tmp_blending_op_23*(-tmp_blending_op_12 + tmp_blending_op_14*tmp_blending_op_15);
       const real_t tmp_blending_op_41 = 1.0 / (tmp_blending_op_21)*1.0;
       const real_t tmp_blending_op_43 = tmp_blending_op_15*tmp_blending_op_18 - tmp_blending_op_9;
       const real_t tmp_blending_op_47 = tmp_blending_op_11*tmp_blending_op_18 - tmp_blending_op_19;
       const real_t tmp_blending_op_51 = -tmp_blending_op_23*tmp_blending_op_43;
       const real_t tmp_blending_op_53 = tmp_blending_op_23*tmp_blending_op_47;
       const real_t tmp_blending_op_74 = tmp_blending_op_23*tmp_blending_op_43;
       const real_t tmp_kernel_op_0 = 1.0;
       const real_t tmp_kernel_op_1 = 1.0;
       const real_t tmp_kernel_op_2 = 1.0;
       const real_t tmp_kernel_op_3 = tmp_kernel_op_1 + tmp_kernel_op_2;
       const real_t tmp_kernel_op_4 = tmp_kernel_op_0 + tmp_kernel_op_3 - 3.0;
       const real_t tmp_kernel_op_5 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_4 + jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_4 + jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_4;
       const real_t tmp_kernel_op_6 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_4 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_4 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_4;
       const real_t tmp_kernel_op_7 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_4 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_4 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_4;
       const real_t tmp_kernel_op_8 = tmp_kernel_op_2*0.25;
       const real_t tmp_kernel_op_9 = tmp_kernel_op_1*0.25;
       const real_t tmp_kernel_op_10 = tmp_kernel_op_1*0.25;
       const real_t tmp_kernel_op_11 = 0.0625;
       const real_t tmp_kernel_op_12 = tmp_kernel_op_11*2.0;
       const real_t tmp_kernel_op_13 = tmp_kernel_op_12 - 0.25;
       const real_t tmp_kernel_op_14 = 0.0625;
       const real_t tmp_kernel_op_15 = tmp_kernel_op_14*2.0;
       const real_t tmp_kernel_op_16 = tmp_kernel_op_15 - 0.25;
       const real_t tmp_kernel_op_17 = 0.0625;
       const real_t tmp_kernel_op_18 = tmp_kernel_op_17*2.0;
       const real_t tmp_kernel_op_19 = tmp_kernel_op_18 - 0.25;
       const real_t tmp_kernel_op_20 = tmp_kernel_op_0 + tmp_kernel_op_17*-4.0 - tmp_kernel_op_8 - tmp_kernel_op_9;
       const real_t tmp_kernel_op_21 = -tmp_kernel_op_10 + tmp_kernel_op_14*-4.0 + tmp_kernel_op_2 - tmp_kernel_op_8;
       const real_t tmp_kernel_op_22 = tmp_kernel_op_10 + tmp_kernel_op_9;
       const real_t tmp_kernel_op_23 = tmp_kernel_op_1 + tmp_kernel_op_11*-4.0 - tmp_kernel_op_22;
       const real_t tmp_kernel_op_24 = tmp_kernel_op_12 + tmp_kernel_op_15 + tmp_kernel_op_18 + tmp_kernel_op_22 + tmp_kernel_op_8 - 1.25;
       const real_t tmp_kernel_op_29 = 2.0;
       const real_t tmp_kernel_op_30 = 0.66666666666666663;
       const real_t tmp_kernel_op_31 = 0.66666666666666663;
       const real_t tmp_kernel_op_32 = tmp_kernel_op_30 + tmp_kernel_op_31;
       const real_t tmp_kernel_op_33 = tmp_kernel_op_29 + tmp_kernel_op_32 - 3.0;
       const real_t tmp_kernel_op_34 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_33 + jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_33 + jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_33;
       const real_t tmp_kernel_op_35 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_33 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_33 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_33;
       const real_t tmp_kernel_op_36 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_33 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_33 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_33;
       const real_t tmp_kernel_op_37 = tmp_kernel_op_31*0.5;
       const real_t tmp_kernel_op_38 = tmp_kernel_op_30*0.5;
       const real_t tmp_kernel_op_39 = tmp_kernel_op_30*0.16666666666666666;
       const real_t tmp_kernel_op_40 = 0.027777777777777776;
       const real_t tmp_kernel_op_41 = tmp_kernel_op_40*2.0;
       const real_t tmp_kernel_op_42 = tmp_kernel_op_41 - 0.16666666666666666;
       const real_t tmp_kernel_op_43 = 0.027777777777777776;
       const real_t tmp_kernel_op_44 = tmp_kernel_op_43*2.0;
       const real_t tmp_kernel_op_45 = tmp_kernel_op_44 - 0.16666666666666666;
       const real_t tmp_kernel_op_46 = 0.25;
       const real_t tmp_kernel_op_47 = tmp_kernel_op_46*2.0;
       const real_t tmp_kernel_op_48 = tmp_kernel_op_47 - 0.5;
       const real_t tmp_kernel_op_49 = tmp_kernel_op_29 - tmp_kernel_op_37 - tmp_kernel_op_38 + tmp_kernel_op_46*-4.0;
       const real_t tmp_kernel_op_50 = tmp_kernel_op_31 - tmp_kernel_op_37 - tmp_kernel_op_39 + tmp_kernel_op_43*-4.0;
       const real_t tmp_kernel_op_51 = tmp_kernel_op_38 + tmp_kernel_op_39;
       const real_t tmp_kernel_op_52 = tmp_kernel_op_30 + tmp_kernel_op_40*-4.0 - tmp_kernel_op_51;
       const real_t tmp_kernel_op_53 = tmp_kernel_op_37 + tmp_kernel_op_41 + tmp_kernel_op_44 + tmp_kernel_op_47 + tmp_kernel_op_51 - 1.5;
       const real_t tmp_kernel_op_58 = 0.66666666666666663;
       const real_t tmp_kernel_op_59 = 0.66666666666666663;
       const real_t tmp_kernel_op_60 = 2.0;
       const real_t tmp_kernel_op_61 = tmp_kernel_op_59 + tmp_kernel_op_60;
       const real_t tmp_kernel_op_62 = tmp_kernel_op_58 + tmp_kernel_op_61 - 3.0;
       const real_t tmp_kernel_op_63 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_62 + jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_62 + jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_62;
       const real_t tmp_kernel_op_64 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_62 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_62 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_62;
       const real_t tmp_kernel_op_65 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_62 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_62 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_62;
       const real_t tmp_kernel_op_66 = tmp_kernel_op_60*0.16666666666666666;
       const real_t tmp_kernel_op_67 = tmp_kernel_op_59*0.16666666666666666;
       const real_t tmp_kernel_op_68 = tmp_kernel_op_59*0.5;
       const real_t tmp_kernel_op_69 = 0.027777777777777776;
       const real_t tmp_kernel_op_70 = tmp_kernel_op_69*2.0;
       const real_t tmp_kernel_op_71 = tmp_kernel_op_70 - 0.16666666666666666;
       const real_t tmp_kernel_op_72 = 0.25;
       const real_t tmp_kernel_op_73 = tmp_kernel_op_72*2.0;
       const real_t tmp_kernel_op_74 = tmp_kernel_op_73 - 0.5;
       const real_t tmp_kernel_op_75 = 0.027777777777777776;
       const real_t tmp_kernel_op_76 = tmp_kernel_op_75*2.0;
       const real_t tmp_kernel_op_77 = tmp_kernel_op_76 - 0.16666666666666666;
       const real_t tmp_kernel_op_78 = tmp_kernel_op_58 - tmp_kernel_op_66 - tmp_kernel_op_67 + tmp_kernel_op_75*-4.0;
       const real_t tmp_kernel_op_79 = tmp_kernel_op_60 - tmp_kernel_op_66 - tmp_kernel_op_68 + tmp_kernel_op_72*-4.0;
       const real_t tmp_kernel_op_80 = tmp_kernel_op_67 + tmp_kernel_op_68;
       const real_t tmp_kernel_op_81 = tmp_kernel_op_59 + tmp_kernel_op_69*-4.0 - tmp_kernel_op_80;
       const real_t tmp_kernel_op_82 = tmp_kernel_op_66 + tmp_kernel_op_70 + tmp_kernel_op_73 + tmp_kernel_op_76 + tmp_kernel_op_80 - 1.5;
       const real_t tmp_kernel_op_87 = 0.66666666666666663;
       const real_t tmp_kernel_op_88 = 2.0;
       const real_t tmp_kernel_op_89 = 0.66666666666666663;
       const real_t tmp_kernel_op_90 = tmp_kernel_op_88 + tmp_kernel_op_89;
       const real_t tmp_kernel_op_91 = tmp_kernel_op_87 + tmp_kernel_op_90 - 3.0;
       const real_t tmp_kernel_op_92 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_91 + jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_91 + jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_91;
       const real_t tmp_kernel_op_93 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_91 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_91 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_91;
       const real_t tmp_kernel_op_94 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_91 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_91 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_91;
       const real_t tmp_kernel_op_95 = tmp_kernel_op_89*0.16666666666666666;
       const real_t tmp_kernel_op_96 = tmp_kernel_op_88*0.16666666666666666;
       const real_t tmp_kernel_op_97 = tmp_kernel_op_88*0.16666666666666666;
       const real_t tmp_kernel_op_98 = 0.25;
       const real_t tmp_kernel_op_99 = tmp_kernel_op_98*2.0;
       const real_t tmp_kernel_op_100 = tmp_kernel_op_99 - 0.5;
       const real_t tmp_kernel_op_101 = 0.027777777777777776;
       const real_t tmp_kernel_op_102 = tmp_kernel_op_101*2.0;
       const real_t tmp_kernel_op_103 = tmp_kernel_op_102 - 0.16666666666666666;
       const real_t tmp_kernel_op_104 = 0.027777777777777776;
       const real_t tmp_kernel_op_105 = tmp_kernel_op_104*2.0;
       const real_t tmp_kernel_op_106 = tmp_kernel_op_105 - 0.16666666666666666;
       const real_t tmp_kernel_op_107 = tmp_kernel_op_104*-4.0 + tmp_kernel_op_87 - tmp_kernel_op_95 - tmp_kernel_op_96;
       const real_t tmp_kernel_op_108 = tmp_kernel_op_101*-4.0 + tmp_kernel_op_89 - tmp_kernel_op_95 - tmp_kernel_op_97;
       const real_t tmp_kernel_op_109 = tmp_kernel_op_96 + tmp_kernel_op_97;
       const real_t tmp_kernel_op_110 = -tmp_kernel_op_109 + tmp_kernel_op_88 + tmp_kernel_op_98*-4.0;
       const real_t tmp_kernel_op_111 = tmp_kernel_op_102 + tmp_kernel_op_105 + tmp_kernel_op_109 + tmp_kernel_op_95 + tmp_kernel_op_99 - 1.5;
       const real_t tmp_kernel_op_116 = 0.66666666666666663;
       const real_t tmp_kernel_op_117 = 0.66666666666666663;
       const real_t tmp_kernel_op_118 = 0.66666666666666663;
       const real_t tmp_kernel_op_119 = tmp_kernel_op_117 + tmp_kernel_op_118;
       const real_t tmp_kernel_op_120 = tmp_kernel_op_116 + tmp_kernel_op_119 - 3.0;
       const real_t tmp_kernel_op_121 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_120 + jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_120 + jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_120;
       const real_t tmp_kernel_op_122 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_120 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_120 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_120;
       const real_t tmp_kernel_op_123 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_120 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_120 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_120;
       const real_t tmp_kernel_op_124 = tmp_kernel_op_118*0.16666666666666666;
       const real_t tmp_kernel_op_125 = tmp_kernel_op_117*0.16666666666666666;
       const real_t tmp_kernel_op_126 = tmp_kernel_op_117*0.16666666666666666;
       const real_t tmp_kernel_op_127 = 0.027777777777777776;
       const real_t tmp_kernel_op_128 = tmp_kernel_op_127*2.0;
       const real_t tmp_kernel_op_129 = tmp_kernel_op_128 - 0.16666666666666666;
       const real_t tmp_kernel_op_130 = 0.027777777777777776;
       const real_t tmp_kernel_op_131 = tmp_kernel_op_130*2.0;
       const real_t tmp_kernel_op_132 = tmp_kernel_op_131 - 0.16666666666666666;
       const real_t tmp_kernel_op_133 = 0.027777777777777776;
       const real_t tmp_kernel_op_134 = tmp_kernel_op_133*2.0;
       const real_t tmp_kernel_op_135 = tmp_kernel_op_134 - 0.16666666666666666;
       const real_t tmp_kernel_op_136 = tmp_kernel_op_116 - tmp_kernel_op_124 - tmp_kernel_op_125 + tmp_kernel_op_133*-4.0;
       const real_t tmp_kernel_op_137 = tmp_kernel_op_118 - tmp_kernel_op_124 - tmp_kernel_op_126 + tmp_kernel_op_130*-4.0;
       const real_t tmp_kernel_op_138 = tmp_kernel_op_125 + tmp_kernel_op_126;
       const real_t tmp_kernel_op_139 = tmp_kernel_op_117 + tmp_kernel_op_127*-4.0 - tmp_kernel_op_138;
       const real_t tmp_kernel_op_140 = tmp_kernel_op_124 + tmp_kernel_op_128 + tmp_kernel_op_131 + tmp_kernel_op_134 + tmp_kernel_op_138 - 0.5;
       const real_t tmp_kernel_op_145 = tmp_kernel_op_1 - 1.0;
       const real_t tmp_kernel_op_146 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_145;
       const real_t tmp_kernel_op_147 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_145;
       const real_t tmp_kernel_op_148 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_145;
       const real_t tmp_kernel_op_149 = tmp_kernel_op_30 - 1.0;
       const real_t tmp_kernel_op_150 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_149;
       const real_t tmp_kernel_op_151 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_149;
       const real_t tmp_kernel_op_152 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_149;
       const real_t tmp_kernel_op_153 = tmp_kernel_op_59 - 1.0;
       const real_t tmp_kernel_op_154 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_153;
       const real_t tmp_kernel_op_155 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_153;
       const real_t tmp_kernel_op_156 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_153;
       const real_t tmp_kernel_op_157 = tmp_kernel_op_88 - 1.0;
       const real_t tmp_kernel_op_158 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_157;
       const real_t tmp_kernel_op_159 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_157;
       const real_t tmp_kernel_op_160 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_157;
       const real_t tmp_kernel_op_161 = tmp_kernel_op_117 - 1.0;
       const real_t tmp_kernel_op_162 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_161;
       const real_t tmp_kernel_op_163 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_161;
       const real_t tmp_kernel_op_164 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_161;
       const real_t tmp_kernel_op_165 = tmp_kernel_op_2 - 1.0;
       const real_t tmp_kernel_op_166 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_165;
       const real_t tmp_kernel_op_167 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_165;
       const real_t tmp_kernel_op_168 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_165;
       const real_t tmp_kernel_op_169 = tmp_kernel_op_31 - 1.0;
       const real_t tmp_kernel_op_170 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_169;
       const real_t tmp_kernel_op_171 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_169;
       const real_t tmp_kernel_op_172 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_169;
       const real_t tmp_kernel_op_173 = tmp_kernel_op_60 - 1.0;
       const real_t tmp_kernel_op_174 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_173;
       const real_t tmp_kernel_op_175 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_173;
       const real_t tmp_kernel_op_176 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_173;
       const real_t tmp_kernel_op_177 = tmp_kernel_op_89 - 1.0;
       const real_t tmp_kernel_op_178 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_177;
       const real_t tmp_kernel_op_179 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_177;
       const real_t tmp_kernel_op_180 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_177;
       const real_t tmp_kernel_op_181 = tmp_kernel_op_118 - 1.0;
       const real_t tmp_kernel_op_182 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_181;
       const real_t tmp_kernel_op_183 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_181;
       const real_t tmp_kernel_op_184 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_181;
       const real_t tmp_kernel_op_185 = tmp_kernel_op_0 - 1.0;
       const real_t tmp_kernel_op_186 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_185;
       const real_t tmp_kernel_op_187 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_185;
       const real_t tmp_kernel_op_188 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_185;
       const real_t tmp_kernel_op_189 = tmp_kernel_op_29 - 1.0;
       const real_t tmp_kernel_op_190 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_189;
       const real_t tmp_kernel_op_191 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_189;
       const real_t tmp_kernel_op_192 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_189;
       const real_t tmp_kernel_op_193 = tmp_kernel_op_58 - 1.0;
       const real_t tmp_kernel_op_194 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_193;
       const real_t tmp_kernel_op_195 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_193;
       const real_t tmp_kernel_op_196 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_193;
       const real_t tmp_kernel_op_197 = tmp_kernel_op_87 - 1.0;
       const real_t tmp_kernel_op_198 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_197;
       const real_t tmp_kernel_op_199 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_197;
       const real_t tmp_kernel_op_200 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_197;
       const real_t tmp_kernel_op_201 = tmp_kernel_op_116 - 1.0;
       const real_t tmp_kernel_op_202 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_201;
       const real_t tmp_kernel_op_203 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_201;
       const real_t tmp_kernel_op_204 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_201;
       const real_t tmp_kernel_op_205 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_206 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_207 = tmp_kernel_op_205 + tmp_kernel_op_206;
       const real_t tmp_kernel_op_208 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_209 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_210 = tmp_kernel_op_208 + tmp_kernel_op_209;
       const real_t tmp_kernel_op_211 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_212 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_213 = tmp_kernel_op_211 + tmp_kernel_op_212;
       const real_t tmp_kernel_op_214 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_215 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_31;
       const real_t tmp_kernel_op_216 = tmp_kernel_op_214 + tmp_kernel_op_215;
       const real_t tmp_kernel_op_217 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_218 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_31;
       const real_t tmp_kernel_op_219 = tmp_kernel_op_217 + tmp_kernel_op_218;
       const real_t tmp_kernel_op_220 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_221 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_31;
       const real_t tmp_kernel_op_222 = tmp_kernel_op_220 + tmp_kernel_op_221;
       const real_t tmp_kernel_op_223 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_58;
       const real_t tmp_kernel_op_224 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_60;
       const real_t tmp_kernel_op_225 = tmp_kernel_op_223 + tmp_kernel_op_224;
       const real_t tmp_kernel_op_226 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_58;
       const real_t tmp_kernel_op_227 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_60;
       const real_t tmp_kernel_op_228 = tmp_kernel_op_226 + tmp_kernel_op_227;
       const real_t tmp_kernel_op_229 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_58;
       const real_t tmp_kernel_op_230 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_60;
       const real_t tmp_kernel_op_231 = tmp_kernel_op_229 + tmp_kernel_op_230;
       const real_t tmp_kernel_op_232 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_87;
       const real_t tmp_kernel_op_233 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_89;
       const real_t tmp_kernel_op_234 = tmp_kernel_op_232 + tmp_kernel_op_233;
       const real_t tmp_kernel_op_235 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_87;
       const real_t tmp_kernel_op_236 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_89;
       const real_t tmp_kernel_op_237 = tmp_kernel_op_235 + tmp_kernel_op_236;
       const real_t tmp_kernel_op_238 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_87;
       const real_t tmp_kernel_op_239 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_89;
       const real_t tmp_kernel_op_240 = tmp_kernel_op_238 + tmp_kernel_op_239;
       const real_t tmp_kernel_op_241 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_116;
       const real_t tmp_kernel_op_242 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_118;
       const real_t tmp_kernel_op_243 = tmp_kernel_op_241 + tmp_kernel_op_242;
       const real_t tmp_kernel_op_244 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_116;
       const real_t tmp_kernel_op_245 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_118;
       const real_t tmp_kernel_op_246 = tmp_kernel_op_244 + tmp_kernel_op_245;
       const real_t tmp_kernel_op_247 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_116;
       const real_t tmp_kernel_op_248 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_118;
       const real_t tmp_kernel_op_249 = tmp_kernel_op_247 + tmp_kernel_op_248;
       const real_t tmp_kernel_op_250 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_251 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_252 = tmp_kernel_op_250 + tmp_kernel_op_251;
       const real_t tmp_kernel_op_253 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_254 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_255 = tmp_kernel_op_253 + tmp_kernel_op_254;
       const real_t tmp_kernel_op_256 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_257 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_258 = tmp_kernel_op_256 + tmp_kernel_op_257;
       const real_t tmp_kernel_op_259 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_260 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_30;
       const real_t tmp_kernel_op_261 = tmp_kernel_op_259 + tmp_kernel_op_260;
       const real_t tmp_kernel_op_262 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_263 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_30;
       const real_t tmp_kernel_op_264 = tmp_kernel_op_262 + tmp_kernel_op_263;
       const real_t tmp_kernel_op_265 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_266 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_30;
       const real_t tmp_kernel_op_267 = tmp_kernel_op_265 + tmp_kernel_op_266;
       const real_t tmp_kernel_op_268 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_58;
       const real_t tmp_kernel_op_269 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_59;
       const real_t tmp_kernel_op_270 = tmp_kernel_op_268 + tmp_kernel_op_269;
       const real_t tmp_kernel_op_271 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_58;
       const real_t tmp_kernel_op_272 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_59;
       const real_t tmp_kernel_op_273 = tmp_kernel_op_271 + tmp_kernel_op_272;
       const real_t tmp_kernel_op_274 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_58;
       const real_t tmp_kernel_op_275 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_59;
       const real_t tmp_kernel_op_276 = tmp_kernel_op_274 + tmp_kernel_op_275;
       const real_t tmp_kernel_op_277 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_87;
       const real_t tmp_kernel_op_278 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_88;
       const real_t tmp_kernel_op_279 = tmp_kernel_op_277 + tmp_kernel_op_278;
       const real_t tmp_kernel_op_280 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_87;
       const real_t tmp_kernel_op_281 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_88;
       const real_t tmp_kernel_op_282 = tmp_kernel_op_280 + tmp_kernel_op_281;
       const real_t tmp_kernel_op_283 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_87;
       const real_t tmp_kernel_op_284 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_88;
       const real_t tmp_kernel_op_285 = tmp_kernel_op_283 + tmp_kernel_op_284;
       const real_t tmp_kernel_op_286 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_116;
       const real_t tmp_kernel_op_287 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_117;
       const real_t tmp_kernel_op_288 = tmp_kernel_op_286 + tmp_kernel_op_287;
       const real_t tmp_kernel_op_289 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_116;
       const real_t tmp_kernel_op_290 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_117;
       const real_t tmp_kernel_op_291 = tmp_kernel_op_289 + tmp_kernel_op_290;
       const real_t tmp_kernel_op_292 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_116;
       const real_t tmp_kernel_op_293 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_117;
       const real_t tmp_kernel_op_294 = tmp_kernel_op_292 + tmp_kernel_op_293;
       const real_t tmp_kernel_op_295 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_296 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_297 = tmp_kernel_op_295 + tmp_kernel_op_296;
       const real_t tmp_kernel_op_298 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_299 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_300 = tmp_kernel_op_298 + tmp_kernel_op_299;
       const real_t tmp_kernel_op_301 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_302 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_303 = tmp_kernel_op_301 + tmp_kernel_op_302;
       const real_t tmp_kernel_op_304 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_31;
       const real_t tmp_kernel_op_305 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_30;
       const real_t tmp_kernel_op_306 = tmp_kernel_op_304 + tmp_kernel_op_305;
       const real_t tmp_kernel_op_307 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_31;
       const real_t tmp_kernel_op_308 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_30;
       const real_t tmp_kernel_op_309 = tmp_kernel_op_307 + tmp_kernel_op_308;
       const real_t tmp_kernel_op_310 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_31;
       const real_t tmp_kernel_op_311 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_30;
       const real_t tmp_kernel_op_312 = tmp_kernel_op_310 + tmp_kernel_op_311;
       const real_t tmp_kernel_op_313 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_60;
       const real_t tmp_kernel_op_314 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_59;
       const real_t tmp_kernel_op_315 = tmp_kernel_op_313 + tmp_kernel_op_314;
       const real_t tmp_kernel_op_316 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_60;
       const real_t tmp_kernel_op_317 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_59;
       const real_t tmp_kernel_op_318 = tmp_kernel_op_316 + tmp_kernel_op_317;
       const real_t tmp_kernel_op_319 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_60;
       const real_t tmp_kernel_op_320 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_59;
       const real_t tmp_kernel_op_321 = tmp_kernel_op_319 + tmp_kernel_op_320;
       const real_t tmp_kernel_op_322 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_89;
       const real_t tmp_kernel_op_323 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_88;
       const real_t tmp_kernel_op_324 = tmp_kernel_op_322 + tmp_kernel_op_323;
       const real_t tmp_kernel_op_325 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_89;
       const real_t tmp_kernel_op_326 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_88;
       const real_t tmp_kernel_op_327 = tmp_kernel_op_325 + tmp_kernel_op_326;
       const real_t tmp_kernel_op_328 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_89;
       const real_t tmp_kernel_op_329 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_88;
       const real_t tmp_kernel_op_330 = tmp_kernel_op_328 + tmp_kernel_op_329;
       const real_t tmp_kernel_op_331 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_118;
       const real_t tmp_kernel_op_332 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_117;
       const real_t tmp_kernel_op_333 = tmp_kernel_op_331 + tmp_kernel_op_332;
       const real_t tmp_kernel_op_334 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_118;
       const real_t tmp_kernel_op_335 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_117;
       const real_t tmp_kernel_op_336 = tmp_kernel_op_334 + tmp_kernel_op_335;
       const real_t tmp_kernel_op_337 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_118;
       const real_t tmp_kernel_op_338 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_117;
       const real_t tmp_kernel_op_339 = tmp_kernel_op_337 + tmp_kernel_op_338;
       const real_t tmp_kernel_op_340 = -tmp_kernel_op_3 + 2.0;
       const real_t tmp_kernel_op_341 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_340 - tmp_kernel_op_205 - tmp_kernel_op_250;
       const real_t tmp_kernel_op_342 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_340 - tmp_kernel_op_208 - tmp_kernel_op_253;
       const real_t tmp_kernel_op_343 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_340 - tmp_kernel_op_211 - tmp_kernel_op_256;
       const real_t tmp_kernel_op_344 = -tmp_kernel_op_32;
       const real_t tmp_kernel_op_345 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_344 - tmp_kernel_op_214 - tmp_kernel_op_259;
       const real_t tmp_kernel_op_346 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_344 - tmp_kernel_op_217 - tmp_kernel_op_262;
       const real_t tmp_kernel_op_347 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_344 - tmp_kernel_op_220 - tmp_kernel_op_265;
       const real_t tmp_kernel_op_348 = -tmp_kernel_op_61 + 2.666666666666667;
       const real_t tmp_kernel_op_349 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_348 - tmp_kernel_op_223 - tmp_kernel_op_268;
       const real_t tmp_kernel_op_350 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_348 - tmp_kernel_op_226 - tmp_kernel_op_271;
       const real_t tmp_kernel_op_351 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_348 - tmp_kernel_op_229 - tmp_kernel_op_274;
       const real_t tmp_kernel_op_352 = -tmp_kernel_op_90 + 2.666666666666667;
       const real_t tmp_kernel_op_353 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_352 - tmp_kernel_op_232 - tmp_kernel_op_277;
       const real_t tmp_kernel_op_354 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_352 - tmp_kernel_op_235 - tmp_kernel_op_280;
       const real_t tmp_kernel_op_355 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_352 - tmp_kernel_op_238 - tmp_kernel_op_283;
       const real_t tmp_kernel_op_356 = -tmp_kernel_op_119 + 2.666666666666667;
       const real_t tmp_kernel_op_357 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_356 - tmp_kernel_op_241 - tmp_kernel_op_286;
       const real_t tmp_kernel_op_358 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_356 - tmp_kernel_op_244 - tmp_kernel_op_289;
       const real_t tmp_kernel_op_359 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_356 - tmp_kernel_op_247 - tmp_kernel_op_292;
       const real_t tmp_kernel_op_360 = tmp_kernel_op_0 - 4.0;
       const real_t tmp_kernel_op_361 = -tmp_kernel_op_1 - tmp_kernel_op_360 - 2.0;
       const real_t tmp_kernel_op_362 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_361 - tmp_kernel_op_206 - tmp_kernel_op_295;
       const real_t tmp_kernel_op_363 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_361 - tmp_kernel_op_209 - tmp_kernel_op_298;
       const real_t tmp_kernel_op_364 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_361 - tmp_kernel_op_212 - tmp_kernel_op_301;
       const real_t tmp_kernel_op_365 = tmp_kernel_op_29 - 4.0;
       const real_t tmp_kernel_op_366 = -tmp_kernel_op_30 - tmp_kernel_op_365 - 1.3333333333333333;
       const real_t tmp_kernel_op_367 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_366 - tmp_kernel_op_215 - tmp_kernel_op_304;
       const real_t tmp_kernel_op_368 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_366 - tmp_kernel_op_218 - tmp_kernel_op_307;
       const real_t tmp_kernel_op_369 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_366 - tmp_kernel_op_221 - tmp_kernel_op_310;
       const real_t tmp_kernel_op_370 = tmp_kernel_op_58 - 4.0;
       const real_t tmp_kernel_op_371 = -tmp_kernel_op_370 - tmp_kernel_op_59 - 4.0;
       const real_t tmp_kernel_op_372 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_371 - tmp_kernel_op_224 - tmp_kernel_op_313;
       const real_t tmp_kernel_op_373 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_371 - tmp_kernel_op_227 - tmp_kernel_op_316;
       const real_t tmp_kernel_op_374 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_371 - tmp_kernel_op_230 - tmp_kernel_op_319;
       const real_t tmp_kernel_op_375 = tmp_kernel_op_87 - 4.0;
       const real_t tmp_kernel_op_376 = -tmp_kernel_op_375 - tmp_kernel_op_88 - 1.3333333333333333;
       const real_t tmp_kernel_op_377 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_376 - tmp_kernel_op_233 - tmp_kernel_op_322;
       const real_t tmp_kernel_op_378 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_376 - tmp_kernel_op_236 - tmp_kernel_op_325;
       const real_t tmp_kernel_op_379 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_376 - tmp_kernel_op_239 - tmp_kernel_op_328;
       const real_t tmp_kernel_op_380 = tmp_kernel_op_116 - 4.0;
       const real_t tmp_kernel_op_381 = -tmp_kernel_op_117 - tmp_kernel_op_380 - 1.3333333333333333;
       const real_t tmp_kernel_op_382 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_381 - tmp_kernel_op_242 - tmp_kernel_op_331;
       const real_t tmp_kernel_op_383 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_381 - tmp_kernel_op_245 - tmp_kernel_op_334;
       const real_t tmp_kernel_op_384 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_381 - tmp_kernel_op_248 - tmp_kernel_op_337;
       const real_t tmp_kernel_op_385 = -tmp_kernel_op_2 - tmp_kernel_op_360 - 2.0;
       const real_t tmp_kernel_op_386 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_385 - tmp_kernel_op_251 - tmp_kernel_op_296;
       const real_t tmp_kernel_op_387 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_385 - tmp_kernel_op_254 - tmp_kernel_op_299;
       const real_t tmp_kernel_op_388 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_385 - tmp_kernel_op_257 - tmp_kernel_op_302;
       const real_t tmp_kernel_op_389 = -tmp_kernel_op_31 - tmp_kernel_op_365 - 1.3333333333333333;
       const real_t tmp_kernel_op_390 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_389 - tmp_kernel_op_260 - tmp_kernel_op_305;
       const real_t tmp_kernel_op_391 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_389 - tmp_kernel_op_263 - tmp_kernel_op_308;
       const real_t tmp_kernel_op_392 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_389 - tmp_kernel_op_266 - tmp_kernel_op_311;
       const real_t tmp_kernel_op_393 = -tmp_kernel_op_370 - tmp_kernel_op_60 - 1.3333333333333333;
       const real_t tmp_kernel_op_394 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_393 - tmp_kernel_op_269 - tmp_kernel_op_314;
       const real_t tmp_kernel_op_395 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_393 - tmp_kernel_op_272 - tmp_kernel_op_317;
       const real_t tmp_kernel_op_396 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_393 - tmp_kernel_op_275 - tmp_kernel_op_320;
       const real_t tmp_kernel_op_397 = -tmp_kernel_op_375 - tmp_kernel_op_89 - 4.0;
       const real_t tmp_kernel_op_398 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_397 - tmp_kernel_op_278 - tmp_kernel_op_323;
       const real_t tmp_kernel_op_399 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_397 - tmp_kernel_op_281 - tmp_kernel_op_326;
       const real_t tmp_kernel_op_400 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_397 - tmp_kernel_op_284 - tmp_kernel_op_329;
       const real_t tmp_kernel_op_401 = -tmp_kernel_op_118 - tmp_kernel_op_380 - 1.3333333333333333;
       const real_t tmp_kernel_op_402 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_401 - tmp_kernel_op_287 - tmp_kernel_op_332;
       const real_t tmp_kernel_op_403 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_401 - tmp_kernel_op_290 - tmp_kernel_op_335;
       const real_t tmp_kernel_op_404 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_401 - tmp_kernel_op_293 - tmp_kernel_op_338;
       {
          /* CellType.WHITE_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
             const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
             const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
             const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
             const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
             const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
             const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
             const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
             const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
             const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
             const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
             const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
             const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
             const real_t tmp_blending_op_35 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_36 = -tmp_blending_op_35;
             const real_t tmp_blending_op_37 = (tmp_blending_op_28*tmp_blending_op_28);
             const real_t tmp_blending_op_38 = (tmp_blending_op_33*tmp_blending_op_33);
             const real_t tmp_blending_op_39 = tmp_blending_op_37 + tmp_blending_op_38 + tmp_blending_op_4;
             const real_t tmp_blending_op_42 = pow(tmp_blending_op_39, -1.5000000000000000)*tmp_blending_op_41;
             const real_t tmp_blending_op_44 = tmp_blending_op_23*tmp_blending_op_39;
             const real_t tmp_blending_op_45 = -tmp_blending_op_33*tmp_blending_op_35 - tmp_blending_op_43*tmp_blending_op_44;
             const real_t tmp_blending_op_46 = tmp_blending_op_3*tmp_blending_op_42;
             const real_t tmp_blending_op_48 = tmp_blending_op_28*tmp_blending_op_36 + tmp_blending_op_44*tmp_blending_op_47;
             const real_t tmp_blending_op_49 = tmp_blending_op_3*tmp_blending_op_36 + tmp_blending_op_39*tmp_blending_op_40;
             const real_t tmp_blending_op_50 = tmp_blending_op_33*tmp_blending_op_42;
             const real_t tmp_blending_op_52 = tmp_blending_op_28*tmp_blending_op_42;
             const real_t tmp_blending_op_61 = p_affine_0_2 + tmp_blending_op_0*0.5 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_62 = (tmp_blending_op_61*tmp_blending_op_61);
             const real_t tmp_blending_op_63 = -tmp_blending_op_17 - tmp_blending_op_61;
             const real_t tmp_blending_op_64 = p_affine_0_0 + tmp_blending_op_25*0.5 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_65 = -tmp_blending_op_6 - tmp_blending_op_64;
             const real_t tmp_blending_op_66 = p_affine_0_1 + tmp_blending_op_30*0.5 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_67 = -tmp_blending_op_13 - tmp_blending_op_66;
             const real_t tmp_blending_op_68 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_65 - tmp_blending_op_12*tmp_blending_op_63 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_63 - tmp_blending_op_19*tmp_blending_op_65 - tmp_blending_op_20*tmp_blending_op_67 + tmp_blending_op_67*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_69 = -tmp_blending_op_68;
             const real_t tmp_blending_op_70 = (tmp_blending_op_64*tmp_blending_op_64);
             const real_t tmp_blending_op_71 = (tmp_blending_op_66*tmp_blending_op_66);
             const real_t tmp_blending_op_72 = tmp_blending_op_62 + tmp_blending_op_70 + tmp_blending_op_71;
             const real_t tmp_blending_op_73 = tmp_blending_op_41*pow(tmp_blending_op_72, -1.5000000000000000);
             const real_t tmp_blending_op_75 = -tmp_blending_op_66*tmp_blending_op_68 - tmp_blending_op_72*tmp_blending_op_74;
             const real_t tmp_blending_op_76 = tmp_blending_op_61*tmp_blending_op_73;
             const real_t tmp_blending_op_77 = tmp_blending_op_53*tmp_blending_op_72 + tmp_blending_op_64*tmp_blending_op_69;
             const real_t tmp_blending_op_78 = tmp_blending_op_40*tmp_blending_op_72 + tmp_blending_op_61*tmp_blending_op_69;
             const real_t tmp_blending_op_79 = tmp_blending_op_66*tmp_blending_op_73;
             const real_t tmp_blending_op_80 = tmp_blending_op_64*tmp_blending_op_73;
             const real_t tmp_blending_op_88 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.5 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_89 = (tmp_blending_op_88*tmp_blending_op_88);
             const real_t tmp_blending_op_90 = -tmp_blending_op_17 - tmp_blending_op_88;
             const real_t tmp_blending_op_91 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.5 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_92 = -tmp_blending_op_6 - tmp_blending_op_91;
             const real_t tmp_blending_op_93 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.5 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_94 = -tmp_blending_op_13 - tmp_blending_op_93;
             const real_t tmp_blending_op_95 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_92 - tmp_blending_op_12*tmp_blending_op_90 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_90 - tmp_blending_op_19*tmp_blending_op_92 - tmp_blending_op_20*tmp_blending_op_94 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_94);
             const real_t tmp_blending_op_96 = -tmp_blending_op_95;
             const real_t tmp_blending_op_97 = (tmp_blending_op_91*tmp_blending_op_91);
             const real_t tmp_blending_op_98 = (tmp_blending_op_93*tmp_blending_op_93);
             const real_t tmp_blending_op_99 = tmp_blending_op_89 + tmp_blending_op_97 + tmp_blending_op_98;
             const real_t tmp_blending_op_100 = tmp_blending_op_41*pow(tmp_blending_op_99, -1.5000000000000000);
             const real_t tmp_blending_op_101 = -tmp_blending_op_74*tmp_blending_op_99 - tmp_blending_op_93*tmp_blending_op_95;
             const real_t tmp_blending_op_102 = tmp_blending_op_100*tmp_blending_op_88;
             const real_t tmp_blending_op_103 = tmp_blending_op_53*tmp_blending_op_99 + tmp_blending_op_91*tmp_blending_op_96;
             const real_t tmp_blending_op_104 = tmp_blending_op_40*tmp_blending_op_99 + tmp_blending_op_88*tmp_blending_op_96;
             const real_t tmp_blending_op_105 = tmp_blending_op_100*tmp_blending_op_93;
             const real_t tmp_blending_op_106 = tmp_blending_op_100*tmp_blending_op_91;
             const real_t tmp_blending_op_114 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.5;
             const real_t tmp_blending_op_115 = (tmp_blending_op_114*tmp_blending_op_114);
             const real_t tmp_blending_op_116 = -tmp_blending_op_114 - tmp_blending_op_17;
             const real_t tmp_blending_op_117 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.5;
             const real_t tmp_blending_op_118 = -tmp_blending_op_117 - tmp_blending_op_6;
             const real_t tmp_blending_op_119 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.5;
             const real_t tmp_blending_op_120 = -tmp_blending_op_119 - tmp_blending_op_13;
             const real_t tmp_blending_op_121 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_118*tmp_blending_op_18 - tmp_blending_op_116*tmp_blending_op_12 + tmp_blending_op_116*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_118*tmp_blending_op_19 - tmp_blending_op_120*tmp_blending_op_20 + tmp_blending_op_120*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_122 = -tmp_blending_op_121;
             const real_t tmp_blending_op_123 = (tmp_blending_op_117*tmp_blending_op_117);
             const real_t tmp_blending_op_124 = (tmp_blending_op_119*tmp_blending_op_119);
             const real_t tmp_blending_op_125 = tmp_blending_op_115 + tmp_blending_op_123 + tmp_blending_op_124;
             const real_t tmp_blending_op_126 = pow(tmp_blending_op_125, -1.5000000000000000)*tmp_blending_op_41;
             const real_t tmp_blending_op_127 = -tmp_blending_op_119*tmp_blending_op_121 - tmp_blending_op_125*tmp_blending_op_74;
             const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_126;
             const real_t tmp_blending_op_129 = tmp_blending_op_117*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_53;
             const real_t tmp_blending_op_130 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_40;
             const real_t tmp_blending_op_131 = tmp_blending_op_119*tmp_blending_op_126;
             const real_t tmp_blending_op_132 = tmp_blending_op_117*tmp_blending_op_126;
             const real_t tmp_blending_op_140 = p_affine_0_2 + tmp_blending_op_0*0.25 + tmp_blending_op_1*0.25 + tmp_blending_op_2*0.25;
             const real_t tmp_blending_op_141 = (tmp_blending_op_140*tmp_blending_op_140);
             const real_t tmp_blending_op_142 = -tmp_blending_op_140 - tmp_blending_op_17;
             const real_t tmp_blending_op_143 = p_affine_0_0 + tmp_blending_op_25*0.25 + tmp_blending_op_26*0.25 + tmp_blending_op_27*0.25;
             const real_t tmp_blending_op_144 = -tmp_blending_op_143 - tmp_blending_op_6;
             const real_t tmp_blending_op_145 = p_affine_0_1 + tmp_blending_op_30*0.25 + tmp_blending_op_31*0.25 + tmp_blending_op_32*0.25;
             const real_t tmp_blending_op_146 = -tmp_blending_op_13 - tmp_blending_op_145;
             const real_t tmp_blending_op_147 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_144*tmp_blending_op_18 - tmp_blending_op_12*tmp_blending_op_142 + tmp_blending_op_14*tmp_blending_op_142*tmp_blending_op_15 - tmp_blending_op_144*tmp_blending_op_19 - tmp_blending_op_146*tmp_blending_op_20 + tmp_blending_op_146*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_148 = -tmp_blending_op_147;
             const real_t tmp_blending_op_149 = (tmp_blending_op_143*tmp_blending_op_143);
             const real_t tmp_blending_op_150 = (tmp_blending_op_145*tmp_blending_op_145);
             const real_t tmp_blending_op_151 = tmp_blending_op_141 + tmp_blending_op_149 + tmp_blending_op_150;
             const real_t tmp_blending_op_152 = pow(tmp_blending_op_151, -1.5000000000000000)*tmp_blending_op_41;
             const real_t tmp_blending_op_153 = -tmp_blending_op_145*tmp_blending_op_147 - tmp_blending_op_151*tmp_blending_op_74;
             const real_t tmp_blending_op_154 = tmp_blending_op_140*tmp_blending_op_152;
             const real_t tmp_blending_op_155 = tmp_blending_op_143*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_53;
             const real_t tmp_blending_op_156 = tmp_blending_op_140*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_40;
             const real_t tmp_blending_op_157 = tmp_blending_op_145*tmp_blending_op_152;
             const real_t tmp_blending_op_158 = tmp_blending_op_143*tmp_blending_op_152;
             const real_t jac_blending_2_2_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_4 + tmp_blending_op_39*(tmp_blending_op_3*tmp_blending_op_40 + tmp_blending_op_35));
             const real_t jac_blending_2_1_q_4 = tmp_blending_op_45*tmp_blending_op_46;
             const real_t jac_blending_2_0_q_4 = tmp_blending_op_46*tmp_blending_op_48;
             const real_t jac_blending_1_2_q_4 = tmp_blending_op_49*tmp_blending_op_50;
             const real_t jac_blending_1_1_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_39*(tmp_blending_op_33*tmp_blending_op_51 + tmp_blending_op_35));
             const real_t tmp_blending_op_58 = jac_blending_1_1_q_4*jac_blending_2_0_q_4;
             const real_t jac_blending_1_0_q_4 = tmp_blending_op_48*tmp_blending_op_50;
             const real_t tmp_blending_op_55 = jac_blending_1_0_q_4*jac_blending_2_1_q_4;
             const real_t jac_blending_0_2_q_4 = tmp_blending_op_49*tmp_blending_op_52;
             const real_t jac_blending_0_1_q_4 = tmp_blending_op_45*tmp_blending_op_52;
             const real_t tmp_blending_op_57 = jac_blending_0_1_q_4*jac_blending_1_0_q_4;
             const real_t jac_blending_0_0_q_4 = tmp_blending_op_42*(-tmp_blending_op_35*tmp_blending_op_37 + tmp_blending_op_39*(tmp_blending_op_28*tmp_blending_op_53 + tmp_blending_op_35));
             const real_t tmp_blending_op_54 = jac_blending_0_0_q_4*jac_blending_1_1_q_4;
             const real_t tmp_blending_op_56 = jac_blending_0_0_q_4*jac_blending_2_1_q_4;
             const real_t tmp_blending_op_59 = jac_blending_0_1_q_4*jac_blending_1_2_q_4*jac_blending_2_0_q_4 + jac_blending_0_2_q_4*tmp_blending_op_55 - jac_blending_0_2_q_4*tmp_blending_op_58 - jac_blending_1_2_q_4*tmp_blending_op_56 + jac_blending_2_2_q_4*tmp_blending_op_54 - jac_blending_2_2_q_4*tmp_blending_op_57;
             const real_t tmp_blending_op_60 = 1.0 / (tmp_blending_op_59);
             const real_t abs_det_jac_blending_q_4 = tmp_blending_op_59;
             const real_t jac_blending_inv_2_2_q_4 = tmp_blending_op_60*(tmp_blending_op_54 - tmp_blending_op_57);
             const real_t jac_blending_inv_2_1_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_2_0_q_4 - tmp_blending_op_56);
             const real_t jac_blending_inv_2_0_q_4 = tmp_blending_op_60*(tmp_blending_op_55 - tmp_blending_op_58);
             const real_t jac_blending_inv_1_2_q_4 = tmp_blending_op_60*(-jac_blending_0_0_q_4*jac_blending_1_2_q_4 + jac_blending_0_2_q_4*jac_blending_1_0_q_4);
             const real_t jac_blending_inv_1_1_q_4 = tmp_blending_op_60*(jac_blending_0_0_q_4*jac_blending_2_2_q_4 - jac_blending_0_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_1_0_q_4 = tmp_blending_op_60*(-jac_blending_1_0_q_4*jac_blending_2_2_q_4 + jac_blending_1_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_0_2_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_1_2_q_4 - jac_blending_0_2_q_4*jac_blending_1_1_q_4);
             const real_t jac_blending_inv_0_1_q_4 = tmp_blending_op_60*(-jac_blending_0_1_q_4*jac_blending_2_2_q_4 + jac_blending_0_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_inv_0_0_q_4 = tmp_blending_op_60*(jac_blending_1_1_q_4*jac_blending_2_2_q_4 - jac_blending_1_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_2_2_q_3 = tmp_blending_op_73*(tmp_blending_op_62*tmp_blending_op_69 + tmp_blending_op_72*(tmp_blending_op_40*tmp_blending_op_61 + tmp_blending_op_68));
             const real_t jac_blending_2_1_q_3 = tmp_blending_op_75*tmp_blending_op_76;
             const real_t jac_blending_2_0_q_3 = tmp_blending_op_76*tmp_blending_op_77;
             const real_t jac_blending_1_2_q_3 = tmp_blending_op_78*tmp_blending_op_79;
             const real_t jac_blending_1_1_q_3 = tmp_blending_op_73*(tmp_blending_op_69*tmp_blending_op_71 + tmp_blending_op_72*(tmp_blending_op_51*tmp_blending_op_66 + tmp_blending_op_68));
             const real_t tmp_blending_op_85 = jac_blending_1_1_q_3*jac_blending_2_0_q_3;
             const real_t jac_blending_1_0_q_3 = tmp_blending_op_77*tmp_blending_op_79;
             const real_t tmp_blending_op_82 = jac_blending_1_0_q_3*jac_blending_2_1_q_3;
             const real_t jac_blending_0_2_q_3 = tmp_blending_op_78*tmp_blending_op_80;
             const real_t jac_blending_0_1_q_3 = tmp_blending_op_75*tmp_blending_op_80;
             const real_t tmp_blending_op_84 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
             const real_t jac_blending_0_0_q_3 = tmp_blending_op_73*(-tmp_blending_op_68*tmp_blending_op_70 + tmp_blending_op_72*(tmp_blending_op_53*tmp_blending_op_64 + tmp_blending_op_68));
             const real_t tmp_blending_op_81 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
             const real_t tmp_blending_op_83 = jac_blending_0_0_q_3*jac_blending_2_1_q_3;
             const real_t tmp_blending_op_86 = jac_blending_0_1_q_3*jac_blending_1_2_q_3*jac_blending_2_0_q_3 + jac_blending_0_2_q_3*tmp_blending_op_82 - jac_blending_0_2_q_3*tmp_blending_op_85 - jac_blending_1_2_q_3*tmp_blending_op_83 + jac_blending_2_2_q_3*tmp_blending_op_81 - jac_blending_2_2_q_3*tmp_blending_op_84;
             const real_t tmp_blending_op_87 = 1.0 / (tmp_blending_op_86);
             const real_t abs_det_jac_blending_q_3 = tmp_blending_op_86;
             const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_87*(tmp_blending_op_81 - tmp_blending_op_84);
             const real_t jac_blending_inv_2_1_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_2_0_q_3 - tmp_blending_op_83);
             const real_t jac_blending_inv_2_0_q_3 = tmp_blending_op_87*(tmp_blending_op_82 - tmp_blending_op_85);
             const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_87*(-jac_blending_0_0_q_3*jac_blending_1_2_q_3 + jac_blending_0_2_q_3*jac_blending_1_0_q_3);
             const real_t jac_blending_inv_1_1_q_3 = tmp_blending_op_87*(jac_blending_0_0_q_3*jac_blending_2_2_q_3 - jac_blending_0_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_1_0_q_3 = tmp_blending_op_87*(-jac_blending_1_0_q_3*jac_blending_2_2_q_3 + jac_blending_1_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_1_2_q_3 - jac_blending_0_2_q_3*jac_blending_1_1_q_3);
             const real_t jac_blending_inv_0_1_q_3 = tmp_blending_op_87*(-jac_blending_0_1_q_3*jac_blending_2_2_q_3 + jac_blending_0_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_inv_0_0_q_3 = tmp_blending_op_87*(jac_blending_1_1_q_3*jac_blending_2_2_q_3 - jac_blending_1_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_2_2_q_2 = tmp_blending_op_100*(tmp_blending_op_89*tmp_blending_op_96 + tmp_blending_op_99*(tmp_blending_op_40*tmp_blending_op_88 + tmp_blending_op_95));
             const real_t jac_blending_2_1_q_2 = tmp_blending_op_101*tmp_blending_op_102;
             const real_t jac_blending_2_0_q_2 = tmp_blending_op_102*tmp_blending_op_103;
             const real_t jac_blending_1_2_q_2 = tmp_blending_op_104*tmp_blending_op_105;
             const real_t jac_blending_1_1_q_2 = tmp_blending_op_100*(tmp_blending_op_96*tmp_blending_op_98 + tmp_blending_op_99*(tmp_blending_op_51*tmp_blending_op_93 + tmp_blending_op_95));
             const real_t tmp_blending_op_111 = jac_blending_1_1_q_2*jac_blending_2_0_q_2;
             const real_t jac_blending_1_0_q_2 = tmp_blending_op_103*tmp_blending_op_105;
             const real_t tmp_blending_op_108 = jac_blending_1_0_q_2*jac_blending_2_1_q_2;
             const real_t jac_blending_0_2_q_2 = tmp_blending_op_104*tmp_blending_op_106;
             const real_t jac_blending_0_1_q_2 = tmp_blending_op_101*tmp_blending_op_106;
             const real_t tmp_blending_op_110 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
             const real_t jac_blending_0_0_q_2 = tmp_blending_op_100*(-tmp_blending_op_95*tmp_blending_op_97 + tmp_blending_op_99*(tmp_blending_op_53*tmp_blending_op_91 + tmp_blending_op_95));
             const real_t tmp_blending_op_107 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
             const real_t tmp_blending_op_109 = jac_blending_0_0_q_2*jac_blending_2_1_q_2;
             const real_t tmp_blending_op_112 = jac_blending_0_1_q_2*jac_blending_1_2_q_2*jac_blending_2_0_q_2 + jac_blending_0_2_q_2*tmp_blending_op_108 - jac_blending_0_2_q_2*tmp_blending_op_111 - jac_blending_1_2_q_2*tmp_blending_op_109 + jac_blending_2_2_q_2*tmp_blending_op_107 - jac_blending_2_2_q_2*tmp_blending_op_110;
             const real_t tmp_blending_op_113 = 1.0 / (tmp_blending_op_112);
             const real_t abs_det_jac_blending_q_2 = tmp_blending_op_112;
             const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_113*(tmp_blending_op_107 - tmp_blending_op_110);
             const real_t jac_blending_inv_2_1_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_2_0_q_2 - tmp_blending_op_109);
             const real_t jac_blending_inv_2_0_q_2 = tmp_blending_op_113*(tmp_blending_op_108 - tmp_blending_op_111);
             const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_113*(-jac_blending_0_0_q_2*jac_blending_1_2_q_2 + jac_blending_0_2_q_2*jac_blending_1_0_q_2);
             const real_t jac_blending_inv_1_1_q_2 = tmp_blending_op_113*(jac_blending_0_0_q_2*jac_blending_2_2_q_2 - jac_blending_0_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_1_0_q_2 = tmp_blending_op_113*(-jac_blending_1_0_q_2*jac_blending_2_2_q_2 + jac_blending_1_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_1_2_q_2 - jac_blending_0_2_q_2*jac_blending_1_1_q_2);
             const real_t jac_blending_inv_0_1_q_2 = tmp_blending_op_113*(-jac_blending_0_1_q_2*jac_blending_2_2_q_2 + jac_blending_0_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_inv_0_0_q_2 = tmp_blending_op_113*(jac_blending_1_1_q_2*jac_blending_2_2_q_2 - jac_blending_1_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_2_2_q_1 = tmp_blending_op_126*(tmp_blending_op_115*tmp_blending_op_122 + tmp_blending_op_125*(tmp_blending_op_114*tmp_blending_op_40 + tmp_blending_op_121));
             const real_t jac_blending_2_1_q_1 = tmp_blending_op_127*tmp_blending_op_128;
             const real_t jac_blending_2_0_q_1 = tmp_blending_op_128*tmp_blending_op_129;
             const real_t jac_blending_1_2_q_1 = tmp_blending_op_130*tmp_blending_op_131;
             const real_t jac_blending_1_1_q_1 = tmp_blending_op_126*(tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*(tmp_blending_op_119*tmp_blending_op_51 + tmp_blending_op_121));
             const real_t tmp_blending_op_137 = jac_blending_1_1_q_1*jac_blending_2_0_q_1;
             const real_t jac_blending_1_0_q_1 = tmp_blending_op_129*tmp_blending_op_131;
             const real_t tmp_blending_op_134 = jac_blending_1_0_q_1*jac_blending_2_1_q_1;
             const real_t jac_blending_0_2_q_1 = tmp_blending_op_130*tmp_blending_op_132;
             const real_t jac_blending_0_1_q_1 = tmp_blending_op_127*tmp_blending_op_132;
             const real_t tmp_blending_op_136 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
             const real_t jac_blending_0_0_q_1 = tmp_blending_op_126*(-tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*(tmp_blending_op_117*tmp_blending_op_53 + tmp_blending_op_121));
             const real_t tmp_blending_op_133 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
             const real_t tmp_blending_op_135 = jac_blending_0_0_q_1*jac_blending_2_1_q_1;
             const real_t tmp_blending_op_138 = jac_blending_0_1_q_1*jac_blending_1_2_q_1*jac_blending_2_0_q_1 + jac_blending_0_2_q_1*tmp_blending_op_134 - jac_blending_0_2_q_1*tmp_blending_op_137 - jac_blending_1_2_q_1*tmp_blending_op_135 + jac_blending_2_2_q_1*tmp_blending_op_133 - jac_blending_2_2_q_1*tmp_blending_op_136;
             const real_t tmp_blending_op_139 = 1.0 / (tmp_blending_op_138);
             const real_t abs_det_jac_blending_q_1 = tmp_blending_op_138;
             const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_139*(tmp_blending_op_133 - tmp_blending_op_136);
             const real_t jac_blending_inv_2_1_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_2_0_q_1 - tmp_blending_op_135);
             const real_t jac_blending_inv_2_0_q_1 = tmp_blending_op_139*(tmp_blending_op_134 - tmp_blending_op_137);
             const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_139*(-jac_blending_0_0_q_1*jac_blending_1_2_q_1 + jac_blending_0_2_q_1*jac_blending_1_0_q_1);
             const real_t jac_blending_inv_1_1_q_1 = tmp_blending_op_139*(jac_blending_0_0_q_1*jac_blending_2_2_q_1 - jac_blending_0_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_1_0_q_1 = tmp_blending_op_139*(-jac_blending_1_0_q_1*jac_blending_2_2_q_1 + jac_blending_1_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_1_2_q_1 - jac_blending_0_2_q_1*jac_blending_1_1_q_1);
             const real_t jac_blending_inv_0_1_q_1 = tmp_blending_op_139*(-jac_blending_0_1_q_1*jac_blending_2_2_q_1 + jac_blending_0_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_inv_0_0_q_1 = tmp_blending_op_139*(jac_blending_1_1_q_1*jac_blending_2_2_q_1 - jac_blending_1_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_2_2_q_0 = tmp_blending_op_152*(tmp_blending_op_141*tmp_blending_op_148 + tmp_blending_op_151*(tmp_blending_op_140*tmp_blending_op_40 + tmp_blending_op_147));
             const real_t jac_blending_2_1_q_0 = tmp_blending_op_153*tmp_blending_op_154;
             const real_t jac_blending_2_0_q_0 = tmp_blending_op_154*tmp_blending_op_155;
             const real_t jac_blending_1_2_q_0 = tmp_blending_op_156*tmp_blending_op_157;
             const real_t jac_blending_1_1_q_0 = tmp_blending_op_152*(tmp_blending_op_148*tmp_blending_op_150 + tmp_blending_op_151*(tmp_blending_op_145*tmp_blending_op_51 + tmp_blending_op_147));
             const real_t tmp_blending_op_163 = jac_blending_1_1_q_0*jac_blending_2_0_q_0;
             const real_t jac_blending_1_0_q_0 = tmp_blending_op_155*tmp_blending_op_157;
             const real_t tmp_blending_op_160 = jac_blending_1_0_q_0*jac_blending_2_1_q_0;
             const real_t jac_blending_0_2_q_0 = tmp_blending_op_156*tmp_blending_op_158;
             const real_t jac_blending_0_1_q_0 = tmp_blending_op_153*tmp_blending_op_158;
             const real_t tmp_blending_op_162 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
             const real_t jac_blending_0_0_q_0 = tmp_blending_op_152*(-tmp_blending_op_147*tmp_blending_op_149 + tmp_blending_op_151*(tmp_blending_op_143*tmp_blending_op_53 + tmp_blending_op_147));
             const real_t tmp_blending_op_159 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
             const real_t tmp_blending_op_161 = jac_blending_0_0_q_0*jac_blending_2_1_q_0;
             const real_t tmp_blending_op_164 = jac_blending_0_1_q_0*jac_blending_1_2_q_0*jac_blending_2_0_q_0 + jac_blending_0_2_q_0*tmp_blending_op_160 - jac_blending_0_2_q_0*tmp_blending_op_163 - jac_blending_1_2_q_0*tmp_blending_op_161 + jac_blending_2_2_q_0*tmp_blending_op_159 - jac_blending_2_2_q_0*tmp_blending_op_162;
             const real_t tmp_blending_op_165 = 1.0 / (tmp_blending_op_164);
             const real_t abs_det_jac_blending_q_0 = tmp_blending_op_164;
             const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_165*(tmp_blending_op_159 - tmp_blending_op_162);
             const real_t jac_blending_inv_2_1_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_2_0_q_0 - tmp_blending_op_161);
             const real_t jac_blending_inv_2_0_q_0 = tmp_blending_op_165*(tmp_blending_op_160 - tmp_blending_op_163);
             const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_165*(-jac_blending_0_0_q_0*jac_blending_1_2_q_0 + jac_blending_0_2_q_0*jac_blending_1_0_q_0);
             const real_t jac_blending_inv_1_1_q_0 = tmp_blending_op_165*(jac_blending_0_0_q_0*jac_blending_2_2_q_0 - jac_blending_0_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_1_0_q_0 = tmp_blending_op_165*(-jac_blending_1_0_q_0*jac_blending_2_2_q_0 + jac_blending_1_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_1_2_q_0 - jac_blending_0_2_q_0*jac_blending_1_1_q_0);
             const real_t jac_blending_inv_0_1_q_0 = tmp_blending_op_165*(-jac_blending_0_1_q_0*jac_blending_2_2_q_0 + jac_blending_0_2_q_0*jac_blending_2_1_q_0);
             const real_t jac_blending_inv_0_0_q_0 = tmp_blending_op_165*(jac_blending_1_1_q_0*jac_blending_2_2_q_0 - jac_blending_1_2_q_0*jac_blending_2_1_q_0);
             const real_t cp_times_delta_dof_0 = _data_cp_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t cp_times_delta_dof_1 = _data_cp_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t cp_times_delta_dof_2 = _data_cp_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t cp_times_delta_dof_3 = _data_cp_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t cp_times_delta_dof_4 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t cp_times_delta_dof_5 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t cp_times_delta_dof_6 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t cp_times_delta_dof_7 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t cp_times_delta_dof_8 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t cp_times_delta_dof_9 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_0 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_1 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_2 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_3 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_4 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_5 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_6 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_7 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_8 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_9 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_0 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_1 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_2 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_3 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_4 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_5 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_6 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_7 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_8 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_9 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_0 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_1 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_2 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_3 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_4 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_5 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_6 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_7 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_8 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_9 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t tmp_kernel_op_25 = tmp_kernel_op_10*ux_dof_6 + tmp_kernel_op_13*ux_dof_1 + tmp_kernel_op_16*ux_dof_2 + tmp_kernel_op_19*ux_dof_3 + tmp_kernel_op_20*ux_dof_7 + tmp_kernel_op_21*ux_dof_8 + tmp_kernel_op_23*ux_dof_9 + tmp_kernel_op_24*ux_dof_0 + tmp_kernel_op_8*ux_dof_4 + tmp_kernel_op_9*ux_dof_5;
             const real_t tmp_kernel_op_26 = tmp_kernel_op_10*uy_dof_6 + tmp_kernel_op_13*uy_dof_1 + tmp_kernel_op_16*uy_dof_2 + tmp_kernel_op_19*uy_dof_3 + tmp_kernel_op_20*uy_dof_7 + tmp_kernel_op_21*uy_dof_8 + tmp_kernel_op_23*uy_dof_9 + tmp_kernel_op_24*uy_dof_0 + tmp_kernel_op_8*uy_dof_4 + tmp_kernel_op_9*uy_dof_5;
             const real_t tmp_kernel_op_27 = tmp_kernel_op_10*uz_dof_6 + tmp_kernel_op_13*uz_dof_1 + tmp_kernel_op_16*uz_dof_2 + tmp_kernel_op_19*uz_dof_3 + tmp_kernel_op_20*uz_dof_7 + tmp_kernel_op_21*uz_dof_8 + tmp_kernel_op_23*uz_dof_9 + tmp_kernel_op_24*uz_dof_0 + tmp_kernel_op_8*uz_dof_4 + tmp_kernel_op_9*uz_dof_5;
             const real_t tmp_kernel_op_28 = abs_det_jac_affine_WHITE_UP*abs_det_jac_blending_q_0*(cp_times_delta_dof_0*tmp_kernel_op_24 + cp_times_delta_dof_1*tmp_kernel_op_13 + cp_times_delta_dof_2*tmp_kernel_op_16 + cp_times_delta_dof_3*tmp_kernel_op_19 + cp_times_delta_dof_4*tmp_kernel_op_8 + cp_times_delta_dof_5*tmp_kernel_op_9 + cp_times_delta_dof_6*tmp_kernel_op_10 + cp_times_delta_dof_7*tmp_kernel_op_20 + cp_times_delta_dof_8*tmp_kernel_op_21 + cp_times_delta_dof_9*tmp_kernel_op_23)*-0.1333333333333333;
             const real_t tmp_kernel_op_54 = tmp_kernel_op_37*ux_dof_4 + tmp_kernel_op_38*ux_dof_5 + tmp_kernel_op_39*ux_dof_6 + tmp_kernel_op_42*ux_dof_1 + tmp_kernel_op_45*ux_dof_2 + tmp_kernel_op_48*ux_dof_3 + tmp_kernel_op_49*ux_dof_7 + tmp_kernel_op_50*ux_dof_8 + tmp_kernel_op_52*ux_dof_9 + tmp_kernel_op_53*ux_dof_0;
             const real_t tmp_kernel_op_55 = tmp_kernel_op_37*uy_dof_4 + tmp_kernel_op_38*uy_dof_5 + tmp_kernel_op_39*uy_dof_6 + tmp_kernel_op_42*uy_dof_1 + tmp_kernel_op_45*uy_dof_2 + tmp_kernel_op_48*uy_dof_3 + tmp_kernel_op_49*uy_dof_7 + tmp_kernel_op_50*uy_dof_8 + tmp_kernel_op_52*uy_dof_9 + tmp_kernel_op_53*uy_dof_0;
             const real_t tmp_kernel_op_56 = tmp_kernel_op_37*uz_dof_4 + tmp_kernel_op_38*uz_dof_5 + tmp_kernel_op_39*uz_dof_6 + tmp_kernel_op_42*uz_dof_1 + tmp_kernel_op_45*uz_dof_2 + tmp_kernel_op_48*uz_dof_3 + tmp_kernel_op_49*uz_dof_7 + tmp_kernel_op_50*uz_dof_8 + tmp_kernel_op_52*uz_dof_9 + tmp_kernel_op_53*uz_dof_0;
             const real_t tmp_kernel_op_57 = abs_det_jac_affine_WHITE_UP*abs_det_jac_blending_q_1*(cp_times_delta_dof_0*tmp_kernel_op_53 + cp_times_delta_dof_1*tmp_kernel_op_42 + cp_times_delta_dof_2*tmp_kernel_op_45 + cp_times_delta_dof_3*tmp_kernel_op_48 + cp_times_delta_dof_4*tmp_kernel_op_37 + cp_times_delta_dof_5*tmp_kernel_op_38 + cp_times_delta_dof_6*tmp_kernel_op_39 + cp_times_delta_dof_7*tmp_kernel_op_49 + cp_times_delta_dof_8*tmp_kernel_op_50 + cp_times_delta_dof_9*tmp_kernel_op_52)*0.074999999999999983;
             const real_t tmp_kernel_op_83 = tmp_kernel_op_66*ux_dof_4 + tmp_kernel_op_67*ux_dof_5 + tmp_kernel_op_68*ux_dof_6 + tmp_kernel_op_71*ux_dof_1 + tmp_kernel_op_74*ux_dof_2 + tmp_kernel_op_77*ux_dof_3 + tmp_kernel_op_78*ux_dof_7 + tmp_kernel_op_79*ux_dof_8 + tmp_kernel_op_81*ux_dof_9 + tmp_kernel_op_82*ux_dof_0;
             const real_t tmp_kernel_op_84 = tmp_kernel_op_66*uy_dof_4 + tmp_kernel_op_67*uy_dof_5 + tmp_kernel_op_68*uy_dof_6 + tmp_kernel_op_71*uy_dof_1 + tmp_kernel_op_74*uy_dof_2 + tmp_kernel_op_77*uy_dof_3 + tmp_kernel_op_78*uy_dof_7 + tmp_kernel_op_79*uy_dof_8 + tmp_kernel_op_81*uy_dof_9 + tmp_kernel_op_82*uy_dof_0;
             const real_t tmp_kernel_op_85 = tmp_kernel_op_66*uz_dof_4 + tmp_kernel_op_67*uz_dof_5 + tmp_kernel_op_68*uz_dof_6 + tmp_kernel_op_71*uz_dof_1 + tmp_kernel_op_74*uz_dof_2 + tmp_kernel_op_77*uz_dof_3 + tmp_kernel_op_78*uz_dof_7 + tmp_kernel_op_79*uz_dof_8 + tmp_kernel_op_81*uz_dof_9 + tmp_kernel_op_82*uz_dof_0;
             const real_t tmp_kernel_op_86 = abs_det_jac_affine_WHITE_UP*abs_det_jac_blending_q_2*(cp_times_delta_dof_0*tmp_kernel_op_82 + cp_times_delta_dof_1*tmp_kernel_op_71 + cp_times_delta_dof_2*tmp_kernel_op_74 + cp_times_delta_dof_3*tmp_kernel_op_77 + cp_times_delta_dof_4*tmp_kernel_op_66 + cp_times_delta_dof_5*tmp_kernel_op_67 + cp_times_delta_dof_6*tmp_kernel_op_68 + cp_times_delta_dof_7*tmp_kernel_op_78 + cp_times_delta_dof_8*tmp_kernel_op_79 + cp_times_delta_dof_9*tmp_kernel_op_81)*0.074999999999999983;
             const real_t tmp_kernel_op_112 = tmp_kernel_op_100*ux_dof_1 + tmp_kernel_op_103*ux_dof_2 + tmp_kernel_op_106*ux_dof_3 + tmp_kernel_op_107*ux_dof_7 + tmp_kernel_op_108*ux_dof_8 + tmp_kernel_op_110*ux_dof_9 + tmp_kernel_op_111*ux_dof_0 + tmp_kernel_op_95*ux_dof_4 + tmp_kernel_op_96*ux_dof_5 + tmp_kernel_op_97*ux_dof_6;
             const real_t tmp_kernel_op_113 = tmp_kernel_op_100*uy_dof_1 + tmp_kernel_op_103*uy_dof_2 + tmp_kernel_op_106*uy_dof_3 + tmp_kernel_op_107*uy_dof_7 + tmp_kernel_op_108*uy_dof_8 + tmp_kernel_op_110*uy_dof_9 + tmp_kernel_op_111*uy_dof_0 + tmp_kernel_op_95*uy_dof_4 + tmp_kernel_op_96*uy_dof_5 + tmp_kernel_op_97*uy_dof_6;
             const real_t tmp_kernel_op_114 = tmp_kernel_op_100*uz_dof_1 + tmp_kernel_op_103*uz_dof_2 + tmp_kernel_op_106*uz_dof_3 + tmp_kernel_op_107*uz_dof_7 + tmp_kernel_op_108*uz_dof_8 + tmp_kernel_op_110*uz_dof_9 + tmp_kernel_op_111*uz_dof_0 + tmp_kernel_op_95*uz_dof_4 + tmp_kernel_op_96*uz_dof_5 + tmp_kernel_op_97*uz_dof_6;
             const real_t tmp_kernel_op_115 = abs_det_jac_affine_WHITE_UP*abs_det_jac_blending_q_3*(cp_times_delta_dof_0*tmp_kernel_op_111 + cp_times_delta_dof_1*tmp_kernel_op_100 + cp_times_delta_dof_2*tmp_kernel_op_103 + cp_times_delta_dof_3*tmp_kernel_op_106 + cp_times_delta_dof_4*tmp_kernel_op_95 + cp_times_delta_dof_5*tmp_kernel_op_96 + cp_times_delta_dof_6*tmp_kernel_op_97 + cp_times_delta_dof_7*tmp_kernel_op_107 + cp_times_delta_dof_8*tmp_kernel_op_108 + cp_times_delta_dof_9*tmp_kernel_op_110)*0.074999999999999983;
             const real_t tmp_kernel_op_141 = tmp_kernel_op_124*ux_dof_4 + tmp_kernel_op_125*ux_dof_5 + tmp_kernel_op_126*ux_dof_6 + tmp_kernel_op_129*ux_dof_1 + tmp_kernel_op_132*ux_dof_2 + tmp_kernel_op_135*ux_dof_3 + tmp_kernel_op_136*ux_dof_7 + tmp_kernel_op_137*ux_dof_8 + tmp_kernel_op_139*ux_dof_9 + tmp_kernel_op_140*ux_dof_0;
             const real_t tmp_kernel_op_142 = tmp_kernel_op_124*uy_dof_4 + tmp_kernel_op_125*uy_dof_5 + tmp_kernel_op_126*uy_dof_6 + tmp_kernel_op_129*uy_dof_1 + tmp_kernel_op_132*uy_dof_2 + tmp_kernel_op_135*uy_dof_3 + tmp_kernel_op_136*uy_dof_7 + tmp_kernel_op_137*uy_dof_8 + tmp_kernel_op_139*uy_dof_9 + tmp_kernel_op_140*uy_dof_0;
             const real_t tmp_kernel_op_143 = tmp_kernel_op_124*uz_dof_4 + tmp_kernel_op_125*uz_dof_5 + tmp_kernel_op_126*uz_dof_6 + tmp_kernel_op_129*uz_dof_1 + tmp_kernel_op_132*uz_dof_2 + tmp_kernel_op_135*uz_dof_3 + tmp_kernel_op_136*uz_dof_7 + tmp_kernel_op_137*uz_dof_8 + tmp_kernel_op_139*uz_dof_9 + tmp_kernel_op_140*uz_dof_0;
             const real_t tmp_kernel_op_144 = abs_det_jac_affine_WHITE_UP*abs_det_jac_blending_q_4*(cp_times_delta_dof_0*tmp_kernel_op_140 + cp_times_delta_dof_1*tmp_kernel_op_129 + cp_times_delta_dof_2*tmp_kernel_op_132 + cp_times_delta_dof_3*tmp_kernel_op_135 + cp_times_delta_dof_4*tmp_kernel_op_124 + cp_times_delta_dof_5*tmp_kernel_op_125 + cp_times_delta_dof_6*tmp_kernel_op_126 + cp_times_delta_dof_7*tmp_kernel_op_136 + cp_times_delta_dof_8*tmp_kernel_op_137 + cp_times_delta_dof_9*tmp_kernel_op_139)*0.074999999999999983;
             const real_t elMatDiag_0 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_kernel_op_92 + jac_blending_inv_1_0_q_3*tmp_kernel_op_93 + jac_blending_inv_2_0_q_3*tmp_kernel_op_94) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_kernel_op_92 + jac_blending_inv_1_1_q_3*tmp_kernel_op_93 + jac_blending_inv_2_1_q_3*tmp_kernel_op_94) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_kernel_op_92 + jac_blending_inv_1_2_q_3*tmp_kernel_op_93 + jac_blending_inv_2_2_q_3*tmp_kernel_op_94))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_kernel_op_92 + jac_blending_inv_1_0_q_3*tmp_kernel_op_93 + jac_blending_inv_2_0_q_3*tmp_kernel_op_94) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_kernel_op_92 + jac_blending_inv_1_1_q_3*tmp_kernel_op_93 + jac_blending_inv_2_1_q_3*tmp_kernel_op_94) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_kernel_op_92 + jac_blending_inv_1_2_q_3*tmp_kernel_op_93 + jac_blending_inv_2_2_q_3*tmp_kernel_op_94))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_kernel_op_121 + jac_blending_inv_1_0_q_4*tmp_kernel_op_122 + jac_blending_inv_2_0_q_4*tmp_kernel_op_123) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_kernel_op_121 + jac_blending_inv_1_1_q_4*tmp_kernel_op_122 + jac_blending_inv_2_1_q_4*tmp_kernel_op_123) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_kernel_op_121 + jac_blending_inv_1_2_q_4*tmp_kernel_op_122 + jac_blending_inv_2_2_q_4*tmp_kernel_op_123))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_kernel_op_121 + jac_blending_inv_1_0_q_4*tmp_kernel_op_122 + jac_blending_inv_2_0_q_4*tmp_kernel_op_123) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_kernel_op_121 + jac_blending_inv_1_1_q_4*tmp_kernel_op_122 + jac_blending_inv_2_1_q_4*tmp_kernel_op_123) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_kernel_op_121 + jac_blending_inv_1_2_q_4*tmp_kernel_op_122 + jac_blending_inv_2_2_q_4*tmp_kernel_op_123))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_kernel_op_5 + jac_blending_inv_1_0_q_0*tmp_kernel_op_6 + jac_blending_inv_2_0_q_0*tmp_kernel_op_7) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_kernel_op_5 + jac_blending_inv_1_1_q_0*tmp_kernel_op_6 + jac_blending_inv_2_1_q_0*tmp_kernel_op_7) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_kernel_op_5 + jac_blending_inv_1_2_q_0*tmp_kernel_op_6 + jac_blending_inv_2_2_q_0*tmp_kernel_op_7))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_kernel_op_5 + jac_blending_inv_1_0_q_0*tmp_kernel_op_6 + jac_blending_inv_2_0_q_0*tmp_kernel_op_7) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_kernel_op_5 + jac_blending_inv_1_1_q_0*tmp_kernel_op_6 + jac_blending_inv_2_1_q_0*tmp_kernel_op_7) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_kernel_op_5 + jac_blending_inv_1_2_q_0*tmp_kernel_op_6 + jac_blending_inv_2_2_q_0*tmp_kernel_op_7))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_kernel_op_34 + jac_blending_inv_1_0_q_1*tmp_kernel_op_35 + jac_blending_inv_2_0_q_1*tmp_kernel_op_36) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_kernel_op_34 + jac_blending_inv_1_1_q_1*tmp_kernel_op_35 + jac_blending_inv_2_1_q_1*tmp_kernel_op_36) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_kernel_op_34 + jac_blending_inv_1_2_q_1*tmp_kernel_op_35 + jac_blending_inv_2_2_q_1*tmp_kernel_op_36))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_kernel_op_34 + jac_blending_inv_1_0_q_1*tmp_kernel_op_35 + jac_blending_inv_2_0_q_1*tmp_kernel_op_36) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_kernel_op_34 + jac_blending_inv_1_1_q_1*tmp_kernel_op_35 + jac_blending_inv_2_1_q_1*tmp_kernel_op_36) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_kernel_op_34 + jac_blending_inv_1_2_q_1*tmp_kernel_op_35 + jac_blending_inv_2_2_q_1*tmp_kernel_op_36))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_kernel_op_63 + jac_blending_inv_1_0_q_2*tmp_kernel_op_64 + jac_blending_inv_2_0_q_2*tmp_kernel_op_65) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_kernel_op_63 + jac_blending_inv_1_1_q_2*tmp_kernel_op_64 + jac_blending_inv_2_1_q_2*tmp_kernel_op_65) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_kernel_op_63 + jac_blending_inv_1_2_q_2*tmp_kernel_op_64 + jac_blending_inv_2_2_q_2*tmp_kernel_op_65))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_kernel_op_63 + jac_blending_inv_1_0_q_2*tmp_kernel_op_64 + jac_blending_inv_2_0_q_2*tmp_kernel_op_65) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_kernel_op_63 + jac_blending_inv_1_1_q_2*tmp_kernel_op_64 + jac_blending_inv_2_1_q_2*tmp_kernel_op_65) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_kernel_op_63 + jac_blending_inv_1_2_q_2*tmp_kernel_op_64 + jac_blending_inv_2_2_q_2*tmp_kernel_op_65)));
             const real_t elMatDiag_1 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_kernel_op_158 + jac_blending_inv_1_0_q_3*tmp_kernel_op_159 + jac_blending_inv_2_0_q_3*tmp_kernel_op_160) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_kernel_op_158 + jac_blending_inv_1_1_q_3*tmp_kernel_op_159 + jac_blending_inv_2_1_q_3*tmp_kernel_op_160) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_kernel_op_158 + jac_blending_inv_1_2_q_3*tmp_kernel_op_159 + jac_blending_inv_2_2_q_3*tmp_kernel_op_160))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_kernel_op_158 + jac_blending_inv_1_0_q_3*tmp_kernel_op_159 + jac_blending_inv_2_0_q_3*tmp_kernel_op_160) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_kernel_op_158 + jac_blending_inv_1_1_q_3*tmp_kernel_op_159 + jac_blending_inv_2_1_q_3*tmp_kernel_op_160) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_kernel_op_158 + jac_blending_inv_1_2_q_3*tmp_kernel_op_159 + jac_blending_inv_2_2_q_3*tmp_kernel_op_160))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_kernel_op_162 + jac_blending_inv_1_0_q_4*tmp_kernel_op_163 + jac_blending_inv_2_0_q_4*tmp_kernel_op_164) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_kernel_op_162 + jac_blending_inv_1_1_q_4*tmp_kernel_op_163 + jac_blending_inv_2_1_q_4*tmp_kernel_op_164) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_kernel_op_162 + jac_blending_inv_1_2_q_4*tmp_kernel_op_163 + jac_blending_inv_2_2_q_4*tmp_kernel_op_164))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_kernel_op_162 + jac_blending_inv_1_0_q_4*tmp_kernel_op_163 + jac_blending_inv_2_0_q_4*tmp_kernel_op_164) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_kernel_op_162 + jac_blending_inv_1_1_q_4*tmp_kernel_op_163 + jac_blending_inv_2_1_q_4*tmp_kernel_op_164) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_kernel_op_162 + jac_blending_inv_1_2_q_4*tmp_kernel_op_163 + jac_blending_inv_2_2_q_4*tmp_kernel_op_164))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_kernel_op_146 + jac_blending_inv_1_0_q_0*tmp_kernel_op_147 + jac_blending_inv_2_0_q_0*tmp_kernel_op_148) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_kernel_op_146 + jac_blending_inv_1_1_q_0*tmp_kernel_op_147 + jac_blending_inv_2_1_q_0*tmp_kernel_op_148) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_kernel_op_146 + jac_blending_inv_1_2_q_0*tmp_kernel_op_147 + jac_blending_inv_2_2_q_0*tmp_kernel_op_148))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_kernel_op_146 + jac_blending_inv_1_0_q_0*tmp_kernel_op_147 + jac_blending_inv_2_0_q_0*tmp_kernel_op_148) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_kernel_op_146 + jac_blending_inv_1_1_q_0*tmp_kernel_op_147 + jac_blending_inv_2_1_q_0*tmp_kernel_op_148) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_kernel_op_146 + jac_blending_inv_1_2_q_0*tmp_kernel_op_147 + jac_blending_inv_2_2_q_0*tmp_kernel_op_148))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_kernel_op_150 + jac_blending_inv_1_0_q_1*tmp_kernel_op_151 + jac_blending_inv_2_0_q_1*tmp_kernel_op_152) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_kernel_op_150 + jac_blending_inv_1_1_q_1*tmp_kernel_op_151 + jac_blending_inv_2_1_q_1*tmp_kernel_op_152) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_kernel_op_150 + jac_blending_inv_1_2_q_1*tmp_kernel_op_151 + jac_blending_inv_2_2_q_1*tmp_kernel_op_152))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_kernel_op_150 + jac_blending_inv_1_0_q_1*tmp_kernel_op_151 + jac_blending_inv_2_0_q_1*tmp_kernel_op_152) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_kernel_op_150 + jac_blending_inv_1_1_q_1*tmp_kernel_op_151 + jac_blending_inv_2_1_q_1*tmp_kernel_op_152) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_kernel_op_150 + jac_blending_inv_1_2_q_1*tmp_kernel_op_151 + jac_blending_inv_2_2_q_1*tmp_kernel_op_152))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_kernel_op_154 + jac_blending_inv_1_0_q_2*tmp_kernel_op_155 + jac_blending_inv_2_0_q_2*tmp_kernel_op_156) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_kernel_op_154 + jac_blending_inv_1_1_q_2*tmp_kernel_op_155 + jac_blending_inv_2_1_q_2*tmp_kernel_op_156) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_kernel_op_154 + jac_blending_inv_1_2_q_2*tmp_kernel_op_155 + jac_blending_inv_2_2_q_2*tmp_kernel_op_156))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_kernel_op_154 + jac_blending_inv_1_0_q_2*tmp_kernel_op_155 + jac_blending_inv_2_0_q_2*tmp_kernel_op_156) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_kernel_op_154 + jac_blending_inv_1_1_q_2*tmp_kernel_op_155 + jac_blending_inv_2_1_q_2*tmp_kernel_op_156) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_kernel_op_154 + jac_blending_inv_1_2_q_2*tmp_kernel_op_155 + jac_blending_inv_2_2_q_2*tmp_kernel_op_156)));
             const real_t elMatDiag_2 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_kernel_op_178 + jac_blending_inv_1_0_q_3*tmp_kernel_op_179 + jac_blending_inv_2_0_q_3*tmp_kernel_op_180) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_kernel_op_178 + jac_blending_inv_1_1_q_3*tmp_kernel_op_179 + jac_blending_inv_2_1_q_3*tmp_kernel_op_180) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_kernel_op_178 + jac_blending_inv_1_2_q_3*tmp_kernel_op_179 + jac_blending_inv_2_2_q_3*tmp_kernel_op_180))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_kernel_op_178 + jac_blending_inv_1_0_q_3*tmp_kernel_op_179 + jac_blending_inv_2_0_q_3*tmp_kernel_op_180) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_kernel_op_178 + jac_blending_inv_1_1_q_3*tmp_kernel_op_179 + jac_blending_inv_2_1_q_3*tmp_kernel_op_180) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_kernel_op_178 + jac_blending_inv_1_2_q_3*tmp_kernel_op_179 + jac_blending_inv_2_2_q_3*tmp_kernel_op_180))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_kernel_op_182 + jac_blending_inv_1_0_q_4*tmp_kernel_op_183 + jac_blending_inv_2_0_q_4*tmp_kernel_op_184) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_kernel_op_182 + jac_blending_inv_1_1_q_4*tmp_kernel_op_183 + jac_blending_inv_2_1_q_4*tmp_kernel_op_184) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_kernel_op_182 + jac_blending_inv_1_2_q_4*tmp_kernel_op_183 + jac_blending_inv_2_2_q_4*tmp_kernel_op_184))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_kernel_op_182 + jac_blending_inv_1_0_q_4*tmp_kernel_op_183 + jac_blending_inv_2_0_q_4*tmp_kernel_op_184) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_kernel_op_182 + jac_blending_inv_1_1_q_4*tmp_kernel_op_183 + jac_blending_inv_2_1_q_4*tmp_kernel_op_184) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_kernel_op_182 + jac_blending_inv_1_2_q_4*tmp_kernel_op_183 + jac_blending_inv_2_2_q_4*tmp_kernel_op_184))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_kernel_op_166 + jac_blending_inv_1_0_q_0*tmp_kernel_op_167 + jac_blending_inv_2_0_q_0*tmp_kernel_op_168) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_kernel_op_166 + jac_blending_inv_1_1_q_0*tmp_kernel_op_167 + jac_blending_inv_2_1_q_0*tmp_kernel_op_168) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_kernel_op_166 + jac_blending_inv_1_2_q_0*tmp_kernel_op_167 + jac_blending_inv_2_2_q_0*tmp_kernel_op_168))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_kernel_op_166 + jac_blending_inv_1_0_q_0*tmp_kernel_op_167 + jac_blending_inv_2_0_q_0*tmp_kernel_op_168) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_kernel_op_166 + jac_blending_inv_1_1_q_0*tmp_kernel_op_167 + jac_blending_inv_2_1_q_0*tmp_kernel_op_168) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_kernel_op_166 + jac_blending_inv_1_2_q_0*tmp_kernel_op_167 + jac_blending_inv_2_2_q_0*tmp_kernel_op_168))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_kernel_op_170 + jac_blending_inv_1_0_q_1*tmp_kernel_op_171 + jac_blending_inv_2_0_q_1*tmp_kernel_op_172) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_kernel_op_170 + jac_blending_inv_1_1_q_1*tmp_kernel_op_171 + jac_blending_inv_2_1_q_1*tmp_kernel_op_172) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_kernel_op_170 + jac_blending_inv_1_2_q_1*tmp_kernel_op_171 + jac_blending_inv_2_2_q_1*tmp_kernel_op_172))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_kernel_op_170 + jac_blending_inv_1_0_q_1*tmp_kernel_op_171 + jac_blending_inv_2_0_q_1*tmp_kernel_op_172) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_kernel_op_170 + jac_blending_inv_1_1_q_1*tmp_kernel_op_171 + jac_blending_inv_2_1_q_1*tmp_kernel_op_172) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_kernel_op_170 + jac_blending_inv_1_2_q_1*tmp_kernel_op_171 + jac_blending_inv_2_2_q_1*tmp_kernel_op_172))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_kernel_op_174 + jac_blending_inv_1_0_q_2*tmp_kernel_op_175 + jac_blending_inv_2_0_q_2*tmp_kernel_op_176) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_kernel_op_174 + jac_blending_inv_1_1_q_2*tmp_kernel_op_175 + jac_blending_inv_2_1_q_2*tmp_kernel_op_176) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_kernel_op_174 + jac_blending_inv_1_2_q_2*tmp_kernel_op_175 + jac_blending_inv_2_2_q_2*tmp_kernel_op_176))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_kernel_op_174 + jac_blending_inv_1_0_q_2*tmp_kernel_op_175 + jac_blending_inv_2_0_q_2*tmp_kernel_op_176) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_kernel_op_174 + jac_blending_inv_1_1_q_2*tmp_kernel_op_175 + jac_blending_inv_2_1_q_2*tmp_kernel_op_176) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_kernel_op_174 + jac_blending_inv_1_2_q_2*tmp_kernel_op_175 + jac_blending_inv_2_2_q_2*tmp_kernel_op_176)));
             const real_t elMatDiag_3 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_kernel_op_198 + jac_blending_inv_1_0_q_3*tmp_kernel_op_199 + jac_blending_inv_2_0_q_3*tmp_kernel_op_200) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_kernel_op_198 + jac_blending_inv_1_1_q_3*tmp_kernel_op_199 + jac_blending_inv_2_1_q_3*tmp_kernel_op_200) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_kernel_op_198 + jac_blending_inv_1_2_q_3*tmp_kernel_op_199 + jac_blending_inv_2_2_q_3*tmp_kernel_op_200))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_kernel_op_198 + jac_blending_inv_1_0_q_3*tmp_kernel_op_199 + jac_blending_inv_2_0_q_3*tmp_kernel_op_200) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_kernel_op_198 + jac_blending_inv_1_1_q_3*tmp_kernel_op_199 + jac_blending_inv_2_1_q_3*tmp_kernel_op_200) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_kernel_op_198 + jac_blending_inv_1_2_q_3*tmp_kernel_op_199 + jac_blending_inv_2_2_q_3*tmp_kernel_op_200))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_kernel_op_202 + jac_blending_inv_1_0_q_4*tmp_kernel_op_203 + jac_blending_inv_2_0_q_4*tmp_kernel_op_204) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_kernel_op_202 + jac_blending_inv_1_1_q_4*tmp_kernel_op_203 + jac_blending_inv_2_1_q_4*tmp_kernel_op_204) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_kernel_op_202 + jac_blending_inv_1_2_q_4*tmp_kernel_op_203 + jac_blending_inv_2_2_q_4*tmp_kernel_op_204))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_kernel_op_202 + jac_blending_inv_1_0_q_4*tmp_kernel_op_203 + jac_blending_inv_2_0_q_4*tmp_kernel_op_204) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_kernel_op_202 + jac_blending_inv_1_1_q_4*tmp_kernel_op_203 + jac_blending_inv_2_1_q_4*tmp_kernel_op_204) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_kernel_op_202 + jac_blending_inv_1_2_q_4*tmp_kernel_op_203 + jac_blending_inv_2_2_q_4*tmp_kernel_op_204))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_kernel_op_186 + jac_blending_inv_1_0_q_0*tmp_kernel_op_187 + jac_blending_inv_2_0_q_0*tmp_kernel_op_188) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_kernel_op_186 + jac_blending_inv_1_1_q_0*tmp_kernel_op_187 + jac_blending_inv_2_1_q_0*tmp_kernel_op_188) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_kernel_op_186 + jac_blending_inv_1_2_q_0*tmp_kernel_op_187 + jac_blending_inv_2_2_q_0*tmp_kernel_op_188))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_kernel_op_186 + jac_blending_inv_1_0_q_0*tmp_kernel_op_187 + jac_blending_inv_2_0_q_0*tmp_kernel_op_188) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_kernel_op_186 + jac_blending_inv_1_1_q_0*tmp_kernel_op_187 + jac_blending_inv_2_1_q_0*tmp_kernel_op_188) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_kernel_op_186 + jac_blending_inv_1_2_q_0*tmp_kernel_op_187 + jac_blending_inv_2_2_q_0*tmp_kernel_op_188))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_kernel_op_190 + jac_blending_inv_1_0_q_1*tmp_kernel_op_191 + jac_blending_inv_2_0_q_1*tmp_kernel_op_192) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_kernel_op_190 + jac_blending_inv_1_1_q_1*tmp_kernel_op_191 + jac_blending_inv_2_1_q_1*tmp_kernel_op_192) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_kernel_op_190 + jac_blending_inv_1_2_q_1*tmp_kernel_op_191 + jac_blending_inv_2_2_q_1*tmp_kernel_op_192))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_kernel_op_190 + jac_blending_inv_1_0_q_1*tmp_kernel_op_191 + jac_blending_inv_2_0_q_1*tmp_kernel_op_192) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_kernel_op_190 + jac_blending_inv_1_1_q_1*tmp_kernel_op_191 + jac_blending_inv_2_1_q_1*tmp_kernel_op_192) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_kernel_op_190 + jac_blending_inv_1_2_q_1*tmp_kernel_op_191 + jac_blending_inv_2_2_q_1*tmp_kernel_op_192))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_kernel_op_194 + jac_blending_inv_1_0_q_2*tmp_kernel_op_195 + jac_blending_inv_2_0_q_2*tmp_kernel_op_196) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_kernel_op_194 + jac_blending_inv_1_1_q_2*tmp_kernel_op_195 + jac_blending_inv_2_1_q_2*tmp_kernel_op_196) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_kernel_op_194 + jac_blending_inv_1_2_q_2*tmp_kernel_op_195 + jac_blending_inv_2_2_q_2*tmp_kernel_op_196))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_kernel_op_194 + jac_blending_inv_1_0_q_2*tmp_kernel_op_195 + jac_blending_inv_2_0_q_2*tmp_kernel_op_196) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_kernel_op_194 + jac_blending_inv_1_1_q_2*tmp_kernel_op_195 + jac_blending_inv_2_1_q_2*tmp_kernel_op_196) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_kernel_op_194 + jac_blending_inv_1_2_q_2*tmp_kernel_op_195 + jac_blending_inv_2_2_q_2*tmp_kernel_op_196)));
             const real_t elMatDiag_4 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_kernel_op_234 + jac_blending_inv_1_0_q_3*tmp_kernel_op_237 + jac_blending_inv_2_0_q_3*tmp_kernel_op_240) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_kernel_op_234 + jac_blending_inv_1_1_q_3*tmp_kernel_op_237 + jac_blending_inv_2_1_q_3*tmp_kernel_op_240) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_kernel_op_234 + jac_blending_inv_1_2_q_3*tmp_kernel_op_237 + jac_blending_inv_2_2_q_3*tmp_kernel_op_240))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_kernel_op_234 + jac_blending_inv_1_0_q_3*tmp_kernel_op_237 + jac_blending_inv_2_0_q_3*tmp_kernel_op_240) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_kernel_op_234 + jac_blending_inv_1_1_q_3*tmp_kernel_op_237 + jac_blending_inv_2_1_q_3*tmp_kernel_op_240) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_kernel_op_234 + jac_blending_inv_1_2_q_3*tmp_kernel_op_237 + jac_blending_inv_2_2_q_3*tmp_kernel_op_240))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_kernel_op_243 + jac_blending_inv_1_0_q_4*tmp_kernel_op_246 + jac_blending_inv_2_0_q_4*tmp_kernel_op_249) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_kernel_op_243 + jac_blending_inv_1_1_q_4*tmp_kernel_op_246 + jac_blending_inv_2_1_q_4*tmp_kernel_op_249) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_kernel_op_243 + jac_blending_inv_1_2_q_4*tmp_kernel_op_246 + jac_blending_inv_2_2_q_4*tmp_kernel_op_249))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_kernel_op_243 + jac_blending_inv_1_0_q_4*tmp_kernel_op_246 + jac_blending_inv_2_0_q_4*tmp_kernel_op_249) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_kernel_op_243 + jac_blending_inv_1_1_q_4*tmp_kernel_op_246 + jac_blending_inv_2_1_q_4*tmp_kernel_op_249) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_kernel_op_243 + jac_blending_inv_1_2_q_4*tmp_kernel_op_246 + jac_blending_inv_2_2_q_4*tmp_kernel_op_249))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_kernel_op_207 + jac_blending_inv_1_0_q_0*tmp_kernel_op_210 + jac_blending_inv_2_0_q_0*tmp_kernel_op_213) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_kernel_op_207 + jac_blending_inv_1_1_q_0*tmp_kernel_op_210 + jac_blending_inv_2_1_q_0*tmp_kernel_op_213) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_kernel_op_207 + jac_blending_inv_1_2_q_0*tmp_kernel_op_210 + jac_blending_inv_2_2_q_0*tmp_kernel_op_213))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_kernel_op_207 + jac_blending_inv_1_0_q_0*tmp_kernel_op_210 + jac_blending_inv_2_0_q_0*tmp_kernel_op_213) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_kernel_op_207 + jac_blending_inv_1_1_q_0*tmp_kernel_op_210 + jac_blending_inv_2_1_q_0*tmp_kernel_op_213) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_kernel_op_207 + jac_blending_inv_1_2_q_0*tmp_kernel_op_210 + jac_blending_inv_2_2_q_0*tmp_kernel_op_213))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_kernel_op_216 + jac_blending_inv_1_0_q_1*tmp_kernel_op_219 + jac_blending_inv_2_0_q_1*tmp_kernel_op_222) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_kernel_op_216 + jac_blending_inv_1_1_q_1*tmp_kernel_op_219 + jac_blending_inv_2_1_q_1*tmp_kernel_op_222) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_kernel_op_216 + jac_blending_inv_1_2_q_1*tmp_kernel_op_219 + jac_blending_inv_2_2_q_1*tmp_kernel_op_222))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_kernel_op_216 + jac_blending_inv_1_0_q_1*tmp_kernel_op_219 + jac_blending_inv_2_0_q_1*tmp_kernel_op_222) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_kernel_op_216 + jac_blending_inv_1_1_q_1*tmp_kernel_op_219 + jac_blending_inv_2_1_q_1*tmp_kernel_op_222) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_kernel_op_216 + jac_blending_inv_1_2_q_1*tmp_kernel_op_219 + jac_blending_inv_2_2_q_1*tmp_kernel_op_222))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_kernel_op_225 + jac_blending_inv_1_0_q_2*tmp_kernel_op_228 + jac_blending_inv_2_0_q_2*tmp_kernel_op_231) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_kernel_op_225 + jac_blending_inv_1_1_q_2*tmp_kernel_op_228 + jac_blending_inv_2_1_q_2*tmp_kernel_op_231) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_kernel_op_225 + jac_blending_inv_1_2_q_2*tmp_kernel_op_228 + jac_blending_inv_2_2_q_2*tmp_kernel_op_231))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_kernel_op_225 + jac_blending_inv_1_0_q_2*tmp_kernel_op_228 + jac_blending_inv_2_0_q_2*tmp_kernel_op_231) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_kernel_op_225 + jac_blending_inv_1_1_q_2*tmp_kernel_op_228 + jac_blending_inv_2_1_q_2*tmp_kernel_op_231) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_kernel_op_225 + jac_blending_inv_1_2_q_2*tmp_kernel_op_228 + jac_blending_inv_2_2_q_2*tmp_kernel_op_231)));
             const real_t elMatDiag_5 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_kernel_op_279 + jac_blending_inv_1_0_q_3*tmp_kernel_op_282 + jac_blending_inv_2_0_q_3*tmp_kernel_op_285) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_kernel_op_279 + jac_blending_inv_1_1_q_3*tmp_kernel_op_282 + jac_blending_inv_2_1_q_3*tmp_kernel_op_285) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_kernel_op_279 + jac_blending_inv_1_2_q_3*tmp_kernel_op_282 + jac_blending_inv_2_2_q_3*tmp_kernel_op_285))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_kernel_op_279 + jac_blending_inv_1_0_q_3*tmp_kernel_op_282 + jac_blending_inv_2_0_q_3*tmp_kernel_op_285) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_kernel_op_279 + jac_blending_inv_1_1_q_3*tmp_kernel_op_282 + jac_blending_inv_2_1_q_3*tmp_kernel_op_285) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_kernel_op_279 + jac_blending_inv_1_2_q_3*tmp_kernel_op_282 + jac_blending_inv_2_2_q_3*tmp_kernel_op_285))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_kernel_op_288 + jac_blending_inv_1_0_q_4*tmp_kernel_op_291 + jac_blending_inv_2_0_q_4*tmp_kernel_op_294) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_kernel_op_288 + jac_blending_inv_1_1_q_4*tmp_kernel_op_291 + jac_blending_inv_2_1_q_4*tmp_kernel_op_294) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_kernel_op_288 + jac_blending_inv_1_2_q_4*tmp_kernel_op_291 + jac_blending_inv_2_2_q_4*tmp_kernel_op_294))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_kernel_op_288 + jac_blending_inv_1_0_q_4*tmp_kernel_op_291 + jac_blending_inv_2_0_q_4*tmp_kernel_op_294) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_kernel_op_288 + jac_blending_inv_1_1_q_4*tmp_kernel_op_291 + jac_blending_inv_2_1_q_4*tmp_kernel_op_294) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_kernel_op_288 + jac_blending_inv_1_2_q_4*tmp_kernel_op_291 + jac_blending_inv_2_2_q_4*tmp_kernel_op_294))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_kernel_op_252 + jac_blending_inv_1_0_q_0*tmp_kernel_op_255 + jac_blending_inv_2_0_q_0*tmp_kernel_op_258) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_kernel_op_252 + jac_blending_inv_1_1_q_0*tmp_kernel_op_255 + jac_blending_inv_2_1_q_0*tmp_kernel_op_258) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_kernel_op_252 + jac_blending_inv_1_2_q_0*tmp_kernel_op_255 + jac_blending_inv_2_2_q_0*tmp_kernel_op_258))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_kernel_op_252 + jac_blending_inv_1_0_q_0*tmp_kernel_op_255 + jac_blending_inv_2_0_q_0*tmp_kernel_op_258) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_kernel_op_252 + jac_blending_inv_1_1_q_0*tmp_kernel_op_255 + jac_blending_inv_2_1_q_0*tmp_kernel_op_258) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_kernel_op_252 + jac_blending_inv_1_2_q_0*tmp_kernel_op_255 + jac_blending_inv_2_2_q_0*tmp_kernel_op_258))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_kernel_op_261 + jac_blending_inv_1_0_q_1*tmp_kernel_op_264 + jac_blending_inv_2_0_q_1*tmp_kernel_op_267) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_kernel_op_261 + jac_blending_inv_1_1_q_1*tmp_kernel_op_264 + jac_blending_inv_2_1_q_1*tmp_kernel_op_267) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_kernel_op_261 + jac_blending_inv_1_2_q_1*tmp_kernel_op_264 + jac_blending_inv_2_2_q_1*tmp_kernel_op_267))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_kernel_op_261 + jac_blending_inv_1_0_q_1*tmp_kernel_op_264 + jac_blending_inv_2_0_q_1*tmp_kernel_op_267) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_kernel_op_261 + jac_blending_inv_1_1_q_1*tmp_kernel_op_264 + jac_blending_inv_2_1_q_1*tmp_kernel_op_267) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_kernel_op_261 + jac_blending_inv_1_2_q_1*tmp_kernel_op_264 + jac_blending_inv_2_2_q_1*tmp_kernel_op_267))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_kernel_op_270 + jac_blending_inv_1_0_q_2*tmp_kernel_op_273 + jac_blending_inv_2_0_q_2*tmp_kernel_op_276) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_kernel_op_270 + jac_blending_inv_1_1_q_2*tmp_kernel_op_273 + jac_blending_inv_2_1_q_2*tmp_kernel_op_276) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_kernel_op_270 + jac_blending_inv_1_2_q_2*tmp_kernel_op_273 + jac_blending_inv_2_2_q_2*tmp_kernel_op_276))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_kernel_op_270 + jac_blending_inv_1_0_q_2*tmp_kernel_op_273 + jac_blending_inv_2_0_q_2*tmp_kernel_op_276) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_kernel_op_270 + jac_blending_inv_1_1_q_2*tmp_kernel_op_273 + jac_blending_inv_2_1_q_2*tmp_kernel_op_276) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_kernel_op_270 + jac_blending_inv_1_2_q_2*tmp_kernel_op_273 + jac_blending_inv_2_2_q_2*tmp_kernel_op_276)));
             const real_t elMatDiag_6 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_kernel_op_324 + jac_blending_inv_1_0_q_3*tmp_kernel_op_327 + jac_blending_inv_2_0_q_3*tmp_kernel_op_330) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_kernel_op_324 + jac_blending_inv_1_1_q_3*tmp_kernel_op_327 + jac_blending_inv_2_1_q_3*tmp_kernel_op_330) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_kernel_op_324 + jac_blending_inv_1_2_q_3*tmp_kernel_op_327 + jac_blending_inv_2_2_q_3*tmp_kernel_op_330))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_kernel_op_324 + jac_blending_inv_1_0_q_3*tmp_kernel_op_327 + jac_blending_inv_2_0_q_3*tmp_kernel_op_330) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_kernel_op_324 + jac_blending_inv_1_1_q_3*tmp_kernel_op_327 + jac_blending_inv_2_1_q_3*tmp_kernel_op_330) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_kernel_op_324 + jac_blending_inv_1_2_q_3*tmp_kernel_op_327 + jac_blending_inv_2_2_q_3*tmp_kernel_op_330))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_kernel_op_333 + jac_blending_inv_1_0_q_4*tmp_kernel_op_336 + jac_blending_inv_2_0_q_4*tmp_kernel_op_339) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_kernel_op_333 + jac_blending_inv_1_1_q_4*tmp_kernel_op_336 + jac_blending_inv_2_1_q_4*tmp_kernel_op_339) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_kernel_op_333 + jac_blending_inv_1_2_q_4*tmp_kernel_op_336 + jac_blending_inv_2_2_q_4*tmp_kernel_op_339))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_kernel_op_333 + jac_blending_inv_1_0_q_4*tmp_kernel_op_336 + jac_blending_inv_2_0_q_4*tmp_kernel_op_339) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_kernel_op_333 + jac_blending_inv_1_1_q_4*tmp_kernel_op_336 + jac_blending_inv_2_1_q_4*tmp_kernel_op_339) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_kernel_op_333 + jac_blending_inv_1_2_q_4*tmp_kernel_op_336 + jac_blending_inv_2_2_q_4*tmp_kernel_op_339))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_kernel_op_297 + jac_blending_inv_1_0_q_0*tmp_kernel_op_300 + jac_blending_inv_2_0_q_0*tmp_kernel_op_303) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_kernel_op_297 + jac_blending_inv_1_1_q_0*tmp_kernel_op_300 + jac_blending_inv_2_1_q_0*tmp_kernel_op_303) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_kernel_op_297 + jac_blending_inv_1_2_q_0*tmp_kernel_op_300 + jac_blending_inv_2_2_q_0*tmp_kernel_op_303))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_kernel_op_297 + jac_blending_inv_1_0_q_0*tmp_kernel_op_300 + jac_blending_inv_2_0_q_0*tmp_kernel_op_303) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_kernel_op_297 + jac_blending_inv_1_1_q_0*tmp_kernel_op_300 + jac_blending_inv_2_1_q_0*tmp_kernel_op_303) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_kernel_op_297 + jac_blending_inv_1_2_q_0*tmp_kernel_op_300 + jac_blending_inv_2_2_q_0*tmp_kernel_op_303))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_kernel_op_306 + jac_blending_inv_1_0_q_1*tmp_kernel_op_309 + jac_blending_inv_2_0_q_1*tmp_kernel_op_312) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_kernel_op_306 + jac_blending_inv_1_1_q_1*tmp_kernel_op_309 + jac_blending_inv_2_1_q_1*tmp_kernel_op_312) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_kernel_op_306 + jac_blending_inv_1_2_q_1*tmp_kernel_op_309 + jac_blending_inv_2_2_q_1*tmp_kernel_op_312))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_kernel_op_306 + jac_blending_inv_1_0_q_1*tmp_kernel_op_309 + jac_blending_inv_2_0_q_1*tmp_kernel_op_312) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_kernel_op_306 + jac_blending_inv_1_1_q_1*tmp_kernel_op_309 + jac_blending_inv_2_1_q_1*tmp_kernel_op_312) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_kernel_op_306 + jac_blending_inv_1_2_q_1*tmp_kernel_op_309 + jac_blending_inv_2_2_q_1*tmp_kernel_op_312))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_kernel_op_315 + jac_blending_inv_1_0_q_2*tmp_kernel_op_318 + jac_blending_inv_2_0_q_2*tmp_kernel_op_321) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_kernel_op_315 + jac_blending_inv_1_1_q_2*tmp_kernel_op_318 + jac_blending_inv_2_1_q_2*tmp_kernel_op_321) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_kernel_op_315 + jac_blending_inv_1_2_q_2*tmp_kernel_op_318 + jac_blending_inv_2_2_q_2*tmp_kernel_op_321))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_kernel_op_315 + jac_blending_inv_1_0_q_2*tmp_kernel_op_318 + jac_blending_inv_2_0_q_2*tmp_kernel_op_321) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_kernel_op_315 + jac_blending_inv_1_1_q_2*tmp_kernel_op_318 + jac_blending_inv_2_1_q_2*tmp_kernel_op_321) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_kernel_op_315 + jac_blending_inv_1_2_q_2*tmp_kernel_op_318 + jac_blending_inv_2_2_q_2*tmp_kernel_op_321)));
             const real_t elMatDiag_7 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_kernel_op_353 + jac_blending_inv_1_0_q_3*tmp_kernel_op_354 + jac_blending_inv_2_0_q_3*tmp_kernel_op_355) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_kernel_op_353 + jac_blending_inv_1_1_q_3*tmp_kernel_op_354 + jac_blending_inv_2_1_q_3*tmp_kernel_op_355) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_kernel_op_353 + jac_blending_inv_1_2_q_3*tmp_kernel_op_354 + jac_blending_inv_2_2_q_3*tmp_kernel_op_355))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_kernel_op_353 + jac_blending_inv_1_0_q_3*tmp_kernel_op_354 + jac_blending_inv_2_0_q_3*tmp_kernel_op_355) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_kernel_op_353 + jac_blending_inv_1_1_q_3*tmp_kernel_op_354 + jac_blending_inv_2_1_q_3*tmp_kernel_op_355) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_kernel_op_353 + jac_blending_inv_1_2_q_3*tmp_kernel_op_354 + jac_blending_inv_2_2_q_3*tmp_kernel_op_355))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_kernel_op_357 + jac_blending_inv_1_0_q_4*tmp_kernel_op_358 + jac_blending_inv_2_0_q_4*tmp_kernel_op_359) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_kernel_op_357 + jac_blending_inv_1_1_q_4*tmp_kernel_op_358 + jac_blending_inv_2_1_q_4*tmp_kernel_op_359) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_kernel_op_357 + jac_blending_inv_1_2_q_4*tmp_kernel_op_358 + jac_blending_inv_2_2_q_4*tmp_kernel_op_359))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_kernel_op_357 + jac_blending_inv_1_0_q_4*tmp_kernel_op_358 + jac_blending_inv_2_0_q_4*tmp_kernel_op_359) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_kernel_op_357 + jac_blending_inv_1_1_q_4*tmp_kernel_op_358 + jac_blending_inv_2_1_q_4*tmp_kernel_op_359) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_kernel_op_357 + jac_blending_inv_1_2_q_4*tmp_kernel_op_358 + jac_blending_inv_2_2_q_4*tmp_kernel_op_359))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_kernel_op_341 + jac_blending_inv_1_0_q_0*tmp_kernel_op_342 + jac_blending_inv_2_0_q_0*tmp_kernel_op_343) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_kernel_op_341 + jac_blending_inv_1_1_q_0*tmp_kernel_op_342 + jac_blending_inv_2_1_q_0*tmp_kernel_op_343) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_kernel_op_341 + jac_blending_inv_1_2_q_0*tmp_kernel_op_342 + jac_blending_inv_2_2_q_0*tmp_kernel_op_343))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_kernel_op_341 + jac_blending_inv_1_0_q_0*tmp_kernel_op_342 + jac_blending_inv_2_0_q_0*tmp_kernel_op_343) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_kernel_op_341 + jac_blending_inv_1_1_q_0*tmp_kernel_op_342 + jac_blending_inv_2_1_q_0*tmp_kernel_op_343) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_kernel_op_341 + jac_blending_inv_1_2_q_0*tmp_kernel_op_342 + jac_blending_inv_2_2_q_0*tmp_kernel_op_343))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_kernel_op_345 + jac_blending_inv_1_0_q_1*tmp_kernel_op_346 + jac_blending_inv_2_0_q_1*tmp_kernel_op_347) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_kernel_op_345 + jac_blending_inv_1_1_q_1*tmp_kernel_op_346 + jac_blending_inv_2_1_q_1*tmp_kernel_op_347) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_kernel_op_345 + jac_blending_inv_1_2_q_1*tmp_kernel_op_346 + jac_blending_inv_2_2_q_1*tmp_kernel_op_347))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_kernel_op_345 + jac_blending_inv_1_0_q_1*tmp_kernel_op_346 + jac_blending_inv_2_0_q_1*tmp_kernel_op_347) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_kernel_op_345 + jac_blending_inv_1_1_q_1*tmp_kernel_op_346 + jac_blending_inv_2_1_q_1*tmp_kernel_op_347) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_kernel_op_345 + jac_blending_inv_1_2_q_1*tmp_kernel_op_346 + jac_blending_inv_2_2_q_1*tmp_kernel_op_347))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_kernel_op_349 + jac_blending_inv_1_0_q_2*tmp_kernel_op_350 + jac_blending_inv_2_0_q_2*tmp_kernel_op_351) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_kernel_op_349 + jac_blending_inv_1_1_q_2*tmp_kernel_op_350 + jac_blending_inv_2_1_q_2*tmp_kernel_op_351) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_kernel_op_349 + jac_blending_inv_1_2_q_2*tmp_kernel_op_350 + jac_blending_inv_2_2_q_2*tmp_kernel_op_351))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_kernel_op_349 + jac_blending_inv_1_0_q_2*tmp_kernel_op_350 + jac_blending_inv_2_0_q_2*tmp_kernel_op_351) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_kernel_op_349 + jac_blending_inv_1_1_q_2*tmp_kernel_op_350 + jac_blending_inv_2_1_q_2*tmp_kernel_op_351) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_kernel_op_349 + jac_blending_inv_1_2_q_2*tmp_kernel_op_350 + jac_blending_inv_2_2_q_2*tmp_kernel_op_351)));
             const real_t elMatDiag_8 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_kernel_op_377 + jac_blending_inv_1_0_q_3*tmp_kernel_op_378 + jac_blending_inv_2_0_q_3*tmp_kernel_op_379) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_kernel_op_377 + jac_blending_inv_1_1_q_3*tmp_kernel_op_378 + jac_blending_inv_2_1_q_3*tmp_kernel_op_379) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_kernel_op_377 + jac_blending_inv_1_2_q_3*tmp_kernel_op_378 + jac_blending_inv_2_2_q_3*tmp_kernel_op_379))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_kernel_op_377 + jac_blending_inv_1_0_q_3*tmp_kernel_op_378 + jac_blending_inv_2_0_q_3*tmp_kernel_op_379) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_kernel_op_377 + jac_blending_inv_1_1_q_3*tmp_kernel_op_378 + jac_blending_inv_2_1_q_3*tmp_kernel_op_379) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_kernel_op_377 + jac_blending_inv_1_2_q_3*tmp_kernel_op_378 + jac_blending_inv_2_2_q_3*tmp_kernel_op_379))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_kernel_op_382 + jac_blending_inv_1_0_q_4*tmp_kernel_op_383 + jac_blending_inv_2_0_q_4*tmp_kernel_op_384) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_kernel_op_382 + jac_blending_inv_1_1_q_4*tmp_kernel_op_383 + jac_blending_inv_2_1_q_4*tmp_kernel_op_384) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_kernel_op_382 + jac_blending_inv_1_2_q_4*tmp_kernel_op_383 + jac_blending_inv_2_2_q_4*tmp_kernel_op_384))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_kernel_op_382 + jac_blending_inv_1_0_q_4*tmp_kernel_op_383 + jac_blending_inv_2_0_q_4*tmp_kernel_op_384) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_kernel_op_382 + jac_blending_inv_1_1_q_4*tmp_kernel_op_383 + jac_blending_inv_2_1_q_4*tmp_kernel_op_384) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_kernel_op_382 + jac_blending_inv_1_2_q_4*tmp_kernel_op_383 + jac_blending_inv_2_2_q_4*tmp_kernel_op_384))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_kernel_op_362 + jac_blending_inv_1_0_q_0*tmp_kernel_op_363 + jac_blending_inv_2_0_q_0*tmp_kernel_op_364) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_kernel_op_362 + jac_blending_inv_1_1_q_0*tmp_kernel_op_363 + jac_blending_inv_2_1_q_0*tmp_kernel_op_364) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_kernel_op_362 + jac_blending_inv_1_2_q_0*tmp_kernel_op_363 + jac_blending_inv_2_2_q_0*tmp_kernel_op_364))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_kernel_op_362 + jac_blending_inv_1_0_q_0*tmp_kernel_op_363 + jac_blending_inv_2_0_q_0*tmp_kernel_op_364) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_kernel_op_362 + jac_blending_inv_1_1_q_0*tmp_kernel_op_363 + jac_blending_inv_2_1_q_0*tmp_kernel_op_364) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_kernel_op_362 + jac_blending_inv_1_2_q_0*tmp_kernel_op_363 + jac_blending_inv_2_2_q_0*tmp_kernel_op_364))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_kernel_op_367 + jac_blending_inv_1_0_q_1*tmp_kernel_op_368 + jac_blending_inv_2_0_q_1*tmp_kernel_op_369) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_kernel_op_367 + jac_blending_inv_1_1_q_1*tmp_kernel_op_368 + jac_blending_inv_2_1_q_1*tmp_kernel_op_369) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_kernel_op_367 + jac_blending_inv_1_2_q_1*tmp_kernel_op_368 + jac_blending_inv_2_2_q_1*tmp_kernel_op_369))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_kernel_op_367 + jac_blending_inv_1_0_q_1*tmp_kernel_op_368 + jac_blending_inv_2_0_q_1*tmp_kernel_op_369) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_kernel_op_367 + jac_blending_inv_1_1_q_1*tmp_kernel_op_368 + jac_blending_inv_2_1_q_1*tmp_kernel_op_369) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_kernel_op_367 + jac_blending_inv_1_2_q_1*tmp_kernel_op_368 + jac_blending_inv_2_2_q_1*tmp_kernel_op_369))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_kernel_op_372 + jac_blending_inv_1_0_q_2*tmp_kernel_op_373 + jac_blending_inv_2_0_q_2*tmp_kernel_op_374) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_kernel_op_372 + jac_blending_inv_1_1_q_2*tmp_kernel_op_373 + jac_blending_inv_2_1_q_2*tmp_kernel_op_374) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_kernel_op_372 + jac_blending_inv_1_2_q_2*tmp_kernel_op_373 + jac_blending_inv_2_2_q_2*tmp_kernel_op_374))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_kernel_op_372 + jac_blending_inv_1_0_q_2*tmp_kernel_op_373 + jac_blending_inv_2_0_q_2*tmp_kernel_op_374) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_kernel_op_372 + jac_blending_inv_1_1_q_2*tmp_kernel_op_373 + jac_blending_inv_2_1_q_2*tmp_kernel_op_374) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_kernel_op_372 + jac_blending_inv_1_2_q_2*tmp_kernel_op_373 + jac_blending_inv_2_2_q_2*tmp_kernel_op_374)));
             const real_t elMatDiag_9 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_kernel_op_398 + jac_blending_inv_1_0_q_3*tmp_kernel_op_399 + jac_blending_inv_2_0_q_3*tmp_kernel_op_400) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_kernel_op_398 + jac_blending_inv_1_1_q_3*tmp_kernel_op_399 + jac_blending_inv_2_1_q_3*tmp_kernel_op_400) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_kernel_op_398 + jac_blending_inv_1_2_q_3*tmp_kernel_op_399 + jac_blending_inv_2_2_q_3*tmp_kernel_op_400))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_kernel_op_398 + jac_blending_inv_1_0_q_3*tmp_kernel_op_399 + jac_blending_inv_2_0_q_3*tmp_kernel_op_400) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_kernel_op_398 + jac_blending_inv_1_1_q_3*tmp_kernel_op_399 + jac_blending_inv_2_1_q_3*tmp_kernel_op_400) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_kernel_op_398 + jac_blending_inv_1_2_q_3*tmp_kernel_op_399 + jac_blending_inv_2_2_q_3*tmp_kernel_op_400))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_kernel_op_402 + jac_blending_inv_1_0_q_4*tmp_kernel_op_403 + jac_blending_inv_2_0_q_4*tmp_kernel_op_404) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_kernel_op_402 + jac_blending_inv_1_1_q_4*tmp_kernel_op_403 + jac_blending_inv_2_1_q_4*tmp_kernel_op_404) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_kernel_op_402 + jac_blending_inv_1_2_q_4*tmp_kernel_op_403 + jac_blending_inv_2_2_q_4*tmp_kernel_op_404))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_kernel_op_402 + jac_blending_inv_1_0_q_4*tmp_kernel_op_403 + jac_blending_inv_2_0_q_4*tmp_kernel_op_404) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_kernel_op_402 + jac_blending_inv_1_1_q_4*tmp_kernel_op_403 + jac_blending_inv_2_1_q_4*tmp_kernel_op_404) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_kernel_op_402 + jac_blending_inv_1_2_q_4*tmp_kernel_op_403 + jac_blending_inv_2_2_q_4*tmp_kernel_op_404))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_kernel_op_386 + jac_blending_inv_1_0_q_0*tmp_kernel_op_387 + jac_blending_inv_2_0_q_0*tmp_kernel_op_388) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_kernel_op_386 + jac_blending_inv_1_1_q_0*tmp_kernel_op_387 + jac_blending_inv_2_1_q_0*tmp_kernel_op_388) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_kernel_op_386 + jac_blending_inv_1_2_q_0*tmp_kernel_op_387 + jac_blending_inv_2_2_q_0*tmp_kernel_op_388))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_kernel_op_386 + jac_blending_inv_1_0_q_0*tmp_kernel_op_387 + jac_blending_inv_2_0_q_0*tmp_kernel_op_388) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_kernel_op_386 + jac_blending_inv_1_1_q_0*tmp_kernel_op_387 + jac_blending_inv_2_1_q_0*tmp_kernel_op_388) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_kernel_op_386 + jac_blending_inv_1_2_q_0*tmp_kernel_op_387 + jac_blending_inv_2_2_q_0*tmp_kernel_op_388))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_kernel_op_390 + jac_blending_inv_1_0_q_1*tmp_kernel_op_391 + jac_blending_inv_2_0_q_1*tmp_kernel_op_392) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_kernel_op_390 + jac_blending_inv_1_1_q_1*tmp_kernel_op_391 + jac_blending_inv_2_1_q_1*tmp_kernel_op_392) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_kernel_op_390 + jac_blending_inv_1_2_q_1*tmp_kernel_op_391 + jac_blending_inv_2_2_q_1*tmp_kernel_op_392))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_kernel_op_390 + jac_blending_inv_1_0_q_1*tmp_kernel_op_391 + jac_blending_inv_2_0_q_1*tmp_kernel_op_392) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_kernel_op_390 + jac_blending_inv_1_1_q_1*tmp_kernel_op_391 + jac_blending_inv_2_1_q_1*tmp_kernel_op_392) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_kernel_op_390 + jac_blending_inv_1_2_q_1*tmp_kernel_op_391 + jac_blending_inv_2_2_q_1*tmp_kernel_op_392))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_kernel_op_394 + jac_blending_inv_1_0_q_2*tmp_kernel_op_395 + jac_blending_inv_2_0_q_2*tmp_kernel_op_396) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_kernel_op_394 + jac_blending_inv_1_1_q_2*tmp_kernel_op_395 + jac_blending_inv_2_1_q_2*tmp_kernel_op_396) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_kernel_op_394 + jac_blending_inv_1_2_q_2*tmp_kernel_op_395 + jac_blending_inv_2_2_q_2*tmp_kernel_op_396))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_kernel_op_394 + jac_blending_inv_1_0_q_2*tmp_kernel_op_395 + jac_blending_inv_2_0_q_2*tmp_kernel_op_396) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_kernel_op_394 + jac_blending_inv_1_1_q_2*tmp_kernel_op_395 + jac_blending_inv_2_1_q_2*tmp_kernel_op_396) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_kernel_op_394 + jac_blending_inv_1_2_q_2*tmp_kernel_op_395 + jac_blending_inv_2_2_q_2*tmp_kernel_op_396)));
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const real_t tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const real_t tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_14_WHITE_DOWN = jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
       const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const real_t tmp_coords_jac_13_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_0_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
       const real_t tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const real_t jac_affine_inv_0_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
       const real_t jac_affine_inv_0_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const real_t jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const real_t jac_affine_inv_1_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       const real_t tmp_moved_constant_0 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_4 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_4 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_4;
       const real_t tmp_moved_constant_1 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_4 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_4 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_4;
       const real_t tmp_moved_constant_2 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_4 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_4 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_4;
       const real_t tmp_moved_constant_3 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_33 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_33 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_33;
       const real_t tmp_moved_constant_4 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_33 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_33 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_33;
       const real_t tmp_moved_constant_5 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_33 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_33 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_33;
       const real_t tmp_moved_constant_6 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_62 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_62 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_62;
       const real_t tmp_moved_constant_7 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_62 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_62 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_62;
       const real_t tmp_moved_constant_8 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_62 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_62 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_62;
       const real_t tmp_moved_constant_9 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_91 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_91 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_91;
       const real_t tmp_moved_constant_10 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_91 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_91 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_91;
       const real_t tmp_moved_constant_11 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_91 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_91 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_91;
       const real_t tmp_moved_constant_12 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_120 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_120 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_120;
       const real_t tmp_moved_constant_13 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_120 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_120 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_120;
       const real_t tmp_moved_constant_14 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_120 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_120 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_120;
       const real_t tmp_moved_constant_15 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_145;
       const real_t tmp_moved_constant_16 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_145;
       const real_t tmp_moved_constant_17 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_145;
       const real_t tmp_moved_constant_18 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_149;
       const real_t tmp_moved_constant_19 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_149;
       const real_t tmp_moved_constant_20 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_149;
       const real_t tmp_moved_constant_21 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_153;
       const real_t tmp_moved_constant_22 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_153;
       const real_t tmp_moved_constant_23 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_153;
       const real_t tmp_moved_constant_24 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_157;
       const real_t tmp_moved_constant_25 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_157;
       const real_t tmp_moved_constant_26 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_157;
       const real_t tmp_moved_constant_27 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_161;
       const real_t tmp_moved_constant_28 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_161;
       const real_t tmp_moved_constant_29 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_161;
       const real_t tmp_moved_constant_30 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_165;
       const real_t tmp_moved_constant_31 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_165;
       const real_t tmp_moved_constant_32 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_165;
       const real_t tmp_moved_constant_33 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_169;
       const real_t tmp_moved_constant_34 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_169;
       const real_t tmp_moved_constant_35 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_169;
       const real_t tmp_moved_constant_36 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_173;
       const real_t tmp_moved_constant_37 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_173;
       const real_t tmp_moved_constant_38 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_173;
       const real_t tmp_moved_constant_39 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_177;
       const real_t tmp_moved_constant_40 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_177;
       const real_t tmp_moved_constant_41 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_177;
       const real_t tmp_moved_constant_42 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_181;
       const real_t tmp_moved_constant_43 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_181;
       const real_t tmp_moved_constant_44 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_181;
       const real_t tmp_moved_constant_45 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_185;
       const real_t tmp_moved_constant_46 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_185;
       const real_t tmp_moved_constant_47 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_185;
       const real_t tmp_moved_constant_48 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_189;
       const real_t tmp_moved_constant_49 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_189;
       const real_t tmp_moved_constant_50 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_189;
       const real_t tmp_moved_constant_51 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_193;
       const real_t tmp_moved_constant_52 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_193;
       const real_t tmp_moved_constant_53 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_193;
       const real_t tmp_moved_constant_54 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_197;
       const real_t tmp_moved_constant_55 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_197;
       const real_t tmp_moved_constant_56 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_197;
       const real_t tmp_moved_constant_57 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_201;
       const real_t tmp_moved_constant_58 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_201;
       const real_t tmp_moved_constant_59 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_201;
       const real_t tmp_moved_constant_60 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_61 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_62 = tmp_moved_constant_60 + tmp_moved_constant_61;
       const real_t tmp_moved_constant_63 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_64 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_65 = tmp_moved_constant_63 + tmp_moved_constant_64;
       const real_t tmp_moved_constant_66 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_67 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_68 = tmp_moved_constant_66 + tmp_moved_constant_67;
       const real_t tmp_moved_constant_69 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_70 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_71 = tmp_moved_constant_69 + tmp_moved_constant_70;
       const real_t tmp_moved_constant_72 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_73 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_74 = tmp_moved_constant_72 + tmp_moved_constant_73;
       const real_t tmp_moved_constant_75 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_76 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_77 = tmp_moved_constant_75 + tmp_moved_constant_76;
       const real_t tmp_moved_constant_78 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_58;
       const real_t tmp_moved_constant_79 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_60;
       const real_t tmp_moved_constant_80 = tmp_moved_constant_78 + tmp_moved_constant_79;
       const real_t tmp_moved_constant_81 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_58;
       const real_t tmp_moved_constant_82 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_60;
       const real_t tmp_moved_constant_83 = tmp_moved_constant_81 + tmp_moved_constant_82;
       const real_t tmp_moved_constant_84 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_58;
       const real_t tmp_moved_constant_85 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_60;
       const real_t tmp_moved_constant_86 = tmp_moved_constant_84 + tmp_moved_constant_85;
       const real_t tmp_moved_constant_87 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_87;
       const real_t tmp_moved_constant_88 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_89 = tmp_moved_constant_87 + tmp_moved_constant_88;
       const real_t tmp_moved_constant_90 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_87;
       const real_t tmp_moved_constant_91 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_92 = tmp_moved_constant_90 + tmp_moved_constant_91;
       const real_t tmp_moved_constant_93 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_87;
       const real_t tmp_moved_constant_94 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_95 = tmp_moved_constant_93 + tmp_moved_constant_94;
       const real_t tmp_moved_constant_96 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_116;
       const real_t tmp_moved_constant_97 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_118;
       const real_t tmp_moved_constant_98 = tmp_moved_constant_96 + tmp_moved_constant_97;
       const real_t tmp_moved_constant_99 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_116;
       const real_t tmp_moved_constant_100 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_118;
       const real_t tmp_moved_constant_101 = tmp_moved_constant_100 + tmp_moved_constant_99;
       const real_t tmp_moved_constant_102 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_116;
       const real_t tmp_moved_constant_103 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_118;
       const real_t tmp_moved_constant_104 = tmp_moved_constant_102 + tmp_moved_constant_103;
       const real_t tmp_moved_constant_105 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_106 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_107 = tmp_moved_constant_105 + tmp_moved_constant_106;
       const real_t tmp_moved_constant_108 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_109 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_110 = tmp_moved_constant_108 + tmp_moved_constant_109;
       const real_t tmp_moved_constant_111 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_112 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_113 = tmp_moved_constant_111 + tmp_moved_constant_112;
       const real_t tmp_moved_constant_114 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_115 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_116 = tmp_moved_constant_114 + tmp_moved_constant_115;
       const real_t tmp_moved_constant_117 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_118 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_119 = tmp_moved_constant_117 + tmp_moved_constant_118;
       const real_t tmp_moved_constant_120 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_121 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_122 = tmp_moved_constant_120 + tmp_moved_constant_121;
       const real_t tmp_moved_constant_123 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_58;
       const real_t tmp_moved_constant_124 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_59;
       const real_t tmp_moved_constant_125 = tmp_moved_constant_123 + tmp_moved_constant_124;
       const real_t tmp_moved_constant_126 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_58;
       const real_t tmp_moved_constant_127 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_59;
       const real_t tmp_moved_constant_128 = tmp_moved_constant_126 + tmp_moved_constant_127;
       const real_t tmp_moved_constant_129 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_58;
       const real_t tmp_moved_constant_130 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_59;
       const real_t tmp_moved_constant_131 = tmp_moved_constant_129 + tmp_moved_constant_130;
       const real_t tmp_moved_constant_132 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_87;
       const real_t tmp_moved_constant_133 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_88;
       const real_t tmp_moved_constant_134 = tmp_moved_constant_132 + tmp_moved_constant_133;
       const real_t tmp_moved_constant_135 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_87;
       const real_t tmp_moved_constant_136 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_88;
       const real_t tmp_moved_constant_137 = tmp_moved_constant_135 + tmp_moved_constant_136;
       const real_t tmp_moved_constant_138 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_87;
       const real_t tmp_moved_constant_139 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_88;
       const real_t tmp_moved_constant_140 = tmp_moved_constant_138 + tmp_moved_constant_139;
       const real_t tmp_moved_constant_141 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_116;
       const real_t tmp_moved_constant_142 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_117;
       const real_t tmp_moved_constant_143 = tmp_moved_constant_141 + tmp_moved_constant_142;
       const real_t tmp_moved_constant_144 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_116;
       const real_t tmp_moved_constant_145 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_117;
       const real_t tmp_moved_constant_146 = tmp_moved_constant_144 + tmp_moved_constant_145;
       const real_t tmp_moved_constant_147 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_116;
       const real_t tmp_moved_constant_148 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_117;
       const real_t tmp_moved_constant_149 = tmp_moved_constant_147 + tmp_moved_constant_148;
       const real_t tmp_moved_constant_150 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_151 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_152 = tmp_moved_constant_150 + tmp_moved_constant_151;
       const real_t tmp_moved_constant_153 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_154 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_155 = tmp_moved_constant_153 + tmp_moved_constant_154;
       const real_t tmp_moved_constant_156 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_157 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_158 = tmp_moved_constant_156 + tmp_moved_constant_157;
       const real_t tmp_moved_constant_159 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_160 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_161 = tmp_moved_constant_159 + tmp_moved_constant_160;
       const real_t tmp_moved_constant_162 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_163 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_164 = tmp_moved_constant_162 + tmp_moved_constant_163;
       const real_t tmp_moved_constant_165 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_166 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_167 = tmp_moved_constant_165 + tmp_moved_constant_166;
       const real_t tmp_moved_constant_168 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_60;
       const real_t tmp_moved_constant_169 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_59;
       const real_t tmp_moved_constant_170 = tmp_moved_constant_168 + tmp_moved_constant_169;
       const real_t tmp_moved_constant_171 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_60;
       const real_t tmp_moved_constant_172 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_59;
       const real_t tmp_moved_constant_173 = tmp_moved_constant_171 + tmp_moved_constant_172;
       const real_t tmp_moved_constant_174 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_60;
       const real_t tmp_moved_constant_175 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_59;
       const real_t tmp_moved_constant_176 = tmp_moved_constant_174 + tmp_moved_constant_175;
       const real_t tmp_moved_constant_177 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_178 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_88;
       const real_t tmp_moved_constant_179 = tmp_moved_constant_177 + tmp_moved_constant_178;
       const real_t tmp_moved_constant_180 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_181 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_88;
       const real_t tmp_moved_constant_182 = tmp_moved_constant_180 + tmp_moved_constant_181;
       const real_t tmp_moved_constant_183 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_184 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_88;
       const real_t tmp_moved_constant_185 = tmp_moved_constant_183 + tmp_moved_constant_184;
       const real_t tmp_moved_constant_186 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_118;
       const real_t tmp_moved_constant_187 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_117;
       const real_t tmp_moved_constant_188 = tmp_moved_constant_186 + tmp_moved_constant_187;
       const real_t tmp_moved_constant_189 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_118;
       const real_t tmp_moved_constant_190 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_117;
       const real_t tmp_moved_constant_191 = tmp_moved_constant_189 + tmp_moved_constant_190;
       const real_t tmp_moved_constant_192 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_118;
       const real_t tmp_moved_constant_193 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_117;
       const real_t tmp_moved_constant_194 = tmp_moved_constant_192 + tmp_moved_constant_193;
       const real_t tmp_moved_constant_195 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_340 - tmp_moved_constant_105 - tmp_moved_constant_60;
       const real_t tmp_moved_constant_196 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_340 - tmp_moved_constant_108 - tmp_moved_constant_63;
       const real_t tmp_moved_constant_197 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_340 - tmp_moved_constant_111 - tmp_moved_constant_66;
       const real_t tmp_moved_constant_198 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_344 - tmp_moved_constant_114 - tmp_moved_constant_69;
       const real_t tmp_moved_constant_199 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_344 - tmp_moved_constant_117 - tmp_moved_constant_72;
       const real_t tmp_moved_constant_200 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_344 - tmp_moved_constant_120 - tmp_moved_constant_75;
       const real_t tmp_moved_constant_201 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_348 - tmp_moved_constant_123 - tmp_moved_constant_78;
       const real_t tmp_moved_constant_202 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_348 - tmp_moved_constant_126 - tmp_moved_constant_81;
       const real_t tmp_moved_constant_203 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_348 - tmp_moved_constant_129 - tmp_moved_constant_84;
       const real_t tmp_moved_constant_204 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_352 - tmp_moved_constant_132 - tmp_moved_constant_87;
       const real_t tmp_moved_constant_205 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_352 - tmp_moved_constant_135 - tmp_moved_constant_90;
       const real_t tmp_moved_constant_206 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_352 - tmp_moved_constant_138 - tmp_moved_constant_93;
       const real_t tmp_moved_constant_207 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_356 - tmp_moved_constant_141 - tmp_moved_constant_96;
       const real_t tmp_moved_constant_208 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_356 - tmp_moved_constant_144 - tmp_moved_constant_99;
       const real_t tmp_moved_constant_209 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_356 - tmp_moved_constant_102 - tmp_moved_constant_147;
       const real_t tmp_moved_constant_210 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_361 - tmp_moved_constant_150 - tmp_moved_constant_61;
       const real_t tmp_moved_constant_211 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_361 - tmp_moved_constant_153 - tmp_moved_constant_64;
       const real_t tmp_moved_constant_212 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_361 - tmp_moved_constant_156 - tmp_moved_constant_67;
       const real_t tmp_moved_constant_213 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_366 - tmp_moved_constant_159 - tmp_moved_constant_70;
       const real_t tmp_moved_constant_214 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_366 - tmp_moved_constant_162 - tmp_moved_constant_73;
       const real_t tmp_moved_constant_215 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_366 - tmp_moved_constant_165 - tmp_moved_constant_76;
       const real_t tmp_moved_constant_216 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_371 - tmp_moved_constant_168 - tmp_moved_constant_79;
       const real_t tmp_moved_constant_217 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_371 - tmp_moved_constant_171 - tmp_moved_constant_82;
       const real_t tmp_moved_constant_218 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_371 - tmp_moved_constant_174 - tmp_moved_constant_85;
       const real_t tmp_moved_constant_219 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_376 - tmp_moved_constant_177 - tmp_moved_constant_88;
       const real_t tmp_moved_constant_220 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_376 - tmp_moved_constant_180 - tmp_moved_constant_91;
       const real_t tmp_moved_constant_221 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_376 - tmp_moved_constant_183 - tmp_moved_constant_94;
       const real_t tmp_moved_constant_222 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_381 - tmp_moved_constant_186 - tmp_moved_constant_97;
       const real_t tmp_moved_constant_223 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_381 - tmp_moved_constant_100 - tmp_moved_constant_189;
       const real_t tmp_moved_constant_224 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_381 - tmp_moved_constant_103 - tmp_moved_constant_192;
       const real_t tmp_moved_constant_225 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_385 - tmp_moved_constant_106 - tmp_moved_constant_151;
       const real_t tmp_moved_constant_226 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_385 - tmp_moved_constant_109 - tmp_moved_constant_154;
       const real_t tmp_moved_constant_227 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_385 - tmp_moved_constant_112 - tmp_moved_constant_157;
       const real_t tmp_moved_constant_228 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_389 - tmp_moved_constant_115 - tmp_moved_constant_160;
       const real_t tmp_moved_constant_229 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_389 - tmp_moved_constant_118 - tmp_moved_constant_163;
       const real_t tmp_moved_constant_230 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_389 - tmp_moved_constant_121 - tmp_moved_constant_166;
       const real_t tmp_moved_constant_231 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_393 - tmp_moved_constant_124 - tmp_moved_constant_169;
       const real_t tmp_moved_constant_232 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_393 - tmp_moved_constant_127 - tmp_moved_constant_172;
       const real_t tmp_moved_constant_233 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_393 - tmp_moved_constant_130 - tmp_moved_constant_175;
       const real_t tmp_moved_constant_234 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_397 - tmp_moved_constant_133 - tmp_moved_constant_178;
       const real_t tmp_moved_constant_235 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_397 - tmp_moved_constant_136 - tmp_moved_constant_181;
       const real_t tmp_moved_constant_236 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_397 - tmp_moved_constant_139 - tmp_moved_constant_184;
       const real_t tmp_moved_constant_237 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_401 - tmp_moved_constant_142 - tmp_moved_constant_187;
       const real_t tmp_moved_constant_238 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_401 - tmp_moved_constant_145 - tmp_moved_constant_190;
       const real_t tmp_moved_constant_239 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_401 - tmp_moved_constant_148 - tmp_moved_constant_193;
       {
          /* CellType.WHITE_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
             const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
             const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
             const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
             const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
             const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
             const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
             const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
             const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
             const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
             const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
             const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
             const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
             const real_t tmp_blending_op_35 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_36 = -tmp_blending_op_35;
             const real_t tmp_blending_op_37 = (tmp_blending_op_28*tmp_blending_op_28);
             const real_t tmp_blending_op_38 = (tmp_blending_op_33*tmp_blending_op_33);
             const real_t tmp_blending_op_39 = tmp_blending_op_37 + tmp_blending_op_38 + tmp_blending_op_4;
             const real_t tmp_blending_op_42 = pow(tmp_blending_op_39, -1.5000000000000000)*tmp_blending_op_41;
             const real_t tmp_blending_op_44 = tmp_blending_op_23*tmp_blending_op_39;
             const real_t tmp_blending_op_45 = -tmp_blending_op_33*tmp_blending_op_35 - tmp_blending_op_43*tmp_blending_op_44;
             const real_t tmp_blending_op_46 = tmp_blending_op_3*tmp_blending_op_42;
             const real_t tmp_blending_op_48 = tmp_blending_op_28*tmp_blending_op_36 + tmp_blending_op_44*tmp_blending_op_47;
             const real_t tmp_blending_op_49 = tmp_blending_op_3*tmp_blending_op_36 + tmp_blending_op_39*tmp_blending_op_40;
             const real_t tmp_blending_op_50 = tmp_blending_op_33*tmp_blending_op_42;
             const real_t tmp_blending_op_52 = tmp_blending_op_28*tmp_blending_op_42;
             const real_t tmp_blending_op_61 = p_affine_0_2 + tmp_blending_op_0*0.5 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_62 = (tmp_blending_op_61*tmp_blending_op_61);
             const real_t tmp_blending_op_63 = -tmp_blending_op_17 - tmp_blending_op_61;
             const real_t tmp_blending_op_64 = p_affine_0_0 + tmp_blending_op_25*0.5 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_65 = -tmp_blending_op_6 - tmp_blending_op_64;
             const real_t tmp_blending_op_66 = p_affine_0_1 + tmp_blending_op_30*0.5 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_67 = -tmp_blending_op_13 - tmp_blending_op_66;
             const real_t tmp_blending_op_68 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_65 - tmp_blending_op_12*tmp_blending_op_63 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_63 - tmp_blending_op_19*tmp_blending_op_65 - tmp_blending_op_20*tmp_blending_op_67 + tmp_blending_op_67*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_69 = -tmp_blending_op_68;
             const real_t tmp_blending_op_70 = (tmp_blending_op_64*tmp_blending_op_64);
             const real_t tmp_blending_op_71 = (tmp_blending_op_66*tmp_blending_op_66);
             const real_t tmp_blending_op_72 = tmp_blending_op_62 + tmp_blending_op_70 + tmp_blending_op_71;
             const real_t tmp_blending_op_73 = tmp_blending_op_41*pow(tmp_blending_op_72, -1.5000000000000000);
             const real_t tmp_blending_op_75 = -tmp_blending_op_66*tmp_blending_op_68 - tmp_blending_op_72*tmp_blending_op_74;
             const real_t tmp_blending_op_76 = tmp_blending_op_61*tmp_blending_op_73;
             const real_t tmp_blending_op_77 = tmp_blending_op_53*tmp_blending_op_72 + tmp_blending_op_64*tmp_blending_op_69;
             const real_t tmp_blending_op_78 = tmp_blending_op_40*tmp_blending_op_72 + tmp_blending_op_61*tmp_blending_op_69;
             const real_t tmp_blending_op_79 = tmp_blending_op_66*tmp_blending_op_73;
             const real_t tmp_blending_op_80 = tmp_blending_op_64*tmp_blending_op_73;
             const real_t tmp_blending_op_88 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.5 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_89 = (tmp_blending_op_88*tmp_blending_op_88);
             const real_t tmp_blending_op_90 = -tmp_blending_op_17 - tmp_blending_op_88;
             const real_t tmp_blending_op_91 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.5 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_92 = -tmp_blending_op_6 - tmp_blending_op_91;
             const real_t tmp_blending_op_93 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.5 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_94 = -tmp_blending_op_13 - tmp_blending_op_93;
             const real_t tmp_blending_op_95 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_92 - tmp_blending_op_12*tmp_blending_op_90 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_90 - tmp_blending_op_19*tmp_blending_op_92 - tmp_blending_op_20*tmp_blending_op_94 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_94);
             const real_t tmp_blending_op_96 = -tmp_blending_op_95;
             const real_t tmp_blending_op_97 = (tmp_blending_op_91*tmp_blending_op_91);
             const real_t tmp_blending_op_98 = (tmp_blending_op_93*tmp_blending_op_93);
             const real_t tmp_blending_op_99 = tmp_blending_op_89 + tmp_blending_op_97 + tmp_blending_op_98;
             const real_t tmp_blending_op_100 = tmp_blending_op_41*pow(tmp_blending_op_99, -1.5000000000000000);
             const real_t tmp_blending_op_101 = -tmp_blending_op_74*tmp_blending_op_99 - tmp_blending_op_93*tmp_blending_op_95;
             const real_t tmp_blending_op_102 = tmp_blending_op_100*tmp_blending_op_88;
             const real_t tmp_blending_op_103 = tmp_blending_op_53*tmp_blending_op_99 + tmp_blending_op_91*tmp_blending_op_96;
             const real_t tmp_blending_op_104 = tmp_blending_op_40*tmp_blending_op_99 + tmp_blending_op_88*tmp_blending_op_96;
             const real_t tmp_blending_op_105 = tmp_blending_op_100*tmp_blending_op_93;
             const real_t tmp_blending_op_106 = tmp_blending_op_100*tmp_blending_op_91;
             const real_t tmp_blending_op_114 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.5;
             const real_t tmp_blending_op_115 = (tmp_blending_op_114*tmp_blending_op_114);
             const real_t tmp_blending_op_116 = -tmp_blending_op_114 - tmp_blending_op_17;
             const real_t tmp_blending_op_117 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.5;
             const real_t tmp_blending_op_118 = -tmp_blending_op_117 - tmp_blending_op_6;
             const real_t tmp_blending_op_119 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.5;
             const real_t tmp_blending_op_120 = -tmp_blending_op_119 - tmp_blending_op_13;
             const real_t tmp_blending_op_121 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_118*tmp_blending_op_18 - tmp_blending_op_116*tmp_blending_op_12 + tmp_blending_op_116*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_118*tmp_blending_op_19 - tmp_blending_op_120*tmp_blending_op_20 + tmp_blending_op_120*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_122 = -tmp_blending_op_121;
             const real_t tmp_blending_op_123 = (tmp_blending_op_117*tmp_blending_op_117);
             const real_t tmp_blending_op_124 = (tmp_blending_op_119*tmp_blending_op_119);
             const real_t tmp_blending_op_125 = tmp_blending_op_115 + tmp_blending_op_123 + tmp_blending_op_124;
             const real_t tmp_blending_op_126 = pow(tmp_blending_op_125, -1.5000000000000000)*tmp_blending_op_41;
             const real_t tmp_blending_op_127 = -tmp_blending_op_119*tmp_blending_op_121 - tmp_blending_op_125*tmp_blending_op_74;
             const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_126;
             const real_t tmp_blending_op_129 = tmp_blending_op_117*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_53;
             const real_t tmp_blending_op_130 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_40;
             const real_t tmp_blending_op_131 = tmp_blending_op_119*tmp_blending_op_126;
             const real_t tmp_blending_op_132 = tmp_blending_op_117*tmp_blending_op_126;
             const real_t tmp_blending_op_140 = p_affine_0_2 + tmp_blending_op_0*0.25 + tmp_blending_op_1*0.25 + tmp_blending_op_2*0.25;
             const real_t tmp_blending_op_141 = (tmp_blending_op_140*tmp_blending_op_140);
             const real_t tmp_blending_op_142 = -tmp_blending_op_140 - tmp_blending_op_17;
             const real_t tmp_blending_op_143 = p_affine_0_0 + tmp_blending_op_25*0.25 + tmp_blending_op_26*0.25 + tmp_blending_op_27*0.25;
             const real_t tmp_blending_op_144 = -tmp_blending_op_143 - tmp_blending_op_6;
             const real_t tmp_blending_op_145 = p_affine_0_1 + tmp_blending_op_30*0.25 + tmp_blending_op_31*0.25 + tmp_blending_op_32*0.25;
             const real_t tmp_blending_op_146 = -tmp_blending_op_13 - tmp_blending_op_145;
             const real_t tmp_blending_op_147 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_144*tmp_blending_op_18 - tmp_blending_op_12*tmp_blending_op_142 + tmp_blending_op_14*tmp_blending_op_142*tmp_blending_op_15 - tmp_blending_op_144*tmp_blending_op_19 - tmp_blending_op_146*tmp_blending_op_20 + tmp_blending_op_146*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_148 = -tmp_blending_op_147;
             const real_t tmp_blending_op_149 = (tmp_blending_op_143*tmp_blending_op_143);
             const real_t tmp_blending_op_150 = (tmp_blending_op_145*tmp_blending_op_145);
             const real_t tmp_blending_op_151 = tmp_blending_op_141 + tmp_blending_op_149 + tmp_blending_op_150;
             const real_t tmp_blending_op_152 = pow(tmp_blending_op_151, -1.5000000000000000)*tmp_blending_op_41;
             const real_t tmp_blending_op_153 = -tmp_blending_op_145*tmp_blending_op_147 - tmp_blending_op_151*tmp_blending_op_74;
             const real_t tmp_blending_op_154 = tmp_blending_op_140*tmp_blending_op_152;
             const real_t tmp_blending_op_155 = tmp_blending_op_143*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_53;
             const real_t tmp_blending_op_156 = tmp_blending_op_140*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_40;
             const real_t tmp_blending_op_157 = tmp_blending_op_145*tmp_blending_op_152;
             const real_t tmp_blending_op_158 = tmp_blending_op_143*tmp_blending_op_152;
             const real_t jac_blending_2_2_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_4 + tmp_blending_op_39*(tmp_blending_op_3*tmp_blending_op_40 + tmp_blending_op_35));
             const real_t jac_blending_2_1_q_4 = tmp_blending_op_45*tmp_blending_op_46;
             const real_t jac_blending_2_0_q_4 = tmp_blending_op_46*tmp_blending_op_48;
             const real_t jac_blending_1_2_q_4 = tmp_blending_op_49*tmp_blending_op_50;
             const real_t jac_blending_1_1_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_39*(tmp_blending_op_33*tmp_blending_op_51 + tmp_blending_op_35));
             const real_t tmp_blending_op_58 = jac_blending_1_1_q_4*jac_blending_2_0_q_4;
             const real_t jac_blending_1_0_q_4 = tmp_blending_op_48*tmp_blending_op_50;
             const real_t tmp_blending_op_55 = jac_blending_1_0_q_4*jac_blending_2_1_q_4;
             const real_t jac_blending_0_2_q_4 = tmp_blending_op_49*tmp_blending_op_52;
             const real_t jac_blending_0_1_q_4 = tmp_blending_op_45*tmp_blending_op_52;
             const real_t tmp_blending_op_57 = jac_blending_0_1_q_4*jac_blending_1_0_q_4;
             const real_t jac_blending_0_0_q_4 = tmp_blending_op_42*(-tmp_blending_op_35*tmp_blending_op_37 + tmp_blending_op_39*(tmp_blending_op_28*tmp_blending_op_53 + tmp_blending_op_35));
             const real_t tmp_blending_op_54 = jac_blending_0_0_q_4*jac_blending_1_1_q_4;
             const real_t tmp_blending_op_56 = jac_blending_0_0_q_4*jac_blending_2_1_q_4;
             const real_t tmp_blending_op_59 = jac_blending_0_1_q_4*jac_blending_1_2_q_4*jac_blending_2_0_q_4 + jac_blending_0_2_q_4*tmp_blending_op_55 - jac_blending_0_2_q_4*tmp_blending_op_58 - jac_blending_1_2_q_4*tmp_blending_op_56 + jac_blending_2_2_q_4*tmp_blending_op_54 - jac_blending_2_2_q_4*tmp_blending_op_57;
             const real_t tmp_blending_op_60 = 1.0 / (tmp_blending_op_59);
             const real_t abs_det_jac_blending_q_4 = tmp_blending_op_59;
             const real_t jac_blending_inv_2_2_q_4 = tmp_blending_op_60*(tmp_blending_op_54 - tmp_blending_op_57);
             const real_t jac_blending_inv_2_1_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_2_0_q_4 - tmp_blending_op_56);
             const real_t jac_blending_inv_2_0_q_4 = tmp_blending_op_60*(tmp_blending_op_55 - tmp_blending_op_58);
             const real_t jac_blending_inv_1_2_q_4 = tmp_blending_op_60*(-jac_blending_0_0_q_4*jac_blending_1_2_q_4 + jac_blending_0_2_q_4*jac_blending_1_0_q_4);
             const real_t jac_blending_inv_1_1_q_4 = tmp_blending_op_60*(jac_blending_0_0_q_4*jac_blending_2_2_q_4 - jac_blending_0_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_1_0_q_4 = tmp_blending_op_60*(-jac_blending_1_0_q_4*jac_blending_2_2_q_4 + jac_blending_1_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_0_2_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_1_2_q_4 - jac_blending_0_2_q_4*jac_blending_1_1_q_4);
             const real_t jac_blending_inv_0_1_q_4 = tmp_blending_op_60*(-jac_blending_0_1_q_4*jac_blending_2_2_q_4 + jac_blending_0_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_inv_0_0_q_4 = tmp_blending_op_60*(jac_blending_1_1_q_4*jac_blending_2_2_q_4 - jac_blending_1_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_2_2_q_3 = tmp_blending_op_73*(tmp_blending_op_62*tmp_blending_op_69 + tmp_blending_op_72*(tmp_blending_op_40*tmp_blending_op_61 + tmp_blending_op_68));
             const real_t jac_blending_2_1_q_3 = tmp_blending_op_75*tmp_blending_op_76;
             const real_t jac_blending_2_0_q_3 = tmp_blending_op_76*tmp_blending_op_77;
             const real_t jac_blending_1_2_q_3 = tmp_blending_op_78*tmp_blending_op_79;
             const real_t jac_blending_1_1_q_3 = tmp_blending_op_73*(tmp_blending_op_69*tmp_blending_op_71 + tmp_blending_op_72*(tmp_blending_op_51*tmp_blending_op_66 + tmp_blending_op_68));
             const real_t tmp_blending_op_85 = jac_blending_1_1_q_3*jac_blending_2_0_q_3;
             const real_t jac_blending_1_0_q_3 = tmp_blending_op_77*tmp_blending_op_79;
             const real_t tmp_blending_op_82 = jac_blending_1_0_q_3*jac_blending_2_1_q_3;
             const real_t jac_blending_0_2_q_3 = tmp_blending_op_78*tmp_blending_op_80;
             const real_t jac_blending_0_1_q_3 = tmp_blending_op_75*tmp_blending_op_80;
             const real_t tmp_blending_op_84 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
             const real_t jac_blending_0_0_q_3 = tmp_blending_op_73*(-tmp_blending_op_68*tmp_blending_op_70 + tmp_blending_op_72*(tmp_blending_op_53*tmp_blending_op_64 + tmp_blending_op_68));
             const real_t tmp_blending_op_81 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
             const real_t tmp_blending_op_83 = jac_blending_0_0_q_3*jac_blending_2_1_q_3;
             const real_t tmp_blending_op_86 = jac_blending_0_1_q_3*jac_blending_1_2_q_3*jac_blending_2_0_q_3 + jac_blending_0_2_q_3*tmp_blending_op_82 - jac_blending_0_2_q_3*tmp_blending_op_85 - jac_blending_1_2_q_3*tmp_blending_op_83 + jac_blending_2_2_q_3*tmp_blending_op_81 - jac_blending_2_2_q_3*tmp_blending_op_84;
             const real_t tmp_blending_op_87 = 1.0 / (tmp_blending_op_86);
             const real_t abs_det_jac_blending_q_3 = tmp_blending_op_86;
             const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_87*(tmp_blending_op_81 - tmp_blending_op_84);
             const real_t jac_blending_inv_2_1_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_2_0_q_3 - tmp_blending_op_83);
             const real_t jac_blending_inv_2_0_q_3 = tmp_blending_op_87*(tmp_blending_op_82 - tmp_blending_op_85);
             const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_87*(-jac_blending_0_0_q_3*jac_blending_1_2_q_3 + jac_blending_0_2_q_3*jac_blending_1_0_q_3);
             const real_t jac_blending_inv_1_1_q_3 = tmp_blending_op_87*(jac_blending_0_0_q_3*jac_blending_2_2_q_3 - jac_blending_0_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_1_0_q_3 = tmp_blending_op_87*(-jac_blending_1_0_q_3*jac_blending_2_2_q_3 + jac_blending_1_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_1_2_q_3 - jac_blending_0_2_q_3*jac_blending_1_1_q_3);
             const real_t jac_blending_inv_0_1_q_3 = tmp_blending_op_87*(-jac_blending_0_1_q_3*jac_blending_2_2_q_3 + jac_blending_0_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_inv_0_0_q_3 = tmp_blending_op_87*(jac_blending_1_1_q_3*jac_blending_2_2_q_3 - jac_blending_1_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_2_2_q_2 = tmp_blending_op_100*(tmp_blending_op_89*tmp_blending_op_96 + tmp_blending_op_99*(tmp_blending_op_40*tmp_blending_op_88 + tmp_blending_op_95));
             const real_t jac_blending_2_1_q_2 = tmp_blending_op_101*tmp_blending_op_102;
             const real_t jac_blending_2_0_q_2 = tmp_blending_op_102*tmp_blending_op_103;
             const real_t jac_blending_1_2_q_2 = tmp_blending_op_104*tmp_blending_op_105;
             const real_t jac_blending_1_1_q_2 = tmp_blending_op_100*(tmp_blending_op_96*tmp_blending_op_98 + tmp_blending_op_99*(tmp_blending_op_51*tmp_blending_op_93 + tmp_blending_op_95));
             const real_t tmp_blending_op_111 = jac_blending_1_1_q_2*jac_blending_2_0_q_2;
             const real_t jac_blending_1_0_q_2 = tmp_blending_op_103*tmp_blending_op_105;
             const real_t tmp_blending_op_108 = jac_blending_1_0_q_2*jac_blending_2_1_q_2;
             const real_t jac_blending_0_2_q_2 = tmp_blending_op_104*tmp_blending_op_106;
             const real_t jac_blending_0_1_q_2 = tmp_blending_op_101*tmp_blending_op_106;
             const real_t tmp_blending_op_110 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
             const real_t jac_blending_0_0_q_2 = tmp_blending_op_100*(-tmp_blending_op_95*tmp_blending_op_97 + tmp_blending_op_99*(tmp_blending_op_53*tmp_blending_op_91 + tmp_blending_op_95));
             const real_t tmp_blending_op_107 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
             const real_t tmp_blending_op_109 = jac_blending_0_0_q_2*jac_blending_2_1_q_2;
             const real_t tmp_blending_op_112 = jac_blending_0_1_q_2*jac_blending_1_2_q_2*jac_blending_2_0_q_2 + jac_blending_0_2_q_2*tmp_blending_op_108 - jac_blending_0_2_q_2*tmp_blending_op_111 - jac_blending_1_2_q_2*tmp_blending_op_109 + jac_blending_2_2_q_2*tmp_blending_op_107 - jac_blending_2_2_q_2*tmp_blending_op_110;
             const real_t tmp_blending_op_113 = 1.0 / (tmp_blending_op_112);
             const real_t abs_det_jac_blending_q_2 = tmp_blending_op_112;
             const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_113*(tmp_blending_op_107 - tmp_blending_op_110);
             const real_t jac_blending_inv_2_1_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_2_0_q_2 - tmp_blending_op_109);
             const real_t jac_blending_inv_2_0_q_2 = tmp_blending_op_113*(tmp_blending_op_108 - tmp_blending_op_111);
             const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_113*(-jac_blending_0_0_q_2*jac_blending_1_2_q_2 + jac_blending_0_2_q_2*jac_blending_1_0_q_2);
             const real_t jac_blending_inv_1_1_q_2 = tmp_blending_op_113*(jac_blending_0_0_q_2*jac_blending_2_2_q_2 - jac_blending_0_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_1_0_q_2 = tmp_blending_op_113*(-jac_blending_1_0_q_2*jac_blending_2_2_q_2 + jac_blending_1_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_1_2_q_2 - jac_blending_0_2_q_2*jac_blending_1_1_q_2);
             const real_t jac_blending_inv_0_1_q_2 = tmp_blending_op_113*(-jac_blending_0_1_q_2*jac_blending_2_2_q_2 + jac_blending_0_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_inv_0_0_q_2 = tmp_blending_op_113*(jac_blending_1_1_q_2*jac_blending_2_2_q_2 - jac_blending_1_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_2_2_q_1 = tmp_blending_op_126*(tmp_blending_op_115*tmp_blending_op_122 + tmp_blending_op_125*(tmp_blending_op_114*tmp_blending_op_40 + tmp_blending_op_121));
             const real_t jac_blending_2_1_q_1 = tmp_blending_op_127*tmp_blending_op_128;
             const real_t jac_blending_2_0_q_1 = tmp_blending_op_128*tmp_blending_op_129;
             const real_t jac_blending_1_2_q_1 = tmp_blending_op_130*tmp_blending_op_131;
             const real_t jac_blending_1_1_q_1 = tmp_blending_op_126*(tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*(tmp_blending_op_119*tmp_blending_op_51 + tmp_blending_op_121));
             const real_t tmp_blending_op_137 = jac_blending_1_1_q_1*jac_blending_2_0_q_1;
             const real_t jac_blending_1_0_q_1 = tmp_blending_op_129*tmp_blending_op_131;
             const real_t tmp_blending_op_134 = jac_blending_1_0_q_1*jac_blending_2_1_q_1;
             const real_t jac_blending_0_2_q_1 = tmp_blending_op_130*tmp_blending_op_132;
             const real_t jac_blending_0_1_q_1 = tmp_blending_op_127*tmp_blending_op_132;
             const real_t tmp_blending_op_136 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
             const real_t jac_blending_0_0_q_1 = tmp_blending_op_126*(-tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*(tmp_blending_op_117*tmp_blending_op_53 + tmp_blending_op_121));
             const real_t tmp_blending_op_133 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
             const real_t tmp_blending_op_135 = jac_blending_0_0_q_1*jac_blending_2_1_q_1;
             const real_t tmp_blending_op_138 = jac_blending_0_1_q_1*jac_blending_1_2_q_1*jac_blending_2_0_q_1 + jac_blending_0_2_q_1*tmp_blending_op_134 - jac_blending_0_2_q_1*tmp_blending_op_137 - jac_blending_1_2_q_1*tmp_blending_op_135 + jac_blending_2_2_q_1*tmp_blending_op_133 - jac_blending_2_2_q_1*tmp_blending_op_136;
             const real_t tmp_blending_op_139 = 1.0 / (tmp_blending_op_138);
             const real_t abs_det_jac_blending_q_1 = tmp_blending_op_138;
             const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_139*(tmp_blending_op_133 - tmp_blending_op_136);
             const real_t jac_blending_inv_2_1_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_2_0_q_1 - tmp_blending_op_135);
             const real_t jac_blending_inv_2_0_q_1 = tmp_blending_op_139*(tmp_blending_op_134 - tmp_blending_op_137);
             const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_139*(-jac_blending_0_0_q_1*jac_blending_1_2_q_1 + jac_blending_0_2_q_1*jac_blending_1_0_q_1);
             const real_t jac_blending_inv_1_1_q_1 = tmp_blending_op_139*(jac_blending_0_0_q_1*jac_blending_2_2_q_1 - jac_blending_0_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_1_0_q_1 = tmp_blending_op_139*(-jac_blending_1_0_q_1*jac_blending_2_2_q_1 + jac_blending_1_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_1_2_q_1 - jac_blending_0_2_q_1*jac_blending_1_1_q_1);
             const real_t jac_blending_inv_0_1_q_1 = tmp_blending_op_139*(-jac_blending_0_1_q_1*jac_blending_2_2_q_1 + jac_blending_0_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_inv_0_0_q_1 = tmp_blending_op_139*(jac_blending_1_1_q_1*jac_blending_2_2_q_1 - jac_blending_1_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_2_2_q_0 = tmp_blending_op_152*(tmp_blending_op_141*tmp_blending_op_148 + tmp_blending_op_151*(tmp_blending_op_140*tmp_blending_op_40 + tmp_blending_op_147));
             const real_t jac_blending_2_1_q_0 = tmp_blending_op_153*tmp_blending_op_154;
             const real_t jac_blending_2_0_q_0 = tmp_blending_op_154*tmp_blending_op_155;
             const real_t jac_blending_1_2_q_0 = tmp_blending_op_156*tmp_blending_op_157;
             const real_t jac_blending_1_1_q_0 = tmp_blending_op_152*(tmp_blending_op_148*tmp_blending_op_150 + tmp_blending_op_151*(tmp_blending_op_145*tmp_blending_op_51 + tmp_blending_op_147));
             const real_t tmp_blending_op_163 = jac_blending_1_1_q_0*jac_blending_2_0_q_0;
             const real_t jac_blending_1_0_q_0 = tmp_blending_op_155*tmp_blending_op_157;
             const real_t tmp_blending_op_160 = jac_blending_1_0_q_0*jac_blending_2_1_q_0;
             const real_t jac_blending_0_2_q_0 = tmp_blending_op_156*tmp_blending_op_158;
             const real_t jac_blending_0_1_q_0 = tmp_blending_op_153*tmp_blending_op_158;
             const real_t tmp_blending_op_162 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
             const real_t jac_blending_0_0_q_0 = tmp_blending_op_152*(-tmp_blending_op_147*tmp_blending_op_149 + tmp_blending_op_151*(tmp_blending_op_143*tmp_blending_op_53 + tmp_blending_op_147));
             const real_t tmp_blending_op_159 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
             const real_t tmp_blending_op_161 = jac_blending_0_0_q_0*jac_blending_2_1_q_0;
             const real_t tmp_blending_op_164 = jac_blending_0_1_q_0*jac_blending_1_2_q_0*jac_blending_2_0_q_0 + jac_blending_0_2_q_0*tmp_blending_op_160 - jac_blending_0_2_q_0*tmp_blending_op_163 - jac_blending_1_2_q_0*tmp_blending_op_161 + jac_blending_2_2_q_0*tmp_blending_op_159 - jac_blending_2_2_q_0*tmp_blending_op_162;
             const real_t tmp_blending_op_165 = 1.0 / (tmp_blending_op_164);
             const real_t abs_det_jac_blending_q_0 = tmp_blending_op_164;
             const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_165*(tmp_blending_op_159 - tmp_blending_op_162);
             const real_t jac_blending_inv_2_1_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_2_0_q_0 - tmp_blending_op_161);
             const real_t jac_blending_inv_2_0_q_0 = tmp_blending_op_165*(tmp_blending_op_160 - tmp_blending_op_163);
             const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_165*(-jac_blending_0_0_q_0*jac_blending_1_2_q_0 + jac_blending_0_2_q_0*jac_blending_1_0_q_0);
             const real_t jac_blending_inv_1_1_q_0 = tmp_blending_op_165*(jac_blending_0_0_q_0*jac_blending_2_2_q_0 - jac_blending_0_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_1_0_q_0 = tmp_blending_op_165*(-jac_blending_1_0_q_0*jac_blending_2_2_q_0 + jac_blending_1_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_1_2_q_0 - jac_blending_0_2_q_0*jac_blending_1_1_q_0);
             const real_t jac_blending_inv_0_1_q_0 = tmp_blending_op_165*(-jac_blending_0_1_q_0*jac_blending_2_2_q_0 + jac_blending_0_2_q_0*jac_blending_2_1_q_0);
             const real_t jac_blending_inv_0_0_q_0 = tmp_blending_op_165*(jac_blending_1_1_q_0*jac_blending_2_2_q_0 - jac_blending_1_2_q_0*jac_blending_2_1_q_0);
             const real_t cp_times_delta_dof_0 = _data_cp_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t cp_times_delta_dof_1 = _data_cp_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t cp_times_delta_dof_2 = _data_cp_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t cp_times_delta_dof_3 = _data_cp_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t cp_times_delta_dof_4 = _data_cp_times_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t cp_times_delta_dof_5 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t cp_times_delta_dof_6 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t cp_times_delta_dof_7 = _data_cp_times_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t cp_times_delta_dof_8 = _data_cp_times_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t cp_times_delta_dof_9 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ux_dof_0 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_1 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_2 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_3 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_4 = _data_uxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ux_dof_5 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t ux_dof_6 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ux_dof_7 = _data_uxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ux_dof_8 = _data_uxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_9 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uy_dof_0 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_1 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_2 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_3 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_4 = _data_uyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uy_dof_5 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t uy_dof_6 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uy_dof_7 = _data_uyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uy_dof_8 = _data_uyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_9 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uz_dof_0 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_1 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_2 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_3 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_4 = _data_uzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uz_dof_5 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t uz_dof_6 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uz_dof_7 = _data_uzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uz_dof_8 = _data_uzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_9 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t tmp_kernel_op_25 = tmp_kernel_op_10*ux_dof_6 + tmp_kernel_op_13*ux_dof_1 + tmp_kernel_op_16*ux_dof_2 + tmp_kernel_op_19*ux_dof_3 + tmp_kernel_op_20*ux_dof_7 + tmp_kernel_op_21*ux_dof_8 + tmp_kernel_op_23*ux_dof_9 + tmp_kernel_op_24*ux_dof_0 + tmp_kernel_op_8*ux_dof_4 + tmp_kernel_op_9*ux_dof_5;
             const real_t tmp_kernel_op_26 = tmp_kernel_op_10*uy_dof_6 + tmp_kernel_op_13*uy_dof_1 + tmp_kernel_op_16*uy_dof_2 + tmp_kernel_op_19*uy_dof_3 + tmp_kernel_op_20*uy_dof_7 + tmp_kernel_op_21*uy_dof_8 + tmp_kernel_op_23*uy_dof_9 + tmp_kernel_op_24*uy_dof_0 + tmp_kernel_op_8*uy_dof_4 + tmp_kernel_op_9*uy_dof_5;
             const real_t tmp_kernel_op_27 = tmp_kernel_op_10*uz_dof_6 + tmp_kernel_op_13*uz_dof_1 + tmp_kernel_op_16*uz_dof_2 + tmp_kernel_op_19*uz_dof_3 + tmp_kernel_op_20*uz_dof_7 + tmp_kernel_op_21*uz_dof_8 + tmp_kernel_op_23*uz_dof_9 + tmp_kernel_op_24*uz_dof_0 + tmp_kernel_op_8*uz_dof_4 + tmp_kernel_op_9*uz_dof_5;
             const real_t tmp_kernel_op_28 = abs_det_jac_affine_WHITE_DOWN*abs_det_jac_blending_q_0*(cp_times_delta_dof_0*tmp_kernel_op_24 + cp_times_delta_dof_1*tmp_kernel_op_13 + cp_times_delta_dof_2*tmp_kernel_op_16 + cp_times_delta_dof_3*tmp_kernel_op_19 + cp_times_delta_dof_4*tmp_kernel_op_8 + cp_times_delta_dof_5*tmp_kernel_op_9 + cp_times_delta_dof_6*tmp_kernel_op_10 + cp_times_delta_dof_7*tmp_kernel_op_20 + cp_times_delta_dof_8*tmp_kernel_op_21 + cp_times_delta_dof_9*tmp_kernel_op_23)*-0.1333333333333333;
             const real_t tmp_kernel_op_54 = tmp_kernel_op_37*ux_dof_4 + tmp_kernel_op_38*ux_dof_5 + tmp_kernel_op_39*ux_dof_6 + tmp_kernel_op_42*ux_dof_1 + tmp_kernel_op_45*ux_dof_2 + tmp_kernel_op_48*ux_dof_3 + tmp_kernel_op_49*ux_dof_7 + tmp_kernel_op_50*ux_dof_8 + tmp_kernel_op_52*ux_dof_9 + tmp_kernel_op_53*ux_dof_0;
             const real_t tmp_kernel_op_55 = tmp_kernel_op_37*uy_dof_4 + tmp_kernel_op_38*uy_dof_5 + tmp_kernel_op_39*uy_dof_6 + tmp_kernel_op_42*uy_dof_1 + tmp_kernel_op_45*uy_dof_2 + tmp_kernel_op_48*uy_dof_3 + tmp_kernel_op_49*uy_dof_7 + tmp_kernel_op_50*uy_dof_8 + tmp_kernel_op_52*uy_dof_9 + tmp_kernel_op_53*uy_dof_0;
             const real_t tmp_kernel_op_56 = tmp_kernel_op_37*uz_dof_4 + tmp_kernel_op_38*uz_dof_5 + tmp_kernel_op_39*uz_dof_6 + tmp_kernel_op_42*uz_dof_1 + tmp_kernel_op_45*uz_dof_2 + tmp_kernel_op_48*uz_dof_3 + tmp_kernel_op_49*uz_dof_7 + tmp_kernel_op_50*uz_dof_8 + tmp_kernel_op_52*uz_dof_9 + tmp_kernel_op_53*uz_dof_0;
             const real_t tmp_kernel_op_57 = abs_det_jac_affine_WHITE_DOWN*abs_det_jac_blending_q_1*(cp_times_delta_dof_0*tmp_kernel_op_53 + cp_times_delta_dof_1*tmp_kernel_op_42 + cp_times_delta_dof_2*tmp_kernel_op_45 + cp_times_delta_dof_3*tmp_kernel_op_48 + cp_times_delta_dof_4*tmp_kernel_op_37 + cp_times_delta_dof_5*tmp_kernel_op_38 + cp_times_delta_dof_6*tmp_kernel_op_39 + cp_times_delta_dof_7*tmp_kernel_op_49 + cp_times_delta_dof_8*tmp_kernel_op_50 + cp_times_delta_dof_9*tmp_kernel_op_52)*0.074999999999999983;
             const real_t tmp_kernel_op_83 = tmp_kernel_op_66*ux_dof_4 + tmp_kernel_op_67*ux_dof_5 + tmp_kernel_op_68*ux_dof_6 + tmp_kernel_op_71*ux_dof_1 + tmp_kernel_op_74*ux_dof_2 + tmp_kernel_op_77*ux_dof_3 + tmp_kernel_op_78*ux_dof_7 + tmp_kernel_op_79*ux_dof_8 + tmp_kernel_op_81*ux_dof_9 + tmp_kernel_op_82*ux_dof_0;
             const real_t tmp_kernel_op_84 = tmp_kernel_op_66*uy_dof_4 + tmp_kernel_op_67*uy_dof_5 + tmp_kernel_op_68*uy_dof_6 + tmp_kernel_op_71*uy_dof_1 + tmp_kernel_op_74*uy_dof_2 + tmp_kernel_op_77*uy_dof_3 + tmp_kernel_op_78*uy_dof_7 + tmp_kernel_op_79*uy_dof_8 + tmp_kernel_op_81*uy_dof_9 + tmp_kernel_op_82*uy_dof_0;
             const real_t tmp_kernel_op_85 = tmp_kernel_op_66*uz_dof_4 + tmp_kernel_op_67*uz_dof_5 + tmp_kernel_op_68*uz_dof_6 + tmp_kernel_op_71*uz_dof_1 + tmp_kernel_op_74*uz_dof_2 + tmp_kernel_op_77*uz_dof_3 + tmp_kernel_op_78*uz_dof_7 + tmp_kernel_op_79*uz_dof_8 + tmp_kernel_op_81*uz_dof_9 + tmp_kernel_op_82*uz_dof_0;
             const real_t tmp_kernel_op_86 = abs_det_jac_affine_WHITE_DOWN*abs_det_jac_blending_q_2*(cp_times_delta_dof_0*tmp_kernel_op_82 + cp_times_delta_dof_1*tmp_kernel_op_71 + cp_times_delta_dof_2*tmp_kernel_op_74 + cp_times_delta_dof_3*tmp_kernel_op_77 + cp_times_delta_dof_4*tmp_kernel_op_66 + cp_times_delta_dof_5*tmp_kernel_op_67 + cp_times_delta_dof_6*tmp_kernel_op_68 + cp_times_delta_dof_7*tmp_kernel_op_78 + cp_times_delta_dof_8*tmp_kernel_op_79 + cp_times_delta_dof_9*tmp_kernel_op_81)*0.074999999999999983;
             const real_t tmp_kernel_op_112 = tmp_kernel_op_100*ux_dof_1 + tmp_kernel_op_103*ux_dof_2 + tmp_kernel_op_106*ux_dof_3 + tmp_kernel_op_107*ux_dof_7 + tmp_kernel_op_108*ux_dof_8 + tmp_kernel_op_110*ux_dof_9 + tmp_kernel_op_111*ux_dof_0 + tmp_kernel_op_95*ux_dof_4 + tmp_kernel_op_96*ux_dof_5 + tmp_kernel_op_97*ux_dof_6;
             const real_t tmp_kernel_op_113 = tmp_kernel_op_100*uy_dof_1 + tmp_kernel_op_103*uy_dof_2 + tmp_kernel_op_106*uy_dof_3 + tmp_kernel_op_107*uy_dof_7 + tmp_kernel_op_108*uy_dof_8 + tmp_kernel_op_110*uy_dof_9 + tmp_kernel_op_111*uy_dof_0 + tmp_kernel_op_95*uy_dof_4 + tmp_kernel_op_96*uy_dof_5 + tmp_kernel_op_97*uy_dof_6;
             const real_t tmp_kernel_op_114 = tmp_kernel_op_100*uz_dof_1 + tmp_kernel_op_103*uz_dof_2 + tmp_kernel_op_106*uz_dof_3 + tmp_kernel_op_107*uz_dof_7 + tmp_kernel_op_108*uz_dof_8 + tmp_kernel_op_110*uz_dof_9 + tmp_kernel_op_111*uz_dof_0 + tmp_kernel_op_95*uz_dof_4 + tmp_kernel_op_96*uz_dof_5 + tmp_kernel_op_97*uz_dof_6;
             const real_t tmp_kernel_op_115 = abs_det_jac_affine_WHITE_DOWN*abs_det_jac_blending_q_3*(cp_times_delta_dof_0*tmp_kernel_op_111 + cp_times_delta_dof_1*tmp_kernel_op_100 + cp_times_delta_dof_2*tmp_kernel_op_103 + cp_times_delta_dof_3*tmp_kernel_op_106 + cp_times_delta_dof_4*tmp_kernel_op_95 + cp_times_delta_dof_5*tmp_kernel_op_96 + cp_times_delta_dof_6*tmp_kernel_op_97 + cp_times_delta_dof_7*tmp_kernel_op_107 + cp_times_delta_dof_8*tmp_kernel_op_108 + cp_times_delta_dof_9*tmp_kernel_op_110)*0.074999999999999983;
             const real_t tmp_kernel_op_141 = tmp_kernel_op_124*ux_dof_4 + tmp_kernel_op_125*ux_dof_5 + tmp_kernel_op_126*ux_dof_6 + tmp_kernel_op_129*ux_dof_1 + tmp_kernel_op_132*ux_dof_2 + tmp_kernel_op_135*ux_dof_3 + tmp_kernel_op_136*ux_dof_7 + tmp_kernel_op_137*ux_dof_8 + tmp_kernel_op_139*ux_dof_9 + tmp_kernel_op_140*ux_dof_0;
             const real_t tmp_kernel_op_142 = tmp_kernel_op_124*uy_dof_4 + tmp_kernel_op_125*uy_dof_5 + tmp_kernel_op_126*uy_dof_6 + tmp_kernel_op_129*uy_dof_1 + tmp_kernel_op_132*uy_dof_2 + tmp_kernel_op_135*uy_dof_3 + tmp_kernel_op_136*uy_dof_7 + tmp_kernel_op_137*uy_dof_8 + tmp_kernel_op_139*uy_dof_9 + tmp_kernel_op_140*uy_dof_0;
             const real_t tmp_kernel_op_143 = tmp_kernel_op_124*uz_dof_4 + tmp_kernel_op_125*uz_dof_5 + tmp_kernel_op_126*uz_dof_6 + tmp_kernel_op_129*uz_dof_1 + tmp_kernel_op_132*uz_dof_2 + tmp_kernel_op_135*uz_dof_3 + tmp_kernel_op_136*uz_dof_7 + tmp_kernel_op_137*uz_dof_8 + tmp_kernel_op_139*uz_dof_9 + tmp_kernel_op_140*uz_dof_0;
             const real_t tmp_kernel_op_144 = abs_det_jac_affine_WHITE_DOWN*abs_det_jac_blending_q_4*(cp_times_delta_dof_0*tmp_kernel_op_140 + cp_times_delta_dof_1*tmp_kernel_op_129 + cp_times_delta_dof_2*tmp_kernel_op_132 + cp_times_delta_dof_3*tmp_kernel_op_135 + cp_times_delta_dof_4*tmp_kernel_op_124 + cp_times_delta_dof_5*tmp_kernel_op_125 + cp_times_delta_dof_6*tmp_kernel_op_126 + cp_times_delta_dof_7*tmp_kernel_op_136 + cp_times_delta_dof_8*tmp_kernel_op_137 + cp_times_delta_dof_9*tmp_kernel_op_139)*0.074999999999999983;
             const real_t elMatDiag_0 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_9 + jac_blending_inv_1_0_q_3*tmp_moved_constant_10 + jac_blending_inv_2_0_q_3*tmp_moved_constant_11) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_9 + jac_blending_inv_1_1_q_3*tmp_moved_constant_10 + jac_blending_inv_2_1_q_3*tmp_moved_constant_11) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_9 + jac_blending_inv_1_2_q_3*tmp_moved_constant_10 + jac_blending_inv_2_2_q_3*tmp_moved_constant_11))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_9 + jac_blending_inv_1_0_q_3*tmp_moved_constant_10 + jac_blending_inv_2_0_q_3*tmp_moved_constant_11) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_9 + jac_blending_inv_1_1_q_3*tmp_moved_constant_10 + jac_blending_inv_2_1_q_3*tmp_moved_constant_11) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_9 + jac_blending_inv_1_2_q_3*tmp_moved_constant_10 + jac_blending_inv_2_2_q_3*tmp_moved_constant_11))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_12 + jac_blending_inv_1_0_q_4*tmp_moved_constant_13 + jac_blending_inv_2_0_q_4*tmp_moved_constant_14) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_12 + jac_blending_inv_1_1_q_4*tmp_moved_constant_13 + jac_blending_inv_2_1_q_4*tmp_moved_constant_14) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_12 + jac_blending_inv_1_2_q_4*tmp_moved_constant_13 + jac_blending_inv_2_2_q_4*tmp_moved_constant_14))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_12 + jac_blending_inv_1_0_q_4*tmp_moved_constant_13 + jac_blending_inv_2_0_q_4*tmp_moved_constant_14) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_12 + jac_blending_inv_1_1_q_4*tmp_moved_constant_13 + jac_blending_inv_2_1_q_4*tmp_moved_constant_14) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_12 + jac_blending_inv_1_2_q_4*tmp_moved_constant_13 + jac_blending_inv_2_2_q_4*tmp_moved_constant_14))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_0 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1 + jac_blending_inv_2_0_q_0*tmp_moved_constant_2) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_0 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1 + jac_blending_inv_2_1_q_0*tmp_moved_constant_2) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_0 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1 + jac_blending_inv_2_2_q_0*tmp_moved_constant_2))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_0 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1 + jac_blending_inv_2_0_q_0*tmp_moved_constant_2) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_0 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1 + jac_blending_inv_2_1_q_0*tmp_moved_constant_2) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_0 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1 + jac_blending_inv_2_2_q_0*tmp_moved_constant_2))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_3 + jac_blending_inv_1_0_q_1*tmp_moved_constant_4 + jac_blending_inv_2_0_q_1*tmp_moved_constant_5) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_3 + jac_blending_inv_1_1_q_1*tmp_moved_constant_4 + jac_blending_inv_2_1_q_1*tmp_moved_constant_5) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_3 + jac_blending_inv_1_2_q_1*tmp_moved_constant_4 + jac_blending_inv_2_2_q_1*tmp_moved_constant_5))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_3 + jac_blending_inv_1_0_q_1*tmp_moved_constant_4 + jac_blending_inv_2_0_q_1*tmp_moved_constant_5) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_3 + jac_blending_inv_1_1_q_1*tmp_moved_constant_4 + jac_blending_inv_2_1_q_1*tmp_moved_constant_5) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_3 + jac_blending_inv_1_2_q_1*tmp_moved_constant_4 + jac_blending_inv_2_2_q_1*tmp_moved_constant_5))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_6 + jac_blending_inv_1_0_q_2*tmp_moved_constant_7 + jac_blending_inv_2_0_q_2*tmp_moved_constant_8) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_6 + jac_blending_inv_1_1_q_2*tmp_moved_constant_7 + jac_blending_inv_2_1_q_2*tmp_moved_constant_8) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_6 + jac_blending_inv_1_2_q_2*tmp_moved_constant_7 + jac_blending_inv_2_2_q_2*tmp_moved_constant_8))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_6 + jac_blending_inv_1_0_q_2*tmp_moved_constant_7 + jac_blending_inv_2_0_q_2*tmp_moved_constant_8) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_6 + jac_blending_inv_1_1_q_2*tmp_moved_constant_7 + jac_blending_inv_2_1_q_2*tmp_moved_constant_8) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_6 + jac_blending_inv_1_2_q_2*tmp_moved_constant_7 + jac_blending_inv_2_2_q_2*tmp_moved_constant_8)));
             const real_t elMatDiag_1 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_24 + jac_blending_inv_1_0_q_3*tmp_moved_constant_25 + jac_blending_inv_2_0_q_3*tmp_moved_constant_26) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_24 + jac_blending_inv_1_1_q_3*tmp_moved_constant_25 + jac_blending_inv_2_1_q_3*tmp_moved_constant_26) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_24 + jac_blending_inv_1_2_q_3*tmp_moved_constant_25 + jac_blending_inv_2_2_q_3*tmp_moved_constant_26))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_24 + jac_blending_inv_1_0_q_3*tmp_moved_constant_25 + jac_blending_inv_2_0_q_3*tmp_moved_constant_26) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_24 + jac_blending_inv_1_1_q_3*tmp_moved_constant_25 + jac_blending_inv_2_1_q_3*tmp_moved_constant_26) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_24 + jac_blending_inv_1_2_q_3*tmp_moved_constant_25 + jac_blending_inv_2_2_q_3*tmp_moved_constant_26))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_27 + jac_blending_inv_1_0_q_4*tmp_moved_constant_28 + jac_blending_inv_2_0_q_4*tmp_moved_constant_29) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_27 + jac_blending_inv_1_1_q_4*tmp_moved_constant_28 + jac_blending_inv_2_1_q_4*tmp_moved_constant_29) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_27 + jac_blending_inv_1_2_q_4*tmp_moved_constant_28 + jac_blending_inv_2_2_q_4*tmp_moved_constant_29))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_27 + jac_blending_inv_1_0_q_4*tmp_moved_constant_28 + jac_blending_inv_2_0_q_4*tmp_moved_constant_29) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_27 + jac_blending_inv_1_1_q_4*tmp_moved_constant_28 + jac_blending_inv_2_1_q_4*tmp_moved_constant_29) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_27 + jac_blending_inv_1_2_q_4*tmp_moved_constant_28 + jac_blending_inv_2_2_q_4*tmp_moved_constant_29))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_15 + jac_blending_inv_1_0_q_0*tmp_moved_constant_16 + jac_blending_inv_2_0_q_0*tmp_moved_constant_17) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_15 + jac_blending_inv_1_1_q_0*tmp_moved_constant_16 + jac_blending_inv_2_1_q_0*tmp_moved_constant_17) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_15 + jac_blending_inv_1_2_q_0*tmp_moved_constant_16 + jac_blending_inv_2_2_q_0*tmp_moved_constant_17))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_15 + jac_blending_inv_1_0_q_0*tmp_moved_constant_16 + jac_blending_inv_2_0_q_0*tmp_moved_constant_17) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_15 + jac_blending_inv_1_1_q_0*tmp_moved_constant_16 + jac_blending_inv_2_1_q_0*tmp_moved_constant_17) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_15 + jac_blending_inv_1_2_q_0*tmp_moved_constant_16 + jac_blending_inv_2_2_q_0*tmp_moved_constant_17))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_18 + jac_blending_inv_1_0_q_1*tmp_moved_constant_19 + jac_blending_inv_2_0_q_1*tmp_moved_constant_20) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_18 + jac_blending_inv_1_1_q_1*tmp_moved_constant_19 + jac_blending_inv_2_1_q_1*tmp_moved_constant_20) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_18 + jac_blending_inv_1_2_q_1*tmp_moved_constant_19 + jac_blending_inv_2_2_q_1*tmp_moved_constant_20))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_18 + jac_blending_inv_1_0_q_1*tmp_moved_constant_19 + jac_blending_inv_2_0_q_1*tmp_moved_constant_20) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_18 + jac_blending_inv_1_1_q_1*tmp_moved_constant_19 + jac_blending_inv_2_1_q_1*tmp_moved_constant_20) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_18 + jac_blending_inv_1_2_q_1*tmp_moved_constant_19 + jac_blending_inv_2_2_q_1*tmp_moved_constant_20))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_21 + jac_blending_inv_1_0_q_2*tmp_moved_constant_22 + jac_blending_inv_2_0_q_2*tmp_moved_constant_23) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_21 + jac_blending_inv_1_1_q_2*tmp_moved_constant_22 + jac_blending_inv_2_1_q_2*tmp_moved_constant_23) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_21 + jac_blending_inv_1_2_q_2*tmp_moved_constant_22 + jac_blending_inv_2_2_q_2*tmp_moved_constant_23))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_21 + jac_blending_inv_1_0_q_2*tmp_moved_constant_22 + jac_blending_inv_2_0_q_2*tmp_moved_constant_23) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_21 + jac_blending_inv_1_1_q_2*tmp_moved_constant_22 + jac_blending_inv_2_1_q_2*tmp_moved_constant_23) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_21 + jac_blending_inv_1_2_q_2*tmp_moved_constant_22 + jac_blending_inv_2_2_q_2*tmp_moved_constant_23)));
             const real_t elMatDiag_2 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_39 + jac_blending_inv_1_0_q_3*tmp_moved_constant_40 + jac_blending_inv_2_0_q_3*tmp_moved_constant_41) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_39 + jac_blending_inv_1_1_q_3*tmp_moved_constant_40 + jac_blending_inv_2_1_q_3*tmp_moved_constant_41) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_39 + jac_blending_inv_1_2_q_3*tmp_moved_constant_40 + jac_blending_inv_2_2_q_3*tmp_moved_constant_41))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_39 + jac_blending_inv_1_0_q_3*tmp_moved_constant_40 + jac_blending_inv_2_0_q_3*tmp_moved_constant_41) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_39 + jac_blending_inv_1_1_q_3*tmp_moved_constant_40 + jac_blending_inv_2_1_q_3*tmp_moved_constant_41) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_39 + jac_blending_inv_1_2_q_3*tmp_moved_constant_40 + jac_blending_inv_2_2_q_3*tmp_moved_constant_41))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_42 + jac_blending_inv_1_0_q_4*tmp_moved_constant_43 + jac_blending_inv_2_0_q_4*tmp_moved_constant_44) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_42 + jac_blending_inv_1_1_q_4*tmp_moved_constant_43 + jac_blending_inv_2_1_q_4*tmp_moved_constant_44) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_42 + jac_blending_inv_1_2_q_4*tmp_moved_constant_43 + jac_blending_inv_2_2_q_4*tmp_moved_constant_44))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_42 + jac_blending_inv_1_0_q_4*tmp_moved_constant_43 + jac_blending_inv_2_0_q_4*tmp_moved_constant_44) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_42 + jac_blending_inv_1_1_q_4*tmp_moved_constant_43 + jac_blending_inv_2_1_q_4*tmp_moved_constant_44) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_42 + jac_blending_inv_1_2_q_4*tmp_moved_constant_43 + jac_blending_inv_2_2_q_4*tmp_moved_constant_44))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_30 + jac_blending_inv_1_0_q_0*tmp_moved_constant_31 + jac_blending_inv_2_0_q_0*tmp_moved_constant_32) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_30 + jac_blending_inv_1_1_q_0*tmp_moved_constant_31 + jac_blending_inv_2_1_q_0*tmp_moved_constant_32) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_30 + jac_blending_inv_1_2_q_0*tmp_moved_constant_31 + jac_blending_inv_2_2_q_0*tmp_moved_constant_32))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_30 + jac_blending_inv_1_0_q_0*tmp_moved_constant_31 + jac_blending_inv_2_0_q_0*tmp_moved_constant_32) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_30 + jac_blending_inv_1_1_q_0*tmp_moved_constant_31 + jac_blending_inv_2_1_q_0*tmp_moved_constant_32) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_30 + jac_blending_inv_1_2_q_0*tmp_moved_constant_31 + jac_blending_inv_2_2_q_0*tmp_moved_constant_32))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_33 + jac_blending_inv_1_0_q_1*tmp_moved_constant_34 + jac_blending_inv_2_0_q_1*tmp_moved_constant_35) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_33 + jac_blending_inv_1_1_q_1*tmp_moved_constant_34 + jac_blending_inv_2_1_q_1*tmp_moved_constant_35) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_33 + jac_blending_inv_1_2_q_1*tmp_moved_constant_34 + jac_blending_inv_2_2_q_1*tmp_moved_constant_35))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_33 + jac_blending_inv_1_0_q_1*tmp_moved_constant_34 + jac_blending_inv_2_0_q_1*tmp_moved_constant_35) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_33 + jac_blending_inv_1_1_q_1*tmp_moved_constant_34 + jac_blending_inv_2_1_q_1*tmp_moved_constant_35) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_33 + jac_blending_inv_1_2_q_1*tmp_moved_constant_34 + jac_blending_inv_2_2_q_1*tmp_moved_constant_35))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_36 + jac_blending_inv_1_0_q_2*tmp_moved_constant_37 + jac_blending_inv_2_0_q_2*tmp_moved_constant_38) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_36 + jac_blending_inv_1_1_q_2*tmp_moved_constant_37 + jac_blending_inv_2_1_q_2*tmp_moved_constant_38) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_36 + jac_blending_inv_1_2_q_2*tmp_moved_constant_37 + jac_blending_inv_2_2_q_2*tmp_moved_constant_38))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_36 + jac_blending_inv_1_0_q_2*tmp_moved_constant_37 + jac_blending_inv_2_0_q_2*tmp_moved_constant_38) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_36 + jac_blending_inv_1_1_q_2*tmp_moved_constant_37 + jac_blending_inv_2_1_q_2*tmp_moved_constant_38) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_36 + jac_blending_inv_1_2_q_2*tmp_moved_constant_37 + jac_blending_inv_2_2_q_2*tmp_moved_constant_38)));
             const real_t elMatDiag_3 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_54 + jac_blending_inv_1_0_q_3*tmp_moved_constant_55 + jac_blending_inv_2_0_q_3*tmp_moved_constant_56) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_54 + jac_blending_inv_1_1_q_3*tmp_moved_constant_55 + jac_blending_inv_2_1_q_3*tmp_moved_constant_56) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_54 + jac_blending_inv_1_2_q_3*tmp_moved_constant_55 + jac_blending_inv_2_2_q_3*tmp_moved_constant_56))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_54 + jac_blending_inv_1_0_q_3*tmp_moved_constant_55 + jac_blending_inv_2_0_q_3*tmp_moved_constant_56) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_54 + jac_blending_inv_1_1_q_3*tmp_moved_constant_55 + jac_blending_inv_2_1_q_3*tmp_moved_constant_56) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_54 + jac_blending_inv_1_2_q_3*tmp_moved_constant_55 + jac_blending_inv_2_2_q_3*tmp_moved_constant_56))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_57 + jac_blending_inv_1_0_q_4*tmp_moved_constant_58 + jac_blending_inv_2_0_q_4*tmp_moved_constant_59) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_57 + jac_blending_inv_1_1_q_4*tmp_moved_constant_58 + jac_blending_inv_2_1_q_4*tmp_moved_constant_59) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_57 + jac_blending_inv_1_2_q_4*tmp_moved_constant_58 + jac_blending_inv_2_2_q_4*tmp_moved_constant_59))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_57 + jac_blending_inv_1_0_q_4*tmp_moved_constant_58 + jac_blending_inv_2_0_q_4*tmp_moved_constant_59) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_57 + jac_blending_inv_1_1_q_4*tmp_moved_constant_58 + jac_blending_inv_2_1_q_4*tmp_moved_constant_59) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_57 + jac_blending_inv_1_2_q_4*tmp_moved_constant_58 + jac_blending_inv_2_2_q_4*tmp_moved_constant_59))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_45 + jac_blending_inv_1_0_q_0*tmp_moved_constant_46 + jac_blending_inv_2_0_q_0*tmp_moved_constant_47) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_45 + jac_blending_inv_1_1_q_0*tmp_moved_constant_46 + jac_blending_inv_2_1_q_0*tmp_moved_constant_47) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_45 + jac_blending_inv_1_2_q_0*tmp_moved_constant_46 + jac_blending_inv_2_2_q_0*tmp_moved_constant_47))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_45 + jac_blending_inv_1_0_q_0*tmp_moved_constant_46 + jac_blending_inv_2_0_q_0*tmp_moved_constant_47) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_45 + jac_blending_inv_1_1_q_0*tmp_moved_constant_46 + jac_blending_inv_2_1_q_0*tmp_moved_constant_47) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_45 + jac_blending_inv_1_2_q_0*tmp_moved_constant_46 + jac_blending_inv_2_2_q_0*tmp_moved_constant_47))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_48 + jac_blending_inv_1_0_q_1*tmp_moved_constant_49 + jac_blending_inv_2_0_q_1*tmp_moved_constant_50) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_48 + jac_blending_inv_1_1_q_1*tmp_moved_constant_49 + jac_blending_inv_2_1_q_1*tmp_moved_constant_50) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_48 + jac_blending_inv_1_2_q_1*tmp_moved_constant_49 + jac_blending_inv_2_2_q_1*tmp_moved_constant_50))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_48 + jac_blending_inv_1_0_q_1*tmp_moved_constant_49 + jac_blending_inv_2_0_q_1*tmp_moved_constant_50) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_48 + jac_blending_inv_1_1_q_1*tmp_moved_constant_49 + jac_blending_inv_2_1_q_1*tmp_moved_constant_50) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_48 + jac_blending_inv_1_2_q_1*tmp_moved_constant_49 + jac_blending_inv_2_2_q_1*tmp_moved_constant_50))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_51 + jac_blending_inv_1_0_q_2*tmp_moved_constant_52 + jac_blending_inv_2_0_q_2*tmp_moved_constant_53) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_51 + jac_blending_inv_1_1_q_2*tmp_moved_constant_52 + jac_blending_inv_2_1_q_2*tmp_moved_constant_53) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_51 + jac_blending_inv_1_2_q_2*tmp_moved_constant_52 + jac_blending_inv_2_2_q_2*tmp_moved_constant_53))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_51 + jac_blending_inv_1_0_q_2*tmp_moved_constant_52 + jac_blending_inv_2_0_q_2*tmp_moved_constant_53) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_51 + jac_blending_inv_1_1_q_2*tmp_moved_constant_52 + jac_blending_inv_2_1_q_2*tmp_moved_constant_53) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_51 + jac_blending_inv_1_2_q_2*tmp_moved_constant_52 + jac_blending_inv_2_2_q_2*tmp_moved_constant_53)));
             const real_t elMatDiag_4 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_89 + jac_blending_inv_1_0_q_3*tmp_moved_constant_92 + jac_blending_inv_2_0_q_3*tmp_moved_constant_95) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_89 + jac_blending_inv_1_1_q_3*tmp_moved_constant_92 + jac_blending_inv_2_1_q_3*tmp_moved_constant_95) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_89 + jac_blending_inv_1_2_q_3*tmp_moved_constant_92 + jac_blending_inv_2_2_q_3*tmp_moved_constant_95))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_89 + jac_blending_inv_1_0_q_3*tmp_moved_constant_92 + jac_blending_inv_2_0_q_3*tmp_moved_constant_95) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_89 + jac_blending_inv_1_1_q_3*tmp_moved_constant_92 + jac_blending_inv_2_1_q_3*tmp_moved_constant_95) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_89 + jac_blending_inv_1_2_q_3*tmp_moved_constant_92 + jac_blending_inv_2_2_q_3*tmp_moved_constant_95))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_98 + jac_blending_inv_1_0_q_4*tmp_moved_constant_101 + jac_blending_inv_2_0_q_4*tmp_moved_constant_104) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_98 + jac_blending_inv_1_1_q_4*tmp_moved_constant_101 + jac_blending_inv_2_1_q_4*tmp_moved_constant_104) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_98 + jac_blending_inv_1_2_q_4*tmp_moved_constant_101 + jac_blending_inv_2_2_q_4*tmp_moved_constant_104))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_98 + jac_blending_inv_1_0_q_4*tmp_moved_constant_101 + jac_blending_inv_2_0_q_4*tmp_moved_constant_104) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_98 + jac_blending_inv_1_1_q_4*tmp_moved_constant_101 + jac_blending_inv_2_1_q_4*tmp_moved_constant_104) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_98 + jac_blending_inv_1_2_q_4*tmp_moved_constant_101 + jac_blending_inv_2_2_q_4*tmp_moved_constant_104))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_62 + jac_blending_inv_1_0_q_0*tmp_moved_constant_65 + jac_blending_inv_2_0_q_0*tmp_moved_constant_68) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_62 + jac_blending_inv_1_1_q_0*tmp_moved_constant_65 + jac_blending_inv_2_1_q_0*tmp_moved_constant_68) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_62 + jac_blending_inv_1_2_q_0*tmp_moved_constant_65 + jac_blending_inv_2_2_q_0*tmp_moved_constant_68))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_62 + jac_blending_inv_1_0_q_0*tmp_moved_constant_65 + jac_blending_inv_2_0_q_0*tmp_moved_constant_68) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_62 + jac_blending_inv_1_1_q_0*tmp_moved_constant_65 + jac_blending_inv_2_1_q_0*tmp_moved_constant_68) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_62 + jac_blending_inv_1_2_q_0*tmp_moved_constant_65 + jac_blending_inv_2_2_q_0*tmp_moved_constant_68))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_71 + jac_blending_inv_1_0_q_1*tmp_moved_constant_74 + jac_blending_inv_2_0_q_1*tmp_moved_constant_77) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_71 + jac_blending_inv_1_1_q_1*tmp_moved_constant_74 + jac_blending_inv_2_1_q_1*tmp_moved_constant_77) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_71 + jac_blending_inv_1_2_q_1*tmp_moved_constant_74 + jac_blending_inv_2_2_q_1*tmp_moved_constant_77))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_71 + jac_blending_inv_1_0_q_1*tmp_moved_constant_74 + jac_blending_inv_2_0_q_1*tmp_moved_constant_77) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_71 + jac_blending_inv_1_1_q_1*tmp_moved_constant_74 + jac_blending_inv_2_1_q_1*tmp_moved_constant_77) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_71 + jac_blending_inv_1_2_q_1*tmp_moved_constant_74 + jac_blending_inv_2_2_q_1*tmp_moved_constant_77))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_80 + jac_blending_inv_1_0_q_2*tmp_moved_constant_83 + jac_blending_inv_2_0_q_2*tmp_moved_constant_86) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_80 + jac_blending_inv_1_1_q_2*tmp_moved_constant_83 + jac_blending_inv_2_1_q_2*tmp_moved_constant_86) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_80 + jac_blending_inv_1_2_q_2*tmp_moved_constant_83 + jac_blending_inv_2_2_q_2*tmp_moved_constant_86))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_80 + jac_blending_inv_1_0_q_2*tmp_moved_constant_83 + jac_blending_inv_2_0_q_2*tmp_moved_constant_86) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_80 + jac_blending_inv_1_1_q_2*tmp_moved_constant_83 + jac_blending_inv_2_1_q_2*tmp_moved_constant_86) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_80 + jac_blending_inv_1_2_q_2*tmp_moved_constant_83 + jac_blending_inv_2_2_q_2*tmp_moved_constant_86)));
             const real_t elMatDiag_5 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_134 + jac_blending_inv_1_0_q_3*tmp_moved_constant_137 + jac_blending_inv_2_0_q_3*tmp_moved_constant_140) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_134 + jac_blending_inv_1_1_q_3*tmp_moved_constant_137 + jac_blending_inv_2_1_q_3*tmp_moved_constant_140) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_134 + jac_blending_inv_1_2_q_3*tmp_moved_constant_137 + jac_blending_inv_2_2_q_3*tmp_moved_constant_140))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_134 + jac_blending_inv_1_0_q_3*tmp_moved_constant_137 + jac_blending_inv_2_0_q_3*tmp_moved_constant_140) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_134 + jac_blending_inv_1_1_q_3*tmp_moved_constant_137 + jac_blending_inv_2_1_q_3*tmp_moved_constant_140) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_134 + jac_blending_inv_1_2_q_3*tmp_moved_constant_137 + jac_blending_inv_2_2_q_3*tmp_moved_constant_140))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_143 + jac_blending_inv_1_0_q_4*tmp_moved_constant_146 + jac_blending_inv_2_0_q_4*tmp_moved_constant_149) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_143 + jac_blending_inv_1_1_q_4*tmp_moved_constant_146 + jac_blending_inv_2_1_q_4*tmp_moved_constant_149) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_143 + jac_blending_inv_1_2_q_4*tmp_moved_constant_146 + jac_blending_inv_2_2_q_4*tmp_moved_constant_149))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_143 + jac_blending_inv_1_0_q_4*tmp_moved_constant_146 + jac_blending_inv_2_0_q_4*tmp_moved_constant_149) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_143 + jac_blending_inv_1_1_q_4*tmp_moved_constant_146 + jac_blending_inv_2_1_q_4*tmp_moved_constant_149) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_143 + jac_blending_inv_1_2_q_4*tmp_moved_constant_146 + jac_blending_inv_2_2_q_4*tmp_moved_constant_149))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_107 + jac_blending_inv_1_0_q_0*tmp_moved_constant_110 + jac_blending_inv_2_0_q_0*tmp_moved_constant_113) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_107 + jac_blending_inv_1_1_q_0*tmp_moved_constant_110 + jac_blending_inv_2_1_q_0*tmp_moved_constant_113) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_107 + jac_blending_inv_1_2_q_0*tmp_moved_constant_110 + jac_blending_inv_2_2_q_0*tmp_moved_constant_113))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_107 + jac_blending_inv_1_0_q_0*tmp_moved_constant_110 + jac_blending_inv_2_0_q_0*tmp_moved_constant_113) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_107 + jac_blending_inv_1_1_q_0*tmp_moved_constant_110 + jac_blending_inv_2_1_q_0*tmp_moved_constant_113) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_107 + jac_blending_inv_1_2_q_0*tmp_moved_constant_110 + jac_blending_inv_2_2_q_0*tmp_moved_constant_113))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_116 + jac_blending_inv_1_0_q_1*tmp_moved_constant_119 + jac_blending_inv_2_0_q_1*tmp_moved_constant_122) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_116 + jac_blending_inv_1_1_q_1*tmp_moved_constant_119 + jac_blending_inv_2_1_q_1*tmp_moved_constant_122) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_116 + jac_blending_inv_1_2_q_1*tmp_moved_constant_119 + jac_blending_inv_2_2_q_1*tmp_moved_constant_122))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_116 + jac_blending_inv_1_0_q_1*tmp_moved_constant_119 + jac_blending_inv_2_0_q_1*tmp_moved_constant_122) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_116 + jac_blending_inv_1_1_q_1*tmp_moved_constant_119 + jac_blending_inv_2_1_q_1*tmp_moved_constant_122) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_116 + jac_blending_inv_1_2_q_1*tmp_moved_constant_119 + jac_blending_inv_2_2_q_1*tmp_moved_constant_122))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_125 + jac_blending_inv_1_0_q_2*tmp_moved_constant_128 + jac_blending_inv_2_0_q_2*tmp_moved_constant_131) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_125 + jac_blending_inv_1_1_q_2*tmp_moved_constant_128 + jac_blending_inv_2_1_q_2*tmp_moved_constant_131) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_125 + jac_blending_inv_1_2_q_2*tmp_moved_constant_128 + jac_blending_inv_2_2_q_2*tmp_moved_constant_131))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_125 + jac_blending_inv_1_0_q_2*tmp_moved_constant_128 + jac_blending_inv_2_0_q_2*tmp_moved_constant_131) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_125 + jac_blending_inv_1_1_q_2*tmp_moved_constant_128 + jac_blending_inv_2_1_q_2*tmp_moved_constant_131) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_125 + jac_blending_inv_1_2_q_2*tmp_moved_constant_128 + jac_blending_inv_2_2_q_2*tmp_moved_constant_131)));
             const real_t elMatDiag_6 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_179 + jac_blending_inv_1_0_q_3*tmp_moved_constant_182 + jac_blending_inv_2_0_q_3*tmp_moved_constant_185) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_179 + jac_blending_inv_1_1_q_3*tmp_moved_constant_182 + jac_blending_inv_2_1_q_3*tmp_moved_constant_185) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_179 + jac_blending_inv_1_2_q_3*tmp_moved_constant_182 + jac_blending_inv_2_2_q_3*tmp_moved_constant_185))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_179 + jac_blending_inv_1_0_q_3*tmp_moved_constant_182 + jac_blending_inv_2_0_q_3*tmp_moved_constant_185) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_179 + jac_blending_inv_1_1_q_3*tmp_moved_constant_182 + jac_blending_inv_2_1_q_3*tmp_moved_constant_185) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_179 + jac_blending_inv_1_2_q_3*tmp_moved_constant_182 + jac_blending_inv_2_2_q_3*tmp_moved_constant_185))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_188 + jac_blending_inv_1_0_q_4*tmp_moved_constant_191 + jac_blending_inv_2_0_q_4*tmp_moved_constant_194) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_188 + jac_blending_inv_1_1_q_4*tmp_moved_constant_191 + jac_blending_inv_2_1_q_4*tmp_moved_constant_194) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_188 + jac_blending_inv_1_2_q_4*tmp_moved_constant_191 + jac_blending_inv_2_2_q_4*tmp_moved_constant_194))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_188 + jac_blending_inv_1_0_q_4*tmp_moved_constant_191 + jac_blending_inv_2_0_q_4*tmp_moved_constant_194) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_188 + jac_blending_inv_1_1_q_4*tmp_moved_constant_191 + jac_blending_inv_2_1_q_4*tmp_moved_constant_194) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_188 + jac_blending_inv_1_2_q_4*tmp_moved_constant_191 + jac_blending_inv_2_2_q_4*tmp_moved_constant_194))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_152 + jac_blending_inv_1_0_q_0*tmp_moved_constant_155 + jac_blending_inv_2_0_q_0*tmp_moved_constant_158) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_152 + jac_blending_inv_1_1_q_0*tmp_moved_constant_155 + jac_blending_inv_2_1_q_0*tmp_moved_constant_158) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_152 + jac_blending_inv_1_2_q_0*tmp_moved_constant_155 + jac_blending_inv_2_2_q_0*tmp_moved_constant_158))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_152 + jac_blending_inv_1_0_q_0*tmp_moved_constant_155 + jac_blending_inv_2_0_q_0*tmp_moved_constant_158) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_152 + jac_blending_inv_1_1_q_0*tmp_moved_constant_155 + jac_blending_inv_2_1_q_0*tmp_moved_constant_158) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_152 + jac_blending_inv_1_2_q_0*tmp_moved_constant_155 + jac_blending_inv_2_2_q_0*tmp_moved_constant_158))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_161 + jac_blending_inv_1_0_q_1*tmp_moved_constant_164 + jac_blending_inv_2_0_q_1*tmp_moved_constant_167) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_161 + jac_blending_inv_1_1_q_1*tmp_moved_constant_164 + jac_blending_inv_2_1_q_1*tmp_moved_constant_167) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_161 + jac_blending_inv_1_2_q_1*tmp_moved_constant_164 + jac_blending_inv_2_2_q_1*tmp_moved_constant_167))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_161 + jac_blending_inv_1_0_q_1*tmp_moved_constant_164 + jac_blending_inv_2_0_q_1*tmp_moved_constant_167) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_161 + jac_blending_inv_1_1_q_1*tmp_moved_constant_164 + jac_blending_inv_2_1_q_1*tmp_moved_constant_167) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_161 + jac_blending_inv_1_2_q_1*tmp_moved_constant_164 + jac_blending_inv_2_2_q_1*tmp_moved_constant_167))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_170 + jac_blending_inv_1_0_q_2*tmp_moved_constant_173 + jac_blending_inv_2_0_q_2*tmp_moved_constant_176) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_170 + jac_blending_inv_1_1_q_2*tmp_moved_constant_173 + jac_blending_inv_2_1_q_2*tmp_moved_constant_176) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_170 + jac_blending_inv_1_2_q_2*tmp_moved_constant_173 + jac_blending_inv_2_2_q_2*tmp_moved_constant_176))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_170 + jac_blending_inv_1_0_q_2*tmp_moved_constant_173 + jac_blending_inv_2_0_q_2*tmp_moved_constant_176) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_170 + jac_blending_inv_1_1_q_2*tmp_moved_constant_173 + jac_blending_inv_2_1_q_2*tmp_moved_constant_176) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_170 + jac_blending_inv_1_2_q_2*tmp_moved_constant_173 + jac_blending_inv_2_2_q_2*tmp_moved_constant_176)));
             const real_t elMatDiag_7 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_204 + jac_blending_inv_1_0_q_3*tmp_moved_constant_205 + jac_blending_inv_2_0_q_3*tmp_moved_constant_206) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_204 + jac_blending_inv_1_1_q_3*tmp_moved_constant_205 + jac_blending_inv_2_1_q_3*tmp_moved_constant_206) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_204 + jac_blending_inv_1_2_q_3*tmp_moved_constant_205 + jac_blending_inv_2_2_q_3*tmp_moved_constant_206))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_204 + jac_blending_inv_1_0_q_3*tmp_moved_constant_205 + jac_blending_inv_2_0_q_3*tmp_moved_constant_206) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_204 + jac_blending_inv_1_1_q_3*tmp_moved_constant_205 + jac_blending_inv_2_1_q_3*tmp_moved_constant_206) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_204 + jac_blending_inv_1_2_q_3*tmp_moved_constant_205 + jac_blending_inv_2_2_q_3*tmp_moved_constant_206))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_207 + jac_blending_inv_1_0_q_4*tmp_moved_constant_208 + jac_blending_inv_2_0_q_4*tmp_moved_constant_209) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_207 + jac_blending_inv_1_1_q_4*tmp_moved_constant_208 + jac_blending_inv_2_1_q_4*tmp_moved_constant_209) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_207 + jac_blending_inv_1_2_q_4*tmp_moved_constant_208 + jac_blending_inv_2_2_q_4*tmp_moved_constant_209))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_207 + jac_blending_inv_1_0_q_4*tmp_moved_constant_208 + jac_blending_inv_2_0_q_4*tmp_moved_constant_209) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_207 + jac_blending_inv_1_1_q_4*tmp_moved_constant_208 + jac_blending_inv_2_1_q_4*tmp_moved_constant_209) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_207 + jac_blending_inv_1_2_q_4*tmp_moved_constant_208 + jac_blending_inv_2_2_q_4*tmp_moved_constant_209))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_195 + jac_blending_inv_1_0_q_0*tmp_moved_constant_196 + jac_blending_inv_2_0_q_0*tmp_moved_constant_197) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_195 + jac_blending_inv_1_1_q_0*tmp_moved_constant_196 + jac_blending_inv_2_1_q_0*tmp_moved_constant_197) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_195 + jac_blending_inv_1_2_q_0*tmp_moved_constant_196 + jac_blending_inv_2_2_q_0*tmp_moved_constant_197))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_195 + jac_blending_inv_1_0_q_0*tmp_moved_constant_196 + jac_blending_inv_2_0_q_0*tmp_moved_constant_197) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_195 + jac_blending_inv_1_1_q_0*tmp_moved_constant_196 + jac_blending_inv_2_1_q_0*tmp_moved_constant_197) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_195 + jac_blending_inv_1_2_q_0*tmp_moved_constant_196 + jac_blending_inv_2_2_q_0*tmp_moved_constant_197))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_198 + jac_blending_inv_1_0_q_1*tmp_moved_constant_199 + jac_blending_inv_2_0_q_1*tmp_moved_constant_200) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_198 + jac_blending_inv_1_1_q_1*tmp_moved_constant_199 + jac_blending_inv_2_1_q_1*tmp_moved_constant_200) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_198 + jac_blending_inv_1_2_q_1*tmp_moved_constant_199 + jac_blending_inv_2_2_q_1*tmp_moved_constant_200))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_198 + jac_blending_inv_1_0_q_1*tmp_moved_constant_199 + jac_blending_inv_2_0_q_1*tmp_moved_constant_200) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_198 + jac_blending_inv_1_1_q_1*tmp_moved_constant_199 + jac_blending_inv_2_1_q_1*tmp_moved_constant_200) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_198 + jac_blending_inv_1_2_q_1*tmp_moved_constant_199 + jac_blending_inv_2_2_q_1*tmp_moved_constant_200))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_201 + jac_blending_inv_1_0_q_2*tmp_moved_constant_202 + jac_blending_inv_2_0_q_2*tmp_moved_constant_203) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_201 + jac_blending_inv_1_1_q_2*tmp_moved_constant_202 + jac_blending_inv_2_1_q_2*tmp_moved_constant_203) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_201 + jac_blending_inv_1_2_q_2*tmp_moved_constant_202 + jac_blending_inv_2_2_q_2*tmp_moved_constant_203))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_201 + jac_blending_inv_1_0_q_2*tmp_moved_constant_202 + jac_blending_inv_2_0_q_2*tmp_moved_constant_203) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_201 + jac_blending_inv_1_1_q_2*tmp_moved_constant_202 + jac_blending_inv_2_1_q_2*tmp_moved_constant_203) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_201 + jac_blending_inv_1_2_q_2*tmp_moved_constant_202 + jac_blending_inv_2_2_q_2*tmp_moved_constant_203)));
             const real_t elMatDiag_8 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_219 + jac_blending_inv_1_0_q_3*tmp_moved_constant_220 + jac_blending_inv_2_0_q_3*tmp_moved_constant_221) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_219 + jac_blending_inv_1_1_q_3*tmp_moved_constant_220 + jac_blending_inv_2_1_q_3*tmp_moved_constant_221) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_219 + jac_blending_inv_1_2_q_3*tmp_moved_constant_220 + jac_blending_inv_2_2_q_3*tmp_moved_constant_221))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_219 + jac_blending_inv_1_0_q_3*tmp_moved_constant_220 + jac_blending_inv_2_0_q_3*tmp_moved_constant_221) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_219 + jac_blending_inv_1_1_q_3*tmp_moved_constant_220 + jac_blending_inv_2_1_q_3*tmp_moved_constant_221) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_219 + jac_blending_inv_1_2_q_3*tmp_moved_constant_220 + jac_blending_inv_2_2_q_3*tmp_moved_constant_221))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_222 + jac_blending_inv_1_0_q_4*tmp_moved_constant_223 + jac_blending_inv_2_0_q_4*tmp_moved_constant_224) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_222 + jac_blending_inv_1_1_q_4*tmp_moved_constant_223 + jac_blending_inv_2_1_q_4*tmp_moved_constant_224) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_222 + jac_blending_inv_1_2_q_4*tmp_moved_constant_223 + jac_blending_inv_2_2_q_4*tmp_moved_constant_224))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_222 + jac_blending_inv_1_0_q_4*tmp_moved_constant_223 + jac_blending_inv_2_0_q_4*tmp_moved_constant_224) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_222 + jac_blending_inv_1_1_q_4*tmp_moved_constant_223 + jac_blending_inv_2_1_q_4*tmp_moved_constant_224) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_222 + jac_blending_inv_1_2_q_4*tmp_moved_constant_223 + jac_blending_inv_2_2_q_4*tmp_moved_constant_224))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_210 + jac_blending_inv_1_0_q_0*tmp_moved_constant_211 + jac_blending_inv_2_0_q_0*tmp_moved_constant_212) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_210 + jac_blending_inv_1_1_q_0*tmp_moved_constant_211 + jac_blending_inv_2_1_q_0*tmp_moved_constant_212) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_210 + jac_blending_inv_1_2_q_0*tmp_moved_constant_211 + jac_blending_inv_2_2_q_0*tmp_moved_constant_212))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_210 + jac_blending_inv_1_0_q_0*tmp_moved_constant_211 + jac_blending_inv_2_0_q_0*tmp_moved_constant_212) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_210 + jac_blending_inv_1_1_q_0*tmp_moved_constant_211 + jac_blending_inv_2_1_q_0*tmp_moved_constant_212) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_210 + jac_blending_inv_1_2_q_0*tmp_moved_constant_211 + jac_blending_inv_2_2_q_0*tmp_moved_constant_212))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_213 + jac_blending_inv_1_0_q_1*tmp_moved_constant_214 + jac_blending_inv_2_0_q_1*tmp_moved_constant_215) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_213 + jac_blending_inv_1_1_q_1*tmp_moved_constant_214 + jac_blending_inv_2_1_q_1*tmp_moved_constant_215) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_213 + jac_blending_inv_1_2_q_1*tmp_moved_constant_214 + jac_blending_inv_2_2_q_1*tmp_moved_constant_215))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_213 + jac_blending_inv_1_0_q_1*tmp_moved_constant_214 + jac_blending_inv_2_0_q_1*tmp_moved_constant_215) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_213 + jac_blending_inv_1_1_q_1*tmp_moved_constant_214 + jac_blending_inv_2_1_q_1*tmp_moved_constant_215) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_213 + jac_blending_inv_1_2_q_1*tmp_moved_constant_214 + jac_blending_inv_2_2_q_1*tmp_moved_constant_215))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_216 + jac_blending_inv_1_0_q_2*tmp_moved_constant_217 + jac_blending_inv_2_0_q_2*tmp_moved_constant_218) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_216 + jac_blending_inv_1_1_q_2*tmp_moved_constant_217 + jac_blending_inv_2_1_q_2*tmp_moved_constant_218) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_216 + jac_blending_inv_1_2_q_2*tmp_moved_constant_217 + jac_blending_inv_2_2_q_2*tmp_moved_constant_218))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_216 + jac_blending_inv_1_0_q_2*tmp_moved_constant_217 + jac_blending_inv_2_0_q_2*tmp_moved_constant_218) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_216 + jac_blending_inv_1_1_q_2*tmp_moved_constant_217 + jac_blending_inv_2_1_q_2*tmp_moved_constant_218) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_216 + jac_blending_inv_1_2_q_2*tmp_moved_constant_217 + jac_blending_inv_2_2_q_2*tmp_moved_constant_218)));
             const real_t elMatDiag_9 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_234 + jac_blending_inv_1_0_q_3*tmp_moved_constant_235 + jac_blending_inv_2_0_q_3*tmp_moved_constant_236) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_234 + jac_blending_inv_1_1_q_3*tmp_moved_constant_235 + jac_blending_inv_2_1_q_3*tmp_moved_constant_236) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_234 + jac_blending_inv_1_2_q_3*tmp_moved_constant_235 + jac_blending_inv_2_2_q_3*tmp_moved_constant_236))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_234 + jac_blending_inv_1_0_q_3*tmp_moved_constant_235 + jac_blending_inv_2_0_q_3*tmp_moved_constant_236) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_234 + jac_blending_inv_1_1_q_3*tmp_moved_constant_235 + jac_blending_inv_2_1_q_3*tmp_moved_constant_236) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_234 + jac_blending_inv_1_2_q_3*tmp_moved_constant_235 + jac_blending_inv_2_2_q_3*tmp_moved_constant_236))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_237 + jac_blending_inv_1_0_q_4*tmp_moved_constant_238 + jac_blending_inv_2_0_q_4*tmp_moved_constant_239) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_237 + jac_blending_inv_1_1_q_4*tmp_moved_constant_238 + jac_blending_inv_2_1_q_4*tmp_moved_constant_239) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_237 + jac_blending_inv_1_2_q_4*tmp_moved_constant_238 + jac_blending_inv_2_2_q_4*tmp_moved_constant_239))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_237 + jac_blending_inv_1_0_q_4*tmp_moved_constant_238 + jac_blending_inv_2_0_q_4*tmp_moved_constant_239) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_237 + jac_blending_inv_1_1_q_4*tmp_moved_constant_238 + jac_blending_inv_2_1_q_4*tmp_moved_constant_239) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_237 + jac_blending_inv_1_2_q_4*tmp_moved_constant_238 + jac_blending_inv_2_2_q_4*tmp_moved_constant_239))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_225 + jac_blending_inv_1_0_q_0*tmp_moved_constant_226 + jac_blending_inv_2_0_q_0*tmp_moved_constant_227) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_225 + jac_blending_inv_1_1_q_0*tmp_moved_constant_226 + jac_blending_inv_2_1_q_0*tmp_moved_constant_227) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_225 + jac_blending_inv_1_2_q_0*tmp_moved_constant_226 + jac_blending_inv_2_2_q_0*tmp_moved_constant_227))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_225 + jac_blending_inv_1_0_q_0*tmp_moved_constant_226 + jac_blending_inv_2_0_q_0*tmp_moved_constant_227) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_225 + jac_blending_inv_1_1_q_0*tmp_moved_constant_226 + jac_blending_inv_2_1_q_0*tmp_moved_constant_227) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_225 + jac_blending_inv_1_2_q_0*tmp_moved_constant_226 + jac_blending_inv_2_2_q_0*tmp_moved_constant_227))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_228 + jac_blending_inv_1_0_q_1*tmp_moved_constant_229 + jac_blending_inv_2_0_q_1*tmp_moved_constant_230) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_228 + jac_blending_inv_1_1_q_1*tmp_moved_constant_229 + jac_blending_inv_2_1_q_1*tmp_moved_constant_230) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_228 + jac_blending_inv_1_2_q_1*tmp_moved_constant_229 + jac_blending_inv_2_2_q_1*tmp_moved_constant_230))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_228 + jac_blending_inv_1_0_q_1*tmp_moved_constant_229 + jac_blending_inv_2_0_q_1*tmp_moved_constant_230) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_228 + jac_blending_inv_1_1_q_1*tmp_moved_constant_229 + jac_blending_inv_2_1_q_1*tmp_moved_constant_230) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_228 + jac_blending_inv_1_2_q_1*tmp_moved_constant_229 + jac_blending_inv_2_2_q_1*tmp_moved_constant_230))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_231 + jac_blending_inv_1_0_q_2*tmp_moved_constant_232 + jac_blending_inv_2_0_q_2*tmp_moved_constant_233) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_231 + jac_blending_inv_1_1_q_2*tmp_moved_constant_232 + jac_blending_inv_2_1_q_2*tmp_moved_constant_233) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_231 + jac_blending_inv_1_2_q_2*tmp_moved_constant_232 + jac_blending_inv_2_2_q_2*tmp_moved_constant_233))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_231 + jac_blending_inv_1_0_q_2*tmp_moved_constant_232 + jac_blending_inv_2_0_q_2*tmp_moved_constant_233) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_231 + jac_blending_inv_1_1_q_2*tmp_moved_constant_232 + jac_blending_inv_2_1_q_2*tmp_moved_constant_233) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_231 + jac_blending_inv_1_2_q_2*tmp_moved_constant_232 + jac_blending_inv_2_2_q_2*tmp_moved_constant_233)));
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
          }
       }
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const real_t tmp_coords_jac_11_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const real_t tmp_coords_jac_9_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const real_t tmp_coords_jac_8_BLUE_UP = jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP;
       const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const real_t tmp_coords_jac_7_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_10_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_12_BLUE_UP = jac_affine_0_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_0_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_0_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
       const real_t tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const real_t jac_affine_inv_0_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
       const real_t jac_affine_inv_0_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_2_1_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const real_t jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const real_t jac_affine_inv_1_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t jac_affine_inv_2_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       const real_t tmp_moved_constant_240 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_4 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_4 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_4;
       const real_t tmp_moved_constant_241 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_4 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_4 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_4;
       const real_t tmp_moved_constant_242 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_4 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_4 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_4;
       const real_t tmp_moved_constant_243 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_33 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_33 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_33;
       const real_t tmp_moved_constant_244 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_33 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_33 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_33;
       const real_t tmp_moved_constant_245 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_33 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_33 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_33;
       const real_t tmp_moved_constant_246 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_62 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_62 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_62;
       const real_t tmp_moved_constant_247 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_62 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_62 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_62;
       const real_t tmp_moved_constant_248 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_62 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_62 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_62;
       const real_t tmp_moved_constant_249 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_91 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_91 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_91;
       const real_t tmp_moved_constant_250 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_91 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_91 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_91;
       const real_t tmp_moved_constant_251 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_91 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_91 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_91;
       const real_t tmp_moved_constant_252 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_120 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_120 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_120;
       const real_t tmp_moved_constant_253 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_120 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_120 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_120;
       const real_t tmp_moved_constant_254 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_120 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_120 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_120;
       const real_t tmp_moved_constant_255 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_145;
       const real_t tmp_moved_constant_256 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_145;
       const real_t tmp_moved_constant_257 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_145;
       const real_t tmp_moved_constant_258 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_149;
       const real_t tmp_moved_constant_259 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_149;
       const real_t tmp_moved_constant_260 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_149;
       const real_t tmp_moved_constant_261 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_153;
       const real_t tmp_moved_constant_262 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_153;
       const real_t tmp_moved_constant_263 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_153;
       const real_t tmp_moved_constant_264 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_157;
       const real_t tmp_moved_constant_265 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_157;
       const real_t tmp_moved_constant_266 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_157;
       const real_t tmp_moved_constant_267 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_161;
       const real_t tmp_moved_constant_268 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_161;
       const real_t tmp_moved_constant_269 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_161;
       const real_t tmp_moved_constant_270 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_165;
       const real_t tmp_moved_constant_271 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_165;
       const real_t tmp_moved_constant_272 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_165;
       const real_t tmp_moved_constant_273 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_169;
       const real_t tmp_moved_constant_274 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_169;
       const real_t tmp_moved_constant_275 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_169;
       const real_t tmp_moved_constant_276 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_173;
       const real_t tmp_moved_constant_277 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_173;
       const real_t tmp_moved_constant_278 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_173;
       const real_t tmp_moved_constant_279 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_177;
       const real_t tmp_moved_constant_280 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_177;
       const real_t tmp_moved_constant_281 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_177;
       const real_t tmp_moved_constant_282 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_181;
       const real_t tmp_moved_constant_283 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_181;
       const real_t tmp_moved_constant_284 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_181;
       const real_t tmp_moved_constant_285 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_185;
       const real_t tmp_moved_constant_286 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_185;
       const real_t tmp_moved_constant_287 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_185;
       const real_t tmp_moved_constant_288 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_189;
       const real_t tmp_moved_constant_289 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_189;
       const real_t tmp_moved_constant_290 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_189;
       const real_t tmp_moved_constant_291 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_193;
       const real_t tmp_moved_constant_292 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_193;
       const real_t tmp_moved_constant_293 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_193;
       const real_t tmp_moved_constant_294 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_197;
       const real_t tmp_moved_constant_295 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_197;
       const real_t tmp_moved_constant_296 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_197;
       const real_t tmp_moved_constant_297 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_201;
       const real_t tmp_moved_constant_298 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_201;
       const real_t tmp_moved_constant_299 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_201;
       const real_t tmp_moved_constant_300 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_301 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_302 = tmp_moved_constant_300 + tmp_moved_constant_301;
       const real_t tmp_moved_constant_303 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_304 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_305 = tmp_moved_constant_303 + tmp_moved_constant_304;
       const real_t tmp_moved_constant_306 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_307 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_308 = tmp_moved_constant_306 + tmp_moved_constant_307;
       const real_t tmp_moved_constant_309 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_310 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_31;
       const real_t tmp_moved_constant_311 = tmp_moved_constant_309 + tmp_moved_constant_310;
       const real_t tmp_moved_constant_312 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_313 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_31;
       const real_t tmp_moved_constant_314 = tmp_moved_constant_312 + tmp_moved_constant_313;
       const real_t tmp_moved_constant_315 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_316 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_31;
       const real_t tmp_moved_constant_317 = tmp_moved_constant_315 + tmp_moved_constant_316;
       const real_t tmp_moved_constant_318 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_58;
       const real_t tmp_moved_constant_319 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_60;
       const real_t tmp_moved_constant_320 = tmp_moved_constant_318 + tmp_moved_constant_319;
       const real_t tmp_moved_constant_321 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_58;
       const real_t tmp_moved_constant_322 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_60;
       const real_t tmp_moved_constant_323 = tmp_moved_constant_321 + tmp_moved_constant_322;
       const real_t tmp_moved_constant_324 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_58;
       const real_t tmp_moved_constant_325 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_60;
       const real_t tmp_moved_constant_326 = tmp_moved_constant_324 + tmp_moved_constant_325;
       const real_t tmp_moved_constant_327 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_87;
       const real_t tmp_moved_constant_328 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_89;
       const real_t tmp_moved_constant_329 = tmp_moved_constant_327 + tmp_moved_constant_328;
       const real_t tmp_moved_constant_330 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_87;
       const real_t tmp_moved_constant_331 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_89;
       const real_t tmp_moved_constant_332 = tmp_moved_constant_330 + tmp_moved_constant_331;
       const real_t tmp_moved_constant_333 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_87;
       const real_t tmp_moved_constant_334 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_89;
       const real_t tmp_moved_constant_335 = tmp_moved_constant_333 + tmp_moved_constant_334;
       const real_t tmp_moved_constant_336 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_116;
       const real_t tmp_moved_constant_337 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_118;
       const real_t tmp_moved_constant_338 = tmp_moved_constant_336 + tmp_moved_constant_337;
       const real_t tmp_moved_constant_339 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_116;
       const real_t tmp_moved_constant_340 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_118;
       const real_t tmp_moved_constant_341 = tmp_moved_constant_339 + tmp_moved_constant_340;
       const real_t tmp_moved_constant_342 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_116;
       const real_t tmp_moved_constant_343 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_118;
       const real_t tmp_moved_constant_344 = tmp_moved_constant_342 + tmp_moved_constant_343;
       const real_t tmp_moved_constant_345 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_346 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_347 = tmp_moved_constant_345 + tmp_moved_constant_346;
       const real_t tmp_moved_constant_348 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_349 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_350 = tmp_moved_constant_348 + tmp_moved_constant_349;
       const real_t tmp_moved_constant_351 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_352 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_353 = tmp_moved_constant_351 + tmp_moved_constant_352;
       const real_t tmp_moved_constant_354 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_355 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_30;
       const real_t tmp_moved_constant_356 = tmp_moved_constant_354 + tmp_moved_constant_355;
       const real_t tmp_moved_constant_357 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_358 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_30;
       const real_t tmp_moved_constant_359 = tmp_moved_constant_357 + tmp_moved_constant_358;
       const real_t tmp_moved_constant_360 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_361 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_30;
       const real_t tmp_moved_constant_362 = tmp_moved_constant_360 + tmp_moved_constant_361;
       const real_t tmp_moved_constant_363 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_58;
       const real_t tmp_moved_constant_364 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_59;
       const real_t tmp_moved_constant_365 = tmp_moved_constant_363 + tmp_moved_constant_364;
       const real_t tmp_moved_constant_366 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_58;
       const real_t tmp_moved_constant_367 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_59;
       const real_t tmp_moved_constant_368 = tmp_moved_constant_366 + tmp_moved_constant_367;
       const real_t tmp_moved_constant_369 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_58;
       const real_t tmp_moved_constant_370 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_59;
       const real_t tmp_moved_constant_371 = tmp_moved_constant_369 + tmp_moved_constant_370;
       const real_t tmp_moved_constant_372 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_87;
       const real_t tmp_moved_constant_373 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_88;
       const real_t tmp_moved_constant_374 = tmp_moved_constant_372 + tmp_moved_constant_373;
       const real_t tmp_moved_constant_375 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_87;
       const real_t tmp_moved_constant_376 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_88;
       const real_t tmp_moved_constant_377 = tmp_moved_constant_375 + tmp_moved_constant_376;
       const real_t tmp_moved_constant_378 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_87;
       const real_t tmp_moved_constant_379 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_88;
       const real_t tmp_moved_constant_380 = tmp_moved_constant_378 + tmp_moved_constant_379;
       const real_t tmp_moved_constant_381 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_116;
       const real_t tmp_moved_constant_382 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_117;
       const real_t tmp_moved_constant_383 = tmp_moved_constant_381 + tmp_moved_constant_382;
       const real_t tmp_moved_constant_384 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_116;
       const real_t tmp_moved_constant_385 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_117;
       const real_t tmp_moved_constant_386 = tmp_moved_constant_384 + tmp_moved_constant_385;
       const real_t tmp_moved_constant_387 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_116;
       const real_t tmp_moved_constant_388 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_117;
       const real_t tmp_moved_constant_389 = tmp_moved_constant_387 + tmp_moved_constant_388;
       const real_t tmp_moved_constant_390 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_391 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_392 = tmp_moved_constant_390 + tmp_moved_constant_391;
       const real_t tmp_moved_constant_393 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_394 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_395 = tmp_moved_constant_393 + tmp_moved_constant_394;
       const real_t tmp_moved_constant_396 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_397 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_398 = tmp_moved_constant_396 + tmp_moved_constant_397;
       const real_t tmp_moved_constant_399 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_31;
       const real_t tmp_moved_constant_400 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_30;
       const real_t tmp_moved_constant_401 = tmp_moved_constant_399 + tmp_moved_constant_400;
       const real_t tmp_moved_constant_402 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_31;
       const real_t tmp_moved_constant_403 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_30;
       const real_t tmp_moved_constant_404 = tmp_moved_constant_402 + tmp_moved_constant_403;
       const real_t tmp_moved_constant_405 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_31;
       const real_t tmp_moved_constant_406 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_30;
       const real_t tmp_moved_constant_407 = tmp_moved_constant_405 + tmp_moved_constant_406;
       const real_t tmp_moved_constant_408 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_60;
       const real_t tmp_moved_constant_409 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_59;
       const real_t tmp_moved_constant_410 = tmp_moved_constant_408 + tmp_moved_constant_409;
       const real_t tmp_moved_constant_411 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_60;
       const real_t tmp_moved_constant_412 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_59;
       const real_t tmp_moved_constant_413 = tmp_moved_constant_411 + tmp_moved_constant_412;
       const real_t tmp_moved_constant_414 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_60;
       const real_t tmp_moved_constant_415 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_59;
       const real_t tmp_moved_constant_416 = tmp_moved_constant_414 + tmp_moved_constant_415;
       const real_t tmp_moved_constant_417 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_89;
       const real_t tmp_moved_constant_418 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_88;
       const real_t tmp_moved_constant_419 = tmp_moved_constant_417 + tmp_moved_constant_418;
       const real_t tmp_moved_constant_420 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_89;
       const real_t tmp_moved_constant_421 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_88;
       const real_t tmp_moved_constant_422 = tmp_moved_constant_420 + tmp_moved_constant_421;
       const real_t tmp_moved_constant_423 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_89;
       const real_t tmp_moved_constant_424 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_88;
       const real_t tmp_moved_constant_425 = tmp_moved_constant_423 + tmp_moved_constant_424;
       const real_t tmp_moved_constant_426 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_118;
       const real_t tmp_moved_constant_427 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_117;
       const real_t tmp_moved_constant_428 = tmp_moved_constant_426 + tmp_moved_constant_427;
       const real_t tmp_moved_constant_429 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_118;
       const real_t tmp_moved_constant_430 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_117;
       const real_t tmp_moved_constant_431 = tmp_moved_constant_429 + tmp_moved_constant_430;
       const real_t tmp_moved_constant_432 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_118;
       const real_t tmp_moved_constant_433 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_117;
       const real_t tmp_moved_constant_434 = tmp_moved_constant_432 + tmp_moved_constant_433;
       const real_t tmp_moved_constant_435 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_340 - tmp_moved_constant_300 - tmp_moved_constant_345;
       const real_t tmp_moved_constant_436 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_340 - tmp_moved_constant_303 - tmp_moved_constant_348;
       const real_t tmp_moved_constant_437 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_340 - tmp_moved_constant_306 - tmp_moved_constant_351;
       const real_t tmp_moved_constant_438 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_344 - tmp_moved_constant_309 - tmp_moved_constant_354;
       const real_t tmp_moved_constant_439 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_344 - tmp_moved_constant_312 - tmp_moved_constant_357;
       const real_t tmp_moved_constant_440 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_344 - tmp_moved_constant_315 - tmp_moved_constant_360;
       const real_t tmp_moved_constant_441 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_348 - tmp_moved_constant_318 - tmp_moved_constant_363;
       const real_t tmp_moved_constant_442 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_348 - tmp_moved_constant_321 - tmp_moved_constant_366;
       const real_t tmp_moved_constant_443 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_348 - tmp_moved_constant_324 - tmp_moved_constant_369;
       const real_t tmp_moved_constant_444 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_352 - tmp_moved_constant_327 - tmp_moved_constant_372;
       const real_t tmp_moved_constant_445 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_352 - tmp_moved_constant_330 - tmp_moved_constant_375;
       const real_t tmp_moved_constant_446 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_352 - tmp_moved_constant_333 - tmp_moved_constant_378;
       const real_t tmp_moved_constant_447 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_356 - tmp_moved_constant_336 - tmp_moved_constant_381;
       const real_t tmp_moved_constant_448 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_356 - tmp_moved_constant_339 - tmp_moved_constant_384;
       const real_t tmp_moved_constant_449 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_356 - tmp_moved_constant_342 - tmp_moved_constant_387;
       const real_t tmp_moved_constant_450 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_361 - tmp_moved_constant_301 - tmp_moved_constant_390;
       const real_t tmp_moved_constant_451 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_361 - tmp_moved_constant_304 - tmp_moved_constant_393;
       const real_t tmp_moved_constant_452 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_361 - tmp_moved_constant_307 - tmp_moved_constant_396;
       const real_t tmp_moved_constant_453 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_366 - tmp_moved_constant_310 - tmp_moved_constant_399;
       const real_t tmp_moved_constant_454 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_366 - tmp_moved_constant_313 - tmp_moved_constant_402;
       const real_t tmp_moved_constant_455 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_366 - tmp_moved_constant_316 - tmp_moved_constant_405;
       const real_t tmp_moved_constant_456 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_371 - tmp_moved_constant_319 - tmp_moved_constant_408;
       const real_t tmp_moved_constant_457 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_371 - tmp_moved_constant_322 - tmp_moved_constant_411;
       const real_t tmp_moved_constant_458 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_371 - tmp_moved_constant_325 - tmp_moved_constant_414;
       const real_t tmp_moved_constant_459 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_376 - tmp_moved_constant_328 - tmp_moved_constant_417;
       const real_t tmp_moved_constant_460 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_376 - tmp_moved_constant_331 - tmp_moved_constant_420;
       const real_t tmp_moved_constant_461 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_376 - tmp_moved_constant_334 - tmp_moved_constant_423;
       const real_t tmp_moved_constant_462 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_381 - tmp_moved_constant_337 - tmp_moved_constant_426;
       const real_t tmp_moved_constant_463 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_381 - tmp_moved_constant_340 - tmp_moved_constant_429;
       const real_t tmp_moved_constant_464 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_381 - tmp_moved_constant_343 - tmp_moved_constant_432;
       const real_t tmp_moved_constant_465 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_385 - tmp_moved_constant_346 - tmp_moved_constant_391;
       const real_t tmp_moved_constant_466 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_385 - tmp_moved_constant_349 - tmp_moved_constant_394;
       const real_t tmp_moved_constant_467 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_385 - tmp_moved_constant_352 - tmp_moved_constant_397;
       const real_t tmp_moved_constant_468 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_389 - tmp_moved_constant_355 - tmp_moved_constant_400;
       const real_t tmp_moved_constant_469 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_389 - tmp_moved_constant_358 - tmp_moved_constant_403;
       const real_t tmp_moved_constant_470 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_389 - tmp_moved_constant_361 - tmp_moved_constant_406;
       const real_t tmp_moved_constant_471 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_393 - tmp_moved_constant_364 - tmp_moved_constant_409;
       const real_t tmp_moved_constant_472 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_393 - tmp_moved_constant_367 - tmp_moved_constant_412;
       const real_t tmp_moved_constant_473 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_393 - tmp_moved_constant_370 - tmp_moved_constant_415;
       const real_t tmp_moved_constant_474 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_397 - tmp_moved_constant_373 - tmp_moved_constant_418;
       const real_t tmp_moved_constant_475 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_397 - tmp_moved_constant_376 - tmp_moved_constant_421;
       const real_t tmp_moved_constant_476 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_397 - tmp_moved_constant_379 - tmp_moved_constant_424;
       const real_t tmp_moved_constant_477 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_401 - tmp_moved_constant_382 - tmp_moved_constant_427;
       const real_t tmp_moved_constant_478 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_401 - tmp_moved_constant_385 - tmp_moved_constant_430;
       const real_t tmp_moved_constant_479 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_401 - tmp_moved_constant_388 - tmp_moved_constant_433;
       {
          /* CellType.BLUE_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
             const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
             const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
             const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
             const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
             const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
             const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
             const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
             const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
             const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
             const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
             const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
             const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
             const real_t tmp_blending_op_35 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_36 = -tmp_blending_op_35;
             const real_t tmp_blending_op_37 = (tmp_blending_op_28*tmp_blending_op_28);
             const real_t tmp_blending_op_38 = (tmp_blending_op_33*tmp_blending_op_33);
             const real_t tmp_blending_op_39 = tmp_blending_op_37 + tmp_blending_op_38 + tmp_blending_op_4;
             const real_t tmp_blending_op_42 = pow(tmp_blending_op_39, -1.5000000000000000)*tmp_blending_op_41;
             const real_t tmp_blending_op_44 = tmp_blending_op_23*tmp_blending_op_39;
             const real_t tmp_blending_op_45 = -tmp_blending_op_33*tmp_blending_op_35 - tmp_blending_op_43*tmp_blending_op_44;
             const real_t tmp_blending_op_46 = tmp_blending_op_3*tmp_blending_op_42;
             const real_t tmp_blending_op_48 = tmp_blending_op_28*tmp_blending_op_36 + tmp_blending_op_44*tmp_blending_op_47;
             const real_t tmp_blending_op_49 = tmp_blending_op_3*tmp_blending_op_36 + tmp_blending_op_39*tmp_blending_op_40;
             const real_t tmp_blending_op_50 = tmp_blending_op_33*tmp_blending_op_42;
             const real_t tmp_blending_op_52 = tmp_blending_op_28*tmp_blending_op_42;
             const real_t tmp_blending_op_61 = p_affine_0_2 + tmp_blending_op_0*0.5 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_62 = (tmp_blending_op_61*tmp_blending_op_61);
             const real_t tmp_blending_op_63 = -tmp_blending_op_17 - tmp_blending_op_61;
             const real_t tmp_blending_op_64 = p_affine_0_0 + tmp_blending_op_25*0.5 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_65 = -tmp_blending_op_6 - tmp_blending_op_64;
             const real_t tmp_blending_op_66 = p_affine_0_1 + tmp_blending_op_30*0.5 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_67 = -tmp_blending_op_13 - tmp_blending_op_66;
             const real_t tmp_blending_op_68 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_65 - tmp_blending_op_12*tmp_blending_op_63 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_63 - tmp_blending_op_19*tmp_blending_op_65 - tmp_blending_op_20*tmp_blending_op_67 + tmp_blending_op_67*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_69 = -tmp_blending_op_68;
             const real_t tmp_blending_op_70 = (tmp_blending_op_64*tmp_blending_op_64);
             const real_t tmp_blending_op_71 = (tmp_blending_op_66*tmp_blending_op_66);
             const real_t tmp_blending_op_72 = tmp_blending_op_62 + tmp_blending_op_70 + tmp_blending_op_71;
             const real_t tmp_blending_op_73 = tmp_blending_op_41*pow(tmp_blending_op_72, -1.5000000000000000);
             const real_t tmp_blending_op_75 = -tmp_blending_op_66*tmp_blending_op_68 - tmp_blending_op_72*tmp_blending_op_74;
             const real_t tmp_blending_op_76 = tmp_blending_op_61*tmp_blending_op_73;
             const real_t tmp_blending_op_77 = tmp_blending_op_53*tmp_blending_op_72 + tmp_blending_op_64*tmp_blending_op_69;
             const real_t tmp_blending_op_78 = tmp_blending_op_40*tmp_blending_op_72 + tmp_blending_op_61*tmp_blending_op_69;
             const real_t tmp_blending_op_79 = tmp_blending_op_66*tmp_blending_op_73;
             const real_t tmp_blending_op_80 = tmp_blending_op_64*tmp_blending_op_73;
             const real_t tmp_blending_op_88 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.5 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_89 = (tmp_blending_op_88*tmp_blending_op_88);
             const real_t tmp_blending_op_90 = -tmp_blending_op_17 - tmp_blending_op_88;
             const real_t tmp_blending_op_91 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.5 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_92 = -tmp_blending_op_6 - tmp_blending_op_91;
             const real_t tmp_blending_op_93 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.5 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_94 = -tmp_blending_op_13 - tmp_blending_op_93;
             const real_t tmp_blending_op_95 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_92 - tmp_blending_op_12*tmp_blending_op_90 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_90 - tmp_blending_op_19*tmp_blending_op_92 - tmp_blending_op_20*tmp_blending_op_94 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_94);
             const real_t tmp_blending_op_96 = -tmp_blending_op_95;
             const real_t tmp_blending_op_97 = (tmp_blending_op_91*tmp_blending_op_91);
             const real_t tmp_blending_op_98 = (tmp_blending_op_93*tmp_blending_op_93);
             const real_t tmp_blending_op_99 = tmp_blending_op_89 + tmp_blending_op_97 + tmp_blending_op_98;
             const real_t tmp_blending_op_100 = tmp_blending_op_41*pow(tmp_blending_op_99, -1.5000000000000000);
             const real_t tmp_blending_op_101 = -tmp_blending_op_74*tmp_blending_op_99 - tmp_blending_op_93*tmp_blending_op_95;
             const real_t tmp_blending_op_102 = tmp_blending_op_100*tmp_blending_op_88;
             const real_t tmp_blending_op_103 = tmp_blending_op_53*tmp_blending_op_99 + tmp_blending_op_91*tmp_blending_op_96;
             const real_t tmp_blending_op_104 = tmp_blending_op_40*tmp_blending_op_99 + tmp_blending_op_88*tmp_blending_op_96;
             const real_t tmp_blending_op_105 = tmp_blending_op_100*tmp_blending_op_93;
             const real_t tmp_blending_op_106 = tmp_blending_op_100*tmp_blending_op_91;
             const real_t tmp_blending_op_114 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.5;
             const real_t tmp_blending_op_115 = (tmp_blending_op_114*tmp_blending_op_114);
             const real_t tmp_blending_op_116 = -tmp_blending_op_114 - tmp_blending_op_17;
             const real_t tmp_blending_op_117 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.5;
             const real_t tmp_blending_op_118 = -tmp_blending_op_117 - tmp_blending_op_6;
             const real_t tmp_blending_op_119 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.5;
             const real_t tmp_blending_op_120 = -tmp_blending_op_119 - tmp_blending_op_13;
             const real_t tmp_blending_op_121 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_118*tmp_blending_op_18 - tmp_blending_op_116*tmp_blending_op_12 + tmp_blending_op_116*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_118*tmp_blending_op_19 - tmp_blending_op_120*tmp_blending_op_20 + tmp_blending_op_120*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_122 = -tmp_blending_op_121;
             const real_t tmp_blending_op_123 = (tmp_blending_op_117*tmp_blending_op_117);
             const real_t tmp_blending_op_124 = (tmp_blending_op_119*tmp_blending_op_119);
             const real_t tmp_blending_op_125 = tmp_blending_op_115 + tmp_blending_op_123 + tmp_blending_op_124;
             const real_t tmp_blending_op_126 = pow(tmp_blending_op_125, -1.5000000000000000)*tmp_blending_op_41;
             const real_t tmp_blending_op_127 = -tmp_blending_op_119*tmp_blending_op_121 - tmp_blending_op_125*tmp_blending_op_74;
             const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_126;
             const real_t tmp_blending_op_129 = tmp_blending_op_117*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_53;
             const real_t tmp_blending_op_130 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_40;
             const real_t tmp_blending_op_131 = tmp_blending_op_119*tmp_blending_op_126;
             const real_t tmp_blending_op_132 = tmp_blending_op_117*tmp_blending_op_126;
             const real_t tmp_blending_op_140 = p_affine_0_2 + tmp_blending_op_0*0.25 + tmp_blending_op_1*0.25 + tmp_blending_op_2*0.25;
             const real_t tmp_blending_op_141 = (tmp_blending_op_140*tmp_blending_op_140);
             const real_t tmp_blending_op_142 = -tmp_blending_op_140 - tmp_blending_op_17;
             const real_t tmp_blending_op_143 = p_affine_0_0 + tmp_blending_op_25*0.25 + tmp_blending_op_26*0.25 + tmp_blending_op_27*0.25;
             const real_t tmp_blending_op_144 = -tmp_blending_op_143 - tmp_blending_op_6;
             const real_t tmp_blending_op_145 = p_affine_0_1 + tmp_blending_op_30*0.25 + tmp_blending_op_31*0.25 + tmp_blending_op_32*0.25;
             const real_t tmp_blending_op_146 = -tmp_blending_op_13 - tmp_blending_op_145;
             const real_t tmp_blending_op_147 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_144*tmp_blending_op_18 - tmp_blending_op_12*tmp_blending_op_142 + tmp_blending_op_14*tmp_blending_op_142*tmp_blending_op_15 - tmp_blending_op_144*tmp_blending_op_19 - tmp_blending_op_146*tmp_blending_op_20 + tmp_blending_op_146*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_148 = -tmp_blending_op_147;
             const real_t tmp_blending_op_149 = (tmp_blending_op_143*tmp_blending_op_143);
             const real_t tmp_blending_op_150 = (tmp_blending_op_145*tmp_blending_op_145);
             const real_t tmp_blending_op_151 = tmp_blending_op_141 + tmp_blending_op_149 + tmp_blending_op_150;
             const real_t tmp_blending_op_152 = pow(tmp_blending_op_151, -1.5000000000000000)*tmp_blending_op_41;
             const real_t tmp_blending_op_153 = -tmp_blending_op_145*tmp_blending_op_147 - tmp_blending_op_151*tmp_blending_op_74;
             const real_t tmp_blending_op_154 = tmp_blending_op_140*tmp_blending_op_152;
             const real_t tmp_blending_op_155 = tmp_blending_op_143*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_53;
             const real_t tmp_blending_op_156 = tmp_blending_op_140*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_40;
             const real_t tmp_blending_op_157 = tmp_blending_op_145*tmp_blending_op_152;
             const real_t tmp_blending_op_158 = tmp_blending_op_143*tmp_blending_op_152;
             const real_t jac_blending_2_2_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_4 + tmp_blending_op_39*(tmp_blending_op_3*tmp_blending_op_40 + tmp_blending_op_35));
             const real_t jac_blending_2_1_q_4 = tmp_blending_op_45*tmp_blending_op_46;
             const real_t jac_blending_2_0_q_4 = tmp_blending_op_46*tmp_blending_op_48;
             const real_t jac_blending_1_2_q_4 = tmp_blending_op_49*tmp_blending_op_50;
             const real_t jac_blending_1_1_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_39*(tmp_blending_op_33*tmp_blending_op_51 + tmp_blending_op_35));
             const real_t tmp_blending_op_58 = jac_blending_1_1_q_4*jac_blending_2_0_q_4;
             const real_t jac_blending_1_0_q_4 = tmp_blending_op_48*tmp_blending_op_50;
             const real_t tmp_blending_op_55 = jac_blending_1_0_q_4*jac_blending_2_1_q_4;
             const real_t jac_blending_0_2_q_4 = tmp_blending_op_49*tmp_blending_op_52;
             const real_t jac_blending_0_1_q_4 = tmp_blending_op_45*tmp_blending_op_52;
             const real_t tmp_blending_op_57 = jac_blending_0_1_q_4*jac_blending_1_0_q_4;
             const real_t jac_blending_0_0_q_4 = tmp_blending_op_42*(-tmp_blending_op_35*tmp_blending_op_37 + tmp_blending_op_39*(tmp_blending_op_28*tmp_blending_op_53 + tmp_blending_op_35));
             const real_t tmp_blending_op_54 = jac_blending_0_0_q_4*jac_blending_1_1_q_4;
             const real_t tmp_blending_op_56 = jac_blending_0_0_q_4*jac_blending_2_1_q_4;
             const real_t tmp_blending_op_59 = jac_blending_0_1_q_4*jac_blending_1_2_q_4*jac_blending_2_0_q_4 + jac_blending_0_2_q_4*tmp_blending_op_55 - jac_blending_0_2_q_4*tmp_blending_op_58 - jac_blending_1_2_q_4*tmp_blending_op_56 + jac_blending_2_2_q_4*tmp_blending_op_54 - jac_blending_2_2_q_4*tmp_blending_op_57;
             const real_t tmp_blending_op_60 = 1.0 / (tmp_blending_op_59);
             const real_t abs_det_jac_blending_q_4 = tmp_blending_op_59;
             const real_t jac_blending_inv_2_2_q_4 = tmp_blending_op_60*(tmp_blending_op_54 - tmp_blending_op_57);
             const real_t jac_blending_inv_2_1_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_2_0_q_4 - tmp_blending_op_56);
             const real_t jac_blending_inv_2_0_q_4 = tmp_blending_op_60*(tmp_blending_op_55 - tmp_blending_op_58);
             const real_t jac_blending_inv_1_2_q_4 = tmp_blending_op_60*(-jac_blending_0_0_q_4*jac_blending_1_2_q_4 + jac_blending_0_2_q_4*jac_blending_1_0_q_4);
             const real_t jac_blending_inv_1_1_q_4 = tmp_blending_op_60*(jac_blending_0_0_q_4*jac_blending_2_2_q_4 - jac_blending_0_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_1_0_q_4 = tmp_blending_op_60*(-jac_blending_1_0_q_4*jac_blending_2_2_q_4 + jac_blending_1_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_0_2_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_1_2_q_4 - jac_blending_0_2_q_4*jac_blending_1_1_q_4);
             const real_t jac_blending_inv_0_1_q_4 = tmp_blending_op_60*(-jac_blending_0_1_q_4*jac_blending_2_2_q_4 + jac_blending_0_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_inv_0_0_q_4 = tmp_blending_op_60*(jac_blending_1_1_q_4*jac_blending_2_2_q_4 - jac_blending_1_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_2_2_q_3 = tmp_blending_op_73*(tmp_blending_op_62*tmp_blending_op_69 + tmp_blending_op_72*(tmp_blending_op_40*tmp_blending_op_61 + tmp_blending_op_68));
             const real_t jac_blending_2_1_q_3 = tmp_blending_op_75*tmp_blending_op_76;
             const real_t jac_blending_2_0_q_3 = tmp_blending_op_76*tmp_blending_op_77;
             const real_t jac_blending_1_2_q_3 = tmp_blending_op_78*tmp_blending_op_79;
             const real_t jac_blending_1_1_q_3 = tmp_blending_op_73*(tmp_blending_op_69*tmp_blending_op_71 + tmp_blending_op_72*(tmp_blending_op_51*tmp_blending_op_66 + tmp_blending_op_68));
             const real_t tmp_blending_op_85 = jac_blending_1_1_q_3*jac_blending_2_0_q_3;
             const real_t jac_blending_1_0_q_3 = tmp_blending_op_77*tmp_blending_op_79;
             const real_t tmp_blending_op_82 = jac_blending_1_0_q_3*jac_blending_2_1_q_3;
             const real_t jac_blending_0_2_q_3 = tmp_blending_op_78*tmp_blending_op_80;
             const real_t jac_blending_0_1_q_3 = tmp_blending_op_75*tmp_blending_op_80;
             const real_t tmp_blending_op_84 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
             const real_t jac_blending_0_0_q_3 = tmp_blending_op_73*(-tmp_blending_op_68*tmp_blending_op_70 + tmp_blending_op_72*(tmp_blending_op_53*tmp_blending_op_64 + tmp_blending_op_68));
             const real_t tmp_blending_op_81 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
             const real_t tmp_blending_op_83 = jac_blending_0_0_q_3*jac_blending_2_1_q_3;
             const real_t tmp_blending_op_86 = jac_blending_0_1_q_3*jac_blending_1_2_q_3*jac_blending_2_0_q_3 + jac_blending_0_2_q_3*tmp_blending_op_82 - jac_blending_0_2_q_3*tmp_blending_op_85 - jac_blending_1_2_q_3*tmp_blending_op_83 + jac_blending_2_2_q_3*tmp_blending_op_81 - jac_blending_2_2_q_3*tmp_blending_op_84;
             const real_t tmp_blending_op_87 = 1.0 / (tmp_blending_op_86);
             const real_t abs_det_jac_blending_q_3 = tmp_blending_op_86;
             const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_87*(tmp_blending_op_81 - tmp_blending_op_84);
             const real_t jac_blending_inv_2_1_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_2_0_q_3 - tmp_blending_op_83);
             const real_t jac_blending_inv_2_0_q_3 = tmp_blending_op_87*(tmp_blending_op_82 - tmp_blending_op_85);
             const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_87*(-jac_blending_0_0_q_3*jac_blending_1_2_q_3 + jac_blending_0_2_q_3*jac_blending_1_0_q_3);
             const real_t jac_blending_inv_1_1_q_3 = tmp_blending_op_87*(jac_blending_0_0_q_3*jac_blending_2_2_q_3 - jac_blending_0_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_1_0_q_3 = tmp_blending_op_87*(-jac_blending_1_0_q_3*jac_blending_2_2_q_3 + jac_blending_1_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_1_2_q_3 - jac_blending_0_2_q_3*jac_blending_1_1_q_3);
             const real_t jac_blending_inv_0_1_q_3 = tmp_blending_op_87*(-jac_blending_0_1_q_3*jac_blending_2_2_q_3 + jac_blending_0_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_inv_0_0_q_3 = tmp_blending_op_87*(jac_blending_1_1_q_3*jac_blending_2_2_q_3 - jac_blending_1_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_2_2_q_2 = tmp_blending_op_100*(tmp_blending_op_89*tmp_blending_op_96 + tmp_blending_op_99*(tmp_blending_op_40*tmp_blending_op_88 + tmp_blending_op_95));
             const real_t jac_blending_2_1_q_2 = tmp_blending_op_101*tmp_blending_op_102;
             const real_t jac_blending_2_0_q_2 = tmp_blending_op_102*tmp_blending_op_103;
             const real_t jac_blending_1_2_q_2 = tmp_blending_op_104*tmp_blending_op_105;
             const real_t jac_blending_1_1_q_2 = tmp_blending_op_100*(tmp_blending_op_96*tmp_blending_op_98 + tmp_blending_op_99*(tmp_blending_op_51*tmp_blending_op_93 + tmp_blending_op_95));
             const real_t tmp_blending_op_111 = jac_blending_1_1_q_2*jac_blending_2_0_q_2;
             const real_t jac_blending_1_0_q_2 = tmp_blending_op_103*tmp_blending_op_105;
             const real_t tmp_blending_op_108 = jac_blending_1_0_q_2*jac_blending_2_1_q_2;
             const real_t jac_blending_0_2_q_2 = tmp_blending_op_104*tmp_blending_op_106;
             const real_t jac_blending_0_1_q_2 = tmp_blending_op_101*tmp_blending_op_106;
             const real_t tmp_blending_op_110 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
             const real_t jac_blending_0_0_q_2 = tmp_blending_op_100*(-tmp_blending_op_95*tmp_blending_op_97 + tmp_blending_op_99*(tmp_blending_op_53*tmp_blending_op_91 + tmp_blending_op_95));
             const real_t tmp_blending_op_107 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
             const real_t tmp_blending_op_109 = jac_blending_0_0_q_2*jac_blending_2_1_q_2;
             const real_t tmp_blending_op_112 = jac_blending_0_1_q_2*jac_blending_1_2_q_2*jac_blending_2_0_q_2 + jac_blending_0_2_q_2*tmp_blending_op_108 - jac_blending_0_2_q_2*tmp_blending_op_111 - jac_blending_1_2_q_2*tmp_blending_op_109 + jac_blending_2_2_q_2*tmp_blending_op_107 - jac_blending_2_2_q_2*tmp_blending_op_110;
             const real_t tmp_blending_op_113 = 1.0 / (tmp_blending_op_112);
             const real_t abs_det_jac_blending_q_2 = tmp_blending_op_112;
             const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_113*(tmp_blending_op_107 - tmp_blending_op_110);
             const real_t jac_blending_inv_2_1_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_2_0_q_2 - tmp_blending_op_109);
             const real_t jac_blending_inv_2_0_q_2 = tmp_blending_op_113*(tmp_blending_op_108 - tmp_blending_op_111);
             const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_113*(-jac_blending_0_0_q_2*jac_blending_1_2_q_2 + jac_blending_0_2_q_2*jac_blending_1_0_q_2);
             const real_t jac_blending_inv_1_1_q_2 = tmp_blending_op_113*(jac_blending_0_0_q_2*jac_blending_2_2_q_2 - jac_blending_0_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_1_0_q_2 = tmp_blending_op_113*(-jac_blending_1_0_q_2*jac_blending_2_2_q_2 + jac_blending_1_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_1_2_q_2 - jac_blending_0_2_q_2*jac_blending_1_1_q_2);
             const real_t jac_blending_inv_0_1_q_2 = tmp_blending_op_113*(-jac_blending_0_1_q_2*jac_blending_2_2_q_2 + jac_blending_0_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_inv_0_0_q_2 = tmp_blending_op_113*(jac_blending_1_1_q_2*jac_blending_2_2_q_2 - jac_blending_1_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_2_2_q_1 = tmp_blending_op_126*(tmp_blending_op_115*tmp_blending_op_122 + tmp_blending_op_125*(tmp_blending_op_114*tmp_blending_op_40 + tmp_blending_op_121));
             const real_t jac_blending_2_1_q_1 = tmp_blending_op_127*tmp_blending_op_128;
             const real_t jac_blending_2_0_q_1 = tmp_blending_op_128*tmp_blending_op_129;
             const real_t jac_blending_1_2_q_1 = tmp_blending_op_130*tmp_blending_op_131;
             const real_t jac_blending_1_1_q_1 = tmp_blending_op_126*(tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*(tmp_blending_op_119*tmp_blending_op_51 + tmp_blending_op_121));
             const real_t tmp_blending_op_137 = jac_blending_1_1_q_1*jac_blending_2_0_q_1;
             const real_t jac_blending_1_0_q_1 = tmp_blending_op_129*tmp_blending_op_131;
             const real_t tmp_blending_op_134 = jac_blending_1_0_q_1*jac_blending_2_1_q_1;
             const real_t jac_blending_0_2_q_1 = tmp_blending_op_130*tmp_blending_op_132;
             const real_t jac_blending_0_1_q_1 = tmp_blending_op_127*tmp_blending_op_132;
             const real_t tmp_blending_op_136 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
             const real_t jac_blending_0_0_q_1 = tmp_blending_op_126*(-tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*(tmp_blending_op_117*tmp_blending_op_53 + tmp_blending_op_121));
             const real_t tmp_blending_op_133 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
             const real_t tmp_blending_op_135 = jac_blending_0_0_q_1*jac_blending_2_1_q_1;
             const real_t tmp_blending_op_138 = jac_blending_0_1_q_1*jac_blending_1_2_q_1*jac_blending_2_0_q_1 + jac_blending_0_2_q_1*tmp_blending_op_134 - jac_blending_0_2_q_1*tmp_blending_op_137 - jac_blending_1_2_q_1*tmp_blending_op_135 + jac_blending_2_2_q_1*tmp_blending_op_133 - jac_blending_2_2_q_1*tmp_blending_op_136;
             const real_t tmp_blending_op_139 = 1.0 / (tmp_blending_op_138);
             const real_t abs_det_jac_blending_q_1 = tmp_blending_op_138;
             const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_139*(tmp_blending_op_133 - tmp_blending_op_136);
             const real_t jac_blending_inv_2_1_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_2_0_q_1 - tmp_blending_op_135);
             const real_t jac_blending_inv_2_0_q_1 = tmp_blending_op_139*(tmp_blending_op_134 - tmp_blending_op_137);
             const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_139*(-jac_blending_0_0_q_1*jac_blending_1_2_q_1 + jac_blending_0_2_q_1*jac_blending_1_0_q_1);
             const real_t jac_blending_inv_1_1_q_1 = tmp_blending_op_139*(jac_blending_0_0_q_1*jac_blending_2_2_q_1 - jac_blending_0_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_1_0_q_1 = tmp_blending_op_139*(-jac_blending_1_0_q_1*jac_blending_2_2_q_1 + jac_blending_1_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_1_2_q_1 - jac_blending_0_2_q_1*jac_blending_1_1_q_1);
             const real_t jac_blending_inv_0_1_q_1 = tmp_blending_op_139*(-jac_blending_0_1_q_1*jac_blending_2_2_q_1 + jac_blending_0_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_inv_0_0_q_1 = tmp_blending_op_139*(jac_blending_1_1_q_1*jac_blending_2_2_q_1 - jac_blending_1_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_2_2_q_0 = tmp_blending_op_152*(tmp_blending_op_141*tmp_blending_op_148 + tmp_blending_op_151*(tmp_blending_op_140*tmp_blending_op_40 + tmp_blending_op_147));
             const real_t jac_blending_2_1_q_0 = tmp_blending_op_153*tmp_blending_op_154;
             const real_t jac_blending_2_0_q_0 = tmp_blending_op_154*tmp_blending_op_155;
             const real_t jac_blending_1_2_q_0 = tmp_blending_op_156*tmp_blending_op_157;
             const real_t jac_blending_1_1_q_0 = tmp_blending_op_152*(tmp_blending_op_148*tmp_blending_op_150 + tmp_blending_op_151*(tmp_blending_op_145*tmp_blending_op_51 + tmp_blending_op_147));
             const real_t tmp_blending_op_163 = jac_blending_1_1_q_0*jac_blending_2_0_q_0;
             const real_t jac_blending_1_0_q_0 = tmp_blending_op_155*tmp_blending_op_157;
             const real_t tmp_blending_op_160 = jac_blending_1_0_q_0*jac_blending_2_1_q_0;
             const real_t jac_blending_0_2_q_0 = tmp_blending_op_156*tmp_blending_op_158;
             const real_t jac_blending_0_1_q_0 = tmp_blending_op_153*tmp_blending_op_158;
             const real_t tmp_blending_op_162 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
             const real_t jac_blending_0_0_q_0 = tmp_blending_op_152*(-tmp_blending_op_147*tmp_blending_op_149 + tmp_blending_op_151*(tmp_blending_op_143*tmp_blending_op_53 + tmp_blending_op_147));
             const real_t tmp_blending_op_159 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
             const real_t tmp_blending_op_161 = jac_blending_0_0_q_0*jac_blending_2_1_q_0;
             const real_t tmp_blending_op_164 = jac_blending_0_1_q_0*jac_blending_1_2_q_0*jac_blending_2_0_q_0 + jac_blending_0_2_q_0*tmp_blending_op_160 - jac_blending_0_2_q_0*tmp_blending_op_163 - jac_blending_1_2_q_0*tmp_blending_op_161 + jac_blending_2_2_q_0*tmp_blending_op_159 - jac_blending_2_2_q_0*tmp_blending_op_162;
             const real_t tmp_blending_op_165 = 1.0 / (tmp_blending_op_164);
             const real_t abs_det_jac_blending_q_0 = tmp_blending_op_164;
             const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_165*(tmp_blending_op_159 - tmp_blending_op_162);
             const real_t jac_blending_inv_2_1_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_2_0_q_0 - tmp_blending_op_161);
             const real_t jac_blending_inv_2_0_q_0 = tmp_blending_op_165*(tmp_blending_op_160 - tmp_blending_op_163);
             const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_165*(-jac_blending_0_0_q_0*jac_blending_1_2_q_0 + jac_blending_0_2_q_0*jac_blending_1_0_q_0);
             const real_t jac_blending_inv_1_1_q_0 = tmp_blending_op_165*(jac_blending_0_0_q_0*jac_blending_2_2_q_0 - jac_blending_0_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_1_0_q_0 = tmp_blending_op_165*(-jac_blending_1_0_q_0*jac_blending_2_2_q_0 + jac_blending_1_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_1_2_q_0 - jac_blending_0_2_q_0*jac_blending_1_1_q_0);
             const real_t jac_blending_inv_0_1_q_0 = tmp_blending_op_165*(-jac_blending_0_1_q_0*jac_blending_2_2_q_0 + jac_blending_0_2_q_0*jac_blending_2_1_q_0);
             const real_t jac_blending_inv_0_0_q_0 = tmp_blending_op_165*(jac_blending_1_1_q_0*jac_blending_2_2_q_0 - jac_blending_1_2_q_0*jac_blending_2_1_q_0);
             const real_t cp_times_delta_dof_0 = _data_cp_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t cp_times_delta_dof_1 = _data_cp_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t cp_times_delta_dof_2 = _data_cp_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t cp_times_delta_dof_3 = _data_cp_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t cp_times_delta_dof_4 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t cp_times_delta_dof_5 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t cp_times_delta_dof_6 = _data_cp_times_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t cp_times_delta_dof_7 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t cp_times_delta_dof_8 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t cp_times_delta_dof_9 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_0 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_1 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_2 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_3 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_4 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ux_dof_5 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ux_dof_6 = _data_uxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_7 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ux_dof_8 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ux_dof_9 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_0 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_1 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_2 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_3 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_4 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uy_dof_5 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uy_dof_6 = _data_uyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_7 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uy_dof_8 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uy_dof_9 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_0 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_1 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_2 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_3 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_4 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uz_dof_5 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uz_dof_6 = _data_uzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_7 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uz_dof_8 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uz_dof_9 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t tmp_kernel_op_25 = tmp_kernel_op_10*ux_dof_6 + tmp_kernel_op_13*ux_dof_1 + tmp_kernel_op_16*ux_dof_2 + tmp_kernel_op_19*ux_dof_3 + tmp_kernel_op_20*ux_dof_7 + tmp_kernel_op_21*ux_dof_8 + tmp_kernel_op_23*ux_dof_9 + tmp_kernel_op_24*ux_dof_0 + tmp_kernel_op_8*ux_dof_4 + tmp_kernel_op_9*ux_dof_5;
             const real_t tmp_kernel_op_26 = tmp_kernel_op_10*uy_dof_6 + tmp_kernel_op_13*uy_dof_1 + tmp_kernel_op_16*uy_dof_2 + tmp_kernel_op_19*uy_dof_3 + tmp_kernel_op_20*uy_dof_7 + tmp_kernel_op_21*uy_dof_8 + tmp_kernel_op_23*uy_dof_9 + tmp_kernel_op_24*uy_dof_0 + tmp_kernel_op_8*uy_dof_4 + tmp_kernel_op_9*uy_dof_5;
             const real_t tmp_kernel_op_27 = tmp_kernel_op_10*uz_dof_6 + tmp_kernel_op_13*uz_dof_1 + tmp_kernel_op_16*uz_dof_2 + tmp_kernel_op_19*uz_dof_3 + tmp_kernel_op_20*uz_dof_7 + tmp_kernel_op_21*uz_dof_8 + tmp_kernel_op_23*uz_dof_9 + tmp_kernel_op_24*uz_dof_0 + tmp_kernel_op_8*uz_dof_4 + tmp_kernel_op_9*uz_dof_5;
             const real_t tmp_kernel_op_28 = abs_det_jac_affine_BLUE_UP*abs_det_jac_blending_q_0*(cp_times_delta_dof_0*tmp_kernel_op_24 + cp_times_delta_dof_1*tmp_kernel_op_13 + cp_times_delta_dof_2*tmp_kernel_op_16 + cp_times_delta_dof_3*tmp_kernel_op_19 + cp_times_delta_dof_4*tmp_kernel_op_8 + cp_times_delta_dof_5*tmp_kernel_op_9 + cp_times_delta_dof_6*tmp_kernel_op_10 + cp_times_delta_dof_7*tmp_kernel_op_20 + cp_times_delta_dof_8*tmp_kernel_op_21 + cp_times_delta_dof_9*tmp_kernel_op_23)*-0.1333333333333333;
             const real_t tmp_kernel_op_54 = tmp_kernel_op_37*ux_dof_4 + tmp_kernel_op_38*ux_dof_5 + tmp_kernel_op_39*ux_dof_6 + tmp_kernel_op_42*ux_dof_1 + tmp_kernel_op_45*ux_dof_2 + tmp_kernel_op_48*ux_dof_3 + tmp_kernel_op_49*ux_dof_7 + tmp_kernel_op_50*ux_dof_8 + tmp_kernel_op_52*ux_dof_9 + tmp_kernel_op_53*ux_dof_0;
             const real_t tmp_kernel_op_55 = tmp_kernel_op_37*uy_dof_4 + tmp_kernel_op_38*uy_dof_5 + tmp_kernel_op_39*uy_dof_6 + tmp_kernel_op_42*uy_dof_1 + tmp_kernel_op_45*uy_dof_2 + tmp_kernel_op_48*uy_dof_3 + tmp_kernel_op_49*uy_dof_7 + tmp_kernel_op_50*uy_dof_8 + tmp_kernel_op_52*uy_dof_9 + tmp_kernel_op_53*uy_dof_0;
             const real_t tmp_kernel_op_56 = tmp_kernel_op_37*uz_dof_4 + tmp_kernel_op_38*uz_dof_5 + tmp_kernel_op_39*uz_dof_6 + tmp_kernel_op_42*uz_dof_1 + tmp_kernel_op_45*uz_dof_2 + tmp_kernel_op_48*uz_dof_3 + tmp_kernel_op_49*uz_dof_7 + tmp_kernel_op_50*uz_dof_8 + tmp_kernel_op_52*uz_dof_9 + tmp_kernel_op_53*uz_dof_0;
             const real_t tmp_kernel_op_57 = abs_det_jac_affine_BLUE_UP*abs_det_jac_blending_q_1*(cp_times_delta_dof_0*tmp_kernel_op_53 + cp_times_delta_dof_1*tmp_kernel_op_42 + cp_times_delta_dof_2*tmp_kernel_op_45 + cp_times_delta_dof_3*tmp_kernel_op_48 + cp_times_delta_dof_4*tmp_kernel_op_37 + cp_times_delta_dof_5*tmp_kernel_op_38 + cp_times_delta_dof_6*tmp_kernel_op_39 + cp_times_delta_dof_7*tmp_kernel_op_49 + cp_times_delta_dof_8*tmp_kernel_op_50 + cp_times_delta_dof_9*tmp_kernel_op_52)*0.074999999999999983;
             const real_t tmp_kernel_op_83 = tmp_kernel_op_66*ux_dof_4 + tmp_kernel_op_67*ux_dof_5 + tmp_kernel_op_68*ux_dof_6 + tmp_kernel_op_71*ux_dof_1 + tmp_kernel_op_74*ux_dof_2 + tmp_kernel_op_77*ux_dof_3 + tmp_kernel_op_78*ux_dof_7 + tmp_kernel_op_79*ux_dof_8 + tmp_kernel_op_81*ux_dof_9 + tmp_kernel_op_82*ux_dof_0;
             const real_t tmp_kernel_op_84 = tmp_kernel_op_66*uy_dof_4 + tmp_kernel_op_67*uy_dof_5 + tmp_kernel_op_68*uy_dof_6 + tmp_kernel_op_71*uy_dof_1 + tmp_kernel_op_74*uy_dof_2 + tmp_kernel_op_77*uy_dof_3 + tmp_kernel_op_78*uy_dof_7 + tmp_kernel_op_79*uy_dof_8 + tmp_kernel_op_81*uy_dof_9 + tmp_kernel_op_82*uy_dof_0;
             const real_t tmp_kernel_op_85 = tmp_kernel_op_66*uz_dof_4 + tmp_kernel_op_67*uz_dof_5 + tmp_kernel_op_68*uz_dof_6 + tmp_kernel_op_71*uz_dof_1 + tmp_kernel_op_74*uz_dof_2 + tmp_kernel_op_77*uz_dof_3 + tmp_kernel_op_78*uz_dof_7 + tmp_kernel_op_79*uz_dof_8 + tmp_kernel_op_81*uz_dof_9 + tmp_kernel_op_82*uz_dof_0;
             const real_t tmp_kernel_op_86 = abs_det_jac_affine_BLUE_UP*abs_det_jac_blending_q_2*(cp_times_delta_dof_0*tmp_kernel_op_82 + cp_times_delta_dof_1*tmp_kernel_op_71 + cp_times_delta_dof_2*tmp_kernel_op_74 + cp_times_delta_dof_3*tmp_kernel_op_77 + cp_times_delta_dof_4*tmp_kernel_op_66 + cp_times_delta_dof_5*tmp_kernel_op_67 + cp_times_delta_dof_6*tmp_kernel_op_68 + cp_times_delta_dof_7*tmp_kernel_op_78 + cp_times_delta_dof_8*tmp_kernel_op_79 + cp_times_delta_dof_9*tmp_kernel_op_81)*0.074999999999999983;
             const real_t tmp_kernel_op_112 = tmp_kernel_op_100*ux_dof_1 + tmp_kernel_op_103*ux_dof_2 + tmp_kernel_op_106*ux_dof_3 + tmp_kernel_op_107*ux_dof_7 + tmp_kernel_op_108*ux_dof_8 + tmp_kernel_op_110*ux_dof_9 + tmp_kernel_op_111*ux_dof_0 + tmp_kernel_op_95*ux_dof_4 + tmp_kernel_op_96*ux_dof_5 + tmp_kernel_op_97*ux_dof_6;
             const real_t tmp_kernel_op_113 = tmp_kernel_op_100*uy_dof_1 + tmp_kernel_op_103*uy_dof_2 + tmp_kernel_op_106*uy_dof_3 + tmp_kernel_op_107*uy_dof_7 + tmp_kernel_op_108*uy_dof_8 + tmp_kernel_op_110*uy_dof_9 + tmp_kernel_op_111*uy_dof_0 + tmp_kernel_op_95*uy_dof_4 + tmp_kernel_op_96*uy_dof_5 + tmp_kernel_op_97*uy_dof_6;
             const real_t tmp_kernel_op_114 = tmp_kernel_op_100*uz_dof_1 + tmp_kernel_op_103*uz_dof_2 + tmp_kernel_op_106*uz_dof_3 + tmp_kernel_op_107*uz_dof_7 + tmp_kernel_op_108*uz_dof_8 + tmp_kernel_op_110*uz_dof_9 + tmp_kernel_op_111*uz_dof_0 + tmp_kernel_op_95*uz_dof_4 + tmp_kernel_op_96*uz_dof_5 + tmp_kernel_op_97*uz_dof_6;
             const real_t tmp_kernel_op_115 = abs_det_jac_affine_BLUE_UP*abs_det_jac_blending_q_3*(cp_times_delta_dof_0*tmp_kernel_op_111 + cp_times_delta_dof_1*tmp_kernel_op_100 + cp_times_delta_dof_2*tmp_kernel_op_103 + cp_times_delta_dof_3*tmp_kernel_op_106 + cp_times_delta_dof_4*tmp_kernel_op_95 + cp_times_delta_dof_5*tmp_kernel_op_96 + cp_times_delta_dof_6*tmp_kernel_op_97 + cp_times_delta_dof_7*tmp_kernel_op_107 + cp_times_delta_dof_8*tmp_kernel_op_108 + cp_times_delta_dof_9*tmp_kernel_op_110)*0.074999999999999983;
             const real_t tmp_kernel_op_141 = tmp_kernel_op_124*ux_dof_4 + tmp_kernel_op_125*ux_dof_5 + tmp_kernel_op_126*ux_dof_6 + tmp_kernel_op_129*ux_dof_1 + tmp_kernel_op_132*ux_dof_2 + tmp_kernel_op_135*ux_dof_3 + tmp_kernel_op_136*ux_dof_7 + tmp_kernel_op_137*ux_dof_8 + tmp_kernel_op_139*ux_dof_9 + tmp_kernel_op_140*ux_dof_0;
             const real_t tmp_kernel_op_142 = tmp_kernel_op_124*uy_dof_4 + tmp_kernel_op_125*uy_dof_5 + tmp_kernel_op_126*uy_dof_6 + tmp_kernel_op_129*uy_dof_1 + tmp_kernel_op_132*uy_dof_2 + tmp_kernel_op_135*uy_dof_3 + tmp_kernel_op_136*uy_dof_7 + tmp_kernel_op_137*uy_dof_8 + tmp_kernel_op_139*uy_dof_9 + tmp_kernel_op_140*uy_dof_0;
             const real_t tmp_kernel_op_143 = tmp_kernel_op_124*uz_dof_4 + tmp_kernel_op_125*uz_dof_5 + tmp_kernel_op_126*uz_dof_6 + tmp_kernel_op_129*uz_dof_1 + tmp_kernel_op_132*uz_dof_2 + tmp_kernel_op_135*uz_dof_3 + tmp_kernel_op_136*uz_dof_7 + tmp_kernel_op_137*uz_dof_8 + tmp_kernel_op_139*uz_dof_9 + tmp_kernel_op_140*uz_dof_0;
             const real_t tmp_kernel_op_144 = abs_det_jac_affine_BLUE_UP*abs_det_jac_blending_q_4*(cp_times_delta_dof_0*tmp_kernel_op_140 + cp_times_delta_dof_1*tmp_kernel_op_129 + cp_times_delta_dof_2*tmp_kernel_op_132 + cp_times_delta_dof_3*tmp_kernel_op_135 + cp_times_delta_dof_4*tmp_kernel_op_124 + cp_times_delta_dof_5*tmp_kernel_op_125 + cp_times_delta_dof_6*tmp_kernel_op_126 + cp_times_delta_dof_7*tmp_kernel_op_136 + cp_times_delta_dof_8*tmp_kernel_op_137 + cp_times_delta_dof_9*tmp_kernel_op_139)*0.074999999999999983;
             const real_t elMatDiag_0 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_249 + jac_blending_inv_1_0_q_3*tmp_moved_constant_250 + jac_blending_inv_2_0_q_3*tmp_moved_constant_251) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_249 + jac_blending_inv_1_1_q_3*tmp_moved_constant_250 + jac_blending_inv_2_1_q_3*tmp_moved_constant_251) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_249 + jac_blending_inv_1_2_q_3*tmp_moved_constant_250 + jac_blending_inv_2_2_q_3*tmp_moved_constant_251))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_249 + jac_blending_inv_1_0_q_3*tmp_moved_constant_250 + jac_blending_inv_2_0_q_3*tmp_moved_constant_251) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_249 + jac_blending_inv_1_1_q_3*tmp_moved_constant_250 + jac_blending_inv_2_1_q_3*tmp_moved_constant_251) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_249 + jac_blending_inv_1_2_q_3*tmp_moved_constant_250 + jac_blending_inv_2_2_q_3*tmp_moved_constant_251))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_252 + jac_blending_inv_1_0_q_4*tmp_moved_constant_253 + jac_blending_inv_2_0_q_4*tmp_moved_constant_254) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_252 + jac_blending_inv_1_1_q_4*tmp_moved_constant_253 + jac_blending_inv_2_1_q_4*tmp_moved_constant_254) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_252 + jac_blending_inv_1_2_q_4*tmp_moved_constant_253 + jac_blending_inv_2_2_q_4*tmp_moved_constant_254))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_252 + jac_blending_inv_1_0_q_4*tmp_moved_constant_253 + jac_blending_inv_2_0_q_4*tmp_moved_constant_254) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_252 + jac_blending_inv_1_1_q_4*tmp_moved_constant_253 + jac_blending_inv_2_1_q_4*tmp_moved_constant_254) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_252 + jac_blending_inv_1_2_q_4*tmp_moved_constant_253 + jac_blending_inv_2_2_q_4*tmp_moved_constant_254))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_240 + jac_blending_inv_1_0_q_0*tmp_moved_constant_241 + jac_blending_inv_2_0_q_0*tmp_moved_constant_242) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_240 + jac_blending_inv_1_1_q_0*tmp_moved_constant_241 + jac_blending_inv_2_1_q_0*tmp_moved_constant_242) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_240 + jac_blending_inv_1_2_q_0*tmp_moved_constant_241 + jac_blending_inv_2_2_q_0*tmp_moved_constant_242))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_240 + jac_blending_inv_1_0_q_0*tmp_moved_constant_241 + jac_blending_inv_2_0_q_0*tmp_moved_constant_242) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_240 + jac_blending_inv_1_1_q_0*tmp_moved_constant_241 + jac_blending_inv_2_1_q_0*tmp_moved_constant_242) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_240 + jac_blending_inv_1_2_q_0*tmp_moved_constant_241 + jac_blending_inv_2_2_q_0*tmp_moved_constant_242))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_243 + jac_blending_inv_1_0_q_1*tmp_moved_constant_244 + jac_blending_inv_2_0_q_1*tmp_moved_constant_245) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_243 + jac_blending_inv_1_1_q_1*tmp_moved_constant_244 + jac_blending_inv_2_1_q_1*tmp_moved_constant_245) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_243 + jac_blending_inv_1_2_q_1*tmp_moved_constant_244 + jac_blending_inv_2_2_q_1*tmp_moved_constant_245))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_243 + jac_blending_inv_1_0_q_1*tmp_moved_constant_244 + jac_blending_inv_2_0_q_1*tmp_moved_constant_245) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_243 + jac_blending_inv_1_1_q_1*tmp_moved_constant_244 + jac_blending_inv_2_1_q_1*tmp_moved_constant_245) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_243 + jac_blending_inv_1_2_q_1*tmp_moved_constant_244 + jac_blending_inv_2_2_q_1*tmp_moved_constant_245))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_246 + jac_blending_inv_1_0_q_2*tmp_moved_constant_247 + jac_blending_inv_2_0_q_2*tmp_moved_constant_248) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_246 + jac_blending_inv_1_1_q_2*tmp_moved_constant_247 + jac_blending_inv_2_1_q_2*tmp_moved_constant_248) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_246 + jac_blending_inv_1_2_q_2*tmp_moved_constant_247 + jac_blending_inv_2_2_q_2*tmp_moved_constant_248))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_246 + jac_blending_inv_1_0_q_2*tmp_moved_constant_247 + jac_blending_inv_2_0_q_2*tmp_moved_constant_248) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_246 + jac_blending_inv_1_1_q_2*tmp_moved_constant_247 + jac_blending_inv_2_1_q_2*tmp_moved_constant_248) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_246 + jac_blending_inv_1_2_q_2*tmp_moved_constant_247 + jac_blending_inv_2_2_q_2*tmp_moved_constant_248)));
             const real_t elMatDiag_1 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_264 + jac_blending_inv_1_0_q_3*tmp_moved_constant_265 + jac_blending_inv_2_0_q_3*tmp_moved_constant_266) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_264 + jac_blending_inv_1_1_q_3*tmp_moved_constant_265 + jac_blending_inv_2_1_q_3*tmp_moved_constant_266) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_264 + jac_blending_inv_1_2_q_3*tmp_moved_constant_265 + jac_blending_inv_2_2_q_3*tmp_moved_constant_266))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_264 + jac_blending_inv_1_0_q_3*tmp_moved_constant_265 + jac_blending_inv_2_0_q_3*tmp_moved_constant_266) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_264 + jac_blending_inv_1_1_q_3*tmp_moved_constant_265 + jac_blending_inv_2_1_q_3*tmp_moved_constant_266) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_264 + jac_blending_inv_1_2_q_3*tmp_moved_constant_265 + jac_blending_inv_2_2_q_3*tmp_moved_constant_266))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_267 + jac_blending_inv_1_0_q_4*tmp_moved_constant_268 + jac_blending_inv_2_0_q_4*tmp_moved_constant_269) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_267 + jac_blending_inv_1_1_q_4*tmp_moved_constant_268 + jac_blending_inv_2_1_q_4*tmp_moved_constant_269) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_267 + jac_blending_inv_1_2_q_4*tmp_moved_constant_268 + jac_blending_inv_2_2_q_4*tmp_moved_constant_269))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_267 + jac_blending_inv_1_0_q_4*tmp_moved_constant_268 + jac_blending_inv_2_0_q_4*tmp_moved_constant_269) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_267 + jac_blending_inv_1_1_q_4*tmp_moved_constant_268 + jac_blending_inv_2_1_q_4*tmp_moved_constant_269) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_267 + jac_blending_inv_1_2_q_4*tmp_moved_constant_268 + jac_blending_inv_2_2_q_4*tmp_moved_constant_269))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_255 + jac_blending_inv_1_0_q_0*tmp_moved_constant_256 + jac_blending_inv_2_0_q_0*tmp_moved_constant_257) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_255 + jac_blending_inv_1_1_q_0*tmp_moved_constant_256 + jac_blending_inv_2_1_q_0*tmp_moved_constant_257) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_255 + jac_blending_inv_1_2_q_0*tmp_moved_constant_256 + jac_blending_inv_2_2_q_0*tmp_moved_constant_257))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_255 + jac_blending_inv_1_0_q_0*tmp_moved_constant_256 + jac_blending_inv_2_0_q_0*tmp_moved_constant_257) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_255 + jac_blending_inv_1_1_q_0*tmp_moved_constant_256 + jac_blending_inv_2_1_q_0*tmp_moved_constant_257) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_255 + jac_blending_inv_1_2_q_0*tmp_moved_constant_256 + jac_blending_inv_2_2_q_0*tmp_moved_constant_257))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_258 + jac_blending_inv_1_0_q_1*tmp_moved_constant_259 + jac_blending_inv_2_0_q_1*tmp_moved_constant_260) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_258 + jac_blending_inv_1_1_q_1*tmp_moved_constant_259 + jac_blending_inv_2_1_q_1*tmp_moved_constant_260) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_258 + jac_blending_inv_1_2_q_1*tmp_moved_constant_259 + jac_blending_inv_2_2_q_1*tmp_moved_constant_260))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_258 + jac_blending_inv_1_0_q_1*tmp_moved_constant_259 + jac_blending_inv_2_0_q_1*tmp_moved_constant_260) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_258 + jac_blending_inv_1_1_q_1*tmp_moved_constant_259 + jac_blending_inv_2_1_q_1*tmp_moved_constant_260) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_258 + jac_blending_inv_1_2_q_1*tmp_moved_constant_259 + jac_blending_inv_2_2_q_1*tmp_moved_constant_260))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_261 + jac_blending_inv_1_0_q_2*tmp_moved_constant_262 + jac_blending_inv_2_0_q_2*tmp_moved_constant_263) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_261 + jac_blending_inv_1_1_q_2*tmp_moved_constant_262 + jac_blending_inv_2_1_q_2*tmp_moved_constant_263) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_261 + jac_blending_inv_1_2_q_2*tmp_moved_constant_262 + jac_blending_inv_2_2_q_2*tmp_moved_constant_263))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_261 + jac_blending_inv_1_0_q_2*tmp_moved_constant_262 + jac_blending_inv_2_0_q_2*tmp_moved_constant_263) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_261 + jac_blending_inv_1_1_q_2*tmp_moved_constant_262 + jac_blending_inv_2_1_q_2*tmp_moved_constant_263) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_261 + jac_blending_inv_1_2_q_2*tmp_moved_constant_262 + jac_blending_inv_2_2_q_2*tmp_moved_constant_263)));
             const real_t elMatDiag_2 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_279 + jac_blending_inv_1_0_q_3*tmp_moved_constant_280 + jac_blending_inv_2_0_q_3*tmp_moved_constant_281) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_279 + jac_blending_inv_1_1_q_3*tmp_moved_constant_280 + jac_blending_inv_2_1_q_3*tmp_moved_constant_281) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_279 + jac_blending_inv_1_2_q_3*tmp_moved_constant_280 + jac_blending_inv_2_2_q_3*tmp_moved_constant_281))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_279 + jac_blending_inv_1_0_q_3*tmp_moved_constant_280 + jac_blending_inv_2_0_q_3*tmp_moved_constant_281) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_279 + jac_blending_inv_1_1_q_3*tmp_moved_constant_280 + jac_blending_inv_2_1_q_3*tmp_moved_constant_281) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_279 + jac_blending_inv_1_2_q_3*tmp_moved_constant_280 + jac_blending_inv_2_2_q_3*tmp_moved_constant_281))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_282 + jac_blending_inv_1_0_q_4*tmp_moved_constant_283 + jac_blending_inv_2_0_q_4*tmp_moved_constant_284) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_282 + jac_blending_inv_1_1_q_4*tmp_moved_constant_283 + jac_blending_inv_2_1_q_4*tmp_moved_constant_284) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_282 + jac_blending_inv_1_2_q_4*tmp_moved_constant_283 + jac_blending_inv_2_2_q_4*tmp_moved_constant_284))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_282 + jac_blending_inv_1_0_q_4*tmp_moved_constant_283 + jac_blending_inv_2_0_q_4*tmp_moved_constant_284) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_282 + jac_blending_inv_1_1_q_4*tmp_moved_constant_283 + jac_blending_inv_2_1_q_4*tmp_moved_constant_284) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_282 + jac_blending_inv_1_2_q_4*tmp_moved_constant_283 + jac_blending_inv_2_2_q_4*tmp_moved_constant_284))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_270 + jac_blending_inv_1_0_q_0*tmp_moved_constant_271 + jac_blending_inv_2_0_q_0*tmp_moved_constant_272) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_270 + jac_blending_inv_1_1_q_0*tmp_moved_constant_271 + jac_blending_inv_2_1_q_0*tmp_moved_constant_272) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_270 + jac_blending_inv_1_2_q_0*tmp_moved_constant_271 + jac_blending_inv_2_2_q_0*tmp_moved_constant_272))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_270 + jac_blending_inv_1_0_q_0*tmp_moved_constant_271 + jac_blending_inv_2_0_q_0*tmp_moved_constant_272) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_270 + jac_blending_inv_1_1_q_0*tmp_moved_constant_271 + jac_blending_inv_2_1_q_0*tmp_moved_constant_272) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_270 + jac_blending_inv_1_2_q_0*tmp_moved_constant_271 + jac_blending_inv_2_2_q_0*tmp_moved_constant_272))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_273 + jac_blending_inv_1_0_q_1*tmp_moved_constant_274 + jac_blending_inv_2_0_q_1*tmp_moved_constant_275) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_273 + jac_blending_inv_1_1_q_1*tmp_moved_constant_274 + jac_blending_inv_2_1_q_1*tmp_moved_constant_275) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_273 + jac_blending_inv_1_2_q_1*tmp_moved_constant_274 + jac_blending_inv_2_2_q_1*tmp_moved_constant_275))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_273 + jac_blending_inv_1_0_q_1*tmp_moved_constant_274 + jac_blending_inv_2_0_q_1*tmp_moved_constant_275) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_273 + jac_blending_inv_1_1_q_1*tmp_moved_constant_274 + jac_blending_inv_2_1_q_1*tmp_moved_constant_275) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_273 + jac_blending_inv_1_2_q_1*tmp_moved_constant_274 + jac_blending_inv_2_2_q_1*tmp_moved_constant_275))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_276 + jac_blending_inv_1_0_q_2*tmp_moved_constant_277 + jac_blending_inv_2_0_q_2*tmp_moved_constant_278) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_276 + jac_blending_inv_1_1_q_2*tmp_moved_constant_277 + jac_blending_inv_2_1_q_2*tmp_moved_constant_278) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_276 + jac_blending_inv_1_2_q_2*tmp_moved_constant_277 + jac_blending_inv_2_2_q_2*tmp_moved_constant_278))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_276 + jac_blending_inv_1_0_q_2*tmp_moved_constant_277 + jac_blending_inv_2_0_q_2*tmp_moved_constant_278) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_276 + jac_blending_inv_1_1_q_2*tmp_moved_constant_277 + jac_blending_inv_2_1_q_2*tmp_moved_constant_278) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_276 + jac_blending_inv_1_2_q_2*tmp_moved_constant_277 + jac_blending_inv_2_2_q_2*tmp_moved_constant_278)));
             const real_t elMatDiag_3 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_294 + jac_blending_inv_1_0_q_3*tmp_moved_constant_295 + jac_blending_inv_2_0_q_3*tmp_moved_constant_296) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_294 + jac_blending_inv_1_1_q_3*tmp_moved_constant_295 + jac_blending_inv_2_1_q_3*tmp_moved_constant_296) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_294 + jac_blending_inv_1_2_q_3*tmp_moved_constant_295 + jac_blending_inv_2_2_q_3*tmp_moved_constant_296))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_294 + jac_blending_inv_1_0_q_3*tmp_moved_constant_295 + jac_blending_inv_2_0_q_3*tmp_moved_constant_296) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_294 + jac_blending_inv_1_1_q_3*tmp_moved_constant_295 + jac_blending_inv_2_1_q_3*tmp_moved_constant_296) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_294 + jac_blending_inv_1_2_q_3*tmp_moved_constant_295 + jac_blending_inv_2_2_q_3*tmp_moved_constant_296))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_297 + jac_blending_inv_1_0_q_4*tmp_moved_constant_298 + jac_blending_inv_2_0_q_4*tmp_moved_constant_299) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_297 + jac_blending_inv_1_1_q_4*tmp_moved_constant_298 + jac_blending_inv_2_1_q_4*tmp_moved_constant_299) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_297 + jac_blending_inv_1_2_q_4*tmp_moved_constant_298 + jac_blending_inv_2_2_q_4*tmp_moved_constant_299))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_297 + jac_blending_inv_1_0_q_4*tmp_moved_constant_298 + jac_blending_inv_2_0_q_4*tmp_moved_constant_299) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_297 + jac_blending_inv_1_1_q_4*tmp_moved_constant_298 + jac_blending_inv_2_1_q_4*tmp_moved_constant_299) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_297 + jac_blending_inv_1_2_q_4*tmp_moved_constant_298 + jac_blending_inv_2_2_q_4*tmp_moved_constant_299))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_285 + jac_blending_inv_1_0_q_0*tmp_moved_constant_286 + jac_blending_inv_2_0_q_0*tmp_moved_constant_287) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_285 + jac_blending_inv_1_1_q_0*tmp_moved_constant_286 + jac_blending_inv_2_1_q_0*tmp_moved_constant_287) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_285 + jac_blending_inv_1_2_q_0*tmp_moved_constant_286 + jac_blending_inv_2_2_q_0*tmp_moved_constant_287))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_285 + jac_blending_inv_1_0_q_0*tmp_moved_constant_286 + jac_blending_inv_2_0_q_0*tmp_moved_constant_287) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_285 + jac_blending_inv_1_1_q_0*tmp_moved_constant_286 + jac_blending_inv_2_1_q_0*tmp_moved_constant_287) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_285 + jac_blending_inv_1_2_q_0*tmp_moved_constant_286 + jac_blending_inv_2_2_q_0*tmp_moved_constant_287))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_288 + jac_blending_inv_1_0_q_1*tmp_moved_constant_289 + jac_blending_inv_2_0_q_1*tmp_moved_constant_290) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_288 + jac_blending_inv_1_1_q_1*tmp_moved_constant_289 + jac_blending_inv_2_1_q_1*tmp_moved_constant_290) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_288 + jac_blending_inv_1_2_q_1*tmp_moved_constant_289 + jac_blending_inv_2_2_q_1*tmp_moved_constant_290))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_288 + jac_blending_inv_1_0_q_1*tmp_moved_constant_289 + jac_blending_inv_2_0_q_1*tmp_moved_constant_290) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_288 + jac_blending_inv_1_1_q_1*tmp_moved_constant_289 + jac_blending_inv_2_1_q_1*tmp_moved_constant_290) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_288 + jac_blending_inv_1_2_q_1*tmp_moved_constant_289 + jac_blending_inv_2_2_q_1*tmp_moved_constant_290))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_291 + jac_blending_inv_1_0_q_2*tmp_moved_constant_292 + jac_blending_inv_2_0_q_2*tmp_moved_constant_293) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_291 + jac_blending_inv_1_1_q_2*tmp_moved_constant_292 + jac_blending_inv_2_1_q_2*tmp_moved_constant_293) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_291 + jac_blending_inv_1_2_q_2*tmp_moved_constant_292 + jac_blending_inv_2_2_q_2*tmp_moved_constant_293))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_291 + jac_blending_inv_1_0_q_2*tmp_moved_constant_292 + jac_blending_inv_2_0_q_2*tmp_moved_constant_293) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_291 + jac_blending_inv_1_1_q_2*tmp_moved_constant_292 + jac_blending_inv_2_1_q_2*tmp_moved_constant_293) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_291 + jac_blending_inv_1_2_q_2*tmp_moved_constant_292 + jac_blending_inv_2_2_q_2*tmp_moved_constant_293)));
             const real_t elMatDiag_4 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_329 + jac_blending_inv_1_0_q_3*tmp_moved_constant_332 + jac_blending_inv_2_0_q_3*tmp_moved_constant_335) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_329 + jac_blending_inv_1_1_q_3*tmp_moved_constant_332 + jac_blending_inv_2_1_q_3*tmp_moved_constant_335) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_329 + jac_blending_inv_1_2_q_3*tmp_moved_constant_332 + jac_blending_inv_2_2_q_3*tmp_moved_constant_335))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_329 + jac_blending_inv_1_0_q_3*tmp_moved_constant_332 + jac_blending_inv_2_0_q_3*tmp_moved_constant_335) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_329 + jac_blending_inv_1_1_q_3*tmp_moved_constant_332 + jac_blending_inv_2_1_q_3*tmp_moved_constant_335) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_329 + jac_blending_inv_1_2_q_3*tmp_moved_constant_332 + jac_blending_inv_2_2_q_3*tmp_moved_constant_335))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_338 + jac_blending_inv_1_0_q_4*tmp_moved_constant_341 + jac_blending_inv_2_0_q_4*tmp_moved_constant_344) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_338 + jac_blending_inv_1_1_q_4*tmp_moved_constant_341 + jac_blending_inv_2_1_q_4*tmp_moved_constant_344) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_338 + jac_blending_inv_1_2_q_4*tmp_moved_constant_341 + jac_blending_inv_2_2_q_4*tmp_moved_constant_344))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_338 + jac_blending_inv_1_0_q_4*tmp_moved_constant_341 + jac_blending_inv_2_0_q_4*tmp_moved_constant_344) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_338 + jac_blending_inv_1_1_q_4*tmp_moved_constant_341 + jac_blending_inv_2_1_q_4*tmp_moved_constant_344) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_338 + jac_blending_inv_1_2_q_4*tmp_moved_constant_341 + jac_blending_inv_2_2_q_4*tmp_moved_constant_344))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_302 + jac_blending_inv_1_0_q_0*tmp_moved_constant_305 + jac_blending_inv_2_0_q_0*tmp_moved_constant_308) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_302 + jac_blending_inv_1_1_q_0*tmp_moved_constant_305 + jac_blending_inv_2_1_q_0*tmp_moved_constant_308) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_302 + jac_blending_inv_1_2_q_0*tmp_moved_constant_305 + jac_blending_inv_2_2_q_0*tmp_moved_constant_308))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_302 + jac_blending_inv_1_0_q_0*tmp_moved_constant_305 + jac_blending_inv_2_0_q_0*tmp_moved_constant_308) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_302 + jac_blending_inv_1_1_q_0*tmp_moved_constant_305 + jac_blending_inv_2_1_q_0*tmp_moved_constant_308) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_302 + jac_blending_inv_1_2_q_0*tmp_moved_constant_305 + jac_blending_inv_2_2_q_0*tmp_moved_constant_308))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_311 + jac_blending_inv_1_0_q_1*tmp_moved_constant_314 + jac_blending_inv_2_0_q_1*tmp_moved_constant_317) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_311 + jac_blending_inv_1_1_q_1*tmp_moved_constant_314 + jac_blending_inv_2_1_q_1*tmp_moved_constant_317) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_311 + jac_blending_inv_1_2_q_1*tmp_moved_constant_314 + jac_blending_inv_2_2_q_1*tmp_moved_constant_317))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_311 + jac_blending_inv_1_0_q_1*tmp_moved_constant_314 + jac_blending_inv_2_0_q_1*tmp_moved_constant_317) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_311 + jac_blending_inv_1_1_q_1*tmp_moved_constant_314 + jac_blending_inv_2_1_q_1*tmp_moved_constant_317) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_311 + jac_blending_inv_1_2_q_1*tmp_moved_constant_314 + jac_blending_inv_2_2_q_1*tmp_moved_constant_317))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_320 + jac_blending_inv_1_0_q_2*tmp_moved_constant_323 + jac_blending_inv_2_0_q_2*tmp_moved_constant_326) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_320 + jac_blending_inv_1_1_q_2*tmp_moved_constant_323 + jac_blending_inv_2_1_q_2*tmp_moved_constant_326) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_320 + jac_blending_inv_1_2_q_2*tmp_moved_constant_323 + jac_blending_inv_2_2_q_2*tmp_moved_constant_326))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_320 + jac_blending_inv_1_0_q_2*tmp_moved_constant_323 + jac_blending_inv_2_0_q_2*tmp_moved_constant_326) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_320 + jac_blending_inv_1_1_q_2*tmp_moved_constant_323 + jac_blending_inv_2_1_q_2*tmp_moved_constant_326) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_320 + jac_blending_inv_1_2_q_2*tmp_moved_constant_323 + jac_blending_inv_2_2_q_2*tmp_moved_constant_326)));
             const real_t elMatDiag_5 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_374 + jac_blending_inv_1_0_q_3*tmp_moved_constant_377 + jac_blending_inv_2_0_q_3*tmp_moved_constant_380) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_374 + jac_blending_inv_1_1_q_3*tmp_moved_constant_377 + jac_blending_inv_2_1_q_3*tmp_moved_constant_380) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_374 + jac_blending_inv_1_2_q_3*tmp_moved_constant_377 + jac_blending_inv_2_2_q_3*tmp_moved_constant_380))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_374 + jac_blending_inv_1_0_q_3*tmp_moved_constant_377 + jac_blending_inv_2_0_q_3*tmp_moved_constant_380) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_374 + jac_blending_inv_1_1_q_3*tmp_moved_constant_377 + jac_blending_inv_2_1_q_3*tmp_moved_constant_380) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_374 + jac_blending_inv_1_2_q_3*tmp_moved_constant_377 + jac_blending_inv_2_2_q_3*tmp_moved_constant_380))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_383 + jac_blending_inv_1_0_q_4*tmp_moved_constant_386 + jac_blending_inv_2_0_q_4*tmp_moved_constant_389) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_383 + jac_blending_inv_1_1_q_4*tmp_moved_constant_386 + jac_blending_inv_2_1_q_4*tmp_moved_constant_389) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_383 + jac_blending_inv_1_2_q_4*tmp_moved_constant_386 + jac_blending_inv_2_2_q_4*tmp_moved_constant_389))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_383 + jac_blending_inv_1_0_q_4*tmp_moved_constant_386 + jac_blending_inv_2_0_q_4*tmp_moved_constant_389) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_383 + jac_blending_inv_1_1_q_4*tmp_moved_constant_386 + jac_blending_inv_2_1_q_4*tmp_moved_constant_389) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_383 + jac_blending_inv_1_2_q_4*tmp_moved_constant_386 + jac_blending_inv_2_2_q_4*tmp_moved_constant_389))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_347 + jac_blending_inv_1_0_q_0*tmp_moved_constant_350 + jac_blending_inv_2_0_q_0*tmp_moved_constant_353) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_347 + jac_blending_inv_1_1_q_0*tmp_moved_constant_350 + jac_blending_inv_2_1_q_0*tmp_moved_constant_353) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_347 + jac_blending_inv_1_2_q_0*tmp_moved_constant_350 + jac_blending_inv_2_2_q_0*tmp_moved_constant_353))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_347 + jac_blending_inv_1_0_q_0*tmp_moved_constant_350 + jac_blending_inv_2_0_q_0*tmp_moved_constant_353) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_347 + jac_blending_inv_1_1_q_0*tmp_moved_constant_350 + jac_blending_inv_2_1_q_0*tmp_moved_constant_353) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_347 + jac_blending_inv_1_2_q_0*tmp_moved_constant_350 + jac_blending_inv_2_2_q_0*tmp_moved_constant_353))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_356 + jac_blending_inv_1_0_q_1*tmp_moved_constant_359 + jac_blending_inv_2_0_q_1*tmp_moved_constant_362) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_356 + jac_blending_inv_1_1_q_1*tmp_moved_constant_359 + jac_blending_inv_2_1_q_1*tmp_moved_constant_362) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_356 + jac_blending_inv_1_2_q_1*tmp_moved_constant_359 + jac_blending_inv_2_2_q_1*tmp_moved_constant_362))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_356 + jac_blending_inv_1_0_q_1*tmp_moved_constant_359 + jac_blending_inv_2_0_q_1*tmp_moved_constant_362) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_356 + jac_blending_inv_1_1_q_1*tmp_moved_constant_359 + jac_blending_inv_2_1_q_1*tmp_moved_constant_362) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_356 + jac_blending_inv_1_2_q_1*tmp_moved_constant_359 + jac_blending_inv_2_2_q_1*tmp_moved_constant_362))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_365 + jac_blending_inv_1_0_q_2*tmp_moved_constant_368 + jac_blending_inv_2_0_q_2*tmp_moved_constant_371) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_365 + jac_blending_inv_1_1_q_2*tmp_moved_constant_368 + jac_blending_inv_2_1_q_2*tmp_moved_constant_371) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_365 + jac_blending_inv_1_2_q_2*tmp_moved_constant_368 + jac_blending_inv_2_2_q_2*tmp_moved_constant_371))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_365 + jac_blending_inv_1_0_q_2*tmp_moved_constant_368 + jac_blending_inv_2_0_q_2*tmp_moved_constant_371) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_365 + jac_blending_inv_1_1_q_2*tmp_moved_constant_368 + jac_blending_inv_2_1_q_2*tmp_moved_constant_371) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_365 + jac_blending_inv_1_2_q_2*tmp_moved_constant_368 + jac_blending_inv_2_2_q_2*tmp_moved_constant_371)));
             const real_t elMatDiag_6 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_419 + jac_blending_inv_1_0_q_3*tmp_moved_constant_422 + jac_blending_inv_2_0_q_3*tmp_moved_constant_425) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_419 + jac_blending_inv_1_1_q_3*tmp_moved_constant_422 + jac_blending_inv_2_1_q_3*tmp_moved_constant_425) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_419 + jac_blending_inv_1_2_q_3*tmp_moved_constant_422 + jac_blending_inv_2_2_q_3*tmp_moved_constant_425))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_419 + jac_blending_inv_1_0_q_3*tmp_moved_constant_422 + jac_blending_inv_2_0_q_3*tmp_moved_constant_425) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_419 + jac_blending_inv_1_1_q_3*tmp_moved_constant_422 + jac_blending_inv_2_1_q_3*tmp_moved_constant_425) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_419 + jac_blending_inv_1_2_q_3*tmp_moved_constant_422 + jac_blending_inv_2_2_q_3*tmp_moved_constant_425))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_428 + jac_blending_inv_1_0_q_4*tmp_moved_constant_431 + jac_blending_inv_2_0_q_4*tmp_moved_constant_434) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_428 + jac_blending_inv_1_1_q_4*tmp_moved_constant_431 + jac_blending_inv_2_1_q_4*tmp_moved_constant_434) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_428 + jac_blending_inv_1_2_q_4*tmp_moved_constant_431 + jac_blending_inv_2_2_q_4*tmp_moved_constant_434))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_428 + jac_blending_inv_1_0_q_4*tmp_moved_constant_431 + jac_blending_inv_2_0_q_4*tmp_moved_constant_434) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_428 + jac_blending_inv_1_1_q_4*tmp_moved_constant_431 + jac_blending_inv_2_1_q_4*tmp_moved_constant_434) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_428 + jac_blending_inv_1_2_q_4*tmp_moved_constant_431 + jac_blending_inv_2_2_q_4*tmp_moved_constant_434))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_392 + jac_blending_inv_1_0_q_0*tmp_moved_constant_395 + jac_blending_inv_2_0_q_0*tmp_moved_constant_398) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_392 + jac_blending_inv_1_1_q_0*tmp_moved_constant_395 + jac_blending_inv_2_1_q_0*tmp_moved_constant_398) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_392 + jac_blending_inv_1_2_q_0*tmp_moved_constant_395 + jac_blending_inv_2_2_q_0*tmp_moved_constant_398))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_392 + jac_blending_inv_1_0_q_0*tmp_moved_constant_395 + jac_blending_inv_2_0_q_0*tmp_moved_constant_398) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_392 + jac_blending_inv_1_1_q_0*tmp_moved_constant_395 + jac_blending_inv_2_1_q_0*tmp_moved_constant_398) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_392 + jac_blending_inv_1_2_q_0*tmp_moved_constant_395 + jac_blending_inv_2_2_q_0*tmp_moved_constant_398))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_401 + jac_blending_inv_1_0_q_1*tmp_moved_constant_404 + jac_blending_inv_2_0_q_1*tmp_moved_constant_407) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_401 + jac_blending_inv_1_1_q_1*tmp_moved_constant_404 + jac_blending_inv_2_1_q_1*tmp_moved_constant_407) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_401 + jac_blending_inv_1_2_q_1*tmp_moved_constant_404 + jac_blending_inv_2_2_q_1*tmp_moved_constant_407))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_401 + jac_blending_inv_1_0_q_1*tmp_moved_constant_404 + jac_blending_inv_2_0_q_1*tmp_moved_constant_407) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_401 + jac_blending_inv_1_1_q_1*tmp_moved_constant_404 + jac_blending_inv_2_1_q_1*tmp_moved_constant_407) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_401 + jac_blending_inv_1_2_q_1*tmp_moved_constant_404 + jac_blending_inv_2_2_q_1*tmp_moved_constant_407))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_410 + jac_blending_inv_1_0_q_2*tmp_moved_constant_413 + jac_blending_inv_2_0_q_2*tmp_moved_constant_416) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_410 + jac_blending_inv_1_1_q_2*tmp_moved_constant_413 + jac_blending_inv_2_1_q_2*tmp_moved_constant_416) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_410 + jac_blending_inv_1_2_q_2*tmp_moved_constant_413 + jac_blending_inv_2_2_q_2*tmp_moved_constant_416))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_410 + jac_blending_inv_1_0_q_2*tmp_moved_constant_413 + jac_blending_inv_2_0_q_2*tmp_moved_constant_416) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_410 + jac_blending_inv_1_1_q_2*tmp_moved_constant_413 + jac_blending_inv_2_1_q_2*tmp_moved_constant_416) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_410 + jac_blending_inv_1_2_q_2*tmp_moved_constant_413 + jac_blending_inv_2_2_q_2*tmp_moved_constant_416)));
             const real_t elMatDiag_7 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_444 + jac_blending_inv_1_0_q_3*tmp_moved_constant_445 + jac_blending_inv_2_0_q_3*tmp_moved_constant_446) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_444 + jac_blending_inv_1_1_q_3*tmp_moved_constant_445 + jac_blending_inv_2_1_q_3*tmp_moved_constant_446) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_444 + jac_blending_inv_1_2_q_3*tmp_moved_constant_445 + jac_blending_inv_2_2_q_3*tmp_moved_constant_446))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_444 + jac_blending_inv_1_0_q_3*tmp_moved_constant_445 + jac_blending_inv_2_0_q_3*tmp_moved_constant_446) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_444 + jac_blending_inv_1_1_q_3*tmp_moved_constant_445 + jac_blending_inv_2_1_q_3*tmp_moved_constant_446) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_444 + jac_blending_inv_1_2_q_3*tmp_moved_constant_445 + jac_blending_inv_2_2_q_3*tmp_moved_constant_446))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_447 + jac_blending_inv_1_0_q_4*tmp_moved_constant_448 + jac_blending_inv_2_0_q_4*tmp_moved_constant_449) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_447 + jac_blending_inv_1_1_q_4*tmp_moved_constant_448 + jac_blending_inv_2_1_q_4*tmp_moved_constant_449) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_447 + jac_blending_inv_1_2_q_4*tmp_moved_constant_448 + jac_blending_inv_2_2_q_4*tmp_moved_constant_449))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_447 + jac_blending_inv_1_0_q_4*tmp_moved_constant_448 + jac_blending_inv_2_0_q_4*tmp_moved_constant_449) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_447 + jac_blending_inv_1_1_q_4*tmp_moved_constant_448 + jac_blending_inv_2_1_q_4*tmp_moved_constant_449) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_447 + jac_blending_inv_1_2_q_4*tmp_moved_constant_448 + jac_blending_inv_2_2_q_4*tmp_moved_constant_449))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_435 + jac_blending_inv_1_0_q_0*tmp_moved_constant_436 + jac_blending_inv_2_0_q_0*tmp_moved_constant_437) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_435 + jac_blending_inv_1_1_q_0*tmp_moved_constant_436 + jac_blending_inv_2_1_q_0*tmp_moved_constant_437) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_435 + jac_blending_inv_1_2_q_0*tmp_moved_constant_436 + jac_blending_inv_2_2_q_0*tmp_moved_constant_437))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_435 + jac_blending_inv_1_0_q_0*tmp_moved_constant_436 + jac_blending_inv_2_0_q_0*tmp_moved_constant_437) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_435 + jac_blending_inv_1_1_q_0*tmp_moved_constant_436 + jac_blending_inv_2_1_q_0*tmp_moved_constant_437) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_435 + jac_blending_inv_1_2_q_0*tmp_moved_constant_436 + jac_blending_inv_2_2_q_0*tmp_moved_constant_437))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_438 + jac_blending_inv_1_0_q_1*tmp_moved_constant_439 + jac_blending_inv_2_0_q_1*tmp_moved_constant_440) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_438 + jac_blending_inv_1_1_q_1*tmp_moved_constant_439 + jac_blending_inv_2_1_q_1*tmp_moved_constant_440) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_438 + jac_blending_inv_1_2_q_1*tmp_moved_constant_439 + jac_blending_inv_2_2_q_1*tmp_moved_constant_440))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_438 + jac_blending_inv_1_0_q_1*tmp_moved_constant_439 + jac_blending_inv_2_0_q_1*tmp_moved_constant_440) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_438 + jac_blending_inv_1_1_q_1*tmp_moved_constant_439 + jac_blending_inv_2_1_q_1*tmp_moved_constant_440) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_438 + jac_blending_inv_1_2_q_1*tmp_moved_constant_439 + jac_blending_inv_2_2_q_1*tmp_moved_constant_440))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_441 + jac_blending_inv_1_0_q_2*tmp_moved_constant_442 + jac_blending_inv_2_0_q_2*tmp_moved_constant_443) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_441 + jac_blending_inv_1_1_q_2*tmp_moved_constant_442 + jac_blending_inv_2_1_q_2*tmp_moved_constant_443) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_441 + jac_blending_inv_1_2_q_2*tmp_moved_constant_442 + jac_blending_inv_2_2_q_2*tmp_moved_constant_443))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_441 + jac_blending_inv_1_0_q_2*tmp_moved_constant_442 + jac_blending_inv_2_0_q_2*tmp_moved_constant_443) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_441 + jac_blending_inv_1_1_q_2*tmp_moved_constant_442 + jac_blending_inv_2_1_q_2*tmp_moved_constant_443) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_441 + jac_blending_inv_1_2_q_2*tmp_moved_constant_442 + jac_blending_inv_2_2_q_2*tmp_moved_constant_443)));
             const real_t elMatDiag_8 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_459 + jac_blending_inv_1_0_q_3*tmp_moved_constant_460 + jac_blending_inv_2_0_q_3*tmp_moved_constant_461) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_459 + jac_blending_inv_1_1_q_3*tmp_moved_constant_460 + jac_blending_inv_2_1_q_3*tmp_moved_constant_461) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_459 + jac_blending_inv_1_2_q_3*tmp_moved_constant_460 + jac_blending_inv_2_2_q_3*tmp_moved_constant_461))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_459 + jac_blending_inv_1_0_q_3*tmp_moved_constant_460 + jac_blending_inv_2_0_q_3*tmp_moved_constant_461) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_459 + jac_blending_inv_1_1_q_3*tmp_moved_constant_460 + jac_blending_inv_2_1_q_3*tmp_moved_constant_461) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_459 + jac_blending_inv_1_2_q_3*tmp_moved_constant_460 + jac_blending_inv_2_2_q_3*tmp_moved_constant_461))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_462 + jac_blending_inv_1_0_q_4*tmp_moved_constant_463 + jac_blending_inv_2_0_q_4*tmp_moved_constant_464) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_462 + jac_blending_inv_1_1_q_4*tmp_moved_constant_463 + jac_blending_inv_2_1_q_4*tmp_moved_constant_464) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_462 + jac_blending_inv_1_2_q_4*tmp_moved_constant_463 + jac_blending_inv_2_2_q_4*tmp_moved_constant_464))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_462 + jac_blending_inv_1_0_q_4*tmp_moved_constant_463 + jac_blending_inv_2_0_q_4*tmp_moved_constant_464) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_462 + jac_blending_inv_1_1_q_4*tmp_moved_constant_463 + jac_blending_inv_2_1_q_4*tmp_moved_constant_464) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_462 + jac_blending_inv_1_2_q_4*tmp_moved_constant_463 + jac_blending_inv_2_2_q_4*tmp_moved_constant_464))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_450 + jac_blending_inv_1_0_q_0*tmp_moved_constant_451 + jac_blending_inv_2_0_q_0*tmp_moved_constant_452) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_450 + jac_blending_inv_1_1_q_0*tmp_moved_constant_451 + jac_blending_inv_2_1_q_0*tmp_moved_constant_452) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_450 + jac_blending_inv_1_2_q_0*tmp_moved_constant_451 + jac_blending_inv_2_2_q_0*tmp_moved_constant_452))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_450 + jac_blending_inv_1_0_q_0*tmp_moved_constant_451 + jac_blending_inv_2_0_q_0*tmp_moved_constant_452) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_450 + jac_blending_inv_1_1_q_0*tmp_moved_constant_451 + jac_blending_inv_2_1_q_0*tmp_moved_constant_452) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_450 + jac_blending_inv_1_2_q_0*tmp_moved_constant_451 + jac_blending_inv_2_2_q_0*tmp_moved_constant_452))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_453 + jac_blending_inv_1_0_q_1*tmp_moved_constant_454 + jac_blending_inv_2_0_q_1*tmp_moved_constant_455) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_453 + jac_blending_inv_1_1_q_1*tmp_moved_constant_454 + jac_blending_inv_2_1_q_1*tmp_moved_constant_455) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_453 + jac_blending_inv_1_2_q_1*tmp_moved_constant_454 + jac_blending_inv_2_2_q_1*tmp_moved_constant_455))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_453 + jac_blending_inv_1_0_q_1*tmp_moved_constant_454 + jac_blending_inv_2_0_q_1*tmp_moved_constant_455) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_453 + jac_blending_inv_1_1_q_1*tmp_moved_constant_454 + jac_blending_inv_2_1_q_1*tmp_moved_constant_455) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_453 + jac_blending_inv_1_2_q_1*tmp_moved_constant_454 + jac_blending_inv_2_2_q_1*tmp_moved_constant_455))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_456 + jac_blending_inv_1_0_q_2*tmp_moved_constant_457 + jac_blending_inv_2_0_q_2*tmp_moved_constant_458) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_456 + jac_blending_inv_1_1_q_2*tmp_moved_constant_457 + jac_blending_inv_2_1_q_2*tmp_moved_constant_458) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_456 + jac_blending_inv_1_2_q_2*tmp_moved_constant_457 + jac_blending_inv_2_2_q_2*tmp_moved_constant_458))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_456 + jac_blending_inv_1_0_q_2*tmp_moved_constant_457 + jac_blending_inv_2_0_q_2*tmp_moved_constant_458) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_456 + jac_blending_inv_1_1_q_2*tmp_moved_constant_457 + jac_blending_inv_2_1_q_2*tmp_moved_constant_458) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_456 + jac_blending_inv_1_2_q_2*tmp_moved_constant_457 + jac_blending_inv_2_2_q_2*tmp_moved_constant_458)));
             const real_t elMatDiag_9 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_474 + jac_blending_inv_1_0_q_3*tmp_moved_constant_475 + jac_blending_inv_2_0_q_3*tmp_moved_constant_476) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_474 + jac_blending_inv_1_1_q_3*tmp_moved_constant_475 + jac_blending_inv_2_1_q_3*tmp_moved_constant_476) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_474 + jac_blending_inv_1_2_q_3*tmp_moved_constant_475 + jac_blending_inv_2_2_q_3*tmp_moved_constant_476))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_474 + jac_blending_inv_1_0_q_3*tmp_moved_constant_475 + jac_blending_inv_2_0_q_3*tmp_moved_constant_476) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_474 + jac_blending_inv_1_1_q_3*tmp_moved_constant_475 + jac_blending_inv_2_1_q_3*tmp_moved_constant_476) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_474 + jac_blending_inv_1_2_q_3*tmp_moved_constant_475 + jac_blending_inv_2_2_q_3*tmp_moved_constant_476))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_477 + jac_blending_inv_1_0_q_4*tmp_moved_constant_478 + jac_blending_inv_2_0_q_4*tmp_moved_constant_479) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_477 + jac_blending_inv_1_1_q_4*tmp_moved_constant_478 + jac_blending_inv_2_1_q_4*tmp_moved_constant_479) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_477 + jac_blending_inv_1_2_q_4*tmp_moved_constant_478 + jac_blending_inv_2_2_q_4*tmp_moved_constant_479))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_477 + jac_blending_inv_1_0_q_4*tmp_moved_constant_478 + jac_blending_inv_2_0_q_4*tmp_moved_constant_479) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_477 + jac_blending_inv_1_1_q_4*tmp_moved_constant_478 + jac_blending_inv_2_1_q_4*tmp_moved_constant_479) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_477 + jac_blending_inv_1_2_q_4*tmp_moved_constant_478 + jac_blending_inv_2_2_q_4*tmp_moved_constant_479))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_465 + jac_blending_inv_1_0_q_0*tmp_moved_constant_466 + jac_blending_inv_2_0_q_0*tmp_moved_constant_467) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_465 + jac_blending_inv_1_1_q_0*tmp_moved_constant_466 + jac_blending_inv_2_1_q_0*tmp_moved_constant_467) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_465 + jac_blending_inv_1_2_q_0*tmp_moved_constant_466 + jac_blending_inv_2_2_q_0*tmp_moved_constant_467))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_465 + jac_blending_inv_1_0_q_0*tmp_moved_constant_466 + jac_blending_inv_2_0_q_0*tmp_moved_constant_467) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_465 + jac_blending_inv_1_1_q_0*tmp_moved_constant_466 + jac_blending_inv_2_1_q_0*tmp_moved_constant_467) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_465 + jac_blending_inv_1_2_q_0*tmp_moved_constant_466 + jac_blending_inv_2_2_q_0*tmp_moved_constant_467))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_468 + jac_blending_inv_1_0_q_1*tmp_moved_constant_469 + jac_blending_inv_2_0_q_1*tmp_moved_constant_470) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_468 + jac_blending_inv_1_1_q_1*tmp_moved_constant_469 + jac_blending_inv_2_1_q_1*tmp_moved_constant_470) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_468 + jac_blending_inv_1_2_q_1*tmp_moved_constant_469 + jac_blending_inv_2_2_q_1*tmp_moved_constant_470))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_468 + jac_blending_inv_1_0_q_1*tmp_moved_constant_469 + jac_blending_inv_2_0_q_1*tmp_moved_constant_470) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_468 + jac_blending_inv_1_1_q_1*tmp_moved_constant_469 + jac_blending_inv_2_1_q_1*tmp_moved_constant_470) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_468 + jac_blending_inv_1_2_q_1*tmp_moved_constant_469 + jac_blending_inv_2_2_q_1*tmp_moved_constant_470))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_471 + jac_blending_inv_1_0_q_2*tmp_moved_constant_472 + jac_blending_inv_2_0_q_2*tmp_moved_constant_473) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_471 + jac_blending_inv_1_1_q_2*tmp_moved_constant_472 + jac_blending_inv_2_1_q_2*tmp_moved_constant_473) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_471 + jac_blending_inv_1_2_q_2*tmp_moved_constant_472 + jac_blending_inv_2_2_q_2*tmp_moved_constant_473))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_471 + jac_blending_inv_1_0_q_2*tmp_moved_constant_472 + jac_blending_inv_2_0_q_2*tmp_moved_constant_473) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_471 + jac_blending_inv_1_1_q_2*tmp_moved_constant_472 + jac_blending_inv_2_1_q_2*tmp_moved_constant_473) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_471 + jac_blending_inv_1_2_q_2*tmp_moved_constant_472 + jac_blending_inv_2_2_q_2*tmp_moved_constant_473)));
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const real_t tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const real_t tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_11_BLUE_DOWN = jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
       const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const real_t tmp_coords_jac_10_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_0_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
       const real_t tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const real_t jac_affine_inv_0_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
       const real_t jac_affine_inv_0_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const real_t jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const real_t jac_affine_inv_1_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       const real_t tmp_moved_constant_480 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_4 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_4 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_4;
       const real_t tmp_moved_constant_481 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_4 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_4 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_4;
       const real_t tmp_moved_constant_482 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_4 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_4 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_4;
       const real_t tmp_moved_constant_483 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_33 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_33 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_33;
       const real_t tmp_moved_constant_484 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_33 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_33 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_33;
       const real_t tmp_moved_constant_485 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_33 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_33 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_33;
       const real_t tmp_moved_constant_486 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_62 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_62 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_62;
       const real_t tmp_moved_constant_487 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_62 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_62 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_62;
       const real_t tmp_moved_constant_488 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_62 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_62 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_62;
       const real_t tmp_moved_constant_489 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_91 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_91 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_91;
       const real_t tmp_moved_constant_490 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_91 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_91 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_91;
       const real_t tmp_moved_constant_491 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_91 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_91 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_91;
       const real_t tmp_moved_constant_492 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_120 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_120 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_120;
       const real_t tmp_moved_constant_493 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_120 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_120 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_120;
       const real_t tmp_moved_constant_494 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_120 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_120 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_120;
       const real_t tmp_moved_constant_495 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_145;
       const real_t tmp_moved_constant_496 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_145;
       const real_t tmp_moved_constant_497 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_145;
       const real_t tmp_moved_constant_498 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_149;
       const real_t tmp_moved_constant_499 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_149;
       const real_t tmp_moved_constant_500 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_149;
       const real_t tmp_moved_constant_501 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_153;
       const real_t tmp_moved_constant_502 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_153;
       const real_t tmp_moved_constant_503 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_153;
       const real_t tmp_moved_constant_504 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_157;
       const real_t tmp_moved_constant_505 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_157;
       const real_t tmp_moved_constant_506 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_157;
       const real_t tmp_moved_constant_507 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_161;
       const real_t tmp_moved_constant_508 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_161;
       const real_t tmp_moved_constant_509 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_161;
       const real_t tmp_moved_constant_510 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_165;
       const real_t tmp_moved_constant_511 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_165;
       const real_t tmp_moved_constant_512 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_165;
       const real_t tmp_moved_constant_513 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_169;
       const real_t tmp_moved_constant_514 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_169;
       const real_t tmp_moved_constant_515 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_169;
       const real_t tmp_moved_constant_516 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_173;
       const real_t tmp_moved_constant_517 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_173;
       const real_t tmp_moved_constant_518 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_173;
       const real_t tmp_moved_constant_519 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_177;
       const real_t tmp_moved_constant_520 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_177;
       const real_t tmp_moved_constant_521 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_177;
       const real_t tmp_moved_constant_522 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_181;
       const real_t tmp_moved_constant_523 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_181;
       const real_t tmp_moved_constant_524 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_181;
       const real_t tmp_moved_constant_525 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_185;
       const real_t tmp_moved_constant_526 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_185;
       const real_t tmp_moved_constant_527 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_185;
       const real_t tmp_moved_constant_528 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_189;
       const real_t tmp_moved_constant_529 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_189;
       const real_t tmp_moved_constant_530 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_189;
       const real_t tmp_moved_constant_531 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_193;
       const real_t tmp_moved_constant_532 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_193;
       const real_t tmp_moved_constant_533 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_193;
       const real_t tmp_moved_constant_534 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_197;
       const real_t tmp_moved_constant_535 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_197;
       const real_t tmp_moved_constant_536 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_197;
       const real_t tmp_moved_constant_537 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_201;
       const real_t tmp_moved_constant_538 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_201;
       const real_t tmp_moved_constant_539 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_201;
       const real_t tmp_moved_constant_540 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_541 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_542 = tmp_moved_constant_540 + tmp_moved_constant_541;
       const real_t tmp_moved_constant_543 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_544 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_545 = tmp_moved_constant_543 + tmp_moved_constant_544;
       const real_t tmp_moved_constant_546 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_547 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_548 = tmp_moved_constant_546 + tmp_moved_constant_547;
       const real_t tmp_moved_constant_549 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_550 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_551 = tmp_moved_constant_549 + tmp_moved_constant_550;
       const real_t tmp_moved_constant_552 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_553 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_554 = tmp_moved_constant_552 + tmp_moved_constant_553;
       const real_t tmp_moved_constant_555 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_556 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_557 = tmp_moved_constant_555 + tmp_moved_constant_556;
       const real_t tmp_moved_constant_558 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_58;
       const real_t tmp_moved_constant_559 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_60;
       const real_t tmp_moved_constant_560 = tmp_moved_constant_558 + tmp_moved_constant_559;
       const real_t tmp_moved_constant_561 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_58;
       const real_t tmp_moved_constant_562 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_60;
       const real_t tmp_moved_constant_563 = tmp_moved_constant_561 + tmp_moved_constant_562;
       const real_t tmp_moved_constant_564 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_58;
       const real_t tmp_moved_constant_565 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_60;
       const real_t tmp_moved_constant_566 = tmp_moved_constant_564 + tmp_moved_constant_565;
       const real_t tmp_moved_constant_567 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_87;
       const real_t tmp_moved_constant_568 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_569 = tmp_moved_constant_567 + tmp_moved_constant_568;
       const real_t tmp_moved_constant_570 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_87;
       const real_t tmp_moved_constant_571 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_572 = tmp_moved_constant_570 + tmp_moved_constant_571;
       const real_t tmp_moved_constant_573 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_87;
       const real_t tmp_moved_constant_574 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_575 = tmp_moved_constant_573 + tmp_moved_constant_574;
       const real_t tmp_moved_constant_576 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_116;
       const real_t tmp_moved_constant_577 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_118;
       const real_t tmp_moved_constant_578 = tmp_moved_constant_576 + tmp_moved_constant_577;
       const real_t tmp_moved_constant_579 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_116;
       const real_t tmp_moved_constant_580 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_118;
       const real_t tmp_moved_constant_581 = tmp_moved_constant_579 + tmp_moved_constant_580;
       const real_t tmp_moved_constant_582 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_116;
       const real_t tmp_moved_constant_583 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_118;
       const real_t tmp_moved_constant_584 = tmp_moved_constant_582 + tmp_moved_constant_583;
       const real_t tmp_moved_constant_585 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_586 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_587 = tmp_moved_constant_585 + tmp_moved_constant_586;
       const real_t tmp_moved_constant_588 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_589 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_590 = tmp_moved_constant_588 + tmp_moved_constant_589;
       const real_t tmp_moved_constant_591 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_592 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_593 = tmp_moved_constant_591 + tmp_moved_constant_592;
       const real_t tmp_moved_constant_594 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_595 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_596 = tmp_moved_constant_594 + tmp_moved_constant_595;
       const real_t tmp_moved_constant_597 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_598 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_599 = tmp_moved_constant_597 + tmp_moved_constant_598;
       const real_t tmp_moved_constant_600 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_601 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_602 = tmp_moved_constant_600 + tmp_moved_constant_601;
       const real_t tmp_moved_constant_603 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_58;
       const real_t tmp_moved_constant_604 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_59;
       const real_t tmp_moved_constant_605 = tmp_moved_constant_603 + tmp_moved_constant_604;
       const real_t tmp_moved_constant_606 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_58;
       const real_t tmp_moved_constant_607 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_59;
       const real_t tmp_moved_constant_608 = tmp_moved_constant_606 + tmp_moved_constant_607;
       const real_t tmp_moved_constant_609 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_58;
       const real_t tmp_moved_constant_610 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_59;
       const real_t tmp_moved_constant_611 = tmp_moved_constant_609 + tmp_moved_constant_610;
       const real_t tmp_moved_constant_612 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_87;
       const real_t tmp_moved_constant_613 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_88;
       const real_t tmp_moved_constant_614 = tmp_moved_constant_612 + tmp_moved_constant_613;
       const real_t tmp_moved_constant_615 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_87;
       const real_t tmp_moved_constant_616 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_88;
       const real_t tmp_moved_constant_617 = tmp_moved_constant_615 + tmp_moved_constant_616;
       const real_t tmp_moved_constant_618 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_87;
       const real_t tmp_moved_constant_619 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_88;
       const real_t tmp_moved_constant_620 = tmp_moved_constant_618 + tmp_moved_constant_619;
       const real_t tmp_moved_constant_621 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_116;
       const real_t tmp_moved_constant_622 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_117;
       const real_t tmp_moved_constant_623 = tmp_moved_constant_621 + tmp_moved_constant_622;
       const real_t tmp_moved_constant_624 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_116;
       const real_t tmp_moved_constant_625 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_117;
       const real_t tmp_moved_constant_626 = tmp_moved_constant_624 + tmp_moved_constant_625;
       const real_t tmp_moved_constant_627 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_116;
       const real_t tmp_moved_constant_628 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_117;
       const real_t tmp_moved_constant_629 = tmp_moved_constant_627 + tmp_moved_constant_628;
       const real_t tmp_moved_constant_630 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_631 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_632 = tmp_moved_constant_630 + tmp_moved_constant_631;
       const real_t tmp_moved_constant_633 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_634 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_635 = tmp_moved_constant_633 + tmp_moved_constant_634;
       const real_t tmp_moved_constant_636 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_637 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_638 = tmp_moved_constant_636 + tmp_moved_constant_637;
       const real_t tmp_moved_constant_639 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_640 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_641 = tmp_moved_constant_639 + tmp_moved_constant_640;
       const real_t tmp_moved_constant_642 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_643 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_644 = tmp_moved_constant_642 + tmp_moved_constant_643;
       const real_t tmp_moved_constant_645 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_646 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_647 = tmp_moved_constant_645 + tmp_moved_constant_646;
       const real_t tmp_moved_constant_648 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_60;
       const real_t tmp_moved_constant_649 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_59;
       const real_t tmp_moved_constant_650 = tmp_moved_constant_648 + tmp_moved_constant_649;
       const real_t tmp_moved_constant_651 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_60;
       const real_t tmp_moved_constant_652 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_59;
       const real_t tmp_moved_constant_653 = tmp_moved_constant_651 + tmp_moved_constant_652;
       const real_t tmp_moved_constant_654 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_60;
       const real_t tmp_moved_constant_655 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_59;
       const real_t tmp_moved_constant_656 = tmp_moved_constant_654 + tmp_moved_constant_655;
       const real_t tmp_moved_constant_657 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_658 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_88;
       const real_t tmp_moved_constant_659 = tmp_moved_constant_657 + tmp_moved_constant_658;
       const real_t tmp_moved_constant_660 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_661 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_88;
       const real_t tmp_moved_constant_662 = tmp_moved_constant_660 + tmp_moved_constant_661;
       const real_t tmp_moved_constant_663 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_664 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_88;
       const real_t tmp_moved_constant_665 = tmp_moved_constant_663 + tmp_moved_constant_664;
       const real_t tmp_moved_constant_666 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_118;
       const real_t tmp_moved_constant_667 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_117;
       const real_t tmp_moved_constant_668 = tmp_moved_constant_666 + tmp_moved_constant_667;
       const real_t tmp_moved_constant_669 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_118;
       const real_t tmp_moved_constant_670 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_117;
       const real_t tmp_moved_constant_671 = tmp_moved_constant_669 + tmp_moved_constant_670;
       const real_t tmp_moved_constant_672 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_118;
       const real_t tmp_moved_constant_673 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_117;
       const real_t tmp_moved_constant_674 = tmp_moved_constant_672 + tmp_moved_constant_673;
       const real_t tmp_moved_constant_675 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_340 - tmp_moved_constant_540 - tmp_moved_constant_585;
       const real_t tmp_moved_constant_676 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_340 - tmp_moved_constant_543 - tmp_moved_constant_588;
       const real_t tmp_moved_constant_677 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_340 - tmp_moved_constant_546 - tmp_moved_constant_591;
       const real_t tmp_moved_constant_678 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_344 - tmp_moved_constant_549 - tmp_moved_constant_594;
       const real_t tmp_moved_constant_679 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_344 - tmp_moved_constant_552 - tmp_moved_constant_597;
       const real_t tmp_moved_constant_680 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_344 - tmp_moved_constant_555 - tmp_moved_constant_600;
       const real_t tmp_moved_constant_681 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_348 - tmp_moved_constant_558 - tmp_moved_constant_603;
       const real_t tmp_moved_constant_682 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_348 - tmp_moved_constant_561 - tmp_moved_constant_606;
       const real_t tmp_moved_constant_683 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_348 - tmp_moved_constant_564 - tmp_moved_constant_609;
       const real_t tmp_moved_constant_684 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_352 - tmp_moved_constant_567 - tmp_moved_constant_612;
       const real_t tmp_moved_constant_685 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_352 - tmp_moved_constant_570 - tmp_moved_constant_615;
       const real_t tmp_moved_constant_686 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_352 - tmp_moved_constant_573 - tmp_moved_constant_618;
       const real_t tmp_moved_constant_687 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_356 - tmp_moved_constant_576 - tmp_moved_constant_621;
       const real_t tmp_moved_constant_688 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_356 - tmp_moved_constant_579 - tmp_moved_constant_624;
       const real_t tmp_moved_constant_689 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_356 - tmp_moved_constant_582 - tmp_moved_constant_627;
       const real_t tmp_moved_constant_690 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_361 - tmp_moved_constant_541 - tmp_moved_constant_630;
       const real_t tmp_moved_constant_691 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_361 - tmp_moved_constant_544 - tmp_moved_constant_633;
       const real_t tmp_moved_constant_692 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_361 - tmp_moved_constant_547 - tmp_moved_constant_636;
       const real_t tmp_moved_constant_693 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_366 - tmp_moved_constant_550 - tmp_moved_constant_639;
       const real_t tmp_moved_constant_694 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_366 - tmp_moved_constant_553 - tmp_moved_constant_642;
       const real_t tmp_moved_constant_695 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_366 - tmp_moved_constant_556 - tmp_moved_constant_645;
       const real_t tmp_moved_constant_696 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_371 - tmp_moved_constant_559 - tmp_moved_constant_648;
       const real_t tmp_moved_constant_697 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_371 - tmp_moved_constant_562 - tmp_moved_constant_651;
       const real_t tmp_moved_constant_698 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_371 - tmp_moved_constant_565 - tmp_moved_constant_654;
       const real_t tmp_moved_constant_699 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_376 - tmp_moved_constant_568 - tmp_moved_constant_657;
       const real_t tmp_moved_constant_700 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_376 - tmp_moved_constant_571 - tmp_moved_constant_660;
       const real_t tmp_moved_constant_701 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_376 - tmp_moved_constant_574 - tmp_moved_constant_663;
       const real_t tmp_moved_constant_702 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_381 - tmp_moved_constant_577 - tmp_moved_constant_666;
       const real_t tmp_moved_constant_703 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_381 - tmp_moved_constant_580 - tmp_moved_constant_669;
       const real_t tmp_moved_constant_704 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_381 - tmp_moved_constant_583 - tmp_moved_constant_672;
       const real_t tmp_moved_constant_705 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_385 - tmp_moved_constant_586 - tmp_moved_constant_631;
       const real_t tmp_moved_constant_706 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_385 - tmp_moved_constant_589 - tmp_moved_constant_634;
       const real_t tmp_moved_constant_707 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_385 - tmp_moved_constant_592 - tmp_moved_constant_637;
       const real_t tmp_moved_constant_708 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_389 - tmp_moved_constant_595 - tmp_moved_constant_640;
       const real_t tmp_moved_constant_709 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_389 - tmp_moved_constant_598 - tmp_moved_constant_643;
       const real_t tmp_moved_constant_710 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_389 - tmp_moved_constant_601 - tmp_moved_constant_646;
       const real_t tmp_moved_constant_711 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_393 - tmp_moved_constant_604 - tmp_moved_constant_649;
       const real_t tmp_moved_constant_712 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_393 - tmp_moved_constant_607 - tmp_moved_constant_652;
       const real_t tmp_moved_constant_713 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_393 - tmp_moved_constant_610 - tmp_moved_constant_655;
       const real_t tmp_moved_constant_714 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_397 - tmp_moved_constant_613 - tmp_moved_constant_658;
       const real_t tmp_moved_constant_715 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_397 - tmp_moved_constant_616 - tmp_moved_constant_661;
       const real_t tmp_moved_constant_716 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_397 - tmp_moved_constant_619 - tmp_moved_constant_664;
       const real_t tmp_moved_constant_717 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_401 - tmp_moved_constant_622 - tmp_moved_constant_667;
       const real_t tmp_moved_constant_718 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_401 - tmp_moved_constant_625 - tmp_moved_constant_670;
       const real_t tmp_moved_constant_719 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_401 - tmp_moved_constant_628 - tmp_moved_constant_673;
       {
          /* CellType.BLUE_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
             const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
             const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
             const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
             const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
             const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
             const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
             const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
             const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
             const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
             const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
             const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
             const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
             const real_t tmp_blending_op_35 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_36 = -tmp_blending_op_35;
             const real_t tmp_blending_op_37 = (tmp_blending_op_28*tmp_blending_op_28);
             const real_t tmp_blending_op_38 = (tmp_blending_op_33*tmp_blending_op_33);
             const real_t tmp_blending_op_39 = tmp_blending_op_37 + tmp_blending_op_38 + tmp_blending_op_4;
             const real_t tmp_blending_op_42 = pow(tmp_blending_op_39, -1.5000000000000000)*tmp_blending_op_41;
             const real_t tmp_blending_op_44 = tmp_blending_op_23*tmp_blending_op_39;
             const real_t tmp_blending_op_45 = -tmp_blending_op_33*tmp_blending_op_35 - tmp_blending_op_43*tmp_blending_op_44;
             const real_t tmp_blending_op_46 = tmp_blending_op_3*tmp_blending_op_42;
             const real_t tmp_blending_op_48 = tmp_blending_op_28*tmp_blending_op_36 + tmp_blending_op_44*tmp_blending_op_47;
             const real_t tmp_blending_op_49 = tmp_blending_op_3*tmp_blending_op_36 + tmp_blending_op_39*tmp_blending_op_40;
             const real_t tmp_blending_op_50 = tmp_blending_op_33*tmp_blending_op_42;
             const real_t tmp_blending_op_52 = tmp_blending_op_28*tmp_blending_op_42;
             const real_t tmp_blending_op_61 = p_affine_0_2 + tmp_blending_op_0*0.5 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_62 = (tmp_blending_op_61*tmp_blending_op_61);
             const real_t tmp_blending_op_63 = -tmp_blending_op_17 - tmp_blending_op_61;
             const real_t tmp_blending_op_64 = p_affine_0_0 + tmp_blending_op_25*0.5 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_65 = -tmp_blending_op_6 - tmp_blending_op_64;
             const real_t tmp_blending_op_66 = p_affine_0_1 + tmp_blending_op_30*0.5 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_67 = -tmp_blending_op_13 - tmp_blending_op_66;
             const real_t tmp_blending_op_68 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_65 - tmp_blending_op_12*tmp_blending_op_63 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_63 - tmp_blending_op_19*tmp_blending_op_65 - tmp_blending_op_20*tmp_blending_op_67 + tmp_blending_op_67*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_69 = -tmp_blending_op_68;
             const real_t tmp_blending_op_70 = (tmp_blending_op_64*tmp_blending_op_64);
             const real_t tmp_blending_op_71 = (tmp_blending_op_66*tmp_blending_op_66);
             const real_t tmp_blending_op_72 = tmp_blending_op_62 + tmp_blending_op_70 + tmp_blending_op_71;
             const real_t tmp_blending_op_73 = tmp_blending_op_41*pow(tmp_blending_op_72, -1.5000000000000000);
             const real_t tmp_blending_op_75 = -tmp_blending_op_66*tmp_blending_op_68 - tmp_blending_op_72*tmp_blending_op_74;
             const real_t tmp_blending_op_76 = tmp_blending_op_61*tmp_blending_op_73;
             const real_t tmp_blending_op_77 = tmp_blending_op_53*tmp_blending_op_72 + tmp_blending_op_64*tmp_blending_op_69;
             const real_t tmp_blending_op_78 = tmp_blending_op_40*tmp_blending_op_72 + tmp_blending_op_61*tmp_blending_op_69;
             const real_t tmp_blending_op_79 = tmp_blending_op_66*tmp_blending_op_73;
             const real_t tmp_blending_op_80 = tmp_blending_op_64*tmp_blending_op_73;
             const real_t tmp_blending_op_88 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.5 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_89 = (tmp_blending_op_88*tmp_blending_op_88);
             const real_t tmp_blending_op_90 = -tmp_blending_op_17 - tmp_blending_op_88;
             const real_t tmp_blending_op_91 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.5 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_92 = -tmp_blending_op_6 - tmp_blending_op_91;
             const real_t tmp_blending_op_93 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.5 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_94 = -tmp_blending_op_13 - tmp_blending_op_93;
             const real_t tmp_blending_op_95 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_92 - tmp_blending_op_12*tmp_blending_op_90 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_90 - tmp_blending_op_19*tmp_blending_op_92 - tmp_blending_op_20*tmp_blending_op_94 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_94);
             const real_t tmp_blending_op_96 = -tmp_blending_op_95;
             const real_t tmp_blending_op_97 = (tmp_blending_op_91*tmp_blending_op_91);
             const real_t tmp_blending_op_98 = (tmp_blending_op_93*tmp_blending_op_93);
             const real_t tmp_blending_op_99 = tmp_blending_op_89 + tmp_blending_op_97 + tmp_blending_op_98;
             const real_t tmp_blending_op_100 = tmp_blending_op_41*pow(tmp_blending_op_99, -1.5000000000000000);
             const real_t tmp_blending_op_101 = -tmp_blending_op_74*tmp_blending_op_99 - tmp_blending_op_93*tmp_blending_op_95;
             const real_t tmp_blending_op_102 = tmp_blending_op_100*tmp_blending_op_88;
             const real_t tmp_blending_op_103 = tmp_blending_op_53*tmp_blending_op_99 + tmp_blending_op_91*tmp_blending_op_96;
             const real_t tmp_blending_op_104 = tmp_blending_op_40*tmp_blending_op_99 + tmp_blending_op_88*tmp_blending_op_96;
             const real_t tmp_blending_op_105 = tmp_blending_op_100*tmp_blending_op_93;
             const real_t tmp_blending_op_106 = tmp_blending_op_100*tmp_blending_op_91;
             const real_t tmp_blending_op_114 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.5;
             const real_t tmp_blending_op_115 = (tmp_blending_op_114*tmp_blending_op_114);
             const real_t tmp_blending_op_116 = -tmp_blending_op_114 - tmp_blending_op_17;
             const real_t tmp_blending_op_117 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.5;
             const real_t tmp_blending_op_118 = -tmp_blending_op_117 - tmp_blending_op_6;
             const real_t tmp_blending_op_119 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.5;
             const real_t tmp_blending_op_120 = -tmp_blending_op_119 - tmp_blending_op_13;
             const real_t tmp_blending_op_121 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_118*tmp_blending_op_18 - tmp_blending_op_116*tmp_blending_op_12 + tmp_blending_op_116*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_118*tmp_blending_op_19 - tmp_blending_op_120*tmp_blending_op_20 + tmp_blending_op_120*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_122 = -tmp_blending_op_121;
             const real_t tmp_blending_op_123 = (tmp_blending_op_117*tmp_blending_op_117);
             const real_t tmp_blending_op_124 = (tmp_blending_op_119*tmp_blending_op_119);
             const real_t tmp_blending_op_125 = tmp_blending_op_115 + tmp_blending_op_123 + tmp_blending_op_124;
             const real_t tmp_blending_op_126 = pow(tmp_blending_op_125, -1.5000000000000000)*tmp_blending_op_41;
             const real_t tmp_blending_op_127 = -tmp_blending_op_119*tmp_blending_op_121 - tmp_blending_op_125*tmp_blending_op_74;
             const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_126;
             const real_t tmp_blending_op_129 = tmp_blending_op_117*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_53;
             const real_t tmp_blending_op_130 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_40;
             const real_t tmp_blending_op_131 = tmp_blending_op_119*tmp_blending_op_126;
             const real_t tmp_blending_op_132 = tmp_blending_op_117*tmp_blending_op_126;
             const real_t tmp_blending_op_140 = p_affine_0_2 + tmp_blending_op_0*0.25 + tmp_blending_op_1*0.25 + tmp_blending_op_2*0.25;
             const real_t tmp_blending_op_141 = (tmp_blending_op_140*tmp_blending_op_140);
             const real_t tmp_blending_op_142 = -tmp_blending_op_140 - tmp_blending_op_17;
             const real_t tmp_blending_op_143 = p_affine_0_0 + tmp_blending_op_25*0.25 + tmp_blending_op_26*0.25 + tmp_blending_op_27*0.25;
             const real_t tmp_blending_op_144 = -tmp_blending_op_143 - tmp_blending_op_6;
             const real_t tmp_blending_op_145 = p_affine_0_1 + tmp_blending_op_30*0.25 + tmp_blending_op_31*0.25 + tmp_blending_op_32*0.25;
             const real_t tmp_blending_op_146 = -tmp_blending_op_13 - tmp_blending_op_145;
             const real_t tmp_blending_op_147 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_144*tmp_blending_op_18 - tmp_blending_op_12*tmp_blending_op_142 + tmp_blending_op_14*tmp_blending_op_142*tmp_blending_op_15 - tmp_blending_op_144*tmp_blending_op_19 - tmp_blending_op_146*tmp_blending_op_20 + tmp_blending_op_146*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_148 = -tmp_blending_op_147;
             const real_t tmp_blending_op_149 = (tmp_blending_op_143*tmp_blending_op_143);
             const real_t tmp_blending_op_150 = (tmp_blending_op_145*tmp_blending_op_145);
             const real_t tmp_blending_op_151 = tmp_blending_op_141 + tmp_blending_op_149 + tmp_blending_op_150;
             const real_t tmp_blending_op_152 = pow(tmp_blending_op_151, -1.5000000000000000)*tmp_blending_op_41;
             const real_t tmp_blending_op_153 = -tmp_blending_op_145*tmp_blending_op_147 - tmp_blending_op_151*tmp_blending_op_74;
             const real_t tmp_blending_op_154 = tmp_blending_op_140*tmp_blending_op_152;
             const real_t tmp_blending_op_155 = tmp_blending_op_143*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_53;
             const real_t tmp_blending_op_156 = tmp_blending_op_140*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_40;
             const real_t tmp_blending_op_157 = tmp_blending_op_145*tmp_blending_op_152;
             const real_t tmp_blending_op_158 = tmp_blending_op_143*tmp_blending_op_152;
             const real_t jac_blending_2_2_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_4 + tmp_blending_op_39*(tmp_blending_op_3*tmp_blending_op_40 + tmp_blending_op_35));
             const real_t jac_blending_2_1_q_4 = tmp_blending_op_45*tmp_blending_op_46;
             const real_t jac_blending_2_0_q_4 = tmp_blending_op_46*tmp_blending_op_48;
             const real_t jac_blending_1_2_q_4 = tmp_blending_op_49*tmp_blending_op_50;
             const real_t jac_blending_1_1_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_39*(tmp_blending_op_33*tmp_blending_op_51 + tmp_blending_op_35));
             const real_t tmp_blending_op_58 = jac_blending_1_1_q_4*jac_blending_2_0_q_4;
             const real_t jac_blending_1_0_q_4 = tmp_blending_op_48*tmp_blending_op_50;
             const real_t tmp_blending_op_55 = jac_blending_1_0_q_4*jac_blending_2_1_q_4;
             const real_t jac_blending_0_2_q_4 = tmp_blending_op_49*tmp_blending_op_52;
             const real_t jac_blending_0_1_q_4 = tmp_blending_op_45*tmp_blending_op_52;
             const real_t tmp_blending_op_57 = jac_blending_0_1_q_4*jac_blending_1_0_q_4;
             const real_t jac_blending_0_0_q_4 = tmp_blending_op_42*(-tmp_blending_op_35*tmp_blending_op_37 + tmp_blending_op_39*(tmp_blending_op_28*tmp_blending_op_53 + tmp_blending_op_35));
             const real_t tmp_blending_op_54 = jac_blending_0_0_q_4*jac_blending_1_1_q_4;
             const real_t tmp_blending_op_56 = jac_blending_0_0_q_4*jac_blending_2_1_q_4;
             const real_t tmp_blending_op_59 = jac_blending_0_1_q_4*jac_blending_1_2_q_4*jac_blending_2_0_q_4 + jac_blending_0_2_q_4*tmp_blending_op_55 - jac_blending_0_2_q_4*tmp_blending_op_58 - jac_blending_1_2_q_4*tmp_blending_op_56 + jac_blending_2_2_q_4*tmp_blending_op_54 - jac_blending_2_2_q_4*tmp_blending_op_57;
             const real_t tmp_blending_op_60 = 1.0 / (tmp_blending_op_59);
             const real_t abs_det_jac_blending_q_4 = tmp_blending_op_59;
             const real_t jac_blending_inv_2_2_q_4 = tmp_blending_op_60*(tmp_blending_op_54 - tmp_blending_op_57);
             const real_t jac_blending_inv_2_1_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_2_0_q_4 - tmp_blending_op_56);
             const real_t jac_blending_inv_2_0_q_4 = tmp_blending_op_60*(tmp_blending_op_55 - tmp_blending_op_58);
             const real_t jac_blending_inv_1_2_q_4 = tmp_blending_op_60*(-jac_blending_0_0_q_4*jac_blending_1_2_q_4 + jac_blending_0_2_q_4*jac_blending_1_0_q_4);
             const real_t jac_blending_inv_1_1_q_4 = tmp_blending_op_60*(jac_blending_0_0_q_4*jac_blending_2_2_q_4 - jac_blending_0_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_1_0_q_4 = tmp_blending_op_60*(-jac_blending_1_0_q_4*jac_blending_2_2_q_4 + jac_blending_1_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_0_2_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_1_2_q_4 - jac_blending_0_2_q_4*jac_blending_1_1_q_4);
             const real_t jac_blending_inv_0_1_q_4 = tmp_blending_op_60*(-jac_blending_0_1_q_4*jac_blending_2_2_q_4 + jac_blending_0_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_inv_0_0_q_4 = tmp_blending_op_60*(jac_blending_1_1_q_4*jac_blending_2_2_q_4 - jac_blending_1_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_2_2_q_3 = tmp_blending_op_73*(tmp_blending_op_62*tmp_blending_op_69 + tmp_blending_op_72*(tmp_blending_op_40*tmp_blending_op_61 + tmp_blending_op_68));
             const real_t jac_blending_2_1_q_3 = tmp_blending_op_75*tmp_blending_op_76;
             const real_t jac_blending_2_0_q_3 = tmp_blending_op_76*tmp_blending_op_77;
             const real_t jac_blending_1_2_q_3 = tmp_blending_op_78*tmp_blending_op_79;
             const real_t jac_blending_1_1_q_3 = tmp_blending_op_73*(tmp_blending_op_69*tmp_blending_op_71 + tmp_blending_op_72*(tmp_blending_op_51*tmp_blending_op_66 + tmp_blending_op_68));
             const real_t tmp_blending_op_85 = jac_blending_1_1_q_3*jac_blending_2_0_q_3;
             const real_t jac_blending_1_0_q_3 = tmp_blending_op_77*tmp_blending_op_79;
             const real_t tmp_blending_op_82 = jac_blending_1_0_q_3*jac_blending_2_1_q_3;
             const real_t jac_blending_0_2_q_3 = tmp_blending_op_78*tmp_blending_op_80;
             const real_t jac_blending_0_1_q_3 = tmp_blending_op_75*tmp_blending_op_80;
             const real_t tmp_blending_op_84 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
             const real_t jac_blending_0_0_q_3 = tmp_blending_op_73*(-tmp_blending_op_68*tmp_blending_op_70 + tmp_blending_op_72*(tmp_blending_op_53*tmp_blending_op_64 + tmp_blending_op_68));
             const real_t tmp_blending_op_81 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
             const real_t tmp_blending_op_83 = jac_blending_0_0_q_3*jac_blending_2_1_q_3;
             const real_t tmp_blending_op_86 = jac_blending_0_1_q_3*jac_blending_1_2_q_3*jac_blending_2_0_q_3 + jac_blending_0_2_q_3*tmp_blending_op_82 - jac_blending_0_2_q_3*tmp_blending_op_85 - jac_blending_1_2_q_3*tmp_blending_op_83 + jac_blending_2_2_q_3*tmp_blending_op_81 - jac_blending_2_2_q_3*tmp_blending_op_84;
             const real_t tmp_blending_op_87 = 1.0 / (tmp_blending_op_86);
             const real_t abs_det_jac_blending_q_3 = tmp_blending_op_86;
             const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_87*(tmp_blending_op_81 - tmp_blending_op_84);
             const real_t jac_blending_inv_2_1_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_2_0_q_3 - tmp_blending_op_83);
             const real_t jac_blending_inv_2_0_q_3 = tmp_blending_op_87*(tmp_blending_op_82 - tmp_blending_op_85);
             const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_87*(-jac_blending_0_0_q_3*jac_blending_1_2_q_3 + jac_blending_0_2_q_3*jac_blending_1_0_q_3);
             const real_t jac_blending_inv_1_1_q_3 = tmp_blending_op_87*(jac_blending_0_0_q_3*jac_blending_2_2_q_3 - jac_blending_0_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_1_0_q_3 = tmp_blending_op_87*(-jac_blending_1_0_q_3*jac_blending_2_2_q_3 + jac_blending_1_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_1_2_q_3 - jac_blending_0_2_q_3*jac_blending_1_1_q_3);
             const real_t jac_blending_inv_0_1_q_3 = tmp_blending_op_87*(-jac_blending_0_1_q_3*jac_blending_2_2_q_3 + jac_blending_0_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_inv_0_0_q_3 = tmp_blending_op_87*(jac_blending_1_1_q_3*jac_blending_2_2_q_3 - jac_blending_1_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_2_2_q_2 = tmp_blending_op_100*(tmp_blending_op_89*tmp_blending_op_96 + tmp_blending_op_99*(tmp_blending_op_40*tmp_blending_op_88 + tmp_blending_op_95));
             const real_t jac_blending_2_1_q_2 = tmp_blending_op_101*tmp_blending_op_102;
             const real_t jac_blending_2_0_q_2 = tmp_blending_op_102*tmp_blending_op_103;
             const real_t jac_blending_1_2_q_2 = tmp_blending_op_104*tmp_blending_op_105;
             const real_t jac_blending_1_1_q_2 = tmp_blending_op_100*(tmp_blending_op_96*tmp_blending_op_98 + tmp_blending_op_99*(tmp_blending_op_51*tmp_blending_op_93 + tmp_blending_op_95));
             const real_t tmp_blending_op_111 = jac_blending_1_1_q_2*jac_blending_2_0_q_2;
             const real_t jac_blending_1_0_q_2 = tmp_blending_op_103*tmp_blending_op_105;
             const real_t tmp_blending_op_108 = jac_blending_1_0_q_2*jac_blending_2_1_q_2;
             const real_t jac_blending_0_2_q_2 = tmp_blending_op_104*tmp_blending_op_106;
             const real_t jac_blending_0_1_q_2 = tmp_blending_op_101*tmp_blending_op_106;
             const real_t tmp_blending_op_110 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
             const real_t jac_blending_0_0_q_2 = tmp_blending_op_100*(-tmp_blending_op_95*tmp_blending_op_97 + tmp_blending_op_99*(tmp_blending_op_53*tmp_blending_op_91 + tmp_blending_op_95));
             const real_t tmp_blending_op_107 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
             const real_t tmp_blending_op_109 = jac_blending_0_0_q_2*jac_blending_2_1_q_2;
             const real_t tmp_blending_op_112 = jac_blending_0_1_q_2*jac_blending_1_2_q_2*jac_blending_2_0_q_2 + jac_blending_0_2_q_2*tmp_blending_op_108 - jac_blending_0_2_q_2*tmp_blending_op_111 - jac_blending_1_2_q_2*tmp_blending_op_109 + jac_blending_2_2_q_2*tmp_blending_op_107 - jac_blending_2_2_q_2*tmp_blending_op_110;
             const real_t tmp_blending_op_113 = 1.0 / (tmp_blending_op_112);
             const real_t abs_det_jac_blending_q_2 = tmp_blending_op_112;
             const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_113*(tmp_blending_op_107 - tmp_blending_op_110);
             const real_t jac_blending_inv_2_1_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_2_0_q_2 - tmp_blending_op_109);
             const real_t jac_blending_inv_2_0_q_2 = tmp_blending_op_113*(tmp_blending_op_108 - tmp_blending_op_111);
             const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_113*(-jac_blending_0_0_q_2*jac_blending_1_2_q_2 + jac_blending_0_2_q_2*jac_blending_1_0_q_2);
             const real_t jac_blending_inv_1_1_q_2 = tmp_blending_op_113*(jac_blending_0_0_q_2*jac_blending_2_2_q_2 - jac_blending_0_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_1_0_q_2 = tmp_blending_op_113*(-jac_blending_1_0_q_2*jac_blending_2_2_q_2 + jac_blending_1_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_1_2_q_2 - jac_blending_0_2_q_2*jac_blending_1_1_q_2);
             const real_t jac_blending_inv_0_1_q_2 = tmp_blending_op_113*(-jac_blending_0_1_q_2*jac_blending_2_2_q_2 + jac_blending_0_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_inv_0_0_q_2 = tmp_blending_op_113*(jac_blending_1_1_q_2*jac_blending_2_2_q_2 - jac_blending_1_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_2_2_q_1 = tmp_blending_op_126*(tmp_blending_op_115*tmp_blending_op_122 + tmp_blending_op_125*(tmp_blending_op_114*tmp_blending_op_40 + tmp_blending_op_121));
             const real_t jac_blending_2_1_q_1 = tmp_blending_op_127*tmp_blending_op_128;
             const real_t jac_blending_2_0_q_1 = tmp_blending_op_128*tmp_blending_op_129;
             const real_t jac_blending_1_2_q_1 = tmp_blending_op_130*tmp_blending_op_131;
             const real_t jac_blending_1_1_q_1 = tmp_blending_op_126*(tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*(tmp_blending_op_119*tmp_blending_op_51 + tmp_blending_op_121));
             const real_t tmp_blending_op_137 = jac_blending_1_1_q_1*jac_blending_2_0_q_1;
             const real_t jac_blending_1_0_q_1 = tmp_blending_op_129*tmp_blending_op_131;
             const real_t tmp_blending_op_134 = jac_blending_1_0_q_1*jac_blending_2_1_q_1;
             const real_t jac_blending_0_2_q_1 = tmp_blending_op_130*tmp_blending_op_132;
             const real_t jac_blending_0_1_q_1 = tmp_blending_op_127*tmp_blending_op_132;
             const real_t tmp_blending_op_136 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
             const real_t jac_blending_0_0_q_1 = tmp_blending_op_126*(-tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*(tmp_blending_op_117*tmp_blending_op_53 + tmp_blending_op_121));
             const real_t tmp_blending_op_133 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
             const real_t tmp_blending_op_135 = jac_blending_0_0_q_1*jac_blending_2_1_q_1;
             const real_t tmp_blending_op_138 = jac_blending_0_1_q_1*jac_blending_1_2_q_1*jac_blending_2_0_q_1 + jac_blending_0_2_q_1*tmp_blending_op_134 - jac_blending_0_2_q_1*tmp_blending_op_137 - jac_blending_1_2_q_1*tmp_blending_op_135 + jac_blending_2_2_q_1*tmp_blending_op_133 - jac_blending_2_2_q_1*tmp_blending_op_136;
             const real_t tmp_blending_op_139 = 1.0 / (tmp_blending_op_138);
             const real_t abs_det_jac_blending_q_1 = tmp_blending_op_138;
             const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_139*(tmp_blending_op_133 - tmp_blending_op_136);
             const real_t jac_blending_inv_2_1_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_2_0_q_1 - tmp_blending_op_135);
             const real_t jac_blending_inv_2_0_q_1 = tmp_blending_op_139*(tmp_blending_op_134 - tmp_blending_op_137);
             const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_139*(-jac_blending_0_0_q_1*jac_blending_1_2_q_1 + jac_blending_0_2_q_1*jac_blending_1_0_q_1);
             const real_t jac_blending_inv_1_1_q_1 = tmp_blending_op_139*(jac_blending_0_0_q_1*jac_blending_2_2_q_1 - jac_blending_0_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_1_0_q_1 = tmp_blending_op_139*(-jac_blending_1_0_q_1*jac_blending_2_2_q_1 + jac_blending_1_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_1_2_q_1 - jac_blending_0_2_q_1*jac_blending_1_1_q_1);
             const real_t jac_blending_inv_0_1_q_1 = tmp_blending_op_139*(-jac_blending_0_1_q_1*jac_blending_2_2_q_1 + jac_blending_0_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_inv_0_0_q_1 = tmp_blending_op_139*(jac_blending_1_1_q_1*jac_blending_2_2_q_1 - jac_blending_1_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_2_2_q_0 = tmp_blending_op_152*(tmp_blending_op_141*tmp_blending_op_148 + tmp_blending_op_151*(tmp_blending_op_140*tmp_blending_op_40 + tmp_blending_op_147));
             const real_t jac_blending_2_1_q_0 = tmp_blending_op_153*tmp_blending_op_154;
             const real_t jac_blending_2_0_q_0 = tmp_blending_op_154*tmp_blending_op_155;
             const real_t jac_blending_1_2_q_0 = tmp_blending_op_156*tmp_blending_op_157;
             const real_t jac_blending_1_1_q_0 = tmp_blending_op_152*(tmp_blending_op_148*tmp_blending_op_150 + tmp_blending_op_151*(tmp_blending_op_145*tmp_blending_op_51 + tmp_blending_op_147));
             const real_t tmp_blending_op_163 = jac_blending_1_1_q_0*jac_blending_2_0_q_0;
             const real_t jac_blending_1_0_q_0 = tmp_blending_op_155*tmp_blending_op_157;
             const real_t tmp_blending_op_160 = jac_blending_1_0_q_0*jac_blending_2_1_q_0;
             const real_t jac_blending_0_2_q_0 = tmp_blending_op_156*tmp_blending_op_158;
             const real_t jac_blending_0_1_q_0 = tmp_blending_op_153*tmp_blending_op_158;
             const real_t tmp_blending_op_162 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
             const real_t jac_blending_0_0_q_0 = tmp_blending_op_152*(-tmp_blending_op_147*tmp_blending_op_149 + tmp_blending_op_151*(tmp_blending_op_143*tmp_blending_op_53 + tmp_blending_op_147));
             const real_t tmp_blending_op_159 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
             const real_t tmp_blending_op_161 = jac_blending_0_0_q_0*jac_blending_2_1_q_0;
             const real_t tmp_blending_op_164 = jac_blending_0_1_q_0*jac_blending_1_2_q_0*jac_blending_2_0_q_0 + jac_blending_0_2_q_0*tmp_blending_op_160 - jac_blending_0_2_q_0*tmp_blending_op_163 - jac_blending_1_2_q_0*tmp_blending_op_161 + jac_blending_2_2_q_0*tmp_blending_op_159 - jac_blending_2_2_q_0*tmp_blending_op_162;
             const real_t tmp_blending_op_165 = 1.0 / (tmp_blending_op_164);
             const real_t abs_det_jac_blending_q_0 = tmp_blending_op_164;
             const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_165*(tmp_blending_op_159 - tmp_blending_op_162);
             const real_t jac_blending_inv_2_1_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_2_0_q_0 - tmp_blending_op_161);
             const real_t jac_blending_inv_2_0_q_0 = tmp_blending_op_165*(tmp_blending_op_160 - tmp_blending_op_163);
             const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_165*(-jac_blending_0_0_q_0*jac_blending_1_2_q_0 + jac_blending_0_2_q_0*jac_blending_1_0_q_0);
             const real_t jac_blending_inv_1_1_q_0 = tmp_blending_op_165*(jac_blending_0_0_q_0*jac_blending_2_2_q_0 - jac_blending_0_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_1_0_q_0 = tmp_blending_op_165*(-jac_blending_1_0_q_0*jac_blending_2_2_q_0 + jac_blending_1_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_1_2_q_0 - jac_blending_0_2_q_0*jac_blending_1_1_q_0);
             const real_t jac_blending_inv_0_1_q_0 = tmp_blending_op_165*(-jac_blending_0_1_q_0*jac_blending_2_2_q_0 + jac_blending_0_2_q_0*jac_blending_2_1_q_0);
             const real_t jac_blending_inv_0_0_q_0 = tmp_blending_op_165*(jac_blending_1_1_q_0*jac_blending_2_2_q_0 - jac_blending_1_2_q_0*jac_blending_2_1_q_0);
             const real_t cp_times_delta_dof_0 = _data_cp_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t cp_times_delta_dof_1 = _data_cp_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t cp_times_delta_dof_2 = _data_cp_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t cp_times_delta_dof_3 = _data_cp_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t cp_times_delta_dof_4 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t cp_times_delta_dof_5 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t cp_times_delta_dof_6 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t cp_times_delta_dof_7 = _data_cp_times_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t cp_times_delta_dof_8 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t cp_times_delta_dof_9 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_0 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_1 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_2 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_3 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_4 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ux_dof_5 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ux_dof_6 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ux_dof_7 = _data_uxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_8 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ux_dof_9 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_0 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_1 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_2 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_3 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_4 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uy_dof_5 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uy_dof_6 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uy_dof_7 = _data_uyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_8 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uy_dof_9 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_0 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_1 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_2 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_3 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_4 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uz_dof_5 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uz_dof_6 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uz_dof_7 = _data_uzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_8 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uz_dof_9 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t tmp_kernel_op_25 = tmp_kernel_op_10*ux_dof_6 + tmp_kernel_op_13*ux_dof_1 + tmp_kernel_op_16*ux_dof_2 + tmp_kernel_op_19*ux_dof_3 + tmp_kernel_op_20*ux_dof_7 + tmp_kernel_op_21*ux_dof_8 + tmp_kernel_op_23*ux_dof_9 + tmp_kernel_op_24*ux_dof_0 + tmp_kernel_op_8*ux_dof_4 + tmp_kernel_op_9*ux_dof_5;
             const real_t tmp_kernel_op_26 = tmp_kernel_op_10*uy_dof_6 + tmp_kernel_op_13*uy_dof_1 + tmp_kernel_op_16*uy_dof_2 + tmp_kernel_op_19*uy_dof_3 + tmp_kernel_op_20*uy_dof_7 + tmp_kernel_op_21*uy_dof_8 + tmp_kernel_op_23*uy_dof_9 + tmp_kernel_op_24*uy_dof_0 + tmp_kernel_op_8*uy_dof_4 + tmp_kernel_op_9*uy_dof_5;
             const real_t tmp_kernel_op_27 = tmp_kernel_op_10*uz_dof_6 + tmp_kernel_op_13*uz_dof_1 + tmp_kernel_op_16*uz_dof_2 + tmp_kernel_op_19*uz_dof_3 + tmp_kernel_op_20*uz_dof_7 + tmp_kernel_op_21*uz_dof_8 + tmp_kernel_op_23*uz_dof_9 + tmp_kernel_op_24*uz_dof_0 + tmp_kernel_op_8*uz_dof_4 + tmp_kernel_op_9*uz_dof_5;
             const real_t tmp_kernel_op_28 = abs_det_jac_affine_BLUE_DOWN*abs_det_jac_blending_q_0*(cp_times_delta_dof_0*tmp_kernel_op_24 + cp_times_delta_dof_1*tmp_kernel_op_13 + cp_times_delta_dof_2*tmp_kernel_op_16 + cp_times_delta_dof_3*tmp_kernel_op_19 + cp_times_delta_dof_4*tmp_kernel_op_8 + cp_times_delta_dof_5*tmp_kernel_op_9 + cp_times_delta_dof_6*tmp_kernel_op_10 + cp_times_delta_dof_7*tmp_kernel_op_20 + cp_times_delta_dof_8*tmp_kernel_op_21 + cp_times_delta_dof_9*tmp_kernel_op_23)*-0.1333333333333333;
             const real_t tmp_kernel_op_54 = tmp_kernel_op_37*ux_dof_4 + tmp_kernel_op_38*ux_dof_5 + tmp_kernel_op_39*ux_dof_6 + tmp_kernel_op_42*ux_dof_1 + tmp_kernel_op_45*ux_dof_2 + tmp_kernel_op_48*ux_dof_3 + tmp_kernel_op_49*ux_dof_7 + tmp_kernel_op_50*ux_dof_8 + tmp_kernel_op_52*ux_dof_9 + tmp_kernel_op_53*ux_dof_0;
             const real_t tmp_kernel_op_55 = tmp_kernel_op_37*uy_dof_4 + tmp_kernel_op_38*uy_dof_5 + tmp_kernel_op_39*uy_dof_6 + tmp_kernel_op_42*uy_dof_1 + tmp_kernel_op_45*uy_dof_2 + tmp_kernel_op_48*uy_dof_3 + tmp_kernel_op_49*uy_dof_7 + tmp_kernel_op_50*uy_dof_8 + tmp_kernel_op_52*uy_dof_9 + tmp_kernel_op_53*uy_dof_0;
             const real_t tmp_kernel_op_56 = tmp_kernel_op_37*uz_dof_4 + tmp_kernel_op_38*uz_dof_5 + tmp_kernel_op_39*uz_dof_6 + tmp_kernel_op_42*uz_dof_1 + tmp_kernel_op_45*uz_dof_2 + tmp_kernel_op_48*uz_dof_3 + tmp_kernel_op_49*uz_dof_7 + tmp_kernel_op_50*uz_dof_8 + tmp_kernel_op_52*uz_dof_9 + tmp_kernel_op_53*uz_dof_0;
             const real_t tmp_kernel_op_57 = abs_det_jac_affine_BLUE_DOWN*abs_det_jac_blending_q_1*(cp_times_delta_dof_0*tmp_kernel_op_53 + cp_times_delta_dof_1*tmp_kernel_op_42 + cp_times_delta_dof_2*tmp_kernel_op_45 + cp_times_delta_dof_3*tmp_kernel_op_48 + cp_times_delta_dof_4*tmp_kernel_op_37 + cp_times_delta_dof_5*tmp_kernel_op_38 + cp_times_delta_dof_6*tmp_kernel_op_39 + cp_times_delta_dof_7*tmp_kernel_op_49 + cp_times_delta_dof_8*tmp_kernel_op_50 + cp_times_delta_dof_9*tmp_kernel_op_52)*0.074999999999999983;
             const real_t tmp_kernel_op_83 = tmp_kernel_op_66*ux_dof_4 + tmp_kernel_op_67*ux_dof_5 + tmp_kernel_op_68*ux_dof_6 + tmp_kernel_op_71*ux_dof_1 + tmp_kernel_op_74*ux_dof_2 + tmp_kernel_op_77*ux_dof_3 + tmp_kernel_op_78*ux_dof_7 + tmp_kernel_op_79*ux_dof_8 + tmp_kernel_op_81*ux_dof_9 + tmp_kernel_op_82*ux_dof_0;
             const real_t tmp_kernel_op_84 = tmp_kernel_op_66*uy_dof_4 + tmp_kernel_op_67*uy_dof_5 + tmp_kernel_op_68*uy_dof_6 + tmp_kernel_op_71*uy_dof_1 + tmp_kernel_op_74*uy_dof_2 + tmp_kernel_op_77*uy_dof_3 + tmp_kernel_op_78*uy_dof_7 + tmp_kernel_op_79*uy_dof_8 + tmp_kernel_op_81*uy_dof_9 + tmp_kernel_op_82*uy_dof_0;
             const real_t tmp_kernel_op_85 = tmp_kernel_op_66*uz_dof_4 + tmp_kernel_op_67*uz_dof_5 + tmp_kernel_op_68*uz_dof_6 + tmp_kernel_op_71*uz_dof_1 + tmp_kernel_op_74*uz_dof_2 + tmp_kernel_op_77*uz_dof_3 + tmp_kernel_op_78*uz_dof_7 + tmp_kernel_op_79*uz_dof_8 + tmp_kernel_op_81*uz_dof_9 + tmp_kernel_op_82*uz_dof_0;
             const real_t tmp_kernel_op_86 = abs_det_jac_affine_BLUE_DOWN*abs_det_jac_blending_q_2*(cp_times_delta_dof_0*tmp_kernel_op_82 + cp_times_delta_dof_1*tmp_kernel_op_71 + cp_times_delta_dof_2*tmp_kernel_op_74 + cp_times_delta_dof_3*tmp_kernel_op_77 + cp_times_delta_dof_4*tmp_kernel_op_66 + cp_times_delta_dof_5*tmp_kernel_op_67 + cp_times_delta_dof_6*tmp_kernel_op_68 + cp_times_delta_dof_7*tmp_kernel_op_78 + cp_times_delta_dof_8*tmp_kernel_op_79 + cp_times_delta_dof_9*tmp_kernel_op_81)*0.074999999999999983;
             const real_t tmp_kernel_op_112 = tmp_kernel_op_100*ux_dof_1 + tmp_kernel_op_103*ux_dof_2 + tmp_kernel_op_106*ux_dof_3 + tmp_kernel_op_107*ux_dof_7 + tmp_kernel_op_108*ux_dof_8 + tmp_kernel_op_110*ux_dof_9 + tmp_kernel_op_111*ux_dof_0 + tmp_kernel_op_95*ux_dof_4 + tmp_kernel_op_96*ux_dof_5 + tmp_kernel_op_97*ux_dof_6;
             const real_t tmp_kernel_op_113 = tmp_kernel_op_100*uy_dof_1 + tmp_kernel_op_103*uy_dof_2 + tmp_kernel_op_106*uy_dof_3 + tmp_kernel_op_107*uy_dof_7 + tmp_kernel_op_108*uy_dof_8 + tmp_kernel_op_110*uy_dof_9 + tmp_kernel_op_111*uy_dof_0 + tmp_kernel_op_95*uy_dof_4 + tmp_kernel_op_96*uy_dof_5 + tmp_kernel_op_97*uy_dof_6;
             const real_t tmp_kernel_op_114 = tmp_kernel_op_100*uz_dof_1 + tmp_kernel_op_103*uz_dof_2 + tmp_kernel_op_106*uz_dof_3 + tmp_kernel_op_107*uz_dof_7 + tmp_kernel_op_108*uz_dof_8 + tmp_kernel_op_110*uz_dof_9 + tmp_kernel_op_111*uz_dof_0 + tmp_kernel_op_95*uz_dof_4 + tmp_kernel_op_96*uz_dof_5 + tmp_kernel_op_97*uz_dof_6;
             const real_t tmp_kernel_op_115 = abs_det_jac_affine_BLUE_DOWN*abs_det_jac_blending_q_3*(cp_times_delta_dof_0*tmp_kernel_op_111 + cp_times_delta_dof_1*tmp_kernel_op_100 + cp_times_delta_dof_2*tmp_kernel_op_103 + cp_times_delta_dof_3*tmp_kernel_op_106 + cp_times_delta_dof_4*tmp_kernel_op_95 + cp_times_delta_dof_5*tmp_kernel_op_96 + cp_times_delta_dof_6*tmp_kernel_op_97 + cp_times_delta_dof_7*tmp_kernel_op_107 + cp_times_delta_dof_8*tmp_kernel_op_108 + cp_times_delta_dof_9*tmp_kernel_op_110)*0.074999999999999983;
             const real_t tmp_kernel_op_141 = tmp_kernel_op_124*ux_dof_4 + tmp_kernel_op_125*ux_dof_5 + tmp_kernel_op_126*ux_dof_6 + tmp_kernel_op_129*ux_dof_1 + tmp_kernel_op_132*ux_dof_2 + tmp_kernel_op_135*ux_dof_3 + tmp_kernel_op_136*ux_dof_7 + tmp_kernel_op_137*ux_dof_8 + tmp_kernel_op_139*ux_dof_9 + tmp_kernel_op_140*ux_dof_0;
             const real_t tmp_kernel_op_142 = tmp_kernel_op_124*uy_dof_4 + tmp_kernel_op_125*uy_dof_5 + tmp_kernel_op_126*uy_dof_6 + tmp_kernel_op_129*uy_dof_1 + tmp_kernel_op_132*uy_dof_2 + tmp_kernel_op_135*uy_dof_3 + tmp_kernel_op_136*uy_dof_7 + tmp_kernel_op_137*uy_dof_8 + tmp_kernel_op_139*uy_dof_9 + tmp_kernel_op_140*uy_dof_0;
             const real_t tmp_kernel_op_143 = tmp_kernel_op_124*uz_dof_4 + tmp_kernel_op_125*uz_dof_5 + tmp_kernel_op_126*uz_dof_6 + tmp_kernel_op_129*uz_dof_1 + tmp_kernel_op_132*uz_dof_2 + tmp_kernel_op_135*uz_dof_3 + tmp_kernel_op_136*uz_dof_7 + tmp_kernel_op_137*uz_dof_8 + tmp_kernel_op_139*uz_dof_9 + tmp_kernel_op_140*uz_dof_0;
             const real_t tmp_kernel_op_144 = abs_det_jac_affine_BLUE_DOWN*abs_det_jac_blending_q_4*(cp_times_delta_dof_0*tmp_kernel_op_140 + cp_times_delta_dof_1*tmp_kernel_op_129 + cp_times_delta_dof_2*tmp_kernel_op_132 + cp_times_delta_dof_3*tmp_kernel_op_135 + cp_times_delta_dof_4*tmp_kernel_op_124 + cp_times_delta_dof_5*tmp_kernel_op_125 + cp_times_delta_dof_6*tmp_kernel_op_126 + cp_times_delta_dof_7*tmp_kernel_op_136 + cp_times_delta_dof_8*tmp_kernel_op_137 + cp_times_delta_dof_9*tmp_kernel_op_139)*0.074999999999999983;
             const real_t elMatDiag_0 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_489 + jac_blending_inv_1_0_q_3*tmp_moved_constant_490 + jac_blending_inv_2_0_q_3*tmp_moved_constant_491) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_489 + jac_blending_inv_1_1_q_3*tmp_moved_constant_490 + jac_blending_inv_2_1_q_3*tmp_moved_constant_491) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_489 + jac_blending_inv_1_2_q_3*tmp_moved_constant_490 + jac_blending_inv_2_2_q_3*tmp_moved_constant_491))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_489 + jac_blending_inv_1_0_q_3*tmp_moved_constant_490 + jac_blending_inv_2_0_q_3*tmp_moved_constant_491) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_489 + jac_blending_inv_1_1_q_3*tmp_moved_constant_490 + jac_blending_inv_2_1_q_3*tmp_moved_constant_491) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_489 + jac_blending_inv_1_2_q_3*tmp_moved_constant_490 + jac_blending_inv_2_2_q_3*tmp_moved_constant_491))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_492 + jac_blending_inv_1_0_q_4*tmp_moved_constant_493 + jac_blending_inv_2_0_q_4*tmp_moved_constant_494) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_492 + jac_blending_inv_1_1_q_4*tmp_moved_constant_493 + jac_blending_inv_2_1_q_4*tmp_moved_constant_494) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_492 + jac_blending_inv_1_2_q_4*tmp_moved_constant_493 + jac_blending_inv_2_2_q_4*tmp_moved_constant_494))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_492 + jac_blending_inv_1_0_q_4*tmp_moved_constant_493 + jac_blending_inv_2_0_q_4*tmp_moved_constant_494) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_492 + jac_blending_inv_1_1_q_4*tmp_moved_constant_493 + jac_blending_inv_2_1_q_4*tmp_moved_constant_494) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_492 + jac_blending_inv_1_2_q_4*tmp_moved_constant_493 + jac_blending_inv_2_2_q_4*tmp_moved_constant_494))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_480 + jac_blending_inv_1_0_q_0*tmp_moved_constant_481 + jac_blending_inv_2_0_q_0*tmp_moved_constant_482) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_480 + jac_blending_inv_1_1_q_0*tmp_moved_constant_481 + jac_blending_inv_2_1_q_0*tmp_moved_constant_482) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_480 + jac_blending_inv_1_2_q_0*tmp_moved_constant_481 + jac_blending_inv_2_2_q_0*tmp_moved_constant_482))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_480 + jac_blending_inv_1_0_q_0*tmp_moved_constant_481 + jac_blending_inv_2_0_q_0*tmp_moved_constant_482) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_480 + jac_blending_inv_1_1_q_0*tmp_moved_constant_481 + jac_blending_inv_2_1_q_0*tmp_moved_constant_482) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_480 + jac_blending_inv_1_2_q_0*tmp_moved_constant_481 + jac_blending_inv_2_2_q_0*tmp_moved_constant_482))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_483 + jac_blending_inv_1_0_q_1*tmp_moved_constant_484 + jac_blending_inv_2_0_q_1*tmp_moved_constant_485) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_483 + jac_blending_inv_1_1_q_1*tmp_moved_constant_484 + jac_blending_inv_2_1_q_1*tmp_moved_constant_485) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_483 + jac_blending_inv_1_2_q_1*tmp_moved_constant_484 + jac_blending_inv_2_2_q_1*tmp_moved_constant_485))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_483 + jac_blending_inv_1_0_q_1*tmp_moved_constant_484 + jac_blending_inv_2_0_q_1*tmp_moved_constant_485) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_483 + jac_blending_inv_1_1_q_1*tmp_moved_constant_484 + jac_blending_inv_2_1_q_1*tmp_moved_constant_485) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_483 + jac_blending_inv_1_2_q_1*tmp_moved_constant_484 + jac_blending_inv_2_2_q_1*tmp_moved_constant_485))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_486 + jac_blending_inv_1_0_q_2*tmp_moved_constant_487 + jac_blending_inv_2_0_q_2*tmp_moved_constant_488) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_486 + jac_blending_inv_1_1_q_2*tmp_moved_constant_487 + jac_blending_inv_2_1_q_2*tmp_moved_constant_488) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_486 + jac_blending_inv_1_2_q_2*tmp_moved_constant_487 + jac_blending_inv_2_2_q_2*tmp_moved_constant_488))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_486 + jac_blending_inv_1_0_q_2*tmp_moved_constant_487 + jac_blending_inv_2_0_q_2*tmp_moved_constant_488) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_486 + jac_blending_inv_1_1_q_2*tmp_moved_constant_487 + jac_blending_inv_2_1_q_2*tmp_moved_constant_488) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_486 + jac_blending_inv_1_2_q_2*tmp_moved_constant_487 + jac_blending_inv_2_2_q_2*tmp_moved_constant_488)));
             const real_t elMatDiag_1 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_504 + jac_blending_inv_1_0_q_3*tmp_moved_constant_505 + jac_blending_inv_2_0_q_3*tmp_moved_constant_506) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_504 + jac_blending_inv_1_1_q_3*tmp_moved_constant_505 + jac_blending_inv_2_1_q_3*tmp_moved_constant_506) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_504 + jac_blending_inv_1_2_q_3*tmp_moved_constant_505 + jac_blending_inv_2_2_q_3*tmp_moved_constant_506))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_504 + jac_blending_inv_1_0_q_3*tmp_moved_constant_505 + jac_blending_inv_2_0_q_3*tmp_moved_constant_506) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_504 + jac_blending_inv_1_1_q_3*tmp_moved_constant_505 + jac_blending_inv_2_1_q_3*tmp_moved_constant_506) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_504 + jac_blending_inv_1_2_q_3*tmp_moved_constant_505 + jac_blending_inv_2_2_q_3*tmp_moved_constant_506))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_507 + jac_blending_inv_1_0_q_4*tmp_moved_constant_508 + jac_blending_inv_2_0_q_4*tmp_moved_constant_509) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_507 + jac_blending_inv_1_1_q_4*tmp_moved_constant_508 + jac_blending_inv_2_1_q_4*tmp_moved_constant_509) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_507 + jac_blending_inv_1_2_q_4*tmp_moved_constant_508 + jac_blending_inv_2_2_q_4*tmp_moved_constant_509))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_507 + jac_blending_inv_1_0_q_4*tmp_moved_constant_508 + jac_blending_inv_2_0_q_4*tmp_moved_constant_509) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_507 + jac_blending_inv_1_1_q_4*tmp_moved_constant_508 + jac_blending_inv_2_1_q_4*tmp_moved_constant_509) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_507 + jac_blending_inv_1_2_q_4*tmp_moved_constant_508 + jac_blending_inv_2_2_q_4*tmp_moved_constant_509))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_495 + jac_blending_inv_1_0_q_0*tmp_moved_constant_496 + jac_blending_inv_2_0_q_0*tmp_moved_constant_497) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_495 + jac_blending_inv_1_1_q_0*tmp_moved_constant_496 + jac_blending_inv_2_1_q_0*tmp_moved_constant_497) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_495 + jac_blending_inv_1_2_q_0*tmp_moved_constant_496 + jac_blending_inv_2_2_q_0*tmp_moved_constant_497))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_495 + jac_blending_inv_1_0_q_0*tmp_moved_constant_496 + jac_blending_inv_2_0_q_0*tmp_moved_constant_497) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_495 + jac_blending_inv_1_1_q_0*tmp_moved_constant_496 + jac_blending_inv_2_1_q_0*tmp_moved_constant_497) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_495 + jac_blending_inv_1_2_q_0*tmp_moved_constant_496 + jac_blending_inv_2_2_q_0*tmp_moved_constant_497))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_498 + jac_blending_inv_1_0_q_1*tmp_moved_constant_499 + jac_blending_inv_2_0_q_1*tmp_moved_constant_500) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_498 + jac_blending_inv_1_1_q_1*tmp_moved_constant_499 + jac_blending_inv_2_1_q_1*tmp_moved_constant_500) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_498 + jac_blending_inv_1_2_q_1*tmp_moved_constant_499 + jac_blending_inv_2_2_q_1*tmp_moved_constant_500))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_498 + jac_blending_inv_1_0_q_1*tmp_moved_constant_499 + jac_blending_inv_2_0_q_1*tmp_moved_constant_500) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_498 + jac_blending_inv_1_1_q_1*tmp_moved_constant_499 + jac_blending_inv_2_1_q_1*tmp_moved_constant_500) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_498 + jac_blending_inv_1_2_q_1*tmp_moved_constant_499 + jac_blending_inv_2_2_q_1*tmp_moved_constant_500))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_501 + jac_blending_inv_1_0_q_2*tmp_moved_constant_502 + jac_blending_inv_2_0_q_2*tmp_moved_constant_503) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_501 + jac_blending_inv_1_1_q_2*tmp_moved_constant_502 + jac_blending_inv_2_1_q_2*tmp_moved_constant_503) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_501 + jac_blending_inv_1_2_q_2*tmp_moved_constant_502 + jac_blending_inv_2_2_q_2*tmp_moved_constant_503))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_501 + jac_blending_inv_1_0_q_2*tmp_moved_constant_502 + jac_blending_inv_2_0_q_2*tmp_moved_constant_503) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_501 + jac_blending_inv_1_1_q_2*tmp_moved_constant_502 + jac_blending_inv_2_1_q_2*tmp_moved_constant_503) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_501 + jac_blending_inv_1_2_q_2*tmp_moved_constant_502 + jac_blending_inv_2_2_q_2*tmp_moved_constant_503)));
             const real_t elMatDiag_2 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_519 + jac_blending_inv_1_0_q_3*tmp_moved_constant_520 + jac_blending_inv_2_0_q_3*tmp_moved_constant_521) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_519 + jac_blending_inv_1_1_q_3*tmp_moved_constant_520 + jac_blending_inv_2_1_q_3*tmp_moved_constant_521) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_519 + jac_blending_inv_1_2_q_3*tmp_moved_constant_520 + jac_blending_inv_2_2_q_3*tmp_moved_constant_521))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_519 + jac_blending_inv_1_0_q_3*tmp_moved_constant_520 + jac_blending_inv_2_0_q_3*tmp_moved_constant_521) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_519 + jac_blending_inv_1_1_q_3*tmp_moved_constant_520 + jac_blending_inv_2_1_q_3*tmp_moved_constant_521) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_519 + jac_blending_inv_1_2_q_3*tmp_moved_constant_520 + jac_blending_inv_2_2_q_3*tmp_moved_constant_521))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_522 + jac_blending_inv_1_0_q_4*tmp_moved_constant_523 + jac_blending_inv_2_0_q_4*tmp_moved_constant_524) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_522 + jac_blending_inv_1_1_q_4*tmp_moved_constant_523 + jac_blending_inv_2_1_q_4*tmp_moved_constant_524) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_522 + jac_blending_inv_1_2_q_4*tmp_moved_constant_523 + jac_blending_inv_2_2_q_4*tmp_moved_constant_524))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_522 + jac_blending_inv_1_0_q_4*tmp_moved_constant_523 + jac_blending_inv_2_0_q_4*tmp_moved_constant_524) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_522 + jac_blending_inv_1_1_q_4*tmp_moved_constant_523 + jac_blending_inv_2_1_q_4*tmp_moved_constant_524) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_522 + jac_blending_inv_1_2_q_4*tmp_moved_constant_523 + jac_blending_inv_2_2_q_4*tmp_moved_constant_524))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_510 + jac_blending_inv_1_0_q_0*tmp_moved_constant_511 + jac_blending_inv_2_0_q_0*tmp_moved_constant_512) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_510 + jac_blending_inv_1_1_q_0*tmp_moved_constant_511 + jac_blending_inv_2_1_q_0*tmp_moved_constant_512) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_510 + jac_blending_inv_1_2_q_0*tmp_moved_constant_511 + jac_blending_inv_2_2_q_0*tmp_moved_constant_512))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_510 + jac_blending_inv_1_0_q_0*tmp_moved_constant_511 + jac_blending_inv_2_0_q_0*tmp_moved_constant_512) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_510 + jac_blending_inv_1_1_q_0*tmp_moved_constant_511 + jac_blending_inv_2_1_q_0*tmp_moved_constant_512) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_510 + jac_blending_inv_1_2_q_0*tmp_moved_constant_511 + jac_blending_inv_2_2_q_0*tmp_moved_constant_512))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_513 + jac_blending_inv_1_0_q_1*tmp_moved_constant_514 + jac_blending_inv_2_0_q_1*tmp_moved_constant_515) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_513 + jac_blending_inv_1_1_q_1*tmp_moved_constant_514 + jac_blending_inv_2_1_q_1*tmp_moved_constant_515) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_513 + jac_blending_inv_1_2_q_1*tmp_moved_constant_514 + jac_blending_inv_2_2_q_1*tmp_moved_constant_515))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_513 + jac_blending_inv_1_0_q_1*tmp_moved_constant_514 + jac_blending_inv_2_0_q_1*tmp_moved_constant_515) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_513 + jac_blending_inv_1_1_q_1*tmp_moved_constant_514 + jac_blending_inv_2_1_q_1*tmp_moved_constant_515) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_513 + jac_blending_inv_1_2_q_1*tmp_moved_constant_514 + jac_blending_inv_2_2_q_1*tmp_moved_constant_515))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_516 + jac_blending_inv_1_0_q_2*tmp_moved_constant_517 + jac_blending_inv_2_0_q_2*tmp_moved_constant_518) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_516 + jac_blending_inv_1_1_q_2*tmp_moved_constant_517 + jac_blending_inv_2_1_q_2*tmp_moved_constant_518) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_516 + jac_blending_inv_1_2_q_2*tmp_moved_constant_517 + jac_blending_inv_2_2_q_2*tmp_moved_constant_518))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_516 + jac_blending_inv_1_0_q_2*tmp_moved_constant_517 + jac_blending_inv_2_0_q_2*tmp_moved_constant_518) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_516 + jac_blending_inv_1_1_q_2*tmp_moved_constant_517 + jac_blending_inv_2_1_q_2*tmp_moved_constant_518) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_516 + jac_blending_inv_1_2_q_2*tmp_moved_constant_517 + jac_blending_inv_2_2_q_2*tmp_moved_constant_518)));
             const real_t elMatDiag_3 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_534 + jac_blending_inv_1_0_q_3*tmp_moved_constant_535 + jac_blending_inv_2_0_q_3*tmp_moved_constant_536) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_534 + jac_blending_inv_1_1_q_3*tmp_moved_constant_535 + jac_blending_inv_2_1_q_3*tmp_moved_constant_536) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_534 + jac_blending_inv_1_2_q_3*tmp_moved_constant_535 + jac_blending_inv_2_2_q_3*tmp_moved_constant_536))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_534 + jac_blending_inv_1_0_q_3*tmp_moved_constant_535 + jac_blending_inv_2_0_q_3*tmp_moved_constant_536) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_534 + jac_blending_inv_1_1_q_3*tmp_moved_constant_535 + jac_blending_inv_2_1_q_3*tmp_moved_constant_536) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_534 + jac_blending_inv_1_2_q_3*tmp_moved_constant_535 + jac_blending_inv_2_2_q_3*tmp_moved_constant_536))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_537 + jac_blending_inv_1_0_q_4*tmp_moved_constant_538 + jac_blending_inv_2_0_q_4*tmp_moved_constant_539) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_537 + jac_blending_inv_1_1_q_4*tmp_moved_constant_538 + jac_blending_inv_2_1_q_4*tmp_moved_constant_539) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_537 + jac_blending_inv_1_2_q_4*tmp_moved_constant_538 + jac_blending_inv_2_2_q_4*tmp_moved_constant_539))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_537 + jac_blending_inv_1_0_q_4*tmp_moved_constant_538 + jac_blending_inv_2_0_q_4*tmp_moved_constant_539) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_537 + jac_blending_inv_1_1_q_4*tmp_moved_constant_538 + jac_blending_inv_2_1_q_4*tmp_moved_constant_539) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_537 + jac_blending_inv_1_2_q_4*tmp_moved_constant_538 + jac_blending_inv_2_2_q_4*tmp_moved_constant_539))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_525 + jac_blending_inv_1_0_q_0*tmp_moved_constant_526 + jac_blending_inv_2_0_q_0*tmp_moved_constant_527) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_525 + jac_blending_inv_1_1_q_0*tmp_moved_constant_526 + jac_blending_inv_2_1_q_0*tmp_moved_constant_527) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_525 + jac_blending_inv_1_2_q_0*tmp_moved_constant_526 + jac_blending_inv_2_2_q_0*tmp_moved_constant_527))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_525 + jac_blending_inv_1_0_q_0*tmp_moved_constant_526 + jac_blending_inv_2_0_q_0*tmp_moved_constant_527) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_525 + jac_blending_inv_1_1_q_0*tmp_moved_constant_526 + jac_blending_inv_2_1_q_0*tmp_moved_constant_527) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_525 + jac_blending_inv_1_2_q_0*tmp_moved_constant_526 + jac_blending_inv_2_2_q_0*tmp_moved_constant_527))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_528 + jac_blending_inv_1_0_q_1*tmp_moved_constant_529 + jac_blending_inv_2_0_q_1*tmp_moved_constant_530) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_528 + jac_blending_inv_1_1_q_1*tmp_moved_constant_529 + jac_blending_inv_2_1_q_1*tmp_moved_constant_530) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_528 + jac_blending_inv_1_2_q_1*tmp_moved_constant_529 + jac_blending_inv_2_2_q_1*tmp_moved_constant_530))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_528 + jac_blending_inv_1_0_q_1*tmp_moved_constant_529 + jac_blending_inv_2_0_q_1*tmp_moved_constant_530) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_528 + jac_blending_inv_1_1_q_1*tmp_moved_constant_529 + jac_blending_inv_2_1_q_1*tmp_moved_constant_530) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_528 + jac_blending_inv_1_2_q_1*tmp_moved_constant_529 + jac_blending_inv_2_2_q_1*tmp_moved_constant_530))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_531 + jac_blending_inv_1_0_q_2*tmp_moved_constant_532 + jac_blending_inv_2_0_q_2*tmp_moved_constant_533) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_531 + jac_blending_inv_1_1_q_2*tmp_moved_constant_532 + jac_blending_inv_2_1_q_2*tmp_moved_constant_533) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_531 + jac_blending_inv_1_2_q_2*tmp_moved_constant_532 + jac_blending_inv_2_2_q_2*tmp_moved_constant_533))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_531 + jac_blending_inv_1_0_q_2*tmp_moved_constant_532 + jac_blending_inv_2_0_q_2*tmp_moved_constant_533) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_531 + jac_blending_inv_1_1_q_2*tmp_moved_constant_532 + jac_blending_inv_2_1_q_2*tmp_moved_constant_533) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_531 + jac_blending_inv_1_2_q_2*tmp_moved_constant_532 + jac_blending_inv_2_2_q_2*tmp_moved_constant_533)));
             const real_t elMatDiag_4 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_569 + jac_blending_inv_1_0_q_3*tmp_moved_constant_572 + jac_blending_inv_2_0_q_3*tmp_moved_constant_575) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_569 + jac_blending_inv_1_1_q_3*tmp_moved_constant_572 + jac_blending_inv_2_1_q_3*tmp_moved_constant_575) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_569 + jac_blending_inv_1_2_q_3*tmp_moved_constant_572 + jac_blending_inv_2_2_q_3*tmp_moved_constant_575))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_569 + jac_blending_inv_1_0_q_3*tmp_moved_constant_572 + jac_blending_inv_2_0_q_3*tmp_moved_constant_575) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_569 + jac_blending_inv_1_1_q_3*tmp_moved_constant_572 + jac_blending_inv_2_1_q_3*tmp_moved_constant_575) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_569 + jac_blending_inv_1_2_q_3*tmp_moved_constant_572 + jac_blending_inv_2_2_q_3*tmp_moved_constant_575))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_578 + jac_blending_inv_1_0_q_4*tmp_moved_constant_581 + jac_blending_inv_2_0_q_4*tmp_moved_constant_584) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_578 + jac_blending_inv_1_1_q_4*tmp_moved_constant_581 + jac_blending_inv_2_1_q_4*tmp_moved_constant_584) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_578 + jac_blending_inv_1_2_q_4*tmp_moved_constant_581 + jac_blending_inv_2_2_q_4*tmp_moved_constant_584))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_578 + jac_blending_inv_1_0_q_4*tmp_moved_constant_581 + jac_blending_inv_2_0_q_4*tmp_moved_constant_584) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_578 + jac_blending_inv_1_1_q_4*tmp_moved_constant_581 + jac_blending_inv_2_1_q_4*tmp_moved_constant_584) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_578 + jac_blending_inv_1_2_q_4*tmp_moved_constant_581 + jac_blending_inv_2_2_q_4*tmp_moved_constant_584))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_542 + jac_blending_inv_1_0_q_0*tmp_moved_constant_545 + jac_blending_inv_2_0_q_0*tmp_moved_constant_548) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_542 + jac_blending_inv_1_1_q_0*tmp_moved_constant_545 + jac_blending_inv_2_1_q_0*tmp_moved_constant_548) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_542 + jac_blending_inv_1_2_q_0*tmp_moved_constant_545 + jac_blending_inv_2_2_q_0*tmp_moved_constant_548))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_542 + jac_blending_inv_1_0_q_0*tmp_moved_constant_545 + jac_blending_inv_2_0_q_0*tmp_moved_constant_548) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_542 + jac_blending_inv_1_1_q_0*tmp_moved_constant_545 + jac_blending_inv_2_1_q_0*tmp_moved_constant_548) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_542 + jac_blending_inv_1_2_q_0*tmp_moved_constant_545 + jac_blending_inv_2_2_q_0*tmp_moved_constant_548))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_551 + jac_blending_inv_1_0_q_1*tmp_moved_constant_554 + jac_blending_inv_2_0_q_1*tmp_moved_constant_557) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_551 + jac_blending_inv_1_1_q_1*tmp_moved_constant_554 + jac_blending_inv_2_1_q_1*tmp_moved_constant_557) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_551 + jac_blending_inv_1_2_q_1*tmp_moved_constant_554 + jac_blending_inv_2_2_q_1*tmp_moved_constant_557))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_551 + jac_blending_inv_1_0_q_1*tmp_moved_constant_554 + jac_blending_inv_2_0_q_1*tmp_moved_constant_557) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_551 + jac_blending_inv_1_1_q_1*tmp_moved_constant_554 + jac_blending_inv_2_1_q_1*tmp_moved_constant_557) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_551 + jac_blending_inv_1_2_q_1*tmp_moved_constant_554 + jac_blending_inv_2_2_q_1*tmp_moved_constant_557))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_560 + jac_blending_inv_1_0_q_2*tmp_moved_constant_563 + jac_blending_inv_2_0_q_2*tmp_moved_constant_566) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_560 + jac_blending_inv_1_1_q_2*tmp_moved_constant_563 + jac_blending_inv_2_1_q_2*tmp_moved_constant_566) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_560 + jac_blending_inv_1_2_q_2*tmp_moved_constant_563 + jac_blending_inv_2_2_q_2*tmp_moved_constant_566))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_560 + jac_blending_inv_1_0_q_2*tmp_moved_constant_563 + jac_blending_inv_2_0_q_2*tmp_moved_constant_566) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_560 + jac_blending_inv_1_1_q_2*tmp_moved_constant_563 + jac_blending_inv_2_1_q_2*tmp_moved_constant_566) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_560 + jac_blending_inv_1_2_q_2*tmp_moved_constant_563 + jac_blending_inv_2_2_q_2*tmp_moved_constant_566)));
             const real_t elMatDiag_5 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_614 + jac_blending_inv_1_0_q_3*tmp_moved_constant_617 + jac_blending_inv_2_0_q_3*tmp_moved_constant_620) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_614 + jac_blending_inv_1_1_q_3*tmp_moved_constant_617 + jac_blending_inv_2_1_q_3*tmp_moved_constant_620) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_614 + jac_blending_inv_1_2_q_3*tmp_moved_constant_617 + jac_blending_inv_2_2_q_3*tmp_moved_constant_620))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_614 + jac_blending_inv_1_0_q_3*tmp_moved_constant_617 + jac_blending_inv_2_0_q_3*tmp_moved_constant_620) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_614 + jac_blending_inv_1_1_q_3*tmp_moved_constant_617 + jac_blending_inv_2_1_q_3*tmp_moved_constant_620) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_614 + jac_blending_inv_1_2_q_3*tmp_moved_constant_617 + jac_blending_inv_2_2_q_3*tmp_moved_constant_620))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_623 + jac_blending_inv_1_0_q_4*tmp_moved_constant_626 + jac_blending_inv_2_0_q_4*tmp_moved_constant_629) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_623 + jac_blending_inv_1_1_q_4*tmp_moved_constant_626 + jac_blending_inv_2_1_q_4*tmp_moved_constant_629) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_623 + jac_blending_inv_1_2_q_4*tmp_moved_constant_626 + jac_blending_inv_2_2_q_4*tmp_moved_constant_629))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_623 + jac_blending_inv_1_0_q_4*tmp_moved_constant_626 + jac_blending_inv_2_0_q_4*tmp_moved_constant_629) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_623 + jac_blending_inv_1_1_q_4*tmp_moved_constant_626 + jac_blending_inv_2_1_q_4*tmp_moved_constant_629) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_623 + jac_blending_inv_1_2_q_4*tmp_moved_constant_626 + jac_blending_inv_2_2_q_4*tmp_moved_constant_629))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_587 + jac_blending_inv_1_0_q_0*tmp_moved_constant_590 + jac_blending_inv_2_0_q_0*tmp_moved_constant_593) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_587 + jac_blending_inv_1_1_q_0*tmp_moved_constant_590 + jac_blending_inv_2_1_q_0*tmp_moved_constant_593) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_587 + jac_blending_inv_1_2_q_0*tmp_moved_constant_590 + jac_blending_inv_2_2_q_0*tmp_moved_constant_593))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_587 + jac_blending_inv_1_0_q_0*tmp_moved_constant_590 + jac_blending_inv_2_0_q_0*tmp_moved_constant_593) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_587 + jac_blending_inv_1_1_q_0*tmp_moved_constant_590 + jac_blending_inv_2_1_q_0*tmp_moved_constant_593) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_587 + jac_blending_inv_1_2_q_0*tmp_moved_constant_590 + jac_blending_inv_2_2_q_0*tmp_moved_constant_593))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_596 + jac_blending_inv_1_0_q_1*tmp_moved_constant_599 + jac_blending_inv_2_0_q_1*tmp_moved_constant_602) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_596 + jac_blending_inv_1_1_q_1*tmp_moved_constant_599 + jac_blending_inv_2_1_q_1*tmp_moved_constant_602) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_596 + jac_blending_inv_1_2_q_1*tmp_moved_constant_599 + jac_blending_inv_2_2_q_1*tmp_moved_constant_602))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_596 + jac_blending_inv_1_0_q_1*tmp_moved_constant_599 + jac_blending_inv_2_0_q_1*tmp_moved_constant_602) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_596 + jac_blending_inv_1_1_q_1*tmp_moved_constant_599 + jac_blending_inv_2_1_q_1*tmp_moved_constant_602) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_596 + jac_blending_inv_1_2_q_1*tmp_moved_constant_599 + jac_blending_inv_2_2_q_1*tmp_moved_constant_602))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_605 + jac_blending_inv_1_0_q_2*tmp_moved_constant_608 + jac_blending_inv_2_0_q_2*tmp_moved_constant_611) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_605 + jac_blending_inv_1_1_q_2*tmp_moved_constant_608 + jac_blending_inv_2_1_q_2*tmp_moved_constant_611) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_605 + jac_blending_inv_1_2_q_2*tmp_moved_constant_608 + jac_blending_inv_2_2_q_2*tmp_moved_constant_611))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_605 + jac_blending_inv_1_0_q_2*tmp_moved_constant_608 + jac_blending_inv_2_0_q_2*tmp_moved_constant_611) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_605 + jac_blending_inv_1_1_q_2*tmp_moved_constant_608 + jac_blending_inv_2_1_q_2*tmp_moved_constant_611) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_605 + jac_blending_inv_1_2_q_2*tmp_moved_constant_608 + jac_blending_inv_2_2_q_2*tmp_moved_constant_611)));
             const real_t elMatDiag_6 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_659 + jac_blending_inv_1_0_q_3*tmp_moved_constant_662 + jac_blending_inv_2_0_q_3*tmp_moved_constant_665) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_659 + jac_blending_inv_1_1_q_3*tmp_moved_constant_662 + jac_blending_inv_2_1_q_3*tmp_moved_constant_665) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_659 + jac_blending_inv_1_2_q_3*tmp_moved_constant_662 + jac_blending_inv_2_2_q_3*tmp_moved_constant_665))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_659 + jac_blending_inv_1_0_q_3*tmp_moved_constant_662 + jac_blending_inv_2_0_q_3*tmp_moved_constant_665) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_659 + jac_blending_inv_1_1_q_3*tmp_moved_constant_662 + jac_blending_inv_2_1_q_3*tmp_moved_constant_665) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_659 + jac_blending_inv_1_2_q_3*tmp_moved_constant_662 + jac_blending_inv_2_2_q_3*tmp_moved_constant_665))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_668 + jac_blending_inv_1_0_q_4*tmp_moved_constant_671 + jac_blending_inv_2_0_q_4*tmp_moved_constant_674) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_668 + jac_blending_inv_1_1_q_4*tmp_moved_constant_671 + jac_blending_inv_2_1_q_4*tmp_moved_constant_674) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_668 + jac_blending_inv_1_2_q_4*tmp_moved_constant_671 + jac_blending_inv_2_2_q_4*tmp_moved_constant_674))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_668 + jac_blending_inv_1_0_q_4*tmp_moved_constant_671 + jac_blending_inv_2_0_q_4*tmp_moved_constant_674) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_668 + jac_blending_inv_1_1_q_4*tmp_moved_constant_671 + jac_blending_inv_2_1_q_4*tmp_moved_constant_674) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_668 + jac_blending_inv_1_2_q_4*tmp_moved_constant_671 + jac_blending_inv_2_2_q_4*tmp_moved_constant_674))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_632 + jac_blending_inv_1_0_q_0*tmp_moved_constant_635 + jac_blending_inv_2_0_q_0*tmp_moved_constant_638) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_632 + jac_blending_inv_1_1_q_0*tmp_moved_constant_635 + jac_blending_inv_2_1_q_0*tmp_moved_constant_638) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_632 + jac_blending_inv_1_2_q_0*tmp_moved_constant_635 + jac_blending_inv_2_2_q_0*tmp_moved_constant_638))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_632 + jac_blending_inv_1_0_q_0*tmp_moved_constant_635 + jac_blending_inv_2_0_q_0*tmp_moved_constant_638) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_632 + jac_blending_inv_1_1_q_0*tmp_moved_constant_635 + jac_blending_inv_2_1_q_0*tmp_moved_constant_638) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_632 + jac_blending_inv_1_2_q_0*tmp_moved_constant_635 + jac_blending_inv_2_2_q_0*tmp_moved_constant_638))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_641 + jac_blending_inv_1_0_q_1*tmp_moved_constant_644 + jac_blending_inv_2_0_q_1*tmp_moved_constant_647) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_641 + jac_blending_inv_1_1_q_1*tmp_moved_constant_644 + jac_blending_inv_2_1_q_1*tmp_moved_constant_647) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_641 + jac_blending_inv_1_2_q_1*tmp_moved_constant_644 + jac_blending_inv_2_2_q_1*tmp_moved_constant_647))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_641 + jac_blending_inv_1_0_q_1*tmp_moved_constant_644 + jac_blending_inv_2_0_q_1*tmp_moved_constant_647) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_641 + jac_blending_inv_1_1_q_1*tmp_moved_constant_644 + jac_blending_inv_2_1_q_1*tmp_moved_constant_647) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_641 + jac_blending_inv_1_2_q_1*tmp_moved_constant_644 + jac_blending_inv_2_2_q_1*tmp_moved_constant_647))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_650 + jac_blending_inv_1_0_q_2*tmp_moved_constant_653 + jac_blending_inv_2_0_q_2*tmp_moved_constant_656) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_650 + jac_blending_inv_1_1_q_2*tmp_moved_constant_653 + jac_blending_inv_2_1_q_2*tmp_moved_constant_656) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_650 + jac_blending_inv_1_2_q_2*tmp_moved_constant_653 + jac_blending_inv_2_2_q_2*tmp_moved_constant_656))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_650 + jac_blending_inv_1_0_q_2*tmp_moved_constant_653 + jac_blending_inv_2_0_q_2*tmp_moved_constant_656) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_650 + jac_blending_inv_1_1_q_2*tmp_moved_constant_653 + jac_blending_inv_2_1_q_2*tmp_moved_constant_656) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_650 + jac_blending_inv_1_2_q_2*tmp_moved_constant_653 + jac_blending_inv_2_2_q_2*tmp_moved_constant_656)));
             const real_t elMatDiag_7 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_684 + jac_blending_inv_1_0_q_3*tmp_moved_constant_685 + jac_blending_inv_2_0_q_3*tmp_moved_constant_686) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_684 + jac_blending_inv_1_1_q_3*tmp_moved_constant_685 + jac_blending_inv_2_1_q_3*tmp_moved_constant_686) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_684 + jac_blending_inv_1_2_q_3*tmp_moved_constant_685 + jac_blending_inv_2_2_q_3*tmp_moved_constant_686))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_684 + jac_blending_inv_1_0_q_3*tmp_moved_constant_685 + jac_blending_inv_2_0_q_3*tmp_moved_constant_686) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_684 + jac_blending_inv_1_1_q_3*tmp_moved_constant_685 + jac_blending_inv_2_1_q_3*tmp_moved_constant_686) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_684 + jac_blending_inv_1_2_q_3*tmp_moved_constant_685 + jac_blending_inv_2_2_q_3*tmp_moved_constant_686))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_687 + jac_blending_inv_1_0_q_4*tmp_moved_constant_688 + jac_blending_inv_2_0_q_4*tmp_moved_constant_689) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_687 + jac_blending_inv_1_1_q_4*tmp_moved_constant_688 + jac_blending_inv_2_1_q_4*tmp_moved_constant_689) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_687 + jac_blending_inv_1_2_q_4*tmp_moved_constant_688 + jac_blending_inv_2_2_q_4*tmp_moved_constant_689))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_687 + jac_blending_inv_1_0_q_4*tmp_moved_constant_688 + jac_blending_inv_2_0_q_4*tmp_moved_constant_689) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_687 + jac_blending_inv_1_1_q_4*tmp_moved_constant_688 + jac_blending_inv_2_1_q_4*tmp_moved_constant_689) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_687 + jac_blending_inv_1_2_q_4*tmp_moved_constant_688 + jac_blending_inv_2_2_q_4*tmp_moved_constant_689))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_675 + jac_blending_inv_1_0_q_0*tmp_moved_constant_676 + jac_blending_inv_2_0_q_0*tmp_moved_constant_677) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_675 + jac_blending_inv_1_1_q_0*tmp_moved_constant_676 + jac_blending_inv_2_1_q_0*tmp_moved_constant_677) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_675 + jac_blending_inv_1_2_q_0*tmp_moved_constant_676 + jac_blending_inv_2_2_q_0*tmp_moved_constant_677))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_675 + jac_blending_inv_1_0_q_0*tmp_moved_constant_676 + jac_blending_inv_2_0_q_0*tmp_moved_constant_677) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_675 + jac_blending_inv_1_1_q_0*tmp_moved_constant_676 + jac_blending_inv_2_1_q_0*tmp_moved_constant_677) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_675 + jac_blending_inv_1_2_q_0*tmp_moved_constant_676 + jac_blending_inv_2_2_q_0*tmp_moved_constant_677))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_678 + jac_blending_inv_1_0_q_1*tmp_moved_constant_679 + jac_blending_inv_2_0_q_1*tmp_moved_constant_680) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_678 + jac_blending_inv_1_1_q_1*tmp_moved_constant_679 + jac_blending_inv_2_1_q_1*tmp_moved_constant_680) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_678 + jac_blending_inv_1_2_q_1*tmp_moved_constant_679 + jac_blending_inv_2_2_q_1*tmp_moved_constant_680))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_678 + jac_blending_inv_1_0_q_1*tmp_moved_constant_679 + jac_blending_inv_2_0_q_1*tmp_moved_constant_680) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_678 + jac_blending_inv_1_1_q_1*tmp_moved_constant_679 + jac_blending_inv_2_1_q_1*tmp_moved_constant_680) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_678 + jac_blending_inv_1_2_q_1*tmp_moved_constant_679 + jac_blending_inv_2_2_q_1*tmp_moved_constant_680))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_681 + jac_blending_inv_1_0_q_2*tmp_moved_constant_682 + jac_blending_inv_2_0_q_2*tmp_moved_constant_683) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_681 + jac_blending_inv_1_1_q_2*tmp_moved_constant_682 + jac_blending_inv_2_1_q_2*tmp_moved_constant_683) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_681 + jac_blending_inv_1_2_q_2*tmp_moved_constant_682 + jac_blending_inv_2_2_q_2*tmp_moved_constant_683))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_681 + jac_blending_inv_1_0_q_2*tmp_moved_constant_682 + jac_blending_inv_2_0_q_2*tmp_moved_constant_683) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_681 + jac_blending_inv_1_1_q_2*tmp_moved_constant_682 + jac_blending_inv_2_1_q_2*tmp_moved_constant_683) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_681 + jac_blending_inv_1_2_q_2*tmp_moved_constant_682 + jac_blending_inv_2_2_q_2*tmp_moved_constant_683)));
             const real_t elMatDiag_8 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_699 + jac_blending_inv_1_0_q_3*tmp_moved_constant_700 + jac_blending_inv_2_0_q_3*tmp_moved_constant_701) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_699 + jac_blending_inv_1_1_q_3*tmp_moved_constant_700 + jac_blending_inv_2_1_q_3*tmp_moved_constant_701) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_699 + jac_blending_inv_1_2_q_3*tmp_moved_constant_700 + jac_blending_inv_2_2_q_3*tmp_moved_constant_701))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_699 + jac_blending_inv_1_0_q_3*tmp_moved_constant_700 + jac_blending_inv_2_0_q_3*tmp_moved_constant_701) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_699 + jac_blending_inv_1_1_q_3*tmp_moved_constant_700 + jac_blending_inv_2_1_q_3*tmp_moved_constant_701) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_699 + jac_blending_inv_1_2_q_3*tmp_moved_constant_700 + jac_blending_inv_2_2_q_3*tmp_moved_constant_701))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_702 + jac_blending_inv_1_0_q_4*tmp_moved_constant_703 + jac_blending_inv_2_0_q_4*tmp_moved_constant_704) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_702 + jac_blending_inv_1_1_q_4*tmp_moved_constant_703 + jac_blending_inv_2_1_q_4*tmp_moved_constant_704) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_702 + jac_blending_inv_1_2_q_4*tmp_moved_constant_703 + jac_blending_inv_2_2_q_4*tmp_moved_constant_704))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_702 + jac_blending_inv_1_0_q_4*tmp_moved_constant_703 + jac_blending_inv_2_0_q_4*tmp_moved_constant_704) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_702 + jac_blending_inv_1_1_q_4*tmp_moved_constant_703 + jac_blending_inv_2_1_q_4*tmp_moved_constant_704) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_702 + jac_blending_inv_1_2_q_4*tmp_moved_constant_703 + jac_blending_inv_2_2_q_4*tmp_moved_constant_704))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_690 + jac_blending_inv_1_0_q_0*tmp_moved_constant_691 + jac_blending_inv_2_0_q_0*tmp_moved_constant_692) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_690 + jac_blending_inv_1_1_q_0*tmp_moved_constant_691 + jac_blending_inv_2_1_q_0*tmp_moved_constant_692) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_690 + jac_blending_inv_1_2_q_0*tmp_moved_constant_691 + jac_blending_inv_2_2_q_0*tmp_moved_constant_692))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_690 + jac_blending_inv_1_0_q_0*tmp_moved_constant_691 + jac_blending_inv_2_0_q_0*tmp_moved_constant_692) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_690 + jac_blending_inv_1_1_q_0*tmp_moved_constant_691 + jac_blending_inv_2_1_q_0*tmp_moved_constant_692) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_690 + jac_blending_inv_1_2_q_0*tmp_moved_constant_691 + jac_blending_inv_2_2_q_0*tmp_moved_constant_692))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_693 + jac_blending_inv_1_0_q_1*tmp_moved_constant_694 + jac_blending_inv_2_0_q_1*tmp_moved_constant_695) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_693 + jac_blending_inv_1_1_q_1*tmp_moved_constant_694 + jac_blending_inv_2_1_q_1*tmp_moved_constant_695) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_693 + jac_blending_inv_1_2_q_1*tmp_moved_constant_694 + jac_blending_inv_2_2_q_1*tmp_moved_constant_695))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_693 + jac_blending_inv_1_0_q_1*tmp_moved_constant_694 + jac_blending_inv_2_0_q_1*tmp_moved_constant_695) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_693 + jac_blending_inv_1_1_q_1*tmp_moved_constant_694 + jac_blending_inv_2_1_q_1*tmp_moved_constant_695) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_693 + jac_blending_inv_1_2_q_1*tmp_moved_constant_694 + jac_blending_inv_2_2_q_1*tmp_moved_constant_695))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_696 + jac_blending_inv_1_0_q_2*tmp_moved_constant_697 + jac_blending_inv_2_0_q_2*tmp_moved_constant_698) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_696 + jac_blending_inv_1_1_q_2*tmp_moved_constant_697 + jac_blending_inv_2_1_q_2*tmp_moved_constant_698) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_696 + jac_blending_inv_1_2_q_2*tmp_moved_constant_697 + jac_blending_inv_2_2_q_2*tmp_moved_constant_698))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_696 + jac_blending_inv_1_0_q_2*tmp_moved_constant_697 + jac_blending_inv_2_0_q_2*tmp_moved_constant_698) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_696 + jac_blending_inv_1_1_q_2*tmp_moved_constant_697 + jac_blending_inv_2_1_q_2*tmp_moved_constant_698) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_696 + jac_blending_inv_1_2_q_2*tmp_moved_constant_697 + jac_blending_inv_2_2_q_2*tmp_moved_constant_698)));
             const real_t elMatDiag_9 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_714 + jac_blending_inv_1_0_q_3*tmp_moved_constant_715 + jac_blending_inv_2_0_q_3*tmp_moved_constant_716) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_714 + jac_blending_inv_1_1_q_3*tmp_moved_constant_715 + jac_blending_inv_2_1_q_3*tmp_moved_constant_716) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_714 + jac_blending_inv_1_2_q_3*tmp_moved_constant_715 + jac_blending_inv_2_2_q_3*tmp_moved_constant_716))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_714 + jac_blending_inv_1_0_q_3*tmp_moved_constant_715 + jac_blending_inv_2_0_q_3*tmp_moved_constant_716) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_714 + jac_blending_inv_1_1_q_3*tmp_moved_constant_715 + jac_blending_inv_2_1_q_3*tmp_moved_constant_716) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_714 + jac_blending_inv_1_2_q_3*tmp_moved_constant_715 + jac_blending_inv_2_2_q_3*tmp_moved_constant_716))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_717 + jac_blending_inv_1_0_q_4*tmp_moved_constant_718 + jac_blending_inv_2_0_q_4*tmp_moved_constant_719) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_717 + jac_blending_inv_1_1_q_4*tmp_moved_constant_718 + jac_blending_inv_2_1_q_4*tmp_moved_constant_719) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_717 + jac_blending_inv_1_2_q_4*tmp_moved_constant_718 + jac_blending_inv_2_2_q_4*tmp_moved_constant_719))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_717 + jac_blending_inv_1_0_q_4*tmp_moved_constant_718 + jac_blending_inv_2_0_q_4*tmp_moved_constant_719) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_717 + jac_blending_inv_1_1_q_4*tmp_moved_constant_718 + jac_blending_inv_2_1_q_4*tmp_moved_constant_719) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_717 + jac_blending_inv_1_2_q_4*tmp_moved_constant_718 + jac_blending_inv_2_2_q_4*tmp_moved_constant_719))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_705 + jac_blending_inv_1_0_q_0*tmp_moved_constant_706 + jac_blending_inv_2_0_q_0*tmp_moved_constant_707) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_705 + jac_blending_inv_1_1_q_0*tmp_moved_constant_706 + jac_blending_inv_2_1_q_0*tmp_moved_constant_707) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_705 + jac_blending_inv_1_2_q_0*tmp_moved_constant_706 + jac_blending_inv_2_2_q_0*tmp_moved_constant_707))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_705 + jac_blending_inv_1_0_q_0*tmp_moved_constant_706 + jac_blending_inv_2_0_q_0*tmp_moved_constant_707) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_705 + jac_blending_inv_1_1_q_0*tmp_moved_constant_706 + jac_blending_inv_2_1_q_0*tmp_moved_constant_707) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_705 + jac_blending_inv_1_2_q_0*tmp_moved_constant_706 + jac_blending_inv_2_2_q_0*tmp_moved_constant_707))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_708 + jac_blending_inv_1_0_q_1*tmp_moved_constant_709 + jac_blending_inv_2_0_q_1*tmp_moved_constant_710) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_708 + jac_blending_inv_1_1_q_1*tmp_moved_constant_709 + jac_blending_inv_2_1_q_1*tmp_moved_constant_710) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_708 + jac_blending_inv_1_2_q_1*tmp_moved_constant_709 + jac_blending_inv_2_2_q_1*tmp_moved_constant_710))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_708 + jac_blending_inv_1_0_q_1*tmp_moved_constant_709 + jac_blending_inv_2_0_q_1*tmp_moved_constant_710) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_708 + jac_blending_inv_1_1_q_1*tmp_moved_constant_709 + jac_blending_inv_2_1_q_1*tmp_moved_constant_710) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_708 + jac_blending_inv_1_2_q_1*tmp_moved_constant_709 + jac_blending_inv_2_2_q_1*tmp_moved_constant_710))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_711 + jac_blending_inv_1_0_q_2*tmp_moved_constant_712 + jac_blending_inv_2_0_q_2*tmp_moved_constant_713) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_711 + jac_blending_inv_1_1_q_2*tmp_moved_constant_712 + jac_blending_inv_2_1_q_2*tmp_moved_constant_713) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_711 + jac_blending_inv_1_2_q_2*tmp_moved_constant_712 + jac_blending_inv_2_2_q_2*tmp_moved_constant_713))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_711 + jac_blending_inv_1_0_q_2*tmp_moved_constant_712 + jac_blending_inv_2_0_q_2*tmp_moved_constant_713) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_711 + jac_blending_inv_1_1_q_2*tmp_moved_constant_712 + jac_blending_inv_2_1_q_2*tmp_moved_constant_713) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_711 + jac_blending_inv_1_2_q_2*tmp_moved_constant_712 + jac_blending_inv_2_2_q_2*tmp_moved_constant_713)));
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const real_t tmp_coords_jac_11_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const real_t tmp_coords_jac_9_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const real_t tmp_coords_jac_8_GREEN_UP = jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP;
       const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const real_t tmp_coords_jac_7_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_10_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_12_GREEN_UP = jac_affine_0_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_0_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_0_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
       const real_t tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const real_t jac_affine_inv_0_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
       const real_t jac_affine_inv_0_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_2_1_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const real_t jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const real_t jac_affine_inv_1_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t jac_affine_inv_2_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       const real_t tmp_moved_constant_720 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_4 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_4 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_4;
       const real_t tmp_moved_constant_721 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_4 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_4 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_4;
       const real_t tmp_moved_constant_722 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_4 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_4 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_4;
       const real_t tmp_moved_constant_723 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_33 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_33 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_33;
       const real_t tmp_moved_constant_724 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_33 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_33 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_33;
       const real_t tmp_moved_constant_725 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_33 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_33 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_33;
       const real_t tmp_moved_constant_726 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_62 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_62 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_62;
       const real_t tmp_moved_constant_727 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_62 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_62 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_62;
       const real_t tmp_moved_constant_728 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_62 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_62 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_62;
       const real_t tmp_moved_constant_729 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_91 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_91 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_91;
       const real_t tmp_moved_constant_730 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_91 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_91 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_91;
       const real_t tmp_moved_constant_731 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_91 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_91 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_91;
       const real_t tmp_moved_constant_732 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_120 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_120 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_120;
       const real_t tmp_moved_constant_733 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_120 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_120 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_120;
       const real_t tmp_moved_constant_734 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_120 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_120 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_120;
       const real_t tmp_moved_constant_735 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_145;
       const real_t tmp_moved_constant_736 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_145;
       const real_t tmp_moved_constant_737 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_145;
       const real_t tmp_moved_constant_738 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_149;
       const real_t tmp_moved_constant_739 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_149;
       const real_t tmp_moved_constant_740 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_149;
       const real_t tmp_moved_constant_741 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_153;
       const real_t tmp_moved_constant_742 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_153;
       const real_t tmp_moved_constant_743 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_153;
       const real_t tmp_moved_constant_744 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_157;
       const real_t tmp_moved_constant_745 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_157;
       const real_t tmp_moved_constant_746 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_157;
       const real_t tmp_moved_constant_747 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_161;
       const real_t tmp_moved_constant_748 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_161;
       const real_t tmp_moved_constant_749 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_161;
       const real_t tmp_moved_constant_750 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_165;
       const real_t tmp_moved_constant_751 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_165;
       const real_t tmp_moved_constant_752 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_165;
       const real_t tmp_moved_constant_753 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_169;
       const real_t tmp_moved_constant_754 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_169;
       const real_t tmp_moved_constant_755 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_169;
       const real_t tmp_moved_constant_756 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_173;
       const real_t tmp_moved_constant_757 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_173;
       const real_t tmp_moved_constant_758 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_173;
       const real_t tmp_moved_constant_759 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_177;
       const real_t tmp_moved_constant_760 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_177;
       const real_t tmp_moved_constant_761 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_177;
       const real_t tmp_moved_constant_762 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_181;
       const real_t tmp_moved_constant_763 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_181;
       const real_t tmp_moved_constant_764 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_181;
       const real_t tmp_moved_constant_765 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_185;
       const real_t tmp_moved_constant_766 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_185;
       const real_t tmp_moved_constant_767 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_185;
       const real_t tmp_moved_constant_768 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_189;
       const real_t tmp_moved_constant_769 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_189;
       const real_t tmp_moved_constant_770 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_189;
       const real_t tmp_moved_constant_771 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_193;
       const real_t tmp_moved_constant_772 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_193;
       const real_t tmp_moved_constant_773 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_193;
       const real_t tmp_moved_constant_774 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_197;
       const real_t tmp_moved_constant_775 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_197;
       const real_t tmp_moved_constant_776 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_197;
       const real_t tmp_moved_constant_777 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_201;
       const real_t tmp_moved_constant_778 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_201;
       const real_t tmp_moved_constant_779 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_201;
       const real_t tmp_moved_constant_780 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_781 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_782 = tmp_moved_constant_780 + tmp_moved_constant_781;
       const real_t tmp_moved_constant_783 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_784 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_785 = tmp_moved_constant_783 + tmp_moved_constant_784;
       const real_t tmp_moved_constant_786 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_787 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_788 = tmp_moved_constant_786 + tmp_moved_constant_787;
       const real_t tmp_moved_constant_789 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_790 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_31;
       const real_t tmp_moved_constant_791 = tmp_moved_constant_789 + tmp_moved_constant_790;
       const real_t tmp_moved_constant_792 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_793 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_31;
       const real_t tmp_moved_constant_794 = tmp_moved_constant_792 + tmp_moved_constant_793;
       const real_t tmp_moved_constant_795 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_796 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_31;
       const real_t tmp_moved_constant_797 = tmp_moved_constant_795 + tmp_moved_constant_796;
       const real_t tmp_moved_constant_798 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_58;
       const real_t tmp_moved_constant_799 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_60;
       const real_t tmp_moved_constant_800 = tmp_moved_constant_798 + tmp_moved_constant_799;
       const real_t tmp_moved_constant_801 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_58;
       const real_t tmp_moved_constant_802 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_60;
       const real_t tmp_moved_constant_803 = tmp_moved_constant_801 + tmp_moved_constant_802;
       const real_t tmp_moved_constant_804 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_58;
       const real_t tmp_moved_constant_805 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_60;
       const real_t tmp_moved_constant_806 = tmp_moved_constant_804 + tmp_moved_constant_805;
       const real_t tmp_moved_constant_807 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_87;
       const real_t tmp_moved_constant_808 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_89;
       const real_t tmp_moved_constant_809 = tmp_moved_constant_807 + tmp_moved_constant_808;
       const real_t tmp_moved_constant_810 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_87;
       const real_t tmp_moved_constant_811 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_89;
       const real_t tmp_moved_constant_812 = tmp_moved_constant_810 + tmp_moved_constant_811;
       const real_t tmp_moved_constant_813 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_87;
       const real_t tmp_moved_constant_814 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_89;
       const real_t tmp_moved_constant_815 = tmp_moved_constant_813 + tmp_moved_constant_814;
       const real_t tmp_moved_constant_816 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_116;
       const real_t tmp_moved_constant_817 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_118;
       const real_t tmp_moved_constant_818 = tmp_moved_constant_816 + tmp_moved_constant_817;
       const real_t tmp_moved_constant_819 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_116;
       const real_t tmp_moved_constant_820 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_118;
       const real_t tmp_moved_constant_821 = tmp_moved_constant_819 + tmp_moved_constant_820;
       const real_t tmp_moved_constant_822 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_116;
       const real_t tmp_moved_constant_823 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_118;
       const real_t tmp_moved_constant_824 = tmp_moved_constant_822 + tmp_moved_constant_823;
       const real_t tmp_moved_constant_825 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_826 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_827 = tmp_moved_constant_825 + tmp_moved_constant_826;
       const real_t tmp_moved_constant_828 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_829 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_830 = tmp_moved_constant_828 + tmp_moved_constant_829;
       const real_t tmp_moved_constant_831 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_832 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_833 = tmp_moved_constant_831 + tmp_moved_constant_832;
       const real_t tmp_moved_constant_834 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_835 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_30;
       const real_t tmp_moved_constant_836 = tmp_moved_constant_834 + tmp_moved_constant_835;
       const real_t tmp_moved_constant_837 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_838 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_30;
       const real_t tmp_moved_constant_839 = tmp_moved_constant_837 + tmp_moved_constant_838;
       const real_t tmp_moved_constant_840 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_841 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_30;
       const real_t tmp_moved_constant_842 = tmp_moved_constant_840 + tmp_moved_constant_841;
       const real_t tmp_moved_constant_843 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_58;
       const real_t tmp_moved_constant_844 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_59;
       const real_t tmp_moved_constant_845 = tmp_moved_constant_843 + tmp_moved_constant_844;
       const real_t tmp_moved_constant_846 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_58;
       const real_t tmp_moved_constant_847 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_59;
       const real_t tmp_moved_constant_848 = tmp_moved_constant_846 + tmp_moved_constant_847;
       const real_t tmp_moved_constant_849 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_58;
       const real_t tmp_moved_constant_850 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_59;
       const real_t tmp_moved_constant_851 = tmp_moved_constant_849 + tmp_moved_constant_850;
       const real_t tmp_moved_constant_852 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_87;
       const real_t tmp_moved_constant_853 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_88;
       const real_t tmp_moved_constant_854 = tmp_moved_constant_852 + tmp_moved_constant_853;
       const real_t tmp_moved_constant_855 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_87;
       const real_t tmp_moved_constant_856 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_88;
       const real_t tmp_moved_constant_857 = tmp_moved_constant_855 + tmp_moved_constant_856;
       const real_t tmp_moved_constant_858 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_87;
       const real_t tmp_moved_constant_859 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_88;
       const real_t tmp_moved_constant_860 = tmp_moved_constant_858 + tmp_moved_constant_859;
       const real_t tmp_moved_constant_861 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_116;
       const real_t tmp_moved_constant_862 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_117;
       const real_t tmp_moved_constant_863 = tmp_moved_constant_861 + tmp_moved_constant_862;
       const real_t tmp_moved_constant_864 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_116;
       const real_t tmp_moved_constant_865 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_117;
       const real_t tmp_moved_constant_866 = tmp_moved_constant_864 + tmp_moved_constant_865;
       const real_t tmp_moved_constant_867 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_116;
       const real_t tmp_moved_constant_868 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_117;
       const real_t tmp_moved_constant_869 = tmp_moved_constant_867 + tmp_moved_constant_868;
       const real_t tmp_moved_constant_870 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_871 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_872 = tmp_moved_constant_870 + tmp_moved_constant_871;
       const real_t tmp_moved_constant_873 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_874 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_875 = tmp_moved_constant_873 + tmp_moved_constant_874;
       const real_t tmp_moved_constant_876 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_877 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_878 = tmp_moved_constant_876 + tmp_moved_constant_877;
       const real_t tmp_moved_constant_879 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_31;
       const real_t tmp_moved_constant_880 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_30;
       const real_t tmp_moved_constant_881 = tmp_moved_constant_879 + tmp_moved_constant_880;
       const real_t tmp_moved_constant_882 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_31;
       const real_t tmp_moved_constant_883 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_30;
       const real_t tmp_moved_constant_884 = tmp_moved_constant_882 + tmp_moved_constant_883;
       const real_t tmp_moved_constant_885 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_31;
       const real_t tmp_moved_constant_886 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_30;
       const real_t tmp_moved_constant_887 = tmp_moved_constant_885 + tmp_moved_constant_886;
       const real_t tmp_moved_constant_888 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_60;
       const real_t tmp_moved_constant_889 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_59;
       const real_t tmp_moved_constant_890 = tmp_moved_constant_888 + tmp_moved_constant_889;
       const real_t tmp_moved_constant_891 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_60;
       const real_t tmp_moved_constant_892 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_59;
       const real_t tmp_moved_constant_893 = tmp_moved_constant_891 + tmp_moved_constant_892;
       const real_t tmp_moved_constant_894 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_60;
       const real_t tmp_moved_constant_895 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_59;
       const real_t tmp_moved_constant_896 = tmp_moved_constant_894 + tmp_moved_constant_895;
       const real_t tmp_moved_constant_897 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_89;
       const real_t tmp_moved_constant_898 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_88;
       const real_t tmp_moved_constant_899 = tmp_moved_constant_897 + tmp_moved_constant_898;
       const real_t tmp_moved_constant_900 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_89;
       const real_t tmp_moved_constant_901 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_88;
       const real_t tmp_moved_constant_902 = tmp_moved_constant_900 + tmp_moved_constant_901;
       const real_t tmp_moved_constant_903 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_89;
       const real_t tmp_moved_constant_904 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_88;
       const real_t tmp_moved_constant_905 = tmp_moved_constant_903 + tmp_moved_constant_904;
       const real_t tmp_moved_constant_906 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_118;
       const real_t tmp_moved_constant_907 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_117;
       const real_t tmp_moved_constant_908 = tmp_moved_constant_906 + tmp_moved_constant_907;
       const real_t tmp_moved_constant_909 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_118;
       const real_t tmp_moved_constant_910 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_117;
       const real_t tmp_moved_constant_911 = tmp_moved_constant_909 + tmp_moved_constant_910;
       const real_t tmp_moved_constant_912 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_118;
       const real_t tmp_moved_constant_913 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_117;
       const real_t tmp_moved_constant_914 = tmp_moved_constant_912 + tmp_moved_constant_913;
       const real_t tmp_moved_constant_915 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_340 - tmp_moved_constant_780 - tmp_moved_constant_825;
       const real_t tmp_moved_constant_916 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_340 - tmp_moved_constant_783 - tmp_moved_constant_828;
       const real_t tmp_moved_constant_917 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_340 - tmp_moved_constant_786 - tmp_moved_constant_831;
       const real_t tmp_moved_constant_918 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_344 - tmp_moved_constant_789 - tmp_moved_constant_834;
       const real_t tmp_moved_constant_919 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_344 - tmp_moved_constant_792 - tmp_moved_constant_837;
       const real_t tmp_moved_constant_920 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_344 - tmp_moved_constant_795 - tmp_moved_constant_840;
       const real_t tmp_moved_constant_921 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_348 - tmp_moved_constant_798 - tmp_moved_constant_843;
       const real_t tmp_moved_constant_922 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_348 - tmp_moved_constant_801 - tmp_moved_constant_846;
       const real_t tmp_moved_constant_923 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_348 - tmp_moved_constant_804 - tmp_moved_constant_849;
       const real_t tmp_moved_constant_924 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_352 - tmp_moved_constant_807 - tmp_moved_constant_852;
       const real_t tmp_moved_constant_925 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_352 - tmp_moved_constant_810 - tmp_moved_constant_855;
       const real_t tmp_moved_constant_926 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_352 - tmp_moved_constant_813 - tmp_moved_constant_858;
       const real_t tmp_moved_constant_927 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_356 - tmp_moved_constant_816 - tmp_moved_constant_861;
       const real_t tmp_moved_constant_928 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_356 - tmp_moved_constant_819 - tmp_moved_constant_864;
       const real_t tmp_moved_constant_929 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_356 - tmp_moved_constant_822 - tmp_moved_constant_867;
       const real_t tmp_moved_constant_930 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_361 - tmp_moved_constant_781 - tmp_moved_constant_870;
       const real_t tmp_moved_constant_931 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_361 - tmp_moved_constant_784 - tmp_moved_constant_873;
       const real_t tmp_moved_constant_932 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_361 - tmp_moved_constant_787 - tmp_moved_constant_876;
       const real_t tmp_moved_constant_933 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_366 - tmp_moved_constant_790 - tmp_moved_constant_879;
       const real_t tmp_moved_constant_934 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_366 - tmp_moved_constant_793 - tmp_moved_constant_882;
       const real_t tmp_moved_constant_935 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_366 - tmp_moved_constant_796 - tmp_moved_constant_885;
       const real_t tmp_moved_constant_936 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_371 - tmp_moved_constant_799 - tmp_moved_constant_888;
       const real_t tmp_moved_constant_937 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_371 - tmp_moved_constant_802 - tmp_moved_constant_891;
       const real_t tmp_moved_constant_938 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_371 - tmp_moved_constant_805 - tmp_moved_constant_894;
       const real_t tmp_moved_constant_939 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_376 - tmp_moved_constant_808 - tmp_moved_constant_897;
       const real_t tmp_moved_constant_940 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_376 - tmp_moved_constant_811 - tmp_moved_constant_900;
       const real_t tmp_moved_constant_941 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_376 - tmp_moved_constant_814 - tmp_moved_constant_903;
       const real_t tmp_moved_constant_942 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_381 - tmp_moved_constant_817 - tmp_moved_constant_906;
       const real_t tmp_moved_constant_943 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_381 - tmp_moved_constant_820 - tmp_moved_constant_909;
       const real_t tmp_moved_constant_944 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_381 - tmp_moved_constant_823 - tmp_moved_constant_912;
       const real_t tmp_moved_constant_945 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_385 - tmp_moved_constant_826 - tmp_moved_constant_871;
       const real_t tmp_moved_constant_946 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_385 - tmp_moved_constant_829 - tmp_moved_constant_874;
       const real_t tmp_moved_constant_947 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_385 - tmp_moved_constant_832 - tmp_moved_constant_877;
       const real_t tmp_moved_constant_948 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_389 - tmp_moved_constant_835 - tmp_moved_constant_880;
       const real_t tmp_moved_constant_949 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_389 - tmp_moved_constant_838 - tmp_moved_constant_883;
       const real_t tmp_moved_constant_950 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_389 - tmp_moved_constant_841 - tmp_moved_constant_886;
       const real_t tmp_moved_constant_951 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_393 - tmp_moved_constant_844 - tmp_moved_constant_889;
       const real_t tmp_moved_constant_952 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_393 - tmp_moved_constant_847 - tmp_moved_constant_892;
       const real_t tmp_moved_constant_953 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_393 - tmp_moved_constant_850 - tmp_moved_constant_895;
       const real_t tmp_moved_constant_954 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_397 - tmp_moved_constant_853 - tmp_moved_constant_898;
       const real_t tmp_moved_constant_955 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_397 - tmp_moved_constant_856 - tmp_moved_constant_901;
       const real_t tmp_moved_constant_956 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_397 - tmp_moved_constant_859 - tmp_moved_constant_904;
       const real_t tmp_moved_constant_957 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_401 - tmp_moved_constant_862 - tmp_moved_constant_907;
       const real_t tmp_moved_constant_958 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_401 - tmp_moved_constant_865 - tmp_moved_constant_910;
       const real_t tmp_moved_constant_959 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_401 - tmp_moved_constant_868 - tmp_moved_constant_913;
       {
          /* CellType.GREEN_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
             const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
             const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
             const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
             const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
             const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
             const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
             const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
             const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
             const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
             const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
             const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
             const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
             const real_t tmp_blending_op_35 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_36 = -tmp_blending_op_35;
             const real_t tmp_blending_op_37 = (tmp_blending_op_28*tmp_blending_op_28);
             const real_t tmp_blending_op_38 = (tmp_blending_op_33*tmp_blending_op_33);
             const real_t tmp_blending_op_39 = tmp_blending_op_37 + tmp_blending_op_38 + tmp_blending_op_4;
             const real_t tmp_blending_op_42 = pow(tmp_blending_op_39, -1.5000000000000000)*tmp_blending_op_41;
             const real_t tmp_blending_op_44 = tmp_blending_op_23*tmp_blending_op_39;
             const real_t tmp_blending_op_45 = -tmp_blending_op_33*tmp_blending_op_35 - tmp_blending_op_43*tmp_blending_op_44;
             const real_t tmp_blending_op_46 = tmp_blending_op_3*tmp_blending_op_42;
             const real_t tmp_blending_op_48 = tmp_blending_op_28*tmp_blending_op_36 + tmp_blending_op_44*tmp_blending_op_47;
             const real_t tmp_blending_op_49 = tmp_blending_op_3*tmp_blending_op_36 + tmp_blending_op_39*tmp_blending_op_40;
             const real_t tmp_blending_op_50 = tmp_blending_op_33*tmp_blending_op_42;
             const real_t tmp_blending_op_52 = tmp_blending_op_28*tmp_blending_op_42;
             const real_t tmp_blending_op_61 = p_affine_0_2 + tmp_blending_op_0*0.5 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_62 = (tmp_blending_op_61*tmp_blending_op_61);
             const real_t tmp_blending_op_63 = -tmp_blending_op_17 - tmp_blending_op_61;
             const real_t tmp_blending_op_64 = p_affine_0_0 + tmp_blending_op_25*0.5 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_65 = -tmp_blending_op_6 - tmp_blending_op_64;
             const real_t tmp_blending_op_66 = p_affine_0_1 + tmp_blending_op_30*0.5 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_67 = -tmp_blending_op_13 - tmp_blending_op_66;
             const real_t tmp_blending_op_68 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_65 - tmp_blending_op_12*tmp_blending_op_63 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_63 - tmp_blending_op_19*tmp_blending_op_65 - tmp_blending_op_20*tmp_blending_op_67 + tmp_blending_op_67*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_69 = -tmp_blending_op_68;
             const real_t tmp_blending_op_70 = (tmp_blending_op_64*tmp_blending_op_64);
             const real_t tmp_blending_op_71 = (tmp_blending_op_66*tmp_blending_op_66);
             const real_t tmp_blending_op_72 = tmp_blending_op_62 + tmp_blending_op_70 + tmp_blending_op_71;
             const real_t tmp_blending_op_73 = tmp_blending_op_41*pow(tmp_blending_op_72, -1.5000000000000000);
             const real_t tmp_blending_op_75 = -tmp_blending_op_66*tmp_blending_op_68 - tmp_blending_op_72*tmp_blending_op_74;
             const real_t tmp_blending_op_76 = tmp_blending_op_61*tmp_blending_op_73;
             const real_t tmp_blending_op_77 = tmp_blending_op_53*tmp_blending_op_72 + tmp_blending_op_64*tmp_blending_op_69;
             const real_t tmp_blending_op_78 = tmp_blending_op_40*tmp_blending_op_72 + tmp_blending_op_61*tmp_blending_op_69;
             const real_t tmp_blending_op_79 = tmp_blending_op_66*tmp_blending_op_73;
             const real_t tmp_blending_op_80 = tmp_blending_op_64*tmp_blending_op_73;
             const real_t tmp_blending_op_88 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.5 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_89 = (tmp_blending_op_88*tmp_blending_op_88);
             const real_t tmp_blending_op_90 = -tmp_blending_op_17 - tmp_blending_op_88;
             const real_t tmp_blending_op_91 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.5 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_92 = -tmp_blending_op_6 - tmp_blending_op_91;
             const real_t tmp_blending_op_93 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.5 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_94 = -tmp_blending_op_13 - tmp_blending_op_93;
             const real_t tmp_blending_op_95 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_92 - tmp_blending_op_12*tmp_blending_op_90 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_90 - tmp_blending_op_19*tmp_blending_op_92 - tmp_blending_op_20*tmp_blending_op_94 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_94);
             const real_t tmp_blending_op_96 = -tmp_blending_op_95;
             const real_t tmp_blending_op_97 = (tmp_blending_op_91*tmp_blending_op_91);
             const real_t tmp_blending_op_98 = (tmp_blending_op_93*tmp_blending_op_93);
             const real_t tmp_blending_op_99 = tmp_blending_op_89 + tmp_blending_op_97 + tmp_blending_op_98;
             const real_t tmp_blending_op_100 = tmp_blending_op_41*pow(tmp_blending_op_99, -1.5000000000000000);
             const real_t tmp_blending_op_101 = -tmp_blending_op_74*tmp_blending_op_99 - tmp_blending_op_93*tmp_blending_op_95;
             const real_t tmp_blending_op_102 = tmp_blending_op_100*tmp_blending_op_88;
             const real_t tmp_blending_op_103 = tmp_blending_op_53*tmp_blending_op_99 + tmp_blending_op_91*tmp_blending_op_96;
             const real_t tmp_blending_op_104 = tmp_blending_op_40*tmp_blending_op_99 + tmp_blending_op_88*tmp_blending_op_96;
             const real_t tmp_blending_op_105 = tmp_blending_op_100*tmp_blending_op_93;
             const real_t tmp_blending_op_106 = tmp_blending_op_100*tmp_blending_op_91;
             const real_t tmp_blending_op_114 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.5;
             const real_t tmp_blending_op_115 = (tmp_blending_op_114*tmp_blending_op_114);
             const real_t tmp_blending_op_116 = -tmp_blending_op_114 - tmp_blending_op_17;
             const real_t tmp_blending_op_117 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.5;
             const real_t tmp_blending_op_118 = -tmp_blending_op_117 - tmp_blending_op_6;
             const real_t tmp_blending_op_119 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.5;
             const real_t tmp_blending_op_120 = -tmp_blending_op_119 - tmp_blending_op_13;
             const real_t tmp_blending_op_121 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_118*tmp_blending_op_18 - tmp_blending_op_116*tmp_blending_op_12 + tmp_blending_op_116*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_118*tmp_blending_op_19 - tmp_blending_op_120*tmp_blending_op_20 + tmp_blending_op_120*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_122 = -tmp_blending_op_121;
             const real_t tmp_blending_op_123 = (tmp_blending_op_117*tmp_blending_op_117);
             const real_t tmp_blending_op_124 = (tmp_blending_op_119*tmp_blending_op_119);
             const real_t tmp_blending_op_125 = tmp_blending_op_115 + tmp_blending_op_123 + tmp_blending_op_124;
             const real_t tmp_blending_op_126 = pow(tmp_blending_op_125, -1.5000000000000000)*tmp_blending_op_41;
             const real_t tmp_blending_op_127 = -tmp_blending_op_119*tmp_blending_op_121 - tmp_blending_op_125*tmp_blending_op_74;
             const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_126;
             const real_t tmp_blending_op_129 = tmp_blending_op_117*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_53;
             const real_t tmp_blending_op_130 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_40;
             const real_t tmp_blending_op_131 = tmp_blending_op_119*tmp_blending_op_126;
             const real_t tmp_blending_op_132 = tmp_blending_op_117*tmp_blending_op_126;
             const real_t tmp_blending_op_140 = p_affine_0_2 + tmp_blending_op_0*0.25 + tmp_blending_op_1*0.25 + tmp_blending_op_2*0.25;
             const real_t tmp_blending_op_141 = (tmp_blending_op_140*tmp_blending_op_140);
             const real_t tmp_blending_op_142 = -tmp_blending_op_140 - tmp_blending_op_17;
             const real_t tmp_blending_op_143 = p_affine_0_0 + tmp_blending_op_25*0.25 + tmp_blending_op_26*0.25 + tmp_blending_op_27*0.25;
             const real_t tmp_blending_op_144 = -tmp_blending_op_143 - tmp_blending_op_6;
             const real_t tmp_blending_op_145 = p_affine_0_1 + tmp_blending_op_30*0.25 + tmp_blending_op_31*0.25 + tmp_blending_op_32*0.25;
             const real_t tmp_blending_op_146 = -tmp_blending_op_13 - tmp_blending_op_145;
             const real_t tmp_blending_op_147 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_144*tmp_blending_op_18 - tmp_blending_op_12*tmp_blending_op_142 + tmp_blending_op_14*tmp_blending_op_142*tmp_blending_op_15 - tmp_blending_op_144*tmp_blending_op_19 - tmp_blending_op_146*tmp_blending_op_20 + tmp_blending_op_146*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_148 = -tmp_blending_op_147;
             const real_t tmp_blending_op_149 = (tmp_blending_op_143*tmp_blending_op_143);
             const real_t tmp_blending_op_150 = (tmp_blending_op_145*tmp_blending_op_145);
             const real_t tmp_blending_op_151 = tmp_blending_op_141 + tmp_blending_op_149 + tmp_blending_op_150;
             const real_t tmp_blending_op_152 = pow(tmp_blending_op_151, -1.5000000000000000)*tmp_blending_op_41;
             const real_t tmp_blending_op_153 = -tmp_blending_op_145*tmp_blending_op_147 - tmp_blending_op_151*tmp_blending_op_74;
             const real_t tmp_blending_op_154 = tmp_blending_op_140*tmp_blending_op_152;
             const real_t tmp_blending_op_155 = tmp_blending_op_143*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_53;
             const real_t tmp_blending_op_156 = tmp_blending_op_140*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_40;
             const real_t tmp_blending_op_157 = tmp_blending_op_145*tmp_blending_op_152;
             const real_t tmp_blending_op_158 = tmp_blending_op_143*tmp_blending_op_152;
             const real_t jac_blending_2_2_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_4 + tmp_blending_op_39*(tmp_blending_op_3*tmp_blending_op_40 + tmp_blending_op_35));
             const real_t jac_blending_2_1_q_4 = tmp_blending_op_45*tmp_blending_op_46;
             const real_t jac_blending_2_0_q_4 = tmp_blending_op_46*tmp_blending_op_48;
             const real_t jac_blending_1_2_q_4 = tmp_blending_op_49*tmp_blending_op_50;
             const real_t jac_blending_1_1_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_39*(tmp_blending_op_33*tmp_blending_op_51 + tmp_blending_op_35));
             const real_t tmp_blending_op_58 = jac_blending_1_1_q_4*jac_blending_2_0_q_4;
             const real_t jac_blending_1_0_q_4 = tmp_blending_op_48*tmp_blending_op_50;
             const real_t tmp_blending_op_55 = jac_blending_1_0_q_4*jac_blending_2_1_q_4;
             const real_t jac_blending_0_2_q_4 = tmp_blending_op_49*tmp_blending_op_52;
             const real_t jac_blending_0_1_q_4 = tmp_blending_op_45*tmp_blending_op_52;
             const real_t tmp_blending_op_57 = jac_blending_0_1_q_4*jac_blending_1_0_q_4;
             const real_t jac_blending_0_0_q_4 = tmp_blending_op_42*(-tmp_blending_op_35*tmp_blending_op_37 + tmp_blending_op_39*(tmp_blending_op_28*tmp_blending_op_53 + tmp_blending_op_35));
             const real_t tmp_blending_op_54 = jac_blending_0_0_q_4*jac_blending_1_1_q_4;
             const real_t tmp_blending_op_56 = jac_blending_0_0_q_4*jac_blending_2_1_q_4;
             const real_t tmp_blending_op_59 = jac_blending_0_1_q_4*jac_blending_1_2_q_4*jac_blending_2_0_q_4 + jac_blending_0_2_q_4*tmp_blending_op_55 - jac_blending_0_2_q_4*tmp_blending_op_58 - jac_blending_1_2_q_4*tmp_blending_op_56 + jac_blending_2_2_q_4*tmp_blending_op_54 - jac_blending_2_2_q_4*tmp_blending_op_57;
             const real_t tmp_blending_op_60 = 1.0 / (tmp_blending_op_59);
             const real_t abs_det_jac_blending_q_4 = tmp_blending_op_59;
             const real_t jac_blending_inv_2_2_q_4 = tmp_blending_op_60*(tmp_blending_op_54 - tmp_blending_op_57);
             const real_t jac_blending_inv_2_1_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_2_0_q_4 - tmp_blending_op_56);
             const real_t jac_blending_inv_2_0_q_4 = tmp_blending_op_60*(tmp_blending_op_55 - tmp_blending_op_58);
             const real_t jac_blending_inv_1_2_q_4 = tmp_blending_op_60*(-jac_blending_0_0_q_4*jac_blending_1_2_q_4 + jac_blending_0_2_q_4*jac_blending_1_0_q_4);
             const real_t jac_blending_inv_1_1_q_4 = tmp_blending_op_60*(jac_blending_0_0_q_4*jac_blending_2_2_q_4 - jac_blending_0_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_1_0_q_4 = tmp_blending_op_60*(-jac_blending_1_0_q_4*jac_blending_2_2_q_4 + jac_blending_1_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_0_2_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_1_2_q_4 - jac_blending_0_2_q_4*jac_blending_1_1_q_4);
             const real_t jac_blending_inv_0_1_q_4 = tmp_blending_op_60*(-jac_blending_0_1_q_4*jac_blending_2_2_q_4 + jac_blending_0_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_inv_0_0_q_4 = tmp_blending_op_60*(jac_blending_1_1_q_4*jac_blending_2_2_q_4 - jac_blending_1_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_2_2_q_3 = tmp_blending_op_73*(tmp_blending_op_62*tmp_blending_op_69 + tmp_blending_op_72*(tmp_blending_op_40*tmp_blending_op_61 + tmp_blending_op_68));
             const real_t jac_blending_2_1_q_3 = tmp_blending_op_75*tmp_blending_op_76;
             const real_t jac_blending_2_0_q_3 = tmp_blending_op_76*tmp_blending_op_77;
             const real_t jac_blending_1_2_q_3 = tmp_blending_op_78*tmp_blending_op_79;
             const real_t jac_blending_1_1_q_3 = tmp_blending_op_73*(tmp_blending_op_69*tmp_blending_op_71 + tmp_blending_op_72*(tmp_blending_op_51*tmp_blending_op_66 + tmp_blending_op_68));
             const real_t tmp_blending_op_85 = jac_blending_1_1_q_3*jac_blending_2_0_q_3;
             const real_t jac_blending_1_0_q_3 = tmp_blending_op_77*tmp_blending_op_79;
             const real_t tmp_blending_op_82 = jac_blending_1_0_q_3*jac_blending_2_1_q_3;
             const real_t jac_blending_0_2_q_3 = tmp_blending_op_78*tmp_blending_op_80;
             const real_t jac_blending_0_1_q_3 = tmp_blending_op_75*tmp_blending_op_80;
             const real_t tmp_blending_op_84 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
             const real_t jac_blending_0_0_q_3 = tmp_blending_op_73*(-tmp_blending_op_68*tmp_blending_op_70 + tmp_blending_op_72*(tmp_blending_op_53*tmp_blending_op_64 + tmp_blending_op_68));
             const real_t tmp_blending_op_81 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
             const real_t tmp_blending_op_83 = jac_blending_0_0_q_3*jac_blending_2_1_q_3;
             const real_t tmp_blending_op_86 = jac_blending_0_1_q_3*jac_blending_1_2_q_3*jac_blending_2_0_q_3 + jac_blending_0_2_q_3*tmp_blending_op_82 - jac_blending_0_2_q_3*tmp_blending_op_85 - jac_blending_1_2_q_3*tmp_blending_op_83 + jac_blending_2_2_q_3*tmp_blending_op_81 - jac_blending_2_2_q_3*tmp_blending_op_84;
             const real_t tmp_blending_op_87 = 1.0 / (tmp_blending_op_86);
             const real_t abs_det_jac_blending_q_3 = tmp_blending_op_86;
             const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_87*(tmp_blending_op_81 - tmp_blending_op_84);
             const real_t jac_blending_inv_2_1_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_2_0_q_3 - tmp_blending_op_83);
             const real_t jac_blending_inv_2_0_q_3 = tmp_blending_op_87*(tmp_blending_op_82 - tmp_blending_op_85);
             const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_87*(-jac_blending_0_0_q_3*jac_blending_1_2_q_3 + jac_blending_0_2_q_3*jac_blending_1_0_q_3);
             const real_t jac_blending_inv_1_1_q_3 = tmp_blending_op_87*(jac_blending_0_0_q_3*jac_blending_2_2_q_3 - jac_blending_0_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_1_0_q_3 = tmp_blending_op_87*(-jac_blending_1_0_q_3*jac_blending_2_2_q_3 + jac_blending_1_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_1_2_q_3 - jac_blending_0_2_q_3*jac_blending_1_1_q_3);
             const real_t jac_blending_inv_0_1_q_3 = tmp_blending_op_87*(-jac_blending_0_1_q_3*jac_blending_2_2_q_3 + jac_blending_0_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_inv_0_0_q_3 = tmp_blending_op_87*(jac_blending_1_1_q_3*jac_blending_2_2_q_3 - jac_blending_1_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_2_2_q_2 = tmp_blending_op_100*(tmp_blending_op_89*tmp_blending_op_96 + tmp_blending_op_99*(tmp_blending_op_40*tmp_blending_op_88 + tmp_blending_op_95));
             const real_t jac_blending_2_1_q_2 = tmp_blending_op_101*tmp_blending_op_102;
             const real_t jac_blending_2_0_q_2 = tmp_blending_op_102*tmp_blending_op_103;
             const real_t jac_blending_1_2_q_2 = tmp_blending_op_104*tmp_blending_op_105;
             const real_t jac_blending_1_1_q_2 = tmp_blending_op_100*(tmp_blending_op_96*tmp_blending_op_98 + tmp_blending_op_99*(tmp_blending_op_51*tmp_blending_op_93 + tmp_blending_op_95));
             const real_t tmp_blending_op_111 = jac_blending_1_1_q_2*jac_blending_2_0_q_2;
             const real_t jac_blending_1_0_q_2 = tmp_blending_op_103*tmp_blending_op_105;
             const real_t tmp_blending_op_108 = jac_blending_1_0_q_2*jac_blending_2_1_q_2;
             const real_t jac_blending_0_2_q_2 = tmp_blending_op_104*tmp_blending_op_106;
             const real_t jac_blending_0_1_q_2 = tmp_blending_op_101*tmp_blending_op_106;
             const real_t tmp_blending_op_110 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
             const real_t jac_blending_0_0_q_2 = tmp_blending_op_100*(-tmp_blending_op_95*tmp_blending_op_97 + tmp_blending_op_99*(tmp_blending_op_53*tmp_blending_op_91 + tmp_blending_op_95));
             const real_t tmp_blending_op_107 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
             const real_t tmp_blending_op_109 = jac_blending_0_0_q_2*jac_blending_2_1_q_2;
             const real_t tmp_blending_op_112 = jac_blending_0_1_q_2*jac_blending_1_2_q_2*jac_blending_2_0_q_2 + jac_blending_0_2_q_2*tmp_blending_op_108 - jac_blending_0_2_q_2*tmp_blending_op_111 - jac_blending_1_2_q_2*tmp_blending_op_109 + jac_blending_2_2_q_2*tmp_blending_op_107 - jac_blending_2_2_q_2*tmp_blending_op_110;
             const real_t tmp_blending_op_113 = 1.0 / (tmp_blending_op_112);
             const real_t abs_det_jac_blending_q_2 = tmp_blending_op_112;
             const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_113*(tmp_blending_op_107 - tmp_blending_op_110);
             const real_t jac_blending_inv_2_1_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_2_0_q_2 - tmp_blending_op_109);
             const real_t jac_blending_inv_2_0_q_2 = tmp_blending_op_113*(tmp_blending_op_108 - tmp_blending_op_111);
             const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_113*(-jac_blending_0_0_q_2*jac_blending_1_2_q_2 + jac_blending_0_2_q_2*jac_blending_1_0_q_2);
             const real_t jac_blending_inv_1_1_q_2 = tmp_blending_op_113*(jac_blending_0_0_q_2*jac_blending_2_2_q_2 - jac_blending_0_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_1_0_q_2 = tmp_blending_op_113*(-jac_blending_1_0_q_2*jac_blending_2_2_q_2 + jac_blending_1_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_1_2_q_2 - jac_blending_0_2_q_2*jac_blending_1_1_q_2);
             const real_t jac_blending_inv_0_1_q_2 = tmp_blending_op_113*(-jac_blending_0_1_q_2*jac_blending_2_2_q_2 + jac_blending_0_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_inv_0_0_q_2 = tmp_blending_op_113*(jac_blending_1_1_q_2*jac_blending_2_2_q_2 - jac_blending_1_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_2_2_q_1 = tmp_blending_op_126*(tmp_blending_op_115*tmp_blending_op_122 + tmp_blending_op_125*(tmp_blending_op_114*tmp_blending_op_40 + tmp_blending_op_121));
             const real_t jac_blending_2_1_q_1 = tmp_blending_op_127*tmp_blending_op_128;
             const real_t jac_blending_2_0_q_1 = tmp_blending_op_128*tmp_blending_op_129;
             const real_t jac_blending_1_2_q_1 = tmp_blending_op_130*tmp_blending_op_131;
             const real_t jac_blending_1_1_q_1 = tmp_blending_op_126*(tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*(tmp_blending_op_119*tmp_blending_op_51 + tmp_blending_op_121));
             const real_t tmp_blending_op_137 = jac_blending_1_1_q_1*jac_blending_2_0_q_1;
             const real_t jac_blending_1_0_q_1 = tmp_blending_op_129*tmp_blending_op_131;
             const real_t tmp_blending_op_134 = jac_blending_1_0_q_1*jac_blending_2_1_q_1;
             const real_t jac_blending_0_2_q_1 = tmp_blending_op_130*tmp_blending_op_132;
             const real_t jac_blending_0_1_q_1 = tmp_blending_op_127*tmp_blending_op_132;
             const real_t tmp_blending_op_136 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
             const real_t jac_blending_0_0_q_1 = tmp_blending_op_126*(-tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*(tmp_blending_op_117*tmp_blending_op_53 + tmp_blending_op_121));
             const real_t tmp_blending_op_133 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
             const real_t tmp_blending_op_135 = jac_blending_0_0_q_1*jac_blending_2_1_q_1;
             const real_t tmp_blending_op_138 = jac_blending_0_1_q_1*jac_blending_1_2_q_1*jac_blending_2_0_q_1 + jac_blending_0_2_q_1*tmp_blending_op_134 - jac_blending_0_2_q_1*tmp_blending_op_137 - jac_blending_1_2_q_1*tmp_blending_op_135 + jac_blending_2_2_q_1*tmp_blending_op_133 - jac_blending_2_2_q_1*tmp_blending_op_136;
             const real_t tmp_blending_op_139 = 1.0 / (tmp_blending_op_138);
             const real_t abs_det_jac_blending_q_1 = tmp_blending_op_138;
             const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_139*(tmp_blending_op_133 - tmp_blending_op_136);
             const real_t jac_blending_inv_2_1_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_2_0_q_1 - tmp_blending_op_135);
             const real_t jac_blending_inv_2_0_q_1 = tmp_blending_op_139*(tmp_blending_op_134 - tmp_blending_op_137);
             const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_139*(-jac_blending_0_0_q_1*jac_blending_1_2_q_1 + jac_blending_0_2_q_1*jac_blending_1_0_q_1);
             const real_t jac_blending_inv_1_1_q_1 = tmp_blending_op_139*(jac_blending_0_0_q_1*jac_blending_2_2_q_1 - jac_blending_0_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_1_0_q_1 = tmp_blending_op_139*(-jac_blending_1_0_q_1*jac_blending_2_2_q_1 + jac_blending_1_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_1_2_q_1 - jac_blending_0_2_q_1*jac_blending_1_1_q_1);
             const real_t jac_blending_inv_0_1_q_1 = tmp_blending_op_139*(-jac_blending_0_1_q_1*jac_blending_2_2_q_1 + jac_blending_0_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_inv_0_0_q_1 = tmp_blending_op_139*(jac_blending_1_1_q_1*jac_blending_2_2_q_1 - jac_blending_1_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_2_2_q_0 = tmp_blending_op_152*(tmp_blending_op_141*tmp_blending_op_148 + tmp_blending_op_151*(tmp_blending_op_140*tmp_blending_op_40 + tmp_blending_op_147));
             const real_t jac_blending_2_1_q_0 = tmp_blending_op_153*tmp_blending_op_154;
             const real_t jac_blending_2_0_q_0 = tmp_blending_op_154*tmp_blending_op_155;
             const real_t jac_blending_1_2_q_0 = tmp_blending_op_156*tmp_blending_op_157;
             const real_t jac_blending_1_1_q_0 = tmp_blending_op_152*(tmp_blending_op_148*tmp_blending_op_150 + tmp_blending_op_151*(tmp_blending_op_145*tmp_blending_op_51 + tmp_blending_op_147));
             const real_t tmp_blending_op_163 = jac_blending_1_1_q_0*jac_blending_2_0_q_0;
             const real_t jac_blending_1_0_q_0 = tmp_blending_op_155*tmp_blending_op_157;
             const real_t tmp_blending_op_160 = jac_blending_1_0_q_0*jac_blending_2_1_q_0;
             const real_t jac_blending_0_2_q_0 = tmp_blending_op_156*tmp_blending_op_158;
             const real_t jac_blending_0_1_q_0 = tmp_blending_op_153*tmp_blending_op_158;
             const real_t tmp_blending_op_162 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
             const real_t jac_blending_0_0_q_0 = tmp_blending_op_152*(-tmp_blending_op_147*tmp_blending_op_149 + tmp_blending_op_151*(tmp_blending_op_143*tmp_blending_op_53 + tmp_blending_op_147));
             const real_t tmp_blending_op_159 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
             const real_t tmp_blending_op_161 = jac_blending_0_0_q_0*jac_blending_2_1_q_0;
             const real_t tmp_blending_op_164 = jac_blending_0_1_q_0*jac_blending_1_2_q_0*jac_blending_2_0_q_0 + jac_blending_0_2_q_0*tmp_blending_op_160 - jac_blending_0_2_q_0*tmp_blending_op_163 - jac_blending_1_2_q_0*tmp_blending_op_161 + jac_blending_2_2_q_0*tmp_blending_op_159 - jac_blending_2_2_q_0*tmp_blending_op_162;
             const real_t tmp_blending_op_165 = 1.0 / (tmp_blending_op_164);
             const real_t abs_det_jac_blending_q_0 = tmp_blending_op_164;
             const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_165*(tmp_blending_op_159 - tmp_blending_op_162);
             const real_t jac_blending_inv_2_1_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_2_0_q_0 - tmp_blending_op_161);
             const real_t jac_blending_inv_2_0_q_0 = tmp_blending_op_165*(tmp_blending_op_160 - tmp_blending_op_163);
             const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_165*(-jac_blending_0_0_q_0*jac_blending_1_2_q_0 + jac_blending_0_2_q_0*jac_blending_1_0_q_0);
             const real_t jac_blending_inv_1_1_q_0 = tmp_blending_op_165*(jac_blending_0_0_q_0*jac_blending_2_2_q_0 - jac_blending_0_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_1_0_q_0 = tmp_blending_op_165*(-jac_blending_1_0_q_0*jac_blending_2_2_q_0 + jac_blending_1_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_1_2_q_0 - jac_blending_0_2_q_0*jac_blending_1_1_q_0);
             const real_t jac_blending_inv_0_1_q_0 = tmp_blending_op_165*(-jac_blending_0_1_q_0*jac_blending_2_2_q_0 + jac_blending_0_2_q_0*jac_blending_2_1_q_0);
             const real_t jac_blending_inv_0_0_q_0 = tmp_blending_op_165*(jac_blending_1_1_q_0*jac_blending_2_2_q_0 - jac_blending_1_2_q_0*jac_blending_2_1_q_0);
             const real_t cp_times_delta_dof_0 = _data_cp_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t cp_times_delta_dof_1 = _data_cp_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t cp_times_delta_dof_2 = _data_cp_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t cp_times_delta_dof_3 = _data_cp_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t cp_times_delta_dof_4 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t cp_times_delta_dof_5 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t cp_times_delta_dof_6 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t cp_times_delta_dof_7 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t cp_times_delta_dof_8 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t cp_times_delta_dof_9 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_0 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_1 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_2 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_3 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_4 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ux_dof_5 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ux_dof_6 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_7 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ux_dof_8 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_9 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_0 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_1 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_2 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_3 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_4 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uy_dof_5 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uy_dof_6 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_7 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uy_dof_8 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_9 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_0 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_1 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_2 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_3 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_4 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uz_dof_5 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uz_dof_6 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_7 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uz_dof_8 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_9 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t tmp_kernel_op_25 = tmp_kernel_op_10*ux_dof_6 + tmp_kernel_op_13*ux_dof_1 + tmp_kernel_op_16*ux_dof_2 + tmp_kernel_op_19*ux_dof_3 + tmp_kernel_op_20*ux_dof_7 + tmp_kernel_op_21*ux_dof_8 + tmp_kernel_op_23*ux_dof_9 + tmp_kernel_op_24*ux_dof_0 + tmp_kernel_op_8*ux_dof_4 + tmp_kernel_op_9*ux_dof_5;
             const real_t tmp_kernel_op_26 = tmp_kernel_op_10*uy_dof_6 + tmp_kernel_op_13*uy_dof_1 + tmp_kernel_op_16*uy_dof_2 + tmp_kernel_op_19*uy_dof_3 + tmp_kernel_op_20*uy_dof_7 + tmp_kernel_op_21*uy_dof_8 + tmp_kernel_op_23*uy_dof_9 + tmp_kernel_op_24*uy_dof_0 + tmp_kernel_op_8*uy_dof_4 + tmp_kernel_op_9*uy_dof_5;
             const real_t tmp_kernel_op_27 = tmp_kernel_op_10*uz_dof_6 + tmp_kernel_op_13*uz_dof_1 + tmp_kernel_op_16*uz_dof_2 + tmp_kernel_op_19*uz_dof_3 + tmp_kernel_op_20*uz_dof_7 + tmp_kernel_op_21*uz_dof_8 + tmp_kernel_op_23*uz_dof_9 + tmp_kernel_op_24*uz_dof_0 + tmp_kernel_op_8*uz_dof_4 + tmp_kernel_op_9*uz_dof_5;
             const real_t tmp_kernel_op_28 = abs_det_jac_affine_GREEN_UP*abs_det_jac_blending_q_0*(cp_times_delta_dof_0*tmp_kernel_op_24 + cp_times_delta_dof_1*tmp_kernel_op_13 + cp_times_delta_dof_2*tmp_kernel_op_16 + cp_times_delta_dof_3*tmp_kernel_op_19 + cp_times_delta_dof_4*tmp_kernel_op_8 + cp_times_delta_dof_5*tmp_kernel_op_9 + cp_times_delta_dof_6*tmp_kernel_op_10 + cp_times_delta_dof_7*tmp_kernel_op_20 + cp_times_delta_dof_8*tmp_kernel_op_21 + cp_times_delta_dof_9*tmp_kernel_op_23)*-0.1333333333333333;
             const real_t tmp_kernel_op_54 = tmp_kernel_op_37*ux_dof_4 + tmp_kernel_op_38*ux_dof_5 + tmp_kernel_op_39*ux_dof_6 + tmp_kernel_op_42*ux_dof_1 + tmp_kernel_op_45*ux_dof_2 + tmp_kernel_op_48*ux_dof_3 + tmp_kernel_op_49*ux_dof_7 + tmp_kernel_op_50*ux_dof_8 + tmp_kernel_op_52*ux_dof_9 + tmp_kernel_op_53*ux_dof_0;
             const real_t tmp_kernel_op_55 = tmp_kernel_op_37*uy_dof_4 + tmp_kernel_op_38*uy_dof_5 + tmp_kernel_op_39*uy_dof_6 + tmp_kernel_op_42*uy_dof_1 + tmp_kernel_op_45*uy_dof_2 + tmp_kernel_op_48*uy_dof_3 + tmp_kernel_op_49*uy_dof_7 + tmp_kernel_op_50*uy_dof_8 + tmp_kernel_op_52*uy_dof_9 + tmp_kernel_op_53*uy_dof_0;
             const real_t tmp_kernel_op_56 = tmp_kernel_op_37*uz_dof_4 + tmp_kernel_op_38*uz_dof_5 + tmp_kernel_op_39*uz_dof_6 + tmp_kernel_op_42*uz_dof_1 + tmp_kernel_op_45*uz_dof_2 + tmp_kernel_op_48*uz_dof_3 + tmp_kernel_op_49*uz_dof_7 + tmp_kernel_op_50*uz_dof_8 + tmp_kernel_op_52*uz_dof_9 + tmp_kernel_op_53*uz_dof_0;
             const real_t tmp_kernel_op_57 = abs_det_jac_affine_GREEN_UP*abs_det_jac_blending_q_1*(cp_times_delta_dof_0*tmp_kernel_op_53 + cp_times_delta_dof_1*tmp_kernel_op_42 + cp_times_delta_dof_2*tmp_kernel_op_45 + cp_times_delta_dof_3*tmp_kernel_op_48 + cp_times_delta_dof_4*tmp_kernel_op_37 + cp_times_delta_dof_5*tmp_kernel_op_38 + cp_times_delta_dof_6*tmp_kernel_op_39 + cp_times_delta_dof_7*tmp_kernel_op_49 + cp_times_delta_dof_8*tmp_kernel_op_50 + cp_times_delta_dof_9*tmp_kernel_op_52)*0.074999999999999983;
             const real_t tmp_kernel_op_83 = tmp_kernel_op_66*ux_dof_4 + tmp_kernel_op_67*ux_dof_5 + tmp_kernel_op_68*ux_dof_6 + tmp_kernel_op_71*ux_dof_1 + tmp_kernel_op_74*ux_dof_2 + tmp_kernel_op_77*ux_dof_3 + tmp_kernel_op_78*ux_dof_7 + tmp_kernel_op_79*ux_dof_8 + tmp_kernel_op_81*ux_dof_9 + tmp_kernel_op_82*ux_dof_0;
             const real_t tmp_kernel_op_84 = tmp_kernel_op_66*uy_dof_4 + tmp_kernel_op_67*uy_dof_5 + tmp_kernel_op_68*uy_dof_6 + tmp_kernel_op_71*uy_dof_1 + tmp_kernel_op_74*uy_dof_2 + tmp_kernel_op_77*uy_dof_3 + tmp_kernel_op_78*uy_dof_7 + tmp_kernel_op_79*uy_dof_8 + tmp_kernel_op_81*uy_dof_9 + tmp_kernel_op_82*uy_dof_0;
             const real_t tmp_kernel_op_85 = tmp_kernel_op_66*uz_dof_4 + tmp_kernel_op_67*uz_dof_5 + tmp_kernel_op_68*uz_dof_6 + tmp_kernel_op_71*uz_dof_1 + tmp_kernel_op_74*uz_dof_2 + tmp_kernel_op_77*uz_dof_3 + tmp_kernel_op_78*uz_dof_7 + tmp_kernel_op_79*uz_dof_8 + tmp_kernel_op_81*uz_dof_9 + tmp_kernel_op_82*uz_dof_0;
             const real_t tmp_kernel_op_86 = abs_det_jac_affine_GREEN_UP*abs_det_jac_blending_q_2*(cp_times_delta_dof_0*tmp_kernel_op_82 + cp_times_delta_dof_1*tmp_kernel_op_71 + cp_times_delta_dof_2*tmp_kernel_op_74 + cp_times_delta_dof_3*tmp_kernel_op_77 + cp_times_delta_dof_4*tmp_kernel_op_66 + cp_times_delta_dof_5*tmp_kernel_op_67 + cp_times_delta_dof_6*tmp_kernel_op_68 + cp_times_delta_dof_7*tmp_kernel_op_78 + cp_times_delta_dof_8*tmp_kernel_op_79 + cp_times_delta_dof_9*tmp_kernel_op_81)*0.074999999999999983;
             const real_t tmp_kernel_op_112 = tmp_kernel_op_100*ux_dof_1 + tmp_kernel_op_103*ux_dof_2 + tmp_kernel_op_106*ux_dof_3 + tmp_kernel_op_107*ux_dof_7 + tmp_kernel_op_108*ux_dof_8 + tmp_kernel_op_110*ux_dof_9 + tmp_kernel_op_111*ux_dof_0 + tmp_kernel_op_95*ux_dof_4 + tmp_kernel_op_96*ux_dof_5 + tmp_kernel_op_97*ux_dof_6;
             const real_t tmp_kernel_op_113 = tmp_kernel_op_100*uy_dof_1 + tmp_kernel_op_103*uy_dof_2 + tmp_kernel_op_106*uy_dof_3 + tmp_kernel_op_107*uy_dof_7 + tmp_kernel_op_108*uy_dof_8 + tmp_kernel_op_110*uy_dof_9 + tmp_kernel_op_111*uy_dof_0 + tmp_kernel_op_95*uy_dof_4 + tmp_kernel_op_96*uy_dof_5 + tmp_kernel_op_97*uy_dof_6;
             const real_t tmp_kernel_op_114 = tmp_kernel_op_100*uz_dof_1 + tmp_kernel_op_103*uz_dof_2 + tmp_kernel_op_106*uz_dof_3 + tmp_kernel_op_107*uz_dof_7 + tmp_kernel_op_108*uz_dof_8 + tmp_kernel_op_110*uz_dof_9 + tmp_kernel_op_111*uz_dof_0 + tmp_kernel_op_95*uz_dof_4 + tmp_kernel_op_96*uz_dof_5 + tmp_kernel_op_97*uz_dof_6;
             const real_t tmp_kernel_op_115 = abs_det_jac_affine_GREEN_UP*abs_det_jac_blending_q_3*(cp_times_delta_dof_0*tmp_kernel_op_111 + cp_times_delta_dof_1*tmp_kernel_op_100 + cp_times_delta_dof_2*tmp_kernel_op_103 + cp_times_delta_dof_3*tmp_kernel_op_106 + cp_times_delta_dof_4*tmp_kernel_op_95 + cp_times_delta_dof_5*tmp_kernel_op_96 + cp_times_delta_dof_6*tmp_kernel_op_97 + cp_times_delta_dof_7*tmp_kernel_op_107 + cp_times_delta_dof_8*tmp_kernel_op_108 + cp_times_delta_dof_9*tmp_kernel_op_110)*0.074999999999999983;
             const real_t tmp_kernel_op_141 = tmp_kernel_op_124*ux_dof_4 + tmp_kernel_op_125*ux_dof_5 + tmp_kernel_op_126*ux_dof_6 + tmp_kernel_op_129*ux_dof_1 + tmp_kernel_op_132*ux_dof_2 + tmp_kernel_op_135*ux_dof_3 + tmp_kernel_op_136*ux_dof_7 + tmp_kernel_op_137*ux_dof_8 + tmp_kernel_op_139*ux_dof_9 + tmp_kernel_op_140*ux_dof_0;
             const real_t tmp_kernel_op_142 = tmp_kernel_op_124*uy_dof_4 + tmp_kernel_op_125*uy_dof_5 + tmp_kernel_op_126*uy_dof_6 + tmp_kernel_op_129*uy_dof_1 + tmp_kernel_op_132*uy_dof_2 + tmp_kernel_op_135*uy_dof_3 + tmp_kernel_op_136*uy_dof_7 + tmp_kernel_op_137*uy_dof_8 + tmp_kernel_op_139*uy_dof_9 + tmp_kernel_op_140*uy_dof_0;
             const real_t tmp_kernel_op_143 = tmp_kernel_op_124*uz_dof_4 + tmp_kernel_op_125*uz_dof_5 + tmp_kernel_op_126*uz_dof_6 + tmp_kernel_op_129*uz_dof_1 + tmp_kernel_op_132*uz_dof_2 + tmp_kernel_op_135*uz_dof_3 + tmp_kernel_op_136*uz_dof_7 + tmp_kernel_op_137*uz_dof_8 + tmp_kernel_op_139*uz_dof_9 + tmp_kernel_op_140*uz_dof_0;
             const real_t tmp_kernel_op_144 = abs_det_jac_affine_GREEN_UP*abs_det_jac_blending_q_4*(cp_times_delta_dof_0*tmp_kernel_op_140 + cp_times_delta_dof_1*tmp_kernel_op_129 + cp_times_delta_dof_2*tmp_kernel_op_132 + cp_times_delta_dof_3*tmp_kernel_op_135 + cp_times_delta_dof_4*tmp_kernel_op_124 + cp_times_delta_dof_5*tmp_kernel_op_125 + cp_times_delta_dof_6*tmp_kernel_op_126 + cp_times_delta_dof_7*tmp_kernel_op_136 + cp_times_delta_dof_8*tmp_kernel_op_137 + cp_times_delta_dof_9*tmp_kernel_op_139)*0.074999999999999983;
             const real_t elMatDiag_0 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_729 + jac_blending_inv_1_0_q_3*tmp_moved_constant_730 + jac_blending_inv_2_0_q_3*tmp_moved_constant_731) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_729 + jac_blending_inv_1_1_q_3*tmp_moved_constant_730 + jac_blending_inv_2_1_q_3*tmp_moved_constant_731) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_729 + jac_blending_inv_1_2_q_3*tmp_moved_constant_730 + jac_blending_inv_2_2_q_3*tmp_moved_constant_731))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_729 + jac_blending_inv_1_0_q_3*tmp_moved_constant_730 + jac_blending_inv_2_0_q_3*tmp_moved_constant_731) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_729 + jac_blending_inv_1_1_q_3*tmp_moved_constant_730 + jac_blending_inv_2_1_q_3*tmp_moved_constant_731) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_729 + jac_blending_inv_1_2_q_3*tmp_moved_constant_730 + jac_blending_inv_2_2_q_3*tmp_moved_constant_731))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_732 + jac_blending_inv_1_0_q_4*tmp_moved_constant_733 + jac_blending_inv_2_0_q_4*tmp_moved_constant_734) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_732 + jac_blending_inv_1_1_q_4*tmp_moved_constant_733 + jac_blending_inv_2_1_q_4*tmp_moved_constant_734) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_732 + jac_blending_inv_1_2_q_4*tmp_moved_constant_733 + jac_blending_inv_2_2_q_4*tmp_moved_constant_734))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_732 + jac_blending_inv_1_0_q_4*tmp_moved_constant_733 + jac_blending_inv_2_0_q_4*tmp_moved_constant_734) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_732 + jac_blending_inv_1_1_q_4*tmp_moved_constant_733 + jac_blending_inv_2_1_q_4*tmp_moved_constant_734) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_732 + jac_blending_inv_1_2_q_4*tmp_moved_constant_733 + jac_blending_inv_2_2_q_4*tmp_moved_constant_734))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_720 + jac_blending_inv_1_0_q_0*tmp_moved_constant_721 + jac_blending_inv_2_0_q_0*tmp_moved_constant_722) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_720 + jac_blending_inv_1_1_q_0*tmp_moved_constant_721 + jac_blending_inv_2_1_q_0*tmp_moved_constant_722) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_720 + jac_blending_inv_1_2_q_0*tmp_moved_constant_721 + jac_blending_inv_2_2_q_0*tmp_moved_constant_722))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_720 + jac_blending_inv_1_0_q_0*tmp_moved_constant_721 + jac_blending_inv_2_0_q_0*tmp_moved_constant_722) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_720 + jac_blending_inv_1_1_q_0*tmp_moved_constant_721 + jac_blending_inv_2_1_q_0*tmp_moved_constant_722) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_720 + jac_blending_inv_1_2_q_0*tmp_moved_constant_721 + jac_blending_inv_2_2_q_0*tmp_moved_constant_722))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_723 + jac_blending_inv_1_0_q_1*tmp_moved_constant_724 + jac_blending_inv_2_0_q_1*tmp_moved_constant_725) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_723 + jac_blending_inv_1_1_q_1*tmp_moved_constant_724 + jac_blending_inv_2_1_q_1*tmp_moved_constant_725) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_723 + jac_blending_inv_1_2_q_1*tmp_moved_constant_724 + jac_blending_inv_2_2_q_1*tmp_moved_constant_725))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_723 + jac_blending_inv_1_0_q_1*tmp_moved_constant_724 + jac_blending_inv_2_0_q_1*tmp_moved_constant_725) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_723 + jac_blending_inv_1_1_q_1*tmp_moved_constant_724 + jac_blending_inv_2_1_q_1*tmp_moved_constant_725) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_723 + jac_blending_inv_1_2_q_1*tmp_moved_constant_724 + jac_blending_inv_2_2_q_1*tmp_moved_constant_725))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_726 + jac_blending_inv_1_0_q_2*tmp_moved_constant_727 + jac_blending_inv_2_0_q_2*tmp_moved_constant_728) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_726 + jac_blending_inv_1_1_q_2*tmp_moved_constant_727 + jac_blending_inv_2_1_q_2*tmp_moved_constant_728) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_726 + jac_blending_inv_1_2_q_2*tmp_moved_constant_727 + jac_blending_inv_2_2_q_2*tmp_moved_constant_728))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_726 + jac_blending_inv_1_0_q_2*tmp_moved_constant_727 + jac_blending_inv_2_0_q_2*tmp_moved_constant_728) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_726 + jac_blending_inv_1_1_q_2*tmp_moved_constant_727 + jac_blending_inv_2_1_q_2*tmp_moved_constant_728) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_726 + jac_blending_inv_1_2_q_2*tmp_moved_constant_727 + jac_blending_inv_2_2_q_2*tmp_moved_constant_728)));
             const real_t elMatDiag_1 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_744 + jac_blending_inv_1_0_q_3*tmp_moved_constant_745 + jac_blending_inv_2_0_q_3*tmp_moved_constant_746) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_744 + jac_blending_inv_1_1_q_3*tmp_moved_constant_745 + jac_blending_inv_2_1_q_3*tmp_moved_constant_746) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_744 + jac_blending_inv_1_2_q_3*tmp_moved_constant_745 + jac_blending_inv_2_2_q_3*tmp_moved_constant_746))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_744 + jac_blending_inv_1_0_q_3*tmp_moved_constant_745 + jac_blending_inv_2_0_q_3*tmp_moved_constant_746) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_744 + jac_blending_inv_1_1_q_3*tmp_moved_constant_745 + jac_blending_inv_2_1_q_3*tmp_moved_constant_746) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_744 + jac_blending_inv_1_2_q_3*tmp_moved_constant_745 + jac_blending_inv_2_2_q_3*tmp_moved_constant_746))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_747 + jac_blending_inv_1_0_q_4*tmp_moved_constant_748 + jac_blending_inv_2_0_q_4*tmp_moved_constant_749) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_747 + jac_blending_inv_1_1_q_4*tmp_moved_constant_748 + jac_blending_inv_2_1_q_4*tmp_moved_constant_749) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_747 + jac_blending_inv_1_2_q_4*tmp_moved_constant_748 + jac_blending_inv_2_2_q_4*tmp_moved_constant_749))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_747 + jac_blending_inv_1_0_q_4*tmp_moved_constant_748 + jac_blending_inv_2_0_q_4*tmp_moved_constant_749) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_747 + jac_blending_inv_1_1_q_4*tmp_moved_constant_748 + jac_blending_inv_2_1_q_4*tmp_moved_constant_749) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_747 + jac_blending_inv_1_2_q_4*tmp_moved_constant_748 + jac_blending_inv_2_2_q_4*tmp_moved_constant_749))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_735 + jac_blending_inv_1_0_q_0*tmp_moved_constant_736 + jac_blending_inv_2_0_q_0*tmp_moved_constant_737) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_735 + jac_blending_inv_1_1_q_0*tmp_moved_constant_736 + jac_blending_inv_2_1_q_0*tmp_moved_constant_737) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_735 + jac_blending_inv_1_2_q_0*tmp_moved_constant_736 + jac_blending_inv_2_2_q_0*tmp_moved_constant_737))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_735 + jac_blending_inv_1_0_q_0*tmp_moved_constant_736 + jac_blending_inv_2_0_q_0*tmp_moved_constant_737) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_735 + jac_blending_inv_1_1_q_0*tmp_moved_constant_736 + jac_blending_inv_2_1_q_0*tmp_moved_constant_737) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_735 + jac_blending_inv_1_2_q_0*tmp_moved_constant_736 + jac_blending_inv_2_2_q_0*tmp_moved_constant_737))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_738 + jac_blending_inv_1_0_q_1*tmp_moved_constant_739 + jac_blending_inv_2_0_q_1*tmp_moved_constant_740) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_738 + jac_blending_inv_1_1_q_1*tmp_moved_constant_739 + jac_blending_inv_2_1_q_1*tmp_moved_constant_740) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_738 + jac_blending_inv_1_2_q_1*tmp_moved_constant_739 + jac_blending_inv_2_2_q_1*tmp_moved_constant_740))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_738 + jac_blending_inv_1_0_q_1*tmp_moved_constant_739 + jac_blending_inv_2_0_q_1*tmp_moved_constant_740) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_738 + jac_blending_inv_1_1_q_1*tmp_moved_constant_739 + jac_blending_inv_2_1_q_1*tmp_moved_constant_740) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_738 + jac_blending_inv_1_2_q_1*tmp_moved_constant_739 + jac_blending_inv_2_2_q_1*tmp_moved_constant_740))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_741 + jac_blending_inv_1_0_q_2*tmp_moved_constant_742 + jac_blending_inv_2_0_q_2*tmp_moved_constant_743) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_741 + jac_blending_inv_1_1_q_2*tmp_moved_constant_742 + jac_blending_inv_2_1_q_2*tmp_moved_constant_743) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_741 + jac_blending_inv_1_2_q_2*tmp_moved_constant_742 + jac_blending_inv_2_2_q_2*tmp_moved_constant_743))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_741 + jac_blending_inv_1_0_q_2*tmp_moved_constant_742 + jac_blending_inv_2_0_q_2*tmp_moved_constant_743) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_741 + jac_blending_inv_1_1_q_2*tmp_moved_constant_742 + jac_blending_inv_2_1_q_2*tmp_moved_constant_743) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_741 + jac_blending_inv_1_2_q_2*tmp_moved_constant_742 + jac_blending_inv_2_2_q_2*tmp_moved_constant_743)));
             const real_t elMatDiag_2 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_759 + jac_blending_inv_1_0_q_3*tmp_moved_constant_760 + jac_blending_inv_2_0_q_3*tmp_moved_constant_761) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_759 + jac_blending_inv_1_1_q_3*tmp_moved_constant_760 + jac_blending_inv_2_1_q_3*tmp_moved_constant_761) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_759 + jac_blending_inv_1_2_q_3*tmp_moved_constant_760 + jac_blending_inv_2_2_q_3*tmp_moved_constant_761))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_759 + jac_blending_inv_1_0_q_3*tmp_moved_constant_760 + jac_blending_inv_2_0_q_3*tmp_moved_constant_761) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_759 + jac_blending_inv_1_1_q_3*tmp_moved_constant_760 + jac_blending_inv_2_1_q_3*tmp_moved_constant_761) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_759 + jac_blending_inv_1_2_q_3*tmp_moved_constant_760 + jac_blending_inv_2_2_q_3*tmp_moved_constant_761))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_762 + jac_blending_inv_1_0_q_4*tmp_moved_constant_763 + jac_blending_inv_2_0_q_4*tmp_moved_constant_764) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_762 + jac_blending_inv_1_1_q_4*tmp_moved_constant_763 + jac_blending_inv_2_1_q_4*tmp_moved_constant_764) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_762 + jac_blending_inv_1_2_q_4*tmp_moved_constant_763 + jac_blending_inv_2_2_q_4*tmp_moved_constant_764))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_762 + jac_blending_inv_1_0_q_4*tmp_moved_constant_763 + jac_blending_inv_2_0_q_4*tmp_moved_constant_764) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_762 + jac_blending_inv_1_1_q_4*tmp_moved_constant_763 + jac_blending_inv_2_1_q_4*tmp_moved_constant_764) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_762 + jac_blending_inv_1_2_q_4*tmp_moved_constant_763 + jac_blending_inv_2_2_q_4*tmp_moved_constant_764))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_750 + jac_blending_inv_1_0_q_0*tmp_moved_constant_751 + jac_blending_inv_2_0_q_0*tmp_moved_constant_752) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_750 + jac_blending_inv_1_1_q_0*tmp_moved_constant_751 + jac_blending_inv_2_1_q_0*tmp_moved_constant_752) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_750 + jac_blending_inv_1_2_q_0*tmp_moved_constant_751 + jac_blending_inv_2_2_q_0*tmp_moved_constant_752))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_750 + jac_blending_inv_1_0_q_0*tmp_moved_constant_751 + jac_blending_inv_2_0_q_0*tmp_moved_constant_752) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_750 + jac_blending_inv_1_1_q_0*tmp_moved_constant_751 + jac_blending_inv_2_1_q_0*tmp_moved_constant_752) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_750 + jac_blending_inv_1_2_q_0*tmp_moved_constant_751 + jac_blending_inv_2_2_q_0*tmp_moved_constant_752))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_753 + jac_blending_inv_1_0_q_1*tmp_moved_constant_754 + jac_blending_inv_2_0_q_1*tmp_moved_constant_755) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_753 + jac_blending_inv_1_1_q_1*tmp_moved_constant_754 + jac_blending_inv_2_1_q_1*tmp_moved_constant_755) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_753 + jac_blending_inv_1_2_q_1*tmp_moved_constant_754 + jac_blending_inv_2_2_q_1*tmp_moved_constant_755))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_753 + jac_blending_inv_1_0_q_1*tmp_moved_constant_754 + jac_blending_inv_2_0_q_1*tmp_moved_constant_755) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_753 + jac_blending_inv_1_1_q_1*tmp_moved_constant_754 + jac_blending_inv_2_1_q_1*tmp_moved_constant_755) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_753 + jac_blending_inv_1_2_q_1*tmp_moved_constant_754 + jac_blending_inv_2_2_q_1*tmp_moved_constant_755))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_756 + jac_blending_inv_1_0_q_2*tmp_moved_constant_757 + jac_blending_inv_2_0_q_2*tmp_moved_constant_758) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_756 + jac_blending_inv_1_1_q_2*tmp_moved_constant_757 + jac_blending_inv_2_1_q_2*tmp_moved_constant_758) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_756 + jac_blending_inv_1_2_q_2*tmp_moved_constant_757 + jac_blending_inv_2_2_q_2*tmp_moved_constant_758))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_756 + jac_blending_inv_1_0_q_2*tmp_moved_constant_757 + jac_blending_inv_2_0_q_2*tmp_moved_constant_758) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_756 + jac_blending_inv_1_1_q_2*tmp_moved_constant_757 + jac_blending_inv_2_1_q_2*tmp_moved_constant_758) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_756 + jac_blending_inv_1_2_q_2*tmp_moved_constant_757 + jac_blending_inv_2_2_q_2*tmp_moved_constant_758)));
             const real_t elMatDiag_3 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_774 + jac_blending_inv_1_0_q_3*tmp_moved_constant_775 + jac_blending_inv_2_0_q_3*tmp_moved_constant_776) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_774 + jac_blending_inv_1_1_q_3*tmp_moved_constant_775 + jac_blending_inv_2_1_q_3*tmp_moved_constant_776) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_774 + jac_blending_inv_1_2_q_3*tmp_moved_constant_775 + jac_blending_inv_2_2_q_3*tmp_moved_constant_776))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_774 + jac_blending_inv_1_0_q_3*tmp_moved_constant_775 + jac_blending_inv_2_0_q_3*tmp_moved_constant_776) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_774 + jac_blending_inv_1_1_q_3*tmp_moved_constant_775 + jac_blending_inv_2_1_q_3*tmp_moved_constant_776) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_774 + jac_blending_inv_1_2_q_3*tmp_moved_constant_775 + jac_blending_inv_2_2_q_3*tmp_moved_constant_776))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_777 + jac_blending_inv_1_0_q_4*tmp_moved_constant_778 + jac_blending_inv_2_0_q_4*tmp_moved_constant_779) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_777 + jac_blending_inv_1_1_q_4*tmp_moved_constant_778 + jac_blending_inv_2_1_q_4*tmp_moved_constant_779) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_777 + jac_blending_inv_1_2_q_4*tmp_moved_constant_778 + jac_blending_inv_2_2_q_4*tmp_moved_constant_779))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_777 + jac_blending_inv_1_0_q_4*tmp_moved_constant_778 + jac_blending_inv_2_0_q_4*tmp_moved_constant_779) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_777 + jac_blending_inv_1_1_q_4*tmp_moved_constant_778 + jac_blending_inv_2_1_q_4*tmp_moved_constant_779) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_777 + jac_blending_inv_1_2_q_4*tmp_moved_constant_778 + jac_blending_inv_2_2_q_4*tmp_moved_constant_779))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_765 + jac_blending_inv_1_0_q_0*tmp_moved_constant_766 + jac_blending_inv_2_0_q_0*tmp_moved_constant_767) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_765 + jac_blending_inv_1_1_q_0*tmp_moved_constant_766 + jac_blending_inv_2_1_q_0*tmp_moved_constant_767) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_765 + jac_blending_inv_1_2_q_0*tmp_moved_constant_766 + jac_blending_inv_2_2_q_0*tmp_moved_constant_767))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_765 + jac_blending_inv_1_0_q_0*tmp_moved_constant_766 + jac_blending_inv_2_0_q_0*tmp_moved_constant_767) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_765 + jac_blending_inv_1_1_q_0*tmp_moved_constant_766 + jac_blending_inv_2_1_q_0*tmp_moved_constant_767) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_765 + jac_blending_inv_1_2_q_0*tmp_moved_constant_766 + jac_blending_inv_2_2_q_0*tmp_moved_constant_767))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_768 + jac_blending_inv_1_0_q_1*tmp_moved_constant_769 + jac_blending_inv_2_0_q_1*tmp_moved_constant_770) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_768 + jac_blending_inv_1_1_q_1*tmp_moved_constant_769 + jac_blending_inv_2_1_q_1*tmp_moved_constant_770) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_768 + jac_blending_inv_1_2_q_1*tmp_moved_constant_769 + jac_blending_inv_2_2_q_1*tmp_moved_constant_770))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_768 + jac_blending_inv_1_0_q_1*tmp_moved_constant_769 + jac_blending_inv_2_0_q_1*tmp_moved_constant_770) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_768 + jac_blending_inv_1_1_q_1*tmp_moved_constant_769 + jac_blending_inv_2_1_q_1*tmp_moved_constant_770) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_768 + jac_blending_inv_1_2_q_1*tmp_moved_constant_769 + jac_blending_inv_2_2_q_1*tmp_moved_constant_770))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_771 + jac_blending_inv_1_0_q_2*tmp_moved_constant_772 + jac_blending_inv_2_0_q_2*tmp_moved_constant_773) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_771 + jac_blending_inv_1_1_q_2*tmp_moved_constant_772 + jac_blending_inv_2_1_q_2*tmp_moved_constant_773) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_771 + jac_blending_inv_1_2_q_2*tmp_moved_constant_772 + jac_blending_inv_2_2_q_2*tmp_moved_constant_773))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_771 + jac_blending_inv_1_0_q_2*tmp_moved_constant_772 + jac_blending_inv_2_0_q_2*tmp_moved_constant_773) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_771 + jac_blending_inv_1_1_q_2*tmp_moved_constant_772 + jac_blending_inv_2_1_q_2*tmp_moved_constant_773) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_771 + jac_blending_inv_1_2_q_2*tmp_moved_constant_772 + jac_blending_inv_2_2_q_2*tmp_moved_constant_773)));
             const real_t elMatDiag_4 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_809 + jac_blending_inv_1_0_q_3*tmp_moved_constant_812 + jac_blending_inv_2_0_q_3*tmp_moved_constant_815) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_809 + jac_blending_inv_1_1_q_3*tmp_moved_constant_812 + jac_blending_inv_2_1_q_3*tmp_moved_constant_815) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_809 + jac_blending_inv_1_2_q_3*tmp_moved_constant_812 + jac_blending_inv_2_2_q_3*tmp_moved_constant_815))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_809 + jac_blending_inv_1_0_q_3*tmp_moved_constant_812 + jac_blending_inv_2_0_q_3*tmp_moved_constant_815) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_809 + jac_blending_inv_1_1_q_3*tmp_moved_constant_812 + jac_blending_inv_2_1_q_3*tmp_moved_constant_815) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_809 + jac_blending_inv_1_2_q_3*tmp_moved_constant_812 + jac_blending_inv_2_2_q_3*tmp_moved_constant_815))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_818 + jac_blending_inv_1_0_q_4*tmp_moved_constant_821 + jac_blending_inv_2_0_q_4*tmp_moved_constant_824) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_818 + jac_blending_inv_1_1_q_4*tmp_moved_constant_821 + jac_blending_inv_2_1_q_4*tmp_moved_constant_824) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_818 + jac_blending_inv_1_2_q_4*tmp_moved_constant_821 + jac_blending_inv_2_2_q_4*tmp_moved_constant_824))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_818 + jac_blending_inv_1_0_q_4*tmp_moved_constant_821 + jac_blending_inv_2_0_q_4*tmp_moved_constant_824) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_818 + jac_blending_inv_1_1_q_4*tmp_moved_constant_821 + jac_blending_inv_2_1_q_4*tmp_moved_constant_824) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_818 + jac_blending_inv_1_2_q_4*tmp_moved_constant_821 + jac_blending_inv_2_2_q_4*tmp_moved_constant_824))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_782 + jac_blending_inv_1_0_q_0*tmp_moved_constant_785 + jac_blending_inv_2_0_q_0*tmp_moved_constant_788) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_782 + jac_blending_inv_1_1_q_0*tmp_moved_constant_785 + jac_blending_inv_2_1_q_0*tmp_moved_constant_788) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_782 + jac_blending_inv_1_2_q_0*tmp_moved_constant_785 + jac_blending_inv_2_2_q_0*tmp_moved_constant_788))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_782 + jac_blending_inv_1_0_q_0*tmp_moved_constant_785 + jac_blending_inv_2_0_q_0*tmp_moved_constant_788) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_782 + jac_blending_inv_1_1_q_0*tmp_moved_constant_785 + jac_blending_inv_2_1_q_0*tmp_moved_constant_788) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_782 + jac_blending_inv_1_2_q_0*tmp_moved_constant_785 + jac_blending_inv_2_2_q_0*tmp_moved_constant_788))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_791 + jac_blending_inv_1_0_q_1*tmp_moved_constant_794 + jac_blending_inv_2_0_q_1*tmp_moved_constant_797) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_791 + jac_blending_inv_1_1_q_1*tmp_moved_constant_794 + jac_blending_inv_2_1_q_1*tmp_moved_constant_797) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_791 + jac_blending_inv_1_2_q_1*tmp_moved_constant_794 + jac_blending_inv_2_2_q_1*tmp_moved_constant_797))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_791 + jac_blending_inv_1_0_q_1*tmp_moved_constant_794 + jac_blending_inv_2_0_q_1*tmp_moved_constant_797) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_791 + jac_blending_inv_1_1_q_1*tmp_moved_constant_794 + jac_blending_inv_2_1_q_1*tmp_moved_constant_797) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_791 + jac_blending_inv_1_2_q_1*tmp_moved_constant_794 + jac_blending_inv_2_2_q_1*tmp_moved_constant_797))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_800 + jac_blending_inv_1_0_q_2*tmp_moved_constant_803 + jac_blending_inv_2_0_q_2*tmp_moved_constant_806) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_800 + jac_blending_inv_1_1_q_2*tmp_moved_constant_803 + jac_blending_inv_2_1_q_2*tmp_moved_constant_806) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_800 + jac_blending_inv_1_2_q_2*tmp_moved_constant_803 + jac_blending_inv_2_2_q_2*tmp_moved_constant_806))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_800 + jac_blending_inv_1_0_q_2*tmp_moved_constant_803 + jac_blending_inv_2_0_q_2*tmp_moved_constant_806) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_800 + jac_blending_inv_1_1_q_2*tmp_moved_constant_803 + jac_blending_inv_2_1_q_2*tmp_moved_constant_806) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_800 + jac_blending_inv_1_2_q_2*tmp_moved_constant_803 + jac_blending_inv_2_2_q_2*tmp_moved_constant_806)));
             const real_t elMatDiag_5 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_854 + jac_blending_inv_1_0_q_3*tmp_moved_constant_857 + jac_blending_inv_2_0_q_3*tmp_moved_constant_860) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_854 + jac_blending_inv_1_1_q_3*tmp_moved_constant_857 + jac_blending_inv_2_1_q_3*tmp_moved_constant_860) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_854 + jac_blending_inv_1_2_q_3*tmp_moved_constant_857 + jac_blending_inv_2_2_q_3*tmp_moved_constant_860))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_854 + jac_blending_inv_1_0_q_3*tmp_moved_constant_857 + jac_blending_inv_2_0_q_3*tmp_moved_constant_860) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_854 + jac_blending_inv_1_1_q_3*tmp_moved_constant_857 + jac_blending_inv_2_1_q_3*tmp_moved_constant_860) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_854 + jac_blending_inv_1_2_q_3*tmp_moved_constant_857 + jac_blending_inv_2_2_q_3*tmp_moved_constant_860))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_863 + jac_blending_inv_1_0_q_4*tmp_moved_constant_866 + jac_blending_inv_2_0_q_4*tmp_moved_constant_869) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_863 + jac_blending_inv_1_1_q_4*tmp_moved_constant_866 + jac_blending_inv_2_1_q_4*tmp_moved_constant_869) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_863 + jac_blending_inv_1_2_q_4*tmp_moved_constant_866 + jac_blending_inv_2_2_q_4*tmp_moved_constant_869))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_863 + jac_blending_inv_1_0_q_4*tmp_moved_constant_866 + jac_blending_inv_2_0_q_4*tmp_moved_constant_869) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_863 + jac_blending_inv_1_1_q_4*tmp_moved_constant_866 + jac_blending_inv_2_1_q_4*tmp_moved_constant_869) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_863 + jac_blending_inv_1_2_q_4*tmp_moved_constant_866 + jac_blending_inv_2_2_q_4*tmp_moved_constant_869))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_827 + jac_blending_inv_1_0_q_0*tmp_moved_constant_830 + jac_blending_inv_2_0_q_0*tmp_moved_constant_833) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_827 + jac_blending_inv_1_1_q_0*tmp_moved_constant_830 + jac_blending_inv_2_1_q_0*tmp_moved_constant_833) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_827 + jac_blending_inv_1_2_q_0*tmp_moved_constant_830 + jac_blending_inv_2_2_q_0*tmp_moved_constant_833))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_827 + jac_blending_inv_1_0_q_0*tmp_moved_constant_830 + jac_blending_inv_2_0_q_0*tmp_moved_constant_833) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_827 + jac_blending_inv_1_1_q_0*tmp_moved_constant_830 + jac_blending_inv_2_1_q_0*tmp_moved_constant_833) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_827 + jac_blending_inv_1_2_q_0*tmp_moved_constant_830 + jac_blending_inv_2_2_q_0*tmp_moved_constant_833))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_836 + jac_blending_inv_1_0_q_1*tmp_moved_constant_839 + jac_blending_inv_2_0_q_1*tmp_moved_constant_842) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_836 + jac_blending_inv_1_1_q_1*tmp_moved_constant_839 + jac_blending_inv_2_1_q_1*tmp_moved_constant_842) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_836 + jac_blending_inv_1_2_q_1*tmp_moved_constant_839 + jac_blending_inv_2_2_q_1*tmp_moved_constant_842))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_836 + jac_blending_inv_1_0_q_1*tmp_moved_constant_839 + jac_blending_inv_2_0_q_1*tmp_moved_constant_842) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_836 + jac_blending_inv_1_1_q_1*tmp_moved_constant_839 + jac_blending_inv_2_1_q_1*tmp_moved_constant_842) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_836 + jac_blending_inv_1_2_q_1*tmp_moved_constant_839 + jac_blending_inv_2_2_q_1*tmp_moved_constant_842))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_845 + jac_blending_inv_1_0_q_2*tmp_moved_constant_848 + jac_blending_inv_2_0_q_2*tmp_moved_constant_851) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_845 + jac_blending_inv_1_1_q_2*tmp_moved_constant_848 + jac_blending_inv_2_1_q_2*tmp_moved_constant_851) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_845 + jac_blending_inv_1_2_q_2*tmp_moved_constant_848 + jac_blending_inv_2_2_q_2*tmp_moved_constant_851))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_845 + jac_blending_inv_1_0_q_2*tmp_moved_constant_848 + jac_blending_inv_2_0_q_2*tmp_moved_constant_851) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_845 + jac_blending_inv_1_1_q_2*tmp_moved_constant_848 + jac_blending_inv_2_1_q_2*tmp_moved_constant_851) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_845 + jac_blending_inv_1_2_q_2*tmp_moved_constant_848 + jac_blending_inv_2_2_q_2*tmp_moved_constant_851)));
             const real_t elMatDiag_6 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_899 + jac_blending_inv_1_0_q_3*tmp_moved_constant_902 + jac_blending_inv_2_0_q_3*tmp_moved_constant_905) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_899 + jac_blending_inv_1_1_q_3*tmp_moved_constant_902 + jac_blending_inv_2_1_q_3*tmp_moved_constant_905) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_899 + jac_blending_inv_1_2_q_3*tmp_moved_constant_902 + jac_blending_inv_2_2_q_3*tmp_moved_constant_905))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_899 + jac_blending_inv_1_0_q_3*tmp_moved_constant_902 + jac_blending_inv_2_0_q_3*tmp_moved_constant_905) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_899 + jac_blending_inv_1_1_q_3*tmp_moved_constant_902 + jac_blending_inv_2_1_q_3*tmp_moved_constant_905) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_899 + jac_blending_inv_1_2_q_3*tmp_moved_constant_902 + jac_blending_inv_2_2_q_3*tmp_moved_constant_905))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_908 + jac_blending_inv_1_0_q_4*tmp_moved_constant_911 + jac_blending_inv_2_0_q_4*tmp_moved_constant_914) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_908 + jac_blending_inv_1_1_q_4*tmp_moved_constant_911 + jac_blending_inv_2_1_q_4*tmp_moved_constant_914) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_908 + jac_blending_inv_1_2_q_4*tmp_moved_constant_911 + jac_blending_inv_2_2_q_4*tmp_moved_constant_914))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_908 + jac_blending_inv_1_0_q_4*tmp_moved_constant_911 + jac_blending_inv_2_0_q_4*tmp_moved_constant_914) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_908 + jac_blending_inv_1_1_q_4*tmp_moved_constant_911 + jac_blending_inv_2_1_q_4*tmp_moved_constant_914) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_908 + jac_blending_inv_1_2_q_4*tmp_moved_constant_911 + jac_blending_inv_2_2_q_4*tmp_moved_constant_914))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_872 + jac_blending_inv_1_0_q_0*tmp_moved_constant_875 + jac_blending_inv_2_0_q_0*tmp_moved_constant_878) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_872 + jac_blending_inv_1_1_q_0*tmp_moved_constant_875 + jac_blending_inv_2_1_q_0*tmp_moved_constant_878) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_872 + jac_blending_inv_1_2_q_0*tmp_moved_constant_875 + jac_blending_inv_2_2_q_0*tmp_moved_constant_878))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_872 + jac_blending_inv_1_0_q_0*tmp_moved_constant_875 + jac_blending_inv_2_0_q_0*tmp_moved_constant_878) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_872 + jac_blending_inv_1_1_q_0*tmp_moved_constant_875 + jac_blending_inv_2_1_q_0*tmp_moved_constant_878) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_872 + jac_blending_inv_1_2_q_0*tmp_moved_constant_875 + jac_blending_inv_2_2_q_0*tmp_moved_constant_878))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_881 + jac_blending_inv_1_0_q_1*tmp_moved_constant_884 + jac_blending_inv_2_0_q_1*tmp_moved_constant_887) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_881 + jac_blending_inv_1_1_q_1*tmp_moved_constant_884 + jac_blending_inv_2_1_q_1*tmp_moved_constant_887) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_881 + jac_blending_inv_1_2_q_1*tmp_moved_constant_884 + jac_blending_inv_2_2_q_1*tmp_moved_constant_887))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_881 + jac_blending_inv_1_0_q_1*tmp_moved_constant_884 + jac_blending_inv_2_0_q_1*tmp_moved_constant_887) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_881 + jac_blending_inv_1_1_q_1*tmp_moved_constant_884 + jac_blending_inv_2_1_q_1*tmp_moved_constant_887) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_881 + jac_blending_inv_1_2_q_1*tmp_moved_constant_884 + jac_blending_inv_2_2_q_1*tmp_moved_constant_887))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_890 + jac_blending_inv_1_0_q_2*tmp_moved_constant_893 + jac_blending_inv_2_0_q_2*tmp_moved_constant_896) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_890 + jac_blending_inv_1_1_q_2*tmp_moved_constant_893 + jac_blending_inv_2_1_q_2*tmp_moved_constant_896) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_890 + jac_blending_inv_1_2_q_2*tmp_moved_constant_893 + jac_blending_inv_2_2_q_2*tmp_moved_constant_896))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_890 + jac_blending_inv_1_0_q_2*tmp_moved_constant_893 + jac_blending_inv_2_0_q_2*tmp_moved_constant_896) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_890 + jac_blending_inv_1_1_q_2*tmp_moved_constant_893 + jac_blending_inv_2_1_q_2*tmp_moved_constant_896) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_890 + jac_blending_inv_1_2_q_2*tmp_moved_constant_893 + jac_blending_inv_2_2_q_2*tmp_moved_constant_896)));
             const real_t elMatDiag_7 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_924 + jac_blending_inv_1_0_q_3*tmp_moved_constant_925 + jac_blending_inv_2_0_q_3*tmp_moved_constant_926) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_924 + jac_blending_inv_1_1_q_3*tmp_moved_constant_925 + jac_blending_inv_2_1_q_3*tmp_moved_constant_926) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_924 + jac_blending_inv_1_2_q_3*tmp_moved_constant_925 + jac_blending_inv_2_2_q_3*tmp_moved_constant_926))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_924 + jac_blending_inv_1_0_q_3*tmp_moved_constant_925 + jac_blending_inv_2_0_q_3*tmp_moved_constant_926) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_924 + jac_blending_inv_1_1_q_3*tmp_moved_constant_925 + jac_blending_inv_2_1_q_3*tmp_moved_constant_926) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_924 + jac_blending_inv_1_2_q_3*tmp_moved_constant_925 + jac_blending_inv_2_2_q_3*tmp_moved_constant_926))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_927 + jac_blending_inv_1_0_q_4*tmp_moved_constant_928 + jac_blending_inv_2_0_q_4*tmp_moved_constant_929) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_927 + jac_blending_inv_1_1_q_4*tmp_moved_constant_928 + jac_blending_inv_2_1_q_4*tmp_moved_constant_929) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_927 + jac_blending_inv_1_2_q_4*tmp_moved_constant_928 + jac_blending_inv_2_2_q_4*tmp_moved_constant_929))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_927 + jac_blending_inv_1_0_q_4*tmp_moved_constant_928 + jac_blending_inv_2_0_q_4*tmp_moved_constant_929) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_927 + jac_blending_inv_1_1_q_4*tmp_moved_constant_928 + jac_blending_inv_2_1_q_4*tmp_moved_constant_929) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_927 + jac_blending_inv_1_2_q_4*tmp_moved_constant_928 + jac_blending_inv_2_2_q_4*tmp_moved_constant_929))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_915 + jac_blending_inv_1_0_q_0*tmp_moved_constant_916 + jac_blending_inv_2_0_q_0*tmp_moved_constant_917) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_915 + jac_blending_inv_1_1_q_0*tmp_moved_constant_916 + jac_blending_inv_2_1_q_0*tmp_moved_constant_917) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_915 + jac_blending_inv_1_2_q_0*tmp_moved_constant_916 + jac_blending_inv_2_2_q_0*tmp_moved_constant_917))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_915 + jac_blending_inv_1_0_q_0*tmp_moved_constant_916 + jac_blending_inv_2_0_q_0*tmp_moved_constant_917) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_915 + jac_blending_inv_1_1_q_0*tmp_moved_constant_916 + jac_blending_inv_2_1_q_0*tmp_moved_constant_917) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_915 + jac_blending_inv_1_2_q_0*tmp_moved_constant_916 + jac_blending_inv_2_2_q_0*tmp_moved_constant_917))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_918 + jac_blending_inv_1_0_q_1*tmp_moved_constant_919 + jac_blending_inv_2_0_q_1*tmp_moved_constant_920) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_918 + jac_blending_inv_1_1_q_1*tmp_moved_constant_919 + jac_blending_inv_2_1_q_1*tmp_moved_constant_920) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_918 + jac_blending_inv_1_2_q_1*tmp_moved_constant_919 + jac_blending_inv_2_2_q_1*tmp_moved_constant_920))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_918 + jac_blending_inv_1_0_q_1*tmp_moved_constant_919 + jac_blending_inv_2_0_q_1*tmp_moved_constant_920) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_918 + jac_blending_inv_1_1_q_1*tmp_moved_constant_919 + jac_blending_inv_2_1_q_1*tmp_moved_constant_920) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_918 + jac_blending_inv_1_2_q_1*tmp_moved_constant_919 + jac_blending_inv_2_2_q_1*tmp_moved_constant_920))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_921 + jac_blending_inv_1_0_q_2*tmp_moved_constant_922 + jac_blending_inv_2_0_q_2*tmp_moved_constant_923) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_921 + jac_blending_inv_1_1_q_2*tmp_moved_constant_922 + jac_blending_inv_2_1_q_2*tmp_moved_constant_923) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_921 + jac_blending_inv_1_2_q_2*tmp_moved_constant_922 + jac_blending_inv_2_2_q_2*tmp_moved_constant_923))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_921 + jac_blending_inv_1_0_q_2*tmp_moved_constant_922 + jac_blending_inv_2_0_q_2*tmp_moved_constant_923) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_921 + jac_blending_inv_1_1_q_2*tmp_moved_constant_922 + jac_blending_inv_2_1_q_2*tmp_moved_constant_923) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_921 + jac_blending_inv_1_2_q_2*tmp_moved_constant_922 + jac_blending_inv_2_2_q_2*tmp_moved_constant_923)));
             const real_t elMatDiag_8 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_939 + jac_blending_inv_1_0_q_3*tmp_moved_constant_940 + jac_blending_inv_2_0_q_3*tmp_moved_constant_941) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_939 + jac_blending_inv_1_1_q_3*tmp_moved_constant_940 + jac_blending_inv_2_1_q_3*tmp_moved_constant_941) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_939 + jac_blending_inv_1_2_q_3*tmp_moved_constant_940 + jac_blending_inv_2_2_q_3*tmp_moved_constant_941))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_939 + jac_blending_inv_1_0_q_3*tmp_moved_constant_940 + jac_blending_inv_2_0_q_3*tmp_moved_constant_941) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_939 + jac_blending_inv_1_1_q_3*tmp_moved_constant_940 + jac_blending_inv_2_1_q_3*tmp_moved_constant_941) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_939 + jac_blending_inv_1_2_q_3*tmp_moved_constant_940 + jac_blending_inv_2_2_q_3*tmp_moved_constant_941))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_942 + jac_blending_inv_1_0_q_4*tmp_moved_constant_943 + jac_blending_inv_2_0_q_4*tmp_moved_constant_944) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_942 + jac_blending_inv_1_1_q_4*tmp_moved_constant_943 + jac_blending_inv_2_1_q_4*tmp_moved_constant_944) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_942 + jac_blending_inv_1_2_q_4*tmp_moved_constant_943 + jac_blending_inv_2_2_q_4*tmp_moved_constant_944))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_942 + jac_blending_inv_1_0_q_4*tmp_moved_constant_943 + jac_blending_inv_2_0_q_4*tmp_moved_constant_944) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_942 + jac_blending_inv_1_1_q_4*tmp_moved_constant_943 + jac_blending_inv_2_1_q_4*tmp_moved_constant_944) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_942 + jac_blending_inv_1_2_q_4*tmp_moved_constant_943 + jac_blending_inv_2_2_q_4*tmp_moved_constant_944))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_930 + jac_blending_inv_1_0_q_0*tmp_moved_constant_931 + jac_blending_inv_2_0_q_0*tmp_moved_constant_932) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_930 + jac_blending_inv_1_1_q_0*tmp_moved_constant_931 + jac_blending_inv_2_1_q_0*tmp_moved_constant_932) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_930 + jac_blending_inv_1_2_q_0*tmp_moved_constant_931 + jac_blending_inv_2_2_q_0*tmp_moved_constant_932))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_930 + jac_blending_inv_1_0_q_0*tmp_moved_constant_931 + jac_blending_inv_2_0_q_0*tmp_moved_constant_932) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_930 + jac_blending_inv_1_1_q_0*tmp_moved_constant_931 + jac_blending_inv_2_1_q_0*tmp_moved_constant_932) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_930 + jac_blending_inv_1_2_q_0*tmp_moved_constant_931 + jac_blending_inv_2_2_q_0*tmp_moved_constant_932))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_933 + jac_blending_inv_1_0_q_1*tmp_moved_constant_934 + jac_blending_inv_2_0_q_1*tmp_moved_constant_935) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_933 + jac_blending_inv_1_1_q_1*tmp_moved_constant_934 + jac_blending_inv_2_1_q_1*tmp_moved_constant_935) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_933 + jac_blending_inv_1_2_q_1*tmp_moved_constant_934 + jac_blending_inv_2_2_q_1*tmp_moved_constant_935))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_933 + jac_blending_inv_1_0_q_1*tmp_moved_constant_934 + jac_blending_inv_2_0_q_1*tmp_moved_constant_935) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_933 + jac_blending_inv_1_1_q_1*tmp_moved_constant_934 + jac_blending_inv_2_1_q_1*tmp_moved_constant_935) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_933 + jac_blending_inv_1_2_q_1*tmp_moved_constant_934 + jac_blending_inv_2_2_q_1*tmp_moved_constant_935))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_936 + jac_blending_inv_1_0_q_2*tmp_moved_constant_937 + jac_blending_inv_2_0_q_2*tmp_moved_constant_938) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_936 + jac_blending_inv_1_1_q_2*tmp_moved_constant_937 + jac_blending_inv_2_1_q_2*tmp_moved_constant_938) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_936 + jac_blending_inv_1_2_q_2*tmp_moved_constant_937 + jac_blending_inv_2_2_q_2*tmp_moved_constant_938))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_936 + jac_blending_inv_1_0_q_2*tmp_moved_constant_937 + jac_blending_inv_2_0_q_2*tmp_moved_constant_938) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_936 + jac_blending_inv_1_1_q_2*tmp_moved_constant_937 + jac_blending_inv_2_1_q_2*tmp_moved_constant_938) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_936 + jac_blending_inv_1_2_q_2*tmp_moved_constant_937 + jac_blending_inv_2_2_q_2*tmp_moved_constant_938)));
             const real_t elMatDiag_9 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_954 + jac_blending_inv_1_0_q_3*tmp_moved_constant_955 + jac_blending_inv_2_0_q_3*tmp_moved_constant_956) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_954 + jac_blending_inv_1_1_q_3*tmp_moved_constant_955 + jac_blending_inv_2_1_q_3*tmp_moved_constant_956) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_954 + jac_blending_inv_1_2_q_3*tmp_moved_constant_955 + jac_blending_inv_2_2_q_3*tmp_moved_constant_956))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_954 + jac_blending_inv_1_0_q_3*tmp_moved_constant_955 + jac_blending_inv_2_0_q_3*tmp_moved_constant_956) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_954 + jac_blending_inv_1_1_q_3*tmp_moved_constant_955 + jac_blending_inv_2_1_q_3*tmp_moved_constant_956) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_954 + jac_blending_inv_1_2_q_3*tmp_moved_constant_955 + jac_blending_inv_2_2_q_3*tmp_moved_constant_956))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_957 + jac_blending_inv_1_0_q_4*tmp_moved_constant_958 + jac_blending_inv_2_0_q_4*tmp_moved_constant_959) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_957 + jac_blending_inv_1_1_q_4*tmp_moved_constant_958 + jac_blending_inv_2_1_q_4*tmp_moved_constant_959) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_957 + jac_blending_inv_1_2_q_4*tmp_moved_constant_958 + jac_blending_inv_2_2_q_4*tmp_moved_constant_959))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_957 + jac_blending_inv_1_0_q_4*tmp_moved_constant_958 + jac_blending_inv_2_0_q_4*tmp_moved_constant_959) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_957 + jac_blending_inv_1_1_q_4*tmp_moved_constant_958 + jac_blending_inv_2_1_q_4*tmp_moved_constant_959) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_957 + jac_blending_inv_1_2_q_4*tmp_moved_constant_958 + jac_blending_inv_2_2_q_4*tmp_moved_constant_959))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_945 + jac_blending_inv_1_0_q_0*tmp_moved_constant_946 + jac_blending_inv_2_0_q_0*tmp_moved_constant_947) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_945 + jac_blending_inv_1_1_q_0*tmp_moved_constant_946 + jac_blending_inv_2_1_q_0*tmp_moved_constant_947) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_945 + jac_blending_inv_1_2_q_0*tmp_moved_constant_946 + jac_blending_inv_2_2_q_0*tmp_moved_constant_947))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_945 + jac_blending_inv_1_0_q_0*tmp_moved_constant_946 + jac_blending_inv_2_0_q_0*tmp_moved_constant_947) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_945 + jac_blending_inv_1_1_q_0*tmp_moved_constant_946 + jac_blending_inv_2_1_q_0*tmp_moved_constant_947) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_945 + jac_blending_inv_1_2_q_0*tmp_moved_constant_946 + jac_blending_inv_2_2_q_0*tmp_moved_constant_947))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_948 + jac_blending_inv_1_0_q_1*tmp_moved_constant_949 + jac_blending_inv_2_0_q_1*tmp_moved_constant_950) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_948 + jac_blending_inv_1_1_q_1*tmp_moved_constant_949 + jac_blending_inv_2_1_q_1*tmp_moved_constant_950) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_948 + jac_blending_inv_1_2_q_1*tmp_moved_constant_949 + jac_blending_inv_2_2_q_1*tmp_moved_constant_950))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_948 + jac_blending_inv_1_0_q_1*tmp_moved_constant_949 + jac_blending_inv_2_0_q_1*tmp_moved_constant_950) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_948 + jac_blending_inv_1_1_q_1*tmp_moved_constant_949 + jac_blending_inv_2_1_q_1*tmp_moved_constant_950) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_948 + jac_blending_inv_1_2_q_1*tmp_moved_constant_949 + jac_blending_inv_2_2_q_1*tmp_moved_constant_950))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_951 + jac_blending_inv_1_0_q_2*tmp_moved_constant_952 + jac_blending_inv_2_0_q_2*tmp_moved_constant_953) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_951 + jac_blending_inv_1_1_q_2*tmp_moved_constant_952 + jac_blending_inv_2_1_q_2*tmp_moved_constant_953) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_951 + jac_blending_inv_1_2_q_2*tmp_moved_constant_952 + jac_blending_inv_2_2_q_2*tmp_moved_constant_953))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_951 + jac_blending_inv_1_0_q_2*tmp_moved_constant_952 + jac_blending_inv_2_0_q_2*tmp_moved_constant_953) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_951 + jac_blending_inv_1_1_q_2*tmp_moved_constant_952 + jac_blending_inv_2_1_q_2*tmp_moved_constant_953) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_951 + jac_blending_inv_1_2_q_2*tmp_moved_constant_952 + jac_blending_inv_2_2_q_2*tmp_moved_constant_953)));
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const real_t tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const real_t tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_11_GREEN_DOWN = jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
       const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const real_t tmp_coords_jac_10_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_0_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
       const real_t tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const real_t jac_affine_inv_0_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
       const real_t jac_affine_inv_0_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const real_t jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const real_t jac_affine_inv_1_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       const real_t tmp_moved_constant_960 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_4 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_4 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_4;
       const real_t tmp_moved_constant_961 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_4 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_4 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_4;
       const real_t tmp_moved_constant_962 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_4 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_4 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_4;
       const real_t tmp_moved_constant_963 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_33 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_33 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_33;
       const real_t tmp_moved_constant_964 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_33 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_33 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_33;
       const real_t tmp_moved_constant_965 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_33 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_33 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_33;
       const real_t tmp_moved_constant_966 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_62 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_62 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_62;
       const real_t tmp_moved_constant_967 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_62 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_62 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_62;
       const real_t tmp_moved_constant_968 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_62 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_62 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_62;
       const real_t tmp_moved_constant_969 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_91 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_91 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_91;
       const real_t tmp_moved_constant_970 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_91 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_91 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_91;
       const real_t tmp_moved_constant_971 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_91 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_91 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_91;
       const real_t tmp_moved_constant_972 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_120 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_120 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_120;
       const real_t tmp_moved_constant_973 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_120 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_120 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_120;
       const real_t tmp_moved_constant_974 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_120 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_120 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_120;
       const real_t tmp_moved_constant_975 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_145;
       const real_t tmp_moved_constant_976 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_145;
       const real_t tmp_moved_constant_977 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_145;
       const real_t tmp_moved_constant_978 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_149;
       const real_t tmp_moved_constant_979 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_149;
       const real_t tmp_moved_constant_980 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_149;
       const real_t tmp_moved_constant_981 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_153;
       const real_t tmp_moved_constant_982 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_153;
       const real_t tmp_moved_constant_983 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_153;
       const real_t tmp_moved_constant_984 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_157;
       const real_t tmp_moved_constant_985 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_157;
       const real_t tmp_moved_constant_986 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_157;
       const real_t tmp_moved_constant_987 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_161;
       const real_t tmp_moved_constant_988 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_161;
       const real_t tmp_moved_constant_989 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_161;
       const real_t tmp_moved_constant_990 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_165;
       const real_t tmp_moved_constant_991 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_165;
       const real_t tmp_moved_constant_992 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_165;
       const real_t tmp_moved_constant_993 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_169;
       const real_t tmp_moved_constant_994 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_169;
       const real_t tmp_moved_constant_995 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_169;
       const real_t tmp_moved_constant_996 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_173;
       const real_t tmp_moved_constant_997 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_173;
       const real_t tmp_moved_constant_998 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_173;
       const real_t tmp_moved_constant_999 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_177;
       const real_t tmp_moved_constant_1000 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_177;
       const real_t tmp_moved_constant_1001 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_177;
       const real_t tmp_moved_constant_1002 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_181;
       const real_t tmp_moved_constant_1003 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_181;
       const real_t tmp_moved_constant_1004 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_181;
       const real_t tmp_moved_constant_1005 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_185;
       const real_t tmp_moved_constant_1006 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_185;
       const real_t tmp_moved_constant_1007 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_185;
       const real_t tmp_moved_constant_1008 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_189;
       const real_t tmp_moved_constant_1009 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_189;
       const real_t tmp_moved_constant_1010 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_189;
       const real_t tmp_moved_constant_1011 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_193;
       const real_t tmp_moved_constant_1012 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_193;
       const real_t tmp_moved_constant_1013 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_193;
       const real_t tmp_moved_constant_1014 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_197;
       const real_t tmp_moved_constant_1015 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_197;
       const real_t tmp_moved_constant_1016 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_197;
       const real_t tmp_moved_constant_1017 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_201;
       const real_t tmp_moved_constant_1018 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_201;
       const real_t tmp_moved_constant_1019 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_201;
       const real_t tmp_moved_constant_1020 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_1021 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_1022 = tmp_moved_constant_1020 + tmp_moved_constant_1021;
       const real_t tmp_moved_constant_1023 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_1024 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_1025 = tmp_moved_constant_1023 + tmp_moved_constant_1024;
       const real_t tmp_moved_constant_1026 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_1027 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_1028 = tmp_moved_constant_1026 + tmp_moved_constant_1027;
       const real_t tmp_moved_constant_1029 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_1030 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_1031 = tmp_moved_constant_1029 + tmp_moved_constant_1030;
       const real_t tmp_moved_constant_1032 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_1033 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_1034 = tmp_moved_constant_1032 + tmp_moved_constant_1033;
       const real_t tmp_moved_constant_1035 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_1036 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_1037 = tmp_moved_constant_1035 + tmp_moved_constant_1036;
       const real_t tmp_moved_constant_1038 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_58;
       const real_t tmp_moved_constant_1039 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_60;
       const real_t tmp_moved_constant_1040 = tmp_moved_constant_1038 + tmp_moved_constant_1039;
       const real_t tmp_moved_constant_1041 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_58;
       const real_t tmp_moved_constant_1042 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_60;
       const real_t tmp_moved_constant_1043 = tmp_moved_constant_1041 + tmp_moved_constant_1042;
       const real_t tmp_moved_constant_1044 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_58;
       const real_t tmp_moved_constant_1045 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_60;
       const real_t tmp_moved_constant_1046 = tmp_moved_constant_1044 + tmp_moved_constant_1045;
       const real_t tmp_moved_constant_1047 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_87;
       const real_t tmp_moved_constant_1048 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_1049 = tmp_moved_constant_1047 + tmp_moved_constant_1048;
       const real_t tmp_moved_constant_1050 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_87;
       const real_t tmp_moved_constant_1051 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_1052 = tmp_moved_constant_1050 + tmp_moved_constant_1051;
       const real_t tmp_moved_constant_1053 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_87;
       const real_t tmp_moved_constant_1054 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_1055 = tmp_moved_constant_1053 + tmp_moved_constant_1054;
       const real_t tmp_moved_constant_1056 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_116;
       const real_t tmp_moved_constant_1057 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_118;
       const real_t tmp_moved_constant_1058 = tmp_moved_constant_1056 + tmp_moved_constant_1057;
       const real_t tmp_moved_constant_1059 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_116;
       const real_t tmp_moved_constant_1060 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_118;
       const real_t tmp_moved_constant_1061 = tmp_moved_constant_1059 + tmp_moved_constant_1060;
       const real_t tmp_moved_constant_1062 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_116;
       const real_t tmp_moved_constant_1063 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_118;
       const real_t tmp_moved_constant_1064 = tmp_moved_constant_1062 + tmp_moved_constant_1063;
       const real_t tmp_moved_constant_1065 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_1066 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_1067 = tmp_moved_constant_1065 + tmp_moved_constant_1066;
       const real_t tmp_moved_constant_1068 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_1069 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_1070 = tmp_moved_constant_1068 + tmp_moved_constant_1069;
       const real_t tmp_moved_constant_1071 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_1072 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_1073 = tmp_moved_constant_1071 + tmp_moved_constant_1072;
       const real_t tmp_moved_constant_1074 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_1075 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_1076 = tmp_moved_constant_1074 + tmp_moved_constant_1075;
       const real_t tmp_moved_constant_1077 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_1078 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_1079 = tmp_moved_constant_1077 + tmp_moved_constant_1078;
       const real_t tmp_moved_constant_1080 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_1081 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_1082 = tmp_moved_constant_1080 + tmp_moved_constant_1081;
       const real_t tmp_moved_constant_1083 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_58;
       const real_t tmp_moved_constant_1084 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_59;
       const real_t tmp_moved_constant_1085 = tmp_moved_constant_1083 + tmp_moved_constant_1084;
       const real_t tmp_moved_constant_1086 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_58;
       const real_t tmp_moved_constant_1087 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_59;
       const real_t tmp_moved_constant_1088 = tmp_moved_constant_1086 + tmp_moved_constant_1087;
       const real_t tmp_moved_constant_1089 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_58;
       const real_t tmp_moved_constant_1090 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_59;
       const real_t tmp_moved_constant_1091 = tmp_moved_constant_1089 + tmp_moved_constant_1090;
       const real_t tmp_moved_constant_1092 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_87;
       const real_t tmp_moved_constant_1093 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_88;
       const real_t tmp_moved_constant_1094 = tmp_moved_constant_1092 + tmp_moved_constant_1093;
       const real_t tmp_moved_constant_1095 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_87;
       const real_t tmp_moved_constant_1096 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_88;
       const real_t tmp_moved_constant_1097 = tmp_moved_constant_1095 + tmp_moved_constant_1096;
       const real_t tmp_moved_constant_1098 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_87;
       const real_t tmp_moved_constant_1099 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_88;
       const real_t tmp_moved_constant_1100 = tmp_moved_constant_1098 + tmp_moved_constant_1099;
       const real_t tmp_moved_constant_1101 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_116;
       const real_t tmp_moved_constant_1102 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_117;
       const real_t tmp_moved_constant_1103 = tmp_moved_constant_1101 + tmp_moved_constant_1102;
       const real_t tmp_moved_constant_1104 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_116;
       const real_t tmp_moved_constant_1105 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_117;
       const real_t tmp_moved_constant_1106 = tmp_moved_constant_1104 + tmp_moved_constant_1105;
       const real_t tmp_moved_constant_1107 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_116;
       const real_t tmp_moved_constant_1108 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_117;
       const real_t tmp_moved_constant_1109 = tmp_moved_constant_1107 + tmp_moved_constant_1108;
       const real_t tmp_moved_constant_1110 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_1111 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_1112 = tmp_moved_constant_1110 + tmp_moved_constant_1111;
       const real_t tmp_moved_constant_1113 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_1114 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_1115 = tmp_moved_constant_1113 + tmp_moved_constant_1114;
       const real_t tmp_moved_constant_1116 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_1117 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_1118 = tmp_moved_constant_1116 + tmp_moved_constant_1117;
       const real_t tmp_moved_constant_1119 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_1120 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_1121 = tmp_moved_constant_1119 + tmp_moved_constant_1120;
       const real_t tmp_moved_constant_1122 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_1123 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_1124 = tmp_moved_constant_1122 + tmp_moved_constant_1123;
       const real_t tmp_moved_constant_1125 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_1126 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_30;
       const real_t tmp_moved_constant_1127 = tmp_moved_constant_1125 + tmp_moved_constant_1126;
       const real_t tmp_moved_constant_1128 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_60;
       const real_t tmp_moved_constant_1129 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_59;
       const real_t tmp_moved_constant_1130 = tmp_moved_constant_1128 + tmp_moved_constant_1129;
       const real_t tmp_moved_constant_1131 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_60;
       const real_t tmp_moved_constant_1132 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_59;
       const real_t tmp_moved_constant_1133 = tmp_moved_constant_1131 + tmp_moved_constant_1132;
       const real_t tmp_moved_constant_1134 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_60;
       const real_t tmp_moved_constant_1135 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_59;
       const real_t tmp_moved_constant_1136 = tmp_moved_constant_1134 + tmp_moved_constant_1135;
       const real_t tmp_moved_constant_1137 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_1138 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_88;
       const real_t tmp_moved_constant_1139 = tmp_moved_constant_1137 + tmp_moved_constant_1138;
       const real_t tmp_moved_constant_1140 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_1141 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_88;
       const real_t tmp_moved_constant_1142 = tmp_moved_constant_1140 + tmp_moved_constant_1141;
       const real_t tmp_moved_constant_1143 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_1144 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_88;
       const real_t tmp_moved_constant_1145 = tmp_moved_constant_1143 + tmp_moved_constant_1144;
       const real_t tmp_moved_constant_1146 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_118;
       const real_t tmp_moved_constant_1147 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_117;
       const real_t tmp_moved_constant_1148 = tmp_moved_constant_1146 + tmp_moved_constant_1147;
       const real_t tmp_moved_constant_1149 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_118;
       const real_t tmp_moved_constant_1150 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_117;
       const real_t tmp_moved_constant_1151 = tmp_moved_constant_1149 + tmp_moved_constant_1150;
       const real_t tmp_moved_constant_1152 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_118;
       const real_t tmp_moved_constant_1153 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_117;
       const real_t tmp_moved_constant_1154 = tmp_moved_constant_1152 + tmp_moved_constant_1153;
       const real_t tmp_moved_constant_1155 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_340 - tmp_moved_constant_1020 - tmp_moved_constant_1065;
       const real_t tmp_moved_constant_1156 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_340 - tmp_moved_constant_1023 - tmp_moved_constant_1068;
       const real_t tmp_moved_constant_1157 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_340 - tmp_moved_constant_1026 - tmp_moved_constant_1071;
       const real_t tmp_moved_constant_1158 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_344 - tmp_moved_constant_1029 - tmp_moved_constant_1074;
       const real_t tmp_moved_constant_1159 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_344 - tmp_moved_constant_1032 - tmp_moved_constant_1077;
       const real_t tmp_moved_constant_1160 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_344 - tmp_moved_constant_1035 - tmp_moved_constant_1080;
       const real_t tmp_moved_constant_1161 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_348 - tmp_moved_constant_1038 - tmp_moved_constant_1083;
       const real_t tmp_moved_constant_1162 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_348 - tmp_moved_constant_1041 - tmp_moved_constant_1086;
       const real_t tmp_moved_constant_1163 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_348 - tmp_moved_constant_1044 - tmp_moved_constant_1089;
       const real_t tmp_moved_constant_1164 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_352 - tmp_moved_constant_1047 - tmp_moved_constant_1092;
       const real_t tmp_moved_constant_1165 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_352 - tmp_moved_constant_1050 - tmp_moved_constant_1095;
       const real_t tmp_moved_constant_1166 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_352 - tmp_moved_constant_1053 - tmp_moved_constant_1098;
       const real_t tmp_moved_constant_1167 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_356 - tmp_moved_constant_1056 - tmp_moved_constant_1101;
       const real_t tmp_moved_constant_1168 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_356 - tmp_moved_constant_1059 - tmp_moved_constant_1104;
       const real_t tmp_moved_constant_1169 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_356 - tmp_moved_constant_1062 - tmp_moved_constant_1107;
       const real_t tmp_moved_constant_1170 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_361 - tmp_moved_constant_1021 - tmp_moved_constant_1110;
       const real_t tmp_moved_constant_1171 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_361 - tmp_moved_constant_1024 - tmp_moved_constant_1113;
       const real_t tmp_moved_constant_1172 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_361 - tmp_moved_constant_1027 - tmp_moved_constant_1116;
       const real_t tmp_moved_constant_1173 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_366 - tmp_moved_constant_1030 - tmp_moved_constant_1119;
       const real_t tmp_moved_constant_1174 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_366 - tmp_moved_constant_1033 - tmp_moved_constant_1122;
       const real_t tmp_moved_constant_1175 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_366 - tmp_moved_constant_1036 - tmp_moved_constant_1125;
       const real_t tmp_moved_constant_1176 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_371 - tmp_moved_constant_1039 - tmp_moved_constant_1128;
       const real_t tmp_moved_constant_1177 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_371 - tmp_moved_constant_1042 - tmp_moved_constant_1131;
       const real_t tmp_moved_constant_1178 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_371 - tmp_moved_constant_1045 - tmp_moved_constant_1134;
       const real_t tmp_moved_constant_1179 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_376 - tmp_moved_constant_1048 - tmp_moved_constant_1137;
       const real_t tmp_moved_constant_1180 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_376 - tmp_moved_constant_1051 - tmp_moved_constant_1140;
       const real_t tmp_moved_constant_1181 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_376 - tmp_moved_constant_1054 - tmp_moved_constant_1143;
       const real_t tmp_moved_constant_1182 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_381 - tmp_moved_constant_1057 - tmp_moved_constant_1146;
       const real_t tmp_moved_constant_1183 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_381 - tmp_moved_constant_1060 - tmp_moved_constant_1149;
       const real_t tmp_moved_constant_1184 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_381 - tmp_moved_constant_1063 - tmp_moved_constant_1152;
       const real_t tmp_moved_constant_1185 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_385 - tmp_moved_constant_1066 - tmp_moved_constant_1111;
       const real_t tmp_moved_constant_1186 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_385 - tmp_moved_constant_1069 - tmp_moved_constant_1114;
       const real_t tmp_moved_constant_1187 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_385 - tmp_moved_constant_1072 - tmp_moved_constant_1117;
       const real_t tmp_moved_constant_1188 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_389 - tmp_moved_constant_1075 - tmp_moved_constant_1120;
       const real_t tmp_moved_constant_1189 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_389 - tmp_moved_constant_1078 - tmp_moved_constant_1123;
       const real_t tmp_moved_constant_1190 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_389 - tmp_moved_constant_1081 - tmp_moved_constant_1126;
       const real_t tmp_moved_constant_1191 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_393 - tmp_moved_constant_1084 - tmp_moved_constant_1129;
       const real_t tmp_moved_constant_1192 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_393 - tmp_moved_constant_1087 - tmp_moved_constant_1132;
       const real_t tmp_moved_constant_1193 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_393 - tmp_moved_constant_1090 - tmp_moved_constant_1135;
       const real_t tmp_moved_constant_1194 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_397 - tmp_moved_constant_1093 - tmp_moved_constant_1138;
       const real_t tmp_moved_constant_1195 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_397 - tmp_moved_constant_1096 - tmp_moved_constant_1141;
       const real_t tmp_moved_constant_1196 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_397 - tmp_moved_constant_1099 - tmp_moved_constant_1144;
       const real_t tmp_moved_constant_1197 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_401 - tmp_moved_constant_1102 - tmp_moved_constant_1147;
       const real_t tmp_moved_constant_1198 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_401 - tmp_moved_constant_1105 - tmp_moved_constant_1150;
       const real_t tmp_moved_constant_1199 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_401 - tmp_moved_constant_1108 - tmp_moved_constant_1153;
       {
          /* CellType.GREEN_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
             const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
             const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
             const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
             const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
             const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
             const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
             const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
             const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
             const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
             const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
             const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
             const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
             const real_t tmp_blending_op_35 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_36 = -tmp_blending_op_35;
             const real_t tmp_blending_op_37 = (tmp_blending_op_28*tmp_blending_op_28);
             const real_t tmp_blending_op_38 = (tmp_blending_op_33*tmp_blending_op_33);
             const real_t tmp_blending_op_39 = tmp_blending_op_37 + tmp_blending_op_38 + tmp_blending_op_4;
             const real_t tmp_blending_op_42 = pow(tmp_blending_op_39, -1.5000000000000000)*tmp_blending_op_41;
             const real_t tmp_blending_op_44 = tmp_blending_op_23*tmp_blending_op_39;
             const real_t tmp_blending_op_45 = -tmp_blending_op_33*tmp_blending_op_35 - tmp_blending_op_43*tmp_blending_op_44;
             const real_t tmp_blending_op_46 = tmp_blending_op_3*tmp_blending_op_42;
             const real_t tmp_blending_op_48 = tmp_blending_op_28*tmp_blending_op_36 + tmp_blending_op_44*tmp_blending_op_47;
             const real_t tmp_blending_op_49 = tmp_blending_op_3*tmp_blending_op_36 + tmp_blending_op_39*tmp_blending_op_40;
             const real_t tmp_blending_op_50 = tmp_blending_op_33*tmp_blending_op_42;
             const real_t tmp_blending_op_52 = tmp_blending_op_28*tmp_blending_op_42;
             const real_t tmp_blending_op_61 = p_affine_0_2 + tmp_blending_op_0*0.5 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_62 = (tmp_blending_op_61*tmp_blending_op_61);
             const real_t tmp_blending_op_63 = -tmp_blending_op_17 - tmp_blending_op_61;
             const real_t tmp_blending_op_64 = p_affine_0_0 + tmp_blending_op_25*0.5 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_65 = -tmp_blending_op_6 - tmp_blending_op_64;
             const real_t tmp_blending_op_66 = p_affine_0_1 + tmp_blending_op_30*0.5 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_67 = -tmp_blending_op_13 - tmp_blending_op_66;
             const real_t tmp_blending_op_68 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_65 - tmp_blending_op_12*tmp_blending_op_63 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_63 - tmp_blending_op_19*tmp_blending_op_65 - tmp_blending_op_20*tmp_blending_op_67 + tmp_blending_op_67*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_69 = -tmp_blending_op_68;
             const real_t tmp_blending_op_70 = (tmp_blending_op_64*tmp_blending_op_64);
             const real_t tmp_blending_op_71 = (tmp_blending_op_66*tmp_blending_op_66);
             const real_t tmp_blending_op_72 = tmp_blending_op_62 + tmp_blending_op_70 + tmp_blending_op_71;
             const real_t tmp_blending_op_73 = tmp_blending_op_41*pow(tmp_blending_op_72, -1.5000000000000000);
             const real_t tmp_blending_op_75 = -tmp_blending_op_66*tmp_blending_op_68 - tmp_blending_op_72*tmp_blending_op_74;
             const real_t tmp_blending_op_76 = tmp_blending_op_61*tmp_blending_op_73;
             const real_t tmp_blending_op_77 = tmp_blending_op_53*tmp_blending_op_72 + tmp_blending_op_64*tmp_blending_op_69;
             const real_t tmp_blending_op_78 = tmp_blending_op_40*tmp_blending_op_72 + tmp_blending_op_61*tmp_blending_op_69;
             const real_t tmp_blending_op_79 = tmp_blending_op_66*tmp_blending_op_73;
             const real_t tmp_blending_op_80 = tmp_blending_op_64*tmp_blending_op_73;
             const real_t tmp_blending_op_88 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.5 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_89 = (tmp_blending_op_88*tmp_blending_op_88);
             const real_t tmp_blending_op_90 = -tmp_blending_op_17 - tmp_blending_op_88;
             const real_t tmp_blending_op_91 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.5 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_92 = -tmp_blending_op_6 - tmp_blending_op_91;
             const real_t tmp_blending_op_93 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.5 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_94 = -tmp_blending_op_13 - tmp_blending_op_93;
             const real_t tmp_blending_op_95 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_92 - tmp_blending_op_12*tmp_blending_op_90 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_90 - tmp_blending_op_19*tmp_blending_op_92 - tmp_blending_op_20*tmp_blending_op_94 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_94);
             const real_t tmp_blending_op_96 = -tmp_blending_op_95;
             const real_t tmp_blending_op_97 = (tmp_blending_op_91*tmp_blending_op_91);
             const real_t tmp_blending_op_98 = (tmp_blending_op_93*tmp_blending_op_93);
             const real_t tmp_blending_op_99 = tmp_blending_op_89 + tmp_blending_op_97 + tmp_blending_op_98;
             const real_t tmp_blending_op_100 = tmp_blending_op_41*pow(tmp_blending_op_99, -1.5000000000000000);
             const real_t tmp_blending_op_101 = -tmp_blending_op_74*tmp_blending_op_99 - tmp_blending_op_93*tmp_blending_op_95;
             const real_t tmp_blending_op_102 = tmp_blending_op_100*tmp_blending_op_88;
             const real_t tmp_blending_op_103 = tmp_blending_op_53*tmp_blending_op_99 + tmp_blending_op_91*tmp_blending_op_96;
             const real_t tmp_blending_op_104 = tmp_blending_op_40*tmp_blending_op_99 + tmp_blending_op_88*tmp_blending_op_96;
             const real_t tmp_blending_op_105 = tmp_blending_op_100*tmp_blending_op_93;
             const real_t tmp_blending_op_106 = tmp_blending_op_100*tmp_blending_op_91;
             const real_t tmp_blending_op_114 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.5;
             const real_t tmp_blending_op_115 = (tmp_blending_op_114*tmp_blending_op_114);
             const real_t tmp_blending_op_116 = -tmp_blending_op_114 - tmp_blending_op_17;
             const real_t tmp_blending_op_117 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.5;
             const real_t tmp_blending_op_118 = -tmp_blending_op_117 - tmp_blending_op_6;
             const real_t tmp_blending_op_119 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.5;
             const real_t tmp_blending_op_120 = -tmp_blending_op_119 - tmp_blending_op_13;
             const real_t tmp_blending_op_121 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_118*tmp_blending_op_18 - tmp_blending_op_116*tmp_blending_op_12 + tmp_blending_op_116*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_118*tmp_blending_op_19 - tmp_blending_op_120*tmp_blending_op_20 + tmp_blending_op_120*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_122 = -tmp_blending_op_121;
             const real_t tmp_blending_op_123 = (tmp_blending_op_117*tmp_blending_op_117);
             const real_t tmp_blending_op_124 = (tmp_blending_op_119*tmp_blending_op_119);
             const real_t tmp_blending_op_125 = tmp_blending_op_115 + tmp_blending_op_123 + tmp_blending_op_124;
             const real_t tmp_blending_op_126 = pow(tmp_blending_op_125, -1.5000000000000000)*tmp_blending_op_41;
             const real_t tmp_blending_op_127 = -tmp_blending_op_119*tmp_blending_op_121 - tmp_blending_op_125*tmp_blending_op_74;
             const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_126;
             const real_t tmp_blending_op_129 = tmp_blending_op_117*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_53;
             const real_t tmp_blending_op_130 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_40;
             const real_t tmp_blending_op_131 = tmp_blending_op_119*tmp_blending_op_126;
             const real_t tmp_blending_op_132 = tmp_blending_op_117*tmp_blending_op_126;
             const real_t tmp_blending_op_140 = p_affine_0_2 + tmp_blending_op_0*0.25 + tmp_blending_op_1*0.25 + tmp_blending_op_2*0.25;
             const real_t tmp_blending_op_141 = (tmp_blending_op_140*tmp_blending_op_140);
             const real_t tmp_blending_op_142 = -tmp_blending_op_140 - tmp_blending_op_17;
             const real_t tmp_blending_op_143 = p_affine_0_0 + tmp_blending_op_25*0.25 + tmp_blending_op_26*0.25 + tmp_blending_op_27*0.25;
             const real_t tmp_blending_op_144 = -tmp_blending_op_143 - tmp_blending_op_6;
             const real_t tmp_blending_op_145 = p_affine_0_1 + tmp_blending_op_30*0.25 + tmp_blending_op_31*0.25 + tmp_blending_op_32*0.25;
             const real_t tmp_blending_op_146 = -tmp_blending_op_13 - tmp_blending_op_145;
             const real_t tmp_blending_op_147 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_144*tmp_blending_op_18 - tmp_blending_op_12*tmp_blending_op_142 + tmp_blending_op_14*tmp_blending_op_142*tmp_blending_op_15 - tmp_blending_op_144*tmp_blending_op_19 - tmp_blending_op_146*tmp_blending_op_20 + tmp_blending_op_146*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_148 = -tmp_blending_op_147;
             const real_t tmp_blending_op_149 = (tmp_blending_op_143*tmp_blending_op_143);
             const real_t tmp_blending_op_150 = (tmp_blending_op_145*tmp_blending_op_145);
             const real_t tmp_blending_op_151 = tmp_blending_op_141 + tmp_blending_op_149 + tmp_blending_op_150;
             const real_t tmp_blending_op_152 = pow(tmp_blending_op_151, -1.5000000000000000)*tmp_blending_op_41;
             const real_t tmp_blending_op_153 = -tmp_blending_op_145*tmp_blending_op_147 - tmp_blending_op_151*tmp_blending_op_74;
             const real_t tmp_blending_op_154 = tmp_blending_op_140*tmp_blending_op_152;
             const real_t tmp_blending_op_155 = tmp_blending_op_143*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_53;
             const real_t tmp_blending_op_156 = tmp_blending_op_140*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_40;
             const real_t tmp_blending_op_157 = tmp_blending_op_145*tmp_blending_op_152;
             const real_t tmp_blending_op_158 = tmp_blending_op_143*tmp_blending_op_152;
             const real_t jac_blending_2_2_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_4 + tmp_blending_op_39*(tmp_blending_op_3*tmp_blending_op_40 + tmp_blending_op_35));
             const real_t jac_blending_2_1_q_4 = tmp_blending_op_45*tmp_blending_op_46;
             const real_t jac_blending_2_0_q_4 = tmp_blending_op_46*tmp_blending_op_48;
             const real_t jac_blending_1_2_q_4 = tmp_blending_op_49*tmp_blending_op_50;
             const real_t jac_blending_1_1_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_39*(tmp_blending_op_33*tmp_blending_op_51 + tmp_blending_op_35));
             const real_t tmp_blending_op_58 = jac_blending_1_1_q_4*jac_blending_2_0_q_4;
             const real_t jac_blending_1_0_q_4 = tmp_blending_op_48*tmp_blending_op_50;
             const real_t tmp_blending_op_55 = jac_blending_1_0_q_4*jac_blending_2_1_q_4;
             const real_t jac_blending_0_2_q_4 = tmp_blending_op_49*tmp_blending_op_52;
             const real_t jac_blending_0_1_q_4 = tmp_blending_op_45*tmp_blending_op_52;
             const real_t tmp_blending_op_57 = jac_blending_0_1_q_4*jac_blending_1_0_q_4;
             const real_t jac_blending_0_0_q_4 = tmp_blending_op_42*(-tmp_blending_op_35*tmp_blending_op_37 + tmp_blending_op_39*(tmp_blending_op_28*tmp_blending_op_53 + tmp_blending_op_35));
             const real_t tmp_blending_op_54 = jac_blending_0_0_q_4*jac_blending_1_1_q_4;
             const real_t tmp_blending_op_56 = jac_blending_0_0_q_4*jac_blending_2_1_q_4;
             const real_t tmp_blending_op_59 = jac_blending_0_1_q_4*jac_blending_1_2_q_4*jac_blending_2_0_q_4 + jac_blending_0_2_q_4*tmp_blending_op_55 - jac_blending_0_2_q_4*tmp_blending_op_58 - jac_blending_1_2_q_4*tmp_blending_op_56 + jac_blending_2_2_q_4*tmp_blending_op_54 - jac_blending_2_2_q_4*tmp_blending_op_57;
             const real_t tmp_blending_op_60 = 1.0 / (tmp_blending_op_59);
             const real_t abs_det_jac_blending_q_4 = tmp_blending_op_59;
             const real_t jac_blending_inv_2_2_q_4 = tmp_blending_op_60*(tmp_blending_op_54 - tmp_blending_op_57);
             const real_t jac_blending_inv_2_1_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_2_0_q_4 - tmp_blending_op_56);
             const real_t jac_blending_inv_2_0_q_4 = tmp_blending_op_60*(tmp_blending_op_55 - tmp_blending_op_58);
             const real_t jac_blending_inv_1_2_q_4 = tmp_blending_op_60*(-jac_blending_0_0_q_4*jac_blending_1_2_q_4 + jac_blending_0_2_q_4*jac_blending_1_0_q_4);
             const real_t jac_blending_inv_1_1_q_4 = tmp_blending_op_60*(jac_blending_0_0_q_4*jac_blending_2_2_q_4 - jac_blending_0_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_1_0_q_4 = tmp_blending_op_60*(-jac_blending_1_0_q_4*jac_blending_2_2_q_4 + jac_blending_1_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_0_2_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_1_2_q_4 - jac_blending_0_2_q_4*jac_blending_1_1_q_4);
             const real_t jac_blending_inv_0_1_q_4 = tmp_blending_op_60*(-jac_blending_0_1_q_4*jac_blending_2_2_q_4 + jac_blending_0_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_inv_0_0_q_4 = tmp_blending_op_60*(jac_blending_1_1_q_4*jac_blending_2_2_q_4 - jac_blending_1_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_2_2_q_3 = tmp_blending_op_73*(tmp_blending_op_62*tmp_blending_op_69 + tmp_blending_op_72*(tmp_blending_op_40*tmp_blending_op_61 + tmp_blending_op_68));
             const real_t jac_blending_2_1_q_3 = tmp_blending_op_75*tmp_blending_op_76;
             const real_t jac_blending_2_0_q_3 = tmp_blending_op_76*tmp_blending_op_77;
             const real_t jac_blending_1_2_q_3 = tmp_blending_op_78*tmp_blending_op_79;
             const real_t jac_blending_1_1_q_3 = tmp_blending_op_73*(tmp_blending_op_69*tmp_blending_op_71 + tmp_blending_op_72*(tmp_blending_op_51*tmp_blending_op_66 + tmp_blending_op_68));
             const real_t tmp_blending_op_85 = jac_blending_1_1_q_3*jac_blending_2_0_q_3;
             const real_t jac_blending_1_0_q_3 = tmp_blending_op_77*tmp_blending_op_79;
             const real_t tmp_blending_op_82 = jac_blending_1_0_q_3*jac_blending_2_1_q_3;
             const real_t jac_blending_0_2_q_3 = tmp_blending_op_78*tmp_blending_op_80;
             const real_t jac_blending_0_1_q_3 = tmp_blending_op_75*tmp_blending_op_80;
             const real_t tmp_blending_op_84 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
             const real_t jac_blending_0_0_q_3 = tmp_blending_op_73*(-tmp_blending_op_68*tmp_blending_op_70 + tmp_blending_op_72*(tmp_blending_op_53*tmp_blending_op_64 + tmp_blending_op_68));
             const real_t tmp_blending_op_81 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
             const real_t tmp_blending_op_83 = jac_blending_0_0_q_3*jac_blending_2_1_q_3;
             const real_t tmp_blending_op_86 = jac_blending_0_1_q_3*jac_blending_1_2_q_3*jac_blending_2_0_q_3 + jac_blending_0_2_q_3*tmp_blending_op_82 - jac_blending_0_2_q_3*tmp_blending_op_85 - jac_blending_1_2_q_3*tmp_blending_op_83 + jac_blending_2_2_q_3*tmp_blending_op_81 - jac_blending_2_2_q_3*tmp_blending_op_84;
             const real_t tmp_blending_op_87 = 1.0 / (tmp_blending_op_86);
             const real_t abs_det_jac_blending_q_3 = tmp_blending_op_86;
             const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_87*(tmp_blending_op_81 - tmp_blending_op_84);
             const real_t jac_blending_inv_2_1_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_2_0_q_3 - tmp_blending_op_83);
             const real_t jac_blending_inv_2_0_q_3 = tmp_blending_op_87*(tmp_blending_op_82 - tmp_blending_op_85);
             const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_87*(-jac_blending_0_0_q_3*jac_blending_1_2_q_3 + jac_blending_0_2_q_3*jac_blending_1_0_q_3);
             const real_t jac_blending_inv_1_1_q_3 = tmp_blending_op_87*(jac_blending_0_0_q_3*jac_blending_2_2_q_3 - jac_blending_0_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_1_0_q_3 = tmp_blending_op_87*(-jac_blending_1_0_q_3*jac_blending_2_2_q_3 + jac_blending_1_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_1_2_q_3 - jac_blending_0_2_q_3*jac_blending_1_1_q_3);
             const real_t jac_blending_inv_0_1_q_3 = tmp_blending_op_87*(-jac_blending_0_1_q_3*jac_blending_2_2_q_3 + jac_blending_0_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_inv_0_0_q_3 = tmp_blending_op_87*(jac_blending_1_1_q_3*jac_blending_2_2_q_3 - jac_blending_1_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_2_2_q_2 = tmp_blending_op_100*(tmp_blending_op_89*tmp_blending_op_96 + tmp_blending_op_99*(tmp_blending_op_40*tmp_blending_op_88 + tmp_blending_op_95));
             const real_t jac_blending_2_1_q_2 = tmp_blending_op_101*tmp_blending_op_102;
             const real_t jac_blending_2_0_q_2 = tmp_blending_op_102*tmp_blending_op_103;
             const real_t jac_blending_1_2_q_2 = tmp_blending_op_104*tmp_blending_op_105;
             const real_t jac_blending_1_1_q_2 = tmp_blending_op_100*(tmp_blending_op_96*tmp_blending_op_98 + tmp_blending_op_99*(tmp_blending_op_51*tmp_blending_op_93 + tmp_blending_op_95));
             const real_t tmp_blending_op_111 = jac_blending_1_1_q_2*jac_blending_2_0_q_2;
             const real_t jac_blending_1_0_q_2 = tmp_blending_op_103*tmp_blending_op_105;
             const real_t tmp_blending_op_108 = jac_blending_1_0_q_2*jac_blending_2_1_q_2;
             const real_t jac_blending_0_2_q_2 = tmp_blending_op_104*tmp_blending_op_106;
             const real_t jac_blending_0_1_q_2 = tmp_blending_op_101*tmp_blending_op_106;
             const real_t tmp_blending_op_110 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
             const real_t jac_blending_0_0_q_2 = tmp_blending_op_100*(-tmp_blending_op_95*tmp_blending_op_97 + tmp_blending_op_99*(tmp_blending_op_53*tmp_blending_op_91 + tmp_blending_op_95));
             const real_t tmp_blending_op_107 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
             const real_t tmp_blending_op_109 = jac_blending_0_0_q_2*jac_blending_2_1_q_2;
             const real_t tmp_blending_op_112 = jac_blending_0_1_q_2*jac_blending_1_2_q_2*jac_blending_2_0_q_2 + jac_blending_0_2_q_2*tmp_blending_op_108 - jac_blending_0_2_q_2*tmp_blending_op_111 - jac_blending_1_2_q_2*tmp_blending_op_109 + jac_blending_2_2_q_2*tmp_blending_op_107 - jac_blending_2_2_q_2*tmp_blending_op_110;
             const real_t tmp_blending_op_113 = 1.0 / (tmp_blending_op_112);
             const real_t abs_det_jac_blending_q_2 = tmp_blending_op_112;
             const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_113*(tmp_blending_op_107 - tmp_blending_op_110);
             const real_t jac_blending_inv_2_1_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_2_0_q_2 - tmp_blending_op_109);
             const real_t jac_blending_inv_2_0_q_2 = tmp_blending_op_113*(tmp_blending_op_108 - tmp_blending_op_111);
             const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_113*(-jac_blending_0_0_q_2*jac_blending_1_2_q_2 + jac_blending_0_2_q_2*jac_blending_1_0_q_2);
             const real_t jac_blending_inv_1_1_q_2 = tmp_blending_op_113*(jac_blending_0_0_q_2*jac_blending_2_2_q_2 - jac_blending_0_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_1_0_q_2 = tmp_blending_op_113*(-jac_blending_1_0_q_2*jac_blending_2_2_q_2 + jac_blending_1_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_1_2_q_2 - jac_blending_0_2_q_2*jac_blending_1_1_q_2);
             const real_t jac_blending_inv_0_1_q_2 = tmp_blending_op_113*(-jac_blending_0_1_q_2*jac_blending_2_2_q_2 + jac_blending_0_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_inv_0_0_q_2 = tmp_blending_op_113*(jac_blending_1_1_q_2*jac_blending_2_2_q_2 - jac_blending_1_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_2_2_q_1 = tmp_blending_op_126*(tmp_blending_op_115*tmp_blending_op_122 + tmp_blending_op_125*(tmp_blending_op_114*tmp_blending_op_40 + tmp_blending_op_121));
             const real_t jac_blending_2_1_q_1 = tmp_blending_op_127*tmp_blending_op_128;
             const real_t jac_blending_2_0_q_1 = tmp_blending_op_128*tmp_blending_op_129;
             const real_t jac_blending_1_2_q_1 = tmp_blending_op_130*tmp_blending_op_131;
             const real_t jac_blending_1_1_q_1 = tmp_blending_op_126*(tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*(tmp_blending_op_119*tmp_blending_op_51 + tmp_blending_op_121));
             const real_t tmp_blending_op_137 = jac_blending_1_1_q_1*jac_blending_2_0_q_1;
             const real_t jac_blending_1_0_q_1 = tmp_blending_op_129*tmp_blending_op_131;
             const real_t tmp_blending_op_134 = jac_blending_1_0_q_1*jac_blending_2_1_q_1;
             const real_t jac_blending_0_2_q_1 = tmp_blending_op_130*tmp_blending_op_132;
             const real_t jac_blending_0_1_q_1 = tmp_blending_op_127*tmp_blending_op_132;
             const real_t tmp_blending_op_136 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
             const real_t jac_blending_0_0_q_1 = tmp_blending_op_126*(-tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*(tmp_blending_op_117*tmp_blending_op_53 + tmp_blending_op_121));
             const real_t tmp_blending_op_133 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
             const real_t tmp_blending_op_135 = jac_blending_0_0_q_1*jac_blending_2_1_q_1;
             const real_t tmp_blending_op_138 = jac_blending_0_1_q_1*jac_blending_1_2_q_1*jac_blending_2_0_q_1 + jac_blending_0_2_q_1*tmp_blending_op_134 - jac_blending_0_2_q_1*tmp_blending_op_137 - jac_blending_1_2_q_1*tmp_blending_op_135 + jac_blending_2_2_q_1*tmp_blending_op_133 - jac_blending_2_2_q_1*tmp_blending_op_136;
             const real_t tmp_blending_op_139 = 1.0 / (tmp_blending_op_138);
             const real_t abs_det_jac_blending_q_1 = tmp_blending_op_138;
             const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_139*(tmp_blending_op_133 - tmp_blending_op_136);
             const real_t jac_blending_inv_2_1_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_2_0_q_1 - tmp_blending_op_135);
             const real_t jac_blending_inv_2_0_q_1 = tmp_blending_op_139*(tmp_blending_op_134 - tmp_blending_op_137);
             const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_139*(-jac_blending_0_0_q_1*jac_blending_1_2_q_1 + jac_blending_0_2_q_1*jac_blending_1_0_q_1);
             const real_t jac_blending_inv_1_1_q_1 = tmp_blending_op_139*(jac_blending_0_0_q_1*jac_blending_2_2_q_1 - jac_blending_0_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_1_0_q_1 = tmp_blending_op_139*(-jac_blending_1_0_q_1*jac_blending_2_2_q_1 + jac_blending_1_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_1_2_q_1 - jac_blending_0_2_q_1*jac_blending_1_1_q_1);
             const real_t jac_blending_inv_0_1_q_1 = tmp_blending_op_139*(-jac_blending_0_1_q_1*jac_blending_2_2_q_1 + jac_blending_0_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_inv_0_0_q_1 = tmp_blending_op_139*(jac_blending_1_1_q_1*jac_blending_2_2_q_1 - jac_blending_1_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_2_2_q_0 = tmp_blending_op_152*(tmp_blending_op_141*tmp_blending_op_148 + tmp_blending_op_151*(tmp_blending_op_140*tmp_blending_op_40 + tmp_blending_op_147));
             const real_t jac_blending_2_1_q_0 = tmp_blending_op_153*tmp_blending_op_154;
             const real_t jac_blending_2_0_q_0 = tmp_blending_op_154*tmp_blending_op_155;
             const real_t jac_blending_1_2_q_0 = tmp_blending_op_156*tmp_blending_op_157;
             const real_t jac_blending_1_1_q_0 = tmp_blending_op_152*(tmp_blending_op_148*tmp_blending_op_150 + tmp_blending_op_151*(tmp_blending_op_145*tmp_blending_op_51 + tmp_blending_op_147));
             const real_t tmp_blending_op_163 = jac_blending_1_1_q_0*jac_blending_2_0_q_0;
             const real_t jac_blending_1_0_q_0 = tmp_blending_op_155*tmp_blending_op_157;
             const real_t tmp_blending_op_160 = jac_blending_1_0_q_0*jac_blending_2_1_q_0;
             const real_t jac_blending_0_2_q_0 = tmp_blending_op_156*tmp_blending_op_158;
             const real_t jac_blending_0_1_q_0 = tmp_blending_op_153*tmp_blending_op_158;
             const real_t tmp_blending_op_162 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
             const real_t jac_blending_0_0_q_0 = tmp_blending_op_152*(-tmp_blending_op_147*tmp_blending_op_149 + tmp_blending_op_151*(tmp_blending_op_143*tmp_blending_op_53 + tmp_blending_op_147));
             const real_t tmp_blending_op_159 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
             const real_t tmp_blending_op_161 = jac_blending_0_0_q_0*jac_blending_2_1_q_0;
             const real_t tmp_blending_op_164 = jac_blending_0_1_q_0*jac_blending_1_2_q_0*jac_blending_2_0_q_0 + jac_blending_0_2_q_0*tmp_blending_op_160 - jac_blending_0_2_q_0*tmp_blending_op_163 - jac_blending_1_2_q_0*tmp_blending_op_161 + jac_blending_2_2_q_0*tmp_blending_op_159 - jac_blending_2_2_q_0*tmp_blending_op_162;
             const real_t tmp_blending_op_165 = 1.0 / (tmp_blending_op_164);
             const real_t abs_det_jac_blending_q_0 = tmp_blending_op_164;
             const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_165*(tmp_blending_op_159 - tmp_blending_op_162);
             const real_t jac_blending_inv_2_1_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_2_0_q_0 - tmp_blending_op_161);
             const real_t jac_blending_inv_2_0_q_0 = tmp_blending_op_165*(tmp_blending_op_160 - tmp_blending_op_163);
             const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_165*(-jac_blending_0_0_q_0*jac_blending_1_2_q_0 + jac_blending_0_2_q_0*jac_blending_1_0_q_0);
             const real_t jac_blending_inv_1_1_q_0 = tmp_blending_op_165*(jac_blending_0_0_q_0*jac_blending_2_2_q_0 - jac_blending_0_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_1_0_q_0 = tmp_blending_op_165*(-jac_blending_1_0_q_0*jac_blending_2_2_q_0 + jac_blending_1_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_1_2_q_0 - jac_blending_0_2_q_0*jac_blending_1_1_q_0);
             const real_t jac_blending_inv_0_1_q_0 = tmp_blending_op_165*(-jac_blending_0_1_q_0*jac_blending_2_2_q_0 + jac_blending_0_2_q_0*jac_blending_2_1_q_0);
             const real_t jac_blending_inv_0_0_q_0 = tmp_blending_op_165*(jac_blending_1_1_q_0*jac_blending_2_2_q_0 - jac_blending_1_2_q_0*jac_blending_2_1_q_0);
             const real_t cp_times_delta_dof_0 = _data_cp_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t cp_times_delta_dof_1 = _data_cp_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t cp_times_delta_dof_2 = _data_cp_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t cp_times_delta_dof_3 = _data_cp_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t cp_times_delta_dof_4 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t cp_times_delta_dof_5 = _data_cp_times_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t cp_times_delta_dof_6 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t cp_times_delta_dof_7 = _data_cp_times_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t cp_times_delta_dof_8 = _data_cp_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t cp_times_delta_dof_9 = _data_cp_times_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_0 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_1 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_2 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_3 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_4 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ux_dof_5 = _data_uxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_6 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ux_dof_7 = _data_uxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_8 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ux_dof_9 = _data_uxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_0 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_1 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_2 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_3 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_4 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uy_dof_5 = _data_uyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_6 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uy_dof_7 = _data_uyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_8 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uy_dof_9 = _data_uyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_0 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_1 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_2 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_3 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_4 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uz_dof_5 = _data_uzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_6 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uz_dof_7 = _data_uzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_8 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uz_dof_9 = _data_uzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t tmp_kernel_op_25 = tmp_kernel_op_10*ux_dof_6 + tmp_kernel_op_13*ux_dof_1 + tmp_kernel_op_16*ux_dof_2 + tmp_kernel_op_19*ux_dof_3 + tmp_kernel_op_20*ux_dof_7 + tmp_kernel_op_21*ux_dof_8 + tmp_kernel_op_23*ux_dof_9 + tmp_kernel_op_24*ux_dof_0 + tmp_kernel_op_8*ux_dof_4 + tmp_kernel_op_9*ux_dof_5;
             const real_t tmp_kernel_op_26 = tmp_kernel_op_10*uy_dof_6 + tmp_kernel_op_13*uy_dof_1 + tmp_kernel_op_16*uy_dof_2 + tmp_kernel_op_19*uy_dof_3 + tmp_kernel_op_20*uy_dof_7 + tmp_kernel_op_21*uy_dof_8 + tmp_kernel_op_23*uy_dof_9 + tmp_kernel_op_24*uy_dof_0 + tmp_kernel_op_8*uy_dof_4 + tmp_kernel_op_9*uy_dof_5;
             const real_t tmp_kernel_op_27 = tmp_kernel_op_10*uz_dof_6 + tmp_kernel_op_13*uz_dof_1 + tmp_kernel_op_16*uz_dof_2 + tmp_kernel_op_19*uz_dof_3 + tmp_kernel_op_20*uz_dof_7 + tmp_kernel_op_21*uz_dof_8 + tmp_kernel_op_23*uz_dof_9 + tmp_kernel_op_24*uz_dof_0 + tmp_kernel_op_8*uz_dof_4 + tmp_kernel_op_9*uz_dof_5;
             const real_t tmp_kernel_op_28 = abs_det_jac_affine_GREEN_DOWN*abs_det_jac_blending_q_0*(cp_times_delta_dof_0*tmp_kernel_op_24 + cp_times_delta_dof_1*tmp_kernel_op_13 + cp_times_delta_dof_2*tmp_kernel_op_16 + cp_times_delta_dof_3*tmp_kernel_op_19 + cp_times_delta_dof_4*tmp_kernel_op_8 + cp_times_delta_dof_5*tmp_kernel_op_9 + cp_times_delta_dof_6*tmp_kernel_op_10 + cp_times_delta_dof_7*tmp_kernel_op_20 + cp_times_delta_dof_8*tmp_kernel_op_21 + cp_times_delta_dof_9*tmp_kernel_op_23)*-0.1333333333333333;
             const real_t tmp_kernel_op_54 = tmp_kernel_op_37*ux_dof_4 + tmp_kernel_op_38*ux_dof_5 + tmp_kernel_op_39*ux_dof_6 + tmp_kernel_op_42*ux_dof_1 + tmp_kernel_op_45*ux_dof_2 + tmp_kernel_op_48*ux_dof_3 + tmp_kernel_op_49*ux_dof_7 + tmp_kernel_op_50*ux_dof_8 + tmp_kernel_op_52*ux_dof_9 + tmp_kernel_op_53*ux_dof_0;
             const real_t tmp_kernel_op_55 = tmp_kernel_op_37*uy_dof_4 + tmp_kernel_op_38*uy_dof_5 + tmp_kernel_op_39*uy_dof_6 + tmp_kernel_op_42*uy_dof_1 + tmp_kernel_op_45*uy_dof_2 + tmp_kernel_op_48*uy_dof_3 + tmp_kernel_op_49*uy_dof_7 + tmp_kernel_op_50*uy_dof_8 + tmp_kernel_op_52*uy_dof_9 + tmp_kernel_op_53*uy_dof_0;
             const real_t tmp_kernel_op_56 = tmp_kernel_op_37*uz_dof_4 + tmp_kernel_op_38*uz_dof_5 + tmp_kernel_op_39*uz_dof_6 + tmp_kernel_op_42*uz_dof_1 + tmp_kernel_op_45*uz_dof_2 + tmp_kernel_op_48*uz_dof_3 + tmp_kernel_op_49*uz_dof_7 + tmp_kernel_op_50*uz_dof_8 + tmp_kernel_op_52*uz_dof_9 + tmp_kernel_op_53*uz_dof_0;
             const real_t tmp_kernel_op_57 = abs_det_jac_affine_GREEN_DOWN*abs_det_jac_blending_q_1*(cp_times_delta_dof_0*tmp_kernel_op_53 + cp_times_delta_dof_1*tmp_kernel_op_42 + cp_times_delta_dof_2*tmp_kernel_op_45 + cp_times_delta_dof_3*tmp_kernel_op_48 + cp_times_delta_dof_4*tmp_kernel_op_37 + cp_times_delta_dof_5*tmp_kernel_op_38 + cp_times_delta_dof_6*tmp_kernel_op_39 + cp_times_delta_dof_7*tmp_kernel_op_49 + cp_times_delta_dof_8*tmp_kernel_op_50 + cp_times_delta_dof_9*tmp_kernel_op_52)*0.074999999999999983;
             const real_t tmp_kernel_op_83 = tmp_kernel_op_66*ux_dof_4 + tmp_kernel_op_67*ux_dof_5 + tmp_kernel_op_68*ux_dof_6 + tmp_kernel_op_71*ux_dof_1 + tmp_kernel_op_74*ux_dof_2 + tmp_kernel_op_77*ux_dof_3 + tmp_kernel_op_78*ux_dof_7 + tmp_kernel_op_79*ux_dof_8 + tmp_kernel_op_81*ux_dof_9 + tmp_kernel_op_82*ux_dof_0;
             const real_t tmp_kernel_op_84 = tmp_kernel_op_66*uy_dof_4 + tmp_kernel_op_67*uy_dof_5 + tmp_kernel_op_68*uy_dof_6 + tmp_kernel_op_71*uy_dof_1 + tmp_kernel_op_74*uy_dof_2 + tmp_kernel_op_77*uy_dof_3 + tmp_kernel_op_78*uy_dof_7 + tmp_kernel_op_79*uy_dof_8 + tmp_kernel_op_81*uy_dof_9 + tmp_kernel_op_82*uy_dof_0;
             const real_t tmp_kernel_op_85 = tmp_kernel_op_66*uz_dof_4 + tmp_kernel_op_67*uz_dof_5 + tmp_kernel_op_68*uz_dof_6 + tmp_kernel_op_71*uz_dof_1 + tmp_kernel_op_74*uz_dof_2 + tmp_kernel_op_77*uz_dof_3 + tmp_kernel_op_78*uz_dof_7 + tmp_kernel_op_79*uz_dof_8 + tmp_kernel_op_81*uz_dof_9 + tmp_kernel_op_82*uz_dof_0;
             const real_t tmp_kernel_op_86 = abs_det_jac_affine_GREEN_DOWN*abs_det_jac_blending_q_2*(cp_times_delta_dof_0*tmp_kernel_op_82 + cp_times_delta_dof_1*tmp_kernel_op_71 + cp_times_delta_dof_2*tmp_kernel_op_74 + cp_times_delta_dof_3*tmp_kernel_op_77 + cp_times_delta_dof_4*tmp_kernel_op_66 + cp_times_delta_dof_5*tmp_kernel_op_67 + cp_times_delta_dof_6*tmp_kernel_op_68 + cp_times_delta_dof_7*tmp_kernel_op_78 + cp_times_delta_dof_8*tmp_kernel_op_79 + cp_times_delta_dof_9*tmp_kernel_op_81)*0.074999999999999983;
             const real_t tmp_kernel_op_112 = tmp_kernel_op_100*ux_dof_1 + tmp_kernel_op_103*ux_dof_2 + tmp_kernel_op_106*ux_dof_3 + tmp_kernel_op_107*ux_dof_7 + tmp_kernel_op_108*ux_dof_8 + tmp_kernel_op_110*ux_dof_9 + tmp_kernel_op_111*ux_dof_0 + tmp_kernel_op_95*ux_dof_4 + tmp_kernel_op_96*ux_dof_5 + tmp_kernel_op_97*ux_dof_6;
             const real_t tmp_kernel_op_113 = tmp_kernel_op_100*uy_dof_1 + tmp_kernel_op_103*uy_dof_2 + tmp_kernel_op_106*uy_dof_3 + tmp_kernel_op_107*uy_dof_7 + tmp_kernel_op_108*uy_dof_8 + tmp_kernel_op_110*uy_dof_9 + tmp_kernel_op_111*uy_dof_0 + tmp_kernel_op_95*uy_dof_4 + tmp_kernel_op_96*uy_dof_5 + tmp_kernel_op_97*uy_dof_6;
             const real_t tmp_kernel_op_114 = tmp_kernel_op_100*uz_dof_1 + tmp_kernel_op_103*uz_dof_2 + tmp_kernel_op_106*uz_dof_3 + tmp_kernel_op_107*uz_dof_7 + tmp_kernel_op_108*uz_dof_8 + tmp_kernel_op_110*uz_dof_9 + tmp_kernel_op_111*uz_dof_0 + tmp_kernel_op_95*uz_dof_4 + tmp_kernel_op_96*uz_dof_5 + tmp_kernel_op_97*uz_dof_6;
             const real_t tmp_kernel_op_115 = abs_det_jac_affine_GREEN_DOWN*abs_det_jac_blending_q_3*(cp_times_delta_dof_0*tmp_kernel_op_111 + cp_times_delta_dof_1*tmp_kernel_op_100 + cp_times_delta_dof_2*tmp_kernel_op_103 + cp_times_delta_dof_3*tmp_kernel_op_106 + cp_times_delta_dof_4*tmp_kernel_op_95 + cp_times_delta_dof_5*tmp_kernel_op_96 + cp_times_delta_dof_6*tmp_kernel_op_97 + cp_times_delta_dof_7*tmp_kernel_op_107 + cp_times_delta_dof_8*tmp_kernel_op_108 + cp_times_delta_dof_9*tmp_kernel_op_110)*0.074999999999999983;
             const real_t tmp_kernel_op_141 = tmp_kernel_op_124*ux_dof_4 + tmp_kernel_op_125*ux_dof_5 + tmp_kernel_op_126*ux_dof_6 + tmp_kernel_op_129*ux_dof_1 + tmp_kernel_op_132*ux_dof_2 + tmp_kernel_op_135*ux_dof_3 + tmp_kernel_op_136*ux_dof_7 + tmp_kernel_op_137*ux_dof_8 + tmp_kernel_op_139*ux_dof_9 + tmp_kernel_op_140*ux_dof_0;
             const real_t tmp_kernel_op_142 = tmp_kernel_op_124*uy_dof_4 + tmp_kernel_op_125*uy_dof_5 + tmp_kernel_op_126*uy_dof_6 + tmp_kernel_op_129*uy_dof_1 + tmp_kernel_op_132*uy_dof_2 + tmp_kernel_op_135*uy_dof_3 + tmp_kernel_op_136*uy_dof_7 + tmp_kernel_op_137*uy_dof_8 + tmp_kernel_op_139*uy_dof_9 + tmp_kernel_op_140*uy_dof_0;
             const real_t tmp_kernel_op_143 = tmp_kernel_op_124*uz_dof_4 + tmp_kernel_op_125*uz_dof_5 + tmp_kernel_op_126*uz_dof_6 + tmp_kernel_op_129*uz_dof_1 + tmp_kernel_op_132*uz_dof_2 + tmp_kernel_op_135*uz_dof_3 + tmp_kernel_op_136*uz_dof_7 + tmp_kernel_op_137*uz_dof_8 + tmp_kernel_op_139*uz_dof_9 + tmp_kernel_op_140*uz_dof_0;
             const real_t tmp_kernel_op_144 = abs_det_jac_affine_GREEN_DOWN*abs_det_jac_blending_q_4*(cp_times_delta_dof_0*tmp_kernel_op_140 + cp_times_delta_dof_1*tmp_kernel_op_129 + cp_times_delta_dof_2*tmp_kernel_op_132 + cp_times_delta_dof_3*tmp_kernel_op_135 + cp_times_delta_dof_4*tmp_kernel_op_124 + cp_times_delta_dof_5*tmp_kernel_op_125 + cp_times_delta_dof_6*tmp_kernel_op_126 + cp_times_delta_dof_7*tmp_kernel_op_136 + cp_times_delta_dof_8*tmp_kernel_op_137 + cp_times_delta_dof_9*tmp_kernel_op_139)*0.074999999999999983;
             const real_t elMatDiag_0 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_969 + jac_blending_inv_1_0_q_3*tmp_moved_constant_970 + jac_blending_inv_2_0_q_3*tmp_moved_constant_971) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_969 + jac_blending_inv_1_1_q_3*tmp_moved_constant_970 + jac_blending_inv_2_1_q_3*tmp_moved_constant_971) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_969 + jac_blending_inv_1_2_q_3*tmp_moved_constant_970 + jac_blending_inv_2_2_q_3*tmp_moved_constant_971))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_969 + jac_blending_inv_1_0_q_3*tmp_moved_constant_970 + jac_blending_inv_2_0_q_3*tmp_moved_constant_971) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_969 + jac_blending_inv_1_1_q_3*tmp_moved_constant_970 + jac_blending_inv_2_1_q_3*tmp_moved_constant_971) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_969 + jac_blending_inv_1_2_q_3*tmp_moved_constant_970 + jac_blending_inv_2_2_q_3*tmp_moved_constant_971))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_972 + jac_blending_inv_1_0_q_4*tmp_moved_constant_973 + jac_blending_inv_2_0_q_4*tmp_moved_constant_974) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_972 + jac_blending_inv_1_1_q_4*tmp_moved_constant_973 + jac_blending_inv_2_1_q_4*tmp_moved_constant_974) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_972 + jac_blending_inv_1_2_q_4*tmp_moved_constant_973 + jac_blending_inv_2_2_q_4*tmp_moved_constant_974))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_972 + jac_blending_inv_1_0_q_4*tmp_moved_constant_973 + jac_blending_inv_2_0_q_4*tmp_moved_constant_974) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_972 + jac_blending_inv_1_1_q_4*tmp_moved_constant_973 + jac_blending_inv_2_1_q_4*tmp_moved_constant_974) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_972 + jac_blending_inv_1_2_q_4*tmp_moved_constant_973 + jac_blending_inv_2_2_q_4*tmp_moved_constant_974))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_960 + jac_blending_inv_1_0_q_0*tmp_moved_constant_961 + jac_blending_inv_2_0_q_0*tmp_moved_constant_962) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_960 + jac_blending_inv_1_1_q_0*tmp_moved_constant_961 + jac_blending_inv_2_1_q_0*tmp_moved_constant_962) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_960 + jac_blending_inv_1_2_q_0*tmp_moved_constant_961 + jac_blending_inv_2_2_q_0*tmp_moved_constant_962))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_960 + jac_blending_inv_1_0_q_0*tmp_moved_constant_961 + jac_blending_inv_2_0_q_0*tmp_moved_constant_962) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_960 + jac_blending_inv_1_1_q_0*tmp_moved_constant_961 + jac_blending_inv_2_1_q_0*tmp_moved_constant_962) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_960 + jac_blending_inv_1_2_q_0*tmp_moved_constant_961 + jac_blending_inv_2_2_q_0*tmp_moved_constant_962))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_963 + jac_blending_inv_1_0_q_1*tmp_moved_constant_964 + jac_blending_inv_2_0_q_1*tmp_moved_constant_965) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_963 + jac_blending_inv_1_1_q_1*tmp_moved_constant_964 + jac_blending_inv_2_1_q_1*tmp_moved_constant_965) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_963 + jac_blending_inv_1_2_q_1*tmp_moved_constant_964 + jac_blending_inv_2_2_q_1*tmp_moved_constant_965))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_963 + jac_blending_inv_1_0_q_1*tmp_moved_constant_964 + jac_blending_inv_2_0_q_1*tmp_moved_constant_965) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_963 + jac_blending_inv_1_1_q_1*tmp_moved_constant_964 + jac_blending_inv_2_1_q_1*tmp_moved_constant_965) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_963 + jac_blending_inv_1_2_q_1*tmp_moved_constant_964 + jac_blending_inv_2_2_q_1*tmp_moved_constant_965))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_966 + jac_blending_inv_1_0_q_2*tmp_moved_constant_967 + jac_blending_inv_2_0_q_2*tmp_moved_constant_968) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_966 + jac_blending_inv_1_1_q_2*tmp_moved_constant_967 + jac_blending_inv_2_1_q_2*tmp_moved_constant_968) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_966 + jac_blending_inv_1_2_q_2*tmp_moved_constant_967 + jac_blending_inv_2_2_q_2*tmp_moved_constant_968))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_966 + jac_blending_inv_1_0_q_2*tmp_moved_constant_967 + jac_blending_inv_2_0_q_2*tmp_moved_constant_968) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_966 + jac_blending_inv_1_1_q_2*tmp_moved_constant_967 + jac_blending_inv_2_1_q_2*tmp_moved_constant_968) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_966 + jac_blending_inv_1_2_q_2*tmp_moved_constant_967 + jac_blending_inv_2_2_q_2*tmp_moved_constant_968)));
             const real_t elMatDiag_1 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_984 + jac_blending_inv_1_0_q_3*tmp_moved_constant_985 + jac_blending_inv_2_0_q_3*tmp_moved_constant_986) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_984 + jac_blending_inv_1_1_q_3*tmp_moved_constant_985 + jac_blending_inv_2_1_q_3*tmp_moved_constant_986) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_984 + jac_blending_inv_1_2_q_3*tmp_moved_constant_985 + jac_blending_inv_2_2_q_3*tmp_moved_constant_986))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_984 + jac_blending_inv_1_0_q_3*tmp_moved_constant_985 + jac_blending_inv_2_0_q_3*tmp_moved_constant_986) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_984 + jac_blending_inv_1_1_q_3*tmp_moved_constant_985 + jac_blending_inv_2_1_q_3*tmp_moved_constant_986) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_984 + jac_blending_inv_1_2_q_3*tmp_moved_constant_985 + jac_blending_inv_2_2_q_3*tmp_moved_constant_986))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_987 + jac_blending_inv_1_0_q_4*tmp_moved_constant_988 + jac_blending_inv_2_0_q_4*tmp_moved_constant_989) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_987 + jac_blending_inv_1_1_q_4*tmp_moved_constant_988 + jac_blending_inv_2_1_q_4*tmp_moved_constant_989) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_987 + jac_blending_inv_1_2_q_4*tmp_moved_constant_988 + jac_blending_inv_2_2_q_4*tmp_moved_constant_989))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_987 + jac_blending_inv_1_0_q_4*tmp_moved_constant_988 + jac_blending_inv_2_0_q_4*tmp_moved_constant_989) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_987 + jac_blending_inv_1_1_q_4*tmp_moved_constant_988 + jac_blending_inv_2_1_q_4*tmp_moved_constant_989) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_987 + jac_blending_inv_1_2_q_4*tmp_moved_constant_988 + jac_blending_inv_2_2_q_4*tmp_moved_constant_989))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_975 + jac_blending_inv_1_0_q_0*tmp_moved_constant_976 + jac_blending_inv_2_0_q_0*tmp_moved_constant_977) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_975 + jac_blending_inv_1_1_q_0*tmp_moved_constant_976 + jac_blending_inv_2_1_q_0*tmp_moved_constant_977) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_975 + jac_blending_inv_1_2_q_0*tmp_moved_constant_976 + jac_blending_inv_2_2_q_0*tmp_moved_constant_977))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_975 + jac_blending_inv_1_0_q_0*tmp_moved_constant_976 + jac_blending_inv_2_0_q_0*tmp_moved_constant_977) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_975 + jac_blending_inv_1_1_q_0*tmp_moved_constant_976 + jac_blending_inv_2_1_q_0*tmp_moved_constant_977) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_975 + jac_blending_inv_1_2_q_0*tmp_moved_constant_976 + jac_blending_inv_2_2_q_0*tmp_moved_constant_977))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_978 + jac_blending_inv_1_0_q_1*tmp_moved_constant_979 + jac_blending_inv_2_0_q_1*tmp_moved_constant_980) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_978 + jac_blending_inv_1_1_q_1*tmp_moved_constant_979 + jac_blending_inv_2_1_q_1*tmp_moved_constant_980) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_978 + jac_blending_inv_1_2_q_1*tmp_moved_constant_979 + jac_blending_inv_2_2_q_1*tmp_moved_constant_980))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_978 + jac_blending_inv_1_0_q_1*tmp_moved_constant_979 + jac_blending_inv_2_0_q_1*tmp_moved_constant_980) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_978 + jac_blending_inv_1_1_q_1*tmp_moved_constant_979 + jac_blending_inv_2_1_q_1*tmp_moved_constant_980) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_978 + jac_blending_inv_1_2_q_1*tmp_moved_constant_979 + jac_blending_inv_2_2_q_1*tmp_moved_constant_980))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_981 + jac_blending_inv_1_0_q_2*tmp_moved_constant_982 + jac_blending_inv_2_0_q_2*tmp_moved_constant_983) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_981 + jac_blending_inv_1_1_q_2*tmp_moved_constant_982 + jac_blending_inv_2_1_q_2*tmp_moved_constant_983) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_981 + jac_blending_inv_1_2_q_2*tmp_moved_constant_982 + jac_blending_inv_2_2_q_2*tmp_moved_constant_983))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_981 + jac_blending_inv_1_0_q_2*tmp_moved_constant_982 + jac_blending_inv_2_0_q_2*tmp_moved_constant_983) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_981 + jac_blending_inv_1_1_q_2*tmp_moved_constant_982 + jac_blending_inv_2_1_q_2*tmp_moved_constant_983) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_981 + jac_blending_inv_1_2_q_2*tmp_moved_constant_982 + jac_blending_inv_2_2_q_2*tmp_moved_constant_983)));
             const real_t elMatDiag_2 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_999 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1000 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1001) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_999 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1000 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1001) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_999 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1000 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1001))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_999 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1000 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1001) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_999 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1000 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1001) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_999 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1000 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1001))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1002 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1003 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1004) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1002 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1003 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1004) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1002 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1003 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1004))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1002 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1003 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1004) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1002 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1003 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1004) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1002 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1003 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1004))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_990 + jac_blending_inv_1_0_q_0*tmp_moved_constant_991 + jac_blending_inv_2_0_q_0*tmp_moved_constant_992) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_990 + jac_blending_inv_1_1_q_0*tmp_moved_constant_991 + jac_blending_inv_2_1_q_0*tmp_moved_constant_992) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_990 + jac_blending_inv_1_2_q_0*tmp_moved_constant_991 + jac_blending_inv_2_2_q_0*tmp_moved_constant_992))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_990 + jac_blending_inv_1_0_q_0*tmp_moved_constant_991 + jac_blending_inv_2_0_q_0*tmp_moved_constant_992) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_990 + jac_blending_inv_1_1_q_0*tmp_moved_constant_991 + jac_blending_inv_2_1_q_0*tmp_moved_constant_992) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_990 + jac_blending_inv_1_2_q_0*tmp_moved_constant_991 + jac_blending_inv_2_2_q_0*tmp_moved_constant_992))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_993 + jac_blending_inv_1_0_q_1*tmp_moved_constant_994 + jac_blending_inv_2_0_q_1*tmp_moved_constant_995) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_993 + jac_blending_inv_1_1_q_1*tmp_moved_constant_994 + jac_blending_inv_2_1_q_1*tmp_moved_constant_995) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_993 + jac_blending_inv_1_2_q_1*tmp_moved_constant_994 + jac_blending_inv_2_2_q_1*tmp_moved_constant_995))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_993 + jac_blending_inv_1_0_q_1*tmp_moved_constant_994 + jac_blending_inv_2_0_q_1*tmp_moved_constant_995) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_993 + jac_blending_inv_1_1_q_1*tmp_moved_constant_994 + jac_blending_inv_2_1_q_1*tmp_moved_constant_995) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_993 + jac_blending_inv_1_2_q_1*tmp_moved_constant_994 + jac_blending_inv_2_2_q_1*tmp_moved_constant_995))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_996 + jac_blending_inv_1_0_q_2*tmp_moved_constant_997 + jac_blending_inv_2_0_q_2*tmp_moved_constant_998) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_996 + jac_blending_inv_1_1_q_2*tmp_moved_constant_997 + jac_blending_inv_2_1_q_2*tmp_moved_constant_998) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_996 + jac_blending_inv_1_2_q_2*tmp_moved_constant_997 + jac_blending_inv_2_2_q_2*tmp_moved_constant_998))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_996 + jac_blending_inv_1_0_q_2*tmp_moved_constant_997 + jac_blending_inv_2_0_q_2*tmp_moved_constant_998) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_996 + jac_blending_inv_1_1_q_2*tmp_moved_constant_997 + jac_blending_inv_2_1_q_2*tmp_moved_constant_998) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_996 + jac_blending_inv_1_2_q_2*tmp_moved_constant_997 + jac_blending_inv_2_2_q_2*tmp_moved_constant_998)));
             const real_t elMatDiag_3 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1014 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1015 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1016) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1014 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1015 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1016) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1014 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1015 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1016))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1014 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1015 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1016) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1014 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1015 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1016) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1014 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1015 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1016))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1017 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1018 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1019) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1017 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1018 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1019) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1017 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1018 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1019))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1017 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1018 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1019) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1017 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1018 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1019) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1017 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1018 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1019))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1005 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1006 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1007) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1005 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1006 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1007) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1005 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1006 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1007))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1005 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1006 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1007) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1005 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1006 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1007) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1005 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1006 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1007))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1008 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1009 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1010) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1008 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1009 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1010) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1008 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1009 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1010))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1008 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1009 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1010) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1008 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1009 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1010) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1008 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1009 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1010))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1011 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1012 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1013) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1011 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1012 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1013) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1011 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1012 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1013))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1011 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1012 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1013) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1011 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1012 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1013) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1011 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1012 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1013)));
             const real_t elMatDiag_4 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1049 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1052 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1055) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1049 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1052 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1055) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1049 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1052 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1055))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1049 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1052 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1055) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1049 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1052 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1055) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1049 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1052 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1055))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1058 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1061 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1064) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1058 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1061 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1064) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1058 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1061 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1064))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1058 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1061 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1064) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1058 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1061 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1064) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1058 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1061 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1064))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1022 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1025 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1028) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1022 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1025 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1028) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1022 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1025 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1028))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1022 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1025 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1028) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1022 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1025 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1028) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1022 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1025 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1028))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1031 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1034 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1037) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1031 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1034 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1037) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1031 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1034 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1037))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1031 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1034 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1037) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1031 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1034 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1037) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1031 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1034 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1037))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1040 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1043 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1046) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1040 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1043 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1046) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1040 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1043 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1046))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1040 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1043 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1046) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1040 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1043 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1046) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1040 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1043 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1046)));
             const real_t elMatDiag_5 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1094 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1097 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1100) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1094 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1097 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1100) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1094 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1097 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1100))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1094 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1097 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1100) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1094 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1097 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1100) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1094 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1097 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1100))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1103 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1106 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1109) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1103 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1106 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1109) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1103 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1106 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1109))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1103 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1106 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1109) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1103 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1106 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1109) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1103 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1106 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1109))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1067 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1070 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1073) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1067 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1070 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1073) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1067 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1070 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1073))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1067 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1070 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1073) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1067 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1070 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1073) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1067 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1070 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1073))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1076 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1079 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1082) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1076 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1079 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1082) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1076 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1079 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1082))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1076 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1079 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1082) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1076 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1079 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1082) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1076 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1079 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1082))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1085 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1088 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1091) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1085 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1088 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1091) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1085 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1088 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1091))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1085 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1088 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1091) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1085 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1088 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1091) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1085 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1088 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1091)));
             const real_t elMatDiag_6 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1139 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1142 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1145) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1139 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1142 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1145) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1139 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1142 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1145))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1139 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1142 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1145) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1139 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1142 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1145) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1139 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1142 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1145))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1148 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1151 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1154) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1148 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1151 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1154) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1148 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1151 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1154))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1148 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1151 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1154) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1148 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1151 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1154) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1148 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1151 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1154))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1112 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1115 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1118) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1112 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1115 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1118) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1112 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1115 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1118))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1112 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1115 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1118) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1112 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1115 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1118) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1112 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1115 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1118))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1121 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1124 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1127) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1121 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1124 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1127) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1121 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1124 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1127))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1121 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1124 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1127) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1121 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1124 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1127) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1121 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1124 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1127))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1130 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1133 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1136) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1130 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1133 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1136) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1130 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1133 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1136))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1130 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1133 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1136) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1130 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1133 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1136) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1130 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1133 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1136)));
             const real_t elMatDiag_7 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1164 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1165 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1166) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1164 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1165 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1166) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1164 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1165 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1166))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1164 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1165 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1166) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1164 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1165 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1166) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1164 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1165 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1166))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1167 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1168 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1169) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1167 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1168 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1169) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1167 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1168 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1169))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1167 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1168 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1169) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1167 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1168 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1169) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1167 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1168 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1169))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1155 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1156 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1157) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1155 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1156 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1157) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1155 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1156 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1157))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1155 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1156 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1157) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1155 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1156 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1157) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1155 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1156 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1157))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1158 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1159 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1160) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1158 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1159 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1160) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1158 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1159 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1160))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1158 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1159 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1160) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1158 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1159 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1160) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1158 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1159 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1160))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1161 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1162 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1163) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1161 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1162 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1163) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1161 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1162 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1163))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1161 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1162 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1163) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1161 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1162 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1163) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1161 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1162 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1163)));
             const real_t elMatDiag_8 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1179 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1180 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1181) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1179 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1180 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1181) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1179 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1180 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1181))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1179 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1180 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1181) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1179 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1180 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1181) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1179 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1180 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1181))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1182 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1183 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1184) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1182 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1183 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1184) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1182 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1183 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1184))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1182 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1183 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1184) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1182 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1183 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1184) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1182 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1183 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1184))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1170 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1171 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1172) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1170 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1171 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1172) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1170 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1171 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1172))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1170 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1171 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1172) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1170 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1171 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1172) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1170 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1171 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1172))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1173 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1174 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1175) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1173 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1174 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1175) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1173 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1174 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1175))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1173 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1174 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1175) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1173 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1174 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1175) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1173 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1174 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1175))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1176 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1177 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1178) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1176 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1177 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1178) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1176 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1177 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1178))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1176 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1177 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1178) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1176 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1177 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1178) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1176 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1177 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1178)));
             const real_t elMatDiag_9 = tmp_kernel_op_115*((tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1194 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1195 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1196) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1194 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1195 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1196) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1194 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1195 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1196))*(tmp_kernel_op_112*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1194 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1195 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1196) + tmp_kernel_op_113*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1194 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1195 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1196) + tmp_kernel_op_114*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1194 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1195 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1196))) + tmp_kernel_op_144*((tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1197 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1198 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1199) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1197 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1198 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1199) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1197 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1198 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1199))*(tmp_kernel_op_141*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1197 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1198 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1199) + tmp_kernel_op_142*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1197 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1198 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1199) + tmp_kernel_op_143*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1197 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1198 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1199))) + tmp_kernel_op_28*((tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1185 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1186 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1187) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1185 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1186 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1187) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1185 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1186 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1187))*(tmp_kernel_op_25*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1185 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1186 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1187) + tmp_kernel_op_26*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1185 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1186 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1187) + tmp_kernel_op_27*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1185 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1186 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1187))) + tmp_kernel_op_57*((tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1188 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1189 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1190) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1188 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1189 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1190) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1188 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1189 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1190))*(tmp_kernel_op_54*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1188 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1189 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1190) + tmp_kernel_op_55*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1188 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1189 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1190) + tmp_kernel_op_56*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1188 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1189 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1190))) + tmp_kernel_op_86*((tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1191 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1192 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1193) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1191 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1192 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1193) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1191 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1192 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1193))*(tmp_kernel_op_83*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1191 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1192 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1193) + tmp_kernel_op_84*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1191 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1192 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1193) + tmp_kernel_op_85*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1191 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1192 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1193)));
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
