/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/





























#include "../P2ElementwiseSupgDiffusion.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ElementwiseSupgDiffusion::apply_P2ElementwiseSupgDiffusion_macro_2D( real_t * RESTRICT  _data_diffusivity_times_deltaEdge, real_t * RESTRICT  _data_diffusivity_times_deltaVertex, real_t * RESTRICT  _data_dstEdge, real_t * RESTRICT  _data_dstVertex, real_t * RESTRICT  _data_srcEdge, real_t * RESTRICT  _data_srcVertex, real_t * RESTRICT  _data_wxEdge, real_t * RESTRICT  _data_wxVertex, real_t * RESTRICT  _data_wyEdge, real_t * RESTRICT  _data_wyVertex, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float ) const
{
    {
       const real_t tmp_coords_jac_0_GRAY = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_GRAY = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_GRAY = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_1_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_2_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t jac_affine_0_0_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_1_0_GRAY;
       const real_t jac_affine_0_1_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_2_0_GRAY;
       const real_t jac_affine_1_0_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_1_1_GRAY;
       const real_t jac_affine_1_1_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_2_1_GRAY;
       const real_t tmp_coords_jac_1_GRAY = jac_affine_0_0_GRAY*jac_affine_1_1_GRAY - jac_affine_0_1_GRAY*jac_affine_1_0_GRAY;
       const real_t tmp_coords_jac_2_GRAY = 1.0 / (tmp_coords_jac_1_GRAY);
       const real_t jac_affine_inv_0_0_GRAY = jac_affine_1_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_0_1_GRAY = -jac_affine_0_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_0_GRAY = -jac_affine_1_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_1_GRAY = jac_affine_0_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t abs_det_jac_affine_GRAY = abs(tmp_coords_jac_1_GRAY);
       const real_t tmp_kernel_op_0 = 1.3333333333333333;
       const real_t tmp_kernel_op_1 = 1.3333333333333333;
       const real_t tmp_kernel_op_2 = tmp_kernel_op_0 + tmp_kernel_op_1 - 3.0;
       const real_t tmp_kernel_op_3 = tmp_kernel_op_0*0.33333333333333331;
       const real_t tmp_kernel_op_4 = 0.1111111111111111;
       const real_t tmp_kernel_op_5 = tmp_kernel_op_4*2.0;
       const real_t tmp_kernel_op_6 = tmp_kernel_op_5 - 0.33333333333333331;
       const real_t tmp_kernel_op_7 = 0.1111111111111111;
       const real_t tmp_kernel_op_8 = tmp_kernel_op_7*2.0;
       const real_t tmp_kernel_op_9 = tmp_kernel_op_8 - 0.33333333333333331;
       const real_t tmp_kernel_op_10 = tmp_kernel_op_1 - tmp_kernel_op_3 + tmp_kernel_op_7*-4.0;
       const real_t tmp_kernel_op_11 = tmp_kernel_op_0 - tmp_kernel_op_3 + tmp_kernel_op_4*-4.0;
       const real_t tmp_kernel_op_12 = tmp_kernel_op_3 + tmp_kernel_op_5 + tmp_kernel_op_8 - 1.0;
       const real_t tmp_kernel_op_17 = jac_affine_inv_1_0_GRAY*8.0;
       const real_t tmp_kernel_op_18 = jac_affine_inv_1_1_GRAY*8.0;
       const real_t tmp_kernel_op_19 = abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_17 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_18);
       const real_t tmp_kernel_op_20 = 0.80000000000000004;
       const real_t tmp_kernel_op_21 = 2.3999999999999999;
       const real_t tmp_kernel_op_22 = tmp_kernel_op_20 + tmp_kernel_op_21 - 3.0;
       const real_t tmp_kernel_op_23 = tmp_kernel_op_20*0.59999999999999998;
       const real_t tmp_kernel_op_24 = 0.040000000000000008;
       const real_t tmp_kernel_op_25 = tmp_kernel_op_24*2.0;
       const real_t tmp_kernel_op_26 = tmp_kernel_op_25 - 0.20000000000000001;
       const real_t tmp_kernel_op_27 = 0.35999999999999999;
       const real_t tmp_kernel_op_28 = tmp_kernel_op_27*2.0;
       const real_t tmp_kernel_op_29 = tmp_kernel_op_28 - 0.59999999999999998;
       const real_t tmp_kernel_op_30 = tmp_kernel_op_21 - tmp_kernel_op_23 + tmp_kernel_op_27*-4.0;
       const real_t tmp_kernel_op_31 = tmp_kernel_op_20 - tmp_kernel_op_23 + tmp_kernel_op_24*-4.0;
       const real_t tmp_kernel_op_32 = tmp_kernel_op_23 + tmp_kernel_op_25 + tmp_kernel_op_28 - 1.3999999999999999;
       const real_t tmp_kernel_op_37 = 2.3999999999999999;
       const real_t tmp_kernel_op_38 = 0.80000000000000004;
       const real_t tmp_kernel_op_39 = tmp_kernel_op_37 + tmp_kernel_op_38 - 3.0;
       const real_t tmp_kernel_op_40 = tmp_kernel_op_37*0.20000000000000001;
       const real_t tmp_kernel_op_41 = 0.35999999999999999;
       const real_t tmp_kernel_op_42 = tmp_kernel_op_41*2.0;
       const real_t tmp_kernel_op_43 = tmp_kernel_op_42 - 0.59999999999999998;
       const real_t tmp_kernel_op_44 = 0.040000000000000008;
       const real_t tmp_kernel_op_45 = tmp_kernel_op_44*2.0;
       const real_t tmp_kernel_op_46 = tmp_kernel_op_45 - 0.20000000000000001;
       const real_t tmp_kernel_op_47 = tmp_kernel_op_38 - tmp_kernel_op_40 + tmp_kernel_op_44*-4.0;
       const real_t tmp_kernel_op_48 = tmp_kernel_op_37 - tmp_kernel_op_40 + tmp_kernel_op_41*-4.0;
       const real_t tmp_kernel_op_49 = tmp_kernel_op_40 + tmp_kernel_op_42 + tmp_kernel_op_45 - 1.3999999999999999;
       const real_t tmp_kernel_op_54 = 0.80000000000000004;
       const real_t tmp_kernel_op_55 = 0.80000000000000004;
       const real_t tmp_kernel_op_56 = tmp_kernel_op_54 + tmp_kernel_op_55 - 3.0;
       const real_t tmp_kernel_op_57 = tmp_kernel_op_54*0.20000000000000001;
       const real_t tmp_kernel_op_58 = 0.040000000000000008;
       const real_t tmp_kernel_op_59 = tmp_kernel_op_58*2.0;
       const real_t tmp_kernel_op_60 = tmp_kernel_op_59 - 0.20000000000000001;
       const real_t tmp_kernel_op_61 = 0.040000000000000008;
       const real_t tmp_kernel_op_62 = tmp_kernel_op_61*2.0;
       const real_t tmp_kernel_op_63 = tmp_kernel_op_62 - 0.20000000000000001;
       const real_t tmp_kernel_op_64 = tmp_kernel_op_55 - tmp_kernel_op_57 + tmp_kernel_op_61*-4.0;
       const real_t tmp_kernel_op_65 = tmp_kernel_op_54 - tmp_kernel_op_57 + tmp_kernel_op_58*-4.0;
       const real_t tmp_kernel_op_66 = tmp_kernel_op_57 + tmp_kernel_op_59 + tmp_kernel_op_62 - 0.20000000000000018;
       const real_t tmp_kernel_op_71 = abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*jac_affine_inv_0_0_GRAY)*4.0 + (jac_affine_inv_0_1_GRAY*jac_affine_inv_0_1_GRAY)*4.0);
       const real_t tmp_kernel_op_72 = abs_det_jac_affine_GRAY*((jac_affine_inv_1_0_GRAY*jac_affine_inv_1_0_GRAY)*4.0 + (jac_affine_inv_1_1_GRAY*jac_affine_inv_1_1_GRAY)*4.0);
       const real_t tmp_kernel_op_73 = jac_affine_inv_0_0_GRAY*4.0;
       const real_t tmp_kernel_op_74 = jac_affine_inv_0_1_GRAY*4.0;
       const real_t tmp_kernel_op_75 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_73 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_74;
       const real_t tmp_kernel_op_76 = abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(-tmp_kernel_op_17 - tmp_kernel_op_73) + jac_affine_inv_1_1_GRAY*(-tmp_kernel_op_18 - tmp_kernel_op_74) - tmp_kernel_op_75);
       const real_t tmp_kernel_op_77 = jac_affine_inv_1_0_GRAY*4.0;
       const real_t tmp_kernel_op_78 = jac_affine_inv_1_1_GRAY*4.0;
       const real_t tmp_kernel_op_79 = abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-8.0 - tmp_kernel_op_77) + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-8.0 - tmp_kernel_op_78) - tmp_kernel_op_75);
       const real_t tmp_kernel_op_80 = tmp_kernel_op_73 + tmp_kernel_op_77;
       const real_t tmp_kernel_op_81 = tmp_kernel_op_74 + tmp_kernel_op_78;
       const real_t tmp_kernel_op_82 = abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_80 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_81 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_80 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_81);
       const real_t tmp_kernel_op_83 = tmp_kernel_op_0 - 1.0;
       const real_t tmp_kernel_op_85 = tmp_kernel_op_20 - 1.0;
       const real_t tmp_kernel_op_87 = tmp_kernel_op_37 - 1.0;
       const real_t tmp_kernel_op_89 = tmp_kernel_op_54 - 1.0;
       const real_t tmp_kernel_op_91 = tmp_kernel_op_1 - 1.0;
       const real_t tmp_kernel_op_93 = tmp_kernel_op_21 - 1.0;
       const real_t tmp_kernel_op_95 = tmp_kernel_op_38 - 1.0;
       const real_t tmp_kernel_op_97 = tmp_kernel_op_55 - 1.0;
       const real_t tmp_kernel_op_99 = jac_affine_inv_0_0_GRAY*tmp_kernel_op_1;
       const real_t tmp_kernel_op_100 = jac_affine_inv_1_0_GRAY*tmp_kernel_op_0;
       const real_t tmp_kernel_op_101 = jac_affine_inv_0_1_GRAY*tmp_kernel_op_1;
       const real_t tmp_kernel_op_102 = jac_affine_inv_1_1_GRAY*tmp_kernel_op_0;
       const real_t tmp_kernel_op_104 = tmp_kernel_op_73*0.59999999999999998;
       const real_t tmp_kernel_op_105 = tmp_kernel_op_77*0.20000000000000001;
       const real_t tmp_kernel_op_106 = tmp_kernel_op_74*0.59999999999999998;
       const real_t tmp_kernel_op_107 = tmp_kernel_op_78*0.20000000000000001;
       const real_t tmp_kernel_op_109 = tmp_kernel_op_73*0.20000000000000001;
       const real_t tmp_kernel_op_110 = tmp_kernel_op_77*0.59999999999999998;
       const real_t tmp_kernel_op_111 = tmp_kernel_op_74*0.20000000000000001;
       const real_t tmp_kernel_op_112 = tmp_kernel_op_78*0.59999999999999998;
       const real_t tmp_kernel_op_114 = tmp_kernel_op_73*0.20000000000000001;
       const real_t tmp_kernel_op_115 = tmp_kernel_op_77*0.20000000000000001;
       const real_t tmp_kernel_op_116 = tmp_kernel_op_74*0.20000000000000001;
       const real_t tmp_kernel_op_117 = tmp_kernel_op_78*0.20000000000000001;
       const real_t tmp_kernel_op_119 = -tmp_kernel_op_0 + 1.3333333333333335;
       const real_t tmp_kernel_op_121 = -tmp_kernel_op_20 - 0.79999999999999982;
       const real_t tmp_kernel_op_123 = -tmp_kernel_op_37 + 2.3999999999999999;
       const real_t tmp_kernel_op_125 = -tmp_kernel_op_54 + 2.3999999999999999;
       const real_t tmp_kernel_op_127 = -tmp_kernel_op_1 + 1.3333333333333335;
       const real_t tmp_kernel_op_129 = -tmp_kernel_op_21 + 2.3999999999999999;
       const real_t tmp_kernel_op_131 = -tmp_kernel_op_38 - 0.79999999999999982;
       const real_t tmp_kernel_op_133 = -tmp_kernel_op_55 + 2.3999999999999999;
       {
          /* FaceType.GRAY */
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d diffusivity_times_delta_dof_0 = _mm256_loadu_pd(& _data_diffusivity_times_deltaVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d diffusivity_times_delta_dof_1 = _mm256_loadu_pd(& _data_diffusivity_times_deltaVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d diffusivity_times_delta_dof_2 = _mm256_loadu_pd(& _data_diffusivity_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d diffusivity_times_delta_dof_3 = _mm256_loadu_pd(& _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d diffusivity_times_delta_dof_4 = _mm256_loadu_pd(& _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d diffusivity_times_delta_dof_5 = _mm256_loadu_pd(& _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d wx_dof_0 = _mm256_loadu_pd(& _data_wxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d wx_dof_1 = _mm256_loadu_pd(& _data_wxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d wx_dof_2 = _mm256_loadu_pd(& _data_wxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d wx_dof_3 = _mm256_loadu_pd(& _data_wxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d wx_dof_4 = _mm256_loadu_pd(& _data_wxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d wx_dof_5 = _mm256_loadu_pd(& _data_wxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d wy_dof_0 = _mm256_loadu_pd(& _data_wyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d wy_dof_1 = _mm256_loadu_pd(& _data_wyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d wy_dof_2 = _mm256_loadu_pd(& _data_wyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d wy_dof_3 = _mm256_loadu_pd(& _data_wyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d wy_dof_4 = _mm256_loadu_pd(& _data_wyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d wy_dof_5 = _mm256_loadu_pd(& _data_wyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]);
                const __m256d tmp_kernel_op_13 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(wx_dof_4,_mm256_set_pd(tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10)),_mm256_mul_pd(wx_dof_5,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(wx_dof_0,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12))),_mm256_mul_pd(wx_dof_3,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(wx_dof_1,_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6))),_mm256_mul_pd(wx_dof_2,_mm256_set_pd(tmp_kernel_op_9,tmp_kernel_op_9,tmp_kernel_op_9,tmp_kernel_op_9)));
                const __m256d tmp_kernel_op_14 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(wy_dof_4,_mm256_set_pd(tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10)),_mm256_mul_pd(wy_dof_5,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(wy_dof_0,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12))),_mm256_mul_pd(wy_dof_3,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(wy_dof_1,_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6))),_mm256_mul_pd(wy_dof_2,_mm256_set_pd(tmp_kernel_op_9,tmp_kernel_op_9,tmp_kernel_op_9,tmp_kernel_op_9)));
                const __m256d tmp_kernel_op_15 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_4,_mm256_set_pd(-0.28125,-0.28125,-0.28125,-0.28125)),_mm256_set_pd(tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10)),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_5,_mm256_set_pd(-0.28125,-0.28125,-0.28125,-0.28125)),_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_0,_mm256_set_pd(-0.28125,-0.28125,-0.28125,-0.28125)),_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_3,_mm256_set_pd(-0.28125,-0.28125,-0.28125,-0.28125)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_1,_mm256_set_pd(-0.28125,-0.28125,-0.28125,-0.28125)),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_2,_mm256_set_pd(-0.28125,-0.28125,-0.28125,-0.28125)),_mm256_set_pd(tmp_kernel_op_9,tmp_kernel_op_9,tmp_kernel_op_9,tmp_kernel_op_9)));
                const __m256d tmp_kernel_op_16 = _mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)))),_mm256_mul_pd(tmp_kernel_op_14,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))))));
                const __m256d tmp_kernel_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(wx_dof_3,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_mul_pd(wx_dof_1,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_mul_pd(wx_dof_2,_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29))),_mm256_mul_pd(wx_dof_4,_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(wx_dof_5,_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(wx_dof_0,_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32)));
                const __m256d tmp_kernel_op_34 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(wy_dof_3,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_mul_pd(wy_dof_1,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_mul_pd(wy_dof_2,_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29))),_mm256_mul_pd(wy_dof_4,_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(wy_dof_5,_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(wy_dof_0,_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32)));
                const __m256d tmp_kernel_op_35 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_3,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_1,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_2,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_4,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_5,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_0,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32)));
                const __m256d tmp_kernel_op_36 = _mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_33,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY),_mm256_set_pd(tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY),_mm256_set_pd(tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22)))),_mm256_mul_pd(tmp_kernel_op_34,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY),_mm256_set_pd(tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY),_mm256_set_pd(tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22))))));
                const __m256d tmp_kernel_op_50 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(wx_dof_3,_mm256_set_pd(tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40)),_mm256_mul_pd(wx_dof_1,_mm256_set_pd(tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43))),_mm256_mul_pd(wx_dof_2,_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46))),_mm256_mul_pd(wx_dof_4,_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(wx_dof_5,_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48))),_mm256_mul_pd(wx_dof_0,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)));
                const __m256d tmp_kernel_op_51 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(wy_dof_3,_mm256_set_pd(tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40)),_mm256_mul_pd(wy_dof_1,_mm256_set_pd(tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43))),_mm256_mul_pd(wy_dof_2,_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46))),_mm256_mul_pd(wy_dof_4,_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(wy_dof_5,_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48))),_mm256_mul_pd(wy_dof_0,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)));
                const __m256d tmp_kernel_op_52 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_3,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40)),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_1,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_2,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_4,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_5,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_0,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)));
                const __m256d tmp_kernel_op_53 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39)))),_mm256_mul_pd(tmp_kernel_op_51,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39))))));
                const __m256d tmp_kernel_op_67 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(wx_dof_3,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57)),_mm256_mul_pd(wx_dof_1,_mm256_set_pd(tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60))),_mm256_mul_pd(wx_dof_2,_mm256_set_pd(tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63))),_mm256_mul_pd(wx_dof_4,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_mul_pd(wx_dof_5,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(wx_dof_0,_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66)));
                const __m256d tmp_kernel_op_68 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(wy_dof_3,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57)),_mm256_mul_pd(wy_dof_1,_mm256_set_pd(tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60))),_mm256_mul_pd(wy_dof_2,_mm256_set_pd(tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63))),_mm256_mul_pd(wy_dof_4,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_mul_pd(wy_dof_5,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(wy_dof_0,_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66)));
                const __m256d tmp_kernel_op_69 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_3,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57)),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_1,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_2,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_4,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_5,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_0,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66)));
                const __m256d tmp_kernel_op_70 = _mm256_mul_pd(tmp_kernel_op_69,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)))),_mm256_mul_pd(tmp_kernel_op_68,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))))));
                const __m256d tmp_kernel_op_84 = _mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY)),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_14,_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY)),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))));
                const __m256d tmp_kernel_op_86 = _mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_33,_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY)),_mm256_set_pd(tmp_kernel_op_85,tmp_kernel_op_85,tmp_kernel_op_85,tmp_kernel_op_85)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_34,_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY)),_mm256_set_pd(tmp_kernel_op_85,tmp_kernel_op_85,tmp_kernel_op_85,tmp_kernel_op_85))));
                const __m256d tmp_kernel_op_88 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY)),_mm256_set_pd(tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_51,_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY)),_mm256_set_pd(tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87))));
                const __m256d tmp_kernel_op_90 = _mm256_mul_pd(tmp_kernel_op_69,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY)),_mm256_set_pd(tmp_kernel_op_89,tmp_kernel_op_89,tmp_kernel_op_89,tmp_kernel_op_89)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY)),_mm256_set_pd(tmp_kernel_op_89,tmp_kernel_op_89,tmp_kernel_op_89,tmp_kernel_op_89))));
                const __m256d tmp_kernel_op_92 = _mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY)),_mm256_set_pd(tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_14,_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY)),_mm256_set_pd(tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91))));
                const __m256d tmp_kernel_op_94 = _mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_33,_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY)),_mm256_set_pd(tmp_kernel_op_93,tmp_kernel_op_93,tmp_kernel_op_93,tmp_kernel_op_93)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_34,_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY)),_mm256_set_pd(tmp_kernel_op_93,tmp_kernel_op_93,tmp_kernel_op_93,tmp_kernel_op_93))));
                const __m256d tmp_kernel_op_96 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY)),_mm256_set_pd(tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_51,_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY)),_mm256_set_pd(tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95))));
                const __m256d tmp_kernel_op_98 = _mm256_mul_pd(tmp_kernel_op_69,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY)),_mm256_set_pd(tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY)),_mm256_set_pd(tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97))));
                const __m256d tmp_kernel_op_103 = _mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100),_mm256_set_pd(tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99))),_mm256_mul_pd(tmp_kernel_op_14,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_101,tmp_kernel_op_101,tmp_kernel_op_101,tmp_kernel_op_101),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)))));
                const __m256d tmp_kernel_op_108 = _mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_33,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105))),_mm256_mul_pd(tmp_kernel_op_34,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_106,tmp_kernel_op_106,tmp_kernel_op_106,tmp_kernel_op_106),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)))));
                const __m256d tmp_kernel_op_113 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(tmp_kernel_op_51,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111),_mm256_set_pd(tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112)))));
                const __m256d tmp_kernel_op_118 = _mm256_mul_pd(tmp_kernel_op_69,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_114,tmp_kernel_op_114,tmp_kernel_op_114,tmp_kernel_op_114),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115))),_mm256_mul_pd(tmp_kernel_op_68,_mm256_add_pd(_mm256_set_pd(tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116),_mm256_set_pd(tmp_kernel_op_117,tmp_kernel_op_117,tmp_kernel_op_117,tmp_kernel_op_117)))));
                const __m256d tmp_kernel_op_120 = _mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_14,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_101,tmp_kernel_op_101,tmp_kernel_op_101,tmp_kernel_op_101)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY),_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119)))),_mm256_mul_pd(tmp_kernel_op_13,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY),_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))))));
                const __m256d tmp_kernel_op_122 = _mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_33,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)))),_mm256_mul_pd(tmp_kernel_op_34,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_106,tmp_kernel_op_106,tmp_kernel_op_106,tmp_kernel_op_106)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))))));
                const __m256d tmp_kernel_op_124 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY),_mm256_set_pd(tmp_kernel_op_123,tmp_kernel_op_123,tmp_kernel_op_123,tmp_kernel_op_123)))),_mm256_mul_pd(tmp_kernel_op_51,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY),_mm256_set_pd(tmp_kernel_op_123,tmp_kernel_op_123,tmp_kernel_op_123,tmp_kernel_op_123))))));
                const __m256d tmp_kernel_op_126 = _mm256_mul_pd(tmp_kernel_op_69,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_114,tmp_kernel_op_114,tmp_kernel_op_114,tmp_kernel_op_114)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY,jac_affine_inv_1_0_GRAY),_mm256_set_pd(tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125)))),_mm256_mul_pd(tmp_kernel_op_68,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY,jac_affine_inv_1_1_GRAY),_mm256_set_pd(tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125))))));
                const __m256d tmp_kernel_op_128 = _mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY),_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127)))),_mm256_mul_pd(tmp_kernel_op_14,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY),_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127))))));
                const __m256d tmp_kernel_op_130 = _mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_33,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105,tmp_kernel_op_105)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY),_mm256_set_pd(tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129)))),_mm256_mul_pd(tmp_kernel_op_34,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY),_mm256_set_pd(tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129))))));
                const __m256d tmp_kernel_op_132 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY),_mm256_set_pd(tmp_kernel_op_131,tmp_kernel_op_131,tmp_kernel_op_131,tmp_kernel_op_131)))),_mm256_mul_pd(tmp_kernel_op_51,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112,tmp_kernel_op_112)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY),_mm256_set_pd(tmp_kernel_op_131,tmp_kernel_op_131,tmp_kernel_op_131,tmp_kernel_op_131))))));
                const __m256d tmp_kernel_op_134 = _mm256_mul_pd(tmp_kernel_op_69,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY,jac_affine_inv_0_0_GRAY),_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133)))),_mm256_mul_pd(tmp_kernel_op_68,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_117,tmp_kernel_op_117,tmp_kernel_op_117,tmp_kernel_op_117)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY,jac_affine_inv_0_1_GRAY),_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133))))));
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_mul_pd(tmp_kernel_op_36,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71)),_mm256_mul_pd(tmp_kernel_op_36,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72)),_mm256_mul_pd(tmp_kernel_op_36,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76)),_mm256_mul_pd(tmp_kernel_op_36,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79)),_mm256_mul_pd(tmp_kernel_op_36,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)),_mm256_mul_pd(tmp_kernel_op_36,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)))));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_mul_pd(tmp_kernel_op_86,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19))),_mm256_mul_pd(tmp_kernel_op_88,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19))),_mm256_mul_pd(tmp_kernel_op_90,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71)),_mm256_mul_pd(tmp_kernel_op_86,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))),_mm256_mul_pd(tmp_kernel_op_88,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))),_mm256_mul_pd(tmp_kernel_op_90,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72)),_mm256_mul_pd(tmp_kernel_op_86,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))),_mm256_mul_pd(tmp_kernel_op_88,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))),_mm256_mul_pd(tmp_kernel_op_90,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76)),_mm256_mul_pd(tmp_kernel_op_86,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(tmp_kernel_op_88,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(tmp_kernel_op_90,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79)),_mm256_mul_pd(tmp_kernel_op_86,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(tmp_kernel_op_88,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(tmp_kernel_op_90,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)),_mm256_mul_pd(tmp_kernel_op_86,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_mul_pd(tmp_kernel_op_88,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_mul_pd(tmp_kernel_op_90,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)))));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19))),_mm256_mul_pd(tmp_kernel_op_96,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19))),_mm256_mul_pd(tmp_kernel_op_98,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71)),_mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))),_mm256_mul_pd(tmp_kernel_op_96,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))),_mm256_mul_pd(tmp_kernel_op_98,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72)),_mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))),_mm256_mul_pd(tmp_kernel_op_96,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))),_mm256_mul_pd(tmp_kernel_op_98,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76)),_mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(tmp_kernel_op_96,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(tmp_kernel_op_98,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79)),_mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(tmp_kernel_op_96,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(tmp_kernel_op_98,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)),_mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_mul_pd(tmp_kernel_op_96,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_mul_pd(tmp_kernel_op_98,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)))));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_103,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19))),_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19))),_mm256_mul_pd(tmp_kernel_op_118,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_103,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71)),_mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))),_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))),_mm256_mul_pd(tmp_kernel_op_118,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_103,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72)),_mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))),_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))),_mm256_mul_pd(tmp_kernel_op_118,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_103,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76)),_mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(tmp_kernel_op_118,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_103,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79)),_mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(tmp_kernel_op_118,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_103,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)),_mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_mul_pd(tmp_kernel_op_118,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)))));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_mul_pd(tmp_kernel_op_122,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19))),_mm256_mul_pd(tmp_kernel_op_124,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19))),_mm256_mul_pd(tmp_kernel_op_126,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71)),_mm256_mul_pd(tmp_kernel_op_122,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))),_mm256_mul_pd(tmp_kernel_op_124,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))),_mm256_mul_pd(tmp_kernel_op_126,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72)),_mm256_mul_pd(tmp_kernel_op_122,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))),_mm256_mul_pd(tmp_kernel_op_124,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))),_mm256_mul_pd(tmp_kernel_op_126,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76)),_mm256_mul_pd(tmp_kernel_op_122,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(tmp_kernel_op_124,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(tmp_kernel_op_126,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79)),_mm256_mul_pd(tmp_kernel_op_122,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(tmp_kernel_op_124,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(tmp_kernel_op_126,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)),_mm256_mul_pd(tmp_kernel_op_122,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_mul_pd(tmp_kernel_op_124,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_mul_pd(tmp_kernel_op_126,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)))));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)),_mm256_mul_pd(tmp_kernel_op_130,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19))),_mm256_mul_pd(tmp_kernel_op_132,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19))),_mm256_mul_pd(tmp_kernel_op_134,_mm256_set_pd(tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19,tmp_kernel_op_19)))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71)),_mm256_mul_pd(tmp_kernel_op_130,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))),_mm256_mul_pd(tmp_kernel_op_132,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))),_mm256_mul_pd(tmp_kernel_op_134,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72)),_mm256_mul_pd(tmp_kernel_op_130,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))),_mm256_mul_pd(tmp_kernel_op_132,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))),_mm256_mul_pd(tmp_kernel_op_134,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76)),_mm256_mul_pd(tmp_kernel_op_130,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(tmp_kernel_op_132,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_mul_pd(tmp_kernel_op_134,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))))),_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79)),_mm256_mul_pd(tmp_kernel_op_130,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(tmp_kernel_op_132,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(tmp_kernel_op_134,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)),_mm256_mul_pd(tmp_kernel_op_130,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_mul_pd(tmp_kernel_op_132,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_mul_pd(tmp_kernel_op_134,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)))));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 < -ctr_1 + micro_edges_per_macro_edge; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t src_dof_3 = _data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t diffusivity_times_delta_dof_0 = _data_diffusivity_times_deltaVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t diffusivity_times_delta_dof_1 = _data_diffusivity_times_deltaVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t diffusivity_times_delta_dof_2 = _data_diffusivity_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t diffusivity_times_delta_dof_3 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t diffusivity_times_delta_dof_4 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t diffusivity_times_delta_dof_5 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t wx_dof_0 = _data_wxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t wx_dof_1 = _data_wxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t wx_dof_2 = _data_wxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t wx_dof_3 = _data_wxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t wx_dof_4 = _data_wxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t wx_dof_5 = _data_wxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t wy_dof_0 = _data_wyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t wy_dof_1 = _data_wyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t wy_dof_2 = _data_wyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t wy_dof_3 = _data_wyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t wy_dof_4 = _data_wyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t wy_dof_5 = _data_wyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
                const real_t tmp_kernel_op_13 = tmp_kernel_op_10*wx_dof_4 + tmp_kernel_op_11*wx_dof_5 + tmp_kernel_op_12*wx_dof_0 + tmp_kernel_op_3*wx_dof_3 + tmp_kernel_op_6*wx_dof_1 + tmp_kernel_op_9*wx_dof_2;
                const real_t tmp_kernel_op_14 = tmp_kernel_op_10*wy_dof_4 + tmp_kernel_op_11*wy_dof_5 + tmp_kernel_op_12*wy_dof_0 + tmp_kernel_op_3*wy_dof_3 + tmp_kernel_op_6*wy_dof_1 + tmp_kernel_op_9*wy_dof_2;
                const real_t tmp_kernel_op_15 = diffusivity_times_delta_dof_0*tmp_kernel_op_12*-0.28125 + diffusivity_times_delta_dof_1*tmp_kernel_op_6*-0.28125 + diffusivity_times_delta_dof_2*tmp_kernel_op_9*-0.28125 + diffusivity_times_delta_dof_3*tmp_kernel_op_3*-0.28125 + diffusivity_times_delta_dof_4*tmp_kernel_op_10*-0.28125 + diffusivity_times_delta_dof_5*tmp_kernel_op_11*-0.28125;
                const real_t tmp_kernel_op_16 = tmp_kernel_op_15*(tmp_kernel_op_13*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_2 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_2) + tmp_kernel_op_14*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_2 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_2));
                const real_t tmp_kernel_op_33 = tmp_kernel_op_23*wx_dof_3 + tmp_kernel_op_26*wx_dof_1 + tmp_kernel_op_29*wx_dof_2 + tmp_kernel_op_30*wx_dof_4 + tmp_kernel_op_31*wx_dof_5 + tmp_kernel_op_32*wx_dof_0;
                const real_t tmp_kernel_op_34 = tmp_kernel_op_23*wy_dof_3 + tmp_kernel_op_26*wy_dof_1 + tmp_kernel_op_29*wy_dof_2 + tmp_kernel_op_30*wy_dof_4 + tmp_kernel_op_31*wy_dof_5 + tmp_kernel_op_32*wy_dof_0;
                const real_t tmp_kernel_op_35 = diffusivity_times_delta_dof_0*tmp_kernel_op_32*0.26041666666666669 + diffusivity_times_delta_dof_1*tmp_kernel_op_26*0.26041666666666669 + diffusivity_times_delta_dof_2*tmp_kernel_op_29*0.26041666666666669 + diffusivity_times_delta_dof_3*tmp_kernel_op_23*0.26041666666666669 + diffusivity_times_delta_dof_4*tmp_kernel_op_30*0.26041666666666669 + diffusivity_times_delta_dof_5*tmp_kernel_op_31*0.26041666666666669;
                const real_t tmp_kernel_op_36 = tmp_kernel_op_35*(tmp_kernel_op_33*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_22 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_22) + tmp_kernel_op_34*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_22 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_22));
                const real_t tmp_kernel_op_50 = tmp_kernel_op_40*wx_dof_3 + tmp_kernel_op_43*wx_dof_1 + tmp_kernel_op_46*wx_dof_2 + tmp_kernel_op_47*wx_dof_4 + tmp_kernel_op_48*wx_dof_5 + tmp_kernel_op_49*wx_dof_0;
                const real_t tmp_kernel_op_51 = tmp_kernel_op_40*wy_dof_3 + tmp_kernel_op_43*wy_dof_1 + tmp_kernel_op_46*wy_dof_2 + tmp_kernel_op_47*wy_dof_4 + tmp_kernel_op_48*wy_dof_5 + tmp_kernel_op_49*wy_dof_0;
                const real_t tmp_kernel_op_52 = diffusivity_times_delta_dof_0*tmp_kernel_op_49*0.26041666666666669 + diffusivity_times_delta_dof_1*tmp_kernel_op_43*0.26041666666666669 + diffusivity_times_delta_dof_2*tmp_kernel_op_46*0.26041666666666669 + diffusivity_times_delta_dof_3*tmp_kernel_op_40*0.26041666666666669 + diffusivity_times_delta_dof_4*tmp_kernel_op_47*0.26041666666666669 + diffusivity_times_delta_dof_5*tmp_kernel_op_48*0.26041666666666669;
                const real_t tmp_kernel_op_53 = tmp_kernel_op_52*(tmp_kernel_op_50*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_39 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_39) + tmp_kernel_op_51*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_39 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_39));
                const real_t tmp_kernel_op_67 = tmp_kernel_op_57*wx_dof_3 + tmp_kernel_op_60*wx_dof_1 + tmp_kernel_op_63*wx_dof_2 + tmp_kernel_op_64*wx_dof_4 + tmp_kernel_op_65*wx_dof_5 + tmp_kernel_op_66*wx_dof_0;
                const real_t tmp_kernel_op_68 = tmp_kernel_op_57*wy_dof_3 + tmp_kernel_op_60*wy_dof_1 + tmp_kernel_op_63*wy_dof_2 + tmp_kernel_op_64*wy_dof_4 + tmp_kernel_op_65*wy_dof_5 + tmp_kernel_op_66*wy_dof_0;
                const real_t tmp_kernel_op_69 = diffusivity_times_delta_dof_0*tmp_kernel_op_66*0.26041666666666669 + diffusivity_times_delta_dof_1*tmp_kernel_op_60*0.26041666666666669 + diffusivity_times_delta_dof_2*tmp_kernel_op_63*0.26041666666666669 + diffusivity_times_delta_dof_3*tmp_kernel_op_57*0.26041666666666669 + diffusivity_times_delta_dof_4*tmp_kernel_op_64*0.26041666666666669 + diffusivity_times_delta_dof_5*tmp_kernel_op_65*0.26041666666666669;
                const real_t tmp_kernel_op_70 = tmp_kernel_op_69*(tmp_kernel_op_67*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_56 + jac_affine_inv_1_0_GRAY*tmp_kernel_op_56) + tmp_kernel_op_68*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_56 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_56));
                const real_t tmp_kernel_op_84 = tmp_kernel_op_15*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_13*tmp_kernel_op_83 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_14*tmp_kernel_op_83);
                const real_t tmp_kernel_op_86 = tmp_kernel_op_35*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_33*tmp_kernel_op_85 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_34*tmp_kernel_op_85);
                const real_t tmp_kernel_op_88 = tmp_kernel_op_52*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_50*tmp_kernel_op_87 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_51*tmp_kernel_op_87);
                const real_t tmp_kernel_op_90 = tmp_kernel_op_69*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_67*tmp_kernel_op_89 + jac_affine_inv_0_1_GRAY*tmp_kernel_op_68*tmp_kernel_op_89);
                const real_t tmp_kernel_op_92 = tmp_kernel_op_15*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_13*tmp_kernel_op_91 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_14*tmp_kernel_op_91);
                const real_t tmp_kernel_op_94 = tmp_kernel_op_35*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_33*tmp_kernel_op_93 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_34*tmp_kernel_op_93);
                const real_t tmp_kernel_op_96 = tmp_kernel_op_52*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_50*tmp_kernel_op_95 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_51*tmp_kernel_op_95);
                const real_t tmp_kernel_op_98 = tmp_kernel_op_69*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_67*tmp_kernel_op_97 + jac_affine_inv_1_1_GRAY*tmp_kernel_op_68*tmp_kernel_op_97);
                const real_t tmp_kernel_op_103 = tmp_kernel_op_15*(tmp_kernel_op_13*(tmp_kernel_op_100 + tmp_kernel_op_99) + tmp_kernel_op_14*(tmp_kernel_op_101 + tmp_kernel_op_102));
                const real_t tmp_kernel_op_108 = tmp_kernel_op_35*(tmp_kernel_op_33*(tmp_kernel_op_104 + tmp_kernel_op_105) + tmp_kernel_op_34*(tmp_kernel_op_106 + tmp_kernel_op_107));
                const real_t tmp_kernel_op_113 = tmp_kernel_op_52*(tmp_kernel_op_50*(tmp_kernel_op_109 + tmp_kernel_op_110) + tmp_kernel_op_51*(tmp_kernel_op_111 + tmp_kernel_op_112));
                const real_t tmp_kernel_op_118 = tmp_kernel_op_69*(tmp_kernel_op_67*(tmp_kernel_op_114 + tmp_kernel_op_115) + tmp_kernel_op_68*(tmp_kernel_op_116 + tmp_kernel_op_117));
                const real_t tmp_kernel_op_120 = tmp_kernel_op_15*(tmp_kernel_op_13*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_119 - tmp_kernel_op_99) + tmp_kernel_op_14*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_119 - tmp_kernel_op_101));
                const real_t tmp_kernel_op_122 = tmp_kernel_op_35*(tmp_kernel_op_33*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_121 - tmp_kernel_op_104) + tmp_kernel_op_34*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_121 - tmp_kernel_op_106));
                const real_t tmp_kernel_op_124 = tmp_kernel_op_52*(tmp_kernel_op_50*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_123 - tmp_kernel_op_109) + tmp_kernel_op_51*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_123 - tmp_kernel_op_111));
                const real_t tmp_kernel_op_126 = tmp_kernel_op_69*(tmp_kernel_op_67*(jac_affine_inv_1_0_GRAY*tmp_kernel_op_125 - tmp_kernel_op_114) + tmp_kernel_op_68*(jac_affine_inv_1_1_GRAY*tmp_kernel_op_125 - tmp_kernel_op_116));
                const real_t tmp_kernel_op_128 = tmp_kernel_op_15*(tmp_kernel_op_13*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_127 - tmp_kernel_op_100) + tmp_kernel_op_14*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_127 - tmp_kernel_op_102));
                const real_t tmp_kernel_op_130 = tmp_kernel_op_35*(tmp_kernel_op_33*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_129 - tmp_kernel_op_105) + tmp_kernel_op_34*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_129 - tmp_kernel_op_107));
                const real_t tmp_kernel_op_132 = tmp_kernel_op_52*(tmp_kernel_op_50*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_131 - tmp_kernel_op_110) + tmp_kernel_op_51*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_131 - tmp_kernel_op_112));
                const real_t tmp_kernel_op_134 = tmp_kernel_op_69*(tmp_kernel_op_67*(jac_affine_inv_0_0_GRAY*tmp_kernel_op_133 - tmp_kernel_op_115) + tmp_kernel_op_68*(jac_affine_inv_0_1_GRAY*tmp_kernel_op_133 - tmp_kernel_op_117));
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_16*tmp_kernel_op_82 + tmp_kernel_op_36*tmp_kernel_op_82 + tmp_kernel_op_53*tmp_kernel_op_82 + tmp_kernel_op_70*tmp_kernel_op_82) + src_dof_1*(tmp_kernel_op_16*tmp_kernel_op_71 + tmp_kernel_op_36*tmp_kernel_op_71 + tmp_kernel_op_53*tmp_kernel_op_71 + tmp_kernel_op_70*tmp_kernel_op_71) + src_dof_2*(tmp_kernel_op_16*tmp_kernel_op_72 + tmp_kernel_op_36*tmp_kernel_op_72 + tmp_kernel_op_53*tmp_kernel_op_72 + tmp_kernel_op_70*tmp_kernel_op_72) + src_dof_3*(tmp_kernel_op_16*tmp_kernel_op_19 + tmp_kernel_op_19*tmp_kernel_op_36 + tmp_kernel_op_19*tmp_kernel_op_53 + tmp_kernel_op_19*tmp_kernel_op_70) + src_dof_4*(tmp_kernel_op_16*tmp_kernel_op_76 + tmp_kernel_op_36*tmp_kernel_op_76 + tmp_kernel_op_53*tmp_kernel_op_76 + tmp_kernel_op_70*tmp_kernel_op_76) + src_dof_5*(tmp_kernel_op_16*tmp_kernel_op_79 + tmp_kernel_op_36*tmp_kernel_op_79 + tmp_kernel_op_53*tmp_kernel_op_79 + tmp_kernel_op_70*tmp_kernel_op_79);
                const real_t elMatVec_1 = src_dof_0*(tmp_kernel_op_82*tmp_kernel_op_84 + tmp_kernel_op_82*tmp_kernel_op_86 + tmp_kernel_op_82*tmp_kernel_op_88 + tmp_kernel_op_82*tmp_kernel_op_90) + src_dof_1*(tmp_kernel_op_71*tmp_kernel_op_84 + tmp_kernel_op_71*tmp_kernel_op_86 + tmp_kernel_op_71*tmp_kernel_op_88 + tmp_kernel_op_71*tmp_kernel_op_90) + src_dof_2*(tmp_kernel_op_72*tmp_kernel_op_84 + tmp_kernel_op_72*tmp_kernel_op_86 + tmp_kernel_op_72*tmp_kernel_op_88 + tmp_kernel_op_72*tmp_kernel_op_90) + src_dof_3*(tmp_kernel_op_19*tmp_kernel_op_84 + tmp_kernel_op_19*tmp_kernel_op_86 + tmp_kernel_op_19*tmp_kernel_op_88 + tmp_kernel_op_19*tmp_kernel_op_90) + src_dof_4*(tmp_kernel_op_76*tmp_kernel_op_84 + tmp_kernel_op_76*tmp_kernel_op_86 + tmp_kernel_op_76*tmp_kernel_op_88 + tmp_kernel_op_76*tmp_kernel_op_90) + src_dof_5*(tmp_kernel_op_79*tmp_kernel_op_84 + tmp_kernel_op_79*tmp_kernel_op_86 + tmp_kernel_op_79*tmp_kernel_op_88 + tmp_kernel_op_79*tmp_kernel_op_90);
                const real_t elMatVec_2 = src_dof_0*(tmp_kernel_op_82*tmp_kernel_op_92 + tmp_kernel_op_82*tmp_kernel_op_94 + tmp_kernel_op_82*tmp_kernel_op_96 + tmp_kernel_op_82*tmp_kernel_op_98) + src_dof_1*(tmp_kernel_op_71*tmp_kernel_op_92 + tmp_kernel_op_71*tmp_kernel_op_94 + tmp_kernel_op_71*tmp_kernel_op_96 + tmp_kernel_op_71*tmp_kernel_op_98) + src_dof_2*(tmp_kernel_op_72*tmp_kernel_op_92 + tmp_kernel_op_72*tmp_kernel_op_94 + tmp_kernel_op_72*tmp_kernel_op_96 + tmp_kernel_op_72*tmp_kernel_op_98) + src_dof_3*(tmp_kernel_op_19*tmp_kernel_op_92 + tmp_kernel_op_19*tmp_kernel_op_94 + tmp_kernel_op_19*tmp_kernel_op_96 + tmp_kernel_op_19*tmp_kernel_op_98) + src_dof_4*(tmp_kernel_op_76*tmp_kernel_op_92 + tmp_kernel_op_76*tmp_kernel_op_94 + tmp_kernel_op_76*tmp_kernel_op_96 + tmp_kernel_op_76*tmp_kernel_op_98) + src_dof_5*(tmp_kernel_op_79*tmp_kernel_op_92 + tmp_kernel_op_79*tmp_kernel_op_94 + tmp_kernel_op_79*tmp_kernel_op_96 + tmp_kernel_op_79*tmp_kernel_op_98);
                const real_t elMatVec_3 = src_dof_0*(tmp_kernel_op_103*tmp_kernel_op_82 + tmp_kernel_op_108*tmp_kernel_op_82 + tmp_kernel_op_113*tmp_kernel_op_82 + tmp_kernel_op_118*tmp_kernel_op_82) + src_dof_1*(tmp_kernel_op_103*tmp_kernel_op_71 + tmp_kernel_op_108*tmp_kernel_op_71 + tmp_kernel_op_113*tmp_kernel_op_71 + tmp_kernel_op_118*tmp_kernel_op_71) + src_dof_2*(tmp_kernel_op_103*tmp_kernel_op_72 + tmp_kernel_op_108*tmp_kernel_op_72 + tmp_kernel_op_113*tmp_kernel_op_72 + tmp_kernel_op_118*tmp_kernel_op_72) + src_dof_3*(tmp_kernel_op_103*tmp_kernel_op_19 + tmp_kernel_op_108*tmp_kernel_op_19 + tmp_kernel_op_113*tmp_kernel_op_19 + tmp_kernel_op_118*tmp_kernel_op_19) + src_dof_4*(tmp_kernel_op_103*tmp_kernel_op_76 + tmp_kernel_op_108*tmp_kernel_op_76 + tmp_kernel_op_113*tmp_kernel_op_76 + tmp_kernel_op_118*tmp_kernel_op_76) + src_dof_5*(tmp_kernel_op_103*tmp_kernel_op_79 + tmp_kernel_op_108*tmp_kernel_op_79 + tmp_kernel_op_113*tmp_kernel_op_79 + tmp_kernel_op_118*tmp_kernel_op_79);
                const real_t elMatVec_4 = src_dof_0*(tmp_kernel_op_120*tmp_kernel_op_82 + tmp_kernel_op_122*tmp_kernel_op_82 + tmp_kernel_op_124*tmp_kernel_op_82 + tmp_kernel_op_126*tmp_kernel_op_82) + src_dof_1*(tmp_kernel_op_120*tmp_kernel_op_71 + tmp_kernel_op_122*tmp_kernel_op_71 + tmp_kernel_op_124*tmp_kernel_op_71 + tmp_kernel_op_126*tmp_kernel_op_71) + src_dof_2*(tmp_kernel_op_120*tmp_kernel_op_72 + tmp_kernel_op_122*tmp_kernel_op_72 + tmp_kernel_op_124*tmp_kernel_op_72 + tmp_kernel_op_126*tmp_kernel_op_72) + src_dof_3*(tmp_kernel_op_120*tmp_kernel_op_19 + tmp_kernel_op_122*tmp_kernel_op_19 + tmp_kernel_op_124*tmp_kernel_op_19 + tmp_kernel_op_126*tmp_kernel_op_19) + src_dof_4*(tmp_kernel_op_120*tmp_kernel_op_76 + tmp_kernel_op_122*tmp_kernel_op_76 + tmp_kernel_op_124*tmp_kernel_op_76 + tmp_kernel_op_126*tmp_kernel_op_76) + src_dof_5*(tmp_kernel_op_120*tmp_kernel_op_79 + tmp_kernel_op_122*tmp_kernel_op_79 + tmp_kernel_op_124*tmp_kernel_op_79 + tmp_kernel_op_126*tmp_kernel_op_79);
                const real_t elMatVec_5 = src_dof_0*(tmp_kernel_op_128*tmp_kernel_op_82 + tmp_kernel_op_130*tmp_kernel_op_82 + tmp_kernel_op_132*tmp_kernel_op_82 + tmp_kernel_op_134*tmp_kernel_op_82) + src_dof_1*(tmp_kernel_op_128*tmp_kernel_op_71 + tmp_kernel_op_130*tmp_kernel_op_71 + tmp_kernel_op_132*tmp_kernel_op_71 + tmp_kernel_op_134*tmp_kernel_op_71) + src_dof_2*(tmp_kernel_op_128*tmp_kernel_op_72 + tmp_kernel_op_130*tmp_kernel_op_72 + tmp_kernel_op_132*tmp_kernel_op_72 + tmp_kernel_op_134*tmp_kernel_op_72) + src_dof_3*(tmp_kernel_op_128*tmp_kernel_op_19 + tmp_kernel_op_130*tmp_kernel_op_19 + tmp_kernel_op_132*tmp_kernel_op_19 + tmp_kernel_op_134*tmp_kernel_op_19) + src_dof_4*(tmp_kernel_op_128*tmp_kernel_op_76 + tmp_kernel_op_130*tmp_kernel_op_76 + tmp_kernel_op_132*tmp_kernel_op_76 + tmp_kernel_op_134*tmp_kernel_op_76) + src_dof_5*(tmp_kernel_op_128*tmp_kernel_op_79 + tmp_kernel_op_130*tmp_kernel_op_79 + tmp_kernel_op_132*tmp_kernel_op_79 + tmp_kernel_op_134*tmp_kernel_op_79);
                _data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatVec_0 + _data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
                _data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatVec_1 + _data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_2 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_3 + _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             }
          }
       }
       const real_t tmp_coords_jac_0_BLUE = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_4_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_0_0_BLUE = tmp_coords_jac_1_BLUE;
       const real_t p_affine_const_0_1_BLUE = tmp_coords_jac_2_BLUE;
       const real_t p_affine_const_1_0_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_1_1_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_4_BLUE;
       const real_t p_affine_const_2_0_BLUE = tmp_coords_jac_1_BLUE + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_2_1_BLUE = tmp_coords_jac_2_BLUE + tmp_coords_jac_4_BLUE;
       const real_t jac_affine_0_0_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_1_0_BLUE;
       const real_t jac_affine_0_1_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_2_0_BLUE;
       const real_t jac_affine_1_0_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_1_1_BLUE;
       const real_t jac_affine_1_1_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_2_1_BLUE;
       const real_t tmp_coords_jac_5_BLUE = jac_affine_0_0_BLUE*jac_affine_1_1_BLUE - jac_affine_0_1_BLUE*jac_affine_1_0_BLUE;
       const real_t tmp_coords_jac_6_BLUE = 1.0 / (tmp_coords_jac_5_BLUE);
       const real_t jac_affine_inv_0_0_BLUE = jac_affine_1_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_0_1_BLUE = -jac_affine_0_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_0_BLUE = -jac_affine_1_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_1_BLUE = jac_affine_0_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t abs_det_jac_affine_BLUE = abs(tmp_coords_jac_5_BLUE);
       const real_t tmp_moved_constant_0 = jac_affine_inv_1_0_BLUE*8.0;
       const real_t tmp_moved_constant_1 = jac_affine_inv_1_1_BLUE*8.0;
       const real_t tmp_moved_constant_2 = abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*tmp_moved_constant_0 + jac_affine_inv_0_1_BLUE*tmp_moved_constant_1);
       const real_t tmp_moved_constant_3 = abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*jac_affine_inv_0_0_BLUE)*4.0 + (jac_affine_inv_0_1_BLUE*jac_affine_inv_0_1_BLUE)*4.0);
       const real_t tmp_moved_constant_4 = abs_det_jac_affine_BLUE*((jac_affine_inv_1_0_BLUE*jac_affine_inv_1_0_BLUE)*4.0 + (jac_affine_inv_1_1_BLUE*jac_affine_inv_1_1_BLUE)*4.0);
       const real_t tmp_moved_constant_5 = jac_affine_inv_0_0_BLUE*4.0;
       const real_t tmp_moved_constant_6 = jac_affine_inv_0_1_BLUE*4.0;
       const real_t tmp_moved_constant_7 = jac_affine_inv_1_0_BLUE*tmp_moved_constant_5 + jac_affine_inv_1_1_BLUE*tmp_moved_constant_6;
       const real_t tmp_moved_constant_8 = abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(-tmp_moved_constant_0 - tmp_moved_constant_5) + jac_affine_inv_1_1_BLUE*(-tmp_moved_constant_1 - tmp_moved_constant_6) - tmp_moved_constant_7);
       const real_t tmp_moved_constant_9 = jac_affine_inv_1_0_BLUE*4.0;
       const real_t tmp_moved_constant_10 = jac_affine_inv_1_1_BLUE*4.0;
       const real_t tmp_moved_constant_11 = abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-8.0 - tmp_moved_constant_9) + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-8.0 - tmp_moved_constant_10) - tmp_moved_constant_7);
       const real_t tmp_moved_constant_12 = tmp_moved_constant_5 + tmp_moved_constant_9;
       const real_t tmp_moved_constant_13 = tmp_moved_constant_10 + tmp_moved_constant_6;
       const real_t tmp_moved_constant_14 = abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*tmp_moved_constant_12 + jac_affine_inv_0_1_BLUE*tmp_moved_constant_13 + jac_affine_inv_1_0_BLUE*tmp_moved_constant_12 + jac_affine_inv_1_1_BLUE*tmp_moved_constant_13);
       const real_t tmp_moved_constant_15 = jac_affine_inv_0_0_BLUE*tmp_kernel_op_1;
       const real_t tmp_moved_constant_16 = jac_affine_inv_1_0_BLUE*tmp_kernel_op_0;
       const real_t tmp_moved_constant_17 = jac_affine_inv_0_1_BLUE*tmp_kernel_op_1;
       const real_t tmp_moved_constant_18 = jac_affine_inv_1_1_BLUE*tmp_kernel_op_0;
       const real_t tmp_moved_constant_19 = tmp_moved_constant_5*0.59999999999999998;
       const real_t tmp_moved_constant_20 = tmp_moved_constant_9*0.20000000000000001;
       const real_t tmp_moved_constant_21 = tmp_moved_constant_6*0.59999999999999998;
       const real_t tmp_moved_constant_22 = tmp_moved_constant_10*0.20000000000000001;
       const real_t tmp_moved_constant_23 = tmp_moved_constant_5*0.20000000000000001;
       const real_t tmp_moved_constant_24 = tmp_moved_constant_9*0.59999999999999998;
       const real_t tmp_moved_constant_25 = tmp_moved_constant_6*0.20000000000000001;
       const real_t tmp_moved_constant_26 = tmp_moved_constant_10*0.59999999999999998;
       const real_t tmp_moved_constant_27 = tmp_moved_constant_5*0.20000000000000001;
       const real_t tmp_moved_constant_28 = tmp_moved_constant_9*0.20000000000000001;
       const real_t tmp_moved_constant_29 = tmp_moved_constant_6*0.20000000000000001;
       const real_t tmp_moved_constant_30 = tmp_moved_constant_10*0.20000000000000001;
       {
          /* FaceType.BLUE */
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d diffusivity_times_delta_dof_0 = _mm256_loadu_pd(& _data_diffusivity_times_deltaVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d diffusivity_times_delta_dof_1 = _mm256_loadu_pd(& _data_diffusivity_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d diffusivity_times_delta_dof_2 = _mm256_loadu_pd(& _data_diffusivity_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]);
                const __m256d diffusivity_times_delta_dof_3 = _mm256_loadu_pd(& _data_diffusivity_times_deltaEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d diffusivity_times_delta_dof_4 = _mm256_loadu_pd(& _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]);
                const __m256d diffusivity_times_delta_dof_5 = _mm256_loadu_pd(& _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d wx_dof_0 = _mm256_loadu_pd(& _data_wxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d wx_dof_1 = _mm256_loadu_pd(& _data_wxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d wx_dof_2 = _mm256_loadu_pd(& _data_wxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]);
                const __m256d wx_dof_3 = _mm256_loadu_pd(& _data_wxEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d wx_dof_4 = _mm256_loadu_pd(& _data_wxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]);
                const __m256d wx_dof_5 = _mm256_loadu_pd(& _data_wxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d wy_dof_0 = _mm256_loadu_pd(& _data_wyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]);
                const __m256d wy_dof_1 = _mm256_loadu_pd(& _data_wyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d wy_dof_2 = _mm256_loadu_pd(& _data_wyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]);
                const __m256d wy_dof_3 = _mm256_loadu_pd(& _data_wyEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]);
                const __m256d wy_dof_4 = _mm256_loadu_pd(& _data_wyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]);
                const __m256d wy_dof_5 = _mm256_loadu_pd(& _data_wyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]);
                const __m256d tmp_kernel_op_13 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(wx_dof_4,_mm256_set_pd(tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10)),_mm256_mul_pd(wx_dof_5,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(wx_dof_0,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12))),_mm256_mul_pd(wx_dof_3,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(wx_dof_1,_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6))),_mm256_mul_pd(wx_dof_2,_mm256_set_pd(tmp_kernel_op_9,tmp_kernel_op_9,tmp_kernel_op_9,tmp_kernel_op_9)));
                const __m256d tmp_kernel_op_14 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(wy_dof_4,_mm256_set_pd(tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10)),_mm256_mul_pd(wy_dof_5,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(wy_dof_0,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12))),_mm256_mul_pd(wy_dof_3,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(wy_dof_1,_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6))),_mm256_mul_pd(wy_dof_2,_mm256_set_pd(tmp_kernel_op_9,tmp_kernel_op_9,tmp_kernel_op_9,tmp_kernel_op_9)));
                const __m256d tmp_kernel_op_15 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_4,_mm256_set_pd(-0.28125,-0.28125,-0.28125,-0.28125)),_mm256_set_pd(tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10,tmp_kernel_op_10)),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_5,_mm256_set_pd(-0.28125,-0.28125,-0.28125,-0.28125)),_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_0,_mm256_set_pd(-0.28125,-0.28125,-0.28125,-0.28125)),_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_3,_mm256_set_pd(-0.28125,-0.28125,-0.28125,-0.28125)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_1,_mm256_set_pd(-0.28125,-0.28125,-0.28125,-0.28125)),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_2,_mm256_set_pd(-0.28125,-0.28125,-0.28125,-0.28125)),_mm256_set_pd(tmp_kernel_op_9,tmp_kernel_op_9,tmp_kernel_op_9,tmp_kernel_op_9)));
                const __m256d tmp_kernel_op_16 = _mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)))),_mm256_mul_pd(tmp_kernel_op_14,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))))));
                const __m256d tmp_kernel_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(wx_dof_3,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_mul_pd(wx_dof_1,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_mul_pd(wx_dof_2,_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29))),_mm256_mul_pd(wx_dof_4,_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(wx_dof_5,_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(wx_dof_0,_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32)));
                const __m256d tmp_kernel_op_34 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(wy_dof_3,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_mul_pd(wy_dof_1,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_mul_pd(wy_dof_2,_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29))),_mm256_mul_pd(wy_dof_4,_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(wy_dof_5,_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(wy_dof_0,_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32)));
                const __m256d tmp_kernel_op_35 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_3,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_1,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_2,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29,tmp_kernel_op_29))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_4,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_5,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_0,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32)));
                const __m256d tmp_kernel_op_36 = _mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_33,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE),_mm256_set_pd(tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE),_mm256_set_pd(tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22)))),_mm256_mul_pd(tmp_kernel_op_34,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE),_mm256_set_pd(tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE),_mm256_set_pd(tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22))))));
                const __m256d tmp_kernel_op_50 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(wx_dof_3,_mm256_set_pd(tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40)),_mm256_mul_pd(wx_dof_1,_mm256_set_pd(tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43))),_mm256_mul_pd(wx_dof_2,_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46))),_mm256_mul_pd(wx_dof_4,_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(wx_dof_5,_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48))),_mm256_mul_pd(wx_dof_0,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)));
                const __m256d tmp_kernel_op_51 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(wy_dof_3,_mm256_set_pd(tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40)),_mm256_mul_pd(wy_dof_1,_mm256_set_pd(tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43))),_mm256_mul_pd(wy_dof_2,_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46))),_mm256_mul_pd(wy_dof_4,_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(wy_dof_5,_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48))),_mm256_mul_pd(wy_dof_0,_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)));
                const __m256d tmp_kernel_op_52 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_3,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40)),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_1,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_2,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_4,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_5,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_0,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)));
                const __m256d tmp_kernel_op_53 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39)))),_mm256_mul_pd(tmp_kernel_op_51,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39))))));
                const __m256d tmp_kernel_op_67 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(wx_dof_3,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57)),_mm256_mul_pd(wx_dof_1,_mm256_set_pd(tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60))),_mm256_mul_pd(wx_dof_2,_mm256_set_pd(tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63))),_mm256_mul_pd(wx_dof_4,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_mul_pd(wx_dof_5,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(wx_dof_0,_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66)));
                const __m256d tmp_kernel_op_68 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(wy_dof_3,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57)),_mm256_mul_pd(wy_dof_1,_mm256_set_pd(tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60))),_mm256_mul_pd(wy_dof_2,_mm256_set_pd(tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63))),_mm256_mul_pd(wy_dof_4,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_mul_pd(wy_dof_5,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(wy_dof_0,_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66)));
                const __m256d tmp_kernel_op_69 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_3,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57)),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_1,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_2,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_4,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_5,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(_mm256_mul_pd(diffusivity_times_delta_dof_0,_mm256_set_pd(0.26041666666666669,0.26041666666666669,0.26041666666666669,0.26041666666666669)),_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66)));
                const __m256d tmp_kernel_op_70 = _mm256_mul_pd(tmp_kernel_op_69,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)))),_mm256_mul_pd(tmp_kernel_op_68,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))))));
                const __m256d tmp_kernel_op_84 = _mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE)),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_14,_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE)),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))));
                const __m256d tmp_kernel_op_86 = _mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_33,_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE)),_mm256_set_pd(tmp_kernel_op_85,tmp_kernel_op_85,tmp_kernel_op_85,tmp_kernel_op_85)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_34,_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE)),_mm256_set_pd(tmp_kernel_op_85,tmp_kernel_op_85,tmp_kernel_op_85,tmp_kernel_op_85))));
                const __m256d tmp_kernel_op_88 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE)),_mm256_set_pd(tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_51,_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE)),_mm256_set_pd(tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87))));
                const __m256d tmp_kernel_op_90 = _mm256_mul_pd(tmp_kernel_op_69,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE)),_mm256_set_pd(tmp_kernel_op_89,tmp_kernel_op_89,tmp_kernel_op_89,tmp_kernel_op_89)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE)),_mm256_set_pd(tmp_kernel_op_89,tmp_kernel_op_89,tmp_kernel_op_89,tmp_kernel_op_89))));
                const __m256d tmp_kernel_op_92 = _mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE)),_mm256_set_pd(tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_14,_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE)),_mm256_set_pd(tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91))));
                const __m256d tmp_kernel_op_94 = _mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_33,_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE)),_mm256_set_pd(tmp_kernel_op_93,tmp_kernel_op_93,tmp_kernel_op_93,tmp_kernel_op_93)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_34,_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE)),_mm256_set_pd(tmp_kernel_op_93,tmp_kernel_op_93,tmp_kernel_op_93,tmp_kernel_op_93))));
                const __m256d tmp_kernel_op_96 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE)),_mm256_set_pd(tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_51,_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE)),_mm256_set_pd(tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95))));
                const __m256d tmp_kernel_op_98 = _mm256_mul_pd(tmp_kernel_op_69,_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE)),_mm256_set_pd(tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_68,_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE)),_mm256_set_pd(tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97,tmp_kernel_op_97))));
                const __m256d tmp_kernel_op_103 = _mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15),_mm256_set_pd(tmp_moved_constant_16,tmp_moved_constant_16,tmp_moved_constant_16,tmp_moved_constant_16))),_mm256_mul_pd(tmp_kernel_op_14,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17),_mm256_set_pd(tmp_moved_constant_18,tmp_moved_constant_18,tmp_moved_constant_18,tmp_moved_constant_18)))));
                const __m256d tmp_kernel_op_108 = _mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_33,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19),_mm256_set_pd(tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20))),_mm256_mul_pd(tmp_kernel_op_34,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21),_mm256_set_pd(tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22)))));
                const __m256d tmp_kernel_op_113 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23),_mm256_set_pd(tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24))),_mm256_mul_pd(tmp_kernel_op_51,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25),_mm256_set_pd(tmp_moved_constant_26,tmp_moved_constant_26,tmp_moved_constant_26,tmp_moved_constant_26)))));
                const __m256d tmp_kernel_op_118 = _mm256_mul_pd(tmp_kernel_op_69,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27),_mm256_set_pd(tmp_moved_constant_28,tmp_moved_constant_28,tmp_moved_constant_28,tmp_moved_constant_28))),_mm256_mul_pd(tmp_kernel_op_68,_mm256_add_pd(_mm256_set_pd(tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29),_mm256_set_pd(tmp_moved_constant_30,tmp_moved_constant_30,tmp_moved_constant_30,tmp_moved_constant_30)))));
                const __m256d tmp_kernel_op_120 = _mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE),_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119)))),_mm256_mul_pd(tmp_kernel_op_14,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE),_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))))));
                const __m256d tmp_kernel_op_122 = _mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_33,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)))),_mm256_mul_pd(tmp_kernel_op_34,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))))));
                const __m256d tmp_kernel_op_124 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE),_mm256_set_pd(tmp_kernel_op_123,tmp_kernel_op_123,tmp_kernel_op_123,tmp_kernel_op_123)))),_mm256_mul_pd(tmp_kernel_op_51,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE),_mm256_set_pd(tmp_kernel_op_123,tmp_kernel_op_123,tmp_kernel_op_123,tmp_kernel_op_123))))));
                const __m256d tmp_kernel_op_126 = _mm256_mul_pd(tmp_kernel_op_69,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE,jac_affine_inv_1_0_BLUE),_mm256_set_pd(tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125)))),_mm256_mul_pd(tmp_kernel_op_68,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE,jac_affine_inv_1_1_BLUE),_mm256_set_pd(tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125))))));
                const __m256d tmp_kernel_op_128 = _mm256_mul_pd(tmp_kernel_op_15,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_16,tmp_moved_constant_16,tmp_moved_constant_16,tmp_moved_constant_16)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE),_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127)))),_mm256_mul_pd(tmp_kernel_op_14,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_18,tmp_moved_constant_18,tmp_moved_constant_18,tmp_moved_constant_18)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE),_mm256_set_pd(tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127,tmp_kernel_op_127))))));
                const __m256d tmp_kernel_op_130 = _mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_33,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE),_mm256_set_pd(tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129)))),_mm256_mul_pd(tmp_kernel_op_34,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE),_mm256_set_pd(tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129,tmp_kernel_op_129))))));
                const __m256d tmp_kernel_op_132 = _mm256_mul_pd(tmp_kernel_op_52,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_50,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE),_mm256_set_pd(tmp_kernel_op_131,tmp_kernel_op_131,tmp_kernel_op_131,tmp_kernel_op_131)))),_mm256_mul_pd(tmp_kernel_op_51,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_26,tmp_moved_constant_26,tmp_moved_constant_26,tmp_moved_constant_26)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE),_mm256_set_pd(tmp_kernel_op_131,tmp_kernel_op_131,tmp_kernel_op_131,tmp_kernel_op_131))))));
                const __m256d tmp_kernel_op_134 = _mm256_mul_pd(tmp_kernel_op_69,_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_67,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_28,tmp_moved_constant_28,tmp_moved_constant_28,tmp_moved_constant_28)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE,jac_affine_inv_0_0_BLUE),_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133)))),_mm256_mul_pd(tmp_kernel_op_68,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_moved_constant_30,tmp_moved_constant_30,tmp_moved_constant_30,tmp_moved_constant_30)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE,jac_affine_inv_0_1_BLUE),_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133))))));
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11)),_mm256_mul_pd(tmp_kernel_op_36,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14)),_mm256_mul_pd(tmp_kernel_op_36,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2)),_mm256_mul_pd(tmp_kernel_op_36,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2))))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3)),_mm256_mul_pd(tmp_kernel_op_36,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4)),_mm256_mul_pd(tmp_kernel_op_36,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_16,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8)),_mm256_mul_pd(tmp_kernel_op_36,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8))),_mm256_mul_pd(tmp_kernel_op_70,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8)))));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11)),_mm256_mul_pd(tmp_kernel_op_86,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11))),_mm256_mul_pd(tmp_kernel_op_88,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11))),_mm256_mul_pd(tmp_kernel_op_90,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14)),_mm256_mul_pd(tmp_kernel_op_86,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))),_mm256_mul_pd(tmp_kernel_op_88,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))),_mm256_mul_pd(tmp_kernel_op_90,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2)),_mm256_mul_pd(tmp_kernel_op_86,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2))),_mm256_mul_pd(tmp_kernel_op_88,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2))),_mm256_mul_pd(tmp_kernel_op_90,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2))))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3)),_mm256_mul_pd(tmp_kernel_op_86,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3))),_mm256_mul_pd(tmp_kernel_op_88,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3))),_mm256_mul_pd(tmp_kernel_op_90,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4)),_mm256_mul_pd(tmp_kernel_op_86,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))),_mm256_mul_pd(tmp_kernel_op_88,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))),_mm256_mul_pd(tmp_kernel_op_90,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_84,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8)),_mm256_mul_pd(tmp_kernel_op_86,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8))),_mm256_mul_pd(tmp_kernel_op_88,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8))),_mm256_mul_pd(tmp_kernel_op_90,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8)))));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11)),_mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11))),_mm256_mul_pd(tmp_kernel_op_96,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11))),_mm256_mul_pd(tmp_kernel_op_98,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14)),_mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))),_mm256_mul_pd(tmp_kernel_op_96,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))),_mm256_mul_pd(tmp_kernel_op_98,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2)),_mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2))),_mm256_mul_pd(tmp_kernel_op_96,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2))),_mm256_mul_pd(tmp_kernel_op_98,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2))))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3)),_mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3))),_mm256_mul_pd(tmp_kernel_op_96,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3))),_mm256_mul_pd(tmp_kernel_op_98,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4)),_mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))),_mm256_mul_pd(tmp_kernel_op_96,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))),_mm256_mul_pd(tmp_kernel_op_98,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8)),_mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8))),_mm256_mul_pd(tmp_kernel_op_96,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8))),_mm256_mul_pd(tmp_kernel_op_98,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8)))));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_103,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11)),_mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11))),_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11))),_mm256_mul_pd(tmp_kernel_op_118,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_103,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14)),_mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))),_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))),_mm256_mul_pd(tmp_kernel_op_118,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_103,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2)),_mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2))),_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2))),_mm256_mul_pd(tmp_kernel_op_118,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2))))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_103,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3)),_mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3))),_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3))),_mm256_mul_pd(tmp_kernel_op_118,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_103,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4)),_mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))),_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))),_mm256_mul_pd(tmp_kernel_op_118,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_103,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8)),_mm256_mul_pd(tmp_kernel_op_108,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8))),_mm256_mul_pd(tmp_kernel_op_113,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8))),_mm256_mul_pd(tmp_kernel_op_118,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8)))));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11)),_mm256_mul_pd(tmp_kernel_op_122,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11))),_mm256_mul_pd(tmp_kernel_op_124,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11))),_mm256_mul_pd(tmp_kernel_op_126,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14)),_mm256_mul_pd(tmp_kernel_op_122,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))),_mm256_mul_pd(tmp_kernel_op_124,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))),_mm256_mul_pd(tmp_kernel_op_126,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2)),_mm256_mul_pd(tmp_kernel_op_122,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2))),_mm256_mul_pd(tmp_kernel_op_124,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2))),_mm256_mul_pd(tmp_kernel_op_126,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2))))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3)),_mm256_mul_pd(tmp_kernel_op_122,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3))),_mm256_mul_pd(tmp_kernel_op_124,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3))),_mm256_mul_pd(tmp_kernel_op_126,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4)),_mm256_mul_pd(tmp_kernel_op_122,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))),_mm256_mul_pd(tmp_kernel_op_124,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))),_mm256_mul_pd(tmp_kernel_op_126,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_120,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8)),_mm256_mul_pd(tmp_kernel_op_122,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8))),_mm256_mul_pd(tmp_kernel_op_124,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8))),_mm256_mul_pd(tmp_kernel_op_126,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8)))));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11)),_mm256_mul_pd(tmp_kernel_op_130,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11))),_mm256_mul_pd(tmp_kernel_op_132,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11))),_mm256_mul_pd(tmp_kernel_op_134,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11)))),_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14)),_mm256_mul_pd(tmp_kernel_op_130,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))),_mm256_mul_pd(tmp_kernel_op_132,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))),_mm256_mul_pd(tmp_kernel_op_134,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))))),_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2)),_mm256_mul_pd(tmp_kernel_op_130,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2))),_mm256_mul_pd(tmp_kernel_op_132,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2))),_mm256_mul_pd(tmp_kernel_op_134,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2))))),_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3)),_mm256_mul_pd(tmp_kernel_op_130,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3))),_mm256_mul_pd(tmp_kernel_op_132,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3))),_mm256_mul_pd(tmp_kernel_op_134,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3))))),_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4)),_mm256_mul_pd(tmp_kernel_op_130,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))),_mm256_mul_pd(tmp_kernel_op_132,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))),_mm256_mul_pd(tmp_kernel_op_134,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))))),_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8)),_mm256_mul_pd(tmp_kernel_op_130,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8))),_mm256_mul_pd(tmp_kernel_op_132,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8))),_mm256_mul_pd(tmp_kernel_op_134,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8)))));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
                const real_t src_dof_3 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t diffusivity_times_delta_dof_0 = _data_diffusivity_times_deltaVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t diffusivity_times_delta_dof_1 = _data_diffusivity_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t diffusivity_times_delta_dof_2 = _data_diffusivity_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
                const real_t diffusivity_times_delta_dof_3 = _data_diffusivity_times_deltaEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t diffusivity_times_delta_dof_4 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
                const real_t diffusivity_times_delta_dof_5 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t wx_dof_0 = _data_wxVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t wx_dof_1 = _data_wxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t wx_dof_2 = _data_wxVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
                const real_t wx_dof_3 = _data_wxEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t wx_dof_4 = _data_wxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
                const real_t wx_dof_5 = _data_wxEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t wy_dof_0 = _data_wyVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                const real_t wy_dof_1 = _data_wyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t wy_dof_2 = _data_wyVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
                const real_t wy_dof_3 = _data_wyEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                const real_t wy_dof_4 = _data_wyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
                const real_t wy_dof_5 = _data_wyEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
                const real_t tmp_kernel_op_13 = tmp_kernel_op_10*wx_dof_4 + tmp_kernel_op_11*wx_dof_5 + tmp_kernel_op_12*wx_dof_0 + tmp_kernel_op_3*wx_dof_3 + tmp_kernel_op_6*wx_dof_1 + tmp_kernel_op_9*wx_dof_2;
                const real_t tmp_kernel_op_14 = tmp_kernel_op_10*wy_dof_4 + tmp_kernel_op_11*wy_dof_5 + tmp_kernel_op_12*wy_dof_0 + tmp_kernel_op_3*wy_dof_3 + tmp_kernel_op_6*wy_dof_1 + tmp_kernel_op_9*wy_dof_2;
                const real_t tmp_kernel_op_15 = diffusivity_times_delta_dof_0*tmp_kernel_op_12*-0.28125 + diffusivity_times_delta_dof_1*tmp_kernel_op_6*-0.28125 + diffusivity_times_delta_dof_2*tmp_kernel_op_9*-0.28125 + diffusivity_times_delta_dof_3*tmp_kernel_op_3*-0.28125 + diffusivity_times_delta_dof_4*tmp_kernel_op_10*-0.28125 + diffusivity_times_delta_dof_5*tmp_kernel_op_11*-0.28125;
                const real_t tmp_kernel_op_16 = tmp_kernel_op_15*(tmp_kernel_op_13*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_2 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_2) + tmp_kernel_op_14*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_2 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_2));
                const real_t tmp_kernel_op_33 = tmp_kernel_op_23*wx_dof_3 + tmp_kernel_op_26*wx_dof_1 + tmp_kernel_op_29*wx_dof_2 + tmp_kernel_op_30*wx_dof_4 + tmp_kernel_op_31*wx_dof_5 + tmp_kernel_op_32*wx_dof_0;
                const real_t tmp_kernel_op_34 = tmp_kernel_op_23*wy_dof_3 + tmp_kernel_op_26*wy_dof_1 + tmp_kernel_op_29*wy_dof_2 + tmp_kernel_op_30*wy_dof_4 + tmp_kernel_op_31*wy_dof_5 + tmp_kernel_op_32*wy_dof_0;
                const real_t tmp_kernel_op_35 = diffusivity_times_delta_dof_0*tmp_kernel_op_32*0.26041666666666669 + diffusivity_times_delta_dof_1*tmp_kernel_op_26*0.26041666666666669 + diffusivity_times_delta_dof_2*tmp_kernel_op_29*0.26041666666666669 + diffusivity_times_delta_dof_3*tmp_kernel_op_23*0.26041666666666669 + diffusivity_times_delta_dof_4*tmp_kernel_op_30*0.26041666666666669 + diffusivity_times_delta_dof_5*tmp_kernel_op_31*0.26041666666666669;
                const real_t tmp_kernel_op_36 = tmp_kernel_op_35*(tmp_kernel_op_33*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_22 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_22) + tmp_kernel_op_34*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_22 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_22));
                const real_t tmp_kernel_op_50 = tmp_kernel_op_40*wx_dof_3 + tmp_kernel_op_43*wx_dof_1 + tmp_kernel_op_46*wx_dof_2 + tmp_kernel_op_47*wx_dof_4 + tmp_kernel_op_48*wx_dof_5 + tmp_kernel_op_49*wx_dof_0;
                const real_t tmp_kernel_op_51 = tmp_kernel_op_40*wy_dof_3 + tmp_kernel_op_43*wy_dof_1 + tmp_kernel_op_46*wy_dof_2 + tmp_kernel_op_47*wy_dof_4 + tmp_kernel_op_48*wy_dof_5 + tmp_kernel_op_49*wy_dof_0;
                const real_t tmp_kernel_op_52 = diffusivity_times_delta_dof_0*tmp_kernel_op_49*0.26041666666666669 + diffusivity_times_delta_dof_1*tmp_kernel_op_43*0.26041666666666669 + diffusivity_times_delta_dof_2*tmp_kernel_op_46*0.26041666666666669 + diffusivity_times_delta_dof_3*tmp_kernel_op_40*0.26041666666666669 + diffusivity_times_delta_dof_4*tmp_kernel_op_47*0.26041666666666669 + diffusivity_times_delta_dof_5*tmp_kernel_op_48*0.26041666666666669;
                const real_t tmp_kernel_op_53 = tmp_kernel_op_52*(tmp_kernel_op_50*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_39 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_39) + tmp_kernel_op_51*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_39 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_39));
                const real_t tmp_kernel_op_67 = tmp_kernel_op_57*wx_dof_3 + tmp_kernel_op_60*wx_dof_1 + tmp_kernel_op_63*wx_dof_2 + tmp_kernel_op_64*wx_dof_4 + tmp_kernel_op_65*wx_dof_5 + tmp_kernel_op_66*wx_dof_0;
                const real_t tmp_kernel_op_68 = tmp_kernel_op_57*wy_dof_3 + tmp_kernel_op_60*wy_dof_1 + tmp_kernel_op_63*wy_dof_2 + tmp_kernel_op_64*wy_dof_4 + tmp_kernel_op_65*wy_dof_5 + tmp_kernel_op_66*wy_dof_0;
                const real_t tmp_kernel_op_69 = diffusivity_times_delta_dof_0*tmp_kernel_op_66*0.26041666666666669 + diffusivity_times_delta_dof_1*tmp_kernel_op_60*0.26041666666666669 + diffusivity_times_delta_dof_2*tmp_kernel_op_63*0.26041666666666669 + diffusivity_times_delta_dof_3*tmp_kernel_op_57*0.26041666666666669 + diffusivity_times_delta_dof_4*tmp_kernel_op_64*0.26041666666666669 + diffusivity_times_delta_dof_5*tmp_kernel_op_65*0.26041666666666669;
                const real_t tmp_kernel_op_70 = tmp_kernel_op_69*(tmp_kernel_op_67*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_56 + jac_affine_inv_1_0_BLUE*tmp_kernel_op_56) + tmp_kernel_op_68*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_56 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_56));
                const real_t tmp_kernel_op_84 = tmp_kernel_op_15*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_13*tmp_kernel_op_83 + jac_affine_inv_0_1_BLUE*tmp_kernel_op_14*tmp_kernel_op_83);
                const real_t tmp_kernel_op_86 = tmp_kernel_op_35*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_33*tmp_kernel_op_85 + jac_affine_inv_0_1_BLUE*tmp_kernel_op_34*tmp_kernel_op_85);
                const real_t tmp_kernel_op_88 = tmp_kernel_op_52*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_50*tmp_kernel_op_87 + jac_affine_inv_0_1_BLUE*tmp_kernel_op_51*tmp_kernel_op_87);
                const real_t tmp_kernel_op_90 = tmp_kernel_op_69*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_67*tmp_kernel_op_89 + jac_affine_inv_0_1_BLUE*tmp_kernel_op_68*tmp_kernel_op_89);
                const real_t tmp_kernel_op_92 = tmp_kernel_op_15*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_13*tmp_kernel_op_91 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_14*tmp_kernel_op_91);
                const real_t tmp_kernel_op_94 = tmp_kernel_op_35*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_33*tmp_kernel_op_93 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_34*tmp_kernel_op_93);
                const real_t tmp_kernel_op_96 = tmp_kernel_op_52*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_50*tmp_kernel_op_95 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_51*tmp_kernel_op_95);
                const real_t tmp_kernel_op_98 = tmp_kernel_op_69*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_67*tmp_kernel_op_97 + jac_affine_inv_1_1_BLUE*tmp_kernel_op_68*tmp_kernel_op_97);
                const real_t tmp_kernel_op_103 = tmp_kernel_op_15*(tmp_kernel_op_13*(tmp_moved_constant_15 + tmp_moved_constant_16) + tmp_kernel_op_14*(tmp_moved_constant_17 + tmp_moved_constant_18));
                const real_t tmp_kernel_op_108 = tmp_kernel_op_35*(tmp_kernel_op_33*(tmp_moved_constant_19 + tmp_moved_constant_20) + tmp_kernel_op_34*(tmp_moved_constant_21 + tmp_moved_constant_22));
                const real_t tmp_kernel_op_113 = tmp_kernel_op_52*(tmp_kernel_op_50*(tmp_moved_constant_23 + tmp_moved_constant_24) + tmp_kernel_op_51*(tmp_moved_constant_25 + tmp_moved_constant_26));
                const real_t tmp_kernel_op_118 = tmp_kernel_op_69*(tmp_kernel_op_67*(tmp_moved_constant_27 + tmp_moved_constant_28) + tmp_kernel_op_68*(tmp_moved_constant_29 + tmp_moved_constant_30));
                const real_t tmp_kernel_op_120 = tmp_kernel_op_15*(tmp_kernel_op_13*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_119 - tmp_moved_constant_15) + tmp_kernel_op_14*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_119 - tmp_moved_constant_17));
                const real_t tmp_kernel_op_122 = tmp_kernel_op_35*(tmp_kernel_op_33*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_121 - tmp_moved_constant_19) + tmp_kernel_op_34*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_121 - tmp_moved_constant_21));
                const real_t tmp_kernel_op_124 = tmp_kernel_op_52*(tmp_kernel_op_50*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_123 - tmp_moved_constant_23) + tmp_kernel_op_51*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_123 - tmp_moved_constant_25));
                const real_t tmp_kernel_op_126 = tmp_kernel_op_69*(tmp_kernel_op_67*(jac_affine_inv_1_0_BLUE*tmp_kernel_op_125 - tmp_moved_constant_27) + tmp_kernel_op_68*(jac_affine_inv_1_1_BLUE*tmp_kernel_op_125 - tmp_moved_constant_29));
                const real_t tmp_kernel_op_128 = tmp_kernel_op_15*(tmp_kernel_op_13*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_127 - tmp_moved_constant_16) + tmp_kernel_op_14*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_127 - tmp_moved_constant_18));
                const real_t tmp_kernel_op_130 = tmp_kernel_op_35*(tmp_kernel_op_33*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_129 - tmp_moved_constant_20) + tmp_kernel_op_34*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_129 - tmp_moved_constant_22));
                const real_t tmp_kernel_op_132 = tmp_kernel_op_52*(tmp_kernel_op_50*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_131 - tmp_moved_constant_24) + tmp_kernel_op_51*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_131 - tmp_moved_constant_26));
                const real_t tmp_kernel_op_134 = tmp_kernel_op_69*(tmp_kernel_op_67*(jac_affine_inv_0_0_BLUE*tmp_kernel_op_133 - tmp_moved_constant_28) + tmp_kernel_op_68*(jac_affine_inv_0_1_BLUE*tmp_kernel_op_133 - tmp_moved_constant_30));
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_16*tmp_moved_constant_14 + tmp_kernel_op_36*tmp_moved_constant_14 + tmp_kernel_op_53*tmp_moved_constant_14 + tmp_kernel_op_70*tmp_moved_constant_14) + src_dof_1*(tmp_kernel_op_16*tmp_moved_constant_3 + tmp_kernel_op_36*tmp_moved_constant_3 + tmp_kernel_op_53*tmp_moved_constant_3 + tmp_kernel_op_70*tmp_moved_constant_3) + src_dof_2*(tmp_kernel_op_16*tmp_moved_constant_4 + tmp_kernel_op_36*tmp_moved_constant_4 + tmp_kernel_op_53*tmp_moved_constant_4 + tmp_kernel_op_70*tmp_moved_constant_4) + src_dof_3*(tmp_kernel_op_16*tmp_moved_constant_2 + tmp_kernel_op_36*tmp_moved_constant_2 + tmp_kernel_op_53*tmp_moved_constant_2 + tmp_kernel_op_70*tmp_moved_constant_2) + src_dof_4*(tmp_kernel_op_16*tmp_moved_constant_8 + tmp_kernel_op_36*tmp_moved_constant_8 + tmp_kernel_op_53*tmp_moved_constant_8 + tmp_kernel_op_70*tmp_moved_constant_8) + src_dof_5*(tmp_kernel_op_16*tmp_moved_constant_11 + tmp_kernel_op_36*tmp_moved_constant_11 + tmp_kernel_op_53*tmp_moved_constant_11 + tmp_kernel_op_70*tmp_moved_constant_11);
                const real_t elMatVec_1 = src_dof_0*(tmp_kernel_op_84*tmp_moved_constant_14 + tmp_kernel_op_86*tmp_moved_constant_14 + tmp_kernel_op_88*tmp_moved_constant_14 + tmp_kernel_op_90*tmp_moved_constant_14) + src_dof_1*(tmp_kernel_op_84*tmp_moved_constant_3 + tmp_kernel_op_86*tmp_moved_constant_3 + tmp_kernel_op_88*tmp_moved_constant_3 + tmp_kernel_op_90*tmp_moved_constant_3) + src_dof_2*(tmp_kernel_op_84*tmp_moved_constant_4 + tmp_kernel_op_86*tmp_moved_constant_4 + tmp_kernel_op_88*tmp_moved_constant_4 + tmp_kernel_op_90*tmp_moved_constant_4) + src_dof_3*(tmp_kernel_op_84*tmp_moved_constant_2 + tmp_kernel_op_86*tmp_moved_constant_2 + tmp_kernel_op_88*tmp_moved_constant_2 + tmp_kernel_op_90*tmp_moved_constant_2) + src_dof_4*(tmp_kernel_op_84*tmp_moved_constant_8 + tmp_kernel_op_86*tmp_moved_constant_8 + tmp_kernel_op_88*tmp_moved_constant_8 + tmp_kernel_op_90*tmp_moved_constant_8) + src_dof_5*(tmp_kernel_op_84*tmp_moved_constant_11 + tmp_kernel_op_86*tmp_moved_constant_11 + tmp_kernel_op_88*tmp_moved_constant_11 + tmp_kernel_op_90*tmp_moved_constant_11);
                const real_t elMatVec_2 = src_dof_0*(tmp_kernel_op_92*tmp_moved_constant_14 + tmp_kernel_op_94*tmp_moved_constant_14 + tmp_kernel_op_96*tmp_moved_constant_14 + tmp_kernel_op_98*tmp_moved_constant_14) + src_dof_1*(tmp_kernel_op_92*tmp_moved_constant_3 + tmp_kernel_op_94*tmp_moved_constant_3 + tmp_kernel_op_96*tmp_moved_constant_3 + tmp_kernel_op_98*tmp_moved_constant_3) + src_dof_2*(tmp_kernel_op_92*tmp_moved_constant_4 + tmp_kernel_op_94*tmp_moved_constant_4 + tmp_kernel_op_96*tmp_moved_constant_4 + tmp_kernel_op_98*tmp_moved_constant_4) + src_dof_3*(tmp_kernel_op_92*tmp_moved_constant_2 + tmp_kernel_op_94*tmp_moved_constant_2 + tmp_kernel_op_96*tmp_moved_constant_2 + tmp_kernel_op_98*tmp_moved_constant_2) + src_dof_4*(tmp_kernel_op_92*tmp_moved_constant_8 + tmp_kernel_op_94*tmp_moved_constant_8 + tmp_kernel_op_96*tmp_moved_constant_8 + tmp_kernel_op_98*tmp_moved_constant_8) + src_dof_5*(tmp_kernel_op_92*tmp_moved_constant_11 + tmp_kernel_op_94*tmp_moved_constant_11 + tmp_kernel_op_96*tmp_moved_constant_11 + tmp_kernel_op_98*tmp_moved_constant_11);
                const real_t elMatVec_3 = src_dof_0*(tmp_kernel_op_103*tmp_moved_constant_14 + tmp_kernel_op_108*tmp_moved_constant_14 + tmp_kernel_op_113*tmp_moved_constant_14 + tmp_kernel_op_118*tmp_moved_constant_14) + src_dof_1*(tmp_kernel_op_103*tmp_moved_constant_3 + tmp_kernel_op_108*tmp_moved_constant_3 + tmp_kernel_op_113*tmp_moved_constant_3 + tmp_kernel_op_118*tmp_moved_constant_3) + src_dof_2*(tmp_kernel_op_103*tmp_moved_constant_4 + tmp_kernel_op_108*tmp_moved_constant_4 + tmp_kernel_op_113*tmp_moved_constant_4 + tmp_kernel_op_118*tmp_moved_constant_4) + src_dof_3*(tmp_kernel_op_103*tmp_moved_constant_2 + tmp_kernel_op_108*tmp_moved_constant_2 + tmp_kernel_op_113*tmp_moved_constant_2 + tmp_kernel_op_118*tmp_moved_constant_2) + src_dof_4*(tmp_kernel_op_103*tmp_moved_constant_8 + tmp_kernel_op_108*tmp_moved_constant_8 + tmp_kernel_op_113*tmp_moved_constant_8 + tmp_kernel_op_118*tmp_moved_constant_8) + src_dof_5*(tmp_kernel_op_103*tmp_moved_constant_11 + tmp_kernel_op_108*tmp_moved_constant_11 + tmp_kernel_op_113*tmp_moved_constant_11 + tmp_kernel_op_118*tmp_moved_constant_11);
                const real_t elMatVec_4 = src_dof_0*(tmp_kernel_op_120*tmp_moved_constant_14 + tmp_kernel_op_122*tmp_moved_constant_14 + tmp_kernel_op_124*tmp_moved_constant_14 + tmp_kernel_op_126*tmp_moved_constant_14) + src_dof_1*(tmp_kernel_op_120*tmp_moved_constant_3 + tmp_kernel_op_122*tmp_moved_constant_3 + tmp_kernel_op_124*tmp_moved_constant_3 + tmp_kernel_op_126*tmp_moved_constant_3) + src_dof_2*(tmp_kernel_op_120*tmp_moved_constant_4 + tmp_kernel_op_122*tmp_moved_constant_4 + tmp_kernel_op_124*tmp_moved_constant_4 + tmp_kernel_op_126*tmp_moved_constant_4) + src_dof_3*(tmp_kernel_op_120*tmp_moved_constant_2 + tmp_kernel_op_122*tmp_moved_constant_2 + tmp_kernel_op_124*tmp_moved_constant_2 + tmp_kernel_op_126*tmp_moved_constant_2) + src_dof_4*(tmp_kernel_op_120*tmp_moved_constant_8 + tmp_kernel_op_122*tmp_moved_constant_8 + tmp_kernel_op_124*tmp_moved_constant_8 + tmp_kernel_op_126*tmp_moved_constant_8) + src_dof_5*(tmp_kernel_op_120*tmp_moved_constant_11 + tmp_kernel_op_122*tmp_moved_constant_11 + tmp_kernel_op_124*tmp_moved_constant_11 + tmp_kernel_op_126*tmp_moved_constant_11);
                const real_t elMatVec_5 = src_dof_0*(tmp_kernel_op_128*tmp_moved_constant_14 + tmp_kernel_op_130*tmp_moved_constant_14 + tmp_kernel_op_132*tmp_moved_constant_14 + tmp_kernel_op_134*tmp_moved_constant_14) + src_dof_1*(tmp_kernel_op_128*tmp_moved_constant_3 + tmp_kernel_op_130*tmp_moved_constant_3 + tmp_kernel_op_132*tmp_moved_constant_3 + tmp_kernel_op_134*tmp_moved_constant_3) + src_dof_2*(tmp_kernel_op_128*tmp_moved_constant_4 + tmp_kernel_op_130*tmp_moved_constant_4 + tmp_kernel_op_132*tmp_moved_constant_4 + tmp_kernel_op_134*tmp_moved_constant_4) + src_dof_3*(tmp_kernel_op_128*tmp_moved_constant_2 + tmp_kernel_op_130*tmp_moved_constant_2 + tmp_kernel_op_132*tmp_moved_constant_2 + tmp_kernel_op_134*tmp_moved_constant_2) + src_dof_4*(tmp_kernel_op_128*tmp_moved_constant_8 + tmp_kernel_op_130*tmp_moved_constant_8 + tmp_kernel_op_132*tmp_moved_constant_8 + tmp_kernel_op_134*tmp_moved_constant_8) + src_dof_5*(tmp_kernel_op_128*tmp_moved_constant_11 + tmp_kernel_op_130*tmp_moved_constant_11 + tmp_kernel_op_132*tmp_moved_constant_11 + tmp_kernel_op_134*tmp_moved_constant_11);
                _data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatVec_0 + _data_dstVertex[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_1 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1] = elMatVec_2 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatVec_3 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
                _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             }
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
