/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/































#include "../P2ElementwiseSupgDiffusionIcosahedralShellMap.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ElementwiseSupgDiffusionIcosahedralShellMap::toMatrix_P2ElementwiseSupgDiffusionIcosahedralShellMap_macro_3D( real_t * RESTRICT  _data_diffusivity_times_deltaEdge, real_t * RESTRICT  _data_diffusivity_times_deltaVertex, idx_t * RESTRICT  _data_dstEdge, idx_t * RESTRICT  _data_dstVertex, idx_t * RESTRICT  _data_srcEdge, idx_t * RESTRICT  _data_srcVertex, real_t * RESTRICT  _data_wxEdge, real_t * RESTRICT  _data_wxVertex, real_t * RESTRICT  _data_wyEdge, real_t * RESTRICT  _data_wyVertex, real_t * RESTRICT  _data_wzEdge, real_t * RESTRICT  _data_wzVertex, real_t forVertex_0, real_t forVertex_1, real_t forVertex_2, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, std::shared_ptr< SparseMatrixProxy > mat, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float, real_t radRayVertex, real_t radRefVertex, real_t rayVertex_0, real_t rayVertex_1, real_t rayVertex_2, real_t refVertex_0, real_t refVertex_1, real_t refVertex_2, real_t thrVertex_0, real_t thrVertex_1, real_t thrVertex_2 ) const
{
    {
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const real_t tmp_coords_jac_5_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const real_t tmp_coords_jac_3_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const real_t tmp_coords_jac_2_WHITE_UP = jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP;
       const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const real_t tmp_coords_jac_1_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_4_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_6_WHITE_UP = jac_affine_0_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_0_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_0_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
       const real_t tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const real_t jac_affine_inv_0_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
       const real_t jac_affine_inv_0_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_2_1_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const real_t jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const real_t jac_affine_inv_1_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t jac_affine_inv_2_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       const real_t tmp_blending_op_5 = rayVertex_1 - refVertex_1;
       const real_t tmp_blending_op_6 = -rayVertex_0;
       const real_t tmp_blending_op_7 = -forVertex_0 - tmp_blending_op_6;
       const real_t tmp_blending_op_8 = rayVertex_2 - thrVertex_2;
       const real_t tmp_blending_op_9 = tmp_blending_op_7*tmp_blending_op_8;
       const real_t tmp_blending_op_10 = rayVertex_2 - refVertex_2;
       const real_t tmp_blending_op_11 = rayVertex_1 - thrVertex_1;
       const real_t tmp_blending_op_12 = tmp_blending_op_11*tmp_blending_op_7;
       const real_t tmp_blending_op_13 = -rayVertex_1;
       const real_t tmp_blending_op_14 = -forVertex_1 - tmp_blending_op_13;
       const real_t tmp_blending_op_15 = rayVertex_0 - thrVertex_0;
       const real_t tmp_blending_op_16 = rayVertex_0 - refVertex_0;
       const real_t tmp_blending_op_17 = -rayVertex_2;
       const real_t tmp_blending_op_18 = -forVertex_2 - tmp_blending_op_17;
       const real_t tmp_blending_op_19 = tmp_blending_op_14*tmp_blending_op_8;
       const real_t tmp_blending_op_20 = tmp_blending_op_15*tmp_blending_op_18;
       const real_t tmp_blending_op_21 = -tmp_blending_op_10*tmp_blending_op_12 + tmp_blending_op_10*tmp_blending_op_14*tmp_blending_op_15 + tmp_blending_op_11*tmp_blending_op_16*tmp_blending_op_18 - tmp_blending_op_16*tmp_blending_op_19 - tmp_blending_op_20*tmp_blending_op_5 + tmp_blending_op_5*tmp_blending_op_9;
       const real_t tmp_blending_op_22 = radRayVertex*tmp_blending_op_21;
       const real_t tmp_blending_op_23 = radRayVertex - radRefVertex;
       const real_t tmp_blending_op_41 = tmp_blending_op_12 - tmp_blending_op_14*tmp_blending_op_15;
       const real_t tmp_blending_op_42 = -tmp_blending_op_23*tmp_blending_op_41;
       const real_t tmp_blending_op_47 = 1.0 / (tmp_blending_op_21);
       const real_t tmp_blending_op_48 = tmp_blending_op_47*1.0;
       const real_t tmp_blending_op_50 = tmp_blending_op_15*tmp_blending_op_18 - tmp_blending_op_9;
       const real_t tmp_blending_op_51 = tmp_blending_op_23*tmp_blending_op_50;
       const real_t tmp_blending_op_55 = -tmp_blending_op_11*tmp_blending_op_18 + tmp_blending_op_19;
       const real_t tmp_blending_op_56 = -tmp_blending_op_23*tmp_blending_op_55;
       const real_t tmp_blending_op_62 = -tmp_blending_op_23*tmp_blending_op_50;
       const real_t tmp_blending_op_227 = tmp_blending_op_47*3.0;
       const real_t tmp_blending_op_230 = tmp_blending_op_23*tmp_blending_op_55;
       const real_t tmp_blending_op_231 = -tmp_blending_op_230 + tmp_blending_op_56;
       const real_t tmp_blending_op_233 = -tmp_blending_op_22;
       const real_t tmp_blending_op_253 = -tmp_blending_op_51 + tmp_blending_op_62;
       const real_t tmp_blending_op_256 = tmp_blending_op_23*tmp_blending_op_41;
       const real_t tmp_blending_op_264 = -tmp_blending_op_256 + tmp_blending_op_42;
       const real_t tmp_kernel_op_0 = jac_affine_inv_2_0_WHITE_UP*4.0;
       const real_t tmp_kernel_op_1 = jac_affine_inv_0_0_WHITE_UP*4.0;
       const real_t tmp_kernel_op_2 = jac_affine_inv_1_0_WHITE_UP*4.0;
       const real_t tmp_kernel_op_3 = tmp_kernel_op_1 + tmp_kernel_op_2;
       const real_t tmp_kernel_op_4 = tmp_kernel_op_0 + tmp_kernel_op_3;
       const real_t tmp_kernel_op_5 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_4 + jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_4 + jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_4;
       const real_t tmp_kernel_op_6 = jac_affine_inv_2_1_WHITE_UP*4.0;
       const real_t tmp_kernel_op_7 = jac_affine_inv_0_1_WHITE_UP*4.0;
       const real_t tmp_kernel_op_8 = jac_affine_inv_1_1_WHITE_UP*4.0;
       const real_t tmp_kernel_op_9 = tmp_kernel_op_7 + tmp_kernel_op_8;
       const real_t tmp_kernel_op_10 = tmp_kernel_op_6 + tmp_kernel_op_9;
       const real_t tmp_kernel_op_11 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_10 + jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_10 + jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_12 = jac_affine_inv_2_2_WHITE_UP*4.0;
       const real_t tmp_kernel_op_13 = jac_affine_inv_0_2_WHITE_UP*4.0;
       const real_t tmp_kernel_op_14 = jac_affine_inv_1_2_WHITE_UP*4.0;
       const real_t tmp_kernel_op_15 = tmp_kernel_op_13 + tmp_kernel_op_14;
       const real_t tmp_kernel_op_16 = tmp_kernel_op_12 + tmp_kernel_op_15;
       const real_t tmp_kernel_op_17 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_16 + jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_16 + jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_16;
       const real_t tmp_kernel_op_18 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_4 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_4 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_4;
       const real_t tmp_kernel_op_19 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_10 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_10 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_20 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_16 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_16 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_16;
       const real_t tmp_kernel_op_21 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_4 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_4 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_4;
       const real_t tmp_kernel_op_22 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_10 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_10 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_23 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_16 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_16 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_16;
       const real_t tmp_kernel_op_24 = 1.0;
       const real_t tmp_kernel_op_25 = 1.0;
       const real_t tmp_kernel_op_26 = 1.0;
       const real_t tmp_kernel_op_27 = tmp_kernel_op_25 + tmp_kernel_op_26;
       const real_t tmp_kernel_op_28 = tmp_kernel_op_24 + tmp_kernel_op_27 - 3.0;
       const real_t tmp_kernel_op_29 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_28 + jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_28 + jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_28;
       const real_t tmp_kernel_op_34 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_28 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_28 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_28;
       const real_t tmp_kernel_op_36 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_28 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_28 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_28;
       const real_t tmp_kernel_op_87 = tmp_kernel_op_26*0.25;
       const real_t tmp_kernel_op_88 = tmp_kernel_op_25*0.25;
       const real_t tmp_kernel_op_89 = tmp_kernel_op_25*0.25;
       const real_t tmp_kernel_op_90 = 0.0625;
       const real_t tmp_kernel_op_91 = tmp_kernel_op_90*2.0;
       const real_t tmp_kernel_op_92 = tmp_kernel_op_91 - 0.25;
       const real_t tmp_kernel_op_93 = 0.0625;
       const real_t tmp_kernel_op_94 = tmp_kernel_op_93*2.0;
       const real_t tmp_kernel_op_95 = tmp_kernel_op_94 - 0.25;
       const real_t tmp_kernel_op_96 = 0.0625;
       const real_t tmp_kernel_op_97 = tmp_kernel_op_96*2.0;
       const real_t tmp_kernel_op_98 = tmp_kernel_op_97 - 0.25;
       const real_t tmp_kernel_op_99 = tmp_kernel_op_24 - tmp_kernel_op_87 - tmp_kernel_op_88 + tmp_kernel_op_96*-4.0;
       const real_t tmp_kernel_op_100 = tmp_kernel_op_26 - tmp_kernel_op_87 - tmp_kernel_op_89 + tmp_kernel_op_93*-4.0;
       const real_t tmp_kernel_op_101 = tmp_kernel_op_88 + tmp_kernel_op_89;
       const real_t tmp_kernel_op_102 = -tmp_kernel_op_101 + tmp_kernel_op_25 + tmp_kernel_op_90*-4.0;
       const real_t tmp_kernel_op_103 = tmp_kernel_op_101 + tmp_kernel_op_87 + tmp_kernel_op_91 + tmp_kernel_op_94 + tmp_kernel_op_97 - 1.25;
       const real_t tmp_kernel_op_109 = 2.0;
       const real_t tmp_kernel_op_110 = 0.66666666666666663;
       const real_t tmp_kernel_op_111 = 0.66666666666666663;
       const real_t tmp_kernel_op_112 = tmp_kernel_op_110 + tmp_kernel_op_111;
       const real_t tmp_kernel_op_113 = tmp_kernel_op_109 + tmp_kernel_op_112 - 3.0;
       const real_t tmp_kernel_op_114 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_113 + jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_113 + jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_113;
       const real_t tmp_kernel_op_119 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_113 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_113 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_113;
       const real_t tmp_kernel_op_121 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_113 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_113 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_113;
       const real_t tmp_kernel_op_172 = tmp_kernel_op_111*0.5;
       const real_t tmp_kernel_op_173 = tmp_kernel_op_110*0.5;
       const real_t tmp_kernel_op_174 = tmp_kernel_op_110*0.16666666666666666;
       const real_t tmp_kernel_op_175 = 0.027777777777777776;
       const real_t tmp_kernel_op_176 = tmp_kernel_op_175*2.0;
       const real_t tmp_kernel_op_177 = tmp_kernel_op_176 - 0.16666666666666666;
       const real_t tmp_kernel_op_178 = 0.027777777777777776;
       const real_t tmp_kernel_op_179 = tmp_kernel_op_178*2.0;
       const real_t tmp_kernel_op_180 = tmp_kernel_op_179 - 0.16666666666666666;
       const real_t tmp_kernel_op_181 = 0.25;
       const real_t tmp_kernel_op_182 = tmp_kernel_op_181*2.0;
       const real_t tmp_kernel_op_183 = tmp_kernel_op_182 - 0.5;
       const real_t tmp_kernel_op_184 = tmp_kernel_op_109 - tmp_kernel_op_172 - tmp_kernel_op_173 + tmp_kernel_op_181*-4.0;
       const real_t tmp_kernel_op_185 = tmp_kernel_op_111 - tmp_kernel_op_172 - tmp_kernel_op_174 + tmp_kernel_op_178*-4.0;
       const real_t tmp_kernel_op_186 = tmp_kernel_op_173 + tmp_kernel_op_174;
       const real_t tmp_kernel_op_187 = tmp_kernel_op_110 + tmp_kernel_op_175*-4.0 - tmp_kernel_op_186;
       const real_t tmp_kernel_op_188 = tmp_kernel_op_172 + tmp_kernel_op_176 + tmp_kernel_op_179 + tmp_kernel_op_182 + tmp_kernel_op_186 - 1.5;
       const real_t tmp_kernel_op_194 = 0.66666666666666663;
       const real_t tmp_kernel_op_195 = 0.66666666666666663;
       const real_t tmp_kernel_op_196 = 2.0;
       const real_t tmp_kernel_op_197 = tmp_kernel_op_195 + tmp_kernel_op_196;
       const real_t tmp_kernel_op_198 = tmp_kernel_op_194 + tmp_kernel_op_197 - 3.0;
       const real_t tmp_kernel_op_199 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_198 + jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_198 + jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_198;
       const real_t tmp_kernel_op_204 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_198 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_198 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_198;
       const real_t tmp_kernel_op_206 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_198 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_198 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_198;
       const real_t tmp_kernel_op_257 = tmp_kernel_op_196*0.16666666666666666;
       const real_t tmp_kernel_op_258 = tmp_kernel_op_195*0.16666666666666666;
       const real_t tmp_kernel_op_259 = tmp_kernel_op_195*0.5;
       const real_t tmp_kernel_op_260 = 0.027777777777777776;
       const real_t tmp_kernel_op_261 = tmp_kernel_op_260*2.0;
       const real_t tmp_kernel_op_262 = tmp_kernel_op_261 - 0.16666666666666666;
       const real_t tmp_kernel_op_263 = 0.25;
       const real_t tmp_kernel_op_264 = tmp_kernel_op_263*2.0;
       const real_t tmp_kernel_op_265 = tmp_kernel_op_264 - 0.5;
       const real_t tmp_kernel_op_266 = 0.027777777777777776;
       const real_t tmp_kernel_op_267 = tmp_kernel_op_266*2.0;
       const real_t tmp_kernel_op_268 = tmp_kernel_op_267 - 0.16666666666666666;
       const real_t tmp_kernel_op_269 = tmp_kernel_op_194 - tmp_kernel_op_257 - tmp_kernel_op_258 + tmp_kernel_op_266*-4.0;
       const real_t tmp_kernel_op_270 = tmp_kernel_op_196 - tmp_kernel_op_257 - tmp_kernel_op_259 + tmp_kernel_op_263*-4.0;
       const real_t tmp_kernel_op_271 = tmp_kernel_op_258 + tmp_kernel_op_259;
       const real_t tmp_kernel_op_272 = tmp_kernel_op_195 + tmp_kernel_op_260*-4.0 - tmp_kernel_op_271;
       const real_t tmp_kernel_op_273 = tmp_kernel_op_257 + tmp_kernel_op_261 + tmp_kernel_op_264 + tmp_kernel_op_267 + tmp_kernel_op_271 - 1.5;
       const real_t tmp_kernel_op_279 = 0.66666666666666663;
       const real_t tmp_kernel_op_280 = 2.0;
       const real_t tmp_kernel_op_281 = 0.66666666666666663;
       const real_t tmp_kernel_op_282 = tmp_kernel_op_280 + tmp_kernel_op_281;
       const real_t tmp_kernel_op_283 = tmp_kernel_op_279 + tmp_kernel_op_282 - 3.0;
       const real_t tmp_kernel_op_284 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_283 + jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_283 + jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_283;
       const real_t tmp_kernel_op_289 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_283 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_283 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_283;
       const real_t tmp_kernel_op_291 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_283 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_283 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_283;
       const real_t tmp_kernel_op_342 = tmp_kernel_op_281*0.16666666666666666;
       const real_t tmp_kernel_op_343 = tmp_kernel_op_280*0.16666666666666666;
       const real_t tmp_kernel_op_344 = tmp_kernel_op_280*0.16666666666666666;
       const real_t tmp_kernel_op_345 = 0.25;
       const real_t tmp_kernel_op_346 = tmp_kernel_op_345*2.0;
       const real_t tmp_kernel_op_347 = tmp_kernel_op_346 - 0.5;
       const real_t tmp_kernel_op_348 = 0.027777777777777776;
       const real_t tmp_kernel_op_349 = tmp_kernel_op_348*2.0;
       const real_t tmp_kernel_op_350 = tmp_kernel_op_349 - 0.16666666666666666;
       const real_t tmp_kernel_op_351 = 0.027777777777777776;
       const real_t tmp_kernel_op_352 = tmp_kernel_op_351*2.0;
       const real_t tmp_kernel_op_353 = tmp_kernel_op_352 - 0.16666666666666666;
       const real_t tmp_kernel_op_354 = tmp_kernel_op_279 - tmp_kernel_op_342 - tmp_kernel_op_343 + tmp_kernel_op_351*-4.0;
       const real_t tmp_kernel_op_355 = tmp_kernel_op_281 - tmp_kernel_op_342 - tmp_kernel_op_344 + tmp_kernel_op_348*-4.0;
       const real_t tmp_kernel_op_356 = tmp_kernel_op_343 + tmp_kernel_op_344;
       const real_t tmp_kernel_op_357 = tmp_kernel_op_280 + tmp_kernel_op_345*-4.0 - tmp_kernel_op_356;
       const real_t tmp_kernel_op_358 = tmp_kernel_op_342 + tmp_kernel_op_346 + tmp_kernel_op_349 + tmp_kernel_op_352 + tmp_kernel_op_356 - 1.5;
       const real_t tmp_kernel_op_364 = 0.66666666666666663;
       const real_t tmp_kernel_op_365 = 0.66666666666666663;
       const real_t tmp_kernel_op_366 = 0.66666666666666663;
       const real_t tmp_kernel_op_367 = tmp_kernel_op_365 + tmp_kernel_op_366;
       const real_t tmp_kernel_op_368 = tmp_kernel_op_364 + tmp_kernel_op_367 - 3.0;
       const real_t tmp_kernel_op_369 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_368 + jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_368 + jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_368;
       const real_t tmp_kernel_op_374 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_368 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_368 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_368;
       const real_t tmp_kernel_op_376 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_368 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_368 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_368;
       const real_t tmp_kernel_op_427 = tmp_kernel_op_366*0.16666666666666666;
       const real_t tmp_kernel_op_428 = tmp_kernel_op_365*0.16666666666666666;
       const real_t tmp_kernel_op_429 = tmp_kernel_op_365*0.16666666666666666;
       const real_t tmp_kernel_op_430 = 0.027777777777777776;
       const real_t tmp_kernel_op_431 = tmp_kernel_op_430*2.0;
       const real_t tmp_kernel_op_432 = tmp_kernel_op_431 - 0.16666666666666666;
       const real_t tmp_kernel_op_433 = 0.027777777777777776;
       const real_t tmp_kernel_op_434 = tmp_kernel_op_433*2.0;
       const real_t tmp_kernel_op_435 = tmp_kernel_op_434 - 0.16666666666666666;
       const real_t tmp_kernel_op_436 = 0.027777777777777776;
       const real_t tmp_kernel_op_437 = tmp_kernel_op_436*2.0;
       const real_t tmp_kernel_op_438 = tmp_kernel_op_437 - 0.16666666666666666;
       const real_t tmp_kernel_op_439 = tmp_kernel_op_364 - tmp_kernel_op_427 - tmp_kernel_op_428 + tmp_kernel_op_436*-4.0;
       const real_t tmp_kernel_op_440 = tmp_kernel_op_366 - tmp_kernel_op_427 - tmp_kernel_op_429 + tmp_kernel_op_433*-4.0;
       const real_t tmp_kernel_op_441 = tmp_kernel_op_428 + tmp_kernel_op_429;
       const real_t tmp_kernel_op_442 = tmp_kernel_op_365 + tmp_kernel_op_430*-4.0 - tmp_kernel_op_441;
       const real_t tmp_kernel_op_443 = tmp_kernel_op_427 + tmp_kernel_op_431 + tmp_kernel_op_434 + tmp_kernel_op_437 + tmp_kernel_op_441 - 0.5;
       const real_t tmp_kernel_op_449 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_450 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_451 = (jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*4.0;
       const real_t tmp_kernel_op_452 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_7;
       const real_t tmp_kernel_op_453 = (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*4.0;
       const real_t tmp_kernel_op_454 = (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*4.0;
       const real_t tmp_kernel_op_455 = tmp_kernel_op_25 - 1.0;
       const real_t tmp_kernel_op_456 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_455;
       const real_t tmp_kernel_op_457 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_455;
       const real_t tmp_kernel_op_458 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_455;
       const real_t tmp_kernel_op_460 = tmp_kernel_op_110 - 1.0;
       const real_t tmp_kernel_op_461 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_460;
       const real_t tmp_kernel_op_462 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_460;
       const real_t tmp_kernel_op_463 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_460;
       const real_t tmp_kernel_op_465 = tmp_kernel_op_195 - 1.0;
       const real_t tmp_kernel_op_466 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_465;
       const real_t tmp_kernel_op_467 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_465;
       const real_t tmp_kernel_op_468 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_465;
       const real_t tmp_kernel_op_470 = tmp_kernel_op_280 - 1.0;
       const real_t tmp_kernel_op_471 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_470;
       const real_t tmp_kernel_op_472 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_470;
       const real_t tmp_kernel_op_473 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_470;
       const real_t tmp_kernel_op_475 = tmp_kernel_op_365 - 1.0;
       const real_t tmp_kernel_op_476 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_475;
       const real_t tmp_kernel_op_477 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_475;
       const real_t tmp_kernel_op_478 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_475;
       const real_t tmp_kernel_op_480 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_481 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_482 = (jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*4.0;
       const real_t tmp_kernel_op_483 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_8;
       const real_t tmp_kernel_op_484 = (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*4.0;
       const real_t tmp_kernel_op_485 = (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*4.0;
       const real_t tmp_kernel_op_486 = tmp_kernel_op_26 - 1.0;
       const real_t tmp_kernel_op_487 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_486;
       const real_t tmp_kernel_op_488 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_486;
       const real_t tmp_kernel_op_489 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_486;
       const real_t tmp_kernel_op_491 = tmp_kernel_op_111 - 1.0;
       const real_t tmp_kernel_op_492 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_491;
       const real_t tmp_kernel_op_493 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_491;
       const real_t tmp_kernel_op_494 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_491;
       const real_t tmp_kernel_op_496 = tmp_kernel_op_196 - 1.0;
       const real_t tmp_kernel_op_497 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_496;
       const real_t tmp_kernel_op_498 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_496;
       const real_t tmp_kernel_op_499 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_496;
       const real_t tmp_kernel_op_501 = tmp_kernel_op_281 - 1.0;
       const real_t tmp_kernel_op_502 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_501;
       const real_t tmp_kernel_op_503 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_501;
       const real_t tmp_kernel_op_504 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_501;
       const real_t tmp_kernel_op_506 = tmp_kernel_op_366 - 1.0;
       const real_t tmp_kernel_op_507 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_506;
       const real_t tmp_kernel_op_508 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_506;
       const real_t tmp_kernel_op_509 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_506;
       const real_t tmp_kernel_op_511 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_512 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_513 = (jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*4.0;
       const real_t tmp_kernel_op_514 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_6;
       const real_t tmp_kernel_op_515 = (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*4.0;
       const real_t tmp_kernel_op_516 = (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*4.0;
       const real_t tmp_kernel_op_517 = tmp_kernel_op_24 - 1.0;
       const real_t tmp_kernel_op_518 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_517;
       const real_t tmp_kernel_op_519 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_517;
       const real_t tmp_kernel_op_520 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_517;
       const real_t tmp_kernel_op_522 = tmp_kernel_op_109 - 1.0;
       const real_t tmp_kernel_op_523 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_522;
       const real_t tmp_kernel_op_524 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_522;
       const real_t tmp_kernel_op_525 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_522;
       const real_t tmp_kernel_op_527 = tmp_kernel_op_194 - 1.0;
       const real_t tmp_kernel_op_528 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_527;
       const real_t tmp_kernel_op_529 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_527;
       const real_t tmp_kernel_op_530 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_527;
       const real_t tmp_kernel_op_532 = tmp_kernel_op_279 - 1.0;
       const real_t tmp_kernel_op_533 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_532;
       const real_t tmp_kernel_op_534 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_532;
       const real_t tmp_kernel_op_535 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_532;
       const real_t tmp_kernel_op_537 = tmp_kernel_op_364 - 1.0;
       const real_t tmp_kernel_op_538 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_537;
       const real_t tmp_kernel_op_539 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_537;
       const real_t tmp_kernel_op_540 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_537;
       const real_t tmp_kernel_op_542 = jac_affine_inv_2_0_WHITE_UP*8.0;
       const real_t tmp_kernel_op_543 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_542;
       const real_t tmp_kernel_op_544 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_545 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_546 = tmp_kernel_op_544 + tmp_kernel_op_545;
       const real_t tmp_kernel_op_547 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_548 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_549 = tmp_kernel_op_547 + tmp_kernel_op_548;
       const real_t tmp_kernel_op_550 = jac_affine_inv_2_1_WHITE_UP*8.0;
       const real_t tmp_kernel_op_551 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_550;
       const real_t tmp_kernel_op_552 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_8;
       const real_t tmp_kernel_op_553 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_6;
       const real_t tmp_kernel_op_554 = tmp_kernel_op_552 + tmp_kernel_op_553;
       const real_t tmp_kernel_op_555 = jac_affine_inv_2_2_WHITE_UP*8.0;
       const real_t tmp_kernel_op_556 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_555;
       const real_t tmp_kernel_op_557 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_24;
       const real_t tmp_kernel_op_558 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_26;
       const real_t tmp_kernel_op_559 = tmp_kernel_op_557 + tmp_kernel_op_558;
       const real_t tmp_kernel_op_560 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_24;
       const real_t tmp_kernel_op_561 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_26;
       const real_t tmp_kernel_op_562 = tmp_kernel_op_560 + tmp_kernel_op_561;
       const real_t tmp_kernel_op_563 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_24;
       const real_t tmp_kernel_op_564 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_26;
       const real_t tmp_kernel_op_565 = tmp_kernel_op_563 + tmp_kernel_op_564;
       const real_t tmp_kernel_op_567 = tmp_kernel_op_2*0.5;
       const real_t tmp_kernel_op_568 = tmp_kernel_op_0*0.16666666666666666;
       const real_t tmp_kernel_op_569 = tmp_kernel_op_567 + tmp_kernel_op_568;
       const real_t tmp_kernel_op_570 = tmp_kernel_op_8*0.5;
       const real_t tmp_kernel_op_571 = tmp_kernel_op_6*0.16666666666666666;
       const real_t tmp_kernel_op_572 = tmp_kernel_op_570 + tmp_kernel_op_571;
       const real_t tmp_kernel_op_573 = tmp_kernel_op_14*0.5;
       const real_t tmp_kernel_op_574 = tmp_kernel_op_12*0.16666666666666666;
       const real_t tmp_kernel_op_575 = tmp_kernel_op_573 + tmp_kernel_op_574;
       const real_t tmp_kernel_op_577 = tmp_kernel_op_2*0.16666666666666666;
       const real_t tmp_kernel_op_578 = tmp_kernel_op_0*0.5;
       const real_t tmp_kernel_op_579 = tmp_kernel_op_577 + tmp_kernel_op_578;
       const real_t tmp_kernel_op_580 = tmp_kernel_op_8*0.16666666666666666;
       const real_t tmp_kernel_op_581 = tmp_kernel_op_6*0.5;
       const real_t tmp_kernel_op_582 = tmp_kernel_op_580 + tmp_kernel_op_581;
       const real_t tmp_kernel_op_583 = tmp_kernel_op_14*0.16666666666666666;
       const real_t tmp_kernel_op_584 = tmp_kernel_op_12*0.5;
       const real_t tmp_kernel_op_585 = tmp_kernel_op_583 + tmp_kernel_op_584;
       const real_t tmp_kernel_op_587 = tmp_kernel_op_2*0.16666666666666666;
       const real_t tmp_kernel_op_588 = tmp_kernel_op_0*0.16666666666666666;
       const real_t tmp_kernel_op_589 = tmp_kernel_op_587 + tmp_kernel_op_588;
       const real_t tmp_kernel_op_590 = tmp_kernel_op_8*0.16666666666666666;
       const real_t tmp_kernel_op_591 = tmp_kernel_op_6*0.16666666666666666;
       const real_t tmp_kernel_op_592 = tmp_kernel_op_590 + tmp_kernel_op_591;
       const real_t tmp_kernel_op_593 = tmp_kernel_op_14*0.16666666666666666;
       const real_t tmp_kernel_op_594 = tmp_kernel_op_12*0.16666666666666666;
       const real_t tmp_kernel_op_595 = tmp_kernel_op_593 + tmp_kernel_op_594;
       const real_t tmp_kernel_op_597 = tmp_kernel_op_2*0.16666666666666666;
       const real_t tmp_kernel_op_598 = tmp_kernel_op_0*0.16666666666666666;
       const real_t tmp_kernel_op_599 = tmp_kernel_op_597 + tmp_kernel_op_598;
       const real_t tmp_kernel_op_600 = tmp_kernel_op_8*0.16666666666666666;
       const real_t tmp_kernel_op_601 = tmp_kernel_op_6*0.16666666666666666;
       const real_t tmp_kernel_op_602 = tmp_kernel_op_600 + tmp_kernel_op_601;
       const real_t tmp_kernel_op_603 = tmp_kernel_op_14*0.16666666666666666;
       const real_t tmp_kernel_op_604 = tmp_kernel_op_12*0.16666666666666666;
       const real_t tmp_kernel_op_605 = tmp_kernel_op_603 + tmp_kernel_op_604;
       const real_t tmp_kernel_op_607 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_542;
       const real_t tmp_kernel_op_608 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_609 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_610 = tmp_kernel_op_608 + tmp_kernel_op_609;
       const real_t tmp_kernel_op_611 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_612 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_613 = tmp_kernel_op_611 + tmp_kernel_op_612;
       const real_t tmp_kernel_op_614 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_550;
       const real_t tmp_kernel_op_615 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_7;
       const real_t tmp_kernel_op_616 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_6;
       const real_t tmp_kernel_op_617 = tmp_kernel_op_615 + tmp_kernel_op_616;
       const real_t tmp_kernel_op_618 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_555;
       const real_t tmp_kernel_op_619 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_24;
       const real_t tmp_kernel_op_620 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_25;
       const real_t tmp_kernel_op_621 = tmp_kernel_op_619 + tmp_kernel_op_620;
       const real_t tmp_kernel_op_622 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_24;
       const real_t tmp_kernel_op_623 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_25;
       const real_t tmp_kernel_op_624 = tmp_kernel_op_622 + tmp_kernel_op_623;
       const real_t tmp_kernel_op_625 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_24;
       const real_t tmp_kernel_op_626 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_25;
       const real_t tmp_kernel_op_627 = tmp_kernel_op_625 + tmp_kernel_op_626;
       const real_t tmp_kernel_op_629 = tmp_kernel_op_1*0.5;
       const real_t tmp_kernel_op_630 = tmp_kernel_op_0*0.16666666666666666;
       const real_t tmp_kernel_op_631 = tmp_kernel_op_629 + tmp_kernel_op_630;
       const real_t tmp_kernel_op_632 = tmp_kernel_op_7*0.5;
       const real_t tmp_kernel_op_633 = tmp_kernel_op_6*0.16666666666666666;
       const real_t tmp_kernel_op_634 = tmp_kernel_op_632 + tmp_kernel_op_633;
       const real_t tmp_kernel_op_635 = tmp_kernel_op_13*0.5;
       const real_t tmp_kernel_op_636 = tmp_kernel_op_12*0.16666666666666666;
       const real_t tmp_kernel_op_637 = tmp_kernel_op_635 + tmp_kernel_op_636;
       const real_t tmp_kernel_op_639 = tmp_kernel_op_1*0.16666666666666666;
       const real_t tmp_kernel_op_640 = tmp_kernel_op_0*0.16666666666666666;
       const real_t tmp_kernel_op_641 = tmp_kernel_op_639 + tmp_kernel_op_640;
       const real_t tmp_kernel_op_642 = tmp_kernel_op_7*0.16666666666666666;
       const real_t tmp_kernel_op_643 = tmp_kernel_op_6*0.16666666666666666;
       const real_t tmp_kernel_op_644 = tmp_kernel_op_642 + tmp_kernel_op_643;
       const real_t tmp_kernel_op_645 = tmp_kernel_op_13*0.16666666666666666;
       const real_t tmp_kernel_op_646 = tmp_kernel_op_12*0.16666666666666666;
       const real_t tmp_kernel_op_647 = tmp_kernel_op_645 + tmp_kernel_op_646;
       const real_t tmp_kernel_op_649 = tmp_kernel_op_1*0.16666666666666666;
       const real_t tmp_kernel_op_650 = tmp_kernel_op_0*0.5;
       const real_t tmp_kernel_op_651 = tmp_kernel_op_649 + tmp_kernel_op_650;
       const real_t tmp_kernel_op_652 = tmp_kernel_op_7*0.16666666666666666;
       const real_t tmp_kernel_op_653 = tmp_kernel_op_6*0.5;
       const real_t tmp_kernel_op_654 = tmp_kernel_op_652 + tmp_kernel_op_653;
       const real_t tmp_kernel_op_655 = tmp_kernel_op_13*0.16666666666666666;
       const real_t tmp_kernel_op_656 = tmp_kernel_op_12*0.5;
       const real_t tmp_kernel_op_657 = tmp_kernel_op_655 + tmp_kernel_op_656;
       const real_t tmp_kernel_op_659 = tmp_kernel_op_1*0.16666666666666666;
       const real_t tmp_kernel_op_660 = tmp_kernel_op_0*0.16666666666666666;
       const real_t tmp_kernel_op_661 = tmp_kernel_op_659 + tmp_kernel_op_660;
       const real_t tmp_kernel_op_662 = tmp_kernel_op_7*0.16666666666666666;
       const real_t tmp_kernel_op_663 = tmp_kernel_op_6*0.16666666666666666;
       const real_t tmp_kernel_op_664 = tmp_kernel_op_662 + tmp_kernel_op_663;
       const real_t tmp_kernel_op_665 = tmp_kernel_op_13*0.16666666666666666;
       const real_t tmp_kernel_op_666 = tmp_kernel_op_12*0.16666666666666666;
       const real_t tmp_kernel_op_667 = tmp_kernel_op_665 + tmp_kernel_op_666;
       const real_t tmp_kernel_op_669 = jac_affine_inv_1_0_WHITE_UP*8.0;
       const real_t tmp_kernel_op_670 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_669;
       const real_t tmp_kernel_op_671 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_672 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_673 = tmp_kernel_op_671 + tmp_kernel_op_672;
       const real_t tmp_kernel_op_674 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_675 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_676 = tmp_kernel_op_674 + tmp_kernel_op_675;
       const real_t tmp_kernel_op_677 = jac_affine_inv_1_1_WHITE_UP*8.0;
       const real_t tmp_kernel_op_678 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_677;
       const real_t tmp_kernel_op_679 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_7;
       const real_t tmp_kernel_op_680 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_8;
       const real_t tmp_kernel_op_681 = tmp_kernel_op_679 + tmp_kernel_op_680;
       const real_t tmp_kernel_op_682 = jac_affine_inv_1_2_WHITE_UP*8.0;
       const real_t tmp_kernel_op_683 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_682;
       const real_t tmp_kernel_op_684 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_26;
       const real_t tmp_kernel_op_685 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_25;
       const real_t tmp_kernel_op_686 = tmp_kernel_op_684 + tmp_kernel_op_685;
       const real_t tmp_kernel_op_687 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_26;
       const real_t tmp_kernel_op_688 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_25;
       const real_t tmp_kernel_op_689 = tmp_kernel_op_687 + tmp_kernel_op_688;
       const real_t tmp_kernel_op_690 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_26;
       const real_t tmp_kernel_op_691 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_25;
       const real_t tmp_kernel_op_692 = tmp_kernel_op_690 + tmp_kernel_op_691;
       const real_t tmp_kernel_op_694 = tmp_kernel_op_1*0.16666666666666666;
       const real_t tmp_kernel_op_695 = tmp_kernel_op_2*0.16666666666666666;
       const real_t tmp_kernel_op_696 = tmp_kernel_op_694 + tmp_kernel_op_695;
       const real_t tmp_kernel_op_697 = tmp_kernel_op_7*0.16666666666666666;
       const real_t tmp_kernel_op_698 = tmp_kernel_op_8*0.16666666666666666;
       const real_t tmp_kernel_op_699 = tmp_kernel_op_697 + tmp_kernel_op_698;
       const real_t tmp_kernel_op_700 = tmp_kernel_op_13*0.16666666666666666;
       const real_t tmp_kernel_op_701 = tmp_kernel_op_14*0.16666666666666666;
       const real_t tmp_kernel_op_702 = tmp_kernel_op_700 + tmp_kernel_op_701;
       const real_t tmp_kernel_op_704 = tmp_kernel_op_1*0.5;
       const real_t tmp_kernel_op_705 = tmp_kernel_op_2*0.16666666666666666;
       const real_t tmp_kernel_op_706 = tmp_kernel_op_704 + tmp_kernel_op_705;
       const real_t tmp_kernel_op_707 = tmp_kernel_op_7*0.5;
       const real_t tmp_kernel_op_708 = tmp_kernel_op_8*0.16666666666666666;
       const real_t tmp_kernel_op_709 = tmp_kernel_op_707 + tmp_kernel_op_708;
       const real_t tmp_kernel_op_710 = tmp_kernel_op_13*0.5;
       const real_t tmp_kernel_op_711 = tmp_kernel_op_14*0.16666666666666666;
       const real_t tmp_kernel_op_712 = tmp_kernel_op_710 + tmp_kernel_op_711;
       const real_t tmp_kernel_op_714 = tmp_kernel_op_1*0.16666666666666666;
       const real_t tmp_kernel_op_715 = tmp_kernel_op_2*0.5;
       const real_t tmp_kernel_op_716 = tmp_kernel_op_714 + tmp_kernel_op_715;
       const real_t tmp_kernel_op_717 = tmp_kernel_op_7*0.16666666666666666;
       const real_t tmp_kernel_op_718 = tmp_kernel_op_8*0.5;
       const real_t tmp_kernel_op_719 = tmp_kernel_op_717 + tmp_kernel_op_718;
       const real_t tmp_kernel_op_720 = tmp_kernel_op_13*0.16666666666666666;
       const real_t tmp_kernel_op_721 = tmp_kernel_op_14*0.5;
       const real_t tmp_kernel_op_722 = tmp_kernel_op_720 + tmp_kernel_op_721;
       const real_t tmp_kernel_op_724 = tmp_kernel_op_1*0.16666666666666666;
       const real_t tmp_kernel_op_725 = tmp_kernel_op_2*0.16666666666666666;
       const real_t tmp_kernel_op_726 = tmp_kernel_op_724 + tmp_kernel_op_725;
       const real_t tmp_kernel_op_727 = tmp_kernel_op_7*0.16666666666666666;
       const real_t tmp_kernel_op_728 = tmp_kernel_op_8*0.16666666666666666;
       const real_t tmp_kernel_op_729 = tmp_kernel_op_727 + tmp_kernel_op_728;
       const real_t tmp_kernel_op_730 = tmp_kernel_op_13*0.16666666666666666;
       const real_t tmp_kernel_op_731 = tmp_kernel_op_14*0.16666666666666666;
       const real_t tmp_kernel_op_732 = tmp_kernel_op_730 + tmp_kernel_op_731;
       const real_t tmp_kernel_op_734 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_735 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_736 = -tmp_kernel_op_3 - tmp_kernel_op_542;
       const real_t tmp_kernel_op_737 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_736 - tmp_kernel_op_734 - tmp_kernel_op_735;
       const real_t tmp_kernel_op_738 = -tmp_kernel_op_550 - tmp_kernel_op_9;
       const real_t tmp_kernel_op_739 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_738 - tmp_kernel_op_544 - tmp_kernel_op_608;
       const real_t tmp_kernel_op_740 = -tmp_kernel_op_15 - tmp_kernel_op_555;
       const real_t tmp_kernel_op_741 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_740 - tmp_kernel_op_547 - tmp_kernel_op_611;
       const real_t tmp_kernel_op_742 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_736 - tmp_kernel_op_545 - tmp_kernel_op_609;
       const real_t tmp_kernel_op_743 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_7;
       const real_t tmp_kernel_op_744 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_8;
       const real_t tmp_kernel_op_745 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_738 - tmp_kernel_op_743 - tmp_kernel_op_744;
       const real_t tmp_kernel_op_746 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_740 - tmp_kernel_op_552 - tmp_kernel_op_615;
       const real_t tmp_kernel_op_747 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_736 - tmp_kernel_op_548 - tmp_kernel_op_612;
       const real_t tmp_kernel_op_748 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_738 - tmp_kernel_op_553 - tmp_kernel_op_616;
       const real_t tmp_kernel_op_749 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_13;
       const real_t tmp_kernel_op_750 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_14;
       const real_t tmp_kernel_op_751 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_740 - tmp_kernel_op_749 - tmp_kernel_op_750;
       const real_t tmp_kernel_op_752 = -tmp_kernel_op_27 + 2.0;
       const real_t tmp_kernel_op_753 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_752 - tmp_kernel_op_557 - tmp_kernel_op_619;
       const real_t tmp_kernel_op_754 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_752 - tmp_kernel_op_560 - tmp_kernel_op_622;
       const real_t tmp_kernel_op_755 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_752 - tmp_kernel_op_563 - tmp_kernel_op_625;
       const real_t tmp_kernel_op_757 = -tmp_kernel_op_112;
       const real_t tmp_kernel_op_758 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_757 - tmp_kernel_op_567 - tmp_kernel_op_629;
       const real_t tmp_kernel_op_759 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_757 - tmp_kernel_op_570 - tmp_kernel_op_632;
       const real_t tmp_kernel_op_760 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_757 - tmp_kernel_op_573 - tmp_kernel_op_635;
       const real_t tmp_kernel_op_762 = -tmp_kernel_op_197 + 2.666666666666667;
       const real_t tmp_kernel_op_763 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_762 - tmp_kernel_op_577 - tmp_kernel_op_639;
       const real_t tmp_kernel_op_764 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_762 - tmp_kernel_op_580 - tmp_kernel_op_642;
       const real_t tmp_kernel_op_765 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_762 - tmp_kernel_op_583 - tmp_kernel_op_645;
       const real_t tmp_kernel_op_767 = -tmp_kernel_op_282 + 2.666666666666667;
       const real_t tmp_kernel_op_768 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_767 - tmp_kernel_op_587 - tmp_kernel_op_649;
       const real_t tmp_kernel_op_769 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_767 - tmp_kernel_op_590 - tmp_kernel_op_652;
       const real_t tmp_kernel_op_770 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_767 - tmp_kernel_op_593 - tmp_kernel_op_655;
       const real_t tmp_kernel_op_772 = -tmp_kernel_op_367 + 2.666666666666667;
       const real_t tmp_kernel_op_773 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_772 - tmp_kernel_op_597 - tmp_kernel_op_659;
       const real_t tmp_kernel_op_774 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_772 - tmp_kernel_op_600 - tmp_kernel_op_662;
       const real_t tmp_kernel_op_775 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_772 - tmp_kernel_op_603 - tmp_kernel_op_665;
       const real_t tmp_kernel_op_777 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_778 = -tmp_kernel_op_0 - tmp_kernel_op_1 - tmp_kernel_op_669;
       const real_t tmp_kernel_op_779 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_778 - tmp_kernel_op_735 - tmp_kernel_op_777;
       const real_t tmp_kernel_op_780 = -tmp_kernel_op_6 - tmp_kernel_op_677 - tmp_kernel_op_7;
       const real_t tmp_kernel_op_781 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_780 - tmp_kernel_op_545 - tmp_kernel_op_671;
       const real_t tmp_kernel_op_782 = -tmp_kernel_op_12 - tmp_kernel_op_13 - tmp_kernel_op_682;
       const real_t tmp_kernel_op_783 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_782 - tmp_kernel_op_548 - tmp_kernel_op_674;
       const real_t tmp_kernel_op_784 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_778 - tmp_kernel_op_544 - tmp_kernel_op_672;
       const real_t tmp_kernel_op_785 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_7;
       const real_t tmp_kernel_op_786 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_780 - tmp_kernel_op_744 - tmp_kernel_op_785;
       const real_t tmp_kernel_op_787 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_782 - tmp_kernel_op_553 - tmp_kernel_op_679;
       const real_t tmp_kernel_op_788 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_778 - tmp_kernel_op_547 - tmp_kernel_op_675;
       const real_t tmp_kernel_op_789 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_780 - tmp_kernel_op_552 - tmp_kernel_op_680;
       const real_t tmp_kernel_op_790 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_13;
       const real_t tmp_kernel_op_791 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_782 - tmp_kernel_op_750 - tmp_kernel_op_790;
       const real_t tmp_kernel_op_792 = tmp_kernel_op_24 - 4.0;
       const real_t tmp_kernel_op_793 = -tmp_kernel_op_25 - tmp_kernel_op_792 - 2.0;
       const real_t tmp_kernel_op_794 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_793 - tmp_kernel_op_558 - tmp_kernel_op_684;
       const real_t tmp_kernel_op_795 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_793 - tmp_kernel_op_561 - tmp_kernel_op_687;
       const real_t tmp_kernel_op_796 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_793 - tmp_kernel_op_564 - tmp_kernel_op_690;
       const real_t tmp_kernel_op_798 = tmp_kernel_op_109 - 4.0;
       const real_t tmp_kernel_op_799 = -tmp_kernel_op_110 - tmp_kernel_op_798 - 1.3333333333333333;
       const real_t tmp_kernel_op_800 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_799 - tmp_kernel_op_568 - tmp_kernel_op_694;
       const real_t tmp_kernel_op_801 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_799 - tmp_kernel_op_571 - tmp_kernel_op_697;
       const real_t tmp_kernel_op_802 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_799 - tmp_kernel_op_574 - tmp_kernel_op_700;
       const real_t tmp_kernel_op_804 = tmp_kernel_op_194 - 4.0;
       const real_t tmp_kernel_op_805 = -tmp_kernel_op_195 - tmp_kernel_op_804 - 4.0;
       const real_t tmp_kernel_op_806 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_805 - tmp_kernel_op_578 - tmp_kernel_op_704;
       const real_t tmp_kernel_op_807 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_805 - tmp_kernel_op_581 - tmp_kernel_op_707;
       const real_t tmp_kernel_op_808 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_805 - tmp_kernel_op_584 - tmp_kernel_op_710;
       const real_t tmp_kernel_op_810 = tmp_kernel_op_279 - 4.0;
       const real_t tmp_kernel_op_811 = -tmp_kernel_op_280 - tmp_kernel_op_810 - 1.3333333333333333;
       const real_t tmp_kernel_op_812 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_811 - tmp_kernel_op_588 - tmp_kernel_op_714;
       const real_t tmp_kernel_op_813 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_811 - tmp_kernel_op_591 - tmp_kernel_op_717;
       const real_t tmp_kernel_op_814 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_811 - tmp_kernel_op_594 - tmp_kernel_op_720;
       const real_t tmp_kernel_op_816 = tmp_kernel_op_364 - 4.0;
       const real_t tmp_kernel_op_817 = -tmp_kernel_op_365 - tmp_kernel_op_816 - 1.3333333333333333;
       const real_t tmp_kernel_op_818 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_817 - tmp_kernel_op_598 - tmp_kernel_op_724;
       const real_t tmp_kernel_op_819 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_817 - tmp_kernel_op_601 - tmp_kernel_op_727;
       const real_t tmp_kernel_op_820 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_817 - tmp_kernel_op_604 - tmp_kernel_op_730;
       const real_t tmp_kernel_op_822 = jac_affine_inv_0_0_WHITE_UP*-8.0 - tmp_kernel_op_0 - tmp_kernel_op_2;
       const real_t tmp_kernel_op_823 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_822 - tmp_kernel_op_734 - tmp_kernel_op_777;
       const real_t tmp_kernel_op_824 = jac_affine_inv_0_1_WHITE_UP*-8.0 - tmp_kernel_op_6 - tmp_kernel_op_8;
       const real_t tmp_kernel_op_825 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_824 - tmp_kernel_op_609 - tmp_kernel_op_672;
       const real_t tmp_kernel_op_826 = jac_affine_inv_0_2_WHITE_UP*-8.0 - tmp_kernel_op_12 - tmp_kernel_op_14;
       const real_t tmp_kernel_op_827 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_826 - tmp_kernel_op_612 - tmp_kernel_op_675;
       const real_t tmp_kernel_op_828 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_822 - tmp_kernel_op_608 - tmp_kernel_op_671;
       const real_t tmp_kernel_op_829 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_824 - tmp_kernel_op_743 - tmp_kernel_op_785;
       const real_t tmp_kernel_op_830 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_826 - tmp_kernel_op_616 - tmp_kernel_op_680;
       const real_t tmp_kernel_op_831 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_822 - tmp_kernel_op_611 - tmp_kernel_op_674;
       const real_t tmp_kernel_op_832 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_824 - tmp_kernel_op_615 - tmp_kernel_op_679;
       const real_t tmp_kernel_op_833 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_826 - tmp_kernel_op_749 - tmp_kernel_op_790;
       const real_t tmp_kernel_op_834 = -tmp_kernel_op_26 - tmp_kernel_op_792 - 2.0;
       const real_t tmp_kernel_op_835 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_834 - tmp_kernel_op_620 - tmp_kernel_op_685;
       const real_t tmp_kernel_op_836 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_834 - tmp_kernel_op_623 - tmp_kernel_op_688;
       const real_t tmp_kernel_op_837 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_834 - tmp_kernel_op_626 - tmp_kernel_op_691;
       const real_t tmp_kernel_op_839 = -tmp_kernel_op_111 - tmp_kernel_op_798 - 1.3333333333333333;
       const real_t tmp_kernel_op_840 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_839 - tmp_kernel_op_630 - tmp_kernel_op_695;
       const real_t tmp_kernel_op_841 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_839 - tmp_kernel_op_633 - tmp_kernel_op_698;
       const real_t tmp_kernel_op_842 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_839 - tmp_kernel_op_636 - tmp_kernel_op_701;
       const real_t tmp_kernel_op_844 = -tmp_kernel_op_196 - tmp_kernel_op_804 - 1.3333333333333333;
       const real_t tmp_kernel_op_845 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_844 - tmp_kernel_op_640 - tmp_kernel_op_705;
       const real_t tmp_kernel_op_846 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_844 - tmp_kernel_op_643 - tmp_kernel_op_708;
       const real_t tmp_kernel_op_847 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_844 - tmp_kernel_op_646 - tmp_kernel_op_711;
       const real_t tmp_kernel_op_849 = -tmp_kernel_op_281 - tmp_kernel_op_810 - 4.0;
       const real_t tmp_kernel_op_850 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_849 - tmp_kernel_op_650 - tmp_kernel_op_715;
       const real_t tmp_kernel_op_851 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_849 - tmp_kernel_op_653 - tmp_kernel_op_718;
       const real_t tmp_kernel_op_852 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_849 - tmp_kernel_op_656 - tmp_kernel_op_721;
       const real_t tmp_kernel_op_854 = -tmp_kernel_op_366 - tmp_kernel_op_816 - 1.3333333333333333;
       const real_t tmp_kernel_op_855 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_854 - tmp_kernel_op_660 - tmp_kernel_op_725;
       const real_t tmp_kernel_op_856 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_854 - tmp_kernel_op_663 - tmp_kernel_op_728;
       const real_t tmp_kernel_op_857 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_854 - tmp_kernel_op_666 - tmp_kernel_op_731;
       {
          /* CellType.WHITE_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
             const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
             const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
             const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
             const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
             const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
             const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
             const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
             const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
             const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
             const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
             const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
             const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
             const real_t tmp_blending_op_35 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_36 = tmp_blending_op_22 - tmp_blending_op_35;
             const real_t tmp_blending_op_37 = -tmp_blending_op_36;
             const real_t tmp_blending_op_38 = (tmp_blending_op_28*tmp_blending_op_28);
             const real_t tmp_blending_op_39 = (tmp_blending_op_33*tmp_blending_op_33);
             const real_t tmp_blending_op_40 = tmp_blending_op_38 + tmp_blending_op_39 + tmp_blending_op_4;
             const real_t tmp_blending_op_43 = tmp_blending_op_3*tmp_blending_op_42;
             const real_t tmp_blending_op_44 = tmp_blending_op_36 + tmp_blending_op_43;
             const real_t tmp_blending_op_45 = tmp_blending_op_37*tmp_blending_op_4 + tmp_blending_op_40*tmp_blending_op_44;
             const real_t tmp_blending_op_46 = pow(tmp_blending_op_40, -1.5000000000000000);
             const real_t tmp_blending_op_49 = tmp_blending_op_46*tmp_blending_op_48;
             const real_t tmp_blending_op_52 = tmp_blending_op_40*tmp_blending_op_51;
             const real_t tmp_blending_op_53 = -tmp_blending_op_33*tmp_blending_op_36 - tmp_blending_op_52;
             const real_t tmp_blending_op_54 = tmp_blending_op_49*tmp_blending_op_53;
             const real_t tmp_blending_op_57 = tmp_blending_op_28*tmp_blending_op_37 + tmp_blending_op_40*tmp_blending_op_56;
             const real_t tmp_blending_op_58 = tmp_blending_op_49*tmp_blending_op_57;
             const real_t tmp_blending_op_59 = tmp_blending_op_3*tmp_blending_op_37;
             const real_t tmp_blending_op_60 = tmp_blending_op_40*tmp_blending_op_42 + tmp_blending_op_59;
             const real_t tmp_blending_op_61 = tmp_blending_op_49*tmp_blending_op_60;
             const real_t tmp_blending_op_63 = tmp_blending_op_33*tmp_blending_op_62 + tmp_blending_op_36;
             const real_t tmp_blending_op_64 = tmp_blending_op_37*tmp_blending_op_39 + tmp_blending_op_40*tmp_blending_op_63;
             const real_t tmp_blending_op_65 = tmp_blending_op_28*tmp_blending_op_56;
             const real_t tmp_blending_op_66 = tmp_blending_op_36 + tmp_blending_op_65;
             const real_t tmp_blending_op_67 = -tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_40*tmp_blending_op_66;
             const real_t tmp_blending_op_75 = p_affine_0_2 + tmp_blending_op_0*0.5 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_76 = (tmp_blending_op_75*tmp_blending_op_75);
             const real_t tmp_blending_op_77 = -tmp_blending_op_17 - tmp_blending_op_75;
             const real_t tmp_blending_op_78 = p_affine_0_0 + tmp_blending_op_25*0.5 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_79 = -tmp_blending_op_6 - tmp_blending_op_78;
             const real_t tmp_blending_op_80 = p_affine_0_1 + tmp_blending_op_30*0.5 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_81 = -tmp_blending_op_13 - tmp_blending_op_80;
             const real_t tmp_blending_op_82 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_79 - tmp_blending_op_12*tmp_blending_op_77 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_77 - tmp_blending_op_19*tmp_blending_op_79 - tmp_blending_op_20*tmp_blending_op_81 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_81);
             const real_t tmp_blending_op_83 = tmp_blending_op_22 - tmp_blending_op_82;
             const real_t tmp_blending_op_84 = -tmp_blending_op_83;
             const real_t tmp_blending_op_85 = (tmp_blending_op_78*tmp_blending_op_78);
             const real_t tmp_blending_op_86 = (tmp_blending_op_80*tmp_blending_op_80);
             const real_t tmp_blending_op_87 = tmp_blending_op_76 + tmp_blending_op_85 + tmp_blending_op_86;
             const real_t tmp_blending_op_88 = tmp_blending_op_42*tmp_blending_op_75;
             const real_t tmp_blending_op_89 = tmp_blending_op_83 + tmp_blending_op_88;
             const real_t tmp_blending_op_90 = tmp_blending_op_76*tmp_blending_op_84 + tmp_blending_op_87*tmp_blending_op_89;
             const real_t tmp_blending_op_91 = pow(tmp_blending_op_87, -1.5000000000000000);
             const real_t tmp_blending_op_92 = tmp_blending_op_48*tmp_blending_op_91;
             const real_t tmp_blending_op_93 = tmp_blending_op_51*tmp_blending_op_87;
             const real_t tmp_blending_op_94 = -tmp_blending_op_80*tmp_blending_op_83 - tmp_blending_op_93;
             const real_t tmp_blending_op_95 = tmp_blending_op_92*tmp_blending_op_94;
             const real_t tmp_blending_op_96 = tmp_blending_op_56*tmp_blending_op_87 + tmp_blending_op_78*tmp_blending_op_84;
             const real_t tmp_blending_op_97 = tmp_blending_op_92*tmp_blending_op_96;
             const real_t tmp_blending_op_98 = tmp_blending_op_75*tmp_blending_op_84;
             const real_t tmp_blending_op_99 = tmp_blending_op_42*tmp_blending_op_87 + tmp_blending_op_98;
             const real_t tmp_blending_op_100 = tmp_blending_op_92*tmp_blending_op_99;
             const real_t tmp_blending_op_101 = tmp_blending_op_62*tmp_blending_op_80 + tmp_blending_op_83;
             const real_t tmp_blending_op_102 = tmp_blending_op_101*tmp_blending_op_87 + tmp_blending_op_84*tmp_blending_op_86;
             const real_t tmp_blending_op_103 = tmp_blending_op_56*tmp_blending_op_78;
             const real_t tmp_blending_op_104 = tmp_blending_op_103 + tmp_blending_op_83;
             const real_t tmp_blending_op_105 = tmp_blending_op_104*tmp_blending_op_87 - tmp_blending_op_83*tmp_blending_op_85;
             const real_t tmp_blending_op_113 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.5 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_114 = (tmp_blending_op_113*tmp_blending_op_113);
             const real_t tmp_blending_op_115 = -tmp_blending_op_113 - tmp_blending_op_17;
             const real_t tmp_blending_op_116 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.5 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_117 = -tmp_blending_op_116 - tmp_blending_op_6;
             const real_t tmp_blending_op_118 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.5 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_119 = -tmp_blending_op_118 - tmp_blending_op_13;
             const real_t tmp_blending_op_120 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_117*tmp_blending_op_18 - tmp_blending_op_115*tmp_blending_op_12 + tmp_blending_op_115*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_117*tmp_blending_op_19 - tmp_blending_op_119*tmp_blending_op_20 + tmp_blending_op_119*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_121 = -tmp_blending_op_120 + tmp_blending_op_22;
             const real_t tmp_blending_op_122 = -tmp_blending_op_121;
             const real_t tmp_blending_op_123 = (tmp_blending_op_116*tmp_blending_op_116);
             const real_t tmp_blending_op_124 = (tmp_blending_op_118*tmp_blending_op_118);
             const real_t tmp_blending_op_125 = tmp_blending_op_114 + tmp_blending_op_123 + tmp_blending_op_124;
             const real_t tmp_blending_op_126 = tmp_blending_op_113*tmp_blending_op_42;
             const real_t tmp_blending_op_127 = tmp_blending_op_121 + tmp_blending_op_126;
             const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_127;
             const real_t tmp_blending_op_129 = pow(tmp_blending_op_125, -1.5000000000000000);
             const real_t tmp_blending_op_130 = tmp_blending_op_129*tmp_blending_op_48;
             const real_t tmp_blending_op_131 = tmp_blending_op_125*tmp_blending_op_51;
             const real_t tmp_blending_op_132 = -tmp_blending_op_118*tmp_blending_op_121 - tmp_blending_op_131;
             const real_t tmp_blending_op_133 = tmp_blending_op_130*tmp_blending_op_132;
             const real_t tmp_blending_op_134 = tmp_blending_op_116*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_56;
             const real_t tmp_blending_op_135 = tmp_blending_op_130*tmp_blending_op_134;
             const real_t tmp_blending_op_136 = tmp_blending_op_113*tmp_blending_op_122;
             const real_t tmp_blending_op_137 = tmp_blending_op_125*tmp_blending_op_42 + tmp_blending_op_136;
             const real_t tmp_blending_op_138 = tmp_blending_op_130*tmp_blending_op_137;
             const real_t tmp_blending_op_139 = tmp_blending_op_118*tmp_blending_op_62 + tmp_blending_op_121;
             const real_t tmp_blending_op_140 = tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*tmp_blending_op_139;
             const real_t tmp_blending_op_141 = tmp_blending_op_116*tmp_blending_op_56;
             const real_t tmp_blending_op_142 = tmp_blending_op_121 + tmp_blending_op_141;
             const real_t tmp_blending_op_143 = -tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*tmp_blending_op_142;
             const real_t tmp_blending_op_151 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.5;
             const real_t tmp_blending_op_152 = (tmp_blending_op_151*tmp_blending_op_151);
             const real_t tmp_blending_op_153 = -tmp_blending_op_151 - tmp_blending_op_17;
             const real_t tmp_blending_op_154 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.5;
             const real_t tmp_blending_op_155 = -tmp_blending_op_154 - tmp_blending_op_6;
             const real_t tmp_blending_op_156 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.5;
             const real_t tmp_blending_op_157 = -tmp_blending_op_13 - tmp_blending_op_156;
             const real_t tmp_blending_op_158 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_155*tmp_blending_op_18 - tmp_blending_op_12*tmp_blending_op_153 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_153 - tmp_blending_op_155*tmp_blending_op_19 - tmp_blending_op_157*tmp_blending_op_20 + tmp_blending_op_157*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_159 = -tmp_blending_op_158 + tmp_blending_op_22;
             const real_t tmp_blending_op_160 = -tmp_blending_op_159;
             const real_t tmp_blending_op_161 = (tmp_blending_op_154*tmp_blending_op_154);
             const real_t tmp_blending_op_162 = (tmp_blending_op_156*tmp_blending_op_156);
             const real_t tmp_blending_op_163 = tmp_blending_op_152 + tmp_blending_op_161 + tmp_blending_op_162;
             const real_t tmp_blending_op_164 = tmp_blending_op_151*tmp_blending_op_42;
             const real_t tmp_blending_op_165 = tmp_blending_op_159 + tmp_blending_op_164;
             const real_t tmp_blending_op_166 = tmp_blending_op_152*tmp_blending_op_160 + tmp_blending_op_163*tmp_blending_op_165;
             const real_t tmp_blending_op_167 = pow(tmp_blending_op_163, -1.5000000000000000);
             const real_t tmp_blending_op_168 = tmp_blending_op_167*tmp_blending_op_48;
             const real_t tmp_blending_op_169 = tmp_blending_op_163*tmp_blending_op_51;
             const real_t tmp_blending_op_170 = -tmp_blending_op_156*tmp_blending_op_159 - tmp_blending_op_169;
             const real_t tmp_blending_op_171 = tmp_blending_op_168*tmp_blending_op_170;
             const real_t tmp_blending_op_172 = tmp_blending_op_154*tmp_blending_op_160 + tmp_blending_op_163*tmp_blending_op_56;
             const real_t tmp_blending_op_173 = tmp_blending_op_168*tmp_blending_op_172;
             const real_t tmp_blending_op_174 = tmp_blending_op_151*tmp_blending_op_160;
             const real_t tmp_blending_op_175 = tmp_blending_op_163*tmp_blending_op_42 + tmp_blending_op_174;
             const real_t tmp_blending_op_176 = tmp_blending_op_168*tmp_blending_op_175;
             const real_t tmp_blending_op_177 = tmp_blending_op_156*tmp_blending_op_62 + tmp_blending_op_159;
             const real_t tmp_blending_op_178 = tmp_blending_op_160*tmp_blending_op_162 + tmp_blending_op_163*tmp_blending_op_177;
             const real_t tmp_blending_op_179 = tmp_blending_op_154*tmp_blending_op_56;
             const real_t tmp_blending_op_180 = tmp_blending_op_159 + tmp_blending_op_179;
             const real_t tmp_blending_op_181 = -tmp_blending_op_159*tmp_blending_op_161 + tmp_blending_op_163*tmp_blending_op_180;
             const real_t tmp_blending_op_189 = p_affine_0_2 + tmp_blending_op_0*0.25 + tmp_blending_op_1*0.25 + tmp_blending_op_2*0.25;
             const real_t tmp_blending_op_190 = (tmp_blending_op_189*tmp_blending_op_189);
             const real_t tmp_blending_op_191 = -tmp_blending_op_17 - tmp_blending_op_189;
             const real_t tmp_blending_op_192 = p_affine_0_0 + tmp_blending_op_25*0.25 + tmp_blending_op_26*0.25 + tmp_blending_op_27*0.25;
             const real_t tmp_blending_op_193 = -tmp_blending_op_192 - tmp_blending_op_6;
             const real_t tmp_blending_op_194 = p_affine_0_1 + tmp_blending_op_30*0.25 + tmp_blending_op_31*0.25 + tmp_blending_op_32*0.25;
             const real_t tmp_blending_op_195 = -tmp_blending_op_13 - tmp_blending_op_194;
             const real_t tmp_blending_op_196 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_193 - tmp_blending_op_12*tmp_blending_op_191 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_191 - tmp_blending_op_19*tmp_blending_op_193 - tmp_blending_op_195*tmp_blending_op_20 + tmp_blending_op_195*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_197 = -tmp_blending_op_196 + tmp_blending_op_22;
             const real_t tmp_blending_op_198 = -tmp_blending_op_197;
             const real_t tmp_blending_op_199 = (tmp_blending_op_192*tmp_blending_op_192);
             const real_t tmp_blending_op_200 = (tmp_blending_op_194*tmp_blending_op_194);
             const real_t tmp_blending_op_201 = tmp_blending_op_190 + tmp_blending_op_199 + tmp_blending_op_200;
             const real_t tmp_blending_op_202 = tmp_blending_op_189*tmp_blending_op_42;
             const real_t tmp_blending_op_203 = tmp_blending_op_197 + tmp_blending_op_202;
             const real_t tmp_blending_op_204 = tmp_blending_op_190*tmp_blending_op_198 + tmp_blending_op_201*tmp_blending_op_203;
             const real_t tmp_blending_op_205 = pow(tmp_blending_op_201, -1.5000000000000000);
             const real_t tmp_blending_op_206 = tmp_blending_op_205*tmp_blending_op_48;
             const real_t tmp_blending_op_207 = tmp_blending_op_201*tmp_blending_op_51;
             const real_t tmp_blending_op_208 = -tmp_blending_op_194*tmp_blending_op_197 - tmp_blending_op_207;
             const real_t tmp_blending_op_209 = tmp_blending_op_206*tmp_blending_op_208;
             const real_t tmp_blending_op_210 = tmp_blending_op_192*tmp_blending_op_198 + tmp_blending_op_201*tmp_blending_op_56;
             const real_t tmp_blending_op_211 = tmp_blending_op_206*tmp_blending_op_210;
             const real_t tmp_blending_op_212 = tmp_blending_op_189*tmp_blending_op_198;
             const real_t tmp_blending_op_213 = tmp_blending_op_201*tmp_blending_op_42 + tmp_blending_op_212;
             const real_t tmp_blending_op_214 = tmp_blending_op_206*tmp_blending_op_213;
             const real_t tmp_blending_op_215 = tmp_blending_op_194*tmp_blending_op_62 + tmp_blending_op_197;
             const real_t tmp_blending_op_216 = tmp_blending_op_198*tmp_blending_op_200 + tmp_blending_op_201*tmp_blending_op_215;
             const real_t tmp_blending_op_217 = tmp_blending_op_192*tmp_blending_op_56;
             const real_t tmp_blending_op_218 = tmp_blending_op_197 + tmp_blending_op_217;
             const real_t tmp_blending_op_219 = -tmp_blending_op_197*tmp_blending_op_199 + tmp_blending_op_201*tmp_blending_op_218;
             const real_t tmp_blending_op_228 = pow(tmp_blending_op_201, -2.5000000000000000)*tmp_blending_op_227;
             const real_t tmp_blending_op_229 = tmp_blending_op_192*tmp_blending_op_228;
             const real_t tmp_blending_op_232 = tmp_blending_op_192*2.0;
             const real_t tmp_blending_op_234 = tmp_blending_op_196 + tmp_blending_op_233;
             const real_t tmp_blending_op_235 = tmp_blending_op_192*tmp_blending_op_230 + tmp_blending_op_217*2.0 + tmp_blending_op_234;
             const real_t tmp_blending_op_236 = tmp_blending_op_210*tmp_blending_op_229;
             const real_t tmp_blending_op_237 = tmp_blending_op_194*tmp_blending_op_23*tmp_blending_op_55 - tmp_blending_op_232*tmp_blending_op_51;
             const real_t tmp_blending_op_238 = tmp_blending_op_199*tmp_blending_op_228;
             const real_t tmp_blending_op_239 = -tmp_blending_op_201*tmp_blending_op_230;
             const real_t tmp_blending_op_240 = tmp_blending_op_208*tmp_blending_op_229;
             const real_t tmp_blending_op_241 = tmp_blending_op_189*tmp_blending_op_240;
             const real_t tmp_blending_op_242 = tmp_blending_op_189*tmp_blending_op_230 + tmp_blending_op_232*tmp_blending_op_42;
             const real_t tmp_blending_op_243 = tmp_blending_op_213*tmp_blending_op_229;
             const real_t tmp_blending_op_244 = tmp_blending_op_194*tmp_blending_op_243;
             const real_t tmp_blending_op_245 = -tmp_blending_op_207;
             const real_t tmp_blending_op_246 = tmp_blending_op_194*2.0;
             const real_t tmp_blending_op_247 = tmp_blending_op_194*tmp_blending_op_228;
             const real_t tmp_blending_op_248 = tmp_blending_op_206*(tmp_blending_op_192*tmp_blending_op_51 + tmp_blending_op_246*tmp_blending_op_56);
             const real_t tmp_blending_op_249 = tmp_blending_op_200*tmp_blending_op_228;
             const real_t tmp_blending_op_250 = tmp_blending_op_189*tmp_blending_op_247;
             const real_t tmp_blending_op_251 = -tmp_blending_op_210*tmp_blending_op_250;
             const real_t tmp_blending_op_252 = -tmp_blending_op_194*tmp_blending_op_51 - tmp_blending_op_197;
             const real_t tmp_blending_op_254 = tmp_blending_op_189*tmp_blending_op_51;
             const real_t tmp_blending_op_255 = tmp_blending_op_246*tmp_blending_op_42 + tmp_blending_op_254;
             const real_t tmp_blending_op_257 = -tmp_blending_op_201*tmp_blending_op_256;
             const real_t tmp_blending_op_258 = tmp_blending_op_189*2.0;
             const real_t tmp_blending_op_259 = tmp_blending_op_189*tmp_blending_op_228;
             const real_t tmp_blending_op_260 = tmp_blending_op_206*(tmp_blending_op_192*tmp_blending_op_256 + tmp_blending_op_258*tmp_blending_op_56);
             const real_t tmp_blending_op_261 = tmp_blending_op_190*tmp_blending_op_228;
             const real_t tmp_blending_op_262 = tmp_blending_op_206*(tmp_blending_op_194*tmp_blending_op_256 + tmp_blending_op_254*-2.0);
             const real_t tmp_blending_op_263 = tmp_blending_op_189*tmp_blending_op_256 + tmp_blending_op_202*2.0 + tmp_blending_op_234;
             const real_t tmp_blending_op_265 = pow(tmp_blending_op_163, -2.5000000000000000)*tmp_blending_op_227;
             const real_t tmp_blending_op_266 = tmp_blending_op_154*tmp_blending_op_265;
             const real_t tmp_blending_op_267 = tmp_blending_op_154*2.0;
             const real_t tmp_blending_op_268 = tmp_blending_op_158 + tmp_blending_op_233;
             const real_t tmp_blending_op_269 = tmp_blending_op_154*tmp_blending_op_230 + tmp_blending_op_179*2.0 + tmp_blending_op_268;
             const real_t tmp_blending_op_270 = tmp_blending_op_172*tmp_blending_op_266;
             const real_t tmp_blending_op_271 = tmp_blending_op_156*tmp_blending_op_23*tmp_blending_op_55 - tmp_blending_op_267*tmp_blending_op_51;
             const real_t tmp_blending_op_272 = tmp_blending_op_161*tmp_blending_op_265;
             const real_t tmp_blending_op_273 = -tmp_blending_op_163*tmp_blending_op_230;
             const real_t tmp_blending_op_274 = tmp_blending_op_170*tmp_blending_op_266;
             const real_t tmp_blending_op_275 = tmp_blending_op_151*tmp_blending_op_274;
             const real_t tmp_blending_op_276 = tmp_blending_op_151*tmp_blending_op_230 + tmp_blending_op_267*tmp_blending_op_42;
             const real_t tmp_blending_op_277 = tmp_blending_op_175*tmp_blending_op_266;
             const real_t tmp_blending_op_278 = tmp_blending_op_156*tmp_blending_op_277;
             const real_t tmp_blending_op_279 = -tmp_blending_op_169;
             const real_t tmp_blending_op_280 = tmp_blending_op_156*2.0;
             const real_t tmp_blending_op_281 = tmp_blending_op_156*tmp_blending_op_265;
             const real_t tmp_blending_op_282 = tmp_blending_op_168*(tmp_blending_op_154*tmp_blending_op_51 + tmp_blending_op_280*tmp_blending_op_56);
             const real_t tmp_blending_op_283 = tmp_blending_op_162*tmp_blending_op_265;
             const real_t tmp_blending_op_284 = tmp_blending_op_151*tmp_blending_op_281;
             const real_t tmp_blending_op_285 = -tmp_blending_op_172*tmp_blending_op_284;
             const real_t tmp_blending_op_286 = -tmp_blending_op_156*tmp_blending_op_51 - tmp_blending_op_159;
             const real_t tmp_blending_op_287 = tmp_blending_op_151*tmp_blending_op_51;
             const real_t tmp_blending_op_288 = tmp_blending_op_280*tmp_blending_op_42 + tmp_blending_op_287;
             const real_t tmp_blending_op_289 = -tmp_blending_op_163*tmp_blending_op_256;
             const real_t tmp_blending_op_290 = tmp_blending_op_151*2.0;
             const real_t tmp_blending_op_291 = tmp_blending_op_151*tmp_blending_op_265;
             const real_t tmp_blending_op_292 = tmp_blending_op_168*(tmp_blending_op_154*tmp_blending_op_256 + tmp_blending_op_290*tmp_blending_op_56);
             const real_t tmp_blending_op_293 = tmp_blending_op_152*tmp_blending_op_265;
             const real_t tmp_blending_op_294 = tmp_blending_op_168*(tmp_blending_op_156*tmp_blending_op_256 + tmp_blending_op_287*-2.0);
             const real_t tmp_blending_op_295 = tmp_blending_op_151*tmp_blending_op_256 + tmp_blending_op_164*2.0 + tmp_blending_op_268;
             const real_t tmp_blending_op_296 = pow(tmp_blending_op_125, -2.5000000000000000)*tmp_blending_op_227;
             const real_t tmp_blending_op_297 = tmp_blending_op_116*tmp_blending_op_296;
             const real_t tmp_blending_op_298 = tmp_blending_op_116*2.0;
             const real_t tmp_blending_op_299 = tmp_blending_op_120 + tmp_blending_op_233;
             const real_t tmp_blending_op_300 = tmp_blending_op_116*tmp_blending_op_230 + tmp_blending_op_141*2.0 + tmp_blending_op_299;
             const real_t tmp_blending_op_301 = tmp_blending_op_134*tmp_blending_op_297;
             const real_t tmp_blending_op_302 = tmp_blending_op_118*tmp_blending_op_23*tmp_blending_op_55 - tmp_blending_op_298*tmp_blending_op_51;
             const real_t tmp_blending_op_303 = tmp_blending_op_123*tmp_blending_op_296;
             const real_t tmp_blending_op_304 = -tmp_blending_op_125*tmp_blending_op_230;
             const real_t tmp_blending_op_305 = tmp_blending_op_132*tmp_blending_op_297;
             const real_t tmp_blending_op_306 = tmp_blending_op_113*tmp_blending_op_305;
             const real_t tmp_blending_op_307 = tmp_blending_op_113*tmp_blending_op_230 + tmp_blending_op_298*tmp_blending_op_42;
             const real_t tmp_blending_op_308 = tmp_blending_op_137*tmp_blending_op_297;
             const real_t tmp_blending_op_309 = tmp_blending_op_118*tmp_blending_op_308;
             const real_t tmp_blending_op_310 = -tmp_blending_op_131;
             const real_t tmp_blending_op_311 = tmp_blending_op_118*2.0;
             const real_t tmp_blending_op_312 = tmp_blending_op_118*tmp_blending_op_296;
             const real_t tmp_blending_op_313 = tmp_blending_op_130*(tmp_blending_op_116*tmp_blending_op_51 + tmp_blending_op_311*tmp_blending_op_56);
             const real_t tmp_blending_op_314 = tmp_blending_op_124*tmp_blending_op_296;
             const real_t tmp_blending_op_315 = tmp_blending_op_113*tmp_blending_op_312;
             const real_t tmp_blending_op_316 = -tmp_blending_op_134*tmp_blending_op_315;
             const real_t tmp_blending_op_317 = -tmp_blending_op_118*tmp_blending_op_51 - tmp_blending_op_121;
             const real_t tmp_blending_op_318 = tmp_blending_op_113*tmp_blending_op_51;
             const real_t tmp_blending_op_319 = tmp_blending_op_311*tmp_blending_op_42 + tmp_blending_op_318;
             const real_t tmp_blending_op_320 = -tmp_blending_op_125*tmp_blending_op_256;
             const real_t tmp_blending_op_321 = tmp_blending_op_113*2.0;
             const real_t tmp_blending_op_322 = tmp_blending_op_113*tmp_blending_op_296;
             const real_t tmp_blending_op_323 = tmp_blending_op_130*(tmp_blending_op_116*tmp_blending_op_256 + tmp_blending_op_321*tmp_blending_op_56);
             const real_t tmp_blending_op_324 = tmp_blending_op_114*tmp_blending_op_296;
             const real_t tmp_blending_op_325 = tmp_blending_op_130*(tmp_blending_op_118*tmp_blending_op_256 + tmp_blending_op_318*-2.0);
             const real_t tmp_blending_op_326 = tmp_blending_op_113*tmp_blending_op_256 + tmp_blending_op_126*2.0 + tmp_blending_op_299;
             const real_t tmp_blending_op_327 = tmp_blending_op_227*pow(tmp_blending_op_87, -2.5000000000000000);
             const real_t tmp_blending_op_328 = tmp_blending_op_327*tmp_blending_op_78;
             const real_t tmp_blending_op_329 = tmp_blending_op_78*2.0;
             const real_t tmp_blending_op_330 = tmp_blending_op_233 + tmp_blending_op_82;
             const real_t tmp_blending_op_331 = tmp_blending_op_103*2.0 + tmp_blending_op_230*tmp_blending_op_78 + tmp_blending_op_330;
             const real_t tmp_blending_op_332 = tmp_blending_op_328*tmp_blending_op_96;
             const real_t tmp_blending_op_333 = tmp_blending_op_23*tmp_blending_op_55*tmp_blending_op_80 - tmp_blending_op_329*tmp_blending_op_51;
             const real_t tmp_blending_op_334 = tmp_blending_op_327*tmp_blending_op_85;
             const real_t tmp_blending_op_335 = -tmp_blending_op_230*tmp_blending_op_87;
             const real_t tmp_blending_op_336 = tmp_blending_op_328*tmp_blending_op_94;
             const real_t tmp_blending_op_337 = tmp_blending_op_336*tmp_blending_op_75;
             const real_t tmp_blending_op_338 = tmp_blending_op_230*tmp_blending_op_75 + tmp_blending_op_329*tmp_blending_op_42;
             const real_t tmp_blending_op_339 = tmp_blending_op_328*tmp_blending_op_99;
             const real_t tmp_blending_op_340 = tmp_blending_op_339*tmp_blending_op_80;
             const real_t tmp_blending_op_341 = -tmp_blending_op_93;
             const real_t tmp_blending_op_342 = tmp_blending_op_80*2.0;
             const real_t tmp_blending_op_343 = tmp_blending_op_327*tmp_blending_op_80;
             const real_t tmp_blending_op_344 = tmp_blending_op_92*(tmp_blending_op_342*tmp_blending_op_56 + tmp_blending_op_51*tmp_blending_op_78);
             const real_t tmp_blending_op_345 = tmp_blending_op_327*tmp_blending_op_86;
             const real_t tmp_blending_op_346 = tmp_blending_op_343*tmp_blending_op_75;
             const real_t tmp_blending_op_347 = -tmp_blending_op_346*tmp_blending_op_96;
             const real_t tmp_blending_op_348 = -tmp_blending_op_51*tmp_blending_op_80 - tmp_blending_op_83;
             const real_t tmp_blending_op_349 = tmp_blending_op_51*tmp_blending_op_75;
             const real_t tmp_blending_op_350 = tmp_blending_op_342*tmp_blending_op_42 + tmp_blending_op_349;
             const real_t tmp_blending_op_351 = -tmp_blending_op_256*tmp_blending_op_87;
             const real_t tmp_blending_op_352 = tmp_blending_op_75*2.0;
             const real_t tmp_blending_op_353 = tmp_blending_op_327*tmp_blending_op_75;
             const real_t tmp_blending_op_354 = tmp_blending_op_92*(tmp_blending_op_256*tmp_blending_op_78 + tmp_blending_op_352*tmp_blending_op_56);
             const real_t tmp_blending_op_355 = tmp_blending_op_327*tmp_blending_op_76;
             const real_t tmp_blending_op_356 = tmp_blending_op_92*(tmp_blending_op_256*tmp_blending_op_80 + tmp_blending_op_349*-2.0);
             const real_t tmp_blending_op_357 = tmp_blending_op_256*tmp_blending_op_75 + tmp_blending_op_330 + tmp_blending_op_88*2.0;
             const real_t tmp_blending_op_358 = tmp_blending_op_227*pow(tmp_blending_op_40, -2.5000000000000000);
             const real_t tmp_blending_op_359 = tmp_blending_op_28*tmp_blending_op_358;
             const real_t tmp_blending_op_360 = tmp_blending_op_28*2.0;
             const real_t tmp_blending_op_361 = tmp_blending_op_233 + tmp_blending_op_35;
             const real_t tmp_blending_op_362 = tmp_blending_op_230*tmp_blending_op_28 + tmp_blending_op_361 + tmp_blending_op_65*2.0;
             const real_t tmp_blending_op_363 = tmp_blending_op_359*tmp_blending_op_57;
             const real_t tmp_blending_op_364 = tmp_blending_op_23*tmp_blending_op_33*tmp_blending_op_55 - tmp_blending_op_360*tmp_blending_op_51;
             const real_t tmp_blending_op_365 = tmp_blending_op_358*tmp_blending_op_38;
             const real_t tmp_blending_op_366 = -tmp_blending_op_230*tmp_blending_op_40;
             const real_t tmp_blending_op_367 = tmp_blending_op_359*tmp_blending_op_53;
             const real_t tmp_blending_op_368 = tmp_blending_op_3*tmp_blending_op_367;
             const real_t tmp_blending_op_369 = tmp_blending_op_230*tmp_blending_op_3 + tmp_blending_op_360*tmp_blending_op_42;
             const real_t tmp_blending_op_370 = tmp_blending_op_359*tmp_blending_op_60;
             const real_t tmp_blending_op_371 = tmp_blending_op_33*tmp_blending_op_370;
             const real_t tmp_blending_op_372 = -tmp_blending_op_52;
             const real_t tmp_blending_op_373 = tmp_blending_op_33*2.0;
             const real_t tmp_blending_op_374 = tmp_blending_op_33*tmp_blending_op_358;
             const real_t tmp_blending_op_375 = tmp_blending_op_49*(tmp_blending_op_28*tmp_blending_op_51 + tmp_blending_op_373*tmp_blending_op_56);
             const real_t tmp_blending_op_376 = tmp_blending_op_358*tmp_blending_op_39;
             const real_t tmp_blending_op_377 = tmp_blending_op_3*tmp_blending_op_374;
             const real_t tmp_blending_op_378 = -tmp_blending_op_377*tmp_blending_op_57;
             const real_t tmp_blending_op_379 = -tmp_blending_op_33*tmp_blending_op_51 - tmp_blending_op_36;
             const real_t tmp_blending_op_380 = tmp_blending_op_3*tmp_blending_op_51;
             const real_t tmp_blending_op_381 = tmp_blending_op_373*tmp_blending_op_42 + tmp_blending_op_380;
             const real_t tmp_blending_op_382 = -tmp_blending_op_256*tmp_blending_op_40;
             const real_t tmp_blending_op_383 = tmp_blending_op_3*2.0;
             const real_t tmp_blending_op_384 = tmp_blending_op_3*tmp_blending_op_358;
             const real_t tmp_blending_op_385 = tmp_blending_op_49*(tmp_blending_op_256*tmp_blending_op_28 + tmp_blending_op_383*tmp_blending_op_56);
             const real_t tmp_blending_op_386 = tmp_blending_op_358*tmp_blending_op_4;
             const real_t tmp_blending_op_387 = tmp_blending_op_49*(tmp_blending_op_256*tmp_blending_op_33 + tmp_blending_op_380*-2.0);
             const real_t tmp_blending_op_388 = tmp_blending_op_256*tmp_blending_op_3 + tmp_blending_op_361 + tmp_blending_op_43*2.0;
             const real_t jac_blending_2_2_q_4 = tmp_blending_op_45*tmp_blending_op_49;
             const real_t jac_blending_2_1_q_4 = tmp_blending_op_3*tmp_blending_op_54;
             const real_t jac_blending_2_0_q_4 = tmp_blending_op_3*tmp_blending_op_58;
             const real_t jac_blending_1_2_q_4 = tmp_blending_op_33*tmp_blending_op_61;
             const real_t jac_blending_1_1_q_4 = tmp_blending_op_49*tmp_blending_op_64;
             const real_t tmp_blending_op_72 = jac_blending_1_1_q_4*jac_blending_2_0_q_4;
             const real_t jac_blending_1_0_q_4 = tmp_blending_op_33*tmp_blending_op_58;
             const real_t tmp_blending_op_69 = jac_blending_1_0_q_4*jac_blending_2_1_q_4;
             const real_t jac_blending_0_2_q_4 = tmp_blending_op_28*tmp_blending_op_61;
             const real_t jac_blending_0_1_q_4 = tmp_blending_op_28*tmp_blending_op_54;
             const real_t tmp_blending_op_71 = jac_blending_0_1_q_4*jac_blending_1_0_q_4;
             const real_t jac_blending_0_0_q_4 = tmp_blending_op_49*tmp_blending_op_67;
             const real_t tmp_blending_op_68 = jac_blending_0_0_q_4*jac_blending_1_1_q_4;
             const real_t tmp_blending_op_70 = jac_blending_0_0_q_4*jac_blending_2_1_q_4;
             const real_t tmp_blending_op_73 = jac_blending_0_1_q_4*jac_blending_1_2_q_4*jac_blending_2_0_q_4 + jac_blending_0_2_q_4*tmp_blending_op_69 - jac_blending_0_2_q_4*tmp_blending_op_72 - jac_blending_1_2_q_4*tmp_blending_op_70 + jac_blending_2_2_q_4*tmp_blending_op_68 - jac_blending_2_2_q_4*tmp_blending_op_71;
             const real_t tmp_blending_op_74 = 1.0 / (tmp_blending_op_73);
             const real_t abs_det_jac_blending_q_4 = tmp_blending_op_73;
             const real_t jac_blending_inv_2_2_q_4 = tmp_blending_op_74*(tmp_blending_op_68 - tmp_blending_op_71);
             const real_t jac_blending_inv_2_1_q_4 = tmp_blending_op_74*(jac_blending_0_1_q_4*jac_blending_2_0_q_4 - tmp_blending_op_70);
             const real_t jac_blending_inv_2_0_q_4 = tmp_blending_op_74*(tmp_blending_op_69 - tmp_blending_op_72);
             const real_t jac_blending_inv_1_2_q_4 = tmp_blending_op_74*(-jac_blending_0_0_q_4*jac_blending_1_2_q_4 + jac_blending_0_2_q_4*jac_blending_1_0_q_4);
             const real_t jac_blending_inv_1_1_q_4 = tmp_blending_op_74*(jac_blending_0_0_q_4*jac_blending_2_2_q_4 - jac_blending_0_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_1_0_q_4 = tmp_blending_op_74*(-jac_blending_1_0_q_4*jac_blending_2_2_q_4 + jac_blending_1_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_0_2_q_4 = tmp_blending_op_74*(jac_blending_0_1_q_4*jac_blending_1_2_q_4 - jac_blending_0_2_q_4*jac_blending_1_1_q_4);
             const real_t jac_blending_inv_0_1_q_4 = tmp_blending_op_74*(-jac_blending_0_1_q_4*jac_blending_2_2_q_4 + jac_blending_0_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_inv_0_0_q_4 = tmp_blending_op_74*(jac_blending_1_1_q_4*jac_blending_2_2_q_4 - jac_blending_1_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_2_2_q_3 = tmp_blending_op_90*tmp_blending_op_92;
             const real_t jac_blending_2_1_q_3 = tmp_blending_op_75*tmp_blending_op_95;
             const real_t jac_blending_2_0_q_3 = tmp_blending_op_75*tmp_blending_op_97;
             const real_t jac_blending_1_2_q_3 = tmp_blending_op_100*tmp_blending_op_80;
             const real_t jac_blending_1_1_q_3 = tmp_blending_op_102*tmp_blending_op_92;
             const real_t tmp_blending_op_110 = jac_blending_1_1_q_3*jac_blending_2_0_q_3;
             const real_t jac_blending_1_0_q_3 = tmp_blending_op_80*tmp_blending_op_97;
             const real_t tmp_blending_op_107 = jac_blending_1_0_q_3*jac_blending_2_1_q_3;
             const real_t jac_blending_0_2_q_3 = tmp_blending_op_100*tmp_blending_op_78;
             const real_t jac_blending_0_1_q_3 = tmp_blending_op_78*tmp_blending_op_95;
             const real_t tmp_blending_op_109 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
             const real_t jac_blending_0_0_q_3 = tmp_blending_op_105*tmp_blending_op_92;
             const real_t tmp_blending_op_106 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
             const real_t tmp_blending_op_108 = jac_blending_0_0_q_3*jac_blending_2_1_q_3;
             const real_t tmp_blending_op_111 = jac_blending_0_1_q_3*jac_blending_1_2_q_3*jac_blending_2_0_q_3 + jac_blending_0_2_q_3*tmp_blending_op_107 - jac_blending_0_2_q_3*tmp_blending_op_110 - jac_blending_1_2_q_3*tmp_blending_op_108 + jac_blending_2_2_q_3*tmp_blending_op_106 - jac_blending_2_2_q_3*tmp_blending_op_109;
             const real_t tmp_blending_op_112 = 1.0 / (tmp_blending_op_111);
             const real_t abs_det_jac_blending_q_3 = tmp_blending_op_111;
             const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_112*(tmp_blending_op_106 - tmp_blending_op_109);
             const real_t jac_blending_inv_2_1_q_3 = tmp_blending_op_112*(jac_blending_0_1_q_3*jac_blending_2_0_q_3 - tmp_blending_op_108);
             const real_t jac_blending_inv_2_0_q_3 = tmp_blending_op_112*(tmp_blending_op_107 - tmp_blending_op_110);
             const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_112*(-jac_blending_0_0_q_3*jac_blending_1_2_q_3 + jac_blending_0_2_q_3*jac_blending_1_0_q_3);
             const real_t jac_blending_inv_1_1_q_3 = tmp_blending_op_112*(jac_blending_0_0_q_3*jac_blending_2_2_q_3 - jac_blending_0_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_1_0_q_3 = tmp_blending_op_112*(-jac_blending_1_0_q_3*jac_blending_2_2_q_3 + jac_blending_1_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_112*(jac_blending_0_1_q_3*jac_blending_1_2_q_3 - jac_blending_0_2_q_3*jac_blending_1_1_q_3);
             const real_t jac_blending_inv_0_1_q_3 = tmp_blending_op_112*(-jac_blending_0_1_q_3*jac_blending_2_2_q_3 + jac_blending_0_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_inv_0_0_q_3 = tmp_blending_op_112*(jac_blending_1_1_q_3*jac_blending_2_2_q_3 - jac_blending_1_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_2_2_q_2 = tmp_blending_op_128*tmp_blending_op_130;
             const real_t jac_blending_2_1_q_2 = tmp_blending_op_113*tmp_blending_op_133;
             const real_t jac_blending_2_0_q_2 = tmp_blending_op_113*tmp_blending_op_135;
             const real_t jac_blending_1_2_q_2 = tmp_blending_op_118*tmp_blending_op_138;
             const real_t jac_blending_1_1_q_2 = tmp_blending_op_130*tmp_blending_op_140;
             const real_t tmp_blending_op_148 = jac_blending_1_1_q_2*jac_blending_2_0_q_2;
             const real_t jac_blending_1_0_q_2 = tmp_blending_op_118*tmp_blending_op_135;
             const real_t tmp_blending_op_145 = jac_blending_1_0_q_2*jac_blending_2_1_q_2;
             const real_t jac_blending_0_2_q_2 = tmp_blending_op_116*tmp_blending_op_138;
             const real_t jac_blending_0_1_q_2 = tmp_blending_op_116*tmp_blending_op_133;
             const real_t tmp_blending_op_147 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
             const real_t jac_blending_0_0_q_2 = tmp_blending_op_130*tmp_blending_op_143;
             const real_t tmp_blending_op_144 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
             const real_t tmp_blending_op_146 = jac_blending_0_0_q_2*jac_blending_2_1_q_2;
             const real_t tmp_blending_op_149 = jac_blending_0_1_q_2*jac_blending_1_2_q_2*jac_blending_2_0_q_2 + jac_blending_0_2_q_2*tmp_blending_op_145 - jac_blending_0_2_q_2*tmp_blending_op_148 - jac_blending_1_2_q_2*tmp_blending_op_146 + jac_blending_2_2_q_2*tmp_blending_op_144 - jac_blending_2_2_q_2*tmp_blending_op_147;
             const real_t tmp_blending_op_150 = 1.0 / (tmp_blending_op_149);
             const real_t abs_det_jac_blending_q_2 = tmp_blending_op_149;
             const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_150*(tmp_blending_op_144 - tmp_blending_op_147);
             const real_t jac_blending_inv_2_1_q_2 = tmp_blending_op_150*(jac_blending_0_1_q_2*jac_blending_2_0_q_2 - tmp_blending_op_146);
             const real_t jac_blending_inv_2_0_q_2 = tmp_blending_op_150*(tmp_blending_op_145 - tmp_blending_op_148);
             const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_150*(-jac_blending_0_0_q_2*jac_blending_1_2_q_2 + jac_blending_0_2_q_2*jac_blending_1_0_q_2);
             const real_t jac_blending_inv_1_1_q_2 = tmp_blending_op_150*(jac_blending_0_0_q_2*jac_blending_2_2_q_2 - jac_blending_0_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_1_0_q_2 = tmp_blending_op_150*(-jac_blending_1_0_q_2*jac_blending_2_2_q_2 + jac_blending_1_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_150*(jac_blending_0_1_q_2*jac_blending_1_2_q_2 - jac_blending_0_2_q_2*jac_blending_1_1_q_2);
             const real_t jac_blending_inv_0_1_q_2 = tmp_blending_op_150*(-jac_blending_0_1_q_2*jac_blending_2_2_q_2 + jac_blending_0_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_inv_0_0_q_2 = tmp_blending_op_150*(jac_blending_1_1_q_2*jac_blending_2_2_q_2 - jac_blending_1_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_2_2_q_1 = tmp_blending_op_166*tmp_blending_op_168;
             const real_t jac_blending_2_1_q_1 = tmp_blending_op_151*tmp_blending_op_171;
             const real_t jac_blending_2_0_q_1 = tmp_blending_op_151*tmp_blending_op_173;
             const real_t jac_blending_1_2_q_1 = tmp_blending_op_156*tmp_blending_op_176;
             const real_t jac_blending_1_1_q_1 = tmp_blending_op_168*tmp_blending_op_178;
             const real_t tmp_blending_op_186 = jac_blending_1_1_q_1*jac_blending_2_0_q_1;
             const real_t jac_blending_1_0_q_1 = tmp_blending_op_156*tmp_blending_op_173;
             const real_t tmp_blending_op_183 = jac_blending_1_0_q_1*jac_blending_2_1_q_1;
             const real_t jac_blending_0_2_q_1 = tmp_blending_op_154*tmp_blending_op_176;
             const real_t jac_blending_0_1_q_1 = tmp_blending_op_154*tmp_blending_op_171;
             const real_t tmp_blending_op_185 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
             const real_t jac_blending_0_0_q_1 = tmp_blending_op_168*tmp_blending_op_181;
             const real_t tmp_blending_op_182 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
             const real_t tmp_blending_op_184 = jac_blending_0_0_q_1*jac_blending_2_1_q_1;
             const real_t tmp_blending_op_187 = jac_blending_0_1_q_1*jac_blending_1_2_q_1*jac_blending_2_0_q_1 + jac_blending_0_2_q_1*tmp_blending_op_183 - jac_blending_0_2_q_1*tmp_blending_op_186 - jac_blending_1_2_q_1*tmp_blending_op_184 + jac_blending_2_2_q_1*tmp_blending_op_182 - jac_blending_2_2_q_1*tmp_blending_op_185;
             const real_t tmp_blending_op_188 = 1.0 / (tmp_blending_op_187);
             const real_t abs_det_jac_blending_q_1 = tmp_blending_op_187;
             const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_188*(tmp_blending_op_182 - tmp_blending_op_185);
             const real_t jac_blending_inv_2_1_q_1 = tmp_blending_op_188*(jac_blending_0_1_q_1*jac_blending_2_0_q_1 - tmp_blending_op_184);
             const real_t jac_blending_inv_2_0_q_1 = tmp_blending_op_188*(tmp_blending_op_183 - tmp_blending_op_186);
             const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_188*(-jac_blending_0_0_q_1*jac_blending_1_2_q_1 + jac_blending_0_2_q_1*jac_blending_1_0_q_1);
             const real_t jac_blending_inv_1_1_q_1 = tmp_blending_op_188*(jac_blending_0_0_q_1*jac_blending_2_2_q_1 - jac_blending_0_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_1_0_q_1 = tmp_blending_op_188*(-jac_blending_1_0_q_1*jac_blending_2_2_q_1 + jac_blending_1_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_188*(jac_blending_0_1_q_1*jac_blending_1_2_q_1 - jac_blending_0_2_q_1*jac_blending_1_1_q_1);
             const real_t jac_blending_inv_0_1_q_1 = tmp_blending_op_188*(-jac_blending_0_1_q_1*jac_blending_2_2_q_1 + jac_blending_0_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_inv_0_0_q_1 = tmp_blending_op_188*(jac_blending_1_1_q_1*jac_blending_2_2_q_1 - jac_blending_1_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_2_2_q_0 = tmp_blending_op_204*tmp_blending_op_206;
             const real_t jac_blending_2_1_q_0 = tmp_blending_op_189*tmp_blending_op_209;
             const real_t jac_blending_2_0_q_0 = tmp_blending_op_189*tmp_blending_op_211;
             const real_t jac_blending_1_2_q_0 = tmp_blending_op_194*tmp_blending_op_214;
             const real_t jac_blending_1_1_q_0 = tmp_blending_op_206*tmp_blending_op_216;
             const real_t tmp_blending_op_224 = jac_blending_1_1_q_0*jac_blending_2_0_q_0;
             const real_t jac_blending_1_0_q_0 = tmp_blending_op_194*tmp_blending_op_211;
             const real_t tmp_blending_op_221 = jac_blending_1_0_q_0*jac_blending_2_1_q_0;
             const real_t jac_blending_0_2_q_0 = tmp_blending_op_192*tmp_blending_op_214;
             const real_t jac_blending_0_1_q_0 = tmp_blending_op_192*tmp_blending_op_209;
             const real_t tmp_blending_op_223 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
             const real_t jac_blending_0_0_q_0 = tmp_blending_op_206*tmp_blending_op_219;
             const real_t tmp_blending_op_220 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
             const real_t tmp_blending_op_222 = jac_blending_0_0_q_0*jac_blending_2_1_q_0;
             const real_t tmp_blending_op_225 = jac_blending_0_1_q_0*jac_blending_1_2_q_0*jac_blending_2_0_q_0 + jac_blending_0_2_q_0*tmp_blending_op_221 - jac_blending_0_2_q_0*tmp_blending_op_224 - jac_blending_1_2_q_0*tmp_blending_op_222 + jac_blending_2_2_q_0*tmp_blending_op_220 - jac_blending_2_2_q_0*tmp_blending_op_223;
             const real_t tmp_blending_op_226 = 1.0 / (tmp_blending_op_225);
             const real_t abs_det_jac_blending_q_0 = tmp_blending_op_225;
             const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_226*(tmp_blending_op_220 - tmp_blending_op_223);
             const real_t jac_blending_inv_2_1_q_0 = tmp_blending_op_226*(jac_blending_0_1_q_0*jac_blending_2_0_q_0 - tmp_blending_op_222);
             const real_t jac_blending_inv_2_0_q_0 = tmp_blending_op_226*(tmp_blending_op_221 - tmp_blending_op_224);
             const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_226*(-jac_blending_0_0_q_0*jac_blending_1_2_q_0 + jac_blending_0_2_q_0*jac_blending_1_0_q_0);
             const real_t jac_blending_inv_1_1_q_0 = tmp_blending_op_226*(jac_blending_0_0_q_0*jac_blending_2_2_q_0 - jac_blending_0_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_1_0_q_0 = tmp_blending_op_226*(-jac_blending_1_0_q_0*jac_blending_2_2_q_0 + jac_blending_1_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_226*(jac_blending_0_1_q_0*jac_blending_1_2_q_0 - jac_blending_0_2_q_0*jac_blending_1_1_q_0);
             const real_t jac_blending_inv_0_1_q_0 = tmp_blending_op_226*(-jac_blending_0_1_q_0*jac_blending_2_2_q_0 + jac_blending_0_2_q_0*jac_blending_2_1_q_0);
             const real_t jac_blending_inv_0_0_q_0 = tmp_blending_op_226*(jac_blending_1_1_q_0*jac_blending_2_2_q_0 - jac_blending_1_2_q_0*jac_blending_2_1_q_0);
             const real_t hessian_blending_0_0_0_q_0 = tmp_blending_op_205*tmp_blending_op_47*(-tmp_blending_op_197*tmp_blending_op_232 + tmp_blending_op_199*tmp_blending_op_230 + tmp_blending_op_201*tmp_blending_op_231 + tmp_blending_op_218*tmp_blending_op_232)*1.0 - tmp_blending_op_219*tmp_blending_op_229;
             const real_t hessian_blending_0_0_1_q_0 = tmp_blending_op_194*tmp_blending_op_205*tmp_blending_op_235*tmp_blending_op_47*1.0 - tmp_blending_op_194*tmp_blending_op_236;
             const real_t hessian_blending_0_0_2_q_0 = tmp_blending_op_189*tmp_blending_op_205*tmp_blending_op_235*tmp_blending_op_47*1.0 - tmp_blending_op_189*tmp_blending_op_236;
             const real_t hessian_blending_0_1_0_q_0 = tmp_blending_op_192*tmp_blending_op_206*tmp_blending_op_237 - tmp_blending_op_208*tmp_blending_op_238 + tmp_blending_op_209;
             const real_t hessian_blending_0_1_1_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_200*tmp_blending_op_230 + tmp_blending_op_215*tmp_blending_op_232 + tmp_blending_op_239)*1.0 - tmp_blending_op_216*tmp_blending_op_229;
             const real_t hessian_blending_0_1_2_q_0 = tmp_blending_op_189*tmp_blending_op_205*tmp_blending_op_237*tmp_blending_op_47*1.0 - tmp_blending_op_241;
             const real_t hessian_blending_0_2_0_q_0 = tmp_blending_op_192*tmp_blending_op_206*tmp_blending_op_242 - tmp_blending_op_213*tmp_blending_op_238 + tmp_blending_op_214;
             const real_t hessian_blending_0_2_1_q_0 = tmp_blending_op_194*tmp_blending_op_205*tmp_blending_op_242*tmp_blending_op_47*1.0 - tmp_blending_op_244;
             const real_t hessian_blending_0_2_2_q_0 = -tmp_blending_op_204*tmp_blending_op_229 + tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_190*tmp_blending_op_230 + tmp_blending_op_203*tmp_blending_op_232 + tmp_blending_op_239)*1.0;
             const real_t hessian_blending_1_0_0_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_199*tmp_blending_op_51 + tmp_blending_op_218*tmp_blending_op_246 + tmp_blending_op_245)*1.0 - tmp_blending_op_219*tmp_blending_op_247;
             const real_t hessian_blending_1_0_1_q_0 = tmp_blending_op_194*tmp_blending_op_248 - tmp_blending_op_210*tmp_blending_op_249 + tmp_blending_op_211;
             const real_t hessian_blending_1_0_2_q_0 = tmp_blending_op_189*tmp_blending_op_248 + tmp_blending_op_251;
             const real_t hessian_blending_1_1_0_q_0 = tmp_blending_op_192*tmp_blending_op_205*tmp_blending_op_252*tmp_blending_op_47*1.0 - tmp_blending_op_194*tmp_blending_op_240;
             const real_t hessian_blending_1_1_1_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_198*tmp_blending_op_246 + tmp_blending_op_200*tmp_blending_op_51 + tmp_blending_op_201*tmp_blending_op_253 + tmp_blending_op_215*tmp_blending_op_246)*1.0 - tmp_blending_op_216*tmp_blending_op_247;
             const real_t hessian_blending_1_1_2_q_0 = tmp_blending_op_189*tmp_blending_op_205*tmp_blending_op_252*tmp_blending_op_47*1.0 - tmp_blending_op_208*tmp_blending_op_250;
             const real_t hessian_blending_1_2_0_q_0 = tmp_blending_op_192*tmp_blending_op_205*tmp_blending_op_255*tmp_blending_op_47*1.0 - tmp_blending_op_244;
             const real_t hessian_blending_1_2_1_q_0 = tmp_blending_op_194*tmp_blending_op_206*tmp_blending_op_255 - tmp_blending_op_213*tmp_blending_op_249 + tmp_blending_op_214;
             const real_t hessian_blending_1_2_2_q_0 = -tmp_blending_op_204*tmp_blending_op_247 + tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_190*tmp_blending_op_51 + tmp_blending_op_203*tmp_blending_op_246 + tmp_blending_op_245)*1.0;
             const real_t hessian_blending_2_0_0_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_199*tmp_blending_op_256 + tmp_blending_op_218*tmp_blending_op_258 + tmp_blending_op_257)*1.0 - tmp_blending_op_219*tmp_blending_op_259;
             const real_t hessian_blending_2_0_1_q_0 = tmp_blending_op_194*tmp_blending_op_260 + tmp_blending_op_251;
             const real_t hessian_blending_2_0_2_q_0 = tmp_blending_op_189*tmp_blending_op_260 - tmp_blending_op_210*tmp_blending_op_261 + tmp_blending_op_211;
             const real_t hessian_blending_2_1_0_q_0 = tmp_blending_op_192*tmp_blending_op_262 - tmp_blending_op_241;
             const real_t hessian_blending_2_1_1_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_200*tmp_blending_op_256 + tmp_blending_op_215*tmp_blending_op_258 + tmp_blending_op_257)*1.0 - tmp_blending_op_216*tmp_blending_op_259;
             const real_t hessian_blending_2_1_2_q_0 = tmp_blending_op_189*tmp_blending_op_262 - tmp_blending_op_208*tmp_blending_op_261 + tmp_blending_op_209;
             const real_t hessian_blending_2_2_0_q_0 = -tmp_blending_op_189*tmp_blending_op_243 + tmp_blending_op_192*tmp_blending_op_205*tmp_blending_op_263*tmp_blending_op_47*1.0;
             const real_t hessian_blending_2_2_1_q_0 = tmp_blending_op_194*tmp_blending_op_205*tmp_blending_op_263*tmp_blending_op_47*1.0 - tmp_blending_op_213*tmp_blending_op_250;
             const real_t hessian_blending_2_2_2_q_0 = -tmp_blending_op_204*tmp_blending_op_259 + tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_190*tmp_blending_op_256 + tmp_blending_op_201*tmp_blending_op_264 + tmp_blending_op_203*tmp_blending_op_258 + tmp_blending_op_212*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_1 = tmp_blending_op_167*tmp_blending_op_47*(-tmp_blending_op_159*tmp_blending_op_267 + tmp_blending_op_161*tmp_blending_op_230 + tmp_blending_op_163*tmp_blending_op_231 + tmp_blending_op_180*tmp_blending_op_267)*1.0 - tmp_blending_op_181*tmp_blending_op_266;
             const real_t hessian_blending_0_0_1_q_1 = tmp_blending_op_156*tmp_blending_op_167*tmp_blending_op_269*tmp_blending_op_47*1.0 - tmp_blending_op_156*tmp_blending_op_270;
             const real_t hessian_blending_0_0_2_q_1 = tmp_blending_op_151*tmp_blending_op_167*tmp_blending_op_269*tmp_blending_op_47*1.0 - tmp_blending_op_151*tmp_blending_op_270;
             const real_t hessian_blending_0_1_0_q_1 = tmp_blending_op_154*tmp_blending_op_168*tmp_blending_op_271 - tmp_blending_op_170*tmp_blending_op_272 + tmp_blending_op_171;
             const real_t hessian_blending_0_1_1_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_162*tmp_blending_op_230 + tmp_blending_op_177*tmp_blending_op_267 + tmp_blending_op_273)*1.0 - tmp_blending_op_178*tmp_blending_op_266;
             const real_t hessian_blending_0_1_2_q_1 = tmp_blending_op_151*tmp_blending_op_167*tmp_blending_op_271*tmp_blending_op_47*1.0 - tmp_blending_op_275;
             const real_t hessian_blending_0_2_0_q_1 = tmp_blending_op_154*tmp_blending_op_168*tmp_blending_op_276 - tmp_blending_op_175*tmp_blending_op_272 + tmp_blending_op_176;
             const real_t hessian_blending_0_2_1_q_1 = tmp_blending_op_156*tmp_blending_op_167*tmp_blending_op_276*tmp_blending_op_47*1.0 - tmp_blending_op_278;
             const real_t hessian_blending_0_2_2_q_1 = -tmp_blending_op_166*tmp_blending_op_266 + tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_152*tmp_blending_op_230 + tmp_blending_op_165*tmp_blending_op_267 + tmp_blending_op_273)*1.0;
             const real_t hessian_blending_1_0_0_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_161*tmp_blending_op_51 + tmp_blending_op_180*tmp_blending_op_280 + tmp_blending_op_279)*1.0 - tmp_blending_op_181*tmp_blending_op_281;
             const real_t hessian_blending_1_0_1_q_1 = tmp_blending_op_156*tmp_blending_op_282 - tmp_blending_op_172*tmp_blending_op_283 + tmp_blending_op_173;
             const real_t hessian_blending_1_0_2_q_1 = tmp_blending_op_151*tmp_blending_op_282 + tmp_blending_op_285;
             const real_t hessian_blending_1_1_0_q_1 = tmp_blending_op_154*tmp_blending_op_167*tmp_blending_op_286*tmp_blending_op_47*1.0 - tmp_blending_op_156*tmp_blending_op_274;
             const real_t hessian_blending_1_1_1_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_160*tmp_blending_op_280 + tmp_blending_op_162*tmp_blending_op_51 + tmp_blending_op_163*tmp_blending_op_253 + tmp_blending_op_177*tmp_blending_op_280)*1.0 - tmp_blending_op_178*tmp_blending_op_281;
             const real_t hessian_blending_1_1_2_q_1 = tmp_blending_op_151*tmp_blending_op_167*tmp_blending_op_286*tmp_blending_op_47*1.0 - tmp_blending_op_170*tmp_blending_op_284;
             const real_t hessian_blending_1_2_0_q_1 = tmp_blending_op_154*tmp_blending_op_167*tmp_blending_op_288*tmp_blending_op_47*1.0 - tmp_blending_op_278;
             const real_t hessian_blending_1_2_1_q_1 = tmp_blending_op_156*tmp_blending_op_168*tmp_blending_op_288 - tmp_blending_op_175*tmp_blending_op_283 + tmp_blending_op_176;
             const real_t hessian_blending_1_2_2_q_1 = -tmp_blending_op_166*tmp_blending_op_281 + tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_152*tmp_blending_op_51 + tmp_blending_op_165*tmp_blending_op_280 + tmp_blending_op_279)*1.0;
             const real_t hessian_blending_2_0_0_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_161*tmp_blending_op_256 + tmp_blending_op_180*tmp_blending_op_290 + tmp_blending_op_289)*1.0 - tmp_blending_op_181*tmp_blending_op_291;
             const real_t hessian_blending_2_0_1_q_1 = tmp_blending_op_156*tmp_blending_op_292 + tmp_blending_op_285;
             const real_t hessian_blending_2_0_2_q_1 = tmp_blending_op_151*tmp_blending_op_292 - tmp_blending_op_172*tmp_blending_op_293 + tmp_blending_op_173;
             const real_t hessian_blending_2_1_0_q_1 = tmp_blending_op_154*tmp_blending_op_294 - tmp_blending_op_275;
             const real_t hessian_blending_2_1_1_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_162*tmp_blending_op_256 + tmp_blending_op_177*tmp_blending_op_290 + tmp_blending_op_289)*1.0 - tmp_blending_op_178*tmp_blending_op_291;
             const real_t hessian_blending_2_1_2_q_1 = tmp_blending_op_151*tmp_blending_op_294 - tmp_blending_op_170*tmp_blending_op_293 + tmp_blending_op_171;
             const real_t hessian_blending_2_2_0_q_1 = -tmp_blending_op_151*tmp_blending_op_277 + tmp_blending_op_154*tmp_blending_op_167*tmp_blending_op_295*tmp_blending_op_47*1.0;
             const real_t hessian_blending_2_2_1_q_1 = tmp_blending_op_156*tmp_blending_op_167*tmp_blending_op_295*tmp_blending_op_47*1.0 - tmp_blending_op_175*tmp_blending_op_284;
             const real_t hessian_blending_2_2_2_q_1 = -tmp_blending_op_166*tmp_blending_op_291 + tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_152*tmp_blending_op_256 + tmp_blending_op_163*tmp_blending_op_264 + tmp_blending_op_165*tmp_blending_op_290 + tmp_blending_op_174*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_2 = tmp_blending_op_129*tmp_blending_op_47*(-tmp_blending_op_121*tmp_blending_op_298 + tmp_blending_op_123*tmp_blending_op_230 + tmp_blending_op_125*tmp_blending_op_231 + tmp_blending_op_142*tmp_blending_op_298)*1.0 - tmp_blending_op_143*tmp_blending_op_297;
             const real_t hessian_blending_0_0_1_q_2 = tmp_blending_op_118*tmp_blending_op_129*tmp_blending_op_300*tmp_blending_op_47*1.0 - tmp_blending_op_118*tmp_blending_op_301;
             const real_t hessian_blending_0_0_2_q_2 = tmp_blending_op_113*tmp_blending_op_129*tmp_blending_op_300*tmp_blending_op_47*1.0 - tmp_blending_op_113*tmp_blending_op_301;
             const real_t hessian_blending_0_1_0_q_2 = tmp_blending_op_116*tmp_blending_op_130*tmp_blending_op_302 - tmp_blending_op_132*tmp_blending_op_303 + tmp_blending_op_133;
             const real_t hessian_blending_0_1_1_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_124*tmp_blending_op_230 + tmp_blending_op_139*tmp_blending_op_298 + tmp_blending_op_304)*1.0 - tmp_blending_op_140*tmp_blending_op_297;
             const real_t hessian_blending_0_1_2_q_2 = tmp_blending_op_113*tmp_blending_op_129*tmp_blending_op_302*tmp_blending_op_47*1.0 - tmp_blending_op_306;
             const real_t hessian_blending_0_2_0_q_2 = tmp_blending_op_116*tmp_blending_op_130*tmp_blending_op_307 - tmp_blending_op_137*tmp_blending_op_303 + tmp_blending_op_138;
             const real_t hessian_blending_0_2_1_q_2 = tmp_blending_op_118*tmp_blending_op_129*tmp_blending_op_307*tmp_blending_op_47*1.0 - tmp_blending_op_309;
             const real_t hessian_blending_0_2_2_q_2 = -tmp_blending_op_128*tmp_blending_op_297 + tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_114*tmp_blending_op_230 + tmp_blending_op_127*tmp_blending_op_298 + tmp_blending_op_304)*1.0;
             const real_t hessian_blending_1_0_0_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_123*tmp_blending_op_51 + tmp_blending_op_142*tmp_blending_op_311 + tmp_blending_op_310)*1.0 - tmp_blending_op_143*tmp_blending_op_312;
             const real_t hessian_blending_1_0_1_q_2 = tmp_blending_op_118*tmp_blending_op_313 - tmp_blending_op_134*tmp_blending_op_314 + tmp_blending_op_135;
             const real_t hessian_blending_1_0_2_q_2 = tmp_blending_op_113*tmp_blending_op_313 + tmp_blending_op_316;
             const real_t hessian_blending_1_1_0_q_2 = tmp_blending_op_116*tmp_blending_op_129*tmp_blending_op_317*tmp_blending_op_47*1.0 - tmp_blending_op_118*tmp_blending_op_305;
             const real_t hessian_blending_1_1_1_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_122*tmp_blending_op_311 + tmp_blending_op_124*tmp_blending_op_51 + tmp_blending_op_125*tmp_blending_op_253 + tmp_blending_op_139*tmp_blending_op_311)*1.0 - tmp_blending_op_140*tmp_blending_op_312;
             const real_t hessian_blending_1_1_2_q_2 = tmp_blending_op_113*tmp_blending_op_129*tmp_blending_op_317*tmp_blending_op_47*1.0 - tmp_blending_op_132*tmp_blending_op_315;
             const real_t hessian_blending_1_2_0_q_2 = tmp_blending_op_116*tmp_blending_op_129*tmp_blending_op_319*tmp_blending_op_47*1.0 - tmp_blending_op_309;
             const real_t hessian_blending_1_2_1_q_2 = tmp_blending_op_118*tmp_blending_op_130*tmp_blending_op_319 - tmp_blending_op_137*tmp_blending_op_314 + tmp_blending_op_138;
             const real_t hessian_blending_1_2_2_q_2 = -tmp_blending_op_128*tmp_blending_op_312 + tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_114*tmp_blending_op_51 + tmp_blending_op_127*tmp_blending_op_311 + tmp_blending_op_310)*1.0;
             const real_t hessian_blending_2_0_0_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_123*tmp_blending_op_256 + tmp_blending_op_142*tmp_blending_op_321 + tmp_blending_op_320)*1.0 - tmp_blending_op_143*tmp_blending_op_322;
             const real_t hessian_blending_2_0_1_q_2 = tmp_blending_op_118*tmp_blending_op_323 + tmp_blending_op_316;
             const real_t hessian_blending_2_0_2_q_2 = tmp_blending_op_113*tmp_blending_op_323 - tmp_blending_op_134*tmp_blending_op_324 + tmp_blending_op_135;
             const real_t hessian_blending_2_1_0_q_2 = tmp_blending_op_116*tmp_blending_op_325 - tmp_blending_op_306;
             const real_t hessian_blending_2_1_1_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_124*tmp_blending_op_256 + tmp_blending_op_139*tmp_blending_op_321 + tmp_blending_op_320)*1.0 - tmp_blending_op_140*tmp_blending_op_322;
             const real_t hessian_blending_2_1_2_q_2 = tmp_blending_op_113*tmp_blending_op_325 - tmp_blending_op_132*tmp_blending_op_324 + tmp_blending_op_133;
             const real_t hessian_blending_2_2_0_q_2 = -tmp_blending_op_113*tmp_blending_op_308 + tmp_blending_op_116*tmp_blending_op_129*tmp_blending_op_326*tmp_blending_op_47*1.0;
             const real_t hessian_blending_2_2_1_q_2 = tmp_blending_op_118*tmp_blending_op_129*tmp_blending_op_326*tmp_blending_op_47*1.0 - tmp_blending_op_137*tmp_blending_op_315;
             const real_t hessian_blending_2_2_2_q_2 = -tmp_blending_op_128*tmp_blending_op_322 + tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_114*tmp_blending_op_256 + tmp_blending_op_125*tmp_blending_op_264 + tmp_blending_op_127*tmp_blending_op_321 + tmp_blending_op_136*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_3 = -tmp_blending_op_105*tmp_blending_op_328 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_104*tmp_blending_op_329 + tmp_blending_op_230*tmp_blending_op_85 + tmp_blending_op_231*tmp_blending_op_87 - tmp_blending_op_329*tmp_blending_op_83)*1.0;
             const real_t hessian_blending_0_0_1_q_3 = tmp_blending_op_331*tmp_blending_op_47*tmp_blending_op_80*tmp_blending_op_91*1.0 - tmp_blending_op_332*tmp_blending_op_80;
             const real_t hessian_blending_0_0_2_q_3 = tmp_blending_op_331*tmp_blending_op_47*tmp_blending_op_75*tmp_blending_op_91*1.0 - tmp_blending_op_332*tmp_blending_op_75;
             const real_t hessian_blending_0_1_0_q_3 = tmp_blending_op_333*tmp_blending_op_78*tmp_blending_op_92 - tmp_blending_op_334*tmp_blending_op_94 + tmp_blending_op_95;
             const real_t hessian_blending_0_1_1_q_3 = -tmp_blending_op_102*tmp_blending_op_328 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_101*tmp_blending_op_329 + tmp_blending_op_230*tmp_blending_op_86 + tmp_blending_op_335)*1.0;
             const real_t hessian_blending_0_1_2_q_3 = tmp_blending_op_333*tmp_blending_op_47*tmp_blending_op_75*tmp_blending_op_91*1.0 - tmp_blending_op_337;
             const real_t hessian_blending_0_2_0_q_3 = tmp_blending_op_100 - tmp_blending_op_334*tmp_blending_op_99 + tmp_blending_op_338*tmp_blending_op_78*tmp_blending_op_92;
             const real_t hessian_blending_0_2_1_q_3 = tmp_blending_op_338*tmp_blending_op_47*tmp_blending_op_80*tmp_blending_op_91*1.0 - tmp_blending_op_340;
             const real_t hessian_blending_0_2_2_q_3 = -tmp_blending_op_328*tmp_blending_op_90 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_230*tmp_blending_op_76 + tmp_blending_op_329*tmp_blending_op_89 + tmp_blending_op_335)*1.0;
             const real_t hessian_blending_1_0_0_q_3 = -tmp_blending_op_105*tmp_blending_op_343 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_104*tmp_blending_op_342 + tmp_blending_op_341 + tmp_blending_op_51*tmp_blending_op_85)*1.0;
             const real_t hessian_blending_1_0_1_q_3 = tmp_blending_op_344*tmp_blending_op_80 - tmp_blending_op_345*tmp_blending_op_96 + tmp_blending_op_97;
             const real_t hessian_blending_1_0_2_q_3 = tmp_blending_op_344*tmp_blending_op_75 + tmp_blending_op_347;
             const real_t hessian_blending_1_1_0_q_3 = -tmp_blending_op_336*tmp_blending_op_80 + tmp_blending_op_348*tmp_blending_op_47*tmp_blending_op_78*tmp_blending_op_91*1.0;
             const real_t hessian_blending_1_1_1_q_3 = -tmp_blending_op_102*tmp_blending_op_343 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_101*tmp_blending_op_342 + tmp_blending_op_253*tmp_blending_op_87 + tmp_blending_op_342*tmp_blending_op_84 + tmp_blending_op_51*tmp_blending_op_86)*1.0;
             const real_t hessian_blending_1_1_2_q_3 = -tmp_blending_op_346*tmp_blending_op_94 + tmp_blending_op_348*tmp_blending_op_47*tmp_blending_op_75*tmp_blending_op_91*1.0;
             const real_t hessian_blending_1_2_0_q_3 = -tmp_blending_op_340 + tmp_blending_op_350*tmp_blending_op_47*tmp_blending_op_78*tmp_blending_op_91*1.0;
             const real_t hessian_blending_1_2_1_q_3 = tmp_blending_op_100 - tmp_blending_op_345*tmp_blending_op_99 + tmp_blending_op_350*tmp_blending_op_80*tmp_blending_op_92;
             const real_t hessian_blending_1_2_2_q_3 = -tmp_blending_op_343*tmp_blending_op_90 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_341 + tmp_blending_op_342*tmp_blending_op_89 + tmp_blending_op_51*tmp_blending_op_76)*1.0;
             const real_t hessian_blending_2_0_0_q_3 = -tmp_blending_op_105*tmp_blending_op_353 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_104*tmp_blending_op_352 + tmp_blending_op_256*tmp_blending_op_85 + tmp_blending_op_351)*1.0;
             const real_t hessian_blending_2_0_1_q_3 = tmp_blending_op_347 + tmp_blending_op_354*tmp_blending_op_80;
             const real_t hessian_blending_2_0_2_q_3 = tmp_blending_op_354*tmp_blending_op_75 - tmp_blending_op_355*tmp_blending_op_96 + tmp_blending_op_97;
             const real_t hessian_blending_2_1_0_q_3 = -tmp_blending_op_337 + tmp_blending_op_356*tmp_blending_op_78;
             const real_t hessian_blending_2_1_1_q_3 = -tmp_blending_op_102*tmp_blending_op_353 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_101*tmp_blending_op_352 + tmp_blending_op_256*tmp_blending_op_86 + tmp_blending_op_351)*1.0;
             const real_t hessian_blending_2_1_2_q_3 = -tmp_blending_op_355*tmp_blending_op_94 + tmp_blending_op_356*tmp_blending_op_75 + tmp_blending_op_95;
             const real_t hessian_blending_2_2_0_q_3 = -tmp_blending_op_339*tmp_blending_op_75 + tmp_blending_op_357*tmp_blending_op_47*tmp_blending_op_78*tmp_blending_op_91*1.0;
             const real_t hessian_blending_2_2_1_q_3 = -tmp_blending_op_346*tmp_blending_op_99 + tmp_blending_op_357*tmp_blending_op_47*tmp_blending_op_80*tmp_blending_op_91*1.0;
             const real_t hessian_blending_2_2_2_q_3 = -tmp_blending_op_353*tmp_blending_op_90 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_256*tmp_blending_op_76 + tmp_blending_op_264*tmp_blending_op_87 + tmp_blending_op_352*tmp_blending_op_89 + tmp_blending_op_98*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_4 = -tmp_blending_op_359*tmp_blending_op_67 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_230*tmp_blending_op_38 + tmp_blending_op_231*tmp_blending_op_40 - tmp_blending_op_36*tmp_blending_op_360 + tmp_blending_op_360*tmp_blending_op_66)*1.0;
             const real_t hessian_blending_0_0_1_q_4 = tmp_blending_op_33*tmp_blending_op_362*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_33*tmp_blending_op_363;
             const real_t hessian_blending_0_0_2_q_4 = tmp_blending_op_3*tmp_blending_op_362*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_3*tmp_blending_op_363;
             const real_t hessian_blending_0_1_0_q_4 = tmp_blending_op_28*tmp_blending_op_364*tmp_blending_op_49 - tmp_blending_op_365*tmp_blending_op_53 + tmp_blending_op_54;
             const real_t hessian_blending_0_1_1_q_4 = -tmp_blending_op_359*tmp_blending_op_64 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_230*tmp_blending_op_39 + tmp_blending_op_360*tmp_blending_op_63 + tmp_blending_op_366)*1.0;
             const real_t hessian_blending_0_1_2_q_4 = tmp_blending_op_3*tmp_blending_op_364*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_368;
             const real_t hessian_blending_0_2_0_q_4 = tmp_blending_op_28*tmp_blending_op_369*tmp_blending_op_49 - tmp_blending_op_365*tmp_blending_op_60 + tmp_blending_op_61;
             const real_t hessian_blending_0_2_1_q_4 = tmp_blending_op_33*tmp_blending_op_369*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_371;
             const real_t hessian_blending_0_2_2_q_4 = -tmp_blending_op_359*tmp_blending_op_45 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_230*tmp_blending_op_4 + tmp_blending_op_360*tmp_blending_op_44 + tmp_blending_op_366)*1.0;
             const real_t hessian_blending_1_0_0_q_4 = -tmp_blending_op_374*tmp_blending_op_67 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_372 + tmp_blending_op_373*tmp_blending_op_66 + tmp_blending_op_38*tmp_blending_op_51)*1.0;
             const real_t hessian_blending_1_0_1_q_4 = tmp_blending_op_33*tmp_blending_op_375 - tmp_blending_op_376*tmp_blending_op_57 + tmp_blending_op_58;
             const real_t hessian_blending_1_0_2_q_4 = tmp_blending_op_3*tmp_blending_op_375 + tmp_blending_op_378;
             const real_t hessian_blending_1_1_0_q_4 = tmp_blending_op_28*tmp_blending_op_379*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_33*tmp_blending_op_367;
             const real_t hessian_blending_1_1_1_q_4 = -tmp_blending_op_374*tmp_blending_op_64 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_253*tmp_blending_op_40 + tmp_blending_op_37*tmp_blending_op_373 + tmp_blending_op_373*tmp_blending_op_63 + tmp_blending_op_39*tmp_blending_op_51)*1.0;
             const real_t hessian_blending_1_1_2_q_4 = tmp_blending_op_3*tmp_blending_op_379*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_377*tmp_blending_op_53;
             const real_t hessian_blending_1_2_0_q_4 = tmp_blending_op_28*tmp_blending_op_381*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_371;
             const real_t hessian_blending_1_2_1_q_4 = tmp_blending_op_33*tmp_blending_op_381*tmp_blending_op_49 - tmp_blending_op_376*tmp_blending_op_60 + tmp_blending_op_61;
             const real_t hessian_blending_1_2_2_q_4 = -tmp_blending_op_374*tmp_blending_op_45 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_372 + tmp_blending_op_373*tmp_blending_op_44 + tmp_blending_op_4*tmp_blending_op_51)*1.0;
             const real_t hessian_blending_2_0_0_q_4 = -tmp_blending_op_384*tmp_blending_op_67 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_256*tmp_blending_op_38 + tmp_blending_op_382 + tmp_blending_op_383*tmp_blending_op_66)*1.0;
             const real_t hessian_blending_2_0_1_q_4 = tmp_blending_op_33*tmp_blending_op_385 + tmp_blending_op_378;
             const real_t hessian_blending_2_0_2_q_4 = tmp_blending_op_3*tmp_blending_op_385 - tmp_blending_op_386*tmp_blending_op_57 + tmp_blending_op_58;
             const real_t hessian_blending_2_1_0_q_4 = tmp_blending_op_28*tmp_blending_op_387 - tmp_blending_op_368;
             const real_t hessian_blending_2_1_1_q_4 = -tmp_blending_op_384*tmp_blending_op_64 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_256*tmp_blending_op_39 + tmp_blending_op_382 + tmp_blending_op_383*tmp_blending_op_63)*1.0;
             const real_t hessian_blending_2_1_2_q_4 = tmp_blending_op_3*tmp_blending_op_387 - tmp_blending_op_386*tmp_blending_op_53 + tmp_blending_op_54;
             const real_t hessian_blending_2_2_0_q_4 = tmp_blending_op_28*tmp_blending_op_388*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_3*tmp_blending_op_370;
             const real_t hessian_blending_2_2_1_q_4 = tmp_blending_op_33*tmp_blending_op_388*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_377*tmp_blending_op_60;
             const real_t hessian_blending_2_2_2_q_4 = -tmp_blending_op_384*tmp_blending_op_45 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_256*tmp_blending_op_4 + tmp_blending_op_264*tmp_blending_op_40 + tmp_blending_op_383*tmp_blending_op_44 + tmp_blending_op_59*2.0)*1.0;
             const real_t diffusivity_times_delta_dof_0 = _data_diffusivity_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t diffusivity_times_delta_dof_1 = _data_diffusivity_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t diffusivity_times_delta_dof_2 = _data_diffusivity_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t diffusivity_times_delta_dof_3 = _data_diffusivity_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t diffusivity_times_delta_dof_4 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t diffusivity_times_delta_dof_5 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t diffusivity_times_delta_dof_6 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t diffusivity_times_delta_dof_7 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t diffusivity_times_delta_dof_8 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t diffusivity_times_delta_dof_9 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wx_dof_0 = _data_wxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wx_dof_1 = _data_wxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wx_dof_2 = _data_wxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wx_dof_3 = _data_wxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wx_dof_4 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wx_dof_5 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wx_dof_6 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wx_dof_7 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wx_dof_8 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wx_dof_9 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wy_dof_0 = _data_wyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wy_dof_1 = _data_wyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wy_dof_2 = _data_wyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wy_dof_3 = _data_wyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wy_dof_4 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wy_dof_5 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wy_dof_6 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wy_dof_7 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wy_dof_8 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wy_dof_9 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wz_dof_0 = _data_wzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wz_dof_1 = _data_wzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wz_dof_2 = _data_wzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wz_dof_3 = _data_wzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wz_dof_4 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wz_dof_5 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wz_dof_6 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wz_dof_7 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wz_dof_8 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wz_dof_9 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t tmp_kernel_op_30 = -hessian_blending_0_0_0_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_0_1_0_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_0_2_0_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_31 = -hessian_blending_0_0_1_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_0_1_1_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_0_2_1_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_32 = -hessian_blending_0_0_2_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_0_1_2_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_0_2_2_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_33 = jac_blending_inv_0_0_q_0*tmp_kernel_op_30 + jac_blending_inv_0_1_q_0*tmp_kernel_op_31 + jac_blending_inv_0_2_q_0*tmp_kernel_op_32;
             const real_t tmp_kernel_op_35 = jac_blending_inv_1_0_q_0*tmp_kernel_op_30 + jac_blending_inv_1_1_q_0*tmp_kernel_op_31 + jac_blending_inv_1_2_q_0*tmp_kernel_op_32;
             const real_t tmp_kernel_op_37 = jac_blending_inv_2_0_q_0*tmp_kernel_op_30 + jac_blending_inv_2_1_q_0*tmp_kernel_op_31 + jac_blending_inv_2_2_q_0*tmp_kernel_op_32;
             const real_t tmp_kernel_op_38 = -hessian_blending_1_0_0_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_1_1_0_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_1_2_0_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_39 = -hessian_blending_1_0_1_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_1_1_1_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_1_2_1_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_40 = -hessian_blending_1_0_2_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_1_1_2_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_1_2_2_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_41 = jac_blending_inv_0_0_q_0*tmp_kernel_op_38 + jac_blending_inv_0_1_q_0*tmp_kernel_op_39 + jac_blending_inv_0_2_q_0*tmp_kernel_op_40;
             const real_t tmp_kernel_op_42 = jac_blending_inv_1_0_q_0*tmp_kernel_op_38 + jac_blending_inv_1_1_q_0*tmp_kernel_op_39 + jac_blending_inv_1_2_q_0*tmp_kernel_op_40;
             const real_t tmp_kernel_op_43 = jac_blending_inv_2_0_q_0*tmp_kernel_op_38 + jac_blending_inv_2_1_q_0*tmp_kernel_op_39 + jac_blending_inv_2_2_q_0*tmp_kernel_op_40;
             const real_t tmp_kernel_op_44 = -hessian_blending_2_0_0_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_2_1_0_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_2_2_0_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_45 = -hessian_blending_2_0_1_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_2_1_1_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_2_2_1_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_46 = -hessian_blending_2_0_2_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_2_1_2_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_2_2_2_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_47 = jac_blending_inv_0_0_q_0*tmp_kernel_op_44 + jac_blending_inv_0_1_q_0*tmp_kernel_op_45 + jac_blending_inv_0_2_q_0*tmp_kernel_op_46;
             const real_t tmp_kernel_op_48 = jac_blending_inv_1_0_q_0*tmp_kernel_op_44 + jac_blending_inv_1_1_q_0*tmp_kernel_op_45 + jac_blending_inv_1_2_q_0*tmp_kernel_op_46;
             const real_t tmp_kernel_op_49 = jac_blending_inv_2_0_q_0*tmp_kernel_op_44 + jac_blending_inv_2_1_q_0*tmp_kernel_op_45 + jac_blending_inv_2_2_q_0*tmp_kernel_op_46;
             const real_t tmp_kernel_op_50 = -hessian_blending_0_0_0_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_0_1_0_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_0_2_0_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_51 = -hessian_blending_0_0_1_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_0_1_1_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_0_2_1_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_52 = -hessian_blending_0_0_2_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_0_1_2_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_0_2_2_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_53 = jac_blending_inv_0_0_q_0*tmp_kernel_op_50 + jac_blending_inv_0_1_q_0*tmp_kernel_op_51 + jac_blending_inv_0_2_q_0*tmp_kernel_op_52;
             const real_t tmp_kernel_op_54 = jac_blending_inv_1_0_q_0*tmp_kernel_op_50 + jac_blending_inv_1_1_q_0*tmp_kernel_op_51 + jac_blending_inv_1_2_q_0*tmp_kernel_op_52;
             const real_t tmp_kernel_op_55 = jac_blending_inv_2_0_q_0*tmp_kernel_op_50 + jac_blending_inv_2_1_q_0*tmp_kernel_op_51 + jac_blending_inv_2_2_q_0*tmp_kernel_op_52;
             const real_t tmp_kernel_op_56 = -hessian_blending_1_0_0_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_1_1_0_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_1_2_0_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_57 = -hessian_blending_1_0_1_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_1_1_1_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_1_2_1_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_58 = -hessian_blending_1_0_2_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_1_1_2_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_1_2_2_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_59 = jac_blending_inv_0_0_q_0*tmp_kernel_op_56 + jac_blending_inv_0_1_q_0*tmp_kernel_op_57 + jac_blending_inv_0_2_q_0*tmp_kernel_op_58;
             const real_t tmp_kernel_op_60 = jac_blending_inv_1_0_q_0*tmp_kernel_op_56 + jac_blending_inv_1_1_q_0*tmp_kernel_op_57 + jac_blending_inv_1_2_q_0*tmp_kernel_op_58;
             const real_t tmp_kernel_op_61 = jac_blending_inv_2_0_q_0*tmp_kernel_op_56 + jac_blending_inv_2_1_q_0*tmp_kernel_op_57 + jac_blending_inv_2_2_q_0*tmp_kernel_op_58;
             const real_t tmp_kernel_op_62 = -hessian_blending_2_0_0_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_2_1_0_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_2_2_0_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_63 = -hessian_blending_2_0_1_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_2_1_1_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_2_2_1_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_64 = -hessian_blending_2_0_2_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_2_1_2_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_2_2_2_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_65 = jac_blending_inv_0_0_q_0*tmp_kernel_op_62 + jac_blending_inv_0_1_q_0*tmp_kernel_op_63 + jac_blending_inv_0_2_q_0*tmp_kernel_op_64;
             const real_t tmp_kernel_op_66 = jac_blending_inv_1_0_q_0*tmp_kernel_op_62 + jac_blending_inv_1_1_q_0*tmp_kernel_op_63 + jac_blending_inv_1_2_q_0*tmp_kernel_op_64;
             const real_t tmp_kernel_op_67 = jac_blending_inv_2_0_q_0*tmp_kernel_op_62 + jac_blending_inv_2_1_q_0*tmp_kernel_op_63 + jac_blending_inv_2_2_q_0*tmp_kernel_op_64;
             const real_t tmp_kernel_op_68 = -hessian_blending_0_0_0_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_0_1_0_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_0_2_0_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_69 = -hessian_blending_0_0_1_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_0_1_1_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_0_2_1_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_70 = -hessian_blending_0_0_2_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_0_1_2_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_0_2_2_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_71 = jac_blending_inv_0_0_q_0*tmp_kernel_op_68 + jac_blending_inv_0_1_q_0*tmp_kernel_op_69 + jac_blending_inv_0_2_q_0*tmp_kernel_op_70;
             const real_t tmp_kernel_op_72 = jac_blending_inv_1_0_q_0*tmp_kernel_op_68 + jac_blending_inv_1_1_q_0*tmp_kernel_op_69 + jac_blending_inv_1_2_q_0*tmp_kernel_op_70;
             const real_t tmp_kernel_op_73 = jac_blending_inv_2_0_q_0*tmp_kernel_op_68 + jac_blending_inv_2_1_q_0*tmp_kernel_op_69 + jac_blending_inv_2_2_q_0*tmp_kernel_op_70;
             const real_t tmp_kernel_op_74 = -hessian_blending_1_0_0_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_1_1_0_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_1_2_0_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_75 = -hessian_blending_1_0_1_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_1_1_1_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_1_2_1_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_76 = -hessian_blending_1_0_2_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_1_1_2_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_1_2_2_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_77 = jac_blending_inv_0_0_q_0*tmp_kernel_op_74 + jac_blending_inv_0_1_q_0*tmp_kernel_op_75 + jac_blending_inv_0_2_q_0*tmp_kernel_op_76;
             const real_t tmp_kernel_op_78 = jac_blending_inv_1_0_q_0*tmp_kernel_op_74 + jac_blending_inv_1_1_q_0*tmp_kernel_op_75 + jac_blending_inv_1_2_q_0*tmp_kernel_op_76;
             const real_t tmp_kernel_op_79 = jac_blending_inv_2_0_q_0*tmp_kernel_op_74 + jac_blending_inv_2_1_q_0*tmp_kernel_op_75 + jac_blending_inv_2_2_q_0*tmp_kernel_op_76;
             const real_t tmp_kernel_op_80 = -hessian_blending_2_0_0_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_2_1_0_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_2_2_0_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_81 = -hessian_blending_2_0_1_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_2_1_1_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_2_2_1_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_82 = -hessian_blending_2_0_2_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_2_1_2_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_2_2_2_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_83 = jac_blending_inv_0_0_q_0*tmp_kernel_op_80 + jac_blending_inv_0_1_q_0*tmp_kernel_op_81 + jac_blending_inv_0_2_q_0*tmp_kernel_op_82;
             const real_t tmp_kernel_op_84 = jac_blending_inv_1_0_q_0*tmp_kernel_op_80 + jac_blending_inv_1_1_q_0*tmp_kernel_op_81 + jac_blending_inv_1_2_q_0*tmp_kernel_op_82;
             const real_t tmp_kernel_op_85 = jac_blending_inv_2_0_q_0*tmp_kernel_op_80 + jac_blending_inv_2_1_q_0*tmp_kernel_op_81 + jac_blending_inv_2_2_q_0*tmp_kernel_op_82;
             const real_t tmp_kernel_op_86 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_5 + jac_blending_inv_1_0_q_0*tmp_kernel_op_11 + jac_blending_inv_2_0_q_0*tmp_kernel_op_17) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_29*tmp_kernel_op_33 + tmp_kernel_op_34*tmp_kernel_op_35 + tmp_kernel_op_36*tmp_kernel_op_37) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_5 + jac_blending_inv_1_1_q_0*tmp_kernel_op_11 + jac_blending_inv_2_1_q_0*tmp_kernel_op_17) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_29*tmp_kernel_op_41 + tmp_kernel_op_34*tmp_kernel_op_42 + tmp_kernel_op_36*tmp_kernel_op_43) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_5 + jac_blending_inv_1_2_q_0*tmp_kernel_op_11 + jac_blending_inv_2_2_q_0*tmp_kernel_op_17) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_29*tmp_kernel_op_47 + tmp_kernel_op_34*tmp_kernel_op_48 + tmp_kernel_op_36*tmp_kernel_op_49) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_18 + jac_blending_inv_1_0_q_0*tmp_kernel_op_19 + jac_blending_inv_2_0_q_0*tmp_kernel_op_20) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_29*tmp_kernel_op_53 + tmp_kernel_op_34*tmp_kernel_op_54 + tmp_kernel_op_36*tmp_kernel_op_55) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_18 + jac_blending_inv_1_1_q_0*tmp_kernel_op_19 + jac_blending_inv_2_1_q_0*tmp_kernel_op_20) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_29*tmp_kernel_op_59 + tmp_kernel_op_34*tmp_kernel_op_60 + tmp_kernel_op_36*tmp_kernel_op_61) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_18 + jac_blending_inv_1_2_q_0*tmp_kernel_op_19 + jac_blending_inv_2_2_q_0*tmp_kernel_op_20) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_29*tmp_kernel_op_65 + tmp_kernel_op_34*tmp_kernel_op_66 + tmp_kernel_op_36*tmp_kernel_op_67) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_21 + jac_blending_inv_1_0_q_0*tmp_kernel_op_22 + jac_blending_inv_2_0_q_0*tmp_kernel_op_23) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_29*tmp_kernel_op_71 + tmp_kernel_op_34*tmp_kernel_op_72 + tmp_kernel_op_36*tmp_kernel_op_73) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_21 + jac_blending_inv_1_1_q_0*tmp_kernel_op_22 + jac_blending_inv_2_1_q_0*tmp_kernel_op_23) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_29*tmp_kernel_op_77 + tmp_kernel_op_34*tmp_kernel_op_78 + tmp_kernel_op_36*tmp_kernel_op_79) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_21 + jac_blending_inv_1_2_q_0*tmp_kernel_op_22 + jac_blending_inv_2_2_q_0*tmp_kernel_op_23) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_29*tmp_kernel_op_83 + tmp_kernel_op_34*tmp_kernel_op_84 + tmp_kernel_op_36*tmp_kernel_op_85);
             const real_t tmp_kernel_op_104 = tmp_kernel_op_100*wx_dof_8 + tmp_kernel_op_102*wx_dof_9 + tmp_kernel_op_103*wx_dof_0 + tmp_kernel_op_87*wx_dof_4 + tmp_kernel_op_88*wx_dof_5 + tmp_kernel_op_89*wx_dof_6 + tmp_kernel_op_92*wx_dof_1 + tmp_kernel_op_95*wx_dof_2 + tmp_kernel_op_98*wx_dof_3 + tmp_kernel_op_99*wx_dof_7;
             const real_t tmp_kernel_op_105 = tmp_kernel_op_100*wy_dof_8 + tmp_kernel_op_102*wy_dof_9 + tmp_kernel_op_103*wy_dof_0 + tmp_kernel_op_87*wy_dof_4 + tmp_kernel_op_88*wy_dof_5 + tmp_kernel_op_89*wy_dof_6 + tmp_kernel_op_92*wy_dof_1 + tmp_kernel_op_95*wy_dof_2 + tmp_kernel_op_98*wy_dof_3 + tmp_kernel_op_99*wy_dof_7;
             const real_t tmp_kernel_op_106 = tmp_kernel_op_100*wz_dof_8 + tmp_kernel_op_102*wz_dof_9 + tmp_kernel_op_103*wz_dof_0 + tmp_kernel_op_87*wz_dof_4 + tmp_kernel_op_88*wz_dof_5 + tmp_kernel_op_89*wz_dof_6 + tmp_kernel_op_92*wz_dof_1 + tmp_kernel_op_95*wz_dof_2 + tmp_kernel_op_98*wz_dof_3 + tmp_kernel_op_99*wz_dof_7;
             const real_t tmp_kernel_op_107 = abs_det_jac_affine_WHITE_UP*abs_det_jac_blending_q_0*(diffusivity_times_delta_dof_0*tmp_kernel_op_103 + diffusivity_times_delta_dof_1*tmp_kernel_op_92 + diffusivity_times_delta_dof_2*tmp_kernel_op_95 + diffusivity_times_delta_dof_3*tmp_kernel_op_98 + diffusivity_times_delta_dof_4*tmp_kernel_op_87 + diffusivity_times_delta_dof_5*tmp_kernel_op_88 + diffusivity_times_delta_dof_6*tmp_kernel_op_89 + diffusivity_times_delta_dof_7*tmp_kernel_op_99 + diffusivity_times_delta_dof_8*tmp_kernel_op_100 + diffusivity_times_delta_dof_9*tmp_kernel_op_102)*-0.1333333333333333;
             const real_t tmp_kernel_op_108 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_kernel_op_29 + jac_blending_inv_1_0_q_0*tmp_kernel_op_34 + jac_blending_inv_2_0_q_0*tmp_kernel_op_36) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_kernel_op_29 + jac_blending_inv_1_1_q_0*tmp_kernel_op_34 + jac_blending_inv_2_1_q_0*tmp_kernel_op_36) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_kernel_op_29 + jac_blending_inv_1_2_q_0*tmp_kernel_op_34 + jac_blending_inv_2_2_q_0*tmp_kernel_op_36));
             const real_t tmp_kernel_op_115 = -hessian_blending_0_0_0_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_0_1_0_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_0_2_0_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_116 = -hessian_blending_0_0_1_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_0_1_1_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_0_2_1_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_117 = -hessian_blending_0_0_2_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_0_1_2_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_0_2_2_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_118 = jac_blending_inv_0_0_q_1*tmp_kernel_op_115 + jac_blending_inv_0_1_q_1*tmp_kernel_op_116 + jac_blending_inv_0_2_q_1*tmp_kernel_op_117;
             const real_t tmp_kernel_op_120 = jac_blending_inv_1_0_q_1*tmp_kernel_op_115 + jac_blending_inv_1_1_q_1*tmp_kernel_op_116 + jac_blending_inv_1_2_q_1*tmp_kernel_op_117;
             const real_t tmp_kernel_op_122 = jac_blending_inv_2_0_q_1*tmp_kernel_op_115 + jac_blending_inv_2_1_q_1*tmp_kernel_op_116 + jac_blending_inv_2_2_q_1*tmp_kernel_op_117;
             const real_t tmp_kernel_op_123 = -hessian_blending_1_0_0_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_1_1_0_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_1_2_0_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_124 = -hessian_blending_1_0_1_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_1_1_1_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_1_2_1_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_125 = -hessian_blending_1_0_2_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_1_1_2_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_1_2_2_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_126 = jac_blending_inv_0_0_q_1*tmp_kernel_op_123 + jac_blending_inv_0_1_q_1*tmp_kernel_op_124 + jac_blending_inv_0_2_q_1*tmp_kernel_op_125;
             const real_t tmp_kernel_op_127 = jac_blending_inv_1_0_q_1*tmp_kernel_op_123 + jac_blending_inv_1_1_q_1*tmp_kernel_op_124 + jac_blending_inv_1_2_q_1*tmp_kernel_op_125;
             const real_t tmp_kernel_op_128 = jac_blending_inv_2_0_q_1*tmp_kernel_op_123 + jac_blending_inv_2_1_q_1*tmp_kernel_op_124 + jac_blending_inv_2_2_q_1*tmp_kernel_op_125;
             const real_t tmp_kernel_op_129 = -hessian_blending_2_0_0_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_2_1_0_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_2_2_0_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_130 = -hessian_blending_2_0_1_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_2_1_1_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_2_2_1_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_131 = -hessian_blending_2_0_2_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_2_1_2_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_2_2_2_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_132 = jac_blending_inv_0_0_q_1*tmp_kernel_op_129 + jac_blending_inv_0_1_q_1*tmp_kernel_op_130 + jac_blending_inv_0_2_q_1*tmp_kernel_op_131;
             const real_t tmp_kernel_op_133 = jac_blending_inv_1_0_q_1*tmp_kernel_op_129 + jac_blending_inv_1_1_q_1*tmp_kernel_op_130 + jac_blending_inv_1_2_q_1*tmp_kernel_op_131;
             const real_t tmp_kernel_op_134 = jac_blending_inv_2_0_q_1*tmp_kernel_op_129 + jac_blending_inv_2_1_q_1*tmp_kernel_op_130 + jac_blending_inv_2_2_q_1*tmp_kernel_op_131;
             const real_t tmp_kernel_op_135 = -hessian_blending_0_0_0_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_0_1_0_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_0_2_0_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_136 = -hessian_blending_0_0_1_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_0_1_1_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_0_2_1_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_137 = -hessian_blending_0_0_2_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_0_1_2_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_0_2_2_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_138 = jac_blending_inv_0_0_q_1*tmp_kernel_op_135 + jac_blending_inv_0_1_q_1*tmp_kernel_op_136 + jac_blending_inv_0_2_q_1*tmp_kernel_op_137;
             const real_t tmp_kernel_op_139 = jac_blending_inv_1_0_q_1*tmp_kernel_op_135 + jac_blending_inv_1_1_q_1*tmp_kernel_op_136 + jac_blending_inv_1_2_q_1*tmp_kernel_op_137;
             const real_t tmp_kernel_op_140 = jac_blending_inv_2_0_q_1*tmp_kernel_op_135 + jac_blending_inv_2_1_q_1*tmp_kernel_op_136 + jac_blending_inv_2_2_q_1*tmp_kernel_op_137;
             const real_t tmp_kernel_op_141 = -hessian_blending_1_0_0_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_1_1_0_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_1_2_0_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_142 = -hessian_blending_1_0_1_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_1_1_1_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_1_2_1_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_143 = -hessian_blending_1_0_2_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_1_1_2_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_1_2_2_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_144 = jac_blending_inv_0_0_q_1*tmp_kernel_op_141 + jac_blending_inv_0_1_q_1*tmp_kernel_op_142 + jac_blending_inv_0_2_q_1*tmp_kernel_op_143;
             const real_t tmp_kernel_op_145 = jac_blending_inv_1_0_q_1*tmp_kernel_op_141 + jac_blending_inv_1_1_q_1*tmp_kernel_op_142 + jac_blending_inv_1_2_q_1*tmp_kernel_op_143;
             const real_t tmp_kernel_op_146 = jac_blending_inv_2_0_q_1*tmp_kernel_op_141 + jac_blending_inv_2_1_q_1*tmp_kernel_op_142 + jac_blending_inv_2_2_q_1*tmp_kernel_op_143;
             const real_t tmp_kernel_op_147 = -hessian_blending_2_0_0_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_2_1_0_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_2_2_0_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_148 = -hessian_blending_2_0_1_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_2_1_1_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_2_2_1_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_149 = -hessian_blending_2_0_2_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_2_1_2_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_2_2_2_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_150 = jac_blending_inv_0_0_q_1*tmp_kernel_op_147 + jac_blending_inv_0_1_q_1*tmp_kernel_op_148 + jac_blending_inv_0_2_q_1*tmp_kernel_op_149;
             const real_t tmp_kernel_op_151 = jac_blending_inv_1_0_q_1*tmp_kernel_op_147 + jac_blending_inv_1_1_q_1*tmp_kernel_op_148 + jac_blending_inv_1_2_q_1*tmp_kernel_op_149;
             const real_t tmp_kernel_op_152 = jac_blending_inv_2_0_q_1*tmp_kernel_op_147 + jac_blending_inv_2_1_q_1*tmp_kernel_op_148 + jac_blending_inv_2_2_q_1*tmp_kernel_op_149;
             const real_t tmp_kernel_op_153 = -hessian_blending_0_0_0_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_0_1_0_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_0_2_0_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_154 = -hessian_blending_0_0_1_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_0_1_1_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_0_2_1_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_155 = -hessian_blending_0_0_2_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_0_1_2_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_0_2_2_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_156 = jac_blending_inv_0_0_q_1*tmp_kernel_op_153 + jac_blending_inv_0_1_q_1*tmp_kernel_op_154 + jac_blending_inv_0_2_q_1*tmp_kernel_op_155;
             const real_t tmp_kernel_op_157 = jac_blending_inv_1_0_q_1*tmp_kernel_op_153 + jac_blending_inv_1_1_q_1*tmp_kernel_op_154 + jac_blending_inv_1_2_q_1*tmp_kernel_op_155;
             const real_t tmp_kernel_op_158 = jac_blending_inv_2_0_q_1*tmp_kernel_op_153 + jac_blending_inv_2_1_q_1*tmp_kernel_op_154 + jac_blending_inv_2_2_q_1*tmp_kernel_op_155;
             const real_t tmp_kernel_op_159 = -hessian_blending_1_0_0_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_1_1_0_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_1_2_0_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_160 = -hessian_blending_1_0_1_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_1_1_1_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_1_2_1_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_161 = -hessian_blending_1_0_2_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_1_1_2_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_1_2_2_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_162 = jac_blending_inv_0_0_q_1*tmp_kernel_op_159 + jac_blending_inv_0_1_q_1*tmp_kernel_op_160 + jac_blending_inv_0_2_q_1*tmp_kernel_op_161;
             const real_t tmp_kernel_op_163 = jac_blending_inv_1_0_q_1*tmp_kernel_op_159 + jac_blending_inv_1_1_q_1*tmp_kernel_op_160 + jac_blending_inv_1_2_q_1*tmp_kernel_op_161;
             const real_t tmp_kernel_op_164 = jac_blending_inv_2_0_q_1*tmp_kernel_op_159 + jac_blending_inv_2_1_q_1*tmp_kernel_op_160 + jac_blending_inv_2_2_q_1*tmp_kernel_op_161;
             const real_t tmp_kernel_op_165 = -hessian_blending_2_0_0_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_2_1_0_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_2_2_0_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_166 = -hessian_blending_2_0_1_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_2_1_1_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_2_2_1_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_167 = -hessian_blending_2_0_2_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_2_1_2_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_2_2_2_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_168 = jac_blending_inv_0_0_q_1*tmp_kernel_op_165 + jac_blending_inv_0_1_q_1*tmp_kernel_op_166 + jac_blending_inv_0_2_q_1*tmp_kernel_op_167;
             const real_t tmp_kernel_op_169 = jac_blending_inv_1_0_q_1*tmp_kernel_op_165 + jac_blending_inv_1_1_q_1*tmp_kernel_op_166 + jac_blending_inv_1_2_q_1*tmp_kernel_op_167;
             const real_t tmp_kernel_op_170 = jac_blending_inv_2_0_q_1*tmp_kernel_op_165 + jac_blending_inv_2_1_q_1*tmp_kernel_op_166 + jac_blending_inv_2_2_q_1*tmp_kernel_op_167;
             const real_t tmp_kernel_op_171 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_5 + jac_blending_inv_1_0_q_1*tmp_kernel_op_11 + jac_blending_inv_2_0_q_1*tmp_kernel_op_17) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_114*tmp_kernel_op_118 + tmp_kernel_op_119*tmp_kernel_op_120 + tmp_kernel_op_121*tmp_kernel_op_122) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_5 + jac_blending_inv_1_1_q_1*tmp_kernel_op_11 + jac_blending_inv_2_1_q_1*tmp_kernel_op_17) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_114*tmp_kernel_op_126 + tmp_kernel_op_119*tmp_kernel_op_127 + tmp_kernel_op_121*tmp_kernel_op_128) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_5 + jac_blending_inv_1_2_q_1*tmp_kernel_op_11 + jac_blending_inv_2_2_q_1*tmp_kernel_op_17) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_114*tmp_kernel_op_132 + tmp_kernel_op_119*tmp_kernel_op_133 + tmp_kernel_op_121*tmp_kernel_op_134) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_18 + jac_blending_inv_1_0_q_1*tmp_kernel_op_19 + jac_blending_inv_2_0_q_1*tmp_kernel_op_20) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_114*tmp_kernel_op_138 + tmp_kernel_op_119*tmp_kernel_op_139 + tmp_kernel_op_121*tmp_kernel_op_140) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_18 + jac_blending_inv_1_1_q_1*tmp_kernel_op_19 + jac_blending_inv_2_1_q_1*tmp_kernel_op_20) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_114*tmp_kernel_op_144 + tmp_kernel_op_119*tmp_kernel_op_145 + tmp_kernel_op_121*tmp_kernel_op_146) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_18 + jac_blending_inv_1_2_q_1*tmp_kernel_op_19 + jac_blending_inv_2_2_q_1*tmp_kernel_op_20) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_114*tmp_kernel_op_150 + tmp_kernel_op_119*tmp_kernel_op_151 + tmp_kernel_op_121*tmp_kernel_op_152) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_21 + jac_blending_inv_1_0_q_1*tmp_kernel_op_22 + jac_blending_inv_2_0_q_1*tmp_kernel_op_23) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_114*tmp_kernel_op_156 + tmp_kernel_op_119*tmp_kernel_op_157 + tmp_kernel_op_121*tmp_kernel_op_158) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_21 + jac_blending_inv_1_1_q_1*tmp_kernel_op_22 + jac_blending_inv_2_1_q_1*tmp_kernel_op_23) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_114*tmp_kernel_op_162 + tmp_kernel_op_119*tmp_kernel_op_163 + tmp_kernel_op_121*tmp_kernel_op_164) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_21 + jac_blending_inv_1_2_q_1*tmp_kernel_op_22 + jac_blending_inv_2_2_q_1*tmp_kernel_op_23) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_114*tmp_kernel_op_168 + tmp_kernel_op_119*tmp_kernel_op_169 + tmp_kernel_op_121*tmp_kernel_op_170);
             const real_t tmp_kernel_op_189 = tmp_kernel_op_172*wx_dof_4 + tmp_kernel_op_173*wx_dof_5 + tmp_kernel_op_174*wx_dof_6 + tmp_kernel_op_177*wx_dof_1 + tmp_kernel_op_180*wx_dof_2 + tmp_kernel_op_183*wx_dof_3 + tmp_kernel_op_184*wx_dof_7 + tmp_kernel_op_185*wx_dof_8 + tmp_kernel_op_187*wx_dof_9 + tmp_kernel_op_188*wx_dof_0;
             const real_t tmp_kernel_op_190 = tmp_kernel_op_172*wy_dof_4 + tmp_kernel_op_173*wy_dof_5 + tmp_kernel_op_174*wy_dof_6 + tmp_kernel_op_177*wy_dof_1 + tmp_kernel_op_180*wy_dof_2 + tmp_kernel_op_183*wy_dof_3 + tmp_kernel_op_184*wy_dof_7 + tmp_kernel_op_185*wy_dof_8 + tmp_kernel_op_187*wy_dof_9 + tmp_kernel_op_188*wy_dof_0;
             const real_t tmp_kernel_op_191 = tmp_kernel_op_172*wz_dof_4 + tmp_kernel_op_173*wz_dof_5 + tmp_kernel_op_174*wz_dof_6 + tmp_kernel_op_177*wz_dof_1 + tmp_kernel_op_180*wz_dof_2 + tmp_kernel_op_183*wz_dof_3 + tmp_kernel_op_184*wz_dof_7 + tmp_kernel_op_185*wz_dof_8 + tmp_kernel_op_187*wz_dof_9 + tmp_kernel_op_188*wz_dof_0;
             const real_t tmp_kernel_op_192 = abs_det_jac_affine_WHITE_UP*abs_det_jac_blending_q_1*(diffusivity_times_delta_dof_0*tmp_kernel_op_188 + diffusivity_times_delta_dof_1*tmp_kernel_op_177 + diffusivity_times_delta_dof_2*tmp_kernel_op_180 + diffusivity_times_delta_dof_3*tmp_kernel_op_183 + diffusivity_times_delta_dof_4*tmp_kernel_op_172 + diffusivity_times_delta_dof_5*tmp_kernel_op_173 + diffusivity_times_delta_dof_6*tmp_kernel_op_174 + diffusivity_times_delta_dof_7*tmp_kernel_op_184 + diffusivity_times_delta_dof_8*tmp_kernel_op_185 + diffusivity_times_delta_dof_9*tmp_kernel_op_187)*0.074999999999999983;
             const real_t tmp_kernel_op_193 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_kernel_op_114 + jac_blending_inv_1_0_q_1*tmp_kernel_op_119 + jac_blending_inv_2_0_q_1*tmp_kernel_op_121) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_kernel_op_114 + jac_blending_inv_1_1_q_1*tmp_kernel_op_119 + jac_blending_inv_2_1_q_1*tmp_kernel_op_121) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_kernel_op_114 + jac_blending_inv_1_2_q_1*tmp_kernel_op_119 + jac_blending_inv_2_2_q_1*tmp_kernel_op_121));
             const real_t tmp_kernel_op_200 = -hessian_blending_0_0_0_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_0_1_0_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_0_2_0_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_201 = -hessian_blending_0_0_1_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_0_1_1_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_0_2_1_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_202 = -hessian_blending_0_0_2_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_0_1_2_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_0_2_2_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_203 = jac_blending_inv_0_0_q_2*tmp_kernel_op_200 + jac_blending_inv_0_1_q_2*tmp_kernel_op_201 + jac_blending_inv_0_2_q_2*tmp_kernel_op_202;
             const real_t tmp_kernel_op_205 = jac_blending_inv_1_0_q_2*tmp_kernel_op_200 + jac_blending_inv_1_1_q_2*tmp_kernel_op_201 + jac_blending_inv_1_2_q_2*tmp_kernel_op_202;
             const real_t tmp_kernel_op_207 = jac_blending_inv_2_0_q_2*tmp_kernel_op_200 + jac_blending_inv_2_1_q_2*tmp_kernel_op_201 + jac_blending_inv_2_2_q_2*tmp_kernel_op_202;
             const real_t tmp_kernel_op_208 = -hessian_blending_1_0_0_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_1_1_0_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_1_2_0_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_209 = -hessian_blending_1_0_1_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_1_1_1_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_1_2_1_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_210 = -hessian_blending_1_0_2_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_1_1_2_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_1_2_2_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_211 = jac_blending_inv_0_0_q_2*tmp_kernel_op_208 + jac_blending_inv_0_1_q_2*tmp_kernel_op_209 + jac_blending_inv_0_2_q_2*tmp_kernel_op_210;
             const real_t tmp_kernel_op_212 = jac_blending_inv_1_0_q_2*tmp_kernel_op_208 + jac_blending_inv_1_1_q_2*tmp_kernel_op_209 + jac_blending_inv_1_2_q_2*tmp_kernel_op_210;
             const real_t tmp_kernel_op_213 = jac_blending_inv_2_0_q_2*tmp_kernel_op_208 + jac_blending_inv_2_1_q_2*tmp_kernel_op_209 + jac_blending_inv_2_2_q_2*tmp_kernel_op_210;
             const real_t tmp_kernel_op_214 = -hessian_blending_2_0_0_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_2_1_0_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_2_2_0_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_215 = -hessian_blending_2_0_1_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_2_1_1_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_2_2_1_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_216 = -hessian_blending_2_0_2_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_2_1_2_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_2_2_2_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_217 = jac_blending_inv_0_0_q_2*tmp_kernel_op_214 + jac_blending_inv_0_1_q_2*tmp_kernel_op_215 + jac_blending_inv_0_2_q_2*tmp_kernel_op_216;
             const real_t tmp_kernel_op_218 = jac_blending_inv_1_0_q_2*tmp_kernel_op_214 + jac_blending_inv_1_1_q_2*tmp_kernel_op_215 + jac_blending_inv_1_2_q_2*tmp_kernel_op_216;
             const real_t tmp_kernel_op_219 = jac_blending_inv_2_0_q_2*tmp_kernel_op_214 + jac_blending_inv_2_1_q_2*tmp_kernel_op_215 + jac_blending_inv_2_2_q_2*tmp_kernel_op_216;
             const real_t tmp_kernel_op_220 = -hessian_blending_0_0_0_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_0_1_0_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_0_2_0_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_221 = -hessian_blending_0_0_1_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_0_1_1_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_0_2_1_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_222 = -hessian_blending_0_0_2_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_0_1_2_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_0_2_2_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_223 = jac_blending_inv_0_0_q_2*tmp_kernel_op_220 + jac_blending_inv_0_1_q_2*tmp_kernel_op_221 + jac_blending_inv_0_2_q_2*tmp_kernel_op_222;
             const real_t tmp_kernel_op_224 = jac_blending_inv_1_0_q_2*tmp_kernel_op_220 + jac_blending_inv_1_1_q_2*tmp_kernel_op_221 + jac_blending_inv_1_2_q_2*tmp_kernel_op_222;
             const real_t tmp_kernel_op_225 = jac_blending_inv_2_0_q_2*tmp_kernel_op_220 + jac_blending_inv_2_1_q_2*tmp_kernel_op_221 + jac_blending_inv_2_2_q_2*tmp_kernel_op_222;
             const real_t tmp_kernel_op_226 = -hessian_blending_1_0_0_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_1_1_0_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_1_2_0_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_227 = -hessian_blending_1_0_1_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_1_1_1_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_1_2_1_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_228 = -hessian_blending_1_0_2_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_1_1_2_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_1_2_2_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_229 = jac_blending_inv_0_0_q_2*tmp_kernel_op_226 + jac_blending_inv_0_1_q_2*tmp_kernel_op_227 + jac_blending_inv_0_2_q_2*tmp_kernel_op_228;
             const real_t tmp_kernel_op_230 = jac_blending_inv_1_0_q_2*tmp_kernel_op_226 + jac_blending_inv_1_1_q_2*tmp_kernel_op_227 + jac_blending_inv_1_2_q_2*tmp_kernel_op_228;
             const real_t tmp_kernel_op_231 = jac_blending_inv_2_0_q_2*tmp_kernel_op_226 + jac_blending_inv_2_1_q_2*tmp_kernel_op_227 + jac_blending_inv_2_2_q_2*tmp_kernel_op_228;
             const real_t tmp_kernel_op_232 = -hessian_blending_2_0_0_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_2_1_0_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_2_2_0_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_233 = -hessian_blending_2_0_1_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_2_1_1_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_2_2_1_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_234 = -hessian_blending_2_0_2_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_2_1_2_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_2_2_2_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_235 = jac_blending_inv_0_0_q_2*tmp_kernel_op_232 + jac_blending_inv_0_1_q_2*tmp_kernel_op_233 + jac_blending_inv_0_2_q_2*tmp_kernel_op_234;
             const real_t tmp_kernel_op_236 = jac_blending_inv_1_0_q_2*tmp_kernel_op_232 + jac_blending_inv_1_1_q_2*tmp_kernel_op_233 + jac_blending_inv_1_2_q_2*tmp_kernel_op_234;
             const real_t tmp_kernel_op_237 = jac_blending_inv_2_0_q_2*tmp_kernel_op_232 + jac_blending_inv_2_1_q_2*tmp_kernel_op_233 + jac_blending_inv_2_2_q_2*tmp_kernel_op_234;
             const real_t tmp_kernel_op_238 = -hessian_blending_0_0_0_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_0_1_0_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_0_2_0_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_239 = -hessian_blending_0_0_1_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_0_1_1_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_0_2_1_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_240 = -hessian_blending_0_0_2_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_0_1_2_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_0_2_2_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_241 = jac_blending_inv_0_0_q_2*tmp_kernel_op_238 + jac_blending_inv_0_1_q_2*tmp_kernel_op_239 + jac_blending_inv_0_2_q_2*tmp_kernel_op_240;
             const real_t tmp_kernel_op_242 = jac_blending_inv_1_0_q_2*tmp_kernel_op_238 + jac_blending_inv_1_1_q_2*tmp_kernel_op_239 + jac_blending_inv_1_2_q_2*tmp_kernel_op_240;
             const real_t tmp_kernel_op_243 = jac_blending_inv_2_0_q_2*tmp_kernel_op_238 + jac_blending_inv_2_1_q_2*tmp_kernel_op_239 + jac_blending_inv_2_2_q_2*tmp_kernel_op_240;
             const real_t tmp_kernel_op_244 = -hessian_blending_1_0_0_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_1_1_0_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_1_2_0_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_245 = -hessian_blending_1_0_1_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_1_1_1_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_1_2_1_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_246 = -hessian_blending_1_0_2_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_1_1_2_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_1_2_2_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_247 = jac_blending_inv_0_0_q_2*tmp_kernel_op_244 + jac_blending_inv_0_1_q_2*tmp_kernel_op_245 + jac_blending_inv_0_2_q_2*tmp_kernel_op_246;
             const real_t tmp_kernel_op_248 = jac_blending_inv_1_0_q_2*tmp_kernel_op_244 + jac_blending_inv_1_1_q_2*tmp_kernel_op_245 + jac_blending_inv_1_2_q_2*tmp_kernel_op_246;
             const real_t tmp_kernel_op_249 = jac_blending_inv_2_0_q_2*tmp_kernel_op_244 + jac_blending_inv_2_1_q_2*tmp_kernel_op_245 + jac_blending_inv_2_2_q_2*tmp_kernel_op_246;
             const real_t tmp_kernel_op_250 = -hessian_blending_2_0_0_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_2_1_0_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_2_2_0_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_251 = -hessian_blending_2_0_1_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_2_1_1_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_2_2_1_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_252 = -hessian_blending_2_0_2_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_2_1_2_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_2_2_2_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_253 = jac_blending_inv_0_0_q_2*tmp_kernel_op_250 + jac_blending_inv_0_1_q_2*tmp_kernel_op_251 + jac_blending_inv_0_2_q_2*tmp_kernel_op_252;
             const real_t tmp_kernel_op_254 = jac_blending_inv_1_0_q_2*tmp_kernel_op_250 + jac_blending_inv_1_1_q_2*tmp_kernel_op_251 + jac_blending_inv_1_2_q_2*tmp_kernel_op_252;
             const real_t tmp_kernel_op_255 = jac_blending_inv_2_0_q_2*tmp_kernel_op_250 + jac_blending_inv_2_1_q_2*tmp_kernel_op_251 + jac_blending_inv_2_2_q_2*tmp_kernel_op_252;
             const real_t tmp_kernel_op_256 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_5 + jac_blending_inv_1_0_q_2*tmp_kernel_op_11 + jac_blending_inv_2_0_q_2*tmp_kernel_op_17) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_199*tmp_kernel_op_203 + tmp_kernel_op_204*tmp_kernel_op_205 + tmp_kernel_op_206*tmp_kernel_op_207) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_5 + jac_blending_inv_1_1_q_2*tmp_kernel_op_11 + jac_blending_inv_2_1_q_2*tmp_kernel_op_17) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_199*tmp_kernel_op_211 + tmp_kernel_op_204*tmp_kernel_op_212 + tmp_kernel_op_206*tmp_kernel_op_213) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_5 + jac_blending_inv_1_2_q_2*tmp_kernel_op_11 + jac_blending_inv_2_2_q_2*tmp_kernel_op_17) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_199*tmp_kernel_op_217 + tmp_kernel_op_204*tmp_kernel_op_218 + tmp_kernel_op_206*tmp_kernel_op_219) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_18 + jac_blending_inv_1_0_q_2*tmp_kernel_op_19 + jac_blending_inv_2_0_q_2*tmp_kernel_op_20) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_199*tmp_kernel_op_223 + tmp_kernel_op_204*tmp_kernel_op_224 + tmp_kernel_op_206*tmp_kernel_op_225) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_18 + jac_blending_inv_1_1_q_2*tmp_kernel_op_19 + jac_blending_inv_2_1_q_2*tmp_kernel_op_20) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_199*tmp_kernel_op_229 + tmp_kernel_op_204*tmp_kernel_op_230 + tmp_kernel_op_206*tmp_kernel_op_231) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_18 + jac_blending_inv_1_2_q_2*tmp_kernel_op_19 + jac_blending_inv_2_2_q_2*tmp_kernel_op_20) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_199*tmp_kernel_op_235 + tmp_kernel_op_204*tmp_kernel_op_236 + tmp_kernel_op_206*tmp_kernel_op_237) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_21 + jac_blending_inv_1_0_q_2*tmp_kernel_op_22 + jac_blending_inv_2_0_q_2*tmp_kernel_op_23) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_199*tmp_kernel_op_241 + tmp_kernel_op_204*tmp_kernel_op_242 + tmp_kernel_op_206*tmp_kernel_op_243) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_21 + jac_blending_inv_1_1_q_2*tmp_kernel_op_22 + jac_blending_inv_2_1_q_2*tmp_kernel_op_23) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_199*tmp_kernel_op_247 + tmp_kernel_op_204*tmp_kernel_op_248 + tmp_kernel_op_206*tmp_kernel_op_249) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_21 + jac_blending_inv_1_2_q_2*tmp_kernel_op_22 + jac_blending_inv_2_2_q_2*tmp_kernel_op_23) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_199*tmp_kernel_op_253 + tmp_kernel_op_204*tmp_kernel_op_254 + tmp_kernel_op_206*tmp_kernel_op_255);
             const real_t tmp_kernel_op_274 = tmp_kernel_op_257*wx_dof_4 + tmp_kernel_op_258*wx_dof_5 + tmp_kernel_op_259*wx_dof_6 + tmp_kernel_op_262*wx_dof_1 + tmp_kernel_op_265*wx_dof_2 + tmp_kernel_op_268*wx_dof_3 + tmp_kernel_op_269*wx_dof_7 + tmp_kernel_op_270*wx_dof_8 + tmp_kernel_op_272*wx_dof_9 + tmp_kernel_op_273*wx_dof_0;
             const real_t tmp_kernel_op_275 = tmp_kernel_op_257*wy_dof_4 + tmp_kernel_op_258*wy_dof_5 + tmp_kernel_op_259*wy_dof_6 + tmp_kernel_op_262*wy_dof_1 + tmp_kernel_op_265*wy_dof_2 + tmp_kernel_op_268*wy_dof_3 + tmp_kernel_op_269*wy_dof_7 + tmp_kernel_op_270*wy_dof_8 + tmp_kernel_op_272*wy_dof_9 + tmp_kernel_op_273*wy_dof_0;
             const real_t tmp_kernel_op_276 = tmp_kernel_op_257*wz_dof_4 + tmp_kernel_op_258*wz_dof_5 + tmp_kernel_op_259*wz_dof_6 + tmp_kernel_op_262*wz_dof_1 + tmp_kernel_op_265*wz_dof_2 + tmp_kernel_op_268*wz_dof_3 + tmp_kernel_op_269*wz_dof_7 + tmp_kernel_op_270*wz_dof_8 + tmp_kernel_op_272*wz_dof_9 + tmp_kernel_op_273*wz_dof_0;
             const real_t tmp_kernel_op_277 = abs_det_jac_affine_WHITE_UP*abs_det_jac_blending_q_2*(diffusivity_times_delta_dof_0*tmp_kernel_op_273 + diffusivity_times_delta_dof_1*tmp_kernel_op_262 + diffusivity_times_delta_dof_2*tmp_kernel_op_265 + diffusivity_times_delta_dof_3*tmp_kernel_op_268 + diffusivity_times_delta_dof_4*tmp_kernel_op_257 + diffusivity_times_delta_dof_5*tmp_kernel_op_258 + diffusivity_times_delta_dof_6*tmp_kernel_op_259 + diffusivity_times_delta_dof_7*tmp_kernel_op_269 + diffusivity_times_delta_dof_8*tmp_kernel_op_270 + diffusivity_times_delta_dof_9*tmp_kernel_op_272)*0.074999999999999983;
             const real_t tmp_kernel_op_278 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_kernel_op_199 + jac_blending_inv_1_0_q_2*tmp_kernel_op_204 + jac_blending_inv_2_0_q_2*tmp_kernel_op_206) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_kernel_op_199 + jac_blending_inv_1_1_q_2*tmp_kernel_op_204 + jac_blending_inv_2_1_q_2*tmp_kernel_op_206) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_kernel_op_199 + jac_blending_inv_1_2_q_2*tmp_kernel_op_204 + jac_blending_inv_2_2_q_2*tmp_kernel_op_206));
             const real_t tmp_kernel_op_285 = -hessian_blending_0_0_0_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_0_1_0_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_0_2_0_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_286 = -hessian_blending_0_0_1_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_0_1_1_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_0_2_1_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_287 = -hessian_blending_0_0_2_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_0_1_2_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_0_2_2_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_288 = jac_blending_inv_0_0_q_3*tmp_kernel_op_285 + jac_blending_inv_0_1_q_3*tmp_kernel_op_286 + jac_blending_inv_0_2_q_3*tmp_kernel_op_287;
             const real_t tmp_kernel_op_290 = jac_blending_inv_1_0_q_3*tmp_kernel_op_285 + jac_blending_inv_1_1_q_3*tmp_kernel_op_286 + jac_blending_inv_1_2_q_3*tmp_kernel_op_287;
             const real_t tmp_kernel_op_292 = jac_blending_inv_2_0_q_3*tmp_kernel_op_285 + jac_blending_inv_2_1_q_3*tmp_kernel_op_286 + jac_blending_inv_2_2_q_3*tmp_kernel_op_287;
             const real_t tmp_kernel_op_293 = -hessian_blending_1_0_0_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_1_1_0_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_1_2_0_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_294 = -hessian_blending_1_0_1_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_1_1_1_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_1_2_1_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_295 = -hessian_blending_1_0_2_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_1_1_2_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_1_2_2_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_296 = jac_blending_inv_0_0_q_3*tmp_kernel_op_293 + jac_blending_inv_0_1_q_3*tmp_kernel_op_294 + jac_blending_inv_0_2_q_3*tmp_kernel_op_295;
             const real_t tmp_kernel_op_297 = jac_blending_inv_1_0_q_3*tmp_kernel_op_293 + jac_blending_inv_1_1_q_3*tmp_kernel_op_294 + jac_blending_inv_1_2_q_3*tmp_kernel_op_295;
             const real_t tmp_kernel_op_298 = jac_blending_inv_2_0_q_3*tmp_kernel_op_293 + jac_blending_inv_2_1_q_3*tmp_kernel_op_294 + jac_blending_inv_2_2_q_3*tmp_kernel_op_295;
             const real_t tmp_kernel_op_299 = -hessian_blending_2_0_0_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_2_1_0_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_2_2_0_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_300 = -hessian_blending_2_0_1_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_2_1_1_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_2_2_1_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_301 = -hessian_blending_2_0_2_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_2_1_2_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_2_2_2_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_302 = jac_blending_inv_0_0_q_3*tmp_kernel_op_299 + jac_blending_inv_0_1_q_3*tmp_kernel_op_300 + jac_blending_inv_0_2_q_3*tmp_kernel_op_301;
             const real_t tmp_kernel_op_303 = jac_blending_inv_1_0_q_3*tmp_kernel_op_299 + jac_blending_inv_1_1_q_3*tmp_kernel_op_300 + jac_blending_inv_1_2_q_3*tmp_kernel_op_301;
             const real_t tmp_kernel_op_304 = jac_blending_inv_2_0_q_3*tmp_kernel_op_299 + jac_blending_inv_2_1_q_3*tmp_kernel_op_300 + jac_blending_inv_2_2_q_3*tmp_kernel_op_301;
             const real_t tmp_kernel_op_305 = -hessian_blending_0_0_0_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_0_1_0_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_0_2_0_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_306 = -hessian_blending_0_0_1_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_0_1_1_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_0_2_1_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_307 = -hessian_blending_0_0_2_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_0_1_2_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_0_2_2_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_308 = jac_blending_inv_0_0_q_3*tmp_kernel_op_305 + jac_blending_inv_0_1_q_3*tmp_kernel_op_306 + jac_blending_inv_0_2_q_3*tmp_kernel_op_307;
             const real_t tmp_kernel_op_309 = jac_blending_inv_1_0_q_3*tmp_kernel_op_305 + jac_blending_inv_1_1_q_3*tmp_kernel_op_306 + jac_blending_inv_1_2_q_3*tmp_kernel_op_307;
             const real_t tmp_kernel_op_310 = jac_blending_inv_2_0_q_3*tmp_kernel_op_305 + jac_blending_inv_2_1_q_3*tmp_kernel_op_306 + jac_blending_inv_2_2_q_3*tmp_kernel_op_307;
             const real_t tmp_kernel_op_311 = -hessian_blending_1_0_0_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_1_1_0_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_1_2_0_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_312 = -hessian_blending_1_0_1_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_1_1_1_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_1_2_1_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_313 = -hessian_blending_1_0_2_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_1_1_2_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_1_2_2_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_314 = jac_blending_inv_0_0_q_3*tmp_kernel_op_311 + jac_blending_inv_0_1_q_3*tmp_kernel_op_312 + jac_blending_inv_0_2_q_3*tmp_kernel_op_313;
             const real_t tmp_kernel_op_315 = jac_blending_inv_1_0_q_3*tmp_kernel_op_311 + jac_blending_inv_1_1_q_3*tmp_kernel_op_312 + jac_blending_inv_1_2_q_3*tmp_kernel_op_313;
             const real_t tmp_kernel_op_316 = jac_blending_inv_2_0_q_3*tmp_kernel_op_311 + jac_blending_inv_2_1_q_3*tmp_kernel_op_312 + jac_blending_inv_2_2_q_3*tmp_kernel_op_313;
             const real_t tmp_kernel_op_317 = -hessian_blending_2_0_0_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_2_1_0_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_2_2_0_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_318 = -hessian_blending_2_0_1_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_2_1_1_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_2_2_1_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_319 = -hessian_blending_2_0_2_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_2_1_2_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_2_2_2_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_320 = jac_blending_inv_0_0_q_3*tmp_kernel_op_317 + jac_blending_inv_0_1_q_3*tmp_kernel_op_318 + jac_blending_inv_0_2_q_3*tmp_kernel_op_319;
             const real_t tmp_kernel_op_321 = jac_blending_inv_1_0_q_3*tmp_kernel_op_317 + jac_blending_inv_1_1_q_3*tmp_kernel_op_318 + jac_blending_inv_1_2_q_3*tmp_kernel_op_319;
             const real_t tmp_kernel_op_322 = jac_blending_inv_2_0_q_3*tmp_kernel_op_317 + jac_blending_inv_2_1_q_3*tmp_kernel_op_318 + jac_blending_inv_2_2_q_3*tmp_kernel_op_319;
             const real_t tmp_kernel_op_323 = -hessian_blending_0_0_0_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_0_1_0_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_0_2_0_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_324 = -hessian_blending_0_0_1_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_0_1_1_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_0_2_1_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_325 = -hessian_blending_0_0_2_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_0_1_2_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_0_2_2_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_326 = jac_blending_inv_0_0_q_3*tmp_kernel_op_323 + jac_blending_inv_0_1_q_3*tmp_kernel_op_324 + jac_blending_inv_0_2_q_3*tmp_kernel_op_325;
             const real_t tmp_kernel_op_327 = jac_blending_inv_1_0_q_3*tmp_kernel_op_323 + jac_blending_inv_1_1_q_3*tmp_kernel_op_324 + jac_blending_inv_1_2_q_3*tmp_kernel_op_325;
             const real_t tmp_kernel_op_328 = jac_blending_inv_2_0_q_3*tmp_kernel_op_323 + jac_blending_inv_2_1_q_3*tmp_kernel_op_324 + jac_blending_inv_2_2_q_3*tmp_kernel_op_325;
             const real_t tmp_kernel_op_329 = -hessian_blending_1_0_0_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_1_1_0_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_1_2_0_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_330 = -hessian_blending_1_0_1_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_1_1_1_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_1_2_1_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_331 = -hessian_blending_1_0_2_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_1_1_2_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_1_2_2_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_332 = jac_blending_inv_0_0_q_3*tmp_kernel_op_329 + jac_blending_inv_0_1_q_3*tmp_kernel_op_330 + jac_blending_inv_0_2_q_3*tmp_kernel_op_331;
             const real_t tmp_kernel_op_333 = jac_blending_inv_1_0_q_3*tmp_kernel_op_329 + jac_blending_inv_1_1_q_3*tmp_kernel_op_330 + jac_blending_inv_1_2_q_3*tmp_kernel_op_331;
             const real_t tmp_kernel_op_334 = jac_blending_inv_2_0_q_3*tmp_kernel_op_329 + jac_blending_inv_2_1_q_3*tmp_kernel_op_330 + jac_blending_inv_2_2_q_3*tmp_kernel_op_331;
             const real_t tmp_kernel_op_335 = -hessian_blending_2_0_0_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_2_1_0_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_2_2_0_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_336 = -hessian_blending_2_0_1_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_2_1_1_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_2_2_1_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_337 = -hessian_blending_2_0_2_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_2_1_2_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_2_2_2_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_338 = jac_blending_inv_0_0_q_3*tmp_kernel_op_335 + jac_blending_inv_0_1_q_3*tmp_kernel_op_336 + jac_blending_inv_0_2_q_3*tmp_kernel_op_337;
             const real_t tmp_kernel_op_339 = jac_blending_inv_1_0_q_3*tmp_kernel_op_335 + jac_blending_inv_1_1_q_3*tmp_kernel_op_336 + jac_blending_inv_1_2_q_3*tmp_kernel_op_337;
             const real_t tmp_kernel_op_340 = jac_blending_inv_2_0_q_3*tmp_kernel_op_335 + jac_blending_inv_2_1_q_3*tmp_kernel_op_336 + jac_blending_inv_2_2_q_3*tmp_kernel_op_337;
             const real_t tmp_kernel_op_341 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_5 + jac_blending_inv_1_0_q_3*tmp_kernel_op_11 + jac_blending_inv_2_0_q_3*tmp_kernel_op_17) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_284*tmp_kernel_op_288 + tmp_kernel_op_289*tmp_kernel_op_290 + tmp_kernel_op_291*tmp_kernel_op_292) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_5 + jac_blending_inv_1_1_q_3*tmp_kernel_op_11 + jac_blending_inv_2_1_q_3*tmp_kernel_op_17) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_284*tmp_kernel_op_296 + tmp_kernel_op_289*tmp_kernel_op_297 + tmp_kernel_op_291*tmp_kernel_op_298) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_5 + jac_blending_inv_1_2_q_3*tmp_kernel_op_11 + jac_blending_inv_2_2_q_3*tmp_kernel_op_17) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_284*tmp_kernel_op_302 + tmp_kernel_op_289*tmp_kernel_op_303 + tmp_kernel_op_291*tmp_kernel_op_304) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_18 + jac_blending_inv_1_0_q_3*tmp_kernel_op_19 + jac_blending_inv_2_0_q_3*tmp_kernel_op_20) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_284*tmp_kernel_op_308 + tmp_kernel_op_289*tmp_kernel_op_309 + tmp_kernel_op_291*tmp_kernel_op_310) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_18 + jac_blending_inv_1_1_q_3*tmp_kernel_op_19 + jac_blending_inv_2_1_q_3*tmp_kernel_op_20) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_284*tmp_kernel_op_314 + tmp_kernel_op_289*tmp_kernel_op_315 + tmp_kernel_op_291*tmp_kernel_op_316) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_18 + jac_blending_inv_1_2_q_3*tmp_kernel_op_19 + jac_blending_inv_2_2_q_3*tmp_kernel_op_20) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_284*tmp_kernel_op_320 + tmp_kernel_op_289*tmp_kernel_op_321 + tmp_kernel_op_291*tmp_kernel_op_322) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_21 + jac_blending_inv_1_0_q_3*tmp_kernel_op_22 + jac_blending_inv_2_0_q_3*tmp_kernel_op_23) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_284*tmp_kernel_op_326 + tmp_kernel_op_289*tmp_kernel_op_327 + tmp_kernel_op_291*tmp_kernel_op_328) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_21 + jac_blending_inv_1_1_q_3*tmp_kernel_op_22 + jac_blending_inv_2_1_q_3*tmp_kernel_op_23) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_284*tmp_kernel_op_332 + tmp_kernel_op_289*tmp_kernel_op_333 + tmp_kernel_op_291*tmp_kernel_op_334) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_21 + jac_blending_inv_1_2_q_3*tmp_kernel_op_22 + jac_blending_inv_2_2_q_3*tmp_kernel_op_23) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_284*tmp_kernel_op_338 + tmp_kernel_op_289*tmp_kernel_op_339 + tmp_kernel_op_291*tmp_kernel_op_340);
             const real_t tmp_kernel_op_359 = tmp_kernel_op_342*wx_dof_4 + tmp_kernel_op_343*wx_dof_5 + tmp_kernel_op_344*wx_dof_6 + tmp_kernel_op_347*wx_dof_1 + tmp_kernel_op_350*wx_dof_2 + tmp_kernel_op_353*wx_dof_3 + tmp_kernel_op_354*wx_dof_7 + tmp_kernel_op_355*wx_dof_8 + tmp_kernel_op_357*wx_dof_9 + tmp_kernel_op_358*wx_dof_0;
             const real_t tmp_kernel_op_360 = tmp_kernel_op_342*wy_dof_4 + tmp_kernel_op_343*wy_dof_5 + tmp_kernel_op_344*wy_dof_6 + tmp_kernel_op_347*wy_dof_1 + tmp_kernel_op_350*wy_dof_2 + tmp_kernel_op_353*wy_dof_3 + tmp_kernel_op_354*wy_dof_7 + tmp_kernel_op_355*wy_dof_8 + tmp_kernel_op_357*wy_dof_9 + tmp_kernel_op_358*wy_dof_0;
             const real_t tmp_kernel_op_361 = tmp_kernel_op_342*wz_dof_4 + tmp_kernel_op_343*wz_dof_5 + tmp_kernel_op_344*wz_dof_6 + tmp_kernel_op_347*wz_dof_1 + tmp_kernel_op_350*wz_dof_2 + tmp_kernel_op_353*wz_dof_3 + tmp_kernel_op_354*wz_dof_7 + tmp_kernel_op_355*wz_dof_8 + tmp_kernel_op_357*wz_dof_9 + tmp_kernel_op_358*wz_dof_0;
             const real_t tmp_kernel_op_362 = abs_det_jac_affine_WHITE_UP*abs_det_jac_blending_q_3*(diffusivity_times_delta_dof_0*tmp_kernel_op_358 + diffusivity_times_delta_dof_1*tmp_kernel_op_347 + diffusivity_times_delta_dof_2*tmp_kernel_op_350 + diffusivity_times_delta_dof_3*tmp_kernel_op_353 + diffusivity_times_delta_dof_4*tmp_kernel_op_342 + diffusivity_times_delta_dof_5*tmp_kernel_op_343 + diffusivity_times_delta_dof_6*tmp_kernel_op_344 + diffusivity_times_delta_dof_7*tmp_kernel_op_354 + diffusivity_times_delta_dof_8*tmp_kernel_op_355 + diffusivity_times_delta_dof_9*tmp_kernel_op_357)*0.074999999999999983;
             const real_t tmp_kernel_op_363 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_kernel_op_284 + jac_blending_inv_1_0_q_3*tmp_kernel_op_289 + jac_blending_inv_2_0_q_3*tmp_kernel_op_291) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_kernel_op_284 + jac_blending_inv_1_1_q_3*tmp_kernel_op_289 + jac_blending_inv_2_1_q_3*tmp_kernel_op_291) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_kernel_op_284 + jac_blending_inv_1_2_q_3*tmp_kernel_op_289 + jac_blending_inv_2_2_q_3*tmp_kernel_op_291));
             const real_t tmp_kernel_op_370 = -hessian_blending_0_0_0_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_0_1_0_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_0_2_0_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_371 = -hessian_blending_0_0_1_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_0_1_1_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_0_2_1_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_372 = -hessian_blending_0_0_2_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_0_1_2_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_0_2_2_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_373 = jac_blending_inv_0_0_q_4*tmp_kernel_op_370 + jac_blending_inv_0_1_q_4*tmp_kernel_op_371 + jac_blending_inv_0_2_q_4*tmp_kernel_op_372;
             const real_t tmp_kernel_op_375 = jac_blending_inv_1_0_q_4*tmp_kernel_op_370 + jac_blending_inv_1_1_q_4*tmp_kernel_op_371 + jac_blending_inv_1_2_q_4*tmp_kernel_op_372;
             const real_t tmp_kernel_op_377 = jac_blending_inv_2_0_q_4*tmp_kernel_op_370 + jac_blending_inv_2_1_q_4*tmp_kernel_op_371 + jac_blending_inv_2_2_q_4*tmp_kernel_op_372;
             const real_t tmp_kernel_op_378 = -hessian_blending_1_0_0_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_1_1_0_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_1_2_0_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_379 = -hessian_blending_1_0_1_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_1_1_1_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_1_2_1_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_380 = -hessian_blending_1_0_2_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_1_1_2_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_1_2_2_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_381 = jac_blending_inv_0_0_q_4*tmp_kernel_op_378 + jac_blending_inv_0_1_q_4*tmp_kernel_op_379 + jac_blending_inv_0_2_q_4*tmp_kernel_op_380;
             const real_t tmp_kernel_op_382 = jac_blending_inv_1_0_q_4*tmp_kernel_op_378 + jac_blending_inv_1_1_q_4*tmp_kernel_op_379 + jac_blending_inv_1_2_q_4*tmp_kernel_op_380;
             const real_t tmp_kernel_op_383 = jac_blending_inv_2_0_q_4*tmp_kernel_op_378 + jac_blending_inv_2_1_q_4*tmp_kernel_op_379 + jac_blending_inv_2_2_q_4*tmp_kernel_op_380;
             const real_t tmp_kernel_op_384 = -hessian_blending_2_0_0_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_2_1_0_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_2_2_0_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_385 = -hessian_blending_2_0_1_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_2_1_1_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_2_2_1_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_386 = -hessian_blending_2_0_2_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_2_1_2_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_2_2_2_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_387 = jac_blending_inv_0_0_q_4*tmp_kernel_op_384 + jac_blending_inv_0_1_q_4*tmp_kernel_op_385 + jac_blending_inv_0_2_q_4*tmp_kernel_op_386;
             const real_t tmp_kernel_op_388 = jac_blending_inv_1_0_q_4*tmp_kernel_op_384 + jac_blending_inv_1_1_q_4*tmp_kernel_op_385 + jac_blending_inv_1_2_q_4*tmp_kernel_op_386;
             const real_t tmp_kernel_op_389 = jac_blending_inv_2_0_q_4*tmp_kernel_op_384 + jac_blending_inv_2_1_q_4*tmp_kernel_op_385 + jac_blending_inv_2_2_q_4*tmp_kernel_op_386;
             const real_t tmp_kernel_op_390 = -hessian_blending_0_0_0_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_0_1_0_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_0_2_0_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_391 = -hessian_blending_0_0_1_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_0_1_1_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_0_2_1_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_392 = -hessian_blending_0_0_2_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_0_1_2_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_0_2_2_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_393 = jac_blending_inv_0_0_q_4*tmp_kernel_op_390 + jac_blending_inv_0_1_q_4*tmp_kernel_op_391 + jac_blending_inv_0_2_q_4*tmp_kernel_op_392;
             const real_t tmp_kernel_op_394 = jac_blending_inv_1_0_q_4*tmp_kernel_op_390 + jac_blending_inv_1_1_q_4*tmp_kernel_op_391 + jac_blending_inv_1_2_q_4*tmp_kernel_op_392;
             const real_t tmp_kernel_op_395 = jac_blending_inv_2_0_q_4*tmp_kernel_op_390 + jac_blending_inv_2_1_q_4*tmp_kernel_op_391 + jac_blending_inv_2_2_q_4*tmp_kernel_op_392;
             const real_t tmp_kernel_op_396 = -hessian_blending_1_0_0_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_1_1_0_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_1_2_0_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_397 = -hessian_blending_1_0_1_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_1_1_1_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_1_2_1_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_398 = -hessian_blending_1_0_2_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_1_1_2_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_1_2_2_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_399 = jac_blending_inv_0_0_q_4*tmp_kernel_op_396 + jac_blending_inv_0_1_q_4*tmp_kernel_op_397 + jac_blending_inv_0_2_q_4*tmp_kernel_op_398;
             const real_t tmp_kernel_op_400 = jac_blending_inv_1_0_q_4*tmp_kernel_op_396 + jac_blending_inv_1_1_q_4*tmp_kernel_op_397 + jac_blending_inv_1_2_q_4*tmp_kernel_op_398;
             const real_t tmp_kernel_op_401 = jac_blending_inv_2_0_q_4*tmp_kernel_op_396 + jac_blending_inv_2_1_q_4*tmp_kernel_op_397 + jac_blending_inv_2_2_q_4*tmp_kernel_op_398;
             const real_t tmp_kernel_op_402 = -hessian_blending_2_0_0_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_2_1_0_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_2_2_0_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_403 = -hessian_blending_2_0_1_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_2_1_1_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_2_2_1_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_404 = -hessian_blending_2_0_2_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_2_1_2_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_2_2_2_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_405 = jac_blending_inv_0_0_q_4*tmp_kernel_op_402 + jac_blending_inv_0_1_q_4*tmp_kernel_op_403 + jac_blending_inv_0_2_q_4*tmp_kernel_op_404;
             const real_t tmp_kernel_op_406 = jac_blending_inv_1_0_q_4*tmp_kernel_op_402 + jac_blending_inv_1_1_q_4*tmp_kernel_op_403 + jac_blending_inv_1_2_q_4*tmp_kernel_op_404;
             const real_t tmp_kernel_op_407 = jac_blending_inv_2_0_q_4*tmp_kernel_op_402 + jac_blending_inv_2_1_q_4*tmp_kernel_op_403 + jac_blending_inv_2_2_q_4*tmp_kernel_op_404;
             const real_t tmp_kernel_op_408 = -hessian_blending_0_0_0_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_0_1_0_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_0_2_0_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_409 = -hessian_blending_0_0_1_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_0_1_1_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_0_2_1_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_410 = -hessian_blending_0_0_2_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_0_1_2_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_0_2_2_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_411 = jac_blending_inv_0_0_q_4*tmp_kernel_op_408 + jac_blending_inv_0_1_q_4*tmp_kernel_op_409 + jac_blending_inv_0_2_q_4*tmp_kernel_op_410;
             const real_t tmp_kernel_op_412 = jac_blending_inv_1_0_q_4*tmp_kernel_op_408 + jac_blending_inv_1_1_q_4*tmp_kernel_op_409 + jac_blending_inv_1_2_q_4*tmp_kernel_op_410;
             const real_t tmp_kernel_op_413 = jac_blending_inv_2_0_q_4*tmp_kernel_op_408 + jac_blending_inv_2_1_q_4*tmp_kernel_op_409 + jac_blending_inv_2_2_q_4*tmp_kernel_op_410;
             const real_t tmp_kernel_op_414 = -hessian_blending_1_0_0_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_1_1_0_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_1_2_0_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_415 = -hessian_blending_1_0_1_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_1_1_1_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_1_2_1_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_416 = -hessian_blending_1_0_2_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_1_1_2_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_1_2_2_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_417 = jac_blending_inv_0_0_q_4*tmp_kernel_op_414 + jac_blending_inv_0_1_q_4*tmp_kernel_op_415 + jac_blending_inv_0_2_q_4*tmp_kernel_op_416;
             const real_t tmp_kernel_op_418 = jac_blending_inv_1_0_q_4*tmp_kernel_op_414 + jac_blending_inv_1_1_q_4*tmp_kernel_op_415 + jac_blending_inv_1_2_q_4*tmp_kernel_op_416;
             const real_t tmp_kernel_op_419 = jac_blending_inv_2_0_q_4*tmp_kernel_op_414 + jac_blending_inv_2_1_q_4*tmp_kernel_op_415 + jac_blending_inv_2_2_q_4*tmp_kernel_op_416;
             const real_t tmp_kernel_op_420 = -hessian_blending_2_0_0_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_2_1_0_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_2_2_0_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_421 = -hessian_blending_2_0_1_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_2_1_1_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_2_2_1_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_422 = -hessian_blending_2_0_2_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_2_1_2_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_2_2_2_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_423 = jac_blending_inv_0_0_q_4*tmp_kernel_op_420 + jac_blending_inv_0_1_q_4*tmp_kernel_op_421 + jac_blending_inv_0_2_q_4*tmp_kernel_op_422;
             const real_t tmp_kernel_op_424 = jac_blending_inv_1_0_q_4*tmp_kernel_op_420 + jac_blending_inv_1_1_q_4*tmp_kernel_op_421 + jac_blending_inv_1_2_q_4*tmp_kernel_op_422;
             const real_t tmp_kernel_op_425 = jac_blending_inv_2_0_q_4*tmp_kernel_op_420 + jac_blending_inv_2_1_q_4*tmp_kernel_op_421 + jac_blending_inv_2_2_q_4*tmp_kernel_op_422;
             const real_t tmp_kernel_op_426 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_5 + jac_blending_inv_1_0_q_4*tmp_kernel_op_11 + jac_blending_inv_2_0_q_4*tmp_kernel_op_17) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_369*tmp_kernel_op_373 + tmp_kernel_op_374*tmp_kernel_op_375 + tmp_kernel_op_376*tmp_kernel_op_377) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_5 + jac_blending_inv_1_1_q_4*tmp_kernel_op_11 + jac_blending_inv_2_1_q_4*tmp_kernel_op_17) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_369*tmp_kernel_op_381 + tmp_kernel_op_374*tmp_kernel_op_382 + tmp_kernel_op_376*tmp_kernel_op_383) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_5 + jac_blending_inv_1_2_q_4*tmp_kernel_op_11 + jac_blending_inv_2_2_q_4*tmp_kernel_op_17) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_369*tmp_kernel_op_387 + tmp_kernel_op_374*tmp_kernel_op_388 + tmp_kernel_op_376*tmp_kernel_op_389) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_18 + jac_blending_inv_1_0_q_4*tmp_kernel_op_19 + jac_blending_inv_2_0_q_4*tmp_kernel_op_20) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_369*tmp_kernel_op_393 + tmp_kernel_op_374*tmp_kernel_op_394 + tmp_kernel_op_376*tmp_kernel_op_395) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_18 + jac_blending_inv_1_1_q_4*tmp_kernel_op_19 + jac_blending_inv_2_1_q_4*tmp_kernel_op_20) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_369*tmp_kernel_op_399 + tmp_kernel_op_374*tmp_kernel_op_400 + tmp_kernel_op_376*tmp_kernel_op_401) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_18 + jac_blending_inv_1_2_q_4*tmp_kernel_op_19 + jac_blending_inv_2_2_q_4*tmp_kernel_op_20) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_369*tmp_kernel_op_405 + tmp_kernel_op_374*tmp_kernel_op_406 + tmp_kernel_op_376*tmp_kernel_op_407) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_21 + jac_blending_inv_1_0_q_4*tmp_kernel_op_22 + jac_blending_inv_2_0_q_4*tmp_kernel_op_23) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_369*tmp_kernel_op_411 + tmp_kernel_op_374*tmp_kernel_op_412 + tmp_kernel_op_376*tmp_kernel_op_413) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_21 + jac_blending_inv_1_1_q_4*tmp_kernel_op_22 + jac_blending_inv_2_1_q_4*tmp_kernel_op_23) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_369*tmp_kernel_op_417 + tmp_kernel_op_374*tmp_kernel_op_418 + tmp_kernel_op_376*tmp_kernel_op_419) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_21 + jac_blending_inv_1_2_q_4*tmp_kernel_op_22 + jac_blending_inv_2_2_q_4*tmp_kernel_op_23) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_369*tmp_kernel_op_423 + tmp_kernel_op_374*tmp_kernel_op_424 + tmp_kernel_op_376*tmp_kernel_op_425);
             const real_t tmp_kernel_op_444 = tmp_kernel_op_427*wx_dof_4 + tmp_kernel_op_428*wx_dof_5 + tmp_kernel_op_429*wx_dof_6 + tmp_kernel_op_432*wx_dof_1 + tmp_kernel_op_435*wx_dof_2 + tmp_kernel_op_438*wx_dof_3 + tmp_kernel_op_439*wx_dof_7 + tmp_kernel_op_440*wx_dof_8 + tmp_kernel_op_442*wx_dof_9 + tmp_kernel_op_443*wx_dof_0;
             const real_t tmp_kernel_op_445 = tmp_kernel_op_427*wy_dof_4 + tmp_kernel_op_428*wy_dof_5 + tmp_kernel_op_429*wy_dof_6 + tmp_kernel_op_432*wy_dof_1 + tmp_kernel_op_435*wy_dof_2 + tmp_kernel_op_438*wy_dof_3 + tmp_kernel_op_439*wy_dof_7 + tmp_kernel_op_440*wy_dof_8 + tmp_kernel_op_442*wy_dof_9 + tmp_kernel_op_443*wy_dof_0;
             const real_t tmp_kernel_op_446 = tmp_kernel_op_427*wz_dof_4 + tmp_kernel_op_428*wz_dof_5 + tmp_kernel_op_429*wz_dof_6 + tmp_kernel_op_432*wz_dof_1 + tmp_kernel_op_435*wz_dof_2 + tmp_kernel_op_438*wz_dof_3 + tmp_kernel_op_439*wz_dof_7 + tmp_kernel_op_440*wz_dof_8 + tmp_kernel_op_442*wz_dof_9 + tmp_kernel_op_443*wz_dof_0;
             const real_t tmp_kernel_op_447 = abs_det_jac_affine_WHITE_UP*abs_det_jac_blending_q_4*(diffusivity_times_delta_dof_0*tmp_kernel_op_443 + diffusivity_times_delta_dof_1*tmp_kernel_op_432 + diffusivity_times_delta_dof_2*tmp_kernel_op_435 + diffusivity_times_delta_dof_3*tmp_kernel_op_438 + diffusivity_times_delta_dof_4*tmp_kernel_op_427 + diffusivity_times_delta_dof_5*tmp_kernel_op_428 + diffusivity_times_delta_dof_6*tmp_kernel_op_429 + diffusivity_times_delta_dof_7*tmp_kernel_op_439 + diffusivity_times_delta_dof_8*tmp_kernel_op_440 + diffusivity_times_delta_dof_9*tmp_kernel_op_442)*0.074999999999999983;
             const real_t tmp_kernel_op_448 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_kernel_op_369 + jac_blending_inv_1_0_q_4*tmp_kernel_op_374 + jac_blending_inv_2_0_q_4*tmp_kernel_op_376) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_kernel_op_369 + jac_blending_inv_1_1_q_4*tmp_kernel_op_374 + jac_blending_inv_2_1_q_4*tmp_kernel_op_376) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_kernel_op_369 + jac_blending_inv_1_2_q_4*tmp_kernel_op_374 + jac_blending_inv_2_2_q_4*tmp_kernel_op_376));
             const real_t tmp_kernel_op_459 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_451 + jac_blending_inv_1_0_q_0*tmp_kernel_op_449 + jac_blending_inv_2_0_q_0*tmp_kernel_op_450) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_kernel_op_456 + tmp_kernel_op_35*tmp_kernel_op_457 + tmp_kernel_op_37*tmp_kernel_op_458) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_451 + jac_blending_inv_1_1_q_0*tmp_kernel_op_449 + jac_blending_inv_2_1_q_0*tmp_kernel_op_450) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_kernel_op_456 + tmp_kernel_op_42*tmp_kernel_op_457 + tmp_kernel_op_43*tmp_kernel_op_458) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_451 + jac_blending_inv_1_2_q_0*tmp_kernel_op_449 + jac_blending_inv_2_2_q_0*tmp_kernel_op_450) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_456*tmp_kernel_op_47 + tmp_kernel_op_457*tmp_kernel_op_48 + tmp_kernel_op_458*tmp_kernel_op_49) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_449 + jac_blending_inv_1_0_q_0*tmp_kernel_op_453 + jac_blending_inv_2_0_q_0*tmp_kernel_op_452) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_456*tmp_kernel_op_53 + tmp_kernel_op_457*tmp_kernel_op_54 + tmp_kernel_op_458*tmp_kernel_op_55) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_449 + jac_blending_inv_1_1_q_0*tmp_kernel_op_453 + jac_blending_inv_2_1_q_0*tmp_kernel_op_452) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_456*tmp_kernel_op_59 + tmp_kernel_op_457*tmp_kernel_op_60 + tmp_kernel_op_458*tmp_kernel_op_61) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_449 + jac_blending_inv_1_2_q_0*tmp_kernel_op_453 + jac_blending_inv_2_2_q_0*tmp_kernel_op_452) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_456*tmp_kernel_op_65 + tmp_kernel_op_457*tmp_kernel_op_66 + tmp_kernel_op_458*tmp_kernel_op_67) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_450 + jac_blending_inv_1_0_q_0*tmp_kernel_op_452 + jac_blending_inv_2_0_q_0*tmp_kernel_op_454) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_456*tmp_kernel_op_71 + tmp_kernel_op_457*tmp_kernel_op_72 + tmp_kernel_op_458*tmp_kernel_op_73) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_450 + jac_blending_inv_1_1_q_0*tmp_kernel_op_452 + jac_blending_inv_2_1_q_0*tmp_kernel_op_454) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_456*tmp_kernel_op_77 + tmp_kernel_op_457*tmp_kernel_op_78 + tmp_kernel_op_458*tmp_kernel_op_79) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_450 + jac_blending_inv_1_2_q_0*tmp_kernel_op_452 + jac_blending_inv_2_2_q_0*tmp_kernel_op_454) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_456*tmp_kernel_op_83 + tmp_kernel_op_457*tmp_kernel_op_84 + tmp_kernel_op_458*tmp_kernel_op_85);
             const real_t tmp_kernel_op_464 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_451 + jac_blending_inv_1_0_q_1*tmp_kernel_op_449 + jac_blending_inv_2_0_q_1*tmp_kernel_op_450) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_kernel_op_461 + tmp_kernel_op_120*tmp_kernel_op_462 + tmp_kernel_op_122*tmp_kernel_op_463) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_451 + jac_blending_inv_1_1_q_1*tmp_kernel_op_449 + jac_blending_inv_2_1_q_1*tmp_kernel_op_450) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_kernel_op_461 + tmp_kernel_op_127*tmp_kernel_op_462 + tmp_kernel_op_128*tmp_kernel_op_463) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_451 + jac_blending_inv_1_2_q_1*tmp_kernel_op_449 + jac_blending_inv_2_2_q_1*tmp_kernel_op_450) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_kernel_op_461 + tmp_kernel_op_133*tmp_kernel_op_462 + tmp_kernel_op_134*tmp_kernel_op_463) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_449 + jac_blending_inv_1_0_q_1*tmp_kernel_op_453 + jac_blending_inv_2_0_q_1*tmp_kernel_op_452) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_kernel_op_461 + tmp_kernel_op_139*tmp_kernel_op_462 + tmp_kernel_op_140*tmp_kernel_op_463) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_449 + jac_blending_inv_1_1_q_1*tmp_kernel_op_453 + jac_blending_inv_2_1_q_1*tmp_kernel_op_452) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_kernel_op_461 + tmp_kernel_op_145*tmp_kernel_op_462 + tmp_kernel_op_146*tmp_kernel_op_463) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_449 + jac_blending_inv_1_2_q_1*tmp_kernel_op_453 + jac_blending_inv_2_2_q_1*tmp_kernel_op_452) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_kernel_op_461 + tmp_kernel_op_151*tmp_kernel_op_462 + tmp_kernel_op_152*tmp_kernel_op_463) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_450 + jac_blending_inv_1_0_q_1*tmp_kernel_op_452 + jac_blending_inv_2_0_q_1*tmp_kernel_op_454) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_kernel_op_461 + tmp_kernel_op_157*tmp_kernel_op_462 + tmp_kernel_op_158*tmp_kernel_op_463) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_450 + jac_blending_inv_1_1_q_1*tmp_kernel_op_452 + jac_blending_inv_2_1_q_1*tmp_kernel_op_454) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_kernel_op_461 + tmp_kernel_op_163*tmp_kernel_op_462 + tmp_kernel_op_164*tmp_kernel_op_463) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_450 + jac_blending_inv_1_2_q_1*tmp_kernel_op_452 + jac_blending_inv_2_2_q_1*tmp_kernel_op_454) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_kernel_op_461 + tmp_kernel_op_169*tmp_kernel_op_462 + tmp_kernel_op_170*tmp_kernel_op_463);
             const real_t tmp_kernel_op_469 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_451 + jac_blending_inv_1_0_q_2*tmp_kernel_op_449 + jac_blending_inv_2_0_q_2*tmp_kernel_op_450) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_kernel_op_466 + tmp_kernel_op_205*tmp_kernel_op_467 + tmp_kernel_op_207*tmp_kernel_op_468) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_451 + jac_blending_inv_1_1_q_2*tmp_kernel_op_449 + jac_blending_inv_2_1_q_2*tmp_kernel_op_450) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_kernel_op_466 + tmp_kernel_op_212*tmp_kernel_op_467 + tmp_kernel_op_213*tmp_kernel_op_468) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_451 + jac_blending_inv_1_2_q_2*tmp_kernel_op_449 + jac_blending_inv_2_2_q_2*tmp_kernel_op_450) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_kernel_op_466 + tmp_kernel_op_218*tmp_kernel_op_467 + tmp_kernel_op_219*tmp_kernel_op_468) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_449 + jac_blending_inv_1_0_q_2*tmp_kernel_op_453 + jac_blending_inv_2_0_q_2*tmp_kernel_op_452) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_kernel_op_466 + tmp_kernel_op_224*tmp_kernel_op_467 + tmp_kernel_op_225*tmp_kernel_op_468) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_449 + jac_blending_inv_1_1_q_2*tmp_kernel_op_453 + jac_blending_inv_2_1_q_2*tmp_kernel_op_452) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_kernel_op_466 + tmp_kernel_op_230*tmp_kernel_op_467 + tmp_kernel_op_231*tmp_kernel_op_468) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_449 + jac_blending_inv_1_2_q_2*tmp_kernel_op_453 + jac_blending_inv_2_2_q_2*tmp_kernel_op_452) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_kernel_op_466 + tmp_kernel_op_236*tmp_kernel_op_467 + tmp_kernel_op_237*tmp_kernel_op_468) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_450 + jac_blending_inv_1_0_q_2*tmp_kernel_op_452 + jac_blending_inv_2_0_q_2*tmp_kernel_op_454) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_kernel_op_466 + tmp_kernel_op_242*tmp_kernel_op_467 + tmp_kernel_op_243*tmp_kernel_op_468) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_450 + jac_blending_inv_1_1_q_2*tmp_kernel_op_452 + jac_blending_inv_2_1_q_2*tmp_kernel_op_454) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_kernel_op_466 + tmp_kernel_op_248*tmp_kernel_op_467 + tmp_kernel_op_249*tmp_kernel_op_468) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_450 + jac_blending_inv_1_2_q_2*tmp_kernel_op_452 + jac_blending_inv_2_2_q_2*tmp_kernel_op_454) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_kernel_op_466 + tmp_kernel_op_254*tmp_kernel_op_467 + tmp_kernel_op_255*tmp_kernel_op_468);
             const real_t tmp_kernel_op_474 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_451 + jac_blending_inv_1_0_q_3*tmp_kernel_op_449 + jac_blending_inv_2_0_q_3*tmp_kernel_op_450) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_kernel_op_471 + tmp_kernel_op_290*tmp_kernel_op_472 + tmp_kernel_op_292*tmp_kernel_op_473) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_451 + jac_blending_inv_1_1_q_3*tmp_kernel_op_449 + jac_blending_inv_2_1_q_3*tmp_kernel_op_450) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_kernel_op_471 + tmp_kernel_op_297*tmp_kernel_op_472 + tmp_kernel_op_298*tmp_kernel_op_473) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_451 + jac_blending_inv_1_2_q_3*tmp_kernel_op_449 + jac_blending_inv_2_2_q_3*tmp_kernel_op_450) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_kernel_op_471 + tmp_kernel_op_303*tmp_kernel_op_472 + tmp_kernel_op_304*tmp_kernel_op_473) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_449 + jac_blending_inv_1_0_q_3*tmp_kernel_op_453 + jac_blending_inv_2_0_q_3*tmp_kernel_op_452) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_kernel_op_471 + tmp_kernel_op_309*tmp_kernel_op_472 + tmp_kernel_op_310*tmp_kernel_op_473) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_449 + jac_blending_inv_1_1_q_3*tmp_kernel_op_453 + jac_blending_inv_2_1_q_3*tmp_kernel_op_452) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_kernel_op_471 + tmp_kernel_op_315*tmp_kernel_op_472 + tmp_kernel_op_316*tmp_kernel_op_473) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_449 + jac_blending_inv_1_2_q_3*tmp_kernel_op_453 + jac_blending_inv_2_2_q_3*tmp_kernel_op_452) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_kernel_op_471 + tmp_kernel_op_321*tmp_kernel_op_472 + tmp_kernel_op_322*tmp_kernel_op_473) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_450 + jac_blending_inv_1_0_q_3*tmp_kernel_op_452 + jac_blending_inv_2_0_q_3*tmp_kernel_op_454) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_kernel_op_471 + tmp_kernel_op_327*tmp_kernel_op_472 + tmp_kernel_op_328*tmp_kernel_op_473) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_450 + jac_blending_inv_1_1_q_3*tmp_kernel_op_452 + jac_blending_inv_2_1_q_3*tmp_kernel_op_454) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_kernel_op_471 + tmp_kernel_op_333*tmp_kernel_op_472 + tmp_kernel_op_334*tmp_kernel_op_473) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_450 + jac_blending_inv_1_2_q_3*tmp_kernel_op_452 + jac_blending_inv_2_2_q_3*tmp_kernel_op_454) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_kernel_op_471 + tmp_kernel_op_339*tmp_kernel_op_472 + tmp_kernel_op_340*tmp_kernel_op_473);
             const real_t tmp_kernel_op_479 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_451 + jac_blending_inv_1_0_q_4*tmp_kernel_op_449 + jac_blending_inv_2_0_q_4*tmp_kernel_op_450) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_kernel_op_476 + tmp_kernel_op_375*tmp_kernel_op_477 + tmp_kernel_op_377*tmp_kernel_op_478) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_451 + jac_blending_inv_1_1_q_4*tmp_kernel_op_449 + jac_blending_inv_2_1_q_4*tmp_kernel_op_450) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_kernel_op_476 + tmp_kernel_op_382*tmp_kernel_op_477 + tmp_kernel_op_383*tmp_kernel_op_478) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_451 + jac_blending_inv_1_2_q_4*tmp_kernel_op_449 + jac_blending_inv_2_2_q_4*tmp_kernel_op_450) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_kernel_op_476 + tmp_kernel_op_388*tmp_kernel_op_477 + tmp_kernel_op_389*tmp_kernel_op_478) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_449 + jac_blending_inv_1_0_q_4*tmp_kernel_op_453 + jac_blending_inv_2_0_q_4*tmp_kernel_op_452) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_kernel_op_476 + tmp_kernel_op_394*tmp_kernel_op_477 + tmp_kernel_op_395*tmp_kernel_op_478) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_449 + jac_blending_inv_1_1_q_4*tmp_kernel_op_453 + jac_blending_inv_2_1_q_4*tmp_kernel_op_452) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_kernel_op_476 + tmp_kernel_op_400*tmp_kernel_op_477 + tmp_kernel_op_401*tmp_kernel_op_478) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_449 + jac_blending_inv_1_2_q_4*tmp_kernel_op_453 + jac_blending_inv_2_2_q_4*tmp_kernel_op_452) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_kernel_op_476 + tmp_kernel_op_406*tmp_kernel_op_477 + tmp_kernel_op_407*tmp_kernel_op_478) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_450 + jac_blending_inv_1_0_q_4*tmp_kernel_op_452 + jac_blending_inv_2_0_q_4*tmp_kernel_op_454) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_kernel_op_476 + tmp_kernel_op_412*tmp_kernel_op_477 + tmp_kernel_op_413*tmp_kernel_op_478) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_450 + jac_blending_inv_1_1_q_4*tmp_kernel_op_452 + jac_blending_inv_2_1_q_4*tmp_kernel_op_454) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_kernel_op_476 + tmp_kernel_op_418*tmp_kernel_op_477 + tmp_kernel_op_419*tmp_kernel_op_478) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_450 + jac_blending_inv_1_2_q_4*tmp_kernel_op_452 + jac_blending_inv_2_2_q_4*tmp_kernel_op_454) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_kernel_op_476 + tmp_kernel_op_424*tmp_kernel_op_477 + tmp_kernel_op_425*tmp_kernel_op_478);
             const real_t tmp_kernel_op_490 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_482 + jac_blending_inv_1_0_q_0*tmp_kernel_op_480 + jac_blending_inv_2_0_q_0*tmp_kernel_op_481) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_kernel_op_487 + tmp_kernel_op_35*tmp_kernel_op_488 + tmp_kernel_op_37*tmp_kernel_op_489) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_482 + jac_blending_inv_1_1_q_0*tmp_kernel_op_480 + jac_blending_inv_2_1_q_0*tmp_kernel_op_481) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_kernel_op_487 + tmp_kernel_op_42*tmp_kernel_op_488 + tmp_kernel_op_43*tmp_kernel_op_489) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_482 + jac_blending_inv_1_2_q_0*tmp_kernel_op_480 + jac_blending_inv_2_2_q_0*tmp_kernel_op_481) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_kernel_op_487 + tmp_kernel_op_48*tmp_kernel_op_488 + tmp_kernel_op_489*tmp_kernel_op_49) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_480 + jac_blending_inv_1_0_q_0*tmp_kernel_op_484 + jac_blending_inv_2_0_q_0*tmp_kernel_op_483) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_487*tmp_kernel_op_53 + tmp_kernel_op_488*tmp_kernel_op_54 + tmp_kernel_op_489*tmp_kernel_op_55) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_480 + jac_blending_inv_1_1_q_0*tmp_kernel_op_484 + jac_blending_inv_2_1_q_0*tmp_kernel_op_483) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_487*tmp_kernel_op_59 + tmp_kernel_op_488*tmp_kernel_op_60 + tmp_kernel_op_489*tmp_kernel_op_61) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_480 + jac_blending_inv_1_2_q_0*tmp_kernel_op_484 + jac_blending_inv_2_2_q_0*tmp_kernel_op_483) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_487*tmp_kernel_op_65 + tmp_kernel_op_488*tmp_kernel_op_66 + tmp_kernel_op_489*tmp_kernel_op_67) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_481 + jac_blending_inv_1_0_q_0*tmp_kernel_op_483 + jac_blending_inv_2_0_q_0*tmp_kernel_op_485) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_487*tmp_kernel_op_71 + tmp_kernel_op_488*tmp_kernel_op_72 + tmp_kernel_op_489*tmp_kernel_op_73) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_481 + jac_blending_inv_1_1_q_0*tmp_kernel_op_483 + jac_blending_inv_2_1_q_0*tmp_kernel_op_485) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_487*tmp_kernel_op_77 + tmp_kernel_op_488*tmp_kernel_op_78 + tmp_kernel_op_489*tmp_kernel_op_79) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_481 + jac_blending_inv_1_2_q_0*tmp_kernel_op_483 + jac_blending_inv_2_2_q_0*tmp_kernel_op_485) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_487*tmp_kernel_op_83 + tmp_kernel_op_488*tmp_kernel_op_84 + tmp_kernel_op_489*tmp_kernel_op_85);
             const real_t tmp_kernel_op_495 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_482 + jac_blending_inv_1_0_q_1*tmp_kernel_op_480 + jac_blending_inv_2_0_q_1*tmp_kernel_op_481) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_kernel_op_492 + tmp_kernel_op_120*tmp_kernel_op_493 + tmp_kernel_op_122*tmp_kernel_op_494) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_482 + jac_blending_inv_1_1_q_1*tmp_kernel_op_480 + jac_blending_inv_2_1_q_1*tmp_kernel_op_481) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_kernel_op_492 + tmp_kernel_op_127*tmp_kernel_op_493 + tmp_kernel_op_128*tmp_kernel_op_494) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_482 + jac_blending_inv_1_2_q_1*tmp_kernel_op_480 + jac_blending_inv_2_2_q_1*tmp_kernel_op_481) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_kernel_op_492 + tmp_kernel_op_133*tmp_kernel_op_493 + tmp_kernel_op_134*tmp_kernel_op_494) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_480 + jac_blending_inv_1_0_q_1*tmp_kernel_op_484 + jac_blending_inv_2_0_q_1*tmp_kernel_op_483) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_kernel_op_492 + tmp_kernel_op_139*tmp_kernel_op_493 + tmp_kernel_op_140*tmp_kernel_op_494) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_480 + jac_blending_inv_1_1_q_1*tmp_kernel_op_484 + jac_blending_inv_2_1_q_1*tmp_kernel_op_483) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_kernel_op_492 + tmp_kernel_op_145*tmp_kernel_op_493 + tmp_kernel_op_146*tmp_kernel_op_494) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_480 + jac_blending_inv_1_2_q_1*tmp_kernel_op_484 + jac_blending_inv_2_2_q_1*tmp_kernel_op_483) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_kernel_op_492 + tmp_kernel_op_151*tmp_kernel_op_493 + tmp_kernel_op_152*tmp_kernel_op_494) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_481 + jac_blending_inv_1_0_q_1*tmp_kernel_op_483 + jac_blending_inv_2_0_q_1*tmp_kernel_op_485) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_kernel_op_492 + tmp_kernel_op_157*tmp_kernel_op_493 + tmp_kernel_op_158*tmp_kernel_op_494) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_481 + jac_blending_inv_1_1_q_1*tmp_kernel_op_483 + jac_blending_inv_2_1_q_1*tmp_kernel_op_485) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_kernel_op_492 + tmp_kernel_op_163*tmp_kernel_op_493 + tmp_kernel_op_164*tmp_kernel_op_494) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_481 + jac_blending_inv_1_2_q_1*tmp_kernel_op_483 + jac_blending_inv_2_2_q_1*tmp_kernel_op_485) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_kernel_op_492 + tmp_kernel_op_169*tmp_kernel_op_493 + tmp_kernel_op_170*tmp_kernel_op_494);
             const real_t tmp_kernel_op_500 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_482 + jac_blending_inv_1_0_q_2*tmp_kernel_op_480 + jac_blending_inv_2_0_q_2*tmp_kernel_op_481) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_kernel_op_497 + tmp_kernel_op_205*tmp_kernel_op_498 + tmp_kernel_op_207*tmp_kernel_op_499) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_482 + jac_blending_inv_1_1_q_2*tmp_kernel_op_480 + jac_blending_inv_2_1_q_2*tmp_kernel_op_481) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_kernel_op_497 + tmp_kernel_op_212*tmp_kernel_op_498 + tmp_kernel_op_213*tmp_kernel_op_499) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_482 + jac_blending_inv_1_2_q_2*tmp_kernel_op_480 + jac_blending_inv_2_2_q_2*tmp_kernel_op_481) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_kernel_op_497 + tmp_kernel_op_218*tmp_kernel_op_498 + tmp_kernel_op_219*tmp_kernel_op_499) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_480 + jac_blending_inv_1_0_q_2*tmp_kernel_op_484 + jac_blending_inv_2_0_q_2*tmp_kernel_op_483) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_kernel_op_497 + tmp_kernel_op_224*tmp_kernel_op_498 + tmp_kernel_op_225*tmp_kernel_op_499) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_480 + jac_blending_inv_1_1_q_2*tmp_kernel_op_484 + jac_blending_inv_2_1_q_2*tmp_kernel_op_483) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_kernel_op_497 + tmp_kernel_op_230*tmp_kernel_op_498 + tmp_kernel_op_231*tmp_kernel_op_499) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_480 + jac_blending_inv_1_2_q_2*tmp_kernel_op_484 + jac_blending_inv_2_2_q_2*tmp_kernel_op_483) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_kernel_op_497 + tmp_kernel_op_236*tmp_kernel_op_498 + tmp_kernel_op_237*tmp_kernel_op_499) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_481 + jac_blending_inv_1_0_q_2*tmp_kernel_op_483 + jac_blending_inv_2_0_q_2*tmp_kernel_op_485) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_kernel_op_497 + tmp_kernel_op_242*tmp_kernel_op_498 + tmp_kernel_op_243*tmp_kernel_op_499) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_481 + jac_blending_inv_1_1_q_2*tmp_kernel_op_483 + jac_blending_inv_2_1_q_2*tmp_kernel_op_485) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_kernel_op_497 + tmp_kernel_op_248*tmp_kernel_op_498 + tmp_kernel_op_249*tmp_kernel_op_499) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_481 + jac_blending_inv_1_2_q_2*tmp_kernel_op_483 + jac_blending_inv_2_2_q_2*tmp_kernel_op_485) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_kernel_op_497 + tmp_kernel_op_254*tmp_kernel_op_498 + tmp_kernel_op_255*tmp_kernel_op_499);
             const real_t tmp_kernel_op_505 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_482 + jac_blending_inv_1_0_q_3*tmp_kernel_op_480 + jac_blending_inv_2_0_q_3*tmp_kernel_op_481) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_kernel_op_502 + tmp_kernel_op_290*tmp_kernel_op_503 + tmp_kernel_op_292*tmp_kernel_op_504) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_482 + jac_blending_inv_1_1_q_3*tmp_kernel_op_480 + jac_blending_inv_2_1_q_3*tmp_kernel_op_481) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_kernel_op_502 + tmp_kernel_op_297*tmp_kernel_op_503 + tmp_kernel_op_298*tmp_kernel_op_504) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_482 + jac_blending_inv_1_2_q_3*tmp_kernel_op_480 + jac_blending_inv_2_2_q_3*tmp_kernel_op_481) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_kernel_op_502 + tmp_kernel_op_303*tmp_kernel_op_503 + tmp_kernel_op_304*tmp_kernel_op_504) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_480 + jac_blending_inv_1_0_q_3*tmp_kernel_op_484 + jac_blending_inv_2_0_q_3*tmp_kernel_op_483) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_kernel_op_502 + tmp_kernel_op_309*tmp_kernel_op_503 + tmp_kernel_op_310*tmp_kernel_op_504) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_480 + jac_blending_inv_1_1_q_3*tmp_kernel_op_484 + jac_blending_inv_2_1_q_3*tmp_kernel_op_483) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_kernel_op_502 + tmp_kernel_op_315*tmp_kernel_op_503 + tmp_kernel_op_316*tmp_kernel_op_504) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_480 + jac_blending_inv_1_2_q_3*tmp_kernel_op_484 + jac_blending_inv_2_2_q_3*tmp_kernel_op_483) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_kernel_op_502 + tmp_kernel_op_321*tmp_kernel_op_503 + tmp_kernel_op_322*tmp_kernel_op_504) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_481 + jac_blending_inv_1_0_q_3*tmp_kernel_op_483 + jac_blending_inv_2_0_q_3*tmp_kernel_op_485) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_kernel_op_502 + tmp_kernel_op_327*tmp_kernel_op_503 + tmp_kernel_op_328*tmp_kernel_op_504) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_481 + jac_blending_inv_1_1_q_3*tmp_kernel_op_483 + jac_blending_inv_2_1_q_3*tmp_kernel_op_485) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_kernel_op_502 + tmp_kernel_op_333*tmp_kernel_op_503 + tmp_kernel_op_334*tmp_kernel_op_504) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_481 + jac_blending_inv_1_2_q_3*tmp_kernel_op_483 + jac_blending_inv_2_2_q_3*tmp_kernel_op_485) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_kernel_op_502 + tmp_kernel_op_339*tmp_kernel_op_503 + tmp_kernel_op_340*tmp_kernel_op_504);
             const real_t tmp_kernel_op_510 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_482 + jac_blending_inv_1_0_q_4*tmp_kernel_op_480 + jac_blending_inv_2_0_q_4*tmp_kernel_op_481) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_kernel_op_507 + tmp_kernel_op_375*tmp_kernel_op_508 + tmp_kernel_op_377*tmp_kernel_op_509) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_482 + jac_blending_inv_1_1_q_4*tmp_kernel_op_480 + jac_blending_inv_2_1_q_4*tmp_kernel_op_481) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_kernel_op_507 + tmp_kernel_op_382*tmp_kernel_op_508 + tmp_kernel_op_383*tmp_kernel_op_509) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_482 + jac_blending_inv_1_2_q_4*tmp_kernel_op_480 + jac_blending_inv_2_2_q_4*tmp_kernel_op_481) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_kernel_op_507 + tmp_kernel_op_388*tmp_kernel_op_508 + tmp_kernel_op_389*tmp_kernel_op_509) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_480 + jac_blending_inv_1_0_q_4*tmp_kernel_op_484 + jac_blending_inv_2_0_q_4*tmp_kernel_op_483) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_kernel_op_507 + tmp_kernel_op_394*tmp_kernel_op_508 + tmp_kernel_op_395*tmp_kernel_op_509) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_480 + jac_blending_inv_1_1_q_4*tmp_kernel_op_484 + jac_blending_inv_2_1_q_4*tmp_kernel_op_483) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_kernel_op_507 + tmp_kernel_op_400*tmp_kernel_op_508 + tmp_kernel_op_401*tmp_kernel_op_509) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_480 + jac_blending_inv_1_2_q_4*tmp_kernel_op_484 + jac_blending_inv_2_2_q_4*tmp_kernel_op_483) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_kernel_op_507 + tmp_kernel_op_406*tmp_kernel_op_508 + tmp_kernel_op_407*tmp_kernel_op_509) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_481 + jac_blending_inv_1_0_q_4*tmp_kernel_op_483 + jac_blending_inv_2_0_q_4*tmp_kernel_op_485) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_kernel_op_507 + tmp_kernel_op_412*tmp_kernel_op_508 + tmp_kernel_op_413*tmp_kernel_op_509) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_481 + jac_blending_inv_1_1_q_4*tmp_kernel_op_483 + jac_blending_inv_2_1_q_4*tmp_kernel_op_485) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_kernel_op_507 + tmp_kernel_op_418*tmp_kernel_op_508 + tmp_kernel_op_419*tmp_kernel_op_509) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_481 + jac_blending_inv_1_2_q_4*tmp_kernel_op_483 + jac_blending_inv_2_2_q_4*tmp_kernel_op_485) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_kernel_op_507 + tmp_kernel_op_424*tmp_kernel_op_508 + tmp_kernel_op_425*tmp_kernel_op_509);
             const real_t tmp_kernel_op_521 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_513 + jac_blending_inv_1_0_q_0*tmp_kernel_op_511 + jac_blending_inv_2_0_q_0*tmp_kernel_op_512) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_kernel_op_518 + tmp_kernel_op_35*tmp_kernel_op_519 + tmp_kernel_op_37*tmp_kernel_op_520) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_513 + jac_blending_inv_1_1_q_0*tmp_kernel_op_511 + jac_blending_inv_2_1_q_0*tmp_kernel_op_512) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_kernel_op_518 + tmp_kernel_op_42*tmp_kernel_op_519 + tmp_kernel_op_43*tmp_kernel_op_520) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_513 + jac_blending_inv_1_2_q_0*tmp_kernel_op_511 + jac_blending_inv_2_2_q_0*tmp_kernel_op_512) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_kernel_op_518 + tmp_kernel_op_48*tmp_kernel_op_519 + tmp_kernel_op_49*tmp_kernel_op_520) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_511 + jac_blending_inv_1_0_q_0*tmp_kernel_op_515 + jac_blending_inv_2_0_q_0*tmp_kernel_op_514) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_518*tmp_kernel_op_53 + tmp_kernel_op_519*tmp_kernel_op_54 + tmp_kernel_op_520*tmp_kernel_op_55) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_511 + jac_blending_inv_1_1_q_0*tmp_kernel_op_515 + jac_blending_inv_2_1_q_0*tmp_kernel_op_514) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_518*tmp_kernel_op_59 + tmp_kernel_op_519*tmp_kernel_op_60 + tmp_kernel_op_520*tmp_kernel_op_61) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_511 + jac_blending_inv_1_2_q_0*tmp_kernel_op_515 + jac_blending_inv_2_2_q_0*tmp_kernel_op_514) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_518*tmp_kernel_op_65 + tmp_kernel_op_519*tmp_kernel_op_66 + tmp_kernel_op_520*tmp_kernel_op_67) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_512 + jac_blending_inv_1_0_q_0*tmp_kernel_op_514 + jac_blending_inv_2_0_q_0*tmp_kernel_op_516) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_518*tmp_kernel_op_71 + tmp_kernel_op_519*tmp_kernel_op_72 + tmp_kernel_op_520*tmp_kernel_op_73) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_512 + jac_blending_inv_1_1_q_0*tmp_kernel_op_514 + jac_blending_inv_2_1_q_0*tmp_kernel_op_516) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_518*tmp_kernel_op_77 + tmp_kernel_op_519*tmp_kernel_op_78 + tmp_kernel_op_520*tmp_kernel_op_79) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_512 + jac_blending_inv_1_2_q_0*tmp_kernel_op_514 + jac_blending_inv_2_2_q_0*tmp_kernel_op_516) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_518*tmp_kernel_op_83 + tmp_kernel_op_519*tmp_kernel_op_84 + tmp_kernel_op_520*tmp_kernel_op_85);
             const real_t tmp_kernel_op_526 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_513 + jac_blending_inv_1_0_q_1*tmp_kernel_op_511 + jac_blending_inv_2_0_q_1*tmp_kernel_op_512) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_kernel_op_523 + tmp_kernel_op_120*tmp_kernel_op_524 + tmp_kernel_op_122*tmp_kernel_op_525) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_513 + jac_blending_inv_1_1_q_1*tmp_kernel_op_511 + jac_blending_inv_2_1_q_1*tmp_kernel_op_512) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_kernel_op_523 + tmp_kernel_op_127*tmp_kernel_op_524 + tmp_kernel_op_128*tmp_kernel_op_525) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_513 + jac_blending_inv_1_2_q_1*tmp_kernel_op_511 + jac_blending_inv_2_2_q_1*tmp_kernel_op_512) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_kernel_op_523 + tmp_kernel_op_133*tmp_kernel_op_524 + tmp_kernel_op_134*tmp_kernel_op_525) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_511 + jac_blending_inv_1_0_q_1*tmp_kernel_op_515 + jac_blending_inv_2_0_q_1*tmp_kernel_op_514) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_kernel_op_523 + tmp_kernel_op_139*tmp_kernel_op_524 + tmp_kernel_op_140*tmp_kernel_op_525) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_511 + jac_blending_inv_1_1_q_1*tmp_kernel_op_515 + jac_blending_inv_2_1_q_1*tmp_kernel_op_514) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_kernel_op_523 + tmp_kernel_op_145*tmp_kernel_op_524 + tmp_kernel_op_146*tmp_kernel_op_525) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_511 + jac_blending_inv_1_2_q_1*tmp_kernel_op_515 + jac_blending_inv_2_2_q_1*tmp_kernel_op_514) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_kernel_op_523 + tmp_kernel_op_151*tmp_kernel_op_524 + tmp_kernel_op_152*tmp_kernel_op_525) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_512 + jac_blending_inv_1_0_q_1*tmp_kernel_op_514 + jac_blending_inv_2_0_q_1*tmp_kernel_op_516) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_kernel_op_523 + tmp_kernel_op_157*tmp_kernel_op_524 + tmp_kernel_op_158*tmp_kernel_op_525) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_512 + jac_blending_inv_1_1_q_1*tmp_kernel_op_514 + jac_blending_inv_2_1_q_1*tmp_kernel_op_516) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_kernel_op_523 + tmp_kernel_op_163*tmp_kernel_op_524 + tmp_kernel_op_164*tmp_kernel_op_525) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_512 + jac_blending_inv_1_2_q_1*tmp_kernel_op_514 + jac_blending_inv_2_2_q_1*tmp_kernel_op_516) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_kernel_op_523 + tmp_kernel_op_169*tmp_kernel_op_524 + tmp_kernel_op_170*tmp_kernel_op_525);
             const real_t tmp_kernel_op_531 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_513 + jac_blending_inv_1_0_q_2*tmp_kernel_op_511 + jac_blending_inv_2_0_q_2*tmp_kernel_op_512) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_kernel_op_528 + tmp_kernel_op_205*tmp_kernel_op_529 + tmp_kernel_op_207*tmp_kernel_op_530) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_513 + jac_blending_inv_1_1_q_2*tmp_kernel_op_511 + jac_blending_inv_2_1_q_2*tmp_kernel_op_512) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_kernel_op_528 + tmp_kernel_op_212*tmp_kernel_op_529 + tmp_kernel_op_213*tmp_kernel_op_530) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_513 + jac_blending_inv_1_2_q_2*tmp_kernel_op_511 + jac_blending_inv_2_2_q_2*tmp_kernel_op_512) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_kernel_op_528 + tmp_kernel_op_218*tmp_kernel_op_529 + tmp_kernel_op_219*tmp_kernel_op_530) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_511 + jac_blending_inv_1_0_q_2*tmp_kernel_op_515 + jac_blending_inv_2_0_q_2*tmp_kernel_op_514) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_kernel_op_528 + tmp_kernel_op_224*tmp_kernel_op_529 + tmp_kernel_op_225*tmp_kernel_op_530) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_511 + jac_blending_inv_1_1_q_2*tmp_kernel_op_515 + jac_blending_inv_2_1_q_2*tmp_kernel_op_514) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_kernel_op_528 + tmp_kernel_op_230*tmp_kernel_op_529 + tmp_kernel_op_231*tmp_kernel_op_530) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_511 + jac_blending_inv_1_2_q_2*tmp_kernel_op_515 + jac_blending_inv_2_2_q_2*tmp_kernel_op_514) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_kernel_op_528 + tmp_kernel_op_236*tmp_kernel_op_529 + tmp_kernel_op_237*tmp_kernel_op_530) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_512 + jac_blending_inv_1_0_q_2*tmp_kernel_op_514 + jac_blending_inv_2_0_q_2*tmp_kernel_op_516) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_kernel_op_528 + tmp_kernel_op_242*tmp_kernel_op_529 + tmp_kernel_op_243*tmp_kernel_op_530) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_512 + jac_blending_inv_1_1_q_2*tmp_kernel_op_514 + jac_blending_inv_2_1_q_2*tmp_kernel_op_516) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_kernel_op_528 + tmp_kernel_op_248*tmp_kernel_op_529 + tmp_kernel_op_249*tmp_kernel_op_530) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_512 + jac_blending_inv_1_2_q_2*tmp_kernel_op_514 + jac_blending_inv_2_2_q_2*tmp_kernel_op_516) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_kernel_op_528 + tmp_kernel_op_254*tmp_kernel_op_529 + tmp_kernel_op_255*tmp_kernel_op_530);
             const real_t tmp_kernel_op_536 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_513 + jac_blending_inv_1_0_q_3*tmp_kernel_op_511 + jac_blending_inv_2_0_q_3*tmp_kernel_op_512) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_kernel_op_533 + tmp_kernel_op_290*tmp_kernel_op_534 + tmp_kernel_op_292*tmp_kernel_op_535) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_513 + jac_blending_inv_1_1_q_3*tmp_kernel_op_511 + jac_blending_inv_2_1_q_3*tmp_kernel_op_512) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_kernel_op_533 + tmp_kernel_op_297*tmp_kernel_op_534 + tmp_kernel_op_298*tmp_kernel_op_535) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_513 + jac_blending_inv_1_2_q_3*tmp_kernel_op_511 + jac_blending_inv_2_2_q_3*tmp_kernel_op_512) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_kernel_op_533 + tmp_kernel_op_303*tmp_kernel_op_534 + tmp_kernel_op_304*tmp_kernel_op_535) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_511 + jac_blending_inv_1_0_q_3*tmp_kernel_op_515 + jac_blending_inv_2_0_q_3*tmp_kernel_op_514) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_kernel_op_533 + tmp_kernel_op_309*tmp_kernel_op_534 + tmp_kernel_op_310*tmp_kernel_op_535) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_511 + jac_blending_inv_1_1_q_3*tmp_kernel_op_515 + jac_blending_inv_2_1_q_3*tmp_kernel_op_514) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_kernel_op_533 + tmp_kernel_op_315*tmp_kernel_op_534 + tmp_kernel_op_316*tmp_kernel_op_535) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_511 + jac_blending_inv_1_2_q_3*tmp_kernel_op_515 + jac_blending_inv_2_2_q_3*tmp_kernel_op_514) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_kernel_op_533 + tmp_kernel_op_321*tmp_kernel_op_534 + tmp_kernel_op_322*tmp_kernel_op_535) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_512 + jac_blending_inv_1_0_q_3*tmp_kernel_op_514 + jac_blending_inv_2_0_q_3*tmp_kernel_op_516) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_kernel_op_533 + tmp_kernel_op_327*tmp_kernel_op_534 + tmp_kernel_op_328*tmp_kernel_op_535) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_512 + jac_blending_inv_1_1_q_3*tmp_kernel_op_514 + jac_blending_inv_2_1_q_3*tmp_kernel_op_516) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_kernel_op_533 + tmp_kernel_op_333*tmp_kernel_op_534 + tmp_kernel_op_334*tmp_kernel_op_535) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_512 + jac_blending_inv_1_2_q_3*tmp_kernel_op_514 + jac_blending_inv_2_2_q_3*tmp_kernel_op_516) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_kernel_op_533 + tmp_kernel_op_339*tmp_kernel_op_534 + tmp_kernel_op_340*tmp_kernel_op_535);
             const real_t tmp_kernel_op_541 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_513 + jac_blending_inv_1_0_q_4*tmp_kernel_op_511 + jac_blending_inv_2_0_q_4*tmp_kernel_op_512) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_kernel_op_538 + tmp_kernel_op_375*tmp_kernel_op_539 + tmp_kernel_op_377*tmp_kernel_op_540) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_513 + jac_blending_inv_1_1_q_4*tmp_kernel_op_511 + jac_blending_inv_2_1_q_4*tmp_kernel_op_512) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_kernel_op_538 + tmp_kernel_op_382*tmp_kernel_op_539 + tmp_kernel_op_383*tmp_kernel_op_540) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_513 + jac_blending_inv_1_2_q_4*tmp_kernel_op_511 + jac_blending_inv_2_2_q_4*tmp_kernel_op_512) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_kernel_op_538 + tmp_kernel_op_388*tmp_kernel_op_539 + tmp_kernel_op_389*tmp_kernel_op_540) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_511 + jac_blending_inv_1_0_q_4*tmp_kernel_op_515 + jac_blending_inv_2_0_q_4*tmp_kernel_op_514) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_kernel_op_538 + tmp_kernel_op_394*tmp_kernel_op_539 + tmp_kernel_op_395*tmp_kernel_op_540) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_511 + jac_blending_inv_1_1_q_4*tmp_kernel_op_515 + jac_blending_inv_2_1_q_4*tmp_kernel_op_514) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_kernel_op_538 + tmp_kernel_op_400*tmp_kernel_op_539 + tmp_kernel_op_401*tmp_kernel_op_540) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_511 + jac_blending_inv_1_2_q_4*tmp_kernel_op_515 + jac_blending_inv_2_2_q_4*tmp_kernel_op_514) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_kernel_op_538 + tmp_kernel_op_406*tmp_kernel_op_539 + tmp_kernel_op_407*tmp_kernel_op_540) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_512 + jac_blending_inv_1_0_q_4*tmp_kernel_op_514 + jac_blending_inv_2_0_q_4*tmp_kernel_op_516) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_kernel_op_538 + tmp_kernel_op_412*tmp_kernel_op_539 + tmp_kernel_op_413*tmp_kernel_op_540) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_512 + jac_blending_inv_1_1_q_4*tmp_kernel_op_514 + jac_blending_inv_2_1_q_4*tmp_kernel_op_516) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_kernel_op_538 + tmp_kernel_op_418*tmp_kernel_op_539 + tmp_kernel_op_419*tmp_kernel_op_540) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_512 + jac_blending_inv_1_2_q_4*tmp_kernel_op_514 + jac_blending_inv_2_2_q_4*tmp_kernel_op_516) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_kernel_op_538 + tmp_kernel_op_424*tmp_kernel_op_539 + tmp_kernel_op_425*tmp_kernel_op_540);
             const real_t tmp_kernel_op_566 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_543 + jac_blending_inv_1_0_q_0*tmp_kernel_op_546 + jac_blending_inv_2_0_q_0*tmp_kernel_op_549) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_kernel_op_559 + tmp_kernel_op_35*tmp_kernel_op_562 + tmp_kernel_op_37*tmp_kernel_op_565) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_543 + jac_blending_inv_1_1_q_0*tmp_kernel_op_546 + jac_blending_inv_2_1_q_0*tmp_kernel_op_549) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_kernel_op_559 + tmp_kernel_op_42*tmp_kernel_op_562 + tmp_kernel_op_43*tmp_kernel_op_565) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_543 + jac_blending_inv_1_2_q_0*tmp_kernel_op_546 + jac_blending_inv_2_2_q_0*tmp_kernel_op_549) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_kernel_op_559 + tmp_kernel_op_48*tmp_kernel_op_562 + tmp_kernel_op_49*tmp_kernel_op_565) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_546 + jac_blending_inv_1_0_q_0*tmp_kernel_op_551 + jac_blending_inv_2_0_q_0*tmp_kernel_op_554) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_kernel_op_559 + tmp_kernel_op_54*tmp_kernel_op_562 + tmp_kernel_op_55*tmp_kernel_op_565) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_546 + jac_blending_inv_1_1_q_0*tmp_kernel_op_551 + jac_blending_inv_2_1_q_0*tmp_kernel_op_554) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_559*tmp_kernel_op_59 + tmp_kernel_op_562*tmp_kernel_op_60 + tmp_kernel_op_565*tmp_kernel_op_61) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_546 + jac_blending_inv_1_2_q_0*tmp_kernel_op_551 + jac_blending_inv_2_2_q_0*tmp_kernel_op_554) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_559*tmp_kernel_op_65 + tmp_kernel_op_562*tmp_kernel_op_66 + tmp_kernel_op_565*tmp_kernel_op_67) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_549 + jac_blending_inv_1_0_q_0*tmp_kernel_op_554 + jac_blending_inv_2_0_q_0*tmp_kernel_op_556) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_559*tmp_kernel_op_71 + tmp_kernel_op_562*tmp_kernel_op_72 + tmp_kernel_op_565*tmp_kernel_op_73) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_549 + jac_blending_inv_1_1_q_0*tmp_kernel_op_554 + jac_blending_inv_2_1_q_0*tmp_kernel_op_556) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_559*tmp_kernel_op_77 + tmp_kernel_op_562*tmp_kernel_op_78 + tmp_kernel_op_565*tmp_kernel_op_79) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_549 + jac_blending_inv_1_2_q_0*tmp_kernel_op_554 + jac_blending_inv_2_2_q_0*tmp_kernel_op_556) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_559*tmp_kernel_op_83 + tmp_kernel_op_562*tmp_kernel_op_84 + tmp_kernel_op_565*tmp_kernel_op_85);
             const real_t tmp_kernel_op_576 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_543 + jac_blending_inv_1_0_q_1*tmp_kernel_op_546 + jac_blending_inv_2_0_q_1*tmp_kernel_op_549) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_kernel_op_569 + tmp_kernel_op_120*tmp_kernel_op_572 + tmp_kernel_op_122*tmp_kernel_op_575) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_543 + jac_blending_inv_1_1_q_1*tmp_kernel_op_546 + jac_blending_inv_2_1_q_1*tmp_kernel_op_549) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_kernel_op_569 + tmp_kernel_op_127*tmp_kernel_op_572 + tmp_kernel_op_128*tmp_kernel_op_575) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_543 + jac_blending_inv_1_2_q_1*tmp_kernel_op_546 + jac_blending_inv_2_2_q_1*tmp_kernel_op_549) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_kernel_op_569 + tmp_kernel_op_133*tmp_kernel_op_572 + tmp_kernel_op_134*tmp_kernel_op_575) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_546 + jac_blending_inv_1_0_q_1*tmp_kernel_op_551 + jac_blending_inv_2_0_q_1*tmp_kernel_op_554) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_kernel_op_569 + tmp_kernel_op_139*tmp_kernel_op_572 + tmp_kernel_op_140*tmp_kernel_op_575) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_546 + jac_blending_inv_1_1_q_1*tmp_kernel_op_551 + jac_blending_inv_2_1_q_1*tmp_kernel_op_554) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_kernel_op_569 + tmp_kernel_op_145*tmp_kernel_op_572 + tmp_kernel_op_146*tmp_kernel_op_575) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_546 + jac_blending_inv_1_2_q_1*tmp_kernel_op_551 + jac_blending_inv_2_2_q_1*tmp_kernel_op_554) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_kernel_op_569 + tmp_kernel_op_151*tmp_kernel_op_572 + tmp_kernel_op_152*tmp_kernel_op_575) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_549 + jac_blending_inv_1_0_q_1*tmp_kernel_op_554 + jac_blending_inv_2_0_q_1*tmp_kernel_op_556) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_kernel_op_569 + tmp_kernel_op_157*tmp_kernel_op_572 + tmp_kernel_op_158*tmp_kernel_op_575) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_549 + jac_blending_inv_1_1_q_1*tmp_kernel_op_554 + jac_blending_inv_2_1_q_1*tmp_kernel_op_556) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_kernel_op_569 + tmp_kernel_op_163*tmp_kernel_op_572 + tmp_kernel_op_164*tmp_kernel_op_575) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_549 + jac_blending_inv_1_2_q_1*tmp_kernel_op_554 + jac_blending_inv_2_2_q_1*tmp_kernel_op_556) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_kernel_op_569 + tmp_kernel_op_169*tmp_kernel_op_572 + tmp_kernel_op_170*tmp_kernel_op_575);
             const real_t tmp_kernel_op_586 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_543 + jac_blending_inv_1_0_q_2*tmp_kernel_op_546 + jac_blending_inv_2_0_q_2*tmp_kernel_op_549) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_kernel_op_579 + tmp_kernel_op_205*tmp_kernel_op_582 + tmp_kernel_op_207*tmp_kernel_op_585) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_543 + jac_blending_inv_1_1_q_2*tmp_kernel_op_546 + jac_blending_inv_2_1_q_2*tmp_kernel_op_549) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_kernel_op_579 + tmp_kernel_op_212*tmp_kernel_op_582 + tmp_kernel_op_213*tmp_kernel_op_585) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_543 + jac_blending_inv_1_2_q_2*tmp_kernel_op_546 + jac_blending_inv_2_2_q_2*tmp_kernel_op_549) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_kernel_op_579 + tmp_kernel_op_218*tmp_kernel_op_582 + tmp_kernel_op_219*tmp_kernel_op_585) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_546 + jac_blending_inv_1_0_q_2*tmp_kernel_op_551 + jac_blending_inv_2_0_q_2*tmp_kernel_op_554) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_kernel_op_579 + tmp_kernel_op_224*tmp_kernel_op_582 + tmp_kernel_op_225*tmp_kernel_op_585) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_546 + jac_blending_inv_1_1_q_2*tmp_kernel_op_551 + jac_blending_inv_2_1_q_2*tmp_kernel_op_554) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_kernel_op_579 + tmp_kernel_op_230*tmp_kernel_op_582 + tmp_kernel_op_231*tmp_kernel_op_585) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_546 + jac_blending_inv_1_2_q_2*tmp_kernel_op_551 + jac_blending_inv_2_2_q_2*tmp_kernel_op_554) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_kernel_op_579 + tmp_kernel_op_236*tmp_kernel_op_582 + tmp_kernel_op_237*tmp_kernel_op_585) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_549 + jac_blending_inv_1_0_q_2*tmp_kernel_op_554 + jac_blending_inv_2_0_q_2*tmp_kernel_op_556) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_kernel_op_579 + tmp_kernel_op_242*tmp_kernel_op_582 + tmp_kernel_op_243*tmp_kernel_op_585) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_549 + jac_blending_inv_1_1_q_2*tmp_kernel_op_554 + jac_blending_inv_2_1_q_2*tmp_kernel_op_556) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_kernel_op_579 + tmp_kernel_op_248*tmp_kernel_op_582 + tmp_kernel_op_249*tmp_kernel_op_585) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_549 + jac_blending_inv_1_2_q_2*tmp_kernel_op_554 + jac_blending_inv_2_2_q_2*tmp_kernel_op_556) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_kernel_op_579 + tmp_kernel_op_254*tmp_kernel_op_582 + tmp_kernel_op_255*tmp_kernel_op_585);
             const real_t tmp_kernel_op_596 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_543 + jac_blending_inv_1_0_q_3*tmp_kernel_op_546 + jac_blending_inv_2_0_q_3*tmp_kernel_op_549) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_kernel_op_589 + tmp_kernel_op_290*tmp_kernel_op_592 + tmp_kernel_op_292*tmp_kernel_op_595) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_543 + jac_blending_inv_1_1_q_3*tmp_kernel_op_546 + jac_blending_inv_2_1_q_3*tmp_kernel_op_549) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_kernel_op_589 + tmp_kernel_op_297*tmp_kernel_op_592 + tmp_kernel_op_298*tmp_kernel_op_595) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_543 + jac_blending_inv_1_2_q_3*tmp_kernel_op_546 + jac_blending_inv_2_2_q_3*tmp_kernel_op_549) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_kernel_op_589 + tmp_kernel_op_303*tmp_kernel_op_592 + tmp_kernel_op_304*tmp_kernel_op_595) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_546 + jac_blending_inv_1_0_q_3*tmp_kernel_op_551 + jac_blending_inv_2_0_q_3*tmp_kernel_op_554) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_kernel_op_589 + tmp_kernel_op_309*tmp_kernel_op_592 + tmp_kernel_op_310*tmp_kernel_op_595) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_546 + jac_blending_inv_1_1_q_3*tmp_kernel_op_551 + jac_blending_inv_2_1_q_3*tmp_kernel_op_554) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_kernel_op_589 + tmp_kernel_op_315*tmp_kernel_op_592 + tmp_kernel_op_316*tmp_kernel_op_595) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_546 + jac_blending_inv_1_2_q_3*tmp_kernel_op_551 + jac_blending_inv_2_2_q_3*tmp_kernel_op_554) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_kernel_op_589 + tmp_kernel_op_321*tmp_kernel_op_592 + tmp_kernel_op_322*tmp_kernel_op_595) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_549 + jac_blending_inv_1_0_q_3*tmp_kernel_op_554 + jac_blending_inv_2_0_q_3*tmp_kernel_op_556) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_kernel_op_589 + tmp_kernel_op_327*tmp_kernel_op_592 + tmp_kernel_op_328*tmp_kernel_op_595) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_549 + jac_blending_inv_1_1_q_3*tmp_kernel_op_554 + jac_blending_inv_2_1_q_3*tmp_kernel_op_556) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_kernel_op_589 + tmp_kernel_op_333*tmp_kernel_op_592 + tmp_kernel_op_334*tmp_kernel_op_595) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_549 + jac_blending_inv_1_2_q_3*tmp_kernel_op_554 + jac_blending_inv_2_2_q_3*tmp_kernel_op_556) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_kernel_op_589 + tmp_kernel_op_339*tmp_kernel_op_592 + tmp_kernel_op_340*tmp_kernel_op_595);
             const real_t tmp_kernel_op_606 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_543 + jac_blending_inv_1_0_q_4*tmp_kernel_op_546 + jac_blending_inv_2_0_q_4*tmp_kernel_op_549) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_kernel_op_599 + tmp_kernel_op_375*tmp_kernel_op_602 + tmp_kernel_op_377*tmp_kernel_op_605) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_543 + jac_blending_inv_1_1_q_4*tmp_kernel_op_546 + jac_blending_inv_2_1_q_4*tmp_kernel_op_549) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_kernel_op_599 + tmp_kernel_op_382*tmp_kernel_op_602 + tmp_kernel_op_383*tmp_kernel_op_605) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_543 + jac_blending_inv_1_2_q_4*tmp_kernel_op_546 + jac_blending_inv_2_2_q_4*tmp_kernel_op_549) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_kernel_op_599 + tmp_kernel_op_388*tmp_kernel_op_602 + tmp_kernel_op_389*tmp_kernel_op_605) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_546 + jac_blending_inv_1_0_q_4*tmp_kernel_op_551 + jac_blending_inv_2_0_q_4*tmp_kernel_op_554) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_kernel_op_599 + tmp_kernel_op_394*tmp_kernel_op_602 + tmp_kernel_op_395*tmp_kernel_op_605) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_546 + jac_blending_inv_1_1_q_4*tmp_kernel_op_551 + jac_blending_inv_2_1_q_4*tmp_kernel_op_554) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_kernel_op_599 + tmp_kernel_op_400*tmp_kernel_op_602 + tmp_kernel_op_401*tmp_kernel_op_605) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_546 + jac_blending_inv_1_2_q_4*tmp_kernel_op_551 + jac_blending_inv_2_2_q_4*tmp_kernel_op_554) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_kernel_op_599 + tmp_kernel_op_406*tmp_kernel_op_602 + tmp_kernel_op_407*tmp_kernel_op_605) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_549 + jac_blending_inv_1_0_q_4*tmp_kernel_op_554 + jac_blending_inv_2_0_q_4*tmp_kernel_op_556) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_kernel_op_599 + tmp_kernel_op_412*tmp_kernel_op_602 + tmp_kernel_op_413*tmp_kernel_op_605) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_549 + jac_blending_inv_1_1_q_4*tmp_kernel_op_554 + jac_blending_inv_2_1_q_4*tmp_kernel_op_556) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_kernel_op_599 + tmp_kernel_op_418*tmp_kernel_op_602 + tmp_kernel_op_419*tmp_kernel_op_605) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_549 + jac_blending_inv_1_2_q_4*tmp_kernel_op_554 + jac_blending_inv_2_2_q_4*tmp_kernel_op_556) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_kernel_op_599 + tmp_kernel_op_424*tmp_kernel_op_602 + tmp_kernel_op_425*tmp_kernel_op_605);
             const real_t tmp_kernel_op_628 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_607 + jac_blending_inv_1_0_q_0*tmp_kernel_op_610 + jac_blending_inv_2_0_q_0*tmp_kernel_op_613) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_kernel_op_621 + tmp_kernel_op_35*tmp_kernel_op_624 + tmp_kernel_op_37*tmp_kernel_op_627) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_607 + jac_blending_inv_1_1_q_0*tmp_kernel_op_610 + jac_blending_inv_2_1_q_0*tmp_kernel_op_613) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_kernel_op_621 + tmp_kernel_op_42*tmp_kernel_op_624 + tmp_kernel_op_43*tmp_kernel_op_627) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_607 + jac_blending_inv_1_2_q_0*tmp_kernel_op_610 + jac_blending_inv_2_2_q_0*tmp_kernel_op_613) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_kernel_op_621 + tmp_kernel_op_48*tmp_kernel_op_624 + tmp_kernel_op_49*tmp_kernel_op_627) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_610 + jac_blending_inv_1_0_q_0*tmp_kernel_op_614 + jac_blending_inv_2_0_q_0*tmp_kernel_op_617) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_kernel_op_621 + tmp_kernel_op_54*tmp_kernel_op_624 + tmp_kernel_op_55*tmp_kernel_op_627) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_610 + jac_blending_inv_1_1_q_0*tmp_kernel_op_614 + jac_blending_inv_2_1_q_0*tmp_kernel_op_617) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_kernel_op_621 + tmp_kernel_op_60*tmp_kernel_op_624 + tmp_kernel_op_61*tmp_kernel_op_627) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_610 + jac_blending_inv_1_2_q_0*tmp_kernel_op_614 + jac_blending_inv_2_2_q_0*tmp_kernel_op_617) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_621*tmp_kernel_op_65 + tmp_kernel_op_624*tmp_kernel_op_66 + tmp_kernel_op_627*tmp_kernel_op_67) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_613 + jac_blending_inv_1_0_q_0*tmp_kernel_op_617 + jac_blending_inv_2_0_q_0*tmp_kernel_op_618) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_621*tmp_kernel_op_71 + tmp_kernel_op_624*tmp_kernel_op_72 + tmp_kernel_op_627*tmp_kernel_op_73) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_613 + jac_blending_inv_1_1_q_0*tmp_kernel_op_617 + jac_blending_inv_2_1_q_0*tmp_kernel_op_618) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_621*tmp_kernel_op_77 + tmp_kernel_op_624*tmp_kernel_op_78 + tmp_kernel_op_627*tmp_kernel_op_79) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_613 + jac_blending_inv_1_2_q_0*tmp_kernel_op_617 + jac_blending_inv_2_2_q_0*tmp_kernel_op_618) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_621*tmp_kernel_op_83 + tmp_kernel_op_624*tmp_kernel_op_84 + tmp_kernel_op_627*tmp_kernel_op_85);
             const real_t tmp_kernel_op_638 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_607 + jac_blending_inv_1_0_q_1*tmp_kernel_op_610 + jac_blending_inv_2_0_q_1*tmp_kernel_op_613) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_kernel_op_631 + tmp_kernel_op_120*tmp_kernel_op_634 + tmp_kernel_op_122*tmp_kernel_op_637) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_607 + jac_blending_inv_1_1_q_1*tmp_kernel_op_610 + jac_blending_inv_2_1_q_1*tmp_kernel_op_613) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_kernel_op_631 + tmp_kernel_op_127*tmp_kernel_op_634 + tmp_kernel_op_128*tmp_kernel_op_637) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_607 + jac_blending_inv_1_2_q_1*tmp_kernel_op_610 + jac_blending_inv_2_2_q_1*tmp_kernel_op_613) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_kernel_op_631 + tmp_kernel_op_133*tmp_kernel_op_634 + tmp_kernel_op_134*tmp_kernel_op_637) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_610 + jac_blending_inv_1_0_q_1*tmp_kernel_op_614 + jac_blending_inv_2_0_q_1*tmp_kernel_op_617) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_kernel_op_631 + tmp_kernel_op_139*tmp_kernel_op_634 + tmp_kernel_op_140*tmp_kernel_op_637) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_610 + jac_blending_inv_1_1_q_1*tmp_kernel_op_614 + jac_blending_inv_2_1_q_1*tmp_kernel_op_617) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_kernel_op_631 + tmp_kernel_op_145*tmp_kernel_op_634 + tmp_kernel_op_146*tmp_kernel_op_637) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_610 + jac_blending_inv_1_2_q_1*tmp_kernel_op_614 + jac_blending_inv_2_2_q_1*tmp_kernel_op_617) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_kernel_op_631 + tmp_kernel_op_151*tmp_kernel_op_634 + tmp_kernel_op_152*tmp_kernel_op_637) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_613 + jac_blending_inv_1_0_q_1*tmp_kernel_op_617 + jac_blending_inv_2_0_q_1*tmp_kernel_op_618) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_kernel_op_631 + tmp_kernel_op_157*tmp_kernel_op_634 + tmp_kernel_op_158*tmp_kernel_op_637) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_613 + jac_blending_inv_1_1_q_1*tmp_kernel_op_617 + jac_blending_inv_2_1_q_1*tmp_kernel_op_618) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_kernel_op_631 + tmp_kernel_op_163*tmp_kernel_op_634 + tmp_kernel_op_164*tmp_kernel_op_637) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_613 + jac_blending_inv_1_2_q_1*tmp_kernel_op_617 + jac_blending_inv_2_2_q_1*tmp_kernel_op_618) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_kernel_op_631 + tmp_kernel_op_169*tmp_kernel_op_634 + tmp_kernel_op_170*tmp_kernel_op_637);
             const real_t tmp_kernel_op_648 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_607 + jac_blending_inv_1_0_q_2*tmp_kernel_op_610 + jac_blending_inv_2_0_q_2*tmp_kernel_op_613) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_kernel_op_641 + tmp_kernel_op_205*tmp_kernel_op_644 + tmp_kernel_op_207*tmp_kernel_op_647) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_607 + jac_blending_inv_1_1_q_2*tmp_kernel_op_610 + jac_blending_inv_2_1_q_2*tmp_kernel_op_613) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_kernel_op_641 + tmp_kernel_op_212*tmp_kernel_op_644 + tmp_kernel_op_213*tmp_kernel_op_647) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_607 + jac_blending_inv_1_2_q_2*tmp_kernel_op_610 + jac_blending_inv_2_2_q_2*tmp_kernel_op_613) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_kernel_op_641 + tmp_kernel_op_218*tmp_kernel_op_644 + tmp_kernel_op_219*tmp_kernel_op_647) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_610 + jac_blending_inv_1_0_q_2*tmp_kernel_op_614 + jac_blending_inv_2_0_q_2*tmp_kernel_op_617) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_kernel_op_641 + tmp_kernel_op_224*tmp_kernel_op_644 + tmp_kernel_op_225*tmp_kernel_op_647) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_610 + jac_blending_inv_1_1_q_2*tmp_kernel_op_614 + jac_blending_inv_2_1_q_2*tmp_kernel_op_617) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_kernel_op_641 + tmp_kernel_op_230*tmp_kernel_op_644 + tmp_kernel_op_231*tmp_kernel_op_647) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_610 + jac_blending_inv_1_2_q_2*tmp_kernel_op_614 + jac_blending_inv_2_2_q_2*tmp_kernel_op_617) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_kernel_op_641 + tmp_kernel_op_236*tmp_kernel_op_644 + tmp_kernel_op_237*tmp_kernel_op_647) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_613 + jac_blending_inv_1_0_q_2*tmp_kernel_op_617 + jac_blending_inv_2_0_q_2*tmp_kernel_op_618) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_kernel_op_641 + tmp_kernel_op_242*tmp_kernel_op_644 + tmp_kernel_op_243*tmp_kernel_op_647) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_613 + jac_blending_inv_1_1_q_2*tmp_kernel_op_617 + jac_blending_inv_2_1_q_2*tmp_kernel_op_618) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_kernel_op_641 + tmp_kernel_op_248*tmp_kernel_op_644 + tmp_kernel_op_249*tmp_kernel_op_647) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_613 + jac_blending_inv_1_2_q_2*tmp_kernel_op_617 + jac_blending_inv_2_2_q_2*tmp_kernel_op_618) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_kernel_op_641 + tmp_kernel_op_254*tmp_kernel_op_644 + tmp_kernel_op_255*tmp_kernel_op_647);
             const real_t tmp_kernel_op_658 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_607 + jac_blending_inv_1_0_q_3*tmp_kernel_op_610 + jac_blending_inv_2_0_q_3*tmp_kernel_op_613) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_kernel_op_651 + tmp_kernel_op_290*tmp_kernel_op_654 + tmp_kernel_op_292*tmp_kernel_op_657) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_607 + jac_blending_inv_1_1_q_3*tmp_kernel_op_610 + jac_blending_inv_2_1_q_3*tmp_kernel_op_613) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_kernel_op_651 + tmp_kernel_op_297*tmp_kernel_op_654 + tmp_kernel_op_298*tmp_kernel_op_657) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_607 + jac_blending_inv_1_2_q_3*tmp_kernel_op_610 + jac_blending_inv_2_2_q_3*tmp_kernel_op_613) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_kernel_op_651 + tmp_kernel_op_303*tmp_kernel_op_654 + tmp_kernel_op_304*tmp_kernel_op_657) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_610 + jac_blending_inv_1_0_q_3*tmp_kernel_op_614 + jac_blending_inv_2_0_q_3*tmp_kernel_op_617) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_kernel_op_651 + tmp_kernel_op_309*tmp_kernel_op_654 + tmp_kernel_op_310*tmp_kernel_op_657) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_610 + jac_blending_inv_1_1_q_3*tmp_kernel_op_614 + jac_blending_inv_2_1_q_3*tmp_kernel_op_617) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_kernel_op_651 + tmp_kernel_op_315*tmp_kernel_op_654 + tmp_kernel_op_316*tmp_kernel_op_657) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_610 + jac_blending_inv_1_2_q_3*tmp_kernel_op_614 + jac_blending_inv_2_2_q_3*tmp_kernel_op_617) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_kernel_op_651 + tmp_kernel_op_321*tmp_kernel_op_654 + tmp_kernel_op_322*tmp_kernel_op_657) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_613 + jac_blending_inv_1_0_q_3*tmp_kernel_op_617 + jac_blending_inv_2_0_q_3*tmp_kernel_op_618) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_kernel_op_651 + tmp_kernel_op_327*tmp_kernel_op_654 + tmp_kernel_op_328*tmp_kernel_op_657) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_613 + jac_blending_inv_1_1_q_3*tmp_kernel_op_617 + jac_blending_inv_2_1_q_3*tmp_kernel_op_618) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_kernel_op_651 + tmp_kernel_op_333*tmp_kernel_op_654 + tmp_kernel_op_334*tmp_kernel_op_657) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_613 + jac_blending_inv_1_2_q_3*tmp_kernel_op_617 + jac_blending_inv_2_2_q_3*tmp_kernel_op_618) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_kernel_op_651 + tmp_kernel_op_339*tmp_kernel_op_654 + tmp_kernel_op_340*tmp_kernel_op_657);
             const real_t tmp_kernel_op_668 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_607 + jac_blending_inv_1_0_q_4*tmp_kernel_op_610 + jac_blending_inv_2_0_q_4*tmp_kernel_op_613) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_kernel_op_661 + tmp_kernel_op_375*tmp_kernel_op_664 + tmp_kernel_op_377*tmp_kernel_op_667) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_607 + jac_blending_inv_1_1_q_4*tmp_kernel_op_610 + jac_blending_inv_2_1_q_4*tmp_kernel_op_613) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_kernel_op_661 + tmp_kernel_op_382*tmp_kernel_op_664 + tmp_kernel_op_383*tmp_kernel_op_667) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_607 + jac_blending_inv_1_2_q_4*tmp_kernel_op_610 + jac_blending_inv_2_2_q_4*tmp_kernel_op_613) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_kernel_op_661 + tmp_kernel_op_388*tmp_kernel_op_664 + tmp_kernel_op_389*tmp_kernel_op_667) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_610 + jac_blending_inv_1_0_q_4*tmp_kernel_op_614 + jac_blending_inv_2_0_q_4*tmp_kernel_op_617) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_kernel_op_661 + tmp_kernel_op_394*tmp_kernel_op_664 + tmp_kernel_op_395*tmp_kernel_op_667) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_610 + jac_blending_inv_1_1_q_4*tmp_kernel_op_614 + jac_blending_inv_2_1_q_4*tmp_kernel_op_617) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_kernel_op_661 + tmp_kernel_op_400*tmp_kernel_op_664 + tmp_kernel_op_401*tmp_kernel_op_667) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_610 + jac_blending_inv_1_2_q_4*tmp_kernel_op_614 + jac_blending_inv_2_2_q_4*tmp_kernel_op_617) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_kernel_op_661 + tmp_kernel_op_406*tmp_kernel_op_664 + tmp_kernel_op_407*tmp_kernel_op_667) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_613 + jac_blending_inv_1_0_q_4*tmp_kernel_op_617 + jac_blending_inv_2_0_q_4*tmp_kernel_op_618) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_kernel_op_661 + tmp_kernel_op_412*tmp_kernel_op_664 + tmp_kernel_op_413*tmp_kernel_op_667) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_613 + jac_blending_inv_1_1_q_4*tmp_kernel_op_617 + jac_blending_inv_2_1_q_4*tmp_kernel_op_618) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_kernel_op_661 + tmp_kernel_op_418*tmp_kernel_op_664 + tmp_kernel_op_419*tmp_kernel_op_667) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_613 + jac_blending_inv_1_2_q_4*tmp_kernel_op_617 + jac_blending_inv_2_2_q_4*tmp_kernel_op_618) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_kernel_op_661 + tmp_kernel_op_424*tmp_kernel_op_664 + tmp_kernel_op_425*tmp_kernel_op_667);
             const real_t tmp_kernel_op_693 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_670 + jac_blending_inv_1_0_q_0*tmp_kernel_op_673 + jac_blending_inv_2_0_q_0*tmp_kernel_op_676) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_kernel_op_686 + tmp_kernel_op_35*tmp_kernel_op_689 + tmp_kernel_op_37*tmp_kernel_op_692) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_670 + jac_blending_inv_1_1_q_0*tmp_kernel_op_673 + jac_blending_inv_2_1_q_0*tmp_kernel_op_676) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_kernel_op_686 + tmp_kernel_op_42*tmp_kernel_op_689 + tmp_kernel_op_43*tmp_kernel_op_692) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_670 + jac_blending_inv_1_2_q_0*tmp_kernel_op_673 + jac_blending_inv_2_2_q_0*tmp_kernel_op_676) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_kernel_op_686 + tmp_kernel_op_48*tmp_kernel_op_689 + tmp_kernel_op_49*tmp_kernel_op_692) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_673 + jac_blending_inv_1_0_q_0*tmp_kernel_op_678 + jac_blending_inv_2_0_q_0*tmp_kernel_op_681) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_kernel_op_686 + tmp_kernel_op_54*tmp_kernel_op_689 + tmp_kernel_op_55*tmp_kernel_op_692) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_673 + jac_blending_inv_1_1_q_0*tmp_kernel_op_678 + jac_blending_inv_2_1_q_0*tmp_kernel_op_681) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_kernel_op_686 + tmp_kernel_op_60*tmp_kernel_op_689 + tmp_kernel_op_61*tmp_kernel_op_692) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_673 + jac_blending_inv_1_2_q_0*tmp_kernel_op_678 + jac_blending_inv_2_2_q_0*tmp_kernel_op_681) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_kernel_op_686 + tmp_kernel_op_66*tmp_kernel_op_689 + tmp_kernel_op_67*tmp_kernel_op_692) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_676 + jac_blending_inv_1_0_q_0*tmp_kernel_op_681 + jac_blending_inv_2_0_q_0*tmp_kernel_op_683) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_686*tmp_kernel_op_71 + tmp_kernel_op_689*tmp_kernel_op_72 + tmp_kernel_op_692*tmp_kernel_op_73) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_676 + jac_blending_inv_1_1_q_0*tmp_kernel_op_681 + jac_blending_inv_2_1_q_0*tmp_kernel_op_683) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_686*tmp_kernel_op_77 + tmp_kernel_op_689*tmp_kernel_op_78 + tmp_kernel_op_692*tmp_kernel_op_79) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_676 + jac_blending_inv_1_2_q_0*tmp_kernel_op_681 + jac_blending_inv_2_2_q_0*tmp_kernel_op_683) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_686*tmp_kernel_op_83 + tmp_kernel_op_689*tmp_kernel_op_84 + tmp_kernel_op_692*tmp_kernel_op_85);
             const real_t tmp_kernel_op_703 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_670 + jac_blending_inv_1_0_q_1*tmp_kernel_op_673 + jac_blending_inv_2_0_q_1*tmp_kernel_op_676) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_kernel_op_696 + tmp_kernel_op_120*tmp_kernel_op_699 + tmp_kernel_op_122*tmp_kernel_op_702) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_670 + jac_blending_inv_1_1_q_1*tmp_kernel_op_673 + jac_blending_inv_2_1_q_1*tmp_kernel_op_676) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_kernel_op_696 + tmp_kernel_op_127*tmp_kernel_op_699 + tmp_kernel_op_128*tmp_kernel_op_702) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_670 + jac_blending_inv_1_2_q_1*tmp_kernel_op_673 + jac_blending_inv_2_2_q_1*tmp_kernel_op_676) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_kernel_op_696 + tmp_kernel_op_133*tmp_kernel_op_699 + tmp_kernel_op_134*tmp_kernel_op_702) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_673 + jac_blending_inv_1_0_q_1*tmp_kernel_op_678 + jac_blending_inv_2_0_q_1*tmp_kernel_op_681) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_kernel_op_696 + tmp_kernel_op_139*tmp_kernel_op_699 + tmp_kernel_op_140*tmp_kernel_op_702) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_673 + jac_blending_inv_1_1_q_1*tmp_kernel_op_678 + jac_blending_inv_2_1_q_1*tmp_kernel_op_681) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_kernel_op_696 + tmp_kernel_op_145*tmp_kernel_op_699 + tmp_kernel_op_146*tmp_kernel_op_702) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_673 + jac_blending_inv_1_2_q_1*tmp_kernel_op_678 + jac_blending_inv_2_2_q_1*tmp_kernel_op_681) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_kernel_op_696 + tmp_kernel_op_151*tmp_kernel_op_699 + tmp_kernel_op_152*tmp_kernel_op_702) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_676 + jac_blending_inv_1_0_q_1*tmp_kernel_op_681 + jac_blending_inv_2_0_q_1*tmp_kernel_op_683) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_kernel_op_696 + tmp_kernel_op_157*tmp_kernel_op_699 + tmp_kernel_op_158*tmp_kernel_op_702) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_676 + jac_blending_inv_1_1_q_1*tmp_kernel_op_681 + jac_blending_inv_2_1_q_1*tmp_kernel_op_683) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_kernel_op_696 + tmp_kernel_op_163*tmp_kernel_op_699 + tmp_kernel_op_164*tmp_kernel_op_702) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_676 + jac_blending_inv_1_2_q_1*tmp_kernel_op_681 + jac_blending_inv_2_2_q_1*tmp_kernel_op_683) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_kernel_op_696 + tmp_kernel_op_169*tmp_kernel_op_699 + tmp_kernel_op_170*tmp_kernel_op_702);
             const real_t tmp_kernel_op_713 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_670 + jac_blending_inv_1_0_q_2*tmp_kernel_op_673 + jac_blending_inv_2_0_q_2*tmp_kernel_op_676) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_kernel_op_706 + tmp_kernel_op_205*tmp_kernel_op_709 + tmp_kernel_op_207*tmp_kernel_op_712) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_670 + jac_blending_inv_1_1_q_2*tmp_kernel_op_673 + jac_blending_inv_2_1_q_2*tmp_kernel_op_676) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_kernel_op_706 + tmp_kernel_op_212*tmp_kernel_op_709 + tmp_kernel_op_213*tmp_kernel_op_712) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_670 + jac_blending_inv_1_2_q_2*tmp_kernel_op_673 + jac_blending_inv_2_2_q_2*tmp_kernel_op_676) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_kernel_op_706 + tmp_kernel_op_218*tmp_kernel_op_709 + tmp_kernel_op_219*tmp_kernel_op_712) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_673 + jac_blending_inv_1_0_q_2*tmp_kernel_op_678 + jac_blending_inv_2_0_q_2*tmp_kernel_op_681) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_kernel_op_706 + tmp_kernel_op_224*tmp_kernel_op_709 + tmp_kernel_op_225*tmp_kernel_op_712) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_673 + jac_blending_inv_1_1_q_2*tmp_kernel_op_678 + jac_blending_inv_2_1_q_2*tmp_kernel_op_681) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_kernel_op_706 + tmp_kernel_op_230*tmp_kernel_op_709 + tmp_kernel_op_231*tmp_kernel_op_712) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_673 + jac_blending_inv_1_2_q_2*tmp_kernel_op_678 + jac_blending_inv_2_2_q_2*tmp_kernel_op_681) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_kernel_op_706 + tmp_kernel_op_236*tmp_kernel_op_709 + tmp_kernel_op_237*tmp_kernel_op_712) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_676 + jac_blending_inv_1_0_q_2*tmp_kernel_op_681 + jac_blending_inv_2_0_q_2*tmp_kernel_op_683) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_kernel_op_706 + tmp_kernel_op_242*tmp_kernel_op_709 + tmp_kernel_op_243*tmp_kernel_op_712) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_676 + jac_blending_inv_1_1_q_2*tmp_kernel_op_681 + jac_blending_inv_2_1_q_2*tmp_kernel_op_683) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_kernel_op_706 + tmp_kernel_op_248*tmp_kernel_op_709 + tmp_kernel_op_249*tmp_kernel_op_712) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_676 + jac_blending_inv_1_2_q_2*tmp_kernel_op_681 + jac_blending_inv_2_2_q_2*tmp_kernel_op_683) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_kernel_op_706 + tmp_kernel_op_254*tmp_kernel_op_709 + tmp_kernel_op_255*tmp_kernel_op_712);
             const real_t tmp_kernel_op_723 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_670 + jac_blending_inv_1_0_q_3*tmp_kernel_op_673 + jac_blending_inv_2_0_q_3*tmp_kernel_op_676) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_kernel_op_716 + tmp_kernel_op_290*tmp_kernel_op_719 + tmp_kernel_op_292*tmp_kernel_op_722) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_670 + jac_blending_inv_1_1_q_3*tmp_kernel_op_673 + jac_blending_inv_2_1_q_3*tmp_kernel_op_676) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_kernel_op_716 + tmp_kernel_op_297*tmp_kernel_op_719 + tmp_kernel_op_298*tmp_kernel_op_722) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_670 + jac_blending_inv_1_2_q_3*tmp_kernel_op_673 + jac_blending_inv_2_2_q_3*tmp_kernel_op_676) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_kernel_op_716 + tmp_kernel_op_303*tmp_kernel_op_719 + tmp_kernel_op_304*tmp_kernel_op_722) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_673 + jac_blending_inv_1_0_q_3*tmp_kernel_op_678 + jac_blending_inv_2_0_q_3*tmp_kernel_op_681) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_kernel_op_716 + tmp_kernel_op_309*tmp_kernel_op_719 + tmp_kernel_op_310*tmp_kernel_op_722) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_673 + jac_blending_inv_1_1_q_3*tmp_kernel_op_678 + jac_blending_inv_2_1_q_3*tmp_kernel_op_681) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_kernel_op_716 + tmp_kernel_op_315*tmp_kernel_op_719 + tmp_kernel_op_316*tmp_kernel_op_722) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_673 + jac_blending_inv_1_2_q_3*tmp_kernel_op_678 + jac_blending_inv_2_2_q_3*tmp_kernel_op_681) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_kernel_op_716 + tmp_kernel_op_321*tmp_kernel_op_719 + tmp_kernel_op_322*tmp_kernel_op_722) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_676 + jac_blending_inv_1_0_q_3*tmp_kernel_op_681 + jac_blending_inv_2_0_q_3*tmp_kernel_op_683) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_kernel_op_716 + tmp_kernel_op_327*tmp_kernel_op_719 + tmp_kernel_op_328*tmp_kernel_op_722) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_676 + jac_blending_inv_1_1_q_3*tmp_kernel_op_681 + jac_blending_inv_2_1_q_3*tmp_kernel_op_683) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_kernel_op_716 + tmp_kernel_op_333*tmp_kernel_op_719 + tmp_kernel_op_334*tmp_kernel_op_722) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_676 + jac_blending_inv_1_2_q_3*tmp_kernel_op_681 + jac_blending_inv_2_2_q_3*tmp_kernel_op_683) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_kernel_op_716 + tmp_kernel_op_339*tmp_kernel_op_719 + tmp_kernel_op_340*tmp_kernel_op_722);
             const real_t tmp_kernel_op_733 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_670 + jac_blending_inv_1_0_q_4*tmp_kernel_op_673 + jac_blending_inv_2_0_q_4*tmp_kernel_op_676) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_kernel_op_726 + tmp_kernel_op_375*tmp_kernel_op_729 + tmp_kernel_op_377*tmp_kernel_op_732) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_670 + jac_blending_inv_1_1_q_4*tmp_kernel_op_673 + jac_blending_inv_2_1_q_4*tmp_kernel_op_676) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_kernel_op_726 + tmp_kernel_op_382*tmp_kernel_op_729 + tmp_kernel_op_383*tmp_kernel_op_732) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_670 + jac_blending_inv_1_2_q_4*tmp_kernel_op_673 + jac_blending_inv_2_2_q_4*tmp_kernel_op_676) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_kernel_op_726 + tmp_kernel_op_388*tmp_kernel_op_729 + tmp_kernel_op_389*tmp_kernel_op_732) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_673 + jac_blending_inv_1_0_q_4*tmp_kernel_op_678 + jac_blending_inv_2_0_q_4*tmp_kernel_op_681) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_kernel_op_726 + tmp_kernel_op_394*tmp_kernel_op_729 + tmp_kernel_op_395*tmp_kernel_op_732) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_673 + jac_blending_inv_1_1_q_4*tmp_kernel_op_678 + jac_blending_inv_2_1_q_4*tmp_kernel_op_681) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_kernel_op_726 + tmp_kernel_op_400*tmp_kernel_op_729 + tmp_kernel_op_401*tmp_kernel_op_732) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_673 + jac_blending_inv_1_2_q_4*tmp_kernel_op_678 + jac_blending_inv_2_2_q_4*tmp_kernel_op_681) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_kernel_op_726 + tmp_kernel_op_406*tmp_kernel_op_729 + tmp_kernel_op_407*tmp_kernel_op_732) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_676 + jac_blending_inv_1_0_q_4*tmp_kernel_op_681 + jac_blending_inv_2_0_q_4*tmp_kernel_op_683) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_kernel_op_726 + tmp_kernel_op_412*tmp_kernel_op_729 + tmp_kernel_op_413*tmp_kernel_op_732) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_676 + jac_blending_inv_1_1_q_4*tmp_kernel_op_681 + jac_blending_inv_2_1_q_4*tmp_kernel_op_683) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_kernel_op_726 + tmp_kernel_op_418*tmp_kernel_op_729 + tmp_kernel_op_419*tmp_kernel_op_732) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_676 + jac_blending_inv_1_2_q_4*tmp_kernel_op_681 + jac_blending_inv_2_2_q_4*tmp_kernel_op_683) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_kernel_op_726 + tmp_kernel_op_424*tmp_kernel_op_729 + tmp_kernel_op_425*tmp_kernel_op_732);
             const real_t tmp_kernel_op_756 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_737 + jac_blending_inv_1_0_q_0*tmp_kernel_op_739 + jac_blending_inv_2_0_q_0*tmp_kernel_op_741) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_kernel_op_753 + tmp_kernel_op_35*tmp_kernel_op_754 + tmp_kernel_op_37*tmp_kernel_op_755) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_737 + jac_blending_inv_1_1_q_0*tmp_kernel_op_739 + jac_blending_inv_2_1_q_0*tmp_kernel_op_741) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_kernel_op_753 + tmp_kernel_op_42*tmp_kernel_op_754 + tmp_kernel_op_43*tmp_kernel_op_755) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_737 + jac_blending_inv_1_2_q_0*tmp_kernel_op_739 + jac_blending_inv_2_2_q_0*tmp_kernel_op_741) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_kernel_op_753 + tmp_kernel_op_48*tmp_kernel_op_754 + tmp_kernel_op_49*tmp_kernel_op_755) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_742 + jac_blending_inv_1_0_q_0*tmp_kernel_op_745 + jac_blending_inv_2_0_q_0*tmp_kernel_op_746) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_kernel_op_753 + tmp_kernel_op_54*tmp_kernel_op_754 + tmp_kernel_op_55*tmp_kernel_op_755) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_742 + jac_blending_inv_1_1_q_0*tmp_kernel_op_745 + jac_blending_inv_2_1_q_0*tmp_kernel_op_746) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_kernel_op_753 + tmp_kernel_op_60*tmp_kernel_op_754 + tmp_kernel_op_61*tmp_kernel_op_755) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_742 + jac_blending_inv_1_2_q_0*tmp_kernel_op_745 + jac_blending_inv_2_2_q_0*tmp_kernel_op_746) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_kernel_op_753 + tmp_kernel_op_66*tmp_kernel_op_754 + tmp_kernel_op_67*tmp_kernel_op_755) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_747 + jac_blending_inv_1_0_q_0*tmp_kernel_op_748 + jac_blending_inv_2_0_q_0*tmp_kernel_op_751) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_kernel_op_753 + tmp_kernel_op_72*tmp_kernel_op_754 + tmp_kernel_op_73*tmp_kernel_op_755) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_747 + jac_blending_inv_1_1_q_0*tmp_kernel_op_748 + jac_blending_inv_2_1_q_0*tmp_kernel_op_751) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_753*tmp_kernel_op_77 + tmp_kernel_op_754*tmp_kernel_op_78 + tmp_kernel_op_755*tmp_kernel_op_79) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_747 + jac_blending_inv_1_2_q_0*tmp_kernel_op_748 + jac_blending_inv_2_2_q_0*tmp_kernel_op_751) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_753*tmp_kernel_op_83 + tmp_kernel_op_754*tmp_kernel_op_84 + tmp_kernel_op_755*tmp_kernel_op_85);
             const real_t tmp_kernel_op_761 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_737 + jac_blending_inv_1_0_q_1*tmp_kernel_op_739 + jac_blending_inv_2_0_q_1*tmp_kernel_op_741) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_kernel_op_758 + tmp_kernel_op_120*tmp_kernel_op_759 + tmp_kernel_op_122*tmp_kernel_op_760) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_737 + jac_blending_inv_1_1_q_1*tmp_kernel_op_739 + jac_blending_inv_2_1_q_1*tmp_kernel_op_741) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_kernel_op_758 + tmp_kernel_op_127*tmp_kernel_op_759 + tmp_kernel_op_128*tmp_kernel_op_760) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_737 + jac_blending_inv_1_2_q_1*tmp_kernel_op_739 + jac_blending_inv_2_2_q_1*tmp_kernel_op_741) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_kernel_op_758 + tmp_kernel_op_133*tmp_kernel_op_759 + tmp_kernel_op_134*tmp_kernel_op_760) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_742 + jac_blending_inv_1_0_q_1*tmp_kernel_op_745 + jac_blending_inv_2_0_q_1*tmp_kernel_op_746) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_kernel_op_758 + tmp_kernel_op_139*tmp_kernel_op_759 + tmp_kernel_op_140*tmp_kernel_op_760) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_742 + jac_blending_inv_1_1_q_1*tmp_kernel_op_745 + jac_blending_inv_2_1_q_1*tmp_kernel_op_746) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_kernel_op_758 + tmp_kernel_op_145*tmp_kernel_op_759 + tmp_kernel_op_146*tmp_kernel_op_760) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_742 + jac_blending_inv_1_2_q_1*tmp_kernel_op_745 + jac_blending_inv_2_2_q_1*tmp_kernel_op_746) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_kernel_op_758 + tmp_kernel_op_151*tmp_kernel_op_759 + tmp_kernel_op_152*tmp_kernel_op_760) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_747 + jac_blending_inv_1_0_q_1*tmp_kernel_op_748 + jac_blending_inv_2_0_q_1*tmp_kernel_op_751) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_kernel_op_758 + tmp_kernel_op_157*tmp_kernel_op_759 + tmp_kernel_op_158*tmp_kernel_op_760) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_747 + jac_blending_inv_1_1_q_1*tmp_kernel_op_748 + jac_blending_inv_2_1_q_1*tmp_kernel_op_751) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_kernel_op_758 + tmp_kernel_op_163*tmp_kernel_op_759 + tmp_kernel_op_164*tmp_kernel_op_760) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_747 + jac_blending_inv_1_2_q_1*tmp_kernel_op_748 + jac_blending_inv_2_2_q_1*tmp_kernel_op_751) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_kernel_op_758 + tmp_kernel_op_169*tmp_kernel_op_759 + tmp_kernel_op_170*tmp_kernel_op_760);
             const real_t tmp_kernel_op_766 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_737 + jac_blending_inv_1_0_q_2*tmp_kernel_op_739 + jac_blending_inv_2_0_q_2*tmp_kernel_op_741) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_kernel_op_763 + tmp_kernel_op_205*tmp_kernel_op_764 + tmp_kernel_op_207*tmp_kernel_op_765) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_737 + jac_blending_inv_1_1_q_2*tmp_kernel_op_739 + jac_blending_inv_2_1_q_2*tmp_kernel_op_741) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_kernel_op_763 + tmp_kernel_op_212*tmp_kernel_op_764 + tmp_kernel_op_213*tmp_kernel_op_765) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_737 + jac_blending_inv_1_2_q_2*tmp_kernel_op_739 + jac_blending_inv_2_2_q_2*tmp_kernel_op_741) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_kernel_op_763 + tmp_kernel_op_218*tmp_kernel_op_764 + tmp_kernel_op_219*tmp_kernel_op_765) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_742 + jac_blending_inv_1_0_q_2*tmp_kernel_op_745 + jac_blending_inv_2_0_q_2*tmp_kernel_op_746) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_kernel_op_763 + tmp_kernel_op_224*tmp_kernel_op_764 + tmp_kernel_op_225*tmp_kernel_op_765) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_742 + jac_blending_inv_1_1_q_2*tmp_kernel_op_745 + jac_blending_inv_2_1_q_2*tmp_kernel_op_746) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_kernel_op_763 + tmp_kernel_op_230*tmp_kernel_op_764 + tmp_kernel_op_231*tmp_kernel_op_765) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_742 + jac_blending_inv_1_2_q_2*tmp_kernel_op_745 + jac_blending_inv_2_2_q_2*tmp_kernel_op_746) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_kernel_op_763 + tmp_kernel_op_236*tmp_kernel_op_764 + tmp_kernel_op_237*tmp_kernel_op_765) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_747 + jac_blending_inv_1_0_q_2*tmp_kernel_op_748 + jac_blending_inv_2_0_q_2*tmp_kernel_op_751) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_kernel_op_763 + tmp_kernel_op_242*tmp_kernel_op_764 + tmp_kernel_op_243*tmp_kernel_op_765) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_747 + jac_blending_inv_1_1_q_2*tmp_kernel_op_748 + jac_blending_inv_2_1_q_2*tmp_kernel_op_751) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_kernel_op_763 + tmp_kernel_op_248*tmp_kernel_op_764 + tmp_kernel_op_249*tmp_kernel_op_765) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_747 + jac_blending_inv_1_2_q_2*tmp_kernel_op_748 + jac_blending_inv_2_2_q_2*tmp_kernel_op_751) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_kernel_op_763 + tmp_kernel_op_254*tmp_kernel_op_764 + tmp_kernel_op_255*tmp_kernel_op_765);
             const real_t tmp_kernel_op_771 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_737 + jac_blending_inv_1_0_q_3*tmp_kernel_op_739 + jac_blending_inv_2_0_q_3*tmp_kernel_op_741) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_kernel_op_768 + tmp_kernel_op_290*tmp_kernel_op_769 + tmp_kernel_op_292*tmp_kernel_op_770) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_737 + jac_blending_inv_1_1_q_3*tmp_kernel_op_739 + jac_blending_inv_2_1_q_3*tmp_kernel_op_741) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_kernel_op_768 + tmp_kernel_op_297*tmp_kernel_op_769 + tmp_kernel_op_298*tmp_kernel_op_770) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_737 + jac_blending_inv_1_2_q_3*tmp_kernel_op_739 + jac_blending_inv_2_2_q_3*tmp_kernel_op_741) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_kernel_op_768 + tmp_kernel_op_303*tmp_kernel_op_769 + tmp_kernel_op_304*tmp_kernel_op_770) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_742 + jac_blending_inv_1_0_q_3*tmp_kernel_op_745 + jac_blending_inv_2_0_q_3*tmp_kernel_op_746) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_kernel_op_768 + tmp_kernel_op_309*tmp_kernel_op_769 + tmp_kernel_op_310*tmp_kernel_op_770) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_742 + jac_blending_inv_1_1_q_3*tmp_kernel_op_745 + jac_blending_inv_2_1_q_3*tmp_kernel_op_746) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_kernel_op_768 + tmp_kernel_op_315*tmp_kernel_op_769 + tmp_kernel_op_316*tmp_kernel_op_770) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_742 + jac_blending_inv_1_2_q_3*tmp_kernel_op_745 + jac_blending_inv_2_2_q_3*tmp_kernel_op_746) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_kernel_op_768 + tmp_kernel_op_321*tmp_kernel_op_769 + tmp_kernel_op_322*tmp_kernel_op_770) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_747 + jac_blending_inv_1_0_q_3*tmp_kernel_op_748 + jac_blending_inv_2_0_q_3*tmp_kernel_op_751) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_kernel_op_768 + tmp_kernel_op_327*tmp_kernel_op_769 + tmp_kernel_op_328*tmp_kernel_op_770) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_747 + jac_blending_inv_1_1_q_3*tmp_kernel_op_748 + jac_blending_inv_2_1_q_3*tmp_kernel_op_751) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_kernel_op_768 + tmp_kernel_op_333*tmp_kernel_op_769 + tmp_kernel_op_334*tmp_kernel_op_770) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_747 + jac_blending_inv_1_2_q_3*tmp_kernel_op_748 + jac_blending_inv_2_2_q_3*tmp_kernel_op_751) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_kernel_op_768 + tmp_kernel_op_339*tmp_kernel_op_769 + tmp_kernel_op_340*tmp_kernel_op_770);
             const real_t tmp_kernel_op_776 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_737 + jac_blending_inv_1_0_q_4*tmp_kernel_op_739 + jac_blending_inv_2_0_q_4*tmp_kernel_op_741) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_kernel_op_773 + tmp_kernel_op_375*tmp_kernel_op_774 + tmp_kernel_op_377*tmp_kernel_op_775) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_737 + jac_blending_inv_1_1_q_4*tmp_kernel_op_739 + jac_blending_inv_2_1_q_4*tmp_kernel_op_741) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_kernel_op_773 + tmp_kernel_op_382*tmp_kernel_op_774 + tmp_kernel_op_383*tmp_kernel_op_775) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_737 + jac_blending_inv_1_2_q_4*tmp_kernel_op_739 + jac_blending_inv_2_2_q_4*tmp_kernel_op_741) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_kernel_op_773 + tmp_kernel_op_388*tmp_kernel_op_774 + tmp_kernel_op_389*tmp_kernel_op_775) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_742 + jac_blending_inv_1_0_q_4*tmp_kernel_op_745 + jac_blending_inv_2_0_q_4*tmp_kernel_op_746) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_kernel_op_773 + tmp_kernel_op_394*tmp_kernel_op_774 + tmp_kernel_op_395*tmp_kernel_op_775) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_742 + jac_blending_inv_1_1_q_4*tmp_kernel_op_745 + jac_blending_inv_2_1_q_4*tmp_kernel_op_746) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_kernel_op_773 + tmp_kernel_op_400*tmp_kernel_op_774 + tmp_kernel_op_401*tmp_kernel_op_775) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_742 + jac_blending_inv_1_2_q_4*tmp_kernel_op_745 + jac_blending_inv_2_2_q_4*tmp_kernel_op_746) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_kernel_op_773 + tmp_kernel_op_406*tmp_kernel_op_774 + tmp_kernel_op_407*tmp_kernel_op_775) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_747 + jac_blending_inv_1_0_q_4*tmp_kernel_op_748 + jac_blending_inv_2_0_q_4*tmp_kernel_op_751) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_kernel_op_773 + tmp_kernel_op_412*tmp_kernel_op_774 + tmp_kernel_op_413*tmp_kernel_op_775) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_747 + jac_blending_inv_1_1_q_4*tmp_kernel_op_748 + jac_blending_inv_2_1_q_4*tmp_kernel_op_751) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_kernel_op_773 + tmp_kernel_op_418*tmp_kernel_op_774 + tmp_kernel_op_419*tmp_kernel_op_775) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_747 + jac_blending_inv_1_2_q_4*tmp_kernel_op_748 + jac_blending_inv_2_2_q_4*tmp_kernel_op_751) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_kernel_op_773 + tmp_kernel_op_424*tmp_kernel_op_774 + tmp_kernel_op_425*tmp_kernel_op_775);
             const real_t tmp_kernel_op_797 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_779 + jac_blending_inv_1_0_q_0*tmp_kernel_op_781 + jac_blending_inv_2_0_q_0*tmp_kernel_op_783) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_kernel_op_794 + tmp_kernel_op_35*tmp_kernel_op_795 + tmp_kernel_op_37*tmp_kernel_op_796) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_779 + jac_blending_inv_1_1_q_0*tmp_kernel_op_781 + jac_blending_inv_2_1_q_0*tmp_kernel_op_783) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_kernel_op_794 + tmp_kernel_op_42*tmp_kernel_op_795 + tmp_kernel_op_43*tmp_kernel_op_796) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_779 + jac_blending_inv_1_2_q_0*tmp_kernel_op_781 + jac_blending_inv_2_2_q_0*tmp_kernel_op_783) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_kernel_op_794 + tmp_kernel_op_48*tmp_kernel_op_795 + tmp_kernel_op_49*tmp_kernel_op_796) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_784 + jac_blending_inv_1_0_q_0*tmp_kernel_op_786 + jac_blending_inv_2_0_q_0*tmp_kernel_op_787) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_kernel_op_794 + tmp_kernel_op_54*tmp_kernel_op_795 + tmp_kernel_op_55*tmp_kernel_op_796) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_784 + jac_blending_inv_1_1_q_0*tmp_kernel_op_786 + jac_blending_inv_2_1_q_0*tmp_kernel_op_787) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_kernel_op_794 + tmp_kernel_op_60*tmp_kernel_op_795 + tmp_kernel_op_61*tmp_kernel_op_796) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_784 + jac_blending_inv_1_2_q_0*tmp_kernel_op_786 + jac_blending_inv_2_2_q_0*tmp_kernel_op_787) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_kernel_op_794 + tmp_kernel_op_66*tmp_kernel_op_795 + tmp_kernel_op_67*tmp_kernel_op_796) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_788 + jac_blending_inv_1_0_q_0*tmp_kernel_op_789 + jac_blending_inv_2_0_q_0*tmp_kernel_op_791) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_kernel_op_794 + tmp_kernel_op_72*tmp_kernel_op_795 + tmp_kernel_op_73*tmp_kernel_op_796) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_788 + jac_blending_inv_1_1_q_0*tmp_kernel_op_789 + jac_blending_inv_2_1_q_0*tmp_kernel_op_791) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_kernel_op_794 + tmp_kernel_op_78*tmp_kernel_op_795 + tmp_kernel_op_79*tmp_kernel_op_796) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_788 + jac_blending_inv_1_2_q_0*tmp_kernel_op_789 + jac_blending_inv_2_2_q_0*tmp_kernel_op_791) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_794*tmp_kernel_op_83 + tmp_kernel_op_795*tmp_kernel_op_84 + tmp_kernel_op_796*tmp_kernel_op_85);
             const real_t tmp_kernel_op_803 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_779 + jac_blending_inv_1_0_q_1*tmp_kernel_op_781 + jac_blending_inv_2_0_q_1*tmp_kernel_op_783) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_kernel_op_800 + tmp_kernel_op_120*tmp_kernel_op_801 + tmp_kernel_op_122*tmp_kernel_op_802) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_779 + jac_blending_inv_1_1_q_1*tmp_kernel_op_781 + jac_blending_inv_2_1_q_1*tmp_kernel_op_783) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_kernel_op_800 + tmp_kernel_op_127*tmp_kernel_op_801 + tmp_kernel_op_128*tmp_kernel_op_802) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_779 + jac_blending_inv_1_2_q_1*tmp_kernel_op_781 + jac_blending_inv_2_2_q_1*tmp_kernel_op_783) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_kernel_op_800 + tmp_kernel_op_133*tmp_kernel_op_801 + tmp_kernel_op_134*tmp_kernel_op_802) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_784 + jac_blending_inv_1_0_q_1*tmp_kernel_op_786 + jac_blending_inv_2_0_q_1*tmp_kernel_op_787) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_kernel_op_800 + tmp_kernel_op_139*tmp_kernel_op_801 + tmp_kernel_op_140*tmp_kernel_op_802) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_784 + jac_blending_inv_1_1_q_1*tmp_kernel_op_786 + jac_blending_inv_2_1_q_1*tmp_kernel_op_787) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_kernel_op_800 + tmp_kernel_op_145*tmp_kernel_op_801 + tmp_kernel_op_146*tmp_kernel_op_802) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_784 + jac_blending_inv_1_2_q_1*tmp_kernel_op_786 + jac_blending_inv_2_2_q_1*tmp_kernel_op_787) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_kernel_op_800 + tmp_kernel_op_151*tmp_kernel_op_801 + tmp_kernel_op_152*tmp_kernel_op_802) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_788 + jac_blending_inv_1_0_q_1*tmp_kernel_op_789 + jac_blending_inv_2_0_q_1*tmp_kernel_op_791) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_kernel_op_800 + tmp_kernel_op_157*tmp_kernel_op_801 + tmp_kernel_op_158*tmp_kernel_op_802) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_788 + jac_blending_inv_1_1_q_1*tmp_kernel_op_789 + jac_blending_inv_2_1_q_1*tmp_kernel_op_791) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_kernel_op_800 + tmp_kernel_op_163*tmp_kernel_op_801 + tmp_kernel_op_164*tmp_kernel_op_802) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_788 + jac_blending_inv_1_2_q_1*tmp_kernel_op_789 + jac_blending_inv_2_2_q_1*tmp_kernel_op_791) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_kernel_op_800 + tmp_kernel_op_169*tmp_kernel_op_801 + tmp_kernel_op_170*tmp_kernel_op_802);
             const real_t tmp_kernel_op_809 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_779 + jac_blending_inv_1_0_q_2*tmp_kernel_op_781 + jac_blending_inv_2_0_q_2*tmp_kernel_op_783) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_kernel_op_806 + tmp_kernel_op_205*tmp_kernel_op_807 + tmp_kernel_op_207*tmp_kernel_op_808) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_779 + jac_blending_inv_1_1_q_2*tmp_kernel_op_781 + jac_blending_inv_2_1_q_2*tmp_kernel_op_783) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_kernel_op_806 + tmp_kernel_op_212*tmp_kernel_op_807 + tmp_kernel_op_213*tmp_kernel_op_808) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_779 + jac_blending_inv_1_2_q_2*tmp_kernel_op_781 + jac_blending_inv_2_2_q_2*tmp_kernel_op_783) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_kernel_op_806 + tmp_kernel_op_218*tmp_kernel_op_807 + tmp_kernel_op_219*tmp_kernel_op_808) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_784 + jac_blending_inv_1_0_q_2*tmp_kernel_op_786 + jac_blending_inv_2_0_q_2*tmp_kernel_op_787) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_kernel_op_806 + tmp_kernel_op_224*tmp_kernel_op_807 + tmp_kernel_op_225*tmp_kernel_op_808) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_784 + jac_blending_inv_1_1_q_2*tmp_kernel_op_786 + jac_blending_inv_2_1_q_2*tmp_kernel_op_787) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_kernel_op_806 + tmp_kernel_op_230*tmp_kernel_op_807 + tmp_kernel_op_231*tmp_kernel_op_808) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_784 + jac_blending_inv_1_2_q_2*tmp_kernel_op_786 + jac_blending_inv_2_2_q_2*tmp_kernel_op_787) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_kernel_op_806 + tmp_kernel_op_236*tmp_kernel_op_807 + tmp_kernel_op_237*tmp_kernel_op_808) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_788 + jac_blending_inv_1_0_q_2*tmp_kernel_op_789 + jac_blending_inv_2_0_q_2*tmp_kernel_op_791) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_kernel_op_806 + tmp_kernel_op_242*tmp_kernel_op_807 + tmp_kernel_op_243*tmp_kernel_op_808) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_788 + jac_blending_inv_1_1_q_2*tmp_kernel_op_789 + jac_blending_inv_2_1_q_2*tmp_kernel_op_791) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_kernel_op_806 + tmp_kernel_op_248*tmp_kernel_op_807 + tmp_kernel_op_249*tmp_kernel_op_808) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_788 + jac_blending_inv_1_2_q_2*tmp_kernel_op_789 + jac_blending_inv_2_2_q_2*tmp_kernel_op_791) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_kernel_op_806 + tmp_kernel_op_254*tmp_kernel_op_807 + tmp_kernel_op_255*tmp_kernel_op_808);
             const real_t tmp_kernel_op_815 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_779 + jac_blending_inv_1_0_q_3*tmp_kernel_op_781 + jac_blending_inv_2_0_q_3*tmp_kernel_op_783) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_kernel_op_812 + tmp_kernel_op_290*tmp_kernel_op_813 + tmp_kernel_op_292*tmp_kernel_op_814) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_779 + jac_blending_inv_1_1_q_3*tmp_kernel_op_781 + jac_blending_inv_2_1_q_3*tmp_kernel_op_783) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_kernel_op_812 + tmp_kernel_op_297*tmp_kernel_op_813 + tmp_kernel_op_298*tmp_kernel_op_814) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_779 + jac_blending_inv_1_2_q_3*tmp_kernel_op_781 + jac_blending_inv_2_2_q_3*tmp_kernel_op_783) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_kernel_op_812 + tmp_kernel_op_303*tmp_kernel_op_813 + tmp_kernel_op_304*tmp_kernel_op_814) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_784 + jac_blending_inv_1_0_q_3*tmp_kernel_op_786 + jac_blending_inv_2_0_q_3*tmp_kernel_op_787) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_kernel_op_812 + tmp_kernel_op_309*tmp_kernel_op_813 + tmp_kernel_op_310*tmp_kernel_op_814) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_784 + jac_blending_inv_1_1_q_3*tmp_kernel_op_786 + jac_blending_inv_2_1_q_3*tmp_kernel_op_787) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_kernel_op_812 + tmp_kernel_op_315*tmp_kernel_op_813 + tmp_kernel_op_316*tmp_kernel_op_814) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_784 + jac_blending_inv_1_2_q_3*tmp_kernel_op_786 + jac_blending_inv_2_2_q_3*tmp_kernel_op_787) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_kernel_op_812 + tmp_kernel_op_321*tmp_kernel_op_813 + tmp_kernel_op_322*tmp_kernel_op_814) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_788 + jac_blending_inv_1_0_q_3*tmp_kernel_op_789 + jac_blending_inv_2_0_q_3*tmp_kernel_op_791) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_kernel_op_812 + tmp_kernel_op_327*tmp_kernel_op_813 + tmp_kernel_op_328*tmp_kernel_op_814) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_788 + jac_blending_inv_1_1_q_3*tmp_kernel_op_789 + jac_blending_inv_2_1_q_3*tmp_kernel_op_791) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_kernel_op_812 + tmp_kernel_op_333*tmp_kernel_op_813 + tmp_kernel_op_334*tmp_kernel_op_814) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_788 + jac_blending_inv_1_2_q_3*tmp_kernel_op_789 + jac_blending_inv_2_2_q_3*tmp_kernel_op_791) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_kernel_op_812 + tmp_kernel_op_339*tmp_kernel_op_813 + tmp_kernel_op_340*tmp_kernel_op_814);
             const real_t tmp_kernel_op_821 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_779 + jac_blending_inv_1_0_q_4*tmp_kernel_op_781 + jac_blending_inv_2_0_q_4*tmp_kernel_op_783) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_kernel_op_818 + tmp_kernel_op_375*tmp_kernel_op_819 + tmp_kernel_op_377*tmp_kernel_op_820) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_779 + jac_blending_inv_1_1_q_4*tmp_kernel_op_781 + jac_blending_inv_2_1_q_4*tmp_kernel_op_783) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_kernel_op_818 + tmp_kernel_op_382*tmp_kernel_op_819 + tmp_kernel_op_383*tmp_kernel_op_820) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_779 + jac_blending_inv_1_2_q_4*tmp_kernel_op_781 + jac_blending_inv_2_2_q_4*tmp_kernel_op_783) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_kernel_op_818 + tmp_kernel_op_388*tmp_kernel_op_819 + tmp_kernel_op_389*tmp_kernel_op_820) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_784 + jac_blending_inv_1_0_q_4*tmp_kernel_op_786 + jac_blending_inv_2_0_q_4*tmp_kernel_op_787) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_kernel_op_818 + tmp_kernel_op_394*tmp_kernel_op_819 + tmp_kernel_op_395*tmp_kernel_op_820) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_784 + jac_blending_inv_1_1_q_4*tmp_kernel_op_786 + jac_blending_inv_2_1_q_4*tmp_kernel_op_787) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_kernel_op_818 + tmp_kernel_op_400*tmp_kernel_op_819 + tmp_kernel_op_401*tmp_kernel_op_820) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_784 + jac_blending_inv_1_2_q_4*tmp_kernel_op_786 + jac_blending_inv_2_2_q_4*tmp_kernel_op_787) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_kernel_op_818 + tmp_kernel_op_406*tmp_kernel_op_819 + tmp_kernel_op_407*tmp_kernel_op_820) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_788 + jac_blending_inv_1_0_q_4*tmp_kernel_op_789 + jac_blending_inv_2_0_q_4*tmp_kernel_op_791) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_kernel_op_818 + tmp_kernel_op_412*tmp_kernel_op_819 + tmp_kernel_op_413*tmp_kernel_op_820) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_788 + jac_blending_inv_1_1_q_4*tmp_kernel_op_789 + jac_blending_inv_2_1_q_4*tmp_kernel_op_791) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_kernel_op_818 + tmp_kernel_op_418*tmp_kernel_op_819 + tmp_kernel_op_419*tmp_kernel_op_820) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_788 + jac_blending_inv_1_2_q_4*tmp_kernel_op_789 + jac_blending_inv_2_2_q_4*tmp_kernel_op_791) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_kernel_op_818 + tmp_kernel_op_424*tmp_kernel_op_819 + tmp_kernel_op_425*tmp_kernel_op_820);
             const real_t tmp_kernel_op_838 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_823 + jac_blending_inv_1_0_q_0*tmp_kernel_op_825 + jac_blending_inv_2_0_q_0*tmp_kernel_op_827) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_kernel_op_835 + tmp_kernel_op_35*tmp_kernel_op_836 + tmp_kernel_op_37*tmp_kernel_op_837) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_823 + jac_blending_inv_1_1_q_0*tmp_kernel_op_825 + jac_blending_inv_2_1_q_0*tmp_kernel_op_827) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_kernel_op_835 + tmp_kernel_op_42*tmp_kernel_op_836 + tmp_kernel_op_43*tmp_kernel_op_837) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_823 + jac_blending_inv_1_2_q_0*tmp_kernel_op_825 + jac_blending_inv_2_2_q_0*tmp_kernel_op_827) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_kernel_op_835 + tmp_kernel_op_48*tmp_kernel_op_836 + tmp_kernel_op_49*tmp_kernel_op_837) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_828 + jac_blending_inv_1_0_q_0*tmp_kernel_op_829 + jac_blending_inv_2_0_q_0*tmp_kernel_op_830) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_kernel_op_835 + tmp_kernel_op_54*tmp_kernel_op_836 + tmp_kernel_op_55*tmp_kernel_op_837) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_828 + jac_blending_inv_1_1_q_0*tmp_kernel_op_829 + jac_blending_inv_2_1_q_0*tmp_kernel_op_830) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_kernel_op_835 + tmp_kernel_op_60*tmp_kernel_op_836 + tmp_kernel_op_61*tmp_kernel_op_837) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_828 + jac_blending_inv_1_2_q_0*tmp_kernel_op_829 + jac_blending_inv_2_2_q_0*tmp_kernel_op_830) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_kernel_op_835 + tmp_kernel_op_66*tmp_kernel_op_836 + tmp_kernel_op_67*tmp_kernel_op_837) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_kernel_op_831 + jac_blending_inv_1_0_q_0*tmp_kernel_op_832 + jac_blending_inv_2_0_q_0*tmp_kernel_op_833) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_kernel_op_835 + tmp_kernel_op_72*tmp_kernel_op_836 + tmp_kernel_op_73*tmp_kernel_op_837) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_kernel_op_831 + jac_blending_inv_1_1_q_0*tmp_kernel_op_832 + jac_blending_inv_2_1_q_0*tmp_kernel_op_833) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_kernel_op_835 + tmp_kernel_op_78*tmp_kernel_op_836 + tmp_kernel_op_79*tmp_kernel_op_837) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_kernel_op_831 + jac_blending_inv_1_2_q_0*tmp_kernel_op_832 + jac_blending_inv_2_2_q_0*tmp_kernel_op_833) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_kernel_op_835 + tmp_kernel_op_836*tmp_kernel_op_84 + tmp_kernel_op_837*tmp_kernel_op_85);
             const real_t tmp_kernel_op_843 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_823 + jac_blending_inv_1_0_q_1*tmp_kernel_op_825 + jac_blending_inv_2_0_q_1*tmp_kernel_op_827) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_kernel_op_840 + tmp_kernel_op_120*tmp_kernel_op_841 + tmp_kernel_op_122*tmp_kernel_op_842) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_823 + jac_blending_inv_1_1_q_1*tmp_kernel_op_825 + jac_blending_inv_2_1_q_1*tmp_kernel_op_827) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_kernel_op_840 + tmp_kernel_op_127*tmp_kernel_op_841 + tmp_kernel_op_128*tmp_kernel_op_842) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_823 + jac_blending_inv_1_2_q_1*tmp_kernel_op_825 + jac_blending_inv_2_2_q_1*tmp_kernel_op_827) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_kernel_op_840 + tmp_kernel_op_133*tmp_kernel_op_841 + tmp_kernel_op_134*tmp_kernel_op_842) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_828 + jac_blending_inv_1_0_q_1*tmp_kernel_op_829 + jac_blending_inv_2_0_q_1*tmp_kernel_op_830) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_kernel_op_840 + tmp_kernel_op_139*tmp_kernel_op_841 + tmp_kernel_op_140*tmp_kernel_op_842) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_828 + jac_blending_inv_1_1_q_1*tmp_kernel_op_829 + jac_blending_inv_2_1_q_1*tmp_kernel_op_830) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_kernel_op_840 + tmp_kernel_op_145*tmp_kernel_op_841 + tmp_kernel_op_146*tmp_kernel_op_842) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_828 + jac_blending_inv_1_2_q_1*tmp_kernel_op_829 + jac_blending_inv_2_2_q_1*tmp_kernel_op_830) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_kernel_op_840 + tmp_kernel_op_151*tmp_kernel_op_841 + tmp_kernel_op_152*tmp_kernel_op_842) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_kernel_op_831 + jac_blending_inv_1_0_q_1*tmp_kernel_op_832 + jac_blending_inv_2_0_q_1*tmp_kernel_op_833) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_kernel_op_840 + tmp_kernel_op_157*tmp_kernel_op_841 + tmp_kernel_op_158*tmp_kernel_op_842) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_kernel_op_831 + jac_blending_inv_1_1_q_1*tmp_kernel_op_832 + jac_blending_inv_2_1_q_1*tmp_kernel_op_833) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_kernel_op_840 + tmp_kernel_op_163*tmp_kernel_op_841 + tmp_kernel_op_164*tmp_kernel_op_842) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_kernel_op_831 + jac_blending_inv_1_2_q_1*tmp_kernel_op_832 + jac_blending_inv_2_2_q_1*tmp_kernel_op_833) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_kernel_op_840 + tmp_kernel_op_169*tmp_kernel_op_841 + tmp_kernel_op_170*tmp_kernel_op_842);
             const real_t tmp_kernel_op_848 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_823 + jac_blending_inv_1_0_q_2*tmp_kernel_op_825 + jac_blending_inv_2_0_q_2*tmp_kernel_op_827) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_kernel_op_845 + tmp_kernel_op_205*tmp_kernel_op_846 + tmp_kernel_op_207*tmp_kernel_op_847) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_823 + jac_blending_inv_1_1_q_2*tmp_kernel_op_825 + jac_blending_inv_2_1_q_2*tmp_kernel_op_827) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_kernel_op_845 + tmp_kernel_op_212*tmp_kernel_op_846 + tmp_kernel_op_213*tmp_kernel_op_847) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_823 + jac_blending_inv_1_2_q_2*tmp_kernel_op_825 + jac_blending_inv_2_2_q_2*tmp_kernel_op_827) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_kernel_op_845 + tmp_kernel_op_218*tmp_kernel_op_846 + tmp_kernel_op_219*tmp_kernel_op_847) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_828 + jac_blending_inv_1_0_q_2*tmp_kernel_op_829 + jac_blending_inv_2_0_q_2*tmp_kernel_op_830) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_kernel_op_845 + tmp_kernel_op_224*tmp_kernel_op_846 + tmp_kernel_op_225*tmp_kernel_op_847) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_828 + jac_blending_inv_1_1_q_2*tmp_kernel_op_829 + jac_blending_inv_2_1_q_2*tmp_kernel_op_830) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_kernel_op_845 + tmp_kernel_op_230*tmp_kernel_op_846 + tmp_kernel_op_231*tmp_kernel_op_847) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_828 + jac_blending_inv_1_2_q_2*tmp_kernel_op_829 + jac_blending_inv_2_2_q_2*tmp_kernel_op_830) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_kernel_op_845 + tmp_kernel_op_236*tmp_kernel_op_846 + tmp_kernel_op_237*tmp_kernel_op_847) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_kernel_op_831 + jac_blending_inv_1_0_q_2*tmp_kernel_op_832 + jac_blending_inv_2_0_q_2*tmp_kernel_op_833) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_kernel_op_845 + tmp_kernel_op_242*tmp_kernel_op_846 + tmp_kernel_op_243*tmp_kernel_op_847) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_kernel_op_831 + jac_blending_inv_1_1_q_2*tmp_kernel_op_832 + jac_blending_inv_2_1_q_2*tmp_kernel_op_833) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_kernel_op_845 + tmp_kernel_op_248*tmp_kernel_op_846 + tmp_kernel_op_249*tmp_kernel_op_847) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_kernel_op_831 + jac_blending_inv_1_2_q_2*tmp_kernel_op_832 + jac_blending_inv_2_2_q_2*tmp_kernel_op_833) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_kernel_op_845 + tmp_kernel_op_254*tmp_kernel_op_846 + tmp_kernel_op_255*tmp_kernel_op_847);
             const real_t tmp_kernel_op_853 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_823 + jac_blending_inv_1_0_q_3*tmp_kernel_op_825 + jac_blending_inv_2_0_q_3*tmp_kernel_op_827) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_kernel_op_850 + tmp_kernel_op_290*tmp_kernel_op_851 + tmp_kernel_op_292*tmp_kernel_op_852) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_823 + jac_blending_inv_1_1_q_3*tmp_kernel_op_825 + jac_blending_inv_2_1_q_3*tmp_kernel_op_827) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_kernel_op_850 + tmp_kernel_op_297*tmp_kernel_op_851 + tmp_kernel_op_298*tmp_kernel_op_852) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_823 + jac_blending_inv_1_2_q_3*tmp_kernel_op_825 + jac_blending_inv_2_2_q_3*tmp_kernel_op_827) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_kernel_op_850 + tmp_kernel_op_303*tmp_kernel_op_851 + tmp_kernel_op_304*tmp_kernel_op_852) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_828 + jac_blending_inv_1_0_q_3*tmp_kernel_op_829 + jac_blending_inv_2_0_q_3*tmp_kernel_op_830) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_kernel_op_850 + tmp_kernel_op_309*tmp_kernel_op_851 + tmp_kernel_op_310*tmp_kernel_op_852) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_828 + jac_blending_inv_1_1_q_3*tmp_kernel_op_829 + jac_blending_inv_2_1_q_3*tmp_kernel_op_830) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_kernel_op_850 + tmp_kernel_op_315*tmp_kernel_op_851 + tmp_kernel_op_316*tmp_kernel_op_852) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_828 + jac_blending_inv_1_2_q_3*tmp_kernel_op_829 + jac_blending_inv_2_2_q_3*tmp_kernel_op_830) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_kernel_op_850 + tmp_kernel_op_321*tmp_kernel_op_851 + tmp_kernel_op_322*tmp_kernel_op_852) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_kernel_op_831 + jac_blending_inv_1_0_q_3*tmp_kernel_op_832 + jac_blending_inv_2_0_q_3*tmp_kernel_op_833) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_kernel_op_850 + tmp_kernel_op_327*tmp_kernel_op_851 + tmp_kernel_op_328*tmp_kernel_op_852) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_kernel_op_831 + jac_blending_inv_1_1_q_3*tmp_kernel_op_832 + jac_blending_inv_2_1_q_3*tmp_kernel_op_833) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_kernel_op_850 + tmp_kernel_op_333*tmp_kernel_op_851 + tmp_kernel_op_334*tmp_kernel_op_852) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_kernel_op_831 + jac_blending_inv_1_2_q_3*tmp_kernel_op_832 + jac_blending_inv_2_2_q_3*tmp_kernel_op_833) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_kernel_op_850 + tmp_kernel_op_339*tmp_kernel_op_851 + tmp_kernel_op_340*tmp_kernel_op_852);
             const real_t tmp_kernel_op_858 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_823 + jac_blending_inv_1_0_q_4*tmp_kernel_op_825 + jac_blending_inv_2_0_q_4*tmp_kernel_op_827) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_kernel_op_855 + tmp_kernel_op_375*tmp_kernel_op_856 + tmp_kernel_op_377*tmp_kernel_op_857) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_823 + jac_blending_inv_1_1_q_4*tmp_kernel_op_825 + jac_blending_inv_2_1_q_4*tmp_kernel_op_827) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_kernel_op_855 + tmp_kernel_op_382*tmp_kernel_op_856 + tmp_kernel_op_383*tmp_kernel_op_857) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_823 + jac_blending_inv_1_2_q_4*tmp_kernel_op_825 + jac_blending_inv_2_2_q_4*tmp_kernel_op_827) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_kernel_op_855 + tmp_kernel_op_388*tmp_kernel_op_856 + tmp_kernel_op_389*tmp_kernel_op_857) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_828 + jac_blending_inv_1_0_q_4*tmp_kernel_op_829 + jac_blending_inv_2_0_q_4*tmp_kernel_op_830) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_kernel_op_855 + tmp_kernel_op_394*tmp_kernel_op_856 + tmp_kernel_op_395*tmp_kernel_op_857) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_828 + jac_blending_inv_1_1_q_4*tmp_kernel_op_829 + jac_blending_inv_2_1_q_4*tmp_kernel_op_830) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_kernel_op_855 + tmp_kernel_op_400*tmp_kernel_op_856 + tmp_kernel_op_401*tmp_kernel_op_857) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_828 + jac_blending_inv_1_2_q_4*tmp_kernel_op_829 + jac_blending_inv_2_2_q_4*tmp_kernel_op_830) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_kernel_op_855 + tmp_kernel_op_406*tmp_kernel_op_856 + tmp_kernel_op_407*tmp_kernel_op_857) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_kernel_op_831 + jac_blending_inv_1_0_q_4*tmp_kernel_op_832 + jac_blending_inv_2_0_q_4*tmp_kernel_op_833) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_kernel_op_855 + tmp_kernel_op_412*tmp_kernel_op_856 + tmp_kernel_op_413*tmp_kernel_op_857) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_kernel_op_831 + jac_blending_inv_1_1_q_4*tmp_kernel_op_832 + jac_blending_inv_2_1_q_4*tmp_kernel_op_833) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_kernel_op_855 + tmp_kernel_op_418*tmp_kernel_op_856 + tmp_kernel_op_419*tmp_kernel_op_857) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_kernel_op_831 + jac_blending_inv_1_2_q_4*tmp_kernel_op_832 + jac_blending_inv_2_2_q_4*tmp_kernel_op_833) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_kernel_op_855 + tmp_kernel_op_424*tmp_kernel_op_856 + tmp_kernel_op_425*tmp_kernel_op_857);
             const real_t tmp_kernel_op_859 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_kernel_op_456 + jac_blending_inv_1_0_q_0*tmp_kernel_op_457 + jac_blending_inv_2_0_q_0*tmp_kernel_op_458) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_kernel_op_456 + jac_blending_inv_1_1_q_0*tmp_kernel_op_457 + jac_blending_inv_2_1_q_0*tmp_kernel_op_458) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_kernel_op_456 + jac_blending_inv_1_2_q_0*tmp_kernel_op_457 + jac_blending_inv_2_2_q_0*tmp_kernel_op_458));
             const real_t tmp_kernel_op_860 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_kernel_op_461 + jac_blending_inv_1_0_q_1*tmp_kernel_op_462 + jac_blending_inv_2_0_q_1*tmp_kernel_op_463) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_kernel_op_461 + jac_blending_inv_1_1_q_1*tmp_kernel_op_462 + jac_blending_inv_2_1_q_1*tmp_kernel_op_463) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_kernel_op_461 + jac_blending_inv_1_2_q_1*tmp_kernel_op_462 + jac_blending_inv_2_2_q_1*tmp_kernel_op_463));
             const real_t tmp_kernel_op_861 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_kernel_op_466 + jac_blending_inv_1_0_q_2*tmp_kernel_op_467 + jac_blending_inv_2_0_q_2*tmp_kernel_op_468) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_kernel_op_466 + jac_blending_inv_1_1_q_2*tmp_kernel_op_467 + jac_blending_inv_2_1_q_2*tmp_kernel_op_468) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_kernel_op_466 + jac_blending_inv_1_2_q_2*tmp_kernel_op_467 + jac_blending_inv_2_2_q_2*tmp_kernel_op_468));
             const real_t tmp_kernel_op_862 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_kernel_op_471 + jac_blending_inv_1_0_q_3*tmp_kernel_op_472 + jac_blending_inv_2_0_q_3*tmp_kernel_op_473) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_kernel_op_471 + jac_blending_inv_1_1_q_3*tmp_kernel_op_472 + jac_blending_inv_2_1_q_3*tmp_kernel_op_473) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_kernel_op_471 + jac_blending_inv_1_2_q_3*tmp_kernel_op_472 + jac_blending_inv_2_2_q_3*tmp_kernel_op_473));
             const real_t tmp_kernel_op_863 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_kernel_op_476 + jac_blending_inv_1_0_q_4*tmp_kernel_op_477 + jac_blending_inv_2_0_q_4*tmp_kernel_op_478) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_kernel_op_476 + jac_blending_inv_1_1_q_4*tmp_kernel_op_477 + jac_blending_inv_2_1_q_4*tmp_kernel_op_478) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_kernel_op_476 + jac_blending_inv_1_2_q_4*tmp_kernel_op_477 + jac_blending_inv_2_2_q_4*tmp_kernel_op_478));
             const real_t tmp_kernel_op_864 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_kernel_op_487 + jac_blending_inv_1_0_q_0*tmp_kernel_op_488 + jac_blending_inv_2_0_q_0*tmp_kernel_op_489) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_kernel_op_487 + jac_blending_inv_1_1_q_0*tmp_kernel_op_488 + jac_blending_inv_2_1_q_0*tmp_kernel_op_489) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_kernel_op_487 + jac_blending_inv_1_2_q_0*tmp_kernel_op_488 + jac_blending_inv_2_2_q_0*tmp_kernel_op_489));
             const real_t tmp_kernel_op_865 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_kernel_op_492 + jac_blending_inv_1_0_q_1*tmp_kernel_op_493 + jac_blending_inv_2_0_q_1*tmp_kernel_op_494) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_kernel_op_492 + jac_blending_inv_1_1_q_1*tmp_kernel_op_493 + jac_blending_inv_2_1_q_1*tmp_kernel_op_494) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_kernel_op_492 + jac_blending_inv_1_2_q_1*tmp_kernel_op_493 + jac_blending_inv_2_2_q_1*tmp_kernel_op_494));
             const real_t tmp_kernel_op_866 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_kernel_op_497 + jac_blending_inv_1_0_q_2*tmp_kernel_op_498 + jac_blending_inv_2_0_q_2*tmp_kernel_op_499) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_kernel_op_497 + jac_blending_inv_1_1_q_2*tmp_kernel_op_498 + jac_blending_inv_2_1_q_2*tmp_kernel_op_499) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_kernel_op_497 + jac_blending_inv_1_2_q_2*tmp_kernel_op_498 + jac_blending_inv_2_2_q_2*tmp_kernel_op_499));
             const real_t tmp_kernel_op_867 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_kernel_op_502 + jac_blending_inv_1_0_q_3*tmp_kernel_op_503 + jac_blending_inv_2_0_q_3*tmp_kernel_op_504) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_kernel_op_502 + jac_blending_inv_1_1_q_3*tmp_kernel_op_503 + jac_blending_inv_2_1_q_3*tmp_kernel_op_504) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_kernel_op_502 + jac_blending_inv_1_2_q_3*tmp_kernel_op_503 + jac_blending_inv_2_2_q_3*tmp_kernel_op_504));
             const real_t tmp_kernel_op_868 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_kernel_op_507 + jac_blending_inv_1_0_q_4*tmp_kernel_op_508 + jac_blending_inv_2_0_q_4*tmp_kernel_op_509) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_kernel_op_507 + jac_blending_inv_1_1_q_4*tmp_kernel_op_508 + jac_blending_inv_2_1_q_4*tmp_kernel_op_509) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_kernel_op_507 + jac_blending_inv_1_2_q_4*tmp_kernel_op_508 + jac_blending_inv_2_2_q_4*tmp_kernel_op_509));
             const real_t tmp_kernel_op_869 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_kernel_op_518 + jac_blending_inv_1_0_q_0*tmp_kernel_op_519 + jac_blending_inv_2_0_q_0*tmp_kernel_op_520) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_kernel_op_518 + jac_blending_inv_1_1_q_0*tmp_kernel_op_519 + jac_blending_inv_2_1_q_0*tmp_kernel_op_520) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_kernel_op_518 + jac_blending_inv_1_2_q_0*tmp_kernel_op_519 + jac_blending_inv_2_2_q_0*tmp_kernel_op_520));
             const real_t tmp_kernel_op_870 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_kernel_op_523 + jac_blending_inv_1_0_q_1*tmp_kernel_op_524 + jac_blending_inv_2_0_q_1*tmp_kernel_op_525) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_kernel_op_523 + jac_blending_inv_1_1_q_1*tmp_kernel_op_524 + jac_blending_inv_2_1_q_1*tmp_kernel_op_525) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_kernel_op_523 + jac_blending_inv_1_2_q_1*tmp_kernel_op_524 + jac_blending_inv_2_2_q_1*tmp_kernel_op_525));
             const real_t tmp_kernel_op_871 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_kernel_op_528 + jac_blending_inv_1_0_q_2*tmp_kernel_op_529 + jac_blending_inv_2_0_q_2*tmp_kernel_op_530) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_kernel_op_528 + jac_blending_inv_1_1_q_2*tmp_kernel_op_529 + jac_blending_inv_2_1_q_2*tmp_kernel_op_530) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_kernel_op_528 + jac_blending_inv_1_2_q_2*tmp_kernel_op_529 + jac_blending_inv_2_2_q_2*tmp_kernel_op_530));
             const real_t tmp_kernel_op_872 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_kernel_op_533 + jac_blending_inv_1_0_q_3*tmp_kernel_op_534 + jac_blending_inv_2_0_q_3*tmp_kernel_op_535) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_kernel_op_533 + jac_blending_inv_1_1_q_3*tmp_kernel_op_534 + jac_blending_inv_2_1_q_3*tmp_kernel_op_535) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_kernel_op_533 + jac_blending_inv_1_2_q_3*tmp_kernel_op_534 + jac_blending_inv_2_2_q_3*tmp_kernel_op_535));
             const real_t tmp_kernel_op_873 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_kernel_op_538 + jac_blending_inv_1_0_q_4*tmp_kernel_op_539 + jac_blending_inv_2_0_q_4*tmp_kernel_op_540) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_kernel_op_538 + jac_blending_inv_1_1_q_4*tmp_kernel_op_539 + jac_blending_inv_2_1_q_4*tmp_kernel_op_540) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_kernel_op_538 + jac_blending_inv_1_2_q_4*tmp_kernel_op_539 + jac_blending_inv_2_2_q_4*tmp_kernel_op_540));
             const real_t tmp_kernel_op_874 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_kernel_op_559 + jac_blending_inv_1_0_q_0*tmp_kernel_op_562 + jac_blending_inv_2_0_q_0*tmp_kernel_op_565) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_kernel_op_559 + jac_blending_inv_1_1_q_0*tmp_kernel_op_562 + jac_blending_inv_2_1_q_0*tmp_kernel_op_565) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_kernel_op_559 + jac_blending_inv_1_2_q_0*tmp_kernel_op_562 + jac_blending_inv_2_2_q_0*tmp_kernel_op_565));
             const real_t tmp_kernel_op_875 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_kernel_op_569 + jac_blending_inv_1_0_q_1*tmp_kernel_op_572 + jac_blending_inv_2_0_q_1*tmp_kernel_op_575) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_kernel_op_569 + jac_blending_inv_1_1_q_1*tmp_kernel_op_572 + jac_blending_inv_2_1_q_1*tmp_kernel_op_575) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_kernel_op_569 + jac_blending_inv_1_2_q_1*tmp_kernel_op_572 + jac_blending_inv_2_2_q_1*tmp_kernel_op_575));
             const real_t tmp_kernel_op_876 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_kernel_op_579 + jac_blending_inv_1_0_q_2*tmp_kernel_op_582 + jac_blending_inv_2_0_q_2*tmp_kernel_op_585) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_kernel_op_579 + jac_blending_inv_1_1_q_2*tmp_kernel_op_582 + jac_blending_inv_2_1_q_2*tmp_kernel_op_585) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_kernel_op_579 + jac_blending_inv_1_2_q_2*tmp_kernel_op_582 + jac_blending_inv_2_2_q_2*tmp_kernel_op_585));
             const real_t tmp_kernel_op_877 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_kernel_op_589 + jac_blending_inv_1_0_q_3*tmp_kernel_op_592 + jac_blending_inv_2_0_q_3*tmp_kernel_op_595) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_kernel_op_589 + jac_blending_inv_1_1_q_3*tmp_kernel_op_592 + jac_blending_inv_2_1_q_3*tmp_kernel_op_595) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_kernel_op_589 + jac_blending_inv_1_2_q_3*tmp_kernel_op_592 + jac_blending_inv_2_2_q_3*tmp_kernel_op_595));
             const real_t tmp_kernel_op_878 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_kernel_op_599 + jac_blending_inv_1_0_q_4*tmp_kernel_op_602 + jac_blending_inv_2_0_q_4*tmp_kernel_op_605) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_kernel_op_599 + jac_blending_inv_1_1_q_4*tmp_kernel_op_602 + jac_blending_inv_2_1_q_4*tmp_kernel_op_605) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_kernel_op_599 + jac_blending_inv_1_2_q_4*tmp_kernel_op_602 + jac_blending_inv_2_2_q_4*tmp_kernel_op_605));
             const real_t tmp_kernel_op_879 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_kernel_op_621 + jac_blending_inv_1_0_q_0*tmp_kernel_op_624 + jac_blending_inv_2_0_q_0*tmp_kernel_op_627) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_kernel_op_621 + jac_blending_inv_1_1_q_0*tmp_kernel_op_624 + jac_blending_inv_2_1_q_0*tmp_kernel_op_627) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_kernel_op_621 + jac_blending_inv_1_2_q_0*tmp_kernel_op_624 + jac_blending_inv_2_2_q_0*tmp_kernel_op_627));
             const real_t tmp_kernel_op_880 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_kernel_op_631 + jac_blending_inv_1_0_q_1*tmp_kernel_op_634 + jac_blending_inv_2_0_q_1*tmp_kernel_op_637) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_kernel_op_631 + jac_blending_inv_1_1_q_1*tmp_kernel_op_634 + jac_blending_inv_2_1_q_1*tmp_kernel_op_637) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_kernel_op_631 + jac_blending_inv_1_2_q_1*tmp_kernel_op_634 + jac_blending_inv_2_2_q_1*tmp_kernel_op_637));
             const real_t tmp_kernel_op_881 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_kernel_op_641 + jac_blending_inv_1_0_q_2*tmp_kernel_op_644 + jac_blending_inv_2_0_q_2*tmp_kernel_op_647) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_kernel_op_641 + jac_blending_inv_1_1_q_2*tmp_kernel_op_644 + jac_blending_inv_2_1_q_2*tmp_kernel_op_647) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_kernel_op_641 + jac_blending_inv_1_2_q_2*tmp_kernel_op_644 + jac_blending_inv_2_2_q_2*tmp_kernel_op_647));
             const real_t tmp_kernel_op_882 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_kernel_op_651 + jac_blending_inv_1_0_q_3*tmp_kernel_op_654 + jac_blending_inv_2_0_q_3*tmp_kernel_op_657) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_kernel_op_651 + jac_blending_inv_1_1_q_3*tmp_kernel_op_654 + jac_blending_inv_2_1_q_3*tmp_kernel_op_657) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_kernel_op_651 + jac_blending_inv_1_2_q_3*tmp_kernel_op_654 + jac_blending_inv_2_2_q_3*tmp_kernel_op_657));
             const real_t tmp_kernel_op_883 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_kernel_op_661 + jac_blending_inv_1_0_q_4*tmp_kernel_op_664 + jac_blending_inv_2_0_q_4*tmp_kernel_op_667) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_kernel_op_661 + jac_blending_inv_1_1_q_4*tmp_kernel_op_664 + jac_blending_inv_2_1_q_4*tmp_kernel_op_667) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_kernel_op_661 + jac_blending_inv_1_2_q_4*tmp_kernel_op_664 + jac_blending_inv_2_2_q_4*tmp_kernel_op_667));
             const real_t tmp_kernel_op_884 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_kernel_op_686 + jac_blending_inv_1_0_q_0*tmp_kernel_op_689 + jac_blending_inv_2_0_q_0*tmp_kernel_op_692) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_kernel_op_686 + jac_blending_inv_1_1_q_0*tmp_kernel_op_689 + jac_blending_inv_2_1_q_0*tmp_kernel_op_692) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_kernel_op_686 + jac_blending_inv_1_2_q_0*tmp_kernel_op_689 + jac_blending_inv_2_2_q_0*tmp_kernel_op_692));
             const real_t tmp_kernel_op_885 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_kernel_op_696 + jac_blending_inv_1_0_q_1*tmp_kernel_op_699 + jac_blending_inv_2_0_q_1*tmp_kernel_op_702) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_kernel_op_696 + jac_blending_inv_1_1_q_1*tmp_kernel_op_699 + jac_blending_inv_2_1_q_1*tmp_kernel_op_702) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_kernel_op_696 + jac_blending_inv_1_2_q_1*tmp_kernel_op_699 + jac_blending_inv_2_2_q_1*tmp_kernel_op_702));
             const real_t tmp_kernel_op_886 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_kernel_op_706 + jac_blending_inv_1_0_q_2*tmp_kernel_op_709 + jac_blending_inv_2_0_q_2*tmp_kernel_op_712) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_kernel_op_706 + jac_blending_inv_1_1_q_2*tmp_kernel_op_709 + jac_blending_inv_2_1_q_2*tmp_kernel_op_712) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_kernel_op_706 + jac_blending_inv_1_2_q_2*tmp_kernel_op_709 + jac_blending_inv_2_2_q_2*tmp_kernel_op_712));
             const real_t tmp_kernel_op_887 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_kernel_op_716 + jac_blending_inv_1_0_q_3*tmp_kernel_op_719 + jac_blending_inv_2_0_q_3*tmp_kernel_op_722) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_kernel_op_716 + jac_blending_inv_1_1_q_3*tmp_kernel_op_719 + jac_blending_inv_2_1_q_3*tmp_kernel_op_722) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_kernel_op_716 + jac_blending_inv_1_2_q_3*tmp_kernel_op_719 + jac_blending_inv_2_2_q_3*tmp_kernel_op_722));
             const real_t tmp_kernel_op_888 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_kernel_op_726 + jac_blending_inv_1_0_q_4*tmp_kernel_op_729 + jac_blending_inv_2_0_q_4*tmp_kernel_op_732) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_kernel_op_726 + jac_blending_inv_1_1_q_4*tmp_kernel_op_729 + jac_blending_inv_2_1_q_4*tmp_kernel_op_732) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_kernel_op_726 + jac_blending_inv_1_2_q_4*tmp_kernel_op_729 + jac_blending_inv_2_2_q_4*tmp_kernel_op_732));
             const real_t tmp_kernel_op_889 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_kernel_op_753 + jac_blending_inv_1_0_q_0*tmp_kernel_op_754 + jac_blending_inv_2_0_q_0*tmp_kernel_op_755) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_kernel_op_753 + jac_blending_inv_1_1_q_0*tmp_kernel_op_754 + jac_blending_inv_2_1_q_0*tmp_kernel_op_755) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_kernel_op_753 + jac_blending_inv_1_2_q_0*tmp_kernel_op_754 + jac_blending_inv_2_2_q_0*tmp_kernel_op_755));
             const real_t tmp_kernel_op_890 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_kernel_op_758 + jac_blending_inv_1_0_q_1*tmp_kernel_op_759 + jac_blending_inv_2_0_q_1*tmp_kernel_op_760) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_kernel_op_758 + jac_blending_inv_1_1_q_1*tmp_kernel_op_759 + jac_blending_inv_2_1_q_1*tmp_kernel_op_760) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_kernel_op_758 + jac_blending_inv_1_2_q_1*tmp_kernel_op_759 + jac_blending_inv_2_2_q_1*tmp_kernel_op_760));
             const real_t tmp_kernel_op_891 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_kernel_op_763 + jac_blending_inv_1_0_q_2*tmp_kernel_op_764 + jac_blending_inv_2_0_q_2*tmp_kernel_op_765) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_kernel_op_763 + jac_blending_inv_1_1_q_2*tmp_kernel_op_764 + jac_blending_inv_2_1_q_2*tmp_kernel_op_765) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_kernel_op_763 + jac_blending_inv_1_2_q_2*tmp_kernel_op_764 + jac_blending_inv_2_2_q_2*tmp_kernel_op_765));
             const real_t tmp_kernel_op_892 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_kernel_op_768 + jac_blending_inv_1_0_q_3*tmp_kernel_op_769 + jac_blending_inv_2_0_q_3*tmp_kernel_op_770) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_kernel_op_768 + jac_blending_inv_1_1_q_3*tmp_kernel_op_769 + jac_blending_inv_2_1_q_3*tmp_kernel_op_770) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_kernel_op_768 + jac_blending_inv_1_2_q_3*tmp_kernel_op_769 + jac_blending_inv_2_2_q_3*tmp_kernel_op_770));
             const real_t tmp_kernel_op_893 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_kernel_op_773 + jac_blending_inv_1_0_q_4*tmp_kernel_op_774 + jac_blending_inv_2_0_q_4*tmp_kernel_op_775) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_kernel_op_773 + jac_blending_inv_1_1_q_4*tmp_kernel_op_774 + jac_blending_inv_2_1_q_4*tmp_kernel_op_775) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_kernel_op_773 + jac_blending_inv_1_2_q_4*tmp_kernel_op_774 + jac_blending_inv_2_2_q_4*tmp_kernel_op_775));
             const real_t tmp_kernel_op_894 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_kernel_op_794 + jac_blending_inv_1_0_q_0*tmp_kernel_op_795 + jac_blending_inv_2_0_q_0*tmp_kernel_op_796) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_kernel_op_794 + jac_blending_inv_1_1_q_0*tmp_kernel_op_795 + jac_blending_inv_2_1_q_0*tmp_kernel_op_796) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_kernel_op_794 + jac_blending_inv_1_2_q_0*tmp_kernel_op_795 + jac_blending_inv_2_2_q_0*tmp_kernel_op_796));
             const real_t tmp_kernel_op_895 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_kernel_op_800 + jac_blending_inv_1_0_q_1*tmp_kernel_op_801 + jac_blending_inv_2_0_q_1*tmp_kernel_op_802) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_kernel_op_800 + jac_blending_inv_1_1_q_1*tmp_kernel_op_801 + jac_blending_inv_2_1_q_1*tmp_kernel_op_802) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_kernel_op_800 + jac_blending_inv_1_2_q_1*tmp_kernel_op_801 + jac_blending_inv_2_2_q_1*tmp_kernel_op_802));
             const real_t tmp_kernel_op_896 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_kernel_op_806 + jac_blending_inv_1_0_q_2*tmp_kernel_op_807 + jac_blending_inv_2_0_q_2*tmp_kernel_op_808) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_kernel_op_806 + jac_blending_inv_1_1_q_2*tmp_kernel_op_807 + jac_blending_inv_2_1_q_2*tmp_kernel_op_808) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_kernel_op_806 + jac_blending_inv_1_2_q_2*tmp_kernel_op_807 + jac_blending_inv_2_2_q_2*tmp_kernel_op_808));
             const real_t tmp_kernel_op_897 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_kernel_op_812 + jac_blending_inv_1_0_q_3*tmp_kernel_op_813 + jac_blending_inv_2_0_q_3*tmp_kernel_op_814) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_kernel_op_812 + jac_blending_inv_1_1_q_3*tmp_kernel_op_813 + jac_blending_inv_2_1_q_3*tmp_kernel_op_814) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_kernel_op_812 + jac_blending_inv_1_2_q_3*tmp_kernel_op_813 + jac_blending_inv_2_2_q_3*tmp_kernel_op_814));
             const real_t tmp_kernel_op_898 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_kernel_op_818 + jac_blending_inv_1_0_q_4*tmp_kernel_op_819 + jac_blending_inv_2_0_q_4*tmp_kernel_op_820) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_kernel_op_818 + jac_blending_inv_1_1_q_4*tmp_kernel_op_819 + jac_blending_inv_2_1_q_4*tmp_kernel_op_820) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_kernel_op_818 + jac_blending_inv_1_2_q_4*tmp_kernel_op_819 + jac_blending_inv_2_2_q_4*tmp_kernel_op_820));
             const real_t tmp_kernel_op_899 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_kernel_op_835 + jac_blending_inv_1_0_q_0*tmp_kernel_op_836 + jac_blending_inv_2_0_q_0*tmp_kernel_op_837) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_kernel_op_835 + jac_blending_inv_1_1_q_0*tmp_kernel_op_836 + jac_blending_inv_2_1_q_0*tmp_kernel_op_837) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_kernel_op_835 + jac_blending_inv_1_2_q_0*tmp_kernel_op_836 + jac_blending_inv_2_2_q_0*tmp_kernel_op_837));
             const real_t tmp_kernel_op_900 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_kernel_op_840 + jac_blending_inv_1_0_q_1*tmp_kernel_op_841 + jac_blending_inv_2_0_q_1*tmp_kernel_op_842) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_kernel_op_840 + jac_blending_inv_1_1_q_1*tmp_kernel_op_841 + jac_blending_inv_2_1_q_1*tmp_kernel_op_842) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_kernel_op_840 + jac_blending_inv_1_2_q_1*tmp_kernel_op_841 + jac_blending_inv_2_2_q_1*tmp_kernel_op_842));
             const real_t tmp_kernel_op_901 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_kernel_op_845 + jac_blending_inv_1_0_q_2*tmp_kernel_op_846 + jac_blending_inv_2_0_q_2*tmp_kernel_op_847) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_kernel_op_845 + jac_blending_inv_1_1_q_2*tmp_kernel_op_846 + jac_blending_inv_2_1_q_2*tmp_kernel_op_847) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_kernel_op_845 + jac_blending_inv_1_2_q_2*tmp_kernel_op_846 + jac_blending_inv_2_2_q_2*tmp_kernel_op_847));
             const real_t tmp_kernel_op_902 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_kernel_op_850 + jac_blending_inv_1_0_q_3*tmp_kernel_op_851 + jac_blending_inv_2_0_q_3*tmp_kernel_op_852) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_kernel_op_850 + jac_blending_inv_1_1_q_3*tmp_kernel_op_851 + jac_blending_inv_2_1_q_3*tmp_kernel_op_852) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_kernel_op_850 + jac_blending_inv_1_2_q_3*tmp_kernel_op_851 + jac_blending_inv_2_2_q_3*tmp_kernel_op_852));
             const real_t tmp_kernel_op_903 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_kernel_op_855 + jac_blending_inv_1_0_q_4*tmp_kernel_op_856 + jac_blending_inv_2_0_q_4*tmp_kernel_op_857) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_kernel_op_855 + jac_blending_inv_1_1_q_4*tmp_kernel_op_856 + jac_blending_inv_2_1_q_4*tmp_kernel_op_857) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_kernel_op_855 + jac_blending_inv_1_2_q_4*tmp_kernel_op_856 + jac_blending_inv_2_2_q_4*tmp_kernel_op_857));
             const real_t elMat_0_0 = tmp_kernel_op_108*tmp_kernel_op_86 + tmp_kernel_op_171*tmp_kernel_op_193 + tmp_kernel_op_256*tmp_kernel_op_278 + tmp_kernel_op_341*tmp_kernel_op_363 + tmp_kernel_op_426*tmp_kernel_op_448;
             const real_t elMat_0_1 = tmp_kernel_op_108*tmp_kernel_op_459 + tmp_kernel_op_193*tmp_kernel_op_464 + tmp_kernel_op_278*tmp_kernel_op_469 + tmp_kernel_op_363*tmp_kernel_op_474 + tmp_kernel_op_448*tmp_kernel_op_479;
             const real_t elMat_0_2 = tmp_kernel_op_108*tmp_kernel_op_490 + tmp_kernel_op_193*tmp_kernel_op_495 + tmp_kernel_op_278*tmp_kernel_op_500 + tmp_kernel_op_363*tmp_kernel_op_505 + tmp_kernel_op_448*tmp_kernel_op_510;
             const real_t elMat_0_3 = tmp_kernel_op_108*tmp_kernel_op_521 + tmp_kernel_op_193*tmp_kernel_op_526 + tmp_kernel_op_278*tmp_kernel_op_531 + tmp_kernel_op_363*tmp_kernel_op_536 + tmp_kernel_op_448*tmp_kernel_op_541;
             const real_t elMat_0_4 = tmp_kernel_op_108*tmp_kernel_op_566 + tmp_kernel_op_193*tmp_kernel_op_576 + tmp_kernel_op_278*tmp_kernel_op_586 + tmp_kernel_op_363*tmp_kernel_op_596 + tmp_kernel_op_448*tmp_kernel_op_606;
             const real_t elMat_0_5 = tmp_kernel_op_108*tmp_kernel_op_628 + tmp_kernel_op_193*tmp_kernel_op_638 + tmp_kernel_op_278*tmp_kernel_op_648 + tmp_kernel_op_363*tmp_kernel_op_658 + tmp_kernel_op_448*tmp_kernel_op_668;
             const real_t elMat_0_6 = tmp_kernel_op_108*tmp_kernel_op_693 + tmp_kernel_op_193*tmp_kernel_op_703 + tmp_kernel_op_278*tmp_kernel_op_713 + tmp_kernel_op_363*tmp_kernel_op_723 + tmp_kernel_op_448*tmp_kernel_op_733;
             const real_t elMat_0_7 = tmp_kernel_op_108*tmp_kernel_op_756 + tmp_kernel_op_193*tmp_kernel_op_761 + tmp_kernel_op_278*tmp_kernel_op_766 + tmp_kernel_op_363*tmp_kernel_op_771 + tmp_kernel_op_448*tmp_kernel_op_776;
             const real_t elMat_0_8 = tmp_kernel_op_108*tmp_kernel_op_797 + tmp_kernel_op_193*tmp_kernel_op_803 + tmp_kernel_op_278*tmp_kernel_op_809 + tmp_kernel_op_363*tmp_kernel_op_815 + tmp_kernel_op_448*tmp_kernel_op_821;
             const real_t elMat_0_9 = tmp_kernel_op_108*tmp_kernel_op_838 + tmp_kernel_op_193*tmp_kernel_op_843 + tmp_kernel_op_278*tmp_kernel_op_848 + tmp_kernel_op_363*tmp_kernel_op_853 + tmp_kernel_op_448*tmp_kernel_op_858;
             const real_t elMat_1_0 = tmp_kernel_op_171*tmp_kernel_op_860 + tmp_kernel_op_256*tmp_kernel_op_861 + tmp_kernel_op_341*tmp_kernel_op_862 + tmp_kernel_op_426*tmp_kernel_op_863 + tmp_kernel_op_859*tmp_kernel_op_86;
             const real_t elMat_1_1 = tmp_kernel_op_459*tmp_kernel_op_859 + tmp_kernel_op_464*tmp_kernel_op_860 + tmp_kernel_op_469*tmp_kernel_op_861 + tmp_kernel_op_474*tmp_kernel_op_862 + tmp_kernel_op_479*tmp_kernel_op_863;
             const real_t elMat_1_2 = tmp_kernel_op_490*tmp_kernel_op_859 + tmp_kernel_op_495*tmp_kernel_op_860 + tmp_kernel_op_500*tmp_kernel_op_861 + tmp_kernel_op_505*tmp_kernel_op_862 + tmp_kernel_op_510*tmp_kernel_op_863;
             const real_t elMat_1_3 = tmp_kernel_op_521*tmp_kernel_op_859 + tmp_kernel_op_526*tmp_kernel_op_860 + tmp_kernel_op_531*tmp_kernel_op_861 + tmp_kernel_op_536*tmp_kernel_op_862 + tmp_kernel_op_541*tmp_kernel_op_863;
             const real_t elMat_1_4 = tmp_kernel_op_566*tmp_kernel_op_859 + tmp_kernel_op_576*tmp_kernel_op_860 + tmp_kernel_op_586*tmp_kernel_op_861 + tmp_kernel_op_596*tmp_kernel_op_862 + tmp_kernel_op_606*tmp_kernel_op_863;
             const real_t elMat_1_5 = tmp_kernel_op_628*tmp_kernel_op_859 + tmp_kernel_op_638*tmp_kernel_op_860 + tmp_kernel_op_648*tmp_kernel_op_861 + tmp_kernel_op_658*tmp_kernel_op_862 + tmp_kernel_op_668*tmp_kernel_op_863;
             const real_t elMat_1_6 = tmp_kernel_op_693*tmp_kernel_op_859 + tmp_kernel_op_703*tmp_kernel_op_860 + tmp_kernel_op_713*tmp_kernel_op_861 + tmp_kernel_op_723*tmp_kernel_op_862 + tmp_kernel_op_733*tmp_kernel_op_863;
             const real_t elMat_1_7 = tmp_kernel_op_756*tmp_kernel_op_859 + tmp_kernel_op_761*tmp_kernel_op_860 + tmp_kernel_op_766*tmp_kernel_op_861 + tmp_kernel_op_771*tmp_kernel_op_862 + tmp_kernel_op_776*tmp_kernel_op_863;
             const real_t elMat_1_8 = tmp_kernel_op_797*tmp_kernel_op_859 + tmp_kernel_op_803*tmp_kernel_op_860 + tmp_kernel_op_809*tmp_kernel_op_861 + tmp_kernel_op_815*tmp_kernel_op_862 + tmp_kernel_op_821*tmp_kernel_op_863;
             const real_t elMat_1_9 = tmp_kernel_op_838*tmp_kernel_op_859 + tmp_kernel_op_843*tmp_kernel_op_860 + tmp_kernel_op_848*tmp_kernel_op_861 + tmp_kernel_op_853*tmp_kernel_op_862 + tmp_kernel_op_858*tmp_kernel_op_863;
             const real_t elMat_2_0 = tmp_kernel_op_171*tmp_kernel_op_865 + tmp_kernel_op_256*tmp_kernel_op_866 + tmp_kernel_op_341*tmp_kernel_op_867 + tmp_kernel_op_426*tmp_kernel_op_868 + tmp_kernel_op_86*tmp_kernel_op_864;
             const real_t elMat_2_1 = tmp_kernel_op_459*tmp_kernel_op_864 + tmp_kernel_op_464*tmp_kernel_op_865 + tmp_kernel_op_469*tmp_kernel_op_866 + tmp_kernel_op_474*tmp_kernel_op_867 + tmp_kernel_op_479*tmp_kernel_op_868;
             const real_t elMat_2_2 = tmp_kernel_op_490*tmp_kernel_op_864 + tmp_kernel_op_495*tmp_kernel_op_865 + tmp_kernel_op_500*tmp_kernel_op_866 + tmp_kernel_op_505*tmp_kernel_op_867 + tmp_kernel_op_510*tmp_kernel_op_868;
             const real_t elMat_2_3 = tmp_kernel_op_521*tmp_kernel_op_864 + tmp_kernel_op_526*tmp_kernel_op_865 + tmp_kernel_op_531*tmp_kernel_op_866 + tmp_kernel_op_536*tmp_kernel_op_867 + tmp_kernel_op_541*tmp_kernel_op_868;
             const real_t elMat_2_4 = tmp_kernel_op_566*tmp_kernel_op_864 + tmp_kernel_op_576*tmp_kernel_op_865 + tmp_kernel_op_586*tmp_kernel_op_866 + tmp_kernel_op_596*tmp_kernel_op_867 + tmp_kernel_op_606*tmp_kernel_op_868;
             const real_t elMat_2_5 = tmp_kernel_op_628*tmp_kernel_op_864 + tmp_kernel_op_638*tmp_kernel_op_865 + tmp_kernel_op_648*tmp_kernel_op_866 + tmp_kernel_op_658*tmp_kernel_op_867 + tmp_kernel_op_668*tmp_kernel_op_868;
             const real_t elMat_2_6 = tmp_kernel_op_693*tmp_kernel_op_864 + tmp_kernel_op_703*tmp_kernel_op_865 + tmp_kernel_op_713*tmp_kernel_op_866 + tmp_kernel_op_723*tmp_kernel_op_867 + tmp_kernel_op_733*tmp_kernel_op_868;
             const real_t elMat_2_7 = tmp_kernel_op_756*tmp_kernel_op_864 + tmp_kernel_op_761*tmp_kernel_op_865 + tmp_kernel_op_766*tmp_kernel_op_866 + tmp_kernel_op_771*tmp_kernel_op_867 + tmp_kernel_op_776*tmp_kernel_op_868;
             const real_t elMat_2_8 = tmp_kernel_op_797*tmp_kernel_op_864 + tmp_kernel_op_803*tmp_kernel_op_865 + tmp_kernel_op_809*tmp_kernel_op_866 + tmp_kernel_op_815*tmp_kernel_op_867 + tmp_kernel_op_821*tmp_kernel_op_868;
             const real_t elMat_2_9 = tmp_kernel_op_838*tmp_kernel_op_864 + tmp_kernel_op_843*tmp_kernel_op_865 + tmp_kernel_op_848*tmp_kernel_op_866 + tmp_kernel_op_853*tmp_kernel_op_867 + tmp_kernel_op_858*tmp_kernel_op_868;
             const real_t elMat_3_0 = tmp_kernel_op_171*tmp_kernel_op_870 + tmp_kernel_op_256*tmp_kernel_op_871 + tmp_kernel_op_341*tmp_kernel_op_872 + tmp_kernel_op_426*tmp_kernel_op_873 + tmp_kernel_op_86*tmp_kernel_op_869;
             const real_t elMat_3_1 = tmp_kernel_op_459*tmp_kernel_op_869 + tmp_kernel_op_464*tmp_kernel_op_870 + tmp_kernel_op_469*tmp_kernel_op_871 + tmp_kernel_op_474*tmp_kernel_op_872 + tmp_kernel_op_479*tmp_kernel_op_873;
             const real_t elMat_3_2 = tmp_kernel_op_490*tmp_kernel_op_869 + tmp_kernel_op_495*tmp_kernel_op_870 + tmp_kernel_op_500*tmp_kernel_op_871 + tmp_kernel_op_505*tmp_kernel_op_872 + tmp_kernel_op_510*tmp_kernel_op_873;
             const real_t elMat_3_3 = tmp_kernel_op_521*tmp_kernel_op_869 + tmp_kernel_op_526*tmp_kernel_op_870 + tmp_kernel_op_531*tmp_kernel_op_871 + tmp_kernel_op_536*tmp_kernel_op_872 + tmp_kernel_op_541*tmp_kernel_op_873;
             const real_t elMat_3_4 = tmp_kernel_op_566*tmp_kernel_op_869 + tmp_kernel_op_576*tmp_kernel_op_870 + tmp_kernel_op_586*tmp_kernel_op_871 + tmp_kernel_op_596*tmp_kernel_op_872 + tmp_kernel_op_606*tmp_kernel_op_873;
             const real_t elMat_3_5 = tmp_kernel_op_628*tmp_kernel_op_869 + tmp_kernel_op_638*tmp_kernel_op_870 + tmp_kernel_op_648*tmp_kernel_op_871 + tmp_kernel_op_658*tmp_kernel_op_872 + tmp_kernel_op_668*tmp_kernel_op_873;
             const real_t elMat_3_6 = tmp_kernel_op_693*tmp_kernel_op_869 + tmp_kernel_op_703*tmp_kernel_op_870 + tmp_kernel_op_713*tmp_kernel_op_871 + tmp_kernel_op_723*tmp_kernel_op_872 + tmp_kernel_op_733*tmp_kernel_op_873;
             const real_t elMat_3_7 = tmp_kernel_op_756*tmp_kernel_op_869 + tmp_kernel_op_761*tmp_kernel_op_870 + tmp_kernel_op_766*tmp_kernel_op_871 + tmp_kernel_op_771*tmp_kernel_op_872 + tmp_kernel_op_776*tmp_kernel_op_873;
             const real_t elMat_3_8 = tmp_kernel_op_797*tmp_kernel_op_869 + tmp_kernel_op_803*tmp_kernel_op_870 + tmp_kernel_op_809*tmp_kernel_op_871 + tmp_kernel_op_815*tmp_kernel_op_872 + tmp_kernel_op_821*tmp_kernel_op_873;
             const real_t elMat_3_9 = tmp_kernel_op_838*tmp_kernel_op_869 + tmp_kernel_op_843*tmp_kernel_op_870 + tmp_kernel_op_848*tmp_kernel_op_871 + tmp_kernel_op_853*tmp_kernel_op_872 + tmp_kernel_op_858*tmp_kernel_op_873;
             const real_t elMat_4_0 = tmp_kernel_op_171*tmp_kernel_op_875 + tmp_kernel_op_256*tmp_kernel_op_876 + tmp_kernel_op_341*tmp_kernel_op_877 + tmp_kernel_op_426*tmp_kernel_op_878 + tmp_kernel_op_86*tmp_kernel_op_874;
             const real_t elMat_4_1 = tmp_kernel_op_459*tmp_kernel_op_874 + tmp_kernel_op_464*tmp_kernel_op_875 + tmp_kernel_op_469*tmp_kernel_op_876 + tmp_kernel_op_474*tmp_kernel_op_877 + tmp_kernel_op_479*tmp_kernel_op_878;
             const real_t elMat_4_2 = tmp_kernel_op_490*tmp_kernel_op_874 + tmp_kernel_op_495*tmp_kernel_op_875 + tmp_kernel_op_500*tmp_kernel_op_876 + tmp_kernel_op_505*tmp_kernel_op_877 + tmp_kernel_op_510*tmp_kernel_op_878;
             const real_t elMat_4_3 = tmp_kernel_op_521*tmp_kernel_op_874 + tmp_kernel_op_526*tmp_kernel_op_875 + tmp_kernel_op_531*tmp_kernel_op_876 + tmp_kernel_op_536*tmp_kernel_op_877 + tmp_kernel_op_541*tmp_kernel_op_878;
             const real_t elMat_4_4 = tmp_kernel_op_566*tmp_kernel_op_874 + tmp_kernel_op_576*tmp_kernel_op_875 + tmp_kernel_op_586*tmp_kernel_op_876 + tmp_kernel_op_596*tmp_kernel_op_877 + tmp_kernel_op_606*tmp_kernel_op_878;
             const real_t elMat_4_5 = tmp_kernel_op_628*tmp_kernel_op_874 + tmp_kernel_op_638*tmp_kernel_op_875 + tmp_kernel_op_648*tmp_kernel_op_876 + tmp_kernel_op_658*tmp_kernel_op_877 + tmp_kernel_op_668*tmp_kernel_op_878;
             const real_t elMat_4_6 = tmp_kernel_op_693*tmp_kernel_op_874 + tmp_kernel_op_703*tmp_kernel_op_875 + tmp_kernel_op_713*tmp_kernel_op_876 + tmp_kernel_op_723*tmp_kernel_op_877 + tmp_kernel_op_733*tmp_kernel_op_878;
             const real_t elMat_4_7 = tmp_kernel_op_756*tmp_kernel_op_874 + tmp_kernel_op_761*tmp_kernel_op_875 + tmp_kernel_op_766*tmp_kernel_op_876 + tmp_kernel_op_771*tmp_kernel_op_877 + tmp_kernel_op_776*tmp_kernel_op_878;
             const real_t elMat_4_8 = tmp_kernel_op_797*tmp_kernel_op_874 + tmp_kernel_op_803*tmp_kernel_op_875 + tmp_kernel_op_809*tmp_kernel_op_876 + tmp_kernel_op_815*tmp_kernel_op_877 + tmp_kernel_op_821*tmp_kernel_op_878;
             const real_t elMat_4_9 = tmp_kernel_op_838*tmp_kernel_op_874 + tmp_kernel_op_843*tmp_kernel_op_875 + tmp_kernel_op_848*tmp_kernel_op_876 + tmp_kernel_op_853*tmp_kernel_op_877 + tmp_kernel_op_858*tmp_kernel_op_878;
             const real_t elMat_5_0 = tmp_kernel_op_171*tmp_kernel_op_880 + tmp_kernel_op_256*tmp_kernel_op_881 + tmp_kernel_op_341*tmp_kernel_op_882 + tmp_kernel_op_426*tmp_kernel_op_883 + tmp_kernel_op_86*tmp_kernel_op_879;
             const real_t elMat_5_1 = tmp_kernel_op_459*tmp_kernel_op_879 + tmp_kernel_op_464*tmp_kernel_op_880 + tmp_kernel_op_469*tmp_kernel_op_881 + tmp_kernel_op_474*tmp_kernel_op_882 + tmp_kernel_op_479*tmp_kernel_op_883;
             const real_t elMat_5_2 = tmp_kernel_op_490*tmp_kernel_op_879 + tmp_kernel_op_495*tmp_kernel_op_880 + tmp_kernel_op_500*tmp_kernel_op_881 + tmp_kernel_op_505*tmp_kernel_op_882 + tmp_kernel_op_510*tmp_kernel_op_883;
             const real_t elMat_5_3 = tmp_kernel_op_521*tmp_kernel_op_879 + tmp_kernel_op_526*tmp_kernel_op_880 + tmp_kernel_op_531*tmp_kernel_op_881 + tmp_kernel_op_536*tmp_kernel_op_882 + tmp_kernel_op_541*tmp_kernel_op_883;
             const real_t elMat_5_4 = tmp_kernel_op_566*tmp_kernel_op_879 + tmp_kernel_op_576*tmp_kernel_op_880 + tmp_kernel_op_586*tmp_kernel_op_881 + tmp_kernel_op_596*tmp_kernel_op_882 + tmp_kernel_op_606*tmp_kernel_op_883;
             const real_t elMat_5_5 = tmp_kernel_op_628*tmp_kernel_op_879 + tmp_kernel_op_638*tmp_kernel_op_880 + tmp_kernel_op_648*tmp_kernel_op_881 + tmp_kernel_op_658*tmp_kernel_op_882 + tmp_kernel_op_668*tmp_kernel_op_883;
             const real_t elMat_5_6 = tmp_kernel_op_693*tmp_kernel_op_879 + tmp_kernel_op_703*tmp_kernel_op_880 + tmp_kernel_op_713*tmp_kernel_op_881 + tmp_kernel_op_723*tmp_kernel_op_882 + tmp_kernel_op_733*tmp_kernel_op_883;
             const real_t elMat_5_7 = tmp_kernel_op_756*tmp_kernel_op_879 + tmp_kernel_op_761*tmp_kernel_op_880 + tmp_kernel_op_766*tmp_kernel_op_881 + tmp_kernel_op_771*tmp_kernel_op_882 + tmp_kernel_op_776*tmp_kernel_op_883;
             const real_t elMat_5_8 = tmp_kernel_op_797*tmp_kernel_op_879 + tmp_kernel_op_803*tmp_kernel_op_880 + tmp_kernel_op_809*tmp_kernel_op_881 + tmp_kernel_op_815*tmp_kernel_op_882 + tmp_kernel_op_821*tmp_kernel_op_883;
             const real_t elMat_5_9 = tmp_kernel_op_838*tmp_kernel_op_879 + tmp_kernel_op_843*tmp_kernel_op_880 + tmp_kernel_op_848*tmp_kernel_op_881 + tmp_kernel_op_853*tmp_kernel_op_882 + tmp_kernel_op_858*tmp_kernel_op_883;
             const real_t elMat_6_0 = tmp_kernel_op_171*tmp_kernel_op_885 + tmp_kernel_op_256*tmp_kernel_op_886 + tmp_kernel_op_341*tmp_kernel_op_887 + tmp_kernel_op_426*tmp_kernel_op_888 + tmp_kernel_op_86*tmp_kernel_op_884;
             const real_t elMat_6_1 = tmp_kernel_op_459*tmp_kernel_op_884 + tmp_kernel_op_464*tmp_kernel_op_885 + tmp_kernel_op_469*tmp_kernel_op_886 + tmp_kernel_op_474*tmp_kernel_op_887 + tmp_kernel_op_479*tmp_kernel_op_888;
             const real_t elMat_6_2 = tmp_kernel_op_490*tmp_kernel_op_884 + tmp_kernel_op_495*tmp_kernel_op_885 + tmp_kernel_op_500*tmp_kernel_op_886 + tmp_kernel_op_505*tmp_kernel_op_887 + tmp_kernel_op_510*tmp_kernel_op_888;
             const real_t elMat_6_3 = tmp_kernel_op_521*tmp_kernel_op_884 + tmp_kernel_op_526*tmp_kernel_op_885 + tmp_kernel_op_531*tmp_kernel_op_886 + tmp_kernel_op_536*tmp_kernel_op_887 + tmp_kernel_op_541*tmp_kernel_op_888;
             const real_t elMat_6_4 = tmp_kernel_op_566*tmp_kernel_op_884 + tmp_kernel_op_576*tmp_kernel_op_885 + tmp_kernel_op_586*tmp_kernel_op_886 + tmp_kernel_op_596*tmp_kernel_op_887 + tmp_kernel_op_606*tmp_kernel_op_888;
             const real_t elMat_6_5 = tmp_kernel_op_628*tmp_kernel_op_884 + tmp_kernel_op_638*tmp_kernel_op_885 + tmp_kernel_op_648*tmp_kernel_op_886 + tmp_kernel_op_658*tmp_kernel_op_887 + tmp_kernel_op_668*tmp_kernel_op_888;
             const real_t elMat_6_6 = tmp_kernel_op_693*tmp_kernel_op_884 + tmp_kernel_op_703*tmp_kernel_op_885 + tmp_kernel_op_713*tmp_kernel_op_886 + tmp_kernel_op_723*tmp_kernel_op_887 + tmp_kernel_op_733*tmp_kernel_op_888;
             const real_t elMat_6_7 = tmp_kernel_op_756*tmp_kernel_op_884 + tmp_kernel_op_761*tmp_kernel_op_885 + tmp_kernel_op_766*tmp_kernel_op_886 + tmp_kernel_op_771*tmp_kernel_op_887 + tmp_kernel_op_776*tmp_kernel_op_888;
             const real_t elMat_6_8 = tmp_kernel_op_797*tmp_kernel_op_884 + tmp_kernel_op_803*tmp_kernel_op_885 + tmp_kernel_op_809*tmp_kernel_op_886 + tmp_kernel_op_815*tmp_kernel_op_887 + tmp_kernel_op_821*tmp_kernel_op_888;
             const real_t elMat_6_9 = tmp_kernel_op_838*tmp_kernel_op_884 + tmp_kernel_op_843*tmp_kernel_op_885 + tmp_kernel_op_848*tmp_kernel_op_886 + tmp_kernel_op_853*tmp_kernel_op_887 + tmp_kernel_op_858*tmp_kernel_op_888;
             const real_t elMat_7_0 = tmp_kernel_op_171*tmp_kernel_op_890 + tmp_kernel_op_256*tmp_kernel_op_891 + tmp_kernel_op_341*tmp_kernel_op_892 + tmp_kernel_op_426*tmp_kernel_op_893 + tmp_kernel_op_86*tmp_kernel_op_889;
             const real_t elMat_7_1 = tmp_kernel_op_459*tmp_kernel_op_889 + tmp_kernel_op_464*tmp_kernel_op_890 + tmp_kernel_op_469*tmp_kernel_op_891 + tmp_kernel_op_474*tmp_kernel_op_892 + tmp_kernel_op_479*tmp_kernel_op_893;
             const real_t elMat_7_2 = tmp_kernel_op_490*tmp_kernel_op_889 + tmp_kernel_op_495*tmp_kernel_op_890 + tmp_kernel_op_500*tmp_kernel_op_891 + tmp_kernel_op_505*tmp_kernel_op_892 + tmp_kernel_op_510*tmp_kernel_op_893;
             const real_t elMat_7_3 = tmp_kernel_op_521*tmp_kernel_op_889 + tmp_kernel_op_526*tmp_kernel_op_890 + tmp_kernel_op_531*tmp_kernel_op_891 + tmp_kernel_op_536*tmp_kernel_op_892 + tmp_kernel_op_541*tmp_kernel_op_893;
             const real_t elMat_7_4 = tmp_kernel_op_566*tmp_kernel_op_889 + tmp_kernel_op_576*tmp_kernel_op_890 + tmp_kernel_op_586*tmp_kernel_op_891 + tmp_kernel_op_596*tmp_kernel_op_892 + tmp_kernel_op_606*tmp_kernel_op_893;
             const real_t elMat_7_5 = tmp_kernel_op_628*tmp_kernel_op_889 + tmp_kernel_op_638*tmp_kernel_op_890 + tmp_kernel_op_648*tmp_kernel_op_891 + tmp_kernel_op_658*tmp_kernel_op_892 + tmp_kernel_op_668*tmp_kernel_op_893;
             const real_t elMat_7_6 = tmp_kernel_op_693*tmp_kernel_op_889 + tmp_kernel_op_703*tmp_kernel_op_890 + tmp_kernel_op_713*tmp_kernel_op_891 + tmp_kernel_op_723*tmp_kernel_op_892 + tmp_kernel_op_733*tmp_kernel_op_893;
             const real_t elMat_7_7 = tmp_kernel_op_756*tmp_kernel_op_889 + tmp_kernel_op_761*tmp_kernel_op_890 + tmp_kernel_op_766*tmp_kernel_op_891 + tmp_kernel_op_771*tmp_kernel_op_892 + tmp_kernel_op_776*tmp_kernel_op_893;
             const real_t elMat_7_8 = tmp_kernel_op_797*tmp_kernel_op_889 + tmp_kernel_op_803*tmp_kernel_op_890 + tmp_kernel_op_809*tmp_kernel_op_891 + tmp_kernel_op_815*tmp_kernel_op_892 + tmp_kernel_op_821*tmp_kernel_op_893;
             const real_t elMat_7_9 = tmp_kernel_op_838*tmp_kernel_op_889 + tmp_kernel_op_843*tmp_kernel_op_890 + tmp_kernel_op_848*tmp_kernel_op_891 + tmp_kernel_op_853*tmp_kernel_op_892 + tmp_kernel_op_858*tmp_kernel_op_893;
             const real_t elMat_8_0 = tmp_kernel_op_171*tmp_kernel_op_895 + tmp_kernel_op_256*tmp_kernel_op_896 + tmp_kernel_op_341*tmp_kernel_op_897 + tmp_kernel_op_426*tmp_kernel_op_898 + tmp_kernel_op_86*tmp_kernel_op_894;
             const real_t elMat_8_1 = tmp_kernel_op_459*tmp_kernel_op_894 + tmp_kernel_op_464*tmp_kernel_op_895 + tmp_kernel_op_469*tmp_kernel_op_896 + tmp_kernel_op_474*tmp_kernel_op_897 + tmp_kernel_op_479*tmp_kernel_op_898;
             const real_t elMat_8_2 = tmp_kernel_op_490*tmp_kernel_op_894 + tmp_kernel_op_495*tmp_kernel_op_895 + tmp_kernel_op_500*tmp_kernel_op_896 + tmp_kernel_op_505*tmp_kernel_op_897 + tmp_kernel_op_510*tmp_kernel_op_898;
             const real_t elMat_8_3 = tmp_kernel_op_521*tmp_kernel_op_894 + tmp_kernel_op_526*tmp_kernel_op_895 + tmp_kernel_op_531*tmp_kernel_op_896 + tmp_kernel_op_536*tmp_kernel_op_897 + tmp_kernel_op_541*tmp_kernel_op_898;
             const real_t elMat_8_4 = tmp_kernel_op_566*tmp_kernel_op_894 + tmp_kernel_op_576*tmp_kernel_op_895 + tmp_kernel_op_586*tmp_kernel_op_896 + tmp_kernel_op_596*tmp_kernel_op_897 + tmp_kernel_op_606*tmp_kernel_op_898;
             const real_t elMat_8_5 = tmp_kernel_op_628*tmp_kernel_op_894 + tmp_kernel_op_638*tmp_kernel_op_895 + tmp_kernel_op_648*tmp_kernel_op_896 + tmp_kernel_op_658*tmp_kernel_op_897 + tmp_kernel_op_668*tmp_kernel_op_898;
             const real_t elMat_8_6 = tmp_kernel_op_693*tmp_kernel_op_894 + tmp_kernel_op_703*tmp_kernel_op_895 + tmp_kernel_op_713*tmp_kernel_op_896 + tmp_kernel_op_723*tmp_kernel_op_897 + tmp_kernel_op_733*tmp_kernel_op_898;
             const real_t elMat_8_7 = tmp_kernel_op_756*tmp_kernel_op_894 + tmp_kernel_op_761*tmp_kernel_op_895 + tmp_kernel_op_766*tmp_kernel_op_896 + tmp_kernel_op_771*tmp_kernel_op_897 + tmp_kernel_op_776*tmp_kernel_op_898;
             const real_t elMat_8_8 = tmp_kernel_op_797*tmp_kernel_op_894 + tmp_kernel_op_803*tmp_kernel_op_895 + tmp_kernel_op_809*tmp_kernel_op_896 + tmp_kernel_op_815*tmp_kernel_op_897 + tmp_kernel_op_821*tmp_kernel_op_898;
             const real_t elMat_8_9 = tmp_kernel_op_838*tmp_kernel_op_894 + tmp_kernel_op_843*tmp_kernel_op_895 + tmp_kernel_op_848*tmp_kernel_op_896 + tmp_kernel_op_853*tmp_kernel_op_897 + tmp_kernel_op_858*tmp_kernel_op_898;
             const real_t elMat_9_0 = tmp_kernel_op_171*tmp_kernel_op_900 + tmp_kernel_op_256*tmp_kernel_op_901 + tmp_kernel_op_341*tmp_kernel_op_902 + tmp_kernel_op_426*tmp_kernel_op_903 + tmp_kernel_op_86*tmp_kernel_op_899;
             const real_t elMat_9_1 = tmp_kernel_op_459*tmp_kernel_op_899 + tmp_kernel_op_464*tmp_kernel_op_900 + tmp_kernel_op_469*tmp_kernel_op_901 + tmp_kernel_op_474*tmp_kernel_op_902 + tmp_kernel_op_479*tmp_kernel_op_903;
             const real_t elMat_9_2 = tmp_kernel_op_490*tmp_kernel_op_899 + tmp_kernel_op_495*tmp_kernel_op_900 + tmp_kernel_op_500*tmp_kernel_op_901 + tmp_kernel_op_505*tmp_kernel_op_902 + tmp_kernel_op_510*tmp_kernel_op_903;
             const real_t elMat_9_3 = tmp_kernel_op_521*tmp_kernel_op_899 + tmp_kernel_op_526*tmp_kernel_op_900 + tmp_kernel_op_531*tmp_kernel_op_901 + tmp_kernel_op_536*tmp_kernel_op_902 + tmp_kernel_op_541*tmp_kernel_op_903;
             const real_t elMat_9_4 = tmp_kernel_op_566*tmp_kernel_op_899 + tmp_kernel_op_576*tmp_kernel_op_900 + tmp_kernel_op_586*tmp_kernel_op_901 + tmp_kernel_op_596*tmp_kernel_op_902 + tmp_kernel_op_606*tmp_kernel_op_903;
             const real_t elMat_9_5 = tmp_kernel_op_628*tmp_kernel_op_899 + tmp_kernel_op_638*tmp_kernel_op_900 + tmp_kernel_op_648*tmp_kernel_op_901 + tmp_kernel_op_658*tmp_kernel_op_902 + tmp_kernel_op_668*tmp_kernel_op_903;
             const real_t elMat_9_6 = tmp_kernel_op_693*tmp_kernel_op_899 + tmp_kernel_op_703*tmp_kernel_op_900 + tmp_kernel_op_713*tmp_kernel_op_901 + tmp_kernel_op_723*tmp_kernel_op_902 + tmp_kernel_op_733*tmp_kernel_op_903;
             const real_t elMat_9_7 = tmp_kernel_op_756*tmp_kernel_op_899 + tmp_kernel_op_761*tmp_kernel_op_900 + tmp_kernel_op_766*tmp_kernel_op_901 + tmp_kernel_op_771*tmp_kernel_op_902 + tmp_kernel_op_776*tmp_kernel_op_903;
             const real_t elMat_9_8 = tmp_kernel_op_797*tmp_kernel_op_899 + tmp_kernel_op_803*tmp_kernel_op_900 + tmp_kernel_op_809*tmp_kernel_op_901 + tmp_kernel_op_815*tmp_kernel_op_902 + tmp_kernel_op_821*tmp_kernel_op_903;
             const real_t elMat_9_9 = tmp_kernel_op_838*tmp_kernel_op_899 + tmp_kernel_op_843*tmp_kernel_op_900 + tmp_kernel_op_848*tmp_kernel_op_901 + tmp_kernel_op_853*tmp_kernel_op_902 + tmp_kernel_op_858*tmp_kernel_op_903;
         
             std::vector< uint_t > _data_rowIdx( 10 );
             std::vector< uint_t > _data_colIdx( 10 );
             std::vector< real_t > _data_mat( 100 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[1] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[2] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[3] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[7] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[8] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[9] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[3] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[7] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_0_4));
             _data_mat[5] = ((real_t)(elMat_0_5));
             _data_mat[6] = ((real_t)(elMat_0_6));
             _data_mat[7] = ((real_t)(elMat_0_7));
             _data_mat[8] = ((real_t)(elMat_0_8));
             _data_mat[9] = ((real_t)(elMat_0_9));
             _data_mat[10] = ((real_t)(elMat_1_0));
             _data_mat[11] = ((real_t)(elMat_1_1));
             _data_mat[12] = ((real_t)(elMat_1_2));
             _data_mat[13] = ((real_t)(elMat_1_3));
             _data_mat[14] = ((real_t)(elMat_1_4));
             _data_mat[15] = ((real_t)(elMat_1_5));
             _data_mat[16] = ((real_t)(elMat_1_6));
             _data_mat[17] = ((real_t)(elMat_1_7));
             _data_mat[18] = ((real_t)(elMat_1_8));
             _data_mat[19] = ((real_t)(elMat_1_9));
             _data_mat[20] = ((real_t)(elMat_2_0));
             _data_mat[21] = ((real_t)(elMat_2_1));
             _data_mat[22] = ((real_t)(elMat_2_2));
             _data_mat[23] = ((real_t)(elMat_2_3));
             _data_mat[24] = ((real_t)(elMat_2_4));
             _data_mat[25] = ((real_t)(elMat_2_5));
             _data_mat[26] = ((real_t)(elMat_2_6));
             _data_mat[27] = ((real_t)(elMat_2_7));
             _data_mat[28] = ((real_t)(elMat_2_8));
             _data_mat[29] = ((real_t)(elMat_2_9));
             _data_mat[30] = ((real_t)(elMat_3_0));
             _data_mat[31] = ((real_t)(elMat_3_1));
             _data_mat[32] = ((real_t)(elMat_3_2));
             _data_mat[33] = ((real_t)(elMat_3_3));
             _data_mat[34] = ((real_t)(elMat_3_4));
             _data_mat[35] = ((real_t)(elMat_3_5));
             _data_mat[36] = ((real_t)(elMat_3_6));
             _data_mat[37] = ((real_t)(elMat_3_7));
             _data_mat[38] = ((real_t)(elMat_3_8));
             _data_mat[39] = ((real_t)(elMat_3_9));
             _data_mat[40] = ((real_t)(elMat_4_0));
             _data_mat[41] = ((real_t)(elMat_4_1));
             _data_mat[42] = ((real_t)(elMat_4_2));
             _data_mat[43] = ((real_t)(elMat_4_3));
             _data_mat[44] = ((real_t)(elMat_4_4));
             _data_mat[45] = ((real_t)(elMat_4_5));
             _data_mat[46] = ((real_t)(elMat_4_6));
             _data_mat[47] = ((real_t)(elMat_4_7));
             _data_mat[48] = ((real_t)(elMat_4_8));
             _data_mat[49] = ((real_t)(elMat_4_9));
             _data_mat[50] = ((real_t)(elMat_5_0));
             _data_mat[51] = ((real_t)(elMat_5_1));
             _data_mat[52] = ((real_t)(elMat_5_2));
             _data_mat[53] = ((real_t)(elMat_5_3));
             _data_mat[54] = ((real_t)(elMat_5_4));
             _data_mat[55] = ((real_t)(elMat_5_5));
             _data_mat[56] = ((real_t)(elMat_5_6));
             _data_mat[57] = ((real_t)(elMat_5_7));
             _data_mat[58] = ((real_t)(elMat_5_8));
             _data_mat[59] = ((real_t)(elMat_5_9));
             _data_mat[60] = ((real_t)(elMat_6_0));
             _data_mat[61] = ((real_t)(elMat_6_1));
             _data_mat[62] = ((real_t)(elMat_6_2));
             _data_mat[63] = ((real_t)(elMat_6_3));
             _data_mat[64] = ((real_t)(elMat_6_4));
             _data_mat[65] = ((real_t)(elMat_6_5));
             _data_mat[66] = ((real_t)(elMat_6_6));
             _data_mat[67] = ((real_t)(elMat_6_7));
             _data_mat[68] = ((real_t)(elMat_6_8));
             _data_mat[69] = ((real_t)(elMat_6_9));
             _data_mat[70] = ((real_t)(elMat_7_0));
             _data_mat[71] = ((real_t)(elMat_7_1));
             _data_mat[72] = ((real_t)(elMat_7_2));
             _data_mat[73] = ((real_t)(elMat_7_3));
             _data_mat[74] = ((real_t)(elMat_7_4));
             _data_mat[75] = ((real_t)(elMat_7_5));
             _data_mat[76] = ((real_t)(elMat_7_6));
             _data_mat[77] = ((real_t)(elMat_7_7));
             _data_mat[78] = ((real_t)(elMat_7_8));
             _data_mat[79] = ((real_t)(elMat_7_9));
             _data_mat[80] = ((real_t)(elMat_8_0));
             _data_mat[81] = ((real_t)(elMat_8_1));
             _data_mat[82] = ((real_t)(elMat_8_2));
             _data_mat[83] = ((real_t)(elMat_8_3));
             _data_mat[84] = ((real_t)(elMat_8_4));
             _data_mat[85] = ((real_t)(elMat_8_5));
             _data_mat[86] = ((real_t)(elMat_8_6));
             _data_mat[87] = ((real_t)(elMat_8_7));
             _data_mat[88] = ((real_t)(elMat_8_8));
             _data_mat[89] = ((real_t)(elMat_8_9));
             _data_mat[90] = ((real_t)(elMat_9_0));
             _data_mat[91] = ((real_t)(elMat_9_1));
             _data_mat[92] = ((real_t)(elMat_9_2));
             _data_mat[93] = ((real_t)(elMat_9_3));
             _data_mat[94] = ((real_t)(elMat_9_4));
             _data_mat[95] = ((real_t)(elMat_9_5));
             _data_mat[96] = ((real_t)(elMat_9_6));
             _data_mat[97] = ((real_t)(elMat_9_7));
             _data_mat[98] = ((real_t)(elMat_9_8));
             _data_mat[99] = ((real_t)(elMat_9_9));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const real_t tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const real_t tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_14_WHITE_DOWN = jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
       const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const real_t tmp_coords_jac_13_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_0_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
       const real_t tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const real_t jac_affine_inv_0_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
       const real_t jac_affine_inv_0_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const real_t jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const real_t jac_affine_inv_1_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       const real_t tmp_moved_constant_0 = jac_affine_inv_2_0_WHITE_DOWN*4.0;
       const real_t tmp_moved_constant_1 = jac_affine_inv_0_0_WHITE_DOWN*4.0;
       const real_t tmp_moved_constant_2 = jac_affine_inv_1_0_WHITE_DOWN*4.0;
       const real_t tmp_moved_constant_3 = tmp_moved_constant_1 + tmp_moved_constant_2;
       const real_t tmp_moved_constant_4 = tmp_moved_constant_0 + tmp_moved_constant_3;
       const real_t tmp_moved_constant_5 = jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_4 + jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_4 + jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_4;
       const real_t tmp_moved_constant_6 = jac_affine_inv_2_1_WHITE_DOWN*4.0;
       const real_t tmp_moved_constant_7 = jac_affine_inv_0_1_WHITE_DOWN*4.0;
       const real_t tmp_moved_constant_8 = jac_affine_inv_1_1_WHITE_DOWN*4.0;
       const real_t tmp_moved_constant_9 = tmp_moved_constant_7 + tmp_moved_constant_8;
       const real_t tmp_moved_constant_10 = tmp_moved_constant_6 + tmp_moved_constant_9;
       const real_t tmp_moved_constant_11 = jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_10 + jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_10 + jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_10;
       const real_t tmp_moved_constant_12 = jac_affine_inv_2_2_WHITE_DOWN*4.0;
       const real_t tmp_moved_constant_13 = jac_affine_inv_0_2_WHITE_DOWN*4.0;
       const real_t tmp_moved_constant_14 = jac_affine_inv_1_2_WHITE_DOWN*4.0;
       const real_t tmp_moved_constant_15 = tmp_moved_constant_13 + tmp_moved_constant_14;
       const real_t tmp_moved_constant_16 = tmp_moved_constant_12 + tmp_moved_constant_15;
       const real_t tmp_moved_constant_17 = jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_16 + jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_16 + jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_16;
       const real_t tmp_moved_constant_18 = jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_4 + jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_4 + jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_4;
       const real_t tmp_moved_constant_19 = jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_10 + jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_10 + jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_10;
       const real_t tmp_moved_constant_20 = jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_16 + jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_16 + jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_16;
       const real_t tmp_moved_constant_21 = jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_4 + jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_4 + jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_4;
       const real_t tmp_moved_constant_22 = jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_10 + jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_10 + jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_10;
       const real_t tmp_moved_constant_23 = jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_16 + jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_16 + jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_16;
       const real_t tmp_moved_constant_24 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_28 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_28 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_25 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_28 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_28 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_26 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_28 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_28 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_27 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_113 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_113 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_113;
       const real_t tmp_moved_constant_28 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_113 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_113 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_113;
       const real_t tmp_moved_constant_29 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_113 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_113 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_113;
       const real_t tmp_moved_constant_30 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_198 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_198 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_198;
       const real_t tmp_moved_constant_31 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_198 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_198 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_198;
       const real_t tmp_moved_constant_32 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_198 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_198 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_198;
       const real_t tmp_moved_constant_33 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_283 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_283 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_283;
       const real_t tmp_moved_constant_34 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_283 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_283 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_283;
       const real_t tmp_moved_constant_35 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_283 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_283 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_283;
       const real_t tmp_moved_constant_36 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_368 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_368 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_368;
       const real_t tmp_moved_constant_37 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_368 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_368 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_368;
       const real_t tmp_moved_constant_38 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_368 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_368 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_368;
       const real_t tmp_moved_constant_39 = jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_1;
       const real_t tmp_moved_constant_40 = jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_1;
       const real_t tmp_moved_constant_41 = (jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*4.0;
       const real_t tmp_moved_constant_42 = jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_7;
       const real_t tmp_moved_constant_43 = (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*4.0;
       const real_t tmp_moved_constant_44 = (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*4.0;
       const real_t tmp_moved_constant_45 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_455;
       const real_t tmp_moved_constant_46 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_455;
       const real_t tmp_moved_constant_47 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_455;
       const real_t tmp_moved_constant_48 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_460;
       const real_t tmp_moved_constant_49 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_460;
       const real_t tmp_moved_constant_50 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_460;
       const real_t tmp_moved_constant_51 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_465;
       const real_t tmp_moved_constant_52 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_465;
       const real_t tmp_moved_constant_53 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_465;
       const real_t tmp_moved_constant_54 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_470;
       const real_t tmp_moved_constant_55 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_470;
       const real_t tmp_moved_constant_56 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_470;
       const real_t tmp_moved_constant_57 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_475;
       const real_t tmp_moved_constant_58 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_475;
       const real_t tmp_moved_constant_59 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_475;
       const real_t tmp_moved_constant_60 = jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_2;
       const real_t tmp_moved_constant_61 = jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_2;
       const real_t tmp_moved_constant_62 = (jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*4.0;
       const real_t tmp_moved_constant_63 = jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_8;
       const real_t tmp_moved_constant_64 = (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*4.0;
       const real_t tmp_moved_constant_65 = (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*4.0;
       const real_t tmp_moved_constant_66 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_486;
       const real_t tmp_moved_constant_67 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_486;
       const real_t tmp_moved_constant_68 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_486;
       const real_t tmp_moved_constant_69 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_491;
       const real_t tmp_moved_constant_70 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_491;
       const real_t tmp_moved_constant_71 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_491;
       const real_t tmp_moved_constant_72 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_496;
       const real_t tmp_moved_constant_73 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_496;
       const real_t tmp_moved_constant_74 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_496;
       const real_t tmp_moved_constant_75 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_501;
       const real_t tmp_moved_constant_76 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_501;
       const real_t tmp_moved_constant_77 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_501;
       const real_t tmp_moved_constant_78 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_506;
       const real_t tmp_moved_constant_79 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_506;
       const real_t tmp_moved_constant_80 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_506;
       const real_t tmp_moved_constant_81 = jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_0;
       const real_t tmp_moved_constant_82 = jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_0;
       const real_t tmp_moved_constant_83 = (jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*4.0;
       const real_t tmp_moved_constant_84 = jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_6;
       const real_t tmp_moved_constant_85 = (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*4.0;
       const real_t tmp_moved_constant_86 = (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*4.0;
       const real_t tmp_moved_constant_87 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_517;
       const real_t tmp_moved_constant_88 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_517;
       const real_t tmp_moved_constant_89 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_517;
       const real_t tmp_moved_constant_90 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_522;
       const real_t tmp_moved_constant_91 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_522;
       const real_t tmp_moved_constant_92 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_522;
       const real_t tmp_moved_constant_93 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_527;
       const real_t tmp_moved_constant_94 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_527;
       const real_t tmp_moved_constant_95 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_527;
       const real_t tmp_moved_constant_96 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_532;
       const real_t tmp_moved_constant_97 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_532;
       const real_t tmp_moved_constant_98 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_532;
       const real_t tmp_moved_constant_99 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_537;
       const real_t tmp_moved_constant_100 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_537;
       const real_t tmp_moved_constant_101 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_537;
       const real_t tmp_moved_constant_102 = jac_affine_inv_2_0_WHITE_DOWN*8.0;
       const real_t tmp_moved_constant_103 = jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_102;
       const real_t tmp_moved_constant_104 = jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_2;
       const real_t tmp_moved_constant_105 = jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_0;
       const real_t tmp_moved_constant_106 = tmp_moved_constant_104 + tmp_moved_constant_105;
       const real_t tmp_moved_constant_107 = jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_2;
       const real_t tmp_moved_constant_108 = jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_0;
       const real_t tmp_moved_constant_109 = tmp_moved_constant_107 + tmp_moved_constant_108;
       const real_t tmp_moved_constant_110 = jac_affine_inv_2_1_WHITE_DOWN*8.0;
       const real_t tmp_moved_constant_111 = jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_110;
       const real_t tmp_moved_constant_112 = jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_8;
       const real_t tmp_moved_constant_113 = jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_6;
       const real_t tmp_moved_constant_114 = tmp_moved_constant_112 + tmp_moved_constant_113;
       const real_t tmp_moved_constant_115 = jac_affine_inv_2_2_WHITE_DOWN*8.0;
       const real_t tmp_moved_constant_116 = jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_115;
       const real_t tmp_moved_constant_117 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_118 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_119 = tmp_moved_constant_117 + tmp_moved_constant_118;
       const real_t tmp_moved_constant_120 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_121 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_122 = tmp_moved_constant_120 + tmp_moved_constant_121;
       const real_t tmp_moved_constant_123 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_124 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_125 = tmp_moved_constant_123 + tmp_moved_constant_124;
       const real_t tmp_moved_constant_126 = tmp_moved_constant_2*0.5;
       const real_t tmp_moved_constant_127 = tmp_moved_constant_0*0.16666666666666666;
       const real_t tmp_moved_constant_128 = tmp_moved_constant_126 + tmp_moved_constant_127;
       const real_t tmp_moved_constant_129 = tmp_moved_constant_8*0.5;
       const real_t tmp_moved_constant_130 = tmp_moved_constant_6*0.16666666666666666;
       const real_t tmp_moved_constant_131 = tmp_moved_constant_129 + tmp_moved_constant_130;
       const real_t tmp_moved_constant_132 = tmp_moved_constant_14*0.5;
       const real_t tmp_moved_constant_133 = tmp_moved_constant_12*0.16666666666666666;
       const real_t tmp_moved_constant_134 = tmp_moved_constant_132 + tmp_moved_constant_133;
       const real_t tmp_moved_constant_135 = tmp_moved_constant_2*0.16666666666666666;
       const real_t tmp_moved_constant_136 = tmp_moved_constant_0*0.5;
       const real_t tmp_moved_constant_137 = tmp_moved_constant_135 + tmp_moved_constant_136;
       const real_t tmp_moved_constant_138 = tmp_moved_constant_8*0.16666666666666666;
       const real_t tmp_moved_constant_139 = tmp_moved_constant_6*0.5;
       const real_t tmp_moved_constant_140 = tmp_moved_constant_138 + tmp_moved_constant_139;
       const real_t tmp_moved_constant_141 = tmp_moved_constant_14*0.16666666666666666;
       const real_t tmp_moved_constant_142 = tmp_moved_constant_12*0.5;
       const real_t tmp_moved_constant_143 = tmp_moved_constant_141 + tmp_moved_constant_142;
       const real_t tmp_moved_constant_144 = tmp_moved_constant_2*0.16666666666666666;
       const real_t tmp_moved_constant_145 = tmp_moved_constant_0*0.16666666666666666;
       const real_t tmp_moved_constant_146 = tmp_moved_constant_144 + tmp_moved_constant_145;
       const real_t tmp_moved_constant_147 = tmp_moved_constant_8*0.16666666666666666;
       const real_t tmp_moved_constant_148 = tmp_moved_constant_6*0.16666666666666666;
       const real_t tmp_moved_constant_149 = tmp_moved_constant_147 + tmp_moved_constant_148;
       const real_t tmp_moved_constant_150 = tmp_moved_constant_14*0.16666666666666666;
       const real_t tmp_moved_constant_151 = tmp_moved_constant_12*0.16666666666666666;
       const real_t tmp_moved_constant_152 = tmp_moved_constant_150 + tmp_moved_constant_151;
       const real_t tmp_moved_constant_153 = tmp_moved_constant_2*0.16666666666666666;
       const real_t tmp_moved_constant_154 = tmp_moved_constant_0*0.16666666666666666;
       const real_t tmp_moved_constant_155 = tmp_moved_constant_153 + tmp_moved_constant_154;
       const real_t tmp_moved_constant_156 = tmp_moved_constant_8*0.16666666666666666;
       const real_t tmp_moved_constant_157 = tmp_moved_constant_6*0.16666666666666666;
       const real_t tmp_moved_constant_158 = tmp_moved_constant_156 + tmp_moved_constant_157;
       const real_t tmp_moved_constant_159 = tmp_moved_constant_14*0.16666666666666666;
       const real_t tmp_moved_constant_160 = tmp_moved_constant_12*0.16666666666666666;
       const real_t tmp_moved_constant_161 = tmp_moved_constant_159 + tmp_moved_constant_160;
       const real_t tmp_moved_constant_162 = jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_102;
       const real_t tmp_moved_constant_163 = jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_1;
       const real_t tmp_moved_constant_164 = jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_0;
       const real_t tmp_moved_constant_165 = tmp_moved_constant_163 + tmp_moved_constant_164;
       const real_t tmp_moved_constant_166 = jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_1;
       const real_t tmp_moved_constant_167 = jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_0;
       const real_t tmp_moved_constant_168 = tmp_moved_constant_166 + tmp_moved_constant_167;
       const real_t tmp_moved_constant_169 = jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_110;
       const real_t tmp_moved_constant_170 = jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_7;
       const real_t tmp_moved_constant_171 = jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_6;
       const real_t tmp_moved_constant_172 = tmp_moved_constant_170 + tmp_moved_constant_171;
       const real_t tmp_moved_constant_173 = jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_115;
       const real_t tmp_moved_constant_174 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_175 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_176 = tmp_moved_constant_174 + tmp_moved_constant_175;
       const real_t tmp_moved_constant_177 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_178 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_179 = tmp_moved_constant_177 + tmp_moved_constant_178;
       const real_t tmp_moved_constant_180 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_181 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_182 = tmp_moved_constant_180 + tmp_moved_constant_181;
       const real_t tmp_moved_constant_183 = tmp_moved_constant_1*0.5;
       const real_t tmp_moved_constant_184 = tmp_moved_constant_0*0.16666666666666666;
       const real_t tmp_moved_constant_185 = tmp_moved_constant_183 + tmp_moved_constant_184;
       const real_t tmp_moved_constant_186 = tmp_moved_constant_7*0.5;
       const real_t tmp_moved_constant_187 = tmp_moved_constant_6*0.16666666666666666;
       const real_t tmp_moved_constant_188 = tmp_moved_constant_186 + tmp_moved_constant_187;
       const real_t tmp_moved_constant_189 = tmp_moved_constant_13*0.5;
       const real_t tmp_moved_constant_190 = tmp_moved_constant_12*0.16666666666666666;
       const real_t tmp_moved_constant_191 = tmp_moved_constant_189 + tmp_moved_constant_190;
       const real_t tmp_moved_constant_192 = tmp_moved_constant_1*0.16666666666666666;
       const real_t tmp_moved_constant_193 = tmp_moved_constant_0*0.16666666666666666;
       const real_t tmp_moved_constant_194 = tmp_moved_constant_192 + tmp_moved_constant_193;
       const real_t tmp_moved_constant_195 = tmp_moved_constant_7*0.16666666666666666;
       const real_t tmp_moved_constant_196 = tmp_moved_constant_6*0.16666666666666666;
       const real_t tmp_moved_constant_197 = tmp_moved_constant_195 + tmp_moved_constant_196;
       const real_t tmp_moved_constant_198 = tmp_moved_constant_13*0.16666666666666666;
       const real_t tmp_moved_constant_199 = tmp_moved_constant_12*0.16666666666666666;
       const real_t tmp_moved_constant_200 = tmp_moved_constant_198 + tmp_moved_constant_199;
       const real_t tmp_moved_constant_201 = tmp_moved_constant_1*0.16666666666666666;
       const real_t tmp_moved_constant_202 = tmp_moved_constant_0*0.5;
       const real_t tmp_moved_constant_203 = tmp_moved_constant_201 + tmp_moved_constant_202;
       const real_t tmp_moved_constant_204 = tmp_moved_constant_7*0.16666666666666666;
       const real_t tmp_moved_constant_205 = tmp_moved_constant_6*0.5;
       const real_t tmp_moved_constant_206 = tmp_moved_constant_204 + tmp_moved_constant_205;
       const real_t tmp_moved_constant_207 = tmp_moved_constant_13*0.16666666666666666;
       const real_t tmp_moved_constant_208 = tmp_moved_constant_12*0.5;
       const real_t tmp_moved_constant_209 = tmp_moved_constant_207 + tmp_moved_constant_208;
       const real_t tmp_moved_constant_210 = tmp_moved_constant_1*0.16666666666666666;
       const real_t tmp_moved_constant_211 = tmp_moved_constant_0*0.16666666666666666;
       const real_t tmp_moved_constant_212 = tmp_moved_constant_210 + tmp_moved_constant_211;
       const real_t tmp_moved_constant_213 = tmp_moved_constant_7*0.16666666666666666;
       const real_t tmp_moved_constant_214 = tmp_moved_constant_6*0.16666666666666666;
       const real_t tmp_moved_constant_215 = tmp_moved_constant_213 + tmp_moved_constant_214;
       const real_t tmp_moved_constant_216 = tmp_moved_constant_13*0.16666666666666666;
       const real_t tmp_moved_constant_217 = tmp_moved_constant_12*0.16666666666666666;
       const real_t tmp_moved_constant_218 = tmp_moved_constant_216 + tmp_moved_constant_217;
       const real_t tmp_moved_constant_219 = jac_affine_inv_1_0_WHITE_DOWN*8.0;
       const real_t tmp_moved_constant_220 = jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_219;
       const real_t tmp_moved_constant_221 = jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_1;
       const real_t tmp_moved_constant_222 = jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_2;
       const real_t tmp_moved_constant_223 = tmp_moved_constant_221 + tmp_moved_constant_222;
       const real_t tmp_moved_constant_224 = jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_1;
       const real_t tmp_moved_constant_225 = jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_2;
       const real_t tmp_moved_constant_226 = tmp_moved_constant_224 + tmp_moved_constant_225;
       const real_t tmp_moved_constant_227 = jac_affine_inv_1_1_WHITE_DOWN*8.0;
       const real_t tmp_moved_constant_228 = jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_227;
       const real_t tmp_moved_constant_229 = jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_7;
       const real_t tmp_moved_constant_230 = jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_8;
       const real_t tmp_moved_constant_231 = tmp_moved_constant_229 + tmp_moved_constant_230;
       const real_t tmp_moved_constant_232 = jac_affine_inv_1_2_WHITE_DOWN*8.0;
       const real_t tmp_moved_constant_233 = jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_232;
       const real_t tmp_moved_constant_234 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_235 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_236 = tmp_moved_constant_234 + tmp_moved_constant_235;
       const real_t tmp_moved_constant_237 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_238 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_239 = tmp_moved_constant_237 + tmp_moved_constant_238;
       const real_t tmp_moved_constant_240 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_241 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_242 = tmp_moved_constant_240 + tmp_moved_constant_241;
       const real_t tmp_moved_constant_243 = tmp_moved_constant_1*0.16666666666666666;
       const real_t tmp_moved_constant_244 = tmp_moved_constant_2*0.16666666666666666;
       const real_t tmp_moved_constant_245 = tmp_moved_constant_243 + tmp_moved_constant_244;
       const real_t tmp_moved_constant_246 = tmp_moved_constant_7*0.16666666666666666;
       const real_t tmp_moved_constant_247 = tmp_moved_constant_8*0.16666666666666666;
       const real_t tmp_moved_constant_248 = tmp_moved_constant_246 + tmp_moved_constant_247;
       const real_t tmp_moved_constant_249 = tmp_moved_constant_13*0.16666666666666666;
       const real_t tmp_moved_constant_250 = tmp_moved_constant_14*0.16666666666666666;
       const real_t tmp_moved_constant_251 = tmp_moved_constant_249 + tmp_moved_constant_250;
       const real_t tmp_moved_constant_252 = tmp_moved_constant_1*0.5;
       const real_t tmp_moved_constant_253 = tmp_moved_constant_2*0.16666666666666666;
       const real_t tmp_moved_constant_254 = tmp_moved_constant_252 + tmp_moved_constant_253;
       const real_t tmp_moved_constant_255 = tmp_moved_constant_7*0.5;
       const real_t tmp_moved_constant_256 = tmp_moved_constant_8*0.16666666666666666;
       const real_t tmp_moved_constant_257 = tmp_moved_constant_255 + tmp_moved_constant_256;
       const real_t tmp_moved_constant_258 = tmp_moved_constant_13*0.5;
       const real_t tmp_moved_constant_259 = tmp_moved_constant_14*0.16666666666666666;
       const real_t tmp_moved_constant_260 = tmp_moved_constant_258 + tmp_moved_constant_259;
       const real_t tmp_moved_constant_261 = tmp_moved_constant_1*0.16666666666666666;
       const real_t tmp_moved_constant_262 = tmp_moved_constant_2*0.5;
       const real_t tmp_moved_constant_263 = tmp_moved_constant_261 + tmp_moved_constant_262;
       const real_t tmp_moved_constant_264 = tmp_moved_constant_7*0.16666666666666666;
       const real_t tmp_moved_constant_265 = tmp_moved_constant_8*0.5;
       const real_t tmp_moved_constant_266 = tmp_moved_constant_264 + tmp_moved_constant_265;
       const real_t tmp_moved_constant_267 = tmp_moved_constant_13*0.16666666666666666;
       const real_t tmp_moved_constant_268 = tmp_moved_constant_14*0.5;
       const real_t tmp_moved_constant_269 = tmp_moved_constant_267 + tmp_moved_constant_268;
       const real_t tmp_moved_constant_270 = tmp_moved_constant_1*0.16666666666666666;
       const real_t tmp_moved_constant_271 = tmp_moved_constant_2*0.16666666666666666;
       const real_t tmp_moved_constant_272 = tmp_moved_constant_270 + tmp_moved_constant_271;
       const real_t tmp_moved_constant_273 = tmp_moved_constant_7*0.16666666666666666;
       const real_t tmp_moved_constant_274 = tmp_moved_constant_8*0.16666666666666666;
       const real_t tmp_moved_constant_275 = tmp_moved_constant_273 + tmp_moved_constant_274;
       const real_t tmp_moved_constant_276 = tmp_moved_constant_13*0.16666666666666666;
       const real_t tmp_moved_constant_277 = tmp_moved_constant_14*0.16666666666666666;
       const real_t tmp_moved_constant_278 = tmp_moved_constant_276 + tmp_moved_constant_277;
       const real_t tmp_moved_constant_279 = jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_1;
       const real_t tmp_moved_constant_280 = jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_2;
       const real_t tmp_moved_constant_281 = -tmp_moved_constant_102 - tmp_moved_constant_3;
       const real_t tmp_moved_constant_282 = jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_281 - tmp_moved_constant_279 - tmp_moved_constant_280;
       const real_t tmp_moved_constant_283 = -tmp_moved_constant_110 - tmp_moved_constant_9;
       const real_t tmp_moved_constant_284 = jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_283 - tmp_moved_constant_104 - tmp_moved_constant_163;
       const real_t tmp_moved_constant_285 = -tmp_moved_constant_115 - tmp_moved_constant_15;
       const real_t tmp_moved_constant_286 = jac_affine_inv_2_0_WHITE_DOWN*tmp_moved_constant_285 - tmp_moved_constant_107 - tmp_moved_constant_166;
       const real_t tmp_moved_constant_287 = jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_281 - tmp_moved_constant_105 - tmp_moved_constant_164;
       const real_t tmp_moved_constant_288 = jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_7;
       const real_t tmp_moved_constant_289 = jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_8;
       const real_t tmp_moved_constant_290 = jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_283 - tmp_moved_constant_288 - tmp_moved_constant_289;
       const real_t tmp_moved_constant_291 = jac_affine_inv_2_1_WHITE_DOWN*tmp_moved_constant_285 - tmp_moved_constant_112 - tmp_moved_constant_170;
       const real_t tmp_moved_constant_292 = jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_281 - tmp_moved_constant_108 - tmp_moved_constant_167;
       const real_t tmp_moved_constant_293 = jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_283 - tmp_moved_constant_113 - tmp_moved_constant_171;
       const real_t tmp_moved_constant_294 = jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_13;
       const real_t tmp_moved_constant_295 = jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_14;
       const real_t tmp_moved_constant_296 = jac_affine_inv_2_2_WHITE_DOWN*tmp_moved_constant_285 - tmp_moved_constant_294 - tmp_moved_constant_295;
       const real_t tmp_moved_constant_297 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_752 - tmp_moved_constant_117 - tmp_moved_constant_174;
       const real_t tmp_moved_constant_298 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_752 - tmp_moved_constant_120 - tmp_moved_constant_177;
       const real_t tmp_moved_constant_299 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_752 - tmp_moved_constant_123 - tmp_moved_constant_180;
       const real_t tmp_moved_constant_300 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_757 - tmp_moved_constant_126 - tmp_moved_constant_183;
       const real_t tmp_moved_constant_301 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_757 - tmp_moved_constant_129 - tmp_moved_constant_186;
       const real_t tmp_moved_constant_302 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_757 - tmp_moved_constant_132 - tmp_moved_constant_189;
       const real_t tmp_moved_constant_303 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_762 - tmp_moved_constant_135 - tmp_moved_constant_192;
       const real_t tmp_moved_constant_304 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_762 - tmp_moved_constant_138 - tmp_moved_constant_195;
       const real_t tmp_moved_constant_305 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_762 - tmp_moved_constant_141 - tmp_moved_constant_198;
       const real_t tmp_moved_constant_306 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_767 - tmp_moved_constant_144 - tmp_moved_constant_201;
       const real_t tmp_moved_constant_307 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_767 - tmp_moved_constant_147 - tmp_moved_constant_204;
       const real_t tmp_moved_constant_308 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_767 - tmp_moved_constant_150 - tmp_moved_constant_207;
       const real_t tmp_moved_constant_309 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_772 - tmp_moved_constant_153 - tmp_moved_constant_210;
       const real_t tmp_moved_constant_310 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_772 - tmp_moved_constant_156 - tmp_moved_constant_213;
       const real_t tmp_moved_constant_311 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_772 - tmp_moved_constant_159 - tmp_moved_constant_216;
       const real_t tmp_moved_constant_312 = jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_1;
       const real_t tmp_moved_constant_313 = -tmp_moved_constant_0 - tmp_moved_constant_1 - tmp_moved_constant_219;
       const real_t tmp_moved_constant_314 = jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_313 - tmp_moved_constant_280 - tmp_moved_constant_312;
       const real_t tmp_moved_constant_315 = -tmp_moved_constant_227 - tmp_moved_constant_6 - tmp_moved_constant_7;
       const real_t tmp_moved_constant_316 = jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_315 - tmp_moved_constant_105 - tmp_moved_constant_221;
       const real_t tmp_moved_constant_317 = -tmp_moved_constant_12 - tmp_moved_constant_13 - tmp_moved_constant_232;
       const real_t tmp_moved_constant_318 = jac_affine_inv_1_0_WHITE_DOWN*tmp_moved_constant_317 - tmp_moved_constant_108 - tmp_moved_constant_224;
       const real_t tmp_moved_constant_319 = jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_313 - tmp_moved_constant_104 - tmp_moved_constant_222;
       const real_t tmp_moved_constant_320 = jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_7;
       const real_t tmp_moved_constant_321 = jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_315 - tmp_moved_constant_289 - tmp_moved_constant_320;
       const real_t tmp_moved_constant_322 = jac_affine_inv_1_1_WHITE_DOWN*tmp_moved_constant_317 - tmp_moved_constant_113 - tmp_moved_constant_229;
       const real_t tmp_moved_constant_323 = jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_313 - tmp_moved_constant_107 - tmp_moved_constant_225;
       const real_t tmp_moved_constant_324 = jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_315 - tmp_moved_constant_112 - tmp_moved_constant_230;
       const real_t tmp_moved_constant_325 = jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_13;
       const real_t tmp_moved_constant_326 = jac_affine_inv_1_2_WHITE_DOWN*tmp_moved_constant_317 - tmp_moved_constant_295 - tmp_moved_constant_325;
       const real_t tmp_moved_constant_327 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_793 - tmp_moved_constant_118 - tmp_moved_constant_234;
       const real_t tmp_moved_constant_328 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_793 - tmp_moved_constant_121 - tmp_moved_constant_237;
       const real_t tmp_moved_constant_329 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_793 - tmp_moved_constant_124 - tmp_moved_constant_240;
       const real_t tmp_moved_constant_330 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_799 - tmp_moved_constant_127 - tmp_moved_constant_243;
       const real_t tmp_moved_constant_331 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_799 - tmp_moved_constant_130 - tmp_moved_constant_246;
       const real_t tmp_moved_constant_332 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_799 - tmp_moved_constant_133 - tmp_moved_constant_249;
       const real_t tmp_moved_constant_333 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_805 - tmp_moved_constant_136 - tmp_moved_constant_252;
       const real_t tmp_moved_constant_334 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_805 - tmp_moved_constant_139 - tmp_moved_constant_255;
       const real_t tmp_moved_constant_335 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_805 - tmp_moved_constant_142 - tmp_moved_constant_258;
       const real_t tmp_moved_constant_336 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_811 - tmp_moved_constant_145 - tmp_moved_constant_261;
       const real_t tmp_moved_constant_337 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_811 - tmp_moved_constant_148 - tmp_moved_constant_264;
       const real_t tmp_moved_constant_338 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_811 - tmp_moved_constant_151 - tmp_moved_constant_267;
       const real_t tmp_moved_constant_339 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_817 - tmp_moved_constant_154 - tmp_moved_constant_270;
       const real_t tmp_moved_constant_340 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_817 - tmp_moved_constant_157 - tmp_moved_constant_273;
       const real_t tmp_moved_constant_341 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_817 - tmp_moved_constant_160 - tmp_moved_constant_276;
       const real_t tmp_moved_constant_342 = jac_affine_inv_0_0_WHITE_DOWN*-8.0 - tmp_moved_constant_0 - tmp_moved_constant_2;
       const real_t tmp_moved_constant_343 = jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_342 - tmp_moved_constant_279 - tmp_moved_constant_312;
       const real_t tmp_moved_constant_344 = jac_affine_inv_0_1_WHITE_DOWN*-8.0 - tmp_moved_constant_6 - tmp_moved_constant_8;
       const real_t tmp_moved_constant_345 = jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_344 - tmp_moved_constant_164 - tmp_moved_constant_222;
       const real_t tmp_moved_constant_346 = jac_affine_inv_0_2_WHITE_DOWN*-8.0 - tmp_moved_constant_12 - tmp_moved_constant_14;
       const real_t tmp_moved_constant_347 = jac_affine_inv_0_0_WHITE_DOWN*tmp_moved_constant_346 - tmp_moved_constant_167 - tmp_moved_constant_225;
       const real_t tmp_moved_constant_348 = jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_342 - tmp_moved_constant_163 - tmp_moved_constant_221;
       const real_t tmp_moved_constant_349 = jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_344 - tmp_moved_constant_288 - tmp_moved_constant_320;
       const real_t tmp_moved_constant_350 = jac_affine_inv_0_1_WHITE_DOWN*tmp_moved_constant_346 - tmp_moved_constant_171 - tmp_moved_constant_230;
       const real_t tmp_moved_constant_351 = jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_342 - tmp_moved_constant_166 - tmp_moved_constant_224;
       const real_t tmp_moved_constant_352 = jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_344 - tmp_moved_constant_170 - tmp_moved_constant_229;
       const real_t tmp_moved_constant_353 = jac_affine_inv_0_2_WHITE_DOWN*tmp_moved_constant_346 - tmp_moved_constant_294 - tmp_moved_constant_325;
       const real_t tmp_moved_constant_354 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_834 - tmp_moved_constant_175 - tmp_moved_constant_235;
       const real_t tmp_moved_constant_355 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_834 - tmp_moved_constant_178 - tmp_moved_constant_238;
       const real_t tmp_moved_constant_356 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_834 - tmp_moved_constant_181 - tmp_moved_constant_241;
       const real_t tmp_moved_constant_357 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_839 - tmp_moved_constant_184 - tmp_moved_constant_244;
       const real_t tmp_moved_constant_358 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_839 - tmp_moved_constant_187 - tmp_moved_constant_247;
       const real_t tmp_moved_constant_359 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_839 - tmp_moved_constant_190 - tmp_moved_constant_250;
       const real_t tmp_moved_constant_360 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_844 - tmp_moved_constant_193 - tmp_moved_constant_253;
       const real_t tmp_moved_constant_361 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_844 - tmp_moved_constant_196 - tmp_moved_constant_256;
       const real_t tmp_moved_constant_362 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_844 - tmp_moved_constant_199 - tmp_moved_constant_259;
       const real_t tmp_moved_constant_363 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_849 - tmp_moved_constant_202 - tmp_moved_constant_262;
       const real_t tmp_moved_constant_364 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_849 - tmp_moved_constant_205 - tmp_moved_constant_265;
       const real_t tmp_moved_constant_365 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_849 - tmp_moved_constant_208 - tmp_moved_constant_268;
       const real_t tmp_moved_constant_366 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_854 - tmp_moved_constant_211 - tmp_moved_constant_271;
       const real_t tmp_moved_constant_367 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_854 - tmp_moved_constant_214 - tmp_moved_constant_274;
       const real_t tmp_moved_constant_368 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_854 - tmp_moved_constant_217 - tmp_moved_constant_277;
       {
          /* CellType.WHITE_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
             const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
             const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
             const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
             const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
             const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
             const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
             const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
             const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
             const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
             const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
             const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
             const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
             const real_t tmp_blending_op_35 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_36 = tmp_blending_op_22 - tmp_blending_op_35;
             const real_t tmp_blending_op_37 = -tmp_blending_op_36;
             const real_t tmp_blending_op_38 = (tmp_blending_op_28*tmp_blending_op_28);
             const real_t tmp_blending_op_39 = (tmp_blending_op_33*tmp_blending_op_33);
             const real_t tmp_blending_op_40 = tmp_blending_op_38 + tmp_blending_op_39 + tmp_blending_op_4;
             const real_t tmp_blending_op_43 = tmp_blending_op_3*tmp_blending_op_42;
             const real_t tmp_blending_op_44 = tmp_blending_op_36 + tmp_blending_op_43;
             const real_t tmp_blending_op_45 = tmp_blending_op_37*tmp_blending_op_4 + tmp_blending_op_40*tmp_blending_op_44;
             const real_t tmp_blending_op_46 = pow(tmp_blending_op_40, -1.5000000000000000);
             const real_t tmp_blending_op_49 = tmp_blending_op_46*tmp_blending_op_48;
             const real_t tmp_blending_op_52 = tmp_blending_op_40*tmp_blending_op_51;
             const real_t tmp_blending_op_53 = -tmp_blending_op_33*tmp_blending_op_36 - tmp_blending_op_52;
             const real_t tmp_blending_op_54 = tmp_blending_op_49*tmp_blending_op_53;
             const real_t tmp_blending_op_57 = tmp_blending_op_28*tmp_blending_op_37 + tmp_blending_op_40*tmp_blending_op_56;
             const real_t tmp_blending_op_58 = tmp_blending_op_49*tmp_blending_op_57;
             const real_t tmp_blending_op_59 = tmp_blending_op_3*tmp_blending_op_37;
             const real_t tmp_blending_op_60 = tmp_blending_op_40*tmp_blending_op_42 + tmp_blending_op_59;
             const real_t tmp_blending_op_61 = tmp_blending_op_49*tmp_blending_op_60;
             const real_t tmp_blending_op_63 = tmp_blending_op_33*tmp_blending_op_62 + tmp_blending_op_36;
             const real_t tmp_blending_op_64 = tmp_blending_op_37*tmp_blending_op_39 + tmp_blending_op_40*tmp_blending_op_63;
             const real_t tmp_blending_op_65 = tmp_blending_op_28*tmp_blending_op_56;
             const real_t tmp_blending_op_66 = tmp_blending_op_36 + tmp_blending_op_65;
             const real_t tmp_blending_op_67 = -tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_40*tmp_blending_op_66;
             const real_t tmp_blending_op_75 = p_affine_0_2 + tmp_blending_op_0*0.5 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_76 = (tmp_blending_op_75*tmp_blending_op_75);
             const real_t tmp_blending_op_77 = -tmp_blending_op_17 - tmp_blending_op_75;
             const real_t tmp_blending_op_78 = p_affine_0_0 + tmp_blending_op_25*0.5 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_79 = -tmp_blending_op_6 - tmp_blending_op_78;
             const real_t tmp_blending_op_80 = p_affine_0_1 + tmp_blending_op_30*0.5 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_81 = -tmp_blending_op_13 - tmp_blending_op_80;
             const real_t tmp_blending_op_82 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_79 - tmp_blending_op_12*tmp_blending_op_77 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_77 - tmp_blending_op_19*tmp_blending_op_79 - tmp_blending_op_20*tmp_blending_op_81 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_81);
             const real_t tmp_blending_op_83 = tmp_blending_op_22 - tmp_blending_op_82;
             const real_t tmp_blending_op_84 = -tmp_blending_op_83;
             const real_t tmp_blending_op_85 = (tmp_blending_op_78*tmp_blending_op_78);
             const real_t tmp_blending_op_86 = (tmp_blending_op_80*tmp_blending_op_80);
             const real_t tmp_blending_op_87 = tmp_blending_op_76 + tmp_blending_op_85 + tmp_blending_op_86;
             const real_t tmp_blending_op_88 = tmp_blending_op_42*tmp_blending_op_75;
             const real_t tmp_blending_op_89 = tmp_blending_op_83 + tmp_blending_op_88;
             const real_t tmp_blending_op_90 = tmp_blending_op_76*tmp_blending_op_84 + tmp_blending_op_87*tmp_blending_op_89;
             const real_t tmp_blending_op_91 = pow(tmp_blending_op_87, -1.5000000000000000);
             const real_t tmp_blending_op_92 = tmp_blending_op_48*tmp_blending_op_91;
             const real_t tmp_blending_op_93 = tmp_blending_op_51*tmp_blending_op_87;
             const real_t tmp_blending_op_94 = -tmp_blending_op_80*tmp_blending_op_83 - tmp_blending_op_93;
             const real_t tmp_blending_op_95 = tmp_blending_op_92*tmp_blending_op_94;
             const real_t tmp_blending_op_96 = tmp_blending_op_56*tmp_blending_op_87 + tmp_blending_op_78*tmp_blending_op_84;
             const real_t tmp_blending_op_97 = tmp_blending_op_92*tmp_blending_op_96;
             const real_t tmp_blending_op_98 = tmp_blending_op_75*tmp_blending_op_84;
             const real_t tmp_blending_op_99 = tmp_blending_op_42*tmp_blending_op_87 + tmp_blending_op_98;
             const real_t tmp_blending_op_100 = tmp_blending_op_92*tmp_blending_op_99;
             const real_t tmp_blending_op_101 = tmp_blending_op_62*tmp_blending_op_80 + tmp_blending_op_83;
             const real_t tmp_blending_op_102 = tmp_blending_op_101*tmp_blending_op_87 + tmp_blending_op_84*tmp_blending_op_86;
             const real_t tmp_blending_op_103 = tmp_blending_op_56*tmp_blending_op_78;
             const real_t tmp_blending_op_104 = tmp_blending_op_103 + tmp_blending_op_83;
             const real_t tmp_blending_op_105 = tmp_blending_op_104*tmp_blending_op_87 - tmp_blending_op_83*tmp_blending_op_85;
             const real_t tmp_blending_op_113 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.5 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_114 = (tmp_blending_op_113*tmp_blending_op_113);
             const real_t tmp_blending_op_115 = -tmp_blending_op_113 - tmp_blending_op_17;
             const real_t tmp_blending_op_116 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.5 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_117 = -tmp_blending_op_116 - tmp_blending_op_6;
             const real_t tmp_blending_op_118 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.5 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_119 = -tmp_blending_op_118 - tmp_blending_op_13;
             const real_t tmp_blending_op_120 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_117*tmp_blending_op_18 - tmp_blending_op_115*tmp_blending_op_12 + tmp_blending_op_115*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_117*tmp_blending_op_19 - tmp_blending_op_119*tmp_blending_op_20 + tmp_blending_op_119*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_121 = -tmp_blending_op_120 + tmp_blending_op_22;
             const real_t tmp_blending_op_122 = -tmp_blending_op_121;
             const real_t tmp_blending_op_123 = (tmp_blending_op_116*tmp_blending_op_116);
             const real_t tmp_blending_op_124 = (tmp_blending_op_118*tmp_blending_op_118);
             const real_t tmp_blending_op_125 = tmp_blending_op_114 + tmp_blending_op_123 + tmp_blending_op_124;
             const real_t tmp_blending_op_126 = tmp_blending_op_113*tmp_blending_op_42;
             const real_t tmp_blending_op_127 = tmp_blending_op_121 + tmp_blending_op_126;
             const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_127;
             const real_t tmp_blending_op_129 = pow(tmp_blending_op_125, -1.5000000000000000);
             const real_t tmp_blending_op_130 = tmp_blending_op_129*tmp_blending_op_48;
             const real_t tmp_blending_op_131 = tmp_blending_op_125*tmp_blending_op_51;
             const real_t tmp_blending_op_132 = -tmp_blending_op_118*tmp_blending_op_121 - tmp_blending_op_131;
             const real_t tmp_blending_op_133 = tmp_blending_op_130*tmp_blending_op_132;
             const real_t tmp_blending_op_134 = tmp_blending_op_116*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_56;
             const real_t tmp_blending_op_135 = tmp_blending_op_130*tmp_blending_op_134;
             const real_t tmp_blending_op_136 = tmp_blending_op_113*tmp_blending_op_122;
             const real_t tmp_blending_op_137 = tmp_blending_op_125*tmp_blending_op_42 + tmp_blending_op_136;
             const real_t tmp_blending_op_138 = tmp_blending_op_130*tmp_blending_op_137;
             const real_t tmp_blending_op_139 = tmp_blending_op_118*tmp_blending_op_62 + tmp_blending_op_121;
             const real_t tmp_blending_op_140 = tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*tmp_blending_op_139;
             const real_t tmp_blending_op_141 = tmp_blending_op_116*tmp_blending_op_56;
             const real_t tmp_blending_op_142 = tmp_blending_op_121 + tmp_blending_op_141;
             const real_t tmp_blending_op_143 = -tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*tmp_blending_op_142;
             const real_t tmp_blending_op_151 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.5;
             const real_t tmp_blending_op_152 = (tmp_blending_op_151*tmp_blending_op_151);
             const real_t tmp_blending_op_153 = -tmp_blending_op_151 - tmp_blending_op_17;
             const real_t tmp_blending_op_154 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.5;
             const real_t tmp_blending_op_155 = -tmp_blending_op_154 - tmp_blending_op_6;
             const real_t tmp_blending_op_156 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.5;
             const real_t tmp_blending_op_157 = -tmp_blending_op_13 - tmp_blending_op_156;
             const real_t tmp_blending_op_158 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_155*tmp_blending_op_18 - tmp_blending_op_12*tmp_blending_op_153 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_153 - tmp_blending_op_155*tmp_blending_op_19 - tmp_blending_op_157*tmp_blending_op_20 + tmp_blending_op_157*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_159 = -tmp_blending_op_158 + tmp_blending_op_22;
             const real_t tmp_blending_op_160 = -tmp_blending_op_159;
             const real_t tmp_blending_op_161 = (tmp_blending_op_154*tmp_blending_op_154);
             const real_t tmp_blending_op_162 = (tmp_blending_op_156*tmp_blending_op_156);
             const real_t tmp_blending_op_163 = tmp_blending_op_152 + tmp_blending_op_161 + tmp_blending_op_162;
             const real_t tmp_blending_op_164 = tmp_blending_op_151*tmp_blending_op_42;
             const real_t tmp_blending_op_165 = tmp_blending_op_159 + tmp_blending_op_164;
             const real_t tmp_blending_op_166 = tmp_blending_op_152*tmp_blending_op_160 + tmp_blending_op_163*tmp_blending_op_165;
             const real_t tmp_blending_op_167 = pow(tmp_blending_op_163, -1.5000000000000000);
             const real_t tmp_blending_op_168 = tmp_blending_op_167*tmp_blending_op_48;
             const real_t tmp_blending_op_169 = tmp_blending_op_163*tmp_blending_op_51;
             const real_t tmp_blending_op_170 = -tmp_blending_op_156*tmp_blending_op_159 - tmp_blending_op_169;
             const real_t tmp_blending_op_171 = tmp_blending_op_168*tmp_blending_op_170;
             const real_t tmp_blending_op_172 = tmp_blending_op_154*tmp_blending_op_160 + tmp_blending_op_163*tmp_blending_op_56;
             const real_t tmp_blending_op_173 = tmp_blending_op_168*tmp_blending_op_172;
             const real_t tmp_blending_op_174 = tmp_blending_op_151*tmp_blending_op_160;
             const real_t tmp_blending_op_175 = tmp_blending_op_163*tmp_blending_op_42 + tmp_blending_op_174;
             const real_t tmp_blending_op_176 = tmp_blending_op_168*tmp_blending_op_175;
             const real_t tmp_blending_op_177 = tmp_blending_op_156*tmp_blending_op_62 + tmp_blending_op_159;
             const real_t tmp_blending_op_178 = tmp_blending_op_160*tmp_blending_op_162 + tmp_blending_op_163*tmp_blending_op_177;
             const real_t tmp_blending_op_179 = tmp_blending_op_154*tmp_blending_op_56;
             const real_t tmp_blending_op_180 = tmp_blending_op_159 + tmp_blending_op_179;
             const real_t tmp_blending_op_181 = -tmp_blending_op_159*tmp_blending_op_161 + tmp_blending_op_163*tmp_blending_op_180;
             const real_t tmp_blending_op_189 = p_affine_0_2 + tmp_blending_op_0*0.25 + tmp_blending_op_1*0.25 + tmp_blending_op_2*0.25;
             const real_t tmp_blending_op_190 = (tmp_blending_op_189*tmp_blending_op_189);
             const real_t tmp_blending_op_191 = -tmp_blending_op_17 - tmp_blending_op_189;
             const real_t tmp_blending_op_192 = p_affine_0_0 + tmp_blending_op_25*0.25 + tmp_blending_op_26*0.25 + tmp_blending_op_27*0.25;
             const real_t tmp_blending_op_193 = -tmp_blending_op_192 - tmp_blending_op_6;
             const real_t tmp_blending_op_194 = p_affine_0_1 + tmp_blending_op_30*0.25 + tmp_blending_op_31*0.25 + tmp_blending_op_32*0.25;
             const real_t tmp_blending_op_195 = -tmp_blending_op_13 - tmp_blending_op_194;
             const real_t tmp_blending_op_196 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_193 - tmp_blending_op_12*tmp_blending_op_191 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_191 - tmp_blending_op_19*tmp_blending_op_193 - tmp_blending_op_195*tmp_blending_op_20 + tmp_blending_op_195*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_197 = -tmp_blending_op_196 + tmp_blending_op_22;
             const real_t tmp_blending_op_198 = -tmp_blending_op_197;
             const real_t tmp_blending_op_199 = (tmp_blending_op_192*tmp_blending_op_192);
             const real_t tmp_blending_op_200 = (tmp_blending_op_194*tmp_blending_op_194);
             const real_t tmp_blending_op_201 = tmp_blending_op_190 + tmp_blending_op_199 + tmp_blending_op_200;
             const real_t tmp_blending_op_202 = tmp_blending_op_189*tmp_blending_op_42;
             const real_t tmp_blending_op_203 = tmp_blending_op_197 + tmp_blending_op_202;
             const real_t tmp_blending_op_204 = tmp_blending_op_190*tmp_blending_op_198 + tmp_blending_op_201*tmp_blending_op_203;
             const real_t tmp_blending_op_205 = pow(tmp_blending_op_201, -1.5000000000000000);
             const real_t tmp_blending_op_206 = tmp_blending_op_205*tmp_blending_op_48;
             const real_t tmp_blending_op_207 = tmp_blending_op_201*tmp_blending_op_51;
             const real_t tmp_blending_op_208 = -tmp_blending_op_194*tmp_blending_op_197 - tmp_blending_op_207;
             const real_t tmp_blending_op_209 = tmp_blending_op_206*tmp_blending_op_208;
             const real_t tmp_blending_op_210 = tmp_blending_op_192*tmp_blending_op_198 + tmp_blending_op_201*tmp_blending_op_56;
             const real_t tmp_blending_op_211 = tmp_blending_op_206*tmp_blending_op_210;
             const real_t tmp_blending_op_212 = tmp_blending_op_189*tmp_blending_op_198;
             const real_t tmp_blending_op_213 = tmp_blending_op_201*tmp_blending_op_42 + tmp_blending_op_212;
             const real_t tmp_blending_op_214 = tmp_blending_op_206*tmp_blending_op_213;
             const real_t tmp_blending_op_215 = tmp_blending_op_194*tmp_blending_op_62 + tmp_blending_op_197;
             const real_t tmp_blending_op_216 = tmp_blending_op_198*tmp_blending_op_200 + tmp_blending_op_201*tmp_blending_op_215;
             const real_t tmp_blending_op_217 = tmp_blending_op_192*tmp_blending_op_56;
             const real_t tmp_blending_op_218 = tmp_blending_op_197 + tmp_blending_op_217;
             const real_t tmp_blending_op_219 = -tmp_blending_op_197*tmp_blending_op_199 + tmp_blending_op_201*tmp_blending_op_218;
             const real_t tmp_blending_op_228 = pow(tmp_blending_op_201, -2.5000000000000000)*tmp_blending_op_227;
             const real_t tmp_blending_op_229 = tmp_blending_op_192*tmp_blending_op_228;
             const real_t tmp_blending_op_232 = tmp_blending_op_192*2.0;
             const real_t tmp_blending_op_234 = tmp_blending_op_196 + tmp_blending_op_233;
             const real_t tmp_blending_op_235 = tmp_blending_op_192*tmp_blending_op_230 + tmp_blending_op_217*2.0 + tmp_blending_op_234;
             const real_t tmp_blending_op_236 = tmp_blending_op_210*tmp_blending_op_229;
             const real_t tmp_blending_op_237 = tmp_blending_op_194*tmp_blending_op_23*tmp_blending_op_55 - tmp_blending_op_232*tmp_blending_op_51;
             const real_t tmp_blending_op_238 = tmp_blending_op_199*tmp_blending_op_228;
             const real_t tmp_blending_op_239 = -tmp_blending_op_201*tmp_blending_op_230;
             const real_t tmp_blending_op_240 = tmp_blending_op_208*tmp_blending_op_229;
             const real_t tmp_blending_op_241 = tmp_blending_op_189*tmp_blending_op_240;
             const real_t tmp_blending_op_242 = tmp_blending_op_189*tmp_blending_op_230 + tmp_blending_op_232*tmp_blending_op_42;
             const real_t tmp_blending_op_243 = tmp_blending_op_213*tmp_blending_op_229;
             const real_t tmp_blending_op_244 = tmp_blending_op_194*tmp_blending_op_243;
             const real_t tmp_blending_op_245 = -tmp_blending_op_207;
             const real_t tmp_blending_op_246 = tmp_blending_op_194*2.0;
             const real_t tmp_blending_op_247 = tmp_blending_op_194*tmp_blending_op_228;
             const real_t tmp_blending_op_248 = tmp_blending_op_206*(tmp_blending_op_192*tmp_blending_op_51 + tmp_blending_op_246*tmp_blending_op_56);
             const real_t tmp_blending_op_249 = tmp_blending_op_200*tmp_blending_op_228;
             const real_t tmp_blending_op_250 = tmp_blending_op_189*tmp_blending_op_247;
             const real_t tmp_blending_op_251 = -tmp_blending_op_210*tmp_blending_op_250;
             const real_t tmp_blending_op_252 = -tmp_blending_op_194*tmp_blending_op_51 - tmp_blending_op_197;
             const real_t tmp_blending_op_254 = tmp_blending_op_189*tmp_blending_op_51;
             const real_t tmp_blending_op_255 = tmp_blending_op_246*tmp_blending_op_42 + tmp_blending_op_254;
             const real_t tmp_blending_op_257 = -tmp_blending_op_201*tmp_blending_op_256;
             const real_t tmp_blending_op_258 = tmp_blending_op_189*2.0;
             const real_t tmp_blending_op_259 = tmp_blending_op_189*tmp_blending_op_228;
             const real_t tmp_blending_op_260 = tmp_blending_op_206*(tmp_blending_op_192*tmp_blending_op_256 + tmp_blending_op_258*tmp_blending_op_56);
             const real_t tmp_blending_op_261 = tmp_blending_op_190*tmp_blending_op_228;
             const real_t tmp_blending_op_262 = tmp_blending_op_206*(tmp_blending_op_194*tmp_blending_op_256 + tmp_blending_op_254*-2.0);
             const real_t tmp_blending_op_263 = tmp_blending_op_189*tmp_blending_op_256 + tmp_blending_op_202*2.0 + tmp_blending_op_234;
             const real_t tmp_blending_op_265 = pow(tmp_blending_op_163, -2.5000000000000000)*tmp_blending_op_227;
             const real_t tmp_blending_op_266 = tmp_blending_op_154*tmp_blending_op_265;
             const real_t tmp_blending_op_267 = tmp_blending_op_154*2.0;
             const real_t tmp_blending_op_268 = tmp_blending_op_158 + tmp_blending_op_233;
             const real_t tmp_blending_op_269 = tmp_blending_op_154*tmp_blending_op_230 + tmp_blending_op_179*2.0 + tmp_blending_op_268;
             const real_t tmp_blending_op_270 = tmp_blending_op_172*tmp_blending_op_266;
             const real_t tmp_blending_op_271 = tmp_blending_op_156*tmp_blending_op_23*tmp_blending_op_55 - tmp_blending_op_267*tmp_blending_op_51;
             const real_t tmp_blending_op_272 = tmp_blending_op_161*tmp_blending_op_265;
             const real_t tmp_blending_op_273 = -tmp_blending_op_163*tmp_blending_op_230;
             const real_t tmp_blending_op_274 = tmp_blending_op_170*tmp_blending_op_266;
             const real_t tmp_blending_op_275 = tmp_blending_op_151*tmp_blending_op_274;
             const real_t tmp_blending_op_276 = tmp_blending_op_151*tmp_blending_op_230 + tmp_blending_op_267*tmp_blending_op_42;
             const real_t tmp_blending_op_277 = tmp_blending_op_175*tmp_blending_op_266;
             const real_t tmp_blending_op_278 = tmp_blending_op_156*tmp_blending_op_277;
             const real_t tmp_blending_op_279 = -tmp_blending_op_169;
             const real_t tmp_blending_op_280 = tmp_blending_op_156*2.0;
             const real_t tmp_blending_op_281 = tmp_blending_op_156*tmp_blending_op_265;
             const real_t tmp_blending_op_282 = tmp_blending_op_168*(tmp_blending_op_154*tmp_blending_op_51 + tmp_blending_op_280*tmp_blending_op_56);
             const real_t tmp_blending_op_283 = tmp_blending_op_162*tmp_blending_op_265;
             const real_t tmp_blending_op_284 = tmp_blending_op_151*tmp_blending_op_281;
             const real_t tmp_blending_op_285 = -tmp_blending_op_172*tmp_blending_op_284;
             const real_t tmp_blending_op_286 = -tmp_blending_op_156*tmp_blending_op_51 - tmp_blending_op_159;
             const real_t tmp_blending_op_287 = tmp_blending_op_151*tmp_blending_op_51;
             const real_t tmp_blending_op_288 = tmp_blending_op_280*tmp_blending_op_42 + tmp_blending_op_287;
             const real_t tmp_blending_op_289 = -tmp_blending_op_163*tmp_blending_op_256;
             const real_t tmp_blending_op_290 = tmp_blending_op_151*2.0;
             const real_t tmp_blending_op_291 = tmp_blending_op_151*tmp_blending_op_265;
             const real_t tmp_blending_op_292 = tmp_blending_op_168*(tmp_blending_op_154*tmp_blending_op_256 + tmp_blending_op_290*tmp_blending_op_56);
             const real_t tmp_blending_op_293 = tmp_blending_op_152*tmp_blending_op_265;
             const real_t tmp_blending_op_294 = tmp_blending_op_168*(tmp_blending_op_156*tmp_blending_op_256 + tmp_blending_op_287*-2.0);
             const real_t tmp_blending_op_295 = tmp_blending_op_151*tmp_blending_op_256 + tmp_blending_op_164*2.0 + tmp_blending_op_268;
             const real_t tmp_blending_op_296 = pow(tmp_blending_op_125, -2.5000000000000000)*tmp_blending_op_227;
             const real_t tmp_blending_op_297 = tmp_blending_op_116*tmp_blending_op_296;
             const real_t tmp_blending_op_298 = tmp_blending_op_116*2.0;
             const real_t tmp_blending_op_299 = tmp_blending_op_120 + tmp_blending_op_233;
             const real_t tmp_blending_op_300 = tmp_blending_op_116*tmp_blending_op_230 + tmp_blending_op_141*2.0 + tmp_blending_op_299;
             const real_t tmp_blending_op_301 = tmp_blending_op_134*tmp_blending_op_297;
             const real_t tmp_blending_op_302 = tmp_blending_op_118*tmp_blending_op_23*tmp_blending_op_55 - tmp_blending_op_298*tmp_blending_op_51;
             const real_t tmp_blending_op_303 = tmp_blending_op_123*tmp_blending_op_296;
             const real_t tmp_blending_op_304 = -tmp_blending_op_125*tmp_blending_op_230;
             const real_t tmp_blending_op_305 = tmp_blending_op_132*tmp_blending_op_297;
             const real_t tmp_blending_op_306 = tmp_blending_op_113*tmp_blending_op_305;
             const real_t tmp_blending_op_307 = tmp_blending_op_113*tmp_blending_op_230 + tmp_blending_op_298*tmp_blending_op_42;
             const real_t tmp_blending_op_308 = tmp_blending_op_137*tmp_blending_op_297;
             const real_t tmp_blending_op_309 = tmp_blending_op_118*tmp_blending_op_308;
             const real_t tmp_blending_op_310 = -tmp_blending_op_131;
             const real_t tmp_blending_op_311 = tmp_blending_op_118*2.0;
             const real_t tmp_blending_op_312 = tmp_blending_op_118*tmp_blending_op_296;
             const real_t tmp_blending_op_313 = tmp_blending_op_130*(tmp_blending_op_116*tmp_blending_op_51 + tmp_blending_op_311*tmp_blending_op_56);
             const real_t tmp_blending_op_314 = tmp_blending_op_124*tmp_blending_op_296;
             const real_t tmp_blending_op_315 = tmp_blending_op_113*tmp_blending_op_312;
             const real_t tmp_blending_op_316 = -tmp_blending_op_134*tmp_blending_op_315;
             const real_t tmp_blending_op_317 = -tmp_blending_op_118*tmp_blending_op_51 - tmp_blending_op_121;
             const real_t tmp_blending_op_318 = tmp_blending_op_113*tmp_blending_op_51;
             const real_t tmp_blending_op_319 = tmp_blending_op_311*tmp_blending_op_42 + tmp_blending_op_318;
             const real_t tmp_blending_op_320 = -tmp_blending_op_125*tmp_blending_op_256;
             const real_t tmp_blending_op_321 = tmp_blending_op_113*2.0;
             const real_t tmp_blending_op_322 = tmp_blending_op_113*tmp_blending_op_296;
             const real_t tmp_blending_op_323 = tmp_blending_op_130*(tmp_blending_op_116*tmp_blending_op_256 + tmp_blending_op_321*tmp_blending_op_56);
             const real_t tmp_blending_op_324 = tmp_blending_op_114*tmp_blending_op_296;
             const real_t tmp_blending_op_325 = tmp_blending_op_130*(tmp_blending_op_118*tmp_blending_op_256 + tmp_blending_op_318*-2.0);
             const real_t tmp_blending_op_326 = tmp_blending_op_113*tmp_blending_op_256 + tmp_blending_op_126*2.0 + tmp_blending_op_299;
             const real_t tmp_blending_op_327 = tmp_blending_op_227*pow(tmp_blending_op_87, -2.5000000000000000);
             const real_t tmp_blending_op_328 = tmp_blending_op_327*tmp_blending_op_78;
             const real_t tmp_blending_op_329 = tmp_blending_op_78*2.0;
             const real_t tmp_blending_op_330 = tmp_blending_op_233 + tmp_blending_op_82;
             const real_t tmp_blending_op_331 = tmp_blending_op_103*2.0 + tmp_blending_op_230*tmp_blending_op_78 + tmp_blending_op_330;
             const real_t tmp_blending_op_332 = tmp_blending_op_328*tmp_blending_op_96;
             const real_t tmp_blending_op_333 = tmp_blending_op_23*tmp_blending_op_55*tmp_blending_op_80 - tmp_blending_op_329*tmp_blending_op_51;
             const real_t tmp_blending_op_334 = tmp_blending_op_327*tmp_blending_op_85;
             const real_t tmp_blending_op_335 = -tmp_blending_op_230*tmp_blending_op_87;
             const real_t tmp_blending_op_336 = tmp_blending_op_328*tmp_blending_op_94;
             const real_t tmp_blending_op_337 = tmp_blending_op_336*tmp_blending_op_75;
             const real_t tmp_blending_op_338 = tmp_blending_op_230*tmp_blending_op_75 + tmp_blending_op_329*tmp_blending_op_42;
             const real_t tmp_blending_op_339 = tmp_blending_op_328*tmp_blending_op_99;
             const real_t tmp_blending_op_340 = tmp_blending_op_339*tmp_blending_op_80;
             const real_t tmp_blending_op_341 = -tmp_blending_op_93;
             const real_t tmp_blending_op_342 = tmp_blending_op_80*2.0;
             const real_t tmp_blending_op_343 = tmp_blending_op_327*tmp_blending_op_80;
             const real_t tmp_blending_op_344 = tmp_blending_op_92*(tmp_blending_op_342*tmp_blending_op_56 + tmp_blending_op_51*tmp_blending_op_78);
             const real_t tmp_blending_op_345 = tmp_blending_op_327*tmp_blending_op_86;
             const real_t tmp_blending_op_346 = tmp_blending_op_343*tmp_blending_op_75;
             const real_t tmp_blending_op_347 = -tmp_blending_op_346*tmp_blending_op_96;
             const real_t tmp_blending_op_348 = -tmp_blending_op_51*tmp_blending_op_80 - tmp_blending_op_83;
             const real_t tmp_blending_op_349 = tmp_blending_op_51*tmp_blending_op_75;
             const real_t tmp_blending_op_350 = tmp_blending_op_342*tmp_blending_op_42 + tmp_blending_op_349;
             const real_t tmp_blending_op_351 = -tmp_blending_op_256*tmp_blending_op_87;
             const real_t tmp_blending_op_352 = tmp_blending_op_75*2.0;
             const real_t tmp_blending_op_353 = tmp_blending_op_327*tmp_blending_op_75;
             const real_t tmp_blending_op_354 = tmp_blending_op_92*(tmp_blending_op_256*tmp_blending_op_78 + tmp_blending_op_352*tmp_blending_op_56);
             const real_t tmp_blending_op_355 = tmp_blending_op_327*tmp_blending_op_76;
             const real_t tmp_blending_op_356 = tmp_blending_op_92*(tmp_blending_op_256*tmp_blending_op_80 + tmp_blending_op_349*-2.0);
             const real_t tmp_blending_op_357 = tmp_blending_op_256*tmp_blending_op_75 + tmp_blending_op_330 + tmp_blending_op_88*2.0;
             const real_t tmp_blending_op_358 = tmp_blending_op_227*pow(tmp_blending_op_40, -2.5000000000000000);
             const real_t tmp_blending_op_359 = tmp_blending_op_28*tmp_blending_op_358;
             const real_t tmp_blending_op_360 = tmp_blending_op_28*2.0;
             const real_t tmp_blending_op_361 = tmp_blending_op_233 + tmp_blending_op_35;
             const real_t tmp_blending_op_362 = tmp_blending_op_230*tmp_blending_op_28 + tmp_blending_op_361 + tmp_blending_op_65*2.0;
             const real_t tmp_blending_op_363 = tmp_blending_op_359*tmp_blending_op_57;
             const real_t tmp_blending_op_364 = tmp_blending_op_23*tmp_blending_op_33*tmp_blending_op_55 - tmp_blending_op_360*tmp_blending_op_51;
             const real_t tmp_blending_op_365 = tmp_blending_op_358*tmp_blending_op_38;
             const real_t tmp_blending_op_366 = -tmp_blending_op_230*tmp_blending_op_40;
             const real_t tmp_blending_op_367 = tmp_blending_op_359*tmp_blending_op_53;
             const real_t tmp_blending_op_368 = tmp_blending_op_3*tmp_blending_op_367;
             const real_t tmp_blending_op_369 = tmp_blending_op_230*tmp_blending_op_3 + tmp_blending_op_360*tmp_blending_op_42;
             const real_t tmp_blending_op_370 = tmp_blending_op_359*tmp_blending_op_60;
             const real_t tmp_blending_op_371 = tmp_blending_op_33*tmp_blending_op_370;
             const real_t tmp_blending_op_372 = -tmp_blending_op_52;
             const real_t tmp_blending_op_373 = tmp_blending_op_33*2.0;
             const real_t tmp_blending_op_374 = tmp_blending_op_33*tmp_blending_op_358;
             const real_t tmp_blending_op_375 = tmp_blending_op_49*(tmp_blending_op_28*tmp_blending_op_51 + tmp_blending_op_373*tmp_blending_op_56);
             const real_t tmp_blending_op_376 = tmp_blending_op_358*tmp_blending_op_39;
             const real_t tmp_blending_op_377 = tmp_blending_op_3*tmp_blending_op_374;
             const real_t tmp_blending_op_378 = -tmp_blending_op_377*tmp_blending_op_57;
             const real_t tmp_blending_op_379 = -tmp_blending_op_33*tmp_blending_op_51 - tmp_blending_op_36;
             const real_t tmp_blending_op_380 = tmp_blending_op_3*tmp_blending_op_51;
             const real_t tmp_blending_op_381 = tmp_blending_op_373*tmp_blending_op_42 + tmp_blending_op_380;
             const real_t tmp_blending_op_382 = -tmp_blending_op_256*tmp_blending_op_40;
             const real_t tmp_blending_op_383 = tmp_blending_op_3*2.0;
             const real_t tmp_blending_op_384 = tmp_blending_op_3*tmp_blending_op_358;
             const real_t tmp_blending_op_385 = tmp_blending_op_49*(tmp_blending_op_256*tmp_blending_op_28 + tmp_blending_op_383*tmp_blending_op_56);
             const real_t tmp_blending_op_386 = tmp_blending_op_358*tmp_blending_op_4;
             const real_t tmp_blending_op_387 = tmp_blending_op_49*(tmp_blending_op_256*tmp_blending_op_33 + tmp_blending_op_380*-2.0);
             const real_t tmp_blending_op_388 = tmp_blending_op_256*tmp_blending_op_3 + tmp_blending_op_361 + tmp_blending_op_43*2.0;
             const real_t jac_blending_2_2_q_4 = tmp_blending_op_45*tmp_blending_op_49;
             const real_t jac_blending_2_1_q_4 = tmp_blending_op_3*tmp_blending_op_54;
             const real_t jac_blending_2_0_q_4 = tmp_blending_op_3*tmp_blending_op_58;
             const real_t jac_blending_1_2_q_4 = tmp_blending_op_33*tmp_blending_op_61;
             const real_t jac_blending_1_1_q_4 = tmp_blending_op_49*tmp_blending_op_64;
             const real_t tmp_blending_op_72 = jac_blending_1_1_q_4*jac_blending_2_0_q_4;
             const real_t jac_blending_1_0_q_4 = tmp_blending_op_33*tmp_blending_op_58;
             const real_t tmp_blending_op_69 = jac_blending_1_0_q_4*jac_blending_2_1_q_4;
             const real_t jac_blending_0_2_q_4 = tmp_blending_op_28*tmp_blending_op_61;
             const real_t jac_blending_0_1_q_4 = tmp_blending_op_28*tmp_blending_op_54;
             const real_t tmp_blending_op_71 = jac_blending_0_1_q_4*jac_blending_1_0_q_4;
             const real_t jac_blending_0_0_q_4 = tmp_blending_op_49*tmp_blending_op_67;
             const real_t tmp_blending_op_68 = jac_blending_0_0_q_4*jac_blending_1_1_q_4;
             const real_t tmp_blending_op_70 = jac_blending_0_0_q_4*jac_blending_2_1_q_4;
             const real_t tmp_blending_op_73 = jac_blending_0_1_q_4*jac_blending_1_2_q_4*jac_blending_2_0_q_4 + jac_blending_0_2_q_4*tmp_blending_op_69 - jac_blending_0_2_q_4*tmp_blending_op_72 - jac_blending_1_2_q_4*tmp_blending_op_70 + jac_blending_2_2_q_4*tmp_blending_op_68 - jac_blending_2_2_q_4*tmp_blending_op_71;
             const real_t tmp_blending_op_74 = 1.0 / (tmp_blending_op_73);
             const real_t abs_det_jac_blending_q_4 = tmp_blending_op_73;
             const real_t jac_blending_inv_2_2_q_4 = tmp_blending_op_74*(tmp_blending_op_68 - tmp_blending_op_71);
             const real_t jac_blending_inv_2_1_q_4 = tmp_blending_op_74*(jac_blending_0_1_q_4*jac_blending_2_0_q_4 - tmp_blending_op_70);
             const real_t jac_blending_inv_2_0_q_4 = tmp_blending_op_74*(tmp_blending_op_69 - tmp_blending_op_72);
             const real_t jac_blending_inv_1_2_q_4 = tmp_blending_op_74*(-jac_blending_0_0_q_4*jac_blending_1_2_q_4 + jac_blending_0_2_q_4*jac_blending_1_0_q_4);
             const real_t jac_blending_inv_1_1_q_4 = tmp_blending_op_74*(jac_blending_0_0_q_4*jac_blending_2_2_q_4 - jac_blending_0_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_1_0_q_4 = tmp_blending_op_74*(-jac_blending_1_0_q_4*jac_blending_2_2_q_4 + jac_blending_1_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_0_2_q_4 = tmp_blending_op_74*(jac_blending_0_1_q_4*jac_blending_1_2_q_4 - jac_blending_0_2_q_4*jac_blending_1_1_q_4);
             const real_t jac_blending_inv_0_1_q_4 = tmp_blending_op_74*(-jac_blending_0_1_q_4*jac_blending_2_2_q_4 + jac_blending_0_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_inv_0_0_q_4 = tmp_blending_op_74*(jac_blending_1_1_q_4*jac_blending_2_2_q_4 - jac_blending_1_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_2_2_q_3 = tmp_blending_op_90*tmp_blending_op_92;
             const real_t jac_blending_2_1_q_3 = tmp_blending_op_75*tmp_blending_op_95;
             const real_t jac_blending_2_0_q_3 = tmp_blending_op_75*tmp_blending_op_97;
             const real_t jac_blending_1_2_q_3 = tmp_blending_op_100*tmp_blending_op_80;
             const real_t jac_blending_1_1_q_3 = tmp_blending_op_102*tmp_blending_op_92;
             const real_t tmp_blending_op_110 = jac_blending_1_1_q_3*jac_blending_2_0_q_3;
             const real_t jac_blending_1_0_q_3 = tmp_blending_op_80*tmp_blending_op_97;
             const real_t tmp_blending_op_107 = jac_blending_1_0_q_3*jac_blending_2_1_q_3;
             const real_t jac_blending_0_2_q_3 = tmp_blending_op_100*tmp_blending_op_78;
             const real_t jac_blending_0_1_q_3 = tmp_blending_op_78*tmp_blending_op_95;
             const real_t tmp_blending_op_109 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
             const real_t jac_blending_0_0_q_3 = tmp_blending_op_105*tmp_blending_op_92;
             const real_t tmp_blending_op_106 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
             const real_t tmp_blending_op_108 = jac_blending_0_0_q_3*jac_blending_2_1_q_3;
             const real_t tmp_blending_op_111 = jac_blending_0_1_q_3*jac_blending_1_2_q_3*jac_blending_2_0_q_3 + jac_blending_0_2_q_3*tmp_blending_op_107 - jac_blending_0_2_q_3*tmp_blending_op_110 - jac_blending_1_2_q_3*tmp_blending_op_108 + jac_blending_2_2_q_3*tmp_blending_op_106 - jac_blending_2_2_q_3*tmp_blending_op_109;
             const real_t tmp_blending_op_112 = 1.0 / (tmp_blending_op_111);
             const real_t abs_det_jac_blending_q_3 = tmp_blending_op_111;
             const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_112*(tmp_blending_op_106 - tmp_blending_op_109);
             const real_t jac_blending_inv_2_1_q_3 = tmp_blending_op_112*(jac_blending_0_1_q_3*jac_blending_2_0_q_3 - tmp_blending_op_108);
             const real_t jac_blending_inv_2_0_q_3 = tmp_blending_op_112*(tmp_blending_op_107 - tmp_blending_op_110);
             const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_112*(-jac_blending_0_0_q_3*jac_blending_1_2_q_3 + jac_blending_0_2_q_3*jac_blending_1_0_q_3);
             const real_t jac_blending_inv_1_1_q_3 = tmp_blending_op_112*(jac_blending_0_0_q_3*jac_blending_2_2_q_3 - jac_blending_0_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_1_0_q_3 = tmp_blending_op_112*(-jac_blending_1_0_q_3*jac_blending_2_2_q_3 + jac_blending_1_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_112*(jac_blending_0_1_q_3*jac_blending_1_2_q_3 - jac_blending_0_2_q_3*jac_blending_1_1_q_3);
             const real_t jac_blending_inv_0_1_q_3 = tmp_blending_op_112*(-jac_blending_0_1_q_3*jac_blending_2_2_q_3 + jac_blending_0_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_inv_0_0_q_3 = tmp_blending_op_112*(jac_blending_1_1_q_3*jac_blending_2_2_q_3 - jac_blending_1_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_2_2_q_2 = tmp_blending_op_128*tmp_blending_op_130;
             const real_t jac_blending_2_1_q_2 = tmp_blending_op_113*tmp_blending_op_133;
             const real_t jac_blending_2_0_q_2 = tmp_blending_op_113*tmp_blending_op_135;
             const real_t jac_blending_1_2_q_2 = tmp_blending_op_118*tmp_blending_op_138;
             const real_t jac_blending_1_1_q_2 = tmp_blending_op_130*tmp_blending_op_140;
             const real_t tmp_blending_op_148 = jac_blending_1_1_q_2*jac_blending_2_0_q_2;
             const real_t jac_blending_1_0_q_2 = tmp_blending_op_118*tmp_blending_op_135;
             const real_t tmp_blending_op_145 = jac_blending_1_0_q_2*jac_blending_2_1_q_2;
             const real_t jac_blending_0_2_q_2 = tmp_blending_op_116*tmp_blending_op_138;
             const real_t jac_blending_0_1_q_2 = tmp_blending_op_116*tmp_blending_op_133;
             const real_t tmp_blending_op_147 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
             const real_t jac_blending_0_0_q_2 = tmp_blending_op_130*tmp_blending_op_143;
             const real_t tmp_blending_op_144 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
             const real_t tmp_blending_op_146 = jac_blending_0_0_q_2*jac_blending_2_1_q_2;
             const real_t tmp_blending_op_149 = jac_blending_0_1_q_2*jac_blending_1_2_q_2*jac_blending_2_0_q_2 + jac_blending_0_2_q_2*tmp_blending_op_145 - jac_blending_0_2_q_2*tmp_blending_op_148 - jac_blending_1_2_q_2*tmp_blending_op_146 + jac_blending_2_2_q_2*tmp_blending_op_144 - jac_blending_2_2_q_2*tmp_blending_op_147;
             const real_t tmp_blending_op_150 = 1.0 / (tmp_blending_op_149);
             const real_t abs_det_jac_blending_q_2 = tmp_blending_op_149;
             const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_150*(tmp_blending_op_144 - tmp_blending_op_147);
             const real_t jac_blending_inv_2_1_q_2 = tmp_blending_op_150*(jac_blending_0_1_q_2*jac_blending_2_0_q_2 - tmp_blending_op_146);
             const real_t jac_blending_inv_2_0_q_2 = tmp_blending_op_150*(tmp_blending_op_145 - tmp_blending_op_148);
             const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_150*(-jac_blending_0_0_q_2*jac_blending_1_2_q_2 + jac_blending_0_2_q_2*jac_blending_1_0_q_2);
             const real_t jac_blending_inv_1_1_q_2 = tmp_blending_op_150*(jac_blending_0_0_q_2*jac_blending_2_2_q_2 - jac_blending_0_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_1_0_q_2 = tmp_blending_op_150*(-jac_blending_1_0_q_2*jac_blending_2_2_q_2 + jac_blending_1_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_150*(jac_blending_0_1_q_2*jac_blending_1_2_q_2 - jac_blending_0_2_q_2*jac_blending_1_1_q_2);
             const real_t jac_blending_inv_0_1_q_2 = tmp_blending_op_150*(-jac_blending_0_1_q_2*jac_blending_2_2_q_2 + jac_blending_0_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_inv_0_0_q_2 = tmp_blending_op_150*(jac_blending_1_1_q_2*jac_blending_2_2_q_2 - jac_blending_1_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_2_2_q_1 = tmp_blending_op_166*tmp_blending_op_168;
             const real_t jac_blending_2_1_q_1 = tmp_blending_op_151*tmp_blending_op_171;
             const real_t jac_blending_2_0_q_1 = tmp_blending_op_151*tmp_blending_op_173;
             const real_t jac_blending_1_2_q_1 = tmp_blending_op_156*tmp_blending_op_176;
             const real_t jac_blending_1_1_q_1 = tmp_blending_op_168*tmp_blending_op_178;
             const real_t tmp_blending_op_186 = jac_blending_1_1_q_1*jac_blending_2_0_q_1;
             const real_t jac_blending_1_0_q_1 = tmp_blending_op_156*tmp_blending_op_173;
             const real_t tmp_blending_op_183 = jac_blending_1_0_q_1*jac_blending_2_1_q_1;
             const real_t jac_blending_0_2_q_1 = tmp_blending_op_154*tmp_blending_op_176;
             const real_t jac_blending_0_1_q_1 = tmp_blending_op_154*tmp_blending_op_171;
             const real_t tmp_blending_op_185 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
             const real_t jac_blending_0_0_q_1 = tmp_blending_op_168*tmp_blending_op_181;
             const real_t tmp_blending_op_182 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
             const real_t tmp_blending_op_184 = jac_blending_0_0_q_1*jac_blending_2_1_q_1;
             const real_t tmp_blending_op_187 = jac_blending_0_1_q_1*jac_blending_1_2_q_1*jac_blending_2_0_q_1 + jac_blending_0_2_q_1*tmp_blending_op_183 - jac_blending_0_2_q_1*tmp_blending_op_186 - jac_blending_1_2_q_1*tmp_blending_op_184 + jac_blending_2_2_q_1*tmp_blending_op_182 - jac_blending_2_2_q_1*tmp_blending_op_185;
             const real_t tmp_blending_op_188 = 1.0 / (tmp_blending_op_187);
             const real_t abs_det_jac_blending_q_1 = tmp_blending_op_187;
             const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_188*(tmp_blending_op_182 - tmp_blending_op_185);
             const real_t jac_blending_inv_2_1_q_1 = tmp_blending_op_188*(jac_blending_0_1_q_1*jac_blending_2_0_q_1 - tmp_blending_op_184);
             const real_t jac_blending_inv_2_0_q_1 = tmp_blending_op_188*(tmp_blending_op_183 - tmp_blending_op_186);
             const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_188*(-jac_blending_0_0_q_1*jac_blending_1_2_q_1 + jac_blending_0_2_q_1*jac_blending_1_0_q_1);
             const real_t jac_blending_inv_1_1_q_1 = tmp_blending_op_188*(jac_blending_0_0_q_1*jac_blending_2_2_q_1 - jac_blending_0_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_1_0_q_1 = tmp_blending_op_188*(-jac_blending_1_0_q_1*jac_blending_2_2_q_1 + jac_blending_1_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_188*(jac_blending_0_1_q_1*jac_blending_1_2_q_1 - jac_blending_0_2_q_1*jac_blending_1_1_q_1);
             const real_t jac_blending_inv_0_1_q_1 = tmp_blending_op_188*(-jac_blending_0_1_q_1*jac_blending_2_2_q_1 + jac_blending_0_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_inv_0_0_q_1 = tmp_blending_op_188*(jac_blending_1_1_q_1*jac_blending_2_2_q_1 - jac_blending_1_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_2_2_q_0 = tmp_blending_op_204*tmp_blending_op_206;
             const real_t jac_blending_2_1_q_0 = tmp_blending_op_189*tmp_blending_op_209;
             const real_t jac_blending_2_0_q_0 = tmp_blending_op_189*tmp_blending_op_211;
             const real_t jac_blending_1_2_q_0 = tmp_blending_op_194*tmp_blending_op_214;
             const real_t jac_blending_1_1_q_0 = tmp_blending_op_206*tmp_blending_op_216;
             const real_t tmp_blending_op_224 = jac_blending_1_1_q_0*jac_blending_2_0_q_0;
             const real_t jac_blending_1_0_q_0 = tmp_blending_op_194*tmp_blending_op_211;
             const real_t tmp_blending_op_221 = jac_blending_1_0_q_0*jac_blending_2_1_q_0;
             const real_t jac_blending_0_2_q_0 = tmp_blending_op_192*tmp_blending_op_214;
             const real_t jac_blending_0_1_q_0 = tmp_blending_op_192*tmp_blending_op_209;
             const real_t tmp_blending_op_223 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
             const real_t jac_blending_0_0_q_0 = tmp_blending_op_206*tmp_blending_op_219;
             const real_t tmp_blending_op_220 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
             const real_t tmp_blending_op_222 = jac_blending_0_0_q_0*jac_blending_2_1_q_0;
             const real_t tmp_blending_op_225 = jac_blending_0_1_q_0*jac_blending_1_2_q_0*jac_blending_2_0_q_0 + jac_blending_0_2_q_0*tmp_blending_op_221 - jac_blending_0_2_q_0*tmp_blending_op_224 - jac_blending_1_2_q_0*tmp_blending_op_222 + jac_blending_2_2_q_0*tmp_blending_op_220 - jac_blending_2_2_q_0*tmp_blending_op_223;
             const real_t tmp_blending_op_226 = 1.0 / (tmp_blending_op_225);
             const real_t abs_det_jac_blending_q_0 = tmp_blending_op_225;
             const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_226*(tmp_blending_op_220 - tmp_blending_op_223);
             const real_t jac_blending_inv_2_1_q_0 = tmp_blending_op_226*(jac_blending_0_1_q_0*jac_blending_2_0_q_0 - tmp_blending_op_222);
             const real_t jac_blending_inv_2_0_q_0 = tmp_blending_op_226*(tmp_blending_op_221 - tmp_blending_op_224);
             const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_226*(-jac_blending_0_0_q_0*jac_blending_1_2_q_0 + jac_blending_0_2_q_0*jac_blending_1_0_q_0);
             const real_t jac_blending_inv_1_1_q_0 = tmp_blending_op_226*(jac_blending_0_0_q_0*jac_blending_2_2_q_0 - jac_blending_0_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_1_0_q_0 = tmp_blending_op_226*(-jac_blending_1_0_q_0*jac_blending_2_2_q_0 + jac_blending_1_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_226*(jac_blending_0_1_q_0*jac_blending_1_2_q_0 - jac_blending_0_2_q_0*jac_blending_1_1_q_0);
             const real_t jac_blending_inv_0_1_q_0 = tmp_blending_op_226*(-jac_blending_0_1_q_0*jac_blending_2_2_q_0 + jac_blending_0_2_q_0*jac_blending_2_1_q_0);
             const real_t jac_blending_inv_0_0_q_0 = tmp_blending_op_226*(jac_blending_1_1_q_0*jac_blending_2_2_q_0 - jac_blending_1_2_q_0*jac_blending_2_1_q_0);
             const real_t hessian_blending_0_0_0_q_0 = tmp_blending_op_205*tmp_blending_op_47*(-tmp_blending_op_197*tmp_blending_op_232 + tmp_blending_op_199*tmp_blending_op_230 + tmp_blending_op_201*tmp_blending_op_231 + tmp_blending_op_218*tmp_blending_op_232)*1.0 - tmp_blending_op_219*tmp_blending_op_229;
             const real_t hessian_blending_0_0_1_q_0 = tmp_blending_op_194*tmp_blending_op_205*tmp_blending_op_235*tmp_blending_op_47*1.0 - tmp_blending_op_194*tmp_blending_op_236;
             const real_t hessian_blending_0_0_2_q_0 = tmp_blending_op_189*tmp_blending_op_205*tmp_blending_op_235*tmp_blending_op_47*1.0 - tmp_blending_op_189*tmp_blending_op_236;
             const real_t hessian_blending_0_1_0_q_0 = tmp_blending_op_192*tmp_blending_op_206*tmp_blending_op_237 - tmp_blending_op_208*tmp_blending_op_238 + tmp_blending_op_209;
             const real_t hessian_blending_0_1_1_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_200*tmp_blending_op_230 + tmp_blending_op_215*tmp_blending_op_232 + tmp_blending_op_239)*1.0 - tmp_blending_op_216*tmp_blending_op_229;
             const real_t hessian_blending_0_1_2_q_0 = tmp_blending_op_189*tmp_blending_op_205*tmp_blending_op_237*tmp_blending_op_47*1.0 - tmp_blending_op_241;
             const real_t hessian_blending_0_2_0_q_0 = tmp_blending_op_192*tmp_blending_op_206*tmp_blending_op_242 - tmp_blending_op_213*tmp_blending_op_238 + tmp_blending_op_214;
             const real_t hessian_blending_0_2_1_q_0 = tmp_blending_op_194*tmp_blending_op_205*tmp_blending_op_242*tmp_blending_op_47*1.0 - tmp_blending_op_244;
             const real_t hessian_blending_0_2_2_q_0 = -tmp_blending_op_204*tmp_blending_op_229 + tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_190*tmp_blending_op_230 + tmp_blending_op_203*tmp_blending_op_232 + tmp_blending_op_239)*1.0;
             const real_t hessian_blending_1_0_0_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_199*tmp_blending_op_51 + tmp_blending_op_218*tmp_blending_op_246 + tmp_blending_op_245)*1.0 - tmp_blending_op_219*tmp_blending_op_247;
             const real_t hessian_blending_1_0_1_q_0 = tmp_blending_op_194*tmp_blending_op_248 - tmp_blending_op_210*tmp_blending_op_249 + tmp_blending_op_211;
             const real_t hessian_blending_1_0_2_q_0 = tmp_blending_op_189*tmp_blending_op_248 + tmp_blending_op_251;
             const real_t hessian_blending_1_1_0_q_0 = tmp_blending_op_192*tmp_blending_op_205*tmp_blending_op_252*tmp_blending_op_47*1.0 - tmp_blending_op_194*tmp_blending_op_240;
             const real_t hessian_blending_1_1_1_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_198*tmp_blending_op_246 + tmp_blending_op_200*tmp_blending_op_51 + tmp_blending_op_201*tmp_blending_op_253 + tmp_blending_op_215*tmp_blending_op_246)*1.0 - tmp_blending_op_216*tmp_blending_op_247;
             const real_t hessian_blending_1_1_2_q_0 = tmp_blending_op_189*tmp_blending_op_205*tmp_blending_op_252*tmp_blending_op_47*1.0 - tmp_blending_op_208*tmp_blending_op_250;
             const real_t hessian_blending_1_2_0_q_0 = tmp_blending_op_192*tmp_blending_op_205*tmp_blending_op_255*tmp_blending_op_47*1.0 - tmp_blending_op_244;
             const real_t hessian_blending_1_2_1_q_0 = tmp_blending_op_194*tmp_blending_op_206*tmp_blending_op_255 - tmp_blending_op_213*tmp_blending_op_249 + tmp_blending_op_214;
             const real_t hessian_blending_1_2_2_q_0 = -tmp_blending_op_204*tmp_blending_op_247 + tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_190*tmp_blending_op_51 + tmp_blending_op_203*tmp_blending_op_246 + tmp_blending_op_245)*1.0;
             const real_t hessian_blending_2_0_0_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_199*tmp_blending_op_256 + tmp_blending_op_218*tmp_blending_op_258 + tmp_blending_op_257)*1.0 - tmp_blending_op_219*tmp_blending_op_259;
             const real_t hessian_blending_2_0_1_q_0 = tmp_blending_op_194*tmp_blending_op_260 + tmp_blending_op_251;
             const real_t hessian_blending_2_0_2_q_0 = tmp_blending_op_189*tmp_blending_op_260 - tmp_blending_op_210*tmp_blending_op_261 + tmp_blending_op_211;
             const real_t hessian_blending_2_1_0_q_0 = tmp_blending_op_192*tmp_blending_op_262 - tmp_blending_op_241;
             const real_t hessian_blending_2_1_1_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_200*tmp_blending_op_256 + tmp_blending_op_215*tmp_blending_op_258 + tmp_blending_op_257)*1.0 - tmp_blending_op_216*tmp_blending_op_259;
             const real_t hessian_blending_2_1_2_q_0 = tmp_blending_op_189*tmp_blending_op_262 - tmp_blending_op_208*tmp_blending_op_261 + tmp_blending_op_209;
             const real_t hessian_blending_2_2_0_q_0 = -tmp_blending_op_189*tmp_blending_op_243 + tmp_blending_op_192*tmp_blending_op_205*tmp_blending_op_263*tmp_blending_op_47*1.0;
             const real_t hessian_blending_2_2_1_q_0 = tmp_blending_op_194*tmp_blending_op_205*tmp_blending_op_263*tmp_blending_op_47*1.0 - tmp_blending_op_213*tmp_blending_op_250;
             const real_t hessian_blending_2_2_2_q_0 = -tmp_blending_op_204*tmp_blending_op_259 + tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_190*tmp_blending_op_256 + tmp_blending_op_201*tmp_blending_op_264 + tmp_blending_op_203*tmp_blending_op_258 + tmp_blending_op_212*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_1 = tmp_blending_op_167*tmp_blending_op_47*(-tmp_blending_op_159*tmp_blending_op_267 + tmp_blending_op_161*tmp_blending_op_230 + tmp_blending_op_163*tmp_blending_op_231 + tmp_blending_op_180*tmp_blending_op_267)*1.0 - tmp_blending_op_181*tmp_blending_op_266;
             const real_t hessian_blending_0_0_1_q_1 = tmp_blending_op_156*tmp_blending_op_167*tmp_blending_op_269*tmp_blending_op_47*1.0 - tmp_blending_op_156*tmp_blending_op_270;
             const real_t hessian_blending_0_0_2_q_1 = tmp_blending_op_151*tmp_blending_op_167*tmp_blending_op_269*tmp_blending_op_47*1.0 - tmp_blending_op_151*tmp_blending_op_270;
             const real_t hessian_blending_0_1_0_q_1 = tmp_blending_op_154*tmp_blending_op_168*tmp_blending_op_271 - tmp_blending_op_170*tmp_blending_op_272 + tmp_blending_op_171;
             const real_t hessian_blending_0_1_1_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_162*tmp_blending_op_230 + tmp_blending_op_177*tmp_blending_op_267 + tmp_blending_op_273)*1.0 - tmp_blending_op_178*tmp_blending_op_266;
             const real_t hessian_blending_0_1_2_q_1 = tmp_blending_op_151*tmp_blending_op_167*tmp_blending_op_271*tmp_blending_op_47*1.0 - tmp_blending_op_275;
             const real_t hessian_blending_0_2_0_q_1 = tmp_blending_op_154*tmp_blending_op_168*tmp_blending_op_276 - tmp_blending_op_175*tmp_blending_op_272 + tmp_blending_op_176;
             const real_t hessian_blending_0_2_1_q_1 = tmp_blending_op_156*tmp_blending_op_167*tmp_blending_op_276*tmp_blending_op_47*1.0 - tmp_blending_op_278;
             const real_t hessian_blending_0_2_2_q_1 = -tmp_blending_op_166*tmp_blending_op_266 + tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_152*tmp_blending_op_230 + tmp_blending_op_165*tmp_blending_op_267 + tmp_blending_op_273)*1.0;
             const real_t hessian_blending_1_0_0_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_161*tmp_blending_op_51 + tmp_blending_op_180*tmp_blending_op_280 + tmp_blending_op_279)*1.0 - tmp_blending_op_181*tmp_blending_op_281;
             const real_t hessian_blending_1_0_1_q_1 = tmp_blending_op_156*tmp_blending_op_282 - tmp_blending_op_172*tmp_blending_op_283 + tmp_blending_op_173;
             const real_t hessian_blending_1_0_2_q_1 = tmp_blending_op_151*tmp_blending_op_282 + tmp_blending_op_285;
             const real_t hessian_blending_1_1_0_q_1 = tmp_blending_op_154*tmp_blending_op_167*tmp_blending_op_286*tmp_blending_op_47*1.0 - tmp_blending_op_156*tmp_blending_op_274;
             const real_t hessian_blending_1_1_1_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_160*tmp_blending_op_280 + tmp_blending_op_162*tmp_blending_op_51 + tmp_blending_op_163*tmp_blending_op_253 + tmp_blending_op_177*tmp_blending_op_280)*1.0 - tmp_blending_op_178*tmp_blending_op_281;
             const real_t hessian_blending_1_1_2_q_1 = tmp_blending_op_151*tmp_blending_op_167*tmp_blending_op_286*tmp_blending_op_47*1.0 - tmp_blending_op_170*tmp_blending_op_284;
             const real_t hessian_blending_1_2_0_q_1 = tmp_blending_op_154*tmp_blending_op_167*tmp_blending_op_288*tmp_blending_op_47*1.0 - tmp_blending_op_278;
             const real_t hessian_blending_1_2_1_q_1 = tmp_blending_op_156*tmp_blending_op_168*tmp_blending_op_288 - tmp_blending_op_175*tmp_blending_op_283 + tmp_blending_op_176;
             const real_t hessian_blending_1_2_2_q_1 = -tmp_blending_op_166*tmp_blending_op_281 + tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_152*tmp_blending_op_51 + tmp_blending_op_165*tmp_blending_op_280 + tmp_blending_op_279)*1.0;
             const real_t hessian_blending_2_0_0_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_161*tmp_blending_op_256 + tmp_blending_op_180*tmp_blending_op_290 + tmp_blending_op_289)*1.0 - tmp_blending_op_181*tmp_blending_op_291;
             const real_t hessian_blending_2_0_1_q_1 = tmp_blending_op_156*tmp_blending_op_292 + tmp_blending_op_285;
             const real_t hessian_blending_2_0_2_q_1 = tmp_blending_op_151*tmp_blending_op_292 - tmp_blending_op_172*tmp_blending_op_293 + tmp_blending_op_173;
             const real_t hessian_blending_2_1_0_q_1 = tmp_blending_op_154*tmp_blending_op_294 - tmp_blending_op_275;
             const real_t hessian_blending_2_1_1_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_162*tmp_blending_op_256 + tmp_blending_op_177*tmp_blending_op_290 + tmp_blending_op_289)*1.0 - tmp_blending_op_178*tmp_blending_op_291;
             const real_t hessian_blending_2_1_2_q_1 = tmp_blending_op_151*tmp_blending_op_294 - tmp_blending_op_170*tmp_blending_op_293 + tmp_blending_op_171;
             const real_t hessian_blending_2_2_0_q_1 = -tmp_blending_op_151*tmp_blending_op_277 + tmp_blending_op_154*tmp_blending_op_167*tmp_blending_op_295*tmp_blending_op_47*1.0;
             const real_t hessian_blending_2_2_1_q_1 = tmp_blending_op_156*tmp_blending_op_167*tmp_blending_op_295*tmp_blending_op_47*1.0 - tmp_blending_op_175*tmp_blending_op_284;
             const real_t hessian_blending_2_2_2_q_1 = -tmp_blending_op_166*tmp_blending_op_291 + tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_152*tmp_blending_op_256 + tmp_blending_op_163*tmp_blending_op_264 + tmp_blending_op_165*tmp_blending_op_290 + tmp_blending_op_174*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_2 = tmp_blending_op_129*tmp_blending_op_47*(-tmp_blending_op_121*tmp_blending_op_298 + tmp_blending_op_123*tmp_blending_op_230 + tmp_blending_op_125*tmp_blending_op_231 + tmp_blending_op_142*tmp_blending_op_298)*1.0 - tmp_blending_op_143*tmp_blending_op_297;
             const real_t hessian_blending_0_0_1_q_2 = tmp_blending_op_118*tmp_blending_op_129*tmp_blending_op_300*tmp_blending_op_47*1.0 - tmp_blending_op_118*tmp_blending_op_301;
             const real_t hessian_blending_0_0_2_q_2 = tmp_blending_op_113*tmp_blending_op_129*tmp_blending_op_300*tmp_blending_op_47*1.0 - tmp_blending_op_113*tmp_blending_op_301;
             const real_t hessian_blending_0_1_0_q_2 = tmp_blending_op_116*tmp_blending_op_130*tmp_blending_op_302 - tmp_blending_op_132*tmp_blending_op_303 + tmp_blending_op_133;
             const real_t hessian_blending_0_1_1_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_124*tmp_blending_op_230 + tmp_blending_op_139*tmp_blending_op_298 + tmp_blending_op_304)*1.0 - tmp_blending_op_140*tmp_blending_op_297;
             const real_t hessian_blending_0_1_2_q_2 = tmp_blending_op_113*tmp_blending_op_129*tmp_blending_op_302*tmp_blending_op_47*1.0 - tmp_blending_op_306;
             const real_t hessian_blending_0_2_0_q_2 = tmp_blending_op_116*tmp_blending_op_130*tmp_blending_op_307 - tmp_blending_op_137*tmp_blending_op_303 + tmp_blending_op_138;
             const real_t hessian_blending_0_2_1_q_2 = tmp_blending_op_118*tmp_blending_op_129*tmp_blending_op_307*tmp_blending_op_47*1.0 - tmp_blending_op_309;
             const real_t hessian_blending_0_2_2_q_2 = -tmp_blending_op_128*tmp_blending_op_297 + tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_114*tmp_blending_op_230 + tmp_blending_op_127*tmp_blending_op_298 + tmp_blending_op_304)*1.0;
             const real_t hessian_blending_1_0_0_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_123*tmp_blending_op_51 + tmp_blending_op_142*tmp_blending_op_311 + tmp_blending_op_310)*1.0 - tmp_blending_op_143*tmp_blending_op_312;
             const real_t hessian_blending_1_0_1_q_2 = tmp_blending_op_118*tmp_blending_op_313 - tmp_blending_op_134*tmp_blending_op_314 + tmp_blending_op_135;
             const real_t hessian_blending_1_0_2_q_2 = tmp_blending_op_113*tmp_blending_op_313 + tmp_blending_op_316;
             const real_t hessian_blending_1_1_0_q_2 = tmp_blending_op_116*tmp_blending_op_129*tmp_blending_op_317*tmp_blending_op_47*1.0 - tmp_blending_op_118*tmp_blending_op_305;
             const real_t hessian_blending_1_1_1_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_122*tmp_blending_op_311 + tmp_blending_op_124*tmp_blending_op_51 + tmp_blending_op_125*tmp_blending_op_253 + tmp_blending_op_139*tmp_blending_op_311)*1.0 - tmp_blending_op_140*tmp_blending_op_312;
             const real_t hessian_blending_1_1_2_q_2 = tmp_blending_op_113*tmp_blending_op_129*tmp_blending_op_317*tmp_blending_op_47*1.0 - tmp_blending_op_132*tmp_blending_op_315;
             const real_t hessian_blending_1_2_0_q_2 = tmp_blending_op_116*tmp_blending_op_129*tmp_blending_op_319*tmp_blending_op_47*1.0 - tmp_blending_op_309;
             const real_t hessian_blending_1_2_1_q_2 = tmp_blending_op_118*tmp_blending_op_130*tmp_blending_op_319 - tmp_blending_op_137*tmp_blending_op_314 + tmp_blending_op_138;
             const real_t hessian_blending_1_2_2_q_2 = -tmp_blending_op_128*tmp_blending_op_312 + tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_114*tmp_blending_op_51 + tmp_blending_op_127*tmp_blending_op_311 + tmp_blending_op_310)*1.0;
             const real_t hessian_blending_2_0_0_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_123*tmp_blending_op_256 + tmp_blending_op_142*tmp_blending_op_321 + tmp_blending_op_320)*1.0 - tmp_blending_op_143*tmp_blending_op_322;
             const real_t hessian_blending_2_0_1_q_2 = tmp_blending_op_118*tmp_blending_op_323 + tmp_blending_op_316;
             const real_t hessian_blending_2_0_2_q_2 = tmp_blending_op_113*tmp_blending_op_323 - tmp_blending_op_134*tmp_blending_op_324 + tmp_blending_op_135;
             const real_t hessian_blending_2_1_0_q_2 = tmp_blending_op_116*tmp_blending_op_325 - tmp_blending_op_306;
             const real_t hessian_blending_2_1_1_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_124*tmp_blending_op_256 + tmp_blending_op_139*tmp_blending_op_321 + tmp_blending_op_320)*1.0 - tmp_blending_op_140*tmp_blending_op_322;
             const real_t hessian_blending_2_1_2_q_2 = tmp_blending_op_113*tmp_blending_op_325 - tmp_blending_op_132*tmp_blending_op_324 + tmp_blending_op_133;
             const real_t hessian_blending_2_2_0_q_2 = -tmp_blending_op_113*tmp_blending_op_308 + tmp_blending_op_116*tmp_blending_op_129*tmp_blending_op_326*tmp_blending_op_47*1.0;
             const real_t hessian_blending_2_2_1_q_2 = tmp_blending_op_118*tmp_blending_op_129*tmp_blending_op_326*tmp_blending_op_47*1.0 - tmp_blending_op_137*tmp_blending_op_315;
             const real_t hessian_blending_2_2_2_q_2 = -tmp_blending_op_128*tmp_blending_op_322 + tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_114*tmp_blending_op_256 + tmp_blending_op_125*tmp_blending_op_264 + tmp_blending_op_127*tmp_blending_op_321 + tmp_blending_op_136*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_3 = -tmp_blending_op_105*tmp_blending_op_328 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_104*tmp_blending_op_329 + tmp_blending_op_230*tmp_blending_op_85 + tmp_blending_op_231*tmp_blending_op_87 - tmp_blending_op_329*tmp_blending_op_83)*1.0;
             const real_t hessian_blending_0_0_1_q_3 = tmp_blending_op_331*tmp_blending_op_47*tmp_blending_op_80*tmp_blending_op_91*1.0 - tmp_blending_op_332*tmp_blending_op_80;
             const real_t hessian_blending_0_0_2_q_3 = tmp_blending_op_331*tmp_blending_op_47*tmp_blending_op_75*tmp_blending_op_91*1.0 - tmp_blending_op_332*tmp_blending_op_75;
             const real_t hessian_blending_0_1_0_q_3 = tmp_blending_op_333*tmp_blending_op_78*tmp_blending_op_92 - tmp_blending_op_334*tmp_blending_op_94 + tmp_blending_op_95;
             const real_t hessian_blending_0_1_1_q_3 = -tmp_blending_op_102*tmp_blending_op_328 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_101*tmp_blending_op_329 + tmp_blending_op_230*tmp_blending_op_86 + tmp_blending_op_335)*1.0;
             const real_t hessian_blending_0_1_2_q_3 = tmp_blending_op_333*tmp_blending_op_47*tmp_blending_op_75*tmp_blending_op_91*1.0 - tmp_blending_op_337;
             const real_t hessian_blending_0_2_0_q_3 = tmp_blending_op_100 - tmp_blending_op_334*tmp_blending_op_99 + tmp_blending_op_338*tmp_blending_op_78*tmp_blending_op_92;
             const real_t hessian_blending_0_2_1_q_3 = tmp_blending_op_338*tmp_blending_op_47*tmp_blending_op_80*tmp_blending_op_91*1.0 - tmp_blending_op_340;
             const real_t hessian_blending_0_2_2_q_3 = -tmp_blending_op_328*tmp_blending_op_90 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_230*tmp_blending_op_76 + tmp_blending_op_329*tmp_blending_op_89 + tmp_blending_op_335)*1.0;
             const real_t hessian_blending_1_0_0_q_3 = -tmp_blending_op_105*tmp_blending_op_343 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_104*tmp_blending_op_342 + tmp_blending_op_341 + tmp_blending_op_51*tmp_blending_op_85)*1.0;
             const real_t hessian_blending_1_0_1_q_3 = tmp_blending_op_344*tmp_blending_op_80 - tmp_blending_op_345*tmp_blending_op_96 + tmp_blending_op_97;
             const real_t hessian_blending_1_0_2_q_3 = tmp_blending_op_344*tmp_blending_op_75 + tmp_blending_op_347;
             const real_t hessian_blending_1_1_0_q_3 = -tmp_blending_op_336*tmp_blending_op_80 + tmp_blending_op_348*tmp_blending_op_47*tmp_blending_op_78*tmp_blending_op_91*1.0;
             const real_t hessian_blending_1_1_1_q_3 = -tmp_blending_op_102*tmp_blending_op_343 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_101*tmp_blending_op_342 + tmp_blending_op_253*tmp_blending_op_87 + tmp_blending_op_342*tmp_blending_op_84 + tmp_blending_op_51*tmp_blending_op_86)*1.0;
             const real_t hessian_blending_1_1_2_q_3 = -tmp_blending_op_346*tmp_blending_op_94 + tmp_blending_op_348*tmp_blending_op_47*tmp_blending_op_75*tmp_blending_op_91*1.0;
             const real_t hessian_blending_1_2_0_q_3 = -tmp_blending_op_340 + tmp_blending_op_350*tmp_blending_op_47*tmp_blending_op_78*tmp_blending_op_91*1.0;
             const real_t hessian_blending_1_2_1_q_3 = tmp_blending_op_100 - tmp_blending_op_345*tmp_blending_op_99 + tmp_blending_op_350*tmp_blending_op_80*tmp_blending_op_92;
             const real_t hessian_blending_1_2_2_q_3 = -tmp_blending_op_343*tmp_blending_op_90 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_341 + tmp_blending_op_342*tmp_blending_op_89 + tmp_blending_op_51*tmp_blending_op_76)*1.0;
             const real_t hessian_blending_2_0_0_q_3 = -tmp_blending_op_105*tmp_blending_op_353 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_104*tmp_blending_op_352 + tmp_blending_op_256*tmp_blending_op_85 + tmp_blending_op_351)*1.0;
             const real_t hessian_blending_2_0_1_q_3 = tmp_blending_op_347 + tmp_blending_op_354*tmp_blending_op_80;
             const real_t hessian_blending_2_0_2_q_3 = tmp_blending_op_354*tmp_blending_op_75 - tmp_blending_op_355*tmp_blending_op_96 + tmp_blending_op_97;
             const real_t hessian_blending_2_1_0_q_3 = -tmp_blending_op_337 + tmp_blending_op_356*tmp_blending_op_78;
             const real_t hessian_blending_2_1_1_q_3 = -tmp_blending_op_102*tmp_blending_op_353 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_101*tmp_blending_op_352 + tmp_blending_op_256*tmp_blending_op_86 + tmp_blending_op_351)*1.0;
             const real_t hessian_blending_2_1_2_q_3 = -tmp_blending_op_355*tmp_blending_op_94 + tmp_blending_op_356*tmp_blending_op_75 + tmp_blending_op_95;
             const real_t hessian_blending_2_2_0_q_3 = -tmp_blending_op_339*tmp_blending_op_75 + tmp_blending_op_357*tmp_blending_op_47*tmp_blending_op_78*tmp_blending_op_91*1.0;
             const real_t hessian_blending_2_2_1_q_3 = -tmp_blending_op_346*tmp_blending_op_99 + tmp_blending_op_357*tmp_blending_op_47*tmp_blending_op_80*tmp_blending_op_91*1.0;
             const real_t hessian_blending_2_2_2_q_3 = -tmp_blending_op_353*tmp_blending_op_90 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_256*tmp_blending_op_76 + tmp_blending_op_264*tmp_blending_op_87 + tmp_blending_op_352*tmp_blending_op_89 + tmp_blending_op_98*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_4 = -tmp_blending_op_359*tmp_blending_op_67 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_230*tmp_blending_op_38 + tmp_blending_op_231*tmp_blending_op_40 - tmp_blending_op_36*tmp_blending_op_360 + tmp_blending_op_360*tmp_blending_op_66)*1.0;
             const real_t hessian_blending_0_0_1_q_4 = tmp_blending_op_33*tmp_blending_op_362*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_33*tmp_blending_op_363;
             const real_t hessian_blending_0_0_2_q_4 = tmp_blending_op_3*tmp_blending_op_362*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_3*tmp_blending_op_363;
             const real_t hessian_blending_0_1_0_q_4 = tmp_blending_op_28*tmp_blending_op_364*tmp_blending_op_49 - tmp_blending_op_365*tmp_blending_op_53 + tmp_blending_op_54;
             const real_t hessian_blending_0_1_1_q_4 = -tmp_blending_op_359*tmp_blending_op_64 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_230*tmp_blending_op_39 + tmp_blending_op_360*tmp_blending_op_63 + tmp_blending_op_366)*1.0;
             const real_t hessian_blending_0_1_2_q_4 = tmp_blending_op_3*tmp_blending_op_364*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_368;
             const real_t hessian_blending_0_2_0_q_4 = tmp_blending_op_28*tmp_blending_op_369*tmp_blending_op_49 - tmp_blending_op_365*tmp_blending_op_60 + tmp_blending_op_61;
             const real_t hessian_blending_0_2_1_q_4 = tmp_blending_op_33*tmp_blending_op_369*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_371;
             const real_t hessian_blending_0_2_2_q_4 = -tmp_blending_op_359*tmp_blending_op_45 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_230*tmp_blending_op_4 + tmp_blending_op_360*tmp_blending_op_44 + tmp_blending_op_366)*1.0;
             const real_t hessian_blending_1_0_0_q_4 = -tmp_blending_op_374*tmp_blending_op_67 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_372 + tmp_blending_op_373*tmp_blending_op_66 + tmp_blending_op_38*tmp_blending_op_51)*1.0;
             const real_t hessian_blending_1_0_1_q_4 = tmp_blending_op_33*tmp_blending_op_375 - tmp_blending_op_376*tmp_blending_op_57 + tmp_blending_op_58;
             const real_t hessian_blending_1_0_2_q_4 = tmp_blending_op_3*tmp_blending_op_375 + tmp_blending_op_378;
             const real_t hessian_blending_1_1_0_q_4 = tmp_blending_op_28*tmp_blending_op_379*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_33*tmp_blending_op_367;
             const real_t hessian_blending_1_1_1_q_4 = -tmp_blending_op_374*tmp_blending_op_64 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_253*tmp_blending_op_40 + tmp_blending_op_37*tmp_blending_op_373 + tmp_blending_op_373*tmp_blending_op_63 + tmp_blending_op_39*tmp_blending_op_51)*1.0;
             const real_t hessian_blending_1_1_2_q_4 = tmp_blending_op_3*tmp_blending_op_379*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_377*tmp_blending_op_53;
             const real_t hessian_blending_1_2_0_q_4 = tmp_blending_op_28*tmp_blending_op_381*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_371;
             const real_t hessian_blending_1_2_1_q_4 = tmp_blending_op_33*tmp_blending_op_381*tmp_blending_op_49 - tmp_blending_op_376*tmp_blending_op_60 + tmp_blending_op_61;
             const real_t hessian_blending_1_2_2_q_4 = -tmp_blending_op_374*tmp_blending_op_45 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_372 + tmp_blending_op_373*tmp_blending_op_44 + tmp_blending_op_4*tmp_blending_op_51)*1.0;
             const real_t hessian_blending_2_0_0_q_4 = -tmp_blending_op_384*tmp_blending_op_67 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_256*tmp_blending_op_38 + tmp_blending_op_382 + tmp_blending_op_383*tmp_blending_op_66)*1.0;
             const real_t hessian_blending_2_0_1_q_4 = tmp_blending_op_33*tmp_blending_op_385 + tmp_blending_op_378;
             const real_t hessian_blending_2_0_2_q_4 = tmp_blending_op_3*tmp_blending_op_385 - tmp_blending_op_386*tmp_blending_op_57 + tmp_blending_op_58;
             const real_t hessian_blending_2_1_0_q_4 = tmp_blending_op_28*tmp_blending_op_387 - tmp_blending_op_368;
             const real_t hessian_blending_2_1_1_q_4 = -tmp_blending_op_384*tmp_blending_op_64 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_256*tmp_blending_op_39 + tmp_blending_op_382 + tmp_blending_op_383*tmp_blending_op_63)*1.0;
             const real_t hessian_blending_2_1_2_q_4 = tmp_blending_op_3*tmp_blending_op_387 - tmp_blending_op_386*tmp_blending_op_53 + tmp_blending_op_54;
             const real_t hessian_blending_2_2_0_q_4 = tmp_blending_op_28*tmp_blending_op_388*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_3*tmp_blending_op_370;
             const real_t hessian_blending_2_2_1_q_4 = tmp_blending_op_33*tmp_blending_op_388*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_377*tmp_blending_op_60;
             const real_t hessian_blending_2_2_2_q_4 = -tmp_blending_op_384*tmp_blending_op_45 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_256*tmp_blending_op_4 + tmp_blending_op_264*tmp_blending_op_40 + tmp_blending_op_383*tmp_blending_op_44 + tmp_blending_op_59*2.0)*1.0;
             const real_t diffusivity_times_delta_dof_0 = _data_diffusivity_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t diffusivity_times_delta_dof_1 = _data_diffusivity_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t diffusivity_times_delta_dof_2 = _data_diffusivity_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t diffusivity_times_delta_dof_3 = _data_diffusivity_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t diffusivity_times_delta_dof_4 = _data_diffusivity_times_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t diffusivity_times_delta_dof_5 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t diffusivity_times_delta_dof_6 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t diffusivity_times_delta_dof_7 = _data_diffusivity_times_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t diffusivity_times_delta_dof_8 = _data_diffusivity_times_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t diffusivity_times_delta_dof_9 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t wx_dof_0 = _data_wxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wx_dof_1 = _data_wxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wx_dof_2 = _data_wxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wx_dof_3 = _data_wxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wx_dof_4 = _data_wxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wx_dof_5 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t wx_dof_6 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wx_dof_7 = _data_wxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t wx_dof_8 = _data_wxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wx_dof_9 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t wy_dof_0 = _data_wyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wy_dof_1 = _data_wyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wy_dof_2 = _data_wyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wy_dof_3 = _data_wyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wy_dof_4 = _data_wyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wy_dof_5 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t wy_dof_6 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wy_dof_7 = _data_wyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t wy_dof_8 = _data_wyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wy_dof_9 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t wz_dof_0 = _data_wzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wz_dof_1 = _data_wzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wz_dof_2 = _data_wzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wz_dof_3 = _data_wzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wz_dof_4 = _data_wzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wz_dof_5 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t wz_dof_6 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wz_dof_7 = _data_wzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t wz_dof_8 = _data_wzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wz_dof_9 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t tmp_kernel_op_30 = -hessian_blending_0_0_0_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_0_1_0_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_0_2_0_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_31 = -hessian_blending_0_0_1_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_0_1_1_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_0_2_1_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_32 = -hessian_blending_0_0_2_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_0_1_2_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_0_2_2_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_33 = jac_blending_inv_0_0_q_0*tmp_kernel_op_30 + jac_blending_inv_0_1_q_0*tmp_kernel_op_31 + jac_blending_inv_0_2_q_0*tmp_kernel_op_32;
             const real_t tmp_kernel_op_35 = jac_blending_inv_1_0_q_0*tmp_kernel_op_30 + jac_blending_inv_1_1_q_0*tmp_kernel_op_31 + jac_blending_inv_1_2_q_0*tmp_kernel_op_32;
             const real_t tmp_kernel_op_37 = jac_blending_inv_2_0_q_0*tmp_kernel_op_30 + jac_blending_inv_2_1_q_0*tmp_kernel_op_31 + jac_blending_inv_2_2_q_0*tmp_kernel_op_32;
             const real_t tmp_kernel_op_38 = -hessian_blending_1_0_0_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_1_1_0_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_1_2_0_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_39 = -hessian_blending_1_0_1_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_1_1_1_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_1_2_1_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_40 = -hessian_blending_1_0_2_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_1_1_2_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_1_2_2_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_41 = jac_blending_inv_0_0_q_0*tmp_kernel_op_38 + jac_blending_inv_0_1_q_0*tmp_kernel_op_39 + jac_blending_inv_0_2_q_0*tmp_kernel_op_40;
             const real_t tmp_kernel_op_42 = jac_blending_inv_1_0_q_0*tmp_kernel_op_38 + jac_blending_inv_1_1_q_0*tmp_kernel_op_39 + jac_blending_inv_1_2_q_0*tmp_kernel_op_40;
             const real_t tmp_kernel_op_43 = jac_blending_inv_2_0_q_0*tmp_kernel_op_38 + jac_blending_inv_2_1_q_0*tmp_kernel_op_39 + jac_blending_inv_2_2_q_0*tmp_kernel_op_40;
             const real_t tmp_kernel_op_44 = -hessian_blending_2_0_0_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_2_1_0_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_2_2_0_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_45 = -hessian_blending_2_0_1_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_2_1_1_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_2_2_1_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_46 = -hessian_blending_2_0_2_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_2_1_2_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_2_2_2_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_47 = jac_blending_inv_0_0_q_0*tmp_kernel_op_44 + jac_blending_inv_0_1_q_0*tmp_kernel_op_45 + jac_blending_inv_0_2_q_0*tmp_kernel_op_46;
             const real_t tmp_kernel_op_48 = jac_blending_inv_1_0_q_0*tmp_kernel_op_44 + jac_blending_inv_1_1_q_0*tmp_kernel_op_45 + jac_blending_inv_1_2_q_0*tmp_kernel_op_46;
             const real_t tmp_kernel_op_49 = jac_blending_inv_2_0_q_0*tmp_kernel_op_44 + jac_blending_inv_2_1_q_0*tmp_kernel_op_45 + jac_blending_inv_2_2_q_0*tmp_kernel_op_46;
             const real_t tmp_kernel_op_50 = -hessian_blending_0_0_0_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_0_1_0_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_0_2_0_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_51 = -hessian_blending_0_0_1_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_0_1_1_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_0_2_1_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_52 = -hessian_blending_0_0_2_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_0_1_2_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_0_2_2_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_53 = jac_blending_inv_0_0_q_0*tmp_kernel_op_50 + jac_blending_inv_0_1_q_0*tmp_kernel_op_51 + jac_blending_inv_0_2_q_0*tmp_kernel_op_52;
             const real_t tmp_kernel_op_54 = jac_blending_inv_1_0_q_0*tmp_kernel_op_50 + jac_blending_inv_1_1_q_0*tmp_kernel_op_51 + jac_blending_inv_1_2_q_0*tmp_kernel_op_52;
             const real_t tmp_kernel_op_55 = jac_blending_inv_2_0_q_0*tmp_kernel_op_50 + jac_blending_inv_2_1_q_0*tmp_kernel_op_51 + jac_blending_inv_2_2_q_0*tmp_kernel_op_52;
             const real_t tmp_kernel_op_56 = -hessian_blending_1_0_0_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_1_1_0_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_1_2_0_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_57 = -hessian_blending_1_0_1_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_1_1_1_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_1_2_1_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_58 = -hessian_blending_1_0_2_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_1_1_2_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_1_2_2_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_59 = jac_blending_inv_0_0_q_0*tmp_kernel_op_56 + jac_blending_inv_0_1_q_0*tmp_kernel_op_57 + jac_blending_inv_0_2_q_0*tmp_kernel_op_58;
             const real_t tmp_kernel_op_60 = jac_blending_inv_1_0_q_0*tmp_kernel_op_56 + jac_blending_inv_1_1_q_0*tmp_kernel_op_57 + jac_blending_inv_1_2_q_0*tmp_kernel_op_58;
             const real_t tmp_kernel_op_61 = jac_blending_inv_2_0_q_0*tmp_kernel_op_56 + jac_blending_inv_2_1_q_0*tmp_kernel_op_57 + jac_blending_inv_2_2_q_0*tmp_kernel_op_58;
             const real_t tmp_kernel_op_62 = -hessian_blending_2_0_0_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_2_1_0_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_2_2_0_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_63 = -hessian_blending_2_0_1_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_2_1_1_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_2_2_1_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_64 = -hessian_blending_2_0_2_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_2_1_2_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_2_2_2_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_65 = jac_blending_inv_0_0_q_0*tmp_kernel_op_62 + jac_blending_inv_0_1_q_0*tmp_kernel_op_63 + jac_blending_inv_0_2_q_0*tmp_kernel_op_64;
             const real_t tmp_kernel_op_66 = jac_blending_inv_1_0_q_0*tmp_kernel_op_62 + jac_blending_inv_1_1_q_0*tmp_kernel_op_63 + jac_blending_inv_1_2_q_0*tmp_kernel_op_64;
             const real_t tmp_kernel_op_67 = jac_blending_inv_2_0_q_0*tmp_kernel_op_62 + jac_blending_inv_2_1_q_0*tmp_kernel_op_63 + jac_blending_inv_2_2_q_0*tmp_kernel_op_64;
             const real_t tmp_kernel_op_68 = -hessian_blending_0_0_0_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_0_1_0_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_0_2_0_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_69 = -hessian_blending_0_0_1_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_0_1_1_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_0_2_1_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_70 = -hessian_blending_0_0_2_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_0_1_2_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_0_2_2_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_71 = jac_blending_inv_0_0_q_0*tmp_kernel_op_68 + jac_blending_inv_0_1_q_0*tmp_kernel_op_69 + jac_blending_inv_0_2_q_0*tmp_kernel_op_70;
             const real_t tmp_kernel_op_72 = jac_blending_inv_1_0_q_0*tmp_kernel_op_68 + jac_blending_inv_1_1_q_0*tmp_kernel_op_69 + jac_blending_inv_1_2_q_0*tmp_kernel_op_70;
             const real_t tmp_kernel_op_73 = jac_blending_inv_2_0_q_0*tmp_kernel_op_68 + jac_blending_inv_2_1_q_0*tmp_kernel_op_69 + jac_blending_inv_2_2_q_0*tmp_kernel_op_70;
             const real_t tmp_kernel_op_74 = -hessian_blending_1_0_0_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_1_1_0_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_1_2_0_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_75 = -hessian_blending_1_0_1_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_1_1_1_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_1_2_1_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_76 = -hessian_blending_1_0_2_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_1_1_2_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_1_2_2_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_77 = jac_blending_inv_0_0_q_0*tmp_kernel_op_74 + jac_blending_inv_0_1_q_0*tmp_kernel_op_75 + jac_blending_inv_0_2_q_0*tmp_kernel_op_76;
             const real_t tmp_kernel_op_78 = jac_blending_inv_1_0_q_0*tmp_kernel_op_74 + jac_blending_inv_1_1_q_0*tmp_kernel_op_75 + jac_blending_inv_1_2_q_0*tmp_kernel_op_76;
             const real_t tmp_kernel_op_79 = jac_blending_inv_2_0_q_0*tmp_kernel_op_74 + jac_blending_inv_2_1_q_0*tmp_kernel_op_75 + jac_blending_inv_2_2_q_0*tmp_kernel_op_76;
             const real_t tmp_kernel_op_80 = -hessian_blending_2_0_0_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_2_1_0_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_2_2_0_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_81 = -hessian_blending_2_0_1_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_2_1_1_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_2_2_1_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_82 = -hessian_blending_2_0_2_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_2_1_2_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_2_2_2_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_83 = jac_blending_inv_0_0_q_0*tmp_kernel_op_80 + jac_blending_inv_0_1_q_0*tmp_kernel_op_81 + jac_blending_inv_0_2_q_0*tmp_kernel_op_82;
             const real_t tmp_kernel_op_84 = jac_blending_inv_1_0_q_0*tmp_kernel_op_80 + jac_blending_inv_1_1_q_0*tmp_kernel_op_81 + jac_blending_inv_1_2_q_0*tmp_kernel_op_82;
             const real_t tmp_kernel_op_85 = jac_blending_inv_2_0_q_0*tmp_kernel_op_80 + jac_blending_inv_2_1_q_0*tmp_kernel_op_81 + jac_blending_inv_2_2_q_0*tmp_kernel_op_82;
             const real_t tmp_kernel_op_86 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_5 + jac_blending_inv_1_0_q_0*tmp_moved_constant_11 + jac_blending_inv_2_0_q_0*tmp_moved_constant_17) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_24 + tmp_kernel_op_35*tmp_moved_constant_25 + tmp_kernel_op_37*tmp_moved_constant_26) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_5 + jac_blending_inv_1_1_q_0*tmp_moved_constant_11 + jac_blending_inv_2_1_q_0*tmp_moved_constant_17) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_24 + tmp_kernel_op_42*tmp_moved_constant_25 + tmp_kernel_op_43*tmp_moved_constant_26) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_5 + jac_blending_inv_1_2_q_0*tmp_moved_constant_11 + jac_blending_inv_2_2_q_0*tmp_moved_constant_17) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_24 + tmp_kernel_op_48*tmp_moved_constant_25 + tmp_kernel_op_49*tmp_moved_constant_26) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_18 + jac_blending_inv_1_0_q_0*tmp_moved_constant_19 + jac_blending_inv_2_0_q_0*tmp_moved_constant_20) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_24 + tmp_kernel_op_54*tmp_moved_constant_25 + tmp_kernel_op_55*tmp_moved_constant_26) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_18 + jac_blending_inv_1_1_q_0*tmp_moved_constant_19 + jac_blending_inv_2_1_q_0*tmp_moved_constant_20) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_24 + tmp_kernel_op_60*tmp_moved_constant_25 + tmp_kernel_op_61*tmp_moved_constant_26) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_18 + jac_blending_inv_1_2_q_0*tmp_moved_constant_19 + jac_blending_inv_2_2_q_0*tmp_moved_constant_20) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_24 + tmp_kernel_op_66*tmp_moved_constant_25 + tmp_kernel_op_67*tmp_moved_constant_26) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_21 + jac_blending_inv_1_0_q_0*tmp_moved_constant_22 + jac_blending_inv_2_0_q_0*tmp_moved_constant_23) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_24 + tmp_kernel_op_72*tmp_moved_constant_25 + tmp_kernel_op_73*tmp_moved_constant_26) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_21 + jac_blending_inv_1_1_q_0*tmp_moved_constant_22 + jac_blending_inv_2_1_q_0*tmp_moved_constant_23) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_24 + tmp_kernel_op_78*tmp_moved_constant_25 + tmp_kernel_op_79*tmp_moved_constant_26) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_21 + jac_blending_inv_1_2_q_0*tmp_moved_constant_22 + jac_blending_inv_2_2_q_0*tmp_moved_constant_23) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_24 + tmp_kernel_op_84*tmp_moved_constant_25 + tmp_kernel_op_85*tmp_moved_constant_26);
             const real_t tmp_kernel_op_104 = tmp_kernel_op_100*wx_dof_8 + tmp_kernel_op_102*wx_dof_9 + tmp_kernel_op_103*wx_dof_0 + tmp_kernel_op_87*wx_dof_4 + tmp_kernel_op_88*wx_dof_5 + tmp_kernel_op_89*wx_dof_6 + tmp_kernel_op_92*wx_dof_1 + tmp_kernel_op_95*wx_dof_2 + tmp_kernel_op_98*wx_dof_3 + tmp_kernel_op_99*wx_dof_7;
             const real_t tmp_kernel_op_105 = tmp_kernel_op_100*wy_dof_8 + tmp_kernel_op_102*wy_dof_9 + tmp_kernel_op_103*wy_dof_0 + tmp_kernel_op_87*wy_dof_4 + tmp_kernel_op_88*wy_dof_5 + tmp_kernel_op_89*wy_dof_6 + tmp_kernel_op_92*wy_dof_1 + tmp_kernel_op_95*wy_dof_2 + tmp_kernel_op_98*wy_dof_3 + tmp_kernel_op_99*wy_dof_7;
             const real_t tmp_kernel_op_106 = tmp_kernel_op_100*wz_dof_8 + tmp_kernel_op_102*wz_dof_9 + tmp_kernel_op_103*wz_dof_0 + tmp_kernel_op_87*wz_dof_4 + tmp_kernel_op_88*wz_dof_5 + tmp_kernel_op_89*wz_dof_6 + tmp_kernel_op_92*wz_dof_1 + tmp_kernel_op_95*wz_dof_2 + tmp_kernel_op_98*wz_dof_3 + tmp_kernel_op_99*wz_dof_7;
             const real_t tmp_kernel_op_107 = abs_det_jac_affine_WHITE_DOWN*abs_det_jac_blending_q_0*(diffusivity_times_delta_dof_0*tmp_kernel_op_103 + diffusivity_times_delta_dof_1*tmp_kernel_op_92 + diffusivity_times_delta_dof_2*tmp_kernel_op_95 + diffusivity_times_delta_dof_3*tmp_kernel_op_98 + diffusivity_times_delta_dof_4*tmp_kernel_op_87 + diffusivity_times_delta_dof_5*tmp_kernel_op_88 + diffusivity_times_delta_dof_6*tmp_kernel_op_89 + diffusivity_times_delta_dof_7*tmp_kernel_op_99 + diffusivity_times_delta_dof_8*tmp_kernel_op_100 + diffusivity_times_delta_dof_9*tmp_kernel_op_102)*-0.1333333333333333;
             const real_t tmp_kernel_op_108 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_24 + jac_blending_inv_1_0_q_0*tmp_moved_constant_25 + jac_blending_inv_2_0_q_0*tmp_moved_constant_26) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_24 + jac_blending_inv_1_1_q_0*tmp_moved_constant_25 + jac_blending_inv_2_1_q_0*tmp_moved_constant_26) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_24 + jac_blending_inv_1_2_q_0*tmp_moved_constant_25 + jac_blending_inv_2_2_q_0*tmp_moved_constant_26));
             const real_t tmp_kernel_op_115 = -hessian_blending_0_0_0_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_0_1_0_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_0_2_0_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_116 = -hessian_blending_0_0_1_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_0_1_1_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_0_2_1_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_117 = -hessian_blending_0_0_2_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_0_1_2_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_0_2_2_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_118 = jac_blending_inv_0_0_q_1*tmp_kernel_op_115 + jac_blending_inv_0_1_q_1*tmp_kernel_op_116 + jac_blending_inv_0_2_q_1*tmp_kernel_op_117;
             const real_t tmp_kernel_op_120 = jac_blending_inv_1_0_q_1*tmp_kernel_op_115 + jac_blending_inv_1_1_q_1*tmp_kernel_op_116 + jac_blending_inv_1_2_q_1*tmp_kernel_op_117;
             const real_t tmp_kernel_op_122 = jac_blending_inv_2_0_q_1*tmp_kernel_op_115 + jac_blending_inv_2_1_q_1*tmp_kernel_op_116 + jac_blending_inv_2_2_q_1*tmp_kernel_op_117;
             const real_t tmp_kernel_op_123 = -hessian_blending_1_0_0_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_1_1_0_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_1_2_0_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_124 = -hessian_blending_1_0_1_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_1_1_1_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_1_2_1_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_125 = -hessian_blending_1_0_2_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_1_1_2_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_1_2_2_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_126 = jac_blending_inv_0_0_q_1*tmp_kernel_op_123 + jac_blending_inv_0_1_q_1*tmp_kernel_op_124 + jac_blending_inv_0_2_q_1*tmp_kernel_op_125;
             const real_t tmp_kernel_op_127 = jac_blending_inv_1_0_q_1*tmp_kernel_op_123 + jac_blending_inv_1_1_q_1*tmp_kernel_op_124 + jac_blending_inv_1_2_q_1*tmp_kernel_op_125;
             const real_t tmp_kernel_op_128 = jac_blending_inv_2_0_q_1*tmp_kernel_op_123 + jac_blending_inv_2_1_q_1*tmp_kernel_op_124 + jac_blending_inv_2_2_q_1*tmp_kernel_op_125;
             const real_t tmp_kernel_op_129 = -hessian_blending_2_0_0_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_2_1_0_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_2_2_0_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_130 = -hessian_blending_2_0_1_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_2_1_1_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_2_2_1_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_131 = -hessian_blending_2_0_2_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_2_1_2_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_2_2_2_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_132 = jac_blending_inv_0_0_q_1*tmp_kernel_op_129 + jac_blending_inv_0_1_q_1*tmp_kernel_op_130 + jac_blending_inv_0_2_q_1*tmp_kernel_op_131;
             const real_t tmp_kernel_op_133 = jac_blending_inv_1_0_q_1*tmp_kernel_op_129 + jac_blending_inv_1_1_q_1*tmp_kernel_op_130 + jac_blending_inv_1_2_q_1*tmp_kernel_op_131;
             const real_t tmp_kernel_op_134 = jac_blending_inv_2_0_q_1*tmp_kernel_op_129 + jac_blending_inv_2_1_q_1*tmp_kernel_op_130 + jac_blending_inv_2_2_q_1*tmp_kernel_op_131;
             const real_t tmp_kernel_op_135 = -hessian_blending_0_0_0_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_0_1_0_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_0_2_0_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_136 = -hessian_blending_0_0_1_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_0_1_1_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_0_2_1_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_137 = -hessian_blending_0_0_2_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_0_1_2_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_0_2_2_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_138 = jac_blending_inv_0_0_q_1*tmp_kernel_op_135 + jac_blending_inv_0_1_q_1*tmp_kernel_op_136 + jac_blending_inv_0_2_q_1*tmp_kernel_op_137;
             const real_t tmp_kernel_op_139 = jac_blending_inv_1_0_q_1*tmp_kernel_op_135 + jac_blending_inv_1_1_q_1*tmp_kernel_op_136 + jac_blending_inv_1_2_q_1*tmp_kernel_op_137;
             const real_t tmp_kernel_op_140 = jac_blending_inv_2_0_q_1*tmp_kernel_op_135 + jac_blending_inv_2_1_q_1*tmp_kernel_op_136 + jac_blending_inv_2_2_q_1*tmp_kernel_op_137;
             const real_t tmp_kernel_op_141 = -hessian_blending_1_0_0_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_1_1_0_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_1_2_0_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_142 = -hessian_blending_1_0_1_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_1_1_1_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_1_2_1_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_143 = -hessian_blending_1_0_2_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_1_1_2_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_1_2_2_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_144 = jac_blending_inv_0_0_q_1*tmp_kernel_op_141 + jac_blending_inv_0_1_q_1*tmp_kernel_op_142 + jac_blending_inv_0_2_q_1*tmp_kernel_op_143;
             const real_t tmp_kernel_op_145 = jac_blending_inv_1_0_q_1*tmp_kernel_op_141 + jac_blending_inv_1_1_q_1*tmp_kernel_op_142 + jac_blending_inv_1_2_q_1*tmp_kernel_op_143;
             const real_t tmp_kernel_op_146 = jac_blending_inv_2_0_q_1*tmp_kernel_op_141 + jac_blending_inv_2_1_q_1*tmp_kernel_op_142 + jac_blending_inv_2_2_q_1*tmp_kernel_op_143;
             const real_t tmp_kernel_op_147 = -hessian_blending_2_0_0_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_2_1_0_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_2_2_0_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_148 = -hessian_blending_2_0_1_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_2_1_1_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_2_2_1_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_149 = -hessian_blending_2_0_2_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_2_1_2_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_2_2_2_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_150 = jac_blending_inv_0_0_q_1*tmp_kernel_op_147 + jac_blending_inv_0_1_q_1*tmp_kernel_op_148 + jac_blending_inv_0_2_q_1*tmp_kernel_op_149;
             const real_t tmp_kernel_op_151 = jac_blending_inv_1_0_q_1*tmp_kernel_op_147 + jac_blending_inv_1_1_q_1*tmp_kernel_op_148 + jac_blending_inv_1_2_q_1*tmp_kernel_op_149;
             const real_t tmp_kernel_op_152 = jac_blending_inv_2_0_q_1*tmp_kernel_op_147 + jac_blending_inv_2_1_q_1*tmp_kernel_op_148 + jac_blending_inv_2_2_q_1*tmp_kernel_op_149;
             const real_t tmp_kernel_op_153 = -hessian_blending_0_0_0_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_0_1_0_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_0_2_0_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_154 = -hessian_blending_0_0_1_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_0_1_1_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_0_2_1_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_155 = -hessian_blending_0_0_2_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_0_1_2_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_0_2_2_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_156 = jac_blending_inv_0_0_q_1*tmp_kernel_op_153 + jac_blending_inv_0_1_q_1*tmp_kernel_op_154 + jac_blending_inv_0_2_q_1*tmp_kernel_op_155;
             const real_t tmp_kernel_op_157 = jac_blending_inv_1_0_q_1*tmp_kernel_op_153 + jac_blending_inv_1_1_q_1*tmp_kernel_op_154 + jac_blending_inv_1_2_q_1*tmp_kernel_op_155;
             const real_t tmp_kernel_op_158 = jac_blending_inv_2_0_q_1*tmp_kernel_op_153 + jac_blending_inv_2_1_q_1*tmp_kernel_op_154 + jac_blending_inv_2_2_q_1*tmp_kernel_op_155;
             const real_t tmp_kernel_op_159 = -hessian_blending_1_0_0_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_1_1_0_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_1_2_0_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_160 = -hessian_blending_1_0_1_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_1_1_1_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_1_2_1_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_161 = -hessian_blending_1_0_2_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_1_1_2_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_1_2_2_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_162 = jac_blending_inv_0_0_q_1*tmp_kernel_op_159 + jac_blending_inv_0_1_q_1*tmp_kernel_op_160 + jac_blending_inv_0_2_q_1*tmp_kernel_op_161;
             const real_t tmp_kernel_op_163 = jac_blending_inv_1_0_q_1*tmp_kernel_op_159 + jac_blending_inv_1_1_q_1*tmp_kernel_op_160 + jac_blending_inv_1_2_q_1*tmp_kernel_op_161;
             const real_t tmp_kernel_op_164 = jac_blending_inv_2_0_q_1*tmp_kernel_op_159 + jac_blending_inv_2_1_q_1*tmp_kernel_op_160 + jac_blending_inv_2_2_q_1*tmp_kernel_op_161;
             const real_t tmp_kernel_op_165 = -hessian_blending_2_0_0_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_2_1_0_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_2_2_0_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_166 = -hessian_blending_2_0_1_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_2_1_1_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_2_2_1_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_167 = -hessian_blending_2_0_2_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_2_1_2_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_2_2_2_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_168 = jac_blending_inv_0_0_q_1*tmp_kernel_op_165 + jac_blending_inv_0_1_q_1*tmp_kernel_op_166 + jac_blending_inv_0_2_q_1*tmp_kernel_op_167;
             const real_t tmp_kernel_op_169 = jac_blending_inv_1_0_q_1*tmp_kernel_op_165 + jac_blending_inv_1_1_q_1*tmp_kernel_op_166 + jac_blending_inv_1_2_q_1*tmp_kernel_op_167;
             const real_t tmp_kernel_op_170 = jac_blending_inv_2_0_q_1*tmp_kernel_op_165 + jac_blending_inv_2_1_q_1*tmp_kernel_op_166 + jac_blending_inv_2_2_q_1*tmp_kernel_op_167;
             const real_t tmp_kernel_op_171 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_5 + jac_blending_inv_1_0_q_1*tmp_moved_constant_11 + jac_blending_inv_2_0_q_1*tmp_moved_constant_17) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_27 + tmp_kernel_op_120*tmp_moved_constant_28 + tmp_kernel_op_122*tmp_moved_constant_29) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_5 + jac_blending_inv_1_1_q_1*tmp_moved_constant_11 + jac_blending_inv_2_1_q_1*tmp_moved_constant_17) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_27 + tmp_kernel_op_127*tmp_moved_constant_28 + tmp_kernel_op_128*tmp_moved_constant_29) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_5 + jac_blending_inv_1_2_q_1*tmp_moved_constant_11 + jac_blending_inv_2_2_q_1*tmp_moved_constant_17) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_27 + tmp_kernel_op_133*tmp_moved_constant_28 + tmp_kernel_op_134*tmp_moved_constant_29) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_18 + jac_blending_inv_1_0_q_1*tmp_moved_constant_19 + jac_blending_inv_2_0_q_1*tmp_moved_constant_20) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_27 + tmp_kernel_op_139*tmp_moved_constant_28 + tmp_kernel_op_140*tmp_moved_constant_29) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_18 + jac_blending_inv_1_1_q_1*tmp_moved_constant_19 + jac_blending_inv_2_1_q_1*tmp_moved_constant_20) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_27 + tmp_kernel_op_145*tmp_moved_constant_28 + tmp_kernel_op_146*tmp_moved_constant_29) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_18 + jac_blending_inv_1_2_q_1*tmp_moved_constant_19 + jac_blending_inv_2_2_q_1*tmp_moved_constant_20) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_27 + tmp_kernel_op_151*tmp_moved_constant_28 + tmp_kernel_op_152*tmp_moved_constant_29) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_21 + jac_blending_inv_1_0_q_1*tmp_moved_constant_22 + jac_blending_inv_2_0_q_1*tmp_moved_constant_23) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_27 + tmp_kernel_op_157*tmp_moved_constant_28 + tmp_kernel_op_158*tmp_moved_constant_29) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_21 + jac_blending_inv_1_1_q_1*tmp_moved_constant_22 + jac_blending_inv_2_1_q_1*tmp_moved_constant_23) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_27 + tmp_kernel_op_163*tmp_moved_constant_28 + tmp_kernel_op_164*tmp_moved_constant_29) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_21 + jac_blending_inv_1_2_q_1*tmp_moved_constant_22 + jac_blending_inv_2_2_q_1*tmp_moved_constant_23) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_27 + tmp_kernel_op_169*tmp_moved_constant_28 + tmp_kernel_op_170*tmp_moved_constant_29);
             const real_t tmp_kernel_op_189 = tmp_kernel_op_172*wx_dof_4 + tmp_kernel_op_173*wx_dof_5 + tmp_kernel_op_174*wx_dof_6 + tmp_kernel_op_177*wx_dof_1 + tmp_kernel_op_180*wx_dof_2 + tmp_kernel_op_183*wx_dof_3 + tmp_kernel_op_184*wx_dof_7 + tmp_kernel_op_185*wx_dof_8 + tmp_kernel_op_187*wx_dof_9 + tmp_kernel_op_188*wx_dof_0;
             const real_t tmp_kernel_op_190 = tmp_kernel_op_172*wy_dof_4 + tmp_kernel_op_173*wy_dof_5 + tmp_kernel_op_174*wy_dof_6 + tmp_kernel_op_177*wy_dof_1 + tmp_kernel_op_180*wy_dof_2 + tmp_kernel_op_183*wy_dof_3 + tmp_kernel_op_184*wy_dof_7 + tmp_kernel_op_185*wy_dof_8 + tmp_kernel_op_187*wy_dof_9 + tmp_kernel_op_188*wy_dof_0;
             const real_t tmp_kernel_op_191 = tmp_kernel_op_172*wz_dof_4 + tmp_kernel_op_173*wz_dof_5 + tmp_kernel_op_174*wz_dof_6 + tmp_kernel_op_177*wz_dof_1 + tmp_kernel_op_180*wz_dof_2 + tmp_kernel_op_183*wz_dof_3 + tmp_kernel_op_184*wz_dof_7 + tmp_kernel_op_185*wz_dof_8 + tmp_kernel_op_187*wz_dof_9 + tmp_kernel_op_188*wz_dof_0;
             const real_t tmp_kernel_op_192 = abs_det_jac_affine_WHITE_DOWN*abs_det_jac_blending_q_1*(diffusivity_times_delta_dof_0*tmp_kernel_op_188 + diffusivity_times_delta_dof_1*tmp_kernel_op_177 + diffusivity_times_delta_dof_2*tmp_kernel_op_180 + diffusivity_times_delta_dof_3*tmp_kernel_op_183 + diffusivity_times_delta_dof_4*tmp_kernel_op_172 + diffusivity_times_delta_dof_5*tmp_kernel_op_173 + diffusivity_times_delta_dof_6*tmp_kernel_op_174 + diffusivity_times_delta_dof_7*tmp_kernel_op_184 + diffusivity_times_delta_dof_8*tmp_kernel_op_185 + diffusivity_times_delta_dof_9*tmp_kernel_op_187)*0.074999999999999983;
             const real_t tmp_kernel_op_193 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_27 + jac_blending_inv_1_0_q_1*tmp_moved_constant_28 + jac_blending_inv_2_0_q_1*tmp_moved_constant_29) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_27 + jac_blending_inv_1_1_q_1*tmp_moved_constant_28 + jac_blending_inv_2_1_q_1*tmp_moved_constant_29) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_27 + jac_blending_inv_1_2_q_1*tmp_moved_constant_28 + jac_blending_inv_2_2_q_1*tmp_moved_constant_29));
             const real_t tmp_kernel_op_200 = -hessian_blending_0_0_0_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_0_1_0_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_0_2_0_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_201 = -hessian_blending_0_0_1_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_0_1_1_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_0_2_1_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_202 = -hessian_blending_0_0_2_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_0_1_2_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_0_2_2_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_203 = jac_blending_inv_0_0_q_2*tmp_kernel_op_200 + jac_blending_inv_0_1_q_2*tmp_kernel_op_201 + jac_blending_inv_0_2_q_2*tmp_kernel_op_202;
             const real_t tmp_kernel_op_205 = jac_blending_inv_1_0_q_2*tmp_kernel_op_200 + jac_blending_inv_1_1_q_2*tmp_kernel_op_201 + jac_blending_inv_1_2_q_2*tmp_kernel_op_202;
             const real_t tmp_kernel_op_207 = jac_blending_inv_2_0_q_2*tmp_kernel_op_200 + jac_blending_inv_2_1_q_2*tmp_kernel_op_201 + jac_blending_inv_2_2_q_2*tmp_kernel_op_202;
             const real_t tmp_kernel_op_208 = -hessian_blending_1_0_0_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_1_1_0_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_1_2_0_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_209 = -hessian_blending_1_0_1_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_1_1_1_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_1_2_1_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_210 = -hessian_blending_1_0_2_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_1_1_2_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_1_2_2_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_211 = jac_blending_inv_0_0_q_2*tmp_kernel_op_208 + jac_blending_inv_0_1_q_2*tmp_kernel_op_209 + jac_blending_inv_0_2_q_2*tmp_kernel_op_210;
             const real_t tmp_kernel_op_212 = jac_blending_inv_1_0_q_2*tmp_kernel_op_208 + jac_blending_inv_1_1_q_2*tmp_kernel_op_209 + jac_blending_inv_1_2_q_2*tmp_kernel_op_210;
             const real_t tmp_kernel_op_213 = jac_blending_inv_2_0_q_2*tmp_kernel_op_208 + jac_blending_inv_2_1_q_2*tmp_kernel_op_209 + jac_blending_inv_2_2_q_2*tmp_kernel_op_210;
             const real_t tmp_kernel_op_214 = -hessian_blending_2_0_0_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_2_1_0_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_2_2_0_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_215 = -hessian_blending_2_0_1_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_2_1_1_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_2_2_1_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_216 = -hessian_blending_2_0_2_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_2_1_2_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_2_2_2_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_217 = jac_blending_inv_0_0_q_2*tmp_kernel_op_214 + jac_blending_inv_0_1_q_2*tmp_kernel_op_215 + jac_blending_inv_0_2_q_2*tmp_kernel_op_216;
             const real_t tmp_kernel_op_218 = jac_blending_inv_1_0_q_2*tmp_kernel_op_214 + jac_blending_inv_1_1_q_2*tmp_kernel_op_215 + jac_blending_inv_1_2_q_2*tmp_kernel_op_216;
             const real_t tmp_kernel_op_219 = jac_blending_inv_2_0_q_2*tmp_kernel_op_214 + jac_blending_inv_2_1_q_2*tmp_kernel_op_215 + jac_blending_inv_2_2_q_2*tmp_kernel_op_216;
             const real_t tmp_kernel_op_220 = -hessian_blending_0_0_0_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_0_1_0_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_0_2_0_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_221 = -hessian_blending_0_0_1_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_0_1_1_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_0_2_1_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_222 = -hessian_blending_0_0_2_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_0_1_2_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_0_2_2_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_223 = jac_blending_inv_0_0_q_2*tmp_kernel_op_220 + jac_blending_inv_0_1_q_2*tmp_kernel_op_221 + jac_blending_inv_0_2_q_2*tmp_kernel_op_222;
             const real_t tmp_kernel_op_224 = jac_blending_inv_1_0_q_2*tmp_kernel_op_220 + jac_blending_inv_1_1_q_2*tmp_kernel_op_221 + jac_blending_inv_1_2_q_2*tmp_kernel_op_222;
             const real_t tmp_kernel_op_225 = jac_blending_inv_2_0_q_2*tmp_kernel_op_220 + jac_blending_inv_2_1_q_2*tmp_kernel_op_221 + jac_blending_inv_2_2_q_2*tmp_kernel_op_222;
             const real_t tmp_kernel_op_226 = -hessian_blending_1_0_0_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_1_1_0_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_1_2_0_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_227 = -hessian_blending_1_0_1_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_1_1_1_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_1_2_1_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_228 = -hessian_blending_1_0_2_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_1_1_2_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_1_2_2_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_229 = jac_blending_inv_0_0_q_2*tmp_kernel_op_226 + jac_blending_inv_0_1_q_2*tmp_kernel_op_227 + jac_blending_inv_0_2_q_2*tmp_kernel_op_228;
             const real_t tmp_kernel_op_230 = jac_blending_inv_1_0_q_2*tmp_kernel_op_226 + jac_blending_inv_1_1_q_2*tmp_kernel_op_227 + jac_blending_inv_1_2_q_2*tmp_kernel_op_228;
             const real_t tmp_kernel_op_231 = jac_blending_inv_2_0_q_2*tmp_kernel_op_226 + jac_blending_inv_2_1_q_2*tmp_kernel_op_227 + jac_blending_inv_2_2_q_2*tmp_kernel_op_228;
             const real_t tmp_kernel_op_232 = -hessian_blending_2_0_0_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_2_1_0_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_2_2_0_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_233 = -hessian_blending_2_0_1_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_2_1_1_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_2_2_1_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_234 = -hessian_blending_2_0_2_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_2_1_2_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_2_2_2_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_235 = jac_blending_inv_0_0_q_2*tmp_kernel_op_232 + jac_blending_inv_0_1_q_2*tmp_kernel_op_233 + jac_blending_inv_0_2_q_2*tmp_kernel_op_234;
             const real_t tmp_kernel_op_236 = jac_blending_inv_1_0_q_2*tmp_kernel_op_232 + jac_blending_inv_1_1_q_2*tmp_kernel_op_233 + jac_blending_inv_1_2_q_2*tmp_kernel_op_234;
             const real_t tmp_kernel_op_237 = jac_blending_inv_2_0_q_2*tmp_kernel_op_232 + jac_blending_inv_2_1_q_2*tmp_kernel_op_233 + jac_blending_inv_2_2_q_2*tmp_kernel_op_234;
             const real_t tmp_kernel_op_238 = -hessian_blending_0_0_0_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_0_1_0_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_0_2_0_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_239 = -hessian_blending_0_0_1_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_0_1_1_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_0_2_1_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_240 = -hessian_blending_0_0_2_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_0_1_2_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_0_2_2_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_241 = jac_blending_inv_0_0_q_2*tmp_kernel_op_238 + jac_blending_inv_0_1_q_2*tmp_kernel_op_239 + jac_blending_inv_0_2_q_2*tmp_kernel_op_240;
             const real_t tmp_kernel_op_242 = jac_blending_inv_1_0_q_2*tmp_kernel_op_238 + jac_blending_inv_1_1_q_2*tmp_kernel_op_239 + jac_blending_inv_1_2_q_2*tmp_kernel_op_240;
             const real_t tmp_kernel_op_243 = jac_blending_inv_2_0_q_2*tmp_kernel_op_238 + jac_blending_inv_2_1_q_2*tmp_kernel_op_239 + jac_blending_inv_2_2_q_2*tmp_kernel_op_240;
             const real_t tmp_kernel_op_244 = -hessian_blending_1_0_0_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_1_1_0_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_1_2_0_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_245 = -hessian_blending_1_0_1_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_1_1_1_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_1_2_1_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_246 = -hessian_blending_1_0_2_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_1_1_2_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_1_2_2_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_247 = jac_blending_inv_0_0_q_2*tmp_kernel_op_244 + jac_blending_inv_0_1_q_2*tmp_kernel_op_245 + jac_blending_inv_0_2_q_2*tmp_kernel_op_246;
             const real_t tmp_kernel_op_248 = jac_blending_inv_1_0_q_2*tmp_kernel_op_244 + jac_blending_inv_1_1_q_2*tmp_kernel_op_245 + jac_blending_inv_1_2_q_2*tmp_kernel_op_246;
             const real_t tmp_kernel_op_249 = jac_blending_inv_2_0_q_2*tmp_kernel_op_244 + jac_blending_inv_2_1_q_2*tmp_kernel_op_245 + jac_blending_inv_2_2_q_2*tmp_kernel_op_246;
             const real_t tmp_kernel_op_250 = -hessian_blending_2_0_0_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_2_1_0_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_2_2_0_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_251 = -hessian_blending_2_0_1_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_2_1_1_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_2_2_1_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_252 = -hessian_blending_2_0_2_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_2_1_2_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_2_2_2_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_253 = jac_blending_inv_0_0_q_2*tmp_kernel_op_250 + jac_blending_inv_0_1_q_2*tmp_kernel_op_251 + jac_blending_inv_0_2_q_2*tmp_kernel_op_252;
             const real_t tmp_kernel_op_254 = jac_blending_inv_1_0_q_2*tmp_kernel_op_250 + jac_blending_inv_1_1_q_2*tmp_kernel_op_251 + jac_blending_inv_1_2_q_2*tmp_kernel_op_252;
             const real_t tmp_kernel_op_255 = jac_blending_inv_2_0_q_2*tmp_kernel_op_250 + jac_blending_inv_2_1_q_2*tmp_kernel_op_251 + jac_blending_inv_2_2_q_2*tmp_kernel_op_252;
             const real_t tmp_kernel_op_256 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_5 + jac_blending_inv_1_0_q_2*tmp_moved_constant_11 + jac_blending_inv_2_0_q_2*tmp_moved_constant_17) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_30 + tmp_kernel_op_205*tmp_moved_constant_31 + tmp_kernel_op_207*tmp_moved_constant_32) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_5 + jac_blending_inv_1_1_q_2*tmp_moved_constant_11 + jac_blending_inv_2_1_q_2*tmp_moved_constant_17) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_30 + tmp_kernel_op_212*tmp_moved_constant_31 + tmp_kernel_op_213*tmp_moved_constant_32) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_5 + jac_blending_inv_1_2_q_2*tmp_moved_constant_11 + jac_blending_inv_2_2_q_2*tmp_moved_constant_17) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_30 + tmp_kernel_op_218*tmp_moved_constant_31 + tmp_kernel_op_219*tmp_moved_constant_32) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_18 + jac_blending_inv_1_0_q_2*tmp_moved_constant_19 + jac_blending_inv_2_0_q_2*tmp_moved_constant_20) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_30 + tmp_kernel_op_224*tmp_moved_constant_31 + tmp_kernel_op_225*tmp_moved_constant_32) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_18 + jac_blending_inv_1_1_q_2*tmp_moved_constant_19 + jac_blending_inv_2_1_q_2*tmp_moved_constant_20) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_30 + tmp_kernel_op_230*tmp_moved_constant_31 + tmp_kernel_op_231*tmp_moved_constant_32) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_18 + jac_blending_inv_1_2_q_2*tmp_moved_constant_19 + jac_blending_inv_2_2_q_2*tmp_moved_constant_20) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_30 + tmp_kernel_op_236*tmp_moved_constant_31 + tmp_kernel_op_237*tmp_moved_constant_32) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_21 + jac_blending_inv_1_0_q_2*tmp_moved_constant_22 + jac_blending_inv_2_0_q_2*tmp_moved_constant_23) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_30 + tmp_kernel_op_242*tmp_moved_constant_31 + tmp_kernel_op_243*tmp_moved_constant_32) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_21 + jac_blending_inv_1_1_q_2*tmp_moved_constant_22 + jac_blending_inv_2_1_q_2*tmp_moved_constant_23) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_30 + tmp_kernel_op_248*tmp_moved_constant_31 + tmp_kernel_op_249*tmp_moved_constant_32) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_21 + jac_blending_inv_1_2_q_2*tmp_moved_constant_22 + jac_blending_inv_2_2_q_2*tmp_moved_constant_23) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_30 + tmp_kernel_op_254*tmp_moved_constant_31 + tmp_kernel_op_255*tmp_moved_constant_32);
             const real_t tmp_kernel_op_274 = tmp_kernel_op_257*wx_dof_4 + tmp_kernel_op_258*wx_dof_5 + tmp_kernel_op_259*wx_dof_6 + tmp_kernel_op_262*wx_dof_1 + tmp_kernel_op_265*wx_dof_2 + tmp_kernel_op_268*wx_dof_3 + tmp_kernel_op_269*wx_dof_7 + tmp_kernel_op_270*wx_dof_8 + tmp_kernel_op_272*wx_dof_9 + tmp_kernel_op_273*wx_dof_0;
             const real_t tmp_kernel_op_275 = tmp_kernel_op_257*wy_dof_4 + tmp_kernel_op_258*wy_dof_5 + tmp_kernel_op_259*wy_dof_6 + tmp_kernel_op_262*wy_dof_1 + tmp_kernel_op_265*wy_dof_2 + tmp_kernel_op_268*wy_dof_3 + tmp_kernel_op_269*wy_dof_7 + tmp_kernel_op_270*wy_dof_8 + tmp_kernel_op_272*wy_dof_9 + tmp_kernel_op_273*wy_dof_0;
             const real_t tmp_kernel_op_276 = tmp_kernel_op_257*wz_dof_4 + tmp_kernel_op_258*wz_dof_5 + tmp_kernel_op_259*wz_dof_6 + tmp_kernel_op_262*wz_dof_1 + tmp_kernel_op_265*wz_dof_2 + tmp_kernel_op_268*wz_dof_3 + tmp_kernel_op_269*wz_dof_7 + tmp_kernel_op_270*wz_dof_8 + tmp_kernel_op_272*wz_dof_9 + tmp_kernel_op_273*wz_dof_0;
             const real_t tmp_kernel_op_277 = abs_det_jac_affine_WHITE_DOWN*abs_det_jac_blending_q_2*(diffusivity_times_delta_dof_0*tmp_kernel_op_273 + diffusivity_times_delta_dof_1*tmp_kernel_op_262 + diffusivity_times_delta_dof_2*tmp_kernel_op_265 + diffusivity_times_delta_dof_3*tmp_kernel_op_268 + diffusivity_times_delta_dof_4*tmp_kernel_op_257 + diffusivity_times_delta_dof_5*tmp_kernel_op_258 + diffusivity_times_delta_dof_6*tmp_kernel_op_259 + diffusivity_times_delta_dof_7*tmp_kernel_op_269 + diffusivity_times_delta_dof_8*tmp_kernel_op_270 + diffusivity_times_delta_dof_9*tmp_kernel_op_272)*0.074999999999999983;
             const real_t tmp_kernel_op_278 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_30 + jac_blending_inv_1_0_q_2*tmp_moved_constant_31 + jac_blending_inv_2_0_q_2*tmp_moved_constant_32) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_30 + jac_blending_inv_1_1_q_2*tmp_moved_constant_31 + jac_blending_inv_2_1_q_2*tmp_moved_constant_32) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_30 + jac_blending_inv_1_2_q_2*tmp_moved_constant_31 + jac_blending_inv_2_2_q_2*tmp_moved_constant_32));
             const real_t tmp_kernel_op_285 = -hessian_blending_0_0_0_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_0_1_0_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_0_2_0_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_286 = -hessian_blending_0_0_1_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_0_1_1_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_0_2_1_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_287 = -hessian_blending_0_0_2_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_0_1_2_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_0_2_2_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_288 = jac_blending_inv_0_0_q_3*tmp_kernel_op_285 + jac_blending_inv_0_1_q_3*tmp_kernel_op_286 + jac_blending_inv_0_2_q_3*tmp_kernel_op_287;
             const real_t tmp_kernel_op_290 = jac_blending_inv_1_0_q_3*tmp_kernel_op_285 + jac_blending_inv_1_1_q_3*tmp_kernel_op_286 + jac_blending_inv_1_2_q_3*tmp_kernel_op_287;
             const real_t tmp_kernel_op_292 = jac_blending_inv_2_0_q_3*tmp_kernel_op_285 + jac_blending_inv_2_1_q_3*tmp_kernel_op_286 + jac_blending_inv_2_2_q_3*tmp_kernel_op_287;
             const real_t tmp_kernel_op_293 = -hessian_blending_1_0_0_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_1_1_0_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_1_2_0_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_294 = -hessian_blending_1_0_1_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_1_1_1_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_1_2_1_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_295 = -hessian_blending_1_0_2_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_1_1_2_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_1_2_2_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_296 = jac_blending_inv_0_0_q_3*tmp_kernel_op_293 + jac_blending_inv_0_1_q_3*tmp_kernel_op_294 + jac_blending_inv_0_2_q_3*tmp_kernel_op_295;
             const real_t tmp_kernel_op_297 = jac_blending_inv_1_0_q_3*tmp_kernel_op_293 + jac_blending_inv_1_1_q_3*tmp_kernel_op_294 + jac_blending_inv_1_2_q_3*tmp_kernel_op_295;
             const real_t tmp_kernel_op_298 = jac_blending_inv_2_0_q_3*tmp_kernel_op_293 + jac_blending_inv_2_1_q_3*tmp_kernel_op_294 + jac_blending_inv_2_2_q_3*tmp_kernel_op_295;
             const real_t tmp_kernel_op_299 = -hessian_blending_2_0_0_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_2_1_0_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_2_2_0_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_300 = -hessian_blending_2_0_1_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_2_1_1_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_2_2_1_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_301 = -hessian_blending_2_0_2_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_2_1_2_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_2_2_2_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_302 = jac_blending_inv_0_0_q_3*tmp_kernel_op_299 + jac_blending_inv_0_1_q_3*tmp_kernel_op_300 + jac_blending_inv_0_2_q_3*tmp_kernel_op_301;
             const real_t tmp_kernel_op_303 = jac_blending_inv_1_0_q_3*tmp_kernel_op_299 + jac_blending_inv_1_1_q_3*tmp_kernel_op_300 + jac_blending_inv_1_2_q_3*tmp_kernel_op_301;
             const real_t tmp_kernel_op_304 = jac_blending_inv_2_0_q_3*tmp_kernel_op_299 + jac_blending_inv_2_1_q_3*tmp_kernel_op_300 + jac_blending_inv_2_2_q_3*tmp_kernel_op_301;
             const real_t tmp_kernel_op_305 = -hessian_blending_0_0_0_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_0_1_0_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_0_2_0_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_306 = -hessian_blending_0_0_1_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_0_1_1_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_0_2_1_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_307 = -hessian_blending_0_0_2_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_0_1_2_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_0_2_2_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_308 = jac_blending_inv_0_0_q_3*tmp_kernel_op_305 + jac_blending_inv_0_1_q_3*tmp_kernel_op_306 + jac_blending_inv_0_2_q_3*tmp_kernel_op_307;
             const real_t tmp_kernel_op_309 = jac_blending_inv_1_0_q_3*tmp_kernel_op_305 + jac_blending_inv_1_1_q_3*tmp_kernel_op_306 + jac_blending_inv_1_2_q_3*tmp_kernel_op_307;
             const real_t tmp_kernel_op_310 = jac_blending_inv_2_0_q_3*tmp_kernel_op_305 + jac_blending_inv_2_1_q_3*tmp_kernel_op_306 + jac_blending_inv_2_2_q_3*tmp_kernel_op_307;
             const real_t tmp_kernel_op_311 = -hessian_blending_1_0_0_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_1_1_0_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_1_2_0_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_312 = -hessian_blending_1_0_1_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_1_1_1_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_1_2_1_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_313 = -hessian_blending_1_0_2_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_1_1_2_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_1_2_2_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_314 = jac_blending_inv_0_0_q_3*tmp_kernel_op_311 + jac_blending_inv_0_1_q_3*tmp_kernel_op_312 + jac_blending_inv_0_2_q_3*tmp_kernel_op_313;
             const real_t tmp_kernel_op_315 = jac_blending_inv_1_0_q_3*tmp_kernel_op_311 + jac_blending_inv_1_1_q_3*tmp_kernel_op_312 + jac_blending_inv_1_2_q_3*tmp_kernel_op_313;
             const real_t tmp_kernel_op_316 = jac_blending_inv_2_0_q_3*tmp_kernel_op_311 + jac_blending_inv_2_1_q_3*tmp_kernel_op_312 + jac_blending_inv_2_2_q_3*tmp_kernel_op_313;
             const real_t tmp_kernel_op_317 = -hessian_blending_2_0_0_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_2_1_0_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_2_2_0_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_318 = -hessian_blending_2_0_1_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_2_1_1_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_2_2_1_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_319 = -hessian_blending_2_0_2_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_2_1_2_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_2_2_2_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_320 = jac_blending_inv_0_0_q_3*tmp_kernel_op_317 + jac_blending_inv_0_1_q_3*tmp_kernel_op_318 + jac_blending_inv_0_2_q_3*tmp_kernel_op_319;
             const real_t tmp_kernel_op_321 = jac_blending_inv_1_0_q_3*tmp_kernel_op_317 + jac_blending_inv_1_1_q_3*tmp_kernel_op_318 + jac_blending_inv_1_2_q_3*tmp_kernel_op_319;
             const real_t tmp_kernel_op_322 = jac_blending_inv_2_0_q_3*tmp_kernel_op_317 + jac_blending_inv_2_1_q_3*tmp_kernel_op_318 + jac_blending_inv_2_2_q_3*tmp_kernel_op_319;
             const real_t tmp_kernel_op_323 = -hessian_blending_0_0_0_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_0_1_0_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_0_2_0_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_324 = -hessian_blending_0_0_1_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_0_1_1_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_0_2_1_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_325 = -hessian_blending_0_0_2_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_0_1_2_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_0_2_2_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_326 = jac_blending_inv_0_0_q_3*tmp_kernel_op_323 + jac_blending_inv_0_1_q_3*tmp_kernel_op_324 + jac_blending_inv_0_2_q_3*tmp_kernel_op_325;
             const real_t tmp_kernel_op_327 = jac_blending_inv_1_0_q_3*tmp_kernel_op_323 + jac_blending_inv_1_1_q_3*tmp_kernel_op_324 + jac_blending_inv_1_2_q_3*tmp_kernel_op_325;
             const real_t tmp_kernel_op_328 = jac_blending_inv_2_0_q_3*tmp_kernel_op_323 + jac_blending_inv_2_1_q_3*tmp_kernel_op_324 + jac_blending_inv_2_2_q_3*tmp_kernel_op_325;
             const real_t tmp_kernel_op_329 = -hessian_blending_1_0_0_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_1_1_0_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_1_2_0_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_330 = -hessian_blending_1_0_1_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_1_1_1_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_1_2_1_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_331 = -hessian_blending_1_0_2_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_1_1_2_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_1_2_2_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_332 = jac_blending_inv_0_0_q_3*tmp_kernel_op_329 + jac_blending_inv_0_1_q_3*tmp_kernel_op_330 + jac_blending_inv_0_2_q_3*tmp_kernel_op_331;
             const real_t tmp_kernel_op_333 = jac_blending_inv_1_0_q_3*tmp_kernel_op_329 + jac_blending_inv_1_1_q_3*tmp_kernel_op_330 + jac_blending_inv_1_2_q_3*tmp_kernel_op_331;
             const real_t tmp_kernel_op_334 = jac_blending_inv_2_0_q_3*tmp_kernel_op_329 + jac_blending_inv_2_1_q_3*tmp_kernel_op_330 + jac_blending_inv_2_2_q_3*tmp_kernel_op_331;
             const real_t tmp_kernel_op_335 = -hessian_blending_2_0_0_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_2_1_0_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_2_2_0_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_336 = -hessian_blending_2_0_1_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_2_1_1_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_2_2_1_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_337 = -hessian_blending_2_0_2_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_2_1_2_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_2_2_2_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_338 = jac_blending_inv_0_0_q_3*tmp_kernel_op_335 + jac_blending_inv_0_1_q_3*tmp_kernel_op_336 + jac_blending_inv_0_2_q_3*tmp_kernel_op_337;
             const real_t tmp_kernel_op_339 = jac_blending_inv_1_0_q_3*tmp_kernel_op_335 + jac_blending_inv_1_1_q_3*tmp_kernel_op_336 + jac_blending_inv_1_2_q_3*tmp_kernel_op_337;
             const real_t tmp_kernel_op_340 = jac_blending_inv_2_0_q_3*tmp_kernel_op_335 + jac_blending_inv_2_1_q_3*tmp_kernel_op_336 + jac_blending_inv_2_2_q_3*tmp_kernel_op_337;
             const real_t tmp_kernel_op_341 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_5 + jac_blending_inv_1_0_q_3*tmp_moved_constant_11 + jac_blending_inv_2_0_q_3*tmp_moved_constant_17) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_33 + tmp_kernel_op_290*tmp_moved_constant_34 + tmp_kernel_op_292*tmp_moved_constant_35) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_5 + jac_blending_inv_1_1_q_3*tmp_moved_constant_11 + jac_blending_inv_2_1_q_3*tmp_moved_constant_17) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_33 + tmp_kernel_op_297*tmp_moved_constant_34 + tmp_kernel_op_298*tmp_moved_constant_35) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_5 + jac_blending_inv_1_2_q_3*tmp_moved_constant_11 + jac_blending_inv_2_2_q_3*tmp_moved_constant_17) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_33 + tmp_kernel_op_303*tmp_moved_constant_34 + tmp_kernel_op_304*tmp_moved_constant_35) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_18 + jac_blending_inv_1_0_q_3*tmp_moved_constant_19 + jac_blending_inv_2_0_q_3*tmp_moved_constant_20) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_33 + tmp_kernel_op_309*tmp_moved_constant_34 + tmp_kernel_op_310*tmp_moved_constant_35) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_18 + jac_blending_inv_1_1_q_3*tmp_moved_constant_19 + jac_blending_inv_2_1_q_3*tmp_moved_constant_20) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_33 + tmp_kernel_op_315*tmp_moved_constant_34 + tmp_kernel_op_316*tmp_moved_constant_35) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_18 + jac_blending_inv_1_2_q_3*tmp_moved_constant_19 + jac_blending_inv_2_2_q_3*tmp_moved_constant_20) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_33 + tmp_kernel_op_321*tmp_moved_constant_34 + tmp_kernel_op_322*tmp_moved_constant_35) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_21 + jac_blending_inv_1_0_q_3*tmp_moved_constant_22 + jac_blending_inv_2_0_q_3*tmp_moved_constant_23) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_33 + tmp_kernel_op_327*tmp_moved_constant_34 + tmp_kernel_op_328*tmp_moved_constant_35) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_21 + jac_blending_inv_1_1_q_3*tmp_moved_constant_22 + jac_blending_inv_2_1_q_3*tmp_moved_constant_23) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_33 + tmp_kernel_op_333*tmp_moved_constant_34 + tmp_kernel_op_334*tmp_moved_constant_35) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_21 + jac_blending_inv_1_2_q_3*tmp_moved_constant_22 + jac_blending_inv_2_2_q_3*tmp_moved_constant_23) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_33 + tmp_kernel_op_339*tmp_moved_constant_34 + tmp_kernel_op_340*tmp_moved_constant_35);
             const real_t tmp_kernel_op_359 = tmp_kernel_op_342*wx_dof_4 + tmp_kernel_op_343*wx_dof_5 + tmp_kernel_op_344*wx_dof_6 + tmp_kernel_op_347*wx_dof_1 + tmp_kernel_op_350*wx_dof_2 + tmp_kernel_op_353*wx_dof_3 + tmp_kernel_op_354*wx_dof_7 + tmp_kernel_op_355*wx_dof_8 + tmp_kernel_op_357*wx_dof_9 + tmp_kernel_op_358*wx_dof_0;
             const real_t tmp_kernel_op_360 = tmp_kernel_op_342*wy_dof_4 + tmp_kernel_op_343*wy_dof_5 + tmp_kernel_op_344*wy_dof_6 + tmp_kernel_op_347*wy_dof_1 + tmp_kernel_op_350*wy_dof_2 + tmp_kernel_op_353*wy_dof_3 + tmp_kernel_op_354*wy_dof_7 + tmp_kernel_op_355*wy_dof_8 + tmp_kernel_op_357*wy_dof_9 + tmp_kernel_op_358*wy_dof_0;
             const real_t tmp_kernel_op_361 = tmp_kernel_op_342*wz_dof_4 + tmp_kernel_op_343*wz_dof_5 + tmp_kernel_op_344*wz_dof_6 + tmp_kernel_op_347*wz_dof_1 + tmp_kernel_op_350*wz_dof_2 + tmp_kernel_op_353*wz_dof_3 + tmp_kernel_op_354*wz_dof_7 + tmp_kernel_op_355*wz_dof_8 + tmp_kernel_op_357*wz_dof_9 + tmp_kernel_op_358*wz_dof_0;
             const real_t tmp_kernel_op_362 = abs_det_jac_affine_WHITE_DOWN*abs_det_jac_blending_q_3*(diffusivity_times_delta_dof_0*tmp_kernel_op_358 + diffusivity_times_delta_dof_1*tmp_kernel_op_347 + diffusivity_times_delta_dof_2*tmp_kernel_op_350 + diffusivity_times_delta_dof_3*tmp_kernel_op_353 + diffusivity_times_delta_dof_4*tmp_kernel_op_342 + diffusivity_times_delta_dof_5*tmp_kernel_op_343 + diffusivity_times_delta_dof_6*tmp_kernel_op_344 + diffusivity_times_delta_dof_7*tmp_kernel_op_354 + diffusivity_times_delta_dof_8*tmp_kernel_op_355 + diffusivity_times_delta_dof_9*tmp_kernel_op_357)*0.074999999999999983;
             const real_t tmp_kernel_op_363 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_33 + jac_blending_inv_1_0_q_3*tmp_moved_constant_34 + jac_blending_inv_2_0_q_3*tmp_moved_constant_35) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_33 + jac_blending_inv_1_1_q_3*tmp_moved_constant_34 + jac_blending_inv_2_1_q_3*tmp_moved_constant_35) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_33 + jac_blending_inv_1_2_q_3*tmp_moved_constant_34 + jac_blending_inv_2_2_q_3*tmp_moved_constant_35));
             const real_t tmp_kernel_op_370 = -hessian_blending_0_0_0_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_0_1_0_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_0_2_0_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_371 = -hessian_blending_0_0_1_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_0_1_1_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_0_2_1_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_372 = -hessian_blending_0_0_2_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_0_1_2_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_0_2_2_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_373 = jac_blending_inv_0_0_q_4*tmp_kernel_op_370 + jac_blending_inv_0_1_q_4*tmp_kernel_op_371 + jac_blending_inv_0_2_q_4*tmp_kernel_op_372;
             const real_t tmp_kernel_op_375 = jac_blending_inv_1_0_q_4*tmp_kernel_op_370 + jac_blending_inv_1_1_q_4*tmp_kernel_op_371 + jac_blending_inv_1_2_q_4*tmp_kernel_op_372;
             const real_t tmp_kernel_op_377 = jac_blending_inv_2_0_q_4*tmp_kernel_op_370 + jac_blending_inv_2_1_q_4*tmp_kernel_op_371 + jac_blending_inv_2_2_q_4*tmp_kernel_op_372;
             const real_t tmp_kernel_op_378 = -hessian_blending_1_0_0_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_1_1_0_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_1_2_0_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_379 = -hessian_blending_1_0_1_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_1_1_1_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_1_2_1_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_380 = -hessian_blending_1_0_2_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_1_1_2_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_1_2_2_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_381 = jac_blending_inv_0_0_q_4*tmp_kernel_op_378 + jac_blending_inv_0_1_q_4*tmp_kernel_op_379 + jac_blending_inv_0_2_q_4*tmp_kernel_op_380;
             const real_t tmp_kernel_op_382 = jac_blending_inv_1_0_q_4*tmp_kernel_op_378 + jac_blending_inv_1_1_q_4*tmp_kernel_op_379 + jac_blending_inv_1_2_q_4*tmp_kernel_op_380;
             const real_t tmp_kernel_op_383 = jac_blending_inv_2_0_q_4*tmp_kernel_op_378 + jac_blending_inv_2_1_q_4*tmp_kernel_op_379 + jac_blending_inv_2_2_q_4*tmp_kernel_op_380;
             const real_t tmp_kernel_op_384 = -hessian_blending_2_0_0_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_2_1_0_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_2_2_0_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_385 = -hessian_blending_2_0_1_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_2_1_1_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_2_2_1_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_386 = -hessian_blending_2_0_2_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_2_1_2_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_2_2_2_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_387 = jac_blending_inv_0_0_q_4*tmp_kernel_op_384 + jac_blending_inv_0_1_q_4*tmp_kernel_op_385 + jac_blending_inv_0_2_q_4*tmp_kernel_op_386;
             const real_t tmp_kernel_op_388 = jac_blending_inv_1_0_q_4*tmp_kernel_op_384 + jac_blending_inv_1_1_q_4*tmp_kernel_op_385 + jac_blending_inv_1_2_q_4*tmp_kernel_op_386;
             const real_t tmp_kernel_op_389 = jac_blending_inv_2_0_q_4*tmp_kernel_op_384 + jac_blending_inv_2_1_q_4*tmp_kernel_op_385 + jac_blending_inv_2_2_q_4*tmp_kernel_op_386;
             const real_t tmp_kernel_op_390 = -hessian_blending_0_0_0_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_0_1_0_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_0_2_0_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_391 = -hessian_blending_0_0_1_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_0_1_1_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_0_2_1_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_392 = -hessian_blending_0_0_2_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_0_1_2_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_0_2_2_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_393 = jac_blending_inv_0_0_q_4*tmp_kernel_op_390 + jac_blending_inv_0_1_q_4*tmp_kernel_op_391 + jac_blending_inv_0_2_q_4*tmp_kernel_op_392;
             const real_t tmp_kernel_op_394 = jac_blending_inv_1_0_q_4*tmp_kernel_op_390 + jac_blending_inv_1_1_q_4*tmp_kernel_op_391 + jac_blending_inv_1_2_q_4*tmp_kernel_op_392;
             const real_t tmp_kernel_op_395 = jac_blending_inv_2_0_q_4*tmp_kernel_op_390 + jac_blending_inv_2_1_q_4*tmp_kernel_op_391 + jac_blending_inv_2_2_q_4*tmp_kernel_op_392;
             const real_t tmp_kernel_op_396 = -hessian_blending_1_0_0_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_1_1_0_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_1_2_0_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_397 = -hessian_blending_1_0_1_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_1_1_1_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_1_2_1_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_398 = -hessian_blending_1_0_2_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_1_1_2_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_1_2_2_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_399 = jac_blending_inv_0_0_q_4*tmp_kernel_op_396 + jac_blending_inv_0_1_q_4*tmp_kernel_op_397 + jac_blending_inv_0_2_q_4*tmp_kernel_op_398;
             const real_t tmp_kernel_op_400 = jac_blending_inv_1_0_q_4*tmp_kernel_op_396 + jac_blending_inv_1_1_q_4*tmp_kernel_op_397 + jac_blending_inv_1_2_q_4*tmp_kernel_op_398;
             const real_t tmp_kernel_op_401 = jac_blending_inv_2_0_q_4*tmp_kernel_op_396 + jac_blending_inv_2_1_q_4*tmp_kernel_op_397 + jac_blending_inv_2_2_q_4*tmp_kernel_op_398;
             const real_t tmp_kernel_op_402 = -hessian_blending_2_0_0_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_2_1_0_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_2_2_0_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_403 = -hessian_blending_2_0_1_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_2_1_1_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_2_2_1_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_404 = -hessian_blending_2_0_2_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_2_1_2_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_2_2_2_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_405 = jac_blending_inv_0_0_q_4*tmp_kernel_op_402 + jac_blending_inv_0_1_q_4*tmp_kernel_op_403 + jac_blending_inv_0_2_q_4*tmp_kernel_op_404;
             const real_t tmp_kernel_op_406 = jac_blending_inv_1_0_q_4*tmp_kernel_op_402 + jac_blending_inv_1_1_q_4*tmp_kernel_op_403 + jac_blending_inv_1_2_q_4*tmp_kernel_op_404;
             const real_t tmp_kernel_op_407 = jac_blending_inv_2_0_q_4*tmp_kernel_op_402 + jac_blending_inv_2_1_q_4*tmp_kernel_op_403 + jac_blending_inv_2_2_q_4*tmp_kernel_op_404;
             const real_t tmp_kernel_op_408 = -hessian_blending_0_0_0_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_0_1_0_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_0_2_0_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_409 = -hessian_blending_0_0_1_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_0_1_1_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_0_2_1_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_410 = -hessian_blending_0_0_2_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_0_1_2_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_0_2_2_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_411 = jac_blending_inv_0_0_q_4*tmp_kernel_op_408 + jac_blending_inv_0_1_q_4*tmp_kernel_op_409 + jac_blending_inv_0_2_q_4*tmp_kernel_op_410;
             const real_t tmp_kernel_op_412 = jac_blending_inv_1_0_q_4*tmp_kernel_op_408 + jac_blending_inv_1_1_q_4*tmp_kernel_op_409 + jac_blending_inv_1_2_q_4*tmp_kernel_op_410;
             const real_t tmp_kernel_op_413 = jac_blending_inv_2_0_q_4*tmp_kernel_op_408 + jac_blending_inv_2_1_q_4*tmp_kernel_op_409 + jac_blending_inv_2_2_q_4*tmp_kernel_op_410;
             const real_t tmp_kernel_op_414 = -hessian_blending_1_0_0_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_1_1_0_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_1_2_0_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_415 = -hessian_blending_1_0_1_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_1_1_1_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_1_2_1_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_416 = -hessian_blending_1_0_2_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_1_1_2_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_1_2_2_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_417 = jac_blending_inv_0_0_q_4*tmp_kernel_op_414 + jac_blending_inv_0_1_q_4*tmp_kernel_op_415 + jac_blending_inv_0_2_q_4*tmp_kernel_op_416;
             const real_t tmp_kernel_op_418 = jac_blending_inv_1_0_q_4*tmp_kernel_op_414 + jac_blending_inv_1_1_q_4*tmp_kernel_op_415 + jac_blending_inv_1_2_q_4*tmp_kernel_op_416;
             const real_t tmp_kernel_op_419 = jac_blending_inv_2_0_q_4*tmp_kernel_op_414 + jac_blending_inv_2_1_q_4*tmp_kernel_op_415 + jac_blending_inv_2_2_q_4*tmp_kernel_op_416;
             const real_t tmp_kernel_op_420 = -hessian_blending_2_0_0_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_2_1_0_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_2_2_0_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_421 = -hessian_blending_2_0_1_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_2_1_1_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_2_2_1_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_422 = -hessian_blending_2_0_2_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_2_1_2_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_2_2_2_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_423 = jac_blending_inv_0_0_q_4*tmp_kernel_op_420 + jac_blending_inv_0_1_q_4*tmp_kernel_op_421 + jac_blending_inv_0_2_q_4*tmp_kernel_op_422;
             const real_t tmp_kernel_op_424 = jac_blending_inv_1_0_q_4*tmp_kernel_op_420 + jac_blending_inv_1_1_q_4*tmp_kernel_op_421 + jac_blending_inv_1_2_q_4*tmp_kernel_op_422;
             const real_t tmp_kernel_op_425 = jac_blending_inv_2_0_q_4*tmp_kernel_op_420 + jac_blending_inv_2_1_q_4*tmp_kernel_op_421 + jac_blending_inv_2_2_q_4*tmp_kernel_op_422;
             const real_t tmp_kernel_op_426 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_5 + jac_blending_inv_1_0_q_4*tmp_moved_constant_11 + jac_blending_inv_2_0_q_4*tmp_moved_constant_17) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_36 + tmp_kernel_op_375*tmp_moved_constant_37 + tmp_kernel_op_377*tmp_moved_constant_38) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_5 + jac_blending_inv_1_1_q_4*tmp_moved_constant_11 + jac_blending_inv_2_1_q_4*tmp_moved_constant_17) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_36 + tmp_kernel_op_382*tmp_moved_constant_37 + tmp_kernel_op_383*tmp_moved_constant_38) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_5 + jac_blending_inv_1_2_q_4*tmp_moved_constant_11 + jac_blending_inv_2_2_q_4*tmp_moved_constant_17) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_36 + tmp_kernel_op_388*tmp_moved_constant_37 + tmp_kernel_op_389*tmp_moved_constant_38) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_18 + jac_blending_inv_1_0_q_4*tmp_moved_constant_19 + jac_blending_inv_2_0_q_4*tmp_moved_constant_20) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_36 + tmp_kernel_op_394*tmp_moved_constant_37 + tmp_kernel_op_395*tmp_moved_constant_38) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_18 + jac_blending_inv_1_1_q_4*tmp_moved_constant_19 + jac_blending_inv_2_1_q_4*tmp_moved_constant_20) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_36 + tmp_kernel_op_400*tmp_moved_constant_37 + tmp_kernel_op_401*tmp_moved_constant_38) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_18 + jac_blending_inv_1_2_q_4*tmp_moved_constant_19 + jac_blending_inv_2_2_q_4*tmp_moved_constant_20) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_36 + tmp_kernel_op_406*tmp_moved_constant_37 + tmp_kernel_op_407*tmp_moved_constant_38) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_21 + jac_blending_inv_1_0_q_4*tmp_moved_constant_22 + jac_blending_inv_2_0_q_4*tmp_moved_constant_23) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_36 + tmp_kernel_op_412*tmp_moved_constant_37 + tmp_kernel_op_413*tmp_moved_constant_38) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_21 + jac_blending_inv_1_1_q_4*tmp_moved_constant_22 + jac_blending_inv_2_1_q_4*tmp_moved_constant_23) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_36 + tmp_kernel_op_418*tmp_moved_constant_37 + tmp_kernel_op_419*tmp_moved_constant_38) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_21 + jac_blending_inv_1_2_q_4*tmp_moved_constant_22 + jac_blending_inv_2_2_q_4*tmp_moved_constant_23) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_36 + tmp_kernel_op_424*tmp_moved_constant_37 + tmp_kernel_op_425*tmp_moved_constant_38);
             const real_t tmp_kernel_op_444 = tmp_kernel_op_427*wx_dof_4 + tmp_kernel_op_428*wx_dof_5 + tmp_kernel_op_429*wx_dof_6 + tmp_kernel_op_432*wx_dof_1 + tmp_kernel_op_435*wx_dof_2 + tmp_kernel_op_438*wx_dof_3 + tmp_kernel_op_439*wx_dof_7 + tmp_kernel_op_440*wx_dof_8 + tmp_kernel_op_442*wx_dof_9 + tmp_kernel_op_443*wx_dof_0;
             const real_t tmp_kernel_op_445 = tmp_kernel_op_427*wy_dof_4 + tmp_kernel_op_428*wy_dof_5 + tmp_kernel_op_429*wy_dof_6 + tmp_kernel_op_432*wy_dof_1 + tmp_kernel_op_435*wy_dof_2 + tmp_kernel_op_438*wy_dof_3 + tmp_kernel_op_439*wy_dof_7 + tmp_kernel_op_440*wy_dof_8 + tmp_kernel_op_442*wy_dof_9 + tmp_kernel_op_443*wy_dof_0;
             const real_t tmp_kernel_op_446 = tmp_kernel_op_427*wz_dof_4 + tmp_kernel_op_428*wz_dof_5 + tmp_kernel_op_429*wz_dof_6 + tmp_kernel_op_432*wz_dof_1 + tmp_kernel_op_435*wz_dof_2 + tmp_kernel_op_438*wz_dof_3 + tmp_kernel_op_439*wz_dof_7 + tmp_kernel_op_440*wz_dof_8 + tmp_kernel_op_442*wz_dof_9 + tmp_kernel_op_443*wz_dof_0;
             const real_t tmp_kernel_op_447 = abs_det_jac_affine_WHITE_DOWN*abs_det_jac_blending_q_4*(diffusivity_times_delta_dof_0*tmp_kernel_op_443 + diffusivity_times_delta_dof_1*tmp_kernel_op_432 + diffusivity_times_delta_dof_2*tmp_kernel_op_435 + diffusivity_times_delta_dof_3*tmp_kernel_op_438 + diffusivity_times_delta_dof_4*tmp_kernel_op_427 + diffusivity_times_delta_dof_5*tmp_kernel_op_428 + diffusivity_times_delta_dof_6*tmp_kernel_op_429 + diffusivity_times_delta_dof_7*tmp_kernel_op_439 + diffusivity_times_delta_dof_8*tmp_kernel_op_440 + diffusivity_times_delta_dof_9*tmp_kernel_op_442)*0.074999999999999983;
             const real_t tmp_kernel_op_448 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_36 + jac_blending_inv_1_0_q_4*tmp_moved_constant_37 + jac_blending_inv_2_0_q_4*tmp_moved_constant_38) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_36 + jac_blending_inv_1_1_q_4*tmp_moved_constant_37 + jac_blending_inv_2_1_q_4*tmp_moved_constant_38) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_36 + jac_blending_inv_1_2_q_4*tmp_moved_constant_37 + jac_blending_inv_2_2_q_4*tmp_moved_constant_38));
             const real_t tmp_kernel_op_459 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_41 + jac_blending_inv_1_0_q_0*tmp_moved_constant_39 + jac_blending_inv_2_0_q_0*tmp_moved_constant_40) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_45 + tmp_kernel_op_35*tmp_moved_constant_46 + tmp_kernel_op_37*tmp_moved_constant_47) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_41 + jac_blending_inv_1_1_q_0*tmp_moved_constant_39 + jac_blending_inv_2_1_q_0*tmp_moved_constant_40) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_45 + tmp_kernel_op_42*tmp_moved_constant_46 + tmp_kernel_op_43*tmp_moved_constant_47) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_41 + jac_blending_inv_1_2_q_0*tmp_moved_constant_39 + jac_blending_inv_2_2_q_0*tmp_moved_constant_40) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_45 + tmp_kernel_op_48*tmp_moved_constant_46 + tmp_kernel_op_49*tmp_moved_constant_47) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_39 + jac_blending_inv_1_0_q_0*tmp_moved_constant_43 + jac_blending_inv_2_0_q_0*tmp_moved_constant_42) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_45 + tmp_kernel_op_54*tmp_moved_constant_46 + tmp_kernel_op_55*tmp_moved_constant_47) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_39 + jac_blending_inv_1_1_q_0*tmp_moved_constant_43 + jac_blending_inv_2_1_q_0*tmp_moved_constant_42) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_45 + tmp_kernel_op_60*tmp_moved_constant_46 + tmp_kernel_op_61*tmp_moved_constant_47) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_39 + jac_blending_inv_1_2_q_0*tmp_moved_constant_43 + jac_blending_inv_2_2_q_0*tmp_moved_constant_42) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_45 + tmp_kernel_op_66*tmp_moved_constant_46 + tmp_kernel_op_67*tmp_moved_constant_47) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_40 + jac_blending_inv_1_0_q_0*tmp_moved_constant_42 + jac_blending_inv_2_0_q_0*tmp_moved_constant_44) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_45 + tmp_kernel_op_72*tmp_moved_constant_46 + tmp_kernel_op_73*tmp_moved_constant_47) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_40 + jac_blending_inv_1_1_q_0*tmp_moved_constant_42 + jac_blending_inv_2_1_q_0*tmp_moved_constant_44) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_45 + tmp_kernel_op_78*tmp_moved_constant_46 + tmp_kernel_op_79*tmp_moved_constant_47) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_40 + jac_blending_inv_1_2_q_0*tmp_moved_constant_42 + jac_blending_inv_2_2_q_0*tmp_moved_constant_44) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_45 + tmp_kernel_op_84*tmp_moved_constant_46 + tmp_kernel_op_85*tmp_moved_constant_47);
             const real_t tmp_kernel_op_464 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_41 + jac_blending_inv_1_0_q_1*tmp_moved_constant_39 + jac_blending_inv_2_0_q_1*tmp_moved_constant_40) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_48 + tmp_kernel_op_120*tmp_moved_constant_49 + tmp_kernel_op_122*tmp_moved_constant_50) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_41 + jac_blending_inv_1_1_q_1*tmp_moved_constant_39 + jac_blending_inv_2_1_q_1*tmp_moved_constant_40) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_48 + tmp_kernel_op_127*tmp_moved_constant_49 + tmp_kernel_op_128*tmp_moved_constant_50) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_41 + jac_blending_inv_1_2_q_1*tmp_moved_constant_39 + jac_blending_inv_2_2_q_1*tmp_moved_constant_40) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_48 + tmp_kernel_op_133*tmp_moved_constant_49 + tmp_kernel_op_134*tmp_moved_constant_50) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_39 + jac_blending_inv_1_0_q_1*tmp_moved_constant_43 + jac_blending_inv_2_0_q_1*tmp_moved_constant_42) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_48 + tmp_kernel_op_139*tmp_moved_constant_49 + tmp_kernel_op_140*tmp_moved_constant_50) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_39 + jac_blending_inv_1_1_q_1*tmp_moved_constant_43 + jac_blending_inv_2_1_q_1*tmp_moved_constant_42) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_48 + tmp_kernel_op_145*tmp_moved_constant_49 + tmp_kernel_op_146*tmp_moved_constant_50) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_39 + jac_blending_inv_1_2_q_1*tmp_moved_constant_43 + jac_blending_inv_2_2_q_1*tmp_moved_constant_42) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_48 + tmp_kernel_op_151*tmp_moved_constant_49 + tmp_kernel_op_152*tmp_moved_constant_50) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_40 + jac_blending_inv_1_0_q_1*tmp_moved_constant_42 + jac_blending_inv_2_0_q_1*tmp_moved_constant_44) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_48 + tmp_kernel_op_157*tmp_moved_constant_49 + tmp_kernel_op_158*tmp_moved_constant_50) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_40 + jac_blending_inv_1_1_q_1*tmp_moved_constant_42 + jac_blending_inv_2_1_q_1*tmp_moved_constant_44) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_48 + tmp_kernel_op_163*tmp_moved_constant_49 + tmp_kernel_op_164*tmp_moved_constant_50) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_40 + jac_blending_inv_1_2_q_1*tmp_moved_constant_42 + jac_blending_inv_2_2_q_1*tmp_moved_constant_44) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_48 + tmp_kernel_op_169*tmp_moved_constant_49 + tmp_kernel_op_170*tmp_moved_constant_50);
             const real_t tmp_kernel_op_469 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_41 + jac_blending_inv_1_0_q_2*tmp_moved_constant_39 + jac_blending_inv_2_0_q_2*tmp_moved_constant_40) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_51 + tmp_kernel_op_205*tmp_moved_constant_52 + tmp_kernel_op_207*tmp_moved_constant_53) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_41 + jac_blending_inv_1_1_q_2*tmp_moved_constant_39 + jac_blending_inv_2_1_q_2*tmp_moved_constant_40) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_51 + tmp_kernel_op_212*tmp_moved_constant_52 + tmp_kernel_op_213*tmp_moved_constant_53) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_41 + jac_blending_inv_1_2_q_2*tmp_moved_constant_39 + jac_blending_inv_2_2_q_2*tmp_moved_constant_40) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_51 + tmp_kernel_op_218*tmp_moved_constant_52 + tmp_kernel_op_219*tmp_moved_constant_53) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_39 + jac_blending_inv_1_0_q_2*tmp_moved_constant_43 + jac_blending_inv_2_0_q_2*tmp_moved_constant_42) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_51 + tmp_kernel_op_224*tmp_moved_constant_52 + tmp_kernel_op_225*tmp_moved_constant_53) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_39 + jac_blending_inv_1_1_q_2*tmp_moved_constant_43 + jac_blending_inv_2_1_q_2*tmp_moved_constant_42) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_51 + tmp_kernel_op_230*tmp_moved_constant_52 + tmp_kernel_op_231*tmp_moved_constant_53) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_39 + jac_blending_inv_1_2_q_2*tmp_moved_constant_43 + jac_blending_inv_2_2_q_2*tmp_moved_constant_42) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_51 + tmp_kernel_op_236*tmp_moved_constant_52 + tmp_kernel_op_237*tmp_moved_constant_53) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_40 + jac_blending_inv_1_0_q_2*tmp_moved_constant_42 + jac_blending_inv_2_0_q_2*tmp_moved_constant_44) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_51 + tmp_kernel_op_242*tmp_moved_constant_52 + tmp_kernel_op_243*tmp_moved_constant_53) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_40 + jac_blending_inv_1_1_q_2*tmp_moved_constant_42 + jac_blending_inv_2_1_q_2*tmp_moved_constant_44) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_51 + tmp_kernel_op_248*tmp_moved_constant_52 + tmp_kernel_op_249*tmp_moved_constant_53) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_40 + jac_blending_inv_1_2_q_2*tmp_moved_constant_42 + jac_blending_inv_2_2_q_2*tmp_moved_constant_44) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_51 + tmp_kernel_op_254*tmp_moved_constant_52 + tmp_kernel_op_255*tmp_moved_constant_53);
             const real_t tmp_kernel_op_474 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_41 + jac_blending_inv_1_0_q_3*tmp_moved_constant_39 + jac_blending_inv_2_0_q_3*tmp_moved_constant_40) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_54 + tmp_kernel_op_290*tmp_moved_constant_55 + tmp_kernel_op_292*tmp_moved_constant_56) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_41 + jac_blending_inv_1_1_q_3*tmp_moved_constant_39 + jac_blending_inv_2_1_q_3*tmp_moved_constant_40) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_54 + tmp_kernel_op_297*tmp_moved_constant_55 + tmp_kernel_op_298*tmp_moved_constant_56) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_41 + jac_blending_inv_1_2_q_3*tmp_moved_constant_39 + jac_blending_inv_2_2_q_3*tmp_moved_constant_40) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_54 + tmp_kernel_op_303*tmp_moved_constant_55 + tmp_kernel_op_304*tmp_moved_constant_56) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_39 + jac_blending_inv_1_0_q_3*tmp_moved_constant_43 + jac_blending_inv_2_0_q_3*tmp_moved_constant_42) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_54 + tmp_kernel_op_309*tmp_moved_constant_55 + tmp_kernel_op_310*tmp_moved_constant_56) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_39 + jac_blending_inv_1_1_q_3*tmp_moved_constant_43 + jac_blending_inv_2_1_q_3*tmp_moved_constant_42) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_54 + tmp_kernel_op_315*tmp_moved_constant_55 + tmp_kernel_op_316*tmp_moved_constant_56) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_39 + jac_blending_inv_1_2_q_3*tmp_moved_constant_43 + jac_blending_inv_2_2_q_3*tmp_moved_constant_42) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_54 + tmp_kernel_op_321*tmp_moved_constant_55 + tmp_kernel_op_322*tmp_moved_constant_56) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_40 + jac_blending_inv_1_0_q_3*tmp_moved_constant_42 + jac_blending_inv_2_0_q_3*tmp_moved_constant_44) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_54 + tmp_kernel_op_327*tmp_moved_constant_55 + tmp_kernel_op_328*tmp_moved_constant_56) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_40 + jac_blending_inv_1_1_q_3*tmp_moved_constant_42 + jac_blending_inv_2_1_q_3*tmp_moved_constant_44) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_54 + tmp_kernel_op_333*tmp_moved_constant_55 + tmp_kernel_op_334*tmp_moved_constant_56) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_40 + jac_blending_inv_1_2_q_3*tmp_moved_constant_42 + jac_blending_inv_2_2_q_3*tmp_moved_constant_44) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_54 + tmp_kernel_op_339*tmp_moved_constant_55 + tmp_kernel_op_340*tmp_moved_constant_56);
             const real_t tmp_kernel_op_479 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_41 + jac_blending_inv_1_0_q_4*tmp_moved_constant_39 + jac_blending_inv_2_0_q_4*tmp_moved_constant_40) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_57 + tmp_kernel_op_375*tmp_moved_constant_58 + tmp_kernel_op_377*tmp_moved_constant_59) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_41 + jac_blending_inv_1_1_q_4*tmp_moved_constant_39 + jac_blending_inv_2_1_q_4*tmp_moved_constant_40) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_57 + tmp_kernel_op_382*tmp_moved_constant_58 + tmp_kernel_op_383*tmp_moved_constant_59) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_41 + jac_blending_inv_1_2_q_4*tmp_moved_constant_39 + jac_blending_inv_2_2_q_4*tmp_moved_constant_40) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_57 + tmp_kernel_op_388*tmp_moved_constant_58 + tmp_kernel_op_389*tmp_moved_constant_59) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_39 + jac_blending_inv_1_0_q_4*tmp_moved_constant_43 + jac_blending_inv_2_0_q_4*tmp_moved_constant_42) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_57 + tmp_kernel_op_394*tmp_moved_constant_58 + tmp_kernel_op_395*tmp_moved_constant_59) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_39 + jac_blending_inv_1_1_q_4*tmp_moved_constant_43 + jac_blending_inv_2_1_q_4*tmp_moved_constant_42) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_57 + tmp_kernel_op_400*tmp_moved_constant_58 + tmp_kernel_op_401*tmp_moved_constant_59) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_39 + jac_blending_inv_1_2_q_4*tmp_moved_constant_43 + jac_blending_inv_2_2_q_4*tmp_moved_constant_42) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_57 + tmp_kernel_op_406*tmp_moved_constant_58 + tmp_kernel_op_407*tmp_moved_constant_59) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_40 + jac_blending_inv_1_0_q_4*tmp_moved_constant_42 + jac_blending_inv_2_0_q_4*tmp_moved_constant_44) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_57 + tmp_kernel_op_412*tmp_moved_constant_58 + tmp_kernel_op_413*tmp_moved_constant_59) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_40 + jac_blending_inv_1_1_q_4*tmp_moved_constant_42 + jac_blending_inv_2_1_q_4*tmp_moved_constant_44) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_57 + tmp_kernel_op_418*tmp_moved_constant_58 + tmp_kernel_op_419*tmp_moved_constant_59) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_40 + jac_blending_inv_1_2_q_4*tmp_moved_constant_42 + jac_blending_inv_2_2_q_4*tmp_moved_constant_44) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_57 + tmp_kernel_op_424*tmp_moved_constant_58 + tmp_kernel_op_425*tmp_moved_constant_59);
             const real_t tmp_kernel_op_490 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_62 + jac_blending_inv_1_0_q_0*tmp_moved_constant_60 + jac_blending_inv_2_0_q_0*tmp_moved_constant_61) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_66 + tmp_kernel_op_35*tmp_moved_constant_67 + tmp_kernel_op_37*tmp_moved_constant_68) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_62 + jac_blending_inv_1_1_q_0*tmp_moved_constant_60 + jac_blending_inv_2_1_q_0*tmp_moved_constant_61) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_66 + tmp_kernel_op_42*tmp_moved_constant_67 + tmp_kernel_op_43*tmp_moved_constant_68) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_62 + jac_blending_inv_1_2_q_0*tmp_moved_constant_60 + jac_blending_inv_2_2_q_0*tmp_moved_constant_61) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_66 + tmp_kernel_op_48*tmp_moved_constant_67 + tmp_kernel_op_49*tmp_moved_constant_68) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_60 + jac_blending_inv_1_0_q_0*tmp_moved_constant_64 + jac_blending_inv_2_0_q_0*tmp_moved_constant_63) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_66 + tmp_kernel_op_54*tmp_moved_constant_67 + tmp_kernel_op_55*tmp_moved_constant_68) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_60 + jac_blending_inv_1_1_q_0*tmp_moved_constant_64 + jac_blending_inv_2_1_q_0*tmp_moved_constant_63) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_66 + tmp_kernel_op_60*tmp_moved_constant_67 + tmp_kernel_op_61*tmp_moved_constant_68) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_60 + jac_blending_inv_1_2_q_0*tmp_moved_constant_64 + jac_blending_inv_2_2_q_0*tmp_moved_constant_63) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_66 + tmp_kernel_op_66*tmp_moved_constant_67 + tmp_kernel_op_67*tmp_moved_constant_68) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_61 + jac_blending_inv_1_0_q_0*tmp_moved_constant_63 + jac_blending_inv_2_0_q_0*tmp_moved_constant_65) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_66 + tmp_kernel_op_72*tmp_moved_constant_67 + tmp_kernel_op_73*tmp_moved_constant_68) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_61 + jac_blending_inv_1_1_q_0*tmp_moved_constant_63 + jac_blending_inv_2_1_q_0*tmp_moved_constant_65) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_66 + tmp_kernel_op_78*tmp_moved_constant_67 + tmp_kernel_op_79*tmp_moved_constant_68) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_61 + jac_blending_inv_1_2_q_0*tmp_moved_constant_63 + jac_blending_inv_2_2_q_0*tmp_moved_constant_65) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_66 + tmp_kernel_op_84*tmp_moved_constant_67 + tmp_kernel_op_85*tmp_moved_constant_68);
             const real_t tmp_kernel_op_495 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_62 + jac_blending_inv_1_0_q_1*tmp_moved_constant_60 + jac_blending_inv_2_0_q_1*tmp_moved_constant_61) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_69 + tmp_kernel_op_120*tmp_moved_constant_70 + tmp_kernel_op_122*tmp_moved_constant_71) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_62 + jac_blending_inv_1_1_q_1*tmp_moved_constant_60 + jac_blending_inv_2_1_q_1*tmp_moved_constant_61) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_69 + tmp_kernel_op_127*tmp_moved_constant_70 + tmp_kernel_op_128*tmp_moved_constant_71) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_62 + jac_blending_inv_1_2_q_1*tmp_moved_constant_60 + jac_blending_inv_2_2_q_1*tmp_moved_constant_61) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_69 + tmp_kernel_op_133*tmp_moved_constant_70 + tmp_kernel_op_134*tmp_moved_constant_71) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_60 + jac_blending_inv_1_0_q_1*tmp_moved_constant_64 + jac_blending_inv_2_0_q_1*tmp_moved_constant_63) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_69 + tmp_kernel_op_139*tmp_moved_constant_70 + tmp_kernel_op_140*tmp_moved_constant_71) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_60 + jac_blending_inv_1_1_q_1*tmp_moved_constant_64 + jac_blending_inv_2_1_q_1*tmp_moved_constant_63) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_69 + tmp_kernel_op_145*tmp_moved_constant_70 + tmp_kernel_op_146*tmp_moved_constant_71) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_60 + jac_blending_inv_1_2_q_1*tmp_moved_constant_64 + jac_blending_inv_2_2_q_1*tmp_moved_constant_63) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_69 + tmp_kernel_op_151*tmp_moved_constant_70 + tmp_kernel_op_152*tmp_moved_constant_71) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_61 + jac_blending_inv_1_0_q_1*tmp_moved_constant_63 + jac_blending_inv_2_0_q_1*tmp_moved_constant_65) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_69 + tmp_kernel_op_157*tmp_moved_constant_70 + tmp_kernel_op_158*tmp_moved_constant_71) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_61 + jac_blending_inv_1_1_q_1*tmp_moved_constant_63 + jac_blending_inv_2_1_q_1*tmp_moved_constant_65) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_69 + tmp_kernel_op_163*tmp_moved_constant_70 + tmp_kernel_op_164*tmp_moved_constant_71) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_61 + jac_blending_inv_1_2_q_1*tmp_moved_constant_63 + jac_blending_inv_2_2_q_1*tmp_moved_constant_65) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_69 + tmp_kernel_op_169*tmp_moved_constant_70 + tmp_kernel_op_170*tmp_moved_constant_71);
             const real_t tmp_kernel_op_500 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_62 + jac_blending_inv_1_0_q_2*tmp_moved_constant_60 + jac_blending_inv_2_0_q_2*tmp_moved_constant_61) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_72 + tmp_kernel_op_205*tmp_moved_constant_73 + tmp_kernel_op_207*tmp_moved_constant_74) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_62 + jac_blending_inv_1_1_q_2*tmp_moved_constant_60 + jac_blending_inv_2_1_q_2*tmp_moved_constant_61) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_72 + tmp_kernel_op_212*tmp_moved_constant_73 + tmp_kernel_op_213*tmp_moved_constant_74) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_62 + jac_blending_inv_1_2_q_2*tmp_moved_constant_60 + jac_blending_inv_2_2_q_2*tmp_moved_constant_61) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_72 + tmp_kernel_op_218*tmp_moved_constant_73 + tmp_kernel_op_219*tmp_moved_constant_74) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_60 + jac_blending_inv_1_0_q_2*tmp_moved_constant_64 + jac_blending_inv_2_0_q_2*tmp_moved_constant_63) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_72 + tmp_kernel_op_224*tmp_moved_constant_73 + tmp_kernel_op_225*tmp_moved_constant_74) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_60 + jac_blending_inv_1_1_q_2*tmp_moved_constant_64 + jac_blending_inv_2_1_q_2*tmp_moved_constant_63) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_72 + tmp_kernel_op_230*tmp_moved_constant_73 + tmp_kernel_op_231*tmp_moved_constant_74) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_60 + jac_blending_inv_1_2_q_2*tmp_moved_constant_64 + jac_blending_inv_2_2_q_2*tmp_moved_constant_63) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_72 + tmp_kernel_op_236*tmp_moved_constant_73 + tmp_kernel_op_237*tmp_moved_constant_74) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_61 + jac_blending_inv_1_0_q_2*tmp_moved_constant_63 + jac_blending_inv_2_0_q_2*tmp_moved_constant_65) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_72 + tmp_kernel_op_242*tmp_moved_constant_73 + tmp_kernel_op_243*tmp_moved_constant_74) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_61 + jac_blending_inv_1_1_q_2*tmp_moved_constant_63 + jac_blending_inv_2_1_q_2*tmp_moved_constant_65) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_72 + tmp_kernel_op_248*tmp_moved_constant_73 + tmp_kernel_op_249*tmp_moved_constant_74) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_61 + jac_blending_inv_1_2_q_2*tmp_moved_constant_63 + jac_blending_inv_2_2_q_2*tmp_moved_constant_65) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_72 + tmp_kernel_op_254*tmp_moved_constant_73 + tmp_kernel_op_255*tmp_moved_constant_74);
             const real_t tmp_kernel_op_505 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_62 + jac_blending_inv_1_0_q_3*tmp_moved_constant_60 + jac_blending_inv_2_0_q_3*tmp_moved_constant_61) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_75 + tmp_kernel_op_290*tmp_moved_constant_76 + tmp_kernel_op_292*tmp_moved_constant_77) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_62 + jac_blending_inv_1_1_q_3*tmp_moved_constant_60 + jac_blending_inv_2_1_q_3*tmp_moved_constant_61) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_75 + tmp_kernel_op_297*tmp_moved_constant_76 + tmp_kernel_op_298*tmp_moved_constant_77) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_62 + jac_blending_inv_1_2_q_3*tmp_moved_constant_60 + jac_blending_inv_2_2_q_3*tmp_moved_constant_61) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_75 + tmp_kernel_op_303*tmp_moved_constant_76 + tmp_kernel_op_304*tmp_moved_constant_77) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_60 + jac_blending_inv_1_0_q_3*tmp_moved_constant_64 + jac_blending_inv_2_0_q_3*tmp_moved_constant_63) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_75 + tmp_kernel_op_309*tmp_moved_constant_76 + tmp_kernel_op_310*tmp_moved_constant_77) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_60 + jac_blending_inv_1_1_q_3*tmp_moved_constant_64 + jac_blending_inv_2_1_q_3*tmp_moved_constant_63) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_75 + tmp_kernel_op_315*tmp_moved_constant_76 + tmp_kernel_op_316*tmp_moved_constant_77) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_60 + jac_blending_inv_1_2_q_3*tmp_moved_constant_64 + jac_blending_inv_2_2_q_3*tmp_moved_constant_63) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_75 + tmp_kernel_op_321*tmp_moved_constant_76 + tmp_kernel_op_322*tmp_moved_constant_77) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_61 + jac_blending_inv_1_0_q_3*tmp_moved_constant_63 + jac_blending_inv_2_0_q_3*tmp_moved_constant_65) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_75 + tmp_kernel_op_327*tmp_moved_constant_76 + tmp_kernel_op_328*tmp_moved_constant_77) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_61 + jac_blending_inv_1_1_q_3*tmp_moved_constant_63 + jac_blending_inv_2_1_q_3*tmp_moved_constant_65) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_75 + tmp_kernel_op_333*tmp_moved_constant_76 + tmp_kernel_op_334*tmp_moved_constant_77) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_61 + jac_blending_inv_1_2_q_3*tmp_moved_constant_63 + jac_blending_inv_2_2_q_3*tmp_moved_constant_65) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_75 + tmp_kernel_op_339*tmp_moved_constant_76 + tmp_kernel_op_340*tmp_moved_constant_77);
             const real_t tmp_kernel_op_510 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_62 + jac_blending_inv_1_0_q_4*tmp_moved_constant_60 + jac_blending_inv_2_0_q_4*tmp_moved_constant_61) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_78 + tmp_kernel_op_375*tmp_moved_constant_79 + tmp_kernel_op_377*tmp_moved_constant_80) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_62 + jac_blending_inv_1_1_q_4*tmp_moved_constant_60 + jac_blending_inv_2_1_q_4*tmp_moved_constant_61) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_78 + tmp_kernel_op_382*tmp_moved_constant_79 + tmp_kernel_op_383*tmp_moved_constant_80) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_62 + jac_blending_inv_1_2_q_4*tmp_moved_constant_60 + jac_blending_inv_2_2_q_4*tmp_moved_constant_61) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_78 + tmp_kernel_op_388*tmp_moved_constant_79 + tmp_kernel_op_389*tmp_moved_constant_80) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_60 + jac_blending_inv_1_0_q_4*tmp_moved_constant_64 + jac_blending_inv_2_0_q_4*tmp_moved_constant_63) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_78 + tmp_kernel_op_394*tmp_moved_constant_79 + tmp_kernel_op_395*tmp_moved_constant_80) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_60 + jac_blending_inv_1_1_q_4*tmp_moved_constant_64 + jac_blending_inv_2_1_q_4*tmp_moved_constant_63) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_78 + tmp_kernel_op_400*tmp_moved_constant_79 + tmp_kernel_op_401*tmp_moved_constant_80) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_60 + jac_blending_inv_1_2_q_4*tmp_moved_constant_64 + jac_blending_inv_2_2_q_4*tmp_moved_constant_63) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_78 + tmp_kernel_op_406*tmp_moved_constant_79 + tmp_kernel_op_407*tmp_moved_constant_80) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_61 + jac_blending_inv_1_0_q_4*tmp_moved_constant_63 + jac_blending_inv_2_0_q_4*tmp_moved_constant_65) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_78 + tmp_kernel_op_412*tmp_moved_constant_79 + tmp_kernel_op_413*tmp_moved_constant_80) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_61 + jac_blending_inv_1_1_q_4*tmp_moved_constant_63 + jac_blending_inv_2_1_q_4*tmp_moved_constant_65) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_78 + tmp_kernel_op_418*tmp_moved_constant_79 + tmp_kernel_op_419*tmp_moved_constant_80) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_61 + jac_blending_inv_1_2_q_4*tmp_moved_constant_63 + jac_blending_inv_2_2_q_4*tmp_moved_constant_65) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_78 + tmp_kernel_op_424*tmp_moved_constant_79 + tmp_kernel_op_425*tmp_moved_constant_80);
             const real_t tmp_kernel_op_521 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_83 + jac_blending_inv_1_0_q_0*tmp_moved_constant_81 + jac_blending_inv_2_0_q_0*tmp_moved_constant_82) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_87 + tmp_kernel_op_35*tmp_moved_constant_88 + tmp_kernel_op_37*tmp_moved_constant_89) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_83 + jac_blending_inv_1_1_q_0*tmp_moved_constant_81 + jac_blending_inv_2_1_q_0*tmp_moved_constant_82) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_87 + tmp_kernel_op_42*tmp_moved_constant_88 + tmp_kernel_op_43*tmp_moved_constant_89) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_83 + jac_blending_inv_1_2_q_0*tmp_moved_constant_81 + jac_blending_inv_2_2_q_0*tmp_moved_constant_82) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_87 + tmp_kernel_op_48*tmp_moved_constant_88 + tmp_kernel_op_49*tmp_moved_constant_89) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_81 + jac_blending_inv_1_0_q_0*tmp_moved_constant_85 + jac_blending_inv_2_0_q_0*tmp_moved_constant_84) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_87 + tmp_kernel_op_54*tmp_moved_constant_88 + tmp_kernel_op_55*tmp_moved_constant_89) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_81 + jac_blending_inv_1_1_q_0*tmp_moved_constant_85 + jac_blending_inv_2_1_q_0*tmp_moved_constant_84) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_87 + tmp_kernel_op_60*tmp_moved_constant_88 + tmp_kernel_op_61*tmp_moved_constant_89) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_81 + jac_blending_inv_1_2_q_0*tmp_moved_constant_85 + jac_blending_inv_2_2_q_0*tmp_moved_constant_84) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_87 + tmp_kernel_op_66*tmp_moved_constant_88 + tmp_kernel_op_67*tmp_moved_constant_89) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_82 + jac_blending_inv_1_0_q_0*tmp_moved_constant_84 + jac_blending_inv_2_0_q_0*tmp_moved_constant_86) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_87 + tmp_kernel_op_72*tmp_moved_constant_88 + tmp_kernel_op_73*tmp_moved_constant_89) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_82 + jac_blending_inv_1_1_q_0*tmp_moved_constant_84 + jac_blending_inv_2_1_q_0*tmp_moved_constant_86) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_87 + tmp_kernel_op_78*tmp_moved_constant_88 + tmp_kernel_op_79*tmp_moved_constant_89) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_82 + jac_blending_inv_1_2_q_0*tmp_moved_constant_84 + jac_blending_inv_2_2_q_0*tmp_moved_constant_86) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_87 + tmp_kernel_op_84*tmp_moved_constant_88 + tmp_kernel_op_85*tmp_moved_constant_89);
             const real_t tmp_kernel_op_526 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_83 + jac_blending_inv_1_0_q_1*tmp_moved_constant_81 + jac_blending_inv_2_0_q_1*tmp_moved_constant_82) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_90 + tmp_kernel_op_120*tmp_moved_constant_91 + tmp_kernel_op_122*tmp_moved_constant_92) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_83 + jac_blending_inv_1_1_q_1*tmp_moved_constant_81 + jac_blending_inv_2_1_q_1*tmp_moved_constant_82) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_90 + tmp_kernel_op_127*tmp_moved_constant_91 + tmp_kernel_op_128*tmp_moved_constant_92) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_83 + jac_blending_inv_1_2_q_1*tmp_moved_constant_81 + jac_blending_inv_2_2_q_1*tmp_moved_constant_82) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_90 + tmp_kernel_op_133*tmp_moved_constant_91 + tmp_kernel_op_134*tmp_moved_constant_92) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_81 + jac_blending_inv_1_0_q_1*tmp_moved_constant_85 + jac_blending_inv_2_0_q_1*tmp_moved_constant_84) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_90 + tmp_kernel_op_139*tmp_moved_constant_91 + tmp_kernel_op_140*tmp_moved_constant_92) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_81 + jac_blending_inv_1_1_q_1*tmp_moved_constant_85 + jac_blending_inv_2_1_q_1*tmp_moved_constant_84) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_90 + tmp_kernel_op_145*tmp_moved_constant_91 + tmp_kernel_op_146*tmp_moved_constant_92) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_81 + jac_blending_inv_1_2_q_1*tmp_moved_constant_85 + jac_blending_inv_2_2_q_1*tmp_moved_constant_84) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_90 + tmp_kernel_op_151*tmp_moved_constant_91 + tmp_kernel_op_152*tmp_moved_constant_92) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_82 + jac_blending_inv_1_0_q_1*tmp_moved_constant_84 + jac_blending_inv_2_0_q_1*tmp_moved_constant_86) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_90 + tmp_kernel_op_157*tmp_moved_constant_91 + tmp_kernel_op_158*tmp_moved_constant_92) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_82 + jac_blending_inv_1_1_q_1*tmp_moved_constant_84 + jac_blending_inv_2_1_q_1*tmp_moved_constant_86) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_90 + tmp_kernel_op_163*tmp_moved_constant_91 + tmp_kernel_op_164*tmp_moved_constant_92) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_82 + jac_blending_inv_1_2_q_1*tmp_moved_constant_84 + jac_blending_inv_2_2_q_1*tmp_moved_constant_86) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_90 + tmp_kernel_op_169*tmp_moved_constant_91 + tmp_kernel_op_170*tmp_moved_constant_92);
             const real_t tmp_kernel_op_531 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_83 + jac_blending_inv_1_0_q_2*tmp_moved_constant_81 + jac_blending_inv_2_0_q_2*tmp_moved_constant_82) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_93 + tmp_kernel_op_205*tmp_moved_constant_94 + tmp_kernel_op_207*tmp_moved_constant_95) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_83 + jac_blending_inv_1_1_q_2*tmp_moved_constant_81 + jac_blending_inv_2_1_q_2*tmp_moved_constant_82) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_93 + tmp_kernel_op_212*tmp_moved_constant_94 + tmp_kernel_op_213*tmp_moved_constant_95) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_83 + jac_blending_inv_1_2_q_2*tmp_moved_constant_81 + jac_blending_inv_2_2_q_2*tmp_moved_constant_82) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_93 + tmp_kernel_op_218*tmp_moved_constant_94 + tmp_kernel_op_219*tmp_moved_constant_95) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_81 + jac_blending_inv_1_0_q_2*tmp_moved_constant_85 + jac_blending_inv_2_0_q_2*tmp_moved_constant_84) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_93 + tmp_kernel_op_224*tmp_moved_constant_94 + tmp_kernel_op_225*tmp_moved_constant_95) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_81 + jac_blending_inv_1_1_q_2*tmp_moved_constant_85 + jac_blending_inv_2_1_q_2*tmp_moved_constant_84) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_93 + tmp_kernel_op_230*tmp_moved_constant_94 + tmp_kernel_op_231*tmp_moved_constant_95) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_81 + jac_blending_inv_1_2_q_2*tmp_moved_constant_85 + jac_blending_inv_2_2_q_2*tmp_moved_constant_84) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_93 + tmp_kernel_op_236*tmp_moved_constant_94 + tmp_kernel_op_237*tmp_moved_constant_95) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_82 + jac_blending_inv_1_0_q_2*tmp_moved_constant_84 + jac_blending_inv_2_0_q_2*tmp_moved_constant_86) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_93 + tmp_kernel_op_242*tmp_moved_constant_94 + tmp_kernel_op_243*tmp_moved_constant_95) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_82 + jac_blending_inv_1_1_q_2*tmp_moved_constant_84 + jac_blending_inv_2_1_q_2*tmp_moved_constant_86) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_93 + tmp_kernel_op_248*tmp_moved_constant_94 + tmp_kernel_op_249*tmp_moved_constant_95) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_82 + jac_blending_inv_1_2_q_2*tmp_moved_constant_84 + jac_blending_inv_2_2_q_2*tmp_moved_constant_86) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_93 + tmp_kernel_op_254*tmp_moved_constant_94 + tmp_kernel_op_255*tmp_moved_constant_95);
             const real_t tmp_kernel_op_536 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_83 + jac_blending_inv_1_0_q_3*tmp_moved_constant_81 + jac_blending_inv_2_0_q_3*tmp_moved_constant_82) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_96 + tmp_kernel_op_290*tmp_moved_constant_97 + tmp_kernel_op_292*tmp_moved_constant_98) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_83 + jac_blending_inv_1_1_q_3*tmp_moved_constant_81 + jac_blending_inv_2_1_q_3*tmp_moved_constant_82) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_96 + tmp_kernel_op_297*tmp_moved_constant_97 + tmp_kernel_op_298*tmp_moved_constant_98) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_83 + jac_blending_inv_1_2_q_3*tmp_moved_constant_81 + jac_blending_inv_2_2_q_3*tmp_moved_constant_82) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_96 + tmp_kernel_op_303*tmp_moved_constant_97 + tmp_kernel_op_304*tmp_moved_constant_98) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_81 + jac_blending_inv_1_0_q_3*tmp_moved_constant_85 + jac_blending_inv_2_0_q_3*tmp_moved_constant_84) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_96 + tmp_kernel_op_309*tmp_moved_constant_97 + tmp_kernel_op_310*tmp_moved_constant_98) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_81 + jac_blending_inv_1_1_q_3*tmp_moved_constant_85 + jac_blending_inv_2_1_q_3*tmp_moved_constant_84) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_96 + tmp_kernel_op_315*tmp_moved_constant_97 + tmp_kernel_op_316*tmp_moved_constant_98) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_81 + jac_blending_inv_1_2_q_3*tmp_moved_constant_85 + jac_blending_inv_2_2_q_3*tmp_moved_constant_84) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_96 + tmp_kernel_op_321*tmp_moved_constant_97 + tmp_kernel_op_322*tmp_moved_constant_98) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_82 + jac_blending_inv_1_0_q_3*tmp_moved_constant_84 + jac_blending_inv_2_0_q_3*tmp_moved_constant_86) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_96 + tmp_kernel_op_327*tmp_moved_constant_97 + tmp_kernel_op_328*tmp_moved_constant_98) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_82 + jac_blending_inv_1_1_q_3*tmp_moved_constant_84 + jac_blending_inv_2_1_q_3*tmp_moved_constant_86) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_96 + tmp_kernel_op_333*tmp_moved_constant_97 + tmp_kernel_op_334*tmp_moved_constant_98) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_82 + jac_blending_inv_1_2_q_3*tmp_moved_constant_84 + jac_blending_inv_2_2_q_3*tmp_moved_constant_86) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_96 + tmp_kernel_op_339*tmp_moved_constant_97 + tmp_kernel_op_340*tmp_moved_constant_98);
             const real_t tmp_kernel_op_541 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_83 + jac_blending_inv_1_0_q_4*tmp_moved_constant_81 + jac_blending_inv_2_0_q_4*tmp_moved_constant_82) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_99 + tmp_kernel_op_375*tmp_moved_constant_100 + tmp_kernel_op_377*tmp_moved_constant_101) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_83 + jac_blending_inv_1_1_q_4*tmp_moved_constant_81 + jac_blending_inv_2_1_q_4*tmp_moved_constant_82) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_99 + tmp_kernel_op_382*tmp_moved_constant_100 + tmp_kernel_op_383*tmp_moved_constant_101) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_83 + jac_blending_inv_1_2_q_4*tmp_moved_constant_81 + jac_blending_inv_2_2_q_4*tmp_moved_constant_82) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_99 + tmp_kernel_op_388*tmp_moved_constant_100 + tmp_kernel_op_389*tmp_moved_constant_101) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_81 + jac_blending_inv_1_0_q_4*tmp_moved_constant_85 + jac_blending_inv_2_0_q_4*tmp_moved_constant_84) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_99 + tmp_kernel_op_394*tmp_moved_constant_100 + tmp_kernel_op_395*tmp_moved_constant_101) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_81 + jac_blending_inv_1_1_q_4*tmp_moved_constant_85 + jac_blending_inv_2_1_q_4*tmp_moved_constant_84) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_99 + tmp_kernel_op_400*tmp_moved_constant_100 + tmp_kernel_op_401*tmp_moved_constant_101) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_81 + jac_blending_inv_1_2_q_4*tmp_moved_constant_85 + jac_blending_inv_2_2_q_4*tmp_moved_constant_84) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_99 + tmp_kernel_op_406*tmp_moved_constant_100 + tmp_kernel_op_407*tmp_moved_constant_101) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_82 + jac_blending_inv_1_0_q_4*tmp_moved_constant_84 + jac_blending_inv_2_0_q_4*tmp_moved_constant_86) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_99 + tmp_kernel_op_412*tmp_moved_constant_100 + tmp_kernel_op_413*tmp_moved_constant_101) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_82 + jac_blending_inv_1_1_q_4*tmp_moved_constant_84 + jac_blending_inv_2_1_q_4*tmp_moved_constant_86) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_99 + tmp_kernel_op_418*tmp_moved_constant_100 + tmp_kernel_op_419*tmp_moved_constant_101) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_82 + jac_blending_inv_1_2_q_4*tmp_moved_constant_84 + jac_blending_inv_2_2_q_4*tmp_moved_constant_86) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_99 + tmp_kernel_op_424*tmp_moved_constant_100 + tmp_kernel_op_425*tmp_moved_constant_101);
             const real_t tmp_kernel_op_566 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_103 + jac_blending_inv_1_0_q_0*tmp_moved_constant_106 + jac_blending_inv_2_0_q_0*tmp_moved_constant_109) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_119 + tmp_kernel_op_35*tmp_moved_constant_122 + tmp_kernel_op_37*tmp_moved_constant_125) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_103 + jac_blending_inv_1_1_q_0*tmp_moved_constant_106 + jac_blending_inv_2_1_q_0*tmp_moved_constant_109) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_119 + tmp_kernel_op_42*tmp_moved_constant_122 + tmp_kernel_op_43*tmp_moved_constant_125) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_103 + jac_blending_inv_1_2_q_0*tmp_moved_constant_106 + jac_blending_inv_2_2_q_0*tmp_moved_constant_109) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_119 + tmp_kernel_op_48*tmp_moved_constant_122 + tmp_kernel_op_49*tmp_moved_constant_125) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_106 + jac_blending_inv_1_0_q_0*tmp_moved_constant_111 + jac_blending_inv_2_0_q_0*tmp_moved_constant_114) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_119 + tmp_kernel_op_54*tmp_moved_constant_122 + tmp_kernel_op_55*tmp_moved_constant_125) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_106 + jac_blending_inv_1_1_q_0*tmp_moved_constant_111 + jac_blending_inv_2_1_q_0*tmp_moved_constant_114) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_119 + tmp_kernel_op_60*tmp_moved_constant_122 + tmp_kernel_op_61*tmp_moved_constant_125) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_106 + jac_blending_inv_1_2_q_0*tmp_moved_constant_111 + jac_blending_inv_2_2_q_0*tmp_moved_constant_114) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_119 + tmp_kernel_op_66*tmp_moved_constant_122 + tmp_kernel_op_67*tmp_moved_constant_125) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_109 + jac_blending_inv_1_0_q_0*tmp_moved_constant_114 + jac_blending_inv_2_0_q_0*tmp_moved_constant_116) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_119 + tmp_kernel_op_72*tmp_moved_constant_122 + tmp_kernel_op_73*tmp_moved_constant_125) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_109 + jac_blending_inv_1_1_q_0*tmp_moved_constant_114 + jac_blending_inv_2_1_q_0*tmp_moved_constant_116) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_119 + tmp_kernel_op_78*tmp_moved_constant_122 + tmp_kernel_op_79*tmp_moved_constant_125) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_109 + jac_blending_inv_1_2_q_0*tmp_moved_constant_114 + jac_blending_inv_2_2_q_0*tmp_moved_constant_116) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_119 + tmp_kernel_op_84*tmp_moved_constant_122 + tmp_kernel_op_85*tmp_moved_constant_125);
             const real_t tmp_kernel_op_576 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_103 + jac_blending_inv_1_0_q_1*tmp_moved_constant_106 + jac_blending_inv_2_0_q_1*tmp_moved_constant_109) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_128 + tmp_kernel_op_120*tmp_moved_constant_131 + tmp_kernel_op_122*tmp_moved_constant_134) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_103 + jac_blending_inv_1_1_q_1*tmp_moved_constant_106 + jac_blending_inv_2_1_q_1*tmp_moved_constant_109) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_128 + tmp_kernel_op_127*tmp_moved_constant_131 + tmp_kernel_op_128*tmp_moved_constant_134) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_103 + jac_blending_inv_1_2_q_1*tmp_moved_constant_106 + jac_blending_inv_2_2_q_1*tmp_moved_constant_109) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_128 + tmp_kernel_op_133*tmp_moved_constant_131 + tmp_kernel_op_134*tmp_moved_constant_134) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_106 + jac_blending_inv_1_0_q_1*tmp_moved_constant_111 + jac_blending_inv_2_0_q_1*tmp_moved_constant_114) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_128 + tmp_kernel_op_139*tmp_moved_constant_131 + tmp_kernel_op_140*tmp_moved_constant_134) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_106 + jac_blending_inv_1_1_q_1*tmp_moved_constant_111 + jac_blending_inv_2_1_q_1*tmp_moved_constant_114) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_128 + tmp_kernel_op_145*tmp_moved_constant_131 + tmp_kernel_op_146*tmp_moved_constant_134) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_106 + jac_blending_inv_1_2_q_1*tmp_moved_constant_111 + jac_blending_inv_2_2_q_1*tmp_moved_constant_114) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_128 + tmp_kernel_op_151*tmp_moved_constant_131 + tmp_kernel_op_152*tmp_moved_constant_134) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_109 + jac_blending_inv_1_0_q_1*tmp_moved_constant_114 + jac_blending_inv_2_0_q_1*tmp_moved_constant_116) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_128 + tmp_kernel_op_157*tmp_moved_constant_131 + tmp_kernel_op_158*tmp_moved_constant_134) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_109 + jac_blending_inv_1_1_q_1*tmp_moved_constant_114 + jac_blending_inv_2_1_q_1*tmp_moved_constant_116) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_128 + tmp_kernel_op_163*tmp_moved_constant_131 + tmp_kernel_op_164*tmp_moved_constant_134) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_109 + jac_blending_inv_1_2_q_1*tmp_moved_constant_114 + jac_blending_inv_2_2_q_1*tmp_moved_constant_116) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_128 + tmp_kernel_op_169*tmp_moved_constant_131 + tmp_kernel_op_170*tmp_moved_constant_134);
             const real_t tmp_kernel_op_586 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_103 + jac_blending_inv_1_0_q_2*tmp_moved_constant_106 + jac_blending_inv_2_0_q_2*tmp_moved_constant_109) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_137 + tmp_kernel_op_205*tmp_moved_constant_140 + tmp_kernel_op_207*tmp_moved_constant_143) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_103 + jac_blending_inv_1_1_q_2*tmp_moved_constant_106 + jac_blending_inv_2_1_q_2*tmp_moved_constant_109) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_137 + tmp_kernel_op_212*tmp_moved_constant_140 + tmp_kernel_op_213*tmp_moved_constant_143) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_103 + jac_blending_inv_1_2_q_2*tmp_moved_constant_106 + jac_blending_inv_2_2_q_2*tmp_moved_constant_109) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_137 + tmp_kernel_op_218*tmp_moved_constant_140 + tmp_kernel_op_219*tmp_moved_constant_143) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_106 + jac_blending_inv_1_0_q_2*tmp_moved_constant_111 + jac_blending_inv_2_0_q_2*tmp_moved_constant_114) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_137 + tmp_kernel_op_224*tmp_moved_constant_140 + tmp_kernel_op_225*tmp_moved_constant_143) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_106 + jac_blending_inv_1_1_q_2*tmp_moved_constant_111 + jac_blending_inv_2_1_q_2*tmp_moved_constant_114) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_137 + tmp_kernel_op_230*tmp_moved_constant_140 + tmp_kernel_op_231*tmp_moved_constant_143) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_106 + jac_blending_inv_1_2_q_2*tmp_moved_constant_111 + jac_blending_inv_2_2_q_2*tmp_moved_constant_114) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_137 + tmp_kernel_op_236*tmp_moved_constant_140 + tmp_kernel_op_237*tmp_moved_constant_143) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_109 + jac_blending_inv_1_0_q_2*tmp_moved_constant_114 + jac_blending_inv_2_0_q_2*tmp_moved_constant_116) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_137 + tmp_kernel_op_242*tmp_moved_constant_140 + tmp_kernel_op_243*tmp_moved_constant_143) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_109 + jac_blending_inv_1_1_q_2*tmp_moved_constant_114 + jac_blending_inv_2_1_q_2*tmp_moved_constant_116) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_137 + tmp_kernel_op_248*tmp_moved_constant_140 + tmp_kernel_op_249*tmp_moved_constant_143) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_109 + jac_blending_inv_1_2_q_2*tmp_moved_constant_114 + jac_blending_inv_2_2_q_2*tmp_moved_constant_116) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_137 + tmp_kernel_op_254*tmp_moved_constant_140 + tmp_kernel_op_255*tmp_moved_constant_143);
             const real_t tmp_kernel_op_596 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_103 + jac_blending_inv_1_0_q_3*tmp_moved_constant_106 + jac_blending_inv_2_0_q_3*tmp_moved_constant_109) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_146 + tmp_kernel_op_290*tmp_moved_constant_149 + tmp_kernel_op_292*tmp_moved_constant_152) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_103 + jac_blending_inv_1_1_q_3*tmp_moved_constant_106 + jac_blending_inv_2_1_q_3*tmp_moved_constant_109) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_146 + tmp_kernel_op_297*tmp_moved_constant_149 + tmp_kernel_op_298*tmp_moved_constant_152) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_103 + jac_blending_inv_1_2_q_3*tmp_moved_constant_106 + jac_blending_inv_2_2_q_3*tmp_moved_constant_109) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_146 + tmp_kernel_op_303*tmp_moved_constant_149 + tmp_kernel_op_304*tmp_moved_constant_152) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_106 + jac_blending_inv_1_0_q_3*tmp_moved_constant_111 + jac_blending_inv_2_0_q_3*tmp_moved_constant_114) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_146 + tmp_kernel_op_309*tmp_moved_constant_149 + tmp_kernel_op_310*tmp_moved_constant_152) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_106 + jac_blending_inv_1_1_q_3*tmp_moved_constant_111 + jac_blending_inv_2_1_q_3*tmp_moved_constant_114) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_146 + tmp_kernel_op_315*tmp_moved_constant_149 + tmp_kernel_op_316*tmp_moved_constant_152) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_106 + jac_blending_inv_1_2_q_3*tmp_moved_constant_111 + jac_blending_inv_2_2_q_3*tmp_moved_constant_114) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_146 + tmp_kernel_op_321*tmp_moved_constant_149 + tmp_kernel_op_322*tmp_moved_constant_152) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_109 + jac_blending_inv_1_0_q_3*tmp_moved_constant_114 + jac_blending_inv_2_0_q_3*tmp_moved_constant_116) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_146 + tmp_kernel_op_327*tmp_moved_constant_149 + tmp_kernel_op_328*tmp_moved_constant_152) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_109 + jac_blending_inv_1_1_q_3*tmp_moved_constant_114 + jac_blending_inv_2_1_q_3*tmp_moved_constant_116) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_146 + tmp_kernel_op_333*tmp_moved_constant_149 + tmp_kernel_op_334*tmp_moved_constant_152) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_109 + jac_blending_inv_1_2_q_3*tmp_moved_constant_114 + jac_blending_inv_2_2_q_3*tmp_moved_constant_116) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_146 + tmp_kernel_op_339*tmp_moved_constant_149 + tmp_kernel_op_340*tmp_moved_constant_152);
             const real_t tmp_kernel_op_606 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_103 + jac_blending_inv_1_0_q_4*tmp_moved_constant_106 + jac_blending_inv_2_0_q_4*tmp_moved_constant_109) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_155 + tmp_kernel_op_375*tmp_moved_constant_158 + tmp_kernel_op_377*tmp_moved_constant_161) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_103 + jac_blending_inv_1_1_q_4*tmp_moved_constant_106 + jac_blending_inv_2_1_q_4*tmp_moved_constant_109) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_155 + tmp_kernel_op_382*tmp_moved_constant_158 + tmp_kernel_op_383*tmp_moved_constant_161) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_103 + jac_blending_inv_1_2_q_4*tmp_moved_constant_106 + jac_blending_inv_2_2_q_4*tmp_moved_constant_109) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_155 + tmp_kernel_op_388*tmp_moved_constant_158 + tmp_kernel_op_389*tmp_moved_constant_161) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_106 + jac_blending_inv_1_0_q_4*tmp_moved_constant_111 + jac_blending_inv_2_0_q_4*tmp_moved_constant_114) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_155 + tmp_kernel_op_394*tmp_moved_constant_158 + tmp_kernel_op_395*tmp_moved_constant_161) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_106 + jac_blending_inv_1_1_q_4*tmp_moved_constant_111 + jac_blending_inv_2_1_q_4*tmp_moved_constant_114) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_155 + tmp_kernel_op_400*tmp_moved_constant_158 + tmp_kernel_op_401*tmp_moved_constant_161) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_106 + jac_blending_inv_1_2_q_4*tmp_moved_constant_111 + jac_blending_inv_2_2_q_4*tmp_moved_constant_114) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_155 + tmp_kernel_op_406*tmp_moved_constant_158 + tmp_kernel_op_407*tmp_moved_constant_161) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_109 + jac_blending_inv_1_0_q_4*tmp_moved_constant_114 + jac_blending_inv_2_0_q_4*tmp_moved_constant_116) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_155 + tmp_kernel_op_412*tmp_moved_constant_158 + tmp_kernel_op_413*tmp_moved_constant_161) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_109 + jac_blending_inv_1_1_q_4*tmp_moved_constant_114 + jac_blending_inv_2_1_q_4*tmp_moved_constant_116) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_155 + tmp_kernel_op_418*tmp_moved_constant_158 + tmp_kernel_op_419*tmp_moved_constant_161) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_109 + jac_blending_inv_1_2_q_4*tmp_moved_constant_114 + jac_blending_inv_2_2_q_4*tmp_moved_constant_116) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_155 + tmp_kernel_op_424*tmp_moved_constant_158 + tmp_kernel_op_425*tmp_moved_constant_161);
             const real_t tmp_kernel_op_628 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_162 + jac_blending_inv_1_0_q_0*tmp_moved_constant_165 + jac_blending_inv_2_0_q_0*tmp_moved_constant_168) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_176 + tmp_kernel_op_35*tmp_moved_constant_179 + tmp_kernel_op_37*tmp_moved_constant_182) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_162 + jac_blending_inv_1_1_q_0*tmp_moved_constant_165 + jac_blending_inv_2_1_q_0*tmp_moved_constant_168) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_176 + tmp_kernel_op_42*tmp_moved_constant_179 + tmp_kernel_op_43*tmp_moved_constant_182) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_162 + jac_blending_inv_1_2_q_0*tmp_moved_constant_165 + jac_blending_inv_2_2_q_0*tmp_moved_constant_168) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_176 + tmp_kernel_op_48*tmp_moved_constant_179 + tmp_kernel_op_49*tmp_moved_constant_182) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_165 + jac_blending_inv_1_0_q_0*tmp_moved_constant_169 + jac_blending_inv_2_0_q_0*tmp_moved_constant_172) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_176 + tmp_kernel_op_54*tmp_moved_constant_179 + tmp_kernel_op_55*tmp_moved_constant_182) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_165 + jac_blending_inv_1_1_q_0*tmp_moved_constant_169 + jac_blending_inv_2_1_q_0*tmp_moved_constant_172) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_176 + tmp_kernel_op_60*tmp_moved_constant_179 + tmp_kernel_op_61*tmp_moved_constant_182) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_165 + jac_blending_inv_1_2_q_0*tmp_moved_constant_169 + jac_blending_inv_2_2_q_0*tmp_moved_constant_172) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_176 + tmp_kernel_op_66*tmp_moved_constant_179 + tmp_kernel_op_67*tmp_moved_constant_182) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_168 + jac_blending_inv_1_0_q_0*tmp_moved_constant_172 + jac_blending_inv_2_0_q_0*tmp_moved_constant_173) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_176 + tmp_kernel_op_72*tmp_moved_constant_179 + tmp_kernel_op_73*tmp_moved_constant_182) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_168 + jac_blending_inv_1_1_q_0*tmp_moved_constant_172 + jac_blending_inv_2_1_q_0*tmp_moved_constant_173) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_176 + tmp_kernel_op_78*tmp_moved_constant_179 + tmp_kernel_op_79*tmp_moved_constant_182) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_168 + jac_blending_inv_1_2_q_0*tmp_moved_constant_172 + jac_blending_inv_2_2_q_0*tmp_moved_constant_173) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_176 + tmp_kernel_op_84*tmp_moved_constant_179 + tmp_kernel_op_85*tmp_moved_constant_182);
             const real_t tmp_kernel_op_638 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_162 + jac_blending_inv_1_0_q_1*tmp_moved_constant_165 + jac_blending_inv_2_0_q_1*tmp_moved_constant_168) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_185 + tmp_kernel_op_120*tmp_moved_constant_188 + tmp_kernel_op_122*tmp_moved_constant_191) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_162 + jac_blending_inv_1_1_q_1*tmp_moved_constant_165 + jac_blending_inv_2_1_q_1*tmp_moved_constant_168) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_185 + tmp_kernel_op_127*tmp_moved_constant_188 + tmp_kernel_op_128*tmp_moved_constant_191) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_162 + jac_blending_inv_1_2_q_1*tmp_moved_constant_165 + jac_blending_inv_2_2_q_1*tmp_moved_constant_168) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_185 + tmp_kernel_op_133*tmp_moved_constant_188 + tmp_kernel_op_134*tmp_moved_constant_191) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_165 + jac_blending_inv_1_0_q_1*tmp_moved_constant_169 + jac_blending_inv_2_0_q_1*tmp_moved_constant_172) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_185 + tmp_kernel_op_139*tmp_moved_constant_188 + tmp_kernel_op_140*tmp_moved_constant_191) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_165 + jac_blending_inv_1_1_q_1*tmp_moved_constant_169 + jac_blending_inv_2_1_q_1*tmp_moved_constant_172) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_185 + tmp_kernel_op_145*tmp_moved_constant_188 + tmp_kernel_op_146*tmp_moved_constant_191) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_165 + jac_blending_inv_1_2_q_1*tmp_moved_constant_169 + jac_blending_inv_2_2_q_1*tmp_moved_constant_172) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_185 + tmp_kernel_op_151*tmp_moved_constant_188 + tmp_kernel_op_152*tmp_moved_constant_191) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_168 + jac_blending_inv_1_0_q_1*tmp_moved_constant_172 + jac_blending_inv_2_0_q_1*tmp_moved_constant_173) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_185 + tmp_kernel_op_157*tmp_moved_constant_188 + tmp_kernel_op_158*tmp_moved_constant_191) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_168 + jac_blending_inv_1_1_q_1*tmp_moved_constant_172 + jac_blending_inv_2_1_q_1*tmp_moved_constant_173) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_185 + tmp_kernel_op_163*tmp_moved_constant_188 + tmp_kernel_op_164*tmp_moved_constant_191) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_168 + jac_blending_inv_1_2_q_1*tmp_moved_constant_172 + jac_blending_inv_2_2_q_1*tmp_moved_constant_173) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_185 + tmp_kernel_op_169*tmp_moved_constant_188 + tmp_kernel_op_170*tmp_moved_constant_191);
             const real_t tmp_kernel_op_648 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_162 + jac_blending_inv_1_0_q_2*tmp_moved_constant_165 + jac_blending_inv_2_0_q_2*tmp_moved_constant_168) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_194 + tmp_kernel_op_205*tmp_moved_constant_197 + tmp_kernel_op_207*tmp_moved_constant_200) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_162 + jac_blending_inv_1_1_q_2*tmp_moved_constant_165 + jac_blending_inv_2_1_q_2*tmp_moved_constant_168) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_194 + tmp_kernel_op_212*tmp_moved_constant_197 + tmp_kernel_op_213*tmp_moved_constant_200) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_162 + jac_blending_inv_1_2_q_2*tmp_moved_constant_165 + jac_blending_inv_2_2_q_2*tmp_moved_constant_168) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_194 + tmp_kernel_op_218*tmp_moved_constant_197 + tmp_kernel_op_219*tmp_moved_constant_200) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_165 + jac_blending_inv_1_0_q_2*tmp_moved_constant_169 + jac_blending_inv_2_0_q_2*tmp_moved_constant_172) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_194 + tmp_kernel_op_224*tmp_moved_constant_197 + tmp_kernel_op_225*tmp_moved_constant_200) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_165 + jac_blending_inv_1_1_q_2*tmp_moved_constant_169 + jac_blending_inv_2_1_q_2*tmp_moved_constant_172) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_194 + tmp_kernel_op_230*tmp_moved_constant_197 + tmp_kernel_op_231*tmp_moved_constant_200) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_165 + jac_blending_inv_1_2_q_2*tmp_moved_constant_169 + jac_blending_inv_2_2_q_2*tmp_moved_constant_172) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_194 + tmp_kernel_op_236*tmp_moved_constant_197 + tmp_kernel_op_237*tmp_moved_constant_200) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_168 + jac_blending_inv_1_0_q_2*tmp_moved_constant_172 + jac_blending_inv_2_0_q_2*tmp_moved_constant_173) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_194 + tmp_kernel_op_242*tmp_moved_constant_197 + tmp_kernel_op_243*tmp_moved_constant_200) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_168 + jac_blending_inv_1_1_q_2*tmp_moved_constant_172 + jac_blending_inv_2_1_q_2*tmp_moved_constant_173) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_194 + tmp_kernel_op_248*tmp_moved_constant_197 + tmp_kernel_op_249*tmp_moved_constant_200) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_168 + jac_blending_inv_1_2_q_2*tmp_moved_constant_172 + jac_blending_inv_2_2_q_2*tmp_moved_constant_173) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_194 + tmp_kernel_op_254*tmp_moved_constant_197 + tmp_kernel_op_255*tmp_moved_constant_200);
             const real_t tmp_kernel_op_658 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_162 + jac_blending_inv_1_0_q_3*tmp_moved_constant_165 + jac_blending_inv_2_0_q_3*tmp_moved_constant_168) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_203 + tmp_kernel_op_290*tmp_moved_constant_206 + tmp_kernel_op_292*tmp_moved_constant_209) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_162 + jac_blending_inv_1_1_q_3*tmp_moved_constant_165 + jac_blending_inv_2_1_q_3*tmp_moved_constant_168) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_203 + tmp_kernel_op_297*tmp_moved_constant_206 + tmp_kernel_op_298*tmp_moved_constant_209) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_162 + jac_blending_inv_1_2_q_3*tmp_moved_constant_165 + jac_blending_inv_2_2_q_3*tmp_moved_constant_168) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_203 + tmp_kernel_op_303*tmp_moved_constant_206 + tmp_kernel_op_304*tmp_moved_constant_209) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_165 + jac_blending_inv_1_0_q_3*tmp_moved_constant_169 + jac_blending_inv_2_0_q_3*tmp_moved_constant_172) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_203 + tmp_kernel_op_309*tmp_moved_constant_206 + tmp_kernel_op_310*tmp_moved_constant_209) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_165 + jac_blending_inv_1_1_q_3*tmp_moved_constant_169 + jac_blending_inv_2_1_q_3*tmp_moved_constant_172) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_203 + tmp_kernel_op_315*tmp_moved_constant_206 + tmp_kernel_op_316*tmp_moved_constant_209) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_165 + jac_blending_inv_1_2_q_3*tmp_moved_constant_169 + jac_blending_inv_2_2_q_3*tmp_moved_constant_172) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_203 + tmp_kernel_op_321*tmp_moved_constant_206 + tmp_kernel_op_322*tmp_moved_constant_209) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_168 + jac_blending_inv_1_0_q_3*tmp_moved_constant_172 + jac_blending_inv_2_0_q_3*tmp_moved_constant_173) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_203 + tmp_kernel_op_327*tmp_moved_constant_206 + tmp_kernel_op_328*tmp_moved_constant_209) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_168 + jac_blending_inv_1_1_q_3*tmp_moved_constant_172 + jac_blending_inv_2_1_q_3*tmp_moved_constant_173) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_203 + tmp_kernel_op_333*tmp_moved_constant_206 + tmp_kernel_op_334*tmp_moved_constant_209) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_168 + jac_blending_inv_1_2_q_3*tmp_moved_constant_172 + jac_blending_inv_2_2_q_3*tmp_moved_constant_173) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_203 + tmp_kernel_op_339*tmp_moved_constant_206 + tmp_kernel_op_340*tmp_moved_constant_209);
             const real_t tmp_kernel_op_668 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_162 + jac_blending_inv_1_0_q_4*tmp_moved_constant_165 + jac_blending_inv_2_0_q_4*tmp_moved_constant_168) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_212 + tmp_kernel_op_375*tmp_moved_constant_215 + tmp_kernel_op_377*tmp_moved_constant_218) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_162 + jac_blending_inv_1_1_q_4*tmp_moved_constant_165 + jac_blending_inv_2_1_q_4*tmp_moved_constant_168) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_212 + tmp_kernel_op_382*tmp_moved_constant_215 + tmp_kernel_op_383*tmp_moved_constant_218) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_162 + jac_blending_inv_1_2_q_4*tmp_moved_constant_165 + jac_blending_inv_2_2_q_4*tmp_moved_constant_168) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_212 + tmp_kernel_op_388*tmp_moved_constant_215 + tmp_kernel_op_389*tmp_moved_constant_218) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_165 + jac_blending_inv_1_0_q_4*tmp_moved_constant_169 + jac_blending_inv_2_0_q_4*tmp_moved_constant_172) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_212 + tmp_kernel_op_394*tmp_moved_constant_215 + tmp_kernel_op_395*tmp_moved_constant_218) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_165 + jac_blending_inv_1_1_q_4*tmp_moved_constant_169 + jac_blending_inv_2_1_q_4*tmp_moved_constant_172) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_212 + tmp_kernel_op_400*tmp_moved_constant_215 + tmp_kernel_op_401*tmp_moved_constant_218) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_165 + jac_blending_inv_1_2_q_4*tmp_moved_constant_169 + jac_blending_inv_2_2_q_4*tmp_moved_constant_172) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_212 + tmp_kernel_op_406*tmp_moved_constant_215 + tmp_kernel_op_407*tmp_moved_constant_218) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_168 + jac_blending_inv_1_0_q_4*tmp_moved_constant_172 + jac_blending_inv_2_0_q_4*tmp_moved_constant_173) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_212 + tmp_kernel_op_412*tmp_moved_constant_215 + tmp_kernel_op_413*tmp_moved_constant_218) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_168 + jac_blending_inv_1_1_q_4*tmp_moved_constant_172 + jac_blending_inv_2_1_q_4*tmp_moved_constant_173) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_212 + tmp_kernel_op_418*tmp_moved_constant_215 + tmp_kernel_op_419*tmp_moved_constant_218) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_168 + jac_blending_inv_1_2_q_4*tmp_moved_constant_172 + jac_blending_inv_2_2_q_4*tmp_moved_constant_173) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_212 + tmp_kernel_op_424*tmp_moved_constant_215 + tmp_kernel_op_425*tmp_moved_constant_218);
             const real_t tmp_kernel_op_693 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_220 + jac_blending_inv_1_0_q_0*tmp_moved_constant_223 + jac_blending_inv_2_0_q_0*tmp_moved_constant_226) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_236 + tmp_kernel_op_35*tmp_moved_constant_239 + tmp_kernel_op_37*tmp_moved_constant_242) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_220 + jac_blending_inv_1_1_q_0*tmp_moved_constant_223 + jac_blending_inv_2_1_q_0*tmp_moved_constant_226) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_236 + tmp_kernel_op_42*tmp_moved_constant_239 + tmp_kernel_op_43*tmp_moved_constant_242) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_220 + jac_blending_inv_1_2_q_0*tmp_moved_constant_223 + jac_blending_inv_2_2_q_0*tmp_moved_constant_226) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_236 + tmp_kernel_op_48*tmp_moved_constant_239 + tmp_kernel_op_49*tmp_moved_constant_242) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_223 + jac_blending_inv_1_0_q_0*tmp_moved_constant_228 + jac_blending_inv_2_0_q_0*tmp_moved_constant_231) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_236 + tmp_kernel_op_54*tmp_moved_constant_239 + tmp_kernel_op_55*tmp_moved_constant_242) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_223 + jac_blending_inv_1_1_q_0*tmp_moved_constant_228 + jac_blending_inv_2_1_q_0*tmp_moved_constant_231) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_236 + tmp_kernel_op_60*tmp_moved_constant_239 + tmp_kernel_op_61*tmp_moved_constant_242) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_223 + jac_blending_inv_1_2_q_0*tmp_moved_constant_228 + jac_blending_inv_2_2_q_0*tmp_moved_constant_231) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_236 + tmp_kernel_op_66*tmp_moved_constant_239 + tmp_kernel_op_67*tmp_moved_constant_242) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_226 + jac_blending_inv_1_0_q_0*tmp_moved_constant_231 + jac_blending_inv_2_0_q_0*tmp_moved_constant_233) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_236 + tmp_kernel_op_72*tmp_moved_constant_239 + tmp_kernel_op_73*tmp_moved_constant_242) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_226 + jac_blending_inv_1_1_q_0*tmp_moved_constant_231 + jac_blending_inv_2_1_q_0*tmp_moved_constant_233) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_236 + tmp_kernel_op_78*tmp_moved_constant_239 + tmp_kernel_op_79*tmp_moved_constant_242) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_226 + jac_blending_inv_1_2_q_0*tmp_moved_constant_231 + jac_blending_inv_2_2_q_0*tmp_moved_constant_233) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_236 + tmp_kernel_op_84*tmp_moved_constant_239 + tmp_kernel_op_85*tmp_moved_constant_242);
             const real_t tmp_kernel_op_703 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_220 + jac_blending_inv_1_0_q_1*tmp_moved_constant_223 + jac_blending_inv_2_0_q_1*tmp_moved_constant_226) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_245 + tmp_kernel_op_120*tmp_moved_constant_248 + tmp_kernel_op_122*tmp_moved_constant_251) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_220 + jac_blending_inv_1_1_q_1*tmp_moved_constant_223 + jac_blending_inv_2_1_q_1*tmp_moved_constant_226) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_245 + tmp_kernel_op_127*tmp_moved_constant_248 + tmp_kernel_op_128*tmp_moved_constant_251) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_220 + jac_blending_inv_1_2_q_1*tmp_moved_constant_223 + jac_blending_inv_2_2_q_1*tmp_moved_constant_226) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_245 + tmp_kernel_op_133*tmp_moved_constant_248 + tmp_kernel_op_134*tmp_moved_constant_251) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_223 + jac_blending_inv_1_0_q_1*tmp_moved_constant_228 + jac_blending_inv_2_0_q_1*tmp_moved_constant_231) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_245 + tmp_kernel_op_139*tmp_moved_constant_248 + tmp_kernel_op_140*tmp_moved_constant_251) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_223 + jac_blending_inv_1_1_q_1*tmp_moved_constant_228 + jac_blending_inv_2_1_q_1*tmp_moved_constant_231) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_245 + tmp_kernel_op_145*tmp_moved_constant_248 + tmp_kernel_op_146*tmp_moved_constant_251) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_223 + jac_blending_inv_1_2_q_1*tmp_moved_constant_228 + jac_blending_inv_2_2_q_1*tmp_moved_constant_231) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_245 + tmp_kernel_op_151*tmp_moved_constant_248 + tmp_kernel_op_152*tmp_moved_constant_251) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_226 + jac_blending_inv_1_0_q_1*tmp_moved_constant_231 + jac_blending_inv_2_0_q_1*tmp_moved_constant_233) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_245 + tmp_kernel_op_157*tmp_moved_constant_248 + tmp_kernel_op_158*tmp_moved_constant_251) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_226 + jac_blending_inv_1_1_q_1*tmp_moved_constant_231 + jac_blending_inv_2_1_q_1*tmp_moved_constant_233) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_245 + tmp_kernel_op_163*tmp_moved_constant_248 + tmp_kernel_op_164*tmp_moved_constant_251) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_226 + jac_blending_inv_1_2_q_1*tmp_moved_constant_231 + jac_blending_inv_2_2_q_1*tmp_moved_constant_233) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_245 + tmp_kernel_op_169*tmp_moved_constant_248 + tmp_kernel_op_170*tmp_moved_constant_251);
             const real_t tmp_kernel_op_713 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_220 + jac_blending_inv_1_0_q_2*tmp_moved_constant_223 + jac_blending_inv_2_0_q_2*tmp_moved_constant_226) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_254 + tmp_kernel_op_205*tmp_moved_constant_257 + tmp_kernel_op_207*tmp_moved_constant_260) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_220 + jac_blending_inv_1_1_q_2*tmp_moved_constant_223 + jac_blending_inv_2_1_q_2*tmp_moved_constant_226) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_254 + tmp_kernel_op_212*tmp_moved_constant_257 + tmp_kernel_op_213*tmp_moved_constant_260) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_220 + jac_blending_inv_1_2_q_2*tmp_moved_constant_223 + jac_blending_inv_2_2_q_2*tmp_moved_constant_226) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_254 + tmp_kernel_op_218*tmp_moved_constant_257 + tmp_kernel_op_219*tmp_moved_constant_260) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_223 + jac_blending_inv_1_0_q_2*tmp_moved_constant_228 + jac_blending_inv_2_0_q_2*tmp_moved_constant_231) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_254 + tmp_kernel_op_224*tmp_moved_constant_257 + tmp_kernel_op_225*tmp_moved_constant_260) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_223 + jac_blending_inv_1_1_q_2*tmp_moved_constant_228 + jac_blending_inv_2_1_q_2*tmp_moved_constant_231) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_254 + tmp_kernel_op_230*tmp_moved_constant_257 + tmp_kernel_op_231*tmp_moved_constant_260) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_223 + jac_blending_inv_1_2_q_2*tmp_moved_constant_228 + jac_blending_inv_2_2_q_2*tmp_moved_constant_231) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_254 + tmp_kernel_op_236*tmp_moved_constant_257 + tmp_kernel_op_237*tmp_moved_constant_260) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_226 + jac_blending_inv_1_0_q_2*tmp_moved_constant_231 + jac_blending_inv_2_0_q_2*tmp_moved_constant_233) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_254 + tmp_kernel_op_242*tmp_moved_constant_257 + tmp_kernel_op_243*tmp_moved_constant_260) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_226 + jac_blending_inv_1_1_q_2*tmp_moved_constant_231 + jac_blending_inv_2_1_q_2*tmp_moved_constant_233) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_254 + tmp_kernel_op_248*tmp_moved_constant_257 + tmp_kernel_op_249*tmp_moved_constant_260) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_226 + jac_blending_inv_1_2_q_2*tmp_moved_constant_231 + jac_blending_inv_2_2_q_2*tmp_moved_constant_233) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_254 + tmp_kernel_op_254*tmp_moved_constant_257 + tmp_kernel_op_255*tmp_moved_constant_260);
             const real_t tmp_kernel_op_723 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_220 + jac_blending_inv_1_0_q_3*tmp_moved_constant_223 + jac_blending_inv_2_0_q_3*tmp_moved_constant_226) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_263 + tmp_kernel_op_290*tmp_moved_constant_266 + tmp_kernel_op_292*tmp_moved_constant_269) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_220 + jac_blending_inv_1_1_q_3*tmp_moved_constant_223 + jac_blending_inv_2_1_q_3*tmp_moved_constant_226) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_263 + tmp_kernel_op_297*tmp_moved_constant_266 + tmp_kernel_op_298*tmp_moved_constant_269) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_220 + jac_blending_inv_1_2_q_3*tmp_moved_constant_223 + jac_blending_inv_2_2_q_3*tmp_moved_constant_226) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_263 + tmp_kernel_op_303*tmp_moved_constant_266 + tmp_kernel_op_304*tmp_moved_constant_269) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_223 + jac_blending_inv_1_0_q_3*tmp_moved_constant_228 + jac_blending_inv_2_0_q_3*tmp_moved_constant_231) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_263 + tmp_kernel_op_309*tmp_moved_constant_266 + tmp_kernel_op_310*tmp_moved_constant_269) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_223 + jac_blending_inv_1_1_q_3*tmp_moved_constant_228 + jac_blending_inv_2_1_q_3*tmp_moved_constant_231) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_263 + tmp_kernel_op_315*tmp_moved_constant_266 + tmp_kernel_op_316*tmp_moved_constant_269) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_223 + jac_blending_inv_1_2_q_3*tmp_moved_constant_228 + jac_blending_inv_2_2_q_3*tmp_moved_constant_231) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_263 + tmp_kernel_op_321*tmp_moved_constant_266 + tmp_kernel_op_322*tmp_moved_constant_269) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_226 + jac_blending_inv_1_0_q_3*tmp_moved_constant_231 + jac_blending_inv_2_0_q_3*tmp_moved_constant_233) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_263 + tmp_kernel_op_327*tmp_moved_constant_266 + tmp_kernel_op_328*tmp_moved_constant_269) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_226 + jac_blending_inv_1_1_q_3*tmp_moved_constant_231 + jac_blending_inv_2_1_q_3*tmp_moved_constant_233) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_263 + tmp_kernel_op_333*tmp_moved_constant_266 + tmp_kernel_op_334*tmp_moved_constant_269) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_226 + jac_blending_inv_1_2_q_3*tmp_moved_constant_231 + jac_blending_inv_2_2_q_3*tmp_moved_constant_233) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_263 + tmp_kernel_op_339*tmp_moved_constant_266 + tmp_kernel_op_340*tmp_moved_constant_269);
             const real_t tmp_kernel_op_733 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_220 + jac_blending_inv_1_0_q_4*tmp_moved_constant_223 + jac_blending_inv_2_0_q_4*tmp_moved_constant_226) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_272 + tmp_kernel_op_375*tmp_moved_constant_275 + tmp_kernel_op_377*tmp_moved_constant_278) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_220 + jac_blending_inv_1_1_q_4*tmp_moved_constant_223 + jac_blending_inv_2_1_q_4*tmp_moved_constant_226) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_272 + tmp_kernel_op_382*tmp_moved_constant_275 + tmp_kernel_op_383*tmp_moved_constant_278) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_220 + jac_blending_inv_1_2_q_4*tmp_moved_constant_223 + jac_blending_inv_2_2_q_4*tmp_moved_constant_226) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_272 + tmp_kernel_op_388*tmp_moved_constant_275 + tmp_kernel_op_389*tmp_moved_constant_278) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_223 + jac_blending_inv_1_0_q_4*tmp_moved_constant_228 + jac_blending_inv_2_0_q_4*tmp_moved_constant_231) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_272 + tmp_kernel_op_394*tmp_moved_constant_275 + tmp_kernel_op_395*tmp_moved_constant_278) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_223 + jac_blending_inv_1_1_q_4*tmp_moved_constant_228 + jac_blending_inv_2_1_q_4*tmp_moved_constant_231) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_272 + tmp_kernel_op_400*tmp_moved_constant_275 + tmp_kernel_op_401*tmp_moved_constant_278) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_223 + jac_blending_inv_1_2_q_4*tmp_moved_constant_228 + jac_blending_inv_2_2_q_4*tmp_moved_constant_231) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_272 + tmp_kernel_op_406*tmp_moved_constant_275 + tmp_kernel_op_407*tmp_moved_constant_278) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_226 + jac_blending_inv_1_0_q_4*tmp_moved_constant_231 + jac_blending_inv_2_0_q_4*tmp_moved_constant_233) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_272 + tmp_kernel_op_412*tmp_moved_constant_275 + tmp_kernel_op_413*tmp_moved_constant_278) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_226 + jac_blending_inv_1_1_q_4*tmp_moved_constant_231 + jac_blending_inv_2_1_q_4*tmp_moved_constant_233) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_272 + tmp_kernel_op_418*tmp_moved_constant_275 + tmp_kernel_op_419*tmp_moved_constant_278) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_226 + jac_blending_inv_1_2_q_4*tmp_moved_constant_231 + jac_blending_inv_2_2_q_4*tmp_moved_constant_233) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_272 + tmp_kernel_op_424*tmp_moved_constant_275 + tmp_kernel_op_425*tmp_moved_constant_278);
             const real_t tmp_kernel_op_756 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_282 + jac_blending_inv_1_0_q_0*tmp_moved_constant_284 + jac_blending_inv_2_0_q_0*tmp_moved_constant_286) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_297 + tmp_kernel_op_35*tmp_moved_constant_298 + tmp_kernel_op_37*tmp_moved_constant_299) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_282 + jac_blending_inv_1_1_q_0*tmp_moved_constant_284 + jac_blending_inv_2_1_q_0*tmp_moved_constant_286) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_297 + tmp_kernel_op_42*tmp_moved_constant_298 + tmp_kernel_op_43*tmp_moved_constant_299) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_282 + jac_blending_inv_1_2_q_0*tmp_moved_constant_284 + jac_blending_inv_2_2_q_0*tmp_moved_constant_286) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_297 + tmp_kernel_op_48*tmp_moved_constant_298 + tmp_kernel_op_49*tmp_moved_constant_299) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_287 + jac_blending_inv_1_0_q_0*tmp_moved_constant_290 + jac_blending_inv_2_0_q_0*tmp_moved_constant_291) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_297 + tmp_kernel_op_54*tmp_moved_constant_298 + tmp_kernel_op_55*tmp_moved_constant_299) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_287 + jac_blending_inv_1_1_q_0*tmp_moved_constant_290 + jac_blending_inv_2_1_q_0*tmp_moved_constant_291) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_297 + tmp_kernel_op_60*tmp_moved_constant_298 + tmp_kernel_op_61*tmp_moved_constant_299) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_287 + jac_blending_inv_1_2_q_0*tmp_moved_constant_290 + jac_blending_inv_2_2_q_0*tmp_moved_constant_291) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_297 + tmp_kernel_op_66*tmp_moved_constant_298 + tmp_kernel_op_67*tmp_moved_constant_299) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_292 + jac_blending_inv_1_0_q_0*tmp_moved_constant_293 + jac_blending_inv_2_0_q_0*tmp_moved_constant_296) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_297 + tmp_kernel_op_72*tmp_moved_constant_298 + tmp_kernel_op_73*tmp_moved_constant_299) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_292 + jac_blending_inv_1_1_q_0*tmp_moved_constant_293 + jac_blending_inv_2_1_q_0*tmp_moved_constant_296) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_297 + tmp_kernel_op_78*tmp_moved_constant_298 + tmp_kernel_op_79*tmp_moved_constant_299) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_292 + jac_blending_inv_1_2_q_0*tmp_moved_constant_293 + jac_blending_inv_2_2_q_0*tmp_moved_constant_296) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_297 + tmp_kernel_op_84*tmp_moved_constant_298 + tmp_kernel_op_85*tmp_moved_constant_299);
             const real_t tmp_kernel_op_761 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_282 + jac_blending_inv_1_0_q_1*tmp_moved_constant_284 + jac_blending_inv_2_0_q_1*tmp_moved_constant_286) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_300 + tmp_kernel_op_120*tmp_moved_constant_301 + tmp_kernel_op_122*tmp_moved_constant_302) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_282 + jac_blending_inv_1_1_q_1*tmp_moved_constant_284 + jac_blending_inv_2_1_q_1*tmp_moved_constant_286) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_300 + tmp_kernel_op_127*tmp_moved_constant_301 + tmp_kernel_op_128*tmp_moved_constant_302) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_282 + jac_blending_inv_1_2_q_1*tmp_moved_constant_284 + jac_blending_inv_2_2_q_1*tmp_moved_constant_286) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_300 + tmp_kernel_op_133*tmp_moved_constant_301 + tmp_kernel_op_134*tmp_moved_constant_302) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_287 + jac_blending_inv_1_0_q_1*tmp_moved_constant_290 + jac_blending_inv_2_0_q_1*tmp_moved_constant_291) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_300 + tmp_kernel_op_139*tmp_moved_constant_301 + tmp_kernel_op_140*tmp_moved_constant_302) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_287 + jac_blending_inv_1_1_q_1*tmp_moved_constant_290 + jac_blending_inv_2_1_q_1*tmp_moved_constant_291) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_300 + tmp_kernel_op_145*tmp_moved_constant_301 + tmp_kernel_op_146*tmp_moved_constant_302) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_287 + jac_blending_inv_1_2_q_1*tmp_moved_constant_290 + jac_blending_inv_2_2_q_1*tmp_moved_constant_291) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_300 + tmp_kernel_op_151*tmp_moved_constant_301 + tmp_kernel_op_152*tmp_moved_constant_302) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_292 + jac_blending_inv_1_0_q_1*tmp_moved_constant_293 + jac_blending_inv_2_0_q_1*tmp_moved_constant_296) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_300 + tmp_kernel_op_157*tmp_moved_constant_301 + tmp_kernel_op_158*tmp_moved_constant_302) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_292 + jac_blending_inv_1_1_q_1*tmp_moved_constant_293 + jac_blending_inv_2_1_q_1*tmp_moved_constant_296) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_300 + tmp_kernel_op_163*tmp_moved_constant_301 + tmp_kernel_op_164*tmp_moved_constant_302) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_292 + jac_blending_inv_1_2_q_1*tmp_moved_constant_293 + jac_blending_inv_2_2_q_1*tmp_moved_constant_296) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_300 + tmp_kernel_op_169*tmp_moved_constant_301 + tmp_kernel_op_170*tmp_moved_constant_302);
             const real_t tmp_kernel_op_766 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_282 + jac_blending_inv_1_0_q_2*tmp_moved_constant_284 + jac_blending_inv_2_0_q_2*tmp_moved_constant_286) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_303 + tmp_kernel_op_205*tmp_moved_constant_304 + tmp_kernel_op_207*tmp_moved_constant_305) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_282 + jac_blending_inv_1_1_q_2*tmp_moved_constant_284 + jac_blending_inv_2_1_q_2*tmp_moved_constant_286) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_303 + tmp_kernel_op_212*tmp_moved_constant_304 + tmp_kernel_op_213*tmp_moved_constant_305) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_282 + jac_blending_inv_1_2_q_2*tmp_moved_constant_284 + jac_blending_inv_2_2_q_2*tmp_moved_constant_286) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_303 + tmp_kernel_op_218*tmp_moved_constant_304 + tmp_kernel_op_219*tmp_moved_constant_305) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_287 + jac_blending_inv_1_0_q_2*tmp_moved_constant_290 + jac_blending_inv_2_0_q_2*tmp_moved_constant_291) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_303 + tmp_kernel_op_224*tmp_moved_constant_304 + tmp_kernel_op_225*tmp_moved_constant_305) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_287 + jac_blending_inv_1_1_q_2*tmp_moved_constant_290 + jac_blending_inv_2_1_q_2*tmp_moved_constant_291) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_303 + tmp_kernel_op_230*tmp_moved_constant_304 + tmp_kernel_op_231*tmp_moved_constant_305) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_287 + jac_blending_inv_1_2_q_2*tmp_moved_constant_290 + jac_blending_inv_2_2_q_2*tmp_moved_constant_291) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_303 + tmp_kernel_op_236*tmp_moved_constant_304 + tmp_kernel_op_237*tmp_moved_constant_305) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_292 + jac_blending_inv_1_0_q_2*tmp_moved_constant_293 + jac_blending_inv_2_0_q_2*tmp_moved_constant_296) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_303 + tmp_kernel_op_242*tmp_moved_constant_304 + tmp_kernel_op_243*tmp_moved_constant_305) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_292 + jac_blending_inv_1_1_q_2*tmp_moved_constant_293 + jac_blending_inv_2_1_q_2*tmp_moved_constant_296) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_303 + tmp_kernel_op_248*tmp_moved_constant_304 + tmp_kernel_op_249*tmp_moved_constant_305) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_292 + jac_blending_inv_1_2_q_2*tmp_moved_constant_293 + jac_blending_inv_2_2_q_2*tmp_moved_constant_296) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_303 + tmp_kernel_op_254*tmp_moved_constant_304 + tmp_kernel_op_255*tmp_moved_constant_305);
             const real_t tmp_kernel_op_771 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_282 + jac_blending_inv_1_0_q_3*tmp_moved_constant_284 + jac_blending_inv_2_0_q_3*tmp_moved_constant_286) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_306 + tmp_kernel_op_290*tmp_moved_constant_307 + tmp_kernel_op_292*tmp_moved_constant_308) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_282 + jac_blending_inv_1_1_q_3*tmp_moved_constant_284 + jac_blending_inv_2_1_q_3*tmp_moved_constant_286) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_306 + tmp_kernel_op_297*tmp_moved_constant_307 + tmp_kernel_op_298*tmp_moved_constant_308) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_282 + jac_blending_inv_1_2_q_3*tmp_moved_constant_284 + jac_blending_inv_2_2_q_3*tmp_moved_constant_286) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_306 + tmp_kernel_op_303*tmp_moved_constant_307 + tmp_kernel_op_304*tmp_moved_constant_308) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_287 + jac_blending_inv_1_0_q_3*tmp_moved_constant_290 + jac_blending_inv_2_0_q_3*tmp_moved_constant_291) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_306 + tmp_kernel_op_309*tmp_moved_constant_307 + tmp_kernel_op_310*tmp_moved_constant_308) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_287 + jac_blending_inv_1_1_q_3*tmp_moved_constant_290 + jac_blending_inv_2_1_q_3*tmp_moved_constant_291) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_306 + tmp_kernel_op_315*tmp_moved_constant_307 + tmp_kernel_op_316*tmp_moved_constant_308) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_287 + jac_blending_inv_1_2_q_3*tmp_moved_constant_290 + jac_blending_inv_2_2_q_3*tmp_moved_constant_291) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_306 + tmp_kernel_op_321*tmp_moved_constant_307 + tmp_kernel_op_322*tmp_moved_constant_308) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_292 + jac_blending_inv_1_0_q_3*tmp_moved_constant_293 + jac_blending_inv_2_0_q_3*tmp_moved_constant_296) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_306 + tmp_kernel_op_327*tmp_moved_constant_307 + tmp_kernel_op_328*tmp_moved_constant_308) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_292 + jac_blending_inv_1_1_q_3*tmp_moved_constant_293 + jac_blending_inv_2_1_q_3*tmp_moved_constant_296) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_306 + tmp_kernel_op_333*tmp_moved_constant_307 + tmp_kernel_op_334*tmp_moved_constant_308) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_292 + jac_blending_inv_1_2_q_3*tmp_moved_constant_293 + jac_blending_inv_2_2_q_3*tmp_moved_constant_296) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_306 + tmp_kernel_op_339*tmp_moved_constant_307 + tmp_kernel_op_340*tmp_moved_constant_308);
             const real_t tmp_kernel_op_776 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_282 + jac_blending_inv_1_0_q_4*tmp_moved_constant_284 + jac_blending_inv_2_0_q_4*tmp_moved_constant_286) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_309 + tmp_kernel_op_375*tmp_moved_constant_310 + tmp_kernel_op_377*tmp_moved_constant_311) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_282 + jac_blending_inv_1_1_q_4*tmp_moved_constant_284 + jac_blending_inv_2_1_q_4*tmp_moved_constant_286) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_309 + tmp_kernel_op_382*tmp_moved_constant_310 + tmp_kernel_op_383*tmp_moved_constant_311) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_282 + jac_blending_inv_1_2_q_4*tmp_moved_constant_284 + jac_blending_inv_2_2_q_4*tmp_moved_constant_286) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_309 + tmp_kernel_op_388*tmp_moved_constant_310 + tmp_kernel_op_389*tmp_moved_constant_311) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_287 + jac_blending_inv_1_0_q_4*tmp_moved_constant_290 + jac_blending_inv_2_0_q_4*tmp_moved_constant_291) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_309 + tmp_kernel_op_394*tmp_moved_constant_310 + tmp_kernel_op_395*tmp_moved_constant_311) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_287 + jac_blending_inv_1_1_q_4*tmp_moved_constant_290 + jac_blending_inv_2_1_q_4*tmp_moved_constant_291) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_309 + tmp_kernel_op_400*tmp_moved_constant_310 + tmp_kernel_op_401*tmp_moved_constant_311) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_287 + jac_blending_inv_1_2_q_4*tmp_moved_constant_290 + jac_blending_inv_2_2_q_4*tmp_moved_constant_291) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_309 + tmp_kernel_op_406*tmp_moved_constant_310 + tmp_kernel_op_407*tmp_moved_constant_311) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_292 + jac_blending_inv_1_0_q_4*tmp_moved_constant_293 + jac_blending_inv_2_0_q_4*tmp_moved_constant_296) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_309 + tmp_kernel_op_412*tmp_moved_constant_310 + tmp_kernel_op_413*tmp_moved_constant_311) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_292 + jac_blending_inv_1_1_q_4*tmp_moved_constant_293 + jac_blending_inv_2_1_q_4*tmp_moved_constant_296) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_309 + tmp_kernel_op_418*tmp_moved_constant_310 + tmp_kernel_op_419*tmp_moved_constant_311) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_292 + jac_blending_inv_1_2_q_4*tmp_moved_constant_293 + jac_blending_inv_2_2_q_4*tmp_moved_constant_296) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_309 + tmp_kernel_op_424*tmp_moved_constant_310 + tmp_kernel_op_425*tmp_moved_constant_311);
             const real_t tmp_kernel_op_797 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_314 + jac_blending_inv_1_0_q_0*tmp_moved_constant_316 + jac_blending_inv_2_0_q_0*tmp_moved_constant_318) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_327 + tmp_kernel_op_35*tmp_moved_constant_328 + tmp_kernel_op_37*tmp_moved_constant_329) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_314 + jac_blending_inv_1_1_q_0*tmp_moved_constant_316 + jac_blending_inv_2_1_q_0*tmp_moved_constant_318) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_327 + tmp_kernel_op_42*tmp_moved_constant_328 + tmp_kernel_op_43*tmp_moved_constant_329) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_314 + jac_blending_inv_1_2_q_0*tmp_moved_constant_316 + jac_blending_inv_2_2_q_0*tmp_moved_constant_318) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_327 + tmp_kernel_op_48*tmp_moved_constant_328 + tmp_kernel_op_49*tmp_moved_constant_329) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_319 + jac_blending_inv_1_0_q_0*tmp_moved_constant_321 + jac_blending_inv_2_0_q_0*tmp_moved_constant_322) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_327 + tmp_kernel_op_54*tmp_moved_constant_328 + tmp_kernel_op_55*tmp_moved_constant_329) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_319 + jac_blending_inv_1_1_q_0*tmp_moved_constant_321 + jac_blending_inv_2_1_q_0*tmp_moved_constant_322) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_327 + tmp_kernel_op_60*tmp_moved_constant_328 + tmp_kernel_op_61*tmp_moved_constant_329) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_319 + jac_blending_inv_1_2_q_0*tmp_moved_constant_321 + jac_blending_inv_2_2_q_0*tmp_moved_constant_322) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_327 + tmp_kernel_op_66*tmp_moved_constant_328 + tmp_kernel_op_67*tmp_moved_constant_329) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_323 + jac_blending_inv_1_0_q_0*tmp_moved_constant_324 + jac_blending_inv_2_0_q_0*tmp_moved_constant_326) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_327 + tmp_kernel_op_72*tmp_moved_constant_328 + tmp_kernel_op_73*tmp_moved_constant_329) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_323 + jac_blending_inv_1_1_q_0*tmp_moved_constant_324 + jac_blending_inv_2_1_q_0*tmp_moved_constant_326) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_327 + tmp_kernel_op_78*tmp_moved_constant_328 + tmp_kernel_op_79*tmp_moved_constant_329) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_323 + jac_blending_inv_1_2_q_0*tmp_moved_constant_324 + jac_blending_inv_2_2_q_0*tmp_moved_constant_326) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_327 + tmp_kernel_op_84*tmp_moved_constant_328 + tmp_kernel_op_85*tmp_moved_constant_329);
             const real_t tmp_kernel_op_803 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_314 + jac_blending_inv_1_0_q_1*tmp_moved_constant_316 + jac_blending_inv_2_0_q_1*tmp_moved_constant_318) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_330 + tmp_kernel_op_120*tmp_moved_constant_331 + tmp_kernel_op_122*tmp_moved_constant_332) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_314 + jac_blending_inv_1_1_q_1*tmp_moved_constant_316 + jac_blending_inv_2_1_q_1*tmp_moved_constant_318) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_330 + tmp_kernel_op_127*tmp_moved_constant_331 + tmp_kernel_op_128*tmp_moved_constant_332) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_314 + jac_blending_inv_1_2_q_1*tmp_moved_constant_316 + jac_blending_inv_2_2_q_1*tmp_moved_constant_318) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_330 + tmp_kernel_op_133*tmp_moved_constant_331 + tmp_kernel_op_134*tmp_moved_constant_332) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_319 + jac_blending_inv_1_0_q_1*tmp_moved_constant_321 + jac_blending_inv_2_0_q_1*tmp_moved_constant_322) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_330 + tmp_kernel_op_139*tmp_moved_constant_331 + tmp_kernel_op_140*tmp_moved_constant_332) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_319 + jac_blending_inv_1_1_q_1*tmp_moved_constant_321 + jac_blending_inv_2_1_q_1*tmp_moved_constant_322) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_330 + tmp_kernel_op_145*tmp_moved_constant_331 + tmp_kernel_op_146*tmp_moved_constant_332) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_319 + jac_blending_inv_1_2_q_1*tmp_moved_constant_321 + jac_blending_inv_2_2_q_1*tmp_moved_constant_322) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_330 + tmp_kernel_op_151*tmp_moved_constant_331 + tmp_kernel_op_152*tmp_moved_constant_332) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_323 + jac_blending_inv_1_0_q_1*tmp_moved_constant_324 + jac_blending_inv_2_0_q_1*tmp_moved_constant_326) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_330 + tmp_kernel_op_157*tmp_moved_constant_331 + tmp_kernel_op_158*tmp_moved_constant_332) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_323 + jac_blending_inv_1_1_q_1*tmp_moved_constant_324 + jac_blending_inv_2_1_q_1*tmp_moved_constant_326) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_330 + tmp_kernel_op_163*tmp_moved_constant_331 + tmp_kernel_op_164*tmp_moved_constant_332) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_323 + jac_blending_inv_1_2_q_1*tmp_moved_constant_324 + jac_blending_inv_2_2_q_1*tmp_moved_constant_326) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_330 + tmp_kernel_op_169*tmp_moved_constant_331 + tmp_kernel_op_170*tmp_moved_constant_332);
             const real_t tmp_kernel_op_809 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_314 + jac_blending_inv_1_0_q_2*tmp_moved_constant_316 + jac_blending_inv_2_0_q_2*tmp_moved_constant_318) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_333 + tmp_kernel_op_205*tmp_moved_constant_334 + tmp_kernel_op_207*tmp_moved_constant_335) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_314 + jac_blending_inv_1_1_q_2*tmp_moved_constant_316 + jac_blending_inv_2_1_q_2*tmp_moved_constant_318) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_333 + tmp_kernel_op_212*tmp_moved_constant_334 + tmp_kernel_op_213*tmp_moved_constant_335) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_314 + jac_blending_inv_1_2_q_2*tmp_moved_constant_316 + jac_blending_inv_2_2_q_2*tmp_moved_constant_318) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_333 + tmp_kernel_op_218*tmp_moved_constant_334 + tmp_kernel_op_219*tmp_moved_constant_335) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_319 + jac_blending_inv_1_0_q_2*tmp_moved_constant_321 + jac_blending_inv_2_0_q_2*tmp_moved_constant_322) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_333 + tmp_kernel_op_224*tmp_moved_constant_334 + tmp_kernel_op_225*tmp_moved_constant_335) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_319 + jac_blending_inv_1_1_q_2*tmp_moved_constant_321 + jac_blending_inv_2_1_q_2*tmp_moved_constant_322) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_333 + tmp_kernel_op_230*tmp_moved_constant_334 + tmp_kernel_op_231*tmp_moved_constant_335) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_319 + jac_blending_inv_1_2_q_2*tmp_moved_constant_321 + jac_blending_inv_2_2_q_2*tmp_moved_constant_322) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_333 + tmp_kernel_op_236*tmp_moved_constant_334 + tmp_kernel_op_237*tmp_moved_constant_335) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_323 + jac_blending_inv_1_0_q_2*tmp_moved_constant_324 + jac_blending_inv_2_0_q_2*tmp_moved_constant_326) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_333 + tmp_kernel_op_242*tmp_moved_constant_334 + tmp_kernel_op_243*tmp_moved_constant_335) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_323 + jac_blending_inv_1_1_q_2*tmp_moved_constant_324 + jac_blending_inv_2_1_q_2*tmp_moved_constant_326) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_333 + tmp_kernel_op_248*tmp_moved_constant_334 + tmp_kernel_op_249*tmp_moved_constant_335) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_323 + jac_blending_inv_1_2_q_2*tmp_moved_constant_324 + jac_blending_inv_2_2_q_2*tmp_moved_constant_326) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_333 + tmp_kernel_op_254*tmp_moved_constant_334 + tmp_kernel_op_255*tmp_moved_constant_335);
             const real_t tmp_kernel_op_815 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_314 + jac_blending_inv_1_0_q_3*tmp_moved_constant_316 + jac_blending_inv_2_0_q_3*tmp_moved_constant_318) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_336 + tmp_kernel_op_290*tmp_moved_constant_337 + tmp_kernel_op_292*tmp_moved_constant_338) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_314 + jac_blending_inv_1_1_q_3*tmp_moved_constant_316 + jac_blending_inv_2_1_q_3*tmp_moved_constant_318) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_336 + tmp_kernel_op_297*tmp_moved_constant_337 + tmp_kernel_op_298*tmp_moved_constant_338) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_314 + jac_blending_inv_1_2_q_3*tmp_moved_constant_316 + jac_blending_inv_2_2_q_3*tmp_moved_constant_318) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_336 + tmp_kernel_op_303*tmp_moved_constant_337 + tmp_kernel_op_304*tmp_moved_constant_338) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_319 + jac_blending_inv_1_0_q_3*tmp_moved_constant_321 + jac_blending_inv_2_0_q_3*tmp_moved_constant_322) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_336 + tmp_kernel_op_309*tmp_moved_constant_337 + tmp_kernel_op_310*tmp_moved_constant_338) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_319 + jac_blending_inv_1_1_q_3*tmp_moved_constant_321 + jac_blending_inv_2_1_q_3*tmp_moved_constant_322) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_336 + tmp_kernel_op_315*tmp_moved_constant_337 + tmp_kernel_op_316*tmp_moved_constant_338) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_319 + jac_blending_inv_1_2_q_3*tmp_moved_constant_321 + jac_blending_inv_2_2_q_3*tmp_moved_constant_322) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_336 + tmp_kernel_op_321*tmp_moved_constant_337 + tmp_kernel_op_322*tmp_moved_constant_338) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_323 + jac_blending_inv_1_0_q_3*tmp_moved_constant_324 + jac_blending_inv_2_0_q_3*tmp_moved_constant_326) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_336 + tmp_kernel_op_327*tmp_moved_constant_337 + tmp_kernel_op_328*tmp_moved_constant_338) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_323 + jac_blending_inv_1_1_q_3*tmp_moved_constant_324 + jac_blending_inv_2_1_q_3*tmp_moved_constant_326) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_336 + tmp_kernel_op_333*tmp_moved_constant_337 + tmp_kernel_op_334*tmp_moved_constant_338) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_323 + jac_blending_inv_1_2_q_3*tmp_moved_constant_324 + jac_blending_inv_2_2_q_3*tmp_moved_constant_326) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_336 + tmp_kernel_op_339*tmp_moved_constant_337 + tmp_kernel_op_340*tmp_moved_constant_338);
             const real_t tmp_kernel_op_821 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_314 + jac_blending_inv_1_0_q_4*tmp_moved_constant_316 + jac_blending_inv_2_0_q_4*tmp_moved_constant_318) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_339 + tmp_kernel_op_375*tmp_moved_constant_340 + tmp_kernel_op_377*tmp_moved_constant_341) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_314 + jac_blending_inv_1_1_q_4*tmp_moved_constant_316 + jac_blending_inv_2_1_q_4*tmp_moved_constant_318) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_339 + tmp_kernel_op_382*tmp_moved_constant_340 + tmp_kernel_op_383*tmp_moved_constant_341) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_314 + jac_blending_inv_1_2_q_4*tmp_moved_constant_316 + jac_blending_inv_2_2_q_4*tmp_moved_constant_318) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_339 + tmp_kernel_op_388*tmp_moved_constant_340 + tmp_kernel_op_389*tmp_moved_constant_341) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_319 + jac_blending_inv_1_0_q_4*tmp_moved_constant_321 + jac_blending_inv_2_0_q_4*tmp_moved_constant_322) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_339 + tmp_kernel_op_394*tmp_moved_constant_340 + tmp_kernel_op_395*tmp_moved_constant_341) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_319 + jac_blending_inv_1_1_q_4*tmp_moved_constant_321 + jac_blending_inv_2_1_q_4*tmp_moved_constant_322) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_339 + tmp_kernel_op_400*tmp_moved_constant_340 + tmp_kernel_op_401*tmp_moved_constant_341) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_319 + jac_blending_inv_1_2_q_4*tmp_moved_constant_321 + jac_blending_inv_2_2_q_4*tmp_moved_constant_322) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_339 + tmp_kernel_op_406*tmp_moved_constant_340 + tmp_kernel_op_407*tmp_moved_constant_341) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_323 + jac_blending_inv_1_0_q_4*tmp_moved_constant_324 + jac_blending_inv_2_0_q_4*tmp_moved_constant_326) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_339 + tmp_kernel_op_412*tmp_moved_constant_340 + tmp_kernel_op_413*tmp_moved_constant_341) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_323 + jac_blending_inv_1_1_q_4*tmp_moved_constant_324 + jac_blending_inv_2_1_q_4*tmp_moved_constant_326) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_339 + tmp_kernel_op_418*tmp_moved_constant_340 + tmp_kernel_op_419*tmp_moved_constant_341) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_323 + jac_blending_inv_1_2_q_4*tmp_moved_constant_324 + jac_blending_inv_2_2_q_4*tmp_moved_constant_326) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_339 + tmp_kernel_op_424*tmp_moved_constant_340 + tmp_kernel_op_425*tmp_moved_constant_341);
             const real_t tmp_kernel_op_838 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_343 + jac_blending_inv_1_0_q_0*tmp_moved_constant_345 + jac_blending_inv_2_0_q_0*tmp_moved_constant_347) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_354 + tmp_kernel_op_35*tmp_moved_constant_355 + tmp_kernel_op_37*tmp_moved_constant_356) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_343 + jac_blending_inv_1_1_q_0*tmp_moved_constant_345 + jac_blending_inv_2_1_q_0*tmp_moved_constant_347) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_354 + tmp_kernel_op_42*tmp_moved_constant_355 + tmp_kernel_op_43*tmp_moved_constant_356) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_343 + jac_blending_inv_1_2_q_0*tmp_moved_constant_345 + jac_blending_inv_2_2_q_0*tmp_moved_constant_347) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_354 + tmp_kernel_op_48*tmp_moved_constant_355 + tmp_kernel_op_49*tmp_moved_constant_356) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_348 + jac_blending_inv_1_0_q_0*tmp_moved_constant_349 + jac_blending_inv_2_0_q_0*tmp_moved_constant_350) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_354 + tmp_kernel_op_54*tmp_moved_constant_355 + tmp_kernel_op_55*tmp_moved_constant_356) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_348 + jac_blending_inv_1_1_q_0*tmp_moved_constant_349 + jac_blending_inv_2_1_q_0*tmp_moved_constant_350) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_354 + tmp_kernel_op_60*tmp_moved_constant_355 + tmp_kernel_op_61*tmp_moved_constant_356) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_348 + jac_blending_inv_1_2_q_0*tmp_moved_constant_349 + jac_blending_inv_2_2_q_0*tmp_moved_constant_350) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_354 + tmp_kernel_op_66*tmp_moved_constant_355 + tmp_kernel_op_67*tmp_moved_constant_356) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_351 + jac_blending_inv_1_0_q_0*tmp_moved_constant_352 + jac_blending_inv_2_0_q_0*tmp_moved_constant_353) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_354 + tmp_kernel_op_72*tmp_moved_constant_355 + tmp_kernel_op_73*tmp_moved_constant_356) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_351 + jac_blending_inv_1_1_q_0*tmp_moved_constant_352 + jac_blending_inv_2_1_q_0*tmp_moved_constant_353) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_354 + tmp_kernel_op_78*tmp_moved_constant_355 + tmp_kernel_op_79*tmp_moved_constant_356) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_351 + jac_blending_inv_1_2_q_0*tmp_moved_constant_352 + jac_blending_inv_2_2_q_0*tmp_moved_constant_353) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_354 + tmp_kernel_op_84*tmp_moved_constant_355 + tmp_kernel_op_85*tmp_moved_constant_356);
             const real_t tmp_kernel_op_843 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_343 + jac_blending_inv_1_0_q_1*tmp_moved_constant_345 + jac_blending_inv_2_0_q_1*tmp_moved_constant_347) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_357 + tmp_kernel_op_120*tmp_moved_constant_358 + tmp_kernel_op_122*tmp_moved_constant_359) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_343 + jac_blending_inv_1_1_q_1*tmp_moved_constant_345 + jac_blending_inv_2_1_q_1*tmp_moved_constant_347) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_357 + tmp_kernel_op_127*tmp_moved_constant_358 + tmp_kernel_op_128*tmp_moved_constant_359) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_343 + jac_blending_inv_1_2_q_1*tmp_moved_constant_345 + jac_blending_inv_2_2_q_1*tmp_moved_constant_347) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_357 + tmp_kernel_op_133*tmp_moved_constant_358 + tmp_kernel_op_134*tmp_moved_constant_359) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_348 + jac_blending_inv_1_0_q_1*tmp_moved_constant_349 + jac_blending_inv_2_0_q_1*tmp_moved_constant_350) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_357 + tmp_kernel_op_139*tmp_moved_constant_358 + tmp_kernel_op_140*tmp_moved_constant_359) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_348 + jac_blending_inv_1_1_q_1*tmp_moved_constant_349 + jac_blending_inv_2_1_q_1*tmp_moved_constant_350) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_357 + tmp_kernel_op_145*tmp_moved_constant_358 + tmp_kernel_op_146*tmp_moved_constant_359) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_348 + jac_blending_inv_1_2_q_1*tmp_moved_constant_349 + jac_blending_inv_2_2_q_1*tmp_moved_constant_350) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_357 + tmp_kernel_op_151*tmp_moved_constant_358 + tmp_kernel_op_152*tmp_moved_constant_359) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_351 + jac_blending_inv_1_0_q_1*tmp_moved_constant_352 + jac_blending_inv_2_0_q_1*tmp_moved_constant_353) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_357 + tmp_kernel_op_157*tmp_moved_constant_358 + tmp_kernel_op_158*tmp_moved_constant_359) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_351 + jac_blending_inv_1_1_q_1*tmp_moved_constant_352 + jac_blending_inv_2_1_q_1*tmp_moved_constant_353) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_357 + tmp_kernel_op_163*tmp_moved_constant_358 + tmp_kernel_op_164*tmp_moved_constant_359) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_351 + jac_blending_inv_1_2_q_1*tmp_moved_constant_352 + jac_blending_inv_2_2_q_1*tmp_moved_constant_353) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_357 + tmp_kernel_op_169*tmp_moved_constant_358 + tmp_kernel_op_170*tmp_moved_constant_359);
             const real_t tmp_kernel_op_848 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_343 + jac_blending_inv_1_0_q_2*tmp_moved_constant_345 + jac_blending_inv_2_0_q_2*tmp_moved_constant_347) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_360 + tmp_kernel_op_205*tmp_moved_constant_361 + tmp_kernel_op_207*tmp_moved_constant_362) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_343 + jac_blending_inv_1_1_q_2*tmp_moved_constant_345 + jac_blending_inv_2_1_q_2*tmp_moved_constant_347) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_360 + tmp_kernel_op_212*tmp_moved_constant_361 + tmp_kernel_op_213*tmp_moved_constant_362) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_343 + jac_blending_inv_1_2_q_2*tmp_moved_constant_345 + jac_blending_inv_2_2_q_2*tmp_moved_constant_347) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_360 + tmp_kernel_op_218*tmp_moved_constant_361 + tmp_kernel_op_219*tmp_moved_constant_362) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_348 + jac_blending_inv_1_0_q_2*tmp_moved_constant_349 + jac_blending_inv_2_0_q_2*tmp_moved_constant_350) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_360 + tmp_kernel_op_224*tmp_moved_constant_361 + tmp_kernel_op_225*tmp_moved_constant_362) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_348 + jac_blending_inv_1_1_q_2*tmp_moved_constant_349 + jac_blending_inv_2_1_q_2*tmp_moved_constant_350) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_360 + tmp_kernel_op_230*tmp_moved_constant_361 + tmp_kernel_op_231*tmp_moved_constant_362) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_348 + jac_blending_inv_1_2_q_2*tmp_moved_constant_349 + jac_blending_inv_2_2_q_2*tmp_moved_constant_350) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_360 + tmp_kernel_op_236*tmp_moved_constant_361 + tmp_kernel_op_237*tmp_moved_constant_362) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_351 + jac_blending_inv_1_0_q_2*tmp_moved_constant_352 + jac_blending_inv_2_0_q_2*tmp_moved_constant_353) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_360 + tmp_kernel_op_242*tmp_moved_constant_361 + tmp_kernel_op_243*tmp_moved_constant_362) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_351 + jac_blending_inv_1_1_q_2*tmp_moved_constant_352 + jac_blending_inv_2_1_q_2*tmp_moved_constant_353) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_360 + tmp_kernel_op_248*tmp_moved_constant_361 + tmp_kernel_op_249*tmp_moved_constant_362) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_351 + jac_blending_inv_1_2_q_2*tmp_moved_constant_352 + jac_blending_inv_2_2_q_2*tmp_moved_constant_353) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_360 + tmp_kernel_op_254*tmp_moved_constant_361 + tmp_kernel_op_255*tmp_moved_constant_362);
             const real_t tmp_kernel_op_853 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_343 + jac_blending_inv_1_0_q_3*tmp_moved_constant_345 + jac_blending_inv_2_0_q_3*tmp_moved_constant_347) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_363 + tmp_kernel_op_290*tmp_moved_constant_364 + tmp_kernel_op_292*tmp_moved_constant_365) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_343 + jac_blending_inv_1_1_q_3*tmp_moved_constant_345 + jac_blending_inv_2_1_q_3*tmp_moved_constant_347) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_363 + tmp_kernel_op_297*tmp_moved_constant_364 + tmp_kernel_op_298*tmp_moved_constant_365) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_343 + jac_blending_inv_1_2_q_3*tmp_moved_constant_345 + jac_blending_inv_2_2_q_3*tmp_moved_constant_347) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_363 + tmp_kernel_op_303*tmp_moved_constant_364 + tmp_kernel_op_304*tmp_moved_constant_365) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_348 + jac_blending_inv_1_0_q_3*tmp_moved_constant_349 + jac_blending_inv_2_0_q_3*tmp_moved_constant_350) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_363 + tmp_kernel_op_309*tmp_moved_constant_364 + tmp_kernel_op_310*tmp_moved_constant_365) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_348 + jac_blending_inv_1_1_q_3*tmp_moved_constant_349 + jac_blending_inv_2_1_q_3*tmp_moved_constant_350) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_363 + tmp_kernel_op_315*tmp_moved_constant_364 + tmp_kernel_op_316*tmp_moved_constant_365) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_348 + jac_blending_inv_1_2_q_3*tmp_moved_constant_349 + jac_blending_inv_2_2_q_3*tmp_moved_constant_350) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_363 + tmp_kernel_op_321*tmp_moved_constant_364 + tmp_kernel_op_322*tmp_moved_constant_365) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_351 + jac_blending_inv_1_0_q_3*tmp_moved_constant_352 + jac_blending_inv_2_0_q_3*tmp_moved_constant_353) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_363 + tmp_kernel_op_327*tmp_moved_constant_364 + tmp_kernel_op_328*tmp_moved_constant_365) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_351 + jac_blending_inv_1_1_q_3*tmp_moved_constant_352 + jac_blending_inv_2_1_q_3*tmp_moved_constant_353) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_363 + tmp_kernel_op_333*tmp_moved_constant_364 + tmp_kernel_op_334*tmp_moved_constant_365) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_351 + jac_blending_inv_1_2_q_3*tmp_moved_constant_352 + jac_blending_inv_2_2_q_3*tmp_moved_constant_353) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_363 + tmp_kernel_op_339*tmp_moved_constant_364 + tmp_kernel_op_340*tmp_moved_constant_365);
             const real_t tmp_kernel_op_858 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_343 + jac_blending_inv_1_0_q_4*tmp_moved_constant_345 + jac_blending_inv_2_0_q_4*tmp_moved_constant_347) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_366 + tmp_kernel_op_375*tmp_moved_constant_367 + tmp_kernel_op_377*tmp_moved_constant_368) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_343 + jac_blending_inv_1_1_q_4*tmp_moved_constant_345 + jac_blending_inv_2_1_q_4*tmp_moved_constant_347) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_366 + tmp_kernel_op_382*tmp_moved_constant_367 + tmp_kernel_op_383*tmp_moved_constant_368) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_343 + jac_blending_inv_1_2_q_4*tmp_moved_constant_345 + jac_blending_inv_2_2_q_4*tmp_moved_constant_347) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_366 + tmp_kernel_op_388*tmp_moved_constant_367 + tmp_kernel_op_389*tmp_moved_constant_368) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_348 + jac_blending_inv_1_0_q_4*tmp_moved_constant_349 + jac_blending_inv_2_0_q_4*tmp_moved_constant_350) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_366 + tmp_kernel_op_394*tmp_moved_constant_367 + tmp_kernel_op_395*tmp_moved_constant_368) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_348 + jac_blending_inv_1_1_q_4*tmp_moved_constant_349 + jac_blending_inv_2_1_q_4*tmp_moved_constant_350) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_366 + tmp_kernel_op_400*tmp_moved_constant_367 + tmp_kernel_op_401*tmp_moved_constant_368) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_348 + jac_blending_inv_1_2_q_4*tmp_moved_constant_349 + jac_blending_inv_2_2_q_4*tmp_moved_constant_350) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_366 + tmp_kernel_op_406*tmp_moved_constant_367 + tmp_kernel_op_407*tmp_moved_constant_368) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_351 + jac_blending_inv_1_0_q_4*tmp_moved_constant_352 + jac_blending_inv_2_0_q_4*tmp_moved_constant_353) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_366 + tmp_kernel_op_412*tmp_moved_constant_367 + tmp_kernel_op_413*tmp_moved_constant_368) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_351 + jac_blending_inv_1_1_q_4*tmp_moved_constant_352 + jac_blending_inv_2_1_q_4*tmp_moved_constant_353) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_366 + tmp_kernel_op_418*tmp_moved_constant_367 + tmp_kernel_op_419*tmp_moved_constant_368) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_351 + jac_blending_inv_1_2_q_4*tmp_moved_constant_352 + jac_blending_inv_2_2_q_4*tmp_moved_constant_353) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_366 + tmp_kernel_op_424*tmp_moved_constant_367 + tmp_kernel_op_425*tmp_moved_constant_368);
             const real_t tmp_kernel_op_859 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_45 + jac_blending_inv_1_0_q_0*tmp_moved_constant_46 + jac_blending_inv_2_0_q_0*tmp_moved_constant_47) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_45 + jac_blending_inv_1_1_q_0*tmp_moved_constant_46 + jac_blending_inv_2_1_q_0*tmp_moved_constant_47) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_45 + jac_blending_inv_1_2_q_0*tmp_moved_constant_46 + jac_blending_inv_2_2_q_0*tmp_moved_constant_47));
             const real_t tmp_kernel_op_860 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_48 + jac_blending_inv_1_0_q_1*tmp_moved_constant_49 + jac_blending_inv_2_0_q_1*tmp_moved_constant_50) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_48 + jac_blending_inv_1_1_q_1*tmp_moved_constant_49 + jac_blending_inv_2_1_q_1*tmp_moved_constant_50) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_48 + jac_blending_inv_1_2_q_1*tmp_moved_constant_49 + jac_blending_inv_2_2_q_1*tmp_moved_constant_50));
             const real_t tmp_kernel_op_861 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_51 + jac_blending_inv_1_0_q_2*tmp_moved_constant_52 + jac_blending_inv_2_0_q_2*tmp_moved_constant_53) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_51 + jac_blending_inv_1_1_q_2*tmp_moved_constant_52 + jac_blending_inv_2_1_q_2*tmp_moved_constant_53) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_51 + jac_blending_inv_1_2_q_2*tmp_moved_constant_52 + jac_blending_inv_2_2_q_2*tmp_moved_constant_53));
             const real_t tmp_kernel_op_862 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_54 + jac_blending_inv_1_0_q_3*tmp_moved_constant_55 + jac_blending_inv_2_0_q_3*tmp_moved_constant_56) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_54 + jac_blending_inv_1_1_q_3*tmp_moved_constant_55 + jac_blending_inv_2_1_q_3*tmp_moved_constant_56) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_54 + jac_blending_inv_1_2_q_3*tmp_moved_constant_55 + jac_blending_inv_2_2_q_3*tmp_moved_constant_56));
             const real_t tmp_kernel_op_863 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_57 + jac_blending_inv_1_0_q_4*tmp_moved_constant_58 + jac_blending_inv_2_0_q_4*tmp_moved_constant_59) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_57 + jac_blending_inv_1_1_q_4*tmp_moved_constant_58 + jac_blending_inv_2_1_q_4*tmp_moved_constant_59) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_57 + jac_blending_inv_1_2_q_4*tmp_moved_constant_58 + jac_blending_inv_2_2_q_4*tmp_moved_constant_59));
             const real_t tmp_kernel_op_864 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_66 + jac_blending_inv_1_0_q_0*tmp_moved_constant_67 + jac_blending_inv_2_0_q_0*tmp_moved_constant_68) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_66 + jac_blending_inv_1_1_q_0*tmp_moved_constant_67 + jac_blending_inv_2_1_q_0*tmp_moved_constant_68) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_66 + jac_blending_inv_1_2_q_0*tmp_moved_constant_67 + jac_blending_inv_2_2_q_0*tmp_moved_constant_68));
             const real_t tmp_kernel_op_865 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_69 + jac_blending_inv_1_0_q_1*tmp_moved_constant_70 + jac_blending_inv_2_0_q_1*tmp_moved_constant_71) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_69 + jac_blending_inv_1_1_q_1*tmp_moved_constant_70 + jac_blending_inv_2_1_q_1*tmp_moved_constant_71) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_69 + jac_blending_inv_1_2_q_1*tmp_moved_constant_70 + jac_blending_inv_2_2_q_1*tmp_moved_constant_71));
             const real_t tmp_kernel_op_866 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_72 + jac_blending_inv_1_0_q_2*tmp_moved_constant_73 + jac_blending_inv_2_0_q_2*tmp_moved_constant_74) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_72 + jac_blending_inv_1_1_q_2*tmp_moved_constant_73 + jac_blending_inv_2_1_q_2*tmp_moved_constant_74) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_72 + jac_blending_inv_1_2_q_2*tmp_moved_constant_73 + jac_blending_inv_2_2_q_2*tmp_moved_constant_74));
             const real_t tmp_kernel_op_867 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_75 + jac_blending_inv_1_0_q_3*tmp_moved_constant_76 + jac_blending_inv_2_0_q_3*tmp_moved_constant_77) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_75 + jac_blending_inv_1_1_q_3*tmp_moved_constant_76 + jac_blending_inv_2_1_q_3*tmp_moved_constant_77) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_75 + jac_blending_inv_1_2_q_3*tmp_moved_constant_76 + jac_blending_inv_2_2_q_3*tmp_moved_constant_77));
             const real_t tmp_kernel_op_868 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_78 + jac_blending_inv_1_0_q_4*tmp_moved_constant_79 + jac_blending_inv_2_0_q_4*tmp_moved_constant_80) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_78 + jac_blending_inv_1_1_q_4*tmp_moved_constant_79 + jac_blending_inv_2_1_q_4*tmp_moved_constant_80) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_78 + jac_blending_inv_1_2_q_4*tmp_moved_constant_79 + jac_blending_inv_2_2_q_4*tmp_moved_constant_80));
             const real_t tmp_kernel_op_869 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_87 + jac_blending_inv_1_0_q_0*tmp_moved_constant_88 + jac_blending_inv_2_0_q_0*tmp_moved_constant_89) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_87 + jac_blending_inv_1_1_q_0*tmp_moved_constant_88 + jac_blending_inv_2_1_q_0*tmp_moved_constant_89) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_87 + jac_blending_inv_1_2_q_0*tmp_moved_constant_88 + jac_blending_inv_2_2_q_0*tmp_moved_constant_89));
             const real_t tmp_kernel_op_870 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_90 + jac_blending_inv_1_0_q_1*tmp_moved_constant_91 + jac_blending_inv_2_0_q_1*tmp_moved_constant_92) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_90 + jac_blending_inv_1_1_q_1*tmp_moved_constant_91 + jac_blending_inv_2_1_q_1*tmp_moved_constant_92) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_90 + jac_blending_inv_1_2_q_1*tmp_moved_constant_91 + jac_blending_inv_2_2_q_1*tmp_moved_constant_92));
             const real_t tmp_kernel_op_871 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_93 + jac_blending_inv_1_0_q_2*tmp_moved_constant_94 + jac_blending_inv_2_0_q_2*tmp_moved_constant_95) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_93 + jac_blending_inv_1_1_q_2*tmp_moved_constant_94 + jac_blending_inv_2_1_q_2*tmp_moved_constant_95) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_93 + jac_blending_inv_1_2_q_2*tmp_moved_constant_94 + jac_blending_inv_2_2_q_2*tmp_moved_constant_95));
             const real_t tmp_kernel_op_872 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_96 + jac_blending_inv_1_0_q_3*tmp_moved_constant_97 + jac_blending_inv_2_0_q_3*tmp_moved_constant_98) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_96 + jac_blending_inv_1_1_q_3*tmp_moved_constant_97 + jac_blending_inv_2_1_q_3*tmp_moved_constant_98) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_96 + jac_blending_inv_1_2_q_3*tmp_moved_constant_97 + jac_blending_inv_2_2_q_3*tmp_moved_constant_98));
             const real_t tmp_kernel_op_873 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_99 + jac_blending_inv_1_0_q_4*tmp_moved_constant_100 + jac_blending_inv_2_0_q_4*tmp_moved_constant_101) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_99 + jac_blending_inv_1_1_q_4*tmp_moved_constant_100 + jac_blending_inv_2_1_q_4*tmp_moved_constant_101) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_99 + jac_blending_inv_1_2_q_4*tmp_moved_constant_100 + jac_blending_inv_2_2_q_4*tmp_moved_constant_101));
             const real_t tmp_kernel_op_874 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_119 + jac_blending_inv_1_0_q_0*tmp_moved_constant_122 + jac_blending_inv_2_0_q_0*tmp_moved_constant_125) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_119 + jac_blending_inv_1_1_q_0*tmp_moved_constant_122 + jac_blending_inv_2_1_q_0*tmp_moved_constant_125) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_119 + jac_blending_inv_1_2_q_0*tmp_moved_constant_122 + jac_blending_inv_2_2_q_0*tmp_moved_constant_125));
             const real_t tmp_kernel_op_875 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_128 + jac_blending_inv_1_0_q_1*tmp_moved_constant_131 + jac_blending_inv_2_0_q_1*tmp_moved_constant_134) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_128 + jac_blending_inv_1_1_q_1*tmp_moved_constant_131 + jac_blending_inv_2_1_q_1*tmp_moved_constant_134) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_128 + jac_blending_inv_1_2_q_1*tmp_moved_constant_131 + jac_blending_inv_2_2_q_1*tmp_moved_constant_134));
             const real_t tmp_kernel_op_876 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_137 + jac_blending_inv_1_0_q_2*tmp_moved_constant_140 + jac_blending_inv_2_0_q_2*tmp_moved_constant_143) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_137 + jac_blending_inv_1_1_q_2*tmp_moved_constant_140 + jac_blending_inv_2_1_q_2*tmp_moved_constant_143) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_137 + jac_blending_inv_1_2_q_2*tmp_moved_constant_140 + jac_blending_inv_2_2_q_2*tmp_moved_constant_143));
             const real_t tmp_kernel_op_877 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_146 + jac_blending_inv_1_0_q_3*tmp_moved_constant_149 + jac_blending_inv_2_0_q_3*tmp_moved_constant_152) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_146 + jac_blending_inv_1_1_q_3*tmp_moved_constant_149 + jac_blending_inv_2_1_q_3*tmp_moved_constant_152) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_146 + jac_blending_inv_1_2_q_3*tmp_moved_constant_149 + jac_blending_inv_2_2_q_3*tmp_moved_constant_152));
             const real_t tmp_kernel_op_878 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_155 + jac_blending_inv_1_0_q_4*tmp_moved_constant_158 + jac_blending_inv_2_0_q_4*tmp_moved_constant_161) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_155 + jac_blending_inv_1_1_q_4*tmp_moved_constant_158 + jac_blending_inv_2_1_q_4*tmp_moved_constant_161) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_155 + jac_blending_inv_1_2_q_4*tmp_moved_constant_158 + jac_blending_inv_2_2_q_4*tmp_moved_constant_161));
             const real_t tmp_kernel_op_879 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_176 + jac_blending_inv_1_0_q_0*tmp_moved_constant_179 + jac_blending_inv_2_0_q_0*tmp_moved_constant_182) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_176 + jac_blending_inv_1_1_q_0*tmp_moved_constant_179 + jac_blending_inv_2_1_q_0*tmp_moved_constant_182) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_176 + jac_blending_inv_1_2_q_0*tmp_moved_constant_179 + jac_blending_inv_2_2_q_0*tmp_moved_constant_182));
             const real_t tmp_kernel_op_880 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_185 + jac_blending_inv_1_0_q_1*tmp_moved_constant_188 + jac_blending_inv_2_0_q_1*tmp_moved_constant_191) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_185 + jac_blending_inv_1_1_q_1*tmp_moved_constant_188 + jac_blending_inv_2_1_q_1*tmp_moved_constant_191) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_185 + jac_blending_inv_1_2_q_1*tmp_moved_constant_188 + jac_blending_inv_2_2_q_1*tmp_moved_constant_191));
             const real_t tmp_kernel_op_881 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_194 + jac_blending_inv_1_0_q_2*tmp_moved_constant_197 + jac_blending_inv_2_0_q_2*tmp_moved_constant_200) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_194 + jac_blending_inv_1_1_q_2*tmp_moved_constant_197 + jac_blending_inv_2_1_q_2*tmp_moved_constant_200) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_194 + jac_blending_inv_1_2_q_2*tmp_moved_constant_197 + jac_blending_inv_2_2_q_2*tmp_moved_constant_200));
             const real_t tmp_kernel_op_882 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_203 + jac_blending_inv_1_0_q_3*tmp_moved_constant_206 + jac_blending_inv_2_0_q_3*tmp_moved_constant_209) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_203 + jac_blending_inv_1_1_q_3*tmp_moved_constant_206 + jac_blending_inv_2_1_q_3*tmp_moved_constant_209) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_203 + jac_blending_inv_1_2_q_3*tmp_moved_constant_206 + jac_blending_inv_2_2_q_3*tmp_moved_constant_209));
             const real_t tmp_kernel_op_883 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_212 + jac_blending_inv_1_0_q_4*tmp_moved_constant_215 + jac_blending_inv_2_0_q_4*tmp_moved_constant_218) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_212 + jac_blending_inv_1_1_q_4*tmp_moved_constant_215 + jac_blending_inv_2_1_q_4*tmp_moved_constant_218) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_212 + jac_blending_inv_1_2_q_4*tmp_moved_constant_215 + jac_blending_inv_2_2_q_4*tmp_moved_constant_218));
             const real_t tmp_kernel_op_884 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_236 + jac_blending_inv_1_0_q_0*tmp_moved_constant_239 + jac_blending_inv_2_0_q_0*tmp_moved_constant_242) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_236 + jac_blending_inv_1_1_q_0*tmp_moved_constant_239 + jac_blending_inv_2_1_q_0*tmp_moved_constant_242) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_236 + jac_blending_inv_1_2_q_0*tmp_moved_constant_239 + jac_blending_inv_2_2_q_0*tmp_moved_constant_242));
             const real_t tmp_kernel_op_885 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_245 + jac_blending_inv_1_0_q_1*tmp_moved_constant_248 + jac_blending_inv_2_0_q_1*tmp_moved_constant_251) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_245 + jac_blending_inv_1_1_q_1*tmp_moved_constant_248 + jac_blending_inv_2_1_q_1*tmp_moved_constant_251) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_245 + jac_blending_inv_1_2_q_1*tmp_moved_constant_248 + jac_blending_inv_2_2_q_1*tmp_moved_constant_251));
             const real_t tmp_kernel_op_886 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_254 + jac_blending_inv_1_0_q_2*tmp_moved_constant_257 + jac_blending_inv_2_0_q_2*tmp_moved_constant_260) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_254 + jac_blending_inv_1_1_q_2*tmp_moved_constant_257 + jac_blending_inv_2_1_q_2*tmp_moved_constant_260) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_254 + jac_blending_inv_1_2_q_2*tmp_moved_constant_257 + jac_blending_inv_2_2_q_2*tmp_moved_constant_260));
             const real_t tmp_kernel_op_887 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_263 + jac_blending_inv_1_0_q_3*tmp_moved_constant_266 + jac_blending_inv_2_0_q_3*tmp_moved_constant_269) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_263 + jac_blending_inv_1_1_q_3*tmp_moved_constant_266 + jac_blending_inv_2_1_q_3*tmp_moved_constant_269) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_263 + jac_blending_inv_1_2_q_3*tmp_moved_constant_266 + jac_blending_inv_2_2_q_3*tmp_moved_constant_269));
             const real_t tmp_kernel_op_888 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_272 + jac_blending_inv_1_0_q_4*tmp_moved_constant_275 + jac_blending_inv_2_0_q_4*tmp_moved_constant_278) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_272 + jac_blending_inv_1_1_q_4*tmp_moved_constant_275 + jac_blending_inv_2_1_q_4*tmp_moved_constant_278) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_272 + jac_blending_inv_1_2_q_4*tmp_moved_constant_275 + jac_blending_inv_2_2_q_4*tmp_moved_constant_278));
             const real_t tmp_kernel_op_889 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_297 + jac_blending_inv_1_0_q_0*tmp_moved_constant_298 + jac_blending_inv_2_0_q_0*tmp_moved_constant_299) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_297 + jac_blending_inv_1_1_q_0*tmp_moved_constant_298 + jac_blending_inv_2_1_q_0*tmp_moved_constant_299) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_297 + jac_blending_inv_1_2_q_0*tmp_moved_constant_298 + jac_blending_inv_2_2_q_0*tmp_moved_constant_299));
             const real_t tmp_kernel_op_890 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_300 + jac_blending_inv_1_0_q_1*tmp_moved_constant_301 + jac_blending_inv_2_0_q_1*tmp_moved_constant_302) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_300 + jac_blending_inv_1_1_q_1*tmp_moved_constant_301 + jac_blending_inv_2_1_q_1*tmp_moved_constant_302) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_300 + jac_blending_inv_1_2_q_1*tmp_moved_constant_301 + jac_blending_inv_2_2_q_1*tmp_moved_constant_302));
             const real_t tmp_kernel_op_891 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_303 + jac_blending_inv_1_0_q_2*tmp_moved_constant_304 + jac_blending_inv_2_0_q_2*tmp_moved_constant_305) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_303 + jac_blending_inv_1_1_q_2*tmp_moved_constant_304 + jac_blending_inv_2_1_q_2*tmp_moved_constant_305) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_303 + jac_blending_inv_1_2_q_2*tmp_moved_constant_304 + jac_blending_inv_2_2_q_2*tmp_moved_constant_305));
             const real_t tmp_kernel_op_892 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_306 + jac_blending_inv_1_0_q_3*tmp_moved_constant_307 + jac_blending_inv_2_0_q_3*tmp_moved_constant_308) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_306 + jac_blending_inv_1_1_q_3*tmp_moved_constant_307 + jac_blending_inv_2_1_q_3*tmp_moved_constant_308) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_306 + jac_blending_inv_1_2_q_3*tmp_moved_constant_307 + jac_blending_inv_2_2_q_3*tmp_moved_constant_308));
             const real_t tmp_kernel_op_893 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_309 + jac_blending_inv_1_0_q_4*tmp_moved_constant_310 + jac_blending_inv_2_0_q_4*tmp_moved_constant_311) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_309 + jac_blending_inv_1_1_q_4*tmp_moved_constant_310 + jac_blending_inv_2_1_q_4*tmp_moved_constant_311) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_309 + jac_blending_inv_1_2_q_4*tmp_moved_constant_310 + jac_blending_inv_2_2_q_4*tmp_moved_constant_311));
             const real_t tmp_kernel_op_894 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_327 + jac_blending_inv_1_0_q_0*tmp_moved_constant_328 + jac_blending_inv_2_0_q_0*tmp_moved_constant_329) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_327 + jac_blending_inv_1_1_q_0*tmp_moved_constant_328 + jac_blending_inv_2_1_q_0*tmp_moved_constant_329) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_327 + jac_blending_inv_1_2_q_0*tmp_moved_constant_328 + jac_blending_inv_2_2_q_0*tmp_moved_constant_329));
             const real_t tmp_kernel_op_895 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_330 + jac_blending_inv_1_0_q_1*tmp_moved_constant_331 + jac_blending_inv_2_0_q_1*tmp_moved_constant_332) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_330 + jac_blending_inv_1_1_q_1*tmp_moved_constant_331 + jac_blending_inv_2_1_q_1*tmp_moved_constant_332) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_330 + jac_blending_inv_1_2_q_1*tmp_moved_constant_331 + jac_blending_inv_2_2_q_1*tmp_moved_constant_332));
             const real_t tmp_kernel_op_896 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_333 + jac_blending_inv_1_0_q_2*tmp_moved_constant_334 + jac_blending_inv_2_0_q_2*tmp_moved_constant_335) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_333 + jac_blending_inv_1_1_q_2*tmp_moved_constant_334 + jac_blending_inv_2_1_q_2*tmp_moved_constant_335) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_333 + jac_blending_inv_1_2_q_2*tmp_moved_constant_334 + jac_blending_inv_2_2_q_2*tmp_moved_constant_335));
             const real_t tmp_kernel_op_897 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_336 + jac_blending_inv_1_0_q_3*tmp_moved_constant_337 + jac_blending_inv_2_0_q_3*tmp_moved_constant_338) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_336 + jac_blending_inv_1_1_q_3*tmp_moved_constant_337 + jac_blending_inv_2_1_q_3*tmp_moved_constant_338) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_336 + jac_blending_inv_1_2_q_3*tmp_moved_constant_337 + jac_blending_inv_2_2_q_3*tmp_moved_constant_338));
             const real_t tmp_kernel_op_898 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_339 + jac_blending_inv_1_0_q_4*tmp_moved_constant_340 + jac_blending_inv_2_0_q_4*tmp_moved_constant_341) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_339 + jac_blending_inv_1_1_q_4*tmp_moved_constant_340 + jac_blending_inv_2_1_q_4*tmp_moved_constant_341) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_339 + jac_blending_inv_1_2_q_4*tmp_moved_constant_340 + jac_blending_inv_2_2_q_4*tmp_moved_constant_341));
             const real_t tmp_kernel_op_899 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_354 + jac_blending_inv_1_0_q_0*tmp_moved_constant_355 + jac_blending_inv_2_0_q_0*tmp_moved_constant_356) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_354 + jac_blending_inv_1_1_q_0*tmp_moved_constant_355 + jac_blending_inv_2_1_q_0*tmp_moved_constant_356) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_354 + jac_blending_inv_1_2_q_0*tmp_moved_constant_355 + jac_blending_inv_2_2_q_0*tmp_moved_constant_356));
             const real_t tmp_kernel_op_900 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_357 + jac_blending_inv_1_0_q_1*tmp_moved_constant_358 + jac_blending_inv_2_0_q_1*tmp_moved_constant_359) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_357 + jac_blending_inv_1_1_q_1*tmp_moved_constant_358 + jac_blending_inv_2_1_q_1*tmp_moved_constant_359) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_357 + jac_blending_inv_1_2_q_1*tmp_moved_constant_358 + jac_blending_inv_2_2_q_1*tmp_moved_constant_359));
             const real_t tmp_kernel_op_901 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_360 + jac_blending_inv_1_0_q_2*tmp_moved_constant_361 + jac_blending_inv_2_0_q_2*tmp_moved_constant_362) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_360 + jac_blending_inv_1_1_q_2*tmp_moved_constant_361 + jac_blending_inv_2_1_q_2*tmp_moved_constant_362) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_360 + jac_blending_inv_1_2_q_2*tmp_moved_constant_361 + jac_blending_inv_2_2_q_2*tmp_moved_constant_362));
             const real_t tmp_kernel_op_902 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_363 + jac_blending_inv_1_0_q_3*tmp_moved_constant_364 + jac_blending_inv_2_0_q_3*tmp_moved_constant_365) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_363 + jac_blending_inv_1_1_q_3*tmp_moved_constant_364 + jac_blending_inv_2_1_q_3*tmp_moved_constant_365) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_363 + jac_blending_inv_1_2_q_3*tmp_moved_constant_364 + jac_blending_inv_2_2_q_3*tmp_moved_constant_365));
             const real_t tmp_kernel_op_903 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_366 + jac_blending_inv_1_0_q_4*tmp_moved_constant_367 + jac_blending_inv_2_0_q_4*tmp_moved_constant_368) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_366 + jac_blending_inv_1_1_q_4*tmp_moved_constant_367 + jac_blending_inv_2_1_q_4*tmp_moved_constant_368) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_366 + jac_blending_inv_1_2_q_4*tmp_moved_constant_367 + jac_blending_inv_2_2_q_4*tmp_moved_constant_368));
             const real_t elMat_0_0 = tmp_kernel_op_108*tmp_kernel_op_86 + tmp_kernel_op_171*tmp_kernel_op_193 + tmp_kernel_op_256*tmp_kernel_op_278 + tmp_kernel_op_341*tmp_kernel_op_363 + tmp_kernel_op_426*tmp_kernel_op_448;
             const real_t elMat_0_1 = tmp_kernel_op_108*tmp_kernel_op_459 + tmp_kernel_op_193*tmp_kernel_op_464 + tmp_kernel_op_278*tmp_kernel_op_469 + tmp_kernel_op_363*tmp_kernel_op_474 + tmp_kernel_op_448*tmp_kernel_op_479;
             const real_t elMat_0_2 = tmp_kernel_op_108*tmp_kernel_op_490 + tmp_kernel_op_193*tmp_kernel_op_495 + tmp_kernel_op_278*tmp_kernel_op_500 + tmp_kernel_op_363*tmp_kernel_op_505 + tmp_kernel_op_448*tmp_kernel_op_510;
             const real_t elMat_0_3 = tmp_kernel_op_108*tmp_kernel_op_521 + tmp_kernel_op_193*tmp_kernel_op_526 + tmp_kernel_op_278*tmp_kernel_op_531 + tmp_kernel_op_363*tmp_kernel_op_536 + tmp_kernel_op_448*tmp_kernel_op_541;
             const real_t elMat_0_4 = tmp_kernel_op_108*tmp_kernel_op_566 + tmp_kernel_op_193*tmp_kernel_op_576 + tmp_kernel_op_278*tmp_kernel_op_586 + tmp_kernel_op_363*tmp_kernel_op_596 + tmp_kernel_op_448*tmp_kernel_op_606;
             const real_t elMat_0_5 = tmp_kernel_op_108*tmp_kernel_op_628 + tmp_kernel_op_193*tmp_kernel_op_638 + tmp_kernel_op_278*tmp_kernel_op_648 + tmp_kernel_op_363*tmp_kernel_op_658 + tmp_kernel_op_448*tmp_kernel_op_668;
             const real_t elMat_0_6 = tmp_kernel_op_108*tmp_kernel_op_693 + tmp_kernel_op_193*tmp_kernel_op_703 + tmp_kernel_op_278*tmp_kernel_op_713 + tmp_kernel_op_363*tmp_kernel_op_723 + tmp_kernel_op_448*tmp_kernel_op_733;
             const real_t elMat_0_7 = tmp_kernel_op_108*tmp_kernel_op_756 + tmp_kernel_op_193*tmp_kernel_op_761 + tmp_kernel_op_278*tmp_kernel_op_766 + tmp_kernel_op_363*tmp_kernel_op_771 + tmp_kernel_op_448*tmp_kernel_op_776;
             const real_t elMat_0_8 = tmp_kernel_op_108*tmp_kernel_op_797 + tmp_kernel_op_193*tmp_kernel_op_803 + tmp_kernel_op_278*tmp_kernel_op_809 + tmp_kernel_op_363*tmp_kernel_op_815 + tmp_kernel_op_448*tmp_kernel_op_821;
             const real_t elMat_0_9 = tmp_kernel_op_108*tmp_kernel_op_838 + tmp_kernel_op_193*tmp_kernel_op_843 + tmp_kernel_op_278*tmp_kernel_op_848 + tmp_kernel_op_363*tmp_kernel_op_853 + tmp_kernel_op_448*tmp_kernel_op_858;
             const real_t elMat_1_0 = tmp_kernel_op_171*tmp_kernel_op_860 + tmp_kernel_op_256*tmp_kernel_op_861 + tmp_kernel_op_341*tmp_kernel_op_862 + tmp_kernel_op_426*tmp_kernel_op_863 + tmp_kernel_op_859*tmp_kernel_op_86;
             const real_t elMat_1_1 = tmp_kernel_op_459*tmp_kernel_op_859 + tmp_kernel_op_464*tmp_kernel_op_860 + tmp_kernel_op_469*tmp_kernel_op_861 + tmp_kernel_op_474*tmp_kernel_op_862 + tmp_kernel_op_479*tmp_kernel_op_863;
             const real_t elMat_1_2 = tmp_kernel_op_490*tmp_kernel_op_859 + tmp_kernel_op_495*tmp_kernel_op_860 + tmp_kernel_op_500*tmp_kernel_op_861 + tmp_kernel_op_505*tmp_kernel_op_862 + tmp_kernel_op_510*tmp_kernel_op_863;
             const real_t elMat_1_3 = tmp_kernel_op_521*tmp_kernel_op_859 + tmp_kernel_op_526*tmp_kernel_op_860 + tmp_kernel_op_531*tmp_kernel_op_861 + tmp_kernel_op_536*tmp_kernel_op_862 + tmp_kernel_op_541*tmp_kernel_op_863;
             const real_t elMat_1_4 = tmp_kernel_op_566*tmp_kernel_op_859 + tmp_kernel_op_576*tmp_kernel_op_860 + tmp_kernel_op_586*tmp_kernel_op_861 + tmp_kernel_op_596*tmp_kernel_op_862 + tmp_kernel_op_606*tmp_kernel_op_863;
             const real_t elMat_1_5 = tmp_kernel_op_628*tmp_kernel_op_859 + tmp_kernel_op_638*tmp_kernel_op_860 + tmp_kernel_op_648*tmp_kernel_op_861 + tmp_kernel_op_658*tmp_kernel_op_862 + tmp_kernel_op_668*tmp_kernel_op_863;
             const real_t elMat_1_6 = tmp_kernel_op_693*tmp_kernel_op_859 + tmp_kernel_op_703*tmp_kernel_op_860 + tmp_kernel_op_713*tmp_kernel_op_861 + tmp_kernel_op_723*tmp_kernel_op_862 + tmp_kernel_op_733*tmp_kernel_op_863;
             const real_t elMat_1_7 = tmp_kernel_op_756*tmp_kernel_op_859 + tmp_kernel_op_761*tmp_kernel_op_860 + tmp_kernel_op_766*tmp_kernel_op_861 + tmp_kernel_op_771*tmp_kernel_op_862 + tmp_kernel_op_776*tmp_kernel_op_863;
             const real_t elMat_1_8 = tmp_kernel_op_797*tmp_kernel_op_859 + tmp_kernel_op_803*tmp_kernel_op_860 + tmp_kernel_op_809*tmp_kernel_op_861 + tmp_kernel_op_815*tmp_kernel_op_862 + tmp_kernel_op_821*tmp_kernel_op_863;
             const real_t elMat_1_9 = tmp_kernel_op_838*tmp_kernel_op_859 + tmp_kernel_op_843*tmp_kernel_op_860 + tmp_kernel_op_848*tmp_kernel_op_861 + tmp_kernel_op_853*tmp_kernel_op_862 + tmp_kernel_op_858*tmp_kernel_op_863;
             const real_t elMat_2_0 = tmp_kernel_op_171*tmp_kernel_op_865 + tmp_kernel_op_256*tmp_kernel_op_866 + tmp_kernel_op_341*tmp_kernel_op_867 + tmp_kernel_op_426*tmp_kernel_op_868 + tmp_kernel_op_86*tmp_kernel_op_864;
             const real_t elMat_2_1 = tmp_kernel_op_459*tmp_kernel_op_864 + tmp_kernel_op_464*tmp_kernel_op_865 + tmp_kernel_op_469*tmp_kernel_op_866 + tmp_kernel_op_474*tmp_kernel_op_867 + tmp_kernel_op_479*tmp_kernel_op_868;
             const real_t elMat_2_2 = tmp_kernel_op_490*tmp_kernel_op_864 + tmp_kernel_op_495*tmp_kernel_op_865 + tmp_kernel_op_500*tmp_kernel_op_866 + tmp_kernel_op_505*tmp_kernel_op_867 + tmp_kernel_op_510*tmp_kernel_op_868;
             const real_t elMat_2_3 = tmp_kernel_op_521*tmp_kernel_op_864 + tmp_kernel_op_526*tmp_kernel_op_865 + tmp_kernel_op_531*tmp_kernel_op_866 + tmp_kernel_op_536*tmp_kernel_op_867 + tmp_kernel_op_541*tmp_kernel_op_868;
             const real_t elMat_2_4 = tmp_kernel_op_566*tmp_kernel_op_864 + tmp_kernel_op_576*tmp_kernel_op_865 + tmp_kernel_op_586*tmp_kernel_op_866 + tmp_kernel_op_596*tmp_kernel_op_867 + tmp_kernel_op_606*tmp_kernel_op_868;
             const real_t elMat_2_5 = tmp_kernel_op_628*tmp_kernel_op_864 + tmp_kernel_op_638*tmp_kernel_op_865 + tmp_kernel_op_648*tmp_kernel_op_866 + tmp_kernel_op_658*tmp_kernel_op_867 + tmp_kernel_op_668*tmp_kernel_op_868;
             const real_t elMat_2_6 = tmp_kernel_op_693*tmp_kernel_op_864 + tmp_kernel_op_703*tmp_kernel_op_865 + tmp_kernel_op_713*tmp_kernel_op_866 + tmp_kernel_op_723*tmp_kernel_op_867 + tmp_kernel_op_733*tmp_kernel_op_868;
             const real_t elMat_2_7 = tmp_kernel_op_756*tmp_kernel_op_864 + tmp_kernel_op_761*tmp_kernel_op_865 + tmp_kernel_op_766*tmp_kernel_op_866 + tmp_kernel_op_771*tmp_kernel_op_867 + tmp_kernel_op_776*tmp_kernel_op_868;
             const real_t elMat_2_8 = tmp_kernel_op_797*tmp_kernel_op_864 + tmp_kernel_op_803*tmp_kernel_op_865 + tmp_kernel_op_809*tmp_kernel_op_866 + tmp_kernel_op_815*tmp_kernel_op_867 + tmp_kernel_op_821*tmp_kernel_op_868;
             const real_t elMat_2_9 = tmp_kernel_op_838*tmp_kernel_op_864 + tmp_kernel_op_843*tmp_kernel_op_865 + tmp_kernel_op_848*tmp_kernel_op_866 + tmp_kernel_op_853*tmp_kernel_op_867 + tmp_kernel_op_858*tmp_kernel_op_868;
             const real_t elMat_3_0 = tmp_kernel_op_171*tmp_kernel_op_870 + tmp_kernel_op_256*tmp_kernel_op_871 + tmp_kernel_op_341*tmp_kernel_op_872 + tmp_kernel_op_426*tmp_kernel_op_873 + tmp_kernel_op_86*tmp_kernel_op_869;
             const real_t elMat_3_1 = tmp_kernel_op_459*tmp_kernel_op_869 + tmp_kernel_op_464*tmp_kernel_op_870 + tmp_kernel_op_469*tmp_kernel_op_871 + tmp_kernel_op_474*tmp_kernel_op_872 + tmp_kernel_op_479*tmp_kernel_op_873;
             const real_t elMat_3_2 = tmp_kernel_op_490*tmp_kernel_op_869 + tmp_kernel_op_495*tmp_kernel_op_870 + tmp_kernel_op_500*tmp_kernel_op_871 + tmp_kernel_op_505*tmp_kernel_op_872 + tmp_kernel_op_510*tmp_kernel_op_873;
             const real_t elMat_3_3 = tmp_kernel_op_521*tmp_kernel_op_869 + tmp_kernel_op_526*tmp_kernel_op_870 + tmp_kernel_op_531*tmp_kernel_op_871 + tmp_kernel_op_536*tmp_kernel_op_872 + tmp_kernel_op_541*tmp_kernel_op_873;
             const real_t elMat_3_4 = tmp_kernel_op_566*tmp_kernel_op_869 + tmp_kernel_op_576*tmp_kernel_op_870 + tmp_kernel_op_586*tmp_kernel_op_871 + tmp_kernel_op_596*tmp_kernel_op_872 + tmp_kernel_op_606*tmp_kernel_op_873;
             const real_t elMat_3_5 = tmp_kernel_op_628*tmp_kernel_op_869 + tmp_kernel_op_638*tmp_kernel_op_870 + tmp_kernel_op_648*tmp_kernel_op_871 + tmp_kernel_op_658*tmp_kernel_op_872 + tmp_kernel_op_668*tmp_kernel_op_873;
             const real_t elMat_3_6 = tmp_kernel_op_693*tmp_kernel_op_869 + tmp_kernel_op_703*tmp_kernel_op_870 + tmp_kernel_op_713*tmp_kernel_op_871 + tmp_kernel_op_723*tmp_kernel_op_872 + tmp_kernel_op_733*tmp_kernel_op_873;
             const real_t elMat_3_7 = tmp_kernel_op_756*tmp_kernel_op_869 + tmp_kernel_op_761*tmp_kernel_op_870 + tmp_kernel_op_766*tmp_kernel_op_871 + tmp_kernel_op_771*tmp_kernel_op_872 + tmp_kernel_op_776*tmp_kernel_op_873;
             const real_t elMat_3_8 = tmp_kernel_op_797*tmp_kernel_op_869 + tmp_kernel_op_803*tmp_kernel_op_870 + tmp_kernel_op_809*tmp_kernel_op_871 + tmp_kernel_op_815*tmp_kernel_op_872 + tmp_kernel_op_821*tmp_kernel_op_873;
             const real_t elMat_3_9 = tmp_kernel_op_838*tmp_kernel_op_869 + tmp_kernel_op_843*tmp_kernel_op_870 + tmp_kernel_op_848*tmp_kernel_op_871 + tmp_kernel_op_853*tmp_kernel_op_872 + tmp_kernel_op_858*tmp_kernel_op_873;
             const real_t elMat_4_0 = tmp_kernel_op_171*tmp_kernel_op_875 + tmp_kernel_op_256*tmp_kernel_op_876 + tmp_kernel_op_341*tmp_kernel_op_877 + tmp_kernel_op_426*tmp_kernel_op_878 + tmp_kernel_op_86*tmp_kernel_op_874;
             const real_t elMat_4_1 = tmp_kernel_op_459*tmp_kernel_op_874 + tmp_kernel_op_464*tmp_kernel_op_875 + tmp_kernel_op_469*tmp_kernel_op_876 + tmp_kernel_op_474*tmp_kernel_op_877 + tmp_kernel_op_479*tmp_kernel_op_878;
             const real_t elMat_4_2 = tmp_kernel_op_490*tmp_kernel_op_874 + tmp_kernel_op_495*tmp_kernel_op_875 + tmp_kernel_op_500*tmp_kernel_op_876 + tmp_kernel_op_505*tmp_kernel_op_877 + tmp_kernel_op_510*tmp_kernel_op_878;
             const real_t elMat_4_3 = tmp_kernel_op_521*tmp_kernel_op_874 + tmp_kernel_op_526*tmp_kernel_op_875 + tmp_kernel_op_531*tmp_kernel_op_876 + tmp_kernel_op_536*tmp_kernel_op_877 + tmp_kernel_op_541*tmp_kernel_op_878;
             const real_t elMat_4_4 = tmp_kernel_op_566*tmp_kernel_op_874 + tmp_kernel_op_576*tmp_kernel_op_875 + tmp_kernel_op_586*tmp_kernel_op_876 + tmp_kernel_op_596*tmp_kernel_op_877 + tmp_kernel_op_606*tmp_kernel_op_878;
             const real_t elMat_4_5 = tmp_kernel_op_628*tmp_kernel_op_874 + tmp_kernel_op_638*tmp_kernel_op_875 + tmp_kernel_op_648*tmp_kernel_op_876 + tmp_kernel_op_658*tmp_kernel_op_877 + tmp_kernel_op_668*tmp_kernel_op_878;
             const real_t elMat_4_6 = tmp_kernel_op_693*tmp_kernel_op_874 + tmp_kernel_op_703*tmp_kernel_op_875 + tmp_kernel_op_713*tmp_kernel_op_876 + tmp_kernel_op_723*tmp_kernel_op_877 + tmp_kernel_op_733*tmp_kernel_op_878;
             const real_t elMat_4_7 = tmp_kernel_op_756*tmp_kernel_op_874 + tmp_kernel_op_761*tmp_kernel_op_875 + tmp_kernel_op_766*tmp_kernel_op_876 + tmp_kernel_op_771*tmp_kernel_op_877 + tmp_kernel_op_776*tmp_kernel_op_878;
             const real_t elMat_4_8 = tmp_kernel_op_797*tmp_kernel_op_874 + tmp_kernel_op_803*tmp_kernel_op_875 + tmp_kernel_op_809*tmp_kernel_op_876 + tmp_kernel_op_815*tmp_kernel_op_877 + tmp_kernel_op_821*tmp_kernel_op_878;
             const real_t elMat_4_9 = tmp_kernel_op_838*tmp_kernel_op_874 + tmp_kernel_op_843*tmp_kernel_op_875 + tmp_kernel_op_848*tmp_kernel_op_876 + tmp_kernel_op_853*tmp_kernel_op_877 + tmp_kernel_op_858*tmp_kernel_op_878;
             const real_t elMat_5_0 = tmp_kernel_op_171*tmp_kernel_op_880 + tmp_kernel_op_256*tmp_kernel_op_881 + tmp_kernel_op_341*tmp_kernel_op_882 + tmp_kernel_op_426*tmp_kernel_op_883 + tmp_kernel_op_86*tmp_kernel_op_879;
             const real_t elMat_5_1 = tmp_kernel_op_459*tmp_kernel_op_879 + tmp_kernel_op_464*tmp_kernel_op_880 + tmp_kernel_op_469*tmp_kernel_op_881 + tmp_kernel_op_474*tmp_kernel_op_882 + tmp_kernel_op_479*tmp_kernel_op_883;
             const real_t elMat_5_2 = tmp_kernel_op_490*tmp_kernel_op_879 + tmp_kernel_op_495*tmp_kernel_op_880 + tmp_kernel_op_500*tmp_kernel_op_881 + tmp_kernel_op_505*tmp_kernel_op_882 + tmp_kernel_op_510*tmp_kernel_op_883;
             const real_t elMat_5_3 = tmp_kernel_op_521*tmp_kernel_op_879 + tmp_kernel_op_526*tmp_kernel_op_880 + tmp_kernel_op_531*tmp_kernel_op_881 + tmp_kernel_op_536*tmp_kernel_op_882 + tmp_kernel_op_541*tmp_kernel_op_883;
             const real_t elMat_5_4 = tmp_kernel_op_566*tmp_kernel_op_879 + tmp_kernel_op_576*tmp_kernel_op_880 + tmp_kernel_op_586*tmp_kernel_op_881 + tmp_kernel_op_596*tmp_kernel_op_882 + tmp_kernel_op_606*tmp_kernel_op_883;
             const real_t elMat_5_5 = tmp_kernel_op_628*tmp_kernel_op_879 + tmp_kernel_op_638*tmp_kernel_op_880 + tmp_kernel_op_648*tmp_kernel_op_881 + tmp_kernel_op_658*tmp_kernel_op_882 + tmp_kernel_op_668*tmp_kernel_op_883;
             const real_t elMat_5_6 = tmp_kernel_op_693*tmp_kernel_op_879 + tmp_kernel_op_703*tmp_kernel_op_880 + tmp_kernel_op_713*tmp_kernel_op_881 + tmp_kernel_op_723*tmp_kernel_op_882 + tmp_kernel_op_733*tmp_kernel_op_883;
             const real_t elMat_5_7 = tmp_kernel_op_756*tmp_kernel_op_879 + tmp_kernel_op_761*tmp_kernel_op_880 + tmp_kernel_op_766*tmp_kernel_op_881 + tmp_kernel_op_771*tmp_kernel_op_882 + tmp_kernel_op_776*tmp_kernel_op_883;
             const real_t elMat_5_8 = tmp_kernel_op_797*tmp_kernel_op_879 + tmp_kernel_op_803*tmp_kernel_op_880 + tmp_kernel_op_809*tmp_kernel_op_881 + tmp_kernel_op_815*tmp_kernel_op_882 + tmp_kernel_op_821*tmp_kernel_op_883;
             const real_t elMat_5_9 = tmp_kernel_op_838*tmp_kernel_op_879 + tmp_kernel_op_843*tmp_kernel_op_880 + tmp_kernel_op_848*tmp_kernel_op_881 + tmp_kernel_op_853*tmp_kernel_op_882 + tmp_kernel_op_858*tmp_kernel_op_883;
             const real_t elMat_6_0 = tmp_kernel_op_171*tmp_kernel_op_885 + tmp_kernel_op_256*tmp_kernel_op_886 + tmp_kernel_op_341*tmp_kernel_op_887 + tmp_kernel_op_426*tmp_kernel_op_888 + tmp_kernel_op_86*tmp_kernel_op_884;
             const real_t elMat_6_1 = tmp_kernel_op_459*tmp_kernel_op_884 + tmp_kernel_op_464*tmp_kernel_op_885 + tmp_kernel_op_469*tmp_kernel_op_886 + tmp_kernel_op_474*tmp_kernel_op_887 + tmp_kernel_op_479*tmp_kernel_op_888;
             const real_t elMat_6_2 = tmp_kernel_op_490*tmp_kernel_op_884 + tmp_kernel_op_495*tmp_kernel_op_885 + tmp_kernel_op_500*tmp_kernel_op_886 + tmp_kernel_op_505*tmp_kernel_op_887 + tmp_kernel_op_510*tmp_kernel_op_888;
             const real_t elMat_6_3 = tmp_kernel_op_521*tmp_kernel_op_884 + tmp_kernel_op_526*tmp_kernel_op_885 + tmp_kernel_op_531*tmp_kernel_op_886 + tmp_kernel_op_536*tmp_kernel_op_887 + tmp_kernel_op_541*tmp_kernel_op_888;
             const real_t elMat_6_4 = tmp_kernel_op_566*tmp_kernel_op_884 + tmp_kernel_op_576*tmp_kernel_op_885 + tmp_kernel_op_586*tmp_kernel_op_886 + tmp_kernel_op_596*tmp_kernel_op_887 + tmp_kernel_op_606*tmp_kernel_op_888;
             const real_t elMat_6_5 = tmp_kernel_op_628*tmp_kernel_op_884 + tmp_kernel_op_638*tmp_kernel_op_885 + tmp_kernel_op_648*tmp_kernel_op_886 + tmp_kernel_op_658*tmp_kernel_op_887 + tmp_kernel_op_668*tmp_kernel_op_888;
             const real_t elMat_6_6 = tmp_kernel_op_693*tmp_kernel_op_884 + tmp_kernel_op_703*tmp_kernel_op_885 + tmp_kernel_op_713*tmp_kernel_op_886 + tmp_kernel_op_723*tmp_kernel_op_887 + tmp_kernel_op_733*tmp_kernel_op_888;
             const real_t elMat_6_7 = tmp_kernel_op_756*tmp_kernel_op_884 + tmp_kernel_op_761*tmp_kernel_op_885 + tmp_kernel_op_766*tmp_kernel_op_886 + tmp_kernel_op_771*tmp_kernel_op_887 + tmp_kernel_op_776*tmp_kernel_op_888;
             const real_t elMat_6_8 = tmp_kernel_op_797*tmp_kernel_op_884 + tmp_kernel_op_803*tmp_kernel_op_885 + tmp_kernel_op_809*tmp_kernel_op_886 + tmp_kernel_op_815*tmp_kernel_op_887 + tmp_kernel_op_821*tmp_kernel_op_888;
             const real_t elMat_6_9 = tmp_kernel_op_838*tmp_kernel_op_884 + tmp_kernel_op_843*tmp_kernel_op_885 + tmp_kernel_op_848*tmp_kernel_op_886 + tmp_kernel_op_853*tmp_kernel_op_887 + tmp_kernel_op_858*tmp_kernel_op_888;
             const real_t elMat_7_0 = tmp_kernel_op_171*tmp_kernel_op_890 + tmp_kernel_op_256*tmp_kernel_op_891 + tmp_kernel_op_341*tmp_kernel_op_892 + tmp_kernel_op_426*tmp_kernel_op_893 + tmp_kernel_op_86*tmp_kernel_op_889;
             const real_t elMat_7_1 = tmp_kernel_op_459*tmp_kernel_op_889 + tmp_kernel_op_464*tmp_kernel_op_890 + tmp_kernel_op_469*tmp_kernel_op_891 + tmp_kernel_op_474*tmp_kernel_op_892 + tmp_kernel_op_479*tmp_kernel_op_893;
             const real_t elMat_7_2 = tmp_kernel_op_490*tmp_kernel_op_889 + tmp_kernel_op_495*tmp_kernel_op_890 + tmp_kernel_op_500*tmp_kernel_op_891 + tmp_kernel_op_505*tmp_kernel_op_892 + tmp_kernel_op_510*tmp_kernel_op_893;
             const real_t elMat_7_3 = tmp_kernel_op_521*tmp_kernel_op_889 + tmp_kernel_op_526*tmp_kernel_op_890 + tmp_kernel_op_531*tmp_kernel_op_891 + tmp_kernel_op_536*tmp_kernel_op_892 + tmp_kernel_op_541*tmp_kernel_op_893;
             const real_t elMat_7_4 = tmp_kernel_op_566*tmp_kernel_op_889 + tmp_kernel_op_576*tmp_kernel_op_890 + tmp_kernel_op_586*tmp_kernel_op_891 + tmp_kernel_op_596*tmp_kernel_op_892 + tmp_kernel_op_606*tmp_kernel_op_893;
             const real_t elMat_7_5 = tmp_kernel_op_628*tmp_kernel_op_889 + tmp_kernel_op_638*tmp_kernel_op_890 + tmp_kernel_op_648*tmp_kernel_op_891 + tmp_kernel_op_658*tmp_kernel_op_892 + tmp_kernel_op_668*tmp_kernel_op_893;
             const real_t elMat_7_6 = tmp_kernel_op_693*tmp_kernel_op_889 + tmp_kernel_op_703*tmp_kernel_op_890 + tmp_kernel_op_713*tmp_kernel_op_891 + tmp_kernel_op_723*tmp_kernel_op_892 + tmp_kernel_op_733*tmp_kernel_op_893;
             const real_t elMat_7_7 = tmp_kernel_op_756*tmp_kernel_op_889 + tmp_kernel_op_761*tmp_kernel_op_890 + tmp_kernel_op_766*tmp_kernel_op_891 + tmp_kernel_op_771*tmp_kernel_op_892 + tmp_kernel_op_776*tmp_kernel_op_893;
             const real_t elMat_7_8 = tmp_kernel_op_797*tmp_kernel_op_889 + tmp_kernel_op_803*tmp_kernel_op_890 + tmp_kernel_op_809*tmp_kernel_op_891 + tmp_kernel_op_815*tmp_kernel_op_892 + tmp_kernel_op_821*tmp_kernel_op_893;
             const real_t elMat_7_9 = tmp_kernel_op_838*tmp_kernel_op_889 + tmp_kernel_op_843*tmp_kernel_op_890 + tmp_kernel_op_848*tmp_kernel_op_891 + tmp_kernel_op_853*tmp_kernel_op_892 + tmp_kernel_op_858*tmp_kernel_op_893;
             const real_t elMat_8_0 = tmp_kernel_op_171*tmp_kernel_op_895 + tmp_kernel_op_256*tmp_kernel_op_896 + tmp_kernel_op_341*tmp_kernel_op_897 + tmp_kernel_op_426*tmp_kernel_op_898 + tmp_kernel_op_86*tmp_kernel_op_894;
             const real_t elMat_8_1 = tmp_kernel_op_459*tmp_kernel_op_894 + tmp_kernel_op_464*tmp_kernel_op_895 + tmp_kernel_op_469*tmp_kernel_op_896 + tmp_kernel_op_474*tmp_kernel_op_897 + tmp_kernel_op_479*tmp_kernel_op_898;
             const real_t elMat_8_2 = tmp_kernel_op_490*tmp_kernel_op_894 + tmp_kernel_op_495*tmp_kernel_op_895 + tmp_kernel_op_500*tmp_kernel_op_896 + tmp_kernel_op_505*tmp_kernel_op_897 + tmp_kernel_op_510*tmp_kernel_op_898;
             const real_t elMat_8_3 = tmp_kernel_op_521*tmp_kernel_op_894 + tmp_kernel_op_526*tmp_kernel_op_895 + tmp_kernel_op_531*tmp_kernel_op_896 + tmp_kernel_op_536*tmp_kernel_op_897 + tmp_kernel_op_541*tmp_kernel_op_898;
             const real_t elMat_8_4 = tmp_kernel_op_566*tmp_kernel_op_894 + tmp_kernel_op_576*tmp_kernel_op_895 + tmp_kernel_op_586*tmp_kernel_op_896 + tmp_kernel_op_596*tmp_kernel_op_897 + tmp_kernel_op_606*tmp_kernel_op_898;
             const real_t elMat_8_5 = tmp_kernel_op_628*tmp_kernel_op_894 + tmp_kernel_op_638*tmp_kernel_op_895 + tmp_kernel_op_648*tmp_kernel_op_896 + tmp_kernel_op_658*tmp_kernel_op_897 + tmp_kernel_op_668*tmp_kernel_op_898;
             const real_t elMat_8_6 = tmp_kernel_op_693*tmp_kernel_op_894 + tmp_kernel_op_703*tmp_kernel_op_895 + tmp_kernel_op_713*tmp_kernel_op_896 + tmp_kernel_op_723*tmp_kernel_op_897 + tmp_kernel_op_733*tmp_kernel_op_898;
             const real_t elMat_8_7 = tmp_kernel_op_756*tmp_kernel_op_894 + tmp_kernel_op_761*tmp_kernel_op_895 + tmp_kernel_op_766*tmp_kernel_op_896 + tmp_kernel_op_771*tmp_kernel_op_897 + tmp_kernel_op_776*tmp_kernel_op_898;
             const real_t elMat_8_8 = tmp_kernel_op_797*tmp_kernel_op_894 + tmp_kernel_op_803*tmp_kernel_op_895 + tmp_kernel_op_809*tmp_kernel_op_896 + tmp_kernel_op_815*tmp_kernel_op_897 + tmp_kernel_op_821*tmp_kernel_op_898;
             const real_t elMat_8_9 = tmp_kernel_op_838*tmp_kernel_op_894 + tmp_kernel_op_843*tmp_kernel_op_895 + tmp_kernel_op_848*tmp_kernel_op_896 + tmp_kernel_op_853*tmp_kernel_op_897 + tmp_kernel_op_858*tmp_kernel_op_898;
             const real_t elMat_9_0 = tmp_kernel_op_171*tmp_kernel_op_900 + tmp_kernel_op_256*tmp_kernel_op_901 + tmp_kernel_op_341*tmp_kernel_op_902 + tmp_kernel_op_426*tmp_kernel_op_903 + tmp_kernel_op_86*tmp_kernel_op_899;
             const real_t elMat_9_1 = tmp_kernel_op_459*tmp_kernel_op_899 + tmp_kernel_op_464*tmp_kernel_op_900 + tmp_kernel_op_469*tmp_kernel_op_901 + tmp_kernel_op_474*tmp_kernel_op_902 + tmp_kernel_op_479*tmp_kernel_op_903;
             const real_t elMat_9_2 = tmp_kernel_op_490*tmp_kernel_op_899 + tmp_kernel_op_495*tmp_kernel_op_900 + tmp_kernel_op_500*tmp_kernel_op_901 + tmp_kernel_op_505*tmp_kernel_op_902 + tmp_kernel_op_510*tmp_kernel_op_903;
             const real_t elMat_9_3 = tmp_kernel_op_521*tmp_kernel_op_899 + tmp_kernel_op_526*tmp_kernel_op_900 + tmp_kernel_op_531*tmp_kernel_op_901 + tmp_kernel_op_536*tmp_kernel_op_902 + tmp_kernel_op_541*tmp_kernel_op_903;
             const real_t elMat_9_4 = tmp_kernel_op_566*tmp_kernel_op_899 + tmp_kernel_op_576*tmp_kernel_op_900 + tmp_kernel_op_586*tmp_kernel_op_901 + tmp_kernel_op_596*tmp_kernel_op_902 + tmp_kernel_op_606*tmp_kernel_op_903;
             const real_t elMat_9_5 = tmp_kernel_op_628*tmp_kernel_op_899 + tmp_kernel_op_638*tmp_kernel_op_900 + tmp_kernel_op_648*tmp_kernel_op_901 + tmp_kernel_op_658*tmp_kernel_op_902 + tmp_kernel_op_668*tmp_kernel_op_903;
             const real_t elMat_9_6 = tmp_kernel_op_693*tmp_kernel_op_899 + tmp_kernel_op_703*tmp_kernel_op_900 + tmp_kernel_op_713*tmp_kernel_op_901 + tmp_kernel_op_723*tmp_kernel_op_902 + tmp_kernel_op_733*tmp_kernel_op_903;
             const real_t elMat_9_7 = tmp_kernel_op_756*tmp_kernel_op_899 + tmp_kernel_op_761*tmp_kernel_op_900 + tmp_kernel_op_766*tmp_kernel_op_901 + tmp_kernel_op_771*tmp_kernel_op_902 + tmp_kernel_op_776*tmp_kernel_op_903;
             const real_t elMat_9_8 = tmp_kernel_op_797*tmp_kernel_op_899 + tmp_kernel_op_803*tmp_kernel_op_900 + tmp_kernel_op_809*tmp_kernel_op_901 + tmp_kernel_op_815*tmp_kernel_op_902 + tmp_kernel_op_821*tmp_kernel_op_903;
             const real_t elMat_9_9 = tmp_kernel_op_838*tmp_kernel_op_899 + tmp_kernel_op_843*tmp_kernel_op_900 + tmp_kernel_op_848*tmp_kernel_op_901 + tmp_kernel_op_853*tmp_kernel_op_902 + tmp_kernel_op_858*tmp_kernel_op_903;
         
             std::vector< uint_t > _data_rowIdx( 10 );
             std::vector< uint_t > _data_colIdx( 10 );
             std::vector< real_t > _data_mat( 100 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[1] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[2] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[3] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[4] = ((uint64_t)(_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]));
             _data_rowIdx[6] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[7] = ((uint64_t)(_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[8] = ((uint64_t)(_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[9] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[3] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]));
             _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[7] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_0_4));
             _data_mat[5] = ((real_t)(elMat_0_5));
             _data_mat[6] = ((real_t)(elMat_0_6));
             _data_mat[7] = ((real_t)(elMat_0_7));
             _data_mat[8] = ((real_t)(elMat_0_8));
             _data_mat[9] = ((real_t)(elMat_0_9));
             _data_mat[10] = ((real_t)(elMat_1_0));
             _data_mat[11] = ((real_t)(elMat_1_1));
             _data_mat[12] = ((real_t)(elMat_1_2));
             _data_mat[13] = ((real_t)(elMat_1_3));
             _data_mat[14] = ((real_t)(elMat_1_4));
             _data_mat[15] = ((real_t)(elMat_1_5));
             _data_mat[16] = ((real_t)(elMat_1_6));
             _data_mat[17] = ((real_t)(elMat_1_7));
             _data_mat[18] = ((real_t)(elMat_1_8));
             _data_mat[19] = ((real_t)(elMat_1_9));
             _data_mat[20] = ((real_t)(elMat_2_0));
             _data_mat[21] = ((real_t)(elMat_2_1));
             _data_mat[22] = ((real_t)(elMat_2_2));
             _data_mat[23] = ((real_t)(elMat_2_3));
             _data_mat[24] = ((real_t)(elMat_2_4));
             _data_mat[25] = ((real_t)(elMat_2_5));
             _data_mat[26] = ((real_t)(elMat_2_6));
             _data_mat[27] = ((real_t)(elMat_2_7));
             _data_mat[28] = ((real_t)(elMat_2_8));
             _data_mat[29] = ((real_t)(elMat_2_9));
             _data_mat[30] = ((real_t)(elMat_3_0));
             _data_mat[31] = ((real_t)(elMat_3_1));
             _data_mat[32] = ((real_t)(elMat_3_2));
             _data_mat[33] = ((real_t)(elMat_3_3));
             _data_mat[34] = ((real_t)(elMat_3_4));
             _data_mat[35] = ((real_t)(elMat_3_5));
             _data_mat[36] = ((real_t)(elMat_3_6));
             _data_mat[37] = ((real_t)(elMat_3_7));
             _data_mat[38] = ((real_t)(elMat_3_8));
             _data_mat[39] = ((real_t)(elMat_3_9));
             _data_mat[40] = ((real_t)(elMat_4_0));
             _data_mat[41] = ((real_t)(elMat_4_1));
             _data_mat[42] = ((real_t)(elMat_4_2));
             _data_mat[43] = ((real_t)(elMat_4_3));
             _data_mat[44] = ((real_t)(elMat_4_4));
             _data_mat[45] = ((real_t)(elMat_4_5));
             _data_mat[46] = ((real_t)(elMat_4_6));
             _data_mat[47] = ((real_t)(elMat_4_7));
             _data_mat[48] = ((real_t)(elMat_4_8));
             _data_mat[49] = ((real_t)(elMat_4_9));
             _data_mat[50] = ((real_t)(elMat_5_0));
             _data_mat[51] = ((real_t)(elMat_5_1));
             _data_mat[52] = ((real_t)(elMat_5_2));
             _data_mat[53] = ((real_t)(elMat_5_3));
             _data_mat[54] = ((real_t)(elMat_5_4));
             _data_mat[55] = ((real_t)(elMat_5_5));
             _data_mat[56] = ((real_t)(elMat_5_6));
             _data_mat[57] = ((real_t)(elMat_5_7));
             _data_mat[58] = ((real_t)(elMat_5_8));
             _data_mat[59] = ((real_t)(elMat_5_9));
             _data_mat[60] = ((real_t)(elMat_6_0));
             _data_mat[61] = ((real_t)(elMat_6_1));
             _data_mat[62] = ((real_t)(elMat_6_2));
             _data_mat[63] = ((real_t)(elMat_6_3));
             _data_mat[64] = ((real_t)(elMat_6_4));
             _data_mat[65] = ((real_t)(elMat_6_5));
             _data_mat[66] = ((real_t)(elMat_6_6));
             _data_mat[67] = ((real_t)(elMat_6_7));
             _data_mat[68] = ((real_t)(elMat_6_8));
             _data_mat[69] = ((real_t)(elMat_6_9));
             _data_mat[70] = ((real_t)(elMat_7_0));
             _data_mat[71] = ((real_t)(elMat_7_1));
             _data_mat[72] = ((real_t)(elMat_7_2));
             _data_mat[73] = ((real_t)(elMat_7_3));
             _data_mat[74] = ((real_t)(elMat_7_4));
             _data_mat[75] = ((real_t)(elMat_7_5));
             _data_mat[76] = ((real_t)(elMat_7_6));
             _data_mat[77] = ((real_t)(elMat_7_7));
             _data_mat[78] = ((real_t)(elMat_7_8));
             _data_mat[79] = ((real_t)(elMat_7_9));
             _data_mat[80] = ((real_t)(elMat_8_0));
             _data_mat[81] = ((real_t)(elMat_8_1));
             _data_mat[82] = ((real_t)(elMat_8_2));
             _data_mat[83] = ((real_t)(elMat_8_3));
             _data_mat[84] = ((real_t)(elMat_8_4));
             _data_mat[85] = ((real_t)(elMat_8_5));
             _data_mat[86] = ((real_t)(elMat_8_6));
             _data_mat[87] = ((real_t)(elMat_8_7));
             _data_mat[88] = ((real_t)(elMat_8_8));
             _data_mat[89] = ((real_t)(elMat_8_9));
             _data_mat[90] = ((real_t)(elMat_9_0));
             _data_mat[91] = ((real_t)(elMat_9_1));
             _data_mat[92] = ((real_t)(elMat_9_2));
             _data_mat[93] = ((real_t)(elMat_9_3));
             _data_mat[94] = ((real_t)(elMat_9_4));
             _data_mat[95] = ((real_t)(elMat_9_5));
             _data_mat[96] = ((real_t)(elMat_9_6));
             _data_mat[97] = ((real_t)(elMat_9_7));
             _data_mat[98] = ((real_t)(elMat_9_8));
             _data_mat[99] = ((real_t)(elMat_9_9));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const real_t tmp_coords_jac_11_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const real_t tmp_coords_jac_9_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const real_t tmp_coords_jac_8_BLUE_UP = jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP;
       const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const real_t tmp_coords_jac_7_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_10_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_12_BLUE_UP = jac_affine_0_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_0_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_0_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
       const real_t tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const real_t jac_affine_inv_0_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
       const real_t jac_affine_inv_0_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_2_1_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const real_t jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const real_t jac_affine_inv_1_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t jac_affine_inv_2_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       const real_t tmp_moved_constant_369 = jac_affine_inv_2_0_BLUE_UP*4.0;
       const real_t tmp_moved_constant_370 = jac_affine_inv_0_0_BLUE_UP*4.0;
       const real_t tmp_moved_constant_371 = jac_affine_inv_1_0_BLUE_UP*4.0;
       const real_t tmp_moved_constant_372 = tmp_moved_constant_370 + tmp_moved_constant_371;
       const real_t tmp_moved_constant_373 = tmp_moved_constant_369 + tmp_moved_constant_372;
       const real_t tmp_moved_constant_374 = jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_373 + jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_373 + jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_373;
       const real_t tmp_moved_constant_375 = jac_affine_inv_2_1_BLUE_UP*4.0;
       const real_t tmp_moved_constant_376 = jac_affine_inv_0_1_BLUE_UP*4.0;
       const real_t tmp_moved_constant_377 = jac_affine_inv_1_1_BLUE_UP*4.0;
       const real_t tmp_moved_constant_378 = tmp_moved_constant_376 + tmp_moved_constant_377;
       const real_t tmp_moved_constant_379 = tmp_moved_constant_375 + tmp_moved_constant_378;
       const real_t tmp_moved_constant_380 = jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_379 + jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_379 + jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_379;
       const real_t tmp_moved_constant_381 = jac_affine_inv_2_2_BLUE_UP*4.0;
       const real_t tmp_moved_constant_382 = jac_affine_inv_0_2_BLUE_UP*4.0;
       const real_t tmp_moved_constant_383 = jac_affine_inv_1_2_BLUE_UP*4.0;
       const real_t tmp_moved_constant_384 = tmp_moved_constant_382 + tmp_moved_constant_383;
       const real_t tmp_moved_constant_385 = tmp_moved_constant_381 + tmp_moved_constant_384;
       const real_t tmp_moved_constant_386 = jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_385 + jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_385 + jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_385;
       const real_t tmp_moved_constant_387 = jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_373 + jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_373 + jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_373;
       const real_t tmp_moved_constant_388 = jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_379 + jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_379 + jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_379;
       const real_t tmp_moved_constant_389 = jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_385 + jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_385 + jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_385;
       const real_t tmp_moved_constant_390 = jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_373 + jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_373 + jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_373;
       const real_t tmp_moved_constant_391 = jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_379 + jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_379 + jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_379;
       const real_t tmp_moved_constant_392 = jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_385 + jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_385 + jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_385;
       const real_t tmp_moved_constant_393 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_28 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_28 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_394 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_28 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_28 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_395 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_28 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_28 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_396 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_113 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_113 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_113;
       const real_t tmp_moved_constant_397 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_113 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_113 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_113;
       const real_t tmp_moved_constant_398 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_113 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_113 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_113;
       const real_t tmp_moved_constant_399 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_198 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_198 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_198;
       const real_t tmp_moved_constant_400 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_198 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_198 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_198;
       const real_t tmp_moved_constant_401 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_198 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_198 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_198;
       const real_t tmp_moved_constant_402 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_283 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_283 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_283;
       const real_t tmp_moved_constant_403 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_283 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_283 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_283;
       const real_t tmp_moved_constant_404 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_283 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_283 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_283;
       const real_t tmp_moved_constant_405 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_368 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_368 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_368;
       const real_t tmp_moved_constant_406 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_368 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_368 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_368;
       const real_t tmp_moved_constant_407 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_368 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_368 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_368;
       const real_t tmp_moved_constant_408 = jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_370;
       const real_t tmp_moved_constant_409 = jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_370;
       const real_t tmp_moved_constant_410 = (jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*4.0;
       const real_t tmp_moved_constant_411 = jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_376;
       const real_t tmp_moved_constant_412 = (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*4.0;
       const real_t tmp_moved_constant_413 = (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*4.0;
       const real_t tmp_moved_constant_414 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_455;
       const real_t tmp_moved_constant_415 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_455;
       const real_t tmp_moved_constant_416 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_455;
       const real_t tmp_moved_constant_417 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_460;
       const real_t tmp_moved_constant_418 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_460;
       const real_t tmp_moved_constant_419 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_460;
       const real_t tmp_moved_constant_420 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_465;
       const real_t tmp_moved_constant_421 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_465;
       const real_t tmp_moved_constant_422 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_465;
       const real_t tmp_moved_constant_423 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_470;
       const real_t tmp_moved_constant_424 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_470;
       const real_t tmp_moved_constant_425 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_470;
       const real_t tmp_moved_constant_426 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_475;
       const real_t tmp_moved_constant_427 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_475;
       const real_t tmp_moved_constant_428 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_475;
       const real_t tmp_moved_constant_429 = jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_371;
       const real_t tmp_moved_constant_430 = jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_371;
       const real_t tmp_moved_constant_431 = (jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*4.0;
       const real_t tmp_moved_constant_432 = jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_377;
       const real_t tmp_moved_constant_433 = (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*4.0;
       const real_t tmp_moved_constant_434 = (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*4.0;
       const real_t tmp_moved_constant_435 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_486;
       const real_t tmp_moved_constant_436 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_486;
       const real_t tmp_moved_constant_437 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_486;
       const real_t tmp_moved_constant_438 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_491;
       const real_t tmp_moved_constant_439 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_491;
       const real_t tmp_moved_constant_440 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_491;
       const real_t tmp_moved_constant_441 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_496;
       const real_t tmp_moved_constant_442 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_496;
       const real_t tmp_moved_constant_443 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_496;
       const real_t tmp_moved_constant_444 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_501;
       const real_t tmp_moved_constant_445 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_501;
       const real_t tmp_moved_constant_446 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_501;
       const real_t tmp_moved_constant_447 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_506;
       const real_t tmp_moved_constant_448 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_506;
       const real_t tmp_moved_constant_449 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_506;
       const real_t tmp_moved_constant_450 = jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_369;
       const real_t tmp_moved_constant_451 = jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_369;
       const real_t tmp_moved_constant_452 = (jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*4.0;
       const real_t tmp_moved_constant_453 = jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_375;
       const real_t tmp_moved_constant_454 = (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*4.0;
       const real_t tmp_moved_constant_455 = (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*4.0;
       const real_t tmp_moved_constant_456 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_517;
       const real_t tmp_moved_constant_457 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_517;
       const real_t tmp_moved_constant_458 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_517;
       const real_t tmp_moved_constant_459 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_522;
       const real_t tmp_moved_constant_460 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_522;
       const real_t tmp_moved_constant_461 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_522;
       const real_t tmp_moved_constant_462 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_527;
       const real_t tmp_moved_constant_463 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_527;
       const real_t tmp_moved_constant_464 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_527;
       const real_t tmp_moved_constant_465 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_532;
       const real_t tmp_moved_constant_466 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_532;
       const real_t tmp_moved_constant_467 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_532;
       const real_t tmp_moved_constant_468 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_537;
       const real_t tmp_moved_constant_469 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_537;
       const real_t tmp_moved_constant_470 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_537;
       const real_t tmp_moved_constant_471 = jac_affine_inv_2_0_BLUE_UP*8.0;
       const real_t tmp_moved_constant_472 = jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_471;
       const real_t tmp_moved_constant_473 = jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_371;
       const real_t tmp_moved_constant_474 = jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_369;
       const real_t tmp_moved_constant_475 = tmp_moved_constant_473 + tmp_moved_constant_474;
       const real_t tmp_moved_constant_476 = jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_371;
       const real_t tmp_moved_constant_477 = jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_369;
       const real_t tmp_moved_constant_478 = tmp_moved_constant_476 + tmp_moved_constant_477;
       const real_t tmp_moved_constant_479 = jac_affine_inv_2_1_BLUE_UP*8.0;
       const real_t tmp_moved_constant_480 = jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_479;
       const real_t tmp_moved_constant_481 = jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_377;
       const real_t tmp_moved_constant_482 = jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_375;
       const real_t tmp_moved_constant_483 = tmp_moved_constant_481 + tmp_moved_constant_482;
       const real_t tmp_moved_constant_484 = jac_affine_inv_2_2_BLUE_UP*8.0;
       const real_t tmp_moved_constant_485 = jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_484;
       const real_t tmp_moved_constant_486 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_24;
       const real_t tmp_moved_constant_487 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_488 = tmp_moved_constant_486 + tmp_moved_constant_487;
       const real_t tmp_moved_constant_489 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_24;
       const real_t tmp_moved_constant_490 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_491 = tmp_moved_constant_489 + tmp_moved_constant_490;
       const real_t tmp_moved_constant_492 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_24;
       const real_t tmp_moved_constant_493 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_494 = tmp_moved_constant_492 + tmp_moved_constant_493;
       const real_t tmp_moved_constant_495 = tmp_moved_constant_371*0.5;
       const real_t tmp_moved_constant_496 = tmp_moved_constant_369*0.16666666666666666;
       const real_t tmp_moved_constant_497 = tmp_moved_constant_495 + tmp_moved_constant_496;
       const real_t tmp_moved_constant_498 = tmp_moved_constant_377*0.5;
       const real_t tmp_moved_constant_499 = tmp_moved_constant_375*0.16666666666666666;
       const real_t tmp_moved_constant_500 = tmp_moved_constant_498 + tmp_moved_constant_499;
       const real_t tmp_moved_constant_501 = tmp_moved_constant_383*0.5;
       const real_t tmp_moved_constant_502 = tmp_moved_constant_381*0.16666666666666666;
       const real_t tmp_moved_constant_503 = tmp_moved_constant_501 + tmp_moved_constant_502;
       const real_t tmp_moved_constant_504 = tmp_moved_constant_371*0.16666666666666666;
       const real_t tmp_moved_constant_505 = tmp_moved_constant_369*0.5;
       const real_t tmp_moved_constant_506 = tmp_moved_constant_504 + tmp_moved_constant_505;
       const real_t tmp_moved_constant_507 = tmp_moved_constant_377*0.16666666666666666;
       const real_t tmp_moved_constant_508 = tmp_moved_constant_375*0.5;
       const real_t tmp_moved_constant_509 = tmp_moved_constant_507 + tmp_moved_constant_508;
       const real_t tmp_moved_constant_510 = tmp_moved_constant_383*0.16666666666666666;
       const real_t tmp_moved_constant_511 = tmp_moved_constant_381*0.5;
       const real_t tmp_moved_constant_512 = tmp_moved_constant_510 + tmp_moved_constant_511;
       const real_t tmp_moved_constant_513 = tmp_moved_constant_371*0.16666666666666666;
       const real_t tmp_moved_constant_514 = tmp_moved_constant_369*0.16666666666666666;
       const real_t tmp_moved_constant_515 = tmp_moved_constant_513 + tmp_moved_constant_514;
       const real_t tmp_moved_constant_516 = tmp_moved_constant_377*0.16666666666666666;
       const real_t tmp_moved_constant_517 = tmp_moved_constant_375*0.16666666666666666;
       const real_t tmp_moved_constant_518 = tmp_moved_constant_516 + tmp_moved_constant_517;
       const real_t tmp_moved_constant_519 = tmp_moved_constant_383*0.16666666666666666;
       const real_t tmp_moved_constant_520 = tmp_moved_constant_381*0.16666666666666666;
       const real_t tmp_moved_constant_521 = tmp_moved_constant_519 + tmp_moved_constant_520;
       const real_t tmp_moved_constant_522 = tmp_moved_constant_371*0.16666666666666666;
       const real_t tmp_moved_constant_523 = tmp_moved_constant_369*0.16666666666666666;
       const real_t tmp_moved_constant_524 = tmp_moved_constant_522 + tmp_moved_constant_523;
       const real_t tmp_moved_constant_525 = tmp_moved_constant_377*0.16666666666666666;
       const real_t tmp_moved_constant_526 = tmp_moved_constant_375*0.16666666666666666;
       const real_t tmp_moved_constant_527 = tmp_moved_constant_525 + tmp_moved_constant_526;
       const real_t tmp_moved_constant_528 = tmp_moved_constant_383*0.16666666666666666;
       const real_t tmp_moved_constant_529 = tmp_moved_constant_381*0.16666666666666666;
       const real_t tmp_moved_constant_530 = tmp_moved_constant_528 + tmp_moved_constant_529;
       const real_t tmp_moved_constant_531 = jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_471;
       const real_t tmp_moved_constant_532 = jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_370;
       const real_t tmp_moved_constant_533 = jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_369;
       const real_t tmp_moved_constant_534 = tmp_moved_constant_532 + tmp_moved_constant_533;
       const real_t tmp_moved_constant_535 = jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_370;
       const real_t tmp_moved_constant_536 = jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_369;
       const real_t tmp_moved_constant_537 = tmp_moved_constant_535 + tmp_moved_constant_536;
       const real_t tmp_moved_constant_538 = jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_479;
       const real_t tmp_moved_constant_539 = jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_376;
       const real_t tmp_moved_constant_540 = jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_375;
       const real_t tmp_moved_constant_541 = tmp_moved_constant_539 + tmp_moved_constant_540;
       const real_t tmp_moved_constant_542 = jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_484;
       const real_t tmp_moved_constant_543 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_24;
       const real_t tmp_moved_constant_544 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_25;
       const real_t tmp_moved_constant_545 = tmp_moved_constant_543 + tmp_moved_constant_544;
       const real_t tmp_moved_constant_546 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_24;
       const real_t tmp_moved_constant_547 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_25;
       const real_t tmp_moved_constant_548 = tmp_moved_constant_546 + tmp_moved_constant_547;
       const real_t tmp_moved_constant_549 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_24;
       const real_t tmp_moved_constant_550 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_25;
       const real_t tmp_moved_constant_551 = tmp_moved_constant_549 + tmp_moved_constant_550;
       const real_t tmp_moved_constant_552 = tmp_moved_constant_370*0.5;
       const real_t tmp_moved_constant_553 = tmp_moved_constant_369*0.16666666666666666;
       const real_t tmp_moved_constant_554 = tmp_moved_constant_552 + tmp_moved_constant_553;
       const real_t tmp_moved_constant_555 = tmp_moved_constant_376*0.5;
       const real_t tmp_moved_constant_556 = tmp_moved_constant_375*0.16666666666666666;
       const real_t tmp_moved_constant_557 = tmp_moved_constant_555 + tmp_moved_constant_556;
       const real_t tmp_moved_constant_558 = tmp_moved_constant_382*0.5;
       const real_t tmp_moved_constant_559 = tmp_moved_constant_381*0.16666666666666666;
       const real_t tmp_moved_constant_560 = tmp_moved_constant_558 + tmp_moved_constant_559;
       const real_t tmp_moved_constant_561 = tmp_moved_constant_370*0.16666666666666666;
       const real_t tmp_moved_constant_562 = tmp_moved_constant_369*0.16666666666666666;
       const real_t tmp_moved_constant_563 = tmp_moved_constant_561 + tmp_moved_constant_562;
       const real_t tmp_moved_constant_564 = tmp_moved_constant_376*0.16666666666666666;
       const real_t tmp_moved_constant_565 = tmp_moved_constant_375*0.16666666666666666;
       const real_t tmp_moved_constant_566 = tmp_moved_constant_564 + tmp_moved_constant_565;
       const real_t tmp_moved_constant_567 = tmp_moved_constant_382*0.16666666666666666;
       const real_t tmp_moved_constant_568 = tmp_moved_constant_381*0.16666666666666666;
       const real_t tmp_moved_constant_569 = tmp_moved_constant_567 + tmp_moved_constant_568;
       const real_t tmp_moved_constant_570 = tmp_moved_constant_370*0.16666666666666666;
       const real_t tmp_moved_constant_571 = tmp_moved_constant_369*0.5;
       const real_t tmp_moved_constant_572 = tmp_moved_constant_570 + tmp_moved_constant_571;
       const real_t tmp_moved_constant_573 = tmp_moved_constant_376*0.16666666666666666;
       const real_t tmp_moved_constant_574 = tmp_moved_constant_375*0.5;
       const real_t tmp_moved_constant_575 = tmp_moved_constant_573 + tmp_moved_constant_574;
       const real_t tmp_moved_constant_576 = tmp_moved_constant_382*0.16666666666666666;
       const real_t tmp_moved_constant_577 = tmp_moved_constant_381*0.5;
       const real_t tmp_moved_constant_578 = tmp_moved_constant_576 + tmp_moved_constant_577;
       const real_t tmp_moved_constant_579 = tmp_moved_constant_370*0.16666666666666666;
       const real_t tmp_moved_constant_580 = tmp_moved_constant_369*0.16666666666666666;
       const real_t tmp_moved_constant_581 = tmp_moved_constant_579 + tmp_moved_constant_580;
       const real_t tmp_moved_constant_582 = tmp_moved_constant_376*0.16666666666666666;
       const real_t tmp_moved_constant_583 = tmp_moved_constant_375*0.16666666666666666;
       const real_t tmp_moved_constant_584 = tmp_moved_constant_582 + tmp_moved_constant_583;
       const real_t tmp_moved_constant_585 = tmp_moved_constant_382*0.16666666666666666;
       const real_t tmp_moved_constant_586 = tmp_moved_constant_381*0.16666666666666666;
       const real_t tmp_moved_constant_587 = tmp_moved_constant_585 + tmp_moved_constant_586;
       const real_t tmp_moved_constant_588 = jac_affine_inv_1_0_BLUE_UP*8.0;
       const real_t tmp_moved_constant_589 = jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_588;
       const real_t tmp_moved_constant_590 = jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_370;
       const real_t tmp_moved_constant_591 = jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_371;
       const real_t tmp_moved_constant_592 = tmp_moved_constant_590 + tmp_moved_constant_591;
       const real_t tmp_moved_constant_593 = jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_370;
       const real_t tmp_moved_constant_594 = jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_371;
       const real_t tmp_moved_constant_595 = tmp_moved_constant_593 + tmp_moved_constant_594;
       const real_t tmp_moved_constant_596 = jac_affine_inv_1_1_BLUE_UP*8.0;
       const real_t tmp_moved_constant_597 = jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_596;
       const real_t tmp_moved_constant_598 = jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_376;
       const real_t tmp_moved_constant_599 = jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_377;
       const real_t tmp_moved_constant_600 = tmp_moved_constant_598 + tmp_moved_constant_599;
       const real_t tmp_moved_constant_601 = jac_affine_inv_1_2_BLUE_UP*8.0;
       const real_t tmp_moved_constant_602 = jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_601;
       const real_t tmp_moved_constant_603 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_604 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_25;
       const real_t tmp_moved_constant_605 = tmp_moved_constant_603 + tmp_moved_constant_604;
       const real_t tmp_moved_constant_606 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_607 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_25;
       const real_t tmp_moved_constant_608 = tmp_moved_constant_606 + tmp_moved_constant_607;
       const real_t tmp_moved_constant_609 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_610 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_25;
       const real_t tmp_moved_constant_611 = tmp_moved_constant_609 + tmp_moved_constant_610;
       const real_t tmp_moved_constant_612 = tmp_moved_constant_370*0.16666666666666666;
       const real_t tmp_moved_constant_613 = tmp_moved_constant_371*0.16666666666666666;
       const real_t tmp_moved_constant_614 = tmp_moved_constant_612 + tmp_moved_constant_613;
       const real_t tmp_moved_constant_615 = tmp_moved_constant_376*0.16666666666666666;
       const real_t tmp_moved_constant_616 = tmp_moved_constant_377*0.16666666666666666;
       const real_t tmp_moved_constant_617 = tmp_moved_constant_615 + tmp_moved_constant_616;
       const real_t tmp_moved_constant_618 = tmp_moved_constant_382*0.16666666666666666;
       const real_t tmp_moved_constant_619 = tmp_moved_constant_383*0.16666666666666666;
       const real_t tmp_moved_constant_620 = tmp_moved_constant_618 + tmp_moved_constant_619;
       const real_t tmp_moved_constant_621 = tmp_moved_constant_370*0.5;
       const real_t tmp_moved_constant_622 = tmp_moved_constant_371*0.16666666666666666;
       const real_t tmp_moved_constant_623 = tmp_moved_constant_621 + tmp_moved_constant_622;
       const real_t tmp_moved_constant_624 = tmp_moved_constant_376*0.5;
       const real_t tmp_moved_constant_625 = tmp_moved_constant_377*0.16666666666666666;
       const real_t tmp_moved_constant_626 = tmp_moved_constant_624 + tmp_moved_constant_625;
       const real_t tmp_moved_constant_627 = tmp_moved_constant_382*0.5;
       const real_t tmp_moved_constant_628 = tmp_moved_constant_383*0.16666666666666666;
       const real_t tmp_moved_constant_629 = tmp_moved_constant_627 + tmp_moved_constant_628;
       const real_t tmp_moved_constant_630 = tmp_moved_constant_370*0.16666666666666666;
       const real_t tmp_moved_constant_631 = tmp_moved_constant_371*0.5;
       const real_t tmp_moved_constant_632 = tmp_moved_constant_630 + tmp_moved_constant_631;
       const real_t tmp_moved_constant_633 = tmp_moved_constant_376*0.16666666666666666;
       const real_t tmp_moved_constant_634 = tmp_moved_constant_377*0.5;
       const real_t tmp_moved_constant_635 = tmp_moved_constant_633 + tmp_moved_constant_634;
       const real_t tmp_moved_constant_636 = tmp_moved_constant_382*0.16666666666666666;
       const real_t tmp_moved_constant_637 = tmp_moved_constant_383*0.5;
       const real_t tmp_moved_constant_638 = tmp_moved_constant_636 + tmp_moved_constant_637;
       const real_t tmp_moved_constant_639 = tmp_moved_constant_370*0.16666666666666666;
       const real_t tmp_moved_constant_640 = tmp_moved_constant_371*0.16666666666666666;
       const real_t tmp_moved_constant_641 = tmp_moved_constant_639 + tmp_moved_constant_640;
       const real_t tmp_moved_constant_642 = tmp_moved_constant_376*0.16666666666666666;
       const real_t tmp_moved_constant_643 = tmp_moved_constant_377*0.16666666666666666;
       const real_t tmp_moved_constant_644 = tmp_moved_constant_642 + tmp_moved_constant_643;
       const real_t tmp_moved_constant_645 = tmp_moved_constant_382*0.16666666666666666;
       const real_t tmp_moved_constant_646 = tmp_moved_constant_383*0.16666666666666666;
       const real_t tmp_moved_constant_647 = tmp_moved_constant_645 + tmp_moved_constant_646;
       const real_t tmp_moved_constant_648 = jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_370;
       const real_t tmp_moved_constant_649 = jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_371;
       const real_t tmp_moved_constant_650 = -tmp_moved_constant_372 - tmp_moved_constant_471;
       const real_t tmp_moved_constant_651 = jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_650 - tmp_moved_constant_648 - tmp_moved_constant_649;
       const real_t tmp_moved_constant_652 = -tmp_moved_constant_378 - tmp_moved_constant_479;
       const real_t tmp_moved_constant_653 = jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_652 - tmp_moved_constant_473 - tmp_moved_constant_532;
       const real_t tmp_moved_constant_654 = -tmp_moved_constant_384 - tmp_moved_constant_484;
       const real_t tmp_moved_constant_655 = jac_affine_inv_2_0_BLUE_UP*tmp_moved_constant_654 - tmp_moved_constant_476 - tmp_moved_constant_535;
       const real_t tmp_moved_constant_656 = jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_650 - tmp_moved_constant_474 - tmp_moved_constant_533;
       const real_t tmp_moved_constant_657 = jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_376;
       const real_t tmp_moved_constant_658 = jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_377;
       const real_t tmp_moved_constant_659 = jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_652 - tmp_moved_constant_657 - tmp_moved_constant_658;
       const real_t tmp_moved_constant_660 = jac_affine_inv_2_1_BLUE_UP*tmp_moved_constant_654 - tmp_moved_constant_481 - tmp_moved_constant_539;
       const real_t tmp_moved_constant_661 = jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_650 - tmp_moved_constant_477 - tmp_moved_constant_536;
       const real_t tmp_moved_constant_662 = jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_652 - tmp_moved_constant_482 - tmp_moved_constant_540;
       const real_t tmp_moved_constant_663 = jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_382;
       const real_t tmp_moved_constant_664 = jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_383;
       const real_t tmp_moved_constant_665 = jac_affine_inv_2_2_BLUE_UP*tmp_moved_constant_654 - tmp_moved_constant_663 - tmp_moved_constant_664;
       const real_t tmp_moved_constant_666 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_752 - tmp_moved_constant_486 - tmp_moved_constant_543;
       const real_t tmp_moved_constant_667 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_752 - tmp_moved_constant_489 - tmp_moved_constant_546;
       const real_t tmp_moved_constant_668 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_752 - tmp_moved_constant_492 - tmp_moved_constant_549;
       const real_t tmp_moved_constant_669 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_757 - tmp_moved_constant_495 - tmp_moved_constant_552;
       const real_t tmp_moved_constant_670 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_757 - tmp_moved_constant_498 - tmp_moved_constant_555;
       const real_t tmp_moved_constant_671 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_757 - tmp_moved_constant_501 - tmp_moved_constant_558;
       const real_t tmp_moved_constant_672 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_762 - tmp_moved_constant_504 - tmp_moved_constant_561;
       const real_t tmp_moved_constant_673 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_762 - tmp_moved_constant_507 - tmp_moved_constant_564;
       const real_t tmp_moved_constant_674 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_762 - tmp_moved_constant_510 - tmp_moved_constant_567;
       const real_t tmp_moved_constant_675 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_767 - tmp_moved_constant_513 - tmp_moved_constant_570;
       const real_t tmp_moved_constant_676 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_767 - tmp_moved_constant_516 - tmp_moved_constant_573;
       const real_t tmp_moved_constant_677 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_767 - tmp_moved_constant_519 - tmp_moved_constant_576;
       const real_t tmp_moved_constant_678 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_772 - tmp_moved_constant_522 - tmp_moved_constant_579;
       const real_t tmp_moved_constant_679 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_772 - tmp_moved_constant_525 - tmp_moved_constant_582;
       const real_t tmp_moved_constant_680 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_772 - tmp_moved_constant_528 - tmp_moved_constant_585;
       const real_t tmp_moved_constant_681 = jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_370;
       const real_t tmp_moved_constant_682 = -tmp_moved_constant_369 - tmp_moved_constant_370 - tmp_moved_constant_588;
       const real_t tmp_moved_constant_683 = jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_682 - tmp_moved_constant_649 - tmp_moved_constant_681;
       const real_t tmp_moved_constant_684 = -tmp_moved_constant_375 - tmp_moved_constant_376 - tmp_moved_constant_596;
       const real_t tmp_moved_constant_685 = jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_684 - tmp_moved_constant_474 - tmp_moved_constant_590;
       const real_t tmp_moved_constant_686 = -tmp_moved_constant_381 - tmp_moved_constant_382 - tmp_moved_constant_601;
       const real_t tmp_moved_constant_687 = jac_affine_inv_1_0_BLUE_UP*tmp_moved_constant_686 - tmp_moved_constant_477 - tmp_moved_constant_593;
       const real_t tmp_moved_constant_688 = jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_682 - tmp_moved_constant_473 - tmp_moved_constant_591;
       const real_t tmp_moved_constant_689 = jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_376;
       const real_t tmp_moved_constant_690 = jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_684 - tmp_moved_constant_658 - tmp_moved_constant_689;
       const real_t tmp_moved_constant_691 = jac_affine_inv_1_1_BLUE_UP*tmp_moved_constant_686 - tmp_moved_constant_482 - tmp_moved_constant_598;
       const real_t tmp_moved_constant_692 = jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_682 - tmp_moved_constant_476 - tmp_moved_constant_594;
       const real_t tmp_moved_constant_693 = jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_684 - tmp_moved_constant_481 - tmp_moved_constant_599;
       const real_t tmp_moved_constant_694 = jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_382;
       const real_t tmp_moved_constant_695 = jac_affine_inv_1_2_BLUE_UP*tmp_moved_constant_686 - tmp_moved_constant_664 - tmp_moved_constant_694;
       const real_t tmp_moved_constant_696 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_793 - tmp_moved_constant_487 - tmp_moved_constant_603;
       const real_t tmp_moved_constant_697 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_793 - tmp_moved_constant_490 - tmp_moved_constant_606;
       const real_t tmp_moved_constant_698 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_793 - tmp_moved_constant_493 - tmp_moved_constant_609;
       const real_t tmp_moved_constant_699 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_799 - tmp_moved_constant_496 - tmp_moved_constant_612;
       const real_t tmp_moved_constant_700 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_799 - tmp_moved_constant_499 - tmp_moved_constant_615;
       const real_t tmp_moved_constant_701 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_799 - tmp_moved_constant_502 - tmp_moved_constant_618;
       const real_t tmp_moved_constant_702 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_805 - tmp_moved_constant_505 - tmp_moved_constant_621;
       const real_t tmp_moved_constant_703 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_805 - tmp_moved_constant_508 - tmp_moved_constant_624;
       const real_t tmp_moved_constant_704 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_805 - tmp_moved_constant_511 - tmp_moved_constant_627;
       const real_t tmp_moved_constant_705 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_811 - tmp_moved_constant_514 - tmp_moved_constant_630;
       const real_t tmp_moved_constant_706 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_811 - tmp_moved_constant_517 - tmp_moved_constant_633;
       const real_t tmp_moved_constant_707 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_811 - tmp_moved_constant_520 - tmp_moved_constant_636;
       const real_t tmp_moved_constant_708 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_817 - tmp_moved_constant_523 - tmp_moved_constant_639;
       const real_t tmp_moved_constant_709 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_817 - tmp_moved_constant_526 - tmp_moved_constant_642;
       const real_t tmp_moved_constant_710 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_817 - tmp_moved_constant_529 - tmp_moved_constant_645;
       const real_t tmp_moved_constant_711 = jac_affine_inv_0_0_BLUE_UP*-8.0 - tmp_moved_constant_369 - tmp_moved_constant_371;
       const real_t tmp_moved_constant_712 = jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_711 - tmp_moved_constant_648 - tmp_moved_constant_681;
       const real_t tmp_moved_constant_713 = jac_affine_inv_0_1_BLUE_UP*-8.0 - tmp_moved_constant_375 - tmp_moved_constant_377;
       const real_t tmp_moved_constant_714 = jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_713 - tmp_moved_constant_533 - tmp_moved_constant_591;
       const real_t tmp_moved_constant_715 = jac_affine_inv_0_2_BLUE_UP*-8.0 - tmp_moved_constant_381 - tmp_moved_constant_383;
       const real_t tmp_moved_constant_716 = jac_affine_inv_0_0_BLUE_UP*tmp_moved_constant_715 - tmp_moved_constant_536 - tmp_moved_constant_594;
       const real_t tmp_moved_constant_717 = jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_711 - tmp_moved_constant_532 - tmp_moved_constant_590;
       const real_t tmp_moved_constant_718 = jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_713 - tmp_moved_constant_657 - tmp_moved_constant_689;
       const real_t tmp_moved_constant_719 = jac_affine_inv_0_1_BLUE_UP*tmp_moved_constant_715 - tmp_moved_constant_540 - tmp_moved_constant_599;
       const real_t tmp_moved_constant_720 = jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_711 - tmp_moved_constant_535 - tmp_moved_constant_593;
       const real_t tmp_moved_constant_721 = jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_713 - tmp_moved_constant_539 - tmp_moved_constant_598;
       const real_t tmp_moved_constant_722 = jac_affine_inv_0_2_BLUE_UP*tmp_moved_constant_715 - tmp_moved_constant_663 - tmp_moved_constant_694;
       const real_t tmp_moved_constant_723 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_834 - tmp_moved_constant_544 - tmp_moved_constant_604;
       const real_t tmp_moved_constant_724 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_834 - tmp_moved_constant_547 - tmp_moved_constant_607;
       const real_t tmp_moved_constant_725 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_834 - tmp_moved_constant_550 - tmp_moved_constant_610;
       const real_t tmp_moved_constant_726 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_839 - tmp_moved_constant_553 - tmp_moved_constant_613;
       const real_t tmp_moved_constant_727 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_839 - tmp_moved_constant_556 - tmp_moved_constant_616;
       const real_t tmp_moved_constant_728 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_839 - tmp_moved_constant_559 - tmp_moved_constant_619;
       const real_t tmp_moved_constant_729 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_844 - tmp_moved_constant_562 - tmp_moved_constant_622;
       const real_t tmp_moved_constant_730 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_844 - tmp_moved_constant_565 - tmp_moved_constant_625;
       const real_t tmp_moved_constant_731 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_844 - tmp_moved_constant_568 - tmp_moved_constant_628;
       const real_t tmp_moved_constant_732 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_849 - tmp_moved_constant_571 - tmp_moved_constant_631;
       const real_t tmp_moved_constant_733 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_849 - tmp_moved_constant_574 - tmp_moved_constant_634;
       const real_t tmp_moved_constant_734 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_849 - tmp_moved_constant_577 - tmp_moved_constant_637;
       const real_t tmp_moved_constant_735 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_854 - tmp_moved_constant_580 - tmp_moved_constant_640;
       const real_t tmp_moved_constant_736 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_854 - tmp_moved_constant_583 - tmp_moved_constant_643;
       const real_t tmp_moved_constant_737 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_854 - tmp_moved_constant_586 - tmp_moved_constant_646;
       {
          /* CellType.BLUE_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
             const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
             const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
             const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
             const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
             const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
             const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
             const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
             const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
             const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
             const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
             const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
             const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
             const real_t tmp_blending_op_35 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_36 = tmp_blending_op_22 - tmp_blending_op_35;
             const real_t tmp_blending_op_37 = -tmp_blending_op_36;
             const real_t tmp_blending_op_38 = (tmp_blending_op_28*tmp_blending_op_28);
             const real_t tmp_blending_op_39 = (tmp_blending_op_33*tmp_blending_op_33);
             const real_t tmp_blending_op_40 = tmp_blending_op_38 + tmp_blending_op_39 + tmp_blending_op_4;
             const real_t tmp_blending_op_43 = tmp_blending_op_3*tmp_blending_op_42;
             const real_t tmp_blending_op_44 = tmp_blending_op_36 + tmp_blending_op_43;
             const real_t tmp_blending_op_45 = tmp_blending_op_37*tmp_blending_op_4 + tmp_blending_op_40*tmp_blending_op_44;
             const real_t tmp_blending_op_46 = pow(tmp_blending_op_40, -1.5000000000000000);
             const real_t tmp_blending_op_49 = tmp_blending_op_46*tmp_blending_op_48;
             const real_t tmp_blending_op_52 = tmp_blending_op_40*tmp_blending_op_51;
             const real_t tmp_blending_op_53 = -tmp_blending_op_33*tmp_blending_op_36 - tmp_blending_op_52;
             const real_t tmp_blending_op_54 = tmp_blending_op_49*tmp_blending_op_53;
             const real_t tmp_blending_op_57 = tmp_blending_op_28*tmp_blending_op_37 + tmp_blending_op_40*tmp_blending_op_56;
             const real_t tmp_blending_op_58 = tmp_blending_op_49*tmp_blending_op_57;
             const real_t tmp_blending_op_59 = tmp_blending_op_3*tmp_blending_op_37;
             const real_t tmp_blending_op_60 = tmp_blending_op_40*tmp_blending_op_42 + tmp_blending_op_59;
             const real_t tmp_blending_op_61 = tmp_blending_op_49*tmp_blending_op_60;
             const real_t tmp_blending_op_63 = tmp_blending_op_33*tmp_blending_op_62 + tmp_blending_op_36;
             const real_t tmp_blending_op_64 = tmp_blending_op_37*tmp_blending_op_39 + tmp_blending_op_40*tmp_blending_op_63;
             const real_t tmp_blending_op_65 = tmp_blending_op_28*tmp_blending_op_56;
             const real_t tmp_blending_op_66 = tmp_blending_op_36 + tmp_blending_op_65;
             const real_t tmp_blending_op_67 = -tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_40*tmp_blending_op_66;
             const real_t tmp_blending_op_75 = p_affine_0_2 + tmp_blending_op_0*0.5 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_76 = (tmp_blending_op_75*tmp_blending_op_75);
             const real_t tmp_blending_op_77 = -tmp_blending_op_17 - tmp_blending_op_75;
             const real_t tmp_blending_op_78 = p_affine_0_0 + tmp_blending_op_25*0.5 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_79 = -tmp_blending_op_6 - tmp_blending_op_78;
             const real_t tmp_blending_op_80 = p_affine_0_1 + tmp_blending_op_30*0.5 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_81 = -tmp_blending_op_13 - tmp_blending_op_80;
             const real_t tmp_blending_op_82 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_79 - tmp_blending_op_12*tmp_blending_op_77 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_77 - tmp_blending_op_19*tmp_blending_op_79 - tmp_blending_op_20*tmp_blending_op_81 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_81);
             const real_t tmp_blending_op_83 = tmp_blending_op_22 - tmp_blending_op_82;
             const real_t tmp_blending_op_84 = -tmp_blending_op_83;
             const real_t tmp_blending_op_85 = (tmp_blending_op_78*tmp_blending_op_78);
             const real_t tmp_blending_op_86 = (tmp_blending_op_80*tmp_blending_op_80);
             const real_t tmp_blending_op_87 = tmp_blending_op_76 + tmp_blending_op_85 + tmp_blending_op_86;
             const real_t tmp_blending_op_88 = tmp_blending_op_42*tmp_blending_op_75;
             const real_t tmp_blending_op_89 = tmp_blending_op_83 + tmp_blending_op_88;
             const real_t tmp_blending_op_90 = tmp_blending_op_76*tmp_blending_op_84 + tmp_blending_op_87*tmp_blending_op_89;
             const real_t tmp_blending_op_91 = pow(tmp_blending_op_87, -1.5000000000000000);
             const real_t tmp_blending_op_92 = tmp_blending_op_48*tmp_blending_op_91;
             const real_t tmp_blending_op_93 = tmp_blending_op_51*tmp_blending_op_87;
             const real_t tmp_blending_op_94 = -tmp_blending_op_80*tmp_blending_op_83 - tmp_blending_op_93;
             const real_t tmp_blending_op_95 = tmp_blending_op_92*tmp_blending_op_94;
             const real_t tmp_blending_op_96 = tmp_blending_op_56*tmp_blending_op_87 + tmp_blending_op_78*tmp_blending_op_84;
             const real_t tmp_blending_op_97 = tmp_blending_op_92*tmp_blending_op_96;
             const real_t tmp_blending_op_98 = tmp_blending_op_75*tmp_blending_op_84;
             const real_t tmp_blending_op_99 = tmp_blending_op_42*tmp_blending_op_87 + tmp_blending_op_98;
             const real_t tmp_blending_op_100 = tmp_blending_op_92*tmp_blending_op_99;
             const real_t tmp_blending_op_101 = tmp_blending_op_62*tmp_blending_op_80 + tmp_blending_op_83;
             const real_t tmp_blending_op_102 = tmp_blending_op_101*tmp_blending_op_87 + tmp_blending_op_84*tmp_blending_op_86;
             const real_t tmp_blending_op_103 = tmp_blending_op_56*tmp_blending_op_78;
             const real_t tmp_blending_op_104 = tmp_blending_op_103 + tmp_blending_op_83;
             const real_t tmp_blending_op_105 = tmp_blending_op_104*tmp_blending_op_87 - tmp_blending_op_83*tmp_blending_op_85;
             const real_t tmp_blending_op_113 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.5 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_114 = (tmp_blending_op_113*tmp_blending_op_113);
             const real_t tmp_blending_op_115 = -tmp_blending_op_113 - tmp_blending_op_17;
             const real_t tmp_blending_op_116 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.5 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_117 = -tmp_blending_op_116 - tmp_blending_op_6;
             const real_t tmp_blending_op_118 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.5 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_119 = -tmp_blending_op_118 - tmp_blending_op_13;
             const real_t tmp_blending_op_120 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_117*tmp_blending_op_18 - tmp_blending_op_115*tmp_blending_op_12 + tmp_blending_op_115*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_117*tmp_blending_op_19 - tmp_blending_op_119*tmp_blending_op_20 + tmp_blending_op_119*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_121 = -tmp_blending_op_120 + tmp_blending_op_22;
             const real_t tmp_blending_op_122 = -tmp_blending_op_121;
             const real_t tmp_blending_op_123 = (tmp_blending_op_116*tmp_blending_op_116);
             const real_t tmp_blending_op_124 = (tmp_blending_op_118*tmp_blending_op_118);
             const real_t tmp_blending_op_125 = tmp_blending_op_114 + tmp_blending_op_123 + tmp_blending_op_124;
             const real_t tmp_blending_op_126 = tmp_blending_op_113*tmp_blending_op_42;
             const real_t tmp_blending_op_127 = tmp_blending_op_121 + tmp_blending_op_126;
             const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_127;
             const real_t tmp_blending_op_129 = pow(tmp_blending_op_125, -1.5000000000000000);
             const real_t tmp_blending_op_130 = tmp_blending_op_129*tmp_blending_op_48;
             const real_t tmp_blending_op_131 = tmp_blending_op_125*tmp_blending_op_51;
             const real_t tmp_blending_op_132 = -tmp_blending_op_118*tmp_blending_op_121 - tmp_blending_op_131;
             const real_t tmp_blending_op_133 = tmp_blending_op_130*tmp_blending_op_132;
             const real_t tmp_blending_op_134 = tmp_blending_op_116*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_56;
             const real_t tmp_blending_op_135 = tmp_blending_op_130*tmp_blending_op_134;
             const real_t tmp_blending_op_136 = tmp_blending_op_113*tmp_blending_op_122;
             const real_t tmp_blending_op_137 = tmp_blending_op_125*tmp_blending_op_42 + tmp_blending_op_136;
             const real_t tmp_blending_op_138 = tmp_blending_op_130*tmp_blending_op_137;
             const real_t tmp_blending_op_139 = tmp_blending_op_118*tmp_blending_op_62 + tmp_blending_op_121;
             const real_t tmp_blending_op_140 = tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*tmp_blending_op_139;
             const real_t tmp_blending_op_141 = tmp_blending_op_116*tmp_blending_op_56;
             const real_t tmp_blending_op_142 = tmp_blending_op_121 + tmp_blending_op_141;
             const real_t tmp_blending_op_143 = -tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*tmp_blending_op_142;
             const real_t tmp_blending_op_151 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.5;
             const real_t tmp_blending_op_152 = (tmp_blending_op_151*tmp_blending_op_151);
             const real_t tmp_blending_op_153 = -tmp_blending_op_151 - tmp_blending_op_17;
             const real_t tmp_blending_op_154 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.5;
             const real_t tmp_blending_op_155 = -tmp_blending_op_154 - tmp_blending_op_6;
             const real_t tmp_blending_op_156 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.5;
             const real_t tmp_blending_op_157 = -tmp_blending_op_13 - tmp_blending_op_156;
             const real_t tmp_blending_op_158 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_155*tmp_blending_op_18 - tmp_blending_op_12*tmp_blending_op_153 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_153 - tmp_blending_op_155*tmp_blending_op_19 - tmp_blending_op_157*tmp_blending_op_20 + tmp_blending_op_157*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_159 = -tmp_blending_op_158 + tmp_blending_op_22;
             const real_t tmp_blending_op_160 = -tmp_blending_op_159;
             const real_t tmp_blending_op_161 = (tmp_blending_op_154*tmp_blending_op_154);
             const real_t tmp_blending_op_162 = (tmp_blending_op_156*tmp_blending_op_156);
             const real_t tmp_blending_op_163 = tmp_blending_op_152 + tmp_blending_op_161 + tmp_blending_op_162;
             const real_t tmp_blending_op_164 = tmp_blending_op_151*tmp_blending_op_42;
             const real_t tmp_blending_op_165 = tmp_blending_op_159 + tmp_blending_op_164;
             const real_t tmp_blending_op_166 = tmp_blending_op_152*tmp_blending_op_160 + tmp_blending_op_163*tmp_blending_op_165;
             const real_t tmp_blending_op_167 = pow(tmp_blending_op_163, -1.5000000000000000);
             const real_t tmp_blending_op_168 = tmp_blending_op_167*tmp_blending_op_48;
             const real_t tmp_blending_op_169 = tmp_blending_op_163*tmp_blending_op_51;
             const real_t tmp_blending_op_170 = -tmp_blending_op_156*tmp_blending_op_159 - tmp_blending_op_169;
             const real_t tmp_blending_op_171 = tmp_blending_op_168*tmp_blending_op_170;
             const real_t tmp_blending_op_172 = tmp_blending_op_154*tmp_blending_op_160 + tmp_blending_op_163*tmp_blending_op_56;
             const real_t tmp_blending_op_173 = tmp_blending_op_168*tmp_blending_op_172;
             const real_t tmp_blending_op_174 = tmp_blending_op_151*tmp_blending_op_160;
             const real_t tmp_blending_op_175 = tmp_blending_op_163*tmp_blending_op_42 + tmp_blending_op_174;
             const real_t tmp_blending_op_176 = tmp_blending_op_168*tmp_blending_op_175;
             const real_t tmp_blending_op_177 = tmp_blending_op_156*tmp_blending_op_62 + tmp_blending_op_159;
             const real_t tmp_blending_op_178 = tmp_blending_op_160*tmp_blending_op_162 + tmp_blending_op_163*tmp_blending_op_177;
             const real_t tmp_blending_op_179 = tmp_blending_op_154*tmp_blending_op_56;
             const real_t tmp_blending_op_180 = tmp_blending_op_159 + tmp_blending_op_179;
             const real_t tmp_blending_op_181 = -tmp_blending_op_159*tmp_blending_op_161 + tmp_blending_op_163*tmp_blending_op_180;
             const real_t tmp_blending_op_189 = p_affine_0_2 + tmp_blending_op_0*0.25 + tmp_blending_op_1*0.25 + tmp_blending_op_2*0.25;
             const real_t tmp_blending_op_190 = (tmp_blending_op_189*tmp_blending_op_189);
             const real_t tmp_blending_op_191 = -tmp_blending_op_17 - tmp_blending_op_189;
             const real_t tmp_blending_op_192 = p_affine_0_0 + tmp_blending_op_25*0.25 + tmp_blending_op_26*0.25 + tmp_blending_op_27*0.25;
             const real_t tmp_blending_op_193 = -tmp_blending_op_192 - tmp_blending_op_6;
             const real_t tmp_blending_op_194 = p_affine_0_1 + tmp_blending_op_30*0.25 + tmp_blending_op_31*0.25 + tmp_blending_op_32*0.25;
             const real_t tmp_blending_op_195 = -tmp_blending_op_13 - tmp_blending_op_194;
             const real_t tmp_blending_op_196 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_193 - tmp_blending_op_12*tmp_blending_op_191 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_191 - tmp_blending_op_19*tmp_blending_op_193 - tmp_blending_op_195*tmp_blending_op_20 + tmp_blending_op_195*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_197 = -tmp_blending_op_196 + tmp_blending_op_22;
             const real_t tmp_blending_op_198 = -tmp_blending_op_197;
             const real_t tmp_blending_op_199 = (tmp_blending_op_192*tmp_blending_op_192);
             const real_t tmp_blending_op_200 = (tmp_blending_op_194*tmp_blending_op_194);
             const real_t tmp_blending_op_201 = tmp_blending_op_190 + tmp_blending_op_199 + tmp_blending_op_200;
             const real_t tmp_blending_op_202 = tmp_blending_op_189*tmp_blending_op_42;
             const real_t tmp_blending_op_203 = tmp_blending_op_197 + tmp_blending_op_202;
             const real_t tmp_blending_op_204 = tmp_blending_op_190*tmp_blending_op_198 + tmp_blending_op_201*tmp_blending_op_203;
             const real_t tmp_blending_op_205 = pow(tmp_blending_op_201, -1.5000000000000000);
             const real_t tmp_blending_op_206 = tmp_blending_op_205*tmp_blending_op_48;
             const real_t tmp_blending_op_207 = tmp_blending_op_201*tmp_blending_op_51;
             const real_t tmp_blending_op_208 = -tmp_blending_op_194*tmp_blending_op_197 - tmp_blending_op_207;
             const real_t tmp_blending_op_209 = tmp_blending_op_206*tmp_blending_op_208;
             const real_t tmp_blending_op_210 = tmp_blending_op_192*tmp_blending_op_198 + tmp_blending_op_201*tmp_blending_op_56;
             const real_t tmp_blending_op_211 = tmp_blending_op_206*tmp_blending_op_210;
             const real_t tmp_blending_op_212 = tmp_blending_op_189*tmp_blending_op_198;
             const real_t tmp_blending_op_213 = tmp_blending_op_201*tmp_blending_op_42 + tmp_blending_op_212;
             const real_t tmp_blending_op_214 = tmp_blending_op_206*tmp_blending_op_213;
             const real_t tmp_blending_op_215 = tmp_blending_op_194*tmp_blending_op_62 + tmp_blending_op_197;
             const real_t tmp_blending_op_216 = tmp_blending_op_198*tmp_blending_op_200 + tmp_blending_op_201*tmp_blending_op_215;
             const real_t tmp_blending_op_217 = tmp_blending_op_192*tmp_blending_op_56;
             const real_t tmp_blending_op_218 = tmp_blending_op_197 + tmp_blending_op_217;
             const real_t tmp_blending_op_219 = -tmp_blending_op_197*tmp_blending_op_199 + tmp_blending_op_201*tmp_blending_op_218;
             const real_t tmp_blending_op_228 = pow(tmp_blending_op_201, -2.5000000000000000)*tmp_blending_op_227;
             const real_t tmp_blending_op_229 = tmp_blending_op_192*tmp_blending_op_228;
             const real_t tmp_blending_op_232 = tmp_blending_op_192*2.0;
             const real_t tmp_blending_op_234 = tmp_blending_op_196 + tmp_blending_op_233;
             const real_t tmp_blending_op_235 = tmp_blending_op_192*tmp_blending_op_230 + tmp_blending_op_217*2.0 + tmp_blending_op_234;
             const real_t tmp_blending_op_236 = tmp_blending_op_210*tmp_blending_op_229;
             const real_t tmp_blending_op_237 = tmp_blending_op_194*tmp_blending_op_23*tmp_blending_op_55 - tmp_blending_op_232*tmp_blending_op_51;
             const real_t tmp_blending_op_238 = tmp_blending_op_199*tmp_blending_op_228;
             const real_t tmp_blending_op_239 = -tmp_blending_op_201*tmp_blending_op_230;
             const real_t tmp_blending_op_240 = tmp_blending_op_208*tmp_blending_op_229;
             const real_t tmp_blending_op_241 = tmp_blending_op_189*tmp_blending_op_240;
             const real_t tmp_blending_op_242 = tmp_blending_op_189*tmp_blending_op_230 + tmp_blending_op_232*tmp_blending_op_42;
             const real_t tmp_blending_op_243 = tmp_blending_op_213*tmp_blending_op_229;
             const real_t tmp_blending_op_244 = tmp_blending_op_194*tmp_blending_op_243;
             const real_t tmp_blending_op_245 = -tmp_blending_op_207;
             const real_t tmp_blending_op_246 = tmp_blending_op_194*2.0;
             const real_t tmp_blending_op_247 = tmp_blending_op_194*tmp_blending_op_228;
             const real_t tmp_blending_op_248 = tmp_blending_op_206*(tmp_blending_op_192*tmp_blending_op_51 + tmp_blending_op_246*tmp_blending_op_56);
             const real_t tmp_blending_op_249 = tmp_blending_op_200*tmp_blending_op_228;
             const real_t tmp_blending_op_250 = tmp_blending_op_189*tmp_blending_op_247;
             const real_t tmp_blending_op_251 = -tmp_blending_op_210*tmp_blending_op_250;
             const real_t tmp_blending_op_252 = -tmp_blending_op_194*tmp_blending_op_51 - tmp_blending_op_197;
             const real_t tmp_blending_op_254 = tmp_blending_op_189*tmp_blending_op_51;
             const real_t tmp_blending_op_255 = tmp_blending_op_246*tmp_blending_op_42 + tmp_blending_op_254;
             const real_t tmp_blending_op_257 = -tmp_blending_op_201*tmp_blending_op_256;
             const real_t tmp_blending_op_258 = tmp_blending_op_189*2.0;
             const real_t tmp_blending_op_259 = tmp_blending_op_189*tmp_blending_op_228;
             const real_t tmp_blending_op_260 = tmp_blending_op_206*(tmp_blending_op_192*tmp_blending_op_256 + tmp_blending_op_258*tmp_blending_op_56);
             const real_t tmp_blending_op_261 = tmp_blending_op_190*tmp_blending_op_228;
             const real_t tmp_blending_op_262 = tmp_blending_op_206*(tmp_blending_op_194*tmp_blending_op_256 + tmp_blending_op_254*-2.0);
             const real_t tmp_blending_op_263 = tmp_blending_op_189*tmp_blending_op_256 + tmp_blending_op_202*2.0 + tmp_blending_op_234;
             const real_t tmp_blending_op_265 = pow(tmp_blending_op_163, -2.5000000000000000)*tmp_blending_op_227;
             const real_t tmp_blending_op_266 = tmp_blending_op_154*tmp_blending_op_265;
             const real_t tmp_blending_op_267 = tmp_blending_op_154*2.0;
             const real_t tmp_blending_op_268 = tmp_blending_op_158 + tmp_blending_op_233;
             const real_t tmp_blending_op_269 = tmp_blending_op_154*tmp_blending_op_230 + tmp_blending_op_179*2.0 + tmp_blending_op_268;
             const real_t tmp_blending_op_270 = tmp_blending_op_172*tmp_blending_op_266;
             const real_t tmp_blending_op_271 = tmp_blending_op_156*tmp_blending_op_23*tmp_blending_op_55 - tmp_blending_op_267*tmp_blending_op_51;
             const real_t tmp_blending_op_272 = tmp_blending_op_161*tmp_blending_op_265;
             const real_t tmp_blending_op_273 = -tmp_blending_op_163*tmp_blending_op_230;
             const real_t tmp_blending_op_274 = tmp_blending_op_170*tmp_blending_op_266;
             const real_t tmp_blending_op_275 = tmp_blending_op_151*tmp_blending_op_274;
             const real_t tmp_blending_op_276 = tmp_blending_op_151*tmp_blending_op_230 + tmp_blending_op_267*tmp_blending_op_42;
             const real_t tmp_blending_op_277 = tmp_blending_op_175*tmp_blending_op_266;
             const real_t tmp_blending_op_278 = tmp_blending_op_156*tmp_blending_op_277;
             const real_t tmp_blending_op_279 = -tmp_blending_op_169;
             const real_t tmp_blending_op_280 = tmp_blending_op_156*2.0;
             const real_t tmp_blending_op_281 = tmp_blending_op_156*tmp_blending_op_265;
             const real_t tmp_blending_op_282 = tmp_blending_op_168*(tmp_blending_op_154*tmp_blending_op_51 + tmp_blending_op_280*tmp_blending_op_56);
             const real_t tmp_blending_op_283 = tmp_blending_op_162*tmp_blending_op_265;
             const real_t tmp_blending_op_284 = tmp_blending_op_151*tmp_blending_op_281;
             const real_t tmp_blending_op_285 = -tmp_blending_op_172*tmp_blending_op_284;
             const real_t tmp_blending_op_286 = -tmp_blending_op_156*tmp_blending_op_51 - tmp_blending_op_159;
             const real_t tmp_blending_op_287 = tmp_blending_op_151*tmp_blending_op_51;
             const real_t tmp_blending_op_288 = tmp_blending_op_280*tmp_blending_op_42 + tmp_blending_op_287;
             const real_t tmp_blending_op_289 = -tmp_blending_op_163*tmp_blending_op_256;
             const real_t tmp_blending_op_290 = tmp_blending_op_151*2.0;
             const real_t tmp_blending_op_291 = tmp_blending_op_151*tmp_blending_op_265;
             const real_t tmp_blending_op_292 = tmp_blending_op_168*(tmp_blending_op_154*tmp_blending_op_256 + tmp_blending_op_290*tmp_blending_op_56);
             const real_t tmp_blending_op_293 = tmp_blending_op_152*tmp_blending_op_265;
             const real_t tmp_blending_op_294 = tmp_blending_op_168*(tmp_blending_op_156*tmp_blending_op_256 + tmp_blending_op_287*-2.0);
             const real_t tmp_blending_op_295 = tmp_blending_op_151*tmp_blending_op_256 + tmp_blending_op_164*2.0 + tmp_blending_op_268;
             const real_t tmp_blending_op_296 = pow(tmp_blending_op_125, -2.5000000000000000)*tmp_blending_op_227;
             const real_t tmp_blending_op_297 = tmp_blending_op_116*tmp_blending_op_296;
             const real_t tmp_blending_op_298 = tmp_blending_op_116*2.0;
             const real_t tmp_blending_op_299 = tmp_blending_op_120 + tmp_blending_op_233;
             const real_t tmp_blending_op_300 = tmp_blending_op_116*tmp_blending_op_230 + tmp_blending_op_141*2.0 + tmp_blending_op_299;
             const real_t tmp_blending_op_301 = tmp_blending_op_134*tmp_blending_op_297;
             const real_t tmp_blending_op_302 = tmp_blending_op_118*tmp_blending_op_23*tmp_blending_op_55 - tmp_blending_op_298*tmp_blending_op_51;
             const real_t tmp_blending_op_303 = tmp_blending_op_123*tmp_blending_op_296;
             const real_t tmp_blending_op_304 = -tmp_blending_op_125*tmp_blending_op_230;
             const real_t tmp_blending_op_305 = tmp_blending_op_132*tmp_blending_op_297;
             const real_t tmp_blending_op_306 = tmp_blending_op_113*tmp_blending_op_305;
             const real_t tmp_blending_op_307 = tmp_blending_op_113*tmp_blending_op_230 + tmp_blending_op_298*tmp_blending_op_42;
             const real_t tmp_blending_op_308 = tmp_blending_op_137*tmp_blending_op_297;
             const real_t tmp_blending_op_309 = tmp_blending_op_118*tmp_blending_op_308;
             const real_t tmp_blending_op_310 = -tmp_blending_op_131;
             const real_t tmp_blending_op_311 = tmp_blending_op_118*2.0;
             const real_t tmp_blending_op_312 = tmp_blending_op_118*tmp_blending_op_296;
             const real_t tmp_blending_op_313 = tmp_blending_op_130*(tmp_blending_op_116*tmp_blending_op_51 + tmp_blending_op_311*tmp_blending_op_56);
             const real_t tmp_blending_op_314 = tmp_blending_op_124*tmp_blending_op_296;
             const real_t tmp_blending_op_315 = tmp_blending_op_113*tmp_blending_op_312;
             const real_t tmp_blending_op_316 = -tmp_blending_op_134*tmp_blending_op_315;
             const real_t tmp_blending_op_317 = -tmp_blending_op_118*tmp_blending_op_51 - tmp_blending_op_121;
             const real_t tmp_blending_op_318 = tmp_blending_op_113*tmp_blending_op_51;
             const real_t tmp_blending_op_319 = tmp_blending_op_311*tmp_blending_op_42 + tmp_blending_op_318;
             const real_t tmp_blending_op_320 = -tmp_blending_op_125*tmp_blending_op_256;
             const real_t tmp_blending_op_321 = tmp_blending_op_113*2.0;
             const real_t tmp_blending_op_322 = tmp_blending_op_113*tmp_blending_op_296;
             const real_t tmp_blending_op_323 = tmp_blending_op_130*(tmp_blending_op_116*tmp_blending_op_256 + tmp_blending_op_321*tmp_blending_op_56);
             const real_t tmp_blending_op_324 = tmp_blending_op_114*tmp_blending_op_296;
             const real_t tmp_blending_op_325 = tmp_blending_op_130*(tmp_blending_op_118*tmp_blending_op_256 + tmp_blending_op_318*-2.0);
             const real_t tmp_blending_op_326 = tmp_blending_op_113*tmp_blending_op_256 + tmp_blending_op_126*2.0 + tmp_blending_op_299;
             const real_t tmp_blending_op_327 = tmp_blending_op_227*pow(tmp_blending_op_87, -2.5000000000000000);
             const real_t tmp_blending_op_328 = tmp_blending_op_327*tmp_blending_op_78;
             const real_t tmp_blending_op_329 = tmp_blending_op_78*2.0;
             const real_t tmp_blending_op_330 = tmp_blending_op_233 + tmp_blending_op_82;
             const real_t tmp_blending_op_331 = tmp_blending_op_103*2.0 + tmp_blending_op_230*tmp_blending_op_78 + tmp_blending_op_330;
             const real_t tmp_blending_op_332 = tmp_blending_op_328*tmp_blending_op_96;
             const real_t tmp_blending_op_333 = tmp_blending_op_23*tmp_blending_op_55*tmp_blending_op_80 - tmp_blending_op_329*tmp_blending_op_51;
             const real_t tmp_blending_op_334 = tmp_blending_op_327*tmp_blending_op_85;
             const real_t tmp_blending_op_335 = -tmp_blending_op_230*tmp_blending_op_87;
             const real_t tmp_blending_op_336 = tmp_blending_op_328*tmp_blending_op_94;
             const real_t tmp_blending_op_337 = tmp_blending_op_336*tmp_blending_op_75;
             const real_t tmp_blending_op_338 = tmp_blending_op_230*tmp_blending_op_75 + tmp_blending_op_329*tmp_blending_op_42;
             const real_t tmp_blending_op_339 = tmp_blending_op_328*tmp_blending_op_99;
             const real_t tmp_blending_op_340 = tmp_blending_op_339*tmp_blending_op_80;
             const real_t tmp_blending_op_341 = -tmp_blending_op_93;
             const real_t tmp_blending_op_342 = tmp_blending_op_80*2.0;
             const real_t tmp_blending_op_343 = tmp_blending_op_327*tmp_blending_op_80;
             const real_t tmp_blending_op_344 = tmp_blending_op_92*(tmp_blending_op_342*tmp_blending_op_56 + tmp_blending_op_51*tmp_blending_op_78);
             const real_t tmp_blending_op_345 = tmp_blending_op_327*tmp_blending_op_86;
             const real_t tmp_blending_op_346 = tmp_blending_op_343*tmp_blending_op_75;
             const real_t tmp_blending_op_347 = -tmp_blending_op_346*tmp_blending_op_96;
             const real_t tmp_blending_op_348 = -tmp_blending_op_51*tmp_blending_op_80 - tmp_blending_op_83;
             const real_t tmp_blending_op_349 = tmp_blending_op_51*tmp_blending_op_75;
             const real_t tmp_blending_op_350 = tmp_blending_op_342*tmp_blending_op_42 + tmp_blending_op_349;
             const real_t tmp_blending_op_351 = -tmp_blending_op_256*tmp_blending_op_87;
             const real_t tmp_blending_op_352 = tmp_blending_op_75*2.0;
             const real_t tmp_blending_op_353 = tmp_blending_op_327*tmp_blending_op_75;
             const real_t tmp_blending_op_354 = tmp_blending_op_92*(tmp_blending_op_256*tmp_blending_op_78 + tmp_blending_op_352*tmp_blending_op_56);
             const real_t tmp_blending_op_355 = tmp_blending_op_327*tmp_blending_op_76;
             const real_t tmp_blending_op_356 = tmp_blending_op_92*(tmp_blending_op_256*tmp_blending_op_80 + tmp_blending_op_349*-2.0);
             const real_t tmp_blending_op_357 = tmp_blending_op_256*tmp_blending_op_75 + tmp_blending_op_330 + tmp_blending_op_88*2.0;
             const real_t tmp_blending_op_358 = tmp_blending_op_227*pow(tmp_blending_op_40, -2.5000000000000000);
             const real_t tmp_blending_op_359 = tmp_blending_op_28*tmp_blending_op_358;
             const real_t tmp_blending_op_360 = tmp_blending_op_28*2.0;
             const real_t tmp_blending_op_361 = tmp_blending_op_233 + tmp_blending_op_35;
             const real_t tmp_blending_op_362 = tmp_blending_op_230*tmp_blending_op_28 + tmp_blending_op_361 + tmp_blending_op_65*2.0;
             const real_t tmp_blending_op_363 = tmp_blending_op_359*tmp_blending_op_57;
             const real_t tmp_blending_op_364 = tmp_blending_op_23*tmp_blending_op_33*tmp_blending_op_55 - tmp_blending_op_360*tmp_blending_op_51;
             const real_t tmp_blending_op_365 = tmp_blending_op_358*tmp_blending_op_38;
             const real_t tmp_blending_op_366 = -tmp_blending_op_230*tmp_blending_op_40;
             const real_t tmp_blending_op_367 = tmp_blending_op_359*tmp_blending_op_53;
             const real_t tmp_blending_op_368 = tmp_blending_op_3*tmp_blending_op_367;
             const real_t tmp_blending_op_369 = tmp_blending_op_230*tmp_blending_op_3 + tmp_blending_op_360*tmp_blending_op_42;
             const real_t tmp_blending_op_370 = tmp_blending_op_359*tmp_blending_op_60;
             const real_t tmp_blending_op_371 = tmp_blending_op_33*tmp_blending_op_370;
             const real_t tmp_blending_op_372 = -tmp_blending_op_52;
             const real_t tmp_blending_op_373 = tmp_blending_op_33*2.0;
             const real_t tmp_blending_op_374 = tmp_blending_op_33*tmp_blending_op_358;
             const real_t tmp_blending_op_375 = tmp_blending_op_49*(tmp_blending_op_28*tmp_blending_op_51 + tmp_blending_op_373*tmp_blending_op_56);
             const real_t tmp_blending_op_376 = tmp_blending_op_358*tmp_blending_op_39;
             const real_t tmp_blending_op_377 = tmp_blending_op_3*tmp_blending_op_374;
             const real_t tmp_blending_op_378 = -tmp_blending_op_377*tmp_blending_op_57;
             const real_t tmp_blending_op_379 = -tmp_blending_op_33*tmp_blending_op_51 - tmp_blending_op_36;
             const real_t tmp_blending_op_380 = tmp_blending_op_3*tmp_blending_op_51;
             const real_t tmp_blending_op_381 = tmp_blending_op_373*tmp_blending_op_42 + tmp_blending_op_380;
             const real_t tmp_blending_op_382 = -tmp_blending_op_256*tmp_blending_op_40;
             const real_t tmp_blending_op_383 = tmp_blending_op_3*2.0;
             const real_t tmp_blending_op_384 = tmp_blending_op_3*tmp_blending_op_358;
             const real_t tmp_blending_op_385 = tmp_blending_op_49*(tmp_blending_op_256*tmp_blending_op_28 + tmp_blending_op_383*tmp_blending_op_56);
             const real_t tmp_blending_op_386 = tmp_blending_op_358*tmp_blending_op_4;
             const real_t tmp_blending_op_387 = tmp_blending_op_49*(tmp_blending_op_256*tmp_blending_op_33 + tmp_blending_op_380*-2.0);
             const real_t tmp_blending_op_388 = tmp_blending_op_256*tmp_blending_op_3 + tmp_blending_op_361 + tmp_blending_op_43*2.0;
             const real_t jac_blending_2_2_q_4 = tmp_blending_op_45*tmp_blending_op_49;
             const real_t jac_blending_2_1_q_4 = tmp_blending_op_3*tmp_blending_op_54;
             const real_t jac_blending_2_0_q_4 = tmp_blending_op_3*tmp_blending_op_58;
             const real_t jac_blending_1_2_q_4 = tmp_blending_op_33*tmp_blending_op_61;
             const real_t jac_blending_1_1_q_4 = tmp_blending_op_49*tmp_blending_op_64;
             const real_t tmp_blending_op_72 = jac_blending_1_1_q_4*jac_blending_2_0_q_4;
             const real_t jac_blending_1_0_q_4 = tmp_blending_op_33*tmp_blending_op_58;
             const real_t tmp_blending_op_69 = jac_blending_1_0_q_4*jac_blending_2_1_q_4;
             const real_t jac_blending_0_2_q_4 = tmp_blending_op_28*tmp_blending_op_61;
             const real_t jac_blending_0_1_q_4 = tmp_blending_op_28*tmp_blending_op_54;
             const real_t tmp_blending_op_71 = jac_blending_0_1_q_4*jac_blending_1_0_q_4;
             const real_t jac_blending_0_0_q_4 = tmp_blending_op_49*tmp_blending_op_67;
             const real_t tmp_blending_op_68 = jac_blending_0_0_q_4*jac_blending_1_1_q_4;
             const real_t tmp_blending_op_70 = jac_blending_0_0_q_4*jac_blending_2_1_q_4;
             const real_t tmp_blending_op_73 = jac_blending_0_1_q_4*jac_blending_1_2_q_4*jac_blending_2_0_q_4 + jac_blending_0_2_q_4*tmp_blending_op_69 - jac_blending_0_2_q_4*tmp_blending_op_72 - jac_blending_1_2_q_4*tmp_blending_op_70 + jac_blending_2_2_q_4*tmp_blending_op_68 - jac_blending_2_2_q_4*tmp_blending_op_71;
             const real_t tmp_blending_op_74 = 1.0 / (tmp_blending_op_73);
             const real_t abs_det_jac_blending_q_4 = tmp_blending_op_73;
             const real_t jac_blending_inv_2_2_q_4 = tmp_blending_op_74*(tmp_blending_op_68 - tmp_blending_op_71);
             const real_t jac_blending_inv_2_1_q_4 = tmp_blending_op_74*(jac_blending_0_1_q_4*jac_blending_2_0_q_4 - tmp_blending_op_70);
             const real_t jac_blending_inv_2_0_q_4 = tmp_blending_op_74*(tmp_blending_op_69 - tmp_blending_op_72);
             const real_t jac_blending_inv_1_2_q_4 = tmp_blending_op_74*(-jac_blending_0_0_q_4*jac_blending_1_2_q_4 + jac_blending_0_2_q_4*jac_blending_1_0_q_4);
             const real_t jac_blending_inv_1_1_q_4 = tmp_blending_op_74*(jac_blending_0_0_q_4*jac_blending_2_2_q_4 - jac_blending_0_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_1_0_q_4 = tmp_blending_op_74*(-jac_blending_1_0_q_4*jac_blending_2_2_q_4 + jac_blending_1_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_0_2_q_4 = tmp_blending_op_74*(jac_blending_0_1_q_4*jac_blending_1_2_q_4 - jac_blending_0_2_q_4*jac_blending_1_1_q_4);
             const real_t jac_blending_inv_0_1_q_4 = tmp_blending_op_74*(-jac_blending_0_1_q_4*jac_blending_2_2_q_4 + jac_blending_0_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_inv_0_0_q_4 = tmp_blending_op_74*(jac_blending_1_1_q_4*jac_blending_2_2_q_4 - jac_blending_1_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_2_2_q_3 = tmp_blending_op_90*tmp_blending_op_92;
             const real_t jac_blending_2_1_q_3 = tmp_blending_op_75*tmp_blending_op_95;
             const real_t jac_blending_2_0_q_3 = tmp_blending_op_75*tmp_blending_op_97;
             const real_t jac_blending_1_2_q_3 = tmp_blending_op_100*tmp_blending_op_80;
             const real_t jac_blending_1_1_q_3 = tmp_blending_op_102*tmp_blending_op_92;
             const real_t tmp_blending_op_110 = jac_blending_1_1_q_3*jac_blending_2_0_q_3;
             const real_t jac_blending_1_0_q_3 = tmp_blending_op_80*tmp_blending_op_97;
             const real_t tmp_blending_op_107 = jac_blending_1_0_q_3*jac_blending_2_1_q_3;
             const real_t jac_blending_0_2_q_3 = tmp_blending_op_100*tmp_blending_op_78;
             const real_t jac_blending_0_1_q_3 = tmp_blending_op_78*tmp_blending_op_95;
             const real_t tmp_blending_op_109 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
             const real_t jac_blending_0_0_q_3 = tmp_blending_op_105*tmp_blending_op_92;
             const real_t tmp_blending_op_106 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
             const real_t tmp_blending_op_108 = jac_blending_0_0_q_3*jac_blending_2_1_q_3;
             const real_t tmp_blending_op_111 = jac_blending_0_1_q_3*jac_blending_1_2_q_3*jac_blending_2_0_q_3 + jac_blending_0_2_q_3*tmp_blending_op_107 - jac_blending_0_2_q_3*tmp_blending_op_110 - jac_blending_1_2_q_3*tmp_blending_op_108 + jac_blending_2_2_q_3*tmp_blending_op_106 - jac_blending_2_2_q_3*tmp_blending_op_109;
             const real_t tmp_blending_op_112 = 1.0 / (tmp_blending_op_111);
             const real_t abs_det_jac_blending_q_3 = tmp_blending_op_111;
             const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_112*(tmp_blending_op_106 - tmp_blending_op_109);
             const real_t jac_blending_inv_2_1_q_3 = tmp_blending_op_112*(jac_blending_0_1_q_3*jac_blending_2_0_q_3 - tmp_blending_op_108);
             const real_t jac_blending_inv_2_0_q_3 = tmp_blending_op_112*(tmp_blending_op_107 - tmp_blending_op_110);
             const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_112*(-jac_blending_0_0_q_3*jac_blending_1_2_q_3 + jac_blending_0_2_q_3*jac_blending_1_0_q_3);
             const real_t jac_blending_inv_1_1_q_3 = tmp_blending_op_112*(jac_blending_0_0_q_3*jac_blending_2_2_q_3 - jac_blending_0_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_1_0_q_3 = tmp_blending_op_112*(-jac_blending_1_0_q_3*jac_blending_2_2_q_3 + jac_blending_1_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_112*(jac_blending_0_1_q_3*jac_blending_1_2_q_3 - jac_blending_0_2_q_3*jac_blending_1_1_q_3);
             const real_t jac_blending_inv_0_1_q_3 = tmp_blending_op_112*(-jac_blending_0_1_q_3*jac_blending_2_2_q_3 + jac_blending_0_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_inv_0_0_q_3 = tmp_blending_op_112*(jac_blending_1_1_q_3*jac_blending_2_2_q_3 - jac_blending_1_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_2_2_q_2 = tmp_blending_op_128*tmp_blending_op_130;
             const real_t jac_blending_2_1_q_2 = tmp_blending_op_113*tmp_blending_op_133;
             const real_t jac_blending_2_0_q_2 = tmp_blending_op_113*tmp_blending_op_135;
             const real_t jac_blending_1_2_q_2 = tmp_blending_op_118*tmp_blending_op_138;
             const real_t jac_blending_1_1_q_2 = tmp_blending_op_130*tmp_blending_op_140;
             const real_t tmp_blending_op_148 = jac_blending_1_1_q_2*jac_blending_2_0_q_2;
             const real_t jac_blending_1_0_q_2 = tmp_blending_op_118*tmp_blending_op_135;
             const real_t tmp_blending_op_145 = jac_blending_1_0_q_2*jac_blending_2_1_q_2;
             const real_t jac_blending_0_2_q_2 = tmp_blending_op_116*tmp_blending_op_138;
             const real_t jac_blending_0_1_q_2 = tmp_blending_op_116*tmp_blending_op_133;
             const real_t tmp_blending_op_147 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
             const real_t jac_blending_0_0_q_2 = tmp_blending_op_130*tmp_blending_op_143;
             const real_t tmp_blending_op_144 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
             const real_t tmp_blending_op_146 = jac_blending_0_0_q_2*jac_blending_2_1_q_2;
             const real_t tmp_blending_op_149 = jac_blending_0_1_q_2*jac_blending_1_2_q_2*jac_blending_2_0_q_2 + jac_blending_0_2_q_2*tmp_blending_op_145 - jac_blending_0_2_q_2*tmp_blending_op_148 - jac_blending_1_2_q_2*tmp_blending_op_146 + jac_blending_2_2_q_2*tmp_blending_op_144 - jac_blending_2_2_q_2*tmp_blending_op_147;
             const real_t tmp_blending_op_150 = 1.0 / (tmp_blending_op_149);
             const real_t abs_det_jac_blending_q_2 = tmp_blending_op_149;
             const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_150*(tmp_blending_op_144 - tmp_blending_op_147);
             const real_t jac_blending_inv_2_1_q_2 = tmp_blending_op_150*(jac_blending_0_1_q_2*jac_blending_2_0_q_2 - tmp_blending_op_146);
             const real_t jac_blending_inv_2_0_q_2 = tmp_blending_op_150*(tmp_blending_op_145 - tmp_blending_op_148);
             const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_150*(-jac_blending_0_0_q_2*jac_blending_1_2_q_2 + jac_blending_0_2_q_2*jac_blending_1_0_q_2);
             const real_t jac_blending_inv_1_1_q_2 = tmp_blending_op_150*(jac_blending_0_0_q_2*jac_blending_2_2_q_2 - jac_blending_0_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_1_0_q_2 = tmp_blending_op_150*(-jac_blending_1_0_q_2*jac_blending_2_2_q_2 + jac_blending_1_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_150*(jac_blending_0_1_q_2*jac_blending_1_2_q_2 - jac_blending_0_2_q_2*jac_blending_1_1_q_2);
             const real_t jac_blending_inv_0_1_q_2 = tmp_blending_op_150*(-jac_blending_0_1_q_2*jac_blending_2_2_q_2 + jac_blending_0_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_inv_0_0_q_2 = tmp_blending_op_150*(jac_blending_1_1_q_2*jac_blending_2_2_q_2 - jac_blending_1_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_2_2_q_1 = tmp_blending_op_166*tmp_blending_op_168;
             const real_t jac_blending_2_1_q_1 = tmp_blending_op_151*tmp_blending_op_171;
             const real_t jac_blending_2_0_q_1 = tmp_blending_op_151*tmp_blending_op_173;
             const real_t jac_blending_1_2_q_1 = tmp_blending_op_156*tmp_blending_op_176;
             const real_t jac_blending_1_1_q_1 = tmp_blending_op_168*tmp_blending_op_178;
             const real_t tmp_blending_op_186 = jac_blending_1_1_q_1*jac_blending_2_0_q_1;
             const real_t jac_blending_1_0_q_1 = tmp_blending_op_156*tmp_blending_op_173;
             const real_t tmp_blending_op_183 = jac_blending_1_0_q_1*jac_blending_2_1_q_1;
             const real_t jac_blending_0_2_q_1 = tmp_blending_op_154*tmp_blending_op_176;
             const real_t jac_blending_0_1_q_1 = tmp_blending_op_154*tmp_blending_op_171;
             const real_t tmp_blending_op_185 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
             const real_t jac_blending_0_0_q_1 = tmp_blending_op_168*tmp_blending_op_181;
             const real_t tmp_blending_op_182 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
             const real_t tmp_blending_op_184 = jac_blending_0_0_q_1*jac_blending_2_1_q_1;
             const real_t tmp_blending_op_187 = jac_blending_0_1_q_1*jac_blending_1_2_q_1*jac_blending_2_0_q_1 + jac_blending_0_2_q_1*tmp_blending_op_183 - jac_blending_0_2_q_1*tmp_blending_op_186 - jac_blending_1_2_q_1*tmp_blending_op_184 + jac_blending_2_2_q_1*tmp_blending_op_182 - jac_blending_2_2_q_1*tmp_blending_op_185;
             const real_t tmp_blending_op_188 = 1.0 / (tmp_blending_op_187);
             const real_t abs_det_jac_blending_q_1 = tmp_blending_op_187;
             const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_188*(tmp_blending_op_182 - tmp_blending_op_185);
             const real_t jac_blending_inv_2_1_q_1 = tmp_blending_op_188*(jac_blending_0_1_q_1*jac_blending_2_0_q_1 - tmp_blending_op_184);
             const real_t jac_blending_inv_2_0_q_1 = tmp_blending_op_188*(tmp_blending_op_183 - tmp_blending_op_186);
             const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_188*(-jac_blending_0_0_q_1*jac_blending_1_2_q_1 + jac_blending_0_2_q_1*jac_blending_1_0_q_1);
             const real_t jac_blending_inv_1_1_q_1 = tmp_blending_op_188*(jac_blending_0_0_q_1*jac_blending_2_2_q_1 - jac_blending_0_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_1_0_q_1 = tmp_blending_op_188*(-jac_blending_1_0_q_1*jac_blending_2_2_q_1 + jac_blending_1_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_188*(jac_blending_0_1_q_1*jac_blending_1_2_q_1 - jac_blending_0_2_q_1*jac_blending_1_1_q_1);
             const real_t jac_blending_inv_0_1_q_1 = tmp_blending_op_188*(-jac_blending_0_1_q_1*jac_blending_2_2_q_1 + jac_blending_0_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_inv_0_0_q_1 = tmp_blending_op_188*(jac_blending_1_1_q_1*jac_blending_2_2_q_1 - jac_blending_1_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_2_2_q_0 = tmp_blending_op_204*tmp_blending_op_206;
             const real_t jac_blending_2_1_q_0 = tmp_blending_op_189*tmp_blending_op_209;
             const real_t jac_blending_2_0_q_0 = tmp_blending_op_189*tmp_blending_op_211;
             const real_t jac_blending_1_2_q_0 = tmp_blending_op_194*tmp_blending_op_214;
             const real_t jac_blending_1_1_q_0 = tmp_blending_op_206*tmp_blending_op_216;
             const real_t tmp_blending_op_224 = jac_blending_1_1_q_0*jac_blending_2_0_q_0;
             const real_t jac_blending_1_0_q_0 = tmp_blending_op_194*tmp_blending_op_211;
             const real_t tmp_blending_op_221 = jac_blending_1_0_q_0*jac_blending_2_1_q_0;
             const real_t jac_blending_0_2_q_0 = tmp_blending_op_192*tmp_blending_op_214;
             const real_t jac_blending_0_1_q_0 = tmp_blending_op_192*tmp_blending_op_209;
             const real_t tmp_blending_op_223 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
             const real_t jac_blending_0_0_q_0 = tmp_blending_op_206*tmp_blending_op_219;
             const real_t tmp_blending_op_220 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
             const real_t tmp_blending_op_222 = jac_blending_0_0_q_0*jac_blending_2_1_q_0;
             const real_t tmp_blending_op_225 = jac_blending_0_1_q_0*jac_blending_1_2_q_0*jac_blending_2_0_q_0 + jac_blending_0_2_q_0*tmp_blending_op_221 - jac_blending_0_2_q_0*tmp_blending_op_224 - jac_blending_1_2_q_0*tmp_blending_op_222 + jac_blending_2_2_q_0*tmp_blending_op_220 - jac_blending_2_2_q_0*tmp_blending_op_223;
             const real_t tmp_blending_op_226 = 1.0 / (tmp_blending_op_225);
             const real_t abs_det_jac_blending_q_0 = tmp_blending_op_225;
             const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_226*(tmp_blending_op_220 - tmp_blending_op_223);
             const real_t jac_blending_inv_2_1_q_0 = tmp_blending_op_226*(jac_blending_0_1_q_0*jac_blending_2_0_q_0 - tmp_blending_op_222);
             const real_t jac_blending_inv_2_0_q_0 = tmp_blending_op_226*(tmp_blending_op_221 - tmp_blending_op_224);
             const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_226*(-jac_blending_0_0_q_0*jac_blending_1_2_q_0 + jac_blending_0_2_q_0*jac_blending_1_0_q_0);
             const real_t jac_blending_inv_1_1_q_0 = tmp_blending_op_226*(jac_blending_0_0_q_0*jac_blending_2_2_q_0 - jac_blending_0_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_1_0_q_0 = tmp_blending_op_226*(-jac_blending_1_0_q_0*jac_blending_2_2_q_0 + jac_blending_1_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_226*(jac_blending_0_1_q_0*jac_blending_1_2_q_0 - jac_blending_0_2_q_0*jac_blending_1_1_q_0);
             const real_t jac_blending_inv_0_1_q_0 = tmp_blending_op_226*(-jac_blending_0_1_q_0*jac_blending_2_2_q_0 + jac_blending_0_2_q_0*jac_blending_2_1_q_0);
             const real_t jac_blending_inv_0_0_q_0 = tmp_blending_op_226*(jac_blending_1_1_q_0*jac_blending_2_2_q_0 - jac_blending_1_2_q_0*jac_blending_2_1_q_0);
             const real_t hessian_blending_0_0_0_q_0 = tmp_blending_op_205*tmp_blending_op_47*(-tmp_blending_op_197*tmp_blending_op_232 + tmp_blending_op_199*tmp_blending_op_230 + tmp_blending_op_201*tmp_blending_op_231 + tmp_blending_op_218*tmp_blending_op_232)*1.0 - tmp_blending_op_219*tmp_blending_op_229;
             const real_t hessian_blending_0_0_1_q_0 = tmp_blending_op_194*tmp_blending_op_205*tmp_blending_op_235*tmp_blending_op_47*1.0 - tmp_blending_op_194*tmp_blending_op_236;
             const real_t hessian_blending_0_0_2_q_0 = tmp_blending_op_189*tmp_blending_op_205*tmp_blending_op_235*tmp_blending_op_47*1.0 - tmp_blending_op_189*tmp_blending_op_236;
             const real_t hessian_blending_0_1_0_q_0 = tmp_blending_op_192*tmp_blending_op_206*tmp_blending_op_237 - tmp_blending_op_208*tmp_blending_op_238 + tmp_blending_op_209;
             const real_t hessian_blending_0_1_1_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_200*tmp_blending_op_230 + tmp_blending_op_215*tmp_blending_op_232 + tmp_blending_op_239)*1.0 - tmp_blending_op_216*tmp_blending_op_229;
             const real_t hessian_blending_0_1_2_q_0 = tmp_blending_op_189*tmp_blending_op_205*tmp_blending_op_237*tmp_blending_op_47*1.0 - tmp_blending_op_241;
             const real_t hessian_blending_0_2_0_q_0 = tmp_blending_op_192*tmp_blending_op_206*tmp_blending_op_242 - tmp_blending_op_213*tmp_blending_op_238 + tmp_blending_op_214;
             const real_t hessian_blending_0_2_1_q_0 = tmp_blending_op_194*tmp_blending_op_205*tmp_blending_op_242*tmp_blending_op_47*1.0 - tmp_blending_op_244;
             const real_t hessian_blending_0_2_2_q_0 = -tmp_blending_op_204*tmp_blending_op_229 + tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_190*tmp_blending_op_230 + tmp_blending_op_203*tmp_blending_op_232 + tmp_blending_op_239)*1.0;
             const real_t hessian_blending_1_0_0_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_199*tmp_blending_op_51 + tmp_blending_op_218*tmp_blending_op_246 + tmp_blending_op_245)*1.0 - tmp_blending_op_219*tmp_blending_op_247;
             const real_t hessian_blending_1_0_1_q_0 = tmp_blending_op_194*tmp_blending_op_248 - tmp_blending_op_210*tmp_blending_op_249 + tmp_blending_op_211;
             const real_t hessian_blending_1_0_2_q_0 = tmp_blending_op_189*tmp_blending_op_248 + tmp_blending_op_251;
             const real_t hessian_blending_1_1_0_q_0 = tmp_blending_op_192*tmp_blending_op_205*tmp_blending_op_252*tmp_blending_op_47*1.0 - tmp_blending_op_194*tmp_blending_op_240;
             const real_t hessian_blending_1_1_1_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_198*tmp_blending_op_246 + tmp_blending_op_200*tmp_blending_op_51 + tmp_blending_op_201*tmp_blending_op_253 + tmp_blending_op_215*tmp_blending_op_246)*1.0 - tmp_blending_op_216*tmp_blending_op_247;
             const real_t hessian_blending_1_1_2_q_0 = tmp_blending_op_189*tmp_blending_op_205*tmp_blending_op_252*tmp_blending_op_47*1.0 - tmp_blending_op_208*tmp_blending_op_250;
             const real_t hessian_blending_1_2_0_q_0 = tmp_blending_op_192*tmp_blending_op_205*tmp_blending_op_255*tmp_blending_op_47*1.0 - tmp_blending_op_244;
             const real_t hessian_blending_1_2_1_q_0 = tmp_blending_op_194*tmp_blending_op_206*tmp_blending_op_255 - tmp_blending_op_213*tmp_blending_op_249 + tmp_blending_op_214;
             const real_t hessian_blending_1_2_2_q_0 = -tmp_blending_op_204*tmp_blending_op_247 + tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_190*tmp_blending_op_51 + tmp_blending_op_203*tmp_blending_op_246 + tmp_blending_op_245)*1.0;
             const real_t hessian_blending_2_0_0_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_199*tmp_blending_op_256 + tmp_blending_op_218*tmp_blending_op_258 + tmp_blending_op_257)*1.0 - tmp_blending_op_219*tmp_blending_op_259;
             const real_t hessian_blending_2_0_1_q_0 = tmp_blending_op_194*tmp_blending_op_260 + tmp_blending_op_251;
             const real_t hessian_blending_2_0_2_q_0 = tmp_blending_op_189*tmp_blending_op_260 - tmp_blending_op_210*tmp_blending_op_261 + tmp_blending_op_211;
             const real_t hessian_blending_2_1_0_q_0 = tmp_blending_op_192*tmp_blending_op_262 - tmp_blending_op_241;
             const real_t hessian_blending_2_1_1_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_200*tmp_blending_op_256 + tmp_blending_op_215*tmp_blending_op_258 + tmp_blending_op_257)*1.0 - tmp_blending_op_216*tmp_blending_op_259;
             const real_t hessian_blending_2_1_2_q_0 = tmp_blending_op_189*tmp_blending_op_262 - tmp_blending_op_208*tmp_blending_op_261 + tmp_blending_op_209;
             const real_t hessian_blending_2_2_0_q_0 = -tmp_blending_op_189*tmp_blending_op_243 + tmp_blending_op_192*tmp_blending_op_205*tmp_blending_op_263*tmp_blending_op_47*1.0;
             const real_t hessian_blending_2_2_1_q_0 = tmp_blending_op_194*tmp_blending_op_205*tmp_blending_op_263*tmp_blending_op_47*1.0 - tmp_blending_op_213*tmp_blending_op_250;
             const real_t hessian_blending_2_2_2_q_0 = -tmp_blending_op_204*tmp_blending_op_259 + tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_190*tmp_blending_op_256 + tmp_blending_op_201*tmp_blending_op_264 + tmp_blending_op_203*tmp_blending_op_258 + tmp_blending_op_212*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_1 = tmp_blending_op_167*tmp_blending_op_47*(-tmp_blending_op_159*tmp_blending_op_267 + tmp_blending_op_161*tmp_blending_op_230 + tmp_blending_op_163*tmp_blending_op_231 + tmp_blending_op_180*tmp_blending_op_267)*1.0 - tmp_blending_op_181*tmp_blending_op_266;
             const real_t hessian_blending_0_0_1_q_1 = tmp_blending_op_156*tmp_blending_op_167*tmp_blending_op_269*tmp_blending_op_47*1.0 - tmp_blending_op_156*tmp_blending_op_270;
             const real_t hessian_blending_0_0_2_q_1 = tmp_blending_op_151*tmp_blending_op_167*tmp_blending_op_269*tmp_blending_op_47*1.0 - tmp_blending_op_151*tmp_blending_op_270;
             const real_t hessian_blending_0_1_0_q_1 = tmp_blending_op_154*tmp_blending_op_168*tmp_blending_op_271 - tmp_blending_op_170*tmp_blending_op_272 + tmp_blending_op_171;
             const real_t hessian_blending_0_1_1_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_162*tmp_blending_op_230 + tmp_blending_op_177*tmp_blending_op_267 + tmp_blending_op_273)*1.0 - tmp_blending_op_178*tmp_blending_op_266;
             const real_t hessian_blending_0_1_2_q_1 = tmp_blending_op_151*tmp_blending_op_167*tmp_blending_op_271*tmp_blending_op_47*1.0 - tmp_blending_op_275;
             const real_t hessian_blending_0_2_0_q_1 = tmp_blending_op_154*tmp_blending_op_168*tmp_blending_op_276 - tmp_blending_op_175*tmp_blending_op_272 + tmp_blending_op_176;
             const real_t hessian_blending_0_2_1_q_1 = tmp_blending_op_156*tmp_blending_op_167*tmp_blending_op_276*tmp_blending_op_47*1.0 - tmp_blending_op_278;
             const real_t hessian_blending_0_2_2_q_1 = -tmp_blending_op_166*tmp_blending_op_266 + tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_152*tmp_blending_op_230 + tmp_blending_op_165*tmp_blending_op_267 + tmp_blending_op_273)*1.0;
             const real_t hessian_blending_1_0_0_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_161*tmp_blending_op_51 + tmp_blending_op_180*tmp_blending_op_280 + tmp_blending_op_279)*1.0 - tmp_blending_op_181*tmp_blending_op_281;
             const real_t hessian_blending_1_0_1_q_1 = tmp_blending_op_156*tmp_blending_op_282 - tmp_blending_op_172*tmp_blending_op_283 + tmp_blending_op_173;
             const real_t hessian_blending_1_0_2_q_1 = tmp_blending_op_151*tmp_blending_op_282 + tmp_blending_op_285;
             const real_t hessian_blending_1_1_0_q_1 = tmp_blending_op_154*tmp_blending_op_167*tmp_blending_op_286*tmp_blending_op_47*1.0 - tmp_blending_op_156*tmp_blending_op_274;
             const real_t hessian_blending_1_1_1_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_160*tmp_blending_op_280 + tmp_blending_op_162*tmp_blending_op_51 + tmp_blending_op_163*tmp_blending_op_253 + tmp_blending_op_177*tmp_blending_op_280)*1.0 - tmp_blending_op_178*tmp_blending_op_281;
             const real_t hessian_blending_1_1_2_q_1 = tmp_blending_op_151*tmp_blending_op_167*tmp_blending_op_286*tmp_blending_op_47*1.0 - tmp_blending_op_170*tmp_blending_op_284;
             const real_t hessian_blending_1_2_0_q_1 = tmp_blending_op_154*tmp_blending_op_167*tmp_blending_op_288*tmp_blending_op_47*1.0 - tmp_blending_op_278;
             const real_t hessian_blending_1_2_1_q_1 = tmp_blending_op_156*tmp_blending_op_168*tmp_blending_op_288 - tmp_blending_op_175*tmp_blending_op_283 + tmp_blending_op_176;
             const real_t hessian_blending_1_2_2_q_1 = -tmp_blending_op_166*tmp_blending_op_281 + tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_152*tmp_blending_op_51 + tmp_blending_op_165*tmp_blending_op_280 + tmp_blending_op_279)*1.0;
             const real_t hessian_blending_2_0_0_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_161*tmp_blending_op_256 + tmp_blending_op_180*tmp_blending_op_290 + tmp_blending_op_289)*1.0 - tmp_blending_op_181*tmp_blending_op_291;
             const real_t hessian_blending_2_0_1_q_1 = tmp_blending_op_156*tmp_blending_op_292 + tmp_blending_op_285;
             const real_t hessian_blending_2_0_2_q_1 = tmp_blending_op_151*tmp_blending_op_292 - tmp_blending_op_172*tmp_blending_op_293 + tmp_blending_op_173;
             const real_t hessian_blending_2_1_0_q_1 = tmp_blending_op_154*tmp_blending_op_294 - tmp_blending_op_275;
             const real_t hessian_blending_2_1_1_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_162*tmp_blending_op_256 + tmp_blending_op_177*tmp_blending_op_290 + tmp_blending_op_289)*1.0 - tmp_blending_op_178*tmp_blending_op_291;
             const real_t hessian_blending_2_1_2_q_1 = tmp_blending_op_151*tmp_blending_op_294 - tmp_blending_op_170*tmp_blending_op_293 + tmp_blending_op_171;
             const real_t hessian_blending_2_2_0_q_1 = -tmp_blending_op_151*tmp_blending_op_277 + tmp_blending_op_154*tmp_blending_op_167*tmp_blending_op_295*tmp_blending_op_47*1.0;
             const real_t hessian_blending_2_2_1_q_1 = tmp_blending_op_156*tmp_blending_op_167*tmp_blending_op_295*tmp_blending_op_47*1.0 - tmp_blending_op_175*tmp_blending_op_284;
             const real_t hessian_blending_2_2_2_q_1 = -tmp_blending_op_166*tmp_blending_op_291 + tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_152*tmp_blending_op_256 + tmp_blending_op_163*tmp_blending_op_264 + tmp_blending_op_165*tmp_blending_op_290 + tmp_blending_op_174*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_2 = tmp_blending_op_129*tmp_blending_op_47*(-tmp_blending_op_121*tmp_blending_op_298 + tmp_blending_op_123*tmp_blending_op_230 + tmp_blending_op_125*tmp_blending_op_231 + tmp_blending_op_142*tmp_blending_op_298)*1.0 - tmp_blending_op_143*tmp_blending_op_297;
             const real_t hessian_blending_0_0_1_q_2 = tmp_blending_op_118*tmp_blending_op_129*tmp_blending_op_300*tmp_blending_op_47*1.0 - tmp_blending_op_118*tmp_blending_op_301;
             const real_t hessian_blending_0_0_2_q_2 = tmp_blending_op_113*tmp_blending_op_129*tmp_blending_op_300*tmp_blending_op_47*1.0 - tmp_blending_op_113*tmp_blending_op_301;
             const real_t hessian_blending_0_1_0_q_2 = tmp_blending_op_116*tmp_blending_op_130*tmp_blending_op_302 - tmp_blending_op_132*tmp_blending_op_303 + tmp_blending_op_133;
             const real_t hessian_blending_0_1_1_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_124*tmp_blending_op_230 + tmp_blending_op_139*tmp_blending_op_298 + tmp_blending_op_304)*1.0 - tmp_blending_op_140*tmp_blending_op_297;
             const real_t hessian_blending_0_1_2_q_2 = tmp_blending_op_113*tmp_blending_op_129*tmp_blending_op_302*tmp_blending_op_47*1.0 - tmp_blending_op_306;
             const real_t hessian_blending_0_2_0_q_2 = tmp_blending_op_116*tmp_blending_op_130*tmp_blending_op_307 - tmp_blending_op_137*tmp_blending_op_303 + tmp_blending_op_138;
             const real_t hessian_blending_0_2_1_q_2 = tmp_blending_op_118*tmp_blending_op_129*tmp_blending_op_307*tmp_blending_op_47*1.0 - tmp_blending_op_309;
             const real_t hessian_blending_0_2_2_q_2 = -tmp_blending_op_128*tmp_blending_op_297 + tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_114*tmp_blending_op_230 + tmp_blending_op_127*tmp_blending_op_298 + tmp_blending_op_304)*1.0;
             const real_t hessian_blending_1_0_0_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_123*tmp_blending_op_51 + tmp_blending_op_142*tmp_blending_op_311 + tmp_blending_op_310)*1.0 - tmp_blending_op_143*tmp_blending_op_312;
             const real_t hessian_blending_1_0_1_q_2 = tmp_blending_op_118*tmp_blending_op_313 - tmp_blending_op_134*tmp_blending_op_314 + tmp_blending_op_135;
             const real_t hessian_blending_1_0_2_q_2 = tmp_blending_op_113*tmp_blending_op_313 + tmp_blending_op_316;
             const real_t hessian_blending_1_1_0_q_2 = tmp_blending_op_116*tmp_blending_op_129*tmp_blending_op_317*tmp_blending_op_47*1.0 - tmp_blending_op_118*tmp_blending_op_305;
             const real_t hessian_blending_1_1_1_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_122*tmp_blending_op_311 + tmp_blending_op_124*tmp_blending_op_51 + tmp_blending_op_125*tmp_blending_op_253 + tmp_blending_op_139*tmp_blending_op_311)*1.0 - tmp_blending_op_140*tmp_blending_op_312;
             const real_t hessian_blending_1_1_2_q_2 = tmp_blending_op_113*tmp_blending_op_129*tmp_blending_op_317*tmp_blending_op_47*1.0 - tmp_blending_op_132*tmp_blending_op_315;
             const real_t hessian_blending_1_2_0_q_2 = tmp_blending_op_116*tmp_blending_op_129*tmp_blending_op_319*tmp_blending_op_47*1.0 - tmp_blending_op_309;
             const real_t hessian_blending_1_2_1_q_2 = tmp_blending_op_118*tmp_blending_op_130*tmp_blending_op_319 - tmp_blending_op_137*tmp_blending_op_314 + tmp_blending_op_138;
             const real_t hessian_blending_1_2_2_q_2 = -tmp_blending_op_128*tmp_blending_op_312 + tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_114*tmp_blending_op_51 + tmp_blending_op_127*tmp_blending_op_311 + tmp_blending_op_310)*1.0;
             const real_t hessian_blending_2_0_0_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_123*tmp_blending_op_256 + tmp_blending_op_142*tmp_blending_op_321 + tmp_blending_op_320)*1.0 - tmp_blending_op_143*tmp_blending_op_322;
             const real_t hessian_blending_2_0_1_q_2 = tmp_blending_op_118*tmp_blending_op_323 + tmp_blending_op_316;
             const real_t hessian_blending_2_0_2_q_2 = tmp_blending_op_113*tmp_blending_op_323 - tmp_blending_op_134*tmp_blending_op_324 + tmp_blending_op_135;
             const real_t hessian_blending_2_1_0_q_2 = tmp_blending_op_116*tmp_blending_op_325 - tmp_blending_op_306;
             const real_t hessian_blending_2_1_1_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_124*tmp_blending_op_256 + tmp_blending_op_139*tmp_blending_op_321 + tmp_blending_op_320)*1.0 - tmp_blending_op_140*tmp_blending_op_322;
             const real_t hessian_blending_2_1_2_q_2 = tmp_blending_op_113*tmp_blending_op_325 - tmp_blending_op_132*tmp_blending_op_324 + tmp_blending_op_133;
             const real_t hessian_blending_2_2_0_q_2 = -tmp_blending_op_113*tmp_blending_op_308 + tmp_blending_op_116*tmp_blending_op_129*tmp_blending_op_326*tmp_blending_op_47*1.0;
             const real_t hessian_blending_2_2_1_q_2 = tmp_blending_op_118*tmp_blending_op_129*tmp_blending_op_326*tmp_blending_op_47*1.0 - tmp_blending_op_137*tmp_blending_op_315;
             const real_t hessian_blending_2_2_2_q_2 = -tmp_blending_op_128*tmp_blending_op_322 + tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_114*tmp_blending_op_256 + tmp_blending_op_125*tmp_blending_op_264 + tmp_blending_op_127*tmp_blending_op_321 + tmp_blending_op_136*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_3 = -tmp_blending_op_105*tmp_blending_op_328 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_104*tmp_blending_op_329 + tmp_blending_op_230*tmp_blending_op_85 + tmp_blending_op_231*tmp_blending_op_87 - tmp_blending_op_329*tmp_blending_op_83)*1.0;
             const real_t hessian_blending_0_0_1_q_3 = tmp_blending_op_331*tmp_blending_op_47*tmp_blending_op_80*tmp_blending_op_91*1.0 - tmp_blending_op_332*tmp_blending_op_80;
             const real_t hessian_blending_0_0_2_q_3 = tmp_blending_op_331*tmp_blending_op_47*tmp_blending_op_75*tmp_blending_op_91*1.0 - tmp_blending_op_332*tmp_blending_op_75;
             const real_t hessian_blending_0_1_0_q_3 = tmp_blending_op_333*tmp_blending_op_78*tmp_blending_op_92 - tmp_blending_op_334*tmp_blending_op_94 + tmp_blending_op_95;
             const real_t hessian_blending_0_1_1_q_3 = -tmp_blending_op_102*tmp_blending_op_328 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_101*tmp_blending_op_329 + tmp_blending_op_230*tmp_blending_op_86 + tmp_blending_op_335)*1.0;
             const real_t hessian_blending_0_1_2_q_3 = tmp_blending_op_333*tmp_blending_op_47*tmp_blending_op_75*tmp_blending_op_91*1.0 - tmp_blending_op_337;
             const real_t hessian_blending_0_2_0_q_3 = tmp_blending_op_100 - tmp_blending_op_334*tmp_blending_op_99 + tmp_blending_op_338*tmp_blending_op_78*tmp_blending_op_92;
             const real_t hessian_blending_0_2_1_q_3 = tmp_blending_op_338*tmp_blending_op_47*tmp_blending_op_80*tmp_blending_op_91*1.0 - tmp_blending_op_340;
             const real_t hessian_blending_0_2_2_q_3 = -tmp_blending_op_328*tmp_blending_op_90 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_230*tmp_blending_op_76 + tmp_blending_op_329*tmp_blending_op_89 + tmp_blending_op_335)*1.0;
             const real_t hessian_blending_1_0_0_q_3 = -tmp_blending_op_105*tmp_blending_op_343 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_104*tmp_blending_op_342 + tmp_blending_op_341 + tmp_blending_op_51*tmp_blending_op_85)*1.0;
             const real_t hessian_blending_1_0_1_q_3 = tmp_blending_op_344*tmp_blending_op_80 - tmp_blending_op_345*tmp_blending_op_96 + tmp_blending_op_97;
             const real_t hessian_blending_1_0_2_q_3 = tmp_blending_op_344*tmp_blending_op_75 + tmp_blending_op_347;
             const real_t hessian_blending_1_1_0_q_3 = -tmp_blending_op_336*tmp_blending_op_80 + tmp_blending_op_348*tmp_blending_op_47*tmp_blending_op_78*tmp_blending_op_91*1.0;
             const real_t hessian_blending_1_1_1_q_3 = -tmp_blending_op_102*tmp_blending_op_343 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_101*tmp_blending_op_342 + tmp_blending_op_253*tmp_blending_op_87 + tmp_blending_op_342*tmp_blending_op_84 + tmp_blending_op_51*tmp_blending_op_86)*1.0;
             const real_t hessian_blending_1_1_2_q_3 = -tmp_blending_op_346*tmp_blending_op_94 + tmp_blending_op_348*tmp_blending_op_47*tmp_blending_op_75*tmp_blending_op_91*1.0;
             const real_t hessian_blending_1_2_0_q_3 = -tmp_blending_op_340 + tmp_blending_op_350*tmp_blending_op_47*tmp_blending_op_78*tmp_blending_op_91*1.0;
             const real_t hessian_blending_1_2_1_q_3 = tmp_blending_op_100 - tmp_blending_op_345*tmp_blending_op_99 + tmp_blending_op_350*tmp_blending_op_80*tmp_blending_op_92;
             const real_t hessian_blending_1_2_2_q_3 = -tmp_blending_op_343*tmp_blending_op_90 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_341 + tmp_blending_op_342*tmp_blending_op_89 + tmp_blending_op_51*tmp_blending_op_76)*1.0;
             const real_t hessian_blending_2_0_0_q_3 = -tmp_blending_op_105*tmp_blending_op_353 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_104*tmp_blending_op_352 + tmp_blending_op_256*tmp_blending_op_85 + tmp_blending_op_351)*1.0;
             const real_t hessian_blending_2_0_1_q_3 = tmp_blending_op_347 + tmp_blending_op_354*tmp_blending_op_80;
             const real_t hessian_blending_2_0_2_q_3 = tmp_blending_op_354*tmp_blending_op_75 - tmp_blending_op_355*tmp_blending_op_96 + tmp_blending_op_97;
             const real_t hessian_blending_2_1_0_q_3 = -tmp_blending_op_337 + tmp_blending_op_356*tmp_blending_op_78;
             const real_t hessian_blending_2_1_1_q_3 = -tmp_blending_op_102*tmp_blending_op_353 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_101*tmp_blending_op_352 + tmp_blending_op_256*tmp_blending_op_86 + tmp_blending_op_351)*1.0;
             const real_t hessian_blending_2_1_2_q_3 = -tmp_blending_op_355*tmp_blending_op_94 + tmp_blending_op_356*tmp_blending_op_75 + tmp_blending_op_95;
             const real_t hessian_blending_2_2_0_q_3 = -tmp_blending_op_339*tmp_blending_op_75 + tmp_blending_op_357*tmp_blending_op_47*tmp_blending_op_78*tmp_blending_op_91*1.0;
             const real_t hessian_blending_2_2_1_q_3 = -tmp_blending_op_346*tmp_blending_op_99 + tmp_blending_op_357*tmp_blending_op_47*tmp_blending_op_80*tmp_blending_op_91*1.0;
             const real_t hessian_blending_2_2_2_q_3 = -tmp_blending_op_353*tmp_blending_op_90 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_256*tmp_blending_op_76 + tmp_blending_op_264*tmp_blending_op_87 + tmp_blending_op_352*tmp_blending_op_89 + tmp_blending_op_98*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_4 = -tmp_blending_op_359*tmp_blending_op_67 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_230*tmp_blending_op_38 + tmp_blending_op_231*tmp_blending_op_40 - tmp_blending_op_36*tmp_blending_op_360 + tmp_blending_op_360*tmp_blending_op_66)*1.0;
             const real_t hessian_blending_0_0_1_q_4 = tmp_blending_op_33*tmp_blending_op_362*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_33*tmp_blending_op_363;
             const real_t hessian_blending_0_0_2_q_4 = tmp_blending_op_3*tmp_blending_op_362*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_3*tmp_blending_op_363;
             const real_t hessian_blending_0_1_0_q_4 = tmp_blending_op_28*tmp_blending_op_364*tmp_blending_op_49 - tmp_blending_op_365*tmp_blending_op_53 + tmp_blending_op_54;
             const real_t hessian_blending_0_1_1_q_4 = -tmp_blending_op_359*tmp_blending_op_64 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_230*tmp_blending_op_39 + tmp_blending_op_360*tmp_blending_op_63 + tmp_blending_op_366)*1.0;
             const real_t hessian_blending_0_1_2_q_4 = tmp_blending_op_3*tmp_blending_op_364*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_368;
             const real_t hessian_blending_0_2_0_q_4 = tmp_blending_op_28*tmp_blending_op_369*tmp_blending_op_49 - tmp_blending_op_365*tmp_blending_op_60 + tmp_blending_op_61;
             const real_t hessian_blending_0_2_1_q_4 = tmp_blending_op_33*tmp_blending_op_369*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_371;
             const real_t hessian_blending_0_2_2_q_4 = -tmp_blending_op_359*tmp_blending_op_45 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_230*tmp_blending_op_4 + tmp_blending_op_360*tmp_blending_op_44 + tmp_blending_op_366)*1.0;
             const real_t hessian_blending_1_0_0_q_4 = -tmp_blending_op_374*tmp_blending_op_67 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_372 + tmp_blending_op_373*tmp_blending_op_66 + tmp_blending_op_38*tmp_blending_op_51)*1.0;
             const real_t hessian_blending_1_0_1_q_4 = tmp_blending_op_33*tmp_blending_op_375 - tmp_blending_op_376*tmp_blending_op_57 + tmp_blending_op_58;
             const real_t hessian_blending_1_0_2_q_4 = tmp_blending_op_3*tmp_blending_op_375 + tmp_blending_op_378;
             const real_t hessian_blending_1_1_0_q_4 = tmp_blending_op_28*tmp_blending_op_379*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_33*tmp_blending_op_367;
             const real_t hessian_blending_1_1_1_q_4 = -tmp_blending_op_374*tmp_blending_op_64 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_253*tmp_blending_op_40 + tmp_blending_op_37*tmp_blending_op_373 + tmp_blending_op_373*tmp_blending_op_63 + tmp_blending_op_39*tmp_blending_op_51)*1.0;
             const real_t hessian_blending_1_1_2_q_4 = tmp_blending_op_3*tmp_blending_op_379*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_377*tmp_blending_op_53;
             const real_t hessian_blending_1_2_0_q_4 = tmp_blending_op_28*tmp_blending_op_381*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_371;
             const real_t hessian_blending_1_2_1_q_4 = tmp_blending_op_33*tmp_blending_op_381*tmp_blending_op_49 - tmp_blending_op_376*tmp_blending_op_60 + tmp_blending_op_61;
             const real_t hessian_blending_1_2_2_q_4 = -tmp_blending_op_374*tmp_blending_op_45 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_372 + tmp_blending_op_373*tmp_blending_op_44 + tmp_blending_op_4*tmp_blending_op_51)*1.0;
             const real_t hessian_blending_2_0_0_q_4 = -tmp_blending_op_384*tmp_blending_op_67 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_256*tmp_blending_op_38 + tmp_blending_op_382 + tmp_blending_op_383*tmp_blending_op_66)*1.0;
             const real_t hessian_blending_2_0_1_q_4 = tmp_blending_op_33*tmp_blending_op_385 + tmp_blending_op_378;
             const real_t hessian_blending_2_0_2_q_4 = tmp_blending_op_3*tmp_blending_op_385 - tmp_blending_op_386*tmp_blending_op_57 + tmp_blending_op_58;
             const real_t hessian_blending_2_1_0_q_4 = tmp_blending_op_28*tmp_blending_op_387 - tmp_blending_op_368;
             const real_t hessian_blending_2_1_1_q_4 = -tmp_blending_op_384*tmp_blending_op_64 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_256*tmp_blending_op_39 + tmp_blending_op_382 + tmp_blending_op_383*tmp_blending_op_63)*1.0;
             const real_t hessian_blending_2_1_2_q_4 = tmp_blending_op_3*tmp_blending_op_387 - tmp_blending_op_386*tmp_blending_op_53 + tmp_blending_op_54;
             const real_t hessian_blending_2_2_0_q_4 = tmp_blending_op_28*tmp_blending_op_388*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_3*tmp_blending_op_370;
             const real_t hessian_blending_2_2_1_q_4 = tmp_blending_op_33*tmp_blending_op_388*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_377*tmp_blending_op_60;
             const real_t hessian_blending_2_2_2_q_4 = -tmp_blending_op_384*tmp_blending_op_45 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_256*tmp_blending_op_4 + tmp_blending_op_264*tmp_blending_op_40 + tmp_blending_op_383*tmp_blending_op_44 + tmp_blending_op_59*2.0)*1.0;
             const real_t diffusivity_times_delta_dof_0 = _data_diffusivity_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t diffusivity_times_delta_dof_1 = _data_diffusivity_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t diffusivity_times_delta_dof_2 = _data_diffusivity_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t diffusivity_times_delta_dof_3 = _data_diffusivity_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t diffusivity_times_delta_dof_4 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t diffusivity_times_delta_dof_5 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t diffusivity_times_delta_dof_6 = _data_diffusivity_times_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t diffusivity_times_delta_dof_7 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t diffusivity_times_delta_dof_8 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t diffusivity_times_delta_dof_9 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wx_dof_0 = _data_wxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wx_dof_1 = _data_wxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wx_dof_2 = _data_wxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wx_dof_3 = _data_wxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wx_dof_4 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t wx_dof_5 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wx_dof_6 = _data_wxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wx_dof_7 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t wx_dof_8 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t wx_dof_9 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wy_dof_0 = _data_wyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wy_dof_1 = _data_wyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wy_dof_2 = _data_wyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wy_dof_3 = _data_wyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wy_dof_4 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t wy_dof_5 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wy_dof_6 = _data_wyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wy_dof_7 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t wy_dof_8 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t wy_dof_9 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wz_dof_0 = _data_wzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wz_dof_1 = _data_wzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wz_dof_2 = _data_wzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wz_dof_3 = _data_wzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wz_dof_4 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t wz_dof_5 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wz_dof_6 = _data_wzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wz_dof_7 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t wz_dof_8 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t wz_dof_9 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t tmp_kernel_op_30 = -hessian_blending_0_0_0_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_0_1_0_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_0_2_0_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_31 = -hessian_blending_0_0_1_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_0_1_1_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_0_2_1_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_32 = -hessian_blending_0_0_2_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_0_1_2_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_0_2_2_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_33 = jac_blending_inv_0_0_q_0*tmp_kernel_op_30 + jac_blending_inv_0_1_q_0*tmp_kernel_op_31 + jac_blending_inv_0_2_q_0*tmp_kernel_op_32;
             const real_t tmp_kernel_op_35 = jac_blending_inv_1_0_q_0*tmp_kernel_op_30 + jac_blending_inv_1_1_q_0*tmp_kernel_op_31 + jac_blending_inv_1_2_q_0*tmp_kernel_op_32;
             const real_t tmp_kernel_op_37 = jac_blending_inv_2_0_q_0*tmp_kernel_op_30 + jac_blending_inv_2_1_q_0*tmp_kernel_op_31 + jac_blending_inv_2_2_q_0*tmp_kernel_op_32;
             const real_t tmp_kernel_op_38 = -hessian_blending_1_0_0_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_1_1_0_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_1_2_0_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_39 = -hessian_blending_1_0_1_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_1_1_1_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_1_2_1_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_40 = -hessian_blending_1_0_2_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_1_1_2_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_1_2_2_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_41 = jac_blending_inv_0_0_q_0*tmp_kernel_op_38 + jac_blending_inv_0_1_q_0*tmp_kernel_op_39 + jac_blending_inv_0_2_q_0*tmp_kernel_op_40;
             const real_t tmp_kernel_op_42 = jac_blending_inv_1_0_q_0*tmp_kernel_op_38 + jac_blending_inv_1_1_q_0*tmp_kernel_op_39 + jac_blending_inv_1_2_q_0*tmp_kernel_op_40;
             const real_t tmp_kernel_op_43 = jac_blending_inv_2_0_q_0*tmp_kernel_op_38 + jac_blending_inv_2_1_q_0*tmp_kernel_op_39 + jac_blending_inv_2_2_q_0*tmp_kernel_op_40;
             const real_t tmp_kernel_op_44 = -hessian_blending_2_0_0_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_2_1_0_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_2_2_0_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_45 = -hessian_blending_2_0_1_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_2_1_1_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_2_2_1_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_46 = -hessian_blending_2_0_2_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_2_1_2_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_2_2_2_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_47 = jac_blending_inv_0_0_q_0*tmp_kernel_op_44 + jac_blending_inv_0_1_q_0*tmp_kernel_op_45 + jac_blending_inv_0_2_q_0*tmp_kernel_op_46;
             const real_t tmp_kernel_op_48 = jac_blending_inv_1_0_q_0*tmp_kernel_op_44 + jac_blending_inv_1_1_q_0*tmp_kernel_op_45 + jac_blending_inv_1_2_q_0*tmp_kernel_op_46;
             const real_t tmp_kernel_op_49 = jac_blending_inv_2_0_q_0*tmp_kernel_op_44 + jac_blending_inv_2_1_q_0*tmp_kernel_op_45 + jac_blending_inv_2_2_q_0*tmp_kernel_op_46;
             const real_t tmp_kernel_op_50 = -hessian_blending_0_0_0_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_0_1_0_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_0_2_0_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_51 = -hessian_blending_0_0_1_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_0_1_1_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_0_2_1_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_52 = -hessian_blending_0_0_2_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_0_1_2_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_0_2_2_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_53 = jac_blending_inv_0_0_q_0*tmp_kernel_op_50 + jac_blending_inv_0_1_q_0*tmp_kernel_op_51 + jac_blending_inv_0_2_q_0*tmp_kernel_op_52;
             const real_t tmp_kernel_op_54 = jac_blending_inv_1_0_q_0*tmp_kernel_op_50 + jac_blending_inv_1_1_q_0*tmp_kernel_op_51 + jac_blending_inv_1_2_q_0*tmp_kernel_op_52;
             const real_t tmp_kernel_op_55 = jac_blending_inv_2_0_q_0*tmp_kernel_op_50 + jac_blending_inv_2_1_q_0*tmp_kernel_op_51 + jac_blending_inv_2_2_q_0*tmp_kernel_op_52;
             const real_t tmp_kernel_op_56 = -hessian_blending_1_0_0_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_1_1_0_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_1_2_0_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_57 = -hessian_blending_1_0_1_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_1_1_1_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_1_2_1_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_58 = -hessian_blending_1_0_2_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_1_1_2_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_1_2_2_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_59 = jac_blending_inv_0_0_q_0*tmp_kernel_op_56 + jac_blending_inv_0_1_q_0*tmp_kernel_op_57 + jac_blending_inv_0_2_q_0*tmp_kernel_op_58;
             const real_t tmp_kernel_op_60 = jac_blending_inv_1_0_q_0*tmp_kernel_op_56 + jac_blending_inv_1_1_q_0*tmp_kernel_op_57 + jac_blending_inv_1_2_q_0*tmp_kernel_op_58;
             const real_t tmp_kernel_op_61 = jac_blending_inv_2_0_q_0*tmp_kernel_op_56 + jac_blending_inv_2_1_q_0*tmp_kernel_op_57 + jac_blending_inv_2_2_q_0*tmp_kernel_op_58;
             const real_t tmp_kernel_op_62 = -hessian_blending_2_0_0_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_2_1_0_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_2_2_0_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_63 = -hessian_blending_2_0_1_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_2_1_1_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_2_2_1_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_64 = -hessian_blending_2_0_2_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_2_1_2_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_2_2_2_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_65 = jac_blending_inv_0_0_q_0*tmp_kernel_op_62 + jac_blending_inv_0_1_q_0*tmp_kernel_op_63 + jac_blending_inv_0_2_q_0*tmp_kernel_op_64;
             const real_t tmp_kernel_op_66 = jac_blending_inv_1_0_q_0*tmp_kernel_op_62 + jac_blending_inv_1_1_q_0*tmp_kernel_op_63 + jac_blending_inv_1_2_q_0*tmp_kernel_op_64;
             const real_t tmp_kernel_op_67 = jac_blending_inv_2_0_q_0*tmp_kernel_op_62 + jac_blending_inv_2_1_q_0*tmp_kernel_op_63 + jac_blending_inv_2_2_q_0*tmp_kernel_op_64;
             const real_t tmp_kernel_op_68 = -hessian_blending_0_0_0_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_0_1_0_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_0_2_0_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_69 = -hessian_blending_0_0_1_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_0_1_1_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_0_2_1_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_70 = -hessian_blending_0_0_2_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_0_1_2_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_0_2_2_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_71 = jac_blending_inv_0_0_q_0*tmp_kernel_op_68 + jac_blending_inv_0_1_q_0*tmp_kernel_op_69 + jac_blending_inv_0_2_q_0*tmp_kernel_op_70;
             const real_t tmp_kernel_op_72 = jac_blending_inv_1_0_q_0*tmp_kernel_op_68 + jac_blending_inv_1_1_q_0*tmp_kernel_op_69 + jac_blending_inv_1_2_q_0*tmp_kernel_op_70;
             const real_t tmp_kernel_op_73 = jac_blending_inv_2_0_q_0*tmp_kernel_op_68 + jac_blending_inv_2_1_q_0*tmp_kernel_op_69 + jac_blending_inv_2_2_q_0*tmp_kernel_op_70;
             const real_t tmp_kernel_op_74 = -hessian_blending_1_0_0_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_1_1_0_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_1_2_0_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_75 = -hessian_blending_1_0_1_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_1_1_1_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_1_2_1_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_76 = -hessian_blending_1_0_2_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_1_1_2_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_1_2_2_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_77 = jac_blending_inv_0_0_q_0*tmp_kernel_op_74 + jac_blending_inv_0_1_q_0*tmp_kernel_op_75 + jac_blending_inv_0_2_q_0*tmp_kernel_op_76;
             const real_t tmp_kernel_op_78 = jac_blending_inv_1_0_q_0*tmp_kernel_op_74 + jac_blending_inv_1_1_q_0*tmp_kernel_op_75 + jac_blending_inv_1_2_q_0*tmp_kernel_op_76;
             const real_t tmp_kernel_op_79 = jac_blending_inv_2_0_q_0*tmp_kernel_op_74 + jac_blending_inv_2_1_q_0*tmp_kernel_op_75 + jac_blending_inv_2_2_q_0*tmp_kernel_op_76;
             const real_t tmp_kernel_op_80 = -hessian_blending_2_0_0_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_2_1_0_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_2_2_0_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_81 = -hessian_blending_2_0_1_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_2_1_1_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_2_2_1_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_82 = -hessian_blending_2_0_2_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_2_1_2_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_2_2_2_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_83 = jac_blending_inv_0_0_q_0*tmp_kernel_op_80 + jac_blending_inv_0_1_q_0*tmp_kernel_op_81 + jac_blending_inv_0_2_q_0*tmp_kernel_op_82;
             const real_t tmp_kernel_op_84 = jac_blending_inv_1_0_q_0*tmp_kernel_op_80 + jac_blending_inv_1_1_q_0*tmp_kernel_op_81 + jac_blending_inv_1_2_q_0*tmp_kernel_op_82;
             const real_t tmp_kernel_op_85 = jac_blending_inv_2_0_q_0*tmp_kernel_op_80 + jac_blending_inv_2_1_q_0*tmp_kernel_op_81 + jac_blending_inv_2_2_q_0*tmp_kernel_op_82;
             const real_t tmp_kernel_op_86 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_374 + jac_blending_inv_1_0_q_0*tmp_moved_constant_380 + jac_blending_inv_2_0_q_0*tmp_moved_constant_386) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_393 + tmp_kernel_op_35*tmp_moved_constant_394 + tmp_kernel_op_37*tmp_moved_constant_395) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_374 + jac_blending_inv_1_1_q_0*tmp_moved_constant_380 + jac_blending_inv_2_1_q_0*tmp_moved_constant_386) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_393 + tmp_kernel_op_42*tmp_moved_constant_394 + tmp_kernel_op_43*tmp_moved_constant_395) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_374 + jac_blending_inv_1_2_q_0*tmp_moved_constant_380 + jac_blending_inv_2_2_q_0*tmp_moved_constant_386) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_393 + tmp_kernel_op_48*tmp_moved_constant_394 + tmp_kernel_op_49*tmp_moved_constant_395) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_387 + jac_blending_inv_1_0_q_0*tmp_moved_constant_388 + jac_blending_inv_2_0_q_0*tmp_moved_constant_389) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_393 + tmp_kernel_op_54*tmp_moved_constant_394 + tmp_kernel_op_55*tmp_moved_constant_395) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_387 + jac_blending_inv_1_1_q_0*tmp_moved_constant_388 + jac_blending_inv_2_1_q_0*tmp_moved_constant_389) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_393 + tmp_kernel_op_60*tmp_moved_constant_394 + tmp_kernel_op_61*tmp_moved_constant_395) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_387 + jac_blending_inv_1_2_q_0*tmp_moved_constant_388 + jac_blending_inv_2_2_q_0*tmp_moved_constant_389) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_393 + tmp_kernel_op_66*tmp_moved_constant_394 + tmp_kernel_op_67*tmp_moved_constant_395) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_390 + jac_blending_inv_1_0_q_0*tmp_moved_constant_391 + jac_blending_inv_2_0_q_0*tmp_moved_constant_392) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_393 + tmp_kernel_op_72*tmp_moved_constant_394 + tmp_kernel_op_73*tmp_moved_constant_395) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_390 + jac_blending_inv_1_1_q_0*tmp_moved_constant_391 + jac_blending_inv_2_1_q_0*tmp_moved_constant_392) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_393 + tmp_kernel_op_78*tmp_moved_constant_394 + tmp_kernel_op_79*tmp_moved_constant_395) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_390 + jac_blending_inv_1_2_q_0*tmp_moved_constant_391 + jac_blending_inv_2_2_q_0*tmp_moved_constant_392) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_393 + tmp_kernel_op_84*tmp_moved_constant_394 + tmp_kernel_op_85*tmp_moved_constant_395);
             const real_t tmp_kernel_op_104 = tmp_kernel_op_100*wx_dof_8 + tmp_kernel_op_102*wx_dof_9 + tmp_kernel_op_103*wx_dof_0 + tmp_kernel_op_87*wx_dof_4 + tmp_kernel_op_88*wx_dof_5 + tmp_kernel_op_89*wx_dof_6 + tmp_kernel_op_92*wx_dof_1 + tmp_kernel_op_95*wx_dof_2 + tmp_kernel_op_98*wx_dof_3 + tmp_kernel_op_99*wx_dof_7;
             const real_t tmp_kernel_op_105 = tmp_kernel_op_100*wy_dof_8 + tmp_kernel_op_102*wy_dof_9 + tmp_kernel_op_103*wy_dof_0 + tmp_kernel_op_87*wy_dof_4 + tmp_kernel_op_88*wy_dof_5 + tmp_kernel_op_89*wy_dof_6 + tmp_kernel_op_92*wy_dof_1 + tmp_kernel_op_95*wy_dof_2 + tmp_kernel_op_98*wy_dof_3 + tmp_kernel_op_99*wy_dof_7;
             const real_t tmp_kernel_op_106 = tmp_kernel_op_100*wz_dof_8 + tmp_kernel_op_102*wz_dof_9 + tmp_kernel_op_103*wz_dof_0 + tmp_kernel_op_87*wz_dof_4 + tmp_kernel_op_88*wz_dof_5 + tmp_kernel_op_89*wz_dof_6 + tmp_kernel_op_92*wz_dof_1 + tmp_kernel_op_95*wz_dof_2 + tmp_kernel_op_98*wz_dof_3 + tmp_kernel_op_99*wz_dof_7;
             const real_t tmp_kernel_op_107 = abs_det_jac_affine_BLUE_UP*abs_det_jac_blending_q_0*(diffusivity_times_delta_dof_0*tmp_kernel_op_103 + diffusivity_times_delta_dof_1*tmp_kernel_op_92 + diffusivity_times_delta_dof_2*tmp_kernel_op_95 + diffusivity_times_delta_dof_3*tmp_kernel_op_98 + diffusivity_times_delta_dof_4*tmp_kernel_op_87 + diffusivity_times_delta_dof_5*tmp_kernel_op_88 + diffusivity_times_delta_dof_6*tmp_kernel_op_89 + diffusivity_times_delta_dof_7*tmp_kernel_op_99 + diffusivity_times_delta_dof_8*tmp_kernel_op_100 + diffusivity_times_delta_dof_9*tmp_kernel_op_102)*-0.1333333333333333;
             const real_t tmp_kernel_op_108 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_393 + jac_blending_inv_1_0_q_0*tmp_moved_constant_394 + jac_blending_inv_2_0_q_0*tmp_moved_constant_395) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_393 + jac_blending_inv_1_1_q_0*tmp_moved_constant_394 + jac_blending_inv_2_1_q_0*tmp_moved_constant_395) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_393 + jac_blending_inv_1_2_q_0*tmp_moved_constant_394 + jac_blending_inv_2_2_q_0*tmp_moved_constant_395));
             const real_t tmp_kernel_op_115 = -hessian_blending_0_0_0_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_0_1_0_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_0_2_0_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_116 = -hessian_blending_0_0_1_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_0_1_1_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_0_2_1_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_117 = -hessian_blending_0_0_2_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_0_1_2_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_0_2_2_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_118 = jac_blending_inv_0_0_q_1*tmp_kernel_op_115 + jac_blending_inv_0_1_q_1*tmp_kernel_op_116 + jac_blending_inv_0_2_q_1*tmp_kernel_op_117;
             const real_t tmp_kernel_op_120 = jac_blending_inv_1_0_q_1*tmp_kernel_op_115 + jac_blending_inv_1_1_q_1*tmp_kernel_op_116 + jac_blending_inv_1_2_q_1*tmp_kernel_op_117;
             const real_t tmp_kernel_op_122 = jac_blending_inv_2_0_q_1*tmp_kernel_op_115 + jac_blending_inv_2_1_q_1*tmp_kernel_op_116 + jac_blending_inv_2_2_q_1*tmp_kernel_op_117;
             const real_t tmp_kernel_op_123 = -hessian_blending_1_0_0_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_1_1_0_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_1_2_0_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_124 = -hessian_blending_1_0_1_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_1_1_1_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_1_2_1_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_125 = -hessian_blending_1_0_2_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_1_1_2_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_1_2_2_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_126 = jac_blending_inv_0_0_q_1*tmp_kernel_op_123 + jac_blending_inv_0_1_q_1*tmp_kernel_op_124 + jac_blending_inv_0_2_q_1*tmp_kernel_op_125;
             const real_t tmp_kernel_op_127 = jac_blending_inv_1_0_q_1*tmp_kernel_op_123 + jac_blending_inv_1_1_q_1*tmp_kernel_op_124 + jac_blending_inv_1_2_q_1*tmp_kernel_op_125;
             const real_t tmp_kernel_op_128 = jac_blending_inv_2_0_q_1*tmp_kernel_op_123 + jac_blending_inv_2_1_q_1*tmp_kernel_op_124 + jac_blending_inv_2_2_q_1*tmp_kernel_op_125;
             const real_t tmp_kernel_op_129 = -hessian_blending_2_0_0_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_2_1_0_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_2_2_0_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_130 = -hessian_blending_2_0_1_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_2_1_1_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_2_2_1_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_131 = -hessian_blending_2_0_2_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_2_1_2_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_2_2_2_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_132 = jac_blending_inv_0_0_q_1*tmp_kernel_op_129 + jac_blending_inv_0_1_q_1*tmp_kernel_op_130 + jac_blending_inv_0_2_q_1*tmp_kernel_op_131;
             const real_t tmp_kernel_op_133 = jac_blending_inv_1_0_q_1*tmp_kernel_op_129 + jac_blending_inv_1_1_q_1*tmp_kernel_op_130 + jac_blending_inv_1_2_q_1*tmp_kernel_op_131;
             const real_t tmp_kernel_op_134 = jac_blending_inv_2_0_q_1*tmp_kernel_op_129 + jac_blending_inv_2_1_q_1*tmp_kernel_op_130 + jac_blending_inv_2_2_q_1*tmp_kernel_op_131;
             const real_t tmp_kernel_op_135 = -hessian_blending_0_0_0_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_0_1_0_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_0_2_0_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_136 = -hessian_blending_0_0_1_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_0_1_1_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_0_2_1_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_137 = -hessian_blending_0_0_2_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_0_1_2_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_0_2_2_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_138 = jac_blending_inv_0_0_q_1*tmp_kernel_op_135 + jac_blending_inv_0_1_q_1*tmp_kernel_op_136 + jac_blending_inv_0_2_q_1*tmp_kernel_op_137;
             const real_t tmp_kernel_op_139 = jac_blending_inv_1_0_q_1*tmp_kernel_op_135 + jac_blending_inv_1_1_q_1*tmp_kernel_op_136 + jac_blending_inv_1_2_q_1*tmp_kernel_op_137;
             const real_t tmp_kernel_op_140 = jac_blending_inv_2_0_q_1*tmp_kernel_op_135 + jac_blending_inv_2_1_q_1*tmp_kernel_op_136 + jac_blending_inv_2_2_q_1*tmp_kernel_op_137;
             const real_t tmp_kernel_op_141 = -hessian_blending_1_0_0_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_1_1_0_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_1_2_0_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_142 = -hessian_blending_1_0_1_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_1_1_1_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_1_2_1_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_143 = -hessian_blending_1_0_2_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_1_1_2_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_1_2_2_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_144 = jac_blending_inv_0_0_q_1*tmp_kernel_op_141 + jac_blending_inv_0_1_q_1*tmp_kernel_op_142 + jac_blending_inv_0_2_q_1*tmp_kernel_op_143;
             const real_t tmp_kernel_op_145 = jac_blending_inv_1_0_q_1*tmp_kernel_op_141 + jac_blending_inv_1_1_q_1*tmp_kernel_op_142 + jac_blending_inv_1_2_q_1*tmp_kernel_op_143;
             const real_t tmp_kernel_op_146 = jac_blending_inv_2_0_q_1*tmp_kernel_op_141 + jac_blending_inv_2_1_q_1*tmp_kernel_op_142 + jac_blending_inv_2_2_q_1*tmp_kernel_op_143;
             const real_t tmp_kernel_op_147 = -hessian_blending_2_0_0_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_2_1_0_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_2_2_0_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_148 = -hessian_blending_2_0_1_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_2_1_1_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_2_2_1_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_149 = -hessian_blending_2_0_2_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_2_1_2_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_2_2_2_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_150 = jac_blending_inv_0_0_q_1*tmp_kernel_op_147 + jac_blending_inv_0_1_q_1*tmp_kernel_op_148 + jac_blending_inv_0_2_q_1*tmp_kernel_op_149;
             const real_t tmp_kernel_op_151 = jac_blending_inv_1_0_q_1*tmp_kernel_op_147 + jac_blending_inv_1_1_q_1*tmp_kernel_op_148 + jac_blending_inv_1_2_q_1*tmp_kernel_op_149;
             const real_t tmp_kernel_op_152 = jac_blending_inv_2_0_q_1*tmp_kernel_op_147 + jac_blending_inv_2_1_q_1*tmp_kernel_op_148 + jac_blending_inv_2_2_q_1*tmp_kernel_op_149;
             const real_t tmp_kernel_op_153 = -hessian_blending_0_0_0_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_0_1_0_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_0_2_0_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_154 = -hessian_blending_0_0_1_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_0_1_1_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_0_2_1_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_155 = -hessian_blending_0_0_2_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_0_1_2_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_0_2_2_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_156 = jac_blending_inv_0_0_q_1*tmp_kernel_op_153 + jac_blending_inv_0_1_q_1*tmp_kernel_op_154 + jac_blending_inv_0_2_q_1*tmp_kernel_op_155;
             const real_t tmp_kernel_op_157 = jac_blending_inv_1_0_q_1*tmp_kernel_op_153 + jac_blending_inv_1_1_q_1*tmp_kernel_op_154 + jac_blending_inv_1_2_q_1*tmp_kernel_op_155;
             const real_t tmp_kernel_op_158 = jac_blending_inv_2_0_q_1*tmp_kernel_op_153 + jac_blending_inv_2_1_q_1*tmp_kernel_op_154 + jac_blending_inv_2_2_q_1*tmp_kernel_op_155;
             const real_t tmp_kernel_op_159 = -hessian_blending_1_0_0_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_1_1_0_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_1_2_0_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_160 = -hessian_blending_1_0_1_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_1_1_1_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_1_2_1_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_161 = -hessian_blending_1_0_2_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_1_1_2_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_1_2_2_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_162 = jac_blending_inv_0_0_q_1*tmp_kernel_op_159 + jac_blending_inv_0_1_q_1*tmp_kernel_op_160 + jac_blending_inv_0_2_q_1*tmp_kernel_op_161;
             const real_t tmp_kernel_op_163 = jac_blending_inv_1_0_q_1*tmp_kernel_op_159 + jac_blending_inv_1_1_q_1*tmp_kernel_op_160 + jac_blending_inv_1_2_q_1*tmp_kernel_op_161;
             const real_t tmp_kernel_op_164 = jac_blending_inv_2_0_q_1*tmp_kernel_op_159 + jac_blending_inv_2_1_q_1*tmp_kernel_op_160 + jac_blending_inv_2_2_q_1*tmp_kernel_op_161;
             const real_t tmp_kernel_op_165 = -hessian_blending_2_0_0_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_2_1_0_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_2_2_0_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_166 = -hessian_blending_2_0_1_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_2_1_1_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_2_2_1_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_167 = -hessian_blending_2_0_2_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_2_1_2_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_2_2_2_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_168 = jac_blending_inv_0_0_q_1*tmp_kernel_op_165 + jac_blending_inv_0_1_q_1*tmp_kernel_op_166 + jac_blending_inv_0_2_q_1*tmp_kernel_op_167;
             const real_t tmp_kernel_op_169 = jac_blending_inv_1_0_q_1*tmp_kernel_op_165 + jac_blending_inv_1_1_q_1*tmp_kernel_op_166 + jac_blending_inv_1_2_q_1*tmp_kernel_op_167;
             const real_t tmp_kernel_op_170 = jac_blending_inv_2_0_q_1*tmp_kernel_op_165 + jac_blending_inv_2_1_q_1*tmp_kernel_op_166 + jac_blending_inv_2_2_q_1*tmp_kernel_op_167;
             const real_t tmp_kernel_op_171 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_374 + jac_blending_inv_1_0_q_1*tmp_moved_constant_380 + jac_blending_inv_2_0_q_1*tmp_moved_constant_386) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_396 + tmp_kernel_op_120*tmp_moved_constant_397 + tmp_kernel_op_122*tmp_moved_constant_398) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_374 + jac_blending_inv_1_1_q_1*tmp_moved_constant_380 + jac_blending_inv_2_1_q_1*tmp_moved_constant_386) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_396 + tmp_kernel_op_127*tmp_moved_constant_397 + tmp_kernel_op_128*tmp_moved_constant_398) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_374 + jac_blending_inv_1_2_q_1*tmp_moved_constant_380 + jac_blending_inv_2_2_q_1*tmp_moved_constant_386) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_396 + tmp_kernel_op_133*tmp_moved_constant_397 + tmp_kernel_op_134*tmp_moved_constant_398) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_387 + jac_blending_inv_1_0_q_1*tmp_moved_constant_388 + jac_blending_inv_2_0_q_1*tmp_moved_constant_389) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_396 + tmp_kernel_op_139*tmp_moved_constant_397 + tmp_kernel_op_140*tmp_moved_constant_398) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_387 + jac_blending_inv_1_1_q_1*tmp_moved_constant_388 + jac_blending_inv_2_1_q_1*tmp_moved_constant_389) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_396 + tmp_kernel_op_145*tmp_moved_constant_397 + tmp_kernel_op_146*tmp_moved_constant_398) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_387 + jac_blending_inv_1_2_q_1*tmp_moved_constant_388 + jac_blending_inv_2_2_q_1*tmp_moved_constant_389) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_396 + tmp_kernel_op_151*tmp_moved_constant_397 + tmp_kernel_op_152*tmp_moved_constant_398) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_390 + jac_blending_inv_1_0_q_1*tmp_moved_constant_391 + jac_blending_inv_2_0_q_1*tmp_moved_constant_392) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_396 + tmp_kernel_op_157*tmp_moved_constant_397 + tmp_kernel_op_158*tmp_moved_constant_398) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_390 + jac_blending_inv_1_1_q_1*tmp_moved_constant_391 + jac_blending_inv_2_1_q_1*tmp_moved_constant_392) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_396 + tmp_kernel_op_163*tmp_moved_constant_397 + tmp_kernel_op_164*tmp_moved_constant_398) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_390 + jac_blending_inv_1_2_q_1*tmp_moved_constant_391 + jac_blending_inv_2_2_q_1*tmp_moved_constant_392) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_396 + tmp_kernel_op_169*tmp_moved_constant_397 + tmp_kernel_op_170*tmp_moved_constant_398);
             const real_t tmp_kernel_op_189 = tmp_kernel_op_172*wx_dof_4 + tmp_kernel_op_173*wx_dof_5 + tmp_kernel_op_174*wx_dof_6 + tmp_kernel_op_177*wx_dof_1 + tmp_kernel_op_180*wx_dof_2 + tmp_kernel_op_183*wx_dof_3 + tmp_kernel_op_184*wx_dof_7 + tmp_kernel_op_185*wx_dof_8 + tmp_kernel_op_187*wx_dof_9 + tmp_kernel_op_188*wx_dof_0;
             const real_t tmp_kernel_op_190 = tmp_kernel_op_172*wy_dof_4 + tmp_kernel_op_173*wy_dof_5 + tmp_kernel_op_174*wy_dof_6 + tmp_kernel_op_177*wy_dof_1 + tmp_kernel_op_180*wy_dof_2 + tmp_kernel_op_183*wy_dof_3 + tmp_kernel_op_184*wy_dof_7 + tmp_kernel_op_185*wy_dof_8 + tmp_kernel_op_187*wy_dof_9 + tmp_kernel_op_188*wy_dof_0;
             const real_t tmp_kernel_op_191 = tmp_kernel_op_172*wz_dof_4 + tmp_kernel_op_173*wz_dof_5 + tmp_kernel_op_174*wz_dof_6 + tmp_kernel_op_177*wz_dof_1 + tmp_kernel_op_180*wz_dof_2 + tmp_kernel_op_183*wz_dof_3 + tmp_kernel_op_184*wz_dof_7 + tmp_kernel_op_185*wz_dof_8 + tmp_kernel_op_187*wz_dof_9 + tmp_kernel_op_188*wz_dof_0;
             const real_t tmp_kernel_op_192 = abs_det_jac_affine_BLUE_UP*abs_det_jac_blending_q_1*(diffusivity_times_delta_dof_0*tmp_kernel_op_188 + diffusivity_times_delta_dof_1*tmp_kernel_op_177 + diffusivity_times_delta_dof_2*tmp_kernel_op_180 + diffusivity_times_delta_dof_3*tmp_kernel_op_183 + diffusivity_times_delta_dof_4*tmp_kernel_op_172 + diffusivity_times_delta_dof_5*tmp_kernel_op_173 + diffusivity_times_delta_dof_6*tmp_kernel_op_174 + diffusivity_times_delta_dof_7*tmp_kernel_op_184 + diffusivity_times_delta_dof_8*tmp_kernel_op_185 + diffusivity_times_delta_dof_9*tmp_kernel_op_187)*0.074999999999999983;
             const real_t tmp_kernel_op_193 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_396 + jac_blending_inv_1_0_q_1*tmp_moved_constant_397 + jac_blending_inv_2_0_q_1*tmp_moved_constant_398) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_396 + jac_blending_inv_1_1_q_1*tmp_moved_constant_397 + jac_blending_inv_2_1_q_1*tmp_moved_constant_398) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_396 + jac_blending_inv_1_2_q_1*tmp_moved_constant_397 + jac_blending_inv_2_2_q_1*tmp_moved_constant_398));
             const real_t tmp_kernel_op_200 = -hessian_blending_0_0_0_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_0_1_0_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_0_2_0_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_201 = -hessian_blending_0_0_1_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_0_1_1_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_0_2_1_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_202 = -hessian_blending_0_0_2_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_0_1_2_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_0_2_2_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_203 = jac_blending_inv_0_0_q_2*tmp_kernel_op_200 + jac_blending_inv_0_1_q_2*tmp_kernel_op_201 + jac_blending_inv_0_2_q_2*tmp_kernel_op_202;
             const real_t tmp_kernel_op_205 = jac_blending_inv_1_0_q_2*tmp_kernel_op_200 + jac_blending_inv_1_1_q_2*tmp_kernel_op_201 + jac_blending_inv_1_2_q_2*tmp_kernel_op_202;
             const real_t tmp_kernel_op_207 = jac_blending_inv_2_0_q_2*tmp_kernel_op_200 + jac_blending_inv_2_1_q_2*tmp_kernel_op_201 + jac_blending_inv_2_2_q_2*tmp_kernel_op_202;
             const real_t tmp_kernel_op_208 = -hessian_blending_1_0_0_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_1_1_0_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_1_2_0_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_209 = -hessian_blending_1_0_1_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_1_1_1_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_1_2_1_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_210 = -hessian_blending_1_0_2_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_1_1_2_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_1_2_2_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_211 = jac_blending_inv_0_0_q_2*tmp_kernel_op_208 + jac_blending_inv_0_1_q_2*tmp_kernel_op_209 + jac_blending_inv_0_2_q_2*tmp_kernel_op_210;
             const real_t tmp_kernel_op_212 = jac_blending_inv_1_0_q_2*tmp_kernel_op_208 + jac_blending_inv_1_1_q_2*tmp_kernel_op_209 + jac_blending_inv_1_2_q_2*tmp_kernel_op_210;
             const real_t tmp_kernel_op_213 = jac_blending_inv_2_0_q_2*tmp_kernel_op_208 + jac_blending_inv_2_1_q_2*tmp_kernel_op_209 + jac_blending_inv_2_2_q_2*tmp_kernel_op_210;
             const real_t tmp_kernel_op_214 = -hessian_blending_2_0_0_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_2_1_0_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_2_2_0_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_215 = -hessian_blending_2_0_1_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_2_1_1_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_2_2_1_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_216 = -hessian_blending_2_0_2_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_2_1_2_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_2_2_2_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_217 = jac_blending_inv_0_0_q_2*tmp_kernel_op_214 + jac_blending_inv_0_1_q_2*tmp_kernel_op_215 + jac_blending_inv_0_2_q_2*tmp_kernel_op_216;
             const real_t tmp_kernel_op_218 = jac_blending_inv_1_0_q_2*tmp_kernel_op_214 + jac_blending_inv_1_1_q_2*tmp_kernel_op_215 + jac_blending_inv_1_2_q_2*tmp_kernel_op_216;
             const real_t tmp_kernel_op_219 = jac_blending_inv_2_0_q_2*tmp_kernel_op_214 + jac_blending_inv_2_1_q_2*tmp_kernel_op_215 + jac_blending_inv_2_2_q_2*tmp_kernel_op_216;
             const real_t tmp_kernel_op_220 = -hessian_blending_0_0_0_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_0_1_0_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_0_2_0_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_221 = -hessian_blending_0_0_1_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_0_1_1_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_0_2_1_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_222 = -hessian_blending_0_0_2_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_0_1_2_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_0_2_2_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_223 = jac_blending_inv_0_0_q_2*tmp_kernel_op_220 + jac_blending_inv_0_1_q_2*tmp_kernel_op_221 + jac_blending_inv_0_2_q_2*tmp_kernel_op_222;
             const real_t tmp_kernel_op_224 = jac_blending_inv_1_0_q_2*tmp_kernel_op_220 + jac_blending_inv_1_1_q_2*tmp_kernel_op_221 + jac_blending_inv_1_2_q_2*tmp_kernel_op_222;
             const real_t tmp_kernel_op_225 = jac_blending_inv_2_0_q_2*tmp_kernel_op_220 + jac_blending_inv_2_1_q_2*tmp_kernel_op_221 + jac_blending_inv_2_2_q_2*tmp_kernel_op_222;
             const real_t tmp_kernel_op_226 = -hessian_blending_1_0_0_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_1_1_0_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_1_2_0_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_227 = -hessian_blending_1_0_1_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_1_1_1_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_1_2_1_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_228 = -hessian_blending_1_0_2_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_1_1_2_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_1_2_2_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_229 = jac_blending_inv_0_0_q_2*tmp_kernel_op_226 + jac_blending_inv_0_1_q_2*tmp_kernel_op_227 + jac_blending_inv_0_2_q_2*tmp_kernel_op_228;
             const real_t tmp_kernel_op_230 = jac_blending_inv_1_0_q_2*tmp_kernel_op_226 + jac_blending_inv_1_1_q_2*tmp_kernel_op_227 + jac_blending_inv_1_2_q_2*tmp_kernel_op_228;
             const real_t tmp_kernel_op_231 = jac_blending_inv_2_0_q_2*tmp_kernel_op_226 + jac_blending_inv_2_1_q_2*tmp_kernel_op_227 + jac_blending_inv_2_2_q_2*tmp_kernel_op_228;
             const real_t tmp_kernel_op_232 = -hessian_blending_2_0_0_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_2_1_0_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_2_2_0_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_233 = -hessian_blending_2_0_1_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_2_1_1_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_2_2_1_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_234 = -hessian_blending_2_0_2_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_2_1_2_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_2_2_2_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_235 = jac_blending_inv_0_0_q_2*tmp_kernel_op_232 + jac_blending_inv_0_1_q_2*tmp_kernel_op_233 + jac_blending_inv_0_2_q_2*tmp_kernel_op_234;
             const real_t tmp_kernel_op_236 = jac_blending_inv_1_0_q_2*tmp_kernel_op_232 + jac_blending_inv_1_1_q_2*tmp_kernel_op_233 + jac_blending_inv_1_2_q_2*tmp_kernel_op_234;
             const real_t tmp_kernel_op_237 = jac_blending_inv_2_0_q_2*tmp_kernel_op_232 + jac_blending_inv_2_1_q_2*tmp_kernel_op_233 + jac_blending_inv_2_2_q_2*tmp_kernel_op_234;
             const real_t tmp_kernel_op_238 = -hessian_blending_0_0_0_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_0_1_0_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_0_2_0_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_239 = -hessian_blending_0_0_1_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_0_1_1_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_0_2_1_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_240 = -hessian_blending_0_0_2_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_0_1_2_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_0_2_2_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_241 = jac_blending_inv_0_0_q_2*tmp_kernel_op_238 + jac_blending_inv_0_1_q_2*tmp_kernel_op_239 + jac_blending_inv_0_2_q_2*tmp_kernel_op_240;
             const real_t tmp_kernel_op_242 = jac_blending_inv_1_0_q_2*tmp_kernel_op_238 + jac_blending_inv_1_1_q_2*tmp_kernel_op_239 + jac_blending_inv_1_2_q_2*tmp_kernel_op_240;
             const real_t tmp_kernel_op_243 = jac_blending_inv_2_0_q_2*tmp_kernel_op_238 + jac_blending_inv_2_1_q_2*tmp_kernel_op_239 + jac_blending_inv_2_2_q_2*tmp_kernel_op_240;
             const real_t tmp_kernel_op_244 = -hessian_blending_1_0_0_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_1_1_0_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_1_2_0_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_245 = -hessian_blending_1_0_1_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_1_1_1_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_1_2_1_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_246 = -hessian_blending_1_0_2_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_1_1_2_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_1_2_2_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_247 = jac_blending_inv_0_0_q_2*tmp_kernel_op_244 + jac_blending_inv_0_1_q_2*tmp_kernel_op_245 + jac_blending_inv_0_2_q_2*tmp_kernel_op_246;
             const real_t tmp_kernel_op_248 = jac_blending_inv_1_0_q_2*tmp_kernel_op_244 + jac_blending_inv_1_1_q_2*tmp_kernel_op_245 + jac_blending_inv_1_2_q_2*tmp_kernel_op_246;
             const real_t tmp_kernel_op_249 = jac_blending_inv_2_0_q_2*tmp_kernel_op_244 + jac_blending_inv_2_1_q_2*tmp_kernel_op_245 + jac_blending_inv_2_2_q_2*tmp_kernel_op_246;
             const real_t tmp_kernel_op_250 = -hessian_blending_2_0_0_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_2_1_0_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_2_2_0_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_251 = -hessian_blending_2_0_1_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_2_1_1_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_2_2_1_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_252 = -hessian_blending_2_0_2_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_2_1_2_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_2_2_2_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_253 = jac_blending_inv_0_0_q_2*tmp_kernel_op_250 + jac_blending_inv_0_1_q_2*tmp_kernel_op_251 + jac_blending_inv_0_2_q_2*tmp_kernel_op_252;
             const real_t tmp_kernel_op_254 = jac_blending_inv_1_0_q_2*tmp_kernel_op_250 + jac_blending_inv_1_1_q_2*tmp_kernel_op_251 + jac_blending_inv_1_2_q_2*tmp_kernel_op_252;
             const real_t tmp_kernel_op_255 = jac_blending_inv_2_0_q_2*tmp_kernel_op_250 + jac_blending_inv_2_1_q_2*tmp_kernel_op_251 + jac_blending_inv_2_2_q_2*tmp_kernel_op_252;
             const real_t tmp_kernel_op_256 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_374 + jac_blending_inv_1_0_q_2*tmp_moved_constant_380 + jac_blending_inv_2_0_q_2*tmp_moved_constant_386) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_399 + tmp_kernel_op_205*tmp_moved_constant_400 + tmp_kernel_op_207*tmp_moved_constant_401) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_374 + jac_blending_inv_1_1_q_2*tmp_moved_constant_380 + jac_blending_inv_2_1_q_2*tmp_moved_constant_386) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_399 + tmp_kernel_op_212*tmp_moved_constant_400 + tmp_kernel_op_213*tmp_moved_constant_401) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_374 + jac_blending_inv_1_2_q_2*tmp_moved_constant_380 + jac_blending_inv_2_2_q_2*tmp_moved_constant_386) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_399 + tmp_kernel_op_218*tmp_moved_constant_400 + tmp_kernel_op_219*tmp_moved_constant_401) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_387 + jac_blending_inv_1_0_q_2*tmp_moved_constant_388 + jac_blending_inv_2_0_q_2*tmp_moved_constant_389) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_399 + tmp_kernel_op_224*tmp_moved_constant_400 + tmp_kernel_op_225*tmp_moved_constant_401) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_387 + jac_blending_inv_1_1_q_2*tmp_moved_constant_388 + jac_blending_inv_2_1_q_2*tmp_moved_constant_389) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_399 + tmp_kernel_op_230*tmp_moved_constant_400 + tmp_kernel_op_231*tmp_moved_constant_401) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_387 + jac_blending_inv_1_2_q_2*tmp_moved_constant_388 + jac_blending_inv_2_2_q_2*tmp_moved_constant_389) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_399 + tmp_kernel_op_236*tmp_moved_constant_400 + tmp_kernel_op_237*tmp_moved_constant_401) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_390 + jac_blending_inv_1_0_q_2*tmp_moved_constant_391 + jac_blending_inv_2_0_q_2*tmp_moved_constant_392) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_399 + tmp_kernel_op_242*tmp_moved_constant_400 + tmp_kernel_op_243*tmp_moved_constant_401) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_390 + jac_blending_inv_1_1_q_2*tmp_moved_constant_391 + jac_blending_inv_2_1_q_2*tmp_moved_constant_392) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_399 + tmp_kernel_op_248*tmp_moved_constant_400 + tmp_kernel_op_249*tmp_moved_constant_401) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_390 + jac_blending_inv_1_2_q_2*tmp_moved_constant_391 + jac_blending_inv_2_2_q_2*tmp_moved_constant_392) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_399 + tmp_kernel_op_254*tmp_moved_constant_400 + tmp_kernel_op_255*tmp_moved_constant_401);
             const real_t tmp_kernel_op_274 = tmp_kernel_op_257*wx_dof_4 + tmp_kernel_op_258*wx_dof_5 + tmp_kernel_op_259*wx_dof_6 + tmp_kernel_op_262*wx_dof_1 + tmp_kernel_op_265*wx_dof_2 + tmp_kernel_op_268*wx_dof_3 + tmp_kernel_op_269*wx_dof_7 + tmp_kernel_op_270*wx_dof_8 + tmp_kernel_op_272*wx_dof_9 + tmp_kernel_op_273*wx_dof_0;
             const real_t tmp_kernel_op_275 = tmp_kernel_op_257*wy_dof_4 + tmp_kernel_op_258*wy_dof_5 + tmp_kernel_op_259*wy_dof_6 + tmp_kernel_op_262*wy_dof_1 + tmp_kernel_op_265*wy_dof_2 + tmp_kernel_op_268*wy_dof_3 + tmp_kernel_op_269*wy_dof_7 + tmp_kernel_op_270*wy_dof_8 + tmp_kernel_op_272*wy_dof_9 + tmp_kernel_op_273*wy_dof_0;
             const real_t tmp_kernel_op_276 = tmp_kernel_op_257*wz_dof_4 + tmp_kernel_op_258*wz_dof_5 + tmp_kernel_op_259*wz_dof_6 + tmp_kernel_op_262*wz_dof_1 + tmp_kernel_op_265*wz_dof_2 + tmp_kernel_op_268*wz_dof_3 + tmp_kernel_op_269*wz_dof_7 + tmp_kernel_op_270*wz_dof_8 + tmp_kernel_op_272*wz_dof_9 + tmp_kernel_op_273*wz_dof_0;
             const real_t tmp_kernel_op_277 = abs_det_jac_affine_BLUE_UP*abs_det_jac_blending_q_2*(diffusivity_times_delta_dof_0*tmp_kernel_op_273 + diffusivity_times_delta_dof_1*tmp_kernel_op_262 + diffusivity_times_delta_dof_2*tmp_kernel_op_265 + diffusivity_times_delta_dof_3*tmp_kernel_op_268 + diffusivity_times_delta_dof_4*tmp_kernel_op_257 + diffusivity_times_delta_dof_5*tmp_kernel_op_258 + diffusivity_times_delta_dof_6*tmp_kernel_op_259 + diffusivity_times_delta_dof_7*tmp_kernel_op_269 + diffusivity_times_delta_dof_8*tmp_kernel_op_270 + diffusivity_times_delta_dof_9*tmp_kernel_op_272)*0.074999999999999983;
             const real_t tmp_kernel_op_278 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_399 + jac_blending_inv_1_0_q_2*tmp_moved_constant_400 + jac_blending_inv_2_0_q_2*tmp_moved_constant_401) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_399 + jac_blending_inv_1_1_q_2*tmp_moved_constant_400 + jac_blending_inv_2_1_q_2*tmp_moved_constant_401) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_399 + jac_blending_inv_1_2_q_2*tmp_moved_constant_400 + jac_blending_inv_2_2_q_2*tmp_moved_constant_401));
             const real_t tmp_kernel_op_285 = -hessian_blending_0_0_0_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_0_1_0_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_0_2_0_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_286 = -hessian_blending_0_0_1_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_0_1_1_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_0_2_1_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_287 = -hessian_blending_0_0_2_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_0_1_2_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_0_2_2_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_288 = jac_blending_inv_0_0_q_3*tmp_kernel_op_285 + jac_blending_inv_0_1_q_3*tmp_kernel_op_286 + jac_blending_inv_0_2_q_3*tmp_kernel_op_287;
             const real_t tmp_kernel_op_290 = jac_blending_inv_1_0_q_3*tmp_kernel_op_285 + jac_blending_inv_1_1_q_3*tmp_kernel_op_286 + jac_blending_inv_1_2_q_3*tmp_kernel_op_287;
             const real_t tmp_kernel_op_292 = jac_blending_inv_2_0_q_3*tmp_kernel_op_285 + jac_blending_inv_2_1_q_3*tmp_kernel_op_286 + jac_blending_inv_2_2_q_3*tmp_kernel_op_287;
             const real_t tmp_kernel_op_293 = -hessian_blending_1_0_0_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_1_1_0_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_1_2_0_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_294 = -hessian_blending_1_0_1_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_1_1_1_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_1_2_1_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_295 = -hessian_blending_1_0_2_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_1_1_2_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_1_2_2_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_296 = jac_blending_inv_0_0_q_3*tmp_kernel_op_293 + jac_blending_inv_0_1_q_3*tmp_kernel_op_294 + jac_blending_inv_0_2_q_3*tmp_kernel_op_295;
             const real_t tmp_kernel_op_297 = jac_blending_inv_1_0_q_3*tmp_kernel_op_293 + jac_blending_inv_1_1_q_3*tmp_kernel_op_294 + jac_blending_inv_1_2_q_3*tmp_kernel_op_295;
             const real_t tmp_kernel_op_298 = jac_blending_inv_2_0_q_3*tmp_kernel_op_293 + jac_blending_inv_2_1_q_3*tmp_kernel_op_294 + jac_blending_inv_2_2_q_3*tmp_kernel_op_295;
             const real_t tmp_kernel_op_299 = -hessian_blending_2_0_0_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_2_1_0_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_2_2_0_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_300 = -hessian_blending_2_0_1_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_2_1_1_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_2_2_1_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_301 = -hessian_blending_2_0_2_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_2_1_2_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_2_2_2_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_302 = jac_blending_inv_0_0_q_3*tmp_kernel_op_299 + jac_blending_inv_0_1_q_3*tmp_kernel_op_300 + jac_blending_inv_0_2_q_3*tmp_kernel_op_301;
             const real_t tmp_kernel_op_303 = jac_blending_inv_1_0_q_3*tmp_kernel_op_299 + jac_blending_inv_1_1_q_3*tmp_kernel_op_300 + jac_blending_inv_1_2_q_3*tmp_kernel_op_301;
             const real_t tmp_kernel_op_304 = jac_blending_inv_2_0_q_3*tmp_kernel_op_299 + jac_blending_inv_2_1_q_3*tmp_kernel_op_300 + jac_blending_inv_2_2_q_3*tmp_kernel_op_301;
             const real_t tmp_kernel_op_305 = -hessian_blending_0_0_0_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_0_1_0_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_0_2_0_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_306 = -hessian_blending_0_0_1_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_0_1_1_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_0_2_1_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_307 = -hessian_blending_0_0_2_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_0_1_2_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_0_2_2_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_308 = jac_blending_inv_0_0_q_3*tmp_kernel_op_305 + jac_blending_inv_0_1_q_3*tmp_kernel_op_306 + jac_blending_inv_0_2_q_3*tmp_kernel_op_307;
             const real_t tmp_kernel_op_309 = jac_blending_inv_1_0_q_3*tmp_kernel_op_305 + jac_blending_inv_1_1_q_3*tmp_kernel_op_306 + jac_blending_inv_1_2_q_3*tmp_kernel_op_307;
             const real_t tmp_kernel_op_310 = jac_blending_inv_2_0_q_3*tmp_kernel_op_305 + jac_blending_inv_2_1_q_3*tmp_kernel_op_306 + jac_blending_inv_2_2_q_3*tmp_kernel_op_307;
             const real_t tmp_kernel_op_311 = -hessian_blending_1_0_0_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_1_1_0_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_1_2_0_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_312 = -hessian_blending_1_0_1_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_1_1_1_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_1_2_1_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_313 = -hessian_blending_1_0_2_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_1_1_2_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_1_2_2_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_314 = jac_blending_inv_0_0_q_3*tmp_kernel_op_311 + jac_blending_inv_0_1_q_3*tmp_kernel_op_312 + jac_blending_inv_0_2_q_3*tmp_kernel_op_313;
             const real_t tmp_kernel_op_315 = jac_blending_inv_1_0_q_3*tmp_kernel_op_311 + jac_blending_inv_1_1_q_3*tmp_kernel_op_312 + jac_blending_inv_1_2_q_3*tmp_kernel_op_313;
             const real_t tmp_kernel_op_316 = jac_blending_inv_2_0_q_3*tmp_kernel_op_311 + jac_blending_inv_2_1_q_3*tmp_kernel_op_312 + jac_blending_inv_2_2_q_3*tmp_kernel_op_313;
             const real_t tmp_kernel_op_317 = -hessian_blending_2_0_0_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_2_1_0_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_2_2_0_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_318 = -hessian_blending_2_0_1_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_2_1_1_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_2_2_1_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_319 = -hessian_blending_2_0_2_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_2_1_2_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_2_2_2_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_320 = jac_blending_inv_0_0_q_3*tmp_kernel_op_317 + jac_blending_inv_0_1_q_3*tmp_kernel_op_318 + jac_blending_inv_0_2_q_3*tmp_kernel_op_319;
             const real_t tmp_kernel_op_321 = jac_blending_inv_1_0_q_3*tmp_kernel_op_317 + jac_blending_inv_1_1_q_3*tmp_kernel_op_318 + jac_blending_inv_1_2_q_3*tmp_kernel_op_319;
             const real_t tmp_kernel_op_322 = jac_blending_inv_2_0_q_3*tmp_kernel_op_317 + jac_blending_inv_2_1_q_3*tmp_kernel_op_318 + jac_blending_inv_2_2_q_3*tmp_kernel_op_319;
             const real_t tmp_kernel_op_323 = -hessian_blending_0_0_0_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_0_1_0_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_0_2_0_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_324 = -hessian_blending_0_0_1_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_0_1_1_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_0_2_1_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_325 = -hessian_blending_0_0_2_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_0_1_2_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_0_2_2_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_326 = jac_blending_inv_0_0_q_3*tmp_kernel_op_323 + jac_blending_inv_0_1_q_3*tmp_kernel_op_324 + jac_blending_inv_0_2_q_3*tmp_kernel_op_325;
             const real_t tmp_kernel_op_327 = jac_blending_inv_1_0_q_3*tmp_kernel_op_323 + jac_blending_inv_1_1_q_3*tmp_kernel_op_324 + jac_blending_inv_1_2_q_3*tmp_kernel_op_325;
             const real_t tmp_kernel_op_328 = jac_blending_inv_2_0_q_3*tmp_kernel_op_323 + jac_blending_inv_2_1_q_3*tmp_kernel_op_324 + jac_blending_inv_2_2_q_3*tmp_kernel_op_325;
             const real_t tmp_kernel_op_329 = -hessian_blending_1_0_0_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_1_1_0_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_1_2_0_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_330 = -hessian_blending_1_0_1_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_1_1_1_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_1_2_1_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_331 = -hessian_blending_1_0_2_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_1_1_2_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_1_2_2_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_332 = jac_blending_inv_0_0_q_3*tmp_kernel_op_329 + jac_blending_inv_0_1_q_3*tmp_kernel_op_330 + jac_blending_inv_0_2_q_3*tmp_kernel_op_331;
             const real_t tmp_kernel_op_333 = jac_blending_inv_1_0_q_3*tmp_kernel_op_329 + jac_blending_inv_1_1_q_3*tmp_kernel_op_330 + jac_blending_inv_1_2_q_3*tmp_kernel_op_331;
             const real_t tmp_kernel_op_334 = jac_blending_inv_2_0_q_3*tmp_kernel_op_329 + jac_blending_inv_2_1_q_3*tmp_kernel_op_330 + jac_blending_inv_2_2_q_3*tmp_kernel_op_331;
             const real_t tmp_kernel_op_335 = -hessian_blending_2_0_0_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_2_1_0_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_2_2_0_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_336 = -hessian_blending_2_0_1_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_2_1_1_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_2_2_1_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_337 = -hessian_blending_2_0_2_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_2_1_2_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_2_2_2_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_338 = jac_blending_inv_0_0_q_3*tmp_kernel_op_335 + jac_blending_inv_0_1_q_3*tmp_kernel_op_336 + jac_blending_inv_0_2_q_3*tmp_kernel_op_337;
             const real_t tmp_kernel_op_339 = jac_blending_inv_1_0_q_3*tmp_kernel_op_335 + jac_blending_inv_1_1_q_3*tmp_kernel_op_336 + jac_blending_inv_1_2_q_3*tmp_kernel_op_337;
             const real_t tmp_kernel_op_340 = jac_blending_inv_2_0_q_3*tmp_kernel_op_335 + jac_blending_inv_2_1_q_3*tmp_kernel_op_336 + jac_blending_inv_2_2_q_3*tmp_kernel_op_337;
             const real_t tmp_kernel_op_341 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_374 + jac_blending_inv_1_0_q_3*tmp_moved_constant_380 + jac_blending_inv_2_0_q_3*tmp_moved_constant_386) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_402 + tmp_kernel_op_290*tmp_moved_constant_403 + tmp_kernel_op_292*tmp_moved_constant_404) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_374 + jac_blending_inv_1_1_q_3*tmp_moved_constant_380 + jac_blending_inv_2_1_q_3*tmp_moved_constant_386) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_402 + tmp_kernel_op_297*tmp_moved_constant_403 + tmp_kernel_op_298*tmp_moved_constant_404) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_374 + jac_blending_inv_1_2_q_3*tmp_moved_constant_380 + jac_blending_inv_2_2_q_3*tmp_moved_constant_386) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_402 + tmp_kernel_op_303*tmp_moved_constant_403 + tmp_kernel_op_304*tmp_moved_constant_404) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_387 + jac_blending_inv_1_0_q_3*tmp_moved_constant_388 + jac_blending_inv_2_0_q_3*tmp_moved_constant_389) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_402 + tmp_kernel_op_309*tmp_moved_constant_403 + tmp_kernel_op_310*tmp_moved_constant_404) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_387 + jac_blending_inv_1_1_q_3*tmp_moved_constant_388 + jac_blending_inv_2_1_q_3*tmp_moved_constant_389) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_402 + tmp_kernel_op_315*tmp_moved_constant_403 + tmp_kernel_op_316*tmp_moved_constant_404) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_387 + jac_blending_inv_1_2_q_3*tmp_moved_constant_388 + jac_blending_inv_2_2_q_3*tmp_moved_constant_389) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_402 + tmp_kernel_op_321*tmp_moved_constant_403 + tmp_kernel_op_322*tmp_moved_constant_404) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_390 + jac_blending_inv_1_0_q_3*tmp_moved_constant_391 + jac_blending_inv_2_0_q_3*tmp_moved_constant_392) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_402 + tmp_kernel_op_327*tmp_moved_constant_403 + tmp_kernel_op_328*tmp_moved_constant_404) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_390 + jac_blending_inv_1_1_q_3*tmp_moved_constant_391 + jac_blending_inv_2_1_q_3*tmp_moved_constant_392) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_402 + tmp_kernel_op_333*tmp_moved_constant_403 + tmp_kernel_op_334*tmp_moved_constant_404) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_390 + jac_blending_inv_1_2_q_3*tmp_moved_constant_391 + jac_blending_inv_2_2_q_3*tmp_moved_constant_392) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_402 + tmp_kernel_op_339*tmp_moved_constant_403 + tmp_kernel_op_340*tmp_moved_constant_404);
             const real_t tmp_kernel_op_359 = tmp_kernel_op_342*wx_dof_4 + tmp_kernel_op_343*wx_dof_5 + tmp_kernel_op_344*wx_dof_6 + tmp_kernel_op_347*wx_dof_1 + tmp_kernel_op_350*wx_dof_2 + tmp_kernel_op_353*wx_dof_3 + tmp_kernel_op_354*wx_dof_7 + tmp_kernel_op_355*wx_dof_8 + tmp_kernel_op_357*wx_dof_9 + tmp_kernel_op_358*wx_dof_0;
             const real_t tmp_kernel_op_360 = tmp_kernel_op_342*wy_dof_4 + tmp_kernel_op_343*wy_dof_5 + tmp_kernel_op_344*wy_dof_6 + tmp_kernel_op_347*wy_dof_1 + tmp_kernel_op_350*wy_dof_2 + tmp_kernel_op_353*wy_dof_3 + tmp_kernel_op_354*wy_dof_7 + tmp_kernel_op_355*wy_dof_8 + tmp_kernel_op_357*wy_dof_9 + tmp_kernel_op_358*wy_dof_0;
             const real_t tmp_kernel_op_361 = tmp_kernel_op_342*wz_dof_4 + tmp_kernel_op_343*wz_dof_5 + tmp_kernel_op_344*wz_dof_6 + tmp_kernel_op_347*wz_dof_1 + tmp_kernel_op_350*wz_dof_2 + tmp_kernel_op_353*wz_dof_3 + tmp_kernel_op_354*wz_dof_7 + tmp_kernel_op_355*wz_dof_8 + tmp_kernel_op_357*wz_dof_9 + tmp_kernel_op_358*wz_dof_0;
             const real_t tmp_kernel_op_362 = abs_det_jac_affine_BLUE_UP*abs_det_jac_blending_q_3*(diffusivity_times_delta_dof_0*tmp_kernel_op_358 + diffusivity_times_delta_dof_1*tmp_kernel_op_347 + diffusivity_times_delta_dof_2*tmp_kernel_op_350 + diffusivity_times_delta_dof_3*tmp_kernel_op_353 + diffusivity_times_delta_dof_4*tmp_kernel_op_342 + diffusivity_times_delta_dof_5*tmp_kernel_op_343 + diffusivity_times_delta_dof_6*tmp_kernel_op_344 + diffusivity_times_delta_dof_7*tmp_kernel_op_354 + diffusivity_times_delta_dof_8*tmp_kernel_op_355 + diffusivity_times_delta_dof_9*tmp_kernel_op_357)*0.074999999999999983;
             const real_t tmp_kernel_op_363 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_402 + jac_blending_inv_1_0_q_3*tmp_moved_constant_403 + jac_blending_inv_2_0_q_3*tmp_moved_constant_404) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_402 + jac_blending_inv_1_1_q_3*tmp_moved_constant_403 + jac_blending_inv_2_1_q_3*tmp_moved_constant_404) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_402 + jac_blending_inv_1_2_q_3*tmp_moved_constant_403 + jac_blending_inv_2_2_q_3*tmp_moved_constant_404));
             const real_t tmp_kernel_op_370 = -hessian_blending_0_0_0_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_0_1_0_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_0_2_0_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_371 = -hessian_blending_0_0_1_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_0_1_1_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_0_2_1_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_372 = -hessian_blending_0_0_2_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_0_1_2_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_0_2_2_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_373 = jac_blending_inv_0_0_q_4*tmp_kernel_op_370 + jac_blending_inv_0_1_q_4*tmp_kernel_op_371 + jac_blending_inv_0_2_q_4*tmp_kernel_op_372;
             const real_t tmp_kernel_op_375 = jac_blending_inv_1_0_q_4*tmp_kernel_op_370 + jac_blending_inv_1_1_q_4*tmp_kernel_op_371 + jac_blending_inv_1_2_q_4*tmp_kernel_op_372;
             const real_t tmp_kernel_op_377 = jac_blending_inv_2_0_q_4*tmp_kernel_op_370 + jac_blending_inv_2_1_q_4*tmp_kernel_op_371 + jac_blending_inv_2_2_q_4*tmp_kernel_op_372;
             const real_t tmp_kernel_op_378 = -hessian_blending_1_0_0_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_1_1_0_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_1_2_0_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_379 = -hessian_blending_1_0_1_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_1_1_1_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_1_2_1_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_380 = -hessian_blending_1_0_2_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_1_1_2_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_1_2_2_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_381 = jac_blending_inv_0_0_q_4*tmp_kernel_op_378 + jac_blending_inv_0_1_q_4*tmp_kernel_op_379 + jac_blending_inv_0_2_q_4*tmp_kernel_op_380;
             const real_t tmp_kernel_op_382 = jac_blending_inv_1_0_q_4*tmp_kernel_op_378 + jac_blending_inv_1_1_q_4*tmp_kernel_op_379 + jac_blending_inv_1_2_q_4*tmp_kernel_op_380;
             const real_t tmp_kernel_op_383 = jac_blending_inv_2_0_q_4*tmp_kernel_op_378 + jac_blending_inv_2_1_q_4*tmp_kernel_op_379 + jac_blending_inv_2_2_q_4*tmp_kernel_op_380;
             const real_t tmp_kernel_op_384 = -hessian_blending_2_0_0_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_2_1_0_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_2_2_0_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_385 = -hessian_blending_2_0_1_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_2_1_1_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_2_2_1_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_386 = -hessian_blending_2_0_2_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_2_1_2_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_2_2_2_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_387 = jac_blending_inv_0_0_q_4*tmp_kernel_op_384 + jac_blending_inv_0_1_q_4*tmp_kernel_op_385 + jac_blending_inv_0_2_q_4*tmp_kernel_op_386;
             const real_t tmp_kernel_op_388 = jac_blending_inv_1_0_q_4*tmp_kernel_op_384 + jac_blending_inv_1_1_q_4*tmp_kernel_op_385 + jac_blending_inv_1_2_q_4*tmp_kernel_op_386;
             const real_t tmp_kernel_op_389 = jac_blending_inv_2_0_q_4*tmp_kernel_op_384 + jac_blending_inv_2_1_q_4*tmp_kernel_op_385 + jac_blending_inv_2_2_q_4*tmp_kernel_op_386;
             const real_t tmp_kernel_op_390 = -hessian_blending_0_0_0_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_0_1_0_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_0_2_0_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_391 = -hessian_blending_0_0_1_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_0_1_1_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_0_2_1_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_392 = -hessian_blending_0_0_2_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_0_1_2_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_0_2_2_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_393 = jac_blending_inv_0_0_q_4*tmp_kernel_op_390 + jac_blending_inv_0_1_q_4*tmp_kernel_op_391 + jac_blending_inv_0_2_q_4*tmp_kernel_op_392;
             const real_t tmp_kernel_op_394 = jac_blending_inv_1_0_q_4*tmp_kernel_op_390 + jac_blending_inv_1_1_q_4*tmp_kernel_op_391 + jac_blending_inv_1_2_q_4*tmp_kernel_op_392;
             const real_t tmp_kernel_op_395 = jac_blending_inv_2_0_q_4*tmp_kernel_op_390 + jac_blending_inv_2_1_q_4*tmp_kernel_op_391 + jac_blending_inv_2_2_q_4*tmp_kernel_op_392;
             const real_t tmp_kernel_op_396 = -hessian_blending_1_0_0_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_1_1_0_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_1_2_0_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_397 = -hessian_blending_1_0_1_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_1_1_1_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_1_2_1_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_398 = -hessian_blending_1_0_2_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_1_1_2_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_1_2_2_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_399 = jac_blending_inv_0_0_q_4*tmp_kernel_op_396 + jac_blending_inv_0_1_q_4*tmp_kernel_op_397 + jac_blending_inv_0_2_q_4*tmp_kernel_op_398;
             const real_t tmp_kernel_op_400 = jac_blending_inv_1_0_q_4*tmp_kernel_op_396 + jac_blending_inv_1_1_q_4*tmp_kernel_op_397 + jac_blending_inv_1_2_q_4*tmp_kernel_op_398;
             const real_t tmp_kernel_op_401 = jac_blending_inv_2_0_q_4*tmp_kernel_op_396 + jac_blending_inv_2_1_q_4*tmp_kernel_op_397 + jac_blending_inv_2_2_q_4*tmp_kernel_op_398;
             const real_t tmp_kernel_op_402 = -hessian_blending_2_0_0_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_2_1_0_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_2_2_0_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_403 = -hessian_blending_2_0_1_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_2_1_1_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_2_2_1_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_404 = -hessian_blending_2_0_2_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_2_1_2_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_2_2_2_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_405 = jac_blending_inv_0_0_q_4*tmp_kernel_op_402 + jac_blending_inv_0_1_q_4*tmp_kernel_op_403 + jac_blending_inv_0_2_q_4*tmp_kernel_op_404;
             const real_t tmp_kernel_op_406 = jac_blending_inv_1_0_q_4*tmp_kernel_op_402 + jac_blending_inv_1_1_q_4*tmp_kernel_op_403 + jac_blending_inv_1_2_q_4*tmp_kernel_op_404;
             const real_t tmp_kernel_op_407 = jac_blending_inv_2_0_q_4*tmp_kernel_op_402 + jac_blending_inv_2_1_q_4*tmp_kernel_op_403 + jac_blending_inv_2_2_q_4*tmp_kernel_op_404;
             const real_t tmp_kernel_op_408 = -hessian_blending_0_0_0_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_0_1_0_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_0_2_0_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_409 = -hessian_blending_0_0_1_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_0_1_1_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_0_2_1_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_410 = -hessian_blending_0_0_2_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_0_1_2_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_0_2_2_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_411 = jac_blending_inv_0_0_q_4*tmp_kernel_op_408 + jac_blending_inv_0_1_q_4*tmp_kernel_op_409 + jac_blending_inv_0_2_q_4*tmp_kernel_op_410;
             const real_t tmp_kernel_op_412 = jac_blending_inv_1_0_q_4*tmp_kernel_op_408 + jac_blending_inv_1_1_q_4*tmp_kernel_op_409 + jac_blending_inv_1_2_q_4*tmp_kernel_op_410;
             const real_t tmp_kernel_op_413 = jac_blending_inv_2_0_q_4*tmp_kernel_op_408 + jac_blending_inv_2_1_q_4*tmp_kernel_op_409 + jac_blending_inv_2_2_q_4*tmp_kernel_op_410;
             const real_t tmp_kernel_op_414 = -hessian_blending_1_0_0_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_1_1_0_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_1_2_0_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_415 = -hessian_blending_1_0_1_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_1_1_1_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_1_2_1_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_416 = -hessian_blending_1_0_2_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_1_1_2_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_1_2_2_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_417 = jac_blending_inv_0_0_q_4*tmp_kernel_op_414 + jac_blending_inv_0_1_q_4*tmp_kernel_op_415 + jac_blending_inv_0_2_q_4*tmp_kernel_op_416;
             const real_t tmp_kernel_op_418 = jac_blending_inv_1_0_q_4*tmp_kernel_op_414 + jac_blending_inv_1_1_q_4*tmp_kernel_op_415 + jac_blending_inv_1_2_q_4*tmp_kernel_op_416;
             const real_t tmp_kernel_op_419 = jac_blending_inv_2_0_q_4*tmp_kernel_op_414 + jac_blending_inv_2_1_q_4*tmp_kernel_op_415 + jac_blending_inv_2_2_q_4*tmp_kernel_op_416;
             const real_t tmp_kernel_op_420 = -hessian_blending_2_0_0_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_2_1_0_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_2_2_0_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_421 = -hessian_blending_2_0_1_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_2_1_1_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_2_2_1_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_422 = -hessian_blending_2_0_2_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_2_1_2_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_2_2_2_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_423 = jac_blending_inv_0_0_q_4*tmp_kernel_op_420 + jac_blending_inv_0_1_q_4*tmp_kernel_op_421 + jac_blending_inv_0_2_q_4*tmp_kernel_op_422;
             const real_t tmp_kernel_op_424 = jac_blending_inv_1_0_q_4*tmp_kernel_op_420 + jac_blending_inv_1_1_q_4*tmp_kernel_op_421 + jac_blending_inv_1_2_q_4*tmp_kernel_op_422;
             const real_t tmp_kernel_op_425 = jac_blending_inv_2_0_q_4*tmp_kernel_op_420 + jac_blending_inv_2_1_q_4*tmp_kernel_op_421 + jac_blending_inv_2_2_q_4*tmp_kernel_op_422;
             const real_t tmp_kernel_op_426 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_374 + jac_blending_inv_1_0_q_4*tmp_moved_constant_380 + jac_blending_inv_2_0_q_4*tmp_moved_constant_386) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_405 + tmp_kernel_op_375*tmp_moved_constant_406 + tmp_kernel_op_377*tmp_moved_constant_407) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_374 + jac_blending_inv_1_1_q_4*tmp_moved_constant_380 + jac_blending_inv_2_1_q_4*tmp_moved_constant_386) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_405 + tmp_kernel_op_382*tmp_moved_constant_406 + tmp_kernel_op_383*tmp_moved_constant_407) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_374 + jac_blending_inv_1_2_q_4*tmp_moved_constant_380 + jac_blending_inv_2_2_q_4*tmp_moved_constant_386) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_405 + tmp_kernel_op_388*tmp_moved_constant_406 + tmp_kernel_op_389*tmp_moved_constant_407) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_387 + jac_blending_inv_1_0_q_4*tmp_moved_constant_388 + jac_blending_inv_2_0_q_4*tmp_moved_constant_389) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_405 + tmp_kernel_op_394*tmp_moved_constant_406 + tmp_kernel_op_395*tmp_moved_constant_407) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_387 + jac_blending_inv_1_1_q_4*tmp_moved_constant_388 + jac_blending_inv_2_1_q_4*tmp_moved_constant_389) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_405 + tmp_kernel_op_400*tmp_moved_constant_406 + tmp_kernel_op_401*tmp_moved_constant_407) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_387 + jac_blending_inv_1_2_q_4*tmp_moved_constant_388 + jac_blending_inv_2_2_q_4*tmp_moved_constant_389) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_405 + tmp_kernel_op_406*tmp_moved_constant_406 + tmp_kernel_op_407*tmp_moved_constant_407) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_390 + jac_blending_inv_1_0_q_4*tmp_moved_constant_391 + jac_blending_inv_2_0_q_4*tmp_moved_constant_392) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_405 + tmp_kernel_op_412*tmp_moved_constant_406 + tmp_kernel_op_413*tmp_moved_constant_407) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_390 + jac_blending_inv_1_1_q_4*tmp_moved_constant_391 + jac_blending_inv_2_1_q_4*tmp_moved_constant_392) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_405 + tmp_kernel_op_418*tmp_moved_constant_406 + tmp_kernel_op_419*tmp_moved_constant_407) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_390 + jac_blending_inv_1_2_q_4*tmp_moved_constant_391 + jac_blending_inv_2_2_q_4*tmp_moved_constant_392) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_405 + tmp_kernel_op_424*tmp_moved_constant_406 + tmp_kernel_op_425*tmp_moved_constant_407);
             const real_t tmp_kernel_op_444 = tmp_kernel_op_427*wx_dof_4 + tmp_kernel_op_428*wx_dof_5 + tmp_kernel_op_429*wx_dof_6 + tmp_kernel_op_432*wx_dof_1 + tmp_kernel_op_435*wx_dof_2 + tmp_kernel_op_438*wx_dof_3 + tmp_kernel_op_439*wx_dof_7 + tmp_kernel_op_440*wx_dof_8 + tmp_kernel_op_442*wx_dof_9 + tmp_kernel_op_443*wx_dof_0;
             const real_t tmp_kernel_op_445 = tmp_kernel_op_427*wy_dof_4 + tmp_kernel_op_428*wy_dof_5 + tmp_kernel_op_429*wy_dof_6 + tmp_kernel_op_432*wy_dof_1 + tmp_kernel_op_435*wy_dof_2 + tmp_kernel_op_438*wy_dof_3 + tmp_kernel_op_439*wy_dof_7 + tmp_kernel_op_440*wy_dof_8 + tmp_kernel_op_442*wy_dof_9 + tmp_kernel_op_443*wy_dof_0;
             const real_t tmp_kernel_op_446 = tmp_kernel_op_427*wz_dof_4 + tmp_kernel_op_428*wz_dof_5 + tmp_kernel_op_429*wz_dof_6 + tmp_kernel_op_432*wz_dof_1 + tmp_kernel_op_435*wz_dof_2 + tmp_kernel_op_438*wz_dof_3 + tmp_kernel_op_439*wz_dof_7 + tmp_kernel_op_440*wz_dof_8 + tmp_kernel_op_442*wz_dof_9 + tmp_kernel_op_443*wz_dof_0;
             const real_t tmp_kernel_op_447 = abs_det_jac_affine_BLUE_UP*abs_det_jac_blending_q_4*(diffusivity_times_delta_dof_0*tmp_kernel_op_443 + diffusivity_times_delta_dof_1*tmp_kernel_op_432 + diffusivity_times_delta_dof_2*tmp_kernel_op_435 + diffusivity_times_delta_dof_3*tmp_kernel_op_438 + diffusivity_times_delta_dof_4*tmp_kernel_op_427 + diffusivity_times_delta_dof_5*tmp_kernel_op_428 + diffusivity_times_delta_dof_6*tmp_kernel_op_429 + diffusivity_times_delta_dof_7*tmp_kernel_op_439 + diffusivity_times_delta_dof_8*tmp_kernel_op_440 + diffusivity_times_delta_dof_9*tmp_kernel_op_442)*0.074999999999999983;
             const real_t tmp_kernel_op_448 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_405 + jac_blending_inv_1_0_q_4*tmp_moved_constant_406 + jac_blending_inv_2_0_q_4*tmp_moved_constant_407) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_405 + jac_blending_inv_1_1_q_4*tmp_moved_constant_406 + jac_blending_inv_2_1_q_4*tmp_moved_constant_407) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_405 + jac_blending_inv_1_2_q_4*tmp_moved_constant_406 + jac_blending_inv_2_2_q_4*tmp_moved_constant_407));
             const real_t tmp_kernel_op_459 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_410 + jac_blending_inv_1_0_q_0*tmp_moved_constant_408 + jac_blending_inv_2_0_q_0*tmp_moved_constant_409) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_414 + tmp_kernel_op_35*tmp_moved_constant_415 + tmp_kernel_op_37*tmp_moved_constant_416) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_410 + jac_blending_inv_1_1_q_0*tmp_moved_constant_408 + jac_blending_inv_2_1_q_0*tmp_moved_constant_409) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_414 + tmp_kernel_op_42*tmp_moved_constant_415 + tmp_kernel_op_43*tmp_moved_constant_416) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_410 + jac_blending_inv_1_2_q_0*tmp_moved_constant_408 + jac_blending_inv_2_2_q_0*tmp_moved_constant_409) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_414 + tmp_kernel_op_48*tmp_moved_constant_415 + tmp_kernel_op_49*tmp_moved_constant_416) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_408 + jac_blending_inv_1_0_q_0*tmp_moved_constant_412 + jac_blending_inv_2_0_q_0*tmp_moved_constant_411) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_414 + tmp_kernel_op_54*tmp_moved_constant_415 + tmp_kernel_op_55*tmp_moved_constant_416) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_408 + jac_blending_inv_1_1_q_0*tmp_moved_constant_412 + jac_blending_inv_2_1_q_0*tmp_moved_constant_411) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_414 + tmp_kernel_op_60*tmp_moved_constant_415 + tmp_kernel_op_61*tmp_moved_constant_416) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_408 + jac_blending_inv_1_2_q_0*tmp_moved_constant_412 + jac_blending_inv_2_2_q_0*tmp_moved_constant_411) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_414 + tmp_kernel_op_66*tmp_moved_constant_415 + tmp_kernel_op_67*tmp_moved_constant_416) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_409 + jac_blending_inv_1_0_q_0*tmp_moved_constant_411 + jac_blending_inv_2_0_q_0*tmp_moved_constant_413) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_414 + tmp_kernel_op_72*tmp_moved_constant_415 + tmp_kernel_op_73*tmp_moved_constant_416) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_409 + jac_blending_inv_1_1_q_0*tmp_moved_constant_411 + jac_blending_inv_2_1_q_0*tmp_moved_constant_413) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_414 + tmp_kernel_op_78*tmp_moved_constant_415 + tmp_kernel_op_79*tmp_moved_constant_416) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_409 + jac_blending_inv_1_2_q_0*tmp_moved_constant_411 + jac_blending_inv_2_2_q_0*tmp_moved_constant_413) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_414 + tmp_kernel_op_84*tmp_moved_constant_415 + tmp_kernel_op_85*tmp_moved_constant_416);
             const real_t tmp_kernel_op_464 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_410 + jac_blending_inv_1_0_q_1*tmp_moved_constant_408 + jac_blending_inv_2_0_q_1*tmp_moved_constant_409) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_417 + tmp_kernel_op_120*tmp_moved_constant_418 + tmp_kernel_op_122*tmp_moved_constant_419) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_410 + jac_blending_inv_1_1_q_1*tmp_moved_constant_408 + jac_blending_inv_2_1_q_1*tmp_moved_constant_409) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_417 + tmp_kernel_op_127*tmp_moved_constant_418 + tmp_kernel_op_128*tmp_moved_constant_419) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_410 + jac_blending_inv_1_2_q_1*tmp_moved_constant_408 + jac_blending_inv_2_2_q_1*tmp_moved_constant_409) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_417 + tmp_kernel_op_133*tmp_moved_constant_418 + tmp_kernel_op_134*tmp_moved_constant_419) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_408 + jac_blending_inv_1_0_q_1*tmp_moved_constant_412 + jac_blending_inv_2_0_q_1*tmp_moved_constant_411) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_417 + tmp_kernel_op_139*tmp_moved_constant_418 + tmp_kernel_op_140*tmp_moved_constant_419) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_408 + jac_blending_inv_1_1_q_1*tmp_moved_constant_412 + jac_blending_inv_2_1_q_1*tmp_moved_constant_411) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_417 + tmp_kernel_op_145*tmp_moved_constant_418 + tmp_kernel_op_146*tmp_moved_constant_419) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_408 + jac_blending_inv_1_2_q_1*tmp_moved_constant_412 + jac_blending_inv_2_2_q_1*tmp_moved_constant_411) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_417 + tmp_kernel_op_151*tmp_moved_constant_418 + tmp_kernel_op_152*tmp_moved_constant_419) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_409 + jac_blending_inv_1_0_q_1*tmp_moved_constant_411 + jac_blending_inv_2_0_q_1*tmp_moved_constant_413) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_417 + tmp_kernel_op_157*tmp_moved_constant_418 + tmp_kernel_op_158*tmp_moved_constant_419) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_409 + jac_blending_inv_1_1_q_1*tmp_moved_constant_411 + jac_blending_inv_2_1_q_1*tmp_moved_constant_413) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_417 + tmp_kernel_op_163*tmp_moved_constant_418 + tmp_kernel_op_164*tmp_moved_constant_419) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_409 + jac_blending_inv_1_2_q_1*tmp_moved_constant_411 + jac_blending_inv_2_2_q_1*tmp_moved_constant_413) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_417 + tmp_kernel_op_169*tmp_moved_constant_418 + tmp_kernel_op_170*tmp_moved_constant_419);
             const real_t tmp_kernel_op_469 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_410 + jac_blending_inv_1_0_q_2*tmp_moved_constant_408 + jac_blending_inv_2_0_q_2*tmp_moved_constant_409) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_420 + tmp_kernel_op_205*tmp_moved_constant_421 + tmp_kernel_op_207*tmp_moved_constant_422) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_410 + jac_blending_inv_1_1_q_2*tmp_moved_constant_408 + jac_blending_inv_2_1_q_2*tmp_moved_constant_409) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_420 + tmp_kernel_op_212*tmp_moved_constant_421 + tmp_kernel_op_213*tmp_moved_constant_422) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_410 + jac_blending_inv_1_2_q_2*tmp_moved_constant_408 + jac_blending_inv_2_2_q_2*tmp_moved_constant_409) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_420 + tmp_kernel_op_218*tmp_moved_constant_421 + tmp_kernel_op_219*tmp_moved_constant_422) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_408 + jac_blending_inv_1_0_q_2*tmp_moved_constant_412 + jac_blending_inv_2_0_q_2*tmp_moved_constant_411) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_420 + tmp_kernel_op_224*tmp_moved_constant_421 + tmp_kernel_op_225*tmp_moved_constant_422) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_408 + jac_blending_inv_1_1_q_2*tmp_moved_constant_412 + jac_blending_inv_2_1_q_2*tmp_moved_constant_411) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_420 + tmp_kernel_op_230*tmp_moved_constant_421 + tmp_kernel_op_231*tmp_moved_constant_422) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_408 + jac_blending_inv_1_2_q_2*tmp_moved_constant_412 + jac_blending_inv_2_2_q_2*tmp_moved_constant_411) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_420 + tmp_kernel_op_236*tmp_moved_constant_421 + tmp_kernel_op_237*tmp_moved_constant_422) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_409 + jac_blending_inv_1_0_q_2*tmp_moved_constant_411 + jac_blending_inv_2_0_q_2*tmp_moved_constant_413) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_420 + tmp_kernel_op_242*tmp_moved_constant_421 + tmp_kernel_op_243*tmp_moved_constant_422) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_409 + jac_blending_inv_1_1_q_2*tmp_moved_constant_411 + jac_blending_inv_2_1_q_2*tmp_moved_constant_413) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_420 + tmp_kernel_op_248*tmp_moved_constant_421 + tmp_kernel_op_249*tmp_moved_constant_422) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_409 + jac_blending_inv_1_2_q_2*tmp_moved_constant_411 + jac_blending_inv_2_2_q_2*tmp_moved_constant_413) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_420 + tmp_kernel_op_254*tmp_moved_constant_421 + tmp_kernel_op_255*tmp_moved_constant_422);
             const real_t tmp_kernel_op_474 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_410 + jac_blending_inv_1_0_q_3*tmp_moved_constant_408 + jac_blending_inv_2_0_q_3*tmp_moved_constant_409) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_423 + tmp_kernel_op_290*tmp_moved_constant_424 + tmp_kernel_op_292*tmp_moved_constant_425) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_410 + jac_blending_inv_1_1_q_3*tmp_moved_constant_408 + jac_blending_inv_2_1_q_3*tmp_moved_constant_409) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_423 + tmp_kernel_op_297*tmp_moved_constant_424 + tmp_kernel_op_298*tmp_moved_constant_425) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_410 + jac_blending_inv_1_2_q_3*tmp_moved_constant_408 + jac_blending_inv_2_2_q_3*tmp_moved_constant_409) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_423 + tmp_kernel_op_303*tmp_moved_constant_424 + tmp_kernel_op_304*tmp_moved_constant_425) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_408 + jac_blending_inv_1_0_q_3*tmp_moved_constant_412 + jac_blending_inv_2_0_q_3*tmp_moved_constant_411) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_423 + tmp_kernel_op_309*tmp_moved_constant_424 + tmp_kernel_op_310*tmp_moved_constant_425) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_408 + jac_blending_inv_1_1_q_3*tmp_moved_constant_412 + jac_blending_inv_2_1_q_3*tmp_moved_constant_411) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_423 + tmp_kernel_op_315*tmp_moved_constant_424 + tmp_kernel_op_316*tmp_moved_constant_425) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_408 + jac_blending_inv_1_2_q_3*tmp_moved_constant_412 + jac_blending_inv_2_2_q_3*tmp_moved_constant_411) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_423 + tmp_kernel_op_321*tmp_moved_constant_424 + tmp_kernel_op_322*tmp_moved_constant_425) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_409 + jac_blending_inv_1_0_q_3*tmp_moved_constant_411 + jac_blending_inv_2_0_q_3*tmp_moved_constant_413) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_423 + tmp_kernel_op_327*tmp_moved_constant_424 + tmp_kernel_op_328*tmp_moved_constant_425) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_409 + jac_blending_inv_1_1_q_3*tmp_moved_constant_411 + jac_blending_inv_2_1_q_3*tmp_moved_constant_413) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_423 + tmp_kernel_op_333*tmp_moved_constant_424 + tmp_kernel_op_334*tmp_moved_constant_425) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_409 + jac_blending_inv_1_2_q_3*tmp_moved_constant_411 + jac_blending_inv_2_2_q_3*tmp_moved_constant_413) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_423 + tmp_kernel_op_339*tmp_moved_constant_424 + tmp_kernel_op_340*tmp_moved_constant_425);
             const real_t tmp_kernel_op_479 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_410 + jac_blending_inv_1_0_q_4*tmp_moved_constant_408 + jac_blending_inv_2_0_q_4*tmp_moved_constant_409) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_426 + tmp_kernel_op_375*tmp_moved_constant_427 + tmp_kernel_op_377*tmp_moved_constant_428) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_410 + jac_blending_inv_1_1_q_4*tmp_moved_constant_408 + jac_blending_inv_2_1_q_4*tmp_moved_constant_409) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_426 + tmp_kernel_op_382*tmp_moved_constant_427 + tmp_kernel_op_383*tmp_moved_constant_428) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_410 + jac_blending_inv_1_2_q_4*tmp_moved_constant_408 + jac_blending_inv_2_2_q_4*tmp_moved_constant_409) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_426 + tmp_kernel_op_388*tmp_moved_constant_427 + tmp_kernel_op_389*tmp_moved_constant_428) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_408 + jac_blending_inv_1_0_q_4*tmp_moved_constant_412 + jac_blending_inv_2_0_q_4*tmp_moved_constant_411) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_426 + tmp_kernel_op_394*tmp_moved_constant_427 + tmp_kernel_op_395*tmp_moved_constant_428) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_408 + jac_blending_inv_1_1_q_4*tmp_moved_constant_412 + jac_blending_inv_2_1_q_4*tmp_moved_constant_411) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_426 + tmp_kernel_op_400*tmp_moved_constant_427 + tmp_kernel_op_401*tmp_moved_constant_428) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_408 + jac_blending_inv_1_2_q_4*tmp_moved_constant_412 + jac_blending_inv_2_2_q_4*tmp_moved_constant_411) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_426 + tmp_kernel_op_406*tmp_moved_constant_427 + tmp_kernel_op_407*tmp_moved_constant_428) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_409 + jac_blending_inv_1_0_q_4*tmp_moved_constant_411 + jac_blending_inv_2_0_q_4*tmp_moved_constant_413) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_426 + tmp_kernel_op_412*tmp_moved_constant_427 + tmp_kernel_op_413*tmp_moved_constant_428) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_409 + jac_blending_inv_1_1_q_4*tmp_moved_constant_411 + jac_blending_inv_2_1_q_4*tmp_moved_constant_413) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_426 + tmp_kernel_op_418*tmp_moved_constant_427 + tmp_kernel_op_419*tmp_moved_constant_428) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_409 + jac_blending_inv_1_2_q_4*tmp_moved_constant_411 + jac_blending_inv_2_2_q_4*tmp_moved_constant_413) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_426 + tmp_kernel_op_424*tmp_moved_constant_427 + tmp_kernel_op_425*tmp_moved_constant_428);
             const real_t tmp_kernel_op_490 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_431 + jac_blending_inv_1_0_q_0*tmp_moved_constant_429 + jac_blending_inv_2_0_q_0*tmp_moved_constant_430) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_435 + tmp_kernel_op_35*tmp_moved_constant_436 + tmp_kernel_op_37*tmp_moved_constant_437) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_431 + jac_blending_inv_1_1_q_0*tmp_moved_constant_429 + jac_blending_inv_2_1_q_0*tmp_moved_constant_430) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_435 + tmp_kernel_op_42*tmp_moved_constant_436 + tmp_kernel_op_43*tmp_moved_constant_437) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_431 + jac_blending_inv_1_2_q_0*tmp_moved_constant_429 + jac_blending_inv_2_2_q_0*tmp_moved_constant_430) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_435 + tmp_kernel_op_48*tmp_moved_constant_436 + tmp_kernel_op_49*tmp_moved_constant_437) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_429 + jac_blending_inv_1_0_q_0*tmp_moved_constant_433 + jac_blending_inv_2_0_q_0*tmp_moved_constant_432) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_435 + tmp_kernel_op_54*tmp_moved_constant_436 + tmp_kernel_op_55*tmp_moved_constant_437) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_429 + jac_blending_inv_1_1_q_0*tmp_moved_constant_433 + jac_blending_inv_2_1_q_0*tmp_moved_constant_432) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_435 + tmp_kernel_op_60*tmp_moved_constant_436 + tmp_kernel_op_61*tmp_moved_constant_437) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_429 + jac_blending_inv_1_2_q_0*tmp_moved_constant_433 + jac_blending_inv_2_2_q_0*tmp_moved_constant_432) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_435 + tmp_kernel_op_66*tmp_moved_constant_436 + tmp_kernel_op_67*tmp_moved_constant_437) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_430 + jac_blending_inv_1_0_q_0*tmp_moved_constant_432 + jac_blending_inv_2_0_q_0*tmp_moved_constant_434) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_435 + tmp_kernel_op_72*tmp_moved_constant_436 + tmp_kernel_op_73*tmp_moved_constant_437) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_430 + jac_blending_inv_1_1_q_0*tmp_moved_constant_432 + jac_blending_inv_2_1_q_0*tmp_moved_constant_434) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_435 + tmp_kernel_op_78*tmp_moved_constant_436 + tmp_kernel_op_79*tmp_moved_constant_437) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_430 + jac_blending_inv_1_2_q_0*tmp_moved_constant_432 + jac_blending_inv_2_2_q_0*tmp_moved_constant_434) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_435 + tmp_kernel_op_84*tmp_moved_constant_436 + tmp_kernel_op_85*tmp_moved_constant_437);
             const real_t tmp_kernel_op_495 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_431 + jac_blending_inv_1_0_q_1*tmp_moved_constant_429 + jac_blending_inv_2_0_q_1*tmp_moved_constant_430) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_438 + tmp_kernel_op_120*tmp_moved_constant_439 + tmp_kernel_op_122*tmp_moved_constant_440) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_431 + jac_blending_inv_1_1_q_1*tmp_moved_constant_429 + jac_blending_inv_2_1_q_1*tmp_moved_constant_430) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_438 + tmp_kernel_op_127*tmp_moved_constant_439 + tmp_kernel_op_128*tmp_moved_constant_440) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_431 + jac_blending_inv_1_2_q_1*tmp_moved_constant_429 + jac_blending_inv_2_2_q_1*tmp_moved_constant_430) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_438 + tmp_kernel_op_133*tmp_moved_constant_439 + tmp_kernel_op_134*tmp_moved_constant_440) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_429 + jac_blending_inv_1_0_q_1*tmp_moved_constant_433 + jac_blending_inv_2_0_q_1*tmp_moved_constant_432) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_438 + tmp_kernel_op_139*tmp_moved_constant_439 + tmp_kernel_op_140*tmp_moved_constant_440) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_429 + jac_blending_inv_1_1_q_1*tmp_moved_constant_433 + jac_blending_inv_2_1_q_1*tmp_moved_constant_432) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_438 + tmp_kernel_op_145*tmp_moved_constant_439 + tmp_kernel_op_146*tmp_moved_constant_440) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_429 + jac_blending_inv_1_2_q_1*tmp_moved_constant_433 + jac_blending_inv_2_2_q_1*tmp_moved_constant_432) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_438 + tmp_kernel_op_151*tmp_moved_constant_439 + tmp_kernel_op_152*tmp_moved_constant_440) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_430 + jac_blending_inv_1_0_q_1*tmp_moved_constant_432 + jac_blending_inv_2_0_q_1*tmp_moved_constant_434) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_438 + tmp_kernel_op_157*tmp_moved_constant_439 + tmp_kernel_op_158*tmp_moved_constant_440) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_430 + jac_blending_inv_1_1_q_1*tmp_moved_constant_432 + jac_blending_inv_2_1_q_1*tmp_moved_constant_434) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_438 + tmp_kernel_op_163*tmp_moved_constant_439 + tmp_kernel_op_164*tmp_moved_constant_440) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_430 + jac_blending_inv_1_2_q_1*tmp_moved_constant_432 + jac_blending_inv_2_2_q_1*tmp_moved_constant_434) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_438 + tmp_kernel_op_169*tmp_moved_constant_439 + tmp_kernel_op_170*tmp_moved_constant_440);
             const real_t tmp_kernel_op_500 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_431 + jac_blending_inv_1_0_q_2*tmp_moved_constant_429 + jac_blending_inv_2_0_q_2*tmp_moved_constant_430) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_441 + tmp_kernel_op_205*tmp_moved_constant_442 + tmp_kernel_op_207*tmp_moved_constant_443) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_431 + jac_blending_inv_1_1_q_2*tmp_moved_constant_429 + jac_blending_inv_2_1_q_2*tmp_moved_constant_430) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_441 + tmp_kernel_op_212*tmp_moved_constant_442 + tmp_kernel_op_213*tmp_moved_constant_443) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_431 + jac_blending_inv_1_2_q_2*tmp_moved_constant_429 + jac_blending_inv_2_2_q_2*tmp_moved_constant_430) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_441 + tmp_kernel_op_218*tmp_moved_constant_442 + tmp_kernel_op_219*tmp_moved_constant_443) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_429 + jac_blending_inv_1_0_q_2*tmp_moved_constant_433 + jac_blending_inv_2_0_q_2*tmp_moved_constant_432) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_441 + tmp_kernel_op_224*tmp_moved_constant_442 + tmp_kernel_op_225*tmp_moved_constant_443) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_429 + jac_blending_inv_1_1_q_2*tmp_moved_constant_433 + jac_blending_inv_2_1_q_2*tmp_moved_constant_432) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_441 + tmp_kernel_op_230*tmp_moved_constant_442 + tmp_kernel_op_231*tmp_moved_constant_443) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_429 + jac_blending_inv_1_2_q_2*tmp_moved_constant_433 + jac_blending_inv_2_2_q_2*tmp_moved_constant_432) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_441 + tmp_kernel_op_236*tmp_moved_constant_442 + tmp_kernel_op_237*tmp_moved_constant_443) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_430 + jac_blending_inv_1_0_q_2*tmp_moved_constant_432 + jac_blending_inv_2_0_q_2*tmp_moved_constant_434) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_441 + tmp_kernel_op_242*tmp_moved_constant_442 + tmp_kernel_op_243*tmp_moved_constant_443) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_430 + jac_blending_inv_1_1_q_2*tmp_moved_constant_432 + jac_blending_inv_2_1_q_2*tmp_moved_constant_434) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_441 + tmp_kernel_op_248*tmp_moved_constant_442 + tmp_kernel_op_249*tmp_moved_constant_443) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_430 + jac_blending_inv_1_2_q_2*tmp_moved_constant_432 + jac_blending_inv_2_2_q_2*tmp_moved_constant_434) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_441 + tmp_kernel_op_254*tmp_moved_constant_442 + tmp_kernel_op_255*tmp_moved_constant_443);
             const real_t tmp_kernel_op_505 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_431 + jac_blending_inv_1_0_q_3*tmp_moved_constant_429 + jac_blending_inv_2_0_q_3*tmp_moved_constant_430) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_444 + tmp_kernel_op_290*tmp_moved_constant_445 + tmp_kernel_op_292*tmp_moved_constant_446) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_431 + jac_blending_inv_1_1_q_3*tmp_moved_constant_429 + jac_blending_inv_2_1_q_3*tmp_moved_constant_430) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_444 + tmp_kernel_op_297*tmp_moved_constant_445 + tmp_kernel_op_298*tmp_moved_constant_446) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_431 + jac_blending_inv_1_2_q_3*tmp_moved_constant_429 + jac_blending_inv_2_2_q_3*tmp_moved_constant_430) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_444 + tmp_kernel_op_303*tmp_moved_constant_445 + tmp_kernel_op_304*tmp_moved_constant_446) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_429 + jac_blending_inv_1_0_q_3*tmp_moved_constant_433 + jac_blending_inv_2_0_q_3*tmp_moved_constant_432) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_444 + tmp_kernel_op_309*tmp_moved_constant_445 + tmp_kernel_op_310*tmp_moved_constant_446) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_429 + jac_blending_inv_1_1_q_3*tmp_moved_constant_433 + jac_blending_inv_2_1_q_3*tmp_moved_constant_432) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_444 + tmp_kernel_op_315*tmp_moved_constant_445 + tmp_kernel_op_316*tmp_moved_constant_446) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_429 + jac_blending_inv_1_2_q_3*tmp_moved_constant_433 + jac_blending_inv_2_2_q_3*tmp_moved_constant_432) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_444 + tmp_kernel_op_321*tmp_moved_constant_445 + tmp_kernel_op_322*tmp_moved_constant_446) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_430 + jac_blending_inv_1_0_q_3*tmp_moved_constant_432 + jac_blending_inv_2_0_q_3*tmp_moved_constant_434) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_444 + tmp_kernel_op_327*tmp_moved_constant_445 + tmp_kernel_op_328*tmp_moved_constant_446) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_430 + jac_blending_inv_1_1_q_3*tmp_moved_constant_432 + jac_blending_inv_2_1_q_3*tmp_moved_constant_434) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_444 + tmp_kernel_op_333*tmp_moved_constant_445 + tmp_kernel_op_334*tmp_moved_constant_446) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_430 + jac_blending_inv_1_2_q_3*tmp_moved_constant_432 + jac_blending_inv_2_2_q_3*tmp_moved_constant_434) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_444 + tmp_kernel_op_339*tmp_moved_constant_445 + tmp_kernel_op_340*tmp_moved_constant_446);
             const real_t tmp_kernel_op_510 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_431 + jac_blending_inv_1_0_q_4*tmp_moved_constant_429 + jac_blending_inv_2_0_q_4*tmp_moved_constant_430) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_447 + tmp_kernel_op_375*tmp_moved_constant_448 + tmp_kernel_op_377*tmp_moved_constant_449) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_431 + jac_blending_inv_1_1_q_4*tmp_moved_constant_429 + jac_blending_inv_2_1_q_4*tmp_moved_constant_430) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_447 + tmp_kernel_op_382*tmp_moved_constant_448 + tmp_kernel_op_383*tmp_moved_constant_449) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_431 + jac_blending_inv_1_2_q_4*tmp_moved_constant_429 + jac_blending_inv_2_2_q_4*tmp_moved_constant_430) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_447 + tmp_kernel_op_388*tmp_moved_constant_448 + tmp_kernel_op_389*tmp_moved_constant_449) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_429 + jac_blending_inv_1_0_q_4*tmp_moved_constant_433 + jac_blending_inv_2_0_q_4*tmp_moved_constant_432) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_447 + tmp_kernel_op_394*tmp_moved_constant_448 + tmp_kernel_op_395*tmp_moved_constant_449) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_429 + jac_blending_inv_1_1_q_4*tmp_moved_constant_433 + jac_blending_inv_2_1_q_4*tmp_moved_constant_432) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_447 + tmp_kernel_op_400*tmp_moved_constant_448 + tmp_kernel_op_401*tmp_moved_constant_449) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_429 + jac_blending_inv_1_2_q_4*tmp_moved_constant_433 + jac_blending_inv_2_2_q_4*tmp_moved_constant_432) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_447 + tmp_kernel_op_406*tmp_moved_constant_448 + tmp_kernel_op_407*tmp_moved_constant_449) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_430 + jac_blending_inv_1_0_q_4*tmp_moved_constant_432 + jac_blending_inv_2_0_q_4*tmp_moved_constant_434) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_447 + tmp_kernel_op_412*tmp_moved_constant_448 + tmp_kernel_op_413*tmp_moved_constant_449) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_430 + jac_blending_inv_1_1_q_4*tmp_moved_constant_432 + jac_blending_inv_2_1_q_4*tmp_moved_constant_434) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_447 + tmp_kernel_op_418*tmp_moved_constant_448 + tmp_kernel_op_419*tmp_moved_constant_449) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_430 + jac_blending_inv_1_2_q_4*tmp_moved_constant_432 + jac_blending_inv_2_2_q_4*tmp_moved_constant_434) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_447 + tmp_kernel_op_424*tmp_moved_constant_448 + tmp_kernel_op_425*tmp_moved_constant_449);
             const real_t tmp_kernel_op_521 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_452 + jac_blending_inv_1_0_q_0*tmp_moved_constant_450 + jac_blending_inv_2_0_q_0*tmp_moved_constant_451) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_456 + tmp_kernel_op_35*tmp_moved_constant_457 + tmp_kernel_op_37*tmp_moved_constant_458) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_452 + jac_blending_inv_1_1_q_0*tmp_moved_constant_450 + jac_blending_inv_2_1_q_0*tmp_moved_constant_451) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_456 + tmp_kernel_op_42*tmp_moved_constant_457 + tmp_kernel_op_43*tmp_moved_constant_458) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_452 + jac_blending_inv_1_2_q_0*tmp_moved_constant_450 + jac_blending_inv_2_2_q_0*tmp_moved_constant_451) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_456 + tmp_kernel_op_48*tmp_moved_constant_457 + tmp_kernel_op_49*tmp_moved_constant_458) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_450 + jac_blending_inv_1_0_q_0*tmp_moved_constant_454 + jac_blending_inv_2_0_q_0*tmp_moved_constant_453) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_456 + tmp_kernel_op_54*tmp_moved_constant_457 + tmp_kernel_op_55*tmp_moved_constant_458) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_450 + jac_blending_inv_1_1_q_0*tmp_moved_constant_454 + jac_blending_inv_2_1_q_0*tmp_moved_constant_453) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_456 + tmp_kernel_op_60*tmp_moved_constant_457 + tmp_kernel_op_61*tmp_moved_constant_458) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_450 + jac_blending_inv_1_2_q_0*tmp_moved_constant_454 + jac_blending_inv_2_2_q_0*tmp_moved_constant_453) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_456 + tmp_kernel_op_66*tmp_moved_constant_457 + tmp_kernel_op_67*tmp_moved_constant_458) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_451 + jac_blending_inv_1_0_q_0*tmp_moved_constant_453 + jac_blending_inv_2_0_q_0*tmp_moved_constant_455) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_456 + tmp_kernel_op_72*tmp_moved_constant_457 + tmp_kernel_op_73*tmp_moved_constant_458) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_451 + jac_blending_inv_1_1_q_0*tmp_moved_constant_453 + jac_blending_inv_2_1_q_0*tmp_moved_constant_455) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_456 + tmp_kernel_op_78*tmp_moved_constant_457 + tmp_kernel_op_79*tmp_moved_constant_458) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_451 + jac_blending_inv_1_2_q_0*tmp_moved_constant_453 + jac_blending_inv_2_2_q_0*tmp_moved_constant_455) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_456 + tmp_kernel_op_84*tmp_moved_constant_457 + tmp_kernel_op_85*tmp_moved_constant_458);
             const real_t tmp_kernel_op_526 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_452 + jac_blending_inv_1_0_q_1*tmp_moved_constant_450 + jac_blending_inv_2_0_q_1*tmp_moved_constant_451) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_459 + tmp_kernel_op_120*tmp_moved_constant_460 + tmp_kernel_op_122*tmp_moved_constant_461) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_452 + jac_blending_inv_1_1_q_1*tmp_moved_constant_450 + jac_blending_inv_2_1_q_1*tmp_moved_constant_451) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_459 + tmp_kernel_op_127*tmp_moved_constant_460 + tmp_kernel_op_128*tmp_moved_constant_461) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_452 + jac_blending_inv_1_2_q_1*tmp_moved_constant_450 + jac_blending_inv_2_2_q_1*tmp_moved_constant_451) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_459 + tmp_kernel_op_133*tmp_moved_constant_460 + tmp_kernel_op_134*tmp_moved_constant_461) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_450 + jac_blending_inv_1_0_q_1*tmp_moved_constant_454 + jac_blending_inv_2_0_q_1*tmp_moved_constant_453) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_459 + tmp_kernel_op_139*tmp_moved_constant_460 + tmp_kernel_op_140*tmp_moved_constant_461) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_450 + jac_blending_inv_1_1_q_1*tmp_moved_constant_454 + jac_blending_inv_2_1_q_1*tmp_moved_constant_453) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_459 + tmp_kernel_op_145*tmp_moved_constant_460 + tmp_kernel_op_146*tmp_moved_constant_461) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_450 + jac_blending_inv_1_2_q_1*tmp_moved_constant_454 + jac_blending_inv_2_2_q_1*tmp_moved_constant_453) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_459 + tmp_kernel_op_151*tmp_moved_constant_460 + tmp_kernel_op_152*tmp_moved_constant_461) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_451 + jac_blending_inv_1_0_q_1*tmp_moved_constant_453 + jac_blending_inv_2_0_q_1*tmp_moved_constant_455) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_459 + tmp_kernel_op_157*tmp_moved_constant_460 + tmp_kernel_op_158*tmp_moved_constant_461) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_451 + jac_blending_inv_1_1_q_1*tmp_moved_constant_453 + jac_blending_inv_2_1_q_1*tmp_moved_constant_455) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_459 + tmp_kernel_op_163*tmp_moved_constant_460 + tmp_kernel_op_164*tmp_moved_constant_461) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_451 + jac_blending_inv_1_2_q_1*tmp_moved_constant_453 + jac_blending_inv_2_2_q_1*tmp_moved_constant_455) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_459 + tmp_kernel_op_169*tmp_moved_constant_460 + tmp_kernel_op_170*tmp_moved_constant_461);
             const real_t tmp_kernel_op_531 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_452 + jac_blending_inv_1_0_q_2*tmp_moved_constant_450 + jac_blending_inv_2_0_q_2*tmp_moved_constant_451) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_462 + tmp_kernel_op_205*tmp_moved_constant_463 + tmp_kernel_op_207*tmp_moved_constant_464) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_452 + jac_blending_inv_1_1_q_2*tmp_moved_constant_450 + jac_blending_inv_2_1_q_2*tmp_moved_constant_451) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_462 + tmp_kernel_op_212*tmp_moved_constant_463 + tmp_kernel_op_213*tmp_moved_constant_464) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_452 + jac_blending_inv_1_2_q_2*tmp_moved_constant_450 + jac_blending_inv_2_2_q_2*tmp_moved_constant_451) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_462 + tmp_kernel_op_218*tmp_moved_constant_463 + tmp_kernel_op_219*tmp_moved_constant_464) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_450 + jac_blending_inv_1_0_q_2*tmp_moved_constant_454 + jac_blending_inv_2_0_q_2*tmp_moved_constant_453) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_462 + tmp_kernel_op_224*tmp_moved_constant_463 + tmp_kernel_op_225*tmp_moved_constant_464) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_450 + jac_blending_inv_1_1_q_2*tmp_moved_constant_454 + jac_blending_inv_2_1_q_2*tmp_moved_constant_453) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_462 + tmp_kernel_op_230*tmp_moved_constant_463 + tmp_kernel_op_231*tmp_moved_constant_464) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_450 + jac_blending_inv_1_2_q_2*tmp_moved_constant_454 + jac_blending_inv_2_2_q_2*tmp_moved_constant_453) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_462 + tmp_kernel_op_236*tmp_moved_constant_463 + tmp_kernel_op_237*tmp_moved_constant_464) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_451 + jac_blending_inv_1_0_q_2*tmp_moved_constant_453 + jac_blending_inv_2_0_q_2*tmp_moved_constant_455) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_462 + tmp_kernel_op_242*tmp_moved_constant_463 + tmp_kernel_op_243*tmp_moved_constant_464) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_451 + jac_blending_inv_1_1_q_2*tmp_moved_constant_453 + jac_blending_inv_2_1_q_2*tmp_moved_constant_455) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_462 + tmp_kernel_op_248*tmp_moved_constant_463 + tmp_kernel_op_249*tmp_moved_constant_464) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_451 + jac_blending_inv_1_2_q_2*tmp_moved_constant_453 + jac_blending_inv_2_2_q_2*tmp_moved_constant_455) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_462 + tmp_kernel_op_254*tmp_moved_constant_463 + tmp_kernel_op_255*tmp_moved_constant_464);
             const real_t tmp_kernel_op_536 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_452 + jac_blending_inv_1_0_q_3*tmp_moved_constant_450 + jac_blending_inv_2_0_q_3*tmp_moved_constant_451) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_465 + tmp_kernel_op_290*tmp_moved_constant_466 + tmp_kernel_op_292*tmp_moved_constant_467) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_452 + jac_blending_inv_1_1_q_3*tmp_moved_constant_450 + jac_blending_inv_2_1_q_3*tmp_moved_constant_451) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_465 + tmp_kernel_op_297*tmp_moved_constant_466 + tmp_kernel_op_298*tmp_moved_constant_467) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_452 + jac_blending_inv_1_2_q_3*tmp_moved_constant_450 + jac_blending_inv_2_2_q_3*tmp_moved_constant_451) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_465 + tmp_kernel_op_303*tmp_moved_constant_466 + tmp_kernel_op_304*tmp_moved_constant_467) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_450 + jac_blending_inv_1_0_q_3*tmp_moved_constant_454 + jac_blending_inv_2_0_q_3*tmp_moved_constant_453) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_465 + tmp_kernel_op_309*tmp_moved_constant_466 + tmp_kernel_op_310*tmp_moved_constant_467) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_450 + jac_blending_inv_1_1_q_3*tmp_moved_constant_454 + jac_blending_inv_2_1_q_3*tmp_moved_constant_453) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_465 + tmp_kernel_op_315*tmp_moved_constant_466 + tmp_kernel_op_316*tmp_moved_constant_467) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_450 + jac_blending_inv_1_2_q_3*tmp_moved_constant_454 + jac_blending_inv_2_2_q_3*tmp_moved_constant_453) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_465 + tmp_kernel_op_321*tmp_moved_constant_466 + tmp_kernel_op_322*tmp_moved_constant_467) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_451 + jac_blending_inv_1_0_q_3*tmp_moved_constant_453 + jac_blending_inv_2_0_q_3*tmp_moved_constant_455) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_465 + tmp_kernel_op_327*tmp_moved_constant_466 + tmp_kernel_op_328*tmp_moved_constant_467) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_451 + jac_blending_inv_1_1_q_3*tmp_moved_constant_453 + jac_blending_inv_2_1_q_3*tmp_moved_constant_455) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_465 + tmp_kernel_op_333*tmp_moved_constant_466 + tmp_kernel_op_334*tmp_moved_constant_467) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_451 + jac_blending_inv_1_2_q_3*tmp_moved_constant_453 + jac_blending_inv_2_2_q_3*tmp_moved_constant_455) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_465 + tmp_kernel_op_339*tmp_moved_constant_466 + tmp_kernel_op_340*tmp_moved_constant_467);
             const real_t tmp_kernel_op_541 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_452 + jac_blending_inv_1_0_q_4*tmp_moved_constant_450 + jac_blending_inv_2_0_q_4*tmp_moved_constant_451) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_468 + tmp_kernel_op_375*tmp_moved_constant_469 + tmp_kernel_op_377*tmp_moved_constant_470) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_452 + jac_blending_inv_1_1_q_4*tmp_moved_constant_450 + jac_blending_inv_2_1_q_4*tmp_moved_constant_451) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_468 + tmp_kernel_op_382*tmp_moved_constant_469 + tmp_kernel_op_383*tmp_moved_constant_470) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_452 + jac_blending_inv_1_2_q_4*tmp_moved_constant_450 + jac_blending_inv_2_2_q_4*tmp_moved_constant_451) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_468 + tmp_kernel_op_388*tmp_moved_constant_469 + tmp_kernel_op_389*tmp_moved_constant_470) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_450 + jac_blending_inv_1_0_q_4*tmp_moved_constant_454 + jac_blending_inv_2_0_q_4*tmp_moved_constant_453) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_468 + tmp_kernel_op_394*tmp_moved_constant_469 + tmp_kernel_op_395*tmp_moved_constant_470) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_450 + jac_blending_inv_1_1_q_4*tmp_moved_constant_454 + jac_blending_inv_2_1_q_4*tmp_moved_constant_453) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_468 + tmp_kernel_op_400*tmp_moved_constant_469 + tmp_kernel_op_401*tmp_moved_constant_470) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_450 + jac_blending_inv_1_2_q_4*tmp_moved_constant_454 + jac_blending_inv_2_2_q_4*tmp_moved_constant_453) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_468 + tmp_kernel_op_406*tmp_moved_constant_469 + tmp_kernel_op_407*tmp_moved_constant_470) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_451 + jac_blending_inv_1_0_q_4*tmp_moved_constant_453 + jac_blending_inv_2_0_q_4*tmp_moved_constant_455) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_468 + tmp_kernel_op_412*tmp_moved_constant_469 + tmp_kernel_op_413*tmp_moved_constant_470) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_451 + jac_blending_inv_1_1_q_4*tmp_moved_constant_453 + jac_blending_inv_2_1_q_4*tmp_moved_constant_455) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_468 + tmp_kernel_op_418*tmp_moved_constant_469 + tmp_kernel_op_419*tmp_moved_constant_470) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_451 + jac_blending_inv_1_2_q_4*tmp_moved_constant_453 + jac_blending_inv_2_2_q_4*tmp_moved_constant_455) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_468 + tmp_kernel_op_424*tmp_moved_constant_469 + tmp_kernel_op_425*tmp_moved_constant_470);
             const real_t tmp_kernel_op_566 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_472 + jac_blending_inv_1_0_q_0*tmp_moved_constant_475 + jac_blending_inv_2_0_q_0*tmp_moved_constant_478) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_488 + tmp_kernel_op_35*tmp_moved_constant_491 + tmp_kernel_op_37*tmp_moved_constant_494) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_472 + jac_blending_inv_1_1_q_0*tmp_moved_constant_475 + jac_blending_inv_2_1_q_0*tmp_moved_constant_478) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_488 + tmp_kernel_op_42*tmp_moved_constant_491 + tmp_kernel_op_43*tmp_moved_constant_494) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_472 + jac_blending_inv_1_2_q_0*tmp_moved_constant_475 + jac_blending_inv_2_2_q_0*tmp_moved_constant_478) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_488 + tmp_kernel_op_48*tmp_moved_constant_491 + tmp_kernel_op_49*tmp_moved_constant_494) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_475 + jac_blending_inv_1_0_q_0*tmp_moved_constant_480 + jac_blending_inv_2_0_q_0*tmp_moved_constant_483) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_488 + tmp_kernel_op_54*tmp_moved_constant_491 + tmp_kernel_op_55*tmp_moved_constant_494) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_475 + jac_blending_inv_1_1_q_0*tmp_moved_constant_480 + jac_blending_inv_2_1_q_0*tmp_moved_constant_483) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_488 + tmp_kernel_op_60*tmp_moved_constant_491 + tmp_kernel_op_61*tmp_moved_constant_494) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_475 + jac_blending_inv_1_2_q_0*tmp_moved_constant_480 + jac_blending_inv_2_2_q_0*tmp_moved_constant_483) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_488 + tmp_kernel_op_66*tmp_moved_constant_491 + tmp_kernel_op_67*tmp_moved_constant_494) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_478 + jac_blending_inv_1_0_q_0*tmp_moved_constant_483 + jac_blending_inv_2_0_q_0*tmp_moved_constant_485) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_488 + tmp_kernel_op_72*tmp_moved_constant_491 + tmp_kernel_op_73*tmp_moved_constant_494) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_478 + jac_blending_inv_1_1_q_0*tmp_moved_constant_483 + jac_blending_inv_2_1_q_0*tmp_moved_constant_485) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_488 + tmp_kernel_op_78*tmp_moved_constant_491 + tmp_kernel_op_79*tmp_moved_constant_494) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_478 + jac_blending_inv_1_2_q_0*tmp_moved_constant_483 + jac_blending_inv_2_2_q_0*tmp_moved_constant_485) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_488 + tmp_kernel_op_84*tmp_moved_constant_491 + tmp_kernel_op_85*tmp_moved_constant_494);
             const real_t tmp_kernel_op_576 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_472 + jac_blending_inv_1_0_q_1*tmp_moved_constant_475 + jac_blending_inv_2_0_q_1*tmp_moved_constant_478) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_497 + tmp_kernel_op_120*tmp_moved_constant_500 + tmp_kernel_op_122*tmp_moved_constant_503) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_472 + jac_blending_inv_1_1_q_1*tmp_moved_constant_475 + jac_blending_inv_2_1_q_1*tmp_moved_constant_478) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_497 + tmp_kernel_op_127*tmp_moved_constant_500 + tmp_kernel_op_128*tmp_moved_constant_503) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_472 + jac_blending_inv_1_2_q_1*tmp_moved_constant_475 + jac_blending_inv_2_2_q_1*tmp_moved_constant_478) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_497 + tmp_kernel_op_133*tmp_moved_constant_500 + tmp_kernel_op_134*tmp_moved_constant_503) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_475 + jac_blending_inv_1_0_q_1*tmp_moved_constant_480 + jac_blending_inv_2_0_q_1*tmp_moved_constant_483) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_497 + tmp_kernel_op_139*tmp_moved_constant_500 + tmp_kernel_op_140*tmp_moved_constant_503) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_475 + jac_blending_inv_1_1_q_1*tmp_moved_constant_480 + jac_blending_inv_2_1_q_1*tmp_moved_constant_483) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_497 + tmp_kernel_op_145*tmp_moved_constant_500 + tmp_kernel_op_146*tmp_moved_constant_503) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_475 + jac_blending_inv_1_2_q_1*tmp_moved_constant_480 + jac_blending_inv_2_2_q_1*tmp_moved_constant_483) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_497 + tmp_kernel_op_151*tmp_moved_constant_500 + tmp_kernel_op_152*tmp_moved_constant_503) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_478 + jac_blending_inv_1_0_q_1*tmp_moved_constant_483 + jac_blending_inv_2_0_q_1*tmp_moved_constant_485) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_497 + tmp_kernel_op_157*tmp_moved_constant_500 + tmp_kernel_op_158*tmp_moved_constant_503) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_478 + jac_blending_inv_1_1_q_1*tmp_moved_constant_483 + jac_blending_inv_2_1_q_1*tmp_moved_constant_485) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_497 + tmp_kernel_op_163*tmp_moved_constant_500 + tmp_kernel_op_164*tmp_moved_constant_503) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_478 + jac_blending_inv_1_2_q_1*tmp_moved_constant_483 + jac_blending_inv_2_2_q_1*tmp_moved_constant_485) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_497 + tmp_kernel_op_169*tmp_moved_constant_500 + tmp_kernel_op_170*tmp_moved_constant_503);
             const real_t tmp_kernel_op_586 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_472 + jac_blending_inv_1_0_q_2*tmp_moved_constant_475 + jac_blending_inv_2_0_q_2*tmp_moved_constant_478) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_506 + tmp_kernel_op_205*tmp_moved_constant_509 + tmp_kernel_op_207*tmp_moved_constant_512) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_472 + jac_blending_inv_1_1_q_2*tmp_moved_constant_475 + jac_blending_inv_2_1_q_2*tmp_moved_constant_478) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_506 + tmp_kernel_op_212*tmp_moved_constant_509 + tmp_kernel_op_213*tmp_moved_constant_512) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_472 + jac_blending_inv_1_2_q_2*tmp_moved_constant_475 + jac_blending_inv_2_2_q_2*tmp_moved_constant_478) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_506 + tmp_kernel_op_218*tmp_moved_constant_509 + tmp_kernel_op_219*tmp_moved_constant_512) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_475 + jac_blending_inv_1_0_q_2*tmp_moved_constant_480 + jac_blending_inv_2_0_q_2*tmp_moved_constant_483) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_506 + tmp_kernel_op_224*tmp_moved_constant_509 + tmp_kernel_op_225*tmp_moved_constant_512) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_475 + jac_blending_inv_1_1_q_2*tmp_moved_constant_480 + jac_blending_inv_2_1_q_2*tmp_moved_constant_483) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_506 + tmp_kernel_op_230*tmp_moved_constant_509 + tmp_kernel_op_231*tmp_moved_constant_512) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_475 + jac_blending_inv_1_2_q_2*tmp_moved_constant_480 + jac_blending_inv_2_2_q_2*tmp_moved_constant_483) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_506 + tmp_kernel_op_236*tmp_moved_constant_509 + tmp_kernel_op_237*tmp_moved_constant_512) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_478 + jac_blending_inv_1_0_q_2*tmp_moved_constant_483 + jac_blending_inv_2_0_q_2*tmp_moved_constant_485) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_506 + tmp_kernel_op_242*tmp_moved_constant_509 + tmp_kernel_op_243*tmp_moved_constant_512) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_478 + jac_blending_inv_1_1_q_2*tmp_moved_constant_483 + jac_blending_inv_2_1_q_2*tmp_moved_constant_485) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_506 + tmp_kernel_op_248*tmp_moved_constant_509 + tmp_kernel_op_249*tmp_moved_constant_512) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_478 + jac_blending_inv_1_2_q_2*tmp_moved_constant_483 + jac_blending_inv_2_2_q_2*tmp_moved_constant_485) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_506 + tmp_kernel_op_254*tmp_moved_constant_509 + tmp_kernel_op_255*tmp_moved_constant_512);
             const real_t tmp_kernel_op_596 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_472 + jac_blending_inv_1_0_q_3*tmp_moved_constant_475 + jac_blending_inv_2_0_q_3*tmp_moved_constant_478) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_515 + tmp_kernel_op_290*tmp_moved_constant_518 + tmp_kernel_op_292*tmp_moved_constant_521) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_472 + jac_blending_inv_1_1_q_3*tmp_moved_constant_475 + jac_blending_inv_2_1_q_3*tmp_moved_constant_478) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_515 + tmp_kernel_op_297*tmp_moved_constant_518 + tmp_kernel_op_298*tmp_moved_constant_521) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_472 + jac_blending_inv_1_2_q_3*tmp_moved_constant_475 + jac_blending_inv_2_2_q_3*tmp_moved_constant_478) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_515 + tmp_kernel_op_303*tmp_moved_constant_518 + tmp_kernel_op_304*tmp_moved_constant_521) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_475 + jac_blending_inv_1_0_q_3*tmp_moved_constant_480 + jac_blending_inv_2_0_q_3*tmp_moved_constant_483) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_515 + tmp_kernel_op_309*tmp_moved_constant_518 + tmp_kernel_op_310*tmp_moved_constant_521) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_475 + jac_blending_inv_1_1_q_3*tmp_moved_constant_480 + jac_blending_inv_2_1_q_3*tmp_moved_constant_483) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_515 + tmp_kernel_op_315*tmp_moved_constant_518 + tmp_kernel_op_316*tmp_moved_constant_521) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_475 + jac_blending_inv_1_2_q_3*tmp_moved_constant_480 + jac_blending_inv_2_2_q_3*tmp_moved_constant_483) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_515 + tmp_kernel_op_321*tmp_moved_constant_518 + tmp_kernel_op_322*tmp_moved_constant_521) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_478 + jac_blending_inv_1_0_q_3*tmp_moved_constant_483 + jac_blending_inv_2_0_q_3*tmp_moved_constant_485) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_515 + tmp_kernel_op_327*tmp_moved_constant_518 + tmp_kernel_op_328*tmp_moved_constant_521) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_478 + jac_blending_inv_1_1_q_3*tmp_moved_constant_483 + jac_blending_inv_2_1_q_3*tmp_moved_constant_485) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_515 + tmp_kernel_op_333*tmp_moved_constant_518 + tmp_kernel_op_334*tmp_moved_constant_521) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_478 + jac_blending_inv_1_2_q_3*tmp_moved_constant_483 + jac_blending_inv_2_2_q_3*tmp_moved_constant_485) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_515 + tmp_kernel_op_339*tmp_moved_constant_518 + tmp_kernel_op_340*tmp_moved_constant_521);
             const real_t tmp_kernel_op_606 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_472 + jac_blending_inv_1_0_q_4*tmp_moved_constant_475 + jac_blending_inv_2_0_q_4*tmp_moved_constant_478) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_524 + tmp_kernel_op_375*tmp_moved_constant_527 + tmp_kernel_op_377*tmp_moved_constant_530) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_472 + jac_blending_inv_1_1_q_4*tmp_moved_constant_475 + jac_blending_inv_2_1_q_4*tmp_moved_constant_478) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_524 + tmp_kernel_op_382*tmp_moved_constant_527 + tmp_kernel_op_383*tmp_moved_constant_530) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_472 + jac_blending_inv_1_2_q_4*tmp_moved_constant_475 + jac_blending_inv_2_2_q_4*tmp_moved_constant_478) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_524 + tmp_kernel_op_388*tmp_moved_constant_527 + tmp_kernel_op_389*tmp_moved_constant_530) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_475 + jac_blending_inv_1_0_q_4*tmp_moved_constant_480 + jac_blending_inv_2_0_q_4*tmp_moved_constant_483) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_524 + tmp_kernel_op_394*tmp_moved_constant_527 + tmp_kernel_op_395*tmp_moved_constant_530) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_475 + jac_blending_inv_1_1_q_4*tmp_moved_constant_480 + jac_blending_inv_2_1_q_4*tmp_moved_constant_483) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_524 + tmp_kernel_op_400*tmp_moved_constant_527 + tmp_kernel_op_401*tmp_moved_constant_530) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_475 + jac_blending_inv_1_2_q_4*tmp_moved_constant_480 + jac_blending_inv_2_2_q_4*tmp_moved_constant_483) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_524 + tmp_kernel_op_406*tmp_moved_constant_527 + tmp_kernel_op_407*tmp_moved_constant_530) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_478 + jac_blending_inv_1_0_q_4*tmp_moved_constant_483 + jac_blending_inv_2_0_q_4*tmp_moved_constant_485) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_524 + tmp_kernel_op_412*tmp_moved_constant_527 + tmp_kernel_op_413*tmp_moved_constant_530) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_478 + jac_blending_inv_1_1_q_4*tmp_moved_constant_483 + jac_blending_inv_2_1_q_4*tmp_moved_constant_485) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_524 + tmp_kernel_op_418*tmp_moved_constant_527 + tmp_kernel_op_419*tmp_moved_constant_530) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_478 + jac_blending_inv_1_2_q_4*tmp_moved_constant_483 + jac_blending_inv_2_2_q_4*tmp_moved_constant_485) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_524 + tmp_kernel_op_424*tmp_moved_constant_527 + tmp_kernel_op_425*tmp_moved_constant_530);
             const real_t tmp_kernel_op_628 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_531 + jac_blending_inv_1_0_q_0*tmp_moved_constant_534 + jac_blending_inv_2_0_q_0*tmp_moved_constant_537) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_545 + tmp_kernel_op_35*tmp_moved_constant_548 + tmp_kernel_op_37*tmp_moved_constant_551) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_531 + jac_blending_inv_1_1_q_0*tmp_moved_constant_534 + jac_blending_inv_2_1_q_0*tmp_moved_constant_537) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_545 + tmp_kernel_op_42*tmp_moved_constant_548 + tmp_kernel_op_43*tmp_moved_constant_551) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_531 + jac_blending_inv_1_2_q_0*tmp_moved_constant_534 + jac_blending_inv_2_2_q_0*tmp_moved_constant_537) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_545 + tmp_kernel_op_48*tmp_moved_constant_548 + tmp_kernel_op_49*tmp_moved_constant_551) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_534 + jac_blending_inv_1_0_q_0*tmp_moved_constant_538 + jac_blending_inv_2_0_q_0*tmp_moved_constant_541) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_545 + tmp_kernel_op_54*tmp_moved_constant_548 + tmp_kernel_op_55*tmp_moved_constant_551) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_534 + jac_blending_inv_1_1_q_0*tmp_moved_constant_538 + jac_blending_inv_2_1_q_0*tmp_moved_constant_541) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_545 + tmp_kernel_op_60*tmp_moved_constant_548 + tmp_kernel_op_61*tmp_moved_constant_551) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_534 + jac_blending_inv_1_2_q_0*tmp_moved_constant_538 + jac_blending_inv_2_2_q_0*tmp_moved_constant_541) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_545 + tmp_kernel_op_66*tmp_moved_constant_548 + tmp_kernel_op_67*tmp_moved_constant_551) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_537 + jac_blending_inv_1_0_q_0*tmp_moved_constant_541 + jac_blending_inv_2_0_q_0*tmp_moved_constant_542) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_545 + tmp_kernel_op_72*tmp_moved_constant_548 + tmp_kernel_op_73*tmp_moved_constant_551) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_537 + jac_blending_inv_1_1_q_0*tmp_moved_constant_541 + jac_blending_inv_2_1_q_0*tmp_moved_constant_542) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_545 + tmp_kernel_op_78*tmp_moved_constant_548 + tmp_kernel_op_79*tmp_moved_constant_551) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_537 + jac_blending_inv_1_2_q_0*tmp_moved_constant_541 + jac_blending_inv_2_2_q_0*tmp_moved_constant_542) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_545 + tmp_kernel_op_84*tmp_moved_constant_548 + tmp_kernel_op_85*tmp_moved_constant_551);
             const real_t tmp_kernel_op_638 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_531 + jac_blending_inv_1_0_q_1*tmp_moved_constant_534 + jac_blending_inv_2_0_q_1*tmp_moved_constant_537) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_554 + tmp_kernel_op_120*tmp_moved_constant_557 + tmp_kernel_op_122*tmp_moved_constant_560) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_531 + jac_blending_inv_1_1_q_1*tmp_moved_constant_534 + jac_blending_inv_2_1_q_1*tmp_moved_constant_537) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_554 + tmp_kernel_op_127*tmp_moved_constant_557 + tmp_kernel_op_128*tmp_moved_constant_560) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_531 + jac_blending_inv_1_2_q_1*tmp_moved_constant_534 + jac_blending_inv_2_2_q_1*tmp_moved_constant_537) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_554 + tmp_kernel_op_133*tmp_moved_constant_557 + tmp_kernel_op_134*tmp_moved_constant_560) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_534 + jac_blending_inv_1_0_q_1*tmp_moved_constant_538 + jac_blending_inv_2_0_q_1*tmp_moved_constant_541) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_554 + tmp_kernel_op_139*tmp_moved_constant_557 + tmp_kernel_op_140*tmp_moved_constant_560) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_534 + jac_blending_inv_1_1_q_1*tmp_moved_constant_538 + jac_blending_inv_2_1_q_1*tmp_moved_constant_541) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_554 + tmp_kernel_op_145*tmp_moved_constant_557 + tmp_kernel_op_146*tmp_moved_constant_560) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_534 + jac_blending_inv_1_2_q_1*tmp_moved_constant_538 + jac_blending_inv_2_2_q_1*tmp_moved_constant_541) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_554 + tmp_kernel_op_151*tmp_moved_constant_557 + tmp_kernel_op_152*tmp_moved_constant_560) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_537 + jac_blending_inv_1_0_q_1*tmp_moved_constant_541 + jac_blending_inv_2_0_q_1*tmp_moved_constant_542) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_554 + tmp_kernel_op_157*tmp_moved_constant_557 + tmp_kernel_op_158*tmp_moved_constant_560) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_537 + jac_blending_inv_1_1_q_1*tmp_moved_constant_541 + jac_blending_inv_2_1_q_1*tmp_moved_constant_542) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_554 + tmp_kernel_op_163*tmp_moved_constant_557 + tmp_kernel_op_164*tmp_moved_constant_560) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_537 + jac_blending_inv_1_2_q_1*tmp_moved_constant_541 + jac_blending_inv_2_2_q_1*tmp_moved_constant_542) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_554 + tmp_kernel_op_169*tmp_moved_constant_557 + tmp_kernel_op_170*tmp_moved_constant_560);
             const real_t tmp_kernel_op_648 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_531 + jac_blending_inv_1_0_q_2*tmp_moved_constant_534 + jac_blending_inv_2_0_q_2*tmp_moved_constant_537) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_563 + tmp_kernel_op_205*tmp_moved_constant_566 + tmp_kernel_op_207*tmp_moved_constant_569) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_531 + jac_blending_inv_1_1_q_2*tmp_moved_constant_534 + jac_blending_inv_2_1_q_2*tmp_moved_constant_537) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_563 + tmp_kernel_op_212*tmp_moved_constant_566 + tmp_kernel_op_213*tmp_moved_constant_569) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_531 + jac_blending_inv_1_2_q_2*tmp_moved_constant_534 + jac_blending_inv_2_2_q_2*tmp_moved_constant_537) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_563 + tmp_kernel_op_218*tmp_moved_constant_566 + tmp_kernel_op_219*tmp_moved_constant_569) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_534 + jac_blending_inv_1_0_q_2*tmp_moved_constant_538 + jac_blending_inv_2_0_q_2*tmp_moved_constant_541) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_563 + tmp_kernel_op_224*tmp_moved_constant_566 + tmp_kernel_op_225*tmp_moved_constant_569) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_534 + jac_blending_inv_1_1_q_2*tmp_moved_constant_538 + jac_blending_inv_2_1_q_2*tmp_moved_constant_541) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_563 + tmp_kernel_op_230*tmp_moved_constant_566 + tmp_kernel_op_231*tmp_moved_constant_569) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_534 + jac_blending_inv_1_2_q_2*tmp_moved_constant_538 + jac_blending_inv_2_2_q_2*tmp_moved_constant_541) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_563 + tmp_kernel_op_236*tmp_moved_constant_566 + tmp_kernel_op_237*tmp_moved_constant_569) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_537 + jac_blending_inv_1_0_q_2*tmp_moved_constant_541 + jac_blending_inv_2_0_q_2*tmp_moved_constant_542) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_563 + tmp_kernel_op_242*tmp_moved_constant_566 + tmp_kernel_op_243*tmp_moved_constant_569) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_537 + jac_blending_inv_1_1_q_2*tmp_moved_constant_541 + jac_blending_inv_2_1_q_2*tmp_moved_constant_542) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_563 + tmp_kernel_op_248*tmp_moved_constant_566 + tmp_kernel_op_249*tmp_moved_constant_569) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_537 + jac_blending_inv_1_2_q_2*tmp_moved_constant_541 + jac_blending_inv_2_2_q_2*tmp_moved_constant_542) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_563 + tmp_kernel_op_254*tmp_moved_constant_566 + tmp_kernel_op_255*tmp_moved_constant_569);
             const real_t tmp_kernel_op_658 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_531 + jac_blending_inv_1_0_q_3*tmp_moved_constant_534 + jac_blending_inv_2_0_q_3*tmp_moved_constant_537) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_572 + tmp_kernel_op_290*tmp_moved_constant_575 + tmp_kernel_op_292*tmp_moved_constant_578) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_531 + jac_blending_inv_1_1_q_3*tmp_moved_constant_534 + jac_blending_inv_2_1_q_3*tmp_moved_constant_537) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_572 + tmp_kernel_op_297*tmp_moved_constant_575 + tmp_kernel_op_298*tmp_moved_constant_578) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_531 + jac_blending_inv_1_2_q_3*tmp_moved_constant_534 + jac_blending_inv_2_2_q_3*tmp_moved_constant_537) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_572 + tmp_kernel_op_303*tmp_moved_constant_575 + tmp_kernel_op_304*tmp_moved_constant_578) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_534 + jac_blending_inv_1_0_q_3*tmp_moved_constant_538 + jac_blending_inv_2_0_q_3*tmp_moved_constant_541) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_572 + tmp_kernel_op_309*tmp_moved_constant_575 + tmp_kernel_op_310*tmp_moved_constant_578) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_534 + jac_blending_inv_1_1_q_3*tmp_moved_constant_538 + jac_blending_inv_2_1_q_3*tmp_moved_constant_541) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_572 + tmp_kernel_op_315*tmp_moved_constant_575 + tmp_kernel_op_316*tmp_moved_constant_578) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_534 + jac_blending_inv_1_2_q_3*tmp_moved_constant_538 + jac_blending_inv_2_2_q_3*tmp_moved_constant_541) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_572 + tmp_kernel_op_321*tmp_moved_constant_575 + tmp_kernel_op_322*tmp_moved_constant_578) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_537 + jac_blending_inv_1_0_q_3*tmp_moved_constant_541 + jac_blending_inv_2_0_q_3*tmp_moved_constant_542) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_572 + tmp_kernel_op_327*tmp_moved_constant_575 + tmp_kernel_op_328*tmp_moved_constant_578) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_537 + jac_blending_inv_1_1_q_3*tmp_moved_constant_541 + jac_blending_inv_2_1_q_3*tmp_moved_constant_542) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_572 + tmp_kernel_op_333*tmp_moved_constant_575 + tmp_kernel_op_334*tmp_moved_constant_578) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_537 + jac_blending_inv_1_2_q_3*tmp_moved_constant_541 + jac_blending_inv_2_2_q_3*tmp_moved_constant_542) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_572 + tmp_kernel_op_339*tmp_moved_constant_575 + tmp_kernel_op_340*tmp_moved_constant_578);
             const real_t tmp_kernel_op_668 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_531 + jac_blending_inv_1_0_q_4*tmp_moved_constant_534 + jac_blending_inv_2_0_q_4*tmp_moved_constant_537) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_581 + tmp_kernel_op_375*tmp_moved_constant_584 + tmp_kernel_op_377*tmp_moved_constant_587) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_531 + jac_blending_inv_1_1_q_4*tmp_moved_constant_534 + jac_blending_inv_2_1_q_4*tmp_moved_constant_537) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_581 + tmp_kernel_op_382*tmp_moved_constant_584 + tmp_kernel_op_383*tmp_moved_constant_587) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_531 + jac_blending_inv_1_2_q_4*tmp_moved_constant_534 + jac_blending_inv_2_2_q_4*tmp_moved_constant_537) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_581 + tmp_kernel_op_388*tmp_moved_constant_584 + tmp_kernel_op_389*tmp_moved_constant_587) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_534 + jac_blending_inv_1_0_q_4*tmp_moved_constant_538 + jac_blending_inv_2_0_q_4*tmp_moved_constant_541) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_581 + tmp_kernel_op_394*tmp_moved_constant_584 + tmp_kernel_op_395*tmp_moved_constant_587) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_534 + jac_blending_inv_1_1_q_4*tmp_moved_constant_538 + jac_blending_inv_2_1_q_4*tmp_moved_constant_541) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_581 + tmp_kernel_op_400*tmp_moved_constant_584 + tmp_kernel_op_401*tmp_moved_constant_587) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_534 + jac_blending_inv_1_2_q_4*tmp_moved_constant_538 + jac_blending_inv_2_2_q_4*tmp_moved_constant_541) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_581 + tmp_kernel_op_406*tmp_moved_constant_584 + tmp_kernel_op_407*tmp_moved_constant_587) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_537 + jac_blending_inv_1_0_q_4*tmp_moved_constant_541 + jac_blending_inv_2_0_q_4*tmp_moved_constant_542) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_581 + tmp_kernel_op_412*tmp_moved_constant_584 + tmp_kernel_op_413*tmp_moved_constant_587) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_537 + jac_blending_inv_1_1_q_4*tmp_moved_constant_541 + jac_blending_inv_2_1_q_4*tmp_moved_constant_542) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_581 + tmp_kernel_op_418*tmp_moved_constant_584 + tmp_kernel_op_419*tmp_moved_constant_587) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_537 + jac_blending_inv_1_2_q_4*tmp_moved_constant_541 + jac_blending_inv_2_2_q_4*tmp_moved_constant_542) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_581 + tmp_kernel_op_424*tmp_moved_constant_584 + tmp_kernel_op_425*tmp_moved_constant_587);
             const real_t tmp_kernel_op_693 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_589 + jac_blending_inv_1_0_q_0*tmp_moved_constant_592 + jac_blending_inv_2_0_q_0*tmp_moved_constant_595) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_605 + tmp_kernel_op_35*tmp_moved_constant_608 + tmp_kernel_op_37*tmp_moved_constant_611) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_589 + jac_blending_inv_1_1_q_0*tmp_moved_constant_592 + jac_blending_inv_2_1_q_0*tmp_moved_constant_595) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_605 + tmp_kernel_op_42*tmp_moved_constant_608 + tmp_kernel_op_43*tmp_moved_constant_611) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_589 + jac_blending_inv_1_2_q_0*tmp_moved_constant_592 + jac_blending_inv_2_2_q_0*tmp_moved_constant_595) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_605 + tmp_kernel_op_48*tmp_moved_constant_608 + tmp_kernel_op_49*tmp_moved_constant_611) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_592 + jac_blending_inv_1_0_q_0*tmp_moved_constant_597 + jac_blending_inv_2_0_q_0*tmp_moved_constant_600) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_605 + tmp_kernel_op_54*tmp_moved_constant_608 + tmp_kernel_op_55*tmp_moved_constant_611) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_592 + jac_blending_inv_1_1_q_0*tmp_moved_constant_597 + jac_blending_inv_2_1_q_0*tmp_moved_constant_600) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_605 + tmp_kernel_op_60*tmp_moved_constant_608 + tmp_kernel_op_61*tmp_moved_constant_611) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_592 + jac_blending_inv_1_2_q_0*tmp_moved_constant_597 + jac_blending_inv_2_2_q_0*tmp_moved_constant_600) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_605 + tmp_kernel_op_66*tmp_moved_constant_608 + tmp_kernel_op_67*tmp_moved_constant_611) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_595 + jac_blending_inv_1_0_q_0*tmp_moved_constant_600 + jac_blending_inv_2_0_q_0*tmp_moved_constant_602) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_605 + tmp_kernel_op_72*tmp_moved_constant_608 + tmp_kernel_op_73*tmp_moved_constant_611) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_595 + jac_blending_inv_1_1_q_0*tmp_moved_constant_600 + jac_blending_inv_2_1_q_0*tmp_moved_constant_602) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_605 + tmp_kernel_op_78*tmp_moved_constant_608 + tmp_kernel_op_79*tmp_moved_constant_611) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_595 + jac_blending_inv_1_2_q_0*tmp_moved_constant_600 + jac_blending_inv_2_2_q_0*tmp_moved_constant_602) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_605 + tmp_kernel_op_84*tmp_moved_constant_608 + tmp_kernel_op_85*tmp_moved_constant_611);
             const real_t tmp_kernel_op_703 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_589 + jac_blending_inv_1_0_q_1*tmp_moved_constant_592 + jac_blending_inv_2_0_q_1*tmp_moved_constant_595) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_614 + tmp_kernel_op_120*tmp_moved_constant_617 + tmp_kernel_op_122*tmp_moved_constant_620) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_589 + jac_blending_inv_1_1_q_1*tmp_moved_constant_592 + jac_blending_inv_2_1_q_1*tmp_moved_constant_595) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_614 + tmp_kernel_op_127*tmp_moved_constant_617 + tmp_kernel_op_128*tmp_moved_constant_620) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_589 + jac_blending_inv_1_2_q_1*tmp_moved_constant_592 + jac_blending_inv_2_2_q_1*tmp_moved_constant_595) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_614 + tmp_kernel_op_133*tmp_moved_constant_617 + tmp_kernel_op_134*tmp_moved_constant_620) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_592 + jac_blending_inv_1_0_q_1*tmp_moved_constant_597 + jac_blending_inv_2_0_q_1*tmp_moved_constant_600) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_614 + tmp_kernel_op_139*tmp_moved_constant_617 + tmp_kernel_op_140*tmp_moved_constant_620) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_592 + jac_blending_inv_1_1_q_1*tmp_moved_constant_597 + jac_blending_inv_2_1_q_1*tmp_moved_constant_600) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_614 + tmp_kernel_op_145*tmp_moved_constant_617 + tmp_kernel_op_146*tmp_moved_constant_620) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_592 + jac_blending_inv_1_2_q_1*tmp_moved_constant_597 + jac_blending_inv_2_2_q_1*tmp_moved_constant_600) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_614 + tmp_kernel_op_151*tmp_moved_constant_617 + tmp_kernel_op_152*tmp_moved_constant_620) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_595 + jac_blending_inv_1_0_q_1*tmp_moved_constant_600 + jac_blending_inv_2_0_q_1*tmp_moved_constant_602) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_614 + tmp_kernel_op_157*tmp_moved_constant_617 + tmp_kernel_op_158*tmp_moved_constant_620) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_595 + jac_blending_inv_1_1_q_1*tmp_moved_constant_600 + jac_blending_inv_2_1_q_1*tmp_moved_constant_602) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_614 + tmp_kernel_op_163*tmp_moved_constant_617 + tmp_kernel_op_164*tmp_moved_constant_620) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_595 + jac_blending_inv_1_2_q_1*tmp_moved_constant_600 + jac_blending_inv_2_2_q_1*tmp_moved_constant_602) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_614 + tmp_kernel_op_169*tmp_moved_constant_617 + tmp_kernel_op_170*tmp_moved_constant_620);
             const real_t tmp_kernel_op_713 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_589 + jac_blending_inv_1_0_q_2*tmp_moved_constant_592 + jac_blending_inv_2_0_q_2*tmp_moved_constant_595) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_623 + tmp_kernel_op_205*tmp_moved_constant_626 + tmp_kernel_op_207*tmp_moved_constant_629) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_589 + jac_blending_inv_1_1_q_2*tmp_moved_constant_592 + jac_blending_inv_2_1_q_2*tmp_moved_constant_595) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_623 + tmp_kernel_op_212*tmp_moved_constant_626 + tmp_kernel_op_213*tmp_moved_constant_629) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_589 + jac_blending_inv_1_2_q_2*tmp_moved_constant_592 + jac_blending_inv_2_2_q_2*tmp_moved_constant_595) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_623 + tmp_kernel_op_218*tmp_moved_constant_626 + tmp_kernel_op_219*tmp_moved_constant_629) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_592 + jac_blending_inv_1_0_q_2*tmp_moved_constant_597 + jac_blending_inv_2_0_q_2*tmp_moved_constant_600) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_623 + tmp_kernel_op_224*tmp_moved_constant_626 + tmp_kernel_op_225*tmp_moved_constant_629) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_592 + jac_blending_inv_1_1_q_2*tmp_moved_constant_597 + jac_blending_inv_2_1_q_2*tmp_moved_constant_600) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_623 + tmp_kernel_op_230*tmp_moved_constant_626 + tmp_kernel_op_231*tmp_moved_constant_629) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_592 + jac_blending_inv_1_2_q_2*tmp_moved_constant_597 + jac_blending_inv_2_2_q_2*tmp_moved_constant_600) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_623 + tmp_kernel_op_236*tmp_moved_constant_626 + tmp_kernel_op_237*tmp_moved_constant_629) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_595 + jac_blending_inv_1_0_q_2*tmp_moved_constant_600 + jac_blending_inv_2_0_q_2*tmp_moved_constant_602) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_623 + tmp_kernel_op_242*tmp_moved_constant_626 + tmp_kernel_op_243*tmp_moved_constant_629) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_595 + jac_blending_inv_1_1_q_2*tmp_moved_constant_600 + jac_blending_inv_2_1_q_2*tmp_moved_constant_602) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_623 + tmp_kernel_op_248*tmp_moved_constant_626 + tmp_kernel_op_249*tmp_moved_constant_629) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_595 + jac_blending_inv_1_2_q_2*tmp_moved_constant_600 + jac_blending_inv_2_2_q_2*tmp_moved_constant_602) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_623 + tmp_kernel_op_254*tmp_moved_constant_626 + tmp_kernel_op_255*tmp_moved_constant_629);
             const real_t tmp_kernel_op_723 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_589 + jac_blending_inv_1_0_q_3*tmp_moved_constant_592 + jac_blending_inv_2_0_q_3*tmp_moved_constant_595) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_632 + tmp_kernel_op_290*tmp_moved_constant_635 + tmp_kernel_op_292*tmp_moved_constant_638) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_589 + jac_blending_inv_1_1_q_3*tmp_moved_constant_592 + jac_blending_inv_2_1_q_3*tmp_moved_constant_595) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_632 + tmp_kernel_op_297*tmp_moved_constant_635 + tmp_kernel_op_298*tmp_moved_constant_638) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_589 + jac_blending_inv_1_2_q_3*tmp_moved_constant_592 + jac_blending_inv_2_2_q_3*tmp_moved_constant_595) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_632 + tmp_kernel_op_303*tmp_moved_constant_635 + tmp_kernel_op_304*tmp_moved_constant_638) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_592 + jac_blending_inv_1_0_q_3*tmp_moved_constant_597 + jac_blending_inv_2_0_q_3*tmp_moved_constant_600) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_632 + tmp_kernel_op_309*tmp_moved_constant_635 + tmp_kernel_op_310*tmp_moved_constant_638) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_592 + jac_blending_inv_1_1_q_3*tmp_moved_constant_597 + jac_blending_inv_2_1_q_3*tmp_moved_constant_600) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_632 + tmp_kernel_op_315*tmp_moved_constant_635 + tmp_kernel_op_316*tmp_moved_constant_638) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_592 + jac_blending_inv_1_2_q_3*tmp_moved_constant_597 + jac_blending_inv_2_2_q_3*tmp_moved_constant_600) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_632 + tmp_kernel_op_321*tmp_moved_constant_635 + tmp_kernel_op_322*tmp_moved_constant_638) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_595 + jac_blending_inv_1_0_q_3*tmp_moved_constant_600 + jac_blending_inv_2_0_q_3*tmp_moved_constant_602) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_632 + tmp_kernel_op_327*tmp_moved_constant_635 + tmp_kernel_op_328*tmp_moved_constant_638) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_595 + jac_blending_inv_1_1_q_3*tmp_moved_constant_600 + jac_blending_inv_2_1_q_3*tmp_moved_constant_602) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_632 + tmp_kernel_op_333*tmp_moved_constant_635 + tmp_kernel_op_334*tmp_moved_constant_638) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_595 + jac_blending_inv_1_2_q_3*tmp_moved_constant_600 + jac_blending_inv_2_2_q_3*tmp_moved_constant_602) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_632 + tmp_kernel_op_339*tmp_moved_constant_635 + tmp_kernel_op_340*tmp_moved_constant_638);
             const real_t tmp_kernel_op_733 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_589 + jac_blending_inv_1_0_q_4*tmp_moved_constant_592 + jac_blending_inv_2_0_q_4*tmp_moved_constant_595) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_641 + tmp_kernel_op_375*tmp_moved_constant_644 + tmp_kernel_op_377*tmp_moved_constant_647) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_589 + jac_blending_inv_1_1_q_4*tmp_moved_constant_592 + jac_blending_inv_2_1_q_4*tmp_moved_constant_595) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_641 + tmp_kernel_op_382*tmp_moved_constant_644 + tmp_kernel_op_383*tmp_moved_constant_647) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_589 + jac_blending_inv_1_2_q_4*tmp_moved_constant_592 + jac_blending_inv_2_2_q_4*tmp_moved_constant_595) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_641 + tmp_kernel_op_388*tmp_moved_constant_644 + tmp_kernel_op_389*tmp_moved_constant_647) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_592 + jac_blending_inv_1_0_q_4*tmp_moved_constant_597 + jac_blending_inv_2_0_q_4*tmp_moved_constant_600) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_641 + tmp_kernel_op_394*tmp_moved_constant_644 + tmp_kernel_op_395*tmp_moved_constant_647) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_592 + jac_blending_inv_1_1_q_4*tmp_moved_constant_597 + jac_blending_inv_2_1_q_4*tmp_moved_constant_600) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_641 + tmp_kernel_op_400*tmp_moved_constant_644 + tmp_kernel_op_401*tmp_moved_constant_647) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_592 + jac_blending_inv_1_2_q_4*tmp_moved_constant_597 + jac_blending_inv_2_2_q_4*tmp_moved_constant_600) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_641 + tmp_kernel_op_406*tmp_moved_constant_644 + tmp_kernel_op_407*tmp_moved_constant_647) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_595 + jac_blending_inv_1_0_q_4*tmp_moved_constant_600 + jac_blending_inv_2_0_q_4*tmp_moved_constant_602) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_641 + tmp_kernel_op_412*tmp_moved_constant_644 + tmp_kernel_op_413*tmp_moved_constant_647) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_595 + jac_blending_inv_1_1_q_4*tmp_moved_constant_600 + jac_blending_inv_2_1_q_4*tmp_moved_constant_602) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_641 + tmp_kernel_op_418*tmp_moved_constant_644 + tmp_kernel_op_419*tmp_moved_constant_647) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_595 + jac_blending_inv_1_2_q_4*tmp_moved_constant_600 + jac_blending_inv_2_2_q_4*tmp_moved_constant_602) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_641 + tmp_kernel_op_424*tmp_moved_constant_644 + tmp_kernel_op_425*tmp_moved_constant_647);
             const real_t tmp_kernel_op_756 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_651 + jac_blending_inv_1_0_q_0*tmp_moved_constant_653 + jac_blending_inv_2_0_q_0*tmp_moved_constant_655) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_666 + tmp_kernel_op_35*tmp_moved_constant_667 + tmp_kernel_op_37*tmp_moved_constant_668) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_651 + jac_blending_inv_1_1_q_0*tmp_moved_constant_653 + jac_blending_inv_2_1_q_0*tmp_moved_constant_655) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_666 + tmp_kernel_op_42*tmp_moved_constant_667 + tmp_kernel_op_43*tmp_moved_constant_668) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_651 + jac_blending_inv_1_2_q_0*tmp_moved_constant_653 + jac_blending_inv_2_2_q_0*tmp_moved_constant_655) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_666 + tmp_kernel_op_48*tmp_moved_constant_667 + tmp_kernel_op_49*tmp_moved_constant_668) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_656 + jac_blending_inv_1_0_q_0*tmp_moved_constant_659 + jac_blending_inv_2_0_q_0*tmp_moved_constant_660) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_666 + tmp_kernel_op_54*tmp_moved_constant_667 + tmp_kernel_op_55*tmp_moved_constant_668) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_656 + jac_blending_inv_1_1_q_0*tmp_moved_constant_659 + jac_blending_inv_2_1_q_0*tmp_moved_constant_660) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_666 + tmp_kernel_op_60*tmp_moved_constant_667 + tmp_kernel_op_61*tmp_moved_constant_668) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_656 + jac_blending_inv_1_2_q_0*tmp_moved_constant_659 + jac_blending_inv_2_2_q_0*tmp_moved_constant_660) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_666 + tmp_kernel_op_66*tmp_moved_constant_667 + tmp_kernel_op_67*tmp_moved_constant_668) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_661 + jac_blending_inv_1_0_q_0*tmp_moved_constant_662 + jac_blending_inv_2_0_q_0*tmp_moved_constant_665) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_666 + tmp_kernel_op_72*tmp_moved_constant_667 + tmp_kernel_op_73*tmp_moved_constant_668) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_661 + jac_blending_inv_1_1_q_0*tmp_moved_constant_662 + jac_blending_inv_2_1_q_0*tmp_moved_constant_665) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_666 + tmp_kernel_op_78*tmp_moved_constant_667 + tmp_kernel_op_79*tmp_moved_constant_668) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_661 + jac_blending_inv_1_2_q_0*tmp_moved_constant_662 + jac_blending_inv_2_2_q_0*tmp_moved_constant_665) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_666 + tmp_kernel_op_84*tmp_moved_constant_667 + tmp_kernel_op_85*tmp_moved_constant_668);
             const real_t tmp_kernel_op_761 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_651 + jac_blending_inv_1_0_q_1*tmp_moved_constant_653 + jac_blending_inv_2_0_q_1*tmp_moved_constant_655) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_669 + tmp_kernel_op_120*tmp_moved_constant_670 + tmp_kernel_op_122*tmp_moved_constant_671) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_651 + jac_blending_inv_1_1_q_1*tmp_moved_constant_653 + jac_blending_inv_2_1_q_1*tmp_moved_constant_655) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_669 + tmp_kernel_op_127*tmp_moved_constant_670 + tmp_kernel_op_128*tmp_moved_constant_671) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_651 + jac_blending_inv_1_2_q_1*tmp_moved_constant_653 + jac_blending_inv_2_2_q_1*tmp_moved_constant_655) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_669 + tmp_kernel_op_133*tmp_moved_constant_670 + tmp_kernel_op_134*tmp_moved_constant_671) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_656 + jac_blending_inv_1_0_q_1*tmp_moved_constant_659 + jac_blending_inv_2_0_q_1*tmp_moved_constant_660) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_669 + tmp_kernel_op_139*tmp_moved_constant_670 + tmp_kernel_op_140*tmp_moved_constant_671) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_656 + jac_blending_inv_1_1_q_1*tmp_moved_constant_659 + jac_blending_inv_2_1_q_1*tmp_moved_constant_660) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_669 + tmp_kernel_op_145*tmp_moved_constant_670 + tmp_kernel_op_146*tmp_moved_constant_671) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_656 + jac_blending_inv_1_2_q_1*tmp_moved_constant_659 + jac_blending_inv_2_2_q_1*tmp_moved_constant_660) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_669 + tmp_kernel_op_151*tmp_moved_constant_670 + tmp_kernel_op_152*tmp_moved_constant_671) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_661 + jac_blending_inv_1_0_q_1*tmp_moved_constant_662 + jac_blending_inv_2_0_q_1*tmp_moved_constant_665) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_669 + tmp_kernel_op_157*tmp_moved_constant_670 + tmp_kernel_op_158*tmp_moved_constant_671) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_661 + jac_blending_inv_1_1_q_1*tmp_moved_constant_662 + jac_blending_inv_2_1_q_1*tmp_moved_constant_665) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_669 + tmp_kernel_op_163*tmp_moved_constant_670 + tmp_kernel_op_164*tmp_moved_constant_671) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_661 + jac_blending_inv_1_2_q_1*tmp_moved_constant_662 + jac_blending_inv_2_2_q_1*tmp_moved_constant_665) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_669 + tmp_kernel_op_169*tmp_moved_constant_670 + tmp_kernel_op_170*tmp_moved_constant_671);
             const real_t tmp_kernel_op_766 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_651 + jac_blending_inv_1_0_q_2*tmp_moved_constant_653 + jac_blending_inv_2_0_q_2*tmp_moved_constant_655) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_672 + tmp_kernel_op_205*tmp_moved_constant_673 + tmp_kernel_op_207*tmp_moved_constant_674) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_651 + jac_blending_inv_1_1_q_2*tmp_moved_constant_653 + jac_blending_inv_2_1_q_2*tmp_moved_constant_655) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_672 + tmp_kernel_op_212*tmp_moved_constant_673 + tmp_kernel_op_213*tmp_moved_constant_674) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_651 + jac_blending_inv_1_2_q_2*tmp_moved_constant_653 + jac_blending_inv_2_2_q_2*tmp_moved_constant_655) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_672 + tmp_kernel_op_218*tmp_moved_constant_673 + tmp_kernel_op_219*tmp_moved_constant_674) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_656 + jac_blending_inv_1_0_q_2*tmp_moved_constant_659 + jac_blending_inv_2_0_q_2*tmp_moved_constant_660) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_672 + tmp_kernel_op_224*tmp_moved_constant_673 + tmp_kernel_op_225*tmp_moved_constant_674) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_656 + jac_blending_inv_1_1_q_2*tmp_moved_constant_659 + jac_blending_inv_2_1_q_2*tmp_moved_constant_660) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_672 + tmp_kernel_op_230*tmp_moved_constant_673 + tmp_kernel_op_231*tmp_moved_constant_674) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_656 + jac_blending_inv_1_2_q_2*tmp_moved_constant_659 + jac_blending_inv_2_2_q_2*tmp_moved_constant_660) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_672 + tmp_kernel_op_236*tmp_moved_constant_673 + tmp_kernel_op_237*tmp_moved_constant_674) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_661 + jac_blending_inv_1_0_q_2*tmp_moved_constant_662 + jac_blending_inv_2_0_q_2*tmp_moved_constant_665) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_672 + tmp_kernel_op_242*tmp_moved_constant_673 + tmp_kernel_op_243*tmp_moved_constant_674) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_661 + jac_blending_inv_1_1_q_2*tmp_moved_constant_662 + jac_blending_inv_2_1_q_2*tmp_moved_constant_665) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_672 + tmp_kernel_op_248*tmp_moved_constant_673 + tmp_kernel_op_249*tmp_moved_constant_674) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_661 + jac_blending_inv_1_2_q_2*tmp_moved_constant_662 + jac_blending_inv_2_2_q_2*tmp_moved_constant_665) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_672 + tmp_kernel_op_254*tmp_moved_constant_673 + tmp_kernel_op_255*tmp_moved_constant_674);
             const real_t tmp_kernel_op_771 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_651 + jac_blending_inv_1_0_q_3*tmp_moved_constant_653 + jac_blending_inv_2_0_q_3*tmp_moved_constant_655) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_675 + tmp_kernel_op_290*tmp_moved_constant_676 + tmp_kernel_op_292*tmp_moved_constant_677) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_651 + jac_blending_inv_1_1_q_3*tmp_moved_constant_653 + jac_blending_inv_2_1_q_3*tmp_moved_constant_655) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_675 + tmp_kernel_op_297*tmp_moved_constant_676 + tmp_kernel_op_298*tmp_moved_constant_677) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_651 + jac_blending_inv_1_2_q_3*tmp_moved_constant_653 + jac_blending_inv_2_2_q_3*tmp_moved_constant_655) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_675 + tmp_kernel_op_303*tmp_moved_constant_676 + tmp_kernel_op_304*tmp_moved_constant_677) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_656 + jac_blending_inv_1_0_q_3*tmp_moved_constant_659 + jac_blending_inv_2_0_q_3*tmp_moved_constant_660) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_675 + tmp_kernel_op_309*tmp_moved_constant_676 + tmp_kernel_op_310*tmp_moved_constant_677) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_656 + jac_blending_inv_1_1_q_3*tmp_moved_constant_659 + jac_blending_inv_2_1_q_3*tmp_moved_constant_660) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_675 + tmp_kernel_op_315*tmp_moved_constant_676 + tmp_kernel_op_316*tmp_moved_constant_677) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_656 + jac_blending_inv_1_2_q_3*tmp_moved_constant_659 + jac_blending_inv_2_2_q_3*tmp_moved_constant_660) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_675 + tmp_kernel_op_321*tmp_moved_constant_676 + tmp_kernel_op_322*tmp_moved_constant_677) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_661 + jac_blending_inv_1_0_q_3*tmp_moved_constant_662 + jac_blending_inv_2_0_q_3*tmp_moved_constant_665) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_675 + tmp_kernel_op_327*tmp_moved_constant_676 + tmp_kernel_op_328*tmp_moved_constant_677) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_661 + jac_blending_inv_1_1_q_3*tmp_moved_constant_662 + jac_blending_inv_2_1_q_3*tmp_moved_constant_665) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_675 + tmp_kernel_op_333*tmp_moved_constant_676 + tmp_kernel_op_334*tmp_moved_constant_677) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_661 + jac_blending_inv_1_2_q_3*tmp_moved_constant_662 + jac_blending_inv_2_2_q_3*tmp_moved_constant_665) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_675 + tmp_kernel_op_339*tmp_moved_constant_676 + tmp_kernel_op_340*tmp_moved_constant_677);
             const real_t tmp_kernel_op_776 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_651 + jac_blending_inv_1_0_q_4*tmp_moved_constant_653 + jac_blending_inv_2_0_q_4*tmp_moved_constant_655) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_678 + tmp_kernel_op_375*tmp_moved_constant_679 + tmp_kernel_op_377*tmp_moved_constant_680) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_651 + jac_blending_inv_1_1_q_4*tmp_moved_constant_653 + jac_blending_inv_2_1_q_4*tmp_moved_constant_655) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_678 + tmp_kernel_op_382*tmp_moved_constant_679 + tmp_kernel_op_383*tmp_moved_constant_680) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_651 + jac_blending_inv_1_2_q_4*tmp_moved_constant_653 + jac_blending_inv_2_2_q_4*tmp_moved_constant_655) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_678 + tmp_kernel_op_388*tmp_moved_constant_679 + tmp_kernel_op_389*tmp_moved_constant_680) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_656 + jac_blending_inv_1_0_q_4*tmp_moved_constant_659 + jac_blending_inv_2_0_q_4*tmp_moved_constant_660) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_678 + tmp_kernel_op_394*tmp_moved_constant_679 + tmp_kernel_op_395*tmp_moved_constant_680) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_656 + jac_blending_inv_1_1_q_4*tmp_moved_constant_659 + jac_blending_inv_2_1_q_4*tmp_moved_constant_660) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_678 + tmp_kernel_op_400*tmp_moved_constant_679 + tmp_kernel_op_401*tmp_moved_constant_680) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_656 + jac_blending_inv_1_2_q_4*tmp_moved_constant_659 + jac_blending_inv_2_2_q_4*tmp_moved_constant_660) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_678 + tmp_kernel_op_406*tmp_moved_constant_679 + tmp_kernel_op_407*tmp_moved_constant_680) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_661 + jac_blending_inv_1_0_q_4*tmp_moved_constant_662 + jac_blending_inv_2_0_q_4*tmp_moved_constant_665) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_678 + tmp_kernel_op_412*tmp_moved_constant_679 + tmp_kernel_op_413*tmp_moved_constant_680) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_661 + jac_blending_inv_1_1_q_4*tmp_moved_constant_662 + jac_blending_inv_2_1_q_4*tmp_moved_constant_665) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_678 + tmp_kernel_op_418*tmp_moved_constant_679 + tmp_kernel_op_419*tmp_moved_constant_680) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_661 + jac_blending_inv_1_2_q_4*tmp_moved_constant_662 + jac_blending_inv_2_2_q_4*tmp_moved_constant_665) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_678 + tmp_kernel_op_424*tmp_moved_constant_679 + tmp_kernel_op_425*tmp_moved_constant_680);
             const real_t tmp_kernel_op_797 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_683 + jac_blending_inv_1_0_q_0*tmp_moved_constant_685 + jac_blending_inv_2_0_q_0*tmp_moved_constant_687) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_696 + tmp_kernel_op_35*tmp_moved_constant_697 + tmp_kernel_op_37*tmp_moved_constant_698) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_683 + jac_blending_inv_1_1_q_0*tmp_moved_constant_685 + jac_blending_inv_2_1_q_0*tmp_moved_constant_687) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_696 + tmp_kernel_op_42*tmp_moved_constant_697 + tmp_kernel_op_43*tmp_moved_constant_698) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_683 + jac_blending_inv_1_2_q_0*tmp_moved_constant_685 + jac_blending_inv_2_2_q_0*tmp_moved_constant_687) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_696 + tmp_kernel_op_48*tmp_moved_constant_697 + tmp_kernel_op_49*tmp_moved_constant_698) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_688 + jac_blending_inv_1_0_q_0*tmp_moved_constant_690 + jac_blending_inv_2_0_q_0*tmp_moved_constant_691) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_696 + tmp_kernel_op_54*tmp_moved_constant_697 + tmp_kernel_op_55*tmp_moved_constant_698) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_688 + jac_blending_inv_1_1_q_0*tmp_moved_constant_690 + jac_blending_inv_2_1_q_0*tmp_moved_constant_691) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_696 + tmp_kernel_op_60*tmp_moved_constant_697 + tmp_kernel_op_61*tmp_moved_constant_698) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_688 + jac_blending_inv_1_2_q_0*tmp_moved_constant_690 + jac_blending_inv_2_2_q_0*tmp_moved_constant_691) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_696 + tmp_kernel_op_66*tmp_moved_constant_697 + tmp_kernel_op_67*tmp_moved_constant_698) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_692 + jac_blending_inv_1_0_q_0*tmp_moved_constant_693 + jac_blending_inv_2_0_q_0*tmp_moved_constant_695) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_696 + tmp_kernel_op_72*tmp_moved_constant_697 + tmp_kernel_op_73*tmp_moved_constant_698) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_692 + jac_blending_inv_1_1_q_0*tmp_moved_constant_693 + jac_blending_inv_2_1_q_0*tmp_moved_constant_695) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_696 + tmp_kernel_op_78*tmp_moved_constant_697 + tmp_kernel_op_79*tmp_moved_constant_698) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_692 + jac_blending_inv_1_2_q_0*tmp_moved_constant_693 + jac_blending_inv_2_2_q_0*tmp_moved_constant_695) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_696 + tmp_kernel_op_84*tmp_moved_constant_697 + tmp_kernel_op_85*tmp_moved_constant_698);
             const real_t tmp_kernel_op_803 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_683 + jac_blending_inv_1_0_q_1*tmp_moved_constant_685 + jac_blending_inv_2_0_q_1*tmp_moved_constant_687) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_699 + tmp_kernel_op_120*tmp_moved_constant_700 + tmp_kernel_op_122*tmp_moved_constant_701) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_683 + jac_blending_inv_1_1_q_1*tmp_moved_constant_685 + jac_blending_inv_2_1_q_1*tmp_moved_constant_687) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_699 + tmp_kernel_op_127*tmp_moved_constant_700 + tmp_kernel_op_128*tmp_moved_constant_701) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_683 + jac_blending_inv_1_2_q_1*tmp_moved_constant_685 + jac_blending_inv_2_2_q_1*tmp_moved_constant_687) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_699 + tmp_kernel_op_133*tmp_moved_constant_700 + tmp_kernel_op_134*tmp_moved_constant_701) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_688 + jac_blending_inv_1_0_q_1*tmp_moved_constant_690 + jac_blending_inv_2_0_q_1*tmp_moved_constant_691) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_699 + tmp_kernel_op_139*tmp_moved_constant_700 + tmp_kernel_op_140*tmp_moved_constant_701) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_688 + jac_blending_inv_1_1_q_1*tmp_moved_constant_690 + jac_blending_inv_2_1_q_1*tmp_moved_constant_691) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_699 + tmp_kernel_op_145*tmp_moved_constant_700 + tmp_kernel_op_146*tmp_moved_constant_701) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_688 + jac_blending_inv_1_2_q_1*tmp_moved_constant_690 + jac_blending_inv_2_2_q_1*tmp_moved_constant_691) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_699 + tmp_kernel_op_151*tmp_moved_constant_700 + tmp_kernel_op_152*tmp_moved_constant_701) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_692 + jac_blending_inv_1_0_q_1*tmp_moved_constant_693 + jac_blending_inv_2_0_q_1*tmp_moved_constant_695) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_699 + tmp_kernel_op_157*tmp_moved_constant_700 + tmp_kernel_op_158*tmp_moved_constant_701) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_692 + jac_blending_inv_1_1_q_1*tmp_moved_constant_693 + jac_blending_inv_2_1_q_1*tmp_moved_constant_695) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_699 + tmp_kernel_op_163*tmp_moved_constant_700 + tmp_kernel_op_164*tmp_moved_constant_701) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_692 + jac_blending_inv_1_2_q_1*tmp_moved_constant_693 + jac_blending_inv_2_2_q_1*tmp_moved_constant_695) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_699 + tmp_kernel_op_169*tmp_moved_constant_700 + tmp_kernel_op_170*tmp_moved_constant_701);
             const real_t tmp_kernel_op_809 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_683 + jac_blending_inv_1_0_q_2*tmp_moved_constant_685 + jac_blending_inv_2_0_q_2*tmp_moved_constant_687) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_702 + tmp_kernel_op_205*tmp_moved_constant_703 + tmp_kernel_op_207*tmp_moved_constant_704) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_683 + jac_blending_inv_1_1_q_2*tmp_moved_constant_685 + jac_blending_inv_2_1_q_2*tmp_moved_constant_687) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_702 + tmp_kernel_op_212*tmp_moved_constant_703 + tmp_kernel_op_213*tmp_moved_constant_704) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_683 + jac_blending_inv_1_2_q_2*tmp_moved_constant_685 + jac_blending_inv_2_2_q_2*tmp_moved_constant_687) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_702 + tmp_kernel_op_218*tmp_moved_constant_703 + tmp_kernel_op_219*tmp_moved_constant_704) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_688 + jac_blending_inv_1_0_q_2*tmp_moved_constant_690 + jac_blending_inv_2_0_q_2*tmp_moved_constant_691) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_702 + tmp_kernel_op_224*tmp_moved_constant_703 + tmp_kernel_op_225*tmp_moved_constant_704) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_688 + jac_blending_inv_1_1_q_2*tmp_moved_constant_690 + jac_blending_inv_2_1_q_2*tmp_moved_constant_691) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_702 + tmp_kernel_op_230*tmp_moved_constant_703 + tmp_kernel_op_231*tmp_moved_constant_704) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_688 + jac_blending_inv_1_2_q_2*tmp_moved_constant_690 + jac_blending_inv_2_2_q_2*tmp_moved_constant_691) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_702 + tmp_kernel_op_236*tmp_moved_constant_703 + tmp_kernel_op_237*tmp_moved_constant_704) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_692 + jac_blending_inv_1_0_q_2*tmp_moved_constant_693 + jac_blending_inv_2_0_q_2*tmp_moved_constant_695) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_702 + tmp_kernel_op_242*tmp_moved_constant_703 + tmp_kernel_op_243*tmp_moved_constant_704) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_692 + jac_blending_inv_1_1_q_2*tmp_moved_constant_693 + jac_blending_inv_2_1_q_2*tmp_moved_constant_695) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_702 + tmp_kernel_op_248*tmp_moved_constant_703 + tmp_kernel_op_249*tmp_moved_constant_704) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_692 + jac_blending_inv_1_2_q_2*tmp_moved_constant_693 + jac_blending_inv_2_2_q_2*tmp_moved_constant_695) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_702 + tmp_kernel_op_254*tmp_moved_constant_703 + tmp_kernel_op_255*tmp_moved_constant_704);
             const real_t tmp_kernel_op_815 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_683 + jac_blending_inv_1_0_q_3*tmp_moved_constant_685 + jac_blending_inv_2_0_q_3*tmp_moved_constant_687) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_705 + tmp_kernel_op_290*tmp_moved_constant_706 + tmp_kernel_op_292*tmp_moved_constant_707) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_683 + jac_blending_inv_1_1_q_3*tmp_moved_constant_685 + jac_blending_inv_2_1_q_3*tmp_moved_constant_687) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_705 + tmp_kernel_op_297*tmp_moved_constant_706 + tmp_kernel_op_298*tmp_moved_constant_707) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_683 + jac_blending_inv_1_2_q_3*tmp_moved_constant_685 + jac_blending_inv_2_2_q_3*tmp_moved_constant_687) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_705 + tmp_kernel_op_303*tmp_moved_constant_706 + tmp_kernel_op_304*tmp_moved_constant_707) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_688 + jac_blending_inv_1_0_q_3*tmp_moved_constant_690 + jac_blending_inv_2_0_q_3*tmp_moved_constant_691) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_705 + tmp_kernel_op_309*tmp_moved_constant_706 + tmp_kernel_op_310*tmp_moved_constant_707) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_688 + jac_blending_inv_1_1_q_3*tmp_moved_constant_690 + jac_blending_inv_2_1_q_3*tmp_moved_constant_691) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_705 + tmp_kernel_op_315*tmp_moved_constant_706 + tmp_kernel_op_316*tmp_moved_constant_707) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_688 + jac_blending_inv_1_2_q_3*tmp_moved_constant_690 + jac_blending_inv_2_2_q_3*tmp_moved_constant_691) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_705 + tmp_kernel_op_321*tmp_moved_constant_706 + tmp_kernel_op_322*tmp_moved_constant_707) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_692 + jac_blending_inv_1_0_q_3*tmp_moved_constant_693 + jac_blending_inv_2_0_q_3*tmp_moved_constant_695) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_705 + tmp_kernel_op_327*tmp_moved_constant_706 + tmp_kernel_op_328*tmp_moved_constant_707) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_692 + jac_blending_inv_1_1_q_3*tmp_moved_constant_693 + jac_blending_inv_2_1_q_3*tmp_moved_constant_695) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_705 + tmp_kernel_op_333*tmp_moved_constant_706 + tmp_kernel_op_334*tmp_moved_constant_707) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_692 + jac_blending_inv_1_2_q_3*tmp_moved_constant_693 + jac_blending_inv_2_2_q_3*tmp_moved_constant_695) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_705 + tmp_kernel_op_339*tmp_moved_constant_706 + tmp_kernel_op_340*tmp_moved_constant_707);
             const real_t tmp_kernel_op_821 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_683 + jac_blending_inv_1_0_q_4*tmp_moved_constant_685 + jac_blending_inv_2_0_q_4*tmp_moved_constant_687) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_708 + tmp_kernel_op_375*tmp_moved_constant_709 + tmp_kernel_op_377*tmp_moved_constant_710) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_683 + jac_blending_inv_1_1_q_4*tmp_moved_constant_685 + jac_blending_inv_2_1_q_4*tmp_moved_constant_687) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_708 + tmp_kernel_op_382*tmp_moved_constant_709 + tmp_kernel_op_383*tmp_moved_constant_710) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_683 + jac_blending_inv_1_2_q_4*tmp_moved_constant_685 + jac_blending_inv_2_2_q_4*tmp_moved_constant_687) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_708 + tmp_kernel_op_388*tmp_moved_constant_709 + tmp_kernel_op_389*tmp_moved_constant_710) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_688 + jac_blending_inv_1_0_q_4*tmp_moved_constant_690 + jac_blending_inv_2_0_q_4*tmp_moved_constant_691) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_708 + tmp_kernel_op_394*tmp_moved_constant_709 + tmp_kernel_op_395*tmp_moved_constant_710) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_688 + jac_blending_inv_1_1_q_4*tmp_moved_constant_690 + jac_blending_inv_2_1_q_4*tmp_moved_constant_691) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_708 + tmp_kernel_op_400*tmp_moved_constant_709 + tmp_kernel_op_401*tmp_moved_constant_710) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_688 + jac_blending_inv_1_2_q_4*tmp_moved_constant_690 + jac_blending_inv_2_2_q_4*tmp_moved_constant_691) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_708 + tmp_kernel_op_406*tmp_moved_constant_709 + tmp_kernel_op_407*tmp_moved_constant_710) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_692 + jac_blending_inv_1_0_q_4*tmp_moved_constant_693 + jac_blending_inv_2_0_q_4*tmp_moved_constant_695) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_708 + tmp_kernel_op_412*tmp_moved_constant_709 + tmp_kernel_op_413*tmp_moved_constant_710) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_692 + jac_blending_inv_1_1_q_4*tmp_moved_constant_693 + jac_blending_inv_2_1_q_4*tmp_moved_constant_695) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_708 + tmp_kernel_op_418*tmp_moved_constant_709 + tmp_kernel_op_419*tmp_moved_constant_710) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_692 + jac_blending_inv_1_2_q_4*tmp_moved_constant_693 + jac_blending_inv_2_2_q_4*tmp_moved_constant_695) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_708 + tmp_kernel_op_424*tmp_moved_constant_709 + tmp_kernel_op_425*tmp_moved_constant_710);
             const real_t tmp_kernel_op_838 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_712 + jac_blending_inv_1_0_q_0*tmp_moved_constant_714 + jac_blending_inv_2_0_q_0*tmp_moved_constant_716) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_723 + tmp_kernel_op_35*tmp_moved_constant_724 + tmp_kernel_op_37*tmp_moved_constant_725) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_712 + jac_blending_inv_1_1_q_0*tmp_moved_constant_714 + jac_blending_inv_2_1_q_0*tmp_moved_constant_716) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_723 + tmp_kernel_op_42*tmp_moved_constant_724 + tmp_kernel_op_43*tmp_moved_constant_725) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_712 + jac_blending_inv_1_2_q_0*tmp_moved_constant_714 + jac_blending_inv_2_2_q_0*tmp_moved_constant_716) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_723 + tmp_kernel_op_48*tmp_moved_constant_724 + tmp_kernel_op_49*tmp_moved_constant_725) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_717 + jac_blending_inv_1_0_q_0*tmp_moved_constant_718 + jac_blending_inv_2_0_q_0*tmp_moved_constant_719) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_723 + tmp_kernel_op_54*tmp_moved_constant_724 + tmp_kernel_op_55*tmp_moved_constant_725) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_717 + jac_blending_inv_1_1_q_0*tmp_moved_constant_718 + jac_blending_inv_2_1_q_0*tmp_moved_constant_719) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_723 + tmp_kernel_op_60*tmp_moved_constant_724 + tmp_kernel_op_61*tmp_moved_constant_725) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_717 + jac_blending_inv_1_2_q_0*tmp_moved_constant_718 + jac_blending_inv_2_2_q_0*tmp_moved_constant_719) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_723 + tmp_kernel_op_66*tmp_moved_constant_724 + tmp_kernel_op_67*tmp_moved_constant_725) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_720 + jac_blending_inv_1_0_q_0*tmp_moved_constant_721 + jac_blending_inv_2_0_q_0*tmp_moved_constant_722) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_723 + tmp_kernel_op_72*tmp_moved_constant_724 + tmp_kernel_op_73*tmp_moved_constant_725) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_720 + jac_blending_inv_1_1_q_0*tmp_moved_constant_721 + jac_blending_inv_2_1_q_0*tmp_moved_constant_722) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_723 + tmp_kernel_op_78*tmp_moved_constant_724 + tmp_kernel_op_79*tmp_moved_constant_725) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_720 + jac_blending_inv_1_2_q_0*tmp_moved_constant_721 + jac_blending_inv_2_2_q_0*tmp_moved_constant_722) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_723 + tmp_kernel_op_84*tmp_moved_constant_724 + tmp_kernel_op_85*tmp_moved_constant_725);
             const real_t tmp_kernel_op_843 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_712 + jac_blending_inv_1_0_q_1*tmp_moved_constant_714 + jac_blending_inv_2_0_q_1*tmp_moved_constant_716) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_726 + tmp_kernel_op_120*tmp_moved_constant_727 + tmp_kernel_op_122*tmp_moved_constant_728) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_712 + jac_blending_inv_1_1_q_1*tmp_moved_constant_714 + jac_blending_inv_2_1_q_1*tmp_moved_constant_716) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_726 + tmp_kernel_op_127*tmp_moved_constant_727 + tmp_kernel_op_128*tmp_moved_constant_728) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_712 + jac_blending_inv_1_2_q_1*tmp_moved_constant_714 + jac_blending_inv_2_2_q_1*tmp_moved_constant_716) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_726 + tmp_kernel_op_133*tmp_moved_constant_727 + tmp_kernel_op_134*tmp_moved_constant_728) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_717 + jac_blending_inv_1_0_q_1*tmp_moved_constant_718 + jac_blending_inv_2_0_q_1*tmp_moved_constant_719) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_726 + tmp_kernel_op_139*tmp_moved_constant_727 + tmp_kernel_op_140*tmp_moved_constant_728) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_717 + jac_blending_inv_1_1_q_1*tmp_moved_constant_718 + jac_blending_inv_2_1_q_1*tmp_moved_constant_719) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_726 + tmp_kernel_op_145*tmp_moved_constant_727 + tmp_kernel_op_146*tmp_moved_constant_728) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_717 + jac_blending_inv_1_2_q_1*tmp_moved_constant_718 + jac_blending_inv_2_2_q_1*tmp_moved_constant_719) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_726 + tmp_kernel_op_151*tmp_moved_constant_727 + tmp_kernel_op_152*tmp_moved_constant_728) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_720 + jac_blending_inv_1_0_q_1*tmp_moved_constant_721 + jac_blending_inv_2_0_q_1*tmp_moved_constant_722) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_726 + tmp_kernel_op_157*tmp_moved_constant_727 + tmp_kernel_op_158*tmp_moved_constant_728) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_720 + jac_blending_inv_1_1_q_1*tmp_moved_constant_721 + jac_blending_inv_2_1_q_1*tmp_moved_constant_722) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_726 + tmp_kernel_op_163*tmp_moved_constant_727 + tmp_kernel_op_164*tmp_moved_constant_728) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_720 + jac_blending_inv_1_2_q_1*tmp_moved_constant_721 + jac_blending_inv_2_2_q_1*tmp_moved_constant_722) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_726 + tmp_kernel_op_169*tmp_moved_constant_727 + tmp_kernel_op_170*tmp_moved_constant_728);
             const real_t tmp_kernel_op_848 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_712 + jac_blending_inv_1_0_q_2*tmp_moved_constant_714 + jac_blending_inv_2_0_q_2*tmp_moved_constant_716) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_729 + tmp_kernel_op_205*tmp_moved_constant_730 + tmp_kernel_op_207*tmp_moved_constant_731) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_712 + jac_blending_inv_1_1_q_2*tmp_moved_constant_714 + jac_blending_inv_2_1_q_2*tmp_moved_constant_716) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_729 + tmp_kernel_op_212*tmp_moved_constant_730 + tmp_kernel_op_213*tmp_moved_constant_731) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_712 + jac_blending_inv_1_2_q_2*tmp_moved_constant_714 + jac_blending_inv_2_2_q_2*tmp_moved_constant_716) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_729 + tmp_kernel_op_218*tmp_moved_constant_730 + tmp_kernel_op_219*tmp_moved_constant_731) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_717 + jac_blending_inv_1_0_q_2*tmp_moved_constant_718 + jac_blending_inv_2_0_q_2*tmp_moved_constant_719) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_729 + tmp_kernel_op_224*tmp_moved_constant_730 + tmp_kernel_op_225*tmp_moved_constant_731) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_717 + jac_blending_inv_1_1_q_2*tmp_moved_constant_718 + jac_blending_inv_2_1_q_2*tmp_moved_constant_719) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_729 + tmp_kernel_op_230*tmp_moved_constant_730 + tmp_kernel_op_231*tmp_moved_constant_731) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_717 + jac_blending_inv_1_2_q_2*tmp_moved_constant_718 + jac_blending_inv_2_2_q_2*tmp_moved_constant_719) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_729 + tmp_kernel_op_236*tmp_moved_constant_730 + tmp_kernel_op_237*tmp_moved_constant_731) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_720 + jac_blending_inv_1_0_q_2*tmp_moved_constant_721 + jac_blending_inv_2_0_q_2*tmp_moved_constant_722) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_729 + tmp_kernel_op_242*tmp_moved_constant_730 + tmp_kernel_op_243*tmp_moved_constant_731) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_720 + jac_blending_inv_1_1_q_2*tmp_moved_constant_721 + jac_blending_inv_2_1_q_2*tmp_moved_constant_722) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_729 + tmp_kernel_op_248*tmp_moved_constant_730 + tmp_kernel_op_249*tmp_moved_constant_731) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_720 + jac_blending_inv_1_2_q_2*tmp_moved_constant_721 + jac_blending_inv_2_2_q_2*tmp_moved_constant_722) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_729 + tmp_kernel_op_254*tmp_moved_constant_730 + tmp_kernel_op_255*tmp_moved_constant_731);
             const real_t tmp_kernel_op_853 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_712 + jac_blending_inv_1_0_q_3*tmp_moved_constant_714 + jac_blending_inv_2_0_q_3*tmp_moved_constant_716) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_732 + tmp_kernel_op_290*tmp_moved_constant_733 + tmp_kernel_op_292*tmp_moved_constant_734) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_712 + jac_blending_inv_1_1_q_3*tmp_moved_constant_714 + jac_blending_inv_2_1_q_3*tmp_moved_constant_716) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_732 + tmp_kernel_op_297*tmp_moved_constant_733 + tmp_kernel_op_298*tmp_moved_constant_734) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_712 + jac_blending_inv_1_2_q_3*tmp_moved_constant_714 + jac_blending_inv_2_2_q_3*tmp_moved_constant_716) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_732 + tmp_kernel_op_303*tmp_moved_constant_733 + tmp_kernel_op_304*tmp_moved_constant_734) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_717 + jac_blending_inv_1_0_q_3*tmp_moved_constant_718 + jac_blending_inv_2_0_q_3*tmp_moved_constant_719) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_732 + tmp_kernel_op_309*tmp_moved_constant_733 + tmp_kernel_op_310*tmp_moved_constant_734) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_717 + jac_blending_inv_1_1_q_3*tmp_moved_constant_718 + jac_blending_inv_2_1_q_3*tmp_moved_constant_719) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_732 + tmp_kernel_op_315*tmp_moved_constant_733 + tmp_kernel_op_316*tmp_moved_constant_734) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_717 + jac_blending_inv_1_2_q_3*tmp_moved_constant_718 + jac_blending_inv_2_2_q_3*tmp_moved_constant_719) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_732 + tmp_kernel_op_321*tmp_moved_constant_733 + tmp_kernel_op_322*tmp_moved_constant_734) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_720 + jac_blending_inv_1_0_q_3*tmp_moved_constant_721 + jac_blending_inv_2_0_q_3*tmp_moved_constant_722) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_732 + tmp_kernel_op_327*tmp_moved_constant_733 + tmp_kernel_op_328*tmp_moved_constant_734) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_720 + jac_blending_inv_1_1_q_3*tmp_moved_constant_721 + jac_blending_inv_2_1_q_3*tmp_moved_constant_722) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_732 + tmp_kernel_op_333*tmp_moved_constant_733 + tmp_kernel_op_334*tmp_moved_constant_734) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_720 + jac_blending_inv_1_2_q_3*tmp_moved_constant_721 + jac_blending_inv_2_2_q_3*tmp_moved_constant_722) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_732 + tmp_kernel_op_339*tmp_moved_constant_733 + tmp_kernel_op_340*tmp_moved_constant_734);
             const real_t tmp_kernel_op_858 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_712 + jac_blending_inv_1_0_q_4*tmp_moved_constant_714 + jac_blending_inv_2_0_q_4*tmp_moved_constant_716) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_735 + tmp_kernel_op_375*tmp_moved_constant_736 + tmp_kernel_op_377*tmp_moved_constant_737) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_712 + jac_blending_inv_1_1_q_4*tmp_moved_constant_714 + jac_blending_inv_2_1_q_4*tmp_moved_constant_716) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_735 + tmp_kernel_op_382*tmp_moved_constant_736 + tmp_kernel_op_383*tmp_moved_constant_737) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_712 + jac_blending_inv_1_2_q_4*tmp_moved_constant_714 + jac_blending_inv_2_2_q_4*tmp_moved_constant_716) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_735 + tmp_kernel_op_388*tmp_moved_constant_736 + tmp_kernel_op_389*tmp_moved_constant_737) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_717 + jac_blending_inv_1_0_q_4*tmp_moved_constant_718 + jac_blending_inv_2_0_q_4*tmp_moved_constant_719) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_735 + tmp_kernel_op_394*tmp_moved_constant_736 + tmp_kernel_op_395*tmp_moved_constant_737) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_717 + jac_blending_inv_1_1_q_4*tmp_moved_constant_718 + jac_blending_inv_2_1_q_4*tmp_moved_constant_719) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_735 + tmp_kernel_op_400*tmp_moved_constant_736 + tmp_kernel_op_401*tmp_moved_constant_737) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_717 + jac_blending_inv_1_2_q_4*tmp_moved_constant_718 + jac_blending_inv_2_2_q_4*tmp_moved_constant_719) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_735 + tmp_kernel_op_406*tmp_moved_constant_736 + tmp_kernel_op_407*tmp_moved_constant_737) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_720 + jac_blending_inv_1_0_q_4*tmp_moved_constant_721 + jac_blending_inv_2_0_q_4*tmp_moved_constant_722) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_735 + tmp_kernel_op_412*tmp_moved_constant_736 + tmp_kernel_op_413*tmp_moved_constant_737) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_720 + jac_blending_inv_1_1_q_4*tmp_moved_constant_721 + jac_blending_inv_2_1_q_4*tmp_moved_constant_722) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_735 + tmp_kernel_op_418*tmp_moved_constant_736 + tmp_kernel_op_419*tmp_moved_constant_737) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_720 + jac_blending_inv_1_2_q_4*tmp_moved_constant_721 + jac_blending_inv_2_2_q_4*tmp_moved_constant_722) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_735 + tmp_kernel_op_424*tmp_moved_constant_736 + tmp_kernel_op_425*tmp_moved_constant_737);
             const real_t tmp_kernel_op_859 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_414 + jac_blending_inv_1_0_q_0*tmp_moved_constant_415 + jac_blending_inv_2_0_q_0*tmp_moved_constant_416) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_414 + jac_blending_inv_1_1_q_0*tmp_moved_constant_415 + jac_blending_inv_2_1_q_0*tmp_moved_constant_416) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_414 + jac_blending_inv_1_2_q_0*tmp_moved_constant_415 + jac_blending_inv_2_2_q_0*tmp_moved_constant_416));
             const real_t tmp_kernel_op_860 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_417 + jac_blending_inv_1_0_q_1*tmp_moved_constant_418 + jac_blending_inv_2_0_q_1*tmp_moved_constant_419) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_417 + jac_blending_inv_1_1_q_1*tmp_moved_constant_418 + jac_blending_inv_2_1_q_1*tmp_moved_constant_419) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_417 + jac_blending_inv_1_2_q_1*tmp_moved_constant_418 + jac_blending_inv_2_2_q_1*tmp_moved_constant_419));
             const real_t tmp_kernel_op_861 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_420 + jac_blending_inv_1_0_q_2*tmp_moved_constant_421 + jac_blending_inv_2_0_q_2*tmp_moved_constant_422) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_420 + jac_blending_inv_1_1_q_2*tmp_moved_constant_421 + jac_blending_inv_2_1_q_2*tmp_moved_constant_422) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_420 + jac_blending_inv_1_2_q_2*tmp_moved_constant_421 + jac_blending_inv_2_2_q_2*tmp_moved_constant_422));
             const real_t tmp_kernel_op_862 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_423 + jac_blending_inv_1_0_q_3*tmp_moved_constant_424 + jac_blending_inv_2_0_q_3*tmp_moved_constant_425) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_423 + jac_blending_inv_1_1_q_3*tmp_moved_constant_424 + jac_blending_inv_2_1_q_3*tmp_moved_constant_425) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_423 + jac_blending_inv_1_2_q_3*tmp_moved_constant_424 + jac_blending_inv_2_2_q_3*tmp_moved_constant_425));
             const real_t tmp_kernel_op_863 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_426 + jac_blending_inv_1_0_q_4*tmp_moved_constant_427 + jac_blending_inv_2_0_q_4*tmp_moved_constant_428) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_426 + jac_blending_inv_1_1_q_4*tmp_moved_constant_427 + jac_blending_inv_2_1_q_4*tmp_moved_constant_428) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_426 + jac_blending_inv_1_2_q_4*tmp_moved_constant_427 + jac_blending_inv_2_2_q_4*tmp_moved_constant_428));
             const real_t tmp_kernel_op_864 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_435 + jac_blending_inv_1_0_q_0*tmp_moved_constant_436 + jac_blending_inv_2_0_q_0*tmp_moved_constant_437) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_435 + jac_blending_inv_1_1_q_0*tmp_moved_constant_436 + jac_blending_inv_2_1_q_0*tmp_moved_constant_437) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_435 + jac_blending_inv_1_2_q_0*tmp_moved_constant_436 + jac_blending_inv_2_2_q_0*tmp_moved_constant_437));
             const real_t tmp_kernel_op_865 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_438 + jac_blending_inv_1_0_q_1*tmp_moved_constant_439 + jac_blending_inv_2_0_q_1*tmp_moved_constant_440) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_438 + jac_blending_inv_1_1_q_1*tmp_moved_constant_439 + jac_blending_inv_2_1_q_1*tmp_moved_constant_440) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_438 + jac_blending_inv_1_2_q_1*tmp_moved_constant_439 + jac_blending_inv_2_2_q_1*tmp_moved_constant_440));
             const real_t tmp_kernel_op_866 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_441 + jac_blending_inv_1_0_q_2*tmp_moved_constant_442 + jac_blending_inv_2_0_q_2*tmp_moved_constant_443) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_441 + jac_blending_inv_1_1_q_2*tmp_moved_constant_442 + jac_blending_inv_2_1_q_2*tmp_moved_constant_443) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_441 + jac_blending_inv_1_2_q_2*tmp_moved_constant_442 + jac_blending_inv_2_2_q_2*tmp_moved_constant_443));
             const real_t tmp_kernel_op_867 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_444 + jac_blending_inv_1_0_q_3*tmp_moved_constant_445 + jac_blending_inv_2_0_q_3*tmp_moved_constant_446) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_444 + jac_blending_inv_1_1_q_3*tmp_moved_constant_445 + jac_blending_inv_2_1_q_3*tmp_moved_constant_446) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_444 + jac_blending_inv_1_2_q_3*tmp_moved_constant_445 + jac_blending_inv_2_2_q_3*tmp_moved_constant_446));
             const real_t tmp_kernel_op_868 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_447 + jac_blending_inv_1_0_q_4*tmp_moved_constant_448 + jac_blending_inv_2_0_q_4*tmp_moved_constant_449) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_447 + jac_blending_inv_1_1_q_4*tmp_moved_constant_448 + jac_blending_inv_2_1_q_4*tmp_moved_constant_449) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_447 + jac_blending_inv_1_2_q_4*tmp_moved_constant_448 + jac_blending_inv_2_2_q_4*tmp_moved_constant_449));
             const real_t tmp_kernel_op_869 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_456 + jac_blending_inv_1_0_q_0*tmp_moved_constant_457 + jac_blending_inv_2_0_q_0*tmp_moved_constant_458) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_456 + jac_blending_inv_1_1_q_0*tmp_moved_constant_457 + jac_blending_inv_2_1_q_0*tmp_moved_constant_458) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_456 + jac_blending_inv_1_2_q_0*tmp_moved_constant_457 + jac_blending_inv_2_2_q_0*tmp_moved_constant_458));
             const real_t tmp_kernel_op_870 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_459 + jac_blending_inv_1_0_q_1*tmp_moved_constant_460 + jac_blending_inv_2_0_q_1*tmp_moved_constant_461) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_459 + jac_blending_inv_1_1_q_1*tmp_moved_constant_460 + jac_blending_inv_2_1_q_1*tmp_moved_constant_461) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_459 + jac_blending_inv_1_2_q_1*tmp_moved_constant_460 + jac_blending_inv_2_2_q_1*tmp_moved_constant_461));
             const real_t tmp_kernel_op_871 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_462 + jac_blending_inv_1_0_q_2*tmp_moved_constant_463 + jac_blending_inv_2_0_q_2*tmp_moved_constant_464) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_462 + jac_blending_inv_1_1_q_2*tmp_moved_constant_463 + jac_blending_inv_2_1_q_2*tmp_moved_constant_464) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_462 + jac_blending_inv_1_2_q_2*tmp_moved_constant_463 + jac_blending_inv_2_2_q_2*tmp_moved_constant_464));
             const real_t tmp_kernel_op_872 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_465 + jac_blending_inv_1_0_q_3*tmp_moved_constant_466 + jac_blending_inv_2_0_q_3*tmp_moved_constant_467) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_465 + jac_blending_inv_1_1_q_3*tmp_moved_constant_466 + jac_blending_inv_2_1_q_3*tmp_moved_constant_467) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_465 + jac_blending_inv_1_2_q_3*tmp_moved_constant_466 + jac_blending_inv_2_2_q_3*tmp_moved_constant_467));
             const real_t tmp_kernel_op_873 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_468 + jac_blending_inv_1_0_q_4*tmp_moved_constant_469 + jac_blending_inv_2_0_q_4*tmp_moved_constant_470) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_468 + jac_blending_inv_1_1_q_4*tmp_moved_constant_469 + jac_blending_inv_2_1_q_4*tmp_moved_constant_470) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_468 + jac_blending_inv_1_2_q_4*tmp_moved_constant_469 + jac_blending_inv_2_2_q_4*tmp_moved_constant_470));
             const real_t tmp_kernel_op_874 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_488 + jac_blending_inv_1_0_q_0*tmp_moved_constant_491 + jac_blending_inv_2_0_q_0*tmp_moved_constant_494) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_488 + jac_blending_inv_1_1_q_0*tmp_moved_constant_491 + jac_blending_inv_2_1_q_0*tmp_moved_constant_494) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_488 + jac_blending_inv_1_2_q_0*tmp_moved_constant_491 + jac_blending_inv_2_2_q_0*tmp_moved_constant_494));
             const real_t tmp_kernel_op_875 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_497 + jac_blending_inv_1_0_q_1*tmp_moved_constant_500 + jac_blending_inv_2_0_q_1*tmp_moved_constant_503) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_497 + jac_blending_inv_1_1_q_1*tmp_moved_constant_500 + jac_blending_inv_2_1_q_1*tmp_moved_constant_503) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_497 + jac_blending_inv_1_2_q_1*tmp_moved_constant_500 + jac_blending_inv_2_2_q_1*tmp_moved_constant_503));
             const real_t tmp_kernel_op_876 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_506 + jac_blending_inv_1_0_q_2*tmp_moved_constant_509 + jac_blending_inv_2_0_q_2*tmp_moved_constant_512) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_506 + jac_blending_inv_1_1_q_2*tmp_moved_constant_509 + jac_blending_inv_2_1_q_2*tmp_moved_constant_512) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_506 + jac_blending_inv_1_2_q_2*tmp_moved_constant_509 + jac_blending_inv_2_2_q_2*tmp_moved_constant_512));
             const real_t tmp_kernel_op_877 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_515 + jac_blending_inv_1_0_q_3*tmp_moved_constant_518 + jac_blending_inv_2_0_q_3*tmp_moved_constant_521) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_515 + jac_blending_inv_1_1_q_3*tmp_moved_constant_518 + jac_blending_inv_2_1_q_3*tmp_moved_constant_521) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_515 + jac_blending_inv_1_2_q_3*tmp_moved_constant_518 + jac_blending_inv_2_2_q_3*tmp_moved_constant_521));
             const real_t tmp_kernel_op_878 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_524 + jac_blending_inv_1_0_q_4*tmp_moved_constant_527 + jac_blending_inv_2_0_q_4*tmp_moved_constant_530) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_524 + jac_blending_inv_1_1_q_4*tmp_moved_constant_527 + jac_blending_inv_2_1_q_4*tmp_moved_constant_530) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_524 + jac_blending_inv_1_2_q_4*tmp_moved_constant_527 + jac_blending_inv_2_2_q_4*tmp_moved_constant_530));
             const real_t tmp_kernel_op_879 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_545 + jac_blending_inv_1_0_q_0*tmp_moved_constant_548 + jac_blending_inv_2_0_q_0*tmp_moved_constant_551) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_545 + jac_blending_inv_1_1_q_0*tmp_moved_constant_548 + jac_blending_inv_2_1_q_0*tmp_moved_constant_551) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_545 + jac_blending_inv_1_2_q_0*tmp_moved_constant_548 + jac_blending_inv_2_2_q_0*tmp_moved_constant_551));
             const real_t tmp_kernel_op_880 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_554 + jac_blending_inv_1_0_q_1*tmp_moved_constant_557 + jac_blending_inv_2_0_q_1*tmp_moved_constant_560) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_554 + jac_blending_inv_1_1_q_1*tmp_moved_constant_557 + jac_blending_inv_2_1_q_1*tmp_moved_constant_560) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_554 + jac_blending_inv_1_2_q_1*tmp_moved_constant_557 + jac_blending_inv_2_2_q_1*tmp_moved_constant_560));
             const real_t tmp_kernel_op_881 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_563 + jac_blending_inv_1_0_q_2*tmp_moved_constant_566 + jac_blending_inv_2_0_q_2*tmp_moved_constant_569) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_563 + jac_blending_inv_1_1_q_2*tmp_moved_constant_566 + jac_blending_inv_2_1_q_2*tmp_moved_constant_569) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_563 + jac_blending_inv_1_2_q_2*tmp_moved_constant_566 + jac_blending_inv_2_2_q_2*tmp_moved_constant_569));
             const real_t tmp_kernel_op_882 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_572 + jac_blending_inv_1_0_q_3*tmp_moved_constant_575 + jac_blending_inv_2_0_q_3*tmp_moved_constant_578) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_572 + jac_blending_inv_1_1_q_3*tmp_moved_constant_575 + jac_blending_inv_2_1_q_3*tmp_moved_constant_578) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_572 + jac_blending_inv_1_2_q_3*tmp_moved_constant_575 + jac_blending_inv_2_2_q_3*tmp_moved_constant_578));
             const real_t tmp_kernel_op_883 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_581 + jac_blending_inv_1_0_q_4*tmp_moved_constant_584 + jac_blending_inv_2_0_q_4*tmp_moved_constant_587) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_581 + jac_blending_inv_1_1_q_4*tmp_moved_constant_584 + jac_blending_inv_2_1_q_4*tmp_moved_constant_587) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_581 + jac_blending_inv_1_2_q_4*tmp_moved_constant_584 + jac_blending_inv_2_2_q_4*tmp_moved_constant_587));
             const real_t tmp_kernel_op_884 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_605 + jac_blending_inv_1_0_q_0*tmp_moved_constant_608 + jac_blending_inv_2_0_q_0*tmp_moved_constant_611) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_605 + jac_blending_inv_1_1_q_0*tmp_moved_constant_608 + jac_blending_inv_2_1_q_0*tmp_moved_constant_611) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_605 + jac_blending_inv_1_2_q_0*tmp_moved_constant_608 + jac_blending_inv_2_2_q_0*tmp_moved_constant_611));
             const real_t tmp_kernel_op_885 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_614 + jac_blending_inv_1_0_q_1*tmp_moved_constant_617 + jac_blending_inv_2_0_q_1*tmp_moved_constant_620) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_614 + jac_blending_inv_1_1_q_1*tmp_moved_constant_617 + jac_blending_inv_2_1_q_1*tmp_moved_constant_620) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_614 + jac_blending_inv_1_2_q_1*tmp_moved_constant_617 + jac_blending_inv_2_2_q_1*tmp_moved_constant_620));
             const real_t tmp_kernel_op_886 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_623 + jac_blending_inv_1_0_q_2*tmp_moved_constant_626 + jac_blending_inv_2_0_q_2*tmp_moved_constant_629) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_623 + jac_blending_inv_1_1_q_2*tmp_moved_constant_626 + jac_blending_inv_2_1_q_2*tmp_moved_constant_629) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_623 + jac_blending_inv_1_2_q_2*tmp_moved_constant_626 + jac_blending_inv_2_2_q_2*tmp_moved_constant_629));
             const real_t tmp_kernel_op_887 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_632 + jac_blending_inv_1_0_q_3*tmp_moved_constant_635 + jac_blending_inv_2_0_q_3*tmp_moved_constant_638) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_632 + jac_blending_inv_1_1_q_3*tmp_moved_constant_635 + jac_blending_inv_2_1_q_3*tmp_moved_constant_638) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_632 + jac_blending_inv_1_2_q_3*tmp_moved_constant_635 + jac_blending_inv_2_2_q_3*tmp_moved_constant_638));
             const real_t tmp_kernel_op_888 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_641 + jac_blending_inv_1_0_q_4*tmp_moved_constant_644 + jac_blending_inv_2_0_q_4*tmp_moved_constant_647) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_641 + jac_blending_inv_1_1_q_4*tmp_moved_constant_644 + jac_blending_inv_2_1_q_4*tmp_moved_constant_647) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_641 + jac_blending_inv_1_2_q_4*tmp_moved_constant_644 + jac_blending_inv_2_2_q_4*tmp_moved_constant_647));
             const real_t tmp_kernel_op_889 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_666 + jac_blending_inv_1_0_q_0*tmp_moved_constant_667 + jac_blending_inv_2_0_q_0*tmp_moved_constant_668) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_666 + jac_blending_inv_1_1_q_0*tmp_moved_constant_667 + jac_blending_inv_2_1_q_0*tmp_moved_constant_668) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_666 + jac_blending_inv_1_2_q_0*tmp_moved_constant_667 + jac_blending_inv_2_2_q_0*tmp_moved_constant_668));
             const real_t tmp_kernel_op_890 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_669 + jac_blending_inv_1_0_q_1*tmp_moved_constant_670 + jac_blending_inv_2_0_q_1*tmp_moved_constant_671) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_669 + jac_blending_inv_1_1_q_1*tmp_moved_constant_670 + jac_blending_inv_2_1_q_1*tmp_moved_constant_671) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_669 + jac_blending_inv_1_2_q_1*tmp_moved_constant_670 + jac_blending_inv_2_2_q_1*tmp_moved_constant_671));
             const real_t tmp_kernel_op_891 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_672 + jac_blending_inv_1_0_q_2*tmp_moved_constant_673 + jac_blending_inv_2_0_q_2*tmp_moved_constant_674) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_672 + jac_blending_inv_1_1_q_2*tmp_moved_constant_673 + jac_blending_inv_2_1_q_2*tmp_moved_constant_674) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_672 + jac_blending_inv_1_2_q_2*tmp_moved_constant_673 + jac_blending_inv_2_2_q_2*tmp_moved_constant_674));
             const real_t tmp_kernel_op_892 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_675 + jac_blending_inv_1_0_q_3*tmp_moved_constant_676 + jac_blending_inv_2_0_q_3*tmp_moved_constant_677) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_675 + jac_blending_inv_1_1_q_3*tmp_moved_constant_676 + jac_blending_inv_2_1_q_3*tmp_moved_constant_677) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_675 + jac_blending_inv_1_2_q_3*tmp_moved_constant_676 + jac_blending_inv_2_2_q_3*tmp_moved_constant_677));
             const real_t tmp_kernel_op_893 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_678 + jac_blending_inv_1_0_q_4*tmp_moved_constant_679 + jac_blending_inv_2_0_q_4*tmp_moved_constant_680) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_678 + jac_blending_inv_1_1_q_4*tmp_moved_constant_679 + jac_blending_inv_2_1_q_4*tmp_moved_constant_680) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_678 + jac_blending_inv_1_2_q_4*tmp_moved_constant_679 + jac_blending_inv_2_2_q_4*tmp_moved_constant_680));
             const real_t tmp_kernel_op_894 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_696 + jac_blending_inv_1_0_q_0*tmp_moved_constant_697 + jac_blending_inv_2_0_q_0*tmp_moved_constant_698) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_696 + jac_blending_inv_1_1_q_0*tmp_moved_constant_697 + jac_blending_inv_2_1_q_0*tmp_moved_constant_698) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_696 + jac_blending_inv_1_2_q_0*tmp_moved_constant_697 + jac_blending_inv_2_2_q_0*tmp_moved_constant_698));
             const real_t tmp_kernel_op_895 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_699 + jac_blending_inv_1_0_q_1*tmp_moved_constant_700 + jac_blending_inv_2_0_q_1*tmp_moved_constant_701) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_699 + jac_blending_inv_1_1_q_1*tmp_moved_constant_700 + jac_blending_inv_2_1_q_1*tmp_moved_constant_701) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_699 + jac_blending_inv_1_2_q_1*tmp_moved_constant_700 + jac_blending_inv_2_2_q_1*tmp_moved_constant_701));
             const real_t tmp_kernel_op_896 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_702 + jac_blending_inv_1_0_q_2*tmp_moved_constant_703 + jac_blending_inv_2_0_q_2*tmp_moved_constant_704) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_702 + jac_blending_inv_1_1_q_2*tmp_moved_constant_703 + jac_blending_inv_2_1_q_2*tmp_moved_constant_704) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_702 + jac_blending_inv_1_2_q_2*tmp_moved_constant_703 + jac_blending_inv_2_2_q_2*tmp_moved_constant_704));
             const real_t tmp_kernel_op_897 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_705 + jac_blending_inv_1_0_q_3*tmp_moved_constant_706 + jac_blending_inv_2_0_q_3*tmp_moved_constant_707) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_705 + jac_blending_inv_1_1_q_3*tmp_moved_constant_706 + jac_blending_inv_2_1_q_3*tmp_moved_constant_707) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_705 + jac_blending_inv_1_2_q_3*tmp_moved_constant_706 + jac_blending_inv_2_2_q_3*tmp_moved_constant_707));
             const real_t tmp_kernel_op_898 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_708 + jac_blending_inv_1_0_q_4*tmp_moved_constant_709 + jac_blending_inv_2_0_q_4*tmp_moved_constant_710) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_708 + jac_blending_inv_1_1_q_4*tmp_moved_constant_709 + jac_blending_inv_2_1_q_4*tmp_moved_constant_710) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_708 + jac_blending_inv_1_2_q_4*tmp_moved_constant_709 + jac_blending_inv_2_2_q_4*tmp_moved_constant_710));
             const real_t tmp_kernel_op_899 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_723 + jac_blending_inv_1_0_q_0*tmp_moved_constant_724 + jac_blending_inv_2_0_q_0*tmp_moved_constant_725) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_723 + jac_blending_inv_1_1_q_0*tmp_moved_constant_724 + jac_blending_inv_2_1_q_0*tmp_moved_constant_725) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_723 + jac_blending_inv_1_2_q_0*tmp_moved_constant_724 + jac_blending_inv_2_2_q_0*tmp_moved_constant_725));
             const real_t tmp_kernel_op_900 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_726 + jac_blending_inv_1_0_q_1*tmp_moved_constant_727 + jac_blending_inv_2_0_q_1*tmp_moved_constant_728) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_726 + jac_blending_inv_1_1_q_1*tmp_moved_constant_727 + jac_blending_inv_2_1_q_1*tmp_moved_constant_728) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_726 + jac_blending_inv_1_2_q_1*tmp_moved_constant_727 + jac_blending_inv_2_2_q_1*tmp_moved_constant_728));
             const real_t tmp_kernel_op_901 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_729 + jac_blending_inv_1_0_q_2*tmp_moved_constant_730 + jac_blending_inv_2_0_q_2*tmp_moved_constant_731) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_729 + jac_blending_inv_1_1_q_2*tmp_moved_constant_730 + jac_blending_inv_2_1_q_2*tmp_moved_constant_731) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_729 + jac_blending_inv_1_2_q_2*tmp_moved_constant_730 + jac_blending_inv_2_2_q_2*tmp_moved_constant_731));
             const real_t tmp_kernel_op_902 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_732 + jac_blending_inv_1_0_q_3*tmp_moved_constant_733 + jac_blending_inv_2_0_q_3*tmp_moved_constant_734) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_732 + jac_blending_inv_1_1_q_3*tmp_moved_constant_733 + jac_blending_inv_2_1_q_3*tmp_moved_constant_734) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_732 + jac_blending_inv_1_2_q_3*tmp_moved_constant_733 + jac_blending_inv_2_2_q_3*tmp_moved_constant_734));
             const real_t tmp_kernel_op_903 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_735 + jac_blending_inv_1_0_q_4*tmp_moved_constant_736 + jac_blending_inv_2_0_q_4*tmp_moved_constant_737) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_735 + jac_blending_inv_1_1_q_4*tmp_moved_constant_736 + jac_blending_inv_2_1_q_4*tmp_moved_constant_737) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_735 + jac_blending_inv_1_2_q_4*tmp_moved_constant_736 + jac_blending_inv_2_2_q_4*tmp_moved_constant_737));
             const real_t elMat_0_0 = tmp_kernel_op_108*tmp_kernel_op_86 + tmp_kernel_op_171*tmp_kernel_op_193 + tmp_kernel_op_256*tmp_kernel_op_278 + tmp_kernel_op_341*tmp_kernel_op_363 + tmp_kernel_op_426*tmp_kernel_op_448;
             const real_t elMat_0_1 = tmp_kernel_op_108*tmp_kernel_op_459 + tmp_kernel_op_193*tmp_kernel_op_464 + tmp_kernel_op_278*tmp_kernel_op_469 + tmp_kernel_op_363*tmp_kernel_op_474 + tmp_kernel_op_448*tmp_kernel_op_479;
             const real_t elMat_0_2 = tmp_kernel_op_108*tmp_kernel_op_490 + tmp_kernel_op_193*tmp_kernel_op_495 + tmp_kernel_op_278*tmp_kernel_op_500 + tmp_kernel_op_363*tmp_kernel_op_505 + tmp_kernel_op_448*tmp_kernel_op_510;
             const real_t elMat_0_3 = tmp_kernel_op_108*tmp_kernel_op_521 + tmp_kernel_op_193*tmp_kernel_op_526 + tmp_kernel_op_278*tmp_kernel_op_531 + tmp_kernel_op_363*tmp_kernel_op_536 + tmp_kernel_op_448*tmp_kernel_op_541;
             const real_t elMat_0_4 = tmp_kernel_op_108*tmp_kernel_op_566 + tmp_kernel_op_193*tmp_kernel_op_576 + tmp_kernel_op_278*tmp_kernel_op_586 + tmp_kernel_op_363*tmp_kernel_op_596 + tmp_kernel_op_448*tmp_kernel_op_606;
             const real_t elMat_0_5 = tmp_kernel_op_108*tmp_kernel_op_628 + tmp_kernel_op_193*tmp_kernel_op_638 + tmp_kernel_op_278*tmp_kernel_op_648 + tmp_kernel_op_363*tmp_kernel_op_658 + tmp_kernel_op_448*tmp_kernel_op_668;
             const real_t elMat_0_6 = tmp_kernel_op_108*tmp_kernel_op_693 + tmp_kernel_op_193*tmp_kernel_op_703 + tmp_kernel_op_278*tmp_kernel_op_713 + tmp_kernel_op_363*tmp_kernel_op_723 + tmp_kernel_op_448*tmp_kernel_op_733;
             const real_t elMat_0_7 = tmp_kernel_op_108*tmp_kernel_op_756 + tmp_kernel_op_193*tmp_kernel_op_761 + tmp_kernel_op_278*tmp_kernel_op_766 + tmp_kernel_op_363*tmp_kernel_op_771 + tmp_kernel_op_448*tmp_kernel_op_776;
             const real_t elMat_0_8 = tmp_kernel_op_108*tmp_kernel_op_797 + tmp_kernel_op_193*tmp_kernel_op_803 + tmp_kernel_op_278*tmp_kernel_op_809 + tmp_kernel_op_363*tmp_kernel_op_815 + tmp_kernel_op_448*tmp_kernel_op_821;
             const real_t elMat_0_9 = tmp_kernel_op_108*tmp_kernel_op_838 + tmp_kernel_op_193*tmp_kernel_op_843 + tmp_kernel_op_278*tmp_kernel_op_848 + tmp_kernel_op_363*tmp_kernel_op_853 + tmp_kernel_op_448*tmp_kernel_op_858;
             const real_t elMat_1_0 = tmp_kernel_op_171*tmp_kernel_op_860 + tmp_kernel_op_256*tmp_kernel_op_861 + tmp_kernel_op_341*tmp_kernel_op_862 + tmp_kernel_op_426*tmp_kernel_op_863 + tmp_kernel_op_859*tmp_kernel_op_86;
             const real_t elMat_1_1 = tmp_kernel_op_459*tmp_kernel_op_859 + tmp_kernel_op_464*tmp_kernel_op_860 + tmp_kernel_op_469*tmp_kernel_op_861 + tmp_kernel_op_474*tmp_kernel_op_862 + tmp_kernel_op_479*tmp_kernel_op_863;
             const real_t elMat_1_2 = tmp_kernel_op_490*tmp_kernel_op_859 + tmp_kernel_op_495*tmp_kernel_op_860 + tmp_kernel_op_500*tmp_kernel_op_861 + tmp_kernel_op_505*tmp_kernel_op_862 + tmp_kernel_op_510*tmp_kernel_op_863;
             const real_t elMat_1_3 = tmp_kernel_op_521*tmp_kernel_op_859 + tmp_kernel_op_526*tmp_kernel_op_860 + tmp_kernel_op_531*tmp_kernel_op_861 + tmp_kernel_op_536*tmp_kernel_op_862 + tmp_kernel_op_541*tmp_kernel_op_863;
             const real_t elMat_1_4 = tmp_kernel_op_566*tmp_kernel_op_859 + tmp_kernel_op_576*tmp_kernel_op_860 + tmp_kernel_op_586*tmp_kernel_op_861 + tmp_kernel_op_596*tmp_kernel_op_862 + tmp_kernel_op_606*tmp_kernel_op_863;
             const real_t elMat_1_5 = tmp_kernel_op_628*tmp_kernel_op_859 + tmp_kernel_op_638*tmp_kernel_op_860 + tmp_kernel_op_648*tmp_kernel_op_861 + tmp_kernel_op_658*tmp_kernel_op_862 + tmp_kernel_op_668*tmp_kernel_op_863;
             const real_t elMat_1_6 = tmp_kernel_op_693*tmp_kernel_op_859 + tmp_kernel_op_703*tmp_kernel_op_860 + tmp_kernel_op_713*tmp_kernel_op_861 + tmp_kernel_op_723*tmp_kernel_op_862 + tmp_kernel_op_733*tmp_kernel_op_863;
             const real_t elMat_1_7 = tmp_kernel_op_756*tmp_kernel_op_859 + tmp_kernel_op_761*tmp_kernel_op_860 + tmp_kernel_op_766*tmp_kernel_op_861 + tmp_kernel_op_771*tmp_kernel_op_862 + tmp_kernel_op_776*tmp_kernel_op_863;
             const real_t elMat_1_8 = tmp_kernel_op_797*tmp_kernel_op_859 + tmp_kernel_op_803*tmp_kernel_op_860 + tmp_kernel_op_809*tmp_kernel_op_861 + tmp_kernel_op_815*tmp_kernel_op_862 + tmp_kernel_op_821*tmp_kernel_op_863;
             const real_t elMat_1_9 = tmp_kernel_op_838*tmp_kernel_op_859 + tmp_kernel_op_843*tmp_kernel_op_860 + tmp_kernel_op_848*tmp_kernel_op_861 + tmp_kernel_op_853*tmp_kernel_op_862 + tmp_kernel_op_858*tmp_kernel_op_863;
             const real_t elMat_2_0 = tmp_kernel_op_171*tmp_kernel_op_865 + tmp_kernel_op_256*tmp_kernel_op_866 + tmp_kernel_op_341*tmp_kernel_op_867 + tmp_kernel_op_426*tmp_kernel_op_868 + tmp_kernel_op_86*tmp_kernel_op_864;
             const real_t elMat_2_1 = tmp_kernel_op_459*tmp_kernel_op_864 + tmp_kernel_op_464*tmp_kernel_op_865 + tmp_kernel_op_469*tmp_kernel_op_866 + tmp_kernel_op_474*tmp_kernel_op_867 + tmp_kernel_op_479*tmp_kernel_op_868;
             const real_t elMat_2_2 = tmp_kernel_op_490*tmp_kernel_op_864 + tmp_kernel_op_495*tmp_kernel_op_865 + tmp_kernel_op_500*tmp_kernel_op_866 + tmp_kernel_op_505*tmp_kernel_op_867 + tmp_kernel_op_510*tmp_kernel_op_868;
             const real_t elMat_2_3 = tmp_kernel_op_521*tmp_kernel_op_864 + tmp_kernel_op_526*tmp_kernel_op_865 + tmp_kernel_op_531*tmp_kernel_op_866 + tmp_kernel_op_536*tmp_kernel_op_867 + tmp_kernel_op_541*tmp_kernel_op_868;
             const real_t elMat_2_4 = tmp_kernel_op_566*tmp_kernel_op_864 + tmp_kernel_op_576*tmp_kernel_op_865 + tmp_kernel_op_586*tmp_kernel_op_866 + tmp_kernel_op_596*tmp_kernel_op_867 + tmp_kernel_op_606*tmp_kernel_op_868;
             const real_t elMat_2_5 = tmp_kernel_op_628*tmp_kernel_op_864 + tmp_kernel_op_638*tmp_kernel_op_865 + tmp_kernel_op_648*tmp_kernel_op_866 + tmp_kernel_op_658*tmp_kernel_op_867 + tmp_kernel_op_668*tmp_kernel_op_868;
             const real_t elMat_2_6 = tmp_kernel_op_693*tmp_kernel_op_864 + tmp_kernel_op_703*tmp_kernel_op_865 + tmp_kernel_op_713*tmp_kernel_op_866 + tmp_kernel_op_723*tmp_kernel_op_867 + tmp_kernel_op_733*tmp_kernel_op_868;
             const real_t elMat_2_7 = tmp_kernel_op_756*tmp_kernel_op_864 + tmp_kernel_op_761*tmp_kernel_op_865 + tmp_kernel_op_766*tmp_kernel_op_866 + tmp_kernel_op_771*tmp_kernel_op_867 + tmp_kernel_op_776*tmp_kernel_op_868;
             const real_t elMat_2_8 = tmp_kernel_op_797*tmp_kernel_op_864 + tmp_kernel_op_803*tmp_kernel_op_865 + tmp_kernel_op_809*tmp_kernel_op_866 + tmp_kernel_op_815*tmp_kernel_op_867 + tmp_kernel_op_821*tmp_kernel_op_868;
             const real_t elMat_2_9 = tmp_kernel_op_838*tmp_kernel_op_864 + tmp_kernel_op_843*tmp_kernel_op_865 + tmp_kernel_op_848*tmp_kernel_op_866 + tmp_kernel_op_853*tmp_kernel_op_867 + tmp_kernel_op_858*tmp_kernel_op_868;
             const real_t elMat_3_0 = tmp_kernel_op_171*tmp_kernel_op_870 + tmp_kernel_op_256*tmp_kernel_op_871 + tmp_kernel_op_341*tmp_kernel_op_872 + tmp_kernel_op_426*tmp_kernel_op_873 + tmp_kernel_op_86*tmp_kernel_op_869;
             const real_t elMat_3_1 = tmp_kernel_op_459*tmp_kernel_op_869 + tmp_kernel_op_464*tmp_kernel_op_870 + tmp_kernel_op_469*tmp_kernel_op_871 + tmp_kernel_op_474*tmp_kernel_op_872 + tmp_kernel_op_479*tmp_kernel_op_873;
             const real_t elMat_3_2 = tmp_kernel_op_490*tmp_kernel_op_869 + tmp_kernel_op_495*tmp_kernel_op_870 + tmp_kernel_op_500*tmp_kernel_op_871 + tmp_kernel_op_505*tmp_kernel_op_872 + tmp_kernel_op_510*tmp_kernel_op_873;
             const real_t elMat_3_3 = tmp_kernel_op_521*tmp_kernel_op_869 + tmp_kernel_op_526*tmp_kernel_op_870 + tmp_kernel_op_531*tmp_kernel_op_871 + tmp_kernel_op_536*tmp_kernel_op_872 + tmp_kernel_op_541*tmp_kernel_op_873;
             const real_t elMat_3_4 = tmp_kernel_op_566*tmp_kernel_op_869 + tmp_kernel_op_576*tmp_kernel_op_870 + tmp_kernel_op_586*tmp_kernel_op_871 + tmp_kernel_op_596*tmp_kernel_op_872 + tmp_kernel_op_606*tmp_kernel_op_873;
             const real_t elMat_3_5 = tmp_kernel_op_628*tmp_kernel_op_869 + tmp_kernel_op_638*tmp_kernel_op_870 + tmp_kernel_op_648*tmp_kernel_op_871 + tmp_kernel_op_658*tmp_kernel_op_872 + tmp_kernel_op_668*tmp_kernel_op_873;
             const real_t elMat_3_6 = tmp_kernel_op_693*tmp_kernel_op_869 + tmp_kernel_op_703*tmp_kernel_op_870 + tmp_kernel_op_713*tmp_kernel_op_871 + tmp_kernel_op_723*tmp_kernel_op_872 + tmp_kernel_op_733*tmp_kernel_op_873;
             const real_t elMat_3_7 = tmp_kernel_op_756*tmp_kernel_op_869 + tmp_kernel_op_761*tmp_kernel_op_870 + tmp_kernel_op_766*tmp_kernel_op_871 + tmp_kernel_op_771*tmp_kernel_op_872 + tmp_kernel_op_776*tmp_kernel_op_873;
             const real_t elMat_3_8 = tmp_kernel_op_797*tmp_kernel_op_869 + tmp_kernel_op_803*tmp_kernel_op_870 + tmp_kernel_op_809*tmp_kernel_op_871 + tmp_kernel_op_815*tmp_kernel_op_872 + tmp_kernel_op_821*tmp_kernel_op_873;
             const real_t elMat_3_9 = tmp_kernel_op_838*tmp_kernel_op_869 + tmp_kernel_op_843*tmp_kernel_op_870 + tmp_kernel_op_848*tmp_kernel_op_871 + tmp_kernel_op_853*tmp_kernel_op_872 + tmp_kernel_op_858*tmp_kernel_op_873;
             const real_t elMat_4_0 = tmp_kernel_op_171*tmp_kernel_op_875 + tmp_kernel_op_256*tmp_kernel_op_876 + tmp_kernel_op_341*tmp_kernel_op_877 + tmp_kernel_op_426*tmp_kernel_op_878 + tmp_kernel_op_86*tmp_kernel_op_874;
             const real_t elMat_4_1 = tmp_kernel_op_459*tmp_kernel_op_874 + tmp_kernel_op_464*tmp_kernel_op_875 + tmp_kernel_op_469*tmp_kernel_op_876 + tmp_kernel_op_474*tmp_kernel_op_877 + tmp_kernel_op_479*tmp_kernel_op_878;
             const real_t elMat_4_2 = tmp_kernel_op_490*tmp_kernel_op_874 + tmp_kernel_op_495*tmp_kernel_op_875 + tmp_kernel_op_500*tmp_kernel_op_876 + tmp_kernel_op_505*tmp_kernel_op_877 + tmp_kernel_op_510*tmp_kernel_op_878;
             const real_t elMat_4_3 = tmp_kernel_op_521*tmp_kernel_op_874 + tmp_kernel_op_526*tmp_kernel_op_875 + tmp_kernel_op_531*tmp_kernel_op_876 + tmp_kernel_op_536*tmp_kernel_op_877 + tmp_kernel_op_541*tmp_kernel_op_878;
             const real_t elMat_4_4 = tmp_kernel_op_566*tmp_kernel_op_874 + tmp_kernel_op_576*tmp_kernel_op_875 + tmp_kernel_op_586*tmp_kernel_op_876 + tmp_kernel_op_596*tmp_kernel_op_877 + tmp_kernel_op_606*tmp_kernel_op_878;
             const real_t elMat_4_5 = tmp_kernel_op_628*tmp_kernel_op_874 + tmp_kernel_op_638*tmp_kernel_op_875 + tmp_kernel_op_648*tmp_kernel_op_876 + tmp_kernel_op_658*tmp_kernel_op_877 + tmp_kernel_op_668*tmp_kernel_op_878;
             const real_t elMat_4_6 = tmp_kernel_op_693*tmp_kernel_op_874 + tmp_kernel_op_703*tmp_kernel_op_875 + tmp_kernel_op_713*tmp_kernel_op_876 + tmp_kernel_op_723*tmp_kernel_op_877 + tmp_kernel_op_733*tmp_kernel_op_878;
             const real_t elMat_4_7 = tmp_kernel_op_756*tmp_kernel_op_874 + tmp_kernel_op_761*tmp_kernel_op_875 + tmp_kernel_op_766*tmp_kernel_op_876 + tmp_kernel_op_771*tmp_kernel_op_877 + tmp_kernel_op_776*tmp_kernel_op_878;
             const real_t elMat_4_8 = tmp_kernel_op_797*tmp_kernel_op_874 + tmp_kernel_op_803*tmp_kernel_op_875 + tmp_kernel_op_809*tmp_kernel_op_876 + tmp_kernel_op_815*tmp_kernel_op_877 + tmp_kernel_op_821*tmp_kernel_op_878;
             const real_t elMat_4_9 = tmp_kernel_op_838*tmp_kernel_op_874 + tmp_kernel_op_843*tmp_kernel_op_875 + tmp_kernel_op_848*tmp_kernel_op_876 + tmp_kernel_op_853*tmp_kernel_op_877 + tmp_kernel_op_858*tmp_kernel_op_878;
             const real_t elMat_5_0 = tmp_kernel_op_171*tmp_kernel_op_880 + tmp_kernel_op_256*tmp_kernel_op_881 + tmp_kernel_op_341*tmp_kernel_op_882 + tmp_kernel_op_426*tmp_kernel_op_883 + tmp_kernel_op_86*tmp_kernel_op_879;
             const real_t elMat_5_1 = tmp_kernel_op_459*tmp_kernel_op_879 + tmp_kernel_op_464*tmp_kernel_op_880 + tmp_kernel_op_469*tmp_kernel_op_881 + tmp_kernel_op_474*tmp_kernel_op_882 + tmp_kernel_op_479*tmp_kernel_op_883;
             const real_t elMat_5_2 = tmp_kernel_op_490*tmp_kernel_op_879 + tmp_kernel_op_495*tmp_kernel_op_880 + tmp_kernel_op_500*tmp_kernel_op_881 + tmp_kernel_op_505*tmp_kernel_op_882 + tmp_kernel_op_510*tmp_kernel_op_883;
             const real_t elMat_5_3 = tmp_kernel_op_521*tmp_kernel_op_879 + tmp_kernel_op_526*tmp_kernel_op_880 + tmp_kernel_op_531*tmp_kernel_op_881 + tmp_kernel_op_536*tmp_kernel_op_882 + tmp_kernel_op_541*tmp_kernel_op_883;
             const real_t elMat_5_4 = tmp_kernel_op_566*tmp_kernel_op_879 + tmp_kernel_op_576*tmp_kernel_op_880 + tmp_kernel_op_586*tmp_kernel_op_881 + tmp_kernel_op_596*tmp_kernel_op_882 + tmp_kernel_op_606*tmp_kernel_op_883;
             const real_t elMat_5_5 = tmp_kernel_op_628*tmp_kernel_op_879 + tmp_kernel_op_638*tmp_kernel_op_880 + tmp_kernel_op_648*tmp_kernel_op_881 + tmp_kernel_op_658*tmp_kernel_op_882 + tmp_kernel_op_668*tmp_kernel_op_883;
             const real_t elMat_5_6 = tmp_kernel_op_693*tmp_kernel_op_879 + tmp_kernel_op_703*tmp_kernel_op_880 + tmp_kernel_op_713*tmp_kernel_op_881 + tmp_kernel_op_723*tmp_kernel_op_882 + tmp_kernel_op_733*tmp_kernel_op_883;
             const real_t elMat_5_7 = tmp_kernel_op_756*tmp_kernel_op_879 + tmp_kernel_op_761*tmp_kernel_op_880 + tmp_kernel_op_766*tmp_kernel_op_881 + tmp_kernel_op_771*tmp_kernel_op_882 + tmp_kernel_op_776*tmp_kernel_op_883;
             const real_t elMat_5_8 = tmp_kernel_op_797*tmp_kernel_op_879 + tmp_kernel_op_803*tmp_kernel_op_880 + tmp_kernel_op_809*tmp_kernel_op_881 + tmp_kernel_op_815*tmp_kernel_op_882 + tmp_kernel_op_821*tmp_kernel_op_883;
             const real_t elMat_5_9 = tmp_kernel_op_838*tmp_kernel_op_879 + tmp_kernel_op_843*tmp_kernel_op_880 + tmp_kernel_op_848*tmp_kernel_op_881 + tmp_kernel_op_853*tmp_kernel_op_882 + tmp_kernel_op_858*tmp_kernel_op_883;
             const real_t elMat_6_0 = tmp_kernel_op_171*tmp_kernel_op_885 + tmp_kernel_op_256*tmp_kernel_op_886 + tmp_kernel_op_341*tmp_kernel_op_887 + tmp_kernel_op_426*tmp_kernel_op_888 + tmp_kernel_op_86*tmp_kernel_op_884;
             const real_t elMat_6_1 = tmp_kernel_op_459*tmp_kernel_op_884 + tmp_kernel_op_464*tmp_kernel_op_885 + tmp_kernel_op_469*tmp_kernel_op_886 + tmp_kernel_op_474*tmp_kernel_op_887 + tmp_kernel_op_479*tmp_kernel_op_888;
             const real_t elMat_6_2 = tmp_kernel_op_490*tmp_kernel_op_884 + tmp_kernel_op_495*tmp_kernel_op_885 + tmp_kernel_op_500*tmp_kernel_op_886 + tmp_kernel_op_505*tmp_kernel_op_887 + tmp_kernel_op_510*tmp_kernel_op_888;
             const real_t elMat_6_3 = tmp_kernel_op_521*tmp_kernel_op_884 + tmp_kernel_op_526*tmp_kernel_op_885 + tmp_kernel_op_531*tmp_kernel_op_886 + tmp_kernel_op_536*tmp_kernel_op_887 + tmp_kernel_op_541*tmp_kernel_op_888;
             const real_t elMat_6_4 = tmp_kernel_op_566*tmp_kernel_op_884 + tmp_kernel_op_576*tmp_kernel_op_885 + tmp_kernel_op_586*tmp_kernel_op_886 + tmp_kernel_op_596*tmp_kernel_op_887 + tmp_kernel_op_606*tmp_kernel_op_888;
             const real_t elMat_6_5 = tmp_kernel_op_628*tmp_kernel_op_884 + tmp_kernel_op_638*tmp_kernel_op_885 + tmp_kernel_op_648*tmp_kernel_op_886 + tmp_kernel_op_658*tmp_kernel_op_887 + tmp_kernel_op_668*tmp_kernel_op_888;
             const real_t elMat_6_6 = tmp_kernel_op_693*tmp_kernel_op_884 + tmp_kernel_op_703*tmp_kernel_op_885 + tmp_kernel_op_713*tmp_kernel_op_886 + tmp_kernel_op_723*tmp_kernel_op_887 + tmp_kernel_op_733*tmp_kernel_op_888;
             const real_t elMat_6_7 = tmp_kernel_op_756*tmp_kernel_op_884 + tmp_kernel_op_761*tmp_kernel_op_885 + tmp_kernel_op_766*tmp_kernel_op_886 + tmp_kernel_op_771*tmp_kernel_op_887 + tmp_kernel_op_776*tmp_kernel_op_888;
             const real_t elMat_6_8 = tmp_kernel_op_797*tmp_kernel_op_884 + tmp_kernel_op_803*tmp_kernel_op_885 + tmp_kernel_op_809*tmp_kernel_op_886 + tmp_kernel_op_815*tmp_kernel_op_887 + tmp_kernel_op_821*tmp_kernel_op_888;
             const real_t elMat_6_9 = tmp_kernel_op_838*tmp_kernel_op_884 + tmp_kernel_op_843*tmp_kernel_op_885 + tmp_kernel_op_848*tmp_kernel_op_886 + tmp_kernel_op_853*tmp_kernel_op_887 + tmp_kernel_op_858*tmp_kernel_op_888;
             const real_t elMat_7_0 = tmp_kernel_op_171*tmp_kernel_op_890 + tmp_kernel_op_256*tmp_kernel_op_891 + tmp_kernel_op_341*tmp_kernel_op_892 + tmp_kernel_op_426*tmp_kernel_op_893 + tmp_kernel_op_86*tmp_kernel_op_889;
             const real_t elMat_7_1 = tmp_kernel_op_459*tmp_kernel_op_889 + tmp_kernel_op_464*tmp_kernel_op_890 + tmp_kernel_op_469*tmp_kernel_op_891 + tmp_kernel_op_474*tmp_kernel_op_892 + tmp_kernel_op_479*tmp_kernel_op_893;
             const real_t elMat_7_2 = tmp_kernel_op_490*tmp_kernel_op_889 + tmp_kernel_op_495*tmp_kernel_op_890 + tmp_kernel_op_500*tmp_kernel_op_891 + tmp_kernel_op_505*tmp_kernel_op_892 + tmp_kernel_op_510*tmp_kernel_op_893;
             const real_t elMat_7_3 = tmp_kernel_op_521*tmp_kernel_op_889 + tmp_kernel_op_526*tmp_kernel_op_890 + tmp_kernel_op_531*tmp_kernel_op_891 + tmp_kernel_op_536*tmp_kernel_op_892 + tmp_kernel_op_541*tmp_kernel_op_893;
             const real_t elMat_7_4 = tmp_kernel_op_566*tmp_kernel_op_889 + tmp_kernel_op_576*tmp_kernel_op_890 + tmp_kernel_op_586*tmp_kernel_op_891 + tmp_kernel_op_596*tmp_kernel_op_892 + tmp_kernel_op_606*tmp_kernel_op_893;
             const real_t elMat_7_5 = tmp_kernel_op_628*tmp_kernel_op_889 + tmp_kernel_op_638*tmp_kernel_op_890 + tmp_kernel_op_648*tmp_kernel_op_891 + tmp_kernel_op_658*tmp_kernel_op_892 + tmp_kernel_op_668*tmp_kernel_op_893;
             const real_t elMat_7_6 = tmp_kernel_op_693*tmp_kernel_op_889 + tmp_kernel_op_703*tmp_kernel_op_890 + tmp_kernel_op_713*tmp_kernel_op_891 + tmp_kernel_op_723*tmp_kernel_op_892 + tmp_kernel_op_733*tmp_kernel_op_893;
             const real_t elMat_7_7 = tmp_kernel_op_756*tmp_kernel_op_889 + tmp_kernel_op_761*tmp_kernel_op_890 + tmp_kernel_op_766*tmp_kernel_op_891 + tmp_kernel_op_771*tmp_kernel_op_892 + tmp_kernel_op_776*tmp_kernel_op_893;
             const real_t elMat_7_8 = tmp_kernel_op_797*tmp_kernel_op_889 + tmp_kernel_op_803*tmp_kernel_op_890 + tmp_kernel_op_809*tmp_kernel_op_891 + tmp_kernel_op_815*tmp_kernel_op_892 + tmp_kernel_op_821*tmp_kernel_op_893;
             const real_t elMat_7_9 = tmp_kernel_op_838*tmp_kernel_op_889 + tmp_kernel_op_843*tmp_kernel_op_890 + tmp_kernel_op_848*tmp_kernel_op_891 + tmp_kernel_op_853*tmp_kernel_op_892 + tmp_kernel_op_858*tmp_kernel_op_893;
             const real_t elMat_8_0 = tmp_kernel_op_171*tmp_kernel_op_895 + tmp_kernel_op_256*tmp_kernel_op_896 + tmp_kernel_op_341*tmp_kernel_op_897 + tmp_kernel_op_426*tmp_kernel_op_898 + tmp_kernel_op_86*tmp_kernel_op_894;
             const real_t elMat_8_1 = tmp_kernel_op_459*tmp_kernel_op_894 + tmp_kernel_op_464*tmp_kernel_op_895 + tmp_kernel_op_469*tmp_kernel_op_896 + tmp_kernel_op_474*tmp_kernel_op_897 + tmp_kernel_op_479*tmp_kernel_op_898;
             const real_t elMat_8_2 = tmp_kernel_op_490*tmp_kernel_op_894 + tmp_kernel_op_495*tmp_kernel_op_895 + tmp_kernel_op_500*tmp_kernel_op_896 + tmp_kernel_op_505*tmp_kernel_op_897 + tmp_kernel_op_510*tmp_kernel_op_898;
             const real_t elMat_8_3 = tmp_kernel_op_521*tmp_kernel_op_894 + tmp_kernel_op_526*tmp_kernel_op_895 + tmp_kernel_op_531*tmp_kernel_op_896 + tmp_kernel_op_536*tmp_kernel_op_897 + tmp_kernel_op_541*tmp_kernel_op_898;
             const real_t elMat_8_4 = tmp_kernel_op_566*tmp_kernel_op_894 + tmp_kernel_op_576*tmp_kernel_op_895 + tmp_kernel_op_586*tmp_kernel_op_896 + tmp_kernel_op_596*tmp_kernel_op_897 + tmp_kernel_op_606*tmp_kernel_op_898;
             const real_t elMat_8_5 = tmp_kernel_op_628*tmp_kernel_op_894 + tmp_kernel_op_638*tmp_kernel_op_895 + tmp_kernel_op_648*tmp_kernel_op_896 + tmp_kernel_op_658*tmp_kernel_op_897 + tmp_kernel_op_668*tmp_kernel_op_898;
             const real_t elMat_8_6 = tmp_kernel_op_693*tmp_kernel_op_894 + tmp_kernel_op_703*tmp_kernel_op_895 + tmp_kernel_op_713*tmp_kernel_op_896 + tmp_kernel_op_723*tmp_kernel_op_897 + tmp_kernel_op_733*tmp_kernel_op_898;
             const real_t elMat_8_7 = tmp_kernel_op_756*tmp_kernel_op_894 + tmp_kernel_op_761*tmp_kernel_op_895 + tmp_kernel_op_766*tmp_kernel_op_896 + tmp_kernel_op_771*tmp_kernel_op_897 + tmp_kernel_op_776*tmp_kernel_op_898;
             const real_t elMat_8_8 = tmp_kernel_op_797*tmp_kernel_op_894 + tmp_kernel_op_803*tmp_kernel_op_895 + tmp_kernel_op_809*tmp_kernel_op_896 + tmp_kernel_op_815*tmp_kernel_op_897 + tmp_kernel_op_821*tmp_kernel_op_898;
             const real_t elMat_8_9 = tmp_kernel_op_838*tmp_kernel_op_894 + tmp_kernel_op_843*tmp_kernel_op_895 + tmp_kernel_op_848*tmp_kernel_op_896 + tmp_kernel_op_853*tmp_kernel_op_897 + tmp_kernel_op_858*tmp_kernel_op_898;
             const real_t elMat_9_0 = tmp_kernel_op_171*tmp_kernel_op_900 + tmp_kernel_op_256*tmp_kernel_op_901 + tmp_kernel_op_341*tmp_kernel_op_902 + tmp_kernel_op_426*tmp_kernel_op_903 + tmp_kernel_op_86*tmp_kernel_op_899;
             const real_t elMat_9_1 = tmp_kernel_op_459*tmp_kernel_op_899 + tmp_kernel_op_464*tmp_kernel_op_900 + tmp_kernel_op_469*tmp_kernel_op_901 + tmp_kernel_op_474*tmp_kernel_op_902 + tmp_kernel_op_479*tmp_kernel_op_903;
             const real_t elMat_9_2 = tmp_kernel_op_490*tmp_kernel_op_899 + tmp_kernel_op_495*tmp_kernel_op_900 + tmp_kernel_op_500*tmp_kernel_op_901 + tmp_kernel_op_505*tmp_kernel_op_902 + tmp_kernel_op_510*tmp_kernel_op_903;
             const real_t elMat_9_3 = tmp_kernel_op_521*tmp_kernel_op_899 + tmp_kernel_op_526*tmp_kernel_op_900 + tmp_kernel_op_531*tmp_kernel_op_901 + tmp_kernel_op_536*tmp_kernel_op_902 + tmp_kernel_op_541*tmp_kernel_op_903;
             const real_t elMat_9_4 = tmp_kernel_op_566*tmp_kernel_op_899 + tmp_kernel_op_576*tmp_kernel_op_900 + tmp_kernel_op_586*tmp_kernel_op_901 + tmp_kernel_op_596*tmp_kernel_op_902 + tmp_kernel_op_606*tmp_kernel_op_903;
             const real_t elMat_9_5 = tmp_kernel_op_628*tmp_kernel_op_899 + tmp_kernel_op_638*tmp_kernel_op_900 + tmp_kernel_op_648*tmp_kernel_op_901 + tmp_kernel_op_658*tmp_kernel_op_902 + tmp_kernel_op_668*tmp_kernel_op_903;
             const real_t elMat_9_6 = tmp_kernel_op_693*tmp_kernel_op_899 + tmp_kernel_op_703*tmp_kernel_op_900 + tmp_kernel_op_713*tmp_kernel_op_901 + tmp_kernel_op_723*tmp_kernel_op_902 + tmp_kernel_op_733*tmp_kernel_op_903;
             const real_t elMat_9_7 = tmp_kernel_op_756*tmp_kernel_op_899 + tmp_kernel_op_761*tmp_kernel_op_900 + tmp_kernel_op_766*tmp_kernel_op_901 + tmp_kernel_op_771*tmp_kernel_op_902 + tmp_kernel_op_776*tmp_kernel_op_903;
             const real_t elMat_9_8 = tmp_kernel_op_797*tmp_kernel_op_899 + tmp_kernel_op_803*tmp_kernel_op_900 + tmp_kernel_op_809*tmp_kernel_op_901 + tmp_kernel_op_815*tmp_kernel_op_902 + tmp_kernel_op_821*tmp_kernel_op_903;
             const real_t elMat_9_9 = tmp_kernel_op_838*tmp_kernel_op_899 + tmp_kernel_op_843*tmp_kernel_op_900 + tmp_kernel_op_848*tmp_kernel_op_901 + tmp_kernel_op_853*tmp_kernel_op_902 + tmp_kernel_op_858*tmp_kernel_op_903;
         
             std::vector< uint_t > _data_rowIdx( 10 );
             std::vector< uint_t > _data_colIdx( 10 );
             std::vector< real_t > _data_mat( 100 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[1] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[2] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[3] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[4] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[5] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[7] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[8] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[9] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[3] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[7] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_0_4));
             _data_mat[5] = ((real_t)(elMat_0_5));
             _data_mat[6] = ((real_t)(elMat_0_6));
             _data_mat[7] = ((real_t)(elMat_0_7));
             _data_mat[8] = ((real_t)(elMat_0_8));
             _data_mat[9] = ((real_t)(elMat_0_9));
             _data_mat[10] = ((real_t)(elMat_1_0));
             _data_mat[11] = ((real_t)(elMat_1_1));
             _data_mat[12] = ((real_t)(elMat_1_2));
             _data_mat[13] = ((real_t)(elMat_1_3));
             _data_mat[14] = ((real_t)(elMat_1_4));
             _data_mat[15] = ((real_t)(elMat_1_5));
             _data_mat[16] = ((real_t)(elMat_1_6));
             _data_mat[17] = ((real_t)(elMat_1_7));
             _data_mat[18] = ((real_t)(elMat_1_8));
             _data_mat[19] = ((real_t)(elMat_1_9));
             _data_mat[20] = ((real_t)(elMat_2_0));
             _data_mat[21] = ((real_t)(elMat_2_1));
             _data_mat[22] = ((real_t)(elMat_2_2));
             _data_mat[23] = ((real_t)(elMat_2_3));
             _data_mat[24] = ((real_t)(elMat_2_4));
             _data_mat[25] = ((real_t)(elMat_2_5));
             _data_mat[26] = ((real_t)(elMat_2_6));
             _data_mat[27] = ((real_t)(elMat_2_7));
             _data_mat[28] = ((real_t)(elMat_2_8));
             _data_mat[29] = ((real_t)(elMat_2_9));
             _data_mat[30] = ((real_t)(elMat_3_0));
             _data_mat[31] = ((real_t)(elMat_3_1));
             _data_mat[32] = ((real_t)(elMat_3_2));
             _data_mat[33] = ((real_t)(elMat_3_3));
             _data_mat[34] = ((real_t)(elMat_3_4));
             _data_mat[35] = ((real_t)(elMat_3_5));
             _data_mat[36] = ((real_t)(elMat_3_6));
             _data_mat[37] = ((real_t)(elMat_3_7));
             _data_mat[38] = ((real_t)(elMat_3_8));
             _data_mat[39] = ((real_t)(elMat_3_9));
             _data_mat[40] = ((real_t)(elMat_4_0));
             _data_mat[41] = ((real_t)(elMat_4_1));
             _data_mat[42] = ((real_t)(elMat_4_2));
             _data_mat[43] = ((real_t)(elMat_4_3));
             _data_mat[44] = ((real_t)(elMat_4_4));
             _data_mat[45] = ((real_t)(elMat_4_5));
             _data_mat[46] = ((real_t)(elMat_4_6));
             _data_mat[47] = ((real_t)(elMat_4_7));
             _data_mat[48] = ((real_t)(elMat_4_8));
             _data_mat[49] = ((real_t)(elMat_4_9));
             _data_mat[50] = ((real_t)(elMat_5_0));
             _data_mat[51] = ((real_t)(elMat_5_1));
             _data_mat[52] = ((real_t)(elMat_5_2));
             _data_mat[53] = ((real_t)(elMat_5_3));
             _data_mat[54] = ((real_t)(elMat_5_4));
             _data_mat[55] = ((real_t)(elMat_5_5));
             _data_mat[56] = ((real_t)(elMat_5_6));
             _data_mat[57] = ((real_t)(elMat_5_7));
             _data_mat[58] = ((real_t)(elMat_5_8));
             _data_mat[59] = ((real_t)(elMat_5_9));
             _data_mat[60] = ((real_t)(elMat_6_0));
             _data_mat[61] = ((real_t)(elMat_6_1));
             _data_mat[62] = ((real_t)(elMat_6_2));
             _data_mat[63] = ((real_t)(elMat_6_3));
             _data_mat[64] = ((real_t)(elMat_6_4));
             _data_mat[65] = ((real_t)(elMat_6_5));
             _data_mat[66] = ((real_t)(elMat_6_6));
             _data_mat[67] = ((real_t)(elMat_6_7));
             _data_mat[68] = ((real_t)(elMat_6_8));
             _data_mat[69] = ((real_t)(elMat_6_9));
             _data_mat[70] = ((real_t)(elMat_7_0));
             _data_mat[71] = ((real_t)(elMat_7_1));
             _data_mat[72] = ((real_t)(elMat_7_2));
             _data_mat[73] = ((real_t)(elMat_7_3));
             _data_mat[74] = ((real_t)(elMat_7_4));
             _data_mat[75] = ((real_t)(elMat_7_5));
             _data_mat[76] = ((real_t)(elMat_7_6));
             _data_mat[77] = ((real_t)(elMat_7_7));
             _data_mat[78] = ((real_t)(elMat_7_8));
             _data_mat[79] = ((real_t)(elMat_7_9));
             _data_mat[80] = ((real_t)(elMat_8_0));
             _data_mat[81] = ((real_t)(elMat_8_1));
             _data_mat[82] = ((real_t)(elMat_8_2));
             _data_mat[83] = ((real_t)(elMat_8_3));
             _data_mat[84] = ((real_t)(elMat_8_4));
             _data_mat[85] = ((real_t)(elMat_8_5));
             _data_mat[86] = ((real_t)(elMat_8_6));
             _data_mat[87] = ((real_t)(elMat_8_7));
             _data_mat[88] = ((real_t)(elMat_8_8));
             _data_mat[89] = ((real_t)(elMat_8_9));
             _data_mat[90] = ((real_t)(elMat_9_0));
             _data_mat[91] = ((real_t)(elMat_9_1));
             _data_mat[92] = ((real_t)(elMat_9_2));
             _data_mat[93] = ((real_t)(elMat_9_3));
             _data_mat[94] = ((real_t)(elMat_9_4));
             _data_mat[95] = ((real_t)(elMat_9_5));
             _data_mat[96] = ((real_t)(elMat_9_6));
             _data_mat[97] = ((real_t)(elMat_9_7));
             _data_mat[98] = ((real_t)(elMat_9_8));
             _data_mat[99] = ((real_t)(elMat_9_9));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const real_t tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const real_t tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_11_BLUE_DOWN = jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
       const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const real_t tmp_coords_jac_10_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_0_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
       const real_t tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const real_t jac_affine_inv_0_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
       const real_t jac_affine_inv_0_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const real_t jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const real_t jac_affine_inv_1_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       const real_t tmp_moved_constant_738 = jac_affine_inv_2_0_BLUE_DOWN*4.0;
       const real_t tmp_moved_constant_739 = jac_affine_inv_0_0_BLUE_DOWN*4.0;
       const real_t tmp_moved_constant_740 = jac_affine_inv_1_0_BLUE_DOWN*4.0;
       const real_t tmp_moved_constant_741 = tmp_moved_constant_739 + tmp_moved_constant_740;
       const real_t tmp_moved_constant_742 = tmp_moved_constant_738 + tmp_moved_constant_741;
       const real_t tmp_moved_constant_743 = jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_742 + jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_742 + jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_742;
       const real_t tmp_moved_constant_744 = jac_affine_inv_2_1_BLUE_DOWN*4.0;
       const real_t tmp_moved_constant_745 = jac_affine_inv_0_1_BLUE_DOWN*4.0;
       const real_t tmp_moved_constant_746 = jac_affine_inv_1_1_BLUE_DOWN*4.0;
       const real_t tmp_moved_constant_747 = tmp_moved_constant_745 + tmp_moved_constant_746;
       const real_t tmp_moved_constant_748 = tmp_moved_constant_744 + tmp_moved_constant_747;
       const real_t tmp_moved_constant_749 = jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_748 + jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_748 + jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_748;
       const real_t tmp_moved_constant_750 = jac_affine_inv_2_2_BLUE_DOWN*4.0;
       const real_t tmp_moved_constant_751 = jac_affine_inv_0_2_BLUE_DOWN*4.0;
       const real_t tmp_moved_constant_752 = jac_affine_inv_1_2_BLUE_DOWN*4.0;
       const real_t tmp_moved_constant_753 = tmp_moved_constant_751 + tmp_moved_constant_752;
       const real_t tmp_moved_constant_754 = tmp_moved_constant_750 + tmp_moved_constant_753;
       const real_t tmp_moved_constant_755 = jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_754 + jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_754 + jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_754;
       const real_t tmp_moved_constant_756 = jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_742 + jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_742 + jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_742;
       const real_t tmp_moved_constant_757 = jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_748 + jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_748 + jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_748;
       const real_t tmp_moved_constant_758 = jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_754 + jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_754 + jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_754;
       const real_t tmp_moved_constant_759 = jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_742 + jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_742 + jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_742;
       const real_t tmp_moved_constant_760 = jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_748 + jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_748 + jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_748;
       const real_t tmp_moved_constant_761 = jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_754 + jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_754 + jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_754;
       const real_t tmp_moved_constant_762 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_28 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_28 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_763 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_28 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_28 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_764 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_28 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_28 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_765 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_113 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_113 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_113;
       const real_t tmp_moved_constant_766 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_113 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_113 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_113;
       const real_t tmp_moved_constant_767 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_113 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_113 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_113;
       const real_t tmp_moved_constant_768 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_198 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_198 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_198;
       const real_t tmp_moved_constant_769 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_198 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_198 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_198;
       const real_t tmp_moved_constant_770 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_198 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_198 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_198;
       const real_t tmp_moved_constant_771 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_283 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_283 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_283;
       const real_t tmp_moved_constant_772 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_283 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_283 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_283;
       const real_t tmp_moved_constant_773 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_283 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_283 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_283;
       const real_t tmp_moved_constant_774 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_368 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_368 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_368;
       const real_t tmp_moved_constant_775 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_368 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_368 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_368;
       const real_t tmp_moved_constant_776 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_368 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_368 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_368;
       const real_t tmp_moved_constant_777 = jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_739;
       const real_t tmp_moved_constant_778 = jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_739;
       const real_t tmp_moved_constant_779 = (jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*4.0;
       const real_t tmp_moved_constant_780 = jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_745;
       const real_t tmp_moved_constant_781 = (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*4.0;
       const real_t tmp_moved_constant_782 = (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*4.0;
       const real_t tmp_moved_constant_783 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_455;
       const real_t tmp_moved_constant_784 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_455;
       const real_t tmp_moved_constant_785 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_455;
       const real_t tmp_moved_constant_786 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_460;
       const real_t tmp_moved_constant_787 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_460;
       const real_t tmp_moved_constant_788 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_460;
       const real_t tmp_moved_constant_789 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_465;
       const real_t tmp_moved_constant_790 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_465;
       const real_t tmp_moved_constant_791 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_465;
       const real_t tmp_moved_constant_792 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_470;
       const real_t tmp_moved_constant_793 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_470;
       const real_t tmp_moved_constant_794 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_470;
       const real_t tmp_moved_constant_795 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_475;
       const real_t tmp_moved_constant_796 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_475;
       const real_t tmp_moved_constant_797 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_475;
       const real_t tmp_moved_constant_798 = jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_740;
       const real_t tmp_moved_constant_799 = jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_740;
       const real_t tmp_moved_constant_800 = (jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*4.0;
       const real_t tmp_moved_constant_801 = jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_746;
       const real_t tmp_moved_constant_802 = (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*4.0;
       const real_t tmp_moved_constant_803 = (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*4.0;
       const real_t tmp_moved_constant_804 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_486;
       const real_t tmp_moved_constant_805 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_486;
       const real_t tmp_moved_constant_806 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_486;
       const real_t tmp_moved_constant_807 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_491;
       const real_t tmp_moved_constant_808 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_491;
       const real_t tmp_moved_constant_809 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_491;
       const real_t tmp_moved_constant_810 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_496;
       const real_t tmp_moved_constant_811 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_496;
       const real_t tmp_moved_constant_812 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_496;
       const real_t tmp_moved_constant_813 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_501;
       const real_t tmp_moved_constant_814 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_501;
       const real_t tmp_moved_constant_815 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_501;
       const real_t tmp_moved_constant_816 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_506;
       const real_t tmp_moved_constant_817 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_506;
       const real_t tmp_moved_constant_818 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_506;
       const real_t tmp_moved_constant_819 = jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_738;
       const real_t tmp_moved_constant_820 = jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_738;
       const real_t tmp_moved_constant_821 = (jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*4.0;
       const real_t tmp_moved_constant_822 = jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_744;
       const real_t tmp_moved_constant_823 = (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*4.0;
       const real_t tmp_moved_constant_824 = (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*4.0;
       const real_t tmp_moved_constant_825 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_517;
       const real_t tmp_moved_constant_826 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_517;
       const real_t tmp_moved_constant_827 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_517;
       const real_t tmp_moved_constant_828 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_522;
       const real_t tmp_moved_constant_829 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_522;
       const real_t tmp_moved_constant_830 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_522;
       const real_t tmp_moved_constant_831 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_527;
       const real_t tmp_moved_constant_832 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_527;
       const real_t tmp_moved_constant_833 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_527;
       const real_t tmp_moved_constant_834 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_532;
       const real_t tmp_moved_constant_835 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_532;
       const real_t tmp_moved_constant_836 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_532;
       const real_t tmp_moved_constant_837 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_537;
       const real_t tmp_moved_constant_838 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_537;
       const real_t tmp_moved_constant_839 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_537;
       const real_t tmp_moved_constant_840 = jac_affine_inv_2_0_BLUE_DOWN*8.0;
       const real_t tmp_moved_constant_841 = jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_840;
       const real_t tmp_moved_constant_842 = jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_740;
       const real_t tmp_moved_constant_843 = jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_738;
       const real_t tmp_moved_constant_844 = tmp_moved_constant_842 + tmp_moved_constant_843;
       const real_t tmp_moved_constant_845 = jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_740;
       const real_t tmp_moved_constant_846 = jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_738;
       const real_t tmp_moved_constant_847 = tmp_moved_constant_845 + tmp_moved_constant_846;
       const real_t tmp_moved_constant_848 = jac_affine_inv_2_1_BLUE_DOWN*8.0;
       const real_t tmp_moved_constant_849 = jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_848;
       const real_t tmp_moved_constant_850 = jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_746;
       const real_t tmp_moved_constant_851 = jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_744;
       const real_t tmp_moved_constant_852 = tmp_moved_constant_850 + tmp_moved_constant_851;
       const real_t tmp_moved_constant_853 = jac_affine_inv_2_2_BLUE_DOWN*8.0;
       const real_t tmp_moved_constant_854 = jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_853;
       const real_t tmp_moved_constant_855 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_856 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_857 = tmp_moved_constant_855 + tmp_moved_constant_856;
       const real_t tmp_moved_constant_858 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_859 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_860 = tmp_moved_constant_858 + tmp_moved_constant_859;
       const real_t tmp_moved_constant_861 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_862 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_863 = tmp_moved_constant_861 + tmp_moved_constant_862;
       const real_t tmp_moved_constant_864 = tmp_moved_constant_740*0.5;
       const real_t tmp_moved_constant_865 = tmp_moved_constant_738*0.16666666666666666;
       const real_t tmp_moved_constant_866 = tmp_moved_constant_864 + tmp_moved_constant_865;
       const real_t tmp_moved_constant_867 = tmp_moved_constant_746*0.5;
       const real_t tmp_moved_constant_868 = tmp_moved_constant_744*0.16666666666666666;
       const real_t tmp_moved_constant_869 = tmp_moved_constant_867 + tmp_moved_constant_868;
       const real_t tmp_moved_constant_870 = tmp_moved_constant_752*0.5;
       const real_t tmp_moved_constant_871 = tmp_moved_constant_750*0.16666666666666666;
       const real_t tmp_moved_constant_872 = tmp_moved_constant_870 + tmp_moved_constant_871;
       const real_t tmp_moved_constant_873 = tmp_moved_constant_740*0.16666666666666666;
       const real_t tmp_moved_constant_874 = tmp_moved_constant_738*0.5;
       const real_t tmp_moved_constant_875 = tmp_moved_constant_873 + tmp_moved_constant_874;
       const real_t tmp_moved_constant_876 = tmp_moved_constant_746*0.16666666666666666;
       const real_t tmp_moved_constant_877 = tmp_moved_constant_744*0.5;
       const real_t tmp_moved_constant_878 = tmp_moved_constant_876 + tmp_moved_constant_877;
       const real_t tmp_moved_constant_879 = tmp_moved_constant_752*0.16666666666666666;
       const real_t tmp_moved_constant_880 = tmp_moved_constant_750*0.5;
       const real_t tmp_moved_constant_881 = tmp_moved_constant_879 + tmp_moved_constant_880;
       const real_t tmp_moved_constant_882 = tmp_moved_constant_740*0.16666666666666666;
       const real_t tmp_moved_constant_883 = tmp_moved_constant_738*0.16666666666666666;
       const real_t tmp_moved_constant_884 = tmp_moved_constant_882 + tmp_moved_constant_883;
       const real_t tmp_moved_constant_885 = tmp_moved_constant_746*0.16666666666666666;
       const real_t tmp_moved_constant_886 = tmp_moved_constant_744*0.16666666666666666;
       const real_t tmp_moved_constant_887 = tmp_moved_constant_885 + tmp_moved_constant_886;
       const real_t tmp_moved_constant_888 = tmp_moved_constant_752*0.16666666666666666;
       const real_t tmp_moved_constant_889 = tmp_moved_constant_750*0.16666666666666666;
       const real_t tmp_moved_constant_890 = tmp_moved_constant_888 + tmp_moved_constant_889;
       const real_t tmp_moved_constant_891 = tmp_moved_constant_740*0.16666666666666666;
       const real_t tmp_moved_constant_892 = tmp_moved_constant_738*0.16666666666666666;
       const real_t tmp_moved_constant_893 = tmp_moved_constant_891 + tmp_moved_constant_892;
       const real_t tmp_moved_constant_894 = tmp_moved_constant_746*0.16666666666666666;
       const real_t tmp_moved_constant_895 = tmp_moved_constant_744*0.16666666666666666;
       const real_t tmp_moved_constant_896 = tmp_moved_constant_894 + tmp_moved_constant_895;
       const real_t tmp_moved_constant_897 = tmp_moved_constant_752*0.16666666666666666;
       const real_t tmp_moved_constant_898 = tmp_moved_constant_750*0.16666666666666666;
       const real_t tmp_moved_constant_899 = tmp_moved_constant_897 + tmp_moved_constant_898;
       const real_t tmp_moved_constant_900 = jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_840;
       const real_t tmp_moved_constant_901 = jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_739;
       const real_t tmp_moved_constant_902 = jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_738;
       const real_t tmp_moved_constant_903 = tmp_moved_constant_901 + tmp_moved_constant_902;
       const real_t tmp_moved_constant_904 = jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_739;
       const real_t tmp_moved_constant_905 = jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_738;
       const real_t tmp_moved_constant_906 = tmp_moved_constant_904 + tmp_moved_constant_905;
       const real_t tmp_moved_constant_907 = jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_848;
       const real_t tmp_moved_constant_908 = jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_745;
       const real_t tmp_moved_constant_909 = jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_744;
       const real_t tmp_moved_constant_910 = tmp_moved_constant_908 + tmp_moved_constant_909;
       const real_t tmp_moved_constant_911 = jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_853;
       const real_t tmp_moved_constant_912 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_913 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_914 = tmp_moved_constant_912 + tmp_moved_constant_913;
       const real_t tmp_moved_constant_915 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_916 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_917 = tmp_moved_constant_915 + tmp_moved_constant_916;
       const real_t tmp_moved_constant_918 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_919 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_920 = tmp_moved_constant_918 + tmp_moved_constant_919;
       const real_t tmp_moved_constant_921 = tmp_moved_constant_739*0.5;
       const real_t tmp_moved_constant_922 = tmp_moved_constant_738*0.16666666666666666;
       const real_t tmp_moved_constant_923 = tmp_moved_constant_921 + tmp_moved_constant_922;
       const real_t tmp_moved_constant_924 = tmp_moved_constant_745*0.5;
       const real_t tmp_moved_constant_925 = tmp_moved_constant_744*0.16666666666666666;
       const real_t tmp_moved_constant_926 = tmp_moved_constant_924 + tmp_moved_constant_925;
       const real_t tmp_moved_constant_927 = tmp_moved_constant_751*0.5;
       const real_t tmp_moved_constant_928 = tmp_moved_constant_750*0.16666666666666666;
       const real_t tmp_moved_constant_929 = tmp_moved_constant_927 + tmp_moved_constant_928;
       const real_t tmp_moved_constant_930 = tmp_moved_constant_739*0.16666666666666666;
       const real_t tmp_moved_constant_931 = tmp_moved_constant_738*0.16666666666666666;
       const real_t tmp_moved_constant_932 = tmp_moved_constant_930 + tmp_moved_constant_931;
       const real_t tmp_moved_constant_933 = tmp_moved_constant_745*0.16666666666666666;
       const real_t tmp_moved_constant_934 = tmp_moved_constant_744*0.16666666666666666;
       const real_t tmp_moved_constant_935 = tmp_moved_constant_933 + tmp_moved_constant_934;
       const real_t tmp_moved_constant_936 = tmp_moved_constant_751*0.16666666666666666;
       const real_t tmp_moved_constant_937 = tmp_moved_constant_750*0.16666666666666666;
       const real_t tmp_moved_constant_938 = tmp_moved_constant_936 + tmp_moved_constant_937;
       const real_t tmp_moved_constant_939 = tmp_moved_constant_739*0.16666666666666666;
       const real_t tmp_moved_constant_940 = tmp_moved_constant_738*0.5;
       const real_t tmp_moved_constant_941 = tmp_moved_constant_939 + tmp_moved_constant_940;
       const real_t tmp_moved_constant_942 = tmp_moved_constant_745*0.16666666666666666;
       const real_t tmp_moved_constant_943 = tmp_moved_constant_744*0.5;
       const real_t tmp_moved_constant_944 = tmp_moved_constant_942 + tmp_moved_constant_943;
       const real_t tmp_moved_constant_945 = tmp_moved_constant_751*0.16666666666666666;
       const real_t tmp_moved_constant_946 = tmp_moved_constant_750*0.5;
       const real_t tmp_moved_constant_947 = tmp_moved_constant_945 + tmp_moved_constant_946;
       const real_t tmp_moved_constant_948 = tmp_moved_constant_739*0.16666666666666666;
       const real_t tmp_moved_constant_949 = tmp_moved_constant_738*0.16666666666666666;
       const real_t tmp_moved_constant_950 = tmp_moved_constant_948 + tmp_moved_constant_949;
       const real_t tmp_moved_constant_951 = tmp_moved_constant_745*0.16666666666666666;
       const real_t tmp_moved_constant_952 = tmp_moved_constant_744*0.16666666666666666;
       const real_t tmp_moved_constant_953 = tmp_moved_constant_951 + tmp_moved_constant_952;
       const real_t tmp_moved_constant_954 = tmp_moved_constant_751*0.16666666666666666;
       const real_t tmp_moved_constant_955 = tmp_moved_constant_750*0.16666666666666666;
       const real_t tmp_moved_constant_956 = tmp_moved_constant_954 + tmp_moved_constant_955;
       const real_t tmp_moved_constant_957 = jac_affine_inv_1_0_BLUE_DOWN*8.0;
       const real_t tmp_moved_constant_958 = jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_957;
       const real_t tmp_moved_constant_959 = jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_739;
       const real_t tmp_moved_constant_960 = jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_740;
       const real_t tmp_moved_constant_961 = tmp_moved_constant_959 + tmp_moved_constant_960;
       const real_t tmp_moved_constant_962 = jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_739;
       const real_t tmp_moved_constant_963 = jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_740;
       const real_t tmp_moved_constant_964 = tmp_moved_constant_962 + tmp_moved_constant_963;
       const real_t tmp_moved_constant_965 = jac_affine_inv_1_1_BLUE_DOWN*8.0;
       const real_t tmp_moved_constant_966 = jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_965;
       const real_t tmp_moved_constant_967 = jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_745;
       const real_t tmp_moved_constant_968 = jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_746;
       const real_t tmp_moved_constant_969 = tmp_moved_constant_967 + tmp_moved_constant_968;
       const real_t tmp_moved_constant_970 = jac_affine_inv_1_2_BLUE_DOWN*8.0;
       const real_t tmp_moved_constant_971 = jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_970;
       const real_t tmp_moved_constant_972 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_973 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_974 = tmp_moved_constant_972 + tmp_moved_constant_973;
       const real_t tmp_moved_constant_975 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_976 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_977 = tmp_moved_constant_975 + tmp_moved_constant_976;
       const real_t tmp_moved_constant_978 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_979 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_980 = tmp_moved_constant_978 + tmp_moved_constant_979;
       const real_t tmp_moved_constant_981 = tmp_moved_constant_739*0.16666666666666666;
       const real_t tmp_moved_constant_982 = tmp_moved_constant_740*0.16666666666666666;
       const real_t tmp_moved_constant_983 = tmp_moved_constant_981 + tmp_moved_constant_982;
       const real_t tmp_moved_constant_984 = tmp_moved_constant_745*0.16666666666666666;
       const real_t tmp_moved_constant_985 = tmp_moved_constant_746*0.16666666666666666;
       const real_t tmp_moved_constant_986 = tmp_moved_constant_984 + tmp_moved_constant_985;
       const real_t tmp_moved_constant_987 = tmp_moved_constant_751*0.16666666666666666;
       const real_t tmp_moved_constant_988 = tmp_moved_constant_752*0.16666666666666666;
       const real_t tmp_moved_constant_989 = tmp_moved_constant_987 + tmp_moved_constant_988;
       const real_t tmp_moved_constant_990 = tmp_moved_constant_739*0.5;
       const real_t tmp_moved_constant_991 = tmp_moved_constant_740*0.16666666666666666;
       const real_t tmp_moved_constant_992 = tmp_moved_constant_990 + tmp_moved_constant_991;
       const real_t tmp_moved_constant_993 = tmp_moved_constant_745*0.5;
       const real_t tmp_moved_constant_994 = tmp_moved_constant_746*0.16666666666666666;
       const real_t tmp_moved_constant_995 = tmp_moved_constant_993 + tmp_moved_constant_994;
       const real_t tmp_moved_constant_996 = tmp_moved_constant_751*0.5;
       const real_t tmp_moved_constant_997 = tmp_moved_constant_752*0.16666666666666666;
       const real_t tmp_moved_constant_998 = tmp_moved_constant_996 + tmp_moved_constant_997;
       const real_t tmp_moved_constant_999 = tmp_moved_constant_739*0.16666666666666666;
       const real_t tmp_moved_constant_1000 = tmp_moved_constant_740*0.5;
       const real_t tmp_moved_constant_1001 = tmp_moved_constant_1000 + tmp_moved_constant_999;
       const real_t tmp_moved_constant_1002 = tmp_moved_constant_745*0.16666666666666666;
       const real_t tmp_moved_constant_1003 = tmp_moved_constant_746*0.5;
       const real_t tmp_moved_constant_1004 = tmp_moved_constant_1002 + tmp_moved_constant_1003;
       const real_t tmp_moved_constant_1005 = tmp_moved_constant_751*0.16666666666666666;
       const real_t tmp_moved_constant_1006 = tmp_moved_constant_752*0.5;
       const real_t tmp_moved_constant_1007 = tmp_moved_constant_1005 + tmp_moved_constant_1006;
       const real_t tmp_moved_constant_1008 = tmp_moved_constant_739*0.16666666666666666;
       const real_t tmp_moved_constant_1009 = tmp_moved_constant_740*0.16666666666666666;
       const real_t tmp_moved_constant_1010 = tmp_moved_constant_1008 + tmp_moved_constant_1009;
       const real_t tmp_moved_constant_1011 = tmp_moved_constant_745*0.16666666666666666;
       const real_t tmp_moved_constant_1012 = tmp_moved_constant_746*0.16666666666666666;
       const real_t tmp_moved_constant_1013 = tmp_moved_constant_1011 + tmp_moved_constant_1012;
       const real_t tmp_moved_constant_1014 = tmp_moved_constant_751*0.16666666666666666;
       const real_t tmp_moved_constant_1015 = tmp_moved_constant_752*0.16666666666666666;
       const real_t tmp_moved_constant_1016 = tmp_moved_constant_1014 + tmp_moved_constant_1015;
       const real_t tmp_moved_constant_1017 = jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_739;
       const real_t tmp_moved_constant_1018 = jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_740;
       const real_t tmp_moved_constant_1019 = -tmp_moved_constant_741 - tmp_moved_constant_840;
       const real_t tmp_moved_constant_1020 = jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_1019 - tmp_moved_constant_1017 - tmp_moved_constant_1018;
       const real_t tmp_moved_constant_1021 = -tmp_moved_constant_747 - tmp_moved_constant_848;
       const real_t tmp_moved_constant_1022 = jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_1021 - tmp_moved_constant_842 - tmp_moved_constant_901;
       const real_t tmp_moved_constant_1023 = -tmp_moved_constant_753 - tmp_moved_constant_853;
       const real_t tmp_moved_constant_1024 = jac_affine_inv_2_0_BLUE_DOWN*tmp_moved_constant_1023 - tmp_moved_constant_845 - tmp_moved_constant_904;
       const real_t tmp_moved_constant_1025 = jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_1019 - tmp_moved_constant_843 - tmp_moved_constant_902;
       const real_t tmp_moved_constant_1026 = jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_745;
       const real_t tmp_moved_constant_1027 = jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_746;
       const real_t tmp_moved_constant_1028 = jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_1021 - tmp_moved_constant_1026 - tmp_moved_constant_1027;
       const real_t tmp_moved_constant_1029 = jac_affine_inv_2_1_BLUE_DOWN*tmp_moved_constant_1023 - tmp_moved_constant_850 - tmp_moved_constant_908;
       const real_t tmp_moved_constant_1030 = jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_1019 - tmp_moved_constant_846 - tmp_moved_constant_905;
       const real_t tmp_moved_constant_1031 = jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_1021 - tmp_moved_constant_851 - tmp_moved_constant_909;
       const real_t tmp_moved_constant_1032 = jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_751;
       const real_t tmp_moved_constant_1033 = jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_752;
       const real_t tmp_moved_constant_1034 = jac_affine_inv_2_2_BLUE_DOWN*tmp_moved_constant_1023 - tmp_moved_constant_1032 - tmp_moved_constant_1033;
       const real_t tmp_moved_constant_1035 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_752 - tmp_moved_constant_855 - tmp_moved_constant_912;
       const real_t tmp_moved_constant_1036 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_752 - tmp_moved_constant_858 - tmp_moved_constant_915;
       const real_t tmp_moved_constant_1037 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_752 - tmp_moved_constant_861 - tmp_moved_constant_918;
       const real_t tmp_moved_constant_1038 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_757 - tmp_moved_constant_864 - tmp_moved_constant_921;
       const real_t tmp_moved_constant_1039 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_757 - tmp_moved_constant_867 - tmp_moved_constant_924;
       const real_t tmp_moved_constant_1040 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_757 - tmp_moved_constant_870 - tmp_moved_constant_927;
       const real_t tmp_moved_constant_1041 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_762 - tmp_moved_constant_873 - tmp_moved_constant_930;
       const real_t tmp_moved_constant_1042 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_762 - tmp_moved_constant_876 - tmp_moved_constant_933;
       const real_t tmp_moved_constant_1043 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_762 - tmp_moved_constant_879 - tmp_moved_constant_936;
       const real_t tmp_moved_constant_1044 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_767 - tmp_moved_constant_882 - tmp_moved_constant_939;
       const real_t tmp_moved_constant_1045 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_767 - tmp_moved_constant_885 - tmp_moved_constant_942;
       const real_t tmp_moved_constant_1046 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_767 - tmp_moved_constant_888 - tmp_moved_constant_945;
       const real_t tmp_moved_constant_1047 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_772 - tmp_moved_constant_891 - tmp_moved_constant_948;
       const real_t tmp_moved_constant_1048 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_772 - tmp_moved_constant_894 - tmp_moved_constant_951;
       const real_t tmp_moved_constant_1049 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_772 - tmp_moved_constant_897 - tmp_moved_constant_954;
       const real_t tmp_moved_constant_1050 = jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_739;
       const real_t tmp_moved_constant_1051 = -tmp_moved_constant_738 - tmp_moved_constant_739 - tmp_moved_constant_957;
       const real_t tmp_moved_constant_1052 = jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_1051 - tmp_moved_constant_1018 - tmp_moved_constant_1050;
       const real_t tmp_moved_constant_1053 = -tmp_moved_constant_744 - tmp_moved_constant_745 - tmp_moved_constant_965;
       const real_t tmp_moved_constant_1054 = jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_1053 - tmp_moved_constant_843 - tmp_moved_constant_959;
       const real_t tmp_moved_constant_1055 = -tmp_moved_constant_750 - tmp_moved_constant_751 - tmp_moved_constant_970;
       const real_t tmp_moved_constant_1056 = jac_affine_inv_1_0_BLUE_DOWN*tmp_moved_constant_1055 - tmp_moved_constant_846 - tmp_moved_constant_962;
       const real_t tmp_moved_constant_1057 = jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_1051 - tmp_moved_constant_842 - tmp_moved_constant_960;
       const real_t tmp_moved_constant_1058 = jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_745;
       const real_t tmp_moved_constant_1059 = jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_1053 - tmp_moved_constant_1027 - tmp_moved_constant_1058;
       const real_t tmp_moved_constant_1060 = jac_affine_inv_1_1_BLUE_DOWN*tmp_moved_constant_1055 - tmp_moved_constant_851 - tmp_moved_constant_967;
       const real_t tmp_moved_constant_1061 = jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_1051 - tmp_moved_constant_845 - tmp_moved_constant_963;
       const real_t tmp_moved_constant_1062 = jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_1053 - tmp_moved_constant_850 - tmp_moved_constant_968;
       const real_t tmp_moved_constant_1063 = jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_751;
       const real_t tmp_moved_constant_1064 = jac_affine_inv_1_2_BLUE_DOWN*tmp_moved_constant_1055 - tmp_moved_constant_1033 - tmp_moved_constant_1063;
       const real_t tmp_moved_constant_1065 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_793 - tmp_moved_constant_856 - tmp_moved_constant_972;
       const real_t tmp_moved_constant_1066 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_793 - tmp_moved_constant_859 - tmp_moved_constant_975;
       const real_t tmp_moved_constant_1067 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_793 - tmp_moved_constant_862 - tmp_moved_constant_978;
       const real_t tmp_moved_constant_1068 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_799 - tmp_moved_constant_865 - tmp_moved_constant_981;
       const real_t tmp_moved_constant_1069 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_799 - tmp_moved_constant_868 - tmp_moved_constant_984;
       const real_t tmp_moved_constant_1070 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_799 - tmp_moved_constant_871 - tmp_moved_constant_987;
       const real_t tmp_moved_constant_1071 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_805 - tmp_moved_constant_874 - tmp_moved_constant_990;
       const real_t tmp_moved_constant_1072 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_805 - tmp_moved_constant_877 - tmp_moved_constant_993;
       const real_t tmp_moved_constant_1073 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_805 - tmp_moved_constant_880 - tmp_moved_constant_996;
       const real_t tmp_moved_constant_1074 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_811 - tmp_moved_constant_883 - tmp_moved_constant_999;
       const real_t tmp_moved_constant_1075 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_811 - tmp_moved_constant_1002 - tmp_moved_constant_886;
       const real_t tmp_moved_constant_1076 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_811 - tmp_moved_constant_1005 - tmp_moved_constant_889;
       const real_t tmp_moved_constant_1077 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_817 - tmp_moved_constant_1008 - tmp_moved_constant_892;
       const real_t tmp_moved_constant_1078 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_817 - tmp_moved_constant_1011 - tmp_moved_constant_895;
       const real_t tmp_moved_constant_1079 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_817 - tmp_moved_constant_1014 - tmp_moved_constant_898;
       const real_t tmp_moved_constant_1080 = jac_affine_inv_0_0_BLUE_DOWN*-8.0 - tmp_moved_constant_738 - tmp_moved_constant_740;
       const real_t tmp_moved_constant_1081 = jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_1080 - tmp_moved_constant_1017 - tmp_moved_constant_1050;
       const real_t tmp_moved_constant_1082 = jac_affine_inv_0_1_BLUE_DOWN*-8.0 - tmp_moved_constant_744 - tmp_moved_constant_746;
       const real_t tmp_moved_constant_1083 = jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_1082 - tmp_moved_constant_902 - tmp_moved_constant_960;
       const real_t tmp_moved_constant_1084 = jac_affine_inv_0_2_BLUE_DOWN*-8.0 - tmp_moved_constant_750 - tmp_moved_constant_752;
       const real_t tmp_moved_constant_1085 = jac_affine_inv_0_0_BLUE_DOWN*tmp_moved_constant_1084 - tmp_moved_constant_905 - tmp_moved_constant_963;
       const real_t tmp_moved_constant_1086 = jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_1080 - tmp_moved_constant_901 - tmp_moved_constant_959;
       const real_t tmp_moved_constant_1087 = jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_1082 - tmp_moved_constant_1026 - tmp_moved_constant_1058;
       const real_t tmp_moved_constant_1088 = jac_affine_inv_0_1_BLUE_DOWN*tmp_moved_constant_1084 - tmp_moved_constant_909 - tmp_moved_constant_968;
       const real_t tmp_moved_constant_1089 = jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_1080 - tmp_moved_constant_904 - tmp_moved_constant_962;
       const real_t tmp_moved_constant_1090 = jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_1082 - tmp_moved_constant_908 - tmp_moved_constant_967;
       const real_t tmp_moved_constant_1091 = jac_affine_inv_0_2_BLUE_DOWN*tmp_moved_constant_1084 - tmp_moved_constant_1032 - tmp_moved_constant_1063;
       const real_t tmp_moved_constant_1092 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_834 - tmp_moved_constant_913 - tmp_moved_constant_973;
       const real_t tmp_moved_constant_1093 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_834 - tmp_moved_constant_916 - tmp_moved_constant_976;
       const real_t tmp_moved_constant_1094 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_834 - tmp_moved_constant_919 - tmp_moved_constant_979;
       const real_t tmp_moved_constant_1095 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_839 - tmp_moved_constant_922 - tmp_moved_constant_982;
       const real_t tmp_moved_constant_1096 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_839 - tmp_moved_constant_925 - tmp_moved_constant_985;
       const real_t tmp_moved_constant_1097 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_839 - tmp_moved_constant_928 - tmp_moved_constant_988;
       const real_t tmp_moved_constant_1098 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_844 - tmp_moved_constant_931 - tmp_moved_constant_991;
       const real_t tmp_moved_constant_1099 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_844 - tmp_moved_constant_934 - tmp_moved_constant_994;
       const real_t tmp_moved_constant_1100 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_844 - tmp_moved_constant_937 - tmp_moved_constant_997;
       const real_t tmp_moved_constant_1101 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_849 - tmp_moved_constant_1000 - tmp_moved_constant_940;
       const real_t tmp_moved_constant_1102 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_849 - tmp_moved_constant_1003 - tmp_moved_constant_943;
       const real_t tmp_moved_constant_1103 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_849 - tmp_moved_constant_1006 - tmp_moved_constant_946;
       const real_t tmp_moved_constant_1104 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_854 - tmp_moved_constant_1009 - tmp_moved_constant_949;
       const real_t tmp_moved_constant_1105 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_854 - tmp_moved_constant_1012 - tmp_moved_constant_952;
       const real_t tmp_moved_constant_1106 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_854 - tmp_moved_constant_1015 - tmp_moved_constant_955;
       {
          /* CellType.BLUE_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
             const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
             const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
             const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
             const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
             const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
             const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
             const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
             const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
             const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
             const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
             const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
             const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
             const real_t tmp_blending_op_35 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_36 = tmp_blending_op_22 - tmp_blending_op_35;
             const real_t tmp_blending_op_37 = -tmp_blending_op_36;
             const real_t tmp_blending_op_38 = (tmp_blending_op_28*tmp_blending_op_28);
             const real_t tmp_blending_op_39 = (tmp_blending_op_33*tmp_blending_op_33);
             const real_t tmp_blending_op_40 = tmp_blending_op_38 + tmp_blending_op_39 + tmp_blending_op_4;
             const real_t tmp_blending_op_43 = tmp_blending_op_3*tmp_blending_op_42;
             const real_t tmp_blending_op_44 = tmp_blending_op_36 + tmp_blending_op_43;
             const real_t tmp_blending_op_45 = tmp_blending_op_37*tmp_blending_op_4 + tmp_blending_op_40*tmp_blending_op_44;
             const real_t tmp_blending_op_46 = pow(tmp_blending_op_40, -1.5000000000000000);
             const real_t tmp_blending_op_49 = tmp_blending_op_46*tmp_blending_op_48;
             const real_t tmp_blending_op_52 = tmp_blending_op_40*tmp_blending_op_51;
             const real_t tmp_blending_op_53 = -tmp_blending_op_33*tmp_blending_op_36 - tmp_blending_op_52;
             const real_t tmp_blending_op_54 = tmp_blending_op_49*tmp_blending_op_53;
             const real_t tmp_blending_op_57 = tmp_blending_op_28*tmp_blending_op_37 + tmp_blending_op_40*tmp_blending_op_56;
             const real_t tmp_blending_op_58 = tmp_blending_op_49*tmp_blending_op_57;
             const real_t tmp_blending_op_59 = tmp_blending_op_3*tmp_blending_op_37;
             const real_t tmp_blending_op_60 = tmp_blending_op_40*tmp_blending_op_42 + tmp_blending_op_59;
             const real_t tmp_blending_op_61 = tmp_blending_op_49*tmp_blending_op_60;
             const real_t tmp_blending_op_63 = tmp_blending_op_33*tmp_blending_op_62 + tmp_blending_op_36;
             const real_t tmp_blending_op_64 = tmp_blending_op_37*tmp_blending_op_39 + tmp_blending_op_40*tmp_blending_op_63;
             const real_t tmp_blending_op_65 = tmp_blending_op_28*tmp_blending_op_56;
             const real_t tmp_blending_op_66 = tmp_blending_op_36 + tmp_blending_op_65;
             const real_t tmp_blending_op_67 = -tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_40*tmp_blending_op_66;
             const real_t tmp_blending_op_75 = p_affine_0_2 + tmp_blending_op_0*0.5 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_76 = (tmp_blending_op_75*tmp_blending_op_75);
             const real_t tmp_blending_op_77 = -tmp_blending_op_17 - tmp_blending_op_75;
             const real_t tmp_blending_op_78 = p_affine_0_0 + tmp_blending_op_25*0.5 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_79 = -tmp_blending_op_6 - tmp_blending_op_78;
             const real_t tmp_blending_op_80 = p_affine_0_1 + tmp_blending_op_30*0.5 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_81 = -tmp_blending_op_13 - tmp_blending_op_80;
             const real_t tmp_blending_op_82 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_79 - tmp_blending_op_12*tmp_blending_op_77 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_77 - tmp_blending_op_19*tmp_blending_op_79 - tmp_blending_op_20*tmp_blending_op_81 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_81);
             const real_t tmp_blending_op_83 = tmp_blending_op_22 - tmp_blending_op_82;
             const real_t tmp_blending_op_84 = -tmp_blending_op_83;
             const real_t tmp_blending_op_85 = (tmp_blending_op_78*tmp_blending_op_78);
             const real_t tmp_blending_op_86 = (tmp_blending_op_80*tmp_blending_op_80);
             const real_t tmp_blending_op_87 = tmp_blending_op_76 + tmp_blending_op_85 + tmp_blending_op_86;
             const real_t tmp_blending_op_88 = tmp_blending_op_42*tmp_blending_op_75;
             const real_t tmp_blending_op_89 = tmp_blending_op_83 + tmp_blending_op_88;
             const real_t tmp_blending_op_90 = tmp_blending_op_76*tmp_blending_op_84 + tmp_blending_op_87*tmp_blending_op_89;
             const real_t tmp_blending_op_91 = pow(tmp_blending_op_87, -1.5000000000000000);
             const real_t tmp_blending_op_92 = tmp_blending_op_48*tmp_blending_op_91;
             const real_t tmp_blending_op_93 = tmp_blending_op_51*tmp_blending_op_87;
             const real_t tmp_blending_op_94 = -tmp_blending_op_80*tmp_blending_op_83 - tmp_blending_op_93;
             const real_t tmp_blending_op_95 = tmp_blending_op_92*tmp_blending_op_94;
             const real_t tmp_blending_op_96 = tmp_blending_op_56*tmp_blending_op_87 + tmp_blending_op_78*tmp_blending_op_84;
             const real_t tmp_blending_op_97 = tmp_blending_op_92*tmp_blending_op_96;
             const real_t tmp_blending_op_98 = tmp_blending_op_75*tmp_blending_op_84;
             const real_t tmp_blending_op_99 = tmp_blending_op_42*tmp_blending_op_87 + tmp_blending_op_98;
             const real_t tmp_blending_op_100 = tmp_blending_op_92*tmp_blending_op_99;
             const real_t tmp_blending_op_101 = tmp_blending_op_62*tmp_blending_op_80 + tmp_blending_op_83;
             const real_t tmp_blending_op_102 = tmp_blending_op_101*tmp_blending_op_87 + tmp_blending_op_84*tmp_blending_op_86;
             const real_t tmp_blending_op_103 = tmp_blending_op_56*tmp_blending_op_78;
             const real_t tmp_blending_op_104 = tmp_blending_op_103 + tmp_blending_op_83;
             const real_t tmp_blending_op_105 = tmp_blending_op_104*tmp_blending_op_87 - tmp_blending_op_83*tmp_blending_op_85;
             const real_t tmp_blending_op_113 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.5 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_114 = (tmp_blending_op_113*tmp_blending_op_113);
             const real_t tmp_blending_op_115 = -tmp_blending_op_113 - tmp_blending_op_17;
             const real_t tmp_blending_op_116 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.5 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_117 = -tmp_blending_op_116 - tmp_blending_op_6;
             const real_t tmp_blending_op_118 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.5 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_119 = -tmp_blending_op_118 - tmp_blending_op_13;
             const real_t tmp_blending_op_120 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_117*tmp_blending_op_18 - tmp_blending_op_115*tmp_blending_op_12 + tmp_blending_op_115*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_117*tmp_blending_op_19 - tmp_blending_op_119*tmp_blending_op_20 + tmp_blending_op_119*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_121 = -tmp_blending_op_120 + tmp_blending_op_22;
             const real_t tmp_blending_op_122 = -tmp_blending_op_121;
             const real_t tmp_blending_op_123 = (tmp_blending_op_116*tmp_blending_op_116);
             const real_t tmp_blending_op_124 = (tmp_blending_op_118*tmp_blending_op_118);
             const real_t tmp_blending_op_125 = tmp_blending_op_114 + tmp_blending_op_123 + tmp_blending_op_124;
             const real_t tmp_blending_op_126 = tmp_blending_op_113*tmp_blending_op_42;
             const real_t tmp_blending_op_127 = tmp_blending_op_121 + tmp_blending_op_126;
             const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_127;
             const real_t tmp_blending_op_129 = pow(tmp_blending_op_125, -1.5000000000000000);
             const real_t tmp_blending_op_130 = tmp_blending_op_129*tmp_blending_op_48;
             const real_t tmp_blending_op_131 = tmp_blending_op_125*tmp_blending_op_51;
             const real_t tmp_blending_op_132 = -tmp_blending_op_118*tmp_blending_op_121 - tmp_blending_op_131;
             const real_t tmp_blending_op_133 = tmp_blending_op_130*tmp_blending_op_132;
             const real_t tmp_blending_op_134 = tmp_blending_op_116*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_56;
             const real_t tmp_blending_op_135 = tmp_blending_op_130*tmp_blending_op_134;
             const real_t tmp_blending_op_136 = tmp_blending_op_113*tmp_blending_op_122;
             const real_t tmp_blending_op_137 = tmp_blending_op_125*tmp_blending_op_42 + tmp_blending_op_136;
             const real_t tmp_blending_op_138 = tmp_blending_op_130*tmp_blending_op_137;
             const real_t tmp_blending_op_139 = tmp_blending_op_118*tmp_blending_op_62 + tmp_blending_op_121;
             const real_t tmp_blending_op_140 = tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*tmp_blending_op_139;
             const real_t tmp_blending_op_141 = tmp_blending_op_116*tmp_blending_op_56;
             const real_t tmp_blending_op_142 = tmp_blending_op_121 + tmp_blending_op_141;
             const real_t tmp_blending_op_143 = -tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*tmp_blending_op_142;
             const real_t tmp_blending_op_151 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.5;
             const real_t tmp_blending_op_152 = (tmp_blending_op_151*tmp_blending_op_151);
             const real_t tmp_blending_op_153 = -tmp_blending_op_151 - tmp_blending_op_17;
             const real_t tmp_blending_op_154 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.5;
             const real_t tmp_blending_op_155 = -tmp_blending_op_154 - tmp_blending_op_6;
             const real_t tmp_blending_op_156 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.5;
             const real_t tmp_blending_op_157 = -tmp_blending_op_13 - tmp_blending_op_156;
             const real_t tmp_blending_op_158 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_155*tmp_blending_op_18 - tmp_blending_op_12*tmp_blending_op_153 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_153 - tmp_blending_op_155*tmp_blending_op_19 - tmp_blending_op_157*tmp_blending_op_20 + tmp_blending_op_157*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_159 = -tmp_blending_op_158 + tmp_blending_op_22;
             const real_t tmp_blending_op_160 = -tmp_blending_op_159;
             const real_t tmp_blending_op_161 = (tmp_blending_op_154*tmp_blending_op_154);
             const real_t tmp_blending_op_162 = (tmp_blending_op_156*tmp_blending_op_156);
             const real_t tmp_blending_op_163 = tmp_blending_op_152 + tmp_blending_op_161 + tmp_blending_op_162;
             const real_t tmp_blending_op_164 = tmp_blending_op_151*tmp_blending_op_42;
             const real_t tmp_blending_op_165 = tmp_blending_op_159 + tmp_blending_op_164;
             const real_t tmp_blending_op_166 = tmp_blending_op_152*tmp_blending_op_160 + tmp_blending_op_163*tmp_blending_op_165;
             const real_t tmp_blending_op_167 = pow(tmp_blending_op_163, -1.5000000000000000);
             const real_t tmp_blending_op_168 = tmp_blending_op_167*tmp_blending_op_48;
             const real_t tmp_blending_op_169 = tmp_blending_op_163*tmp_blending_op_51;
             const real_t tmp_blending_op_170 = -tmp_blending_op_156*tmp_blending_op_159 - tmp_blending_op_169;
             const real_t tmp_blending_op_171 = tmp_blending_op_168*tmp_blending_op_170;
             const real_t tmp_blending_op_172 = tmp_blending_op_154*tmp_blending_op_160 + tmp_blending_op_163*tmp_blending_op_56;
             const real_t tmp_blending_op_173 = tmp_blending_op_168*tmp_blending_op_172;
             const real_t tmp_blending_op_174 = tmp_blending_op_151*tmp_blending_op_160;
             const real_t tmp_blending_op_175 = tmp_blending_op_163*tmp_blending_op_42 + tmp_blending_op_174;
             const real_t tmp_blending_op_176 = tmp_blending_op_168*tmp_blending_op_175;
             const real_t tmp_blending_op_177 = tmp_blending_op_156*tmp_blending_op_62 + tmp_blending_op_159;
             const real_t tmp_blending_op_178 = tmp_blending_op_160*tmp_blending_op_162 + tmp_blending_op_163*tmp_blending_op_177;
             const real_t tmp_blending_op_179 = tmp_blending_op_154*tmp_blending_op_56;
             const real_t tmp_blending_op_180 = tmp_blending_op_159 + tmp_blending_op_179;
             const real_t tmp_blending_op_181 = -tmp_blending_op_159*tmp_blending_op_161 + tmp_blending_op_163*tmp_blending_op_180;
             const real_t tmp_blending_op_189 = p_affine_0_2 + tmp_blending_op_0*0.25 + tmp_blending_op_1*0.25 + tmp_blending_op_2*0.25;
             const real_t tmp_blending_op_190 = (tmp_blending_op_189*tmp_blending_op_189);
             const real_t tmp_blending_op_191 = -tmp_blending_op_17 - tmp_blending_op_189;
             const real_t tmp_blending_op_192 = p_affine_0_0 + tmp_blending_op_25*0.25 + tmp_blending_op_26*0.25 + tmp_blending_op_27*0.25;
             const real_t tmp_blending_op_193 = -tmp_blending_op_192 - tmp_blending_op_6;
             const real_t tmp_blending_op_194 = p_affine_0_1 + tmp_blending_op_30*0.25 + tmp_blending_op_31*0.25 + tmp_blending_op_32*0.25;
             const real_t tmp_blending_op_195 = -tmp_blending_op_13 - tmp_blending_op_194;
             const real_t tmp_blending_op_196 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_193 - tmp_blending_op_12*tmp_blending_op_191 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_191 - tmp_blending_op_19*tmp_blending_op_193 - tmp_blending_op_195*tmp_blending_op_20 + tmp_blending_op_195*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_197 = -tmp_blending_op_196 + tmp_blending_op_22;
             const real_t tmp_blending_op_198 = -tmp_blending_op_197;
             const real_t tmp_blending_op_199 = (tmp_blending_op_192*tmp_blending_op_192);
             const real_t tmp_blending_op_200 = (tmp_blending_op_194*tmp_blending_op_194);
             const real_t tmp_blending_op_201 = tmp_blending_op_190 + tmp_blending_op_199 + tmp_blending_op_200;
             const real_t tmp_blending_op_202 = tmp_blending_op_189*tmp_blending_op_42;
             const real_t tmp_blending_op_203 = tmp_blending_op_197 + tmp_blending_op_202;
             const real_t tmp_blending_op_204 = tmp_blending_op_190*tmp_blending_op_198 + tmp_blending_op_201*tmp_blending_op_203;
             const real_t tmp_blending_op_205 = pow(tmp_blending_op_201, -1.5000000000000000);
             const real_t tmp_blending_op_206 = tmp_blending_op_205*tmp_blending_op_48;
             const real_t tmp_blending_op_207 = tmp_blending_op_201*tmp_blending_op_51;
             const real_t tmp_blending_op_208 = -tmp_blending_op_194*tmp_blending_op_197 - tmp_blending_op_207;
             const real_t tmp_blending_op_209 = tmp_blending_op_206*tmp_blending_op_208;
             const real_t tmp_blending_op_210 = tmp_blending_op_192*tmp_blending_op_198 + tmp_blending_op_201*tmp_blending_op_56;
             const real_t tmp_blending_op_211 = tmp_blending_op_206*tmp_blending_op_210;
             const real_t tmp_blending_op_212 = tmp_blending_op_189*tmp_blending_op_198;
             const real_t tmp_blending_op_213 = tmp_blending_op_201*tmp_blending_op_42 + tmp_blending_op_212;
             const real_t tmp_blending_op_214 = tmp_blending_op_206*tmp_blending_op_213;
             const real_t tmp_blending_op_215 = tmp_blending_op_194*tmp_blending_op_62 + tmp_blending_op_197;
             const real_t tmp_blending_op_216 = tmp_blending_op_198*tmp_blending_op_200 + tmp_blending_op_201*tmp_blending_op_215;
             const real_t tmp_blending_op_217 = tmp_blending_op_192*tmp_blending_op_56;
             const real_t tmp_blending_op_218 = tmp_blending_op_197 + tmp_blending_op_217;
             const real_t tmp_blending_op_219 = -tmp_blending_op_197*tmp_blending_op_199 + tmp_blending_op_201*tmp_blending_op_218;
             const real_t tmp_blending_op_228 = pow(tmp_blending_op_201, -2.5000000000000000)*tmp_blending_op_227;
             const real_t tmp_blending_op_229 = tmp_blending_op_192*tmp_blending_op_228;
             const real_t tmp_blending_op_232 = tmp_blending_op_192*2.0;
             const real_t tmp_blending_op_234 = tmp_blending_op_196 + tmp_blending_op_233;
             const real_t tmp_blending_op_235 = tmp_blending_op_192*tmp_blending_op_230 + tmp_blending_op_217*2.0 + tmp_blending_op_234;
             const real_t tmp_blending_op_236 = tmp_blending_op_210*tmp_blending_op_229;
             const real_t tmp_blending_op_237 = tmp_blending_op_194*tmp_blending_op_23*tmp_blending_op_55 - tmp_blending_op_232*tmp_blending_op_51;
             const real_t tmp_blending_op_238 = tmp_blending_op_199*tmp_blending_op_228;
             const real_t tmp_blending_op_239 = -tmp_blending_op_201*tmp_blending_op_230;
             const real_t tmp_blending_op_240 = tmp_blending_op_208*tmp_blending_op_229;
             const real_t tmp_blending_op_241 = tmp_blending_op_189*tmp_blending_op_240;
             const real_t tmp_blending_op_242 = tmp_blending_op_189*tmp_blending_op_230 + tmp_blending_op_232*tmp_blending_op_42;
             const real_t tmp_blending_op_243 = tmp_blending_op_213*tmp_blending_op_229;
             const real_t tmp_blending_op_244 = tmp_blending_op_194*tmp_blending_op_243;
             const real_t tmp_blending_op_245 = -tmp_blending_op_207;
             const real_t tmp_blending_op_246 = tmp_blending_op_194*2.0;
             const real_t tmp_blending_op_247 = tmp_blending_op_194*tmp_blending_op_228;
             const real_t tmp_blending_op_248 = tmp_blending_op_206*(tmp_blending_op_192*tmp_blending_op_51 + tmp_blending_op_246*tmp_blending_op_56);
             const real_t tmp_blending_op_249 = tmp_blending_op_200*tmp_blending_op_228;
             const real_t tmp_blending_op_250 = tmp_blending_op_189*tmp_blending_op_247;
             const real_t tmp_blending_op_251 = -tmp_blending_op_210*tmp_blending_op_250;
             const real_t tmp_blending_op_252 = -tmp_blending_op_194*tmp_blending_op_51 - tmp_blending_op_197;
             const real_t tmp_blending_op_254 = tmp_blending_op_189*tmp_blending_op_51;
             const real_t tmp_blending_op_255 = tmp_blending_op_246*tmp_blending_op_42 + tmp_blending_op_254;
             const real_t tmp_blending_op_257 = -tmp_blending_op_201*tmp_blending_op_256;
             const real_t tmp_blending_op_258 = tmp_blending_op_189*2.0;
             const real_t tmp_blending_op_259 = tmp_blending_op_189*tmp_blending_op_228;
             const real_t tmp_blending_op_260 = tmp_blending_op_206*(tmp_blending_op_192*tmp_blending_op_256 + tmp_blending_op_258*tmp_blending_op_56);
             const real_t tmp_blending_op_261 = tmp_blending_op_190*tmp_blending_op_228;
             const real_t tmp_blending_op_262 = tmp_blending_op_206*(tmp_blending_op_194*tmp_blending_op_256 + tmp_blending_op_254*-2.0);
             const real_t tmp_blending_op_263 = tmp_blending_op_189*tmp_blending_op_256 + tmp_blending_op_202*2.0 + tmp_blending_op_234;
             const real_t tmp_blending_op_265 = pow(tmp_blending_op_163, -2.5000000000000000)*tmp_blending_op_227;
             const real_t tmp_blending_op_266 = tmp_blending_op_154*tmp_blending_op_265;
             const real_t tmp_blending_op_267 = tmp_blending_op_154*2.0;
             const real_t tmp_blending_op_268 = tmp_blending_op_158 + tmp_blending_op_233;
             const real_t tmp_blending_op_269 = tmp_blending_op_154*tmp_blending_op_230 + tmp_blending_op_179*2.0 + tmp_blending_op_268;
             const real_t tmp_blending_op_270 = tmp_blending_op_172*tmp_blending_op_266;
             const real_t tmp_blending_op_271 = tmp_blending_op_156*tmp_blending_op_23*tmp_blending_op_55 - tmp_blending_op_267*tmp_blending_op_51;
             const real_t tmp_blending_op_272 = tmp_blending_op_161*tmp_blending_op_265;
             const real_t tmp_blending_op_273 = -tmp_blending_op_163*tmp_blending_op_230;
             const real_t tmp_blending_op_274 = tmp_blending_op_170*tmp_blending_op_266;
             const real_t tmp_blending_op_275 = tmp_blending_op_151*tmp_blending_op_274;
             const real_t tmp_blending_op_276 = tmp_blending_op_151*tmp_blending_op_230 + tmp_blending_op_267*tmp_blending_op_42;
             const real_t tmp_blending_op_277 = tmp_blending_op_175*tmp_blending_op_266;
             const real_t tmp_blending_op_278 = tmp_blending_op_156*tmp_blending_op_277;
             const real_t tmp_blending_op_279 = -tmp_blending_op_169;
             const real_t tmp_blending_op_280 = tmp_blending_op_156*2.0;
             const real_t tmp_blending_op_281 = tmp_blending_op_156*tmp_blending_op_265;
             const real_t tmp_blending_op_282 = tmp_blending_op_168*(tmp_blending_op_154*tmp_blending_op_51 + tmp_blending_op_280*tmp_blending_op_56);
             const real_t tmp_blending_op_283 = tmp_blending_op_162*tmp_blending_op_265;
             const real_t tmp_blending_op_284 = tmp_blending_op_151*tmp_blending_op_281;
             const real_t tmp_blending_op_285 = -tmp_blending_op_172*tmp_blending_op_284;
             const real_t tmp_blending_op_286 = -tmp_blending_op_156*tmp_blending_op_51 - tmp_blending_op_159;
             const real_t tmp_blending_op_287 = tmp_blending_op_151*tmp_blending_op_51;
             const real_t tmp_blending_op_288 = tmp_blending_op_280*tmp_blending_op_42 + tmp_blending_op_287;
             const real_t tmp_blending_op_289 = -tmp_blending_op_163*tmp_blending_op_256;
             const real_t tmp_blending_op_290 = tmp_blending_op_151*2.0;
             const real_t tmp_blending_op_291 = tmp_blending_op_151*tmp_blending_op_265;
             const real_t tmp_blending_op_292 = tmp_blending_op_168*(tmp_blending_op_154*tmp_blending_op_256 + tmp_blending_op_290*tmp_blending_op_56);
             const real_t tmp_blending_op_293 = tmp_blending_op_152*tmp_blending_op_265;
             const real_t tmp_blending_op_294 = tmp_blending_op_168*(tmp_blending_op_156*tmp_blending_op_256 + tmp_blending_op_287*-2.0);
             const real_t tmp_blending_op_295 = tmp_blending_op_151*tmp_blending_op_256 + tmp_blending_op_164*2.0 + tmp_blending_op_268;
             const real_t tmp_blending_op_296 = pow(tmp_blending_op_125, -2.5000000000000000)*tmp_blending_op_227;
             const real_t tmp_blending_op_297 = tmp_blending_op_116*tmp_blending_op_296;
             const real_t tmp_blending_op_298 = tmp_blending_op_116*2.0;
             const real_t tmp_blending_op_299 = tmp_blending_op_120 + tmp_blending_op_233;
             const real_t tmp_blending_op_300 = tmp_blending_op_116*tmp_blending_op_230 + tmp_blending_op_141*2.0 + tmp_blending_op_299;
             const real_t tmp_blending_op_301 = tmp_blending_op_134*tmp_blending_op_297;
             const real_t tmp_blending_op_302 = tmp_blending_op_118*tmp_blending_op_23*tmp_blending_op_55 - tmp_blending_op_298*tmp_blending_op_51;
             const real_t tmp_blending_op_303 = tmp_blending_op_123*tmp_blending_op_296;
             const real_t tmp_blending_op_304 = -tmp_blending_op_125*tmp_blending_op_230;
             const real_t tmp_blending_op_305 = tmp_blending_op_132*tmp_blending_op_297;
             const real_t tmp_blending_op_306 = tmp_blending_op_113*tmp_blending_op_305;
             const real_t tmp_blending_op_307 = tmp_blending_op_113*tmp_blending_op_230 + tmp_blending_op_298*tmp_blending_op_42;
             const real_t tmp_blending_op_308 = tmp_blending_op_137*tmp_blending_op_297;
             const real_t tmp_blending_op_309 = tmp_blending_op_118*tmp_blending_op_308;
             const real_t tmp_blending_op_310 = -tmp_blending_op_131;
             const real_t tmp_blending_op_311 = tmp_blending_op_118*2.0;
             const real_t tmp_blending_op_312 = tmp_blending_op_118*tmp_blending_op_296;
             const real_t tmp_blending_op_313 = tmp_blending_op_130*(tmp_blending_op_116*tmp_blending_op_51 + tmp_blending_op_311*tmp_blending_op_56);
             const real_t tmp_blending_op_314 = tmp_blending_op_124*tmp_blending_op_296;
             const real_t tmp_blending_op_315 = tmp_blending_op_113*tmp_blending_op_312;
             const real_t tmp_blending_op_316 = -tmp_blending_op_134*tmp_blending_op_315;
             const real_t tmp_blending_op_317 = -tmp_blending_op_118*tmp_blending_op_51 - tmp_blending_op_121;
             const real_t tmp_blending_op_318 = tmp_blending_op_113*tmp_blending_op_51;
             const real_t tmp_blending_op_319 = tmp_blending_op_311*tmp_blending_op_42 + tmp_blending_op_318;
             const real_t tmp_blending_op_320 = -tmp_blending_op_125*tmp_blending_op_256;
             const real_t tmp_blending_op_321 = tmp_blending_op_113*2.0;
             const real_t tmp_blending_op_322 = tmp_blending_op_113*tmp_blending_op_296;
             const real_t tmp_blending_op_323 = tmp_blending_op_130*(tmp_blending_op_116*tmp_blending_op_256 + tmp_blending_op_321*tmp_blending_op_56);
             const real_t tmp_blending_op_324 = tmp_blending_op_114*tmp_blending_op_296;
             const real_t tmp_blending_op_325 = tmp_blending_op_130*(tmp_blending_op_118*tmp_blending_op_256 + tmp_blending_op_318*-2.0);
             const real_t tmp_blending_op_326 = tmp_blending_op_113*tmp_blending_op_256 + tmp_blending_op_126*2.0 + tmp_blending_op_299;
             const real_t tmp_blending_op_327 = tmp_blending_op_227*pow(tmp_blending_op_87, -2.5000000000000000);
             const real_t tmp_blending_op_328 = tmp_blending_op_327*tmp_blending_op_78;
             const real_t tmp_blending_op_329 = tmp_blending_op_78*2.0;
             const real_t tmp_blending_op_330 = tmp_blending_op_233 + tmp_blending_op_82;
             const real_t tmp_blending_op_331 = tmp_blending_op_103*2.0 + tmp_blending_op_230*tmp_blending_op_78 + tmp_blending_op_330;
             const real_t tmp_blending_op_332 = tmp_blending_op_328*tmp_blending_op_96;
             const real_t tmp_blending_op_333 = tmp_blending_op_23*tmp_blending_op_55*tmp_blending_op_80 - tmp_blending_op_329*tmp_blending_op_51;
             const real_t tmp_blending_op_334 = tmp_blending_op_327*tmp_blending_op_85;
             const real_t tmp_blending_op_335 = -tmp_blending_op_230*tmp_blending_op_87;
             const real_t tmp_blending_op_336 = tmp_blending_op_328*tmp_blending_op_94;
             const real_t tmp_blending_op_337 = tmp_blending_op_336*tmp_blending_op_75;
             const real_t tmp_blending_op_338 = tmp_blending_op_230*tmp_blending_op_75 + tmp_blending_op_329*tmp_blending_op_42;
             const real_t tmp_blending_op_339 = tmp_blending_op_328*tmp_blending_op_99;
             const real_t tmp_blending_op_340 = tmp_blending_op_339*tmp_blending_op_80;
             const real_t tmp_blending_op_341 = -tmp_blending_op_93;
             const real_t tmp_blending_op_342 = tmp_blending_op_80*2.0;
             const real_t tmp_blending_op_343 = tmp_blending_op_327*tmp_blending_op_80;
             const real_t tmp_blending_op_344 = tmp_blending_op_92*(tmp_blending_op_342*tmp_blending_op_56 + tmp_blending_op_51*tmp_blending_op_78);
             const real_t tmp_blending_op_345 = tmp_blending_op_327*tmp_blending_op_86;
             const real_t tmp_blending_op_346 = tmp_blending_op_343*tmp_blending_op_75;
             const real_t tmp_blending_op_347 = -tmp_blending_op_346*tmp_blending_op_96;
             const real_t tmp_blending_op_348 = -tmp_blending_op_51*tmp_blending_op_80 - tmp_blending_op_83;
             const real_t tmp_blending_op_349 = tmp_blending_op_51*tmp_blending_op_75;
             const real_t tmp_blending_op_350 = tmp_blending_op_342*tmp_blending_op_42 + tmp_blending_op_349;
             const real_t tmp_blending_op_351 = -tmp_blending_op_256*tmp_blending_op_87;
             const real_t tmp_blending_op_352 = tmp_blending_op_75*2.0;
             const real_t tmp_blending_op_353 = tmp_blending_op_327*tmp_blending_op_75;
             const real_t tmp_blending_op_354 = tmp_blending_op_92*(tmp_blending_op_256*tmp_blending_op_78 + tmp_blending_op_352*tmp_blending_op_56);
             const real_t tmp_blending_op_355 = tmp_blending_op_327*tmp_blending_op_76;
             const real_t tmp_blending_op_356 = tmp_blending_op_92*(tmp_blending_op_256*tmp_blending_op_80 + tmp_blending_op_349*-2.0);
             const real_t tmp_blending_op_357 = tmp_blending_op_256*tmp_blending_op_75 + tmp_blending_op_330 + tmp_blending_op_88*2.0;
             const real_t tmp_blending_op_358 = tmp_blending_op_227*pow(tmp_blending_op_40, -2.5000000000000000);
             const real_t tmp_blending_op_359 = tmp_blending_op_28*tmp_blending_op_358;
             const real_t tmp_blending_op_360 = tmp_blending_op_28*2.0;
             const real_t tmp_blending_op_361 = tmp_blending_op_233 + tmp_blending_op_35;
             const real_t tmp_blending_op_362 = tmp_blending_op_230*tmp_blending_op_28 + tmp_blending_op_361 + tmp_blending_op_65*2.0;
             const real_t tmp_blending_op_363 = tmp_blending_op_359*tmp_blending_op_57;
             const real_t tmp_blending_op_364 = tmp_blending_op_23*tmp_blending_op_33*tmp_blending_op_55 - tmp_blending_op_360*tmp_blending_op_51;
             const real_t tmp_blending_op_365 = tmp_blending_op_358*tmp_blending_op_38;
             const real_t tmp_blending_op_366 = -tmp_blending_op_230*tmp_blending_op_40;
             const real_t tmp_blending_op_367 = tmp_blending_op_359*tmp_blending_op_53;
             const real_t tmp_blending_op_368 = tmp_blending_op_3*tmp_blending_op_367;
             const real_t tmp_blending_op_369 = tmp_blending_op_230*tmp_blending_op_3 + tmp_blending_op_360*tmp_blending_op_42;
             const real_t tmp_blending_op_370 = tmp_blending_op_359*tmp_blending_op_60;
             const real_t tmp_blending_op_371 = tmp_blending_op_33*tmp_blending_op_370;
             const real_t tmp_blending_op_372 = -tmp_blending_op_52;
             const real_t tmp_blending_op_373 = tmp_blending_op_33*2.0;
             const real_t tmp_blending_op_374 = tmp_blending_op_33*tmp_blending_op_358;
             const real_t tmp_blending_op_375 = tmp_blending_op_49*(tmp_blending_op_28*tmp_blending_op_51 + tmp_blending_op_373*tmp_blending_op_56);
             const real_t tmp_blending_op_376 = tmp_blending_op_358*tmp_blending_op_39;
             const real_t tmp_blending_op_377 = tmp_blending_op_3*tmp_blending_op_374;
             const real_t tmp_blending_op_378 = -tmp_blending_op_377*tmp_blending_op_57;
             const real_t tmp_blending_op_379 = -tmp_blending_op_33*tmp_blending_op_51 - tmp_blending_op_36;
             const real_t tmp_blending_op_380 = tmp_blending_op_3*tmp_blending_op_51;
             const real_t tmp_blending_op_381 = tmp_blending_op_373*tmp_blending_op_42 + tmp_blending_op_380;
             const real_t tmp_blending_op_382 = -tmp_blending_op_256*tmp_blending_op_40;
             const real_t tmp_blending_op_383 = tmp_blending_op_3*2.0;
             const real_t tmp_blending_op_384 = tmp_blending_op_3*tmp_blending_op_358;
             const real_t tmp_blending_op_385 = tmp_blending_op_49*(tmp_blending_op_256*tmp_blending_op_28 + tmp_blending_op_383*tmp_blending_op_56);
             const real_t tmp_blending_op_386 = tmp_blending_op_358*tmp_blending_op_4;
             const real_t tmp_blending_op_387 = tmp_blending_op_49*(tmp_blending_op_256*tmp_blending_op_33 + tmp_blending_op_380*-2.0);
             const real_t tmp_blending_op_388 = tmp_blending_op_256*tmp_blending_op_3 + tmp_blending_op_361 + tmp_blending_op_43*2.0;
             const real_t jac_blending_2_2_q_4 = tmp_blending_op_45*tmp_blending_op_49;
             const real_t jac_blending_2_1_q_4 = tmp_blending_op_3*tmp_blending_op_54;
             const real_t jac_blending_2_0_q_4 = tmp_blending_op_3*tmp_blending_op_58;
             const real_t jac_blending_1_2_q_4 = tmp_blending_op_33*tmp_blending_op_61;
             const real_t jac_blending_1_1_q_4 = tmp_blending_op_49*tmp_blending_op_64;
             const real_t tmp_blending_op_72 = jac_blending_1_1_q_4*jac_blending_2_0_q_4;
             const real_t jac_blending_1_0_q_4 = tmp_blending_op_33*tmp_blending_op_58;
             const real_t tmp_blending_op_69 = jac_blending_1_0_q_4*jac_blending_2_1_q_4;
             const real_t jac_blending_0_2_q_4 = tmp_blending_op_28*tmp_blending_op_61;
             const real_t jac_blending_0_1_q_4 = tmp_blending_op_28*tmp_blending_op_54;
             const real_t tmp_blending_op_71 = jac_blending_0_1_q_4*jac_blending_1_0_q_4;
             const real_t jac_blending_0_0_q_4 = tmp_blending_op_49*tmp_blending_op_67;
             const real_t tmp_blending_op_68 = jac_blending_0_0_q_4*jac_blending_1_1_q_4;
             const real_t tmp_blending_op_70 = jac_blending_0_0_q_4*jac_blending_2_1_q_4;
             const real_t tmp_blending_op_73 = jac_blending_0_1_q_4*jac_blending_1_2_q_4*jac_blending_2_0_q_4 + jac_blending_0_2_q_4*tmp_blending_op_69 - jac_blending_0_2_q_4*tmp_blending_op_72 - jac_blending_1_2_q_4*tmp_blending_op_70 + jac_blending_2_2_q_4*tmp_blending_op_68 - jac_blending_2_2_q_4*tmp_blending_op_71;
             const real_t tmp_blending_op_74 = 1.0 / (tmp_blending_op_73);
             const real_t abs_det_jac_blending_q_4 = tmp_blending_op_73;
             const real_t jac_blending_inv_2_2_q_4 = tmp_blending_op_74*(tmp_blending_op_68 - tmp_blending_op_71);
             const real_t jac_blending_inv_2_1_q_4 = tmp_blending_op_74*(jac_blending_0_1_q_4*jac_blending_2_0_q_4 - tmp_blending_op_70);
             const real_t jac_blending_inv_2_0_q_4 = tmp_blending_op_74*(tmp_blending_op_69 - tmp_blending_op_72);
             const real_t jac_blending_inv_1_2_q_4 = tmp_blending_op_74*(-jac_blending_0_0_q_4*jac_blending_1_2_q_4 + jac_blending_0_2_q_4*jac_blending_1_0_q_4);
             const real_t jac_blending_inv_1_1_q_4 = tmp_blending_op_74*(jac_blending_0_0_q_4*jac_blending_2_2_q_4 - jac_blending_0_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_1_0_q_4 = tmp_blending_op_74*(-jac_blending_1_0_q_4*jac_blending_2_2_q_4 + jac_blending_1_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_0_2_q_4 = tmp_blending_op_74*(jac_blending_0_1_q_4*jac_blending_1_2_q_4 - jac_blending_0_2_q_4*jac_blending_1_1_q_4);
             const real_t jac_blending_inv_0_1_q_4 = tmp_blending_op_74*(-jac_blending_0_1_q_4*jac_blending_2_2_q_4 + jac_blending_0_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_inv_0_0_q_4 = tmp_blending_op_74*(jac_blending_1_1_q_4*jac_blending_2_2_q_4 - jac_blending_1_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_2_2_q_3 = tmp_blending_op_90*tmp_blending_op_92;
             const real_t jac_blending_2_1_q_3 = tmp_blending_op_75*tmp_blending_op_95;
             const real_t jac_blending_2_0_q_3 = tmp_blending_op_75*tmp_blending_op_97;
             const real_t jac_blending_1_2_q_3 = tmp_blending_op_100*tmp_blending_op_80;
             const real_t jac_blending_1_1_q_3 = tmp_blending_op_102*tmp_blending_op_92;
             const real_t tmp_blending_op_110 = jac_blending_1_1_q_3*jac_blending_2_0_q_3;
             const real_t jac_blending_1_0_q_3 = tmp_blending_op_80*tmp_blending_op_97;
             const real_t tmp_blending_op_107 = jac_blending_1_0_q_3*jac_blending_2_1_q_3;
             const real_t jac_blending_0_2_q_3 = tmp_blending_op_100*tmp_blending_op_78;
             const real_t jac_blending_0_1_q_3 = tmp_blending_op_78*tmp_blending_op_95;
             const real_t tmp_blending_op_109 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
             const real_t jac_blending_0_0_q_3 = tmp_blending_op_105*tmp_blending_op_92;
             const real_t tmp_blending_op_106 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
             const real_t tmp_blending_op_108 = jac_blending_0_0_q_3*jac_blending_2_1_q_3;
             const real_t tmp_blending_op_111 = jac_blending_0_1_q_3*jac_blending_1_2_q_3*jac_blending_2_0_q_3 + jac_blending_0_2_q_3*tmp_blending_op_107 - jac_blending_0_2_q_3*tmp_blending_op_110 - jac_blending_1_2_q_3*tmp_blending_op_108 + jac_blending_2_2_q_3*tmp_blending_op_106 - jac_blending_2_2_q_3*tmp_blending_op_109;
             const real_t tmp_blending_op_112 = 1.0 / (tmp_blending_op_111);
             const real_t abs_det_jac_blending_q_3 = tmp_blending_op_111;
             const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_112*(tmp_blending_op_106 - tmp_blending_op_109);
             const real_t jac_blending_inv_2_1_q_3 = tmp_blending_op_112*(jac_blending_0_1_q_3*jac_blending_2_0_q_3 - tmp_blending_op_108);
             const real_t jac_blending_inv_2_0_q_3 = tmp_blending_op_112*(tmp_blending_op_107 - tmp_blending_op_110);
             const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_112*(-jac_blending_0_0_q_3*jac_blending_1_2_q_3 + jac_blending_0_2_q_3*jac_blending_1_0_q_3);
             const real_t jac_blending_inv_1_1_q_3 = tmp_blending_op_112*(jac_blending_0_0_q_3*jac_blending_2_2_q_3 - jac_blending_0_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_1_0_q_3 = tmp_blending_op_112*(-jac_blending_1_0_q_3*jac_blending_2_2_q_3 + jac_blending_1_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_112*(jac_blending_0_1_q_3*jac_blending_1_2_q_3 - jac_blending_0_2_q_3*jac_blending_1_1_q_3);
             const real_t jac_blending_inv_0_1_q_3 = tmp_blending_op_112*(-jac_blending_0_1_q_3*jac_blending_2_2_q_3 + jac_blending_0_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_inv_0_0_q_3 = tmp_blending_op_112*(jac_blending_1_1_q_3*jac_blending_2_2_q_3 - jac_blending_1_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_2_2_q_2 = tmp_blending_op_128*tmp_blending_op_130;
             const real_t jac_blending_2_1_q_2 = tmp_blending_op_113*tmp_blending_op_133;
             const real_t jac_blending_2_0_q_2 = tmp_blending_op_113*tmp_blending_op_135;
             const real_t jac_blending_1_2_q_2 = tmp_blending_op_118*tmp_blending_op_138;
             const real_t jac_blending_1_1_q_2 = tmp_blending_op_130*tmp_blending_op_140;
             const real_t tmp_blending_op_148 = jac_blending_1_1_q_2*jac_blending_2_0_q_2;
             const real_t jac_blending_1_0_q_2 = tmp_blending_op_118*tmp_blending_op_135;
             const real_t tmp_blending_op_145 = jac_blending_1_0_q_2*jac_blending_2_1_q_2;
             const real_t jac_blending_0_2_q_2 = tmp_blending_op_116*tmp_blending_op_138;
             const real_t jac_blending_0_1_q_2 = tmp_blending_op_116*tmp_blending_op_133;
             const real_t tmp_blending_op_147 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
             const real_t jac_blending_0_0_q_2 = tmp_blending_op_130*tmp_blending_op_143;
             const real_t tmp_blending_op_144 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
             const real_t tmp_blending_op_146 = jac_blending_0_0_q_2*jac_blending_2_1_q_2;
             const real_t tmp_blending_op_149 = jac_blending_0_1_q_2*jac_blending_1_2_q_2*jac_blending_2_0_q_2 + jac_blending_0_2_q_2*tmp_blending_op_145 - jac_blending_0_2_q_2*tmp_blending_op_148 - jac_blending_1_2_q_2*tmp_blending_op_146 + jac_blending_2_2_q_2*tmp_blending_op_144 - jac_blending_2_2_q_2*tmp_blending_op_147;
             const real_t tmp_blending_op_150 = 1.0 / (tmp_blending_op_149);
             const real_t abs_det_jac_blending_q_2 = tmp_blending_op_149;
             const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_150*(tmp_blending_op_144 - tmp_blending_op_147);
             const real_t jac_blending_inv_2_1_q_2 = tmp_blending_op_150*(jac_blending_0_1_q_2*jac_blending_2_0_q_2 - tmp_blending_op_146);
             const real_t jac_blending_inv_2_0_q_2 = tmp_blending_op_150*(tmp_blending_op_145 - tmp_blending_op_148);
             const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_150*(-jac_blending_0_0_q_2*jac_blending_1_2_q_2 + jac_blending_0_2_q_2*jac_blending_1_0_q_2);
             const real_t jac_blending_inv_1_1_q_2 = tmp_blending_op_150*(jac_blending_0_0_q_2*jac_blending_2_2_q_2 - jac_blending_0_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_1_0_q_2 = tmp_blending_op_150*(-jac_blending_1_0_q_2*jac_blending_2_2_q_2 + jac_blending_1_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_150*(jac_blending_0_1_q_2*jac_blending_1_2_q_2 - jac_blending_0_2_q_2*jac_blending_1_1_q_2);
             const real_t jac_blending_inv_0_1_q_2 = tmp_blending_op_150*(-jac_blending_0_1_q_2*jac_blending_2_2_q_2 + jac_blending_0_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_inv_0_0_q_2 = tmp_blending_op_150*(jac_blending_1_1_q_2*jac_blending_2_2_q_2 - jac_blending_1_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_2_2_q_1 = tmp_blending_op_166*tmp_blending_op_168;
             const real_t jac_blending_2_1_q_1 = tmp_blending_op_151*tmp_blending_op_171;
             const real_t jac_blending_2_0_q_1 = tmp_blending_op_151*tmp_blending_op_173;
             const real_t jac_blending_1_2_q_1 = tmp_blending_op_156*tmp_blending_op_176;
             const real_t jac_blending_1_1_q_1 = tmp_blending_op_168*tmp_blending_op_178;
             const real_t tmp_blending_op_186 = jac_blending_1_1_q_1*jac_blending_2_0_q_1;
             const real_t jac_blending_1_0_q_1 = tmp_blending_op_156*tmp_blending_op_173;
             const real_t tmp_blending_op_183 = jac_blending_1_0_q_1*jac_blending_2_1_q_1;
             const real_t jac_blending_0_2_q_1 = tmp_blending_op_154*tmp_blending_op_176;
             const real_t jac_blending_0_1_q_1 = tmp_blending_op_154*tmp_blending_op_171;
             const real_t tmp_blending_op_185 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
             const real_t jac_blending_0_0_q_1 = tmp_blending_op_168*tmp_blending_op_181;
             const real_t tmp_blending_op_182 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
             const real_t tmp_blending_op_184 = jac_blending_0_0_q_1*jac_blending_2_1_q_1;
             const real_t tmp_blending_op_187 = jac_blending_0_1_q_1*jac_blending_1_2_q_1*jac_blending_2_0_q_1 + jac_blending_0_2_q_1*tmp_blending_op_183 - jac_blending_0_2_q_1*tmp_blending_op_186 - jac_blending_1_2_q_1*tmp_blending_op_184 + jac_blending_2_2_q_1*tmp_blending_op_182 - jac_blending_2_2_q_1*tmp_blending_op_185;
             const real_t tmp_blending_op_188 = 1.0 / (tmp_blending_op_187);
             const real_t abs_det_jac_blending_q_1 = tmp_blending_op_187;
             const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_188*(tmp_blending_op_182 - tmp_blending_op_185);
             const real_t jac_blending_inv_2_1_q_1 = tmp_blending_op_188*(jac_blending_0_1_q_1*jac_blending_2_0_q_1 - tmp_blending_op_184);
             const real_t jac_blending_inv_2_0_q_1 = tmp_blending_op_188*(tmp_blending_op_183 - tmp_blending_op_186);
             const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_188*(-jac_blending_0_0_q_1*jac_blending_1_2_q_1 + jac_blending_0_2_q_1*jac_blending_1_0_q_1);
             const real_t jac_blending_inv_1_1_q_1 = tmp_blending_op_188*(jac_blending_0_0_q_1*jac_blending_2_2_q_1 - jac_blending_0_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_1_0_q_1 = tmp_blending_op_188*(-jac_blending_1_0_q_1*jac_blending_2_2_q_1 + jac_blending_1_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_188*(jac_blending_0_1_q_1*jac_blending_1_2_q_1 - jac_blending_0_2_q_1*jac_blending_1_1_q_1);
             const real_t jac_blending_inv_0_1_q_1 = tmp_blending_op_188*(-jac_blending_0_1_q_1*jac_blending_2_2_q_1 + jac_blending_0_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_inv_0_0_q_1 = tmp_blending_op_188*(jac_blending_1_1_q_1*jac_blending_2_2_q_1 - jac_blending_1_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_2_2_q_0 = tmp_blending_op_204*tmp_blending_op_206;
             const real_t jac_blending_2_1_q_0 = tmp_blending_op_189*tmp_blending_op_209;
             const real_t jac_blending_2_0_q_0 = tmp_blending_op_189*tmp_blending_op_211;
             const real_t jac_blending_1_2_q_0 = tmp_blending_op_194*tmp_blending_op_214;
             const real_t jac_blending_1_1_q_0 = tmp_blending_op_206*tmp_blending_op_216;
             const real_t tmp_blending_op_224 = jac_blending_1_1_q_0*jac_blending_2_0_q_0;
             const real_t jac_blending_1_0_q_0 = tmp_blending_op_194*tmp_blending_op_211;
             const real_t tmp_blending_op_221 = jac_blending_1_0_q_0*jac_blending_2_1_q_0;
             const real_t jac_blending_0_2_q_0 = tmp_blending_op_192*tmp_blending_op_214;
             const real_t jac_blending_0_1_q_0 = tmp_blending_op_192*tmp_blending_op_209;
             const real_t tmp_blending_op_223 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
             const real_t jac_blending_0_0_q_0 = tmp_blending_op_206*tmp_blending_op_219;
             const real_t tmp_blending_op_220 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
             const real_t tmp_blending_op_222 = jac_blending_0_0_q_0*jac_blending_2_1_q_0;
             const real_t tmp_blending_op_225 = jac_blending_0_1_q_0*jac_blending_1_2_q_0*jac_blending_2_0_q_0 + jac_blending_0_2_q_0*tmp_blending_op_221 - jac_blending_0_2_q_0*tmp_blending_op_224 - jac_blending_1_2_q_0*tmp_blending_op_222 + jac_blending_2_2_q_0*tmp_blending_op_220 - jac_blending_2_2_q_0*tmp_blending_op_223;
             const real_t tmp_blending_op_226 = 1.0 / (tmp_blending_op_225);
             const real_t abs_det_jac_blending_q_0 = tmp_blending_op_225;
             const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_226*(tmp_blending_op_220 - tmp_blending_op_223);
             const real_t jac_blending_inv_2_1_q_0 = tmp_blending_op_226*(jac_blending_0_1_q_0*jac_blending_2_0_q_0 - tmp_blending_op_222);
             const real_t jac_blending_inv_2_0_q_0 = tmp_blending_op_226*(tmp_blending_op_221 - tmp_blending_op_224);
             const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_226*(-jac_blending_0_0_q_0*jac_blending_1_2_q_0 + jac_blending_0_2_q_0*jac_blending_1_0_q_0);
             const real_t jac_blending_inv_1_1_q_0 = tmp_blending_op_226*(jac_blending_0_0_q_0*jac_blending_2_2_q_0 - jac_blending_0_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_1_0_q_0 = tmp_blending_op_226*(-jac_blending_1_0_q_0*jac_blending_2_2_q_0 + jac_blending_1_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_226*(jac_blending_0_1_q_0*jac_blending_1_2_q_0 - jac_blending_0_2_q_0*jac_blending_1_1_q_0);
             const real_t jac_blending_inv_0_1_q_0 = tmp_blending_op_226*(-jac_blending_0_1_q_0*jac_blending_2_2_q_0 + jac_blending_0_2_q_0*jac_blending_2_1_q_0);
             const real_t jac_blending_inv_0_0_q_0 = tmp_blending_op_226*(jac_blending_1_1_q_0*jac_blending_2_2_q_0 - jac_blending_1_2_q_0*jac_blending_2_1_q_0);
             const real_t hessian_blending_0_0_0_q_0 = tmp_blending_op_205*tmp_blending_op_47*(-tmp_blending_op_197*tmp_blending_op_232 + tmp_blending_op_199*tmp_blending_op_230 + tmp_blending_op_201*tmp_blending_op_231 + tmp_blending_op_218*tmp_blending_op_232)*1.0 - tmp_blending_op_219*tmp_blending_op_229;
             const real_t hessian_blending_0_0_1_q_0 = tmp_blending_op_194*tmp_blending_op_205*tmp_blending_op_235*tmp_blending_op_47*1.0 - tmp_blending_op_194*tmp_blending_op_236;
             const real_t hessian_blending_0_0_2_q_0 = tmp_blending_op_189*tmp_blending_op_205*tmp_blending_op_235*tmp_blending_op_47*1.0 - tmp_blending_op_189*tmp_blending_op_236;
             const real_t hessian_blending_0_1_0_q_0 = tmp_blending_op_192*tmp_blending_op_206*tmp_blending_op_237 - tmp_blending_op_208*tmp_blending_op_238 + tmp_blending_op_209;
             const real_t hessian_blending_0_1_1_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_200*tmp_blending_op_230 + tmp_blending_op_215*tmp_blending_op_232 + tmp_blending_op_239)*1.0 - tmp_blending_op_216*tmp_blending_op_229;
             const real_t hessian_blending_0_1_2_q_0 = tmp_blending_op_189*tmp_blending_op_205*tmp_blending_op_237*tmp_blending_op_47*1.0 - tmp_blending_op_241;
             const real_t hessian_blending_0_2_0_q_0 = tmp_blending_op_192*tmp_blending_op_206*tmp_blending_op_242 - tmp_blending_op_213*tmp_blending_op_238 + tmp_blending_op_214;
             const real_t hessian_blending_0_2_1_q_0 = tmp_blending_op_194*tmp_blending_op_205*tmp_blending_op_242*tmp_blending_op_47*1.0 - tmp_blending_op_244;
             const real_t hessian_blending_0_2_2_q_0 = -tmp_blending_op_204*tmp_blending_op_229 + tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_190*tmp_blending_op_230 + tmp_blending_op_203*tmp_blending_op_232 + tmp_blending_op_239)*1.0;
             const real_t hessian_blending_1_0_0_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_199*tmp_blending_op_51 + tmp_blending_op_218*tmp_blending_op_246 + tmp_blending_op_245)*1.0 - tmp_blending_op_219*tmp_blending_op_247;
             const real_t hessian_blending_1_0_1_q_0 = tmp_blending_op_194*tmp_blending_op_248 - tmp_blending_op_210*tmp_blending_op_249 + tmp_blending_op_211;
             const real_t hessian_blending_1_0_2_q_0 = tmp_blending_op_189*tmp_blending_op_248 + tmp_blending_op_251;
             const real_t hessian_blending_1_1_0_q_0 = tmp_blending_op_192*tmp_blending_op_205*tmp_blending_op_252*tmp_blending_op_47*1.0 - tmp_blending_op_194*tmp_blending_op_240;
             const real_t hessian_blending_1_1_1_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_198*tmp_blending_op_246 + tmp_blending_op_200*tmp_blending_op_51 + tmp_blending_op_201*tmp_blending_op_253 + tmp_blending_op_215*tmp_blending_op_246)*1.0 - tmp_blending_op_216*tmp_blending_op_247;
             const real_t hessian_blending_1_1_2_q_0 = tmp_blending_op_189*tmp_blending_op_205*tmp_blending_op_252*tmp_blending_op_47*1.0 - tmp_blending_op_208*tmp_blending_op_250;
             const real_t hessian_blending_1_2_0_q_0 = tmp_blending_op_192*tmp_blending_op_205*tmp_blending_op_255*tmp_blending_op_47*1.0 - tmp_blending_op_244;
             const real_t hessian_blending_1_2_1_q_0 = tmp_blending_op_194*tmp_blending_op_206*tmp_blending_op_255 - tmp_blending_op_213*tmp_blending_op_249 + tmp_blending_op_214;
             const real_t hessian_blending_1_2_2_q_0 = -tmp_blending_op_204*tmp_blending_op_247 + tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_190*tmp_blending_op_51 + tmp_blending_op_203*tmp_blending_op_246 + tmp_blending_op_245)*1.0;
             const real_t hessian_blending_2_0_0_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_199*tmp_blending_op_256 + tmp_blending_op_218*tmp_blending_op_258 + tmp_blending_op_257)*1.0 - tmp_blending_op_219*tmp_blending_op_259;
             const real_t hessian_blending_2_0_1_q_0 = tmp_blending_op_194*tmp_blending_op_260 + tmp_blending_op_251;
             const real_t hessian_blending_2_0_2_q_0 = tmp_blending_op_189*tmp_blending_op_260 - tmp_blending_op_210*tmp_blending_op_261 + tmp_blending_op_211;
             const real_t hessian_blending_2_1_0_q_0 = tmp_blending_op_192*tmp_blending_op_262 - tmp_blending_op_241;
             const real_t hessian_blending_2_1_1_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_200*tmp_blending_op_256 + tmp_blending_op_215*tmp_blending_op_258 + tmp_blending_op_257)*1.0 - tmp_blending_op_216*tmp_blending_op_259;
             const real_t hessian_blending_2_1_2_q_0 = tmp_blending_op_189*tmp_blending_op_262 - tmp_blending_op_208*tmp_blending_op_261 + tmp_blending_op_209;
             const real_t hessian_blending_2_2_0_q_0 = -tmp_blending_op_189*tmp_blending_op_243 + tmp_blending_op_192*tmp_blending_op_205*tmp_blending_op_263*tmp_blending_op_47*1.0;
             const real_t hessian_blending_2_2_1_q_0 = tmp_blending_op_194*tmp_blending_op_205*tmp_blending_op_263*tmp_blending_op_47*1.0 - tmp_blending_op_213*tmp_blending_op_250;
             const real_t hessian_blending_2_2_2_q_0 = -tmp_blending_op_204*tmp_blending_op_259 + tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_190*tmp_blending_op_256 + tmp_blending_op_201*tmp_blending_op_264 + tmp_blending_op_203*tmp_blending_op_258 + tmp_blending_op_212*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_1 = tmp_blending_op_167*tmp_blending_op_47*(-tmp_blending_op_159*tmp_blending_op_267 + tmp_blending_op_161*tmp_blending_op_230 + tmp_blending_op_163*tmp_blending_op_231 + tmp_blending_op_180*tmp_blending_op_267)*1.0 - tmp_blending_op_181*tmp_blending_op_266;
             const real_t hessian_blending_0_0_1_q_1 = tmp_blending_op_156*tmp_blending_op_167*tmp_blending_op_269*tmp_blending_op_47*1.0 - tmp_blending_op_156*tmp_blending_op_270;
             const real_t hessian_blending_0_0_2_q_1 = tmp_blending_op_151*tmp_blending_op_167*tmp_blending_op_269*tmp_blending_op_47*1.0 - tmp_blending_op_151*tmp_blending_op_270;
             const real_t hessian_blending_0_1_0_q_1 = tmp_blending_op_154*tmp_blending_op_168*tmp_blending_op_271 - tmp_blending_op_170*tmp_blending_op_272 + tmp_blending_op_171;
             const real_t hessian_blending_0_1_1_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_162*tmp_blending_op_230 + tmp_blending_op_177*tmp_blending_op_267 + tmp_blending_op_273)*1.0 - tmp_blending_op_178*tmp_blending_op_266;
             const real_t hessian_blending_0_1_2_q_1 = tmp_blending_op_151*tmp_blending_op_167*tmp_blending_op_271*tmp_blending_op_47*1.0 - tmp_blending_op_275;
             const real_t hessian_blending_0_2_0_q_1 = tmp_blending_op_154*tmp_blending_op_168*tmp_blending_op_276 - tmp_blending_op_175*tmp_blending_op_272 + tmp_blending_op_176;
             const real_t hessian_blending_0_2_1_q_1 = tmp_blending_op_156*tmp_blending_op_167*tmp_blending_op_276*tmp_blending_op_47*1.0 - tmp_blending_op_278;
             const real_t hessian_blending_0_2_2_q_1 = -tmp_blending_op_166*tmp_blending_op_266 + tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_152*tmp_blending_op_230 + tmp_blending_op_165*tmp_blending_op_267 + tmp_blending_op_273)*1.0;
             const real_t hessian_blending_1_0_0_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_161*tmp_blending_op_51 + tmp_blending_op_180*tmp_blending_op_280 + tmp_blending_op_279)*1.0 - tmp_blending_op_181*tmp_blending_op_281;
             const real_t hessian_blending_1_0_1_q_1 = tmp_blending_op_156*tmp_blending_op_282 - tmp_blending_op_172*tmp_blending_op_283 + tmp_blending_op_173;
             const real_t hessian_blending_1_0_2_q_1 = tmp_blending_op_151*tmp_blending_op_282 + tmp_blending_op_285;
             const real_t hessian_blending_1_1_0_q_1 = tmp_blending_op_154*tmp_blending_op_167*tmp_blending_op_286*tmp_blending_op_47*1.0 - tmp_blending_op_156*tmp_blending_op_274;
             const real_t hessian_blending_1_1_1_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_160*tmp_blending_op_280 + tmp_blending_op_162*tmp_blending_op_51 + tmp_blending_op_163*tmp_blending_op_253 + tmp_blending_op_177*tmp_blending_op_280)*1.0 - tmp_blending_op_178*tmp_blending_op_281;
             const real_t hessian_blending_1_1_2_q_1 = tmp_blending_op_151*tmp_blending_op_167*tmp_blending_op_286*tmp_blending_op_47*1.0 - tmp_blending_op_170*tmp_blending_op_284;
             const real_t hessian_blending_1_2_0_q_1 = tmp_blending_op_154*tmp_blending_op_167*tmp_blending_op_288*tmp_blending_op_47*1.0 - tmp_blending_op_278;
             const real_t hessian_blending_1_2_1_q_1 = tmp_blending_op_156*tmp_blending_op_168*tmp_blending_op_288 - tmp_blending_op_175*tmp_blending_op_283 + tmp_blending_op_176;
             const real_t hessian_blending_1_2_2_q_1 = -tmp_blending_op_166*tmp_blending_op_281 + tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_152*tmp_blending_op_51 + tmp_blending_op_165*tmp_blending_op_280 + tmp_blending_op_279)*1.0;
             const real_t hessian_blending_2_0_0_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_161*tmp_blending_op_256 + tmp_blending_op_180*tmp_blending_op_290 + tmp_blending_op_289)*1.0 - tmp_blending_op_181*tmp_blending_op_291;
             const real_t hessian_blending_2_0_1_q_1 = tmp_blending_op_156*tmp_blending_op_292 + tmp_blending_op_285;
             const real_t hessian_blending_2_0_2_q_1 = tmp_blending_op_151*tmp_blending_op_292 - tmp_blending_op_172*tmp_blending_op_293 + tmp_blending_op_173;
             const real_t hessian_blending_2_1_0_q_1 = tmp_blending_op_154*tmp_blending_op_294 - tmp_blending_op_275;
             const real_t hessian_blending_2_1_1_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_162*tmp_blending_op_256 + tmp_blending_op_177*tmp_blending_op_290 + tmp_blending_op_289)*1.0 - tmp_blending_op_178*tmp_blending_op_291;
             const real_t hessian_blending_2_1_2_q_1 = tmp_blending_op_151*tmp_blending_op_294 - tmp_blending_op_170*tmp_blending_op_293 + tmp_blending_op_171;
             const real_t hessian_blending_2_2_0_q_1 = -tmp_blending_op_151*tmp_blending_op_277 + tmp_blending_op_154*tmp_blending_op_167*tmp_blending_op_295*tmp_blending_op_47*1.0;
             const real_t hessian_blending_2_2_1_q_1 = tmp_blending_op_156*tmp_blending_op_167*tmp_blending_op_295*tmp_blending_op_47*1.0 - tmp_blending_op_175*tmp_blending_op_284;
             const real_t hessian_blending_2_2_2_q_1 = -tmp_blending_op_166*tmp_blending_op_291 + tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_152*tmp_blending_op_256 + tmp_blending_op_163*tmp_blending_op_264 + tmp_blending_op_165*tmp_blending_op_290 + tmp_blending_op_174*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_2 = tmp_blending_op_129*tmp_blending_op_47*(-tmp_blending_op_121*tmp_blending_op_298 + tmp_blending_op_123*tmp_blending_op_230 + tmp_blending_op_125*tmp_blending_op_231 + tmp_blending_op_142*tmp_blending_op_298)*1.0 - tmp_blending_op_143*tmp_blending_op_297;
             const real_t hessian_blending_0_0_1_q_2 = tmp_blending_op_118*tmp_blending_op_129*tmp_blending_op_300*tmp_blending_op_47*1.0 - tmp_blending_op_118*tmp_blending_op_301;
             const real_t hessian_blending_0_0_2_q_2 = tmp_blending_op_113*tmp_blending_op_129*tmp_blending_op_300*tmp_blending_op_47*1.0 - tmp_blending_op_113*tmp_blending_op_301;
             const real_t hessian_blending_0_1_0_q_2 = tmp_blending_op_116*tmp_blending_op_130*tmp_blending_op_302 - tmp_blending_op_132*tmp_blending_op_303 + tmp_blending_op_133;
             const real_t hessian_blending_0_1_1_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_124*tmp_blending_op_230 + tmp_blending_op_139*tmp_blending_op_298 + tmp_blending_op_304)*1.0 - tmp_blending_op_140*tmp_blending_op_297;
             const real_t hessian_blending_0_1_2_q_2 = tmp_blending_op_113*tmp_blending_op_129*tmp_blending_op_302*tmp_blending_op_47*1.0 - tmp_blending_op_306;
             const real_t hessian_blending_0_2_0_q_2 = tmp_blending_op_116*tmp_blending_op_130*tmp_blending_op_307 - tmp_blending_op_137*tmp_blending_op_303 + tmp_blending_op_138;
             const real_t hessian_blending_0_2_1_q_2 = tmp_blending_op_118*tmp_blending_op_129*tmp_blending_op_307*tmp_blending_op_47*1.0 - tmp_blending_op_309;
             const real_t hessian_blending_0_2_2_q_2 = -tmp_blending_op_128*tmp_blending_op_297 + tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_114*tmp_blending_op_230 + tmp_blending_op_127*tmp_blending_op_298 + tmp_blending_op_304)*1.0;
             const real_t hessian_blending_1_0_0_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_123*tmp_blending_op_51 + tmp_blending_op_142*tmp_blending_op_311 + tmp_blending_op_310)*1.0 - tmp_blending_op_143*tmp_blending_op_312;
             const real_t hessian_blending_1_0_1_q_2 = tmp_blending_op_118*tmp_blending_op_313 - tmp_blending_op_134*tmp_blending_op_314 + tmp_blending_op_135;
             const real_t hessian_blending_1_0_2_q_2 = tmp_blending_op_113*tmp_blending_op_313 + tmp_blending_op_316;
             const real_t hessian_blending_1_1_0_q_2 = tmp_blending_op_116*tmp_blending_op_129*tmp_blending_op_317*tmp_blending_op_47*1.0 - tmp_blending_op_118*tmp_blending_op_305;
             const real_t hessian_blending_1_1_1_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_122*tmp_blending_op_311 + tmp_blending_op_124*tmp_blending_op_51 + tmp_blending_op_125*tmp_blending_op_253 + tmp_blending_op_139*tmp_blending_op_311)*1.0 - tmp_blending_op_140*tmp_blending_op_312;
             const real_t hessian_blending_1_1_2_q_2 = tmp_blending_op_113*tmp_blending_op_129*tmp_blending_op_317*tmp_blending_op_47*1.0 - tmp_blending_op_132*tmp_blending_op_315;
             const real_t hessian_blending_1_2_0_q_2 = tmp_blending_op_116*tmp_blending_op_129*tmp_blending_op_319*tmp_blending_op_47*1.0 - tmp_blending_op_309;
             const real_t hessian_blending_1_2_1_q_2 = tmp_blending_op_118*tmp_blending_op_130*tmp_blending_op_319 - tmp_blending_op_137*tmp_blending_op_314 + tmp_blending_op_138;
             const real_t hessian_blending_1_2_2_q_2 = -tmp_blending_op_128*tmp_blending_op_312 + tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_114*tmp_blending_op_51 + tmp_blending_op_127*tmp_blending_op_311 + tmp_blending_op_310)*1.0;
             const real_t hessian_blending_2_0_0_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_123*tmp_blending_op_256 + tmp_blending_op_142*tmp_blending_op_321 + tmp_blending_op_320)*1.0 - tmp_blending_op_143*tmp_blending_op_322;
             const real_t hessian_blending_2_0_1_q_2 = tmp_blending_op_118*tmp_blending_op_323 + tmp_blending_op_316;
             const real_t hessian_blending_2_0_2_q_2 = tmp_blending_op_113*tmp_blending_op_323 - tmp_blending_op_134*tmp_blending_op_324 + tmp_blending_op_135;
             const real_t hessian_blending_2_1_0_q_2 = tmp_blending_op_116*tmp_blending_op_325 - tmp_blending_op_306;
             const real_t hessian_blending_2_1_1_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_124*tmp_blending_op_256 + tmp_blending_op_139*tmp_blending_op_321 + tmp_blending_op_320)*1.0 - tmp_blending_op_140*tmp_blending_op_322;
             const real_t hessian_blending_2_1_2_q_2 = tmp_blending_op_113*tmp_blending_op_325 - tmp_blending_op_132*tmp_blending_op_324 + tmp_blending_op_133;
             const real_t hessian_blending_2_2_0_q_2 = -tmp_blending_op_113*tmp_blending_op_308 + tmp_blending_op_116*tmp_blending_op_129*tmp_blending_op_326*tmp_blending_op_47*1.0;
             const real_t hessian_blending_2_2_1_q_2 = tmp_blending_op_118*tmp_blending_op_129*tmp_blending_op_326*tmp_blending_op_47*1.0 - tmp_blending_op_137*tmp_blending_op_315;
             const real_t hessian_blending_2_2_2_q_2 = -tmp_blending_op_128*tmp_blending_op_322 + tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_114*tmp_blending_op_256 + tmp_blending_op_125*tmp_blending_op_264 + tmp_blending_op_127*tmp_blending_op_321 + tmp_blending_op_136*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_3 = -tmp_blending_op_105*tmp_blending_op_328 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_104*tmp_blending_op_329 + tmp_blending_op_230*tmp_blending_op_85 + tmp_blending_op_231*tmp_blending_op_87 - tmp_blending_op_329*tmp_blending_op_83)*1.0;
             const real_t hessian_blending_0_0_1_q_3 = tmp_blending_op_331*tmp_blending_op_47*tmp_blending_op_80*tmp_blending_op_91*1.0 - tmp_blending_op_332*tmp_blending_op_80;
             const real_t hessian_blending_0_0_2_q_3 = tmp_blending_op_331*tmp_blending_op_47*tmp_blending_op_75*tmp_blending_op_91*1.0 - tmp_blending_op_332*tmp_blending_op_75;
             const real_t hessian_blending_0_1_0_q_3 = tmp_blending_op_333*tmp_blending_op_78*tmp_blending_op_92 - tmp_blending_op_334*tmp_blending_op_94 + tmp_blending_op_95;
             const real_t hessian_blending_0_1_1_q_3 = -tmp_blending_op_102*tmp_blending_op_328 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_101*tmp_blending_op_329 + tmp_blending_op_230*tmp_blending_op_86 + tmp_blending_op_335)*1.0;
             const real_t hessian_blending_0_1_2_q_3 = tmp_blending_op_333*tmp_blending_op_47*tmp_blending_op_75*tmp_blending_op_91*1.0 - tmp_blending_op_337;
             const real_t hessian_blending_0_2_0_q_3 = tmp_blending_op_100 - tmp_blending_op_334*tmp_blending_op_99 + tmp_blending_op_338*tmp_blending_op_78*tmp_blending_op_92;
             const real_t hessian_blending_0_2_1_q_3 = tmp_blending_op_338*tmp_blending_op_47*tmp_blending_op_80*tmp_blending_op_91*1.0 - tmp_blending_op_340;
             const real_t hessian_blending_0_2_2_q_3 = -tmp_blending_op_328*tmp_blending_op_90 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_230*tmp_blending_op_76 + tmp_blending_op_329*tmp_blending_op_89 + tmp_blending_op_335)*1.0;
             const real_t hessian_blending_1_0_0_q_3 = -tmp_blending_op_105*tmp_blending_op_343 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_104*tmp_blending_op_342 + tmp_blending_op_341 + tmp_blending_op_51*tmp_blending_op_85)*1.0;
             const real_t hessian_blending_1_0_1_q_3 = tmp_blending_op_344*tmp_blending_op_80 - tmp_blending_op_345*tmp_blending_op_96 + tmp_blending_op_97;
             const real_t hessian_blending_1_0_2_q_3 = tmp_blending_op_344*tmp_blending_op_75 + tmp_blending_op_347;
             const real_t hessian_blending_1_1_0_q_3 = -tmp_blending_op_336*tmp_blending_op_80 + tmp_blending_op_348*tmp_blending_op_47*tmp_blending_op_78*tmp_blending_op_91*1.0;
             const real_t hessian_blending_1_1_1_q_3 = -tmp_blending_op_102*tmp_blending_op_343 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_101*tmp_blending_op_342 + tmp_blending_op_253*tmp_blending_op_87 + tmp_blending_op_342*tmp_blending_op_84 + tmp_blending_op_51*tmp_blending_op_86)*1.0;
             const real_t hessian_blending_1_1_2_q_3 = -tmp_blending_op_346*tmp_blending_op_94 + tmp_blending_op_348*tmp_blending_op_47*tmp_blending_op_75*tmp_blending_op_91*1.0;
             const real_t hessian_blending_1_2_0_q_3 = -tmp_blending_op_340 + tmp_blending_op_350*tmp_blending_op_47*tmp_blending_op_78*tmp_blending_op_91*1.0;
             const real_t hessian_blending_1_2_1_q_3 = tmp_blending_op_100 - tmp_blending_op_345*tmp_blending_op_99 + tmp_blending_op_350*tmp_blending_op_80*tmp_blending_op_92;
             const real_t hessian_blending_1_2_2_q_3 = -tmp_blending_op_343*tmp_blending_op_90 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_341 + tmp_blending_op_342*tmp_blending_op_89 + tmp_blending_op_51*tmp_blending_op_76)*1.0;
             const real_t hessian_blending_2_0_0_q_3 = -tmp_blending_op_105*tmp_blending_op_353 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_104*tmp_blending_op_352 + tmp_blending_op_256*tmp_blending_op_85 + tmp_blending_op_351)*1.0;
             const real_t hessian_blending_2_0_1_q_3 = tmp_blending_op_347 + tmp_blending_op_354*tmp_blending_op_80;
             const real_t hessian_blending_2_0_2_q_3 = tmp_blending_op_354*tmp_blending_op_75 - tmp_blending_op_355*tmp_blending_op_96 + tmp_blending_op_97;
             const real_t hessian_blending_2_1_0_q_3 = -tmp_blending_op_337 + tmp_blending_op_356*tmp_blending_op_78;
             const real_t hessian_blending_2_1_1_q_3 = -tmp_blending_op_102*tmp_blending_op_353 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_101*tmp_blending_op_352 + tmp_blending_op_256*tmp_blending_op_86 + tmp_blending_op_351)*1.0;
             const real_t hessian_blending_2_1_2_q_3 = -tmp_blending_op_355*tmp_blending_op_94 + tmp_blending_op_356*tmp_blending_op_75 + tmp_blending_op_95;
             const real_t hessian_blending_2_2_0_q_3 = -tmp_blending_op_339*tmp_blending_op_75 + tmp_blending_op_357*tmp_blending_op_47*tmp_blending_op_78*tmp_blending_op_91*1.0;
             const real_t hessian_blending_2_2_1_q_3 = -tmp_blending_op_346*tmp_blending_op_99 + tmp_blending_op_357*tmp_blending_op_47*tmp_blending_op_80*tmp_blending_op_91*1.0;
             const real_t hessian_blending_2_2_2_q_3 = -tmp_blending_op_353*tmp_blending_op_90 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_256*tmp_blending_op_76 + tmp_blending_op_264*tmp_blending_op_87 + tmp_blending_op_352*tmp_blending_op_89 + tmp_blending_op_98*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_4 = -tmp_blending_op_359*tmp_blending_op_67 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_230*tmp_blending_op_38 + tmp_blending_op_231*tmp_blending_op_40 - tmp_blending_op_36*tmp_blending_op_360 + tmp_blending_op_360*tmp_blending_op_66)*1.0;
             const real_t hessian_blending_0_0_1_q_4 = tmp_blending_op_33*tmp_blending_op_362*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_33*tmp_blending_op_363;
             const real_t hessian_blending_0_0_2_q_4 = tmp_blending_op_3*tmp_blending_op_362*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_3*tmp_blending_op_363;
             const real_t hessian_blending_0_1_0_q_4 = tmp_blending_op_28*tmp_blending_op_364*tmp_blending_op_49 - tmp_blending_op_365*tmp_blending_op_53 + tmp_blending_op_54;
             const real_t hessian_blending_0_1_1_q_4 = -tmp_blending_op_359*tmp_blending_op_64 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_230*tmp_blending_op_39 + tmp_blending_op_360*tmp_blending_op_63 + tmp_blending_op_366)*1.0;
             const real_t hessian_blending_0_1_2_q_4 = tmp_blending_op_3*tmp_blending_op_364*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_368;
             const real_t hessian_blending_0_2_0_q_4 = tmp_blending_op_28*tmp_blending_op_369*tmp_blending_op_49 - tmp_blending_op_365*tmp_blending_op_60 + tmp_blending_op_61;
             const real_t hessian_blending_0_2_1_q_4 = tmp_blending_op_33*tmp_blending_op_369*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_371;
             const real_t hessian_blending_0_2_2_q_4 = -tmp_blending_op_359*tmp_blending_op_45 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_230*tmp_blending_op_4 + tmp_blending_op_360*tmp_blending_op_44 + tmp_blending_op_366)*1.0;
             const real_t hessian_blending_1_0_0_q_4 = -tmp_blending_op_374*tmp_blending_op_67 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_372 + tmp_blending_op_373*tmp_blending_op_66 + tmp_blending_op_38*tmp_blending_op_51)*1.0;
             const real_t hessian_blending_1_0_1_q_4 = tmp_blending_op_33*tmp_blending_op_375 - tmp_blending_op_376*tmp_blending_op_57 + tmp_blending_op_58;
             const real_t hessian_blending_1_0_2_q_4 = tmp_blending_op_3*tmp_blending_op_375 + tmp_blending_op_378;
             const real_t hessian_blending_1_1_0_q_4 = tmp_blending_op_28*tmp_blending_op_379*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_33*tmp_blending_op_367;
             const real_t hessian_blending_1_1_1_q_4 = -tmp_blending_op_374*tmp_blending_op_64 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_253*tmp_blending_op_40 + tmp_blending_op_37*tmp_blending_op_373 + tmp_blending_op_373*tmp_blending_op_63 + tmp_blending_op_39*tmp_blending_op_51)*1.0;
             const real_t hessian_blending_1_1_2_q_4 = tmp_blending_op_3*tmp_blending_op_379*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_377*tmp_blending_op_53;
             const real_t hessian_blending_1_2_0_q_4 = tmp_blending_op_28*tmp_blending_op_381*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_371;
             const real_t hessian_blending_1_2_1_q_4 = tmp_blending_op_33*tmp_blending_op_381*tmp_blending_op_49 - tmp_blending_op_376*tmp_blending_op_60 + tmp_blending_op_61;
             const real_t hessian_blending_1_2_2_q_4 = -tmp_blending_op_374*tmp_blending_op_45 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_372 + tmp_blending_op_373*tmp_blending_op_44 + tmp_blending_op_4*tmp_blending_op_51)*1.0;
             const real_t hessian_blending_2_0_0_q_4 = -tmp_blending_op_384*tmp_blending_op_67 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_256*tmp_blending_op_38 + tmp_blending_op_382 + tmp_blending_op_383*tmp_blending_op_66)*1.0;
             const real_t hessian_blending_2_0_1_q_4 = tmp_blending_op_33*tmp_blending_op_385 + tmp_blending_op_378;
             const real_t hessian_blending_2_0_2_q_4 = tmp_blending_op_3*tmp_blending_op_385 - tmp_blending_op_386*tmp_blending_op_57 + tmp_blending_op_58;
             const real_t hessian_blending_2_1_0_q_4 = tmp_blending_op_28*tmp_blending_op_387 - tmp_blending_op_368;
             const real_t hessian_blending_2_1_1_q_4 = -tmp_blending_op_384*tmp_blending_op_64 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_256*tmp_blending_op_39 + tmp_blending_op_382 + tmp_blending_op_383*tmp_blending_op_63)*1.0;
             const real_t hessian_blending_2_1_2_q_4 = tmp_blending_op_3*tmp_blending_op_387 - tmp_blending_op_386*tmp_blending_op_53 + tmp_blending_op_54;
             const real_t hessian_blending_2_2_0_q_4 = tmp_blending_op_28*tmp_blending_op_388*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_3*tmp_blending_op_370;
             const real_t hessian_blending_2_2_1_q_4 = tmp_blending_op_33*tmp_blending_op_388*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_377*tmp_blending_op_60;
             const real_t hessian_blending_2_2_2_q_4 = -tmp_blending_op_384*tmp_blending_op_45 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_256*tmp_blending_op_4 + tmp_blending_op_264*tmp_blending_op_40 + tmp_blending_op_383*tmp_blending_op_44 + tmp_blending_op_59*2.0)*1.0;
             const real_t diffusivity_times_delta_dof_0 = _data_diffusivity_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t diffusivity_times_delta_dof_1 = _data_diffusivity_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t diffusivity_times_delta_dof_2 = _data_diffusivity_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t diffusivity_times_delta_dof_3 = _data_diffusivity_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t diffusivity_times_delta_dof_4 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t diffusivity_times_delta_dof_5 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t diffusivity_times_delta_dof_6 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t diffusivity_times_delta_dof_7 = _data_diffusivity_times_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t diffusivity_times_delta_dof_8 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t diffusivity_times_delta_dof_9 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wx_dof_0 = _data_wxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wx_dof_1 = _data_wxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wx_dof_2 = _data_wxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wx_dof_3 = _data_wxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wx_dof_4 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wx_dof_5 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wx_dof_6 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wx_dof_7 = _data_wxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wx_dof_8 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wx_dof_9 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wy_dof_0 = _data_wyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wy_dof_1 = _data_wyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wy_dof_2 = _data_wyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wy_dof_3 = _data_wyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wy_dof_4 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wy_dof_5 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wy_dof_6 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wy_dof_7 = _data_wyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wy_dof_8 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wy_dof_9 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wz_dof_0 = _data_wzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wz_dof_1 = _data_wzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wz_dof_2 = _data_wzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wz_dof_3 = _data_wzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wz_dof_4 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wz_dof_5 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wz_dof_6 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wz_dof_7 = _data_wzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wz_dof_8 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wz_dof_9 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t tmp_kernel_op_30 = -hessian_blending_0_0_0_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_0_1_0_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_0_2_0_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_31 = -hessian_blending_0_0_1_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_0_1_1_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_0_2_1_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_32 = -hessian_blending_0_0_2_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_0_1_2_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_0_2_2_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_33 = jac_blending_inv_0_0_q_0*tmp_kernel_op_30 + jac_blending_inv_0_1_q_0*tmp_kernel_op_31 + jac_blending_inv_0_2_q_0*tmp_kernel_op_32;
             const real_t tmp_kernel_op_35 = jac_blending_inv_1_0_q_0*tmp_kernel_op_30 + jac_blending_inv_1_1_q_0*tmp_kernel_op_31 + jac_blending_inv_1_2_q_0*tmp_kernel_op_32;
             const real_t tmp_kernel_op_37 = jac_blending_inv_2_0_q_0*tmp_kernel_op_30 + jac_blending_inv_2_1_q_0*tmp_kernel_op_31 + jac_blending_inv_2_2_q_0*tmp_kernel_op_32;
             const real_t tmp_kernel_op_38 = -hessian_blending_1_0_0_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_1_1_0_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_1_2_0_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_39 = -hessian_blending_1_0_1_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_1_1_1_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_1_2_1_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_40 = -hessian_blending_1_0_2_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_1_1_2_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_1_2_2_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_41 = jac_blending_inv_0_0_q_0*tmp_kernel_op_38 + jac_blending_inv_0_1_q_0*tmp_kernel_op_39 + jac_blending_inv_0_2_q_0*tmp_kernel_op_40;
             const real_t tmp_kernel_op_42 = jac_blending_inv_1_0_q_0*tmp_kernel_op_38 + jac_blending_inv_1_1_q_0*tmp_kernel_op_39 + jac_blending_inv_1_2_q_0*tmp_kernel_op_40;
             const real_t tmp_kernel_op_43 = jac_blending_inv_2_0_q_0*tmp_kernel_op_38 + jac_blending_inv_2_1_q_0*tmp_kernel_op_39 + jac_blending_inv_2_2_q_0*tmp_kernel_op_40;
             const real_t tmp_kernel_op_44 = -hessian_blending_2_0_0_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_2_1_0_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_2_2_0_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_45 = -hessian_blending_2_0_1_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_2_1_1_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_2_2_1_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_46 = -hessian_blending_2_0_2_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_2_1_2_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_2_2_2_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_47 = jac_blending_inv_0_0_q_0*tmp_kernel_op_44 + jac_blending_inv_0_1_q_0*tmp_kernel_op_45 + jac_blending_inv_0_2_q_0*tmp_kernel_op_46;
             const real_t tmp_kernel_op_48 = jac_blending_inv_1_0_q_0*tmp_kernel_op_44 + jac_blending_inv_1_1_q_0*tmp_kernel_op_45 + jac_blending_inv_1_2_q_0*tmp_kernel_op_46;
             const real_t tmp_kernel_op_49 = jac_blending_inv_2_0_q_0*tmp_kernel_op_44 + jac_blending_inv_2_1_q_0*tmp_kernel_op_45 + jac_blending_inv_2_2_q_0*tmp_kernel_op_46;
             const real_t tmp_kernel_op_50 = -hessian_blending_0_0_0_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_0_1_0_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_0_2_0_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_51 = -hessian_blending_0_0_1_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_0_1_1_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_0_2_1_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_52 = -hessian_blending_0_0_2_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_0_1_2_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_0_2_2_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_53 = jac_blending_inv_0_0_q_0*tmp_kernel_op_50 + jac_blending_inv_0_1_q_0*tmp_kernel_op_51 + jac_blending_inv_0_2_q_0*tmp_kernel_op_52;
             const real_t tmp_kernel_op_54 = jac_blending_inv_1_0_q_0*tmp_kernel_op_50 + jac_blending_inv_1_1_q_0*tmp_kernel_op_51 + jac_blending_inv_1_2_q_0*tmp_kernel_op_52;
             const real_t tmp_kernel_op_55 = jac_blending_inv_2_0_q_0*tmp_kernel_op_50 + jac_blending_inv_2_1_q_0*tmp_kernel_op_51 + jac_blending_inv_2_2_q_0*tmp_kernel_op_52;
             const real_t tmp_kernel_op_56 = -hessian_blending_1_0_0_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_1_1_0_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_1_2_0_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_57 = -hessian_blending_1_0_1_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_1_1_1_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_1_2_1_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_58 = -hessian_blending_1_0_2_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_1_1_2_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_1_2_2_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_59 = jac_blending_inv_0_0_q_0*tmp_kernel_op_56 + jac_blending_inv_0_1_q_0*tmp_kernel_op_57 + jac_blending_inv_0_2_q_0*tmp_kernel_op_58;
             const real_t tmp_kernel_op_60 = jac_blending_inv_1_0_q_0*tmp_kernel_op_56 + jac_blending_inv_1_1_q_0*tmp_kernel_op_57 + jac_blending_inv_1_2_q_0*tmp_kernel_op_58;
             const real_t tmp_kernel_op_61 = jac_blending_inv_2_0_q_0*tmp_kernel_op_56 + jac_blending_inv_2_1_q_0*tmp_kernel_op_57 + jac_blending_inv_2_2_q_0*tmp_kernel_op_58;
             const real_t tmp_kernel_op_62 = -hessian_blending_2_0_0_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_2_1_0_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_2_2_0_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_63 = -hessian_blending_2_0_1_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_2_1_1_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_2_2_1_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_64 = -hessian_blending_2_0_2_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_2_1_2_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_2_2_2_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_65 = jac_blending_inv_0_0_q_0*tmp_kernel_op_62 + jac_blending_inv_0_1_q_0*tmp_kernel_op_63 + jac_blending_inv_0_2_q_0*tmp_kernel_op_64;
             const real_t tmp_kernel_op_66 = jac_blending_inv_1_0_q_0*tmp_kernel_op_62 + jac_blending_inv_1_1_q_0*tmp_kernel_op_63 + jac_blending_inv_1_2_q_0*tmp_kernel_op_64;
             const real_t tmp_kernel_op_67 = jac_blending_inv_2_0_q_0*tmp_kernel_op_62 + jac_blending_inv_2_1_q_0*tmp_kernel_op_63 + jac_blending_inv_2_2_q_0*tmp_kernel_op_64;
             const real_t tmp_kernel_op_68 = -hessian_blending_0_0_0_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_0_1_0_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_0_2_0_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_69 = -hessian_blending_0_0_1_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_0_1_1_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_0_2_1_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_70 = -hessian_blending_0_0_2_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_0_1_2_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_0_2_2_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_71 = jac_blending_inv_0_0_q_0*tmp_kernel_op_68 + jac_blending_inv_0_1_q_0*tmp_kernel_op_69 + jac_blending_inv_0_2_q_0*tmp_kernel_op_70;
             const real_t tmp_kernel_op_72 = jac_blending_inv_1_0_q_0*tmp_kernel_op_68 + jac_blending_inv_1_1_q_0*tmp_kernel_op_69 + jac_blending_inv_1_2_q_0*tmp_kernel_op_70;
             const real_t tmp_kernel_op_73 = jac_blending_inv_2_0_q_0*tmp_kernel_op_68 + jac_blending_inv_2_1_q_0*tmp_kernel_op_69 + jac_blending_inv_2_2_q_0*tmp_kernel_op_70;
             const real_t tmp_kernel_op_74 = -hessian_blending_1_0_0_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_1_1_0_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_1_2_0_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_75 = -hessian_blending_1_0_1_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_1_1_1_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_1_2_1_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_76 = -hessian_blending_1_0_2_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_1_1_2_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_1_2_2_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_77 = jac_blending_inv_0_0_q_0*tmp_kernel_op_74 + jac_blending_inv_0_1_q_0*tmp_kernel_op_75 + jac_blending_inv_0_2_q_0*tmp_kernel_op_76;
             const real_t tmp_kernel_op_78 = jac_blending_inv_1_0_q_0*tmp_kernel_op_74 + jac_blending_inv_1_1_q_0*tmp_kernel_op_75 + jac_blending_inv_1_2_q_0*tmp_kernel_op_76;
             const real_t tmp_kernel_op_79 = jac_blending_inv_2_0_q_0*tmp_kernel_op_74 + jac_blending_inv_2_1_q_0*tmp_kernel_op_75 + jac_blending_inv_2_2_q_0*tmp_kernel_op_76;
             const real_t tmp_kernel_op_80 = -hessian_blending_2_0_0_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_2_1_0_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_2_2_0_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_81 = -hessian_blending_2_0_1_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_2_1_1_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_2_2_1_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_82 = -hessian_blending_2_0_2_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_2_1_2_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_2_2_2_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_83 = jac_blending_inv_0_0_q_0*tmp_kernel_op_80 + jac_blending_inv_0_1_q_0*tmp_kernel_op_81 + jac_blending_inv_0_2_q_0*tmp_kernel_op_82;
             const real_t tmp_kernel_op_84 = jac_blending_inv_1_0_q_0*tmp_kernel_op_80 + jac_blending_inv_1_1_q_0*tmp_kernel_op_81 + jac_blending_inv_1_2_q_0*tmp_kernel_op_82;
             const real_t tmp_kernel_op_85 = jac_blending_inv_2_0_q_0*tmp_kernel_op_80 + jac_blending_inv_2_1_q_0*tmp_kernel_op_81 + jac_blending_inv_2_2_q_0*tmp_kernel_op_82;
             const real_t tmp_kernel_op_86 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_743 + jac_blending_inv_1_0_q_0*tmp_moved_constant_749 + jac_blending_inv_2_0_q_0*tmp_moved_constant_755) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_762 + tmp_kernel_op_35*tmp_moved_constant_763 + tmp_kernel_op_37*tmp_moved_constant_764) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_743 + jac_blending_inv_1_1_q_0*tmp_moved_constant_749 + jac_blending_inv_2_1_q_0*tmp_moved_constant_755) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_762 + tmp_kernel_op_42*tmp_moved_constant_763 + tmp_kernel_op_43*tmp_moved_constant_764) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_743 + jac_blending_inv_1_2_q_0*tmp_moved_constant_749 + jac_blending_inv_2_2_q_0*tmp_moved_constant_755) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_762 + tmp_kernel_op_48*tmp_moved_constant_763 + tmp_kernel_op_49*tmp_moved_constant_764) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_756 + jac_blending_inv_1_0_q_0*tmp_moved_constant_757 + jac_blending_inv_2_0_q_0*tmp_moved_constant_758) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_762 + tmp_kernel_op_54*tmp_moved_constant_763 + tmp_kernel_op_55*tmp_moved_constant_764) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_756 + jac_blending_inv_1_1_q_0*tmp_moved_constant_757 + jac_blending_inv_2_1_q_0*tmp_moved_constant_758) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_762 + tmp_kernel_op_60*tmp_moved_constant_763 + tmp_kernel_op_61*tmp_moved_constant_764) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_756 + jac_blending_inv_1_2_q_0*tmp_moved_constant_757 + jac_blending_inv_2_2_q_0*tmp_moved_constant_758) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_762 + tmp_kernel_op_66*tmp_moved_constant_763 + tmp_kernel_op_67*tmp_moved_constant_764) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_759 + jac_blending_inv_1_0_q_0*tmp_moved_constant_760 + jac_blending_inv_2_0_q_0*tmp_moved_constant_761) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_762 + tmp_kernel_op_72*tmp_moved_constant_763 + tmp_kernel_op_73*tmp_moved_constant_764) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_759 + jac_blending_inv_1_1_q_0*tmp_moved_constant_760 + jac_blending_inv_2_1_q_0*tmp_moved_constant_761) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_762 + tmp_kernel_op_78*tmp_moved_constant_763 + tmp_kernel_op_79*tmp_moved_constant_764) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_759 + jac_blending_inv_1_2_q_0*tmp_moved_constant_760 + jac_blending_inv_2_2_q_0*tmp_moved_constant_761) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_762 + tmp_kernel_op_84*tmp_moved_constant_763 + tmp_kernel_op_85*tmp_moved_constant_764);
             const real_t tmp_kernel_op_104 = tmp_kernel_op_100*wx_dof_8 + tmp_kernel_op_102*wx_dof_9 + tmp_kernel_op_103*wx_dof_0 + tmp_kernel_op_87*wx_dof_4 + tmp_kernel_op_88*wx_dof_5 + tmp_kernel_op_89*wx_dof_6 + tmp_kernel_op_92*wx_dof_1 + tmp_kernel_op_95*wx_dof_2 + tmp_kernel_op_98*wx_dof_3 + tmp_kernel_op_99*wx_dof_7;
             const real_t tmp_kernel_op_105 = tmp_kernel_op_100*wy_dof_8 + tmp_kernel_op_102*wy_dof_9 + tmp_kernel_op_103*wy_dof_0 + tmp_kernel_op_87*wy_dof_4 + tmp_kernel_op_88*wy_dof_5 + tmp_kernel_op_89*wy_dof_6 + tmp_kernel_op_92*wy_dof_1 + tmp_kernel_op_95*wy_dof_2 + tmp_kernel_op_98*wy_dof_3 + tmp_kernel_op_99*wy_dof_7;
             const real_t tmp_kernel_op_106 = tmp_kernel_op_100*wz_dof_8 + tmp_kernel_op_102*wz_dof_9 + tmp_kernel_op_103*wz_dof_0 + tmp_kernel_op_87*wz_dof_4 + tmp_kernel_op_88*wz_dof_5 + tmp_kernel_op_89*wz_dof_6 + tmp_kernel_op_92*wz_dof_1 + tmp_kernel_op_95*wz_dof_2 + tmp_kernel_op_98*wz_dof_3 + tmp_kernel_op_99*wz_dof_7;
             const real_t tmp_kernel_op_107 = abs_det_jac_affine_BLUE_DOWN*abs_det_jac_blending_q_0*(diffusivity_times_delta_dof_0*tmp_kernel_op_103 + diffusivity_times_delta_dof_1*tmp_kernel_op_92 + diffusivity_times_delta_dof_2*tmp_kernel_op_95 + diffusivity_times_delta_dof_3*tmp_kernel_op_98 + diffusivity_times_delta_dof_4*tmp_kernel_op_87 + diffusivity_times_delta_dof_5*tmp_kernel_op_88 + diffusivity_times_delta_dof_6*tmp_kernel_op_89 + diffusivity_times_delta_dof_7*tmp_kernel_op_99 + diffusivity_times_delta_dof_8*tmp_kernel_op_100 + diffusivity_times_delta_dof_9*tmp_kernel_op_102)*-0.1333333333333333;
             const real_t tmp_kernel_op_108 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_762 + jac_blending_inv_1_0_q_0*tmp_moved_constant_763 + jac_blending_inv_2_0_q_0*tmp_moved_constant_764) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_762 + jac_blending_inv_1_1_q_0*tmp_moved_constant_763 + jac_blending_inv_2_1_q_0*tmp_moved_constant_764) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_762 + jac_blending_inv_1_2_q_0*tmp_moved_constant_763 + jac_blending_inv_2_2_q_0*tmp_moved_constant_764));
             const real_t tmp_kernel_op_115 = -hessian_blending_0_0_0_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_0_1_0_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_0_2_0_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_116 = -hessian_blending_0_0_1_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_0_1_1_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_0_2_1_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_117 = -hessian_blending_0_0_2_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_0_1_2_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_0_2_2_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_118 = jac_blending_inv_0_0_q_1*tmp_kernel_op_115 + jac_blending_inv_0_1_q_1*tmp_kernel_op_116 + jac_blending_inv_0_2_q_1*tmp_kernel_op_117;
             const real_t tmp_kernel_op_120 = jac_blending_inv_1_0_q_1*tmp_kernel_op_115 + jac_blending_inv_1_1_q_1*tmp_kernel_op_116 + jac_blending_inv_1_2_q_1*tmp_kernel_op_117;
             const real_t tmp_kernel_op_122 = jac_blending_inv_2_0_q_1*tmp_kernel_op_115 + jac_blending_inv_2_1_q_1*tmp_kernel_op_116 + jac_blending_inv_2_2_q_1*tmp_kernel_op_117;
             const real_t tmp_kernel_op_123 = -hessian_blending_1_0_0_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_1_1_0_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_1_2_0_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_124 = -hessian_blending_1_0_1_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_1_1_1_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_1_2_1_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_125 = -hessian_blending_1_0_2_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_1_1_2_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_1_2_2_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_126 = jac_blending_inv_0_0_q_1*tmp_kernel_op_123 + jac_blending_inv_0_1_q_1*tmp_kernel_op_124 + jac_blending_inv_0_2_q_1*tmp_kernel_op_125;
             const real_t tmp_kernel_op_127 = jac_blending_inv_1_0_q_1*tmp_kernel_op_123 + jac_blending_inv_1_1_q_1*tmp_kernel_op_124 + jac_blending_inv_1_2_q_1*tmp_kernel_op_125;
             const real_t tmp_kernel_op_128 = jac_blending_inv_2_0_q_1*tmp_kernel_op_123 + jac_blending_inv_2_1_q_1*tmp_kernel_op_124 + jac_blending_inv_2_2_q_1*tmp_kernel_op_125;
             const real_t tmp_kernel_op_129 = -hessian_blending_2_0_0_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_2_1_0_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_2_2_0_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_130 = -hessian_blending_2_0_1_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_2_1_1_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_2_2_1_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_131 = -hessian_blending_2_0_2_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_2_1_2_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_2_2_2_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_132 = jac_blending_inv_0_0_q_1*tmp_kernel_op_129 + jac_blending_inv_0_1_q_1*tmp_kernel_op_130 + jac_blending_inv_0_2_q_1*tmp_kernel_op_131;
             const real_t tmp_kernel_op_133 = jac_blending_inv_1_0_q_1*tmp_kernel_op_129 + jac_blending_inv_1_1_q_1*tmp_kernel_op_130 + jac_blending_inv_1_2_q_1*tmp_kernel_op_131;
             const real_t tmp_kernel_op_134 = jac_blending_inv_2_0_q_1*tmp_kernel_op_129 + jac_blending_inv_2_1_q_1*tmp_kernel_op_130 + jac_blending_inv_2_2_q_1*tmp_kernel_op_131;
             const real_t tmp_kernel_op_135 = -hessian_blending_0_0_0_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_0_1_0_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_0_2_0_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_136 = -hessian_blending_0_0_1_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_0_1_1_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_0_2_1_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_137 = -hessian_blending_0_0_2_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_0_1_2_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_0_2_2_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_138 = jac_blending_inv_0_0_q_1*tmp_kernel_op_135 + jac_blending_inv_0_1_q_1*tmp_kernel_op_136 + jac_blending_inv_0_2_q_1*tmp_kernel_op_137;
             const real_t tmp_kernel_op_139 = jac_blending_inv_1_0_q_1*tmp_kernel_op_135 + jac_blending_inv_1_1_q_1*tmp_kernel_op_136 + jac_blending_inv_1_2_q_1*tmp_kernel_op_137;
             const real_t tmp_kernel_op_140 = jac_blending_inv_2_0_q_1*tmp_kernel_op_135 + jac_blending_inv_2_1_q_1*tmp_kernel_op_136 + jac_blending_inv_2_2_q_1*tmp_kernel_op_137;
             const real_t tmp_kernel_op_141 = -hessian_blending_1_0_0_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_1_1_0_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_1_2_0_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_142 = -hessian_blending_1_0_1_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_1_1_1_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_1_2_1_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_143 = -hessian_blending_1_0_2_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_1_1_2_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_1_2_2_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_144 = jac_blending_inv_0_0_q_1*tmp_kernel_op_141 + jac_blending_inv_0_1_q_1*tmp_kernel_op_142 + jac_blending_inv_0_2_q_1*tmp_kernel_op_143;
             const real_t tmp_kernel_op_145 = jac_blending_inv_1_0_q_1*tmp_kernel_op_141 + jac_blending_inv_1_1_q_1*tmp_kernel_op_142 + jac_blending_inv_1_2_q_1*tmp_kernel_op_143;
             const real_t tmp_kernel_op_146 = jac_blending_inv_2_0_q_1*tmp_kernel_op_141 + jac_blending_inv_2_1_q_1*tmp_kernel_op_142 + jac_blending_inv_2_2_q_1*tmp_kernel_op_143;
             const real_t tmp_kernel_op_147 = -hessian_blending_2_0_0_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_2_1_0_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_2_2_0_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_148 = -hessian_blending_2_0_1_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_2_1_1_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_2_2_1_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_149 = -hessian_blending_2_0_2_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_2_1_2_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_2_2_2_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_150 = jac_blending_inv_0_0_q_1*tmp_kernel_op_147 + jac_blending_inv_0_1_q_1*tmp_kernel_op_148 + jac_blending_inv_0_2_q_1*tmp_kernel_op_149;
             const real_t tmp_kernel_op_151 = jac_blending_inv_1_0_q_1*tmp_kernel_op_147 + jac_blending_inv_1_1_q_1*tmp_kernel_op_148 + jac_blending_inv_1_2_q_1*tmp_kernel_op_149;
             const real_t tmp_kernel_op_152 = jac_blending_inv_2_0_q_1*tmp_kernel_op_147 + jac_blending_inv_2_1_q_1*tmp_kernel_op_148 + jac_blending_inv_2_2_q_1*tmp_kernel_op_149;
             const real_t tmp_kernel_op_153 = -hessian_blending_0_0_0_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_0_1_0_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_0_2_0_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_154 = -hessian_blending_0_0_1_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_0_1_1_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_0_2_1_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_155 = -hessian_blending_0_0_2_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_0_1_2_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_0_2_2_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_156 = jac_blending_inv_0_0_q_1*tmp_kernel_op_153 + jac_blending_inv_0_1_q_1*tmp_kernel_op_154 + jac_blending_inv_0_2_q_1*tmp_kernel_op_155;
             const real_t tmp_kernel_op_157 = jac_blending_inv_1_0_q_1*tmp_kernel_op_153 + jac_blending_inv_1_1_q_1*tmp_kernel_op_154 + jac_blending_inv_1_2_q_1*tmp_kernel_op_155;
             const real_t tmp_kernel_op_158 = jac_blending_inv_2_0_q_1*tmp_kernel_op_153 + jac_blending_inv_2_1_q_1*tmp_kernel_op_154 + jac_blending_inv_2_2_q_1*tmp_kernel_op_155;
             const real_t tmp_kernel_op_159 = -hessian_blending_1_0_0_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_1_1_0_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_1_2_0_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_160 = -hessian_blending_1_0_1_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_1_1_1_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_1_2_1_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_161 = -hessian_blending_1_0_2_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_1_1_2_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_1_2_2_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_162 = jac_blending_inv_0_0_q_1*tmp_kernel_op_159 + jac_blending_inv_0_1_q_1*tmp_kernel_op_160 + jac_blending_inv_0_2_q_1*tmp_kernel_op_161;
             const real_t tmp_kernel_op_163 = jac_blending_inv_1_0_q_1*tmp_kernel_op_159 + jac_blending_inv_1_1_q_1*tmp_kernel_op_160 + jac_blending_inv_1_2_q_1*tmp_kernel_op_161;
             const real_t tmp_kernel_op_164 = jac_blending_inv_2_0_q_1*tmp_kernel_op_159 + jac_blending_inv_2_1_q_1*tmp_kernel_op_160 + jac_blending_inv_2_2_q_1*tmp_kernel_op_161;
             const real_t tmp_kernel_op_165 = -hessian_blending_2_0_0_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_2_1_0_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_2_2_0_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_166 = -hessian_blending_2_0_1_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_2_1_1_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_2_2_1_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_167 = -hessian_blending_2_0_2_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_2_1_2_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_2_2_2_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_168 = jac_blending_inv_0_0_q_1*tmp_kernel_op_165 + jac_blending_inv_0_1_q_1*tmp_kernel_op_166 + jac_blending_inv_0_2_q_1*tmp_kernel_op_167;
             const real_t tmp_kernel_op_169 = jac_blending_inv_1_0_q_1*tmp_kernel_op_165 + jac_blending_inv_1_1_q_1*tmp_kernel_op_166 + jac_blending_inv_1_2_q_1*tmp_kernel_op_167;
             const real_t tmp_kernel_op_170 = jac_blending_inv_2_0_q_1*tmp_kernel_op_165 + jac_blending_inv_2_1_q_1*tmp_kernel_op_166 + jac_blending_inv_2_2_q_1*tmp_kernel_op_167;
             const real_t tmp_kernel_op_171 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_743 + jac_blending_inv_1_0_q_1*tmp_moved_constant_749 + jac_blending_inv_2_0_q_1*tmp_moved_constant_755) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_765 + tmp_kernel_op_120*tmp_moved_constant_766 + tmp_kernel_op_122*tmp_moved_constant_767) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_743 + jac_blending_inv_1_1_q_1*tmp_moved_constant_749 + jac_blending_inv_2_1_q_1*tmp_moved_constant_755) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_765 + tmp_kernel_op_127*tmp_moved_constant_766 + tmp_kernel_op_128*tmp_moved_constant_767) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_743 + jac_blending_inv_1_2_q_1*tmp_moved_constant_749 + jac_blending_inv_2_2_q_1*tmp_moved_constant_755) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_765 + tmp_kernel_op_133*tmp_moved_constant_766 + tmp_kernel_op_134*tmp_moved_constant_767) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_756 + jac_blending_inv_1_0_q_1*tmp_moved_constant_757 + jac_blending_inv_2_0_q_1*tmp_moved_constant_758) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_765 + tmp_kernel_op_139*tmp_moved_constant_766 + tmp_kernel_op_140*tmp_moved_constant_767) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_756 + jac_blending_inv_1_1_q_1*tmp_moved_constant_757 + jac_blending_inv_2_1_q_1*tmp_moved_constant_758) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_765 + tmp_kernel_op_145*tmp_moved_constant_766 + tmp_kernel_op_146*tmp_moved_constant_767) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_756 + jac_blending_inv_1_2_q_1*tmp_moved_constant_757 + jac_blending_inv_2_2_q_1*tmp_moved_constant_758) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_765 + tmp_kernel_op_151*tmp_moved_constant_766 + tmp_kernel_op_152*tmp_moved_constant_767) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_759 + jac_blending_inv_1_0_q_1*tmp_moved_constant_760 + jac_blending_inv_2_0_q_1*tmp_moved_constant_761) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_765 + tmp_kernel_op_157*tmp_moved_constant_766 + tmp_kernel_op_158*tmp_moved_constant_767) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_759 + jac_blending_inv_1_1_q_1*tmp_moved_constant_760 + jac_blending_inv_2_1_q_1*tmp_moved_constant_761) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_765 + tmp_kernel_op_163*tmp_moved_constant_766 + tmp_kernel_op_164*tmp_moved_constant_767) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_759 + jac_blending_inv_1_2_q_1*tmp_moved_constant_760 + jac_blending_inv_2_2_q_1*tmp_moved_constant_761) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_765 + tmp_kernel_op_169*tmp_moved_constant_766 + tmp_kernel_op_170*tmp_moved_constant_767);
             const real_t tmp_kernel_op_189 = tmp_kernel_op_172*wx_dof_4 + tmp_kernel_op_173*wx_dof_5 + tmp_kernel_op_174*wx_dof_6 + tmp_kernel_op_177*wx_dof_1 + tmp_kernel_op_180*wx_dof_2 + tmp_kernel_op_183*wx_dof_3 + tmp_kernel_op_184*wx_dof_7 + tmp_kernel_op_185*wx_dof_8 + tmp_kernel_op_187*wx_dof_9 + tmp_kernel_op_188*wx_dof_0;
             const real_t tmp_kernel_op_190 = tmp_kernel_op_172*wy_dof_4 + tmp_kernel_op_173*wy_dof_5 + tmp_kernel_op_174*wy_dof_6 + tmp_kernel_op_177*wy_dof_1 + tmp_kernel_op_180*wy_dof_2 + tmp_kernel_op_183*wy_dof_3 + tmp_kernel_op_184*wy_dof_7 + tmp_kernel_op_185*wy_dof_8 + tmp_kernel_op_187*wy_dof_9 + tmp_kernel_op_188*wy_dof_0;
             const real_t tmp_kernel_op_191 = tmp_kernel_op_172*wz_dof_4 + tmp_kernel_op_173*wz_dof_5 + tmp_kernel_op_174*wz_dof_6 + tmp_kernel_op_177*wz_dof_1 + tmp_kernel_op_180*wz_dof_2 + tmp_kernel_op_183*wz_dof_3 + tmp_kernel_op_184*wz_dof_7 + tmp_kernel_op_185*wz_dof_8 + tmp_kernel_op_187*wz_dof_9 + tmp_kernel_op_188*wz_dof_0;
             const real_t tmp_kernel_op_192 = abs_det_jac_affine_BLUE_DOWN*abs_det_jac_blending_q_1*(diffusivity_times_delta_dof_0*tmp_kernel_op_188 + diffusivity_times_delta_dof_1*tmp_kernel_op_177 + diffusivity_times_delta_dof_2*tmp_kernel_op_180 + diffusivity_times_delta_dof_3*tmp_kernel_op_183 + diffusivity_times_delta_dof_4*tmp_kernel_op_172 + diffusivity_times_delta_dof_5*tmp_kernel_op_173 + diffusivity_times_delta_dof_6*tmp_kernel_op_174 + diffusivity_times_delta_dof_7*tmp_kernel_op_184 + diffusivity_times_delta_dof_8*tmp_kernel_op_185 + diffusivity_times_delta_dof_9*tmp_kernel_op_187)*0.074999999999999983;
             const real_t tmp_kernel_op_193 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_765 + jac_blending_inv_1_0_q_1*tmp_moved_constant_766 + jac_blending_inv_2_0_q_1*tmp_moved_constant_767) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_765 + jac_blending_inv_1_1_q_1*tmp_moved_constant_766 + jac_blending_inv_2_1_q_1*tmp_moved_constant_767) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_765 + jac_blending_inv_1_2_q_1*tmp_moved_constant_766 + jac_blending_inv_2_2_q_1*tmp_moved_constant_767));
             const real_t tmp_kernel_op_200 = -hessian_blending_0_0_0_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_0_1_0_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_0_2_0_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_201 = -hessian_blending_0_0_1_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_0_1_1_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_0_2_1_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_202 = -hessian_blending_0_0_2_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_0_1_2_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_0_2_2_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_203 = jac_blending_inv_0_0_q_2*tmp_kernel_op_200 + jac_blending_inv_0_1_q_2*tmp_kernel_op_201 + jac_blending_inv_0_2_q_2*tmp_kernel_op_202;
             const real_t tmp_kernel_op_205 = jac_blending_inv_1_0_q_2*tmp_kernel_op_200 + jac_blending_inv_1_1_q_2*tmp_kernel_op_201 + jac_blending_inv_1_2_q_2*tmp_kernel_op_202;
             const real_t tmp_kernel_op_207 = jac_blending_inv_2_0_q_2*tmp_kernel_op_200 + jac_blending_inv_2_1_q_2*tmp_kernel_op_201 + jac_blending_inv_2_2_q_2*tmp_kernel_op_202;
             const real_t tmp_kernel_op_208 = -hessian_blending_1_0_0_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_1_1_0_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_1_2_0_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_209 = -hessian_blending_1_0_1_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_1_1_1_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_1_2_1_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_210 = -hessian_blending_1_0_2_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_1_1_2_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_1_2_2_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_211 = jac_blending_inv_0_0_q_2*tmp_kernel_op_208 + jac_blending_inv_0_1_q_2*tmp_kernel_op_209 + jac_blending_inv_0_2_q_2*tmp_kernel_op_210;
             const real_t tmp_kernel_op_212 = jac_blending_inv_1_0_q_2*tmp_kernel_op_208 + jac_blending_inv_1_1_q_2*tmp_kernel_op_209 + jac_blending_inv_1_2_q_2*tmp_kernel_op_210;
             const real_t tmp_kernel_op_213 = jac_blending_inv_2_0_q_2*tmp_kernel_op_208 + jac_blending_inv_2_1_q_2*tmp_kernel_op_209 + jac_blending_inv_2_2_q_2*tmp_kernel_op_210;
             const real_t tmp_kernel_op_214 = -hessian_blending_2_0_0_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_2_1_0_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_2_2_0_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_215 = -hessian_blending_2_0_1_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_2_1_1_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_2_2_1_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_216 = -hessian_blending_2_0_2_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_2_1_2_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_2_2_2_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_217 = jac_blending_inv_0_0_q_2*tmp_kernel_op_214 + jac_blending_inv_0_1_q_2*tmp_kernel_op_215 + jac_blending_inv_0_2_q_2*tmp_kernel_op_216;
             const real_t tmp_kernel_op_218 = jac_blending_inv_1_0_q_2*tmp_kernel_op_214 + jac_blending_inv_1_1_q_2*tmp_kernel_op_215 + jac_blending_inv_1_2_q_2*tmp_kernel_op_216;
             const real_t tmp_kernel_op_219 = jac_blending_inv_2_0_q_2*tmp_kernel_op_214 + jac_blending_inv_2_1_q_2*tmp_kernel_op_215 + jac_blending_inv_2_2_q_2*tmp_kernel_op_216;
             const real_t tmp_kernel_op_220 = -hessian_blending_0_0_0_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_0_1_0_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_0_2_0_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_221 = -hessian_blending_0_0_1_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_0_1_1_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_0_2_1_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_222 = -hessian_blending_0_0_2_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_0_1_2_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_0_2_2_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_223 = jac_blending_inv_0_0_q_2*tmp_kernel_op_220 + jac_blending_inv_0_1_q_2*tmp_kernel_op_221 + jac_blending_inv_0_2_q_2*tmp_kernel_op_222;
             const real_t tmp_kernel_op_224 = jac_blending_inv_1_0_q_2*tmp_kernel_op_220 + jac_blending_inv_1_1_q_2*tmp_kernel_op_221 + jac_blending_inv_1_2_q_2*tmp_kernel_op_222;
             const real_t tmp_kernel_op_225 = jac_blending_inv_2_0_q_2*tmp_kernel_op_220 + jac_blending_inv_2_1_q_2*tmp_kernel_op_221 + jac_blending_inv_2_2_q_2*tmp_kernel_op_222;
             const real_t tmp_kernel_op_226 = -hessian_blending_1_0_0_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_1_1_0_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_1_2_0_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_227 = -hessian_blending_1_0_1_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_1_1_1_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_1_2_1_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_228 = -hessian_blending_1_0_2_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_1_1_2_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_1_2_2_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_229 = jac_blending_inv_0_0_q_2*tmp_kernel_op_226 + jac_blending_inv_0_1_q_2*tmp_kernel_op_227 + jac_blending_inv_0_2_q_2*tmp_kernel_op_228;
             const real_t tmp_kernel_op_230 = jac_blending_inv_1_0_q_2*tmp_kernel_op_226 + jac_blending_inv_1_1_q_2*tmp_kernel_op_227 + jac_blending_inv_1_2_q_2*tmp_kernel_op_228;
             const real_t tmp_kernel_op_231 = jac_blending_inv_2_0_q_2*tmp_kernel_op_226 + jac_blending_inv_2_1_q_2*tmp_kernel_op_227 + jac_blending_inv_2_2_q_2*tmp_kernel_op_228;
             const real_t tmp_kernel_op_232 = -hessian_blending_2_0_0_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_2_1_0_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_2_2_0_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_233 = -hessian_blending_2_0_1_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_2_1_1_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_2_2_1_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_234 = -hessian_blending_2_0_2_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_2_1_2_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_2_2_2_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_235 = jac_blending_inv_0_0_q_2*tmp_kernel_op_232 + jac_blending_inv_0_1_q_2*tmp_kernel_op_233 + jac_blending_inv_0_2_q_2*tmp_kernel_op_234;
             const real_t tmp_kernel_op_236 = jac_blending_inv_1_0_q_2*tmp_kernel_op_232 + jac_blending_inv_1_1_q_2*tmp_kernel_op_233 + jac_blending_inv_1_2_q_2*tmp_kernel_op_234;
             const real_t tmp_kernel_op_237 = jac_blending_inv_2_0_q_2*tmp_kernel_op_232 + jac_blending_inv_2_1_q_2*tmp_kernel_op_233 + jac_blending_inv_2_2_q_2*tmp_kernel_op_234;
             const real_t tmp_kernel_op_238 = -hessian_blending_0_0_0_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_0_1_0_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_0_2_0_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_239 = -hessian_blending_0_0_1_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_0_1_1_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_0_2_1_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_240 = -hessian_blending_0_0_2_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_0_1_2_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_0_2_2_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_241 = jac_blending_inv_0_0_q_2*tmp_kernel_op_238 + jac_blending_inv_0_1_q_2*tmp_kernel_op_239 + jac_blending_inv_0_2_q_2*tmp_kernel_op_240;
             const real_t tmp_kernel_op_242 = jac_blending_inv_1_0_q_2*tmp_kernel_op_238 + jac_blending_inv_1_1_q_2*tmp_kernel_op_239 + jac_blending_inv_1_2_q_2*tmp_kernel_op_240;
             const real_t tmp_kernel_op_243 = jac_blending_inv_2_0_q_2*tmp_kernel_op_238 + jac_blending_inv_2_1_q_2*tmp_kernel_op_239 + jac_blending_inv_2_2_q_2*tmp_kernel_op_240;
             const real_t tmp_kernel_op_244 = -hessian_blending_1_0_0_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_1_1_0_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_1_2_0_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_245 = -hessian_blending_1_0_1_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_1_1_1_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_1_2_1_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_246 = -hessian_blending_1_0_2_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_1_1_2_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_1_2_2_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_247 = jac_blending_inv_0_0_q_2*tmp_kernel_op_244 + jac_blending_inv_0_1_q_2*tmp_kernel_op_245 + jac_blending_inv_0_2_q_2*tmp_kernel_op_246;
             const real_t tmp_kernel_op_248 = jac_blending_inv_1_0_q_2*tmp_kernel_op_244 + jac_blending_inv_1_1_q_2*tmp_kernel_op_245 + jac_blending_inv_1_2_q_2*tmp_kernel_op_246;
             const real_t tmp_kernel_op_249 = jac_blending_inv_2_0_q_2*tmp_kernel_op_244 + jac_blending_inv_2_1_q_2*tmp_kernel_op_245 + jac_blending_inv_2_2_q_2*tmp_kernel_op_246;
             const real_t tmp_kernel_op_250 = -hessian_blending_2_0_0_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_2_1_0_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_2_2_0_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_251 = -hessian_blending_2_0_1_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_2_1_1_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_2_2_1_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_252 = -hessian_blending_2_0_2_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_2_1_2_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_2_2_2_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_253 = jac_blending_inv_0_0_q_2*tmp_kernel_op_250 + jac_blending_inv_0_1_q_2*tmp_kernel_op_251 + jac_blending_inv_0_2_q_2*tmp_kernel_op_252;
             const real_t tmp_kernel_op_254 = jac_blending_inv_1_0_q_2*tmp_kernel_op_250 + jac_blending_inv_1_1_q_2*tmp_kernel_op_251 + jac_blending_inv_1_2_q_2*tmp_kernel_op_252;
             const real_t tmp_kernel_op_255 = jac_blending_inv_2_0_q_2*tmp_kernel_op_250 + jac_blending_inv_2_1_q_2*tmp_kernel_op_251 + jac_blending_inv_2_2_q_2*tmp_kernel_op_252;
             const real_t tmp_kernel_op_256 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_743 + jac_blending_inv_1_0_q_2*tmp_moved_constant_749 + jac_blending_inv_2_0_q_2*tmp_moved_constant_755) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_768 + tmp_kernel_op_205*tmp_moved_constant_769 + tmp_kernel_op_207*tmp_moved_constant_770) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_743 + jac_blending_inv_1_1_q_2*tmp_moved_constant_749 + jac_blending_inv_2_1_q_2*tmp_moved_constant_755) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_768 + tmp_kernel_op_212*tmp_moved_constant_769 + tmp_kernel_op_213*tmp_moved_constant_770) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_743 + jac_blending_inv_1_2_q_2*tmp_moved_constant_749 + jac_blending_inv_2_2_q_2*tmp_moved_constant_755) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_768 + tmp_kernel_op_218*tmp_moved_constant_769 + tmp_kernel_op_219*tmp_moved_constant_770) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_756 + jac_blending_inv_1_0_q_2*tmp_moved_constant_757 + jac_blending_inv_2_0_q_2*tmp_moved_constant_758) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_768 + tmp_kernel_op_224*tmp_moved_constant_769 + tmp_kernel_op_225*tmp_moved_constant_770) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_756 + jac_blending_inv_1_1_q_2*tmp_moved_constant_757 + jac_blending_inv_2_1_q_2*tmp_moved_constant_758) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_768 + tmp_kernel_op_230*tmp_moved_constant_769 + tmp_kernel_op_231*tmp_moved_constant_770) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_756 + jac_blending_inv_1_2_q_2*tmp_moved_constant_757 + jac_blending_inv_2_2_q_2*tmp_moved_constant_758) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_768 + tmp_kernel_op_236*tmp_moved_constant_769 + tmp_kernel_op_237*tmp_moved_constant_770) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_759 + jac_blending_inv_1_0_q_2*tmp_moved_constant_760 + jac_blending_inv_2_0_q_2*tmp_moved_constant_761) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_768 + tmp_kernel_op_242*tmp_moved_constant_769 + tmp_kernel_op_243*tmp_moved_constant_770) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_759 + jac_blending_inv_1_1_q_2*tmp_moved_constant_760 + jac_blending_inv_2_1_q_2*tmp_moved_constant_761) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_768 + tmp_kernel_op_248*tmp_moved_constant_769 + tmp_kernel_op_249*tmp_moved_constant_770) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_759 + jac_blending_inv_1_2_q_2*tmp_moved_constant_760 + jac_blending_inv_2_2_q_2*tmp_moved_constant_761) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_768 + tmp_kernel_op_254*tmp_moved_constant_769 + tmp_kernel_op_255*tmp_moved_constant_770);
             const real_t tmp_kernel_op_274 = tmp_kernel_op_257*wx_dof_4 + tmp_kernel_op_258*wx_dof_5 + tmp_kernel_op_259*wx_dof_6 + tmp_kernel_op_262*wx_dof_1 + tmp_kernel_op_265*wx_dof_2 + tmp_kernel_op_268*wx_dof_3 + tmp_kernel_op_269*wx_dof_7 + tmp_kernel_op_270*wx_dof_8 + tmp_kernel_op_272*wx_dof_9 + tmp_kernel_op_273*wx_dof_0;
             const real_t tmp_kernel_op_275 = tmp_kernel_op_257*wy_dof_4 + tmp_kernel_op_258*wy_dof_5 + tmp_kernel_op_259*wy_dof_6 + tmp_kernel_op_262*wy_dof_1 + tmp_kernel_op_265*wy_dof_2 + tmp_kernel_op_268*wy_dof_3 + tmp_kernel_op_269*wy_dof_7 + tmp_kernel_op_270*wy_dof_8 + tmp_kernel_op_272*wy_dof_9 + tmp_kernel_op_273*wy_dof_0;
             const real_t tmp_kernel_op_276 = tmp_kernel_op_257*wz_dof_4 + tmp_kernel_op_258*wz_dof_5 + tmp_kernel_op_259*wz_dof_6 + tmp_kernel_op_262*wz_dof_1 + tmp_kernel_op_265*wz_dof_2 + tmp_kernel_op_268*wz_dof_3 + tmp_kernel_op_269*wz_dof_7 + tmp_kernel_op_270*wz_dof_8 + tmp_kernel_op_272*wz_dof_9 + tmp_kernel_op_273*wz_dof_0;
             const real_t tmp_kernel_op_277 = abs_det_jac_affine_BLUE_DOWN*abs_det_jac_blending_q_2*(diffusivity_times_delta_dof_0*tmp_kernel_op_273 + diffusivity_times_delta_dof_1*tmp_kernel_op_262 + diffusivity_times_delta_dof_2*tmp_kernel_op_265 + diffusivity_times_delta_dof_3*tmp_kernel_op_268 + diffusivity_times_delta_dof_4*tmp_kernel_op_257 + diffusivity_times_delta_dof_5*tmp_kernel_op_258 + diffusivity_times_delta_dof_6*tmp_kernel_op_259 + diffusivity_times_delta_dof_7*tmp_kernel_op_269 + diffusivity_times_delta_dof_8*tmp_kernel_op_270 + diffusivity_times_delta_dof_9*tmp_kernel_op_272)*0.074999999999999983;
             const real_t tmp_kernel_op_278 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_768 + jac_blending_inv_1_0_q_2*tmp_moved_constant_769 + jac_blending_inv_2_0_q_2*tmp_moved_constant_770) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_768 + jac_blending_inv_1_1_q_2*tmp_moved_constant_769 + jac_blending_inv_2_1_q_2*tmp_moved_constant_770) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_768 + jac_blending_inv_1_2_q_2*tmp_moved_constant_769 + jac_blending_inv_2_2_q_2*tmp_moved_constant_770));
             const real_t tmp_kernel_op_285 = -hessian_blending_0_0_0_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_0_1_0_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_0_2_0_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_286 = -hessian_blending_0_0_1_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_0_1_1_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_0_2_1_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_287 = -hessian_blending_0_0_2_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_0_1_2_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_0_2_2_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_288 = jac_blending_inv_0_0_q_3*tmp_kernel_op_285 + jac_blending_inv_0_1_q_3*tmp_kernel_op_286 + jac_blending_inv_0_2_q_3*tmp_kernel_op_287;
             const real_t tmp_kernel_op_290 = jac_blending_inv_1_0_q_3*tmp_kernel_op_285 + jac_blending_inv_1_1_q_3*tmp_kernel_op_286 + jac_blending_inv_1_2_q_3*tmp_kernel_op_287;
             const real_t tmp_kernel_op_292 = jac_blending_inv_2_0_q_3*tmp_kernel_op_285 + jac_blending_inv_2_1_q_3*tmp_kernel_op_286 + jac_blending_inv_2_2_q_3*tmp_kernel_op_287;
             const real_t tmp_kernel_op_293 = -hessian_blending_1_0_0_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_1_1_0_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_1_2_0_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_294 = -hessian_blending_1_0_1_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_1_1_1_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_1_2_1_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_295 = -hessian_blending_1_0_2_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_1_1_2_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_1_2_2_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_296 = jac_blending_inv_0_0_q_3*tmp_kernel_op_293 + jac_blending_inv_0_1_q_3*tmp_kernel_op_294 + jac_blending_inv_0_2_q_3*tmp_kernel_op_295;
             const real_t tmp_kernel_op_297 = jac_blending_inv_1_0_q_3*tmp_kernel_op_293 + jac_blending_inv_1_1_q_3*tmp_kernel_op_294 + jac_blending_inv_1_2_q_3*tmp_kernel_op_295;
             const real_t tmp_kernel_op_298 = jac_blending_inv_2_0_q_3*tmp_kernel_op_293 + jac_blending_inv_2_1_q_3*tmp_kernel_op_294 + jac_blending_inv_2_2_q_3*tmp_kernel_op_295;
             const real_t tmp_kernel_op_299 = -hessian_blending_2_0_0_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_2_1_0_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_2_2_0_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_300 = -hessian_blending_2_0_1_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_2_1_1_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_2_2_1_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_301 = -hessian_blending_2_0_2_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_2_1_2_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_2_2_2_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_302 = jac_blending_inv_0_0_q_3*tmp_kernel_op_299 + jac_blending_inv_0_1_q_3*tmp_kernel_op_300 + jac_blending_inv_0_2_q_3*tmp_kernel_op_301;
             const real_t tmp_kernel_op_303 = jac_blending_inv_1_0_q_3*tmp_kernel_op_299 + jac_blending_inv_1_1_q_3*tmp_kernel_op_300 + jac_blending_inv_1_2_q_3*tmp_kernel_op_301;
             const real_t tmp_kernel_op_304 = jac_blending_inv_2_0_q_3*tmp_kernel_op_299 + jac_blending_inv_2_1_q_3*tmp_kernel_op_300 + jac_blending_inv_2_2_q_3*tmp_kernel_op_301;
             const real_t tmp_kernel_op_305 = -hessian_blending_0_0_0_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_0_1_0_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_0_2_0_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_306 = -hessian_blending_0_0_1_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_0_1_1_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_0_2_1_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_307 = -hessian_blending_0_0_2_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_0_1_2_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_0_2_2_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_308 = jac_blending_inv_0_0_q_3*tmp_kernel_op_305 + jac_blending_inv_0_1_q_3*tmp_kernel_op_306 + jac_blending_inv_0_2_q_3*tmp_kernel_op_307;
             const real_t tmp_kernel_op_309 = jac_blending_inv_1_0_q_3*tmp_kernel_op_305 + jac_blending_inv_1_1_q_3*tmp_kernel_op_306 + jac_blending_inv_1_2_q_3*tmp_kernel_op_307;
             const real_t tmp_kernel_op_310 = jac_blending_inv_2_0_q_3*tmp_kernel_op_305 + jac_blending_inv_2_1_q_3*tmp_kernel_op_306 + jac_blending_inv_2_2_q_3*tmp_kernel_op_307;
             const real_t tmp_kernel_op_311 = -hessian_blending_1_0_0_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_1_1_0_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_1_2_0_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_312 = -hessian_blending_1_0_1_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_1_1_1_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_1_2_1_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_313 = -hessian_blending_1_0_2_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_1_1_2_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_1_2_2_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_314 = jac_blending_inv_0_0_q_3*tmp_kernel_op_311 + jac_blending_inv_0_1_q_3*tmp_kernel_op_312 + jac_blending_inv_0_2_q_3*tmp_kernel_op_313;
             const real_t tmp_kernel_op_315 = jac_blending_inv_1_0_q_3*tmp_kernel_op_311 + jac_blending_inv_1_1_q_3*tmp_kernel_op_312 + jac_blending_inv_1_2_q_3*tmp_kernel_op_313;
             const real_t tmp_kernel_op_316 = jac_blending_inv_2_0_q_3*tmp_kernel_op_311 + jac_blending_inv_2_1_q_3*tmp_kernel_op_312 + jac_blending_inv_2_2_q_3*tmp_kernel_op_313;
             const real_t tmp_kernel_op_317 = -hessian_blending_2_0_0_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_2_1_0_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_2_2_0_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_318 = -hessian_blending_2_0_1_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_2_1_1_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_2_2_1_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_319 = -hessian_blending_2_0_2_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_2_1_2_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_2_2_2_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_320 = jac_blending_inv_0_0_q_3*tmp_kernel_op_317 + jac_blending_inv_0_1_q_3*tmp_kernel_op_318 + jac_blending_inv_0_2_q_3*tmp_kernel_op_319;
             const real_t tmp_kernel_op_321 = jac_blending_inv_1_0_q_3*tmp_kernel_op_317 + jac_blending_inv_1_1_q_3*tmp_kernel_op_318 + jac_blending_inv_1_2_q_3*tmp_kernel_op_319;
             const real_t tmp_kernel_op_322 = jac_blending_inv_2_0_q_3*tmp_kernel_op_317 + jac_blending_inv_2_1_q_3*tmp_kernel_op_318 + jac_blending_inv_2_2_q_3*tmp_kernel_op_319;
             const real_t tmp_kernel_op_323 = -hessian_blending_0_0_0_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_0_1_0_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_0_2_0_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_324 = -hessian_blending_0_0_1_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_0_1_1_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_0_2_1_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_325 = -hessian_blending_0_0_2_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_0_1_2_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_0_2_2_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_326 = jac_blending_inv_0_0_q_3*tmp_kernel_op_323 + jac_blending_inv_0_1_q_3*tmp_kernel_op_324 + jac_blending_inv_0_2_q_3*tmp_kernel_op_325;
             const real_t tmp_kernel_op_327 = jac_blending_inv_1_0_q_3*tmp_kernel_op_323 + jac_blending_inv_1_1_q_3*tmp_kernel_op_324 + jac_blending_inv_1_2_q_3*tmp_kernel_op_325;
             const real_t tmp_kernel_op_328 = jac_blending_inv_2_0_q_3*tmp_kernel_op_323 + jac_blending_inv_2_1_q_3*tmp_kernel_op_324 + jac_blending_inv_2_2_q_3*tmp_kernel_op_325;
             const real_t tmp_kernel_op_329 = -hessian_blending_1_0_0_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_1_1_0_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_1_2_0_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_330 = -hessian_blending_1_0_1_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_1_1_1_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_1_2_1_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_331 = -hessian_blending_1_0_2_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_1_1_2_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_1_2_2_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_332 = jac_blending_inv_0_0_q_3*tmp_kernel_op_329 + jac_blending_inv_0_1_q_3*tmp_kernel_op_330 + jac_blending_inv_0_2_q_3*tmp_kernel_op_331;
             const real_t tmp_kernel_op_333 = jac_blending_inv_1_0_q_3*tmp_kernel_op_329 + jac_blending_inv_1_1_q_3*tmp_kernel_op_330 + jac_blending_inv_1_2_q_3*tmp_kernel_op_331;
             const real_t tmp_kernel_op_334 = jac_blending_inv_2_0_q_3*tmp_kernel_op_329 + jac_blending_inv_2_1_q_3*tmp_kernel_op_330 + jac_blending_inv_2_2_q_3*tmp_kernel_op_331;
             const real_t tmp_kernel_op_335 = -hessian_blending_2_0_0_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_2_1_0_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_2_2_0_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_336 = -hessian_blending_2_0_1_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_2_1_1_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_2_2_1_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_337 = -hessian_blending_2_0_2_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_2_1_2_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_2_2_2_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_338 = jac_blending_inv_0_0_q_3*tmp_kernel_op_335 + jac_blending_inv_0_1_q_3*tmp_kernel_op_336 + jac_blending_inv_0_2_q_3*tmp_kernel_op_337;
             const real_t tmp_kernel_op_339 = jac_blending_inv_1_0_q_3*tmp_kernel_op_335 + jac_blending_inv_1_1_q_3*tmp_kernel_op_336 + jac_blending_inv_1_2_q_3*tmp_kernel_op_337;
             const real_t tmp_kernel_op_340 = jac_blending_inv_2_0_q_3*tmp_kernel_op_335 + jac_blending_inv_2_1_q_3*tmp_kernel_op_336 + jac_blending_inv_2_2_q_3*tmp_kernel_op_337;
             const real_t tmp_kernel_op_341 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_743 + jac_blending_inv_1_0_q_3*tmp_moved_constant_749 + jac_blending_inv_2_0_q_3*tmp_moved_constant_755) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_771 + tmp_kernel_op_290*tmp_moved_constant_772 + tmp_kernel_op_292*tmp_moved_constant_773) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_743 + jac_blending_inv_1_1_q_3*tmp_moved_constant_749 + jac_blending_inv_2_1_q_3*tmp_moved_constant_755) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_771 + tmp_kernel_op_297*tmp_moved_constant_772 + tmp_kernel_op_298*tmp_moved_constant_773) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_743 + jac_blending_inv_1_2_q_3*tmp_moved_constant_749 + jac_blending_inv_2_2_q_3*tmp_moved_constant_755) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_771 + tmp_kernel_op_303*tmp_moved_constant_772 + tmp_kernel_op_304*tmp_moved_constant_773) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_756 + jac_blending_inv_1_0_q_3*tmp_moved_constant_757 + jac_blending_inv_2_0_q_3*tmp_moved_constant_758) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_771 + tmp_kernel_op_309*tmp_moved_constant_772 + tmp_kernel_op_310*tmp_moved_constant_773) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_756 + jac_blending_inv_1_1_q_3*tmp_moved_constant_757 + jac_blending_inv_2_1_q_3*tmp_moved_constant_758) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_771 + tmp_kernel_op_315*tmp_moved_constant_772 + tmp_kernel_op_316*tmp_moved_constant_773) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_756 + jac_blending_inv_1_2_q_3*tmp_moved_constant_757 + jac_blending_inv_2_2_q_3*tmp_moved_constant_758) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_771 + tmp_kernel_op_321*tmp_moved_constant_772 + tmp_kernel_op_322*tmp_moved_constant_773) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_759 + jac_blending_inv_1_0_q_3*tmp_moved_constant_760 + jac_blending_inv_2_0_q_3*tmp_moved_constant_761) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_771 + tmp_kernel_op_327*tmp_moved_constant_772 + tmp_kernel_op_328*tmp_moved_constant_773) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_759 + jac_blending_inv_1_1_q_3*tmp_moved_constant_760 + jac_blending_inv_2_1_q_3*tmp_moved_constant_761) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_771 + tmp_kernel_op_333*tmp_moved_constant_772 + tmp_kernel_op_334*tmp_moved_constant_773) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_759 + jac_blending_inv_1_2_q_3*tmp_moved_constant_760 + jac_blending_inv_2_2_q_3*tmp_moved_constant_761) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_771 + tmp_kernel_op_339*tmp_moved_constant_772 + tmp_kernel_op_340*tmp_moved_constant_773);
             const real_t tmp_kernel_op_359 = tmp_kernel_op_342*wx_dof_4 + tmp_kernel_op_343*wx_dof_5 + tmp_kernel_op_344*wx_dof_6 + tmp_kernel_op_347*wx_dof_1 + tmp_kernel_op_350*wx_dof_2 + tmp_kernel_op_353*wx_dof_3 + tmp_kernel_op_354*wx_dof_7 + tmp_kernel_op_355*wx_dof_8 + tmp_kernel_op_357*wx_dof_9 + tmp_kernel_op_358*wx_dof_0;
             const real_t tmp_kernel_op_360 = tmp_kernel_op_342*wy_dof_4 + tmp_kernel_op_343*wy_dof_5 + tmp_kernel_op_344*wy_dof_6 + tmp_kernel_op_347*wy_dof_1 + tmp_kernel_op_350*wy_dof_2 + tmp_kernel_op_353*wy_dof_3 + tmp_kernel_op_354*wy_dof_7 + tmp_kernel_op_355*wy_dof_8 + tmp_kernel_op_357*wy_dof_9 + tmp_kernel_op_358*wy_dof_0;
             const real_t tmp_kernel_op_361 = tmp_kernel_op_342*wz_dof_4 + tmp_kernel_op_343*wz_dof_5 + tmp_kernel_op_344*wz_dof_6 + tmp_kernel_op_347*wz_dof_1 + tmp_kernel_op_350*wz_dof_2 + tmp_kernel_op_353*wz_dof_3 + tmp_kernel_op_354*wz_dof_7 + tmp_kernel_op_355*wz_dof_8 + tmp_kernel_op_357*wz_dof_9 + tmp_kernel_op_358*wz_dof_0;
             const real_t tmp_kernel_op_362 = abs_det_jac_affine_BLUE_DOWN*abs_det_jac_blending_q_3*(diffusivity_times_delta_dof_0*tmp_kernel_op_358 + diffusivity_times_delta_dof_1*tmp_kernel_op_347 + diffusivity_times_delta_dof_2*tmp_kernel_op_350 + diffusivity_times_delta_dof_3*tmp_kernel_op_353 + diffusivity_times_delta_dof_4*tmp_kernel_op_342 + diffusivity_times_delta_dof_5*tmp_kernel_op_343 + diffusivity_times_delta_dof_6*tmp_kernel_op_344 + diffusivity_times_delta_dof_7*tmp_kernel_op_354 + diffusivity_times_delta_dof_8*tmp_kernel_op_355 + diffusivity_times_delta_dof_9*tmp_kernel_op_357)*0.074999999999999983;
             const real_t tmp_kernel_op_363 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_771 + jac_blending_inv_1_0_q_3*tmp_moved_constant_772 + jac_blending_inv_2_0_q_3*tmp_moved_constant_773) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_771 + jac_blending_inv_1_1_q_3*tmp_moved_constant_772 + jac_blending_inv_2_1_q_3*tmp_moved_constant_773) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_771 + jac_blending_inv_1_2_q_3*tmp_moved_constant_772 + jac_blending_inv_2_2_q_3*tmp_moved_constant_773));
             const real_t tmp_kernel_op_370 = -hessian_blending_0_0_0_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_0_1_0_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_0_2_0_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_371 = -hessian_blending_0_0_1_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_0_1_1_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_0_2_1_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_372 = -hessian_blending_0_0_2_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_0_1_2_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_0_2_2_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_373 = jac_blending_inv_0_0_q_4*tmp_kernel_op_370 + jac_blending_inv_0_1_q_4*tmp_kernel_op_371 + jac_blending_inv_0_2_q_4*tmp_kernel_op_372;
             const real_t tmp_kernel_op_375 = jac_blending_inv_1_0_q_4*tmp_kernel_op_370 + jac_blending_inv_1_1_q_4*tmp_kernel_op_371 + jac_blending_inv_1_2_q_4*tmp_kernel_op_372;
             const real_t tmp_kernel_op_377 = jac_blending_inv_2_0_q_4*tmp_kernel_op_370 + jac_blending_inv_2_1_q_4*tmp_kernel_op_371 + jac_blending_inv_2_2_q_4*tmp_kernel_op_372;
             const real_t tmp_kernel_op_378 = -hessian_blending_1_0_0_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_1_1_0_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_1_2_0_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_379 = -hessian_blending_1_0_1_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_1_1_1_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_1_2_1_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_380 = -hessian_blending_1_0_2_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_1_1_2_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_1_2_2_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_381 = jac_blending_inv_0_0_q_4*tmp_kernel_op_378 + jac_blending_inv_0_1_q_4*tmp_kernel_op_379 + jac_blending_inv_0_2_q_4*tmp_kernel_op_380;
             const real_t tmp_kernel_op_382 = jac_blending_inv_1_0_q_4*tmp_kernel_op_378 + jac_blending_inv_1_1_q_4*tmp_kernel_op_379 + jac_blending_inv_1_2_q_4*tmp_kernel_op_380;
             const real_t tmp_kernel_op_383 = jac_blending_inv_2_0_q_4*tmp_kernel_op_378 + jac_blending_inv_2_1_q_4*tmp_kernel_op_379 + jac_blending_inv_2_2_q_4*tmp_kernel_op_380;
             const real_t tmp_kernel_op_384 = -hessian_blending_2_0_0_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_2_1_0_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_2_2_0_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_385 = -hessian_blending_2_0_1_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_2_1_1_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_2_2_1_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_386 = -hessian_blending_2_0_2_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_2_1_2_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_2_2_2_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_387 = jac_blending_inv_0_0_q_4*tmp_kernel_op_384 + jac_blending_inv_0_1_q_4*tmp_kernel_op_385 + jac_blending_inv_0_2_q_4*tmp_kernel_op_386;
             const real_t tmp_kernel_op_388 = jac_blending_inv_1_0_q_4*tmp_kernel_op_384 + jac_blending_inv_1_1_q_4*tmp_kernel_op_385 + jac_blending_inv_1_2_q_4*tmp_kernel_op_386;
             const real_t tmp_kernel_op_389 = jac_blending_inv_2_0_q_4*tmp_kernel_op_384 + jac_blending_inv_2_1_q_4*tmp_kernel_op_385 + jac_blending_inv_2_2_q_4*tmp_kernel_op_386;
             const real_t tmp_kernel_op_390 = -hessian_blending_0_0_0_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_0_1_0_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_0_2_0_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_391 = -hessian_blending_0_0_1_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_0_1_1_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_0_2_1_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_392 = -hessian_blending_0_0_2_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_0_1_2_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_0_2_2_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_393 = jac_blending_inv_0_0_q_4*tmp_kernel_op_390 + jac_blending_inv_0_1_q_4*tmp_kernel_op_391 + jac_blending_inv_0_2_q_4*tmp_kernel_op_392;
             const real_t tmp_kernel_op_394 = jac_blending_inv_1_0_q_4*tmp_kernel_op_390 + jac_blending_inv_1_1_q_4*tmp_kernel_op_391 + jac_blending_inv_1_2_q_4*tmp_kernel_op_392;
             const real_t tmp_kernel_op_395 = jac_blending_inv_2_0_q_4*tmp_kernel_op_390 + jac_blending_inv_2_1_q_4*tmp_kernel_op_391 + jac_blending_inv_2_2_q_4*tmp_kernel_op_392;
             const real_t tmp_kernel_op_396 = -hessian_blending_1_0_0_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_1_1_0_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_1_2_0_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_397 = -hessian_blending_1_0_1_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_1_1_1_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_1_2_1_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_398 = -hessian_blending_1_0_2_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_1_1_2_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_1_2_2_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_399 = jac_blending_inv_0_0_q_4*tmp_kernel_op_396 + jac_blending_inv_0_1_q_4*tmp_kernel_op_397 + jac_blending_inv_0_2_q_4*tmp_kernel_op_398;
             const real_t tmp_kernel_op_400 = jac_blending_inv_1_0_q_4*tmp_kernel_op_396 + jac_blending_inv_1_1_q_4*tmp_kernel_op_397 + jac_blending_inv_1_2_q_4*tmp_kernel_op_398;
             const real_t tmp_kernel_op_401 = jac_blending_inv_2_0_q_4*tmp_kernel_op_396 + jac_blending_inv_2_1_q_4*tmp_kernel_op_397 + jac_blending_inv_2_2_q_4*tmp_kernel_op_398;
             const real_t tmp_kernel_op_402 = -hessian_blending_2_0_0_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_2_1_0_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_2_2_0_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_403 = -hessian_blending_2_0_1_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_2_1_1_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_2_2_1_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_404 = -hessian_blending_2_0_2_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_2_1_2_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_2_2_2_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_405 = jac_blending_inv_0_0_q_4*tmp_kernel_op_402 + jac_blending_inv_0_1_q_4*tmp_kernel_op_403 + jac_blending_inv_0_2_q_4*tmp_kernel_op_404;
             const real_t tmp_kernel_op_406 = jac_blending_inv_1_0_q_4*tmp_kernel_op_402 + jac_blending_inv_1_1_q_4*tmp_kernel_op_403 + jac_blending_inv_1_2_q_4*tmp_kernel_op_404;
             const real_t tmp_kernel_op_407 = jac_blending_inv_2_0_q_4*tmp_kernel_op_402 + jac_blending_inv_2_1_q_4*tmp_kernel_op_403 + jac_blending_inv_2_2_q_4*tmp_kernel_op_404;
             const real_t tmp_kernel_op_408 = -hessian_blending_0_0_0_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_0_1_0_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_0_2_0_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_409 = -hessian_blending_0_0_1_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_0_1_1_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_0_2_1_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_410 = -hessian_blending_0_0_2_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_0_1_2_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_0_2_2_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_411 = jac_blending_inv_0_0_q_4*tmp_kernel_op_408 + jac_blending_inv_0_1_q_4*tmp_kernel_op_409 + jac_blending_inv_0_2_q_4*tmp_kernel_op_410;
             const real_t tmp_kernel_op_412 = jac_blending_inv_1_0_q_4*tmp_kernel_op_408 + jac_blending_inv_1_1_q_4*tmp_kernel_op_409 + jac_blending_inv_1_2_q_4*tmp_kernel_op_410;
             const real_t tmp_kernel_op_413 = jac_blending_inv_2_0_q_4*tmp_kernel_op_408 + jac_blending_inv_2_1_q_4*tmp_kernel_op_409 + jac_blending_inv_2_2_q_4*tmp_kernel_op_410;
             const real_t tmp_kernel_op_414 = -hessian_blending_1_0_0_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_1_1_0_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_1_2_0_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_415 = -hessian_blending_1_0_1_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_1_1_1_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_1_2_1_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_416 = -hessian_blending_1_0_2_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_1_1_2_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_1_2_2_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_417 = jac_blending_inv_0_0_q_4*tmp_kernel_op_414 + jac_blending_inv_0_1_q_4*tmp_kernel_op_415 + jac_blending_inv_0_2_q_4*tmp_kernel_op_416;
             const real_t tmp_kernel_op_418 = jac_blending_inv_1_0_q_4*tmp_kernel_op_414 + jac_blending_inv_1_1_q_4*tmp_kernel_op_415 + jac_blending_inv_1_2_q_4*tmp_kernel_op_416;
             const real_t tmp_kernel_op_419 = jac_blending_inv_2_0_q_4*tmp_kernel_op_414 + jac_blending_inv_2_1_q_4*tmp_kernel_op_415 + jac_blending_inv_2_2_q_4*tmp_kernel_op_416;
             const real_t tmp_kernel_op_420 = -hessian_blending_2_0_0_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_2_1_0_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_2_2_0_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_421 = -hessian_blending_2_0_1_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_2_1_1_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_2_2_1_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_422 = -hessian_blending_2_0_2_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_2_1_2_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_2_2_2_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_423 = jac_blending_inv_0_0_q_4*tmp_kernel_op_420 + jac_blending_inv_0_1_q_4*tmp_kernel_op_421 + jac_blending_inv_0_2_q_4*tmp_kernel_op_422;
             const real_t tmp_kernel_op_424 = jac_blending_inv_1_0_q_4*tmp_kernel_op_420 + jac_blending_inv_1_1_q_4*tmp_kernel_op_421 + jac_blending_inv_1_2_q_4*tmp_kernel_op_422;
             const real_t tmp_kernel_op_425 = jac_blending_inv_2_0_q_4*tmp_kernel_op_420 + jac_blending_inv_2_1_q_4*tmp_kernel_op_421 + jac_blending_inv_2_2_q_4*tmp_kernel_op_422;
             const real_t tmp_kernel_op_426 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_743 + jac_blending_inv_1_0_q_4*tmp_moved_constant_749 + jac_blending_inv_2_0_q_4*tmp_moved_constant_755) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_774 + tmp_kernel_op_375*tmp_moved_constant_775 + tmp_kernel_op_377*tmp_moved_constant_776) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_743 + jac_blending_inv_1_1_q_4*tmp_moved_constant_749 + jac_blending_inv_2_1_q_4*tmp_moved_constant_755) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_774 + tmp_kernel_op_382*tmp_moved_constant_775 + tmp_kernel_op_383*tmp_moved_constant_776) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_743 + jac_blending_inv_1_2_q_4*tmp_moved_constant_749 + jac_blending_inv_2_2_q_4*tmp_moved_constant_755) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_774 + tmp_kernel_op_388*tmp_moved_constant_775 + tmp_kernel_op_389*tmp_moved_constant_776) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_756 + jac_blending_inv_1_0_q_4*tmp_moved_constant_757 + jac_blending_inv_2_0_q_4*tmp_moved_constant_758) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_774 + tmp_kernel_op_394*tmp_moved_constant_775 + tmp_kernel_op_395*tmp_moved_constant_776) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_756 + jac_blending_inv_1_1_q_4*tmp_moved_constant_757 + jac_blending_inv_2_1_q_4*tmp_moved_constant_758) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_774 + tmp_kernel_op_400*tmp_moved_constant_775 + tmp_kernel_op_401*tmp_moved_constant_776) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_756 + jac_blending_inv_1_2_q_4*tmp_moved_constant_757 + jac_blending_inv_2_2_q_4*tmp_moved_constant_758) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_774 + tmp_kernel_op_406*tmp_moved_constant_775 + tmp_kernel_op_407*tmp_moved_constant_776) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_759 + jac_blending_inv_1_0_q_4*tmp_moved_constant_760 + jac_blending_inv_2_0_q_4*tmp_moved_constant_761) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_774 + tmp_kernel_op_412*tmp_moved_constant_775 + tmp_kernel_op_413*tmp_moved_constant_776) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_759 + jac_blending_inv_1_1_q_4*tmp_moved_constant_760 + jac_blending_inv_2_1_q_4*tmp_moved_constant_761) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_774 + tmp_kernel_op_418*tmp_moved_constant_775 + tmp_kernel_op_419*tmp_moved_constant_776) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_759 + jac_blending_inv_1_2_q_4*tmp_moved_constant_760 + jac_blending_inv_2_2_q_4*tmp_moved_constant_761) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_774 + tmp_kernel_op_424*tmp_moved_constant_775 + tmp_kernel_op_425*tmp_moved_constant_776);
             const real_t tmp_kernel_op_444 = tmp_kernel_op_427*wx_dof_4 + tmp_kernel_op_428*wx_dof_5 + tmp_kernel_op_429*wx_dof_6 + tmp_kernel_op_432*wx_dof_1 + tmp_kernel_op_435*wx_dof_2 + tmp_kernel_op_438*wx_dof_3 + tmp_kernel_op_439*wx_dof_7 + tmp_kernel_op_440*wx_dof_8 + tmp_kernel_op_442*wx_dof_9 + tmp_kernel_op_443*wx_dof_0;
             const real_t tmp_kernel_op_445 = tmp_kernel_op_427*wy_dof_4 + tmp_kernel_op_428*wy_dof_5 + tmp_kernel_op_429*wy_dof_6 + tmp_kernel_op_432*wy_dof_1 + tmp_kernel_op_435*wy_dof_2 + tmp_kernel_op_438*wy_dof_3 + tmp_kernel_op_439*wy_dof_7 + tmp_kernel_op_440*wy_dof_8 + tmp_kernel_op_442*wy_dof_9 + tmp_kernel_op_443*wy_dof_0;
             const real_t tmp_kernel_op_446 = tmp_kernel_op_427*wz_dof_4 + tmp_kernel_op_428*wz_dof_5 + tmp_kernel_op_429*wz_dof_6 + tmp_kernel_op_432*wz_dof_1 + tmp_kernel_op_435*wz_dof_2 + tmp_kernel_op_438*wz_dof_3 + tmp_kernel_op_439*wz_dof_7 + tmp_kernel_op_440*wz_dof_8 + tmp_kernel_op_442*wz_dof_9 + tmp_kernel_op_443*wz_dof_0;
             const real_t tmp_kernel_op_447 = abs_det_jac_affine_BLUE_DOWN*abs_det_jac_blending_q_4*(diffusivity_times_delta_dof_0*tmp_kernel_op_443 + diffusivity_times_delta_dof_1*tmp_kernel_op_432 + diffusivity_times_delta_dof_2*tmp_kernel_op_435 + diffusivity_times_delta_dof_3*tmp_kernel_op_438 + diffusivity_times_delta_dof_4*tmp_kernel_op_427 + diffusivity_times_delta_dof_5*tmp_kernel_op_428 + diffusivity_times_delta_dof_6*tmp_kernel_op_429 + diffusivity_times_delta_dof_7*tmp_kernel_op_439 + diffusivity_times_delta_dof_8*tmp_kernel_op_440 + diffusivity_times_delta_dof_9*tmp_kernel_op_442)*0.074999999999999983;
             const real_t tmp_kernel_op_448 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_774 + jac_blending_inv_1_0_q_4*tmp_moved_constant_775 + jac_blending_inv_2_0_q_4*tmp_moved_constant_776) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_774 + jac_blending_inv_1_1_q_4*tmp_moved_constant_775 + jac_blending_inv_2_1_q_4*tmp_moved_constant_776) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_774 + jac_blending_inv_1_2_q_4*tmp_moved_constant_775 + jac_blending_inv_2_2_q_4*tmp_moved_constant_776));
             const real_t tmp_kernel_op_459 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_779 + jac_blending_inv_1_0_q_0*tmp_moved_constant_777 + jac_blending_inv_2_0_q_0*tmp_moved_constant_778) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_783 + tmp_kernel_op_35*tmp_moved_constant_784 + tmp_kernel_op_37*tmp_moved_constant_785) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_779 + jac_blending_inv_1_1_q_0*tmp_moved_constant_777 + jac_blending_inv_2_1_q_0*tmp_moved_constant_778) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_783 + tmp_kernel_op_42*tmp_moved_constant_784 + tmp_kernel_op_43*tmp_moved_constant_785) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_779 + jac_blending_inv_1_2_q_0*tmp_moved_constant_777 + jac_blending_inv_2_2_q_0*tmp_moved_constant_778) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_783 + tmp_kernel_op_48*tmp_moved_constant_784 + tmp_kernel_op_49*tmp_moved_constant_785) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_777 + jac_blending_inv_1_0_q_0*tmp_moved_constant_781 + jac_blending_inv_2_0_q_0*tmp_moved_constant_780) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_783 + tmp_kernel_op_54*tmp_moved_constant_784 + tmp_kernel_op_55*tmp_moved_constant_785) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_777 + jac_blending_inv_1_1_q_0*tmp_moved_constant_781 + jac_blending_inv_2_1_q_0*tmp_moved_constant_780) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_783 + tmp_kernel_op_60*tmp_moved_constant_784 + tmp_kernel_op_61*tmp_moved_constant_785) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_777 + jac_blending_inv_1_2_q_0*tmp_moved_constant_781 + jac_blending_inv_2_2_q_0*tmp_moved_constant_780) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_783 + tmp_kernel_op_66*tmp_moved_constant_784 + tmp_kernel_op_67*tmp_moved_constant_785) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_778 + jac_blending_inv_1_0_q_0*tmp_moved_constant_780 + jac_blending_inv_2_0_q_0*tmp_moved_constant_782) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_783 + tmp_kernel_op_72*tmp_moved_constant_784 + tmp_kernel_op_73*tmp_moved_constant_785) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_778 + jac_blending_inv_1_1_q_0*tmp_moved_constant_780 + jac_blending_inv_2_1_q_0*tmp_moved_constant_782) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_783 + tmp_kernel_op_78*tmp_moved_constant_784 + tmp_kernel_op_79*tmp_moved_constant_785) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_778 + jac_blending_inv_1_2_q_0*tmp_moved_constant_780 + jac_blending_inv_2_2_q_0*tmp_moved_constant_782) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_783 + tmp_kernel_op_84*tmp_moved_constant_784 + tmp_kernel_op_85*tmp_moved_constant_785);
             const real_t tmp_kernel_op_464 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_779 + jac_blending_inv_1_0_q_1*tmp_moved_constant_777 + jac_blending_inv_2_0_q_1*tmp_moved_constant_778) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_786 + tmp_kernel_op_120*tmp_moved_constant_787 + tmp_kernel_op_122*tmp_moved_constant_788) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_779 + jac_blending_inv_1_1_q_1*tmp_moved_constant_777 + jac_blending_inv_2_1_q_1*tmp_moved_constant_778) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_786 + tmp_kernel_op_127*tmp_moved_constant_787 + tmp_kernel_op_128*tmp_moved_constant_788) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_779 + jac_blending_inv_1_2_q_1*tmp_moved_constant_777 + jac_blending_inv_2_2_q_1*tmp_moved_constant_778) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_786 + tmp_kernel_op_133*tmp_moved_constant_787 + tmp_kernel_op_134*tmp_moved_constant_788) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_777 + jac_blending_inv_1_0_q_1*tmp_moved_constant_781 + jac_blending_inv_2_0_q_1*tmp_moved_constant_780) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_786 + tmp_kernel_op_139*tmp_moved_constant_787 + tmp_kernel_op_140*tmp_moved_constant_788) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_777 + jac_blending_inv_1_1_q_1*tmp_moved_constant_781 + jac_blending_inv_2_1_q_1*tmp_moved_constant_780) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_786 + tmp_kernel_op_145*tmp_moved_constant_787 + tmp_kernel_op_146*tmp_moved_constant_788) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_777 + jac_blending_inv_1_2_q_1*tmp_moved_constant_781 + jac_blending_inv_2_2_q_1*tmp_moved_constant_780) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_786 + tmp_kernel_op_151*tmp_moved_constant_787 + tmp_kernel_op_152*tmp_moved_constant_788) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_778 + jac_blending_inv_1_0_q_1*tmp_moved_constant_780 + jac_blending_inv_2_0_q_1*tmp_moved_constant_782) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_786 + tmp_kernel_op_157*tmp_moved_constant_787 + tmp_kernel_op_158*tmp_moved_constant_788) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_778 + jac_blending_inv_1_1_q_1*tmp_moved_constant_780 + jac_blending_inv_2_1_q_1*tmp_moved_constant_782) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_786 + tmp_kernel_op_163*tmp_moved_constant_787 + tmp_kernel_op_164*tmp_moved_constant_788) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_778 + jac_blending_inv_1_2_q_1*tmp_moved_constant_780 + jac_blending_inv_2_2_q_1*tmp_moved_constant_782) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_786 + tmp_kernel_op_169*tmp_moved_constant_787 + tmp_kernel_op_170*tmp_moved_constant_788);
             const real_t tmp_kernel_op_469 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_779 + jac_blending_inv_1_0_q_2*tmp_moved_constant_777 + jac_blending_inv_2_0_q_2*tmp_moved_constant_778) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_789 + tmp_kernel_op_205*tmp_moved_constant_790 + tmp_kernel_op_207*tmp_moved_constant_791) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_779 + jac_blending_inv_1_1_q_2*tmp_moved_constant_777 + jac_blending_inv_2_1_q_2*tmp_moved_constant_778) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_789 + tmp_kernel_op_212*tmp_moved_constant_790 + tmp_kernel_op_213*tmp_moved_constant_791) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_779 + jac_blending_inv_1_2_q_2*tmp_moved_constant_777 + jac_blending_inv_2_2_q_2*tmp_moved_constant_778) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_789 + tmp_kernel_op_218*tmp_moved_constant_790 + tmp_kernel_op_219*tmp_moved_constant_791) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_777 + jac_blending_inv_1_0_q_2*tmp_moved_constant_781 + jac_blending_inv_2_0_q_2*tmp_moved_constant_780) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_789 + tmp_kernel_op_224*tmp_moved_constant_790 + tmp_kernel_op_225*tmp_moved_constant_791) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_777 + jac_blending_inv_1_1_q_2*tmp_moved_constant_781 + jac_blending_inv_2_1_q_2*tmp_moved_constant_780) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_789 + tmp_kernel_op_230*tmp_moved_constant_790 + tmp_kernel_op_231*tmp_moved_constant_791) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_777 + jac_blending_inv_1_2_q_2*tmp_moved_constant_781 + jac_blending_inv_2_2_q_2*tmp_moved_constant_780) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_789 + tmp_kernel_op_236*tmp_moved_constant_790 + tmp_kernel_op_237*tmp_moved_constant_791) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_778 + jac_blending_inv_1_0_q_2*tmp_moved_constant_780 + jac_blending_inv_2_0_q_2*tmp_moved_constant_782) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_789 + tmp_kernel_op_242*tmp_moved_constant_790 + tmp_kernel_op_243*tmp_moved_constant_791) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_778 + jac_blending_inv_1_1_q_2*tmp_moved_constant_780 + jac_blending_inv_2_1_q_2*tmp_moved_constant_782) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_789 + tmp_kernel_op_248*tmp_moved_constant_790 + tmp_kernel_op_249*tmp_moved_constant_791) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_778 + jac_blending_inv_1_2_q_2*tmp_moved_constant_780 + jac_blending_inv_2_2_q_2*tmp_moved_constant_782) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_789 + tmp_kernel_op_254*tmp_moved_constant_790 + tmp_kernel_op_255*tmp_moved_constant_791);
             const real_t tmp_kernel_op_474 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_779 + jac_blending_inv_1_0_q_3*tmp_moved_constant_777 + jac_blending_inv_2_0_q_3*tmp_moved_constant_778) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_792 + tmp_kernel_op_290*tmp_moved_constant_793 + tmp_kernel_op_292*tmp_moved_constant_794) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_779 + jac_blending_inv_1_1_q_3*tmp_moved_constant_777 + jac_blending_inv_2_1_q_3*tmp_moved_constant_778) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_792 + tmp_kernel_op_297*tmp_moved_constant_793 + tmp_kernel_op_298*tmp_moved_constant_794) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_779 + jac_blending_inv_1_2_q_3*tmp_moved_constant_777 + jac_blending_inv_2_2_q_3*tmp_moved_constant_778) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_792 + tmp_kernel_op_303*tmp_moved_constant_793 + tmp_kernel_op_304*tmp_moved_constant_794) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_777 + jac_blending_inv_1_0_q_3*tmp_moved_constant_781 + jac_blending_inv_2_0_q_3*tmp_moved_constant_780) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_792 + tmp_kernel_op_309*tmp_moved_constant_793 + tmp_kernel_op_310*tmp_moved_constant_794) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_777 + jac_blending_inv_1_1_q_3*tmp_moved_constant_781 + jac_blending_inv_2_1_q_3*tmp_moved_constant_780) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_792 + tmp_kernel_op_315*tmp_moved_constant_793 + tmp_kernel_op_316*tmp_moved_constant_794) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_777 + jac_blending_inv_1_2_q_3*tmp_moved_constant_781 + jac_blending_inv_2_2_q_3*tmp_moved_constant_780) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_792 + tmp_kernel_op_321*tmp_moved_constant_793 + tmp_kernel_op_322*tmp_moved_constant_794) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_778 + jac_blending_inv_1_0_q_3*tmp_moved_constant_780 + jac_blending_inv_2_0_q_3*tmp_moved_constant_782) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_792 + tmp_kernel_op_327*tmp_moved_constant_793 + tmp_kernel_op_328*tmp_moved_constant_794) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_778 + jac_blending_inv_1_1_q_3*tmp_moved_constant_780 + jac_blending_inv_2_1_q_3*tmp_moved_constant_782) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_792 + tmp_kernel_op_333*tmp_moved_constant_793 + tmp_kernel_op_334*tmp_moved_constant_794) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_778 + jac_blending_inv_1_2_q_3*tmp_moved_constant_780 + jac_blending_inv_2_2_q_3*tmp_moved_constant_782) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_792 + tmp_kernel_op_339*tmp_moved_constant_793 + tmp_kernel_op_340*tmp_moved_constant_794);
             const real_t tmp_kernel_op_479 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_779 + jac_blending_inv_1_0_q_4*tmp_moved_constant_777 + jac_blending_inv_2_0_q_4*tmp_moved_constant_778) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_795 + tmp_kernel_op_375*tmp_moved_constant_796 + tmp_kernel_op_377*tmp_moved_constant_797) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_779 + jac_blending_inv_1_1_q_4*tmp_moved_constant_777 + jac_blending_inv_2_1_q_4*tmp_moved_constant_778) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_795 + tmp_kernel_op_382*tmp_moved_constant_796 + tmp_kernel_op_383*tmp_moved_constant_797) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_779 + jac_blending_inv_1_2_q_4*tmp_moved_constant_777 + jac_blending_inv_2_2_q_4*tmp_moved_constant_778) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_795 + tmp_kernel_op_388*tmp_moved_constant_796 + tmp_kernel_op_389*tmp_moved_constant_797) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_777 + jac_blending_inv_1_0_q_4*tmp_moved_constant_781 + jac_blending_inv_2_0_q_4*tmp_moved_constant_780) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_795 + tmp_kernel_op_394*tmp_moved_constant_796 + tmp_kernel_op_395*tmp_moved_constant_797) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_777 + jac_blending_inv_1_1_q_4*tmp_moved_constant_781 + jac_blending_inv_2_1_q_4*tmp_moved_constant_780) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_795 + tmp_kernel_op_400*tmp_moved_constant_796 + tmp_kernel_op_401*tmp_moved_constant_797) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_777 + jac_blending_inv_1_2_q_4*tmp_moved_constant_781 + jac_blending_inv_2_2_q_4*tmp_moved_constant_780) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_795 + tmp_kernel_op_406*tmp_moved_constant_796 + tmp_kernel_op_407*tmp_moved_constant_797) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_778 + jac_blending_inv_1_0_q_4*tmp_moved_constant_780 + jac_blending_inv_2_0_q_4*tmp_moved_constant_782) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_795 + tmp_kernel_op_412*tmp_moved_constant_796 + tmp_kernel_op_413*tmp_moved_constant_797) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_778 + jac_blending_inv_1_1_q_4*tmp_moved_constant_780 + jac_blending_inv_2_1_q_4*tmp_moved_constant_782) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_795 + tmp_kernel_op_418*tmp_moved_constant_796 + tmp_kernel_op_419*tmp_moved_constant_797) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_778 + jac_blending_inv_1_2_q_4*tmp_moved_constant_780 + jac_blending_inv_2_2_q_4*tmp_moved_constant_782) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_795 + tmp_kernel_op_424*tmp_moved_constant_796 + tmp_kernel_op_425*tmp_moved_constant_797);
             const real_t tmp_kernel_op_490 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_800 + jac_blending_inv_1_0_q_0*tmp_moved_constant_798 + jac_blending_inv_2_0_q_0*tmp_moved_constant_799) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_804 + tmp_kernel_op_35*tmp_moved_constant_805 + tmp_kernel_op_37*tmp_moved_constant_806) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_800 + jac_blending_inv_1_1_q_0*tmp_moved_constant_798 + jac_blending_inv_2_1_q_0*tmp_moved_constant_799) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_804 + tmp_kernel_op_42*tmp_moved_constant_805 + tmp_kernel_op_43*tmp_moved_constant_806) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_800 + jac_blending_inv_1_2_q_0*tmp_moved_constant_798 + jac_blending_inv_2_2_q_0*tmp_moved_constant_799) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_804 + tmp_kernel_op_48*tmp_moved_constant_805 + tmp_kernel_op_49*tmp_moved_constant_806) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_798 + jac_blending_inv_1_0_q_0*tmp_moved_constant_802 + jac_blending_inv_2_0_q_0*tmp_moved_constant_801) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_804 + tmp_kernel_op_54*tmp_moved_constant_805 + tmp_kernel_op_55*tmp_moved_constant_806) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_798 + jac_blending_inv_1_1_q_0*tmp_moved_constant_802 + jac_blending_inv_2_1_q_0*tmp_moved_constant_801) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_804 + tmp_kernel_op_60*tmp_moved_constant_805 + tmp_kernel_op_61*tmp_moved_constant_806) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_798 + jac_blending_inv_1_2_q_0*tmp_moved_constant_802 + jac_blending_inv_2_2_q_0*tmp_moved_constant_801) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_804 + tmp_kernel_op_66*tmp_moved_constant_805 + tmp_kernel_op_67*tmp_moved_constant_806) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_799 + jac_blending_inv_1_0_q_0*tmp_moved_constant_801 + jac_blending_inv_2_0_q_0*tmp_moved_constant_803) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_804 + tmp_kernel_op_72*tmp_moved_constant_805 + tmp_kernel_op_73*tmp_moved_constant_806) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_799 + jac_blending_inv_1_1_q_0*tmp_moved_constant_801 + jac_blending_inv_2_1_q_0*tmp_moved_constant_803) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_804 + tmp_kernel_op_78*tmp_moved_constant_805 + tmp_kernel_op_79*tmp_moved_constant_806) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_799 + jac_blending_inv_1_2_q_0*tmp_moved_constant_801 + jac_blending_inv_2_2_q_0*tmp_moved_constant_803) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_804 + tmp_kernel_op_84*tmp_moved_constant_805 + tmp_kernel_op_85*tmp_moved_constant_806);
             const real_t tmp_kernel_op_495 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_800 + jac_blending_inv_1_0_q_1*tmp_moved_constant_798 + jac_blending_inv_2_0_q_1*tmp_moved_constant_799) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_807 + tmp_kernel_op_120*tmp_moved_constant_808 + tmp_kernel_op_122*tmp_moved_constant_809) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_800 + jac_blending_inv_1_1_q_1*tmp_moved_constant_798 + jac_blending_inv_2_1_q_1*tmp_moved_constant_799) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_807 + tmp_kernel_op_127*tmp_moved_constant_808 + tmp_kernel_op_128*tmp_moved_constant_809) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_800 + jac_blending_inv_1_2_q_1*tmp_moved_constant_798 + jac_blending_inv_2_2_q_1*tmp_moved_constant_799) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_807 + tmp_kernel_op_133*tmp_moved_constant_808 + tmp_kernel_op_134*tmp_moved_constant_809) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_798 + jac_blending_inv_1_0_q_1*tmp_moved_constant_802 + jac_blending_inv_2_0_q_1*tmp_moved_constant_801) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_807 + tmp_kernel_op_139*tmp_moved_constant_808 + tmp_kernel_op_140*tmp_moved_constant_809) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_798 + jac_blending_inv_1_1_q_1*tmp_moved_constant_802 + jac_blending_inv_2_1_q_1*tmp_moved_constant_801) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_807 + tmp_kernel_op_145*tmp_moved_constant_808 + tmp_kernel_op_146*tmp_moved_constant_809) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_798 + jac_blending_inv_1_2_q_1*tmp_moved_constant_802 + jac_blending_inv_2_2_q_1*tmp_moved_constant_801) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_807 + tmp_kernel_op_151*tmp_moved_constant_808 + tmp_kernel_op_152*tmp_moved_constant_809) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_799 + jac_blending_inv_1_0_q_1*tmp_moved_constant_801 + jac_blending_inv_2_0_q_1*tmp_moved_constant_803) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_807 + tmp_kernel_op_157*tmp_moved_constant_808 + tmp_kernel_op_158*tmp_moved_constant_809) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_799 + jac_blending_inv_1_1_q_1*tmp_moved_constant_801 + jac_blending_inv_2_1_q_1*tmp_moved_constant_803) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_807 + tmp_kernel_op_163*tmp_moved_constant_808 + tmp_kernel_op_164*tmp_moved_constant_809) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_799 + jac_blending_inv_1_2_q_1*tmp_moved_constant_801 + jac_blending_inv_2_2_q_1*tmp_moved_constant_803) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_807 + tmp_kernel_op_169*tmp_moved_constant_808 + tmp_kernel_op_170*tmp_moved_constant_809);
             const real_t tmp_kernel_op_500 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_800 + jac_blending_inv_1_0_q_2*tmp_moved_constant_798 + jac_blending_inv_2_0_q_2*tmp_moved_constant_799) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_810 + tmp_kernel_op_205*tmp_moved_constant_811 + tmp_kernel_op_207*tmp_moved_constant_812) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_800 + jac_blending_inv_1_1_q_2*tmp_moved_constant_798 + jac_blending_inv_2_1_q_2*tmp_moved_constant_799) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_810 + tmp_kernel_op_212*tmp_moved_constant_811 + tmp_kernel_op_213*tmp_moved_constant_812) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_800 + jac_blending_inv_1_2_q_2*tmp_moved_constant_798 + jac_blending_inv_2_2_q_2*tmp_moved_constant_799) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_810 + tmp_kernel_op_218*tmp_moved_constant_811 + tmp_kernel_op_219*tmp_moved_constant_812) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_798 + jac_blending_inv_1_0_q_2*tmp_moved_constant_802 + jac_blending_inv_2_0_q_2*tmp_moved_constant_801) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_810 + tmp_kernel_op_224*tmp_moved_constant_811 + tmp_kernel_op_225*tmp_moved_constant_812) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_798 + jac_blending_inv_1_1_q_2*tmp_moved_constant_802 + jac_blending_inv_2_1_q_2*tmp_moved_constant_801) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_810 + tmp_kernel_op_230*tmp_moved_constant_811 + tmp_kernel_op_231*tmp_moved_constant_812) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_798 + jac_blending_inv_1_2_q_2*tmp_moved_constant_802 + jac_blending_inv_2_2_q_2*tmp_moved_constant_801) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_810 + tmp_kernel_op_236*tmp_moved_constant_811 + tmp_kernel_op_237*tmp_moved_constant_812) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_799 + jac_blending_inv_1_0_q_2*tmp_moved_constant_801 + jac_blending_inv_2_0_q_2*tmp_moved_constant_803) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_810 + tmp_kernel_op_242*tmp_moved_constant_811 + tmp_kernel_op_243*tmp_moved_constant_812) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_799 + jac_blending_inv_1_1_q_2*tmp_moved_constant_801 + jac_blending_inv_2_1_q_2*tmp_moved_constant_803) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_810 + tmp_kernel_op_248*tmp_moved_constant_811 + tmp_kernel_op_249*tmp_moved_constant_812) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_799 + jac_blending_inv_1_2_q_2*tmp_moved_constant_801 + jac_blending_inv_2_2_q_2*tmp_moved_constant_803) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_810 + tmp_kernel_op_254*tmp_moved_constant_811 + tmp_kernel_op_255*tmp_moved_constant_812);
             const real_t tmp_kernel_op_505 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_800 + jac_blending_inv_1_0_q_3*tmp_moved_constant_798 + jac_blending_inv_2_0_q_3*tmp_moved_constant_799) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_813 + tmp_kernel_op_290*tmp_moved_constant_814 + tmp_kernel_op_292*tmp_moved_constant_815) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_800 + jac_blending_inv_1_1_q_3*tmp_moved_constant_798 + jac_blending_inv_2_1_q_3*tmp_moved_constant_799) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_813 + tmp_kernel_op_297*tmp_moved_constant_814 + tmp_kernel_op_298*tmp_moved_constant_815) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_800 + jac_blending_inv_1_2_q_3*tmp_moved_constant_798 + jac_blending_inv_2_2_q_3*tmp_moved_constant_799) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_813 + tmp_kernel_op_303*tmp_moved_constant_814 + tmp_kernel_op_304*tmp_moved_constant_815) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_798 + jac_blending_inv_1_0_q_3*tmp_moved_constant_802 + jac_blending_inv_2_0_q_3*tmp_moved_constant_801) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_813 + tmp_kernel_op_309*tmp_moved_constant_814 + tmp_kernel_op_310*tmp_moved_constant_815) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_798 + jac_blending_inv_1_1_q_3*tmp_moved_constant_802 + jac_blending_inv_2_1_q_3*tmp_moved_constant_801) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_813 + tmp_kernel_op_315*tmp_moved_constant_814 + tmp_kernel_op_316*tmp_moved_constant_815) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_798 + jac_blending_inv_1_2_q_3*tmp_moved_constant_802 + jac_blending_inv_2_2_q_3*tmp_moved_constant_801) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_813 + tmp_kernel_op_321*tmp_moved_constant_814 + tmp_kernel_op_322*tmp_moved_constant_815) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_799 + jac_blending_inv_1_0_q_3*tmp_moved_constant_801 + jac_blending_inv_2_0_q_3*tmp_moved_constant_803) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_813 + tmp_kernel_op_327*tmp_moved_constant_814 + tmp_kernel_op_328*tmp_moved_constant_815) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_799 + jac_blending_inv_1_1_q_3*tmp_moved_constant_801 + jac_blending_inv_2_1_q_3*tmp_moved_constant_803) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_813 + tmp_kernel_op_333*tmp_moved_constant_814 + tmp_kernel_op_334*tmp_moved_constant_815) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_799 + jac_blending_inv_1_2_q_3*tmp_moved_constant_801 + jac_blending_inv_2_2_q_3*tmp_moved_constant_803) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_813 + tmp_kernel_op_339*tmp_moved_constant_814 + tmp_kernel_op_340*tmp_moved_constant_815);
             const real_t tmp_kernel_op_510 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_800 + jac_blending_inv_1_0_q_4*tmp_moved_constant_798 + jac_blending_inv_2_0_q_4*tmp_moved_constant_799) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_816 + tmp_kernel_op_375*tmp_moved_constant_817 + tmp_kernel_op_377*tmp_moved_constant_818) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_800 + jac_blending_inv_1_1_q_4*tmp_moved_constant_798 + jac_blending_inv_2_1_q_4*tmp_moved_constant_799) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_816 + tmp_kernel_op_382*tmp_moved_constant_817 + tmp_kernel_op_383*tmp_moved_constant_818) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_800 + jac_blending_inv_1_2_q_4*tmp_moved_constant_798 + jac_blending_inv_2_2_q_4*tmp_moved_constant_799) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_816 + tmp_kernel_op_388*tmp_moved_constant_817 + tmp_kernel_op_389*tmp_moved_constant_818) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_798 + jac_blending_inv_1_0_q_4*tmp_moved_constant_802 + jac_blending_inv_2_0_q_4*tmp_moved_constant_801) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_816 + tmp_kernel_op_394*tmp_moved_constant_817 + tmp_kernel_op_395*tmp_moved_constant_818) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_798 + jac_blending_inv_1_1_q_4*tmp_moved_constant_802 + jac_blending_inv_2_1_q_4*tmp_moved_constant_801) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_816 + tmp_kernel_op_400*tmp_moved_constant_817 + tmp_kernel_op_401*tmp_moved_constant_818) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_798 + jac_blending_inv_1_2_q_4*tmp_moved_constant_802 + jac_blending_inv_2_2_q_4*tmp_moved_constant_801) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_816 + tmp_kernel_op_406*tmp_moved_constant_817 + tmp_kernel_op_407*tmp_moved_constant_818) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_799 + jac_blending_inv_1_0_q_4*tmp_moved_constant_801 + jac_blending_inv_2_0_q_4*tmp_moved_constant_803) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_816 + tmp_kernel_op_412*tmp_moved_constant_817 + tmp_kernel_op_413*tmp_moved_constant_818) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_799 + jac_blending_inv_1_1_q_4*tmp_moved_constant_801 + jac_blending_inv_2_1_q_4*tmp_moved_constant_803) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_816 + tmp_kernel_op_418*tmp_moved_constant_817 + tmp_kernel_op_419*tmp_moved_constant_818) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_799 + jac_blending_inv_1_2_q_4*tmp_moved_constant_801 + jac_blending_inv_2_2_q_4*tmp_moved_constant_803) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_816 + tmp_kernel_op_424*tmp_moved_constant_817 + tmp_kernel_op_425*tmp_moved_constant_818);
             const real_t tmp_kernel_op_521 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_821 + jac_blending_inv_1_0_q_0*tmp_moved_constant_819 + jac_blending_inv_2_0_q_0*tmp_moved_constant_820) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_825 + tmp_kernel_op_35*tmp_moved_constant_826 + tmp_kernel_op_37*tmp_moved_constant_827) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_821 + jac_blending_inv_1_1_q_0*tmp_moved_constant_819 + jac_blending_inv_2_1_q_0*tmp_moved_constant_820) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_825 + tmp_kernel_op_42*tmp_moved_constant_826 + tmp_kernel_op_43*tmp_moved_constant_827) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_821 + jac_blending_inv_1_2_q_0*tmp_moved_constant_819 + jac_blending_inv_2_2_q_0*tmp_moved_constant_820) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_825 + tmp_kernel_op_48*tmp_moved_constant_826 + tmp_kernel_op_49*tmp_moved_constant_827) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_819 + jac_blending_inv_1_0_q_0*tmp_moved_constant_823 + jac_blending_inv_2_0_q_0*tmp_moved_constant_822) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_825 + tmp_kernel_op_54*tmp_moved_constant_826 + tmp_kernel_op_55*tmp_moved_constant_827) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_819 + jac_blending_inv_1_1_q_0*tmp_moved_constant_823 + jac_blending_inv_2_1_q_0*tmp_moved_constant_822) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_825 + tmp_kernel_op_60*tmp_moved_constant_826 + tmp_kernel_op_61*tmp_moved_constant_827) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_819 + jac_blending_inv_1_2_q_0*tmp_moved_constant_823 + jac_blending_inv_2_2_q_0*tmp_moved_constant_822) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_825 + tmp_kernel_op_66*tmp_moved_constant_826 + tmp_kernel_op_67*tmp_moved_constant_827) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_820 + jac_blending_inv_1_0_q_0*tmp_moved_constant_822 + jac_blending_inv_2_0_q_0*tmp_moved_constant_824) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_825 + tmp_kernel_op_72*tmp_moved_constant_826 + tmp_kernel_op_73*tmp_moved_constant_827) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_820 + jac_blending_inv_1_1_q_0*tmp_moved_constant_822 + jac_blending_inv_2_1_q_0*tmp_moved_constant_824) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_825 + tmp_kernel_op_78*tmp_moved_constant_826 + tmp_kernel_op_79*tmp_moved_constant_827) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_820 + jac_blending_inv_1_2_q_0*tmp_moved_constant_822 + jac_blending_inv_2_2_q_0*tmp_moved_constant_824) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_825 + tmp_kernel_op_84*tmp_moved_constant_826 + tmp_kernel_op_85*tmp_moved_constant_827);
             const real_t tmp_kernel_op_526 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_821 + jac_blending_inv_1_0_q_1*tmp_moved_constant_819 + jac_blending_inv_2_0_q_1*tmp_moved_constant_820) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_828 + tmp_kernel_op_120*tmp_moved_constant_829 + tmp_kernel_op_122*tmp_moved_constant_830) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_821 + jac_blending_inv_1_1_q_1*tmp_moved_constant_819 + jac_blending_inv_2_1_q_1*tmp_moved_constant_820) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_828 + tmp_kernel_op_127*tmp_moved_constant_829 + tmp_kernel_op_128*tmp_moved_constant_830) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_821 + jac_blending_inv_1_2_q_1*tmp_moved_constant_819 + jac_blending_inv_2_2_q_1*tmp_moved_constant_820) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_828 + tmp_kernel_op_133*tmp_moved_constant_829 + tmp_kernel_op_134*tmp_moved_constant_830) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_819 + jac_blending_inv_1_0_q_1*tmp_moved_constant_823 + jac_blending_inv_2_0_q_1*tmp_moved_constant_822) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_828 + tmp_kernel_op_139*tmp_moved_constant_829 + tmp_kernel_op_140*tmp_moved_constant_830) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_819 + jac_blending_inv_1_1_q_1*tmp_moved_constant_823 + jac_blending_inv_2_1_q_1*tmp_moved_constant_822) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_828 + tmp_kernel_op_145*tmp_moved_constant_829 + tmp_kernel_op_146*tmp_moved_constant_830) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_819 + jac_blending_inv_1_2_q_1*tmp_moved_constant_823 + jac_blending_inv_2_2_q_1*tmp_moved_constant_822) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_828 + tmp_kernel_op_151*tmp_moved_constant_829 + tmp_kernel_op_152*tmp_moved_constant_830) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_820 + jac_blending_inv_1_0_q_1*tmp_moved_constant_822 + jac_blending_inv_2_0_q_1*tmp_moved_constant_824) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_828 + tmp_kernel_op_157*tmp_moved_constant_829 + tmp_kernel_op_158*tmp_moved_constant_830) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_820 + jac_blending_inv_1_1_q_1*tmp_moved_constant_822 + jac_blending_inv_2_1_q_1*tmp_moved_constant_824) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_828 + tmp_kernel_op_163*tmp_moved_constant_829 + tmp_kernel_op_164*tmp_moved_constant_830) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_820 + jac_blending_inv_1_2_q_1*tmp_moved_constant_822 + jac_blending_inv_2_2_q_1*tmp_moved_constant_824) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_828 + tmp_kernel_op_169*tmp_moved_constant_829 + tmp_kernel_op_170*tmp_moved_constant_830);
             const real_t tmp_kernel_op_531 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_821 + jac_blending_inv_1_0_q_2*tmp_moved_constant_819 + jac_blending_inv_2_0_q_2*tmp_moved_constant_820) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_831 + tmp_kernel_op_205*tmp_moved_constant_832 + tmp_kernel_op_207*tmp_moved_constant_833) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_821 + jac_blending_inv_1_1_q_2*tmp_moved_constant_819 + jac_blending_inv_2_1_q_2*tmp_moved_constant_820) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_831 + tmp_kernel_op_212*tmp_moved_constant_832 + tmp_kernel_op_213*tmp_moved_constant_833) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_821 + jac_blending_inv_1_2_q_2*tmp_moved_constant_819 + jac_blending_inv_2_2_q_2*tmp_moved_constant_820) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_831 + tmp_kernel_op_218*tmp_moved_constant_832 + tmp_kernel_op_219*tmp_moved_constant_833) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_819 + jac_blending_inv_1_0_q_2*tmp_moved_constant_823 + jac_blending_inv_2_0_q_2*tmp_moved_constant_822) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_831 + tmp_kernel_op_224*tmp_moved_constant_832 + tmp_kernel_op_225*tmp_moved_constant_833) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_819 + jac_blending_inv_1_1_q_2*tmp_moved_constant_823 + jac_blending_inv_2_1_q_2*tmp_moved_constant_822) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_831 + tmp_kernel_op_230*tmp_moved_constant_832 + tmp_kernel_op_231*tmp_moved_constant_833) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_819 + jac_blending_inv_1_2_q_2*tmp_moved_constant_823 + jac_blending_inv_2_2_q_2*tmp_moved_constant_822) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_831 + tmp_kernel_op_236*tmp_moved_constant_832 + tmp_kernel_op_237*tmp_moved_constant_833) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_820 + jac_blending_inv_1_0_q_2*tmp_moved_constant_822 + jac_blending_inv_2_0_q_2*tmp_moved_constant_824) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_831 + tmp_kernel_op_242*tmp_moved_constant_832 + tmp_kernel_op_243*tmp_moved_constant_833) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_820 + jac_blending_inv_1_1_q_2*tmp_moved_constant_822 + jac_blending_inv_2_1_q_2*tmp_moved_constant_824) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_831 + tmp_kernel_op_248*tmp_moved_constant_832 + tmp_kernel_op_249*tmp_moved_constant_833) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_820 + jac_blending_inv_1_2_q_2*tmp_moved_constant_822 + jac_blending_inv_2_2_q_2*tmp_moved_constant_824) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_831 + tmp_kernel_op_254*tmp_moved_constant_832 + tmp_kernel_op_255*tmp_moved_constant_833);
             const real_t tmp_kernel_op_536 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_821 + jac_blending_inv_1_0_q_3*tmp_moved_constant_819 + jac_blending_inv_2_0_q_3*tmp_moved_constant_820) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_834 + tmp_kernel_op_290*tmp_moved_constant_835 + tmp_kernel_op_292*tmp_moved_constant_836) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_821 + jac_blending_inv_1_1_q_3*tmp_moved_constant_819 + jac_blending_inv_2_1_q_3*tmp_moved_constant_820) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_834 + tmp_kernel_op_297*tmp_moved_constant_835 + tmp_kernel_op_298*tmp_moved_constant_836) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_821 + jac_blending_inv_1_2_q_3*tmp_moved_constant_819 + jac_blending_inv_2_2_q_3*tmp_moved_constant_820) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_834 + tmp_kernel_op_303*tmp_moved_constant_835 + tmp_kernel_op_304*tmp_moved_constant_836) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_819 + jac_blending_inv_1_0_q_3*tmp_moved_constant_823 + jac_blending_inv_2_0_q_3*tmp_moved_constant_822) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_834 + tmp_kernel_op_309*tmp_moved_constant_835 + tmp_kernel_op_310*tmp_moved_constant_836) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_819 + jac_blending_inv_1_1_q_3*tmp_moved_constant_823 + jac_blending_inv_2_1_q_3*tmp_moved_constant_822) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_834 + tmp_kernel_op_315*tmp_moved_constant_835 + tmp_kernel_op_316*tmp_moved_constant_836) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_819 + jac_blending_inv_1_2_q_3*tmp_moved_constant_823 + jac_blending_inv_2_2_q_3*tmp_moved_constant_822) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_834 + tmp_kernel_op_321*tmp_moved_constant_835 + tmp_kernel_op_322*tmp_moved_constant_836) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_820 + jac_blending_inv_1_0_q_3*tmp_moved_constant_822 + jac_blending_inv_2_0_q_3*tmp_moved_constant_824) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_834 + tmp_kernel_op_327*tmp_moved_constant_835 + tmp_kernel_op_328*tmp_moved_constant_836) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_820 + jac_blending_inv_1_1_q_3*tmp_moved_constant_822 + jac_blending_inv_2_1_q_3*tmp_moved_constant_824) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_834 + tmp_kernel_op_333*tmp_moved_constant_835 + tmp_kernel_op_334*tmp_moved_constant_836) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_820 + jac_blending_inv_1_2_q_3*tmp_moved_constant_822 + jac_blending_inv_2_2_q_3*tmp_moved_constant_824) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_834 + tmp_kernel_op_339*tmp_moved_constant_835 + tmp_kernel_op_340*tmp_moved_constant_836);
             const real_t tmp_kernel_op_541 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_821 + jac_blending_inv_1_0_q_4*tmp_moved_constant_819 + jac_blending_inv_2_0_q_4*tmp_moved_constant_820) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_837 + tmp_kernel_op_375*tmp_moved_constant_838 + tmp_kernel_op_377*tmp_moved_constant_839) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_821 + jac_blending_inv_1_1_q_4*tmp_moved_constant_819 + jac_blending_inv_2_1_q_4*tmp_moved_constant_820) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_837 + tmp_kernel_op_382*tmp_moved_constant_838 + tmp_kernel_op_383*tmp_moved_constant_839) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_821 + jac_blending_inv_1_2_q_4*tmp_moved_constant_819 + jac_blending_inv_2_2_q_4*tmp_moved_constant_820) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_837 + tmp_kernel_op_388*tmp_moved_constant_838 + tmp_kernel_op_389*tmp_moved_constant_839) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_819 + jac_blending_inv_1_0_q_4*tmp_moved_constant_823 + jac_blending_inv_2_0_q_4*tmp_moved_constant_822) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_837 + tmp_kernel_op_394*tmp_moved_constant_838 + tmp_kernel_op_395*tmp_moved_constant_839) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_819 + jac_blending_inv_1_1_q_4*tmp_moved_constant_823 + jac_blending_inv_2_1_q_4*tmp_moved_constant_822) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_837 + tmp_kernel_op_400*tmp_moved_constant_838 + tmp_kernel_op_401*tmp_moved_constant_839) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_819 + jac_blending_inv_1_2_q_4*tmp_moved_constant_823 + jac_blending_inv_2_2_q_4*tmp_moved_constant_822) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_837 + tmp_kernel_op_406*tmp_moved_constant_838 + tmp_kernel_op_407*tmp_moved_constant_839) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_820 + jac_blending_inv_1_0_q_4*tmp_moved_constant_822 + jac_blending_inv_2_0_q_4*tmp_moved_constant_824) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_837 + tmp_kernel_op_412*tmp_moved_constant_838 + tmp_kernel_op_413*tmp_moved_constant_839) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_820 + jac_blending_inv_1_1_q_4*tmp_moved_constant_822 + jac_blending_inv_2_1_q_4*tmp_moved_constant_824) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_837 + tmp_kernel_op_418*tmp_moved_constant_838 + tmp_kernel_op_419*tmp_moved_constant_839) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_820 + jac_blending_inv_1_2_q_4*tmp_moved_constant_822 + jac_blending_inv_2_2_q_4*tmp_moved_constant_824) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_837 + tmp_kernel_op_424*tmp_moved_constant_838 + tmp_kernel_op_425*tmp_moved_constant_839);
             const real_t tmp_kernel_op_566 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_841 + jac_blending_inv_1_0_q_0*tmp_moved_constant_844 + jac_blending_inv_2_0_q_0*tmp_moved_constant_847) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_857 + tmp_kernel_op_35*tmp_moved_constant_860 + tmp_kernel_op_37*tmp_moved_constant_863) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_841 + jac_blending_inv_1_1_q_0*tmp_moved_constant_844 + jac_blending_inv_2_1_q_0*tmp_moved_constant_847) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_857 + tmp_kernel_op_42*tmp_moved_constant_860 + tmp_kernel_op_43*tmp_moved_constant_863) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_841 + jac_blending_inv_1_2_q_0*tmp_moved_constant_844 + jac_blending_inv_2_2_q_0*tmp_moved_constant_847) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_857 + tmp_kernel_op_48*tmp_moved_constant_860 + tmp_kernel_op_49*tmp_moved_constant_863) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_844 + jac_blending_inv_1_0_q_0*tmp_moved_constant_849 + jac_blending_inv_2_0_q_0*tmp_moved_constant_852) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_857 + tmp_kernel_op_54*tmp_moved_constant_860 + tmp_kernel_op_55*tmp_moved_constant_863) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_844 + jac_blending_inv_1_1_q_0*tmp_moved_constant_849 + jac_blending_inv_2_1_q_0*tmp_moved_constant_852) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_857 + tmp_kernel_op_60*tmp_moved_constant_860 + tmp_kernel_op_61*tmp_moved_constant_863) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_844 + jac_blending_inv_1_2_q_0*tmp_moved_constant_849 + jac_blending_inv_2_2_q_0*tmp_moved_constant_852) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_857 + tmp_kernel_op_66*tmp_moved_constant_860 + tmp_kernel_op_67*tmp_moved_constant_863) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_847 + jac_blending_inv_1_0_q_0*tmp_moved_constant_852 + jac_blending_inv_2_0_q_0*tmp_moved_constant_854) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_857 + tmp_kernel_op_72*tmp_moved_constant_860 + tmp_kernel_op_73*tmp_moved_constant_863) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_847 + jac_blending_inv_1_1_q_0*tmp_moved_constant_852 + jac_blending_inv_2_1_q_0*tmp_moved_constant_854) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_857 + tmp_kernel_op_78*tmp_moved_constant_860 + tmp_kernel_op_79*tmp_moved_constant_863) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_847 + jac_blending_inv_1_2_q_0*tmp_moved_constant_852 + jac_blending_inv_2_2_q_0*tmp_moved_constant_854) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_857 + tmp_kernel_op_84*tmp_moved_constant_860 + tmp_kernel_op_85*tmp_moved_constant_863);
             const real_t tmp_kernel_op_576 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_841 + jac_blending_inv_1_0_q_1*tmp_moved_constant_844 + jac_blending_inv_2_0_q_1*tmp_moved_constant_847) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_866 + tmp_kernel_op_120*tmp_moved_constant_869 + tmp_kernel_op_122*tmp_moved_constant_872) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_841 + jac_blending_inv_1_1_q_1*tmp_moved_constant_844 + jac_blending_inv_2_1_q_1*tmp_moved_constant_847) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_866 + tmp_kernel_op_127*tmp_moved_constant_869 + tmp_kernel_op_128*tmp_moved_constant_872) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_841 + jac_blending_inv_1_2_q_1*tmp_moved_constant_844 + jac_blending_inv_2_2_q_1*tmp_moved_constant_847) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_866 + tmp_kernel_op_133*tmp_moved_constant_869 + tmp_kernel_op_134*tmp_moved_constant_872) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_844 + jac_blending_inv_1_0_q_1*tmp_moved_constant_849 + jac_blending_inv_2_0_q_1*tmp_moved_constant_852) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_866 + tmp_kernel_op_139*tmp_moved_constant_869 + tmp_kernel_op_140*tmp_moved_constant_872) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_844 + jac_blending_inv_1_1_q_1*tmp_moved_constant_849 + jac_blending_inv_2_1_q_1*tmp_moved_constant_852) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_866 + tmp_kernel_op_145*tmp_moved_constant_869 + tmp_kernel_op_146*tmp_moved_constant_872) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_844 + jac_blending_inv_1_2_q_1*tmp_moved_constant_849 + jac_blending_inv_2_2_q_1*tmp_moved_constant_852) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_866 + tmp_kernel_op_151*tmp_moved_constant_869 + tmp_kernel_op_152*tmp_moved_constant_872) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_847 + jac_blending_inv_1_0_q_1*tmp_moved_constant_852 + jac_blending_inv_2_0_q_1*tmp_moved_constant_854) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_866 + tmp_kernel_op_157*tmp_moved_constant_869 + tmp_kernel_op_158*tmp_moved_constant_872) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_847 + jac_blending_inv_1_1_q_1*tmp_moved_constant_852 + jac_blending_inv_2_1_q_1*tmp_moved_constant_854) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_866 + tmp_kernel_op_163*tmp_moved_constant_869 + tmp_kernel_op_164*tmp_moved_constant_872) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_847 + jac_blending_inv_1_2_q_1*tmp_moved_constant_852 + jac_blending_inv_2_2_q_1*tmp_moved_constant_854) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_866 + tmp_kernel_op_169*tmp_moved_constant_869 + tmp_kernel_op_170*tmp_moved_constant_872);
             const real_t tmp_kernel_op_586 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_841 + jac_blending_inv_1_0_q_2*tmp_moved_constant_844 + jac_blending_inv_2_0_q_2*tmp_moved_constant_847) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_875 + tmp_kernel_op_205*tmp_moved_constant_878 + tmp_kernel_op_207*tmp_moved_constant_881) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_841 + jac_blending_inv_1_1_q_2*tmp_moved_constant_844 + jac_blending_inv_2_1_q_2*tmp_moved_constant_847) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_875 + tmp_kernel_op_212*tmp_moved_constant_878 + tmp_kernel_op_213*tmp_moved_constant_881) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_841 + jac_blending_inv_1_2_q_2*tmp_moved_constant_844 + jac_blending_inv_2_2_q_2*tmp_moved_constant_847) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_875 + tmp_kernel_op_218*tmp_moved_constant_878 + tmp_kernel_op_219*tmp_moved_constant_881) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_844 + jac_blending_inv_1_0_q_2*tmp_moved_constant_849 + jac_blending_inv_2_0_q_2*tmp_moved_constant_852) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_875 + tmp_kernel_op_224*tmp_moved_constant_878 + tmp_kernel_op_225*tmp_moved_constant_881) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_844 + jac_blending_inv_1_1_q_2*tmp_moved_constant_849 + jac_blending_inv_2_1_q_2*tmp_moved_constant_852) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_875 + tmp_kernel_op_230*tmp_moved_constant_878 + tmp_kernel_op_231*tmp_moved_constant_881) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_844 + jac_blending_inv_1_2_q_2*tmp_moved_constant_849 + jac_blending_inv_2_2_q_2*tmp_moved_constant_852) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_875 + tmp_kernel_op_236*tmp_moved_constant_878 + tmp_kernel_op_237*tmp_moved_constant_881) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_847 + jac_blending_inv_1_0_q_2*tmp_moved_constant_852 + jac_blending_inv_2_0_q_2*tmp_moved_constant_854) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_875 + tmp_kernel_op_242*tmp_moved_constant_878 + tmp_kernel_op_243*tmp_moved_constant_881) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_847 + jac_blending_inv_1_1_q_2*tmp_moved_constant_852 + jac_blending_inv_2_1_q_2*tmp_moved_constant_854) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_875 + tmp_kernel_op_248*tmp_moved_constant_878 + tmp_kernel_op_249*tmp_moved_constant_881) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_847 + jac_blending_inv_1_2_q_2*tmp_moved_constant_852 + jac_blending_inv_2_2_q_2*tmp_moved_constant_854) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_875 + tmp_kernel_op_254*tmp_moved_constant_878 + tmp_kernel_op_255*tmp_moved_constant_881);
             const real_t tmp_kernel_op_596 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_841 + jac_blending_inv_1_0_q_3*tmp_moved_constant_844 + jac_blending_inv_2_0_q_3*tmp_moved_constant_847) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_884 + tmp_kernel_op_290*tmp_moved_constant_887 + tmp_kernel_op_292*tmp_moved_constant_890) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_841 + jac_blending_inv_1_1_q_3*tmp_moved_constant_844 + jac_blending_inv_2_1_q_3*tmp_moved_constant_847) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_884 + tmp_kernel_op_297*tmp_moved_constant_887 + tmp_kernel_op_298*tmp_moved_constant_890) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_841 + jac_blending_inv_1_2_q_3*tmp_moved_constant_844 + jac_blending_inv_2_2_q_3*tmp_moved_constant_847) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_884 + tmp_kernel_op_303*tmp_moved_constant_887 + tmp_kernel_op_304*tmp_moved_constant_890) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_844 + jac_blending_inv_1_0_q_3*tmp_moved_constant_849 + jac_blending_inv_2_0_q_3*tmp_moved_constant_852) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_884 + tmp_kernel_op_309*tmp_moved_constant_887 + tmp_kernel_op_310*tmp_moved_constant_890) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_844 + jac_blending_inv_1_1_q_3*tmp_moved_constant_849 + jac_blending_inv_2_1_q_3*tmp_moved_constant_852) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_884 + tmp_kernel_op_315*tmp_moved_constant_887 + tmp_kernel_op_316*tmp_moved_constant_890) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_844 + jac_blending_inv_1_2_q_3*tmp_moved_constant_849 + jac_blending_inv_2_2_q_3*tmp_moved_constant_852) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_884 + tmp_kernel_op_321*tmp_moved_constant_887 + tmp_kernel_op_322*tmp_moved_constant_890) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_847 + jac_blending_inv_1_0_q_3*tmp_moved_constant_852 + jac_blending_inv_2_0_q_3*tmp_moved_constant_854) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_884 + tmp_kernel_op_327*tmp_moved_constant_887 + tmp_kernel_op_328*tmp_moved_constant_890) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_847 + jac_blending_inv_1_1_q_3*tmp_moved_constant_852 + jac_blending_inv_2_1_q_3*tmp_moved_constant_854) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_884 + tmp_kernel_op_333*tmp_moved_constant_887 + tmp_kernel_op_334*tmp_moved_constant_890) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_847 + jac_blending_inv_1_2_q_3*tmp_moved_constant_852 + jac_blending_inv_2_2_q_3*tmp_moved_constant_854) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_884 + tmp_kernel_op_339*tmp_moved_constant_887 + tmp_kernel_op_340*tmp_moved_constant_890);
             const real_t tmp_kernel_op_606 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_841 + jac_blending_inv_1_0_q_4*tmp_moved_constant_844 + jac_blending_inv_2_0_q_4*tmp_moved_constant_847) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_893 + tmp_kernel_op_375*tmp_moved_constant_896 + tmp_kernel_op_377*tmp_moved_constant_899) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_841 + jac_blending_inv_1_1_q_4*tmp_moved_constant_844 + jac_blending_inv_2_1_q_4*tmp_moved_constant_847) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_893 + tmp_kernel_op_382*tmp_moved_constant_896 + tmp_kernel_op_383*tmp_moved_constant_899) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_841 + jac_blending_inv_1_2_q_4*tmp_moved_constant_844 + jac_blending_inv_2_2_q_4*tmp_moved_constant_847) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_893 + tmp_kernel_op_388*tmp_moved_constant_896 + tmp_kernel_op_389*tmp_moved_constant_899) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_844 + jac_blending_inv_1_0_q_4*tmp_moved_constant_849 + jac_blending_inv_2_0_q_4*tmp_moved_constant_852) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_893 + tmp_kernel_op_394*tmp_moved_constant_896 + tmp_kernel_op_395*tmp_moved_constant_899) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_844 + jac_blending_inv_1_1_q_4*tmp_moved_constant_849 + jac_blending_inv_2_1_q_4*tmp_moved_constant_852) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_893 + tmp_kernel_op_400*tmp_moved_constant_896 + tmp_kernel_op_401*tmp_moved_constant_899) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_844 + jac_blending_inv_1_2_q_4*tmp_moved_constant_849 + jac_blending_inv_2_2_q_4*tmp_moved_constant_852) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_893 + tmp_kernel_op_406*tmp_moved_constant_896 + tmp_kernel_op_407*tmp_moved_constant_899) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_847 + jac_blending_inv_1_0_q_4*tmp_moved_constant_852 + jac_blending_inv_2_0_q_4*tmp_moved_constant_854) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_893 + tmp_kernel_op_412*tmp_moved_constant_896 + tmp_kernel_op_413*tmp_moved_constant_899) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_847 + jac_blending_inv_1_1_q_4*tmp_moved_constant_852 + jac_blending_inv_2_1_q_4*tmp_moved_constant_854) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_893 + tmp_kernel_op_418*tmp_moved_constant_896 + tmp_kernel_op_419*tmp_moved_constant_899) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_847 + jac_blending_inv_1_2_q_4*tmp_moved_constant_852 + jac_blending_inv_2_2_q_4*tmp_moved_constant_854) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_893 + tmp_kernel_op_424*tmp_moved_constant_896 + tmp_kernel_op_425*tmp_moved_constant_899);
             const real_t tmp_kernel_op_628 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_900 + jac_blending_inv_1_0_q_0*tmp_moved_constant_903 + jac_blending_inv_2_0_q_0*tmp_moved_constant_906) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_914 + tmp_kernel_op_35*tmp_moved_constant_917 + tmp_kernel_op_37*tmp_moved_constant_920) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_900 + jac_blending_inv_1_1_q_0*tmp_moved_constant_903 + jac_blending_inv_2_1_q_0*tmp_moved_constant_906) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_914 + tmp_kernel_op_42*tmp_moved_constant_917 + tmp_kernel_op_43*tmp_moved_constant_920) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_900 + jac_blending_inv_1_2_q_0*tmp_moved_constant_903 + jac_blending_inv_2_2_q_0*tmp_moved_constant_906) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_914 + tmp_kernel_op_48*tmp_moved_constant_917 + tmp_kernel_op_49*tmp_moved_constant_920) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_903 + jac_blending_inv_1_0_q_0*tmp_moved_constant_907 + jac_blending_inv_2_0_q_0*tmp_moved_constant_910) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_914 + tmp_kernel_op_54*tmp_moved_constant_917 + tmp_kernel_op_55*tmp_moved_constant_920) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_903 + jac_blending_inv_1_1_q_0*tmp_moved_constant_907 + jac_blending_inv_2_1_q_0*tmp_moved_constant_910) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_914 + tmp_kernel_op_60*tmp_moved_constant_917 + tmp_kernel_op_61*tmp_moved_constant_920) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_903 + jac_blending_inv_1_2_q_0*tmp_moved_constant_907 + jac_blending_inv_2_2_q_0*tmp_moved_constant_910) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_914 + tmp_kernel_op_66*tmp_moved_constant_917 + tmp_kernel_op_67*tmp_moved_constant_920) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_906 + jac_blending_inv_1_0_q_0*tmp_moved_constant_910 + jac_blending_inv_2_0_q_0*tmp_moved_constant_911) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_914 + tmp_kernel_op_72*tmp_moved_constant_917 + tmp_kernel_op_73*tmp_moved_constant_920) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_906 + jac_blending_inv_1_1_q_0*tmp_moved_constant_910 + jac_blending_inv_2_1_q_0*tmp_moved_constant_911) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_914 + tmp_kernel_op_78*tmp_moved_constant_917 + tmp_kernel_op_79*tmp_moved_constant_920) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_906 + jac_blending_inv_1_2_q_0*tmp_moved_constant_910 + jac_blending_inv_2_2_q_0*tmp_moved_constant_911) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_914 + tmp_kernel_op_84*tmp_moved_constant_917 + tmp_kernel_op_85*tmp_moved_constant_920);
             const real_t tmp_kernel_op_638 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_900 + jac_blending_inv_1_0_q_1*tmp_moved_constant_903 + jac_blending_inv_2_0_q_1*tmp_moved_constant_906) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_923 + tmp_kernel_op_120*tmp_moved_constant_926 + tmp_kernel_op_122*tmp_moved_constant_929) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_900 + jac_blending_inv_1_1_q_1*tmp_moved_constant_903 + jac_blending_inv_2_1_q_1*tmp_moved_constant_906) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_923 + tmp_kernel_op_127*tmp_moved_constant_926 + tmp_kernel_op_128*tmp_moved_constant_929) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_900 + jac_blending_inv_1_2_q_1*tmp_moved_constant_903 + jac_blending_inv_2_2_q_1*tmp_moved_constant_906) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_923 + tmp_kernel_op_133*tmp_moved_constant_926 + tmp_kernel_op_134*tmp_moved_constant_929) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_903 + jac_blending_inv_1_0_q_1*tmp_moved_constant_907 + jac_blending_inv_2_0_q_1*tmp_moved_constant_910) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_923 + tmp_kernel_op_139*tmp_moved_constant_926 + tmp_kernel_op_140*tmp_moved_constant_929) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_903 + jac_blending_inv_1_1_q_1*tmp_moved_constant_907 + jac_blending_inv_2_1_q_1*tmp_moved_constant_910) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_923 + tmp_kernel_op_145*tmp_moved_constant_926 + tmp_kernel_op_146*tmp_moved_constant_929) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_903 + jac_blending_inv_1_2_q_1*tmp_moved_constant_907 + jac_blending_inv_2_2_q_1*tmp_moved_constant_910) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_923 + tmp_kernel_op_151*tmp_moved_constant_926 + tmp_kernel_op_152*tmp_moved_constant_929) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_906 + jac_blending_inv_1_0_q_1*tmp_moved_constant_910 + jac_blending_inv_2_0_q_1*tmp_moved_constant_911) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_923 + tmp_kernel_op_157*tmp_moved_constant_926 + tmp_kernel_op_158*tmp_moved_constant_929) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_906 + jac_blending_inv_1_1_q_1*tmp_moved_constant_910 + jac_blending_inv_2_1_q_1*tmp_moved_constant_911) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_923 + tmp_kernel_op_163*tmp_moved_constant_926 + tmp_kernel_op_164*tmp_moved_constant_929) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_906 + jac_blending_inv_1_2_q_1*tmp_moved_constant_910 + jac_blending_inv_2_2_q_1*tmp_moved_constant_911) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_923 + tmp_kernel_op_169*tmp_moved_constant_926 + tmp_kernel_op_170*tmp_moved_constant_929);
             const real_t tmp_kernel_op_648 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_900 + jac_blending_inv_1_0_q_2*tmp_moved_constant_903 + jac_blending_inv_2_0_q_2*tmp_moved_constant_906) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_932 + tmp_kernel_op_205*tmp_moved_constant_935 + tmp_kernel_op_207*tmp_moved_constant_938) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_900 + jac_blending_inv_1_1_q_2*tmp_moved_constant_903 + jac_blending_inv_2_1_q_2*tmp_moved_constant_906) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_932 + tmp_kernel_op_212*tmp_moved_constant_935 + tmp_kernel_op_213*tmp_moved_constant_938) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_900 + jac_blending_inv_1_2_q_2*tmp_moved_constant_903 + jac_blending_inv_2_2_q_2*tmp_moved_constant_906) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_932 + tmp_kernel_op_218*tmp_moved_constant_935 + tmp_kernel_op_219*tmp_moved_constant_938) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_903 + jac_blending_inv_1_0_q_2*tmp_moved_constant_907 + jac_blending_inv_2_0_q_2*tmp_moved_constant_910) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_932 + tmp_kernel_op_224*tmp_moved_constant_935 + tmp_kernel_op_225*tmp_moved_constant_938) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_903 + jac_blending_inv_1_1_q_2*tmp_moved_constant_907 + jac_blending_inv_2_1_q_2*tmp_moved_constant_910) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_932 + tmp_kernel_op_230*tmp_moved_constant_935 + tmp_kernel_op_231*tmp_moved_constant_938) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_903 + jac_blending_inv_1_2_q_2*tmp_moved_constant_907 + jac_blending_inv_2_2_q_2*tmp_moved_constant_910) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_932 + tmp_kernel_op_236*tmp_moved_constant_935 + tmp_kernel_op_237*tmp_moved_constant_938) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_906 + jac_blending_inv_1_0_q_2*tmp_moved_constant_910 + jac_blending_inv_2_0_q_2*tmp_moved_constant_911) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_932 + tmp_kernel_op_242*tmp_moved_constant_935 + tmp_kernel_op_243*tmp_moved_constant_938) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_906 + jac_blending_inv_1_1_q_2*tmp_moved_constant_910 + jac_blending_inv_2_1_q_2*tmp_moved_constant_911) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_932 + tmp_kernel_op_248*tmp_moved_constant_935 + tmp_kernel_op_249*tmp_moved_constant_938) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_906 + jac_blending_inv_1_2_q_2*tmp_moved_constant_910 + jac_blending_inv_2_2_q_2*tmp_moved_constant_911) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_932 + tmp_kernel_op_254*tmp_moved_constant_935 + tmp_kernel_op_255*tmp_moved_constant_938);
             const real_t tmp_kernel_op_658 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_900 + jac_blending_inv_1_0_q_3*tmp_moved_constant_903 + jac_blending_inv_2_0_q_3*tmp_moved_constant_906) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_941 + tmp_kernel_op_290*tmp_moved_constant_944 + tmp_kernel_op_292*tmp_moved_constant_947) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_900 + jac_blending_inv_1_1_q_3*tmp_moved_constant_903 + jac_blending_inv_2_1_q_3*tmp_moved_constant_906) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_941 + tmp_kernel_op_297*tmp_moved_constant_944 + tmp_kernel_op_298*tmp_moved_constant_947) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_900 + jac_blending_inv_1_2_q_3*tmp_moved_constant_903 + jac_blending_inv_2_2_q_3*tmp_moved_constant_906) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_941 + tmp_kernel_op_303*tmp_moved_constant_944 + tmp_kernel_op_304*tmp_moved_constant_947) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_903 + jac_blending_inv_1_0_q_3*tmp_moved_constant_907 + jac_blending_inv_2_0_q_3*tmp_moved_constant_910) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_941 + tmp_kernel_op_309*tmp_moved_constant_944 + tmp_kernel_op_310*tmp_moved_constant_947) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_903 + jac_blending_inv_1_1_q_3*tmp_moved_constant_907 + jac_blending_inv_2_1_q_3*tmp_moved_constant_910) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_941 + tmp_kernel_op_315*tmp_moved_constant_944 + tmp_kernel_op_316*tmp_moved_constant_947) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_903 + jac_blending_inv_1_2_q_3*tmp_moved_constant_907 + jac_blending_inv_2_2_q_3*tmp_moved_constant_910) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_941 + tmp_kernel_op_321*tmp_moved_constant_944 + tmp_kernel_op_322*tmp_moved_constant_947) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_906 + jac_blending_inv_1_0_q_3*tmp_moved_constant_910 + jac_blending_inv_2_0_q_3*tmp_moved_constant_911) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_941 + tmp_kernel_op_327*tmp_moved_constant_944 + tmp_kernel_op_328*tmp_moved_constant_947) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_906 + jac_blending_inv_1_1_q_3*tmp_moved_constant_910 + jac_blending_inv_2_1_q_3*tmp_moved_constant_911) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_941 + tmp_kernel_op_333*tmp_moved_constant_944 + tmp_kernel_op_334*tmp_moved_constant_947) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_906 + jac_blending_inv_1_2_q_3*tmp_moved_constant_910 + jac_blending_inv_2_2_q_3*tmp_moved_constant_911) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_941 + tmp_kernel_op_339*tmp_moved_constant_944 + tmp_kernel_op_340*tmp_moved_constant_947);
             const real_t tmp_kernel_op_668 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_900 + jac_blending_inv_1_0_q_4*tmp_moved_constant_903 + jac_blending_inv_2_0_q_4*tmp_moved_constant_906) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_950 + tmp_kernel_op_375*tmp_moved_constant_953 + tmp_kernel_op_377*tmp_moved_constant_956) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_900 + jac_blending_inv_1_1_q_4*tmp_moved_constant_903 + jac_blending_inv_2_1_q_4*tmp_moved_constant_906) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_950 + tmp_kernel_op_382*tmp_moved_constant_953 + tmp_kernel_op_383*tmp_moved_constant_956) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_900 + jac_blending_inv_1_2_q_4*tmp_moved_constant_903 + jac_blending_inv_2_2_q_4*tmp_moved_constant_906) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_950 + tmp_kernel_op_388*tmp_moved_constant_953 + tmp_kernel_op_389*tmp_moved_constant_956) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_903 + jac_blending_inv_1_0_q_4*tmp_moved_constant_907 + jac_blending_inv_2_0_q_4*tmp_moved_constant_910) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_950 + tmp_kernel_op_394*tmp_moved_constant_953 + tmp_kernel_op_395*tmp_moved_constant_956) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_903 + jac_blending_inv_1_1_q_4*tmp_moved_constant_907 + jac_blending_inv_2_1_q_4*tmp_moved_constant_910) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_950 + tmp_kernel_op_400*tmp_moved_constant_953 + tmp_kernel_op_401*tmp_moved_constant_956) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_903 + jac_blending_inv_1_2_q_4*tmp_moved_constant_907 + jac_blending_inv_2_2_q_4*tmp_moved_constant_910) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_950 + tmp_kernel_op_406*tmp_moved_constant_953 + tmp_kernel_op_407*tmp_moved_constant_956) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_906 + jac_blending_inv_1_0_q_4*tmp_moved_constant_910 + jac_blending_inv_2_0_q_4*tmp_moved_constant_911) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_950 + tmp_kernel_op_412*tmp_moved_constant_953 + tmp_kernel_op_413*tmp_moved_constant_956) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_906 + jac_blending_inv_1_1_q_4*tmp_moved_constant_910 + jac_blending_inv_2_1_q_4*tmp_moved_constant_911) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_950 + tmp_kernel_op_418*tmp_moved_constant_953 + tmp_kernel_op_419*tmp_moved_constant_956) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_906 + jac_blending_inv_1_2_q_4*tmp_moved_constant_910 + jac_blending_inv_2_2_q_4*tmp_moved_constant_911) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_950 + tmp_kernel_op_424*tmp_moved_constant_953 + tmp_kernel_op_425*tmp_moved_constant_956);
             const real_t tmp_kernel_op_693 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_958 + jac_blending_inv_1_0_q_0*tmp_moved_constant_961 + jac_blending_inv_2_0_q_0*tmp_moved_constant_964) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_974 + tmp_kernel_op_35*tmp_moved_constant_977 + tmp_kernel_op_37*tmp_moved_constant_980) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_958 + jac_blending_inv_1_1_q_0*tmp_moved_constant_961 + jac_blending_inv_2_1_q_0*tmp_moved_constant_964) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_974 + tmp_kernel_op_42*tmp_moved_constant_977 + tmp_kernel_op_43*tmp_moved_constant_980) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_958 + jac_blending_inv_1_2_q_0*tmp_moved_constant_961 + jac_blending_inv_2_2_q_0*tmp_moved_constant_964) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_974 + tmp_kernel_op_48*tmp_moved_constant_977 + tmp_kernel_op_49*tmp_moved_constant_980) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_961 + jac_blending_inv_1_0_q_0*tmp_moved_constant_966 + jac_blending_inv_2_0_q_0*tmp_moved_constant_969) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_974 + tmp_kernel_op_54*tmp_moved_constant_977 + tmp_kernel_op_55*tmp_moved_constant_980) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_961 + jac_blending_inv_1_1_q_0*tmp_moved_constant_966 + jac_blending_inv_2_1_q_0*tmp_moved_constant_969) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_974 + tmp_kernel_op_60*tmp_moved_constant_977 + tmp_kernel_op_61*tmp_moved_constant_980) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_961 + jac_blending_inv_1_2_q_0*tmp_moved_constant_966 + jac_blending_inv_2_2_q_0*tmp_moved_constant_969) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_974 + tmp_kernel_op_66*tmp_moved_constant_977 + tmp_kernel_op_67*tmp_moved_constant_980) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_964 + jac_blending_inv_1_0_q_0*tmp_moved_constant_969 + jac_blending_inv_2_0_q_0*tmp_moved_constant_971) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_974 + tmp_kernel_op_72*tmp_moved_constant_977 + tmp_kernel_op_73*tmp_moved_constant_980) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_964 + jac_blending_inv_1_1_q_0*tmp_moved_constant_969 + jac_blending_inv_2_1_q_0*tmp_moved_constant_971) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_974 + tmp_kernel_op_78*tmp_moved_constant_977 + tmp_kernel_op_79*tmp_moved_constant_980) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_964 + jac_blending_inv_1_2_q_0*tmp_moved_constant_969 + jac_blending_inv_2_2_q_0*tmp_moved_constant_971) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_974 + tmp_kernel_op_84*tmp_moved_constant_977 + tmp_kernel_op_85*tmp_moved_constant_980);
             const real_t tmp_kernel_op_703 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_958 + jac_blending_inv_1_0_q_1*tmp_moved_constant_961 + jac_blending_inv_2_0_q_1*tmp_moved_constant_964) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_983 + tmp_kernel_op_120*tmp_moved_constant_986 + tmp_kernel_op_122*tmp_moved_constant_989) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_958 + jac_blending_inv_1_1_q_1*tmp_moved_constant_961 + jac_blending_inv_2_1_q_1*tmp_moved_constant_964) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_983 + tmp_kernel_op_127*tmp_moved_constant_986 + tmp_kernel_op_128*tmp_moved_constant_989) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_958 + jac_blending_inv_1_2_q_1*tmp_moved_constant_961 + jac_blending_inv_2_2_q_1*tmp_moved_constant_964) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_983 + tmp_kernel_op_133*tmp_moved_constant_986 + tmp_kernel_op_134*tmp_moved_constant_989) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_961 + jac_blending_inv_1_0_q_1*tmp_moved_constant_966 + jac_blending_inv_2_0_q_1*tmp_moved_constant_969) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_983 + tmp_kernel_op_139*tmp_moved_constant_986 + tmp_kernel_op_140*tmp_moved_constant_989) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_961 + jac_blending_inv_1_1_q_1*tmp_moved_constant_966 + jac_blending_inv_2_1_q_1*tmp_moved_constant_969) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_983 + tmp_kernel_op_145*tmp_moved_constant_986 + tmp_kernel_op_146*tmp_moved_constant_989) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_961 + jac_blending_inv_1_2_q_1*tmp_moved_constant_966 + jac_blending_inv_2_2_q_1*tmp_moved_constant_969) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_983 + tmp_kernel_op_151*tmp_moved_constant_986 + tmp_kernel_op_152*tmp_moved_constant_989) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_964 + jac_blending_inv_1_0_q_1*tmp_moved_constant_969 + jac_blending_inv_2_0_q_1*tmp_moved_constant_971) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_983 + tmp_kernel_op_157*tmp_moved_constant_986 + tmp_kernel_op_158*tmp_moved_constant_989) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_964 + jac_blending_inv_1_1_q_1*tmp_moved_constant_969 + jac_blending_inv_2_1_q_1*tmp_moved_constant_971) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_983 + tmp_kernel_op_163*tmp_moved_constant_986 + tmp_kernel_op_164*tmp_moved_constant_989) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_964 + jac_blending_inv_1_2_q_1*tmp_moved_constant_969 + jac_blending_inv_2_2_q_1*tmp_moved_constant_971) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_983 + tmp_kernel_op_169*tmp_moved_constant_986 + tmp_kernel_op_170*tmp_moved_constant_989);
             const real_t tmp_kernel_op_713 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_958 + jac_blending_inv_1_0_q_2*tmp_moved_constant_961 + jac_blending_inv_2_0_q_2*tmp_moved_constant_964) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_992 + tmp_kernel_op_205*tmp_moved_constant_995 + tmp_kernel_op_207*tmp_moved_constant_998) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_958 + jac_blending_inv_1_1_q_2*tmp_moved_constant_961 + jac_blending_inv_2_1_q_2*tmp_moved_constant_964) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_992 + tmp_kernel_op_212*tmp_moved_constant_995 + tmp_kernel_op_213*tmp_moved_constant_998) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_958 + jac_blending_inv_1_2_q_2*tmp_moved_constant_961 + jac_blending_inv_2_2_q_2*tmp_moved_constant_964) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_992 + tmp_kernel_op_218*tmp_moved_constant_995 + tmp_kernel_op_219*tmp_moved_constant_998) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_961 + jac_blending_inv_1_0_q_2*tmp_moved_constant_966 + jac_blending_inv_2_0_q_2*tmp_moved_constant_969) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_992 + tmp_kernel_op_224*tmp_moved_constant_995 + tmp_kernel_op_225*tmp_moved_constant_998) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_961 + jac_blending_inv_1_1_q_2*tmp_moved_constant_966 + jac_blending_inv_2_1_q_2*tmp_moved_constant_969) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_992 + tmp_kernel_op_230*tmp_moved_constant_995 + tmp_kernel_op_231*tmp_moved_constant_998) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_961 + jac_blending_inv_1_2_q_2*tmp_moved_constant_966 + jac_blending_inv_2_2_q_2*tmp_moved_constant_969) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_992 + tmp_kernel_op_236*tmp_moved_constant_995 + tmp_kernel_op_237*tmp_moved_constant_998) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_964 + jac_blending_inv_1_0_q_2*tmp_moved_constant_969 + jac_blending_inv_2_0_q_2*tmp_moved_constant_971) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_992 + tmp_kernel_op_242*tmp_moved_constant_995 + tmp_kernel_op_243*tmp_moved_constant_998) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_964 + jac_blending_inv_1_1_q_2*tmp_moved_constant_969 + jac_blending_inv_2_1_q_2*tmp_moved_constant_971) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_992 + tmp_kernel_op_248*tmp_moved_constant_995 + tmp_kernel_op_249*tmp_moved_constant_998) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_964 + jac_blending_inv_1_2_q_2*tmp_moved_constant_969 + jac_blending_inv_2_2_q_2*tmp_moved_constant_971) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_992 + tmp_kernel_op_254*tmp_moved_constant_995 + tmp_kernel_op_255*tmp_moved_constant_998);
             const real_t tmp_kernel_op_723 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_958 + jac_blending_inv_1_0_q_3*tmp_moved_constant_961 + jac_blending_inv_2_0_q_3*tmp_moved_constant_964) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1001 + tmp_kernel_op_290*tmp_moved_constant_1004 + tmp_kernel_op_292*tmp_moved_constant_1007) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_958 + jac_blending_inv_1_1_q_3*tmp_moved_constant_961 + jac_blending_inv_2_1_q_3*tmp_moved_constant_964) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1001 + tmp_kernel_op_297*tmp_moved_constant_1004 + tmp_kernel_op_298*tmp_moved_constant_1007) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_958 + jac_blending_inv_1_2_q_3*tmp_moved_constant_961 + jac_blending_inv_2_2_q_3*tmp_moved_constant_964) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1001 + tmp_kernel_op_303*tmp_moved_constant_1004 + tmp_kernel_op_304*tmp_moved_constant_1007) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_961 + jac_blending_inv_1_0_q_3*tmp_moved_constant_966 + jac_blending_inv_2_0_q_3*tmp_moved_constant_969) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1001 + tmp_kernel_op_309*tmp_moved_constant_1004 + tmp_kernel_op_310*tmp_moved_constant_1007) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_961 + jac_blending_inv_1_1_q_3*tmp_moved_constant_966 + jac_blending_inv_2_1_q_3*tmp_moved_constant_969) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1001 + tmp_kernel_op_315*tmp_moved_constant_1004 + tmp_kernel_op_316*tmp_moved_constant_1007) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_961 + jac_blending_inv_1_2_q_3*tmp_moved_constant_966 + jac_blending_inv_2_2_q_3*tmp_moved_constant_969) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1001 + tmp_kernel_op_321*tmp_moved_constant_1004 + tmp_kernel_op_322*tmp_moved_constant_1007) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_964 + jac_blending_inv_1_0_q_3*tmp_moved_constant_969 + jac_blending_inv_2_0_q_3*tmp_moved_constant_971) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1001 + tmp_kernel_op_327*tmp_moved_constant_1004 + tmp_kernel_op_328*tmp_moved_constant_1007) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_964 + jac_blending_inv_1_1_q_3*tmp_moved_constant_969 + jac_blending_inv_2_1_q_3*tmp_moved_constant_971) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1001 + tmp_kernel_op_333*tmp_moved_constant_1004 + tmp_kernel_op_334*tmp_moved_constant_1007) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_964 + jac_blending_inv_1_2_q_3*tmp_moved_constant_969 + jac_blending_inv_2_2_q_3*tmp_moved_constant_971) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1001 + tmp_kernel_op_339*tmp_moved_constant_1004 + tmp_kernel_op_340*tmp_moved_constant_1007);
             const real_t tmp_kernel_op_733 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_958 + jac_blending_inv_1_0_q_4*tmp_moved_constant_961 + jac_blending_inv_2_0_q_4*tmp_moved_constant_964) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1010 + tmp_kernel_op_375*tmp_moved_constant_1013 + tmp_kernel_op_377*tmp_moved_constant_1016) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_958 + jac_blending_inv_1_1_q_4*tmp_moved_constant_961 + jac_blending_inv_2_1_q_4*tmp_moved_constant_964) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1010 + tmp_kernel_op_382*tmp_moved_constant_1013 + tmp_kernel_op_383*tmp_moved_constant_1016) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_958 + jac_blending_inv_1_2_q_4*tmp_moved_constant_961 + jac_blending_inv_2_2_q_4*tmp_moved_constant_964) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1010 + tmp_kernel_op_388*tmp_moved_constant_1013 + tmp_kernel_op_389*tmp_moved_constant_1016) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_961 + jac_blending_inv_1_0_q_4*tmp_moved_constant_966 + jac_blending_inv_2_0_q_4*tmp_moved_constant_969) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1010 + tmp_kernel_op_394*tmp_moved_constant_1013 + tmp_kernel_op_395*tmp_moved_constant_1016) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_961 + jac_blending_inv_1_1_q_4*tmp_moved_constant_966 + jac_blending_inv_2_1_q_4*tmp_moved_constant_969) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1010 + tmp_kernel_op_400*tmp_moved_constant_1013 + tmp_kernel_op_401*tmp_moved_constant_1016) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_961 + jac_blending_inv_1_2_q_4*tmp_moved_constant_966 + jac_blending_inv_2_2_q_4*tmp_moved_constant_969) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1010 + tmp_kernel_op_406*tmp_moved_constant_1013 + tmp_kernel_op_407*tmp_moved_constant_1016) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_964 + jac_blending_inv_1_0_q_4*tmp_moved_constant_969 + jac_blending_inv_2_0_q_4*tmp_moved_constant_971) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1010 + tmp_kernel_op_412*tmp_moved_constant_1013 + tmp_kernel_op_413*tmp_moved_constant_1016) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_964 + jac_blending_inv_1_1_q_4*tmp_moved_constant_969 + jac_blending_inv_2_1_q_4*tmp_moved_constant_971) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1010 + tmp_kernel_op_418*tmp_moved_constant_1013 + tmp_kernel_op_419*tmp_moved_constant_1016) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_964 + jac_blending_inv_1_2_q_4*tmp_moved_constant_969 + jac_blending_inv_2_2_q_4*tmp_moved_constant_971) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1010 + tmp_kernel_op_424*tmp_moved_constant_1013 + tmp_kernel_op_425*tmp_moved_constant_1016);
             const real_t tmp_kernel_op_756 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1020 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1022 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1024) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1035 + tmp_kernel_op_35*tmp_moved_constant_1036 + tmp_kernel_op_37*tmp_moved_constant_1037) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1020 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1022 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1024) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1035 + tmp_kernel_op_42*tmp_moved_constant_1036 + tmp_kernel_op_43*tmp_moved_constant_1037) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1020 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1022 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1024) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1035 + tmp_kernel_op_48*tmp_moved_constant_1036 + tmp_kernel_op_49*tmp_moved_constant_1037) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1025 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1028 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1029) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1035 + tmp_kernel_op_54*tmp_moved_constant_1036 + tmp_kernel_op_55*tmp_moved_constant_1037) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1025 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1028 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1029) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1035 + tmp_kernel_op_60*tmp_moved_constant_1036 + tmp_kernel_op_61*tmp_moved_constant_1037) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1025 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1028 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1029) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1035 + tmp_kernel_op_66*tmp_moved_constant_1036 + tmp_kernel_op_67*tmp_moved_constant_1037) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1030 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1031 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1034) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1035 + tmp_kernel_op_72*tmp_moved_constant_1036 + tmp_kernel_op_73*tmp_moved_constant_1037) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1030 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1031 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1034) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1035 + tmp_kernel_op_78*tmp_moved_constant_1036 + tmp_kernel_op_79*tmp_moved_constant_1037) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1030 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1031 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1034) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1035 + tmp_kernel_op_84*tmp_moved_constant_1036 + tmp_kernel_op_85*tmp_moved_constant_1037);
             const real_t tmp_kernel_op_761 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1020 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1022 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1024) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1038 + tmp_kernel_op_120*tmp_moved_constant_1039 + tmp_kernel_op_122*tmp_moved_constant_1040) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1020 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1022 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1024) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1038 + tmp_kernel_op_127*tmp_moved_constant_1039 + tmp_kernel_op_128*tmp_moved_constant_1040) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1020 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1022 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1024) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1038 + tmp_kernel_op_133*tmp_moved_constant_1039 + tmp_kernel_op_134*tmp_moved_constant_1040) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1025 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1028 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1029) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1038 + tmp_kernel_op_139*tmp_moved_constant_1039 + tmp_kernel_op_140*tmp_moved_constant_1040) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1025 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1028 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1029) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1038 + tmp_kernel_op_145*tmp_moved_constant_1039 + tmp_kernel_op_146*tmp_moved_constant_1040) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1025 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1028 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1029) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1038 + tmp_kernel_op_151*tmp_moved_constant_1039 + tmp_kernel_op_152*tmp_moved_constant_1040) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1030 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1031 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1034) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1038 + tmp_kernel_op_157*tmp_moved_constant_1039 + tmp_kernel_op_158*tmp_moved_constant_1040) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1030 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1031 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1034) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1038 + tmp_kernel_op_163*tmp_moved_constant_1039 + tmp_kernel_op_164*tmp_moved_constant_1040) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1030 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1031 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1034) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1038 + tmp_kernel_op_169*tmp_moved_constant_1039 + tmp_kernel_op_170*tmp_moved_constant_1040);
             const real_t tmp_kernel_op_766 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1020 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1022 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1024) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1041 + tmp_kernel_op_205*tmp_moved_constant_1042 + tmp_kernel_op_207*tmp_moved_constant_1043) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1020 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1022 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1024) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1041 + tmp_kernel_op_212*tmp_moved_constant_1042 + tmp_kernel_op_213*tmp_moved_constant_1043) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1020 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1022 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1024) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1041 + tmp_kernel_op_218*tmp_moved_constant_1042 + tmp_kernel_op_219*tmp_moved_constant_1043) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1025 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1028 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1029) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1041 + tmp_kernel_op_224*tmp_moved_constant_1042 + tmp_kernel_op_225*tmp_moved_constant_1043) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1025 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1028 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1029) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1041 + tmp_kernel_op_230*tmp_moved_constant_1042 + tmp_kernel_op_231*tmp_moved_constant_1043) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1025 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1028 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1029) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1041 + tmp_kernel_op_236*tmp_moved_constant_1042 + tmp_kernel_op_237*tmp_moved_constant_1043) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1030 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1031 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1034) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1041 + tmp_kernel_op_242*tmp_moved_constant_1042 + tmp_kernel_op_243*tmp_moved_constant_1043) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1030 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1031 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1034) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1041 + tmp_kernel_op_248*tmp_moved_constant_1042 + tmp_kernel_op_249*tmp_moved_constant_1043) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1030 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1031 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1034) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1041 + tmp_kernel_op_254*tmp_moved_constant_1042 + tmp_kernel_op_255*tmp_moved_constant_1043);
             const real_t tmp_kernel_op_771 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1020 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1022 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1024) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1044 + tmp_kernel_op_290*tmp_moved_constant_1045 + tmp_kernel_op_292*tmp_moved_constant_1046) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1020 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1022 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1024) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1044 + tmp_kernel_op_297*tmp_moved_constant_1045 + tmp_kernel_op_298*tmp_moved_constant_1046) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1020 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1022 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1024) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1044 + tmp_kernel_op_303*tmp_moved_constant_1045 + tmp_kernel_op_304*tmp_moved_constant_1046) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1025 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1028 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1029) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1044 + tmp_kernel_op_309*tmp_moved_constant_1045 + tmp_kernel_op_310*tmp_moved_constant_1046) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1025 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1028 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1029) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1044 + tmp_kernel_op_315*tmp_moved_constant_1045 + tmp_kernel_op_316*tmp_moved_constant_1046) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1025 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1028 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1029) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1044 + tmp_kernel_op_321*tmp_moved_constant_1045 + tmp_kernel_op_322*tmp_moved_constant_1046) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1030 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1031 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1034) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1044 + tmp_kernel_op_327*tmp_moved_constant_1045 + tmp_kernel_op_328*tmp_moved_constant_1046) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1030 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1031 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1034) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1044 + tmp_kernel_op_333*tmp_moved_constant_1045 + tmp_kernel_op_334*tmp_moved_constant_1046) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1030 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1031 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1034) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1044 + tmp_kernel_op_339*tmp_moved_constant_1045 + tmp_kernel_op_340*tmp_moved_constant_1046);
             const real_t tmp_kernel_op_776 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1020 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1022 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1024) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1047 + tmp_kernel_op_375*tmp_moved_constant_1048 + tmp_kernel_op_377*tmp_moved_constant_1049) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1020 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1022 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1024) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1047 + tmp_kernel_op_382*tmp_moved_constant_1048 + tmp_kernel_op_383*tmp_moved_constant_1049) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1020 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1022 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1024) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1047 + tmp_kernel_op_388*tmp_moved_constant_1048 + tmp_kernel_op_389*tmp_moved_constant_1049) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1025 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1028 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1029) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1047 + tmp_kernel_op_394*tmp_moved_constant_1048 + tmp_kernel_op_395*tmp_moved_constant_1049) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1025 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1028 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1029) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1047 + tmp_kernel_op_400*tmp_moved_constant_1048 + tmp_kernel_op_401*tmp_moved_constant_1049) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1025 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1028 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1029) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1047 + tmp_kernel_op_406*tmp_moved_constant_1048 + tmp_kernel_op_407*tmp_moved_constant_1049) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1030 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1031 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1034) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1047 + tmp_kernel_op_412*tmp_moved_constant_1048 + tmp_kernel_op_413*tmp_moved_constant_1049) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1030 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1031 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1034) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1047 + tmp_kernel_op_418*tmp_moved_constant_1048 + tmp_kernel_op_419*tmp_moved_constant_1049) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1030 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1031 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1034) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1047 + tmp_kernel_op_424*tmp_moved_constant_1048 + tmp_kernel_op_425*tmp_moved_constant_1049);
             const real_t tmp_kernel_op_797 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1052 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1054 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1056) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1065 + tmp_kernel_op_35*tmp_moved_constant_1066 + tmp_kernel_op_37*tmp_moved_constant_1067) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1052 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1054 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1056) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1065 + tmp_kernel_op_42*tmp_moved_constant_1066 + tmp_kernel_op_43*tmp_moved_constant_1067) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1052 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1054 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1056) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1065 + tmp_kernel_op_48*tmp_moved_constant_1066 + tmp_kernel_op_49*tmp_moved_constant_1067) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1057 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1059 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1060) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1065 + tmp_kernel_op_54*tmp_moved_constant_1066 + tmp_kernel_op_55*tmp_moved_constant_1067) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1057 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1059 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1060) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1065 + tmp_kernel_op_60*tmp_moved_constant_1066 + tmp_kernel_op_61*tmp_moved_constant_1067) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1057 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1059 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1060) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1065 + tmp_kernel_op_66*tmp_moved_constant_1066 + tmp_kernel_op_67*tmp_moved_constant_1067) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1061 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1062 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1064) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1065 + tmp_kernel_op_72*tmp_moved_constant_1066 + tmp_kernel_op_73*tmp_moved_constant_1067) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1061 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1062 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1064) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1065 + tmp_kernel_op_78*tmp_moved_constant_1066 + tmp_kernel_op_79*tmp_moved_constant_1067) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1061 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1062 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1064) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1065 + tmp_kernel_op_84*tmp_moved_constant_1066 + tmp_kernel_op_85*tmp_moved_constant_1067);
             const real_t tmp_kernel_op_803 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1052 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1054 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1056) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1068 + tmp_kernel_op_120*tmp_moved_constant_1069 + tmp_kernel_op_122*tmp_moved_constant_1070) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1052 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1054 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1056) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1068 + tmp_kernel_op_127*tmp_moved_constant_1069 + tmp_kernel_op_128*tmp_moved_constant_1070) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1052 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1054 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1056) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1068 + tmp_kernel_op_133*tmp_moved_constant_1069 + tmp_kernel_op_134*tmp_moved_constant_1070) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1057 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1059 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1060) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1068 + tmp_kernel_op_139*tmp_moved_constant_1069 + tmp_kernel_op_140*tmp_moved_constant_1070) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1057 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1059 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1060) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1068 + tmp_kernel_op_145*tmp_moved_constant_1069 + tmp_kernel_op_146*tmp_moved_constant_1070) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1057 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1059 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1060) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1068 + tmp_kernel_op_151*tmp_moved_constant_1069 + tmp_kernel_op_152*tmp_moved_constant_1070) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1061 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1062 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1064) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1068 + tmp_kernel_op_157*tmp_moved_constant_1069 + tmp_kernel_op_158*tmp_moved_constant_1070) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1061 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1062 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1064) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1068 + tmp_kernel_op_163*tmp_moved_constant_1069 + tmp_kernel_op_164*tmp_moved_constant_1070) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1061 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1062 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1064) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1068 + tmp_kernel_op_169*tmp_moved_constant_1069 + tmp_kernel_op_170*tmp_moved_constant_1070);
             const real_t tmp_kernel_op_809 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1052 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1054 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1056) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1071 + tmp_kernel_op_205*tmp_moved_constant_1072 + tmp_kernel_op_207*tmp_moved_constant_1073) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1052 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1054 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1056) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1071 + tmp_kernel_op_212*tmp_moved_constant_1072 + tmp_kernel_op_213*tmp_moved_constant_1073) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1052 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1054 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1056) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1071 + tmp_kernel_op_218*tmp_moved_constant_1072 + tmp_kernel_op_219*tmp_moved_constant_1073) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1057 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1059 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1060) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1071 + tmp_kernel_op_224*tmp_moved_constant_1072 + tmp_kernel_op_225*tmp_moved_constant_1073) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1057 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1059 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1060) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1071 + tmp_kernel_op_230*tmp_moved_constant_1072 + tmp_kernel_op_231*tmp_moved_constant_1073) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1057 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1059 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1060) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1071 + tmp_kernel_op_236*tmp_moved_constant_1072 + tmp_kernel_op_237*tmp_moved_constant_1073) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1061 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1062 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1064) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1071 + tmp_kernel_op_242*tmp_moved_constant_1072 + tmp_kernel_op_243*tmp_moved_constant_1073) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1061 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1062 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1064) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1071 + tmp_kernel_op_248*tmp_moved_constant_1072 + tmp_kernel_op_249*tmp_moved_constant_1073) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1061 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1062 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1064) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1071 + tmp_kernel_op_254*tmp_moved_constant_1072 + tmp_kernel_op_255*tmp_moved_constant_1073);
             const real_t tmp_kernel_op_815 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1052 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1054 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1056) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1074 + tmp_kernel_op_290*tmp_moved_constant_1075 + tmp_kernel_op_292*tmp_moved_constant_1076) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1052 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1054 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1056) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1074 + tmp_kernel_op_297*tmp_moved_constant_1075 + tmp_kernel_op_298*tmp_moved_constant_1076) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1052 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1054 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1056) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1074 + tmp_kernel_op_303*tmp_moved_constant_1075 + tmp_kernel_op_304*tmp_moved_constant_1076) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1057 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1059 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1060) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1074 + tmp_kernel_op_309*tmp_moved_constant_1075 + tmp_kernel_op_310*tmp_moved_constant_1076) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1057 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1059 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1060) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1074 + tmp_kernel_op_315*tmp_moved_constant_1075 + tmp_kernel_op_316*tmp_moved_constant_1076) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1057 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1059 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1060) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1074 + tmp_kernel_op_321*tmp_moved_constant_1075 + tmp_kernel_op_322*tmp_moved_constant_1076) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1061 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1062 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1064) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1074 + tmp_kernel_op_327*tmp_moved_constant_1075 + tmp_kernel_op_328*tmp_moved_constant_1076) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1061 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1062 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1064) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1074 + tmp_kernel_op_333*tmp_moved_constant_1075 + tmp_kernel_op_334*tmp_moved_constant_1076) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1061 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1062 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1064) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1074 + tmp_kernel_op_339*tmp_moved_constant_1075 + tmp_kernel_op_340*tmp_moved_constant_1076);
             const real_t tmp_kernel_op_821 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1052 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1054 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1056) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1077 + tmp_kernel_op_375*tmp_moved_constant_1078 + tmp_kernel_op_377*tmp_moved_constant_1079) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1052 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1054 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1056) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1077 + tmp_kernel_op_382*tmp_moved_constant_1078 + tmp_kernel_op_383*tmp_moved_constant_1079) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1052 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1054 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1056) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1077 + tmp_kernel_op_388*tmp_moved_constant_1078 + tmp_kernel_op_389*tmp_moved_constant_1079) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1057 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1059 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1060) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1077 + tmp_kernel_op_394*tmp_moved_constant_1078 + tmp_kernel_op_395*tmp_moved_constant_1079) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1057 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1059 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1060) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1077 + tmp_kernel_op_400*tmp_moved_constant_1078 + tmp_kernel_op_401*tmp_moved_constant_1079) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1057 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1059 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1060) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1077 + tmp_kernel_op_406*tmp_moved_constant_1078 + tmp_kernel_op_407*tmp_moved_constant_1079) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1061 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1062 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1064) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1077 + tmp_kernel_op_412*tmp_moved_constant_1078 + tmp_kernel_op_413*tmp_moved_constant_1079) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1061 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1062 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1064) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1077 + tmp_kernel_op_418*tmp_moved_constant_1078 + tmp_kernel_op_419*tmp_moved_constant_1079) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1061 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1062 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1064) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1077 + tmp_kernel_op_424*tmp_moved_constant_1078 + tmp_kernel_op_425*tmp_moved_constant_1079);
             const real_t tmp_kernel_op_838 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1081 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1083 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1085) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1092 + tmp_kernel_op_35*tmp_moved_constant_1093 + tmp_kernel_op_37*tmp_moved_constant_1094) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1081 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1083 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1085) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1092 + tmp_kernel_op_42*tmp_moved_constant_1093 + tmp_kernel_op_43*tmp_moved_constant_1094) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1081 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1083 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1085) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1092 + tmp_kernel_op_48*tmp_moved_constant_1093 + tmp_kernel_op_49*tmp_moved_constant_1094) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1086 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1087 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1088) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1092 + tmp_kernel_op_54*tmp_moved_constant_1093 + tmp_kernel_op_55*tmp_moved_constant_1094) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1086 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1087 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1088) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1092 + tmp_kernel_op_60*tmp_moved_constant_1093 + tmp_kernel_op_61*tmp_moved_constant_1094) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1086 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1087 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1088) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1092 + tmp_kernel_op_66*tmp_moved_constant_1093 + tmp_kernel_op_67*tmp_moved_constant_1094) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1089 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1090 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1091) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1092 + tmp_kernel_op_72*tmp_moved_constant_1093 + tmp_kernel_op_73*tmp_moved_constant_1094) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1089 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1090 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1091) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1092 + tmp_kernel_op_78*tmp_moved_constant_1093 + tmp_kernel_op_79*tmp_moved_constant_1094) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1089 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1090 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1091) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1092 + tmp_kernel_op_84*tmp_moved_constant_1093 + tmp_kernel_op_85*tmp_moved_constant_1094);
             const real_t tmp_kernel_op_843 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1081 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1083 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1085) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1095 + tmp_kernel_op_120*tmp_moved_constant_1096 + tmp_kernel_op_122*tmp_moved_constant_1097) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1081 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1083 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1085) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1095 + tmp_kernel_op_127*tmp_moved_constant_1096 + tmp_kernel_op_128*tmp_moved_constant_1097) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1081 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1083 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1085) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1095 + tmp_kernel_op_133*tmp_moved_constant_1096 + tmp_kernel_op_134*tmp_moved_constant_1097) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1086 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1087 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1088) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1095 + tmp_kernel_op_139*tmp_moved_constant_1096 + tmp_kernel_op_140*tmp_moved_constant_1097) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1086 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1087 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1088) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1095 + tmp_kernel_op_145*tmp_moved_constant_1096 + tmp_kernel_op_146*tmp_moved_constant_1097) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1086 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1087 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1088) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1095 + tmp_kernel_op_151*tmp_moved_constant_1096 + tmp_kernel_op_152*tmp_moved_constant_1097) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1089 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1090 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1091) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1095 + tmp_kernel_op_157*tmp_moved_constant_1096 + tmp_kernel_op_158*tmp_moved_constant_1097) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1089 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1090 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1091) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1095 + tmp_kernel_op_163*tmp_moved_constant_1096 + tmp_kernel_op_164*tmp_moved_constant_1097) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1089 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1090 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1091) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1095 + tmp_kernel_op_169*tmp_moved_constant_1096 + tmp_kernel_op_170*tmp_moved_constant_1097);
             const real_t tmp_kernel_op_848 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1081 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1083 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1085) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1098 + tmp_kernel_op_205*tmp_moved_constant_1099 + tmp_kernel_op_207*tmp_moved_constant_1100) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1081 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1083 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1085) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1098 + tmp_kernel_op_212*tmp_moved_constant_1099 + tmp_kernel_op_213*tmp_moved_constant_1100) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1081 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1083 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1085) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1098 + tmp_kernel_op_218*tmp_moved_constant_1099 + tmp_kernel_op_219*tmp_moved_constant_1100) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1086 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1087 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1088) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1098 + tmp_kernel_op_224*tmp_moved_constant_1099 + tmp_kernel_op_225*tmp_moved_constant_1100) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1086 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1087 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1088) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1098 + tmp_kernel_op_230*tmp_moved_constant_1099 + tmp_kernel_op_231*tmp_moved_constant_1100) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1086 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1087 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1088) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1098 + tmp_kernel_op_236*tmp_moved_constant_1099 + tmp_kernel_op_237*tmp_moved_constant_1100) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1089 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1090 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1091) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1098 + tmp_kernel_op_242*tmp_moved_constant_1099 + tmp_kernel_op_243*tmp_moved_constant_1100) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1089 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1090 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1091) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1098 + tmp_kernel_op_248*tmp_moved_constant_1099 + tmp_kernel_op_249*tmp_moved_constant_1100) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1089 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1090 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1091) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1098 + tmp_kernel_op_254*tmp_moved_constant_1099 + tmp_kernel_op_255*tmp_moved_constant_1100);
             const real_t tmp_kernel_op_853 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1081 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1083 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1085) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1101 + tmp_kernel_op_290*tmp_moved_constant_1102 + tmp_kernel_op_292*tmp_moved_constant_1103) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1081 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1083 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1085) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1101 + tmp_kernel_op_297*tmp_moved_constant_1102 + tmp_kernel_op_298*tmp_moved_constant_1103) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1081 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1083 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1085) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1101 + tmp_kernel_op_303*tmp_moved_constant_1102 + tmp_kernel_op_304*tmp_moved_constant_1103) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1086 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1087 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1088) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1101 + tmp_kernel_op_309*tmp_moved_constant_1102 + tmp_kernel_op_310*tmp_moved_constant_1103) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1086 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1087 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1088) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1101 + tmp_kernel_op_315*tmp_moved_constant_1102 + tmp_kernel_op_316*tmp_moved_constant_1103) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1086 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1087 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1088) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1101 + tmp_kernel_op_321*tmp_moved_constant_1102 + tmp_kernel_op_322*tmp_moved_constant_1103) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1089 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1090 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1091) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1101 + tmp_kernel_op_327*tmp_moved_constant_1102 + tmp_kernel_op_328*tmp_moved_constant_1103) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1089 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1090 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1091) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1101 + tmp_kernel_op_333*tmp_moved_constant_1102 + tmp_kernel_op_334*tmp_moved_constant_1103) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1089 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1090 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1091) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1101 + tmp_kernel_op_339*tmp_moved_constant_1102 + tmp_kernel_op_340*tmp_moved_constant_1103);
             const real_t tmp_kernel_op_858 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1081 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1083 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1085) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1104 + tmp_kernel_op_375*tmp_moved_constant_1105 + tmp_kernel_op_377*tmp_moved_constant_1106) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1081 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1083 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1085) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1104 + tmp_kernel_op_382*tmp_moved_constant_1105 + tmp_kernel_op_383*tmp_moved_constant_1106) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1081 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1083 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1085) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1104 + tmp_kernel_op_388*tmp_moved_constant_1105 + tmp_kernel_op_389*tmp_moved_constant_1106) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1086 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1087 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1088) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1104 + tmp_kernel_op_394*tmp_moved_constant_1105 + tmp_kernel_op_395*tmp_moved_constant_1106) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1086 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1087 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1088) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1104 + tmp_kernel_op_400*tmp_moved_constant_1105 + tmp_kernel_op_401*tmp_moved_constant_1106) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1086 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1087 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1088) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1104 + tmp_kernel_op_406*tmp_moved_constant_1105 + tmp_kernel_op_407*tmp_moved_constant_1106) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1089 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1090 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1091) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1104 + tmp_kernel_op_412*tmp_moved_constant_1105 + tmp_kernel_op_413*tmp_moved_constant_1106) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1089 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1090 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1091) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1104 + tmp_kernel_op_418*tmp_moved_constant_1105 + tmp_kernel_op_419*tmp_moved_constant_1106) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1089 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1090 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1091) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1104 + tmp_kernel_op_424*tmp_moved_constant_1105 + tmp_kernel_op_425*tmp_moved_constant_1106);
             const real_t tmp_kernel_op_859 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_783 + jac_blending_inv_1_0_q_0*tmp_moved_constant_784 + jac_blending_inv_2_0_q_0*tmp_moved_constant_785) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_783 + jac_blending_inv_1_1_q_0*tmp_moved_constant_784 + jac_blending_inv_2_1_q_0*tmp_moved_constant_785) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_783 + jac_blending_inv_1_2_q_0*tmp_moved_constant_784 + jac_blending_inv_2_2_q_0*tmp_moved_constant_785));
             const real_t tmp_kernel_op_860 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_786 + jac_blending_inv_1_0_q_1*tmp_moved_constant_787 + jac_blending_inv_2_0_q_1*tmp_moved_constant_788) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_786 + jac_blending_inv_1_1_q_1*tmp_moved_constant_787 + jac_blending_inv_2_1_q_1*tmp_moved_constant_788) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_786 + jac_blending_inv_1_2_q_1*tmp_moved_constant_787 + jac_blending_inv_2_2_q_1*tmp_moved_constant_788));
             const real_t tmp_kernel_op_861 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_789 + jac_blending_inv_1_0_q_2*tmp_moved_constant_790 + jac_blending_inv_2_0_q_2*tmp_moved_constant_791) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_789 + jac_blending_inv_1_1_q_2*tmp_moved_constant_790 + jac_blending_inv_2_1_q_2*tmp_moved_constant_791) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_789 + jac_blending_inv_1_2_q_2*tmp_moved_constant_790 + jac_blending_inv_2_2_q_2*tmp_moved_constant_791));
             const real_t tmp_kernel_op_862 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_792 + jac_blending_inv_1_0_q_3*tmp_moved_constant_793 + jac_blending_inv_2_0_q_3*tmp_moved_constant_794) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_792 + jac_blending_inv_1_1_q_3*tmp_moved_constant_793 + jac_blending_inv_2_1_q_3*tmp_moved_constant_794) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_792 + jac_blending_inv_1_2_q_3*tmp_moved_constant_793 + jac_blending_inv_2_2_q_3*tmp_moved_constant_794));
             const real_t tmp_kernel_op_863 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_795 + jac_blending_inv_1_0_q_4*tmp_moved_constant_796 + jac_blending_inv_2_0_q_4*tmp_moved_constant_797) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_795 + jac_blending_inv_1_1_q_4*tmp_moved_constant_796 + jac_blending_inv_2_1_q_4*tmp_moved_constant_797) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_795 + jac_blending_inv_1_2_q_4*tmp_moved_constant_796 + jac_blending_inv_2_2_q_4*tmp_moved_constant_797));
             const real_t tmp_kernel_op_864 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_804 + jac_blending_inv_1_0_q_0*tmp_moved_constant_805 + jac_blending_inv_2_0_q_0*tmp_moved_constant_806) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_804 + jac_blending_inv_1_1_q_0*tmp_moved_constant_805 + jac_blending_inv_2_1_q_0*tmp_moved_constant_806) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_804 + jac_blending_inv_1_2_q_0*tmp_moved_constant_805 + jac_blending_inv_2_2_q_0*tmp_moved_constant_806));
             const real_t tmp_kernel_op_865 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_807 + jac_blending_inv_1_0_q_1*tmp_moved_constant_808 + jac_blending_inv_2_0_q_1*tmp_moved_constant_809) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_807 + jac_blending_inv_1_1_q_1*tmp_moved_constant_808 + jac_blending_inv_2_1_q_1*tmp_moved_constant_809) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_807 + jac_blending_inv_1_2_q_1*tmp_moved_constant_808 + jac_blending_inv_2_2_q_1*tmp_moved_constant_809));
             const real_t tmp_kernel_op_866 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_810 + jac_blending_inv_1_0_q_2*tmp_moved_constant_811 + jac_blending_inv_2_0_q_2*tmp_moved_constant_812) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_810 + jac_blending_inv_1_1_q_2*tmp_moved_constant_811 + jac_blending_inv_2_1_q_2*tmp_moved_constant_812) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_810 + jac_blending_inv_1_2_q_2*tmp_moved_constant_811 + jac_blending_inv_2_2_q_2*tmp_moved_constant_812));
             const real_t tmp_kernel_op_867 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_813 + jac_blending_inv_1_0_q_3*tmp_moved_constant_814 + jac_blending_inv_2_0_q_3*tmp_moved_constant_815) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_813 + jac_blending_inv_1_1_q_3*tmp_moved_constant_814 + jac_blending_inv_2_1_q_3*tmp_moved_constant_815) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_813 + jac_blending_inv_1_2_q_3*tmp_moved_constant_814 + jac_blending_inv_2_2_q_3*tmp_moved_constant_815));
             const real_t tmp_kernel_op_868 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_816 + jac_blending_inv_1_0_q_4*tmp_moved_constant_817 + jac_blending_inv_2_0_q_4*tmp_moved_constant_818) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_816 + jac_blending_inv_1_1_q_4*tmp_moved_constant_817 + jac_blending_inv_2_1_q_4*tmp_moved_constant_818) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_816 + jac_blending_inv_1_2_q_4*tmp_moved_constant_817 + jac_blending_inv_2_2_q_4*tmp_moved_constant_818));
             const real_t tmp_kernel_op_869 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_825 + jac_blending_inv_1_0_q_0*tmp_moved_constant_826 + jac_blending_inv_2_0_q_0*tmp_moved_constant_827) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_825 + jac_blending_inv_1_1_q_0*tmp_moved_constant_826 + jac_blending_inv_2_1_q_0*tmp_moved_constant_827) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_825 + jac_blending_inv_1_2_q_0*tmp_moved_constant_826 + jac_blending_inv_2_2_q_0*tmp_moved_constant_827));
             const real_t tmp_kernel_op_870 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_828 + jac_blending_inv_1_0_q_1*tmp_moved_constant_829 + jac_blending_inv_2_0_q_1*tmp_moved_constant_830) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_828 + jac_blending_inv_1_1_q_1*tmp_moved_constant_829 + jac_blending_inv_2_1_q_1*tmp_moved_constant_830) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_828 + jac_blending_inv_1_2_q_1*tmp_moved_constant_829 + jac_blending_inv_2_2_q_1*tmp_moved_constant_830));
             const real_t tmp_kernel_op_871 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_831 + jac_blending_inv_1_0_q_2*tmp_moved_constant_832 + jac_blending_inv_2_0_q_2*tmp_moved_constant_833) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_831 + jac_blending_inv_1_1_q_2*tmp_moved_constant_832 + jac_blending_inv_2_1_q_2*tmp_moved_constant_833) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_831 + jac_blending_inv_1_2_q_2*tmp_moved_constant_832 + jac_blending_inv_2_2_q_2*tmp_moved_constant_833));
             const real_t tmp_kernel_op_872 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_834 + jac_blending_inv_1_0_q_3*tmp_moved_constant_835 + jac_blending_inv_2_0_q_3*tmp_moved_constant_836) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_834 + jac_blending_inv_1_1_q_3*tmp_moved_constant_835 + jac_blending_inv_2_1_q_3*tmp_moved_constant_836) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_834 + jac_blending_inv_1_2_q_3*tmp_moved_constant_835 + jac_blending_inv_2_2_q_3*tmp_moved_constant_836));
             const real_t tmp_kernel_op_873 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_837 + jac_blending_inv_1_0_q_4*tmp_moved_constant_838 + jac_blending_inv_2_0_q_4*tmp_moved_constant_839) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_837 + jac_blending_inv_1_1_q_4*tmp_moved_constant_838 + jac_blending_inv_2_1_q_4*tmp_moved_constant_839) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_837 + jac_blending_inv_1_2_q_4*tmp_moved_constant_838 + jac_blending_inv_2_2_q_4*tmp_moved_constant_839));
             const real_t tmp_kernel_op_874 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_857 + jac_blending_inv_1_0_q_0*tmp_moved_constant_860 + jac_blending_inv_2_0_q_0*tmp_moved_constant_863) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_857 + jac_blending_inv_1_1_q_0*tmp_moved_constant_860 + jac_blending_inv_2_1_q_0*tmp_moved_constant_863) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_857 + jac_blending_inv_1_2_q_0*tmp_moved_constant_860 + jac_blending_inv_2_2_q_0*tmp_moved_constant_863));
             const real_t tmp_kernel_op_875 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_866 + jac_blending_inv_1_0_q_1*tmp_moved_constant_869 + jac_blending_inv_2_0_q_1*tmp_moved_constant_872) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_866 + jac_blending_inv_1_1_q_1*tmp_moved_constant_869 + jac_blending_inv_2_1_q_1*tmp_moved_constant_872) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_866 + jac_blending_inv_1_2_q_1*tmp_moved_constant_869 + jac_blending_inv_2_2_q_1*tmp_moved_constant_872));
             const real_t tmp_kernel_op_876 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_875 + jac_blending_inv_1_0_q_2*tmp_moved_constant_878 + jac_blending_inv_2_0_q_2*tmp_moved_constant_881) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_875 + jac_blending_inv_1_1_q_2*tmp_moved_constant_878 + jac_blending_inv_2_1_q_2*tmp_moved_constant_881) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_875 + jac_blending_inv_1_2_q_2*tmp_moved_constant_878 + jac_blending_inv_2_2_q_2*tmp_moved_constant_881));
             const real_t tmp_kernel_op_877 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_884 + jac_blending_inv_1_0_q_3*tmp_moved_constant_887 + jac_blending_inv_2_0_q_3*tmp_moved_constant_890) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_884 + jac_blending_inv_1_1_q_3*tmp_moved_constant_887 + jac_blending_inv_2_1_q_3*tmp_moved_constant_890) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_884 + jac_blending_inv_1_2_q_3*tmp_moved_constant_887 + jac_blending_inv_2_2_q_3*tmp_moved_constant_890));
             const real_t tmp_kernel_op_878 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_893 + jac_blending_inv_1_0_q_4*tmp_moved_constant_896 + jac_blending_inv_2_0_q_4*tmp_moved_constant_899) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_893 + jac_blending_inv_1_1_q_4*tmp_moved_constant_896 + jac_blending_inv_2_1_q_4*tmp_moved_constant_899) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_893 + jac_blending_inv_1_2_q_4*tmp_moved_constant_896 + jac_blending_inv_2_2_q_4*tmp_moved_constant_899));
             const real_t tmp_kernel_op_879 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_914 + jac_blending_inv_1_0_q_0*tmp_moved_constant_917 + jac_blending_inv_2_0_q_0*tmp_moved_constant_920) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_914 + jac_blending_inv_1_1_q_0*tmp_moved_constant_917 + jac_blending_inv_2_1_q_0*tmp_moved_constant_920) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_914 + jac_blending_inv_1_2_q_0*tmp_moved_constant_917 + jac_blending_inv_2_2_q_0*tmp_moved_constant_920));
             const real_t tmp_kernel_op_880 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_923 + jac_blending_inv_1_0_q_1*tmp_moved_constant_926 + jac_blending_inv_2_0_q_1*tmp_moved_constant_929) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_923 + jac_blending_inv_1_1_q_1*tmp_moved_constant_926 + jac_blending_inv_2_1_q_1*tmp_moved_constant_929) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_923 + jac_blending_inv_1_2_q_1*tmp_moved_constant_926 + jac_blending_inv_2_2_q_1*tmp_moved_constant_929));
             const real_t tmp_kernel_op_881 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_932 + jac_blending_inv_1_0_q_2*tmp_moved_constant_935 + jac_blending_inv_2_0_q_2*tmp_moved_constant_938) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_932 + jac_blending_inv_1_1_q_2*tmp_moved_constant_935 + jac_blending_inv_2_1_q_2*tmp_moved_constant_938) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_932 + jac_blending_inv_1_2_q_2*tmp_moved_constant_935 + jac_blending_inv_2_2_q_2*tmp_moved_constant_938));
             const real_t tmp_kernel_op_882 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_941 + jac_blending_inv_1_0_q_3*tmp_moved_constant_944 + jac_blending_inv_2_0_q_3*tmp_moved_constant_947) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_941 + jac_blending_inv_1_1_q_3*tmp_moved_constant_944 + jac_blending_inv_2_1_q_3*tmp_moved_constant_947) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_941 + jac_blending_inv_1_2_q_3*tmp_moved_constant_944 + jac_blending_inv_2_2_q_3*tmp_moved_constant_947));
             const real_t tmp_kernel_op_883 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_950 + jac_blending_inv_1_0_q_4*tmp_moved_constant_953 + jac_blending_inv_2_0_q_4*tmp_moved_constant_956) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_950 + jac_blending_inv_1_1_q_4*tmp_moved_constant_953 + jac_blending_inv_2_1_q_4*tmp_moved_constant_956) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_950 + jac_blending_inv_1_2_q_4*tmp_moved_constant_953 + jac_blending_inv_2_2_q_4*tmp_moved_constant_956));
             const real_t tmp_kernel_op_884 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_974 + jac_blending_inv_1_0_q_0*tmp_moved_constant_977 + jac_blending_inv_2_0_q_0*tmp_moved_constant_980) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_974 + jac_blending_inv_1_1_q_0*tmp_moved_constant_977 + jac_blending_inv_2_1_q_0*tmp_moved_constant_980) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_974 + jac_blending_inv_1_2_q_0*tmp_moved_constant_977 + jac_blending_inv_2_2_q_0*tmp_moved_constant_980));
             const real_t tmp_kernel_op_885 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_983 + jac_blending_inv_1_0_q_1*tmp_moved_constant_986 + jac_blending_inv_2_0_q_1*tmp_moved_constant_989) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_983 + jac_blending_inv_1_1_q_1*tmp_moved_constant_986 + jac_blending_inv_2_1_q_1*tmp_moved_constant_989) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_983 + jac_blending_inv_1_2_q_1*tmp_moved_constant_986 + jac_blending_inv_2_2_q_1*tmp_moved_constant_989));
             const real_t tmp_kernel_op_886 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_992 + jac_blending_inv_1_0_q_2*tmp_moved_constant_995 + jac_blending_inv_2_0_q_2*tmp_moved_constant_998) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_992 + jac_blending_inv_1_1_q_2*tmp_moved_constant_995 + jac_blending_inv_2_1_q_2*tmp_moved_constant_998) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_992 + jac_blending_inv_1_2_q_2*tmp_moved_constant_995 + jac_blending_inv_2_2_q_2*tmp_moved_constant_998));
             const real_t tmp_kernel_op_887 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1001 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1004 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1007) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1001 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1004 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1007) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1001 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1004 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1007));
             const real_t tmp_kernel_op_888 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1010 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1013 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1016) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1010 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1013 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1016) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1010 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1013 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1016));
             const real_t tmp_kernel_op_889 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1035 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1036 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1037) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1035 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1036 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1037) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1035 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1036 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1037));
             const real_t tmp_kernel_op_890 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1038 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1039 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1040) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1038 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1039 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1040) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1038 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1039 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1040));
             const real_t tmp_kernel_op_891 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1041 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1042 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1043) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1041 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1042 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1043) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1041 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1042 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1043));
             const real_t tmp_kernel_op_892 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1044 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1045 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1046) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1044 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1045 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1046) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1044 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1045 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1046));
             const real_t tmp_kernel_op_893 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1047 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1048 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1049) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1047 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1048 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1049) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1047 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1048 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1049));
             const real_t tmp_kernel_op_894 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1065 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1066 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1067) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1065 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1066 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1067) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1065 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1066 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1067));
             const real_t tmp_kernel_op_895 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1068 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1069 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1070) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1068 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1069 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1070) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1068 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1069 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1070));
             const real_t tmp_kernel_op_896 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1071 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1072 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1073) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1071 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1072 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1073) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1071 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1072 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1073));
             const real_t tmp_kernel_op_897 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1074 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1075 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1076) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1074 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1075 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1076) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1074 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1075 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1076));
             const real_t tmp_kernel_op_898 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1077 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1078 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1079) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1077 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1078 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1079) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1077 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1078 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1079));
             const real_t tmp_kernel_op_899 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1092 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1093 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1094) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1092 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1093 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1094) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1092 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1093 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1094));
             const real_t tmp_kernel_op_900 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1095 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1096 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1097) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1095 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1096 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1097) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1095 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1096 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1097));
             const real_t tmp_kernel_op_901 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1098 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1099 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1100) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1098 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1099 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1100) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1098 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1099 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1100));
             const real_t tmp_kernel_op_902 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1101 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1102 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1103) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1101 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1102 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1103) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1101 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1102 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1103));
             const real_t tmp_kernel_op_903 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1104 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1105 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1106) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1104 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1105 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1106) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1104 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1105 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1106));
             const real_t elMat_0_0 = tmp_kernel_op_108*tmp_kernel_op_86 + tmp_kernel_op_171*tmp_kernel_op_193 + tmp_kernel_op_256*tmp_kernel_op_278 + tmp_kernel_op_341*tmp_kernel_op_363 + tmp_kernel_op_426*tmp_kernel_op_448;
             const real_t elMat_0_1 = tmp_kernel_op_108*tmp_kernel_op_459 + tmp_kernel_op_193*tmp_kernel_op_464 + tmp_kernel_op_278*tmp_kernel_op_469 + tmp_kernel_op_363*tmp_kernel_op_474 + tmp_kernel_op_448*tmp_kernel_op_479;
             const real_t elMat_0_2 = tmp_kernel_op_108*tmp_kernel_op_490 + tmp_kernel_op_193*tmp_kernel_op_495 + tmp_kernel_op_278*tmp_kernel_op_500 + tmp_kernel_op_363*tmp_kernel_op_505 + tmp_kernel_op_448*tmp_kernel_op_510;
             const real_t elMat_0_3 = tmp_kernel_op_108*tmp_kernel_op_521 + tmp_kernel_op_193*tmp_kernel_op_526 + tmp_kernel_op_278*tmp_kernel_op_531 + tmp_kernel_op_363*tmp_kernel_op_536 + tmp_kernel_op_448*tmp_kernel_op_541;
             const real_t elMat_0_4 = tmp_kernel_op_108*tmp_kernel_op_566 + tmp_kernel_op_193*tmp_kernel_op_576 + tmp_kernel_op_278*tmp_kernel_op_586 + tmp_kernel_op_363*tmp_kernel_op_596 + tmp_kernel_op_448*tmp_kernel_op_606;
             const real_t elMat_0_5 = tmp_kernel_op_108*tmp_kernel_op_628 + tmp_kernel_op_193*tmp_kernel_op_638 + tmp_kernel_op_278*tmp_kernel_op_648 + tmp_kernel_op_363*tmp_kernel_op_658 + tmp_kernel_op_448*tmp_kernel_op_668;
             const real_t elMat_0_6 = tmp_kernel_op_108*tmp_kernel_op_693 + tmp_kernel_op_193*tmp_kernel_op_703 + tmp_kernel_op_278*tmp_kernel_op_713 + tmp_kernel_op_363*tmp_kernel_op_723 + tmp_kernel_op_448*tmp_kernel_op_733;
             const real_t elMat_0_7 = tmp_kernel_op_108*tmp_kernel_op_756 + tmp_kernel_op_193*tmp_kernel_op_761 + tmp_kernel_op_278*tmp_kernel_op_766 + tmp_kernel_op_363*tmp_kernel_op_771 + tmp_kernel_op_448*tmp_kernel_op_776;
             const real_t elMat_0_8 = tmp_kernel_op_108*tmp_kernel_op_797 + tmp_kernel_op_193*tmp_kernel_op_803 + tmp_kernel_op_278*tmp_kernel_op_809 + tmp_kernel_op_363*tmp_kernel_op_815 + tmp_kernel_op_448*tmp_kernel_op_821;
             const real_t elMat_0_9 = tmp_kernel_op_108*tmp_kernel_op_838 + tmp_kernel_op_193*tmp_kernel_op_843 + tmp_kernel_op_278*tmp_kernel_op_848 + tmp_kernel_op_363*tmp_kernel_op_853 + tmp_kernel_op_448*tmp_kernel_op_858;
             const real_t elMat_1_0 = tmp_kernel_op_171*tmp_kernel_op_860 + tmp_kernel_op_256*tmp_kernel_op_861 + tmp_kernel_op_341*tmp_kernel_op_862 + tmp_kernel_op_426*tmp_kernel_op_863 + tmp_kernel_op_859*tmp_kernel_op_86;
             const real_t elMat_1_1 = tmp_kernel_op_459*tmp_kernel_op_859 + tmp_kernel_op_464*tmp_kernel_op_860 + tmp_kernel_op_469*tmp_kernel_op_861 + tmp_kernel_op_474*tmp_kernel_op_862 + tmp_kernel_op_479*tmp_kernel_op_863;
             const real_t elMat_1_2 = tmp_kernel_op_490*tmp_kernel_op_859 + tmp_kernel_op_495*tmp_kernel_op_860 + tmp_kernel_op_500*tmp_kernel_op_861 + tmp_kernel_op_505*tmp_kernel_op_862 + tmp_kernel_op_510*tmp_kernel_op_863;
             const real_t elMat_1_3 = tmp_kernel_op_521*tmp_kernel_op_859 + tmp_kernel_op_526*tmp_kernel_op_860 + tmp_kernel_op_531*tmp_kernel_op_861 + tmp_kernel_op_536*tmp_kernel_op_862 + tmp_kernel_op_541*tmp_kernel_op_863;
             const real_t elMat_1_4 = tmp_kernel_op_566*tmp_kernel_op_859 + tmp_kernel_op_576*tmp_kernel_op_860 + tmp_kernel_op_586*tmp_kernel_op_861 + tmp_kernel_op_596*tmp_kernel_op_862 + tmp_kernel_op_606*tmp_kernel_op_863;
             const real_t elMat_1_5 = tmp_kernel_op_628*tmp_kernel_op_859 + tmp_kernel_op_638*tmp_kernel_op_860 + tmp_kernel_op_648*tmp_kernel_op_861 + tmp_kernel_op_658*tmp_kernel_op_862 + tmp_kernel_op_668*tmp_kernel_op_863;
             const real_t elMat_1_6 = tmp_kernel_op_693*tmp_kernel_op_859 + tmp_kernel_op_703*tmp_kernel_op_860 + tmp_kernel_op_713*tmp_kernel_op_861 + tmp_kernel_op_723*tmp_kernel_op_862 + tmp_kernel_op_733*tmp_kernel_op_863;
             const real_t elMat_1_7 = tmp_kernel_op_756*tmp_kernel_op_859 + tmp_kernel_op_761*tmp_kernel_op_860 + tmp_kernel_op_766*tmp_kernel_op_861 + tmp_kernel_op_771*tmp_kernel_op_862 + tmp_kernel_op_776*tmp_kernel_op_863;
             const real_t elMat_1_8 = tmp_kernel_op_797*tmp_kernel_op_859 + tmp_kernel_op_803*tmp_kernel_op_860 + tmp_kernel_op_809*tmp_kernel_op_861 + tmp_kernel_op_815*tmp_kernel_op_862 + tmp_kernel_op_821*tmp_kernel_op_863;
             const real_t elMat_1_9 = tmp_kernel_op_838*tmp_kernel_op_859 + tmp_kernel_op_843*tmp_kernel_op_860 + tmp_kernel_op_848*tmp_kernel_op_861 + tmp_kernel_op_853*tmp_kernel_op_862 + tmp_kernel_op_858*tmp_kernel_op_863;
             const real_t elMat_2_0 = tmp_kernel_op_171*tmp_kernel_op_865 + tmp_kernel_op_256*tmp_kernel_op_866 + tmp_kernel_op_341*tmp_kernel_op_867 + tmp_kernel_op_426*tmp_kernel_op_868 + tmp_kernel_op_86*tmp_kernel_op_864;
             const real_t elMat_2_1 = tmp_kernel_op_459*tmp_kernel_op_864 + tmp_kernel_op_464*tmp_kernel_op_865 + tmp_kernel_op_469*tmp_kernel_op_866 + tmp_kernel_op_474*tmp_kernel_op_867 + tmp_kernel_op_479*tmp_kernel_op_868;
             const real_t elMat_2_2 = tmp_kernel_op_490*tmp_kernel_op_864 + tmp_kernel_op_495*tmp_kernel_op_865 + tmp_kernel_op_500*tmp_kernel_op_866 + tmp_kernel_op_505*tmp_kernel_op_867 + tmp_kernel_op_510*tmp_kernel_op_868;
             const real_t elMat_2_3 = tmp_kernel_op_521*tmp_kernel_op_864 + tmp_kernel_op_526*tmp_kernel_op_865 + tmp_kernel_op_531*tmp_kernel_op_866 + tmp_kernel_op_536*tmp_kernel_op_867 + tmp_kernel_op_541*tmp_kernel_op_868;
             const real_t elMat_2_4 = tmp_kernel_op_566*tmp_kernel_op_864 + tmp_kernel_op_576*tmp_kernel_op_865 + tmp_kernel_op_586*tmp_kernel_op_866 + tmp_kernel_op_596*tmp_kernel_op_867 + tmp_kernel_op_606*tmp_kernel_op_868;
             const real_t elMat_2_5 = tmp_kernel_op_628*tmp_kernel_op_864 + tmp_kernel_op_638*tmp_kernel_op_865 + tmp_kernel_op_648*tmp_kernel_op_866 + tmp_kernel_op_658*tmp_kernel_op_867 + tmp_kernel_op_668*tmp_kernel_op_868;
             const real_t elMat_2_6 = tmp_kernel_op_693*tmp_kernel_op_864 + tmp_kernel_op_703*tmp_kernel_op_865 + tmp_kernel_op_713*tmp_kernel_op_866 + tmp_kernel_op_723*tmp_kernel_op_867 + tmp_kernel_op_733*tmp_kernel_op_868;
             const real_t elMat_2_7 = tmp_kernel_op_756*tmp_kernel_op_864 + tmp_kernel_op_761*tmp_kernel_op_865 + tmp_kernel_op_766*tmp_kernel_op_866 + tmp_kernel_op_771*tmp_kernel_op_867 + tmp_kernel_op_776*tmp_kernel_op_868;
             const real_t elMat_2_8 = tmp_kernel_op_797*tmp_kernel_op_864 + tmp_kernel_op_803*tmp_kernel_op_865 + tmp_kernel_op_809*tmp_kernel_op_866 + tmp_kernel_op_815*tmp_kernel_op_867 + tmp_kernel_op_821*tmp_kernel_op_868;
             const real_t elMat_2_9 = tmp_kernel_op_838*tmp_kernel_op_864 + tmp_kernel_op_843*tmp_kernel_op_865 + tmp_kernel_op_848*tmp_kernel_op_866 + tmp_kernel_op_853*tmp_kernel_op_867 + tmp_kernel_op_858*tmp_kernel_op_868;
             const real_t elMat_3_0 = tmp_kernel_op_171*tmp_kernel_op_870 + tmp_kernel_op_256*tmp_kernel_op_871 + tmp_kernel_op_341*tmp_kernel_op_872 + tmp_kernel_op_426*tmp_kernel_op_873 + tmp_kernel_op_86*tmp_kernel_op_869;
             const real_t elMat_3_1 = tmp_kernel_op_459*tmp_kernel_op_869 + tmp_kernel_op_464*tmp_kernel_op_870 + tmp_kernel_op_469*tmp_kernel_op_871 + tmp_kernel_op_474*tmp_kernel_op_872 + tmp_kernel_op_479*tmp_kernel_op_873;
             const real_t elMat_3_2 = tmp_kernel_op_490*tmp_kernel_op_869 + tmp_kernel_op_495*tmp_kernel_op_870 + tmp_kernel_op_500*tmp_kernel_op_871 + tmp_kernel_op_505*tmp_kernel_op_872 + tmp_kernel_op_510*tmp_kernel_op_873;
             const real_t elMat_3_3 = tmp_kernel_op_521*tmp_kernel_op_869 + tmp_kernel_op_526*tmp_kernel_op_870 + tmp_kernel_op_531*tmp_kernel_op_871 + tmp_kernel_op_536*tmp_kernel_op_872 + tmp_kernel_op_541*tmp_kernel_op_873;
             const real_t elMat_3_4 = tmp_kernel_op_566*tmp_kernel_op_869 + tmp_kernel_op_576*tmp_kernel_op_870 + tmp_kernel_op_586*tmp_kernel_op_871 + tmp_kernel_op_596*tmp_kernel_op_872 + tmp_kernel_op_606*tmp_kernel_op_873;
             const real_t elMat_3_5 = tmp_kernel_op_628*tmp_kernel_op_869 + tmp_kernel_op_638*tmp_kernel_op_870 + tmp_kernel_op_648*tmp_kernel_op_871 + tmp_kernel_op_658*tmp_kernel_op_872 + tmp_kernel_op_668*tmp_kernel_op_873;
             const real_t elMat_3_6 = tmp_kernel_op_693*tmp_kernel_op_869 + tmp_kernel_op_703*tmp_kernel_op_870 + tmp_kernel_op_713*tmp_kernel_op_871 + tmp_kernel_op_723*tmp_kernel_op_872 + tmp_kernel_op_733*tmp_kernel_op_873;
             const real_t elMat_3_7 = tmp_kernel_op_756*tmp_kernel_op_869 + tmp_kernel_op_761*tmp_kernel_op_870 + tmp_kernel_op_766*tmp_kernel_op_871 + tmp_kernel_op_771*tmp_kernel_op_872 + tmp_kernel_op_776*tmp_kernel_op_873;
             const real_t elMat_3_8 = tmp_kernel_op_797*tmp_kernel_op_869 + tmp_kernel_op_803*tmp_kernel_op_870 + tmp_kernel_op_809*tmp_kernel_op_871 + tmp_kernel_op_815*tmp_kernel_op_872 + tmp_kernel_op_821*tmp_kernel_op_873;
             const real_t elMat_3_9 = tmp_kernel_op_838*tmp_kernel_op_869 + tmp_kernel_op_843*tmp_kernel_op_870 + tmp_kernel_op_848*tmp_kernel_op_871 + tmp_kernel_op_853*tmp_kernel_op_872 + tmp_kernel_op_858*tmp_kernel_op_873;
             const real_t elMat_4_0 = tmp_kernel_op_171*tmp_kernel_op_875 + tmp_kernel_op_256*tmp_kernel_op_876 + tmp_kernel_op_341*tmp_kernel_op_877 + tmp_kernel_op_426*tmp_kernel_op_878 + tmp_kernel_op_86*tmp_kernel_op_874;
             const real_t elMat_4_1 = tmp_kernel_op_459*tmp_kernel_op_874 + tmp_kernel_op_464*tmp_kernel_op_875 + tmp_kernel_op_469*tmp_kernel_op_876 + tmp_kernel_op_474*tmp_kernel_op_877 + tmp_kernel_op_479*tmp_kernel_op_878;
             const real_t elMat_4_2 = tmp_kernel_op_490*tmp_kernel_op_874 + tmp_kernel_op_495*tmp_kernel_op_875 + tmp_kernel_op_500*tmp_kernel_op_876 + tmp_kernel_op_505*tmp_kernel_op_877 + tmp_kernel_op_510*tmp_kernel_op_878;
             const real_t elMat_4_3 = tmp_kernel_op_521*tmp_kernel_op_874 + tmp_kernel_op_526*tmp_kernel_op_875 + tmp_kernel_op_531*tmp_kernel_op_876 + tmp_kernel_op_536*tmp_kernel_op_877 + tmp_kernel_op_541*tmp_kernel_op_878;
             const real_t elMat_4_4 = tmp_kernel_op_566*tmp_kernel_op_874 + tmp_kernel_op_576*tmp_kernel_op_875 + tmp_kernel_op_586*tmp_kernel_op_876 + tmp_kernel_op_596*tmp_kernel_op_877 + tmp_kernel_op_606*tmp_kernel_op_878;
             const real_t elMat_4_5 = tmp_kernel_op_628*tmp_kernel_op_874 + tmp_kernel_op_638*tmp_kernel_op_875 + tmp_kernel_op_648*tmp_kernel_op_876 + tmp_kernel_op_658*tmp_kernel_op_877 + tmp_kernel_op_668*tmp_kernel_op_878;
             const real_t elMat_4_6 = tmp_kernel_op_693*tmp_kernel_op_874 + tmp_kernel_op_703*tmp_kernel_op_875 + tmp_kernel_op_713*tmp_kernel_op_876 + tmp_kernel_op_723*tmp_kernel_op_877 + tmp_kernel_op_733*tmp_kernel_op_878;
             const real_t elMat_4_7 = tmp_kernel_op_756*tmp_kernel_op_874 + tmp_kernel_op_761*tmp_kernel_op_875 + tmp_kernel_op_766*tmp_kernel_op_876 + tmp_kernel_op_771*tmp_kernel_op_877 + tmp_kernel_op_776*tmp_kernel_op_878;
             const real_t elMat_4_8 = tmp_kernel_op_797*tmp_kernel_op_874 + tmp_kernel_op_803*tmp_kernel_op_875 + tmp_kernel_op_809*tmp_kernel_op_876 + tmp_kernel_op_815*tmp_kernel_op_877 + tmp_kernel_op_821*tmp_kernel_op_878;
             const real_t elMat_4_9 = tmp_kernel_op_838*tmp_kernel_op_874 + tmp_kernel_op_843*tmp_kernel_op_875 + tmp_kernel_op_848*tmp_kernel_op_876 + tmp_kernel_op_853*tmp_kernel_op_877 + tmp_kernel_op_858*tmp_kernel_op_878;
             const real_t elMat_5_0 = tmp_kernel_op_171*tmp_kernel_op_880 + tmp_kernel_op_256*tmp_kernel_op_881 + tmp_kernel_op_341*tmp_kernel_op_882 + tmp_kernel_op_426*tmp_kernel_op_883 + tmp_kernel_op_86*tmp_kernel_op_879;
             const real_t elMat_5_1 = tmp_kernel_op_459*tmp_kernel_op_879 + tmp_kernel_op_464*tmp_kernel_op_880 + tmp_kernel_op_469*tmp_kernel_op_881 + tmp_kernel_op_474*tmp_kernel_op_882 + tmp_kernel_op_479*tmp_kernel_op_883;
             const real_t elMat_5_2 = tmp_kernel_op_490*tmp_kernel_op_879 + tmp_kernel_op_495*tmp_kernel_op_880 + tmp_kernel_op_500*tmp_kernel_op_881 + tmp_kernel_op_505*tmp_kernel_op_882 + tmp_kernel_op_510*tmp_kernel_op_883;
             const real_t elMat_5_3 = tmp_kernel_op_521*tmp_kernel_op_879 + tmp_kernel_op_526*tmp_kernel_op_880 + tmp_kernel_op_531*tmp_kernel_op_881 + tmp_kernel_op_536*tmp_kernel_op_882 + tmp_kernel_op_541*tmp_kernel_op_883;
             const real_t elMat_5_4 = tmp_kernel_op_566*tmp_kernel_op_879 + tmp_kernel_op_576*tmp_kernel_op_880 + tmp_kernel_op_586*tmp_kernel_op_881 + tmp_kernel_op_596*tmp_kernel_op_882 + tmp_kernel_op_606*tmp_kernel_op_883;
             const real_t elMat_5_5 = tmp_kernel_op_628*tmp_kernel_op_879 + tmp_kernel_op_638*tmp_kernel_op_880 + tmp_kernel_op_648*tmp_kernel_op_881 + tmp_kernel_op_658*tmp_kernel_op_882 + tmp_kernel_op_668*tmp_kernel_op_883;
             const real_t elMat_5_6 = tmp_kernel_op_693*tmp_kernel_op_879 + tmp_kernel_op_703*tmp_kernel_op_880 + tmp_kernel_op_713*tmp_kernel_op_881 + tmp_kernel_op_723*tmp_kernel_op_882 + tmp_kernel_op_733*tmp_kernel_op_883;
             const real_t elMat_5_7 = tmp_kernel_op_756*tmp_kernel_op_879 + tmp_kernel_op_761*tmp_kernel_op_880 + tmp_kernel_op_766*tmp_kernel_op_881 + tmp_kernel_op_771*tmp_kernel_op_882 + tmp_kernel_op_776*tmp_kernel_op_883;
             const real_t elMat_5_8 = tmp_kernel_op_797*tmp_kernel_op_879 + tmp_kernel_op_803*tmp_kernel_op_880 + tmp_kernel_op_809*tmp_kernel_op_881 + tmp_kernel_op_815*tmp_kernel_op_882 + tmp_kernel_op_821*tmp_kernel_op_883;
             const real_t elMat_5_9 = tmp_kernel_op_838*tmp_kernel_op_879 + tmp_kernel_op_843*tmp_kernel_op_880 + tmp_kernel_op_848*tmp_kernel_op_881 + tmp_kernel_op_853*tmp_kernel_op_882 + tmp_kernel_op_858*tmp_kernel_op_883;
             const real_t elMat_6_0 = tmp_kernel_op_171*tmp_kernel_op_885 + tmp_kernel_op_256*tmp_kernel_op_886 + tmp_kernel_op_341*tmp_kernel_op_887 + tmp_kernel_op_426*tmp_kernel_op_888 + tmp_kernel_op_86*tmp_kernel_op_884;
             const real_t elMat_6_1 = tmp_kernel_op_459*tmp_kernel_op_884 + tmp_kernel_op_464*tmp_kernel_op_885 + tmp_kernel_op_469*tmp_kernel_op_886 + tmp_kernel_op_474*tmp_kernel_op_887 + tmp_kernel_op_479*tmp_kernel_op_888;
             const real_t elMat_6_2 = tmp_kernel_op_490*tmp_kernel_op_884 + tmp_kernel_op_495*tmp_kernel_op_885 + tmp_kernel_op_500*tmp_kernel_op_886 + tmp_kernel_op_505*tmp_kernel_op_887 + tmp_kernel_op_510*tmp_kernel_op_888;
             const real_t elMat_6_3 = tmp_kernel_op_521*tmp_kernel_op_884 + tmp_kernel_op_526*tmp_kernel_op_885 + tmp_kernel_op_531*tmp_kernel_op_886 + tmp_kernel_op_536*tmp_kernel_op_887 + tmp_kernel_op_541*tmp_kernel_op_888;
             const real_t elMat_6_4 = tmp_kernel_op_566*tmp_kernel_op_884 + tmp_kernel_op_576*tmp_kernel_op_885 + tmp_kernel_op_586*tmp_kernel_op_886 + tmp_kernel_op_596*tmp_kernel_op_887 + tmp_kernel_op_606*tmp_kernel_op_888;
             const real_t elMat_6_5 = tmp_kernel_op_628*tmp_kernel_op_884 + tmp_kernel_op_638*tmp_kernel_op_885 + tmp_kernel_op_648*tmp_kernel_op_886 + tmp_kernel_op_658*tmp_kernel_op_887 + tmp_kernel_op_668*tmp_kernel_op_888;
             const real_t elMat_6_6 = tmp_kernel_op_693*tmp_kernel_op_884 + tmp_kernel_op_703*tmp_kernel_op_885 + tmp_kernel_op_713*tmp_kernel_op_886 + tmp_kernel_op_723*tmp_kernel_op_887 + tmp_kernel_op_733*tmp_kernel_op_888;
             const real_t elMat_6_7 = tmp_kernel_op_756*tmp_kernel_op_884 + tmp_kernel_op_761*tmp_kernel_op_885 + tmp_kernel_op_766*tmp_kernel_op_886 + tmp_kernel_op_771*tmp_kernel_op_887 + tmp_kernel_op_776*tmp_kernel_op_888;
             const real_t elMat_6_8 = tmp_kernel_op_797*tmp_kernel_op_884 + tmp_kernel_op_803*tmp_kernel_op_885 + tmp_kernel_op_809*tmp_kernel_op_886 + tmp_kernel_op_815*tmp_kernel_op_887 + tmp_kernel_op_821*tmp_kernel_op_888;
             const real_t elMat_6_9 = tmp_kernel_op_838*tmp_kernel_op_884 + tmp_kernel_op_843*tmp_kernel_op_885 + tmp_kernel_op_848*tmp_kernel_op_886 + tmp_kernel_op_853*tmp_kernel_op_887 + tmp_kernel_op_858*tmp_kernel_op_888;
             const real_t elMat_7_0 = tmp_kernel_op_171*tmp_kernel_op_890 + tmp_kernel_op_256*tmp_kernel_op_891 + tmp_kernel_op_341*tmp_kernel_op_892 + tmp_kernel_op_426*tmp_kernel_op_893 + tmp_kernel_op_86*tmp_kernel_op_889;
             const real_t elMat_7_1 = tmp_kernel_op_459*tmp_kernel_op_889 + tmp_kernel_op_464*tmp_kernel_op_890 + tmp_kernel_op_469*tmp_kernel_op_891 + tmp_kernel_op_474*tmp_kernel_op_892 + tmp_kernel_op_479*tmp_kernel_op_893;
             const real_t elMat_7_2 = tmp_kernel_op_490*tmp_kernel_op_889 + tmp_kernel_op_495*tmp_kernel_op_890 + tmp_kernel_op_500*tmp_kernel_op_891 + tmp_kernel_op_505*tmp_kernel_op_892 + tmp_kernel_op_510*tmp_kernel_op_893;
             const real_t elMat_7_3 = tmp_kernel_op_521*tmp_kernel_op_889 + tmp_kernel_op_526*tmp_kernel_op_890 + tmp_kernel_op_531*tmp_kernel_op_891 + tmp_kernel_op_536*tmp_kernel_op_892 + tmp_kernel_op_541*tmp_kernel_op_893;
             const real_t elMat_7_4 = tmp_kernel_op_566*tmp_kernel_op_889 + tmp_kernel_op_576*tmp_kernel_op_890 + tmp_kernel_op_586*tmp_kernel_op_891 + tmp_kernel_op_596*tmp_kernel_op_892 + tmp_kernel_op_606*tmp_kernel_op_893;
             const real_t elMat_7_5 = tmp_kernel_op_628*tmp_kernel_op_889 + tmp_kernel_op_638*tmp_kernel_op_890 + tmp_kernel_op_648*tmp_kernel_op_891 + tmp_kernel_op_658*tmp_kernel_op_892 + tmp_kernel_op_668*tmp_kernel_op_893;
             const real_t elMat_7_6 = tmp_kernel_op_693*tmp_kernel_op_889 + tmp_kernel_op_703*tmp_kernel_op_890 + tmp_kernel_op_713*tmp_kernel_op_891 + tmp_kernel_op_723*tmp_kernel_op_892 + tmp_kernel_op_733*tmp_kernel_op_893;
             const real_t elMat_7_7 = tmp_kernel_op_756*tmp_kernel_op_889 + tmp_kernel_op_761*tmp_kernel_op_890 + tmp_kernel_op_766*tmp_kernel_op_891 + tmp_kernel_op_771*tmp_kernel_op_892 + tmp_kernel_op_776*tmp_kernel_op_893;
             const real_t elMat_7_8 = tmp_kernel_op_797*tmp_kernel_op_889 + tmp_kernel_op_803*tmp_kernel_op_890 + tmp_kernel_op_809*tmp_kernel_op_891 + tmp_kernel_op_815*tmp_kernel_op_892 + tmp_kernel_op_821*tmp_kernel_op_893;
             const real_t elMat_7_9 = tmp_kernel_op_838*tmp_kernel_op_889 + tmp_kernel_op_843*tmp_kernel_op_890 + tmp_kernel_op_848*tmp_kernel_op_891 + tmp_kernel_op_853*tmp_kernel_op_892 + tmp_kernel_op_858*tmp_kernel_op_893;
             const real_t elMat_8_0 = tmp_kernel_op_171*tmp_kernel_op_895 + tmp_kernel_op_256*tmp_kernel_op_896 + tmp_kernel_op_341*tmp_kernel_op_897 + tmp_kernel_op_426*tmp_kernel_op_898 + tmp_kernel_op_86*tmp_kernel_op_894;
             const real_t elMat_8_1 = tmp_kernel_op_459*tmp_kernel_op_894 + tmp_kernel_op_464*tmp_kernel_op_895 + tmp_kernel_op_469*tmp_kernel_op_896 + tmp_kernel_op_474*tmp_kernel_op_897 + tmp_kernel_op_479*tmp_kernel_op_898;
             const real_t elMat_8_2 = tmp_kernel_op_490*tmp_kernel_op_894 + tmp_kernel_op_495*tmp_kernel_op_895 + tmp_kernel_op_500*tmp_kernel_op_896 + tmp_kernel_op_505*tmp_kernel_op_897 + tmp_kernel_op_510*tmp_kernel_op_898;
             const real_t elMat_8_3 = tmp_kernel_op_521*tmp_kernel_op_894 + tmp_kernel_op_526*tmp_kernel_op_895 + tmp_kernel_op_531*tmp_kernel_op_896 + tmp_kernel_op_536*tmp_kernel_op_897 + tmp_kernel_op_541*tmp_kernel_op_898;
             const real_t elMat_8_4 = tmp_kernel_op_566*tmp_kernel_op_894 + tmp_kernel_op_576*tmp_kernel_op_895 + tmp_kernel_op_586*tmp_kernel_op_896 + tmp_kernel_op_596*tmp_kernel_op_897 + tmp_kernel_op_606*tmp_kernel_op_898;
             const real_t elMat_8_5 = tmp_kernel_op_628*tmp_kernel_op_894 + tmp_kernel_op_638*tmp_kernel_op_895 + tmp_kernel_op_648*tmp_kernel_op_896 + tmp_kernel_op_658*tmp_kernel_op_897 + tmp_kernel_op_668*tmp_kernel_op_898;
             const real_t elMat_8_6 = tmp_kernel_op_693*tmp_kernel_op_894 + tmp_kernel_op_703*tmp_kernel_op_895 + tmp_kernel_op_713*tmp_kernel_op_896 + tmp_kernel_op_723*tmp_kernel_op_897 + tmp_kernel_op_733*tmp_kernel_op_898;
             const real_t elMat_8_7 = tmp_kernel_op_756*tmp_kernel_op_894 + tmp_kernel_op_761*tmp_kernel_op_895 + tmp_kernel_op_766*tmp_kernel_op_896 + tmp_kernel_op_771*tmp_kernel_op_897 + tmp_kernel_op_776*tmp_kernel_op_898;
             const real_t elMat_8_8 = tmp_kernel_op_797*tmp_kernel_op_894 + tmp_kernel_op_803*tmp_kernel_op_895 + tmp_kernel_op_809*tmp_kernel_op_896 + tmp_kernel_op_815*tmp_kernel_op_897 + tmp_kernel_op_821*tmp_kernel_op_898;
             const real_t elMat_8_9 = tmp_kernel_op_838*tmp_kernel_op_894 + tmp_kernel_op_843*tmp_kernel_op_895 + tmp_kernel_op_848*tmp_kernel_op_896 + tmp_kernel_op_853*tmp_kernel_op_897 + tmp_kernel_op_858*tmp_kernel_op_898;
             const real_t elMat_9_0 = tmp_kernel_op_171*tmp_kernel_op_900 + tmp_kernel_op_256*tmp_kernel_op_901 + tmp_kernel_op_341*tmp_kernel_op_902 + tmp_kernel_op_426*tmp_kernel_op_903 + tmp_kernel_op_86*tmp_kernel_op_899;
             const real_t elMat_9_1 = tmp_kernel_op_459*tmp_kernel_op_899 + tmp_kernel_op_464*tmp_kernel_op_900 + tmp_kernel_op_469*tmp_kernel_op_901 + tmp_kernel_op_474*tmp_kernel_op_902 + tmp_kernel_op_479*tmp_kernel_op_903;
             const real_t elMat_9_2 = tmp_kernel_op_490*tmp_kernel_op_899 + tmp_kernel_op_495*tmp_kernel_op_900 + tmp_kernel_op_500*tmp_kernel_op_901 + tmp_kernel_op_505*tmp_kernel_op_902 + tmp_kernel_op_510*tmp_kernel_op_903;
             const real_t elMat_9_3 = tmp_kernel_op_521*tmp_kernel_op_899 + tmp_kernel_op_526*tmp_kernel_op_900 + tmp_kernel_op_531*tmp_kernel_op_901 + tmp_kernel_op_536*tmp_kernel_op_902 + tmp_kernel_op_541*tmp_kernel_op_903;
             const real_t elMat_9_4 = tmp_kernel_op_566*tmp_kernel_op_899 + tmp_kernel_op_576*tmp_kernel_op_900 + tmp_kernel_op_586*tmp_kernel_op_901 + tmp_kernel_op_596*tmp_kernel_op_902 + tmp_kernel_op_606*tmp_kernel_op_903;
             const real_t elMat_9_5 = tmp_kernel_op_628*tmp_kernel_op_899 + tmp_kernel_op_638*tmp_kernel_op_900 + tmp_kernel_op_648*tmp_kernel_op_901 + tmp_kernel_op_658*tmp_kernel_op_902 + tmp_kernel_op_668*tmp_kernel_op_903;
             const real_t elMat_9_6 = tmp_kernel_op_693*tmp_kernel_op_899 + tmp_kernel_op_703*tmp_kernel_op_900 + tmp_kernel_op_713*tmp_kernel_op_901 + tmp_kernel_op_723*tmp_kernel_op_902 + tmp_kernel_op_733*tmp_kernel_op_903;
             const real_t elMat_9_7 = tmp_kernel_op_756*tmp_kernel_op_899 + tmp_kernel_op_761*tmp_kernel_op_900 + tmp_kernel_op_766*tmp_kernel_op_901 + tmp_kernel_op_771*tmp_kernel_op_902 + tmp_kernel_op_776*tmp_kernel_op_903;
             const real_t elMat_9_8 = tmp_kernel_op_797*tmp_kernel_op_899 + tmp_kernel_op_803*tmp_kernel_op_900 + tmp_kernel_op_809*tmp_kernel_op_901 + tmp_kernel_op_815*tmp_kernel_op_902 + tmp_kernel_op_821*tmp_kernel_op_903;
             const real_t elMat_9_9 = tmp_kernel_op_838*tmp_kernel_op_899 + tmp_kernel_op_843*tmp_kernel_op_900 + tmp_kernel_op_848*tmp_kernel_op_901 + tmp_kernel_op_853*tmp_kernel_op_902 + tmp_kernel_op_858*tmp_kernel_op_903;
         
             std::vector< uint_t > _data_rowIdx( 10 );
             std::vector< uint_t > _data_colIdx( 10 );
             std::vector< real_t > _data_mat( 100 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[1] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[2] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[3] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[7] = ((uint64_t)(_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[8] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[9] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[3] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[7] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_0_4));
             _data_mat[5] = ((real_t)(elMat_0_5));
             _data_mat[6] = ((real_t)(elMat_0_6));
             _data_mat[7] = ((real_t)(elMat_0_7));
             _data_mat[8] = ((real_t)(elMat_0_8));
             _data_mat[9] = ((real_t)(elMat_0_9));
             _data_mat[10] = ((real_t)(elMat_1_0));
             _data_mat[11] = ((real_t)(elMat_1_1));
             _data_mat[12] = ((real_t)(elMat_1_2));
             _data_mat[13] = ((real_t)(elMat_1_3));
             _data_mat[14] = ((real_t)(elMat_1_4));
             _data_mat[15] = ((real_t)(elMat_1_5));
             _data_mat[16] = ((real_t)(elMat_1_6));
             _data_mat[17] = ((real_t)(elMat_1_7));
             _data_mat[18] = ((real_t)(elMat_1_8));
             _data_mat[19] = ((real_t)(elMat_1_9));
             _data_mat[20] = ((real_t)(elMat_2_0));
             _data_mat[21] = ((real_t)(elMat_2_1));
             _data_mat[22] = ((real_t)(elMat_2_2));
             _data_mat[23] = ((real_t)(elMat_2_3));
             _data_mat[24] = ((real_t)(elMat_2_4));
             _data_mat[25] = ((real_t)(elMat_2_5));
             _data_mat[26] = ((real_t)(elMat_2_6));
             _data_mat[27] = ((real_t)(elMat_2_7));
             _data_mat[28] = ((real_t)(elMat_2_8));
             _data_mat[29] = ((real_t)(elMat_2_9));
             _data_mat[30] = ((real_t)(elMat_3_0));
             _data_mat[31] = ((real_t)(elMat_3_1));
             _data_mat[32] = ((real_t)(elMat_3_2));
             _data_mat[33] = ((real_t)(elMat_3_3));
             _data_mat[34] = ((real_t)(elMat_3_4));
             _data_mat[35] = ((real_t)(elMat_3_5));
             _data_mat[36] = ((real_t)(elMat_3_6));
             _data_mat[37] = ((real_t)(elMat_3_7));
             _data_mat[38] = ((real_t)(elMat_3_8));
             _data_mat[39] = ((real_t)(elMat_3_9));
             _data_mat[40] = ((real_t)(elMat_4_0));
             _data_mat[41] = ((real_t)(elMat_4_1));
             _data_mat[42] = ((real_t)(elMat_4_2));
             _data_mat[43] = ((real_t)(elMat_4_3));
             _data_mat[44] = ((real_t)(elMat_4_4));
             _data_mat[45] = ((real_t)(elMat_4_5));
             _data_mat[46] = ((real_t)(elMat_4_6));
             _data_mat[47] = ((real_t)(elMat_4_7));
             _data_mat[48] = ((real_t)(elMat_4_8));
             _data_mat[49] = ((real_t)(elMat_4_9));
             _data_mat[50] = ((real_t)(elMat_5_0));
             _data_mat[51] = ((real_t)(elMat_5_1));
             _data_mat[52] = ((real_t)(elMat_5_2));
             _data_mat[53] = ((real_t)(elMat_5_3));
             _data_mat[54] = ((real_t)(elMat_5_4));
             _data_mat[55] = ((real_t)(elMat_5_5));
             _data_mat[56] = ((real_t)(elMat_5_6));
             _data_mat[57] = ((real_t)(elMat_5_7));
             _data_mat[58] = ((real_t)(elMat_5_8));
             _data_mat[59] = ((real_t)(elMat_5_9));
             _data_mat[60] = ((real_t)(elMat_6_0));
             _data_mat[61] = ((real_t)(elMat_6_1));
             _data_mat[62] = ((real_t)(elMat_6_2));
             _data_mat[63] = ((real_t)(elMat_6_3));
             _data_mat[64] = ((real_t)(elMat_6_4));
             _data_mat[65] = ((real_t)(elMat_6_5));
             _data_mat[66] = ((real_t)(elMat_6_6));
             _data_mat[67] = ((real_t)(elMat_6_7));
             _data_mat[68] = ((real_t)(elMat_6_8));
             _data_mat[69] = ((real_t)(elMat_6_9));
             _data_mat[70] = ((real_t)(elMat_7_0));
             _data_mat[71] = ((real_t)(elMat_7_1));
             _data_mat[72] = ((real_t)(elMat_7_2));
             _data_mat[73] = ((real_t)(elMat_7_3));
             _data_mat[74] = ((real_t)(elMat_7_4));
             _data_mat[75] = ((real_t)(elMat_7_5));
             _data_mat[76] = ((real_t)(elMat_7_6));
             _data_mat[77] = ((real_t)(elMat_7_7));
             _data_mat[78] = ((real_t)(elMat_7_8));
             _data_mat[79] = ((real_t)(elMat_7_9));
             _data_mat[80] = ((real_t)(elMat_8_0));
             _data_mat[81] = ((real_t)(elMat_8_1));
             _data_mat[82] = ((real_t)(elMat_8_2));
             _data_mat[83] = ((real_t)(elMat_8_3));
             _data_mat[84] = ((real_t)(elMat_8_4));
             _data_mat[85] = ((real_t)(elMat_8_5));
             _data_mat[86] = ((real_t)(elMat_8_6));
             _data_mat[87] = ((real_t)(elMat_8_7));
             _data_mat[88] = ((real_t)(elMat_8_8));
             _data_mat[89] = ((real_t)(elMat_8_9));
             _data_mat[90] = ((real_t)(elMat_9_0));
             _data_mat[91] = ((real_t)(elMat_9_1));
             _data_mat[92] = ((real_t)(elMat_9_2));
             _data_mat[93] = ((real_t)(elMat_9_3));
             _data_mat[94] = ((real_t)(elMat_9_4));
             _data_mat[95] = ((real_t)(elMat_9_5));
             _data_mat[96] = ((real_t)(elMat_9_6));
             _data_mat[97] = ((real_t)(elMat_9_7));
             _data_mat[98] = ((real_t)(elMat_9_8));
             _data_mat[99] = ((real_t)(elMat_9_9));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const real_t tmp_coords_jac_11_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const real_t tmp_coords_jac_9_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const real_t tmp_coords_jac_8_GREEN_UP = jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP;
       const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const real_t tmp_coords_jac_7_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_10_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_12_GREEN_UP = jac_affine_0_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_0_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_0_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
       const real_t tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const real_t jac_affine_inv_0_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
       const real_t jac_affine_inv_0_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_2_1_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const real_t jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const real_t jac_affine_inv_1_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t jac_affine_inv_2_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       const real_t tmp_moved_constant_1107 = jac_affine_inv_2_0_GREEN_UP*4.0;
       const real_t tmp_moved_constant_1108 = jac_affine_inv_0_0_GREEN_UP*4.0;
       const real_t tmp_moved_constant_1109 = jac_affine_inv_1_0_GREEN_UP*4.0;
       const real_t tmp_moved_constant_1110 = tmp_moved_constant_1108 + tmp_moved_constant_1109;
       const real_t tmp_moved_constant_1111 = tmp_moved_constant_1107 + tmp_moved_constant_1110;
       const real_t tmp_moved_constant_1112 = jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_1111 + jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_1111 + jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_1111;
       const real_t tmp_moved_constant_1113 = jac_affine_inv_2_1_GREEN_UP*4.0;
       const real_t tmp_moved_constant_1114 = jac_affine_inv_0_1_GREEN_UP*4.0;
       const real_t tmp_moved_constant_1115 = jac_affine_inv_1_1_GREEN_UP*4.0;
       const real_t tmp_moved_constant_1116 = tmp_moved_constant_1114 + tmp_moved_constant_1115;
       const real_t tmp_moved_constant_1117 = tmp_moved_constant_1113 + tmp_moved_constant_1116;
       const real_t tmp_moved_constant_1118 = jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_1117 + jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_1117 + jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_1117;
       const real_t tmp_moved_constant_1119 = jac_affine_inv_2_2_GREEN_UP*4.0;
       const real_t tmp_moved_constant_1120 = jac_affine_inv_0_2_GREEN_UP*4.0;
       const real_t tmp_moved_constant_1121 = jac_affine_inv_1_2_GREEN_UP*4.0;
       const real_t tmp_moved_constant_1122 = tmp_moved_constant_1120 + tmp_moved_constant_1121;
       const real_t tmp_moved_constant_1123 = tmp_moved_constant_1119 + tmp_moved_constant_1122;
       const real_t tmp_moved_constant_1124 = jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_1123 + jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_1123 + jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_1123;
       const real_t tmp_moved_constant_1125 = jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_1111 + jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1111 + jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1111;
       const real_t tmp_moved_constant_1126 = jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_1117 + jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1117 + jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1117;
       const real_t tmp_moved_constant_1127 = jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_1123 + jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1123 + jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1123;
       const real_t tmp_moved_constant_1128 = jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1111 + jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1111 + jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1111;
       const real_t tmp_moved_constant_1129 = jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1117 + jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1117 + jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1117;
       const real_t tmp_moved_constant_1130 = jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1123 + jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1123 + jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1123;
       const real_t tmp_moved_constant_1131 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_28 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_28 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_1132 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_28 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_28 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_1133 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_28 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_28 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_1134 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_113 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_113 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_113;
       const real_t tmp_moved_constant_1135 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_113 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_113 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_113;
       const real_t tmp_moved_constant_1136 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_113 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_113 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_113;
       const real_t tmp_moved_constant_1137 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_198 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_198 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_198;
       const real_t tmp_moved_constant_1138 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_198 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_198 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_198;
       const real_t tmp_moved_constant_1139 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_198 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_198 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_198;
       const real_t tmp_moved_constant_1140 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_283 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_283 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_283;
       const real_t tmp_moved_constant_1141 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_283 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_283 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_283;
       const real_t tmp_moved_constant_1142 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_283 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_283 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_283;
       const real_t tmp_moved_constant_1143 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_368 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_368 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_368;
       const real_t tmp_moved_constant_1144 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_368 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_368 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_368;
       const real_t tmp_moved_constant_1145 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_368 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_368 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_368;
       const real_t tmp_moved_constant_1146 = jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_1108;
       const real_t tmp_moved_constant_1147 = jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1108;
       const real_t tmp_moved_constant_1148 = (jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*4.0;
       const real_t tmp_moved_constant_1149 = jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1114;
       const real_t tmp_moved_constant_1150 = (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*4.0;
       const real_t tmp_moved_constant_1151 = (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*4.0;
       const real_t tmp_moved_constant_1152 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_455;
       const real_t tmp_moved_constant_1153 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_455;
       const real_t tmp_moved_constant_1154 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_455;
       const real_t tmp_moved_constant_1155 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_460;
       const real_t tmp_moved_constant_1156 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_460;
       const real_t tmp_moved_constant_1157 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_460;
       const real_t tmp_moved_constant_1158 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_465;
       const real_t tmp_moved_constant_1159 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_465;
       const real_t tmp_moved_constant_1160 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_465;
       const real_t tmp_moved_constant_1161 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_470;
       const real_t tmp_moved_constant_1162 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_470;
       const real_t tmp_moved_constant_1163 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_470;
       const real_t tmp_moved_constant_1164 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_475;
       const real_t tmp_moved_constant_1165 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_475;
       const real_t tmp_moved_constant_1166 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_475;
       const real_t tmp_moved_constant_1167 = jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1109;
       const real_t tmp_moved_constant_1168 = jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1109;
       const real_t tmp_moved_constant_1169 = (jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*4.0;
       const real_t tmp_moved_constant_1170 = jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1115;
       const real_t tmp_moved_constant_1171 = (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*4.0;
       const real_t tmp_moved_constant_1172 = (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*4.0;
       const real_t tmp_moved_constant_1173 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_486;
       const real_t tmp_moved_constant_1174 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_486;
       const real_t tmp_moved_constant_1175 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_486;
       const real_t tmp_moved_constant_1176 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_491;
       const real_t tmp_moved_constant_1177 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_491;
       const real_t tmp_moved_constant_1178 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_491;
       const real_t tmp_moved_constant_1179 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_496;
       const real_t tmp_moved_constant_1180 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_496;
       const real_t tmp_moved_constant_1181 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_496;
       const real_t tmp_moved_constant_1182 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_501;
       const real_t tmp_moved_constant_1183 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_501;
       const real_t tmp_moved_constant_1184 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_501;
       const real_t tmp_moved_constant_1185 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_506;
       const real_t tmp_moved_constant_1186 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_506;
       const real_t tmp_moved_constant_1187 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_506;
       const real_t tmp_moved_constant_1188 = jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1107;
       const real_t tmp_moved_constant_1189 = jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1107;
       const real_t tmp_moved_constant_1190 = (jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*4.0;
       const real_t tmp_moved_constant_1191 = jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1113;
       const real_t tmp_moved_constant_1192 = (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*4.0;
       const real_t tmp_moved_constant_1193 = (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*4.0;
       const real_t tmp_moved_constant_1194 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_517;
       const real_t tmp_moved_constant_1195 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_517;
       const real_t tmp_moved_constant_1196 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_517;
       const real_t tmp_moved_constant_1197 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_522;
       const real_t tmp_moved_constant_1198 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_522;
       const real_t tmp_moved_constant_1199 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_522;
       const real_t tmp_moved_constant_1200 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_527;
       const real_t tmp_moved_constant_1201 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_527;
       const real_t tmp_moved_constant_1202 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_527;
       const real_t tmp_moved_constant_1203 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_532;
       const real_t tmp_moved_constant_1204 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_532;
       const real_t tmp_moved_constant_1205 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_532;
       const real_t tmp_moved_constant_1206 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_537;
       const real_t tmp_moved_constant_1207 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_537;
       const real_t tmp_moved_constant_1208 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_537;
       const real_t tmp_moved_constant_1209 = jac_affine_inv_2_0_GREEN_UP*8.0;
       const real_t tmp_moved_constant_1210 = jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_1209;
       const real_t tmp_moved_constant_1211 = jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1109;
       const real_t tmp_moved_constant_1212 = jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1107;
       const real_t tmp_moved_constant_1213 = tmp_moved_constant_1211 + tmp_moved_constant_1212;
       const real_t tmp_moved_constant_1214 = jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1109;
       const real_t tmp_moved_constant_1215 = jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1107;
       const real_t tmp_moved_constant_1216 = tmp_moved_constant_1214 + tmp_moved_constant_1215;
       const real_t tmp_moved_constant_1217 = jac_affine_inv_2_1_GREEN_UP*8.0;
       const real_t tmp_moved_constant_1218 = jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1217;
       const real_t tmp_moved_constant_1219 = jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1115;
       const real_t tmp_moved_constant_1220 = jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1113;
       const real_t tmp_moved_constant_1221 = tmp_moved_constant_1219 + tmp_moved_constant_1220;
       const real_t tmp_moved_constant_1222 = jac_affine_inv_2_2_GREEN_UP*8.0;
       const real_t tmp_moved_constant_1223 = jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1222;
       const real_t tmp_moved_constant_1224 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_24;
       const real_t tmp_moved_constant_1225 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_1226 = tmp_moved_constant_1224 + tmp_moved_constant_1225;
       const real_t tmp_moved_constant_1227 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_24;
       const real_t tmp_moved_constant_1228 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_1229 = tmp_moved_constant_1227 + tmp_moved_constant_1228;
       const real_t tmp_moved_constant_1230 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_24;
       const real_t tmp_moved_constant_1231 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_1232 = tmp_moved_constant_1230 + tmp_moved_constant_1231;
       const real_t tmp_moved_constant_1233 = tmp_moved_constant_1109*0.5;
       const real_t tmp_moved_constant_1234 = tmp_moved_constant_1107*0.16666666666666666;
       const real_t tmp_moved_constant_1235 = tmp_moved_constant_1233 + tmp_moved_constant_1234;
       const real_t tmp_moved_constant_1236 = tmp_moved_constant_1115*0.5;
       const real_t tmp_moved_constant_1237 = tmp_moved_constant_1113*0.16666666666666666;
       const real_t tmp_moved_constant_1238 = tmp_moved_constant_1236 + tmp_moved_constant_1237;
       const real_t tmp_moved_constant_1239 = tmp_moved_constant_1121*0.5;
       const real_t tmp_moved_constant_1240 = tmp_moved_constant_1119*0.16666666666666666;
       const real_t tmp_moved_constant_1241 = tmp_moved_constant_1239 + tmp_moved_constant_1240;
       const real_t tmp_moved_constant_1242 = tmp_moved_constant_1109*0.16666666666666666;
       const real_t tmp_moved_constant_1243 = tmp_moved_constant_1107*0.5;
       const real_t tmp_moved_constant_1244 = tmp_moved_constant_1242 + tmp_moved_constant_1243;
       const real_t tmp_moved_constant_1245 = tmp_moved_constant_1115*0.16666666666666666;
       const real_t tmp_moved_constant_1246 = tmp_moved_constant_1113*0.5;
       const real_t tmp_moved_constant_1247 = tmp_moved_constant_1245 + tmp_moved_constant_1246;
       const real_t tmp_moved_constant_1248 = tmp_moved_constant_1121*0.16666666666666666;
       const real_t tmp_moved_constant_1249 = tmp_moved_constant_1119*0.5;
       const real_t tmp_moved_constant_1250 = tmp_moved_constant_1248 + tmp_moved_constant_1249;
       const real_t tmp_moved_constant_1251 = tmp_moved_constant_1109*0.16666666666666666;
       const real_t tmp_moved_constant_1252 = tmp_moved_constant_1107*0.16666666666666666;
       const real_t tmp_moved_constant_1253 = tmp_moved_constant_1251 + tmp_moved_constant_1252;
       const real_t tmp_moved_constant_1254 = tmp_moved_constant_1115*0.16666666666666666;
       const real_t tmp_moved_constant_1255 = tmp_moved_constant_1113*0.16666666666666666;
       const real_t tmp_moved_constant_1256 = tmp_moved_constant_1254 + tmp_moved_constant_1255;
       const real_t tmp_moved_constant_1257 = tmp_moved_constant_1121*0.16666666666666666;
       const real_t tmp_moved_constant_1258 = tmp_moved_constant_1119*0.16666666666666666;
       const real_t tmp_moved_constant_1259 = tmp_moved_constant_1257 + tmp_moved_constant_1258;
       const real_t tmp_moved_constant_1260 = tmp_moved_constant_1109*0.16666666666666666;
       const real_t tmp_moved_constant_1261 = tmp_moved_constant_1107*0.16666666666666666;
       const real_t tmp_moved_constant_1262 = tmp_moved_constant_1260 + tmp_moved_constant_1261;
       const real_t tmp_moved_constant_1263 = tmp_moved_constant_1115*0.16666666666666666;
       const real_t tmp_moved_constant_1264 = tmp_moved_constant_1113*0.16666666666666666;
       const real_t tmp_moved_constant_1265 = tmp_moved_constant_1263 + tmp_moved_constant_1264;
       const real_t tmp_moved_constant_1266 = tmp_moved_constant_1121*0.16666666666666666;
       const real_t tmp_moved_constant_1267 = tmp_moved_constant_1119*0.16666666666666666;
       const real_t tmp_moved_constant_1268 = tmp_moved_constant_1266 + tmp_moved_constant_1267;
       const real_t tmp_moved_constant_1269 = jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_1209;
       const real_t tmp_moved_constant_1270 = jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1108;
       const real_t tmp_moved_constant_1271 = jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_1107;
       const real_t tmp_moved_constant_1272 = tmp_moved_constant_1270 + tmp_moved_constant_1271;
       const real_t tmp_moved_constant_1273 = jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1108;
       const real_t tmp_moved_constant_1274 = jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1107;
       const real_t tmp_moved_constant_1275 = tmp_moved_constant_1273 + tmp_moved_constant_1274;
       const real_t tmp_moved_constant_1276 = jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_1217;
       const real_t tmp_moved_constant_1277 = jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1114;
       const real_t tmp_moved_constant_1278 = jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1113;
       const real_t tmp_moved_constant_1279 = tmp_moved_constant_1277 + tmp_moved_constant_1278;
       const real_t tmp_moved_constant_1280 = jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1222;
       const real_t tmp_moved_constant_1281 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_24;
       const real_t tmp_moved_constant_1282 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_25;
       const real_t tmp_moved_constant_1283 = tmp_moved_constant_1281 + tmp_moved_constant_1282;
       const real_t tmp_moved_constant_1284 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_24;
       const real_t tmp_moved_constant_1285 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_25;
       const real_t tmp_moved_constant_1286 = tmp_moved_constant_1284 + tmp_moved_constant_1285;
       const real_t tmp_moved_constant_1287 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_24;
       const real_t tmp_moved_constant_1288 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_25;
       const real_t tmp_moved_constant_1289 = tmp_moved_constant_1287 + tmp_moved_constant_1288;
       const real_t tmp_moved_constant_1290 = tmp_moved_constant_1108*0.5;
       const real_t tmp_moved_constant_1291 = tmp_moved_constant_1107*0.16666666666666666;
       const real_t tmp_moved_constant_1292 = tmp_moved_constant_1290 + tmp_moved_constant_1291;
       const real_t tmp_moved_constant_1293 = tmp_moved_constant_1114*0.5;
       const real_t tmp_moved_constant_1294 = tmp_moved_constant_1113*0.16666666666666666;
       const real_t tmp_moved_constant_1295 = tmp_moved_constant_1293 + tmp_moved_constant_1294;
       const real_t tmp_moved_constant_1296 = tmp_moved_constant_1120*0.5;
       const real_t tmp_moved_constant_1297 = tmp_moved_constant_1119*0.16666666666666666;
       const real_t tmp_moved_constant_1298 = tmp_moved_constant_1296 + tmp_moved_constant_1297;
       const real_t tmp_moved_constant_1299 = tmp_moved_constant_1108*0.16666666666666666;
       const real_t tmp_moved_constant_1300 = tmp_moved_constant_1107*0.16666666666666666;
       const real_t tmp_moved_constant_1301 = tmp_moved_constant_1299 + tmp_moved_constant_1300;
       const real_t tmp_moved_constant_1302 = tmp_moved_constant_1114*0.16666666666666666;
       const real_t tmp_moved_constant_1303 = tmp_moved_constant_1113*0.16666666666666666;
       const real_t tmp_moved_constant_1304 = tmp_moved_constant_1302 + tmp_moved_constant_1303;
       const real_t tmp_moved_constant_1305 = tmp_moved_constant_1120*0.16666666666666666;
       const real_t tmp_moved_constant_1306 = tmp_moved_constant_1119*0.16666666666666666;
       const real_t tmp_moved_constant_1307 = tmp_moved_constant_1305 + tmp_moved_constant_1306;
       const real_t tmp_moved_constant_1308 = tmp_moved_constant_1108*0.16666666666666666;
       const real_t tmp_moved_constant_1309 = tmp_moved_constant_1107*0.5;
       const real_t tmp_moved_constant_1310 = tmp_moved_constant_1308 + tmp_moved_constant_1309;
       const real_t tmp_moved_constant_1311 = tmp_moved_constant_1114*0.16666666666666666;
       const real_t tmp_moved_constant_1312 = tmp_moved_constant_1113*0.5;
       const real_t tmp_moved_constant_1313 = tmp_moved_constant_1311 + tmp_moved_constant_1312;
       const real_t tmp_moved_constant_1314 = tmp_moved_constant_1120*0.16666666666666666;
       const real_t tmp_moved_constant_1315 = tmp_moved_constant_1119*0.5;
       const real_t tmp_moved_constant_1316 = tmp_moved_constant_1314 + tmp_moved_constant_1315;
       const real_t tmp_moved_constant_1317 = tmp_moved_constant_1108*0.16666666666666666;
       const real_t tmp_moved_constant_1318 = tmp_moved_constant_1107*0.16666666666666666;
       const real_t tmp_moved_constant_1319 = tmp_moved_constant_1317 + tmp_moved_constant_1318;
       const real_t tmp_moved_constant_1320 = tmp_moved_constant_1114*0.16666666666666666;
       const real_t tmp_moved_constant_1321 = tmp_moved_constant_1113*0.16666666666666666;
       const real_t tmp_moved_constant_1322 = tmp_moved_constant_1320 + tmp_moved_constant_1321;
       const real_t tmp_moved_constant_1323 = tmp_moved_constant_1120*0.16666666666666666;
       const real_t tmp_moved_constant_1324 = tmp_moved_constant_1119*0.16666666666666666;
       const real_t tmp_moved_constant_1325 = tmp_moved_constant_1323 + tmp_moved_constant_1324;
       const real_t tmp_moved_constant_1326 = jac_affine_inv_1_0_GREEN_UP*8.0;
       const real_t tmp_moved_constant_1327 = jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_1326;
       const real_t tmp_moved_constant_1328 = jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1108;
       const real_t tmp_moved_constant_1329 = jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_1109;
       const real_t tmp_moved_constant_1330 = tmp_moved_constant_1328 + tmp_moved_constant_1329;
       const real_t tmp_moved_constant_1331 = jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1108;
       const real_t tmp_moved_constant_1332 = jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1109;
       const real_t tmp_moved_constant_1333 = tmp_moved_constant_1331 + tmp_moved_constant_1332;
       const real_t tmp_moved_constant_1334 = jac_affine_inv_1_1_GREEN_UP*8.0;
       const real_t tmp_moved_constant_1335 = jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_1334;
       const real_t tmp_moved_constant_1336 = jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1114;
       const real_t tmp_moved_constant_1337 = jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1115;
       const real_t tmp_moved_constant_1338 = tmp_moved_constant_1336 + tmp_moved_constant_1337;
       const real_t tmp_moved_constant_1339 = jac_affine_inv_1_2_GREEN_UP*8.0;
       const real_t tmp_moved_constant_1340 = jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1339;
       const real_t tmp_moved_constant_1341 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_1342 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_25;
       const real_t tmp_moved_constant_1343 = tmp_moved_constant_1341 + tmp_moved_constant_1342;
       const real_t tmp_moved_constant_1344 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_1345 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_25;
       const real_t tmp_moved_constant_1346 = tmp_moved_constant_1344 + tmp_moved_constant_1345;
       const real_t tmp_moved_constant_1347 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_26;
       const real_t tmp_moved_constant_1348 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_25;
       const real_t tmp_moved_constant_1349 = tmp_moved_constant_1347 + tmp_moved_constant_1348;
       const real_t tmp_moved_constant_1350 = tmp_moved_constant_1108*0.16666666666666666;
       const real_t tmp_moved_constant_1351 = tmp_moved_constant_1109*0.16666666666666666;
       const real_t tmp_moved_constant_1352 = tmp_moved_constant_1350 + tmp_moved_constant_1351;
       const real_t tmp_moved_constant_1353 = tmp_moved_constant_1114*0.16666666666666666;
       const real_t tmp_moved_constant_1354 = tmp_moved_constant_1115*0.16666666666666666;
       const real_t tmp_moved_constant_1355 = tmp_moved_constant_1353 + tmp_moved_constant_1354;
       const real_t tmp_moved_constant_1356 = tmp_moved_constant_1120*0.16666666666666666;
       const real_t tmp_moved_constant_1357 = tmp_moved_constant_1121*0.16666666666666666;
       const real_t tmp_moved_constant_1358 = tmp_moved_constant_1356 + tmp_moved_constant_1357;
       const real_t tmp_moved_constant_1359 = tmp_moved_constant_1108*0.5;
       const real_t tmp_moved_constant_1360 = tmp_moved_constant_1109*0.16666666666666666;
       const real_t tmp_moved_constant_1361 = tmp_moved_constant_1359 + tmp_moved_constant_1360;
       const real_t tmp_moved_constant_1362 = tmp_moved_constant_1114*0.5;
       const real_t tmp_moved_constant_1363 = tmp_moved_constant_1115*0.16666666666666666;
       const real_t tmp_moved_constant_1364 = tmp_moved_constant_1362 + tmp_moved_constant_1363;
       const real_t tmp_moved_constant_1365 = tmp_moved_constant_1120*0.5;
       const real_t tmp_moved_constant_1366 = tmp_moved_constant_1121*0.16666666666666666;
       const real_t tmp_moved_constant_1367 = tmp_moved_constant_1365 + tmp_moved_constant_1366;
       const real_t tmp_moved_constant_1368 = tmp_moved_constant_1108*0.16666666666666666;
       const real_t tmp_moved_constant_1369 = tmp_moved_constant_1109*0.5;
       const real_t tmp_moved_constant_1370 = tmp_moved_constant_1368 + tmp_moved_constant_1369;
       const real_t tmp_moved_constant_1371 = tmp_moved_constant_1114*0.16666666666666666;
       const real_t tmp_moved_constant_1372 = tmp_moved_constant_1115*0.5;
       const real_t tmp_moved_constant_1373 = tmp_moved_constant_1371 + tmp_moved_constant_1372;
       const real_t tmp_moved_constant_1374 = tmp_moved_constant_1120*0.16666666666666666;
       const real_t tmp_moved_constant_1375 = tmp_moved_constant_1121*0.5;
       const real_t tmp_moved_constant_1376 = tmp_moved_constant_1374 + tmp_moved_constant_1375;
       const real_t tmp_moved_constant_1377 = tmp_moved_constant_1108*0.16666666666666666;
       const real_t tmp_moved_constant_1378 = tmp_moved_constant_1109*0.16666666666666666;
       const real_t tmp_moved_constant_1379 = tmp_moved_constant_1377 + tmp_moved_constant_1378;
       const real_t tmp_moved_constant_1380 = tmp_moved_constant_1114*0.16666666666666666;
       const real_t tmp_moved_constant_1381 = tmp_moved_constant_1115*0.16666666666666666;
       const real_t tmp_moved_constant_1382 = tmp_moved_constant_1380 + tmp_moved_constant_1381;
       const real_t tmp_moved_constant_1383 = tmp_moved_constant_1120*0.16666666666666666;
       const real_t tmp_moved_constant_1384 = tmp_moved_constant_1121*0.16666666666666666;
       const real_t tmp_moved_constant_1385 = tmp_moved_constant_1383 + tmp_moved_constant_1384;
       const real_t tmp_moved_constant_1386 = jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_1108;
       const real_t tmp_moved_constant_1387 = jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_1109;
       const real_t tmp_moved_constant_1388 = -tmp_moved_constant_1110 - tmp_moved_constant_1209;
       const real_t tmp_moved_constant_1389 = jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_1388 - tmp_moved_constant_1386 - tmp_moved_constant_1387;
       const real_t tmp_moved_constant_1390 = -tmp_moved_constant_1116 - tmp_moved_constant_1217;
       const real_t tmp_moved_constant_1391 = jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_1390 - tmp_moved_constant_1211 - tmp_moved_constant_1270;
       const real_t tmp_moved_constant_1392 = -tmp_moved_constant_1122 - tmp_moved_constant_1222;
       const real_t tmp_moved_constant_1393 = jac_affine_inv_2_0_GREEN_UP*tmp_moved_constant_1392 - tmp_moved_constant_1214 - tmp_moved_constant_1273;
       const real_t tmp_moved_constant_1394 = jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1388 - tmp_moved_constant_1212 - tmp_moved_constant_1271;
       const real_t tmp_moved_constant_1395 = jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1114;
       const real_t tmp_moved_constant_1396 = jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1115;
       const real_t tmp_moved_constant_1397 = jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1390 - tmp_moved_constant_1395 - tmp_moved_constant_1396;
       const real_t tmp_moved_constant_1398 = jac_affine_inv_2_1_GREEN_UP*tmp_moved_constant_1392 - tmp_moved_constant_1219 - tmp_moved_constant_1277;
       const real_t tmp_moved_constant_1399 = jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1388 - tmp_moved_constant_1215 - tmp_moved_constant_1274;
       const real_t tmp_moved_constant_1400 = jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1390 - tmp_moved_constant_1220 - tmp_moved_constant_1278;
       const real_t tmp_moved_constant_1401 = jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1120;
       const real_t tmp_moved_constant_1402 = jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1121;
       const real_t tmp_moved_constant_1403 = jac_affine_inv_2_2_GREEN_UP*tmp_moved_constant_1392 - tmp_moved_constant_1401 - tmp_moved_constant_1402;
       const real_t tmp_moved_constant_1404 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_752 - tmp_moved_constant_1224 - tmp_moved_constant_1281;
       const real_t tmp_moved_constant_1405 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_752 - tmp_moved_constant_1227 - tmp_moved_constant_1284;
       const real_t tmp_moved_constant_1406 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_752 - tmp_moved_constant_1230 - tmp_moved_constant_1287;
       const real_t tmp_moved_constant_1407 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_757 - tmp_moved_constant_1233 - tmp_moved_constant_1290;
       const real_t tmp_moved_constant_1408 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_757 - tmp_moved_constant_1236 - tmp_moved_constant_1293;
       const real_t tmp_moved_constant_1409 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_757 - tmp_moved_constant_1239 - tmp_moved_constant_1296;
       const real_t tmp_moved_constant_1410 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_762 - tmp_moved_constant_1242 - tmp_moved_constant_1299;
       const real_t tmp_moved_constant_1411 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_762 - tmp_moved_constant_1245 - tmp_moved_constant_1302;
       const real_t tmp_moved_constant_1412 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_762 - tmp_moved_constant_1248 - tmp_moved_constant_1305;
       const real_t tmp_moved_constant_1413 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_767 - tmp_moved_constant_1251 - tmp_moved_constant_1308;
       const real_t tmp_moved_constant_1414 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_767 - tmp_moved_constant_1254 - tmp_moved_constant_1311;
       const real_t tmp_moved_constant_1415 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_767 - tmp_moved_constant_1257 - tmp_moved_constant_1314;
       const real_t tmp_moved_constant_1416 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_772 - tmp_moved_constant_1260 - tmp_moved_constant_1317;
       const real_t tmp_moved_constant_1417 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_772 - tmp_moved_constant_1263 - tmp_moved_constant_1320;
       const real_t tmp_moved_constant_1418 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_772 - tmp_moved_constant_1266 - tmp_moved_constant_1323;
       const real_t tmp_moved_constant_1419 = jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_1108;
       const real_t tmp_moved_constant_1420 = -tmp_moved_constant_1107 - tmp_moved_constant_1108 - tmp_moved_constant_1326;
       const real_t tmp_moved_constant_1421 = jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_1420 - tmp_moved_constant_1387 - tmp_moved_constant_1419;
       const real_t tmp_moved_constant_1422 = -tmp_moved_constant_1113 - tmp_moved_constant_1114 - tmp_moved_constant_1334;
       const real_t tmp_moved_constant_1423 = jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_1422 - tmp_moved_constant_1212 - tmp_moved_constant_1328;
       const real_t tmp_moved_constant_1424 = -tmp_moved_constant_1119 - tmp_moved_constant_1120 - tmp_moved_constant_1339;
       const real_t tmp_moved_constant_1425 = jac_affine_inv_1_0_GREEN_UP*tmp_moved_constant_1424 - tmp_moved_constant_1215 - tmp_moved_constant_1331;
       const real_t tmp_moved_constant_1426 = jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1420 - tmp_moved_constant_1211 - tmp_moved_constant_1329;
       const real_t tmp_moved_constant_1427 = jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1114;
       const real_t tmp_moved_constant_1428 = jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1422 - tmp_moved_constant_1396 - tmp_moved_constant_1427;
       const real_t tmp_moved_constant_1429 = jac_affine_inv_1_1_GREEN_UP*tmp_moved_constant_1424 - tmp_moved_constant_1220 - tmp_moved_constant_1336;
       const real_t tmp_moved_constant_1430 = jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1420 - tmp_moved_constant_1214 - tmp_moved_constant_1332;
       const real_t tmp_moved_constant_1431 = jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1422 - tmp_moved_constant_1219 - tmp_moved_constant_1337;
       const real_t tmp_moved_constant_1432 = jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1120;
       const real_t tmp_moved_constant_1433 = jac_affine_inv_1_2_GREEN_UP*tmp_moved_constant_1424 - tmp_moved_constant_1402 - tmp_moved_constant_1432;
       const real_t tmp_moved_constant_1434 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_793 - tmp_moved_constant_1225 - tmp_moved_constant_1341;
       const real_t tmp_moved_constant_1435 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_793 - tmp_moved_constant_1228 - tmp_moved_constant_1344;
       const real_t tmp_moved_constant_1436 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_793 - tmp_moved_constant_1231 - tmp_moved_constant_1347;
       const real_t tmp_moved_constant_1437 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_799 - tmp_moved_constant_1234 - tmp_moved_constant_1350;
       const real_t tmp_moved_constant_1438 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_799 - tmp_moved_constant_1237 - tmp_moved_constant_1353;
       const real_t tmp_moved_constant_1439 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_799 - tmp_moved_constant_1240 - tmp_moved_constant_1356;
       const real_t tmp_moved_constant_1440 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_805 - tmp_moved_constant_1243 - tmp_moved_constant_1359;
       const real_t tmp_moved_constant_1441 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_805 - tmp_moved_constant_1246 - tmp_moved_constant_1362;
       const real_t tmp_moved_constant_1442 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_805 - tmp_moved_constant_1249 - tmp_moved_constant_1365;
       const real_t tmp_moved_constant_1443 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_811 - tmp_moved_constant_1252 - tmp_moved_constant_1368;
       const real_t tmp_moved_constant_1444 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_811 - tmp_moved_constant_1255 - tmp_moved_constant_1371;
       const real_t tmp_moved_constant_1445 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_811 - tmp_moved_constant_1258 - tmp_moved_constant_1374;
       const real_t tmp_moved_constant_1446 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_817 - tmp_moved_constant_1261 - tmp_moved_constant_1377;
       const real_t tmp_moved_constant_1447 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_817 - tmp_moved_constant_1264 - tmp_moved_constant_1380;
       const real_t tmp_moved_constant_1448 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_817 - tmp_moved_constant_1267 - tmp_moved_constant_1383;
       const real_t tmp_moved_constant_1449 = jac_affine_inv_0_0_GREEN_UP*-8.0 - tmp_moved_constant_1107 - tmp_moved_constant_1109;
       const real_t tmp_moved_constant_1450 = jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_1449 - tmp_moved_constant_1386 - tmp_moved_constant_1419;
       const real_t tmp_moved_constant_1451 = jac_affine_inv_0_1_GREEN_UP*-8.0 - tmp_moved_constant_1113 - tmp_moved_constant_1115;
       const real_t tmp_moved_constant_1452 = jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_1451 - tmp_moved_constant_1271 - tmp_moved_constant_1329;
       const real_t tmp_moved_constant_1453 = jac_affine_inv_0_2_GREEN_UP*-8.0 - tmp_moved_constant_1119 - tmp_moved_constant_1121;
       const real_t tmp_moved_constant_1454 = jac_affine_inv_0_0_GREEN_UP*tmp_moved_constant_1453 - tmp_moved_constant_1274 - tmp_moved_constant_1332;
       const real_t tmp_moved_constant_1455 = jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_1449 - tmp_moved_constant_1270 - tmp_moved_constant_1328;
       const real_t tmp_moved_constant_1456 = jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_1451 - tmp_moved_constant_1395 - tmp_moved_constant_1427;
       const real_t tmp_moved_constant_1457 = jac_affine_inv_0_1_GREEN_UP*tmp_moved_constant_1453 - tmp_moved_constant_1278 - tmp_moved_constant_1337;
       const real_t tmp_moved_constant_1458 = jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1449 - tmp_moved_constant_1273 - tmp_moved_constant_1331;
       const real_t tmp_moved_constant_1459 = jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1451 - tmp_moved_constant_1277 - tmp_moved_constant_1336;
       const real_t tmp_moved_constant_1460 = jac_affine_inv_0_2_GREEN_UP*tmp_moved_constant_1453 - tmp_moved_constant_1401 - tmp_moved_constant_1432;
       const real_t tmp_moved_constant_1461 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_834 - tmp_moved_constant_1282 - tmp_moved_constant_1342;
       const real_t tmp_moved_constant_1462 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_834 - tmp_moved_constant_1285 - tmp_moved_constant_1345;
       const real_t tmp_moved_constant_1463 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_834 - tmp_moved_constant_1288 - tmp_moved_constant_1348;
       const real_t tmp_moved_constant_1464 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_839 - tmp_moved_constant_1291 - tmp_moved_constant_1351;
       const real_t tmp_moved_constant_1465 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_839 - tmp_moved_constant_1294 - tmp_moved_constant_1354;
       const real_t tmp_moved_constant_1466 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_839 - tmp_moved_constant_1297 - tmp_moved_constant_1357;
       const real_t tmp_moved_constant_1467 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_844 - tmp_moved_constant_1300 - tmp_moved_constant_1360;
       const real_t tmp_moved_constant_1468 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_844 - tmp_moved_constant_1303 - tmp_moved_constant_1363;
       const real_t tmp_moved_constant_1469 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_844 - tmp_moved_constant_1306 - tmp_moved_constant_1366;
       const real_t tmp_moved_constant_1470 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_849 - tmp_moved_constant_1309 - tmp_moved_constant_1369;
       const real_t tmp_moved_constant_1471 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_849 - tmp_moved_constant_1312 - tmp_moved_constant_1372;
       const real_t tmp_moved_constant_1472 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_849 - tmp_moved_constant_1315 - tmp_moved_constant_1375;
       const real_t tmp_moved_constant_1473 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_854 - tmp_moved_constant_1318 - tmp_moved_constant_1378;
       const real_t tmp_moved_constant_1474 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_854 - tmp_moved_constant_1321 - tmp_moved_constant_1381;
       const real_t tmp_moved_constant_1475 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_854 - tmp_moved_constant_1324 - tmp_moved_constant_1384;
       {
          /* CellType.GREEN_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
             const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
             const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
             const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
             const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
             const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
             const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
             const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
             const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
             const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
             const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
             const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
             const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
             const real_t tmp_blending_op_35 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_36 = tmp_blending_op_22 - tmp_blending_op_35;
             const real_t tmp_blending_op_37 = -tmp_blending_op_36;
             const real_t tmp_blending_op_38 = (tmp_blending_op_28*tmp_blending_op_28);
             const real_t tmp_blending_op_39 = (tmp_blending_op_33*tmp_blending_op_33);
             const real_t tmp_blending_op_40 = tmp_blending_op_38 + tmp_blending_op_39 + tmp_blending_op_4;
             const real_t tmp_blending_op_43 = tmp_blending_op_3*tmp_blending_op_42;
             const real_t tmp_blending_op_44 = tmp_blending_op_36 + tmp_blending_op_43;
             const real_t tmp_blending_op_45 = tmp_blending_op_37*tmp_blending_op_4 + tmp_blending_op_40*tmp_blending_op_44;
             const real_t tmp_blending_op_46 = pow(tmp_blending_op_40, -1.5000000000000000);
             const real_t tmp_blending_op_49 = tmp_blending_op_46*tmp_blending_op_48;
             const real_t tmp_blending_op_52 = tmp_blending_op_40*tmp_blending_op_51;
             const real_t tmp_blending_op_53 = -tmp_blending_op_33*tmp_blending_op_36 - tmp_blending_op_52;
             const real_t tmp_blending_op_54 = tmp_blending_op_49*tmp_blending_op_53;
             const real_t tmp_blending_op_57 = tmp_blending_op_28*tmp_blending_op_37 + tmp_blending_op_40*tmp_blending_op_56;
             const real_t tmp_blending_op_58 = tmp_blending_op_49*tmp_blending_op_57;
             const real_t tmp_blending_op_59 = tmp_blending_op_3*tmp_blending_op_37;
             const real_t tmp_blending_op_60 = tmp_blending_op_40*tmp_blending_op_42 + tmp_blending_op_59;
             const real_t tmp_blending_op_61 = tmp_blending_op_49*tmp_blending_op_60;
             const real_t tmp_blending_op_63 = tmp_blending_op_33*tmp_blending_op_62 + tmp_blending_op_36;
             const real_t tmp_blending_op_64 = tmp_blending_op_37*tmp_blending_op_39 + tmp_blending_op_40*tmp_blending_op_63;
             const real_t tmp_blending_op_65 = tmp_blending_op_28*tmp_blending_op_56;
             const real_t tmp_blending_op_66 = tmp_blending_op_36 + tmp_blending_op_65;
             const real_t tmp_blending_op_67 = -tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_40*tmp_blending_op_66;
             const real_t tmp_blending_op_75 = p_affine_0_2 + tmp_blending_op_0*0.5 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_76 = (tmp_blending_op_75*tmp_blending_op_75);
             const real_t tmp_blending_op_77 = -tmp_blending_op_17 - tmp_blending_op_75;
             const real_t tmp_blending_op_78 = p_affine_0_0 + tmp_blending_op_25*0.5 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_79 = -tmp_blending_op_6 - tmp_blending_op_78;
             const real_t tmp_blending_op_80 = p_affine_0_1 + tmp_blending_op_30*0.5 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_81 = -tmp_blending_op_13 - tmp_blending_op_80;
             const real_t tmp_blending_op_82 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_79 - tmp_blending_op_12*tmp_blending_op_77 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_77 - tmp_blending_op_19*tmp_blending_op_79 - tmp_blending_op_20*tmp_blending_op_81 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_81);
             const real_t tmp_blending_op_83 = tmp_blending_op_22 - tmp_blending_op_82;
             const real_t tmp_blending_op_84 = -tmp_blending_op_83;
             const real_t tmp_blending_op_85 = (tmp_blending_op_78*tmp_blending_op_78);
             const real_t tmp_blending_op_86 = (tmp_blending_op_80*tmp_blending_op_80);
             const real_t tmp_blending_op_87 = tmp_blending_op_76 + tmp_blending_op_85 + tmp_blending_op_86;
             const real_t tmp_blending_op_88 = tmp_blending_op_42*tmp_blending_op_75;
             const real_t tmp_blending_op_89 = tmp_blending_op_83 + tmp_blending_op_88;
             const real_t tmp_blending_op_90 = tmp_blending_op_76*tmp_blending_op_84 + tmp_blending_op_87*tmp_blending_op_89;
             const real_t tmp_blending_op_91 = pow(tmp_blending_op_87, -1.5000000000000000);
             const real_t tmp_blending_op_92 = tmp_blending_op_48*tmp_blending_op_91;
             const real_t tmp_blending_op_93 = tmp_blending_op_51*tmp_blending_op_87;
             const real_t tmp_blending_op_94 = -tmp_blending_op_80*tmp_blending_op_83 - tmp_blending_op_93;
             const real_t tmp_blending_op_95 = tmp_blending_op_92*tmp_blending_op_94;
             const real_t tmp_blending_op_96 = tmp_blending_op_56*tmp_blending_op_87 + tmp_blending_op_78*tmp_blending_op_84;
             const real_t tmp_blending_op_97 = tmp_blending_op_92*tmp_blending_op_96;
             const real_t tmp_blending_op_98 = tmp_blending_op_75*tmp_blending_op_84;
             const real_t tmp_blending_op_99 = tmp_blending_op_42*tmp_blending_op_87 + tmp_blending_op_98;
             const real_t tmp_blending_op_100 = tmp_blending_op_92*tmp_blending_op_99;
             const real_t tmp_blending_op_101 = tmp_blending_op_62*tmp_blending_op_80 + tmp_blending_op_83;
             const real_t tmp_blending_op_102 = tmp_blending_op_101*tmp_blending_op_87 + tmp_blending_op_84*tmp_blending_op_86;
             const real_t tmp_blending_op_103 = tmp_blending_op_56*tmp_blending_op_78;
             const real_t tmp_blending_op_104 = tmp_blending_op_103 + tmp_blending_op_83;
             const real_t tmp_blending_op_105 = tmp_blending_op_104*tmp_blending_op_87 - tmp_blending_op_83*tmp_blending_op_85;
             const real_t tmp_blending_op_113 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.5 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_114 = (tmp_blending_op_113*tmp_blending_op_113);
             const real_t tmp_blending_op_115 = -tmp_blending_op_113 - tmp_blending_op_17;
             const real_t tmp_blending_op_116 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.5 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_117 = -tmp_blending_op_116 - tmp_blending_op_6;
             const real_t tmp_blending_op_118 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.5 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_119 = -tmp_blending_op_118 - tmp_blending_op_13;
             const real_t tmp_blending_op_120 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_117*tmp_blending_op_18 - tmp_blending_op_115*tmp_blending_op_12 + tmp_blending_op_115*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_117*tmp_blending_op_19 - tmp_blending_op_119*tmp_blending_op_20 + tmp_blending_op_119*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_121 = -tmp_blending_op_120 + tmp_blending_op_22;
             const real_t tmp_blending_op_122 = -tmp_blending_op_121;
             const real_t tmp_blending_op_123 = (tmp_blending_op_116*tmp_blending_op_116);
             const real_t tmp_blending_op_124 = (tmp_blending_op_118*tmp_blending_op_118);
             const real_t tmp_blending_op_125 = tmp_blending_op_114 + tmp_blending_op_123 + tmp_blending_op_124;
             const real_t tmp_blending_op_126 = tmp_blending_op_113*tmp_blending_op_42;
             const real_t tmp_blending_op_127 = tmp_blending_op_121 + tmp_blending_op_126;
             const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_127;
             const real_t tmp_blending_op_129 = pow(tmp_blending_op_125, -1.5000000000000000);
             const real_t tmp_blending_op_130 = tmp_blending_op_129*tmp_blending_op_48;
             const real_t tmp_blending_op_131 = tmp_blending_op_125*tmp_blending_op_51;
             const real_t tmp_blending_op_132 = -tmp_blending_op_118*tmp_blending_op_121 - tmp_blending_op_131;
             const real_t tmp_blending_op_133 = tmp_blending_op_130*tmp_blending_op_132;
             const real_t tmp_blending_op_134 = tmp_blending_op_116*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_56;
             const real_t tmp_blending_op_135 = tmp_blending_op_130*tmp_blending_op_134;
             const real_t tmp_blending_op_136 = tmp_blending_op_113*tmp_blending_op_122;
             const real_t tmp_blending_op_137 = tmp_blending_op_125*tmp_blending_op_42 + tmp_blending_op_136;
             const real_t tmp_blending_op_138 = tmp_blending_op_130*tmp_blending_op_137;
             const real_t tmp_blending_op_139 = tmp_blending_op_118*tmp_blending_op_62 + tmp_blending_op_121;
             const real_t tmp_blending_op_140 = tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*tmp_blending_op_139;
             const real_t tmp_blending_op_141 = tmp_blending_op_116*tmp_blending_op_56;
             const real_t tmp_blending_op_142 = tmp_blending_op_121 + tmp_blending_op_141;
             const real_t tmp_blending_op_143 = -tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*tmp_blending_op_142;
             const real_t tmp_blending_op_151 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.5;
             const real_t tmp_blending_op_152 = (tmp_blending_op_151*tmp_blending_op_151);
             const real_t tmp_blending_op_153 = -tmp_blending_op_151 - tmp_blending_op_17;
             const real_t tmp_blending_op_154 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.5;
             const real_t tmp_blending_op_155 = -tmp_blending_op_154 - tmp_blending_op_6;
             const real_t tmp_blending_op_156 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.5;
             const real_t tmp_blending_op_157 = -tmp_blending_op_13 - tmp_blending_op_156;
             const real_t tmp_blending_op_158 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_155*tmp_blending_op_18 - tmp_blending_op_12*tmp_blending_op_153 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_153 - tmp_blending_op_155*tmp_blending_op_19 - tmp_blending_op_157*tmp_blending_op_20 + tmp_blending_op_157*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_159 = -tmp_blending_op_158 + tmp_blending_op_22;
             const real_t tmp_blending_op_160 = -tmp_blending_op_159;
             const real_t tmp_blending_op_161 = (tmp_blending_op_154*tmp_blending_op_154);
             const real_t tmp_blending_op_162 = (tmp_blending_op_156*tmp_blending_op_156);
             const real_t tmp_blending_op_163 = tmp_blending_op_152 + tmp_blending_op_161 + tmp_blending_op_162;
             const real_t tmp_blending_op_164 = tmp_blending_op_151*tmp_blending_op_42;
             const real_t tmp_blending_op_165 = tmp_blending_op_159 + tmp_blending_op_164;
             const real_t tmp_blending_op_166 = tmp_blending_op_152*tmp_blending_op_160 + tmp_blending_op_163*tmp_blending_op_165;
             const real_t tmp_blending_op_167 = pow(tmp_blending_op_163, -1.5000000000000000);
             const real_t tmp_blending_op_168 = tmp_blending_op_167*tmp_blending_op_48;
             const real_t tmp_blending_op_169 = tmp_blending_op_163*tmp_blending_op_51;
             const real_t tmp_blending_op_170 = -tmp_blending_op_156*tmp_blending_op_159 - tmp_blending_op_169;
             const real_t tmp_blending_op_171 = tmp_blending_op_168*tmp_blending_op_170;
             const real_t tmp_blending_op_172 = tmp_blending_op_154*tmp_blending_op_160 + tmp_blending_op_163*tmp_blending_op_56;
             const real_t tmp_blending_op_173 = tmp_blending_op_168*tmp_blending_op_172;
             const real_t tmp_blending_op_174 = tmp_blending_op_151*tmp_blending_op_160;
             const real_t tmp_blending_op_175 = tmp_blending_op_163*tmp_blending_op_42 + tmp_blending_op_174;
             const real_t tmp_blending_op_176 = tmp_blending_op_168*tmp_blending_op_175;
             const real_t tmp_blending_op_177 = tmp_blending_op_156*tmp_blending_op_62 + tmp_blending_op_159;
             const real_t tmp_blending_op_178 = tmp_blending_op_160*tmp_blending_op_162 + tmp_blending_op_163*tmp_blending_op_177;
             const real_t tmp_blending_op_179 = tmp_blending_op_154*tmp_blending_op_56;
             const real_t tmp_blending_op_180 = tmp_blending_op_159 + tmp_blending_op_179;
             const real_t tmp_blending_op_181 = -tmp_blending_op_159*tmp_blending_op_161 + tmp_blending_op_163*tmp_blending_op_180;
             const real_t tmp_blending_op_189 = p_affine_0_2 + tmp_blending_op_0*0.25 + tmp_blending_op_1*0.25 + tmp_blending_op_2*0.25;
             const real_t tmp_blending_op_190 = (tmp_blending_op_189*tmp_blending_op_189);
             const real_t tmp_blending_op_191 = -tmp_blending_op_17 - tmp_blending_op_189;
             const real_t tmp_blending_op_192 = p_affine_0_0 + tmp_blending_op_25*0.25 + tmp_blending_op_26*0.25 + tmp_blending_op_27*0.25;
             const real_t tmp_blending_op_193 = -tmp_blending_op_192 - tmp_blending_op_6;
             const real_t tmp_blending_op_194 = p_affine_0_1 + tmp_blending_op_30*0.25 + tmp_blending_op_31*0.25 + tmp_blending_op_32*0.25;
             const real_t tmp_blending_op_195 = -tmp_blending_op_13 - tmp_blending_op_194;
             const real_t tmp_blending_op_196 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_193 - tmp_blending_op_12*tmp_blending_op_191 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_191 - tmp_blending_op_19*tmp_blending_op_193 - tmp_blending_op_195*tmp_blending_op_20 + tmp_blending_op_195*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_197 = -tmp_blending_op_196 + tmp_blending_op_22;
             const real_t tmp_blending_op_198 = -tmp_blending_op_197;
             const real_t tmp_blending_op_199 = (tmp_blending_op_192*tmp_blending_op_192);
             const real_t tmp_blending_op_200 = (tmp_blending_op_194*tmp_blending_op_194);
             const real_t tmp_blending_op_201 = tmp_blending_op_190 + tmp_blending_op_199 + tmp_blending_op_200;
             const real_t tmp_blending_op_202 = tmp_blending_op_189*tmp_blending_op_42;
             const real_t tmp_blending_op_203 = tmp_blending_op_197 + tmp_blending_op_202;
             const real_t tmp_blending_op_204 = tmp_blending_op_190*tmp_blending_op_198 + tmp_blending_op_201*tmp_blending_op_203;
             const real_t tmp_blending_op_205 = pow(tmp_blending_op_201, -1.5000000000000000);
             const real_t tmp_blending_op_206 = tmp_blending_op_205*tmp_blending_op_48;
             const real_t tmp_blending_op_207 = tmp_blending_op_201*tmp_blending_op_51;
             const real_t tmp_blending_op_208 = -tmp_blending_op_194*tmp_blending_op_197 - tmp_blending_op_207;
             const real_t tmp_blending_op_209 = tmp_blending_op_206*tmp_blending_op_208;
             const real_t tmp_blending_op_210 = tmp_blending_op_192*tmp_blending_op_198 + tmp_blending_op_201*tmp_blending_op_56;
             const real_t tmp_blending_op_211 = tmp_blending_op_206*tmp_blending_op_210;
             const real_t tmp_blending_op_212 = tmp_blending_op_189*tmp_blending_op_198;
             const real_t tmp_blending_op_213 = tmp_blending_op_201*tmp_blending_op_42 + tmp_blending_op_212;
             const real_t tmp_blending_op_214 = tmp_blending_op_206*tmp_blending_op_213;
             const real_t tmp_blending_op_215 = tmp_blending_op_194*tmp_blending_op_62 + tmp_blending_op_197;
             const real_t tmp_blending_op_216 = tmp_blending_op_198*tmp_blending_op_200 + tmp_blending_op_201*tmp_blending_op_215;
             const real_t tmp_blending_op_217 = tmp_blending_op_192*tmp_blending_op_56;
             const real_t tmp_blending_op_218 = tmp_blending_op_197 + tmp_blending_op_217;
             const real_t tmp_blending_op_219 = -tmp_blending_op_197*tmp_blending_op_199 + tmp_blending_op_201*tmp_blending_op_218;
             const real_t tmp_blending_op_228 = pow(tmp_blending_op_201, -2.5000000000000000)*tmp_blending_op_227;
             const real_t tmp_blending_op_229 = tmp_blending_op_192*tmp_blending_op_228;
             const real_t tmp_blending_op_232 = tmp_blending_op_192*2.0;
             const real_t tmp_blending_op_234 = tmp_blending_op_196 + tmp_blending_op_233;
             const real_t tmp_blending_op_235 = tmp_blending_op_192*tmp_blending_op_230 + tmp_blending_op_217*2.0 + tmp_blending_op_234;
             const real_t tmp_blending_op_236 = tmp_blending_op_210*tmp_blending_op_229;
             const real_t tmp_blending_op_237 = tmp_blending_op_194*tmp_blending_op_23*tmp_blending_op_55 - tmp_blending_op_232*tmp_blending_op_51;
             const real_t tmp_blending_op_238 = tmp_blending_op_199*tmp_blending_op_228;
             const real_t tmp_blending_op_239 = -tmp_blending_op_201*tmp_blending_op_230;
             const real_t tmp_blending_op_240 = tmp_blending_op_208*tmp_blending_op_229;
             const real_t tmp_blending_op_241 = tmp_blending_op_189*tmp_blending_op_240;
             const real_t tmp_blending_op_242 = tmp_blending_op_189*tmp_blending_op_230 + tmp_blending_op_232*tmp_blending_op_42;
             const real_t tmp_blending_op_243 = tmp_blending_op_213*tmp_blending_op_229;
             const real_t tmp_blending_op_244 = tmp_blending_op_194*tmp_blending_op_243;
             const real_t tmp_blending_op_245 = -tmp_blending_op_207;
             const real_t tmp_blending_op_246 = tmp_blending_op_194*2.0;
             const real_t tmp_blending_op_247 = tmp_blending_op_194*tmp_blending_op_228;
             const real_t tmp_blending_op_248 = tmp_blending_op_206*(tmp_blending_op_192*tmp_blending_op_51 + tmp_blending_op_246*tmp_blending_op_56);
             const real_t tmp_blending_op_249 = tmp_blending_op_200*tmp_blending_op_228;
             const real_t tmp_blending_op_250 = tmp_blending_op_189*tmp_blending_op_247;
             const real_t tmp_blending_op_251 = -tmp_blending_op_210*tmp_blending_op_250;
             const real_t tmp_blending_op_252 = -tmp_blending_op_194*tmp_blending_op_51 - tmp_blending_op_197;
             const real_t tmp_blending_op_254 = tmp_blending_op_189*tmp_blending_op_51;
             const real_t tmp_blending_op_255 = tmp_blending_op_246*tmp_blending_op_42 + tmp_blending_op_254;
             const real_t tmp_blending_op_257 = -tmp_blending_op_201*tmp_blending_op_256;
             const real_t tmp_blending_op_258 = tmp_blending_op_189*2.0;
             const real_t tmp_blending_op_259 = tmp_blending_op_189*tmp_blending_op_228;
             const real_t tmp_blending_op_260 = tmp_blending_op_206*(tmp_blending_op_192*tmp_blending_op_256 + tmp_blending_op_258*tmp_blending_op_56);
             const real_t tmp_blending_op_261 = tmp_blending_op_190*tmp_blending_op_228;
             const real_t tmp_blending_op_262 = tmp_blending_op_206*(tmp_blending_op_194*tmp_blending_op_256 + tmp_blending_op_254*-2.0);
             const real_t tmp_blending_op_263 = tmp_blending_op_189*tmp_blending_op_256 + tmp_blending_op_202*2.0 + tmp_blending_op_234;
             const real_t tmp_blending_op_265 = pow(tmp_blending_op_163, -2.5000000000000000)*tmp_blending_op_227;
             const real_t tmp_blending_op_266 = tmp_blending_op_154*tmp_blending_op_265;
             const real_t tmp_blending_op_267 = tmp_blending_op_154*2.0;
             const real_t tmp_blending_op_268 = tmp_blending_op_158 + tmp_blending_op_233;
             const real_t tmp_blending_op_269 = tmp_blending_op_154*tmp_blending_op_230 + tmp_blending_op_179*2.0 + tmp_blending_op_268;
             const real_t tmp_blending_op_270 = tmp_blending_op_172*tmp_blending_op_266;
             const real_t tmp_blending_op_271 = tmp_blending_op_156*tmp_blending_op_23*tmp_blending_op_55 - tmp_blending_op_267*tmp_blending_op_51;
             const real_t tmp_blending_op_272 = tmp_blending_op_161*tmp_blending_op_265;
             const real_t tmp_blending_op_273 = -tmp_blending_op_163*tmp_blending_op_230;
             const real_t tmp_blending_op_274 = tmp_blending_op_170*tmp_blending_op_266;
             const real_t tmp_blending_op_275 = tmp_blending_op_151*tmp_blending_op_274;
             const real_t tmp_blending_op_276 = tmp_blending_op_151*tmp_blending_op_230 + tmp_blending_op_267*tmp_blending_op_42;
             const real_t tmp_blending_op_277 = tmp_blending_op_175*tmp_blending_op_266;
             const real_t tmp_blending_op_278 = tmp_blending_op_156*tmp_blending_op_277;
             const real_t tmp_blending_op_279 = -tmp_blending_op_169;
             const real_t tmp_blending_op_280 = tmp_blending_op_156*2.0;
             const real_t tmp_blending_op_281 = tmp_blending_op_156*tmp_blending_op_265;
             const real_t tmp_blending_op_282 = tmp_blending_op_168*(tmp_blending_op_154*tmp_blending_op_51 + tmp_blending_op_280*tmp_blending_op_56);
             const real_t tmp_blending_op_283 = tmp_blending_op_162*tmp_blending_op_265;
             const real_t tmp_blending_op_284 = tmp_blending_op_151*tmp_blending_op_281;
             const real_t tmp_blending_op_285 = -tmp_blending_op_172*tmp_blending_op_284;
             const real_t tmp_blending_op_286 = -tmp_blending_op_156*tmp_blending_op_51 - tmp_blending_op_159;
             const real_t tmp_blending_op_287 = tmp_blending_op_151*tmp_blending_op_51;
             const real_t tmp_blending_op_288 = tmp_blending_op_280*tmp_blending_op_42 + tmp_blending_op_287;
             const real_t tmp_blending_op_289 = -tmp_blending_op_163*tmp_blending_op_256;
             const real_t tmp_blending_op_290 = tmp_blending_op_151*2.0;
             const real_t tmp_blending_op_291 = tmp_blending_op_151*tmp_blending_op_265;
             const real_t tmp_blending_op_292 = tmp_blending_op_168*(tmp_blending_op_154*tmp_blending_op_256 + tmp_blending_op_290*tmp_blending_op_56);
             const real_t tmp_blending_op_293 = tmp_blending_op_152*tmp_blending_op_265;
             const real_t tmp_blending_op_294 = tmp_blending_op_168*(tmp_blending_op_156*tmp_blending_op_256 + tmp_blending_op_287*-2.0);
             const real_t tmp_blending_op_295 = tmp_blending_op_151*tmp_blending_op_256 + tmp_blending_op_164*2.0 + tmp_blending_op_268;
             const real_t tmp_blending_op_296 = pow(tmp_blending_op_125, -2.5000000000000000)*tmp_blending_op_227;
             const real_t tmp_blending_op_297 = tmp_blending_op_116*tmp_blending_op_296;
             const real_t tmp_blending_op_298 = tmp_blending_op_116*2.0;
             const real_t tmp_blending_op_299 = tmp_blending_op_120 + tmp_blending_op_233;
             const real_t tmp_blending_op_300 = tmp_blending_op_116*tmp_blending_op_230 + tmp_blending_op_141*2.0 + tmp_blending_op_299;
             const real_t tmp_blending_op_301 = tmp_blending_op_134*tmp_blending_op_297;
             const real_t tmp_blending_op_302 = tmp_blending_op_118*tmp_blending_op_23*tmp_blending_op_55 - tmp_blending_op_298*tmp_blending_op_51;
             const real_t tmp_blending_op_303 = tmp_blending_op_123*tmp_blending_op_296;
             const real_t tmp_blending_op_304 = -tmp_blending_op_125*tmp_blending_op_230;
             const real_t tmp_blending_op_305 = tmp_blending_op_132*tmp_blending_op_297;
             const real_t tmp_blending_op_306 = tmp_blending_op_113*tmp_blending_op_305;
             const real_t tmp_blending_op_307 = tmp_blending_op_113*tmp_blending_op_230 + tmp_blending_op_298*tmp_blending_op_42;
             const real_t tmp_blending_op_308 = tmp_blending_op_137*tmp_blending_op_297;
             const real_t tmp_blending_op_309 = tmp_blending_op_118*tmp_blending_op_308;
             const real_t tmp_blending_op_310 = -tmp_blending_op_131;
             const real_t tmp_blending_op_311 = tmp_blending_op_118*2.0;
             const real_t tmp_blending_op_312 = tmp_blending_op_118*tmp_blending_op_296;
             const real_t tmp_blending_op_313 = tmp_blending_op_130*(tmp_blending_op_116*tmp_blending_op_51 + tmp_blending_op_311*tmp_blending_op_56);
             const real_t tmp_blending_op_314 = tmp_blending_op_124*tmp_blending_op_296;
             const real_t tmp_blending_op_315 = tmp_blending_op_113*tmp_blending_op_312;
             const real_t tmp_blending_op_316 = -tmp_blending_op_134*tmp_blending_op_315;
             const real_t tmp_blending_op_317 = -tmp_blending_op_118*tmp_blending_op_51 - tmp_blending_op_121;
             const real_t tmp_blending_op_318 = tmp_blending_op_113*tmp_blending_op_51;
             const real_t tmp_blending_op_319 = tmp_blending_op_311*tmp_blending_op_42 + tmp_blending_op_318;
             const real_t tmp_blending_op_320 = -tmp_blending_op_125*tmp_blending_op_256;
             const real_t tmp_blending_op_321 = tmp_blending_op_113*2.0;
             const real_t tmp_blending_op_322 = tmp_blending_op_113*tmp_blending_op_296;
             const real_t tmp_blending_op_323 = tmp_blending_op_130*(tmp_blending_op_116*tmp_blending_op_256 + tmp_blending_op_321*tmp_blending_op_56);
             const real_t tmp_blending_op_324 = tmp_blending_op_114*tmp_blending_op_296;
             const real_t tmp_blending_op_325 = tmp_blending_op_130*(tmp_blending_op_118*tmp_blending_op_256 + tmp_blending_op_318*-2.0);
             const real_t tmp_blending_op_326 = tmp_blending_op_113*tmp_blending_op_256 + tmp_blending_op_126*2.0 + tmp_blending_op_299;
             const real_t tmp_blending_op_327 = tmp_blending_op_227*pow(tmp_blending_op_87, -2.5000000000000000);
             const real_t tmp_blending_op_328 = tmp_blending_op_327*tmp_blending_op_78;
             const real_t tmp_blending_op_329 = tmp_blending_op_78*2.0;
             const real_t tmp_blending_op_330 = tmp_blending_op_233 + tmp_blending_op_82;
             const real_t tmp_blending_op_331 = tmp_blending_op_103*2.0 + tmp_blending_op_230*tmp_blending_op_78 + tmp_blending_op_330;
             const real_t tmp_blending_op_332 = tmp_blending_op_328*tmp_blending_op_96;
             const real_t tmp_blending_op_333 = tmp_blending_op_23*tmp_blending_op_55*tmp_blending_op_80 - tmp_blending_op_329*tmp_blending_op_51;
             const real_t tmp_blending_op_334 = tmp_blending_op_327*tmp_blending_op_85;
             const real_t tmp_blending_op_335 = -tmp_blending_op_230*tmp_blending_op_87;
             const real_t tmp_blending_op_336 = tmp_blending_op_328*tmp_blending_op_94;
             const real_t tmp_blending_op_337 = tmp_blending_op_336*tmp_blending_op_75;
             const real_t tmp_blending_op_338 = tmp_blending_op_230*tmp_blending_op_75 + tmp_blending_op_329*tmp_blending_op_42;
             const real_t tmp_blending_op_339 = tmp_blending_op_328*tmp_blending_op_99;
             const real_t tmp_blending_op_340 = tmp_blending_op_339*tmp_blending_op_80;
             const real_t tmp_blending_op_341 = -tmp_blending_op_93;
             const real_t tmp_blending_op_342 = tmp_blending_op_80*2.0;
             const real_t tmp_blending_op_343 = tmp_blending_op_327*tmp_blending_op_80;
             const real_t tmp_blending_op_344 = tmp_blending_op_92*(tmp_blending_op_342*tmp_blending_op_56 + tmp_blending_op_51*tmp_blending_op_78);
             const real_t tmp_blending_op_345 = tmp_blending_op_327*tmp_blending_op_86;
             const real_t tmp_blending_op_346 = tmp_blending_op_343*tmp_blending_op_75;
             const real_t tmp_blending_op_347 = -tmp_blending_op_346*tmp_blending_op_96;
             const real_t tmp_blending_op_348 = -tmp_blending_op_51*tmp_blending_op_80 - tmp_blending_op_83;
             const real_t tmp_blending_op_349 = tmp_blending_op_51*tmp_blending_op_75;
             const real_t tmp_blending_op_350 = tmp_blending_op_342*tmp_blending_op_42 + tmp_blending_op_349;
             const real_t tmp_blending_op_351 = -tmp_blending_op_256*tmp_blending_op_87;
             const real_t tmp_blending_op_352 = tmp_blending_op_75*2.0;
             const real_t tmp_blending_op_353 = tmp_blending_op_327*tmp_blending_op_75;
             const real_t tmp_blending_op_354 = tmp_blending_op_92*(tmp_blending_op_256*tmp_blending_op_78 + tmp_blending_op_352*tmp_blending_op_56);
             const real_t tmp_blending_op_355 = tmp_blending_op_327*tmp_blending_op_76;
             const real_t tmp_blending_op_356 = tmp_blending_op_92*(tmp_blending_op_256*tmp_blending_op_80 + tmp_blending_op_349*-2.0);
             const real_t tmp_blending_op_357 = tmp_blending_op_256*tmp_blending_op_75 + tmp_blending_op_330 + tmp_blending_op_88*2.0;
             const real_t tmp_blending_op_358 = tmp_blending_op_227*pow(tmp_blending_op_40, -2.5000000000000000);
             const real_t tmp_blending_op_359 = tmp_blending_op_28*tmp_blending_op_358;
             const real_t tmp_blending_op_360 = tmp_blending_op_28*2.0;
             const real_t tmp_blending_op_361 = tmp_blending_op_233 + tmp_blending_op_35;
             const real_t tmp_blending_op_362 = tmp_blending_op_230*tmp_blending_op_28 + tmp_blending_op_361 + tmp_blending_op_65*2.0;
             const real_t tmp_blending_op_363 = tmp_blending_op_359*tmp_blending_op_57;
             const real_t tmp_blending_op_364 = tmp_blending_op_23*tmp_blending_op_33*tmp_blending_op_55 - tmp_blending_op_360*tmp_blending_op_51;
             const real_t tmp_blending_op_365 = tmp_blending_op_358*tmp_blending_op_38;
             const real_t tmp_blending_op_366 = -tmp_blending_op_230*tmp_blending_op_40;
             const real_t tmp_blending_op_367 = tmp_blending_op_359*tmp_blending_op_53;
             const real_t tmp_blending_op_368 = tmp_blending_op_3*tmp_blending_op_367;
             const real_t tmp_blending_op_369 = tmp_blending_op_230*tmp_blending_op_3 + tmp_blending_op_360*tmp_blending_op_42;
             const real_t tmp_blending_op_370 = tmp_blending_op_359*tmp_blending_op_60;
             const real_t tmp_blending_op_371 = tmp_blending_op_33*tmp_blending_op_370;
             const real_t tmp_blending_op_372 = -tmp_blending_op_52;
             const real_t tmp_blending_op_373 = tmp_blending_op_33*2.0;
             const real_t tmp_blending_op_374 = tmp_blending_op_33*tmp_blending_op_358;
             const real_t tmp_blending_op_375 = tmp_blending_op_49*(tmp_blending_op_28*tmp_blending_op_51 + tmp_blending_op_373*tmp_blending_op_56);
             const real_t tmp_blending_op_376 = tmp_blending_op_358*tmp_blending_op_39;
             const real_t tmp_blending_op_377 = tmp_blending_op_3*tmp_blending_op_374;
             const real_t tmp_blending_op_378 = -tmp_blending_op_377*tmp_blending_op_57;
             const real_t tmp_blending_op_379 = -tmp_blending_op_33*tmp_blending_op_51 - tmp_blending_op_36;
             const real_t tmp_blending_op_380 = tmp_blending_op_3*tmp_blending_op_51;
             const real_t tmp_blending_op_381 = tmp_blending_op_373*tmp_blending_op_42 + tmp_blending_op_380;
             const real_t tmp_blending_op_382 = -tmp_blending_op_256*tmp_blending_op_40;
             const real_t tmp_blending_op_383 = tmp_blending_op_3*2.0;
             const real_t tmp_blending_op_384 = tmp_blending_op_3*tmp_blending_op_358;
             const real_t tmp_blending_op_385 = tmp_blending_op_49*(tmp_blending_op_256*tmp_blending_op_28 + tmp_blending_op_383*tmp_blending_op_56);
             const real_t tmp_blending_op_386 = tmp_blending_op_358*tmp_blending_op_4;
             const real_t tmp_blending_op_387 = tmp_blending_op_49*(tmp_blending_op_256*tmp_blending_op_33 + tmp_blending_op_380*-2.0);
             const real_t tmp_blending_op_388 = tmp_blending_op_256*tmp_blending_op_3 + tmp_blending_op_361 + tmp_blending_op_43*2.0;
             const real_t jac_blending_2_2_q_4 = tmp_blending_op_45*tmp_blending_op_49;
             const real_t jac_blending_2_1_q_4 = tmp_blending_op_3*tmp_blending_op_54;
             const real_t jac_blending_2_0_q_4 = tmp_blending_op_3*tmp_blending_op_58;
             const real_t jac_blending_1_2_q_4 = tmp_blending_op_33*tmp_blending_op_61;
             const real_t jac_blending_1_1_q_4 = tmp_blending_op_49*tmp_blending_op_64;
             const real_t tmp_blending_op_72 = jac_blending_1_1_q_4*jac_blending_2_0_q_4;
             const real_t jac_blending_1_0_q_4 = tmp_blending_op_33*tmp_blending_op_58;
             const real_t tmp_blending_op_69 = jac_blending_1_0_q_4*jac_blending_2_1_q_4;
             const real_t jac_blending_0_2_q_4 = tmp_blending_op_28*tmp_blending_op_61;
             const real_t jac_blending_0_1_q_4 = tmp_blending_op_28*tmp_blending_op_54;
             const real_t tmp_blending_op_71 = jac_blending_0_1_q_4*jac_blending_1_0_q_4;
             const real_t jac_blending_0_0_q_4 = tmp_blending_op_49*tmp_blending_op_67;
             const real_t tmp_blending_op_68 = jac_blending_0_0_q_4*jac_blending_1_1_q_4;
             const real_t tmp_blending_op_70 = jac_blending_0_0_q_4*jac_blending_2_1_q_4;
             const real_t tmp_blending_op_73 = jac_blending_0_1_q_4*jac_blending_1_2_q_4*jac_blending_2_0_q_4 + jac_blending_0_2_q_4*tmp_blending_op_69 - jac_blending_0_2_q_4*tmp_blending_op_72 - jac_blending_1_2_q_4*tmp_blending_op_70 + jac_blending_2_2_q_4*tmp_blending_op_68 - jac_blending_2_2_q_4*tmp_blending_op_71;
             const real_t tmp_blending_op_74 = 1.0 / (tmp_blending_op_73);
             const real_t abs_det_jac_blending_q_4 = tmp_blending_op_73;
             const real_t jac_blending_inv_2_2_q_4 = tmp_blending_op_74*(tmp_blending_op_68 - tmp_blending_op_71);
             const real_t jac_blending_inv_2_1_q_4 = tmp_blending_op_74*(jac_blending_0_1_q_4*jac_blending_2_0_q_4 - tmp_blending_op_70);
             const real_t jac_blending_inv_2_0_q_4 = tmp_blending_op_74*(tmp_blending_op_69 - tmp_blending_op_72);
             const real_t jac_blending_inv_1_2_q_4 = tmp_blending_op_74*(-jac_blending_0_0_q_4*jac_blending_1_2_q_4 + jac_blending_0_2_q_4*jac_blending_1_0_q_4);
             const real_t jac_blending_inv_1_1_q_4 = tmp_blending_op_74*(jac_blending_0_0_q_4*jac_blending_2_2_q_4 - jac_blending_0_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_1_0_q_4 = tmp_blending_op_74*(-jac_blending_1_0_q_4*jac_blending_2_2_q_4 + jac_blending_1_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_0_2_q_4 = tmp_blending_op_74*(jac_blending_0_1_q_4*jac_blending_1_2_q_4 - jac_blending_0_2_q_4*jac_blending_1_1_q_4);
             const real_t jac_blending_inv_0_1_q_4 = tmp_blending_op_74*(-jac_blending_0_1_q_4*jac_blending_2_2_q_4 + jac_blending_0_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_inv_0_0_q_4 = tmp_blending_op_74*(jac_blending_1_1_q_4*jac_blending_2_2_q_4 - jac_blending_1_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_2_2_q_3 = tmp_blending_op_90*tmp_blending_op_92;
             const real_t jac_blending_2_1_q_3 = tmp_blending_op_75*tmp_blending_op_95;
             const real_t jac_blending_2_0_q_3 = tmp_blending_op_75*tmp_blending_op_97;
             const real_t jac_blending_1_2_q_3 = tmp_blending_op_100*tmp_blending_op_80;
             const real_t jac_blending_1_1_q_3 = tmp_blending_op_102*tmp_blending_op_92;
             const real_t tmp_blending_op_110 = jac_blending_1_1_q_3*jac_blending_2_0_q_3;
             const real_t jac_blending_1_0_q_3 = tmp_blending_op_80*tmp_blending_op_97;
             const real_t tmp_blending_op_107 = jac_blending_1_0_q_3*jac_blending_2_1_q_3;
             const real_t jac_blending_0_2_q_3 = tmp_blending_op_100*tmp_blending_op_78;
             const real_t jac_blending_0_1_q_3 = tmp_blending_op_78*tmp_blending_op_95;
             const real_t tmp_blending_op_109 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
             const real_t jac_blending_0_0_q_3 = tmp_blending_op_105*tmp_blending_op_92;
             const real_t tmp_blending_op_106 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
             const real_t tmp_blending_op_108 = jac_blending_0_0_q_3*jac_blending_2_1_q_3;
             const real_t tmp_blending_op_111 = jac_blending_0_1_q_3*jac_blending_1_2_q_3*jac_blending_2_0_q_3 + jac_blending_0_2_q_3*tmp_blending_op_107 - jac_blending_0_2_q_3*tmp_blending_op_110 - jac_blending_1_2_q_3*tmp_blending_op_108 + jac_blending_2_2_q_3*tmp_blending_op_106 - jac_blending_2_2_q_3*tmp_blending_op_109;
             const real_t tmp_blending_op_112 = 1.0 / (tmp_blending_op_111);
             const real_t abs_det_jac_blending_q_3 = tmp_blending_op_111;
             const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_112*(tmp_blending_op_106 - tmp_blending_op_109);
             const real_t jac_blending_inv_2_1_q_3 = tmp_blending_op_112*(jac_blending_0_1_q_3*jac_blending_2_0_q_3 - tmp_blending_op_108);
             const real_t jac_blending_inv_2_0_q_3 = tmp_blending_op_112*(tmp_blending_op_107 - tmp_blending_op_110);
             const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_112*(-jac_blending_0_0_q_3*jac_blending_1_2_q_3 + jac_blending_0_2_q_3*jac_blending_1_0_q_3);
             const real_t jac_blending_inv_1_1_q_3 = tmp_blending_op_112*(jac_blending_0_0_q_3*jac_blending_2_2_q_3 - jac_blending_0_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_1_0_q_3 = tmp_blending_op_112*(-jac_blending_1_0_q_3*jac_blending_2_2_q_3 + jac_blending_1_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_112*(jac_blending_0_1_q_3*jac_blending_1_2_q_3 - jac_blending_0_2_q_3*jac_blending_1_1_q_3);
             const real_t jac_blending_inv_0_1_q_3 = tmp_blending_op_112*(-jac_blending_0_1_q_3*jac_blending_2_2_q_3 + jac_blending_0_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_inv_0_0_q_3 = tmp_blending_op_112*(jac_blending_1_1_q_3*jac_blending_2_2_q_3 - jac_blending_1_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_2_2_q_2 = tmp_blending_op_128*tmp_blending_op_130;
             const real_t jac_blending_2_1_q_2 = tmp_blending_op_113*tmp_blending_op_133;
             const real_t jac_blending_2_0_q_2 = tmp_blending_op_113*tmp_blending_op_135;
             const real_t jac_blending_1_2_q_2 = tmp_blending_op_118*tmp_blending_op_138;
             const real_t jac_blending_1_1_q_2 = tmp_blending_op_130*tmp_blending_op_140;
             const real_t tmp_blending_op_148 = jac_blending_1_1_q_2*jac_blending_2_0_q_2;
             const real_t jac_blending_1_0_q_2 = tmp_blending_op_118*tmp_blending_op_135;
             const real_t tmp_blending_op_145 = jac_blending_1_0_q_2*jac_blending_2_1_q_2;
             const real_t jac_blending_0_2_q_2 = tmp_blending_op_116*tmp_blending_op_138;
             const real_t jac_blending_0_1_q_2 = tmp_blending_op_116*tmp_blending_op_133;
             const real_t tmp_blending_op_147 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
             const real_t jac_blending_0_0_q_2 = tmp_blending_op_130*tmp_blending_op_143;
             const real_t tmp_blending_op_144 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
             const real_t tmp_blending_op_146 = jac_blending_0_0_q_2*jac_blending_2_1_q_2;
             const real_t tmp_blending_op_149 = jac_blending_0_1_q_2*jac_blending_1_2_q_2*jac_blending_2_0_q_2 + jac_blending_0_2_q_2*tmp_blending_op_145 - jac_blending_0_2_q_2*tmp_blending_op_148 - jac_blending_1_2_q_2*tmp_blending_op_146 + jac_blending_2_2_q_2*tmp_blending_op_144 - jac_blending_2_2_q_2*tmp_blending_op_147;
             const real_t tmp_blending_op_150 = 1.0 / (tmp_blending_op_149);
             const real_t abs_det_jac_blending_q_2 = tmp_blending_op_149;
             const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_150*(tmp_blending_op_144 - tmp_blending_op_147);
             const real_t jac_blending_inv_2_1_q_2 = tmp_blending_op_150*(jac_blending_0_1_q_2*jac_blending_2_0_q_2 - tmp_blending_op_146);
             const real_t jac_blending_inv_2_0_q_2 = tmp_blending_op_150*(tmp_blending_op_145 - tmp_blending_op_148);
             const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_150*(-jac_blending_0_0_q_2*jac_blending_1_2_q_2 + jac_blending_0_2_q_2*jac_blending_1_0_q_2);
             const real_t jac_blending_inv_1_1_q_2 = tmp_blending_op_150*(jac_blending_0_0_q_2*jac_blending_2_2_q_2 - jac_blending_0_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_1_0_q_2 = tmp_blending_op_150*(-jac_blending_1_0_q_2*jac_blending_2_2_q_2 + jac_blending_1_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_150*(jac_blending_0_1_q_2*jac_blending_1_2_q_2 - jac_blending_0_2_q_2*jac_blending_1_1_q_2);
             const real_t jac_blending_inv_0_1_q_2 = tmp_blending_op_150*(-jac_blending_0_1_q_2*jac_blending_2_2_q_2 + jac_blending_0_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_inv_0_0_q_2 = tmp_blending_op_150*(jac_blending_1_1_q_2*jac_blending_2_2_q_2 - jac_blending_1_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_2_2_q_1 = tmp_blending_op_166*tmp_blending_op_168;
             const real_t jac_blending_2_1_q_1 = tmp_blending_op_151*tmp_blending_op_171;
             const real_t jac_blending_2_0_q_1 = tmp_blending_op_151*tmp_blending_op_173;
             const real_t jac_blending_1_2_q_1 = tmp_blending_op_156*tmp_blending_op_176;
             const real_t jac_blending_1_1_q_1 = tmp_blending_op_168*tmp_blending_op_178;
             const real_t tmp_blending_op_186 = jac_blending_1_1_q_1*jac_blending_2_0_q_1;
             const real_t jac_blending_1_0_q_1 = tmp_blending_op_156*tmp_blending_op_173;
             const real_t tmp_blending_op_183 = jac_blending_1_0_q_1*jac_blending_2_1_q_1;
             const real_t jac_blending_0_2_q_1 = tmp_blending_op_154*tmp_blending_op_176;
             const real_t jac_blending_0_1_q_1 = tmp_blending_op_154*tmp_blending_op_171;
             const real_t tmp_blending_op_185 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
             const real_t jac_blending_0_0_q_1 = tmp_blending_op_168*tmp_blending_op_181;
             const real_t tmp_blending_op_182 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
             const real_t tmp_blending_op_184 = jac_blending_0_0_q_1*jac_blending_2_1_q_1;
             const real_t tmp_blending_op_187 = jac_blending_0_1_q_1*jac_blending_1_2_q_1*jac_blending_2_0_q_1 + jac_blending_0_2_q_1*tmp_blending_op_183 - jac_blending_0_2_q_1*tmp_blending_op_186 - jac_blending_1_2_q_1*tmp_blending_op_184 + jac_blending_2_2_q_1*tmp_blending_op_182 - jac_blending_2_2_q_1*tmp_blending_op_185;
             const real_t tmp_blending_op_188 = 1.0 / (tmp_blending_op_187);
             const real_t abs_det_jac_blending_q_1 = tmp_blending_op_187;
             const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_188*(tmp_blending_op_182 - tmp_blending_op_185);
             const real_t jac_blending_inv_2_1_q_1 = tmp_blending_op_188*(jac_blending_0_1_q_1*jac_blending_2_0_q_1 - tmp_blending_op_184);
             const real_t jac_blending_inv_2_0_q_1 = tmp_blending_op_188*(tmp_blending_op_183 - tmp_blending_op_186);
             const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_188*(-jac_blending_0_0_q_1*jac_blending_1_2_q_1 + jac_blending_0_2_q_1*jac_blending_1_0_q_1);
             const real_t jac_blending_inv_1_1_q_1 = tmp_blending_op_188*(jac_blending_0_0_q_1*jac_blending_2_2_q_1 - jac_blending_0_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_1_0_q_1 = tmp_blending_op_188*(-jac_blending_1_0_q_1*jac_blending_2_2_q_1 + jac_blending_1_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_188*(jac_blending_0_1_q_1*jac_blending_1_2_q_1 - jac_blending_0_2_q_1*jac_blending_1_1_q_1);
             const real_t jac_blending_inv_0_1_q_1 = tmp_blending_op_188*(-jac_blending_0_1_q_1*jac_blending_2_2_q_1 + jac_blending_0_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_inv_0_0_q_1 = tmp_blending_op_188*(jac_blending_1_1_q_1*jac_blending_2_2_q_1 - jac_blending_1_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_2_2_q_0 = tmp_blending_op_204*tmp_blending_op_206;
             const real_t jac_blending_2_1_q_0 = tmp_blending_op_189*tmp_blending_op_209;
             const real_t jac_blending_2_0_q_0 = tmp_blending_op_189*tmp_blending_op_211;
             const real_t jac_blending_1_2_q_0 = tmp_blending_op_194*tmp_blending_op_214;
             const real_t jac_blending_1_1_q_0 = tmp_blending_op_206*tmp_blending_op_216;
             const real_t tmp_blending_op_224 = jac_blending_1_1_q_0*jac_blending_2_0_q_0;
             const real_t jac_blending_1_0_q_0 = tmp_blending_op_194*tmp_blending_op_211;
             const real_t tmp_blending_op_221 = jac_blending_1_0_q_0*jac_blending_2_1_q_0;
             const real_t jac_blending_0_2_q_0 = tmp_blending_op_192*tmp_blending_op_214;
             const real_t jac_blending_0_1_q_0 = tmp_blending_op_192*tmp_blending_op_209;
             const real_t tmp_blending_op_223 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
             const real_t jac_blending_0_0_q_0 = tmp_blending_op_206*tmp_blending_op_219;
             const real_t tmp_blending_op_220 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
             const real_t tmp_blending_op_222 = jac_blending_0_0_q_0*jac_blending_2_1_q_0;
             const real_t tmp_blending_op_225 = jac_blending_0_1_q_0*jac_blending_1_2_q_0*jac_blending_2_0_q_0 + jac_blending_0_2_q_0*tmp_blending_op_221 - jac_blending_0_2_q_0*tmp_blending_op_224 - jac_blending_1_2_q_0*tmp_blending_op_222 + jac_blending_2_2_q_0*tmp_blending_op_220 - jac_blending_2_2_q_0*tmp_blending_op_223;
             const real_t tmp_blending_op_226 = 1.0 / (tmp_blending_op_225);
             const real_t abs_det_jac_blending_q_0 = tmp_blending_op_225;
             const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_226*(tmp_blending_op_220 - tmp_blending_op_223);
             const real_t jac_blending_inv_2_1_q_0 = tmp_blending_op_226*(jac_blending_0_1_q_0*jac_blending_2_0_q_0 - tmp_blending_op_222);
             const real_t jac_blending_inv_2_0_q_0 = tmp_blending_op_226*(tmp_blending_op_221 - tmp_blending_op_224);
             const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_226*(-jac_blending_0_0_q_0*jac_blending_1_2_q_0 + jac_blending_0_2_q_0*jac_blending_1_0_q_0);
             const real_t jac_blending_inv_1_1_q_0 = tmp_blending_op_226*(jac_blending_0_0_q_0*jac_blending_2_2_q_0 - jac_blending_0_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_1_0_q_0 = tmp_blending_op_226*(-jac_blending_1_0_q_0*jac_blending_2_2_q_0 + jac_blending_1_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_226*(jac_blending_0_1_q_0*jac_blending_1_2_q_0 - jac_blending_0_2_q_0*jac_blending_1_1_q_0);
             const real_t jac_blending_inv_0_1_q_0 = tmp_blending_op_226*(-jac_blending_0_1_q_0*jac_blending_2_2_q_0 + jac_blending_0_2_q_0*jac_blending_2_1_q_0);
             const real_t jac_blending_inv_0_0_q_0 = tmp_blending_op_226*(jac_blending_1_1_q_0*jac_blending_2_2_q_0 - jac_blending_1_2_q_0*jac_blending_2_1_q_0);
             const real_t hessian_blending_0_0_0_q_0 = tmp_blending_op_205*tmp_blending_op_47*(-tmp_blending_op_197*tmp_blending_op_232 + tmp_blending_op_199*tmp_blending_op_230 + tmp_blending_op_201*tmp_blending_op_231 + tmp_blending_op_218*tmp_blending_op_232)*1.0 - tmp_blending_op_219*tmp_blending_op_229;
             const real_t hessian_blending_0_0_1_q_0 = tmp_blending_op_194*tmp_blending_op_205*tmp_blending_op_235*tmp_blending_op_47*1.0 - tmp_blending_op_194*tmp_blending_op_236;
             const real_t hessian_blending_0_0_2_q_0 = tmp_blending_op_189*tmp_blending_op_205*tmp_blending_op_235*tmp_blending_op_47*1.0 - tmp_blending_op_189*tmp_blending_op_236;
             const real_t hessian_blending_0_1_0_q_0 = tmp_blending_op_192*tmp_blending_op_206*tmp_blending_op_237 - tmp_blending_op_208*tmp_blending_op_238 + tmp_blending_op_209;
             const real_t hessian_blending_0_1_1_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_200*tmp_blending_op_230 + tmp_blending_op_215*tmp_blending_op_232 + tmp_blending_op_239)*1.0 - tmp_blending_op_216*tmp_blending_op_229;
             const real_t hessian_blending_0_1_2_q_0 = tmp_blending_op_189*tmp_blending_op_205*tmp_blending_op_237*tmp_blending_op_47*1.0 - tmp_blending_op_241;
             const real_t hessian_blending_0_2_0_q_0 = tmp_blending_op_192*tmp_blending_op_206*tmp_blending_op_242 - tmp_blending_op_213*tmp_blending_op_238 + tmp_blending_op_214;
             const real_t hessian_blending_0_2_1_q_0 = tmp_blending_op_194*tmp_blending_op_205*tmp_blending_op_242*tmp_blending_op_47*1.0 - tmp_blending_op_244;
             const real_t hessian_blending_0_2_2_q_0 = -tmp_blending_op_204*tmp_blending_op_229 + tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_190*tmp_blending_op_230 + tmp_blending_op_203*tmp_blending_op_232 + tmp_blending_op_239)*1.0;
             const real_t hessian_blending_1_0_0_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_199*tmp_blending_op_51 + tmp_blending_op_218*tmp_blending_op_246 + tmp_blending_op_245)*1.0 - tmp_blending_op_219*tmp_blending_op_247;
             const real_t hessian_blending_1_0_1_q_0 = tmp_blending_op_194*tmp_blending_op_248 - tmp_blending_op_210*tmp_blending_op_249 + tmp_blending_op_211;
             const real_t hessian_blending_1_0_2_q_0 = tmp_blending_op_189*tmp_blending_op_248 + tmp_blending_op_251;
             const real_t hessian_blending_1_1_0_q_0 = tmp_blending_op_192*tmp_blending_op_205*tmp_blending_op_252*tmp_blending_op_47*1.0 - tmp_blending_op_194*tmp_blending_op_240;
             const real_t hessian_blending_1_1_1_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_198*tmp_blending_op_246 + tmp_blending_op_200*tmp_blending_op_51 + tmp_blending_op_201*tmp_blending_op_253 + tmp_blending_op_215*tmp_blending_op_246)*1.0 - tmp_blending_op_216*tmp_blending_op_247;
             const real_t hessian_blending_1_1_2_q_0 = tmp_blending_op_189*tmp_blending_op_205*tmp_blending_op_252*tmp_blending_op_47*1.0 - tmp_blending_op_208*tmp_blending_op_250;
             const real_t hessian_blending_1_2_0_q_0 = tmp_blending_op_192*tmp_blending_op_205*tmp_blending_op_255*tmp_blending_op_47*1.0 - tmp_blending_op_244;
             const real_t hessian_blending_1_2_1_q_0 = tmp_blending_op_194*tmp_blending_op_206*tmp_blending_op_255 - tmp_blending_op_213*tmp_blending_op_249 + tmp_blending_op_214;
             const real_t hessian_blending_1_2_2_q_0 = -tmp_blending_op_204*tmp_blending_op_247 + tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_190*tmp_blending_op_51 + tmp_blending_op_203*tmp_blending_op_246 + tmp_blending_op_245)*1.0;
             const real_t hessian_blending_2_0_0_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_199*tmp_blending_op_256 + tmp_blending_op_218*tmp_blending_op_258 + tmp_blending_op_257)*1.0 - tmp_blending_op_219*tmp_blending_op_259;
             const real_t hessian_blending_2_0_1_q_0 = tmp_blending_op_194*tmp_blending_op_260 + tmp_blending_op_251;
             const real_t hessian_blending_2_0_2_q_0 = tmp_blending_op_189*tmp_blending_op_260 - tmp_blending_op_210*tmp_blending_op_261 + tmp_blending_op_211;
             const real_t hessian_blending_2_1_0_q_0 = tmp_blending_op_192*tmp_blending_op_262 - tmp_blending_op_241;
             const real_t hessian_blending_2_1_1_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_200*tmp_blending_op_256 + tmp_blending_op_215*tmp_blending_op_258 + tmp_blending_op_257)*1.0 - tmp_blending_op_216*tmp_blending_op_259;
             const real_t hessian_blending_2_1_2_q_0 = tmp_blending_op_189*tmp_blending_op_262 - tmp_blending_op_208*tmp_blending_op_261 + tmp_blending_op_209;
             const real_t hessian_blending_2_2_0_q_0 = -tmp_blending_op_189*tmp_blending_op_243 + tmp_blending_op_192*tmp_blending_op_205*tmp_blending_op_263*tmp_blending_op_47*1.0;
             const real_t hessian_blending_2_2_1_q_0 = tmp_blending_op_194*tmp_blending_op_205*tmp_blending_op_263*tmp_blending_op_47*1.0 - tmp_blending_op_213*tmp_blending_op_250;
             const real_t hessian_blending_2_2_2_q_0 = -tmp_blending_op_204*tmp_blending_op_259 + tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_190*tmp_blending_op_256 + tmp_blending_op_201*tmp_blending_op_264 + tmp_blending_op_203*tmp_blending_op_258 + tmp_blending_op_212*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_1 = tmp_blending_op_167*tmp_blending_op_47*(-tmp_blending_op_159*tmp_blending_op_267 + tmp_blending_op_161*tmp_blending_op_230 + tmp_blending_op_163*tmp_blending_op_231 + tmp_blending_op_180*tmp_blending_op_267)*1.0 - tmp_blending_op_181*tmp_blending_op_266;
             const real_t hessian_blending_0_0_1_q_1 = tmp_blending_op_156*tmp_blending_op_167*tmp_blending_op_269*tmp_blending_op_47*1.0 - tmp_blending_op_156*tmp_blending_op_270;
             const real_t hessian_blending_0_0_2_q_1 = tmp_blending_op_151*tmp_blending_op_167*tmp_blending_op_269*tmp_blending_op_47*1.0 - tmp_blending_op_151*tmp_blending_op_270;
             const real_t hessian_blending_0_1_0_q_1 = tmp_blending_op_154*tmp_blending_op_168*tmp_blending_op_271 - tmp_blending_op_170*tmp_blending_op_272 + tmp_blending_op_171;
             const real_t hessian_blending_0_1_1_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_162*tmp_blending_op_230 + tmp_blending_op_177*tmp_blending_op_267 + tmp_blending_op_273)*1.0 - tmp_blending_op_178*tmp_blending_op_266;
             const real_t hessian_blending_0_1_2_q_1 = tmp_blending_op_151*tmp_blending_op_167*tmp_blending_op_271*tmp_blending_op_47*1.0 - tmp_blending_op_275;
             const real_t hessian_blending_0_2_0_q_1 = tmp_blending_op_154*tmp_blending_op_168*tmp_blending_op_276 - tmp_blending_op_175*tmp_blending_op_272 + tmp_blending_op_176;
             const real_t hessian_blending_0_2_1_q_1 = tmp_blending_op_156*tmp_blending_op_167*tmp_blending_op_276*tmp_blending_op_47*1.0 - tmp_blending_op_278;
             const real_t hessian_blending_0_2_2_q_1 = -tmp_blending_op_166*tmp_blending_op_266 + tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_152*tmp_blending_op_230 + tmp_blending_op_165*tmp_blending_op_267 + tmp_blending_op_273)*1.0;
             const real_t hessian_blending_1_0_0_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_161*tmp_blending_op_51 + tmp_blending_op_180*tmp_blending_op_280 + tmp_blending_op_279)*1.0 - tmp_blending_op_181*tmp_blending_op_281;
             const real_t hessian_blending_1_0_1_q_1 = tmp_blending_op_156*tmp_blending_op_282 - tmp_blending_op_172*tmp_blending_op_283 + tmp_blending_op_173;
             const real_t hessian_blending_1_0_2_q_1 = tmp_blending_op_151*tmp_blending_op_282 + tmp_blending_op_285;
             const real_t hessian_blending_1_1_0_q_1 = tmp_blending_op_154*tmp_blending_op_167*tmp_blending_op_286*tmp_blending_op_47*1.0 - tmp_blending_op_156*tmp_blending_op_274;
             const real_t hessian_blending_1_1_1_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_160*tmp_blending_op_280 + tmp_blending_op_162*tmp_blending_op_51 + tmp_blending_op_163*tmp_blending_op_253 + tmp_blending_op_177*tmp_blending_op_280)*1.0 - tmp_blending_op_178*tmp_blending_op_281;
             const real_t hessian_blending_1_1_2_q_1 = tmp_blending_op_151*tmp_blending_op_167*tmp_blending_op_286*tmp_blending_op_47*1.0 - tmp_blending_op_170*tmp_blending_op_284;
             const real_t hessian_blending_1_2_0_q_1 = tmp_blending_op_154*tmp_blending_op_167*tmp_blending_op_288*tmp_blending_op_47*1.0 - tmp_blending_op_278;
             const real_t hessian_blending_1_2_1_q_1 = tmp_blending_op_156*tmp_blending_op_168*tmp_blending_op_288 - tmp_blending_op_175*tmp_blending_op_283 + tmp_blending_op_176;
             const real_t hessian_blending_1_2_2_q_1 = -tmp_blending_op_166*tmp_blending_op_281 + tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_152*tmp_blending_op_51 + tmp_blending_op_165*tmp_blending_op_280 + tmp_blending_op_279)*1.0;
             const real_t hessian_blending_2_0_0_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_161*tmp_blending_op_256 + tmp_blending_op_180*tmp_blending_op_290 + tmp_blending_op_289)*1.0 - tmp_blending_op_181*tmp_blending_op_291;
             const real_t hessian_blending_2_0_1_q_1 = tmp_blending_op_156*tmp_blending_op_292 + tmp_blending_op_285;
             const real_t hessian_blending_2_0_2_q_1 = tmp_blending_op_151*tmp_blending_op_292 - tmp_blending_op_172*tmp_blending_op_293 + tmp_blending_op_173;
             const real_t hessian_blending_2_1_0_q_1 = tmp_blending_op_154*tmp_blending_op_294 - tmp_blending_op_275;
             const real_t hessian_blending_2_1_1_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_162*tmp_blending_op_256 + tmp_blending_op_177*tmp_blending_op_290 + tmp_blending_op_289)*1.0 - tmp_blending_op_178*tmp_blending_op_291;
             const real_t hessian_blending_2_1_2_q_1 = tmp_blending_op_151*tmp_blending_op_294 - tmp_blending_op_170*tmp_blending_op_293 + tmp_blending_op_171;
             const real_t hessian_blending_2_2_0_q_1 = -tmp_blending_op_151*tmp_blending_op_277 + tmp_blending_op_154*tmp_blending_op_167*tmp_blending_op_295*tmp_blending_op_47*1.0;
             const real_t hessian_blending_2_2_1_q_1 = tmp_blending_op_156*tmp_blending_op_167*tmp_blending_op_295*tmp_blending_op_47*1.0 - tmp_blending_op_175*tmp_blending_op_284;
             const real_t hessian_blending_2_2_2_q_1 = -tmp_blending_op_166*tmp_blending_op_291 + tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_152*tmp_blending_op_256 + tmp_blending_op_163*tmp_blending_op_264 + tmp_blending_op_165*tmp_blending_op_290 + tmp_blending_op_174*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_2 = tmp_blending_op_129*tmp_blending_op_47*(-tmp_blending_op_121*tmp_blending_op_298 + tmp_blending_op_123*tmp_blending_op_230 + tmp_blending_op_125*tmp_blending_op_231 + tmp_blending_op_142*tmp_blending_op_298)*1.0 - tmp_blending_op_143*tmp_blending_op_297;
             const real_t hessian_blending_0_0_1_q_2 = tmp_blending_op_118*tmp_blending_op_129*tmp_blending_op_300*tmp_blending_op_47*1.0 - tmp_blending_op_118*tmp_blending_op_301;
             const real_t hessian_blending_0_0_2_q_2 = tmp_blending_op_113*tmp_blending_op_129*tmp_blending_op_300*tmp_blending_op_47*1.0 - tmp_blending_op_113*tmp_blending_op_301;
             const real_t hessian_blending_0_1_0_q_2 = tmp_blending_op_116*tmp_blending_op_130*tmp_blending_op_302 - tmp_blending_op_132*tmp_blending_op_303 + tmp_blending_op_133;
             const real_t hessian_blending_0_1_1_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_124*tmp_blending_op_230 + tmp_blending_op_139*tmp_blending_op_298 + tmp_blending_op_304)*1.0 - tmp_blending_op_140*tmp_blending_op_297;
             const real_t hessian_blending_0_1_2_q_2 = tmp_blending_op_113*tmp_blending_op_129*tmp_blending_op_302*tmp_blending_op_47*1.0 - tmp_blending_op_306;
             const real_t hessian_blending_0_2_0_q_2 = tmp_blending_op_116*tmp_blending_op_130*tmp_blending_op_307 - tmp_blending_op_137*tmp_blending_op_303 + tmp_blending_op_138;
             const real_t hessian_blending_0_2_1_q_2 = tmp_blending_op_118*tmp_blending_op_129*tmp_blending_op_307*tmp_blending_op_47*1.0 - tmp_blending_op_309;
             const real_t hessian_blending_0_2_2_q_2 = -tmp_blending_op_128*tmp_blending_op_297 + tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_114*tmp_blending_op_230 + tmp_blending_op_127*tmp_blending_op_298 + tmp_blending_op_304)*1.0;
             const real_t hessian_blending_1_0_0_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_123*tmp_blending_op_51 + tmp_blending_op_142*tmp_blending_op_311 + tmp_blending_op_310)*1.0 - tmp_blending_op_143*tmp_blending_op_312;
             const real_t hessian_blending_1_0_1_q_2 = tmp_blending_op_118*tmp_blending_op_313 - tmp_blending_op_134*tmp_blending_op_314 + tmp_blending_op_135;
             const real_t hessian_blending_1_0_2_q_2 = tmp_blending_op_113*tmp_blending_op_313 + tmp_blending_op_316;
             const real_t hessian_blending_1_1_0_q_2 = tmp_blending_op_116*tmp_blending_op_129*tmp_blending_op_317*tmp_blending_op_47*1.0 - tmp_blending_op_118*tmp_blending_op_305;
             const real_t hessian_blending_1_1_1_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_122*tmp_blending_op_311 + tmp_blending_op_124*tmp_blending_op_51 + tmp_blending_op_125*tmp_blending_op_253 + tmp_blending_op_139*tmp_blending_op_311)*1.0 - tmp_blending_op_140*tmp_blending_op_312;
             const real_t hessian_blending_1_1_2_q_2 = tmp_blending_op_113*tmp_blending_op_129*tmp_blending_op_317*tmp_blending_op_47*1.0 - tmp_blending_op_132*tmp_blending_op_315;
             const real_t hessian_blending_1_2_0_q_2 = tmp_blending_op_116*tmp_blending_op_129*tmp_blending_op_319*tmp_blending_op_47*1.0 - tmp_blending_op_309;
             const real_t hessian_blending_1_2_1_q_2 = tmp_blending_op_118*tmp_blending_op_130*tmp_blending_op_319 - tmp_blending_op_137*tmp_blending_op_314 + tmp_blending_op_138;
             const real_t hessian_blending_1_2_2_q_2 = -tmp_blending_op_128*tmp_blending_op_312 + tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_114*tmp_blending_op_51 + tmp_blending_op_127*tmp_blending_op_311 + tmp_blending_op_310)*1.0;
             const real_t hessian_blending_2_0_0_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_123*tmp_blending_op_256 + tmp_blending_op_142*tmp_blending_op_321 + tmp_blending_op_320)*1.0 - tmp_blending_op_143*tmp_blending_op_322;
             const real_t hessian_blending_2_0_1_q_2 = tmp_blending_op_118*tmp_blending_op_323 + tmp_blending_op_316;
             const real_t hessian_blending_2_0_2_q_2 = tmp_blending_op_113*tmp_blending_op_323 - tmp_blending_op_134*tmp_blending_op_324 + tmp_blending_op_135;
             const real_t hessian_blending_2_1_0_q_2 = tmp_blending_op_116*tmp_blending_op_325 - tmp_blending_op_306;
             const real_t hessian_blending_2_1_1_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_124*tmp_blending_op_256 + tmp_blending_op_139*tmp_blending_op_321 + tmp_blending_op_320)*1.0 - tmp_blending_op_140*tmp_blending_op_322;
             const real_t hessian_blending_2_1_2_q_2 = tmp_blending_op_113*tmp_blending_op_325 - tmp_blending_op_132*tmp_blending_op_324 + tmp_blending_op_133;
             const real_t hessian_blending_2_2_0_q_2 = -tmp_blending_op_113*tmp_blending_op_308 + tmp_blending_op_116*tmp_blending_op_129*tmp_blending_op_326*tmp_blending_op_47*1.0;
             const real_t hessian_blending_2_2_1_q_2 = tmp_blending_op_118*tmp_blending_op_129*tmp_blending_op_326*tmp_blending_op_47*1.0 - tmp_blending_op_137*tmp_blending_op_315;
             const real_t hessian_blending_2_2_2_q_2 = -tmp_blending_op_128*tmp_blending_op_322 + tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_114*tmp_blending_op_256 + tmp_blending_op_125*tmp_blending_op_264 + tmp_blending_op_127*tmp_blending_op_321 + tmp_blending_op_136*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_3 = -tmp_blending_op_105*tmp_blending_op_328 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_104*tmp_blending_op_329 + tmp_blending_op_230*tmp_blending_op_85 + tmp_blending_op_231*tmp_blending_op_87 - tmp_blending_op_329*tmp_blending_op_83)*1.0;
             const real_t hessian_blending_0_0_1_q_3 = tmp_blending_op_331*tmp_blending_op_47*tmp_blending_op_80*tmp_blending_op_91*1.0 - tmp_blending_op_332*tmp_blending_op_80;
             const real_t hessian_blending_0_0_2_q_3 = tmp_blending_op_331*tmp_blending_op_47*tmp_blending_op_75*tmp_blending_op_91*1.0 - tmp_blending_op_332*tmp_blending_op_75;
             const real_t hessian_blending_0_1_0_q_3 = tmp_blending_op_333*tmp_blending_op_78*tmp_blending_op_92 - tmp_blending_op_334*tmp_blending_op_94 + tmp_blending_op_95;
             const real_t hessian_blending_0_1_1_q_3 = -tmp_blending_op_102*tmp_blending_op_328 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_101*tmp_blending_op_329 + tmp_blending_op_230*tmp_blending_op_86 + tmp_blending_op_335)*1.0;
             const real_t hessian_blending_0_1_2_q_3 = tmp_blending_op_333*tmp_blending_op_47*tmp_blending_op_75*tmp_blending_op_91*1.0 - tmp_blending_op_337;
             const real_t hessian_blending_0_2_0_q_3 = tmp_blending_op_100 - tmp_blending_op_334*tmp_blending_op_99 + tmp_blending_op_338*tmp_blending_op_78*tmp_blending_op_92;
             const real_t hessian_blending_0_2_1_q_3 = tmp_blending_op_338*tmp_blending_op_47*tmp_blending_op_80*tmp_blending_op_91*1.0 - tmp_blending_op_340;
             const real_t hessian_blending_0_2_2_q_3 = -tmp_blending_op_328*tmp_blending_op_90 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_230*tmp_blending_op_76 + tmp_blending_op_329*tmp_blending_op_89 + tmp_blending_op_335)*1.0;
             const real_t hessian_blending_1_0_0_q_3 = -tmp_blending_op_105*tmp_blending_op_343 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_104*tmp_blending_op_342 + tmp_blending_op_341 + tmp_blending_op_51*tmp_blending_op_85)*1.0;
             const real_t hessian_blending_1_0_1_q_3 = tmp_blending_op_344*tmp_blending_op_80 - tmp_blending_op_345*tmp_blending_op_96 + tmp_blending_op_97;
             const real_t hessian_blending_1_0_2_q_3 = tmp_blending_op_344*tmp_blending_op_75 + tmp_blending_op_347;
             const real_t hessian_blending_1_1_0_q_3 = -tmp_blending_op_336*tmp_blending_op_80 + tmp_blending_op_348*tmp_blending_op_47*tmp_blending_op_78*tmp_blending_op_91*1.0;
             const real_t hessian_blending_1_1_1_q_3 = -tmp_blending_op_102*tmp_blending_op_343 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_101*tmp_blending_op_342 + tmp_blending_op_253*tmp_blending_op_87 + tmp_blending_op_342*tmp_blending_op_84 + tmp_blending_op_51*tmp_blending_op_86)*1.0;
             const real_t hessian_blending_1_1_2_q_3 = -tmp_blending_op_346*tmp_blending_op_94 + tmp_blending_op_348*tmp_blending_op_47*tmp_blending_op_75*tmp_blending_op_91*1.0;
             const real_t hessian_blending_1_2_0_q_3 = -tmp_blending_op_340 + tmp_blending_op_350*tmp_blending_op_47*tmp_blending_op_78*tmp_blending_op_91*1.0;
             const real_t hessian_blending_1_2_1_q_3 = tmp_blending_op_100 - tmp_blending_op_345*tmp_blending_op_99 + tmp_blending_op_350*tmp_blending_op_80*tmp_blending_op_92;
             const real_t hessian_blending_1_2_2_q_3 = -tmp_blending_op_343*tmp_blending_op_90 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_341 + tmp_blending_op_342*tmp_blending_op_89 + tmp_blending_op_51*tmp_blending_op_76)*1.0;
             const real_t hessian_blending_2_0_0_q_3 = -tmp_blending_op_105*tmp_blending_op_353 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_104*tmp_blending_op_352 + tmp_blending_op_256*tmp_blending_op_85 + tmp_blending_op_351)*1.0;
             const real_t hessian_blending_2_0_1_q_3 = tmp_blending_op_347 + tmp_blending_op_354*tmp_blending_op_80;
             const real_t hessian_blending_2_0_2_q_3 = tmp_blending_op_354*tmp_blending_op_75 - tmp_blending_op_355*tmp_blending_op_96 + tmp_blending_op_97;
             const real_t hessian_blending_2_1_0_q_3 = -tmp_blending_op_337 + tmp_blending_op_356*tmp_blending_op_78;
             const real_t hessian_blending_2_1_1_q_3 = -tmp_blending_op_102*tmp_blending_op_353 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_101*tmp_blending_op_352 + tmp_blending_op_256*tmp_blending_op_86 + tmp_blending_op_351)*1.0;
             const real_t hessian_blending_2_1_2_q_3 = -tmp_blending_op_355*tmp_blending_op_94 + tmp_blending_op_356*tmp_blending_op_75 + tmp_blending_op_95;
             const real_t hessian_blending_2_2_0_q_3 = -tmp_blending_op_339*tmp_blending_op_75 + tmp_blending_op_357*tmp_blending_op_47*tmp_blending_op_78*tmp_blending_op_91*1.0;
             const real_t hessian_blending_2_2_1_q_3 = -tmp_blending_op_346*tmp_blending_op_99 + tmp_blending_op_357*tmp_blending_op_47*tmp_blending_op_80*tmp_blending_op_91*1.0;
             const real_t hessian_blending_2_2_2_q_3 = -tmp_blending_op_353*tmp_blending_op_90 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_256*tmp_blending_op_76 + tmp_blending_op_264*tmp_blending_op_87 + tmp_blending_op_352*tmp_blending_op_89 + tmp_blending_op_98*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_4 = -tmp_blending_op_359*tmp_blending_op_67 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_230*tmp_blending_op_38 + tmp_blending_op_231*tmp_blending_op_40 - tmp_blending_op_36*tmp_blending_op_360 + tmp_blending_op_360*tmp_blending_op_66)*1.0;
             const real_t hessian_blending_0_0_1_q_4 = tmp_blending_op_33*tmp_blending_op_362*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_33*tmp_blending_op_363;
             const real_t hessian_blending_0_0_2_q_4 = tmp_blending_op_3*tmp_blending_op_362*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_3*tmp_blending_op_363;
             const real_t hessian_blending_0_1_0_q_4 = tmp_blending_op_28*tmp_blending_op_364*tmp_blending_op_49 - tmp_blending_op_365*tmp_blending_op_53 + tmp_blending_op_54;
             const real_t hessian_blending_0_1_1_q_4 = -tmp_blending_op_359*tmp_blending_op_64 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_230*tmp_blending_op_39 + tmp_blending_op_360*tmp_blending_op_63 + tmp_blending_op_366)*1.0;
             const real_t hessian_blending_0_1_2_q_4 = tmp_blending_op_3*tmp_blending_op_364*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_368;
             const real_t hessian_blending_0_2_0_q_4 = tmp_blending_op_28*tmp_blending_op_369*tmp_blending_op_49 - tmp_blending_op_365*tmp_blending_op_60 + tmp_blending_op_61;
             const real_t hessian_blending_0_2_1_q_4 = tmp_blending_op_33*tmp_blending_op_369*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_371;
             const real_t hessian_blending_0_2_2_q_4 = -tmp_blending_op_359*tmp_blending_op_45 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_230*tmp_blending_op_4 + tmp_blending_op_360*tmp_blending_op_44 + tmp_blending_op_366)*1.0;
             const real_t hessian_blending_1_0_0_q_4 = -tmp_blending_op_374*tmp_blending_op_67 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_372 + tmp_blending_op_373*tmp_blending_op_66 + tmp_blending_op_38*tmp_blending_op_51)*1.0;
             const real_t hessian_blending_1_0_1_q_4 = tmp_blending_op_33*tmp_blending_op_375 - tmp_blending_op_376*tmp_blending_op_57 + tmp_blending_op_58;
             const real_t hessian_blending_1_0_2_q_4 = tmp_blending_op_3*tmp_blending_op_375 + tmp_blending_op_378;
             const real_t hessian_blending_1_1_0_q_4 = tmp_blending_op_28*tmp_blending_op_379*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_33*tmp_blending_op_367;
             const real_t hessian_blending_1_1_1_q_4 = -tmp_blending_op_374*tmp_blending_op_64 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_253*tmp_blending_op_40 + tmp_blending_op_37*tmp_blending_op_373 + tmp_blending_op_373*tmp_blending_op_63 + tmp_blending_op_39*tmp_blending_op_51)*1.0;
             const real_t hessian_blending_1_1_2_q_4 = tmp_blending_op_3*tmp_blending_op_379*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_377*tmp_blending_op_53;
             const real_t hessian_blending_1_2_0_q_4 = tmp_blending_op_28*tmp_blending_op_381*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_371;
             const real_t hessian_blending_1_2_1_q_4 = tmp_blending_op_33*tmp_blending_op_381*tmp_blending_op_49 - tmp_blending_op_376*tmp_blending_op_60 + tmp_blending_op_61;
             const real_t hessian_blending_1_2_2_q_4 = -tmp_blending_op_374*tmp_blending_op_45 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_372 + tmp_blending_op_373*tmp_blending_op_44 + tmp_blending_op_4*tmp_blending_op_51)*1.0;
             const real_t hessian_blending_2_0_0_q_4 = -tmp_blending_op_384*tmp_blending_op_67 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_256*tmp_blending_op_38 + tmp_blending_op_382 + tmp_blending_op_383*tmp_blending_op_66)*1.0;
             const real_t hessian_blending_2_0_1_q_4 = tmp_blending_op_33*tmp_blending_op_385 + tmp_blending_op_378;
             const real_t hessian_blending_2_0_2_q_4 = tmp_blending_op_3*tmp_blending_op_385 - tmp_blending_op_386*tmp_blending_op_57 + tmp_blending_op_58;
             const real_t hessian_blending_2_1_0_q_4 = tmp_blending_op_28*tmp_blending_op_387 - tmp_blending_op_368;
             const real_t hessian_blending_2_1_1_q_4 = -tmp_blending_op_384*tmp_blending_op_64 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_256*tmp_blending_op_39 + tmp_blending_op_382 + tmp_blending_op_383*tmp_blending_op_63)*1.0;
             const real_t hessian_blending_2_1_2_q_4 = tmp_blending_op_3*tmp_blending_op_387 - tmp_blending_op_386*tmp_blending_op_53 + tmp_blending_op_54;
             const real_t hessian_blending_2_2_0_q_4 = tmp_blending_op_28*tmp_blending_op_388*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_3*tmp_blending_op_370;
             const real_t hessian_blending_2_2_1_q_4 = tmp_blending_op_33*tmp_blending_op_388*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_377*tmp_blending_op_60;
             const real_t hessian_blending_2_2_2_q_4 = -tmp_blending_op_384*tmp_blending_op_45 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_256*tmp_blending_op_4 + tmp_blending_op_264*tmp_blending_op_40 + tmp_blending_op_383*tmp_blending_op_44 + tmp_blending_op_59*2.0)*1.0;
             const real_t diffusivity_times_delta_dof_0 = _data_diffusivity_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t diffusivity_times_delta_dof_1 = _data_diffusivity_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t diffusivity_times_delta_dof_2 = _data_diffusivity_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t diffusivity_times_delta_dof_3 = _data_diffusivity_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t diffusivity_times_delta_dof_4 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t diffusivity_times_delta_dof_5 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t diffusivity_times_delta_dof_6 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t diffusivity_times_delta_dof_7 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t diffusivity_times_delta_dof_8 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t diffusivity_times_delta_dof_9 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wx_dof_0 = _data_wxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wx_dof_1 = _data_wxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wx_dof_2 = _data_wxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wx_dof_3 = _data_wxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wx_dof_4 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wx_dof_5 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wx_dof_6 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wx_dof_7 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t wx_dof_8 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wx_dof_9 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wy_dof_0 = _data_wyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wy_dof_1 = _data_wyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wy_dof_2 = _data_wyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wy_dof_3 = _data_wyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wy_dof_4 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wy_dof_5 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wy_dof_6 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wy_dof_7 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t wy_dof_8 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wy_dof_9 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wz_dof_0 = _data_wzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wz_dof_1 = _data_wzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wz_dof_2 = _data_wzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wz_dof_3 = _data_wzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wz_dof_4 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wz_dof_5 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wz_dof_6 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wz_dof_7 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t wz_dof_8 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wz_dof_9 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t tmp_kernel_op_30 = -hessian_blending_0_0_0_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_0_1_0_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_0_2_0_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_31 = -hessian_blending_0_0_1_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_0_1_1_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_0_2_1_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_32 = -hessian_blending_0_0_2_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_0_1_2_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_0_2_2_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_33 = jac_blending_inv_0_0_q_0*tmp_kernel_op_30 + jac_blending_inv_0_1_q_0*tmp_kernel_op_31 + jac_blending_inv_0_2_q_0*tmp_kernel_op_32;
             const real_t tmp_kernel_op_35 = jac_blending_inv_1_0_q_0*tmp_kernel_op_30 + jac_blending_inv_1_1_q_0*tmp_kernel_op_31 + jac_blending_inv_1_2_q_0*tmp_kernel_op_32;
             const real_t tmp_kernel_op_37 = jac_blending_inv_2_0_q_0*tmp_kernel_op_30 + jac_blending_inv_2_1_q_0*tmp_kernel_op_31 + jac_blending_inv_2_2_q_0*tmp_kernel_op_32;
             const real_t tmp_kernel_op_38 = -hessian_blending_1_0_0_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_1_1_0_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_1_2_0_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_39 = -hessian_blending_1_0_1_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_1_1_1_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_1_2_1_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_40 = -hessian_blending_1_0_2_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_1_1_2_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_1_2_2_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_41 = jac_blending_inv_0_0_q_0*tmp_kernel_op_38 + jac_blending_inv_0_1_q_0*tmp_kernel_op_39 + jac_blending_inv_0_2_q_0*tmp_kernel_op_40;
             const real_t tmp_kernel_op_42 = jac_blending_inv_1_0_q_0*tmp_kernel_op_38 + jac_blending_inv_1_1_q_0*tmp_kernel_op_39 + jac_blending_inv_1_2_q_0*tmp_kernel_op_40;
             const real_t tmp_kernel_op_43 = jac_blending_inv_2_0_q_0*tmp_kernel_op_38 + jac_blending_inv_2_1_q_0*tmp_kernel_op_39 + jac_blending_inv_2_2_q_0*tmp_kernel_op_40;
             const real_t tmp_kernel_op_44 = -hessian_blending_2_0_0_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_2_1_0_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_2_2_0_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_45 = -hessian_blending_2_0_1_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_2_1_1_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_2_2_1_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_46 = -hessian_blending_2_0_2_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_2_1_2_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_2_2_2_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_47 = jac_blending_inv_0_0_q_0*tmp_kernel_op_44 + jac_blending_inv_0_1_q_0*tmp_kernel_op_45 + jac_blending_inv_0_2_q_0*tmp_kernel_op_46;
             const real_t tmp_kernel_op_48 = jac_blending_inv_1_0_q_0*tmp_kernel_op_44 + jac_blending_inv_1_1_q_0*tmp_kernel_op_45 + jac_blending_inv_1_2_q_0*tmp_kernel_op_46;
             const real_t tmp_kernel_op_49 = jac_blending_inv_2_0_q_0*tmp_kernel_op_44 + jac_blending_inv_2_1_q_0*tmp_kernel_op_45 + jac_blending_inv_2_2_q_0*tmp_kernel_op_46;
             const real_t tmp_kernel_op_50 = -hessian_blending_0_0_0_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_0_1_0_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_0_2_0_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_51 = -hessian_blending_0_0_1_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_0_1_1_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_0_2_1_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_52 = -hessian_blending_0_0_2_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_0_1_2_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_0_2_2_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_53 = jac_blending_inv_0_0_q_0*tmp_kernel_op_50 + jac_blending_inv_0_1_q_0*tmp_kernel_op_51 + jac_blending_inv_0_2_q_0*tmp_kernel_op_52;
             const real_t tmp_kernel_op_54 = jac_blending_inv_1_0_q_0*tmp_kernel_op_50 + jac_blending_inv_1_1_q_0*tmp_kernel_op_51 + jac_blending_inv_1_2_q_0*tmp_kernel_op_52;
             const real_t tmp_kernel_op_55 = jac_blending_inv_2_0_q_0*tmp_kernel_op_50 + jac_blending_inv_2_1_q_0*tmp_kernel_op_51 + jac_blending_inv_2_2_q_0*tmp_kernel_op_52;
             const real_t tmp_kernel_op_56 = -hessian_blending_1_0_0_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_1_1_0_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_1_2_0_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_57 = -hessian_blending_1_0_1_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_1_1_1_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_1_2_1_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_58 = -hessian_blending_1_0_2_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_1_1_2_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_1_2_2_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_59 = jac_blending_inv_0_0_q_0*tmp_kernel_op_56 + jac_blending_inv_0_1_q_0*tmp_kernel_op_57 + jac_blending_inv_0_2_q_0*tmp_kernel_op_58;
             const real_t tmp_kernel_op_60 = jac_blending_inv_1_0_q_0*tmp_kernel_op_56 + jac_blending_inv_1_1_q_0*tmp_kernel_op_57 + jac_blending_inv_1_2_q_0*tmp_kernel_op_58;
             const real_t tmp_kernel_op_61 = jac_blending_inv_2_0_q_0*tmp_kernel_op_56 + jac_blending_inv_2_1_q_0*tmp_kernel_op_57 + jac_blending_inv_2_2_q_0*tmp_kernel_op_58;
             const real_t tmp_kernel_op_62 = -hessian_blending_2_0_0_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_2_1_0_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_2_2_0_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_63 = -hessian_blending_2_0_1_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_2_1_1_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_2_2_1_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_64 = -hessian_blending_2_0_2_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_2_1_2_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_2_2_2_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_65 = jac_blending_inv_0_0_q_0*tmp_kernel_op_62 + jac_blending_inv_0_1_q_0*tmp_kernel_op_63 + jac_blending_inv_0_2_q_0*tmp_kernel_op_64;
             const real_t tmp_kernel_op_66 = jac_blending_inv_1_0_q_0*tmp_kernel_op_62 + jac_blending_inv_1_1_q_0*tmp_kernel_op_63 + jac_blending_inv_1_2_q_0*tmp_kernel_op_64;
             const real_t tmp_kernel_op_67 = jac_blending_inv_2_0_q_0*tmp_kernel_op_62 + jac_blending_inv_2_1_q_0*tmp_kernel_op_63 + jac_blending_inv_2_2_q_0*tmp_kernel_op_64;
             const real_t tmp_kernel_op_68 = -hessian_blending_0_0_0_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_0_1_0_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_0_2_0_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_69 = -hessian_blending_0_0_1_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_0_1_1_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_0_2_1_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_70 = -hessian_blending_0_0_2_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_0_1_2_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_0_2_2_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_71 = jac_blending_inv_0_0_q_0*tmp_kernel_op_68 + jac_blending_inv_0_1_q_0*tmp_kernel_op_69 + jac_blending_inv_0_2_q_0*tmp_kernel_op_70;
             const real_t tmp_kernel_op_72 = jac_blending_inv_1_0_q_0*tmp_kernel_op_68 + jac_blending_inv_1_1_q_0*tmp_kernel_op_69 + jac_blending_inv_1_2_q_0*tmp_kernel_op_70;
             const real_t tmp_kernel_op_73 = jac_blending_inv_2_0_q_0*tmp_kernel_op_68 + jac_blending_inv_2_1_q_0*tmp_kernel_op_69 + jac_blending_inv_2_2_q_0*tmp_kernel_op_70;
             const real_t tmp_kernel_op_74 = -hessian_blending_1_0_0_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_1_1_0_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_1_2_0_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_75 = -hessian_blending_1_0_1_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_1_1_1_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_1_2_1_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_76 = -hessian_blending_1_0_2_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_1_1_2_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_1_2_2_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_77 = jac_blending_inv_0_0_q_0*tmp_kernel_op_74 + jac_blending_inv_0_1_q_0*tmp_kernel_op_75 + jac_blending_inv_0_2_q_0*tmp_kernel_op_76;
             const real_t tmp_kernel_op_78 = jac_blending_inv_1_0_q_0*tmp_kernel_op_74 + jac_blending_inv_1_1_q_0*tmp_kernel_op_75 + jac_blending_inv_1_2_q_0*tmp_kernel_op_76;
             const real_t tmp_kernel_op_79 = jac_blending_inv_2_0_q_0*tmp_kernel_op_74 + jac_blending_inv_2_1_q_0*tmp_kernel_op_75 + jac_blending_inv_2_2_q_0*tmp_kernel_op_76;
             const real_t tmp_kernel_op_80 = -hessian_blending_2_0_0_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_2_1_0_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_2_2_0_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_81 = -hessian_blending_2_0_1_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_2_1_1_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_2_2_1_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_82 = -hessian_blending_2_0_2_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_2_1_2_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_2_2_2_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_83 = jac_blending_inv_0_0_q_0*tmp_kernel_op_80 + jac_blending_inv_0_1_q_0*tmp_kernel_op_81 + jac_blending_inv_0_2_q_0*tmp_kernel_op_82;
             const real_t tmp_kernel_op_84 = jac_blending_inv_1_0_q_0*tmp_kernel_op_80 + jac_blending_inv_1_1_q_0*tmp_kernel_op_81 + jac_blending_inv_1_2_q_0*tmp_kernel_op_82;
             const real_t tmp_kernel_op_85 = jac_blending_inv_2_0_q_0*tmp_kernel_op_80 + jac_blending_inv_2_1_q_0*tmp_kernel_op_81 + jac_blending_inv_2_2_q_0*tmp_kernel_op_82;
             const real_t tmp_kernel_op_86 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1112 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1118 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1124) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1131 + tmp_kernel_op_35*tmp_moved_constant_1132 + tmp_kernel_op_37*tmp_moved_constant_1133) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1112 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1118 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1124) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1131 + tmp_kernel_op_42*tmp_moved_constant_1132 + tmp_kernel_op_43*tmp_moved_constant_1133) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1112 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1118 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1124) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1131 + tmp_kernel_op_48*tmp_moved_constant_1132 + tmp_kernel_op_49*tmp_moved_constant_1133) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1125 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1126 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1127) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1131 + tmp_kernel_op_54*tmp_moved_constant_1132 + tmp_kernel_op_55*tmp_moved_constant_1133) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1125 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1126 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1127) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1131 + tmp_kernel_op_60*tmp_moved_constant_1132 + tmp_kernel_op_61*tmp_moved_constant_1133) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1125 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1126 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1127) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1131 + tmp_kernel_op_66*tmp_moved_constant_1132 + tmp_kernel_op_67*tmp_moved_constant_1133) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1128 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1129 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1130) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1131 + tmp_kernel_op_72*tmp_moved_constant_1132 + tmp_kernel_op_73*tmp_moved_constant_1133) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1128 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1129 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1130) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1131 + tmp_kernel_op_78*tmp_moved_constant_1132 + tmp_kernel_op_79*tmp_moved_constant_1133) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1128 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1129 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1130) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1131 + tmp_kernel_op_84*tmp_moved_constant_1132 + tmp_kernel_op_85*tmp_moved_constant_1133);
             const real_t tmp_kernel_op_104 = tmp_kernel_op_100*wx_dof_8 + tmp_kernel_op_102*wx_dof_9 + tmp_kernel_op_103*wx_dof_0 + tmp_kernel_op_87*wx_dof_4 + tmp_kernel_op_88*wx_dof_5 + tmp_kernel_op_89*wx_dof_6 + tmp_kernel_op_92*wx_dof_1 + tmp_kernel_op_95*wx_dof_2 + tmp_kernel_op_98*wx_dof_3 + tmp_kernel_op_99*wx_dof_7;
             const real_t tmp_kernel_op_105 = tmp_kernel_op_100*wy_dof_8 + tmp_kernel_op_102*wy_dof_9 + tmp_kernel_op_103*wy_dof_0 + tmp_kernel_op_87*wy_dof_4 + tmp_kernel_op_88*wy_dof_5 + tmp_kernel_op_89*wy_dof_6 + tmp_kernel_op_92*wy_dof_1 + tmp_kernel_op_95*wy_dof_2 + tmp_kernel_op_98*wy_dof_3 + tmp_kernel_op_99*wy_dof_7;
             const real_t tmp_kernel_op_106 = tmp_kernel_op_100*wz_dof_8 + tmp_kernel_op_102*wz_dof_9 + tmp_kernel_op_103*wz_dof_0 + tmp_kernel_op_87*wz_dof_4 + tmp_kernel_op_88*wz_dof_5 + tmp_kernel_op_89*wz_dof_6 + tmp_kernel_op_92*wz_dof_1 + tmp_kernel_op_95*wz_dof_2 + tmp_kernel_op_98*wz_dof_3 + tmp_kernel_op_99*wz_dof_7;
             const real_t tmp_kernel_op_107 = abs_det_jac_affine_GREEN_UP*abs_det_jac_blending_q_0*(diffusivity_times_delta_dof_0*tmp_kernel_op_103 + diffusivity_times_delta_dof_1*tmp_kernel_op_92 + diffusivity_times_delta_dof_2*tmp_kernel_op_95 + diffusivity_times_delta_dof_3*tmp_kernel_op_98 + diffusivity_times_delta_dof_4*tmp_kernel_op_87 + diffusivity_times_delta_dof_5*tmp_kernel_op_88 + diffusivity_times_delta_dof_6*tmp_kernel_op_89 + diffusivity_times_delta_dof_7*tmp_kernel_op_99 + diffusivity_times_delta_dof_8*tmp_kernel_op_100 + diffusivity_times_delta_dof_9*tmp_kernel_op_102)*-0.1333333333333333;
             const real_t tmp_kernel_op_108 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1131 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1132 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1133) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1131 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1132 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1133) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1131 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1132 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1133));
             const real_t tmp_kernel_op_115 = -hessian_blending_0_0_0_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_0_1_0_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_0_2_0_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_116 = -hessian_blending_0_0_1_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_0_1_1_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_0_2_1_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_117 = -hessian_blending_0_0_2_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_0_1_2_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_0_2_2_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_118 = jac_blending_inv_0_0_q_1*tmp_kernel_op_115 + jac_blending_inv_0_1_q_1*tmp_kernel_op_116 + jac_blending_inv_0_2_q_1*tmp_kernel_op_117;
             const real_t tmp_kernel_op_120 = jac_blending_inv_1_0_q_1*tmp_kernel_op_115 + jac_blending_inv_1_1_q_1*tmp_kernel_op_116 + jac_blending_inv_1_2_q_1*tmp_kernel_op_117;
             const real_t tmp_kernel_op_122 = jac_blending_inv_2_0_q_1*tmp_kernel_op_115 + jac_blending_inv_2_1_q_1*tmp_kernel_op_116 + jac_blending_inv_2_2_q_1*tmp_kernel_op_117;
             const real_t tmp_kernel_op_123 = -hessian_blending_1_0_0_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_1_1_0_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_1_2_0_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_124 = -hessian_blending_1_0_1_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_1_1_1_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_1_2_1_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_125 = -hessian_blending_1_0_2_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_1_1_2_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_1_2_2_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_126 = jac_blending_inv_0_0_q_1*tmp_kernel_op_123 + jac_blending_inv_0_1_q_1*tmp_kernel_op_124 + jac_blending_inv_0_2_q_1*tmp_kernel_op_125;
             const real_t tmp_kernel_op_127 = jac_blending_inv_1_0_q_1*tmp_kernel_op_123 + jac_blending_inv_1_1_q_1*tmp_kernel_op_124 + jac_blending_inv_1_2_q_1*tmp_kernel_op_125;
             const real_t tmp_kernel_op_128 = jac_blending_inv_2_0_q_1*tmp_kernel_op_123 + jac_blending_inv_2_1_q_1*tmp_kernel_op_124 + jac_blending_inv_2_2_q_1*tmp_kernel_op_125;
             const real_t tmp_kernel_op_129 = -hessian_blending_2_0_0_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_2_1_0_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_2_2_0_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_130 = -hessian_blending_2_0_1_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_2_1_1_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_2_2_1_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_131 = -hessian_blending_2_0_2_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_2_1_2_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_2_2_2_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_132 = jac_blending_inv_0_0_q_1*tmp_kernel_op_129 + jac_blending_inv_0_1_q_1*tmp_kernel_op_130 + jac_blending_inv_0_2_q_1*tmp_kernel_op_131;
             const real_t tmp_kernel_op_133 = jac_blending_inv_1_0_q_1*tmp_kernel_op_129 + jac_blending_inv_1_1_q_1*tmp_kernel_op_130 + jac_blending_inv_1_2_q_1*tmp_kernel_op_131;
             const real_t tmp_kernel_op_134 = jac_blending_inv_2_0_q_1*tmp_kernel_op_129 + jac_blending_inv_2_1_q_1*tmp_kernel_op_130 + jac_blending_inv_2_2_q_1*tmp_kernel_op_131;
             const real_t tmp_kernel_op_135 = -hessian_blending_0_0_0_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_0_1_0_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_0_2_0_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_136 = -hessian_blending_0_0_1_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_0_1_1_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_0_2_1_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_137 = -hessian_blending_0_0_2_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_0_1_2_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_0_2_2_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_138 = jac_blending_inv_0_0_q_1*tmp_kernel_op_135 + jac_blending_inv_0_1_q_1*tmp_kernel_op_136 + jac_blending_inv_0_2_q_1*tmp_kernel_op_137;
             const real_t tmp_kernel_op_139 = jac_blending_inv_1_0_q_1*tmp_kernel_op_135 + jac_blending_inv_1_1_q_1*tmp_kernel_op_136 + jac_blending_inv_1_2_q_1*tmp_kernel_op_137;
             const real_t tmp_kernel_op_140 = jac_blending_inv_2_0_q_1*tmp_kernel_op_135 + jac_blending_inv_2_1_q_1*tmp_kernel_op_136 + jac_blending_inv_2_2_q_1*tmp_kernel_op_137;
             const real_t tmp_kernel_op_141 = -hessian_blending_1_0_0_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_1_1_0_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_1_2_0_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_142 = -hessian_blending_1_0_1_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_1_1_1_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_1_2_1_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_143 = -hessian_blending_1_0_2_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_1_1_2_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_1_2_2_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_144 = jac_blending_inv_0_0_q_1*tmp_kernel_op_141 + jac_blending_inv_0_1_q_1*tmp_kernel_op_142 + jac_blending_inv_0_2_q_1*tmp_kernel_op_143;
             const real_t tmp_kernel_op_145 = jac_blending_inv_1_0_q_1*tmp_kernel_op_141 + jac_blending_inv_1_1_q_1*tmp_kernel_op_142 + jac_blending_inv_1_2_q_1*tmp_kernel_op_143;
             const real_t tmp_kernel_op_146 = jac_blending_inv_2_0_q_1*tmp_kernel_op_141 + jac_blending_inv_2_1_q_1*tmp_kernel_op_142 + jac_blending_inv_2_2_q_1*tmp_kernel_op_143;
             const real_t tmp_kernel_op_147 = -hessian_blending_2_0_0_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_2_1_0_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_2_2_0_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_148 = -hessian_blending_2_0_1_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_2_1_1_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_2_2_1_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_149 = -hessian_blending_2_0_2_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_2_1_2_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_2_2_2_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_150 = jac_blending_inv_0_0_q_1*tmp_kernel_op_147 + jac_blending_inv_0_1_q_1*tmp_kernel_op_148 + jac_blending_inv_0_2_q_1*tmp_kernel_op_149;
             const real_t tmp_kernel_op_151 = jac_blending_inv_1_0_q_1*tmp_kernel_op_147 + jac_blending_inv_1_1_q_1*tmp_kernel_op_148 + jac_blending_inv_1_2_q_1*tmp_kernel_op_149;
             const real_t tmp_kernel_op_152 = jac_blending_inv_2_0_q_1*tmp_kernel_op_147 + jac_blending_inv_2_1_q_1*tmp_kernel_op_148 + jac_blending_inv_2_2_q_1*tmp_kernel_op_149;
             const real_t tmp_kernel_op_153 = -hessian_blending_0_0_0_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_0_1_0_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_0_2_0_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_154 = -hessian_blending_0_0_1_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_0_1_1_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_0_2_1_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_155 = -hessian_blending_0_0_2_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_0_1_2_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_0_2_2_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_156 = jac_blending_inv_0_0_q_1*tmp_kernel_op_153 + jac_blending_inv_0_1_q_1*tmp_kernel_op_154 + jac_blending_inv_0_2_q_1*tmp_kernel_op_155;
             const real_t tmp_kernel_op_157 = jac_blending_inv_1_0_q_1*tmp_kernel_op_153 + jac_blending_inv_1_1_q_1*tmp_kernel_op_154 + jac_blending_inv_1_2_q_1*tmp_kernel_op_155;
             const real_t tmp_kernel_op_158 = jac_blending_inv_2_0_q_1*tmp_kernel_op_153 + jac_blending_inv_2_1_q_1*tmp_kernel_op_154 + jac_blending_inv_2_2_q_1*tmp_kernel_op_155;
             const real_t tmp_kernel_op_159 = -hessian_blending_1_0_0_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_1_1_0_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_1_2_0_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_160 = -hessian_blending_1_0_1_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_1_1_1_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_1_2_1_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_161 = -hessian_blending_1_0_2_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_1_1_2_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_1_2_2_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_162 = jac_blending_inv_0_0_q_1*tmp_kernel_op_159 + jac_blending_inv_0_1_q_1*tmp_kernel_op_160 + jac_blending_inv_0_2_q_1*tmp_kernel_op_161;
             const real_t tmp_kernel_op_163 = jac_blending_inv_1_0_q_1*tmp_kernel_op_159 + jac_blending_inv_1_1_q_1*tmp_kernel_op_160 + jac_blending_inv_1_2_q_1*tmp_kernel_op_161;
             const real_t tmp_kernel_op_164 = jac_blending_inv_2_0_q_1*tmp_kernel_op_159 + jac_blending_inv_2_1_q_1*tmp_kernel_op_160 + jac_blending_inv_2_2_q_1*tmp_kernel_op_161;
             const real_t tmp_kernel_op_165 = -hessian_blending_2_0_0_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_2_1_0_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_2_2_0_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_166 = -hessian_blending_2_0_1_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_2_1_1_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_2_2_1_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_167 = -hessian_blending_2_0_2_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_2_1_2_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_2_2_2_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_168 = jac_blending_inv_0_0_q_1*tmp_kernel_op_165 + jac_blending_inv_0_1_q_1*tmp_kernel_op_166 + jac_blending_inv_0_2_q_1*tmp_kernel_op_167;
             const real_t tmp_kernel_op_169 = jac_blending_inv_1_0_q_1*tmp_kernel_op_165 + jac_blending_inv_1_1_q_1*tmp_kernel_op_166 + jac_blending_inv_1_2_q_1*tmp_kernel_op_167;
             const real_t tmp_kernel_op_170 = jac_blending_inv_2_0_q_1*tmp_kernel_op_165 + jac_blending_inv_2_1_q_1*tmp_kernel_op_166 + jac_blending_inv_2_2_q_1*tmp_kernel_op_167;
             const real_t tmp_kernel_op_171 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1112 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1118 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1124) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1134 + tmp_kernel_op_120*tmp_moved_constant_1135 + tmp_kernel_op_122*tmp_moved_constant_1136) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1112 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1118 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1124) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1134 + tmp_kernel_op_127*tmp_moved_constant_1135 + tmp_kernel_op_128*tmp_moved_constant_1136) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1112 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1118 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1124) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1134 + tmp_kernel_op_133*tmp_moved_constant_1135 + tmp_kernel_op_134*tmp_moved_constant_1136) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1125 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1126 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1127) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1134 + tmp_kernel_op_139*tmp_moved_constant_1135 + tmp_kernel_op_140*tmp_moved_constant_1136) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1125 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1126 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1127) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1134 + tmp_kernel_op_145*tmp_moved_constant_1135 + tmp_kernel_op_146*tmp_moved_constant_1136) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1125 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1126 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1127) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1134 + tmp_kernel_op_151*tmp_moved_constant_1135 + tmp_kernel_op_152*tmp_moved_constant_1136) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1128 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1129 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1130) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1134 + tmp_kernel_op_157*tmp_moved_constant_1135 + tmp_kernel_op_158*tmp_moved_constant_1136) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1128 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1129 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1130) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1134 + tmp_kernel_op_163*tmp_moved_constant_1135 + tmp_kernel_op_164*tmp_moved_constant_1136) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1128 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1129 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1130) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1134 + tmp_kernel_op_169*tmp_moved_constant_1135 + tmp_kernel_op_170*tmp_moved_constant_1136);
             const real_t tmp_kernel_op_189 = tmp_kernel_op_172*wx_dof_4 + tmp_kernel_op_173*wx_dof_5 + tmp_kernel_op_174*wx_dof_6 + tmp_kernel_op_177*wx_dof_1 + tmp_kernel_op_180*wx_dof_2 + tmp_kernel_op_183*wx_dof_3 + tmp_kernel_op_184*wx_dof_7 + tmp_kernel_op_185*wx_dof_8 + tmp_kernel_op_187*wx_dof_9 + tmp_kernel_op_188*wx_dof_0;
             const real_t tmp_kernel_op_190 = tmp_kernel_op_172*wy_dof_4 + tmp_kernel_op_173*wy_dof_5 + tmp_kernel_op_174*wy_dof_6 + tmp_kernel_op_177*wy_dof_1 + tmp_kernel_op_180*wy_dof_2 + tmp_kernel_op_183*wy_dof_3 + tmp_kernel_op_184*wy_dof_7 + tmp_kernel_op_185*wy_dof_8 + tmp_kernel_op_187*wy_dof_9 + tmp_kernel_op_188*wy_dof_0;
             const real_t tmp_kernel_op_191 = tmp_kernel_op_172*wz_dof_4 + tmp_kernel_op_173*wz_dof_5 + tmp_kernel_op_174*wz_dof_6 + tmp_kernel_op_177*wz_dof_1 + tmp_kernel_op_180*wz_dof_2 + tmp_kernel_op_183*wz_dof_3 + tmp_kernel_op_184*wz_dof_7 + tmp_kernel_op_185*wz_dof_8 + tmp_kernel_op_187*wz_dof_9 + tmp_kernel_op_188*wz_dof_0;
             const real_t tmp_kernel_op_192 = abs_det_jac_affine_GREEN_UP*abs_det_jac_blending_q_1*(diffusivity_times_delta_dof_0*tmp_kernel_op_188 + diffusivity_times_delta_dof_1*tmp_kernel_op_177 + diffusivity_times_delta_dof_2*tmp_kernel_op_180 + diffusivity_times_delta_dof_3*tmp_kernel_op_183 + diffusivity_times_delta_dof_4*tmp_kernel_op_172 + diffusivity_times_delta_dof_5*tmp_kernel_op_173 + diffusivity_times_delta_dof_6*tmp_kernel_op_174 + diffusivity_times_delta_dof_7*tmp_kernel_op_184 + diffusivity_times_delta_dof_8*tmp_kernel_op_185 + diffusivity_times_delta_dof_9*tmp_kernel_op_187)*0.074999999999999983;
             const real_t tmp_kernel_op_193 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1134 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1135 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1136) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1134 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1135 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1136) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1134 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1135 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1136));
             const real_t tmp_kernel_op_200 = -hessian_blending_0_0_0_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_0_1_0_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_0_2_0_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_201 = -hessian_blending_0_0_1_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_0_1_1_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_0_2_1_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_202 = -hessian_blending_0_0_2_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_0_1_2_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_0_2_2_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_203 = jac_blending_inv_0_0_q_2*tmp_kernel_op_200 + jac_blending_inv_0_1_q_2*tmp_kernel_op_201 + jac_blending_inv_0_2_q_2*tmp_kernel_op_202;
             const real_t tmp_kernel_op_205 = jac_blending_inv_1_0_q_2*tmp_kernel_op_200 + jac_blending_inv_1_1_q_2*tmp_kernel_op_201 + jac_blending_inv_1_2_q_2*tmp_kernel_op_202;
             const real_t tmp_kernel_op_207 = jac_blending_inv_2_0_q_2*tmp_kernel_op_200 + jac_blending_inv_2_1_q_2*tmp_kernel_op_201 + jac_blending_inv_2_2_q_2*tmp_kernel_op_202;
             const real_t tmp_kernel_op_208 = -hessian_blending_1_0_0_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_1_1_0_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_1_2_0_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_209 = -hessian_blending_1_0_1_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_1_1_1_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_1_2_1_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_210 = -hessian_blending_1_0_2_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_1_1_2_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_1_2_2_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_211 = jac_blending_inv_0_0_q_2*tmp_kernel_op_208 + jac_blending_inv_0_1_q_2*tmp_kernel_op_209 + jac_blending_inv_0_2_q_2*tmp_kernel_op_210;
             const real_t tmp_kernel_op_212 = jac_blending_inv_1_0_q_2*tmp_kernel_op_208 + jac_blending_inv_1_1_q_2*tmp_kernel_op_209 + jac_blending_inv_1_2_q_2*tmp_kernel_op_210;
             const real_t tmp_kernel_op_213 = jac_blending_inv_2_0_q_2*tmp_kernel_op_208 + jac_blending_inv_2_1_q_2*tmp_kernel_op_209 + jac_blending_inv_2_2_q_2*tmp_kernel_op_210;
             const real_t tmp_kernel_op_214 = -hessian_blending_2_0_0_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_2_1_0_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_2_2_0_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_215 = -hessian_blending_2_0_1_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_2_1_1_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_2_2_1_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_216 = -hessian_blending_2_0_2_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_2_1_2_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_2_2_2_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_217 = jac_blending_inv_0_0_q_2*tmp_kernel_op_214 + jac_blending_inv_0_1_q_2*tmp_kernel_op_215 + jac_blending_inv_0_2_q_2*tmp_kernel_op_216;
             const real_t tmp_kernel_op_218 = jac_blending_inv_1_0_q_2*tmp_kernel_op_214 + jac_blending_inv_1_1_q_2*tmp_kernel_op_215 + jac_blending_inv_1_2_q_2*tmp_kernel_op_216;
             const real_t tmp_kernel_op_219 = jac_blending_inv_2_0_q_2*tmp_kernel_op_214 + jac_blending_inv_2_1_q_2*tmp_kernel_op_215 + jac_blending_inv_2_2_q_2*tmp_kernel_op_216;
             const real_t tmp_kernel_op_220 = -hessian_blending_0_0_0_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_0_1_0_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_0_2_0_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_221 = -hessian_blending_0_0_1_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_0_1_1_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_0_2_1_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_222 = -hessian_blending_0_0_2_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_0_1_2_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_0_2_2_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_223 = jac_blending_inv_0_0_q_2*tmp_kernel_op_220 + jac_blending_inv_0_1_q_2*tmp_kernel_op_221 + jac_blending_inv_0_2_q_2*tmp_kernel_op_222;
             const real_t tmp_kernel_op_224 = jac_blending_inv_1_0_q_2*tmp_kernel_op_220 + jac_blending_inv_1_1_q_2*tmp_kernel_op_221 + jac_blending_inv_1_2_q_2*tmp_kernel_op_222;
             const real_t tmp_kernel_op_225 = jac_blending_inv_2_0_q_2*tmp_kernel_op_220 + jac_blending_inv_2_1_q_2*tmp_kernel_op_221 + jac_blending_inv_2_2_q_2*tmp_kernel_op_222;
             const real_t tmp_kernel_op_226 = -hessian_blending_1_0_0_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_1_1_0_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_1_2_0_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_227 = -hessian_blending_1_0_1_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_1_1_1_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_1_2_1_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_228 = -hessian_blending_1_0_2_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_1_1_2_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_1_2_2_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_229 = jac_blending_inv_0_0_q_2*tmp_kernel_op_226 + jac_blending_inv_0_1_q_2*tmp_kernel_op_227 + jac_blending_inv_0_2_q_2*tmp_kernel_op_228;
             const real_t tmp_kernel_op_230 = jac_blending_inv_1_0_q_2*tmp_kernel_op_226 + jac_blending_inv_1_1_q_2*tmp_kernel_op_227 + jac_blending_inv_1_2_q_2*tmp_kernel_op_228;
             const real_t tmp_kernel_op_231 = jac_blending_inv_2_0_q_2*tmp_kernel_op_226 + jac_blending_inv_2_1_q_2*tmp_kernel_op_227 + jac_blending_inv_2_2_q_2*tmp_kernel_op_228;
             const real_t tmp_kernel_op_232 = -hessian_blending_2_0_0_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_2_1_0_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_2_2_0_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_233 = -hessian_blending_2_0_1_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_2_1_1_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_2_2_1_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_234 = -hessian_blending_2_0_2_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_2_1_2_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_2_2_2_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_235 = jac_blending_inv_0_0_q_2*tmp_kernel_op_232 + jac_blending_inv_0_1_q_2*tmp_kernel_op_233 + jac_blending_inv_0_2_q_2*tmp_kernel_op_234;
             const real_t tmp_kernel_op_236 = jac_blending_inv_1_0_q_2*tmp_kernel_op_232 + jac_blending_inv_1_1_q_2*tmp_kernel_op_233 + jac_blending_inv_1_2_q_2*tmp_kernel_op_234;
             const real_t tmp_kernel_op_237 = jac_blending_inv_2_0_q_2*tmp_kernel_op_232 + jac_blending_inv_2_1_q_2*tmp_kernel_op_233 + jac_blending_inv_2_2_q_2*tmp_kernel_op_234;
             const real_t tmp_kernel_op_238 = -hessian_blending_0_0_0_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_0_1_0_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_0_2_0_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_239 = -hessian_blending_0_0_1_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_0_1_1_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_0_2_1_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_240 = -hessian_blending_0_0_2_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_0_1_2_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_0_2_2_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_241 = jac_blending_inv_0_0_q_2*tmp_kernel_op_238 + jac_blending_inv_0_1_q_2*tmp_kernel_op_239 + jac_blending_inv_0_2_q_2*tmp_kernel_op_240;
             const real_t tmp_kernel_op_242 = jac_blending_inv_1_0_q_2*tmp_kernel_op_238 + jac_blending_inv_1_1_q_2*tmp_kernel_op_239 + jac_blending_inv_1_2_q_2*tmp_kernel_op_240;
             const real_t tmp_kernel_op_243 = jac_blending_inv_2_0_q_2*tmp_kernel_op_238 + jac_blending_inv_2_1_q_2*tmp_kernel_op_239 + jac_blending_inv_2_2_q_2*tmp_kernel_op_240;
             const real_t tmp_kernel_op_244 = -hessian_blending_1_0_0_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_1_1_0_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_1_2_0_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_245 = -hessian_blending_1_0_1_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_1_1_1_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_1_2_1_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_246 = -hessian_blending_1_0_2_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_1_1_2_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_1_2_2_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_247 = jac_blending_inv_0_0_q_2*tmp_kernel_op_244 + jac_blending_inv_0_1_q_2*tmp_kernel_op_245 + jac_blending_inv_0_2_q_2*tmp_kernel_op_246;
             const real_t tmp_kernel_op_248 = jac_blending_inv_1_0_q_2*tmp_kernel_op_244 + jac_blending_inv_1_1_q_2*tmp_kernel_op_245 + jac_blending_inv_1_2_q_2*tmp_kernel_op_246;
             const real_t tmp_kernel_op_249 = jac_blending_inv_2_0_q_2*tmp_kernel_op_244 + jac_blending_inv_2_1_q_2*tmp_kernel_op_245 + jac_blending_inv_2_2_q_2*tmp_kernel_op_246;
             const real_t tmp_kernel_op_250 = -hessian_blending_2_0_0_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_2_1_0_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_2_2_0_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_251 = -hessian_blending_2_0_1_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_2_1_1_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_2_2_1_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_252 = -hessian_blending_2_0_2_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_2_1_2_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_2_2_2_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_253 = jac_blending_inv_0_0_q_2*tmp_kernel_op_250 + jac_blending_inv_0_1_q_2*tmp_kernel_op_251 + jac_blending_inv_0_2_q_2*tmp_kernel_op_252;
             const real_t tmp_kernel_op_254 = jac_blending_inv_1_0_q_2*tmp_kernel_op_250 + jac_blending_inv_1_1_q_2*tmp_kernel_op_251 + jac_blending_inv_1_2_q_2*tmp_kernel_op_252;
             const real_t tmp_kernel_op_255 = jac_blending_inv_2_0_q_2*tmp_kernel_op_250 + jac_blending_inv_2_1_q_2*tmp_kernel_op_251 + jac_blending_inv_2_2_q_2*tmp_kernel_op_252;
             const real_t tmp_kernel_op_256 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1112 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1118 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1124) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1137 + tmp_kernel_op_205*tmp_moved_constant_1138 + tmp_kernel_op_207*tmp_moved_constant_1139) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1112 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1118 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1124) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1137 + tmp_kernel_op_212*tmp_moved_constant_1138 + tmp_kernel_op_213*tmp_moved_constant_1139) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1112 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1118 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1124) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1137 + tmp_kernel_op_218*tmp_moved_constant_1138 + tmp_kernel_op_219*tmp_moved_constant_1139) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1125 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1126 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1127) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1137 + tmp_kernel_op_224*tmp_moved_constant_1138 + tmp_kernel_op_225*tmp_moved_constant_1139) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1125 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1126 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1127) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1137 + tmp_kernel_op_230*tmp_moved_constant_1138 + tmp_kernel_op_231*tmp_moved_constant_1139) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1125 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1126 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1127) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1137 + tmp_kernel_op_236*tmp_moved_constant_1138 + tmp_kernel_op_237*tmp_moved_constant_1139) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1128 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1129 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1130) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1137 + tmp_kernel_op_242*tmp_moved_constant_1138 + tmp_kernel_op_243*tmp_moved_constant_1139) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1128 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1129 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1130) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1137 + tmp_kernel_op_248*tmp_moved_constant_1138 + tmp_kernel_op_249*tmp_moved_constant_1139) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1128 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1129 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1130) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1137 + tmp_kernel_op_254*tmp_moved_constant_1138 + tmp_kernel_op_255*tmp_moved_constant_1139);
             const real_t tmp_kernel_op_274 = tmp_kernel_op_257*wx_dof_4 + tmp_kernel_op_258*wx_dof_5 + tmp_kernel_op_259*wx_dof_6 + tmp_kernel_op_262*wx_dof_1 + tmp_kernel_op_265*wx_dof_2 + tmp_kernel_op_268*wx_dof_3 + tmp_kernel_op_269*wx_dof_7 + tmp_kernel_op_270*wx_dof_8 + tmp_kernel_op_272*wx_dof_9 + tmp_kernel_op_273*wx_dof_0;
             const real_t tmp_kernel_op_275 = tmp_kernel_op_257*wy_dof_4 + tmp_kernel_op_258*wy_dof_5 + tmp_kernel_op_259*wy_dof_6 + tmp_kernel_op_262*wy_dof_1 + tmp_kernel_op_265*wy_dof_2 + tmp_kernel_op_268*wy_dof_3 + tmp_kernel_op_269*wy_dof_7 + tmp_kernel_op_270*wy_dof_8 + tmp_kernel_op_272*wy_dof_9 + tmp_kernel_op_273*wy_dof_0;
             const real_t tmp_kernel_op_276 = tmp_kernel_op_257*wz_dof_4 + tmp_kernel_op_258*wz_dof_5 + tmp_kernel_op_259*wz_dof_6 + tmp_kernel_op_262*wz_dof_1 + tmp_kernel_op_265*wz_dof_2 + tmp_kernel_op_268*wz_dof_3 + tmp_kernel_op_269*wz_dof_7 + tmp_kernel_op_270*wz_dof_8 + tmp_kernel_op_272*wz_dof_9 + tmp_kernel_op_273*wz_dof_0;
             const real_t tmp_kernel_op_277 = abs_det_jac_affine_GREEN_UP*abs_det_jac_blending_q_2*(diffusivity_times_delta_dof_0*tmp_kernel_op_273 + diffusivity_times_delta_dof_1*tmp_kernel_op_262 + diffusivity_times_delta_dof_2*tmp_kernel_op_265 + diffusivity_times_delta_dof_3*tmp_kernel_op_268 + diffusivity_times_delta_dof_4*tmp_kernel_op_257 + diffusivity_times_delta_dof_5*tmp_kernel_op_258 + diffusivity_times_delta_dof_6*tmp_kernel_op_259 + diffusivity_times_delta_dof_7*tmp_kernel_op_269 + diffusivity_times_delta_dof_8*tmp_kernel_op_270 + diffusivity_times_delta_dof_9*tmp_kernel_op_272)*0.074999999999999983;
             const real_t tmp_kernel_op_278 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1137 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1138 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1139) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1137 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1138 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1139) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1137 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1138 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1139));
             const real_t tmp_kernel_op_285 = -hessian_blending_0_0_0_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_0_1_0_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_0_2_0_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_286 = -hessian_blending_0_0_1_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_0_1_1_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_0_2_1_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_287 = -hessian_blending_0_0_2_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_0_1_2_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_0_2_2_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_288 = jac_blending_inv_0_0_q_3*tmp_kernel_op_285 + jac_blending_inv_0_1_q_3*tmp_kernel_op_286 + jac_blending_inv_0_2_q_3*tmp_kernel_op_287;
             const real_t tmp_kernel_op_290 = jac_blending_inv_1_0_q_3*tmp_kernel_op_285 + jac_blending_inv_1_1_q_3*tmp_kernel_op_286 + jac_blending_inv_1_2_q_3*tmp_kernel_op_287;
             const real_t tmp_kernel_op_292 = jac_blending_inv_2_0_q_3*tmp_kernel_op_285 + jac_blending_inv_2_1_q_3*tmp_kernel_op_286 + jac_blending_inv_2_2_q_3*tmp_kernel_op_287;
             const real_t tmp_kernel_op_293 = -hessian_blending_1_0_0_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_1_1_0_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_1_2_0_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_294 = -hessian_blending_1_0_1_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_1_1_1_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_1_2_1_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_295 = -hessian_blending_1_0_2_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_1_1_2_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_1_2_2_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_296 = jac_blending_inv_0_0_q_3*tmp_kernel_op_293 + jac_blending_inv_0_1_q_3*tmp_kernel_op_294 + jac_blending_inv_0_2_q_3*tmp_kernel_op_295;
             const real_t tmp_kernel_op_297 = jac_blending_inv_1_0_q_3*tmp_kernel_op_293 + jac_blending_inv_1_1_q_3*tmp_kernel_op_294 + jac_blending_inv_1_2_q_3*tmp_kernel_op_295;
             const real_t tmp_kernel_op_298 = jac_blending_inv_2_0_q_3*tmp_kernel_op_293 + jac_blending_inv_2_1_q_3*tmp_kernel_op_294 + jac_blending_inv_2_2_q_3*tmp_kernel_op_295;
             const real_t tmp_kernel_op_299 = -hessian_blending_2_0_0_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_2_1_0_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_2_2_0_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_300 = -hessian_blending_2_0_1_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_2_1_1_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_2_2_1_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_301 = -hessian_blending_2_0_2_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_2_1_2_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_2_2_2_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_302 = jac_blending_inv_0_0_q_3*tmp_kernel_op_299 + jac_blending_inv_0_1_q_3*tmp_kernel_op_300 + jac_blending_inv_0_2_q_3*tmp_kernel_op_301;
             const real_t tmp_kernel_op_303 = jac_blending_inv_1_0_q_3*tmp_kernel_op_299 + jac_blending_inv_1_1_q_3*tmp_kernel_op_300 + jac_blending_inv_1_2_q_3*tmp_kernel_op_301;
             const real_t tmp_kernel_op_304 = jac_blending_inv_2_0_q_3*tmp_kernel_op_299 + jac_blending_inv_2_1_q_3*tmp_kernel_op_300 + jac_blending_inv_2_2_q_3*tmp_kernel_op_301;
             const real_t tmp_kernel_op_305 = -hessian_blending_0_0_0_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_0_1_0_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_0_2_0_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_306 = -hessian_blending_0_0_1_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_0_1_1_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_0_2_1_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_307 = -hessian_blending_0_0_2_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_0_1_2_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_0_2_2_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_308 = jac_blending_inv_0_0_q_3*tmp_kernel_op_305 + jac_blending_inv_0_1_q_3*tmp_kernel_op_306 + jac_blending_inv_0_2_q_3*tmp_kernel_op_307;
             const real_t tmp_kernel_op_309 = jac_blending_inv_1_0_q_3*tmp_kernel_op_305 + jac_blending_inv_1_1_q_3*tmp_kernel_op_306 + jac_blending_inv_1_2_q_3*tmp_kernel_op_307;
             const real_t tmp_kernel_op_310 = jac_blending_inv_2_0_q_3*tmp_kernel_op_305 + jac_blending_inv_2_1_q_3*tmp_kernel_op_306 + jac_blending_inv_2_2_q_3*tmp_kernel_op_307;
             const real_t tmp_kernel_op_311 = -hessian_blending_1_0_0_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_1_1_0_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_1_2_0_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_312 = -hessian_blending_1_0_1_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_1_1_1_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_1_2_1_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_313 = -hessian_blending_1_0_2_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_1_1_2_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_1_2_2_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_314 = jac_blending_inv_0_0_q_3*tmp_kernel_op_311 + jac_blending_inv_0_1_q_3*tmp_kernel_op_312 + jac_blending_inv_0_2_q_3*tmp_kernel_op_313;
             const real_t tmp_kernel_op_315 = jac_blending_inv_1_0_q_3*tmp_kernel_op_311 + jac_blending_inv_1_1_q_3*tmp_kernel_op_312 + jac_blending_inv_1_2_q_3*tmp_kernel_op_313;
             const real_t tmp_kernel_op_316 = jac_blending_inv_2_0_q_3*tmp_kernel_op_311 + jac_blending_inv_2_1_q_3*tmp_kernel_op_312 + jac_blending_inv_2_2_q_3*tmp_kernel_op_313;
             const real_t tmp_kernel_op_317 = -hessian_blending_2_0_0_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_2_1_0_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_2_2_0_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_318 = -hessian_blending_2_0_1_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_2_1_1_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_2_2_1_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_319 = -hessian_blending_2_0_2_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_2_1_2_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_2_2_2_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_320 = jac_blending_inv_0_0_q_3*tmp_kernel_op_317 + jac_blending_inv_0_1_q_3*tmp_kernel_op_318 + jac_blending_inv_0_2_q_3*tmp_kernel_op_319;
             const real_t tmp_kernel_op_321 = jac_blending_inv_1_0_q_3*tmp_kernel_op_317 + jac_blending_inv_1_1_q_3*tmp_kernel_op_318 + jac_blending_inv_1_2_q_3*tmp_kernel_op_319;
             const real_t tmp_kernel_op_322 = jac_blending_inv_2_0_q_3*tmp_kernel_op_317 + jac_blending_inv_2_1_q_3*tmp_kernel_op_318 + jac_blending_inv_2_2_q_3*tmp_kernel_op_319;
             const real_t tmp_kernel_op_323 = -hessian_blending_0_0_0_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_0_1_0_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_0_2_0_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_324 = -hessian_blending_0_0_1_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_0_1_1_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_0_2_1_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_325 = -hessian_blending_0_0_2_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_0_1_2_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_0_2_2_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_326 = jac_blending_inv_0_0_q_3*tmp_kernel_op_323 + jac_blending_inv_0_1_q_3*tmp_kernel_op_324 + jac_blending_inv_0_2_q_3*tmp_kernel_op_325;
             const real_t tmp_kernel_op_327 = jac_blending_inv_1_0_q_3*tmp_kernel_op_323 + jac_blending_inv_1_1_q_3*tmp_kernel_op_324 + jac_blending_inv_1_2_q_3*tmp_kernel_op_325;
             const real_t tmp_kernel_op_328 = jac_blending_inv_2_0_q_3*tmp_kernel_op_323 + jac_blending_inv_2_1_q_3*tmp_kernel_op_324 + jac_blending_inv_2_2_q_3*tmp_kernel_op_325;
             const real_t tmp_kernel_op_329 = -hessian_blending_1_0_0_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_1_1_0_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_1_2_0_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_330 = -hessian_blending_1_0_1_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_1_1_1_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_1_2_1_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_331 = -hessian_blending_1_0_2_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_1_1_2_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_1_2_2_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_332 = jac_blending_inv_0_0_q_3*tmp_kernel_op_329 + jac_blending_inv_0_1_q_3*tmp_kernel_op_330 + jac_blending_inv_0_2_q_3*tmp_kernel_op_331;
             const real_t tmp_kernel_op_333 = jac_blending_inv_1_0_q_3*tmp_kernel_op_329 + jac_blending_inv_1_1_q_3*tmp_kernel_op_330 + jac_blending_inv_1_2_q_3*tmp_kernel_op_331;
             const real_t tmp_kernel_op_334 = jac_blending_inv_2_0_q_3*tmp_kernel_op_329 + jac_blending_inv_2_1_q_3*tmp_kernel_op_330 + jac_blending_inv_2_2_q_3*tmp_kernel_op_331;
             const real_t tmp_kernel_op_335 = -hessian_blending_2_0_0_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_2_1_0_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_2_2_0_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_336 = -hessian_blending_2_0_1_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_2_1_1_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_2_2_1_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_337 = -hessian_blending_2_0_2_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_2_1_2_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_2_2_2_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_338 = jac_blending_inv_0_0_q_3*tmp_kernel_op_335 + jac_blending_inv_0_1_q_3*tmp_kernel_op_336 + jac_blending_inv_0_2_q_3*tmp_kernel_op_337;
             const real_t tmp_kernel_op_339 = jac_blending_inv_1_0_q_3*tmp_kernel_op_335 + jac_blending_inv_1_1_q_3*tmp_kernel_op_336 + jac_blending_inv_1_2_q_3*tmp_kernel_op_337;
             const real_t tmp_kernel_op_340 = jac_blending_inv_2_0_q_3*tmp_kernel_op_335 + jac_blending_inv_2_1_q_3*tmp_kernel_op_336 + jac_blending_inv_2_2_q_3*tmp_kernel_op_337;
             const real_t tmp_kernel_op_341 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1112 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1118 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1124) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1140 + tmp_kernel_op_290*tmp_moved_constant_1141 + tmp_kernel_op_292*tmp_moved_constant_1142) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1112 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1118 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1124) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1140 + tmp_kernel_op_297*tmp_moved_constant_1141 + tmp_kernel_op_298*tmp_moved_constant_1142) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1112 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1118 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1124) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1140 + tmp_kernel_op_303*tmp_moved_constant_1141 + tmp_kernel_op_304*tmp_moved_constant_1142) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1125 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1126 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1127) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1140 + tmp_kernel_op_309*tmp_moved_constant_1141 + tmp_kernel_op_310*tmp_moved_constant_1142) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1125 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1126 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1127) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1140 + tmp_kernel_op_315*tmp_moved_constant_1141 + tmp_kernel_op_316*tmp_moved_constant_1142) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1125 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1126 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1127) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1140 + tmp_kernel_op_321*tmp_moved_constant_1141 + tmp_kernel_op_322*tmp_moved_constant_1142) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1128 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1129 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1130) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1140 + tmp_kernel_op_327*tmp_moved_constant_1141 + tmp_kernel_op_328*tmp_moved_constant_1142) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1128 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1129 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1130) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1140 + tmp_kernel_op_333*tmp_moved_constant_1141 + tmp_kernel_op_334*tmp_moved_constant_1142) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1128 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1129 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1130) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1140 + tmp_kernel_op_339*tmp_moved_constant_1141 + tmp_kernel_op_340*tmp_moved_constant_1142);
             const real_t tmp_kernel_op_359 = tmp_kernel_op_342*wx_dof_4 + tmp_kernel_op_343*wx_dof_5 + tmp_kernel_op_344*wx_dof_6 + tmp_kernel_op_347*wx_dof_1 + tmp_kernel_op_350*wx_dof_2 + tmp_kernel_op_353*wx_dof_3 + tmp_kernel_op_354*wx_dof_7 + tmp_kernel_op_355*wx_dof_8 + tmp_kernel_op_357*wx_dof_9 + tmp_kernel_op_358*wx_dof_0;
             const real_t tmp_kernel_op_360 = tmp_kernel_op_342*wy_dof_4 + tmp_kernel_op_343*wy_dof_5 + tmp_kernel_op_344*wy_dof_6 + tmp_kernel_op_347*wy_dof_1 + tmp_kernel_op_350*wy_dof_2 + tmp_kernel_op_353*wy_dof_3 + tmp_kernel_op_354*wy_dof_7 + tmp_kernel_op_355*wy_dof_8 + tmp_kernel_op_357*wy_dof_9 + tmp_kernel_op_358*wy_dof_0;
             const real_t tmp_kernel_op_361 = tmp_kernel_op_342*wz_dof_4 + tmp_kernel_op_343*wz_dof_5 + tmp_kernel_op_344*wz_dof_6 + tmp_kernel_op_347*wz_dof_1 + tmp_kernel_op_350*wz_dof_2 + tmp_kernel_op_353*wz_dof_3 + tmp_kernel_op_354*wz_dof_7 + tmp_kernel_op_355*wz_dof_8 + tmp_kernel_op_357*wz_dof_9 + tmp_kernel_op_358*wz_dof_0;
             const real_t tmp_kernel_op_362 = abs_det_jac_affine_GREEN_UP*abs_det_jac_blending_q_3*(diffusivity_times_delta_dof_0*tmp_kernel_op_358 + diffusivity_times_delta_dof_1*tmp_kernel_op_347 + diffusivity_times_delta_dof_2*tmp_kernel_op_350 + diffusivity_times_delta_dof_3*tmp_kernel_op_353 + diffusivity_times_delta_dof_4*tmp_kernel_op_342 + diffusivity_times_delta_dof_5*tmp_kernel_op_343 + diffusivity_times_delta_dof_6*tmp_kernel_op_344 + diffusivity_times_delta_dof_7*tmp_kernel_op_354 + diffusivity_times_delta_dof_8*tmp_kernel_op_355 + diffusivity_times_delta_dof_9*tmp_kernel_op_357)*0.074999999999999983;
             const real_t tmp_kernel_op_363 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1140 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1141 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1142) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1140 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1141 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1142) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1140 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1141 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1142));
             const real_t tmp_kernel_op_370 = -hessian_blending_0_0_0_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_0_1_0_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_0_2_0_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_371 = -hessian_blending_0_0_1_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_0_1_1_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_0_2_1_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_372 = -hessian_blending_0_0_2_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_0_1_2_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_0_2_2_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_373 = jac_blending_inv_0_0_q_4*tmp_kernel_op_370 + jac_blending_inv_0_1_q_4*tmp_kernel_op_371 + jac_blending_inv_0_2_q_4*tmp_kernel_op_372;
             const real_t tmp_kernel_op_375 = jac_blending_inv_1_0_q_4*tmp_kernel_op_370 + jac_blending_inv_1_1_q_4*tmp_kernel_op_371 + jac_blending_inv_1_2_q_4*tmp_kernel_op_372;
             const real_t tmp_kernel_op_377 = jac_blending_inv_2_0_q_4*tmp_kernel_op_370 + jac_blending_inv_2_1_q_4*tmp_kernel_op_371 + jac_blending_inv_2_2_q_4*tmp_kernel_op_372;
             const real_t tmp_kernel_op_378 = -hessian_blending_1_0_0_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_1_1_0_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_1_2_0_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_379 = -hessian_blending_1_0_1_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_1_1_1_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_1_2_1_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_380 = -hessian_blending_1_0_2_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_1_1_2_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_1_2_2_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_381 = jac_blending_inv_0_0_q_4*tmp_kernel_op_378 + jac_blending_inv_0_1_q_4*tmp_kernel_op_379 + jac_blending_inv_0_2_q_4*tmp_kernel_op_380;
             const real_t tmp_kernel_op_382 = jac_blending_inv_1_0_q_4*tmp_kernel_op_378 + jac_blending_inv_1_1_q_4*tmp_kernel_op_379 + jac_blending_inv_1_2_q_4*tmp_kernel_op_380;
             const real_t tmp_kernel_op_383 = jac_blending_inv_2_0_q_4*tmp_kernel_op_378 + jac_blending_inv_2_1_q_4*tmp_kernel_op_379 + jac_blending_inv_2_2_q_4*tmp_kernel_op_380;
             const real_t tmp_kernel_op_384 = -hessian_blending_2_0_0_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_2_1_0_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_2_2_0_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_385 = -hessian_blending_2_0_1_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_2_1_1_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_2_2_1_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_386 = -hessian_blending_2_0_2_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_2_1_2_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_2_2_2_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_387 = jac_blending_inv_0_0_q_4*tmp_kernel_op_384 + jac_blending_inv_0_1_q_4*tmp_kernel_op_385 + jac_blending_inv_0_2_q_4*tmp_kernel_op_386;
             const real_t tmp_kernel_op_388 = jac_blending_inv_1_0_q_4*tmp_kernel_op_384 + jac_blending_inv_1_1_q_4*tmp_kernel_op_385 + jac_blending_inv_1_2_q_4*tmp_kernel_op_386;
             const real_t tmp_kernel_op_389 = jac_blending_inv_2_0_q_4*tmp_kernel_op_384 + jac_blending_inv_2_1_q_4*tmp_kernel_op_385 + jac_blending_inv_2_2_q_4*tmp_kernel_op_386;
             const real_t tmp_kernel_op_390 = -hessian_blending_0_0_0_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_0_1_0_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_0_2_0_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_391 = -hessian_blending_0_0_1_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_0_1_1_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_0_2_1_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_392 = -hessian_blending_0_0_2_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_0_1_2_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_0_2_2_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_393 = jac_blending_inv_0_0_q_4*tmp_kernel_op_390 + jac_blending_inv_0_1_q_4*tmp_kernel_op_391 + jac_blending_inv_0_2_q_4*tmp_kernel_op_392;
             const real_t tmp_kernel_op_394 = jac_blending_inv_1_0_q_4*tmp_kernel_op_390 + jac_blending_inv_1_1_q_4*tmp_kernel_op_391 + jac_blending_inv_1_2_q_4*tmp_kernel_op_392;
             const real_t tmp_kernel_op_395 = jac_blending_inv_2_0_q_4*tmp_kernel_op_390 + jac_blending_inv_2_1_q_4*tmp_kernel_op_391 + jac_blending_inv_2_2_q_4*tmp_kernel_op_392;
             const real_t tmp_kernel_op_396 = -hessian_blending_1_0_0_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_1_1_0_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_1_2_0_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_397 = -hessian_blending_1_0_1_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_1_1_1_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_1_2_1_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_398 = -hessian_blending_1_0_2_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_1_1_2_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_1_2_2_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_399 = jac_blending_inv_0_0_q_4*tmp_kernel_op_396 + jac_blending_inv_0_1_q_4*tmp_kernel_op_397 + jac_blending_inv_0_2_q_4*tmp_kernel_op_398;
             const real_t tmp_kernel_op_400 = jac_blending_inv_1_0_q_4*tmp_kernel_op_396 + jac_blending_inv_1_1_q_4*tmp_kernel_op_397 + jac_blending_inv_1_2_q_4*tmp_kernel_op_398;
             const real_t tmp_kernel_op_401 = jac_blending_inv_2_0_q_4*tmp_kernel_op_396 + jac_blending_inv_2_1_q_4*tmp_kernel_op_397 + jac_blending_inv_2_2_q_4*tmp_kernel_op_398;
             const real_t tmp_kernel_op_402 = -hessian_blending_2_0_0_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_2_1_0_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_2_2_0_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_403 = -hessian_blending_2_0_1_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_2_1_1_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_2_2_1_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_404 = -hessian_blending_2_0_2_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_2_1_2_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_2_2_2_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_405 = jac_blending_inv_0_0_q_4*tmp_kernel_op_402 + jac_blending_inv_0_1_q_4*tmp_kernel_op_403 + jac_blending_inv_0_2_q_4*tmp_kernel_op_404;
             const real_t tmp_kernel_op_406 = jac_blending_inv_1_0_q_4*tmp_kernel_op_402 + jac_blending_inv_1_1_q_4*tmp_kernel_op_403 + jac_blending_inv_1_2_q_4*tmp_kernel_op_404;
             const real_t tmp_kernel_op_407 = jac_blending_inv_2_0_q_4*tmp_kernel_op_402 + jac_blending_inv_2_1_q_4*tmp_kernel_op_403 + jac_blending_inv_2_2_q_4*tmp_kernel_op_404;
             const real_t tmp_kernel_op_408 = -hessian_blending_0_0_0_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_0_1_0_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_0_2_0_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_409 = -hessian_blending_0_0_1_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_0_1_1_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_0_2_1_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_410 = -hessian_blending_0_0_2_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_0_1_2_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_0_2_2_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_411 = jac_blending_inv_0_0_q_4*tmp_kernel_op_408 + jac_blending_inv_0_1_q_4*tmp_kernel_op_409 + jac_blending_inv_0_2_q_4*tmp_kernel_op_410;
             const real_t tmp_kernel_op_412 = jac_blending_inv_1_0_q_4*tmp_kernel_op_408 + jac_blending_inv_1_1_q_4*tmp_kernel_op_409 + jac_blending_inv_1_2_q_4*tmp_kernel_op_410;
             const real_t tmp_kernel_op_413 = jac_blending_inv_2_0_q_4*tmp_kernel_op_408 + jac_blending_inv_2_1_q_4*tmp_kernel_op_409 + jac_blending_inv_2_2_q_4*tmp_kernel_op_410;
             const real_t tmp_kernel_op_414 = -hessian_blending_1_0_0_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_1_1_0_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_1_2_0_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_415 = -hessian_blending_1_0_1_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_1_1_1_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_1_2_1_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_416 = -hessian_blending_1_0_2_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_1_1_2_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_1_2_2_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_417 = jac_blending_inv_0_0_q_4*tmp_kernel_op_414 + jac_blending_inv_0_1_q_4*tmp_kernel_op_415 + jac_blending_inv_0_2_q_4*tmp_kernel_op_416;
             const real_t tmp_kernel_op_418 = jac_blending_inv_1_0_q_4*tmp_kernel_op_414 + jac_blending_inv_1_1_q_4*tmp_kernel_op_415 + jac_blending_inv_1_2_q_4*tmp_kernel_op_416;
             const real_t tmp_kernel_op_419 = jac_blending_inv_2_0_q_4*tmp_kernel_op_414 + jac_blending_inv_2_1_q_4*tmp_kernel_op_415 + jac_blending_inv_2_2_q_4*tmp_kernel_op_416;
             const real_t tmp_kernel_op_420 = -hessian_blending_2_0_0_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_2_1_0_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_2_2_0_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_421 = -hessian_blending_2_0_1_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_2_1_1_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_2_2_1_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_422 = -hessian_blending_2_0_2_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_2_1_2_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_2_2_2_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_423 = jac_blending_inv_0_0_q_4*tmp_kernel_op_420 + jac_blending_inv_0_1_q_4*tmp_kernel_op_421 + jac_blending_inv_0_2_q_4*tmp_kernel_op_422;
             const real_t tmp_kernel_op_424 = jac_blending_inv_1_0_q_4*tmp_kernel_op_420 + jac_blending_inv_1_1_q_4*tmp_kernel_op_421 + jac_blending_inv_1_2_q_4*tmp_kernel_op_422;
             const real_t tmp_kernel_op_425 = jac_blending_inv_2_0_q_4*tmp_kernel_op_420 + jac_blending_inv_2_1_q_4*tmp_kernel_op_421 + jac_blending_inv_2_2_q_4*tmp_kernel_op_422;
             const real_t tmp_kernel_op_426 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1112 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1118 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1124) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1143 + tmp_kernel_op_375*tmp_moved_constant_1144 + tmp_kernel_op_377*tmp_moved_constant_1145) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1112 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1118 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1124) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1143 + tmp_kernel_op_382*tmp_moved_constant_1144 + tmp_kernel_op_383*tmp_moved_constant_1145) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1112 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1118 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1124) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1143 + tmp_kernel_op_388*tmp_moved_constant_1144 + tmp_kernel_op_389*tmp_moved_constant_1145) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1125 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1126 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1127) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1143 + tmp_kernel_op_394*tmp_moved_constant_1144 + tmp_kernel_op_395*tmp_moved_constant_1145) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1125 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1126 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1127) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1143 + tmp_kernel_op_400*tmp_moved_constant_1144 + tmp_kernel_op_401*tmp_moved_constant_1145) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1125 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1126 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1127) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1143 + tmp_kernel_op_406*tmp_moved_constant_1144 + tmp_kernel_op_407*tmp_moved_constant_1145) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1128 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1129 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1130) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1143 + tmp_kernel_op_412*tmp_moved_constant_1144 + tmp_kernel_op_413*tmp_moved_constant_1145) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1128 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1129 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1130) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1143 + tmp_kernel_op_418*tmp_moved_constant_1144 + tmp_kernel_op_419*tmp_moved_constant_1145) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1128 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1129 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1130) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1143 + tmp_kernel_op_424*tmp_moved_constant_1144 + tmp_kernel_op_425*tmp_moved_constant_1145);
             const real_t tmp_kernel_op_444 = tmp_kernel_op_427*wx_dof_4 + tmp_kernel_op_428*wx_dof_5 + tmp_kernel_op_429*wx_dof_6 + tmp_kernel_op_432*wx_dof_1 + tmp_kernel_op_435*wx_dof_2 + tmp_kernel_op_438*wx_dof_3 + tmp_kernel_op_439*wx_dof_7 + tmp_kernel_op_440*wx_dof_8 + tmp_kernel_op_442*wx_dof_9 + tmp_kernel_op_443*wx_dof_0;
             const real_t tmp_kernel_op_445 = tmp_kernel_op_427*wy_dof_4 + tmp_kernel_op_428*wy_dof_5 + tmp_kernel_op_429*wy_dof_6 + tmp_kernel_op_432*wy_dof_1 + tmp_kernel_op_435*wy_dof_2 + tmp_kernel_op_438*wy_dof_3 + tmp_kernel_op_439*wy_dof_7 + tmp_kernel_op_440*wy_dof_8 + tmp_kernel_op_442*wy_dof_9 + tmp_kernel_op_443*wy_dof_0;
             const real_t tmp_kernel_op_446 = tmp_kernel_op_427*wz_dof_4 + tmp_kernel_op_428*wz_dof_5 + tmp_kernel_op_429*wz_dof_6 + tmp_kernel_op_432*wz_dof_1 + tmp_kernel_op_435*wz_dof_2 + tmp_kernel_op_438*wz_dof_3 + tmp_kernel_op_439*wz_dof_7 + tmp_kernel_op_440*wz_dof_8 + tmp_kernel_op_442*wz_dof_9 + tmp_kernel_op_443*wz_dof_0;
             const real_t tmp_kernel_op_447 = abs_det_jac_affine_GREEN_UP*abs_det_jac_blending_q_4*(diffusivity_times_delta_dof_0*tmp_kernel_op_443 + diffusivity_times_delta_dof_1*tmp_kernel_op_432 + diffusivity_times_delta_dof_2*tmp_kernel_op_435 + diffusivity_times_delta_dof_3*tmp_kernel_op_438 + diffusivity_times_delta_dof_4*tmp_kernel_op_427 + diffusivity_times_delta_dof_5*tmp_kernel_op_428 + diffusivity_times_delta_dof_6*tmp_kernel_op_429 + diffusivity_times_delta_dof_7*tmp_kernel_op_439 + diffusivity_times_delta_dof_8*tmp_kernel_op_440 + diffusivity_times_delta_dof_9*tmp_kernel_op_442)*0.074999999999999983;
             const real_t tmp_kernel_op_448 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1143 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1144 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1145) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1143 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1144 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1145) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1143 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1144 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1145));
             const real_t tmp_kernel_op_459 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1148 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1146 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1147) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1152 + tmp_kernel_op_35*tmp_moved_constant_1153 + tmp_kernel_op_37*tmp_moved_constant_1154) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1148 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1146 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1147) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1152 + tmp_kernel_op_42*tmp_moved_constant_1153 + tmp_kernel_op_43*tmp_moved_constant_1154) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1148 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1146 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1147) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1152 + tmp_kernel_op_48*tmp_moved_constant_1153 + tmp_kernel_op_49*tmp_moved_constant_1154) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1146 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1150 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1149) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1152 + tmp_kernel_op_54*tmp_moved_constant_1153 + tmp_kernel_op_55*tmp_moved_constant_1154) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1146 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1150 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1149) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1152 + tmp_kernel_op_60*tmp_moved_constant_1153 + tmp_kernel_op_61*tmp_moved_constant_1154) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1146 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1150 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1149) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1152 + tmp_kernel_op_66*tmp_moved_constant_1153 + tmp_kernel_op_67*tmp_moved_constant_1154) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1147 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1149 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1151) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1152 + tmp_kernel_op_72*tmp_moved_constant_1153 + tmp_kernel_op_73*tmp_moved_constant_1154) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1147 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1149 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1151) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1152 + tmp_kernel_op_78*tmp_moved_constant_1153 + tmp_kernel_op_79*tmp_moved_constant_1154) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1147 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1149 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1151) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1152 + tmp_kernel_op_84*tmp_moved_constant_1153 + tmp_kernel_op_85*tmp_moved_constant_1154);
             const real_t tmp_kernel_op_464 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1148 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1146 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1147) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1155 + tmp_kernel_op_120*tmp_moved_constant_1156 + tmp_kernel_op_122*tmp_moved_constant_1157) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1148 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1146 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1147) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1155 + tmp_kernel_op_127*tmp_moved_constant_1156 + tmp_kernel_op_128*tmp_moved_constant_1157) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1148 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1146 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1147) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1155 + tmp_kernel_op_133*tmp_moved_constant_1156 + tmp_kernel_op_134*tmp_moved_constant_1157) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1146 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1150 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1149) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1155 + tmp_kernel_op_139*tmp_moved_constant_1156 + tmp_kernel_op_140*tmp_moved_constant_1157) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1146 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1150 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1149) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1155 + tmp_kernel_op_145*tmp_moved_constant_1156 + tmp_kernel_op_146*tmp_moved_constant_1157) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1146 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1150 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1149) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1155 + tmp_kernel_op_151*tmp_moved_constant_1156 + tmp_kernel_op_152*tmp_moved_constant_1157) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1147 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1149 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1151) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1155 + tmp_kernel_op_157*tmp_moved_constant_1156 + tmp_kernel_op_158*tmp_moved_constant_1157) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1147 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1149 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1151) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1155 + tmp_kernel_op_163*tmp_moved_constant_1156 + tmp_kernel_op_164*tmp_moved_constant_1157) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1147 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1149 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1151) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1155 + tmp_kernel_op_169*tmp_moved_constant_1156 + tmp_kernel_op_170*tmp_moved_constant_1157);
             const real_t tmp_kernel_op_469 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1148 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1146 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1147) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1158 + tmp_kernel_op_205*tmp_moved_constant_1159 + tmp_kernel_op_207*tmp_moved_constant_1160) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1148 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1146 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1147) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1158 + tmp_kernel_op_212*tmp_moved_constant_1159 + tmp_kernel_op_213*tmp_moved_constant_1160) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1148 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1146 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1147) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1158 + tmp_kernel_op_218*tmp_moved_constant_1159 + tmp_kernel_op_219*tmp_moved_constant_1160) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1146 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1150 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1149) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1158 + tmp_kernel_op_224*tmp_moved_constant_1159 + tmp_kernel_op_225*tmp_moved_constant_1160) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1146 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1150 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1149) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1158 + tmp_kernel_op_230*tmp_moved_constant_1159 + tmp_kernel_op_231*tmp_moved_constant_1160) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1146 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1150 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1149) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1158 + tmp_kernel_op_236*tmp_moved_constant_1159 + tmp_kernel_op_237*tmp_moved_constant_1160) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1147 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1149 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1151) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1158 + tmp_kernel_op_242*tmp_moved_constant_1159 + tmp_kernel_op_243*tmp_moved_constant_1160) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1147 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1149 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1151) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1158 + tmp_kernel_op_248*tmp_moved_constant_1159 + tmp_kernel_op_249*tmp_moved_constant_1160) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1147 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1149 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1151) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1158 + tmp_kernel_op_254*tmp_moved_constant_1159 + tmp_kernel_op_255*tmp_moved_constant_1160);
             const real_t tmp_kernel_op_474 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1148 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1146 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1147) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1161 + tmp_kernel_op_290*tmp_moved_constant_1162 + tmp_kernel_op_292*tmp_moved_constant_1163) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1148 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1146 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1147) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1161 + tmp_kernel_op_297*tmp_moved_constant_1162 + tmp_kernel_op_298*tmp_moved_constant_1163) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1148 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1146 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1147) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1161 + tmp_kernel_op_303*tmp_moved_constant_1162 + tmp_kernel_op_304*tmp_moved_constant_1163) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1146 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1150 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1149) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1161 + tmp_kernel_op_309*tmp_moved_constant_1162 + tmp_kernel_op_310*tmp_moved_constant_1163) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1146 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1150 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1149) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1161 + tmp_kernel_op_315*tmp_moved_constant_1162 + tmp_kernel_op_316*tmp_moved_constant_1163) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1146 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1150 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1149) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1161 + tmp_kernel_op_321*tmp_moved_constant_1162 + tmp_kernel_op_322*tmp_moved_constant_1163) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1147 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1149 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1151) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1161 + tmp_kernel_op_327*tmp_moved_constant_1162 + tmp_kernel_op_328*tmp_moved_constant_1163) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1147 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1149 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1151) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1161 + tmp_kernel_op_333*tmp_moved_constant_1162 + tmp_kernel_op_334*tmp_moved_constant_1163) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1147 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1149 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1151) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1161 + tmp_kernel_op_339*tmp_moved_constant_1162 + tmp_kernel_op_340*tmp_moved_constant_1163);
             const real_t tmp_kernel_op_479 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1148 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1146 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1147) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1164 + tmp_kernel_op_375*tmp_moved_constant_1165 + tmp_kernel_op_377*tmp_moved_constant_1166) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1148 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1146 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1147) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1164 + tmp_kernel_op_382*tmp_moved_constant_1165 + tmp_kernel_op_383*tmp_moved_constant_1166) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1148 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1146 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1147) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1164 + tmp_kernel_op_388*tmp_moved_constant_1165 + tmp_kernel_op_389*tmp_moved_constant_1166) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1146 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1150 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1149) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1164 + tmp_kernel_op_394*tmp_moved_constant_1165 + tmp_kernel_op_395*tmp_moved_constant_1166) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1146 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1150 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1149) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1164 + tmp_kernel_op_400*tmp_moved_constant_1165 + tmp_kernel_op_401*tmp_moved_constant_1166) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1146 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1150 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1149) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1164 + tmp_kernel_op_406*tmp_moved_constant_1165 + tmp_kernel_op_407*tmp_moved_constant_1166) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1147 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1149 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1151) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1164 + tmp_kernel_op_412*tmp_moved_constant_1165 + tmp_kernel_op_413*tmp_moved_constant_1166) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1147 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1149 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1151) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1164 + tmp_kernel_op_418*tmp_moved_constant_1165 + tmp_kernel_op_419*tmp_moved_constant_1166) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1147 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1149 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1151) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1164 + tmp_kernel_op_424*tmp_moved_constant_1165 + tmp_kernel_op_425*tmp_moved_constant_1166);
             const real_t tmp_kernel_op_490 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1169 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1167 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1168) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1173 + tmp_kernel_op_35*tmp_moved_constant_1174 + tmp_kernel_op_37*tmp_moved_constant_1175) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1169 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1167 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1168) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1173 + tmp_kernel_op_42*tmp_moved_constant_1174 + tmp_kernel_op_43*tmp_moved_constant_1175) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1169 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1167 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1168) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1173 + tmp_kernel_op_48*tmp_moved_constant_1174 + tmp_kernel_op_49*tmp_moved_constant_1175) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1167 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1171 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1170) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1173 + tmp_kernel_op_54*tmp_moved_constant_1174 + tmp_kernel_op_55*tmp_moved_constant_1175) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1167 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1171 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1170) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1173 + tmp_kernel_op_60*tmp_moved_constant_1174 + tmp_kernel_op_61*tmp_moved_constant_1175) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1167 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1171 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1170) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1173 + tmp_kernel_op_66*tmp_moved_constant_1174 + tmp_kernel_op_67*tmp_moved_constant_1175) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1168 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1170 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1172) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1173 + tmp_kernel_op_72*tmp_moved_constant_1174 + tmp_kernel_op_73*tmp_moved_constant_1175) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1168 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1170 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1172) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1173 + tmp_kernel_op_78*tmp_moved_constant_1174 + tmp_kernel_op_79*tmp_moved_constant_1175) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1168 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1170 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1172) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1173 + tmp_kernel_op_84*tmp_moved_constant_1174 + tmp_kernel_op_85*tmp_moved_constant_1175);
             const real_t tmp_kernel_op_495 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1169 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1167 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1168) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1176 + tmp_kernel_op_120*tmp_moved_constant_1177 + tmp_kernel_op_122*tmp_moved_constant_1178) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1169 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1167 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1168) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1176 + tmp_kernel_op_127*tmp_moved_constant_1177 + tmp_kernel_op_128*tmp_moved_constant_1178) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1169 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1167 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1168) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1176 + tmp_kernel_op_133*tmp_moved_constant_1177 + tmp_kernel_op_134*tmp_moved_constant_1178) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1167 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1171 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1170) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1176 + tmp_kernel_op_139*tmp_moved_constant_1177 + tmp_kernel_op_140*tmp_moved_constant_1178) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1167 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1171 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1170) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1176 + tmp_kernel_op_145*tmp_moved_constant_1177 + tmp_kernel_op_146*tmp_moved_constant_1178) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1167 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1171 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1170) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1176 + tmp_kernel_op_151*tmp_moved_constant_1177 + tmp_kernel_op_152*tmp_moved_constant_1178) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1168 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1170 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1172) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1176 + tmp_kernel_op_157*tmp_moved_constant_1177 + tmp_kernel_op_158*tmp_moved_constant_1178) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1168 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1170 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1172) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1176 + tmp_kernel_op_163*tmp_moved_constant_1177 + tmp_kernel_op_164*tmp_moved_constant_1178) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1168 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1170 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1172) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1176 + tmp_kernel_op_169*tmp_moved_constant_1177 + tmp_kernel_op_170*tmp_moved_constant_1178);
             const real_t tmp_kernel_op_500 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1169 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1167 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1168) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1179 + tmp_kernel_op_205*tmp_moved_constant_1180 + tmp_kernel_op_207*tmp_moved_constant_1181) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1169 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1167 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1168) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1179 + tmp_kernel_op_212*tmp_moved_constant_1180 + tmp_kernel_op_213*tmp_moved_constant_1181) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1169 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1167 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1168) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1179 + tmp_kernel_op_218*tmp_moved_constant_1180 + tmp_kernel_op_219*tmp_moved_constant_1181) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1167 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1171 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1170) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1179 + tmp_kernel_op_224*tmp_moved_constant_1180 + tmp_kernel_op_225*tmp_moved_constant_1181) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1167 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1171 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1170) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1179 + tmp_kernel_op_230*tmp_moved_constant_1180 + tmp_kernel_op_231*tmp_moved_constant_1181) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1167 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1171 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1170) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1179 + tmp_kernel_op_236*tmp_moved_constant_1180 + tmp_kernel_op_237*tmp_moved_constant_1181) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1168 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1170 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1172) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1179 + tmp_kernel_op_242*tmp_moved_constant_1180 + tmp_kernel_op_243*tmp_moved_constant_1181) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1168 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1170 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1172) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1179 + tmp_kernel_op_248*tmp_moved_constant_1180 + tmp_kernel_op_249*tmp_moved_constant_1181) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1168 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1170 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1172) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1179 + tmp_kernel_op_254*tmp_moved_constant_1180 + tmp_kernel_op_255*tmp_moved_constant_1181);
             const real_t tmp_kernel_op_505 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1169 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1167 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1168) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1182 + tmp_kernel_op_290*tmp_moved_constant_1183 + tmp_kernel_op_292*tmp_moved_constant_1184) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1169 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1167 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1168) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1182 + tmp_kernel_op_297*tmp_moved_constant_1183 + tmp_kernel_op_298*tmp_moved_constant_1184) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1169 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1167 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1168) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1182 + tmp_kernel_op_303*tmp_moved_constant_1183 + tmp_kernel_op_304*tmp_moved_constant_1184) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1167 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1171 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1170) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1182 + tmp_kernel_op_309*tmp_moved_constant_1183 + tmp_kernel_op_310*tmp_moved_constant_1184) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1167 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1171 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1170) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1182 + tmp_kernel_op_315*tmp_moved_constant_1183 + tmp_kernel_op_316*tmp_moved_constant_1184) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1167 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1171 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1170) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1182 + tmp_kernel_op_321*tmp_moved_constant_1183 + tmp_kernel_op_322*tmp_moved_constant_1184) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1168 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1170 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1172) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1182 + tmp_kernel_op_327*tmp_moved_constant_1183 + tmp_kernel_op_328*tmp_moved_constant_1184) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1168 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1170 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1172) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1182 + tmp_kernel_op_333*tmp_moved_constant_1183 + tmp_kernel_op_334*tmp_moved_constant_1184) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1168 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1170 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1172) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1182 + tmp_kernel_op_339*tmp_moved_constant_1183 + tmp_kernel_op_340*tmp_moved_constant_1184);
             const real_t tmp_kernel_op_510 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1169 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1167 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1168) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1185 + tmp_kernel_op_375*tmp_moved_constant_1186 + tmp_kernel_op_377*tmp_moved_constant_1187) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1169 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1167 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1168) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1185 + tmp_kernel_op_382*tmp_moved_constant_1186 + tmp_kernel_op_383*tmp_moved_constant_1187) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1169 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1167 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1168) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1185 + tmp_kernel_op_388*tmp_moved_constant_1186 + tmp_kernel_op_389*tmp_moved_constant_1187) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1167 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1171 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1170) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1185 + tmp_kernel_op_394*tmp_moved_constant_1186 + tmp_kernel_op_395*tmp_moved_constant_1187) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1167 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1171 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1170) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1185 + tmp_kernel_op_400*tmp_moved_constant_1186 + tmp_kernel_op_401*tmp_moved_constant_1187) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1167 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1171 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1170) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1185 + tmp_kernel_op_406*tmp_moved_constant_1186 + tmp_kernel_op_407*tmp_moved_constant_1187) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1168 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1170 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1172) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1185 + tmp_kernel_op_412*tmp_moved_constant_1186 + tmp_kernel_op_413*tmp_moved_constant_1187) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1168 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1170 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1172) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1185 + tmp_kernel_op_418*tmp_moved_constant_1186 + tmp_kernel_op_419*tmp_moved_constant_1187) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1168 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1170 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1172) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1185 + tmp_kernel_op_424*tmp_moved_constant_1186 + tmp_kernel_op_425*tmp_moved_constant_1187);
             const real_t tmp_kernel_op_521 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1190 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1188 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1189) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1194 + tmp_kernel_op_35*tmp_moved_constant_1195 + tmp_kernel_op_37*tmp_moved_constant_1196) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1190 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1188 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1189) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1194 + tmp_kernel_op_42*tmp_moved_constant_1195 + tmp_kernel_op_43*tmp_moved_constant_1196) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1190 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1188 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1189) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1194 + tmp_kernel_op_48*tmp_moved_constant_1195 + tmp_kernel_op_49*tmp_moved_constant_1196) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1188 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1192 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1191) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1194 + tmp_kernel_op_54*tmp_moved_constant_1195 + tmp_kernel_op_55*tmp_moved_constant_1196) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1188 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1192 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1191) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1194 + tmp_kernel_op_60*tmp_moved_constant_1195 + tmp_kernel_op_61*tmp_moved_constant_1196) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1188 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1192 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1191) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1194 + tmp_kernel_op_66*tmp_moved_constant_1195 + tmp_kernel_op_67*tmp_moved_constant_1196) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1189 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1191 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1193) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1194 + tmp_kernel_op_72*tmp_moved_constant_1195 + tmp_kernel_op_73*tmp_moved_constant_1196) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1189 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1191 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1193) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1194 + tmp_kernel_op_78*tmp_moved_constant_1195 + tmp_kernel_op_79*tmp_moved_constant_1196) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1189 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1191 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1193) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1194 + tmp_kernel_op_84*tmp_moved_constant_1195 + tmp_kernel_op_85*tmp_moved_constant_1196);
             const real_t tmp_kernel_op_526 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1190 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1188 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1189) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1197 + tmp_kernel_op_120*tmp_moved_constant_1198 + tmp_kernel_op_122*tmp_moved_constant_1199) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1190 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1188 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1189) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1197 + tmp_kernel_op_127*tmp_moved_constant_1198 + tmp_kernel_op_128*tmp_moved_constant_1199) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1190 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1188 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1189) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1197 + tmp_kernel_op_133*tmp_moved_constant_1198 + tmp_kernel_op_134*tmp_moved_constant_1199) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1188 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1192 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1191) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1197 + tmp_kernel_op_139*tmp_moved_constant_1198 + tmp_kernel_op_140*tmp_moved_constant_1199) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1188 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1192 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1191) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1197 + tmp_kernel_op_145*tmp_moved_constant_1198 + tmp_kernel_op_146*tmp_moved_constant_1199) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1188 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1192 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1191) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1197 + tmp_kernel_op_151*tmp_moved_constant_1198 + tmp_kernel_op_152*tmp_moved_constant_1199) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1189 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1191 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1193) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1197 + tmp_kernel_op_157*tmp_moved_constant_1198 + tmp_kernel_op_158*tmp_moved_constant_1199) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1189 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1191 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1193) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1197 + tmp_kernel_op_163*tmp_moved_constant_1198 + tmp_kernel_op_164*tmp_moved_constant_1199) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1189 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1191 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1193) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1197 + tmp_kernel_op_169*tmp_moved_constant_1198 + tmp_kernel_op_170*tmp_moved_constant_1199);
             const real_t tmp_kernel_op_531 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1190 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1188 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1189) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1200 + tmp_kernel_op_205*tmp_moved_constant_1201 + tmp_kernel_op_207*tmp_moved_constant_1202) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1190 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1188 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1189) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1200 + tmp_kernel_op_212*tmp_moved_constant_1201 + tmp_kernel_op_213*tmp_moved_constant_1202) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1190 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1188 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1189) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1200 + tmp_kernel_op_218*tmp_moved_constant_1201 + tmp_kernel_op_219*tmp_moved_constant_1202) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1188 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1192 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1191) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1200 + tmp_kernel_op_224*tmp_moved_constant_1201 + tmp_kernel_op_225*tmp_moved_constant_1202) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1188 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1192 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1191) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1200 + tmp_kernel_op_230*tmp_moved_constant_1201 + tmp_kernel_op_231*tmp_moved_constant_1202) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1188 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1192 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1191) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1200 + tmp_kernel_op_236*tmp_moved_constant_1201 + tmp_kernel_op_237*tmp_moved_constant_1202) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1189 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1191 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1193) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1200 + tmp_kernel_op_242*tmp_moved_constant_1201 + tmp_kernel_op_243*tmp_moved_constant_1202) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1189 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1191 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1193) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1200 + tmp_kernel_op_248*tmp_moved_constant_1201 + tmp_kernel_op_249*tmp_moved_constant_1202) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1189 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1191 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1193) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1200 + tmp_kernel_op_254*tmp_moved_constant_1201 + tmp_kernel_op_255*tmp_moved_constant_1202);
             const real_t tmp_kernel_op_536 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1190 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1188 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1189) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1203 + tmp_kernel_op_290*tmp_moved_constant_1204 + tmp_kernel_op_292*tmp_moved_constant_1205) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1190 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1188 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1189) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1203 + tmp_kernel_op_297*tmp_moved_constant_1204 + tmp_kernel_op_298*tmp_moved_constant_1205) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1190 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1188 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1189) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1203 + tmp_kernel_op_303*tmp_moved_constant_1204 + tmp_kernel_op_304*tmp_moved_constant_1205) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1188 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1192 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1191) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1203 + tmp_kernel_op_309*tmp_moved_constant_1204 + tmp_kernel_op_310*tmp_moved_constant_1205) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1188 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1192 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1191) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1203 + tmp_kernel_op_315*tmp_moved_constant_1204 + tmp_kernel_op_316*tmp_moved_constant_1205) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1188 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1192 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1191) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1203 + tmp_kernel_op_321*tmp_moved_constant_1204 + tmp_kernel_op_322*tmp_moved_constant_1205) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1189 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1191 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1193) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1203 + tmp_kernel_op_327*tmp_moved_constant_1204 + tmp_kernel_op_328*tmp_moved_constant_1205) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1189 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1191 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1193) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1203 + tmp_kernel_op_333*tmp_moved_constant_1204 + tmp_kernel_op_334*tmp_moved_constant_1205) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1189 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1191 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1193) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1203 + tmp_kernel_op_339*tmp_moved_constant_1204 + tmp_kernel_op_340*tmp_moved_constant_1205);
             const real_t tmp_kernel_op_541 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1190 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1188 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1189) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1206 + tmp_kernel_op_375*tmp_moved_constant_1207 + tmp_kernel_op_377*tmp_moved_constant_1208) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1190 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1188 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1189) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1206 + tmp_kernel_op_382*tmp_moved_constant_1207 + tmp_kernel_op_383*tmp_moved_constant_1208) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1190 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1188 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1189) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1206 + tmp_kernel_op_388*tmp_moved_constant_1207 + tmp_kernel_op_389*tmp_moved_constant_1208) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1188 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1192 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1191) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1206 + tmp_kernel_op_394*tmp_moved_constant_1207 + tmp_kernel_op_395*tmp_moved_constant_1208) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1188 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1192 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1191) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1206 + tmp_kernel_op_400*tmp_moved_constant_1207 + tmp_kernel_op_401*tmp_moved_constant_1208) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1188 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1192 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1191) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1206 + tmp_kernel_op_406*tmp_moved_constant_1207 + tmp_kernel_op_407*tmp_moved_constant_1208) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1189 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1191 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1193) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1206 + tmp_kernel_op_412*tmp_moved_constant_1207 + tmp_kernel_op_413*tmp_moved_constant_1208) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1189 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1191 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1193) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1206 + tmp_kernel_op_418*tmp_moved_constant_1207 + tmp_kernel_op_419*tmp_moved_constant_1208) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1189 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1191 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1193) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1206 + tmp_kernel_op_424*tmp_moved_constant_1207 + tmp_kernel_op_425*tmp_moved_constant_1208);
             const real_t tmp_kernel_op_566 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1210 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1213 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1216) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1226 + tmp_kernel_op_35*tmp_moved_constant_1229 + tmp_kernel_op_37*tmp_moved_constant_1232) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1210 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1213 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1216) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1226 + tmp_kernel_op_42*tmp_moved_constant_1229 + tmp_kernel_op_43*tmp_moved_constant_1232) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1210 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1213 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1216) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1226 + tmp_kernel_op_48*tmp_moved_constant_1229 + tmp_kernel_op_49*tmp_moved_constant_1232) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1213 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1218 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1221) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1226 + tmp_kernel_op_54*tmp_moved_constant_1229 + tmp_kernel_op_55*tmp_moved_constant_1232) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1213 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1218 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1221) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1226 + tmp_kernel_op_60*tmp_moved_constant_1229 + tmp_kernel_op_61*tmp_moved_constant_1232) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1213 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1218 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1221) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1226 + tmp_kernel_op_66*tmp_moved_constant_1229 + tmp_kernel_op_67*tmp_moved_constant_1232) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1216 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1221 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1223) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1226 + tmp_kernel_op_72*tmp_moved_constant_1229 + tmp_kernel_op_73*tmp_moved_constant_1232) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1216 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1221 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1223) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1226 + tmp_kernel_op_78*tmp_moved_constant_1229 + tmp_kernel_op_79*tmp_moved_constant_1232) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1216 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1221 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1223) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1226 + tmp_kernel_op_84*tmp_moved_constant_1229 + tmp_kernel_op_85*tmp_moved_constant_1232);
             const real_t tmp_kernel_op_576 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1210 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1213 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1216) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1235 + tmp_kernel_op_120*tmp_moved_constant_1238 + tmp_kernel_op_122*tmp_moved_constant_1241) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1210 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1213 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1216) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1235 + tmp_kernel_op_127*tmp_moved_constant_1238 + tmp_kernel_op_128*tmp_moved_constant_1241) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1210 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1213 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1216) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1235 + tmp_kernel_op_133*tmp_moved_constant_1238 + tmp_kernel_op_134*tmp_moved_constant_1241) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1213 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1218 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1221) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1235 + tmp_kernel_op_139*tmp_moved_constant_1238 + tmp_kernel_op_140*tmp_moved_constant_1241) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1213 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1218 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1221) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1235 + tmp_kernel_op_145*tmp_moved_constant_1238 + tmp_kernel_op_146*tmp_moved_constant_1241) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1213 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1218 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1221) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1235 + tmp_kernel_op_151*tmp_moved_constant_1238 + tmp_kernel_op_152*tmp_moved_constant_1241) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1216 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1221 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1223) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1235 + tmp_kernel_op_157*tmp_moved_constant_1238 + tmp_kernel_op_158*tmp_moved_constant_1241) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1216 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1221 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1223) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1235 + tmp_kernel_op_163*tmp_moved_constant_1238 + tmp_kernel_op_164*tmp_moved_constant_1241) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1216 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1221 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1223) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1235 + tmp_kernel_op_169*tmp_moved_constant_1238 + tmp_kernel_op_170*tmp_moved_constant_1241);
             const real_t tmp_kernel_op_586 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1210 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1213 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1216) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1244 + tmp_kernel_op_205*tmp_moved_constant_1247 + tmp_kernel_op_207*tmp_moved_constant_1250) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1210 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1213 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1216) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1244 + tmp_kernel_op_212*tmp_moved_constant_1247 + tmp_kernel_op_213*tmp_moved_constant_1250) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1210 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1213 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1216) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1244 + tmp_kernel_op_218*tmp_moved_constant_1247 + tmp_kernel_op_219*tmp_moved_constant_1250) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1213 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1218 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1221) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1244 + tmp_kernel_op_224*tmp_moved_constant_1247 + tmp_kernel_op_225*tmp_moved_constant_1250) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1213 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1218 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1221) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1244 + tmp_kernel_op_230*tmp_moved_constant_1247 + tmp_kernel_op_231*tmp_moved_constant_1250) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1213 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1218 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1221) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1244 + tmp_kernel_op_236*tmp_moved_constant_1247 + tmp_kernel_op_237*tmp_moved_constant_1250) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1216 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1221 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1223) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1244 + tmp_kernel_op_242*tmp_moved_constant_1247 + tmp_kernel_op_243*tmp_moved_constant_1250) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1216 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1221 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1223) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1244 + tmp_kernel_op_248*tmp_moved_constant_1247 + tmp_kernel_op_249*tmp_moved_constant_1250) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1216 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1221 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1223) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1244 + tmp_kernel_op_254*tmp_moved_constant_1247 + tmp_kernel_op_255*tmp_moved_constant_1250);
             const real_t tmp_kernel_op_596 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1210 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1213 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1216) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1253 + tmp_kernel_op_290*tmp_moved_constant_1256 + tmp_kernel_op_292*tmp_moved_constant_1259) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1210 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1213 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1216) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1253 + tmp_kernel_op_297*tmp_moved_constant_1256 + tmp_kernel_op_298*tmp_moved_constant_1259) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1210 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1213 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1216) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1253 + tmp_kernel_op_303*tmp_moved_constant_1256 + tmp_kernel_op_304*tmp_moved_constant_1259) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1213 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1218 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1221) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1253 + tmp_kernel_op_309*tmp_moved_constant_1256 + tmp_kernel_op_310*tmp_moved_constant_1259) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1213 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1218 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1221) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1253 + tmp_kernel_op_315*tmp_moved_constant_1256 + tmp_kernel_op_316*tmp_moved_constant_1259) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1213 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1218 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1221) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1253 + tmp_kernel_op_321*tmp_moved_constant_1256 + tmp_kernel_op_322*tmp_moved_constant_1259) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1216 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1221 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1223) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1253 + tmp_kernel_op_327*tmp_moved_constant_1256 + tmp_kernel_op_328*tmp_moved_constant_1259) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1216 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1221 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1223) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1253 + tmp_kernel_op_333*tmp_moved_constant_1256 + tmp_kernel_op_334*tmp_moved_constant_1259) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1216 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1221 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1223) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1253 + tmp_kernel_op_339*tmp_moved_constant_1256 + tmp_kernel_op_340*tmp_moved_constant_1259);
             const real_t tmp_kernel_op_606 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1210 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1213 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1216) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1262 + tmp_kernel_op_375*tmp_moved_constant_1265 + tmp_kernel_op_377*tmp_moved_constant_1268) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1210 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1213 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1216) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1262 + tmp_kernel_op_382*tmp_moved_constant_1265 + tmp_kernel_op_383*tmp_moved_constant_1268) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1210 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1213 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1216) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1262 + tmp_kernel_op_388*tmp_moved_constant_1265 + tmp_kernel_op_389*tmp_moved_constant_1268) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1213 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1218 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1221) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1262 + tmp_kernel_op_394*tmp_moved_constant_1265 + tmp_kernel_op_395*tmp_moved_constant_1268) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1213 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1218 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1221) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1262 + tmp_kernel_op_400*tmp_moved_constant_1265 + tmp_kernel_op_401*tmp_moved_constant_1268) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1213 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1218 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1221) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1262 + tmp_kernel_op_406*tmp_moved_constant_1265 + tmp_kernel_op_407*tmp_moved_constant_1268) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1216 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1221 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1223) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1262 + tmp_kernel_op_412*tmp_moved_constant_1265 + tmp_kernel_op_413*tmp_moved_constant_1268) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1216 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1221 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1223) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1262 + tmp_kernel_op_418*tmp_moved_constant_1265 + tmp_kernel_op_419*tmp_moved_constant_1268) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1216 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1221 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1223) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1262 + tmp_kernel_op_424*tmp_moved_constant_1265 + tmp_kernel_op_425*tmp_moved_constant_1268);
             const real_t tmp_kernel_op_628 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1269 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1272 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1275) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1283 + tmp_kernel_op_35*tmp_moved_constant_1286 + tmp_kernel_op_37*tmp_moved_constant_1289) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1269 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1272 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1275) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1283 + tmp_kernel_op_42*tmp_moved_constant_1286 + tmp_kernel_op_43*tmp_moved_constant_1289) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1269 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1272 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1275) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1283 + tmp_kernel_op_48*tmp_moved_constant_1286 + tmp_kernel_op_49*tmp_moved_constant_1289) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1272 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1276 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1279) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1283 + tmp_kernel_op_54*tmp_moved_constant_1286 + tmp_kernel_op_55*tmp_moved_constant_1289) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1272 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1276 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1279) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1283 + tmp_kernel_op_60*tmp_moved_constant_1286 + tmp_kernel_op_61*tmp_moved_constant_1289) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1272 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1276 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1279) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1283 + tmp_kernel_op_66*tmp_moved_constant_1286 + tmp_kernel_op_67*tmp_moved_constant_1289) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1275 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1279 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1280) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1283 + tmp_kernel_op_72*tmp_moved_constant_1286 + tmp_kernel_op_73*tmp_moved_constant_1289) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1275 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1279 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1280) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1283 + tmp_kernel_op_78*tmp_moved_constant_1286 + tmp_kernel_op_79*tmp_moved_constant_1289) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1275 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1279 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1280) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1283 + tmp_kernel_op_84*tmp_moved_constant_1286 + tmp_kernel_op_85*tmp_moved_constant_1289);
             const real_t tmp_kernel_op_638 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1269 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1272 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1275) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1292 + tmp_kernel_op_120*tmp_moved_constant_1295 + tmp_kernel_op_122*tmp_moved_constant_1298) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1269 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1272 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1275) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1292 + tmp_kernel_op_127*tmp_moved_constant_1295 + tmp_kernel_op_128*tmp_moved_constant_1298) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1269 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1272 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1275) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1292 + tmp_kernel_op_133*tmp_moved_constant_1295 + tmp_kernel_op_134*tmp_moved_constant_1298) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1272 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1276 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1279) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1292 + tmp_kernel_op_139*tmp_moved_constant_1295 + tmp_kernel_op_140*tmp_moved_constant_1298) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1272 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1276 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1279) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1292 + tmp_kernel_op_145*tmp_moved_constant_1295 + tmp_kernel_op_146*tmp_moved_constant_1298) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1272 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1276 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1279) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1292 + tmp_kernel_op_151*tmp_moved_constant_1295 + tmp_kernel_op_152*tmp_moved_constant_1298) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1275 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1279 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1280) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1292 + tmp_kernel_op_157*tmp_moved_constant_1295 + tmp_kernel_op_158*tmp_moved_constant_1298) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1275 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1279 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1280) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1292 + tmp_kernel_op_163*tmp_moved_constant_1295 + tmp_kernel_op_164*tmp_moved_constant_1298) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1275 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1279 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1280) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1292 + tmp_kernel_op_169*tmp_moved_constant_1295 + tmp_kernel_op_170*tmp_moved_constant_1298);
             const real_t tmp_kernel_op_648 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1269 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1272 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1275) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1301 + tmp_kernel_op_205*tmp_moved_constant_1304 + tmp_kernel_op_207*tmp_moved_constant_1307) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1269 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1272 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1275) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1301 + tmp_kernel_op_212*tmp_moved_constant_1304 + tmp_kernel_op_213*tmp_moved_constant_1307) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1269 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1272 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1275) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1301 + tmp_kernel_op_218*tmp_moved_constant_1304 + tmp_kernel_op_219*tmp_moved_constant_1307) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1272 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1276 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1279) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1301 + tmp_kernel_op_224*tmp_moved_constant_1304 + tmp_kernel_op_225*tmp_moved_constant_1307) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1272 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1276 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1279) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1301 + tmp_kernel_op_230*tmp_moved_constant_1304 + tmp_kernel_op_231*tmp_moved_constant_1307) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1272 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1276 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1279) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1301 + tmp_kernel_op_236*tmp_moved_constant_1304 + tmp_kernel_op_237*tmp_moved_constant_1307) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1275 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1279 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1280) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1301 + tmp_kernel_op_242*tmp_moved_constant_1304 + tmp_kernel_op_243*tmp_moved_constant_1307) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1275 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1279 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1280) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1301 + tmp_kernel_op_248*tmp_moved_constant_1304 + tmp_kernel_op_249*tmp_moved_constant_1307) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1275 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1279 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1280) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1301 + tmp_kernel_op_254*tmp_moved_constant_1304 + tmp_kernel_op_255*tmp_moved_constant_1307);
             const real_t tmp_kernel_op_658 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1269 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1272 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1275) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1310 + tmp_kernel_op_290*tmp_moved_constant_1313 + tmp_kernel_op_292*tmp_moved_constant_1316) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1269 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1272 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1275) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1310 + tmp_kernel_op_297*tmp_moved_constant_1313 + tmp_kernel_op_298*tmp_moved_constant_1316) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1269 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1272 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1275) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1310 + tmp_kernel_op_303*tmp_moved_constant_1313 + tmp_kernel_op_304*tmp_moved_constant_1316) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1272 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1276 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1279) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1310 + tmp_kernel_op_309*tmp_moved_constant_1313 + tmp_kernel_op_310*tmp_moved_constant_1316) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1272 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1276 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1279) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1310 + tmp_kernel_op_315*tmp_moved_constant_1313 + tmp_kernel_op_316*tmp_moved_constant_1316) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1272 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1276 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1279) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1310 + tmp_kernel_op_321*tmp_moved_constant_1313 + tmp_kernel_op_322*tmp_moved_constant_1316) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1275 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1279 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1280) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1310 + tmp_kernel_op_327*tmp_moved_constant_1313 + tmp_kernel_op_328*tmp_moved_constant_1316) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1275 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1279 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1280) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1310 + tmp_kernel_op_333*tmp_moved_constant_1313 + tmp_kernel_op_334*tmp_moved_constant_1316) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1275 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1279 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1280) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1310 + tmp_kernel_op_339*tmp_moved_constant_1313 + tmp_kernel_op_340*tmp_moved_constant_1316);
             const real_t tmp_kernel_op_668 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1269 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1272 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1275) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1319 + tmp_kernel_op_375*tmp_moved_constant_1322 + tmp_kernel_op_377*tmp_moved_constant_1325) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1269 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1272 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1275) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1319 + tmp_kernel_op_382*tmp_moved_constant_1322 + tmp_kernel_op_383*tmp_moved_constant_1325) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1269 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1272 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1275) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1319 + tmp_kernel_op_388*tmp_moved_constant_1322 + tmp_kernel_op_389*tmp_moved_constant_1325) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1272 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1276 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1279) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1319 + tmp_kernel_op_394*tmp_moved_constant_1322 + tmp_kernel_op_395*tmp_moved_constant_1325) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1272 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1276 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1279) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1319 + tmp_kernel_op_400*tmp_moved_constant_1322 + tmp_kernel_op_401*tmp_moved_constant_1325) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1272 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1276 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1279) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1319 + tmp_kernel_op_406*tmp_moved_constant_1322 + tmp_kernel_op_407*tmp_moved_constant_1325) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1275 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1279 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1280) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1319 + tmp_kernel_op_412*tmp_moved_constant_1322 + tmp_kernel_op_413*tmp_moved_constant_1325) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1275 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1279 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1280) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1319 + tmp_kernel_op_418*tmp_moved_constant_1322 + tmp_kernel_op_419*tmp_moved_constant_1325) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1275 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1279 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1280) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1319 + tmp_kernel_op_424*tmp_moved_constant_1322 + tmp_kernel_op_425*tmp_moved_constant_1325);
             const real_t tmp_kernel_op_693 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1327 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1330 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1333) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1343 + tmp_kernel_op_35*tmp_moved_constant_1346 + tmp_kernel_op_37*tmp_moved_constant_1349) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1327 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1330 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1333) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1343 + tmp_kernel_op_42*tmp_moved_constant_1346 + tmp_kernel_op_43*tmp_moved_constant_1349) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1327 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1330 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1333) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1343 + tmp_kernel_op_48*tmp_moved_constant_1346 + tmp_kernel_op_49*tmp_moved_constant_1349) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1330 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1335 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1338) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1343 + tmp_kernel_op_54*tmp_moved_constant_1346 + tmp_kernel_op_55*tmp_moved_constant_1349) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1330 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1335 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1338) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1343 + tmp_kernel_op_60*tmp_moved_constant_1346 + tmp_kernel_op_61*tmp_moved_constant_1349) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1330 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1335 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1338) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1343 + tmp_kernel_op_66*tmp_moved_constant_1346 + tmp_kernel_op_67*tmp_moved_constant_1349) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1333 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1338 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1340) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1343 + tmp_kernel_op_72*tmp_moved_constant_1346 + tmp_kernel_op_73*tmp_moved_constant_1349) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1333 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1338 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1340) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1343 + tmp_kernel_op_78*tmp_moved_constant_1346 + tmp_kernel_op_79*tmp_moved_constant_1349) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1333 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1338 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1340) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1343 + tmp_kernel_op_84*tmp_moved_constant_1346 + tmp_kernel_op_85*tmp_moved_constant_1349);
             const real_t tmp_kernel_op_703 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1327 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1330 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1333) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1352 + tmp_kernel_op_120*tmp_moved_constant_1355 + tmp_kernel_op_122*tmp_moved_constant_1358) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1327 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1330 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1333) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1352 + tmp_kernel_op_127*tmp_moved_constant_1355 + tmp_kernel_op_128*tmp_moved_constant_1358) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1327 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1330 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1333) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1352 + tmp_kernel_op_133*tmp_moved_constant_1355 + tmp_kernel_op_134*tmp_moved_constant_1358) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1330 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1335 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1338) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1352 + tmp_kernel_op_139*tmp_moved_constant_1355 + tmp_kernel_op_140*tmp_moved_constant_1358) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1330 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1335 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1338) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1352 + tmp_kernel_op_145*tmp_moved_constant_1355 + tmp_kernel_op_146*tmp_moved_constant_1358) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1330 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1335 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1338) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1352 + tmp_kernel_op_151*tmp_moved_constant_1355 + tmp_kernel_op_152*tmp_moved_constant_1358) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1333 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1338 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1340) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1352 + tmp_kernel_op_157*tmp_moved_constant_1355 + tmp_kernel_op_158*tmp_moved_constant_1358) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1333 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1338 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1340) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1352 + tmp_kernel_op_163*tmp_moved_constant_1355 + tmp_kernel_op_164*tmp_moved_constant_1358) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1333 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1338 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1340) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1352 + tmp_kernel_op_169*tmp_moved_constant_1355 + tmp_kernel_op_170*tmp_moved_constant_1358);
             const real_t tmp_kernel_op_713 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1327 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1330 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1333) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1361 + tmp_kernel_op_205*tmp_moved_constant_1364 + tmp_kernel_op_207*tmp_moved_constant_1367) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1327 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1330 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1333) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1361 + tmp_kernel_op_212*tmp_moved_constant_1364 + tmp_kernel_op_213*tmp_moved_constant_1367) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1327 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1330 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1333) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1361 + tmp_kernel_op_218*tmp_moved_constant_1364 + tmp_kernel_op_219*tmp_moved_constant_1367) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1330 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1335 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1338) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1361 + tmp_kernel_op_224*tmp_moved_constant_1364 + tmp_kernel_op_225*tmp_moved_constant_1367) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1330 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1335 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1338) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1361 + tmp_kernel_op_230*tmp_moved_constant_1364 + tmp_kernel_op_231*tmp_moved_constant_1367) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1330 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1335 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1338) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1361 + tmp_kernel_op_236*tmp_moved_constant_1364 + tmp_kernel_op_237*tmp_moved_constant_1367) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1333 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1338 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1340) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1361 + tmp_kernel_op_242*tmp_moved_constant_1364 + tmp_kernel_op_243*tmp_moved_constant_1367) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1333 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1338 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1340) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1361 + tmp_kernel_op_248*tmp_moved_constant_1364 + tmp_kernel_op_249*tmp_moved_constant_1367) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1333 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1338 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1340) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1361 + tmp_kernel_op_254*tmp_moved_constant_1364 + tmp_kernel_op_255*tmp_moved_constant_1367);
             const real_t tmp_kernel_op_723 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1327 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1330 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1333) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1370 + tmp_kernel_op_290*tmp_moved_constant_1373 + tmp_kernel_op_292*tmp_moved_constant_1376) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1327 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1330 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1333) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1370 + tmp_kernel_op_297*tmp_moved_constant_1373 + tmp_kernel_op_298*tmp_moved_constant_1376) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1327 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1330 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1333) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1370 + tmp_kernel_op_303*tmp_moved_constant_1373 + tmp_kernel_op_304*tmp_moved_constant_1376) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1330 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1335 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1338) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1370 + tmp_kernel_op_309*tmp_moved_constant_1373 + tmp_kernel_op_310*tmp_moved_constant_1376) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1330 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1335 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1338) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1370 + tmp_kernel_op_315*tmp_moved_constant_1373 + tmp_kernel_op_316*tmp_moved_constant_1376) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1330 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1335 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1338) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1370 + tmp_kernel_op_321*tmp_moved_constant_1373 + tmp_kernel_op_322*tmp_moved_constant_1376) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1333 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1338 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1340) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1370 + tmp_kernel_op_327*tmp_moved_constant_1373 + tmp_kernel_op_328*tmp_moved_constant_1376) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1333 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1338 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1340) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1370 + tmp_kernel_op_333*tmp_moved_constant_1373 + tmp_kernel_op_334*tmp_moved_constant_1376) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1333 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1338 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1340) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1370 + tmp_kernel_op_339*tmp_moved_constant_1373 + tmp_kernel_op_340*tmp_moved_constant_1376);
             const real_t tmp_kernel_op_733 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1327 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1330 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1333) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1379 + tmp_kernel_op_375*tmp_moved_constant_1382 + tmp_kernel_op_377*tmp_moved_constant_1385) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1327 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1330 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1333) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1379 + tmp_kernel_op_382*tmp_moved_constant_1382 + tmp_kernel_op_383*tmp_moved_constant_1385) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1327 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1330 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1333) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1379 + tmp_kernel_op_388*tmp_moved_constant_1382 + tmp_kernel_op_389*tmp_moved_constant_1385) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1330 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1335 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1338) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1379 + tmp_kernel_op_394*tmp_moved_constant_1382 + tmp_kernel_op_395*tmp_moved_constant_1385) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1330 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1335 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1338) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1379 + tmp_kernel_op_400*tmp_moved_constant_1382 + tmp_kernel_op_401*tmp_moved_constant_1385) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1330 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1335 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1338) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1379 + tmp_kernel_op_406*tmp_moved_constant_1382 + tmp_kernel_op_407*tmp_moved_constant_1385) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1333 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1338 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1340) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1379 + tmp_kernel_op_412*tmp_moved_constant_1382 + tmp_kernel_op_413*tmp_moved_constant_1385) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1333 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1338 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1340) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1379 + tmp_kernel_op_418*tmp_moved_constant_1382 + tmp_kernel_op_419*tmp_moved_constant_1385) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1333 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1338 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1340) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1379 + tmp_kernel_op_424*tmp_moved_constant_1382 + tmp_kernel_op_425*tmp_moved_constant_1385);
             const real_t tmp_kernel_op_756 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1389 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1391 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1393) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1404 + tmp_kernel_op_35*tmp_moved_constant_1405 + tmp_kernel_op_37*tmp_moved_constant_1406) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1389 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1391 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1393) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1404 + tmp_kernel_op_42*tmp_moved_constant_1405 + tmp_kernel_op_43*tmp_moved_constant_1406) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1389 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1391 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1393) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1404 + tmp_kernel_op_48*tmp_moved_constant_1405 + tmp_kernel_op_49*tmp_moved_constant_1406) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1394 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1397 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1398) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1404 + tmp_kernel_op_54*tmp_moved_constant_1405 + tmp_kernel_op_55*tmp_moved_constant_1406) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1394 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1397 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1398) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1404 + tmp_kernel_op_60*tmp_moved_constant_1405 + tmp_kernel_op_61*tmp_moved_constant_1406) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1394 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1397 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1398) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1404 + tmp_kernel_op_66*tmp_moved_constant_1405 + tmp_kernel_op_67*tmp_moved_constant_1406) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1399 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1400 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1403) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1404 + tmp_kernel_op_72*tmp_moved_constant_1405 + tmp_kernel_op_73*tmp_moved_constant_1406) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1399 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1400 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1403) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1404 + tmp_kernel_op_78*tmp_moved_constant_1405 + tmp_kernel_op_79*tmp_moved_constant_1406) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1399 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1400 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1403) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1404 + tmp_kernel_op_84*tmp_moved_constant_1405 + tmp_kernel_op_85*tmp_moved_constant_1406);
             const real_t tmp_kernel_op_761 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1389 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1391 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1393) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1407 + tmp_kernel_op_120*tmp_moved_constant_1408 + tmp_kernel_op_122*tmp_moved_constant_1409) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1389 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1391 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1393) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1407 + tmp_kernel_op_127*tmp_moved_constant_1408 + tmp_kernel_op_128*tmp_moved_constant_1409) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1389 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1391 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1393) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1407 + tmp_kernel_op_133*tmp_moved_constant_1408 + tmp_kernel_op_134*tmp_moved_constant_1409) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1394 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1397 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1398) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1407 + tmp_kernel_op_139*tmp_moved_constant_1408 + tmp_kernel_op_140*tmp_moved_constant_1409) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1394 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1397 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1398) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1407 + tmp_kernel_op_145*tmp_moved_constant_1408 + tmp_kernel_op_146*tmp_moved_constant_1409) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1394 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1397 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1398) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1407 + tmp_kernel_op_151*tmp_moved_constant_1408 + tmp_kernel_op_152*tmp_moved_constant_1409) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1399 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1400 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1403) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1407 + tmp_kernel_op_157*tmp_moved_constant_1408 + tmp_kernel_op_158*tmp_moved_constant_1409) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1399 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1400 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1403) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1407 + tmp_kernel_op_163*tmp_moved_constant_1408 + tmp_kernel_op_164*tmp_moved_constant_1409) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1399 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1400 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1403) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1407 + tmp_kernel_op_169*tmp_moved_constant_1408 + tmp_kernel_op_170*tmp_moved_constant_1409);
             const real_t tmp_kernel_op_766 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1389 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1391 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1393) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1410 + tmp_kernel_op_205*tmp_moved_constant_1411 + tmp_kernel_op_207*tmp_moved_constant_1412) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1389 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1391 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1393) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1410 + tmp_kernel_op_212*tmp_moved_constant_1411 + tmp_kernel_op_213*tmp_moved_constant_1412) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1389 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1391 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1393) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1410 + tmp_kernel_op_218*tmp_moved_constant_1411 + tmp_kernel_op_219*tmp_moved_constant_1412) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1394 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1397 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1398) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1410 + tmp_kernel_op_224*tmp_moved_constant_1411 + tmp_kernel_op_225*tmp_moved_constant_1412) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1394 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1397 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1398) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1410 + tmp_kernel_op_230*tmp_moved_constant_1411 + tmp_kernel_op_231*tmp_moved_constant_1412) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1394 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1397 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1398) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1410 + tmp_kernel_op_236*tmp_moved_constant_1411 + tmp_kernel_op_237*tmp_moved_constant_1412) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1399 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1400 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1403) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1410 + tmp_kernel_op_242*tmp_moved_constant_1411 + tmp_kernel_op_243*tmp_moved_constant_1412) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1399 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1400 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1403) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1410 + tmp_kernel_op_248*tmp_moved_constant_1411 + tmp_kernel_op_249*tmp_moved_constant_1412) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1399 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1400 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1403) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1410 + tmp_kernel_op_254*tmp_moved_constant_1411 + tmp_kernel_op_255*tmp_moved_constant_1412);
             const real_t tmp_kernel_op_771 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1389 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1391 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1393) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1413 + tmp_kernel_op_290*tmp_moved_constant_1414 + tmp_kernel_op_292*tmp_moved_constant_1415) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1389 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1391 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1393) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1413 + tmp_kernel_op_297*tmp_moved_constant_1414 + tmp_kernel_op_298*tmp_moved_constant_1415) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1389 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1391 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1393) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1413 + tmp_kernel_op_303*tmp_moved_constant_1414 + tmp_kernel_op_304*tmp_moved_constant_1415) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1394 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1397 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1398) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1413 + tmp_kernel_op_309*tmp_moved_constant_1414 + tmp_kernel_op_310*tmp_moved_constant_1415) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1394 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1397 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1398) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1413 + tmp_kernel_op_315*tmp_moved_constant_1414 + tmp_kernel_op_316*tmp_moved_constant_1415) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1394 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1397 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1398) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1413 + tmp_kernel_op_321*tmp_moved_constant_1414 + tmp_kernel_op_322*tmp_moved_constant_1415) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1399 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1400 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1403) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1413 + tmp_kernel_op_327*tmp_moved_constant_1414 + tmp_kernel_op_328*tmp_moved_constant_1415) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1399 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1400 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1403) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1413 + tmp_kernel_op_333*tmp_moved_constant_1414 + tmp_kernel_op_334*tmp_moved_constant_1415) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1399 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1400 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1403) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1413 + tmp_kernel_op_339*tmp_moved_constant_1414 + tmp_kernel_op_340*tmp_moved_constant_1415);
             const real_t tmp_kernel_op_776 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1389 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1391 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1393) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1416 + tmp_kernel_op_375*tmp_moved_constant_1417 + tmp_kernel_op_377*tmp_moved_constant_1418) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1389 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1391 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1393) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1416 + tmp_kernel_op_382*tmp_moved_constant_1417 + tmp_kernel_op_383*tmp_moved_constant_1418) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1389 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1391 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1393) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1416 + tmp_kernel_op_388*tmp_moved_constant_1417 + tmp_kernel_op_389*tmp_moved_constant_1418) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1394 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1397 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1398) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1416 + tmp_kernel_op_394*tmp_moved_constant_1417 + tmp_kernel_op_395*tmp_moved_constant_1418) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1394 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1397 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1398) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1416 + tmp_kernel_op_400*tmp_moved_constant_1417 + tmp_kernel_op_401*tmp_moved_constant_1418) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1394 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1397 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1398) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1416 + tmp_kernel_op_406*tmp_moved_constant_1417 + tmp_kernel_op_407*tmp_moved_constant_1418) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1399 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1400 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1403) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1416 + tmp_kernel_op_412*tmp_moved_constant_1417 + tmp_kernel_op_413*tmp_moved_constant_1418) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1399 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1400 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1403) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1416 + tmp_kernel_op_418*tmp_moved_constant_1417 + tmp_kernel_op_419*tmp_moved_constant_1418) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1399 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1400 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1403) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1416 + tmp_kernel_op_424*tmp_moved_constant_1417 + tmp_kernel_op_425*tmp_moved_constant_1418);
             const real_t tmp_kernel_op_797 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1421 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1423 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1425) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1434 + tmp_kernel_op_35*tmp_moved_constant_1435 + tmp_kernel_op_37*tmp_moved_constant_1436) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1421 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1423 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1425) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1434 + tmp_kernel_op_42*tmp_moved_constant_1435 + tmp_kernel_op_43*tmp_moved_constant_1436) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1421 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1423 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1425) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1434 + tmp_kernel_op_48*tmp_moved_constant_1435 + tmp_kernel_op_49*tmp_moved_constant_1436) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1426 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1428 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1429) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1434 + tmp_kernel_op_54*tmp_moved_constant_1435 + tmp_kernel_op_55*tmp_moved_constant_1436) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1426 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1428 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1429) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1434 + tmp_kernel_op_60*tmp_moved_constant_1435 + tmp_kernel_op_61*tmp_moved_constant_1436) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1426 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1428 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1429) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1434 + tmp_kernel_op_66*tmp_moved_constant_1435 + tmp_kernel_op_67*tmp_moved_constant_1436) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1430 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1431 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1433) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1434 + tmp_kernel_op_72*tmp_moved_constant_1435 + tmp_kernel_op_73*tmp_moved_constant_1436) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1430 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1431 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1433) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1434 + tmp_kernel_op_78*tmp_moved_constant_1435 + tmp_kernel_op_79*tmp_moved_constant_1436) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1430 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1431 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1433) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1434 + tmp_kernel_op_84*tmp_moved_constant_1435 + tmp_kernel_op_85*tmp_moved_constant_1436);
             const real_t tmp_kernel_op_803 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1421 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1423 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1425) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1437 + tmp_kernel_op_120*tmp_moved_constant_1438 + tmp_kernel_op_122*tmp_moved_constant_1439) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1421 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1423 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1425) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1437 + tmp_kernel_op_127*tmp_moved_constant_1438 + tmp_kernel_op_128*tmp_moved_constant_1439) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1421 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1423 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1425) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1437 + tmp_kernel_op_133*tmp_moved_constant_1438 + tmp_kernel_op_134*tmp_moved_constant_1439) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1426 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1428 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1429) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1437 + tmp_kernel_op_139*tmp_moved_constant_1438 + tmp_kernel_op_140*tmp_moved_constant_1439) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1426 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1428 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1429) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1437 + tmp_kernel_op_145*tmp_moved_constant_1438 + tmp_kernel_op_146*tmp_moved_constant_1439) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1426 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1428 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1429) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1437 + tmp_kernel_op_151*tmp_moved_constant_1438 + tmp_kernel_op_152*tmp_moved_constant_1439) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1430 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1431 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1433) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1437 + tmp_kernel_op_157*tmp_moved_constant_1438 + tmp_kernel_op_158*tmp_moved_constant_1439) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1430 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1431 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1433) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1437 + tmp_kernel_op_163*tmp_moved_constant_1438 + tmp_kernel_op_164*tmp_moved_constant_1439) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1430 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1431 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1433) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1437 + tmp_kernel_op_169*tmp_moved_constant_1438 + tmp_kernel_op_170*tmp_moved_constant_1439);
             const real_t tmp_kernel_op_809 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1421 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1423 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1425) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1440 + tmp_kernel_op_205*tmp_moved_constant_1441 + tmp_kernel_op_207*tmp_moved_constant_1442) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1421 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1423 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1425) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1440 + tmp_kernel_op_212*tmp_moved_constant_1441 + tmp_kernel_op_213*tmp_moved_constant_1442) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1421 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1423 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1425) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1440 + tmp_kernel_op_218*tmp_moved_constant_1441 + tmp_kernel_op_219*tmp_moved_constant_1442) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1426 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1428 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1429) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1440 + tmp_kernel_op_224*tmp_moved_constant_1441 + tmp_kernel_op_225*tmp_moved_constant_1442) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1426 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1428 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1429) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1440 + tmp_kernel_op_230*tmp_moved_constant_1441 + tmp_kernel_op_231*tmp_moved_constant_1442) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1426 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1428 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1429) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1440 + tmp_kernel_op_236*tmp_moved_constant_1441 + tmp_kernel_op_237*tmp_moved_constant_1442) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1430 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1431 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1433) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1440 + tmp_kernel_op_242*tmp_moved_constant_1441 + tmp_kernel_op_243*tmp_moved_constant_1442) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1430 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1431 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1433) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1440 + tmp_kernel_op_248*tmp_moved_constant_1441 + tmp_kernel_op_249*tmp_moved_constant_1442) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1430 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1431 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1433) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1440 + tmp_kernel_op_254*tmp_moved_constant_1441 + tmp_kernel_op_255*tmp_moved_constant_1442);
             const real_t tmp_kernel_op_815 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1421 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1423 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1425) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1443 + tmp_kernel_op_290*tmp_moved_constant_1444 + tmp_kernel_op_292*tmp_moved_constant_1445) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1421 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1423 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1425) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1443 + tmp_kernel_op_297*tmp_moved_constant_1444 + tmp_kernel_op_298*tmp_moved_constant_1445) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1421 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1423 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1425) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1443 + tmp_kernel_op_303*tmp_moved_constant_1444 + tmp_kernel_op_304*tmp_moved_constant_1445) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1426 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1428 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1429) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1443 + tmp_kernel_op_309*tmp_moved_constant_1444 + tmp_kernel_op_310*tmp_moved_constant_1445) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1426 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1428 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1429) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1443 + tmp_kernel_op_315*tmp_moved_constant_1444 + tmp_kernel_op_316*tmp_moved_constant_1445) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1426 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1428 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1429) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1443 + tmp_kernel_op_321*tmp_moved_constant_1444 + tmp_kernel_op_322*tmp_moved_constant_1445) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1430 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1431 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1433) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1443 + tmp_kernel_op_327*tmp_moved_constant_1444 + tmp_kernel_op_328*tmp_moved_constant_1445) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1430 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1431 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1433) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1443 + tmp_kernel_op_333*tmp_moved_constant_1444 + tmp_kernel_op_334*tmp_moved_constant_1445) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1430 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1431 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1433) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1443 + tmp_kernel_op_339*tmp_moved_constant_1444 + tmp_kernel_op_340*tmp_moved_constant_1445);
             const real_t tmp_kernel_op_821 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1421 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1423 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1425) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1446 + tmp_kernel_op_375*tmp_moved_constant_1447 + tmp_kernel_op_377*tmp_moved_constant_1448) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1421 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1423 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1425) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1446 + tmp_kernel_op_382*tmp_moved_constant_1447 + tmp_kernel_op_383*tmp_moved_constant_1448) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1421 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1423 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1425) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1446 + tmp_kernel_op_388*tmp_moved_constant_1447 + tmp_kernel_op_389*tmp_moved_constant_1448) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1426 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1428 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1429) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1446 + tmp_kernel_op_394*tmp_moved_constant_1447 + tmp_kernel_op_395*tmp_moved_constant_1448) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1426 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1428 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1429) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1446 + tmp_kernel_op_400*tmp_moved_constant_1447 + tmp_kernel_op_401*tmp_moved_constant_1448) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1426 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1428 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1429) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1446 + tmp_kernel_op_406*tmp_moved_constant_1447 + tmp_kernel_op_407*tmp_moved_constant_1448) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1430 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1431 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1433) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1446 + tmp_kernel_op_412*tmp_moved_constant_1447 + tmp_kernel_op_413*tmp_moved_constant_1448) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1430 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1431 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1433) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1446 + tmp_kernel_op_418*tmp_moved_constant_1447 + tmp_kernel_op_419*tmp_moved_constant_1448) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1430 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1431 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1433) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1446 + tmp_kernel_op_424*tmp_moved_constant_1447 + tmp_kernel_op_425*tmp_moved_constant_1448);
             const real_t tmp_kernel_op_838 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1450 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1452 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1454) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1461 + tmp_kernel_op_35*tmp_moved_constant_1462 + tmp_kernel_op_37*tmp_moved_constant_1463) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1450 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1452 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1454) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1461 + tmp_kernel_op_42*tmp_moved_constant_1462 + tmp_kernel_op_43*tmp_moved_constant_1463) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1450 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1452 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1454) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1461 + tmp_kernel_op_48*tmp_moved_constant_1462 + tmp_kernel_op_49*tmp_moved_constant_1463) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1455 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1456 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1457) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1461 + tmp_kernel_op_54*tmp_moved_constant_1462 + tmp_kernel_op_55*tmp_moved_constant_1463) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1455 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1456 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1457) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1461 + tmp_kernel_op_60*tmp_moved_constant_1462 + tmp_kernel_op_61*tmp_moved_constant_1463) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1455 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1456 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1457) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1461 + tmp_kernel_op_66*tmp_moved_constant_1462 + tmp_kernel_op_67*tmp_moved_constant_1463) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1458 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1459 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1460) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1461 + tmp_kernel_op_72*tmp_moved_constant_1462 + tmp_kernel_op_73*tmp_moved_constant_1463) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1458 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1459 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1460) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1461 + tmp_kernel_op_78*tmp_moved_constant_1462 + tmp_kernel_op_79*tmp_moved_constant_1463) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1458 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1459 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1460) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1461 + tmp_kernel_op_84*tmp_moved_constant_1462 + tmp_kernel_op_85*tmp_moved_constant_1463);
             const real_t tmp_kernel_op_843 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1450 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1452 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1454) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1464 + tmp_kernel_op_120*tmp_moved_constant_1465 + tmp_kernel_op_122*tmp_moved_constant_1466) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1450 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1452 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1454) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1464 + tmp_kernel_op_127*tmp_moved_constant_1465 + tmp_kernel_op_128*tmp_moved_constant_1466) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1450 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1452 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1454) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1464 + tmp_kernel_op_133*tmp_moved_constant_1465 + tmp_kernel_op_134*tmp_moved_constant_1466) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1455 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1456 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1457) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1464 + tmp_kernel_op_139*tmp_moved_constant_1465 + tmp_kernel_op_140*tmp_moved_constant_1466) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1455 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1456 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1457) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1464 + tmp_kernel_op_145*tmp_moved_constant_1465 + tmp_kernel_op_146*tmp_moved_constant_1466) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1455 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1456 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1457) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1464 + tmp_kernel_op_151*tmp_moved_constant_1465 + tmp_kernel_op_152*tmp_moved_constant_1466) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1458 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1459 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1460) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1464 + tmp_kernel_op_157*tmp_moved_constant_1465 + tmp_kernel_op_158*tmp_moved_constant_1466) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1458 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1459 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1460) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1464 + tmp_kernel_op_163*tmp_moved_constant_1465 + tmp_kernel_op_164*tmp_moved_constant_1466) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1458 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1459 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1460) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1464 + tmp_kernel_op_169*tmp_moved_constant_1465 + tmp_kernel_op_170*tmp_moved_constant_1466);
             const real_t tmp_kernel_op_848 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1450 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1452 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1454) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1467 + tmp_kernel_op_205*tmp_moved_constant_1468 + tmp_kernel_op_207*tmp_moved_constant_1469) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1450 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1452 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1454) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1467 + tmp_kernel_op_212*tmp_moved_constant_1468 + tmp_kernel_op_213*tmp_moved_constant_1469) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1450 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1452 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1454) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1467 + tmp_kernel_op_218*tmp_moved_constant_1468 + tmp_kernel_op_219*tmp_moved_constant_1469) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1455 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1456 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1457) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1467 + tmp_kernel_op_224*tmp_moved_constant_1468 + tmp_kernel_op_225*tmp_moved_constant_1469) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1455 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1456 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1457) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1467 + tmp_kernel_op_230*tmp_moved_constant_1468 + tmp_kernel_op_231*tmp_moved_constant_1469) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1455 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1456 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1457) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1467 + tmp_kernel_op_236*tmp_moved_constant_1468 + tmp_kernel_op_237*tmp_moved_constant_1469) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1458 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1459 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1460) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1467 + tmp_kernel_op_242*tmp_moved_constant_1468 + tmp_kernel_op_243*tmp_moved_constant_1469) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1458 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1459 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1460) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1467 + tmp_kernel_op_248*tmp_moved_constant_1468 + tmp_kernel_op_249*tmp_moved_constant_1469) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1458 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1459 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1460) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1467 + tmp_kernel_op_254*tmp_moved_constant_1468 + tmp_kernel_op_255*tmp_moved_constant_1469);
             const real_t tmp_kernel_op_853 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1450 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1452 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1454) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1470 + tmp_kernel_op_290*tmp_moved_constant_1471 + tmp_kernel_op_292*tmp_moved_constant_1472) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1450 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1452 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1454) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1470 + tmp_kernel_op_297*tmp_moved_constant_1471 + tmp_kernel_op_298*tmp_moved_constant_1472) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1450 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1452 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1454) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1470 + tmp_kernel_op_303*tmp_moved_constant_1471 + tmp_kernel_op_304*tmp_moved_constant_1472) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1455 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1456 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1457) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1470 + tmp_kernel_op_309*tmp_moved_constant_1471 + tmp_kernel_op_310*tmp_moved_constant_1472) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1455 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1456 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1457) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1470 + tmp_kernel_op_315*tmp_moved_constant_1471 + tmp_kernel_op_316*tmp_moved_constant_1472) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1455 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1456 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1457) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1470 + tmp_kernel_op_321*tmp_moved_constant_1471 + tmp_kernel_op_322*tmp_moved_constant_1472) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1458 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1459 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1460) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1470 + tmp_kernel_op_327*tmp_moved_constant_1471 + tmp_kernel_op_328*tmp_moved_constant_1472) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1458 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1459 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1460) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1470 + tmp_kernel_op_333*tmp_moved_constant_1471 + tmp_kernel_op_334*tmp_moved_constant_1472) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1458 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1459 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1460) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1470 + tmp_kernel_op_339*tmp_moved_constant_1471 + tmp_kernel_op_340*tmp_moved_constant_1472);
             const real_t tmp_kernel_op_858 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1450 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1452 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1454) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1473 + tmp_kernel_op_375*tmp_moved_constant_1474 + tmp_kernel_op_377*tmp_moved_constant_1475) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1450 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1452 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1454) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1473 + tmp_kernel_op_382*tmp_moved_constant_1474 + tmp_kernel_op_383*tmp_moved_constant_1475) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1450 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1452 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1454) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1473 + tmp_kernel_op_388*tmp_moved_constant_1474 + tmp_kernel_op_389*tmp_moved_constant_1475) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1455 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1456 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1457) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1473 + tmp_kernel_op_394*tmp_moved_constant_1474 + tmp_kernel_op_395*tmp_moved_constant_1475) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1455 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1456 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1457) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1473 + tmp_kernel_op_400*tmp_moved_constant_1474 + tmp_kernel_op_401*tmp_moved_constant_1475) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1455 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1456 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1457) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1473 + tmp_kernel_op_406*tmp_moved_constant_1474 + tmp_kernel_op_407*tmp_moved_constant_1475) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1458 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1459 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1460) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1473 + tmp_kernel_op_412*tmp_moved_constant_1474 + tmp_kernel_op_413*tmp_moved_constant_1475) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1458 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1459 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1460) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1473 + tmp_kernel_op_418*tmp_moved_constant_1474 + tmp_kernel_op_419*tmp_moved_constant_1475) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1458 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1459 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1460) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1473 + tmp_kernel_op_424*tmp_moved_constant_1474 + tmp_kernel_op_425*tmp_moved_constant_1475);
             const real_t tmp_kernel_op_859 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1152 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1153 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1154) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1152 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1153 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1154) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1152 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1153 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1154));
             const real_t tmp_kernel_op_860 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1155 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1156 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1157) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1155 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1156 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1157) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1155 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1156 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1157));
             const real_t tmp_kernel_op_861 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1158 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1159 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1160) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1158 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1159 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1160) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1158 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1159 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1160));
             const real_t tmp_kernel_op_862 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1161 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1162 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1163) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1161 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1162 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1163) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1161 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1162 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1163));
             const real_t tmp_kernel_op_863 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1164 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1165 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1166) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1164 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1165 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1166) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1164 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1165 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1166));
             const real_t tmp_kernel_op_864 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1173 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1174 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1175) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1173 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1174 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1175) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1173 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1174 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1175));
             const real_t tmp_kernel_op_865 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1176 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1177 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1178) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1176 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1177 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1178) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1176 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1177 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1178));
             const real_t tmp_kernel_op_866 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1179 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1180 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1181) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1179 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1180 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1181) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1179 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1180 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1181));
             const real_t tmp_kernel_op_867 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1182 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1183 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1184) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1182 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1183 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1184) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1182 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1183 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1184));
             const real_t tmp_kernel_op_868 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1185 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1186 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1187) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1185 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1186 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1187) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1185 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1186 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1187));
             const real_t tmp_kernel_op_869 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1194 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1195 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1196) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1194 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1195 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1196) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1194 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1195 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1196));
             const real_t tmp_kernel_op_870 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1197 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1198 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1199) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1197 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1198 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1199) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1197 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1198 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1199));
             const real_t tmp_kernel_op_871 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1200 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1201 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1202) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1200 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1201 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1202) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1200 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1201 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1202));
             const real_t tmp_kernel_op_872 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1203 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1204 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1205) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1203 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1204 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1205) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1203 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1204 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1205));
             const real_t tmp_kernel_op_873 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1206 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1207 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1208) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1206 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1207 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1208) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1206 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1207 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1208));
             const real_t tmp_kernel_op_874 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1226 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1229 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1232) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1226 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1229 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1232) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1226 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1229 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1232));
             const real_t tmp_kernel_op_875 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1235 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1238 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1241) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1235 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1238 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1241) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1235 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1238 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1241));
             const real_t tmp_kernel_op_876 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1244 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1247 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1250) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1244 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1247 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1250) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1244 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1247 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1250));
             const real_t tmp_kernel_op_877 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1253 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1256 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1259) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1253 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1256 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1259) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1253 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1256 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1259));
             const real_t tmp_kernel_op_878 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1262 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1265 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1268) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1262 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1265 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1268) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1262 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1265 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1268));
             const real_t tmp_kernel_op_879 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1283 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1286 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1289) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1283 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1286 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1289) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1283 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1286 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1289));
             const real_t tmp_kernel_op_880 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1292 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1295 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1298) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1292 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1295 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1298) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1292 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1295 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1298));
             const real_t tmp_kernel_op_881 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1301 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1304 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1307) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1301 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1304 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1307) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1301 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1304 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1307));
             const real_t tmp_kernel_op_882 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1310 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1313 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1316) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1310 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1313 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1316) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1310 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1313 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1316));
             const real_t tmp_kernel_op_883 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1319 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1322 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1325) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1319 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1322 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1325) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1319 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1322 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1325));
             const real_t tmp_kernel_op_884 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1343 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1346 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1349) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1343 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1346 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1349) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1343 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1346 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1349));
             const real_t tmp_kernel_op_885 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1352 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1355 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1358) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1352 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1355 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1358) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1352 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1355 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1358));
             const real_t tmp_kernel_op_886 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1361 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1364 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1367) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1361 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1364 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1367) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1361 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1364 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1367));
             const real_t tmp_kernel_op_887 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1370 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1373 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1376) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1370 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1373 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1376) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1370 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1373 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1376));
             const real_t tmp_kernel_op_888 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1379 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1382 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1385) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1379 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1382 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1385) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1379 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1382 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1385));
             const real_t tmp_kernel_op_889 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1404 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1405 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1406) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1404 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1405 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1406) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1404 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1405 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1406));
             const real_t tmp_kernel_op_890 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1407 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1408 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1409) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1407 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1408 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1409) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1407 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1408 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1409));
             const real_t tmp_kernel_op_891 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1410 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1411 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1412) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1410 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1411 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1412) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1410 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1411 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1412));
             const real_t tmp_kernel_op_892 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1413 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1414 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1415) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1413 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1414 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1415) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1413 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1414 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1415));
             const real_t tmp_kernel_op_893 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1416 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1417 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1418) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1416 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1417 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1418) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1416 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1417 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1418));
             const real_t tmp_kernel_op_894 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1434 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1435 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1436) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1434 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1435 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1436) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1434 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1435 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1436));
             const real_t tmp_kernel_op_895 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1437 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1438 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1439) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1437 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1438 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1439) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1437 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1438 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1439));
             const real_t tmp_kernel_op_896 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1440 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1441 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1442) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1440 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1441 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1442) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1440 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1441 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1442));
             const real_t tmp_kernel_op_897 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1443 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1444 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1445) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1443 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1444 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1445) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1443 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1444 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1445));
             const real_t tmp_kernel_op_898 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1446 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1447 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1448) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1446 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1447 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1448) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1446 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1447 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1448));
             const real_t tmp_kernel_op_899 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1461 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1462 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1463) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1461 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1462 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1463) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1461 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1462 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1463));
             const real_t tmp_kernel_op_900 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1464 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1465 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1466) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1464 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1465 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1466) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1464 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1465 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1466));
             const real_t tmp_kernel_op_901 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1467 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1468 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1469) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1467 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1468 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1469) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1467 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1468 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1469));
             const real_t tmp_kernel_op_902 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1470 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1471 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1472) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1470 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1471 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1472) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1470 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1471 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1472));
             const real_t tmp_kernel_op_903 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1473 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1474 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1475) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1473 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1474 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1475) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1473 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1474 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1475));
             const real_t elMat_0_0 = tmp_kernel_op_108*tmp_kernel_op_86 + tmp_kernel_op_171*tmp_kernel_op_193 + tmp_kernel_op_256*tmp_kernel_op_278 + tmp_kernel_op_341*tmp_kernel_op_363 + tmp_kernel_op_426*tmp_kernel_op_448;
             const real_t elMat_0_1 = tmp_kernel_op_108*tmp_kernel_op_459 + tmp_kernel_op_193*tmp_kernel_op_464 + tmp_kernel_op_278*tmp_kernel_op_469 + tmp_kernel_op_363*tmp_kernel_op_474 + tmp_kernel_op_448*tmp_kernel_op_479;
             const real_t elMat_0_2 = tmp_kernel_op_108*tmp_kernel_op_490 + tmp_kernel_op_193*tmp_kernel_op_495 + tmp_kernel_op_278*tmp_kernel_op_500 + tmp_kernel_op_363*tmp_kernel_op_505 + tmp_kernel_op_448*tmp_kernel_op_510;
             const real_t elMat_0_3 = tmp_kernel_op_108*tmp_kernel_op_521 + tmp_kernel_op_193*tmp_kernel_op_526 + tmp_kernel_op_278*tmp_kernel_op_531 + tmp_kernel_op_363*tmp_kernel_op_536 + tmp_kernel_op_448*tmp_kernel_op_541;
             const real_t elMat_0_4 = tmp_kernel_op_108*tmp_kernel_op_566 + tmp_kernel_op_193*tmp_kernel_op_576 + tmp_kernel_op_278*tmp_kernel_op_586 + tmp_kernel_op_363*tmp_kernel_op_596 + tmp_kernel_op_448*tmp_kernel_op_606;
             const real_t elMat_0_5 = tmp_kernel_op_108*tmp_kernel_op_628 + tmp_kernel_op_193*tmp_kernel_op_638 + tmp_kernel_op_278*tmp_kernel_op_648 + tmp_kernel_op_363*tmp_kernel_op_658 + tmp_kernel_op_448*tmp_kernel_op_668;
             const real_t elMat_0_6 = tmp_kernel_op_108*tmp_kernel_op_693 + tmp_kernel_op_193*tmp_kernel_op_703 + tmp_kernel_op_278*tmp_kernel_op_713 + tmp_kernel_op_363*tmp_kernel_op_723 + tmp_kernel_op_448*tmp_kernel_op_733;
             const real_t elMat_0_7 = tmp_kernel_op_108*tmp_kernel_op_756 + tmp_kernel_op_193*tmp_kernel_op_761 + tmp_kernel_op_278*tmp_kernel_op_766 + tmp_kernel_op_363*tmp_kernel_op_771 + tmp_kernel_op_448*tmp_kernel_op_776;
             const real_t elMat_0_8 = tmp_kernel_op_108*tmp_kernel_op_797 + tmp_kernel_op_193*tmp_kernel_op_803 + tmp_kernel_op_278*tmp_kernel_op_809 + tmp_kernel_op_363*tmp_kernel_op_815 + tmp_kernel_op_448*tmp_kernel_op_821;
             const real_t elMat_0_9 = tmp_kernel_op_108*tmp_kernel_op_838 + tmp_kernel_op_193*tmp_kernel_op_843 + tmp_kernel_op_278*tmp_kernel_op_848 + tmp_kernel_op_363*tmp_kernel_op_853 + tmp_kernel_op_448*tmp_kernel_op_858;
             const real_t elMat_1_0 = tmp_kernel_op_171*tmp_kernel_op_860 + tmp_kernel_op_256*tmp_kernel_op_861 + tmp_kernel_op_341*tmp_kernel_op_862 + tmp_kernel_op_426*tmp_kernel_op_863 + tmp_kernel_op_859*tmp_kernel_op_86;
             const real_t elMat_1_1 = tmp_kernel_op_459*tmp_kernel_op_859 + tmp_kernel_op_464*tmp_kernel_op_860 + tmp_kernel_op_469*tmp_kernel_op_861 + tmp_kernel_op_474*tmp_kernel_op_862 + tmp_kernel_op_479*tmp_kernel_op_863;
             const real_t elMat_1_2 = tmp_kernel_op_490*tmp_kernel_op_859 + tmp_kernel_op_495*tmp_kernel_op_860 + tmp_kernel_op_500*tmp_kernel_op_861 + tmp_kernel_op_505*tmp_kernel_op_862 + tmp_kernel_op_510*tmp_kernel_op_863;
             const real_t elMat_1_3 = tmp_kernel_op_521*tmp_kernel_op_859 + tmp_kernel_op_526*tmp_kernel_op_860 + tmp_kernel_op_531*tmp_kernel_op_861 + tmp_kernel_op_536*tmp_kernel_op_862 + tmp_kernel_op_541*tmp_kernel_op_863;
             const real_t elMat_1_4 = tmp_kernel_op_566*tmp_kernel_op_859 + tmp_kernel_op_576*tmp_kernel_op_860 + tmp_kernel_op_586*tmp_kernel_op_861 + tmp_kernel_op_596*tmp_kernel_op_862 + tmp_kernel_op_606*tmp_kernel_op_863;
             const real_t elMat_1_5 = tmp_kernel_op_628*tmp_kernel_op_859 + tmp_kernel_op_638*tmp_kernel_op_860 + tmp_kernel_op_648*tmp_kernel_op_861 + tmp_kernel_op_658*tmp_kernel_op_862 + tmp_kernel_op_668*tmp_kernel_op_863;
             const real_t elMat_1_6 = tmp_kernel_op_693*tmp_kernel_op_859 + tmp_kernel_op_703*tmp_kernel_op_860 + tmp_kernel_op_713*tmp_kernel_op_861 + tmp_kernel_op_723*tmp_kernel_op_862 + tmp_kernel_op_733*tmp_kernel_op_863;
             const real_t elMat_1_7 = tmp_kernel_op_756*tmp_kernel_op_859 + tmp_kernel_op_761*tmp_kernel_op_860 + tmp_kernel_op_766*tmp_kernel_op_861 + tmp_kernel_op_771*tmp_kernel_op_862 + tmp_kernel_op_776*tmp_kernel_op_863;
             const real_t elMat_1_8 = tmp_kernel_op_797*tmp_kernel_op_859 + tmp_kernel_op_803*tmp_kernel_op_860 + tmp_kernel_op_809*tmp_kernel_op_861 + tmp_kernel_op_815*tmp_kernel_op_862 + tmp_kernel_op_821*tmp_kernel_op_863;
             const real_t elMat_1_9 = tmp_kernel_op_838*tmp_kernel_op_859 + tmp_kernel_op_843*tmp_kernel_op_860 + tmp_kernel_op_848*tmp_kernel_op_861 + tmp_kernel_op_853*tmp_kernel_op_862 + tmp_kernel_op_858*tmp_kernel_op_863;
             const real_t elMat_2_0 = tmp_kernel_op_171*tmp_kernel_op_865 + tmp_kernel_op_256*tmp_kernel_op_866 + tmp_kernel_op_341*tmp_kernel_op_867 + tmp_kernel_op_426*tmp_kernel_op_868 + tmp_kernel_op_86*tmp_kernel_op_864;
             const real_t elMat_2_1 = tmp_kernel_op_459*tmp_kernel_op_864 + tmp_kernel_op_464*tmp_kernel_op_865 + tmp_kernel_op_469*tmp_kernel_op_866 + tmp_kernel_op_474*tmp_kernel_op_867 + tmp_kernel_op_479*tmp_kernel_op_868;
             const real_t elMat_2_2 = tmp_kernel_op_490*tmp_kernel_op_864 + tmp_kernel_op_495*tmp_kernel_op_865 + tmp_kernel_op_500*tmp_kernel_op_866 + tmp_kernel_op_505*tmp_kernel_op_867 + tmp_kernel_op_510*tmp_kernel_op_868;
             const real_t elMat_2_3 = tmp_kernel_op_521*tmp_kernel_op_864 + tmp_kernel_op_526*tmp_kernel_op_865 + tmp_kernel_op_531*tmp_kernel_op_866 + tmp_kernel_op_536*tmp_kernel_op_867 + tmp_kernel_op_541*tmp_kernel_op_868;
             const real_t elMat_2_4 = tmp_kernel_op_566*tmp_kernel_op_864 + tmp_kernel_op_576*tmp_kernel_op_865 + tmp_kernel_op_586*tmp_kernel_op_866 + tmp_kernel_op_596*tmp_kernel_op_867 + tmp_kernel_op_606*tmp_kernel_op_868;
             const real_t elMat_2_5 = tmp_kernel_op_628*tmp_kernel_op_864 + tmp_kernel_op_638*tmp_kernel_op_865 + tmp_kernel_op_648*tmp_kernel_op_866 + tmp_kernel_op_658*tmp_kernel_op_867 + tmp_kernel_op_668*tmp_kernel_op_868;
             const real_t elMat_2_6 = tmp_kernel_op_693*tmp_kernel_op_864 + tmp_kernel_op_703*tmp_kernel_op_865 + tmp_kernel_op_713*tmp_kernel_op_866 + tmp_kernel_op_723*tmp_kernel_op_867 + tmp_kernel_op_733*tmp_kernel_op_868;
             const real_t elMat_2_7 = tmp_kernel_op_756*tmp_kernel_op_864 + tmp_kernel_op_761*tmp_kernel_op_865 + tmp_kernel_op_766*tmp_kernel_op_866 + tmp_kernel_op_771*tmp_kernel_op_867 + tmp_kernel_op_776*tmp_kernel_op_868;
             const real_t elMat_2_8 = tmp_kernel_op_797*tmp_kernel_op_864 + tmp_kernel_op_803*tmp_kernel_op_865 + tmp_kernel_op_809*tmp_kernel_op_866 + tmp_kernel_op_815*tmp_kernel_op_867 + tmp_kernel_op_821*tmp_kernel_op_868;
             const real_t elMat_2_9 = tmp_kernel_op_838*tmp_kernel_op_864 + tmp_kernel_op_843*tmp_kernel_op_865 + tmp_kernel_op_848*tmp_kernel_op_866 + tmp_kernel_op_853*tmp_kernel_op_867 + tmp_kernel_op_858*tmp_kernel_op_868;
             const real_t elMat_3_0 = tmp_kernel_op_171*tmp_kernel_op_870 + tmp_kernel_op_256*tmp_kernel_op_871 + tmp_kernel_op_341*tmp_kernel_op_872 + tmp_kernel_op_426*tmp_kernel_op_873 + tmp_kernel_op_86*tmp_kernel_op_869;
             const real_t elMat_3_1 = tmp_kernel_op_459*tmp_kernel_op_869 + tmp_kernel_op_464*tmp_kernel_op_870 + tmp_kernel_op_469*tmp_kernel_op_871 + tmp_kernel_op_474*tmp_kernel_op_872 + tmp_kernel_op_479*tmp_kernel_op_873;
             const real_t elMat_3_2 = tmp_kernel_op_490*tmp_kernel_op_869 + tmp_kernel_op_495*tmp_kernel_op_870 + tmp_kernel_op_500*tmp_kernel_op_871 + tmp_kernel_op_505*tmp_kernel_op_872 + tmp_kernel_op_510*tmp_kernel_op_873;
             const real_t elMat_3_3 = tmp_kernel_op_521*tmp_kernel_op_869 + tmp_kernel_op_526*tmp_kernel_op_870 + tmp_kernel_op_531*tmp_kernel_op_871 + tmp_kernel_op_536*tmp_kernel_op_872 + tmp_kernel_op_541*tmp_kernel_op_873;
             const real_t elMat_3_4 = tmp_kernel_op_566*tmp_kernel_op_869 + tmp_kernel_op_576*tmp_kernel_op_870 + tmp_kernel_op_586*tmp_kernel_op_871 + tmp_kernel_op_596*tmp_kernel_op_872 + tmp_kernel_op_606*tmp_kernel_op_873;
             const real_t elMat_3_5 = tmp_kernel_op_628*tmp_kernel_op_869 + tmp_kernel_op_638*tmp_kernel_op_870 + tmp_kernel_op_648*tmp_kernel_op_871 + tmp_kernel_op_658*tmp_kernel_op_872 + tmp_kernel_op_668*tmp_kernel_op_873;
             const real_t elMat_3_6 = tmp_kernel_op_693*tmp_kernel_op_869 + tmp_kernel_op_703*tmp_kernel_op_870 + tmp_kernel_op_713*tmp_kernel_op_871 + tmp_kernel_op_723*tmp_kernel_op_872 + tmp_kernel_op_733*tmp_kernel_op_873;
             const real_t elMat_3_7 = tmp_kernel_op_756*tmp_kernel_op_869 + tmp_kernel_op_761*tmp_kernel_op_870 + tmp_kernel_op_766*tmp_kernel_op_871 + tmp_kernel_op_771*tmp_kernel_op_872 + tmp_kernel_op_776*tmp_kernel_op_873;
             const real_t elMat_3_8 = tmp_kernel_op_797*tmp_kernel_op_869 + tmp_kernel_op_803*tmp_kernel_op_870 + tmp_kernel_op_809*tmp_kernel_op_871 + tmp_kernel_op_815*tmp_kernel_op_872 + tmp_kernel_op_821*tmp_kernel_op_873;
             const real_t elMat_3_9 = tmp_kernel_op_838*tmp_kernel_op_869 + tmp_kernel_op_843*tmp_kernel_op_870 + tmp_kernel_op_848*tmp_kernel_op_871 + tmp_kernel_op_853*tmp_kernel_op_872 + tmp_kernel_op_858*tmp_kernel_op_873;
             const real_t elMat_4_0 = tmp_kernel_op_171*tmp_kernel_op_875 + tmp_kernel_op_256*tmp_kernel_op_876 + tmp_kernel_op_341*tmp_kernel_op_877 + tmp_kernel_op_426*tmp_kernel_op_878 + tmp_kernel_op_86*tmp_kernel_op_874;
             const real_t elMat_4_1 = tmp_kernel_op_459*tmp_kernel_op_874 + tmp_kernel_op_464*tmp_kernel_op_875 + tmp_kernel_op_469*tmp_kernel_op_876 + tmp_kernel_op_474*tmp_kernel_op_877 + tmp_kernel_op_479*tmp_kernel_op_878;
             const real_t elMat_4_2 = tmp_kernel_op_490*tmp_kernel_op_874 + tmp_kernel_op_495*tmp_kernel_op_875 + tmp_kernel_op_500*tmp_kernel_op_876 + tmp_kernel_op_505*tmp_kernel_op_877 + tmp_kernel_op_510*tmp_kernel_op_878;
             const real_t elMat_4_3 = tmp_kernel_op_521*tmp_kernel_op_874 + tmp_kernel_op_526*tmp_kernel_op_875 + tmp_kernel_op_531*tmp_kernel_op_876 + tmp_kernel_op_536*tmp_kernel_op_877 + tmp_kernel_op_541*tmp_kernel_op_878;
             const real_t elMat_4_4 = tmp_kernel_op_566*tmp_kernel_op_874 + tmp_kernel_op_576*tmp_kernel_op_875 + tmp_kernel_op_586*tmp_kernel_op_876 + tmp_kernel_op_596*tmp_kernel_op_877 + tmp_kernel_op_606*tmp_kernel_op_878;
             const real_t elMat_4_5 = tmp_kernel_op_628*tmp_kernel_op_874 + tmp_kernel_op_638*tmp_kernel_op_875 + tmp_kernel_op_648*tmp_kernel_op_876 + tmp_kernel_op_658*tmp_kernel_op_877 + tmp_kernel_op_668*tmp_kernel_op_878;
             const real_t elMat_4_6 = tmp_kernel_op_693*tmp_kernel_op_874 + tmp_kernel_op_703*tmp_kernel_op_875 + tmp_kernel_op_713*tmp_kernel_op_876 + tmp_kernel_op_723*tmp_kernel_op_877 + tmp_kernel_op_733*tmp_kernel_op_878;
             const real_t elMat_4_7 = tmp_kernel_op_756*tmp_kernel_op_874 + tmp_kernel_op_761*tmp_kernel_op_875 + tmp_kernel_op_766*tmp_kernel_op_876 + tmp_kernel_op_771*tmp_kernel_op_877 + tmp_kernel_op_776*tmp_kernel_op_878;
             const real_t elMat_4_8 = tmp_kernel_op_797*tmp_kernel_op_874 + tmp_kernel_op_803*tmp_kernel_op_875 + tmp_kernel_op_809*tmp_kernel_op_876 + tmp_kernel_op_815*tmp_kernel_op_877 + tmp_kernel_op_821*tmp_kernel_op_878;
             const real_t elMat_4_9 = tmp_kernel_op_838*tmp_kernel_op_874 + tmp_kernel_op_843*tmp_kernel_op_875 + tmp_kernel_op_848*tmp_kernel_op_876 + tmp_kernel_op_853*tmp_kernel_op_877 + tmp_kernel_op_858*tmp_kernel_op_878;
             const real_t elMat_5_0 = tmp_kernel_op_171*tmp_kernel_op_880 + tmp_kernel_op_256*tmp_kernel_op_881 + tmp_kernel_op_341*tmp_kernel_op_882 + tmp_kernel_op_426*tmp_kernel_op_883 + tmp_kernel_op_86*tmp_kernel_op_879;
             const real_t elMat_5_1 = tmp_kernel_op_459*tmp_kernel_op_879 + tmp_kernel_op_464*tmp_kernel_op_880 + tmp_kernel_op_469*tmp_kernel_op_881 + tmp_kernel_op_474*tmp_kernel_op_882 + tmp_kernel_op_479*tmp_kernel_op_883;
             const real_t elMat_5_2 = tmp_kernel_op_490*tmp_kernel_op_879 + tmp_kernel_op_495*tmp_kernel_op_880 + tmp_kernel_op_500*tmp_kernel_op_881 + tmp_kernel_op_505*tmp_kernel_op_882 + tmp_kernel_op_510*tmp_kernel_op_883;
             const real_t elMat_5_3 = tmp_kernel_op_521*tmp_kernel_op_879 + tmp_kernel_op_526*tmp_kernel_op_880 + tmp_kernel_op_531*tmp_kernel_op_881 + tmp_kernel_op_536*tmp_kernel_op_882 + tmp_kernel_op_541*tmp_kernel_op_883;
             const real_t elMat_5_4 = tmp_kernel_op_566*tmp_kernel_op_879 + tmp_kernel_op_576*tmp_kernel_op_880 + tmp_kernel_op_586*tmp_kernel_op_881 + tmp_kernel_op_596*tmp_kernel_op_882 + tmp_kernel_op_606*tmp_kernel_op_883;
             const real_t elMat_5_5 = tmp_kernel_op_628*tmp_kernel_op_879 + tmp_kernel_op_638*tmp_kernel_op_880 + tmp_kernel_op_648*tmp_kernel_op_881 + tmp_kernel_op_658*tmp_kernel_op_882 + tmp_kernel_op_668*tmp_kernel_op_883;
             const real_t elMat_5_6 = tmp_kernel_op_693*tmp_kernel_op_879 + tmp_kernel_op_703*tmp_kernel_op_880 + tmp_kernel_op_713*tmp_kernel_op_881 + tmp_kernel_op_723*tmp_kernel_op_882 + tmp_kernel_op_733*tmp_kernel_op_883;
             const real_t elMat_5_7 = tmp_kernel_op_756*tmp_kernel_op_879 + tmp_kernel_op_761*tmp_kernel_op_880 + tmp_kernel_op_766*tmp_kernel_op_881 + tmp_kernel_op_771*tmp_kernel_op_882 + tmp_kernel_op_776*tmp_kernel_op_883;
             const real_t elMat_5_8 = tmp_kernel_op_797*tmp_kernel_op_879 + tmp_kernel_op_803*tmp_kernel_op_880 + tmp_kernel_op_809*tmp_kernel_op_881 + tmp_kernel_op_815*tmp_kernel_op_882 + tmp_kernel_op_821*tmp_kernel_op_883;
             const real_t elMat_5_9 = tmp_kernel_op_838*tmp_kernel_op_879 + tmp_kernel_op_843*tmp_kernel_op_880 + tmp_kernel_op_848*tmp_kernel_op_881 + tmp_kernel_op_853*tmp_kernel_op_882 + tmp_kernel_op_858*tmp_kernel_op_883;
             const real_t elMat_6_0 = tmp_kernel_op_171*tmp_kernel_op_885 + tmp_kernel_op_256*tmp_kernel_op_886 + tmp_kernel_op_341*tmp_kernel_op_887 + tmp_kernel_op_426*tmp_kernel_op_888 + tmp_kernel_op_86*tmp_kernel_op_884;
             const real_t elMat_6_1 = tmp_kernel_op_459*tmp_kernel_op_884 + tmp_kernel_op_464*tmp_kernel_op_885 + tmp_kernel_op_469*tmp_kernel_op_886 + tmp_kernel_op_474*tmp_kernel_op_887 + tmp_kernel_op_479*tmp_kernel_op_888;
             const real_t elMat_6_2 = tmp_kernel_op_490*tmp_kernel_op_884 + tmp_kernel_op_495*tmp_kernel_op_885 + tmp_kernel_op_500*tmp_kernel_op_886 + tmp_kernel_op_505*tmp_kernel_op_887 + tmp_kernel_op_510*tmp_kernel_op_888;
             const real_t elMat_6_3 = tmp_kernel_op_521*tmp_kernel_op_884 + tmp_kernel_op_526*tmp_kernel_op_885 + tmp_kernel_op_531*tmp_kernel_op_886 + tmp_kernel_op_536*tmp_kernel_op_887 + tmp_kernel_op_541*tmp_kernel_op_888;
             const real_t elMat_6_4 = tmp_kernel_op_566*tmp_kernel_op_884 + tmp_kernel_op_576*tmp_kernel_op_885 + tmp_kernel_op_586*tmp_kernel_op_886 + tmp_kernel_op_596*tmp_kernel_op_887 + tmp_kernel_op_606*tmp_kernel_op_888;
             const real_t elMat_6_5 = tmp_kernel_op_628*tmp_kernel_op_884 + tmp_kernel_op_638*tmp_kernel_op_885 + tmp_kernel_op_648*tmp_kernel_op_886 + tmp_kernel_op_658*tmp_kernel_op_887 + tmp_kernel_op_668*tmp_kernel_op_888;
             const real_t elMat_6_6 = tmp_kernel_op_693*tmp_kernel_op_884 + tmp_kernel_op_703*tmp_kernel_op_885 + tmp_kernel_op_713*tmp_kernel_op_886 + tmp_kernel_op_723*tmp_kernel_op_887 + tmp_kernel_op_733*tmp_kernel_op_888;
             const real_t elMat_6_7 = tmp_kernel_op_756*tmp_kernel_op_884 + tmp_kernel_op_761*tmp_kernel_op_885 + tmp_kernel_op_766*tmp_kernel_op_886 + tmp_kernel_op_771*tmp_kernel_op_887 + tmp_kernel_op_776*tmp_kernel_op_888;
             const real_t elMat_6_8 = tmp_kernel_op_797*tmp_kernel_op_884 + tmp_kernel_op_803*tmp_kernel_op_885 + tmp_kernel_op_809*tmp_kernel_op_886 + tmp_kernel_op_815*tmp_kernel_op_887 + tmp_kernel_op_821*tmp_kernel_op_888;
             const real_t elMat_6_9 = tmp_kernel_op_838*tmp_kernel_op_884 + tmp_kernel_op_843*tmp_kernel_op_885 + tmp_kernel_op_848*tmp_kernel_op_886 + tmp_kernel_op_853*tmp_kernel_op_887 + tmp_kernel_op_858*tmp_kernel_op_888;
             const real_t elMat_7_0 = tmp_kernel_op_171*tmp_kernel_op_890 + tmp_kernel_op_256*tmp_kernel_op_891 + tmp_kernel_op_341*tmp_kernel_op_892 + tmp_kernel_op_426*tmp_kernel_op_893 + tmp_kernel_op_86*tmp_kernel_op_889;
             const real_t elMat_7_1 = tmp_kernel_op_459*tmp_kernel_op_889 + tmp_kernel_op_464*tmp_kernel_op_890 + tmp_kernel_op_469*tmp_kernel_op_891 + tmp_kernel_op_474*tmp_kernel_op_892 + tmp_kernel_op_479*tmp_kernel_op_893;
             const real_t elMat_7_2 = tmp_kernel_op_490*tmp_kernel_op_889 + tmp_kernel_op_495*tmp_kernel_op_890 + tmp_kernel_op_500*tmp_kernel_op_891 + tmp_kernel_op_505*tmp_kernel_op_892 + tmp_kernel_op_510*tmp_kernel_op_893;
             const real_t elMat_7_3 = tmp_kernel_op_521*tmp_kernel_op_889 + tmp_kernel_op_526*tmp_kernel_op_890 + tmp_kernel_op_531*tmp_kernel_op_891 + tmp_kernel_op_536*tmp_kernel_op_892 + tmp_kernel_op_541*tmp_kernel_op_893;
             const real_t elMat_7_4 = tmp_kernel_op_566*tmp_kernel_op_889 + tmp_kernel_op_576*tmp_kernel_op_890 + tmp_kernel_op_586*tmp_kernel_op_891 + tmp_kernel_op_596*tmp_kernel_op_892 + tmp_kernel_op_606*tmp_kernel_op_893;
             const real_t elMat_7_5 = tmp_kernel_op_628*tmp_kernel_op_889 + tmp_kernel_op_638*tmp_kernel_op_890 + tmp_kernel_op_648*tmp_kernel_op_891 + tmp_kernel_op_658*tmp_kernel_op_892 + tmp_kernel_op_668*tmp_kernel_op_893;
             const real_t elMat_7_6 = tmp_kernel_op_693*tmp_kernel_op_889 + tmp_kernel_op_703*tmp_kernel_op_890 + tmp_kernel_op_713*tmp_kernel_op_891 + tmp_kernel_op_723*tmp_kernel_op_892 + tmp_kernel_op_733*tmp_kernel_op_893;
             const real_t elMat_7_7 = tmp_kernel_op_756*tmp_kernel_op_889 + tmp_kernel_op_761*tmp_kernel_op_890 + tmp_kernel_op_766*tmp_kernel_op_891 + tmp_kernel_op_771*tmp_kernel_op_892 + tmp_kernel_op_776*tmp_kernel_op_893;
             const real_t elMat_7_8 = tmp_kernel_op_797*tmp_kernel_op_889 + tmp_kernel_op_803*tmp_kernel_op_890 + tmp_kernel_op_809*tmp_kernel_op_891 + tmp_kernel_op_815*tmp_kernel_op_892 + tmp_kernel_op_821*tmp_kernel_op_893;
             const real_t elMat_7_9 = tmp_kernel_op_838*tmp_kernel_op_889 + tmp_kernel_op_843*tmp_kernel_op_890 + tmp_kernel_op_848*tmp_kernel_op_891 + tmp_kernel_op_853*tmp_kernel_op_892 + tmp_kernel_op_858*tmp_kernel_op_893;
             const real_t elMat_8_0 = tmp_kernel_op_171*tmp_kernel_op_895 + tmp_kernel_op_256*tmp_kernel_op_896 + tmp_kernel_op_341*tmp_kernel_op_897 + tmp_kernel_op_426*tmp_kernel_op_898 + tmp_kernel_op_86*tmp_kernel_op_894;
             const real_t elMat_8_1 = tmp_kernel_op_459*tmp_kernel_op_894 + tmp_kernel_op_464*tmp_kernel_op_895 + tmp_kernel_op_469*tmp_kernel_op_896 + tmp_kernel_op_474*tmp_kernel_op_897 + tmp_kernel_op_479*tmp_kernel_op_898;
             const real_t elMat_8_2 = tmp_kernel_op_490*tmp_kernel_op_894 + tmp_kernel_op_495*tmp_kernel_op_895 + tmp_kernel_op_500*tmp_kernel_op_896 + tmp_kernel_op_505*tmp_kernel_op_897 + tmp_kernel_op_510*tmp_kernel_op_898;
             const real_t elMat_8_3 = tmp_kernel_op_521*tmp_kernel_op_894 + tmp_kernel_op_526*tmp_kernel_op_895 + tmp_kernel_op_531*tmp_kernel_op_896 + tmp_kernel_op_536*tmp_kernel_op_897 + tmp_kernel_op_541*tmp_kernel_op_898;
             const real_t elMat_8_4 = tmp_kernel_op_566*tmp_kernel_op_894 + tmp_kernel_op_576*tmp_kernel_op_895 + tmp_kernel_op_586*tmp_kernel_op_896 + tmp_kernel_op_596*tmp_kernel_op_897 + tmp_kernel_op_606*tmp_kernel_op_898;
             const real_t elMat_8_5 = tmp_kernel_op_628*tmp_kernel_op_894 + tmp_kernel_op_638*tmp_kernel_op_895 + tmp_kernel_op_648*tmp_kernel_op_896 + tmp_kernel_op_658*tmp_kernel_op_897 + tmp_kernel_op_668*tmp_kernel_op_898;
             const real_t elMat_8_6 = tmp_kernel_op_693*tmp_kernel_op_894 + tmp_kernel_op_703*tmp_kernel_op_895 + tmp_kernel_op_713*tmp_kernel_op_896 + tmp_kernel_op_723*tmp_kernel_op_897 + tmp_kernel_op_733*tmp_kernel_op_898;
             const real_t elMat_8_7 = tmp_kernel_op_756*tmp_kernel_op_894 + tmp_kernel_op_761*tmp_kernel_op_895 + tmp_kernel_op_766*tmp_kernel_op_896 + tmp_kernel_op_771*tmp_kernel_op_897 + tmp_kernel_op_776*tmp_kernel_op_898;
             const real_t elMat_8_8 = tmp_kernel_op_797*tmp_kernel_op_894 + tmp_kernel_op_803*tmp_kernel_op_895 + tmp_kernel_op_809*tmp_kernel_op_896 + tmp_kernel_op_815*tmp_kernel_op_897 + tmp_kernel_op_821*tmp_kernel_op_898;
             const real_t elMat_8_9 = tmp_kernel_op_838*tmp_kernel_op_894 + tmp_kernel_op_843*tmp_kernel_op_895 + tmp_kernel_op_848*tmp_kernel_op_896 + tmp_kernel_op_853*tmp_kernel_op_897 + tmp_kernel_op_858*tmp_kernel_op_898;
             const real_t elMat_9_0 = tmp_kernel_op_171*tmp_kernel_op_900 + tmp_kernel_op_256*tmp_kernel_op_901 + tmp_kernel_op_341*tmp_kernel_op_902 + tmp_kernel_op_426*tmp_kernel_op_903 + tmp_kernel_op_86*tmp_kernel_op_899;
             const real_t elMat_9_1 = tmp_kernel_op_459*tmp_kernel_op_899 + tmp_kernel_op_464*tmp_kernel_op_900 + tmp_kernel_op_469*tmp_kernel_op_901 + tmp_kernel_op_474*tmp_kernel_op_902 + tmp_kernel_op_479*tmp_kernel_op_903;
             const real_t elMat_9_2 = tmp_kernel_op_490*tmp_kernel_op_899 + tmp_kernel_op_495*tmp_kernel_op_900 + tmp_kernel_op_500*tmp_kernel_op_901 + tmp_kernel_op_505*tmp_kernel_op_902 + tmp_kernel_op_510*tmp_kernel_op_903;
             const real_t elMat_9_3 = tmp_kernel_op_521*tmp_kernel_op_899 + tmp_kernel_op_526*tmp_kernel_op_900 + tmp_kernel_op_531*tmp_kernel_op_901 + tmp_kernel_op_536*tmp_kernel_op_902 + tmp_kernel_op_541*tmp_kernel_op_903;
             const real_t elMat_9_4 = tmp_kernel_op_566*tmp_kernel_op_899 + tmp_kernel_op_576*tmp_kernel_op_900 + tmp_kernel_op_586*tmp_kernel_op_901 + tmp_kernel_op_596*tmp_kernel_op_902 + tmp_kernel_op_606*tmp_kernel_op_903;
             const real_t elMat_9_5 = tmp_kernel_op_628*tmp_kernel_op_899 + tmp_kernel_op_638*tmp_kernel_op_900 + tmp_kernel_op_648*tmp_kernel_op_901 + tmp_kernel_op_658*tmp_kernel_op_902 + tmp_kernel_op_668*tmp_kernel_op_903;
             const real_t elMat_9_6 = tmp_kernel_op_693*tmp_kernel_op_899 + tmp_kernel_op_703*tmp_kernel_op_900 + tmp_kernel_op_713*tmp_kernel_op_901 + tmp_kernel_op_723*tmp_kernel_op_902 + tmp_kernel_op_733*tmp_kernel_op_903;
             const real_t elMat_9_7 = tmp_kernel_op_756*tmp_kernel_op_899 + tmp_kernel_op_761*tmp_kernel_op_900 + tmp_kernel_op_766*tmp_kernel_op_901 + tmp_kernel_op_771*tmp_kernel_op_902 + tmp_kernel_op_776*tmp_kernel_op_903;
             const real_t elMat_9_8 = tmp_kernel_op_797*tmp_kernel_op_899 + tmp_kernel_op_803*tmp_kernel_op_900 + tmp_kernel_op_809*tmp_kernel_op_901 + tmp_kernel_op_815*tmp_kernel_op_902 + tmp_kernel_op_821*tmp_kernel_op_903;
             const real_t elMat_9_9 = tmp_kernel_op_838*tmp_kernel_op_899 + tmp_kernel_op_843*tmp_kernel_op_900 + tmp_kernel_op_848*tmp_kernel_op_901 + tmp_kernel_op_853*tmp_kernel_op_902 + tmp_kernel_op_858*tmp_kernel_op_903;
         
             std::vector< uint_t > _data_rowIdx( 10 );
             std::vector< uint_t > _data_colIdx( 10 );
             std::vector< real_t > _data_mat( 100 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[1] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[2] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[3] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[4] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[7] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[8] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[9] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[3] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[7] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_0_4));
             _data_mat[5] = ((real_t)(elMat_0_5));
             _data_mat[6] = ((real_t)(elMat_0_6));
             _data_mat[7] = ((real_t)(elMat_0_7));
             _data_mat[8] = ((real_t)(elMat_0_8));
             _data_mat[9] = ((real_t)(elMat_0_9));
             _data_mat[10] = ((real_t)(elMat_1_0));
             _data_mat[11] = ((real_t)(elMat_1_1));
             _data_mat[12] = ((real_t)(elMat_1_2));
             _data_mat[13] = ((real_t)(elMat_1_3));
             _data_mat[14] = ((real_t)(elMat_1_4));
             _data_mat[15] = ((real_t)(elMat_1_5));
             _data_mat[16] = ((real_t)(elMat_1_6));
             _data_mat[17] = ((real_t)(elMat_1_7));
             _data_mat[18] = ((real_t)(elMat_1_8));
             _data_mat[19] = ((real_t)(elMat_1_9));
             _data_mat[20] = ((real_t)(elMat_2_0));
             _data_mat[21] = ((real_t)(elMat_2_1));
             _data_mat[22] = ((real_t)(elMat_2_2));
             _data_mat[23] = ((real_t)(elMat_2_3));
             _data_mat[24] = ((real_t)(elMat_2_4));
             _data_mat[25] = ((real_t)(elMat_2_5));
             _data_mat[26] = ((real_t)(elMat_2_6));
             _data_mat[27] = ((real_t)(elMat_2_7));
             _data_mat[28] = ((real_t)(elMat_2_8));
             _data_mat[29] = ((real_t)(elMat_2_9));
             _data_mat[30] = ((real_t)(elMat_3_0));
             _data_mat[31] = ((real_t)(elMat_3_1));
             _data_mat[32] = ((real_t)(elMat_3_2));
             _data_mat[33] = ((real_t)(elMat_3_3));
             _data_mat[34] = ((real_t)(elMat_3_4));
             _data_mat[35] = ((real_t)(elMat_3_5));
             _data_mat[36] = ((real_t)(elMat_3_6));
             _data_mat[37] = ((real_t)(elMat_3_7));
             _data_mat[38] = ((real_t)(elMat_3_8));
             _data_mat[39] = ((real_t)(elMat_3_9));
             _data_mat[40] = ((real_t)(elMat_4_0));
             _data_mat[41] = ((real_t)(elMat_4_1));
             _data_mat[42] = ((real_t)(elMat_4_2));
             _data_mat[43] = ((real_t)(elMat_4_3));
             _data_mat[44] = ((real_t)(elMat_4_4));
             _data_mat[45] = ((real_t)(elMat_4_5));
             _data_mat[46] = ((real_t)(elMat_4_6));
             _data_mat[47] = ((real_t)(elMat_4_7));
             _data_mat[48] = ((real_t)(elMat_4_8));
             _data_mat[49] = ((real_t)(elMat_4_9));
             _data_mat[50] = ((real_t)(elMat_5_0));
             _data_mat[51] = ((real_t)(elMat_5_1));
             _data_mat[52] = ((real_t)(elMat_5_2));
             _data_mat[53] = ((real_t)(elMat_5_3));
             _data_mat[54] = ((real_t)(elMat_5_4));
             _data_mat[55] = ((real_t)(elMat_5_5));
             _data_mat[56] = ((real_t)(elMat_5_6));
             _data_mat[57] = ((real_t)(elMat_5_7));
             _data_mat[58] = ((real_t)(elMat_5_8));
             _data_mat[59] = ((real_t)(elMat_5_9));
             _data_mat[60] = ((real_t)(elMat_6_0));
             _data_mat[61] = ((real_t)(elMat_6_1));
             _data_mat[62] = ((real_t)(elMat_6_2));
             _data_mat[63] = ((real_t)(elMat_6_3));
             _data_mat[64] = ((real_t)(elMat_6_4));
             _data_mat[65] = ((real_t)(elMat_6_5));
             _data_mat[66] = ((real_t)(elMat_6_6));
             _data_mat[67] = ((real_t)(elMat_6_7));
             _data_mat[68] = ((real_t)(elMat_6_8));
             _data_mat[69] = ((real_t)(elMat_6_9));
             _data_mat[70] = ((real_t)(elMat_7_0));
             _data_mat[71] = ((real_t)(elMat_7_1));
             _data_mat[72] = ((real_t)(elMat_7_2));
             _data_mat[73] = ((real_t)(elMat_7_3));
             _data_mat[74] = ((real_t)(elMat_7_4));
             _data_mat[75] = ((real_t)(elMat_7_5));
             _data_mat[76] = ((real_t)(elMat_7_6));
             _data_mat[77] = ((real_t)(elMat_7_7));
             _data_mat[78] = ((real_t)(elMat_7_8));
             _data_mat[79] = ((real_t)(elMat_7_9));
             _data_mat[80] = ((real_t)(elMat_8_0));
             _data_mat[81] = ((real_t)(elMat_8_1));
             _data_mat[82] = ((real_t)(elMat_8_2));
             _data_mat[83] = ((real_t)(elMat_8_3));
             _data_mat[84] = ((real_t)(elMat_8_4));
             _data_mat[85] = ((real_t)(elMat_8_5));
             _data_mat[86] = ((real_t)(elMat_8_6));
             _data_mat[87] = ((real_t)(elMat_8_7));
             _data_mat[88] = ((real_t)(elMat_8_8));
             _data_mat[89] = ((real_t)(elMat_8_9));
             _data_mat[90] = ((real_t)(elMat_9_0));
             _data_mat[91] = ((real_t)(elMat_9_1));
             _data_mat[92] = ((real_t)(elMat_9_2));
             _data_mat[93] = ((real_t)(elMat_9_3));
             _data_mat[94] = ((real_t)(elMat_9_4));
             _data_mat[95] = ((real_t)(elMat_9_5));
             _data_mat[96] = ((real_t)(elMat_9_6));
             _data_mat[97] = ((real_t)(elMat_9_7));
             _data_mat[98] = ((real_t)(elMat_9_8));
             _data_mat[99] = ((real_t)(elMat_9_9));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const real_t tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const real_t tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_11_GREEN_DOWN = jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
       const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const real_t tmp_coords_jac_10_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_0_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
       const real_t tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const real_t jac_affine_inv_0_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
       const real_t jac_affine_inv_0_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const real_t jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const real_t jac_affine_inv_1_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       const real_t tmp_moved_constant_1476 = jac_affine_inv_2_0_GREEN_DOWN*4.0;
       const real_t tmp_moved_constant_1477 = jac_affine_inv_0_0_GREEN_DOWN*4.0;
       const real_t tmp_moved_constant_1478 = jac_affine_inv_1_0_GREEN_DOWN*4.0;
       const real_t tmp_moved_constant_1479 = tmp_moved_constant_1477 + tmp_moved_constant_1478;
       const real_t tmp_moved_constant_1480 = tmp_moved_constant_1476 + tmp_moved_constant_1479;
       const real_t tmp_moved_constant_1481 = jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1480 + jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1480 + jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1480;
       const real_t tmp_moved_constant_1482 = jac_affine_inv_2_1_GREEN_DOWN*4.0;
       const real_t tmp_moved_constant_1483 = jac_affine_inv_0_1_GREEN_DOWN*4.0;
       const real_t tmp_moved_constant_1484 = jac_affine_inv_1_1_GREEN_DOWN*4.0;
       const real_t tmp_moved_constant_1485 = tmp_moved_constant_1483 + tmp_moved_constant_1484;
       const real_t tmp_moved_constant_1486 = tmp_moved_constant_1482 + tmp_moved_constant_1485;
       const real_t tmp_moved_constant_1487 = jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1486 + jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1486 + jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1486;
       const real_t tmp_moved_constant_1488 = jac_affine_inv_2_2_GREEN_DOWN*4.0;
       const real_t tmp_moved_constant_1489 = jac_affine_inv_0_2_GREEN_DOWN*4.0;
       const real_t tmp_moved_constant_1490 = jac_affine_inv_1_2_GREEN_DOWN*4.0;
       const real_t tmp_moved_constant_1491 = tmp_moved_constant_1489 + tmp_moved_constant_1490;
       const real_t tmp_moved_constant_1492 = tmp_moved_constant_1488 + tmp_moved_constant_1491;
       const real_t tmp_moved_constant_1493 = jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1492 + jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1492 + jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1492;
       const real_t tmp_moved_constant_1494 = jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1480 + jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1480 + jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1480;
       const real_t tmp_moved_constant_1495 = jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1486 + jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1486 + jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1486;
       const real_t tmp_moved_constant_1496 = jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1492 + jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1492 + jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1492;
       const real_t tmp_moved_constant_1497 = jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1480 + jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1480 + jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1480;
       const real_t tmp_moved_constant_1498 = jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1486 + jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1486 + jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1486;
       const real_t tmp_moved_constant_1499 = jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1492 + jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1492 + jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1492;
       const real_t tmp_moved_constant_1500 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_28 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_28 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_1501 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_28 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_28 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_1502 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_28 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_28 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_1503 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_113 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_113 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_113;
       const real_t tmp_moved_constant_1504 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_113 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_113 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_113;
       const real_t tmp_moved_constant_1505 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_113 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_113 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_113;
       const real_t tmp_moved_constant_1506 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_198 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_198 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_198;
       const real_t tmp_moved_constant_1507 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_198 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_198 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_198;
       const real_t tmp_moved_constant_1508 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_198 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_198 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_198;
       const real_t tmp_moved_constant_1509 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_283 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_283 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_283;
       const real_t tmp_moved_constant_1510 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_283 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_283 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_283;
       const real_t tmp_moved_constant_1511 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_283 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_283 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_283;
       const real_t tmp_moved_constant_1512 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_368 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_368 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_368;
       const real_t tmp_moved_constant_1513 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_368 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_368 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_368;
       const real_t tmp_moved_constant_1514 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_368 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_368 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_368;
       const real_t tmp_moved_constant_1515 = jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1477;
       const real_t tmp_moved_constant_1516 = jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1477;
       const real_t tmp_moved_constant_1517 = (jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*4.0;
       const real_t tmp_moved_constant_1518 = jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1483;
       const real_t tmp_moved_constant_1519 = (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*4.0;
       const real_t tmp_moved_constant_1520 = (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*4.0;
       const real_t tmp_moved_constant_1521 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_455;
       const real_t tmp_moved_constant_1522 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_455;
       const real_t tmp_moved_constant_1523 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_455;
       const real_t tmp_moved_constant_1524 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_460;
       const real_t tmp_moved_constant_1525 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_460;
       const real_t tmp_moved_constant_1526 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_460;
       const real_t tmp_moved_constant_1527 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_465;
       const real_t tmp_moved_constant_1528 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_465;
       const real_t tmp_moved_constant_1529 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_465;
       const real_t tmp_moved_constant_1530 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_470;
       const real_t tmp_moved_constant_1531 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_470;
       const real_t tmp_moved_constant_1532 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_470;
       const real_t tmp_moved_constant_1533 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_475;
       const real_t tmp_moved_constant_1534 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_475;
       const real_t tmp_moved_constant_1535 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_475;
       const real_t tmp_moved_constant_1536 = jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1478;
       const real_t tmp_moved_constant_1537 = jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1478;
       const real_t tmp_moved_constant_1538 = (jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*4.0;
       const real_t tmp_moved_constant_1539 = jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1484;
       const real_t tmp_moved_constant_1540 = (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*4.0;
       const real_t tmp_moved_constant_1541 = (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*4.0;
       const real_t tmp_moved_constant_1542 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_486;
       const real_t tmp_moved_constant_1543 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_486;
       const real_t tmp_moved_constant_1544 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_486;
       const real_t tmp_moved_constant_1545 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_491;
       const real_t tmp_moved_constant_1546 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_491;
       const real_t tmp_moved_constant_1547 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_491;
       const real_t tmp_moved_constant_1548 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_496;
       const real_t tmp_moved_constant_1549 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_496;
       const real_t tmp_moved_constant_1550 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_496;
       const real_t tmp_moved_constant_1551 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_501;
       const real_t tmp_moved_constant_1552 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_501;
       const real_t tmp_moved_constant_1553 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_501;
       const real_t tmp_moved_constant_1554 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_506;
       const real_t tmp_moved_constant_1555 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_506;
       const real_t tmp_moved_constant_1556 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_506;
       const real_t tmp_moved_constant_1557 = jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1476;
       const real_t tmp_moved_constant_1558 = jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1476;
       const real_t tmp_moved_constant_1559 = (jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*4.0;
       const real_t tmp_moved_constant_1560 = jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1482;
       const real_t tmp_moved_constant_1561 = (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*4.0;
       const real_t tmp_moved_constant_1562 = (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*4.0;
       const real_t tmp_moved_constant_1563 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_517;
       const real_t tmp_moved_constant_1564 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_517;
       const real_t tmp_moved_constant_1565 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_517;
       const real_t tmp_moved_constant_1566 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_522;
       const real_t tmp_moved_constant_1567 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_522;
       const real_t tmp_moved_constant_1568 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_522;
       const real_t tmp_moved_constant_1569 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_527;
       const real_t tmp_moved_constant_1570 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_527;
       const real_t tmp_moved_constant_1571 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_527;
       const real_t tmp_moved_constant_1572 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_532;
       const real_t tmp_moved_constant_1573 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_532;
       const real_t tmp_moved_constant_1574 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_532;
       const real_t tmp_moved_constant_1575 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_537;
       const real_t tmp_moved_constant_1576 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_537;
       const real_t tmp_moved_constant_1577 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_537;
       const real_t tmp_moved_constant_1578 = jac_affine_inv_2_0_GREEN_DOWN*8.0;
       const real_t tmp_moved_constant_1579 = jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1578;
       const real_t tmp_moved_constant_1580 = jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1478;
       const real_t tmp_moved_constant_1581 = jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1476;
       const real_t tmp_moved_constant_1582 = tmp_moved_constant_1580 + tmp_moved_constant_1581;
       const real_t tmp_moved_constant_1583 = jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1478;
       const real_t tmp_moved_constant_1584 = jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1476;
       const real_t tmp_moved_constant_1585 = tmp_moved_constant_1583 + tmp_moved_constant_1584;
       const real_t tmp_moved_constant_1586 = jac_affine_inv_2_1_GREEN_DOWN*8.0;
       const real_t tmp_moved_constant_1587 = jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1586;
       const real_t tmp_moved_constant_1588 = jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1484;
       const real_t tmp_moved_constant_1589 = jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1482;
       const real_t tmp_moved_constant_1590 = tmp_moved_constant_1588 + tmp_moved_constant_1589;
       const real_t tmp_moved_constant_1591 = jac_affine_inv_2_2_GREEN_DOWN*8.0;
       const real_t tmp_moved_constant_1592 = jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1591;
       const real_t tmp_moved_constant_1593 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_1594 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_1595 = tmp_moved_constant_1593 + tmp_moved_constant_1594;
       const real_t tmp_moved_constant_1596 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_1597 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_1598 = tmp_moved_constant_1596 + tmp_moved_constant_1597;
       const real_t tmp_moved_constant_1599 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_1600 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_1601 = tmp_moved_constant_1599 + tmp_moved_constant_1600;
       const real_t tmp_moved_constant_1602 = tmp_moved_constant_1478*0.5;
       const real_t tmp_moved_constant_1603 = tmp_moved_constant_1476*0.16666666666666666;
       const real_t tmp_moved_constant_1604 = tmp_moved_constant_1602 + tmp_moved_constant_1603;
       const real_t tmp_moved_constant_1605 = tmp_moved_constant_1484*0.5;
       const real_t tmp_moved_constant_1606 = tmp_moved_constant_1482*0.16666666666666666;
       const real_t tmp_moved_constant_1607 = tmp_moved_constant_1605 + tmp_moved_constant_1606;
       const real_t tmp_moved_constant_1608 = tmp_moved_constant_1490*0.5;
       const real_t tmp_moved_constant_1609 = tmp_moved_constant_1488*0.16666666666666666;
       const real_t tmp_moved_constant_1610 = tmp_moved_constant_1608 + tmp_moved_constant_1609;
       const real_t tmp_moved_constant_1611 = tmp_moved_constant_1478*0.16666666666666666;
       const real_t tmp_moved_constant_1612 = tmp_moved_constant_1476*0.5;
       const real_t tmp_moved_constant_1613 = tmp_moved_constant_1611 + tmp_moved_constant_1612;
       const real_t tmp_moved_constant_1614 = tmp_moved_constant_1484*0.16666666666666666;
       const real_t tmp_moved_constant_1615 = tmp_moved_constant_1482*0.5;
       const real_t tmp_moved_constant_1616 = tmp_moved_constant_1614 + tmp_moved_constant_1615;
       const real_t tmp_moved_constant_1617 = tmp_moved_constant_1490*0.16666666666666666;
       const real_t tmp_moved_constant_1618 = tmp_moved_constant_1488*0.5;
       const real_t tmp_moved_constant_1619 = tmp_moved_constant_1617 + tmp_moved_constant_1618;
       const real_t tmp_moved_constant_1620 = tmp_moved_constant_1478*0.16666666666666666;
       const real_t tmp_moved_constant_1621 = tmp_moved_constant_1476*0.16666666666666666;
       const real_t tmp_moved_constant_1622 = tmp_moved_constant_1620 + tmp_moved_constant_1621;
       const real_t tmp_moved_constant_1623 = tmp_moved_constant_1484*0.16666666666666666;
       const real_t tmp_moved_constant_1624 = tmp_moved_constant_1482*0.16666666666666666;
       const real_t tmp_moved_constant_1625 = tmp_moved_constant_1623 + tmp_moved_constant_1624;
       const real_t tmp_moved_constant_1626 = tmp_moved_constant_1490*0.16666666666666666;
       const real_t tmp_moved_constant_1627 = tmp_moved_constant_1488*0.16666666666666666;
       const real_t tmp_moved_constant_1628 = tmp_moved_constant_1626 + tmp_moved_constant_1627;
       const real_t tmp_moved_constant_1629 = tmp_moved_constant_1478*0.16666666666666666;
       const real_t tmp_moved_constant_1630 = tmp_moved_constant_1476*0.16666666666666666;
       const real_t tmp_moved_constant_1631 = tmp_moved_constant_1629 + tmp_moved_constant_1630;
       const real_t tmp_moved_constant_1632 = tmp_moved_constant_1484*0.16666666666666666;
       const real_t tmp_moved_constant_1633 = tmp_moved_constant_1482*0.16666666666666666;
       const real_t tmp_moved_constant_1634 = tmp_moved_constant_1632 + tmp_moved_constant_1633;
       const real_t tmp_moved_constant_1635 = tmp_moved_constant_1490*0.16666666666666666;
       const real_t tmp_moved_constant_1636 = tmp_moved_constant_1488*0.16666666666666666;
       const real_t tmp_moved_constant_1637 = tmp_moved_constant_1635 + tmp_moved_constant_1636;
       const real_t tmp_moved_constant_1638 = jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1578;
       const real_t tmp_moved_constant_1639 = jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1477;
       const real_t tmp_moved_constant_1640 = jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1476;
       const real_t tmp_moved_constant_1641 = tmp_moved_constant_1639 + tmp_moved_constant_1640;
       const real_t tmp_moved_constant_1642 = jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1477;
       const real_t tmp_moved_constant_1643 = jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1476;
       const real_t tmp_moved_constant_1644 = tmp_moved_constant_1642 + tmp_moved_constant_1643;
       const real_t tmp_moved_constant_1645 = jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1586;
       const real_t tmp_moved_constant_1646 = jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1483;
       const real_t tmp_moved_constant_1647 = jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1482;
       const real_t tmp_moved_constant_1648 = tmp_moved_constant_1646 + tmp_moved_constant_1647;
       const real_t tmp_moved_constant_1649 = jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1591;
       const real_t tmp_moved_constant_1650 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_1651 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_1652 = tmp_moved_constant_1650 + tmp_moved_constant_1651;
       const real_t tmp_moved_constant_1653 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_1654 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_1655 = tmp_moved_constant_1653 + tmp_moved_constant_1654;
       const real_t tmp_moved_constant_1656 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_24;
       const real_t tmp_moved_constant_1657 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_1658 = tmp_moved_constant_1656 + tmp_moved_constant_1657;
       const real_t tmp_moved_constant_1659 = tmp_moved_constant_1477*0.5;
       const real_t tmp_moved_constant_1660 = tmp_moved_constant_1476*0.16666666666666666;
       const real_t tmp_moved_constant_1661 = tmp_moved_constant_1659 + tmp_moved_constant_1660;
       const real_t tmp_moved_constant_1662 = tmp_moved_constant_1483*0.5;
       const real_t tmp_moved_constant_1663 = tmp_moved_constant_1482*0.16666666666666666;
       const real_t tmp_moved_constant_1664 = tmp_moved_constant_1662 + tmp_moved_constant_1663;
       const real_t tmp_moved_constant_1665 = tmp_moved_constant_1489*0.5;
       const real_t tmp_moved_constant_1666 = tmp_moved_constant_1488*0.16666666666666666;
       const real_t tmp_moved_constant_1667 = tmp_moved_constant_1665 + tmp_moved_constant_1666;
       const real_t tmp_moved_constant_1668 = tmp_moved_constant_1477*0.16666666666666666;
       const real_t tmp_moved_constant_1669 = tmp_moved_constant_1476*0.16666666666666666;
       const real_t tmp_moved_constant_1670 = tmp_moved_constant_1668 + tmp_moved_constant_1669;
       const real_t tmp_moved_constant_1671 = tmp_moved_constant_1483*0.16666666666666666;
       const real_t tmp_moved_constant_1672 = tmp_moved_constant_1482*0.16666666666666666;
       const real_t tmp_moved_constant_1673 = tmp_moved_constant_1671 + tmp_moved_constant_1672;
       const real_t tmp_moved_constant_1674 = tmp_moved_constant_1489*0.16666666666666666;
       const real_t tmp_moved_constant_1675 = tmp_moved_constant_1488*0.16666666666666666;
       const real_t tmp_moved_constant_1676 = tmp_moved_constant_1674 + tmp_moved_constant_1675;
       const real_t tmp_moved_constant_1677 = tmp_moved_constant_1477*0.16666666666666666;
       const real_t tmp_moved_constant_1678 = tmp_moved_constant_1476*0.5;
       const real_t tmp_moved_constant_1679 = tmp_moved_constant_1677 + tmp_moved_constant_1678;
       const real_t tmp_moved_constant_1680 = tmp_moved_constant_1483*0.16666666666666666;
       const real_t tmp_moved_constant_1681 = tmp_moved_constant_1482*0.5;
       const real_t tmp_moved_constant_1682 = tmp_moved_constant_1680 + tmp_moved_constant_1681;
       const real_t tmp_moved_constant_1683 = tmp_moved_constant_1489*0.16666666666666666;
       const real_t tmp_moved_constant_1684 = tmp_moved_constant_1488*0.5;
       const real_t tmp_moved_constant_1685 = tmp_moved_constant_1683 + tmp_moved_constant_1684;
       const real_t tmp_moved_constant_1686 = tmp_moved_constant_1477*0.16666666666666666;
       const real_t tmp_moved_constant_1687 = tmp_moved_constant_1476*0.16666666666666666;
       const real_t tmp_moved_constant_1688 = tmp_moved_constant_1686 + tmp_moved_constant_1687;
       const real_t tmp_moved_constant_1689 = tmp_moved_constant_1483*0.16666666666666666;
       const real_t tmp_moved_constant_1690 = tmp_moved_constant_1482*0.16666666666666666;
       const real_t tmp_moved_constant_1691 = tmp_moved_constant_1689 + tmp_moved_constant_1690;
       const real_t tmp_moved_constant_1692 = tmp_moved_constant_1489*0.16666666666666666;
       const real_t tmp_moved_constant_1693 = tmp_moved_constant_1488*0.16666666666666666;
       const real_t tmp_moved_constant_1694 = tmp_moved_constant_1692 + tmp_moved_constant_1693;
       const real_t tmp_moved_constant_1695 = jac_affine_inv_1_0_GREEN_DOWN*8.0;
       const real_t tmp_moved_constant_1696 = jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1695;
       const real_t tmp_moved_constant_1697 = jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1477;
       const real_t tmp_moved_constant_1698 = jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1478;
       const real_t tmp_moved_constant_1699 = tmp_moved_constant_1697 + tmp_moved_constant_1698;
       const real_t tmp_moved_constant_1700 = jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1477;
       const real_t tmp_moved_constant_1701 = jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1478;
       const real_t tmp_moved_constant_1702 = tmp_moved_constant_1700 + tmp_moved_constant_1701;
       const real_t tmp_moved_constant_1703 = jac_affine_inv_1_1_GREEN_DOWN*8.0;
       const real_t tmp_moved_constant_1704 = jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1703;
       const real_t tmp_moved_constant_1705 = jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1483;
       const real_t tmp_moved_constant_1706 = jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1484;
       const real_t tmp_moved_constant_1707 = tmp_moved_constant_1705 + tmp_moved_constant_1706;
       const real_t tmp_moved_constant_1708 = jac_affine_inv_1_2_GREEN_DOWN*8.0;
       const real_t tmp_moved_constant_1709 = jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1708;
       const real_t tmp_moved_constant_1710 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_1711 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_1712 = tmp_moved_constant_1710 + tmp_moved_constant_1711;
       const real_t tmp_moved_constant_1713 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_1714 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_1715 = tmp_moved_constant_1713 + tmp_moved_constant_1714;
       const real_t tmp_moved_constant_1716 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_26;
       const real_t tmp_moved_constant_1717 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_25;
       const real_t tmp_moved_constant_1718 = tmp_moved_constant_1716 + tmp_moved_constant_1717;
       const real_t tmp_moved_constant_1719 = tmp_moved_constant_1477*0.16666666666666666;
       const real_t tmp_moved_constant_1720 = tmp_moved_constant_1478*0.16666666666666666;
       const real_t tmp_moved_constant_1721 = tmp_moved_constant_1719 + tmp_moved_constant_1720;
       const real_t tmp_moved_constant_1722 = tmp_moved_constant_1483*0.16666666666666666;
       const real_t tmp_moved_constant_1723 = tmp_moved_constant_1484*0.16666666666666666;
       const real_t tmp_moved_constant_1724 = tmp_moved_constant_1722 + tmp_moved_constant_1723;
       const real_t tmp_moved_constant_1725 = tmp_moved_constant_1489*0.16666666666666666;
       const real_t tmp_moved_constant_1726 = tmp_moved_constant_1490*0.16666666666666666;
       const real_t tmp_moved_constant_1727 = tmp_moved_constant_1725 + tmp_moved_constant_1726;
       const real_t tmp_moved_constant_1728 = tmp_moved_constant_1477*0.5;
       const real_t tmp_moved_constant_1729 = tmp_moved_constant_1478*0.16666666666666666;
       const real_t tmp_moved_constant_1730 = tmp_moved_constant_1728 + tmp_moved_constant_1729;
       const real_t tmp_moved_constant_1731 = tmp_moved_constant_1483*0.5;
       const real_t tmp_moved_constant_1732 = tmp_moved_constant_1484*0.16666666666666666;
       const real_t tmp_moved_constant_1733 = tmp_moved_constant_1731 + tmp_moved_constant_1732;
       const real_t tmp_moved_constant_1734 = tmp_moved_constant_1489*0.5;
       const real_t tmp_moved_constant_1735 = tmp_moved_constant_1490*0.16666666666666666;
       const real_t tmp_moved_constant_1736 = tmp_moved_constant_1734 + tmp_moved_constant_1735;
       const real_t tmp_moved_constant_1737 = tmp_moved_constant_1477*0.16666666666666666;
       const real_t tmp_moved_constant_1738 = tmp_moved_constant_1478*0.5;
       const real_t tmp_moved_constant_1739 = tmp_moved_constant_1737 + tmp_moved_constant_1738;
       const real_t tmp_moved_constant_1740 = tmp_moved_constant_1483*0.16666666666666666;
       const real_t tmp_moved_constant_1741 = tmp_moved_constant_1484*0.5;
       const real_t tmp_moved_constant_1742 = tmp_moved_constant_1740 + tmp_moved_constant_1741;
       const real_t tmp_moved_constant_1743 = tmp_moved_constant_1489*0.16666666666666666;
       const real_t tmp_moved_constant_1744 = tmp_moved_constant_1490*0.5;
       const real_t tmp_moved_constant_1745 = tmp_moved_constant_1743 + tmp_moved_constant_1744;
       const real_t tmp_moved_constant_1746 = tmp_moved_constant_1477*0.16666666666666666;
       const real_t tmp_moved_constant_1747 = tmp_moved_constant_1478*0.16666666666666666;
       const real_t tmp_moved_constant_1748 = tmp_moved_constant_1746 + tmp_moved_constant_1747;
       const real_t tmp_moved_constant_1749 = tmp_moved_constant_1483*0.16666666666666666;
       const real_t tmp_moved_constant_1750 = tmp_moved_constant_1484*0.16666666666666666;
       const real_t tmp_moved_constant_1751 = tmp_moved_constant_1749 + tmp_moved_constant_1750;
       const real_t tmp_moved_constant_1752 = tmp_moved_constant_1489*0.16666666666666666;
       const real_t tmp_moved_constant_1753 = tmp_moved_constant_1490*0.16666666666666666;
       const real_t tmp_moved_constant_1754 = tmp_moved_constant_1752 + tmp_moved_constant_1753;
       const real_t tmp_moved_constant_1755 = jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1477;
       const real_t tmp_moved_constant_1756 = jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1478;
       const real_t tmp_moved_constant_1757 = -tmp_moved_constant_1479 - tmp_moved_constant_1578;
       const real_t tmp_moved_constant_1758 = jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1757 - tmp_moved_constant_1755 - tmp_moved_constant_1756;
       const real_t tmp_moved_constant_1759 = -tmp_moved_constant_1485 - tmp_moved_constant_1586;
       const real_t tmp_moved_constant_1760 = jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1759 - tmp_moved_constant_1580 - tmp_moved_constant_1639;
       const real_t tmp_moved_constant_1761 = -tmp_moved_constant_1491 - tmp_moved_constant_1591;
       const real_t tmp_moved_constant_1762 = jac_affine_inv_2_0_GREEN_DOWN*tmp_moved_constant_1761 - tmp_moved_constant_1583 - tmp_moved_constant_1642;
       const real_t tmp_moved_constant_1763 = jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1757 - tmp_moved_constant_1581 - tmp_moved_constant_1640;
       const real_t tmp_moved_constant_1764 = jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1483;
       const real_t tmp_moved_constant_1765 = jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1484;
       const real_t tmp_moved_constant_1766 = jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1759 - tmp_moved_constant_1764 - tmp_moved_constant_1765;
       const real_t tmp_moved_constant_1767 = jac_affine_inv_2_1_GREEN_DOWN*tmp_moved_constant_1761 - tmp_moved_constant_1588 - tmp_moved_constant_1646;
       const real_t tmp_moved_constant_1768 = jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1757 - tmp_moved_constant_1584 - tmp_moved_constant_1643;
       const real_t tmp_moved_constant_1769 = jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1759 - tmp_moved_constant_1589 - tmp_moved_constant_1647;
       const real_t tmp_moved_constant_1770 = jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1489;
       const real_t tmp_moved_constant_1771 = jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1490;
       const real_t tmp_moved_constant_1772 = jac_affine_inv_2_2_GREEN_DOWN*tmp_moved_constant_1761 - tmp_moved_constant_1770 - tmp_moved_constant_1771;
       const real_t tmp_moved_constant_1773 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_752 - tmp_moved_constant_1593 - tmp_moved_constant_1650;
       const real_t tmp_moved_constant_1774 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_752 - tmp_moved_constant_1596 - tmp_moved_constant_1653;
       const real_t tmp_moved_constant_1775 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_752 - tmp_moved_constant_1599 - tmp_moved_constant_1656;
       const real_t tmp_moved_constant_1776 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_757 - tmp_moved_constant_1602 - tmp_moved_constant_1659;
       const real_t tmp_moved_constant_1777 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_757 - tmp_moved_constant_1605 - tmp_moved_constant_1662;
       const real_t tmp_moved_constant_1778 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_757 - tmp_moved_constant_1608 - tmp_moved_constant_1665;
       const real_t tmp_moved_constant_1779 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_762 - tmp_moved_constant_1611 - tmp_moved_constant_1668;
       const real_t tmp_moved_constant_1780 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_762 - tmp_moved_constant_1614 - tmp_moved_constant_1671;
       const real_t tmp_moved_constant_1781 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_762 - tmp_moved_constant_1617 - tmp_moved_constant_1674;
       const real_t tmp_moved_constant_1782 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_767 - tmp_moved_constant_1620 - tmp_moved_constant_1677;
       const real_t tmp_moved_constant_1783 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_767 - tmp_moved_constant_1623 - tmp_moved_constant_1680;
       const real_t tmp_moved_constant_1784 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_767 - tmp_moved_constant_1626 - tmp_moved_constant_1683;
       const real_t tmp_moved_constant_1785 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_772 - tmp_moved_constant_1629 - tmp_moved_constant_1686;
       const real_t tmp_moved_constant_1786 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_772 - tmp_moved_constant_1632 - tmp_moved_constant_1689;
       const real_t tmp_moved_constant_1787 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_772 - tmp_moved_constant_1635 - tmp_moved_constant_1692;
       const real_t tmp_moved_constant_1788 = jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1477;
       const real_t tmp_moved_constant_1789 = -tmp_moved_constant_1476 - tmp_moved_constant_1477 - tmp_moved_constant_1695;
       const real_t tmp_moved_constant_1790 = jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1789 - tmp_moved_constant_1756 - tmp_moved_constant_1788;
       const real_t tmp_moved_constant_1791 = -tmp_moved_constant_1482 - tmp_moved_constant_1483 - tmp_moved_constant_1703;
       const real_t tmp_moved_constant_1792 = jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1791 - tmp_moved_constant_1581 - tmp_moved_constant_1697;
       const real_t tmp_moved_constant_1793 = -tmp_moved_constant_1488 - tmp_moved_constant_1489 - tmp_moved_constant_1708;
       const real_t tmp_moved_constant_1794 = jac_affine_inv_1_0_GREEN_DOWN*tmp_moved_constant_1793 - tmp_moved_constant_1584 - tmp_moved_constant_1700;
       const real_t tmp_moved_constant_1795 = jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1789 - tmp_moved_constant_1580 - tmp_moved_constant_1698;
       const real_t tmp_moved_constant_1796 = jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1483;
       const real_t tmp_moved_constant_1797 = jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1791 - tmp_moved_constant_1765 - tmp_moved_constant_1796;
       const real_t tmp_moved_constant_1798 = jac_affine_inv_1_1_GREEN_DOWN*tmp_moved_constant_1793 - tmp_moved_constant_1589 - tmp_moved_constant_1705;
       const real_t tmp_moved_constant_1799 = jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1789 - tmp_moved_constant_1583 - tmp_moved_constant_1701;
       const real_t tmp_moved_constant_1800 = jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1791 - tmp_moved_constant_1588 - tmp_moved_constant_1706;
       const real_t tmp_moved_constant_1801 = jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1489;
       const real_t tmp_moved_constant_1802 = jac_affine_inv_1_2_GREEN_DOWN*tmp_moved_constant_1793 - tmp_moved_constant_1771 - tmp_moved_constant_1801;
       const real_t tmp_moved_constant_1803 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_793 - tmp_moved_constant_1594 - tmp_moved_constant_1710;
       const real_t tmp_moved_constant_1804 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_793 - tmp_moved_constant_1597 - tmp_moved_constant_1713;
       const real_t tmp_moved_constant_1805 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_793 - tmp_moved_constant_1600 - tmp_moved_constant_1716;
       const real_t tmp_moved_constant_1806 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_799 - tmp_moved_constant_1603 - tmp_moved_constant_1719;
       const real_t tmp_moved_constant_1807 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_799 - tmp_moved_constant_1606 - tmp_moved_constant_1722;
       const real_t tmp_moved_constant_1808 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_799 - tmp_moved_constant_1609 - tmp_moved_constant_1725;
       const real_t tmp_moved_constant_1809 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_805 - tmp_moved_constant_1612 - tmp_moved_constant_1728;
       const real_t tmp_moved_constant_1810 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_805 - tmp_moved_constant_1615 - tmp_moved_constant_1731;
       const real_t tmp_moved_constant_1811 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_805 - tmp_moved_constant_1618 - tmp_moved_constant_1734;
       const real_t tmp_moved_constant_1812 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_811 - tmp_moved_constant_1621 - tmp_moved_constant_1737;
       const real_t tmp_moved_constant_1813 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_811 - tmp_moved_constant_1624 - tmp_moved_constant_1740;
       const real_t tmp_moved_constant_1814 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_811 - tmp_moved_constant_1627 - tmp_moved_constant_1743;
       const real_t tmp_moved_constant_1815 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_817 - tmp_moved_constant_1630 - tmp_moved_constant_1746;
       const real_t tmp_moved_constant_1816 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_817 - tmp_moved_constant_1633 - tmp_moved_constant_1749;
       const real_t tmp_moved_constant_1817 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_817 - tmp_moved_constant_1636 - tmp_moved_constant_1752;
       const real_t tmp_moved_constant_1818 = jac_affine_inv_0_0_GREEN_DOWN*-8.0 - tmp_moved_constant_1476 - tmp_moved_constant_1478;
       const real_t tmp_moved_constant_1819 = jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1818 - tmp_moved_constant_1755 - tmp_moved_constant_1788;
       const real_t tmp_moved_constant_1820 = jac_affine_inv_0_1_GREEN_DOWN*-8.0 - tmp_moved_constant_1482 - tmp_moved_constant_1484;
       const real_t tmp_moved_constant_1821 = jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1820 - tmp_moved_constant_1640 - tmp_moved_constant_1698;
       const real_t tmp_moved_constant_1822 = jac_affine_inv_0_2_GREEN_DOWN*-8.0 - tmp_moved_constant_1488 - tmp_moved_constant_1490;
       const real_t tmp_moved_constant_1823 = jac_affine_inv_0_0_GREEN_DOWN*tmp_moved_constant_1822 - tmp_moved_constant_1643 - tmp_moved_constant_1701;
       const real_t tmp_moved_constant_1824 = jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1818 - tmp_moved_constant_1639 - tmp_moved_constant_1697;
       const real_t tmp_moved_constant_1825 = jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1820 - tmp_moved_constant_1764 - tmp_moved_constant_1796;
       const real_t tmp_moved_constant_1826 = jac_affine_inv_0_1_GREEN_DOWN*tmp_moved_constant_1822 - tmp_moved_constant_1647 - tmp_moved_constant_1706;
       const real_t tmp_moved_constant_1827 = jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1818 - tmp_moved_constant_1642 - tmp_moved_constant_1700;
       const real_t tmp_moved_constant_1828 = jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1820 - tmp_moved_constant_1646 - tmp_moved_constant_1705;
       const real_t tmp_moved_constant_1829 = jac_affine_inv_0_2_GREEN_DOWN*tmp_moved_constant_1822 - tmp_moved_constant_1770 - tmp_moved_constant_1801;
       const real_t tmp_moved_constant_1830 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_834 - tmp_moved_constant_1651 - tmp_moved_constant_1711;
       const real_t tmp_moved_constant_1831 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_834 - tmp_moved_constant_1654 - tmp_moved_constant_1714;
       const real_t tmp_moved_constant_1832 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_834 - tmp_moved_constant_1657 - tmp_moved_constant_1717;
       const real_t tmp_moved_constant_1833 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_839 - tmp_moved_constant_1660 - tmp_moved_constant_1720;
       const real_t tmp_moved_constant_1834 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_839 - tmp_moved_constant_1663 - tmp_moved_constant_1723;
       const real_t tmp_moved_constant_1835 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_839 - tmp_moved_constant_1666 - tmp_moved_constant_1726;
       const real_t tmp_moved_constant_1836 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_844 - tmp_moved_constant_1669 - tmp_moved_constant_1729;
       const real_t tmp_moved_constant_1837 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_844 - tmp_moved_constant_1672 - tmp_moved_constant_1732;
       const real_t tmp_moved_constant_1838 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_844 - tmp_moved_constant_1675 - tmp_moved_constant_1735;
       const real_t tmp_moved_constant_1839 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_849 - tmp_moved_constant_1678 - tmp_moved_constant_1738;
       const real_t tmp_moved_constant_1840 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_849 - tmp_moved_constant_1681 - tmp_moved_constant_1741;
       const real_t tmp_moved_constant_1841 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_849 - tmp_moved_constant_1684 - tmp_moved_constant_1744;
       const real_t tmp_moved_constant_1842 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_854 - tmp_moved_constant_1687 - tmp_moved_constant_1747;
       const real_t tmp_moved_constant_1843 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_854 - tmp_moved_constant_1690 - tmp_moved_constant_1750;
       const real_t tmp_moved_constant_1844 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_854 - tmp_moved_constant_1693 - tmp_moved_constant_1753;
       {
          /* CellType.GREEN_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
             const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
             const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
             const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
             const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
             const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
             const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
             const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
             const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
             const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
             const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
             const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
             const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
             const real_t tmp_blending_op_35 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_36 = tmp_blending_op_22 - tmp_blending_op_35;
             const real_t tmp_blending_op_37 = -tmp_blending_op_36;
             const real_t tmp_blending_op_38 = (tmp_blending_op_28*tmp_blending_op_28);
             const real_t tmp_blending_op_39 = (tmp_blending_op_33*tmp_blending_op_33);
             const real_t tmp_blending_op_40 = tmp_blending_op_38 + tmp_blending_op_39 + tmp_blending_op_4;
             const real_t tmp_blending_op_43 = tmp_blending_op_3*tmp_blending_op_42;
             const real_t tmp_blending_op_44 = tmp_blending_op_36 + tmp_blending_op_43;
             const real_t tmp_blending_op_45 = tmp_blending_op_37*tmp_blending_op_4 + tmp_blending_op_40*tmp_blending_op_44;
             const real_t tmp_blending_op_46 = pow(tmp_blending_op_40, -1.5000000000000000);
             const real_t tmp_blending_op_49 = tmp_blending_op_46*tmp_blending_op_48;
             const real_t tmp_blending_op_52 = tmp_blending_op_40*tmp_blending_op_51;
             const real_t tmp_blending_op_53 = -tmp_blending_op_33*tmp_blending_op_36 - tmp_blending_op_52;
             const real_t tmp_blending_op_54 = tmp_blending_op_49*tmp_blending_op_53;
             const real_t tmp_blending_op_57 = tmp_blending_op_28*tmp_blending_op_37 + tmp_blending_op_40*tmp_blending_op_56;
             const real_t tmp_blending_op_58 = tmp_blending_op_49*tmp_blending_op_57;
             const real_t tmp_blending_op_59 = tmp_blending_op_3*tmp_blending_op_37;
             const real_t tmp_blending_op_60 = tmp_blending_op_40*tmp_blending_op_42 + tmp_blending_op_59;
             const real_t tmp_blending_op_61 = tmp_blending_op_49*tmp_blending_op_60;
             const real_t tmp_blending_op_63 = tmp_blending_op_33*tmp_blending_op_62 + tmp_blending_op_36;
             const real_t tmp_blending_op_64 = tmp_blending_op_37*tmp_blending_op_39 + tmp_blending_op_40*tmp_blending_op_63;
             const real_t tmp_blending_op_65 = tmp_blending_op_28*tmp_blending_op_56;
             const real_t tmp_blending_op_66 = tmp_blending_op_36 + tmp_blending_op_65;
             const real_t tmp_blending_op_67 = -tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_40*tmp_blending_op_66;
             const real_t tmp_blending_op_75 = p_affine_0_2 + tmp_blending_op_0*0.5 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_76 = (tmp_blending_op_75*tmp_blending_op_75);
             const real_t tmp_blending_op_77 = -tmp_blending_op_17 - tmp_blending_op_75;
             const real_t tmp_blending_op_78 = p_affine_0_0 + tmp_blending_op_25*0.5 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_79 = -tmp_blending_op_6 - tmp_blending_op_78;
             const real_t tmp_blending_op_80 = p_affine_0_1 + tmp_blending_op_30*0.5 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_81 = -tmp_blending_op_13 - tmp_blending_op_80;
             const real_t tmp_blending_op_82 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_79 - tmp_blending_op_12*tmp_blending_op_77 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_77 - tmp_blending_op_19*tmp_blending_op_79 - tmp_blending_op_20*tmp_blending_op_81 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_81);
             const real_t tmp_blending_op_83 = tmp_blending_op_22 - tmp_blending_op_82;
             const real_t tmp_blending_op_84 = -tmp_blending_op_83;
             const real_t tmp_blending_op_85 = (tmp_blending_op_78*tmp_blending_op_78);
             const real_t tmp_blending_op_86 = (tmp_blending_op_80*tmp_blending_op_80);
             const real_t tmp_blending_op_87 = tmp_blending_op_76 + tmp_blending_op_85 + tmp_blending_op_86;
             const real_t tmp_blending_op_88 = tmp_blending_op_42*tmp_blending_op_75;
             const real_t tmp_blending_op_89 = tmp_blending_op_83 + tmp_blending_op_88;
             const real_t tmp_blending_op_90 = tmp_blending_op_76*tmp_blending_op_84 + tmp_blending_op_87*tmp_blending_op_89;
             const real_t tmp_blending_op_91 = pow(tmp_blending_op_87, -1.5000000000000000);
             const real_t tmp_blending_op_92 = tmp_blending_op_48*tmp_blending_op_91;
             const real_t tmp_blending_op_93 = tmp_blending_op_51*tmp_blending_op_87;
             const real_t tmp_blending_op_94 = -tmp_blending_op_80*tmp_blending_op_83 - tmp_blending_op_93;
             const real_t tmp_blending_op_95 = tmp_blending_op_92*tmp_blending_op_94;
             const real_t tmp_blending_op_96 = tmp_blending_op_56*tmp_blending_op_87 + tmp_blending_op_78*tmp_blending_op_84;
             const real_t tmp_blending_op_97 = tmp_blending_op_92*tmp_blending_op_96;
             const real_t tmp_blending_op_98 = tmp_blending_op_75*tmp_blending_op_84;
             const real_t tmp_blending_op_99 = tmp_blending_op_42*tmp_blending_op_87 + tmp_blending_op_98;
             const real_t tmp_blending_op_100 = tmp_blending_op_92*tmp_blending_op_99;
             const real_t tmp_blending_op_101 = tmp_blending_op_62*tmp_blending_op_80 + tmp_blending_op_83;
             const real_t tmp_blending_op_102 = tmp_blending_op_101*tmp_blending_op_87 + tmp_blending_op_84*tmp_blending_op_86;
             const real_t tmp_blending_op_103 = tmp_blending_op_56*tmp_blending_op_78;
             const real_t tmp_blending_op_104 = tmp_blending_op_103 + tmp_blending_op_83;
             const real_t tmp_blending_op_105 = tmp_blending_op_104*tmp_blending_op_87 - tmp_blending_op_83*tmp_blending_op_85;
             const real_t tmp_blending_op_113 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.5 + tmp_blending_op_2*0.16666666666666666;
             const real_t tmp_blending_op_114 = (tmp_blending_op_113*tmp_blending_op_113);
             const real_t tmp_blending_op_115 = -tmp_blending_op_113 - tmp_blending_op_17;
             const real_t tmp_blending_op_116 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.5 + tmp_blending_op_27*0.16666666666666666;
             const real_t tmp_blending_op_117 = -tmp_blending_op_116 - tmp_blending_op_6;
             const real_t tmp_blending_op_118 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.5 + tmp_blending_op_32*0.16666666666666666;
             const real_t tmp_blending_op_119 = -tmp_blending_op_118 - tmp_blending_op_13;
             const real_t tmp_blending_op_120 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_117*tmp_blending_op_18 - tmp_blending_op_115*tmp_blending_op_12 + tmp_blending_op_115*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_117*tmp_blending_op_19 - tmp_blending_op_119*tmp_blending_op_20 + tmp_blending_op_119*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_121 = -tmp_blending_op_120 + tmp_blending_op_22;
             const real_t tmp_blending_op_122 = -tmp_blending_op_121;
             const real_t tmp_blending_op_123 = (tmp_blending_op_116*tmp_blending_op_116);
             const real_t tmp_blending_op_124 = (tmp_blending_op_118*tmp_blending_op_118);
             const real_t tmp_blending_op_125 = tmp_blending_op_114 + tmp_blending_op_123 + tmp_blending_op_124;
             const real_t tmp_blending_op_126 = tmp_blending_op_113*tmp_blending_op_42;
             const real_t tmp_blending_op_127 = tmp_blending_op_121 + tmp_blending_op_126;
             const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_127;
             const real_t tmp_blending_op_129 = pow(tmp_blending_op_125, -1.5000000000000000);
             const real_t tmp_blending_op_130 = tmp_blending_op_129*tmp_blending_op_48;
             const real_t tmp_blending_op_131 = tmp_blending_op_125*tmp_blending_op_51;
             const real_t tmp_blending_op_132 = -tmp_blending_op_118*tmp_blending_op_121 - tmp_blending_op_131;
             const real_t tmp_blending_op_133 = tmp_blending_op_130*tmp_blending_op_132;
             const real_t tmp_blending_op_134 = tmp_blending_op_116*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_56;
             const real_t tmp_blending_op_135 = tmp_blending_op_130*tmp_blending_op_134;
             const real_t tmp_blending_op_136 = tmp_blending_op_113*tmp_blending_op_122;
             const real_t tmp_blending_op_137 = tmp_blending_op_125*tmp_blending_op_42 + tmp_blending_op_136;
             const real_t tmp_blending_op_138 = tmp_blending_op_130*tmp_blending_op_137;
             const real_t tmp_blending_op_139 = tmp_blending_op_118*tmp_blending_op_62 + tmp_blending_op_121;
             const real_t tmp_blending_op_140 = tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*tmp_blending_op_139;
             const real_t tmp_blending_op_141 = tmp_blending_op_116*tmp_blending_op_56;
             const real_t tmp_blending_op_142 = tmp_blending_op_121 + tmp_blending_op_141;
             const real_t tmp_blending_op_143 = -tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*tmp_blending_op_142;
             const real_t tmp_blending_op_151 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.5;
             const real_t tmp_blending_op_152 = (tmp_blending_op_151*tmp_blending_op_151);
             const real_t tmp_blending_op_153 = -tmp_blending_op_151 - tmp_blending_op_17;
             const real_t tmp_blending_op_154 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.5;
             const real_t tmp_blending_op_155 = -tmp_blending_op_154 - tmp_blending_op_6;
             const real_t tmp_blending_op_156 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.5;
             const real_t tmp_blending_op_157 = -tmp_blending_op_13 - tmp_blending_op_156;
             const real_t tmp_blending_op_158 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_155*tmp_blending_op_18 - tmp_blending_op_12*tmp_blending_op_153 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_153 - tmp_blending_op_155*tmp_blending_op_19 - tmp_blending_op_157*tmp_blending_op_20 + tmp_blending_op_157*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_159 = -tmp_blending_op_158 + tmp_blending_op_22;
             const real_t tmp_blending_op_160 = -tmp_blending_op_159;
             const real_t tmp_blending_op_161 = (tmp_blending_op_154*tmp_blending_op_154);
             const real_t tmp_blending_op_162 = (tmp_blending_op_156*tmp_blending_op_156);
             const real_t tmp_blending_op_163 = tmp_blending_op_152 + tmp_blending_op_161 + tmp_blending_op_162;
             const real_t tmp_blending_op_164 = tmp_blending_op_151*tmp_blending_op_42;
             const real_t tmp_blending_op_165 = tmp_blending_op_159 + tmp_blending_op_164;
             const real_t tmp_blending_op_166 = tmp_blending_op_152*tmp_blending_op_160 + tmp_blending_op_163*tmp_blending_op_165;
             const real_t tmp_blending_op_167 = pow(tmp_blending_op_163, -1.5000000000000000);
             const real_t tmp_blending_op_168 = tmp_blending_op_167*tmp_blending_op_48;
             const real_t tmp_blending_op_169 = tmp_blending_op_163*tmp_blending_op_51;
             const real_t tmp_blending_op_170 = -tmp_blending_op_156*tmp_blending_op_159 - tmp_blending_op_169;
             const real_t tmp_blending_op_171 = tmp_blending_op_168*tmp_blending_op_170;
             const real_t tmp_blending_op_172 = tmp_blending_op_154*tmp_blending_op_160 + tmp_blending_op_163*tmp_blending_op_56;
             const real_t tmp_blending_op_173 = tmp_blending_op_168*tmp_blending_op_172;
             const real_t tmp_blending_op_174 = tmp_blending_op_151*tmp_blending_op_160;
             const real_t tmp_blending_op_175 = tmp_blending_op_163*tmp_blending_op_42 + tmp_blending_op_174;
             const real_t tmp_blending_op_176 = tmp_blending_op_168*tmp_blending_op_175;
             const real_t tmp_blending_op_177 = tmp_blending_op_156*tmp_blending_op_62 + tmp_blending_op_159;
             const real_t tmp_blending_op_178 = tmp_blending_op_160*tmp_blending_op_162 + tmp_blending_op_163*tmp_blending_op_177;
             const real_t tmp_blending_op_179 = tmp_blending_op_154*tmp_blending_op_56;
             const real_t tmp_blending_op_180 = tmp_blending_op_159 + tmp_blending_op_179;
             const real_t tmp_blending_op_181 = -tmp_blending_op_159*tmp_blending_op_161 + tmp_blending_op_163*tmp_blending_op_180;
             const real_t tmp_blending_op_189 = p_affine_0_2 + tmp_blending_op_0*0.25 + tmp_blending_op_1*0.25 + tmp_blending_op_2*0.25;
             const real_t tmp_blending_op_190 = (tmp_blending_op_189*tmp_blending_op_189);
             const real_t tmp_blending_op_191 = -tmp_blending_op_17 - tmp_blending_op_189;
             const real_t tmp_blending_op_192 = p_affine_0_0 + tmp_blending_op_25*0.25 + tmp_blending_op_26*0.25 + tmp_blending_op_27*0.25;
             const real_t tmp_blending_op_193 = -tmp_blending_op_192 - tmp_blending_op_6;
             const real_t tmp_blending_op_194 = p_affine_0_1 + tmp_blending_op_30*0.25 + tmp_blending_op_31*0.25 + tmp_blending_op_32*0.25;
             const real_t tmp_blending_op_195 = -tmp_blending_op_13 - tmp_blending_op_194;
             const real_t tmp_blending_op_196 = tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_193 - tmp_blending_op_12*tmp_blending_op_191 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_191 - tmp_blending_op_19*tmp_blending_op_193 - tmp_blending_op_195*tmp_blending_op_20 + tmp_blending_op_195*tmp_blending_op_7*tmp_blending_op_8);
             const real_t tmp_blending_op_197 = -tmp_blending_op_196 + tmp_blending_op_22;
             const real_t tmp_blending_op_198 = -tmp_blending_op_197;
             const real_t tmp_blending_op_199 = (tmp_blending_op_192*tmp_blending_op_192);
             const real_t tmp_blending_op_200 = (tmp_blending_op_194*tmp_blending_op_194);
             const real_t tmp_blending_op_201 = tmp_blending_op_190 + tmp_blending_op_199 + tmp_blending_op_200;
             const real_t tmp_blending_op_202 = tmp_blending_op_189*tmp_blending_op_42;
             const real_t tmp_blending_op_203 = tmp_blending_op_197 + tmp_blending_op_202;
             const real_t tmp_blending_op_204 = tmp_blending_op_190*tmp_blending_op_198 + tmp_blending_op_201*tmp_blending_op_203;
             const real_t tmp_blending_op_205 = pow(tmp_blending_op_201, -1.5000000000000000);
             const real_t tmp_blending_op_206 = tmp_blending_op_205*tmp_blending_op_48;
             const real_t tmp_blending_op_207 = tmp_blending_op_201*tmp_blending_op_51;
             const real_t tmp_blending_op_208 = -tmp_blending_op_194*tmp_blending_op_197 - tmp_blending_op_207;
             const real_t tmp_blending_op_209 = tmp_blending_op_206*tmp_blending_op_208;
             const real_t tmp_blending_op_210 = tmp_blending_op_192*tmp_blending_op_198 + tmp_blending_op_201*tmp_blending_op_56;
             const real_t tmp_blending_op_211 = tmp_blending_op_206*tmp_blending_op_210;
             const real_t tmp_blending_op_212 = tmp_blending_op_189*tmp_blending_op_198;
             const real_t tmp_blending_op_213 = tmp_blending_op_201*tmp_blending_op_42 + tmp_blending_op_212;
             const real_t tmp_blending_op_214 = tmp_blending_op_206*tmp_blending_op_213;
             const real_t tmp_blending_op_215 = tmp_blending_op_194*tmp_blending_op_62 + tmp_blending_op_197;
             const real_t tmp_blending_op_216 = tmp_blending_op_198*tmp_blending_op_200 + tmp_blending_op_201*tmp_blending_op_215;
             const real_t tmp_blending_op_217 = tmp_blending_op_192*tmp_blending_op_56;
             const real_t tmp_blending_op_218 = tmp_blending_op_197 + tmp_blending_op_217;
             const real_t tmp_blending_op_219 = -tmp_blending_op_197*tmp_blending_op_199 + tmp_blending_op_201*tmp_blending_op_218;
             const real_t tmp_blending_op_228 = pow(tmp_blending_op_201, -2.5000000000000000)*tmp_blending_op_227;
             const real_t tmp_blending_op_229 = tmp_blending_op_192*tmp_blending_op_228;
             const real_t tmp_blending_op_232 = tmp_blending_op_192*2.0;
             const real_t tmp_blending_op_234 = tmp_blending_op_196 + tmp_blending_op_233;
             const real_t tmp_blending_op_235 = tmp_blending_op_192*tmp_blending_op_230 + tmp_blending_op_217*2.0 + tmp_blending_op_234;
             const real_t tmp_blending_op_236 = tmp_blending_op_210*tmp_blending_op_229;
             const real_t tmp_blending_op_237 = tmp_blending_op_194*tmp_blending_op_23*tmp_blending_op_55 - tmp_blending_op_232*tmp_blending_op_51;
             const real_t tmp_blending_op_238 = tmp_blending_op_199*tmp_blending_op_228;
             const real_t tmp_blending_op_239 = -tmp_blending_op_201*tmp_blending_op_230;
             const real_t tmp_blending_op_240 = tmp_blending_op_208*tmp_blending_op_229;
             const real_t tmp_blending_op_241 = tmp_blending_op_189*tmp_blending_op_240;
             const real_t tmp_blending_op_242 = tmp_blending_op_189*tmp_blending_op_230 + tmp_blending_op_232*tmp_blending_op_42;
             const real_t tmp_blending_op_243 = tmp_blending_op_213*tmp_blending_op_229;
             const real_t tmp_blending_op_244 = tmp_blending_op_194*tmp_blending_op_243;
             const real_t tmp_blending_op_245 = -tmp_blending_op_207;
             const real_t tmp_blending_op_246 = tmp_blending_op_194*2.0;
             const real_t tmp_blending_op_247 = tmp_blending_op_194*tmp_blending_op_228;
             const real_t tmp_blending_op_248 = tmp_blending_op_206*(tmp_blending_op_192*tmp_blending_op_51 + tmp_blending_op_246*tmp_blending_op_56);
             const real_t tmp_blending_op_249 = tmp_blending_op_200*tmp_blending_op_228;
             const real_t tmp_blending_op_250 = tmp_blending_op_189*tmp_blending_op_247;
             const real_t tmp_blending_op_251 = -tmp_blending_op_210*tmp_blending_op_250;
             const real_t tmp_blending_op_252 = -tmp_blending_op_194*tmp_blending_op_51 - tmp_blending_op_197;
             const real_t tmp_blending_op_254 = tmp_blending_op_189*tmp_blending_op_51;
             const real_t tmp_blending_op_255 = tmp_blending_op_246*tmp_blending_op_42 + tmp_blending_op_254;
             const real_t tmp_blending_op_257 = -tmp_blending_op_201*tmp_blending_op_256;
             const real_t tmp_blending_op_258 = tmp_blending_op_189*2.0;
             const real_t tmp_blending_op_259 = tmp_blending_op_189*tmp_blending_op_228;
             const real_t tmp_blending_op_260 = tmp_blending_op_206*(tmp_blending_op_192*tmp_blending_op_256 + tmp_blending_op_258*tmp_blending_op_56);
             const real_t tmp_blending_op_261 = tmp_blending_op_190*tmp_blending_op_228;
             const real_t tmp_blending_op_262 = tmp_blending_op_206*(tmp_blending_op_194*tmp_blending_op_256 + tmp_blending_op_254*-2.0);
             const real_t tmp_blending_op_263 = tmp_blending_op_189*tmp_blending_op_256 + tmp_blending_op_202*2.0 + tmp_blending_op_234;
             const real_t tmp_blending_op_265 = pow(tmp_blending_op_163, -2.5000000000000000)*tmp_blending_op_227;
             const real_t tmp_blending_op_266 = tmp_blending_op_154*tmp_blending_op_265;
             const real_t tmp_blending_op_267 = tmp_blending_op_154*2.0;
             const real_t tmp_blending_op_268 = tmp_blending_op_158 + tmp_blending_op_233;
             const real_t tmp_blending_op_269 = tmp_blending_op_154*tmp_blending_op_230 + tmp_blending_op_179*2.0 + tmp_blending_op_268;
             const real_t tmp_blending_op_270 = tmp_blending_op_172*tmp_blending_op_266;
             const real_t tmp_blending_op_271 = tmp_blending_op_156*tmp_blending_op_23*tmp_blending_op_55 - tmp_blending_op_267*tmp_blending_op_51;
             const real_t tmp_blending_op_272 = tmp_blending_op_161*tmp_blending_op_265;
             const real_t tmp_blending_op_273 = -tmp_blending_op_163*tmp_blending_op_230;
             const real_t tmp_blending_op_274 = tmp_blending_op_170*tmp_blending_op_266;
             const real_t tmp_blending_op_275 = tmp_blending_op_151*tmp_blending_op_274;
             const real_t tmp_blending_op_276 = tmp_blending_op_151*tmp_blending_op_230 + tmp_blending_op_267*tmp_blending_op_42;
             const real_t tmp_blending_op_277 = tmp_blending_op_175*tmp_blending_op_266;
             const real_t tmp_blending_op_278 = tmp_blending_op_156*tmp_blending_op_277;
             const real_t tmp_blending_op_279 = -tmp_blending_op_169;
             const real_t tmp_blending_op_280 = tmp_blending_op_156*2.0;
             const real_t tmp_blending_op_281 = tmp_blending_op_156*tmp_blending_op_265;
             const real_t tmp_blending_op_282 = tmp_blending_op_168*(tmp_blending_op_154*tmp_blending_op_51 + tmp_blending_op_280*tmp_blending_op_56);
             const real_t tmp_blending_op_283 = tmp_blending_op_162*tmp_blending_op_265;
             const real_t tmp_blending_op_284 = tmp_blending_op_151*tmp_blending_op_281;
             const real_t tmp_blending_op_285 = -tmp_blending_op_172*tmp_blending_op_284;
             const real_t tmp_blending_op_286 = -tmp_blending_op_156*tmp_blending_op_51 - tmp_blending_op_159;
             const real_t tmp_blending_op_287 = tmp_blending_op_151*tmp_blending_op_51;
             const real_t tmp_blending_op_288 = tmp_blending_op_280*tmp_blending_op_42 + tmp_blending_op_287;
             const real_t tmp_blending_op_289 = -tmp_blending_op_163*tmp_blending_op_256;
             const real_t tmp_blending_op_290 = tmp_blending_op_151*2.0;
             const real_t tmp_blending_op_291 = tmp_blending_op_151*tmp_blending_op_265;
             const real_t tmp_blending_op_292 = tmp_blending_op_168*(tmp_blending_op_154*tmp_blending_op_256 + tmp_blending_op_290*tmp_blending_op_56);
             const real_t tmp_blending_op_293 = tmp_blending_op_152*tmp_blending_op_265;
             const real_t tmp_blending_op_294 = tmp_blending_op_168*(tmp_blending_op_156*tmp_blending_op_256 + tmp_blending_op_287*-2.0);
             const real_t tmp_blending_op_295 = tmp_blending_op_151*tmp_blending_op_256 + tmp_blending_op_164*2.0 + tmp_blending_op_268;
             const real_t tmp_blending_op_296 = pow(tmp_blending_op_125, -2.5000000000000000)*tmp_blending_op_227;
             const real_t tmp_blending_op_297 = tmp_blending_op_116*tmp_blending_op_296;
             const real_t tmp_blending_op_298 = tmp_blending_op_116*2.0;
             const real_t tmp_blending_op_299 = tmp_blending_op_120 + tmp_blending_op_233;
             const real_t tmp_blending_op_300 = tmp_blending_op_116*tmp_blending_op_230 + tmp_blending_op_141*2.0 + tmp_blending_op_299;
             const real_t tmp_blending_op_301 = tmp_blending_op_134*tmp_blending_op_297;
             const real_t tmp_blending_op_302 = tmp_blending_op_118*tmp_blending_op_23*tmp_blending_op_55 - tmp_blending_op_298*tmp_blending_op_51;
             const real_t tmp_blending_op_303 = tmp_blending_op_123*tmp_blending_op_296;
             const real_t tmp_blending_op_304 = -tmp_blending_op_125*tmp_blending_op_230;
             const real_t tmp_blending_op_305 = tmp_blending_op_132*tmp_blending_op_297;
             const real_t tmp_blending_op_306 = tmp_blending_op_113*tmp_blending_op_305;
             const real_t tmp_blending_op_307 = tmp_blending_op_113*tmp_blending_op_230 + tmp_blending_op_298*tmp_blending_op_42;
             const real_t tmp_blending_op_308 = tmp_blending_op_137*tmp_blending_op_297;
             const real_t tmp_blending_op_309 = tmp_blending_op_118*tmp_blending_op_308;
             const real_t tmp_blending_op_310 = -tmp_blending_op_131;
             const real_t tmp_blending_op_311 = tmp_blending_op_118*2.0;
             const real_t tmp_blending_op_312 = tmp_blending_op_118*tmp_blending_op_296;
             const real_t tmp_blending_op_313 = tmp_blending_op_130*(tmp_blending_op_116*tmp_blending_op_51 + tmp_blending_op_311*tmp_blending_op_56);
             const real_t tmp_blending_op_314 = tmp_blending_op_124*tmp_blending_op_296;
             const real_t tmp_blending_op_315 = tmp_blending_op_113*tmp_blending_op_312;
             const real_t tmp_blending_op_316 = -tmp_blending_op_134*tmp_blending_op_315;
             const real_t tmp_blending_op_317 = -tmp_blending_op_118*tmp_blending_op_51 - tmp_blending_op_121;
             const real_t tmp_blending_op_318 = tmp_blending_op_113*tmp_blending_op_51;
             const real_t tmp_blending_op_319 = tmp_blending_op_311*tmp_blending_op_42 + tmp_blending_op_318;
             const real_t tmp_blending_op_320 = -tmp_blending_op_125*tmp_blending_op_256;
             const real_t tmp_blending_op_321 = tmp_blending_op_113*2.0;
             const real_t tmp_blending_op_322 = tmp_blending_op_113*tmp_blending_op_296;
             const real_t tmp_blending_op_323 = tmp_blending_op_130*(tmp_blending_op_116*tmp_blending_op_256 + tmp_blending_op_321*tmp_blending_op_56);
             const real_t tmp_blending_op_324 = tmp_blending_op_114*tmp_blending_op_296;
             const real_t tmp_blending_op_325 = tmp_blending_op_130*(tmp_blending_op_118*tmp_blending_op_256 + tmp_blending_op_318*-2.0);
             const real_t tmp_blending_op_326 = tmp_blending_op_113*tmp_blending_op_256 + tmp_blending_op_126*2.0 + tmp_blending_op_299;
             const real_t tmp_blending_op_327 = tmp_blending_op_227*pow(tmp_blending_op_87, -2.5000000000000000);
             const real_t tmp_blending_op_328 = tmp_blending_op_327*tmp_blending_op_78;
             const real_t tmp_blending_op_329 = tmp_blending_op_78*2.0;
             const real_t tmp_blending_op_330 = tmp_blending_op_233 + tmp_blending_op_82;
             const real_t tmp_blending_op_331 = tmp_blending_op_103*2.0 + tmp_blending_op_230*tmp_blending_op_78 + tmp_blending_op_330;
             const real_t tmp_blending_op_332 = tmp_blending_op_328*tmp_blending_op_96;
             const real_t tmp_blending_op_333 = tmp_blending_op_23*tmp_blending_op_55*tmp_blending_op_80 - tmp_blending_op_329*tmp_blending_op_51;
             const real_t tmp_blending_op_334 = tmp_blending_op_327*tmp_blending_op_85;
             const real_t tmp_blending_op_335 = -tmp_blending_op_230*tmp_blending_op_87;
             const real_t tmp_blending_op_336 = tmp_blending_op_328*tmp_blending_op_94;
             const real_t tmp_blending_op_337 = tmp_blending_op_336*tmp_blending_op_75;
             const real_t tmp_blending_op_338 = tmp_blending_op_230*tmp_blending_op_75 + tmp_blending_op_329*tmp_blending_op_42;
             const real_t tmp_blending_op_339 = tmp_blending_op_328*tmp_blending_op_99;
             const real_t tmp_blending_op_340 = tmp_blending_op_339*tmp_blending_op_80;
             const real_t tmp_blending_op_341 = -tmp_blending_op_93;
             const real_t tmp_blending_op_342 = tmp_blending_op_80*2.0;
             const real_t tmp_blending_op_343 = tmp_blending_op_327*tmp_blending_op_80;
             const real_t tmp_blending_op_344 = tmp_blending_op_92*(tmp_blending_op_342*tmp_blending_op_56 + tmp_blending_op_51*tmp_blending_op_78);
             const real_t tmp_blending_op_345 = tmp_blending_op_327*tmp_blending_op_86;
             const real_t tmp_blending_op_346 = tmp_blending_op_343*tmp_blending_op_75;
             const real_t tmp_blending_op_347 = -tmp_blending_op_346*tmp_blending_op_96;
             const real_t tmp_blending_op_348 = -tmp_blending_op_51*tmp_blending_op_80 - tmp_blending_op_83;
             const real_t tmp_blending_op_349 = tmp_blending_op_51*tmp_blending_op_75;
             const real_t tmp_blending_op_350 = tmp_blending_op_342*tmp_blending_op_42 + tmp_blending_op_349;
             const real_t tmp_blending_op_351 = -tmp_blending_op_256*tmp_blending_op_87;
             const real_t tmp_blending_op_352 = tmp_blending_op_75*2.0;
             const real_t tmp_blending_op_353 = tmp_blending_op_327*tmp_blending_op_75;
             const real_t tmp_blending_op_354 = tmp_blending_op_92*(tmp_blending_op_256*tmp_blending_op_78 + tmp_blending_op_352*tmp_blending_op_56);
             const real_t tmp_blending_op_355 = tmp_blending_op_327*tmp_blending_op_76;
             const real_t tmp_blending_op_356 = tmp_blending_op_92*(tmp_blending_op_256*tmp_blending_op_80 + tmp_blending_op_349*-2.0);
             const real_t tmp_blending_op_357 = tmp_blending_op_256*tmp_blending_op_75 + tmp_blending_op_330 + tmp_blending_op_88*2.0;
             const real_t tmp_blending_op_358 = tmp_blending_op_227*pow(tmp_blending_op_40, -2.5000000000000000);
             const real_t tmp_blending_op_359 = tmp_blending_op_28*tmp_blending_op_358;
             const real_t tmp_blending_op_360 = tmp_blending_op_28*2.0;
             const real_t tmp_blending_op_361 = tmp_blending_op_233 + tmp_blending_op_35;
             const real_t tmp_blending_op_362 = tmp_blending_op_230*tmp_blending_op_28 + tmp_blending_op_361 + tmp_blending_op_65*2.0;
             const real_t tmp_blending_op_363 = tmp_blending_op_359*tmp_blending_op_57;
             const real_t tmp_blending_op_364 = tmp_blending_op_23*tmp_blending_op_33*tmp_blending_op_55 - tmp_blending_op_360*tmp_blending_op_51;
             const real_t tmp_blending_op_365 = tmp_blending_op_358*tmp_blending_op_38;
             const real_t tmp_blending_op_366 = -tmp_blending_op_230*tmp_blending_op_40;
             const real_t tmp_blending_op_367 = tmp_blending_op_359*tmp_blending_op_53;
             const real_t tmp_blending_op_368 = tmp_blending_op_3*tmp_blending_op_367;
             const real_t tmp_blending_op_369 = tmp_blending_op_230*tmp_blending_op_3 + tmp_blending_op_360*tmp_blending_op_42;
             const real_t tmp_blending_op_370 = tmp_blending_op_359*tmp_blending_op_60;
             const real_t tmp_blending_op_371 = tmp_blending_op_33*tmp_blending_op_370;
             const real_t tmp_blending_op_372 = -tmp_blending_op_52;
             const real_t tmp_blending_op_373 = tmp_blending_op_33*2.0;
             const real_t tmp_blending_op_374 = tmp_blending_op_33*tmp_blending_op_358;
             const real_t tmp_blending_op_375 = tmp_blending_op_49*(tmp_blending_op_28*tmp_blending_op_51 + tmp_blending_op_373*tmp_blending_op_56);
             const real_t tmp_blending_op_376 = tmp_blending_op_358*tmp_blending_op_39;
             const real_t tmp_blending_op_377 = tmp_blending_op_3*tmp_blending_op_374;
             const real_t tmp_blending_op_378 = -tmp_blending_op_377*tmp_blending_op_57;
             const real_t tmp_blending_op_379 = -tmp_blending_op_33*tmp_blending_op_51 - tmp_blending_op_36;
             const real_t tmp_blending_op_380 = tmp_blending_op_3*tmp_blending_op_51;
             const real_t tmp_blending_op_381 = tmp_blending_op_373*tmp_blending_op_42 + tmp_blending_op_380;
             const real_t tmp_blending_op_382 = -tmp_blending_op_256*tmp_blending_op_40;
             const real_t tmp_blending_op_383 = tmp_blending_op_3*2.0;
             const real_t tmp_blending_op_384 = tmp_blending_op_3*tmp_blending_op_358;
             const real_t tmp_blending_op_385 = tmp_blending_op_49*(tmp_blending_op_256*tmp_blending_op_28 + tmp_blending_op_383*tmp_blending_op_56);
             const real_t tmp_blending_op_386 = tmp_blending_op_358*tmp_blending_op_4;
             const real_t tmp_blending_op_387 = tmp_blending_op_49*(tmp_blending_op_256*tmp_blending_op_33 + tmp_blending_op_380*-2.0);
             const real_t tmp_blending_op_388 = tmp_blending_op_256*tmp_blending_op_3 + tmp_blending_op_361 + tmp_blending_op_43*2.0;
             const real_t jac_blending_2_2_q_4 = tmp_blending_op_45*tmp_blending_op_49;
             const real_t jac_blending_2_1_q_4 = tmp_blending_op_3*tmp_blending_op_54;
             const real_t jac_blending_2_0_q_4 = tmp_blending_op_3*tmp_blending_op_58;
             const real_t jac_blending_1_2_q_4 = tmp_blending_op_33*tmp_blending_op_61;
             const real_t jac_blending_1_1_q_4 = tmp_blending_op_49*tmp_blending_op_64;
             const real_t tmp_blending_op_72 = jac_blending_1_1_q_4*jac_blending_2_0_q_4;
             const real_t jac_blending_1_0_q_4 = tmp_blending_op_33*tmp_blending_op_58;
             const real_t tmp_blending_op_69 = jac_blending_1_0_q_4*jac_blending_2_1_q_4;
             const real_t jac_blending_0_2_q_4 = tmp_blending_op_28*tmp_blending_op_61;
             const real_t jac_blending_0_1_q_4 = tmp_blending_op_28*tmp_blending_op_54;
             const real_t tmp_blending_op_71 = jac_blending_0_1_q_4*jac_blending_1_0_q_4;
             const real_t jac_blending_0_0_q_4 = tmp_blending_op_49*tmp_blending_op_67;
             const real_t tmp_blending_op_68 = jac_blending_0_0_q_4*jac_blending_1_1_q_4;
             const real_t tmp_blending_op_70 = jac_blending_0_0_q_4*jac_blending_2_1_q_4;
             const real_t tmp_blending_op_73 = jac_blending_0_1_q_4*jac_blending_1_2_q_4*jac_blending_2_0_q_4 + jac_blending_0_2_q_4*tmp_blending_op_69 - jac_blending_0_2_q_4*tmp_blending_op_72 - jac_blending_1_2_q_4*tmp_blending_op_70 + jac_blending_2_2_q_4*tmp_blending_op_68 - jac_blending_2_2_q_4*tmp_blending_op_71;
             const real_t tmp_blending_op_74 = 1.0 / (tmp_blending_op_73);
             const real_t abs_det_jac_blending_q_4 = tmp_blending_op_73;
             const real_t jac_blending_inv_2_2_q_4 = tmp_blending_op_74*(tmp_blending_op_68 - tmp_blending_op_71);
             const real_t jac_blending_inv_2_1_q_4 = tmp_blending_op_74*(jac_blending_0_1_q_4*jac_blending_2_0_q_4 - tmp_blending_op_70);
             const real_t jac_blending_inv_2_0_q_4 = tmp_blending_op_74*(tmp_blending_op_69 - tmp_blending_op_72);
             const real_t jac_blending_inv_1_2_q_4 = tmp_blending_op_74*(-jac_blending_0_0_q_4*jac_blending_1_2_q_4 + jac_blending_0_2_q_4*jac_blending_1_0_q_4);
             const real_t jac_blending_inv_1_1_q_4 = tmp_blending_op_74*(jac_blending_0_0_q_4*jac_blending_2_2_q_4 - jac_blending_0_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_1_0_q_4 = tmp_blending_op_74*(-jac_blending_1_0_q_4*jac_blending_2_2_q_4 + jac_blending_1_2_q_4*jac_blending_2_0_q_4);
             const real_t jac_blending_inv_0_2_q_4 = tmp_blending_op_74*(jac_blending_0_1_q_4*jac_blending_1_2_q_4 - jac_blending_0_2_q_4*jac_blending_1_1_q_4);
             const real_t jac_blending_inv_0_1_q_4 = tmp_blending_op_74*(-jac_blending_0_1_q_4*jac_blending_2_2_q_4 + jac_blending_0_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_inv_0_0_q_4 = tmp_blending_op_74*(jac_blending_1_1_q_4*jac_blending_2_2_q_4 - jac_blending_1_2_q_4*jac_blending_2_1_q_4);
             const real_t jac_blending_2_2_q_3 = tmp_blending_op_90*tmp_blending_op_92;
             const real_t jac_blending_2_1_q_3 = tmp_blending_op_75*tmp_blending_op_95;
             const real_t jac_blending_2_0_q_3 = tmp_blending_op_75*tmp_blending_op_97;
             const real_t jac_blending_1_2_q_3 = tmp_blending_op_100*tmp_blending_op_80;
             const real_t jac_blending_1_1_q_3 = tmp_blending_op_102*tmp_blending_op_92;
             const real_t tmp_blending_op_110 = jac_blending_1_1_q_3*jac_blending_2_0_q_3;
             const real_t jac_blending_1_0_q_3 = tmp_blending_op_80*tmp_blending_op_97;
             const real_t tmp_blending_op_107 = jac_blending_1_0_q_3*jac_blending_2_1_q_3;
             const real_t jac_blending_0_2_q_3 = tmp_blending_op_100*tmp_blending_op_78;
             const real_t jac_blending_0_1_q_3 = tmp_blending_op_78*tmp_blending_op_95;
             const real_t tmp_blending_op_109 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
             const real_t jac_blending_0_0_q_3 = tmp_blending_op_105*tmp_blending_op_92;
             const real_t tmp_blending_op_106 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
             const real_t tmp_blending_op_108 = jac_blending_0_0_q_3*jac_blending_2_1_q_3;
             const real_t tmp_blending_op_111 = jac_blending_0_1_q_3*jac_blending_1_2_q_3*jac_blending_2_0_q_3 + jac_blending_0_2_q_3*tmp_blending_op_107 - jac_blending_0_2_q_3*tmp_blending_op_110 - jac_blending_1_2_q_3*tmp_blending_op_108 + jac_blending_2_2_q_3*tmp_blending_op_106 - jac_blending_2_2_q_3*tmp_blending_op_109;
             const real_t tmp_blending_op_112 = 1.0 / (tmp_blending_op_111);
             const real_t abs_det_jac_blending_q_3 = tmp_blending_op_111;
             const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_112*(tmp_blending_op_106 - tmp_blending_op_109);
             const real_t jac_blending_inv_2_1_q_3 = tmp_blending_op_112*(jac_blending_0_1_q_3*jac_blending_2_0_q_3 - tmp_blending_op_108);
             const real_t jac_blending_inv_2_0_q_3 = tmp_blending_op_112*(tmp_blending_op_107 - tmp_blending_op_110);
             const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_112*(-jac_blending_0_0_q_3*jac_blending_1_2_q_3 + jac_blending_0_2_q_3*jac_blending_1_0_q_3);
             const real_t jac_blending_inv_1_1_q_3 = tmp_blending_op_112*(jac_blending_0_0_q_3*jac_blending_2_2_q_3 - jac_blending_0_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_1_0_q_3 = tmp_blending_op_112*(-jac_blending_1_0_q_3*jac_blending_2_2_q_3 + jac_blending_1_2_q_3*jac_blending_2_0_q_3);
             const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_112*(jac_blending_0_1_q_3*jac_blending_1_2_q_3 - jac_blending_0_2_q_3*jac_blending_1_1_q_3);
             const real_t jac_blending_inv_0_1_q_3 = tmp_blending_op_112*(-jac_blending_0_1_q_3*jac_blending_2_2_q_3 + jac_blending_0_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_inv_0_0_q_3 = tmp_blending_op_112*(jac_blending_1_1_q_3*jac_blending_2_2_q_3 - jac_blending_1_2_q_3*jac_blending_2_1_q_3);
             const real_t jac_blending_2_2_q_2 = tmp_blending_op_128*tmp_blending_op_130;
             const real_t jac_blending_2_1_q_2 = tmp_blending_op_113*tmp_blending_op_133;
             const real_t jac_blending_2_0_q_2 = tmp_blending_op_113*tmp_blending_op_135;
             const real_t jac_blending_1_2_q_2 = tmp_blending_op_118*tmp_blending_op_138;
             const real_t jac_blending_1_1_q_2 = tmp_blending_op_130*tmp_blending_op_140;
             const real_t tmp_blending_op_148 = jac_blending_1_1_q_2*jac_blending_2_0_q_2;
             const real_t jac_blending_1_0_q_2 = tmp_blending_op_118*tmp_blending_op_135;
             const real_t tmp_blending_op_145 = jac_blending_1_0_q_2*jac_blending_2_1_q_2;
             const real_t jac_blending_0_2_q_2 = tmp_blending_op_116*tmp_blending_op_138;
             const real_t jac_blending_0_1_q_2 = tmp_blending_op_116*tmp_blending_op_133;
             const real_t tmp_blending_op_147 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
             const real_t jac_blending_0_0_q_2 = tmp_blending_op_130*tmp_blending_op_143;
             const real_t tmp_blending_op_144 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
             const real_t tmp_blending_op_146 = jac_blending_0_0_q_2*jac_blending_2_1_q_2;
             const real_t tmp_blending_op_149 = jac_blending_0_1_q_2*jac_blending_1_2_q_2*jac_blending_2_0_q_2 + jac_blending_0_2_q_2*tmp_blending_op_145 - jac_blending_0_2_q_2*tmp_blending_op_148 - jac_blending_1_2_q_2*tmp_blending_op_146 + jac_blending_2_2_q_2*tmp_blending_op_144 - jac_blending_2_2_q_2*tmp_blending_op_147;
             const real_t tmp_blending_op_150 = 1.0 / (tmp_blending_op_149);
             const real_t abs_det_jac_blending_q_2 = tmp_blending_op_149;
             const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_150*(tmp_blending_op_144 - tmp_blending_op_147);
             const real_t jac_blending_inv_2_1_q_2 = tmp_blending_op_150*(jac_blending_0_1_q_2*jac_blending_2_0_q_2 - tmp_blending_op_146);
             const real_t jac_blending_inv_2_0_q_2 = tmp_blending_op_150*(tmp_blending_op_145 - tmp_blending_op_148);
             const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_150*(-jac_blending_0_0_q_2*jac_blending_1_2_q_2 + jac_blending_0_2_q_2*jac_blending_1_0_q_2);
             const real_t jac_blending_inv_1_1_q_2 = tmp_blending_op_150*(jac_blending_0_0_q_2*jac_blending_2_2_q_2 - jac_blending_0_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_1_0_q_2 = tmp_blending_op_150*(-jac_blending_1_0_q_2*jac_blending_2_2_q_2 + jac_blending_1_2_q_2*jac_blending_2_0_q_2);
             const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_150*(jac_blending_0_1_q_2*jac_blending_1_2_q_2 - jac_blending_0_2_q_2*jac_blending_1_1_q_2);
             const real_t jac_blending_inv_0_1_q_2 = tmp_blending_op_150*(-jac_blending_0_1_q_2*jac_blending_2_2_q_2 + jac_blending_0_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_inv_0_0_q_2 = tmp_blending_op_150*(jac_blending_1_1_q_2*jac_blending_2_2_q_2 - jac_blending_1_2_q_2*jac_blending_2_1_q_2);
             const real_t jac_blending_2_2_q_1 = tmp_blending_op_166*tmp_blending_op_168;
             const real_t jac_blending_2_1_q_1 = tmp_blending_op_151*tmp_blending_op_171;
             const real_t jac_blending_2_0_q_1 = tmp_blending_op_151*tmp_blending_op_173;
             const real_t jac_blending_1_2_q_1 = tmp_blending_op_156*tmp_blending_op_176;
             const real_t jac_blending_1_1_q_1 = tmp_blending_op_168*tmp_blending_op_178;
             const real_t tmp_blending_op_186 = jac_blending_1_1_q_1*jac_blending_2_0_q_1;
             const real_t jac_blending_1_0_q_1 = tmp_blending_op_156*tmp_blending_op_173;
             const real_t tmp_blending_op_183 = jac_blending_1_0_q_1*jac_blending_2_1_q_1;
             const real_t jac_blending_0_2_q_1 = tmp_blending_op_154*tmp_blending_op_176;
             const real_t jac_blending_0_1_q_1 = tmp_blending_op_154*tmp_blending_op_171;
             const real_t tmp_blending_op_185 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
             const real_t jac_blending_0_0_q_1 = tmp_blending_op_168*tmp_blending_op_181;
             const real_t tmp_blending_op_182 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
             const real_t tmp_blending_op_184 = jac_blending_0_0_q_1*jac_blending_2_1_q_1;
             const real_t tmp_blending_op_187 = jac_blending_0_1_q_1*jac_blending_1_2_q_1*jac_blending_2_0_q_1 + jac_blending_0_2_q_1*tmp_blending_op_183 - jac_blending_0_2_q_1*tmp_blending_op_186 - jac_blending_1_2_q_1*tmp_blending_op_184 + jac_blending_2_2_q_1*tmp_blending_op_182 - jac_blending_2_2_q_1*tmp_blending_op_185;
             const real_t tmp_blending_op_188 = 1.0 / (tmp_blending_op_187);
             const real_t abs_det_jac_blending_q_1 = tmp_blending_op_187;
             const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_188*(tmp_blending_op_182 - tmp_blending_op_185);
             const real_t jac_blending_inv_2_1_q_1 = tmp_blending_op_188*(jac_blending_0_1_q_1*jac_blending_2_0_q_1 - tmp_blending_op_184);
             const real_t jac_blending_inv_2_0_q_1 = tmp_blending_op_188*(tmp_blending_op_183 - tmp_blending_op_186);
             const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_188*(-jac_blending_0_0_q_1*jac_blending_1_2_q_1 + jac_blending_0_2_q_1*jac_blending_1_0_q_1);
             const real_t jac_blending_inv_1_1_q_1 = tmp_blending_op_188*(jac_blending_0_0_q_1*jac_blending_2_2_q_1 - jac_blending_0_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_1_0_q_1 = tmp_blending_op_188*(-jac_blending_1_0_q_1*jac_blending_2_2_q_1 + jac_blending_1_2_q_1*jac_blending_2_0_q_1);
             const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_188*(jac_blending_0_1_q_1*jac_blending_1_2_q_1 - jac_blending_0_2_q_1*jac_blending_1_1_q_1);
             const real_t jac_blending_inv_0_1_q_1 = tmp_blending_op_188*(-jac_blending_0_1_q_1*jac_blending_2_2_q_1 + jac_blending_0_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_inv_0_0_q_1 = tmp_blending_op_188*(jac_blending_1_1_q_1*jac_blending_2_2_q_1 - jac_blending_1_2_q_1*jac_blending_2_1_q_1);
             const real_t jac_blending_2_2_q_0 = tmp_blending_op_204*tmp_blending_op_206;
             const real_t jac_blending_2_1_q_0 = tmp_blending_op_189*tmp_blending_op_209;
             const real_t jac_blending_2_0_q_0 = tmp_blending_op_189*tmp_blending_op_211;
             const real_t jac_blending_1_2_q_0 = tmp_blending_op_194*tmp_blending_op_214;
             const real_t jac_blending_1_1_q_0 = tmp_blending_op_206*tmp_blending_op_216;
             const real_t tmp_blending_op_224 = jac_blending_1_1_q_0*jac_blending_2_0_q_0;
             const real_t jac_blending_1_0_q_0 = tmp_blending_op_194*tmp_blending_op_211;
             const real_t tmp_blending_op_221 = jac_blending_1_0_q_0*jac_blending_2_1_q_0;
             const real_t jac_blending_0_2_q_0 = tmp_blending_op_192*tmp_blending_op_214;
             const real_t jac_blending_0_1_q_0 = tmp_blending_op_192*tmp_blending_op_209;
             const real_t tmp_blending_op_223 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
             const real_t jac_blending_0_0_q_0 = tmp_blending_op_206*tmp_blending_op_219;
             const real_t tmp_blending_op_220 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
             const real_t tmp_blending_op_222 = jac_blending_0_0_q_0*jac_blending_2_1_q_0;
             const real_t tmp_blending_op_225 = jac_blending_0_1_q_0*jac_blending_1_2_q_0*jac_blending_2_0_q_0 + jac_blending_0_2_q_0*tmp_blending_op_221 - jac_blending_0_2_q_0*tmp_blending_op_224 - jac_blending_1_2_q_0*tmp_blending_op_222 + jac_blending_2_2_q_0*tmp_blending_op_220 - jac_blending_2_2_q_0*tmp_blending_op_223;
             const real_t tmp_blending_op_226 = 1.0 / (tmp_blending_op_225);
             const real_t abs_det_jac_blending_q_0 = tmp_blending_op_225;
             const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_226*(tmp_blending_op_220 - tmp_blending_op_223);
             const real_t jac_blending_inv_2_1_q_0 = tmp_blending_op_226*(jac_blending_0_1_q_0*jac_blending_2_0_q_0 - tmp_blending_op_222);
             const real_t jac_blending_inv_2_0_q_0 = tmp_blending_op_226*(tmp_blending_op_221 - tmp_blending_op_224);
             const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_226*(-jac_blending_0_0_q_0*jac_blending_1_2_q_0 + jac_blending_0_2_q_0*jac_blending_1_0_q_0);
             const real_t jac_blending_inv_1_1_q_0 = tmp_blending_op_226*(jac_blending_0_0_q_0*jac_blending_2_2_q_0 - jac_blending_0_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_1_0_q_0 = tmp_blending_op_226*(-jac_blending_1_0_q_0*jac_blending_2_2_q_0 + jac_blending_1_2_q_0*jac_blending_2_0_q_0);
             const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_226*(jac_blending_0_1_q_0*jac_blending_1_2_q_0 - jac_blending_0_2_q_0*jac_blending_1_1_q_0);
             const real_t jac_blending_inv_0_1_q_0 = tmp_blending_op_226*(-jac_blending_0_1_q_0*jac_blending_2_2_q_0 + jac_blending_0_2_q_0*jac_blending_2_1_q_0);
             const real_t jac_blending_inv_0_0_q_0 = tmp_blending_op_226*(jac_blending_1_1_q_0*jac_blending_2_2_q_0 - jac_blending_1_2_q_0*jac_blending_2_1_q_0);
             const real_t hessian_blending_0_0_0_q_0 = tmp_blending_op_205*tmp_blending_op_47*(-tmp_blending_op_197*tmp_blending_op_232 + tmp_blending_op_199*tmp_blending_op_230 + tmp_blending_op_201*tmp_blending_op_231 + tmp_blending_op_218*tmp_blending_op_232)*1.0 - tmp_blending_op_219*tmp_blending_op_229;
             const real_t hessian_blending_0_0_1_q_0 = tmp_blending_op_194*tmp_blending_op_205*tmp_blending_op_235*tmp_blending_op_47*1.0 - tmp_blending_op_194*tmp_blending_op_236;
             const real_t hessian_blending_0_0_2_q_0 = tmp_blending_op_189*tmp_blending_op_205*tmp_blending_op_235*tmp_blending_op_47*1.0 - tmp_blending_op_189*tmp_blending_op_236;
             const real_t hessian_blending_0_1_0_q_0 = tmp_blending_op_192*tmp_blending_op_206*tmp_blending_op_237 - tmp_blending_op_208*tmp_blending_op_238 + tmp_blending_op_209;
             const real_t hessian_blending_0_1_1_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_200*tmp_blending_op_230 + tmp_blending_op_215*tmp_blending_op_232 + tmp_blending_op_239)*1.0 - tmp_blending_op_216*tmp_blending_op_229;
             const real_t hessian_blending_0_1_2_q_0 = tmp_blending_op_189*tmp_blending_op_205*tmp_blending_op_237*tmp_blending_op_47*1.0 - tmp_blending_op_241;
             const real_t hessian_blending_0_2_0_q_0 = tmp_blending_op_192*tmp_blending_op_206*tmp_blending_op_242 - tmp_blending_op_213*tmp_blending_op_238 + tmp_blending_op_214;
             const real_t hessian_blending_0_2_1_q_0 = tmp_blending_op_194*tmp_blending_op_205*tmp_blending_op_242*tmp_blending_op_47*1.0 - tmp_blending_op_244;
             const real_t hessian_blending_0_2_2_q_0 = -tmp_blending_op_204*tmp_blending_op_229 + tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_190*tmp_blending_op_230 + tmp_blending_op_203*tmp_blending_op_232 + tmp_blending_op_239)*1.0;
             const real_t hessian_blending_1_0_0_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_199*tmp_blending_op_51 + tmp_blending_op_218*tmp_blending_op_246 + tmp_blending_op_245)*1.0 - tmp_blending_op_219*tmp_blending_op_247;
             const real_t hessian_blending_1_0_1_q_0 = tmp_blending_op_194*tmp_blending_op_248 - tmp_blending_op_210*tmp_blending_op_249 + tmp_blending_op_211;
             const real_t hessian_blending_1_0_2_q_0 = tmp_blending_op_189*tmp_blending_op_248 + tmp_blending_op_251;
             const real_t hessian_blending_1_1_0_q_0 = tmp_blending_op_192*tmp_blending_op_205*tmp_blending_op_252*tmp_blending_op_47*1.0 - tmp_blending_op_194*tmp_blending_op_240;
             const real_t hessian_blending_1_1_1_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_198*tmp_blending_op_246 + tmp_blending_op_200*tmp_blending_op_51 + tmp_blending_op_201*tmp_blending_op_253 + tmp_blending_op_215*tmp_blending_op_246)*1.0 - tmp_blending_op_216*tmp_blending_op_247;
             const real_t hessian_blending_1_1_2_q_0 = tmp_blending_op_189*tmp_blending_op_205*tmp_blending_op_252*tmp_blending_op_47*1.0 - tmp_blending_op_208*tmp_blending_op_250;
             const real_t hessian_blending_1_2_0_q_0 = tmp_blending_op_192*tmp_blending_op_205*tmp_blending_op_255*tmp_blending_op_47*1.0 - tmp_blending_op_244;
             const real_t hessian_blending_1_2_1_q_0 = tmp_blending_op_194*tmp_blending_op_206*tmp_blending_op_255 - tmp_blending_op_213*tmp_blending_op_249 + tmp_blending_op_214;
             const real_t hessian_blending_1_2_2_q_0 = -tmp_blending_op_204*tmp_blending_op_247 + tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_190*tmp_blending_op_51 + tmp_blending_op_203*tmp_blending_op_246 + tmp_blending_op_245)*1.0;
             const real_t hessian_blending_2_0_0_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_199*tmp_blending_op_256 + tmp_blending_op_218*tmp_blending_op_258 + tmp_blending_op_257)*1.0 - tmp_blending_op_219*tmp_blending_op_259;
             const real_t hessian_blending_2_0_1_q_0 = tmp_blending_op_194*tmp_blending_op_260 + tmp_blending_op_251;
             const real_t hessian_blending_2_0_2_q_0 = tmp_blending_op_189*tmp_blending_op_260 - tmp_blending_op_210*tmp_blending_op_261 + tmp_blending_op_211;
             const real_t hessian_blending_2_1_0_q_0 = tmp_blending_op_192*tmp_blending_op_262 - tmp_blending_op_241;
             const real_t hessian_blending_2_1_1_q_0 = tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_200*tmp_blending_op_256 + tmp_blending_op_215*tmp_blending_op_258 + tmp_blending_op_257)*1.0 - tmp_blending_op_216*tmp_blending_op_259;
             const real_t hessian_blending_2_1_2_q_0 = tmp_blending_op_189*tmp_blending_op_262 - tmp_blending_op_208*tmp_blending_op_261 + tmp_blending_op_209;
             const real_t hessian_blending_2_2_0_q_0 = -tmp_blending_op_189*tmp_blending_op_243 + tmp_blending_op_192*tmp_blending_op_205*tmp_blending_op_263*tmp_blending_op_47*1.0;
             const real_t hessian_blending_2_2_1_q_0 = tmp_blending_op_194*tmp_blending_op_205*tmp_blending_op_263*tmp_blending_op_47*1.0 - tmp_blending_op_213*tmp_blending_op_250;
             const real_t hessian_blending_2_2_2_q_0 = -tmp_blending_op_204*tmp_blending_op_259 + tmp_blending_op_205*tmp_blending_op_47*(tmp_blending_op_190*tmp_blending_op_256 + tmp_blending_op_201*tmp_blending_op_264 + tmp_blending_op_203*tmp_blending_op_258 + tmp_blending_op_212*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_1 = tmp_blending_op_167*tmp_blending_op_47*(-tmp_blending_op_159*tmp_blending_op_267 + tmp_blending_op_161*tmp_blending_op_230 + tmp_blending_op_163*tmp_blending_op_231 + tmp_blending_op_180*tmp_blending_op_267)*1.0 - tmp_blending_op_181*tmp_blending_op_266;
             const real_t hessian_blending_0_0_1_q_1 = tmp_blending_op_156*tmp_blending_op_167*tmp_blending_op_269*tmp_blending_op_47*1.0 - tmp_blending_op_156*tmp_blending_op_270;
             const real_t hessian_blending_0_0_2_q_1 = tmp_blending_op_151*tmp_blending_op_167*tmp_blending_op_269*tmp_blending_op_47*1.0 - tmp_blending_op_151*tmp_blending_op_270;
             const real_t hessian_blending_0_1_0_q_1 = tmp_blending_op_154*tmp_blending_op_168*tmp_blending_op_271 - tmp_blending_op_170*tmp_blending_op_272 + tmp_blending_op_171;
             const real_t hessian_blending_0_1_1_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_162*tmp_blending_op_230 + tmp_blending_op_177*tmp_blending_op_267 + tmp_blending_op_273)*1.0 - tmp_blending_op_178*tmp_blending_op_266;
             const real_t hessian_blending_0_1_2_q_1 = tmp_blending_op_151*tmp_blending_op_167*tmp_blending_op_271*tmp_blending_op_47*1.0 - tmp_blending_op_275;
             const real_t hessian_blending_0_2_0_q_1 = tmp_blending_op_154*tmp_blending_op_168*tmp_blending_op_276 - tmp_blending_op_175*tmp_blending_op_272 + tmp_blending_op_176;
             const real_t hessian_blending_0_2_1_q_1 = tmp_blending_op_156*tmp_blending_op_167*tmp_blending_op_276*tmp_blending_op_47*1.0 - tmp_blending_op_278;
             const real_t hessian_blending_0_2_2_q_1 = -tmp_blending_op_166*tmp_blending_op_266 + tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_152*tmp_blending_op_230 + tmp_blending_op_165*tmp_blending_op_267 + tmp_blending_op_273)*1.0;
             const real_t hessian_blending_1_0_0_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_161*tmp_blending_op_51 + tmp_blending_op_180*tmp_blending_op_280 + tmp_blending_op_279)*1.0 - tmp_blending_op_181*tmp_blending_op_281;
             const real_t hessian_blending_1_0_1_q_1 = tmp_blending_op_156*tmp_blending_op_282 - tmp_blending_op_172*tmp_blending_op_283 + tmp_blending_op_173;
             const real_t hessian_blending_1_0_2_q_1 = tmp_blending_op_151*tmp_blending_op_282 + tmp_blending_op_285;
             const real_t hessian_blending_1_1_0_q_1 = tmp_blending_op_154*tmp_blending_op_167*tmp_blending_op_286*tmp_blending_op_47*1.0 - tmp_blending_op_156*tmp_blending_op_274;
             const real_t hessian_blending_1_1_1_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_160*tmp_blending_op_280 + tmp_blending_op_162*tmp_blending_op_51 + tmp_blending_op_163*tmp_blending_op_253 + tmp_blending_op_177*tmp_blending_op_280)*1.0 - tmp_blending_op_178*tmp_blending_op_281;
             const real_t hessian_blending_1_1_2_q_1 = tmp_blending_op_151*tmp_blending_op_167*tmp_blending_op_286*tmp_blending_op_47*1.0 - tmp_blending_op_170*tmp_blending_op_284;
             const real_t hessian_blending_1_2_0_q_1 = tmp_blending_op_154*tmp_blending_op_167*tmp_blending_op_288*tmp_blending_op_47*1.0 - tmp_blending_op_278;
             const real_t hessian_blending_1_2_1_q_1 = tmp_blending_op_156*tmp_blending_op_168*tmp_blending_op_288 - tmp_blending_op_175*tmp_blending_op_283 + tmp_blending_op_176;
             const real_t hessian_blending_1_2_2_q_1 = -tmp_blending_op_166*tmp_blending_op_281 + tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_152*tmp_blending_op_51 + tmp_blending_op_165*tmp_blending_op_280 + tmp_blending_op_279)*1.0;
             const real_t hessian_blending_2_0_0_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_161*tmp_blending_op_256 + tmp_blending_op_180*tmp_blending_op_290 + tmp_blending_op_289)*1.0 - tmp_blending_op_181*tmp_blending_op_291;
             const real_t hessian_blending_2_0_1_q_1 = tmp_blending_op_156*tmp_blending_op_292 + tmp_blending_op_285;
             const real_t hessian_blending_2_0_2_q_1 = tmp_blending_op_151*tmp_blending_op_292 - tmp_blending_op_172*tmp_blending_op_293 + tmp_blending_op_173;
             const real_t hessian_blending_2_1_0_q_1 = tmp_blending_op_154*tmp_blending_op_294 - tmp_blending_op_275;
             const real_t hessian_blending_2_1_1_q_1 = tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_162*tmp_blending_op_256 + tmp_blending_op_177*tmp_blending_op_290 + tmp_blending_op_289)*1.0 - tmp_blending_op_178*tmp_blending_op_291;
             const real_t hessian_blending_2_1_2_q_1 = tmp_blending_op_151*tmp_blending_op_294 - tmp_blending_op_170*tmp_blending_op_293 + tmp_blending_op_171;
             const real_t hessian_blending_2_2_0_q_1 = -tmp_blending_op_151*tmp_blending_op_277 + tmp_blending_op_154*tmp_blending_op_167*tmp_blending_op_295*tmp_blending_op_47*1.0;
             const real_t hessian_blending_2_2_1_q_1 = tmp_blending_op_156*tmp_blending_op_167*tmp_blending_op_295*tmp_blending_op_47*1.0 - tmp_blending_op_175*tmp_blending_op_284;
             const real_t hessian_blending_2_2_2_q_1 = -tmp_blending_op_166*tmp_blending_op_291 + tmp_blending_op_167*tmp_blending_op_47*(tmp_blending_op_152*tmp_blending_op_256 + tmp_blending_op_163*tmp_blending_op_264 + tmp_blending_op_165*tmp_blending_op_290 + tmp_blending_op_174*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_2 = tmp_blending_op_129*tmp_blending_op_47*(-tmp_blending_op_121*tmp_blending_op_298 + tmp_blending_op_123*tmp_blending_op_230 + tmp_blending_op_125*tmp_blending_op_231 + tmp_blending_op_142*tmp_blending_op_298)*1.0 - tmp_blending_op_143*tmp_blending_op_297;
             const real_t hessian_blending_0_0_1_q_2 = tmp_blending_op_118*tmp_blending_op_129*tmp_blending_op_300*tmp_blending_op_47*1.0 - tmp_blending_op_118*tmp_blending_op_301;
             const real_t hessian_blending_0_0_2_q_2 = tmp_blending_op_113*tmp_blending_op_129*tmp_blending_op_300*tmp_blending_op_47*1.0 - tmp_blending_op_113*tmp_blending_op_301;
             const real_t hessian_blending_0_1_0_q_2 = tmp_blending_op_116*tmp_blending_op_130*tmp_blending_op_302 - tmp_blending_op_132*tmp_blending_op_303 + tmp_blending_op_133;
             const real_t hessian_blending_0_1_1_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_124*tmp_blending_op_230 + tmp_blending_op_139*tmp_blending_op_298 + tmp_blending_op_304)*1.0 - tmp_blending_op_140*tmp_blending_op_297;
             const real_t hessian_blending_0_1_2_q_2 = tmp_blending_op_113*tmp_blending_op_129*tmp_blending_op_302*tmp_blending_op_47*1.0 - tmp_blending_op_306;
             const real_t hessian_blending_0_2_0_q_2 = tmp_blending_op_116*tmp_blending_op_130*tmp_blending_op_307 - tmp_blending_op_137*tmp_blending_op_303 + tmp_blending_op_138;
             const real_t hessian_blending_0_2_1_q_2 = tmp_blending_op_118*tmp_blending_op_129*tmp_blending_op_307*tmp_blending_op_47*1.0 - tmp_blending_op_309;
             const real_t hessian_blending_0_2_2_q_2 = -tmp_blending_op_128*tmp_blending_op_297 + tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_114*tmp_blending_op_230 + tmp_blending_op_127*tmp_blending_op_298 + tmp_blending_op_304)*1.0;
             const real_t hessian_blending_1_0_0_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_123*tmp_blending_op_51 + tmp_blending_op_142*tmp_blending_op_311 + tmp_blending_op_310)*1.0 - tmp_blending_op_143*tmp_blending_op_312;
             const real_t hessian_blending_1_0_1_q_2 = tmp_blending_op_118*tmp_blending_op_313 - tmp_blending_op_134*tmp_blending_op_314 + tmp_blending_op_135;
             const real_t hessian_blending_1_0_2_q_2 = tmp_blending_op_113*tmp_blending_op_313 + tmp_blending_op_316;
             const real_t hessian_blending_1_1_0_q_2 = tmp_blending_op_116*tmp_blending_op_129*tmp_blending_op_317*tmp_blending_op_47*1.0 - tmp_blending_op_118*tmp_blending_op_305;
             const real_t hessian_blending_1_1_1_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_122*tmp_blending_op_311 + tmp_blending_op_124*tmp_blending_op_51 + tmp_blending_op_125*tmp_blending_op_253 + tmp_blending_op_139*tmp_blending_op_311)*1.0 - tmp_blending_op_140*tmp_blending_op_312;
             const real_t hessian_blending_1_1_2_q_2 = tmp_blending_op_113*tmp_blending_op_129*tmp_blending_op_317*tmp_blending_op_47*1.0 - tmp_blending_op_132*tmp_blending_op_315;
             const real_t hessian_blending_1_2_0_q_2 = tmp_blending_op_116*tmp_blending_op_129*tmp_blending_op_319*tmp_blending_op_47*1.0 - tmp_blending_op_309;
             const real_t hessian_blending_1_2_1_q_2 = tmp_blending_op_118*tmp_blending_op_130*tmp_blending_op_319 - tmp_blending_op_137*tmp_blending_op_314 + tmp_blending_op_138;
             const real_t hessian_blending_1_2_2_q_2 = -tmp_blending_op_128*tmp_blending_op_312 + tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_114*tmp_blending_op_51 + tmp_blending_op_127*tmp_blending_op_311 + tmp_blending_op_310)*1.0;
             const real_t hessian_blending_2_0_0_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_123*tmp_blending_op_256 + tmp_blending_op_142*tmp_blending_op_321 + tmp_blending_op_320)*1.0 - tmp_blending_op_143*tmp_blending_op_322;
             const real_t hessian_blending_2_0_1_q_2 = tmp_blending_op_118*tmp_blending_op_323 + tmp_blending_op_316;
             const real_t hessian_blending_2_0_2_q_2 = tmp_blending_op_113*tmp_blending_op_323 - tmp_blending_op_134*tmp_blending_op_324 + tmp_blending_op_135;
             const real_t hessian_blending_2_1_0_q_2 = tmp_blending_op_116*tmp_blending_op_325 - tmp_blending_op_306;
             const real_t hessian_blending_2_1_1_q_2 = tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_124*tmp_blending_op_256 + tmp_blending_op_139*tmp_blending_op_321 + tmp_blending_op_320)*1.0 - tmp_blending_op_140*tmp_blending_op_322;
             const real_t hessian_blending_2_1_2_q_2 = tmp_blending_op_113*tmp_blending_op_325 - tmp_blending_op_132*tmp_blending_op_324 + tmp_blending_op_133;
             const real_t hessian_blending_2_2_0_q_2 = -tmp_blending_op_113*tmp_blending_op_308 + tmp_blending_op_116*tmp_blending_op_129*tmp_blending_op_326*tmp_blending_op_47*1.0;
             const real_t hessian_blending_2_2_1_q_2 = tmp_blending_op_118*tmp_blending_op_129*tmp_blending_op_326*tmp_blending_op_47*1.0 - tmp_blending_op_137*tmp_blending_op_315;
             const real_t hessian_blending_2_2_2_q_2 = -tmp_blending_op_128*tmp_blending_op_322 + tmp_blending_op_129*tmp_blending_op_47*(tmp_blending_op_114*tmp_blending_op_256 + tmp_blending_op_125*tmp_blending_op_264 + tmp_blending_op_127*tmp_blending_op_321 + tmp_blending_op_136*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_3 = -tmp_blending_op_105*tmp_blending_op_328 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_104*tmp_blending_op_329 + tmp_blending_op_230*tmp_blending_op_85 + tmp_blending_op_231*tmp_blending_op_87 - tmp_blending_op_329*tmp_blending_op_83)*1.0;
             const real_t hessian_blending_0_0_1_q_3 = tmp_blending_op_331*tmp_blending_op_47*tmp_blending_op_80*tmp_blending_op_91*1.0 - tmp_blending_op_332*tmp_blending_op_80;
             const real_t hessian_blending_0_0_2_q_3 = tmp_blending_op_331*tmp_blending_op_47*tmp_blending_op_75*tmp_blending_op_91*1.0 - tmp_blending_op_332*tmp_blending_op_75;
             const real_t hessian_blending_0_1_0_q_3 = tmp_blending_op_333*tmp_blending_op_78*tmp_blending_op_92 - tmp_blending_op_334*tmp_blending_op_94 + tmp_blending_op_95;
             const real_t hessian_blending_0_1_1_q_3 = -tmp_blending_op_102*tmp_blending_op_328 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_101*tmp_blending_op_329 + tmp_blending_op_230*tmp_blending_op_86 + tmp_blending_op_335)*1.0;
             const real_t hessian_blending_0_1_2_q_3 = tmp_blending_op_333*tmp_blending_op_47*tmp_blending_op_75*tmp_blending_op_91*1.0 - tmp_blending_op_337;
             const real_t hessian_blending_0_2_0_q_3 = tmp_blending_op_100 - tmp_blending_op_334*tmp_blending_op_99 + tmp_blending_op_338*tmp_blending_op_78*tmp_blending_op_92;
             const real_t hessian_blending_0_2_1_q_3 = tmp_blending_op_338*tmp_blending_op_47*tmp_blending_op_80*tmp_blending_op_91*1.0 - tmp_blending_op_340;
             const real_t hessian_blending_0_2_2_q_3 = -tmp_blending_op_328*tmp_blending_op_90 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_230*tmp_blending_op_76 + tmp_blending_op_329*tmp_blending_op_89 + tmp_blending_op_335)*1.0;
             const real_t hessian_blending_1_0_0_q_3 = -tmp_blending_op_105*tmp_blending_op_343 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_104*tmp_blending_op_342 + tmp_blending_op_341 + tmp_blending_op_51*tmp_blending_op_85)*1.0;
             const real_t hessian_blending_1_0_1_q_3 = tmp_blending_op_344*tmp_blending_op_80 - tmp_blending_op_345*tmp_blending_op_96 + tmp_blending_op_97;
             const real_t hessian_blending_1_0_2_q_3 = tmp_blending_op_344*tmp_blending_op_75 + tmp_blending_op_347;
             const real_t hessian_blending_1_1_0_q_3 = -tmp_blending_op_336*tmp_blending_op_80 + tmp_blending_op_348*tmp_blending_op_47*tmp_blending_op_78*tmp_blending_op_91*1.0;
             const real_t hessian_blending_1_1_1_q_3 = -tmp_blending_op_102*tmp_blending_op_343 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_101*tmp_blending_op_342 + tmp_blending_op_253*tmp_blending_op_87 + tmp_blending_op_342*tmp_blending_op_84 + tmp_blending_op_51*tmp_blending_op_86)*1.0;
             const real_t hessian_blending_1_1_2_q_3 = -tmp_blending_op_346*tmp_blending_op_94 + tmp_blending_op_348*tmp_blending_op_47*tmp_blending_op_75*tmp_blending_op_91*1.0;
             const real_t hessian_blending_1_2_0_q_3 = -tmp_blending_op_340 + tmp_blending_op_350*tmp_blending_op_47*tmp_blending_op_78*tmp_blending_op_91*1.0;
             const real_t hessian_blending_1_2_1_q_3 = tmp_blending_op_100 - tmp_blending_op_345*tmp_blending_op_99 + tmp_blending_op_350*tmp_blending_op_80*tmp_blending_op_92;
             const real_t hessian_blending_1_2_2_q_3 = -tmp_blending_op_343*tmp_blending_op_90 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_341 + tmp_blending_op_342*tmp_blending_op_89 + tmp_blending_op_51*tmp_blending_op_76)*1.0;
             const real_t hessian_blending_2_0_0_q_3 = -tmp_blending_op_105*tmp_blending_op_353 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_104*tmp_blending_op_352 + tmp_blending_op_256*tmp_blending_op_85 + tmp_blending_op_351)*1.0;
             const real_t hessian_blending_2_0_1_q_3 = tmp_blending_op_347 + tmp_blending_op_354*tmp_blending_op_80;
             const real_t hessian_blending_2_0_2_q_3 = tmp_blending_op_354*tmp_blending_op_75 - tmp_blending_op_355*tmp_blending_op_96 + tmp_blending_op_97;
             const real_t hessian_blending_2_1_0_q_3 = -tmp_blending_op_337 + tmp_blending_op_356*tmp_blending_op_78;
             const real_t hessian_blending_2_1_1_q_3 = -tmp_blending_op_102*tmp_blending_op_353 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_101*tmp_blending_op_352 + tmp_blending_op_256*tmp_blending_op_86 + tmp_blending_op_351)*1.0;
             const real_t hessian_blending_2_1_2_q_3 = -tmp_blending_op_355*tmp_blending_op_94 + tmp_blending_op_356*tmp_blending_op_75 + tmp_blending_op_95;
             const real_t hessian_blending_2_2_0_q_3 = -tmp_blending_op_339*tmp_blending_op_75 + tmp_blending_op_357*tmp_blending_op_47*tmp_blending_op_78*tmp_blending_op_91*1.0;
             const real_t hessian_blending_2_2_1_q_3 = -tmp_blending_op_346*tmp_blending_op_99 + tmp_blending_op_357*tmp_blending_op_47*tmp_blending_op_80*tmp_blending_op_91*1.0;
             const real_t hessian_blending_2_2_2_q_3 = -tmp_blending_op_353*tmp_blending_op_90 + tmp_blending_op_47*tmp_blending_op_91*(tmp_blending_op_256*tmp_blending_op_76 + tmp_blending_op_264*tmp_blending_op_87 + tmp_blending_op_352*tmp_blending_op_89 + tmp_blending_op_98*2.0)*1.0;
             const real_t hessian_blending_0_0_0_q_4 = -tmp_blending_op_359*tmp_blending_op_67 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_230*tmp_blending_op_38 + tmp_blending_op_231*tmp_blending_op_40 - tmp_blending_op_36*tmp_blending_op_360 + tmp_blending_op_360*tmp_blending_op_66)*1.0;
             const real_t hessian_blending_0_0_1_q_4 = tmp_blending_op_33*tmp_blending_op_362*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_33*tmp_blending_op_363;
             const real_t hessian_blending_0_0_2_q_4 = tmp_blending_op_3*tmp_blending_op_362*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_3*tmp_blending_op_363;
             const real_t hessian_blending_0_1_0_q_4 = tmp_blending_op_28*tmp_blending_op_364*tmp_blending_op_49 - tmp_blending_op_365*tmp_blending_op_53 + tmp_blending_op_54;
             const real_t hessian_blending_0_1_1_q_4 = -tmp_blending_op_359*tmp_blending_op_64 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_230*tmp_blending_op_39 + tmp_blending_op_360*tmp_blending_op_63 + tmp_blending_op_366)*1.0;
             const real_t hessian_blending_0_1_2_q_4 = tmp_blending_op_3*tmp_blending_op_364*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_368;
             const real_t hessian_blending_0_2_0_q_4 = tmp_blending_op_28*tmp_blending_op_369*tmp_blending_op_49 - tmp_blending_op_365*tmp_blending_op_60 + tmp_blending_op_61;
             const real_t hessian_blending_0_2_1_q_4 = tmp_blending_op_33*tmp_blending_op_369*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_371;
             const real_t hessian_blending_0_2_2_q_4 = -tmp_blending_op_359*tmp_blending_op_45 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_230*tmp_blending_op_4 + tmp_blending_op_360*tmp_blending_op_44 + tmp_blending_op_366)*1.0;
             const real_t hessian_blending_1_0_0_q_4 = -tmp_blending_op_374*tmp_blending_op_67 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_372 + tmp_blending_op_373*tmp_blending_op_66 + tmp_blending_op_38*tmp_blending_op_51)*1.0;
             const real_t hessian_blending_1_0_1_q_4 = tmp_blending_op_33*tmp_blending_op_375 - tmp_blending_op_376*tmp_blending_op_57 + tmp_blending_op_58;
             const real_t hessian_blending_1_0_2_q_4 = tmp_blending_op_3*tmp_blending_op_375 + tmp_blending_op_378;
             const real_t hessian_blending_1_1_0_q_4 = tmp_blending_op_28*tmp_blending_op_379*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_33*tmp_blending_op_367;
             const real_t hessian_blending_1_1_1_q_4 = -tmp_blending_op_374*tmp_blending_op_64 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_253*tmp_blending_op_40 + tmp_blending_op_37*tmp_blending_op_373 + tmp_blending_op_373*tmp_blending_op_63 + tmp_blending_op_39*tmp_blending_op_51)*1.0;
             const real_t hessian_blending_1_1_2_q_4 = tmp_blending_op_3*tmp_blending_op_379*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_377*tmp_blending_op_53;
             const real_t hessian_blending_1_2_0_q_4 = tmp_blending_op_28*tmp_blending_op_381*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_371;
             const real_t hessian_blending_1_2_1_q_4 = tmp_blending_op_33*tmp_blending_op_381*tmp_blending_op_49 - tmp_blending_op_376*tmp_blending_op_60 + tmp_blending_op_61;
             const real_t hessian_blending_1_2_2_q_4 = -tmp_blending_op_374*tmp_blending_op_45 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_372 + tmp_blending_op_373*tmp_blending_op_44 + tmp_blending_op_4*tmp_blending_op_51)*1.0;
             const real_t hessian_blending_2_0_0_q_4 = -tmp_blending_op_384*tmp_blending_op_67 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_256*tmp_blending_op_38 + tmp_blending_op_382 + tmp_blending_op_383*tmp_blending_op_66)*1.0;
             const real_t hessian_blending_2_0_1_q_4 = tmp_blending_op_33*tmp_blending_op_385 + tmp_blending_op_378;
             const real_t hessian_blending_2_0_2_q_4 = tmp_blending_op_3*tmp_blending_op_385 - tmp_blending_op_386*tmp_blending_op_57 + tmp_blending_op_58;
             const real_t hessian_blending_2_1_0_q_4 = tmp_blending_op_28*tmp_blending_op_387 - tmp_blending_op_368;
             const real_t hessian_blending_2_1_1_q_4 = -tmp_blending_op_384*tmp_blending_op_64 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_256*tmp_blending_op_39 + tmp_blending_op_382 + tmp_blending_op_383*tmp_blending_op_63)*1.0;
             const real_t hessian_blending_2_1_2_q_4 = tmp_blending_op_3*tmp_blending_op_387 - tmp_blending_op_386*tmp_blending_op_53 + tmp_blending_op_54;
             const real_t hessian_blending_2_2_0_q_4 = tmp_blending_op_28*tmp_blending_op_388*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_3*tmp_blending_op_370;
             const real_t hessian_blending_2_2_1_q_4 = tmp_blending_op_33*tmp_blending_op_388*tmp_blending_op_46*tmp_blending_op_47*1.0 - tmp_blending_op_377*tmp_blending_op_60;
             const real_t hessian_blending_2_2_2_q_4 = -tmp_blending_op_384*tmp_blending_op_45 + tmp_blending_op_46*tmp_blending_op_47*(tmp_blending_op_256*tmp_blending_op_4 + tmp_blending_op_264*tmp_blending_op_40 + tmp_blending_op_383*tmp_blending_op_44 + tmp_blending_op_59*2.0)*1.0;
             const real_t diffusivity_times_delta_dof_0 = _data_diffusivity_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t diffusivity_times_delta_dof_1 = _data_diffusivity_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t diffusivity_times_delta_dof_2 = _data_diffusivity_times_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t diffusivity_times_delta_dof_3 = _data_diffusivity_times_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t diffusivity_times_delta_dof_4 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t diffusivity_times_delta_dof_5 = _data_diffusivity_times_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t diffusivity_times_delta_dof_6 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t diffusivity_times_delta_dof_7 = _data_diffusivity_times_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t diffusivity_times_delta_dof_8 = _data_diffusivity_times_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t diffusivity_times_delta_dof_9 = _data_diffusivity_times_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wx_dof_0 = _data_wxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wx_dof_1 = _data_wxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wx_dof_2 = _data_wxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wx_dof_3 = _data_wxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wx_dof_4 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wx_dof_5 = _data_wxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wx_dof_6 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t wx_dof_7 = _data_wxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wx_dof_8 = _data_wxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wx_dof_9 = _data_wxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wy_dof_0 = _data_wyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wy_dof_1 = _data_wyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wy_dof_2 = _data_wyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wy_dof_3 = _data_wyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wy_dof_4 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wy_dof_5 = _data_wyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wy_dof_6 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t wy_dof_7 = _data_wyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wy_dof_8 = _data_wyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wy_dof_9 = _data_wyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wz_dof_0 = _data_wzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wz_dof_1 = _data_wzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wz_dof_2 = _data_wzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t wz_dof_3 = _data_wzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t wz_dof_4 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wz_dof_5 = _data_wzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wz_dof_6 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t wz_dof_7 = _data_wzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t wz_dof_8 = _data_wzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t wz_dof_9 = _data_wzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t tmp_kernel_op_30 = -hessian_blending_0_0_0_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_0_1_0_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_0_2_0_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_31 = -hessian_blending_0_0_1_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_0_1_1_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_0_2_1_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_32 = -hessian_blending_0_0_2_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_0_1_2_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_0_2_2_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_33 = jac_blending_inv_0_0_q_0*tmp_kernel_op_30 + jac_blending_inv_0_1_q_0*tmp_kernel_op_31 + jac_blending_inv_0_2_q_0*tmp_kernel_op_32;
             const real_t tmp_kernel_op_35 = jac_blending_inv_1_0_q_0*tmp_kernel_op_30 + jac_blending_inv_1_1_q_0*tmp_kernel_op_31 + jac_blending_inv_1_2_q_0*tmp_kernel_op_32;
             const real_t tmp_kernel_op_37 = jac_blending_inv_2_0_q_0*tmp_kernel_op_30 + jac_blending_inv_2_1_q_0*tmp_kernel_op_31 + jac_blending_inv_2_2_q_0*tmp_kernel_op_32;
             const real_t tmp_kernel_op_38 = -hessian_blending_1_0_0_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_1_1_0_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_1_2_0_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_39 = -hessian_blending_1_0_1_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_1_1_1_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_1_2_1_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_40 = -hessian_blending_1_0_2_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_1_1_2_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_1_2_2_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_41 = jac_blending_inv_0_0_q_0*tmp_kernel_op_38 + jac_blending_inv_0_1_q_0*tmp_kernel_op_39 + jac_blending_inv_0_2_q_0*tmp_kernel_op_40;
             const real_t tmp_kernel_op_42 = jac_blending_inv_1_0_q_0*tmp_kernel_op_38 + jac_blending_inv_1_1_q_0*tmp_kernel_op_39 + jac_blending_inv_1_2_q_0*tmp_kernel_op_40;
             const real_t tmp_kernel_op_43 = jac_blending_inv_2_0_q_0*tmp_kernel_op_38 + jac_blending_inv_2_1_q_0*tmp_kernel_op_39 + jac_blending_inv_2_2_q_0*tmp_kernel_op_40;
             const real_t tmp_kernel_op_44 = -hessian_blending_2_0_0_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_2_1_0_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_2_2_0_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_45 = -hessian_blending_2_0_1_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_2_1_1_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_2_2_1_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_46 = -hessian_blending_2_0_2_q_0*jac_blending_inv_0_0_q_0 - hessian_blending_2_1_2_q_0*jac_blending_inv_1_0_q_0 - hessian_blending_2_2_2_q_0*jac_blending_inv_2_0_q_0;
             const real_t tmp_kernel_op_47 = jac_blending_inv_0_0_q_0*tmp_kernel_op_44 + jac_blending_inv_0_1_q_0*tmp_kernel_op_45 + jac_blending_inv_0_2_q_0*tmp_kernel_op_46;
             const real_t tmp_kernel_op_48 = jac_blending_inv_1_0_q_0*tmp_kernel_op_44 + jac_blending_inv_1_1_q_0*tmp_kernel_op_45 + jac_blending_inv_1_2_q_0*tmp_kernel_op_46;
             const real_t tmp_kernel_op_49 = jac_blending_inv_2_0_q_0*tmp_kernel_op_44 + jac_blending_inv_2_1_q_0*tmp_kernel_op_45 + jac_blending_inv_2_2_q_0*tmp_kernel_op_46;
             const real_t tmp_kernel_op_50 = -hessian_blending_0_0_0_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_0_1_0_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_0_2_0_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_51 = -hessian_blending_0_0_1_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_0_1_1_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_0_2_1_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_52 = -hessian_blending_0_0_2_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_0_1_2_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_0_2_2_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_53 = jac_blending_inv_0_0_q_0*tmp_kernel_op_50 + jac_blending_inv_0_1_q_0*tmp_kernel_op_51 + jac_blending_inv_0_2_q_0*tmp_kernel_op_52;
             const real_t tmp_kernel_op_54 = jac_blending_inv_1_0_q_0*tmp_kernel_op_50 + jac_blending_inv_1_1_q_0*tmp_kernel_op_51 + jac_blending_inv_1_2_q_0*tmp_kernel_op_52;
             const real_t tmp_kernel_op_55 = jac_blending_inv_2_0_q_0*tmp_kernel_op_50 + jac_blending_inv_2_1_q_0*tmp_kernel_op_51 + jac_blending_inv_2_2_q_0*tmp_kernel_op_52;
             const real_t tmp_kernel_op_56 = -hessian_blending_1_0_0_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_1_1_0_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_1_2_0_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_57 = -hessian_blending_1_0_1_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_1_1_1_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_1_2_1_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_58 = -hessian_blending_1_0_2_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_1_1_2_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_1_2_2_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_59 = jac_blending_inv_0_0_q_0*tmp_kernel_op_56 + jac_blending_inv_0_1_q_0*tmp_kernel_op_57 + jac_blending_inv_0_2_q_0*tmp_kernel_op_58;
             const real_t tmp_kernel_op_60 = jac_blending_inv_1_0_q_0*tmp_kernel_op_56 + jac_blending_inv_1_1_q_0*tmp_kernel_op_57 + jac_blending_inv_1_2_q_0*tmp_kernel_op_58;
             const real_t tmp_kernel_op_61 = jac_blending_inv_2_0_q_0*tmp_kernel_op_56 + jac_blending_inv_2_1_q_0*tmp_kernel_op_57 + jac_blending_inv_2_2_q_0*tmp_kernel_op_58;
             const real_t tmp_kernel_op_62 = -hessian_blending_2_0_0_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_2_1_0_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_2_2_0_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_63 = -hessian_blending_2_0_1_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_2_1_1_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_2_2_1_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_64 = -hessian_blending_2_0_2_q_0*jac_blending_inv_0_1_q_0 - hessian_blending_2_1_2_q_0*jac_blending_inv_1_1_q_0 - hessian_blending_2_2_2_q_0*jac_blending_inv_2_1_q_0;
             const real_t tmp_kernel_op_65 = jac_blending_inv_0_0_q_0*tmp_kernel_op_62 + jac_blending_inv_0_1_q_0*tmp_kernel_op_63 + jac_blending_inv_0_2_q_0*tmp_kernel_op_64;
             const real_t tmp_kernel_op_66 = jac_blending_inv_1_0_q_0*tmp_kernel_op_62 + jac_blending_inv_1_1_q_0*tmp_kernel_op_63 + jac_blending_inv_1_2_q_0*tmp_kernel_op_64;
             const real_t tmp_kernel_op_67 = jac_blending_inv_2_0_q_0*tmp_kernel_op_62 + jac_blending_inv_2_1_q_0*tmp_kernel_op_63 + jac_blending_inv_2_2_q_0*tmp_kernel_op_64;
             const real_t tmp_kernel_op_68 = -hessian_blending_0_0_0_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_0_1_0_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_0_2_0_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_69 = -hessian_blending_0_0_1_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_0_1_1_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_0_2_1_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_70 = -hessian_blending_0_0_2_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_0_1_2_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_0_2_2_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_71 = jac_blending_inv_0_0_q_0*tmp_kernel_op_68 + jac_blending_inv_0_1_q_0*tmp_kernel_op_69 + jac_blending_inv_0_2_q_0*tmp_kernel_op_70;
             const real_t tmp_kernel_op_72 = jac_blending_inv_1_0_q_0*tmp_kernel_op_68 + jac_blending_inv_1_1_q_0*tmp_kernel_op_69 + jac_blending_inv_1_2_q_0*tmp_kernel_op_70;
             const real_t tmp_kernel_op_73 = jac_blending_inv_2_0_q_0*tmp_kernel_op_68 + jac_blending_inv_2_1_q_0*tmp_kernel_op_69 + jac_blending_inv_2_2_q_0*tmp_kernel_op_70;
             const real_t tmp_kernel_op_74 = -hessian_blending_1_0_0_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_1_1_0_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_1_2_0_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_75 = -hessian_blending_1_0_1_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_1_1_1_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_1_2_1_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_76 = -hessian_blending_1_0_2_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_1_1_2_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_1_2_2_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_77 = jac_blending_inv_0_0_q_0*tmp_kernel_op_74 + jac_blending_inv_0_1_q_0*tmp_kernel_op_75 + jac_blending_inv_0_2_q_0*tmp_kernel_op_76;
             const real_t tmp_kernel_op_78 = jac_blending_inv_1_0_q_0*tmp_kernel_op_74 + jac_blending_inv_1_1_q_0*tmp_kernel_op_75 + jac_blending_inv_1_2_q_0*tmp_kernel_op_76;
             const real_t tmp_kernel_op_79 = jac_blending_inv_2_0_q_0*tmp_kernel_op_74 + jac_blending_inv_2_1_q_0*tmp_kernel_op_75 + jac_blending_inv_2_2_q_0*tmp_kernel_op_76;
             const real_t tmp_kernel_op_80 = -hessian_blending_2_0_0_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_2_1_0_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_2_2_0_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_81 = -hessian_blending_2_0_1_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_2_1_1_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_2_2_1_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_82 = -hessian_blending_2_0_2_q_0*jac_blending_inv_0_2_q_0 - hessian_blending_2_1_2_q_0*jac_blending_inv_1_2_q_0 - hessian_blending_2_2_2_q_0*jac_blending_inv_2_2_q_0;
             const real_t tmp_kernel_op_83 = jac_blending_inv_0_0_q_0*tmp_kernel_op_80 + jac_blending_inv_0_1_q_0*tmp_kernel_op_81 + jac_blending_inv_0_2_q_0*tmp_kernel_op_82;
             const real_t tmp_kernel_op_84 = jac_blending_inv_1_0_q_0*tmp_kernel_op_80 + jac_blending_inv_1_1_q_0*tmp_kernel_op_81 + jac_blending_inv_1_2_q_0*tmp_kernel_op_82;
             const real_t tmp_kernel_op_85 = jac_blending_inv_2_0_q_0*tmp_kernel_op_80 + jac_blending_inv_2_1_q_0*tmp_kernel_op_81 + jac_blending_inv_2_2_q_0*tmp_kernel_op_82;
             const real_t tmp_kernel_op_86 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1481 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1487 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1493) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1500 + tmp_kernel_op_35*tmp_moved_constant_1501 + tmp_kernel_op_37*tmp_moved_constant_1502) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1481 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1487 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1493) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1500 + tmp_kernel_op_42*tmp_moved_constant_1501 + tmp_kernel_op_43*tmp_moved_constant_1502) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1481 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1487 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1493) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1500 + tmp_kernel_op_48*tmp_moved_constant_1501 + tmp_kernel_op_49*tmp_moved_constant_1502) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1494 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1495 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1496) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1500 + tmp_kernel_op_54*tmp_moved_constant_1501 + tmp_kernel_op_55*tmp_moved_constant_1502) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1494 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1495 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1496) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1500 + tmp_kernel_op_60*tmp_moved_constant_1501 + tmp_kernel_op_61*tmp_moved_constant_1502) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1494 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1495 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1496) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1500 + tmp_kernel_op_66*tmp_moved_constant_1501 + tmp_kernel_op_67*tmp_moved_constant_1502) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1497 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1498 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1499) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1500 + tmp_kernel_op_72*tmp_moved_constant_1501 + tmp_kernel_op_73*tmp_moved_constant_1502) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1497 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1498 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1499) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1500 + tmp_kernel_op_78*tmp_moved_constant_1501 + tmp_kernel_op_79*tmp_moved_constant_1502) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1497 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1498 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1499) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1500 + tmp_kernel_op_84*tmp_moved_constant_1501 + tmp_kernel_op_85*tmp_moved_constant_1502);
             const real_t tmp_kernel_op_104 = tmp_kernel_op_100*wx_dof_8 + tmp_kernel_op_102*wx_dof_9 + tmp_kernel_op_103*wx_dof_0 + tmp_kernel_op_87*wx_dof_4 + tmp_kernel_op_88*wx_dof_5 + tmp_kernel_op_89*wx_dof_6 + tmp_kernel_op_92*wx_dof_1 + tmp_kernel_op_95*wx_dof_2 + tmp_kernel_op_98*wx_dof_3 + tmp_kernel_op_99*wx_dof_7;
             const real_t tmp_kernel_op_105 = tmp_kernel_op_100*wy_dof_8 + tmp_kernel_op_102*wy_dof_9 + tmp_kernel_op_103*wy_dof_0 + tmp_kernel_op_87*wy_dof_4 + tmp_kernel_op_88*wy_dof_5 + tmp_kernel_op_89*wy_dof_6 + tmp_kernel_op_92*wy_dof_1 + tmp_kernel_op_95*wy_dof_2 + tmp_kernel_op_98*wy_dof_3 + tmp_kernel_op_99*wy_dof_7;
             const real_t tmp_kernel_op_106 = tmp_kernel_op_100*wz_dof_8 + tmp_kernel_op_102*wz_dof_9 + tmp_kernel_op_103*wz_dof_0 + tmp_kernel_op_87*wz_dof_4 + tmp_kernel_op_88*wz_dof_5 + tmp_kernel_op_89*wz_dof_6 + tmp_kernel_op_92*wz_dof_1 + tmp_kernel_op_95*wz_dof_2 + tmp_kernel_op_98*wz_dof_3 + tmp_kernel_op_99*wz_dof_7;
             const real_t tmp_kernel_op_107 = abs_det_jac_affine_GREEN_DOWN*abs_det_jac_blending_q_0*(diffusivity_times_delta_dof_0*tmp_kernel_op_103 + diffusivity_times_delta_dof_1*tmp_kernel_op_92 + diffusivity_times_delta_dof_2*tmp_kernel_op_95 + diffusivity_times_delta_dof_3*tmp_kernel_op_98 + diffusivity_times_delta_dof_4*tmp_kernel_op_87 + diffusivity_times_delta_dof_5*tmp_kernel_op_88 + diffusivity_times_delta_dof_6*tmp_kernel_op_89 + diffusivity_times_delta_dof_7*tmp_kernel_op_99 + diffusivity_times_delta_dof_8*tmp_kernel_op_100 + diffusivity_times_delta_dof_9*tmp_kernel_op_102)*-0.1333333333333333;
             const real_t tmp_kernel_op_108 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1500 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1501 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1502) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1500 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1501 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1502) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1500 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1501 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1502));
             const real_t tmp_kernel_op_115 = -hessian_blending_0_0_0_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_0_1_0_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_0_2_0_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_116 = -hessian_blending_0_0_1_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_0_1_1_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_0_2_1_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_117 = -hessian_blending_0_0_2_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_0_1_2_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_0_2_2_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_118 = jac_blending_inv_0_0_q_1*tmp_kernel_op_115 + jac_blending_inv_0_1_q_1*tmp_kernel_op_116 + jac_blending_inv_0_2_q_1*tmp_kernel_op_117;
             const real_t tmp_kernel_op_120 = jac_blending_inv_1_0_q_1*tmp_kernel_op_115 + jac_blending_inv_1_1_q_1*tmp_kernel_op_116 + jac_blending_inv_1_2_q_1*tmp_kernel_op_117;
             const real_t tmp_kernel_op_122 = jac_blending_inv_2_0_q_1*tmp_kernel_op_115 + jac_blending_inv_2_1_q_1*tmp_kernel_op_116 + jac_blending_inv_2_2_q_1*tmp_kernel_op_117;
             const real_t tmp_kernel_op_123 = -hessian_blending_1_0_0_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_1_1_0_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_1_2_0_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_124 = -hessian_blending_1_0_1_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_1_1_1_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_1_2_1_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_125 = -hessian_blending_1_0_2_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_1_1_2_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_1_2_2_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_126 = jac_blending_inv_0_0_q_1*tmp_kernel_op_123 + jac_blending_inv_0_1_q_1*tmp_kernel_op_124 + jac_blending_inv_0_2_q_1*tmp_kernel_op_125;
             const real_t tmp_kernel_op_127 = jac_blending_inv_1_0_q_1*tmp_kernel_op_123 + jac_blending_inv_1_1_q_1*tmp_kernel_op_124 + jac_blending_inv_1_2_q_1*tmp_kernel_op_125;
             const real_t tmp_kernel_op_128 = jac_blending_inv_2_0_q_1*tmp_kernel_op_123 + jac_blending_inv_2_1_q_1*tmp_kernel_op_124 + jac_blending_inv_2_2_q_1*tmp_kernel_op_125;
             const real_t tmp_kernel_op_129 = -hessian_blending_2_0_0_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_2_1_0_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_2_2_0_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_130 = -hessian_blending_2_0_1_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_2_1_1_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_2_2_1_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_131 = -hessian_blending_2_0_2_q_1*jac_blending_inv_0_0_q_1 - hessian_blending_2_1_2_q_1*jac_blending_inv_1_0_q_1 - hessian_blending_2_2_2_q_1*jac_blending_inv_2_0_q_1;
             const real_t tmp_kernel_op_132 = jac_blending_inv_0_0_q_1*tmp_kernel_op_129 + jac_blending_inv_0_1_q_1*tmp_kernel_op_130 + jac_blending_inv_0_2_q_1*tmp_kernel_op_131;
             const real_t tmp_kernel_op_133 = jac_blending_inv_1_0_q_1*tmp_kernel_op_129 + jac_blending_inv_1_1_q_1*tmp_kernel_op_130 + jac_blending_inv_1_2_q_1*tmp_kernel_op_131;
             const real_t tmp_kernel_op_134 = jac_blending_inv_2_0_q_1*tmp_kernel_op_129 + jac_blending_inv_2_1_q_1*tmp_kernel_op_130 + jac_blending_inv_2_2_q_1*tmp_kernel_op_131;
             const real_t tmp_kernel_op_135 = -hessian_blending_0_0_0_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_0_1_0_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_0_2_0_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_136 = -hessian_blending_0_0_1_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_0_1_1_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_0_2_1_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_137 = -hessian_blending_0_0_2_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_0_1_2_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_0_2_2_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_138 = jac_blending_inv_0_0_q_1*tmp_kernel_op_135 + jac_blending_inv_0_1_q_1*tmp_kernel_op_136 + jac_blending_inv_0_2_q_1*tmp_kernel_op_137;
             const real_t tmp_kernel_op_139 = jac_blending_inv_1_0_q_1*tmp_kernel_op_135 + jac_blending_inv_1_1_q_1*tmp_kernel_op_136 + jac_blending_inv_1_2_q_1*tmp_kernel_op_137;
             const real_t tmp_kernel_op_140 = jac_blending_inv_2_0_q_1*tmp_kernel_op_135 + jac_blending_inv_2_1_q_1*tmp_kernel_op_136 + jac_blending_inv_2_2_q_1*tmp_kernel_op_137;
             const real_t tmp_kernel_op_141 = -hessian_blending_1_0_0_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_1_1_0_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_1_2_0_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_142 = -hessian_blending_1_0_1_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_1_1_1_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_1_2_1_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_143 = -hessian_blending_1_0_2_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_1_1_2_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_1_2_2_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_144 = jac_blending_inv_0_0_q_1*tmp_kernel_op_141 + jac_blending_inv_0_1_q_1*tmp_kernel_op_142 + jac_blending_inv_0_2_q_1*tmp_kernel_op_143;
             const real_t tmp_kernel_op_145 = jac_blending_inv_1_0_q_1*tmp_kernel_op_141 + jac_blending_inv_1_1_q_1*tmp_kernel_op_142 + jac_blending_inv_1_2_q_1*tmp_kernel_op_143;
             const real_t tmp_kernel_op_146 = jac_blending_inv_2_0_q_1*tmp_kernel_op_141 + jac_blending_inv_2_1_q_1*tmp_kernel_op_142 + jac_blending_inv_2_2_q_1*tmp_kernel_op_143;
             const real_t tmp_kernel_op_147 = -hessian_blending_2_0_0_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_2_1_0_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_2_2_0_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_148 = -hessian_blending_2_0_1_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_2_1_1_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_2_2_1_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_149 = -hessian_blending_2_0_2_q_1*jac_blending_inv_0_1_q_1 - hessian_blending_2_1_2_q_1*jac_blending_inv_1_1_q_1 - hessian_blending_2_2_2_q_1*jac_blending_inv_2_1_q_1;
             const real_t tmp_kernel_op_150 = jac_blending_inv_0_0_q_1*tmp_kernel_op_147 + jac_blending_inv_0_1_q_1*tmp_kernel_op_148 + jac_blending_inv_0_2_q_1*tmp_kernel_op_149;
             const real_t tmp_kernel_op_151 = jac_blending_inv_1_0_q_1*tmp_kernel_op_147 + jac_blending_inv_1_1_q_1*tmp_kernel_op_148 + jac_blending_inv_1_2_q_1*tmp_kernel_op_149;
             const real_t tmp_kernel_op_152 = jac_blending_inv_2_0_q_1*tmp_kernel_op_147 + jac_blending_inv_2_1_q_1*tmp_kernel_op_148 + jac_blending_inv_2_2_q_1*tmp_kernel_op_149;
             const real_t tmp_kernel_op_153 = -hessian_blending_0_0_0_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_0_1_0_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_0_2_0_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_154 = -hessian_blending_0_0_1_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_0_1_1_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_0_2_1_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_155 = -hessian_blending_0_0_2_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_0_1_2_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_0_2_2_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_156 = jac_blending_inv_0_0_q_1*tmp_kernel_op_153 + jac_blending_inv_0_1_q_1*tmp_kernel_op_154 + jac_blending_inv_0_2_q_1*tmp_kernel_op_155;
             const real_t tmp_kernel_op_157 = jac_blending_inv_1_0_q_1*tmp_kernel_op_153 + jac_blending_inv_1_1_q_1*tmp_kernel_op_154 + jac_blending_inv_1_2_q_1*tmp_kernel_op_155;
             const real_t tmp_kernel_op_158 = jac_blending_inv_2_0_q_1*tmp_kernel_op_153 + jac_blending_inv_2_1_q_1*tmp_kernel_op_154 + jac_blending_inv_2_2_q_1*tmp_kernel_op_155;
             const real_t tmp_kernel_op_159 = -hessian_blending_1_0_0_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_1_1_0_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_1_2_0_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_160 = -hessian_blending_1_0_1_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_1_1_1_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_1_2_1_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_161 = -hessian_blending_1_0_2_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_1_1_2_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_1_2_2_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_162 = jac_blending_inv_0_0_q_1*tmp_kernel_op_159 + jac_blending_inv_0_1_q_1*tmp_kernel_op_160 + jac_blending_inv_0_2_q_1*tmp_kernel_op_161;
             const real_t tmp_kernel_op_163 = jac_blending_inv_1_0_q_1*tmp_kernel_op_159 + jac_blending_inv_1_1_q_1*tmp_kernel_op_160 + jac_blending_inv_1_2_q_1*tmp_kernel_op_161;
             const real_t tmp_kernel_op_164 = jac_blending_inv_2_0_q_1*tmp_kernel_op_159 + jac_blending_inv_2_1_q_1*tmp_kernel_op_160 + jac_blending_inv_2_2_q_1*tmp_kernel_op_161;
             const real_t tmp_kernel_op_165 = -hessian_blending_2_0_0_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_2_1_0_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_2_2_0_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_166 = -hessian_blending_2_0_1_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_2_1_1_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_2_2_1_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_167 = -hessian_blending_2_0_2_q_1*jac_blending_inv_0_2_q_1 - hessian_blending_2_1_2_q_1*jac_blending_inv_1_2_q_1 - hessian_blending_2_2_2_q_1*jac_blending_inv_2_2_q_1;
             const real_t tmp_kernel_op_168 = jac_blending_inv_0_0_q_1*tmp_kernel_op_165 + jac_blending_inv_0_1_q_1*tmp_kernel_op_166 + jac_blending_inv_0_2_q_1*tmp_kernel_op_167;
             const real_t tmp_kernel_op_169 = jac_blending_inv_1_0_q_1*tmp_kernel_op_165 + jac_blending_inv_1_1_q_1*tmp_kernel_op_166 + jac_blending_inv_1_2_q_1*tmp_kernel_op_167;
             const real_t tmp_kernel_op_170 = jac_blending_inv_2_0_q_1*tmp_kernel_op_165 + jac_blending_inv_2_1_q_1*tmp_kernel_op_166 + jac_blending_inv_2_2_q_1*tmp_kernel_op_167;
             const real_t tmp_kernel_op_171 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1481 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1487 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1493) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1503 + tmp_kernel_op_120*tmp_moved_constant_1504 + tmp_kernel_op_122*tmp_moved_constant_1505) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1481 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1487 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1493) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1503 + tmp_kernel_op_127*tmp_moved_constant_1504 + tmp_kernel_op_128*tmp_moved_constant_1505) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1481 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1487 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1493) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1503 + tmp_kernel_op_133*tmp_moved_constant_1504 + tmp_kernel_op_134*tmp_moved_constant_1505) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1494 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1495 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1496) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1503 + tmp_kernel_op_139*tmp_moved_constant_1504 + tmp_kernel_op_140*tmp_moved_constant_1505) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1494 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1495 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1496) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1503 + tmp_kernel_op_145*tmp_moved_constant_1504 + tmp_kernel_op_146*tmp_moved_constant_1505) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1494 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1495 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1496) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1503 + tmp_kernel_op_151*tmp_moved_constant_1504 + tmp_kernel_op_152*tmp_moved_constant_1505) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1497 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1498 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1499) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1503 + tmp_kernel_op_157*tmp_moved_constant_1504 + tmp_kernel_op_158*tmp_moved_constant_1505) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1497 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1498 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1499) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1503 + tmp_kernel_op_163*tmp_moved_constant_1504 + tmp_kernel_op_164*tmp_moved_constant_1505) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1497 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1498 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1499) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1503 + tmp_kernel_op_169*tmp_moved_constant_1504 + tmp_kernel_op_170*tmp_moved_constant_1505);
             const real_t tmp_kernel_op_189 = tmp_kernel_op_172*wx_dof_4 + tmp_kernel_op_173*wx_dof_5 + tmp_kernel_op_174*wx_dof_6 + tmp_kernel_op_177*wx_dof_1 + tmp_kernel_op_180*wx_dof_2 + tmp_kernel_op_183*wx_dof_3 + tmp_kernel_op_184*wx_dof_7 + tmp_kernel_op_185*wx_dof_8 + tmp_kernel_op_187*wx_dof_9 + tmp_kernel_op_188*wx_dof_0;
             const real_t tmp_kernel_op_190 = tmp_kernel_op_172*wy_dof_4 + tmp_kernel_op_173*wy_dof_5 + tmp_kernel_op_174*wy_dof_6 + tmp_kernel_op_177*wy_dof_1 + tmp_kernel_op_180*wy_dof_2 + tmp_kernel_op_183*wy_dof_3 + tmp_kernel_op_184*wy_dof_7 + tmp_kernel_op_185*wy_dof_8 + tmp_kernel_op_187*wy_dof_9 + tmp_kernel_op_188*wy_dof_0;
             const real_t tmp_kernel_op_191 = tmp_kernel_op_172*wz_dof_4 + tmp_kernel_op_173*wz_dof_5 + tmp_kernel_op_174*wz_dof_6 + tmp_kernel_op_177*wz_dof_1 + tmp_kernel_op_180*wz_dof_2 + tmp_kernel_op_183*wz_dof_3 + tmp_kernel_op_184*wz_dof_7 + tmp_kernel_op_185*wz_dof_8 + tmp_kernel_op_187*wz_dof_9 + tmp_kernel_op_188*wz_dof_0;
             const real_t tmp_kernel_op_192 = abs_det_jac_affine_GREEN_DOWN*abs_det_jac_blending_q_1*(diffusivity_times_delta_dof_0*tmp_kernel_op_188 + diffusivity_times_delta_dof_1*tmp_kernel_op_177 + diffusivity_times_delta_dof_2*tmp_kernel_op_180 + diffusivity_times_delta_dof_3*tmp_kernel_op_183 + diffusivity_times_delta_dof_4*tmp_kernel_op_172 + diffusivity_times_delta_dof_5*tmp_kernel_op_173 + diffusivity_times_delta_dof_6*tmp_kernel_op_174 + diffusivity_times_delta_dof_7*tmp_kernel_op_184 + diffusivity_times_delta_dof_8*tmp_kernel_op_185 + diffusivity_times_delta_dof_9*tmp_kernel_op_187)*0.074999999999999983;
             const real_t tmp_kernel_op_193 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1503 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1504 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1505) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1503 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1504 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1505) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1503 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1504 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1505));
             const real_t tmp_kernel_op_200 = -hessian_blending_0_0_0_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_0_1_0_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_0_2_0_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_201 = -hessian_blending_0_0_1_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_0_1_1_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_0_2_1_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_202 = -hessian_blending_0_0_2_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_0_1_2_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_0_2_2_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_203 = jac_blending_inv_0_0_q_2*tmp_kernel_op_200 + jac_blending_inv_0_1_q_2*tmp_kernel_op_201 + jac_blending_inv_0_2_q_2*tmp_kernel_op_202;
             const real_t tmp_kernel_op_205 = jac_blending_inv_1_0_q_2*tmp_kernel_op_200 + jac_blending_inv_1_1_q_2*tmp_kernel_op_201 + jac_blending_inv_1_2_q_2*tmp_kernel_op_202;
             const real_t tmp_kernel_op_207 = jac_blending_inv_2_0_q_2*tmp_kernel_op_200 + jac_blending_inv_2_1_q_2*tmp_kernel_op_201 + jac_blending_inv_2_2_q_2*tmp_kernel_op_202;
             const real_t tmp_kernel_op_208 = -hessian_blending_1_0_0_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_1_1_0_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_1_2_0_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_209 = -hessian_blending_1_0_1_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_1_1_1_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_1_2_1_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_210 = -hessian_blending_1_0_2_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_1_1_2_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_1_2_2_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_211 = jac_blending_inv_0_0_q_2*tmp_kernel_op_208 + jac_blending_inv_0_1_q_2*tmp_kernel_op_209 + jac_blending_inv_0_2_q_2*tmp_kernel_op_210;
             const real_t tmp_kernel_op_212 = jac_blending_inv_1_0_q_2*tmp_kernel_op_208 + jac_blending_inv_1_1_q_2*tmp_kernel_op_209 + jac_blending_inv_1_2_q_2*tmp_kernel_op_210;
             const real_t tmp_kernel_op_213 = jac_blending_inv_2_0_q_2*tmp_kernel_op_208 + jac_blending_inv_2_1_q_2*tmp_kernel_op_209 + jac_blending_inv_2_2_q_2*tmp_kernel_op_210;
             const real_t tmp_kernel_op_214 = -hessian_blending_2_0_0_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_2_1_0_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_2_2_0_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_215 = -hessian_blending_2_0_1_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_2_1_1_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_2_2_1_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_216 = -hessian_blending_2_0_2_q_2*jac_blending_inv_0_0_q_2 - hessian_blending_2_1_2_q_2*jac_blending_inv_1_0_q_2 - hessian_blending_2_2_2_q_2*jac_blending_inv_2_0_q_2;
             const real_t tmp_kernel_op_217 = jac_blending_inv_0_0_q_2*tmp_kernel_op_214 + jac_blending_inv_0_1_q_2*tmp_kernel_op_215 + jac_blending_inv_0_2_q_2*tmp_kernel_op_216;
             const real_t tmp_kernel_op_218 = jac_blending_inv_1_0_q_2*tmp_kernel_op_214 + jac_blending_inv_1_1_q_2*tmp_kernel_op_215 + jac_blending_inv_1_2_q_2*tmp_kernel_op_216;
             const real_t tmp_kernel_op_219 = jac_blending_inv_2_0_q_2*tmp_kernel_op_214 + jac_blending_inv_2_1_q_2*tmp_kernel_op_215 + jac_blending_inv_2_2_q_2*tmp_kernel_op_216;
             const real_t tmp_kernel_op_220 = -hessian_blending_0_0_0_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_0_1_0_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_0_2_0_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_221 = -hessian_blending_0_0_1_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_0_1_1_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_0_2_1_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_222 = -hessian_blending_0_0_2_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_0_1_2_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_0_2_2_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_223 = jac_blending_inv_0_0_q_2*tmp_kernel_op_220 + jac_blending_inv_0_1_q_2*tmp_kernel_op_221 + jac_blending_inv_0_2_q_2*tmp_kernel_op_222;
             const real_t tmp_kernel_op_224 = jac_blending_inv_1_0_q_2*tmp_kernel_op_220 + jac_blending_inv_1_1_q_2*tmp_kernel_op_221 + jac_blending_inv_1_2_q_2*tmp_kernel_op_222;
             const real_t tmp_kernel_op_225 = jac_blending_inv_2_0_q_2*tmp_kernel_op_220 + jac_blending_inv_2_1_q_2*tmp_kernel_op_221 + jac_blending_inv_2_2_q_2*tmp_kernel_op_222;
             const real_t tmp_kernel_op_226 = -hessian_blending_1_0_0_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_1_1_0_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_1_2_0_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_227 = -hessian_blending_1_0_1_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_1_1_1_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_1_2_1_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_228 = -hessian_blending_1_0_2_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_1_1_2_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_1_2_2_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_229 = jac_blending_inv_0_0_q_2*tmp_kernel_op_226 + jac_blending_inv_0_1_q_2*tmp_kernel_op_227 + jac_blending_inv_0_2_q_2*tmp_kernel_op_228;
             const real_t tmp_kernel_op_230 = jac_blending_inv_1_0_q_2*tmp_kernel_op_226 + jac_blending_inv_1_1_q_2*tmp_kernel_op_227 + jac_blending_inv_1_2_q_2*tmp_kernel_op_228;
             const real_t tmp_kernel_op_231 = jac_blending_inv_2_0_q_2*tmp_kernel_op_226 + jac_blending_inv_2_1_q_2*tmp_kernel_op_227 + jac_blending_inv_2_2_q_2*tmp_kernel_op_228;
             const real_t tmp_kernel_op_232 = -hessian_blending_2_0_0_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_2_1_0_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_2_2_0_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_233 = -hessian_blending_2_0_1_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_2_1_1_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_2_2_1_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_234 = -hessian_blending_2_0_2_q_2*jac_blending_inv_0_1_q_2 - hessian_blending_2_1_2_q_2*jac_blending_inv_1_1_q_2 - hessian_blending_2_2_2_q_2*jac_blending_inv_2_1_q_2;
             const real_t tmp_kernel_op_235 = jac_blending_inv_0_0_q_2*tmp_kernel_op_232 + jac_blending_inv_0_1_q_2*tmp_kernel_op_233 + jac_blending_inv_0_2_q_2*tmp_kernel_op_234;
             const real_t tmp_kernel_op_236 = jac_blending_inv_1_0_q_2*tmp_kernel_op_232 + jac_blending_inv_1_1_q_2*tmp_kernel_op_233 + jac_blending_inv_1_2_q_2*tmp_kernel_op_234;
             const real_t tmp_kernel_op_237 = jac_blending_inv_2_0_q_2*tmp_kernel_op_232 + jac_blending_inv_2_1_q_2*tmp_kernel_op_233 + jac_blending_inv_2_2_q_2*tmp_kernel_op_234;
             const real_t tmp_kernel_op_238 = -hessian_blending_0_0_0_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_0_1_0_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_0_2_0_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_239 = -hessian_blending_0_0_1_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_0_1_1_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_0_2_1_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_240 = -hessian_blending_0_0_2_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_0_1_2_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_0_2_2_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_241 = jac_blending_inv_0_0_q_2*tmp_kernel_op_238 + jac_blending_inv_0_1_q_2*tmp_kernel_op_239 + jac_blending_inv_0_2_q_2*tmp_kernel_op_240;
             const real_t tmp_kernel_op_242 = jac_blending_inv_1_0_q_2*tmp_kernel_op_238 + jac_blending_inv_1_1_q_2*tmp_kernel_op_239 + jac_blending_inv_1_2_q_2*tmp_kernel_op_240;
             const real_t tmp_kernel_op_243 = jac_blending_inv_2_0_q_2*tmp_kernel_op_238 + jac_blending_inv_2_1_q_2*tmp_kernel_op_239 + jac_blending_inv_2_2_q_2*tmp_kernel_op_240;
             const real_t tmp_kernel_op_244 = -hessian_blending_1_0_0_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_1_1_0_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_1_2_0_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_245 = -hessian_blending_1_0_1_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_1_1_1_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_1_2_1_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_246 = -hessian_blending_1_0_2_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_1_1_2_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_1_2_2_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_247 = jac_blending_inv_0_0_q_2*tmp_kernel_op_244 + jac_blending_inv_0_1_q_2*tmp_kernel_op_245 + jac_blending_inv_0_2_q_2*tmp_kernel_op_246;
             const real_t tmp_kernel_op_248 = jac_blending_inv_1_0_q_2*tmp_kernel_op_244 + jac_blending_inv_1_1_q_2*tmp_kernel_op_245 + jac_blending_inv_1_2_q_2*tmp_kernel_op_246;
             const real_t tmp_kernel_op_249 = jac_blending_inv_2_0_q_2*tmp_kernel_op_244 + jac_blending_inv_2_1_q_2*tmp_kernel_op_245 + jac_blending_inv_2_2_q_2*tmp_kernel_op_246;
             const real_t tmp_kernel_op_250 = -hessian_blending_2_0_0_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_2_1_0_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_2_2_0_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_251 = -hessian_blending_2_0_1_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_2_1_1_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_2_2_1_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_252 = -hessian_blending_2_0_2_q_2*jac_blending_inv_0_2_q_2 - hessian_blending_2_1_2_q_2*jac_blending_inv_1_2_q_2 - hessian_blending_2_2_2_q_2*jac_blending_inv_2_2_q_2;
             const real_t tmp_kernel_op_253 = jac_blending_inv_0_0_q_2*tmp_kernel_op_250 + jac_blending_inv_0_1_q_2*tmp_kernel_op_251 + jac_blending_inv_0_2_q_2*tmp_kernel_op_252;
             const real_t tmp_kernel_op_254 = jac_blending_inv_1_0_q_2*tmp_kernel_op_250 + jac_blending_inv_1_1_q_2*tmp_kernel_op_251 + jac_blending_inv_1_2_q_2*tmp_kernel_op_252;
             const real_t tmp_kernel_op_255 = jac_blending_inv_2_0_q_2*tmp_kernel_op_250 + jac_blending_inv_2_1_q_2*tmp_kernel_op_251 + jac_blending_inv_2_2_q_2*tmp_kernel_op_252;
             const real_t tmp_kernel_op_256 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1481 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1487 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1493) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1506 + tmp_kernel_op_205*tmp_moved_constant_1507 + tmp_kernel_op_207*tmp_moved_constant_1508) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1481 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1487 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1493) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1506 + tmp_kernel_op_212*tmp_moved_constant_1507 + tmp_kernel_op_213*tmp_moved_constant_1508) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1481 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1487 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1493) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1506 + tmp_kernel_op_218*tmp_moved_constant_1507 + tmp_kernel_op_219*tmp_moved_constant_1508) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1494 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1495 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1496) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1506 + tmp_kernel_op_224*tmp_moved_constant_1507 + tmp_kernel_op_225*tmp_moved_constant_1508) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1494 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1495 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1496) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1506 + tmp_kernel_op_230*tmp_moved_constant_1507 + tmp_kernel_op_231*tmp_moved_constant_1508) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1494 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1495 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1496) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1506 + tmp_kernel_op_236*tmp_moved_constant_1507 + tmp_kernel_op_237*tmp_moved_constant_1508) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1497 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1498 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1499) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1506 + tmp_kernel_op_242*tmp_moved_constant_1507 + tmp_kernel_op_243*tmp_moved_constant_1508) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1497 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1498 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1499) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1506 + tmp_kernel_op_248*tmp_moved_constant_1507 + tmp_kernel_op_249*tmp_moved_constant_1508) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1497 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1498 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1499) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1506 + tmp_kernel_op_254*tmp_moved_constant_1507 + tmp_kernel_op_255*tmp_moved_constant_1508);
             const real_t tmp_kernel_op_274 = tmp_kernel_op_257*wx_dof_4 + tmp_kernel_op_258*wx_dof_5 + tmp_kernel_op_259*wx_dof_6 + tmp_kernel_op_262*wx_dof_1 + tmp_kernel_op_265*wx_dof_2 + tmp_kernel_op_268*wx_dof_3 + tmp_kernel_op_269*wx_dof_7 + tmp_kernel_op_270*wx_dof_8 + tmp_kernel_op_272*wx_dof_9 + tmp_kernel_op_273*wx_dof_0;
             const real_t tmp_kernel_op_275 = tmp_kernel_op_257*wy_dof_4 + tmp_kernel_op_258*wy_dof_5 + tmp_kernel_op_259*wy_dof_6 + tmp_kernel_op_262*wy_dof_1 + tmp_kernel_op_265*wy_dof_2 + tmp_kernel_op_268*wy_dof_3 + tmp_kernel_op_269*wy_dof_7 + tmp_kernel_op_270*wy_dof_8 + tmp_kernel_op_272*wy_dof_9 + tmp_kernel_op_273*wy_dof_0;
             const real_t tmp_kernel_op_276 = tmp_kernel_op_257*wz_dof_4 + tmp_kernel_op_258*wz_dof_5 + tmp_kernel_op_259*wz_dof_6 + tmp_kernel_op_262*wz_dof_1 + tmp_kernel_op_265*wz_dof_2 + tmp_kernel_op_268*wz_dof_3 + tmp_kernel_op_269*wz_dof_7 + tmp_kernel_op_270*wz_dof_8 + tmp_kernel_op_272*wz_dof_9 + tmp_kernel_op_273*wz_dof_0;
             const real_t tmp_kernel_op_277 = abs_det_jac_affine_GREEN_DOWN*abs_det_jac_blending_q_2*(diffusivity_times_delta_dof_0*tmp_kernel_op_273 + diffusivity_times_delta_dof_1*tmp_kernel_op_262 + diffusivity_times_delta_dof_2*tmp_kernel_op_265 + diffusivity_times_delta_dof_3*tmp_kernel_op_268 + diffusivity_times_delta_dof_4*tmp_kernel_op_257 + diffusivity_times_delta_dof_5*tmp_kernel_op_258 + diffusivity_times_delta_dof_6*tmp_kernel_op_259 + diffusivity_times_delta_dof_7*tmp_kernel_op_269 + diffusivity_times_delta_dof_8*tmp_kernel_op_270 + diffusivity_times_delta_dof_9*tmp_kernel_op_272)*0.074999999999999983;
             const real_t tmp_kernel_op_278 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1506 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1507 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1508) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1506 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1507 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1508) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1506 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1507 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1508));
             const real_t tmp_kernel_op_285 = -hessian_blending_0_0_0_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_0_1_0_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_0_2_0_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_286 = -hessian_blending_0_0_1_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_0_1_1_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_0_2_1_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_287 = -hessian_blending_0_0_2_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_0_1_2_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_0_2_2_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_288 = jac_blending_inv_0_0_q_3*tmp_kernel_op_285 + jac_blending_inv_0_1_q_3*tmp_kernel_op_286 + jac_blending_inv_0_2_q_3*tmp_kernel_op_287;
             const real_t tmp_kernel_op_290 = jac_blending_inv_1_0_q_3*tmp_kernel_op_285 + jac_blending_inv_1_1_q_3*tmp_kernel_op_286 + jac_blending_inv_1_2_q_3*tmp_kernel_op_287;
             const real_t tmp_kernel_op_292 = jac_blending_inv_2_0_q_3*tmp_kernel_op_285 + jac_blending_inv_2_1_q_3*tmp_kernel_op_286 + jac_blending_inv_2_2_q_3*tmp_kernel_op_287;
             const real_t tmp_kernel_op_293 = -hessian_blending_1_0_0_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_1_1_0_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_1_2_0_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_294 = -hessian_blending_1_0_1_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_1_1_1_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_1_2_1_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_295 = -hessian_blending_1_0_2_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_1_1_2_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_1_2_2_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_296 = jac_blending_inv_0_0_q_3*tmp_kernel_op_293 + jac_blending_inv_0_1_q_3*tmp_kernel_op_294 + jac_blending_inv_0_2_q_3*tmp_kernel_op_295;
             const real_t tmp_kernel_op_297 = jac_blending_inv_1_0_q_3*tmp_kernel_op_293 + jac_blending_inv_1_1_q_3*tmp_kernel_op_294 + jac_blending_inv_1_2_q_3*tmp_kernel_op_295;
             const real_t tmp_kernel_op_298 = jac_blending_inv_2_0_q_3*tmp_kernel_op_293 + jac_blending_inv_2_1_q_3*tmp_kernel_op_294 + jac_blending_inv_2_2_q_3*tmp_kernel_op_295;
             const real_t tmp_kernel_op_299 = -hessian_blending_2_0_0_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_2_1_0_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_2_2_0_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_300 = -hessian_blending_2_0_1_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_2_1_1_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_2_2_1_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_301 = -hessian_blending_2_0_2_q_3*jac_blending_inv_0_0_q_3 - hessian_blending_2_1_2_q_3*jac_blending_inv_1_0_q_3 - hessian_blending_2_2_2_q_3*jac_blending_inv_2_0_q_3;
             const real_t tmp_kernel_op_302 = jac_blending_inv_0_0_q_3*tmp_kernel_op_299 + jac_blending_inv_0_1_q_3*tmp_kernel_op_300 + jac_blending_inv_0_2_q_3*tmp_kernel_op_301;
             const real_t tmp_kernel_op_303 = jac_blending_inv_1_0_q_3*tmp_kernel_op_299 + jac_blending_inv_1_1_q_3*tmp_kernel_op_300 + jac_blending_inv_1_2_q_3*tmp_kernel_op_301;
             const real_t tmp_kernel_op_304 = jac_blending_inv_2_0_q_3*tmp_kernel_op_299 + jac_blending_inv_2_1_q_3*tmp_kernel_op_300 + jac_blending_inv_2_2_q_3*tmp_kernel_op_301;
             const real_t tmp_kernel_op_305 = -hessian_blending_0_0_0_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_0_1_0_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_0_2_0_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_306 = -hessian_blending_0_0_1_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_0_1_1_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_0_2_1_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_307 = -hessian_blending_0_0_2_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_0_1_2_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_0_2_2_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_308 = jac_blending_inv_0_0_q_3*tmp_kernel_op_305 + jac_blending_inv_0_1_q_3*tmp_kernel_op_306 + jac_blending_inv_0_2_q_3*tmp_kernel_op_307;
             const real_t tmp_kernel_op_309 = jac_blending_inv_1_0_q_3*tmp_kernel_op_305 + jac_blending_inv_1_1_q_3*tmp_kernel_op_306 + jac_blending_inv_1_2_q_3*tmp_kernel_op_307;
             const real_t tmp_kernel_op_310 = jac_blending_inv_2_0_q_3*tmp_kernel_op_305 + jac_blending_inv_2_1_q_3*tmp_kernel_op_306 + jac_blending_inv_2_2_q_3*tmp_kernel_op_307;
             const real_t tmp_kernel_op_311 = -hessian_blending_1_0_0_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_1_1_0_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_1_2_0_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_312 = -hessian_blending_1_0_1_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_1_1_1_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_1_2_1_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_313 = -hessian_blending_1_0_2_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_1_1_2_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_1_2_2_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_314 = jac_blending_inv_0_0_q_3*tmp_kernel_op_311 + jac_blending_inv_0_1_q_3*tmp_kernel_op_312 + jac_blending_inv_0_2_q_3*tmp_kernel_op_313;
             const real_t tmp_kernel_op_315 = jac_blending_inv_1_0_q_3*tmp_kernel_op_311 + jac_blending_inv_1_1_q_3*tmp_kernel_op_312 + jac_blending_inv_1_2_q_3*tmp_kernel_op_313;
             const real_t tmp_kernel_op_316 = jac_blending_inv_2_0_q_3*tmp_kernel_op_311 + jac_blending_inv_2_1_q_3*tmp_kernel_op_312 + jac_blending_inv_2_2_q_3*tmp_kernel_op_313;
             const real_t tmp_kernel_op_317 = -hessian_blending_2_0_0_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_2_1_0_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_2_2_0_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_318 = -hessian_blending_2_0_1_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_2_1_1_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_2_2_1_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_319 = -hessian_blending_2_0_2_q_3*jac_blending_inv_0_1_q_3 - hessian_blending_2_1_2_q_3*jac_blending_inv_1_1_q_3 - hessian_blending_2_2_2_q_3*jac_blending_inv_2_1_q_3;
             const real_t tmp_kernel_op_320 = jac_blending_inv_0_0_q_3*tmp_kernel_op_317 + jac_blending_inv_0_1_q_3*tmp_kernel_op_318 + jac_blending_inv_0_2_q_3*tmp_kernel_op_319;
             const real_t tmp_kernel_op_321 = jac_blending_inv_1_0_q_3*tmp_kernel_op_317 + jac_blending_inv_1_1_q_3*tmp_kernel_op_318 + jac_blending_inv_1_2_q_3*tmp_kernel_op_319;
             const real_t tmp_kernel_op_322 = jac_blending_inv_2_0_q_3*tmp_kernel_op_317 + jac_blending_inv_2_1_q_3*tmp_kernel_op_318 + jac_blending_inv_2_2_q_3*tmp_kernel_op_319;
             const real_t tmp_kernel_op_323 = -hessian_blending_0_0_0_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_0_1_0_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_0_2_0_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_324 = -hessian_blending_0_0_1_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_0_1_1_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_0_2_1_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_325 = -hessian_blending_0_0_2_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_0_1_2_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_0_2_2_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_326 = jac_blending_inv_0_0_q_3*tmp_kernel_op_323 + jac_blending_inv_0_1_q_3*tmp_kernel_op_324 + jac_blending_inv_0_2_q_3*tmp_kernel_op_325;
             const real_t tmp_kernel_op_327 = jac_blending_inv_1_0_q_3*tmp_kernel_op_323 + jac_blending_inv_1_1_q_3*tmp_kernel_op_324 + jac_blending_inv_1_2_q_3*tmp_kernel_op_325;
             const real_t tmp_kernel_op_328 = jac_blending_inv_2_0_q_3*tmp_kernel_op_323 + jac_blending_inv_2_1_q_3*tmp_kernel_op_324 + jac_blending_inv_2_2_q_3*tmp_kernel_op_325;
             const real_t tmp_kernel_op_329 = -hessian_blending_1_0_0_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_1_1_0_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_1_2_0_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_330 = -hessian_blending_1_0_1_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_1_1_1_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_1_2_1_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_331 = -hessian_blending_1_0_2_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_1_1_2_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_1_2_2_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_332 = jac_blending_inv_0_0_q_3*tmp_kernel_op_329 + jac_blending_inv_0_1_q_3*tmp_kernel_op_330 + jac_blending_inv_0_2_q_3*tmp_kernel_op_331;
             const real_t tmp_kernel_op_333 = jac_blending_inv_1_0_q_3*tmp_kernel_op_329 + jac_blending_inv_1_1_q_3*tmp_kernel_op_330 + jac_blending_inv_1_2_q_3*tmp_kernel_op_331;
             const real_t tmp_kernel_op_334 = jac_blending_inv_2_0_q_3*tmp_kernel_op_329 + jac_blending_inv_2_1_q_3*tmp_kernel_op_330 + jac_blending_inv_2_2_q_3*tmp_kernel_op_331;
             const real_t tmp_kernel_op_335 = -hessian_blending_2_0_0_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_2_1_0_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_2_2_0_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_336 = -hessian_blending_2_0_1_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_2_1_1_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_2_2_1_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_337 = -hessian_blending_2_0_2_q_3*jac_blending_inv_0_2_q_3 - hessian_blending_2_1_2_q_3*jac_blending_inv_1_2_q_3 - hessian_blending_2_2_2_q_3*jac_blending_inv_2_2_q_3;
             const real_t tmp_kernel_op_338 = jac_blending_inv_0_0_q_3*tmp_kernel_op_335 + jac_blending_inv_0_1_q_3*tmp_kernel_op_336 + jac_blending_inv_0_2_q_3*tmp_kernel_op_337;
             const real_t tmp_kernel_op_339 = jac_blending_inv_1_0_q_3*tmp_kernel_op_335 + jac_blending_inv_1_1_q_3*tmp_kernel_op_336 + jac_blending_inv_1_2_q_3*tmp_kernel_op_337;
             const real_t tmp_kernel_op_340 = jac_blending_inv_2_0_q_3*tmp_kernel_op_335 + jac_blending_inv_2_1_q_3*tmp_kernel_op_336 + jac_blending_inv_2_2_q_3*tmp_kernel_op_337;
             const real_t tmp_kernel_op_341 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1481 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1487 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1493) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1509 + tmp_kernel_op_290*tmp_moved_constant_1510 + tmp_kernel_op_292*tmp_moved_constant_1511) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1481 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1487 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1493) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1509 + tmp_kernel_op_297*tmp_moved_constant_1510 + tmp_kernel_op_298*tmp_moved_constant_1511) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1481 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1487 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1493) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1509 + tmp_kernel_op_303*tmp_moved_constant_1510 + tmp_kernel_op_304*tmp_moved_constant_1511) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1494 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1495 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1496) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1509 + tmp_kernel_op_309*tmp_moved_constant_1510 + tmp_kernel_op_310*tmp_moved_constant_1511) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1494 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1495 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1496) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1509 + tmp_kernel_op_315*tmp_moved_constant_1510 + tmp_kernel_op_316*tmp_moved_constant_1511) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1494 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1495 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1496) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1509 + tmp_kernel_op_321*tmp_moved_constant_1510 + tmp_kernel_op_322*tmp_moved_constant_1511) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1497 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1498 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1499) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1509 + tmp_kernel_op_327*tmp_moved_constant_1510 + tmp_kernel_op_328*tmp_moved_constant_1511) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1497 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1498 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1499) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1509 + tmp_kernel_op_333*tmp_moved_constant_1510 + tmp_kernel_op_334*tmp_moved_constant_1511) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1497 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1498 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1499) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1509 + tmp_kernel_op_339*tmp_moved_constant_1510 + tmp_kernel_op_340*tmp_moved_constant_1511);
             const real_t tmp_kernel_op_359 = tmp_kernel_op_342*wx_dof_4 + tmp_kernel_op_343*wx_dof_5 + tmp_kernel_op_344*wx_dof_6 + tmp_kernel_op_347*wx_dof_1 + tmp_kernel_op_350*wx_dof_2 + tmp_kernel_op_353*wx_dof_3 + tmp_kernel_op_354*wx_dof_7 + tmp_kernel_op_355*wx_dof_8 + tmp_kernel_op_357*wx_dof_9 + tmp_kernel_op_358*wx_dof_0;
             const real_t tmp_kernel_op_360 = tmp_kernel_op_342*wy_dof_4 + tmp_kernel_op_343*wy_dof_5 + tmp_kernel_op_344*wy_dof_6 + tmp_kernel_op_347*wy_dof_1 + tmp_kernel_op_350*wy_dof_2 + tmp_kernel_op_353*wy_dof_3 + tmp_kernel_op_354*wy_dof_7 + tmp_kernel_op_355*wy_dof_8 + tmp_kernel_op_357*wy_dof_9 + tmp_kernel_op_358*wy_dof_0;
             const real_t tmp_kernel_op_361 = tmp_kernel_op_342*wz_dof_4 + tmp_kernel_op_343*wz_dof_5 + tmp_kernel_op_344*wz_dof_6 + tmp_kernel_op_347*wz_dof_1 + tmp_kernel_op_350*wz_dof_2 + tmp_kernel_op_353*wz_dof_3 + tmp_kernel_op_354*wz_dof_7 + tmp_kernel_op_355*wz_dof_8 + tmp_kernel_op_357*wz_dof_9 + tmp_kernel_op_358*wz_dof_0;
             const real_t tmp_kernel_op_362 = abs_det_jac_affine_GREEN_DOWN*abs_det_jac_blending_q_3*(diffusivity_times_delta_dof_0*tmp_kernel_op_358 + diffusivity_times_delta_dof_1*tmp_kernel_op_347 + diffusivity_times_delta_dof_2*tmp_kernel_op_350 + diffusivity_times_delta_dof_3*tmp_kernel_op_353 + diffusivity_times_delta_dof_4*tmp_kernel_op_342 + diffusivity_times_delta_dof_5*tmp_kernel_op_343 + diffusivity_times_delta_dof_6*tmp_kernel_op_344 + diffusivity_times_delta_dof_7*tmp_kernel_op_354 + diffusivity_times_delta_dof_8*tmp_kernel_op_355 + diffusivity_times_delta_dof_9*tmp_kernel_op_357)*0.074999999999999983;
             const real_t tmp_kernel_op_363 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1509 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1510 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1511) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1509 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1510 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1511) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1509 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1510 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1511));
             const real_t tmp_kernel_op_370 = -hessian_blending_0_0_0_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_0_1_0_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_0_2_0_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_371 = -hessian_blending_0_0_1_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_0_1_1_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_0_2_1_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_372 = -hessian_blending_0_0_2_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_0_1_2_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_0_2_2_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_373 = jac_blending_inv_0_0_q_4*tmp_kernel_op_370 + jac_blending_inv_0_1_q_4*tmp_kernel_op_371 + jac_blending_inv_0_2_q_4*tmp_kernel_op_372;
             const real_t tmp_kernel_op_375 = jac_blending_inv_1_0_q_4*tmp_kernel_op_370 + jac_blending_inv_1_1_q_4*tmp_kernel_op_371 + jac_blending_inv_1_2_q_4*tmp_kernel_op_372;
             const real_t tmp_kernel_op_377 = jac_blending_inv_2_0_q_4*tmp_kernel_op_370 + jac_blending_inv_2_1_q_4*tmp_kernel_op_371 + jac_blending_inv_2_2_q_4*tmp_kernel_op_372;
             const real_t tmp_kernel_op_378 = -hessian_blending_1_0_0_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_1_1_0_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_1_2_0_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_379 = -hessian_blending_1_0_1_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_1_1_1_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_1_2_1_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_380 = -hessian_blending_1_0_2_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_1_1_2_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_1_2_2_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_381 = jac_blending_inv_0_0_q_4*tmp_kernel_op_378 + jac_blending_inv_0_1_q_4*tmp_kernel_op_379 + jac_blending_inv_0_2_q_4*tmp_kernel_op_380;
             const real_t tmp_kernel_op_382 = jac_blending_inv_1_0_q_4*tmp_kernel_op_378 + jac_blending_inv_1_1_q_4*tmp_kernel_op_379 + jac_blending_inv_1_2_q_4*tmp_kernel_op_380;
             const real_t tmp_kernel_op_383 = jac_blending_inv_2_0_q_4*tmp_kernel_op_378 + jac_blending_inv_2_1_q_4*tmp_kernel_op_379 + jac_blending_inv_2_2_q_4*tmp_kernel_op_380;
             const real_t tmp_kernel_op_384 = -hessian_blending_2_0_0_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_2_1_0_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_2_2_0_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_385 = -hessian_blending_2_0_1_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_2_1_1_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_2_2_1_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_386 = -hessian_blending_2_0_2_q_4*jac_blending_inv_0_0_q_4 - hessian_blending_2_1_2_q_4*jac_blending_inv_1_0_q_4 - hessian_blending_2_2_2_q_4*jac_blending_inv_2_0_q_4;
             const real_t tmp_kernel_op_387 = jac_blending_inv_0_0_q_4*tmp_kernel_op_384 + jac_blending_inv_0_1_q_4*tmp_kernel_op_385 + jac_blending_inv_0_2_q_4*tmp_kernel_op_386;
             const real_t tmp_kernel_op_388 = jac_blending_inv_1_0_q_4*tmp_kernel_op_384 + jac_blending_inv_1_1_q_4*tmp_kernel_op_385 + jac_blending_inv_1_2_q_4*tmp_kernel_op_386;
             const real_t tmp_kernel_op_389 = jac_blending_inv_2_0_q_4*tmp_kernel_op_384 + jac_blending_inv_2_1_q_4*tmp_kernel_op_385 + jac_blending_inv_2_2_q_4*tmp_kernel_op_386;
             const real_t tmp_kernel_op_390 = -hessian_blending_0_0_0_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_0_1_0_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_0_2_0_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_391 = -hessian_blending_0_0_1_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_0_1_1_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_0_2_1_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_392 = -hessian_blending_0_0_2_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_0_1_2_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_0_2_2_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_393 = jac_blending_inv_0_0_q_4*tmp_kernel_op_390 + jac_blending_inv_0_1_q_4*tmp_kernel_op_391 + jac_blending_inv_0_2_q_4*tmp_kernel_op_392;
             const real_t tmp_kernel_op_394 = jac_blending_inv_1_0_q_4*tmp_kernel_op_390 + jac_blending_inv_1_1_q_4*tmp_kernel_op_391 + jac_blending_inv_1_2_q_4*tmp_kernel_op_392;
             const real_t tmp_kernel_op_395 = jac_blending_inv_2_0_q_4*tmp_kernel_op_390 + jac_blending_inv_2_1_q_4*tmp_kernel_op_391 + jac_blending_inv_2_2_q_4*tmp_kernel_op_392;
             const real_t tmp_kernel_op_396 = -hessian_blending_1_0_0_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_1_1_0_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_1_2_0_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_397 = -hessian_blending_1_0_1_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_1_1_1_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_1_2_1_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_398 = -hessian_blending_1_0_2_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_1_1_2_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_1_2_2_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_399 = jac_blending_inv_0_0_q_4*tmp_kernel_op_396 + jac_blending_inv_0_1_q_4*tmp_kernel_op_397 + jac_blending_inv_0_2_q_4*tmp_kernel_op_398;
             const real_t tmp_kernel_op_400 = jac_blending_inv_1_0_q_4*tmp_kernel_op_396 + jac_blending_inv_1_1_q_4*tmp_kernel_op_397 + jac_blending_inv_1_2_q_4*tmp_kernel_op_398;
             const real_t tmp_kernel_op_401 = jac_blending_inv_2_0_q_4*tmp_kernel_op_396 + jac_blending_inv_2_1_q_4*tmp_kernel_op_397 + jac_blending_inv_2_2_q_4*tmp_kernel_op_398;
             const real_t tmp_kernel_op_402 = -hessian_blending_2_0_0_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_2_1_0_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_2_2_0_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_403 = -hessian_blending_2_0_1_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_2_1_1_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_2_2_1_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_404 = -hessian_blending_2_0_2_q_4*jac_blending_inv_0_1_q_4 - hessian_blending_2_1_2_q_4*jac_blending_inv_1_1_q_4 - hessian_blending_2_2_2_q_4*jac_blending_inv_2_1_q_4;
             const real_t tmp_kernel_op_405 = jac_blending_inv_0_0_q_4*tmp_kernel_op_402 + jac_blending_inv_0_1_q_4*tmp_kernel_op_403 + jac_blending_inv_0_2_q_4*tmp_kernel_op_404;
             const real_t tmp_kernel_op_406 = jac_blending_inv_1_0_q_4*tmp_kernel_op_402 + jac_blending_inv_1_1_q_4*tmp_kernel_op_403 + jac_blending_inv_1_2_q_4*tmp_kernel_op_404;
             const real_t tmp_kernel_op_407 = jac_blending_inv_2_0_q_4*tmp_kernel_op_402 + jac_blending_inv_2_1_q_4*tmp_kernel_op_403 + jac_blending_inv_2_2_q_4*tmp_kernel_op_404;
             const real_t tmp_kernel_op_408 = -hessian_blending_0_0_0_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_0_1_0_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_0_2_0_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_409 = -hessian_blending_0_0_1_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_0_1_1_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_0_2_1_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_410 = -hessian_blending_0_0_2_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_0_1_2_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_0_2_2_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_411 = jac_blending_inv_0_0_q_4*tmp_kernel_op_408 + jac_blending_inv_0_1_q_4*tmp_kernel_op_409 + jac_blending_inv_0_2_q_4*tmp_kernel_op_410;
             const real_t tmp_kernel_op_412 = jac_blending_inv_1_0_q_4*tmp_kernel_op_408 + jac_blending_inv_1_1_q_4*tmp_kernel_op_409 + jac_blending_inv_1_2_q_4*tmp_kernel_op_410;
             const real_t tmp_kernel_op_413 = jac_blending_inv_2_0_q_4*tmp_kernel_op_408 + jac_blending_inv_2_1_q_4*tmp_kernel_op_409 + jac_blending_inv_2_2_q_4*tmp_kernel_op_410;
             const real_t tmp_kernel_op_414 = -hessian_blending_1_0_0_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_1_1_0_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_1_2_0_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_415 = -hessian_blending_1_0_1_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_1_1_1_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_1_2_1_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_416 = -hessian_blending_1_0_2_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_1_1_2_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_1_2_2_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_417 = jac_blending_inv_0_0_q_4*tmp_kernel_op_414 + jac_blending_inv_0_1_q_4*tmp_kernel_op_415 + jac_blending_inv_0_2_q_4*tmp_kernel_op_416;
             const real_t tmp_kernel_op_418 = jac_blending_inv_1_0_q_4*tmp_kernel_op_414 + jac_blending_inv_1_1_q_4*tmp_kernel_op_415 + jac_blending_inv_1_2_q_4*tmp_kernel_op_416;
             const real_t tmp_kernel_op_419 = jac_blending_inv_2_0_q_4*tmp_kernel_op_414 + jac_blending_inv_2_1_q_4*tmp_kernel_op_415 + jac_blending_inv_2_2_q_4*tmp_kernel_op_416;
             const real_t tmp_kernel_op_420 = -hessian_blending_2_0_0_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_2_1_0_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_2_2_0_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_421 = -hessian_blending_2_0_1_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_2_1_1_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_2_2_1_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_422 = -hessian_blending_2_0_2_q_4*jac_blending_inv_0_2_q_4 - hessian_blending_2_1_2_q_4*jac_blending_inv_1_2_q_4 - hessian_blending_2_2_2_q_4*jac_blending_inv_2_2_q_4;
             const real_t tmp_kernel_op_423 = jac_blending_inv_0_0_q_4*tmp_kernel_op_420 + jac_blending_inv_0_1_q_4*tmp_kernel_op_421 + jac_blending_inv_0_2_q_4*tmp_kernel_op_422;
             const real_t tmp_kernel_op_424 = jac_blending_inv_1_0_q_4*tmp_kernel_op_420 + jac_blending_inv_1_1_q_4*tmp_kernel_op_421 + jac_blending_inv_1_2_q_4*tmp_kernel_op_422;
             const real_t tmp_kernel_op_425 = jac_blending_inv_2_0_q_4*tmp_kernel_op_420 + jac_blending_inv_2_1_q_4*tmp_kernel_op_421 + jac_blending_inv_2_2_q_4*tmp_kernel_op_422;
             const real_t tmp_kernel_op_426 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1481 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1487 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1493) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1512 + tmp_kernel_op_375*tmp_moved_constant_1513 + tmp_kernel_op_377*tmp_moved_constant_1514) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1481 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1487 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1493) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1512 + tmp_kernel_op_382*tmp_moved_constant_1513 + tmp_kernel_op_383*tmp_moved_constant_1514) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1481 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1487 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1493) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1512 + tmp_kernel_op_388*tmp_moved_constant_1513 + tmp_kernel_op_389*tmp_moved_constant_1514) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1494 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1495 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1496) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1512 + tmp_kernel_op_394*tmp_moved_constant_1513 + tmp_kernel_op_395*tmp_moved_constant_1514) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1494 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1495 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1496) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1512 + tmp_kernel_op_400*tmp_moved_constant_1513 + tmp_kernel_op_401*tmp_moved_constant_1514) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1494 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1495 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1496) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1512 + tmp_kernel_op_406*tmp_moved_constant_1513 + tmp_kernel_op_407*tmp_moved_constant_1514) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1497 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1498 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1499) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1512 + tmp_kernel_op_412*tmp_moved_constant_1513 + tmp_kernel_op_413*tmp_moved_constant_1514) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1497 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1498 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1499) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1512 + tmp_kernel_op_418*tmp_moved_constant_1513 + tmp_kernel_op_419*tmp_moved_constant_1514) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1497 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1498 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1499) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1512 + tmp_kernel_op_424*tmp_moved_constant_1513 + tmp_kernel_op_425*tmp_moved_constant_1514);
             const real_t tmp_kernel_op_444 = tmp_kernel_op_427*wx_dof_4 + tmp_kernel_op_428*wx_dof_5 + tmp_kernel_op_429*wx_dof_6 + tmp_kernel_op_432*wx_dof_1 + tmp_kernel_op_435*wx_dof_2 + tmp_kernel_op_438*wx_dof_3 + tmp_kernel_op_439*wx_dof_7 + tmp_kernel_op_440*wx_dof_8 + tmp_kernel_op_442*wx_dof_9 + tmp_kernel_op_443*wx_dof_0;
             const real_t tmp_kernel_op_445 = tmp_kernel_op_427*wy_dof_4 + tmp_kernel_op_428*wy_dof_5 + tmp_kernel_op_429*wy_dof_6 + tmp_kernel_op_432*wy_dof_1 + tmp_kernel_op_435*wy_dof_2 + tmp_kernel_op_438*wy_dof_3 + tmp_kernel_op_439*wy_dof_7 + tmp_kernel_op_440*wy_dof_8 + tmp_kernel_op_442*wy_dof_9 + tmp_kernel_op_443*wy_dof_0;
             const real_t tmp_kernel_op_446 = tmp_kernel_op_427*wz_dof_4 + tmp_kernel_op_428*wz_dof_5 + tmp_kernel_op_429*wz_dof_6 + tmp_kernel_op_432*wz_dof_1 + tmp_kernel_op_435*wz_dof_2 + tmp_kernel_op_438*wz_dof_3 + tmp_kernel_op_439*wz_dof_7 + tmp_kernel_op_440*wz_dof_8 + tmp_kernel_op_442*wz_dof_9 + tmp_kernel_op_443*wz_dof_0;
             const real_t tmp_kernel_op_447 = abs_det_jac_affine_GREEN_DOWN*abs_det_jac_blending_q_4*(diffusivity_times_delta_dof_0*tmp_kernel_op_443 + diffusivity_times_delta_dof_1*tmp_kernel_op_432 + diffusivity_times_delta_dof_2*tmp_kernel_op_435 + diffusivity_times_delta_dof_3*tmp_kernel_op_438 + diffusivity_times_delta_dof_4*tmp_kernel_op_427 + diffusivity_times_delta_dof_5*tmp_kernel_op_428 + diffusivity_times_delta_dof_6*tmp_kernel_op_429 + diffusivity_times_delta_dof_7*tmp_kernel_op_439 + diffusivity_times_delta_dof_8*tmp_kernel_op_440 + diffusivity_times_delta_dof_9*tmp_kernel_op_442)*0.074999999999999983;
             const real_t tmp_kernel_op_448 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1512 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1513 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1514) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1512 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1513 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1514) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1512 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1513 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1514));
             const real_t tmp_kernel_op_459 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1517 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1515 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1516) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1521 + tmp_kernel_op_35*tmp_moved_constant_1522 + tmp_kernel_op_37*tmp_moved_constant_1523) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1517 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1515 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1516) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1521 + tmp_kernel_op_42*tmp_moved_constant_1522 + tmp_kernel_op_43*tmp_moved_constant_1523) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1517 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1515 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1516) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1521 + tmp_kernel_op_48*tmp_moved_constant_1522 + tmp_kernel_op_49*tmp_moved_constant_1523) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1515 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1519 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1518) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1521 + tmp_kernel_op_54*tmp_moved_constant_1522 + tmp_kernel_op_55*tmp_moved_constant_1523) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1515 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1519 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1518) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1521 + tmp_kernel_op_60*tmp_moved_constant_1522 + tmp_kernel_op_61*tmp_moved_constant_1523) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1515 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1519 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1518) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1521 + tmp_kernel_op_66*tmp_moved_constant_1522 + tmp_kernel_op_67*tmp_moved_constant_1523) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1516 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1518 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1520) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1521 + tmp_kernel_op_72*tmp_moved_constant_1522 + tmp_kernel_op_73*tmp_moved_constant_1523) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1516 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1518 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1520) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1521 + tmp_kernel_op_78*tmp_moved_constant_1522 + tmp_kernel_op_79*tmp_moved_constant_1523) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1516 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1518 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1520) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1521 + tmp_kernel_op_84*tmp_moved_constant_1522 + tmp_kernel_op_85*tmp_moved_constant_1523);
             const real_t tmp_kernel_op_464 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1517 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1515 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1516) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1524 + tmp_kernel_op_120*tmp_moved_constant_1525 + tmp_kernel_op_122*tmp_moved_constant_1526) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1517 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1515 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1516) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1524 + tmp_kernel_op_127*tmp_moved_constant_1525 + tmp_kernel_op_128*tmp_moved_constant_1526) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1517 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1515 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1516) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1524 + tmp_kernel_op_133*tmp_moved_constant_1525 + tmp_kernel_op_134*tmp_moved_constant_1526) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1515 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1519 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1518) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1524 + tmp_kernel_op_139*tmp_moved_constant_1525 + tmp_kernel_op_140*tmp_moved_constant_1526) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1515 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1519 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1518) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1524 + tmp_kernel_op_145*tmp_moved_constant_1525 + tmp_kernel_op_146*tmp_moved_constant_1526) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1515 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1519 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1518) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1524 + tmp_kernel_op_151*tmp_moved_constant_1525 + tmp_kernel_op_152*tmp_moved_constant_1526) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1516 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1518 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1520) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1524 + tmp_kernel_op_157*tmp_moved_constant_1525 + tmp_kernel_op_158*tmp_moved_constant_1526) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1516 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1518 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1520) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1524 + tmp_kernel_op_163*tmp_moved_constant_1525 + tmp_kernel_op_164*tmp_moved_constant_1526) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1516 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1518 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1520) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1524 + tmp_kernel_op_169*tmp_moved_constant_1525 + tmp_kernel_op_170*tmp_moved_constant_1526);
             const real_t tmp_kernel_op_469 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1517 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1515 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1516) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1527 + tmp_kernel_op_205*tmp_moved_constant_1528 + tmp_kernel_op_207*tmp_moved_constant_1529) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1517 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1515 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1516) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1527 + tmp_kernel_op_212*tmp_moved_constant_1528 + tmp_kernel_op_213*tmp_moved_constant_1529) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1517 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1515 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1516) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1527 + tmp_kernel_op_218*tmp_moved_constant_1528 + tmp_kernel_op_219*tmp_moved_constant_1529) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1515 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1519 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1518) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1527 + tmp_kernel_op_224*tmp_moved_constant_1528 + tmp_kernel_op_225*tmp_moved_constant_1529) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1515 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1519 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1518) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1527 + tmp_kernel_op_230*tmp_moved_constant_1528 + tmp_kernel_op_231*tmp_moved_constant_1529) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1515 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1519 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1518) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1527 + tmp_kernel_op_236*tmp_moved_constant_1528 + tmp_kernel_op_237*tmp_moved_constant_1529) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1516 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1518 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1520) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1527 + tmp_kernel_op_242*tmp_moved_constant_1528 + tmp_kernel_op_243*tmp_moved_constant_1529) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1516 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1518 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1520) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1527 + tmp_kernel_op_248*tmp_moved_constant_1528 + tmp_kernel_op_249*tmp_moved_constant_1529) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1516 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1518 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1520) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1527 + tmp_kernel_op_254*tmp_moved_constant_1528 + tmp_kernel_op_255*tmp_moved_constant_1529);
             const real_t tmp_kernel_op_474 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1517 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1515 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1516) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1530 + tmp_kernel_op_290*tmp_moved_constant_1531 + tmp_kernel_op_292*tmp_moved_constant_1532) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1517 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1515 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1516) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1530 + tmp_kernel_op_297*tmp_moved_constant_1531 + tmp_kernel_op_298*tmp_moved_constant_1532) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1517 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1515 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1516) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1530 + tmp_kernel_op_303*tmp_moved_constant_1531 + tmp_kernel_op_304*tmp_moved_constant_1532) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1515 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1519 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1518) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1530 + tmp_kernel_op_309*tmp_moved_constant_1531 + tmp_kernel_op_310*tmp_moved_constant_1532) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1515 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1519 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1518) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1530 + tmp_kernel_op_315*tmp_moved_constant_1531 + tmp_kernel_op_316*tmp_moved_constant_1532) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1515 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1519 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1518) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1530 + tmp_kernel_op_321*tmp_moved_constant_1531 + tmp_kernel_op_322*tmp_moved_constant_1532) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1516 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1518 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1520) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1530 + tmp_kernel_op_327*tmp_moved_constant_1531 + tmp_kernel_op_328*tmp_moved_constant_1532) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1516 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1518 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1520) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1530 + tmp_kernel_op_333*tmp_moved_constant_1531 + tmp_kernel_op_334*tmp_moved_constant_1532) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1516 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1518 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1520) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1530 + tmp_kernel_op_339*tmp_moved_constant_1531 + tmp_kernel_op_340*tmp_moved_constant_1532);
             const real_t tmp_kernel_op_479 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1517 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1515 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1516) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1533 + tmp_kernel_op_375*tmp_moved_constant_1534 + tmp_kernel_op_377*tmp_moved_constant_1535) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1517 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1515 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1516) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1533 + tmp_kernel_op_382*tmp_moved_constant_1534 + tmp_kernel_op_383*tmp_moved_constant_1535) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1517 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1515 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1516) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1533 + tmp_kernel_op_388*tmp_moved_constant_1534 + tmp_kernel_op_389*tmp_moved_constant_1535) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1515 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1519 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1518) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1533 + tmp_kernel_op_394*tmp_moved_constant_1534 + tmp_kernel_op_395*tmp_moved_constant_1535) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1515 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1519 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1518) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1533 + tmp_kernel_op_400*tmp_moved_constant_1534 + tmp_kernel_op_401*tmp_moved_constant_1535) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1515 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1519 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1518) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1533 + tmp_kernel_op_406*tmp_moved_constant_1534 + tmp_kernel_op_407*tmp_moved_constant_1535) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1516 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1518 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1520) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1533 + tmp_kernel_op_412*tmp_moved_constant_1534 + tmp_kernel_op_413*tmp_moved_constant_1535) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1516 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1518 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1520) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1533 + tmp_kernel_op_418*tmp_moved_constant_1534 + tmp_kernel_op_419*tmp_moved_constant_1535) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1516 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1518 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1520) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1533 + tmp_kernel_op_424*tmp_moved_constant_1534 + tmp_kernel_op_425*tmp_moved_constant_1535);
             const real_t tmp_kernel_op_490 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1538 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1536 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1537) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1542 + tmp_kernel_op_35*tmp_moved_constant_1543 + tmp_kernel_op_37*tmp_moved_constant_1544) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1538 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1536 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1537) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1542 + tmp_kernel_op_42*tmp_moved_constant_1543 + tmp_kernel_op_43*tmp_moved_constant_1544) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1538 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1536 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1537) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1542 + tmp_kernel_op_48*tmp_moved_constant_1543 + tmp_kernel_op_49*tmp_moved_constant_1544) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1536 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1540 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1539) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1542 + tmp_kernel_op_54*tmp_moved_constant_1543 + tmp_kernel_op_55*tmp_moved_constant_1544) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1536 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1540 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1539) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1542 + tmp_kernel_op_60*tmp_moved_constant_1543 + tmp_kernel_op_61*tmp_moved_constant_1544) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1536 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1540 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1539) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1542 + tmp_kernel_op_66*tmp_moved_constant_1543 + tmp_kernel_op_67*tmp_moved_constant_1544) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1537 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1539 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1541) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1542 + tmp_kernel_op_72*tmp_moved_constant_1543 + tmp_kernel_op_73*tmp_moved_constant_1544) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1537 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1539 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1541) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1542 + tmp_kernel_op_78*tmp_moved_constant_1543 + tmp_kernel_op_79*tmp_moved_constant_1544) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1537 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1539 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1541) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1542 + tmp_kernel_op_84*tmp_moved_constant_1543 + tmp_kernel_op_85*tmp_moved_constant_1544);
             const real_t tmp_kernel_op_495 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1538 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1536 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1537) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1545 + tmp_kernel_op_120*tmp_moved_constant_1546 + tmp_kernel_op_122*tmp_moved_constant_1547) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1538 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1536 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1537) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1545 + tmp_kernel_op_127*tmp_moved_constant_1546 + tmp_kernel_op_128*tmp_moved_constant_1547) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1538 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1536 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1537) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1545 + tmp_kernel_op_133*tmp_moved_constant_1546 + tmp_kernel_op_134*tmp_moved_constant_1547) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1536 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1540 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1539) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1545 + tmp_kernel_op_139*tmp_moved_constant_1546 + tmp_kernel_op_140*tmp_moved_constant_1547) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1536 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1540 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1539) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1545 + tmp_kernel_op_145*tmp_moved_constant_1546 + tmp_kernel_op_146*tmp_moved_constant_1547) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1536 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1540 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1539) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1545 + tmp_kernel_op_151*tmp_moved_constant_1546 + tmp_kernel_op_152*tmp_moved_constant_1547) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1537 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1539 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1541) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1545 + tmp_kernel_op_157*tmp_moved_constant_1546 + tmp_kernel_op_158*tmp_moved_constant_1547) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1537 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1539 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1541) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1545 + tmp_kernel_op_163*tmp_moved_constant_1546 + tmp_kernel_op_164*tmp_moved_constant_1547) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1537 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1539 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1541) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1545 + tmp_kernel_op_169*tmp_moved_constant_1546 + tmp_kernel_op_170*tmp_moved_constant_1547);
             const real_t tmp_kernel_op_500 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1538 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1536 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1537) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1548 + tmp_kernel_op_205*tmp_moved_constant_1549 + tmp_kernel_op_207*tmp_moved_constant_1550) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1538 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1536 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1537) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1548 + tmp_kernel_op_212*tmp_moved_constant_1549 + tmp_kernel_op_213*tmp_moved_constant_1550) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1538 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1536 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1537) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1548 + tmp_kernel_op_218*tmp_moved_constant_1549 + tmp_kernel_op_219*tmp_moved_constant_1550) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1536 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1540 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1539) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1548 + tmp_kernel_op_224*tmp_moved_constant_1549 + tmp_kernel_op_225*tmp_moved_constant_1550) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1536 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1540 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1539) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1548 + tmp_kernel_op_230*tmp_moved_constant_1549 + tmp_kernel_op_231*tmp_moved_constant_1550) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1536 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1540 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1539) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1548 + tmp_kernel_op_236*tmp_moved_constant_1549 + tmp_kernel_op_237*tmp_moved_constant_1550) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1537 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1539 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1541) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1548 + tmp_kernel_op_242*tmp_moved_constant_1549 + tmp_kernel_op_243*tmp_moved_constant_1550) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1537 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1539 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1541) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1548 + tmp_kernel_op_248*tmp_moved_constant_1549 + tmp_kernel_op_249*tmp_moved_constant_1550) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1537 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1539 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1541) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1548 + tmp_kernel_op_254*tmp_moved_constant_1549 + tmp_kernel_op_255*tmp_moved_constant_1550);
             const real_t tmp_kernel_op_505 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1538 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1536 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1537) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1551 + tmp_kernel_op_290*tmp_moved_constant_1552 + tmp_kernel_op_292*tmp_moved_constant_1553) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1538 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1536 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1537) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1551 + tmp_kernel_op_297*tmp_moved_constant_1552 + tmp_kernel_op_298*tmp_moved_constant_1553) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1538 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1536 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1537) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1551 + tmp_kernel_op_303*tmp_moved_constant_1552 + tmp_kernel_op_304*tmp_moved_constant_1553) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1536 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1540 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1539) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1551 + tmp_kernel_op_309*tmp_moved_constant_1552 + tmp_kernel_op_310*tmp_moved_constant_1553) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1536 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1540 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1539) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1551 + tmp_kernel_op_315*tmp_moved_constant_1552 + tmp_kernel_op_316*tmp_moved_constant_1553) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1536 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1540 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1539) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1551 + tmp_kernel_op_321*tmp_moved_constant_1552 + tmp_kernel_op_322*tmp_moved_constant_1553) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1537 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1539 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1541) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1551 + tmp_kernel_op_327*tmp_moved_constant_1552 + tmp_kernel_op_328*tmp_moved_constant_1553) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1537 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1539 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1541) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1551 + tmp_kernel_op_333*tmp_moved_constant_1552 + tmp_kernel_op_334*tmp_moved_constant_1553) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1537 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1539 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1541) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1551 + tmp_kernel_op_339*tmp_moved_constant_1552 + tmp_kernel_op_340*tmp_moved_constant_1553);
             const real_t tmp_kernel_op_510 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1538 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1536 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1537) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1554 + tmp_kernel_op_375*tmp_moved_constant_1555 + tmp_kernel_op_377*tmp_moved_constant_1556) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1538 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1536 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1537) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1554 + tmp_kernel_op_382*tmp_moved_constant_1555 + tmp_kernel_op_383*tmp_moved_constant_1556) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1538 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1536 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1537) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1554 + tmp_kernel_op_388*tmp_moved_constant_1555 + tmp_kernel_op_389*tmp_moved_constant_1556) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1536 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1540 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1539) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1554 + tmp_kernel_op_394*tmp_moved_constant_1555 + tmp_kernel_op_395*tmp_moved_constant_1556) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1536 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1540 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1539) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1554 + tmp_kernel_op_400*tmp_moved_constant_1555 + tmp_kernel_op_401*tmp_moved_constant_1556) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1536 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1540 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1539) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1554 + tmp_kernel_op_406*tmp_moved_constant_1555 + tmp_kernel_op_407*tmp_moved_constant_1556) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1537 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1539 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1541) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1554 + tmp_kernel_op_412*tmp_moved_constant_1555 + tmp_kernel_op_413*tmp_moved_constant_1556) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1537 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1539 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1541) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1554 + tmp_kernel_op_418*tmp_moved_constant_1555 + tmp_kernel_op_419*tmp_moved_constant_1556) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1537 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1539 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1541) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1554 + tmp_kernel_op_424*tmp_moved_constant_1555 + tmp_kernel_op_425*tmp_moved_constant_1556);
             const real_t tmp_kernel_op_521 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1559 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1557 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1558) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1563 + tmp_kernel_op_35*tmp_moved_constant_1564 + tmp_kernel_op_37*tmp_moved_constant_1565) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1559 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1557 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1558) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1563 + tmp_kernel_op_42*tmp_moved_constant_1564 + tmp_kernel_op_43*tmp_moved_constant_1565) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1559 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1557 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1558) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1563 + tmp_kernel_op_48*tmp_moved_constant_1564 + tmp_kernel_op_49*tmp_moved_constant_1565) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1557 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1561 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1560) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1563 + tmp_kernel_op_54*tmp_moved_constant_1564 + tmp_kernel_op_55*tmp_moved_constant_1565) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1557 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1561 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1560) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1563 + tmp_kernel_op_60*tmp_moved_constant_1564 + tmp_kernel_op_61*tmp_moved_constant_1565) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1557 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1561 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1560) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1563 + tmp_kernel_op_66*tmp_moved_constant_1564 + tmp_kernel_op_67*tmp_moved_constant_1565) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1558 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1560 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1562) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1563 + tmp_kernel_op_72*tmp_moved_constant_1564 + tmp_kernel_op_73*tmp_moved_constant_1565) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1558 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1560 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1562) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1563 + tmp_kernel_op_78*tmp_moved_constant_1564 + tmp_kernel_op_79*tmp_moved_constant_1565) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1558 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1560 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1562) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1563 + tmp_kernel_op_84*tmp_moved_constant_1564 + tmp_kernel_op_85*tmp_moved_constant_1565);
             const real_t tmp_kernel_op_526 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1559 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1557 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1558) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1566 + tmp_kernel_op_120*tmp_moved_constant_1567 + tmp_kernel_op_122*tmp_moved_constant_1568) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1559 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1557 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1558) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1566 + tmp_kernel_op_127*tmp_moved_constant_1567 + tmp_kernel_op_128*tmp_moved_constant_1568) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1559 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1557 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1558) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1566 + tmp_kernel_op_133*tmp_moved_constant_1567 + tmp_kernel_op_134*tmp_moved_constant_1568) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1557 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1561 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1560) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1566 + tmp_kernel_op_139*tmp_moved_constant_1567 + tmp_kernel_op_140*tmp_moved_constant_1568) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1557 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1561 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1560) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1566 + tmp_kernel_op_145*tmp_moved_constant_1567 + tmp_kernel_op_146*tmp_moved_constant_1568) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1557 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1561 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1560) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1566 + tmp_kernel_op_151*tmp_moved_constant_1567 + tmp_kernel_op_152*tmp_moved_constant_1568) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1558 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1560 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1562) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1566 + tmp_kernel_op_157*tmp_moved_constant_1567 + tmp_kernel_op_158*tmp_moved_constant_1568) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1558 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1560 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1562) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1566 + tmp_kernel_op_163*tmp_moved_constant_1567 + tmp_kernel_op_164*tmp_moved_constant_1568) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1558 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1560 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1562) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1566 + tmp_kernel_op_169*tmp_moved_constant_1567 + tmp_kernel_op_170*tmp_moved_constant_1568);
             const real_t tmp_kernel_op_531 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1559 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1557 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1558) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1569 + tmp_kernel_op_205*tmp_moved_constant_1570 + tmp_kernel_op_207*tmp_moved_constant_1571) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1559 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1557 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1558) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1569 + tmp_kernel_op_212*tmp_moved_constant_1570 + tmp_kernel_op_213*tmp_moved_constant_1571) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1559 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1557 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1558) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1569 + tmp_kernel_op_218*tmp_moved_constant_1570 + tmp_kernel_op_219*tmp_moved_constant_1571) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1557 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1561 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1560) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1569 + tmp_kernel_op_224*tmp_moved_constant_1570 + tmp_kernel_op_225*tmp_moved_constant_1571) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1557 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1561 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1560) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1569 + tmp_kernel_op_230*tmp_moved_constant_1570 + tmp_kernel_op_231*tmp_moved_constant_1571) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1557 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1561 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1560) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1569 + tmp_kernel_op_236*tmp_moved_constant_1570 + tmp_kernel_op_237*tmp_moved_constant_1571) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1558 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1560 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1562) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1569 + tmp_kernel_op_242*tmp_moved_constant_1570 + tmp_kernel_op_243*tmp_moved_constant_1571) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1558 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1560 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1562) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1569 + tmp_kernel_op_248*tmp_moved_constant_1570 + tmp_kernel_op_249*tmp_moved_constant_1571) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1558 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1560 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1562) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1569 + tmp_kernel_op_254*tmp_moved_constant_1570 + tmp_kernel_op_255*tmp_moved_constant_1571);
             const real_t tmp_kernel_op_536 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1559 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1557 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1558) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1572 + tmp_kernel_op_290*tmp_moved_constant_1573 + tmp_kernel_op_292*tmp_moved_constant_1574) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1559 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1557 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1558) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1572 + tmp_kernel_op_297*tmp_moved_constant_1573 + tmp_kernel_op_298*tmp_moved_constant_1574) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1559 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1557 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1558) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1572 + tmp_kernel_op_303*tmp_moved_constant_1573 + tmp_kernel_op_304*tmp_moved_constant_1574) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1557 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1561 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1560) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1572 + tmp_kernel_op_309*tmp_moved_constant_1573 + tmp_kernel_op_310*tmp_moved_constant_1574) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1557 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1561 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1560) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1572 + tmp_kernel_op_315*tmp_moved_constant_1573 + tmp_kernel_op_316*tmp_moved_constant_1574) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1557 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1561 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1560) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1572 + tmp_kernel_op_321*tmp_moved_constant_1573 + tmp_kernel_op_322*tmp_moved_constant_1574) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1558 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1560 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1562) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1572 + tmp_kernel_op_327*tmp_moved_constant_1573 + tmp_kernel_op_328*tmp_moved_constant_1574) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1558 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1560 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1562) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1572 + tmp_kernel_op_333*tmp_moved_constant_1573 + tmp_kernel_op_334*tmp_moved_constant_1574) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1558 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1560 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1562) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1572 + tmp_kernel_op_339*tmp_moved_constant_1573 + tmp_kernel_op_340*tmp_moved_constant_1574);
             const real_t tmp_kernel_op_541 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1559 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1557 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1558) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1575 + tmp_kernel_op_375*tmp_moved_constant_1576 + tmp_kernel_op_377*tmp_moved_constant_1577) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1559 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1557 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1558) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1575 + tmp_kernel_op_382*tmp_moved_constant_1576 + tmp_kernel_op_383*tmp_moved_constant_1577) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1559 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1557 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1558) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1575 + tmp_kernel_op_388*tmp_moved_constant_1576 + tmp_kernel_op_389*tmp_moved_constant_1577) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1557 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1561 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1560) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1575 + tmp_kernel_op_394*tmp_moved_constant_1576 + tmp_kernel_op_395*tmp_moved_constant_1577) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1557 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1561 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1560) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1575 + tmp_kernel_op_400*tmp_moved_constant_1576 + tmp_kernel_op_401*tmp_moved_constant_1577) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1557 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1561 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1560) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1575 + tmp_kernel_op_406*tmp_moved_constant_1576 + tmp_kernel_op_407*tmp_moved_constant_1577) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1558 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1560 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1562) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1575 + tmp_kernel_op_412*tmp_moved_constant_1576 + tmp_kernel_op_413*tmp_moved_constant_1577) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1558 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1560 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1562) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1575 + tmp_kernel_op_418*tmp_moved_constant_1576 + tmp_kernel_op_419*tmp_moved_constant_1577) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1558 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1560 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1562) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1575 + tmp_kernel_op_424*tmp_moved_constant_1576 + tmp_kernel_op_425*tmp_moved_constant_1577);
             const real_t tmp_kernel_op_566 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1579 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1582 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1585) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1595 + tmp_kernel_op_35*tmp_moved_constant_1598 + tmp_kernel_op_37*tmp_moved_constant_1601) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1579 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1582 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1585) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1595 + tmp_kernel_op_42*tmp_moved_constant_1598 + tmp_kernel_op_43*tmp_moved_constant_1601) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1579 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1582 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1585) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1595 + tmp_kernel_op_48*tmp_moved_constant_1598 + tmp_kernel_op_49*tmp_moved_constant_1601) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1582 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1587 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1590) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1595 + tmp_kernel_op_54*tmp_moved_constant_1598 + tmp_kernel_op_55*tmp_moved_constant_1601) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1582 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1587 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1590) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1595 + tmp_kernel_op_60*tmp_moved_constant_1598 + tmp_kernel_op_61*tmp_moved_constant_1601) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1582 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1587 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1590) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1595 + tmp_kernel_op_66*tmp_moved_constant_1598 + tmp_kernel_op_67*tmp_moved_constant_1601) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1585 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1590 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1592) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1595 + tmp_kernel_op_72*tmp_moved_constant_1598 + tmp_kernel_op_73*tmp_moved_constant_1601) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1585 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1590 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1592) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1595 + tmp_kernel_op_78*tmp_moved_constant_1598 + tmp_kernel_op_79*tmp_moved_constant_1601) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1585 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1590 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1592) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1595 + tmp_kernel_op_84*tmp_moved_constant_1598 + tmp_kernel_op_85*tmp_moved_constant_1601);
             const real_t tmp_kernel_op_576 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1579 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1582 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1585) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1604 + tmp_kernel_op_120*tmp_moved_constant_1607 + tmp_kernel_op_122*tmp_moved_constant_1610) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1579 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1582 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1585) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1604 + tmp_kernel_op_127*tmp_moved_constant_1607 + tmp_kernel_op_128*tmp_moved_constant_1610) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1579 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1582 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1585) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1604 + tmp_kernel_op_133*tmp_moved_constant_1607 + tmp_kernel_op_134*tmp_moved_constant_1610) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1582 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1587 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1590) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1604 + tmp_kernel_op_139*tmp_moved_constant_1607 + tmp_kernel_op_140*tmp_moved_constant_1610) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1582 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1587 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1590) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1604 + tmp_kernel_op_145*tmp_moved_constant_1607 + tmp_kernel_op_146*tmp_moved_constant_1610) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1582 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1587 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1590) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1604 + tmp_kernel_op_151*tmp_moved_constant_1607 + tmp_kernel_op_152*tmp_moved_constant_1610) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1585 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1590 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1592) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1604 + tmp_kernel_op_157*tmp_moved_constant_1607 + tmp_kernel_op_158*tmp_moved_constant_1610) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1585 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1590 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1592) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1604 + tmp_kernel_op_163*tmp_moved_constant_1607 + tmp_kernel_op_164*tmp_moved_constant_1610) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1585 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1590 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1592) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1604 + tmp_kernel_op_169*tmp_moved_constant_1607 + tmp_kernel_op_170*tmp_moved_constant_1610);
             const real_t tmp_kernel_op_586 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1579 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1582 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1585) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1613 + tmp_kernel_op_205*tmp_moved_constant_1616 + tmp_kernel_op_207*tmp_moved_constant_1619) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1579 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1582 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1585) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1613 + tmp_kernel_op_212*tmp_moved_constant_1616 + tmp_kernel_op_213*tmp_moved_constant_1619) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1579 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1582 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1585) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1613 + tmp_kernel_op_218*tmp_moved_constant_1616 + tmp_kernel_op_219*tmp_moved_constant_1619) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1582 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1587 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1590) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1613 + tmp_kernel_op_224*tmp_moved_constant_1616 + tmp_kernel_op_225*tmp_moved_constant_1619) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1582 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1587 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1590) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1613 + tmp_kernel_op_230*tmp_moved_constant_1616 + tmp_kernel_op_231*tmp_moved_constant_1619) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1582 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1587 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1590) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1613 + tmp_kernel_op_236*tmp_moved_constant_1616 + tmp_kernel_op_237*tmp_moved_constant_1619) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1585 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1590 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1592) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1613 + tmp_kernel_op_242*tmp_moved_constant_1616 + tmp_kernel_op_243*tmp_moved_constant_1619) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1585 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1590 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1592) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1613 + tmp_kernel_op_248*tmp_moved_constant_1616 + tmp_kernel_op_249*tmp_moved_constant_1619) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1585 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1590 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1592) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1613 + tmp_kernel_op_254*tmp_moved_constant_1616 + tmp_kernel_op_255*tmp_moved_constant_1619);
             const real_t tmp_kernel_op_596 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1579 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1582 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1585) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1622 + tmp_kernel_op_290*tmp_moved_constant_1625 + tmp_kernel_op_292*tmp_moved_constant_1628) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1579 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1582 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1585) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1622 + tmp_kernel_op_297*tmp_moved_constant_1625 + tmp_kernel_op_298*tmp_moved_constant_1628) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1579 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1582 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1585) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1622 + tmp_kernel_op_303*tmp_moved_constant_1625 + tmp_kernel_op_304*tmp_moved_constant_1628) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1582 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1587 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1590) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1622 + tmp_kernel_op_309*tmp_moved_constant_1625 + tmp_kernel_op_310*tmp_moved_constant_1628) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1582 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1587 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1590) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1622 + tmp_kernel_op_315*tmp_moved_constant_1625 + tmp_kernel_op_316*tmp_moved_constant_1628) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1582 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1587 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1590) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1622 + tmp_kernel_op_321*tmp_moved_constant_1625 + tmp_kernel_op_322*tmp_moved_constant_1628) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1585 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1590 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1592) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1622 + tmp_kernel_op_327*tmp_moved_constant_1625 + tmp_kernel_op_328*tmp_moved_constant_1628) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1585 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1590 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1592) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1622 + tmp_kernel_op_333*tmp_moved_constant_1625 + tmp_kernel_op_334*tmp_moved_constant_1628) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1585 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1590 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1592) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1622 + tmp_kernel_op_339*tmp_moved_constant_1625 + tmp_kernel_op_340*tmp_moved_constant_1628);
             const real_t tmp_kernel_op_606 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1579 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1582 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1585) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1631 + tmp_kernel_op_375*tmp_moved_constant_1634 + tmp_kernel_op_377*tmp_moved_constant_1637) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1579 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1582 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1585) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1631 + tmp_kernel_op_382*tmp_moved_constant_1634 + tmp_kernel_op_383*tmp_moved_constant_1637) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1579 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1582 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1585) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1631 + tmp_kernel_op_388*tmp_moved_constant_1634 + tmp_kernel_op_389*tmp_moved_constant_1637) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1582 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1587 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1590) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1631 + tmp_kernel_op_394*tmp_moved_constant_1634 + tmp_kernel_op_395*tmp_moved_constant_1637) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1582 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1587 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1590) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1631 + tmp_kernel_op_400*tmp_moved_constant_1634 + tmp_kernel_op_401*tmp_moved_constant_1637) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1582 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1587 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1590) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1631 + tmp_kernel_op_406*tmp_moved_constant_1634 + tmp_kernel_op_407*tmp_moved_constant_1637) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1585 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1590 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1592) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1631 + tmp_kernel_op_412*tmp_moved_constant_1634 + tmp_kernel_op_413*tmp_moved_constant_1637) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1585 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1590 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1592) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1631 + tmp_kernel_op_418*tmp_moved_constant_1634 + tmp_kernel_op_419*tmp_moved_constant_1637) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1585 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1590 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1592) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1631 + tmp_kernel_op_424*tmp_moved_constant_1634 + tmp_kernel_op_425*tmp_moved_constant_1637);
             const real_t tmp_kernel_op_628 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1638 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1641 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1644) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1652 + tmp_kernel_op_35*tmp_moved_constant_1655 + tmp_kernel_op_37*tmp_moved_constant_1658) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1638 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1641 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1644) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1652 + tmp_kernel_op_42*tmp_moved_constant_1655 + tmp_kernel_op_43*tmp_moved_constant_1658) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1638 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1641 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1644) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1652 + tmp_kernel_op_48*tmp_moved_constant_1655 + tmp_kernel_op_49*tmp_moved_constant_1658) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1641 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1645 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1648) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1652 + tmp_kernel_op_54*tmp_moved_constant_1655 + tmp_kernel_op_55*tmp_moved_constant_1658) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1641 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1645 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1648) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1652 + tmp_kernel_op_60*tmp_moved_constant_1655 + tmp_kernel_op_61*tmp_moved_constant_1658) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1641 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1645 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1648) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1652 + tmp_kernel_op_66*tmp_moved_constant_1655 + tmp_kernel_op_67*tmp_moved_constant_1658) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1644 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1648 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1649) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1652 + tmp_kernel_op_72*tmp_moved_constant_1655 + tmp_kernel_op_73*tmp_moved_constant_1658) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1644 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1648 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1649) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1652 + tmp_kernel_op_78*tmp_moved_constant_1655 + tmp_kernel_op_79*tmp_moved_constant_1658) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1644 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1648 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1649) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1652 + tmp_kernel_op_84*tmp_moved_constant_1655 + tmp_kernel_op_85*tmp_moved_constant_1658);
             const real_t tmp_kernel_op_638 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1638 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1641 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1644) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1661 + tmp_kernel_op_120*tmp_moved_constant_1664 + tmp_kernel_op_122*tmp_moved_constant_1667) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1638 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1641 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1644) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1661 + tmp_kernel_op_127*tmp_moved_constant_1664 + tmp_kernel_op_128*tmp_moved_constant_1667) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1638 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1641 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1644) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1661 + tmp_kernel_op_133*tmp_moved_constant_1664 + tmp_kernel_op_134*tmp_moved_constant_1667) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1641 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1645 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1648) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1661 + tmp_kernel_op_139*tmp_moved_constant_1664 + tmp_kernel_op_140*tmp_moved_constant_1667) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1641 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1645 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1648) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1661 + tmp_kernel_op_145*tmp_moved_constant_1664 + tmp_kernel_op_146*tmp_moved_constant_1667) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1641 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1645 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1648) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1661 + tmp_kernel_op_151*tmp_moved_constant_1664 + tmp_kernel_op_152*tmp_moved_constant_1667) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1644 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1648 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1649) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1661 + tmp_kernel_op_157*tmp_moved_constant_1664 + tmp_kernel_op_158*tmp_moved_constant_1667) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1644 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1648 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1649) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1661 + tmp_kernel_op_163*tmp_moved_constant_1664 + tmp_kernel_op_164*tmp_moved_constant_1667) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1644 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1648 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1649) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1661 + tmp_kernel_op_169*tmp_moved_constant_1664 + tmp_kernel_op_170*tmp_moved_constant_1667);
             const real_t tmp_kernel_op_648 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1638 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1641 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1644) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1670 + tmp_kernel_op_205*tmp_moved_constant_1673 + tmp_kernel_op_207*tmp_moved_constant_1676) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1638 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1641 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1644) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1670 + tmp_kernel_op_212*tmp_moved_constant_1673 + tmp_kernel_op_213*tmp_moved_constant_1676) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1638 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1641 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1644) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1670 + tmp_kernel_op_218*tmp_moved_constant_1673 + tmp_kernel_op_219*tmp_moved_constant_1676) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1641 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1645 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1648) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1670 + tmp_kernel_op_224*tmp_moved_constant_1673 + tmp_kernel_op_225*tmp_moved_constant_1676) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1641 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1645 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1648) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1670 + tmp_kernel_op_230*tmp_moved_constant_1673 + tmp_kernel_op_231*tmp_moved_constant_1676) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1641 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1645 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1648) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1670 + tmp_kernel_op_236*tmp_moved_constant_1673 + tmp_kernel_op_237*tmp_moved_constant_1676) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1644 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1648 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1649) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1670 + tmp_kernel_op_242*tmp_moved_constant_1673 + tmp_kernel_op_243*tmp_moved_constant_1676) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1644 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1648 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1649) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1670 + tmp_kernel_op_248*tmp_moved_constant_1673 + tmp_kernel_op_249*tmp_moved_constant_1676) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1644 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1648 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1649) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1670 + tmp_kernel_op_254*tmp_moved_constant_1673 + tmp_kernel_op_255*tmp_moved_constant_1676);
             const real_t tmp_kernel_op_658 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1638 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1641 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1644) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1679 + tmp_kernel_op_290*tmp_moved_constant_1682 + tmp_kernel_op_292*tmp_moved_constant_1685) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1638 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1641 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1644) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1679 + tmp_kernel_op_297*tmp_moved_constant_1682 + tmp_kernel_op_298*tmp_moved_constant_1685) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1638 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1641 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1644) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1679 + tmp_kernel_op_303*tmp_moved_constant_1682 + tmp_kernel_op_304*tmp_moved_constant_1685) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1641 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1645 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1648) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1679 + tmp_kernel_op_309*tmp_moved_constant_1682 + tmp_kernel_op_310*tmp_moved_constant_1685) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1641 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1645 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1648) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1679 + tmp_kernel_op_315*tmp_moved_constant_1682 + tmp_kernel_op_316*tmp_moved_constant_1685) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1641 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1645 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1648) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1679 + tmp_kernel_op_321*tmp_moved_constant_1682 + tmp_kernel_op_322*tmp_moved_constant_1685) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1644 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1648 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1649) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1679 + tmp_kernel_op_327*tmp_moved_constant_1682 + tmp_kernel_op_328*tmp_moved_constant_1685) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1644 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1648 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1649) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1679 + tmp_kernel_op_333*tmp_moved_constant_1682 + tmp_kernel_op_334*tmp_moved_constant_1685) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1644 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1648 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1649) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1679 + tmp_kernel_op_339*tmp_moved_constant_1682 + tmp_kernel_op_340*tmp_moved_constant_1685);
             const real_t tmp_kernel_op_668 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1638 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1641 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1644) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1688 + tmp_kernel_op_375*tmp_moved_constant_1691 + tmp_kernel_op_377*tmp_moved_constant_1694) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1638 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1641 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1644) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1688 + tmp_kernel_op_382*tmp_moved_constant_1691 + tmp_kernel_op_383*tmp_moved_constant_1694) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1638 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1641 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1644) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1688 + tmp_kernel_op_388*tmp_moved_constant_1691 + tmp_kernel_op_389*tmp_moved_constant_1694) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1641 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1645 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1648) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1688 + tmp_kernel_op_394*tmp_moved_constant_1691 + tmp_kernel_op_395*tmp_moved_constant_1694) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1641 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1645 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1648) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1688 + tmp_kernel_op_400*tmp_moved_constant_1691 + tmp_kernel_op_401*tmp_moved_constant_1694) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1641 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1645 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1648) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1688 + tmp_kernel_op_406*tmp_moved_constant_1691 + tmp_kernel_op_407*tmp_moved_constant_1694) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1644 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1648 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1649) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1688 + tmp_kernel_op_412*tmp_moved_constant_1691 + tmp_kernel_op_413*tmp_moved_constant_1694) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1644 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1648 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1649) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1688 + tmp_kernel_op_418*tmp_moved_constant_1691 + tmp_kernel_op_419*tmp_moved_constant_1694) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1644 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1648 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1649) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1688 + tmp_kernel_op_424*tmp_moved_constant_1691 + tmp_kernel_op_425*tmp_moved_constant_1694);
             const real_t tmp_kernel_op_693 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1696 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1699 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1702) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1712 + tmp_kernel_op_35*tmp_moved_constant_1715 + tmp_kernel_op_37*tmp_moved_constant_1718) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1696 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1699 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1702) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1712 + tmp_kernel_op_42*tmp_moved_constant_1715 + tmp_kernel_op_43*tmp_moved_constant_1718) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1696 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1699 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1702) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1712 + tmp_kernel_op_48*tmp_moved_constant_1715 + tmp_kernel_op_49*tmp_moved_constant_1718) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1699 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1704 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1707) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1712 + tmp_kernel_op_54*tmp_moved_constant_1715 + tmp_kernel_op_55*tmp_moved_constant_1718) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1699 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1704 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1707) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1712 + tmp_kernel_op_60*tmp_moved_constant_1715 + tmp_kernel_op_61*tmp_moved_constant_1718) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1699 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1704 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1707) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1712 + tmp_kernel_op_66*tmp_moved_constant_1715 + tmp_kernel_op_67*tmp_moved_constant_1718) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1702 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1707 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1709) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1712 + tmp_kernel_op_72*tmp_moved_constant_1715 + tmp_kernel_op_73*tmp_moved_constant_1718) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1702 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1707 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1709) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1712 + tmp_kernel_op_78*tmp_moved_constant_1715 + tmp_kernel_op_79*tmp_moved_constant_1718) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1702 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1707 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1709) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1712 + tmp_kernel_op_84*tmp_moved_constant_1715 + tmp_kernel_op_85*tmp_moved_constant_1718);
             const real_t tmp_kernel_op_703 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1696 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1699 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1702) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1721 + tmp_kernel_op_120*tmp_moved_constant_1724 + tmp_kernel_op_122*tmp_moved_constant_1727) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1696 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1699 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1702) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1721 + tmp_kernel_op_127*tmp_moved_constant_1724 + tmp_kernel_op_128*tmp_moved_constant_1727) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1696 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1699 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1702) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1721 + tmp_kernel_op_133*tmp_moved_constant_1724 + tmp_kernel_op_134*tmp_moved_constant_1727) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1699 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1704 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1707) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1721 + tmp_kernel_op_139*tmp_moved_constant_1724 + tmp_kernel_op_140*tmp_moved_constant_1727) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1699 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1704 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1707) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1721 + tmp_kernel_op_145*tmp_moved_constant_1724 + tmp_kernel_op_146*tmp_moved_constant_1727) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1699 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1704 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1707) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1721 + tmp_kernel_op_151*tmp_moved_constant_1724 + tmp_kernel_op_152*tmp_moved_constant_1727) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1702 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1707 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1709) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1721 + tmp_kernel_op_157*tmp_moved_constant_1724 + tmp_kernel_op_158*tmp_moved_constant_1727) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1702 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1707 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1709) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1721 + tmp_kernel_op_163*tmp_moved_constant_1724 + tmp_kernel_op_164*tmp_moved_constant_1727) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1702 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1707 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1709) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1721 + tmp_kernel_op_169*tmp_moved_constant_1724 + tmp_kernel_op_170*tmp_moved_constant_1727);
             const real_t tmp_kernel_op_713 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1696 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1699 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1702) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1730 + tmp_kernel_op_205*tmp_moved_constant_1733 + tmp_kernel_op_207*tmp_moved_constant_1736) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1696 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1699 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1702) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1730 + tmp_kernel_op_212*tmp_moved_constant_1733 + tmp_kernel_op_213*tmp_moved_constant_1736) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1696 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1699 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1702) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1730 + tmp_kernel_op_218*tmp_moved_constant_1733 + tmp_kernel_op_219*tmp_moved_constant_1736) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1699 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1704 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1707) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1730 + tmp_kernel_op_224*tmp_moved_constant_1733 + tmp_kernel_op_225*tmp_moved_constant_1736) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1699 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1704 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1707) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1730 + tmp_kernel_op_230*tmp_moved_constant_1733 + tmp_kernel_op_231*tmp_moved_constant_1736) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1699 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1704 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1707) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1730 + tmp_kernel_op_236*tmp_moved_constant_1733 + tmp_kernel_op_237*tmp_moved_constant_1736) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1702 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1707 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1709) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1730 + tmp_kernel_op_242*tmp_moved_constant_1733 + tmp_kernel_op_243*tmp_moved_constant_1736) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1702 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1707 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1709) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1730 + tmp_kernel_op_248*tmp_moved_constant_1733 + tmp_kernel_op_249*tmp_moved_constant_1736) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1702 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1707 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1709) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1730 + tmp_kernel_op_254*tmp_moved_constant_1733 + tmp_kernel_op_255*tmp_moved_constant_1736);
             const real_t tmp_kernel_op_723 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1696 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1699 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1702) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1739 + tmp_kernel_op_290*tmp_moved_constant_1742 + tmp_kernel_op_292*tmp_moved_constant_1745) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1696 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1699 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1702) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1739 + tmp_kernel_op_297*tmp_moved_constant_1742 + tmp_kernel_op_298*tmp_moved_constant_1745) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1696 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1699 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1702) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1739 + tmp_kernel_op_303*tmp_moved_constant_1742 + tmp_kernel_op_304*tmp_moved_constant_1745) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1699 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1704 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1707) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1739 + tmp_kernel_op_309*tmp_moved_constant_1742 + tmp_kernel_op_310*tmp_moved_constant_1745) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1699 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1704 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1707) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1739 + tmp_kernel_op_315*tmp_moved_constant_1742 + tmp_kernel_op_316*tmp_moved_constant_1745) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1699 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1704 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1707) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1739 + tmp_kernel_op_321*tmp_moved_constant_1742 + tmp_kernel_op_322*tmp_moved_constant_1745) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1702 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1707 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1709) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1739 + tmp_kernel_op_327*tmp_moved_constant_1742 + tmp_kernel_op_328*tmp_moved_constant_1745) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1702 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1707 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1709) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1739 + tmp_kernel_op_333*tmp_moved_constant_1742 + tmp_kernel_op_334*tmp_moved_constant_1745) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1702 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1707 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1709) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1739 + tmp_kernel_op_339*tmp_moved_constant_1742 + tmp_kernel_op_340*tmp_moved_constant_1745);
             const real_t tmp_kernel_op_733 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1696 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1699 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1702) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1748 + tmp_kernel_op_375*tmp_moved_constant_1751 + tmp_kernel_op_377*tmp_moved_constant_1754) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1696 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1699 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1702) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1748 + tmp_kernel_op_382*tmp_moved_constant_1751 + tmp_kernel_op_383*tmp_moved_constant_1754) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1696 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1699 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1702) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1748 + tmp_kernel_op_388*tmp_moved_constant_1751 + tmp_kernel_op_389*tmp_moved_constant_1754) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1699 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1704 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1707) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1748 + tmp_kernel_op_394*tmp_moved_constant_1751 + tmp_kernel_op_395*tmp_moved_constant_1754) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1699 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1704 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1707) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1748 + tmp_kernel_op_400*tmp_moved_constant_1751 + tmp_kernel_op_401*tmp_moved_constant_1754) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1699 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1704 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1707) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1748 + tmp_kernel_op_406*tmp_moved_constant_1751 + tmp_kernel_op_407*tmp_moved_constant_1754) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1702 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1707 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1709) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1748 + tmp_kernel_op_412*tmp_moved_constant_1751 + tmp_kernel_op_413*tmp_moved_constant_1754) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1702 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1707 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1709) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1748 + tmp_kernel_op_418*tmp_moved_constant_1751 + tmp_kernel_op_419*tmp_moved_constant_1754) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1702 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1707 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1709) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1748 + tmp_kernel_op_424*tmp_moved_constant_1751 + tmp_kernel_op_425*tmp_moved_constant_1754);
             const real_t tmp_kernel_op_756 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1758 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1760 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1762) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1773 + tmp_kernel_op_35*tmp_moved_constant_1774 + tmp_kernel_op_37*tmp_moved_constant_1775) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1758 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1760 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1762) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1773 + tmp_kernel_op_42*tmp_moved_constant_1774 + tmp_kernel_op_43*tmp_moved_constant_1775) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1758 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1760 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1762) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1773 + tmp_kernel_op_48*tmp_moved_constant_1774 + tmp_kernel_op_49*tmp_moved_constant_1775) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1763 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1766 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1767) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1773 + tmp_kernel_op_54*tmp_moved_constant_1774 + tmp_kernel_op_55*tmp_moved_constant_1775) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1763 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1766 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1767) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1773 + tmp_kernel_op_60*tmp_moved_constant_1774 + tmp_kernel_op_61*tmp_moved_constant_1775) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1763 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1766 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1767) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1773 + tmp_kernel_op_66*tmp_moved_constant_1774 + tmp_kernel_op_67*tmp_moved_constant_1775) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1768 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1769 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1772) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1773 + tmp_kernel_op_72*tmp_moved_constant_1774 + tmp_kernel_op_73*tmp_moved_constant_1775) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1768 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1769 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1772) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1773 + tmp_kernel_op_78*tmp_moved_constant_1774 + tmp_kernel_op_79*tmp_moved_constant_1775) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1768 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1769 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1772) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1773 + tmp_kernel_op_84*tmp_moved_constant_1774 + tmp_kernel_op_85*tmp_moved_constant_1775);
             const real_t tmp_kernel_op_761 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1758 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1760 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1762) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1776 + tmp_kernel_op_120*tmp_moved_constant_1777 + tmp_kernel_op_122*tmp_moved_constant_1778) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1758 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1760 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1762) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1776 + tmp_kernel_op_127*tmp_moved_constant_1777 + tmp_kernel_op_128*tmp_moved_constant_1778) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1758 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1760 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1762) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1776 + tmp_kernel_op_133*tmp_moved_constant_1777 + tmp_kernel_op_134*tmp_moved_constant_1778) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1763 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1766 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1767) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1776 + tmp_kernel_op_139*tmp_moved_constant_1777 + tmp_kernel_op_140*tmp_moved_constant_1778) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1763 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1766 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1767) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1776 + tmp_kernel_op_145*tmp_moved_constant_1777 + tmp_kernel_op_146*tmp_moved_constant_1778) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1763 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1766 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1767) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1776 + tmp_kernel_op_151*tmp_moved_constant_1777 + tmp_kernel_op_152*tmp_moved_constant_1778) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1768 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1769 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1772) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1776 + tmp_kernel_op_157*tmp_moved_constant_1777 + tmp_kernel_op_158*tmp_moved_constant_1778) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1768 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1769 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1772) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1776 + tmp_kernel_op_163*tmp_moved_constant_1777 + tmp_kernel_op_164*tmp_moved_constant_1778) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1768 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1769 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1772) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1776 + tmp_kernel_op_169*tmp_moved_constant_1777 + tmp_kernel_op_170*tmp_moved_constant_1778);
             const real_t tmp_kernel_op_766 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1758 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1760 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1762) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1779 + tmp_kernel_op_205*tmp_moved_constant_1780 + tmp_kernel_op_207*tmp_moved_constant_1781) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1758 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1760 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1762) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1779 + tmp_kernel_op_212*tmp_moved_constant_1780 + tmp_kernel_op_213*tmp_moved_constant_1781) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1758 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1760 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1762) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1779 + tmp_kernel_op_218*tmp_moved_constant_1780 + tmp_kernel_op_219*tmp_moved_constant_1781) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1763 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1766 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1767) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1779 + tmp_kernel_op_224*tmp_moved_constant_1780 + tmp_kernel_op_225*tmp_moved_constant_1781) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1763 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1766 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1767) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1779 + tmp_kernel_op_230*tmp_moved_constant_1780 + tmp_kernel_op_231*tmp_moved_constant_1781) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1763 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1766 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1767) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1779 + tmp_kernel_op_236*tmp_moved_constant_1780 + tmp_kernel_op_237*tmp_moved_constant_1781) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1768 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1769 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1772) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1779 + tmp_kernel_op_242*tmp_moved_constant_1780 + tmp_kernel_op_243*tmp_moved_constant_1781) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1768 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1769 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1772) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1779 + tmp_kernel_op_248*tmp_moved_constant_1780 + tmp_kernel_op_249*tmp_moved_constant_1781) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1768 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1769 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1772) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1779 + tmp_kernel_op_254*tmp_moved_constant_1780 + tmp_kernel_op_255*tmp_moved_constant_1781);
             const real_t tmp_kernel_op_771 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1758 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1760 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1762) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1782 + tmp_kernel_op_290*tmp_moved_constant_1783 + tmp_kernel_op_292*tmp_moved_constant_1784) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1758 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1760 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1762) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1782 + tmp_kernel_op_297*tmp_moved_constant_1783 + tmp_kernel_op_298*tmp_moved_constant_1784) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1758 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1760 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1762) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1782 + tmp_kernel_op_303*tmp_moved_constant_1783 + tmp_kernel_op_304*tmp_moved_constant_1784) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1763 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1766 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1767) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1782 + tmp_kernel_op_309*tmp_moved_constant_1783 + tmp_kernel_op_310*tmp_moved_constant_1784) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1763 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1766 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1767) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1782 + tmp_kernel_op_315*tmp_moved_constant_1783 + tmp_kernel_op_316*tmp_moved_constant_1784) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1763 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1766 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1767) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1782 + tmp_kernel_op_321*tmp_moved_constant_1783 + tmp_kernel_op_322*tmp_moved_constant_1784) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1768 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1769 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1772) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1782 + tmp_kernel_op_327*tmp_moved_constant_1783 + tmp_kernel_op_328*tmp_moved_constant_1784) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1768 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1769 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1772) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1782 + tmp_kernel_op_333*tmp_moved_constant_1783 + tmp_kernel_op_334*tmp_moved_constant_1784) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1768 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1769 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1772) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1782 + tmp_kernel_op_339*tmp_moved_constant_1783 + tmp_kernel_op_340*tmp_moved_constant_1784);
             const real_t tmp_kernel_op_776 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1758 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1760 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1762) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1785 + tmp_kernel_op_375*tmp_moved_constant_1786 + tmp_kernel_op_377*tmp_moved_constant_1787) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1758 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1760 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1762) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1785 + tmp_kernel_op_382*tmp_moved_constant_1786 + tmp_kernel_op_383*tmp_moved_constant_1787) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1758 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1760 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1762) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1785 + tmp_kernel_op_388*tmp_moved_constant_1786 + tmp_kernel_op_389*tmp_moved_constant_1787) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1763 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1766 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1767) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1785 + tmp_kernel_op_394*tmp_moved_constant_1786 + tmp_kernel_op_395*tmp_moved_constant_1787) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1763 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1766 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1767) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1785 + tmp_kernel_op_400*tmp_moved_constant_1786 + tmp_kernel_op_401*tmp_moved_constant_1787) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1763 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1766 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1767) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1785 + tmp_kernel_op_406*tmp_moved_constant_1786 + tmp_kernel_op_407*tmp_moved_constant_1787) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1768 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1769 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1772) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1785 + tmp_kernel_op_412*tmp_moved_constant_1786 + tmp_kernel_op_413*tmp_moved_constant_1787) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1768 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1769 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1772) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1785 + tmp_kernel_op_418*tmp_moved_constant_1786 + tmp_kernel_op_419*tmp_moved_constant_1787) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1768 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1769 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1772) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1785 + tmp_kernel_op_424*tmp_moved_constant_1786 + tmp_kernel_op_425*tmp_moved_constant_1787);
             const real_t tmp_kernel_op_797 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1790 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1792 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1794) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1803 + tmp_kernel_op_35*tmp_moved_constant_1804 + tmp_kernel_op_37*tmp_moved_constant_1805) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1790 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1792 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1794) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1803 + tmp_kernel_op_42*tmp_moved_constant_1804 + tmp_kernel_op_43*tmp_moved_constant_1805) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1790 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1792 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1794) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1803 + tmp_kernel_op_48*tmp_moved_constant_1804 + tmp_kernel_op_49*tmp_moved_constant_1805) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1795 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1797 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1798) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1803 + tmp_kernel_op_54*tmp_moved_constant_1804 + tmp_kernel_op_55*tmp_moved_constant_1805) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1795 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1797 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1798) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1803 + tmp_kernel_op_60*tmp_moved_constant_1804 + tmp_kernel_op_61*tmp_moved_constant_1805) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1795 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1797 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1798) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1803 + tmp_kernel_op_66*tmp_moved_constant_1804 + tmp_kernel_op_67*tmp_moved_constant_1805) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1799 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1800 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1802) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1803 + tmp_kernel_op_72*tmp_moved_constant_1804 + tmp_kernel_op_73*tmp_moved_constant_1805) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1799 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1800 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1802) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1803 + tmp_kernel_op_78*tmp_moved_constant_1804 + tmp_kernel_op_79*tmp_moved_constant_1805) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1799 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1800 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1802) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1803 + tmp_kernel_op_84*tmp_moved_constant_1804 + tmp_kernel_op_85*tmp_moved_constant_1805);
             const real_t tmp_kernel_op_803 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1790 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1792 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1794) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1806 + tmp_kernel_op_120*tmp_moved_constant_1807 + tmp_kernel_op_122*tmp_moved_constant_1808) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1790 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1792 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1794) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1806 + tmp_kernel_op_127*tmp_moved_constant_1807 + tmp_kernel_op_128*tmp_moved_constant_1808) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1790 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1792 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1794) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1806 + tmp_kernel_op_133*tmp_moved_constant_1807 + tmp_kernel_op_134*tmp_moved_constant_1808) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1795 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1797 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1798) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1806 + tmp_kernel_op_139*tmp_moved_constant_1807 + tmp_kernel_op_140*tmp_moved_constant_1808) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1795 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1797 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1798) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1806 + tmp_kernel_op_145*tmp_moved_constant_1807 + tmp_kernel_op_146*tmp_moved_constant_1808) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1795 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1797 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1798) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1806 + tmp_kernel_op_151*tmp_moved_constant_1807 + tmp_kernel_op_152*tmp_moved_constant_1808) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1799 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1800 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1802) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1806 + tmp_kernel_op_157*tmp_moved_constant_1807 + tmp_kernel_op_158*tmp_moved_constant_1808) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1799 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1800 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1802) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1806 + tmp_kernel_op_163*tmp_moved_constant_1807 + tmp_kernel_op_164*tmp_moved_constant_1808) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1799 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1800 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1802) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1806 + tmp_kernel_op_169*tmp_moved_constant_1807 + tmp_kernel_op_170*tmp_moved_constant_1808);
             const real_t tmp_kernel_op_809 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1790 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1792 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1794) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1809 + tmp_kernel_op_205*tmp_moved_constant_1810 + tmp_kernel_op_207*tmp_moved_constant_1811) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1790 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1792 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1794) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1809 + tmp_kernel_op_212*tmp_moved_constant_1810 + tmp_kernel_op_213*tmp_moved_constant_1811) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1790 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1792 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1794) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1809 + tmp_kernel_op_218*tmp_moved_constant_1810 + tmp_kernel_op_219*tmp_moved_constant_1811) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1795 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1797 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1798) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1809 + tmp_kernel_op_224*tmp_moved_constant_1810 + tmp_kernel_op_225*tmp_moved_constant_1811) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1795 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1797 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1798) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1809 + tmp_kernel_op_230*tmp_moved_constant_1810 + tmp_kernel_op_231*tmp_moved_constant_1811) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1795 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1797 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1798) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1809 + tmp_kernel_op_236*tmp_moved_constant_1810 + tmp_kernel_op_237*tmp_moved_constant_1811) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1799 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1800 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1802) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1809 + tmp_kernel_op_242*tmp_moved_constant_1810 + tmp_kernel_op_243*tmp_moved_constant_1811) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1799 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1800 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1802) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1809 + tmp_kernel_op_248*tmp_moved_constant_1810 + tmp_kernel_op_249*tmp_moved_constant_1811) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1799 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1800 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1802) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1809 + tmp_kernel_op_254*tmp_moved_constant_1810 + tmp_kernel_op_255*tmp_moved_constant_1811);
             const real_t tmp_kernel_op_815 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1790 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1792 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1794) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1812 + tmp_kernel_op_290*tmp_moved_constant_1813 + tmp_kernel_op_292*tmp_moved_constant_1814) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1790 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1792 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1794) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1812 + tmp_kernel_op_297*tmp_moved_constant_1813 + tmp_kernel_op_298*tmp_moved_constant_1814) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1790 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1792 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1794) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1812 + tmp_kernel_op_303*tmp_moved_constant_1813 + tmp_kernel_op_304*tmp_moved_constant_1814) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1795 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1797 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1798) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1812 + tmp_kernel_op_309*tmp_moved_constant_1813 + tmp_kernel_op_310*tmp_moved_constant_1814) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1795 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1797 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1798) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1812 + tmp_kernel_op_315*tmp_moved_constant_1813 + tmp_kernel_op_316*tmp_moved_constant_1814) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1795 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1797 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1798) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1812 + tmp_kernel_op_321*tmp_moved_constant_1813 + tmp_kernel_op_322*tmp_moved_constant_1814) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1799 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1800 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1802) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1812 + tmp_kernel_op_327*tmp_moved_constant_1813 + tmp_kernel_op_328*tmp_moved_constant_1814) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1799 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1800 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1802) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1812 + tmp_kernel_op_333*tmp_moved_constant_1813 + tmp_kernel_op_334*tmp_moved_constant_1814) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1799 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1800 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1802) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1812 + tmp_kernel_op_339*tmp_moved_constant_1813 + tmp_kernel_op_340*tmp_moved_constant_1814);
             const real_t tmp_kernel_op_821 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1790 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1792 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1794) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1815 + tmp_kernel_op_375*tmp_moved_constant_1816 + tmp_kernel_op_377*tmp_moved_constant_1817) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1790 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1792 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1794) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1815 + tmp_kernel_op_382*tmp_moved_constant_1816 + tmp_kernel_op_383*tmp_moved_constant_1817) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1790 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1792 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1794) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1815 + tmp_kernel_op_388*tmp_moved_constant_1816 + tmp_kernel_op_389*tmp_moved_constant_1817) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1795 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1797 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1798) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1815 + tmp_kernel_op_394*tmp_moved_constant_1816 + tmp_kernel_op_395*tmp_moved_constant_1817) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1795 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1797 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1798) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1815 + tmp_kernel_op_400*tmp_moved_constant_1816 + tmp_kernel_op_401*tmp_moved_constant_1817) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1795 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1797 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1798) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1815 + tmp_kernel_op_406*tmp_moved_constant_1816 + tmp_kernel_op_407*tmp_moved_constant_1817) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1799 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1800 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1802) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1815 + tmp_kernel_op_412*tmp_moved_constant_1816 + tmp_kernel_op_413*tmp_moved_constant_1817) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1799 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1800 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1802) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1815 + tmp_kernel_op_418*tmp_moved_constant_1816 + tmp_kernel_op_419*tmp_moved_constant_1817) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1799 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1800 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1802) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1815 + tmp_kernel_op_424*tmp_moved_constant_1816 + tmp_kernel_op_425*tmp_moved_constant_1817);
             const real_t tmp_kernel_op_838 = jac_blending_inv_0_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1819 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1821 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1823) + jac_blending_inv_0_0_q_0*(tmp_kernel_op_33*tmp_moved_constant_1830 + tmp_kernel_op_35*tmp_moved_constant_1831 + tmp_kernel_op_37*tmp_moved_constant_1832) + jac_blending_inv_0_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1819 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1821 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1823) + jac_blending_inv_0_1_q_0*(tmp_kernel_op_41*tmp_moved_constant_1830 + tmp_kernel_op_42*tmp_moved_constant_1831 + tmp_kernel_op_43*tmp_moved_constant_1832) + jac_blending_inv_0_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1819 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1821 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1823) + jac_blending_inv_0_2_q_0*(tmp_kernel_op_47*tmp_moved_constant_1830 + tmp_kernel_op_48*tmp_moved_constant_1831 + tmp_kernel_op_49*tmp_moved_constant_1832) + jac_blending_inv_1_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1824 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1825 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1826) + jac_blending_inv_1_0_q_0*(tmp_kernel_op_53*tmp_moved_constant_1830 + tmp_kernel_op_54*tmp_moved_constant_1831 + tmp_kernel_op_55*tmp_moved_constant_1832) + jac_blending_inv_1_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1824 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1825 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1826) + jac_blending_inv_1_1_q_0*(tmp_kernel_op_59*tmp_moved_constant_1830 + tmp_kernel_op_60*tmp_moved_constant_1831 + tmp_kernel_op_61*tmp_moved_constant_1832) + jac_blending_inv_1_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1824 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1825 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1826) + jac_blending_inv_1_2_q_0*(tmp_kernel_op_65*tmp_moved_constant_1830 + tmp_kernel_op_66*tmp_moved_constant_1831 + tmp_kernel_op_67*tmp_moved_constant_1832) + jac_blending_inv_2_0_q_0*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1827 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1828 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1829) + jac_blending_inv_2_0_q_0*(tmp_kernel_op_71*tmp_moved_constant_1830 + tmp_kernel_op_72*tmp_moved_constant_1831 + tmp_kernel_op_73*tmp_moved_constant_1832) + jac_blending_inv_2_1_q_0*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1827 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1828 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1829) + jac_blending_inv_2_1_q_0*(tmp_kernel_op_77*tmp_moved_constant_1830 + tmp_kernel_op_78*tmp_moved_constant_1831 + tmp_kernel_op_79*tmp_moved_constant_1832) + jac_blending_inv_2_2_q_0*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1827 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1828 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1829) + jac_blending_inv_2_2_q_0*(tmp_kernel_op_83*tmp_moved_constant_1830 + tmp_kernel_op_84*tmp_moved_constant_1831 + tmp_kernel_op_85*tmp_moved_constant_1832);
             const real_t tmp_kernel_op_843 = jac_blending_inv_0_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1819 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1821 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1823) + jac_blending_inv_0_0_q_1*(tmp_kernel_op_118*tmp_moved_constant_1833 + tmp_kernel_op_120*tmp_moved_constant_1834 + tmp_kernel_op_122*tmp_moved_constant_1835) + jac_blending_inv_0_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1819 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1821 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1823) + jac_blending_inv_0_1_q_1*(tmp_kernel_op_126*tmp_moved_constant_1833 + tmp_kernel_op_127*tmp_moved_constant_1834 + tmp_kernel_op_128*tmp_moved_constant_1835) + jac_blending_inv_0_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1819 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1821 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1823) + jac_blending_inv_0_2_q_1*(tmp_kernel_op_132*tmp_moved_constant_1833 + tmp_kernel_op_133*tmp_moved_constant_1834 + tmp_kernel_op_134*tmp_moved_constant_1835) + jac_blending_inv_1_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1824 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1825 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1826) + jac_blending_inv_1_0_q_1*(tmp_kernel_op_138*tmp_moved_constant_1833 + tmp_kernel_op_139*tmp_moved_constant_1834 + tmp_kernel_op_140*tmp_moved_constant_1835) + jac_blending_inv_1_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1824 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1825 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1826) + jac_blending_inv_1_1_q_1*(tmp_kernel_op_144*tmp_moved_constant_1833 + tmp_kernel_op_145*tmp_moved_constant_1834 + tmp_kernel_op_146*tmp_moved_constant_1835) + jac_blending_inv_1_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1824 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1825 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1826) + jac_blending_inv_1_2_q_1*(tmp_kernel_op_150*tmp_moved_constant_1833 + tmp_kernel_op_151*tmp_moved_constant_1834 + tmp_kernel_op_152*tmp_moved_constant_1835) + jac_blending_inv_2_0_q_1*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1827 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1828 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1829) + jac_blending_inv_2_0_q_1*(tmp_kernel_op_156*tmp_moved_constant_1833 + tmp_kernel_op_157*tmp_moved_constant_1834 + tmp_kernel_op_158*tmp_moved_constant_1835) + jac_blending_inv_2_1_q_1*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1827 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1828 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1829) + jac_blending_inv_2_1_q_1*(tmp_kernel_op_162*tmp_moved_constant_1833 + tmp_kernel_op_163*tmp_moved_constant_1834 + tmp_kernel_op_164*tmp_moved_constant_1835) + jac_blending_inv_2_2_q_1*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1827 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1828 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1829) + jac_blending_inv_2_2_q_1*(tmp_kernel_op_168*tmp_moved_constant_1833 + tmp_kernel_op_169*tmp_moved_constant_1834 + tmp_kernel_op_170*tmp_moved_constant_1835);
             const real_t tmp_kernel_op_848 = jac_blending_inv_0_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1819 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1821 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1823) + jac_blending_inv_0_0_q_2*(tmp_kernel_op_203*tmp_moved_constant_1836 + tmp_kernel_op_205*tmp_moved_constant_1837 + tmp_kernel_op_207*tmp_moved_constant_1838) + jac_blending_inv_0_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1819 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1821 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1823) + jac_blending_inv_0_1_q_2*(tmp_kernel_op_211*tmp_moved_constant_1836 + tmp_kernel_op_212*tmp_moved_constant_1837 + tmp_kernel_op_213*tmp_moved_constant_1838) + jac_blending_inv_0_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1819 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1821 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1823) + jac_blending_inv_0_2_q_2*(tmp_kernel_op_217*tmp_moved_constant_1836 + tmp_kernel_op_218*tmp_moved_constant_1837 + tmp_kernel_op_219*tmp_moved_constant_1838) + jac_blending_inv_1_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1824 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1825 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1826) + jac_blending_inv_1_0_q_2*(tmp_kernel_op_223*tmp_moved_constant_1836 + tmp_kernel_op_224*tmp_moved_constant_1837 + tmp_kernel_op_225*tmp_moved_constant_1838) + jac_blending_inv_1_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1824 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1825 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1826) + jac_blending_inv_1_1_q_2*(tmp_kernel_op_229*tmp_moved_constant_1836 + tmp_kernel_op_230*tmp_moved_constant_1837 + tmp_kernel_op_231*tmp_moved_constant_1838) + jac_blending_inv_1_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1824 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1825 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1826) + jac_blending_inv_1_2_q_2*(tmp_kernel_op_235*tmp_moved_constant_1836 + tmp_kernel_op_236*tmp_moved_constant_1837 + tmp_kernel_op_237*tmp_moved_constant_1838) + jac_blending_inv_2_0_q_2*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1827 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1828 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1829) + jac_blending_inv_2_0_q_2*(tmp_kernel_op_241*tmp_moved_constant_1836 + tmp_kernel_op_242*tmp_moved_constant_1837 + tmp_kernel_op_243*tmp_moved_constant_1838) + jac_blending_inv_2_1_q_2*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1827 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1828 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1829) + jac_blending_inv_2_1_q_2*(tmp_kernel_op_247*tmp_moved_constant_1836 + tmp_kernel_op_248*tmp_moved_constant_1837 + tmp_kernel_op_249*tmp_moved_constant_1838) + jac_blending_inv_2_2_q_2*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1827 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1828 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1829) + jac_blending_inv_2_2_q_2*(tmp_kernel_op_253*tmp_moved_constant_1836 + tmp_kernel_op_254*tmp_moved_constant_1837 + tmp_kernel_op_255*tmp_moved_constant_1838);
             const real_t tmp_kernel_op_853 = jac_blending_inv_0_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1819 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1821 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1823) + jac_blending_inv_0_0_q_3*(tmp_kernel_op_288*tmp_moved_constant_1839 + tmp_kernel_op_290*tmp_moved_constant_1840 + tmp_kernel_op_292*tmp_moved_constant_1841) + jac_blending_inv_0_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1819 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1821 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1823) + jac_blending_inv_0_1_q_3*(tmp_kernel_op_296*tmp_moved_constant_1839 + tmp_kernel_op_297*tmp_moved_constant_1840 + tmp_kernel_op_298*tmp_moved_constant_1841) + jac_blending_inv_0_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1819 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1821 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1823) + jac_blending_inv_0_2_q_3*(tmp_kernel_op_302*tmp_moved_constant_1839 + tmp_kernel_op_303*tmp_moved_constant_1840 + tmp_kernel_op_304*tmp_moved_constant_1841) + jac_blending_inv_1_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1824 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1825 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1826) + jac_blending_inv_1_0_q_3*(tmp_kernel_op_308*tmp_moved_constant_1839 + tmp_kernel_op_309*tmp_moved_constant_1840 + tmp_kernel_op_310*tmp_moved_constant_1841) + jac_blending_inv_1_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1824 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1825 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1826) + jac_blending_inv_1_1_q_3*(tmp_kernel_op_314*tmp_moved_constant_1839 + tmp_kernel_op_315*tmp_moved_constant_1840 + tmp_kernel_op_316*tmp_moved_constant_1841) + jac_blending_inv_1_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1824 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1825 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1826) + jac_blending_inv_1_2_q_3*(tmp_kernel_op_320*tmp_moved_constant_1839 + tmp_kernel_op_321*tmp_moved_constant_1840 + tmp_kernel_op_322*tmp_moved_constant_1841) + jac_blending_inv_2_0_q_3*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1827 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1828 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1829) + jac_blending_inv_2_0_q_3*(tmp_kernel_op_326*tmp_moved_constant_1839 + tmp_kernel_op_327*tmp_moved_constant_1840 + tmp_kernel_op_328*tmp_moved_constant_1841) + jac_blending_inv_2_1_q_3*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1827 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1828 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1829) + jac_blending_inv_2_1_q_3*(tmp_kernel_op_332*tmp_moved_constant_1839 + tmp_kernel_op_333*tmp_moved_constant_1840 + tmp_kernel_op_334*tmp_moved_constant_1841) + jac_blending_inv_2_2_q_3*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1827 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1828 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1829) + jac_blending_inv_2_2_q_3*(tmp_kernel_op_338*tmp_moved_constant_1839 + tmp_kernel_op_339*tmp_moved_constant_1840 + tmp_kernel_op_340*tmp_moved_constant_1841);
             const real_t tmp_kernel_op_858 = jac_blending_inv_0_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1819 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1821 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1823) + jac_blending_inv_0_0_q_4*(tmp_kernel_op_373*tmp_moved_constant_1842 + tmp_kernel_op_375*tmp_moved_constant_1843 + tmp_kernel_op_377*tmp_moved_constant_1844) + jac_blending_inv_0_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1819 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1821 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1823) + jac_blending_inv_0_1_q_4*(tmp_kernel_op_381*tmp_moved_constant_1842 + tmp_kernel_op_382*tmp_moved_constant_1843 + tmp_kernel_op_383*tmp_moved_constant_1844) + jac_blending_inv_0_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1819 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1821 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1823) + jac_blending_inv_0_2_q_4*(tmp_kernel_op_387*tmp_moved_constant_1842 + tmp_kernel_op_388*tmp_moved_constant_1843 + tmp_kernel_op_389*tmp_moved_constant_1844) + jac_blending_inv_1_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1824 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1825 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1826) + jac_blending_inv_1_0_q_4*(tmp_kernel_op_393*tmp_moved_constant_1842 + tmp_kernel_op_394*tmp_moved_constant_1843 + tmp_kernel_op_395*tmp_moved_constant_1844) + jac_blending_inv_1_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1824 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1825 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1826) + jac_blending_inv_1_1_q_4*(tmp_kernel_op_399*tmp_moved_constant_1842 + tmp_kernel_op_400*tmp_moved_constant_1843 + tmp_kernel_op_401*tmp_moved_constant_1844) + jac_blending_inv_1_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1824 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1825 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1826) + jac_blending_inv_1_2_q_4*(tmp_kernel_op_405*tmp_moved_constant_1842 + tmp_kernel_op_406*tmp_moved_constant_1843 + tmp_kernel_op_407*tmp_moved_constant_1844) + jac_blending_inv_2_0_q_4*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1827 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1828 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1829) + jac_blending_inv_2_0_q_4*(tmp_kernel_op_411*tmp_moved_constant_1842 + tmp_kernel_op_412*tmp_moved_constant_1843 + tmp_kernel_op_413*tmp_moved_constant_1844) + jac_blending_inv_2_1_q_4*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1827 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1828 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1829) + jac_blending_inv_2_1_q_4*(tmp_kernel_op_417*tmp_moved_constant_1842 + tmp_kernel_op_418*tmp_moved_constant_1843 + tmp_kernel_op_419*tmp_moved_constant_1844) + jac_blending_inv_2_2_q_4*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1827 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1828 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1829) + jac_blending_inv_2_2_q_4*(tmp_kernel_op_423*tmp_moved_constant_1842 + tmp_kernel_op_424*tmp_moved_constant_1843 + tmp_kernel_op_425*tmp_moved_constant_1844);
             const real_t tmp_kernel_op_859 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1521 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1522 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1523) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1521 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1522 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1523) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1521 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1522 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1523));
             const real_t tmp_kernel_op_860 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1524 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1525 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1526) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1524 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1525 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1526) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1524 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1525 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1526));
             const real_t tmp_kernel_op_861 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1527 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1528 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1529) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1527 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1528 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1529) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1527 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1528 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1529));
             const real_t tmp_kernel_op_862 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1530 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1531 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1532) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1530 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1531 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1532) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1530 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1531 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1532));
             const real_t tmp_kernel_op_863 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1533 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1534 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1535) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1533 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1534 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1535) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1533 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1534 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1535));
             const real_t tmp_kernel_op_864 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1542 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1543 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1544) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1542 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1543 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1544) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1542 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1543 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1544));
             const real_t tmp_kernel_op_865 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1545 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1546 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1547) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1545 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1546 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1547) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1545 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1546 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1547));
             const real_t tmp_kernel_op_866 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1548 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1549 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1550) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1548 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1549 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1550) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1548 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1549 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1550));
             const real_t tmp_kernel_op_867 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1551 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1552 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1553) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1551 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1552 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1553) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1551 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1552 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1553));
             const real_t tmp_kernel_op_868 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1554 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1555 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1556) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1554 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1555 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1556) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1554 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1555 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1556));
             const real_t tmp_kernel_op_869 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1563 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1564 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1565) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1563 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1564 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1565) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1563 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1564 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1565));
             const real_t tmp_kernel_op_870 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1566 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1567 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1568) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1566 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1567 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1568) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1566 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1567 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1568));
             const real_t tmp_kernel_op_871 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1569 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1570 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1571) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1569 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1570 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1571) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1569 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1570 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1571));
             const real_t tmp_kernel_op_872 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1572 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1573 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1574) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1572 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1573 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1574) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1572 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1573 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1574));
             const real_t tmp_kernel_op_873 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1575 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1576 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1577) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1575 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1576 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1577) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1575 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1576 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1577));
             const real_t tmp_kernel_op_874 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1595 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1598 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1601) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1595 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1598 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1601) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1595 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1598 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1601));
             const real_t tmp_kernel_op_875 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1604 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1607 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1610) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1604 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1607 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1610) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1604 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1607 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1610));
             const real_t tmp_kernel_op_876 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1613 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1616 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1619) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1613 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1616 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1619) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1613 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1616 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1619));
             const real_t tmp_kernel_op_877 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1622 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1625 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1628) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1622 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1625 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1628) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1622 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1625 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1628));
             const real_t tmp_kernel_op_878 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1631 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1634 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1637) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1631 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1634 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1637) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1631 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1634 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1637));
             const real_t tmp_kernel_op_879 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1652 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1655 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1658) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1652 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1655 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1658) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1652 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1655 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1658));
             const real_t tmp_kernel_op_880 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1661 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1664 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1667) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1661 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1664 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1667) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1661 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1664 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1667));
             const real_t tmp_kernel_op_881 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1670 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1673 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1676) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1670 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1673 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1676) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1670 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1673 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1676));
             const real_t tmp_kernel_op_882 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1679 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1682 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1685) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1679 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1682 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1685) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1679 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1682 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1685));
             const real_t tmp_kernel_op_883 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1688 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1691 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1694) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1688 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1691 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1694) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1688 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1691 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1694));
             const real_t tmp_kernel_op_884 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1712 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1715 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1718) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1712 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1715 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1718) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1712 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1715 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1718));
             const real_t tmp_kernel_op_885 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1721 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1724 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1727) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1721 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1724 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1727) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1721 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1724 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1727));
             const real_t tmp_kernel_op_886 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1730 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1733 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1736) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1730 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1733 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1736) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1730 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1733 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1736));
             const real_t tmp_kernel_op_887 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1739 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1742 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1745) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1739 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1742 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1745) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1739 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1742 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1745));
             const real_t tmp_kernel_op_888 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1748 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1751 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1754) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1748 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1751 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1754) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1748 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1751 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1754));
             const real_t tmp_kernel_op_889 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1773 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1774 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1775) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1773 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1774 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1775) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1773 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1774 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1775));
             const real_t tmp_kernel_op_890 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1776 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1777 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1778) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1776 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1777 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1778) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1776 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1777 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1778));
             const real_t tmp_kernel_op_891 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1779 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1780 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1781) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1779 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1780 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1781) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1779 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1780 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1781));
             const real_t tmp_kernel_op_892 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1782 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1783 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1784) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1782 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1783 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1784) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1782 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1783 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1784));
             const real_t tmp_kernel_op_893 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1785 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1786 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1787) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1785 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1786 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1787) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1785 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1786 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1787));
             const real_t tmp_kernel_op_894 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1803 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1804 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1805) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1803 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1804 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1805) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1803 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1804 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1805));
             const real_t tmp_kernel_op_895 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1806 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1807 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1808) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1806 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1807 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1808) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1806 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1807 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1808));
             const real_t tmp_kernel_op_896 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1809 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1810 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1811) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1809 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1810 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1811) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1809 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1810 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1811));
             const real_t tmp_kernel_op_897 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1812 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1813 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1814) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1812 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1813 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1814) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1812 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1813 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1814));
             const real_t tmp_kernel_op_898 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1815 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1816 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1817) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1815 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1816 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1817) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1815 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1816 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1817));
             const real_t tmp_kernel_op_899 = tmp_kernel_op_107*(tmp_kernel_op_104*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1830 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1831 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1832) + tmp_kernel_op_105*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1830 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1831 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1832) + tmp_kernel_op_106*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1830 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1831 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1832));
             const real_t tmp_kernel_op_900 = tmp_kernel_op_192*(tmp_kernel_op_189*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1833 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1834 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1835) + tmp_kernel_op_190*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1833 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1834 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1835) + tmp_kernel_op_191*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1833 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1834 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1835));
             const real_t tmp_kernel_op_901 = tmp_kernel_op_277*(tmp_kernel_op_274*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1836 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1837 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1838) + tmp_kernel_op_275*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1836 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1837 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1838) + tmp_kernel_op_276*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1836 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1837 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1838));
             const real_t tmp_kernel_op_902 = tmp_kernel_op_362*(tmp_kernel_op_359*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1839 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1840 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1841) + tmp_kernel_op_360*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1839 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1840 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1841) + tmp_kernel_op_361*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1839 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1840 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1841));
             const real_t tmp_kernel_op_903 = tmp_kernel_op_447*(tmp_kernel_op_444*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1842 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1843 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1844) + tmp_kernel_op_445*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1842 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1843 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1844) + tmp_kernel_op_446*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1842 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1843 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1844));
             const real_t elMat_0_0 = tmp_kernel_op_108*tmp_kernel_op_86 + tmp_kernel_op_171*tmp_kernel_op_193 + tmp_kernel_op_256*tmp_kernel_op_278 + tmp_kernel_op_341*tmp_kernel_op_363 + tmp_kernel_op_426*tmp_kernel_op_448;
             const real_t elMat_0_1 = tmp_kernel_op_108*tmp_kernel_op_459 + tmp_kernel_op_193*tmp_kernel_op_464 + tmp_kernel_op_278*tmp_kernel_op_469 + tmp_kernel_op_363*tmp_kernel_op_474 + tmp_kernel_op_448*tmp_kernel_op_479;
             const real_t elMat_0_2 = tmp_kernel_op_108*tmp_kernel_op_490 + tmp_kernel_op_193*tmp_kernel_op_495 + tmp_kernel_op_278*tmp_kernel_op_500 + tmp_kernel_op_363*tmp_kernel_op_505 + tmp_kernel_op_448*tmp_kernel_op_510;
             const real_t elMat_0_3 = tmp_kernel_op_108*tmp_kernel_op_521 + tmp_kernel_op_193*tmp_kernel_op_526 + tmp_kernel_op_278*tmp_kernel_op_531 + tmp_kernel_op_363*tmp_kernel_op_536 + tmp_kernel_op_448*tmp_kernel_op_541;
             const real_t elMat_0_4 = tmp_kernel_op_108*tmp_kernel_op_566 + tmp_kernel_op_193*tmp_kernel_op_576 + tmp_kernel_op_278*tmp_kernel_op_586 + tmp_kernel_op_363*tmp_kernel_op_596 + tmp_kernel_op_448*tmp_kernel_op_606;
             const real_t elMat_0_5 = tmp_kernel_op_108*tmp_kernel_op_628 + tmp_kernel_op_193*tmp_kernel_op_638 + tmp_kernel_op_278*tmp_kernel_op_648 + tmp_kernel_op_363*tmp_kernel_op_658 + tmp_kernel_op_448*tmp_kernel_op_668;
             const real_t elMat_0_6 = tmp_kernel_op_108*tmp_kernel_op_693 + tmp_kernel_op_193*tmp_kernel_op_703 + tmp_kernel_op_278*tmp_kernel_op_713 + tmp_kernel_op_363*tmp_kernel_op_723 + tmp_kernel_op_448*tmp_kernel_op_733;
             const real_t elMat_0_7 = tmp_kernel_op_108*tmp_kernel_op_756 + tmp_kernel_op_193*tmp_kernel_op_761 + tmp_kernel_op_278*tmp_kernel_op_766 + tmp_kernel_op_363*tmp_kernel_op_771 + tmp_kernel_op_448*tmp_kernel_op_776;
             const real_t elMat_0_8 = tmp_kernel_op_108*tmp_kernel_op_797 + tmp_kernel_op_193*tmp_kernel_op_803 + tmp_kernel_op_278*tmp_kernel_op_809 + tmp_kernel_op_363*tmp_kernel_op_815 + tmp_kernel_op_448*tmp_kernel_op_821;
             const real_t elMat_0_9 = tmp_kernel_op_108*tmp_kernel_op_838 + tmp_kernel_op_193*tmp_kernel_op_843 + tmp_kernel_op_278*tmp_kernel_op_848 + tmp_kernel_op_363*tmp_kernel_op_853 + tmp_kernel_op_448*tmp_kernel_op_858;
             const real_t elMat_1_0 = tmp_kernel_op_171*tmp_kernel_op_860 + tmp_kernel_op_256*tmp_kernel_op_861 + tmp_kernel_op_341*tmp_kernel_op_862 + tmp_kernel_op_426*tmp_kernel_op_863 + tmp_kernel_op_859*tmp_kernel_op_86;
             const real_t elMat_1_1 = tmp_kernel_op_459*tmp_kernel_op_859 + tmp_kernel_op_464*tmp_kernel_op_860 + tmp_kernel_op_469*tmp_kernel_op_861 + tmp_kernel_op_474*tmp_kernel_op_862 + tmp_kernel_op_479*tmp_kernel_op_863;
             const real_t elMat_1_2 = tmp_kernel_op_490*tmp_kernel_op_859 + tmp_kernel_op_495*tmp_kernel_op_860 + tmp_kernel_op_500*tmp_kernel_op_861 + tmp_kernel_op_505*tmp_kernel_op_862 + tmp_kernel_op_510*tmp_kernel_op_863;
             const real_t elMat_1_3 = tmp_kernel_op_521*tmp_kernel_op_859 + tmp_kernel_op_526*tmp_kernel_op_860 + tmp_kernel_op_531*tmp_kernel_op_861 + tmp_kernel_op_536*tmp_kernel_op_862 + tmp_kernel_op_541*tmp_kernel_op_863;
             const real_t elMat_1_4 = tmp_kernel_op_566*tmp_kernel_op_859 + tmp_kernel_op_576*tmp_kernel_op_860 + tmp_kernel_op_586*tmp_kernel_op_861 + tmp_kernel_op_596*tmp_kernel_op_862 + tmp_kernel_op_606*tmp_kernel_op_863;
             const real_t elMat_1_5 = tmp_kernel_op_628*tmp_kernel_op_859 + tmp_kernel_op_638*tmp_kernel_op_860 + tmp_kernel_op_648*tmp_kernel_op_861 + tmp_kernel_op_658*tmp_kernel_op_862 + tmp_kernel_op_668*tmp_kernel_op_863;
             const real_t elMat_1_6 = tmp_kernel_op_693*tmp_kernel_op_859 + tmp_kernel_op_703*tmp_kernel_op_860 + tmp_kernel_op_713*tmp_kernel_op_861 + tmp_kernel_op_723*tmp_kernel_op_862 + tmp_kernel_op_733*tmp_kernel_op_863;
             const real_t elMat_1_7 = tmp_kernel_op_756*tmp_kernel_op_859 + tmp_kernel_op_761*tmp_kernel_op_860 + tmp_kernel_op_766*tmp_kernel_op_861 + tmp_kernel_op_771*tmp_kernel_op_862 + tmp_kernel_op_776*tmp_kernel_op_863;
             const real_t elMat_1_8 = tmp_kernel_op_797*tmp_kernel_op_859 + tmp_kernel_op_803*tmp_kernel_op_860 + tmp_kernel_op_809*tmp_kernel_op_861 + tmp_kernel_op_815*tmp_kernel_op_862 + tmp_kernel_op_821*tmp_kernel_op_863;
             const real_t elMat_1_9 = tmp_kernel_op_838*tmp_kernel_op_859 + tmp_kernel_op_843*tmp_kernel_op_860 + tmp_kernel_op_848*tmp_kernel_op_861 + tmp_kernel_op_853*tmp_kernel_op_862 + tmp_kernel_op_858*tmp_kernel_op_863;
             const real_t elMat_2_0 = tmp_kernel_op_171*tmp_kernel_op_865 + tmp_kernel_op_256*tmp_kernel_op_866 + tmp_kernel_op_341*tmp_kernel_op_867 + tmp_kernel_op_426*tmp_kernel_op_868 + tmp_kernel_op_86*tmp_kernel_op_864;
             const real_t elMat_2_1 = tmp_kernel_op_459*tmp_kernel_op_864 + tmp_kernel_op_464*tmp_kernel_op_865 + tmp_kernel_op_469*tmp_kernel_op_866 + tmp_kernel_op_474*tmp_kernel_op_867 + tmp_kernel_op_479*tmp_kernel_op_868;
             const real_t elMat_2_2 = tmp_kernel_op_490*tmp_kernel_op_864 + tmp_kernel_op_495*tmp_kernel_op_865 + tmp_kernel_op_500*tmp_kernel_op_866 + tmp_kernel_op_505*tmp_kernel_op_867 + tmp_kernel_op_510*tmp_kernel_op_868;
             const real_t elMat_2_3 = tmp_kernel_op_521*tmp_kernel_op_864 + tmp_kernel_op_526*tmp_kernel_op_865 + tmp_kernel_op_531*tmp_kernel_op_866 + tmp_kernel_op_536*tmp_kernel_op_867 + tmp_kernel_op_541*tmp_kernel_op_868;
             const real_t elMat_2_4 = tmp_kernel_op_566*tmp_kernel_op_864 + tmp_kernel_op_576*tmp_kernel_op_865 + tmp_kernel_op_586*tmp_kernel_op_866 + tmp_kernel_op_596*tmp_kernel_op_867 + tmp_kernel_op_606*tmp_kernel_op_868;
             const real_t elMat_2_5 = tmp_kernel_op_628*tmp_kernel_op_864 + tmp_kernel_op_638*tmp_kernel_op_865 + tmp_kernel_op_648*tmp_kernel_op_866 + tmp_kernel_op_658*tmp_kernel_op_867 + tmp_kernel_op_668*tmp_kernel_op_868;
             const real_t elMat_2_6 = tmp_kernel_op_693*tmp_kernel_op_864 + tmp_kernel_op_703*tmp_kernel_op_865 + tmp_kernel_op_713*tmp_kernel_op_866 + tmp_kernel_op_723*tmp_kernel_op_867 + tmp_kernel_op_733*tmp_kernel_op_868;
             const real_t elMat_2_7 = tmp_kernel_op_756*tmp_kernel_op_864 + tmp_kernel_op_761*tmp_kernel_op_865 + tmp_kernel_op_766*tmp_kernel_op_866 + tmp_kernel_op_771*tmp_kernel_op_867 + tmp_kernel_op_776*tmp_kernel_op_868;
             const real_t elMat_2_8 = tmp_kernel_op_797*tmp_kernel_op_864 + tmp_kernel_op_803*tmp_kernel_op_865 + tmp_kernel_op_809*tmp_kernel_op_866 + tmp_kernel_op_815*tmp_kernel_op_867 + tmp_kernel_op_821*tmp_kernel_op_868;
             const real_t elMat_2_9 = tmp_kernel_op_838*tmp_kernel_op_864 + tmp_kernel_op_843*tmp_kernel_op_865 + tmp_kernel_op_848*tmp_kernel_op_866 + tmp_kernel_op_853*tmp_kernel_op_867 + tmp_kernel_op_858*tmp_kernel_op_868;
             const real_t elMat_3_0 = tmp_kernel_op_171*tmp_kernel_op_870 + tmp_kernel_op_256*tmp_kernel_op_871 + tmp_kernel_op_341*tmp_kernel_op_872 + tmp_kernel_op_426*tmp_kernel_op_873 + tmp_kernel_op_86*tmp_kernel_op_869;
             const real_t elMat_3_1 = tmp_kernel_op_459*tmp_kernel_op_869 + tmp_kernel_op_464*tmp_kernel_op_870 + tmp_kernel_op_469*tmp_kernel_op_871 + tmp_kernel_op_474*tmp_kernel_op_872 + tmp_kernel_op_479*tmp_kernel_op_873;
             const real_t elMat_3_2 = tmp_kernel_op_490*tmp_kernel_op_869 + tmp_kernel_op_495*tmp_kernel_op_870 + tmp_kernel_op_500*tmp_kernel_op_871 + tmp_kernel_op_505*tmp_kernel_op_872 + tmp_kernel_op_510*tmp_kernel_op_873;
             const real_t elMat_3_3 = tmp_kernel_op_521*tmp_kernel_op_869 + tmp_kernel_op_526*tmp_kernel_op_870 + tmp_kernel_op_531*tmp_kernel_op_871 + tmp_kernel_op_536*tmp_kernel_op_872 + tmp_kernel_op_541*tmp_kernel_op_873;
             const real_t elMat_3_4 = tmp_kernel_op_566*tmp_kernel_op_869 + tmp_kernel_op_576*tmp_kernel_op_870 + tmp_kernel_op_586*tmp_kernel_op_871 + tmp_kernel_op_596*tmp_kernel_op_872 + tmp_kernel_op_606*tmp_kernel_op_873;
             const real_t elMat_3_5 = tmp_kernel_op_628*tmp_kernel_op_869 + tmp_kernel_op_638*tmp_kernel_op_870 + tmp_kernel_op_648*tmp_kernel_op_871 + tmp_kernel_op_658*tmp_kernel_op_872 + tmp_kernel_op_668*tmp_kernel_op_873;
             const real_t elMat_3_6 = tmp_kernel_op_693*tmp_kernel_op_869 + tmp_kernel_op_703*tmp_kernel_op_870 + tmp_kernel_op_713*tmp_kernel_op_871 + tmp_kernel_op_723*tmp_kernel_op_872 + tmp_kernel_op_733*tmp_kernel_op_873;
             const real_t elMat_3_7 = tmp_kernel_op_756*tmp_kernel_op_869 + tmp_kernel_op_761*tmp_kernel_op_870 + tmp_kernel_op_766*tmp_kernel_op_871 + tmp_kernel_op_771*tmp_kernel_op_872 + tmp_kernel_op_776*tmp_kernel_op_873;
             const real_t elMat_3_8 = tmp_kernel_op_797*tmp_kernel_op_869 + tmp_kernel_op_803*tmp_kernel_op_870 + tmp_kernel_op_809*tmp_kernel_op_871 + tmp_kernel_op_815*tmp_kernel_op_872 + tmp_kernel_op_821*tmp_kernel_op_873;
             const real_t elMat_3_9 = tmp_kernel_op_838*tmp_kernel_op_869 + tmp_kernel_op_843*tmp_kernel_op_870 + tmp_kernel_op_848*tmp_kernel_op_871 + tmp_kernel_op_853*tmp_kernel_op_872 + tmp_kernel_op_858*tmp_kernel_op_873;
             const real_t elMat_4_0 = tmp_kernel_op_171*tmp_kernel_op_875 + tmp_kernel_op_256*tmp_kernel_op_876 + tmp_kernel_op_341*tmp_kernel_op_877 + tmp_kernel_op_426*tmp_kernel_op_878 + tmp_kernel_op_86*tmp_kernel_op_874;
             const real_t elMat_4_1 = tmp_kernel_op_459*tmp_kernel_op_874 + tmp_kernel_op_464*tmp_kernel_op_875 + tmp_kernel_op_469*tmp_kernel_op_876 + tmp_kernel_op_474*tmp_kernel_op_877 + tmp_kernel_op_479*tmp_kernel_op_878;
             const real_t elMat_4_2 = tmp_kernel_op_490*tmp_kernel_op_874 + tmp_kernel_op_495*tmp_kernel_op_875 + tmp_kernel_op_500*tmp_kernel_op_876 + tmp_kernel_op_505*tmp_kernel_op_877 + tmp_kernel_op_510*tmp_kernel_op_878;
             const real_t elMat_4_3 = tmp_kernel_op_521*tmp_kernel_op_874 + tmp_kernel_op_526*tmp_kernel_op_875 + tmp_kernel_op_531*tmp_kernel_op_876 + tmp_kernel_op_536*tmp_kernel_op_877 + tmp_kernel_op_541*tmp_kernel_op_878;
             const real_t elMat_4_4 = tmp_kernel_op_566*tmp_kernel_op_874 + tmp_kernel_op_576*tmp_kernel_op_875 + tmp_kernel_op_586*tmp_kernel_op_876 + tmp_kernel_op_596*tmp_kernel_op_877 + tmp_kernel_op_606*tmp_kernel_op_878;
             const real_t elMat_4_5 = tmp_kernel_op_628*tmp_kernel_op_874 + tmp_kernel_op_638*tmp_kernel_op_875 + tmp_kernel_op_648*tmp_kernel_op_876 + tmp_kernel_op_658*tmp_kernel_op_877 + tmp_kernel_op_668*tmp_kernel_op_878;
             const real_t elMat_4_6 = tmp_kernel_op_693*tmp_kernel_op_874 + tmp_kernel_op_703*tmp_kernel_op_875 + tmp_kernel_op_713*tmp_kernel_op_876 + tmp_kernel_op_723*tmp_kernel_op_877 + tmp_kernel_op_733*tmp_kernel_op_878;
             const real_t elMat_4_7 = tmp_kernel_op_756*tmp_kernel_op_874 + tmp_kernel_op_761*tmp_kernel_op_875 + tmp_kernel_op_766*tmp_kernel_op_876 + tmp_kernel_op_771*tmp_kernel_op_877 + tmp_kernel_op_776*tmp_kernel_op_878;
             const real_t elMat_4_8 = tmp_kernel_op_797*tmp_kernel_op_874 + tmp_kernel_op_803*tmp_kernel_op_875 + tmp_kernel_op_809*tmp_kernel_op_876 + tmp_kernel_op_815*tmp_kernel_op_877 + tmp_kernel_op_821*tmp_kernel_op_878;
             const real_t elMat_4_9 = tmp_kernel_op_838*tmp_kernel_op_874 + tmp_kernel_op_843*tmp_kernel_op_875 + tmp_kernel_op_848*tmp_kernel_op_876 + tmp_kernel_op_853*tmp_kernel_op_877 + tmp_kernel_op_858*tmp_kernel_op_878;
             const real_t elMat_5_0 = tmp_kernel_op_171*tmp_kernel_op_880 + tmp_kernel_op_256*tmp_kernel_op_881 + tmp_kernel_op_341*tmp_kernel_op_882 + tmp_kernel_op_426*tmp_kernel_op_883 + tmp_kernel_op_86*tmp_kernel_op_879;
             const real_t elMat_5_1 = tmp_kernel_op_459*tmp_kernel_op_879 + tmp_kernel_op_464*tmp_kernel_op_880 + tmp_kernel_op_469*tmp_kernel_op_881 + tmp_kernel_op_474*tmp_kernel_op_882 + tmp_kernel_op_479*tmp_kernel_op_883;
             const real_t elMat_5_2 = tmp_kernel_op_490*tmp_kernel_op_879 + tmp_kernel_op_495*tmp_kernel_op_880 + tmp_kernel_op_500*tmp_kernel_op_881 + tmp_kernel_op_505*tmp_kernel_op_882 + tmp_kernel_op_510*tmp_kernel_op_883;
             const real_t elMat_5_3 = tmp_kernel_op_521*tmp_kernel_op_879 + tmp_kernel_op_526*tmp_kernel_op_880 + tmp_kernel_op_531*tmp_kernel_op_881 + tmp_kernel_op_536*tmp_kernel_op_882 + tmp_kernel_op_541*tmp_kernel_op_883;
             const real_t elMat_5_4 = tmp_kernel_op_566*tmp_kernel_op_879 + tmp_kernel_op_576*tmp_kernel_op_880 + tmp_kernel_op_586*tmp_kernel_op_881 + tmp_kernel_op_596*tmp_kernel_op_882 + tmp_kernel_op_606*tmp_kernel_op_883;
             const real_t elMat_5_5 = tmp_kernel_op_628*tmp_kernel_op_879 + tmp_kernel_op_638*tmp_kernel_op_880 + tmp_kernel_op_648*tmp_kernel_op_881 + tmp_kernel_op_658*tmp_kernel_op_882 + tmp_kernel_op_668*tmp_kernel_op_883;
             const real_t elMat_5_6 = tmp_kernel_op_693*tmp_kernel_op_879 + tmp_kernel_op_703*tmp_kernel_op_880 + tmp_kernel_op_713*tmp_kernel_op_881 + tmp_kernel_op_723*tmp_kernel_op_882 + tmp_kernel_op_733*tmp_kernel_op_883;
             const real_t elMat_5_7 = tmp_kernel_op_756*tmp_kernel_op_879 + tmp_kernel_op_761*tmp_kernel_op_880 + tmp_kernel_op_766*tmp_kernel_op_881 + tmp_kernel_op_771*tmp_kernel_op_882 + tmp_kernel_op_776*tmp_kernel_op_883;
             const real_t elMat_5_8 = tmp_kernel_op_797*tmp_kernel_op_879 + tmp_kernel_op_803*tmp_kernel_op_880 + tmp_kernel_op_809*tmp_kernel_op_881 + tmp_kernel_op_815*tmp_kernel_op_882 + tmp_kernel_op_821*tmp_kernel_op_883;
             const real_t elMat_5_9 = tmp_kernel_op_838*tmp_kernel_op_879 + tmp_kernel_op_843*tmp_kernel_op_880 + tmp_kernel_op_848*tmp_kernel_op_881 + tmp_kernel_op_853*tmp_kernel_op_882 + tmp_kernel_op_858*tmp_kernel_op_883;
             const real_t elMat_6_0 = tmp_kernel_op_171*tmp_kernel_op_885 + tmp_kernel_op_256*tmp_kernel_op_886 + tmp_kernel_op_341*tmp_kernel_op_887 + tmp_kernel_op_426*tmp_kernel_op_888 + tmp_kernel_op_86*tmp_kernel_op_884;
             const real_t elMat_6_1 = tmp_kernel_op_459*tmp_kernel_op_884 + tmp_kernel_op_464*tmp_kernel_op_885 + tmp_kernel_op_469*tmp_kernel_op_886 + tmp_kernel_op_474*tmp_kernel_op_887 + tmp_kernel_op_479*tmp_kernel_op_888;
             const real_t elMat_6_2 = tmp_kernel_op_490*tmp_kernel_op_884 + tmp_kernel_op_495*tmp_kernel_op_885 + tmp_kernel_op_500*tmp_kernel_op_886 + tmp_kernel_op_505*tmp_kernel_op_887 + tmp_kernel_op_510*tmp_kernel_op_888;
             const real_t elMat_6_3 = tmp_kernel_op_521*tmp_kernel_op_884 + tmp_kernel_op_526*tmp_kernel_op_885 + tmp_kernel_op_531*tmp_kernel_op_886 + tmp_kernel_op_536*tmp_kernel_op_887 + tmp_kernel_op_541*tmp_kernel_op_888;
             const real_t elMat_6_4 = tmp_kernel_op_566*tmp_kernel_op_884 + tmp_kernel_op_576*tmp_kernel_op_885 + tmp_kernel_op_586*tmp_kernel_op_886 + tmp_kernel_op_596*tmp_kernel_op_887 + tmp_kernel_op_606*tmp_kernel_op_888;
             const real_t elMat_6_5 = tmp_kernel_op_628*tmp_kernel_op_884 + tmp_kernel_op_638*tmp_kernel_op_885 + tmp_kernel_op_648*tmp_kernel_op_886 + tmp_kernel_op_658*tmp_kernel_op_887 + tmp_kernel_op_668*tmp_kernel_op_888;
             const real_t elMat_6_6 = tmp_kernel_op_693*tmp_kernel_op_884 + tmp_kernel_op_703*tmp_kernel_op_885 + tmp_kernel_op_713*tmp_kernel_op_886 + tmp_kernel_op_723*tmp_kernel_op_887 + tmp_kernel_op_733*tmp_kernel_op_888;
             const real_t elMat_6_7 = tmp_kernel_op_756*tmp_kernel_op_884 + tmp_kernel_op_761*tmp_kernel_op_885 + tmp_kernel_op_766*tmp_kernel_op_886 + tmp_kernel_op_771*tmp_kernel_op_887 + tmp_kernel_op_776*tmp_kernel_op_888;
             const real_t elMat_6_8 = tmp_kernel_op_797*tmp_kernel_op_884 + tmp_kernel_op_803*tmp_kernel_op_885 + tmp_kernel_op_809*tmp_kernel_op_886 + tmp_kernel_op_815*tmp_kernel_op_887 + tmp_kernel_op_821*tmp_kernel_op_888;
             const real_t elMat_6_9 = tmp_kernel_op_838*tmp_kernel_op_884 + tmp_kernel_op_843*tmp_kernel_op_885 + tmp_kernel_op_848*tmp_kernel_op_886 + tmp_kernel_op_853*tmp_kernel_op_887 + tmp_kernel_op_858*tmp_kernel_op_888;
             const real_t elMat_7_0 = tmp_kernel_op_171*tmp_kernel_op_890 + tmp_kernel_op_256*tmp_kernel_op_891 + tmp_kernel_op_341*tmp_kernel_op_892 + tmp_kernel_op_426*tmp_kernel_op_893 + tmp_kernel_op_86*tmp_kernel_op_889;
             const real_t elMat_7_1 = tmp_kernel_op_459*tmp_kernel_op_889 + tmp_kernel_op_464*tmp_kernel_op_890 + tmp_kernel_op_469*tmp_kernel_op_891 + tmp_kernel_op_474*tmp_kernel_op_892 + tmp_kernel_op_479*tmp_kernel_op_893;
             const real_t elMat_7_2 = tmp_kernel_op_490*tmp_kernel_op_889 + tmp_kernel_op_495*tmp_kernel_op_890 + tmp_kernel_op_500*tmp_kernel_op_891 + tmp_kernel_op_505*tmp_kernel_op_892 + tmp_kernel_op_510*tmp_kernel_op_893;
             const real_t elMat_7_3 = tmp_kernel_op_521*tmp_kernel_op_889 + tmp_kernel_op_526*tmp_kernel_op_890 + tmp_kernel_op_531*tmp_kernel_op_891 + tmp_kernel_op_536*tmp_kernel_op_892 + tmp_kernel_op_541*tmp_kernel_op_893;
             const real_t elMat_7_4 = tmp_kernel_op_566*tmp_kernel_op_889 + tmp_kernel_op_576*tmp_kernel_op_890 + tmp_kernel_op_586*tmp_kernel_op_891 + tmp_kernel_op_596*tmp_kernel_op_892 + tmp_kernel_op_606*tmp_kernel_op_893;
             const real_t elMat_7_5 = tmp_kernel_op_628*tmp_kernel_op_889 + tmp_kernel_op_638*tmp_kernel_op_890 + tmp_kernel_op_648*tmp_kernel_op_891 + tmp_kernel_op_658*tmp_kernel_op_892 + tmp_kernel_op_668*tmp_kernel_op_893;
             const real_t elMat_7_6 = tmp_kernel_op_693*tmp_kernel_op_889 + tmp_kernel_op_703*tmp_kernel_op_890 + tmp_kernel_op_713*tmp_kernel_op_891 + tmp_kernel_op_723*tmp_kernel_op_892 + tmp_kernel_op_733*tmp_kernel_op_893;
             const real_t elMat_7_7 = tmp_kernel_op_756*tmp_kernel_op_889 + tmp_kernel_op_761*tmp_kernel_op_890 + tmp_kernel_op_766*tmp_kernel_op_891 + tmp_kernel_op_771*tmp_kernel_op_892 + tmp_kernel_op_776*tmp_kernel_op_893;
             const real_t elMat_7_8 = tmp_kernel_op_797*tmp_kernel_op_889 + tmp_kernel_op_803*tmp_kernel_op_890 + tmp_kernel_op_809*tmp_kernel_op_891 + tmp_kernel_op_815*tmp_kernel_op_892 + tmp_kernel_op_821*tmp_kernel_op_893;
             const real_t elMat_7_9 = tmp_kernel_op_838*tmp_kernel_op_889 + tmp_kernel_op_843*tmp_kernel_op_890 + tmp_kernel_op_848*tmp_kernel_op_891 + tmp_kernel_op_853*tmp_kernel_op_892 + tmp_kernel_op_858*tmp_kernel_op_893;
             const real_t elMat_8_0 = tmp_kernel_op_171*tmp_kernel_op_895 + tmp_kernel_op_256*tmp_kernel_op_896 + tmp_kernel_op_341*tmp_kernel_op_897 + tmp_kernel_op_426*tmp_kernel_op_898 + tmp_kernel_op_86*tmp_kernel_op_894;
             const real_t elMat_8_1 = tmp_kernel_op_459*tmp_kernel_op_894 + tmp_kernel_op_464*tmp_kernel_op_895 + tmp_kernel_op_469*tmp_kernel_op_896 + tmp_kernel_op_474*tmp_kernel_op_897 + tmp_kernel_op_479*tmp_kernel_op_898;
             const real_t elMat_8_2 = tmp_kernel_op_490*tmp_kernel_op_894 + tmp_kernel_op_495*tmp_kernel_op_895 + tmp_kernel_op_500*tmp_kernel_op_896 + tmp_kernel_op_505*tmp_kernel_op_897 + tmp_kernel_op_510*tmp_kernel_op_898;
             const real_t elMat_8_3 = tmp_kernel_op_521*tmp_kernel_op_894 + tmp_kernel_op_526*tmp_kernel_op_895 + tmp_kernel_op_531*tmp_kernel_op_896 + tmp_kernel_op_536*tmp_kernel_op_897 + tmp_kernel_op_541*tmp_kernel_op_898;
             const real_t elMat_8_4 = tmp_kernel_op_566*tmp_kernel_op_894 + tmp_kernel_op_576*tmp_kernel_op_895 + tmp_kernel_op_586*tmp_kernel_op_896 + tmp_kernel_op_596*tmp_kernel_op_897 + tmp_kernel_op_606*tmp_kernel_op_898;
             const real_t elMat_8_5 = tmp_kernel_op_628*tmp_kernel_op_894 + tmp_kernel_op_638*tmp_kernel_op_895 + tmp_kernel_op_648*tmp_kernel_op_896 + tmp_kernel_op_658*tmp_kernel_op_897 + tmp_kernel_op_668*tmp_kernel_op_898;
             const real_t elMat_8_6 = tmp_kernel_op_693*tmp_kernel_op_894 + tmp_kernel_op_703*tmp_kernel_op_895 + tmp_kernel_op_713*tmp_kernel_op_896 + tmp_kernel_op_723*tmp_kernel_op_897 + tmp_kernel_op_733*tmp_kernel_op_898;
             const real_t elMat_8_7 = tmp_kernel_op_756*tmp_kernel_op_894 + tmp_kernel_op_761*tmp_kernel_op_895 + tmp_kernel_op_766*tmp_kernel_op_896 + tmp_kernel_op_771*tmp_kernel_op_897 + tmp_kernel_op_776*tmp_kernel_op_898;
             const real_t elMat_8_8 = tmp_kernel_op_797*tmp_kernel_op_894 + tmp_kernel_op_803*tmp_kernel_op_895 + tmp_kernel_op_809*tmp_kernel_op_896 + tmp_kernel_op_815*tmp_kernel_op_897 + tmp_kernel_op_821*tmp_kernel_op_898;
             const real_t elMat_8_9 = tmp_kernel_op_838*tmp_kernel_op_894 + tmp_kernel_op_843*tmp_kernel_op_895 + tmp_kernel_op_848*tmp_kernel_op_896 + tmp_kernel_op_853*tmp_kernel_op_897 + tmp_kernel_op_858*tmp_kernel_op_898;
             const real_t elMat_9_0 = tmp_kernel_op_171*tmp_kernel_op_900 + tmp_kernel_op_256*tmp_kernel_op_901 + tmp_kernel_op_341*tmp_kernel_op_902 + tmp_kernel_op_426*tmp_kernel_op_903 + tmp_kernel_op_86*tmp_kernel_op_899;
             const real_t elMat_9_1 = tmp_kernel_op_459*tmp_kernel_op_899 + tmp_kernel_op_464*tmp_kernel_op_900 + tmp_kernel_op_469*tmp_kernel_op_901 + tmp_kernel_op_474*tmp_kernel_op_902 + tmp_kernel_op_479*tmp_kernel_op_903;
             const real_t elMat_9_2 = tmp_kernel_op_490*tmp_kernel_op_899 + tmp_kernel_op_495*tmp_kernel_op_900 + tmp_kernel_op_500*tmp_kernel_op_901 + tmp_kernel_op_505*tmp_kernel_op_902 + tmp_kernel_op_510*tmp_kernel_op_903;
             const real_t elMat_9_3 = tmp_kernel_op_521*tmp_kernel_op_899 + tmp_kernel_op_526*tmp_kernel_op_900 + tmp_kernel_op_531*tmp_kernel_op_901 + tmp_kernel_op_536*tmp_kernel_op_902 + tmp_kernel_op_541*tmp_kernel_op_903;
             const real_t elMat_9_4 = tmp_kernel_op_566*tmp_kernel_op_899 + tmp_kernel_op_576*tmp_kernel_op_900 + tmp_kernel_op_586*tmp_kernel_op_901 + tmp_kernel_op_596*tmp_kernel_op_902 + tmp_kernel_op_606*tmp_kernel_op_903;
             const real_t elMat_9_5 = tmp_kernel_op_628*tmp_kernel_op_899 + tmp_kernel_op_638*tmp_kernel_op_900 + tmp_kernel_op_648*tmp_kernel_op_901 + tmp_kernel_op_658*tmp_kernel_op_902 + tmp_kernel_op_668*tmp_kernel_op_903;
             const real_t elMat_9_6 = tmp_kernel_op_693*tmp_kernel_op_899 + tmp_kernel_op_703*tmp_kernel_op_900 + tmp_kernel_op_713*tmp_kernel_op_901 + tmp_kernel_op_723*tmp_kernel_op_902 + tmp_kernel_op_733*tmp_kernel_op_903;
             const real_t elMat_9_7 = tmp_kernel_op_756*tmp_kernel_op_899 + tmp_kernel_op_761*tmp_kernel_op_900 + tmp_kernel_op_766*tmp_kernel_op_901 + tmp_kernel_op_771*tmp_kernel_op_902 + tmp_kernel_op_776*tmp_kernel_op_903;
             const real_t elMat_9_8 = tmp_kernel_op_797*tmp_kernel_op_899 + tmp_kernel_op_803*tmp_kernel_op_900 + tmp_kernel_op_809*tmp_kernel_op_901 + tmp_kernel_op_815*tmp_kernel_op_902 + tmp_kernel_op_821*tmp_kernel_op_903;
             const real_t elMat_9_9 = tmp_kernel_op_838*tmp_kernel_op_899 + tmp_kernel_op_843*tmp_kernel_op_900 + tmp_kernel_op_848*tmp_kernel_op_901 + tmp_kernel_op_853*tmp_kernel_op_902 + tmp_kernel_op_858*tmp_kernel_op_903;
         
             std::vector< uint_t > _data_rowIdx( 10 );
             std::vector< uint_t > _data_colIdx( 10 );
             std::vector< real_t > _data_mat( 100 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[1] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[2] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[3] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[7] = ((uint64_t)(_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[8] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[9] = ((uint64_t)(_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[3] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[7] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_0_4));
             _data_mat[5] = ((real_t)(elMat_0_5));
             _data_mat[6] = ((real_t)(elMat_0_6));
             _data_mat[7] = ((real_t)(elMat_0_7));
             _data_mat[8] = ((real_t)(elMat_0_8));
             _data_mat[9] = ((real_t)(elMat_0_9));
             _data_mat[10] = ((real_t)(elMat_1_0));
             _data_mat[11] = ((real_t)(elMat_1_1));
             _data_mat[12] = ((real_t)(elMat_1_2));
             _data_mat[13] = ((real_t)(elMat_1_3));
             _data_mat[14] = ((real_t)(elMat_1_4));
             _data_mat[15] = ((real_t)(elMat_1_5));
             _data_mat[16] = ((real_t)(elMat_1_6));
             _data_mat[17] = ((real_t)(elMat_1_7));
             _data_mat[18] = ((real_t)(elMat_1_8));
             _data_mat[19] = ((real_t)(elMat_1_9));
             _data_mat[20] = ((real_t)(elMat_2_0));
             _data_mat[21] = ((real_t)(elMat_2_1));
             _data_mat[22] = ((real_t)(elMat_2_2));
             _data_mat[23] = ((real_t)(elMat_2_3));
             _data_mat[24] = ((real_t)(elMat_2_4));
             _data_mat[25] = ((real_t)(elMat_2_5));
             _data_mat[26] = ((real_t)(elMat_2_6));
             _data_mat[27] = ((real_t)(elMat_2_7));
             _data_mat[28] = ((real_t)(elMat_2_8));
             _data_mat[29] = ((real_t)(elMat_2_9));
             _data_mat[30] = ((real_t)(elMat_3_0));
             _data_mat[31] = ((real_t)(elMat_3_1));
             _data_mat[32] = ((real_t)(elMat_3_2));
             _data_mat[33] = ((real_t)(elMat_3_3));
             _data_mat[34] = ((real_t)(elMat_3_4));
             _data_mat[35] = ((real_t)(elMat_3_5));
             _data_mat[36] = ((real_t)(elMat_3_6));
             _data_mat[37] = ((real_t)(elMat_3_7));
             _data_mat[38] = ((real_t)(elMat_3_8));
             _data_mat[39] = ((real_t)(elMat_3_9));
             _data_mat[40] = ((real_t)(elMat_4_0));
             _data_mat[41] = ((real_t)(elMat_4_1));
             _data_mat[42] = ((real_t)(elMat_4_2));
             _data_mat[43] = ((real_t)(elMat_4_3));
             _data_mat[44] = ((real_t)(elMat_4_4));
             _data_mat[45] = ((real_t)(elMat_4_5));
             _data_mat[46] = ((real_t)(elMat_4_6));
             _data_mat[47] = ((real_t)(elMat_4_7));
             _data_mat[48] = ((real_t)(elMat_4_8));
             _data_mat[49] = ((real_t)(elMat_4_9));
             _data_mat[50] = ((real_t)(elMat_5_0));
             _data_mat[51] = ((real_t)(elMat_5_1));
             _data_mat[52] = ((real_t)(elMat_5_2));
             _data_mat[53] = ((real_t)(elMat_5_3));
             _data_mat[54] = ((real_t)(elMat_5_4));
             _data_mat[55] = ((real_t)(elMat_5_5));
             _data_mat[56] = ((real_t)(elMat_5_6));
             _data_mat[57] = ((real_t)(elMat_5_7));
             _data_mat[58] = ((real_t)(elMat_5_8));
             _data_mat[59] = ((real_t)(elMat_5_9));
             _data_mat[60] = ((real_t)(elMat_6_0));
             _data_mat[61] = ((real_t)(elMat_6_1));
             _data_mat[62] = ((real_t)(elMat_6_2));
             _data_mat[63] = ((real_t)(elMat_6_3));
             _data_mat[64] = ((real_t)(elMat_6_4));
             _data_mat[65] = ((real_t)(elMat_6_5));
             _data_mat[66] = ((real_t)(elMat_6_6));
             _data_mat[67] = ((real_t)(elMat_6_7));
             _data_mat[68] = ((real_t)(elMat_6_8));
             _data_mat[69] = ((real_t)(elMat_6_9));
             _data_mat[70] = ((real_t)(elMat_7_0));
             _data_mat[71] = ((real_t)(elMat_7_1));
             _data_mat[72] = ((real_t)(elMat_7_2));
             _data_mat[73] = ((real_t)(elMat_7_3));
             _data_mat[74] = ((real_t)(elMat_7_4));
             _data_mat[75] = ((real_t)(elMat_7_5));
             _data_mat[76] = ((real_t)(elMat_7_6));
             _data_mat[77] = ((real_t)(elMat_7_7));
             _data_mat[78] = ((real_t)(elMat_7_8));
             _data_mat[79] = ((real_t)(elMat_7_9));
             _data_mat[80] = ((real_t)(elMat_8_0));
             _data_mat[81] = ((real_t)(elMat_8_1));
             _data_mat[82] = ((real_t)(elMat_8_2));
             _data_mat[83] = ((real_t)(elMat_8_3));
             _data_mat[84] = ((real_t)(elMat_8_4));
             _data_mat[85] = ((real_t)(elMat_8_5));
             _data_mat[86] = ((real_t)(elMat_8_6));
             _data_mat[87] = ((real_t)(elMat_8_7));
             _data_mat[88] = ((real_t)(elMat_8_8));
             _data_mat[89] = ((real_t)(elMat_8_9));
             _data_mat[90] = ((real_t)(elMat_9_0));
             _data_mat[91] = ((real_t)(elMat_9_1));
             _data_mat[92] = ((real_t)(elMat_9_2));
             _data_mat[93] = ((real_t)(elMat_9_3));
             _data_mat[94] = ((real_t)(elMat_9_4));
             _data_mat[95] = ((real_t)(elMat_9_5));
             _data_mat[96] = ((real_t)(elMat_9_6));
             _data_mat[97] = ((real_t)(elMat_9_7));
             _data_mat[98] = ((real_t)(elMat_9_8));
             _data_mat[99] = ((real_t)(elMat_9_9));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
