/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/































#include "../P2ElementwiseSupgMassIcosahedralShellMap.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ElementwiseSupgMassIcosahedralShellMap::apply_P2ElementwiseSupgMassIcosahedralShellMap_macro_3D( real_t * RESTRICT  _data_deltaEdge, real_t * RESTRICT  _data_deltaVertex, real_t * RESTRICT  _data_dstEdge, real_t * RESTRICT  _data_dstVertex, real_t * RESTRICT  _data_srcEdge, real_t * RESTRICT  _data_srcVertex, real_t * RESTRICT  _data_uxEdge, real_t * RESTRICT  _data_uxVertex, real_t * RESTRICT  _data_uyEdge, real_t * RESTRICT  _data_uyVertex, real_t * RESTRICT  _data_uzEdge, real_t * RESTRICT  _data_uzVertex, real_t forVertex_0, real_t forVertex_1, real_t forVertex_2, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float, real_t radRayVertex, real_t radRefVertex, real_t rayVertex_0, real_t rayVertex_1, real_t rayVertex_2, real_t refVertex_0, real_t refVertex_1, real_t refVertex_2, real_t thrVertex_0, real_t thrVertex_1, real_t thrVertex_2 ) const
{
    {
       const real_t _data_q_w [] = {0.041666666666666657, 0.041666666666666657, 0.041666666666666657, 0.041666666666666657};
   
       const real_t _data_q_p_0 [] = {0.1381966011250105, 0.1381966011250105, 0.5854101966249684, 0.1381966011250105};
   
       const real_t _data_q_p_1 [] = {0.1381966011250105, 0.5854101966249684, 0.1381966011250105, 0.1381966011250105};
   
       const real_t _data_q_p_2 [] = {0.5854101966249684, 0.1381966011250105, 0.1381966011250105, 0.1381966011250105};
   
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const real_t tmp_coords_jac_5_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const real_t tmp_coords_jac_3_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const real_t tmp_coords_jac_2_WHITE_UP = jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP;
       const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const real_t tmp_coords_jac_1_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_4_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_6_WHITE_UP = jac_affine_0_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_0_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_0_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
       const real_t tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const real_t jac_affine_inv_0_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
       const real_t jac_affine_inv_0_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_2_1_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const real_t jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const real_t jac_affine_inv_1_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t jac_affine_inv_2_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       const real_t tmp_qloop_0 = rayVertex_1 - refVertex_1;
       const real_t tmp_qloop_1 = -rayVertex_0;
       const real_t tmp_qloop_2 = -forVertex_0 - tmp_qloop_1;
       const real_t tmp_qloop_3 = rayVertex_2 - thrVertex_2;
       const real_t tmp_qloop_4 = tmp_qloop_2*tmp_qloop_3;
       const real_t tmp_qloop_5 = rayVertex_2 - refVertex_2;
       const real_t tmp_qloop_6 = rayVertex_1 - thrVertex_1;
       const real_t tmp_qloop_7 = tmp_qloop_2*tmp_qloop_6;
       const real_t tmp_qloop_8 = -rayVertex_1;
       const real_t tmp_qloop_9 = -forVertex_1 - tmp_qloop_8;
       const real_t tmp_qloop_10 = rayVertex_0 - thrVertex_0;
       const real_t tmp_qloop_11 = rayVertex_0 - refVertex_0;
       const real_t tmp_qloop_12 = -rayVertex_2;
       const real_t tmp_qloop_13 = -forVertex_2 - tmp_qloop_12;
       const real_t tmp_qloop_14 = tmp_qloop_3*tmp_qloop_9;
       const real_t tmp_qloop_15 = tmp_qloop_10*tmp_qloop_13;
       const real_t tmp_qloop_16 = -tmp_qloop_0*tmp_qloop_15 + tmp_qloop_0*tmp_qloop_4 + tmp_qloop_10*tmp_qloop_5*tmp_qloop_9 + tmp_qloop_11*tmp_qloop_13*tmp_qloop_6 - tmp_qloop_11*tmp_qloop_14 - tmp_qloop_5*tmp_qloop_7;
       const real_t tmp_qloop_17 = 1.0 / (tmp_qloop_16);
       const real_t tmp_qloop_20 = radRayVertex*tmp_qloop_16;
       const real_t tmp_qloop_21 = radRayVertex - radRefVertex;
       const real_t tmp_qloop_32 = -tmp_qloop_13*tmp_qloop_6 + tmp_qloop_14;
       const real_t tmp_qloop_33 = -tmp_qloop_21*tmp_qloop_32;
       const real_t tmp_qloop_39 = tmp_qloop_10*tmp_qloop_13 - tmp_qloop_4;
       const real_t tmp_qloop_40 = tmp_qloop_21*tmp_qloop_39;
       const real_t tmp_qloop_45 = -tmp_qloop_10*tmp_qloop_9 + tmp_qloop_7;
       const real_t tmp_qloop_46 = -tmp_qloop_21*tmp_qloop_45;
       const real_t tmp_qloop_53 = -tmp_qloop_21*tmp_qloop_39;
       const real_t tmp_qloop_68 = tmp_qloop_21*tmp_qloop_32;
       const real_t tmp_qloop_72 = tmp_qloop_21*tmp_qloop_45;
       {
          /* CellType.WHITE_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t delta_dof_0 = _data_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t delta_dof_1 = _data_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t delta_dof_2 = _data_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t delta_dof_3 = _data_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t delta_dof_4 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t delta_dof_5 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t delta_dof_6 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t delta_dof_7 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t delta_dof_8 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t delta_dof_9 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_0 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_1 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_2 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_3 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_4 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_5 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_6 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_7 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_8 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_9 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_0 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_1 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_2 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_3 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_4 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_5 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_6 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_7 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_8 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_9 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_0 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_1 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_2 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_3 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_4 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_5 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_6 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_7 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_8 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_9 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_4_0 = 0.0;
             real_t q_acc_4_1 = 0.0;
             real_t q_acc_4_2 = 0.0;
             real_t q_acc_4_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_5_0 = 0.0;
             real_t q_acc_5_1 = 0.0;
             real_t q_acc_5_2 = 0.0;
             real_t q_acc_5_3 = 0.0;
             real_t q_acc_5_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_6_0 = 0.0;
             real_t q_acc_6_1 = 0.0;
             real_t q_acc_6_2 = 0.0;
             real_t q_acc_6_3 = 0.0;
             real_t q_acc_6_4 = 0.0;
             real_t q_acc_6_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_7_0 = 0.0;
             real_t q_acc_7_1 = 0.0;
             real_t q_acc_7_2 = 0.0;
             real_t q_acc_7_3 = 0.0;
             real_t q_acc_7_4 = 0.0;
             real_t q_acc_7_5 = 0.0;
             real_t q_acc_7_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_8_0 = 0.0;
             real_t q_acc_8_1 = 0.0;
             real_t q_acc_8_2 = 0.0;
             real_t q_acc_8_3 = 0.0;
             real_t q_acc_8_4 = 0.0;
             real_t q_acc_8_5 = 0.0;
             real_t q_acc_8_6 = 0.0;
             real_t q_acc_8_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_9_0 = 0.0;
             real_t q_acc_9_1 = 0.0;
             real_t q_acc_9_2 = 0.0;
             real_t q_acc_9_3 = 0.0;
             real_t q_acc_9_4 = 0.0;
             real_t q_acc_9_5 = 0.0;
             real_t q_acc_9_6 = 0.0;
             real_t q_acc_9_7 = 0.0;
             real_t q_acc_9_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                const real_t tmp_qloop_47 = -tmp_qloop_28;
                const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_70 = -tmp_qloop_41;
                const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                const real_t tmp_qloop_103 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const real_t tmp_qloop_104 = tmp_qloop_103*2.0;
                const real_t tmp_qloop_105 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const real_t tmp_qloop_106 = tmp_qloop_105*2.0;
                const real_t tmp_qloop_107 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const real_t tmp_qloop_108 = tmp_qloop_107*2.0;
                const real_t tmp_qloop_109 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_110 = tmp_qloop_109*_data_q_p_2[q];
                const real_t tmp_qloop_111 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_112 = tmp_qloop_111*_data_q_p_1[q];
                const real_t tmp_qloop_113 = tmp_qloop_111*_data_q_p_2[q];
                const real_t tmp_qloop_114 = tmp_qloop_112 + tmp_qloop_113;
                const real_t tmp_qloop_115 = tmp_qloop_104 + tmp_qloop_106 + tmp_qloop_108 + tmp_qloop_110 + tmp_qloop_114 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0;
                const real_t tmp_qloop_116 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_117 = tmp_qloop_109 + tmp_qloop_111;
                const real_t tmp_qloop_118 = tmp_qloop_116 + tmp_qloop_117 - 3.0;
                const real_t tmp_qloop_119 = jac_affine_inv_0_0_WHITE_UP*tmp_qloop_118 + jac_affine_inv_1_0_WHITE_UP*tmp_qloop_118 + jac_affine_inv_2_0_WHITE_UP*tmp_qloop_118;
                const real_t tmp_qloop_120 = jac_affine_inv_0_1_WHITE_UP*tmp_qloop_118 + jac_affine_inv_1_1_WHITE_UP*tmp_qloop_118 + jac_affine_inv_2_1_WHITE_UP*tmp_qloop_118;
                const real_t tmp_qloop_121 = jac_affine_inv_0_2_WHITE_UP*tmp_qloop_118 + jac_affine_inv_1_2_WHITE_UP*tmp_qloop_118 + jac_affine_inv_2_2_WHITE_UP*tmp_qloop_118;
                const real_t tmp_qloop_122 = tmp_qloop_104 - _data_q_p_0[q];
                const real_t tmp_qloop_123 = tmp_qloop_106 - _data_q_p_1[q];
                const real_t tmp_qloop_124 = tmp_qloop_108 - _data_q_p_2[q];
                const real_t tmp_qloop_125 = tmp_qloop_107*-4.0 - tmp_qloop_110 - tmp_qloop_113 + tmp_qloop_116;
                const real_t tmp_qloop_126 = tmp_qloop_105*-4.0 + tmp_qloop_109 - tmp_qloop_110 - tmp_qloop_112;
                const real_t tmp_qloop_127 = tmp_qloop_103*-4.0 + tmp_qloop_111 - tmp_qloop_114;
                const real_t tmp_qloop_128 = tmp_qloop_110*ux_dof_4 + tmp_qloop_112*ux_dof_6 + tmp_qloop_113*ux_dof_5 + tmp_qloop_115*ux_dof_0 + tmp_qloop_122*ux_dof_1 + tmp_qloop_123*ux_dof_2 + tmp_qloop_124*ux_dof_3 + tmp_qloop_125*ux_dof_7 + tmp_qloop_126*ux_dof_8 + tmp_qloop_127*ux_dof_9;
                const real_t tmp_qloop_129 = tmp_qloop_110*uy_dof_4 + tmp_qloop_112*uy_dof_6 + tmp_qloop_113*uy_dof_5 + tmp_qloop_115*uy_dof_0 + tmp_qloop_122*uy_dof_1 + tmp_qloop_123*uy_dof_2 + tmp_qloop_124*uy_dof_3 + tmp_qloop_125*uy_dof_7 + tmp_qloop_126*uy_dof_8 + tmp_qloop_127*uy_dof_9;
                const real_t tmp_qloop_130 = tmp_qloop_110*uz_dof_4 + tmp_qloop_112*uz_dof_6 + tmp_qloop_113*uz_dof_5 + tmp_qloop_115*uz_dof_0 + tmp_qloop_122*uz_dof_1 + tmp_qloop_123*uz_dof_2 + tmp_qloop_124*uz_dof_3 + tmp_qloop_125*uz_dof_7 + tmp_qloop_126*uz_dof_8 + tmp_qloop_127*uz_dof_9;
                const real_t tmp_qloop_133 = tmp_qloop_111 - 1.0;
                const real_t tmp_qloop_134 = jac_affine_inv_0_0_WHITE_UP*tmp_qloop_133;
                const real_t tmp_qloop_135 = jac_affine_inv_0_1_WHITE_UP*tmp_qloop_133;
                const real_t tmp_qloop_136 = jac_affine_inv_0_2_WHITE_UP*tmp_qloop_133;
                const real_t tmp_qloop_138 = tmp_qloop_109 - 1.0;
                const real_t tmp_qloop_139 = jac_affine_inv_1_0_WHITE_UP*tmp_qloop_138;
                const real_t tmp_qloop_140 = jac_affine_inv_1_1_WHITE_UP*tmp_qloop_138;
                const real_t tmp_qloop_141 = jac_affine_inv_1_2_WHITE_UP*tmp_qloop_138;
                const real_t tmp_qloop_143 = tmp_qloop_116 - 1.0;
                const real_t tmp_qloop_144 = jac_affine_inv_2_0_WHITE_UP*tmp_qloop_143;
                const real_t tmp_qloop_145 = jac_affine_inv_2_1_WHITE_UP*tmp_qloop_143;
                const real_t tmp_qloop_146 = jac_affine_inv_2_2_WHITE_UP*tmp_qloop_143;
                const real_t tmp_qloop_148 = jac_affine_inv_2_0_WHITE_UP*tmp_qloop_109;
                const real_t tmp_qloop_149 = jac_affine_inv_1_0_WHITE_UP*tmp_qloop_116;
                const real_t tmp_qloop_150 = tmp_qloop_148 + tmp_qloop_149;
                const real_t tmp_qloop_151 = jac_affine_inv_2_1_WHITE_UP*tmp_qloop_109;
                const real_t tmp_qloop_152 = jac_affine_inv_1_1_WHITE_UP*tmp_qloop_116;
                const real_t tmp_qloop_153 = tmp_qloop_151 + tmp_qloop_152;
                const real_t tmp_qloop_154 = jac_affine_inv_2_2_WHITE_UP*tmp_qloop_109;
                const real_t tmp_qloop_155 = jac_affine_inv_1_2_WHITE_UP*tmp_qloop_116;
                const real_t tmp_qloop_156 = tmp_qloop_154 + tmp_qloop_155;
                const real_t tmp_qloop_158 = jac_affine_inv_2_0_WHITE_UP*tmp_qloop_111;
                const real_t tmp_qloop_159 = jac_affine_inv_0_0_WHITE_UP*tmp_qloop_116;
                const real_t tmp_qloop_160 = tmp_qloop_158 + tmp_qloop_159;
                const real_t tmp_qloop_161 = jac_affine_inv_2_1_WHITE_UP*tmp_qloop_111;
                const real_t tmp_qloop_162 = jac_affine_inv_0_1_WHITE_UP*tmp_qloop_116;
                const real_t tmp_qloop_163 = tmp_qloop_161 + tmp_qloop_162;
                const real_t tmp_qloop_164 = jac_affine_inv_2_2_WHITE_UP*tmp_qloop_111;
                const real_t tmp_qloop_165 = jac_affine_inv_0_2_WHITE_UP*tmp_qloop_116;
                const real_t tmp_qloop_166 = tmp_qloop_164 + tmp_qloop_165;
                const real_t tmp_qloop_168 = jac_affine_inv_1_0_WHITE_UP*tmp_qloop_111;
                const real_t tmp_qloop_169 = jac_affine_inv_0_0_WHITE_UP*tmp_qloop_109;
                const real_t tmp_qloop_170 = tmp_qloop_168 + tmp_qloop_169;
                const real_t tmp_qloop_171 = jac_affine_inv_1_1_WHITE_UP*tmp_qloop_111;
                const real_t tmp_qloop_172 = jac_affine_inv_0_1_WHITE_UP*tmp_qloop_109;
                const real_t tmp_qloop_173 = tmp_qloop_171 + tmp_qloop_172;
                const real_t tmp_qloop_174 = jac_affine_inv_1_2_WHITE_UP*tmp_qloop_111;
                const real_t tmp_qloop_175 = jac_affine_inv_0_2_WHITE_UP*tmp_qloop_109;
                const real_t tmp_qloop_176 = tmp_qloop_174 + tmp_qloop_175;
                const real_t tmp_qloop_178 = -tmp_qloop_117 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_179 = jac_affine_inv_2_0_WHITE_UP*tmp_qloop_178 - tmp_qloop_149 - tmp_qloop_159;
                const real_t tmp_qloop_180 = jac_affine_inv_2_1_WHITE_UP*tmp_qloop_178 - tmp_qloop_152 - tmp_qloop_162;
                const real_t tmp_qloop_181 = jac_affine_inv_2_2_WHITE_UP*tmp_qloop_178 - tmp_qloop_155 - tmp_qloop_165;
                const real_t tmp_qloop_183 = tmp_qloop_116 - 4.0;
                const real_t tmp_qloop_184 = -tmp_qloop_111 - tmp_qloop_183 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_185 = jac_affine_inv_1_0_WHITE_UP*tmp_qloop_184 - tmp_qloop_148 - tmp_qloop_169;
                const real_t tmp_qloop_186 = jac_affine_inv_1_1_WHITE_UP*tmp_qloop_184 - tmp_qloop_151 - tmp_qloop_172;
                const real_t tmp_qloop_187 = jac_affine_inv_1_2_WHITE_UP*tmp_qloop_184 - tmp_qloop_154 - tmp_qloop_175;
                const real_t tmp_qloop_189 = -tmp_qloop_109 - tmp_qloop_183 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_190 = jac_affine_inv_0_0_WHITE_UP*tmp_qloop_189 - tmp_qloop_158 - tmp_qloop_168;
                const real_t tmp_qloop_191 = jac_affine_inv_0_1_WHITE_UP*tmp_qloop_189 - tmp_qloop_161 - tmp_qloop_171;
                const real_t tmp_qloop_192 = jac_affine_inv_0_2_WHITE_UP*tmp_qloop_189 - tmp_qloop_164 - tmp_qloop_174;
                const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                const real_t abs_det_jac_blending = tmp_qloop_64;
                const real_t tmp_qloop_131 = abs_det_jac_affine_WHITE_UP*abs_det_jac_blending*(delta_dof_0*tmp_qloop_115 + delta_dof_1*tmp_qloop_122 + delta_dof_2*tmp_qloop_123 + delta_dof_3*tmp_qloop_124 + delta_dof_4*tmp_qloop_110 + delta_dof_5*tmp_qloop_113 + delta_dof_6*tmp_qloop_112 + delta_dof_7*tmp_qloop_125 + delta_dof_8*tmp_qloop_126 + delta_dof_9*tmp_qloop_127)*_data_q_w[q];
                const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t tmp_qloop_132 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_119 + jac_blending_inv_1_0*tmp_qloop_120 + jac_blending_inv_2_0*tmp_qloop_121) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_119 + jac_blending_inv_1_1*tmp_qloop_120 + jac_blending_inv_2_1*tmp_qloop_121) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_119 + jac_blending_inv_1_2*tmp_qloop_120 + jac_blending_inv_2_2*tmp_qloop_121));
                const real_t tmp_qloop_137 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_134 + jac_blending_inv_1_0*tmp_qloop_135 + jac_blending_inv_2_0*tmp_qloop_136) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_134 + jac_blending_inv_1_1*tmp_qloop_135 + jac_blending_inv_2_1*tmp_qloop_136) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_134 + jac_blending_inv_1_2*tmp_qloop_135 + jac_blending_inv_2_2*tmp_qloop_136));
                const real_t tmp_qloop_142 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_139 + jac_blending_inv_1_0*tmp_qloop_140 + jac_blending_inv_2_0*tmp_qloop_141) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_139 + jac_blending_inv_1_1*tmp_qloop_140 + jac_blending_inv_2_1*tmp_qloop_141) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_139 + jac_blending_inv_1_2*tmp_qloop_140 + jac_blending_inv_2_2*tmp_qloop_141));
                const real_t tmp_qloop_147 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_144 + jac_blending_inv_1_0*tmp_qloop_145 + jac_blending_inv_2_0*tmp_qloop_146) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_144 + jac_blending_inv_1_1*tmp_qloop_145 + jac_blending_inv_2_1*tmp_qloop_146) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_144 + jac_blending_inv_1_2*tmp_qloop_145 + jac_blending_inv_2_2*tmp_qloop_146));
                const real_t tmp_qloop_157 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_150 + jac_blending_inv_1_0*tmp_qloop_153 + jac_blending_inv_2_0*tmp_qloop_156) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_150 + jac_blending_inv_1_1*tmp_qloop_153 + jac_blending_inv_2_1*tmp_qloop_156) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_150 + jac_blending_inv_1_2*tmp_qloop_153 + jac_blending_inv_2_2*tmp_qloop_156));
                const real_t tmp_qloop_167 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_160 + jac_blending_inv_1_0*tmp_qloop_163 + jac_blending_inv_2_0*tmp_qloop_166) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_160 + jac_blending_inv_1_1*tmp_qloop_163 + jac_blending_inv_2_1*tmp_qloop_166) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_160 + jac_blending_inv_1_2*tmp_qloop_163 + jac_blending_inv_2_2*tmp_qloop_166));
                const real_t tmp_qloop_177 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_170 + jac_blending_inv_1_0*tmp_qloop_173 + jac_blending_inv_2_0*tmp_qloop_176) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_170 + jac_blending_inv_1_1*tmp_qloop_173 + jac_blending_inv_2_1*tmp_qloop_176) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_170 + jac_blending_inv_1_2*tmp_qloop_173 + jac_blending_inv_2_2*tmp_qloop_176));
                const real_t tmp_qloop_182 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_179 + jac_blending_inv_1_0*tmp_qloop_180 + jac_blending_inv_2_0*tmp_qloop_181) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_179 + jac_blending_inv_1_1*tmp_qloop_180 + jac_blending_inv_2_1*tmp_qloop_181) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_179 + jac_blending_inv_1_2*tmp_qloop_180 + jac_blending_inv_2_2*tmp_qloop_181));
                const real_t tmp_qloop_188 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_185 + jac_blending_inv_1_0*tmp_qloop_186 + jac_blending_inv_2_0*tmp_qloop_187) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_185 + jac_blending_inv_1_1*tmp_qloop_186 + jac_blending_inv_2_1*tmp_qloop_187) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_185 + jac_blending_inv_1_2*tmp_qloop_186 + jac_blending_inv_2_2*tmp_qloop_187));
                const real_t tmp_qloop_193 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_190 + jac_blending_inv_1_0*tmp_qloop_191 + jac_blending_inv_2_0*tmp_qloop_192) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_190 + jac_blending_inv_1_1*tmp_qloop_191 + jac_blending_inv_2_1*tmp_qloop_192) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_190 + jac_blending_inv_1_2*tmp_qloop_191 + jac_blending_inv_2_2*tmp_qloop_192));
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_115*tmp_qloop_132;
                const real_t q_tmp_0_1 = tmp_qloop_122*tmp_qloop_132;
                const real_t q_tmp_0_2 = tmp_qloop_123*tmp_qloop_132;
                const real_t q_tmp_0_3 = tmp_qloop_124*tmp_qloop_132;
                const real_t q_tmp_0_4 = tmp_qloop_110*tmp_qloop_132;
                const real_t q_tmp_0_5 = tmp_qloop_113*tmp_qloop_132;
                const real_t q_tmp_0_6 = tmp_qloop_112*tmp_qloop_132;
                const real_t q_tmp_0_7 = tmp_qloop_125*tmp_qloop_132;
                const real_t q_tmp_0_8 = tmp_qloop_126*tmp_qloop_132;
                const real_t q_tmp_0_9 = tmp_qloop_127*tmp_qloop_132;
                const real_t q_tmp_1_0 = tmp_qloop_115*tmp_qloop_137;
                const real_t q_tmp_1_1 = tmp_qloop_122*tmp_qloop_137;
                const real_t q_tmp_1_2 = tmp_qloop_123*tmp_qloop_137;
                const real_t q_tmp_1_3 = tmp_qloop_124*tmp_qloop_137;
                const real_t q_tmp_1_4 = tmp_qloop_110*tmp_qloop_137;
                const real_t q_tmp_1_5 = tmp_qloop_113*tmp_qloop_137;
                const real_t q_tmp_1_6 = tmp_qloop_112*tmp_qloop_137;
                const real_t q_tmp_1_7 = tmp_qloop_125*tmp_qloop_137;
                const real_t q_tmp_1_8 = tmp_qloop_126*tmp_qloop_137;
                const real_t q_tmp_1_9 = tmp_qloop_127*tmp_qloop_137;
                const real_t q_tmp_2_0 = tmp_qloop_115*tmp_qloop_142;
                const real_t q_tmp_2_1 = tmp_qloop_122*tmp_qloop_142;
                const real_t q_tmp_2_2 = tmp_qloop_123*tmp_qloop_142;
                const real_t q_tmp_2_3 = tmp_qloop_124*tmp_qloop_142;
                const real_t q_tmp_2_4 = tmp_qloop_110*tmp_qloop_142;
                const real_t q_tmp_2_5 = tmp_qloop_113*tmp_qloop_142;
                const real_t q_tmp_2_6 = tmp_qloop_112*tmp_qloop_142;
                const real_t q_tmp_2_7 = tmp_qloop_125*tmp_qloop_142;
                const real_t q_tmp_2_8 = tmp_qloop_126*tmp_qloop_142;
                const real_t q_tmp_2_9 = tmp_qloop_127*tmp_qloop_142;
                const real_t q_tmp_3_0 = tmp_qloop_115*tmp_qloop_147;
                const real_t q_tmp_3_1 = tmp_qloop_122*tmp_qloop_147;
                const real_t q_tmp_3_2 = tmp_qloop_123*tmp_qloop_147;
                const real_t q_tmp_3_3 = tmp_qloop_124*tmp_qloop_147;
                const real_t q_tmp_3_4 = tmp_qloop_110*tmp_qloop_147;
                const real_t q_tmp_3_5 = tmp_qloop_113*tmp_qloop_147;
                const real_t q_tmp_3_6 = tmp_qloop_112*tmp_qloop_147;
                const real_t q_tmp_3_7 = tmp_qloop_125*tmp_qloop_147;
                const real_t q_tmp_3_8 = tmp_qloop_126*tmp_qloop_147;
                const real_t q_tmp_3_9 = tmp_qloop_127*tmp_qloop_147;
                const real_t q_tmp_4_0 = tmp_qloop_115*tmp_qloop_157;
                const real_t q_tmp_4_1 = tmp_qloop_122*tmp_qloop_157;
                const real_t q_tmp_4_2 = tmp_qloop_123*tmp_qloop_157;
                const real_t q_tmp_4_3 = tmp_qloop_124*tmp_qloop_157;
                const real_t q_tmp_4_4 = tmp_qloop_110*tmp_qloop_157;
                const real_t q_tmp_4_5 = tmp_qloop_113*tmp_qloop_157;
                const real_t q_tmp_4_6 = tmp_qloop_112*tmp_qloop_157;
                const real_t q_tmp_4_7 = tmp_qloop_125*tmp_qloop_157;
                const real_t q_tmp_4_8 = tmp_qloop_126*tmp_qloop_157;
                const real_t q_tmp_4_9 = tmp_qloop_127*tmp_qloop_157;
                const real_t q_tmp_5_0 = tmp_qloop_115*tmp_qloop_167;
                const real_t q_tmp_5_1 = tmp_qloop_122*tmp_qloop_167;
                const real_t q_tmp_5_2 = tmp_qloop_123*tmp_qloop_167;
                const real_t q_tmp_5_3 = tmp_qloop_124*tmp_qloop_167;
                const real_t q_tmp_5_4 = tmp_qloop_110*tmp_qloop_167;
                const real_t q_tmp_5_5 = tmp_qloop_113*tmp_qloop_167;
                const real_t q_tmp_5_6 = tmp_qloop_112*tmp_qloop_167;
                const real_t q_tmp_5_7 = tmp_qloop_125*tmp_qloop_167;
                const real_t q_tmp_5_8 = tmp_qloop_126*tmp_qloop_167;
                const real_t q_tmp_5_9 = tmp_qloop_127*tmp_qloop_167;
                const real_t q_tmp_6_0 = tmp_qloop_115*tmp_qloop_177;
                const real_t q_tmp_6_1 = tmp_qloop_122*tmp_qloop_177;
                const real_t q_tmp_6_2 = tmp_qloop_123*tmp_qloop_177;
                const real_t q_tmp_6_3 = tmp_qloop_124*tmp_qloop_177;
                const real_t q_tmp_6_4 = tmp_qloop_110*tmp_qloop_177;
                const real_t q_tmp_6_5 = tmp_qloop_113*tmp_qloop_177;
                const real_t q_tmp_6_6 = tmp_qloop_112*tmp_qloop_177;
                const real_t q_tmp_6_7 = tmp_qloop_125*tmp_qloop_177;
                const real_t q_tmp_6_8 = tmp_qloop_126*tmp_qloop_177;
                const real_t q_tmp_6_9 = tmp_qloop_127*tmp_qloop_177;
                const real_t q_tmp_7_0 = tmp_qloop_115*tmp_qloop_182;
                const real_t q_tmp_7_1 = tmp_qloop_122*tmp_qloop_182;
                const real_t q_tmp_7_2 = tmp_qloop_123*tmp_qloop_182;
                const real_t q_tmp_7_3 = tmp_qloop_124*tmp_qloop_182;
                const real_t q_tmp_7_4 = tmp_qloop_110*tmp_qloop_182;
                const real_t q_tmp_7_5 = tmp_qloop_113*tmp_qloop_182;
                const real_t q_tmp_7_6 = tmp_qloop_112*tmp_qloop_182;
                const real_t q_tmp_7_7 = tmp_qloop_125*tmp_qloop_182;
                const real_t q_tmp_7_8 = tmp_qloop_126*tmp_qloop_182;
                const real_t q_tmp_7_9 = tmp_qloop_127*tmp_qloop_182;
                const real_t q_tmp_8_0 = tmp_qloop_115*tmp_qloop_188;
                const real_t q_tmp_8_1 = tmp_qloop_122*tmp_qloop_188;
                const real_t q_tmp_8_2 = tmp_qloop_123*tmp_qloop_188;
                const real_t q_tmp_8_3 = tmp_qloop_124*tmp_qloop_188;
                const real_t q_tmp_8_4 = tmp_qloop_110*tmp_qloop_188;
                const real_t q_tmp_8_5 = tmp_qloop_113*tmp_qloop_188;
                const real_t q_tmp_8_6 = tmp_qloop_112*tmp_qloop_188;
                const real_t q_tmp_8_7 = tmp_qloop_125*tmp_qloop_188;
                const real_t q_tmp_8_8 = tmp_qloop_126*tmp_qloop_188;
                const real_t q_tmp_8_9 = tmp_qloop_127*tmp_qloop_188;
                const real_t q_tmp_9_0 = tmp_qloop_115*tmp_qloop_193;
                const real_t q_tmp_9_1 = tmp_qloop_122*tmp_qloop_193;
                const real_t q_tmp_9_2 = tmp_qloop_123*tmp_qloop_193;
                const real_t q_tmp_9_3 = tmp_qloop_124*tmp_qloop_193;
                const real_t q_tmp_9_4 = tmp_qloop_110*tmp_qloop_193;
                const real_t q_tmp_9_5 = tmp_qloop_113*tmp_qloop_193;
                const real_t q_tmp_9_6 = tmp_qloop_112*tmp_qloop_193;
                const real_t q_tmp_9_7 = tmp_qloop_125*tmp_qloop_193;
                const real_t q_tmp_9_8 = tmp_qloop_126*tmp_qloop_193;
                const real_t q_tmp_9_9 = tmp_qloop_127*tmp_qloop_193;
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_4_0 = q_acc_4_0 + q_tmp_4_0;
                q_acc_4_1 = q_acc_4_1 + q_tmp_4_1;
                q_acc_4_2 = q_acc_4_2 + q_tmp_4_2;
                q_acc_4_3 = q_acc_4_3 + q_tmp_4_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_5_0 = q_acc_5_0 + q_tmp_5_0;
                q_acc_5_1 = q_acc_5_1 + q_tmp_5_1;
                q_acc_5_2 = q_acc_5_2 + q_tmp_5_2;
                q_acc_5_3 = q_acc_5_3 + q_tmp_5_3;
                q_acc_5_4 = q_acc_5_4 + q_tmp_5_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_6_0 = q_acc_6_0 + q_tmp_6_0;
                q_acc_6_1 = q_acc_6_1 + q_tmp_6_1;
                q_acc_6_2 = q_acc_6_2 + q_tmp_6_2;
                q_acc_6_3 = q_acc_6_3 + q_tmp_6_3;
                q_acc_6_4 = q_acc_6_4 + q_tmp_6_4;
                q_acc_6_5 = q_acc_6_5 + q_tmp_6_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_7_0 = q_acc_7_0 + q_tmp_7_0;
                q_acc_7_1 = q_acc_7_1 + q_tmp_7_1;
                q_acc_7_2 = q_acc_7_2 + q_tmp_7_2;
                q_acc_7_3 = q_acc_7_3 + q_tmp_7_3;
                q_acc_7_4 = q_acc_7_4 + q_tmp_7_4;
                q_acc_7_5 = q_acc_7_5 + q_tmp_7_5;
                q_acc_7_6 = q_acc_7_6 + q_tmp_7_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_8_0 = q_acc_8_0 + q_tmp_8_0;
                q_acc_8_1 = q_acc_8_1 + q_tmp_8_1;
                q_acc_8_2 = q_acc_8_2 + q_tmp_8_2;
                q_acc_8_3 = q_acc_8_3 + q_tmp_8_3;
                q_acc_8_4 = q_acc_8_4 + q_tmp_8_4;
                q_acc_8_5 = q_acc_8_5 + q_tmp_8_5;
                q_acc_8_6 = q_acc_8_6 + q_tmp_8_6;
                q_acc_8_7 = q_acc_8_7 + q_tmp_8_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_9_0 = q_acc_9_0 + q_tmp_9_0;
                q_acc_9_1 = q_acc_9_1 + q_tmp_9_1;
                q_acc_9_2 = q_acc_9_2 + q_tmp_9_2;
                q_acc_9_3 = q_acc_9_3 + q_tmp_9_3;
                q_acc_9_4 = q_acc_9_4 + q_tmp_9_4;
                q_acc_9_5 = q_acc_9_5 + q_tmp_9_5;
                q_acc_9_6 = q_acc_9_6 + q_tmp_9_6;
                q_acc_9_7 = q_acc_9_7 + q_tmp_9_7;
                q_acc_9_8 = q_acc_9_8 + q_tmp_9_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_1_0*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_2_0*src_dof_0 + q_acc_2_1*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_3_0*src_dof_0 + q_acc_3_1*src_dof_1 + q_acc_3_2*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             const real_t elMatVec_4 = q_acc_4_0*src_dof_0 + q_acc_4_1*src_dof_1 + q_acc_4_2*src_dof_2 + q_acc_4_3*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
             const real_t elMatVec_5 = q_acc_5_0*src_dof_0 + q_acc_5_1*src_dof_1 + q_acc_5_2*src_dof_2 + q_acc_5_3*src_dof_3 + q_acc_5_4*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
             const real_t elMatVec_6 = q_acc_6_0*src_dof_0 + q_acc_6_1*src_dof_1 + q_acc_6_2*src_dof_2 + q_acc_6_3*src_dof_3 + q_acc_6_4*src_dof_4 + q_acc_6_5*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
             const real_t elMatVec_7 = q_acc_7_0*src_dof_0 + q_acc_7_1*src_dof_1 + q_acc_7_2*src_dof_2 + q_acc_7_3*src_dof_3 + q_acc_7_4*src_dof_4 + q_acc_7_5*src_dof_5 + q_acc_7_6*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
             const real_t elMatVec_8 = q_acc_8_0*src_dof_0 + q_acc_8_1*src_dof_1 + q_acc_8_2*src_dof_2 + q_acc_8_3*src_dof_3 + q_acc_8_4*src_dof_4 + q_acc_8_5*src_dof_5 + q_acc_8_6*src_dof_6 + q_acc_8_7*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
             const real_t elMatVec_9 = q_acc_9_0*src_dof_0 + q_acc_9_1*src_dof_1 + q_acc_9_2*src_dof_2 + q_acc_9_3*src_dof_3 + q_acc_9_4*src_dof_4 + q_acc_9_5*src_dof_5 + q_acc_9_6*src_dof_6 + q_acc_9_7*src_dof_7 + q_acc_9_8*src_dof_8 + q_acc_9_9*src_dof_9;
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_7 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const real_t tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const real_t tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_14_WHITE_DOWN = jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
       const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const real_t tmp_coords_jac_13_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_0_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
       const real_t tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const real_t jac_affine_inv_0_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
       const real_t jac_affine_inv_0_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const real_t jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const real_t jac_affine_inv_1_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       {
          /* CellType.WHITE_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_4 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_8 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t delta_dof_0 = _data_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t delta_dof_1 = _data_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t delta_dof_2 = _data_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t delta_dof_3 = _data_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t delta_dof_4 = _data_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t delta_dof_5 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t delta_dof_6 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t delta_dof_7 = _data_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t delta_dof_8 = _data_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t delta_dof_9 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ux_dof_0 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_1 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_2 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_3 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_4 = _data_uxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ux_dof_5 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t ux_dof_6 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ux_dof_7 = _data_uxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ux_dof_8 = _data_uxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_9 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uy_dof_0 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_1 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_2 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_3 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_4 = _data_uyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uy_dof_5 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t uy_dof_6 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uy_dof_7 = _data_uyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uy_dof_8 = _data_uyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_9 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uz_dof_0 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_1 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_2 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_3 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_4 = _data_uzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uz_dof_5 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t uz_dof_6 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uz_dof_7 = _data_uzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uz_dof_8 = _data_uzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_9 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_4_0 = 0.0;
             real_t q_acc_4_1 = 0.0;
             real_t q_acc_4_2 = 0.0;
             real_t q_acc_4_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_5_0 = 0.0;
             real_t q_acc_5_1 = 0.0;
             real_t q_acc_5_2 = 0.0;
             real_t q_acc_5_3 = 0.0;
             real_t q_acc_5_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_6_0 = 0.0;
             real_t q_acc_6_1 = 0.0;
             real_t q_acc_6_2 = 0.0;
             real_t q_acc_6_3 = 0.0;
             real_t q_acc_6_4 = 0.0;
             real_t q_acc_6_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_7_0 = 0.0;
             real_t q_acc_7_1 = 0.0;
             real_t q_acc_7_2 = 0.0;
             real_t q_acc_7_3 = 0.0;
             real_t q_acc_7_4 = 0.0;
             real_t q_acc_7_5 = 0.0;
             real_t q_acc_7_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_8_0 = 0.0;
             real_t q_acc_8_1 = 0.0;
             real_t q_acc_8_2 = 0.0;
             real_t q_acc_8_3 = 0.0;
             real_t q_acc_8_4 = 0.0;
             real_t q_acc_8_5 = 0.0;
             real_t q_acc_8_6 = 0.0;
             real_t q_acc_8_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_9_0 = 0.0;
             real_t q_acc_9_1 = 0.0;
             real_t q_acc_9_2 = 0.0;
             real_t q_acc_9_3 = 0.0;
             real_t q_acc_9_4 = 0.0;
             real_t q_acc_9_5 = 0.0;
             real_t q_acc_9_6 = 0.0;
             real_t q_acc_9_7 = 0.0;
             real_t q_acc_9_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                const real_t tmp_qloop_47 = -tmp_qloop_28;
                const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_70 = -tmp_qloop_41;
                const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                const real_t tmp_qloop_103 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const real_t tmp_qloop_104 = tmp_qloop_103*2.0;
                const real_t tmp_qloop_105 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const real_t tmp_qloop_106 = tmp_qloop_105*2.0;
                const real_t tmp_qloop_107 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const real_t tmp_qloop_108 = tmp_qloop_107*2.0;
                const real_t tmp_qloop_109 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_110 = tmp_qloop_109*_data_q_p_2[q];
                const real_t tmp_qloop_111 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_112 = tmp_qloop_111*_data_q_p_1[q];
                const real_t tmp_qloop_113 = tmp_qloop_111*_data_q_p_2[q];
                const real_t tmp_qloop_114 = tmp_qloop_112 + tmp_qloop_113;
                const real_t tmp_qloop_115 = tmp_qloop_104 + tmp_qloop_106 + tmp_qloop_108 + tmp_qloop_110 + tmp_qloop_114 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0;
                const real_t tmp_qloop_116 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_117 = tmp_qloop_109 + tmp_qloop_111;
                const real_t tmp_qloop_118 = tmp_qloop_116 + tmp_qloop_117 - 3.0;
                const real_t tmp_qloop_119 = jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_118 + jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_118 + jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_118;
                const real_t tmp_qloop_120 = jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_118 + jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_118 + jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_118;
                const real_t tmp_qloop_121 = jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_118 + jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_118 + jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_118;
                const real_t tmp_qloop_122 = tmp_qloop_104 - _data_q_p_0[q];
                const real_t tmp_qloop_123 = tmp_qloop_106 - _data_q_p_1[q];
                const real_t tmp_qloop_124 = tmp_qloop_108 - _data_q_p_2[q];
                const real_t tmp_qloop_125 = tmp_qloop_107*-4.0 - tmp_qloop_110 - tmp_qloop_113 + tmp_qloop_116;
                const real_t tmp_qloop_126 = tmp_qloop_105*-4.0 + tmp_qloop_109 - tmp_qloop_110 - tmp_qloop_112;
                const real_t tmp_qloop_127 = tmp_qloop_103*-4.0 + tmp_qloop_111 - tmp_qloop_114;
                const real_t tmp_qloop_128 = tmp_qloop_110*ux_dof_4 + tmp_qloop_112*ux_dof_6 + tmp_qloop_113*ux_dof_5 + tmp_qloop_115*ux_dof_0 + tmp_qloop_122*ux_dof_1 + tmp_qloop_123*ux_dof_2 + tmp_qloop_124*ux_dof_3 + tmp_qloop_125*ux_dof_7 + tmp_qloop_126*ux_dof_8 + tmp_qloop_127*ux_dof_9;
                const real_t tmp_qloop_129 = tmp_qloop_110*uy_dof_4 + tmp_qloop_112*uy_dof_6 + tmp_qloop_113*uy_dof_5 + tmp_qloop_115*uy_dof_0 + tmp_qloop_122*uy_dof_1 + tmp_qloop_123*uy_dof_2 + tmp_qloop_124*uy_dof_3 + tmp_qloop_125*uy_dof_7 + tmp_qloop_126*uy_dof_8 + tmp_qloop_127*uy_dof_9;
                const real_t tmp_qloop_130 = tmp_qloop_110*uz_dof_4 + tmp_qloop_112*uz_dof_6 + tmp_qloop_113*uz_dof_5 + tmp_qloop_115*uz_dof_0 + tmp_qloop_122*uz_dof_1 + tmp_qloop_123*uz_dof_2 + tmp_qloop_124*uz_dof_3 + tmp_qloop_125*uz_dof_7 + tmp_qloop_126*uz_dof_8 + tmp_qloop_127*uz_dof_9;
                const real_t tmp_qloop_133 = tmp_qloop_111 - 1.0;
                const real_t tmp_qloop_134 = jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_133;
                const real_t tmp_qloop_135 = jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_133;
                const real_t tmp_qloop_136 = jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_133;
                const real_t tmp_qloop_138 = tmp_qloop_109 - 1.0;
                const real_t tmp_qloop_139 = jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_138;
                const real_t tmp_qloop_140 = jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_138;
                const real_t tmp_qloop_141 = jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_138;
                const real_t tmp_qloop_143 = tmp_qloop_116 - 1.0;
                const real_t tmp_qloop_144 = jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_143;
                const real_t tmp_qloop_145 = jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_143;
                const real_t tmp_qloop_146 = jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_143;
                const real_t tmp_qloop_148 = jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_109;
                const real_t tmp_qloop_149 = jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_116;
                const real_t tmp_qloop_150 = tmp_qloop_148 + tmp_qloop_149;
                const real_t tmp_qloop_151 = jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_109;
                const real_t tmp_qloop_152 = jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_116;
                const real_t tmp_qloop_153 = tmp_qloop_151 + tmp_qloop_152;
                const real_t tmp_qloop_154 = jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_109;
                const real_t tmp_qloop_155 = jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_116;
                const real_t tmp_qloop_156 = tmp_qloop_154 + tmp_qloop_155;
                const real_t tmp_qloop_158 = jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_111;
                const real_t tmp_qloop_159 = jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_116;
                const real_t tmp_qloop_160 = tmp_qloop_158 + tmp_qloop_159;
                const real_t tmp_qloop_161 = jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_111;
                const real_t tmp_qloop_162 = jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_116;
                const real_t tmp_qloop_163 = tmp_qloop_161 + tmp_qloop_162;
                const real_t tmp_qloop_164 = jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_111;
                const real_t tmp_qloop_165 = jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_116;
                const real_t tmp_qloop_166 = tmp_qloop_164 + tmp_qloop_165;
                const real_t tmp_qloop_168 = jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_111;
                const real_t tmp_qloop_169 = jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_109;
                const real_t tmp_qloop_170 = tmp_qloop_168 + tmp_qloop_169;
                const real_t tmp_qloop_171 = jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_111;
                const real_t tmp_qloop_172 = jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_109;
                const real_t tmp_qloop_173 = tmp_qloop_171 + tmp_qloop_172;
                const real_t tmp_qloop_174 = jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_111;
                const real_t tmp_qloop_175 = jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_109;
                const real_t tmp_qloop_176 = tmp_qloop_174 + tmp_qloop_175;
                const real_t tmp_qloop_178 = -tmp_qloop_117 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_179 = jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_178 - tmp_qloop_149 - tmp_qloop_159;
                const real_t tmp_qloop_180 = jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_178 - tmp_qloop_152 - tmp_qloop_162;
                const real_t tmp_qloop_181 = jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_178 - tmp_qloop_155 - tmp_qloop_165;
                const real_t tmp_qloop_183 = tmp_qloop_116 - 4.0;
                const real_t tmp_qloop_184 = -tmp_qloop_111 - tmp_qloop_183 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_185 = jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_184 - tmp_qloop_148 - tmp_qloop_169;
                const real_t tmp_qloop_186 = jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_184 - tmp_qloop_151 - tmp_qloop_172;
                const real_t tmp_qloop_187 = jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_184 - tmp_qloop_154 - tmp_qloop_175;
                const real_t tmp_qloop_189 = -tmp_qloop_109 - tmp_qloop_183 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_190 = jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_189 - tmp_qloop_158 - tmp_qloop_168;
                const real_t tmp_qloop_191 = jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_189 - tmp_qloop_161 - tmp_qloop_171;
                const real_t tmp_qloop_192 = jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_189 - tmp_qloop_164 - tmp_qloop_174;
                const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                const real_t abs_det_jac_blending = tmp_qloop_64;
                const real_t tmp_qloop_131 = abs_det_jac_affine_WHITE_DOWN*abs_det_jac_blending*(delta_dof_0*tmp_qloop_115 + delta_dof_1*tmp_qloop_122 + delta_dof_2*tmp_qloop_123 + delta_dof_3*tmp_qloop_124 + delta_dof_4*tmp_qloop_110 + delta_dof_5*tmp_qloop_113 + delta_dof_6*tmp_qloop_112 + delta_dof_7*tmp_qloop_125 + delta_dof_8*tmp_qloop_126 + delta_dof_9*tmp_qloop_127)*_data_q_w[q];
                const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t tmp_qloop_132 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_119 + jac_blending_inv_1_0*tmp_qloop_120 + jac_blending_inv_2_0*tmp_qloop_121) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_119 + jac_blending_inv_1_1*tmp_qloop_120 + jac_blending_inv_2_1*tmp_qloop_121) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_119 + jac_blending_inv_1_2*tmp_qloop_120 + jac_blending_inv_2_2*tmp_qloop_121));
                const real_t tmp_qloop_137 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_134 + jac_blending_inv_1_0*tmp_qloop_135 + jac_blending_inv_2_0*tmp_qloop_136) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_134 + jac_blending_inv_1_1*tmp_qloop_135 + jac_blending_inv_2_1*tmp_qloop_136) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_134 + jac_blending_inv_1_2*tmp_qloop_135 + jac_blending_inv_2_2*tmp_qloop_136));
                const real_t tmp_qloop_142 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_139 + jac_blending_inv_1_0*tmp_qloop_140 + jac_blending_inv_2_0*tmp_qloop_141) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_139 + jac_blending_inv_1_1*tmp_qloop_140 + jac_blending_inv_2_1*tmp_qloop_141) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_139 + jac_blending_inv_1_2*tmp_qloop_140 + jac_blending_inv_2_2*tmp_qloop_141));
                const real_t tmp_qloop_147 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_144 + jac_blending_inv_1_0*tmp_qloop_145 + jac_blending_inv_2_0*tmp_qloop_146) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_144 + jac_blending_inv_1_1*tmp_qloop_145 + jac_blending_inv_2_1*tmp_qloop_146) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_144 + jac_blending_inv_1_2*tmp_qloop_145 + jac_blending_inv_2_2*tmp_qloop_146));
                const real_t tmp_qloop_157 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_150 + jac_blending_inv_1_0*tmp_qloop_153 + jac_blending_inv_2_0*tmp_qloop_156) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_150 + jac_blending_inv_1_1*tmp_qloop_153 + jac_blending_inv_2_1*tmp_qloop_156) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_150 + jac_blending_inv_1_2*tmp_qloop_153 + jac_blending_inv_2_2*tmp_qloop_156));
                const real_t tmp_qloop_167 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_160 + jac_blending_inv_1_0*tmp_qloop_163 + jac_blending_inv_2_0*tmp_qloop_166) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_160 + jac_blending_inv_1_1*tmp_qloop_163 + jac_blending_inv_2_1*tmp_qloop_166) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_160 + jac_blending_inv_1_2*tmp_qloop_163 + jac_blending_inv_2_2*tmp_qloop_166));
                const real_t tmp_qloop_177 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_170 + jac_blending_inv_1_0*tmp_qloop_173 + jac_blending_inv_2_0*tmp_qloop_176) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_170 + jac_blending_inv_1_1*tmp_qloop_173 + jac_blending_inv_2_1*tmp_qloop_176) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_170 + jac_blending_inv_1_2*tmp_qloop_173 + jac_blending_inv_2_2*tmp_qloop_176));
                const real_t tmp_qloop_182 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_179 + jac_blending_inv_1_0*tmp_qloop_180 + jac_blending_inv_2_0*tmp_qloop_181) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_179 + jac_blending_inv_1_1*tmp_qloop_180 + jac_blending_inv_2_1*tmp_qloop_181) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_179 + jac_blending_inv_1_2*tmp_qloop_180 + jac_blending_inv_2_2*tmp_qloop_181));
                const real_t tmp_qloop_188 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_185 + jac_blending_inv_1_0*tmp_qloop_186 + jac_blending_inv_2_0*tmp_qloop_187) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_185 + jac_blending_inv_1_1*tmp_qloop_186 + jac_blending_inv_2_1*tmp_qloop_187) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_185 + jac_blending_inv_1_2*tmp_qloop_186 + jac_blending_inv_2_2*tmp_qloop_187));
                const real_t tmp_qloop_193 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_190 + jac_blending_inv_1_0*tmp_qloop_191 + jac_blending_inv_2_0*tmp_qloop_192) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_190 + jac_blending_inv_1_1*tmp_qloop_191 + jac_blending_inv_2_1*tmp_qloop_192) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_190 + jac_blending_inv_1_2*tmp_qloop_191 + jac_blending_inv_2_2*tmp_qloop_192));
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_115*tmp_qloop_132;
                const real_t q_tmp_0_1 = tmp_qloop_122*tmp_qloop_132;
                const real_t q_tmp_0_2 = tmp_qloop_123*tmp_qloop_132;
                const real_t q_tmp_0_3 = tmp_qloop_124*tmp_qloop_132;
                const real_t q_tmp_0_4 = tmp_qloop_110*tmp_qloop_132;
                const real_t q_tmp_0_5 = tmp_qloop_113*tmp_qloop_132;
                const real_t q_tmp_0_6 = tmp_qloop_112*tmp_qloop_132;
                const real_t q_tmp_0_7 = tmp_qloop_125*tmp_qloop_132;
                const real_t q_tmp_0_8 = tmp_qloop_126*tmp_qloop_132;
                const real_t q_tmp_0_9 = tmp_qloop_127*tmp_qloop_132;
                const real_t q_tmp_1_0 = tmp_qloop_115*tmp_qloop_137;
                const real_t q_tmp_1_1 = tmp_qloop_122*tmp_qloop_137;
                const real_t q_tmp_1_2 = tmp_qloop_123*tmp_qloop_137;
                const real_t q_tmp_1_3 = tmp_qloop_124*tmp_qloop_137;
                const real_t q_tmp_1_4 = tmp_qloop_110*tmp_qloop_137;
                const real_t q_tmp_1_5 = tmp_qloop_113*tmp_qloop_137;
                const real_t q_tmp_1_6 = tmp_qloop_112*tmp_qloop_137;
                const real_t q_tmp_1_7 = tmp_qloop_125*tmp_qloop_137;
                const real_t q_tmp_1_8 = tmp_qloop_126*tmp_qloop_137;
                const real_t q_tmp_1_9 = tmp_qloop_127*tmp_qloop_137;
                const real_t q_tmp_2_0 = tmp_qloop_115*tmp_qloop_142;
                const real_t q_tmp_2_1 = tmp_qloop_122*tmp_qloop_142;
                const real_t q_tmp_2_2 = tmp_qloop_123*tmp_qloop_142;
                const real_t q_tmp_2_3 = tmp_qloop_124*tmp_qloop_142;
                const real_t q_tmp_2_4 = tmp_qloop_110*tmp_qloop_142;
                const real_t q_tmp_2_5 = tmp_qloop_113*tmp_qloop_142;
                const real_t q_tmp_2_6 = tmp_qloop_112*tmp_qloop_142;
                const real_t q_tmp_2_7 = tmp_qloop_125*tmp_qloop_142;
                const real_t q_tmp_2_8 = tmp_qloop_126*tmp_qloop_142;
                const real_t q_tmp_2_9 = tmp_qloop_127*tmp_qloop_142;
                const real_t q_tmp_3_0 = tmp_qloop_115*tmp_qloop_147;
                const real_t q_tmp_3_1 = tmp_qloop_122*tmp_qloop_147;
                const real_t q_tmp_3_2 = tmp_qloop_123*tmp_qloop_147;
                const real_t q_tmp_3_3 = tmp_qloop_124*tmp_qloop_147;
                const real_t q_tmp_3_4 = tmp_qloop_110*tmp_qloop_147;
                const real_t q_tmp_3_5 = tmp_qloop_113*tmp_qloop_147;
                const real_t q_tmp_3_6 = tmp_qloop_112*tmp_qloop_147;
                const real_t q_tmp_3_7 = tmp_qloop_125*tmp_qloop_147;
                const real_t q_tmp_3_8 = tmp_qloop_126*tmp_qloop_147;
                const real_t q_tmp_3_9 = tmp_qloop_127*tmp_qloop_147;
                const real_t q_tmp_4_0 = tmp_qloop_115*tmp_qloop_157;
                const real_t q_tmp_4_1 = tmp_qloop_122*tmp_qloop_157;
                const real_t q_tmp_4_2 = tmp_qloop_123*tmp_qloop_157;
                const real_t q_tmp_4_3 = tmp_qloop_124*tmp_qloop_157;
                const real_t q_tmp_4_4 = tmp_qloop_110*tmp_qloop_157;
                const real_t q_tmp_4_5 = tmp_qloop_113*tmp_qloop_157;
                const real_t q_tmp_4_6 = tmp_qloop_112*tmp_qloop_157;
                const real_t q_tmp_4_7 = tmp_qloop_125*tmp_qloop_157;
                const real_t q_tmp_4_8 = tmp_qloop_126*tmp_qloop_157;
                const real_t q_tmp_4_9 = tmp_qloop_127*tmp_qloop_157;
                const real_t q_tmp_5_0 = tmp_qloop_115*tmp_qloop_167;
                const real_t q_tmp_5_1 = tmp_qloop_122*tmp_qloop_167;
                const real_t q_tmp_5_2 = tmp_qloop_123*tmp_qloop_167;
                const real_t q_tmp_5_3 = tmp_qloop_124*tmp_qloop_167;
                const real_t q_tmp_5_4 = tmp_qloop_110*tmp_qloop_167;
                const real_t q_tmp_5_5 = tmp_qloop_113*tmp_qloop_167;
                const real_t q_tmp_5_6 = tmp_qloop_112*tmp_qloop_167;
                const real_t q_tmp_5_7 = tmp_qloop_125*tmp_qloop_167;
                const real_t q_tmp_5_8 = tmp_qloop_126*tmp_qloop_167;
                const real_t q_tmp_5_9 = tmp_qloop_127*tmp_qloop_167;
                const real_t q_tmp_6_0 = tmp_qloop_115*tmp_qloop_177;
                const real_t q_tmp_6_1 = tmp_qloop_122*tmp_qloop_177;
                const real_t q_tmp_6_2 = tmp_qloop_123*tmp_qloop_177;
                const real_t q_tmp_6_3 = tmp_qloop_124*tmp_qloop_177;
                const real_t q_tmp_6_4 = tmp_qloop_110*tmp_qloop_177;
                const real_t q_tmp_6_5 = tmp_qloop_113*tmp_qloop_177;
                const real_t q_tmp_6_6 = tmp_qloop_112*tmp_qloop_177;
                const real_t q_tmp_6_7 = tmp_qloop_125*tmp_qloop_177;
                const real_t q_tmp_6_8 = tmp_qloop_126*tmp_qloop_177;
                const real_t q_tmp_6_9 = tmp_qloop_127*tmp_qloop_177;
                const real_t q_tmp_7_0 = tmp_qloop_115*tmp_qloop_182;
                const real_t q_tmp_7_1 = tmp_qloop_122*tmp_qloop_182;
                const real_t q_tmp_7_2 = tmp_qloop_123*tmp_qloop_182;
                const real_t q_tmp_7_3 = tmp_qloop_124*tmp_qloop_182;
                const real_t q_tmp_7_4 = tmp_qloop_110*tmp_qloop_182;
                const real_t q_tmp_7_5 = tmp_qloop_113*tmp_qloop_182;
                const real_t q_tmp_7_6 = tmp_qloop_112*tmp_qloop_182;
                const real_t q_tmp_7_7 = tmp_qloop_125*tmp_qloop_182;
                const real_t q_tmp_7_8 = tmp_qloop_126*tmp_qloop_182;
                const real_t q_tmp_7_9 = tmp_qloop_127*tmp_qloop_182;
                const real_t q_tmp_8_0 = tmp_qloop_115*tmp_qloop_188;
                const real_t q_tmp_8_1 = tmp_qloop_122*tmp_qloop_188;
                const real_t q_tmp_8_2 = tmp_qloop_123*tmp_qloop_188;
                const real_t q_tmp_8_3 = tmp_qloop_124*tmp_qloop_188;
                const real_t q_tmp_8_4 = tmp_qloop_110*tmp_qloop_188;
                const real_t q_tmp_8_5 = tmp_qloop_113*tmp_qloop_188;
                const real_t q_tmp_8_6 = tmp_qloop_112*tmp_qloop_188;
                const real_t q_tmp_8_7 = tmp_qloop_125*tmp_qloop_188;
                const real_t q_tmp_8_8 = tmp_qloop_126*tmp_qloop_188;
                const real_t q_tmp_8_9 = tmp_qloop_127*tmp_qloop_188;
                const real_t q_tmp_9_0 = tmp_qloop_115*tmp_qloop_193;
                const real_t q_tmp_9_1 = tmp_qloop_122*tmp_qloop_193;
                const real_t q_tmp_9_2 = tmp_qloop_123*tmp_qloop_193;
                const real_t q_tmp_9_3 = tmp_qloop_124*tmp_qloop_193;
                const real_t q_tmp_9_4 = tmp_qloop_110*tmp_qloop_193;
                const real_t q_tmp_9_5 = tmp_qloop_113*tmp_qloop_193;
                const real_t q_tmp_9_6 = tmp_qloop_112*tmp_qloop_193;
                const real_t q_tmp_9_7 = tmp_qloop_125*tmp_qloop_193;
                const real_t q_tmp_9_8 = tmp_qloop_126*tmp_qloop_193;
                const real_t q_tmp_9_9 = tmp_qloop_127*tmp_qloop_193;
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_4_0 = q_acc_4_0 + q_tmp_4_0;
                q_acc_4_1 = q_acc_4_1 + q_tmp_4_1;
                q_acc_4_2 = q_acc_4_2 + q_tmp_4_2;
                q_acc_4_3 = q_acc_4_3 + q_tmp_4_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_5_0 = q_acc_5_0 + q_tmp_5_0;
                q_acc_5_1 = q_acc_5_1 + q_tmp_5_1;
                q_acc_5_2 = q_acc_5_2 + q_tmp_5_2;
                q_acc_5_3 = q_acc_5_3 + q_tmp_5_3;
                q_acc_5_4 = q_acc_5_4 + q_tmp_5_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_6_0 = q_acc_6_0 + q_tmp_6_0;
                q_acc_6_1 = q_acc_6_1 + q_tmp_6_1;
                q_acc_6_2 = q_acc_6_2 + q_tmp_6_2;
                q_acc_6_3 = q_acc_6_3 + q_tmp_6_3;
                q_acc_6_4 = q_acc_6_4 + q_tmp_6_4;
                q_acc_6_5 = q_acc_6_5 + q_tmp_6_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_7_0 = q_acc_7_0 + q_tmp_7_0;
                q_acc_7_1 = q_acc_7_1 + q_tmp_7_1;
                q_acc_7_2 = q_acc_7_2 + q_tmp_7_2;
                q_acc_7_3 = q_acc_7_3 + q_tmp_7_3;
                q_acc_7_4 = q_acc_7_4 + q_tmp_7_4;
                q_acc_7_5 = q_acc_7_5 + q_tmp_7_5;
                q_acc_7_6 = q_acc_7_6 + q_tmp_7_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_8_0 = q_acc_8_0 + q_tmp_8_0;
                q_acc_8_1 = q_acc_8_1 + q_tmp_8_1;
                q_acc_8_2 = q_acc_8_2 + q_tmp_8_2;
                q_acc_8_3 = q_acc_8_3 + q_tmp_8_3;
                q_acc_8_4 = q_acc_8_4 + q_tmp_8_4;
                q_acc_8_5 = q_acc_8_5 + q_tmp_8_5;
                q_acc_8_6 = q_acc_8_6 + q_tmp_8_6;
                q_acc_8_7 = q_acc_8_7 + q_tmp_8_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_9_0 = q_acc_9_0 + q_tmp_9_0;
                q_acc_9_1 = q_acc_9_1 + q_tmp_9_1;
                q_acc_9_2 = q_acc_9_2 + q_tmp_9_2;
                q_acc_9_3 = q_acc_9_3 + q_tmp_9_3;
                q_acc_9_4 = q_acc_9_4 + q_tmp_9_4;
                q_acc_9_5 = q_acc_9_5 + q_tmp_9_5;
                q_acc_9_6 = q_acc_9_6 + q_tmp_9_6;
                q_acc_9_7 = q_acc_9_7 + q_tmp_9_7;
                q_acc_9_8 = q_acc_9_8 + q_tmp_9_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_1_0*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_2_0*src_dof_0 + q_acc_2_1*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_3_0*src_dof_0 + q_acc_3_1*src_dof_1 + q_acc_3_2*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             const real_t elMatVec_4 = q_acc_4_0*src_dof_0 + q_acc_4_1*src_dof_1 + q_acc_4_2*src_dof_2 + q_acc_4_3*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
             const real_t elMatVec_5 = q_acc_5_0*src_dof_0 + q_acc_5_1*src_dof_1 + q_acc_5_2*src_dof_2 + q_acc_5_3*src_dof_3 + q_acc_5_4*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
             const real_t elMatVec_6 = q_acc_6_0*src_dof_0 + q_acc_6_1*src_dof_1 + q_acc_6_2*src_dof_2 + q_acc_6_3*src_dof_3 + q_acc_6_4*src_dof_4 + q_acc_6_5*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
             const real_t elMatVec_7 = q_acc_7_0*src_dof_0 + q_acc_7_1*src_dof_1 + q_acc_7_2*src_dof_2 + q_acc_7_3*src_dof_3 + q_acc_7_4*src_dof_4 + q_acc_7_5*src_dof_5 + q_acc_7_6*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
             const real_t elMatVec_8 = q_acc_8_0*src_dof_0 + q_acc_8_1*src_dof_1 + q_acc_8_2*src_dof_2 + q_acc_8_3*src_dof_3 + q_acc_8_4*src_dof_4 + q_acc_8_5*src_dof_5 + q_acc_8_6*src_dof_6 + q_acc_8_7*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
             const real_t elMatVec_9 = q_acc_9_0*src_dof_0 + q_acc_9_1*src_dof_1 + q_acc_9_2*src_dof_2 + q_acc_9_3*src_dof_3 + q_acc_9_4*src_dof_4 + q_acc_9_5*src_dof_5 + q_acc_9_6*src_dof_6 + q_acc_9_7*src_dof_7 + q_acc_9_8*src_dof_8 + q_acc_9_9*src_dof_9;
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_7 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
          }
       }
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const real_t tmp_coords_jac_11_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const real_t tmp_coords_jac_9_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const real_t tmp_coords_jac_8_BLUE_UP = jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP;
       const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const real_t tmp_coords_jac_7_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_10_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_12_BLUE_UP = jac_affine_0_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_0_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_0_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
       const real_t tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const real_t jac_affine_inv_0_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
       const real_t jac_affine_inv_0_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_2_1_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const real_t jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const real_t jac_affine_inv_1_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t jac_affine_inv_2_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       {
          /* CellType.BLUE_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_6 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t delta_dof_0 = _data_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t delta_dof_1 = _data_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t delta_dof_2 = _data_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t delta_dof_3 = _data_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t delta_dof_4 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t delta_dof_5 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t delta_dof_6 = _data_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t delta_dof_7 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t delta_dof_8 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t delta_dof_9 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_0 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_1 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_2 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_3 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_4 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ux_dof_5 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ux_dof_6 = _data_uxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_7 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ux_dof_8 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ux_dof_9 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_0 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_1 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_2 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_3 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_4 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uy_dof_5 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uy_dof_6 = _data_uyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_7 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uy_dof_8 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uy_dof_9 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_0 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_1 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_2 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_3 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_4 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uz_dof_5 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uz_dof_6 = _data_uzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_7 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uz_dof_8 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uz_dof_9 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_4_0 = 0.0;
             real_t q_acc_4_1 = 0.0;
             real_t q_acc_4_2 = 0.0;
             real_t q_acc_4_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_5_0 = 0.0;
             real_t q_acc_5_1 = 0.0;
             real_t q_acc_5_2 = 0.0;
             real_t q_acc_5_3 = 0.0;
             real_t q_acc_5_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_6_0 = 0.0;
             real_t q_acc_6_1 = 0.0;
             real_t q_acc_6_2 = 0.0;
             real_t q_acc_6_3 = 0.0;
             real_t q_acc_6_4 = 0.0;
             real_t q_acc_6_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_7_0 = 0.0;
             real_t q_acc_7_1 = 0.0;
             real_t q_acc_7_2 = 0.0;
             real_t q_acc_7_3 = 0.0;
             real_t q_acc_7_4 = 0.0;
             real_t q_acc_7_5 = 0.0;
             real_t q_acc_7_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_8_0 = 0.0;
             real_t q_acc_8_1 = 0.0;
             real_t q_acc_8_2 = 0.0;
             real_t q_acc_8_3 = 0.0;
             real_t q_acc_8_4 = 0.0;
             real_t q_acc_8_5 = 0.0;
             real_t q_acc_8_6 = 0.0;
             real_t q_acc_8_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_9_0 = 0.0;
             real_t q_acc_9_1 = 0.0;
             real_t q_acc_9_2 = 0.0;
             real_t q_acc_9_3 = 0.0;
             real_t q_acc_9_4 = 0.0;
             real_t q_acc_9_5 = 0.0;
             real_t q_acc_9_6 = 0.0;
             real_t q_acc_9_7 = 0.0;
             real_t q_acc_9_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                const real_t tmp_qloop_47 = -tmp_qloop_28;
                const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_70 = -tmp_qloop_41;
                const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                const real_t tmp_qloop_103 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const real_t tmp_qloop_104 = tmp_qloop_103*2.0;
                const real_t tmp_qloop_105 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const real_t tmp_qloop_106 = tmp_qloop_105*2.0;
                const real_t tmp_qloop_107 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const real_t tmp_qloop_108 = tmp_qloop_107*2.0;
                const real_t tmp_qloop_109 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_110 = tmp_qloop_109*_data_q_p_2[q];
                const real_t tmp_qloop_111 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_112 = tmp_qloop_111*_data_q_p_1[q];
                const real_t tmp_qloop_113 = tmp_qloop_111*_data_q_p_2[q];
                const real_t tmp_qloop_114 = tmp_qloop_112 + tmp_qloop_113;
                const real_t tmp_qloop_115 = tmp_qloop_104 + tmp_qloop_106 + tmp_qloop_108 + tmp_qloop_110 + tmp_qloop_114 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0;
                const real_t tmp_qloop_116 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_117 = tmp_qloop_109 + tmp_qloop_111;
                const real_t tmp_qloop_118 = tmp_qloop_116 + tmp_qloop_117 - 3.0;
                const real_t tmp_qloop_119 = jac_affine_inv_0_0_BLUE_UP*tmp_qloop_118 + jac_affine_inv_1_0_BLUE_UP*tmp_qloop_118 + jac_affine_inv_2_0_BLUE_UP*tmp_qloop_118;
                const real_t tmp_qloop_120 = jac_affine_inv_0_1_BLUE_UP*tmp_qloop_118 + jac_affine_inv_1_1_BLUE_UP*tmp_qloop_118 + jac_affine_inv_2_1_BLUE_UP*tmp_qloop_118;
                const real_t tmp_qloop_121 = jac_affine_inv_0_2_BLUE_UP*tmp_qloop_118 + jac_affine_inv_1_2_BLUE_UP*tmp_qloop_118 + jac_affine_inv_2_2_BLUE_UP*tmp_qloop_118;
                const real_t tmp_qloop_122 = tmp_qloop_104 - _data_q_p_0[q];
                const real_t tmp_qloop_123 = tmp_qloop_106 - _data_q_p_1[q];
                const real_t tmp_qloop_124 = tmp_qloop_108 - _data_q_p_2[q];
                const real_t tmp_qloop_125 = tmp_qloop_107*-4.0 - tmp_qloop_110 - tmp_qloop_113 + tmp_qloop_116;
                const real_t tmp_qloop_126 = tmp_qloop_105*-4.0 + tmp_qloop_109 - tmp_qloop_110 - tmp_qloop_112;
                const real_t tmp_qloop_127 = tmp_qloop_103*-4.0 + tmp_qloop_111 - tmp_qloop_114;
                const real_t tmp_qloop_128 = tmp_qloop_110*ux_dof_4 + tmp_qloop_112*ux_dof_6 + tmp_qloop_113*ux_dof_5 + tmp_qloop_115*ux_dof_0 + tmp_qloop_122*ux_dof_1 + tmp_qloop_123*ux_dof_2 + tmp_qloop_124*ux_dof_3 + tmp_qloop_125*ux_dof_7 + tmp_qloop_126*ux_dof_8 + tmp_qloop_127*ux_dof_9;
                const real_t tmp_qloop_129 = tmp_qloop_110*uy_dof_4 + tmp_qloop_112*uy_dof_6 + tmp_qloop_113*uy_dof_5 + tmp_qloop_115*uy_dof_0 + tmp_qloop_122*uy_dof_1 + tmp_qloop_123*uy_dof_2 + tmp_qloop_124*uy_dof_3 + tmp_qloop_125*uy_dof_7 + tmp_qloop_126*uy_dof_8 + tmp_qloop_127*uy_dof_9;
                const real_t tmp_qloop_130 = tmp_qloop_110*uz_dof_4 + tmp_qloop_112*uz_dof_6 + tmp_qloop_113*uz_dof_5 + tmp_qloop_115*uz_dof_0 + tmp_qloop_122*uz_dof_1 + tmp_qloop_123*uz_dof_2 + tmp_qloop_124*uz_dof_3 + tmp_qloop_125*uz_dof_7 + tmp_qloop_126*uz_dof_8 + tmp_qloop_127*uz_dof_9;
                const real_t tmp_qloop_133 = tmp_qloop_111 - 1.0;
                const real_t tmp_qloop_134 = jac_affine_inv_0_0_BLUE_UP*tmp_qloop_133;
                const real_t tmp_qloop_135 = jac_affine_inv_0_1_BLUE_UP*tmp_qloop_133;
                const real_t tmp_qloop_136 = jac_affine_inv_0_2_BLUE_UP*tmp_qloop_133;
                const real_t tmp_qloop_138 = tmp_qloop_109 - 1.0;
                const real_t tmp_qloop_139 = jac_affine_inv_1_0_BLUE_UP*tmp_qloop_138;
                const real_t tmp_qloop_140 = jac_affine_inv_1_1_BLUE_UP*tmp_qloop_138;
                const real_t tmp_qloop_141 = jac_affine_inv_1_2_BLUE_UP*tmp_qloop_138;
                const real_t tmp_qloop_143 = tmp_qloop_116 - 1.0;
                const real_t tmp_qloop_144 = jac_affine_inv_2_0_BLUE_UP*tmp_qloop_143;
                const real_t tmp_qloop_145 = jac_affine_inv_2_1_BLUE_UP*tmp_qloop_143;
                const real_t tmp_qloop_146 = jac_affine_inv_2_2_BLUE_UP*tmp_qloop_143;
                const real_t tmp_qloop_148 = jac_affine_inv_2_0_BLUE_UP*tmp_qloop_109;
                const real_t tmp_qloop_149 = jac_affine_inv_1_0_BLUE_UP*tmp_qloop_116;
                const real_t tmp_qloop_150 = tmp_qloop_148 + tmp_qloop_149;
                const real_t tmp_qloop_151 = jac_affine_inv_2_1_BLUE_UP*tmp_qloop_109;
                const real_t tmp_qloop_152 = jac_affine_inv_1_1_BLUE_UP*tmp_qloop_116;
                const real_t tmp_qloop_153 = tmp_qloop_151 + tmp_qloop_152;
                const real_t tmp_qloop_154 = jac_affine_inv_2_2_BLUE_UP*tmp_qloop_109;
                const real_t tmp_qloop_155 = jac_affine_inv_1_2_BLUE_UP*tmp_qloop_116;
                const real_t tmp_qloop_156 = tmp_qloop_154 + tmp_qloop_155;
                const real_t tmp_qloop_158 = jac_affine_inv_2_0_BLUE_UP*tmp_qloop_111;
                const real_t tmp_qloop_159 = jac_affine_inv_0_0_BLUE_UP*tmp_qloop_116;
                const real_t tmp_qloop_160 = tmp_qloop_158 + tmp_qloop_159;
                const real_t tmp_qloop_161 = jac_affine_inv_2_1_BLUE_UP*tmp_qloop_111;
                const real_t tmp_qloop_162 = jac_affine_inv_0_1_BLUE_UP*tmp_qloop_116;
                const real_t tmp_qloop_163 = tmp_qloop_161 + tmp_qloop_162;
                const real_t tmp_qloop_164 = jac_affine_inv_2_2_BLUE_UP*tmp_qloop_111;
                const real_t tmp_qloop_165 = jac_affine_inv_0_2_BLUE_UP*tmp_qloop_116;
                const real_t tmp_qloop_166 = tmp_qloop_164 + tmp_qloop_165;
                const real_t tmp_qloop_168 = jac_affine_inv_1_0_BLUE_UP*tmp_qloop_111;
                const real_t tmp_qloop_169 = jac_affine_inv_0_0_BLUE_UP*tmp_qloop_109;
                const real_t tmp_qloop_170 = tmp_qloop_168 + tmp_qloop_169;
                const real_t tmp_qloop_171 = jac_affine_inv_1_1_BLUE_UP*tmp_qloop_111;
                const real_t tmp_qloop_172 = jac_affine_inv_0_1_BLUE_UP*tmp_qloop_109;
                const real_t tmp_qloop_173 = tmp_qloop_171 + tmp_qloop_172;
                const real_t tmp_qloop_174 = jac_affine_inv_1_2_BLUE_UP*tmp_qloop_111;
                const real_t tmp_qloop_175 = jac_affine_inv_0_2_BLUE_UP*tmp_qloop_109;
                const real_t tmp_qloop_176 = tmp_qloop_174 + tmp_qloop_175;
                const real_t tmp_qloop_178 = -tmp_qloop_117 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_179 = jac_affine_inv_2_0_BLUE_UP*tmp_qloop_178 - tmp_qloop_149 - tmp_qloop_159;
                const real_t tmp_qloop_180 = jac_affine_inv_2_1_BLUE_UP*tmp_qloop_178 - tmp_qloop_152 - tmp_qloop_162;
                const real_t tmp_qloop_181 = jac_affine_inv_2_2_BLUE_UP*tmp_qloop_178 - tmp_qloop_155 - tmp_qloop_165;
                const real_t tmp_qloop_183 = tmp_qloop_116 - 4.0;
                const real_t tmp_qloop_184 = -tmp_qloop_111 - tmp_qloop_183 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_185 = jac_affine_inv_1_0_BLUE_UP*tmp_qloop_184 - tmp_qloop_148 - tmp_qloop_169;
                const real_t tmp_qloop_186 = jac_affine_inv_1_1_BLUE_UP*tmp_qloop_184 - tmp_qloop_151 - tmp_qloop_172;
                const real_t tmp_qloop_187 = jac_affine_inv_1_2_BLUE_UP*tmp_qloop_184 - tmp_qloop_154 - tmp_qloop_175;
                const real_t tmp_qloop_189 = -tmp_qloop_109 - tmp_qloop_183 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_190 = jac_affine_inv_0_0_BLUE_UP*tmp_qloop_189 - tmp_qloop_158 - tmp_qloop_168;
                const real_t tmp_qloop_191 = jac_affine_inv_0_1_BLUE_UP*tmp_qloop_189 - tmp_qloop_161 - tmp_qloop_171;
                const real_t tmp_qloop_192 = jac_affine_inv_0_2_BLUE_UP*tmp_qloop_189 - tmp_qloop_164 - tmp_qloop_174;
                const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                const real_t abs_det_jac_blending = tmp_qloop_64;
                const real_t tmp_qloop_131 = abs_det_jac_affine_BLUE_UP*abs_det_jac_blending*(delta_dof_0*tmp_qloop_115 + delta_dof_1*tmp_qloop_122 + delta_dof_2*tmp_qloop_123 + delta_dof_3*tmp_qloop_124 + delta_dof_4*tmp_qloop_110 + delta_dof_5*tmp_qloop_113 + delta_dof_6*tmp_qloop_112 + delta_dof_7*tmp_qloop_125 + delta_dof_8*tmp_qloop_126 + delta_dof_9*tmp_qloop_127)*_data_q_w[q];
                const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t tmp_qloop_132 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_119 + jac_blending_inv_1_0*tmp_qloop_120 + jac_blending_inv_2_0*tmp_qloop_121) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_119 + jac_blending_inv_1_1*tmp_qloop_120 + jac_blending_inv_2_1*tmp_qloop_121) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_119 + jac_blending_inv_1_2*tmp_qloop_120 + jac_blending_inv_2_2*tmp_qloop_121));
                const real_t tmp_qloop_137 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_134 + jac_blending_inv_1_0*tmp_qloop_135 + jac_blending_inv_2_0*tmp_qloop_136) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_134 + jac_blending_inv_1_1*tmp_qloop_135 + jac_blending_inv_2_1*tmp_qloop_136) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_134 + jac_blending_inv_1_2*tmp_qloop_135 + jac_blending_inv_2_2*tmp_qloop_136));
                const real_t tmp_qloop_142 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_139 + jac_blending_inv_1_0*tmp_qloop_140 + jac_blending_inv_2_0*tmp_qloop_141) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_139 + jac_blending_inv_1_1*tmp_qloop_140 + jac_blending_inv_2_1*tmp_qloop_141) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_139 + jac_blending_inv_1_2*tmp_qloop_140 + jac_blending_inv_2_2*tmp_qloop_141));
                const real_t tmp_qloop_147 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_144 + jac_blending_inv_1_0*tmp_qloop_145 + jac_blending_inv_2_0*tmp_qloop_146) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_144 + jac_blending_inv_1_1*tmp_qloop_145 + jac_blending_inv_2_1*tmp_qloop_146) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_144 + jac_blending_inv_1_2*tmp_qloop_145 + jac_blending_inv_2_2*tmp_qloop_146));
                const real_t tmp_qloop_157 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_150 + jac_blending_inv_1_0*tmp_qloop_153 + jac_blending_inv_2_0*tmp_qloop_156) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_150 + jac_blending_inv_1_1*tmp_qloop_153 + jac_blending_inv_2_1*tmp_qloop_156) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_150 + jac_blending_inv_1_2*tmp_qloop_153 + jac_blending_inv_2_2*tmp_qloop_156));
                const real_t tmp_qloop_167 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_160 + jac_blending_inv_1_0*tmp_qloop_163 + jac_blending_inv_2_0*tmp_qloop_166) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_160 + jac_blending_inv_1_1*tmp_qloop_163 + jac_blending_inv_2_1*tmp_qloop_166) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_160 + jac_blending_inv_1_2*tmp_qloop_163 + jac_blending_inv_2_2*tmp_qloop_166));
                const real_t tmp_qloop_177 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_170 + jac_blending_inv_1_0*tmp_qloop_173 + jac_blending_inv_2_0*tmp_qloop_176) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_170 + jac_blending_inv_1_1*tmp_qloop_173 + jac_blending_inv_2_1*tmp_qloop_176) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_170 + jac_blending_inv_1_2*tmp_qloop_173 + jac_blending_inv_2_2*tmp_qloop_176));
                const real_t tmp_qloop_182 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_179 + jac_blending_inv_1_0*tmp_qloop_180 + jac_blending_inv_2_0*tmp_qloop_181) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_179 + jac_blending_inv_1_1*tmp_qloop_180 + jac_blending_inv_2_1*tmp_qloop_181) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_179 + jac_blending_inv_1_2*tmp_qloop_180 + jac_blending_inv_2_2*tmp_qloop_181));
                const real_t tmp_qloop_188 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_185 + jac_blending_inv_1_0*tmp_qloop_186 + jac_blending_inv_2_0*tmp_qloop_187) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_185 + jac_blending_inv_1_1*tmp_qloop_186 + jac_blending_inv_2_1*tmp_qloop_187) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_185 + jac_blending_inv_1_2*tmp_qloop_186 + jac_blending_inv_2_2*tmp_qloop_187));
                const real_t tmp_qloop_193 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_190 + jac_blending_inv_1_0*tmp_qloop_191 + jac_blending_inv_2_0*tmp_qloop_192) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_190 + jac_blending_inv_1_1*tmp_qloop_191 + jac_blending_inv_2_1*tmp_qloop_192) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_190 + jac_blending_inv_1_2*tmp_qloop_191 + jac_blending_inv_2_2*tmp_qloop_192));
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_115*tmp_qloop_132;
                const real_t q_tmp_0_1 = tmp_qloop_122*tmp_qloop_132;
                const real_t q_tmp_0_2 = tmp_qloop_123*tmp_qloop_132;
                const real_t q_tmp_0_3 = tmp_qloop_124*tmp_qloop_132;
                const real_t q_tmp_0_4 = tmp_qloop_110*tmp_qloop_132;
                const real_t q_tmp_0_5 = tmp_qloop_113*tmp_qloop_132;
                const real_t q_tmp_0_6 = tmp_qloop_112*tmp_qloop_132;
                const real_t q_tmp_0_7 = tmp_qloop_125*tmp_qloop_132;
                const real_t q_tmp_0_8 = tmp_qloop_126*tmp_qloop_132;
                const real_t q_tmp_0_9 = tmp_qloop_127*tmp_qloop_132;
                const real_t q_tmp_1_0 = tmp_qloop_115*tmp_qloop_137;
                const real_t q_tmp_1_1 = tmp_qloop_122*tmp_qloop_137;
                const real_t q_tmp_1_2 = tmp_qloop_123*tmp_qloop_137;
                const real_t q_tmp_1_3 = tmp_qloop_124*tmp_qloop_137;
                const real_t q_tmp_1_4 = tmp_qloop_110*tmp_qloop_137;
                const real_t q_tmp_1_5 = tmp_qloop_113*tmp_qloop_137;
                const real_t q_tmp_1_6 = tmp_qloop_112*tmp_qloop_137;
                const real_t q_tmp_1_7 = tmp_qloop_125*tmp_qloop_137;
                const real_t q_tmp_1_8 = tmp_qloop_126*tmp_qloop_137;
                const real_t q_tmp_1_9 = tmp_qloop_127*tmp_qloop_137;
                const real_t q_tmp_2_0 = tmp_qloop_115*tmp_qloop_142;
                const real_t q_tmp_2_1 = tmp_qloop_122*tmp_qloop_142;
                const real_t q_tmp_2_2 = tmp_qloop_123*tmp_qloop_142;
                const real_t q_tmp_2_3 = tmp_qloop_124*tmp_qloop_142;
                const real_t q_tmp_2_4 = tmp_qloop_110*tmp_qloop_142;
                const real_t q_tmp_2_5 = tmp_qloop_113*tmp_qloop_142;
                const real_t q_tmp_2_6 = tmp_qloop_112*tmp_qloop_142;
                const real_t q_tmp_2_7 = tmp_qloop_125*tmp_qloop_142;
                const real_t q_tmp_2_8 = tmp_qloop_126*tmp_qloop_142;
                const real_t q_tmp_2_9 = tmp_qloop_127*tmp_qloop_142;
                const real_t q_tmp_3_0 = tmp_qloop_115*tmp_qloop_147;
                const real_t q_tmp_3_1 = tmp_qloop_122*tmp_qloop_147;
                const real_t q_tmp_3_2 = tmp_qloop_123*tmp_qloop_147;
                const real_t q_tmp_3_3 = tmp_qloop_124*tmp_qloop_147;
                const real_t q_tmp_3_4 = tmp_qloop_110*tmp_qloop_147;
                const real_t q_tmp_3_5 = tmp_qloop_113*tmp_qloop_147;
                const real_t q_tmp_3_6 = tmp_qloop_112*tmp_qloop_147;
                const real_t q_tmp_3_7 = tmp_qloop_125*tmp_qloop_147;
                const real_t q_tmp_3_8 = tmp_qloop_126*tmp_qloop_147;
                const real_t q_tmp_3_9 = tmp_qloop_127*tmp_qloop_147;
                const real_t q_tmp_4_0 = tmp_qloop_115*tmp_qloop_157;
                const real_t q_tmp_4_1 = tmp_qloop_122*tmp_qloop_157;
                const real_t q_tmp_4_2 = tmp_qloop_123*tmp_qloop_157;
                const real_t q_tmp_4_3 = tmp_qloop_124*tmp_qloop_157;
                const real_t q_tmp_4_4 = tmp_qloop_110*tmp_qloop_157;
                const real_t q_tmp_4_5 = tmp_qloop_113*tmp_qloop_157;
                const real_t q_tmp_4_6 = tmp_qloop_112*tmp_qloop_157;
                const real_t q_tmp_4_7 = tmp_qloop_125*tmp_qloop_157;
                const real_t q_tmp_4_8 = tmp_qloop_126*tmp_qloop_157;
                const real_t q_tmp_4_9 = tmp_qloop_127*tmp_qloop_157;
                const real_t q_tmp_5_0 = tmp_qloop_115*tmp_qloop_167;
                const real_t q_tmp_5_1 = tmp_qloop_122*tmp_qloop_167;
                const real_t q_tmp_5_2 = tmp_qloop_123*tmp_qloop_167;
                const real_t q_tmp_5_3 = tmp_qloop_124*tmp_qloop_167;
                const real_t q_tmp_5_4 = tmp_qloop_110*tmp_qloop_167;
                const real_t q_tmp_5_5 = tmp_qloop_113*tmp_qloop_167;
                const real_t q_tmp_5_6 = tmp_qloop_112*tmp_qloop_167;
                const real_t q_tmp_5_7 = tmp_qloop_125*tmp_qloop_167;
                const real_t q_tmp_5_8 = tmp_qloop_126*tmp_qloop_167;
                const real_t q_tmp_5_9 = tmp_qloop_127*tmp_qloop_167;
                const real_t q_tmp_6_0 = tmp_qloop_115*tmp_qloop_177;
                const real_t q_tmp_6_1 = tmp_qloop_122*tmp_qloop_177;
                const real_t q_tmp_6_2 = tmp_qloop_123*tmp_qloop_177;
                const real_t q_tmp_6_3 = tmp_qloop_124*tmp_qloop_177;
                const real_t q_tmp_6_4 = tmp_qloop_110*tmp_qloop_177;
                const real_t q_tmp_6_5 = tmp_qloop_113*tmp_qloop_177;
                const real_t q_tmp_6_6 = tmp_qloop_112*tmp_qloop_177;
                const real_t q_tmp_6_7 = tmp_qloop_125*tmp_qloop_177;
                const real_t q_tmp_6_8 = tmp_qloop_126*tmp_qloop_177;
                const real_t q_tmp_6_9 = tmp_qloop_127*tmp_qloop_177;
                const real_t q_tmp_7_0 = tmp_qloop_115*tmp_qloop_182;
                const real_t q_tmp_7_1 = tmp_qloop_122*tmp_qloop_182;
                const real_t q_tmp_7_2 = tmp_qloop_123*tmp_qloop_182;
                const real_t q_tmp_7_3 = tmp_qloop_124*tmp_qloop_182;
                const real_t q_tmp_7_4 = tmp_qloop_110*tmp_qloop_182;
                const real_t q_tmp_7_5 = tmp_qloop_113*tmp_qloop_182;
                const real_t q_tmp_7_6 = tmp_qloop_112*tmp_qloop_182;
                const real_t q_tmp_7_7 = tmp_qloop_125*tmp_qloop_182;
                const real_t q_tmp_7_8 = tmp_qloop_126*tmp_qloop_182;
                const real_t q_tmp_7_9 = tmp_qloop_127*tmp_qloop_182;
                const real_t q_tmp_8_0 = tmp_qloop_115*tmp_qloop_188;
                const real_t q_tmp_8_1 = tmp_qloop_122*tmp_qloop_188;
                const real_t q_tmp_8_2 = tmp_qloop_123*tmp_qloop_188;
                const real_t q_tmp_8_3 = tmp_qloop_124*tmp_qloop_188;
                const real_t q_tmp_8_4 = tmp_qloop_110*tmp_qloop_188;
                const real_t q_tmp_8_5 = tmp_qloop_113*tmp_qloop_188;
                const real_t q_tmp_8_6 = tmp_qloop_112*tmp_qloop_188;
                const real_t q_tmp_8_7 = tmp_qloop_125*tmp_qloop_188;
                const real_t q_tmp_8_8 = tmp_qloop_126*tmp_qloop_188;
                const real_t q_tmp_8_9 = tmp_qloop_127*tmp_qloop_188;
                const real_t q_tmp_9_0 = tmp_qloop_115*tmp_qloop_193;
                const real_t q_tmp_9_1 = tmp_qloop_122*tmp_qloop_193;
                const real_t q_tmp_9_2 = tmp_qloop_123*tmp_qloop_193;
                const real_t q_tmp_9_3 = tmp_qloop_124*tmp_qloop_193;
                const real_t q_tmp_9_4 = tmp_qloop_110*tmp_qloop_193;
                const real_t q_tmp_9_5 = tmp_qloop_113*tmp_qloop_193;
                const real_t q_tmp_9_6 = tmp_qloop_112*tmp_qloop_193;
                const real_t q_tmp_9_7 = tmp_qloop_125*tmp_qloop_193;
                const real_t q_tmp_9_8 = tmp_qloop_126*tmp_qloop_193;
                const real_t q_tmp_9_9 = tmp_qloop_127*tmp_qloop_193;
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_4_0 = q_acc_4_0 + q_tmp_4_0;
                q_acc_4_1 = q_acc_4_1 + q_tmp_4_1;
                q_acc_4_2 = q_acc_4_2 + q_tmp_4_2;
                q_acc_4_3 = q_acc_4_3 + q_tmp_4_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_5_0 = q_acc_5_0 + q_tmp_5_0;
                q_acc_5_1 = q_acc_5_1 + q_tmp_5_1;
                q_acc_5_2 = q_acc_5_2 + q_tmp_5_2;
                q_acc_5_3 = q_acc_5_3 + q_tmp_5_3;
                q_acc_5_4 = q_acc_5_4 + q_tmp_5_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_6_0 = q_acc_6_0 + q_tmp_6_0;
                q_acc_6_1 = q_acc_6_1 + q_tmp_6_1;
                q_acc_6_2 = q_acc_6_2 + q_tmp_6_2;
                q_acc_6_3 = q_acc_6_3 + q_tmp_6_3;
                q_acc_6_4 = q_acc_6_4 + q_tmp_6_4;
                q_acc_6_5 = q_acc_6_5 + q_tmp_6_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_7_0 = q_acc_7_0 + q_tmp_7_0;
                q_acc_7_1 = q_acc_7_1 + q_tmp_7_1;
                q_acc_7_2 = q_acc_7_2 + q_tmp_7_2;
                q_acc_7_3 = q_acc_7_3 + q_tmp_7_3;
                q_acc_7_4 = q_acc_7_4 + q_tmp_7_4;
                q_acc_7_5 = q_acc_7_5 + q_tmp_7_5;
                q_acc_7_6 = q_acc_7_6 + q_tmp_7_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_8_0 = q_acc_8_0 + q_tmp_8_0;
                q_acc_8_1 = q_acc_8_1 + q_tmp_8_1;
                q_acc_8_2 = q_acc_8_2 + q_tmp_8_2;
                q_acc_8_3 = q_acc_8_3 + q_tmp_8_3;
                q_acc_8_4 = q_acc_8_4 + q_tmp_8_4;
                q_acc_8_5 = q_acc_8_5 + q_tmp_8_5;
                q_acc_8_6 = q_acc_8_6 + q_tmp_8_6;
                q_acc_8_7 = q_acc_8_7 + q_tmp_8_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_9_0 = q_acc_9_0 + q_tmp_9_0;
                q_acc_9_1 = q_acc_9_1 + q_tmp_9_1;
                q_acc_9_2 = q_acc_9_2 + q_tmp_9_2;
                q_acc_9_3 = q_acc_9_3 + q_tmp_9_3;
                q_acc_9_4 = q_acc_9_4 + q_tmp_9_4;
                q_acc_9_5 = q_acc_9_5 + q_tmp_9_5;
                q_acc_9_6 = q_acc_9_6 + q_tmp_9_6;
                q_acc_9_7 = q_acc_9_7 + q_tmp_9_7;
                q_acc_9_8 = q_acc_9_8 + q_tmp_9_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_1_0*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_2_0*src_dof_0 + q_acc_2_1*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_3_0*src_dof_0 + q_acc_3_1*src_dof_1 + q_acc_3_2*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             const real_t elMatVec_4 = q_acc_4_0*src_dof_0 + q_acc_4_1*src_dof_1 + q_acc_4_2*src_dof_2 + q_acc_4_3*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
             const real_t elMatVec_5 = q_acc_5_0*src_dof_0 + q_acc_5_1*src_dof_1 + q_acc_5_2*src_dof_2 + q_acc_5_3*src_dof_3 + q_acc_5_4*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
             const real_t elMatVec_6 = q_acc_6_0*src_dof_0 + q_acc_6_1*src_dof_1 + q_acc_6_2*src_dof_2 + q_acc_6_3*src_dof_3 + q_acc_6_4*src_dof_4 + q_acc_6_5*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
             const real_t elMatVec_7 = q_acc_7_0*src_dof_0 + q_acc_7_1*src_dof_1 + q_acc_7_2*src_dof_2 + q_acc_7_3*src_dof_3 + q_acc_7_4*src_dof_4 + q_acc_7_5*src_dof_5 + q_acc_7_6*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
             const real_t elMatVec_8 = q_acc_8_0*src_dof_0 + q_acc_8_1*src_dof_1 + q_acc_8_2*src_dof_2 + q_acc_8_3*src_dof_3 + q_acc_8_4*src_dof_4 + q_acc_8_5*src_dof_5 + q_acc_8_6*src_dof_6 + q_acc_8_7*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
             const real_t elMatVec_9 = q_acc_9_0*src_dof_0 + q_acc_9_1*src_dof_1 + q_acc_9_2*src_dof_2 + q_acc_9_3*src_dof_3 + q_acc_9_4*src_dof_4 + q_acc_9_5*src_dof_5 + q_acc_9_6*src_dof_6 + q_acc_9_7*src_dof_7 + q_acc_9_8*src_dof_8 + q_acc_9_9*src_dof_9;
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_7 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const real_t tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const real_t tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_11_BLUE_DOWN = jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
       const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const real_t tmp_coords_jac_10_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_0_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
       const real_t tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const real_t jac_affine_inv_0_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
       const real_t jac_affine_inv_0_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const real_t jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const real_t jac_affine_inv_1_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       {
          /* CellType.BLUE_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t delta_dof_0 = _data_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t delta_dof_1 = _data_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t delta_dof_2 = _data_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t delta_dof_3 = _data_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t delta_dof_4 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t delta_dof_5 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t delta_dof_6 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t delta_dof_7 = _data_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t delta_dof_8 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t delta_dof_9 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_0 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_1 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_2 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_3 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_4 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ux_dof_5 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ux_dof_6 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ux_dof_7 = _data_uxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_8 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ux_dof_9 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_0 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_1 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_2 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_3 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_4 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uy_dof_5 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uy_dof_6 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uy_dof_7 = _data_uyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_8 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uy_dof_9 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_0 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_1 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_2 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_3 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_4 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uz_dof_5 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uz_dof_6 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uz_dof_7 = _data_uzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_8 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uz_dof_9 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_4_0 = 0.0;
             real_t q_acc_4_1 = 0.0;
             real_t q_acc_4_2 = 0.0;
             real_t q_acc_4_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_5_0 = 0.0;
             real_t q_acc_5_1 = 0.0;
             real_t q_acc_5_2 = 0.0;
             real_t q_acc_5_3 = 0.0;
             real_t q_acc_5_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_6_0 = 0.0;
             real_t q_acc_6_1 = 0.0;
             real_t q_acc_6_2 = 0.0;
             real_t q_acc_6_3 = 0.0;
             real_t q_acc_6_4 = 0.0;
             real_t q_acc_6_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_7_0 = 0.0;
             real_t q_acc_7_1 = 0.0;
             real_t q_acc_7_2 = 0.0;
             real_t q_acc_7_3 = 0.0;
             real_t q_acc_7_4 = 0.0;
             real_t q_acc_7_5 = 0.0;
             real_t q_acc_7_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_8_0 = 0.0;
             real_t q_acc_8_1 = 0.0;
             real_t q_acc_8_2 = 0.0;
             real_t q_acc_8_3 = 0.0;
             real_t q_acc_8_4 = 0.0;
             real_t q_acc_8_5 = 0.0;
             real_t q_acc_8_6 = 0.0;
             real_t q_acc_8_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_9_0 = 0.0;
             real_t q_acc_9_1 = 0.0;
             real_t q_acc_9_2 = 0.0;
             real_t q_acc_9_3 = 0.0;
             real_t q_acc_9_4 = 0.0;
             real_t q_acc_9_5 = 0.0;
             real_t q_acc_9_6 = 0.0;
             real_t q_acc_9_7 = 0.0;
             real_t q_acc_9_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                const real_t tmp_qloop_47 = -tmp_qloop_28;
                const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_70 = -tmp_qloop_41;
                const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                const real_t tmp_qloop_103 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const real_t tmp_qloop_104 = tmp_qloop_103*2.0;
                const real_t tmp_qloop_105 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const real_t tmp_qloop_106 = tmp_qloop_105*2.0;
                const real_t tmp_qloop_107 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const real_t tmp_qloop_108 = tmp_qloop_107*2.0;
                const real_t tmp_qloop_109 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_110 = tmp_qloop_109*_data_q_p_2[q];
                const real_t tmp_qloop_111 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_112 = tmp_qloop_111*_data_q_p_1[q];
                const real_t tmp_qloop_113 = tmp_qloop_111*_data_q_p_2[q];
                const real_t tmp_qloop_114 = tmp_qloop_112 + tmp_qloop_113;
                const real_t tmp_qloop_115 = tmp_qloop_104 + tmp_qloop_106 + tmp_qloop_108 + tmp_qloop_110 + tmp_qloop_114 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0;
                const real_t tmp_qloop_116 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_117 = tmp_qloop_109 + tmp_qloop_111;
                const real_t tmp_qloop_118 = tmp_qloop_116 + tmp_qloop_117 - 3.0;
                const real_t tmp_qloop_119 = jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_118 + jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_118 + jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_118;
                const real_t tmp_qloop_120 = jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_118 + jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_118 + jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_118;
                const real_t tmp_qloop_121 = jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_118 + jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_118 + jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_118;
                const real_t tmp_qloop_122 = tmp_qloop_104 - _data_q_p_0[q];
                const real_t tmp_qloop_123 = tmp_qloop_106 - _data_q_p_1[q];
                const real_t tmp_qloop_124 = tmp_qloop_108 - _data_q_p_2[q];
                const real_t tmp_qloop_125 = tmp_qloop_107*-4.0 - tmp_qloop_110 - tmp_qloop_113 + tmp_qloop_116;
                const real_t tmp_qloop_126 = tmp_qloop_105*-4.0 + tmp_qloop_109 - tmp_qloop_110 - tmp_qloop_112;
                const real_t tmp_qloop_127 = tmp_qloop_103*-4.0 + tmp_qloop_111 - tmp_qloop_114;
                const real_t tmp_qloop_128 = tmp_qloop_110*ux_dof_4 + tmp_qloop_112*ux_dof_6 + tmp_qloop_113*ux_dof_5 + tmp_qloop_115*ux_dof_0 + tmp_qloop_122*ux_dof_1 + tmp_qloop_123*ux_dof_2 + tmp_qloop_124*ux_dof_3 + tmp_qloop_125*ux_dof_7 + tmp_qloop_126*ux_dof_8 + tmp_qloop_127*ux_dof_9;
                const real_t tmp_qloop_129 = tmp_qloop_110*uy_dof_4 + tmp_qloop_112*uy_dof_6 + tmp_qloop_113*uy_dof_5 + tmp_qloop_115*uy_dof_0 + tmp_qloop_122*uy_dof_1 + tmp_qloop_123*uy_dof_2 + tmp_qloop_124*uy_dof_3 + tmp_qloop_125*uy_dof_7 + tmp_qloop_126*uy_dof_8 + tmp_qloop_127*uy_dof_9;
                const real_t tmp_qloop_130 = tmp_qloop_110*uz_dof_4 + tmp_qloop_112*uz_dof_6 + tmp_qloop_113*uz_dof_5 + tmp_qloop_115*uz_dof_0 + tmp_qloop_122*uz_dof_1 + tmp_qloop_123*uz_dof_2 + tmp_qloop_124*uz_dof_3 + tmp_qloop_125*uz_dof_7 + tmp_qloop_126*uz_dof_8 + tmp_qloop_127*uz_dof_9;
                const real_t tmp_qloop_133 = tmp_qloop_111 - 1.0;
                const real_t tmp_qloop_134 = jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_133;
                const real_t tmp_qloop_135 = jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_133;
                const real_t tmp_qloop_136 = jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_133;
                const real_t tmp_qloop_138 = tmp_qloop_109 - 1.0;
                const real_t tmp_qloop_139 = jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_138;
                const real_t tmp_qloop_140 = jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_138;
                const real_t tmp_qloop_141 = jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_138;
                const real_t tmp_qloop_143 = tmp_qloop_116 - 1.0;
                const real_t tmp_qloop_144 = jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_143;
                const real_t tmp_qloop_145 = jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_143;
                const real_t tmp_qloop_146 = jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_143;
                const real_t tmp_qloop_148 = jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_109;
                const real_t tmp_qloop_149 = jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_116;
                const real_t tmp_qloop_150 = tmp_qloop_148 + tmp_qloop_149;
                const real_t tmp_qloop_151 = jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_109;
                const real_t tmp_qloop_152 = jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_116;
                const real_t tmp_qloop_153 = tmp_qloop_151 + tmp_qloop_152;
                const real_t tmp_qloop_154 = jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_109;
                const real_t tmp_qloop_155 = jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_116;
                const real_t tmp_qloop_156 = tmp_qloop_154 + tmp_qloop_155;
                const real_t tmp_qloop_158 = jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_111;
                const real_t tmp_qloop_159 = jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_116;
                const real_t tmp_qloop_160 = tmp_qloop_158 + tmp_qloop_159;
                const real_t tmp_qloop_161 = jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_111;
                const real_t tmp_qloop_162 = jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_116;
                const real_t tmp_qloop_163 = tmp_qloop_161 + tmp_qloop_162;
                const real_t tmp_qloop_164 = jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_111;
                const real_t tmp_qloop_165 = jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_116;
                const real_t tmp_qloop_166 = tmp_qloop_164 + tmp_qloop_165;
                const real_t tmp_qloop_168 = jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_111;
                const real_t tmp_qloop_169 = jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_109;
                const real_t tmp_qloop_170 = tmp_qloop_168 + tmp_qloop_169;
                const real_t tmp_qloop_171 = jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_111;
                const real_t tmp_qloop_172 = jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_109;
                const real_t tmp_qloop_173 = tmp_qloop_171 + tmp_qloop_172;
                const real_t tmp_qloop_174 = jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_111;
                const real_t tmp_qloop_175 = jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_109;
                const real_t tmp_qloop_176 = tmp_qloop_174 + tmp_qloop_175;
                const real_t tmp_qloop_178 = -tmp_qloop_117 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_179 = jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_178 - tmp_qloop_149 - tmp_qloop_159;
                const real_t tmp_qloop_180 = jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_178 - tmp_qloop_152 - tmp_qloop_162;
                const real_t tmp_qloop_181 = jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_178 - tmp_qloop_155 - tmp_qloop_165;
                const real_t tmp_qloop_183 = tmp_qloop_116 - 4.0;
                const real_t tmp_qloop_184 = -tmp_qloop_111 - tmp_qloop_183 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_185 = jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_184 - tmp_qloop_148 - tmp_qloop_169;
                const real_t tmp_qloop_186 = jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_184 - tmp_qloop_151 - tmp_qloop_172;
                const real_t tmp_qloop_187 = jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_184 - tmp_qloop_154 - tmp_qloop_175;
                const real_t tmp_qloop_189 = -tmp_qloop_109 - tmp_qloop_183 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_190 = jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_189 - tmp_qloop_158 - tmp_qloop_168;
                const real_t tmp_qloop_191 = jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_189 - tmp_qloop_161 - tmp_qloop_171;
                const real_t tmp_qloop_192 = jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_189 - tmp_qloop_164 - tmp_qloop_174;
                const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                const real_t abs_det_jac_blending = tmp_qloop_64;
                const real_t tmp_qloop_131 = abs_det_jac_affine_BLUE_DOWN*abs_det_jac_blending*(delta_dof_0*tmp_qloop_115 + delta_dof_1*tmp_qloop_122 + delta_dof_2*tmp_qloop_123 + delta_dof_3*tmp_qloop_124 + delta_dof_4*tmp_qloop_110 + delta_dof_5*tmp_qloop_113 + delta_dof_6*tmp_qloop_112 + delta_dof_7*tmp_qloop_125 + delta_dof_8*tmp_qloop_126 + delta_dof_9*tmp_qloop_127)*_data_q_w[q];
                const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t tmp_qloop_132 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_119 + jac_blending_inv_1_0*tmp_qloop_120 + jac_blending_inv_2_0*tmp_qloop_121) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_119 + jac_blending_inv_1_1*tmp_qloop_120 + jac_blending_inv_2_1*tmp_qloop_121) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_119 + jac_blending_inv_1_2*tmp_qloop_120 + jac_blending_inv_2_2*tmp_qloop_121));
                const real_t tmp_qloop_137 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_134 + jac_blending_inv_1_0*tmp_qloop_135 + jac_blending_inv_2_0*tmp_qloop_136) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_134 + jac_blending_inv_1_1*tmp_qloop_135 + jac_blending_inv_2_1*tmp_qloop_136) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_134 + jac_blending_inv_1_2*tmp_qloop_135 + jac_blending_inv_2_2*tmp_qloop_136));
                const real_t tmp_qloop_142 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_139 + jac_blending_inv_1_0*tmp_qloop_140 + jac_blending_inv_2_0*tmp_qloop_141) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_139 + jac_blending_inv_1_1*tmp_qloop_140 + jac_blending_inv_2_1*tmp_qloop_141) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_139 + jac_blending_inv_1_2*tmp_qloop_140 + jac_blending_inv_2_2*tmp_qloop_141));
                const real_t tmp_qloop_147 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_144 + jac_blending_inv_1_0*tmp_qloop_145 + jac_blending_inv_2_0*tmp_qloop_146) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_144 + jac_blending_inv_1_1*tmp_qloop_145 + jac_blending_inv_2_1*tmp_qloop_146) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_144 + jac_blending_inv_1_2*tmp_qloop_145 + jac_blending_inv_2_2*tmp_qloop_146));
                const real_t tmp_qloop_157 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_150 + jac_blending_inv_1_0*tmp_qloop_153 + jac_blending_inv_2_0*tmp_qloop_156) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_150 + jac_blending_inv_1_1*tmp_qloop_153 + jac_blending_inv_2_1*tmp_qloop_156) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_150 + jac_blending_inv_1_2*tmp_qloop_153 + jac_blending_inv_2_2*tmp_qloop_156));
                const real_t tmp_qloop_167 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_160 + jac_blending_inv_1_0*tmp_qloop_163 + jac_blending_inv_2_0*tmp_qloop_166) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_160 + jac_blending_inv_1_1*tmp_qloop_163 + jac_blending_inv_2_1*tmp_qloop_166) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_160 + jac_blending_inv_1_2*tmp_qloop_163 + jac_blending_inv_2_2*tmp_qloop_166));
                const real_t tmp_qloop_177 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_170 + jac_blending_inv_1_0*tmp_qloop_173 + jac_blending_inv_2_0*tmp_qloop_176) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_170 + jac_blending_inv_1_1*tmp_qloop_173 + jac_blending_inv_2_1*tmp_qloop_176) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_170 + jac_blending_inv_1_2*tmp_qloop_173 + jac_blending_inv_2_2*tmp_qloop_176));
                const real_t tmp_qloop_182 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_179 + jac_blending_inv_1_0*tmp_qloop_180 + jac_blending_inv_2_0*tmp_qloop_181) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_179 + jac_blending_inv_1_1*tmp_qloop_180 + jac_blending_inv_2_1*tmp_qloop_181) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_179 + jac_blending_inv_1_2*tmp_qloop_180 + jac_blending_inv_2_2*tmp_qloop_181));
                const real_t tmp_qloop_188 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_185 + jac_blending_inv_1_0*tmp_qloop_186 + jac_blending_inv_2_0*tmp_qloop_187) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_185 + jac_blending_inv_1_1*tmp_qloop_186 + jac_blending_inv_2_1*tmp_qloop_187) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_185 + jac_blending_inv_1_2*tmp_qloop_186 + jac_blending_inv_2_2*tmp_qloop_187));
                const real_t tmp_qloop_193 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_190 + jac_blending_inv_1_0*tmp_qloop_191 + jac_blending_inv_2_0*tmp_qloop_192) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_190 + jac_blending_inv_1_1*tmp_qloop_191 + jac_blending_inv_2_1*tmp_qloop_192) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_190 + jac_blending_inv_1_2*tmp_qloop_191 + jac_blending_inv_2_2*tmp_qloop_192));
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_115*tmp_qloop_132;
                const real_t q_tmp_0_1 = tmp_qloop_122*tmp_qloop_132;
                const real_t q_tmp_0_2 = tmp_qloop_123*tmp_qloop_132;
                const real_t q_tmp_0_3 = tmp_qloop_124*tmp_qloop_132;
                const real_t q_tmp_0_4 = tmp_qloop_110*tmp_qloop_132;
                const real_t q_tmp_0_5 = tmp_qloop_113*tmp_qloop_132;
                const real_t q_tmp_0_6 = tmp_qloop_112*tmp_qloop_132;
                const real_t q_tmp_0_7 = tmp_qloop_125*tmp_qloop_132;
                const real_t q_tmp_0_8 = tmp_qloop_126*tmp_qloop_132;
                const real_t q_tmp_0_9 = tmp_qloop_127*tmp_qloop_132;
                const real_t q_tmp_1_0 = tmp_qloop_115*tmp_qloop_137;
                const real_t q_tmp_1_1 = tmp_qloop_122*tmp_qloop_137;
                const real_t q_tmp_1_2 = tmp_qloop_123*tmp_qloop_137;
                const real_t q_tmp_1_3 = tmp_qloop_124*tmp_qloop_137;
                const real_t q_tmp_1_4 = tmp_qloop_110*tmp_qloop_137;
                const real_t q_tmp_1_5 = tmp_qloop_113*tmp_qloop_137;
                const real_t q_tmp_1_6 = tmp_qloop_112*tmp_qloop_137;
                const real_t q_tmp_1_7 = tmp_qloop_125*tmp_qloop_137;
                const real_t q_tmp_1_8 = tmp_qloop_126*tmp_qloop_137;
                const real_t q_tmp_1_9 = tmp_qloop_127*tmp_qloop_137;
                const real_t q_tmp_2_0 = tmp_qloop_115*tmp_qloop_142;
                const real_t q_tmp_2_1 = tmp_qloop_122*tmp_qloop_142;
                const real_t q_tmp_2_2 = tmp_qloop_123*tmp_qloop_142;
                const real_t q_tmp_2_3 = tmp_qloop_124*tmp_qloop_142;
                const real_t q_tmp_2_4 = tmp_qloop_110*tmp_qloop_142;
                const real_t q_tmp_2_5 = tmp_qloop_113*tmp_qloop_142;
                const real_t q_tmp_2_6 = tmp_qloop_112*tmp_qloop_142;
                const real_t q_tmp_2_7 = tmp_qloop_125*tmp_qloop_142;
                const real_t q_tmp_2_8 = tmp_qloop_126*tmp_qloop_142;
                const real_t q_tmp_2_9 = tmp_qloop_127*tmp_qloop_142;
                const real_t q_tmp_3_0 = tmp_qloop_115*tmp_qloop_147;
                const real_t q_tmp_3_1 = tmp_qloop_122*tmp_qloop_147;
                const real_t q_tmp_3_2 = tmp_qloop_123*tmp_qloop_147;
                const real_t q_tmp_3_3 = tmp_qloop_124*tmp_qloop_147;
                const real_t q_tmp_3_4 = tmp_qloop_110*tmp_qloop_147;
                const real_t q_tmp_3_5 = tmp_qloop_113*tmp_qloop_147;
                const real_t q_tmp_3_6 = tmp_qloop_112*tmp_qloop_147;
                const real_t q_tmp_3_7 = tmp_qloop_125*tmp_qloop_147;
                const real_t q_tmp_3_8 = tmp_qloop_126*tmp_qloop_147;
                const real_t q_tmp_3_9 = tmp_qloop_127*tmp_qloop_147;
                const real_t q_tmp_4_0 = tmp_qloop_115*tmp_qloop_157;
                const real_t q_tmp_4_1 = tmp_qloop_122*tmp_qloop_157;
                const real_t q_tmp_4_2 = tmp_qloop_123*tmp_qloop_157;
                const real_t q_tmp_4_3 = tmp_qloop_124*tmp_qloop_157;
                const real_t q_tmp_4_4 = tmp_qloop_110*tmp_qloop_157;
                const real_t q_tmp_4_5 = tmp_qloop_113*tmp_qloop_157;
                const real_t q_tmp_4_6 = tmp_qloop_112*tmp_qloop_157;
                const real_t q_tmp_4_7 = tmp_qloop_125*tmp_qloop_157;
                const real_t q_tmp_4_8 = tmp_qloop_126*tmp_qloop_157;
                const real_t q_tmp_4_9 = tmp_qloop_127*tmp_qloop_157;
                const real_t q_tmp_5_0 = tmp_qloop_115*tmp_qloop_167;
                const real_t q_tmp_5_1 = tmp_qloop_122*tmp_qloop_167;
                const real_t q_tmp_5_2 = tmp_qloop_123*tmp_qloop_167;
                const real_t q_tmp_5_3 = tmp_qloop_124*tmp_qloop_167;
                const real_t q_tmp_5_4 = tmp_qloop_110*tmp_qloop_167;
                const real_t q_tmp_5_5 = tmp_qloop_113*tmp_qloop_167;
                const real_t q_tmp_5_6 = tmp_qloop_112*tmp_qloop_167;
                const real_t q_tmp_5_7 = tmp_qloop_125*tmp_qloop_167;
                const real_t q_tmp_5_8 = tmp_qloop_126*tmp_qloop_167;
                const real_t q_tmp_5_9 = tmp_qloop_127*tmp_qloop_167;
                const real_t q_tmp_6_0 = tmp_qloop_115*tmp_qloop_177;
                const real_t q_tmp_6_1 = tmp_qloop_122*tmp_qloop_177;
                const real_t q_tmp_6_2 = tmp_qloop_123*tmp_qloop_177;
                const real_t q_tmp_6_3 = tmp_qloop_124*tmp_qloop_177;
                const real_t q_tmp_6_4 = tmp_qloop_110*tmp_qloop_177;
                const real_t q_tmp_6_5 = tmp_qloop_113*tmp_qloop_177;
                const real_t q_tmp_6_6 = tmp_qloop_112*tmp_qloop_177;
                const real_t q_tmp_6_7 = tmp_qloop_125*tmp_qloop_177;
                const real_t q_tmp_6_8 = tmp_qloop_126*tmp_qloop_177;
                const real_t q_tmp_6_9 = tmp_qloop_127*tmp_qloop_177;
                const real_t q_tmp_7_0 = tmp_qloop_115*tmp_qloop_182;
                const real_t q_tmp_7_1 = tmp_qloop_122*tmp_qloop_182;
                const real_t q_tmp_7_2 = tmp_qloop_123*tmp_qloop_182;
                const real_t q_tmp_7_3 = tmp_qloop_124*tmp_qloop_182;
                const real_t q_tmp_7_4 = tmp_qloop_110*tmp_qloop_182;
                const real_t q_tmp_7_5 = tmp_qloop_113*tmp_qloop_182;
                const real_t q_tmp_7_6 = tmp_qloop_112*tmp_qloop_182;
                const real_t q_tmp_7_7 = tmp_qloop_125*tmp_qloop_182;
                const real_t q_tmp_7_8 = tmp_qloop_126*tmp_qloop_182;
                const real_t q_tmp_7_9 = tmp_qloop_127*tmp_qloop_182;
                const real_t q_tmp_8_0 = tmp_qloop_115*tmp_qloop_188;
                const real_t q_tmp_8_1 = tmp_qloop_122*tmp_qloop_188;
                const real_t q_tmp_8_2 = tmp_qloop_123*tmp_qloop_188;
                const real_t q_tmp_8_3 = tmp_qloop_124*tmp_qloop_188;
                const real_t q_tmp_8_4 = tmp_qloop_110*tmp_qloop_188;
                const real_t q_tmp_8_5 = tmp_qloop_113*tmp_qloop_188;
                const real_t q_tmp_8_6 = tmp_qloop_112*tmp_qloop_188;
                const real_t q_tmp_8_7 = tmp_qloop_125*tmp_qloop_188;
                const real_t q_tmp_8_8 = tmp_qloop_126*tmp_qloop_188;
                const real_t q_tmp_8_9 = tmp_qloop_127*tmp_qloop_188;
                const real_t q_tmp_9_0 = tmp_qloop_115*tmp_qloop_193;
                const real_t q_tmp_9_1 = tmp_qloop_122*tmp_qloop_193;
                const real_t q_tmp_9_2 = tmp_qloop_123*tmp_qloop_193;
                const real_t q_tmp_9_3 = tmp_qloop_124*tmp_qloop_193;
                const real_t q_tmp_9_4 = tmp_qloop_110*tmp_qloop_193;
                const real_t q_tmp_9_5 = tmp_qloop_113*tmp_qloop_193;
                const real_t q_tmp_9_6 = tmp_qloop_112*tmp_qloop_193;
                const real_t q_tmp_9_7 = tmp_qloop_125*tmp_qloop_193;
                const real_t q_tmp_9_8 = tmp_qloop_126*tmp_qloop_193;
                const real_t q_tmp_9_9 = tmp_qloop_127*tmp_qloop_193;
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_4_0 = q_acc_4_0 + q_tmp_4_0;
                q_acc_4_1 = q_acc_4_1 + q_tmp_4_1;
                q_acc_4_2 = q_acc_4_2 + q_tmp_4_2;
                q_acc_4_3 = q_acc_4_3 + q_tmp_4_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_5_0 = q_acc_5_0 + q_tmp_5_0;
                q_acc_5_1 = q_acc_5_1 + q_tmp_5_1;
                q_acc_5_2 = q_acc_5_2 + q_tmp_5_2;
                q_acc_5_3 = q_acc_5_3 + q_tmp_5_3;
                q_acc_5_4 = q_acc_5_4 + q_tmp_5_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_6_0 = q_acc_6_0 + q_tmp_6_0;
                q_acc_6_1 = q_acc_6_1 + q_tmp_6_1;
                q_acc_6_2 = q_acc_6_2 + q_tmp_6_2;
                q_acc_6_3 = q_acc_6_3 + q_tmp_6_3;
                q_acc_6_4 = q_acc_6_4 + q_tmp_6_4;
                q_acc_6_5 = q_acc_6_5 + q_tmp_6_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_7_0 = q_acc_7_0 + q_tmp_7_0;
                q_acc_7_1 = q_acc_7_1 + q_tmp_7_1;
                q_acc_7_2 = q_acc_7_2 + q_tmp_7_2;
                q_acc_7_3 = q_acc_7_3 + q_tmp_7_3;
                q_acc_7_4 = q_acc_7_4 + q_tmp_7_4;
                q_acc_7_5 = q_acc_7_5 + q_tmp_7_5;
                q_acc_7_6 = q_acc_7_6 + q_tmp_7_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_8_0 = q_acc_8_0 + q_tmp_8_0;
                q_acc_8_1 = q_acc_8_1 + q_tmp_8_1;
                q_acc_8_2 = q_acc_8_2 + q_tmp_8_2;
                q_acc_8_3 = q_acc_8_3 + q_tmp_8_3;
                q_acc_8_4 = q_acc_8_4 + q_tmp_8_4;
                q_acc_8_5 = q_acc_8_5 + q_tmp_8_5;
                q_acc_8_6 = q_acc_8_6 + q_tmp_8_6;
                q_acc_8_7 = q_acc_8_7 + q_tmp_8_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_9_0 = q_acc_9_0 + q_tmp_9_0;
                q_acc_9_1 = q_acc_9_1 + q_tmp_9_1;
                q_acc_9_2 = q_acc_9_2 + q_tmp_9_2;
                q_acc_9_3 = q_acc_9_3 + q_tmp_9_3;
                q_acc_9_4 = q_acc_9_4 + q_tmp_9_4;
                q_acc_9_5 = q_acc_9_5 + q_tmp_9_5;
                q_acc_9_6 = q_acc_9_6 + q_tmp_9_6;
                q_acc_9_7 = q_acc_9_7 + q_tmp_9_7;
                q_acc_9_8 = q_acc_9_8 + q_tmp_9_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_1_0*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_2_0*src_dof_0 + q_acc_2_1*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_3_0*src_dof_0 + q_acc_3_1*src_dof_1 + q_acc_3_2*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             const real_t elMatVec_4 = q_acc_4_0*src_dof_0 + q_acc_4_1*src_dof_1 + q_acc_4_2*src_dof_2 + q_acc_4_3*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
             const real_t elMatVec_5 = q_acc_5_0*src_dof_0 + q_acc_5_1*src_dof_1 + q_acc_5_2*src_dof_2 + q_acc_5_3*src_dof_3 + q_acc_5_4*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
             const real_t elMatVec_6 = q_acc_6_0*src_dof_0 + q_acc_6_1*src_dof_1 + q_acc_6_2*src_dof_2 + q_acc_6_3*src_dof_3 + q_acc_6_4*src_dof_4 + q_acc_6_5*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
             const real_t elMatVec_7 = q_acc_7_0*src_dof_0 + q_acc_7_1*src_dof_1 + q_acc_7_2*src_dof_2 + q_acc_7_3*src_dof_3 + q_acc_7_4*src_dof_4 + q_acc_7_5*src_dof_5 + q_acc_7_6*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
             const real_t elMatVec_8 = q_acc_8_0*src_dof_0 + q_acc_8_1*src_dof_1 + q_acc_8_2*src_dof_2 + q_acc_8_3*src_dof_3 + q_acc_8_4*src_dof_4 + q_acc_8_5*src_dof_5 + q_acc_8_6*src_dof_6 + q_acc_8_7*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
             const real_t elMatVec_9 = q_acc_9_0*src_dof_0 + q_acc_9_1*src_dof_1 + q_acc_9_2*src_dof_2 + q_acc_9_3*src_dof_3 + q_acc_9_4*src_dof_4 + q_acc_9_5*src_dof_5 + q_acc_9_6*src_dof_6 + q_acc_9_7*src_dof_7 + q_acc_9_8*src_dof_8 + q_acc_9_9*src_dof_9;
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_7 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const real_t tmp_coords_jac_11_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const real_t tmp_coords_jac_9_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const real_t tmp_coords_jac_8_GREEN_UP = jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP;
       const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const real_t tmp_coords_jac_7_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_10_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_12_GREEN_UP = jac_affine_0_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_0_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_0_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
       const real_t tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const real_t jac_affine_inv_0_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
       const real_t jac_affine_inv_0_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_2_1_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const real_t jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const real_t jac_affine_inv_1_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t jac_affine_inv_2_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       {
          /* CellType.GREEN_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t delta_dof_0 = _data_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t delta_dof_1 = _data_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t delta_dof_2 = _data_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t delta_dof_3 = _data_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t delta_dof_4 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t delta_dof_5 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t delta_dof_6 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t delta_dof_7 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t delta_dof_8 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t delta_dof_9 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_0 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_1 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_2 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_3 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_4 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ux_dof_5 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ux_dof_6 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_7 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ux_dof_8 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_9 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_0 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_1 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_2 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_3 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_4 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uy_dof_5 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uy_dof_6 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_7 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uy_dof_8 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_9 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_0 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_1 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_2 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_3 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_4 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uz_dof_5 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uz_dof_6 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_7 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uz_dof_8 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_9 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_4_0 = 0.0;
             real_t q_acc_4_1 = 0.0;
             real_t q_acc_4_2 = 0.0;
             real_t q_acc_4_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_5_0 = 0.0;
             real_t q_acc_5_1 = 0.0;
             real_t q_acc_5_2 = 0.0;
             real_t q_acc_5_3 = 0.0;
             real_t q_acc_5_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_6_0 = 0.0;
             real_t q_acc_6_1 = 0.0;
             real_t q_acc_6_2 = 0.0;
             real_t q_acc_6_3 = 0.0;
             real_t q_acc_6_4 = 0.0;
             real_t q_acc_6_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_7_0 = 0.0;
             real_t q_acc_7_1 = 0.0;
             real_t q_acc_7_2 = 0.0;
             real_t q_acc_7_3 = 0.0;
             real_t q_acc_7_4 = 0.0;
             real_t q_acc_7_5 = 0.0;
             real_t q_acc_7_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_8_0 = 0.0;
             real_t q_acc_8_1 = 0.0;
             real_t q_acc_8_2 = 0.0;
             real_t q_acc_8_3 = 0.0;
             real_t q_acc_8_4 = 0.0;
             real_t q_acc_8_5 = 0.0;
             real_t q_acc_8_6 = 0.0;
             real_t q_acc_8_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_9_0 = 0.0;
             real_t q_acc_9_1 = 0.0;
             real_t q_acc_9_2 = 0.0;
             real_t q_acc_9_3 = 0.0;
             real_t q_acc_9_4 = 0.0;
             real_t q_acc_9_5 = 0.0;
             real_t q_acc_9_6 = 0.0;
             real_t q_acc_9_7 = 0.0;
             real_t q_acc_9_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                const real_t tmp_qloop_47 = -tmp_qloop_28;
                const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_70 = -tmp_qloop_41;
                const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                const real_t tmp_qloop_103 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const real_t tmp_qloop_104 = tmp_qloop_103*2.0;
                const real_t tmp_qloop_105 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const real_t tmp_qloop_106 = tmp_qloop_105*2.0;
                const real_t tmp_qloop_107 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const real_t tmp_qloop_108 = tmp_qloop_107*2.0;
                const real_t tmp_qloop_109 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_110 = tmp_qloop_109*_data_q_p_2[q];
                const real_t tmp_qloop_111 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_112 = tmp_qloop_111*_data_q_p_1[q];
                const real_t tmp_qloop_113 = tmp_qloop_111*_data_q_p_2[q];
                const real_t tmp_qloop_114 = tmp_qloop_112 + tmp_qloop_113;
                const real_t tmp_qloop_115 = tmp_qloop_104 + tmp_qloop_106 + tmp_qloop_108 + tmp_qloop_110 + tmp_qloop_114 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0;
                const real_t tmp_qloop_116 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_117 = tmp_qloop_109 + tmp_qloop_111;
                const real_t tmp_qloop_118 = tmp_qloop_116 + tmp_qloop_117 - 3.0;
                const real_t tmp_qloop_119 = jac_affine_inv_0_0_GREEN_UP*tmp_qloop_118 + jac_affine_inv_1_0_GREEN_UP*tmp_qloop_118 + jac_affine_inv_2_0_GREEN_UP*tmp_qloop_118;
                const real_t tmp_qloop_120 = jac_affine_inv_0_1_GREEN_UP*tmp_qloop_118 + jac_affine_inv_1_1_GREEN_UP*tmp_qloop_118 + jac_affine_inv_2_1_GREEN_UP*tmp_qloop_118;
                const real_t tmp_qloop_121 = jac_affine_inv_0_2_GREEN_UP*tmp_qloop_118 + jac_affine_inv_1_2_GREEN_UP*tmp_qloop_118 + jac_affine_inv_2_2_GREEN_UP*tmp_qloop_118;
                const real_t tmp_qloop_122 = tmp_qloop_104 - _data_q_p_0[q];
                const real_t tmp_qloop_123 = tmp_qloop_106 - _data_q_p_1[q];
                const real_t tmp_qloop_124 = tmp_qloop_108 - _data_q_p_2[q];
                const real_t tmp_qloop_125 = tmp_qloop_107*-4.0 - tmp_qloop_110 - tmp_qloop_113 + tmp_qloop_116;
                const real_t tmp_qloop_126 = tmp_qloop_105*-4.0 + tmp_qloop_109 - tmp_qloop_110 - tmp_qloop_112;
                const real_t tmp_qloop_127 = tmp_qloop_103*-4.0 + tmp_qloop_111 - tmp_qloop_114;
                const real_t tmp_qloop_128 = tmp_qloop_110*ux_dof_4 + tmp_qloop_112*ux_dof_6 + tmp_qloop_113*ux_dof_5 + tmp_qloop_115*ux_dof_0 + tmp_qloop_122*ux_dof_1 + tmp_qloop_123*ux_dof_2 + tmp_qloop_124*ux_dof_3 + tmp_qloop_125*ux_dof_7 + tmp_qloop_126*ux_dof_8 + tmp_qloop_127*ux_dof_9;
                const real_t tmp_qloop_129 = tmp_qloop_110*uy_dof_4 + tmp_qloop_112*uy_dof_6 + tmp_qloop_113*uy_dof_5 + tmp_qloop_115*uy_dof_0 + tmp_qloop_122*uy_dof_1 + tmp_qloop_123*uy_dof_2 + tmp_qloop_124*uy_dof_3 + tmp_qloop_125*uy_dof_7 + tmp_qloop_126*uy_dof_8 + tmp_qloop_127*uy_dof_9;
                const real_t tmp_qloop_130 = tmp_qloop_110*uz_dof_4 + tmp_qloop_112*uz_dof_6 + tmp_qloop_113*uz_dof_5 + tmp_qloop_115*uz_dof_0 + tmp_qloop_122*uz_dof_1 + tmp_qloop_123*uz_dof_2 + tmp_qloop_124*uz_dof_3 + tmp_qloop_125*uz_dof_7 + tmp_qloop_126*uz_dof_8 + tmp_qloop_127*uz_dof_9;
                const real_t tmp_qloop_133 = tmp_qloop_111 - 1.0;
                const real_t tmp_qloop_134 = jac_affine_inv_0_0_GREEN_UP*tmp_qloop_133;
                const real_t tmp_qloop_135 = jac_affine_inv_0_1_GREEN_UP*tmp_qloop_133;
                const real_t tmp_qloop_136 = jac_affine_inv_0_2_GREEN_UP*tmp_qloop_133;
                const real_t tmp_qloop_138 = tmp_qloop_109 - 1.0;
                const real_t tmp_qloop_139 = jac_affine_inv_1_0_GREEN_UP*tmp_qloop_138;
                const real_t tmp_qloop_140 = jac_affine_inv_1_1_GREEN_UP*tmp_qloop_138;
                const real_t tmp_qloop_141 = jac_affine_inv_1_2_GREEN_UP*tmp_qloop_138;
                const real_t tmp_qloop_143 = tmp_qloop_116 - 1.0;
                const real_t tmp_qloop_144 = jac_affine_inv_2_0_GREEN_UP*tmp_qloop_143;
                const real_t tmp_qloop_145 = jac_affine_inv_2_1_GREEN_UP*tmp_qloop_143;
                const real_t tmp_qloop_146 = jac_affine_inv_2_2_GREEN_UP*tmp_qloop_143;
                const real_t tmp_qloop_148 = jac_affine_inv_2_0_GREEN_UP*tmp_qloop_109;
                const real_t tmp_qloop_149 = jac_affine_inv_1_0_GREEN_UP*tmp_qloop_116;
                const real_t tmp_qloop_150 = tmp_qloop_148 + tmp_qloop_149;
                const real_t tmp_qloop_151 = jac_affine_inv_2_1_GREEN_UP*tmp_qloop_109;
                const real_t tmp_qloop_152 = jac_affine_inv_1_1_GREEN_UP*tmp_qloop_116;
                const real_t tmp_qloop_153 = tmp_qloop_151 + tmp_qloop_152;
                const real_t tmp_qloop_154 = jac_affine_inv_2_2_GREEN_UP*tmp_qloop_109;
                const real_t tmp_qloop_155 = jac_affine_inv_1_2_GREEN_UP*tmp_qloop_116;
                const real_t tmp_qloop_156 = tmp_qloop_154 + tmp_qloop_155;
                const real_t tmp_qloop_158 = jac_affine_inv_2_0_GREEN_UP*tmp_qloop_111;
                const real_t tmp_qloop_159 = jac_affine_inv_0_0_GREEN_UP*tmp_qloop_116;
                const real_t tmp_qloop_160 = tmp_qloop_158 + tmp_qloop_159;
                const real_t tmp_qloop_161 = jac_affine_inv_2_1_GREEN_UP*tmp_qloop_111;
                const real_t tmp_qloop_162 = jac_affine_inv_0_1_GREEN_UP*tmp_qloop_116;
                const real_t tmp_qloop_163 = tmp_qloop_161 + tmp_qloop_162;
                const real_t tmp_qloop_164 = jac_affine_inv_2_2_GREEN_UP*tmp_qloop_111;
                const real_t tmp_qloop_165 = jac_affine_inv_0_2_GREEN_UP*tmp_qloop_116;
                const real_t tmp_qloop_166 = tmp_qloop_164 + tmp_qloop_165;
                const real_t tmp_qloop_168 = jac_affine_inv_1_0_GREEN_UP*tmp_qloop_111;
                const real_t tmp_qloop_169 = jac_affine_inv_0_0_GREEN_UP*tmp_qloop_109;
                const real_t tmp_qloop_170 = tmp_qloop_168 + tmp_qloop_169;
                const real_t tmp_qloop_171 = jac_affine_inv_1_1_GREEN_UP*tmp_qloop_111;
                const real_t tmp_qloop_172 = jac_affine_inv_0_1_GREEN_UP*tmp_qloop_109;
                const real_t tmp_qloop_173 = tmp_qloop_171 + tmp_qloop_172;
                const real_t tmp_qloop_174 = jac_affine_inv_1_2_GREEN_UP*tmp_qloop_111;
                const real_t tmp_qloop_175 = jac_affine_inv_0_2_GREEN_UP*tmp_qloop_109;
                const real_t tmp_qloop_176 = tmp_qloop_174 + tmp_qloop_175;
                const real_t tmp_qloop_178 = -tmp_qloop_117 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_179 = jac_affine_inv_2_0_GREEN_UP*tmp_qloop_178 - tmp_qloop_149 - tmp_qloop_159;
                const real_t tmp_qloop_180 = jac_affine_inv_2_1_GREEN_UP*tmp_qloop_178 - tmp_qloop_152 - tmp_qloop_162;
                const real_t tmp_qloop_181 = jac_affine_inv_2_2_GREEN_UP*tmp_qloop_178 - tmp_qloop_155 - tmp_qloop_165;
                const real_t tmp_qloop_183 = tmp_qloop_116 - 4.0;
                const real_t tmp_qloop_184 = -tmp_qloop_111 - tmp_qloop_183 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_185 = jac_affine_inv_1_0_GREEN_UP*tmp_qloop_184 - tmp_qloop_148 - tmp_qloop_169;
                const real_t tmp_qloop_186 = jac_affine_inv_1_1_GREEN_UP*tmp_qloop_184 - tmp_qloop_151 - tmp_qloop_172;
                const real_t tmp_qloop_187 = jac_affine_inv_1_2_GREEN_UP*tmp_qloop_184 - tmp_qloop_154 - tmp_qloop_175;
                const real_t tmp_qloop_189 = -tmp_qloop_109 - tmp_qloop_183 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_190 = jac_affine_inv_0_0_GREEN_UP*tmp_qloop_189 - tmp_qloop_158 - tmp_qloop_168;
                const real_t tmp_qloop_191 = jac_affine_inv_0_1_GREEN_UP*tmp_qloop_189 - tmp_qloop_161 - tmp_qloop_171;
                const real_t tmp_qloop_192 = jac_affine_inv_0_2_GREEN_UP*tmp_qloop_189 - tmp_qloop_164 - tmp_qloop_174;
                const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                const real_t abs_det_jac_blending = tmp_qloop_64;
                const real_t tmp_qloop_131 = abs_det_jac_affine_GREEN_UP*abs_det_jac_blending*(delta_dof_0*tmp_qloop_115 + delta_dof_1*tmp_qloop_122 + delta_dof_2*tmp_qloop_123 + delta_dof_3*tmp_qloop_124 + delta_dof_4*tmp_qloop_110 + delta_dof_5*tmp_qloop_113 + delta_dof_6*tmp_qloop_112 + delta_dof_7*tmp_qloop_125 + delta_dof_8*tmp_qloop_126 + delta_dof_9*tmp_qloop_127)*_data_q_w[q];
                const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t tmp_qloop_132 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_119 + jac_blending_inv_1_0*tmp_qloop_120 + jac_blending_inv_2_0*tmp_qloop_121) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_119 + jac_blending_inv_1_1*tmp_qloop_120 + jac_blending_inv_2_1*tmp_qloop_121) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_119 + jac_blending_inv_1_2*tmp_qloop_120 + jac_blending_inv_2_2*tmp_qloop_121));
                const real_t tmp_qloop_137 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_134 + jac_blending_inv_1_0*tmp_qloop_135 + jac_blending_inv_2_0*tmp_qloop_136) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_134 + jac_blending_inv_1_1*tmp_qloop_135 + jac_blending_inv_2_1*tmp_qloop_136) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_134 + jac_blending_inv_1_2*tmp_qloop_135 + jac_blending_inv_2_2*tmp_qloop_136));
                const real_t tmp_qloop_142 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_139 + jac_blending_inv_1_0*tmp_qloop_140 + jac_blending_inv_2_0*tmp_qloop_141) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_139 + jac_blending_inv_1_1*tmp_qloop_140 + jac_blending_inv_2_1*tmp_qloop_141) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_139 + jac_blending_inv_1_2*tmp_qloop_140 + jac_blending_inv_2_2*tmp_qloop_141));
                const real_t tmp_qloop_147 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_144 + jac_blending_inv_1_0*tmp_qloop_145 + jac_blending_inv_2_0*tmp_qloop_146) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_144 + jac_blending_inv_1_1*tmp_qloop_145 + jac_blending_inv_2_1*tmp_qloop_146) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_144 + jac_blending_inv_1_2*tmp_qloop_145 + jac_blending_inv_2_2*tmp_qloop_146));
                const real_t tmp_qloop_157 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_150 + jac_blending_inv_1_0*tmp_qloop_153 + jac_blending_inv_2_0*tmp_qloop_156) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_150 + jac_blending_inv_1_1*tmp_qloop_153 + jac_blending_inv_2_1*tmp_qloop_156) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_150 + jac_blending_inv_1_2*tmp_qloop_153 + jac_blending_inv_2_2*tmp_qloop_156));
                const real_t tmp_qloop_167 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_160 + jac_blending_inv_1_0*tmp_qloop_163 + jac_blending_inv_2_0*tmp_qloop_166) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_160 + jac_blending_inv_1_1*tmp_qloop_163 + jac_blending_inv_2_1*tmp_qloop_166) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_160 + jac_blending_inv_1_2*tmp_qloop_163 + jac_blending_inv_2_2*tmp_qloop_166));
                const real_t tmp_qloop_177 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_170 + jac_blending_inv_1_0*tmp_qloop_173 + jac_blending_inv_2_0*tmp_qloop_176) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_170 + jac_blending_inv_1_1*tmp_qloop_173 + jac_blending_inv_2_1*tmp_qloop_176) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_170 + jac_blending_inv_1_2*tmp_qloop_173 + jac_blending_inv_2_2*tmp_qloop_176));
                const real_t tmp_qloop_182 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_179 + jac_blending_inv_1_0*tmp_qloop_180 + jac_blending_inv_2_0*tmp_qloop_181) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_179 + jac_blending_inv_1_1*tmp_qloop_180 + jac_blending_inv_2_1*tmp_qloop_181) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_179 + jac_blending_inv_1_2*tmp_qloop_180 + jac_blending_inv_2_2*tmp_qloop_181));
                const real_t tmp_qloop_188 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_185 + jac_blending_inv_1_0*tmp_qloop_186 + jac_blending_inv_2_0*tmp_qloop_187) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_185 + jac_blending_inv_1_1*tmp_qloop_186 + jac_blending_inv_2_1*tmp_qloop_187) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_185 + jac_blending_inv_1_2*tmp_qloop_186 + jac_blending_inv_2_2*tmp_qloop_187));
                const real_t tmp_qloop_193 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_190 + jac_blending_inv_1_0*tmp_qloop_191 + jac_blending_inv_2_0*tmp_qloop_192) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_190 + jac_blending_inv_1_1*tmp_qloop_191 + jac_blending_inv_2_1*tmp_qloop_192) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_190 + jac_blending_inv_1_2*tmp_qloop_191 + jac_blending_inv_2_2*tmp_qloop_192));
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_115*tmp_qloop_132;
                const real_t q_tmp_0_1 = tmp_qloop_122*tmp_qloop_132;
                const real_t q_tmp_0_2 = tmp_qloop_123*tmp_qloop_132;
                const real_t q_tmp_0_3 = tmp_qloop_124*tmp_qloop_132;
                const real_t q_tmp_0_4 = tmp_qloop_110*tmp_qloop_132;
                const real_t q_tmp_0_5 = tmp_qloop_113*tmp_qloop_132;
                const real_t q_tmp_0_6 = tmp_qloop_112*tmp_qloop_132;
                const real_t q_tmp_0_7 = tmp_qloop_125*tmp_qloop_132;
                const real_t q_tmp_0_8 = tmp_qloop_126*tmp_qloop_132;
                const real_t q_tmp_0_9 = tmp_qloop_127*tmp_qloop_132;
                const real_t q_tmp_1_0 = tmp_qloop_115*tmp_qloop_137;
                const real_t q_tmp_1_1 = tmp_qloop_122*tmp_qloop_137;
                const real_t q_tmp_1_2 = tmp_qloop_123*tmp_qloop_137;
                const real_t q_tmp_1_3 = tmp_qloop_124*tmp_qloop_137;
                const real_t q_tmp_1_4 = tmp_qloop_110*tmp_qloop_137;
                const real_t q_tmp_1_5 = tmp_qloop_113*tmp_qloop_137;
                const real_t q_tmp_1_6 = tmp_qloop_112*tmp_qloop_137;
                const real_t q_tmp_1_7 = tmp_qloop_125*tmp_qloop_137;
                const real_t q_tmp_1_8 = tmp_qloop_126*tmp_qloop_137;
                const real_t q_tmp_1_9 = tmp_qloop_127*tmp_qloop_137;
                const real_t q_tmp_2_0 = tmp_qloop_115*tmp_qloop_142;
                const real_t q_tmp_2_1 = tmp_qloop_122*tmp_qloop_142;
                const real_t q_tmp_2_2 = tmp_qloop_123*tmp_qloop_142;
                const real_t q_tmp_2_3 = tmp_qloop_124*tmp_qloop_142;
                const real_t q_tmp_2_4 = tmp_qloop_110*tmp_qloop_142;
                const real_t q_tmp_2_5 = tmp_qloop_113*tmp_qloop_142;
                const real_t q_tmp_2_6 = tmp_qloop_112*tmp_qloop_142;
                const real_t q_tmp_2_7 = tmp_qloop_125*tmp_qloop_142;
                const real_t q_tmp_2_8 = tmp_qloop_126*tmp_qloop_142;
                const real_t q_tmp_2_9 = tmp_qloop_127*tmp_qloop_142;
                const real_t q_tmp_3_0 = tmp_qloop_115*tmp_qloop_147;
                const real_t q_tmp_3_1 = tmp_qloop_122*tmp_qloop_147;
                const real_t q_tmp_3_2 = tmp_qloop_123*tmp_qloop_147;
                const real_t q_tmp_3_3 = tmp_qloop_124*tmp_qloop_147;
                const real_t q_tmp_3_4 = tmp_qloop_110*tmp_qloop_147;
                const real_t q_tmp_3_5 = tmp_qloop_113*tmp_qloop_147;
                const real_t q_tmp_3_6 = tmp_qloop_112*tmp_qloop_147;
                const real_t q_tmp_3_7 = tmp_qloop_125*tmp_qloop_147;
                const real_t q_tmp_3_8 = tmp_qloop_126*tmp_qloop_147;
                const real_t q_tmp_3_9 = tmp_qloop_127*tmp_qloop_147;
                const real_t q_tmp_4_0 = tmp_qloop_115*tmp_qloop_157;
                const real_t q_tmp_4_1 = tmp_qloop_122*tmp_qloop_157;
                const real_t q_tmp_4_2 = tmp_qloop_123*tmp_qloop_157;
                const real_t q_tmp_4_3 = tmp_qloop_124*tmp_qloop_157;
                const real_t q_tmp_4_4 = tmp_qloop_110*tmp_qloop_157;
                const real_t q_tmp_4_5 = tmp_qloop_113*tmp_qloop_157;
                const real_t q_tmp_4_6 = tmp_qloop_112*tmp_qloop_157;
                const real_t q_tmp_4_7 = tmp_qloop_125*tmp_qloop_157;
                const real_t q_tmp_4_8 = tmp_qloop_126*tmp_qloop_157;
                const real_t q_tmp_4_9 = tmp_qloop_127*tmp_qloop_157;
                const real_t q_tmp_5_0 = tmp_qloop_115*tmp_qloop_167;
                const real_t q_tmp_5_1 = tmp_qloop_122*tmp_qloop_167;
                const real_t q_tmp_5_2 = tmp_qloop_123*tmp_qloop_167;
                const real_t q_tmp_5_3 = tmp_qloop_124*tmp_qloop_167;
                const real_t q_tmp_5_4 = tmp_qloop_110*tmp_qloop_167;
                const real_t q_tmp_5_5 = tmp_qloop_113*tmp_qloop_167;
                const real_t q_tmp_5_6 = tmp_qloop_112*tmp_qloop_167;
                const real_t q_tmp_5_7 = tmp_qloop_125*tmp_qloop_167;
                const real_t q_tmp_5_8 = tmp_qloop_126*tmp_qloop_167;
                const real_t q_tmp_5_9 = tmp_qloop_127*tmp_qloop_167;
                const real_t q_tmp_6_0 = tmp_qloop_115*tmp_qloop_177;
                const real_t q_tmp_6_1 = tmp_qloop_122*tmp_qloop_177;
                const real_t q_tmp_6_2 = tmp_qloop_123*tmp_qloop_177;
                const real_t q_tmp_6_3 = tmp_qloop_124*tmp_qloop_177;
                const real_t q_tmp_6_4 = tmp_qloop_110*tmp_qloop_177;
                const real_t q_tmp_6_5 = tmp_qloop_113*tmp_qloop_177;
                const real_t q_tmp_6_6 = tmp_qloop_112*tmp_qloop_177;
                const real_t q_tmp_6_7 = tmp_qloop_125*tmp_qloop_177;
                const real_t q_tmp_6_8 = tmp_qloop_126*tmp_qloop_177;
                const real_t q_tmp_6_9 = tmp_qloop_127*tmp_qloop_177;
                const real_t q_tmp_7_0 = tmp_qloop_115*tmp_qloop_182;
                const real_t q_tmp_7_1 = tmp_qloop_122*tmp_qloop_182;
                const real_t q_tmp_7_2 = tmp_qloop_123*tmp_qloop_182;
                const real_t q_tmp_7_3 = tmp_qloop_124*tmp_qloop_182;
                const real_t q_tmp_7_4 = tmp_qloop_110*tmp_qloop_182;
                const real_t q_tmp_7_5 = tmp_qloop_113*tmp_qloop_182;
                const real_t q_tmp_7_6 = tmp_qloop_112*tmp_qloop_182;
                const real_t q_tmp_7_7 = tmp_qloop_125*tmp_qloop_182;
                const real_t q_tmp_7_8 = tmp_qloop_126*tmp_qloop_182;
                const real_t q_tmp_7_9 = tmp_qloop_127*tmp_qloop_182;
                const real_t q_tmp_8_0 = tmp_qloop_115*tmp_qloop_188;
                const real_t q_tmp_8_1 = tmp_qloop_122*tmp_qloop_188;
                const real_t q_tmp_8_2 = tmp_qloop_123*tmp_qloop_188;
                const real_t q_tmp_8_3 = tmp_qloop_124*tmp_qloop_188;
                const real_t q_tmp_8_4 = tmp_qloop_110*tmp_qloop_188;
                const real_t q_tmp_8_5 = tmp_qloop_113*tmp_qloop_188;
                const real_t q_tmp_8_6 = tmp_qloop_112*tmp_qloop_188;
                const real_t q_tmp_8_7 = tmp_qloop_125*tmp_qloop_188;
                const real_t q_tmp_8_8 = tmp_qloop_126*tmp_qloop_188;
                const real_t q_tmp_8_9 = tmp_qloop_127*tmp_qloop_188;
                const real_t q_tmp_9_0 = tmp_qloop_115*tmp_qloop_193;
                const real_t q_tmp_9_1 = tmp_qloop_122*tmp_qloop_193;
                const real_t q_tmp_9_2 = tmp_qloop_123*tmp_qloop_193;
                const real_t q_tmp_9_3 = tmp_qloop_124*tmp_qloop_193;
                const real_t q_tmp_9_4 = tmp_qloop_110*tmp_qloop_193;
                const real_t q_tmp_9_5 = tmp_qloop_113*tmp_qloop_193;
                const real_t q_tmp_9_6 = tmp_qloop_112*tmp_qloop_193;
                const real_t q_tmp_9_7 = tmp_qloop_125*tmp_qloop_193;
                const real_t q_tmp_9_8 = tmp_qloop_126*tmp_qloop_193;
                const real_t q_tmp_9_9 = tmp_qloop_127*tmp_qloop_193;
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_4_0 = q_acc_4_0 + q_tmp_4_0;
                q_acc_4_1 = q_acc_4_1 + q_tmp_4_1;
                q_acc_4_2 = q_acc_4_2 + q_tmp_4_2;
                q_acc_4_3 = q_acc_4_3 + q_tmp_4_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_5_0 = q_acc_5_0 + q_tmp_5_0;
                q_acc_5_1 = q_acc_5_1 + q_tmp_5_1;
                q_acc_5_2 = q_acc_5_2 + q_tmp_5_2;
                q_acc_5_3 = q_acc_5_3 + q_tmp_5_3;
                q_acc_5_4 = q_acc_5_4 + q_tmp_5_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_6_0 = q_acc_6_0 + q_tmp_6_0;
                q_acc_6_1 = q_acc_6_1 + q_tmp_6_1;
                q_acc_6_2 = q_acc_6_2 + q_tmp_6_2;
                q_acc_6_3 = q_acc_6_3 + q_tmp_6_3;
                q_acc_6_4 = q_acc_6_4 + q_tmp_6_4;
                q_acc_6_5 = q_acc_6_5 + q_tmp_6_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_7_0 = q_acc_7_0 + q_tmp_7_0;
                q_acc_7_1 = q_acc_7_1 + q_tmp_7_1;
                q_acc_7_2 = q_acc_7_2 + q_tmp_7_2;
                q_acc_7_3 = q_acc_7_3 + q_tmp_7_3;
                q_acc_7_4 = q_acc_7_4 + q_tmp_7_4;
                q_acc_7_5 = q_acc_7_5 + q_tmp_7_5;
                q_acc_7_6 = q_acc_7_6 + q_tmp_7_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_8_0 = q_acc_8_0 + q_tmp_8_0;
                q_acc_8_1 = q_acc_8_1 + q_tmp_8_1;
                q_acc_8_2 = q_acc_8_2 + q_tmp_8_2;
                q_acc_8_3 = q_acc_8_3 + q_tmp_8_3;
                q_acc_8_4 = q_acc_8_4 + q_tmp_8_4;
                q_acc_8_5 = q_acc_8_5 + q_tmp_8_5;
                q_acc_8_6 = q_acc_8_6 + q_tmp_8_6;
                q_acc_8_7 = q_acc_8_7 + q_tmp_8_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_9_0 = q_acc_9_0 + q_tmp_9_0;
                q_acc_9_1 = q_acc_9_1 + q_tmp_9_1;
                q_acc_9_2 = q_acc_9_2 + q_tmp_9_2;
                q_acc_9_3 = q_acc_9_3 + q_tmp_9_3;
                q_acc_9_4 = q_acc_9_4 + q_tmp_9_4;
                q_acc_9_5 = q_acc_9_5 + q_tmp_9_5;
                q_acc_9_6 = q_acc_9_6 + q_tmp_9_6;
                q_acc_9_7 = q_acc_9_7 + q_tmp_9_7;
                q_acc_9_8 = q_acc_9_8 + q_tmp_9_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_1_0*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_2_0*src_dof_0 + q_acc_2_1*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_3_0*src_dof_0 + q_acc_3_1*src_dof_1 + q_acc_3_2*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             const real_t elMatVec_4 = q_acc_4_0*src_dof_0 + q_acc_4_1*src_dof_1 + q_acc_4_2*src_dof_2 + q_acc_4_3*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
             const real_t elMatVec_5 = q_acc_5_0*src_dof_0 + q_acc_5_1*src_dof_1 + q_acc_5_2*src_dof_2 + q_acc_5_3*src_dof_3 + q_acc_5_4*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
             const real_t elMatVec_6 = q_acc_6_0*src_dof_0 + q_acc_6_1*src_dof_1 + q_acc_6_2*src_dof_2 + q_acc_6_3*src_dof_3 + q_acc_6_4*src_dof_4 + q_acc_6_5*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
             const real_t elMatVec_7 = q_acc_7_0*src_dof_0 + q_acc_7_1*src_dof_1 + q_acc_7_2*src_dof_2 + q_acc_7_3*src_dof_3 + q_acc_7_4*src_dof_4 + q_acc_7_5*src_dof_5 + q_acc_7_6*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
             const real_t elMatVec_8 = q_acc_8_0*src_dof_0 + q_acc_8_1*src_dof_1 + q_acc_8_2*src_dof_2 + q_acc_8_3*src_dof_3 + q_acc_8_4*src_dof_4 + q_acc_8_5*src_dof_5 + q_acc_8_6*src_dof_6 + q_acc_8_7*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
             const real_t elMatVec_9 = q_acc_9_0*src_dof_0 + q_acc_9_1*src_dof_1 + q_acc_9_2*src_dof_2 + q_acc_9_3*src_dof_3 + q_acc_9_4*src_dof_4 + q_acc_9_5*src_dof_5 + q_acc_9_6*src_dof_6 + q_acc_9_7*src_dof_7 + q_acc_9_8*src_dof_8 + q_acc_9_9*src_dof_9;
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_7 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const real_t tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const real_t tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_11_GREEN_DOWN = jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
       const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const real_t tmp_coords_jac_10_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_0_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
       const real_t tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const real_t jac_affine_inv_0_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
       const real_t jac_affine_inv_0_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const real_t jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const real_t jac_affine_inv_1_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       {
          /* CellType.GREEN_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_5 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_9 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t delta_dof_0 = _data_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t delta_dof_1 = _data_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t delta_dof_2 = _data_deltaVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t delta_dof_3 = _data_deltaVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t delta_dof_4 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t delta_dof_5 = _data_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t delta_dof_6 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t delta_dof_7 = _data_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t delta_dof_8 = _data_deltaEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t delta_dof_9 = _data_deltaEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_0 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_1 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_2 = _data_uxVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t ux_dof_3 = _data_uxVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t ux_dof_4 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ux_dof_5 = _data_uxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_6 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t ux_dof_7 = _data_uxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t ux_dof_8 = _data_uxEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t ux_dof_9 = _data_uxEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_0 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_1 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_2 = _data_uyVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uy_dof_3 = _data_uyVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uy_dof_4 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uy_dof_5 = _data_uyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_6 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uy_dof_7 = _data_uyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uy_dof_8 = _data_uyEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uy_dof_9 = _data_uyEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_0 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_1 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_2 = _data_uzVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t uz_dof_3 = _data_uzVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t uz_dof_4 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uz_dof_5 = _data_uzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_6 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t uz_dof_7 = _data_uzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t uz_dof_8 = _data_uzEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t uz_dof_9 = _data_uzEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_4_0 = 0.0;
             real_t q_acc_4_1 = 0.0;
             real_t q_acc_4_2 = 0.0;
             real_t q_acc_4_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_5_0 = 0.0;
             real_t q_acc_5_1 = 0.0;
             real_t q_acc_5_2 = 0.0;
             real_t q_acc_5_3 = 0.0;
             real_t q_acc_5_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_6_0 = 0.0;
             real_t q_acc_6_1 = 0.0;
             real_t q_acc_6_2 = 0.0;
             real_t q_acc_6_3 = 0.0;
             real_t q_acc_6_4 = 0.0;
             real_t q_acc_6_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_7_0 = 0.0;
             real_t q_acc_7_1 = 0.0;
             real_t q_acc_7_2 = 0.0;
             real_t q_acc_7_3 = 0.0;
             real_t q_acc_7_4 = 0.0;
             real_t q_acc_7_5 = 0.0;
             real_t q_acc_7_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_8_0 = 0.0;
             real_t q_acc_8_1 = 0.0;
             real_t q_acc_8_2 = 0.0;
             real_t q_acc_8_3 = 0.0;
             real_t q_acc_8_4 = 0.0;
             real_t q_acc_8_5 = 0.0;
             real_t q_acc_8_6 = 0.0;
             real_t q_acc_8_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_9_0 = 0.0;
             real_t q_acc_9_1 = 0.0;
             real_t q_acc_9_2 = 0.0;
             real_t q_acc_9_3 = 0.0;
             real_t q_acc_9_4 = 0.0;
             real_t q_acc_9_5 = 0.0;
             real_t q_acc_9_6 = 0.0;
             real_t q_acc_9_7 = 0.0;
             real_t q_acc_9_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                const real_t tmp_qloop_47 = -tmp_qloop_28;
                const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_70 = -tmp_qloop_41;
                const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                const real_t tmp_qloop_103 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const real_t tmp_qloop_104 = tmp_qloop_103*2.0;
                const real_t tmp_qloop_105 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const real_t tmp_qloop_106 = tmp_qloop_105*2.0;
                const real_t tmp_qloop_107 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const real_t tmp_qloop_108 = tmp_qloop_107*2.0;
                const real_t tmp_qloop_109 = 4.0*_data_q_p_1[q];
                const real_t tmp_qloop_110 = tmp_qloop_109*_data_q_p_2[q];
                const real_t tmp_qloop_111 = 4.0*_data_q_p_0[q];
                const real_t tmp_qloop_112 = tmp_qloop_111*_data_q_p_1[q];
                const real_t tmp_qloop_113 = tmp_qloop_111*_data_q_p_2[q];
                const real_t tmp_qloop_114 = tmp_qloop_112 + tmp_qloop_113;
                const real_t tmp_qloop_115 = tmp_qloop_104 + tmp_qloop_106 + tmp_qloop_108 + tmp_qloop_110 + tmp_qloop_114 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0;
                const real_t tmp_qloop_116 = 4.0*_data_q_p_2[q];
                const real_t tmp_qloop_117 = tmp_qloop_109 + tmp_qloop_111;
                const real_t tmp_qloop_118 = tmp_qloop_116 + tmp_qloop_117 - 3.0;
                const real_t tmp_qloop_119 = jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_118 + jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_118 + jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_118;
                const real_t tmp_qloop_120 = jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_118 + jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_118 + jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_118;
                const real_t tmp_qloop_121 = jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_118 + jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_118 + jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_118;
                const real_t tmp_qloop_122 = tmp_qloop_104 - _data_q_p_0[q];
                const real_t tmp_qloop_123 = tmp_qloop_106 - _data_q_p_1[q];
                const real_t tmp_qloop_124 = tmp_qloop_108 - _data_q_p_2[q];
                const real_t tmp_qloop_125 = tmp_qloop_107*-4.0 - tmp_qloop_110 - tmp_qloop_113 + tmp_qloop_116;
                const real_t tmp_qloop_126 = tmp_qloop_105*-4.0 + tmp_qloop_109 - tmp_qloop_110 - tmp_qloop_112;
                const real_t tmp_qloop_127 = tmp_qloop_103*-4.0 + tmp_qloop_111 - tmp_qloop_114;
                const real_t tmp_qloop_128 = tmp_qloop_110*ux_dof_4 + tmp_qloop_112*ux_dof_6 + tmp_qloop_113*ux_dof_5 + tmp_qloop_115*ux_dof_0 + tmp_qloop_122*ux_dof_1 + tmp_qloop_123*ux_dof_2 + tmp_qloop_124*ux_dof_3 + tmp_qloop_125*ux_dof_7 + tmp_qloop_126*ux_dof_8 + tmp_qloop_127*ux_dof_9;
                const real_t tmp_qloop_129 = tmp_qloop_110*uy_dof_4 + tmp_qloop_112*uy_dof_6 + tmp_qloop_113*uy_dof_5 + tmp_qloop_115*uy_dof_0 + tmp_qloop_122*uy_dof_1 + tmp_qloop_123*uy_dof_2 + tmp_qloop_124*uy_dof_3 + tmp_qloop_125*uy_dof_7 + tmp_qloop_126*uy_dof_8 + tmp_qloop_127*uy_dof_9;
                const real_t tmp_qloop_130 = tmp_qloop_110*uz_dof_4 + tmp_qloop_112*uz_dof_6 + tmp_qloop_113*uz_dof_5 + tmp_qloop_115*uz_dof_0 + tmp_qloop_122*uz_dof_1 + tmp_qloop_123*uz_dof_2 + tmp_qloop_124*uz_dof_3 + tmp_qloop_125*uz_dof_7 + tmp_qloop_126*uz_dof_8 + tmp_qloop_127*uz_dof_9;
                const real_t tmp_qloop_133 = tmp_qloop_111 - 1.0;
                const real_t tmp_qloop_134 = jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_133;
                const real_t tmp_qloop_135 = jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_133;
                const real_t tmp_qloop_136 = jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_133;
                const real_t tmp_qloop_138 = tmp_qloop_109 - 1.0;
                const real_t tmp_qloop_139 = jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_138;
                const real_t tmp_qloop_140 = jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_138;
                const real_t tmp_qloop_141 = jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_138;
                const real_t tmp_qloop_143 = tmp_qloop_116 - 1.0;
                const real_t tmp_qloop_144 = jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_143;
                const real_t tmp_qloop_145 = jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_143;
                const real_t tmp_qloop_146 = jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_143;
                const real_t tmp_qloop_148 = jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_109;
                const real_t tmp_qloop_149 = jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_116;
                const real_t tmp_qloop_150 = tmp_qloop_148 + tmp_qloop_149;
                const real_t tmp_qloop_151 = jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_109;
                const real_t tmp_qloop_152 = jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_116;
                const real_t tmp_qloop_153 = tmp_qloop_151 + tmp_qloop_152;
                const real_t tmp_qloop_154 = jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_109;
                const real_t tmp_qloop_155 = jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_116;
                const real_t tmp_qloop_156 = tmp_qloop_154 + tmp_qloop_155;
                const real_t tmp_qloop_158 = jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_111;
                const real_t tmp_qloop_159 = jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_116;
                const real_t tmp_qloop_160 = tmp_qloop_158 + tmp_qloop_159;
                const real_t tmp_qloop_161 = jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_111;
                const real_t tmp_qloop_162 = jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_116;
                const real_t tmp_qloop_163 = tmp_qloop_161 + tmp_qloop_162;
                const real_t tmp_qloop_164 = jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_111;
                const real_t tmp_qloop_165 = jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_116;
                const real_t tmp_qloop_166 = tmp_qloop_164 + tmp_qloop_165;
                const real_t tmp_qloop_168 = jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_111;
                const real_t tmp_qloop_169 = jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_109;
                const real_t tmp_qloop_170 = tmp_qloop_168 + tmp_qloop_169;
                const real_t tmp_qloop_171 = jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_111;
                const real_t tmp_qloop_172 = jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_109;
                const real_t tmp_qloop_173 = tmp_qloop_171 + tmp_qloop_172;
                const real_t tmp_qloop_174 = jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_111;
                const real_t tmp_qloop_175 = jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_109;
                const real_t tmp_qloop_176 = tmp_qloop_174 + tmp_qloop_175;
                const real_t tmp_qloop_178 = -tmp_qloop_117 - 8.0*_data_q_p_2[q] + 4.0;
                const real_t tmp_qloop_179 = jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_178 - tmp_qloop_149 - tmp_qloop_159;
                const real_t tmp_qloop_180 = jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_178 - tmp_qloop_152 - tmp_qloop_162;
                const real_t tmp_qloop_181 = jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_178 - tmp_qloop_155 - tmp_qloop_165;
                const real_t tmp_qloop_183 = tmp_qloop_116 - 4.0;
                const real_t tmp_qloop_184 = -tmp_qloop_111 - tmp_qloop_183 - 8.0*_data_q_p_1[q];
                const real_t tmp_qloop_185 = jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_184 - tmp_qloop_148 - tmp_qloop_169;
                const real_t tmp_qloop_186 = jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_184 - tmp_qloop_151 - tmp_qloop_172;
                const real_t tmp_qloop_187 = jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_184 - tmp_qloop_154 - tmp_qloop_175;
                const real_t tmp_qloop_189 = -tmp_qloop_109 - tmp_qloop_183 - 8.0*_data_q_p_0[q];
                const real_t tmp_qloop_190 = jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_189 - tmp_qloop_158 - tmp_qloop_168;
                const real_t tmp_qloop_191 = jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_189 - tmp_qloop_161 - tmp_qloop_171;
                const real_t tmp_qloop_192 = jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_189 - tmp_qloop_164 - tmp_qloop_174;
                const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                const real_t abs_det_jac_blending = tmp_qloop_64;
                const real_t tmp_qloop_131 = abs_det_jac_affine_GREEN_DOWN*abs_det_jac_blending*(delta_dof_0*tmp_qloop_115 + delta_dof_1*tmp_qloop_122 + delta_dof_2*tmp_qloop_123 + delta_dof_3*tmp_qloop_124 + delta_dof_4*tmp_qloop_110 + delta_dof_5*tmp_qloop_113 + delta_dof_6*tmp_qloop_112 + delta_dof_7*tmp_qloop_125 + delta_dof_8*tmp_qloop_126 + delta_dof_9*tmp_qloop_127)*_data_q_w[q];
                const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t tmp_qloop_132 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_119 + jac_blending_inv_1_0*tmp_qloop_120 + jac_blending_inv_2_0*tmp_qloop_121) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_119 + jac_blending_inv_1_1*tmp_qloop_120 + jac_blending_inv_2_1*tmp_qloop_121) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_119 + jac_blending_inv_1_2*tmp_qloop_120 + jac_blending_inv_2_2*tmp_qloop_121));
                const real_t tmp_qloop_137 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_134 + jac_blending_inv_1_0*tmp_qloop_135 + jac_blending_inv_2_0*tmp_qloop_136) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_134 + jac_blending_inv_1_1*tmp_qloop_135 + jac_blending_inv_2_1*tmp_qloop_136) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_134 + jac_blending_inv_1_2*tmp_qloop_135 + jac_blending_inv_2_2*tmp_qloop_136));
                const real_t tmp_qloop_142 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_139 + jac_blending_inv_1_0*tmp_qloop_140 + jac_blending_inv_2_0*tmp_qloop_141) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_139 + jac_blending_inv_1_1*tmp_qloop_140 + jac_blending_inv_2_1*tmp_qloop_141) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_139 + jac_blending_inv_1_2*tmp_qloop_140 + jac_blending_inv_2_2*tmp_qloop_141));
                const real_t tmp_qloop_147 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_144 + jac_blending_inv_1_0*tmp_qloop_145 + jac_blending_inv_2_0*tmp_qloop_146) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_144 + jac_blending_inv_1_1*tmp_qloop_145 + jac_blending_inv_2_1*tmp_qloop_146) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_144 + jac_blending_inv_1_2*tmp_qloop_145 + jac_blending_inv_2_2*tmp_qloop_146));
                const real_t tmp_qloop_157 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_150 + jac_blending_inv_1_0*tmp_qloop_153 + jac_blending_inv_2_0*tmp_qloop_156) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_150 + jac_blending_inv_1_1*tmp_qloop_153 + jac_blending_inv_2_1*tmp_qloop_156) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_150 + jac_blending_inv_1_2*tmp_qloop_153 + jac_blending_inv_2_2*tmp_qloop_156));
                const real_t tmp_qloop_167 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_160 + jac_blending_inv_1_0*tmp_qloop_163 + jac_blending_inv_2_0*tmp_qloop_166) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_160 + jac_blending_inv_1_1*tmp_qloop_163 + jac_blending_inv_2_1*tmp_qloop_166) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_160 + jac_blending_inv_1_2*tmp_qloop_163 + jac_blending_inv_2_2*tmp_qloop_166));
                const real_t tmp_qloop_177 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_170 + jac_blending_inv_1_0*tmp_qloop_173 + jac_blending_inv_2_0*tmp_qloop_176) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_170 + jac_blending_inv_1_1*tmp_qloop_173 + jac_blending_inv_2_1*tmp_qloop_176) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_170 + jac_blending_inv_1_2*tmp_qloop_173 + jac_blending_inv_2_2*tmp_qloop_176));
                const real_t tmp_qloop_182 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_179 + jac_blending_inv_1_0*tmp_qloop_180 + jac_blending_inv_2_0*tmp_qloop_181) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_179 + jac_blending_inv_1_1*tmp_qloop_180 + jac_blending_inv_2_1*tmp_qloop_181) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_179 + jac_blending_inv_1_2*tmp_qloop_180 + jac_blending_inv_2_2*tmp_qloop_181));
                const real_t tmp_qloop_188 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_185 + jac_blending_inv_1_0*tmp_qloop_186 + jac_blending_inv_2_0*tmp_qloop_187) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_185 + jac_blending_inv_1_1*tmp_qloop_186 + jac_blending_inv_2_1*tmp_qloop_187) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_185 + jac_blending_inv_1_2*tmp_qloop_186 + jac_blending_inv_2_2*tmp_qloop_187));
                const real_t tmp_qloop_193 = tmp_qloop_131*(tmp_qloop_128*(jac_blending_inv_0_0*tmp_qloop_190 + jac_blending_inv_1_0*tmp_qloop_191 + jac_blending_inv_2_0*tmp_qloop_192) + tmp_qloop_129*(jac_blending_inv_0_1*tmp_qloop_190 + jac_blending_inv_1_1*tmp_qloop_191 + jac_blending_inv_2_1*tmp_qloop_192) + tmp_qloop_130*(jac_blending_inv_0_2*tmp_qloop_190 + jac_blending_inv_1_2*tmp_qloop_191 + jac_blending_inv_2_2*tmp_qloop_192));
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_115*tmp_qloop_132;
                const real_t q_tmp_0_1 = tmp_qloop_122*tmp_qloop_132;
                const real_t q_tmp_0_2 = tmp_qloop_123*tmp_qloop_132;
                const real_t q_tmp_0_3 = tmp_qloop_124*tmp_qloop_132;
                const real_t q_tmp_0_4 = tmp_qloop_110*tmp_qloop_132;
                const real_t q_tmp_0_5 = tmp_qloop_113*tmp_qloop_132;
                const real_t q_tmp_0_6 = tmp_qloop_112*tmp_qloop_132;
                const real_t q_tmp_0_7 = tmp_qloop_125*tmp_qloop_132;
                const real_t q_tmp_0_8 = tmp_qloop_126*tmp_qloop_132;
                const real_t q_tmp_0_9 = tmp_qloop_127*tmp_qloop_132;
                const real_t q_tmp_1_0 = tmp_qloop_115*tmp_qloop_137;
                const real_t q_tmp_1_1 = tmp_qloop_122*tmp_qloop_137;
                const real_t q_tmp_1_2 = tmp_qloop_123*tmp_qloop_137;
                const real_t q_tmp_1_3 = tmp_qloop_124*tmp_qloop_137;
                const real_t q_tmp_1_4 = tmp_qloop_110*tmp_qloop_137;
                const real_t q_tmp_1_5 = tmp_qloop_113*tmp_qloop_137;
                const real_t q_tmp_1_6 = tmp_qloop_112*tmp_qloop_137;
                const real_t q_tmp_1_7 = tmp_qloop_125*tmp_qloop_137;
                const real_t q_tmp_1_8 = tmp_qloop_126*tmp_qloop_137;
                const real_t q_tmp_1_9 = tmp_qloop_127*tmp_qloop_137;
                const real_t q_tmp_2_0 = tmp_qloop_115*tmp_qloop_142;
                const real_t q_tmp_2_1 = tmp_qloop_122*tmp_qloop_142;
                const real_t q_tmp_2_2 = tmp_qloop_123*tmp_qloop_142;
                const real_t q_tmp_2_3 = tmp_qloop_124*tmp_qloop_142;
                const real_t q_tmp_2_4 = tmp_qloop_110*tmp_qloop_142;
                const real_t q_tmp_2_5 = tmp_qloop_113*tmp_qloop_142;
                const real_t q_tmp_2_6 = tmp_qloop_112*tmp_qloop_142;
                const real_t q_tmp_2_7 = tmp_qloop_125*tmp_qloop_142;
                const real_t q_tmp_2_8 = tmp_qloop_126*tmp_qloop_142;
                const real_t q_tmp_2_9 = tmp_qloop_127*tmp_qloop_142;
                const real_t q_tmp_3_0 = tmp_qloop_115*tmp_qloop_147;
                const real_t q_tmp_3_1 = tmp_qloop_122*tmp_qloop_147;
                const real_t q_tmp_3_2 = tmp_qloop_123*tmp_qloop_147;
                const real_t q_tmp_3_3 = tmp_qloop_124*tmp_qloop_147;
                const real_t q_tmp_3_4 = tmp_qloop_110*tmp_qloop_147;
                const real_t q_tmp_3_5 = tmp_qloop_113*tmp_qloop_147;
                const real_t q_tmp_3_6 = tmp_qloop_112*tmp_qloop_147;
                const real_t q_tmp_3_7 = tmp_qloop_125*tmp_qloop_147;
                const real_t q_tmp_3_8 = tmp_qloop_126*tmp_qloop_147;
                const real_t q_tmp_3_9 = tmp_qloop_127*tmp_qloop_147;
                const real_t q_tmp_4_0 = tmp_qloop_115*tmp_qloop_157;
                const real_t q_tmp_4_1 = tmp_qloop_122*tmp_qloop_157;
                const real_t q_tmp_4_2 = tmp_qloop_123*tmp_qloop_157;
                const real_t q_tmp_4_3 = tmp_qloop_124*tmp_qloop_157;
                const real_t q_tmp_4_4 = tmp_qloop_110*tmp_qloop_157;
                const real_t q_tmp_4_5 = tmp_qloop_113*tmp_qloop_157;
                const real_t q_tmp_4_6 = tmp_qloop_112*tmp_qloop_157;
                const real_t q_tmp_4_7 = tmp_qloop_125*tmp_qloop_157;
                const real_t q_tmp_4_8 = tmp_qloop_126*tmp_qloop_157;
                const real_t q_tmp_4_9 = tmp_qloop_127*tmp_qloop_157;
                const real_t q_tmp_5_0 = tmp_qloop_115*tmp_qloop_167;
                const real_t q_tmp_5_1 = tmp_qloop_122*tmp_qloop_167;
                const real_t q_tmp_5_2 = tmp_qloop_123*tmp_qloop_167;
                const real_t q_tmp_5_3 = tmp_qloop_124*tmp_qloop_167;
                const real_t q_tmp_5_4 = tmp_qloop_110*tmp_qloop_167;
                const real_t q_tmp_5_5 = tmp_qloop_113*tmp_qloop_167;
                const real_t q_tmp_5_6 = tmp_qloop_112*tmp_qloop_167;
                const real_t q_tmp_5_7 = tmp_qloop_125*tmp_qloop_167;
                const real_t q_tmp_5_8 = tmp_qloop_126*tmp_qloop_167;
                const real_t q_tmp_5_9 = tmp_qloop_127*tmp_qloop_167;
                const real_t q_tmp_6_0 = tmp_qloop_115*tmp_qloop_177;
                const real_t q_tmp_6_1 = tmp_qloop_122*tmp_qloop_177;
                const real_t q_tmp_6_2 = tmp_qloop_123*tmp_qloop_177;
                const real_t q_tmp_6_3 = tmp_qloop_124*tmp_qloop_177;
                const real_t q_tmp_6_4 = tmp_qloop_110*tmp_qloop_177;
                const real_t q_tmp_6_5 = tmp_qloop_113*tmp_qloop_177;
                const real_t q_tmp_6_6 = tmp_qloop_112*tmp_qloop_177;
                const real_t q_tmp_6_7 = tmp_qloop_125*tmp_qloop_177;
                const real_t q_tmp_6_8 = tmp_qloop_126*tmp_qloop_177;
                const real_t q_tmp_6_9 = tmp_qloop_127*tmp_qloop_177;
                const real_t q_tmp_7_0 = tmp_qloop_115*tmp_qloop_182;
                const real_t q_tmp_7_1 = tmp_qloop_122*tmp_qloop_182;
                const real_t q_tmp_7_2 = tmp_qloop_123*tmp_qloop_182;
                const real_t q_tmp_7_3 = tmp_qloop_124*tmp_qloop_182;
                const real_t q_tmp_7_4 = tmp_qloop_110*tmp_qloop_182;
                const real_t q_tmp_7_5 = tmp_qloop_113*tmp_qloop_182;
                const real_t q_tmp_7_6 = tmp_qloop_112*tmp_qloop_182;
                const real_t q_tmp_7_7 = tmp_qloop_125*tmp_qloop_182;
                const real_t q_tmp_7_8 = tmp_qloop_126*tmp_qloop_182;
                const real_t q_tmp_7_9 = tmp_qloop_127*tmp_qloop_182;
                const real_t q_tmp_8_0 = tmp_qloop_115*tmp_qloop_188;
                const real_t q_tmp_8_1 = tmp_qloop_122*tmp_qloop_188;
                const real_t q_tmp_8_2 = tmp_qloop_123*tmp_qloop_188;
                const real_t q_tmp_8_3 = tmp_qloop_124*tmp_qloop_188;
                const real_t q_tmp_8_4 = tmp_qloop_110*tmp_qloop_188;
                const real_t q_tmp_8_5 = tmp_qloop_113*tmp_qloop_188;
                const real_t q_tmp_8_6 = tmp_qloop_112*tmp_qloop_188;
                const real_t q_tmp_8_7 = tmp_qloop_125*tmp_qloop_188;
                const real_t q_tmp_8_8 = tmp_qloop_126*tmp_qloop_188;
                const real_t q_tmp_8_9 = tmp_qloop_127*tmp_qloop_188;
                const real_t q_tmp_9_0 = tmp_qloop_115*tmp_qloop_193;
                const real_t q_tmp_9_1 = tmp_qloop_122*tmp_qloop_193;
                const real_t q_tmp_9_2 = tmp_qloop_123*tmp_qloop_193;
                const real_t q_tmp_9_3 = tmp_qloop_124*tmp_qloop_193;
                const real_t q_tmp_9_4 = tmp_qloop_110*tmp_qloop_193;
                const real_t q_tmp_9_5 = tmp_qloop_113*tmp_qloop_193;
                const real_t q_tmp_9_6 = tmp_qloop_112*tmp_qloop_193;
                const real_t q_tmp_9_7 = tmp_qloop_125*tmp_qloop_193;
                const real_t q_tmp_9_8 = tmp_qloop_126*tmp_qloop_193;
                const real_t q_tmp_9_9 = tmp_qloop_127*tmp_qloop_193;
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_4_0 = q_acc_4_0 + q_tmp_4_0;
                q_acc_4_1 = q_acc_4_1 + q_tmp_4_1;
                q_acc_4_2 = q_acc_4_2 + q_tmp_4_2;
                q_acc_4_3 = q_acc_4_3 + q_tmp_4_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_5_0 = q_acc_5_0 + q_tmp_5_0;
                q_acc_5_1 = q_acc_5_1 + q_tmp_5_1;
                q_acc_5_2 = q_acc_5_2 + q_tmp_5_2;
                q_acc_5_3 = q_acc_5_3 + q_tmp_5_3;
                q_acc_5_4 = q_acc_5_4 + q_tmp_5_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_6_0 = q_acc_6_0 + q_tmp_6_0;
                q_acc_6_1 = q_acc_6_1 + q_tmp_6_1;
                q_acc_6_2 = q_acc_6_2 + q_tmp_6_2;
                q_acc_6_3 = q_acc_6_3 + q_tmp_6_3;
                q_acc_6_4 = q_acc_6_4 + q_tmp_6_4;
                q_acc_6_5 = q_acc_6_5 + q_tmp_6_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_7_0 = q_acc_7_0 + q_tmp_7_0;
                q_acc_7_1 = q_acc_7_1 + q_tmp_7_1;
                q_acc_7_2 = q_acc_7_2 + q_tmp_7_2;
                q_acc_7_3 = q_acc_7_3 + q_tmp_7_3;
                q_acc_7_4 = q_acc_7_4 + q_tmp_7_4;
                q_acc_7_5 = q_acc_7_5 + q_tmp_7_5;
                q_acc_7_6 = q_acc_7_6 + q_tmp_7_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_8_0 = q_acc_8_0 + q_tmp_8_0;
                q_acc_8_1 = q_acc_8_1 + q_tmp_8_1;
                q_acc_8_2 = q_acc_8_2 + q_tmp_8_2;
                q_acc_8_3 = q_acc_8_3 + q_tmp_8_3;
                q_acc_8_4 = q_acc_8_4 + q_tmp_8_4;
                q_acc_8_5 = q_acc_8_5 + q_tmp_8_5;
                q_acc_8_6 = q_acc_8_6 + q_tmp_8_6;
                q_acc_8_7 = q_acc_8_7 + q_tmp_8_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_9_0 = q_acc_9_0 + q_tmp_9_0;
                q_acc_9_1 = q_acc_9_1 + q_tmp_9_1;
                q_acc_9_2 = q_acc_9_2 + q_tmp_9_2;
                q_acc_9_3 = q_acc_9_3 + q_tmp_9_3;
                q_acc_9_4 = q_acc_9_4 + q_tmp_9_4;
                q_acc_9_5 = q_acc_9_5 + q_tmp_9_5;
                q_acc_9_6 = q_acc_9_6 + q_tmp_9_6;
                q_acc_9_7 = q_acc_9_7 + q_tmp_9_7;
                q_acc_9_8 = q_acc_9_8 + q_tmp_9_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_1_0*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_2_0*src_dof_0 + q_acc_2_1*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_3_0*src_dof_0 + q_acc_3_1*src_dof_1 + q_acc_3_2*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             const real_t elMatVec_4 = q_acc_4_0*src_dof_0 + q_acc_4_1*src_dof_1 + q_acc_4_2*src_dof_2 + q_acc_4_3*src_dof_3 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
             const real_t elMatVec_5 = q_acc_5_0*src_dof_0 + q_acc_5_1*src_dof_1 + q_acc_5_2*src_dof_2 + q_acc_5_3*src_dof_3 + q_acc_5_4*src_dof_4 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
             const real_t elMatVec_6 = q_acc_6_0*src_dof_0 + q_acc_6_1*src_dof_1 + q_acc_6_2*src_dof_2 + q_acc_6_3*src_dof_3 + q_acc_6_4*src_dof_4 + q_acc_6_5*src_dof_5 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
             const real_t elMatVec_7 = q_acc_7_0*src_dof_0 + q_acc_7_1*src_dof_1 + q_acc_7_2*src_dof_2 + q_acc_7_3*src_dof_3 + q_acc_7_4*src_dof_4 + q_acc_7_5*src_dof_5 + q_acc_7_6*src_dof_6 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
             const real_t elMatVec_8 = q_acc_8_0*src_dof_0 + q_acc_8_1*src_dof_1 + q_acc_8_2*src_dof_2 + q_acc_8_3*src_dof_3 + q_acc_8_4*src_dof_4 + q_acc_8_5*src_dof_5 + q_acc_8_6*src_dof_6 + q_acc_8_7*src_dof_7 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
             const real_t elMatVec_9 = q_acc_9_0*src_dof_0 + q_acc_9_1*src_dof_1 + q_acc_9_2*src_dof_2 + q_acc_9_3*src_dof_3 + q_acc_9_4*src_dof_4 + q_acc_9_5*src_dof_5 + q_acc_9_6*src_dof_6 + q_acc_9_7*src_dof_7 + q_acc_9_8*src_dof_8 + q_acc_9_9*src_dof_9;
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_7 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
